README file for PlasmaState Module

Prepared by C.Ludescher-Furth -- ludescher@pppl.gov 10/08/07

****************
REVISION HISTORY
****************
      date          Description

  Oct 08, 2007  -- Created
  May 05, 2008  -- Added geq2ps, ps2geq and ps_nbline
  May 13, 2008  -- Added jsocdf2ps ps2xplasma
----------------------------------------------------------------


Index:
   1. CONTENTS
   2. UNPACKING INSTRUCTIONS
   3. DESTINATIONS
   4. BUILDING INSTRUCTIONS
   5. TESTING INSTRUCTIONS
   6. DOCUMENTATION
   7. FINAL INSTALLATION


************
1. CONTENTS:
************
The directory into which plasma_state{zip,tar.gz} was extracted, should contain
the following files:

README_PlasmaState: This file.  Brief descriptions of the other files, and
                instructions for compiling, testing and installing the
                plasma_state libraries.

Makefile:       NOTE, "GNU make" must be used
                (usually in /usr/gnu/bin or /usr/local/bin).
		Main Makefile to envoke Makefile(s) in subdirectories.  

-- in subdirectory fpreproc:
   Python scripts for fortran pre-processing.

-- in subdirectory include/fpreproc:
   *.h files for source pre-processing.


-- in subdirectory plasma_state_test:
   Makefile 
   Sources to build plasma_state_test 
   README: Copy of README_PlasmaState
   Makefile
   Input file for test:
      g104403.nstx: equilibrium data	  
   Refernce output files for test:
     ref_output, ref_debug3 

-- in subdirectory cstate:
   Makefile 
   Sources to build cstate
   qktest.ind script for testing 

-- in subdirectory update_state:
   Makefile 
   Sources to build update_state

-- in subdirectory jsocdf2ps:
   Makefile 
   Sources to build jsocdf2ps

-- in subroutine geq2ps
   Makefile
   Sources to build geq2ps

-- in subroutine ps2geq
   Makefile
   Sources to build ps2geq
   cur_state.cdf: sample plasma state file

-- in subdirectory ps_nbline_driver:
   Makefile 
   Sources to build ps_nbline_driver
   tftr_nbline.cdf: sample plasma state file 

-- in subdirectory ps2xplasma:
   Makefile 
   Sources to build ps2xplasma


-- in subdirectory share:
   Make.flags:        Include file for Makefile, to setup Flags, etc.
   Make.local.sample: Include file for Makefile, to setup non-conventional,
                      site specific locations.
 

For Test Program cstate:
   in subdirectories cstate_lib, xplasma_debug, trgraf,
        ureadsub, sglib
 	sources and Makefiles to build these libraries.


**************************
2. UNPACKING INSTRUCTIONS:
**************************
Note: Download the module(s) into an empty directory.

for tarfiles:
  > gunzip plasma_state.tar.gz
  > tar xvf plasma_state.tar

or, for zip archives:
  > unzip plasma_state.zip


****************
3. DESTINATIONS:
****************
Or where do the files go?
(this refers to building and testing; see FINAL INSTALLATION for end result) 


When you extract the tar file you get sub directories:
./ccps_lib
./cstate_lib
./fpreproc             --  scripts for pre-processing of fortran
./include/fpreproc     --  *.h files for cpp
./plasma_state         -- 
./plasma_state_kernel  -- 
./ps_nbline            --   
./ps_xplasma2          --
./ps2plasma            -- 
./share                --  include file Make.flags, Make.local.sample

For Programs:
./ccps_test
./cstate
./jsocdf2ps
./geq2ps
./plasma_state_test
./ps2geq
./ps2xplasma
./ps_nbline_driver
./update_state

The makefile will create more sub directories,

lib:     for the library, libplasma_state.a
mod:     for the f90 modules
obj/*:   for compiled objects and pre-processed sources
test:    for the test programs and the sample output files.

By default these directories are created in  
./<MACHINE>, which is determined by Make.flags.
e.g.: if you are running Linux, and the tar file resides in $HOME/foo,
      the directories would be in
      $HOME/foo/LINUX/...

You can overwrite the destination by defining OBJ, as an environment
variable (e.g. export OBJ=/dir1/dir2),
or with make (e.g. "make all OBJ=.").
If OBJ is defined, the destinations will be
$OBJ/lib and $OBJ/test.
If OBJ is defined as "." then, in the example above, the destination
would be $HOME/foo/lib.

The rationale behind <MACHINE> is to facilitate building for various platforms.

Note: If you define OBJ as option to gmake, you have to consistently do so;
      e.g: gmake clean OBJ=., gmake install OBJ=.

 
*************************
4. BUILDING INSTRUCTIONS:
*************************

Required Compilers:
===================
           Fortran 90 or 95
           C 

Required Libraries:
===================
           libpspline.a     -> NTCC module PSPLINE, now on GitHub
           transp libraries -> NTCC module PS_TranspSubs 
                               (available with PlasmaState)
                               Note: if you have NUBEAM,
                                     you don't need PS_TranspSubs 
           lapack           -  Linear Algebra PACKage
           netCDF           -  network Common Data Form

Optional Libraries:
===================
	   readline, history, termcap  for Command Line Editing
           Note: if not all three libraries are installed
                 you must define NO_EDITLIBS
		 e.g.: gmake NO_EDITLIBS=Y

Check with your systems administrator where these libraries and modules are.


lapack, blas, netCDF
---------------------------
lapack, blas, netCDF are assumed to be in /usr/local/lib,
if not, you can specify the location with LIBROOT,

e.g.: "gmake LIBROOT=/usr/contrib".

If netCDF is in a separate location, specify NETCDF_DIR

e.g.: "gmake NETCDF_DIR=/usr/local/my-netcdf LIBROOT=/my-libroot".

Alternatively you can modify Make.local.sample
and rename it to Make.local.

pspline, xplasma and preact
---------------------------
If your site already has pspline, xplasma and preact libraries installed,
specify their location (library and modules) with PREFIX, 

e.g. "gmake PREFIX=/usr/ntcc"

At PPPL these libraries are in $NTCCHOME/lib.

Note: If you don't have all required NTCC libraries, you may download
      them together into the same work directory. The Makefile will build
      them all in one step. 


Building libraries and programs
-------------------------------- 
> gmake            -- to compile library and link all test programs

> gmake checklibs  -- tells you what the makefile will do
                      (without any action);
                      it says which libraries it will make and
                      which ones it already found and where.
 
> gmake clean      -- to remove objects
> gmake realclean  -- to remove objects and library

> gmake show_makeflags -- to see what flags, definitions Make will use

Compiling on Linux:
-------------------
By default the Makefile will select LaheyFujitsu.

To select a different compiler define
FORTRAN_VARIANT to "Portland" "PathScale" " GCC" "NagWare"  "Fujitsu" "Intel" or "Absoft"

e.g.:
setenv FORTRAN_VARIANT Portland (csh)
FORTRAN_VARIANT=Portland; export  FORTRAN_VARIANT (sh)

Alternatively, FORTRAN_VARIANT can be passed directly to the gmake
command, as in:
gmake  FORTRAN_VARIANT=Portland

Note: some test programs are linked with g++; to find the Fortran libraries,
      you need to define FLIBROOT
      e.g. export FLIBROOT=/usr/pppl/lf64x/lf6480

To use vastf90:
> gmake VAST90=y

To use NAG90: 
> gmake NAG90=y

Note: By default the test programs, plasma_state_test and plasma_state_driver,
      are linked with lf95. If you encounter a problem, try linking with g++:

> gmake USEFC=N 


Compiling on Alpha Linux:
-------------------------
The Makefile assumes the Compaq compiler and specifies the 
 " -assume no2underscores " option.

Therefore the calling user software must also be compiled with this
option, or you should edit share/Make.flags to remove the option.


Compiling on SUN:
-----------------
The Makefile specifies the -dalign option.
Therefore the calling user software must also be compiled with this
option, or you should edit share/Make.flags to remove the option.



************************
5. TESTING INSTRUCTIONS:
************************

directory $OBJ/test  -or-  <MACHINE>/test  
      will contain plasma_state_test and cstate:

To run tests / programs:
========================
cd plasma_state_test
../<MACHINE>/test/plasma_state_test

cd cstate
../<MACHINE>/test/cstate @qktest.ind


Write g-eqdsk file from plasma state "cur_state" into "foo"
cd ps2geq
../LINUX/test/ps2geq  cur_state.cdf  foo.geq
will write ./g104403.nstc -- "g104403.nstx" is the file name stored in the
state itself, in data element eqdsk_file.


Load plasma state from sample g-eqdsk file into "gps.cdf"
cd geq2ps
../LINUX/test/geq2ps  g104403.nstx   gps.cdf  -tok:NSTX  -shot:104403

For ps_nbline_driver:
cd /ps_nbline_driver
Arguments are:
"-ps:<file>"   -- plasma state file; 
"-seed:<xxx>"  -- random number seed in form of a character string 
"-n:<n>  "     -- sample size 
e.g.:
../LINUX/test/ps_nbline_driver -ps:tftr_nbline.cdf -seed:abc -n:20 

See: README_ps_nbline

update_state
------------
This program applies a state update file or list of update files to an existing state, to create a new state. 

For help:
<MACHINE>/test/update_state


************************
6. DOCUMENTATION:
************************

PLASMA_STATE Home Page:
http://w3.pppl.gov/NTCC/PlasmaState


NTCC Home Page:
http://w3.pppl.gov/NTCC


**********************
7. FINAL INSTALLATION:
**********************

Choose or create the root directory in which you wish to install the software.
A common location would be /usr/ntcc, but installation can occur in any
directory where you have appropriate permissions.

You define your choice of root directory via PREFIX.
The default for PREFIX is /usr/ntcc.

The assumptions are:

libraries in:       $PREFIX/lib        = $LIBDIR
f90 modules in:     $PREFIX/mod        = $MODDIR
man pages in:       $PREFIX/man/man3   = $MANDIR/man3

To install the software, return to the top directory (the directory,
where you downloaded the tar files) and type

> gmake install  
    to install into /usr/ntcc/...

> gmake install PREFIX=/dir1/dir2/
    to install into /dir1/dir2/...

If you want things elsewhere, you can overwrite the default with
> gmake install LIBDIR=/xxx MODDIR=yyy MANDIR=zzz

NOTE:
-----
To link a program, you need all plasma_state, xplasma, pspline libraries.

e,g:

-L<PREFIX>/lib  \
         -lplasma_state -lps_xplasma2 -lplasma_state_kernel \ 
         -lxplasma2 -lgeqdsk_mds -lmdstransp -lvaxonly -lnscrunch \
	 -lfluxav -lr8bloat -lpspline -lezcdf \
         -llsode -llsode_linpack -lcomput -lportlib

Make sure users know what <PREFIX> is.

After you have installed the software, you can delete the entire tree
with
> cd ..
> rm -r foo
   assuming the previous example.

----------------------------------------------------------------------------

IF YOU HAVE ANY PROBLEMS, PLEASE CONTACT EITHER:


        Doug McCune, Princeton University
                dmccune@pppl.gov
        or

        Christiane Ludescher-Furth, Princeton University
                cludescher@pppl.gov
        or      
                ntcc_webmaster@pppl.gov

README_ps_nbline

"ps_nbline" ("ps" for Plasma State; "nbline" for the name of the subroutine
that finds the start of beam neutral trajectories in NUBEAM).
This is a library module that could be connected to other software.

"ps_nbline_driver" is an example driver program.

A version of the NUBEAM nbline subroutine has been repackaged to get its beam
geometry and power, voltage, and species mix from the Plasma State only, and
is not dependent on the larger NUBEAM module.

"ps_nbline" requires as input a plasma state, and two passed routines to provide
random number generation (flat distribution and Gaussian distribution).  
In the example program "ps_nbline_driver" I use the Charles Karney MPI-compatible 
RNG software from http://w3.pppl.gov/NTCC numerical tools.  A "stream" 
argument is accepted, to allow multiple parallel RNG streams as might be 
needed in a restartable MPI application, and a "species" argument allows you 
to sample beam neutrals one species at a time, if desired, in case of 
multi-species NBI experiments.

It returns as output a data structure containing parameters for one beam 
neutral atom:  {Specie, Beam Index, full/half/third Energy index, (R,Phi,Z) of
start, and velocity (vR,vPhi,vZ) in MKS units}.  All are in a lab frame coordinate 
system with R the major radius, Z the elevation relative to a machine midplane
and where increasing values of Phi (and positive vPhi) progress 
counter-clockwise around the machine center line.

Choice of RNG software, and initialization thereof, is left to the "ps_nbline"
caller.  Ps_nbline choose particle start positions randomly with equal weighting 
proportional to the magnitude of beam currents into the torus from all injectors.  
Injectors are described by a source grid size and shape and location, aperture 
size and shape and location, divergence, focal length, power, voltage, and full-, 
half-, and (1/3)-energy current fractions for each injector.

One can generate a Plasma State from any time slice of any archived TRANSP 
experimental analysis or simulation run, using a program called "trxpl".  This
retrieves the beam geometry in effect for the selected run, as well as the 
instantaneous power, voltage, and energy fractions on each of the beams present
in the run-- i.e. all the data needed by "ps_nbline" (plus a bunch of stuff 
"ps_nbline" does not need, but other applications might).

Some caveats about the TRANSP data:  except for NSTX runs, most TRANSP runs lack 
the toroidal location of beam sources; for these runs the toroidal angle coordinate 
"Phi" will be computed as if all beam source grids were located at Phi=0 in th
laboratory frame.  (The neutral trajectories provided by "ps_nbline" are at the
 beam aperture opening into the vacuum vessel, not the source grid, so Phi won't 
be zero exactly).  Also, most existing TRANSP runs do not have geometrical data 
on all available beams; only the subset of beams with non-zero power for the 
shot simulated, are included.  We are moving in a direction where future TRANSP
runs will carry the full beam geometry description of all available beams even 
if not all are used in a given shot or simulation, but that is not where we are
at present.  Finally, although the Plasma State contains specification of the 
direction of toroidal current (i.e. "counter-clockwise viewed from above" or 
the reverse), many TRANSP users have in the past only been concerned with whether 
individual beams were injecting "co", with the current, or "ctr", against (for
beam aimings centered on the magnetic axis, this was sufficient for accurate 
simulations).  This means, though, that some TRANSP runs and their derived 
plasma states will have the wrong direction of plasma current combined with 
the wrong sign of vPhi of beam neutrals, so that "only" the co or ctr-ness of 
each individual beam is correct.

These caveats may be of concern if you are going to compute 3d effects.

-------------------------

Example of "ps_nbline_driver", for a tiny sample size.
 The arguments and values: 
"-ps", plasma state file
"-seed", random number seed in form of a character string
"-n", sample size.  
With larger sample sizes, you get closer to the expected energy fraction and co/ctr mixes.

ps_nbline_driver -ps:tftr_nbline.cdf -seed:abc -n:20
   argument no.  1: -ps:tftr_nbline.cdf
    argument no.  2: -seed:abc
    argument no.  3: -n:20
  
  ps_nbline_driver: syntax OK
  
  ------------------------------------ 
  RNG test results:
      frandm          fgauss
   1  4.50010516E-01  9.54309940E+00
   2  7.18333199E-01  1.17204567E+01
   3  5.25048820E-01  1.04145045E+01
   4  7.55693237E-01  1.02004305E+01
   5  3.18666724E-01  9.60477437E+00
   6  8.72751186E-01  9.80269201E+00
   7  1.29855160E-01  8.87728236E+00
   8  8.31454150E-01  8.67708024E+00
   9  9.43850719E-01  1.14250035E+01
  10  2.37133567E-01  1.10478839E+01
  11  9.72845561E-01  9.32498935E+00
  12  7.43387513E-01  1.04314225E+01
  13  4.00741842E-01  1.02622470E+01
  14  4.00277616E-01  1.03286282E+01
  15  6.50063801E-01  1.12435599E+01
  16  1.08780631E-02  8.59363494E+00
  17  7.00286196E-01  1.01747963E+01
  18  6.23248648E-01  9.17080061E+00
  19  8.08206244E-01  1.01316755E+01
  20  1.62234187E-02  8.61111097E+00
  21  7.92262033E-01  9.46932217E+00
  22  4.21848449E-01  1.04098390E+01
  23  9.76429074E-01  1.07312779E+01
  24  6.05808724E-01  1.02980799E+01
  25  4.41820946E-01  8.37151374E+00
  26  6.55106671E-01  9.23611368E+00
  27  5.97069260E-02  8.82862485E+00
  28  8.41814208E-01  9.58590151E+00
  29  6.03647844E-01  9.96678980E+00
  30  1.04597327E-01  9.26885227E+00
  31  9.64920938E-01  9.77263843E+00
  32  1.67712281E-01  1.11549240E+01
  33  2.92440867E-01  9.57128715E+00
  34  9.09841725E-01  1.11220171E+01
  35  9.59699111E-01  1.02416403E+01
  36  4.98057882E-03  8.11127411E+00
  37  1.95753395E-01  1.06179655E+01
  38  5.87201884E-01  9.70769104E+00
  39  1.88702178E-01  9.76436955E+00
  40  2.76439633E-01  1.04380348E+01
  41  9.15405774E-01  1.01519354E+01
  42  1.65489233E-01  9.58863337E+00
  43  1.70753562E-01  1.04283036E+01
  44  1.30009942E-01  1.09841057E+01
  45  9.75551003E-01  9.01113234E+00
  46  7.38616987E-01  9.94416185E+00
  47  7.08592535E-01  1.06629201E+01
  48  3.89803052E-01  9.58697980E+00
  49  2.46643776E-01  9.61960633E+00
  50  4.21602817E-01  9.52528339E+00
  
 frandm mean & rms deviation:   5.20443193E-01  3.08012625E-01
  
   Guassian sample over exp(-(x-xcen)**2/(2*xwid**2))
 xcen, xwid:   1.00000000E+01  1.00000000E+00
 fgauss mean & rms deviation:   9.91514583E+00  8.15161174E-01
  
  ------------------------------------ 
  Read the Plasma State: tftr_nbline.cdf
  
  The number of neutral beams:  7
  
  Check beam energy fractions...
  
  Name            co?  Pinj(W)       Einj(KeV)     F(full-E)     F(half-E)
 B_001             F    2.89019E+06   1.08665E+02   4.32616E-01   2.96263E-01
 B_002             F    2.74858E+06   1.06391E+02   4.38727E-01   2.93311E-01
 B_003             F    2.38328E+06   1.04528E+02   4.43777E-01   2.90880E-01
 B_004             T    2.42064E+06   1.06527E+02   4.38378E-01   2.93482E-01
 B_005             T    2.36997E+06   1.08742E+02   4.32398E-01   2.96362E-01
 B_006             T    2.65970E+06   1.08373E+02   4.33385E-01   2.95890E-01
 B_007             T    2.25763E+06   1.05660E+02   4.40713E-01   2.92362E-01
   Total Power (W):  1.773E+07 Co-inj fraction:  5.475E-01 Ctr-inj:  4.525E-01
  
 S   iB E co  Rsta       Phista     Zsta       vR         vPhi       vZ
 --- -- - -- ---------- ---------- ---------- ---------- ---------- ----------
 D    6 2 T   8.286E+00  8.508E-02 -2.201E-01 -2.213E+06  5.070E+05 -2.536E+03
D    1 3 F   8.357E+00 -7.838E-02 -6.732E-02 -1.816E+06 -3.860E+05  3.031E+03
 D    2 1 F   8.289E+00 -8.841E-02  1.666E-02 -3.093E+06 -7.438E+05  3.430E+03
 D    2 2 F   8.305E+00 -9.626E-02 -1.117E-02 -2.182E+06 -5.476E+05  1.502E+04
 D    1 1 F   8.366E+00 -8.323E-02  1.940E-01 -3.141E+06 -6.877E+05 -7.922E+03
 D    3 2 F   8.202E+00 -1.045E-01  2.178E-01 -2.143E+06 -6.166E+05  5.873E+03
 D    6 3 T   8.304E+00  9.397E-02  8.123E-02 -1.797E+06  4.528E+05  2.832E+04
 D    4 1 T   8.189E+00  1.102E-01 -1.713E-01 -3.055E+06  8.884E+05 -1.152E+05
 D    2 3 F   8.310E+00 -9.835E-02  8.990E-02 -1.779E+06 -4.578E+05 -2.408E+04
 D    1 3 F   8.362E+00 -8.101E-02  1.500E-01 -1.817E+06 -3.773E+05  3.894E+04
 D    6 2 T   8.301E+00  9.250E-02  5.335E-02 -2.202E+06  5.509E+05  5.428E+04
 D    3 2 F   8.207E+00 -1.067E-01 -1.983E-02 -2.146E+06 -6.030E+05 -3.330E+04
 D    6 1 T   8.309E+00  9.646E-02  1.549E-01 -3.114E+06  7.760E+05  8.039E+04
 D    1 2 F   8.351E+00 -7.508E-02 -2.458E-01 -2.226E+06 -4.568E+05 -4.719E+04
 D    5 2 T   8.361E+00  9.068E-02 -1.759E-01 -2.215E+06  5.147E+05 -1.961E+04
 D    4 1 T   8.180E+00  1.066E-01  4.059E-02 -3.055E+06  8.924E+05 -5.673E+04
 D    3 2 F   8.199E+00 -1.033E-01  1.293E-01 -2.151E+06 -5.846E+05  4.505E+04
 D    2 1 F   8.284E+00 -8.592E-02  2.210E-02 -3.094E+06 -7.391E+05  2.436E+04
 D    3 3 F   8.197E+00 -1.021E-01 -1.214E-01 -1.759E+06 -4.697E+05 -9.562E+03
 D    2 1 F   8.300E+00 -9.387E-02 -4.234E-03 -3.076E+06 -8.105E+05 -1.062E+03
  
full energy fraction:    3.500E-01
half energy fraction:    4.000E-01
(1/3) energy fraction:   2.500E-01
  
Co-injected power fraction:    3.839E-01
Ctr-injected power fraction:   6.161E-01
transpgrid.pppl.gov>

These are D beams from a Plasma State from an old TFTR TRANSP simulation.

module ps_namwr_mod

  ! hand maintained
  ! module routines to assist production of commented namelist output
  ! from plasma state

  use plasma_state_constants_mod
  implicit NONE

  PRIVATE

  PUBLIC :: ps_namwr
  PUBLIC :: ps_namwr_c0,ps_namwr_c1,ps_namwr_i0,ps_namwr_i1,ps_namwr_i2
  PUBLIC :: ps_namwr_d0,ps_namwr_d1,ps_namwr_d2
  PUBLIC :: ps_namwr_hd

  INTERFACE ps_namwr
     module procedure ps_namwr_c0,ps_namwr_c1
     module procedure ps_namwr_i0,ps_namwr_i1,ps_namwr_i2
     module procedure ps_namwr_d0,ps_namwr_d1,ps_namwr_d2
     module procedure ps_namwr_slist
     module procedure ps_namwr_hd
  END INTERFACE

!
! gfortran can not handle a namelist entry like
!   rlim(1) =  0.1851,  0.1851,  0.2794,  0.2794,  0.2979,  0.5712,  0.5712
! my guess is that it would prefer this to be
!   rlim(1:7) =  0.1851,  0.1851,  0.2794,  0.2794,  0.2979,  0.5712,  0.5712
! so for simplicity in code changes, just write out a single line when using gfortran
!
#ifdef __GFORTRAN
  logical, parameter :: namwr_single_line=.true.  ! write one line per namelist array element 
#else
  logical, parameter :: namwr_single_line=.false.
#endif

  !--------------------------------------------------
  ! local data private to the module (not SAVEd) 
  character*20 :: cval
  integer :: ilnb

  !--------------------------------------------------
  ! local private constants
  character*1, parameter :: echar = 'd'
  character*1, parameter :: dquot = '"'

  !--------------------------------------------------
  ! public routines...

CONTAINS

  subroutine ps_namwr_hd(ilun,descr,units,name)

    integer, intent(in) :: ilun         ! unit to write
    character*(*), intent(in) :: descr  ! description
    character*(*), intent(in) :: units  ! "units" label
    character*(*), intent(in) :: name   ! name of variable

    write(ilun,'(" ")')
    write(ilun,'("   ! name: ",a,"  units: ",a)') trim(name), trim(units)
    write(ilun,'("   ! description: ",a)') trim(descr)

  end subroutine ps_namwr_hd

  subroutine ps_namwr_c0(ilun,descr,units,name,val)

    integer, intent(in) :: ilun         ! unit to write
    character*(*), intent(in) :: descr  ! description
    character*(*), intent(in) :: units  ! "units" label
    character*(*), intent(in) :: name   ! name of variable
    character*(*), intent(in) :: val    ! its value

    call ps_namwr_hd(ilun,descr,units,name)
    write(ilun,'(" ")')

    ilnb = max(1,len(trim(val)))
    write(ilun,'("   ",a," = ",a,a,a)') trim(name),dquot,val(1:ilnb),dquot

  end subroutine ps_namwr_c0

  subroutine ps_namwr_c1(ilun,descr,units,name,inum,val)

    integer, intent(in) :: ilun         ! unit to write
    character*(*), intent(in) :: descr  ! description
    character*(*), intent(in) :: units  ! "units" label
    character*(*), intent(in) :: name   ! name of array
    integer, intent(in) :: inum         ! number of values in array
    character*(*), dimension(inum), intent(in) :: val    ! the values

    integer :: ii

    call ps_namwr_hd(ilun,descr,units,name)
    write(ilun,'(" ")')

    do ii=1,inum
       ilnb = max(1,len(trim(val(ii))))
       if(ii.le.9) then
          write(ilun,'("   ",a,"(",i1,") = ",a,a,a)') trim(name),ii, &
               dquot,val(ii)(1:ilnb),dquot
       else if(ii.le.99) then
          write(ilun,'("   ",a,"(",i2,") = ",a,a,a)') trim(name),ii, &
               dquot,val(ii)(1:ilnb),dquot
       else if(ii.le.999) then
          write(ilun,'("   ",a,"(",i3,") = ",a,a,a)') trim(name),ii, &
               dquot,val(ii)(1:ilnb),dquot
       endif
    enddo
  end subroutine ps_namwr_c1


  subroutine ps_namwr_i0(ilun,descr,units,name,val)

    integer, intent(in) :: ilun         ! unit to write
    character*(*), intent(in) :: descr  ! description
    character*(*), intent(in) :: units  ! "units" label
    character*(*), intent(in) :: name   ! name of variable
    integer, intent(in) :: val    ! its value

    call ps_namwr_hd(ilun,descr,units,name)
    write(ilun,'(" ")')

    if(val.ne.ps_unInit) then
       call ival_clean(val)
       write(ilun,'("   ",a," = ",a)') trim(name),cval(1:ilnb)
    endif

  end subroutine ps_namwr_i0

  subroutine ps_namwr_i1(ilun,descr,units,name,inum,val)

    integer, intent(in) :: ilun         ! unit to write
    character*(*), intent(in) :: descr  ! description
    character*(*), intent(in) :: units  ! "units" label
    character*(*), intent(in) :: name   ! name of array
    integer, intent(in) :: inum         ! number of values in array
    integer, dimension(inum), intent(in) :: val    ! the values

    call ps_namwr_hd(ilun,descr,units,name)
    write(ilun,'(" ")')

    if(inum.gt.0) then
       call namwr_i1_write(ilun,name,0,val)
    endif

  end subroutine ps_namwr_i1

  subroutine ps_namwr_i2(ilun,descr,units,name,isize_vec,vals)

    integer, intent(in) :: ilun         ! unit to write
    character*(*), intent(in) :: descr  ! description
    character*(*), intent(in) :: units  ! "units" label
    character*(*), intent(in) :: name   ! name of array

    integer, intent(in), dimension(:) :: isize_vec  ! row sizes
    integer, intent(in), dimension(:,:) :: vals     ! 2d array of values

    integer :: irows,inum,ii

    call ps_namwr_hd(ilun,descr,units,name)
    write(ilun,'(" ")')

    irows = size(isize_vec)
    do ii=1,irows
       inum = isize_vec(ii)
       if(inum.gt.0) then
          call namwr_i1_write(ilun,name,ii,vals(1:inum,ii))
       endif
    enddo

  end subroutine ps_namwr_i2

  subroutine ps_namwr_d0(ilun,descr,units,name,val)

    integer, intent(in) :: ilun         ! unit to write
    character*(*), intent(in) :: descr  ! description
    character*(*), intent(in) :: units  ! "units" label
    character*(*), intent(in) :: name   ! name of variable
    real*8, intent(in) :: val    ! its value

    call ps_namwr_hd(ilun,descr,units,name)
    write(ilun,'(" ")')

    call dval_clean(val)
    write(ilun,'("   ",a," = ",a)') trim(name),cval(1:ilnb)

  end subroutine ps_namwr_d0

  subroutine ps_namwr_d1(ilun,descr,units,name,inum,val)

    integer, intent(in) :: ilun         ! unit to write
    character*(*), intent(in) :: descr  ! description
    character*(*), intent(in) :: units  ! "units" label
    character*(*), intent(in) :: name   ! name of array
    integer, intent(in) :: inum         ! number of values in array
    real*8, dimension(inum), intent(in) :: val    ! the values

    call ps_namwr_hd(ilun,descr,units,name)
    write(ilun,'(" ")')

    if(inum.gt.0) then
       call namwr_d1_write(ilun,name,0,val)
    endif

  end subroutine ps_namwr_d1

  subroutine ps_namwr_d2(ilun,descr,units,name,isize_vec,vals)

    integer, intent(in) :: ilun         ! unit to write
    character*(*), intent(in) :: descr  ! description
    character*(*), intent(in) :: units  ! "units" label
    character*(*), intent(in) :: name   ! name of array

    integer, intent(in), dimension(:) :: isize_vec  ! row sizes
    real*8, intent(in), dimension(:,:) :: vals      ! 2d array of values

    integer :: irows,inum,ii

    call ps_namwr_hd(ilun,descr,units,name)
    write(ilun,'(" ")')

    irows = size(isize_vec)
    do ii=1,irows
       inum = isize_vec(ii)
       if(inum.gt.0) then
          call namwr_d1_write(ilun,name,ii,vals(1:inum,ii))
       endif
    enddo

  end subroutine ps_namwr_d2

  subroutine ps_namwr_slist(ilun,descr,units,name,inum, &
       snames,sqatom,sq,sm)

    integer, intent(in) :: ilun         ! unit to write
    character*(*), intent(in) :: descr  ! description
    character*(*), intent(in) :: units  ! "units" label
    character*(*), intent(in) :: name   ! name of array
    integer, intent(in) :: inum         ! number of values in array

    character*(*), dimension(inum), intent(in) :: snames  ! specie names
    real*8, dimension(inum), intent(in) :: sqatom  ! specie atomic charges
    real*8, dimension(inum), intent(in) :: sq      ! specie ionic charges
    real*8, dimension(inum), intent(in) :: sm      ! specie masses

    integer :: ibuf(inum)

    call ps_namwr_hd(ilun,descr,units,name)
    write(ilun,'(" ")')

    if(inum.gt.0) then
       ibuf = sm(1:inum)/ps_mp + 0.1
       call namwr_i1_write(ilun,'iAMU_'//trim(name),0,ibuf)

       ibuf = sqatom(1:inum)/ps_xe + 0.1
       call namwr_i1_write(ilun,'iZatom_'//trim(name),0,ibuf)

       ibuf = sq(1:inum)/ps_xe + 0.1
       call namwr_i1_write(ilun,'iZion_'//trim(name),0,ibuf)
    endif

  end subroutine ps_namwr_slist


  !--------------------------------------------------
  ! private routines...

  subroutine namwr_i1_write(ilun,name,ind2,iarray)

    integer, intent(in) :: ilun
    character*(*), intent(in) :: name
    integer, intent(in) :: ind2
    integer, dimension(:), intent(in) :: iarray

    character*120 :: buf
    integer :: ilnam
    integer :: ind0,ind,isize,ic
    character*10 indc
    logical :: toggle

    ilnam = len(trim(name))
    isize = size(iarray)
    ind0=1

    call indc_encode(ind0,ind2,indc)

    do 
       buf = '   '//name(1:ilnam)//'('//trim(indc)//') = '
       ic = len(trim(buf)) + 1

       ind=ind0-1
       toggle = .false.
       do
          ind=ind+1
          if(ind.gt.isize) exit

          call ival_clean(iarray(ind))

          if((ic + ilnb + 1).ge.80 .or. toggle) then
             ind0=ind
             exit
          endif

          if(ind.lt.isize) then
             buf(ic+1:ic+ilnb+1) = cval(1:ilnb)//','
          else
             buf(ic+1:ic+ilnb) = cval(1:ilnb)
          endif
          ic = len(trim(buf)) + 1
          toggle = namwr_single_line
       enddo

       if(ind.le.isize) then
          ic=len(trim(buf))
          buf(ic:ic)=' '  ! remove trailing comma
       endif

       write(ilun,'(A)') trim(buf)
       if(ind.gt.isize) exit

       call indc_encode(ind0,ind2,indc)
    enddo

  end subroutine namwr_i1_write

  subroutine namwr_d1_write(ilun,name,ind2,darray)

    integer, intent(in) :: ilun
    character*(*), intent(in) :: name
    integer, intent(in) :: ind2
    real*8, dimension(:), intent(in) :: darray

    character*120 :: buf
    integer :: ilnam
    integer :: ind0,ind,isize,ic
    character*10 indc
    logical :: toggle

    ilnam = len(trim(name))
    isize = size(darray)
    ind0=1

    call indc_encode(ind0,ind2,indc)

    do 
       buf = '   '//name(1:ilnam)//'('//trim(indc)//') = '
       ic = len(trim(buf)) + 1

       ind=ind0-1
       toggle = .false.
       do
          ind=ind+1
          if(ind.gt.isize) exit

          call dval_clean(darray(ind))

          if((ic + ilnb + 1).ge.80 .or. toggle) then
             ind0=ind
             exit
          endif

          if(ind.lt.isize) then
             buf(ic+1:ic+ilnb+1) = cval(1:ilnb)//','
          else
             buf(ic+1:ic+ilnb) = cval(1:ilnb)
          endif
          ic = len(trim(buf)) + 1
          toggle = namwr_single_line
       enddo

       if(ind.le.isize) then
          ic=len(trim(buf))
          buf(ic:ic)=' '  ! remove trailing comma
       endif

       write(ilun,'(A)') trim(buf)
       if(ind.gt.isize) exit

       call indc_encode(ind0,ind2,indc)
    enddo

  end subroutine namwr_d1_write

  subroutine indc_encode(ind0,ind2,indc)

    integer, intent(in) :: ind0 ! 1st dimension value
    integer, intent(in) :: ind2 ! IF .GT. 0: 2nd dimension value
    character*(*), intent(out) :: indc

    character*4 :: indc2

    indc=' '
    if(ind0.le.9) then
       write(indc(1:1),'(I1)') ind0
    else if(ind0.le.99) then
       write(indc(1:2),'(I2)') ind0
    else if(ind0.le.999) then
       write(indc(1:3),'(I3)') ind0
    else
       write(indc(1:4),'(I4)') ind0
    endif
       
    if(ind2.gt.0) then
       indc2=' '
       if(ind2.le.9) then
          write(indc2(1:1),'(I1)') ind2
       else if(ind2.le.99) then
          write(indc2(1:2),'(I2)') ind2
       else if(ind2.le.999) then
          write(indc2(1:3),'(I3)') ind2
       else
          write(indc2(1:4),'(I4)') ind2
       endif

       indc = trim(indc)//','//trim(indc2)
    endif

  end subroutine indc_encode

  subroutine ival_clean(ival)
    ! (private)
    ! encode an integer (ival) left justified

    integer, intent(in) :: ival

    integer :: ii,ic

    cval=' '
    write(cval,'(I18)') ival

    ic=0
    do ii=1,len(cval)
       if(cval(ii:ii).ne.' ') then
          ic=ic+1
          cval(ic:ic) = cval(ii:ii)
       endif
    enddo

    cval(ic+1:len(cval)) = ' '

    ilnb = len(trim(cval))

  end subroutine ival_clean

  subroutine dval_clean(dval)
    ! (private)
    ! encode a floating point number (dval) and then shorten the
    ! encoding where possible...

    !  examples:  1.200000E+01 -> 12.0
    !             7.000000E-01 ->  0.7
    !             6.300000E+23 ->  6.3e23

    real*8, intent(in) :: dval

    !--------------------
    character*4 cexp
    integer iexp,ic,ilen,ie1,ie2,iechar,ine,istop,imove
    !--------------------

    !------------------------------------------------

    cval=' '
    write(cval,'(1pe18.11)') dval

    ! first find and decode the exponent; substitute "echar"

    ilen=len(cval)
    ie1=0
    ie2=0
    do ic=ilen,1,-1
       if(ie2.eq.0) then
          if(cval(ic:ic).ne.' ') then
             ie2=ic
          endif
       else
          if((cval(ic:ic).eq.'E').or.(cval(ic:ic).eq.'e').or. &
               (cval(ic:ic).eq.'D').or.(cval(ic:ic).eq.'d')) then
             iechar=ic
             ie1=ic+1
             exit
          endif
       endif
    enddo

    cexp=' '
    ine=ie2-ie1+1
    cexp(4-ine+1:4)=cval(ie1:ie2)
    read(cexp,'(I4)') iexp  ! encode exponent
    cval(iechar:)=' '       ! delete exponent from string
    !debug    write(6,*) ' iexp = ',iexp,' cval = ',cval

    istop=5
    if(iexp.eq.1) istop=6
    if(iexp.eq.2) istop=7
    if(iexp.eq.-1) istop=4

    !  now strip off any trailing zeroes

    imove=iechar
    do ic=iechar-1,istop,-1
       if(cval(ic:ic).eq.'0') then
          imove=ic
       else
          exit
       endif
    enddo

    cval(imove:iechar-1)=' '
    if(iexp.eq.-1) then
       do ic=imove-1,4,-1
          cval(ic+1:ic+1)=cval(ic:ic)
       enddo
       cval(4:4)=cval(2:2)
       cval(2:2)='0'
    else if(iexp.eq.0) then
       continue
    else if(iexp.eq.1) then
       cval(3:3)=cval(4:4)
       cval(4:4)='.'
    else if(iexp.eq.2) then
       cval(3:3)=cval(4:4)
       cval(4:4)=cval(5:5)
       cval(5:5)='.'
    else
       cval(imove:imove)=echar
       ic=imove+1
       if(iexp.gt.0) then
          if(iexp.lt.10) then
             write(cval(ic:ic),'(I1)') iexp
          else if(iexp.lt.100) then
             write(cval(ic:ic+1),'(I2)') iexp
          else
             write(cval(ic:ic+2),'(I3)') iexp
          endif
       else
          if(iexp.gt.-10) then
             write(cval(ic:ic+1),'(I2)') iexp
          else if(iexp.gt.-100) then
             write(cval(ic:ic+2),'(I3)') iexp
          else
             write(cval(ic:ic+3),'(I4)') iexp
          endif
       endif
    endif

    ilnb = len(trim(cval))

  end subroutine dval_clean

end module ps_namwr_mod

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)

SUBROUTINE plasma_state_contents_mdescr(itype,icomponent,ss,w,isize)


  ! fill window structure with requested table of contents

  USE plasma_state_mod
  IMPLICIT NONE

  INTEGER, INTENT(IN) :: itype   ! type of table of contents
                                 ! values such as ps_grid_dims or ps_profiles

  INTEGER, INTENT(IN) :: icomponent(ps_ccount) ! component flags
             ! icomponent(j).eq.1 => component j active
             ! e.g. icomponent(ps_cnum_EQ).eq.1 => EQ component is active

  TYPE (plasma_state) :: ss      ! state examined
  TYPE (ps_list_window) :: w     ! list window structure filled

  INTEGER, INTENT(INOUT) :: isize  ! incremented size...

  !local:

  INTEGER :: id,inum
  INTEGER :: i1,i2,i3,i4

  !----------------

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! Ang_Href_coil
        w%list_elems(isize) = "Ang_Href_coil"
        w%elem_descr(isize) = "angle w.r.t. horizontal of coil base"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "degrees"
        w%c256val(isize) = "(ncoils)"
        IF(ALLOCATED(ss%Ang_Href_coil)) THEN
           IF(MAXVAL(ABS(ss%Ang_Href_coil)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! Ang_Vref_coil
        w%list_elems(isize) = "Ang_Vref_coil"
        w%elem_descr(isize) = "angle w.r.t. vertical of coil sides"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "degrees"
        w%c256val(isize) = "(ncoils)"
        IF(ALLOCATED(ss%Ang_Vref_coil)) THEN
           IF(MAXVAL(ABS(ss%Ang_Vref_coil)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! ant_model
        w%list_elems(isize) = "ant_model"
        w%elem_descr(isize) = "antenna model filenames (1 per antenna source)"
        w%component(isize) = "IC"
        w%elem_units(isize) = "character"
        w%c256val(isize) = "(nicrf_src)"
        IF(ALLOCATED(ss%ant_model)) THEN
           w%ival(isize) = 0
           DO I1 = 1,ss%nicrf_src
              IF(ss%ant_model(I1).NE." ") THEN
                 w%ival(isize) = 1
                 exit
              ENDIF
           ENDDO   ! I1
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! ap2_halfheight
        w%list_elems(isize) = "ap2_halfheight"
        w%elem_descr(isize) = "aperture half-height"
        w%component(isize) = "NBI"
        w%elem_units(isize) = "m"
        w%c256val(isize) = "(nbeam)"
        IF(ALLOCATED(ss%ap2_halfheight)) THEN
           IF(MAXVAL(ABS(ss%ap2_halfheight)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! ap2_halfwidth
        w%list_elems(isize) = "ap2_halfwidth"
        w%elem_descr(isize) = "2nd aperture half-width"
        w%component(isize) = "NBI"
        w%elem_units(isize) = "m"
        w%c256val(isize) = "(nbeam)"
        IF(ALLOCATED(ss%ap2_halfwidth)) THEN
           IF(MAXVAL(ABS(ss%ap2_halfwidth)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! ap2_horiz_offset
        w%list_elems(isize) = "ap2_horiz_offset"
        w%elem_descr(isize) = "horizontal offset, 2nd aperture"
        w%component(isize) = "NBI"
        w%elem_units(isize) = "m"
        w%c256val(isize) = "(nbeam)"
        IF(ALLOCATED(ss%ap2_horiz_offset)) THEN
           IF(MAXVAL(ABS(ss%ap2_horiz_offset)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! ap2_vert_offset
        w%list_elems(isize) = "ap2_vert_offset"
        w%elem_descr(isize) = "vertical offset, 2nd aperture"
        w%component(isize) = "NBI"
        w%elem_units(isize) = "m"
        w%c256val(isize) = "(nbeam)"
        IF(ALLOCATED(ss%ap2_vert_offset)) THEN
           IF(MAXVAL(ABS(ss%ap2_vert_offset)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! ap_halfheight
        w%list_elems(isize) = "ap_halfheight"
        w%elem_descr(isize) = "aperture half-height"
        w%component(isize) = "NBI"
        w%elem_units(isize) = "m"
        w%c256val(isize) = "(nbeam)"
        IF(ALLOCATED(ss%ap_halfheight)) THEN
           IF(MAXVAL(ABS(ss%ap_halfheight)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! ap_halfwidth
        w%list_elems(isize) = "ap_halfwidth"
        w%elem_descr(isize) = "aperture half-width"
        w%component(isize) = "NBI"
        w%elem_units(isize) = "m"
        w%c256val(isize) = "(nbeam)"
        IF(ALLOCATED(ss%ap_halfwidth)) THEN
           IF(MAXVAL(ABS(ss%ap_halfwidth)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! ap_horiz_offset
        w%list_elems(isize) = "ap_horiz_offset"
        w%elem_descr(isize) = "horizontal offset of aperture"
        w%component(isize) = "NBI"
        w%elem_units(isize) = "m"
        w%c256val(isize) = "(nbeam)"
        IF(ALLOCATED(ss%ap_horiz_offset)) THEN
           IF(MAXVAL(ABS(ss%ap_horiz_offset)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! ap_vert_offset
        w%list_elems(isize) = "ap_vert_offset"
        w%elem_descr(isize) = "vertical offset of aperture"
        w%component(isize) = "NBI"
        w%elem_units(isize) = "m"
        w%c256val(isize) = "(nbeam)"
        IF(ALLOCATED(ss%ap_vert_offset)) THEN
           IF(MAXVAL(ABS(ss%ap_vert_offset)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! beam_type
        w%list_elems(isize) = "beam_type"
        w%elem_descr(isize) = "beam type:"
        w%component(isize) = "NBI"
        w%elem_units(isize) = "character"
        w%c256val(isize) = "(nbeam)"
        IF(ALLOCATED(ss%beam_type)) THEN
           w%ival(isize) = 0
           DO I1 = 1,ss%nbeam
              IF(ss%beam_type(I1).NE." ") THEN
                 w%ival(isize) = 1
                 exit
              ENDIF
           ENDDO   ! I1
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! b_halfHeight
        w%list_elems(isize) = "b_halfHeight"
        w%elem_descr(isize) = "beam half-height at source"
        w%component(isize) = "NBI"
        w%elem_units(isize) = "m"
        w%c256val(isize) = "(nbeam)"
        IF(ALLOCATED(ss%b_halfHeight)) THEN
           IF(MAXVAL(ABS(ss%b_halfHeight)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! b_halfwidth
        w%list_elems(isize) = "b_halfwidth"
        w%elem_descr(isize) = "beam half-width at source"
        w%component(isize) = "NBI"
        w%elem_units(isize) = "m"
        w%c256val(isize) = "(nbeam)"
        IF(ALLOCATED(ss%b_halfwidth)) THEN
           IF(MAXVAL(ABS(ss%b_halfwidth)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! b_Hdivergence
        w%list_elems(isize) = "b_Hdivergence"
        w%elem_descr(isize) = "horizontal divergence (D) of beam"
        w%component(isize) = "NBI"
        w%elem_units(isize) = "degrees"
        w%c256val(isize) = "(nbeam)"
        IF(ALLOCATED(ss%b_Hdivergence)) THEN
           IF(MAXVAL(ABS(ss%b_Hdivergence)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! b_Hfocal_length
        w%list_elems(isize) = "b_Hfocal_length"
        w%elem_descr(isize) = "horizontal focal length"
        w%component(isize) = "NBI"
        w%elem_units(isize) = "m"
        w%c256val(isize) = "(nbeam)"
        IF(ALLOCATED(ss%b_Hfocal_length)) THEN
           IF(MAXVAL(ABS(ss%b_Hfocal_length)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! b_Vdivergence
        w%list_elems(isize) = "b_Vdivergence"
        w%elem_descr(isize) = "vertical divergence (D) of beam"
        w%component(isize) = "NBI"
        w%elem_units(isize) = "degrees"
        w%c256val(isize) = "(nbeam)"
        IF(ALLOCATED(ss%b_Vdivergence)) THEN
           IF(MAXVAL(ABS(ss%b_Vdivergence)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! b_Vfocal_length
        w%list_elems(isize) = "b_Vfocal_length"
        w%elem_descr(isize) = "vertical focal length"
        w%component(isize) = "NBI"
        w%elem_units(isize) = "m"
        w%c256val(isize) = "(nbeam)"
        IF(ALLOCATED(ss%b_Vfocal_length)) THEN
           IF(MAXVAL(ABS(ss%b_Vfocal_length)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! coil_in_circuit
        w%list_elems(isize) = "coil_in_circuit"
        w%elem_descr(isize) = "circuit to which each coil belongs"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "character"
        w%c256val(isize) = "(ncoils)"
        IF(ALLOCATED(ss%coil_in_circuit)) THEN
           w%ival(isize) = 0
           DO I1 = 1,ss%ncoils
              IF(ss%coil_in_circuit(I1).NE." ") THEN
                 w%ival(isize) = 1
                 exit
              ENDIF
           ENDDO   ! I1
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! coil_resispt
        w%list_elems(isize) = "coil_resispt"
        w%elem_descr(isize) = "coil resistance per turn"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "ohms/turn"
        w%c256val(isize) = "(ncoils)"
        IF(ALLOCATED(ss%coil_resispt)) THEN
           IF(MAXVAL(ABS(ss%coil_resispt)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! dx_fshield
        w%list_elems(isize) = "dx_fshield"
        w%elem_descr(isize) = "distance, antenna to Faraday shield"
        w%component(isize) = "IC"
        w%elem_units(isize) = "m"
        w%c256val(isize) = "(nicrf_src)"
        IF(ALLOCATED(ss%dx_fshield)) THEN
           IF(MAXVAL(ABS(ss%dx_fshield)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! D_einj_standard
        w%list_elems(isize) = "D_einj_standard"
        w%elem_descr(isize) = "D beam table energies"
        w%component(isize) = "NBI"
        w%elem_units(isize) = "keV"
        w%c256val(isize) = "(n_d_einj_standard)"
        IF(ALLOCATED(ss%D_einj_standard)) THEN
           IF(MAXVAL(ABS(ss%D_einj_standard)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! D_ffull_standard
        w%list_elems(isize) = "D_ffull_standard"
        w%elem_descr(isize) = "D beam full energy fractions"
        w%component(isize) = "NBI"
        w%elem_units(isize) = "-"
        w%c256val(isize) = "(n_d_einj_standard)"
        IF(ALLOCATED(ss%D_ffull_standard)) THEN
           IF(MAXVAL(ABS(ss%D_ffull_standard)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! D_fhalf_standard
        w%list_elems(isize) = "D_fhalf_standard"
        w%elem_descr(isize) = "D beam half energy fractions"
        w%component(isize) = "NBI"
        w%elem_units(isize) = "-"
        w%c256val(isize) = "(n_d_einj_standard)"
        IF(ALLOCATED(ss%D_fhalf_standard)) THEN
           IF(MAXVAL(ABS(ss%D_fhalf_standard)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EC).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! EC_Beam_Elongation
        w%list_elems(isize) = "EC_Beam_Elongation"
        w%elem_descr(isize) = "EC beam ellipticity"
        w%component(isize) = "EC"
        w%elem_units(isize) = "-"
        w%c256val(isize) = "(necrf_src)"
        IF(ALLOCATED(ss%EC_Beam_Elongation)) THEN
           IF(MAXVAL(ABS(ss%EC_Beam_Elongation)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EC).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! EC_Half_Power_Angle
        w%list_elems(isize) = "EC_Half_Power_Angle"
        w%elem_descr(isize) = "Divergence of EC beam"
        w%component(isize) = "EC"
        w%elem_units(isize) = "degrees"
        w%c256val(isize) = "(necrf_src)"
        IF(ALLOCATED(ss%EC_Half_Power_Angle)) THEN
           IF(MAXVAL(ABS(ss%EC_Half_Power_Angle)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EC).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! EC_PRINC_CURV_HOR
        w%list_elems(isize) = "EC_PRINC_CURV_HOR"
        w%elem_descr(isize) = "principal curvature in horizontal direction"
        w%component(isize) = "EC"
        w%elem_units(isize) = "m"
        w%c256val(isize) = "(necrf_src)"
        IF(ALLOCATED(ss%EC_PRINC_CURV_HOR)) THEN
           IF(MAXVAL(ABS(ss%EC_PRINC_CURV_HOR)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EC).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! EC_PRINC_CURV_VERT
        w%list_elems(isize) = "EC_PRINC_CURV_VERT"
        w%elem_descr(isize) = "principal curvature in vertical direction"
        w%component(isize) = "EC"
        w%elem_units(isize) = "m"
        w%c256val(isize) = "(necrf_src)"
        IF(ALLOCATED(ss%EC_PRINC_CURV_VERT)) THEN
           IF(MAXVAL(ABS(ss%EC_PRINC_CURV_VERT)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EC).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! EC_PRINC_WIDTH_HOR
        w%list_elems(isize) = "EC_PRINC_WIDTH_HOR"
        w%elem_descr(isize) = "principal beam width in horizontal direction"
        w%component(isize) = "EC"
        w%elem_units(isize) = "m"
        w%c256val(isize) = "(necrf_src)"
        IF(ALLOCATED(ss%EC_PRINC_WIDTH_HOR)) THEN
           IF(MAXVAL(ABS(ss%EC_PRINC_WIDTH_HOR)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EC).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! EC_PRINC_WIDTH_VERT
        w%list_elems(isize) = "EC_PRINC_WIDTH_VERT"
        w%elem_descr(isize) = "principal beam width in vertical direction"
        w%component(isize) = "EC"
        w%elem_units(isize) = "m"
        w%c256val(isize) = "(necrf_src)"
        IF(ALLOCATED(ss%EC_PRINC_WIDTH_VERT)) THEN
           IF(MAXVAL(ABS(ss%EC_PRINC_WIDTH_VERT)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! Einj_max
        w%list_elems(isize) = "Einj_max"
        w%elem_descr(isize) = "maximum injection energy"
        w%component(isize) = "NBI"
        w%elem_units(isize) = "keV"
        w%c256val(isize) = "(nbeam)"
        IF(ALLOCATED(ss%Einj_max)) THEN
           IF(MAXVAL(ABS(ss%Einj_max)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! Einj_min
        w%list_elems(isize) = "Einj_min"
        w%elem_descr(isize) = "minimum injection energy"
        w%component(isize) = "NBI"
        w%elem_units(isize) = "keV"
        w%c256val(isize) = "(nbeam)"
        IF(ALLOCATED(ss%Einj_min)) THEN
           IF(MAXVAL(ABS(ss%Einj_min)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! geometry
        w%list_elems(isize) = "geometry"
        w%elem_descr(isize) = "path to file(s) vac. vessel & coil descr."
        w%component(isize) = "EQ"
        w%elem_units(isize) = "character"
        w%c256val(isize) = "scalar"
        IF(ss%geometry.EQ." ") THEN
           w%ival(isize) = 0
        ELSE
           w%ival(isize) = 1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! Hsize_coil
        w%list_elems(isize) = "Hsize_coil"
        w%elem_descr(isize) = "(Rotatable) Horizontal coil base size"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "m"
        w%c256val(isize) = "(ncoils)"
        IF(ALLOCATED(ss%Hsize_coil)) THEN
           IF(MAXVAL(ABS(ss%Hsize_coil)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! H_einj_standard
        w%list_elems(isize) = "H_einj_standard"
        w%elem_descr(isize) = "H beam table energies"
        w%component(isize) = "NBI"
        w%elem_units(isize) = "keV"
        w%c256val(isize) = "(n_h_einj_standard)"
        IF(ALLOCATED(ss%H_einj_standard)) THEN
           IF(MAXVAL(ABS(ss%H_einj_standard)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! H_ffull_standard
        w%list_elems(isize) = "H_ffull_standard"
        w%elem_descr(isize) = "H beam full energy fractions"
        w%component(isize) = "NBI"
        w%elem_units(isize) = "-"
        w%c256val(isize) = "(n_h_einj_standard)"
        IF(ALLOCATED(ss%H_ffull_standard)) THEN
           IF(MAXVAL(ABS(ss%H_ffull_standard)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! H_fhalf_standard
        w%list_elems(isize) = "H_fhalf_standard"
        w%elem_descr(isize) = "H beam half energy fractions"
        w%component(isize) = "NBI"
        w%elem_units(isize) = "-"
        w%c256val(isize) = "(n_h_einj_standard)"
        IF(ALLOCATED(ss%H_fhalf_standard)) THEN
           IF(MAXVAL(ABS(ss%H_fhalf_standard)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! Lbscap
        w%list_elems(isize) = "Lbscap"
        w%elem_descr(isize) = "distance, source to aperture"
        w%component(isize) = "NBI"
        w%elem_units(isize) = "m"
        w%c256val(isize) = "(nbeam)"
        IF(ALLOCATED(ss%Lbscap)) THEN
           IF(MAXVAL(ABS(ss%Lbscap)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! Lbscap2
        w%list_elems(isize) = "Lbscap2"
        w%elem_descr(isize) = "distance, source to 2nd aperture"
        w%component(isize) = "NBI"
        w%elem_units(isize) = "m"
        w%c256val(isize) = "(nbeam)"
        IF(ALLOCATED(ss%Lbscap2)) THEN
           IF(MAXVAL(ABS(ss%Lbscap2)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! Lbsctan
        w%list_elems(isize) = "Lbsctan"
        w%elem_descr(isize) = "distance, source to tangency point"
        w%component(isize) = "NBI"
        w%elem_units(isize) = "m"
        w%c256val(isize) = "(nbeam)"
        IF(ALLOCATED(ss%Lbsctan)) THEN
           IF(MAXVAL(ABS(ss%Lbsctan)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! nbap2_shape
        w%list_elems(isize) = "nbap2_shape"
        w%elem_descr(isize) = "keyword for optional 2nd aperture"
        w%component(isize) = "NBI"
        w%elem_units(isize) = "character"
        w%c256val(isize) = "(nbeam)"
        IF(ALLOCATED(ss%nbap2_shape)) THEN
           w%ival(isize) = 0
           DO I1 = 1,ss%nbeam
              IF(ss%nbap2_shape(I1).NE." ") THEN
                 w%ival(isize) = 1
                 exit
              ENDIF
           ENDDO   ! I1
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! nbap_shape
        w%list_elems(isize) = "nbap_shape"
        w%elem_descr(isize) = "shape keyword for beam aperture"
        w%component(isize) = "NBI"
        w%elem_units(isize) = "character"
        w%c256val(isize) = "(nbeam)"
        IF(ALLOCATED(ss%nbap_shape)) THEN
           w%ival(isize) = 0
           DO I1 = 1,ss%nbeam
              IF(ss%nbap_shape(I1).NE." ") THEN
                 w%ival(isize) = 1
                 exit
              ENDIF
           ENDDO   ! I1
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! nbshape
        w%list_elems(isize) = "nbshape"
        w%elem_descr(isize) = "shape keyword for beam source grid"
        w%component(isize) = "NBI"
        w%elem_units(isize) = "character"
        w%c256val(isize) = "(nbeam)"
        IF(ALLOCATED(ss%nbshape)) THEN
           w%ival(isize) = 0
           DO I1 = 1,ss%nbeam
              IF(ss%nbshape(I1).NE." ") THEN
                 w%ival(isize) = 1
                 exit
              ENDIF
           ENDDO   ! I1
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! nrz_antgeo
        w%list_elems(isize) = "nrz_antgeo"
        w%elem_descr(isize) = "number of (R,Z) points, antenna geometries"
        w%component(isize) = "IC"
        w%elem_units(isize) = "integer"
        w%c256val(isize) = "(nicrf_src)"
        IF(ALLOCATED(ss%nrz_antgeo)) THEN
           w%ival(isize) = 0
           DO I1 = 1,ss%nicrf_src
              IF((ss%nrz_antgeo(I1).NE.0).AND.(ss%nrz_antgeo(I1).NE.ps_unInit)) THEN
                 w%ival(isize) = 1
                 exit
              ENDIF
           ENDDO   ! I1
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_RIPPLE).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! ntf_coil2
        w%list_elems(isize) = "ntf_coil2"
        w%elem_descr(isize) = "number of TF coils involved in inducing 2nd component"
        w%component(isize) = "RIPPLE"
        w%elem_units(isize) = "integer"
        w%c256val(isize) = "scalar"
        IF((ss%ntf_coil2.EQ.0).OR.(ss%ntf_coil2.EQ.ps_unInit)) THEN
           w%ival(isize) = 0
        ELSE
           w%ival(isize) = 1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_RIPPLE).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! ntf_coils
        w%list_elems(isize) = "ntf_coils"
        w%elem_descr(isize) = "number of TF coils"
        w%component(isize) = "RIPPLE"
        w%elem_units(isize) = "integer"
        w%c256val(isize) = "scalar"
        IF((ss%ntf_coils.EQ.0).OR.(ss%ntf_coils.EQ.ps_unInit)) THEN
           w%ival(isize) = 0
        ELSE
           w%ival(isize) = 1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! Nturns
        w%list_elems(isize) = "Nturns"
        w%elem_descr(isize) = "SIGNED number of conductor turns wrapped in each coil"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "integer"
        w%c256val(isize) = "(ncoils)"
        IF(ALLOCATED(ss%Nturns)) THEN
           w%ival(isize) = 0
           DO I1 = 1,ss%ncoils
              IF((ss%Nturns(I1).NE.0).AND.(ss%Nturns(I1).NE.ps_unInit)) THEN
                 w%ival(isize) = 1
                 exit
              ENDIF
           ENDDO   ! I1
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! num_rzlim
        w%list_elems(isize) = "num_rzlim"
        w%elem_descr(isize) = "number of points, axisymmetric (R,Z) limiter"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "integer"
        w%c256val(isize) = "scalar"
        IF((ss%num_rzlim.EQ.0).OR.(ss%num_rzlim.EQ.ps_unInit)) THEN
           w%ival(isize) = 0
        ELSE
           w%ival(isize) = 1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! n_D_einj_standard
        w%list_elems(isize) = "n_D_einj_standard"
        w%elem_descr(isize) = "no. pts in D beam energy fractions table"
        w%component(isize) = "NBI"
        w%elem_units(isize) = "integer"
        w%c256val(isize) = "scalar"
        IF((ss%n_D_einj_standard.EQ.0).OR.(ss%n_D_einj_standard.EQ.ps_unInit)) THEN
           w%ival(isize) = 0
        ELSE
           w%ival(isize) = 1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! n_H_einj_standard
        w%list_elems(isize) = "n_H_einj_standard"
        w%elem_descr(isize) = "no. pts in H beam energy fractions table"
        w%component(isize) = "NBI"
        w%elem_units(isize) = "integer"
        w%c256val(isize) = "scalar"
        IF((ss%n_H_einj_standard.EQ.0).OR.(ss%n_H_einj_standard.EQ.ps_unInit)) THEN
           w%ival(isize) = 0
        ELSE
           w%ival(isize) = 1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! n_T_einj_standard
        w%list_elems(isize) = "n_T_einj_standard"
        w%elem_descr(isize) = "no. pts in T beam energy fractions table"
        w%component(isize) = "NBI"
        w%elem_units(isize) = "integer"
        w%c256val(isize) = "scalar"
        IF((ss%n_T_einj_standard.EQ.0).OR.(ss%n_T_einj_standard.EQ.ps_unInit)) THEN
           w%ival(isize) = 0
        ELSE
           w%ival(isize) = 1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! Phibsc
        w%list_elems(isize) = "Phibsc"
        w%elem_descr(isize) = "toroidal location of beam source"
        w%component(isize) = "NBI"
        w%elem_units(isize) = "degrees"
        w%c256val(isize) = "(nbeam)"
        IF(ALLOCATED(ss%Phibsc)) THEN
           IF(MAXVAL(ABS(ss%Phibsc)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EC).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! Phi_EC_launch
        w%list_elems(isize) = "Phi_EC_launch"
        w%elem_descr(isize) = "Phi of center of launcher"
        w%component(isize) = "EC"
        w%elem_units(isize) = "degrees"
        w%c256val(isize) = "(necrf_src)"
        IF(ALLOCATED(ss%Phi_EC_launch)) THEN
           IF(MAXVAL(ABS(ss%Phi_EC_launch)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! rlim
        w%list_elems(isize) = "rlim"
        w%elem_descr(isize) = "R points in closed (R,Z) contour sequence"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "m"
        w%c256val(isize) = "(num_rzlim)"
        IF(ALLOCATED(ss%rlim)) THEN
           IF(MAXVAL(ABS(ss%rlim)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! Rloc_coil
        w%list_elems(isize) = "Rloc_coil"
        w%elem_descr(isize) = "R location of coil, lower left corner"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "m"
        w%c256val(isize) = "(ncoils)"
        IF(ALLOCATED(ss%Rloc_coil)) THEN
           IF(MAXVAL(ABS(ss%Rloc_coil)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! R_antgeo
        w%list_elems(isize) = "R_antgeo"
        w%elem_descr(isize) = "antenna geo: R pts"
        w%component(isize) = "IC"
        w%elem_units(isize) = "m"
        w%c256val(isize) = "(max_nrz_antgeo,nicrf_src)"
        IF(ALLOCATED(ss%R_antgeo)) THEN
           IF(MAXVAL(ABS(ss%R_antgeo)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EC).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! R_EC_launch
        w%list_elems(isize) = "R_EC_launch"
        w%elem_descr(isize) = "R of center of launcher"
        w%component(isize) = "EC"
        w%elem_units(isize) = "m"
        w%c256val(isize) = "(necrf_src)"
        IF(ALLOCATED(ss%R_EC_launch)) THEN
           IF(MAXVAL(ABS(ss%R_EC_launch)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! R_max_box
        w%list_elems(isize) = "R_max_box"
        w%elem_descr(isize) = "R_max of bounding box"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "m"
        w%c256val(isize) = "scalar"
        IF(ss%R_max_box.EQ.0.0_rspec) THEN
           w%ival(isize) = 0
        ELSE
           w%ival(isize) = 1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! R_min_box
        w%list_elems(isize) = "R_min_box"
        w%elem_descr(isize) = "R_min of bounding box"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "m"
        w%c256val(isize) = "scalar"
        IF(ss%R_min_box.EQ.0.0_rspec) THEN
           w%ival(isize) = 0
        ELSE
           w%ival(isize) = 1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! sRtcen
        w%list_elems(isize) = "sRtcen"
        w%elem_descr(isize) = "signed tangency radius"
        w%component(isize) = "NBI"
        w%elem_units(isize) = "m"
        w%c256val(isize) = "(nbeam)"
        IF(ALLOCATED(ss%sRtcen)) THEN
           IF(MAXVAL(ABS(ss%sRtcen)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! tokamak_id
        w%list_elems(isize) = "tokamak_id"
        w%elem_descr(isize) = "Tokamak (Machine Description) ID"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "character"
        w%c256val(isize) = "scalar"
        IF(ss%tokamak_id.EQ." ") THEN
           w%ival(isize) = 0
        ELSE
           w%ival(isize) = 1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! T_einj_standard
        w%list_elems(isize) = "T_einj_standard"
        w%elem_descr(isize) = "T beam table energies"
        w%component(isize) = "NBI"
        w%elem_units(isize) = "keV"
        w%c256val(isize) = "(n_t_einj_standard)"
        IF(ALLOCATED(ss%T_einj_standard)) THEN
           IF(MAXVAL(ABS(ss%T_einj_standard)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! T_ffull_standard
        w%list_elems(isize) = "T_ffull_standard"
        w%elem_descr(isize) = "T beam full energy fractions"
        w%component(isize) = "NBI"
        w%elem_units(isize) = "-"
        w%c256val(isize) = "(n_t_einj_standard)"
        IF(ALLOCATED(ss%T_ffull_standard)) THEN
           IF(MAXVAL(ABS(ss%T_ffull_standard)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! T_fhalf_standard
        w%list_elems(isize) = "T_fhalf_standard"
        w%elem_descr(isize) = "T beam half energy fractions"
        w%component(isize) = "NBI"
        w%elem_units(isize) = "-"
        w%c256val(isize) = "(n_t_einj_standard)"
        IF(ALLOCATED(ss%T_fhalf_standard)) THEN
           IF(MAXVAL(ABS(ss%T_fhalf_standard)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! VRep_coil_count
        w%list_elems(isize) = "VRep_coil_count"
        w%elem_descr(isize) = "replication count, vertical coil stack"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "integer"
        w%c256val(isize) = "(ncoils)"
        IF(ALLOCATED(ss%VRep_coil_count)) THEN
           w%ival(isize) = 0
           DO I1 = 1,ss%ncoils
              IF((ss%VRep_coil_count(I1).NE.0).AND.(ss%VRep_coil_count(I1).NE.ps_unInit)) THEN
                 w%ival(isize) = 1
                 exit
              ENDIF
           ENDDO   ! I1
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! Vrep_coil_spacing
        w%list_elems(isize) = "Vrep_coil_spacing"
        w%elem_descr(isize) = "replicated coil separation"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "m"
        w%c256val(isize) = "(ncoils)"
        IF(ALLOCATED(ss%Vrep_coil_spacing)) THEN
           IF(MAXVAL(ABS(ss%Vrep_coil_spacing)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! Vsize_coil
        w%list_elems(isize) = "Vsize_coil"
        w%elem_descr(isize) = "(Rotatable) Vertical coil size"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "m"
        w%c256val(isize) = "(ncoils)"
        IF(ALLOCATED(ss%Vsize_coil)) THEN
           IF(MAXVAL(ABS(ss%Vsize_coil)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! Zbap
        w%list_elems(isize) = "Zbap"
        w%elem_descr(isize) = "elevation of beam centerline at aperture"
        w%component(isize) = "NBI"
        w%elem_units(isize) = "m"
        w%c256val(isize) = "(nbeam)"
        IF(ALLOCATED(ss%Zbap)) THEN
           IF(MAXVAL(ABS(ss%Zbap)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! Zbsc
        w%list_elems(isize) = "Zbsc"
        w%elem_descr(isize) = "elevation of beam source"
        w%component(isize) = "NBI"
        w%elem_units(isize) = "m"
        w%c256val(isize) = "(nbeam)"
        IF(ALLOCATED(ss%Zbsc)) THEN
           IF(MAXVAL(ABS(ss%Zbsc)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! zlim
        w%list_elems(isize) = "zlim"
        w%elem_descr(isize) = "Z points in closed (R,Z) contour sequence"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "m"
        w%c256val(isize) = "(num_rzlim)"
        IF(ALLOCATED(ss%zlim)) THEN
           IF(MAXVAL(ABS(ss%zlim)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! Zloc_coil
        w%list_elems(isize) = "Zloc_coil"
        w%elem_descr(isize) = "Z location of coil, lower left corner"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "m"
        w%c256val(isize) = "(ncoils)"
        IF(ALLOCATED(ss%Zloc_coil)) THEN
           IF(MAXVAL(ABS(ss%Zloc_coil)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! Z_antgeo
        w%list_elems(isize) = "Z_antgeo"
        w%elem_descr(isize) = "antenna geo: Z pts"
        w%component(isize) = "IC"
        w%elem_units(isize) = "m"
        w%c256val(isize) = "(max_nrz_antgeo,nicrf_src)"
        IF(ALLOCATED(ss%Z_antgeo)) THEN
           IF(MAXVAL(ABS(ss%Z_antgeo)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EC).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! Z_EC_launch
        w%list_elems(isize) = "Z_EC_launch"
        w%elem_descr(isize) = "Z of center of launcher"
        w%component(isize) = "EC"
        w%elem_units(isize) = "m"
        w%c256val(isize) = "(necrf_src)"
        IF(ALLOCATED(ss%Z_EC_launch)) THEN
           IF(MAXVAL(ABS(ss%Z_EC_launch)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! Z_max_box
        w%list_elems(isize) = "Z_max_box"
        w%elem_descr(isize) = "Z_max of bounding box"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "m"
        w%c256val(isize) = "scalar"
        IF(ss%Z_max_box.EQ.0.0_rspec) THEN
           w%ival(isize) = 0
        ELSE
           w%ival(isize) = 1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! Z_min_box
        w%list_elems(isize) = "Z_min_box"
        w%elem_descr(isize) = "Z_min of bounding box"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "m"
        w%c256val(isize) = "scalar"
        IF(ss%Z_min_box.EQ.0.0_rspec) THEN
           w%ival(isize) = 0
        ELSE
           w%ival(isize) = 1
        ENDIF
     ENDIF
  ENDIF
END SUBROUTINE plasma_state_contents_mdescr

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_i3_dummy
     return
  end subroutine ccps_getset_i3_dummy

subroutine psget_id_vtor_omp(iobj, n1, data, ierr)
    !! 'Array of IDs for vtor_omp profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_vtor_omp', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_vtor_omp
end subroutine psget_id_vtor_omp


subroutine psgetrnk_id_vtor_omp(iobj, ndims, ierr)
    !! 'Array of IDs for vtor_omp profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_vtor_omp


subroutine psgetdim_id_vtor_omp(iobj, ndims, dims, ierr)
    !! 'Array of IDs for vtor_omp profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_vtor_omp', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_vtor_omp ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_vtor_omp)
    endif
end subroutine psgetdim_id_vtor_omp


subroutine psget_id_ti(iobj, data, ierr)
    !! 'ID for Ti profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_ti', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_ti
end subroutine psget_id_ti


subroutine psget_id_qcomp_i(iobj, data, ierr)
    !! 'ID for qcomp_i profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_qcomp_i', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_qcomp_i
end subroutine psget_id_qcomp_i


subroutine psget_id_sn_trans(iobj, n1, data, ierr)
    !! 'Array of IDs for sn_trans profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_sn_trans', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_sn_trans
end subroutine psget_id_sn_trans


subroutine psgetrnk_id_sn_trans(iobj, ndims, ierr)
    !! 'Array of IDs for sn_trans profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_sn_trans


subroutine psgetdim_id_sn_trans(iobj, ndims, dims, ierr)
    !! 'Array of IDs for sn_trans profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_sn_trans', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_sn_trans ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_sn_trans)
    endif
end subroutine psgetdim_id_sn_trans


subroutine psget_id_chii_trans(iobj, data, ierr)
    !! 'ID for chii_trans profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_chii_trans', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_chii_trans
end subroutine psget_id_chii_trans


subroutine psget_id_vn_transcat(iobj, n1, n2, data, ierr)
    !! 'Array of IDs for vn_transcat profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_vn_transcat', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % id_vn_transcat
end subroutine psget_id_vn_transcat


subroutine psgetrnk_id_vn_transcat(iobj, ndims, ierr)
    !! 'Array of IDs for vn_transcat profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_id_vn_transcat


subroutine psgetdim_id_vn_transcat(iobj, ndims, dims, ierr)
    !! 'Array of IDs for vn_transcat profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_id_vn_transcat', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_vn_transcat ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_vn_transcat)
    endif
end subroutine psgetdim_id_vn_transcat


subroutine psget_id_lpol(iobj, data, ierr)
    !! 'ID for Lpol profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_lpol', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_lpol
end subroutine psget_id_lpol


subroutine psget_id_xrjcos_momeq(iobj, n1, data, ierr)
    !! 'Array of IDs for xRjcos_momeq profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_xrjcos_momeq', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_xrjcos_momeq
end subroutine psget_id_xrjcos_momeq


subroutine psgetrnk_id_xrjcos_momeq(iobj, ndims, ierr)
    !! 'Array of IDs for xRjcos_momeq profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_xrjcos_momeq


subroutine psgetdim_id_xrjcos_momeq(iobj, ndims, dims, ierr)
    !! 'Array of IDs for xRjcos_momeq profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_xrjcos_momeq', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_xrjcos_momeq ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_xrjcos_momeq)
    endif
end subroutine psgetdim_id_xrjcos_momeq


subroutine psget_id_grho1(iobj, data, ierr)
    !! 'ID for grho1 profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_grho1', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_grho1
end subroutine psget_id_grho1


subroutine psget_id_gb1(iobj, data, ierr)
    !! 'ID for gb1 profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_gb1', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_gb1
end subroutine psget_id_gb1


subroutine psget_id_z_midp(iobj, data, ierr)
    !! 'ID for Z_midp profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_z_midp', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_z_midp
end subroutine psget_id_z_midp


subroutine psget_id_rminor_mean(iobj, data, ierr)
    !! 'ID for rMinor_mean profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_rminor_mean', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_rminor_mean
end subroutine psget_id_rminor_mean


subroutine psget_id_picrf_srcs(iobj, n1, n2, data, ierr)
    !! 'Array of IDs for picrf_srcs profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_picrf_srcs', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % id_picrf_srcs
end subroutine psget_id_picrf_srcs


subroutine psgetrnk_id_picrf_srcs(iobj, ndims, ierr)
    !! 'Array of IDs for picrf_srcs profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_id_picrf_srcs


subroutine psgetdim_id_picrf_srcs(iobj, ndims, dims, ierr)
    !! 'Array of IDs for picrf_srcs profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_id_picrf_srcs', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_picrf_srcs ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_picrf_srcs)
    endif
end subroutine psgetdim_id_picrf_srcs


subroutine psget_id_eperp_mini(iobj, n1, data, ierr)
    !! 'Array of IDs for eperp_mini profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_eperp_mini', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_eperp_mini
end subroutine psget_id_eperp_mini


subroutine psgetrnk_id_eperp_mini(iobj, ndims, ierr)
    !! 'Array of IDs for eperp_mini profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_eperp_mini


subroutine psgetdim_id_eperp_mini(iobj, ndims, dims, ierr)
    !! 'Array of IDs for eperp_mini profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_eperp_mini', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_eperp_mini ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_eperp_mini)
    endif
end subroutine psgetdim_id_eperp_mini


subroutine psget_id_tqbe(iobj, data, ierr)
    !! 'ID for tqbe profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_tqbe', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_tqbe
end subroutine psget_id_tqbe


subroutine psget_id_pb0_halo(iobj, data, ierr)
    !! 'ID for pb0_halo profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_pb0_halo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_pb0_halo
end subroutine psget_id_pb0_halo


subroutine psget_id_rate_sinb0x(iobj, n1, data, ierr)
    !! 'Array of IDs for rate_sinb0x profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_rate_sinb0x', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_rate_sinb0x
end subroutine psget_id_rate_sinb0x


subroutine psgetrnk_id_rate_sinb0x(iobj, ndims, ierr)
    !! 'Array of IDs for rate_sinb0x profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_rate_sinb0x


subroutine psgetdim_id_rate_sinb0x(iobj, ndims, dims, ierr)
    !! 'Array of IDs for rate_sinb0x profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_rate_sinb0x', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_rate_sinb0x ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_rate_sinb0x)
    endif
end subroutine psgetdim_id_rate_sinb0x


subroutine psget_id_sftherm(iobj, n1, data, ierr)
    !! 'Array of IDs for sftherm profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_sftherm', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_sftherm
end subroutine psget_id_sftherm


subroutine psgetrnk_id_sftherm(iobj, ndims, ierr)
    !! 'Array of IDs for sftherm profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_sftherm


subroutine psgetdim_id_sftherm(iobj, ndims, dims, ierr)
    !! 'Array of IDs for sftherm profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_sftherm', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_sftherm ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_sftherm)
    endif
end subroutine psgetdim_id_sftherm


subroutine psget_id_epll_rw(iobj, data, ierr)
    !! 'ID for epll_rw profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_epll_rw', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_epll_rw
end subroutine psget_id_epll_rw


subroutine psget_id_t0cx(iobj, n1, data, ierr)
    !! 'Array of IDs for T0cx profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_t0cx', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_t0cx
end subroutine psget_id_t0cx


subroutine psgetrnk_id_t0cx(iobj, ndims, ierr)
    !! 'Array of IDs for T0cx profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_t0cx


subroutine psgetdim_id_t0cx(iobj, ndims, dims, ierr)
    !! 'Array of IDs for T0cx profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_t0cx', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_t0cx ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_t0cx)
    endif
end subroutine psgetdim_id_t0cx


subroutine psget_id_p0_reco(iobj, data, ierr)
    !! 'ID for p0_reco profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_p0_reco', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_p0_reco
end subroutine psget_id_p0_reco


subroutine psget_id_curech(iobj, data, ierr)
    !! 'ID for curech profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_curech', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_curech
end subroutine psget_id_curech


subroutine psget_id_tfrip_log(iobj, data, ierr)
    !! 'ID for tfrip_log profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_tfrip_log', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_tfrip_log
end subroutine psget_id_tfrip_log


subroutine psget_id_fidiff_btrap(iobj, n1, data, ierr)
    !! 'Array of IDs for fidiff_btrap profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_fidiff_btrap', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_fidiff_btrap
end subroutine psget_id_fidiff_btrap


subroutine psgetrnk_id_fidiff_btrap(iobj, ndims, ierr)
    !! 'Array of IDs for fidiff_btrap profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_fidiff_btrap


subroutine psgetdim_id_fidiff_btrap(iobj, ndims, dims, ierr)
    !! 'Array of IDs for fidiff_btrap profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_fidiff_btrap', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_fidiff_btrap ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_fidiff_btrap)
    endif
end subroutine psgetdim_id_fidiff_btrap


subroutine psget_id_bidiff_dpass_ctr(iobj, n1, data, ierr)
    !! 'Array of IDs for bidiff_dpass_ctr profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_bidiff_dpass_ctr', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_bidiff_dpass_ctr
end subroutine psget_id_bidiff_dpass_ctr


subroutine psgetrnk_id_bidiff_dpass_ctr(iobj, ndims, ierr)
    !! 'Array of IDs for bidiff_dpass_ctr profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_bidiff_dpass_ctr


subroutine psgetdim_id_bidiff_dpass_ctr(iobj, ndims, dims, ierr)
    !! 'Array of IDs for bidiff_dpass_ctr profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_bidiff_dpass_ctr', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_bidiff_dpass_ctr ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_bidiff_dpass_ctr)
    endif
end subroutine psgetdim_id_bidiff_dpass_ctr


subroutine psget_id_chii_anom(iobj, data, ierr)
    !! 'ID for chii_anom profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_chii_anom', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_chii_anom
end subroutine psget_id_chii_anom


subroutine psget_id_ti_ky_tglf(iobj, n1, data, ierr)
    !! 'Array of IDs for ti_ky_tglf profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_ti_ky_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_ti_ky_tglf
end subroutine psget_id_ti_ky_tglf


subroutine psgetrnk_id_ti_ky_tglf(iobj, ndims, ierr)
    !! 'Array of IDs for ti_ky_tglf profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_ti_ky_tglf


subroutine psgetdim_id_ti_ky_tglf(iobj, ndims, dims, ierr)
    !! 'Array of IDs for ti_ky_tglf profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_ti_ky_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_ti_ky_tglf ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_ti_ky_tglf)
    endif
end subroutine psgetdim_id_ti_ky_tglf


subroutine psget_id_growthrate_max_tglf(iobj, data, ierr)
    !! 'ID for growthrate_max_tglf profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_growthrate_max_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_growthrate_max_tglf
end subroutine psget_id_growthrate_max_tglf


subroutine psget_id_chie_tglf(iobj, data, ierr)
    !! 'ID for chie_tglf profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_chie_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_chie_tglf
end subroutine psget_id_chie_tglf


subroutine psget_id_difns_mmm71(iobj, n1, data, ierr)
    !! 'Array of IDs for difns_mmm71 profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_difns_mmm71', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_difns_mmm71
end subroutine psget_id_difns_mmm71


subroutine psgetrnk_id_difns_mmm71(iobj, ndims, ierr)
    !! 'Array of IDs for difns_mmm71 profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_difns_mmm71


subroutine psgetdim_id_difns_mmm71(iobj, ndims, dims, ierr)
    !! 'Array of IDs for difns_mmm71 profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_difns_mmm71', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_difns_mmm71 ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_difns_mmm71)
    endif
end subroutine psgetdim_id_difns_mmm71


subroutine psget_id_chiphi_w19(iobj, data, ierr)
    !! 'ID for chiphi_w19 profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_chiphi_w19', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_chiphi_w19
end subroutine psget_id_chiphi_w19


subroutine psget_id_velte_paleo(iobj, data, ierr)
    !! 'ID for velte_paleo profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_velte_paleo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_velte_paleo
end subroutine psget_id_velte_paleo


subroutine psget_id_velti_glf(iobj, data, ierr)
    !! 'ID for velti_glf profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_velti_glf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_velti_glf
end subroutine psget_id_velti_glf


subroutine psget_id_difns_gtcneo(iobj, n1, data, ierr)
    !! 'Array of IDs for difns_gtcneo profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_difns_gtcneo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_difns_gtcneo
end subroutine psget_id_difns_gtcneo


subroutine psgetrnk_id_difns_gtcneo(iobj, ndims, ierr)
    !! 'Array of IDs for difns_gtcneo profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_difns_gtcneo


subroutine psgetdim_id_difns_gtcneo(iobj, ndims, dims, ierr)
    !! 'Array of IDs for difns_gtcneo profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_difns_gtcneo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_difns_gtcneo ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_difns_gtcneo)
    endif
end subroutine psgetdim_id_difns_gtcneo


subroutine psget_id_velti_neo(iobj, data, ierr)
    !! 'ID for velti_neo profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_velti_neo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_velti_neo
end subroutine psget_id_velti_neo


subroutine psget_id_velti_nclass(iobj, data, ierr)
    !! 'ID for velti_nclass profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_velti_nclass', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_velti_nclass
end subroutine psget_id_velti_nclass

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


MODULE plasma_state_definition_mod

#include "ps_container_size.h"

  USE plasma_state_constants_mod
  USE plasma_state_util_mod

  ! plasma_state header:

  use swim_global_data_mod, only: rspec, swim_err_out_file, swim_error
  implicit NONE


  !--------------------------------------------
  !
  !  PLASMA STATE DATA TYPE
  !
  !--------------------------------------------

  !  assumed size (#integer words) of a plasma_state_container instance...
  !  Note: use MACRO defined in #include file!

  INTEGER, PARAMETER :: ps_container_size = __PS_CONTAINER_SIZE

  TYPE :: plasma_state_container

     TYPE (plasma_state), pointer :: ps_ptr => NULL()

  END TYPE plasma_state_container

  TYPE :: plasma_state

     ! version of the software (i.e. that wrote state data to a file)

     CHARACTER*32 :: version_ID

     ! ---------------------------------------
     ! internal tags for use of software that manages collections of
     ! plasma states.  These quantities are not read from or written to
     ! disk files not copied between state objects!  these must be
     ! maintained by the module or software which instantiates state
     ! objects.

     INTEGER :: itag = ps_unInit
     CHARACTER*32 :: chtag = ' '

     ! this is an opaque container for an interpolation object-- a
     ! separate such object to be associated with each state instance.
     !  Note: use MACRO defined in #include file!

     INTEGER :: iobj(ps_container_size) = __PS_CONTAINER_INIT

     ! as of Jan. 2008 "xplasma" provides the interpolation capability
     ! but in principle this could be replaced.  This object will imbed
     ! a pointer, and it cannot be safely copied, nor read from nor written
     ! to disk files!  See "plasma_state_mod.f90" for usage.

     ! ---------------------------------------
     ! zone weight mapping index
     ! if ID_ZONWT(id) is ZERO, the weighting is just volume or area
     ! depending on the profile type; if it is non-zero, it is an ID
     ! of a profile over the same grid that is to be used for weighting
     ! (for example, when Temperatures are rezoned a density weighting
     ! would be used; ID_ZONWT(id) will point to the correct density profile).
     ! This is updated when the state is updated or read from file.

     INTEGER, dimension(:), allocatable :: ID_ZONWT

     ! ---------------------------
     ! hash codes
     ! These are used to detect that a profile, grid, or set of variables
     ! contains changes (e.g. when just read in from a file).

     INTEGER, dimension(ps_hash_total) :: hash_codes      ! file copy
     INTEGER, dimension(ps_hash_total) :: new_hash_codes  ! updated..
     INTEGER, dimension(ps_hash_total) :: saved_hash_codes  ! saved..

     ! ---------------------------
     ! count of active dimensions in each component

     INTEGER, dimension(ps_ccount) :: active_dims

     ! --------------------------------------------------------------------


     !===============================================
     ! Section: MACHINE_DESCRIPTION

     !----------------------------
     ! Component: ANOM

     !----------------------------
     ! Component: EC

     ! ** Item List Dimension **

     INTEGER :: necrf_src = 0
       !item list dimension of ecrf_src_name (ecrf_source)
       !L|ecrf_source   ecrf_src_name(necrf_src)

     CHARACTER*32, DIMENSION(:), ALLOCATABLE :: ecrf_src_name
       !number & name of ECRF sources
       !L|ecrf_source   ecrf_src_name(necrf_src)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: EC_Beam_Elongation
       !EC beam ellipticity
       !The conical EC beam shape can be elongated
       !"vertically" (elongation > 1) or "horizontally"
       !(elongation < 1).  Here "vertical" means in the
       !direction normal to the plane contaiing the beam
       !centerline and the +phi unit vector; "horizontal"
       !means normal to the plane of the beam centerline
       !and the "vertical" direction.  If this quantity is
       !defaulted to zero, it is reset to 1.0 exactly, i.e.
       !for a beam with circular cross section.
       !R|units=-   EC_Beam_Elongation(necrf_src)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: EC_Half_Power_Angle
       !Divergence of EC beam
       !beam at half-power, this half-angle away from
       !direction of beam centerline which is started
       !at the launcher (treated as a point source);
       !See EC_theta_aim(necrf_src) & EC_phi_aim(necrf_src)
       !in the shot configuration section.
       !R|units=degrees  EC_Half_Power_Angle(necrf_src)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: EC_PRINC_CURV_HOR
       !principal curvature in horizontal direction
       !R|units=m  EC_PRINC_CURV_HOR(necrf_src)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: EC_PRINC_CURV_VERT
       !principal curvature in vertical direction
       !R|units=m  EC_PRINC_CURV_VERT(necrf_src)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: EC_PRINC_WIDTH_HOR
       !principal beam width in horizontal direction
       !R|units=m  EC_PRINC_WIDTH_HOR(necrf_src)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: EC_PRINC_WIDTH_VERT
       !principal beam width in vertical direction
       !R|units=m  EC_PRINC_WIDTH_VERT(necrf_src)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: Phi_EC_launch
       !Phi of center of launcher
       !this may be left at zero for axisymmetric simulations.
       !R|units=degrees  Phi_EC_launch(necrf_src)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: R_EC_launch
       !R of center of launcher
       !R|units=m   R_EC_launch(necrf_src)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: Z_EC_launch
       !Z of center of launcher
       !R|units=m   Z_EC_launch(necrf_src)

     !----------------------------
     ! Component: EQ

     ! ** Item List Dimension **

     INTEGER :: ncircuits = 0
       !item list dimension of circuit_name (pf_circuits)
       !L|pf_circuits  circuit_name(ncircuits)

     ! ** Item List Dimension **

     INTEGER :: ncoils = 0
       !item list dimension of coil_name (pf_coils)
       !L|pf_coils     coil_name(ncoils)

     ! ** (Ad hoc) Array Dimension **

     INTEGER :: num_rzlim = 0
       !number of points, axisymmetric (R,Z) limiter
       !dimension for rlim & zlim -- closed axisymmetric piecewise linear
       !contour describing axisymmetric limiter or vacuum vessel wall
       !expect rlim(1)=rlim(num_rzlim) and zlim(1)=zlim(num_rzlim)
       !I|ENUM  num_rzlim

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: Ang_Href_coil
       !angle w.r.t. horizontal of coil base
       !zero means, base is alligned horizontally
       !+10 (degrees) means, tilted up to the right;
       !-10 (degrees) means, tilted down to the right
       !R|units=degrees Ang_Href_coil(ncoils)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: Ang_Vref_coil
       !angle w.r.t. vertical of coil sides
       !zero means, walls are alligned vertically
       !+10 (degrees) means, tilted up and to left 10 degrees from vertical
       !-10 (degrees) means, tilted up and to right, 10 degrees from vertical
       !R|units=degrees Ang_Vref_coil(ncoils)

     CHARACTER*32, DIMENSION(:), ALLOCATABLE :: circuit_name
       !Number & names of circuits
       !connecting coils affecting poloidal field-- axisymmetric coils,
       !or eddy currents represented as cancelling coil pairs
       !L|pf_circuits  circuit_name(ncircuits)

     CHARACTER*32, DIMENSION(:), ALLOCATABLE :: coil_in_circuit
       !circuit to which each coil belongs
       !(each must exactly match a name in the circuit_name(...) list).
       !N  coil_in_circuit(ncoils)

     CHARACTER*32, DIMENSION(:), ALLOCATABLE :: coil_name
       !Number & name of axisymmetric coils
       !L|pf_coils     coil_name(ncoils)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: coil_resispt
       !coil resistance per turn
       !total resistance (ohms) of coil j: abs(Nturns(j))*coil_resispt(j)
       !R|units=ohms/turn  coil_resispt(ncoils)

     CHARACTER*256 :: geometry = " "
       !path to file(s) vac. vessel & coil descr.
       !F  geometry

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: Hsize_coil
       !(Rotatable) Horizontal coil base size
       !R|units=m  Hsize_coil(ncoils)

     INTEGER, DIMENSION(:), ALLOCATABLE :: Nturns
       !SIGNED number of conductor turns wrapped in each coil
       !+ means, a positive current flows counter-clockwise viewed from above;
       !- means, a positive current flows clockwise viewed from above;
       !I  Nturns(ncoils)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: rlim
       !R points in closed (R,Z) contour sequence
       !R|units=m  rlim(num_rzlim)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: Rloc_coil
       !R location of coil, lower left corner
       !R|units=m  Rloc_coil(ncoils)

     REAL(KIND=rspec) :: R_max_box = 0.0_rspec
       !R_max of bounding box
       !R  R_max_box

     REAL(KIND=rspec) :: R_min_box = 0.0_rspec
       !R_min of bounding box
       !R  R_min_box

     INTEGER, DIMENSION(:), ALLOCATABLE :: VRep_coil_count
       !replication count, vertical coil stack
       !default: 1
       !I  VRep_coil_count(ncoils)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: Vrep_coil_spacing
       !replicated coil separation
       !(only meaningful for coils {k} with VRep_coil_count(k) > 1).
       !R|units=m Vrep_coil_spacing(ncoils)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: Vsize_coil
       !(Rotatable) Vertical coil size
       !R|units=m  Vsize_coil(ncoils)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: zlim
       !Z points in closed (R,Z) contour sequence
       !R|units=m  zlim(num_rzlim)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: Zloc_coil
       !Z location of coil, lower left corner
       !R|units=m  Zloc_coil(ncoils)

     REAL(KIND=rspec) :: Z_max_box = 0.0_rspec
       !Z_max of bounding box
       !R  Z_max_box

     REAL(KIND=rspec) :: Z_min_box = 0.0_rspec
       !Z_min of bounding box
       !R  Z_min_box

     !----------------------------
     ! Component: FUS

     !----------------------------
     ! Component: GAS

     !----------------------------
     ! Component: IC

     ! ** (Ad hoc) Array Dimension **

     INTEGER :: max_nrz_antgeo = 0
       !Maximum size of variable length enumeration: NRZ_ANTGEO
       !(derived from NRZ_ANTGEO)

     ! ** Item List Dimension **

     INTEGER :: nicrf_src = 0
       !item list dimension of icrf_src_name (icrf_source)
       !L|icrf_source   icrf_src_name(nicrf_src)

     CHARACTER*256, DIMENSION(:), ALLOCATABLE :: ant_model
       !antenna model filenames (1 per antenna source)
       !F ant_model(nicrf_src)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: dx_fshield
       !distance, antenna to Faraday shield
       !R|units=m dx_fshield(nicrf_src)

     CHARACTER*32, DIMENSION(:), ALLOCATABLE :: icrf_src_name
       !number & name of ICRF sources
       !L|icrf_source   icrf_src_name(nicrf_src)

     INTEGER, DIMENSION(:), ALLOCATABLE :: nrz_antgeo
       !number of (R,Z) points, antenna geometries
       !I|ENUM nrz_antgeo(nicrf_src)

     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: R_antgeo
       !antenna geo: R pts
       !R|units=m R_antgeo(nrz_antgeo(),nicrf_src)

     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: Z_antgeo
       !antenna geo: Z pts
       !R|units=m Z_antgeo(nrz_antgeo(),nicrf_src)

     !----------------------------
     ! Component: LH

     ! ** Item List Dimension **

     INTEGER :: nlhrf_src = 0
       !item list dimension of lhrf_src_name (lhrf_source)
       !L|lhrf_source   lhrf_src_name(nlhrf_src)

     CHARACTER*32, DIMENSION(:), ALLOCATABLE :: lhrf_src_name
       !number & name of LHRF sources
       !L|lhrf_source   lhrf_src_name(nlhrf_src)

     !----------------------------
     ! Component: LMHD

     !----------------------------
     ! Component: NBI

     ! ** Item List Dimension **

     INTEGER :: nbeam = 0
       !item list dimension of nbi_src_name (neutral_beams)
       !L|neutral_beams nbi_src_name(nbeam)

     ! ** (Ad hoc) Array Dimension **

     INTEGER :: n_D_einj_standard = 0
       !no. pts in D beam energy fractions table
       !I|ENUM n_D_einj_standard

     ! ** (Ad hoc) Array Dimension **

     INTEGER :: n_H_einj_standard = 0
       !no. pts in H beam energy fractions table
       !I|ENUM n_H_einj_standard

     ! ** (Ad hoc) Array Dimension **

     INTEGER :: n_T_einj_standard = 0
       !no. pts in T beam energy fractions table
       !I|ENUM n_T_einj_standard

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: ap2_halfheight
       !aperture half-height
       !for nbap_shape(j)="rectangle", this is the vertical size
       !specification; this quantity ignored for nbap_shape(j)="circle", or
       !if there is no 2nd aperture.
       !R|units=m         ap2_halfheight(nbeam)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: ap2_halfwidth
       !2nd aperture half-width
       !for nbap_shape(j)="rectangle", this is the horizontal size
       !specification; for nbap_shape(j)="circle", ap_halfwidth(j) is
       !the radius; ignored if there is no 2nd aperture.
       !R|units=m         ap2_halfwidth(nbeam)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: ap2_horiz_offset
       !horizontal offset, 2nd aperture
       !opening relative to beam centerline; positive value means shift of
       !aperture away from machine axis i.e. to make a beam with a larger
       !tangency radius
       !R|units=m         ap2_horiz_offset(nbeam)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: ap2_vert_offset
       !vertical offset, 2nd aperture
       !opening relative to beam centerline: positive value means the
       !aperture opening is shifted upward relative to the beam centerline
       !R|units=m         ap2_vert_offset(nbeam)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: ap_halfheight
       !aperture half-height
       !for nbap_shape(j)="rectangle", this is the vertical size
       !specification; this quantity ignored for nbap_shape(j)="circle".
       !R|units=m         ap_halfheight(nbeam)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: ap_halfwidth
       !aperture half-width
       !for nbap_shape(j)="rectangle", this is the horizontal size
       !specification; for nbap_shape(j)="circle", ap_halfwidth(j) is
       !the radius.
       !R|units=m         ap_halfwidth(nbeam)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: ap_horiz_offset
       !horizontal offset of aperture
       !opening relative to beam centerline; positive value means shift of
       !aperture away from machine axis i.e. to make a beam with a larger
       !tangency radius
       !R|units=m         ap_horiz_offset(nbeam)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: ap_vert_offset
       !vertical offset of aperture
       !opening relative to beam centerline: positive value means the
       !aperture opening is shifted upward relative to the beam centerline
       !R|units=m         ap_vert_offset(nbeam)

     CHARACTER*32, DIMENSION(:), ALLOCATABLE :: beam_type
       !beam type:
       !"standard", H/D/T beam using standard full-half-third energy
       !injection fractions; energy dependence of standard beam energy
       !fractions are defined as part of the machine description
       !"negative_ion", H/D/T beam 100% injected at full energy
       !"Helium" for Helium or He3 beam, energy fraction is 100% full energy.
       !"Impurity" for injection of one of: {Ne,Ar,Xe,Kr}: 100% full energy.
       !N     beam_type(nbeam)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: b_halfHeight
       !beam half-height at source
       !If nbshape(j)="Rectangle" this is the vertical half-height of the
       !beam at its source grid.  This quantity ignored for
       !nbshape(j)="circle".
       !R|units=m       b_halfHeight(nbeam)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: b_halfwidth
       !beam half-width at source
       !If nbshape(j)="Rectangle" this is the horizontal half-width of
       !the source rectangle for beam j; if nbshape(j)="circle" it is
       !the radius of the circular source for beam j, in meters.
       !R|units=m       b_halfwidth(nbeam)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: b_Hdivergence
       !horizontal divergence (D) of beam
       !for nbshape(j)="circle" sources this is the ONLY divergence.
       !--> definition of D (b_Hdivergence(...) given in DEGREES):
       !for alpha the random angle of deviation from the direction of
       !aiming, P(alpha) ~ exp(-alpha**2/D**2); P(D) = (1/e)*P(0)
       !I.e. D is the angle of deviation from the aiming angle, in
       !either direction, for a (1/e) reduction in probability of
       !launch of a beam particle.
       !R|units=degrees   b_Hdivergence(nbeam)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: b_Hfocal_length
       !horizontal focal length
       !for nbshape(j)="circle" sources this is the only focal length.
       !R|units=m       b_Hfocal_length(nbeam)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: b_Vdivergence
       !vertical divergence (D) of beam
       !used for nbshape(j)="Rectangle" sources ONLY.
       !--> definition of D (b_Vdivergence(...) given in DEGREES):
       !for alpha the random angle of deviation from the direction of
       !aiming, P(alpha) ~ exp(-alpha**2/D**2); P(D) = (1/e)*P(0)
       !I.e. D is the angle of deviation from the aiming angle, in
       !either direction, for a (1/e) reduction in probability of
       !launch of a beam particle.
       !R|units=degrees   b_Vdivergence(nbeam)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: b_Vfocal_length
       !vertical focal length
       !used for nbshape(j)="Rectangle" sources only.
       !R|units=m       b_Vfocal_length(nbeam)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: D_einj_standard
       !D beam table energies
       !for full-half-third energy beam current fractions data
       !R|units=keV D_einj_standard(n_D_einj_standard)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: D_ffull_standard
       !D beam full energy fractions
       !R|units=- D_ffull_standard(n_D_einj_standard)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: D_fhalf_standard
       !D beam half energy fractions
       !R|units=- D_fhalf_standard(n_D_einj_standard)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: Einj_max
       !maximum injection energy
       !maximum energy of the full energy fractional component of each beam
       !Some codes use 1.5*maxval(Einj_max) as an upper limit on a lab frame
       !energy grid for beam ions slowing down distribution functions.
       !R|units=keV       Einj_max(nbeam)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: Einj_min
       !minimum injection energy
       !minimum energy of the full energy fractional component of each beam
       !R|units=keV       Einj_min(nbeam)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: H_einj_standard
       !H beam table energies
       !for full-half-third energy beam current fractions data
       !R|units=keV H_einj_standard(n_H_einj_standard)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: H_ffull_standard
       !H beam full energy fractions
       !R|units=- H_ffull_standard(n_H_einj_standard)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: H_fhalf_standard
       !H beam half energy fractions
       !R|units=- H_fhalf_standard(n_H_einj_standard)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: Lbscap
       !distance, source to aperture
       !Distance of beam centerline from source to aperture into vacuum vessel
       !R|units=m       Lbscap(nbeam)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: Lbscap2
       !distance, source to 2nd aperture
       !Distance of beam centerline from source to center of 2nd aperture
       !into vacuum vessel.
       !R|units=m       Lbscap2(nbeam)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: Lbsctan
       !distance, source to tangency point
       !This is the length of the centerline from the center of the neutral
       !beam's original ion source to the centerline tangency point, |sRtcen|
       !from the machine axis.  The length is given in meters.
       !R|units=m       Lbsctan(nbeam)

     CHARACTER*32, DIMENSION(:), ALLOCATABLE :: nbap2_shape
       !keyword for optional 2nd aperture
       !For beam j, nbap2_shape= blank or 'None': no 2nd aperture
       !Other possible values:  "Rectangle"; "Circle".
       !The beam centerline is assumed to pass through the center of the
       !aperture.
       !N     nbap2_shape(nbeam)

     CHARACTER*32, DIMENSION(:), ALLOCATABLE :: nbap_shape
       !shape keyword for beam aperture
       !For beam j, nbap_shape(j)="Rectangle" indicates a rectangular
       !aperture; nbap_shape(j)="Circle" indicates a circular aperture.
       !The beam centerline is assumed to pass through the center of the
       !aperture.
       !N     nbap_shape(nbeam)

     CHARACTER*32, DIMENSION(:), ALLOCATABLE :: nbi_src_name
       !number & name of neutral beams
       !L|neutral_beams nbi_src_name(nbeam)

     CHARACTER*32, DIMENSION(:), ALLOCATABLE :: nbshape
       !shape keyword for beam source grid
       !For beam j, nbshape(j)="Rectangle" indicates a rectangular shaped
       !source; nbshape(j)="Circle" indicates a circular shaped source.
       !(The keyword must be spelled correctly but upper or lower case
       !letters may be used interchangeably).  The plane of
       !the source is assumed perpendicular to the beam centerline.
       !N     nbshape(nbeam)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: Phibsc
       !toroidal location of beam source
       !Angle of location of beam centerline at source, with respect to some
       !reference Phi=0 vertical plane.  Phi is assumed to increase in the
       !counter-clockwise direction of the torus when viewed from above, i.e.
       !(R,phi,Z) form a right handed coordinate system.  The setting of
       !Phibsc does not affect beam heating in axisymmetric simulations.
       !R|units=degrees       Phibsc(nbeam)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: sRtcen
       !signed tangency radius
       !This is the major radius of tangency of the neutral beam centerlines--
       !i.e. the distance of closest approach of each beam centerline to the
       !machine axis, in meters.
       !Sign convention: + for beams which impart angular momentum in the
       !counter-clockwise direction around the torus as viewed from above.
       !R|units=m       sRtcen(nbeam)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: T_einj_standard
       !T beam table energies
       !for full-half-third energy beam current fractions data
       !R|units=keV T_einj_standard(n_T_einj_standard)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: T_ffull_standard
       !T beam full energy fractions
       !R|units=- T_ffull_standard(n_T_einj_standard)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: T_fhalf_standard
       !T beam half energy fractions
       !R|units=- T_fhalf_standard(n_T_einj_standard)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: Zbap
       !elevation of beam centerline at aperture
       !At a distance (Lbscap) from the beam source, the beam centerline
       !passes above (+) or below (-) machine midplane as defined by Z=0
       !in the equilibrium specification.  If defaulted, the centerline
       !is centered on the midplane (Z=0) when it crosses the plane of the
       !aperture.  If both Zbap(...) and Zbsc(...) are defaulted, the
       !entire beam centerline lies in the midplane.
       !Note that Z at the beam centerline tangency radius is:
       !Ztan = Zbsc + (Lbsctan/Lbscap)*(Zbap-Zbsc)
       !R|units=m       Zbap(nbeam)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: Zbsc
       !elevation of beam source
       !Elevation of beam centerline at source (+ above) (- below)
       !machine midplane as defined by Z=0 in the equilibrium specification
       !(the default, 0.0, centers beam source in the machine midplane).
       !R|units=m       Zbsc(nbeam)

     !----------------------------
     ! Component: PEL

     !----------------------------
     ! Component: PLASMA

     CHARACTER*32 :: tokamak_id = " "
       !Tokamak (Machine Description) ID
       !<tokid>_<revid> within a 32 character string.
       !N  tokamak_id

     !----------------------------
     ! Component: RAD

     !----------------------------
     ! Component: RIPPLE

     INTEGER :: ntf_coil2 = ps_unInit
       !number of TF coils involved in inducing 2nd component
       !of TF ripple field (typically ntf_coil2 = ntf_coils/2).
       !(This 2nd TF ripple field is sometimes introduced in
       !tokamak experiments to study the effects of TF ripple
       !induced fast ion loss).
       !I ntf_coil2

     INTEGER :: ntf_coils = ps_unInit
       !number of TF coils
       !the number of toroidal field (TF) coils is also the
       !number of periods in the main TF ripple field
       !I ntf_coils

     !----------------------------
     ! Component: RUNAWAY

     !===============================================
     ! Section: SHOT_CONFIGURATION

     !----------------------------
     ! Component: ANOM

     !----------------------------
     ! Component: EC

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: EC_Omode_Fraction
       !O-mode fraction of EC source
       !Power(O-mode)/(Power(O-mode)+Power(X-mode))
       !R|units=-   EC_Omode_Fraction(necrf_src)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: EC_phi_aim
       !toroidal aiming angle
       !0 degrees-> component of beam in +R direction
       !90 degrees-> component of beam in +phi direction
       !180 degrees-> component of beam in -R direction
       !270 degrees or -90 degrees-> component in -phi direction
       !An EC beam with a component in the +phi direction
       !will push electrons in the +phi direction, counter
       !clockwise (CCW) around the machine axis as viewed
       !from above; and hence drive current in a clockwise
       !(CW) direction.  See shot configuration variable
       !kCCW_Jphi for orientation of main plasma current.
       !See also EC_theta_aim(...).
       !R|units=degrees  EC_phi_aim(necrf_src)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: EC_theta_aim
       !poloidal aiming angle
       != angle from +Z direction:
       !0 degrees-> straight up;
       !+/-  45 degrees-> on a cone in an upward direction
       !+/-  90 degrees-> in a horizontal direction...
       !+/- 135 degrees-> on a cone in a downward direction
       !+/- 180 degrees-> straight down
       !(for values other than 0,+/- 180, see alse EC_phi_aim).
       !R|units=degrees  EC_theta_aim(necrf_src)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: freq_ec
       !frequency of EC source
       !R|units=Hz freq_ec(necrf_src)

     !----------------------------
     ! Component: EQ

     INTEGER :: kccw_Bphi = 0
       !B_phi orientation: +1 means CCW viewed from above
       !-1 means clockwise (CW) viewed from above.
       !I  kccw_Bphi = 0

     INTEGER :: kccw_Jphi = 0
       !J_phi orientation: +1 means CCW viewed from above
       !I  kccw_Jphi = 0

     !----------------------------
     ! Component: FUS

     ! ** Species List Dimension **

     INTEGER :: nspec_fusion = 0
       !species list dimension of SFUS (fusion_ion)
       !S|fusion_ion   SFUS(nspec_fusion)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: m_SFUS
       !SFUS specie mass
       !S|fusion_ion   SFUS(nspec_fusion)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: qatom_SFUS
       !SFUS atomic number
       !S|fusion_ion   SFUS(nspec_fusion)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: q_SFUS
       !SFUS specie charge
       !S|fusion_ion   SFUS(nspec_fusion)

     CHARACTER*32, DIMENSION(:), ALLOCATABLE :: SFUS_name
       !fusion product ion species
       !S|fusion_ion   SFUS(nspec_fusion)

     INTEGER, DIMENSION(:), ALLOCATABLE :: SFUS_type
       !SFUS specie types
       !S|fusion_ion   SFUS(nspec_fusion)

     !----------------------------
     ! Component: GAS

     ! ** Item List Dimension **

     INTEGER :: ngsc0 = 0
       !item list dimension of gs_name (gas_source)
       !L|gas_source    gs_name(ngsc0)

     CHARACTER*32, DIMENSION(:), ALLOCATABLE :: gas_atom
       !name of species introduced by each gas source
       !Possible values are: "H", "D", "T", "He3", and "He4" at present.
       !Each must correspond to an actual species in the SGAS list.
       !N  gas_atom(ngsc0)

     CHARACTER*32, DIMENSION(:), ALLOCATABLE :: gs_name
       !number & name of edge neutral gas sources
       !L|gas_source    gs_name(ngsc0)

     INTEGER, DIMENSION(:), ALLOCATABLE :: is_recycling
       !0/1; =1 to for recycling sources
       !i.e. sources proportional to ion outfluxes
       !I  is_recycling(ngsc0)

     !----------------------------
     ! Component: IC

     ! ** (Ad hoc) Array Dimension **

     INTEGER :: max_num_nphi = 0
       !Maximum size of variable length enumeration: NUM_NPHI
       !(derived from NUM_NPHI)

     ! ** (Ad hoc) Array Dimension **

     INTEGER :: max_num_nphi_vac = 0
       !Maximum size of variable length enumeration: NUM_NPHI_VAC
       !(derived from NUM_NPHI_VAC)

     ! ** (Ad hoc) Array Dimension **

     INTEGER :: max_n_straps = 0
       !Maximum size of variable length enumeration: N_STRAPS
       !(derived from N_STRAPS)

     ! ** Species List Dimension **

     INTEGER :: nspec_rfmin = 0
       !species list dimension of RFMIN (RF_minority)
       !S|RF_minority  RFMIN(nspec_rfmin)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: freq_ic
       !frequency on each ICRF source
       !R|units=Hz freq_ic(nicrf_src)

     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: Imag_ant_coef
       !imag part of Fourier Coef
       !R|units=Amps/m Imag_ant_coef(num_nphi_vac(),nicrf_src)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: m_RFMIN
       !RFMIN specie mass
       !S|RF_minority  RFMIN(nspec_rfmin)

     INTEGER, DIMENSION(:,:), ALLOCATABLE :: nphi
       !n_phi wave spectrum from antenna
       !I nphi(num_nphi(),nicrf_src)

     INTEGER, DIMENSION(:), ALLOCATABLE :: num_nphi
       !number of non-zero n_phi values
       !counting both positive and negative
       !n_phi values
       !I|ENUM:nphi  num_nphi(nicrf_src)

     INTEGER, DIMENSION(:), ALLOCATABLE :: num_nphi_vac
       !number of non-zero n_phi values
       !counting both positive and negative
       !n_phi values for the retained vacuum
       !spectrum--will typicall be a few hundred
       !or less and is a super set of num_phi
       !I|ENUM num_nphi_vac(nicrf_src)

     INTEGER, DIMENSION(:), ALLOCATABLE :: n_straps
       !number of straps in the antenna
       !I|ENUM n_straps(nicrf_src)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: qatom_RFMIN
       !RFMIN atomic number
       !S|RF_minority  RFMIN(nspec_rfmin)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: q_RFMIN
       !RFMIN specie charge
       !S|RF_minority  RFMIN(nspec_rfmin)

     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: Real_ant_coef
       !real part of Fourier Coef
       !R|units=Amps/m Real_ant_coef(num_nphi_vac(),nicrf_src)

     CHARACTER*32, DIMENSION(:), ALLOCATABLE :: RFMIN_name
       !ICRF minority species
       !S|RF_minority  RFMIN(nspec_rfmin)

     INTEGER, DIMENSION(:), ALLOCATABLE :: RFMIN_type
       !RFMIN specie types
       !S|RF_minority  RFMIN(nspec_rfmin)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: R_ant
       !major radius of antenna
       !R|units=m R_ant(nicrf_src)

     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: wt_nphi
       !vacuum spectrum n_phi weight
       !power_ic(iant)*wt_nphi(ind,iant)
       !gives "vacuum" power @nphi(ind,iant)
       !"ind" covers range 1:num_nphi(iant).
       !see also wt_nphi_abs(...)
       !R|units=- wt_nphi(num_nphi(),nicrf_src)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: Z_ant
       !height of antenna
       !R|units=m Z_ant(nicrf_src)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: Z_mid_ant
       !center of antenna relative to TF coil midplane
       !machine midplane as defined by Z=0 in the equilibrium specification
       !same reference as used for beams
       !default of 0.0 could be used, but ant. is often offset
       !R|units=m Z_mid_ant(nicrf_src)

     !----------------------------
     ! Component: LH

     ! ** (Ad hoc) Array Dimension **

     INTEGER :: max_nspectrumlh_src = 0
       !Maximum size of variable length enumeration: NSPECTRUMLH_SRC
       !(derived from NSPECTRUMLH_SRC)

     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: amaxlh
       !width of the spectrum peak
       !R|units=- amaxlh(nspectrumlh_src(),nlhrf_src)

     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: aminlh
       !parallel mode number, center of the spectrum peak
       !R|units=- aminlh(nspectrumlh_src(),nlhrf_src)

     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: apolmaxlh
       !poloidal mode number right of lumps
       !R|units=- apolmaxlh(nspectrumlh_src(),nlhrf_src)

     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: apolminlh
       !poloidal mode number left of lumps
       !R|units=- apolminlh(nspectrumlh_src(),nlhrf_src)

     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: atormaxlh
       !toroidal mode number right of lumps
       !R|units=- atormaxlh(nspectrumlh_src(),nlhrf_src)

     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: atorminlh
       !toroidal mode number left of lumps
       !R|units=- atorminlh(nspectrumlh_src(),nlhrf_src)

     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: fracpslh
       !fraction of power on each peak (the sum over all peaks must be 1)
       !R|units=- fracpslh(nspectrumlh_src(),nlhrf_src)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: freq_lh
       !frequency on each LHRF source
       !R|units=Hz freq_lh(nlhrf_src)

     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: hegrilh
       !need description
       !R|units=- hegrilh(nspectrumlh_src(),nlhrf_src)

     INTEGER :: i_npoloidal = ps_unInit
       !need description
       !I i_npoloidal

     INTEGER, DIMENSION(:,:), ALLOCATABLE :: nnkparlh
       !need description
       !I nnkparlh(nspectrumlh_src(),nlhrf_src)

     INTEGER, DIMENSION(:,:), ALLOCATABLE :: nnkpollh
       !need description
       !I nnkpollh(nspectrumlh_src(),nlhrf_src)

     INTEGER, DIMENSION(:,:), ALLOCATABLE :: nnktorlh
       !need description
       !I nnktorlh(nspectrumlh_src(),nlhrf_src)

     INTEGER, DIMENSION(:), ALLOCATABLE :: nspectrumlh_src
       !number of spectrum peaks
       !I|ENUM nspectrumlh_src(nlhrf_src)

     INTEGER, DIMENSION(:,:), ALLOCATABLE :: nthinlh
       !need description
       !I nthinlh(nspectrumlh_src(),nlhrf_src)

     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: phigrilh
       !need description
       !R|units=- phigrilh(nspectrumlh_src(),nlhrf_src)

     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: rhopsi0lh
       !need description
       !R|units=- rhopsi0lh(nspectrumlh_src(),nlhrf_src)

     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: thegrilh
       !need description
       !R|units=- thegrilh(nspectrumlh_src(),nlhrf_src)

     !----------------------------
     ! Component: LMHD

     !----------------------------
     ! Component: NBI

     CHARACTER*32, DIMENSION(:), ALLOCATABLE :: nbion
       !name of species injected by each beam.
       !Possible values are: "H", "D", "T", "He3", and "He4" at present.
       !DMC Apr 2010: added: "Ne", "Ar", "Kr", "Xe"
       !Each beam can inject one species.  Multiple beams (or usually
       !all beams) can inject the same species.
       !the SNBI species list will be constructed from nbion elements;
       !in many experiments this will consist only of the single element "D".
       !N  nbion(nbeam)

     CHARACTER*32, DIMENSION(:), ALLOCATABLE :: nbion_trace
       !(if non-blank) beam trace element
       !Possible values same as nbion; nbion(ib).ne.nbion_trace(ib) enforced.
       !This allows a second trace element to be injected with any neutral
       !beam-- as in trace tritium beam experiments, or, heating beams doped
       !with a noble gas species.  See: power_nbi_trace(...)
       !N  nbion_trace(nbeam)

     !----------------------------
     ! Component: PEL

     !----------------------------
     ! Component: PLASMA

     ! ** Species List Dimension **

     INTEGER :: nspec_th = 0
       !species list dimension of S (thermal_specie)
       !S|thermal_specie  S(0:nspec_th)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: m_S
       !S specie mass
       !S|thermal_specie  S(0:nspec_th)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: qatom_S
       !S atomic number
       !S|thermal_specie  S(0:nspec_th)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: q_S
       !S specie charge
       !S|thermal_specie  S(0:nspec_th)

     INTEGER :: shot_number = ps_unInit
       !integer shot number
       !I shot_number

     CHARACTER*32, DIMENSION(:), ALLOCATABLE :: S_name
       !thermal species list
       !index 0 for electrons
       !S|thermal_specie  S(0:nspec_th)

     INTEGER, DIMENSION(:), ALLOCATABLE :: S_type
       !S specie types
       !S|thermal_specie  S(0:nspec_th)

     !----------------------------
     ! Component: RAD

     ! ** Item List Dimension **

     INTEGER :: nxs = 0
       !item list dimension of xs_name (impurity_source)
       !L|impurity_source  xs_name(nxs)

     CHARACTER*32, DIMENSION(:), ALLOCATABLE :: xs_name
       !number & name of impurity sources
       !L|impurity_source  xs_name(nxs)

     !----------------------------
     ! Component: RIPPLE

     !----------------------------
     ! Component: RUNAWAY

     !===============================================
     ! Section: SIMULATION_INIT

     !----------------------------
     ! Component: ANOM

     ! ** E Grid Dimension **

     INTEGER :: nefi_anom = 0
       !grid dimension of E_anom (E coordinate)
       !G  E_anom(nefi_anom)

     ! ** E Grid Dimension **

     INTEGER :: nefi_anom2 = 0
       !grid dimension of E_anom2 (E coordinate)
       !G  E_anom2(nefi_anom2)

     ! ** (Ad hoc) Array Dimension **

     INTEGER :: nky_anomth = 0
       !number of points, ky grid ( anomalous data over ky spectrum)
       !I|ENUM  nky_anomth

     ! ** (Ad hoc) Array Dimension **

     INTEGER :: nky_mmm = 0
       !number of points, ky grid for MMM model
       !I|ENUM  nky_mmm

     ! ** RHO Grid Dimension **

     INTEGER :: nrho_anom = 0
       !grid dimension of rho_anom (RHO coordinate)
       !G  rho_anom(nrho_anom)

     ! ** RHO Grid Dimension **

     INTEGER :: nrho_anom2 = 0
       !grid dimension of rho_anom2 (RHO coordinate)
       !G  rho_anom2(nrho_anom2)

     ! ** RHO Grid Dimension **

     INTEGER :: nrho_anomth = 0
       !grid dimension of rho_anomth (RHO coordinate)
       !G  rho_anomth(nrho_anomth)

     CHARACTER*80 :: ANOM_Code_Info = " "
       !Information: code implementing ANOM component
       !C*80   ANOM_Code_Info

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: E_anom
       !(optional) energy grid (1d profiles)
       !for separated variation of fast ion
       !anomalous transport with fast ion energy
       !G  E_anom(nefi_anom)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: E_anom2
       !energy grid (2d anomalous transport profiles)
       !for Db(E,rho), separate profiles for various
       !pitch related limiting orbit topologies:
       !deeply trapped
       !barely trapped
       !barely passing  co/ctr
       !vpll/v -> 1 limit  co/ctr
       !G  E_anom2(nefi_anom2)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: rho_anom
       !rho grid (1d anomalous transport profiles)
       !G  rho_anom(nrho_anom)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: rho_anom2
       !rho grid (2d anomalous transport profiles)
       !G  rho_anom2(nrho_anom2)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: rho_anomth
       !rho grid (1d anomalous data for 1d
       !transport models)
       !G  rho_anomth(nrho_anomth)

     !----------------------------
     ! Component: EC

     ! ** RHO Grid Dimension **

     INTEGER :: nrho_ecrf = 0
       !grid dimension of rho_ecrf (RHO coordinate)
       !G  rho_ecrf(nrho_ecrf)

     CHARACTER*80 :: EC_Code_Info = " "
       !Information: code implementing EC component
       !C*80   EC_Code_Info

     CHARACTER*80 :: EC_Data_Info = " "
       !information on source of ECRF power data
       !C*80   EC_Data_Info

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: rho_ecrf
       !rho grid -- ECRF
       !G  rho_ecrf(nrho_ecrf)

     !----------------------------
     ! Component: EQ

     ! ** Item List Dimension **

     INTEGER :: neqmom = 0
       !item list dimension of eqmom_num (EQ_moments)
       !L|EQ_moments  eqmom_num(neqmom)

     ! ** Item List Dimension **

     INTEGER :: npsmom = 0
       !item list dimension of psmom_num (PS_moments)
       !L|PS_moments  psmom_num(npsmom)

     ! ** R Grid Dimension **

     INTEGER :: nr = 0
       !grid dimension of R_grid (R coordinate)
       !G   R_grid(nR)

     ! ** RHO Grid Dimension **

     INTEGER :: nrho_eq = 0
       !grid dimension of rho_eq (RHO coordinate)
       !G   rho_eq(nrho_eq)

     ! ** RHO Grid Dimension **

     INTEGER :: nrho_eq_geo = 0
       !grid dimension of rho_eq_geo (RHO coordinate)
       !G   rho_eq_geo(nrho_eq_geo)

     ! ** TH Grid Dimension **

     INTEGER :: nth_eq = 0
       !grid dimension of th_eq (TH coordinate)
       !G|CCW   th_eq(nth_eq)

     ! ** Z Grid Dimension **

     INTEGER :: nz = 0
       !grid dimension of Z_grid (Z coordinate)
       !G   Z_grid(nZ)

     CHARACTER*32, DIMENSION(:), ALLOCATABLE :: eqmom_num
       !Equilibrium moments
       !neqmom = nmom; eqmom_num(1)='1', eqmom_num(2)='2', etc...
       !L|EQ_moments  eqmom_num(neqmom)

     CHARACTER*80 :: EQ_Code_Info = " "
       !Information: code implementing EQ component
       !C*80   EQ_Code_Info

     CHARACTER*80 :: EQ_Data_Info = " "
       !Information: source of EQ input data
       !C*80   EQ_Data_Info

     INTEGER, DIMENSION(:), ALLOCATABLE :: icircuit_coil
       !index of circuit to which each coil belongs
       !(derived from machine description): coil j, named coil_name(j),
       !belongs to the circuit named circuit_name(icircuit_coil(j)).
       !I  icircuit_coil(ncoils)

     INTEGER :: nmom = 16
       !number of Fourier (R,Z) moments
       !requested for Fourier Spline representation
       !R(x,th) = R0(x) + sum x*(xRj(x)*cos(j*th) + xRj~(x)*sin(j*th))
       !Z(x,th) = Z0(x) + sum x*(xZj~(x)*cos(j*th) + xZj(x)*sin(j*th))
       !I  nmom = 16

     CHARACTER*32, DIMENSION(:), ALLOCATABLE :: psmom_num
       !Pfirsch-Schlutter moments
       !if call to compute PS moments occurs and this has not been
       !initialized, npsmom=16 will be set, and psmom_num(1)='1',
       !psmom_num(2)='2', ..., psmom_num(16)='16'
       !L|PS_moments  psmom_num(npsmom)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: rho_eq
       !rho grid (EQ)
       !G   rho_eq(nrho_eq)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: rho_eq_geo
       !rho grid (EQ flux surface averages)
       !this grid is built from rho_eq: nrho_eq_geo = 2*nrho_eq - 1
       !rho_eq_geo(1:nrho_eq_geo:2) = rho_eq(1:nrho_eq)
       !rho_eq_geo(2:nrho_eq_geo:2) =
       !(rho_eq(1:nrho_eq-1)+rho_eq(2:nrho_eq))/2
       !i.e. a doubly fine grid for metric flux surface averages stored
       !as piecewise linear radidal profiles.
       !G   rho_eq_geo(nrho_eq_geo)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: R_grid
       !R grid
       !G   R_grid(nR)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: th_eq
       !theta grid (EQ)
       !G|CCW   th_eq(nth_eq)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: Z_grid
       !Z grid
       !G   Z_grid(nZ)

     !----------------------------
     ! Component: FUS

     ! ** RHO Grid Dimension **

     INTEGER :: nrho_fus = 0
       !grid dimension of rho_fus (RHO coordinate)
       !G  rho_fus(nrho_fus)

     CHARACTER*80 :: FUS_Code_Info = " "
       !Information: code implementing FUS component
       !C*80   FUS_Code_Info

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: rho_fus
       !rho grid -- Fusion products model
       !G  rho_fus(nrho_fus)

     !----------------------------
     ! Component: GAS

     ! ** RHO Grid Dimension **

     INTEGER :: nrho_gas = 0
       !grid dimension of rho_gas (RHO coordinate)
       !G  rho_gas(nrho_gas)

     ! ** Species List Dimension **

     INTEGER :: nspec_gas = 0
       !species list dimension of SGAS (neutral_gas)
       !S|neutral_gas  SGAS(nspec_gas)

     ! ** Species List Dimension **

     INTEGER :: nspec_imp0 = 0
       !species list dimension of SIMP0 (impurity_atoms)
       !S|impurity_atoms SIMP0(nspec_imp0)

     CHARACTER*80 :: GAS_Code_Info = " "
       !Information: code implementing GAS component
       !C*80   GAS_Code_Info

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: m_SGAS
       !SGAS specie mass
       !S|neutral_gas  SGAS(nspec_gas)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: m_SIMP0
       !SIMP0 specie mass
       !S|impurity_atoms SIMP0(nspec_imp0)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: qatom_SGAS
       !SGAS atomic number
       !S|neutral_gas  SGAS(nspec_gas)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: qatom_SIMP0
       !SIMP0 atomic number
       !S|impurity_atoms SIMP0(nspec_imp0)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: q_SGAS
       !SGAS specie charge
       !S|neutral_gas  SGAS(nspec_gas)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: q_SIMP0
       !SIMP0 specie charge
       !S|impurity_atoms SIMP0(nspec_imp0)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: rho_gas
       !rho grid (GAS -- neutral gas model)
       !G  rho_gas(nrho_gas)

     INTEGER, DIMENSION(:), ALLOCATABLE :: sc0_to_sgas
       !index map from neutral source to neutral species
       !(computed from GAS_ATOM(ngsc0)).
       !this indicates the species injected by the source
       !although charge exchange induces a source/sink
       !profile of additional species proportional to
       !each source.
       !I  sc0_to_sgas(ngsc0)

     CHARACTER*32, DIMENSION(:), ALLOCATABLE :: SGAS_name
       !atomic neutral species in plasma core
       !S|neutral_gas  SGAS(nspec_gas)

     INTEGER, DIMENSION(:), ALLOCATABLE :: sgas_to_s
       !map sgas index to "s" list
       !I  sgas_to_s(nspec_gas)

     INTEGER, DIMENSION(:), ALLOCATABLE :: SGAS_type
       !SGAS specie types
       !S|neutral_gas  SGAS(nspec_gas)

     CHARACTER*32, DIMENSION(:), ALLOCATABLE :: SIMP0_name
       !atomic impurity species in simulation
       !S|impurity_atoms SIMP0(nspec_imp0)

     INTEGER, DIMENSION(:), ALLOCATABLE :: simp0_to_s
       !map simp0 index to "s" list
       !I  simp0_to_s(nspec_imp0)

     INTEGER, DIMENSION(:), ALLOCATABLE :: SIMP0_type
       !SIMP0 specie types
       !S|impurity_atoms SIMP0(nspec_imp0)

     !----------------------------
     ! Component: IC

     ! ** RHO Grid Dimension **

     INTEGER :: nrho_icrf = 0
       !grid dimension of rho_icrf (RHO coordinate)
       !G  rho_icrf(nrho_icrf)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: fracmin
       !minority density fraction if kdens_rfmin="fraction"
       !if so, it must have non-zero positive value for each minority ion specie.
       !sum(fracmin) << 1 is expected.
       !R|units=- fracmin(nspec_rfmin)

     CHARACTER*80 :: IC_Code_Info = " "
       !Information: code implementing IC component
       !C*80   IC_Code_Info

     CHARACTER*80 :: IC_Data_Info = " "
       !information on source of ICRF power data
       !C*80   IC_Data_Info

     CHARACTER*32 :: kdens_rfmin = "data"
       != "fraction" => nmini(i) = fracmin(i)*ne
       != any other value (e.g. "data" or "model") then
       !the minority density is set by some other
       !means (e.g. read in from another data source).
       !N  kdens_rfmin = "data"

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: rho_icrf
       !rho grid (RF)
       !G  rho_icrf(nrho_icrf)

     !----------------------------
     ! Component: LH

     ! ** RHO Grid Dimension **

     INTEGER :: nrho_lhrf = 0
       !grid dimension of rho_lhrf (RHO coordinate)
       !G  rho_lhrf(nrho_lhrf)

     CHARACTER*80 :: LH_Code_Info = " "
       !Information: code implementing LH component
       !C*80   LH_Code_Info

     CHARACTER*80 :: LH_Data_Info = " "
       !Information on source of LHRF power data
       !C*80   LH_Data_Info

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: rho_lhrf
       !rho grid -- LHRF
       !G  rho_lhrf(nrho_lhrf)

     !----------------------------
     ! Component: LMHD

     ! ** Item List Dimension **

     INTEGER :: mmodes = 0
       !item list dimension of Tor_mode_label (toroidal_modes)
       !L|toroidal_modes Tor_mode_label(mmodes)

     ! ** Item List Dimension **

     INTEGER :: nballoon = 0
       !item list dimension of Balloon_code (Balloon_codes)
       !L|Balloon_codes  Balloon_code(nballoon)

     ! ** Item List Dimension **

     INTEGER :: ndelta_w = 0
       !item list dimension of DeltaW_code (Delta_W_codes)
       !L|Delta_W_codes  DeltaW_code(ndelta_w)

     ! ** Item List Dimension **

     INTEGER :: nnewcomb = 0
       !item list dimension of Newcomb_code (Newcomb_codes)
       !L|Newcomb_codes  Newcomb_code(nnewcomb)

     ! ** RHO Grid Dimension **

     INTEGER :: nrho_lmhd = 0
       !grid dimension of rho_lmhd (RHO coordinate)
       !G  rho_lmhd(nrho_lmhd)

     CHARACTER*32, DIMENSION(:), ALLOCATABLE :: Balloon_code
       !name(s) of Ballooning code(s) used
       !L|Balloon_codes  Balloon_code(nballoon)

     CHARACTER*32, DIMENSION(:), ALLOCATABLE :: Balloon_mapper
       !mapper code used for each ballooning code
       !N  Balloon_mapper(nballoon)

     CHARACTER*32, DIMENSION(:), ALLOCATABLE :: DeltaW_code
       !name(s) of delta(W) code(s) used
       !L|Delta_W_codes  DeltaW_code(ndelta_w)

     CHARACTER*32, DIMENSION(:), ALLOCATABLE :: DeltaW_mapper
       !mapper code used for each delta(W) code
       !N  DeltaW_mapper(ndelta_W)

     CHARACTER*32 :: LMHD_eq_code = " "
       !name of MHD equilibrium refinement code used
       !N  LMHD_eq_code

     CHARACTER*32, DIMENSION(:), ALLOCATABLE :: Newcomb_code
       !name(s) of Newcomb code(s) used
       !L|Newcomb_codes  Newcomb_code(nnewcomb)

     CHARACTER*32, DIMENSION(:), ALLOCATABLE :: Newcomb_mapper
       !mapper code used for each Newcomb code
       !N  Newcomb_mapper(nnewcomb)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: rho_lmhd
       !rho grid (LMHD component)
       !G  rho_lmhd(nrho_lmhd)

     CHARACTER*32, DIMENSION(:), ALLOCATABLE :: Tor_mode_label
       !Toroidal modes to monitor
       !L|toroidal_modes Tor_mode_label(mmodes)

     INTEGER, DIMENSION(:), ALLOCATABLE :: Tor_mode_No
       !(from input) Toroidal modes monitored
       !set at initialization, would not vary in time
       !likely just: 1,2,3,...,mmodes
       !I   Tor_mode_No(mmodes)

     !----------------------------
     ! Component: NBI

     ! ** RHO Grid Dimension **

     INTEGER :: nrho_nbi = 0
       !grid dimension of rho_nbi (RHO coordinate)
       !G  rho_nbi(nrho_nbi)

     ! ** Species List Dimension **

     INTEGER :: nspec_beam = 0
       !species list dimension of SNBI (beam_ion)
       !S|beam_ion     SNBI(nspec_beam)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: m_SNBI
       !SNBI specie mass
       !S|beam_ion     SNBI(nspec_beam)

     CHARACTER*80 :: NBI_Code_Info = " "
       !Information: code implementing NBI component
       !C*80   NBI_Code_Info

     CHARACTER*80 :: NBI_Data_Info = " "
       !information on source of beam power & voltage data
       !C*80   NBI_Data_Info

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: qatom_SNBI
       !SNBI atomic number
       !S|beam_ion     SNBI(nspec_beam)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: q_SNBI
       !SNBI specie charge
       !S|beam_ion     SNBI(nspec_beam)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: rho_nbi
       !rho grid -- NBI
       !G  rho_nbi(nrho_nbi)

     CHARACTER*32, DIMENSION(:), ALLOCATABLE :: SNBI_name
       !beam ion species
       !this species list to be constructed from nbion(1:nbeam)
       !and augmented optionally by nbion_trace(1:nbeam)
       !S|beam_ion     SNBI(nspec_beam)

     INTEGER, DIMENSION(:), ALLOCATABLE :: SNBI_type
       !SNBI specie types
       !S|beam_ion     SNBI(nspec_beam)

     INTEGER, DIMENSION(:), ALLOCATABLE :: trace_flag
       !trace element flag
       !0 means, beam has no trace element;
       !1 means, trace element, matching injection energy fractions
       !2 means, trace element injected at 100% full energy
       !(1 will be set if the trace element is an isotope of
       !of the beam's main injection specie; 2 if not).
       !I  trace_flag(nbeam)

     !----------------------------
     ! Component: PEL

     ! ** RHO Grid Dimension **

     INTEGER :: nrho_pel = 0
       !grid dimension of rho_pel (RHO coordinate)
       !G  rho_pel(nrho_pel)

     CHARACTER*80 :: PEL_Code_Info = " "
       !Information: code implementing PELLET component
       !C*80   PEL_Code_Info

     CHARACTER*80 :: PEL_Data_Info = " "
       !Information: on source of pellet injection
       !C*80   PEL_Data_Info

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: rho_pel
       !rho grid -- PEL
       !G  rho_pel(nrho_pel)

     !----------------------------
     ! Component: PLASMA

     ! ** RHO Grid Dimension **

     INTEGER :: nrho = 0
       !grid dimension of rho (RHO coordinate)
       !G   rho(nrho)

     ! ** Species List Dimension **

     INTEGER :: nspec_all = 0
       !species list dimension of ALL (specie)
       !S|specie  ALL(0:nspec_all)

     ! ** Species List Dimension **

     INTEGER :: nspec_alla = 0
       !species list dimension of ALLA (specie)
       !S|specie  ALLA(0:nspec_alla)

     ! ** Species List Dimension **

     INTEGER :: nspec_impi = 0
       !species list dimension of SIMPI (impurity_atoms)
       !S|impurity_atoms SIMPI(nspec_impi)

     ! ** Species List Dimension **

     INTEGER :: nspec_tha = 0
       !species list dimension of SA (thermal_specie)
       !S|thermal_specie  SA(0:nspec_tha)

     ! ** Item List Dimension **

     INTEGER :: ntrcat = 0
       !item list dimension of trcat (TR_categories)
       !L|TR_categories  trcat(ntrcat)

     INTEGER, DIMENSION(:), ALLOCATABLE :: alla_index
       !species index in original lists
       !alla_index(j)=-1 indicates that element (j) of the "alla" list is
       !derived from a composite of ions in the "s" list (using Zeff
       !and quasineutrality equations).
       !otherwise for thermal ions alla_index(j) gives the index of the
       !species in "S".  For example, if index 2 corresponds to Deuterium
       !thermal ions in "alla", then alla_index(2) gives the index in "S"
       !for Deuterium thermal ions.  For non-thermal ions, ion species j
       !corresponds to species index:
       !alla_index(j) in "SNBI" if all_type(j) = ps_beam_ion
       !alla_index(j) in "RFMIN" if all_type(j) = ps_rf_minority
       !alla_index(j) in "SFUS" if all_type(j) = ps_fusion_ion
       !I alla_index(0:nspec_alla)

     CHARACTER*32, DIMENSION(:), ALLOCATABLE :: ALLA_name
       !all species abridged
       !(index 0 for electrons)
       !S|specie  ALLA(0:nspec_alla)

     INTEGER, DIMENSION(:), ALLOCATABLE :: ALLA_type
       !ALLA specie types
       !S|specie  ALLA(0:nspec_alla)

     INTEGER, DIMENSION(:), ALLOCATABLE :: all_index
       !species index in original lists
       !ion species j in "all" corresponds to ion species:
       !all_index(j) in "s" if all_type(j) = ps_electron, ps_therm_ion, or
       !ps_impurity
       !all_index(j) in "snbi" if all_type(j) = ps_beam_ion
       !all_index(j) in "rfmin" if all_type(j) = ps_rf_minority
       !all_index(j) in "sfus" if all_type(j) = ps_fusion_ion
       !I all_index(0:nspec_all)

     CHARACTER*32, DIMENSION(:), ALLOCATABLE :: ALL_name
       !all species
       !index 0 for electrons
       !this list is the union of lists "s", "snbi", "rfmin", and "sfus"
       !S|specie  ALL(0:nspec_all)

     INTEGER, DIMENSION(:), ALLOCATABLE :: ALL_type
       !ALL specie types
       !S|specie  ALL(0:nspec_all)

     CHARACTER*80 :: CUR_Data_Info = " "
       !information on source of plasma current data
       !C*80   CUR_Data_Info

     CHARACTER*80 :: Global_label = " "
       !Run Label
       !imbedded blanks allowed; <= 80 characters
       !C*80   Global_label

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: m_ALL
       !ALL specie mass
       !S|specie  ALL(0:nspec_all)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: m_ALLA
       !ALLA specie mass
       !S|specie  ALLA(0:nspec_alla)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: m_SA
       !SA specie mass
       !S|thermal_specie  SA(0:nspec_tha)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: m_SIMPI
       !SIMPI specie mass
       !S|impurity_atoms SIMPI(nspec_impi)

     CHARACTER*80 :: ns_Data_Info = " "
       !information on source of Density data
       !C*80   ns_Data_Info

     CHARACTER*80 :: PLASMA_Code_Info = " "
       !Information: code managing PLASMA component
       !(advance of specie temperatures & densities etc)
       !C*80   PLASMA_Code_Info

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: qatom_ALL
       !ALL atomic number
       !S|specie  ALL(0:nspec_all)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: qatom_ALLA
       !ALLA atomic number
       !S|specie  ALLA(0:nspec_alla)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: qatom_SA
       !SA atomic number
       !S|thermal_specie  SA(0:nspec_tha)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: qatom_SIMPI
       !SIMPI atomic number
       !S|impurity_atoms SIMPI(nspec_impi)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: q_ALL
       !ALL specie charge
       !S|specie  ALL(0:nspec_all)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: q_ALLA
       !ALLA specie charge
       !S|specie  ALLA(0:nspec_alla)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: q_SA
       !SA specie charge
       !S|thermal_specie  SA(0:nspec_tha)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: q_SIMPI
       !SIMPI specie charge
       !S|impurity_atoms SIMPI(nspec_impi)

     INTEGER, DIMENSION(:), ALLOCATABLE :: rfmin_to_all
       !map rfmin index to "all" list
       !I  rfmin_to_all(nspec_rfmin)

     INTEGER, DIMENSION(:), ALLOCATABLE :: rfmin_to_alla
       !map rfmin index to "alla" list
       !I  rfmin_to_alla(nspec_rfmin)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: rho
       !rho grid (PLASMA)
       !G   rho(nrho)

     CHARACTER*32 :: RunID = " "
       !Run ID
       !one word, no imbedded blanks; <= 32 characters
       !N      RunID

     INTEGER, DIMENSION(:), ALLOCATABLE :: sa_index
       !species index in original lists
       !sa_index(j)=-1 indicates that element (j) of the "SA" list is
       !derived from a composite of ions in the "S" list (using Zeff
       !and quasineutrality equations).
       !otherwise sa_index(j) gives the index of the species in "S"
       !For example, if index 2 corresponds to Deuterium ions in "SA", then
       !sa_index(2) gives the index in "S" for Deuterium ions.
       !For non-impurities usually sa_index(j)=j but this could be altered
       !if He3+1 or He4+1 (less than fully stripped He ions) are present in
       !the model.
       !I sa_index(0:nspec_all)

     CHARACTER*32, DIMENSION(:), ALLOCATABLE :: SA_name
       !thermal species abridged
       !(index 0 for electrons)
       !S|thermal_specie  SA(0:nspec_tha)

     INTEGER, DIMENSION(:), ALLOCATABLE :: SA_type
       !SA specie types
       !S|thermal_specie  SA(0:nspec_tha)

     INTEGER, DIMENSION(:), ALLOCATABLE :: sfus_to_all
       !map sfus index to "all" list
       !I  sfus_to_all(nspec_fusion)

     INTEGER, DIMENSION(:), ALLOCATABLE :: sfus_to_alla
       !map sfus index to "alla" list
       !I  sfus_to_alla(nspec_fusion)

     CHARACTER*32, DIMENSION(:), ALLOCATABLE :: SIMPI_name
       !impurity ion species in simulation
       !S|impurity_atoms SIMPI(nspec_impi)

     INTEGER, DIMENSION(:), ALLOCATABLE :: simpi_to_s
       !map simpi index to "s" list
       !I  simpi_to_s(nspec_impi)

     INTEGER, DIMENSION(:), ALLOCATABLE :: SIMPI_type
       !SIMPI specie types
       !S|impurity_atoms SIMPI(nspec_impi)

     INTEGER, DIMENSION(:), ALLOCATABLE :: snbi_to_all
       !map snbi index to "all" list
       !I  snbi_to_all(nspec_beam)

     INTEGER, DIMENSION(:), ALLOCATABLE :: snbi_to_alla
       !map snbi index to "alla" list
       !I  snbi_to_alla(nspec_beam)

     INTEGER, DIMENSION(:), ALLOCATABLE :: s_to_sa
       !address in sa species list
       !if species s(j) is in list SA, s_to_sa(j) gives its address in SA.
       !if species s(j) is NOT in list SA, s_to_sa(j)=-1.
       !I s_to_sa(0:nspec_th)

     REAL(KIND=rspec) :: tfinal = 0.0_rspec
       !stop time of simulation (may be adjustable)
       !R  tfinal

     CHARACTER*80 :: TF_Data_Info = " "
       !information on source of toroidal field data
       !C*80   TF_Data_Info

     REAL(KIND=rspec) :: tinit = 0.0_rspec
       !start time of simulation
       !R  tinit

     CHARACTER*32, DIMENSION(:), ALLOCATABLE :: trcat
       !Application defined list of
       !transport categories (possible examples: NC for neoclassical,
       !TURB for turbulent, SAW for sawtooth induced, ...); used to
       !dimension profile data provided to quantify transport rates
       !according to underlying physics
       !L|TR_categories  trcat(ntrcat)

     CHARACTER*256, DIMENSION(:), ALLOCATABLE :: trmodels
       !short description or ID of transport models
       !C*256 trmodels(ntrcat)

     CHARACTER*80 :: Ts_Data_Info = " "
       !information on source of Temperature data
       !C*80   Ts_Data_Info

     CHARACTER*80 :: vpol_Data_Info = " "
       !information on source of poloidal velocity data
       !C*80   vpol_Data_Info

     CHARACTER*80 :: VSUR_Data_Info = " "
       !information on source of surface voltage data
       !C*80   VSUR_Data_Info

     CHARACTER*80 :: vtor_Data_Info = " "
       !information on source of toroidal velocity data
       !C*80   vtor_Data_Info

     INTEGER :: Z0max = 2
       !maximum Z of non-impurity species
       !(default is 2: Helium).  Ion species with Z <= Z0max
       !are considered "non-impurities" and are present in
       !SGAS, a list of recycling neutral gas species.
       !IS  Z0max = 2

     CHARACTER*80 :: ZEFF_Data_Info = " "
       !information on source of Zeff data
       !C*80   ZEFF_Data_Info

     INTEGER :: Zimp1 = 2
       !lower limit on Z of impurity in reduced species list SA;
       !by default the lowest available Z impurity is chosen.
       !After the SA list is defined, this value is reset to
       !match the lower Z impurity selected for the SA list.
       !IS  Zimp1 = 2

     INTEGER :: Zimp2 = 1000
       !upper limit on Z of impurity in SA species list;
       !by default the highest Z impurity available is chosen.
       !After the SA list is defined, this value is reset to
       !match the higher Z impurity selected for the SA list.
       !IS  Zimp2 = 1000

     !----------------------------
     ! Component: RAD

     ! ** RHO Grid Dimension **

     INTEGER :: nrho_mist = 0
       !grid dimension of rho_mist (RHO coordinate)
       !G  rho_mist(nrho_mist)

     ! ** RHO Grid Dimension **

     INTEGER :: nrho_rad = 0
       !grid dimension of rho_rad (RHO coordinate)
       !G  rho_rad(nrho_rad)

     CHARACTER*80 :: RAD_Code_Info = " "
       !Information: code implementing RAD component
       !C*80   RAD_Code_Info

     CHARACTER*80 :: RAD_Data_Info = " "
       !Information on source of radiated power data
       !C*80   RAD_Data_Info

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: rho_mist
       !rho grid (PLASMA) impurity-driven sources
       !G  rho_mist(nrho_mist)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: rho_rad
       !rho grid (RAD)
       !G  rho_rad(nrho_rad)

     !----------------------------
     ! Component: RIPPLE

     ! ** R Grid Dimension **

     INTEGER :: nr_rip = 0
       !grid dimension of R_ripple (R coordinate)
       !G  R_ripple(nR_rip)

     ! ** Z Grid Dimension **

     INTEGER :: nz_rip = 0
       !grid dimension of Z_ripple (Z coordinate)
       !G  Z_ripple(nZ_rip)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: R_ripple
       !R grid for TF ripple field(s)
       !G  R_ripple(nR_rip)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: Z_ripple
       !Z grid for TF ripple field(s)
       !G  Z_ripple(nZ_rip)

     !----------------------------
     ! Component: RUNAWAY

     ! ** RHO Grid Dimension **

     INTEGER :: nrho_rw = 0
       !grid dimension of rho_rw (RHO coordinate)
       !G  rho_rw(nrho_rw)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: rho_rw
       !rho grid -- RUNAWAY electrons
       !G  rho_rw(nrho_rw)

     CHARACTER*80 :: RUNAWAY_Code_Info = " "
       !Information: code implementing RUNAWAY component
       !C*80   RUNAWAY_Code_Info

     !===============================================
     ! Section: STATE_DATA

     !----------------------------
     ! Component: ANOM

     INTEGER :: nmdifb = 0
       !type of fast ion diffusivity
       !=4: 2D fast ion diffusivity from ufiles
       !=6: fast ion diffusivity from dep code
       !I   nmdifb = 0

     REAL(KIND=rspec) :: nmodel_bdy = 0.0_rspec
       !model density, boundary value
       !R|units=m^-3   nmodel_bdy

     REAL(KIND=rspec) :: tmodel_bdy = 0.0_rspec
       !model temperature, boundary value
       !R|units=keV    tmodel_bdy

     !----------------------------
     ! Component: EC

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: power_ec
       !power on each ECRF source
       !R|units=W  power_ec(necrf_src)

     !----------------------------
     ! Component: EQ

     REAL(KIND=rspec) :: B_axis = 0.0_rspec
       !|B| at magnetic axis
       !R  B_axis

     REAL(KIND=rspec) :: B_axis_vac = 0.0_rspec
       !vacuum B field at axis
       !R  B_axis_vac

     REAL(KIND=rspec) :: B_max_lcfs = 0.0_rspec
       !|B|_max of last closed flux surface
       !R  B_max_lcfs

     REAL(KIND=rspec) :: B_min_lcfs = 0.0_rspec
       !|B|_min of last closed flux surface
       !R  B_min_lcfs

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: coil_apt
       !SIGNED circuit current
       !amps/turn within each coil attached to the indicated circult:
       !SIGN: + means current flows counter-clockwise, viewed from above, for
       !a coil (j) with Nturns(j) > 0; direction opposite if Nturns(j) < 0
       !- means the reverse.
       !The SIGNED current in coil (j) is Nturns(j)*coil_apt(icircuit_coil(j));
       !a positive current flows counter-clockwise viewed from above.
       !Any element of Nturns(...) and any element of coil_apt(...) can be
       !either positive or negative.
       !R|units=amps/turn coil_apt(ncircuits)

     CHARACTER*256 :: eqdsk_file = " "
       !EFIT G-eqdsk file: psi(R,Z), g(psi), etc.
       !F  eqdsk_file

     REAL(KIND=rspec) :: Psi_to_machine_axis = 0.0_rspec
       !delta(Psi) from magnetic axis to machine axis
       !subtract this from Psi(R,Z) to get a Psi value
       !that approaches zero as R-> zero: Psi ~ R*A_phi
       !(as in the EFIT free boundary representation).
       !Note: prescribed boundary code runs (e.g.
       !traditional TRANSP runs) cannot know this
       !number; so Plasma States created from such run
       !data will leave this at zero.  Plasma States
       !using free boundary MHD equilibrium information
       !will always have a non-zero value here.
       !R|units=Wb/rad   Psi_to_machine_axis

     REAL(KIND=rspec) :: R_axis = 0.0_rspec
       !R of magnetic axis
       !R  R_axis

     REAL(KIND=rspec) :: R_max_lcfs = 0.0_rspec
       !R_max of last closed flux surface
       !R  R_max_lcfs

     REAL(KIND=rspec) :: R_min_lcfs = 0.0_rspec
       !R_min of last closed flux surface
       !R  R_min_lcfs

     REAL(KIND=rspec) :: Z_axis = 0.0_rspec
       !Z of magnetic axis
       !R  Z_axis

     REAL(KIND=rspec) :: Z_max_lcfs = 0.0_rspec
       !Z_max of last closed flux surface
       !R  Z_max_lcfs

     REAL(KIND=rspec) :: Z_min_lcfs = 0.0_rspec
       !Z_min of last closed flux surface
       !R  Z_min_lcfs

     !----------------------------
     ! Component: FUS

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: nmini_bdy
       !RF minority ion densities at/beyond boundary
       !R|units=m^-3  nmini_bdy(nspec_rfmin)

     !----------------------------
     ! Component: GAS

     REAL(KIND=rspec) :: dn0out = 0.0_rspec
       !Hydrogenic neutral density in scrape off region
       !This is a simplified 0d specification of neutral density
       !beyond the plasma boundary, that can be used to deplete
       !fast ion orbits that go beyond the boundary via charge
       !exchange, in some models.
       !R|units=m^-3  dn0out

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: e0_av
       !average energy of neutral sources, "(3/2)*T0"
       ![in reference frame of (vphi0_av)]; some models
       !impose a minimum value such as 0.005 KeV.  The
       !value can effect penetration of neutrals and
       !depth of edge-driven charge exchange loss, but
       !(depending on plasma parameters) the effect
       !is often weak.
       !R|units=KeV   e0_av(ngsc0)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: sc0
       !edge neutral sources (atoms/sec)
       !these numbers normalize numerous GAS profiles
       !R|units=#/sec  sc0(ngsc0)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: vphi0_av
       !average toroidal velocity of neutral source
       !(some models may assume this is zero).
       !R|units=m/sec vphi0_av(ngsc0)

     !----------------------------
     ! Component: IC

     CHARACTER*256, DIMENSION(:), ALLOCATABLE :: dist_fun
       !distribution function filenames
       !F  dist_fun(0:nspec_alla)

     INTEGER, DIMENSION(:), ALLOCATABLE :: isThermal
       !=1 if minority specie is thermalized
       !=0: never set; =2: non-thermal.
       !I  isThermal(nspec_rfmin)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: nfusi_bdy
       !fusion ion densities at/beyond boundary
       !R|units=m^-3  nfusi_bdy(nspec_fusion)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: picrf_abs
       !RF power absorbed inside plasma
       !R|units=W picrf_abs(nicrf_src)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: picrf_ext
       !RF power deposited outside plasma
       !R|units=W picrf_ext(nicrf_src)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: power_ic
       !power on each ICRF source
       !R|units=W  power_ic(nicrf_src)

     CHARACTER*256, DIMENSION(:), ALLOCATABLE :: ql_operator
       !quasilinear operator filenames
       !F  ql_operator(0:nspec_alla)

     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: wt_nphi_abs
       !absorbed spectrum n_phi weight
       !power_ic(iant)*wt_nphi_abs(ind,iant)
       !gives power in toroidal mode
       !nphi(ind,iant)
       !"ind" covers range 1:num_nphi(iant).
       !see vacuum spectrum wt_nphi(...)
       !R|units=- wt_nphi_abs(num_nphi(),nicrf_src)

     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: wt_nphi_ext
       !fraction of power deposited outside
       !plasma vs. nphi, antenna #.
       !R|units=- wt_nphi_ext(num_nphi(),nicrf_src)

     !----------------------------
     ! Component: LH

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: power_lh
       !power on each LHRF source
       !R|units=W  power_lh(nlhrf_src)

     !----------------------------
     ! Component: LMHD

     INTEGER, DIMENSION(:), ALLOCATABLE :: Balloon_stable
       !0: stable everywhere; =1: unstable somewhere
       !I   Balloon_stable(nballoon)

     INTEGER, DIMENSION(:), ALLOCATABLE :: Balloon_status
       !completion status: Ballooning codes
       !** see also: balstab profile, below **
       !I   Balloon_status(nballoon)

     INTEGER, DIMENSION(:,:), ALLOCATABLE :: DeltaW_stable
       !0: stable; 1: unstable;
       !element (i,j) indicates if toroidal mode number
       !Tor_mode_No(i) is stable or unstable according to
       !the code DeltaW_code(j)
       !I   DeltaW_stable(mmodes,ndelta_W)

     INTEGER, DIMENSION(:), ALLOCATABLE :: DeltaW_status
       !completion status: Delta(W) codes
       !I   DeltaW_status(ndelta_W)

     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: gamma_lmhd
       !ideal growth rate
       !from a delta-W linear MHD code, normalized to the
       !Alfven time Rq/V_a where:
       !R -- major radius of magnetic axis
       !V_a -- alfven speed at magnetic axis
       !q = qmin  (minimum q anywhere in equilibrium)
       !R|units=-  gamma_lmhd(mmodes,ndelta_W)

     INTEGER :: LMHD_status = ps_unInit
       !0: OK; =1: at least one code error occurred.
       !I   LMHD_status

     INTEGER, DIMENSION(:), ALLOCATABLE :: Mercier_stable
       !0: stable everywhere; =1: unstable somewhere
       !I   Mercier_stable(nballoon)

     INTEGER :: MHD_eq_status = ps_unInit
       !0: OK; =1: MHD equilibrium refinement failed
       !if this is non-zero, the entire LMHD calculation is abandoned!!
       !I   MHD_eq_status

     INTEGER, DIMENSION(:,:), ALLOCATABLE :: Newcomb_stable
       !0: stable; 1: unstable;
       !element (i,j) indicates if toroidal mode number
       !Tor_mode_No(i) is stable or unstable according to
       !the code Newcomb_code(j)
       !I   Newcomb_stable(mmodes,nnewcomb)

     INTEGER, DIMENSION(:), ALLOCATABLE :: Newcomb_status
       !completion status: Newcomb codes
       !I   Newcomb_status(nnewcomb)

     INTEGER, DIMENSION(:), ALLOCATABLE :: Tornum_balcrit
       !critical toroidal mode number for ballooning
       !unstable cases (-1 if could not be found).
       !I   Tornum_balcrit(nballoon)

     !----------------------------
     ! Component: NBI

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: frac_full
       !fraction of beam current at full voltage
       !R|units=-  frac_full(nbeam)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: frac_half
       !fraction of beam current at half voltage
       !1-frac_full(ib)-frac_half(ib) = fraction at (1/3) voltage
       !R|units=-  frac_half(nbeam)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: kvolt_nbi
       !energy of each beam source **keV**
       !R|units=keV kvolt_nbi(nbeam)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: nbeami_bdy
       !beam ion densities at/beyond boundary
       !R|units=m^-3  nbeami_bdy(nspec_beam)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: power_nbi
       !power on each beam source
       !R|units=W  power_nbi(nbeam)

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: power_nbi_trace
       !power injected as trace element (if any)
       !total power on beam ib is power_nbi(ib) + power_nbi_trace(ib)
       !R|units=W  power_nbi_trace(nbeam)

     !----------------------------
     ! Component: PEL

     !----------------------------
     ! Component: PLASMA

     REAL(KIND=rspec) :: eldot = 0.0_rspec
       ![d(Philim)/dt]/[2*Philim]
       !R|units=1/sec  eldot

     INTEGER :: lock_machine_descr = 0
       !Machine_Description section lock
       !I  lock_machine_descr = 0

     INTEGER :: lock_shot_config = 0
       !Shot_Configuration section lock
       !I  lock_shot_config = 0

     INTEGER :: lock_sim_init = 0
       !Simulation_Init section lock
       !I  lock_sim_init = 0

     REAL(KIND=rspec) :: nebar = 0.0_rspec
       !line-averaged electron density
       !R|units=#/m^2 nebar

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: ns_bdy
       !specie densities at/beyond boundary
       !R|units=m^-3 ns_bdy(0:nspec_th)

     INTEGER, DIMENSION(:), ALLOCATABLE :: ns_is_input
       !specie density measurement flag
       !I ns_is_input(0:nspec_th)

     REAL(KIND=rspec) :: omegat_bdy = 0.0_rspec
       !toroidal angular velocity at/beyond boundary
       !R|units=rad/sec  omegat_bdy

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: rho_bdy_ns
       !locations beyond which densities are known
       !R|units=- rho_bdy_ns(0:nspec_th)

     REAL(KIND=rspec) :: rho_bdy_omegat = 0.0_rspec
       !location beyond which angular velocity is known
       !R rho_bdy_omegat

     REAL(KIND=rspec) :: rho_bdy_Te = 0.0_rspec
       !location beyond which Te is known
       !R rho_bdy_Te

     REAL(KIND=rspec) :: rho_bdy_Ti = 0.0_rspec
       !location beyond which Ti is known
       !R rho_bdy_Ti

     REAL(KIND=rspec) :: t0 = 0.0_rspec
       !time at beginning of IPS macro timestep
       !R  t0

     REAL(KIND=rspec) :: t1 = 0.0_rspec
       !time at end of IPS macro timestep
       !R  t1

     REAL(KIND=rspec) :: Te_bdy = 0.0_rspec
       !Electron temperature at/beyond boundary
       !R Te_bdy

     REAL(KIND=rspec) :: Ti_bdy = 0.0_rspec
       !Ion temperature at/beyond boundary
       !R Ti_bdy

     INTEGER, DIMENSION(:), ALLOCATABLE :: Ts_is_input
       !specie temperature measurement flag
       !I Ts_is_input(0:nspec_th)

     INTEGER, DIMENSION(:), ALLOCATABLE :: vpol_is_input
       !specie outer midplane poloidal velocit flag
       !I vpol_is_input(0:nspec_th)

     REAL(KIND=rspec) :: vsur = 0.0_rspec
       !toroidal voltage at surface
       !R  vsur

     INTEGER, DIMENSION(:), ALLOCATABLE :: vtor_is_input
       !specie outer midplane toroidal velocit flag
       !I vtor_is_input(0:nspec_th)

     !----------------------------
     ! Component: RAD

     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: xs
       !impurity source magnitude (atoms/sec)
       !these numbers normalize "sii_xs" source profiles
       !R|units=#/sec    xs(nxs)

     !----------------------------
     ! Component: RIPPLE

     !----------------------------
     ! Component: RUNAWAY

     !===============================================
     ! Section: STATE_PROFILES

     !----------------------------
     ! Component: ANOM

     INTEGER :: id_anom_evar = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: anom_evar
       !anomalous transport energy variation
       !=1 to use transport profiles as given; O(1) expected.
       !if undefined, use transport profiles as given.
       !R|pclin|units=- anom_evar(nefi_anom)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_bidiff_bpass_co
     REAL(KIND=rspec), DIMENSION(:,:,:), ALLOCATABLE :: bidiff_bpass_co
       !beam ion diffusivity: co barely passing orbits
       !R|units=m^2/sec|pclin  bidiff_bpass_co(nefi_anom2,nrho_anom2,nspec_beam)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_bidiff_bpass_ctr
     REAL(KIND=rspec), DIMENSION(:,:,:), ALLOCATABLE :: bidiff_bpass_ctr
       !beam ion diffusivity: ctr barely passing orbits
       !R|units=m^2/sec|pclin  bidiff_bpass_ctr(nefi_anom2,nrho_anom2,nspec_beam)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_bidiff_btrap
     REAL(KIND=rspec), DIMENSION(:,:,:), ALLOCATABLE :: bidiff_btrap
       !beam ion diffusivity: barely trapped orbits
       !R|units=m^2/sec|pclin  bidiff_btrap(nefi_anom2,nrho_anom2,nspec_beam)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_bidiff_dpass_co
     REAL(KIND=rspec), DIMENSION(:,:,:), ALLOCATABLE :: bidiff_dpass_co
       !beam ion diffusivity: co passing |vpll/v| -> 1
       !R|units=m^2/sec|pclin  bidiff_dpass_co(nefi_anom2,nrho_anom2,nspec_beam)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_bidiff_dpass_ctr
     REAL(KIND=rspec), DIMENSION(:,:,:), ALLOCATABLE :: bidiff_dpass_ctr
       !beam ion diffusivity: ctr passing |vpll/v| -> 1
       !R|units=m^2/sec|pclin  bidiff_dpass_ctr(nefi_anom2,nrho_anom2,nspec_beam)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_bidiff_dtrap
     REAL(KIND=rspec), DIMENSION(:,:,:), ALLOCATABLE :: bidiff_dtrap
       !beam ion diffusivity: deeply trapped orbits
       !R|units=m^2/sec|pclin  bidiff_dtrap(nefi_anom2,nrho_anom2,nspec_beam)

     INTEGER :: id_chie_anom = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: chie_anom
       !Te-equation, diffusivity term
       !R|units=m^2/sec|pclin  chie_anom(nrho_anomth)

     INTEGER :: id_chie_drbm = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: chie_drbm
       !Te-equation, diffusivity term
       !R|units=m^2/sec|pclin  chie_drbm(nrho_anomth)

     INTEGER :: id_chie_etg = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: chie_etg
       !Te-equation, diffusivity term ETG model
       !R|units=m^2/sec|pclin chie_etg(nrho_anomth)

     INTEGER :: id_chie_glf = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: chie_glf
       !Te-equation, diffusivity from GLF23 model
       !R|units=m^2/s|pclin chie_glf(nrho_anomth)

     INTEGER :: id_chie_gtcneo = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: chie_gtcneo
       !Te-equation, neoclassical diffusivity from GTC_NEO model
       !R|units=m^2/s|pclin chie_gtcneo(nrho_anomth)

     INTEGER :: id_chie_mmm71 = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: chie_mmm71
       !Te-equation, diffusivity term
       !R|units=m^2/sec|pclin  chie_mmm71(nrho_anomth)

     INTEGER :: id_chie_mtm = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: chie_mtm
       !Te-equation, thermal diffusivity term MTM model
       !R|units=m^2/sec|pclin chie_mtm(nrho_anomth)

     INTEGER :: id_chie_nclass = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: chie_nclass
       !Te-equation, neoclassical diffusivity from NCLASS model
       !R|units=m^2/s|pclin chie_nclass(nrho_anomth)

     INTEGER :: id_chie_neo = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: chie_neo
       !Te-equation, neoclassical diffusivity from NEO model
       !R|units=m^2/s|pclin chie_neo(nrho_anomth)

     INTEGER :: id_chie_ntm = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: chie_ntm
       !Te-equation, neoclassical diffusivity from NTM model
       !R|units=m^2/s|pclin chie_ntm(nrho_anomth)

     INTEGER :: id_chie_paleo = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: chie_paleo
       !Te-equation, diffusivity term PALEO model
       !R|units=m^2/sec|pclin chie_paleo(nrho_anomth)

     INTEGER :: id_chie_tglf = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: chie_tglf
       !Te-equation, diffusivity from TGLF model
       !R|units=m^2/s|pclin chie_tglf(nrho_anomth)

     INTEGER :: id_chie_w19 = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: chie_w19
       !Te-equation, diffusivity term
       !R|units=m^2/sec|pclin  chie_w19(nrho_anomth)

     INTEGER :: id_chii_anom = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: chii_anom
       !Ti-equation, diffusivity term
       !R|units=m^2/sec|pclin  chii_anom(nrho_anomth)

     INTEGER :: id_chii_drbm = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: chii_drbm
       !Ti-equation, diffusivity term
       !R|units=m^2/sec|pclin  chii_drbm(nrho_anomth)

     INTEGER :: id_chii_glf = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: chii_glf
       !Ti-equation, diffusivity from GLF23 model
       !R|units=m^2/s|pclin chii_glf(nrho_anomth)

     INTEGER :: id_chii_gtcneo = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: chii_gtcneo
       !Ti-equation, neoclassical diffusivity from GTC_NEO model
       !R|units=m^2/s|pclin chii_gtcneo(nrho_anomth)

     INTEGER :: id_chii_mmm71 = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: chii_mmm71
       !Ti-equation, diffusivity term
       !R|units=m^2/sec|pclin  chii_mmm71(nrho_anomth)

     INTEGER :: id_chii_nclass = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: chii_nclass
       !Ti-equation, neoclassical diffusivity from NCALSS model
       !R|units=m^2/s|pclin chii_nclass(nrho_anomth)

     INTEGER :: id_chii_neo = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: chii_neo
       !Ti-equation, neoclassical diffusivity from NEO model
       !R|units=m^2/s|pclin chii_neo(nrho_anomth)

     INTEGER :: id_chii_ntm = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: chii_ntm
       !Ti-equation, neoclassical diffusivity from NTM model
       !R|units=m^2/s|pclin chii_ntm(nrho_anomth)

     INTEGER :: id_chii_tglf = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: chii_tglf
       !Ti-equation, diffusivity from TGLF model
       !R|units=m^2/s|pclin chii_tglf(nrho_anomth)

     INTEGER :: id_chii_w19 = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: chii_w19
       !Ti-equation, diffusivity term
       !R|units=m^2/sec|pclin  chii_w19(nrho_anomth)

     INTEGER :: id_chiphi_anom = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: chiphi_anom
       !momentum-equation, diffusivity term
       !R|units=m^2/sec|pclin  chiphi_anom(nrho_anomth)

     INTEGER :: id_chiphi_drbm = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: chiphi_drbm
       !momentum-equation, diffusivity term
       !R|units=m^2/sec|pclin  chiphi_drbm(nrho_anomth)

     INTEGER :: id_chiphi_glf = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: chiphi_glf
       !momentum-equation, diffusivity from GLF23 model
       !R|units=m^2/s|pclin chiphi_glf(nrho_anomth)

     INTEGER :: id_chiphi_gtcneo = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: chiphi_gtcneo
       !momentum-equation, neoclassical diffusivity from GTC_NEO model
       !R|units=m^2/s|pclin chiphi_gtcneo(nrho_anomth)

     INTEGER :: id_chiphi_mmm71 = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: chiphi_mmm71
       !momentum-equation, diffusivity term, toroidal
       !R|units=m^2/sec|pclin  chiphi_mmm71(nrho_anomth)

     INTEGER :: id_chiphi_neo = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: chiphi_neo
       !momentum-equation, neoclassical diffusivity from NEO model
       !R|units=m^2/s|pclin chiphi_neo(nrho_anomth)

     INTEGER :: id_chiphi_tglf = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: chiphi_tglf
       !momentum-equation, diffusivity from TGLF model
       !R|units=m^2/s|pclin chiphi_tglf(nrho_anomth)

     INTEGER :: id_chiphi_w19 = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: chiphi_w19
       !momentum-equation, diffusivity term
       !R|units=m^2/sec|pclin  chiphi_w19(nrho_anomth)

     INTEGER :: id_chitheta_mmm71 = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: chitheta_mmm71
       !momentum-equation, diffusivity term, poloidal
       !R|units=m^2/sec|pclin  chitheta_mmm71(nrho_anomth)

     INTEGER :: id_db_mtm = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: db_mtm
       !dB/B from MTM model
       !R|units=-|pclin db_mtm(nrho_anomth)

     INTEGER :: id_difb_fusi = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: difb_fusi
       !fusion ion anomalous diffusivity
       !R|pclin  difb_fusi(nrho_anom)

     INTEGER :: id_difb_nbi = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: difb_nbi
       !beam ion anomalous diffusivity
       !R|pclin  difb_nbi(nrho_anom)

     INTEGER :: id_difb_rfmi = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: difb_rfmi
       !RF minority ion anomalous diffusivity
       !R|pclin  difb_rfmi(nrho_anom)

     INTEGER :: id_difne_nclass = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: difne_nclass
       !electron-density-equations, neoclassical diffusivity from NCLASS model
       !R|units=m^2/s|pclin difne_nclass(nrho_anomth)

     INTEGER :: id_difnh_nclass = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: difnh_nclass
       !main-hydrogenic-density-equations, neoclassical diffusivity from NCLASS model
       !R|units=m^2/s|pclin difnh_nclass(nrho_anomth)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_difns_anom
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: difns_anom
       !density-equations, diffusivity term
       !R|units=m^2/sec|pclin  difns_anom(nrho_anomth,0:nspec_th)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_difns_drbm
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: difns_drbm
       !density-equations, diffusivity term
       !R|units=m^2/sec|pclin  difns_drbm(nrho_anomth,0:nspec_th)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_difns_glf
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: difns_glf
       !density-equations, diffusivity from GLF23 model
       !R|units=m^2/s|pclin difns_glf(nrho_anomth,0:nspec_th)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_difns_gtcneo
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: difns_gtcneo
       !density-equations, neoclassical diffusivity from GTC_NEO model
       !R|units=m^2/s|pclin difns_gtcneo(nrho_anomth,0:nspec_th)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_difns_mmm71
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: difns_mmm71
       !density-equations, diffusivity term
       !R|units=m^2/sec|pclin  difns_mmm71(nrho_anomth,0:nspec_th)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_difns_nclass
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: difns_nclass
       !density-equations, neoclassical diffusivity from NCLASS model
       !R|units=m^2/s|pclin difns_nclass(nrho_anomth,0:nspec_th)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_difns_neo
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: difns_neo
       !density-equations, neoclassical diffusivity from NEO model
       !R|units=m^2/s|pclin difns_neo(nrho_anomth,0:nspec_th)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_difns_tglf
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: difns_tglf
       !density-equations, diffusivity from TGLF model
       !R|units=m^2/s|pclin difns_tglf(nrho_anomth,0:nspec_th)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_difns_w19
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: difns_w19
       !density-equations, diffusivity term
       !R|units=m^2/sec|pclin  difns_w19(nrho_anomth,0:nspec_th)

     INTEGER :: id_difnx_nclass = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: difnx_nclass
       !main-impurity-density-equations, neoclassical diffusivity from NCLASS model
       !R|units=m^2/s|pclin difnx_nclass(nrho_anomth)

     INTEGER :: id_difnz_mmm71 = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: difnz_mmm71
       !impurity ion diffusivity term
       !R|units=m^2/sec|pclin  difnz_mmm71(nrho_anomth)

     INTEGER :: id_dQedGrdte_tglf = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: dQedGrdte_tglf
       !Te flux gradient term from TGLF model
       !R|units=1/(m*s)|pclin dQedGrdte_tglf(nrho_anomth)

     INTEGER :: id_dQedGrdti_tglf = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: dQedGrdti_tglf
       !Te flux gradient term from TGLF model
       !R|units=1/(m*s)|pclin dQedGrdti_tglf(nrho_anomth)

     INTEGER :: id_dQidGrdte_tglf = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: dQidGrdte_tglf
       !Ti flux gradient term from TGLF model
       !R|units=1/(m*s)|pclin dQidGrdte_tglf(nrho_anomth)

     INTEGER :: id_dQidGrdti_tglf = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: dQidGrdti_tglf
       !Ti flux gradient term from TGLF model
       !R|units=1/(m*s)|pclin dQidGrdti_tglf(nrho_anomth)

     INTEGER :: id_ee_mobility_factor = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: ee_mobility_factor
       !chi_e/chi_i
       !ratio of electron heat diffusivity to ion heat diffusivity, a model input
       !(does not effect relative non-diffusive heat pinch velocities).
       !R|units=-|Hermite  ee_mobility_factor(nrho_anomth)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_fidiff_bpass_co
     REAL(KIND=rspec), DIMENSION(:,:,:), ALLOCATABLE :: fidiff_bpass_co
       !fusion ion diffusivity: co barely passing orbits
       !R|units=m^2/sec|pclin  fidiff_bpass_co(nefi_anom2,nrho_anom2,nspec_fusion)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_fidiff_bpass_ctr
     REAL(KIND=rspec), DIMENSION(:,:,:), ALLOCATABLE :: fidiff_bpass_ctr
       !fusion ion diffusivity: ctr barely passing orbits
       !R|units=m^2/sec|pclin  fidiff_bpass_ctr(nefi_anom2,nrho_anom2,nspec_fusion)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_fidiff_btrap
     REAL(KIND=rspec), DIMENSION(:,:,:), ALLOCATABLE :: fidiff_btrap
       !fusion ion diffusivity: barely trapped orbits
       !R|units=m^2/sec|pclin  fidiff_btrap(nefi_anom2,nrho_anom2,nspec_fusion)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_fidiff_dpass_co
     REAL(KIND=rspec), DIMENSION(:,:,:), ALLOCATABLE :: fidiff_dpass_co
       !fusion ion diffusivity: co passing |vpll/v| -> 1
       !R|units=m^2/sec|pclin  fidiff_dpass_co(nefi_anom2,nrho_anom2,nspec_fusion)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_fidiff_dpass_ctr
     REAL(KIND=rspec), DIMENSION(:,:,:), ALLOCATABLE :: fidiff_dpass_ctr
       !fusion ion diffusivity: ctr passing |vpll/v| -> 1
       !R|units=m^2/sec|pclin  fidiff_dpass_ctr(nefi_anom2,nrho_anom2,nspec_fusion)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_fidiff_dtrap
     REAL(KIND=rspec), DIMENSION(:,:,:), ALLOCATABLE :: fidiff_dtrap
       !fusion ion diffusivity: deeply trapped orbits
       !R|units=m^2/sec|pclin  fidiff_dtrap(nefi_anom2,nrho_anom2,nspec_fusion)

     INTEGER :: id_freq_drbm = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: freq_drbm
       !frequency from DRBM model
       !R|units=GB|pclin freq_drbm(nrho_anomth)

     INTEGER :: id_freq_glf = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: freq_glf
       !frequency from GLF23 model
       !R|units=GB|pclin freq_glf(nrho_anomth)

     INTEGER :: id_freq_max_tglf = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: freq_max_tglf
       !frequency corresponding maximum growthrate from TGLF model
       !R|units=GB|pclin freq_max_tglf(nrho_anomth)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_freq_mmm71
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: freq_mmm71
       !frequency from mmm71 model
       !R|units=GB|pclin freq_mmm71(nrho_anomth,nky_mmm)

     INTEGER :: id_freq_mtm = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: freq_mtm
       !frequency from MTM model
       !R|units=rad/sec|pclin freq_mtm(nrho_anomth)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_freq_tglf
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: freq_tglf
       !frequency from TGLF model
       !R|units=GB|pclin freq_tglf(nrho_anomth,nky_anomth)

     INTEGER :: id_growthrate_drbm = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: growthrate_drbm
       !growthrate from DRBM model
       !R|units=GB|pclin growthrate_drbm(nrho_anomth)

     INTEGER :: id_growthrate_glf = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: growthrate_glf
       !growthrate from GLF23 model
       !R|units=GB|pclin growthrate_glf(nrho_anomth)

     INTEGER :: id_growthrate_max_tglf = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: growthrate_max_tglf
       !maximum growthrate from TGLF model
       !R|units=GB|pclin growthrate_max_tglf(nrho_anomth)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_growthrate_mmm71
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: growthrate_mmm71
       !growthrate from mmm71 model
       !R|units=GB|pclin growthrate_mmm71(nrho_anomth,nky_mmm)

     INTEGER :: id_growthrate_mtm = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: growthrate_mtm
       !growthrate from MTM model
       !R|units=1/sec|pclin growthrate_mtm(nrho_anomth)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_growthrate_tglf
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: growthrate_tglf
       !growthrate from TGLF model
       !R|units=GB|pclin growthrate_tglf(nrho_anomth,nky_anomth)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_growthrate_vpar
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: growthrate_vpar
       !growthrate from parallel velocity shear
       !R|units=GB|pclin growthrate_vpar(nrho_anomth,0:nspec_th)

     INTEGER :: id_kyrhos_mtm = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: kyrhos_mtm
       !ky*rhos at max growth rate for MTM model
       !R|units=-|pclin kyrhos_mtm(nrho_anomth)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_kyspectrum_tglf
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: kyspectrum_tglf
       !ky-spectrum from TGLF model
       !R|units=-|pclin kyspectrum_tglf(nrho_anomth,nky_anomth)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_neflux_ky_tglf
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: neflux_ky_tglf
       !electron density flux spectrum
       !R|units=GB|pclin neflux_ky_tglf(nrho_anomth,nky_anomth)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_ne_ky_tglf
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: ne_ky_tglf
       !electron density fluctuation spectrum
       !R|units=GB|pclin ne_ky_tglf(nrho_anomth,nky_anomth)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_niflux_ky_tglf
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: niflux_ky_tglf
       !ion density flux spectrum
       !R|units=GB|pclin niflux_ky_tglf(nrho_anomth,nky_anomth)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_ni_ky_tglf
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: ni_ky_tglf
       !ion density fluctuation spectrum
       !R|units=GB|pclin ni_ky_tglf(nrho_anomth,nky_anomth)

     INTEGER :: id_nmodel = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: nmodel
       !target density profile
       !from experiment or "profile consistency" model
       !R|units=m^-3|step  nmodel(~nrho_anomth)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_nzflux_ky_tglf
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: nzflux_ky_tglf
       !impurity density flux spectrum
       !R|units=GB|pclin nzflux_ky_tglf(nrho_anomth,nky_anomth)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_nz_ky_tglf
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: nz_ky_tglf
       !impurity density fluctuation spectrum
       !R|units=GB|pclin nz_ky_tglf(nrho_anomth,nky_anomth)

     INTEGER :: id_omega_exb = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: omega_exb
       !ExB flow shear rate
       !R|units=GB|pclin omega_exb(nrho_anomth)

     INTEGER :: id_pe_anom = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: pe_anom
       !anomalous electron heating
       !R|units=W|step*dV  pe_anom(~nrho_anomth)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_phiflux_ky_tglf
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: phiflux_ky_tglf
       !momentum fluctuation spectrum
       !R|units=GB|pclin phiflux_ky_tglf(nrho_anomth,nky_anomth)

     INTEGER :: id_pi_anom = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: pi_anom
       !anomalous ion heating
       !R|units=W|step*dV  pi_anom(~nrho_anomth)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_pot_ky_tglf
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: pot_ky_tglf
       !potential fluctuation spectrum
       !R|units=GB|pclin pot_ky_tglf(nrho_anomth,nky_anomth)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_sc_anom
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: sc_anom
       !anomalous sources
       !R|units=#/sec|step*dV sc_anom(~nrho_anomth,0:nspec_th)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_teflux_ky_tglf
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: teflux_ky_tglf
       !electron density flux spectrum
       !R|units=GB|pclin teflux_ky_tglf(nrho_anomth,nky_anomth)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_te_ky_tglf
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: te_ky_tglf
       !electron density fluctuation spectrum
       !R|units=GB|pclin te_ky_tglf(nrho_anomth,nky_anomth)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_tiflux_ky_tglf
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: tiflux_ky_tglf
       !ion density flux spectrum
       !R|units=GB|pclin tiflux_ky_tglf(nrho_anomth,nky_anomth)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_ti_ky_tglf
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: ti_ky_tglf
       !ion density fluctuation spectrum
       !R|units=GB|pclin ti_ky_tglf(nrho_anomth,nky_anomth)

     INTEGER :: id_tmodel = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: tmodel
       !target temperature profile
       !from experiment or "profile consistency" model
       !R|units=keV|step*nmodel   tmodel(~nrho_anomth)

     INTEGER :: id_tq_anom = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: tq_anom
       !anomalous torque
       !R|units=Nt*m|step*dV  tq_anom(~nrho_anomth)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_tzflux_ky_tglf
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: tzflux_ky_tglf
       !impurity density flux spectrum
       !R|units=GB|pclin tzflux_ky_tglf(nrho_anomth,nky_anomth)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_tz_ky_tglf
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: tz_ky_tglf
       !impurity density fluctuation spectrum
       !R|units=GB|pclin tz_ky_tglf(nrho_anomth,nky_anomth)

     INTEGER :: id_velb_fusi = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: velb_fusi
       !fusion ion anom. radial velocity
       !R|pclin  velb_fusi(nrho_anom)

     INTEGER :: id_velb_nbi = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: velb_nbi
       !beam ion anom. radial velocity
       !R|pclin  velb_nbi(nrho_anom)

     INTEGER :: id_velb_rfmi = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: velb_rfmi
       !RF minority ion anom. radial velocity
       !R|pclin  velb_rfmi(nrho_anom)

     INTEGER :: id_velne_nclass = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: velne_nclass
       !electron-density-equations, advective velocity term from NCLASS model
       !R|units=m/sec|pclin velne_nclass(nrho_anomth)

     INTEGER :: id_velnh_nclass = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: velnh_nclass
       !main-hydrogenic-density-equations, advective velocity term from NCLASS model
       !R|units=m/sec|pclin velnh_nclass(nrho_anomth)

     INTEGER :: id_velni_drbm = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: velni_drbm
       !ion convective velocity
       !R|units=m/s|pclin velni_drbm(nrho_anomth)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_velns_anom
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: velns_anom
       !density-equations, advective velocity term
       !R|units=m/sec|pclin  velns_anom(nrho_anomth,0:nspec_th)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_velns_glf
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: velns_glf
       !density-equations, advective velocity term from GLF23 model
       !R|units=m/sec|pclin  velns_glf(nrho_anomth,0:nspec_th)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_velns_gtcneo
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: velns_gtcneo
       !density-equations, advective velocity term from GTC_NEO model
       !R|units=m/sec|pclin  velns_gtcneo(nrho_anomth,0:nspec_th)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_velns_mmm71
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: velns_mmm71
       !density-equations, advective velocity term from MMM71 model
       !R|units=m/sec|pclin  velns_mmm71(nrho_anomth,0:nspec_th)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_velns_nclass
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: velns_nclass
       !density-equations, advective velocity term from NCLASS model
       !R|units=m/sec|pclin velns_nclass(nrho_anomth,0:nspec_th)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_velns_neo
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: velns_neo
       !density-equations, advective velocity term from NEO model
       !R|units=m/sec|pclin  velns_neo(nrho_anomth,0:nspec_th)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_velns_tglf
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: velns_tglf
       !density-equations, advective velocity term from TGLF model
       !R|units=m/sec|pclin velns_tglf(nrho_anomth,0:nspec_th)

     INTEGER :: id_velnx_nclass = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: velnx_nclass
       !main-impurity-density-equations, advective velocity term from NCLASS model
       !R|units=m/sec|pclin velnx_nclass(nrho_anomth)

     INTEGER :: id_velpphi_anom = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: velpphi_anom
       !momentum-equation, advective velocity term
       !R|units=m/sec|pclin  velpphi_anom(nrho_anomth)

     INTEGER :: id_velpphi_glf = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: velpphi_glf
       !momentum-equation, advective velocity term from GLF23 model
       !R|units=m/sec|pclin  velpphi_glf(nrho_anomth)

     INTEGER :: id_velpphi_gtcneo = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: velpphi_gtcneo
       !momentum-equation, advective velocity term from GTC_NEO model
       !R|units=m/sec|pclin  velpphi_gtcneo(nrho_anomth)

     INTEGER :: id_velpphi_mmm71 = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: velpphi_mmm71
       !momentum-equation, advective velocity term from MMM71 model
       !R|units=m/sec|pclin  velpphi_mmm71(nrho_anomth)

     INTEGER :: id_velpphi_neo = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: velpphi_neo
       !momentum-equation, advective velocity term from NEO model
       !R|units=m/sec|pclin  velpphi_neo(nrho_anomth)

     INTEGER :: id_velpphi_tglf = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: velpphi_tglf
       !momentum-equation, advective velocity term from TGLF model
       !R|units=m/sec|pclin velpphi_tglf(nrho_anomth)

     INTEGER :: id_velte_anom = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: velte_anom
       !Te-equation, advective velocity term
       !R|units=m/sec|pclin  velte_anom(nrho_anomth)

     INTEGER :: id_velte_glf = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: velte_glf
       !Te-equation, advective velocity term from GLF23 model
       !R|units=m/sec|pclin  velte_glf(nrho_anomth)

     INTEGER :: id_velte_gtcneo = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: velte_gtcneo
       !Te-equation, advective velocity term from GTC_NEO model
       !R|units=m/sec|pclin  velte_gtcneo(nrho_anomth)

     INTEGER :: id_velte_mmm71 = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: velte_mmm71
       !Te-equation, advective velocity term from MMM71 model
       !R|units=m/sec|pclin  velte_mmm71(nrho_anomth)

     INTEGER :: id_velte_nclass = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: velte_nclass
       !Te-equation, advective velocity term from NCLASS model
       !R|units=m/sec|pclin velte_nclass(nrho_anomth)

     INTEGER :: id_velte_neo = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: velte_neo
       !Te-equation, advective velocity term from NEO model
       !R|units=m/sec|pclin  velte_neo(nrho_anomth)

     INTEGER :: id_velte_paleo = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: velte_paleo
       !Te-equation, convection term from PALEO model
       !R|units=m/sec|pclin   velte_paleo(nrho_anomth)

     INTEGER :: id_velte_tglf = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: velte_tglf
       !Te-equation, advective velocity term from TGLF model
       !R|units=m/sec|pclin velte_tglf(nrho_anomth)

     INTEGER :: id_velti_anom = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: velti_anom
       !Ti-equation, advective velocity term
       !R|units=m/sec|pclin  velti_anom(nrho_anomth)

     INTEGER :: id_velti_glf = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: velti_glf
       !Ti-equation, advective velocity term from GLF23 model
       !R|units=m/sec|pclin  velti_glf(nrho_anomth)

     INTEGER :: id_velti_gtcneo = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: velti_gtcneo
       !Ti-equation, advective velocity term from GTC_NEO model
       !R|units=m/sec|pclin  velti_gtcneo(nrho_anomth)

     INTEGER :: id_velti_mmm71 = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: velti_mmm71
       !Ti-equation, advective velocity term from MMM71 model
       !R|units=m/sec|pclin  velti_mmm71(nrho_anomth)

     INTEGER :: id_velti_nclass = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: velti_nclass
       !Ti-equation, advective velocity term from NCLASS model
       !R|units=m/sec|pclin velti_nclass(nrho_anomth)

     INTEGER :: id_velti_neo = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: velti_neo
       !Ti-equation, advective velocity term from NEO model
       !R|units=m/sec|pclin  velti_neo(nrho_anomth)

     INTEGER :: id_velti_tglf = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: velti_tglf
       !Ti-equation, advective velocity term from TGLF model
       !R|units=m/sec|pclin velti_tglf(nrho_anomth)

     !----------------------------
     ! Component: EC

     INTEGER :: id_curech = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: curech
       !ECH current drive
       !R|step*dA|units=A   curech(~nrho_ecrf)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_curech_src
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: curech_src
       !ECH current drive (by antenna)
       !R|step*dA|units=A   curech_src(~nrho_ecrf,necrf_src)

     INTEGER :: id_peech = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: peech
       !electron heating by ECH
       !R|step*dV|units=W   peech(~nrho_ecrf)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_peech_src
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: peech_src
       !ECH heating (by antenna)
       !R|step*dV|units=W   peech_src(~nrho_ecrf,necrf_src)

     !----------------------------
     ! Component: EQ

     INTEGER :: id_area = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: area
       !enclosed area
       !R|units=m^2|Spline_00 area(nrho_eq)

     INTEGER :: id_BphiRZ = 0
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: BphiRZ
       !Toroidal field
       !R|units=T|Hermite      BphiRZ(nR,nZ)

     INTEGER :: id_BRRZ = 0
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: BRRZ
       !R component of poloidal field
       !R|units=T|Hermite      BRRZ(nR,nZ)

     INTEGER :: id_BZRZ = 0
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: BZRZ
       !Z component of poloidal field
       !R|units=T|Hermite      BZRZ(nR,nZ)

     INTEGER :: id_B_surfMax = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: B_surfMax
       !max mod(B) on flux surface
       !R|pclin  B_surfMax(nrho_eq_geo)

     INTEGER :: id_B_surfMin = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: B_surfMin
       !min mod(B) on flux surface
       !R|pclin  B_surfMin(nrho_eq_geo)

     INTEGER :: id_curt = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: curt
       !total enclosed toroidal current
       !this includes <j.B> contributions and <j x B> contributions and
       !is related to the poloidal field:
       !mu0*I(rho) = rho*phit(nrho_eq)/(q(rho)*2*pi*pi)
       !* grho2r2i(rho) * (dVol/drho)
       !(From Ampere's Law, mu0*I_phi = loop integral (B_pol*dl)
       != loop integral (dl * grad(psi)/R)
       != rho*phit(nrho_eq)/(q(rho)*pi) *
       !loop integral (dl * grad(rho)/R)
       !(2*pi) * loop integral (dl * grad(rho)/rho)
       != loop integral (dl * 2*pi*R/grad(rho) * grad(rho)**2/R**2)
       != grho2r2i(rho) * dVol/drho
       !derivation depends on the definition of the radial coord.:
       !rho = sqrt(phit(rho)/phit(rho=1))
       !curt(nrho_eq) gives the total current, >0 by convention;
       !see kccw_Jphi, +/-1, for direction of toroidal current.
       !R|units=A|Spline_00   curt(nrho_eq)

       ! (Hermite derivative):
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: d2R_geo_dRHOdTH
       !flux surfaces R(rho,theta)
       !R|units=m|Hermite_explicit R_geo(nrho_eq,nth_eq)

       ! (Hermite derivative):
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: d2Z_geo_dRHOdTH
       !flux surfaces Z(rho,theta)
       !R|units=m|Hermite_explicit Z_geo(nrho_eq,nth_eq)

       ! (Hermite derivative):
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: dR0_momeq_dRHO
       !R0 of flux surface
       !Fourier Spline representation
       !R|units=m|Hermite_explicit  R0_momeq(nrho_eq)

       ! (Hermite derivative):
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: dR_geo_dRHO
       !flux surfaces R(rho,theta)
       !R|units=m|Hermite_explicit R_geo(nrho_eq,nth_eq)

       ! (Hermite derivative):
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: dR_geo_dTH
       !flux surfaces R(rho,theta)
       !R|units=m|Hermite_explicit R_geo(nrho_eq,nth_eq)

       ! (Hermite derivative):
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: dxRjcos_momeq_dRHO
       !scaled R cos moments
       !Fourier Spline representation
       !R|units=m|Hermite_explicit  xRjcos_momeq(nrho_eq,neqmom)

       ! (Hermite derivative):
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: dxRjsin_momeq_dRHO
       !scaled R sin moments
       !Fourier Spline representation
       !R|units=m|Hermite_explicit  xRjsin_momeq(nrho_eq,neqmom)

       ! (Hermite derivative):
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: dxZjcos_momeq_dRHO
       !scaled Z cos moments
       !Fourier Spline representation
       !R|units=m|Hermite_explicit  xZjcos_momeq(nrho_eq,neqmom)

       ! (Hermite derivative):
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: dxZjsin_momeq_dRHO
       !scaled Z sin moments
       !Fourier Spline representation
       !R|units=m|Hermite_explicit  xZjsin_momeq(nrho_eq,neqmom)

       ! (Hermite derivative):
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: dZ0_momeq_dRHO
       !Z0 of flux surface
       !Fourier Spline representation
       !R|units=m|Hermite_explicit  Z0_momeq(nrho_eq)

       ! (Hermite derivative):
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: dZ_geo_dRHO
       !flux surfaces Z(rho,theta)
       !R|units=m|Hermite_explicit Z_geo(nrho_eq,nth_eq)

       ! (Hermite derivative):
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: dZ_geo_dTH
       !flux surfaces Z(rho,theta)
       !R|units=m|Hermite_explicit Z_geo(nrho_eq,nth_eq)

     INTEGER :: id_elong = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: elong
       !elongation (b/a)
       !(Zmax-Zmin)/(Rmax-Rmin) on each surface
       !R|pclin  elong(nrho_eq_geo)

     INTEGER :: id_gamma_nc = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: gamma_nc
       !NC gamma
       !2pi/int(0 to 2pi)[dtheta*(B/B.grad(theta))]
       !R|units=m^-1|pclin   gamma_nc(nrho_eq_geo)

     INTEGER :: id_gb1 = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: gb1
       !<|B|>
       !R|units=T|pclin      gb1(nrho_eq_geo)

     INTEGER :: id_gb2 = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: gb2
       !<B^2>
       !R|units=T^2|pclin    gb2(nrho_eq_geo)

     INTEGER :: id_gb2i = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: gb2i
       !<1/B^2>
       !R|units=T^-2|pclin   gb2i(nrho_eq_geo)

     INTEGER :: id_gbr2 = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: gbr2
       !<|B|*R^2>
       !R|units=T*m^2|pclin  gbr2(nrho_eq_geo)

     INTEGER :: id_gncfb2h = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: gncfb2h
       !<(B^-2)*((1-H)^0.5-(1/3)*(1-H)^1.5)>; H=B/Bmax
       !R|units=T^-2|pclin  gncfb2h(nrho_eq_geo)

     INTEGER :: id_gncfh = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: gncfh
       !<H^-2*(1-SQRT(1-H)*(1+H/2))>; H=B/Bmax
       !R|units=-|pclin  gncfh(nrho_eq_geo)

     INTEGER :: id_gr1 = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: gr1
       !<R>
       !R|units=m|pclin   gr1(nrho_eq_geo)

     INTEGER :: id_gr2 = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: gr2
       !<R^2>
       !R|units=m^2|pclin gr2(nrho_eq_geo)

     INTEGER :: id_gr2i = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: gr2i
       !<R^-2>
       !R|units=m^-2|pclin gr2i(nrho_eq_geo)

     INTEGER :: id_gr2rho2 = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: gr2rho2
       !<R^2*|grad(rho)|^2>
       !R|units=-|pclin gr2rho2(nrho_eq_geo)

     INTEGER :: id_gr3i = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: gr3i
       !<R^-3>
       !R|units=m^-3|pclin gr3i(nrho_eq_geo)

     INTEGER :: id_grho1 = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: grho1
       !<|grad(rho)|>
       !R|units=m^-1|pclin grho1(nrho_eq_geo)

     INTEGER :: id_grho2 = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: grho2
       !<|grad(rho)|^2>
       !R|units=m^-2|pclin grho2(nrho_eq_geo)

     INTEGER :: id_grho2b2i = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: grho2b2i
       !<|grad(rho)|^2/B^2>
       !R|units=T^-2*m^-2|pclin grho2b2i(nrho_eq_geo)

     INTEGER :: id_grho2r2i = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: grho2r2i
       !<|grad(rho)|^2/R^2>
       !R|units=m^-4|pclin grho2r2i(nrho_eq_geo)

     INTEGER :: id_grho2r3i = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: grho2r3i
       !<|grad(rho)|^2/R^3>
       !R|units=m^-5|pclin grho2r3i(nrho_eq_geo)

     INTEGER :: id_gri = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: gri
       !<1/R>
       !R|units=m^-2|pclin gri(nrho_eq_geo)

     INTEGER :: id_grirhoi = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: grirhoi
       !<1/(R*|grad(rho)|)>
       !R|units=-|pclin grirhoi(nrho_eq_geo)

     INTEGER :: id_g_eq = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: g_eq
       !equilibrium R*|B_phi|
       !By convention this profile is always positive; direction
       !of B_phi is taken from element kccw_Bphi:
       !B_phi = kccw_Bphi*g/R
       !R|units=T*m|Spline_00      g_eq(nrho_eq)

     INTEGER :: id_jdotb = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: jdotb
       !<J.B>
       !Parallel current * mod(B) -- note sign convention:
       !Local positive values indicate local current flow
       !in the direction of the main toroidal current; i.e. actually
       !kccw_Jphi * kccw_Bphi * <J.B> is stored.  So, even if the
       !main toroidal current and the toroidal field are anti-parallel,
       !jdotb is generally positive, but there can be localized regions
       !of negative values, usually near the plasma edge.
       !From a parallel Ampere's Law expression, <J.B> can be expressed
       !as a combination of derivatives of toroidal current and toroidal
       !field functions curt(rho) and g(rho):
       !<J.B> = 2pi*[g*d(curt)/drho-curt*dg/drho]/(dVol/drho)
       !R|units=A*T/m^2|Hermite_00     jdotb(nrho_eq)

     INTEGER :: id_Lpol = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: Lpol
       !poloidal path length
       !R|units=m|Spline Lpol(nrho_eq)

     INTEGER :: id_ngradb2_av = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: ngradb2_av
       !<(B.grad(B)/|B|)^2>
       !average of square of grad(B) along field line
       !R|units=T^2*m^-2|pclin   ngradb2_av(nrho_eq_geo)

     INTEGER :: id_phit = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: phit
       !toroidal flux vs. rho
       !By convention, this profile always positive; 0 on axis.
       !See kccw_Bphi for specification of direction of toroidal field.
       !R|units=Wb|Spline_00       phit(nrho_eq)

     INTEGER :: id_psipol = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: psipol
       !poloidal flux vs. rho
       !By convention, this profile always positive; 0 on axis.
       !-- see kccw_Jphi; see also psi_to_machine_axis
       !for specification of direction (sign) of toroidal current and
       !hence the poloidal magnetic field.
       !R|units=Wb/rad|Spline_00   psipol(nrho_eq)

     INTEGER :: id_PsiRZ = 0
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: PsiRZ
       !Psi(R,Z)
       !Note on Psi(rho) and Psi(R,Z) both: convention is to set
       !Psi=0 at the magnetic axis and increasing towards the plasma
       !boundary.  Direction of poloidal field is taken from element
       !kccw_Jphi:
       !
       !BR = kccw_Jphi*(1/R)*d(Psi/dZ)
       !BZ =-kccw_Jphi*(1/R)*d(Psi/dR)
       !
       !see also: Psi_to_machine_axis.
       !R|units=Wb/rad|Spline  PsiRZ(nR,nZ)

     INTEGER :: id_psmom_errck = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: psmom_errck
       !PS moments sum convergence
       !|ngradb2_av(:)-sum[j=1:npsmom]psmom_nc(:,j)/gb2(:)|/maxval(|ngradb2_av(:)|)
       !R|units=-|pclin       psmom_errck(nrho_eq_geo)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_psmom_nc
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: psmom_nc
       !PS moments
       !(1:npsmom) Pfirsch-Schlutter moments (NCLASS)
       !convergence check: sum[j=1:infinity](psmom_nc(:,j))= gb2(:)*ngradb2_av(:)
       !R|units=m^-2|pclin    psmom_nc(nrho_eq_geo,npsmom)

     INTEGER :: id_P_eq = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: P_eq
       !equilibrium scalar pressure
       !R|units=Pa|Spline_00       P_eq(nrho_eq)

     INTEGER :: id_q_eq = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: q_eq
       !equilibrium q profile
       !R|units=-|Spline           q_eq(nrho_eq)

     INTEGER :: id_R0_momeq = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: R0_momeq
       !R0 of flux surface
       !Fourier Spline representation
       !R|units=m|Hermite_explicit  R0_momeq(nrho_eq)

     INTEGER :: id_Rmajor_mean = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: Rmajor_mean
       !Rmajor_mean = (R_Surfmax+R_surfmin)/2
       !R|pclin  Rmajor_mean(nrho_eq_geo)

     INTEGER :: id_rMinor_mean = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: rMinor_mean
       !rMinor_mean = (R_Surfmax-R_surfmin)/2
       !R|pclin  rMinor_mean(nrho_eq_geo)

     INTEGER :: id_R_geo = 0
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: R_geo
       !flux surfaces R(rho,theta)
       !R|units=m|Hermite_explicit R_geo(nrho_eq,nth_eq)

     INTEGER :: id_R_midp_in = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: R_midp_in
       !R (high field side) midplane intercept
       !R|pclin  R_midp_in(nrho_eq_geo)

     INTEGER :: id_R_midp_out = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: R_midp_out
       !R (low field side) midplane intercept
       !R|pclin  R_midp_out(nrho_eq_geo)

     INTEGER :: id_R_surfMax = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: R_surfMax
       !max R on flux surface
       !R|pclin  R_surfMax(nrho_eq_geo)

     INTEGER :: id_R_surfMin = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: R_surfMin
       !min R on flux surface
       !R|pclin  R_surfMin(nrho_eq_geo)

     INTEGER :: id_squareLO = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: squareLO
       !lower outer squareness
       !lower half of plasma, large major radius side
       !definition per C. T. Holcomb et al,
       !Physics of Plasmas 15, 056116 (2009)
       !R|pclin  squareLO(nrho_eq_geo)

     INTEGER :: id_squareUO = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: squareUO
       !upper outer squareness
       !upper half of plasma, large major radius side
       !definition per C. T. Holcomb et al,
       !Physics of Plasmas 15, 056116 (2009)
       !R|pclin  squareUO(nrho_eq_geo)

     INTEGER :: id_surf = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: surf
       !area of flux surfaces
       !R|units=m^2|Spline surf(nrho_eq)

     INTEGER :: id_triang = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: triang
       !triangularity (symmetrized)
       !((Rmin+Rmax)/2 - min(R(Zmax),R(Zmin)))/((Rmax-Rmin)/2)
       !R|pclin  triang(nrho_eq_geo)

     INTEGER :: id_triangL = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: triangL
       !lower triangularity
       !((Rmin+Rmax)/2 - R(Zmin))/((Rmax-Rmin)/2)
       !R|pclin  triangL(nrho_eq_geo)

     INTEGER :: id_triangU = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: triangU
       !upper triangularity
       !((Rmin+Rmax)/2 - R(Zmax))/((Rmax-Rmin)/2)
       !R|pclin  triangU(nrho_eq_geo)

     INTEGER :: id_triang_miller_L = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: triang_miller_L
       !Miller lower triangularity
       !Sin(aCos((R(Zmin)-Rmajor_mean)/rMinor_mean)-pi/2).
       !R|pclin  triang_miller_L(nrho_eq_geo)

     INTEGER :: id_triang_miller_U = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: triang_miller_U
       !Miller upper triangularity
       !Sin(aCos((R(Zmax)-Rmajor_mean)/rMinor_mean)-pi/2).
       !R|pclin  triang_miller_U(nrho_eq_geo)

     INTEGER :: id_vol = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: vol
       !enclosed volume
       !R|units=m^3|Spline_00  vol(nrho_eq)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_xRjcos_momeq
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: xRjcos_momeq
       !scaled R cos moments
       !Fourier Spline representation
       !R|units=m|Hermite_explicit  xRjcos_momeq(nrho_eq,neqmom)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_xRjsin_momeq
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: xRjsin_momeq
       !scaled R sin moments
       !Fourier Spline representation
       !R|units=m|Hermite_explicit  xRjsin_momeq(nrho_eq,neqmom)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_xZjcos_momeq
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: xZjcos_momeq
       !scaled Z cos moments
       !Fourier Spline representation
       !R|units=m|Hermite_explicit  xZjcos_momeq(nrho_eq,neqmom)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_xZjsin_momeq
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: xZjsin_momeq
       !scaled Z sin moments
       !Fourier Spline representation
       !R|units=m|Hermite_explicit  xZjsin_momeq(nrho_eq,neqmom)

     INTEGER :: id_Z0_momeq = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: Z0_momeq
       !Z0 of flux surface
       !Fourier Spline representation
       !R|units=m|Hermite_explicit  Z0_momeq(nrho_eq)

     INTEGER :: id_Z_geo = 0
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: Z_geo
       !flux surfaces Z(rho,theta)
       !R|units=m|Hermite_explicit Z_geo(nrho_eq,nth_eq)

     INTEGER :: id_Z_midp = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: Z_midp
       !flux surface midplane elevation
       !R|pclin  Z_midp(nrho_eq_geo)

     INTEGER :: id_Z_surfMax = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: Z_surfMax
       !max Z on flux surface
       !R|pclin  Z_surfMax(nrho_eq_geo)

     INTEGER :: id_Z_surfMin = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: Z_surfMin
       !min Z on flux surface
       !R|pclin  Z_surfMin(nrho_eq_geo)

     !----------------------------
     ! Component: FUS

     INTEGER :: id_curfusn = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: curfusn
       !fusion ion driven current (shielded)
       !R|step*dA|units=A   curfusn(~nrho_fus)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_eperp_fusi
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: eperp_fusi
       !fusion ion <Eperp>, lab frame
       !R|units=keV|alias=eperp_|step*nfusi eperp_fusi(~nrho_fus,nspec_fusion)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_epll_fusi
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: epll_fusi
       !fusion ion <Epll>, lab frame
       !R|units=keV|alias=epll_|step*nfusi  epll_fusi(~nrho_fus,nspec_fusion)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_nfusi
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: nfusi
       !fusion ion density
       !R|units=m^-3|alias=n|step  nfusi(~nrho_fus,nspec_fusion)

     INTEGER :: id_pfuse = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: pfuse
       !electron heating by all fusion ions
       !R|step*dV   pfuse(~nrho_fus)

     INTEGER :: id_pfusi = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: pfusi
       !thermal ion heating by all fusion ions
       !R|step*dV   pfusi(~nrho_fus)

     INTEGER :: id_pfusth = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: pfusth
       !thermalization of fusion ions
       !R|step*dV   pfusth(~nrho_fus)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_rate_sinf0i
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: rate_sinf0i
       !sink rate due to ionization by fusion ions
       !R|step|units=1/sec       rate_sinf0i(~nrho_fus,nspec_gas)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_rate_sinf0x
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: rate_sinf0x
       !sink rate due to CX with fusion ions (total)
       !R|step|units=1/sec       rate_sinf0x(~nrho_fus,nspec_gas)

     INTEGER, DIMENSION(:,:), ALLOCATABLE :: id_rate_sinf0xs
     REAL(KIND=rspec), DIMENSION(:,:,:), ALLOCATABLE :: rate_sinf0xs
       !sink rate due to CX with fusion ions
       !R|step|units=1/sec       rate_sinf0xs(~nrho_fus,nspec_gas,nspec_fusion)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_sfsce
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: sfsce
       !net thermalization source of fusion ions
       !sources due to fusion ions:  fusion ion thermalization;
       !corrections due to charge exchange effects (usually small).
       !R|step*dV|units=#/sec   sfsce(~nrho_fus,0:nspec_tha)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_sftherm
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: sftherm
       !fusion ion thermalization
       !R|step*dV|units=#/sec   sftherm(~nrho_fus,nspec_fusion)

     !----------------------------
     ! Component: GAS

     INTEGER, DIMENSION(:,:), ALLOCATABLE :: id_n0norm
     REAL(KIND=rspec), DIMENSION(:,:,:), ALLOCATABLE :: n0norm
       !neutral density per unit gas influx (sc0)
       !for each neutral specie due to each source
       !R|step|units=(m^-3)/(#/sec)    n0norm(~nrho_gas,nspec_gas,ngsc0)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_n0_reco
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: n0_reco
       !reco thermal neutral density
       !R|units=m^-3|step         n0_reco(~nrho_gas,nspec_gas)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_omeg0cx
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: omeg0cx
       !effective neutral angular velocity for CX torque
       !(use with tqqcx)
       !R|step*tqqcx|units=rad/sec  omeg0cx(~nrho_gas,ngsc0)

     INTEGER, DIMENSION(:,:), ALLOCATABLE :: id_omeg0sc0
     REAL(KIND=rspec), DIMENSION(:,:,:), ALLOCATABLE :: omeg0sc0
       !toroidal angular velocity
       !for each neutral specie due to each influx (sc0).
       !R|step*n0norm|units=(rad/sec)  omeg0sc0(~nrho_gas,nspec_gas,ngsc0)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_omeg0_reco
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: omeg0_reco
       !reco neutral toroidal angular velocity
       !R|units=rad/sec|step*n0_reco  omeg0_reco(~nrho_gas,nspec_gas)

     INTEGER :: id_p0_reco = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: p0_reco
       !power in recombination neutral source
       !(loss from thermal ions)
       !R|step*dV   p0_reco(~nrho_gas)

     INTEGER :: id_pcx_reco = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: pcx_reco
       !reco driven CX power
       !(>0 => local source to thermal ions)
       !(no associated particle source/sink)
       !R|step*dV   pcx_reco(~nrho_gas)

     INTEGER :: id_psc_reco = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: psc_reco
       !reco power: recapture - p0_reco
       !(net source/sink to thermal ions)
       !(associated particle source/sink exists)
       !R|step*dV   psc_reco(~nrho_gas)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_qioniz
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: qioniz
       !ionization power per unit influx (sc0)
       !R|step*dV|units=W/(#/sec)     qioniz(~nrho_gas,ngsc0)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_qqcx
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: qqcx
       !cx power per unit influx per (T0-Ti)
       !R|step*dV|units=W/(#/sec)/keV  qqcx(~nrho_gas,ngsc0)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_s0reco
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: s0reco
       !recombination neutral sce
       !psc_reco =~ (3/2)*Ti*(s0reco_recap-s0reco)*1.602e-16
       !note: electron sink = sum (Z(i)*s0reco(:,i))
       !where Z(i) is the number of electrons carried by a neutral atom
       !of species (i).
       !R|step*dV|units=#/sec s0reco(~nrho_gas,nspec_gas)

     INTEGER :: id_s0reco_e = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: s0reco_e
       !net electron source associated with recombination:
       !sum[-Z(i)*s0reco(:,i) + Z(i)*s0reco_recap(:,i)]
       !R|step*dV|units=#/sec s0reco_e(~nrho_gas)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_s0reco_recap
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: s0reco_recap
       !recombination neutrals recapture
       !recapture of recombination source thermal neutrals -- ion source
       !psc_reco =~ (3/2)*Ti*(sb0reco_recap-sb0reco)*1.602e-16
       !R|step*dV|units=#/sec s0reco_recap(~nrho_gas,nspec_gas)

     INTEGER, DIMENSION(:,:), ALLOCATABLE :: id_sprof0
     REAL(KIND=rspec), DIMENSION(:,:,:), ALLOCATABLE :: sprof0
       !gas species source/sinks per unit species influx
       !due to charge exchange, single species neutral
       !source (sc0(i)) leads to multi species ion sce.
       !remark (Jan. 2009):
       !charge exchange can affect impurity charge
       !states -- may need to add profiles to track
       !this interaction, in the future...
       !R|step*dV|units=(#/sec)/(#/sec)  sprof0(~nrho_gas,nspec_gas,ngsc0)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_sprof0e
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: sprof0e
       !electron source per unit neutral species influx
       !R|step*dV|units=(#/sec)/(#/sec)  sprof0e(~nrho_gas,ngsc0)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_T0cx
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: T0cx
       !effective neutral temperature for CX power
       !(use with qqcx)
       !R|step*qqcx|units=keV  T0cx(~nrho_gas,ngsc0)

     INTEGER, DIMENSION(:,:), ALLOCATABLE :: id_T0sc0
     REAL(KIND=rspec), DIMENSION(:,:,:), ALLOCATABLE :: T0sc0
       !neutral temperature (2/3)<E0>
       !in co-rotating frame for each neutral specie
       !due each neutral influx (sc0)
       !R|step*n0norm|units=keV        T0sc0(~nrho_gas,nspec_gas,ngsc0)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_T0_reco
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: T0_reco
       !reco neutral temperature (2/3)<E0>
       !R|units=keV|step*n0_reco  T0_reco(~nrho_gas,nspec_gas)

     INTEGER :: id_tq0_reco = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: tq0_reco
       !torque of recombination neutral source
       !(momentum loss from thermal ions)
       !R|step*dV   tq0_reco(~nrho_gas)

     INTEGER :: id_tqcx_reco = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: tqcx_reco
       !reco driven CX momentum torque
       !(positive value = momentum source)
       !(no associated particle source/sink)
       !R|step*dV   tqcx_reco(~nrho_gas)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_tqioniz
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: tqioniz
       !ionization torque per unit influx (sc0)
       !R|step*dV|units=Nt*m/(#/sec)     tqioniz(~nrho_gas,ngsc0)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_tqqcx
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: tqqcx
       !cx torque per unit influx per (omeg0-omegi)
       !R|step*dV|units=Nt*m/(#/sec)/(rad/sec)  tqqcx(~nrho_gas,ngsc0)

     INTEGER :: id_tqsc_reco = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: tqsc_reco
       !reco torque: recapture - tq0_reco
       !(net source/sink to thermal ions)
       !(associated particle source/sink exists)
       !R|step*dV   tqsc_reco(~nrho_gas)

     !----------------------------
     ! Component: IC

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_cdicrf
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: cdicrf
       !ICRF current drive
       !(summed over nphi)
       !R|units=A|step*dA   cdicrf(~nrho_icrf,nicrf_src)

     INTEGER, DIMENSION(:,:), ALLOCATABLE :: id_cdicrf_nphi
     REAL(KIND=rspec), DIMENSION(:,:,:), ALLOCATABLE :: cdicrf_nphi
       !ICRF current drive
       !contribution from each n_phi on each antenna
       !R|units=A|step*dA   cdicrf_nphi(~nrho_icrf,num_nphi(),nicrf_src)

     INTEGER :: id_curich = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: curich
       !total driven current (all IC srcs)
       !R|units=A|step*dA   curich(~nrho_icrf)

     INTEGER :: id_curmino = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: curmino
       !minority ion driven cur (shielded).
       !R|step*dA|units=A   curmino(~nrho_icrf)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_eperp_mini
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: eperp_mini
       !minority species <Eperp>, lab frame
       !R|units=keV|alias=eperp_|step*nmini eperp_mini(~nrho_icrf,nspec_rfmin)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_epll_mini
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: epll_mini
       !minority species <Epll>, lab frame
       !R|units=keV|alias=epll_|step*nmini  epll_mini(~nrho_icrf,nspec_rfmin)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_nmini
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: nmini
       !minority species density
       !R|units=m^-3|alias=n|step  nmini(~nrho_icrf,nspec_rfmin)

     INTEGER, DIMENSION(:,:,:), ALLOCATABLE :: id_picrf_nphi_srcs
     REAL(KIND=rspec), DIMENSION(:,:,:,:), ALLOCATABLE :: picrf_nphi_srcs
       !direct ICRF power deposition
       !contribution from each n_phi on each antenna
       !R|units=W|alias=picrf_nphi_|step*dV   picrf_nphi_srcs(~nrho_icrf,num_nphi(),nicrf_src,0:nspec_alla)

     INTEGER, DIMENSION(:,:), ALLOCATABLE :: id_picrf_srcs
     REAL(KIND=rspec), DIMENSION(:,:,:), ALLOCATABLE :: picrf_srcs
       !direct ICRF power deposition
       !(sum over nphi)
       !R|units=W|alias=picrfs_|step*dV   picrf_srcs(~nrho_icrf,nicrf_src,0:nspec_alla)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_picrf_totals
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: picrf_totals
       !direct ICRF power deposition
       !(sum over IC sources & nphi)
       !R|units=W|alias=picrf_|step*dV    picrf_totals(~nrho_icrf,0:nspec_alla)

     INTEGER :: id_picth = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: picth
       !direct thermal ion heating by ICRF
       !(sum over thermal ion species & IC sources)
       !R|step*dV|units=W   picth(~nrho_icrf)

     INTEGER :: id_pmine = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: pmine
       !electron heating by minority ions
       !R|step*dV   pmine(~nrho_icrf)

     INTEGER :: id_pmini = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: pmini
       !thermal ion heating by minority ions
       !R|step*dV   pmini(~nrho_icrf)

     INTEGER :: id_pminth = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: pminth
       !(de)thermalization of minority ions
       !R|step*dV   pminth(~nrho_icrf)

     !----------------------------
     ! Component: LH

     INTEGER :: id_curlh = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: curlh
       !LH current drive
       !R|step*dA|units=A   curlh(~nrho_lhrf)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_curlh_src
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: curlh_src
       !LH current drive (by antenna)
       !R|step*dA|units=A   curlh_src(~nrho_lhrf,nlhrf_src)

     INTEGER :: id_pelh = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: pelh
       !electron heating by LH
       !R|step*dV   pelh(~nrho_lhrf)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_pelh_src
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: pelh_src
       !LH electron heating by antenna
       !R|step*dV|units=W   pelh_src(~nrho_lhrf,nlhrf_src)

     INTEGER :: id_pilh = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: pilh
       !ion heating by LH
       !R|step*dV   pilh(~nrho_lhrf)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_pilh_src
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: pilh_src
       !LH ion heating by antenna
       !R|step*dV|units=W   pilh_src(~nrho_lhrf,nlhrf_src)

     !----------------------------
     ! Component: LMHD

     INTEGER :: id_balstab = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: balstab
       !Ballooning/Mercier stability indicator
       != 0.0: stable;
       != 1.0: Ballooning unstable;
       != 2.0: Mercier unstable
       != 3.0: Both Ballooning and Mercier unstable
       !(note a floating point profile is used; interpolation to another
       !grid would yield non-integer values that if non-zero would indicate
       !instability in the vicinity).
       !R|units=-|pclin balstab(nrho_lmhd)

     !----------------------------
     ! Component: NBI

     INTEGER :: id_curbeam = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: curbeam
       !beam ion driven current (shielded)
       !R|step*dA|units=A   curbeam(~nrho_nbi)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_eperp_beami
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: eperp_beami
       !beam species <Eperp>, lab frame
       !R|units=keV|alias=eperp_|step*nbeami eperp_beami(~nrho_nbi,nspec_beam)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_epll_beami
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: epll_beami
       !beam species <Epll>, lab frame
       !R|units=keV|alias=epll_|step*nbeami  epll_beami(~nrho_nbi,nspec_beam)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_n0_halo
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: n0_halo
       !halo thermal neutral density
       !R|units=m^-3|step         n0_halo(~nrho_nbi,nspec_gas)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_nbeami
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: nbeami
       !beam species density
       !R|units=m^-3|alias=n|step  nbeami(~nrho_nbi,nspec_beam)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_omeg0_halo
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: omeg0_halo
       !halo neutral toroidal angular velocity
       !R|units=rad/sec|step*n0_halo  omeg0_halo(~nrho_nbi,nspec_gas)

     INTEGER :: id_pb0_halo = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: pb0_halo
       !power in halo neutral source
       !(loss from thermal ions)
       !R|step*dV   pb0_halo(~nrho_nbi)

     INTEGER :: id_pbe = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: pbe
       !electron heating by all beam ions
       !R|step*dV   pbe(~nrho_nbi)

     INTEGER :: id_pbi = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: pbi
       !thermal ion heating by all beam ions
       !R|step*dV   pbi(~nrho_nbi)

     INTEGER :: id_pbth = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: pbth
       !thermalization of beam ions
       !R|step*dV   pbth(~nrho_nbi)

     INTEGER :: id_pcx_halo = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: pcx_halo
       !beam halo driven CX power
       !(>0 means local source)
       !(no associated particle source/sink)
       !R|step*dV   pcx_halo(~nrho_nbi)

     INTEGER :: id_psc_halo = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: psc_halo
       !beam halo power: recapture - pb0_halo
       !(net source/sink to thermal ions)
       !(associated particle source/sink exists)
       !R|step*dV   psc_halo(~nrho_nbi)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_qbeami
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: qbeami
       !average beam ion charge
       !Note, although H & He beam ions will be fully stripped,
       !Impurity beams (Ne, Xe, Ar, Kr) may not be...
       !<state>%q_snbi(1:<state>%nspec_beam) will contain the
       !density weighted volume average charge over the
       !profile: ps_xe for H beams, 2*ps_xe for He beams...
       !R|units=C|step*nbeami qbeami(~nrho_nbi,nspec_beam)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_rate_sinb0i
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: rate_sinb0i
       !sink rate due to ionization by beam ions
       !R|step|units=1/sec       rate_sinb0i(~nrho_nbi,nspec_gas)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_rate_sinb0x
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: rate_sinb0x
       !sink rate due to CX with beam ions (total)
       !R|step|units=1/sec       rate_sinb0x(~nrho_nbi,nspec_gas)

     INTEGER, DIMENSION(:,:), ALLOCATABLE :: id_rate_sinb0xs
     REAL(KIND=rspec), DIMENSION(:,:,:), ALLOCATABLE :: rate_sinb0xs
       !sink rate due to CX with beam ions
       !R|step|units=1/sec       rate_sinb0xs(~nrho_nbi,nspec_gas,nspec_beam)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_sb0halo
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: sb0halo
       !beam dep cx sink
       !thermal neutrals created by fast neutral deposition and/or recapture
       !of fast neutrals
       !psc_halo =~ (3/2)*Ti*(sb0halo_recap-sb0halo)*1.602e-16
       !R|step*dV|units=#/sec sb0halo(~nrho_nbi,nspec_gas)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_sb0halo_recap
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: sb0halo_recap
       !cx neutral recapture
       !recapture of thermal neutrals -- ion source
       !psc_halo =~ (3/2)*Ti*(sb0halo_recap-sb0halo)*1.602e-16
       !(cross species CX source/sink contributions may occur)
       !note: electron recapture, cold source = sum (Z(i)*sb0halo_recap(:,i))
       !where Z(i) is the number of electrons carried by a neutral atom
       !of species (i).  => this is to be included in sbsce(:,0).
       !R|step*dV|units=#/sec sb0halo_recap(~nrho_nbi,nspec_gas)

     INTEGER :: id_sbedep = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: sbedep
       !beam deposition cold electron sce
       !there is also a contribution due to recapture of charge-exchanged
       !fast neutrals from partially slowed down beam ions.
       !R|step*dV|units=#/sec sbedep(~nrho_nbi)

     INTEGER :: id_sbehalo = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: sbehalo
       !cold electron sce due to
       !recapture of beam halo charge exchange thermal neutrals
       != sum Z(i)*sb0halo_recap(i), if electrons do not go into
       !an impurity charge state spectrum.
       !R|step*dV|units=#/sec sbehalo(~nrho_nbi)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_sbsce
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: sbsce
       !net source, thermal ions & electrons
       !...cold electron deposition; ion thermalization;
       !corrections for charge exchange (beam deposition halo, mainly),
       !halo recapture
       !for thermal ions:
       !sbsce = sbtherm - sb0halo + sb0halo_recap
       !(caution: sbtherm is defined over beam species list;
       !sbsce over thermal species list;
       !sb0halo & sb0halo_recap over the neutral gas species list).
       !for electrons:
       !sbsce = sbedep + sbehalo
       !R|step*dV|units=#/sec   sbsce(~nrho_nbi,0:nspec_tha)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_sbtherm
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: sbtherm
       !beam ion thermalization
       !source of slowed down, thermalized beam ions
       !R|step*dV|units=#/sec sbtherm(~nrho_nbi,nspec_beam)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_T0_halo
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: T0_halo
       !halo neutral temperature (2/3)<E0>
       !R|units=keV|step*n0_halo  T0_halo(~nrho_nbi,nspec_gas)

     INTEGER :: id_tqb0_halo = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: tqb0_halo
       !torque of halo neutral source
       !(loss from thermal ions)
       !R|step*dV   tqb0_halo(~nrho_nbi)

     INTEGER :: id_tqbe = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: tqbe
       !collisional beam torque to electrons
       !R|step*dV   tqbe(~nrho_nbi)

     INTEGER :: id_tqbi = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: tqbi
       !collisional beam torque to thermal ions
       !R|step*dV   tqbi(~nrho_nbi)

     INTEGER :: id_tqbjxb = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: tqbjxb
       !JxB beam torque
       !R|step*dV   tqbjxb(~nrho_nbi)

     INTEGER :: id_tqbth = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: tqbth
       !momentum in thermalization of beam ions
       !R|step*dV   tqbth(~nrho_nbi)

     INTEGER :: id_tqcx_halo = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: tqcx_halo
       !beam halo driven CX momentum torque
       !(positive value = momentum source)
       !(no associated particle source/sink)
       !R|step*dV   tqcx_halo(~nrho_nbi)

     INTEGER :: id_tqsc_halo = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: tqsc_halo
       !beam halo torque: recapture - tqb0_halo
       !(net source/sink to thermal ions)
       !(associated particle source/sink exists)
       !R|step*dV   tqsc_halo(~nrho_nbi)

     !----------------------------
     ! Component: PEL

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_spsce
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: spsce
       !net source, thermal ions & electrons
       !R|step*dV|units=#/sec   spsce(~nrho_pel,0:nspec_tha)

     !----------------------------
     ! Component: PLASMA

     INTEGER :: id_chie_trans = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: chie_trans
       !electron thermal diffusivity
       !R|pclin chie_trans(nrho)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_chie_transcat
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: chie_transcat
       !Electron energy diffusivity
       !R|units=m^2/sec|pclin chie_transcat(nrho,ntrcat)

     INTEGER :: id_chii_trans = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: chii_trans
       !ion thermal diffusivity
       !R|pclin chii_trans(nrho)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_chii_transcat
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: chii_transcat
       !Ion energy diffusivity
       !R|units=m^2/sec|pclin chii_transcat(nrho,ntrcat)

     INTEGER :: id_chimo_trans = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: chimo_trans
       !angular momentum diffusivity
       !R|pclin chimo_trans(nrho)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_chimo_transcat
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: chimo_transcat
       !Angular momentum diffusivity
       !R|units=m^2/sec|pclin chimo_transcat(nrho,ntrcat)

     INTEGER :: id_curr_bootstrap = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: curr_bootstrap
       !Neoclassical bootstrap current
       !R|units=A|step*dA   curr_bootstrap(~nrho)

     INTEGER :: id_curr_ohmic = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: curr_ohmic
       !Ohmic current
       !i.e. inductive current driven by toroidal loop voltage
       !in the toroidal direction, Amps/zone:  sum of:
       !curr_ohmic + curr_bootstrap + RF driven currents +
       !fast ion driven currents + runaway electron current +
       !diamagnetic current => curt (total enclosed toroidal
       !current) in the EQ component.
       !R|units=A|step*dA   curr_ohmic(~nrho)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_diff_trans
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: diff_trans
       !specie ptcl diffusivity
       !R|units=m^2/sec|pclin diff_trans(nrho,0:nspec_th)

     INTEGER, DIMENSION(:,:), ALLOCATABLE :: id_diff_transcat
     REAL(KIND=rspec), DIMENSION(:,:,:), ALLOCATABLE :: diff_transcat
       !specie diffusivity
       !R|units=m^2/sec|pclin diff_transcat(nrho,0:nspec_th,ntrcat)

     INTEGER :: id_Epot = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: Epot
       !radial electrostatic potential
       !at zone bdys
       !R|units=keV|pclin  Epot(nrho)

     INTEGER :: id_eta_parallel = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: eta_parallel
       !parallel electrical resistivity
       !R|units=ohm*m|Hermite eta_parallel(nrho)

     INTEGER :: id_Fi_depletion = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: Fi_depletion
       !fast ion depletion: sum[nj*Zj/ne]
       !R|units=-|step*ns(:,ps_elec_index) Fi_depletion(~nrho)

     INTEGER :: id_iota = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: iota
       !iota profile (1/q)
       !R|units=-|Spline_00  iota(nrho)

     INTEGER :: id_ni = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: ni
       !total thermal ion density
       !should match sum ns(:,1:nspec_th)
       !R|units=m^-3|step  ni(~nrho)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_ns
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: ns
       !thermal specie density
       !R|units=m^-3|alias=n|step  ns(~nrho,0:nspec_th)

     INTEGER :: id_omegat = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: omegat
       !ion toroidal angular velocity
       !single profile for all thermal
       !ion species; should be consistent
       !with ns & v_pars.
       !R|units=rad/sec|step*ni  omegat(~nrho)

     INTEGER :: id_pe_trans = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: pe_trans
       !electron transport (loss) power
       !R|step*dV   pe_trans(~nrho)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_pe_transcat
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: pe_transcat
       !electron transport
       !R|step*dV|units=W  pe_transcat(~nrho,ntrcat)

     INTEGER :: id_pi_trans = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: pi_trans
       !ion transport (loss) power
       !R|step*dV   pi_trans(~nrho)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_pi_transcat
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: pi_transcat
       !ion transport
       !R|step*dV|units=W  pi_transcat(~nrho,ntrcat)

     INTEGER :: id_pohme = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: pohme
       !Ohmic heating of electrons
       !R|units=W|step*dV   pohme(~nrho)

     INTEGER :: id_qcomp_e = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: qcomp_e
       !Compressional electron heating
       !R|step*dV   qcomp_e(~nrho)

     INTEGER :: id_qcomp_i = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: qcomp_i
       !Compressional ion heating
       !R|step*dV   qcomp_i(~nrho)

     INTEGER :: id_qie = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: qie
       !Ion->Electron heat coupling
       !+: power flow from ions to electrons
       !-: power flow from electrons to ions
       !R|units=W|step*dV   qie(~nrho)

     INTEGER :: id_qrot_conv = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: qrot_conv
       !rotational energy dissipation (convective)
       !R|step*dV   qrot_conv(~nrho)

     INTEGER :: id_qrot_diff = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: qrot_diff
       !rotational energy dissipation (diffusive)
       !R|step*dV   qrot_diff(~nrho)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_res_sn
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: res_sn
       !residuals for particle transport eqn
       !R|units=Norm|step*dV res_sn(~nrho,0:nspec_th)

     INTEGER :: id_res_te = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: res_te
       !residuals for electron transport eqn
       !R|step*dV res_te(~nrho)

     INTEGER :: id_res_ti = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: res_ti
       !residuals for ion transport eqn
       !R|step*dV res_ti(~nrho)

     INTEGER :: id_res_tq = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: res_tq
       !rediduals for angular momentum transport eqn
       !R|units=Norm|step*dV res_tq(~nrho)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_sn_trans
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: sn_trans
       !particle transport (loss)
       !electrons & thermal ion species
       !R|units=#/sec|step*dV sn_trans(~nrho,0:nspec_th)

     INTEGER, DIMENSION(:,:), ALLOCATABLE :: id_sn_transcat
     REAL(KIND=rspec), DIMENSION(:,:,:), ALLOCATABLE :: sn_transcat
       !species transport
       !R|step*dV|units=#/sec  sn_transcat(~nrho,0:nspec_th,ntrcat)

     INTEGER :: id_Ti = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: Ti
       !ion temperature
       !single profile for all thermal
       !ion species; should be consistent
       !with ns & Ts
       !R|units=keV|step*ni Ti(~nrho)

     INTEGER :: id_tq_trans = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: tq_trans
       !angular momentum transport (loss)
       !toroidal angular momentum
       !R|units=Nt*m|step*dV  tq_trans(~nrho)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_tq_transcat
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: tq_transcat
       !toroidal angular momentum transport
       !R|step*dV|units=Nt*m  tq_transcat(~nrho,ntrcat)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_Ts
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: Ts
       !thermal specie temperature
       !R|units=keV|alias=T|step*ns  Ts(~nrho,0:nspec_th)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_upwind_pfrac_ns
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: upwind_pfrac_ns
       !specie density forward upwind fractions
       !R|units=-|pclin upwind_pfrac_ns(nrho,0:nspec_th)

     INTEGER :: id_upwind_pfrac_omega = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: upwind_pfrac_omega
       !omega (ang. velocity) forward upwind fraction
       !R|pclin upwind_pfrac_omega(nrho)

     INTEGER :: id_upwind_pfrac_Te = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: upwind_pfrac_Te
       !Te (electron energy advection) forward upwind fraction
       !R|pclin upwind_pfrac_Te(nrho)

     INTEGER :: id_upwind_pfrac_Ti = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: upwind_pfrac_Ti
       !Ti (ion energy advection) forward upwind fraction
       !R|pclin upwind_pfrac_Ti(nrho)

     INTEGER :: id_vee_trans = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: vee_trans
       !electron energy radial velocity
       !R|pclin   vee_trans(nrho)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_vee_transcat
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: vee_transcat
       !Electron energy radial velocity
       !R|units=m/sec|pclin vee_transcat(nrho,ntrcat)

     INTEGER :: id_vie_trans = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: vie_trans
       !ion energy radial velocity
       !R|pclin   vie_trans(nrho)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_vie_transcat
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: vie_transcat
       !Ion energy radial velocity
       !R|units=m/sec|pclin vie_transcat(nrho,ntrcat)

     INTEGER :: id_vmo_trans = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: vmo_trans
       !angular momentum radial velocity
       !R|pclin   vmo_trans(nrho)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_vmo_transcat
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: vmo_transcat
       !Angular momentum radial velocity
       !R|units=m/sec|pclin vmo_transcat(nrho,ntrcat)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_vn_trans
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: vn_trans
       !specie radial velocity
       !R|units=m/sec|pclin   vn_trans(nrho,0:nspec_th)

     INTEGER, DIMENSION(:,:), ALLOCATABLE :: id_vn_transcat
     REAL(KIND=rspec), DIMENSION(:,:,:), ALLOCATABLE :: vn_transcat
       !specie radial velocity
       !R|units=m/sec|pclin vn_transcat(nrho,0:nspec_th,ntrcat)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_vpol_inmp
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: vpol_inmp
       !poloidal velocity, inner half midplane
       !R|units=m/sec|step*ns vpol_inmp(~nrho,0:nspec_th)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_vpol_omp
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: vpol_omp
       !poloidal velocity, outer half midplane
       !R|units=m/sec|step*ns vpol_omp(~nrho,0:nspec_th)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_vtor_inmp
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: vtor_inmp
       !toroidal velocity, inner half midplane
       !R|units=m/sec|step*ns vtor_inmp(~nrho,0:nspec_th)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_vtor_omp
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: vtor_omp
       !toroidal velocity, outer half midplane
       !R|units=m/sec|step*ns vtor_omp(~nrho,0:nspec_th)

     INTEGER :: id_V_loop = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: V_loop
       !loop voltage
       !R|units=Volts|pclin	V_loop(nrho)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_v_pars
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: v_pars
       !thermal specie <vpll>
       !R|units=m/sec|alias=vpll_|step*ns v_pars(~nrho,0:nspec_th)

     INTEGER, DIMENSION(:), ALLOCATABLE :: id_v_pers
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: v_pers
       !thermal specie <vper>
       !R|units=m/sec|alias=vper_|step*ns v_pers(~nrho,0:nspec_th)

     INTEGER :: id_Zeff = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: Zeff
       !Zeff (sum[nj*Zj**2]/ne)
       !R|step*ns(:,ps_elec_index)  Zeff(~nrho)

     INTEGER :: id_Zeff_fi = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: Zeff_fi
       !Fast ion contribution to Zeff
       !R|step*ns(:,ps_elec_index)  Zeff_fi(~nrho)

     INTEGER :: id_Zeff_th = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: Zeff_th
       !Thermal ion contribution to Zeff
       !R|step*ns(:,ps_elec_index)  Zeff_th(~nrho)

     !----------------------------
     ! Component: RAD

     INTEGER :: id_prad = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: prad
       !total radiated power
       !R|step*dV  prad(~nrho_rad)

     INTEGER :: id_prad_br = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: prad_br
       !bremsstrahlung contribution
       !R|step*dV  prad_br(~nrho_rad)

     INTEGER :: id_prad_cy = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: prad_cy
       !cyclotron radiation contribution
       !R|step*dV  prad_cy(~nrho_rad)

     INTEGER :: id_prad_li = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: prad_li
       !line radiation contribution
       !R|step*dV  prad_li(~nrho_rad)

     INTEGER, DIMENSION(:,:), ALLOCATABLE :: id_sii_xs
     REAL(KIND=rspec), DIMENSION(:,:,:), ALLOCATABLE :: sii_xs
       !species source/sinks driven by xs(1:nxs)
       !R|step*dV|units=(#/sec)/(#/sec) sii_xs(~nrho_mist,0:nspec_th,nxs)

     !----------------------------
     ! Component: RIPPLE

     INTEGER :: id_tfrip2_log = 0
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: tfrip2_log
       !2nd component of TF ripple
       !log((Bmax-Bmin)/(Bmax+Bmin))
       !This field is sometimes introduced
       !time dependently in experiments.
       !R|pclin  tfrip2_log(nR_rip,nZ_rip)

     INTEGER :: id_tfrip_log = 0
     REAL(KIND=rspec), DIMENSION(:,:), ALLOCATABLE :: tfrip_log
       !TF ripple: log((Bmax-Bmin)/(Bmax+Bmin))
       !This field is likely time invariant,
       !an attribute of the tokamak TF coils.
       !R|pclin  tfrip_log(nR_rip,nZ_rip)

     !----------------------------
     ! Component: RUNAWAY

     INTEGER :: id_cur_rw = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: cur_rw
       !current carried by fast electrons
       !R|step*dA|units=A   cur_rw(~nrho_rw)

     INTEGER :: id_dcur_rw_dVloop = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: dcur_rw_dVloop
       !sensitivity to loop volts
       !R|step*dA|units=A/Volt dcur_rw_dVloop(~nrho_rw)

     INTEGER :: id_eperp_rw = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: eperp_rw
       !runaway electron <Eperp>
       !R|units=keV|step*nrw  eperp_rw(~nrho_rw)

     INTEGER :: id_epll_rw = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: epll_rw
       !runaway electron <Epll>
       !R|units=keV|step*nrw  epll_rw(~nrho_rw)

     INTEGER :: id_nrw = 0
     REAL(KIND=rspec), DIMENSION(:), ALLOCATABLE :: nrw
       !runaway electron density
       !nrw/ne << 1 is assumed
       !R|units=m^-3|step   nrw(~nrho_rw)


  END TYPE plasma_state

  !-------------------------------------------------------------------------
  !   ps_list_window TYPE definition
  !      this is an aid to state visualization software
  !-------------------------------------------------------------------------

  TYPE :: ps_list_window

    CHARACTER*32 :: list_name = ' '   ! name of list
    INTEGER :: size = 0               ! size of list (# of elements)

    CHARACTER*32, DIMENSION(:), POINTER :: list_elems => NULL()
                                           ! sorted list element names

    CHARACTER*32, DIMENSION(:), POINTER :: elem_units => NULL()
                                           ! element units labels

    CHARACTER*256, DIMENSION(:), POINTER :: elem_descr => NULL()
                                           ! element descriptions

    CHARACTER*32, DIMENSION(:), POINTER :: component => NULL()
                                           ! component membership of element

    CHARACTER*32, DIMENSION(:), POINTER :: val_field => NULL()
                                           ! element value as character string

    CHARACTER*256, DIMENSION(:), POINTER :: c256val => NULL()
                                           ! CHAR*256 value (e.g. file path)

    INTEGER, DIMENSION(:), POINTER :: ival => NULL()
                                           ! INTEGER value

    REAL(KIND=rspec), DIMENSION(:), POINTER :: fval => NULL()
                                           ! REAL(KIND=rspec) value

    INTEGER, DIMENSION(:), POINTER :: vecsizes => NULL()
                                           ! vector sizes

    INTEGER, DIMENSION(:,:), POINTER :: ivec => NULL()
                                           ! INTEGER vectors

    REAL(KIND=rspec), DIMENSION(:,:), POINTER :: fvec => NULL()
                                           ! REAL(KIND=rspec) vectors

    !  species list data...

    INTEGER, DIMENSION(:), POINTER :: spectype => NULL()
                                           ! type of species e.g. ps_therm_ion

    INTEGER, DIMENSION(:), POINTER :: qval => NULL()
                                           ! ion charge

    INTEGER, DIMENSION(:), POINTER :: qatom => NULL()
                                           ! atomic number

    REAL(KIND=rspec), DIMENSION(:), POINTER :: awght => NULL()
                                           ! atomic weight
  END TYPE ps_list_window

  CONTAINS

    SUBROUTINE load_ps_container(iarray,ptr)
      INTEGER :: iarray(*)
      TYPE (plasma_state_container) :: ptr

      ptr = transfer(iarray(1:ps_container_size),ptr)
    END SUBROUTINE load_ps_container

    SUBROUTINE unload_ps_container(ptr,iarray)
      TYPE (plasma_state_container) :: ptr
      INTEGER :: iarray(*)

      iarray(1:ps_container_size) = transfer(ptr,iarray(1:ps_container_size))
    END SUBROUTINE unload_ps_container

    SUBROUTINE free_window(w)

      TYPE (ps_list_window) :: w

      w%list_name = ' '
      w%size = 0

      if(associated(w%list_elems)) deallocate(w%list_elems)
      if(associated(w%elem_descr)) deallocate(w%elem_descr)
      if(associated(w%component)) deallocate(w%component)
      if(associated(w%elem_units)) deallocate(w%elem_units)
      if(associated(w%val_field)) deallocate(w%val_field)
      if(associated(w%c256val)) deallocate(w%c256val)
      if(associated(w%ival)) deallocate(w%ival)
      if(associated(w%fval)) deallocate(w%fval)
      if(associated(w%vecsizes)) deallocate(w%vecsizes)
      if(associated(w%ivec)) deallocate(w%ivec)
      if(associated(w%fvec)) deallocate(w%fvec)
      if(associated(w%spectype)) deallocate(w%spectype)
      if(associated(w%qval)) deallocate(w%qval)
      if(associated(w%qatom)) deallocate(w%qatom)
      if(associated(w%awght)) deallocate(w%awght)

    END SUBROUTINE free_window

    SUBROUTINE clone_window(w1,w2)

      TYPE (ps_list_window) :: w1,w2

      call free_window(w2)

      w2%list_name = w1%list_name
      w2%size = w1%size

      if(associated(w1%list_elems)) then
         allocate(w2%list_elems(size(w1%list_elems)))
         w2%list_elems = w1%list_elems
      endif

      if(associated(w1%elem_descr))  then
         allocate(w2%elem_descr(size(w1%elem_descr)))
         w2%elem_descr = w1%elem_descr
      endif

      if(associated(w1%component))  then
         allocate(w2%component(size(w1%component)))
         w2%component = w1%component
      endif

      if(associated(w1%elem_units))  then
         allocate(w2%elem_units(size(w1%elem_units)))
         w2%elem_units = w1%elem_units
      endif

      if(associated(w1%val_field))  then
         allocate(w2%val_field(size(w1%val_field)))
         w2%val_field = w1%val_field
      endif

      if(associated(w1%c256val))  then
         allocate(w2%c256val(size(w1%c256val)))
         w2%c256val = w1%c256val
      endif

      if(associated(w1%ival))  then
         allocate(w2%ival(size(w1%ival)))
         w2%ival = w1%ival
      endif

      if(associated(w1%fval))  then
         allocate(w2%fval(size(w1%fval)))
         w2%fval = w1%fval
      endif

      if(associated(w1%vecsizes))  then
         allocate(w2%vecsizes(size(w1%vecsizes)))
         w2%vecsizes = w1%vecsizes
      endif

      if(associated(w1%ivec))  then
         allocate(w2%ivec(size(w1%ivec,1),size(w1%ivec,2)))
         w2%ivec = w1%ivec
      endif

      if(associated(w1%fvec))  then
         allocate(w2%fvec(size(w1%fvec,1),size(w1%fvec,2)))
         w2%fvec = w1%fvec
      endif

      if(associated(w1%spectype))  then
         allocate(w2%spectype(size(w1%spectype)))
         w2%spectype = w1%spectype
      endif

      if(associated(w1%qval))  then
         allocate(w2%qval(size(w1%qval)))
         w2%qval = w1%qval
      endif

      if(associated(w1%qatom))  then
         allocate(w2%qatom(size(w1%qatom)))
         w2%qatom = w1%qatom
      endif

      if(associated(w1%awght))  then
         allocate(w2%awght(size(w1%awght)))
         w2%awght = w1%awght
      endif

    END SUBROUTINE clone_window

  !-------------------------------------------------------------------------
  !
  !   Data declarations -- NONE
  !
  !-------------------------------------------------------------------------

END MODULE plasma_state_definition_mod

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


MODULE plasma_state_util_mod

  ! plasma_state header:

  use swim_global_data_mod, only: rspec, swim_err_out_file, swim_error
  implicit NONE


  SAVE
  PRIVATE

  !--------------------------------------------
  !
  !  PLASMA STATE MODULE -- UTILITY VARIABLES
  !    debug switch; counter for each defined component.
  !
  !--------------------------------------------
  !  The only SAVEd global variables are:
  !     ps_debug
  !
  !  All the rest are PARAMETERs.
  !--------------------------------------------

  INTEGER, PUBLIC :: ps_debug = 0  ! set =1 for summary debugging;
  ! set ps_debug = 2 for detailed debugging of plasma_state_store operations.

  INTEGER, PARAMETER, PUBLIC :: ps_ignore = 0
  INTEGER, PARAMETER, PUBLIC :: ps_warn = 1
  INTEGER, PARAMETER, PUBLIC :: ps_error = 2

  PUBLIC :: ps_diff
  PUBLIC :: ps_diff_c0,ps_diff_c1
  PUBLIC :: ps_diff_i0,ps_diff_i1,ps_diff_i2,ps_diff_i3
  PUBLIC :: ps_diff_r0,ps_diff_r1,ps_diff_r2

  INTERFACE ps_diff
     MODULE PROCEDURE ps_diff_c0,ps_diff_c1
     MODULE PROCEDURE ps_diff_i0,ps_diff_i1,ps_diff_i2,ps_diff_i3
     MODULE PROCEDURE ps_diff_r0,ps_diff_r1,ps_diff_r2
  END INTERFACE

  PUBLIC :: ps_conformal
  PUBLIC :: ps_conformal_c1
  PUBLIC :: ps_conformal_i1,ps_conformal_i2,ps_conformal_i3
  PUBLIC :: ps_conformal_r1,ps_conformal_r2,ps_conformal_r3,ps_conformal_r4

  INTERFACE ps_conformal
     MODULE PROCEDURE ps_conformal_c1
     MODULE PROCEDURE ps_conformal_i1,ps_conformal_i2,ps_conformal_i3
     MODULE PROCEDURE ps_conformal_r1,ps_conformal_r2,ps_conformal_r3,ps_conformal_r4
  END INTERFACE


  ! component information

  INTEGER, PARAMETER, PUBLIC :: ps_ccount = 14  ! number of known components

  ! C*32 parameter name for each component:
  CHARACTER*32, PARAMETER, PUBLIC :: ps_cname_ANOM = 'ANOM'
  CHARACTER*80, PARAMETER, PUBLIC :: ps_cdescr_ANOM = &
     'Anomalous transport'
  CHARACTER*32, PARAMETER, PUBLIC :: ps_cname_EC = 'EC'
  CHARACTER*80, PARAMETER, PUBLIC :: ps_cdescr_EC = &
     'Electron cyclotron heating and current drive'
  CHARACTER*32, PARAMETER, PUBLIC :: ps_cname_EQ = 'EQ'
  CHARACTER*80, PARAMETER, PUBLIC :: ps_cdescr_EQ = &
     'MHD equilibrium'
  CHARACTER*32, PARAMETER, PUBLIC :: ps_cname_FUS = 'FUS'
  CHARACTER*80, PARAMETER, PUBLIC :: ps_cdescr_FUS = &
     'Fusion product fast ions'
  CHARACTER*32, PARAMETER, PUBLIC :: ps_cname_GAS = 'GAS'
  CHARACTER*80, PARAMETER, PUBLIC :: ps_cdescr_GAS = &
     'Neutral Gas sources & transport'
  CHARACTER*32, PARAMETER, PUBLIC :: ps_cname_IC = 'IC'
  CHARACTER*80, PARAMETER, PUBLIC :: ps_cdescr_IC = &
     'Ion cyclotron heating'
  CHARACTER*32, PARAMETER, PUBLIC :: ps_cname_LH = 'LH'
  CHARACTER*80, PARAMETER, PUBLIC :: ps_cdescr_LH = &
     'Lower Hybrid heating and current drive'
  CHARACTER*32, PARAMETER, PUBLIC :: ps_cname_LMHD = 'LMHD'
  CHARACTER*80, PARAMETER, PUBLIC :: ps_cdescr_LMHD = &
     'Linear MHD stability'
  CHARACTER*32, PARAMETER, PUBLIC :: ps_cname_NBI = 'NBI'
  CHARACTER*80, PARAMETER, PUBLIC :: ps_cdescr_NBI = &
     'Neutral beam'
  CHARACTER*32, PARAMETER, PUBLIC :: ps_cname_PEL = 'PEL'
  CHARACTER*80, PARAMETER, PUBLIC :: ps_cdescr_PEL = &
     'Pellet injection'
  CHARACTER*32, PARAMETER, PUBLIC :: ps_cname_PLASMA = 'PLASMA'
  CHARACTER*80, PARAMETER, PUBLIC :: ps_cdescr_PLASMA = &
     'Thermal plasma parameters; fluid profile advance'
  CHARACTER*32, PARAMETER, PUBLIC :: ps_cname_RAD = 'RAD'
  CHARACTER*80, PARAMETER, PUBLIC :: ps_cdescr_RAD = &
     'Radiated Power & impurity transport'
  CHARACTER*32, PARAMETER, PUBLIC :: ps_cname_RIPPLE = 'RIPPLE'
  CHARACTER*80, PARAMETER, PUBLIC :: ps_cdescr_RIPPLE = &
     'TF field ripple'
  CHARACTER*32, PARAMETER, PUBLIC :: ps_cname_RUNAWAY = 'RUNAWAY'
  CHARACTER*80, PARAMETER, PUBLIC :: ps_cdescr_RUNAWAY = &
     'Runaway electrons'

  ! INTEGER parameter number for each component:
  INTEGER, PARAMETER, PUBLIC :: ps_cnum_ANOM = 1
  INTEGER, PARAMETER, PUBLIC :: ps_cnum_EC = 2
  INTEGER, PARAMETER, PUBLIC :: ps_cnum_EQ = 3
  INTEGER, PARAMETER, PUBLIC :: ps_cnum_FUS = 4
  INTEGER, PARAMETER, PUBLIC :: ps_cnum_GAS = 5
  INTEGER, PARAMETER, PUBLIC :: ps_cnum_IC = 6
  INTEGER, PARAMETER, PUBLIC :: ps_cnum_LH = 7
  INTEGER, PARAMETER, PUBLIC :: ps_cnum_LMHD = 8
  INTEGER, PARAMETER, PUBLIC :: ps_cnum_NBI = 9
  INTEGER, PARAMETER, PUBLIC :: ps_cnum_PEL = 10
  INTEGER, PARAMETER, PUBLIC :: ps_cnum_PLASMA = 11
  INTEGER, PARAMETER, PUBLIC :: ps_cnum_RAD = 12
  INTEGER, PARAMETER, PUBLIC :: ps_cnum_RIPPLE = 13
  INTEGER, PARAMETER, PUBLIC :: ps_cnum_RUNAWAY = 14

  ! array of names for each component:
  CHARACTER*32, PARAMETER, DIMENSION(ps_ccount), PUBLIC :: ps_cnames = (/ &
       ps_cname_ANOM, &
       ps_cname_EC, &
       ps_cname_EQ, &
       ps_cname_FUS, &
       ps_cname_GAS, &
       ps_cname_IC, &
       ps_cname_LH, &
       ps_cname_LMHD, &
       ps_cname_NBI, &
       ps_cname_PEL, &
       ps_cname_PLASMA, &
       ps_cname_RAD, &
       ps_cname_RIPPLE, &
       ps_cname_RUNAWAY /)

  ! array of descriptions for each component:
  CHARACTER*80, PARAMETER, DIMENSION(ps_ccount), PUBLIC :: ps_cdescrs = (/ &
       ps_cdescr_ANOM, &
       ps_cdescr_EC, &
       ps_cdescr_EQ, &
       ps_cdescr_FUS, &
       ps_cdescr_GAS, &
       ps_cdescr_IC, &
       ps_cdescr_LH, &
       ps_cdescr_LMHD, &
       ps_cdescr_NBI, &
       ps_cdescr_PEL, &
       ps_cdescr_PLASMA, &
       ps_cdescr_RAD, &
       ps_cdescr_RIPPLE, &
       ps_cdescr_RUNAWAY /)

  INTEGER, PARAMETER, DIMENSION(ps_ccount), PUBLIC :: ps_cczero = &
       (/ 0,0,0,0,0,0,0,0,0,0,0,0,0,0 /)

  INTEGER, PARAMETER, DIMENSION(ps_ccount), PUBLIC :: ps_cc_all = &
       (/ 1,1,1,1,1,1,1,1,1,1,1,1,1,1 /)

  INTEGER, PARAMETER, DIMENSION(ps_ccount), PUBLIC :: ps_ndims = &
       (/ 7,2,10,2,4,7,3,5,6,1,7,3,2,1 /)

  ! coordinate information

  INTEGER, PARAMETER :: ps_coordCount = 6

  INTEGER, PARAMETER :: ps_coordNum_E = 1
  INTEGER, PARAMETER :: ps_coordNum_KY = 2
  INTEGER, PARAMETER :: ps_coordNum_R = 3
  INTEGER, PARAMETER :: ps_coordNum_RHO = 4
  INTEGER, PARAMETER :: ps_coordNum_TH = 5
  INTEGER, PARAMETER :: ps_coordNum_Z = 6

  CHARACTER*32, PARAMETER :: ps_coordName_E = "E"
  CHARACTER*32, PARAMETER :: ps_coordName_KY = "KY"
  CHARACTER*32, PARAMETER :: ps_coordName_R = "R"
  CHARACTER*32, PARAMETER :: ps_coordName_RHO = "RHO"
  CHARACTER*32, PARAMETER :: ps_coordName_TH = "TH"
  CHARACTER*32, PARAMETER :: ps_coordName_Z = "Z"

  INTEGER, PARAMETER, DIMENSION(ps_coordCount) :: ps_allCoords = (/ 1,1,1,1,1,1 /)
  INTEGER, PARAMETER, DIMENSION(ps_coordCount) :: ps_noCoords = (/ 0,0,0,0,0,0 /)

  CHARACTER*32, PARAMETER, DIMENSION(ps_coordCount) :: ps_coordNames = (/ &
       ps_coordName_E, &
       ps_coordName_KY, &
       ps_coordName_R, &
       ps_coordName_RHO, &
       ps_coordName_TH, &
       ps_coordName_Z /)

  ! hash addresses


  INTEGER, PARAMETER, PUBLIC :: ps_shash_machine_description = 1

  INTEGER, PARAMETER, PUBLIC :: ps_shash_Ang_Href_coil = 3
  INTEGER, PARAMETER, PUBLIC :: ps_shash_Ang_Vref_coil = 5
  INTEGER, PARAMETER, PUBLIC :: ps_shash_ant_model = 7
  INTEGER, PARAMETER, PUBLIC :: ps_shash_ap2_halfheight = 9
  INTEGER, PARAMETER, PUBLIC :: ps_shash_ap2_halfwidth = 11
  INTEGER, PARAMETER, PUBLIC :: ps_shash_ap2_horiz_offset = 13
  INTEGER, PARAMETER, PUBLIC :: ps_shash_ap2_vert_offset = 15
  INTEGER, PARAMETER, PUBLIC :: ps_shash_ap_halfheight = 17
  INTEGER, PARAMETER, PUBLIC :: ps_shash_ap_halfwidth = 19
  INTEGER, PARAMETER, PUBLIC :: ps_shash_ap_horiz_offset = 21
  INTEGER, PARAMETER, PUBLIC :: ps_shash_ap_vert_offset = 23
  INTEGER, PARAMETER, PUBLIC :: ps_shash_beam_type = 25
  INTEGER, PARAMETER, PUBLIC :: ps_shash_b_halfHeight = 27
  INTEGER, PARAMETER, PUBLIC :: ps_shash_b_halfwidth = 29
  INTEGER, PARAMETER, PUBLIC :: ps_shash_b_Hdivergence = 31
  INTEGER, PARAMETER, PUBLIC :: ps_shash_b_Hfocal_length = 33
  INTEGER, PARAMETER, PUBLIC :: ps_shash_b_Vdivergence = 35
  INTEGER, PARAMETER, PUBLIC :: ps_shash_b_Vfocal_length = 37
  INTEGER, PARAMETER, PUBLIC :: ps_shash_coil_in_circuit = 39
  INTEGER, PARAMETER, PUBLIC :: ps_shash_coil_resispt = 41
  INTEGER, PARAMETER, PUBLIC :: ps_shash_dx_fshield = 43
  INTEGER, PARAMETER, PUBLIC :: ps_shash_D_einj_standard = 45
  INTEGER, PARAMETER, PUBLIC :: ps_shash_D_ffull_standard = 47
  INTEGER, PARAMETER, PUBLIC :: ps_shash_D_fhalf_standard = 49
  INTEGER, PARAMETER, PUBLIC :: ps_shash_EC_Beam_Elongation = 51
  INTEGER, PARAMETER, PUBLIC :: ps_shash_EC_Half_Power_Angle = 53
  INTEGER, PARAMETER, PUBLIC :: ps_shash_EC_PRINC_CURV_HOR = 55
  INTEGER, PARAMETER, PUBLIC :: ps_shash_EC_PRINC_CURV_VERT = 57
  INTEGER, PARAMETER, PUBLIC :: ps_shash_EC_PRINC_WIDTH_HOR = 59
  INTEGER, PARAMETER, PUBLIC :: ps_shash_EC_PRINC_WIDTH_VERT = 61
  INTEGER, PARAMETER, PUBLIC :: ps_shash_Einj_max = 63
  INTEGER, PARAMETER, PUBLIC :: ps_shash_Einj_min = 65
  INTEGER, PARAMETER, PUBLIC :: ps_shash_geometry = 67
  INTEGER, PARAMETER, PUBLIC :: ps_shash_Hsize_coil = 69
  INTEGER, PARAMETER, PUBLIC :: ps_shash_H_einj_standard = 71
  INTEGER, PARAMETER, PUBLIC :: ps_shash_H_ffull_standard = 73
  INTEGER, PARAMETER, PUBLIC :: ps_shash_H_fhalf_standard = 75
  INTEGER, PARAMETER, PUBLIC :: ps_shash_Lbscap = 77
  INTEGER, PARAMETER, PUBLIC :: ps_shash_Lbscap2 = 79
  INTEGER, PARAMETER, PUBLIC :: ps_shash_Lbsctan = 81
  INTEGER, PARAMETER, PUBLIC :: ps_shash_nbap2_shape = 83
  INTEGER, PARAMETER, PUBLIC :: ps_shash_nbap_shape = 85
  INTEGER, PARAMETER, PUBLIC :: ps_shash_nbshape = 87
  INTEGER, PARAMETER, PUBLIC :: ps_shash_nrz_antgeo = 89
  INTEGER, PARAMETER, PUBLIC :: ps_shash_ntf_coil2 = 91
  INTEGER, PARAMETER, PUBLIC :: ps_shash_ntf_coils = 93
  INTEGER, PARAMETER, PUBLIC :: ps_shash_Nturns = 95
  INTEGER, PARAMETER, PUBLIC :: ps_shash_Phibsc = 97
  INTEGER, PARAMETER, PUBLIC :: ps_shash_Phi_EC_launch = 99
  INTEGER, PARAMETER, PUBLIC :: ps_shash_rlim = 101
  INTEGER, PARAMETER, PUBLIC :: ps_shash_Rloc_coil = 103
  INTEGER, PARAMETER, PUBLIC :: ps_shash_R_antgeo = 105
  INTEGER, PARAMETER, PUBLIC :: ps_shash_R_EC_launch = 107
  INTEGER, PARAMETER, PUBLIC :: ps_shash_R_max_box = 109
  INTEGER, PARAMETER, PUBLIC :: ps_shash_R_min_box = 111
  INTEGER, PARAMETER, PUBLIC :: ps_shash_sRtcen = 113
  INTEGER, PARAMETER, PUBLIC :: ps_shash_tokamak_id = 115
  INTEGER, PARAMETER, PUBLIC :: ps_shash_T_einj_standard = 117
  INTEGER, PARAMETER, PUBLIC :: ps_shash_T_ffull_standard = 119
  INTEGER, PARAMETER, PUBLIC :: ps_shash_T_fhalf_standard = 121
  INTEGER, PARAMETER, PUBLIC :: ps_shash_VRep_coil_count = 123
  INTEGER, PARAMETER, PUBLIC :: ps_shash_Vrep_coil_spacing = 125
  INTEGER, PARAMETER, PUBLIC :: ps_shash_Vsize_coil = 127
  INTEGER, PARAMETER, PUBLIC :: ps_shash_Zbap = 129
  INTEGER, PARAMETER, PUBLIC :: ps_shash_Zbsc = 131
  INTEGER, PARAMETER, PUBLIC :: ps_shash_zlim = 133
  INTEGER, PARAMETER, PUBLIC :: ps_shash_Zloc_coil = 135
  INTEGER, PARAMETER, PUBLIC :: ps_shash_Z_antgeo = 137
  INTEGER, PARAMETER, PUBLIC :: ps_shash_Z_EC_launch = 139
  INTEGER, PARAMETER, PUBLIC :: ps_shash_Z_max_box = 141
  INTEGER, PARAMETER, PUBLIC :: ps_shash_Z_min_box = 143

  INTEGER, PARAMETER, PUBLIC :: ps_shash_shot_configuration = 145

  INTEGER, PARAMETER, PUBLIC :: ps_shash_amaxlh = 147
  INTEGER, PARAMETER, PUBLIC :: ps_shash_aminlh = 149
  INTEGER, PARAMETER, PUBLIC :: ps_shash_apolmaxlh = 151
  INTEGER, PARAMETER, PUBLIC :: ps_shash_apolminlh = 153
  INTEGER, PARAMETER, PUBLIC :: ps_shash_atormaxlh = 155
  INTEGER, PARAMETER, PUBLIC :: ps_shash_atorminlh = 157
  INTEGER, PARAMETER, PUBLIC :: ps_shash_EC_Omode_Fraction = 159
  INTEGER, PARAMETER, PUBLIC :: ps_shash_EC_phi_aim = 161
  INTEGER, PARAMETER, PUBLIC :: ps_shash_EC_theta_aim = 163
  INTEGER, PARAMETER, PUBLIC :: ps_shash_fracpslh = 165
  INTEGER, PARAMETER, PUBLIC :: ps_shash_freq_ec = 167
  INTEGER, PARAMETER, PUBLIC :: ps_shash_freq_ic = 169
  INTEGER, PARAMETER, PUBLIC :: ps_shash_freq_lh = 171
  INTEGER, PARAMETER, PUBLIC :: ps_shash_gas_atom = 173
  INTEGER, PARAMETER, PUBLIC :: ps_shash_hegrilh = 175
  INTEGER, PARAMETER, PUBLIC :: ps_shash_Imag_ant_coef = 177
  INTEGER, PARAMETER, PUBLIC :: ps_shash_is_recycling = 179
  INTEGER, PARAMETER, PUBLIC :: ps_shash_i_npoloidal = 181
  INTEGER, PARAMETER, PUBLIC :: ps_shash_kccw_Bphi = 183
  INTEGER, PARAMETER, PUBLIC :: ps_shash_kccw_Jphi = 185
  INTEGER, PARAMETER, PUBLIC :: ps_shash_nbion = 187
  INTEGER, PARAMETER, PUBLIC :: ps_shash_nbion_trace = 189
  INTEGER, PARAMETER, PUBLIC :: ps_shash_nnkparlh = 191
  INTEGER, PARAMETER, PUBLIC :: ps_shash_nnkpollh = 193
  INTEGER, PARAMETER, PUBLIC :: ps_shash_nnktorlh = 195
  INTEGER, PARAMETER, PUBLIC :: ps_shash_nphi = 197
  INTEGER, PARAMETER, PUBLIC :: ps_shash_nspectrumlh_src = 199
  INTEGER, PARAMETER, PUBLIC :: ps_shash_nthinlh = 201
  INTEGER, PARAMETER, PUBLIC :: ps_shash_num_nphi = 203
  INTEGER, PARAMETER, PUBLIC :: ps_shash_num_nphi_vac = 205
  INTEGER, PARAMETER, PUBLIC :: ps_shash_n_straps = 207
  INTEGER, PARAMETER, PUBLIC :: ps_shash_phigrilh = 209
  INTEGER, PARAMETER, PUBLIC :: ps_shash_Real_ant_coef = 211
  INTEGER, PARAMETER, PUBLIC :: ps_shash_rhopsi0lh = 213
  INTEGER, PARAMETER, PUBLIC :: ps_shash_R_ant = 215
  INTEGER, PARAMETER, PUBLIC :: ps_shash_shot_number = 217
  INTEGER, PARAMETER, PUBLIC :: ps_shash_thegrilh = 219
  INTEGER, PARAMETER, PUBLIC :: ps_shash_wt_nphi = 221
  INTEGER, PARAMETER, PUBLIC :: ps_shash_Z_ant = 223
  INTEGER, PARAMETER, PUBLIC :: ps_shash_Z_mid_ant = 225

  INTEGER, PARAMETER, PUBLIC :: ps_shash_simulation_init = 227

  INTEGER, PARAMETER, PUBLIC :: ps_shash_alla_index = 229
  INTEGER, PARAMETER, PUBLIC :: ps_shash_all_index = 231
  INTEGER, PARAMETER, PUBLIC :: ps_shash_ANOM_Code_Info = 233
  INTEGER, PARAMETER, PUBLIC :: ps_shash_Balloon_mapper = 235
  INTEGER, PARAMETER, PUBLIC :: ps_shash_CUR_Data_Info = 237
  INTEGER, PARAMETER, PUBLIC :: ps_shash_DeltaW_mapper = 239
  INTEGER, PARAMETER, PUBLIC :: ps_shash_EC_Code_Info = 241
  INTEGER, PARAMETER, PUBLIC :: ps_shash_EC_Data_Info = 243
  INTEGER, PARAMETER, PUBLIC :: ps_shash_EQ_Code_Info = 245
  INTEGER, PARAMETER, PUBLIC :: ps_shash_EQ_Data_Info = 247
  INTEGER, PARAMETER, PUBLIC :: ps_shash_fracmin = 249
  INTEGER, PARAMETER, PUBLIC :: ps_shash_FUS_Code_Info = 251
  INTEGER, PARAMETER, PUBLIC :: ps_shash_GAS_Code_Info = 253
  INTEGER, PARAMETER, PUBLIC :: ps_shash_Global_label = 255
  INTEGER, PARAMETER, PUBLIC :: ps_shash_icircuit_coil = 257
  INTEGER, PARAMETER, PUBLIC :: ps_shash_IC_Code_Info = 259
  INTEGER, PARAMETER, PUBLIC :: ps_shash_IC_Data_Info = 261
  INTEGER, PARAMETER, PUBLIC :: ps_shash_kdens_rfmin = 263
  INTEGER, PARAMETER, PUBLIC :: ps_shash_LH_Code_Info = 265
  INTEGER, PARAMETER, PUBLIC :: ps_shash_LH_Data_Info = 267
  INTEGER, PARAMETER, PUBLIC :: ps_shash_LMHD_eq_code = 269
  INTEGER, PARAMETER, PUBLIC :: ps_shash_NBI_Code_Info = 271
  INTEGER, PARAMETER, PUBLIC :: ps_shash_NBI_Data_Info = 273
  INTEGER, PARAMETER, PUBLIC :: ps_shash_Newcomb_mapper = 275
  INTEGER, PARAMETER, PUBLIC :: ps_shash_nmom = 277
  INTEGER, PARAMETER, PUBLIC :: ps_shash_ns_Data_Info = 279
  INTEGER, PARAMETER, PUBLIC :: ps_shash_PEL_Code_Info = 281
  INTEGER, PARAMETER, PUBLIC :: ps_shash_PEL_Data_Info = 283
  INTEGER, PARAMETER, PUBLIC :: ps_shash_PLASMA_Code_Info = 285
  INTEGER, PARAMETER, PUBLIC :: ps_shash_RAD_Code_Info = 287
  INTEGER, PARAMETER, PUBLIC :: ps_shash_RAD_Data_Info = 289
  INTEGER, PARAMETER, PUBLIC :: ps_shash_rfmin_to_all = 291
  INTEGER, PARAMETER, PUBLIC :: ps_shash_rfmin_to_alla = 293
  INTEGER, PARAMETER, PUBLIC :: ps_shash_RUNAWAY_Code_Info = 295
  INTEGER, PARAMETER, PUBLIC :: ps_shash_RunID = 297
  INTEGER, PARAMETER, PUBLIC :: ps_shash_sa_index = 299
  INTEGER, PARAMETER, PUBLIC :: ps_shash_sc0_to_sgas = 301
  INTEGER, PARAMETER, PUBLIC :: ps_shash_sfus_to_all = 303
  INTEGER, PARAMETER, PUBLIC :: ps_shash_sfus_to_alla = 305
  INTEGER, PARAMETER, PUBLIC :: ps_shash_sgas_to_s = 307
  INTEGER, PARAMETER, PUBLIC :: ps_shash_simp0_to_s = 309
  INTEGER, PARAMETER, PUBLIC :: ps_shash_simpi_to_s = 311
  INTEGER, PARAMETER, PUBLIC :: ps_shash_snbi_to_all = 313
  INTEGER, PARAMETER, PUBLIC :: ps_shash_snbi_to_alla = 315
  INTEGER, PARAMETER, PUBLIC :: ps_shash_s_to_sa = 317
  INTEGER, PARAMETER, PUBLIC :: ps_shash_tfinal = 319
  INTEGER, PARAMETER, PUBLIC :: ps_shash_TF_Data_Info = 321
  INTEGER, PARAMETER, PUBLIC :: ps_shash_tinit = 323
  INTEGER, PARAMETER, PUBLIC :: ps_shash_Tor_mode_No = 325
  INTEGER, PARAMETER, PUBLIC :: ps_shash_trace_flag = 327
  INTEGER, PARAMETER, PUBLIC :: ps_shash_trmodels = 329
  INTEGER, PARAMETER, PUBLIC :: ps_shash_Ts_Data_Info = 331
  INTEGER, PARAMETER, PUBLIC :: ps_shash_vpol_Data_Info = 333
  INTEGER, PARAMETER, PUBLIC :: ps_shash_VSUR_Data_Info = 335
  INTEGER, PARAMETER, PUBLIC :: ps_shash_vtor_Data_Info = 337
  INTEGER, PARAMETER, PUBLIC :: ps_shash_Z0max = 339
  INTEGER, PARAMETER, PUBLIC :: ps_shash_ZEFF_Data_Info = 341
  INTEGER, PARAMETER, PUBLIC :: ps_shash_Zimp1 = 343
  INTEGER, PARAMETER, PUBLIC :: ps_shash_Zimp2 = 345

  INTEGER, PARAMETER, PUBLIC :: ps_shash_state_data = 347

  INTEGER, PARAMETER, PUBLIC :: ps_shash_Balloon_stable = 349
  INTEGER, PARAMETER, PUBLIC :: ps_shash_Balloon_status = 351
  INTEGER, PARAMETER, PUBLIC :: ps_shash_B_axis = 353
  INTEGER, PARAMETER, PUBLIC :: ps_shash_B_axis_vac = 355
  INTEGER, PARAMETER, PUBLIC :: ps_shash_B_max_lcfs = 357
  INTEGER, PARAMETER, PUBLIC :: ps_shash_B_min_lcfs = 359
  INTEGER, PARAMETER, PUBLIC :: ps_shash_coil_apt = 361
  INTEGER, PARAMETER, PUBLIC :: ps_shash_DeltaW_stable = 363
  INTEGER, PARAMETER, PUBLIC :: ps_shash_DeltaW_status = 365
  INTEGER, PARAMETER, PUBLIC :: ps_shash_dist_fun = 367
  INTEGER, PARAMETER, PUBLIC :: ps_shash_dn0out = 369
  INTEGER, PARAMETER, PUBLIC :: ps_shash_e0_av = 371
  INTEGER, PARAMETER, PUBLIC :: ps_shash_eldot = 373
  INTEGER, PARAMETER, PUBLIC :: ps_shash_eqdsk_file = 375
  INTEGER, PARAMETER, PUBLIC :: ps_shash_frac_full = 377
  INTEGER, PARAMETER, PUBLIC :: ps_shash_frac_half = 379
  INTEGER, PARAMETER, PUBLIC :: ps_shash_gamma_lmhd = 381
  INTEGER, PARAMETER, PUBLIC :: ps_shash_isThermal = 383
  INTEGER, PARAMETER, PUBLIC :: ps_shash_kvolt_nbi = 385
  INTEGER, PARAMETER, PUBLIC :: ps_shash_LMHD_status = 387
  INTEGER, PARAMETER, PUBLIC :: ps_shash_lock_machine_descr = 389
  INTEGER, PARAMETER, PUBLIC :: ps_shash_lock_shot_config = 391
  INTEGER, PARAMETER, PUBLIC :: ps_shash_lock_sim_init = 393
  INTEGER, PARAMETER, PUBLIC :: ps_shash_Mercier_stable = 395
  INTEGER, PARAMETER, PUBLIC :: ps_shash_MHD_eq_status = 397
  INTEGER, PARAMETER, PUBLIC :: ps_shash_nbeami_bdy = 399
  INTEGER, PARAMETER, PUBLIC :: ps_shash_nebar = 401
  INTEGER, PARAMETER, PUBLIC :: ps_shash_Newcomb_stable = 403
  INTEGER, PARAMETER, PUBLIC :: ps_shash_Newcomb_status = 405
  INTEGER, PARAMETER, PUBLIC :: ps_shash_nfusi_bdy = 407
  INTEGER, PARAMETER, PUBLIC :: ps_shash_nmdifb = 409
  INTEGER, PARAMETER, PUBLIC :: ps_shash_nmini_bdy = 411
  INTEGER, PARAMETER, PUBLIC :: ps_shash_nmodel_bdy = 413
  INTEGER, PARAMETER, PUBLIC :: ps_shash_ns_bdy = 415
  INTEGER, PARAMETER, PUBLIC :: ps_shash_ns_is_input = 417
  INTEGER, PARAMETER, PUBLIC :: ps_shash_omegat_bdy = 419
  INTEGER, PARAMETER, PUBLIC :: ps_shash_picrf_abs = 421
  INTEGER, PARAMETER, PUBLIC :: ps_shash_picrf_ext = 423
  INTEGER, PARAMETER, PUBLIC :: ps_shash_power_ec = 425
  INTEGER, PARAMETER, PUBLIC :: ps_shash_power_ic = 427
  INTEGER, PARAMETER, PUBLIC :: ps_shash_power_lh = 429
  INTEGER, PARAMETER, PUBLIC :: ps_shash_power_nbi = 431
  INTEGER, PARAMETER, PUBLIC :: ps_shash_power_nbi_trace = 433
  INTEGER, PARAMETER, PUBLIC :: ps_shash_Psi_to_machine_axis = 435
  INTEGER, PARAMETER, PUBLIC :: ps_shash_ql_operator = 437
  INTEGER, PARAMETER, PUBLIC :: ps_shash_rho_bdy_ns = 439
  INTEGER, PARAMETER, PUBLIC :: ps_shash_rho_bdy_omegat = 441
  INTEGER, PARAMETER, PUBLIC :: ps_shash_rho_bdy_Te = 443
  INTEGER, PARAMETER, PUBLIC :: ps_shash_rho_bdy_Ti = 445
  INTEGER, PARAMETER, PUBLIC :: ps_shash_R_axis = 447
  INTEGER, PARAMETER, PUBLIC :: ps_shash_R_max_lcfs = 449
  INTEGER, PARAMETER, PUBLIC :: ps_shash_R_min_lcfs = 451
  INTEGER, PARAMETER, PUBLIC :: ps_shash_sc0 = 453
  INTEGER, PARAMETER, PUBLIC :: ps_shash_t0 = 455
  INTEGER, PARAMETER, PUBLIC :: ps_shash_t1 = 457
  INTEGER, PARAMETER, PUBLIC :: ps_shash_Te_bdy = 459
  INTEGER, PARAMETER, PUBLIC :: ps_shash_Ti_bdy = 461
  INTEGER, PARAMETER, PUBLIC :: ps_shash_tmodel_bdy = 463
  INTEGER, PARAMETER, PUBLIC :: ps_shash_Tornum_balcrit = 465
  INTEGER, PARAMETER, PUBLIC :: ps_shash_Ts_is_input = 467
  INTEGER, PARAMETER, PUBLIC :: ps_shash_vphi0_av = 469
  INTEGER, PARAMETER, PUBLIC :: ps_shash_vpol_is_input = 471
  INTEGER, PARAMETER, PUBLIC :: ps_shash_vsur = 473
  INTEGER, PARAMETER, PUBLIC :: ps_shash_vtor_is_input = 475
  INTEGER, PARAMETER, PUBLIC :: ps_shash_wt_nphi_abs = 477
  INTEGER, PARAMETER, PUBLIC :: ps_shash_wt_nphi_ext = 479
  INTEGER, PARAMETER, PUBLIC :: ps_shash_xs = 481
  INTEGER, PARAMETER, PUBLIC :: ps_shash_Z_axis = 483
  INTEGER, PARAMETER, PUBLIC :: ps_shash_Z_max_lcfs = 485
  INTEGER, PARAMETER, PUBLIC :: ps_shash_Z_min_lcfs = 487

  INTEGER, PARAMETER, PUBLIC :: ps_shash_state_profiles = 489


  INTEGER, PARAMETER, PUBLIC :: ps_dhash_max_nrz_antgeo = 491
  INTEGER, PARAMETER, PUBLIC :: ps_dhash_max_nspectrumlh_src = 493
  INTEGER, PARAMETER, PUBLIC :: ps_dhash_max_num_nphi = 495
  INTEGER, PARAMETER, PUBLIC :: ps_dhash_max_num_nphi_vac = 497
  INTEGER, PARAMETER, PUBLIC :: ps_dhash_max_n_straps = 499
  INTEGER, PARAMETER, PUBLIC :: ps_dhash_mmodes = 501
  INTEGER, PARAMETER, PUBLIC :: ps_dhash_nballoon = 503
  INTEGER, PARAMETER, PUBLIC :: ps_dhash_nbeam = 505
  INTEGER, PARAMETER, PUBLIC :: ps_dhash_ncircuits = 507
  INTEGER, PARAMETER, PUBLIC :: ps_dhash_ncoils = 509
  INTEGER, PARAMETER, PUBLIC :: ps_dhash_ndelta_w = 511
  INTEGER, PARAMETER, PUBLIC :: ps_dhash_necrf_src = 513
  INTEGER, PARAMETER, PUBLIC :: ps_dhash_nefi_anom = 515
  INTEGER, PARAMETER, PUBLIC :: ps_dhash_nefi_anom2 = 517
  INTEGER, PARAMETER, PUBLIC :: ps_dhash_neqmom = 519
  INTEGER, PARAMETER, PUBLIC :: ps_dhash_ngsc0 = 521
  INTEGER, PARAMETER, PUBLIC :: ps_dhash_nicrf_src = 523
  INTEGER, PARAMETER, PUBLIC :: ps_dhash_nky_anomth = 525
  INTEGER, PARAMETER, PUBLIC :: ps_dhash_nky_mmm = 527
  INTEGER, PARAMETER, PUBLIC :: ps_dhash_nlhrf_src = 529
  INTEGER, PARAMETER, PUBLIC :: ps_dhash_nnewcomb = 531
  INTEGER, PARAMETER, PUBLIC :: ps_dhash_npsmom = 533
  INTEGER, PARAMETER, PUBLIC :: ps_dhash_nr = 535
  INTEGER, PARAMETER, PUBLIC :: ps_dhash_nrho = 537
  INTEGER, PARAMETER, PUBLIC :: ps_dhash_nrho_anom = 539
  INTEGER, PARAMETER, PUBLIC :: ps_dhash_nrho_anom2 = 541
  INTEGER, PARAMETER, PUBLIC :: ps_dhash_nrho_anomth = 543
  INTEGER, PARAMETER, PUBLIC :: ps_dhash_nrho_ecrf = 545
  INTEGER, PARAMETER, PUBLIC :: ps_dhash_nrho_eq = 547
  INTEGER, PARAMETER, PUBLIC :: ps_dhash_nrho_eq_geo = 549
  INTEGER, PARAMETER, PUBLIC :: ps_dhash_nrho_fus = 551
  INTEGER, PARAMETER, PUBLIC :: ps_dhash_nrho_gas = 553
  INTEGER, PARAMETER, PUBLIC :: ps_dhash_nrho_icrf = 555
  INTEGER, PARAMETER, PUBLIC :: ps_dhash_nrho_lhrf = 557
  INTEGER, PARAMETER, PUBLIC :: ps_dhash_nrho_lmhd = 559
  INTEGER, PARAMETER, PUBLIC :: ps_dhash_nrho_mist = 561
  INTEGER, PARAMETER, PUBLIC :: ps_dhash_nrho_nbi = 563
  INTEGER, PARAMETER, PUBLIC :: ps_dhash_nrho_pel = 565
  INTEGER, PARAMETER, PUBLIC :: ps_dhash_nrho_rad = 567
  INTEGER, PARAMETER, PUBLIC :: ps_dhash_nrho_rw = 569
  INTEGER, PARAMETER, PUBLIC :: ps_dhash_nr_rip = 571
  INTEGER, PARAMETER, PUBLIC :: ps_dhash_nspec_all = 573
  INTEGER, PARAMETER, PUBLIC :: ps_dhash_nspec_alla = 575
  INTEGER, PARAMETER, PUBLIC :: ps_dhash_nspec_beam = 577
  INTEGER, PARAMETER, PUBLIC :: ps_dhash_nspec_fusion = 579
  INTEGER, PARAMETER, PUBLIC :: ps_dhash_nspec_gas = 581
  INTEGER, PARAMETER, PUBLIC :: ps_dhash_nspec_imp0 = 583
  INTEGER, PARAMETER, PUBLIC :: ps_dhash_nspec_impi = 585
  INTEGER, PARAMETER, PUBLIC :: ps_dhash_nspec_rfmin = 587
  INTEGER, PARAMETER, PUBLIC :: ps_dhash_nspec_th = 589
  INTEGER, PARAMETER, PUBLIC :: ps_dhash_nspec_tha = 591
  INTEGER, PARAMETER, PUBLIC :: ps_dhash_nth_eq = 593
  INTEGER, PARAMETER, PUBLIC :: ps_dhash_ntrcat = 595
  INTEGER, PARAMETER, PUBLIC :: ps_dhash_num_rzlim = 597
  INTEGER, PARAMETER, PUBLIC :: ps_dhash_nxs = 599
  INTEGER, PARAMETER, PUBLIC :: ps_dhash_nz = 601
  INTEGER, PARAMETER, PUBLIC :: ps_dhash_nz_rip = 603
  INTEGER, PARAMETER, PUBLIC :: ps_dhash_n_d_einj_standard = 605
  INTEGER, PARAMETER, PUBLIC :: ps_dhash_n_h_einj_standard = 607
  INTEGER, PARAMETER, PUBLIC :: ps_dhash_n_t_einj_standard = 609

  INTEGER, PARAMETER, PUBLIC :: ps_phash_anom_evar = 611
  INTEGER, PARAMETER, PUBLIC :: ps_phash_area = 613
  INTEGER, PARAMETER, PUBLIC :: ps_phash_balstab = 615
  INTEGER, PARAMETER, PUBLIC :: ps_phash_bidiff_bpass_co = 617
  INTEGER, PARAMETER, PUBLIC :: ps_phash_bidiff_bpass_ctr = 619
  INTEGER, PARAMETER, PUBLIC :: ps_phash_bidiff_btrap = 621
  INTEGER, PARAMETER, PUBLIC :: ps_phash_bidiff_dpass_co = 623
  INTEGER, PARAMETER, PUBLIC :: ps_phash_bidiff_dpass_ctr = 625
  INTEGER, PARAMETER, PUBLIC :: ps_phash_bidiff_dtrap = 627
  INTEGER, PARAMETER, PUBLIC :: ps_phash_bphirz = 629
  INTEGER, PARAMETER, PUBLIC :: ps_phash_brrz = 631
  INTEGER, PARAMETER, PUBLIC :: ps_phash_bzrz = 633
  INTEGER, PARAMETER, PUBLIC :: ps_phash_b_surfmax = 635
  INTEGER, PARAMETER, PUBLIC :: ps_phash_b_surfmin = 637
  INTEGER, PARAMETER, PUBLIC :: ps_phash_cdicrf = 639
  INTEGER, PARAMETER, PUBLIC :: ps_phash_cdicrf_nphi = 641
  INTEGER, PARAMETER, PUBLIC :: ps_phash_chie_anom = 643
  INTEGER, PARAMETER, PUBLIC :: ps_phash_chie_drbm = 645
  INTEGER, PARAMETER, PUBLIC :: ps_phash_chie_etg = 647
  INTEGER, PARAMETER, PUBLIC :: ps_phash_chie_glf = 649
  INTEGER, PARAMETER, PUBLIC :: ps_phash_chie_gtcneo = 651
  INTEGER, PARAMETER, PUBLIC :: ps_phash_chie_mmm71 = 653
  INTEGER, PARAMETER, PUBLIC :: ps_phash_chie_mtm = 655
  INTEGER, PARAMETER, PUBLIC :: ps_phash_chie_nclass = 657
  INTEGER, PARAMETER, PUBLIC :: ps_phash_chie_neo = 659
  INTEGER, PARAMETER, PUBLIC :: ps_phash_chie_ntm = 661
  INTEGER, PARAMETER, PUBLIC :: ps_phash_chie_paleo = 663
  INTEGER, PARAMETER, PUBLIC :: ps_phash_chie_tglf = 665
  INTEGER, PARAMETER, PUBLIC :: ps_phash_chie_trans = 667
  INTEGER, PARAMETER, PUBLIC :: ps_phash_chie_transcat = 669
  INTEGER, PARAMETER, PUBLIC :: ps_phash_chie_w19 = 671
  INTEGER, PARAMETER, PUBLIC :: ps_phash_chii_anom = 673
  INTEGER, PARAMETER, PUBLIC :: ps_phash_chii_drbm = 675
  INTEGER, PARAMETER, PUBLIC :: ps_phash_chii_glf = 677
  INTEGER, PARAMETER, PUBLIC :: ps_phash_chii_gtcneo = 679
  INTEGER, PARAMETER, PUBLIC :: ps_phash_chii_mmm71 = 681
  INTEGER, PARAMETER, PUBLIC :: ps_phash_chii_nclass = 683
  INTEGER, PARAMETER, PUBLIC :: ps_phash_chii_neo = 685
  INTEGER, PARAMETER, PUBLIC :: ps_phash_chii_ntm = 687
  INTEGER, PARAMETER, PUBLIC :: ps_phash_chii_tglf = 689
  INTEGER, PARAMETER, PUBLIC :: ps_phash_chii_trans = 691
  INTEGER, PARAMETER, PUBLIC :: ps_phash_chii_transcat = 693
  INTEGER, PARAMETER, PUBLIC :: ps_phash_chii_w19 = 695
  INTEGER, PARAMETER, PUBLIC :: ps_phash_chimo_trans = 697
  INTEGER, PARAMETER, PUBLIC :: ps_phash_chimo_transcat = 699
  INTEGER, PARAMETER, PUBLIC :: ps_phash_chiphi_anom = 701
  INTEGER, PARAMETER, PUBLIC :: ps_phash_chiphi_drbm = 703
  INTEGER, PARAMETER, PUBLIC :: ps_phash_chiphi_glf = 705
  INTEGER, PARAMETER, PUBLIC :: ps_phash_chiphi_gtcneo = 707
  INTEGER, PARAMETER, PUBLIC :: ps_phash_chiphi_mmm71 = 709
  INTEGER, PARAMETER, PUBLIC :: ps_phash_chiphi_neo = 711
  INTEGER, PARAMETER, PUBLIC :: ps_phash_chiphi_tglf = 713
  INTEGER, PARAMETER, PUBLIC :: ps_phash_chiphi_w19 = 715
  INTEGER, PARAMETER, PUBLIC :: ps_phash_chitheta_mmm71 = 717
  INTEGER, PARAMETER, PUBLIC :: ps_phash_curbeam = 719
  INTEGER, PARAMETER, PUBLIC :: ps_phash_curech = 721
  INTEGER, PARAMETER, PUBLIC :: ps_phash_curech_src = 723
  INTEGER, PARAMETER, PUBLIC :: ps_phash_curfusn = 725
  INTEGER, PARAMETER, PUBLIC :: ps_phash_curich = 727
  INTEGER, PARAMETER, PUBLIC :: ps_phash_curlh = 729
  INTEGER, PARAMETER, PUBLIC :: ps_phash_curlh_src = 731
  INTEGER, PARAMETER, PUBLIC :: ps_phash_curmino = 733
  INTEGER, PARAMETER, PUBLIC :: ps_phash_curr_bootstrap = 735
  INTEGER, PARAMETER, PUBLIC :: ps_phash_curr_ohmic = 737
  INTEGER, PARAMETER, PUBLIC :: ps_phash_curt = 739
  INTEGER, PARAMETER, PUBLIC :: ps_phash_cur_rw = 741
  INTEGER, PARAMETER, PUBLIC :: ps_phash_d2r_geo_drhodth = 743
  INTEGER, PARAMETER, PUBLIC :: ps_phash_d2z_geo_drhodth = 745
  INTEGER, PARAMETER, PUBLIC :: ps_phash_db_mtm = 747
  INTEGER, PARAMETER, PUBLIC :: ps_phash_dcur_rw_dvloop = 749
  INTEGER, PARAMETER, PUBLIC :: ps_phash_difb_fusi = 751
  INTEGER, PARAMETER, PUBLIC :: ps_phash_difb_nbi = 753
  INTEGER, PARAMETER, PUBLIC :: ps_phash_difb_rfmi = 755
  INTEGER, PARAMETER, PUBLIC :: ps_phash_diff_trans = 757
  INTEGER, PARAMETER, PUBLIC :: ps_phash_diff_transcat = 759
  INTEGER, PARAMETER, PUBLIC :: ps_phash_difne_nclass = 761
  INTEGER, PARAMETER, PUBLIC :: ps_phash_difnh_nclass = 763
  INTEGER, PARAMETER, PUBLIC :: ps_phash_difns_anom = 765
  INTEGER, PARAMETER, PUBLIC :: ps_phash_difns_drbm = 767
  INTEGER, PARAMETER, PUBLIC :: ps_phash_difns_glf = 769
  INTEGER, PARAMETER, PUBLIC :: ps_phash_difns_gtcneo = 771
  INTEGER, PARAMETER, PUBLIC :: ps_phash_difns_mmm71 = 773
  INTEGER, PARAMETER, PUBLIC :: ps_phash_difns_nclass = 775
  INTEGER, PARAMETER, PUBLIC :: ps_phash_difns_neo = 777
  INTEGER, PARAMETER, PUBLIC :: ps_phash_difns_tglf = 779
  INTEGER, PARAMETER, PUBLIC :: ps_phash_difns_w19 = 781
  INTEGER, PARAMETER, PUBLIC :: ps_phash_difnx_nclass = 783
  INTEGER, PARAMETER, PUBLIC :: ps_phash_difnz_mmm71 = 785
  INTEGER, PARAMETER, PUBLIC :: ps_phash_dqedgrdte_tglf = 787
  INTEGER, PARAMETER, PUBLIC :: ps_phash_dqedgrdti_tglf = 789
  INTEGER, PARAMETER, PUBLIC :: ps_phash_dqidgrdte_tglf = 791
  INTEGER, PARAMETER, PUBLIC :: ps_phash_dqidgrdti_tglf = 793
  INTEGER, PARAMETER, PUBLIC :: ps_phash_dr0_momeq_drho = 795
  INTEGER, PARAMETER, PUBLIC :: ps_phash_dr_geo_drho = 797
  INTEGER, PARAMETER, PUBLIC :: ps_phash_dr_geo_dth = 799
  INTEGER, PARAMETER, PUBLIC :: ps_phash_dxrjcos_momeq_drho = 801
  INTEGER, PARAMETER, PUBLIC :: ps_phash_dxrjsin_momeq_drho = 803
  INTEGER, PARAMETER, PUBLIC :: ps_phash_dxzjcos_momeq_drho = 805
  INTEGER, PARAMETER, PUBLIC :: ps_phash_dxzjsin_momeq_drho = 807
  INTEGER, PARAMETER, PUBLIC :: ps_phash_dz0_momeq_drho = 809
  INTEGER, PARAMETER, PUBLIC :: ps_phash_dz_geo_drho = 811
  INTEGER, PARAMETER, PUBLIC :: ps_phash_dz_geo_dth = 813
  INTEGER, PARAMETER, PUBLIC :: ps_phash_ee_mobility_factor = 815
  INTEGER, PARAMETER, PUBLIC :: ps_phash_elong = 817
  INTEGER, PARAMETER, PUBLIC :: ps_phash_eperp_beami = 819
  INTEGER, PARAMETER, PUBLIC :: ps_phash_eperp_fusi = 821
  INTEGER, PARAMETER, PUBLIC :: ps_phash_eperp_mini = 823
  INTEGER, PARAMETER, PUBLIC :: ps_phash_eperp_rw = 825
  INTEGER, PARAMETER, PUBLIC :: ps_phash_epll_beami = 827
  INTEGER, PARAMETER, PUBLIC :: ps_phash_epll_fusi = 829
  INTEGER, PARAMETER, PUBLIC :: ps_phash_epll_mini = 831
  INTEGER, PARAMETER, PUBLIC :: ps_phash_epll_rw = 833
  INTEGER, PARAMETER, PUBLIC :: ps_phash_epot = 835
  INTEGER, PARAMETER, PUBLIC :: ps_phash_eta_parallel = 837
  INTEGER, PARAMETER, PUBLIC :: ps_phash_fidiff_bpass_co = 839
  INTEGER, PARAMETER, PUBLIC :: ps_phash_fidiff_bpass_ctr = 841
  INTEGER, PARAMETER, PUBLIC :: ps_phash_fidiff_btrap = 843
  INTEGER, PARAMETER, PUBLIC :: ps_phash_fidiff_dpass_co = 845
  INTEGER, PARAMETER, PUBLIC :: ps_phash_fidiff_dpass_ctr = 847
  INTEGER, PARAMETER, PUBLIC :: ps_phash_fidiff_dtrap = 849
  INTEGER, PARAMETER, PUBLIC :: ps_phash_fi_depletion = 851
  INTEGER, PARAMETER, PUBLIC :: ps_phash_freq_drbm = 853
  INTEGER, PARAMETER, PUBLIC :: ps_phash_freq_glf = 855
  INTEGER, PARAMETER, PUBLIC :: ps_phash_freq_max_tglf = 857
  INTEGER, PARAMETER, PUBLIC :: ps_phash_freq_mmm71 = 859
  INTEGER, PARAMETER, PUBLIC :: ps_phash_freq_mtm = 861
  INTEGER, PARAMETER, PUBLIC :: ps_phash_freq_tglf = 863
  INTEGER, PARAMETER, PUBLIC :: ps_phash_gamma_nc = 865
  INTEGER, PARAMETER, PUBLIC :: ps_phash_gb1 = 867
  INTEGER, PARAMETER, PUBLIC :: ps_phash_gb2 = 869
  INTEGER, PARAMETER, PUBLIC :: ps_phash_gb2i = 871
  INTEGER, PARAMETER, PUBLIC :: ps_phash_gbr2 = 873
  INTEGER, PARAMETER, PUBLIC :: ps_phash_gncfb2h = 875
  INTEGER, PARAMETER, PUBLIC :: ps_phash_gncfh = 877
  INTEGER, PARAMETER, PUBLIC :: ps_phash_gr1 = 879
  INTEGER, PARAMETER, PUBLIC :: ps_phash_gr2 = 881
  INTEGER, PARAMETER, PUBLIC :: ps_phash_gr2i = 883
  INTEGER, PARAMETER, PUBLIC :: ps_phash_gr2rho2 = 885
  INTEGER, PARAMETER, PUBLIC :: ps_phash_gr3i = 887
  INTEGER, PARAMETER, PUBLIC :: ps_phash_grho1 = 889
  INTEGER, PARAMETER, PUBLIC :: ps_phash_grho2 = 891
  INTEGER, PARAMETER, PUBLIC :: ps_phash_grho2b2i = 893
  INTEGER, PARAMETER, PUBLIC :: ps_phash_grho2r2i = 895
  INTEGER, PARAMETER, PUBLIC :: ps_phash_grho2r3i = 897
  INTEGER, PARAMETER, PUBLIC :: ps_phash_gri = 899
  INTEGER, PARAMETER, PUBLIC :: ps_phash_grirhoi = 901
  INTEGER, PARAMETER, PUBLIC :: ps_phash_growthrate_drbm = 903
  INTEGER, PARAMETER, PUBLIC :: ps_phash_growthrate_glf = 905
  INTEGER, PARAMETER, PUBLIC :: ps_phash_growthrate_max_tglf = 907
  INTEGER, PARAMETER, PUBLIC :: ps_phash_growthrate_mmm71 = 909
  INTEGER, PARAMETER, PUBLIC :: ps_phash_growthrate_mtm = 911
  INTEGER, PARAMETER, PUBLIC :: ps_phash_growthrate_tglf = 913
  INTEGER, PARAMETER, PUBLIC :: ps_phash_growthrate_vpar = 915
  INTEGER, PARAMETER, PUBLIC :: ps_phash_g_eq = 917
  INTEGER, PARAMETER, PUBLIC :: ps_phash_iota = 919
  INTEGER, PARAMETER, PUBLIC :: ps_phash_jdotb = 921
  INTEGER, PARAMETER, PUBLIC :: ps_phash_kyrhos_mtm = 923
  INTEGER, PARAMETER, PUBLIC :: ps_phash_kyspectrum_tglf = 925
  INTEGER, PARAMETER, PUBLIC :: ps_phash_lpol = 927
  INTEGER, PARAMETER, PUBLIC :: ps_phash_n0norm = 929
  INTEGER, PARAMETER, PUBLIC :: ps_phash_n0_halo = 931
  INTEGER, PARAMETER, PUBLIC :: ps_phash_n0_reco = 933
  INTEGER, PARAMETER, PUBLIC :: ps_phash_nbeami = 935
  INTEGER, PARAMETER, PUBLIC :: ps_phash_neflux_ky_tglf = 937
  INTEGER, PARAMETER, PUBLIC :: ps_phash_ne_ky_tglf = 939
  INTEGER, PARAMETER, PUBLIC :: ps_phash_nfusi = 941
  INTEGER, PARAMETER, PUBLIC :: ps_phash_ngradb2_av = 943
  INTEGER, PARAMETER, PUBLIC :: ps_phash_ni = 945
  INTEGER, PARAMETER, PUBLIC :: ps_phash_niflux_ky_tglf = 947
  INTEGER, PARAMETER, PUBLIC :: ps_phash_ni_ky_tglf = 949
  INTEGER, PARAMETER, PUBLIC :: ps_phash_nmini = 951
  INTEGER, PARAMETER, PUBLIC :: ps_phash_nmodel = 953
  INTEGER, PARAMETER, PUBLIC :: ps_phash_nrw = 955
  INTEGER, PARAMETER, PUBLIC :: ps_phash_ns = 957
  INTEGER, PARAMETER, PUBLIC :: ps_phash_nzflux_ky_tglf = 959
  INTEGER, PARAMETER, PUBLIC :: ps_phash_nz_ky_tglf = 961
  INTEGER, PARAMETER, PUBLIC :: ps_phash_omeg0cx = 963
  INTEGER, PARAMETER, PUBLIC :: ps_phash_omeg0sc0 = 965
  INTEGER, PARAMETER, PUBLIC :: ps_phash_omeg0_halo = 967
  INTEGER, PARAMETER, PUBLIC :: ps_phash_omeg0_reco = 969
  INTEGER, PARAMETER, PUBLIC :: ps_phash_omegat = 971
  INTEGER, PARAMETER, PUBLIC :: ps_phash_omega_exb = 973
  INTEGER, PARAMETER, PUBLIC :: ps_phash_p0_reco = 975
  INTEGER, PARAMETER, PUBLIC :: ps_phash_pb0_halo = 977
  INTEGER, PARAMETER, PUBLIC :: ps_phash_pbe = 979
  INTEGER, PARAMETER, PUBLIC :: ps_phash_pbi = 981
  INTEGER, PARAMETER, PUBLIC :: ps_phash_pbth = 983
  INTEGER, PARAMETER, PUBLIC :: ps_phash_pcx_halo = 985
  INTEGER, PARAMETER, PUBLIC :: ps_phash_pcx_reco = 987
  INTEGER, PARAMETER, PUBLIC :: ps_phash_peech = 989
  INTEGER, PARAMETER, PUBLIC :: ps_phash_peech_src = 991
  INTEGER, PARAMETER, PUBLIC :: ps_phash_pelh = 993
  INTEGER, PARAMETER, PUBLIC :: ps_phash_pelh_src = 995
  INTEGER, PARAMETER, PUBLIC :: ps_phash_pe_anom = 997
  INTEGER, PARAMETER, PUBLIC :: ps_phash_pe_trans = 999
  INTEGER, PARAMETER, PUBLIC :: ps_phash_pe_transcat = 1001
  INTEGER, PARAMETER, PUBLIC :: ps_phash_pfuse = 1003
  INTEGER, PARAMETER, PUBLIC :: ps_phash_pfusi = 1005
  INTEGER, PARAMETER, PUBLIC :: ps_phash_pfusth = 1007
  INTEGER, PARAMETER, PUBLIC :: ps_phash_phiflux_ky_tglf = 1009
  INTEGER, PARAMETER, PUBLIC :: ps_phash_phit = 1011
  INTEGER, PARAMETER, PUBLIC :: ps_phash_picrf_nphi_srcs = 1013
  INTEGER, PARAMETER, PUBLIC :: ps_phash_picrf_srcs = 1015
  INTEGER, PARAMETER, PUBLIC :: ps_phash_picrf_totals = 1017
  INTEGER, PARAMETER, PUBLIC :: ps_phash_picth = 1019
  INTEGER, PARAMETER, PUBLIC :: ps_phash_pilh = 1021
  INTEGER, PARAMETER, PUBLIC :: ps_phash_pilh_src = 1023
  INTEGER, PARAMETER, PUBLIC :: ps_phash_pi_anom = 1025
  INTEGER, PARAMETER, PUBLIC :: ps_phash_pi_trans = 1027
  INTEGER, PARAMETER, PUBLIC :: ps_phash_pi_transcat = 1029
  INTEGER, PARAMETER, PUBLIC :: ps_phash_pmine = 1031
  INTEGER, PARAMETER, PUBLIC :: ps_phash_pmini = 1033
  INTEGER, PARAMETER, PUBLIC :: ps_phash_pminth = 1035
  INTEGER, PARAMETER, PUBLIC :: ps_phash_pohme = 1037
  INTEGER, PARAMETER, PUBLIC :: ps_phash_pot_ky_tglf = 1039
  INTEGER, PARAMETER, PUBLIC :: ps_phash_prad = 1041
  INTEGER, PARAMETER, PUBLIC :: ps_phash_prad_br = 1043
  INTEGER, PARAMETER, PUBLIC :: ps_phash_prad_cy = 1045
  INTEGER, PARAMETER, PUBLIC :: ps_phash_prad_li = 1047
  INTEGER, PARAMETER, PUBLIC :: ps_phash_psc_halo = 1049
  INTEGER, PARAMETER, PUBLIC :: ps_phash_psc_reco = 1051
  INTEGER, PARAMETER, PUBLIC :: ps_phash_psipol = 1053
  INTEGER, PARAMETER, PUBLIC :: ps_phash_psirz = 1055
  INTEGER, PARAMETER, PUBLIC :: ps_phash_psmom_errck = 1057
  INTEGER, PARAMETER, PUBLIC :: ps_phash_psmom_nc = 1059
  INTEGER, PARAMETER, PUBLIC :: ps_phash_p_eq = 1061
  INTEGER, PARAMETER, PUBLIC :: ps_phash_qbeami = 1063
  INTEGER, PARAMETER, PUBLIC :: ps_phash_qcomp_e = 1065
  INTEGER, PARAMETER, PUBLIC :: ps_phash_qcomp_i = 1067
  INTEGER, PARAMETER, PUBLIC :: ps_phash_qie = 1069
  INTEGER, PARAMETER, PUBLIC :: ps_phash_qioniz = 1071
  INTEGER, PARAMETER, PUBLIC :: ps_phash_qqcx = 1073
  INTEGER, PARAMETER, PUBLIC :: ps_phash_qrot_conv = 1075
  INTEGER, PARAMETER, PUBLIC :: ps_phash_qrot_diff = 1077
  INTEGER, PARAMETER, PUBLIC :: ps_phash_q_eq = 1079
  INTEGER, PARAMETER, PUBLIC :: ps_phash_r0_momeq = 1081
  INTEGER, PARAMETER, PUBLIC :: ps_phash_rate_sinb0i = 1083
  INTEGER, PARAMETER, PUBLIC :: ps_phash_rate_sinb0x = 1085
  INTEGER, PARAMETER, PUBLIC :: ps_phash_rate_sinb0xs = 1087
  INTEGER, PARAMETER, PUBLIC :: ps_phash_rate_sinf0i = 1089
  INTEGER, PARAMETER, PUBLIC :: ps_phash_rate_sinf0x = 1091
  INTEGER, PARAMETER, PUBLIC :: ps_phash_rate_sinf0xs = 1093
  INTEGER, PARAMETER, PUBLIC :: ps_phash_res_sn = 1095
  INTEGER, PARAMETER, PUBLIC :: ps_phash_res_te = 1097
  INTEGER, PARAMETER, PUBLIC :: ps_phash_res_ti = 1099
  INTEGER, PARAMETER, PUBLIC :: ps_phash_res_tq = 1101
  INTEGER, PARAMETER, PUBLIC :: ps_phash_rmajor_mean = 1103
  INTEGER, PARAMETER, PUBLIC :: ps_phash_rminor_mean = 1105
  INTEGER, PARAMETER, PUBLIC :: ps_phash_r_geo = 1107
  INTEGER, PARAMETER, PUBLIC :: ps_phash_r_midp_in = 1109
  INTEGER, PARAMETER, PUBLIC :: ps_phash_r_midp_out = 1111
  INTEGER, PARAMETER, PUBLIC :: ps_phash_r_surfmax = 1113
  INTEGER, PARAMETER, PUBLIC :: ps_phash_r_surfmin = 1115
  INTEGER, PARAMETER, PUBLIC :: ps_phash_s0reco = 1117
  INTEGER, PARAMETER, PUBLIC :: ps_phash_s0reco_e = 1119
  INTEGER, PARAMETER, PUBLIC :: ps_phash_s0reco_recap = 1121
  INTEGER, PARAMETER, PUBLIC :: ps_phash_sb0halo = 1123
  INTEGER, PARAMETER, PUBLIC :: ps_phash_sb0halo_recap = 1125
  INTEGER, PARAMETER, PUBLIC :: ps_phash_sbedep = 1127
  INTEGER, PARAMETER, PUBLIC :: ps_phash_sbehalo = 1129
  INTEGER, PARAMETER, PUBLIC :: ps_phash_sbsce = 1131
  INTEGER, PARAMETER, PUBLIC :: ps_phash_sbtherm = 1133
  INTEGER, PARAMETER, PUBLIC :: ps_phash_sc_anom = 1135
  INTEGER, PARAMETER, PUBLIC :: ps_phash_sfsce = 1137
  INTEGER, PARAMETER, PUBLIC :: ps_phash_sftherm = 1139
  INTEGER, PARAMETER, PUBLIC :: ps_phash_sii_xs = 1141
  INTEGER, PARAMETER, PUBLIC :: ps_phash_sn_trans = 1143
  INTEGER, PARAMETER, PUBLIC :: ps_phash_sn_transcat = 1145
  INTEGER, PARAMETER, PUBLIC :: ps_phash_sprof0 = 1147
  INTEGER, PARAMETER, PUBLIC :: ps_phash_sprof0e = 1149
  INTEGER, PARAMETER, PUBLIC :: ps_phash_spsce = 1151
  INTEGER, PARAMETER, PUBLIC :: ps_phash_squarelo = 1153
  INTEGER, PARAMETER, PUBLIC :: ps_phash_squareuo = 1155
  INTEGER, PARAMETER, PUBLIC :: ps_phash_surf = 1157
  INTEGER, PARAMETER, PUBLIC :: ps_phash_t0cx = 1159
  INTEGER, PARAMETER, PUBLIC :: ps_phash_t0sc0 = 1161
  INTEGER, PARAMETER, PUBLIC :: ps_phash_t0_halo = 1163
  INTEGER, PARAMETER, PUBLIC :: ps_phash_t0_reco = 1165
  INTEGER, PARAMETER, PUBLIC :: ps_phash_teflux_ky_tglf = 1167
  INTEGER, PARAMETER, PUBLIC :: ps_phash_te_ky_tglf = 1169
  INTEGER, PARAMETER, PUBLIC :: ps_phash_tfrip2_log = 1171
  INTEGER, PARAMETER, PUBLIC :: ps_phash_tfrip_log = 1173
  INTEGER, PARAMETER, PUBLIC :: ps_phash_ti = 1175
  INTEGER, PARAMETER, PUBLIC :: ps_phash_tiflux_ky_tglf = 1177
  INTEGER, PARAMETER, PUBLIC :: ps_phash_ti_ky_tglf = 1179
  INTEGER, PARAMETER, PUBLIC :: ps_phash_tmodel = 1181
  INTEGER, PARAMETER, PUBLIC :: ps_phash_tq0_reco = 1183
  INTEGER, PARAMETER, PUBLIC :: ps_phash_tqb0_halo = 1185
  INTEGER, PARAMETER, PUBLIC :: ps_phash_tqbe = 1187
  INTEGER, PARAMETER, PUBLIC :: ps_phash_tqbi = 1189
  INTEGER, PARAMETER, PUBLIC :: ps_phash_tqbjxb = 1191
  INTEGER, PARAMETER, PUBLIC :: ps_phash_tqbth = 1193
  INTEGER, PARAMETER, PUBLIC :: ps_phash_tqcx_halo = 1195
  INTEGER, PARAMETER, PUBLIC :: ps_phash_tqcx_reco = 1197
  INTEGER, PARAMETER, PUBLIC :: ps_phash_tqioniz = 1199
  INTEGER, PARAMETER, PUBLIC :: ps_phash_tqqcx = 1201
  INTEGER, PARAMETER, PUBLIC :: ps_phash_tqsc_halo = 1203
  INTEGER, PARAMETER, PUBLIC :: ps_phash_tqsc_reco = 1205
  INTEGER, PARAMETER, PUBLIC :: ps_phash_tq_anom = 1207
  INTEGER, PARAMETER, PUBLIC :: ps_phash_tq_trans = 1209
  INTEGER, PARAMETER, PUBLIC :: ps_phash_tq_transcat = 1211
  INTEGER, PARAMETER, PUBLIC :: ps_phash_triang = 1213
  INTEGER, PARAMETER, PUBLIC :: ps_phash_triangl = 1215
  INTEGER, PARAMETER, PUBLIC :: ps_phash_triangu = 1217
  INTEGER, PARAMETER, PUBLIC :: ps_phash_triang_miller_l = 1219
  INTEGER, PARAMETER, PUBLIC :: ps_phash_triang_miller_u = 1221
  INTEGER, PARAMETER, PUBLIC :: ps_phash_ts = 1223
  INTEGER, PARAMETER, PUBLIC :: ps_phash_tzflux_ky_tglf = 1225
  INTEGER, PARAMETER, PUBLIC :: ps_phash_tz_ky_tglf = 1227
  INTEGER, PARAMETER, PUBLIC :: ps_phash_upwind_pfrac_ns = 1229
  INTEGER, PARAMETER, PUBLIC :: ps_phash_upwind_pfrac_omega = 1231
  INTEGER, PARAMETER, PUBLIC :: ps_phash_upwind_pfrac_te = 1233
  INTEGER, PARAMETER, PUBLIC :: ps_phash_upwind_pfrac_ti = 1235
  INTEGER, PARAMETER, PUBLIC :: ps_phash_vee_trans = 1237
  INTEGER, PARAMETER, PUBLIC :: ps_phash_vee_transcat = 1239
  INTEGER, PARAMETER, PUBLIC :: ps_phash_velb_fusi = 1241
  INTEGER, PARAMETER, PUBLIC :: ps_phash_velb_nbi = 1243
  INTEGER, PARAMETER, PUBLIC :: ps_phash_velb_rfmi = 1245
  INTEGER, PARAMETER, PUBLIC :: ps_phash_velne_nclass = 1247
  INTEGER, PARAMETER, PUBLIC :: ps_phash_velnh_nclass = 1249
  INTEGER, PARAMETER, PUBLIC :: ps_phash_velni_drbm = 1251
  INTEGER, PARAMETER, PUBLIC :: ps_phash_velns_anom = 1253
  INTEGER, PARAMETER, PUBLIC :: ps_phash_velns_glf = 1255
  INTEGER, PARAMETER, PUBLIC :: ps_phash_velns_gtcneo = 1257
  INTEGER, PARAMETER, PUBLIC :: ps_phash_velns_mmm71 = 1259
  INTEGER, PARAMETER, PUBLIC :: ps_phash_velns_nclass = 1261
  INTEGER, PARAMETER, PUBLIC :: ps_phash_velns_neo = 1263
  INTEGER, PARAMETER, PUBLIC :: ps_phash_velns_tglf = 1265
  INTEGER, PARAMETER, PUBLIC :: ps_phash_velnx_nclass = 1267
  INTEGER, PARAMETER, PUBLIC :: ps_phash_velpphi_anom = 1269
  INTEGER, PARAMETER, PUBLIC :: ps_phash_velpphi_glf = 1271
  INTEGER, PARAMETER, PUBLIC :: ps_phash_velpphi_gtcneo = 1273
  INTEGER, PARAMETER, PUBLIC :: ps_phash_velpphi_mmm71 = 1275
  INTEGER, PARAMETER, PUBLIC :: ps_phash_velpphi_neo = 1277
  INTEGER, PARAMETER, PUBLIC :: ps_phash_velpphi_tglf = 1279
  INTEGER, PARAMETER, PUBLIC :: ps_phash_velte_anom = 1281
  INTEGER, PARAMETER, PUBLIC :: ps_phash_velte_glf = 1283
  INTEGER, PARAMETER, PUBLIC :: ps_phash_velte_gtcneo = 1285
  INTEGER, PARAMETER, PUBLIC :: ps_phash_velte_mmm71 = 1287
  INTEGER, PARAMETER, PUBLIC :: ps_phash_velte_nclass = 1289
  INTEGER, PARAMETER, PUBLIC :: ps_phash_velte_neo = 1291
  INTEGER, PARAMETER, PUBLIC :: ps_phash_velte_paleo = 1293
  INTEGER, PARAMETER, PUBLIC :: ps_phash_velte_tglf = 1295
  INTEGER, PARAMETER, PUBLIC :: ps_phash_velti_anom = 1297
  INTEGER, PARAMETER, PUBLIC :: ps_phash_velti_glf = 1299
  INTEGER, PARAMETER, PUBLIC :: ps_phash_velti_gtcneo = 1301
  INTEGER, PARAMETER, PUBLIC :: ps_phash_velti_mmm71 = 1303
  INTEGER, PARAMETER, PUBLIC :: ps_phash_velti_nclass = 1305
  INTEGER, PARAMETER, PUBLIC :: ps_phash_velti_neo = 1307
  INTEGER, PARAMETER, PUBLIC :: ps_phash_velti_tglf = 1309
  INTEGER, PARAMETER, PUBLIC :: ps_phash_vie_trans = 1311
  INTEGER, PARAMETER, PUBLIC :: ps_phash_vie_transcat = 1313
  INTEGER, PARAMETER, PUBLIC :: ps_phash_vmo_trans = 1315
  INTEGER, PARAMETER, PUBLIC :: ps_phash_vmo_transcat = 1317
  INTEGER, PARAMETER, PUBLIC :: ps_phash_vn_trans = 1319
  INTEGER, PARAMETER, PUBLIC :: ps_phash_vn_transcat = 1321
  INTEGER, PARAMETER, PUBLIC :: ps_phash_vol = 1323
  INTEGER, PARAMETER, PUBLIC :: ps_phash_vpol_inmp = 1325
  INTEGER, PARAMETER, PUBLIC :: ps_phash_vpol_omp = 1327
  INTEGER, PARAMETER, PUBLIC :: ps_phash_vtor_inmp = 1329
  INTEGER, PARAMETER, PUBLIC :: ps_phash_vtor_omp = 1331
  INTEGER, PARAMETER, PUBLIC :: ps_phash_v_loop = 1333
  INTEGER, PARAMETER, PUBLIC :: ps_phash_v_pars = 1335
  INTEGER, PARAMETER, PUBLIC :: ps_phash_v_pers = 1337
  INTEGER, PARAMETER, PUBLIC :: ps_phash_xrjcos_momeq = 1339
  INTEGER, PARAMETER, PUBLIC :: ps_phash_xrjsin_momeq = 1341
  INTEGER, PARAMETER, PUBLIC :: ps_phash_xzjcos_momeq = 1343
  INTEGER, PARAMETER, PUBLIC :: ps_phash_xzjsin_momeq = 1345
  INTEGER, PARAMETER, PUBLIC :: ps_phash_z0_momeq = 1347
  INTEGER, PARAMETER, PUBLIC :: ps_phash_zeff = 1349
  INTEGER, PARAMETER, PUBLIC :: ps_phash_zeff_fi = 1351
  INTEGER, PARAMETER, PUBLIC :: ps_phash_zeff_th = 1353
  INTEGER, PARAMETER, PUBLIC :: ps_phash_z_geo = 1355
  INTEGER, PARAMETER, PUBLIC :: ps_phash_z_midp = 1357
  INTEGER, PARAMETER, PUBLIC :: ps_phash_z_surfmax = 1359
  INTEGER, PARAMETER, PUBLIC :: ps_phash_z_surfmin = 1361

  ! auxilliary hash code pair addresses:
  INTEGER, PARAMETER, PUBLIC :: ps_hash_aux1 = 1363
  INTEGER, PARAMETER, PUBLIC :: ps_hash_aux2 = 1365
  INTEGER, PARAMETER, PUBLIC :: ps_hash_aux3 = 1367
  INTEGER, PARAMETER, PUBLIC :: ps_hash_aux4 = 1369
  INTEGER, PARAMETER, PUBLIC :: ps_hash_aux5 = 1371
  INTEGER, PARAMETER, PUBLIC :: ps_hash_aux6 = 1373
  INTEGER, PARAMETER, PUBLIC :: ps_hash_aux7 = 1375
  INTEGER, PARAMETER, PUBLIC :: ps_hash_aux8 = 1377
  INTEGER, PARAMETER, PUBLIC :: ps_hash_aux9 = 1379

  ! total number of hash codes:
  INTEGER, PARAMETER, PUBLIC :: ps_hash_total = 1380


contains

   ! routines to check for differences in values
   ! set iflag if differences are detected AND policy = ps_error

   subroutine ps_diff_c0(name,c0a,c0b,policy,iout,iflag)
     character*(*), intent(in) :: name
     character*(*), intent(in) :: c0a
     character*(*), intent(in) :: c0b
     integer, intent(in) :: policy
     integer, intent(in) :: iout
     integer, intent(inout) :: iflag

     character*1 msghd

     !--------------
     if(policy.eq.ps_ignore) return

     if(c0a.ne.c0b) then

        msghd = '%'
        if(policy.eq.ps_error) then
           iflag = 1
           msghd = '?'
        endif

        write(iout,*) msghd//'ps_diff: value difference detected in: '// &
             trim(name)
     endif
   end subroutine ps_diff_c0

   subroutine ps_diff_c1(name,c1a,c1b,policy,iout,iflag)
     character*(*), intent(in) :: name
     character*(*), dimension(:), intent(in) :: c1a
     character*(*), dimension(:), intent(in) :: c1b
     integer, intent(in) :: policy
     integer, intent(in) :: iout
     integer, intent(inout) :: iflag

     integer :: ii,idiff

     character*1 msghd

     !--------------
     if(policy.eq.ps_ignore) return

     idiff=0
     if(len(c1a(1)).ne.len(c1b(1))) idiff=2
     if(size(c1a).ne.size(c1b)) idiff=2
     if(idiff.eq.0) then
        do ii=1,size(c1a)
           if(c1a(ii).ne.c1b(ii)) then
              idiff=1
              exit
           endif
        enddo
     endif

     if(idiff.ne.0) then

        msghd = '%'
        if((policy.eq.ps_error).OR.(idiff.eq.2)) then
           iflag = 1
           msghd = '?'
        endif

        if(idiff.eq.1) then
           write(iout,*) msghd//'ps_diff: value difference detected in: '// &
                trim(name)
        else
           write(iout,*) msghd//'ps_diff: shape difference detected in: '// &
                trim(name)
        endif
     endif
   end subroutine ps_diff_c1

   subroutine ps_diff_i0(name,i0a,i0b,policy,iout,iflag)
     character*(*), intent(in) :: name
     integer, intent(in) :: i0a
     integer, intent(in) :: i0b
     integer, intent(in) :: policy
     integer, intent(in) :: iout
     integer, intent(inout) :: iflag

     character*1 msghd

     !--------------
     if(policy.eq.ps_ignore) return

     if(i0a.ne.i0b) then

        msghd = '%'
        if(policy.eq.ps_error) then
           iflag = 1
           msghd = '?'
        endif

        write(iout,*) msghd//'ps_diff: value difference detected in: '// &
             trim(name)
     endif
   end subroutine ps_diff_i0

   subroutine ps_diff_i1(name,i1a,i1b,policy,iout,iflag)
     character*(*), intent(in) :: name
     integer, dimension(:), intent(in) :: i1a
     integer, dimension(:), intent(in) :: i1b
     integer, intent(in) :: policy
     integer, intent(in) :: iout
     integer, intent(inout) :: iflag

     integer :: ii,idiff

     character*1 msghd

     !--------------
     if(policy.eq.ps_ignore) return

     idiff=0
     if(size(i1a).ne.size(i1b)) idiff=2
     if(idiff.eq.0) then
        do ii=1,size(i1a)
           if(i1a(ii).ne.i1b(ii)) then
              idiff=1
              exit
           endif
        enddo
     endif

     if(idiff.ne.0) then

        msghd = '%'
        if((policy.eq.ps_error).OR.(idiff.eq.2)) then
           iflag = 1
           msghd = '?'
        endif

        if(idiff.eq.1) then
           write(iout,*) msghd//'ps_diff: value difference detected in: '// &
                trim(name)
        else
           write(iout,*) msghd//'ps_diff: shape difference detected in: '// &
                trim(name)
        endif
     endif
   end subroutine ps_diff_i1

   subroutine ps_diff_i2(name,i2a,i2b,policy,iout,iflag)
     character*(*), intent(in) :: name
     integer, dimension(:,:), intent(in) :: i2a
     integer, dimension(:,:), intent(in) :: i2b
     integer, intent(in) :: policy
     integer, intent(in) :: iout
     integer, intent(inout) :: iflag

     integer :: ii,jj,idiff

     character*1 msghd

     !--------------
     if(policy.eq.ps_ignore) return

     idiff=0
     if(size(i2a,1).ne.size(i2b,1)) idiff=2
     if(size(i2a,2).ne.size(i2b,2)) idiff=2
     if(idiff.eq.0) then
        do jj=1,size(i2a,2)
           do ii=1,size(i2a,1)
              if(i2a(ii,jj).ne.i2b(ii,jj)) then
                 idiff=1
                 exit
              endif
           enddo
           if(idiff.ne.0) exit
        enddo
     endif

     if(idiff.ne.0) then

        msghd = '%'
        if((policy.eq.ps_error).OR.(idiff.eq.2)) then
           iflag = 1
           msghd = '?'
        endif

        if(idiff.eq.1) then
           write(iout,*) msghd//'ps_diff: value difference detected in: '// &
                trim(name)
        else
           write(iout,*) msghd//'ps_diff: shape difference detected in: '// &
                trim(name)
        endif
     endif
   end subroutine ps_diff_i2

   subroutine ps_diff_i3(name,i3a,i3b,policy,iout,iflag)
     character*(*), intent(in) :: name
     integer, dimension(:,:,:), intent(in) :: i3a
     integer, dimension(:,:,:), intent(in) :: i3b
     integer, intent(in) :: policy
     integer, intent(in) :: iout
     integer, intent(inout) :: iflag

     integer :: ii,jj,kk,idiff

     character*1 msghd

     !--------------
     if(policy.eq.ps_ignore) return

     idiff=0
     if(size(i3a,1).ne.size(i3b,1)) idiff=2
     if(size(i3a,2).ne.size(i3b,2)) idiff=2
     if(size(i3a,3).ne.size(i3b,3)) idiff=2
     if(idiff.eq.0) then
        do kk=1,size(i3a,3)
           do jj=1,size(i3a,2)
              do ii=1,size(i3a,1)
                 if(i3a(ii,jj,kk).ne.i3b(ii,jj,kk)) then
                    idiff=1
                    exit
                 endif
              enddo
              if(idiff.ne.0) exit
           enddo
        enddo
     endif

     if(idiff.ne.0) then

        msghd = '%'
        if((policy.eq.ps_error).OR.(idiff.eq.2)) then
           iflag = 1
           msghd = '?'
        endif

        if(idiff.eq.1) then
           write(iout,*) msghd//'ps_diff: value difference detected in: '// &
                trim(name)
        else
           write(iout,*) msghd//'ps_diff: shape difference detected in: '// &
                trim(name)
        endif
     endif
   end subroutine ps_diff_i3

   subroutine ps_diff_r0(name,r0a,r0b,policy,iout,iflag)
     character*(*), intent(in) :: name
     real*8, intent(in) :: r0a
     real*8, intent(in) :: r0b
     integer, intent(in) :: policy
     integer, intent(in) :: iout
     integer, intent(inout) :: iflag

     character*1 msghd

     !--------------
     if(policy.eq.ps_ignore) return

     if(r0a.ne.r0b) then

        msghd = '%'
        if(policy.eq.ps_error) then
           iflag = 1
           msghd = '?'
        endif

        write(iout,*) msghd//'ps_diff: value difference detected in: '// &
             trim(name)
     endif
   end subroutine ps_diff_r0

   subroutine ps_diff_r1(name,r1a,r1b,policy,iout,iflag)
     character*(*), intent(in) :: name
     real*8, dimension(:), intent(in) :: r1a
     real*8, dimension(:), intent(in) :: r1b
     integer, intent(in) :: policy
     integer, intent(in) :: iout
     integer, intent(inout) :: iflag

     integer :: ii,idiff

     character*1 msghd

     !--------------
     if(policy.eq.ps_ignore) return

     idiff=0
     if(size(r1a).ne.size(r1b)) idiff=2
     if(idiff.eq.0) then
        do ii=1,size(r1a)
           if(r1a(ii).ne.r1b(ii)) then
              idiff=1
              exit
           endif
        enddo
     endif

     if(idiff.ne.0) then

        msghd = '%'
        if((policy.eq.ps_error).OR.(idiff.eq.2)) then
           iflag = 1
           msghd = '?'
        endif

        if(idiff.eq.1) then
           write(iout,*) msghd//'ps_diff: value difference detected in: '// &
                trim(name)
        else
           write(iout,*) msghd//'ps_diff: shape difference detected in: '// &
                trim(name)
        endif
     endif
   end subroutine ps_diff_r1

   subroutine ps_diff_r2(name,r2a,r2b,policy,iout,iflag)
     character*(*), intent(in) :: name
     real*8, dimension(:,:), intent(in) :: r2a
     real*8, dimension(:,:), intent(in) :: r2b
     integer, intent(in) :: policy
     integer, intent(in) :: iout
     integer, intent(inout) :: iflag

     integer :: ii,jj,idiff

     character*1 msghd

     !--------------
     if(policy.eq.ps_ignore) return

     idiff=0
     if(size(r2a,1).ne.size(r2b,1)) idiff=2
     if(size(r2a,2).ne.size(r2b,2)) idiff=2
     if(idiff.eq.0) then
        do jj=1,size(r2a,2)
           do ii=1,size(r2a,1)
              if(r2a(ii,jj).ne.r2b(ii,jj)) then
                 idiff=1
                 exit
              endif
           enddo
           if(idiff.ne.0) exit
        enddo
     endif

     if(idiff.ne.0) then

        msghd = '%'
        if((policy.eq.ps_error).OR.(idiff.eq.2)) then
           iflag = 1
           msghd = '?'
        endif

        if(idiff.eq.1) then
           write(iout,*) msghd//'ps_diff: value difference detected in: '// &
                trim(name)
        else
           write(iout,*) msghd//'ps_diff: shape difference detected in: '// &
                trim(name)
        endif
     endif
   end subroutine ps_diff_r2

   ! routines to check for conformal dimensioning of arrays
   ! set iflag and issue message if array dimensions do not match

   subroutine ps_conformal_c1(name,c1a,c1b,iout,iflag)
     character*(*), intent(in) :: name
     character*(*), dimension(:), intent(in) :: c1a
     character*(*), dimension(:), intent(in) :: c1b
     integer, intent(in) :: iout
     integer, intent(inout) :: iflag

     integer :: ii,idiff

     character*1 msghd

     !--------------

     idiff=0
     if(len(c1a(1)).ne.len(c1b(1))) idiff=2
     if(size(c1a).ne.size(c1b)) idiff=2

     if(idiff.ne.0) then

        msghd = '?'
        iflag = 1
        write(iout,*) msghd//'ps_conformal: shape difference detected in: '// &
                trim(name)

     endif
   end subroutine ps_conformal_c1

   subroutine ps_conformal_i1(name,i1a,i1b,iout,iflag)
     character*(*), intent(in) :: name
     integer, dimension(:), intent(in) :: i1a
     integer, dimension(:), intent(in) :: i1b
     integer, intent(in) :: iout
     integer, intent(inout) :: iflag

     integer :: ii,idiff

     character*1 msghd

     !--------------

     idiff=0
     if(size(i1a).ne.size(i1b)) idiff=2

     if(idiff.ne.0) then

        msghd = '?'
        iflag = 1
        write(iout,*) msghd//'ps_conformal: shape difference detected in: '// &
                trim(name)

     endif
   end subroutine ps_conformal_i1

   subroutine ps_conformal_i2(name,i2a,i2b,iout,iflag)
     character*(*), intent(in) :: name
     integer, dimension(:,:), intent(in) :: i2a
     integer, dimension(:,:), intent(in) :: i2b
     integer, intent(in) :: iout
     integer, intent(inout) :: iflag

     integer :: ii,jj,idiff

     character*1 msghd

     !--------------

     idiff=0
     if(size(i2a,1).ne.size(i2b,1)) idiff=2
     if(size(i2a,2).ne.size(i2b,2)) idiff=2

     if(idiff.ne.0) then

        msghd = '?'
        iflag = 1
        write(iout,*) msghd//'ps_conformal: shape difference detected in: '// &
                trim(name)

     endif
   end subroutine ps_conformal_i2

   subroutine ps_conformal_i3(name,i3a,i3b,iout,iflag)
     character*(*), intent(in) :: name
     integer, dimension(:,:,:), intent(in) :: i3a
     integer, dimension(:,:,:), intent(in) :: i3b
     integer, intent(in) :: iout
     integer, intent(inout) :: iflag

     integer :: ii,jj,kk,idiff

     character*1 msghd

     !--------------

     idiff=0
     if(size(i3a,1).ne.size(i3b,1)) idiff=2
     if(size(i3a,2).ne.size(i3b,2)) idiff=2
     if(size(i3a,3).ne.size(i3b,3)) idiff=2

     if(idiff.ne.0) then

        msghd = '?'
        iflag = 1
        write(iout,*) msghd//'ps_conformal: shape difference detected in: '// &
                trim(name)

     endif
   end subroutine ps_conformal_i3

   subroutine ps_conformal_r1(name,r1a,r1b,iout,iflag)
     character*(*), intent(in) :: name
     real*8, dimension(:), intent(in) :: r1a
     real*8, dimension(:), intent(in) :: r1b
     integer, intent(in) :: iout
     integer, intent(inout) :: iflag

     integer :: ii,idiff

     character*1 msghd

     !--------------

     idiff=0
     if(size(r1a).ne.size(r1b)) idiff=2

     if(idiff.ne.0) then

        msghd = '?'
        iflag = 1
        write(iout,*) msghd//'ps_conformal: shape difference detected in: '// &
                trim(name)

     endif
   end subroutine ps_conformal_r1

   subroutine ps_conformal_r2(name,r2a,r2b,iout,iflag)
     character*(*), intent(in) :: name
     real*8, dimension(:,:), intent(in) :: r2a
     real*8, dimension(:,:), intent(in) :: r2b
     integer, intent(in) :: iout
     integer, intent(inout) :: iflag

     integer :: ii,jj,idiff

     character*1 msghd

     !--------------

     idiff=0
     if(size(r2a,1).ne.size(r2b,1)) idiff=2
     if(size(r2a,2).ne.size(r2b,2)) idiff=2

     if(idiff.ne.0) then

        msghd = '?'
        iflag = 1
        write(iout,*) msghd//'ps_conformal: shape difference detected in: '// &
                trim(name)

     endif
   end subroutine ps_conformal_r2

   subroutine ps_conformal_r3(name,r3a,r3b,iout,iflag)
     character*(*), intent(in) :: name
     real*8, dimension(:,:,:), intent(in) :: r3a
     real*8, dimension(:,:,:), intent(in) :: r3b
     integer, intent(in) :: iout
     integer, intent(inout) :: iflag

     integer :: ii,jj,kk,idiff

     character*1 msghd

     !--------------

     idiff=0
     if(size(r3a,1).ne.size(r3b,1)) idiff=2
     if(size(r3a,2).ne.size(r3b,2)) idiff=2
     if(size(r3a,3).ne.size(r3b,3)) idiff=2

     if(idiff.ne.0) then

        msghd = '?'
        iflag = 1
        write(iout,*) msghd//'ps_conformal: shape difference detected in: '// &
                trim(name)

     endif
   end subroutine ps_conformal_r3

   subroutine ps_conformal_r4(name,r4a,r4b,iout,iflag)
     character*(*), intent(in) :: name
     real*8, dimension(:,:,:,:), intent(in) :: r4a
     real*8, dimension(:,:,:,:), intent(in) :: r4b
     integer, intent(in) :: iout
     integer, intent(inout) :: iflag

     integer :: ii,jj,kk,idiff

     character*1 msghd

     !--------------

     idiff=0
     if(size(r4a,1).ne.size(r4b,1)) idiff=2
     if(size(r4a,2).ne.size(r4b,2)) idiff=2
     if(size(r4a,3).ne.size(r4b,3)) idiff=2
     if(size(r4a,4).ne.size(r4b,4)) idiff=2

     if(idiff.ne.0) then

        msghd = '?'
        iflag = 1
        write(iout,*) msghd//'ps_conformal: shape difference detected in: '// &
                trim(name)

     endif
   end subroutine ps_conformal_r4

end module plasma_state_util_mod

subroutine ccps_rho_rezone(iobj,id,ngrid,rho_grid,result, &
     curflag, normflag, smooflag, ierr)

  ! REZONE a 1d profile f(rho), rho=sqrt(tor.flux) flux label
  !   Densities are rezoned to conserve volume integral
  !   Temperatures are rezoned to conserve density weighted volume integral
  !   Current densities are rezoned to conserve cross-sect. area integral

  !   The user specifies the target rho_grid boundaries -- strict ascending
  !   sequence spanning [0.0_rspec:1.0_rspec] -- ngrid points

  !   The result returned is "zone oriented" -- between the boundary points --
  !   (ngrid-1) values returned.

  !   curflag.NE.0 indicates quantity has area normalization (i.e. a
  !   current density).

  !   normflag.NE.0 means: return integrated quantities, e.g. 
  !     (#ptcls/zone), (Amps), (Watts),...
  !   normflag.EQ.0 means: return normalized quantities, e.g.
  !     (#ptcls/m^3), (Amps/m^2), (Watts/m^3)

  !   ...See subroutine ccps_rho_metric to get normaling areas or volumes
  !   ***normflag has no effect on temperatures or other weighted-averaged 
  !   quantities.

  !   smooflag.NE.0 means: smooth the result; total integrated over entire
  !   range [0:1] is still conserved.

  !   Note on smoothing: if underlying profile being rezoned is a step 
  !   function, rezoning to a finer grid without smoothing will reveal
  !   the underlying step structure.  If smoothing is specified, the
  !   results are blended over a zone width with a convolution.  This
  !   removes the "step-function-like" behavior in the result.  However,
  !   any smoothing can produce small artifacts...

  use plasma_state_mod
  implicit NONE

  integer :: iobj(*)        ! (ps_container_size) words are used: state object

  integer, intent(in) :: ID ! profile to be rezoned.  If id references a
  !  quantity that is specified as weighted in the plasma state specification
  !  then the rezoning here will be weighted (e.g. the case with temperature
  !  profiles).

  integer :: ngrid          ! size of RHO grid provided
  REAL(kind=rspec) :: rho_grid(ngrid)  ! the RHO grid
          ! *** strict ascending order ***
          ! *** in range [0.0_rspec:1.0_rspec] ***

  REAL(kind=rspec) :: result(ngrid-1) ! results returned ***(ngrid-1) values***

  integer, intent(in) :: curflag      ! set .NE.0 for current density rezone
  integer, intent(in) :: normflag     ! set .NE.0 for area or volume norm.
  integer, intent(in) :: smooflag     ! set .NE.0 for smoothing

  integer,intent(out) :: ierr   ! exit status 0=OK

  !-------------------------
  type (plasma_state_container) :: ptr
  type (plasma_state), pointer :: ss
  !-------------------------

  call ccps_argcheck('ccps_rho_rezone',iobj,ierr)
  if(ierr.ne.0) return

  ! proceed...

  call load_ps_container(iobj,ptr)
  ss => ptr%ps_ptr

  call ps_rho_rezone(rho_grid, id, result, ierr, state=ss, &
       curdens = (curflag.NE.0), &
       nonorm = (normflag.EQ.0), &
       zonesmoo = (smooflag.Ne.0))

end subroutine ccps_rho_rezone

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


SUBROUTINE plasma_state_merge_4(cclist,w1,ss1,ss2,ss3,icheck,iout,ierr)


  ! Merge floating point data
  !   ss3 <-- w1*ss1 + (1-w1)*ss2

  USE plasma_state_definition_mod
  IMPLICIT NONE

  INTEGER, INTENT(IN) :: cclist(ps_ccount)
                                ! list of components to merge
                                ! use ps_cc_all to merge all components

  REAL(KIND=rspec) :: w1        ! weight on ss1
  TYPE (plasma_state) :: ss1    ! state data to copy *from* with weight (w1)
  TYPE (plasma_state) :: ss2    ! state data to copy *from* with weight (1-w1)
  TYPE (plasma_state) :: ss3    ! state to which data is copied.
  INTEGER, INTENT(IN) :: icheck ! control for checking match of non-floating-
  !  point data: ps_ignore, ps_warn, or ps_error on mismatch.

  INTEGER, INTENT(IN) :: iout
  INTEGER, INTENT(INOUT) :: ierr  ! completion code (not cleared,set on error)

  !-------------------
  INTEGER :: isize
  !-------------------

  !-----------------------------------------------
  ! copy scalars and arrays that are allocated...

  IF(cclist(ps_cnum_NBI).EQ.1) THEN

     CALL ps_diff("NBI_Data_Info",ss1%NBI_Data_Info,ss2%NBI_Data_Info,icheck,iout,ierr)
     ss3%NBI_Data_Info = ss1%NBI_Data_Info
  ENDIF

  IF((ALLOCATED(ss3%nbi_src_name)).AND.(cclist(ps_cnum_NBI).EQ.1)) THEN
     IF(ALLOCATED(ss1%nbi_src_name).AND.ALLOCATED(ss2%nbi_src_name)) THEN
        CALL ps_diff("nbi_src_name",ss1%nbi_src_name,ss2%nbi_src_name,icheck,iout,ierr)
        CALL ps_conformal("nbi_src_name",ss1%nbi_src_name,ss3%nbi_src_name,iout,ierr)
        if(ierr.eq.0) ss3%nbi_src_name = ss1%nbi_src_name
     ELSE IF(ALLOCATED(ss1%nbi_src_name)) THEN
        CALL ps_conformal("nbi_src_name",ss1%nbi_src_name,ss3%nbi_src_name,iout,ierr)
        ss3%nbi_src_name = ss1%nbi_src_name
     ELSE IF(ALLOCATED(ss2%nbi_src_name)) THEN
        CALL ps_conformal("nbi_src_name",ss2%nbi_src_name,ss3%nbi_src_name,iout,ierr)
        ss3%nbi_src_name = ss2%nbi_src_name
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%nbshape)).AND.(cclist(ps_cnum_NBI).EQ.1)) THEN
     IF(ALLOCATED(ss1%nbshape).AND.ALLOCATED(ss2%nbshape)) THEN
        CALL ps_diff("nbshape",ss1%nbshape,ss2%nbshape,icheck,iout,ierr)
        CALL ps_conformal("nbshape",ss1%nbshape,ss3%nbshape,iout,ierr)
        if(ierr.eq.0) ss3%nbshape = ss1%nbshape
     ELSE IF(ALLOCATED(ss1%nbshape)) THEN
        CALL ps_conformal("nbshape",ss1%nbshape,ss3%nbshape,iout,ierr)
        ss3%nbshape = ss1%nbshape
     ELSE IF(ALLOCATED(ss2%nbshape)) THEN
        CALL ps_conformal("nbshape",ss2%nbshape,ss3%nbshape,iout,ierr)
        ss3%nbshape = ss2%nbshape
     ENDIF
  ENDIF

  IF(cclist(ps_cnum_PLASMA).EQ.1) THEN
     ss3%nebar = w1*ss1%nebar + (1.0_rspec-w1)*ss2%nebar
  ENDIF

  IF((ALLOCATED(ss3%neflux_ky_tglf)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%neflux_ky_tglf).AND.ALLOCATED(ss2%neflux_ky_tglf)) THEN
        CALL ps_conformal("neflux_ky_tglf",ss2%neflux_ky_tglf,ss3%neflux_ky_tglf,iout,ierr)
        CALL ps_conformal("neflux_ky_tglf",ss1%neflux_ky_tglf,ss3%neflux_ky_tglf,iout,ierr)
        if(ierr.eq.0) ss3%neflux_ky_tglf = w1*ss1%neflux_ky_tglf + (1.0_rspec-w1)*ss2%neflux_ky_tglf
     ELSE IF(ALLOCATED(ss1%neflux_ky_tglf)) THEN
        CALL ps_conformal("neflux_ky_tglf",ss1%neflux_ky_tglf,ss3%neflux_ky_tglf,iout,ierr)
        ss3%neflux_ky_tglf = ss1%neflux_ky_tglf
     ELSE IF(ALLOCATED(ss2%neflux_ky_tglf)) THEN
        CALL ps_conformal("neflux_ky_tglf",ss2%neflux_ky_tglf,ss3%neflux_ky_tglf,iout,ierr)
        ss3%neflux_ky_tglf = ss2%neflux_ky_tglf
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%Newcomb_code)).AND.(cclist(ps_cnum_LMHD).EQ.1)) THEN
     IF(ALLOCATED(ss1%Newcomb_code).AND.ALLOCATED(ss2%Newcomb_code)) THEN
        CALL ps_diff("Newcomb_code",ss1%Newcomb_code,ss2%Newcomb_code,icheck,iout,ierr)
        CALL ps_conformal("Newcomb_code",ss1%Newcomb_code,ss3%Newcomb_code,iout,ierr)
        if(ierr.eq.0) ss3%Newcomb_code = ss1%Newcomb_code
     ELSE IF(ALLOCATED(ss1%Newcomb_code)) THEN
        CALL ps_conformal("Newcomb_code",ss1%Newcomb_code,ss3%Newcomb_code,iout,ierr)
        ss3%Newcomb_code = ss1%Newcomb_code
     ELSE IF(ALLOCATED(ss2%Newcomb_code)) THEN
        CALL ps_conformal("Newcomb_code",ss2%Newcomb_code,ss3%Newcomb_code,iout,ierr)
        ss3%Newcomb_code = ss2%Newcomb_code
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%Newcomb_mapper)).AND.(cclist(ps_cnum_LMHD).EQ.1)) THEN
     IF(ALLOCATED(ss1%Newcomb_mapper).AND.ALLOCATED(ss2%Newcomb_mapper)) THEN
        CALL ps_diff("Newcomb_mapper",ss1%Newcomb_mapper,ss2%Newcomb_mapper,icheck,iout,ierr)
        CALL ps_conformal("Newcomb_mapper",ss1%Newcomb_mapper,ss3%Newcomb_mapper,iout,ierr)
        if(ierr.eq.0) ss3%Newcomb_mapper = ss1%Newcomb_mapper
     ELSE IF(ALLOCATED(ss1%Newcomb_mapper)) THEN
        CALL ps_conformal("Newcomb_mapper",ss1%Newcomb_mapper,ss3%Newcomb_mapper,iout,ierr)
        ss3%Newcomb_mapper = ss1%Newcomb_mapper
     ELSE IF(ALLOCATED(ss2%Newcomb_mapper)) THEN
        CALL ps_conformal("Newcomb_mapper",ss2%Newcomb_mapper,ss3%Newcomb_mapper,iout,ierr)
        ss3%Newcomb_mapper = ss2%Newcomb_mapper
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%Newcomb_stable)).AND.(cclist(ps_cnum_LMHD).EQ.1)) THEN
     IF(ALLOCATED(ss1%Newcomb_stable).AND.ALLOCATED(ss2%Newcomb_stable)) THEN
        CALL ps_diff("Newcomb_stable",ss1%Newcomb_stable,ss2%Newcomb_stable,icheck,iout,ierr)
        CALL ps_conformal("Newcomb_stable",ss1%Newcomb_stable,ss3%Newcomb_stable,iout,ierr)
        if(ierr.eq.0) ss3%Newcomb_stable = ss1%Newcomb_stable
     ELSE IF(ALLOCATED(ss1%Newcomb_stable)) THEN
        CALL ps_conformal("Newcomb_stable",ss1%Newcomb_stable,ss3%Newcomb_stable,iout,ierr)
        ss3%Newcomb_stable = ss1%Newcomb_stable
     ELSE IF(ALLOCATED(ss2%Newcomb_stable)) THEN
        CALL ps_conformal("Newcomb_stable",ss2%Newcomb_stable,ss3%Newcomb_stable,iout,ierr)
        ss3%Newcomb_stable = ss2%Newcomb_stable
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%Newcomb_status)).AND.(cclist(ps_cnum_LMHD).EQ.1)) THEN
     IF(ALLOCATED(ss1%Newcomb_status).AND.ALLOCATED(ss2%Newcomb_status)) THEN
        CALL ps_diff("Newcomb_status",ss1%Newcomb_status,ss2%Newcomb_status,icheck,iout,ierr)
        CALL ps_conformal("Newcomb_status",ss1%Newcomb_status,ss3%Newcomb_status,iout,ierr)
        if(ierr.eq.0) ss3%Newcomb_status = ss1%Newcomb_status
     ELSE IF(ALLOCATED(ss1%Newcomb_status)) THEN
        CALL ps_conformal("Newcomb_status",ss1%Newcomb_status,ss3%Newcomb_status,iout,ierr)
        ss3%Newcomb_status = ss1%Newcomb_status
     ELSE IF(ALLOCATED(ss2%Newcomb_status)) THEN
        CALL ps_conformal("Newcomb_status",ss2%Newcomb_status,ss3%Newcomb_status,iout,ierr)
        ss3%Newcomb_status = ss2%Newcomb_status
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%ne_ky_tglf)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%ne_ky_tglf).AND.ALLOCATED(ss2%ne_ky_tglf)) THEN
        CALL ps_conformal("ne_ky_tglf",ss2%ne_ky_tglf,ss3%ne_ky_tglf,iout,ierr)
        CALL ps_conformal("ne_ky_tglf",ss1%ne_ky_tglf,ss3%ne_ky_tglf,iout,ierr)
        if(ierr.eq.0) ss3%ne_ky_tglf = w1*ss1%ne_ky_tglf + (1.0_rspec-w1)*ss2%ne_ky_tglf
     ELSE IF(ALLOCATED(ss1%ne_ky_tglf)) THEN
        CALL ps_conformal("ne_ky_tglf",ss1%ne_ky_tglf,ss3%ne_ky_tglf,iout,ierr)
        ss3%ne_ky_tglf = ss1%ne_ky_tglf
     ELSE IF(ALLOCATED(ss2%ne_ky_tglf)) THEN
        CALL ps_conformal("ne_ky_tglf",ss2%ne_ky_tglf,ss3%ne_ky_tglf,iout,ierr)
        ss3%ne_ky_tglf = ss2%ne_ky_tglf
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%nfusi)).AND.(cclist(ps_cnum_FUS).EQ.1)) THEN
     IF(ALLOCATED(ss1%nfusi).AND.ALLOCATED(ss2%nfusi)) THEN
        CALL ps_conformal("nfusi",ss2%nfusi,ss3%nfusi,iout,ierr)
        CALL ps_conformal("nfusi",ss1%nfusi,ss3%nfusi,iout,ierr)
        if(ierr.eq.0) ss3%nfusi = w1*ss1%nfusi + (1.0_rspec-w1)*ss2%nfusi
     ELSE IF(ALLOCATED(ss1%nfusi)) THEN
        CALL ps_conformal("nfusi",ss1%nfusi,ss3%nfusi,iout,ierr)
        ss3%nfusi = ss1%nfusi
     ELSE IF(ALLOCATED(ss2%nfusi)) THEN
        CALL ps_conformal("nfusi",ss2%nfusi,ss3%nfusi,iout,ierr)
        ss3%nfusi = ss2%nfusi
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%nfusi_bdy)).AND.(cclist(ps_cnum_IC).EQ.1)) THEN
     IF(ALLOCATED(ss1%nfusi_bdy).AND.ALLOCATED(ss2%nfusi_bdy)) THEN
        CALL ps_conformal("nfusi_bdy",ss2%nfusi_bdy,ss3%nfusi_bdy,iout,ierr)
        CALL ps_conformal("nfusi_bdy",ss1%nfusi_bdy,ss3%nfusi_bdy,iout,ierr)
        if(ierr.eq.0) ss3%nfusi_bdy = w1*ss1%nfusi_bdy + (1.0_rspec-w1)*ss2%nfusi_bdy
     ELSE IF(ALLOCATED(ss1%nfusi_bdy)) THEN
        CALL ps_conformal("nfusi_bdy",ss1%nfusi_bdy,ss3%nfusi_bdy,iout,ierr)
        ss3%nfusi_bdy = ss1%nfusi_bdy
     ELSE IF(ALLOCATED(ss2%nfusi_bdy)) THEN
        CALL ps_conformal("nfusi_bdy",ss2%nfusi_bdy,ss3%nfusi_bdy,iout,ierr)
        ss3%nfusi_bdy = ss2%nfusi_bdy
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%ngradb2_av)).AND.(cclist(ps_cnum_EQ).EQ.1)) THEN
     IF(ALLOCATED(ss1%ngradb2_av).AND.ALLOCATED(ss2%ngradb2_av)) THEN
        CALL ps_conformal("ngradb2_av",ss2%ngradb2_av,ss3%ngradb2_av,iout,ierr)
        CALL ps_conformal("ngradb2_av",ss1%ngradb2_av,ss3%ngradb2_av,iout,ierr)
        if(ierr.eq.0) ss3%ngradb2_av = w1*ss1%ngradb2_av + (1.0_rspec-w1)*ss2%ngradb2_av
     ELSE IF(ALLOCATED(ss1%ngradb2_av)) THEN
        CALL ps_conformal("ngradb2_av",ss1%ngradb2_av,ss3%ngradb2_av,iout,ierr)
        ss3%ngradb2_av = ss1%ngradb2_av
     ELSE IF(ALLOCATED(ss2%ngradb2_av)) THEN
        CALL ps_conformal("ngradb2_av",ss2%ngradb2_av,ss3%ngradb2_av,iout,ierr)
        ss3%ngradb2_av = ss2%ngradb2_av
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%ni)).AND.(cclist(ps_cnum_PLASMA).EQ.1)) THEN
     IF(ALLOCATED(ss1%ni).AND.ALLOCATED(ss2%ni)) THEN
        CALL ps_conformal("ni",ss2%ni,ss3%ni,iout,ierr)
        CALL ps_conformal("ni",ss1%ni,ss3%ni,iout,ierr)
        if(ierr.eq.0) ss3%ni = w1*ss1%ni + (1.0_rspec-w1)*ss2%ni
     ELSE IF(ALLOCATED(ss1%ni)) THEN
        CALL ps_conformal("ni",ss1%ni,ss3%ni,iout,ierr)
        ss3%ni = ss1%ni
     ELSE IF(ALLOCATED(ss2%ni)) THEN
        CALL ps_conformal("ni",ss2%ni,ss3%ni,iout,ierr)
        ss3%ni = ss2%ni
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%niflux_ky_tglf)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%niflux_ky_tglf).AND.ALLOCATED(ss2%niflux_ky_tglf)) THEN
        CALL ps_conformal("niflux_ky_tglf",ss2%niflux_ky_tglf,ss3%niflux_ky_tglf,iout,ierr)
        CALL ps_conformal("niflux_ky_tglf",ss1%niflux_ky_tglf,ss3%niflux_ky_tglf,iout,ierr)
        if(ierr.eq.0) ss3%niflux_ky_tglf = w1*ss1%niflux_ky_tglf + (1.0_rspec-w1)*ss2%niflux_ky_tglf
     ELSE IF(ALLOCATED(ss1%niflux_ky_tglf)) THEN
        CALL ps_conformal("niflux_ky_tglf",ss1%niflux_ky_tglf,ss3%niflux_ky_tglf,iout,ierr)
        ss3%niflux_ky_tglf = ss1%niflux_ky_tglf
     ELSE IF(ALLOCATED(ss2%niflux_ky_tglf)) THEN
        CALL ps_conformal("niflux_ky_tglf",ss2%niflux_ky_tglf,ss3%niflux_ky_tglf,iout,ierr)
        ss3%niflux_ky_tglf = ss2%niflux_ky_tglf
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%ni_ky_tglf)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%ni_ky_tglf).AND.ALLOCATED(ss2%ni_ky_tglf)) THEN
        CALL ps_conformal("ni_ky_tglf",ss2%ni_ky_tglf,ss3%ni_ky_tglf,iout,ierr)
        CALL ps_conformal("ni_ky_tglf",ss1%ni_ky_tglf,ss3%ni_ky_tglf,iout,ierr)
        if(ierr.eq.0) ss3%ni_ky_tglf = w1*ss1%ni_ky_tglf + (1.0_rspec-w1)*ss2%ni_ky_tglf
     ELSE IF(ALLOCATED(ss1%ni_ky_tglf)) THEN
        CALL ps_conformal("ni_ky_tglf",ss1%ni_ky_tglf,ss3%ni_ky_tglf,iout,ierr)
        ss3%ni_ky_tglf = ss1%ni_ky_tglf
     ELSE IF(ALLOCATED(ss2%ni_ky_tglf)) THEN
        CALL ps_conformal("ni_ky_tglf",ss2%ni_ky_tglf,ss3%ni_ky_tglf,iout,ierr)
        ss3%ni_ky_tglf = ss2%ni_ky_tglf
     ENDIF
  ENDIF

  IF(cclist(ps_cnum_ANOM).EQ.1) THEN

     CALL ps_diff("nmdifb",ss1%nmdifb,ss2%nmdifb,icheck,iout,ierr)
     ss3%nmdifb = ss1%nmdifb
  ENDIF

  IF((ALLOCATED(ss3%nmini)).AND.(cclist(ps_cnum_IC).EQ.1)) THEN
     IF(ALLOCATED(ss1%nmini).AND.ALLOCATED(ss2%nmini)) THEN
        CALL ps_conformal("nmini",ss2%nmini,ss3%nmini,iout,ierr)
        CALL ps_conformal("nmini",ss1%nmini,ss3%nmini,iout,ierr)
        if(ierr.eq.0) ss3%nmini = w1*ss1%nmini + (1.0_rspec-w1)*ss2%nmini
     ELSE IF(ALLOCATED(ss1%nmini)) THEN
        CALL ps_conformal("nmini",ss1%nmini,ss3%nmini,iout,ierr)
        ss3%nmini = ss1%nmini
     ELSE IF(ALLOCATED(ss2%nmini)) THEN
        CALL ps_conformal("nmini",ss2%nmini,ss3%nmini,iout,ierr)
        ss3%nmini = ss2%nmini
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%nmini_bdy)).AND.(cclist(ps_cnum_FUS).EQ.1)) THEN
     IF(ALLOCATED(ss1%nmini_bdy).AND.ALLOCATED(ss2%nmini_bdy)) THEN
        CALL ps_conformal("nmini_bdy",ss2%nmini_bdy,ss3%nmini_bdy,iout,ierr)
        CALL ps_conformal("nmini_bdy",ss1%nmini_bdy,ss3%nmini_bdy,iout,ierr)
        if(ierr.eq.0) ss3%nmini_bdy = w1*ss1%nmini_bdy + (1.0_rspec-w1)*ss2%nmini_bdy
     ELSE IF(ALLOCATED(ss1%nmini_bdy)) THEN
        CALL ps_conformal("nmini_bdy",ss1%nmini_bdy,ss3%nmini_bdy,iout,ierr)
        ss3%nmini_bdy = ss1%nmini_bdy
     ELSE IF(ALLOCATED(ss2%nmini_bdy)) THEN
        CALL ps_conformal("nmini_bdy",ss2%nmini_bdy,ss3%nmini_bdy,iout,ierr)
        ss3%nmini_bdy = ss2%nmini_bdy
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%nmodel)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%nmodel).AND.ALLOCATED(ss2%nmodel)) THEN
        CALL ps_conformal("nmodel",ss2%nmodel,ss3%nmodel,iout,ierr)
        CALL ps_conformal("nmodel",ss1%nmodel,ss3%nmodel,iout,ierr)
        if(ierr.eq.0) ss3%nmodel = w1*ss1%nmodel + (1.0_rspec-w1)*ss2%nmodel
     ELSE IF(ALLOCATED(ss1%nmodel)) THEN
        CALL ps_conformal("nmodel",ss1%nmodel,ss3%nmodel,iout,ierr)
        ss3%nmodel = ss1%nmodel
     ELSE IF(ALLOCATED(ss2%nmodel)) THEN
        CALL ps_conformal("nmodel",ss2%nmodel,ss3%nmodel,iout,ierr)
        ss3%nmodel = ss2%nmodel
     ENDIF
  ENDIF

  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     ss3%nmodel_bdy = w1*ss1%nmodel_bdy + (1.0_rspec-w1)*ss2%nmodel_bdy
  ENDIF

  IF(cclist(ps_cnum_EQ).EQ.1) THEN

     CALL ps_diff("nmom",ss1%nmom,ss2%nmom,icheck,iout,ierr)
     ss3%nmom = ss1%nmom
  ENDIF

  IF((ALLOCATED(ss3%nnkparlh)).AND.(cclist(ps_cnum_LH).EQ.1)) THEN
     IF(ALLOCATED(ss1%nnkparlh).AND.ALLOCATED(ss2%nnkparlh)) THEN
        CALL ps_diff("nnkparlh",ss1%nnkparlh,ss2%nnkparlh,icheck,iout,ierr)
        CALL ps_conformal("nnkparlh",ss1%nnkparlh,ss3%nnkparlh,iout,ierr)
        if(ierr.eq.0) ss3%nnkparlh = ss1%nnkparlh
     ELSE IF(ALLOCATED(ss1%nnkparlh)) THEN
        CALL ps_conformal("nnkparlh",ss1%nnkparlh,ss3%nnkparlh,iout,ierr)
        ss3%nnkparlh = ss1%nnkparlh
     ELSE IF(ALLOCATED(ss2%nnkparlh)) THEN
        CALL ps_conformal("nnkparlh",ss2%nnkparlh,ss3%nnkparlh,iout,ierr)
        ss3%nnkparlh = ss2%nnkparlh
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%nnkpollh)).AND.(cclist(ps_cnum_LH).EQ.1)) THEN
     IF(ALLOCATED(ss1%nnkpollh).AND.ALLOCATED(ss2%nnkpollh)) THEN
        CALL ps_diff("nnkpollh",ss1%nnkpollh,ss2%nnkpollh,icheck,iout,ierr)
        CALL ps_conformal("nnkpollh",ss1%nnkpollh,ss3%nnkpollh,iout,ierr)
        if(ierr.eq.0) ss3%nnkpollh = ss1%nnkpollh
     ELSE IF(ALLOCATED(ss1%nnkpollh)) THEN
        CALL ps_conformal("nnkpollh",ss1%nnkpollh,ss3%nnkpollh,iout,ierr)
        ss3%nnkpollh = ss1%nnkpollh
     ELSE IF(ALLOCATED(ss2%nnkpollh)) THEN
        CALL ps_conformal("nnkpollh",ss2%nnkpollh,ss3%nnkpollh,iout,ierr)
        ss3%nnkpollh = ss2%nnkpollh
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%nnktorlh)).AND.(cclist(ps_cnum_LH).EQ.1)) THEN
     IF(ALLOCATED(ss1%nnktorlh).AND.ALLOCATED(ss2%nnktorlh)) THEN
        CALL ps_diff("nnktorlh",ss1%nnktorlh,ss2%nnktorlh,icheck,iout,ierr)
        CALL ps_conformal("nnktorlh",ss1%nnktorlh,ss3%nnktorlh,iout,ierr)
        if(ierr.eq.0) ss3%nnktorlh = ss1%nnktorlh
     ELSE IF(ALLOCATED(ss1%nnktorlh)) THEN
        CALL ps_conformal("nnktorlh",ss1%nnktorlh,ss3%nnktorlh,iout,ierr)
        ss3%nnktorlh = ss1%nnktorlh
     ELSE IF(ALLOCATED(ss2%nnktorlh)) THEN
        CALL ps_conformal("nnktorlh",ss2%nnktorlh,ss3%nnktorlh,iout,ierr)
        ss3%nnktorlh = ss2%nnktorlh
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%nphi)).AND.(cclist(ps_cnum_IC).EQ.1)) THEN
     IF(ALLOCATED(ss1%nphi).AND.ALLOCATED(ss2%nphi)) THEN
        CALL ps_diff("nphi",ss1%nphi,ss2%nphi,icheck,iout,ierr)
        CALL ps_conformal("nphi",ss1%nphi,ss3%nphi,iout,ierr)
        if(ierr.eq.0) ss3%nphi = ss1%nphi
     ELSE IF(ALLOCATED(ss1%nphi)) THEN
        CALL ps_conformal("nphi",ss1%nphi,ss3%nphi,iout,ierr)
        ss3%nphi = ss1%nphi
     ELSE IF(ALLOCATED(ss2%nphi)) THEN
        CALL ps_conformal("nphi",ss2%nphi,ss3%nphi,iout,ierr)
        ss3%nphi = ss2%nphi
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%nrw)).AND.(cclist(ps_cnum_RUNAWAY).EQ.1)) THEN
     IF(ALLOCATED(ss1%nrw).AND.ALLOCATED(ss2%nrw)) THEN
        CALL ps_conformal("nrw",ss2%nrw,ss3%nrw,iout,ierr)
        CALL ps_conformal("nrw",ss1%nrw,ss3%nrw,iout,ierr)
        if(ierr.eq.0) ss3%nrw = w1*ss1%nrw + (1.0_rspec-w1)*ss2%nrw
     ELSE IF(ALLOCATED(ss1%nrw)) THEN
        CALL ps_conformal("nrw",ss1%nrw,ss3%nrw,iout,ierr)
        ss3%nrw = ss1%nrw
     ELSE IF(ALLOCATED(ss2%nrw)) THEN
        CALL ps_conformal("nrw",ss2%nrw,ss3%nrw,iout,ierr)
        ss3%nrw = ss2%nrw
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%nrz_antgeo)).AND.(cclist(ps_cnum_IC).EQ.1)) THEN
     IF(ALLOCATED(ss1%nrz_antgeo).AND.ALLOCATED(ss2%nrz_antgeo)) THEN
        CALL ps_diff("nrz_antgeo",ss1%nrz_antgeo,ss2%nrz_antgeo,icheck,iout,ierr)
        CALL ps_conformal("nrz_antgeo",ss1%nrz_antgeo,ss3%nrz_antgeo,iout,ierr)
        if(ierr.eq.0) ss3%nrz_antgeo = ss1%nrz_antgeo
     ELSE IF(ALLOCATED(ss1%nrz_antgeo)) THEN
        CALL ps_conformal("nrz_antgeo",ss1%nrz_antgeo,ss3%nrz_antgeo,iout,ierr)
        ss3%nrz_antgeo = ss1%nrz_antgeo
     ELSE IF(ALLOCATED(ss2%nrz_antgeo)) THEN
        CALL ps_conformal("nrz_antgeo",ss2%nrz_antgeo,ss3%nrz_antgeo,iout,ierr)
        ss3%nrz_antgeo = ss2%nrz_antgeo
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%ns)).AND.(cclist(ps_cnum_PLASMA).EQ.1)) THEN
     IF(ALLOCATED(ss1%ns).AND.ALLOCATED(ss2%ns)) THEN
        CALL ps_conformal("ns",ss2%ns,ss3%ns,iout,ierr)
        CALL ps_conformal("ns",ss1%ns,ss3%ns,iout,ierr)
        if(ierr.eq.0) ss3%ns = w1*ss1%ns + (1.0_rspec-w1)*ss2%ns
     ELSE IF(ALLOCATED(ss1%ns)) THEN
        CALL ps_conformal("ns",ss1%ns,ss3%ns,iout,ierr)
        ss3%ns = ss1%ns
     ELSE IF(ALLOCATED(ss2%ns)) THEN
        CALL ps_conformal("ns",ss2%ns,ss3%ns,iout,ierr)
        ss3%ns = ss2%ns
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%nspectrumlh_src)).AND.(cclist(ps_cnum_LH).EQ.1)) THEN
     IF(ALLOCATED(ss1%nspectrumlh_src).AND.ALLOCATED(ss2%nspectrumlh_src)) THEN
        CALL ps_diff("nspectrumlh_src",ss1%nspectrumlh_src,ss2%nspectrumlh_src,icheck,iout,ierr)
        CALL ps_conformal("nspectrumlh_src",ss1%nspectrumlh_src,ss3%nspectrumlh_src,iout,ierr)
        if(ierr.eq.0) ss3%nspectrumlh_src = ss1%nspectrumlh_src
     ELSE IF(ALLOCATED(ss1%nspectrumlh_src)) THEN
        CALL ps_conformal("nspectrumlh_src",ss1%nspectrumlh_src,ss3%nspectrumlh_src,iout,ierr)
        ss3%nspectrumlh_src = ss1%nspectrumlh_src
     ELSE IF(ALLOCATED(ss2%nspectrumlh_src)) THEN
        CALL ps_conformal("nspectrumlh_src",ss2%nspectrumlh_src,ss3%nspectrumlh_src,iout,ierr)
        ss3%nspectrumlh_src = ss2%nspectrumlh_src
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%ns_bdy)).AND.(cclist(ps_cnum_PLASMA).EQ.1)) THEN
     IF(ALLOCATED(ss1%ns_bdy).AND.ALLOCATED(ss2%ns_bdy)) THEN
        CALL ps_conformal("ns_bdy",ss2%ns_bdy,ss3%ns_bdy,iout,ierr)
        CALL ps_conformal("ns_bdy",ss1%ns_bdy,ss3%ns_bdy,iout,ierr)
        if(ierr.eq.0) ss3%ns_bdy = w1*ss1%ns_bdy + (1.0_rspec-w1)*ss2%ns_bdy
     ELSE IF(ALLOCATED(ss1%ns_bdy)) THEN
        CALL ps_conformal("ns_bdy",ss1%ns_bdy,ss3%ns_bdy,iout,ierr)
        ss3%ns_bdy = ss1%ns_bdy
     ELSE IF(ALLOCATED(ss2%ns_bdy)) THEN
        CALL ps_conformal("ns_bdy",ss2%ns_bdy,ss3%ns_bdy,iout,ierr)
        ss3%ns_bdy = ss2%ns_bdy
     ENDIF
  ENDIF

  IF(cclist(ps_cnum_PLASMA).EQ.1) THEN

     CALL ps_diff("ns_Data_Info",ss1%ns_Data_Info,ss2%ns_Data_Info,icheck,iout,ierr)
     ss3%ns_Data_Info = ss1%ns_Data_Info
  ENDIF

  IF((ALLOCATED(ss3%ns_is_input)).AND.(cclist(ps_cnum_PLASMA).EQ.1)) THEN
     IF(ALLOCATED(ss1%ns_is_input).AND.ALLOCATED(ss2%ns_is_input)) THEN
        CALL ps_diff("ns_is_input",ss1%ns_is_input,ss2%ns_is_input,icheck,iout,ierr)
        CALL ps_conformal("ns_is_input",ss1%ns_is_input,ss3%ns_is_input,iout,ierr)
        if(ierr.eq.0) ss3%ns_is_input = ss1%ns_is_input
     ELSE IF(ALLOCATED(ss1%ns_is_input)) THEN
        CALL ps_conformal("ns_is_input",ss1%ns_is_input,ss3%ns_is_input,iout,ierr)
        ss3%ns_is_input = ss1%ns_is_input
     ELSE IF(ALLOCATED(ss2%ns_is_input)) THEN
        CALL ps_conformal("ns_is_input",ss2%ns_is_input,ss3%ns_is_input,iout,ierr)
        ss3%ns_is_input = ss2%ns_is_input
     ENDIF
  ENDIF

  IF(cclist(ps_cnum_RIPPLE).EQ.1) THEN

     CALL ps_diff("ntf_coil2",ss1%ntf_coil2,ss2%ntf_coil2,icheck,iout,ierr)
     ss3%ntf_coil2 = ss1%ntf_coil2
  ENDIF

END SUBROUTINE plasma_state_merge_4

subroutine ps_init_xpl(iobj,iout,ierr)

  !-----------------------------------------------------
  ! D. McCune 26 Nov 2007
  !
  ! Re-initialize xplasma object associated with state
  ! In version 1.xxx of the software this was done when xplasma_read(...)
  ! was invoked; with the I/O now done using NetCDF directly, this must
  ! be done as a separate step.
  !-----------------------------------------------------


  use plasma_state_definition_mod  ! plasma state object definitions
  use plasma_state_xpobj           ! XPLASMA2 state object definitions
  implicit NONE

  !-----------------------
  !  passed arguments:

  integer :: iobj(ps_container_size)              ! opaque handle => xplasma
  integer, intent(in) :: iout     ! Fortran LUN of file for messages
  integer, intent(out) :: ierr    ! completion status code (0=OK)

  type (interp_object) :: xobj
  type (xplasma), pointer :: s
  character*32 sname
  !-----------------------

  xobj = transfer(iobj,xobj)
  s => xobj%s_xpobj
  call xplasma_global_info(s,ierr, init_check=.TRUE., initLabel=sname)
  if(ierr.ne.0) then
     write(iout,*) ' ?ps_init_xpl: xplasma object invalid or uninitialized.'
     return
  endif

  call xplasma_init(s,sname,ierr,total=.TRUE.)
  if(ierr.ne.0) then
     write(iout,*) ' ?ps_init_xpl: xplasma_init error:'
     call xplasma_error(s,ierr,iout)
  endif

end subroutine ps_init_xpl

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


SUBROUTINE plasma_state_get_0(ss,icdf,version_change,iout,iertot)


  !  read subset of variables and arrays from NetCDF file

  USE plasma_state_definition_mod
  USE netcdf
  IMPLICIT NONE

  TYPE (plasma_state) :: ss     ! state data to read
  INTEGER, INTENT(IN) :: icdf   ! NetCDF file ID
  LOGICAL, INTENT(IN) :: version_change  ! flag file/software version mismatch
  INTEGER, INTENT(IN) :: iout   ! message LUN
  INTEGER, INTENT(INOUT) :: iertot  ! error count

  !--------------

  INTEGER :: varid,dimid,status,ilen,jlen,idims(20),indim
  INTEGER :: ii,iflag_alloc2,iflag_loc2,isize
  CHARACTER*80 :: nc_errmsg

  !--------------


  !-----------------------------------------------
  ! NetCDF reads...

  IF(ALLOCATED(ss%alla_index)) THEN
     status = nf90_inq_varid(icdf,"alla_index",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"alla_index")
     ELSE
        status = nf90_get_var(icdf,varid,ss%alla_index)
        IF(status.NE.NF90_NOERR) THEN
           ss%alla_index = 0
           CALL ncerr_name(2,status,"alla_index")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%ALLA_name)) THEN
     status = nf90_inq_varid(icdf,"ALLA_name",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"ALLA_name")
     ELSE
        status = nf90_get_var(icdf,varid,ss%ALLA_name)
        IF(status.NE.NF90_NOERR) THEN
           ss%ALLA_name = " "
           CALL ncerr_name(2,status,"ALLA_name")
        ELSE
           CALL denull_vec(ss%ALLA_name,ss%nspec_alla+1)
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%ALLA_type)) THEN
     status = nf90_inq_varid(icdf,"ALLA_type",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"ALLA_type")
     ELSE
        status = nf90_get_var(icdf,varid,ss%ALLA_type)
        IF(status.NE.NF90_NOERR) THEN
           ss%ALLA_type = 0
           CALL ncerr_name(2,status,"ALLA_type")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%all_index)) THEN
     status = nf90_inq_varid(icdf,"all_index",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"all_index")
     ELSE
        status = nf90_get_var(icdf,varid,ss%all_index)
        IF(status.NE.NF90_NOERR) THEN
           ss%all_index = 0
           CALL ncerr_name(2,status,"all_index")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%ALL_name)) THEN
     status = nf90_inq_varid(icdf,"ALL_name",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"ALL_name")
     ELSE
        status = nf90_get_var(icdf,varid,ss%ALL_name)
        IF(status.NE.NF90_NOERR) THEN
           ss%ALL_name = " "
           CALL ncerr_name(2,status,"ALL_name")
        ELSE
           CALL denull_vec(ss%ALL_name,ss%nspec_all+1)
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%ALL_type)) THEN
     status = nf90_inq_varid(icdf,"ALL_type",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"ALL_type")
     ELSE
        status = nf90_get_var(icdf,varid,ss%ALL_type)
        IF(status.NE.NF90_NOERR) THEN
           ss%ALL_type = 0
           CALL ncerr_name(2,status,"ALL_type")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%amaxlh)) THEN
     status = nf90_inq_varid(icdf,"amaxlh",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"amaxlh")
     ELSE
        status = nf90_get_var(icdf,varid,ss%amaxlh)
        IF(status.NE.NF90_NOERR) THEN
           ss%amaxlh = 0.0_rspec
           CALL ncerr_name(2,status,"amaxlh")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%aminlh)) THEN
     status = nf90_inq_varid(icdf,"aminlh",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"aminlh")
     ELSE
        status = nf90_get_var(icdf,varid,ss%aminlh)
        IF(status.NE.NF90_NOERR) THEN
           ss%aminlh = 0.0_rspec
           CALL ncerr_name(2,status,"aminlh")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%Ang_Href_coil)) THEN
     status = nf90_inq_varid(icdf,"Ang_Href_coil",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"Ang_Href_coil")
     ELSE
        status = nf90_get_var(icdf,varid,ss%Ang_Href_coil)
        IF(status.NE.NF90_NOERR) THEN
           ss%Ang_Href_coil = 0.0_rspec
           CALL ncerr_name(2,status,"Ang_Href_coil")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%Ang_Vref_coil)) THEN
     status = nf90_inq_varid(icdf,"Ang_Vref_coil",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"Ang_Vref_coil")
     ELSE
        status = nf90_get_var(icdf,varid,ss%Ang_Vref_coil)
        IF(status.NE.NF90_NOERR) THEN
           ss%Ang_Vref_coil = 0.0_rspec
           CALL ncerr_name(2,status,"Ang_Vref_coil")
        ENDIF
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"ANOM_Code_Info",varid)
  IF(status.NE.NF90_NOERR) THEN
     CALL ncerr_name(1,status,"ANOM_Code_Info")
  ELSE
     ilen = len(ss%ANOM_Code_Info)
     status = nf90_inquire_variable(icdf,varid,ndims=indim,dimids=idims)
     IF((status.EQ.NF90_NOERR).AND.(indim.eq.1)) THEN
        status = nf90_inquire_dimension(icdf,idims(1),len=jlen)
        IF(status.EQ.NF90_NOERR) ilen=min(ilen,jlen)
     ENDIF
     ss%ANOM_Code_Info = " "
     status = nf90_get_var(icdf,varid,ss%ANOM_Code_Info(1:ilen))
     IF(status.NE.NF90_NOERR) THEN
        ss%ANOM_Code_Info = " "
        CALL ncerr_name(2,status,"ANOM_Code_Info")
     ELSE
        CALL denull(ss%ANOM_Code_Info)
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%anom_evar)) THEN
     status = nf90_inq_varid(icdf,"anom_evar",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"anom_evar")
     ELSE
        status = nf90_get_var(icdf,varid,ss%anom_evar)
        IF(status.NE.NF90_NOERR) THEN
           ss%anom_evar = 0.0_rspec
           CALL ncerr_name(2,status,"anom_evar")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%ant_model)) THEN
     status = nf90_inq_varid(icdf,"ant_model",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"ant_model")
     ELSE
        status = nf90_get_var(icdf,varid,ss%ant_model)
        IF(status.NE.NF90_NOERR) THEN
           ss%ant_model = " "
           CALL ncerr_name(2,status,"ant_model")
        ELSE
           CALL denull_vec(ss%ant_model,ss%nicrf_src)
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%ap2_halfheight)) THEN
     status = nf90_inq_varid(icdf,"ap2_halfheight",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"ap2_halfheight")
     ELSE
        status = nf90_get_var(icdf,varid,ss%ap2_halfheight)
        IF(status.NE.NF90_NOERR) THEN
           ss%ap2_halfheight = 0.0_rspec
           CALL ncerr_name(2,status,"ap2_halfheight")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%ap2_halfwidth)) THEN
     status = nf90_inq_varid(icdf,"ap2_halfwidth",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"ap2_halfwidth")
     ELSE
        status = nf90_get_var(icdf,varid,ss%ap2_halfwidth)
        IF(status.NE.NF90_NOERR) THEN
           ss%ap2_halfwidth = 0.0_rspec
           CALL ncerr_name(2,status,"ap2_halfwidth")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%ap2_horiz_offset)) THEN
     status = nf90_inq_varid(icdf,"ap2_horiz_offset",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"ap2_horiz_offset")
     ELSE
        status = nf90_get_var(icdf,varid,ss%ap2_horiz_offset)
        IF(status.NE.NF90_NOERR) THEN
           ss%ap2_horiz_offset = 0.0_rspec
           CALL ncerr_name(2,status,"ap2_horiz_offset")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%ap2_vert_offset)) THEN
     status = nf90_inq_varid(icdf,"ap2_vert_offset",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"ap2_vert_offset")
     ELSE
        status = nf90_get_var(icdf,varid,ss%ap2_vert_offset)
        IF(status.NE.NF90_NOERR) THEN
           ss%ap2_vert_offset = 0.0_rspec
           CALL ncerr_name(2,status,"ap2_vert_offset")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%apolmaxlh)) THEN
     status = nf90_inq_varid(icdf,"apolmaxlh",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"apolmaxlh")
     ELSE
        status = nf90_get_var(icdf,varid,ss%apolmaxlh)
        IF(status.NE.NF90_NOERR) THEN
           ss%apolmaxlh = 0.0_rspec
           CALL ncerr_name(2,status,"apolmaxlh")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%apolminlh)) THEN
     status = nf90_inq_varid(icdf,"apolminlh",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"apolminlh")
     ELSE
        status = nf90_get_var(icdf,varid,ss%apolminlh)
        IF(status.NE.NF90_NOERR) THEN
           ss%apolminlh = 0.0_rspec
           CALL ncerr_name(2,status,"apolminlh")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%ap_halfheight)) THEN
     status = nf90_inq_varid(icdf,"ap_halfheight",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"ap_halfheight")
     ELSE
        status = nf90_get_var(icdf,varid,ss%ap_halfheight)
        IF(status.NE.NF90_NOERR) THEN
           ss%ap_halfheight = 0.0_rspec
           CALL ncerr_name(2,status,"ap_halfheight")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%ap_halfwidth)) THEN
     status = nf90_inq_varid(icdf,"ap_halfwidth",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"ap_halfwidth")
     ELSE
        status = nf90_get_var(icdf,varid,ss%ap_halfwidth)
        IF(status.NE.NF90_NOERR) THEN
           ss%ap_halfwidth = 0.0_rspec
           CALL ncerr_name(2,status,"ap_halfwidth")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%ap_horiz_offset)) THEN
     status = nf90_inq_varid(icdf,"ap_horiz_offset",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"ap_horiz_offset")
     ELSE
        status = nf90_get_var(icdf,varid,ss%ap_horiz_offset)
        IF(status.NE.NF90_NOERR) THEN
           ss%ap_horiz_offset = 0.0_rspec
           CALL ncerr_name(2,status,"ap_horiz_offset")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%ap_vert_offset)) THEN
     status = nf90_inq_varid(icdf,"ap_vert_offset",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"ap_vert_offset")
     ELSE
        status = nf90_get_var(icdf,varid,ss%ap_vert_offset)
        IF(status.NE.NF90_NOERR) THEN
           ss%ap_vert_offset = 0.0_rspec
           CALL ncerr_name(2,status,"ap_vert_offset")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%area)) THEN
     status = nf90_inq_varid(icdf,"area",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"area")
     ELSE
        status = nf90_get_var(icdf,varid,ss%area)
        IF(status.NE.NF90_NOERR) THEN
           ss%area = 0.0_rspec
           CALL ncerr_name(2,status,"area")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%atormaxlh)) THEN
     status = nf90_inq_varid(icdf,"atormaxlh",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"atormaxlh")
     ELSE
        status = nf90_get_var(icdf,varid,ss%atormaxlh)
        IF(status.NE.NF90_NOERR) THEN
           ss%atormaxlh = 0.0_rspec
           CALL ncerr_name(2,status,"atormaxlh")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%atorminlh)) THEN
     status = nf90_inq_varid(icdf,"atorminlh",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"atorminlh")
     ELSE
        status = nf90_get_var(icdf,varid,ss%atorminlh)
        IF(status.NE.NF90_NOERR) THEN
           ss%atorminlh = 0.0_rspec
           CALL ncerr_name(2,status,"atorminlh")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%Balloon_code)) THEN
     status = nf90_inq_varid(icdf,"Balloon_code",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"Balloon_code")
     ELSE
        status = nf90_get_var(icdf,varid,ss%Balloon_code)
        IF(status.NE.NF90_NOERR) THEN
           ss%Balloon_code = " "
           CALL ncerr_name(2,status,"Balloon_code")
        ELSE
           CALL denull_vec(ss%Balloon_code,ss%nballoon)
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%Balloon_mapper)) THEN
     status = nf90_inq_varid(icdf,"Balloon_mapper",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"Balloon_mapper")
     ELSE
        status = nf90_get_var(icdf,varid,ss%Balloon_mapper)
        IF(status.NE.NF90_NOERR) THEN
           ss%Balloon_mapper = " "
           CALL ncerr_name(2,status,"Balloon_mapper")
        ELSE
           CALL denull_vec(ss%Balloon_mapper,ss%nballoon)
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%Balloon_stable)) THEN
     status = nf90_inq_varid(icdf,"Balloon_stable",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"Balloon_stable")
     ELSE
        status = nf90_get_var(icdf,varid,ss%Balloon_stable)
        IF(status.NE.NF90_NOERR) THEN
           ss%Balloon_stable = 0
           CALL ncerr_name(2,status,"Balloon_stable")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%Balloon_status)) THEN
     status = nf90_inq_varid(icdf,"Balloon_status",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"Balloon_status")
     ELSE
        status = nf90_get_var(icdf,varid,ss%Balloon_status)
        IF(status.NE.NF90_NOERR) THEN
           ss%Balloon_status = 0
           CALL ncerr_name(2,status,"Balloon_status")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%balstab)) THEN
     status = nf90_inq_varid(icdf,"balstab",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"balstab")
     ELSE
        status = nf90_get_var(icdf,varid,ss%balstab)
        IF(status.NE.NF90_NOERR) THEN
           ss%balstab = 0.0_rspec
           CALL ncerr_name(2,status,"balstab")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%beam_type)) THEN
     status = nf90_inq_varid(icdf,"beam_type",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"beam_type")
     ELSE
        status = nf90_get_var(icdf,varid,ss%beam_type)
        IF(status.NE.NF90_NOERR) THEN
           ss%beam_type = " "
           CALL ncerr_name(2,status,"beam_type")
        ELSE
           CALL denull_vec(ss%beam_type,ss%nbeam)
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%bidiff_bpass_co)) THEN
     status = nf90_inq_varid(icdf,"bidiff_bpass_co",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"bidiff_bpass_co")
     ELSE
        status = nf90_get_var(icdf,varid,ss%bidiff_bpass_co)
        IF(status.NE.NF90_NOERR) THEN
           ss%bidiff_bpass_co = 0.0_rspec
           CALL ncerr_name(2,status,"bidiff_bpass_co")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%bidiff_bpass_ctr)) THEN
     status = nf90_inq_varid(icdf,"bidiff_bpass_ctr",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"bidiff_bpass_ctr")
     ELSE
        status = nf90_get_var(icdf,varid,ss%bidiff_bpass_ctr)
        IF(status.NE.NF90_NOERR) THEN
           ss%bidiff_bpass_ctr = 0.0_rspec
           CALL ncerr_name(2,status,"bidiff_bpass_ctr")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%bidiff_btrap)) THEN
     status = nf90_inq_varid(icdf,"bidiff_btrap",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"bidiff_btrap")
     ELSE
        status = nf90_get_var(icdf,varid,ss%bidiff_btrap)
        IF(status.NE.NF90_NOERR) THEN
           ss%bidiff_btrap = 0.0_rspec
           CALL ncerr_name(2,status,"bidiff_btrap")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%bidiff_dpass_co)) THEN
     status = nf90_inq_varid(icdf,"bidiff_dpass_co",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"bidiff_dpass_co")
     ELSE
        status = nf90_get_var(icdf,varid,ss%bidiff_dpass_co)
        IF(status.NE.NF90_NOERR) THEN
           ss%bidiff_dpass_co = 0.0_rspec
           CALL ncerr_name(2,status,"bidiff_dpass_co")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%bidiff_dpass_ctr)) THEN
     status = nf90_inq_varid(icdf,"bidiff_dpass_ctr",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"bidiff_dpass_ctr")
     ELSE
        status = nf90_get_var(icdf,varid,ss%bidiff_dpass_ctr)
        IF(status.NE.NF90_NOERR) THEN
           ss%bidiff_dpass_ctr = 0.0_rspec
           CALL ncerr_name(2,status,"bidiff_dpass_ctr")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%bidiff_dtrap)) THEN
     status = nf90_inq_varid(icdf,"bidiff_dtrap",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"bidiff_dtrap")
     ELSE
        status = nf90_get_var(icdf,varid,ss%bidiff_dtrap)
        IF(status.NE.NF90_NOERR) THEN
           ss%bidiff_dtrap = 0.0_rspec
           CALL ncerr_name(2,status,"bidiff_dtrap")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%BphiRZ)) THEN
     status = nf90_inq_varid(icdf,"BphiRZ",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"BphiRZ")
     ELSE
        status = nf90_get_var(icdf,varid,ss%BphiRZ)
        IF(status.NE.NF90_NOERR) THEN
           ss%BphiRZ = 0.0_rspec
           CALL ncerr_name(2,status,"BphiRZ")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%BRRZ)) THEN
     status = nf90_inq_varid(icdf,"BRRZ",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"BRRZ")
     ELSE
        status = nf90_get_var(icdf,varid,ss%BRRZ)
        IF(status.NE.NF90_NOERR) THEN
           ss%BRRZ = 0.0_rspec
           CALL ncerr_name(2,status,"BRRZ")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%BZRZ)) THEN
     status = nf90_inq_varid(icdf,"BZRZ",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"BZRZ")
     ELSE
        status = nf90_get_var(icdf,varid,ss%BZRZ)
        IF(status.NE.NF90_NOERR) THEN
           ss%BZRZ = 0.0_rspec
           CALL ncerr_name(2,status,"BZRZ")
        ENDIF
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"B_axis",varid)
  IF(status.NE.NF90_NOERR) THEN
     CALL ncerr_name(1,status,"B_axis")
  ELSE
     status = nf90_get_var(icdf,varid,ss%B_axis)
     IF(status.NE.NF90_NOERR) THEN
        ss%B_axis = 0.0_rspec
        CALL ncerr_name(2,status,"B_axis")
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"B_axis_vac",varid)
  IF(status.NE.NF90_NOERR) THEN
     CALL ncerr_name(1,status,"B_axis_vac")
  ELSE
     status = nf90_get_var(icdf,varid,ss%B_axis_vac)
     IF(status.NE.NF90_NOERR) THEN
        ss%B_axis_vac = 0.0_rspec
        CALL ncerr_name(2,status,"B_axis_vac")
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%b_halfHeight)) THEN
     status = nf90_inq_varid(icdf,"b_halfHeight",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"b_halfHeight")
     ELSE
        status = nf90_get_var(icdf,varid,ss%b_halfHeight)
        IF(status.NE.NF90_NOERR) THEN
           ss%b_halfHeight = 0.0_rspec
           CALL ncerr_name(2,status,"b_halfHeight")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%b_halfwidth)) THEN
     status = nf90_inq_varid(icdf,"b_halfwidth",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"b_halfwidth")
     ELSE
        status = nf90_get_var(icdf,varid,ss%b_halfwidth)
        IF(status.NE.NF90_NOERR) THEN
           ss%b_halfwidth = 0.0_rspec
           CALL ncerr_name(2,status,"b_halfwidth")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%b_Hdivergence)) THEN
     status = nf90_inq_varid(icdf,"b_Hdivergence",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"b_Hdivergence")
     ELSE
        status = nf90_get_var(icdf,varid,ss%b_Hdivergence)
        IF(status.NE.NF90_NOERR) THEN
           ss%b_Hdivergence = 0.0_rspec
           CALL ncerr_name(2,status,"b_Hdivergence")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%b_Hfocal_length)) THEN
     status = nf90_inq_varid(icdf,"b_Hfocal_length",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"b_Hfocal_length")
     ELSE
        status = nf90_get_var(icdf,varid,ss%b_Hfocal_length)
        IF(status.NE.NF90_NOERR) THEN
           ss%b_Hfocal_length = 0.0_rspec
           CALL ncerr_name(2,status,"b_Hfocal_length")
        ENDIF
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"B_max_lcfs",varid)
  IF(status.NE.NF90_NOERR) THEN
     CALL ncerr_name(1,status,"B_max_lcfs")
  ELSE
     status = nf90_get_var(icdf,varid,ss%B_max_lcfs)
     IF(status.NE.NF90_NOERR) THEN
        ss%B_max_lcfs = 0.0_rspec
        CALL ncerr_name(2,status,"B_max_lcfs")
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"B_min_lcfs",varid)
  IF(status.NE.NF90_NOERR) THEN
     CALL ncerr_name(1,status,"B_min_lcfs")
  ELSE
     status = nf90_get_var(icdf,varid,ss%B_min_lcfs)
     IF(status.NE.NF90_NOERR) THEN
        ss%B_min_lcfs = 0.0_rspec
        CALL ncerr_name(2,status,"B_min_lcfs")
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%B_surfMax)) THEN
     status = nf90_inq_varid(icdf,"B_surfMax",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"B_surfMax")
     ELSE
        status = nf90_get_var(icdf,varid,ss%B_surfMax)
        IF(status.NE.NF90_NOERR) THEN
           ss%B_surfMax = 0.0_rspec
           CALL ncerr_name(2,status,"B_surfMax")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%B_surfMin)) THEN
     status = nf90_inq_varid(icdf,"B_surfMin",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"B_surfMin")
     ELSE
        status = nf90_get_var(icdf,varid,ss%B_surfMin)
        IF(status.NE.NF90_NOERR) THEN
           ss%B_surfMin = 0.0_rspec
           CALL ncerr_name(2,status,"B_surfMin")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%b_Vdivergence)) THEN
     status = nf90_inq_varid(icdf,"b_Vdivergence",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"b_Vdivergence")
     ELSE
        status = nf90_get_var(icdf,varid,ss%b_Vdivergence)
        IF(status.NE.NF90_NOERR) THEN
           ss%b_Vdivergence = 0.0_rspec
           CALL ncerr_name(2,status,"b_Vdivergence")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%b_Vfocal_length)) THEN
     status = nf90_inq_varid(icdf,"b_Vfocal_length",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"b_Vfocal_length")
     ELSE
        status = nf90_get_var(icdf,varid,ss%b_Vfocal_length)
        IF(status.NE.NF90_NOERR) THEN
           ss%b_Vfocal_length = 0.0_rspec
           CALL ncerr_name(2,status,"b_Vfocal_length")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%cdicrf)) THEN
     status = nf90_inq_varid(icdf,"cdicrf",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"cdicrf")
     ELSE
        status = nf90_get_var(icdf,varid,ss%cdicrf)
        IF(status.NE.NF90_NOERR) THEN
           ss%cdicrf = 0.0_rspec
           CALL ncerr_name(2,status,"cdicrf")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%cdicrf_nphi)) THEN
     status = nf90_inq_varid(icdf,"cdicrf_nphi",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"cdicrf_nphi")
     ELSE
        status = nf90_get_var(icdf,varid,ss%cdicrf_nphi)
        IF(status.NE.NF90_NOERR) THEN
           ss%cdicrf_nphi = 0.0_rspec
           CALL ncerr_name(2,status,"cdicrf_nphi")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%chie_anom)) THEN
     status = nf90_inq_varid(icdf,"chie_anom",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"chie_anom")
     ELSE
        status = nf90_get_var(icdf,varid,ss%chie_anom)
        IF(status.NE.NF90_NOERR) THEN
           ss%chie_anom = 0.0_rspec
           CALL ncerr_name(2,status,"chie_anom")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%chie_drbm)) THEN
     status = nf90_inq_varid(icdf,"chie_drbm",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"chie_drbm")
     ELSE
        status = nf90_get_var(icdf,varid,ss%chie_drbm)
        IF(status.NE.NF90_NOERR) THEN
           ss%chie_drbm = 0.0_rspec
           CALL ncerr_name(2,status,"chie_drbm")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%chie_etg)) THEN
     status = nf90_inq_varid(icdf,"chie_etg",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"chie_etg")
     ELSE
        status = nf90_get_var(icdf,varid,ss%chie_etg)
        IF(status.NE.NF90_NOERR) THEN
           ss%chie_etg = 0.0_rspec
           CALL ncerr_name(2,status,"chie_etg")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%chie_glf)) THEN
     status = nf90_inq_varid(icdf,"chie_glf",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"chie_glf")
     ELSE
        status = nf90_get_var(icdf,varid,ss%chie_glf)
        IF(status.NE.NF90_NOERR) THEN
           ss%chie_glf = 0.0_rspec
           CALL ncerr_name(2,status,"chie_glf")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%chie_gtcneo)) THEN
     status = nf90_inq_varid(icdf,"chie_gtcneo",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"chie_gtcneo")
     ELSE
        status = nf90_get_var(icdf,varid,ss%chie_gtcneo)
        IF(status.NE.NF90_NOERR) THEN
           ss%chie_gtcneo = 0.0_rspec
           CALL ncerr_name(2,status,"chie_gtcneo")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%chie_mmm71)) THEN
     status = nf90_inq_varid(icdf,"chie_mmm71",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"chie_mmm71")
     ELSE
        status = nf90_get_var(icdf,varid,ss%chie_mmm71)
        IF(status.NE.NF90_NOERR) THEN
           ss%chie_mmm71 = 0.0_rspec
           CALL ncerr_name(2,status,"chie_mmm71")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%chie_mtm)) THEN
     status = nf90_inq_varid(icdf,"chie_mtm",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"chie_mtm")
     ELSE
        status = nf90_get_var(icdf,varid,ss%chie_mtm)
        IF(status.NE.NF90_NOERR) THEN
           ss%chie_mtm = 0.0_rspec
           CALL ncerr_name(2,status,"chie_mtm")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%chie_nclass)) THEN
     status = nf90_inq_varid(icdf,"chie_nclass",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"chie_nclass")
     ELSE
        status = nf90_get_var(icdf,varid,ss%chie_nclass)
        IF(status.NE.NF90_NOERR) THEN
           ss%chie_nclass = 0.0_rspec
           CALL ncerr_name(2,status,"chie_nclass")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%chie_neo)) THEN
     status = nf90_inq_varid(icdf,"chie_neo",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"chie_neo")
     ELSE
        status = nf90_get_var(icdf,varid,ss%chie_neo)
        IF(status.NE.NF90_NOERR) THEN
           ss%chie_neo = 0.0_rspec
           CALL ncerr_name(2,status,"chie_neo")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%chie_ntm)) THEN
     status = nf90_inq_varid(icdf,"chie_ntm",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"chie_ntm")
     ELSE
        status = nf90_get_var(icdf,varid,ss%chie_ntm)
        IF(status.NE.NF90_NOERR) THEN
           ss%chie_ntm = 0.0_rspec
           CALL ncerr_name(2,status,"chie_ntm")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%chie_paleo)) THEN
     status = nf90_inq_varid(icdf,"chie_paleo",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"chie_paleo")
     ELSE
        status = nf90_get_var(icdf,varid,ss%chie_paleo)
        IF(status.NE.NF90_NOERR) THEN
           ss%chie_paleo = 0.0_rspec
           CALL ncerr_name(2,status,"chie_paleo")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%chie_tglf)) THEN
     status = nf90_inq_varid(icdf,"chie_tglf",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"chie_tglf")
     ELSE
        status = nf90_get_var(icdf,varid,ss%chie_tglf)
        IF(status.NE.NF90_NOERR) THEN
           ss%chie_tglf = 0.0_rspec
           CALL ncerr_name(2,status,"chie_tglf")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%chie_trans)) THEN
     status = nf90_inq_varid(icdf,"chie_trans",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"chie_trans")
     ELSE
        status = nf90_get_var(icdf,varid,ss%chie_trans)
        IF(status.NE.NF90_NOERR) THEN
           ss%chie_trans = 0.0_rspec
           CALL ncerr_name(2,status,"chie_trans")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%chie_transcat)) THEN
     status = nf90_inq_varid(icdf,"chie_transcat",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"chie_transcat")
     ELSE
        status = nf90_get_var(icdf,varid,ss%chie_transcat)
        IF(status.NE.NF90_NOERR) THEN
           ss%chie_transcat = 0.0_rspec
           CALL ncerr_name(2,status,"chie_transcat")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%chie_w19)) THEN
     status = nf90_inq_varid(icdf,"chie_w19",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"chie_w19")
     ELSE
        status = nf90_get_var(icdf,varid,ss%chie_w19)
        IF(status.NE.NF90_NOERR) THEN
           ss%chie_w19 = 0.0_rspec
           CALL ncerr_name(2,status,"chie_w19")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%chii_anom)) THEN
     status = nf90_inq_varid(icdf,"chii_anom",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"chii_anom")
     ELSE
        status = nf90_get_var(icdf,varid,ss%chii_anom)
        IF(status.NE.NF90_NOERR) THEN
           ss%chii_anom = 0.0_rspec
           CALL ncerr_name(2,status,"chii_anom")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%chii_drbm)) THEN
     status = nf90_inq_varid(icdf,"chii_drbm",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"chii_drbm")
     ELSE
        status = nf90_get_var(icdf,varid,ss%chii_drbm)
        IF(status.NE.NF90_NOERR) THEN
           ss%chii_drbm = 0.0_rspec
           CALL ncerr_name(2,status,"chii_drbm")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%chii_glf)) THEN
     status = nf90_inq_varid(icdf,"chii_glf",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"chii_glf")
     ELSE
        status = nf90_get_var(icdf,varid,ss%chii_glf)
        IF(status.NE.NF90_NOERR) THEN
           ss%chii_glf = 0.0_rspec
           CALL ncerr_name(2,status,"chii_glf")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%chii_gtcneo)) THEN
     status = nf90_inq_varid(icdf,"chii_gtcneo",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"chii_gtcneo")
     ELSE
        status = nf90_get_var(icdf,varid,ss%chii_gtcneo)
        IF(status.NE.NF90_NOERR) THEN
           ss%chii_gtcneo = 0.0_rspec
           CALL ncerr_name(2,status,"chii_gtcneo")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%chii_mmm71)) THEN
     status = nf90_inq_varid(icdf,"chii_mmm71",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"chii_mmm71")
     ELSE
        status = nf90_get_var(icdf,varid,ss%chii_mmm71)
        IF(status.NE.NF90_NOERR) THEN
           ss%chii_mmm71 = 0.0_rspec
           CALL ncerr_name(2,status,"chii_mmm71")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%chii_nclass)) THEN
     status = nf90_inq_varid(icdf,"chii_nclass",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"chii_nclass")
     ELSE
        status = nf90_get_var(icdf,varid,ss%chii_nclass)
        IF(status.NE.NF90_NOERR) THEN
           ss%chii_nclass = 0.0_rspec
           CALL ncerr_name(2,status,"chii_nclass")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%chii_neo)) THEN
     status = nf90_inq_varid(icdf,"chii_neo",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"chii_neo")
     ELSE
        status = nf90_get_var(icdf,varid,ss%chii_neo)
        IF(status.NE.NF90_NOERR) THEN
           ss%chii_neo = 0.0_rspec
           CALL ncerr_name(2,status,"chii_neo")
        ENDIF
     ENDIF
  ENDIF

  CONTAINS
     SUBROUTINE denull_vec(vstr,isize)
        INTEGER, intent(in) :: isize
        CHARACTER*(*) :: vstr(isize)
        INTEGER :: i

        do i=1,isize
           call denull(vstr(i))
        enddo
     END SUBROUTINE denull_vec

     SUBROUTINE denull(str)
        ! convert null characters to blank
        CHARACTER*(*) :: str
        INTEGER :: i

        do i=1,len(str)
           if(ichar(str(i:i)).eq.0) str(i:i)=' '
        enddo
     END SUBROUTINE denull

     SUBROUTINE ncerr_name(itype,status,name)
        INTEGER, INTENT(in) :: itype
        INTEGER, INTENT(in) :: status
        CHARACTER*(*), INTENT(in) :: name

        if(itype.eq.1) then
           write(iout,*) ' %plasma_state_get: warning: variable name = "'// &
                  trim(name)//'":'
        else
           write(iout,*) ' ?plasma_state_get: error: variable name = "'// &
                  trim(name)//'":'
           if(version_change) then
              write(iout,*) '   => version change RECOVERY: variable reset to initial value.'
           else
              iertot = iertot + 1
           endif
        endif
        call ncerr(status)
     END SUBROUTINE ncerr_name

     SUBROUTINE ncerr(status)
        INTEGER, INTENT(in) :: status

        nc_errmsg = NF90_strerror(status)
        write(iout,*) '  NetCDF message: ',trim(nc_errmsg)
     END SUBROUTINE ncerr

END SUBROUTINE plasma_state_get_0

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_r7_dummy
     return
  end subroutine ccps_getset_r7_dummy

subroutine psget_real_ant_coef(iobj, n1, n2, data, ierr)
    !! real part of Fourier Coef
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_real_ant_coef', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % Real_ant_coef
end subroutine psget_real_ant_coef


subroutine psset_real_ant_coef(iobj, n1, n2, data, ierr)
    !! real part of Fourier Coef
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_real_ant_coef', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % Real_ant_coef = data(1:n1, 1: n2)
end subroutine psset_real_ant_coef


subroutine psgetrnk_real_ant_coef(iobj, ndims, ierr)
    !! real part of Fourier Coef
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_real_ant_coef


subroutine psgetdim_real_ant_coef(iobj, ndims, dims, ierr)
    !! real part of Fourier Coef
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_real_ant_coef', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % Real_ant_coef ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % Real_ant_coef)
    endif
end subroutine psgetdim_real_ant_coef


subroutine psget_runaway_code_info(iobj, data, ierr)
    !! Information: code implementing RUNAWAY component
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    CHARACTER*(*), intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_runaway_code_info', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % RUNAWAY_Code_Info
end subroutine psget_runaway_code_info


subroutine psset_runaway_code_info(iobj, data, ierr)
    !! Information: code implementing RUNAWAY component
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    CHARACTER*(*), intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_runaway_code_info', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % RUNAWAY_Code_Info = data
end subroutine psset_runaway_code_info


subroutine psgetsz_runaway_code_info(iobj, size, ierr)
    !! Information: code implementing RUNAWAY component
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: size    ! size of character string
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psgetsz_runaway_code_info', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! note that the following will return the character length size regardless of
    ! the number of array elements (if RUNAWAY_Code_Info is an array)
    size = len(ss % RUNAWAY_Code_Info)
end subroutine psgetsz_runaway_code_info


subroutine psget_rho_anomth(iobj, n1, data, ierr)
    !! rho grid (1d anomalous data for 1d, transport models)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_rho_anomth', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % rho_anomth
end subroutine psget_rho_anomth


subroutine psset_rho_anomth(iobj, n1, data, ierr)
    !! rho grid (1d anomalous data for 1d, transport models)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_rho_anomth', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % rho_anomth = data(1:n1)
end subroutine psset_rho_anomth


subroutine psgetrnk_rho_anomth(iobj, ndims, ierr)
    !! rho grid (1d anomalous data for 1d, transport models)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_rho_anomth


subroutine psgetdim_rho_anomth(iobj, ndims, dims, ierr)
    !! rho grid (1d anomalous data for 1d, transport models)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_rho_anomth', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % rho_anomth ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % rho_anomth)
    endif
end subroutine psgetdim_rho_anomth


subroutine psget_r_axis(iobj, data, ierr)
    !! R of magnetic axis
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_r_axis', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % R_axis
end subroutine psget_r_axis


subroutine psset_r_axis(iobj, data, ierr)
    !! R of magnetic axis
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_r_axis', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % R_axis = data
end subroutine psset_r_axis


subroutine psget_res_ti(iobj, n1, data, ierr)
    !! residuals for ion transport eqn
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_res_ti', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % res_ti
end subroutine psget_res_ti


subroutine psset_res_ti(iobj, n1, data, ierr)
    !! residuals for ion transport eqn
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_res_ti', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % res_ti = data(1:n1)
end subroutine psset_res_ti


subroutine psgetrnk_res_ti(iobj, ndims, ierr)
    !! residuals for ion transport eqn
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_res_ti


subroutine psgetdim_res_ti(iobj, ndims, dims, ierr)
    !! residuals for ion transport eqn
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_res_ti', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % res_ti ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % res_ti)
    endif
end subroutine psgetdim_res_ti


subroutine psget_r_surfmin(iobj, n1, data, ierr)
    !! min R on flux surface
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_r_surfmin', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % R_surfMin
end subroutine psget_r_surfmin


subroutine psset_r_surfmin(iobj, n1, data, ierr)
    !! min R on flux surface
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_r_surfmin', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % R_surfMin = data(1:n1)
end subroutine psset_r_surfmin


subroutine psgetrnk_r_surfmin(iobj, ndims, ierr)
    !! min R on flux surface
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_r_surfmin


subroutine psgetdim_r_surfmin(iobj, ndims, dims, ierr)
    !! min R on flux surface
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_r_surfmin', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % R_surfMin ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % R_surfMin)
    endif
end subroutine psgetdim_r_surfmin


subroutine psget_rate_sinf0i(iobj, n1, n2, data, ierr)
    !! sink rate due to ionization by fusion ions
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_rate_sinf0i', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % rate_sinf0i
end subroutine psget_rate_sinf0i


subroutine psset_rate_sinf0i(iobj, n1, n2, data, ierr)
    !! sink rate due to ionization by fusion ions
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_rate_sinf0i', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % rate_sinf0i = data(1:n1, 1: n2)
end subroutine psset_rate_sinf0i


subroutine psgetrnk_rate_sinf0i(iobj, ndims, ierr)
    !! sink rate due to ionization by fusion ions
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_rate_sinf0i


subroutine psgetdim_rate_sinf0i(iobj, ndims, dims, ierr)
    !! sink rate due to ionization by fusion ions
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_rate_sinf0i', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % rate_sinf0i ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % rate_sinf0i)
    endif
end subroutine psgetdim_rate_sinf0i

subroutine ccps_argcheck(srname,iobj,ierr)

  ! ccps_lib internal routine
  ! check that object argument is not empty (not all zero)

  use plasma_state_mod
  implicit NONE

  character*(*), intent(in) :: srname  ! name of caller
  integer :: iobj(*)
  integer, intent(out) :: ierr         ! status code 0=OK

  !-------------------------
  integer :: ii, ichk, iout
  !-------------------------

  ierr=0

  ichk=0
  do ii=1,ps_container_size
     if(iobj(ii).ne.0) then
        ichk=1
        exit
     endif
  enddo

  if(ichk.eq.0) then
     iout = Swim_err_out_file
     write(iout,*) ' ?'//trim(srname)//': state container "iobj" empty (all zeroes).'
     ierr=1
     return
  endif

end subroutine ccps_argcheck

subroutine ur_cstate_quasi_check(isel)

  !  Quasi-neutrality check on state #isel

  use cstate_lib_mod
  implicit NONE

  integer, intent(in) :: isel  ! selected state (btw 1 & nsss_cur)

  !------------------------
  ! local

  integer :: luntty,lnout
  logical :: lxout,lchar

  integer :: i,ii,jj,inrho,inrhom1,icopy,ins,ierr
  integer :: ith,inbi,ifus,irf
  real*8, dimension(:), allocatable :: my_rho,nzth,nzfast,nztot,adiff,rdiff,ne
  real*8, dimension(:,:), allocatable :: nall

  real*8, dimension(:), allocatable :: Zia
  logical, dimension(:), allocatable :: isfast

  real*8 :: ne1

  real*8, parameter :: ZERO = 0.0d0
  real*8, parameter :: ONE  = 1.0d0
  !------------------------

  luntty = lnout(0)

  !  error checks...

  if(nsss_cur.eq.0) then
     write(luntty,*) ' ur_cstate_quasi_check: no states are loaded.'
     return
  endif

  if((isel.le.0).or.(isel.gt.nsss_cur)) then
     write(luntty,*) ' ur_cstate_quasi_check: state index out of range:',isel
     return
  endif

  if(.NOT.allocated(sss(isel)%ns)) then
     write(luntty,*) ' ur_cstate_quasi_check: state thermal densities not found.'
     return
  endif

  if(.NOT.allocated(sss(isel)%qatom_all)) then
     write(luntty,*) ' ur_cstate_quasi_check: state merged specie list not found.'
     return
  endif

  i = isel
  ins = sss(i)%nspec_all

  do

     !  choose rho grid

     if(lxout(0)) then
        write(luntty,*) 'ur_cstate_quasi_check rho-grid select menu:'
        write(luntty,*) '  A -- use PLASMA grid, size is: ',sss(i)%nrho
        if(allocated(sss(i)%rho_nbi)) then
           write(luntty,*) '  B -- use NBI grid, size is: ',sss(i)%nrho_nbi
        endif
        if(allocated(sss(i)%rho_fus)) then
           write(luntty,*) '  C -- use FUS grid, size is: ',sss(i)%nrho_fus
        endif
        if(allocated(sss(i)%rho_icrf)) then
           write(luntty,*) '  D -- use IC grid, size is: ',sss(i)%nrho_icrf
        endif
        write(luntty,*) '  N -- use equispaced grid, user selected size.'
        write(luntty,*) '  U -- examine un-rezoned data.'
        write(luntty,*) '  Q -- quit this menu.'
     endif

     call uread('ur_cstate_quasi_check: menu option:')

     if(lchar('Q')) then
        exit

     else if(lchar('A')) then
        inrho = sss(i)%nrho
        icopy = 1

     else if(lchar('B')) then
        inrho = sss(i)%nrho_nbi
        icopy = 2

     else if(lchar('C')) then
        inrho = sss(i)%nrho_fus
        icopy = 3

     else if(lchar('D')) then
        inrho = sss(i)%nrho_icrf
        icopy = 4

     else if(lchar('U')) then
        call ur_cstate_nchk(isel)
        cycle

     else if(lchar('N')) then
        icopy = 0

        inrho = sss(i)%nrho
        if(lxout(0)) then
           write(luntty,*) ' #zones = grid size - 1'
        endif

        call ureadi('enter grid size btw 5 and 501:',inrho)
        inrho=max(5,min(501,inrho))

     else
        call uermsg('unrecognized menu option',' ',0)
        cycle
     endif

     !  allocate and initialize arrays

     if(inrho.eq.0) then
        call uermsg('ur_cstate_quasi_check: no such grid.',0)
        cycle
     endif

     if(inrho.gt.999) then
        call uermsi('grid too large, max size = 999',inrho,0)
        cycle
     endif

     if(allocated(my_rho)) then
        deallocate(isfast,Zia,my_rho,nzth,nzfast,nztot,adiff,rdiff,nall,ne)
     endif

     allocate(isfast(ins),Zia(ins))
     allocate(my_rho(inrho),nzth(inrho-1),nzfast(inrho-1),nztot(inrho-1))
     allocate(adiff(inrho-1),rdiff(inrho-1))
     allocate(nall(inrho-1,ins))
     allocate(ne(inrho-1))

     nzth = ZERO; nzfast = ZERO; nztot = ZERO
     adiff = ZERO; rdiff = ZERO
     nall = ZERO

     !  copy or generate chosen rho grid

     if(icopy.eq.1) then
        my_rho = sss(i)%rho
     else if(icopy.eq.2) then
        my_rho = sss(i)%rho_nbi
     else if(icopy.eq.3) then
        my_rho = sss(i)%rho_fus
     else if(icopy.eq.4) then
        my_rho = sss(i)%rho_icrf
     else
        my_rho(1) = ZERO
        my_rho(inrho) = ONE
        do jj = 2,inrho-1
           my_rho(jj) = (jj-1)*ONE/(inrho-1)
        enddo
     endif

     ! indexing for each ion category

     ith = 0
     inbi = 0
     ifus = 0
     irf = 0

     ! get electron density rezoned to chosen grid

     call ps_rho_rezone(my_rho,sss(i)%id_ns(0),ne,ierr, state=sss(i))
     if(ierr.ne.0) then
        call uermsg('ur_cstate_zeff_check: error during rezoning.',0)
        cycle
     endif

     ! get all the densities rezoned to the chosen grid
     ! get all the charge numbers

     do ii=1,ins
        if(sss(i)%all_type(ii).eq.ps_beam_ion) then
           inbi = inbi + 1
           Zia(ii) = sss(i)%q_snbi(inbi)/ps_xe
           call ps_rho_rezone(my_rho,sss(i)%id_nbeami(inbi),nall(:,ii),ierr, &
                state=sss(i))
           isfast(ii)=.TRUE.
           if(ierr.ne.0) exit

        else if(sss(i)%all_type(ii).eq.ps_fusion_ion) then
           ifus = ifus + 1
           Zia(ii) = sss(i)%q_sfus(ifus)/ps_xe
           call ps_rho_rezone(my_rho,sss(i)%id_nfusi(ifus),nall(:,ii),ierr, &
                state=sss(i))
           isfast(ii)=.TRUE.
           if(ierr.ne.0) exit

        else if(sss(i)%all_type(ii).eq.ps_rf_minority) then
           irf = irf + 1
           Zia(ii) = sss(i)%q_rfmin(irf)/ps_xe
           call ps_rho_rezone(my_rho,sss(i)%id_nmini(irf),nall(:,ii),ierr, &
                state=sss(i))
           isfast(ii)=.TRUE.
           if(ierr.ne.0) exit

        else
           ith = ith + 1
           Zia(ii) = sss(i)%q_s(ith)/ps_xe
           call ps_rho_rezone(my_rho,sss(i)%id_ns(ith),nall(:,ii),ierr, &
                state=sss(i))
           isfast(ii)=.FALSE.
           if(ierr.ne.0) exit
        endif
     enddo

     if(ierr.ne.0) then
        call uermsg('ur_cstate_quasi_check: error during rezoning.',0)
        cycle
     endif

     ! compute (summation arrays were already ZEROed).

     do ii=1,ins
        if(isfast(ii)) then
           nzfast = nzfast + Zia(ii)*nall(:,ii)
        else
           nzth = nzth + Zia(ii)*nall(:,ii)
        endif
     enddo

     nztot = nzfast + nzth

     ! compute absolute and relative deviation

     do jj=1,inrho-1
        ne1 = max(ONE,ne(jj))
        adiff(jj) = ne1-nztot(jj)
        rdiff(jj) = abs(adiff(jj))/ne1
     enddo

     ! printout

     write(luntty,*) ' '
     write(luntty,*) ' zone  th:Zi*ni    fast:Zi*ni  tot:Zi*ni   ne          diff        rel. diff '
     write(luntty,*) ' ----  ----------  ----------  ----------  ----------  ----------  ----------'
     do jj=1,inrho-1
        write(luntty,'(2x,i3,2x,6(1pe11.4,1x))') jj,nzth(jj),nzfast(jj), &
             nztot(jj),ne(jj),adiff(jj),rdiff(jj)
     enddo
     write(luntty,*) ' '

  enddo

end subroutine ur_cstate_quasi_check

subroutine cstate_empty_dims(luntty,ierr)

  ! find all empty dimensions (could be none...)
  ! MOD DMC: also set grid_dims

  use cstate_lib_mod
  implicit NONE

  integer, intent(in) :: luntty  ! LUN for messages

  !-------------------------
  ! local

  integer :: itype,ii,jj,isize,ilen,ierr,inum_empty,isize_dim,ici,iersum
  integer :: ing
  logical :: iok(nsss_cur)
  character*32 dim0,dim
  character*1 :: dtype(3) = (/ "G", "S", "L" /)
  !-------------------------

  write(luntty,*) ' '
  write(luntty,*) ' %cstate_empty_dims: dimensions empty in ALL states:'

  if(allocated(empty_dims)) deallocate(empty_dims)
  if(allocated(grid_dims)) deallocate(grid_dims)

  if(allocated(ww)) deallocate(ww)
  allocate(ww(nsss_cur))

  !  get dimension info on each state...

  inum_empty = 0
  nldims = 0
  iersum = 0

  do itype=1,3

     do ii=1,nsss_cur
        call psw_contents(dtype(itype),ps_cc_all,ww(ii),ierr, state=sss(ii))
        iok(ii) = (ierr.eq.0)
        if(.not.iok(ii)) iersum = iersum + 1
     enddo

     !  #dimensions the same in all states...
     isize = ww(1)%size
     if(itype.gt.1) then
        nldims = nldims + isize
     else
        ing=isize
     endif

     !  count the number that are empty in all of the states

     do jj=1,isize
        isize_dim = 0
        do ii=1,nsss_cur
           isize_dim = max(isize_dim,ww(ii)%ival(jj))
        enddo

        if(isize_dim.eq.0) then
           inum_empty = inum_empty + 1
        endif
     enddo
  enddo

  if(iersum.ne.0) then
     write(luntty,*) ' ?unexpected internal error: cstate_empty_dims.f90'
     ierr=1
     return
  endif

  !  allocate the list of empties...

  allocate(empty_dims(inum_empty))
  allocate(grid_dims(ing))

  !  fill the list of empties...

  inum_empty = 0
  ing = 0

  do itype = 1,3

     do ii=1,nsss_cur
        call psw_contents(dtype(itype),ps_cc_all,ww(ii),ierr, state=sss(ii))
        iok(ii) = (ierr.eq.0)
     enddo

     isize = ww(1)%size

     do jj=1,isize
        dim0=ww(1)%val_field(jj)
        ilen=len(trim(dim0))
        ici=1
        ici=max(ici,index(dim0,':'))
        dim = dim0(ici+1:ilen-1)   ! strip parens

        isize_dim = 0
        do ii=1,nsss_cur
           isize_dim = max(isize_dim,ww(ii)%ival(jj))
        enddo

        if(isize_dim.eq.0) then
           inum_empty = inum_empty + 1
           empty_dims(inum_empty) = dim
           call ulower(empty_dims(inum_empty))
           write(luntty,'(3x,i4,".  ",a)') inum_empty,empty_dims(inum_empty)
        endif

        if(itype.eq.1) then
           ing = ing + 1
           grid_dims(ing) = dim
           call ulower(grid_dims(ing))
        endif

     enddo
  enddo

  if(inum_empty.eq.0) write(luntty,*) '   NONE.'

  do ii=1,nsss_cur
     call free_window(ww(ii))
  enddo
  deallocate(ww)

end subroutine cstate_empty_dims

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


SUBROUTINE plasma_state_hash_diff(ss1,lbl1,ss2,lbl2,sstr,icomp,idiff)

  ! summarize difference between two states, based on hash code comparison.

  USE plasma_state_definition_mod
  IMPLICIT NONE

  TYPE (plasma_state) :: ss1        ! 1st state
  CHARACTER*(*), intent(in) :: lbl1 ! label for 1st state

  TYPE (plasma_state) :: ss2        ! 2nd state
  CHARACTER*(*), intent(in) :: lbl2 ! label for 2nd state

  CHARACTER*(*), intent(in) :: sstr ! search string
  !  if section, dimension, or profile name contains sstr as a substring
  !  check the hash difference for that item.

  !  ==> if sstr = "*", check the hash difference for ALL items.

  INTEGER, intent(out) :: icomp     ! number of hash comparisons done
  INTEGER, intent(out) :: idiff     ! number of DIFFERENCES found

  !-------------------
  INTEGER :: iout,ils,iaddr1,iaddr2
  CHARACTER*32 ss
  !-------------------

  iout = SWIM_err_out_file

  ss = sstr
  call uupper(ss)
  ils = len(trim(ss))

  icomp = 0  ! number hash pairs compared
  idiff = 0  ! number that were different
  !--------------------------------------------
  ! section hash codes

  IF((ss(1:ils).EQ."*").OR.(INDEX("MACHINE_DESCRIPTION",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_shash_machine_description
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
          (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("SECTION","MACHINE_DESCRIPTION")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("SHOT_CONFIGURATION",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_shash_shot_configuration
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
          (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("SECTION","SHOT_CONFIGURATION")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("SIMULATION_INIT",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_shash_simulation_init
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
          (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("SECTION","SIMULATION_INIT")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("STATE_DATA",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_shash_state_data
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
          (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("SECTION","STATE_DATA")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("STATE_PROFILES",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_shash_state_profiles
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
          (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("SECTION","STATE_PROFILES")
     ENDIF
  ENDIF

  !--------------------------------------------
  ! dimension hash codes

  IF((ss(1:ils).EQ."*").OR.(INDEX("MAX_NRZ_ANTGEO",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_dhash_max_nrz_antgeo
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("DIMENSION","MAX_NRZ_ANTGEO")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("MAX_NSPECTRUMLH_SRC",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_dhash_max_nspectrumlh_src
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("DIMENSION","MAX_NSPECTRUMLH_SRC")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("MAX_NUM_NPHI",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_dhash_max_num_nphi
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("DIMENSION","MAX_NUM_NPHI")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("MAX_NUM_NPHI_VAC",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_dhash_max_num_nphi_vac
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("DIMENSION","MAX_NUM_NPHI_VAC")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("MAX_N_STRAPS",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_dhash_max_n_straps
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("DIMENSION","MAX_N_STRAPS")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("MMODES",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_dhash_mmodes
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("DIMENSION","MMODES")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("NBALLOON",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_dhash_nballoon
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("DIMENSION","NBALLOON")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("NBEAM",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_dhash_nbeam
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("DIMENSION","NBEAM")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("NCIRCUITS",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_dhash_ncircuits
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("DIMENSION","NCIRCUITS")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("NCOILS",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_dhash_ncoils
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("DIMENSION","NCOILS")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("NDELTA_W",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_dhash_ndelta_w
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("DIMENSION","NDELTA_W")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("NECRF_SRC",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_dhash_necrf_src
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("DIMENSION","NECRF_SRC")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("NEFI_ANOM",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_dhash_nefi_anom
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("DIMENSION","NEFI_ANOM")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("NEFI_ANOM2",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_dhash_nefi_anom2
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("DIMENSION","NEFI_ANOM2")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("NEQMOM",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_dhash_neqmom
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("DIMENSION","NEQMOM")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("NGSC0",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_dhash_ngsc0
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("DIMENSION","NGSC0")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("NICRF_SRC",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_dhash_nicrf_src
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("DIMENSION","NICRF_SRC")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("NKY_ANOMTH",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_dhash_nky_anomth
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("DIMENSION","NKY_ANOMTH")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("NKY_MMM",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_dhash_nky_mmm
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("DIMENSION","NKY_MMM")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("NLHRF_SRC",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_dhash_nlhrf_src
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("DIMENSION","NLHRF_SRC")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("NNEWCOMB",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_dhash_nnewcomb
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("DIMENSION","NNEWCOMB")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("NPSMOM",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_dhash_npsmom
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("DIMENSION","NPSMOM")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("NR",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_dhash_nr
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("DIMENSION","NR")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("NRHO",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_dhash_nrho
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("DIMENSION","NRHO")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("NRHO_ANOM",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_dhash_nrho_anom
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("DIMENSION","NRHO_ANOM")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("NRHO_ANOM2",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_dhash_nrho_anom2
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("DIMENSION","NRHO_ANOM2")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("NRHO_ANOMTH",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_dhash_nrho_anomth
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("DIMENSION","NRHO_ANOMTH")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("NRHO_ECRF",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_dhash_nrho_ecrf
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("DIMENSION","NRHO_ECRF")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("NRHO_EQ",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_dhash_nrho_eq
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("DIMENSION","NRHO_EQ")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("NRHO_EQ_GEO",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_dhash_nrho_eq_geo
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("DIMENSION","NRHO_EQ_GEO")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("NRHO_FUS",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_dhash_nrho_fus
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("DIMENSION","NRHO_FUS")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("NRHO_GAS",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_dhash_nrho_gas
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("DIMENSION","NRHO_GAS")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("NRHO_ICRF",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_dhash_nrho_icrf
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("DIMENSION","NRHO_ICRF")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("NRHO_LHRF",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_dhash_nrho_lhrf
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("DIMENSION","NRHO_LHRF")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("NRHO_LMHD",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_dhash_nrho_lmhd
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("DIMENSION","NRHO_LMHD")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("NRHO_MIST",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_dhash_nrho_mist
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("DIMENSION","NRHO_MIST")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("NRHO_NBI",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_dhash_nrho_nbi
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("DIMENSION","NRHO_NBI")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("NRHO_PEL",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_dhash_nrho_pel
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("DIMENSION","NRHO_PEL")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("NRHO_RAD",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_dhash_nrho_rad
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("DIMENSION","NRHO_RAD")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("NRHO_RW",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_dhash_nrho_rw
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("DIMENSION","NRHO_RW")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("NR_RIP",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_dhash_nr_rip
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("DIMENSION","NR_RIP")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("NSPEC_ALL",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_dhash_nspec_all
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("DIMENSION","NSPEC_ALL")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("NSPEC_ALLA",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_dhash_nspec_alla
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("DIMENSION","NSPEC_ALLA")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("NSPEC_BEAM",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_dhash_nspec_beam
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("DIMENSION","NSPEC_BEAM")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("NSPEC_FUSION",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_dhash_nspec_fusion
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("DIMENSION","NSPEC_FUSION")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("NSPEC_GAS",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_dhash_nspec_gas
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("DIMENSION","NSPEC_GAS")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("NSPEC_IMP0",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_dhash_nspec_imp0
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("DIMENSION","NSPEC_IMP0")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("NSPEC_IMPI",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_dhash_nspec_impi
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("DIMENSION","NSPEC_IMPI")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("NSPEC_RFMIN",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_dhash_nspec_rfmin
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("DIMENSION","NSPEC_RFMIN")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("NSPEC_TH",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_dhash_nspec_th
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("DIMENSION","NSPEC_TH")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("NSPEC_THA",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_dhash_nspec_tha
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("DIMENSION","NSPEC_THA")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("NTH_EQ",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_dhash_nth_eq
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("DIMENSION","NTH_EQ")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("NTRCAT",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_dhash_ntrcat
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("DIMENSION","NTRCAT")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("NUM_RZLIM",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_dhash_num_rzlim
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("DIMENSION","NUM_RZLIM")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("NXS",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_dhash_nxs
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("DIMENSION","NXS")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("NZ",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_dhash_nz
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("DIMENSION","NZ")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("NZ_RIP",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_dhash_nz_rip
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("DIMENSION","NZ_RIP")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("N_D_EINJ_STANDARD",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_dhash_n_d_einj_standard
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("DIMENSION","N_D_EINJ_STANDARD")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("N_H_EINJ_STANDARD",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_dhash_n_h_einj_standard
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("DIMENSION","N_H_EINJ_STANDARD")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("N_T_EINJ_STANDARD",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_dhash_n_t_einj_standard
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("DIMENSION","N_T_EINJ_STANDARD")
     ENDIF
  ENDIF

  !--------------------------------------------
  ! profile hash codes

  IF((ss(1:ils).EQ."*").OR.(INDEX("ANOM_EVAR",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_anom_evar
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","ANOM_EVAR")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("AREA",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_area
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","AREA")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("BALSTAB",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_balstab
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","BALSTAB")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("BIDIFF_BPASS_CO",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_bidiff_bpass_co
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","BIDIFF_BPASS_CO")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("BIDIFF_BPASS_CTR",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_bidiff_bpass_ctr
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","BIDIFF_BPASS_CTR")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("BIDIFF_BTRAP",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_bidiff_btrap
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","BIDIFF_BTRAP")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("BIDIFF_DPASS_CO",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_bidiff_dpass_co
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","BIDIFF_DPASS_CO")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("BIDIFF_DPASS_CTR",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_bidiff_dpass_ctr
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","BIDIFF_DPASS_CTR")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("BIDIFF_DTRAP",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_bidiff_dtrap
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","BIDIFF_DTRAP")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("BPHIRZ",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_bphirz
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","BPHIRZ")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("BRRZ",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_brrz
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","BRRZ")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("BZRZ",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_bzrz
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","BZRZ")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("B_SURFMAX",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_b_surfmax
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","B_SURFMAX")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("B_SURFMIN",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_b_surfmin
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","B_SURFMIN")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("CDICRF",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_cdicrf
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","CDICRF")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("CDICRF_NPHI",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_cdicrf_nphi
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","CDICRF_NPHI")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("CHIE_ANOM",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_chie_anom
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","CHIE_ANOM")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("CHIE_DRBM",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_chie_drbm
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","CHIE_DRBM")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("CHIE_ETG",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_chie_etg
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","CHIE_ETG")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("CHIE_GLF",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_chie_glf
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","CHIE_GLF")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("CHIE_GTCNEO",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_chie_gtcneo
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","CHIE_GTCNEO")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("CHIE_MMM71",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_chie_mmm71
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","CHIE_MMM71")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("CHIE_MTM",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_chie_mtm
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","CHIE_MTM")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("CHIE_NCLASS",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_chie_nclass
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","CHIE_NCLASS")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("CHIE_NEO",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_chie_neo
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","CHIE_NEO")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("CHIE_NTM",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_chie_ntm
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","CHIE_NTM")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("CHIE_PALEO",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_chie_paleo
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","CHIE_PALEO")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("CHIE_TGLF",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_chie_tglf
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","CHIE_TGLF")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("CHIE_TRANS",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_chie_trans
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","CHIE_TRANS")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("CHIE_TRANSCAT",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_chie_transcat
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","CHIE_TRANSCAT")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("CHIE_W19",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_chie_w19
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","CHIE_W19")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("CHII_ANOM",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_chii_anom
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","CHII_ANOM")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("CHII_DRBM",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_chii_drbm
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","CHII_DRBM")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("CHII_GLF",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_chii_glf
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","CHII_GLF")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("CHII_GTCNEO",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_chii_gtcneo
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","CHII_GTCNEO")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("CHII_MMM71",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_chii_mmm71
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","CHII_MMM71")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("CHII_NCLASS",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_chii_nclass
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","CHII_NCLASS")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("CHII_NEO",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_chii_neo
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","CHII_NEO")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("CHII_NTM",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_chii_ntm
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","CHII_NTM")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("CHII_TGLF",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_chii_tglf
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","CHII_TGLF")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("CHII_TRANS",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_chii_trans
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","CHII_TRANS")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("CHII_TRANSCAT",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_chii_transcat
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","CHII_TRANSCAT")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("CHII_W19",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_chii_w19
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","CHII_W19")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("CHIMO_TRANS",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_chimo_trans
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","CHIMO_TRANS")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("CHIMO_TRANSCAT",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_chimo_transcat
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","CHIMO_TRANSCAT")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("CHIPHI_ANOM",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_chiphi_anom
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","CHIPHI_ANOM")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("CHIPHI_DRBM",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_chiphi_drbm
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","CHIPHI_DRBM")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("CHIPHI_GLF",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_chiphi_glf
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","CHIPHI_GLF")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("CHIPHI_GTCNEO",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_chiphi_gtcneo
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","CHIPHI_GTCNEO")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("CHIPHI_MMM71",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_chiphi_mmm71
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","CHIPHI_MMM71")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("CHIPHI_NEO",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_chiphi_neo
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","CHIPHI_NEO")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("CHIPHI_TGLF",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_chiphi_tglf
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","CHIPHI_TGLF")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("CHIPHI_W19",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_chiphi_w19
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","CHIPHI_W19")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("CHITHETA_MMM71",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_chitheta_mmm71
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","CHITHETA_MMM71")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("CURBEAM",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_curbeam
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","CURBEAM")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("CURECH",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_curech
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","CURECH")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("CURECH_SRC",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_curech_src
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","CURECH_SRC")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("CURFUSN",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_curfusn
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","CURFUSN")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("CURICH",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_curich
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","CURICH")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("CURLH",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_curlh
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","CURLH")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("CURLH_SRC",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_curlh_src
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","CURLH_SRC")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("CURMINO",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_curmino
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","CURMINO")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("CURR_BOOTSTRAP",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_curr_bootstrap
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","CURR_BOOTSTRAP")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("CURR_OHMIC",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_curr_ohmic
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","CURR_OHMIC")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("CURT",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_curt
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","CURT")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("CUR_RW",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_cur_rw
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","CUR_RW")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("D2R_GEO_DRHODTH",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_d2r_geo_drhodth
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","D2R_GEO_DRHODTH")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("D2Z_GEO_DRHODTH",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_d2z_geo_drhodth
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","D2Z_GEO_DRHODTH")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("DB_MTM",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_db_mtm
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","DB_MTM")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("DCUR_RW_DVLOOP",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_dcur_rw_dvloop
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","DCUR_RW_DVLOOP")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("DIFB_FUSI",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_difb_fusi
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","DIFB_FUSI")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("DIFB_NBI",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_difb_nbi
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","DIFB_NBI")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("DIFB_RFMI",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_difb_rfmi
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","DIFB_RFMI")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("DIFF_TRANS",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_diff_trans
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","DIFF_TRANS")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("DIFF_TRANSCAT",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_diff_transcat
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","DIFF_TRANSCAT")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("DIFNE_NCLASS",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_difne_nclass
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","DIFNE_NCLASS")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("DIFNH_NCLASS",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_difnh_nclass
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","DIFNH_NCLASS")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("DIFNS_ANOM",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_difns_anom
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","DIFNS_ANOM")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("DIFNS_DRBM",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_difns_drbm
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","DIFNS_DRBM")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("DIFNS_GLF",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_difns_glf
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","DIFNS_GLF")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("DIFNS_GTCNEO",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_difns_gtcneo
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","DIFNS_GTCNEO")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("DIFNS_MMM71",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_difns_mmm71
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","DIFNS_MMM71")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("DIFNS_NCLASS",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_difns_nclass
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","DIFNS_NCLASS")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("DIFNS_NEO",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_difns_neo
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","DIFNS_NEO")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("DIFNS_TGLF",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_difns_tglf
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","DIFNS_TGLF")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("DIFNS_W19",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_difns_w19
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","DIFNS_W19")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("DIFNX_NCLASS",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_difnx_nclass
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","DIFNX_NCLASS")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("DIFNZ_MMM71",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_difnz_mmm71
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","DIFNZ_MMM71")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("DQEDGRDTE_TGLF",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_dqedgrdte_tglf
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","DQEDGRDTE_TGLF")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("DQEDGRDTI_TGLF",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_dqedgrdti_tglf
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","DQEDGRDTI_TGLF")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("DQIDGRDTE_TGLF",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_dqidgrdte_tglf
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","DQIDGRDTE_TGLF")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("DQIDGRDTI_TGLF",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_dqidgrdti_tglf
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","DQIDGRDTI_TGLF")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("DR0_MOMEQ_DRHO",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_dr0_momeq_drho
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","DR0_MOMEQ_DRHO")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("DR_GEO_DRHO",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_dr_geo_drho
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","DR_GEO_DRHO")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("DR_GEO_DTH",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_dr_geo_dth
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","DR_GEO_DTH")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("DXRJCOS_MOMEQ_DRHO",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_dxrjcos_momeq_drho
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","DXRJCOS_MOMEQ_DRHO")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("DXRJSIN_MOMEQ_DRHO",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_dxrjsin_momeq_drho
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","DXRJSIN_MOMEQ_DRHO")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("DXZJCOS_MOMEQ_DRHO",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_dxzjcos_momeq_drho
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","DXZJCOS_MOMEQ_DRHO")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("DXZJSIN_MOMEQ_DRHO",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_dxzjsin_momeq_drho
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","DXZJSIN_MOMEQ_DRHO")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("DZ0_MOMEQ_DRHO",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_dz0_momeq_drho
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","DZ0_MOMEQ_DRHO")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("DZ_GEO_DRHO",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_dz_geo_drho
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","DZ_GEO_DRHO")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("DZ_GEO_DTH",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_dz_geo_dth
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","DZ_GEO_DTH")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("EE_MOBILITY_FACTOR",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_ee_mobility_factor
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","EE_MOBILITY_FACTOR")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("ELONG",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_elong
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","ELONG")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("EPERP_BEAMI",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_eperp_beami
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","EPERP_BEAMI")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("EPERP_FUSI",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_eperp_fusi
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","EPERP_FUSI")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("EPERP_MINI",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_eperp_mini
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","EPERP_MINI")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("EPERP_RW",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_eperp_rw
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","EPERP_RW")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("EPLL_BEAMI",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_epll_beami
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","EPLL_BEAMI")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("EPLL_FUSI",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_epll_fusi
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","EPLL_FUSI")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("EPLL_MINI",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_epll_mini
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","EPLL_MINI")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("EPLL_RW",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_epll_rw
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","EPLL_RW")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("EPOT",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_epot
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","EPOT")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("ETA_PARALLEL",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_eta_parallel
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","ETA_PARALLEL")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("FIDIFF_BPASS_CO",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_fidiff_bpass_co
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","FIDIFF_BPASS_CO")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("FIDIFF_BPASS_CTR",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_fidiff_bpass_ctr
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","FIDIFF_BPASS_CTR")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("FIDIFF_BTRAP",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_fidiff_btrap
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","FIDIFF_BTRAP")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("FIDIFF_DPASS_CO",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_fidiff_dpass_co
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","FIDIFF_DPASS_CO")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("FIDIFF_DPASS_CTR",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_fidiff_dpass_ctr
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","FIDIFF_DPASS_CTR")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("FIDIFF_DTRAP",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_fidiff_dtrap
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","FIDIFF_DTRAP")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("FI_DEPLETION",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_fi_depletion
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","FI_DEPLETION")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("FREQ_DRBM",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_freq_drbm
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","FREQ_DRBM")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("FREQ_GLF",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_freq_glf
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","FREQ_GLF")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("FREQ_MAX_TGLF",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_freq_max_tglf
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","FREQ_MAX_TGLF")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("FREQ_MMM71",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_freq_mmm71
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","FREQ_MMM71")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("FREQ_MTM",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_freq_mtm
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","FREQ_MTM")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("FREQ_TGLF",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_freq_tglf
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","FREQ_TGLF")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("GAMMA_NC",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_gamma_nc
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","GAMMA_NC")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("GB1",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_gb1
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","GB1")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("GB2",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_gb2
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","GB2")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("GB2I",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_gb2i
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","GB2I")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("GBR2",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_gbr2
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","GBR2")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("GNCFB2H",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_gncfb2h
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","GNCFB2H")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("GNCFH",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_gncfh
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","GNCFH")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("GR1",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_gr1
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","GR1")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("GR2",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_gr2
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","GR2")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("GR2I",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_gr2i
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","GR2I")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("GR2RHO2",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_gr2rho2
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","GR2RHO2")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("GR3I",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_gr3i
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","GR3I")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("GRHO1",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_grho1
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","GRHO1")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("GRHO2",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_grho2
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","GRHO2")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("GRHO2B2I",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_grho2b2i
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","GRHO2B2I")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("GRHO2R2I",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_grho2r2i
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","GRHO2R2I")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("GRHO2R3I",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_grho2r3i
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","GRHO2R3I")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("GRI",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_gri
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","GRI")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("GRIRHOI",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_grirhoi
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","GRIRHOI")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("GROWTHRATE_DRBM",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_growthrate_drbm
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","GROWTHRATE_DRBM")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("GROWTHRATE_GLF",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_growthrate_glf
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","GROWTHRATE_GLF")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("GROWTHRATE_MAX_TGLF",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_growthrate_max_tglf
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","GROWTHRATE_MAX_TGLF")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("GROWTHRATE_MMM71",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_growthrate_mmm71
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","GROWTHRATE_MMM71")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("GROWTHRATE_MTM",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_growthrate_mtm
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","GROWTHRATE_MTM")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("GROWTHRATE_TGLF",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_growthrate_tglf
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","GROWTHRATE_TGLF")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("GROWTHRATE_VPAR",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_growthrate_vpar
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","GROWTHRATE_VPAR")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("G_EQ",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_g_eq
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","G_EQ")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("IOTA",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_iota
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","IOTA")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("JDOTB",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_jdotb
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","JDOTB")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("KYRHOS_MTM",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_kyrhos_mtm
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","KYRHOS_MTM")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("KYSPECTRUM_TGLF",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_kyspectrum_tglf
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","KYSPECTRUM_TGLF")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("LPOL",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_lpol
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","LPOL")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("N0NORM",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_n0norm
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","N0NORM")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("N0_HALO",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_n0_halo
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","N0_HALO")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("N0_RECO",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_n0_reco
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","N0_RECO")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("NBEAMI",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_nbeami
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","NBEAMI")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("NEFLUX_KY_TGLF",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_neflux_ky_tglf
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","NEFLUX_KY_TGLF")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("NE_KY_TGLF",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_ne_ky_tglf
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","NE_KY_TGLF")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("NFUSI",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_nfusi
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","NFUSI")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("NGRADB2_AV",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_ngradb2_av
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","NGRADB2_AV")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("NI",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_ni
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","NI")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("NIFLUX_KY_TGLF",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_niflux_ky_tglf
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","NIFLUX_KY_TGLF")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("NI_KY_TGLF",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_ni_ky_tglf
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","NI_KY_TGLF")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("NMINI",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_nmini
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","NMINI")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("NMODEL",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_nmodel
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","NMODEL")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("NRW",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_nrw
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","NRW")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("NS",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_ns
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","NS")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("NZFLUX_KY_TGLF",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_nzflux_ky_tglf
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","NZFLUX_KY_TGLF")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("NZ_KY_TGLF",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_nz_ky_tglf
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","NZ_KY_TGLF")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("OMEG0CX",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_omeg0cx
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","OMEG0CX")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("OMEG0SC0",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_omeg0sc0
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","OMEG0SC0")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("OMEG0_HALO",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_omeg0_halo
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","OMEG0_HALO")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("OMEG0_RECO",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_omeg0_reco
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","OMEG0_RECO")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("OMEGAT",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_omegat
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","OMEGAT")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("OMEGA_EXB",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_omega_exb
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","OMEGA_EXB")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("P0_RECO",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_p0_reco
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","P0_RECO")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("PB0_HALO",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_pb0_halo
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","PB0_HALO")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("PBE",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_pbe
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","PBE")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("PBI",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_pbi
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","PBI")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("PBTH",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_pbth
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","PBTH")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("PCX_HALO",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_pcx_halo
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","PCX_HALO")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("PCX_RECO",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_pcx_reco
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","PCX_RECO")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("PEECH",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_peech
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","PEECH")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("PEECH_SRC",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_peech_src
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","PEECH_SRC")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("PELH",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_pelh
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","PELH")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("PELH_SRC",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_pelh_src
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","PELH_SRC")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("PE_ANOM",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_pe_anom
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","PE_ANOM")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("PE_TRANS",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_pe_trans
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","PE_TRANS")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("PE_TRANSCAT",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_pe_transcat
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","PE_TRANSCAT")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("PFUSE",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_pfuse
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","PFUSE")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("PFUSI",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_pfusi
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","PFUSI")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("PFUSTH",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_pfusth
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","PFUSTH")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("PHIFLUX_KY_TGLF",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_phiflux_ky_tglf
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","PHIFLUX_KY_TGLF")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("PHIT",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_phit
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","PHIT")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("PICRF_NPHI_SRCS",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_picrf_nphi_srcs
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","PICRF_NPHI_SRCS")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("PICRF_SRCS",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_picrf_srcs
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","PICRF_SRCS")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("PICRF_TOTALS",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_picrf_totals
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","PICRF_TOTALS")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("PICTH",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_picth
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","PICTH")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("PILH",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_pilh
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","PILH")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("PILH_SRC",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_pilh_src
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","PILH_SRC")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("PI_ANOM",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_pi_anom
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","PI_ANOM")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("PI_TRANS",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_pi_trans
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","PI_TRANS")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("PI_TRANSCAT",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_pi_transcat
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","PI_TRANSCAT")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("PMINE",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_pmine
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","PMINE")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("PMINI",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_pmini
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","PMINI")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("PMINTH",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_pminth
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","PMINTH")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("POHME",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_pohme
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","POHME")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("POT_KY_TGLF",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_pot_ky_tglf
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","POT_KY_TGLF")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("PRAD",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_prad
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","PRAD")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("PRAD_BR",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_prad_br
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","PRAD_BR")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("PRAD_CY",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_prad_cy
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","PRAD_CY")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("PRAD_LI",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_prad_li
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","PRAD_LI")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("PSC_HALO",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_psc_halo
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","PSC_HALO")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("PSC_RECO",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_psc_reco
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","PSC_RECO")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("PSIPOL",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_psipol
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","PSIPOL")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("PSIRZ",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_psirz
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","PSIRZ")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("PSMOM_ERRCK",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_psmom_errck
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","PSMOM_ERRCK")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("PSMOM_NC",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_psmom_nc
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","PSMOM_NC")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("P_EQ",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_p_eq
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","P_EQ")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("QBEAMI",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_qbeami
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","QBEAMI")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("QCOMP_E",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_qcomp_e
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","QCOMP_E")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("QCOMP_I",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_qcomp_i
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","QCOMP_I")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("QIE",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_qie
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","QIE")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("QIONIZ",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_qioniz
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","QIONIZ")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("QQCX",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_qqcx
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","QQCX")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("QROT_CONV",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_qrot_conv
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","QROT_CONV")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("QROT_DIFF",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_qrot_diff
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","QROT_DIFF")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("Q_EQ",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_q_eq
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","Q_EQ")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("R0_MOMEQ",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_r0_momeq
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","R0_MOMEQ")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("RATE_SINB0I",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_rate_sinb0i
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","RATE_SINB0I")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("RATE_SINB0X",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_rate_sinb0x
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","RATE_SINB0X")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("RATE_SINB0XS",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_rate_sinb0xs
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","RATE_SINB0XS")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("RATE_SINF0I",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_rate_sinf0i
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","RATE_SINF0I")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("RATE_SINF0X",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_rate_sinf0x
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","RATE_SINF0X")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("RATE_SINF0XS",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_rate_sinf0xs
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","RATE_SINF0XS")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("RES_SN",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_res_sn
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","RES_SN")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("RES_TE",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_res_te
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","RES_TE")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("RES_TI",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_res_ti
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","RES_TI")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("RES_TQ",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_res_tq
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","RES_TQ")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("RMAJOR_MEAN",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_rmajor_mean
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","RMAJOR_MEAN")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("RMINOR_MEAN",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_rminor_mean
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","RMINOR_MEAN")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("R_GEO",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_r_geo
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","R_GEO")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("R_MIDP_IN",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_r_midp_in
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","R_MIDP_IN")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("R_MIDP_OUT",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_r_midp_out
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","R_MIDP_OUT")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("R_SURFMAX",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_r_surfmax
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","R_SURFMAX")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("R_SURFMIN",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_r_surfmin
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","R_SURFMIN")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("S0RECO",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_s0reco
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","S0RECO")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("S0RECO_E",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_s0reco_e
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","S0RECO_E")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("S0RECO_RECAP",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_s0reco_recap
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","S0RECO_RECAP")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("SB0HALO",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_sb0halo
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","SB0HALO")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("SB0HALO_RECAP",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_sb0halo_recap
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","SB0HALO_RECAP")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("SBEDEP",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_sbedep
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","SBEDEP")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("SBEHALO",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_sbehalo
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","SBEHALO")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("SBSCE",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_sbsce
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","SBSCE")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("SBTHERM",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_sbtherm
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","SBTHERM")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("SC_ANOM",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_sc_anom
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","SC_ANOM")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("SFSCE",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_sfsce
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","SFSCE")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("SFTHERM",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_sftherm
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","SFTHERM")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("SII_XS",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_sii_xs
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","SII_XS")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("SN_TRANS",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_sn_trans
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","SN_TRANS")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("SN_TRANSCAT",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_sn_transcat
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","SN_TRANSCAT")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("SPROF0",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_sprof0
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","SPROF0")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("SPROF0E",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_sprof0e
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","SPROF0E")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("SPSCE",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_spsce
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","SPSCE")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("SQUARELO",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_squarelo
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","SQUARELO")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("SQUAREUO",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_squareuo
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","SQUAREUO")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("SURF",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_surf
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","SURF")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("T0CX",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_t0cx
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","T0CX")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("T0SC0",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_t0sc0
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","T0SC0")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("T0_HALO",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_t0_halo
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","T0_HALO")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("T0_RECO",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_t0_reco
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","T0_RECO")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("TEFLUX_KY_TGLF",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_teflux_ky_tglf
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","TEFLUX_KY_TGLF")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("TE_KY_TGLF",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_te_ky_tglf
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","TE_KY_TGLF")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("TFRIP2_LOG",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_tfrip2_log
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","TFRIP2_LOG")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("TFRIP_LOG",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_tfrip_log
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","TFRIP_LOG")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("TI",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_ti
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","TI")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("TIFLUX_KY_TGLF",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_tiflux_ky_tglf
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","TIFLUX_KY_TGLF")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("TI_KY_TGLF",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_ti_ky_tglf
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","TI_KY_TGLF")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("TMODEL",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_tmodel
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","TMODEL")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("TQ0_RECO",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_tq0_reco
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","TQ0_RECO")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("TQB0_HALO",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_tqb0_halo
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","TQB0_HALO")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("TQBE",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_tqbe
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","TQBE")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("TQBI",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_tqbi
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","TQBI")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("TQBJXB",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_tqbjxb
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","TQBJXB")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("TQBTH",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_tqbth
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","TQBTH")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("TQCX_HALO",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_tqcx_halo
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","TQCX_HALO")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("TQCX_RECO",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_tqcx_reco
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","TQCX_RECO")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("TQIONIZ",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_tqioniz
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","TQIONIZ")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("TQQCX",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_tqqcx
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","TQQCX")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("TQSC_HALO",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_tqsc_halo
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","TQSC_HALO")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("TQSC_RECO",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_tqsc_reco
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","TQSC_RECO")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("TQ_ANOM",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_tq_anom
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","TQ_ANOM")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("TQ_TRANS",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_tq_trans
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","TQ_TRANS")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("TQ_TRANSCAT",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_tq_transcat
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","TQ_TRANSCAT")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("TRIANG",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_triang
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","TRIANG")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("TRIANGL",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_triangl
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","TRIANGL")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("TRIANGU",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_triangu
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","TRIANGU")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("TRIANG_MILLER_L",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_triang_miller_l
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","TRIANG_MILLER_L")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("TRIANG_MILLER_U",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_triang_miller_u
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","TRIANG_MILLER_U")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("TS",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_ts
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","TS")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("TZFLUX_KY_TGLF",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_tzflux_ky_tglf
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","TZFLUX_KY_TGLF")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("TZ_KY_TGLF",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_tz_ky_tglf
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","TZ_KY_TGLF")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("UPWIND_PFRAC_NS",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_upwind_pfrac_ns
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","UPWIND_PFRAC_NS")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("UPWIND_PFRAC_OMEGA",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_upwind_pfrac_omega
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","UPWIND_PFRAC_OMEGA")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("UPWIND_PFRAC_TE",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_upwind_pfrac_te
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","UPWIND_PFRAC_TE")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("UPWIND_PFRAC_TI",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_upwind_pfrac_ti
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","UPWIND_PFRAC_TI")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("VEE_TRANS",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_vee_trans
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","VEE_TRANS")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("VEE_TRANSCAT",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_vee_transcat
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","VEE_TRANSCAT")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("VELB_FUSI",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_velb_fusi
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","VELB_FUSI")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("VELB_NBI",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_velb_nbi
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","VELB_NBI")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("VELB_RFMI",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_velb_rfmi
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","VELB_RFMI")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("VELNE_NCLASS",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_velne_nclass
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","VELNE_NCLASS")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("VELNH_NCLASS",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_velnh_nclass
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","VELNH_NCLASS")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("VELNI_DRBM",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_velni_drbm
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","VELNI_DRBM")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("VELNS_ANOM",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_velns_anom
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","VELNS_ANOM")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("VELNS_GLF",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_velns_glf
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","VELNS_GLF")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("VELNS_GTCNEO",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_velns_gtcneo
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","VELNS_GTCNEO")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("VELNS_MMM71",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_velns_mmm71
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","VELNS_MMM71")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("VELNS_NCLASS",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_velns_nclass
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","VELNS_NCLASS")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("VELNS_NEO",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_velns_neo
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","VELNS_NEO")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("VELNS_TGLF",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_velns_tglf
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","VELNS_TGLF")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("VELNX_NCLASS",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_velnx_nclass
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","VELNX_NCLASS")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("VELPPHI_ANOM",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_velpphi_anom
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","VELPPHI_ANOM")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("VELPPHI_GLF",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_velpphi_glf
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","VELPPHI_GLF")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("VELPPHI_GTCNEO",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_velpphi_gtcneo
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","VELPPHI_GTCNEO")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("VELPPHI_MMM71",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_velpphi_mmm71
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","VELPPHI_MMM71")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("VELPPHI_NEO",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_velpphi_neo
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","VELPPHI_NEO")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("VELPPHI_TGLF",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_velpphi_tglf
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","VELPPHI_TGLF")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("VELTE_ANOM",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_velte_anom
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","VELTE_ANOM")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("VELTE_GLF",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_velte_glf
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","VELTE_GLF")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("VELTE_GTCNEO",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_velte_gtcneo
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","VELTE_GTCNEO")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("VELTE_MMM71",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_velte_mmm71
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","VELTE_MMM71")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("VELTE_NCLASS",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_velte_nclass
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","VELTE_NCLASS")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("VELTE_NEO",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_velte_neo
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","VELTE_NEO")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("VELTE_PALEO",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_velte_paleo
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","VELTE_PALEO")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("VELTE_TGLF",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_velte_tglf
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","VELTE_TGLF")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("VELTI_ANOM",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_velti_anom
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","VELTI_ANOM")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("VELTI_GLF",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_velti_glf
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","VELTI_GLF")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("VELTI_GTCNEO",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_velti_gtcneo
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","VELTI_GTCNEO")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("VELTI_MMM71",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_velti_mmm71
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","VELTI_MMM71")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("VELTI_NCLASS",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_velti_nclass
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","VELTI_NCLASS")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("VELTI_NEO",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_velti_neo
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","VELTI_NEO")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("VELTI_TGLF",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_velti_tglf
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","VELTI_TGLF")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("VIE_TRANS",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_vie_trans
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","VIE_TRANS")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("VIE_TRANSCAT",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_vie_transcat
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","VIE_TRANSCAT")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("VMO_TRANS",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_vmo_trans
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","VMO_TRANS")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("VMO_TRANSCAT",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_vmo_transcat
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","VMO_TRANSCAT")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("VN_TRANS",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_vn_trans
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","VN_TRANS")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("VN_TRANSCAT",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_vn_transcat
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","VN_TRANSCAT")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("VOL",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_vol
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","VOL")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("VPOL_INMP",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_vpol_inmp
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","VPOL_INMP")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("VPOL_OMP",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_vpol_omp
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","VPOL_OMP")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("VTOR_INMP",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_vtor_inmp
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","VTOR_INMP")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("VTOR_OMP",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_vtor_omp
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","VTOR_OMP")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("V_LOOP",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_v_loop
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","V_LOOP")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("V_PARS",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_v_pars
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","V_PARS")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("V_PERS",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_v_pers
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","V_PERS")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("XRJCOS_MOMEQ",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_xrjcos_momeq
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","XRJCOS_MOMEQ")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("XRJSIN_MOMEQ",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_xrjsin_momeq
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","XRJSIN_MOMEQ")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("XZJCOS_MOMEQ",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_xzjcos_momeq
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","XZJCOS_MOMEQ")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("XZJSIN_MOMEQ",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_xzjsin_momeq
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","XZJSIN_MOMEQ")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("Z0_MOMEQ",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_z0_momeq
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","Z0_MOMEQ")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("ZEFF",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_zeff
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","ZEFF")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("ZEFF_FI",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_zeff_fi
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","ZEFF_FI")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("ZEFF_TH",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_zeff_th
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","ZEFF_TH")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("Z_GEO",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_z_geo
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","Z_GEO")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("Z_MIDP",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_z_midp
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","Z_MIDP")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("Z_SURFMAX",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_z_surfmax
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","Z_SURFMAX")
     ENDIF
  ENDIF

  IF((ss(1:ils).EQ."*").OR.(INDEX("Z_SURFMIN",ss(1:ils)).GT.0)) THEN
     icomp = icomp + 1
     iaddr1 = ps_phash_z_surfmin
     iaddr2 = iaddr1 + 1
     IF((ss1%hash_codes(iaddr1).NE.ss2%hash_codes(iaddr1)).OR. &
        (ss1%hash_codes(iaddr2).NE.ss2%hash_codes(iaddr2))) THEN
        idiff = idiff + 1
        if(idiff.eq.1) call diff_header
        call diff_report("PROFILE","Z_SURFMIN")
     ENDIF
  ENDIF

  IF(icomp.EQ.0) THEN
     write(iout,*) ' --> plasma_state_hash_diff: no comparison, sstr="'// &
          trim(sstr)//'".'
  ELSE IF(idiff.EQ.0) THEN
     write(iout,*) ' --> plasma_state_hash_diff: no hash differences between states:'
     write(iout,*) '    "'//trim(lbl1)//'" and "'//trim(lbl2)//'".'
     write(iout,*) '    (sstr="'//trim(sstr)//'"; ',icomp,' hashes compared).'
  ELSE
     write(iout,*) ' --> plasma_state_hash_diff: ',idiff,' hash difference(s) between states:'
     write(iout,*) '    "'//trim(lbl1)//'" and "'//trim(lbl2)//'".'
     write(iout,*) '    (sstr="'//trim(sstr)//'"; ',icomp,' hashes compared).'
  ENDIF
CONTAINS
  subroutine diff_header
     write(iout,*) ' ----------------------- '
     write(iout,*) ' plasma_state_hash_diff detects hash code differences:'
  end subroutine diff_header

  subroutine diff_report(typestr,namestr)
     character*(*) :: typestr
     character*(*) :: namestr
     write(iout,*) '     '//trim(typestr)//' hash for '//trim(namestr)//' is different.'
  end subroutine diff_report

END SUBROUTINE plasma_state_hash_diff

subroutine ccps_init(iobj,bytename,ierr)

  ! construct a state object with passed, null-terminated tag name byte string
  ! this routine to be called from C/C++ constructor

  use plasma_state_mod
  implicit NONE

#include "fpreproc/byte_declare.h"

  integer :: iobj(*)   ! (ps_container_size) words are used
  BYTE_DECLARE, intent(in) :: bytename(*)
  integer :: ierr

  !--------------------------------
  type (plasma_state_container) :: ptr
  character*32 tagname
  type (plasma_state), pointer :: ss
  !--------------------------------

  call cstring(tagname,bytename,'2F')  ! fill fortran char string (tagname)

  ! allocate state object

  allocate(ptr%ps_ptr)
  ss => ptr%ps_ptr

  ! initialize with tagname

  call ps_init_user_state(ss,tagname,ierr)

  ! transfer pointer

  if(ierr.eq.0) then
     call unload_ps_container(ptr,iobj)
  else
     iobj(1:ps_container_size)=0
  endif

end subroutine ccps_init

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_r4_dummy
     return
  end subroutine ccps_getset_r4_dummy

subroutine psget_rloc_coil(iobj, n1, data, ierr)
    !! R location of coil, lower left corner
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_rloc_coil', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % Rloc_coil
end subroutine psget_rloc_coil


subroutine psset_rloc_coil(iobj, n1, data, ierr)
    !! R location of coil, lower left corner
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_rloc_coil', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % Rloc_coil = data(1:n1)
end subroutine psset_rloc_coil


subroutine psgetrnk_rloc_coil(iobj, ndims, ierr)
    !! R location of coil, lower left corner
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_rloc_coil


subroutine psgetdim_rloc_coil(iobj, ndims, dims, ierr)
    !! R location of coil, lower left corner
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_rloc_coil', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % Rloc_coil ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % Rloc_coil)
    endif
end subroutine psgetdim_rloc_coil


subroutine psget_rfmin_type(iobj, n1, data, ierr)
    !! RFMIN specie types
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_rfmin_type', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % RFMIN_type
end subroutine psget_rfmin_type


subroutine psset_rfmin_type(iobj, n1, data, ierr)
    !! RFMIN specie types
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_rfmin_type', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % RFMIN_type = data(1:n1)
end subroutine psset_rfmin_type


subroutine psgetrnk_rfmin_type(iobj, ndims, ierr)
    !! RFMIN specie types
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_rfmin_type


subroutine psgetdim_rfmin_type(iobj, ndims, dims, ierr)
    !! RFMIN specie types
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_rfmin_type', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % RFMIN_type ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % RFMIN_type)
    endif
end subroutine psgetdim_rfmin_type


subroutine psget_runid(iobj, data, ierr)
    !! Run ID, one word, no imbedded blanks; <= 32 characters
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    CHARACTER*(*), intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_runid', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % RunID
end subroutine psget_runid


subroutine psset_runid(iobj, data, ierr)
    !! Run ID, one word, no imbedded blanks; <= 32 characters
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    CHARACTER*(*), intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_runid', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % RunID = data
end subroutine psset_runid


subroutine psgetsz_runid(iobj, size, ierr)
    !! Run ID, one word, no imbedded blanks; <= 32 characters
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: size    ! size of character string
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psgetsz_runid', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! note that the following will return the character length size regardless of
    ! the number of array elements (if RunID is an array)
    size = len(ss % RunID)
end subroutine psgetsz_runid


subroutine psget_rho_ecrf(iobj, n1, data, ierr)
    !! rho grid -- ECRF
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_rho_ecrf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % rho_ecrf
end subroutine psget_rho_ecrf


subroutine psset_rho_ecrf(iobj, n1, data, ierr)
    !! rho grid -- ECRF
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_rho_ecrf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % rho_ecrf = data(1:n1)
end subroutine psset_rho_ecrf


subroutine psgetrnk_rho_ecrf(iobj, ndims, ierr)
    !! rho grid -- ECRF
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_rho_ecrf


subroutine psgetdim_rho_ecrf(iobj, ndims, dims, ierr)
    !! rho grid -- ECRF
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_rho_ecrf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % rho_ecrf ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % rho_ecrf)
    endif
end subroutine psgetdim_rho_ecrf


subroutine psget_rho_mist(iobj, n1, data, ierr)
    !! rho grid (PLASMA) impurity-driven sources
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_rho_mist', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % rho_mist
end subroutine psget_rho_mist


subroutine psset_rho_mist(iobj, n1, data, ierr)
    !! rho grid (PLASMA) impurity-driven sources
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_rho_mist', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % rho_mist = data(1:n1)
end subroutine psset_rho_mist


subroutine psgetrnk_rho_mist(iobj, ndims, ierr)
    !! rho grid (PLASMA) impurity-driven sources
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_rho_mist


subroutine psgetdim_rho_mist(iobj, ndims, dims, ierr)
    !! rho grid (PLASMA) impurity-driven sources
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_rho_mist', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % rho_mist ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % rho_mist)
    endif
end subroutine psgetdim_rho_mist


subroutine psget_rho_bdy_ns(iobj, n1, data, ierr)
    !! locations beyond which densities are known
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_rho_bdy_ns', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % rho_bdy_ns
end subroutine psget_rho_bdy_ns


subroutine psset_rho_bdy_ns(iobj, n1, data, ierr)
    !! locations beyond which densities are known
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_rho_bdy_ns', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % rho_bdy_ns = data(1:n1)
end subroutine psset_rho_bdy_ns


subroutine psgetrnk_rho_bdy_ns(iobj, ndims, ierr)
    !! locations beyond which densities are known
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_rho_bdy_ns


subroutine psgetdim_rho_bdy_ns(iobj, ndims, dims, ierr)
    !! locations beyond which densities are known
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_rho_bdy_ns', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % rho_bdy_ns ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % rho_bdy_ns)
    endif
end subroutine psgetdim_rho_bdy_ns


subroutine psget_r_max_lcfs(iobj, data, ierr)
    !! R_max of last closed flux surface
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_r_max_lcfs', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % R_max_lcfs
end subroutine psget_r_max_lcfs


subroutine psset_r_max_lcfs(iobj, data, ierr)
    !! R_max of last closed flux surface
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_r_max_lcfs', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % R_max_lcfs = data
end subroutine psset_r_max_lcfs


subroutine psget_r_midp_in(iobj, n1, data, ierr)
    !! R (high field side) midplane intercept
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_r_midp_in', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % R_midp_in
end subroutine psget_r_midp_in


subroutine psset_r_midp_in(iobj, n1, data, ierr)
    !! R (high field side) midplane intercept
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_r_midp_in', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % R_midp_in = data(1:n1)
end subroutine psset_r_midp_in


subroutine psgetrnk_r_midp_in(iobj, ndims, ierr)
    !! R (high field side) midplane intercept
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_r_midp_in


subroutine psgetdim_r_midp_in(iobj, ndims, dims, ierr)
    !! R (high field side) midplane intercept
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_r_midp_in', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % R_midp_in ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % R_midp_in)
    endif
end subroutine psgetdim_r_midp_in


subroutine psget_rate_sinb0xs(iobj, n1, n2, n3, data, ierr)
    !! sink rate due to CX with beam ions
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2, n3 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2, n3) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_rate_sinb0xs', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2, 1: n3) = ss % rate_sinb0xs
end subroutine psget_rate_sinb0xs


subroutine psset_rate_sinb0xs(iobj, n1, n2, n3, data, ierr)
    !! sink rate due to CX with beam ions
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2, n3 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2, n3) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_rate_sinb0xs', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % rate_sinb0xs = data(1:n1, 1: n2, 1: n3)
end subroutine psset_rate_sinb0xs


subroutine psgetrnk_rate_sinb0xs(iobj, ndims, ierr)
    !! sink rate due to CX with beam ions
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 3
end subroutine psgetrnk_rate_sinb0xs


subroutine psgetdim_rate_sinb0xs(iobj, ndims, dims, ierr)
    !! sink rate due to CX with beam ions
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 3) ierr = 1
    call ccps_argcheck('psgetdim_rate_sinb0xs', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % rate_sinb0xs ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % rate_sinb0xs)
    endif
end subroutine psgetdim_rate_sinb0xs

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_i4_dummy
     return
  end subroutine ccps_getset_i4_dummy

subroutine psget_isthermal(iobj, n1, data, ierr)
    !! =1 if minority specie is thermalized, =0: never set; =2:
    !! non-thermal.
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_isthermal', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % isThermal
end subroutine psget_isthermal


subroutine psset_isthermal(iobj, n1, data, ierr)
    !! =1 if minority specie is thermalized, =0: never set; =2:
    !! non-thermal.
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_isthermal', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % isThermal = data(1:n1)
end subroutine psset_isthermal


subroutine psgetrnk_isthermal(iobj, ndims, ierr)
    !! =1 if minority specie is thermalized, =0: never set; =2:
    !! non-thermal.
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_isthermal


subroutine psgetdim_isthermal(iobj, ndims, dims, ierr)
    !! =1 if minority specie is thermalized, =0: never set; =2:
    !! non-thermal.
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_isthermal', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % isThermal ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % isThermal)
    endif
end subroutine psgetdim_isthermal


subroutine psget_id_vpol_omp(iobj, n1, data, ierr)
    !! 'Array of IDs for vpol_omp profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_vpol_omp', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_vpol_omp
end subroutine psget_id_vpol_omp


subroutine psgetrnk_id_vpol_omp(iobj, ndims, ierr)
    !! 'Array of IDs for vpol_omp profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_vpol_omp


subroutine psgetdim_id_vpol_omp(iobj, ndims, dims, ierr)
    !! 'Array of IDs for vpol_omp profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_vpol_omp', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_vpol_omp ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_vpol_omp)
    endif
end subroutine psgetdim_id_vpol_omp


subroutine psget_id_omegat(iobj, data, ierr)
    !! 'ID for omegat profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_omegat', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_omegat
end subroutine psget_id_omegat


subroutine psget_id_qrot_conv(iobj, data, ierr)
    !! 'ID for qrot_conv profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_qrot_conv', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_qrot_conv
end subroutine psget_id_qrot_conv


subroutine psget_id_pe_transcat(iobj, n1, data, ierr)
    !! 'Array of IDs for pe_transcat profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_pe_transcat', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_pe_transcat
end subroutine psget_id_pe_transcat


subroutine psgetrnk_id_pe_transcat(iobj, ndims, ierr)
    !! 'Array of IDs for pe_transcat profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_pe_transcat


subroutine psgetdim_id_pe_transcat(iobj, ndims, dims, ierr)
    !! 'Array of IDs for pe_transcat profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_pe_transcat', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_pe_transcat ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_pe_transcat)
    endif
end subroutine psgetdim_id_pe_transcat


subroutine psget_id_chimo_trans(iobj, data, ierr)
    !! 'ID for chimo_trans profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_chimo_trans', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_chimo_trans
end subroutine psget_id_chimo_trans


subroutine psget_id_chie_transcat(iobj, n1, data, ierr)
    !! 'Array of IDs for chie_transcat profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_chie_transcat', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_chie_transcat
end subroutine psget_id_chie_transcat


subroutine psgetrnk_id_chie_transcat(iobj, ndims, ierr)
    !! 'Array of IDs for chie_transcat profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_chie_transcat


subroutine psgetdim_id_chie_transcat(iobj, ndims, dims, ierr)
    !! 'Array of IDs for chie_transcat profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_chie_transcat', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_chie_transcat ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_chie_transcat)
    endif
end subroutine psgetdim_id_chie_transcat


subroutine psget_id_p_eq(iobj, data, ierr)
    !! 'ID for P_eq profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_p_eq', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_p_eq
end subroutine psget_id_p_eq


subroutine psget_id_xrjsin_momeq(iobj, n1, data, ierr)
    !! 'Array of IDs for xRjsin_momeq profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_xrjsin_momeq', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_xrjsin_momeq
end subroutine psget_id_xrjsin_momeq


subroutine psgetrnk_id_xrjsin_momeq(iobj, ndims, ierr)
    !! 'Array of IDs for xRjsin_momeq profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_xrjsin_momeq


subroutine psgetdim_id_xrjsin_momeq(iobj, ndims, dims, ierr)
    !! 'Array of IDs for xRjsin_momeq profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_xrjsin_momeq', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_xrjsin_momeq ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_xrjsin_momeq)
    endif
end subroutine psgetdim_id_xrjsin_momeq


subroutine psget_id_grho2(iobj, data, ierr)
    !! 'ID for grho2 profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_grho2', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_grho2
end subroutine psget_id_grho2


subroutine psget_id_gb2(iobj, data, ierr)
    !! 'ID for gb2 profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_gb2', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_gb2
end subroutine psget_id_gb2


subroutine psget_id_r_midp_in(iobj, data, ierr)
    !! 'ID for R_midp_in profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_r_midp_in', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_r_midp_in
end subroutine psget_id_r_midp_in


subroutine psget_id_elong(iobj, data, ierr)
    !! 'ID for elong profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_elong', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_elong
end subroutine psget_id_elong


subroutine psget_id_picrf_totals(iobj, n1, data, ierr)
    !! 'Array of IDs for picrf_totals profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_picrf_totals', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_picrf_totals
end subroutine psget_id_picrf_totals


subroutine psgetrnk_id_picrf_totals(iobj, ndims, ierr)
    !! 'Array of IDs for picrf_totals profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_picrf_totals


subroutine psgetdim_id_picrf_totals(iobj, ndims, dims, ierr)
    !! 'Array of IDs for picrf_totals profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_picrf_totals', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_picrf_totals ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_picrf_totals)
    endif
end subroutine psgetdim_id_picrf_totals


subroutine psget_id_epll_mini(iobj, n1, data, ierr)
    !! 'Array of IDs for epll_mini profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_epll_mini', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_epll_mini
end subroutine psget_id_epll_mini


subroutine psgetrnk_id_epll_mini(iobj, ndims, ierr)
    !! 'Array of IDs for epll_mini profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_epll_mini


subroutine psgetdim_id_epll_mini(iobj, ndims, dims, ierr)
    !! 'Array of IDs for epll_mini profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_epll_mini', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_epll_mini ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_epll_mini)
    endif
end subroutine psgetdim_id_epll_mini


subroutine psget_id_tqbi(iobj, data, ierr)
    !! 'ID for tqbi profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_tqbi', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_tqbi
end subroutine psget_id_tqbi


subroutine psget_id_psc_halo(iobj, data, ierr)
    !! 'ID for psc_halo profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_psc_halo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_psc_halo
end subroutine psget_id_psc_halo


subroutine psget_id_rate_sinb0xs(iobj, n1, n2, data, ierr)
    !! 'Array of IDs for rate_sinb0xs profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_rate_sinb0xs', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % id_rate_sinb0xs
end subroutine psget_id_rate_sinb0xs


subroutine psgetrnk_id_rate_sinb0xs(iobj, ndims, ierr)
    !! 'Array of IDs for rate_sinb0xs profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_id_rate_sinb0xs


subroutine psgetdim_id_rate_sinb0xs(iobj, ndims, dims, ierr)
    !! 'Array of IDs for rate_sinb0xs profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_id_rate_sinb0xs', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_rate_sinb0xs ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_rate_sinb0xs)
    endif
end subroutine psgetdim_id_rate_sinb0xs


subroutine psget_id_curfusn(iobj, data, ierr)
    !! 'ID for curfusn profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_curfusn', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_curfusn
end subroutine psget_id_curfusn


subroutine psget_id_prad(iobj, data, ierr)
    !! 'ID for prad profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_prad', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_prad
end subroutine psget_id_prad


subroutine psget_id_omeg0cx(iobj, n1, data, ierr)
    !! 'Array of IDs for omeg0cx profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_omeg0cx', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_omeg0cx
end subroutine psget_id_omeg0cx


subroutine psgetrnk_id_omeg0cx(iobj, ndims, ierr)
    !! 'Array of IDs for omeg0cx profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_omeg0cx


subroutine psgetdim_id_omeg0cx(iobj, ndims, dims, ierr)
    !! 'Array of IDs for omeg0cx profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_omeg0cx', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_omeg0cx ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_omeg0cx)
    endif
end subroutine psgetdim_id_omeg0cx


subroutine psget_id_psc_reco(iobj, data, ierr)
    !! 'ID for psc_reco profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_psc_reco', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_psc_reco
end subroutine psget_id_psc_reco


subroutine psget_id_peech_src(iobj, n1, data, ierr)
    !! 'Array of IDs for peech_src profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_peech_src', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_peech_src
end subroutine psget_id_peech_src


subroutine psgetrnk_id_peech_src(iobj, ndims, ierr)
    !! 'Array of IDs for peech_src profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_peech_src


subroutine psgetdim_id_peech_src(iobj, ndims, dims, ierr)
    !! 'Array of IDs for peech_src profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_peech_src', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_peech_src ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_peech_src)
    endif
end subroutine psgetdim_id_peech_src


subroutine psget_id_tfrip2_log(iobj, data, ierr)
    !! 'ID for tfrip2_log profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_tfrip2_log', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_tfrip2_log
end subroutine psget_id_tfrip2_log


subroutine psget_id_fidiff_bpass_co(iobj, n1, data, ierr)
    !! 'Array of IDs for fidiff_bpass_co profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_fidiff_bpass_co', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_fidiff_bpass_co
end subroutine psget_id_fidiff_bpass_co


subroutine psgetrnk_id_fidiff_bpass_co(iobj, ndims, ierr)
    !! 'Array of IDs for fidiff_bpass_co profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_fidiff_bpass_co


subroutine psgetdim_id_fidiff_bpass_co(iobj, ndims, dims, ierr)
    !! 'Array of IDs for fidiff_bpass_co profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_fidiff_bpass_co', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_fidiff_bpass_co ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_fidiff_bpass_co)
    endif
end subroutine psgetdim_id_fidiff_bpass_co


subroutine psget_id_pe_anom(iobj, data, ierr)
    !! 'ID for pe_anom profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_pe_anom', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_pe_anom
end subroutine psget_id_pe_anom


subroutine psget_id_chiphi_anom(iobj, data, ierr)
    !! 'ID for chiphi_anom profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_chiphi_anom', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_chiphi_anom
end subroutine psget_id_chiphi_anom


subroutine psget_id_tz_ky_tglf(iobj, n1, data, ierr)
    !! 'Array of IDs for tz_ky_tglf profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_tz_ky_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_tz_ky_tglf
end subroutine psget_id_tz_ky_tglf


subroutine psgetrnk_id_tz_ky_tglf(iobj, ndims, ierr)
    !! 'Array of IDs for tz_ky_tglf profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_tz_ky_tglf


subroutine psgetdim_id_tz_ky_tglf(iobj, ndims, dims, ierr)
    !! 'Array of IDs for tz_ky_tglf profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_tz_ky_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_tz_ky_tglf ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_tz_ky_tglf)
    endif
end subroutine psgetdim_id_tz_ky_tglf


subroutine psget_id_freq_max_tglf(iobj, data, ierr)
    !! 'ID for freq_max_tglf profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_freq_max_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_freq_max_tglf
end subroutine psget_id_freq_max_tglf


subroutine psget_id_chii_tglf(iobj, data, ierr)
    !! 'ID for chii_tglf profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_chii_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_chii_tglf
end subroutine psget_id_chii_tglf


subroutine psget_id_difnz_mmm71(iobj, data, ierr)
    !! 'ID for difnz_mmm71 profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_difnz_mmm71', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_difnz_mmm71
end subroutine psget_id_difnz_mmm71


subroutine psget_id_difns_w19(iobj, n1, data, ierr)
    !! 'Array of IDs for difns_w19 profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_difns_w19', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_difns_w19
end subroutine psget_id_difns_w19


subroutine psgetrnk_id_difns_w19(iobj, ndims, ierr)
    !! 'Array of IDs for difns_w19 profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_difns_w19


subroutine psgetdim_id_difns_w19(iobj, ndims, dims, ierr)
    !! 'Array of IDs for difns_w19 profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_difns_w19', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_difns_w19 ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_difns_w19)
    endif
end subroutine psgetdim_id_difns_w19


subroutine psget_id_chie_etg(iobj, data, ierr)
    !! 'ID for chie_etg profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_chie_etg', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_chie_etg
end subroutine psget_id_chie_etg


subroutine psget_id_velpphi_glf(iobj, data, ierr)
    !! 'ID for velpphi_glf profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_velpphi_glf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_velpphi_glf
end subroutine psget_id_velpphi_glf


subroutine psget_id_velte_gtcneo(iobj, data, ierr)
    !! 'ID for velte_gtcneo profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_velte_gtcneo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_velte_gtcneo
end subroutine psget_id_velte_gtcneo


subroutine psget_id_velpphi_neo(iobj, data, ierr)
    !! 'ID for velpphi_neo profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_velpphi_neo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_velpphi_neo
end subroutine psget_id_velpphi_neo


subroutine psget_id_velns_nclass(iobj, n1, data, ierr)
    !! 'Array of IDs for velns_nclass profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_velns_nclass', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_velns_nclass
end subroutine psget_id_velns_nclass


subroutine psgetrnk_id_velns_nclass(iobj, ndims, ierr)
    !! 'Array of IDs for velns_nclass profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_velns_nclass


subroutine psgetdim_id_velns_nclass(iobj, ndims, dims, ierr)
    !! 'Array of IDs for velns_nclass profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_velns_nclass', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_velns_nclass ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_velns_nclass)
    endif
end subroutine psgetdim_id_velns_nclass

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_v8_dummy
     return
  end subroutine ccps_getset_v8_dummy

subroutine psget_vsize_coil(iobj, n1, data, ierr)
    !! (Rotatable) Vertical coil size
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_vsize_coil', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % Vsize_coil
end subroutine psget_vsize_coil


subroutine psset_vsize_coil(iobj, n1, data, ierr)
    !! (Rotatable) Vertical coil size
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_vsize_coil', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % Vsize_coil = data(1:n1)
end subroutine psset_vsize_coil


subroutine psgetrnk_vsize_coil(iobj, ndims, ierr)
    !! (Rotatable) Vertical coil size
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_vsize_coil


subroutine psgetdim_vsize_coil(iobj, ndims, dims, ierr)
    !! (Rotatable) Vertical coil size
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_vsize_coil', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % Vsize_coil ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % Vsize_coil)
    endif
end subroutine psgetdim_vsize_coil


subroutine psget_vee_trans(iobj, n1, data, ierr)
    !! electron energy radial velocity
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_vee_trans', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % vee_trans
end subroutine psget_vee_trans


subroutine psset_vee_trans(iobj, n1, data, ierr)
    !! electron energy radial velocity
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_vee_trans', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % vee_trans = data(1:n1)
end subroutine psset_vee_trans


subroutine psgetrnk_vee_trans(iobj, ndims, ierr)
    !! electron energy radial velocity
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_vee_trans


subroutine psgetdim_vee_trans(iobj, ndims, dims, ierr)
    !! electron energy radial velocity
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_vee_trans', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % vee_trans ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % vee_trans)
    endif
end subroutine psgetdim_vee_trans


subroutine psget_velb_nbi(iobj, n1, data, ierr)
    !! beam ion anom. radial velocity
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_velb_nbi', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % velb_nbi
end subroutine psget_velb_nbi


subroutine psset_velb_nbi(iobj, n1, data, ierr)
    !! beam ion anom. radial velocity
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_velb_nbi', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % velb_nbi = data(1:n1)
end subroutine psset_velb_nbi


subroutine psgetrnk_velb_nbi(iobj, ndims, ierr)
    !! beam ion anom. radial velocity
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_velb_nbi


subroutine psgetdim_velb_nbi(iobj, ndims, dims, ierr)
    !! beam ion anom. radial velocity
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_velb_nbi', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % velb_nbi ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % velb_nbi)
    endif
end subroutine psgetdim_velb_nbi


subroutine psget_velte_anom(iobj, n1, data, ierr)
    !! Te-equation, advective velocity term
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_velte_anom', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % velte_anom
end subroutine psget_velte_anom


subroutine psset_velte_anom(iobj, n1, data, ierr)
    !! Te-equation, advective velocity term
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_velte_anom', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % velte_anom = data(1:n1)
end subroutine psset_velte_anom


subroutine psgetrnk_velte_anom(iobj, ndims, ierr)
    !! Te-equation, advective velocity term
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_velte_anom


subroutine psgetdim_velte_anom(iobj, ndims, dims, ierr)
    !! Te-equation, advective velocity term
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_velte_anom', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % velte_anom ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % velte_anom)
    endif
end subroutine psgetdim_velte_anom


subroutine psget_velns_tglf(iobj, n1, n2, data, ierr)
    !! density-equations, advective velocity term from TGLF model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_velns_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % velns_tglf
end subroutine psget_velns_tglf


subroutine psset_velns_tglf(iobj, n1, n2, data, ierr)
    !! density-equations, advective velocity term from TGLF model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_velns_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % velns_tglf = data(1:n1, 1: n2)
end subroutine psset_velns_tglf


subroutine psgetrnk_velns_tglf(iobj, ndims, ierr)
    !! density-equations, advective velocity term from TGLF model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_velns_tglf


subroutine psgetdim_velns_tglf(iobj, ndims, dims, ierr)
    !! density-equations, advective velocity term from TGLF model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_velns_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % velns_tglf ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % velns_tglf)
    endif
end subroutine psgetdim_velns_tglf


subroutine psget_velti_mmm71(iobj, n1, data, ierr)
    !! Ti-equation, advective velocity term from MMM71 model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_velti_mmm71', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % velti_mmm71
end subroutine psget_velti_mmm71


subroutine psset_velti_mmm71(iobj, n1, data, ierr)
    !! Ti-equation, advective velocity term from MMM71 model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_velti_mmm71', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % velti_mmm71 = data(1:n1)
end subroutine psset_velti_mmm71


subroutine psgetrnk_velti_mmm71(iobj, ndims, ierr)
    !! Ti-equation, advective velocity term from MMM71 model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_velti_mmm71


subroutine psgetdim_velti_mmm71(iobj, ndims, dims, ierr)
    !! Ti-equation, advective velocity term from MMM71 model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_velti_mmm71', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % velti_mmm71 ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % velti_mmm71)
    endif
end subroutine psgetdim_velti_mmm71

subroutine ur_dcomp_display(dtype, tlabel, ilabel)

  !  generate summary comparitive display of all grids or species lists or
  !  item lists

  use cstate_lib_mod
  implicit NONE

  !-------------------------
  ! passed:

  character*1, intent(in) :: dtype      ! "G" for grids;
  !                           "S" for species lists; "L" for item lists

  character*(*), intent(in) :: tlabel   ! label for table cells
  !                              e.g. "Grid_sizes"

  character*(*), intent(in) :: ilabel   ! short label for objects compared
  !                              e.g. "grids"

  !-------------------------
  ! local

  integer :: isize

  integer :: luntty,lnout
 
  integer :: ival_lens(nsss_cur)
  integer, dimension(:,:), allocatable :: imatch_sets,igsizes
  integer :: ierr,i,ii,j,jlim,jj,kk,ilen_gname,imatch_cur,insel
  integer :: inum,inums(nsss_cur),inmax,iself(nsss_cur)
  logical :: match

  character*32 iname,gname1,gname2,chdr,cvals(nsss_cur),sname1,sname2

  type (ps_list_window), dimension(:), allocatable :: wwloc

  !-------------------------
  luntty = lnout(0)

  isize = w1%size

  if((dtype.ne.'G').and.(dtype.ne.'S').and.(dtype.ne.'L')) then
     write(luntty,*) ' ?ur_dcomp_display: cstate_lib internal error: dtype=', &
          dtype
     return
  endif

  ! set up display objects
  ! all have the same members as the data objects
  ! because the list of grids or lists is an attribute of the state definition

  do i=1,nsss_cur
     call psw_contents(dtype,ncur_components,ww(i),ierr, state=sss(i))
     if(ierr.ne.0) exit

     call free_window(wdisp(i))
     wdisp(i)%size = isize
     wdisp(i)%list_name = tlabel
     allocate(wdisp(i)%list_elems(isize))
     wdisp(i)%list_elems = w1%list_elems
     allocate(wdisp(i)%val_field(isize)); wdisp(i)%val_field = ' '
  enddo
  if(ierr.ne.0) return

  imatch_cur = 0
  allocate(igsizes(nsss_cur,isize))
  allocate(imatch_sets(nsss_cur,isize))
  imatch_sets = 0

  ival_lens = 0
  ilen_gname = len(trim(wdisp(1)%list_name))

  !  loop over grids or lists
  do ii = 1,isize
     do i=1,nsss_cur
        igsizes(i,ii) = ww(i)%ival(ii)
     enddo
     do i=1,nsss_cur
        call iencode(igsizes(i,ii),wdisp(i)%val_field(ii),ival_lens(i))
     enddo
     ilen_gname=max(ilen_gname,len(trim(wdisp(1)%list_elems(ii))))
  enddo

  ilen_gname = ilen_gname + 1  ! extra space added

  !  look for and mark matching grids or lists
  do ii = 1,isize
     if(dtype.eq.'G') then
        ! special code for grids: grids of different names can be considered
        ! identical...

        do i=1,nsss_cur

           match = .FALSE.
           gname1 = ww(i)%list_elems(ii)
           do jj=1,ii
              if(jj.lt.ii) then
                 jlim=nsss_cur
              else
                 jlim=i-1
              endif

              do j = 1,jlim
                 gname2 = ww(j)%list_elems(jj)
                 call pscomp_grids(sss(i),sss(j),gname1,gname2,match,ierr)

                 if(match) then
                    if(imatch_sets(j,jj).gt.0) then
                       imatch_sets(i,ii) = imatch_sets(j,jj)
                       call augment(wdisp(i)%val_field(ii), &
                            imatch_sets(i,ii),ival_lens(i))
                    else
                       imatch_cur = imatch_cur + 1
                       imatch_sets(i,ii) = imatch_cur
                       call augment(wdisp(i)%val_field(ii), &
                            imatch_sets(i,ii),ival_lens(i))
                       imatch_sets(j,jj) = imatch_cur
                       call augment(wdisp(j)%val_field(jj), &
                            imatch_sets(j,jj),ival_lens(j))
                    endif
                    exit
                 endif
              enddo
              if(match) exit
           enddo

        enddo

     else if(dtype.eq.'S') then
        ! special code for species lists: lists of different names can 
        ! be considered identical...

        allocate(wwloc(2))

        do i=1,nsss_cur

           match = .FALSE.
           gname1 = ww(i)%list_elems(ii)
           do jj=1,ii
              if(jj.lt.ii) then
                 jlim=nsss_cur
              else
                 jlim=i-1
              endif

              do j=1,jlim
                 gname2 = ww(j)%list_elems(jj)

                 if((igsizes(i,ii).gt.0).and. &
                      (igsizes(i,ii).eq.igsizes(j,jj))) then

                    match = .TRUE.  ! size match only at present

                    call psw_slist(gname1,wwloc(1),ierr, state=sss(i))
                    call psw_slist(gname2,wwloc(2),ierr, state=sss(j))

                    do kk=1,igsizes(i,ii)
                       sname1=wwloc(1)%list_elems(kk)
                       sname2=wwloc(2)%list_elems(kk)
                       if(sname1.ne.sname2) then
                          match=.FALSE.
                          exit
                       endif
                    enddo
                 endif

                 if(match) then
                    if(imatch_sets(j,jj).gt.0) then
                       imatch_sets(i,ii) = imatch_sets(j,jj)
                       call augment(wdisp(i)%val_field(ii), &
                            imatch_sets(i,ii),ival_lens(i))
                    else
                       imatch_cur = imatch_cur + 1
                       imatch_sets(i,ii) = imatch_cur
                       call augment(wdisp(i)%val_field(ii), &
                            imatch_sets(i,ii),ival_lens(i))
                       imatch_sets(j,jj) = imatch_cur
                       call augment(wdisp(j)%val_field(jj), &
                            imatch_sets(j,jj),ival_lens(j))
                    endif
                    exit
                 endif
              enddo
              if(match) exit
           enddo

        enddo

        do i=1,2
           call free_window(wwloc(i))
        enddo

        deallocate(wwloc)

     else
        ! for non-grid, non-species-list dimensions, only lists of the 
        ! same names are compared between states

        allocate(wwloc(nsss_cur))

        iname = ww(1)%list_elems(ii)
        do i=1,nsss_cur
           call psw_ilist(iname,wwloc(i),ierr, state=sss(i))
        enddo

        do i=2,nsss_cur
           do j=1,i-1
              match = .FALSE.
              if(igsizes(i,ii).eq.igsizes(j,ii)) then
                 ! sizes match; compare element names
                 ! Note: empty lists not considered to match.

                 if(igsizes(i,ii).gt.0) match=.TRUE.

                 do jj=1,igsizes(i,ii)
                    gname1=wwloc(i)%list_elems(jj)
                    gname2=wwloc(j)%list_elems(jj)
                    if(gname1.ne.gname2) then
                       match=.FALSE.
                       exit
                    endif
                 enddo
              endif

              if(match) then
                 if(imatch_sets(j,ii).gt.0) then
                    imatch_sets(i,ii) = imatch_sets(j,ii)
                    call augment(wdisp(i)%val_field(ii), &
                         imatch_sets(i,ii),ival_lens(i))
                 else
                    imatch_cur = imatch_cur + 1
                    imatch_sets(i,ii) = imatch_cur
                    call augment(wdisp(i)%val_field(ii), &
                         imatch_sets(i,ii),ival_lens(i))
                    imatch_sets(j,ii) = imatch_cur
                    call augment(wdisp(j)%val_field(ii), &
                         imatch_sets(j,ii),ival_lens(j))
                 endif
              endif
              exit
           enddo
        enddo

        do i=1,nsss_cur
           call free_window(wwloc(i))
        enddo

        deallocate(wwloc)
     endif
  enddo

  do i=1,nsss_cur
     ival_lens(i)=max(ival_lens(i),len(trim(sss_label(i))))
  enddo

  write(luntty,*) ' '
  call disp1(ilen_gname,ival_lens, &
       wdisp(1)%list_name,sss_label(1:nsss_cur))

  chdr = rline(1:len(chdr))
  cvals = chdr
  call disp1(ilen_gname,ival_lens,chdr,cvals)

  do ii = 1,isize
     do jj=1,nsss_cur
        cvals(jj) = wdisp(jj)%val_field(ii)
     enddo
     call disp1(ilen_gname,ival_lens, &
          wdisp(1)%list_elems(ii),cvals)
  enddo

  deallocate(igsizes,imatch_sets)

  contains
    subroutine disp1(len1,lenn,col1,coln)
      !  display 1 line
      integer, intent(in) :: len1
      integer, intent(in), dimension(:) :: lenn
      character*(*) :: col1
      character*32, dimension(:) :: coln

      !---------------------
      integer :: ic,ii,isum
      !---------------------

      isum = len1 + sum(lenn) + size(lenn)
      if(isum.gt.len(cbuf)) then
         write(luntty,*) ' ?ur_dcomp_display:disp1: char buf overflow.'

      else
         cbuf=' '
         cbuf(1:len1) = col1(1:len1)
         ic = len1
         do ii=1,size(lenn)
            ic = ic + 1
            cbuf(ic+1:ic+lenn(ii)) = coln(ii)(1:lenn(ii))
            ic = ic + lenn(ii)
         enddo
         write(luntty,'(A)') trim(cbuf)
      endif

    end subroutine disp1

    subroutine iencode(ival,val_field,ilen_max)
      ! encode a non-negative integer value as character, left-justified
      ! record maximum length

      integer :: ival   ! integer value (in)
      character*(*) :: val_field  ! encoded string (out)
      integer :: ilen_max  ! max length (inout)

      !---------------------
      integer :: iuse,ilen
      !---------------------

      iuse = max(0,ival)
      val_field = ' '

      if(iuse.eq.0) then
         ilen=7
         val_field(1:7)='(empty)'
      else if(iuse.le.9) then
         ilen=1
         write(val_field(1:1),'(I1)') iuse
      else if(iuse.le.99) then
         ilen=2
         write(val_field(1:2),'(I2)') iuse
      else if(iuse.le.999) then
         ilen=3
         write(val_field(1:3),'(I3)') iuse
      else if(iuse.le.9999) then
         ilen=4
         write(val_field(1:4),'(I4)') iuse
      else if(iuse.le.99999) then
         ilen=5
         write(val_field(1:5),'(I5)') iuse
      else if(iuse.le.999999) then
         ilen=6
         write(val_field(1:6),'(I6)') iuse
      else if(iuse.le.9999999) then
         ilen=7
         write(val_field(1:7),'(I7)') iuse
      else
         ilen=7
         val_field='*******'
      endif

      ilen_max = max(ilen_max,ilen)
    end subroutine iencode

    subroutine augment(val_field,imatch_set,ilen_max)

      !  extend label to mark presence of matched set

      character*(*) val_field ! display value (inout)
      integer :: imatch_set   ! number of set of matching grids (in)
      integer :: ilen_max     ! max val_field non-blank length (out)

      !----------------------
      integer :: ic,ib,ilen
      character*4 zmatch
      !----------------------

      write(zmatch,'(i4)') imatch_set

      ilen = len(trim(val_field))

      ic = ilen + 2
      val_field(ic:ic)='['; ic = ic + 1
      do ib = 1,len(zmatch)
         if(zmatch(ib:ib).ne.' ') then
            val_field(ic:ic)=zmatch(ib:ib)
            ic = ic + 1
         endif
      enddo
      val_field(ic:ic)=']'

      ilen = ic
      ilen_max = max(ilen_max,ilen)

    end subroutine augment

end subroutine ur_dcomp_display

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_p7_dummy
     return
  end subroutine ccps_getset_p7_dummy

subroutine psget_phi_ec_launch(iobj, n1, data, ierr)
    !! Phi of center of launcher, this may be left at zero for
    !! axisymmetric simulations.
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_phi_ec_launch', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % Phi_EC_launch
end subroutine psget_phi_ec_launch


subroutine psset_phi_ec_launch(iobj, n1, data, ierr)
    !! Phi of center of launcher, this may be left at zero for
    !! axisymmetric simulations.
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_phi_ec_launch', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % Phi_EC_launch = data(1:n1)
end subroutine psset_phi_ec_launch


subroutine psgetrnk_phi_ec_launch(iobj, ndims, ierr)
    !! Phi of center of launcher, this may be left at zero for
    !! axisymmetric simulations.
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_phi_ec_launch


subroutine psgetdim_phi_ec_launch(iobj, ndims, dims, ierr)
    !! Phi of center of launcher, this may be left at zero for
    !! axisymmetric simulations.
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_phi_ec_launch', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % Phi_EC_launch ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % Phi_EC_launch)
    endif
end subroutine psgetdim_phi_ec_launch


subroutine psget_picrf_ext(iobj, n1, data, ierr)
    !! RF power deposited outside plasma
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_picrf_ext', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % picrf_ext
end subroutine psget_picrf_ext


subroutine psset_picrf_ext(iobj, n1, data, ierr)
    !! RF power deposited outside plasma
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_picrf_ext', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % picrf_ext = data(1:n1)
end subroutine psset_picrf_ext


subroutine psgetrnk_picrf_ext(iobj, ndims, ierr)
    !! RF power deposited outside plasma
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_picrf_ext


subroutine psgetdim_picrf_ext(iobj, ndims, dims, ierr)
    !! RF power deposited outside plasma
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_picrf_ext', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % picrf_ext ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % picrf_ext)
    endif
end subroutine psgetdim_picrf_ext


subroutine psget_phit(iobj, n1, data, ierr)
    !! toroidal flux vs. rho, By convention, this profile always
    !! positive; 0 on axis., See kccw_Bphi for specification of
    !! direction of toroidal field.
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_phit', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % phit
end subroutine psget_phit


subroutine psset_phit(iobj, n1, data, ierr)
    !! toroidal flux vs. rho, By convention, this profile always
    !! positive; 0 on axis., See kccw_Bphi for specification of
    !! direction of toroidal field.
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_phit', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % phit = data(1:n1)
end subroutine psset_phit


subroutine psgetrnk_phit(iobj, ndims, ierr)
    !! toroidal flux vs. rho, By convention, this profile always
    !! positive; 0 on axis., See kccw_Bphi for specification of
    !! direction of toroidal field.
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_phit


subroutine psgetdim_phit(iobj, ndims, dims, ierr)
    !! toroidal flux vs. rho, By convention, this profile always
    !! positive; 0 on axis., See kccw_Bphi for specification of
    !! direction of toroidal field.
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_phit', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % phit ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % phit)
    endif
end subroutine psgetdim_phit


subroutine psget_psirz(iobj, n1, n2, data, ierr)
    !! Psi(R,Z), Note on Psi(rho) and Psi(R,Z) both: convention is
    !! to set, Psi=0 at the magnetic axis and increasing towards the
    !! plasma, boundary.  Direction of poloidal field is taken from
    !! element, kccw_Jphi:, , BR = kccw_Jphi*(1/R)*d(Psi/dZ), BZ
    !! =-kccw_Jphi*(1/R)*d(Psi/dR), , see also: Psi_to_machine_axis.
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_psirz', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % PsiRZ
end subroutine psget_psirz


subroutine psset_psirz(iobj, n1, n2, data, ierr)
    !! Psi(R,Z), Note on Psi(rho) and Psi(R,Z) both: convention is
    !! to set, Psi=0 at the magnetic axis and increasing towards the
    !! plasma, boundary.  Direction of poloidal field is taken from
    !! element, kccw_Jphi:, , BR = kccw_Jphi*(1/R)*d(Psi/dZ), BZ
    !! =-kccw_Jphi*(1/R)*d(Psi/dR), , see also: Psi_to_machine_axis.
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_psirz', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % PsiRZ = data(1:n1, 1: n2)
end subroutine psset_psirz


subroutine psgetrnk_psirz(iobj, ndims, ierr)
    !! Psi(R,Z), Note on Psi(rho) and Psi(R,Z) both: convention is
    !! to set, Psi=0 at the magnetic axis and increasing towards the
    !! plasma, boundary.  Direction of poloidal field is taken from
    !! element, kccw_Jphi:, , BR = kccw_Jphi*(1/R)*d(Psi/dZ), BZ
    !! =-kccw_Jphi*(1/R)*d(Psi/dR), , see also: Psi_to_machine_axis.
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_psirz


subroutine psgetdim_psirz(iobj, ndims, dims, ierr)
    !! Psi(R,Z), Note on Psi(rho) and Psi(R,Z) both: convention is
    !! to set, Psi=0 at the magnetic axis and increasing towards the
    !! plasma, boundary.  Direction of poloidal field is taken from
    !! element, kccw_Jphi:, , BR = kccw_Jphi*(1/R)*d(Psi/dZ), BZ
    !! =-kccw_Jphi*(1/R)*d(Psi/dR), , see also: Psi_to_machine_axis.
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_psirz', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % PsiRZ ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % PsiRZ)
    endif
end subroutine psgetdim_psirz


subroutine psget_prad_li(iobj, n1, data, ierr)
    !! line radiation contribution
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_prad_li', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % prad_li
end subroutine psget_prad_li


subroutine psset_prad_li(iobj, n1, data, ierr)
    !! line radiation contribution
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_prad_li', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % prad_li = data(1:n1)
end subroutine psset_prad_li


subroutine psgetrnk_prad_li(iobj, ndims, ierr)
    !! line radiation contribution
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_prad_li


subroutine psgetdim_prad_li(iobj, ndims, dims, ierr)
    !! line radiation contribution
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_prad_li', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % prad_li ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % prad_li)
    endif
end subroutine psgetdim_prad_li


subroutine psget_pilh(iobj, n1, data, ierr)
    !! ion heating by LH
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_pilh', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % pilh
end subroutine psget_pilh


subroutine psset_pilh(iobj, n1, data, ierr)
    !! ion heating by LH
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_pilh', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % pilh = data(1:n1)
end subroutine psset_pilh


subroutine psgetrnk_pilh(iobj, ndims, ierr)
    !! ion heating by LH
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_pilh


subroutine psgetdim_pilh(iobj, ndims, dims, ierr)
    !! ion heating by LH
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_pilh', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % pilh ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % pilh)
    endif
end subroutine psgetdim_pilh

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_n2_dummy
     return
  end subroutine ccps_getset_n2_dummy

subroutine psget_num_rzlim(iobj, data, ierr)
    !! number of points, axisymmetric (R,Z) limiter, dimension for
    !! rlim & zlim -- closed axisymmetric piecewise linear, contour
    !! describing axisymmetric limiter or vacuum vessel wall, expect
    !! rlim(1)=rlim(num_rzlim) and zlim(1)=zlim(num_rzlim)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_num_rzlim', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % num_rzlim
end subroutine psget_num_rzlim


subroutine psset_num_rzlim(iobj, data, ierr)
    !! number of points, axisymmetric (R,Z) limiter, dimension for
    !! rlim & zlim -- closed axisymmetric piecewise linear, contour
    !! describing axisymmetric limiter or vacuum vessel wall, expect
    !! rlim(1)=rlim(num_rzlim) and zlim(1)=zlim(num_rzlim)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_num_rzlim', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % num_rzlim = data
end subroutine psset_num_rzlim


subroutine psget_nnktorlh(iobj, n1, n2, data, ierr)
    !! need description
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_nnktorlh', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % nnktorlh
end subroutine psget_nnktorlh


subroutine psset_nnktorlh(iobj, n1, n2, data, ierr)
    !! need description
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    INTEGER, intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_nnktorlh', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % nnktorlh = data(1:n1, 1: n2)
end subroutine psset_nnktorlh


subroutine psgetrnk_nnktorlh(iobj, ndims, ierr)
    !! need description
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_nnktorlh


subroutine psgetdim_nnktorlh(iobj, ndims, dims, ierr)
    !! need description
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_nnktorlh', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % nnktorlh ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % nnktorlh)
    endif
end subroutine psgetdim_nnktorlh


subroutine psget_nspec_tha(iobj, data, ierr)
    !! species list dimension of SA (thermal_specie)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_nspec_tha', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % nspec_tha
end subroutine psget_nspec_tha


subroutine psset_nspec_tha(iobj, data, ierr)
    !! species list dimension of SA (thermal_specie)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_nspec_tha', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % nspec_tha = data
end subroutine psset_nspec_tha


subroutine psget_nth_eq(iobj, data, ierr)
    !! grid dimension of th_eq (TH coordinate)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_nth_eq', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % nth_eq
end subroutine psget_nth_eq


subroutine psset_nth_eq(iobj, data, ierr)
    !! grid dimension of th_eq (TH coordinate)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_nth_eq', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % nth_eq = data
end subroutine psset_nth_eq


subroutine psget_nmom(iobj, data, ierr)
    !! number of Fourier (R,Z) moments, requested for Fourier
    !! Spline representation, R(x,th) = R0(x) + sum
    !! x*(xRj(x)*cos(j*th) + xRj~(x)*sin(j*th)), Z(x,th) = Z0(x) + sum
    !! x*(xZj~(x)*cos(j*th) + xZj(x)*sin(j*th))
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_nmom', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % nmom
end subroutine psget_nmom


subroutine psset_nmom(iobj, data, ierr)
    !! number of Fourier (R,Z) moments, requested for Fourier
    !! Spline representation, R(x,th) = R0(x) + sum
    !! x*(xRj(x)*cos(j*th) + xRj~(x)*sin(j*th)), Z(x,th) = Z0(x) + sum
    !! x*(xZj~(x)*cos(j*th) + xZj(x)*sin(j*th))
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_nmom', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % nmom = data
end subroutine psset_nmom


subroutine psget_nnewcomb(iobj, data, ierr)
    !! item list dimension of Newcomb_code (Newcomb_codes)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_nnewcomb', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % nnewcomb
end subroutine psget_nnewcomb


subroutine psset_nnewcomb(iobj, data, ierr)
    !! item list dimension of Newcomb_code (Newcomb_codes)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_nnewcomb', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % nnewcomb = data
end subroutine psset_nnewcomb


subroutine psget_nr_rip(iobj, data, ierr)
    !! grid dimension of R_ripple (R coordinate)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_nr_rip', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % nr_rip
end subroutine psget_nr_rip


subroutine psset_nr_rip(iobj, data, ierr)
    !! grid dimension of R_ripple (R coordinate)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_nr_rip', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % nr_rip = data
end subroutine psset_nr_rip


subroutine psget_nrho_anom2(iobj, data, ierr)
    !! grid dimension of rho_anom2 (RHO coordinate)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_nrho_anom2', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % nrho_anom2
end subroutine psget_nrho_anom2


subroutine psset_nrho_anom2(iobj, data, ierr)
    !! grid dimension of rho_anom2 (RHO coordinate)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_nrho_anom2', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % nrho_anom2 = data
end subroutine psset_nrho_anom2


subroutine psget_nebar(iobj, data, ierr)
    !! line-averaged electron density
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_nebar', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % nebar
end subroutine psget_nebar


subroutine psset_nebar(iobj, data, ierr)
    !! line-averaged electron density
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_nebar', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % nebar = data
end subroutine psset_nebar


subroutine psget_ni(iobj, n1, data, ierr)
    !! total thermal ion density, should match sum ns(:,1:nspec_th)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_ni', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % ni
end subroutine psget_ni


subroutine psset_ni(iobj, n1, data, ierr)
    !! total thermal ion density, should match sum ns(:,1:nspec_th)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_ni', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % ni = data(1:n1)
end subroutine psset_ni


subroutine psgetrnk_ni(iobj, ndims, ierr)
    !! total thermal ion density, should match sum ns(:,1:nspec_th)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_ni


subroutine psgetdim_ni(iobj, ndims, dims, ierr)
    !! total thermal ion density, should match sum ns(:,1:nspec_th)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_ni', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % ni ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % ni)
    endif
end subroutine psgetdim_ni


subroutine psget_nmini(iobj, n1, n2, data, ierr)
    !! minority species density
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_nmini', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % nmini
end subroutine psget_nmini


subroutine psset_nmini(iobj, n1, n2, data, ierr)
    !! minority species density
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_nmini', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % nmini = data(1:n1, 1: n2)
end subroutine psset_nmini


subroutine psgetrnk_nmini(iobj, ndims, ierr)
    !! minority species density
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_nmini


subroutine psgetdim_nmini(iobj, ndims, dims, ierr)
    !! minority species density
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_nmini', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % nmini ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % nmini)
    endif
end subroutine psgetdim_nmini

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


SUBROUTINE ps_update_file_write_def_1(ss,icdf,cclist,nids,iout,iwarn,iertot)


  ! Define updated data

  USE plasma_state_definition_mod
  USE netcdf
  USE ps_nidlist_defn
  IMPLICIT NONE

  TYPE (plasma_state) :: ss  ! state containing array elements to be allocated
  INTEGER, INTENT(IN) :: icdf  ! NetCDF file ID
  INTEGER, INTENT(IN) :: cclist(ps_ccount)  ! component selection
  TYPE (nidlist) :: nids       ! defined dimensions list
  INTEGER, INTENT(IN) :: iout  ! LUN for messages
  INTEGER, INTENT(INOUT) :: iwarn   ! warn count
  INTEGER, INTENT(INOUT) :: iertot  ! error count

  !-------------------
  LOGICAL :: plasma_state_hash_match,ichange

  INTEGER :: varid,pvarid,vvarid,dimid,status,iertmp,iaddr
  INTEGER :: idims(20),indim,ival,ii,ierr
  CHARACTER*80 :: nc_errmsg

  !-------------------

  ierr = 0   ! local

  iaddr = ps_phash_chii_ntm
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%chii_ntm).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("chii_ntm","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        CALL define_var("chii_ntm","R",indim,idims, &
               "Ti-equation, neoclassical diffusivity from NTM model", &
               "m^2/s","ANOM","STATE_PROFILES", &
               "R|units=m^2/s|pclin chii_ntm(nrho_anomth)")
     ENDIF
  ENDIF

  iaddr = ps_phash_chii_tglf
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%chii_tglf).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("chii_tglf","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        CALL define_var("chii_tglf","R",indim,idims, &
               "Ti-equation, diffusivity from TGLF model", &
               "m^2/s","ANOM","STATE_PROFILES", &
               "R|units=m^2/s|pclin chii_tglf(nrho_anomth)")
     ENDIF
  ENDIF

  iaddr = ps_phash_chii_trans
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%chii_trans).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("chii_trans","PLASMA")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho,"dim_nrho",ss%nrho)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho
        CALL define_var("chii_trans","R",indim,idims, &
               "ion thermal diffusivity", &
               "m^2/sec","PLASMA","STATE_PROFILES", &
               "R|pclin chii_trans(nrho)")
     ENDIF
  ENDIF

  iaddr = ps_phash_chii_transcat
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%chii_transcat).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("chii_transcat","PLASMA")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho,"dim_nrho",ss%nrho)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho
        IF(nids%nid_dim_ntrcat.EQ.0) THEN
           CALL define_dim(nids%nid_dim_ntrcat,"dim_ntrcat",ss%ntrcat)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_ntrcat
        CALL define_var("chii_transcat","R",indim,idims, &
               "Ion energy diffusivity", &
               "m^2/sec","PLASMA","STATE_PROFILES", &
               "R|units=m^2/sec|pclin chii_transcat(nrho,ntrcat)")
     ENDIF
  ENDIF

  iaddr = ps_phash_chii_w19
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%chii_w19).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("chii_w19","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        CALL define_var("chii_w19","R",indim,idims, &
               "Ti-equation, diffusivity term", &
               "m^2/sec","ANOM","STATE_PROFILES", &
               "R|units=m^2/sec|pclin  chii_w19(nrho_anomth)")
     ENDIF
  ENDIF

  iaddr = ps_phash_chimo_trans
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%chimo_trans).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("chimo_trans","PLASMA")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho,"dim_nrho",ss%nrho)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho
        CALL define_var("chimo_trans","R",indim,idims, &
               "angular momentum diffusivity", &
               "m^2/sec","PLASMA","STATE_PROFILES", &
               "R|pclin chimo_trans(nrho)")
     ENDIF
  ENDIF

  iaddr = ps_phash_chimo_transcat
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%chimo_transcat).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("chimo_transcat","PLASMA")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho,"dim_nrho",ss%nrho)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho
        IF(nids%nid_dim_ntrcat.EQ.0) THEN
           CALL define_dim(nids%nid_dim_ntrcat,"dim_ntrcat",ss%ntrcat)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_ntrcat
        CALL define_var("chimo_transcat","R",indim,idims, &
               "Angular momentum diffusivity", &
               "m^2/sec","PLASMA","STATE_PROFILES", &
               "R|units=m^2/sec|pclin chimo_transcat(nrho,ntrcat)")
     ENDIF
  ENDIF

  iaddr = ps_phash_chiphi_anom
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%chiphi_anom).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("chiphi_anom","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        CALL define_var("chiphi_anom","R",indim,idims, &
               "momentum-equation, diffusivity term", &
               "m^2/sec","ANOM","STATE_PROFILES", &
               "R|units=m^2/sec|pclin  chiphi_anom(nrho_anomth)")
     ENDIF
  ENDIF

  iaddr = ps_phash_chiphi_drbm
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%chiphi_drbm).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("chiphi_drbm","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        CALL define_var("chiphi_drbm","R",indim,idims, &
               "momentum-equation, diffusivity term", &
               "m^2/sec","ANOM","STATE_PROFILES", &
               "R|units=m^2/sec|pclin  chiphi_drbm(nrho_anomth)")
     ENDIF
  ENDIF

  iaddr = ps_phash_chiphi_glf
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%chiphi_glf).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("chiphi_glf","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        CALL define_var("chiphi_glf","R",indim,idims, &
               "momentum-equation, diffusivity from GLF23 model", &
               "m^2/s","ANOM","STATE_PROFILES", &
               "R|units=m^2/s|pclin chiphi_glf(nrho_anomth)")
     ENDIF
  ENDIF

  iaddr = ps_phash_chiphi_gtcneo
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%chiphi_gtcneo).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("chiphi_gtcneo","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        CALL define_var("chiphi_gtcneo","R",indim,idims, &
               "momentum-equation, neoclassical diffusivity from GTC_NEO model", &
               "m^2/s","ANOM","STATE_PROFILES", &
               "R|units=m^2/s|pclin chiphi_gtcneo(nrho_anomth)")
     ENDIF
  ENDIF

  iaddr = ps_phash_chiphi_mmm71
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%chiphi_mmm71).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("chiphi_mmm71","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        CALL define_var("chiphi_mmm71","R",indim,idims, &
               "momentum-equation, diffusivity term, toroidal", &
               "m^2/sec","ANOM","STATE_PROFILES", &
               "R|units=m^2/sec|pclin  chiphi_mmm71(nrho_anomth)")
     ENDIF
  ENDIF

  iaddr = ps_phash_chiphi_neo
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%chiphi_neo).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("chiphi_neo","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        CALL define_var("chiphi_neo","R",indim,idims, &
               "momentum-equation, neoclassical diffusivity from NEO model", &
               "m^2/s","ANOM","STATE_PROFILES", &
               "R|units=m^2/s|pclin chiphi_neo(nrho_anomth)")
     ENDIF
  ENDIF

  iaddr = ps_phash_chiphi_tglf
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%chiphi_tglf).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("chiphi_tglf","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        CALL define_var("chiphi_tglf","R",indim,idims, &
               "momentum-equation, diffusivity from TGLF model", &
               "m^2/s","ANOM","STATE_PROFILES", &
               "R|units=m^2/s|pclin chiphi_tglf(nrho_anomth)")
     ENDIF
  ENDIF

  iaddr = ps_phash_chiphi_w19
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%chiphi_w19).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("chiphi_w19","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        CALL define_var("chiphi_w19","R",indim,idims, &
               "momentum-equation, diffusivity term", &
               "m^2/sec","ANOM","STATE_PROFILES", &
               "R|units=m^2/sec|pclin  chiphi_w19(nrho_anomth)")
     ENDIF
  ENDIF

  iaddr = ps_phash_chitheta_mmm71
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%chitheta_mmm71).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("chitheta_mmm71","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        CALL define_var("chitheta_mmm71","R",indim,idims, &
               "momentum-equation, diffusivity term, poloidal", &
               "m^2/sec","ANOM","STATE_PROFILES", &
               "R|units=m^2/sec|pclin  chitheta_mmm71(nrho_anomth)")
     ENDIF
  ENDIF

  iaddr = ps_dhash_ncircuits
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%circuit_name).AND.ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("circuit_name","EQ")
     ELSE
        indim = 1
        idims(1)=nids%nid_clen_32
        IF(nids%nid_dim_ncircuits.EQ.0) THEN
           CALL define_dim(nids%nid_dim_ncircuits,"dim_ncircuits",ss%ncircuits)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_ncircuits
        CALL define_var("circuit_name","N",indim,idims, &
               "Number & names of circuits", &
               "__NONE","EQ","MACHINE_DESCRIPTION", &
               "L|pf_circuits  circuit_name(ncircuits)")
     ENDIF
  ENDIF

  iaddr = ps_shash_coil_apt
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%coil_apt).AND.ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("coil_apt","EQ")
     ELSE
        indim = 0
        IF(nids%nid_dim_ncircuits.EQ.0) THEN
           CALL define_dim(nids%nid_dim_ncircuits,"dim_ncircuits",ss%ncircuits)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_ncircuits
        CALL define_var("coil_apt","R",indim,idims, &
               "SIGNED circuit current", &
               "amps/turn","EQ","STATE_DATA", &
               "R|units=amps/turn coil_apt(ncircuits)")
     ENDIF
  ENDIF

  iaddr = ps_shash_coil_in_circuit
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%coil_in_circuit).AND.ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("coil_in_circuit","EQ")
     ELSE
        indim = 1
        idims(1)=nids%nid_clen_32
        IF(nids%nid_dim_ncoils.EQ.0) THEN
           CALL define_dim(nids%nid_dim_ncoils,"dim_ncoils",ss%ncoils)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_ncoils
        CALL define_var("coil_in_circuit","N",indim,idims, &
               "circuit to which each coil belongs", &
               "__NONE","EQ","MACHINE_DESCRIPTION", &
               "N  coil_in_circuit(ncoils)")
     ENDIF
  ENDIF

  iaddr = ps_dhash_ncoils
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%coil_name).AND.ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("coil_name","EQ")
     ELSE
        indim = 1
        idims(1)=nids%nid_clen_32
        IF(nids%nid_dim_ncoils.EQ.0) THEN
           CALL define_dim(nids%nid_dim_ncoils,"dim_ncoils",ss%ncoils)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_ncoils
        CALL define_var("coil_name","N",indim,idims, &
               "Number & name of axisymmetric coils", &
               "__NONE","EQ","MACHINE_DESCRIPTION", &
               "L|pf_coils     coil_name(ncoils)")
     ENDIF
  ENDIF

  iaddr = ps_shash_coil_resispt
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%coil_resispt).AND.ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("coil_resispt","EQ")
     ELSE
        indim = 0
        IF(nids%nid_dim_ncoils.EQ.0) THEN
           CALL define_dim(nids%nid_dim_ncoils,"dim_ncoils",ss%ncoils)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_ncoils
        CALL define_var("coil_resispt","R",indim,idims, &
               "coil resistance per turn", &
               "ohms/turn","EQ","MACHINE_DESCRIPTION", &
               "R|units=ohms/turn  coil_resispt(ncoils)")
     ENDIF
  ENDIF

  iaddr = ps_phash_curbeam
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%curbeam).AND.ichange) THEN
     IF(cclist(ps_cnum_NBI).NE.1) THEN
        CALL ccwarn("curbeam","NBI")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_nbi.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_nbi,"dm1_nrho_nbi",ss%nrho_nbi-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_nbi
        CALL define_var("curbeam","R",indim,idims, &
               "beam ion driven current (shielded)", &
               "A","NBI","STATE_PROFILES", &
               "R|step*dA|units=A   curbeam(~nrho_nbi)")
     ENDIF
  ENDIF

  iaddr = ps_phash_curech
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%curech).AND.ichange) THEN
     IF(cclist(ps_cnum_EC).NE.1) THEN
        CALL ccwarn("curech","EC")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_ecrf.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_ecrf,"dm1_nrho_ecrf",ss%nrho_ecrf-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_ecrf
        CALL define_var("curech","R",indim,idims, &
               "ECH current drive", &
               "A","EC","STATE_PROFILES", &
               "R|step*dA|units=A   curech(~nrho_ecrf)")
     ENDIF
  ENDIF

  iaddr = ps_phash_curech_src
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%curech_src).AND.ichange) THEN
     IF(cclist(ps_cnum_EC).NE.1) THEN
        CALL ccwarn("curech_src","EC")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_ecrf.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_ecrf,"dm1_nrho_ecrf",ss%nrho_ecrf-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_ecrf
        IF(nids%nid_dim_necrf_src.EQ.0) THEN
           CALL define_dim(nids%nid_dim_necrf_src,"dim_necrf_src",ss%necrf_src)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_necrf_src
        CALL define_var("curech_src","R",indim,idims, &
               "ECH current drive (by antenna)", &
               "A","EC","STATE_PROFILES", &
               "R|step*dA|units=A   curech_src(~nrho_ecrf,necrf_src)")
     ENDIF
  ENDIF

  iaddr = ps_phash_curfusn
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%curfusn).AND.ichange) THEN
     IF(cclist(ps_cnum_FUS).NE.1) THEN
        CALL ccwarn("curfusn","FUS")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_fus.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_fus,"dm1_nrho_fus",ss%nrho_fus-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_fus
        CALL define_var("curfusn","R",indim,idims, &
               "fusion ion driven current (shielded)", &
               "A","FUS","STATE_PROFILES", &
               "R|step*dA|units=A   curfusn(~nrho_fus)")
     ENDIF
  ENDIF

  iaddr = ps_phash_curich
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%curich).AND.ichange) THEN
     IF(cclist(ps_cnum_IC).NE.1) THEN
        CALL ccwarn("curich","IC")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_icrf.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_icrf,"dm1_nrho_icrf",ss%nrho_icrf-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_icrf
        CALL define_var("curich","R",indim,idims, &
               "total driven current (all IC srcs)", &
               "A","IC","STATE_PROFILES", &
               "R|units=A|step*dA   curich(~nrho_icrf)")
     ENDIF
  ENDIF

  iaddr = ps_phash_curlh
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%curlh).AND.ichange) THEN
     IF(cclist(ps_cnum_LH).NE.1) THEN
        CALL ccwarn("curlh","LH")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_lhrf.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_lhrf,"dm1_nrho_lhrf",ss%nrho_lhrf-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_lhrf
        CALL define_var("curlh","R",indim,idims, &
               "LH current drive", &
               "A","LH","STATE_PROFILES", &
               "R|step*dA|units=A   curlh(~nrho_lhrf)")
     ENDIF
  ENDIF

  iaddr = ps_phash_curlh_src
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%curlh_src).AND.ichange) THEN
     IF(cclist(ps_cnum_LH).NE.1) THEN
        CALL ccwarn("curlh_src","LH")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_lhrf.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_lhrf,"dm1_nrho_lhrf",ss%nrho_lhrf-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_lhrf
        IF(nids%nid_dim_nlhrf_src.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nlhrf_src,"dim_nlhrf_src",ss%nlhrf_src)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nlhrf_src
        CALL define_var("curlh_src","R",indim,idims, &
               "LH current drive (by antenna)", &
               "A","LH","STATE_PROFILES", &
               "R|step*dA|units=A   curlh_src(~nrho_lhrf,nlhrf_src)")
     ENDIF
  ENDIF

  iaddr = ps_phash_curmino
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%curmino).AND.ichange) THEN
     IF(cclist(ps_cnum_IC).NE.1) THEN
        CALL ccwarn("curmino","IC")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_icrf.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_icrf,"dm1_nrho_icrf",ss%nrho_icrf-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_icrf
        CALL define_var("curmino","R",indim,idims, &
               "minority ion driven cur (shielded).", &
               "A","IC","STATE_PROFILES", &
               "R|step*dA|units=A   curmino(~nrho_icrf)")
     ENDIF
  ENDIF

  iaddr = ps_phash_curr_bootstrap
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%curr_bootstrap).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("curr_bootstrap","PLASMA")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho,"dm1_nrho",ss%nrho-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho
        CALL define_var("curr_bootstrap","R",indim,idims, &
               "Neoclassical bootstrap current", &
               "A","PLASMA","STATE_PROFILES", &
               "R|units=A|step*dA   curr_bootstrap(~nrho)")
     ENDIF
  ENDIF

  iaddr = ps_phash_curr_ohmic
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%curr_ohmic).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("curr_ohmic","PLASMA")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho,"dm1_nrho",ss%nrho-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho
        CALL define_var("curr_ohmic","R",indim,idims, &
               "Ohmic current", &
               "A","PLASMA","STATE_PROFILES", &
               "R|units=A|step*dA   curr_ohmic(~nrho)")
     ENDIF
  ENDIF

  iaddr = ps_phash_curt
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%curt).AND.ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("curt","EQ")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_eq.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_eq,"dim_nrho_eq",ss%nrho_eq)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_eq
        CALL define_var("curt","R",indim,idims, &
               "total enclosed toroidal current", &
               "A","EQ","STATE_PROFILES", &
               "R|units=A|Spline_00   curt(nrho_eq)")
     ENDIF
  ENDIF

  iaddr = ps_shash_CUR_Data_Info
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("CUR_Data_Info","PLASMA")
     ELSE
        indim = 1
        idims(1)=nids%nid_clen_80
        CALL define_var("CUR_Data_Info","C*80",indim,idims, &
               "information on source of plasma current data", &
               "__NONE","PLASMA","SIMULATION_INIT", &
               "C*80   CUR_Data_Info")
     ENDIF
  ENDIF

  iaddr = ps_phash_cur_rw
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%cur_rw).AND.ichange) THEN
     IF(cclist(ps_cnum_RUNAWAY).NE.1) THEN
        CALL ccwarn("cur_rw","RUNAWAY")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_rw.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_rw,"dm1_nrho_rw",ss%nrho_rw-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_rw
        CALL define_var("cur_rw","R",indim,idims, &
               "current carried by fast electrons", &
               "A","RUNAWAY","STATE_PROFILES", &
               "R|step*dA|units=A   cur_rw(~nrho_rw)")
     ENDIF
  ENDIF

  iaddr = ps_phash_d2R_geo_dRHOdTH
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%d2R_geo_dRHOdTH).AND.ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("d2R_geo_dRHOdTH","EQ")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_eq.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_eq,"dim_nrho_eq",ss%nrho_eq)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_eq
        IF(nids%nid_dim_nth_eq.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nth_eq,"dim_nth_eq",ss%nth_eq)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nth_eq
        CALL define_var("d2R_geo_dRHOdTH","R",indim,idims, &
               "flux surfaces R(rho,theta)", &
               "m/-/rad","EQ","STATE_PROFILES", &
               "R|units=m|Hermite_explicit R_geo(nrho_eq,nth_eq)")
     ENDIF
  ENDIF

  iaddr = ps_phash_d2Z_geo_dRHOdTH
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%d2Z_geo_dRHOdTH).AND.ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("d2Z_geo_dRHOdTH","EQ")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_eq.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_eq,"dim_nrho_eq",ss%nrho_eq)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_eq
        IF(nids%nid_dim_nth_eq.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nth_eq,"dim_nth_eq",ss%nth_eq)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nth_eq
        CALL define_var("d2Z_geo_dRHOdTH","R",indim,idims, &
               "flux surfaces Z(rho,theta)", &
               "m/-/rad","EQ","STATE_PROFILES", &
               "R|units=m|Hermite_explicit Z_geo(nrho_eq,nth_eq)")
     ENDIF
  ENDIF

  iaddr = ps_phash_db_mtm
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%db_mtm).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("db_mtm","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        CALL define_var("db_mtm","R",indim,idims, &
               "dB/B from MTM model", &
               "-","ANOM","STATE_PROFILES", &
               "R|units=-|pclin db_mtm(nrho_anomth)")
     ENDIF
  ENDIF

  iaddr = ps_phash_dcur_rw_dVloop
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%dcur_rw_dVloop).AND.ichange) THEN
     IF(cclist(ps_cnum_RUNAWAY).NE.1) THEN
        CALL ccwarn("dcur_rw_dVloop","RUNAWAY")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_rw.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_rw,"dm1_nrho_rw",ss%nrho_rw-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_rw
        CALL define_var("dcur_rw_dVloop","R",indim,idims, &
               "sensitivity to loop volts", &
               "A/Volt","RUNAWAY","STATE_PROFILES", &
               "R|step*dA|units=A/Volt dcur_rw_dVloop(~nrho_rw)")
     ENDIF
  ENDIF

  iaddr = ps_dhash_ndelta_w
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%DeltaW_code).AND.ichange) THEN
     IF(cclist(ps_cnum_LMHD).NE.1) THEN
        CALL ccwarn("DeltaW_code","LMHD")
     ELSE
        indim = 1
        idims(1)=nids%nid_clen_32
        IF(nids%nid_dim_ndelta_w.EQ.0) THEN
           CALL define_dim(nids%nid_dim_ndelta_w,"dim_ndelta_w",ss%ndelta_w)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_ndelta_w
        CALL define_var("DeltaW_code","N",indim,idims, &
               "name(s) of delta(W) code(s) used", &
               "__NONE","LMHD","SIMULATION_INIT", &
               "L|Delta_W_codes  DeltaW_code(ndelta_w)")
     ENDIF
  ENDIF

  iaddr = ps_shash_DeltaW_mapper
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%DeltaW_mapper).AND.ichange) THEN
     IF(cclist(ps_cnum_LMHD).NE.1) THEN
        CALL ccwarn("DeltaW_mapper","LMHD")
     ELSE
        indim = 1
        idims(1)=nids%nid_clen_32
        IF(nids%nid_dim_ndelta_w.EQ.0) THEN
           CALL define_dim(nids%nid_dim_ndelta_w,"dim_ndelta_w",ss%ndelta_w)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_ndelta_w
        CALL define_var("DeltaW_mapper","N",indim,idims, &
               "mapper code used for each delta(W) code", &
               "__NONE","LMHD","SIMULATION_INIT", &
               "N  DeltaW_mapper(ndelta_W)")
     ENDIF
  ENDIF

  iaddr = ps_shash_DeltaW_stable
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%DeltaW_stable).AND.ichange) THEN
     IF(cclist(ps_cnum_LMHD).NE.1) THEN
        CALL ccwarn("DeltaW_stable","LMHD")
     ELSE
        indim = 0
        IF(nids%nid_dim_mmodes.EQ.0) THEN
           CALL define_dim(nids%nid_dim_mmodes,"dim_mmodes",ss%mmodes)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_mmodes
        IF(nids%nid_dim_ndelta_w.EQ.0) THEN
           CALL define_dim(nids%nid_dim_ndelta_w,"dim_ndelta_w",ss%ndelta_w)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_ndelta_w
        CALL define_var("DeltaW_stable","I",indim,idims, &
               "0: stable; 1: unstable;", &
               "__NONE","LMHD","STATE_DATA", &
               "I   DeltaW_stable(mmodes,ndelta_W)")
     ENDIF
  ENDIF

  iaddr = ps_shash_DeltaW_status
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%DeltaW_status).AND.ichange) THEN
     IF(cclist(ps_cnum_LMHD).NE.1) THEN
        CALL ccwarn("DeltaW_status","LMHD")
     ELSE
        indim = 0
        IF(nids%nid_dim_ndelta_w.EQ.0) THEN
           CALL define_dim(nids%nid_dim_ndelta_w,"dim_ndelta_w",ss%ndelta_w)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_ndelta_w
        CALL define_var("DeltaW_status","I",indim,idims, &
               "completion status: Delta(W) codes", &
               "__NONE","LMHD","STATE_DATA", &
               "I   DeltaW_status(ndelta_W)")
     ENDIF
  ENDIF

  iaddr = ps_phash_difb_fusi
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%difb_fusi).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("difb_fusi","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anom.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anom,"dim_nrho_anom",ss%nrho_anom)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anom
        CALL define_var("difb_fusi","R",indim,idims, &
               "fusion ion anomalous diffusivity", &
               "m^2/sec","ANOM","STATE_PROFILES", &
               "R|pclin  difb_fusi(nrho_anom)")
     ENDIF
  ENDIF

  iaddr = ps_phash_difb_nbi
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%difb_nbi).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("difb_nbi","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anom.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anom,"dim_nrho_anom",ss%nrho_anom)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anom
        CALL define_var("difb_nbi","R",indim,idims, &
               "beam ion anomalous diffusivity", &
               "m^2/sec","ANOM","STATE_PROFILES", &
               "R|pclin  difb_nbi(nrho_anom)")
     ENDIF
  ENDIF

  iaddr = ps_phash_difb_rfmi
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%difb_rfmi).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("difb_rfmi","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anom.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anom,"dim_nrho_anom",ss%nrho_anom)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anom
        CALL define_var("difb_rfmi","R",indim,idims, &
               "RF minority ion anomalous diffusivity", &
               "m^2/sec","ANOM","STATE_PROFILES", &
               "R|pclin  difb_rfmi(nrho_anom)")
     ENDIF
  ENDIF

  iaddr = ps_phash_diff_trans
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%diff_trans).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("diff_trans","PLASMA")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho,"dim_nrho",ss%nrho)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho
        IF(nids%nid_dp1_nspec_th.EQ.0) THEN
           CALL define_dim(nids%nid_dp1_nspec_th,"dp1_nspec_th",ss%nspec_th+1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dp1_nspec_th
        CALL define_var("diff_trans","R",indim,idims, &
               "specie ptcl diffusivity", &
               "m^2/sec","PLASMA","STATE_PROFILES", &
               "R|units=m^2/sec|pclin diff_trans(nrho,0:nspec_th)")
     ENDIF
  ENDIF

  iaddr = ps_phash_diff_transcat
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%diff_transcat).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("diff_transcat","PLASMA")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho,"dim_nrho",ss%nrho)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho
        IF(nids%nid_dp1_nspec_th.EQ.0) THEN
           CALL define_dim(nids%nid_dp1_nspec_th,"dp1_nspec_th",ss%nspec_th+1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dp1_nspec_th
        IF(nids%nid_dim_ntrcat.EQ.0) THEN
           CALL define_dim(nids%nid_dim_ntrcat,"dim_ntrcat",ss%ntrcat)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_ntrcat
        CALL define_var("diff_transcat","R",indim,idims, &
               "specie diffusivity", &
               "m^2/sec","PLASMA","STATE_PROFILES", &
               "R|units=m^2/sec|pclin diff_transcat(nrho,0:nspec_th,ntrcat)")
     ENDIF
  ENDIF

  iaddr = ps_phash_difne_nclass
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%difne_nclass).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("difne_nclass","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        CALL define_var("difne_nclass","R",indim,idims, &
               "electron-density-equations, neoclassical diffusivity from NCLASS model", &
               "m^2/s","ANOM","STATE_PROFILES", &
               "R|units=m^2/s|pclin difne_nclass(nrho_anomth)")
     ENDIF
  ENDIF

  iaddr = ps_phash_difnh_nclass
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%difnh_nclass).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("difnh_nclass","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        CALL define_var("difnh_nclass","R",indim,idims, &
               "main-hydrogenic-density-equations, neoclassical diffusivity from NCLASS model", &
               "m^2/s","ANOM","STATE_PROFILES", &
               "R|units=m^2/s|pclin difnh_nclass(nrho_anomth)")
     ENDIF
  ENDIF

  iaddr = ps_phash_difns_anom
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%difns_anom).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("difns_anom","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        IF(nids%nid_dp1_nspec_th.EQ.0) THEN
           CALL define_dim(nids%nid_dp1_nspec_th,"dp1_nspec_th",ss%nspec_th+1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dp1_nspec_th
        CALL define_var("difns_anom","R",indim,idims, &
               "density-equations, diffusivity term", &
               "m^2/sec","ANOM","STATE_PROFILES", &
               "R|units=m^2/sec|pclin  difns_anom(nrho_anomth,0:nspec_th)")
     ENDIF
  ENDIF

  iaddr = ps_phash_difns_drbm
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%difns_drbm).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("difns_drbm","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        IF(nids%nid_dp1_nspec_th.EQ.0) THEN
           CALL define_dim(nids%nid_dp1_nspec_th,"dp1_nspec_th",ss%nspec_th+1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dp1_nspec_th
        CALL define_var("difns_drbm","R",indim,idims, &
               "density-equations, diffusivity term", &
               "m^2/sec","ANOM","STATE_PROFILES", &
               "R|units=m^2/sec|pclin  difns_drbm(nrho_anomth,0:nspec_th)")
     ENDIF
  ENDIF

  iaddr = ps_phash_difns_glf
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%difns_glf).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("difns_glf","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        IF(nids%nid_dp1_nspec_th.EQ.0) THEN
           CALL define_dim(nids%nid_dp1_nspec_th,"dp1_nspec_th",ss%nspec_th+1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dp1_nspec_th
        CALL define_var("difns_glf","R",indim,idims, &
               "density-equations, diffusivity from GLF23 model", &
               "m^2/s","ANOM","STATE_PROFILES", &
               "R|units=m^2/s|pclin difns_glf(nrho_anomth,0:nspec_th)")
     ENDIF
  ENDIF

  iaddr = ps_phash_difns_gtcneo
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%difns_gtcneo).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("difns_gtcneo","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        IF(nids%nid_dp1_nspec_th.EQ.0) THEN
           CALL define_dim(nids%nid_dp1_nspec_th,"dp1_nspec_th",ss%nspec_th+1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dp1_nspec_th
        CALL define_var("difns_gtcneo","R",indim,idims, &
               "density-equations, neoclassical diffusivity from GTC_NEO model", &
               "m^2/s","ANOM","STATE_PROFILES", &
               "R|units=m^2/s|pclin difns_gtcneo(nrho_anomth,0:nspec_th)")
     ENDIF
  ENDIF

  iaddr = ps_phash_difns_mmm71
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%difns_mmm71).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("difns_mmm71","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        IF(nids%nid_dp1_nspec_th.EQ.0) THEN
           CALL define_dim(nids%nid_dp1_nspec_th,"dp1_nspec_th",ss%nspec_th+1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dp1_nspec_th
        CALL define_var("difns_mmm71","R",indim,idims, &
               "density-equations, diffusivity term", &
               "m^2/sec","ANOM","STATE_PROFILES", &
               "R|units=m^2/sec|pclin  difns_mmm71(nrho_anomth,0:nspec_th)")
     ENDIF
  ENDIF

  iaddr = ps_phash_difns_nclass
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%difns_nclass).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("difns_nclass","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        IF(nids%nid_dp1_nspec_th.EQ.0) THEN
           CALL define_dim(nids%nid_dp1_nspec_th,"dp1_nspec_th",ss%nspec_th+1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dp1_nspec_th
        CALL define_var("difns_nclass","R",indim,idims, &
               "density-equations, neoclassical diffusivity from NCLASS model", &
               "m^2/s","ANOM","STATE_PROFILES", &
               "R|units=m^2/s|pclin difns_nclass(nrho_anomth,0:nspec_th)")
     ENDIF
  ENDIF

  iaddr = ps_phash_difns_neo
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%difns_neo).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("difns_neo","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        IF(nids%nid_dp1_nspec_th.EQ.0) THEN
           CALL define_dim(nids%nid_dp1_nspec_th,"dp1_nspec_th",ss%nspec_th+1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dp1_nspec_th
        CALL define_var("difns_neo","R",indim,idims, &
               "density-equations, neoclassical diffusivity from NEO model", &
               "m^2/s","ANOM","STATE_PROFILES", &
               "R|units=m^2/s|pclin difns_neo(nrho_anomth,0:nspec_th)")
     ENDIF
  ENDIF

  iaddr = ps_phash_difns_tglf
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%difns_tglf).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("difns_tglf","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        IF(nids%nid_dp1_nspec_th.EQ.0) THEN
           CALL define_dim(nids%nid_dp1_nspec_th,"dp1_nspec_th",ss%nspec_th+1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dp1_nspec_th
        CALL define_var("difns_tglf","R",indim,idims, &
               "density-equations, diffusivity from TGLF model", &
               "m^2/s","ANOM","STATE_PROFILES", &
               "R|units=m^2/s|pclin difns_tglf(nrho_anomth,0:nspec_th)")
     ENDIF
  ENDIF

  iaddr = ps_phash_difns_w19
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%difns_w19).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("difns_w19","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        IF(nids%nid_dp1_nspec_th.EQ.0) THEN
           CALL define_dim(nids%nid_dp1_nspec_th,"dp1_nspec_th",ss%nspec_th+1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dp1_nspec_th
        CALL define_var("difns_w19","R",indim,idims, &
               "density-equations, diffusivity term", &
               "m^2/sec","ANOM","STATE_PROFILES", &
               "R|units=m^2/sec|pclin  difns_w19(nrho_anomth,0:nspec_th)")
     ENDIF
  ENDIF

  iaddr = ps_phash_difnx_nclass
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%difnx_nclass).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("difnx_nclass","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        CALL define_var("difnx_nclass","R",indim,idims, &
               "main-impurity-density-equations, neoclassical diffusivity from NCLASS model", &
               "m^2/s","ANOM","STATE_PROFILES", &
               "R|units=m^2/s|pclin difnx_nclass(nrho_anomth)")
     ENDIF
  ENDIF

  iaddr = ps_phash_difnz_mmm71
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%difnz_mmm71).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("difnz_mmm71","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        CALL define_var("difnz_mmm71","R",indim,idims, &
               "impurity ion diffusivity term", &
               "m^2/sec","ANOM","STATE_PROFILES", &
               "R|units=m^2/sec|pclin  difnz_mmm71(nrho_anomth)")
     ENDIF
  ENDIF

  iaddr = ps_shash_dist_fun
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%dist_fun).AND.ichange) THEN
     IF(cclist(ps_cnum_IC).NE.1) THEN
        CALL ccwarn("dist_fun","IC")
     ELSE
        indim = 1
        idims(1)=nids%nid_clen_256
        IF(nids%nid_dp1_nspec_alla.EQ.0) THEN
           CALL define_dim(nids%nid_dp1_nspec_alla,"dp1_nspec_alla",ss%nspec_alla+1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dp1_nspec_alla
        CALL define_var("dist_fun","F",indim,idims, &
               "distribution function filenames", &
               "__NONE","IC","STATE_DATA", &
               "F  dist_fun(0:nspec_alla)")
     ENDIF
  ENDIF

  iaddr = ps_shash_dn0out
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ichange) THEN
     IF(cclist(ps_cnum_GAS).NE.1) THEN
        CALL ccwarn("dn0out","GAS")
     ELSE
        indim = 0
        CALL define_var("dn0out","R",indim,idims, &
               "Hydrogenic neutral density in scrape off region", &
               "m^-3","GAS","STATE_DATA", &
               "R|units=m^-3  dn0out")
     ENDIF
  ENDIF

  iaddr = ps_phash_dQedGrdte_tglf
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%dQedGrdte_tglf).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("dQedGrdte_tglf","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        CALL define_var("dQedGrdte_tglf","R",indim,idims, &
               "Te flux gradient term from TGLF model", &
               "1/(m*s)","ANOM","STATE_PROFILES", &
               "R|units=1/(m*s)|pclin dQedGrdte_tglf(nrho_anomth)")
     ENDIF
  ENDIF

  iaddr = ps_phash_dQedGrdti_tglf
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%dQedGrdti_tglf).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("dQedGrdti_tglf","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        CALL define_var("dQedGrdti_tglf","R",indim,idims, &
               "Te flux gradient term from TGLF model", &
               "1/(m*s)","ANOM","STATE_PROFILES", &
               "R|units=1/(m*s)|pclin dQedGrdti_tglf(nrho_anomth)")
     ENDIF
  ENDIF

  iaddr = ps_phash_dQidGrdte_tglf
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%dQidGrdte_tglf).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("dQidGrdte_tglf","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        CALL define_var("dQidGrdte_tglf","R",indim,idims, &
               "Ti flux gradient term from TGLF model", &
               "1/(m*s)","ANOM","STATE_PROFILES", &
               "R|units=1/(m*s)|pclin dQidGrdte_tglf(nrho_anomth)")
     ENDIF
  ENDIF

  iaddr = ps_phash_dQidGrdti_tglf
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%dQidGrdti_tglf).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("dQidGrdti_tglf","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        CALL define_var("dQidGrdti_tglf","R",indim,idims, &
               "Ti flux gradient term from TGLF model", &
               "1/(m*s)","ANOM","STATE_PROFILES", &
               "R|units=1/(m*s)|pclin dQidGrdti_tglf(nrho_anomth)")
     ENDIF
  ENDIF

  iaddr = ps_phash_dR0_momeq_dRHO
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%dR0_momeq_dRHO).AND.ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("dR0_momeq_dRHO","EQ")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_eq.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_eq,"dim_nrho_eq",ss%nrho_eq)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_eq
        CALL define_var("dR0_momeq_dRHO","R",indim,idims, &
               "R0 of flux surface", &
               "m/-","EQ","STATE_PROFILES", &
               "R|units=m|Hermite_explicit  R0_momeq(nrho_eq)")
     ENDIF
  ENDIF

  iaddr = ps_phash_dR_geo_dRHO
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%dR_geo_dRHO).AND.ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("dR_geo_dRHO","EQ")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_eq.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_eq,"dim_nrho_eq",ss%nrho_eq)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_eq
        IF(nids%nid_dim_nth_eq.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nth_eq,"dim_nth_eq",ss%nth_eq)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nth_eq
        CALL define_var("dR_geo_dRHO","R",indim,idims, &
               "flux surfaces R(rho,theta)", &
               "m/-","EQ","STATE_PROFILES", &
               "R|units=m|Hermite_explicit R_geo(nrho_eq,nth_eq)")
     ENDIF
  ENDIF

  iaddr = ps_phash_dR_geo_dTH
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%dR_geo_dTH).AND.ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("dR_geo_dTH","EQ")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_eq.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_eq,"dim_nrho_eq",ss%nrho_eq)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_eq
        IF(nids%nid_dim_nth_eq.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nth_eq,"dim_nth_eq",ss%nth_eq)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nth_eq
        CALL define_var("dR_geo_dTH","R",indim,idims, &
               "flux surfaces R(rho,theta)", &
               "m/rad","EQ","STATE_PROFILES", &
               "R|units=m|Hermite_explicit R_geo(nrho_eq,nth_eq)")
     ENDIF
  ENDIF

  iaddr = ps_phash_dxRjcos_momeq_dRHO
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%dxRjcos_momeq_dRHO).AND.ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("dxRjcos_momeq_dRHO","EQ")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_eq.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_eq,"dim_nrho_eq",ss%nrho_eq)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_eq
        IF(nids%nid_dim_neqmom.EQ.0) THEN
           CALL define_dim(nids%nid_dim_neqmom,"dim_neqmom",ss%neqmom)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_neqmom
        CALL define_var("dxRjcos_momeq_dRHO","R",indim,idims, &
               "scaled R cos moments", &
               "m/-","EQ","STATE_PROFILES", &
               "R|units=m|Hermite_explicit  xRjcos_momeq(nrho_eq,neqmom)")
     ENDIF
  ENDIF

  iaddr = ps_phash_dxRjsin_momeq_dRHO
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%dxRjsin_momeq_dRHO).AND.ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("dxRjsin_momeq_dRHO","EQ")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_eq.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_eq,"dim_nrho_eq",ss%nrho_eq)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_eq
        IF(nids%nid_dim_neqmom.EQ.0) THEN
           CALL define_dim(nids%nid_dim_neqmom,"dim_neqmom",ss%neqmom)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_neqmom
        CALL define_var("dxRjsin_momeq_dRHO","R",indim,idims, &
               "scaled R sin moments", &
               "m/-","EQ","STATE_PROFILES", &
               "R|units=m|Hermite_explicit  xRjsin_momeq(nrho_eq,neqmom)")
     ENDIF
  ENDIF

  iaddr = ps_phash_dxZjcos_momeq_dRHO
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%dxZjcos_momeq_dRHO).AND.ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("dxZjcos_momeq_dRHO","EQ")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_eq.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_eq,"dim_nrho_eq",ss%nrho_eq)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_eq
        IF(nids%nid_dim_neqmom.EQ.0) THEN
           CALL define_dim(nids%nid_dim_neqmom,"dim_neqmom",ss%neqmom)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_neqmom
        CALL define_var("dxZjcos_momeq_dRHO","R",indim,idims, &
               "scaled Z cos moments", &
               "m/-","EQ","STATE_PROFILES", &
               "R|units=m|Hermite_explicit  xZjcos_momeq(nrho_eq,neqmom)")
     ENDIF
  ENDIF

  iaddr = ps_phash_dxZjsin_momeq_dRHO
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%dxZjsin_momeq_dRHO).AND.ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("dxZjsin_momeq_dRHO","EQ")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_eq.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_eq,"dim_nrho_eq",ss%nrho_eq)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_eq
        IF(nids%nid_dim_neqmom.EQ.0) THEN
           CALL define_dim(nids%nid_dim_neqmom,"dim_neqmom",ss%neqmom)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_neqmom
        CALL define_var("dxZjsin_momeq_dRHO","R",indim,idims, &
               "scaled Z sin moments", &
               "m/-","EQ","STATE_PROFILES", &
               "R|units=m|Hermite_explicit  xZjsin_momeq(nrho_eq,neqmom)")
     ENDIF
  ENDIF

  iaddr = ps_shash_dx_fshield
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%dx_fshield).AND.ichange) THEN
     IF(cclist(ps_cnum_IC).NE.1) THEN
        CALL ccwarn("dx_fshield","IC")
     ELSE
        indim = 0
        IF(nids%nid_dim_nicrf_src.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nicrf_src,"dim_nicrf_src",ss%nicrf_src)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nicrf_src
        CALL define_var("dx_fshield","R",indim,idims, &
               "distance, antenna to Faraday shield", &
               "m","IC","MACHINE_DESCRIPTION", &
               "R|units=m dx_fshield(nicrf_src)")
     ENDIF
  ENDIF

  iaddr = ps_phash_dZ0_momeq_dRHO
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%dZ0_momeq_dRHO).AND.ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("dZ0_momeq_dRHO","EQ")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_eq.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_eq,"dim_nrho_eq",ss%nrho_eq)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_eq
        CALL define_var("dZ0_momeq_dRHO","R",indim,idims, &
               "Z0 of flux surface", &
               "m/-","EQ","STATE_PROFILES", &
               "R|units=m|Hermite_explicit  Z0_momeq(nrho_eq)")
     ENDIF
  ENDIF

  iaddr = ps_phash_dZ_geo_dRHO
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%dZ_geo_dRHO).AND.ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("dZ_geo_dRHO","EQ")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_eq.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_eq,"dim_nrho_eq",ss%nrho_eq)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_eq
        IF(nids%nid_dim_nth_eq.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nth_eq,"dim_nth_eq",ss%nth_eq)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nth_eq
        CALL define_var("dZ_geo_dRHO","R",indim,idims, &
               "flux surfaces Z(rho,theta)", &
               "m/-","EQ","STATE_PROFILES", &
               "R|units=m|Hermite_explicit Z_geo(nrho_eq,nth_eq)")
     ENDIF
  ENDIF

  iaddr = ps_phash_dZ_geo_dTH
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%dZ_geo_dTH).AND.ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("dZ_geo_dTH","EQ")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_eq.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_eq,"dim_nrho_eq",ss%nrho_eq)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_eq
        IF(nids%nid_dim_nth_eq.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nth_eq,"dim_nth_eq",ss%nth_eq)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nth_eq
        CALL define_var("dZ_geo_dTH","R",indim,idims, &
               "flux surfaces Z(rho,theta)", &
               "m/rad","EQ","STATE_PROFILES", &
               "R|units=m|Hermite_explicit Z_geo(nrho_eq,nth_eq)")
     ENDIF
  ENDIF
  CONTAINS


     SUBROUTINE define_dim(dimid,dname,idval)
        INTEGER, intent(out) :: dimid
        CHARACTER*(*), INTENT(in) :: dname
        INTEGER, intent(in) :: idval

        status = nf90_def_dim(icdf,dname,idval,dimid)
        IF(status.NE.NF90_NOERR) THEN
           WRITE(iout,*) ' ?ps_update_file_write: error defining dimension "'// &
                 trim(dname)//'".'
           IERR=9999
        ENDIF
     END SUBROUTINE define_dim



     SUBROUTINE define_var(name,dtype,indim,idims, &
          long_name,units,component,section,spec)

        CHARACTER*(*), INTENT(in) :: name
        CHARACTER*(*), INTENT(in) :: dtype
        INTEGER, INTENT(in) :: indim
        INTEGER, dimension(:), INTENT(in) :: idims
        CHARACTER*(*), INTENT(in) :: long_name
        CHARACTER*(*), INTENT(in) :: units
        CHARACTER*(*), INTENT(in) :: component
        CHARACTER*(*), INTENT(in) :: section
        CHARACTER*(*), INTENT(in) :: spec

        integer :: itype

        IF(dtype.EQ.'R') THEN
           itype = NF90_DOUBLE

        ELSE IF (dtype.EQ.'I') THEN
           itype = NF90_INT

        ELSE
           itype = NF90_CHAR

        ENDIF

        IF(indim.EQ.0) THEN
           status=nf90_def_var(icdf,name,itype, varid=varid)

        ELSE
           status=nf90_def_var(icdf,name,itype, dimids=idims(1:indim),varid=varid)

        ENDIF

        IF(status.NE.NF90_NOERR) THEN
           WRITE(iout,*) " ?plasma_state_store: error defining variable: "//trim(name)
           CALL ncerr(status)
           iertot = iertot + 1
           RETURN
        ENDIF

        ! Variable OK, now add attributes:

        CALL add_attrib("long_name",long_name)
        IF(dtype.EQ.'R') CALL add_attrib("units",units)
        CALL add_attrib("component",component)
        CALL add_attrib("section",section)
        CALL add_attrib("specification",spec)

     END SUBROUTINE define_var

     SUBROUTINE add_attrib(name,value)
        CHARACTER*(*), intent(in) :: name
        CHARACTER*(*), intent(in) :: value

        status=nf90_put_att(icdf,varid,name,value)
        IF(status.NE.NF90_NOERR) THEN
           WRITE(iout,*) " ?plasma_state_store: error defining attribute: "//trim(name)//' = '//trim(value)
           CALL ncerr(status)
           iertot = iertot + 1
        ENDIF
     END SUBROUTINE add_attrib



     SUBROUTINE ncerr(status)
        INTEGER, INTENT(in) :: status

        nc_errmsg = NF90_strerror(status)
        write(iout,*) '  NetCDF message: ',trim(nc_errmsg)
     END SUBROUTINE ncerr



     SUBROUTINE ccwarn(varnam,compnam)

        CHARACTER*(*), intent(in) :: varnam   ! name of variable or array
        CHARACTER*(*), intent(in) :: compnam  ! name of component

        if(iwarn.eq.0) then
           write(iout,*) ' '
           write(iout,*) ' %ps_update_file_write: modified state elements'
           write(iout,*) '  exist which were not written due to the "cclist"'
           write(iout,*) '  input variable which screens out elements from'
           write(iout,*) '  selected components: cclist = ',cclist,';'
           write(iout,*) '  element values of 1 indicate components that are'
           write(iout,*) '  enabled for write.'
           write(iout,*) ' '
        endif

        iwarn = iwarn + 1

        write(iout,*) ' %ps_update_file_write: modified: ss%'// &
             trim(varnam)//' ('//trim(compnam)//' component) NOT WRITTEN.'

     END SUBROUTINE ccwarn

END SUBROUTINE ps_update_file_write_def_1

SUBROUTINE ps_update_file_write_1(ss,icdf,cclist,iucount,iout,iwarn,iertot)


  ! Write updated data

  USE plasma_state_definition_mod
  USE netcdf
  IMPLICIT NONE

  TYPE (plasma_state) :: ss  ! state containing array elements to be allocated
  INTEGER, INTENT(IN) :: icdf  ! NetCDF file ID
  INTEGER, INTENT(IN) :: cclist(ps_ccount)  ! component selection
  INTEGER, INTENT(INOUT) :: iucount ! update count
  INTEGER, INTENT(IN) :: iout  ! LUN for messages
  INTEGER, INTENT(INOUT) :: iwarn   ! warn count
  INTEGER, INTENT(INOUT) :: iertot  ! error count

  !-------------------

  INTEGER :: varid,status
  CHARACTER*80 :: nc_errmsg

  !-------------------


  status = nf90_inq_varid(icdf,"chii_ntm",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%chii_ntm)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: chii_ntm"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"chii_tglf",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%chii_tglf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: chii_tglf"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"chii_trans",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%chii_trans)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: chii_trans"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"chii_transcat",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%chii_transcat)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: chii_transcat"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"chii_w19",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%chii_w19)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: chii_w19"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"chimo_trans",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%chimo_trans)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: chimo_trans"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"chimo_transcat",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%chimo_transcat)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: chimo_transcat"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"chiphi_anom",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%chiphi_anom)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: chiphi_anom"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"chiphi_drbm",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%chiphi_drbm)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: chiphi_drbm"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"chiphi_glf",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%chiphi_glf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: chiphi_glf"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"chiphi_gtcneo",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%chiphi_gtcneo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: chiphi_gtcneo"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"chiphi_mmm71",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%chiphi_mmm71)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: chiphi_mmm71"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"chiphi_neo",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%chiphi_neo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: chiphi_neo"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"chiphi_tglf",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%chiphi_tglf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: chiphi_tglf"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"chiphi_w19",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%chiphi_w19)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: chiphi_w19"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"chitheta_mmm71",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%chitheta_mmm71)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: chitheta_mmm71"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"circuit_name",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%circuit_name)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: circuit_name"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"coil_apt",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%coil_apt)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: coil_apt"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"coil_in_circuit",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%coil_in_circuit)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: coil_in_circuit"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"coil_name",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%coil_name)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: coil_name"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"coil_resispt",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%coil_resispt)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: coil_resispt"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"curbeam",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%curbeam)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: curbeam"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"curech",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%curech)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: curech"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"curech_src",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%curech_src)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: curech_src"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"curfusn",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%curfusn)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: curfusn"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"curich",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%curich)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: curich"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"curlh",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%curlh)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: curlh"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"curlh_src",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%curlh_src)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: curlh_src"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"curmino",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%curmino)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: curmino"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"curr_bootstrap",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%curr_bootstrap)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: curr_bootstrap"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"curr_ohmic",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%curr_ohmic)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: curr_ohmic"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"curt",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%curt)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: curt"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"CUR_Data_Info",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%CUR_Data_Info)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: CUR_Data_Info"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"cur_rw",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%cur_rw)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: cur_rw"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"d2R_geo_dRHOdTH",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%d2R_geo_dRHOdTH)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: d2R_geo_dRHOdTH"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"d2Z_geo_dRHOdTH",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%d2Z_geo_dRHOdTH)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: d2Z_geo_dRHOdTH"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"db_mtm",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%db_mtm)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: db_mtm"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"dcur_rw_dVloop",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%dcur_rw_dVloop)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: dcur_rw_dVloop"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"DeltaW_code",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%DeltaW_code)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: DeltaW_code"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"DeltaW_mapper",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%DeltaW_mapper)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: DeltaW_mapper"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"DeltaW_stable",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%DeltaW_stable)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: DeltaW_stable"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"DeltaW_status",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%DeltaW_status)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: DeltaW_status"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"difb_fusi",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%difb_fusi)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: difb_fusi"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"difb_nbi",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%difb_nbi)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: difb_nbi"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"difb_rfmi",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%difb_rfmi)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: difb_rfmi"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"diff_trans",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%diff_trans)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: diff_trans"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"diff_transcat",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%diff_transcat)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: diff_transcat"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"difne_nclass",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%difne_nclass)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: difne_nclass"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"difnh_nclass",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%difnh_nclass)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: difnh_nclass"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"difns_anom",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%difns_anom)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: difns_anom"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"difns_drbm",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%difns_drbm)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: difns_drbm"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"difns_glf",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%difns_glf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: difns_glf"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"difns_gtcneo",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%difns_gtcneo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: difns_gtcneo"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"difns_mmm71",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%difns_mmm71)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: difns_mmm71"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"difns_nclass",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%difns_nclass)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: difns_nclass"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"difns_neo",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%difns_neo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: difns_neo"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"difns_tglf",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%difns_tglf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: difns_tglf"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"difns_w19",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%difns_w19)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: difns_w19"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"difnx_nclass",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%difnx_nclass)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: difnx_nclass"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"difnz_mmm71",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%difnz_mmm71)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: difnz_mmm71"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"dist_fun",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%dist_fun)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: dist_fun"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"dn0out",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%dn0out)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: dn0out"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"dQedGrdte_tglf",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%dQedGrdte_tglf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: dQedGrdte_tglf"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"dQedGrdti_tglf",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%dQedGrdti_tglf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: dQedGrdti_tglf"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"dQidGrdte_tglf",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%dQidGrdte_tglf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: dQidGrdte_tglf"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"dQidGrdti_tglf",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%dQidGrdti_tglf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: dQidGrdti_tglf"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"dR0_momeq_dRHO",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%dR0_momeq_dRHO)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: dR0_momeq_dRHO"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"dR_geo_dRHO",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%dR_geo_dRHO)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: dR_geo_dRHO"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"dR_geo_dTH",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%dR_geo_dTH)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: dR_geo_dTH"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"dxRjcos_momeq_dRHO",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%dxRjcos_momeq_dRHO)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: dxRjcos_momeq_dRHO"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"dxRjsin_momeq_dRHO",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%dxRjsin_momeq_dRHO)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: dxRjsin_momeq_dRHO"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"dxZjcos_momeq_dRHO",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%dxZjcos_momeq_dRHO)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: dxZjcos_momeq_dRHO"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"dxZjsin_momeq_dRHO",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%dxZjsin_momeq_dRHO)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: dxZjsin_momeq_dRHO"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"dx_fshield",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%dx_fshield)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: dx_fshield"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"dZ0_momeq_dRHO",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%dZ0_momeq_dRHO)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: dZ0_momeq_dRHO"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"dZ_geo_dRHO",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%dZ_geo_dRHO)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: dZ_geo_dRHO"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"dZ_geo_dTH",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%dZ_geo_dTH)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: dZ_geo_dTH"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF
  CONTAINS


     SUBROUTINE ncerr(status)
        INTEGER, INTENT(in) :: status

        nc_errmsg = NF90_strerror(status)
        write(iout,*) '  NetCDF message: ',trim(nc_errmsg)
     END SUBROUTINE ncerr

END SUBROUTINE ps_update_file_write_1

subroutine ccps_sconfig_write(iobj,filename,ierr)

  ! write file containing shot configuration data

  use plasma_state_mod
  implicit NONE

#include "fpreproc/byte_declare.h"

  integer :: iobj(*)        ! (ps_container_size) words are used: state object
  BYTE_DECLARE, intent(in) :: filename(*)  ! null terminated file name (max 256 chars)
  integer,intent(out) :: ierr      ! exit status 0=OK

  !-------------------------
  character*256 filename_ftn
  type (plasma_state_container) :: ptr
  type (plasma_state), pointer :: ss
  !-------------------------

  call ccps_argcheck('ccps_sconfig_write',iobj,ierr)
  if(ierr.ne.0) return

  ! proceed...

  call load_ps_container(iobj,ptr)
  ss => ptr%ps_ptr

  ! convert filepath to fortran string
  call cstring(filename_ftn,filename,'2F')  ! convert filename to fortran string

  call ps_sconfig_write(filename_ftn, ierr, state=ss)

end subroutine ccps_sconfig_write

subroutine cstate_ck_empty(dims,result)

  !  check if item is empty -- it is empty if any of its dimensions are zero.

  use cstate_lib_mod
  implicit NONE

  character*(*), intent(in) :: dims
  logical, intent(out) :: result

  !---------------------------------
  integer :: ii,inum,jj,iloc
  character*32 :: locdims(20)  ! 20 a more than reasonable upper bound
  integer :: ilowlims(20)
  !---------------------------------

  result = .FALSE.
  if(dims.eq.'scalar') return  ! scalars are never empty...

  inum = 0
  if(allocated(empty_dims)) inum = size(empty_dims)
  if(inum.eq.0) return

  iloc = 0

  ! extract dims from dims string
  !   typical dims string value: "(1:nrho_fp-1,1:nspec_nonmax)"

  call cstate_extract_dims(dims,size(locdims),iloc,locdims,ilowlims)

  !  see if any dims are on the empty list
  do jj=1,inum
     do ii=1,iloc
        if(locdims(ii).eq.empty_dims(jj)) then
           result = .TRUE.
           exit
        endif
     enddo
     if(result) exit
  enddo

end subroutine cstate_ck_empty

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_b8_dummy
     return
  end subroutine ccps_getset_b8_dummy

subroutine psget_b_hdivergence(iobj, n1, data, ierr)
    !! horizontal divergence (D) of beam, for nbshape(j)="circle"
    !! sources this is the ONLY divergence., --> definition of D
    !! (b_Hdivergence(...) given in DEGREES):, for alpha the random
    !! angle of deviation from the direction of, aiming, P(alpha) ~
    !! exp(-alpha**2/D**2); P(D) = (1/e)*P(0), I.e. D is the angle of
    !! deviation from the aiming angle, in, either direction, for a
    !! (1/e) reduction in probability of, launch of a beam particle.
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_b_hdivergence', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % b_Hdivergence
end subroutine psget_b_hdivergence


subroutine psset_b_hdivergence(iobj, n1, data, ierr)
    !! horizontal divergence (D) of beam, for nbshape(j)="circle"
    !! sources this is the ONLY divergence., --> definition of D
    !! (b_Hdivergence(...) given in DEGREES):, for alpha the random
    !! angle of deviation from the direction of, aiming, P(alpha) ~
    !! exp(-alpha**2/D**2); P(D) = (1/e)*P(0), I.e. D is the angle of
    !! deviation from the aiming angle, in, either direction, for a
    !! (1/e) reduction in probability of, launch of a beam particle.
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_b_hdivergence', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % b_Hdivergence = data(1:n1)
end subroutine psset_b_hdivergence


subroutine psgetrnk_b_hdivergence(iobj, ndims, ierr)
    !! horizontal divergence (D) of beam, for nbshape(j)="circle"
    !! sources this is the ONLY divergence., --> definition of D
    !! (b_Hdivergence(...) given in DEGREES):, for alpha the random
    !! angle of deviation from the direction of, aiming, P(alpha) ~
    !! exp(-alpha**2/D**2); P(D) = (1/e)*P(0), I.e. D is the angle of
    !! deviation from the aiming angle, in, either direction, for a
    !! (1/e) reduction in probability of, launch of a beam particle.
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_b_hdivergence


subroutine psgetdim_b_hdivergence(iobj, ndims, dims, ierr)
    !! horizontal divergence (D) of beam, for nbshape(j)="circle"
    !! sources this is the ONLY divergence., --> definition of D
    !! (b_Hdivergence(...) given in DEGREES):, for alpha the random
    !! angle of deviation from the direction of, aiming, P(alpha) ~
    !! exp(-alpha**2/D**2); P(D) = (1/e)*P(0), I.e. D is the angle of
    !! deviation from the aiming angle, in, either direction, for a
    !! (1/e) reduction in probability of, launch of a beam particle.
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_b_hdivergence', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % b_Hdivergence ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % b_Hdivergence)
    endif
end subroutine psgetdim_b_hdivergence


subroutine psget_bphirz(iobj, n1, n2, data, ierr)
    !! Toroidal field
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_bphirz', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % BphiRZ
end subroutine psget_bphirz


subroutine psset_bphirz(iobj, n1, n2, data, ierr)
    !! Toroidal field
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_bphirz', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % BphiRZ = data(1:n1, 1: n2)
end subroutine psset_bphirz


subroutine psgetrnk_bphirz(iobj, ndims, ierr)
    !! Toroidal field
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_bphirz


subroutine psgetdim_bphirz(iobj, ndims, dims, ierr)
    !! Toroidal field
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_bphirz', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % BphiRZ ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % BphiRZ)
    endif
end subroutine psgetdim_bphirz


subroutine psget_bidiff_dtrap(iobj, n1, n2, n3, data, ierr)
    !! beam ion diffusivity: deeply trapped orbits
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2, n3 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2, n3) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_bidiff_dtrap', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2, 1: n3) = ss % bidiff_dtrap
end subroutine psget_bidiff_dtrap


subroutine psset_bidiff_dtrap(iobj, n1, n2, n3, data, ierr)
    !! beam ion diffusivity: deeply trapped orbits
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2, n3 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2, n3) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_bidiff_dtrap', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % bidiff_dtrap = data(1:n1, 1: n2, 1: n3)
end subroutine psset_bidiff_dtrap


subroutine psgetrnk_bidiff_dtrap(iobj, ndims, ierr)
    !! beam ion diffusivity: deeply trapped orbits
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 3
end subroutine psgetrnk_bidiff_dtrap


subroutine psgetdim_bidiff_dtrap(iobj, ndims, dims, ierr)
    !! beam ion diffusivity: deeply trapped orbits
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 3) ierr = 1
    call ccps_argcheck('psgetdim_bidiff_dtrap', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % bidiff_dtrap ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % bidiff_dtrap)
    endif
end subroutine psgetdim_bidiff_dtrap

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


SUBROUTINE plasma_state_copy_4(cclist,ss,ss2,icopy_lists,iwant_1deq,partial_copy,ierr)


  ! Copy scalars, and, arrays that are allocated
  !   ss2 <-- ss

  USE plasma_state_definition_mod
  IMPLICIT NONE

  INTEGER, INTENT(IN) :: cclist(ps_ccount)
                                ! list of components to merge
                                ! use ps_cc_all to merge all components

  TYPE (plasma_state) :: ss     ! state data to copy *from*
  TYPE (plasma_state) :: ss2    ! state data to copy *to*

  INTEGER, INTENT(IN) :: icopy_lists ! =1 to require copying of all lists

  INTEGER, INTENT(IN) :: iwant_1deq  ! =1 to request fcns of (rho_eq)
                                     !  even if cclist(ps_cnum_EQ).eq.0

  LOGICAL, INTENT(IN) :: partial_copy ! .TRUE. if full state copy not in effect

  INTEGER, INTENT(INOUT) :: ierr  ! completion flag (not cleared, set by error)

  !-------------------
  INTEGER :: iout
  !-------------------

  iout = SWIM_err_out_file


  !-----------------------------------------------
  ! copy scalars and arrays that are allocated...
  IF((cclist(ps_cnum_NBI).EQ.1).OR.(icopy_lists.EQ.1)) THEN
     ss2%NBI_Data_Info = ss%NBI_Data_Info
  ENDIF
  IF( ((ALLOCATED(ss2%nbi_src_name)).AND.(ALLOCATED(ss%nbi_src_name))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_NBI).EQ.1)) ) THEN
     ss2%nbi_src_name = ss%nbi_src_name
  ENDIF
  IF( ((ALLOCATED(ss2%nbshape)).AND.(ALLOCATED(ss%nbshape))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_NBI).EQ.1)) ) THEN
     ss2%nbshape = ss%nbshape
  ENDIF
  IF((cclist(ps_cnum_PLASMA).EQ.1).OR.(icopy_lists.EQ.1)) THEN
     ss2%nebar = ss%nebar
  ENDIF
  IF(ALLOCATED(ss2%id_neflux_ky_tglf)) THEN
     IF(partial_copy) THEN
        ss2%id_neflux_ky_tglf = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%neflux_ky_tglf).AND.ALLOCATED(ss2%neflux_ky_tglf)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%neflux_ky_tglf = ss%neflux_ky_tglf
     IF(ALLOCATED(ss2%id_neflux_ky_tglf)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_neflux_ky_tglf = ss%id_neflux_ky_tglf
        ENDIF
     ENDIF
  ENDIF
  IF( ((ALLOCATED(ss2%Newcomb_code)).AND.(ALLOCATED(ss%Newcomb_code))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_LMHD).EQ.1)) ) THEN
     ss2%Newcomb_code = ss%Newcomb_code
  ENDIF
  IF( ((ALLOCATED(ss2%Newcomb_mapper)).AND.(ALLOCATED(ss%Newcomb_mapper))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_LMHD).EQ.1)) ) THEN
     ss2%Newcomb_mapper = ss%Newcomb_mapper
  ENDIF
  IF( ((ALLOCATED(ss2%Newcomb_stable)).AND.(ALLOCATED(ss%Newcomb_stable))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_LMHD).EQ.1)) ) THEN
     ss2%Newcomb_stable = ss%Newcomb_stable
  ENDIF
  IF( ((ALLOCATED(ss2%Newcomb_status)).AND.(ALLOCATED(ss%Newcomb_status))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_LMHD).EQ.1)) ) THEN
     ss2%Newcomb_status = ss%Newcomb_status
  ENDIF
  IF(ALLOCATED(ss2%id_ne_ky_tglf)) THEN
     IF(partial_copy) THEN
        ss2%id_ne_ky_tglf = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%ne_ky_tglf).AND.ALLOCATED(ss2%ne_ky_tglf)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%ne_ky_tglf = ss%ne_ky_tglf
     IF(ALLOCATED(ss2%id_ne_ky_tglf)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_ne_ky_tglf = ss%id_ne_ky_tglf
        ENDIF
     ENDIF
  ENDIF
  IF(ALLOCATED(ss2%id_nfusi)) THEN
     IF(partial_copy) THEN
        ss2%id_nfusi = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%nfusi).AND.ALLOCATED(ss2%nfusi)).AND. &
        ((cclist(ps_cnum_FUS).EQ.1))) THEN
     ss2%nfusi = ss%nfusi
     IF(ALLOCATED(ss2%id_nfusi)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_nfusi = ss%id_nfusi
        ENDIF
     ENDIF
  ENDIF
  IF( ((ALLOCATED(ss2%nfusi_bdy)).AND.(ALLOCATED(ss%nfusi_bdy))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_IC).EQ.1)) ) THEN
     ss2%nfusi_bdy = ss%nfusi_bdy
  ENDIF
  IF(partial_copy) THEN
     ss2%id_ngradb2_av = 0
  ENDIF
  IF((ALLOCATED(ss%ngradb2_av).AND.ALLOCATED(ss2%ngradb2_av)).AND. &
        ((cclist(ps_cnum_EQ).EQ.1))) THEN
     ss2%ngradb2_av = ss%ngradb2_av
     IF(.not.partial_copy) THEN
        ss2%id_ngradb2_av = ss%id_ngradb2_av
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_ni = 0
  ENDIF
  IF((ALLOCATED(ss%ni).AND.ALLOCATED(ss2%ni)).AND. &
        ((cclist(ps_cnum_PLASMA).EQ.1))) THEN
     ss2%ni = ss%ni
     IF(.not.partial_copy) THEN
        ss2%id_ni = ss%id_ni
     ENDIF
  ENDIF
  IF(ALLOCATED(ss2%id_niflux_ky_tglf)) THEN
     IF(partial_copy) THEN
        ss2%id_niflux_ky_tglf = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%niflux_ky_tglf).AND.ALLOCATED(ss2%niflux_ky_tglf)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%niflux_ky_tglf = ss%niflux_ky_tglf
     IF(ALLOCATED(ss2%id_niflux_ky_tglf)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_niflux_ky_tglf = ss%id_niflux_ky_tglf
        ENDIF
     ENDIF
  ENDIF
  IF(ALLOCATED(ss2%id_ni_ky_tglf)) THEN
     IF(partial_copy) THEN
        ss2%id_ni_ky_tglf = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%ni_ky_tglf).AND.ALLOCATED(ss2%ni_ky_tglf)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%ni_ky_tglf = ss%ni_ky_tglf
     IF(ALLOCATED(ss2%id_ni_ky_tglf)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_ni_ky_tglf = ss%id_ni_ky_tglf
        ENDIF
     ENDIF
  ENDIF
  IF((cclist(ps_cnum_ANOM).EQ.1).OR.(icopy_lists.EQ.1)) THEN
     ss2%nmdifb = ss%nmdifb
  ENDIF
  IF(ALLOCATED(ss2%id_nmini)) THEN
     IF(partial_copy) THEN
        ss2%id_nmini = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%nmini).AND.ALLOCATED(ss2%nmini)).AND. &
        ((cclist(ps_cnum_IC).EQ.1))) THEN
     ss2%nmini = ss%nmini
     IF(ALLOCATED(ss2%id_nmini)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_nmini = ss%id_nmini
        ENDIF
     ENDIF
  ENDIF
  IF( ((ALLOCATED(ss2%nmini_bdy)).AND.(ALLOCATED(ss%nmini_bdy))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_FUS).EQ.1)) ) THEN
     ss2%nmini_bdy = ss%nmini_bdy
  ENDIF
  IF(partial_copy) THEN
     ss2%id_nmodel = 0
  ENDIF
  IF((ALLOCATED(ss%nmodel).AND.ALLOCATED(ss2%nmodel)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%nmodel = ss%nmodel
     IF(.not.partial_copy) THEN
        ss2%id_nmodel = ss%id_nmodel
     ENDIF
  ENDIF
  IF((cclist(ps_cnum_ANOM).EQ.1).OR.(icopy_lists.EQ.1)) THEN
     ss2%nmodel_bdy = ss%nmodel_bdy
  ENDIF
  IF((cclist(ps_cnum_EQ).EQ.1).OR.(icopy_lists.EQ.1)) THEN
     ss2%nmom = ss%nmom
  ENDIF
  IF( ((ALLOCATED(ss2%nnkparlh)).AND.(ALLOCATED(ss%nnkparlh))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_LH).EQ.1)) ) THEN
     ss2%nnkparlh = ss%nnkparlh
  ENDIF
  IF( ((ALLOCATED(ss2%nnkpollh)).AND.(ALLOCATED(ss%nnkpollh))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_LH).EQ.1)) ) THEN
     ss2%nnkpollh = ss%nnkpollh
  ENDIF
  IF( ((ALLOCATED(ss2%nnktorlh)).AND.(ALLOCATED(ss%nnktorlh))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_LH).EQ.1)) ) THEN
     ss2%nnktorlh = ss%nnktorlh
  ENDIF
  IF( ((ALLOCATED(ss2%nphi)).AND.(ALLOCATED(ss%nphi))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_IC).EQ.1)) ) THEN
     ss2%nphi = ss%nphi
  ENDIF
  IF(partial_copy) THEN
     ss2%id_nrw = 0
  ENDIF
  IF((ALLOCATED(ss%nrw).AND.ALLOCATED(ss2%nrw)).AND. &
        ((cclist(ps_cnum_RUNAWAY).EQ.1))) THEN
     ss2%nrw = ss%nrw
     IF(.not.partial_copy) THEN
        ss2%id_nrw = ss%id_nrw
     ENDIF
  ENDIF
  IF( ((ALLOCATED(ss2%nrz_antgeo)).AND.(ALLOCATED(ss%nrz_antgeo))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_IC).EQ.1)) ) THEN
     ss2%nrz_antgeo = ss%nrz_antgeo
  ENDIF
  IF(ALLOCATED(ss2%id_ns)) THEN
     IF(partial_copy) THEN
        ss2%id_ns = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%ns).AND.ALLOCATED(ss2%ns)).AND. &
        ((cclist(ps_cnum_PLASMA).EQ.1))) THEN
     ss2%ns = ss%ns
     IF(ALLOCATED(ss2%id_ns)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_ns = ss%id_ns
        ENDIF
     ENDIF
  ENDIF
  IF( ((ALLOCATED(ss2%nspectrumlh_src)).AND.(ALLOCATED(ss%nspectrumlh_src))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_LH).EQ.1)) ) THEN
     ss2%nspectrumlh_src = ss%nspectrumlh_src
  ENDIF
  IF( ((ALLOCATED(ss2%ns_bdy)).AND.(ALLOCATED(ss%ns_bdy))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_PLASMA).EQ.1)) ) THEN
     ss2%ns_bdy = ss%ns_bdy
  ENDIF
  IF((cclist(ps_cnum_PLASMA).EQ.1).OR.(icopy_lists.EQ.1)) THEN
     ss2%ns_Data_Info = ss%ns_Data_Info
  ENDIF
  IF( ((ALLOCATED(ss2%ns_is_input)).AND.(ALLOCATED(ss%ns_is_input))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_PLASMA).EQ.1)) ) THEN
     ss2%ns_is_input = ss%ns_is_input
  ENDIF
  IF((cclist(ps_cnum_RIPPLE).EQ.1).OR.(icopy_lists.EQ.1)) THEN
     ss2%ntf_coil2 = ss%ntf_coil2
  ENDIF

END SUBROUTINE plasma_state_copy_4

subroutine cstate_ldim_stats(luntty,ierr)

  ! get exhaustive statistics and data on "list dimensions" -- dimensions
  ! not representing physical coordinates: species lists, etc.

  ! **call cstate_empty_dims FIRST**
  !   cstate_empty_dims computs "nldims" which is used here.

  use cstate_lib_mod
  implicit NONE

  integer, intent(in) :: luntty  ! LUN for messages

  !-------------------------
  ! local
  integer :: itype,ii,jj,kk,iii,jjj,inum,idim,isize,ierr,iersum,isize_mrg,itot
  integer :: idum,isum,ilparen,irparen,imatch
  logical :: iok(nsss_cur)
  character*1 :: dtype(2) = (/ "S", "L" /)
  character*32 :: lname,mname,tmpname(1),str

  integer, dimension(:,:), allocatable :: addr_table

  integer :: ired(nldims)
  !-------------------------

  write(luntty,*) ' '
  write(luntty,*) ' %cstate_ldim_stats: starting...'

  !-----------------
  if(allocated(dimsizes)) deallocate(dimsizes,mrgsizes,list_dims,list_lolim)

  allocate(dimsizes(nsss_cur,nldims),mrgsizes(nldims))
  allocate(list_dims(nldims),list_lolim(nldims))
  dimsizes = 0
  mrgsizes = 0
  !-----------------

  maxnl=0
  maxml=0

  if(allocated(ww)) deallocate(ww)
  allocate(ww(nsss_cur))
  allocate(wdisp(nsss_cur))

  iersum = 0
  idim = 0

  ired = 0

  !-------------------------------------------------------------------------
  !  On first pass get basic information:  name & sizes of each list
  !  dimension before & after merge across states; maximum sizes as well.

  do itype = 1,2

     do ii=1,nsss_cur
        call psw_contents(dtype(itype),ps_cc_all,ww(ii),ierr, state=sss(ii))
        iok(ii) = (ierr.eq.0)
        if(.not.iok(ii)) iersum = iersum + 1
     enddo
     if(iersum.gt.0) exit

     !  #dimensions of type (itype): attribute of state definition...
     isize = ww(1)%size

     do jj=1,isize

        idim = idim + 1
        itot = 0

        ! extract bare dimension, e.g. "(0:nspec_th)" -> "nspec_th"

        call cstate_extract_dims(ww(1)%val_field(jj),1,idum, &
             tmpname,list_lolim(idim:idim))
        list_dims(idim) = tmpname(1)

        ! check for possibility of reduction operation
        do ii=1,nreduce_opt
           if(list_dims(idim).eq.reduce_dims(ii)) then
              ired(idim)=ii
              exit
           endif
        enddo

        do ii=1,nsss_cur
           dimsizes(ii,idim) = ww(ii)%ival(jj)
           itot = itot + dimsizes(ii,idim)
           maxnl = max(maxnl,dimsizes(ii,idim))
        enddo

        if(itot.gt.0) then
           lname = ww(1)%list_elems(jj)
           do ii=1,nsss_cur
              if(dtype(itype).eq.'S') then
                 call psw_slist(lname,wdisp(ii),ierr, state=sss(ii))
              else
                 call psw_ilist(lname,wdisp(ii),ierr, state=sss(ii))
              endif
              if(ierr.ne.0) then
                 iersum = iersum + 1
                 exit
              endif
           enddo
           if(iersum.gt.0) exit

           call psw_merge(wdisp,wmerge,ierr)
           if(ierr.gt.0) then
              iersum=iersum+1
              exit
           endif

           isize_mrg = wmerge%size
           mrgsizes(idim) = isize_mrg
           maxml = max(maxml,isize_mrg)

        endif
     enddo
     if(iersum.gt.0) exit
  enddo

  if(iersum.ne.0) then
     write(luntty,*) ' ?unexpected internal error: cstate_ldim_stats.f90'
     ierr=1
     return
  endif

  if(allocated(mrg_addr_map)) deallocate(mrg_addr_map,orig_order, &
       sumlbl,sumindx,sumctrl,sumterms,mrg_name)
  allocate(mrg_addr_map(nsss_cur,maxml,nldims)); mrg_addr_map = 0
  allocate(mrg_name(maxml,nldims)); mrg_name=' '
  allocate(orig_order(maxnl,nsss_cur,nldims)); orig_order = 0
  allocate(sumlbl(nmax_rsum,nldims)); sumlbl=' '
  allocate(sumterms(nmax_rsum,nldims)); sumterms = 0
  allocate(sumindx(maxnl,nsss_cur,nldims)); sumindx = 0
  allocate(sumctrl(maxnl,nsss_cur,nldims)); sumctrl = 0

  !-------------------------------------------------------------------------
  !  On 2nd pass compute address and order mappings
  !
  !  for k'th list dimension:
  !    mrg_addr_map(istate,jmerge,k) = 0
  !      means merged list element (jmerge) does not exist in state (istate)
  !                                  = j
  !      means merged list element (jmerge) exists in state (istate) at
  !      ordered position (j)
  !         --> original position:  L = orig_order(j,istate,k)
  !
  !  for a multiple dimension lookup in dimensions (k1,k2)-> (j1,j2)-> (L1,L2)
  !  item does not exist if either j1 or j2 is zero.  If item does exist, the
  !  linear address is L1 + (dimsizes(k1))*(L2-1)
  !
  !  for 3d lookup:  L1 + dimsizes(k1)*((L2-1) + dimsizes(k2)*(L3-1))
  !    ..etc..
  !
  !  this allows computation of merge of data objects in manner consistent
  !  with the merging of species and item lists.

  idim = 0

  do itype = 1,2

     ! only need 1st one this time... call is repeat so ierr check is skipped

     call psw_contents(dtype(itype),ps_cc_all,ww(1),ierr, state=sss(1))

     isize = ww(1)%size

     do jj=1,isize

        idim = idim + 1
        if(mrgsizes(idim).eq.0) cycle

        lname = ww(1)%list_elems(jj)
        do ii=1,nsss_cur
           if(dtype(itype).eq.'S') then
              call psw_slist(lname,wdisp(ii),ierr, state=sss(ii))
              call psw_slist(lname,wtmp,ierr, state=sss(ii), iorder=.FALSE.)
              inum=wtmp%size  ! = wdisp(ii)%size
              if((lname.eq.'ALL').or.(lname.eq.'ALLA')) then
                 call ired_chk('ALL')
                 sumlbl(1,idim)='IMP'
                 sumlbl(2,idim)='BEAM'
                 sumlbl(3,idim)='FUSN'
                 sumlbl(4,idim)='MINO'
                 do iii=1,inum
                    if(wdisp(ii)%spectype(iii).eq.ps_beam_ion) then
                       isum=2
                       sumindx(iii,ii,idim)=isum
                       sumctrl(iii,ii,idim)=ired(idim)
                       sumterms(isum,idim) = sumterms(isum,idim) + 1
                    else if(wdisp(ii)%spectype(iii).eq.ps_fusion_ion) then
                       isum=3
                       sumindx(iii,ii,idim)=isum
                       sumctrl(iii,ii,idim)=ired(idim)
                       sumterms(isum,idim) = sumterms(isum,idim) + 1
                    else if(wdisp(ii)%spectype(iii).eq.ps_rf_minority) then
                       isum=4
                       sumindx(iii,ii,idim)=isum
                       sumctrl(iii,ii,idim)=ired(idim)
                       sumterms(isum,idim) = sumterms(isum,idim) + 1
                    else
                       if(wdisp(ii)%spectype(iii).eq.ps_impurity) then
                          isum=1
                          sumindx(iii,ii,idim)=isum
                          sumctrl(iii,ii,idim)=ired(idim)
                          sumterms(isum,idim) = sumterms(isum,idim) + 1
                       endif
                    endif
                 enddo
              else if((lname.eq.'S').or.(lname.eq.'SA')) then
                 call ired_chk('S')
                 sumlbl(1,idim)='IMP'
                 do iii=1,inum
                    if(wdisp(ii)%spectype(iii).eq.ps_impurity) then
                       isum=1
                       sumindx(iii,ii,idim)=isum
                       sumctrl(iii,ii,idim)=ired(idim)
                       sumterms(isum,idim) = sumterms(isum,idim) + 1
                    endif
                 enddo
              else if(lname.eq.'SGAS') then
                 call ired_chk('SGAS')
                 sumlbl(1,idim)='H_iso'
                 sumlbl(2,idim)='He_iso'
                 do iii=1,inum
                    if(wdisp(ii)%qatom(iii).eq.1) then
                       isum=1
                       sumindx(iii,ii,idim)=isum
                       sumctrl(iii,ii,idim)=ired(idim)
                       sumterms(isum,idim) = sumterms(isum,idim) + 1
                    else if(wdisp(ii)%qatom(iii).eq.2) then
                       isum=2
                       sumindx(iii,ii,idim)=isum
                       sumctrl(iii,ii,idim)=ired(idim)
                       sumterms(isum,idim) = sumterms(isum,idim) + 1
                    endif
                 enddo
              else if(lname.eq.'SNBI') then
                 call ired_chk('SNBI')
                 sumlbl(1,idim)='BEAM'
                 do iii=1,inum
                    isum=1
                    sumindx(iii,ii,idim)=isum
                    sumctrl(iii,ii,idim)=ired(idim)
                    sumterms(isum,idim) = sumterms(isum,idim) + 1
                 enddo
              else if(lname.eq.'SFUS') then
                 call ired_chk('SFUS')
                 sumlbl(1,idim)='FUSN'
                 do iii=1,inum
                    isum=1
                    sumindx(iii,ii,idim)=isum
                    sumctrl(iii,ii,idim)=ired(idim)
                    sumterms(isum,idim) = sumterms(isum,idim) + 1
                 enddo
              else if(lname.eq.'RFMIN') then
                 call ired_chk('RFMIN')
                 sumlbl(1,idim)='MINO'
                 do iii=1,inum
                    isum=1
                    sumindx(iii,ii,idim)=isum
                    sumctrl(iii,ii,idim)=ired(idim)
                    sumterms(isum,idim) = sumterms(isum,idim) + 1
                 enddo
              endif
           else
              call psw_ilist(lname,wdisp(ii),ierr, state=sss(ii))
              call psw_ilist(lname,wtmp,ierr, state=sss(ii), iorder=.FALSE.)

              !  put short names in place...
              do iii=1,wtmp%size
                 wtmp%list_elems(iii)=trim(wtmp%c256val(iii))
                 wdisp(ii)%list_elems(iii)=trim(wdisp(ii)%c256val(iii))
              enddo

              inum=wtmp%size  ! = wdisp(ii)%size
              if(lname.eq.'ECRF_SRC_NAME') then
                 call ired_chk('ECRF_SRC_NAME')
                 sumlbl(1,idim)='ECTOT'
                 if(inum.gt.0) then
                    isum=1
                    sumindx(1:inum,ii,idim)=isum
                    sumctrl(1:inum,ii,idim)=ired(idim)
                    sumterms(isum,idim) = sumterms(isum,idim) + inum
                 endif
              else if(lname.eq.'LHRF_SRC_NAME') then
                 call ired_chk('LHRF_SRC_NAME')
                 sumlbl(1,idim)='LHTOT'
                 if(inum.gt.0) then
                    isum=1
                    sumindx(1:inum,ii,idim)=isum
                    sumctrl(1:inum,ii,idim)=ired(idim)
                    sumterms(isum,idim) = sumterms(isum,idim) + inum
                 endif
              else if(lname.eq.'ICRF_SRC_NAME') then
                 call ired_chk('ICRF_SRC_NAME')
                 sumlbl(1,idim)='ICTOT'
                 if(inum.gt.0) then
                    isum=1
                    sumindx(1:inum,ii,idim)=isum
                    sumctrl(1:inum,ii,idim)=ired(idim)
                    sumterms(isum,idim) = sumterms(isum,idim) + inum
                 endif
              else if(lname.eq.'NBI_SRC_NAME') then
                 call ired_chk('NBI_SRC_NAME')
                 sumlbl(1,idim)='BTOT'
                 if(inum.gt.0) then
                    isum=1
                    sumindx(1:inum,ii,idim)=isum
                    sumctrl(1:inum,ii,idim)=ired(idim)
                    sumterms(isum,idim) = sumterms(isum,idim) + inum
                 endif
              endif

           endif

           ! find orig_order

           do iii=1,inum
              mname=wdisp(ii)%list_elems(iii)
              do jjj=1,inum
                 if(mname.eq.wtmp%list_elems(jjj)) then
                    orig_order(iii,ii,idim) = jjj
                    exit
                 endif
              enddo
           enddo
        enddo

        ! find addr_table
        inum = mrgsizes(idim)
        allocate(addr_table(nsss_cur,inum))

        call psw_merge(wdisp,wmerge,ierr, addr_table=addr_table)

        mrg_addr_map(1:nsss_cur,1:inum,idim) = addr_table
        mrg_name(1:inum,idim)=wmerge%list_elems(1:inum)

        deallocate(addr_table)

        ! disallow reduction sums with only a single contributor
        ! (original labeling will be retained).

        do iii=1,nmax_rsum
           if(sumterms(iii,idim).eq.1) then
              do ii=1,nsss_cur
                 do jjj=1,maxnl
                    if(sumindx(jjj,ii,idim).eq.iii) then
                       sumindx(jjj,ii,idim)=0
                       sumctrl(jjj,ii,idim)=0
                    endif
                 enddo
              enddo
              sumterms(iii,idim)=0
           endif
        enddo

     enddo
  enddo

  !-------------------------------------------------------------------------
  !  get enumeration dimension data

  iersum = 0
  do ii=1,nsss_cur
     call psw_contents('E',ps_cc_all,ww(ii),ierr, state=sss(ii))
     if(ierr.ne.0) iersum = iersum + 1
  enddo

  !  #dimensions of type (itype): attribute of state definition...

  if(allocated(enum_dims)) &
       deallocate(enum_dims,enum_max,enum_decl,enum_ldim_ref)

  isize = ww(1)%size
  nedims= isize
  allocate(enum_dims(isize))
  allocate(enum_max(isize)); enum_max = 0
  allocate(enum_decl(isize))
  allocate(enum_ldim_ref(isize)); enum_ldim_ref = 0

  do jj=1,isize
     enum_dims(jj) = trim(ww(1)%list_elems(jj))
     call ulower(enum_dims(jj)) ! -> lowercase
     enum_decl(jj) = trim(ww(1)%val_field(jj))
     ilparen = index(enum_decl(jj),'(')
     irparen = max((ilparen+2),index(enum_decl(jj),')'))
     if(ilparen.gt.0) then
        str = enum_decl(jj)(ilparen+1:irparen-1)
        imatch = 0
        do kk=1,nldims
           if(str.eq.list_dims(kk)) then
              enum_ldim_ref(jj)=kk
              imatch = kk
              exit
           endif
        enddo
        if(imatch.eq.0) then
           iersum=iersum + 1
           write(luntty,*) '?cstate_ldim_stats: no list dimension found to '//&
                'match: ',trim(enum_decl(jj))
        endif
     endif
  enddo

  do ii=1,nsss_cur
     do jj=1,isize
        enum_max(jj)=max(enum_max(jj),ww(ii)%ival(jj))
     enddo
  enddo

  !-------------------------------------------------------------------------
  !  clean up...

  do ii=1,nsss_cur
     call free_window(ww(ii))
     call free_window(wdisp(ii))
  enddo
  deallocate(ww,wdisp)
     
  if(iersum.ne.0) then
     write(luntty,*) ' ?unexpected internal error: cstate_ldim_stats.f90'// &
          ' (enumeration scan).'
     ierr=1
  else
     write(luntty,*) ' %cstate_ldim_stats: completed.'
     ierr=0
  endif

  contains
    subroutine ired_chk(lisnam)

      character*(*), intent(in) :: lisnam
      if(ired(idim).eq.0) then
         write(luntty,*) ' ?cstate_ldim_stats: internal error.'
         write(luntty,*) '  inconsistency in code data on reducibility:'
         write(luntty,*) '    list name: ',trim(lisnam)
         write(luntty,*) '    dimension name: ',trim(list_dims(idim))
         write(luntty,*) '  code for list reduction requires dimension reducibility.'
         call bad_exit
      endif
    end subroutine ired_chk

end subroutine cstate_ldim_stats

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_a1_dummy
     return
  end subroutine ccps_getset_a1_dummy

subroutine psget_ap_halfwidth(iobj, n1, data, ierr)
    !! aperture half-width, for nbap_shape(j)="rectangle", this is
    !! the horizontal size, specification; for nbap_shape(j)="circle",
    !! ap_halfwidth(j) is, the radius.
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_ap_halfwidth', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % ap_halfwidth
end subroutine psget_ap_halfwidth


subroutine psset_ap_halfwidth(iobj, n1, data, ierr)
    !! aperture half-width, for nbap_shape(j)="rectangle", this is
    !! the horizontal size, specification; for nbap_shape(j)="circle",
    !! ap_halfwidth(j) is, the radius.
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_ap_halfwidth', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % ap_halfwidth = data(1:n1)
end subroutine psset_ap_halfwidth


subroutine psgetrnk_ap_halfwidth(iobj, ndims, ierr)
    !! aperture half-width, for nbap_shape(j)="rectangle", this is
    !! the horizontal size, specification; for nbap_shape(j)="circle",
    !! ap_halfwidth(j) is, the radius.
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_ap_halfwidth


subroutine psgetdim_ap_halfwidth(iobj, ndims, dims, ierr)
    !! aperture half-width, for nbap_shape(j)="rectangle", this is
    !! the horizontal size, specification; for nbap_shape(j)="circle",
    !! ap_halfwidth(j) is, the radius.
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_ap_halfwidth', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % ap_halfwidth ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % ap_halfwidth)
    endif
end subroutine psgetdim_ap_halfwidth


subroutine psget_atormaxlh(iobj, n1, n2, data, ierr)
    !! toroidal mode number right of lumps
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_atormaxlh', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % atormaxlh
end subroutine psget_atormaxlh


subroutine psset_atormaxlh(iobj, n1, n2, data, ierr)
    !! toroidal mode number right of lumps
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_atormaxlh', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % atormaxlh = data(1:n1, 1: n2)
end subroutine psset_atormaxlh


subroutine psgetrnk_atormaxlh(iobj, ndims, ierr)
    !! toroidal mode number right of lumps
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_atormaxlh


subroutine psgetdim_atormaxlh(iobj, ndims, dims, ierr)
    !! toroidal mode number right of lumps
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_atormaxlh', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % atormaxlh ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % atormaxlh)
    endif
end subroutine psgetdim_atormaxlh


subroutine psget_all_index(iobj, n1, data, ierr)
    !! species index in original lists, ion species j in "all"
    !! corresponds to ion species:, all_index(j) in "s" if all_type(j)
    !! = ps_electron, ps_therm_ion, or, ps_impurity, all_index(j) in
    !! "snbi" if all_type(j) = ps_beam_ion, all_index(j) in "rfmin" if
    !! all_type(j) = ps_rf_minority, all_index(j) in "sfus" if
    !! all_type(j) = ps_fusion_ion
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_all_index', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % all_index
end subroutine psget_all_index


subroutine psset_all_index(iobj, n1, data, ierr)
    !! species index in original lists, ion species j in "all"
    !! corresponds to ion species:, all_index(j) in "s" if all_type(j)
    !! = ps_electron, ps_therm_ion, or, ps_impurity, all_index(j) in
    !! "snbi" if all_type(j) = ps_beam_ion, all_index(j) in "rfmin" if
    !! all_type(j) = ps_rf_minority, all_index(j) in "sfus" if
    !! all_type(j) = ps_fusion_ion
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_all_index', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % all_index = data(1:n1)
end subroutine psset_all_index


subroutine psgetrnk_all_index(iobj, ndims, ierr)
    !! species index in original lists, ion species j in "all"
    !! corresponds to ion species:, all_index(j) in "s" if all_type(j)
    !! = ps_electron, ps_therm_ion, or, ps_impurity, all_index(j) in
    !! "snbi" if all_type(j) = ps_beam_ion, all_index(j) in "rfmin" if
    !! all_type(j) = ps_rf_minority, all_index(j) in "sfus" if
    !! all_type(j) = ps_fusion_ion
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_all_index


subroutine psgetdim_all_index(iobj, ndims, dims, ierr)
    !! species index in original lists, ion species j in "all"
    !! corresponds to ion species:, all_index(j) in "s" if all_type(j)
    !! = ps_electron, ps_therm_ion, or, ps_impurity, all_index(j) in
    !! "snbi" if all_type(j) = ps_beam_ion, all_index(j) in "rfmin" if
    !! all_type(j) = ps_rf_minority, all_index(j) in "sfus" if
    !! all_type(j) = ps_fusion_ion
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_all_index', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % all_index ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % all_index)
    endif
end subroutine psgetdim_all_index


subroutine psget_area(iobj, n1, data, ierr)
    !! enclosed area
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_area', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % area
end subroutine psget_area


subroutine psset_area(iobj, n1, data, ierr)
    !! enclosed area
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_area', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % area = data(1:n1)
end subroutine psset_area


subroutine psgetrnk_area(iobj, ndims, ierr)
    !! enclosed area
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_area


subroutine psgetdim_area(iobj, ndims, dims, ierr)
    !! enclosed area
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_area', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % area ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % area)
    endif
end subroutine psgetdim_area


subroutine psget_anom_evar(iobj, n1, data, ierr)
    !! anomalous transport energy variation, =1 to use transport
    !! profiles as given; O(1) expected., if undefined, use transport
    !! profiles as given.
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_anom_evar', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % anom_evar
end subroutine psget_anom_evar


subroutine psset_anom_evar(iobj, n1, data, ierr)
    !! anomalous transport energy variation, =1 to use transport
    !! profiles as given; O(1) expected., if undefined, use transport
    !! profiles as given.
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_anom_evar', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % anom_evar = data(1:n1)
end subroutine psset_anom_evar


subroutine psgetrnk_anom_evar(iobj, ndims, ierr)
    !! anomalous transport energy variation, =1 to use transport
    !! profiles as given; O(1) expected., if undefined, use transport
    !! profiles as given.
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_anom_evar


subroutine psgetdim_anom_evar(iobj, ndims, dims, ierr)
    !! anomalous transport energy variation, =1 to use transport
    !! profiles as given; O(1) expected., if undefined, use transport
    !! profiles as given.
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_anom_evar', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % anom_evar ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % anom_evar)
    endif
end subroutine psgetdim_anom_evar

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_d2_dummy
     return
  end subroutine ccps_getset_d2_dummy

subroutine psget_dx_fshield(iobj, n1, data, ierr)
    !! distance, antenna to Faraday shield
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_dx_fshield', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % dx_fshield
end subroutine psget_dx_fshield


subroutine psset_dx_fshield(iobj, n1, data, ierr)
    !! distance, antenna to Faraday shield
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_dx_fshield', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % dx_fshield = data(1:n1)
end subroutine psset_dx_fshield


subroutine psgetrnk_dx_fshield(iobj, ndims, ierr)
    !! distance, antenna to Faraday shield
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_dx_fshield


subroutine psgetdim_dx_fshield(iobj, ndims, dims, ierr)
    !! distance, antenna to Faraday shield
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_dx_fshield', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % dx_fshield ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % dx_fshield)
    endif
end subroutine psgetdim_dx_fshield


subroutine psget_dn0out(iobj, data, ierr)
    !! Hydrogenic neutral density in scrape off region, This is a
    !! simplified 0d specification of neutral density, beyond the
    !! plasma boundary, that can be used to deplete, fast ion orbits
    !! that go beyond the boundary via charge, exchange, in some
    !! models.
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_dn0out', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % dn0out
end subroutine psget_dn0out


subroutine psset_dn0out(iobj, data, ierr)
    !! Hydrogenic neutral density in scrape off region, This is a
    !! simplified 0d specification of neutral density, beyond the
    !! plasma boundary, that can be used to deplete, fast ion orbits
    !! that go beyond the boundary via charge, exchange, in some
    !! models.
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_dn0out', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % dn0out = data
end subroutine psset_dn0out


subroutine psget_dist_fun(iobj, n1, data, ierr)
    !! distribution function filenames
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    CHARACTER*(*), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_dist_fun', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % dist_fun
end subroutine psget_dist_fun


subroutine psset_dist_fun(iobj, n1, data, ierr)
    !! distribution function filenames
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    CHARACTER*(*), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_dist_fun', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % dist_fun = data(1:n1)
end subroutine psset_dist_fun


subroutine psgetsz_dist_fun(iobj, size, ierr)
    !! distribution function filenames
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: size    ! size of character string
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psgetsz_dist_fun', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! note that the following will return the character length size regardless of
    ! the number of array elements (if dist_fun is an array)
    size = len(ss % dist_fun)
end subroutine psgetsz_dist_fun


subroutine psgetrnk_dist_fun(iobj, ndims, ierr)
    !! distribution function filenames
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_dist_fun


subroutine psgetdim_dist_fun(iobj, ndims, dims, ierr)
    !! distribution function filenames
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_dist_fun', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % dist_fun ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % dist_fun)
    endif
end subroutine psgetdim_dist_fun


subroutine psget_dqidgrdti_tglf(iobj, n1, data, ierr)
    !! Ti flux gradient term from TGLF model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_dqidgrdti_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % dQidGrdti_tglf
end subroutine psget_dqidgrdti_tglf


subroutine psset_dqidgrdti_tglf(iobj, n1, data, ierr)
    !! Ti flux gradient term from TGLF model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_dqidgrdti_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % dQidGrdti_tglf = data(1:n1)
end subroutine psset_dqidgrdti_tglf


subroutine psgetrnk_dqidgrdti_tglf(iobj, ndims, ierr)
    !! Ti flux gradient term from TGLF model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_dqidgrdti_tglf


subroutine psgetdim_dqidgrdti_tglf(iobj, ndims, dims, ierr)
    !! Ti flux gradient term from TGLF model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_dqidgrdti_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % dQidGrdti_tglf ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % dQidGrdti_tglf)
    endif
end subroutine psgetdim_dqidgrdti_tglf


subroutine psget_dxrjsin_momeq_drho(iobj, n1, n2, data, ierr)
    !! scaled R sin moments, Fourier Spline representation
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_dxrjsin_momeq_drho', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % dxRjsin_momeq_dRHO
end subroutine psget_dxrjsin_momeq_drho


subroutine psset_dxrjsin_momeq_drho(iobj, n1, n2, data, ierr)
    !! scaled R sin moments, Fourier Spline representation
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_dxrjsin_momeq_drho', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % dxRjsin_momeq_dRHO = data(1:n1, 1: n2)
end subroutine psset_dxrjsin_momeq_drho


subroutine psgetrnk_dxrjsin_momeq_drho(iobj, ndims, ierr)
    !! scaled R sin moments, Fourier Spline representation
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_dxrjsin_momeq_drho


subroutine psgetdim_dxrjsin_momeq_drho(iobj, ndims, dims, ierr)
    !! scaled R sin moments, Fourier Spline representation
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_dxrjsin_momeq_drho', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % dxRjsin_momeq_dRHO ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % dxRjsin_momeq_dRHO)
    endif
end subroutine psgetdim_dxrjsin_momeq_drho

subroutine cstate_main(imod)

  implicit NONE

  ! construct or extend list of states to be compared; call code to compare
  ! states

  ! routines which use the UREAD cmd line interface have prefix "ur_" in
  ! their names.  Exception: cstate_main.f90, this routine, which calls
  ! ur_ cstate_lib routines.

  ! DMC 25 June 2007

  !----------------------------------------------
  !  argument:

  integer, intent(in) :: imod   ! =1 to allow user modification of state list

  !----------------------------------------------
  !  local:

  integer :: iexit

  !----------------------------------------------

  iexit=0
  do

     if(imod.eq.1) then
        call ur_cstate_list(iexit)
     endif

     if(iexit.eq.1) exit

     call ur_cstate_compare

     iexit=1
  enddo

end subroutine cstate_main

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_s8_dummy
     return
  end subroutine ccps_getset_s8_dummy

subroutine psget_shot_number(iobj, data, ierr)
    !! integer shot number
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_shot_number', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % shot_number
end subroutine psget_shot_number


subroutine psset_shot_number(iobj, data, ierr)
    !! integer shot number
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_shot_number', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % shot_number = data
end subroutine psset_shot_number


subroutine psget_sfus_type(iobj, n1, data, ierr)
    !! SFUS specie types
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_sfus_type', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % SFUS_type
end subroutine psget_sfus_type


subroutine psset_sfus_type(iobj, n1, data, ierr)
    !! SFUS specie types
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_sfus_type', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % SFUS_type = data(1:n1)
end subroutine psset_sfus_type


subroutine psgetrnk_sfus_type(iobj, ndims, ierr)
    !! SFUS specie types
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_sfus_type


subroutine psgetdim_sfus_type(iobj, ndims, dims, ierr)
    !! SFUS specie types
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_sfus_type', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % SFUS_type ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % SFUS_type)
    endif
end subroutine psgetdim_sfus_type


subroutine psget_sa_index(iobj, n1, data, ierr)
    !! species index in original lists, sa_index(j)=-1 indicates
    !! that element (j) of the "SA" list is, derived from a composite
    !! of ions in the "S" list (using Zeff, and quasineutrality
    !! equations)., otherwise sa_index(j) gives the index of the
    !! species in "S", For example, if index 2 corresponds to
    !! Deuterium ions in "SA", then, sa_index(2) gives the index in
    !! "S" for Deuterium ions., For non-impurities usually
    !! sa_index(j)=j but this could be altered, if He3+1 or He4+1
    !! (less than fully stripped He ions) are present in, the model.
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_sa_index', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % sa_index
end subroutine psget_sa_index


subroutine psset_sa_index(iobj, n1, data, ierr)
    !! species index in original lists, sa_index(j)=-1 indicates
    !! that element (j) of the "SA" list is, derived from a composite
    !! of ions in the "S" list (using Zeff, and quasineutrality
    !! equations)., otherwise sa_index(j) gives the index of the
    !! species in "S", For example, if index 2 corresponds to
    !! Deuterium ions in "SA", then, sa_index(2) gives the index in
    !! "S" for Deuterium ions., For non-impurities usually
    !! sa_index(j)=j but this could be altered, if He3+1 or He4+1
    !! (less than fully stripped He ions) are present in, the model.
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_sa_index', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % sa_index = data(1:n1)
end subroutine psset_sa_index


subroutine psgetrnk_sa_index(iobj, ndims, ierr)
    !! species index in original lists, sa_index(j)=-1 indicates
    !! that element (j) of the "SA" list is, derived from a composite
    !! of ions in the "S" list (using Zeff, and quasineutrality
    !! equations)., otherwise sa_index(j) gives the index of the
    !! species in "S", For example, if index 2 corresponds to
    !! Deuterium ions in "SA", then, sa_index(2) gives the index in
    !! "S" for Deuterium ions., For non-impurities usually
    !! sa_index(j)=j but this could be altered, if He3+1 or He4+1
    !! (less than fully stripped He ions) are present in, the model.
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_sa_index


subroutine psgetdim_sa_index(iobj, ndims, dims, ierr)
    !! species index in original lists, sa_index(j)=-1 indicates
    !! that element (j) of the "SA" list is, derived from a composite
    !! of ions in the "S" list (using Zeff, and quasineutrality
    !! equations)., otherwise sa_index(j) gives the index of the
    !! species in "S", For example, if index 2 corresponds to
    !! Deuterium ions in "SA", then, sa_index(2) gives the index in
    !! "S" for Deuterium ions., For non-impurities usually
    !! sa_index(j)=j but this could be altered, if He3+1 or He4+1
    !! (less than fully stripped He ions) are present in, the model.
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_sa_index', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % sa_index ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % sa_index)
    endif
end subroutine psgetdim_sa_index


subroutine psget_snbi_to_alla(iobj, n1, data, ierr)
    !! map snbi index to "alla" list
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_snbi_to_alla', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % snbi_to_alla
end subroutine psget_snbi_to_alla


subroutine psset_snbi_to_alla(iobj, n1, data, ierr)
    !! map snbi index to "alla" list
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_snbi_to_alla', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % snbi_to_alla = data(1:n1)
end subroutine psset_snbi_to_alla


subroutine psgetrnk_snbi_to_alla(iobj, ndims, ierr)
    !! map snbi index to "alla" list
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_snbi_to_alla


subroutine psgetdim_snbi_to_alla(iobj, ndims, dims, ierr)
    !! map snbi index to "alla" list
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_snbi_to_alla', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % snbi_to_alla ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % snbi_to_alla)
    endif
end subroutine psgetdim_snbi_to_alla


subroutine psget_simpi_name(iobj, n1, data, ierr)
    !! impurity ion species in simulation
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    CHARACTER*(*), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_simpi_name', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % SIMPI_name
end subroutine psget_simpi_name


subroutine psset_simpi_name(iobj, n1, data, ierr)
    !! impurity ion species in simulation
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    CHARACTER*(*), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_simpi_name', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % SIMPI_name = data(1:n1)
end subroutine psset_simpi_name


subroutine psgetsz_simpi_name(iobj, size, ierr)
    !! impurity ion species in simulation
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: size    ! size of character string
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psgetsz_simpi_name', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! note that the following will return the character length size regardless of
    ! the number of array elements (if SIMPI_name is an array)
    size = len(ss % SIMPI_name)
end subroutine psgetsz_simpi_name


subroutine psgetrnk_simpi_name(iobj, ndims, ierr)
    !! impurity ion species in simulation
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_simpi_name


subroutine psgetdim_simpi_name(iobj, ndims, dims, ierr)
    !! impurity ion species in simulation
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_simpi_name', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % SIMPI_name ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % SIMPI_name)
    endif
end subroutine psgetdim_simpi_name


subroutine psget_simp0_type(iobj, n1, data, ierr)
    !! SIMP0 specie types
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_simp0_type', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % SIMP0_type
end subroutine psget_simp0_type


subroutine psset_simp0_type(iobj, n1, data, ierr)
    !! SIMP0 specie types
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_simp0_type', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % SIMP0_type = data(1:n1)
end subroutine psset_simp0_type


subroutine psgetrnk_simp0_type(iobj, ndims, ierr)
    !! SIMP0 specie types
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_simp0_type


subroutine psgetdim_simp0_type(iobj, ndims, dims, ierr)
    !! SIMP0 specie types
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_simp0_type', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % SIMP0_type ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % SIMP0_type)
    endif
end subroutine psgetdim_simp0_type


subroutine psget_squareuo(iobj, n1, data, ierr)
    !! upper outer squareness, upper half of plasma, large major
    !! radius side, definition per C. T. Holcomb et al,, Physics of
    !! Plasmas 15, 056116 (2009)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_squareuo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % squareUO
end subroutine psget_squareuo


subroutine psset_squareuo(iobj, n1, data, ierr)
    !! upper outer squareness, upper half of plasma, large major
    !! radius side, definition per C. T. Holcomb et al,, Physics of
    !! Plasmas 15, 056116 (2009)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_squareuo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % squareUO = data(1:n1)
end subroutine psset_squareuo


subroutine psgetrnk_squareuo(iobj, ndims, ierr)
    !! upper outer squareness, upper half of plasma, large major
    !! radius side, definition per C. T. Holcomb et al,, Physics of
    !! Plasmas 15, 056116 (2009)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_squareuo


subroutine psgetdim_squareuo(iobj, ndims, dims, ierr)
    !! upper outer squareness, upper half of plasma, large major
    !! radius side, definition per C. T. Holcomb et al,, Physics of
    !! Plasmas 15, 056116 (2009)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_squareuo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % squareUO ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % squareUO)
    endif
end subroutine psgetdim_squareuo


subroutine psget_sbedep(iobj, n1, data, ierr)
    !! beam deposition cold electron sce, there is also a
    !! contribution due to recapture of charge-exchanged, fast
    !! neutrals from partially slowed down beam ions.
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_sbedep', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % sbedep
end subroutine psget_sbedep


subroutine psset_sbedep(iobj, n1, data, ierr)
    !! beam deposition cold electron sce, there is also a
    !! contribution due to recapture of charge-exchanged, fast
    !! neutrals from partially slowed down beam ions.
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_sbedep', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % sbedep = data(1:n1)
end subroutine psset_sbedep


subroutine psgetrnk_sbedep(iobj, ndims, ierr)
    !! beam deposition cold electron sce, there is also a
    !! contribution due to recapture of charge-exchanged, fast
    !! neutrals from partially slowed down beam ions.
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_sbedep


subroutine psgetdim_sbedep(iobj, ndims, dims, ierr)
    !! beam deposition cold electron sce, there is also a
    !! contribution due to recapture of charge-exchanged, fast
    !! neutrals from partially slowed down beam ions.
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_sbedep', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % sbedep ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % sbedep)
    endif
end subroutine psgetdim_sbedep


subroutine psget_spsce(iobj, n1, n2, data, ierr)
    !! net source, thermal ions & electrons
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_spsce', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % spsce
end subroutine psget_spsce


subroutine psset_spsce(iobj, n1, n2, data, ierr)
    !! net source, thermal ions & electrons
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_spsce', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % spsce = data(1:n1, 1: n2)
end subroutine psset_spsce


subroutine psgetrnk_spsce(iobj, ndims, ierr)
    !! net source, thermal ions & electrons
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_spsce


subroutine psgetdim_spsce(iobj, ndims, dims, ierr)
    !! net source, thermal ions & electrons
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_spsce', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % spsce ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % spsce)
    endif
end subroutine psgetdim_spsce


subroutine psget_sii_xs(iobj, n1, n2, n3, data, ierr)
    !! species source/sinks driven by xs(1:nxs)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2, n3 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2, n3) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_sii_xs', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2, 1: n3) = ss % sii_xs
end subroutine psget_sii_xs


subroutine psset_sii_xs(iobj, n1, n2, n3, data, ierr)
    !! species source/sinks driven by xs(1:nxs)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2, n3 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2, n3) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_sii_xs', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % sii_xs = data(1:n1, 1: n2, 1: n3)
end subroutine psset_sii_xs


subroutine psgetrnk_sii_xs(iobj, ndims, ierr)
    !! species source/sinks driven by xs(1:nxs)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 3
end subroutine psgetrnk_sii_xs


subroutine psgetdim_sii_xs(iobj, ndims, dims, ierr)
    !! species source/sinks driven by xs(1:nxs)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 3) ierr = 1
    call ccps_argcheck('psgetdim_sii_xs', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % sii_xs ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % sii_xs)
    endif
end subroutine psgetdim_sii_xs

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_p2_dummy
     return
  end subroutine ccps_getset_p2_dummy

subroutine psget_picrf_nphi_srcs(iobj, n1, n2, n3, n4, data, ierr)
    !! direct ICRF power deposition, contribution from each n_phi
    !! on each antenna
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2, n3, n4 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2, n3, n4) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_picrf_nphi_srcs', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2, 1: n3, 1: n4) = ss % picrf_nphi_srcs
end subroutine psget_picrf_nphi_srcs


subroutine psset_picrf_nphi_srcs(iobj, n1, n2, n3, n4, data, ierr)
    !! direct ICRF power deposition, contribution from each n_phi
    !! on each antenna
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2, n3, n4 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2, n3, n4) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_picrf_nphi_srcs', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % picrf_nphi_srcs = data(1:n1, 1: n2, 1: n3, 1: n4)
end subroutine psset_picrf_nphi_srcs


subroutine psgetrnk_picrf_nphi_srcs(iobj, ndims, ierr)
    !! direct ICRF power deposition, contribution from each n_phi
    !! on each antenna
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 4
end subroutine psgetrnk_picrf_nphi_srcs


subroutine psgetdim_picrf_nphi_srcs(iobj, ndims, dims, ierr)
    !! direct ICRF power deposition, contribution from each n_phi
    !! on each antenna
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 4) ierr = 1
    call ccps_argcheck('psgetdim_picrf_nphi_srcs', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % picrf_nphi_srcs ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % picrf_nphi_srcs)
    endif
end subroutine psgetdim_picrf_nphi_srcs


subroutine psget_pbth(iobj, n1, data, ierr)
    !! thermalization of beam ions
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_pbth', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % pbth
end subroutine psget_pbth


subroutine psset_pbth(iobj, n1, data, ierr)
    !! thermalization of beam ions
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_pbth', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % pbth = data(1:n1)
end subroutine psset_pbth


subroutine psgetrnk_pbth(iobj, ndims, ierr)
    !! thermalization of beam ions
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_pbth


subroutine psgetdim_pbth(iobj, ndims, dims, ierr)
    !! thermalization of beam ions
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_pbth', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % pbth ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % pbth)
    endif
end subroutine psgetdim_pbth


subroutine psget_peech(iobj, n1, data, ierr)
    !! electron heating by ECH
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_peech', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % peech
end subroutine psget_peech


subroutine psset_peech(iobj, n1, data, ierr)
    !! electron heating by ECH
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_peech', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % peech = data(1:n1)
end subroutine psset_peech


subroutine psgetrnk_peech(iobj, ndims, ierr)
    !! electron heating by ECH
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_peech


subroutine psgetdim_peech(iobj, ndims, dims, ierr)
    !! electron heating by ECH
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_peech', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % peech ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % peech)
    endif
end subroutine psgetdim_peech


subroutine psget_phiflux_ky_tglf(iobj, n1, n2, data, ierr)
    !! momentum fluctuation spectrum
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_phiflux_ky_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % phiflux_ky_tglf
end subroutine psget_phiflux_ky_tglf


subroutine psset_phiflux_ky_tglf(iobj, n1, n2, data, ierr)
    !! momentum fluctuation spectrum
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_phiflux_ky_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % phiflux_ky_tglf = data(1:n1, 1: n2)
end subroutine psset_phiflux_ky_tglf


subroutine psgetrnk_phiflux_ky_tglf(iobj, ndims, ierr)
    !! momentum fluctuation spectrum
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_phiflux_ky_tglf


subroutine psgetdim_phiflux_ky_tglf(iobj, ndims, dims, ierr)
    !! momentum fluctuation spectrum
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_phiflux_ky_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % phiflux_ky_tglf ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % phiflux_ky_tglf)
    endif
end subroutine psgetdim_phiflux_ky_tglf

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_s0_dummy
     return
  end subroutine ccps_getset_s0_dummy

subroutine psget_s_type(iobj, n1, data, ierr)
    !! S specie types
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_s_type', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % S_type
end subroutine psget_s_type


subroutine psset_s_type(iobj, n1, data, ierr)
    !! S specie types
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_s_type', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % S_type = data(1:n1)
end subroutine psset_s_type


subroutine psgetrnk_s_type(iobj, ndims, ierr)
    !! S specie types
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_s_type


subroutine psgetdim_s_type(iobj, ndims, dims, ierr)
    !! S specie types
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_s_type', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % S_type ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % S_type)
    endif
end subroutine psgetdim_s_type


subroutine psget_snbi_name(iobj, n1, data, ierr)
    !! beam ion species, this species list to be constructed from
    !! nbion(1:nbeam), and augmented optionally by nbion_trace(1:nbeam)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    CHARACTER*(*), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_snbi_name', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % SNBI_name
end subroutine psget_snbi_name


subroutine psset_snbi_name(iobj, n1, data, ierr)
    !! beam ion species, this species list to be constructed from
    !! nbion(1:nbeam), and augmented optionally by nbion_trace(1:nbeam)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    CHARACTER*(*), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_snbi_name', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % SNBI_name = data(1:n1)
end subroutine psset_snbi_name


subroutine psgetsz_snbi_name(iobj, size, ierr)
    !! beam ion species, this species list to be constructed from
    !! nbion(1:nbeam), and augmented optionally by nbion_trace(1:nbeam)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: size    ! size of character string
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psgetsz_snbi_name', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! note that the following will return the character length size regardless of
    ! the number of array elements (if SNBI_name is an array)
    size = len(ss % SNBI_name)
end subroutine psgetsz_snbi_name


subroutine psgetrnk_snbi_name(iobj, ndims, ierr)
    !! beam ion species, this species list to be constructed from
    !! nbion(1:nbeam), and augmented optionally by nbion_trace(1:nbeam)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_snbi_name


subroutine psgetdim_snbi_name(iobj, ndims, dims, ierr)
    !! beam ion species, this species list to be constructed from
    !! nbion(1:nbeam), and augmented optionally by nbion_trace(1:nbeam)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_snbi_name', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % SNBI_name ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % SNBI_name)
    endif
end subroutine psgetdim_snbi_name


subroutine psget_sfus_to_alla(iobj, n1, data, ierr)
    !! map sfus index to "alla" list
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_sfus_to_alla', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % sfus_to_alla
end subroutine psget_sfus_to_alla


subroutine psset_sfus_to_alla(iobj, n1, data, ierr)
    !! map sfus index to "alla" list
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_sfus_to_alla', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % sfus_to_alla = data(1:n1)
end subroutine psset_sfus_to_alla


subroutine psgetrnk_sfus_to_alla(iobj, ndims, ierr)
    !! map sfus index to "alla" list
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_sfus_to_alla


subroutine psgetdim_sfus_to_alla(iobj, ndims, dims, ierr)
    !! map sfus index to "alla" list
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_sfus_to_alla', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % sfus_to_alla ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % sfus_to_alla)
    endif
end subroutine psgetdim_sfus_to_alla


subroutine psget_sb0halo(iobj, n1, n2, data, ierr)
    !! beam dep cx sink, thermal neutrals created by fast neutral
    !! deposition and/or recapture, of fast neutrals, psc_halo =~
    !! (3/2)*Ti*(sb0halo_recap-sb0halo)*1.602e-16
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_sb0halo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % sb0halo
end subroutine psget_sb0halo


subroutine psset_sb0halo(iobj, n1, n2, data, ierr)
    !! beam dep cx sink, thermal neutrals created by fast neutral
    !! deposition and/or recapture, of fast neutrals, psc_halo =~
    !! (3/2)*Ti*(sb0halo_recap-sb0halo)*1.602e-16
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_sb0halo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % sb0halo = data(1:n1, 1: n2)
end subroutine psset_sb0halo


subroutine psgetrnk_sb0halo(iobj, ndims, ierr)
    !! beam dep cx sink, thermal neutrals created by fast neutral
    !! deposition and/or recapture, of fast neutrals, psc_halo =~
    !! (3/2)*Ti*(sb0halo_recap-sb0halo)*1.602e-16
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_sb0halo


subroutine psgetdim_sb0halo(iobj, ndims, dims, ierr)
    !! beam dep cx sink, thermal neutrals created by fast neutral
    !! deposition and/or recapture, of fast neutrals, psc_halo =~
    !! (3/2)*Ti*(sb0halo_recap-sb0halo)*1.602e-16
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_sb0halo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % sb0halo ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % sb0halo)
    endif
end subroutine psgetdim_sb0halo


subroutine psget_s0reco(iobj, n1, n2, data, ierr)
    !! recombination neutral sce, psc_reco =~
    !! (3/2)*Ti*(s0reco_recap-s0reco)*1.602e-16, note: electron sink =
    !! sum (Z(i)*s0reco(:,i)), where Z(i) is the number of electrons
    !! carried by a neutral atom, of species (i).
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_s0reco', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % s0reco
end subroutine psget_s0reco


subroutine psset_s0reco(iobj, n1, n2, data, ierr)
    !! recombination neutral sce, psc_reco =~
    !! (3/2)*Ti*(s0reco_recap-s0reco)*1.602e-16, note: electron sink =
    !! sum (Z(i)*s0reco(:,i)), where Z(i) is the number of electrons
    !! carried by a neutral atom, of species (i).
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_s0reco', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % s0reco = data(1:n1, 1: n2)
end subroutine psset_s0reco


subroutine psgetrnk_s0reco(iobj, ndims, ierr)
    !! recombination neutral sce, psc_reco =~
    !! (3/2)*Ti*(s0reco_recap-s0reco)*1.602e-16, note: electron sink =
    !! sum (Z(i)*s0reco(:,i)), where Z(i) is the number of electrons
    !! carried by a neutral atom, of species (i).
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_s0reco


subroutine psgetdim_s0reco(iobj, ndims, dims, ierr)
    !! recombination neutral sce, psc_reco =~
    !! (3/2)*Ti*(s0reco_recap-s0reco)*1.602e-16, note: electron sink =
    !! sum (Z(i)*s0reco(:,i)), where Z(i) is the number of electrons
    !! carried by a neutral atom, of species (i).
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_s0reco', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % s0reco ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % s0reco)
    endif
end subroutine psgetdim_s0reco

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_n8_dummy
     return
  end subroutine ccps_getset_n8_dummy

subroutine psget_nbi_data_info(iobj, data, ierr)
    !! information on source of beam power & voltage data
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    CHARACTER*(*), intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_nbi_data_info', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % NBI_Data_Info
end subroutine psget_nbi_data_info


subroutine psset_nbi_data_info(iobj, data, ierr)
    !! information on source of beam power & voltage data
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    CHARACTER*(*), intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_nbi_data_info', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % NBI_Data_Info = data
end subroutine psset_nbi_data_info


subroutine psgetsz_nbi_data_info(iobj, size, ierr)
    !! information on source of beam power & voltage data
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: size    ! size of character string
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psgetsz_nbi_data_info', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! note that the following will return the character length size regardless of
    ! the number of array elements (if NBI_Data_Info is an array)
    size = len(ss % NBI_Data_Info)
end subroutine psgetsz_nbi_data_info


subroutine psget_nrho_eq_geo(iobj, data, ierr)
    !! grid dimension of rho_eq_geo (RHO coordinate)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_nrho_eq_geo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % nrho_eq_geo
end subroutine psget_nrho_eq_geo


subroutine psset_nrho_eq_geo(iobj, data, ierr)
    !! grid dimension of rho_eq_geo (RHO coordinate)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_nrho_eq_geo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % nrho_eq_geo = data
end subroutine psset_nrho_eq_geo


subroutine psget_newcomb_mapper(iobj, n1, data, ierr)
    !! mapper code used for each Newcomb code
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    CHARACTER*(*), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_newcomb_mapper', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % Newcomb_mapper
end subroutine psget_newcomb_mapper


subroutine psset_newcomb_mapper(iobj, n1, data, ierr)
    !! mapper code used for each Newcomb code
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    CHARACTER*(*), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_newcomb_mapper', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % Newcomb_mapper = data(1:n1)
end subroutine psset_newcomb_mapper


subroutine psgetsz_newcomb_mapper(iobj, size, ierr)
    !! mapper code used for each Newcomb code
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: size    ! size of character string
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psgetsz_newcomb_mapper', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! note that the following will return the character length size regardless of
    ! the number of array elements (if Newcomb_mapper is an array)
    size = len(ss % Newcomb_mapper)
end subroutine psgetsz_newcomb_mapper


subroutine psgetrnk_newcomb_mapper(iobj, ndims, ierr)
    !! mapper code used for each Newcomb code
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_newcomb_mapper


subroutine psgetdim_newcomb_mapper(iobj, ndims, dims, ierr)
    !! mapper code used for each Newcomb code
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_newcomb_mapper', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % Newcomb_mapper ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % Newcomb_mapper)
    endif
end subroutine psgetdim_newcomb_mapper


subroutine psget_nrho_anom(iobj, data, ierr)
    !! grid dimension of rho_anom (RHO coordinate)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_nrho_anom', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % nrho_anom
end subroutine psget_nrho_anom


subroutine psset_nrho_anom(iobj, data, ierr)
    !! grid dimension of rho_anom (RHO coordinate)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_nrho_anom', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % nrho_anom = data
end subroutine psset_nrho_anom


subroutine psget_ngradb2_av(iobj, n1, data, ierr)
    !! <(B.grad(B)/|B|)^2>, average of square of grad(B) along
    !! field line
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_ngradb2_av', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % ngradb2_av
end subroutine psget_ngradb2_av


subroutine psset_ngradb2_av(iobj, n1, data, ierr)
    !! <(B.grad(B)/|B|)^2>, average of square of grad(B) along
    !! field line
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_ngradb2_av', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % ngradb2_av = data(1:n1)
end subroutine psset_ngradb2_av


subroutine psgetrnk_ngradb2_av(iobj, ndims, ierr)
    !! <(B.grad(B)/|B|)^2>, average of square of grad(B) along
    !! field line
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_ngradb2_av


subroutine psgetdim_ngradb2_av(iobj, ndims, dims, ierr)
    !! <(B.grad(B)/|B|)^2>, average of square of grad(B) along
    !! field line
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_ngradb2_av', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % ngradb2_av ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % ngradb2_av)
    endif
end subroutine psgetdim_ngradb2_av

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


SUBROUTINE plasma_state_copy_9(cclist,ss,ss2,icopy_lists,iwant_1deq,partial_copy,ierr)


  ! Copy scalars, and, arrays that are allocated
  !   ss2 <-- ss

  USE plasma_state_definition_mod
  IMPLICIT NONE

  INTEGER, INTENT(IN) :: cclist(ps_ccount)
                                ! list of components to merge
                                ! use ps_cc_all to merge all components

  TYPE (plasma_state) :: ss     ! state data to copy *from*
  TYPE (plasma_state) :: ss2    ! state data to copy *to*

  INTEGER, INTENT(IN) :: icopy_lists ! =1 to require copying of all lists

  INTEGER, INTENT(IN) :: iwant_1deq  ! =1 to request fcns of (rho_eq)
                                     !  even if cclist(ps_cnum_EQ).eq.0

  LOGICAL, INTENT(IN) :: partial_copy ! .TRUE. if full state copy not in effect

  INTEGER, INTENT(INOUT) :: ierr  ! completion flag (not cleared, set by error)

  !-------------------
  INTEGER :: iout
  !-------------------

  iout = SWIM_err_out_file


  !-----------------------------------------------
  ! copy scalars and arrays that are allocated...
  IF(partial_copy) THEN
     ss2%id_velte_mmm71 = 0
  ENDIF
  IF((ALLOCATED(ss%velte_mmm71).AND.ALLOCATED(ss2%velte_mmm71)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%velte_mmm71 = ss%velte_mmm71
     IF(.not.partial_copy) THEN
        ss2%id_velte_mmm71 = ss%id_velte_mmm71
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_velte_nclass = 0
  ENDIF
  IF((ALLOCATED(ss%velte_nclass).AND.ALLOCATED(ss2%velte_nclass)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%velte_nclass = ss%velte_nclass
     IF(.not.partial_copy) THEN
        ss2%id_velte_nclass = ss%id_velte_nclass
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_velte_neo = 0
  ENDIF
  IF((ALLOCATED(ss%velte_neo).AND.ALLOCATED(ss2%velte_neo)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%velte_neo = ss%velte_neo
     IF(.not.partial_copy) THEN
        ss2%id_velte_neo = ss%id_velte_neo
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_velte_paleo = 0
  ENDIF
  IF((ALLOCATED(ss%velte_paleo).AND.ALLOCATED(ss2%velte_paleo)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%velte_paleo = ss%velte_paleo
     IF(.not.partial_copy) THEN
        ss2%id_velte_paleo = ss%id_velte_paleo
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_velte_tglf = 0
  ENDIF
  IF((ALLOCATED(ss%velte_tglf).AND.ALLOCATED(ss2%velte_tglf)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%velte_tglf = ss%velte_tglf
     IF(.not.partial_copy) THEN
        ss2%id_velte_tglf = ss%id_velte_tglf
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_velti_anom = 0
  ENDIF
  IF((ALLOCATED(ss%velti_anom).AND.ALLOCATED(ss2%velti_anom)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%velti_anom = ss%velti_anom
     IF(.not.partial_copy) THEN
        ss2%id_velti_anom = ss%id_velti_anom
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_velti_glf = 0
  ENDIF
  IF((ALLOCATED(ss%velti_glf).AND.ALLOCATED(ss2%velti_glf)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%velti_glf = ss%velti_glf
     IF(.not.partial_copy) THEN
        ss2%id_velti_glf = ss%id_velti_glf
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_velti_gtcneo = 0
  ENDIF
  IF((ALLOCATED(ss%velti_gtcneo).AND.ALLOCATED(ss2%velti_gtcneo)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%velti_gtcneo = ss%velti_gtcneo
     IF(.not.partial_copy) THEN
        ss2%id_velti_gtcneo = ss%id_velti_gtcneo
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_velti_mmm71 = 0
  ENDIF
  IF((ALLOCATED(ss%velti_mmm71).AND.ALLOCATED(ss2%velti_mmm71)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%velti_mmm71 = ss%velti_mmm71
     IF(.not.partial_copy) THEN
        ss2%id_velti_mmm71 = ss%id_velti_mmm71
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_velti_nclass = 0
  ENDIF
  IF((ALLOCATED(ss%velti_nclass).AND.ALLOCATED(ss2%velti_nclass)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%velti_nclass = ss%velti_nclass
     IF(.not.partial_copy) THEN
        ss2%id_velti_nclass = ss%id_velti_nclass
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_velti_neo = 0
  ENDIF
  IF((ALLOCATED(ss%velti_neo).AND.ALLOCATED(ss2%velti_neo)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%velti_neo = ss%velti_neo
     IF(.not.partial_copy) THEN
        ss2%id_velti_neo = ss%id_velti_neo
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_velti_tglf = 0
  ENDIF
  IF((ALLOCATED(ss%velti_tglf).AND.ALLOCATED(ss2%velti_tglf)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%velti_tglf = ss%velti_tglf
     IF(.not.partial_copy) THEN
        ss2%id_velti_tglf = ss%id_velti_tglf
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_vie_trans = 0
  ENDIF
  IF((ALLOCATED(ss%vie_trans).AND.ALLOCATED(ss2%vie_trans)).AND. &
        ((cclist(ps_cnum_PLASMA).EQ.1))) THEN
     ss2%vie_trans = ss%vie_trans
     IF(.not.partial_copy) THEN
        ss2%id_vie_trans = ss%id_vie_trans
     ENDIF
  ENDIF
  IF(ALLOCATED(ss2%id_vie_transcat)) THEN
     IF(partial_copy) THEN
        ss2%id_vie_transcat = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%vie_transcat).AND.ALLOCATED(ss2%vie_transcat)).AND. &
        ((cclist(ps_cnum_PLASMA).EQ.1))) THEN
     ss2%vie_transcat = ss%vie_transcat
     IF(ALLOCATED(ss2%id_vie_transcat)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_vie_transcat = ss%id_vie_transcat
        ENDIF
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_vmo_trans = 0
  ENDIF
  IF((ALLOCATED(ss%vmo_trans).AND.ALLOCATED(ss2%vmo_trans)).AND. &
        ((cclist(ps_cnum_PLASMA).EQ.1))) THEN
     ss2%vmo_trans = ss%vmo_trans
     IF(.not.partial_copy) THEN
        ss2%id_vmo_trans = ss%id_vmo_trans
     ENDIF
  ENDIF
  IF(ALLOCATED(ss2%id_vmo_transcat)) THEN
     IF(partial_copy) THEN
        ss2%id_vmo_transcat = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%vmo_transcat).AND.ALLOCATED(ss2%vmo_transcat)).AND. &
        ((cclist(ps_cnum_PLASMA).EQ.1))) THEN
     ss2%vmo_transcat = ss%vmo_transcat
     IF(ALLOCATED(ss2%id_vmo_transcat)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_vmo_transcat = ss%id_vmo_transcat
        ENDIF
     ENDIF
  ENDIF
  IF(ALLOCATED(ss2%id_vn_trans)) THEN
     IF(partial_copy) THEN
        ss2%id_vn_trans = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%vn_trans).AND.ALLOCATED(ss2%vn_trans)).AND. &
        ((cclist(ps_cnum_PLASMA).EQ.1))) THEN
     ss2%vn_trans = ss%vn_trans
     IF(ALLOCATED(ss2%id_vn_trans)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_vn_trans = ss%id_vn_trans
        ENDIF
     ENDIF
  ENDIF
  IF(ALLOCATED(ss2%id_vn_transcat)) THEN
     IF(partial_copy) THEN
        ss2%id_vn_transcat = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%vn_transcat).AND.ALLOCATED(ss2%vn_transcat)).AND. &
        ((cclist(ps_cnum_PLASMA).EQ.1))) THEN
     ss2%vn_transcat = ss%vn_transcat
     IF(ALLOCATED(ss2%id_vn_transcat)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_vn_transcat = ss%id_vn_transcat
        ENDIF
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_vol = 0
  ENDIF
  IF((ALLOCATED(ss%vol).AND.ALLOCATED(ss2%vol)).AND. &
        ((cclist(ps_cnum_EQ).EQ.1).OR.(iwant_1deq.eq.1))) THEN
     ss2%vol = ss%vol
     IF(.not.partial_copy) THEN
        ss2%id_vol = ss%id_vol
     ENDIF
  ENDIF
  IF( ((ALLOCATED(ss2%vphi0_av)).AND.(ALLOCATED(ss%vphi0_av))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_GAS).EQ.1)) ) THEN
     ss2%vphi0_av = ss%vphi0_av
  ENDIF
  IF((cclist(ps_cnum_PLASMA).EQ.1).OR.(icopy_lists.EQ.1)) THEN
     ss2%vpol_Data_Info = ss%vpol_Data_Info
  ENDIF
  IF(ALLOCATED(ss2%id_vpol_inmp)) THEN
     IF(partial_copy) THEN
        ss2%id_vpol_inmp = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%vpol_inmp).AND.ALLOCATED(ss2%vpol_inmp)).AND. &
        ((cclist(ps_cnum_PLASMA).EQ.1))) THEN
     ss2%vpol_inmp = ss%vpol_inmp
     IF(ALLOCATED(ss2%id_vpol_inmp)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_vpol_inmp = ss%id_vpol_inmp
        ENDIF
     ENDIF
  ENDIF
  IF( ((ALLOCATED(ss2%vpol_is_input)).AND.(ALLOCATED(ss%vpol_is_input))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_PLASMA).EQ.1)) ) THEN
     ss2%vpol_is_input = ss%vpol_is_input
  ENDIF
  IF(ALLOCATED(ss2%id_vpol_omp)) THEN
     IF(partial_copy) THEN
        ss2%id_vpol_omp = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%vpol_omp).AND.ALLOCATED(ss2%vpol_omp)).AND. &
        ((cclist(ps_cnum_PLASMA).EQ.1))) THEN
     ss2%vpol_omp = ss%vpol_omp
     IF(ALLOCATED(ss2%id_vpol_omp)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_vpol_omp = ss%id_vpol_omp
        ENDIF
     ENDIF
  ENDIF
  IF( ((ALLOCATED(ss2%VRep_coil_count)).AND.(ALLOCATED(ss%VRep_coil_count))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_EQ).EQ.1)) ) THEN
     ss2%VRep_coil_count = ss%VRep_coil_count
  ENDIF
  IF( ((ALLOCATED(ss2%Vrep_coil_spacing)).AND.(ALLOCATED(ss%Vrep_coil_spacing))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_EQ).EQ.1)) ) THEN
     ss2%Vrep_coil_spacing = ss%Vrep_coil_spacing
  ENDIF
  IF( ((ALLOCATED(ss2%Vsize_coil)).AND.(ALLOCATED(ss%Vsize_coil))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_EQ).EQ.1)) ) THEN
     ss2%Vsize_coil = ss%Vsize_coil
  ENDIF
  IF((cclist(ps_cnum_PLASMA).EQ.1).OR.(icopy_lists.EQ.1)) THEN
     ss2%vsur = ss%vsur
  ENDIF
  IF((cclist(ps_cnum_PLASMA).EQ.1).OR.(icopy_lists.EQ.1)) THEN
     ss2%VSUR_Data_Info = ss%VSUR_Data_Info
  ENDIF
  IF((cclist(ps_cnum_PLASMA).EQ.1).OR.(icopy_lists.EQ.1)) THEN
     ss2%vtor_Data_Info = ss%vtor_Data_Info
  ENDIF
  IF(ALLOCATED(ss2%id_vtor_inmp)) THEN
     IF(partial_copy) THEN
        ss2%id_vtor_inmp = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%vtor_inmp).AND.ALLOCATED(ss2%vtor_inmp)).AND. &
        ((cclist(ps_cnum_PLASMA).EQ.1))) THEN
     ss2%vtor_inmp = ss%vtor_inmp
     IF(ALLOCATED(ss2%id_vtor_inmp)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_vtor_inmp = ss%id_vtor_inmp
        ENDIF
     ENDIF
  ENDIF
  IF( ((ALLOCATED(ss2%vtor_is_input)).AND.(ALLOCATED(ss%vtor_is_input))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_PLASMA).EQ.1)) ) THEN
     ss2%vtor_is_input = ss%vtor_is_input
  ENDIF
  IF(ALLOCATED(ss2%id_vtor_omp)) THEN
     IF(partial_copy) THEN
        ss2%id_vtor_omp = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%vtor_omp).AND.ALLOCATED(ss2%vtor_omp)).AND. &
        ((cclist(ps_cnum_PLASMA).EQ.1))) THEN
     ss2%vtor_omp = ss%vtor_omp
     IF(ALLOCATED(ss2%id_vtor_omp)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_vtor_omp = ss%id_vtor_omp
        ENDIF
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_V_loop = 0
  ENDIF
  IF((ALLOCATED(ss%V_loop).AND.ALLOCATED(ss2%V_loop)).AND. &
        ((cclist(ps_cnum_PLASMA).EQ.1))) THEN
     ss2%V_loop = ss%V_loop
     IF(.not.partial_copy) THEN
        ss2%id_V_loop = ss%id_V_loop
     ENDIF
  ENDIF
  IF(ALLOCATED(ss2%id_v_pars)) THEN
     IF(partial_copy) THEN
        ss2%id_v_pars = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%v_pars).AND.ALLOCATED(ss2%v_pars)).AND. &
        ((cclist(ps_cnum_PLASMA).EQ.1))) THEN
     ss2%v_pars = ss%v_pars
     IF(ALLOCATED(ss2%id_v_pars)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_v_pars = ss%id_v_pars
        ENDIF
     ENDIF
  ENDIF
  IF(ALLOCATED(ss2%id_v_pers)) THEN
     IF(partial_copy) THEN
        ss2%id_v_pers = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%v_pers).AND.ALLOCATED(ss2%v_pers)).AND. &
        ((cclist(ps_cnum_PLASMA).EQ.1))) THEN
     ss2%v_pers = ss%v_pers
     IF(ALLOCATED(ss2%id_v_pers)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_v_pers = ss%id_v_pers
        ENDIF
     ENDIF
  ENDIF
  IF( ((ALLOCATED(ss2%wt_nphi)).AND.(ALLOCATED(ss%wt_nphi))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_IC).EQ.1)) ) THEN
     ss2%wt_nphi = ss%wt_nphi
  ENDIF
  IF( ((ALLOCATED(ss2%wt_nphi_abs)).AND.(ALLOCATED(ss%wt_nphi_abs))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_IC).EQ.1)) ) THEN
     ss2%wt_nphi_abs = ss%wt_nphi_abs
  ENDIF
  IF( ((ALLOCATED(ss2%wt_nphi_ext)).AND.(ALLOCATED(ss%wt_nphi_ext))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_IC).EQ.1)) ) THEN
     ss2%wt_nphi_ext = ss%wt_nphi_ext
  ENDIF
  IF(ALLOCATED(ss2%id_xRjcos_momeq)) THEN
     IF(partial_copy) THEN
        ss2%id_xRjcos_momeq = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%xRjcos_momeq).AND.ALLOCATED(ss2%xRjcos_momeq)).AND. &
        ((cclist(ps_cnum_EQ).EQ.1))) THEN
     ss2%xRjcos_momeq = ss%xRjcos_momeq
     IF(ALLOCATED(ss2%id_xRjcos_momeq)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_xRjcos_momeq = ss%id_xRjcos_momeq
        ENDIF
     ENDIF
  ENDIF
  IF(ALLOCATED(ss2%id_xRjsin_momeq)) THEN
     IF(partial_copy) THEN
        ss2%id_xRjsin_momeq = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%xRjsin_momeq).AND.ALLOCATED(ss2%xRjsin_momeq)).AND. &
        ((cclist(ps_cnum_EQ).EQ.1))) THEN
     ss2%xRjsin_momeq = ss%xRjsin_momeq
     IF(ALLOCATED(ss2%id_xRjsin_momeq)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_xRjsin_momeq = ss%id_xRjsin_momeq
        ENDIF
     ENDIF
  ENDIF
  IF( ((ALLOCATED(ss2%xs)).AND.(ALLOCATED(ss%xs))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_RAD).EQ.1)) ) THEN
     ss2%xs = ss%xs
  ENDIF
  IF( ((ALLOCATED(ss2%xs_name)).AND.(ALLOCATED(ss%xs_name))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_RAD).EQ.1)) ) THEN
     ss2%xs_name = ss%xs_name
  ENDIF
  IF(ALLOCATED(ss2%id_xZjcos_momeq)) THEN
     IF(partial_copy) THEN
        ss2%id_xZjcos_momeq = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%xZjcos_momeq).AND.ALLOCATED(ss2%xZjcos_momeq)).AND. &
        ((cclist(ps_cnum_EQ).EQ.1))) THEN
     ss2%xZjcos_momeq = ss%xZjcos_momeq
     IF(ALLOCATED(ss2%id_xZjcos_momeq)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_xZjcos_momeq = ss%id_xZjcos_momeq
        ENDIF
     ENDIF
  ENDIF
  IF(ALLOCATED(ss2%id_xZjsin_momeq)) THEN
     IF(partial_copy) THEN
        ss2%id_xZjsin_momeq = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%xZjsin_momeq).AND.ALLOCATED(ss2%xZjsin_momeq)).AND. &
        ((cclist(ps_cnum_EQ).EQ.1))) THEN
     ss2%xZjsin_momeq = ss%xZjsin_momeq
     IF(ALLOCATED(ss2%id_xZjsin_momeq)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_xZjsin_momeq = ss%id_xZjsin_momeq
        ENDIF
     ENDIF
  ENDIF
  ss2%Z0max = ss%Z0max
  IF(partial_copy) THEN
     ss2%id_Z0_momeq = 0
  ENDIF
  IF((ALLOCATED(ss%Z0_momeq).AND.ALLOCATED(ss2%Z0_momeq)).AND. &
        ((cclist(ps_cnum_EQ).EQ.1).OR.(iwant_1deq.eq.1))) THEN
     ss2%Z0_momeq = ss%Z0_momeq
     IF(.not.partial_copy) THEN
        ss2%id_Z0_momeq = ss%id_Z0_momeq
     ENDIF
  ENDIF
  IF( ((ALLOCATED(ss2%Zbap)).AND.(ALLOCATED(ss%Zbap))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_NBI).EQ.1)) ) THEN
     ss2%Zbap = ss%Zbap
  ENDIF
  IF( ((ALLOCATED(ss2%Zbsc)).AND.(ALLOCATED(ss%Zbsc))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_NBI).EQ.1)) ) THEN
     ss2%Zbsc = ss%Zbsc
  ENDIF
  IF(partial_copy) THEN
     ss2%id_Zeff = 0
  ENDIF
  IF((ALLOCATED(ss%Zeff).AND.ALLOCATED(ss2%Zeff)).AND. &
        ((cclist(ps_cnum_PLASMA).EQ.1))) THEN
     ss2%Zeff = ss%Zeff
     IF(.not.partial_copy) THEN
        ss2%id_Zeff = ss%id_Zeff
     ENDIF
  ENDIF
  IF((cclist(ps_cnum_PLASMA).EQ.1).OR.(icopy_lists.EQ.1)) THEN
     ss2%ZEFF_Data_Info = ss%ZEFF_Data_Info
  ENDIF
  IF(partial_copy) THEN
     ss2%id_Zeff_fi = 0
  ENDIF
  IF((ALLOCATED(ss%Zeff_fi).AND.ALLOCATED(ss2%Zeff_fi)).AND. &
        ((cclist(ps_cnum_PLASMA).EQ.1))) THEN
     ss2%Zeff_fi = ss%Zeff_fi
     IF(.not.partial_copy) THEN
        ss2%id_Zeff_fi = ss%id_Zeff_fi
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_Zeff_th = 0
  ENDIF
  IF((ALLOCATED(ss%Zeff_th).AND.ALLOCATED(ss2%Zeff_th)).AND. &
        ((cclist(ps_cnum_PLASMA).EQ.1))) THEN
     ss2%Zeff_th = ss%Zeff_th
     IF(.not.partial_copy) THEN
        ss2%id_Zeff_th = ss%id_Zeff_th
     ENDIF
  ENDIF
  ss2%Zimp1 = ss%Zimp1
  ss2%Zimp2 = ss%Zimp2
  IF( ((ALLOCATED(ss2%zlim)).AND.(ALLOCATED(ss%zlim))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_EQ).EQ.1)) ) THEN
     ss2%zlim = ss%zlim
  ENDIF
  IF( ((ALLOCATED(ss2%Zloc_coil)).AND.(ALLOCATED(ss%Zloc_coil))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_EQ).EQ.1)) ) THEN
     ss2%Zloc_coil = ss%Zloc_coil
  ENDIF
  IF( ((ALLOCATED(ss2%Z_ant)).AND.(ALLOCATED(ss%Z_ant))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_IC).EQ.1)) ) THEN
     ss2%Z_ant = ss%Z_ant
  ENDIF
  IF( ((ALLOCATED(ss2%Z_antgeo)).AND.(ALLOCATED(ss%Z_antgeo))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_IC).EQ.1)) ) THEN
     ss2%Z_antgeo = ss%Z_antgeo
  ENDIF
  IF((cclist(ps_cnum_EQ).EQ.1).OR.(icopy_lists.EQ.1)) THEN
     ss2%Z_axis = ss%Z_axis
  ENDIF
  IF( ((ALLOCATED(ss2%Z_EC_launch)).AND.(ALLOCATED(ss%Z_EC_launch))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_EC).EQ.1)) ) THEN
     ss2%Z_EC_launch = ss%Z_EC_launch
  ENDIF
  IF(partial_copy) THEN
     ss2%id_Z_geo = 0
  ENDIF
  IF((ALLOCATED(ss%Z_geo).AND.ALLOCATED(ss2%Z_geo)).AND. &
        ((cclist(ps_cnum_EQ).EQ.1))) THEN
     ss2%Z_geo = ss%Z_geo
     IF(.not.partial_copy) THEN
        ss2%id_Z_geo = ss%id_Z_geo
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%Z_grid).AND.ALLOCATED(ss2%Z_grid)).AND. &
        ((cclist(ps_cnum_EQ).EQ.1))) THEN
     ss2%Z_grid = ss%Z_grid
  ENDIF
  IF((cclist(ps_cnum_EQ).EQ.1).OR.(icopy_lists.EQ.1)) THEN
     ss2%Z_max_box = ss%Z_max_box
  ENDIF
  IF((cclist(ps_cnum_EQ).EQ.1).OR.(icopy_lists.EQ.1)) THEN
     ss2%Z_max_lcfs = ss%Z_max_lcfs
  ENDIF
  IF(partial_copy) THEN
     ss2%id_Z_midp = 0
  ENDIF
  IF((ALLOCATED(ss%Z_midp).AND.ALLOCATED(ss2%Z_midp)).AND. &
        ((cclist(ps_cnum_EQ).EQ.1))) THEN
     ss2%Z_midp = ss%Z_midp
     IF(.not.partial_copy) THEN
        ss2%id_Z_midp = ss%id_Z_midp
     ENDIF
  ENDIF
  IF( ((ALLOCATED(ss2%Z_mid_ant)).AND.(ALLOCATED(ss%Z_mid_ant))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_IC).EQ.1)) ) THEN
     ss2%Z_mid_ant = ss%Z_mid_ant
  ENDIF
  IF((cclist(ps_cnum_EQ).EQ.1).OR.(icopy_lists.EQ.1)) THEN
     ss2%Z_min_box = ss%Z_min_box
  ENDIF
  IF((cclist(ps_cnum_EQ).EQ.1).OR.(icopy_lists.EQ.1)) THEN
     ss2%Z_min_lcfs = ss%Z_min_lcfs
  ENDIF
  IF((ALLOCATED(ss%Z_ripple).AND.ALLOCATED(ss2%Z_ripple)).AND. &
        ((cclist(ps_cnum_RIPPLE).EQ.1))) THEN
     ss2%Z_ripple = ss%Z_ripple
  ENDIF
  IF(partial_copy) THEN
     ss2%id_Z_surfMax = 0
  ENDIF
  IF((ALLOCATED(ss%Z_surfMax).AND.ALLOCATED(ss2%Z_surfMax)).AND. &
        ((cclist(ps_cnum_EQ).EQ.1))) THEN
     ss2%Z_surfMax = ss%Z_surfMax
     IF(.not.partial_copy) THEN
        ss2%id_Z_surfMax = ss%id_Z_surfMax
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_Z_surfMin = 0
  ENDIF
  IF((ALLOCATED(ss%Z_surfMin).AND.ALLOCATED(ss2%Z_surfMin)).AND. &
        ((cclist(ps_cnum_EQ).EQ.1))) THEN
     ss2%Z_surfMin = ss%Z_surfMin
     IF(.not.partial_copy) THEN
        ss2%id_Z_surfMin = ss%id_Z_surfMin
     ENDIF
  ENDIF

END SUBROUTINE plasma_state_copy_9

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


SUBROUTINE ps_update_file_read(filename,ss,ierr)

  ! get (i.e. read from file) plasma state updates
  ! apply updates to state (ss)

  USE plasma_state_definition_mod
  USE plasma_hash_code
  USE netcdf
  IMPLICIT NONE

  CHARACTER*(*), INTENT(IN) :: filename        ! file containing updates
  TYPE (plasma_state) :: ss     ! state to be updated
  INTEGER, INTENT(OUT) :: ierr  ! completion code (0=OK)

  !--------------

  INTEGER :: icdf,iout,varid,dimid,status,iertot
  INTEGER :: ival,jval,icount,iucount,ii
  INTEGER :: prehash1,prehash2
  INTEGER :: posthash1,posthash2
  CHARACTER*80 :: nc_errmsg
  LOGICAL :: izero

  !--------------
  ! Initialization...

  iout = SWIM_err_out_file

  iertot = 0

  iucount = 0

  ! ********* OPEN the NetCDF file **********

  status = nf90_open(trim(filename),NF90_NOWRITE,icdf)
  IF(status.NE.NF90_NOERR) THEN
     CALL ncerr(status)
     WRITE(iout,*) ' ?ps_update_file_read: file open failure: "'//trim(filename)//'".'
     ierr=9999
     RETURN
  ENDIF

  ! ********* READ header information
  ! ...check for version_id mismatch

  status = nf90_inq_varid(icdf,"ps_partial_update",varid)
  if(status.NE.NF90_NOERR) THEN
     WRITE(iout,*) ' ?ps_update_file_read: did not find: "ps_partial_update"!'
     WRITE(iout,*) '  This routine can only read state update files, which'
     WRITE(iout,*) '  must contain this marker variable.'
     ierr=9999
     status = nf90_close(icdf)
     RETURN
  ENDIF

  status = nf90_inq_varid(icdf,"version_id",varid)
  IF(status.NE.NF90_NOERR) THEN
     CALL ncerr(status)
     WRITE(iout,*) ' ?ps_update_file_read: "version_id" not found.'
     ierr=9999
     status = nf90_close(icdf)
     RETURN
  ENDIF

  status = nf90_get_var(icdf,varid,ss%version_id)
  IF(status.NE.NF90_NOERR) THEN
     CALL ncerr(status)
     WRITE(iout,*) ' ?ps_update_file_read: "version_id" read error.'
     ierr=9999
     status = nf90_close(icdf)
     RETURN
  ENDIF
  CALL denull(ss%version_id)

  IF(ss%version_id.NE.ps_version_id) THEN
     WRITE(iout,*) ' %ps_update_file_read: warning: version_id mismatch:'
     WRITE(iout,*) '  Version_ID of current software: "'//trim(ps_version_id)//'".'
     WRITE(iout,*) '  Version_ID found in file:       "'//trim(ss%version_id)//'".'
     WRITE(iout,*) '  (...recovery attempt in progress...)'
  ENDIF

  !--------------------------------------------------------------

  ! *** Array Dimensions ***
  icount = 0
  iertot = 0

  status = nf90_inq_dimid(icdf,"dim_max_nrz_antgeo",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ival)
     IF(ss%max_nrz_antgeo.EQ.0) THEN
        ss%max_nrz_antgeo = ival
        icount = icount + 1
     ENDIF
     jval = ss%max_nrz_antgeo
     CALL ichk_dim(ival,jval,"max_nrz_antgeo")
  ENDIF

  status = nf90_inq_dimid(icdf,"dim_max_nspectrumlh_src",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ival)
     IF(ss%max_nspectrumlh_src.EQ.0) THEN
        ss%max_nspectrumlh_src = ival
        icount = icount + 1
     ENDIF
     jval = ss%max_nspectrumlh_src
     CALL ichk_dim(ival,jval,"max_nspectrumlh_src")
  ENDIF

  status = nf90_inq_dimid(icdf,"dim_max_num_nphi",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ival)
     IF(ss%max_num_nphi.EQ.0) THEN
        ss%max_num_nphi = ival
        icount = icount + 1
     ENDIF
     jval = ss%max_num_nphi
     CALL ichk_dim(ival,jval,"max_num_nphi")
  ENDIF

  status = nf90_inq_dimid(icdf,"dim_max_num_nphi_vac",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ival)
     IF(ss%max_num_nphi_vac.EQ.0) THEN
        ss%max_num_nphi_vac = ival
        icount = icount + 1
     ENDIF
     jval = ss%max_num_nphi_vac
     CALL ichk_dim(ival,jval,"max_num_nphi_vac")
  ENDIF

  status = nf90_inq_dimid(icdf,"dim_max_n_straps",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ival)
     IF(ss%max_n_straps.EQ.0) THEN
        ss%max_n_straps = ival
        icount = icount + 1
     ENDIF
     jval = ss%max_n_straps
     CALL ichk_dim(ival,jval,"max_n_straps")
  ENDIF

  status = nf90_inq_dimid(icdf,"dim_mmodes",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ival)
     IF(ss%mmodes.EQ.0) THEN
        ss%mmodes = ival
        icount = icount + 1
     ENDIF
     jval = ss%mmodes
     CALL ichk_dim(ival,jval,"mmodes")
  ENDIF

  status = nf90_inq_dimid(icdf,"dim_nballoon",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ival)
     IF(ss%nballoon.EQ.0) THEN
        ss%nballoon = ival
        icount = icount + 1
     ENDIF
     jval = ss%nballoon
     CALL ichk_dim(ival,jval,"nballoon")
  ENDIF

  status = nf90_inq_dimid(icdf,"dim_nbeam",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ival)
     IF(ss%nbeam.EQ.0) THEN
        ss%nbeam = ival
        icount = icount + 1
     ENDIF
     jval = ss%nbeam
     CALL ichk_dim(ival,jval,"nbeam")
  ENDIF

  status = nf90_inq_dimid(icdf,"dim_ncircuits",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ival)
     IF(ss%ncircuits.EQ.0) THEN
        ss%ncircuits = ival
        icount = icount + 1
     ENDIF
     jval = ss%ncircuits
     CALL ichk_dim(ival,jval,"ncircuits")
  ENDIF

  status = nf90_inq_dimid(icdf,"dim_ncoils",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ival)
     IF(ss%ncoils.EQ.0) THEN
        ss%ncoils = ival
        icount = icount + 1
     ENDIF
     jval = ss%ncoils
     CALL ichk_dim(ival,jval,"ncoils")
  ENDIF

  status = nf90_inq_dimid(icdf,"dim_ndelta_w",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ival)
     IF(ss%ndelta_w.EQ.0) THEN
        ss%ndelta_w = ival
        icount = icount + 1
     ENDIF
     jval = ss%ndelta_w
     CALL ichk_dim(ival,jval,"ndelta_w")
  ENDIF

  status = nf90_inq_dimid(icdf,"dim_necrf_src",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ival)
     IF(ss%necrf_src.EQ.0) THEN
        ss%necrf_src = ival
        icount = icount + 1
     ENDIF
     jval = ss%necrf_src
     CALL ichk_dim(ival,jval,"necrf_src")
  ENDIF

  status = nf90_inq_dimid(icdf,"dim_nefi_anom",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ival)
     IF(ss%nefi_anom.EQ.0) THEN
        ss%nefi_anom = ival
        icount = icount + 1
     ENDIF
     jval = ss%nefi_anom
     CALL ichk_dim(ival,jval,"nefi_anom")
  ENDIF

  status = nf90_inq_dimid(icdf,"dim_nefi_anom2",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ival)
     IF(ss%nefi_anom2.EQ.0) THEN
        ss%nefi_anom2 = ival
        icount = icount + 1
     ENDIF
     jval = ss%nefi_anom2
     CALL ichk_dim(ival,jval,"nefi_anom2")
  ENDIF

  status = nf90_inq_dimid(icdf,"dim_neqmom",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ival)
     IF(ss%neqmom.EQ.0) THEN
        ss%neqmom = ival
        icount = icount + 1
     ENDIF
     jval = ss%neqmom
     CALL ichk_dim(ival,jval,"neqmom")
  ENDIF

  status = nf90_inq_dimid(icdf,"dim_ngsc0",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ival)
     IF(ss%ngsc0.EQ.0) THEN
        ss%ngsc0 = ival
        icount = icount + 1
     ENDIF
     jval = ss%ngsc0
     CALL ichk_dim(ival,jval,"ngsc0")
  ENDIF

  status = nf90_inq_dimid(icdf,"dim_nicrf_src",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ival)
     IF(ss%nicrf_src.EQ.0) THEN
        ss%nicrf_src = ival
        icount = icount + 1
     ENDIF
     jval = ss%nicrf_src
     CALL ichk_dim(ival,jval,"nicrf_src")
  ENDIF

  status = nf90_inq_dimid(icdf,"dim_nky_anomth",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ival)
     IF(ss%nky_anomth.EQ.0) THEN
        ss%nky_anomth = ival
        icount = icount + 1
     ENDIF
     jval = ss%nky_anomth
     CALL ichk_dim(ival,jval,"nky_anomth")
  ENDIF

  status = nf90_inq_dimid(icdf,"dim_nky_mmm",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ival)
     IF(ss%nky_mmm.EQ.0) THEN
        ss%nky_mmm = ival
        icount = icount + 1
     ENDIF
     jval = ss%nky_mmm
     CALL ichk_dim(ival,jval,"nky_mmm")
  ENDIF

  status = nf90_inq_dimid(icdf,"dim_nlhrf_src",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ival)
     IF(ss%nlhrf_src.EQ.0) THEN
        ss%nlhrf_src = ival
        icount = icount + 1
     ENDIF
     jval = ss%nlhrf_src
     CALL ichk_dim(ival,jval,"nlhrf_src")
  ENDIF

  status = nf90_inq_dimid(icdf,"dim_nnewcomb",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ival)
     IF(ss%nnewcomb.EQ.0) THEN
        ss%nnewcomb = ival
        icount = icount + 1
     ENDIF
     jval = ss%nnewcomb
     CALL ichk_dim(ival,jval,"nnewcomb")
  ENDIF

  status = nf90_inq_dimid(icdf,"dim_npsmom",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ival)
     IF(ss%npsmom.EQ.0) THEN
        ss%npsmom = ival
        icount = icount + 1
     ENDIF
     jval = ss%npsmom
     CALL ichk_dim(ival,jval,"npsmom")
  ENDIF

  status = nf90_inq_dimid(icdf,"dim_nr",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ival)
     IF(ss%nr.EQ.0) THEN
        ss%nr = ival
        icount = icount + 1
     ENDIF
     jval = ss%nr
     CALL ichk_dim(ival,jval,"nr")
  ENDIF

  status = nf90_inq_dimid(icdf,"dm1_nrho",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ival)
     ival = ival + 1
     IF(ss%nrho.EQ.0) THEN
        ss%nrho = ival
        icount = icount + 1
     ENDIF
     jval = ss%nrho
     CALL ichk_dim(ival,jval,"nrho")
  ENDIF
  status = nf90_inq_dimid(icdf,"dim_nrho",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ival)
     IF(ss%nrho.EQ.0) THEN
        ss%nrho = ival
        icount = icount + 1
     ENDIF
     jval = ss%nrho
     CALL ichk_dim(ival,jval,"nrho")
  ENDIF

  status = nf90_inq_dimid(icdf,"dim_nrho_anom",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ival)
     IF(ss%nrho_anom.EQ.0) THEN
        ss%nrho_anom = ival
        icount = icount + 1
     ENDIF
     jval = ss%nrho_anom
     CALL ichk_dim(ival,jval,"nrho_anom")
  ENDIF

  status = nf90_inq_dimid(icdf,"dim_nrho_anom2",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ival)
     IF(ss%nrho_anom2.EQ.0) THEN
        ss%nrho_anom2 = ival
        icount = icount + 1
     ENDIF
     jval = ss%nrho_anom2
     CALL ichk_dim(ival,jval,"nrho_anom2")
  ENDIF

  status = nf90_inq_dimid(icdf,"dm1_nrho_anomth",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ival)
     ival = ival + 1
     IF(ss%nrho_anomth.EQ.0) THEN
        ss%nrho_anomth = ival
        icount = icount + 1
     ENDIF
     jval = ss%nrho_anomth
     CALL ichk_dim(ival,jval,"nrho_anomth")
  ENDIF
  status = nf90_inq_dimid(icdf,"dim_nrho_anomth",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ival)
     IF(ss%nrho_anomth.EQ.0) THEN
        ss%nrho_anomth = ival
        icount = icount + 1
     ENDIF
     jval = ss%nrho_anomth
     CALL ichk_dim(ival,jval,"nrho_anomth")
  ENDIF

  status = nf90_inq_dimid(icdf,"dm1_nrho_ecrf",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ival)
     ival = ival + 1
     IF(ss%nrho_ecrf.EQ.0) THEN
        ss%nrho_ecrf = ival
        icount = icount + 1
     ENDIF
     jval = ss%nrho_ecrf
     CALL ichk_dim(ival,jval,"nrho_ecrf")
  ENDIF
  status = nf90_inq_dimid(icdf,"dim_nrho_ecrf",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ival)
     IF(ss%nrho_ecrf.EQ.0) THEN
        ss%nrho_ecrf = ival
        icount = icount + 1
     ENDIF
     jval = ss%nrho_ecrf
     CALL ichk_dim(ival,jval,"nrho_ecrf")
  ENDIF

  status = nf90_inq_dimid(icdf,"dim_nrho_eq",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ival)
     IF(ss%nrho_eq.EQ.0) THEN
        ss%nrho_eq = ival
        icount = icount + 1
     ENDIF
     jval = ss%nrho_eq
     CALL ichk_dim(ival,jval,"nrho_eq")
  ENDIF

  status = nf90_inq_dimid(icdf,"dim_nrho_eq_geo",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ival)
     IF(ss%nrho_eq_geo.EQ.0) THEN
        ss%nrho_eq_geo = ival
        icount = icount + 1
     ENDIF
     jval = ss%nrho_eq_geo
     CALL ichk_dim(ival,jval,"nrho_eq_geo")
  ENDIF

  status = nf90_inq_dimid(icdf,"dm1_nrho_fus",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ival)
     ival = ival + 1
     IF(ss%nrho_fus.EQ.0) THEN
        ss%nrho_fus = ival
        icount = icount + 1
     ENDIF
     jval = ss%nrho_fus
     CALL ichk_dim(ival,jval,"nrho_fus")
  ENDIF
  status = nf90_inq_dimid(icdf,"dim_nrho_fus",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ival)
     IF(ss%nrho_fus.EQ.0) THEN
        ss%nrho_fus = ival
        icount = icount + 1
     ENDIF
     jval = ss%nrho_fus
     CALL ichk_dim(ival,jval,"nrho_fus")
  ENDIF

  status = nf90_inq_dimid(icdf,"dm1_nrho_gas",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ival)
     ival = ival + 1
     IF(ss%nrho_gas.EQ.0) THEN
        ss%nrho_gas = ival
        icount = icount + 1
     ENDIF
     jval = ss%nrho_gas
     CALL ichk_dim(ival,jval,"nrho_gas")
  ENDIF
  status = nf90_inq_dimid(icdf,"dim_nrho_gas",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ival)
     IF(ss%nrho_gas.EQ.0) THEN
        ss%nrho_gas = ival
        icount = icount + 1
     ENDIF
     jval = ss%nrho_gas
     CALL ichk_dim(ival,jval,"nrho_gas")
  ENDIF

  status = nf90_inq_dimid(icdf,"dm1_nrho_icrf",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ival)
     ival = ival + 1
     IF(ss%nrho_icrf.EQ.0) THEN
        ss%nrho_icrf = ival
        icount = icount + 1
     ENDIF
     jval = ss%nrho_icrf
     CALL ichk_dim(ival,jval,"nrho_icrf")
  ENDIF
  status = nf90_inq_dimid(icdf,"dim_nrho_icrf",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ival)
     IF(ss%nrho_icrf.EQ.0) THEN
        ss%nrho_icrf = ival
        icount = icount + 1
     ENDIF
     jval = ss%nrho_icrf
     CALL ichk_dim(ival,jval,"nrho_icrf")
  ENDIF

  status = nf90_inq_dimid(icdf,"dm1_nrho_lhrf",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ival)
     ival = ival + 1
     IF(ss%nrho_lhrf.EQ.0) THEN
        ss%nrho_lhrf = ival
        icount = icount + 1
     ENDIF
     jval = ss%nrho_lhrf
     CALL ichk_dim(ival,jval,"nrho_lhrf")
  ENDIF
  status = nf90_inq_dimid(icdf,"dim_nrho_lhrf",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ival)
     IF(ss%nrho_lhrf.EQ.0) THEN
        ss%nrho_lhrf = ival
        icount = icount + 1
     ENDIF
     jval = ss%nrho_lhrf
     CALL ichk_dim(ival,jval,"nrho_lhrf")
  ENDIF

  status = nf90_inq_dimid(icdf,"dim_nrho_lmhd",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ival)
     IF(ss%nrho_lmhd.EQ.0) THEN
        ss%nrho_lmhd = ival
        icount = icount + 1
     ENDIF
     jval = ss%nrho_lmhd
     CALL ichk_dim(ival,jval,"nrho_lmhd")
  ENDIF

  status = nf90_inq_dimid(icdf,"dm1_nrho_mist",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ival)
     ival = ival + 1
     IF(ss%nrho_mist.EQ.0) THEN
        ss%nrho_mist = ival
        icount = icount + 1
     ENDIF
     jval = ss%nrho_mist
     CALL ichk_dim(ival,jval,"nrho_mist")
  ENDIF
  status = nf90_inq_dimid(icdf,"dim_nrho_mist",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ival)
     IF(ss%nrho_mist.EQ.0) THEN
        ss%nrho_mist = ival
        icount = icount + 1
     ENDIF
     jval = ss%nrho_mist
     CALL ichk_dim(ival,jval,"nrho_mist")
  ENDIF

  status = nf90_inq_dimid(icdf,"dm1_nrho_nbi",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ival)
     ival = ival + 1
     IF(ss%nrho_nbi.EQ.0) THEN
        ss%nrho_nbi = ival
        icount = icount + 1
     ENDIF
     jval = ss%nrho_nbi
     CALL ichk_dim(ival,jval,"nrho_nbi")
  ENDIF
  status = nf90_inq_dimid(icdf,"dim_nrho_nbi",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ival)
     IF(ss%nrho_nbi.EQ.0) THEN
        ss%nrho_nbi = ival
        icount = icount + 1
     ENDIF
     jval = ss%nrho_nbi
     CALL ichk_dim(ival,jval,"nrho_nbi")
  ENDIF

  status = nf90_inq_dimid(icdf,"dm1_nrho_pel",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ival)
     ival = ival + 1
     IF(ss%nrho_pel.EQ.0) THEN
        ss%nrho_pel = ival
        icount = icount + 1
     ENDIF
     jval = ss%nrho_pel
     CALL ichk_dim(ival,jval,"nrho_pel")
  ENDIF
  status = nf90_inq_dimid(icdf,"dim_nrho_pel",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ival)
     IF(ss%nrho_pel.EQ.0) THEN
        ss%nrho_pel = ival
        icount = icount + 1
     ENDIF
     jval = ss%nrho_pel
     CALL ichk_dim(ival,jval,"nrho_pel")
  ENDIF

  status = nf90_inq_dimid(icdf,"dm1_nrho_rad",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ival)
     ival = ival + 1
     IF(ss%nrho_rad.EQ.0) THEN
        ss%nrho_rad = ival
        icount = icount + 1
     ENDIF
     jval = ss%nrho_rad
     CALL ichk_dim(ival,jval,"nrho_rad")
  ENDIF
  status = nf90_inq_dimid(icdf,"dim_nrho_rad",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ival)
     IF(ss%nrho_rad.EQ.0) THEN
        ss%nrho_rad = ival
        icount = icount + 1
     ENDIF
     jval = ss%nrho_rad
     CALL ichk_dim(ival,jval,"nrho_rad")
  ENDIF

  status = nf90_inq_dimid(icdf,"dm1_nrho_rw",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ival)
     ival = ival + 1
     IF(ss%nrho_rw.EQ.0) THEN
        ss%nrho_rw = ival
        icount = icount + 1
     ENDIF
     jval = ss%nrho_rw
     CALL ichk_dim(ival,jval,"nrho_rw")
  ENDIF
  status = nf90_inq_dimid(icdf,"dim_nrho_rw",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ival)
     IF(ss%nrho_rw.EQ.0) THEN
        ss%nrho_rw = ival
        icount = icount + 1
     ENDIF
     jval = ss%nrho_rw
     CALL ichk_dim(ival,jval,"nrho_rw")
  ENDIF

  status = nf90_inq_dimid(icdf,"dim_nr_rip",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ival)
     IF(ss%nr_rip.EQ.0) THEN
        ss%nr_rip = ival
        icount = icount + 1
     ENDIF
     jval = ss%nr_rip
     CALL ichk_dim(ival,jval,"nr_rip")
  ENDIF

  status = nf90_inq_dimid(icdf,"dim_nspec_all",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ival)
     IF(ss%nspec_all.EQ.0) THEN
        ss%nspec_all = ival
        icount = icount + 1
     ENDIF
     jval = ss%nspec_all
     CALL ichk_dim(ival,jval,"nspec_all")
  ENDIF
  status = nf90_inq_dimid(icdf,"dp1_nspec_all",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ival)
     ival = ival - 1
     IF(ss%nspec_all.EQ.0) THEN
        ss%nspec_all = ival
        icount = icount + 1
     ENDIF
     jval = ss%nspec_all
     CALL ichk_dim(ival,jval,"nspec_all")
  ENDIF

  status = nf90_inq_dimid(icdf,"dim_nspec_alla",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ival)
     IF(ss%nspec_alla.EQ.0) THEN
        ss%nspec_alla = ival
        icount = icount + 1
     ENDIF
     jval = ss%nspec_alla
     CALL ichk_dim(ival,jval,"nspec_alla")
  ENDIF
  status = nf90_inq_dimid(icdf,"dp1_nspec_alla",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ival)
     ival = ival - 1
     IF(ss%nspec_alla.EQ.0) THEN
        ss%nspec_alla = ival
        icount = icount + 1
     ENDIF
     jval = ss%nspec_alla
     CALL ichk_dim(ival,jval,"nspec_alla")
  ENDIF

  status = nf90_inq_dimid(icdf,"dim_nspec_beam",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ival)
     IF(ss%nspec_beam.EQ.0) THEN
        ss%nspec_beam = ival
        icount = icount + 1
     ENDIF
     jval = ss%nspec_beam
     CALL ichk_dim(ival,jval,"nspec_beam")
  ENDIF

  status = nf90_inq_dimid(icdf,"dim_nspec_fusion",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ival)
     IF(ss%nspec_fusion.EQ.0) THEN
        ss%nspec_fusion = ival
        icount = icount + 1
     ENDIF
     jval = ss%nspec_fusion
     CALL ichk_dim(ival,jval,"nspec_fusion")
  ENDIF

  status = nf90_inq_dimid(icdf,"dim_nspec_gas",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ival)
     IF(ss%nspec_gas.EQ.0) THEN
        ss%nspec_gas = ival
        icount = icount + 1
     ENDIF
     jval = ss%nspec_gas
     CALL ichk_dim(ival,jval,"nspec_gas")
  ENDIF

  status = nf90_inq_dimid(icdf,"dim_nspec_imp0",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ival)
     IF(ss%nspec_imp0.EQ.0) THEN
        ss%nspec_imp0 = ival
        icount = icount + 1
     ENDIF
     jval = ss%nspec_imp0
     CALL ichk_dim(ival,jval,"nspec_imp0")
  ENDIF

  status = nf90_inq_dimid(icdf,"dim_nspec_impi",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ival)
     IF(ss%nspec_impi.EQ.0) THEN
        ss%nspec_impi = ival
        icount = icount + 1
     ENDIF
     jval = ss%nspec_impi
     CALL ichk_dim(ival,jval,"nspec_impi")
  ENDIF

  status = nf90_inq_dimid(icdf,"dim_nspec_rfmin",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ival)
     IF(ss%nspec_rfmin.EQ.0) THEN
        ss%nspec_rfmin = ival
        icount = icount + 1
     ENDIF
     jval = ss%nspec_rfmin
     CALL ichk_dim(ival,jval,"nspec_rfmin")
  ENDIF

  status = nf90_inq_dimid(icdf,"dim_nspec_th",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ival)
     IF(ss%nspec_th.EQ.0) THEN
        ss%nspec_th = ival
        icount = icount + 1
     ENDIF
     jval = ss%nspec_th
     CALL ichk_dim(ival,jval,"nspec_th")
  ENDIF
  status = nf90_inq_dimid(icdf,"dp1_nspec_th",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ival)
     ival = ival - 1
     IF(ss%nspec_th.EQ.0) THEN
        ss%nspec_th = ival
        icount = icount + 1
     ENDIF
     jval = ss%nspec_th
     CALL ichk_dim(ival,jval,"nspec_th")
  ENDIF

  status = nf90_inq_dimid(icdf,"dim_nspec_tha",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ival)
     IF(ss%nspec_tha.EQ.0) THEN
        ss%nspec_tha = ival
        icount = icount + 1
     ENDIF
     jval = ss%nspec_tha
     CALL ichk_dim(ival,jval,"nspec_tha")
  ENDIF
  status = nf90_inq_dimid(icdf,"dp1_nspec_tha",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ival)
     ival = ival - 1
     IF(ss%nspec_tha.EQ.0) THEN
        ss%nspec_tha = ival
        icount = icount + 1
     ENDIF
     jval = ss%nspec_tha
     CALL ichk_dim(ival,jval,"nspec_tha")
  ENDIF

  status = nf90_inq_dimid(icdf,"dim_nth_eq",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ival)
     IF(ss%nth_eq.EQ.0) THEN
        ss%nth_eq = ival
        icount = icount + 1
     ENDIF
     jval = ss%nth_eq
     CALL ichk_dim(ival,jval,"nth_eq")
  ENDIF

  status = nf90_inq_dimid(icdf,"dim_ntrcat",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ival)
     IF(ss%ntrcat.EQ.0) THEN
        ss%ntrcat = ival
        icount = icount + 1
     ENDIF
     jval = ss%ntrcat
     CALL ichk_dim(ival,jval,"ntrcat")
  ENDIF

  status = nf90_inq_dimid(icdf,"dim_num_rzlim",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ival)
     IF(ss%num_rzlim.EQ.0) THEN
        ss%num_rzlim = ival
        icount = icount + 1
     ENDIF
     jval = ss%num_rzlim
     CALL ichk_dim(ival,jval,"num_rzlim")
  ENDIF

  status = nf90_inq_dimid(icdf,"dim_nxs",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ival)
     IF(ss%nxs.EQ.0) THEN
        ss%nxs = ival
        icount = icount + 1
     ENDIF
     jval = ss%nxs
     CALL ichk_dim(ival,jval,"nxs")
  ENDIF

  status = nf90_inq_dimid(icdf,"dim_nz",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ival)
     IF(ss%nz.EQ.0) THEN
        ss%nz = ival
        icount = icount + 1
     ENDIF
     jval = ss%nz
     CALL ichk_dim(ival,jval,"nz")
  ENDIF

  status = nf90_inq_dimid(icdf,"dim_nz_rip",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ival)
     IF(ss%nz_rip.EQ.0) THEN
        ss%nz_rip = ival
        icount = icount + 1
     ENDIF
     jval = ss%nz_rip
     CALL ichk_dim(ival,jval,"nz_rip")
  ENDIF

  status = nf90_inq_dimid(icdf,"dim_n_d_einj_standard",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ival)
     IF(ss%n_D_einj_standard.EQ.0) THEN
        ss%n_D_einj_standard = ival
        icount = icount + 1
     ENDIF
     jval = ss%n_D_einj_standard
     CALL ichk_dim(ival,jval,"n_D_einj_standard")
  ENDIF

  status = nf90_inq_dimid(icdf,"dim_n_h_einj_standard",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ival)
     IF(ss%n_H_einj_standard.EQ.0) THEN
        ss%n_H_einj_standard = ival
        icount = icount + 1
     ENDIF
     jval = ss%n_H_einj_standard
     CALL ichk_dim(ival,jval,"n_H_einj_standard")
  ENDIF

  status = nf90_inq_dimid(icdf,"dim_n_t_einj_standard",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ival)
     IF(ss%n_T_einj_standard.EQ.0) THEN
        ss%n_T_einj_standard = ival
        icount = icount + 1
     ENDIF
     jval = ss%n_T_einj_standard
     CALL ichk_dim(ival,jval,"n_T_einj_standard")
  ENDIF

  IF(iertot.GT.0) THEN
     WRITE(iout,*) " ?ps_update_file_read: error with dimension values."
     ierr=9999
     status = nf90_close(icdf)
     RETURN
  ENDIF

  ! DIMENSIONS read in OK; allocate state arrays...

  IF(icount.GT.0) THEN
     CALL plasma_state_empty_alloc(ss,ierr)
     IF(ierr.NE.0) THEN
        WRITE(iout,*) " ?ps_update_file_read: plasma_state_empty_alloc error."
        ierr=9999
        status = nf90_close(icdf)
        RETURN
     ENDIF
  ENDIF

  !---------------------------------------------
  ! call subroutines to read data and arrays...

  call ps_update_file_read_0(ss,icdf,iout,iucount,iertot)
  call ps_update_file_read_1(ss,icdf,iout,iucount,iertot)
  call ps_update_file_read_2(ss,icdf,iout,iucount,iertot)
  call ps_update_file_read_3(ss,icdf,iout,iucount,iertot)
  call ps_update_file_read_4(ss,icdf,iout,iucount,iertot)
  call ps_update_file_read_5(ss,icdf,iout,iucount,iertot)
  call ps_update_file_read_6(ss,icdf,iout,iucount,iertot)
  call ps_update_file_read_7(ss,icdf,iout,iucount,iertot)
  call ps_update_file_read_8(ss,icdf,iout,iucount,iertot)
  call ps_update_file_read_9(ss,icdf,iout,iucount,iertot)


  IF(iertot.GT.0) THEN
     WRITE(iout,*) ' ?ps_update_file_read: an error occurred.'
     ierr=9999
  ELSE
     WRITE(iout,*) ' *ps_update_file_read: OK, found data for', iucount, &
          ' state elements.'
     ierr=0
  ENDIF


CONTAINS

  subroutine ichk_zero(iarray)
     integer, dimension(:), intent(in) :: iarray

     integer :: ii

     izero=.TRUE.
     do ii=1,size(iarray)
        if(iarray(ii).ne.0) then
           izero=.FALSE.
           exit
        endif
     enddo

     if(.not.izero) then
        prehash1=17
        prehash2=23
        call hashCode(iarray,prehash1,prehash2)
     endif

  end subroutine ichk_zero

  subroutine rchk_zero(rarray)
     real(kind=rspec), dimension(:), intent(in) :: rarray

     integer :: ii

     izero=.TRUE.
     do ii=1,size(rarray)
        if(rarray(ii).ne.0.0_rspec) then
           izero=.FALSE.
           exit
        endif
     enddo

     if(.not.izero) then
        prehash1=17
        prehash2=23
        call hashCode(rarray,prehash1,prehash2)
     endif

  end subroutine rchk_zero

  subroutine cchk_zero(c32array)
     character*32, dimension(:), intent(in) :: c32array

     integer :: ii

     izero=.TRUE.
     do ii=1,size(c32array)
        if(c32array(ii).ne." ") then
           izero=.FALSE.
           exit
        endif
     enddo

     if(.not.izero) then
        prehash1=17
        prehash2=23
        call hashCode(c32array,prehash1,prehash2)
     endif

  end subroutine cchk_zero

  subroutine ichk_hash(itemName,iarray)
     character*(*), intent(in) :: itemName
     integer, dimension(:), intent(in) :: iarray

     posthash1=17
     posthash2=23
     call hashCode(iarray,posthash1,posthash2)

     if((prehash1.ne.posthash1).OR.(prehash2.ne.posthash2)) then
        write(iout,*) ' ?ps_update_file_read: value change detected in dimension quantity: '//trim(itemName)
        iertot = iertot + 1
     endif

  end subroutine ichk_hash

  subroutine rchk_hash(itemName,rarray)
     character*(*), intent(in) :: itemName
     real(kind=rspec), dimension(:), intent(in) :: rarray

     posthash1=17
     posthash2=23
     call hashCode(rarray,posthash1,posthash2)

     if((prehash1.ne.posthash1).OR.(prehash2.ne.posthash2)) then
        write(iout,*) ' ?ps_update_file_read: value change detected in dimension quantity: '//trim(itemName)
        iertot = iertot + 1
     endif

  end subroutine rchk_hash

  subroutine cchk_hash(itemName,c32array)
     character*(*), intent(in) :: itemName
     character*32, dimension(:), intent(in) :: c32array

     posthash1=17
     posthash2=23
     call hashCode(c32array,posthash1,posthash2)

     if((prehash1.ne.posthash1).OR.(prehash2.ne.posthash2)) then
        write(iout,*) ' ?ps_update_file_read: value change detected in dimension quantity: '//trim(itemName)
        iertot = iertot + 1
     endif

  end subroutine cchk_hash

  SUBROUTINE ichk_dim(ival,jval,dname)
     INTEGER, intent(in) :: ival  ! file dimension value
     INTEGER, intent(in) :: jval  ! state dimension value
     CHARACTER*(*), intent(in) :: dname

     IF(ival.ne.jval) THEN
        WRITE(iout,*) ' ?ps_update_file_read: update file dimension not consistent with state:'
        WRITE(iout,*) '  file value:  ',ival
        WRITE(iout,*) '  state value: ',jval
        WRITE(iout,*) '  dimension name: '//trim(dname)
        iertot = iertot + 1
     ENDIF
  END SUBROUTINE ichk_dim

  SUBROUTINE ncerr(status)
     INTEGER, INTENT(in) :: status

     nc_errmsg = NF90_strerror(status)
     write(iout,*) '  NetCDF message: ',trim(nc_errmsg)
  END SUBROUTINE ncerr

  SUBROUTINE denull(str)
     ! convert null characters to blank
     CHARACTER*(*) :: str
     INTEGER :: i

     do i=1,len(str)
        if(ichar(str(i:i)).eq.0) str(i:i)=' '
     enddo
  END SUBROUTINE denull

END SUBROUTINE ps_update_file_read

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_e6_dummy
     return
  end subroutine ccps_getset_e6_dummy

subroutine psget_eq_data_info(iobj, data, ierr)
    !! Information: source of EQ input data
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    CHARACTER*(*), intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_eq_data_info', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % EQ_Data_Info
end subroutine psget_eq_data_info


subroutine psset_eq_data_info(iobj, data, ierr)
    !! Information: source of EQ input data
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    CHARACTER*(*), intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_eq_data_info', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % EQ_Data_Info = data
end subroutine psset_eq_data_info


subroutine psgetsz_eq_data_info(iobj, size, ierr)
    !! Information: source of EQ input data
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: size    ! size of character string
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psgetsz_eq_data_info', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! note that the following will return the character length size regardless of
    ! the number of array elements (if EQ_Data_Info is an array)
    size = len(ss % EQ_Data_Info)
end subroutine psgetsz_eq_data_info

subroutine ps_limcon(iobj,npts,rpts,zpts,igot,iout,ierr)

  !------------------------------------------------------------
  ! D. McCune 19 Dec 2006

  ! XPLASMA2 implementation of plasma_state subroutine
  !   fetch the (R,Z) axisymmetric limiter contour (1:igot)
  !------------------------------------------------------------

  use plasma_state_definition_mod
  use plasma_state_xpobj  ! XPLASMA2 state object definitions
  implicit NONE

  !-----------------------

  integer :: iobj(ps_container_size)     ! xplasma opaque container
  integer, intent(in) :: npts              ! #pts in limiter arrays

  REAL(kind=rspec), intent(out) :: Rpts(npts),Zpts(npts) ! limiter contour
  integer, intent(out) :: igot             ! #pts in limiter data returned

  integer, intent(in) :: iout              ! Fortran LUN for messages
  integer, intent(out) :: ierr             ! error status code returned 0 = OK

  !-----------------------
  integer :: itype,ipts
  type (interp_object) :: xobj
  type (xplasma), pointer :: s
  !-----------------------

  !  initialize output; check state tag

  igot=0
  Rpts=0
  Zpts=0

  xobj = transfer(iobj,xobj)
  s => xobj%s_xpobj

  call xplasma_global_info(s,ierr, init_check=.TRUE.)
  if(ierr.ne.0) then
     write(iout,*) ' %ps_limcon: invalid or unitialized xplasma object.'
     return
  endif

  !-----------------------

  call xplasma_lim_info(s,ierr, itype=itype, npts=ipts)
  if(ierr.ne.0) then
     write(iout,*) ' ?ps_limcon: xplasma_lim_info error:'
     call xplasma_error(s,ierr,iout)
     return
  endif

  if(itype.ne.100) then
     write(iout,*) ' ?ps_limcon: no contour limiter available; itype=',itype
     ierr=999
     return
  endif

  if(ipts.gt.npts) then
     write(iout,*) ' ?ps_limcon: passed array size "npts" too small.'
     write(iout,*) '  received npts=',npts,'; need at least ',ipts
     ierr=999
     return
  endif

  igot=ipts

  call xplasma_lim_info(s,ierr, rpts=Rpts(1:igot), zpts=Zpts(1:igot))

end subroutine ps_limcon

#include "config_random.h"
! Version 2.1 of random number routines
! Author: Charles Karney <karney@princeton.edu>
! Date: 1999-10-27 14:10 -0400
!
      REAL8 function random(ri,ra)
      implicit none
      integer ri
      REAL8 ra(0:100-1)
      REAL8 tmp(1)

      call random_array(tmp,1,ri,ra)
      random = tmp(1)
      return
      end

      Real function srandom(ri,ra)
      implicit none
      integer ri
      REAL8 ra(0:100-1)
      Real tmp(1)

      call srandom_array(tmp,1,ri,ra)
      srandom = tmp(1)
      return
      end
!
      subroutine random_array(y,n,ri,ra)
      implicit none
      REAL8 ulp2
      parameter(ulp2=TWO**(-47-1))
#ifndef HIPREC
      Real ulps
      REAL8 mult
      parameter(ulps=2.0**(-23),mult=TWO**23)
#endif /* not HIPREC */
      integer n
      REAL8 y(0:n-1)
#ifndef HIPREC
      Real ys(0:n-1)
#endif /* not HIPREC */
      integer ri
      REAL8 ra(0:100-1)
      integer i,k,j
      external rand_batch
#ifdef HIPREC
      entry srandom_array(y,n,ri,ra)
#endif /* HIPREC */
      if(n.LE.0)return
      k=min(n,100-ri)
      do i=0,k-1
      y(i)=ra(i+ri)+ulp2
      end do
      ri=ri+(k)
      do j=k,n-1,100
      call rand_batch(ri,ra(0))
      do i=j,min(j+100,n)-1
      y(i)=ra(i-j+ri)+ulp2
#ifndef HIPREC
      end do
      ri=ri+(min(100,n-j))
      end do
      return
      entry srandom_array(ys,n,ri,ra)
      if(n.LE.0)return
      k=min(n,100-ri)
      do i=0,k-1
      ys(i)=(int(mult*ra(i+ri))+0.5)*ulps
      end do
      ri=ri+(k)
      do j=k,n-1,100
      call rand_batch(ri,ra(0))
      do i=j,min(j+100,n)-1
      ys(i)=(int(mult*ra(i-j+ri))+0.5)*ulps
#endif /* not HIPREC */
      end do
      ri=ri+(min(100,n-j))
      end do
      return
      end
!
      subroutine rand_batch(ri,ra)
      implicit none
      integer ri
      REAL8 ra(0:100-1)
      integer i
      REAL8 w(0:1009-100-1)
      REAL8 tmp
      do i=0,63-1
      tmp=ra(i)+ra(i+100-63)
#if USEINT
      w(i)=tmp-int(tmp)
#else
      if(tmp.GE.ONE)then
      w(i)=tmp-ONE
      else
      w(i)=tmp
      end if
#endif
      end do
      do i=63,100-1
      tmp=ra(i)+w(i-63)
#if USEINT
      w(i)=tmp-int(tmp)
#else
      if(tmp.GE.ONE)then
      w(i)=tmp-ONE
      else
      w(i)=tmp
      end if
#endif
      end do
      do i=100,1009-100-1
      tmp=w(i-100)+w(i-63)
#if USEINT
      w(i)=tmp-int(tmp)
#else
      if(tmp.GE.ONE)then
      w(i)=tmp-ONE
      else
      w(i)=tmp
      end if
#endif
      end do
      do i=1009-100,1009-100+63-1
      tmp=w(i-100)+w(i-63)
#if USEINT
      ra(i-1009+100)=tmp-int(tmp)
#else
      if(tmp.GE.ONE)then
      ra(i-1009+100)=tmp-ONE
      else
      ra(i-1009+100)=tmp
      end if
#endif
      end do
      do i=1009-100+63,1009-1
      tmp=w(i-100)+ra(i-1009+100-63)
#if USEINT
      ra(i-1009+100)=tmp-int(tmp)
#else
      if(tmp.GE.ONE)then
      ra(i-1009+100)=tmp-ONE
      else
      ra(i-1009+100)=tmp
      end if
#endif
      end do
      ri=0
      return
      end
!
      subroutine random_init_x(seed,ri,ra)
      implicit none
      integer b
      REAL8 del,ulp
      parameter(b=2**14,del=TWO**(-14),ulp=TWO**(-47))
      integer a0,a1,a2,a3,a4,a5,a6,c0
      parameter(a0=15661,a1=678,a2=724,a3=5245,a4=13656,a5=11852,a6=29)
      parameter(c0=1)
      integer seed(0:8-1)
      integer ri
      REAL8 ra(0:100-1)
      integer i,j,s(0:8-1)
      logical odd
      integer z(0:8-1),t
      do i=0,8-1
      s(i)=seed(i)
      end do
      odd=mod(s(7),2).NE.0
      ra(0)=(((s(7)*del+s(6))*del+s(5))*del+int(s(4)/512))*512*del
      do j=1,100-1
      z(0)=c0+a0*s(0)
      z(1)=a0*s(1)+a1*s(0)
      z(2)=a0*s(2)+a1*s(1)+a2*s(0)
      z(3)=a0*s(3)+a1*s(2)+a2*s(1)+a3*s(0)
      z(4)=a0*s(4)+a1*s(3)+a2*s(2)+a3*s(1)+a4*s(0)
      z(5)=a0*s(5)+a1*s(4)+a2*s(3)+a3*s(2)+a4*s(1)+a5*s(0)
      z(6)=a0*s(6)+a1*s(5)+a2*s(4)+a3*s(3)+a4*s(2)+a5*s(1)+a6*s(0)
      z(7)=a0*s(7)+a1*s(6)+a2*s(5)+a3*s(4)+a4*s(3)+a5*s(2)+a6*s(1)
      t=0
      do i=0,8-1
      t=int(t/b)+z(i)
      s(i)=mod(t,b)
      end do
      odd=odd.OR.(mod(s(7),2).NE.0)
      ra(j)=(((s(7)*del+s(6))*del+s(5))*del+int(s(4)/512))*512*del
      end do
      ri=100
      if(odd)return
      z(0)=c0+a0*s(0)
      z(1)=a0*s(1)+a1*s(0)
      z(2)=a0*s(2)+a1*s(1)+a2*s(0)
      z(3)=a0*s(3)+a1*s(2)+a2*s(1)+a3*s(0)
      z(4)=a0*s(4)+a1*s(3)+a2*s(2)+a3*s(1)+a4*s(0)
      z(5)=a0*s(5)+a1*s(4)+a2*s(3)+a3*s(2)+a4*s(1)+a5*s(0)
      z(6)=a0*s(6)+a1*s(5)+a2*s(4)+a3*s(3)+a4*s(2)+a5*s(1)+a6*s(0)
      z(7)=a0*s(7)+a1*s(6)+a2*s(5)+a3*s(4)+a4*s(3)+a5*s(2)+a6*s(1)
      t=0
      do i=0,8-1
      t=int(t/b)+z(i)
      s(i)=mod(t,b)
      end do
      j=int((s(8-1)*100)/b)
      ra(j)=ra(j)+(ulp)
      return
      end
!
      subroutine decimal_to_seed(decimal,seed)
      implicit none
      character*(*)decimal
      integer seed(0:8-1)
      external rand_axc
      integer i,ten(0:8-1),c(0:8-1),ch
      data ten/10,7*0/
      do i=0,8-1
      seed(i)=0
      c(i)=0
      end do
      do i=1,len(decimal)
      ch=ichar(decimal(i:i))
      if(ch.GE.ichar('0').AND.ch.LE.ichar('9'))then
      c(0)=ch-ichar('0')
      call rand_axc(ten,seed,c)
      end if
      end do
      return
      end
!
      subroutine string_to_seed(string,seed)
      implicit none
      integer b
      parameter(b=2**14)
      character*(*)string
      integer seed(0:8-1)
      external rand_axc
      integer t,i,k,unity(0:8-1),c(0:8-1),ch
      data unity/1,7*0/
      do i=0,8-1
      seed(i)=0
      c(i)=0
      end do
      do i=1,len(string)
      ch=ichar(string(i:i))
      if(ch.GT.ichar(' ').AND.ch.LT.127)then
      t=mod(seed(0),2)*(b/2)
      do k=0,8-1
      seed(k)=int(seed(k)/2)
      if(k.LT.8-1)then
      seed(k)=seed(k)+(mod(seed(k+1),2)*(b/2))
      else
      seed(k)=seed(k)+(t)
      end if
      end do
      c(0)=ch
      call rand_axc(unity,seed,c)
      end if
      end do
      return
      end
!
      subroutine set_random_seed(time,seed)
      implicit none
      integer time(8)
      integer seed(0:8-1)
      character*26 c
      integer t(8)
      external decimal_to_seed
      t(1)=mod(mod(time(1),1000000000)+1000000000,1000000000)
      t(2)=mod(mod(time(2),100)+100,100)
      t(3)=mod(mod(time(3),100)+100,100)
      t(4)=((1-sign(1,time(4)))/2)*1000+mod(abs(time(4)),1000)
      t(5)=mod(mod(time(5),100)+100,100)
      t(6)=mod(mod(time(6),100)+100,100)
      t(7)=mod(mod(time(7),100)+100,100)
      t(8)=mod(mod(time(7),1000)+1000,1000)
      c=' '
      write(c(1:17),'(i9.9,2i2.2,i4.4)')t(1),t(2),t(3),t(4)
      write(c(18:26),'(3i2.2,i3.3)')t(5),t(6),t(7),t(8)
      call decimal_to_seed(c,seed)
      return
      end
!
      subroutine seed_to_decimal(seed,decimal)
      implicit none
      integer pow,decbase,b
      parameter(pow=4,decbase=10**pow,b=2**14)
      character*(*)decimal
      integer seed(0:8-1)
      integer z(0:8-1),i,t,j,k
      character*36 str
      k=-1
      do i=0,8-1
      z(i)=seed(i)
      if(z(i).GT.0)k=i
      end do
      str=' '
      i=9
90000 continue
      i=i-1
      t=0
      do j=k,0,-1
      z(j)=z(j)+t*b
      t=mod(z(j),decbase)
      z(j)=int(z(j)/decbase)
      end do
      if(z(max(0,k)).EQ.0)k=k-1
      j=pow*(i+1)
      if(k.GE.0)then
      str(j-(pow-1):j)='0000'
      else
      str(j-(pow-1):j)='   0'
      end if
90001 continue
      if(t.EQ.0)goto 90010
      str(j:j)=char(ichar('0')+mod(t,10))
      j=j-1
      t=int(t/10)
      goto 90001
90010 continue
      if(k.GE.0)goto 90000
      k=min(j+1,len(str))
      if(len(decimal).GE.len(str(k:)))then
      decimal=str(k:)
      else
      decimal=str(len(str(k:))-len(decimal)+1:)
      end if
      return
      end
!
      subroutine rand_next_seed(n,ax,cx,y)
      implicit none
      integer n,ax(0:8-1),cx(0:8-1)
      integer y(0:8-1)
      external rand_axc
      integer a(0:8-1),c(0:8-1),z(0:8-1),t(0:8-1),m,i
      data z/8*0/
      if(n.EQ.0)return
      m=n
      do i=0,8-1
      a(i)=ax(i)
      c(i)=cx(i)
      end do
90000 continue
      if(mod(m,2).GT.0)then
      call rand_axc(a,y,c)
      end if
      m=int(m/2)
      if(m.EQ.0)return
      do i=0,8-1
      t(i)=c(i)
      end do
      call rand_axc(a,c,t)
      do i=0,8-1
      t(i)=a(i)
      end do
      call rand_axc(t,a,z)
      goto 90000
      end
!
      subroutine next_seed3(n0,n1,n2,seed)
      implicit none
      integer n0,n1,n2
      integer seed(0:8-1)
      external rand_next_seed
      integer af0(0:8-1),cf0(0:8-1)
      integer ab0(0:8-1),cb0(0:8-1)
      integer af1(0:8-1),cf1(0:8-1)
      integer ab1(0:8-1),cb1(0:8-1)
      integer af2(0:8-1),cf2(0:8-1)
      integer ab2(0:8-1),cb2(0:8-1)
      data af0/15741,8689,9280,4732,12011,7130,6824,12302/
      data cf0/16317,10266,1198,331,10769,8310,2779,13880/
      data ab0/9173,9894,15203,15379,7981,2280,8071,429/
      data cb0/8383,3616,597,12724,15663,9639,187,4866/
      data af1/8405,4808,3603,6718,13766,9243,10375,12108/
      data cf1/13951,7170,9039,11206,8706,14101,1864,15191/
      data ab1/6269,3240,9759,7130,15320,14399,3675,1380/
      data cb1/15357,5843,6205,16275,8838,12132,2198,10330/
      data af2/445,10754,1869,6593,385,12498,14501,7383/
      data cf2/2285,8057,3864,10235,1805,10614,9615,15522/
      data ab2/405,4903,2746,1477,3263,13564,8139,2362/
      data cb2/8463,575,5876,2220,4924,1701,9060,5639/
      if(n2.GT.0)then
      call rand_next_seed(n2,af2,cf2,seed)
      else if(n2.LT.0)then
      call rand_next_seed(-n2,ab2,cb2,seed)
      end if
      if(n1.GT.0)then
      call rand_next_seed(n1,af1,cf1,seed)
      else if(n1.LT.0)then
      call rand_next_seed(-n1,ab1,cb1,seed)
      end if
      entry next_seed(n0,seed)
      if(n0.GT.0)then
      call rand_next_seed(n0,af0,cf0,seed)
      else if(n0.LT.0)then
      call rand_next_seed(-n0,ab0,cb0,seed)
      end if
      return
      end
!
      subroutine rand_axc(a,x,c)
      implicit none
      integer b
      parameter(b=2**14)
      integer a(0:8-1),c(0:8-1)
      integer x(0:8-1)
      integer z(0:8-1),i,j,t
      do i=0,8-1
      z(i)=c(i)
      end do
      do j=0,8-1
      do i=j,8-1
      z(i)=z(i)+(a(j)*x(i-j))
      end do
      end do
      t=0
      do i=0,8-1
      t=int(t/b)+z(i)
      x(i)=mod(t,b)
      end do
      return
      end
!

subroutine ccps_free(iobj,ierr)

  ! free a state object -- this routine to be called by C/C++ destructor

  use plasma_state_mod
  implicit NONE

  integer :: iobj(*)   ! (ps_container_size) words are used
  integer :: ierr

  !--------------------------------
  type (plasma_state_container) :: ptr
  type (plasma_state), pointer :: ss
  !--------------------------------

  call ccps_argcheck('ccps_free',iobj,ierr)
  if(ierr.ne.0) return

  ! proceed...

  call load_ps_container(iobj,ptr)
  ss => ptr%ps_ptr

  call ps_free_user_state(ss,ierr)

  deallocate(ptr%ps_ptr)

  iobj(1:ps_container_size)=0

end subroutine ccps_free

subroutine ps_limsize(iobj,ipts,iout,ierr)

  !------------------------------------------------------------
  ! D. McCune 19 Dec 2006

  ! XPLASMA2 implementation of plasma_state subroutine
  !   fetch the length of the (R,Z) axisymmetric limiter contour (#pts).
  !------------------------------------------------------------

  use plasma_state_definition_mod
  use plasma_state_xpobj  ! XPLASMA2 state object definitions
  implicit NONE

  !-----------------------

  integer :: iobj(ps_container_size)     ! xplasma opaque container
  integer, intent(out) :: ipts             ! #pts in limiter

  integer, intent(in) :: iout              ! Fortran LUN for messages
  integer, intent(out) :: ierr             ! error status code returned 0 = OK

  !-----------------------
  integer :: itype
  type (interp_object) :: xobj
  type (xplasma), pointer :: s
  !-----------------------

  xobj = transfer(iobj,xobj)
  s => xobj%s_xpobj

  call xplasma_global_info(s,ierr, init_check=.TRUE.)
  if(ierr.ne.0) then
     write(iout,*) ' %ps_limsize: invalid or unitialized xplasma object.'
     return
  endif

  !-----------------------

  call xplasma_lim_info(s,ierr, itype=itype, npts=ipts)
  if(ierr.ne.0) then
     write(iout,*) ' ?ps_limsize: xplasma_lim_info error:'
     call xplasma_error(s,ierr,iout)
     ipts=0
     return
  endif

  if(itype.ne.100) then
     write(iout,*) ' ?ps_limsize: no contour limiter available; itype=',itype
     ipts=0
     ierr=999
     return
  endif

end subroutine ps_limsize

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_q9_dummy
     return
  end subroutine ccps_getset_q9_dummy

subroutine psget_q_sfus(iobj, n1, data, ierr)
    !! SFUS specie charge
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_q_sfus', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % q_SFUS
end subroutine psget_q_sfus


subroutine psset_q_sfus(iobj, n1, data, ierr)
    !! SFUS specie charge
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_q_sfus', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % q_SFUS = data(1:n1)
end subroutine psset_q_sfus


subroutine psgetrnk_q_sfus(iobj, ndims, ierr)
    !! SFUS specie charge
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_q_sfus


subroutine psgetdim_q_sfus(iobj, ndims, dims, ierr)
    !! SFUS specie charge
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_q_sfus', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % q_SFUS ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % q_SFUS)
    endif
end subroutine psgetdim_q_sfus


subroutine psget_q_simp0(iobj, n1, data, ierr)
    !! SIMP0 specie charge
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_q_simp0', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % q_SIMP0
end subroutine psget_q_simp0


subroutine psset_q_simp0(iobj, n1, data, ierr)
    !! SIMP0 specie charge
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_q_simp0', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % q_SIMP0 = data(1:n1)
end subroutine psset_q_simp0


subroutine psgetrnk_q_simp0(iobj, ndims, ierr)
    !! SIMP0 specie charge
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_q_simp0


subroutine psgetdim_q_simp0(iobj, ndims, dims, ierr)
    !! SIMP0 specie charge
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_q_simp0', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % q_SIMP0 ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % q_SIMP0)
    endif
end subroutine psgetdim_q_simp0


subroutine psget_qbeami(iobj, n1, n2, data, ierr)
    !! average beam ion charge, Note, although H & He beam ions
    !! will be fully stripped,, Impurity beams (Ne, Xe, Ar, Kr) may
    !! not be..., <state>%q_snbi(1:<state>%nspec_beam) will contain
    !! the, density weighted volume average charge over the, profile:
    !! ps_xe for H beams, 2*ps_xe for He beams...
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_qbeami', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % qbeami
end subroutine psget_qbeami


subroutine psset_qbeami(iobj, n1, n2, data, ierr)
    !! average beam ion charge, Note, although H & He beam ions
    !! will be fully stripped,, Impurity beams (Ne, Xe, Ar, Kr) may
    !! not be..., <state>%q_snbi(1:<state>%nspec_beam) will contain
    !! the, density weighted volume average charge over the, profile:
    !! ps_xe for H beams, 2*ps_xe for He beams...
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_qbeami', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % qbeami = data(1:n1, 1: n2)
end subroutine psset_qbeami


subroutine psgetrnk_qbeami(iobj, ndims, ierr)
    !! average beam ion charge, Note, although H & He beam ions
    !! will be fully stripped,, Impurity beams (Ne, Xe, Ar, Kr) may
    !! not be..., <state>%q_snbi(1:<state>%nspec_beam) will contain
    !! the, density weighted volume average charge over the, profile:
    !! ps_xe for H beams, 2*ps_xe for He beams...
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_qbeami


subroutine psgetdim_qbeami(iobj, ndims, dims, ierr)
    !! average beam ion charge, Note, although H & He beam ions
    !! will be fully stripped,, Impurity beams (Ne, Xe, Ar, Kr) may
    !! not be..., <state>%q_snbi(1:<state>%nspec_beam) will contain
    !! the, density weighted volume average charge over the, profile:
    !! ps_xe for H beams, 2*ps_xe for He beams...
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_qbeami', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % qbeami ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % qbeami)
    endif
end subroutine psgetdim_qbeami


subroutine psget_qioniz(iobj, n1, n2, data, ierr)
    !! ionization power per unit influx (sc0)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_qioniz', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % qioniz
end subroutine psget_qioniz


subroutine psset_qioniz(iobj, n1, n2, data, ierr)
    !! ionization power per unit influx (sc0)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_qioniz', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % qioniz = data(1:n1, 1: n2)
end subroutine psset_qioniz


subroutine psgetrnk_qioniz(iobj, ndims, ierr)
    !! ionization power per unit influx (sc0)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_qioniz


subroutine psgetdim_qioniz(iobj, ndims, dims, ierr)
    !! ionization power per unit influx (sc0)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_qioniz', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % qioniz ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % qioniz)
    endif
end subroutine psgetdim_qioniz

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


SUBROUTINE ps_update_file_write_def_7(ss,icdf,cclist,nids,iout,iwarn,iertot)


  ! Define updated data

  USE plasma_state_definition_mod
  USE netcdf
  USE ps_nidlist_defn
  IMPLICIT NONE

  TYPE (plasma_state) :: ss  ! state containing array elements to be allocated
  INTEGER, INTENT(IN) :: icdf  ! NetCDF file ID
  INTEGER, INTENT(IN) :: cclist(ps_ccount)  ! component selection
  TYPE (nidlist) :: nids       ! defined dimensions list
  INTEGER, INTENT(IN) :: iout  ! LUN for messages
  INTEGER, INTENT(INOUT) :: iwarn   ! warn count
  INTEGER, INTENT(INOUT) :: iertot  ! error count

  !-------------------
  LOGICAL :: plasma_state_hash_match,ichange

  INTEGER :: varid,pvarid,vvarid,dimid,status,iertmp,iaddr
  INTEGER :: idims(20),indim,ival,ii,ierr
  CHARACTER*80 :: nc_errmsg

  !-------------------

  ierr = 0   ! local

  iaddr = ps_shash_Rloc_coil
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%Rloc_coil).AND.ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("Rloc_coil","EQ")
     ELSE
        indim = 0
        IF(nids%nid_dim_ncoils.EQ.0) THEN
           CALL define_dim(nids%nid_dim_ncoils,"dim_ncoils",ss%ncoils)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_ncoils
        CALL define_var("Rloc_coil","R",indim,idims, &
               "R location of coil, lower left corner", &
               "m","EQ","MACHINE_DESCRIPTION", &
               "R|units=m  Rloc_coil(ncoils)")
     ENDIF
  ENDIF

  iaddr = ps_phash_Rmajor_mean
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%Rmajor_mean).AND.ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("Rmajor_mean","EQ")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_eq_geo.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_eq_geo,"dim_nrho_eq_geo",ss%nrho_eq_geo)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_eq_geo
        CALL define_var("Rmajor_mean","R",indim,idims, &
               "Rmajor_mean = (R_Surfmax+R_surfmin)/2", &
               "m","EQ","STATE_PROFILES", &
               "R|pclin  Rmajor_mean(nrho_eq_geo)")
     ENDIF
  ENDIF

  iaddr = ps_phash_rMinor_mean
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%rMinor_mean).AND.ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("rMinor_mean","EQ")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_eq_geo.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_eq_geo,"dim_nrho_eq_geo",ss%nrho_eq_geo)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_eq_geo
        CALL define_var("rMinor_mean","R",indim,idims, &
               "rMinor_mean = (R_Surfmax-R_surfmin)/2", &
               "m","EQ","STATE_PROFILES", &
               "R|pclin  rMinor_mean(nrho_eq_geo)")
     ENDIF
  ENDIF

  iaddr = ps_shash_RUNAWAY_Code_Info
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ichange) THEN
     IF(cclist(ps_cnum_RUNAWAY).NE.1) THEN
        CALL ccwarn("RUNAWAY_Code_Info","RUNAWAY")
     ELSE
        indim = 1
        idims(1)=nids%nid_clen_80
        CALL define_var("RUNAWAY_Code_Info","C*80",indim,idims, &
               "Information: code implementing RUNAWAY component", &
               "__NONE","RUNAWAY","SIMULATION_INIT", &
               "C*80   RUNAWAY_Code_Info")
     ENDIF
  ENDIF

  iaddr = ps_shash_RunID
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("RunID","PLASMA")
     ELSE
        indim = 1
        idims(1)=nids%nid_clen_32
        CALL define_var("RunID","N",indim,idims, &
               "Run ID", &
               "__NONE","PLASMA","SIMULATION_INIT", &
               "N      RunID")
     ENDIF
  ENDIF

  iaddr = ps_shash_R_ant
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%R_ant).AND.ichange) THEN
     IF(cclist(ps_cnum_IC).NE.1) THEN
        CALL ccwarn("R_ant","IC")
     ELSE
        indim = 0
        IF(nids%nid_dim_nicrf_src.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nicrf_src,"dim_nicrf_src",ss%nicrf_src)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nicrf_src
        CALL define_var("R_ant","R",indim,idims, &
               "major radius of antenna", &
               "m","IC","SHOT_CONFIGURATION", &
               "R|units=m R_ant(nicrf_src)")
     ENDIF
  ENDIF

  iaddr = ps_shash_R_antgeo
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%R_antgeo).AND.ichange) THEN
     IF(cclist(ps_cnum_IC).NE.1) THEN
        CALL ccwarn("R_antgeo","IC")
     ELSE
        indim = 0
        IF(nids%nid_dim_max_nrz_antgeo.EQ.0) THEN
           CALL define_dim(nids%nid_dim_max_nrz_antgeo,"dim_max_nrz_antgeo",ss%max_nrz_antgeo)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_max_nrz_antgeo
        IF(nids%nid_dim_nicrf_src.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nicrf_src,"dim_nicrf_src",ss%nicrf_src)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nicrf_src
        CALL define_var("R_antgeo","R",indim,idims, &
               "antenna geo: R pts", &
               "m","IC","MACHINE_DESCRIPTION", &
               "R|units=m R_antgeo(nrz_antgeo(),nicrf_src)")
     ENDIF
  ENDIF

  iaddr = ps_shash_R_axis
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("R_axis","EQ")
     ELSE
        indim = 0
        CALL define_var("R_axis","R",indim,idims, &
               "R of magnetic axis", &
               "m","EQ","STATE_DATA", &
               "R  R_axis")
     ENDIF
  ENDIF

  iaddr = ps_shash_R_EC_launch
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%R_EC_launch).AND.ichange) THEN
     IF(cclist(ps_cnum_EC).NE.1) THEN
        CALL ccwarn("R_EC_launch","EC")
     ELSE
        indim = 0
        IF(nids%nid_dim_necrf_src.EQ.0) THEN
           CALL define_dim(nids%nid_dim_necrf_src,"dim_necrf_src",ss%necrf_src)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_necrf_src
        CALL define_var("R_EC_launch","R",indim,idims, &
               "R of center of launcher", &
               "m","EC","MACHINE_DESCRIPTION", &
               "R|units=m   R_EC_launch(necrf_src)")
     ENDIF
  ENDIF

  iaddr = ps_phash_R_geo
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%R_geo).AND.ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("R_geo","EQ")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_eq.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_eq,"dim_nrho_eq",ss%nrho_eq)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_eq
        IF(nids%nid_dim_nth_eq.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nth_eq,"dim_nth_eq",ss%nth_eq)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nth_eq
        CALL define_var("R_geo","R",indim,idims, &
               "flux surfaces R(rho,theta)", &
               "m","EQ","STATE_PROFILES", &
               "R|units=m|Hermite_explicit R_geo(nrho_eq,nth_eq)")
     ENDIF
  ENDIF

  iaddr = ps_dhash_nr
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%R_grid).AND.ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("R_grid","EQ")
     ELSE
        indim = 0
        IF(nids%nid_dim_nr.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nr,"dim_nr",ss%nr)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nr
        CALL define_var("R_grid","R",indim,idims, &
               "R grid", &
               "m","EQ","SIMULATION_INIT", &
               "G   R_grid(nR)")
     ENDIF
  ENDIF

  iaddr = ps_shash_R_max_box
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("R_max_box","EQ")
     ELSE
        indim = 0
        CALL define_var("R_max_box","R",indim,idims, &
               "R_max of bounding box", &
               "m","EQ","MACHINE_DESCRIPTION", &
               "R  R_max_box")
     ENDIF
  ENDIF

  iaddr = ps_shash_R_max_lcfs
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("R_max_lcfs","EQ")
     ELSE
        indim = 0
        CALL define_var("R_max_lcfs","R",indim,idims, &
               "R_max of last closed flux surface", &
               "m","EQ","STATE_DATA", &
               "R  R_max_lcfs")
     ENDIF
  ENDIF

  iaddr = ps_phash_R_midp_in
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%R_midp_in).AND.ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("R_midp_in","EQ")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_eq_geo.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_eq_geo,"dim_nrho_eq_geo",ss%nrho_eq_geo)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_eq_geo
        CALL define_var("R_midp_in","R",indim,idims, &
               "R (high field side) midplane intercept", &
               "m","EQ","STATE_PROFILES", &
               "R|pclin  R_midp_in(nrho_eq_geo)")
     ENDIF
  ENDIF

  iaddr = ps_phash_R_midp_out
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%R_midp_out).AND.ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("R_midp_out","EQ")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_eq_geo.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_eq_geo,"dim_nrho_eq_geo",ss%nrho_eq_geo)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_eq_geo
        CALL define_var("R_midp_out","R",indim,idims, &
               "R (low field side) midplane intercept", &
               "m","EQ","STATE_PROFILES", &
               "R|pclin  R_midp_out(nrho_eq_geo)")
     ENDIF
  ENDIF

  iaddr = ps_shash_R_min_box
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("R_min_box","EQ")
     ELSE
        indim = 0
        CALL define_var("R_min_box","R",indim,idims, &
               "R_min of bounding box", &
               "m","EQ","MACHINE_DESCRIPTION", &
               "R  R_min_box")
     ENDIF
  ENDIF

  iaddr = ps_shash_R_min_lcfs
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("R_min_lcfs","EQ")
     ELSE
        indim = 0
        CALL define_var("R_min_lcfs","R",indim,idims, &
               "R_min of last closed flux surface", &
               "m","EQ","STATE_DATA", &
               "R  R_min_lcfs")
     ENDIF
  ENDIF

  iaddr = ps_dhash_nr_rip
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%R_ripple).AND.ichange) THEN
     IF(cclist(ps_cnum_RIPPLE).NE.1) THEN
        CALL ccwarn("R_ripple","RIPPLE")
     ELSE
        indim = 0
        IF(nids%nid_dim_nr_rip.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nr_rip,"dim_nr_rip",ss%nr_rip)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nr_rip
        CALL define_var("R_ripple","R",indim,idims, &
               "R grid for TF ripple field(s)", &
               "m","RIPPLE","SIMULATION_INIT", &
               "G  R_ripple(nR_rip)")
     ENDIF
  ENDIF

  iaddr = ps_phash_R_surfMax
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%R_surfMax).AND.ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("R_surfMax","EQ")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_eq_geo.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_eq_geo,"dim_nrho_eq_geo",ss%nrho_eq_geo)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_eq_geo
        CALL define_var("R_surfMax","R",indim,idims, &
               "max R on flux surface", &
               "m","EQ","STATE_PROFILES", &
               "R|pclin  R_surfMax(nrho_eq_geo)")
     ENDIF
  ENDIF

  iaddr = ps_phash_R_surfMin
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%R_surfMin).AND.ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("R_surfMin","EQ")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_eq_geo.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_eq_geo,"dim_nrho_eq_geo",ss%nrho_eq_geo)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_eq_geo
        CALL define_var("R_surfMin","R",indim,idims, &
               "min R on flux surface", &
               "m","EQ","STATE_PROFILES", &
               "R|pclin  R_surfMin(nrho_eq_geo)")
     ENDIF
  ENDIF

  iaddr = ps_phash_s0reco
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%s0reco).AND.ichange) THEN
     IF(cclist(ps_cnum_GAS).NE.1) THEN
        CALL ccwarn("s0reco","GAS")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_gas.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_gas,"dm1_nrho_gas",ss%nrho_gas-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_gas
        IF(nids%nid_dim_nspec_gas.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nspec_gas,"dim_nspec_gas",ss%nspec_gas)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nspec_gas
        CALL define_var("s0reco","R",indim,idims, &
               "recombination neutral sce", &
               "#/sec","GAS","STATE_PROFILES", &
               "R|step*dV|units=#/sec s0reco(~nrho_gas,nspec_gas)")
     ENDIF
  ENDIF

  iaddr = ps_phash_s0reco_e
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%s0reco_e).AND.ichange) THEN
     IF(cclist(ps_cnum_GAS).NE.1) THEN
        CALL ccwarn("s0reco_e","GAS")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_gas.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_gas,"dm1_nrho_gas",ss%nrho_gas-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_gas
        CALL define_var("s0reco_e","R",indim,idims, &
               "net electron source associated with recombination:", &
               "#/sec","GAS","STATE_PROFILES", &
               "R|step*dV|units=#/sec s0reco_e(~nrho_gas)")
     ENDIF
  ENDIF

  iaddr = ps_phash_s0reco_recap
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%s0reco_recap).AND.ichange) THEN
     IF(cclist(ps_cnum_GAS).NE.1) THEN
        CALL ccwarn("s0reco_recap","GAS")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_gas.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_gas,"dm1_nrho_gas",ss%nrho_gas-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_gas
        IF(nids%nid_dim_nspec_gas.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nspec_gas,"dim_nspec_gas",ss%nspec_gas)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nspec_gas
        CALL define_var("s0reco_recap","R",indim,idims, &
               "recombination neutrals recapture", &
               "#/sec","GAS","STATE_PROFILES", &
               "R|step*dV|units=#/sec s0reco_recap(~nrho_gas,nspec_gas)")
     ENDIF
  ENDIF

  iaddr = ps_shash_sa_index
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%sa_index).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("sa_index","PLASMA")
     ELSE
        indim = 0
        IF(nids%nid_dp1_nspec_all.EQ.0) THEN
           CALL define_dim(nids%nid_dp1_nspec_all,"dp1_nspec_all",ss%nspec_all+1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dp1_nspec_all
        CALL define_var("sa_index","I",indim,idims, &
               "species index in original lists", &
               "__NONE","PLASMA","SIMULATION_INIT", &
               "I sa_index(0:nspec_all)")
     ENDIF
  ENDIF

  iaddr = ps_dhash_nspec_tha
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%SA_name).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("SA_name","PLASMA")
     ELSE
        indim = 1
        idims(1)=nids%nid_clen_32
        IF(nids%nid_dp1_nspec_tha.EQ.0) THEN
           CALL define_dim(nids%nid_dp1_nspec_tha,"dp1_nspec_tha",ss%nspec_tha+1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dp1_nspec_tha
        CALL define_var("SA_name","N",indim,idims, &
               "thermal species abridged", &
               "__NONE","PLASMA","SIMULATION_INIT", &
               "S|thermal_specie  SA(0:nspec_tha)")
     ENDIF
  ENDIF

  iaddr = ps_dhash_nspec_tha
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%SA_type).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("SA_type","PLASMA")
     ELSE
        indim = 0
        IF(nids%nid_dp1_nspec_tha.EQ.0) THEN
           CALL define_dim(nids%nid_dp1_nspec_tha,"dp1_nspec_tha",ss%nspec_tha+1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dp1_nspec_tha
        CALL define_var("SA_type","I",indim,idims, &
               "SA specie types", &
               "__NONE","PLASMA","SIMULATION_INIT", &
               "S|thermal_specie  SA(0:nspec_tha)")
     ENDIF
  ENDIF

  iaddr = ps_phash_sb0halo
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%sb0halo).AND.ichange) THEN
     IF(cclist(ps_cnum_NBI).NE.1) THEN
        CALL ccwarn("sb0halo","NBI")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_nbi.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_nbi,"dm1_nrho_nbi",ss%nrho_nbi-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_nbi
        IF(nids%nid_dim_nspec_gas.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nspec_gas,"dim_nspec_gas",ss%nspec_gas)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nspec_gas
        CALL define_var("sb0halo","R",indim,idims, &
               "beam dep cx sink", &
               "#/sec","NBI","STATE_PROFILES", &
               "R|step*dV|units=#/sec sb0halo(~nrho_nbi,nspec_gas)")
     ENDIF
  ENDIF

  iaddr = ps_phash_sb0halo_recap
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%sb0halo_recap).AND.ichange) THEN
     IF(cclist(ps_cnum_NBI).NE.1) THEN
        CALL ccwarn("sb0halo_recap","NBI")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_nbi.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_nbi,"dm1_nrho_nbi",ss%nrho_nbi-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_nbi
        IF(nids%nid_dim_nspec_gas.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nspec_gas,"dim_nspec_gas",ss%nspec_gas)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nspec_gas
        CALL define_var("sb0halo_recap","R",indim,idims, &
               "cx neutral recapture", &
               "#/sec","NBI","STATE_PROFILES", &
               "R|step*dV|units=#/sec sb0halo_recap(~nrho_nbi,nspec_gas)")
     ENDIF
  ENDIF

  iaddr = ps_phash_sbedep
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%sbedep).AND.ichange) THEN
     IF(cclist(ps_cnum_NBI).NE.1) THEN
        CALL ccwarn("sbedep","NBI")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_nbi.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_nbi,"dm1_nrho_nbi",ss%nrho_nbi-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_nbi
        CALL define_var("sbedep","R",indim,idims, &
               "beam deposition cold electron sce", &
               "#/sec","NBI","STATE_PROFILES", &
               "R|step*dV|units=#/sec sbedep(~nrho_nbi)")
     ENDIF
  ENDIF

  iaddr = ps_phash_sbehalo
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%sbehalo).AND.ichange) THEN
     IF(cclist(ps_cnum_NBI).NE.1) THEN
        CALL ccwarn("sbehalo","NBI")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_nbi.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_nbi,"dm1_nrho_nbi",ss%nrho_nbi-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_nbi
        CALL define_var("sbehalo","R",indim,idims, &
               "cold electron sce due to", &
               "#/sec","NBI","STATE_PROFILES", &
               "R|step*dV|units=#/sec sbehalo(~nrho_nbi)")
     ENDIF
  ENDIF

  iaddr = ps_phash_sbsce
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%sbsce).AND.ichange) THEN
     IF(cclist(ps_cnum_NBI).NE.1) THEN
        CALL ccwarn("sbsce","NBI")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_nbi.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_nbi,"dm1_nrho_nbi",ss%nrho_nbi-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_nbi
        IF(nids%nid_dp1_nspec_tha.EQ.0) THEN
           CALL define_dim(nids%nid_dp1_nspec_tha,"dp1_nspec_tha",ss%nspec_tha+1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dp1_nspec_tha
        CALL define_var("sbsce","R",indim,idims, &
               "net source, thermal ions & electrons", &
               "#/sec","NBI","STATE_PROFILES", &
               "R|step*dV|units=#/sec   sbsce(~nrho_nbi,0:nspec_tha)")
     ENDIF
  ENDIF

  iaddr = ps_phash_sbtherm
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%sbtherm).AND.ichange) THEN
     IF(cclist(ps_cnum_NBI).NE.1) THEN
        CALL ccwarn("sbtherm","NBI")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_nbi.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_nbi,"dm1_nrho_nbi",ss%nrho_nbi-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_nbi
        IF(nids%nid_dim_nspec_beam.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nspec_beam,"dim_nspec_beam",ss%nspec_beam)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nspec_beam
        CALL define_var("sbtherm","R",indim,idims, &
               "beam ion thermalization", &
               "#/sec","NBI","STATE_PROFILES", &
               "R|step*dV|units=#/sec sbtherm(~nrho_nbi,nspec_beam)")
     ENDIF
  ENDIF

  iaddr = ps_shash_sc0
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%sc0).AND.ichange) THEN
     IF(cclist(ps_cnum_GAS).NE.1) THEN
        CALL ccwarn("sc0","GAS")
     ELSE
        indim = 0
        IF(nids%nid_dim_ngsc0.EQ.0) THEN
           CALL define_dim(nids%nid_dim_ngsc0,"dim_ngsc0",ss%ngsc0)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_ngsc0
        CALL define_var("sc0","R",indim,idims, &
               "edge neutral sources (atoms/sec)", &
               "#/sec","GAS","STATE_DATA", &
               "R|units=#/sec  sc0(ngsc0)")
     ENDIF
  ENDIF

  iaddr = ps_shash_sc0_to_sgas
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%sc0_to_sgas).AND.ichange) THEN
     IF(cclist(ps_cnum_GAS).NE.1) THEN
        CALL ccwarn("sc0_to_sgas","GAS")
     ELSE
        indim = 0
        IF(nids%nid_dim_ngsc0.EQ.0) THEN
           CALL define_dim(nids%nid_dim_ngsc0,"dim_ngsc0",ss%ngsc0)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_ngsc0
        CALL define_var("sc0_to_sgas","I",indim,idims, &
               "index map from neutral source to neutral species", &
               "__NONE","GAS","SIMULATION_INIT", &
               "I  sc0_to_sgas(ngsc0)")
     ENDIF
  ENDIF

  iaddr = ps_phash_sc_anom
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%sc_anom).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("sc_anom","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_anomth,"dm1_nrho_anomth",ss%nrho_anomth-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_anomth
        IF(nids%nid_dp1_nspec_th.EQ.0) THEN
           CALL define_dim(nids%nid_dp1_nspec_th,"dp1_nspec_th",ss%nspec_th+1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dp1_nspec_th
        CALL define_var("sc_anom","R",indim,idims, &
               "anomalous sources", &
               "#/sec","ANOM","STATE_PROFILES", &
               "R|units=#/sec|step*dV sc_anom(~nrho_anomth,0:nspec_th)")
     ENDIF
  ENDIF

  iaddr = ps_phash_sfsce
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%sfsce).AND.ichange) THEN
     IF(cclist(ps_cnum_FUS).NE.1) THEN
        CALL ccwarn("sfsce","FUS")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_fus.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_fus,"dm1_nrho_fus",ss%nrho_fus-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_fus
        IF(nids%nid_dp1_nspec_tha.EQ.0) THEN
           CALL define_dim(nids%nid_dp1_nspec_tha,"dp1_nspec_tha",ss%nspec_tha+1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dp1_nspec_tha
        CALL define_var("sfsce","R",indim,idims, &
               "net thermalization source of fusion ions", &
               "#/sec","FUS","STATE_PROFILES", &
               "R|step*dV|units=#/sec   sfsce(~nrho_fus,0:nspec_tha)")
     ENDIF
  ENDIF

  iaddr = ps_phash_sftherm
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%sftherm).AND.ichange) THEN
     IF(cclist(ps_cnum_FUS).NE.1) THEN
        CALL ccwarn("sftherm","FUS")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_fus.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_fus,"dm1_nrho_fus",ss%nrho_fus-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_fus
        IF(nids%nid_dim_nspec_fusion.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nspec_fusion,"dim_nspec_fusion",ss%nspec_fusion)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nspec_fusion
        CALL define_var("sftherm","R",indim,idims, &
               "fusion ion thermalization", &
               "#/sec","FUS","STATE_PROFILES", &
               "R|step*dV|units=#/sec   sftherm(~nrho_fus,nspec_fusion)")
     ENDIF
  ENDIF

  iaddr = ps_dhash_nspec_fusion
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%SFUS_name).AND.ichange) THEN
     IF(cclist(ps_cnum_FUS).NE.1) THEN
        CALL ccwarn("SFUS_name","FUS")
     ELSE
        indim = 1
        idims(1)=nids%nid_clen_32
        IF(nids%nid_dim_nspec_fusion.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nspec_fusion,"dim_nspec_fusion",ss%nspec_fusion)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nspec_fusion
        CALL define_var("SFUS_name","N",indim,idims, &
               "fusion product ion species", &
               "__NONE","FUS","SHOT_CONFIGURATION", &
               "S|fusion_ion   SFUS(nspec_fusion)")
     ENDIF
  ENDIF

  iaddr = ps_shash_sfus_to_all
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%sfus_to_all).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("sfus_to_all","PLASMA")
     ELSE
        indim = 0
        IF(nids%nid_dim_nspec_fusion.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nspec_fusion,"dim_nspec_fusion",ss%nspec_fusion)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nspec_fusion
        CALL define_var("sfus_to_all","I",indim,idims, &
               'map sfus index to "all" list', &
               "__NONE","PLASMA","SIMULATION_INIT", &
               "I  sfus_to_all(nspec_fusion)")
     ENDIF
  ENDIF

  iaddr = ps_shash_sfus_to_alla
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%sfus_to_alla).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("sfus_to_alla","PLASMA")
     ELSE
        indim = 0
        IF(nids%nid_dim_nspec_fusion.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nspec_fusion,"dim_nspec_fusion",ss%nspec_fusion)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nspec_fusion
        CALL define_var("sfus_to_alla","I",indim,idims, &
               'map sfus index to "alla" list', &
               "__NONE","PLASMA","SIMULATION_INIT", &
               "I  sfus_to_alla(nspec_fusion)")
     ENDIF
  ENDIF

  iaddr = ps_dhash_nspec_fusion
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%SFUS_type).AND.ichange) THEN
     IF(cclist(ps_cnum_FUS).NE.1) THEN
        CALL ccwarn("SFUS_type","FUS")
     ELSE
        indim = 0
        IF(nids%nid_dim_nspec_fusion.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nspec_fusion,"dim_nspec_fusion",ss%nspec_fusion)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nspec_fusion
        CALL define_var("SFUS_type","I",indim,idims, &
               "SFUS specie types", &
               "__NONE","FUS","SHOT_CONFIGURATION", &
               "S|fusion_ion   SFUS(nspec_fusion)")
     ENDIF
  ENDIF

  iaddr = ps_dhash_nspec_gas
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%SGAS_name).AND.ichange) THEN
     IF(cclist(ps_cnum_GAS).NE.1) THEN
        CALL ccwarn("SGAS_name","GAS")
     ELSE
        indim = 1
        idims(1)=nids%nid_clen_32
        IF(nids%nid_dim_nspec_gas.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nspec_gas,"dim_nspec_gas",ss%nspec_gas)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nspec_gas
        CALL define_var("SGAS_name","N",indim,idims, &
               "atomic neutral species in plasma core", &
               "__NONE","GAS","SIMULATION_INIT", &
               "S|neutral_gas  SGAS(nspec_gas)")
     ENDIF
  ENDIF

  iaddr = ps_shash_sgas_to_s
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%sgas_to_s).AND.ichange) THEN
     IF(cclist(ps_cnum_GAS).NE.1) THEN
        CALL ccwarn("sgas_to_s","GAS")
     ELSE
        indim = 0
        IF(nids%nid_dim_nspec_gas.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nspec_gas,"dim_nspec_gas",ss%nspec_gas)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nspec_gas
        CALL define_var("sgas_to_s","I",indim,idims, &
               'map sgas index to "s" list', &
               "__NONE","GAS","SIMULATION_INIT", &
               "I  sgas_to_s(nspec_gas)")
     ENDIF
  ENDIF

  iaddr = ps_dhash_nspec_gas
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%SGAS_type).AND.ichange) THEN
     IF(cclist(ps_cnum_GAS).NE.1) THEN
        CALL ccwarn("SGAS_type","GAS")
     ELSE
        indim = 0
        IF(nids%nid_dim_nspec_gas.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nspec_gas,"dim_nspec_gas",ss%nspec_gas)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nspec_gas
        CALL define_var("SGAS_type","I",indim,idims, &
               "SGAS specie types", &
               "__NONE","GAS","SIMULATION_INIT", &
               "S|neutral_gas  SGAS(nspec_gas)")
     ENDIF
  ENDIF

  iaddr = ps_shash_shot_number
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("shot_number","PLASMA")
     ELSE
        indim = 0
        CALL define_var("shot_number","I",indim,idims, &
               "integer shot number", &
               "__NONE","PLASMA","SHOT_CONFIGURATION", &
               "I shot_number")
     ENDIF
  ENDIF

  iaddr = ps_phash_sii_xs
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%sii_xs).AND.ichange) THEN
     IF(cclist(ps_cnum_RAD).NE.1) THEN
        CALL ccwarn("sii_xs","RAD")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_mist.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_mist,"dm1_nrho_mist",ss%nrho_mist-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_mist
        IF(nids%nid_dp1_nspec_th.EQ.0) THEN
           CALL define_dim(nids%nid_dp1_nspec_th,"dp1_nspec_th",ss%nspec_th+1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dp1_nspec_th
        IF(nids%nid_dim_nxs.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nxs,"dim_nxs",ss%nxs)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nxs
        CALL define_var("sii_xs","R",indim,idims, &
               "species source/sinks driven by xs(1:nxs)", &
               "(#/sec)/(#/sec)","RAD","STATE_PROFILES", &
               "R|step*dV|units=(#/sec)/(#/sec) sii_xs(~nrho_mist,0:nspec_th,nxs)")
     ENDIF
  ENDIF

  iaddr = ps_dhash_nspec_imp0
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%SIMP0_name).AND.ichange) THEN
     IF(cclist(ps_cnum_GAS).NE.1) THEN
        CALL ccwarn("SIMP0_name","GAS")
     ELSE
        indim = 1
        idims(1)=nids%nid_clen_32
        IF(nids%nid_dim_nspec_imp0.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nspec_imp0,"dim_nspec_imp0",ss%nspec_imp0)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nspec_imp0
        CALL define_var("SIMP0_name","N",indim,idims, &
               "atomic impurity species in simulation", &
               "__NONE","GAS","SIMULATION_INIT", &
               "S|impurity_atoms SIMP0(nspec_imp0)")
     ENDIF
  ENDIF

  iaddr = ps_shash_simp0_to_s
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%simp0_to_s).AND.ichange) THEN
     IF(cclist(ps_cnum_GAS).NE.1) THEN
        CALL ccwarn("simp0_to_s","GAS")
     ELSE
        indim = 0
        IF(nids%nid_dim_nspec_imp0.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nspec_imp0,"dim_nspec_imp0",ss%nspec_imp0)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nspec_imp0
        CALL define_var("simp0_to_s","I",indim,idims, &
               'map simp0 index to "s" list', &
               "__NONE","GAS","SIMULATION_INIT", &
               "I  simp0_to_s(nspec_imp0)")
     ENDIF
  ENDIF

  iaddr = ps_dhash_nspec_imp0
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%SIMP0_type).AND.ichange) THEN
     IF(cclist(ps_cnum_GAS).NE.1) THEN
        CALL ccwarn("SIMP0_type","GAS")
     ELSE
        indim = 0
        IF(nids%nid_dim_nspec_imp0.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nspec_imp0,"dim_nspec_imp0",ss%nspec_imp0)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nspec_imp0
        CALL define_var("SIMP0_type","I",indim,idims, &
               "SIMP0 specie types", &
               "__NONE","GAS","SIMULATION_INIT", &
               "S|impurity_atoms SIMP0(nspec_imp0)")
     ENDIF
  ENDIF

  iaddr = ps_dhash_nspec_impi
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%SIMPI_name).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("SIMPI_name","PLASMA")
     ELSE
        indim = 1
        idims(1)=nids%nid_clen_32
        IF(nids%nid_dim_nspec_impi.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nspec_impi,"dim_nspec_impi",ss%nspec_impi)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nspec_impi
        CALL define_var("SIMPI_name","N",indim,idims, &
               "impurity ion species in simulation", &
               "__NONE","PLASMA","SIMULATION_INIT", &
               "S|impurity_atoms SIMPI(nspec_impi)")
     ENDIF
  ENDIF

  iaddr = ps_shash_simpi_to_s
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%simpi_to_s).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("simpi_to_s","PLASMA")
     ELSE
        indim = 0
        IF(nids%nid_dim_nspec_impi.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nspec_impi,"dim_nspec_impi",ss%nspec_impi)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nspec_impi
        CALL define_var("simpi_to_s","I",indim,idims, &
               'map simpi index to "s" list', &
               "__NONE","PLASMA","SIMULATION_INIT", &
               "I  simpi_to_s(nspec_impi)")
     ENDIF
  ENDIF

  iaddr = ps_dhash_nspec_impi
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%SIMPI_type).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("SIMPI_type","PLASMA")
     ELSE
        indim = 0
        IF(nids%nid_dim_nspec_impi.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nspec_impi,"dim_nspec_impi",ss%nspec_impi)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nspec_impi
        CALL define_var("SIMPI_type","I",indim,idims, &
               "SIMPI specie types", &
               "__NONE","PLASMA","SIMULATION_INIT", &
               "S|impurity_atoms SIMPI(nspec_impi)")
     ENDIF
  ENDIF

  iaddr = ps_dhash_nspec_beam
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%SNBI_name).AND.ichange) THEN
     IF(cclist(ps_cnum_NBI).NE.1) THEN
        CALL ccwarn("SNBI_name","NBI")
     ELSE
        indim = 1
        idims(1)=nids%nid_clen_32
        IF(nids%nid_dim_nspec_beam.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nspec_beam,"dim_nspec_beam",ss%nspec_beam)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nspec_beam
        CALL define_var("SNBI_name","N",indim,idims, &
               "beam ion species", &
               "__NONE","NBI","SIMULATION_INIT", &
               "S|beam_ion     SNBI(nspec_beam)")
     ENDIF
  ENDIF

  iaddr = ps_shash_snbi_to_all
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%snbi_to_all).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("snbi_to_all","PLASMA")
     ELSE
        indim = 0
        IF(nids%nid_dim_nspec_beam.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nspec_beam,"dim_nspec_beam",ss%nspec_beam)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nspec_beam
        CALL define_var("snbi_to_all","I",indim,idims, &
               'map snbi index to "all" list', &
               "__NONE","PLASMA","SIMULATION_INIT", &
               "I  snbi_to_all(nspec_beam)")
     ENDIF
  ENDIF

  iaddr = ps_shash_snbi_to_alla
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%snbi_to_alla).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("snbi_to_alla","PLASMA")
     ELSE
        indim = 0
        IF(nids%nid_dim_nspec_beam.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nspec_beam,"dim_nspec_beam",ss%nspec_beam)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nspec_beam
        CALL define_var("snbi_to_alla","I",indim,idims, &
               'map snbi index to "alla" list', &
               "__NONE","PLASMA","SIMULATION_INIT", &
               "I  snbi_to_alla(nspec_beam)")
     ENDIF
  ENDIF

  iaddr = ps_dhash_nspec_beam
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%SNBI_type).AND.ichange) THEN
     IF(cclist(ps_cnum_NBI).NE.1) THEN
        CALL ccwarn("SNBI_type","NBI")
     ELSE
        indim = 0
        IF(nids%nid_dim_nspec_beam.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nspec_beam,"dim_nspec_beam",ss%nspec_beam)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nspec_beam
        CALL define_var("SNBI_type","I",indim,idims, &
               "SNBI specie types", &
               "__NONE","NBI","SIMULATION_INIT", &
               "S|beam_ion     SNBI(nspec_beam)")
     ENDIF
  ENDIF

  iaddr = ps_phash_sn_trans
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%sn_trans).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("sn_trans","PLASMA")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho,"dm1_nrho",ss%nrho-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho
        IF(nids%nid_dp1_nspec_th.EQ.0) THEN
           CALL define_dim(nids%nid_dp1_nspec_th,"dp1_nspec_th",ss%nspec_th+1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dp1_nspec_th
        CALL define_var("sn_trans","R",indim,idims, &
               "particle transport (loss)", &
               "#/sec","PLASMA","STATE_PROFILES", &
               "R|units=#/sec|step*dV sn_trans(~nrho,0:nspec_th)")
     ENDIF
  ENDIF

  iaddr = ps_phash_sn_transcat
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%sn_transcat).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("sn_transcat","PLASMA")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho,"dm1_nrho",ss%nrho-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho
        IF(nids%nid_dp1_nspec_th.EQ.0) THEN
           CALL define_dim(nids%nid_dp1_nspec_th,"dp1_nspec_th",ss%nspec_th+1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dp1_nspec_th
        IF(nids%nid_dim_ntrcat.EQ.0) THEN
           CALL define_dim(nids%nid_dim_ntrcat,"dim_ntrcat",ss%ntrcat)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_ntrcat
        CALL define_var("sn_transcat","R",indim,idims, &
               "species transport", &
               "#/sec","PLASMA","STATE_PROFILES", &
               "R|step*dV|units=#/sec  sn_transcat(~nrho,0:nspec_th,ntrcat)")
     ENDIF
  ENDIF

  iaddr = ps_phash_sprof0
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%sprof0).AND.ichange) THEN
     IF(cclist(ps_cnum_GAS).NE.1) THEN
        CALL ccwarn("sprof0","GAS")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_gas.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_gas,"dm1_nrho_gas",ss%nrho_gas-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_gas
        IF(nids%nid_dim_nspec_gas.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nspec_gas,"dim_nspec_gas",ss%nspec_gas)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nspec_gas
        IF(nids%nid_dim_ngsc0.EQ.0) THEN
           CALL define_dim(nids%nid_dim_ngsc0,"dim_ngsc0",ss%ngsc0)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_ngsc0
        CALL define_var("sprof0","R",indim,idims, &
               "gas species source/sinks per unit species influx", &
               "(#/sec)/(#/sec)","GAS","STATE_PROFILES", &
               "R|step*dV|units=(#/sec)/(#/sec)  sprof0(~nrho_gas,nspec_gas,ngsc0)")
     ENDIF
  ENDIF

  iaddr = ps_phash_sprof0e
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%sprof0e).AND.ichange) THEN
     IF(cclist(ps_cnum_GAS).NE.1) THEN
        CALL ccwarn("sprof0e","GAS")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_gas.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_gas,"dm1_nrho_gas",ss%nrho_gas-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_gas
        IF(nids%nid_dim_ngsc0.EQ.0) THEN
           CALL define_dim(nids%nid_dim_ngsc0,"dim_ngsc0",ss%ngsc0)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_ngsc0
        CALL define_var("sprof0e","R",indim,idims, &
               "electron source per unit neutral species influx", &
               "(#/sec)/(#/sec)","GAS","STATE_PROFILES", &
               "R|step*dV|units=(#/sec)/(#/sec)  sprof0e(~nrho_gas,ngsc0)")
     ENDIF
  ENDIF

  iaddr = ps_phash_spsce
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%spsce).AND.ichange) THEN
     IF(cclist(ps_cnum_PEL).NE.1) THEN
        CALL ccwarn("spsce","PEL")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_pel.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_pel,"dm1_nrho_pel",ss%nrho_pel-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_pel
        IF(nids%nid_dp1_nspec_tha.EQ.0) THEN
           CALL define_dim(nids%nid_dp1_nspec_tha,"dp1_nspec_tha",ss%nspec_tha+1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dp1_nspec_tha
        CALL define_var("spsce","R",indim,idims, &
               "net source, thermal ions & electrons", &
               "#/sec","PEL","STATE_PROFILES", &
               "R|step*dV|units=#/sec   spsce(~nrho_pel,0:nspec_tha)")
     ENDIF
  ENDIF

  iaddr = ps_phash_squareLO
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%squareLO).AND.ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("squareLO","EQ")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_eq_geo.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_eq_geo,"dim_nrho_eq_geo",ss%nrho_eq_geo)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_eq_geo
        CALL define_var("squareLO","R",indim,idims, &
               "lower outer squareness", &
               "-","EQ","STATE_PROFILES", &
               "R|pclin  squareLO(nrho_eq_geo)")
     ENDIF
  ENDIF

  iaddr = ps_phash_squareUO
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%squareUO).AND.ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("squareUO","EQ")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_eq_geo.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_eq_geo,"dim_nrho_eq_geo",ss%nrho_eq_geo)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_eq_geo
        CALL define_var("squareUO","R",indim,idims, &
               "upper outer squareness", &
               "-","EQ","STATE_PROFILES", &
               "R|pclin  squareUO(nrho_eq_geo)")
     ENDIF
  ENDIF

  iaddr = ps_shash_sRtcen
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%sRtcen).AND.ichange) THEN
     IF(cclist(ps_cnum_NBI).NE.1) THEN
        CALL ccwarn("sRtcen","NBI")
     ELSE
        indim = 0
        IF(nids%nid_dim_nbeam.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nbeam,"dim_nbeam",ss%nbeam)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nbeam
        CALL define_var("sRtcen","R",indim,idims, &
               "signed tangency radius", &
               "m","NBI","MACHINE_DESCRIPTION", &
               "R|units=m       sRtcen(nbeam)")
     ENDIF
  ENDIF

  iaddr = ps_phash_surf
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%surf).AND.ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("surf","EQ")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_eq.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_eq,"dim_nrho_eq",ss%nrho_eq)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_eq
        CALL define_var("surf","R",indim,idims, &
               "area of flux surfaces", &
               "m^2","EQ","STATE_PROFILES", &
               "R|units=m^2|Spline surf(nrho_eq)")
     ENDIF
  ENDIF

  iaddr = ps_dhash_nspec_th
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%S_name).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("S_name","PLASMA")
     ELSE
        indim = 1
        idims(1)=nids%nid_clen_32
        IF(nids%nid_dp1_nspec_th.EQ.0) THEN
           CALL define_dim(nids%nid_dp1_nspec_th,"dp1_nspec_th",ss%nspec_th+1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dp1_nspec_th
        CALL define_var("S_name","N",indim,idims, &
               "thermal species list", &
               "__NONE","PLASMA","SHOT_CONFIGURATION", &
               "S|thermal_specie  S(0:nspec_th)")
     ENDIF
  ENDIF

  iaddr = ps_shash_s_to_sa
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%s_to_sa).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("s_to_sa","PLASMA")
     ELSE
        indim = 0
        IF(nids%nid_dp1_nspec_th.EQ.0) THEN
           CALL define_dim(nids%nid_dp1_nspec_th,"dp1_nspec_th",ss%nspec_th+1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dp1_nspec_th
        CALL define_var("s_to_sa","I",indim,idims, &
               "address in sa species list", &
               "__NONE","PLASMA","SIMULATION_INIT", &
               "I s_to_sa(0:nspec_th)")
     ENDIF
  ENDIF

  iaddr = ps_dhash_nspec_th
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%S_type).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("S_type","PLASMA")
     ELSE
        indim = 0
        IF(nids%nid_dp1_nspec_th.EQ.0) THEN
           CALL define_dim(nids%nid_dp1_nspec_th,"dp1_nspec_th",ss%nspec_th+1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dp1_nspec_th
        CALL define_var("S_type","I",indim,idims, &
               "S specie types", &
               "__NONE","PLASMA","SHOT_CONFIGURATION", &
               "S|thermal_specie  S(0:nspec_th)")
     ENDIF
  ENDIF

  iaddr = ps_shash_t0
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("t0","PLASMA")
     ELSE
        indim = 0
        CALL define_var("t0","R",indim,idims, &
               "time at beginning of IPS macro timestep", &
               "sec","PLASMA","STATE_DATA", &
               "R  t0")
     ENDIF
  ENDIF

  iaddr = ps_phash_T0cx
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%T0cx).AND.ichange) THEN
     IF(cclist(ps_cnum_GAS).NE.1) THEN
        CALL ccwarn("T0cx","GAS")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_gas.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_gas,"dm1_nrho_gas",ss%nrho_gas-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_gas
        IF(nids%nid_dim_ngsc0.EQ.0) THEN
           CALL define_dim(nids%nid_dim_ngsc0,"dim_ngsc0",ss%ngsc0)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_ngsc0
        CALL define_var("T0cx","R",indim,idims, &
               "effective neutral temperature for CX power", &
               "keV","GAS","STATE_PROFILES", &
               "R|step*qqcx|units=keV  T0cx(~nrho_gas,ngsc0)")
     ENDIF
  ENDIF

  iaddr = ps_phash_T0sc0
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%T0sc0).AND.ichange) THEN
     IF(cclist(ps_cnum_GAS).NE.1) THEN
        CALL ccwarn("T0sc0","GAS")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_gas.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_gas,"dm1_nrho_gas",ss%nrho_gas-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_gas
        IF(nids%nid_dim_nspec_gas.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nspec_gas,"dim_nspec_gas",ss%nspec_gas)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nspec_gas
        IF(nids%nid_dim_ngsc0.EQ.0) THEN
           CALL define_dim(nids%nid_dim_ngsc0,"dim_ngsc0",ss%ngsc0)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_ngsc0
        CALL define_var("T0sc0","R",indim,idims, &
               "neutral temperature (2/3)<E0>", &
               "keV","GAS","STATE_PROFILES", &
               "R|step*n0norm|units=keV        T0sc0(~nrho_gas,nspec_gas,ngsc0)")
     ENDIF
  ENDIF

  iaddr = ps_phash_T0_halo
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%T0_halo).AND.ichange) THEN
     IF(cclist(ps_cnum_NBI).NE.1) THEN
        CALL ccwarn("T0_halo","NBI")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_nbi.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_nbi,"dm1_nrho_nbi",ss%nrho_nbi-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_nbi
        IF(nids%nid_dim_nspec_gas.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nspec_gas,"dim_nspec_gas",ss%nspec_gas)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nspec_gas
        CALL define_var("T0_halo","R",indim,idims, &
               "halo neutral temperature (2/3)<E0>", &
               "keV","NBI","STATE_PROFILES", &
               "R|units=keV|step*n0_halo  T0_halo(~nrho_nbi,nspec_gas)")
     ENDIF
  ENDIF

  iaddr = ps_phash_T0_reco
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%T0_reco).AND.ichange) THEN
     IF(cclist(ps_cnum_GAS).NE.1) THEN
        CALL ccwarn("T0_reco","GAS")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_gas.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_gas,"dm1_nrho_gas",ss%nrho_gas-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_gas
        IF(nids%nid_dim_nspec_gas.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nspec_gas,"dim_nspec_gas",ss%nspec_gas)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nspec_gas
        CALL define_var("T0_reco","R",indim,idims, &
               "reco neutral temperature (2/3)<E0>", &
               "keV","GAS","STATE_PROFILES", &
               "R|units=keV|step*n0_reco  T0_reco(~nrho_gas,nspec_gas)")
     ENDIF
  ENDIF

  iaddr = ps_shash_t1
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("t1","PLASMA")
     ELSE
        indim = 0
        CALL define_var("t1","R",indim,idims, &
               "time at end of IPS macro timestep", &
               "sec","PLASMA","STATE_DATA", &
               "R  t1")
     ENDIF
  ENDIF

  iaddr = ps_phash_teflux_ky_tglf
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%teflux_ky_tglf).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("teflux_ky_tglf","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        IF(nids%nid_dim_nky_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nky_anomth,"dim_nky_anomth",ss%nky_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nky_anomth
        CALL define_var("teflux_ky_tglf","R",indim,idims, &
               "electron density flux spectrum", &
               "GB","ANOM","STATE_PROFILES", &
               "R|units=GB|pclin teflux_ky_tglf(nrho_anomth,nky_anomth)")
     ENDIF
  ENDIF

  iaddr = ps_shash_Te_bdy
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("Te_bdy","PLASMA")
     ELSE
        indim = 0
        CALL define_var("Te_bdy","R",indim,idims, &
               "Electron temperature at/beyond boundary", &
               "KeV","PLASMA","STATE_DATA", &
               "R Te_bdy")
     ENDIF
  ENDIF

  iaddr = ps_phash_te_ky_tglf
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%te_ky_tglf).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("te_ky_tglf","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        IF(nids%nid_dim_nky_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nky_anomth,"dim_nky_anomth",ss%nky_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nky_anomth
        CALL define_var("te_ky_tglf","R",indim,idims, &
               "electron density fluctuation spectrum", &
               "GB","ANOM","STATE_PROFILES", &
               "R|units=GB|pclin te_ky_tglf(nrho_anomth,nky_anomth)")
     ENDIF
  ENDIF
  CONTAINS


     SUBROUTINE define_dim(dimid,dname,idval)
        INTEGER, intent(out) :: dimid
        CHARACTER*(*), INTENT(in) :: dname
        INTEGER, intent(in) :: idval

        status = nf90_def_dim(icdf,dname,idval,dimid)
        IF(status.NE.NF90_NOERR) THEN
           WRITE(iout,*) ' ?ps_update_file_write: error defining dimension "'// &
                 trim(dname)//'".'
           IERR=9999
        ENDIF
     END SUBROUTINE define_dim



     SUBROUTINE define_var(name,dtype,indim,idims, &
          long_name,units,component,section,spec)

        CHARACTER*(*), INTENT(in) :: name
        CHARACTER*(*), INTENT(in) :: dtype
        INTEGER, INTENT(in) :: indim
        INTEGER, dimension(:), INTENT(in) :: idims
        CHARACTER*(*), INTENT(in) :: long_name
        CHARACTER*(*), INTENT(in) :: units
        CHARACTER*(*), INTENT(in) :: component
        CHARACTER*(*), INTENT(in) :: section
        CHARACTER*(*), INTENT(in) :: spec

        integer :: itype

        IF(dtype.EQ.'R') THEN
           itype = NF90_DOUBLE

        ELSE IF (dtype.EQ.'I') THEN
           itype = NF90_INT

        ELSE
           itype = NF90_CHAR

        ENDIF

        IF(indim.EQ.0) THEN
           status=nf90_def_var(icdf,name,itype, varid=varid)

        ELSE
           status=nf90_def_var(icdf,name,itype, dimids=idims(1:indim),varid=varid)

        ENDIF

        IF(status.NE.NF90_NOERR) THEN
           WRITE(iout,*) " ?plasma_state_store: error defining variable: "//trim(name)
           CALL ncerr(status)
           iertot = iertot + 1
           RETURN
        ENDIF

        ! Variable OK, now add attributes:

        CALL add_attrib("long_name",long_name)
        IF(dtype.EQ.'R') CALL add_attrib("units",units)
        CALL add_attrib("component",component)
        CALL add_attrib("section",section)
        CALL add_attrib("specification",spec)

     END SUBROUTINE define_var

     SUBROUTINE add_attrib(name,value)
        CHARACTER*(*), intent(in) :: name
        CHARACTER*(*), intent(in) :: value

        status=nf90_put_att(icdf,varid,name,value)
        IF(status.NE.NF90_NOERR) THEN
           WRITE(iout,*) " ?plasma_state_store: error defining attribute: "//trim(name)//' = '//trim(value)
           CALL ncerr(status)
           iertot = iertot + 1
        ENDIF
     END SUBROUTINE add_attrib



     SUBROUTINE ncerr(status)
        INTEGER, INTENT(in) :: status

        nc_errmsg = NF90_strerror(status)
        write(iout,*) '  NetCDF message: ',trim(nc_errmsg)
     END SUBROUTINE ncerr



     SUBROUTINE ccwarn(varnam,compnam)

        CHARACTER*(*), intent(in) :: varnam   ! name of variable or array
        CHARACTER*(*), intent(in) :: compnam  ! name of component

        if(iwarn.eq.0) then
           write(iout,*) ' '
           write(iout,*) ' %ps_update_file_write: modified state elements'
           write(iout,*) '  exist which were not written due to the "cclist"'
           write(iout,*) '  input variable which screens out elements from'
           write(iout,*) '  selected components: cclist = ',cclist,';'
           write(iout,*) '  element values of 1 indicate components that are'
           write(iout,*) '  enabled for write.'
           write(iout,*) ' '
        endif

        iwarn = iwarn + 1

        write(iout,*) ' %ps_update_file_write: modified: ss%'// &
             trim(varnam)//' ('//trim(compnam)//' component) NOT WRITTEN.'

     END SUBROUTINE ccwarn

END SUBROUTINE ps_update_file_write_def_7

SUBROUTINE ps_update_file_write_7(ss,icdf,cclist,iucount,iout,iwarn,iertot)


  ! Write updated data

  USE plasma_state_definition_mod
  USE netcdf
  IMPLICIT NONE

  TYPE (plasma_state) :: ss  ! state containing array elements to be allocated
  INTEGER, INTENT(IN) :: icdf  ! NetCDF file ID
  INTEGER, INTENT(IN) :: cclist(ps_ccount)  ! component selection
  INTEGER, INTENT(INOUT) :: iucount ! update count
  INTEGER, INTENT(IN) :: iout  ! LUN for messages
  INTEGER, INTENT(INOUT) :: iwarn   ! warn count
  INTEGER, INTENT(INOUT) :: iertot  ! error count

  !-------------------

  INTEGER :: varid,status
  CHARACTER*80 :: nc_errmsg

  !-------------------


  status = nf90_inq_varid(icdf,"Rloc_coil",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%Rloc_coil)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: Rloc_coil"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Rmajor_mean",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%Rmajor_mean)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: Rmajor_mean"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"rMinor_mean",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%rMinor_mean)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: rMinor_mean"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"RUNAWAY_Code_Info",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%RUNAWAY_Code_Info)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: RUNAWAY_Code_Info"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"RunID",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%RunID)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: RunID"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"R_ant",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%R_ant)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: R_ant"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"R_antgeo",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%R_antgeo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: R_antgeo"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"R_axis",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%R_axis)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: R_axis"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"R_EC_launch",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%R_EC_launch)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: R_EC_launch"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"R_geo",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%R_geo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: R_geo"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"R_grid",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%R_grid)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: R_grid"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"R_max_box",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%R_max_box)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: R_max_box"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"R_max_lcfs",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%R_max_lcfs)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: R_max_lcfs"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"R_midp_in",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%R_midp_in)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: R_midp_in"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"R_midp_out",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%R_midp_out)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: R_midp_out"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"R_min_box",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%R_min_box)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: R_min_box"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"R_min_lcfs",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%R_min_lcfs)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: R_min_lcfs"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"R_ripple",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%R_ripple)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: R_ripple"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"R_surfMax",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%R_surfMax)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: R_surfMax"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"R_surfMin",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%R_surfMin)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: R_surfMin"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"s0reco",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%s0reco)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: s0reco"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"s0reco_e",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%s0reco_e)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: s0reco_e"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"s0reco_recap",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%s0reco_recap)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: s0reco_recap"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"sa_index",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%sa_index)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: sa_index"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"SA_name",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%SA_name)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: SA_name"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"SA_type",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%SA_type)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: SA_type"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"sb0halo",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%sb0halo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: sb0halo"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"sb0halo_recap",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%sb0halo_recap)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: sb0halo_recap"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"sbedep",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%sbedep)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: sbedep"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"sbehalo",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%sbehalo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: sbehalo"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"sbsce",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%sbsce)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: sbsce"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"sbtherm",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%sbtherm)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: sbtherm"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"sc0",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%sc0)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: sc0"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"sc0_to_sgas",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%sc0_to_sgas)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: sc0_to_sgas"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"sc_anom",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%sc_anom)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: sc_anom"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"sfsce",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%sfsce)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: sfsce"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"sftherm",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%sftherm)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: sftherm"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"SFUS_name",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%SFUS_name)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: SFUS_name"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"sfus_to_all",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%sfus_to_all)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: sfus_to_all"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"sfus_to_alla",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%sfus_to_alla)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: sfus_to_alla"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"SFUS_type",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%SFUS_type)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: SFUS_type"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"SGAS_name",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%SGAS_name)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: SGAS_name"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"sgas_to_s",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%sgas_to_s)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: sgas_to_s"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"SGAS_type",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%SGAS_type)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: SGAS_type"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"shot_number",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%shot_number)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: shot_number"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"sii_xs",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%sii_xs)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: sii_xs"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"SIMP0_name",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%SIMP0_name)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: SIMP0_name"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"simp0_to_s",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%simp0_to_s)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: simp0_to_s"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"SIMP0_type",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%SIMP0_type)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: SIMP0_type"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"SIMPI_name",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%SIMPI_name)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: SIMPI_name"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"simpi_to_s",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%simpi_to_s)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: simpi_to_s"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"SIMPI_type",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%SIMPI_type)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: SIMPI_type"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"SNBI_name",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%SNBI_name)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: SNBI_name"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"snbi_to_all",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%snbi_to_all)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: snbi_to_all"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"snbi_to_alla",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%snbi_to_alla)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: snbi_to_alla"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"SNBI_type",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%SNBI_type)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: SNBI_type"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"sn_trans",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%sn_trans)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: sn_trans"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"sn_transcat",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%sn_transcat)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: sn_transcat"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"sprof0",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%sprof0)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: sprof0"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"sprof0e",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%sprof0e)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: sprof0e"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"spsce",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%spsce)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: spsce"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"squareLO",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%squareLO)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: squareLO"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"squareUO",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%squareUO)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: squareUO"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"sRtcen",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%sRtcen)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: sRtcen"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"surf",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%surf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: surf"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"S_name",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%S_name)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: S_name"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"s_to_sa",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%s_to_sa)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: s_to_sa"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"S_type",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%S_type)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: S_type"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"t0",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%t0)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: t0"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"T0cx",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%T0cx)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: T0cx"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"T0sc0",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%T0sc0)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: T0sc0"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"T0_halo",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%T0_halo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: T0_halo"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"T0_reco",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%T0_reco)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: T0_reco"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"t1",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%t1)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: t1"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"teflux_ky_tglf",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%teflux_ky_tglf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: teflux_ky_tglf"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Te_bdy",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%Te_bdy)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: Te_bdy"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"te_ky_tglf",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%te_ky_tglf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: te_ky_tglf"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF
  CONTAINS


     SUBROUTINE ncerr(status)
        INTEGER, INTENT(in) :: status

        nc_errmsg = NF90_strerror(status)
        write(iout,*) '  NetCDF message: ',trim(nc_errmsg)
     END SUBROUTINE ncerr

END SUBROUTINE ps_update_file_write_7

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_d6_dummy
     return
  end subroutine ccps_getset_d6_dummy

subroutine psget_difb_fusi(iobj, n1, data, ierr)
    !! fusion ion anomalous diffusivity
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_difb_fusi', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % difb_fusi
end subroutine psget_difb_fusi


subroutine psset_difb_fusi(iobj, n1, data, ierr)
    !! fusion ion anomalous diffusivity
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_difb_fusi', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % difb_fusi = data(1:n1)
end subroutine psset_difb_fusi


subroutine psgetrnk_difb_fusi(iobj, ndims, ierr)
    !! fusion ion anomalous diffusivity
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_difb_fusi


subroutine psgetdim_difb_fusi(iobj, ndims, dims, ierr)
    !! fusion ion anomalous diffusivity
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_difb_fusi', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % difb_fusi ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % difb_fusi)
    endif
end subroutine psgetdim_difb_fusi


subroutine psget_difns_tglf(iobj, n1, n2, data, ierr)
    !! density-equations, diffusivity from TGLF model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_difns_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % difns_tglf
end subroutine psget_difns_tglf


subroutine psset_difns_tglf(iobj, n1, n2, data, ierr)
    !! density-equations, diffusivity from TGLF model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_difns_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % difns_tglf = data(1:n1, 1: n2)
end subroutine psset_difns_tglf


subroutine psgetrnk_difns_tglf(iobj, ndims, ierr)
    !! density-equations, diffusivity from TGLF model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_difns_tglf


subroutine psgetdim_difns_tglf(iobj, ndims, dims, ierr)
    !! density-equations, diffusivity from TGLF model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_difns_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % difns_tglf ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % difns_tglf)
    endif
end subroutine psgetdim_difns_tglf


subroutine psget_db_mtm(iobj, n1, data, ierr)
    !! dB/B from MTM model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_db_mtm', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % db_mtm
end subroutine psget_db_mtm


subroutine psset_db_mtm(iobj, n1, data, ierr)
    !! dB/B from MTM model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_db_mtm', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % db_mtm = data(1:n1)
end subroutine psset_db_mtm


subroutine psgetrnk_db_mtm(iobj, ndims, ierr)
    !! dB/B from MTM model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_db_mtm


subroutine psgetdim_db_mtm(iobj, ndims, dims, ierr)
    !! dB/B from MTM model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_db_mtm', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % db_mtm ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % db_mtm)
    endif
end subroutine psgetdim_db_mtm


subroutine psget_dz_geo_drho(iobj, n1, n2, data, ierr)
    !! flux surfaces Z(rho,theta)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_dz_geo_drho', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % dZ_geo_dRHO
end subroutine psget_dz_geo_drho


subroutine psset_dz_geo_drho(iobj, n1, n2, data, ierr)
    !! flux surfaces Z(rho,theta)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_dz_geo_drho', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % dZ_geo_dRHO = data(1:n1, 1: n2)
end subroutine psset_dz_geo_drho


subroutine psgetrnk_dz_geo_drho(iobj, ndims, ierr)
    !! flux surfaces Z(rho,theta)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_dz_geo_drho


subroutine psgetdim_dz_geo_drho(iobj, ndims, dims, ierr)
    !! flux surfaces Z(rho,theta)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_dz_geo_drho', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % dZ_geo_dRHO ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % dZ_geo_dRHO)
    endif
end subroutine psgetdim_dz_geo_drho

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_e1_dummy
     return
  end subroutine ccps_getset_e1_dummy

subroutine psget_einj_min(iobj, n1, data, ierr)
    !! minimum injection energy, minimum energy of the full energy
    !! fractional component of each beam
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_einj_min', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % Einj_min
end subroutine psget_einj_min


subroutine psset_einj_min(iobj, n1, data, ierr)
    !! minimum injection energy, minimum energy of the full energy
    !! fractional component of each beam
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_einj_min', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % Einj_min = data(1:n1)
end subroutine psset_einj_min


subroutine psgetrnk_einj_min(iobj, ndims, ierr)
    !! minimum injection energy, minimum energy of the full energy
    !! fractional component of each beam
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_einj_min


subroutine psgetdim_einj_min(iobj, ndims, dims, ierr)
    !! minimum injection energy, minimum energy of the full energy
    !! fractional component of each beam
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_einj_min', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % Einj_min ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % Einj_min)
    endif
end subroutine psgetdim_einj_min


subroutine psget_ec_princ_curv_vert(iobj, n1, data, ierr)
    !! principal curvature in vertical direction
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_ec_princ_curv_vert', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % EC_PRINC_CURV_VERT
end subroutine psget_ec_princ_curv_vert


subroutine psset_ec_princ_curv_vert(iobj, n1, data, ierr)
    !! principal curvature in vertical direction
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_ec_princ_curv_vert', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % EC_PRINC_CURV_VERT = data(1:n1)
end subroutine psset_ec_princ_curv_vert


subroutine psgetrnk_ec_princ_curv_vert(iobj, ndims, ierr)
    !! principal curvature in vertical direction
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_ec_princ_curv_vert


subroutine psgetdim_ec_princ_curv_vert(iobj, ndims, dims, ierr)
    !! principal curvature in vertical direction
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_ec_princ_curv_vert', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % EC_PRINC_CURV_VERT ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % EC_PRINC_CURV_VERT)
    endif
end subroutine psgetdim_ec_princ_curv_vert


subroutine psget_ec_code_info(iobj, data, ierr)
    !! Information: code implementing EC component
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    CHARACTER*(*), intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_ec_code_info', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % EC_Code_Info
end subroutine psget_ec_code_info


subroutine psset_ec_code_info(iobj, data, ierr)
    !! Information: code implementing EC component
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    CHARACTER*(*), intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_ec_code_info', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % EC_Code_Info = data
end subroutine psset_ec_code_info


subroutine psgetsz_ec_code_info(iobj, size, ierr)
    !! Information: code implementing EC component
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: size    ! size of character string
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psgetsz_ec_code_info', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! note that the following will return the character length size regardless of
    ! the number of array elements (if EC_Code_Info is an array)
    size = len(ss % EC_Code_Info)
end subroutine psgetsz_ec_code_info


subroutine psget_e_anom(iobj, n1, data, ierr)
    !! (optional) energy grid (1d profiles), for separated
    !! variation of fast ion, anomalous transport with fast ion energy
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_e_anom', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % E_anom
end subroutine psget_e_anom


subroutine psset_e_anom(iobj, n1, data, ierr)
    !! (optional) energy grid (1d profiles), for separated
    !! variation of fast ion, anomalous transport with fast ion energy
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_e_anom', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % E_anom = data(1:n1)
end subroutine psset_e_anom


subroutine psgetrnk_e_anom(iobj, ndims, ierr)
    !! (optional) energy grid (1d profiles), for separated
    !! variation of fast ion, anomalous transport with fast ion energy
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_e_anom


subroutine psgetdim_e_anom(iobj, ndims, dims, ierr)
    !! (optional) energy grid (1d profiles), for separated
    !! variation of fast ion, anomalous transport with fast ion energy
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_e_anom', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % E_anom ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % E_anom)
    endif
end subroutine psgetdim_e_anom


subroutine psget_eldot(iobj, data, ierr)
    !! [d(Philim)/dt]/[2*Philim]
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_eldot', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % eldot
end subroutine psget_eldot


subroutine psset_eldot(iobj, data, ierr)
    !! [d(Philim)/dt]/[2*Philim]
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_eldot', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % eldot = data
end subroutine psset_eldot

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_d9_dummy
     return
  end subroutine ccps_getset_d9_dummy

subroutine psget_d_einj_standard(iobj, n1, data, ierr)
    !! D beam table energies, for full-half-third energy beam
    !! current fractions data
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_d_einj_standard', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % D_einj_standard
end subroutine psget_d_einj_standard


subroutine psset_d_einj_standard(iobj, n1, data, ierr)
    !! D beam table energies, for full-half-third energy beam
    !! current fractions data
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_d_einj_standard', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % D_einj_standard = data(1:n1)
end subroutine psset_d_einj_standard


subroutine psgetrnk_d_einj_standard(iobj, ndims, ierr)
    !! D beam table energies, for full-half-third energy beam
    !! current fractions data
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_d_einj_standard


subroutine psgetdim_d_einj_standard(iobj, ndims, dims, ierr)
    !! D beam table energies, for full-half-third energy beam
    !! current fractions data
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_d_einj_standard', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % D_einj_standard ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % D_einj_standard)
    endif
end subroutine psgetdim_d_einj_standard


subroutine psget_deltaw_mapper(iobj, n1, data, ierr)
    !! mapper code used for each delta(W) code
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    CHARACTER*(*), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_deltaw_mapper', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % DeltaW_mapper
end subroutine psget_deltaw_mapper


subroutine psset_deltaw_mapper(iobj, n1, data, ierr)
    !! mapper code used for each delta(W) code
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    CHARACTER*(*), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_deltaw_mapper', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % DeltaW_mapper = data(1:n1)
end subroutine psset_deltaw_mapper


subroutine psgetsz_deltaw_mapper(iobj, size, ierr)
    !! mapper code used for each delta(W) code
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: size    ! size of character string
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psgetsz_deltaw_mapper', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! note that the following will return the character length size regardless of
    ! the number of array elements (if DeltaW_mapper is an array)
    size = len(ss % DeltaW_mapper)
end subroutine psgetsz_deltaw_mapper


subroutine psgetrnk_deltaw_mapper(iobj, ndims, ierr)
    !! mapper code used for each delta(W) code
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_deltaw_mapper


subroutine psgetdim_deltaw_mapper(iobj, ndims, dims, ierr)
    !! mapper code used for each delta(W) code
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_deltaw_mapper', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % DeltaW_mapper ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % DeltaW_mapper)
    endif
end subroutine psgetdim_deltaw_mapper


subroutine psget_dqedgrdte_tglf(iobj, n1, data, ierr)
    !! Te flux gradient term from TGLF model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_dqedgrdte_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % dQedGrdte_tglf
end subroutine psget_dqedgrdte_tglf


subroutine psset_dqedgrdte_tglf(iobj, n1, data, ierr)
    !! Te flux gradient term from TGLF model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_dqedgrdte_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % dQedGrdte_tglf = data(1:n1)
end subroutine psset_dqedgrdte_tglf


subroutine psgetrnk_dqedgrdte_tglf(iobj, ndims, ierr)
    !! Te flux gradient term from TGLF model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_dqedgrdte_tglf


subroutine psgetdim_dqedgrdte_tglf(iobj, ndims, dims, ierr)
    !! Te flux gradient term from TGLF model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_dqedgrdte_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % dQedGrdte_tglf ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % dQedGrdte_tglf)
    endif
end subroutine psgetdim_dqedgrdte_tglf


subroutine psget_difns_glf(iobj, n1, n2, data, ierr)
    !! density-equations, diffusivity from GLF23 model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_difns_glf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % difns_glf
end subroutine psget_difns_glf


subroutine psset_difns_glf(iobj, n1, n2, data, ierr)
    !! density-equations, diffusivity from GLF23 model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_difns_glf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % difns_glf = data(1:n1, 1: n2)
end subroutine psset_difns_glf


subroutine psgetrnk_difns_glf(iobj, ndims, ierr)
    !! density-equations, diffusivity from GLF23 model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_difns_glf


subroutine psgetdim_difns_glf(iobj, ndims, dims, ierr)
    !! density-equations, diffusivity from GLF23 model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_difns_glf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % difns_glf ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % difns_glf)
    endif
end subroutine psgetdim_difns_glf


subroutine psget_difne_nclass(iobj, n1, data, ierr)
    !! electron-density-equations, neoclassical diffusivity from
    !! NCLASS model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_difne_nclass', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % difne_nclass
end subroutine psget_difne_nclass


subroutine psset_difne_nclass(iobj, n1, data, ierr)
    !! electron-density-equations, neoclassical diffusivity from
    !! NCLASS model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_difne_nclass', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % difne_nclass = data(1:n1)
end subroutine psset_difne_nclass


subroutine psgetrnk_difne_nclass(iobj, ndims, ierr)
    !! electron-density-equations, neoclassical diffusivity from
    !! NCLASS model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_difne_nclass


subroutine psgetdim_difne_nclass(iobj, ndims, dims, ierr)
    !! electron-density-equations, neoclassical diffusivity from
    !! NCLASS model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_difne_nclass', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % difne_nclass ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % difne_nclass)
    endif
end subroutine psgetdim_difne_nclass


subroutine psget_dr0_momeq_drho(iobj, n1, data, ierr)
    !! R0 of flux surface, Fourier Spline representation
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_dr0_momeq_drho', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % dR0_momeq_dRHO
end subroutine psget_dr0_momeq_drho


subroutine psset_dr0_momeq_drho(iobj, n1, data, ierr)
    !! R0 of flux surface, Fourier Spline representation
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_dr0_momeq_drho', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % dR0_momeq_dRHO = data(1:n1)
end subroutine psset_dr0_momeq_drho


subroutine psgetrnk_dr0_momeq_drho(iobj, ndims, ierr)
    !! R0 of flux surface, Fourier Spline representation
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_dr0_momeq_drho


subroutine psgetdim_dr0_momeq_drho(iobj, ndims, dims, ierr)
    !! R0 of flux surface, Fourier Spline representation
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_dr0_momeq_drho', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % dR0_momeq_dRHO ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % dR0_momeq_dRHO)
    endif
end subroutine psgetdim_dr0_momeq_drho

!******************** START FILE IERFCN.FOR ; GROUP FILTR6 ******************
!
!  IERFCN   TEST Y(J)-YSM(J)
!   IERFCN=1==> EPSLON VIOLATION
!   IERFCN=0==> NO VIOLATION
!
!   ISIGN=SIGN OF VIOLATION
!   DY=MAGNITUDE OF VIOLATION
!
INTEGER FUNCTION r8ierfcn(Y,YSM,N,JP,EPS,NE,DY,ISIGN)
  use iso_c_binding, only: fp => c_double
  use physconst_mod, only: ZERO, HALF, ONE
  implicit none
  ! Arguments
  integer, intent(in) :: n, jp, ne
  real(fp), dimension(n), intent(in) :: y
  real(fp), dimension(n), intent(in) :: ysm
  real(fp), dimension(ne), intent(in) :: eps
  real(fp), intent(out) :: dy
  integer, intent(out) :: isign
  ! Local variables
  real(fp) :: zeps
!
  r8ierfcn=0
  ZEPS=EPS(NE)
  IF(JP.LT.NE) ZEPS=EPS(JP)
  DY=Y(JP)-YSM(JP)
  ISIGN=SIGN(ONE,DY)
  DY=ABS(DY)
  IF(DY.LE.ZEPS) RETURN
  r8ierfcn=1
  RETURN
END FUNCTION r8ierfcn

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


SUBROUTINE plasma_state_zonwt_update(ss,ierr)

  !   update zone weighting index map

  USE plasma_state_definition_mod
  IMPLICIT NONE

  TYPE (plasma_state) :: ss    ! state object to be updated
  INTEGER, INTENT(OUT) :: ierr  ! completion code (0=OK)

  !-------------------
  INTEGER :: iout,isize,i1,i2,i3,i4,iertot,iertarg,ierval
  !-------------------

  iout = SWIM_err_out_file

  ierr = 0

  CALL ps_maxid(ss%iobj, isize, iout, ierr)
  if(ierr.NE.0) return

  ! reallocate to a safe size; initialize all elements to ZERO

  IF(ALLOCATED(ss%id_zonwt)) DEALLOCATE(ss%id_zonwt)
  ALLOCATE(ss%id_zonwt(isize))
  ss%id_zonwt = 0

  iertot = 0

  IF(ALLOCATED(ss%id_NBEAMI)) THEN
     iertarg = 0; ierval = 0
     DO I1 = 1,ss%nspec_beam
        IF((ss%id_eperp_beami(I1).GT.0).AND.(ss%id_eperp_beami(I1).LE.isize)) THEN
           IF((ss%id_NBEAMI(I1).GT.0).AND.(ss%id_NBEAMI(I1).LE.isize)) THEN
              ss%id_zonwt(ss%id_eperp_beami(I1)) = ss%id_NBEAMI(I1)
           ELSE
              ierval = ierval + 1
           ENDIF
        ELSE
           iertarg = iertarg + 1
        ENDIF
     ENDDO   ! I1
     IF(iertarg.GT.0) THEN
        WRITE(iout,*) " ?plasma_state_zonwt_update target element out of bounds detected!"
        write(IOUT,*) "  id_eperp_beami: ",ss%id_eperp_beami
        write(IOUT,*) "  allowable range is 1 to ",isize
        iertot = iertot + 1
     ENDIF
     IF(ierval.GT.0) THEN
        WRITE(iout,*) " ?plasma_state_zonwt_update weight element out of bounds detected!"
        write(IOUT,*) "  id_NBEAMI: ",ss%id_NBEAMI
        write(IOUT,*) "  allowable range is 1 to ",isize
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%id_NFUSI)) THEN
     iertarg = 0; ierval = 0
     DO I1 = 1,ss%nspec_fusion
        IF((ss%id_eperp_fusi(I1).GT.0).AND.(ss%id_eperp_fusi(I1).LE.isize)) THEN
           IF((ss%id_NFUSI(I1).GT.0).AND.(ss%id_NFUSI(I1).LE.isize)) THEN
              ss%id_zonwt(ss%id_eperp_fusi(I1)) = ss%id_NFUSI(I1)
           ELSE
              ierval = ierval + 1
           ENDIF
        ELSE
           iertarg = iertarg + 1
        ENDIF
     ENDDO   ! I1
     IF(iertarg.GT.0) THEN
        WRITE(iout,*) " ?plasma_state_zonwt_update target element out of bounds detected!"
        write(IOUT,*) "  id_eperp_fusi: ",ss%id_eperp_fusi
        write(IOUT,*) "  allowable range is 1 to ",isize
        iertot = iertot + 1
     ENDIF
     IF(ierval.GT.0) THEN
        WRITE(iout,*) " ?plasma_state_zonwt_update weight element out of bounds detected!"
        write(IOUT,*) "  id_NFUSI: ",ss%id_NFUSI
        write(IOUT,*) "  allowable range is 1 to ",isize
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%id_NMINI)) THEN
     iertarg = 0; ierval = 0
     DO I1 = 1,ss%nspec_rfmin
        IF((ss%id_eperp_mini(I1).GT.0).AND.(ss%id_eperp_mini(I1).LE.isize)) THEN
           IF((ss%id_NMINI(I1).GT.0).AND.(ss%id_NMINI(I1).LE.isize)) THEN
              ss%id_zonwt(ss%id_eperp_mini(I1)) = ss%id_NMINI(I1)
           ELSE
              ierval = ierval + 1
           ENDIF
        ELSE
           iertarg = iertarg + 1
        ENDIF
     ENDDO   ! I1
     IF(iertarg.GT.0) THEN
        WRITE(iout,*) " ?plasma_state_zonwt_update target element out of bounds detected!"
        write(IOUT,*) "  id_eperp_mini: ",ss%id_eperp_mini
        write(IOUT,*) "  allowable range is 1 to ",isize
        iertot = iertot + 1
     ENDIF
     IF(ierval.GT.0) THEN
        WRITE(iout,*) " ?plasma_state_zonwt_update weight element out of bounds detected!"
        write(IOUT,*) "  id_NMINI: ",ss%id_NMINI
        write(IOUT,*) "  allowable range is 1 to ",isize
        iertot = iertot + 1
     ENDIF
  ENDIF
  !singleton
  IF(ss%id_eperp_rw.GT.0) THEN
     IF(ss%id_eperp_rw.LE.isize) THEN
        IF((ss%id_NRW.GT.0).AND.(ss%id_NRW.LE.isize)) THEN
           ss%id_zonwt(ss%id_eperp_rw) = ss%id_NRW
        ELSE
           WRITE(iout,*) " ?plasma_state_zonwt_update weight element out of bounds detected!"
           write(IOUT,*) "  id_NRW: ",ss%id_NRW
           write(IOUT,*) "  allowable range is 1 to ",isize
           iertot = iertot + 1
        ENDIF
     ELSE
        WRITE(iout,*) " ?plasma_state_zonwt_update weight element out of bounds detected!"
        write(IOUT,*) "  id_eperp_rw: ",ss%id_eperp_rw
        write(IOUT,*) "  allowable range is 1 to ",isize
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%id_NBEAMI)) THEN
     iertarg = 0; ierval = 0
     DO I1 = 1,ss%nspec_beam
        IF((ss%id_epll_beami(I1).GT.0).AND.(ss%id_epll_beami(I1).LE.isize)) THEN
           IF((ss%id_NBEAMI(I1).GT.0).AND.(ss%id_NBEAMI(I1).LE.isize)) THEN
              ss%id_zonwt(ss%id_epll_beami(I1)) = ss%id_NBEAMI(I1)
           ELSE
              ierval = ierval + 1
           ENDIF
        ELSE
           iertarg = iertarg + 1
        ENDIF
     ENDDO   ! I1
     IF(iertarg.GT.0) THEN
        WRITE(iout,*) " ?plasma_state_zonwt_update target element out of bounds detected!"
        write(IOUT,*) "  id_epll_beami: ",ss%id_epll_beami
        write(IOUT,*) "  allowable range is 1 to ",isize
        iertot = iertot + 1
     ENDIF
     IF(ierval.GT.0) THEN
        WRITE(iout,*) " ?plasma_state_zonwt_update weight element out of bounds detected!"
        write(IOUT,*) "  id_NBEAMI: ",ss%id_NBEAMI
        write(IOUT,*) "  allowable range is 1 to ",isize
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%id_NFUSI)) THEN
     iertarg = 0; ierval = 0
     DO I1 = 1,ss%nspec_fusion
        IF((ss%id_epll_fusi(I1).GT.0).AND.(ss%id_epll_fusi(I1).LE.isize)) THEN
           IF((ss%id_NFUSI(I1).GT.0).AND.(ss%id_NFUSI(I1).LE.isize)) THEN
              ss%id_zonwt(ss%id_epll_fusi(I1)) = ss%id_NFUSI(I1)
           ELSE
              ierval = ierval + 1
           ENDIF
        ELSE
           iertarg = iertarg + 1
        ENDIF
     ENDDO   ! I1
     IF(iertarg.GT.0) THEN
        WRITE(iout,*) " ?plasma_state_zonwt_update target element out of bounds detected!"
        write(IOUT,*) "  id_epll_fusi: ",ss%id_epll_fusi
        write(IOUT,*) "  allowable range is 1 to ",isize
        iertot = iertot + 1
     ENDIF
     IF(ierval.GT.0) THEN
        WRITE(iout,*) " ?plasma_state_zonwt_update weight element out of bounds detected!"
        write(IOUT,*) "  id_NFUSI: ",ss%id_NFUSI
        write(IOUT,*) "  allowable range is 1 to ",isize
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%id_NMINI)) THEN
     iertarg = 0; ierval = 0
     DO I1 = 1,ss%nspec_rfmin
        IF((ss%id_epll_mini(I1).GT.0).AND.(ss%id_epll_mini(I1).LE.isize)) THEN
           IF((ss%id_NMINI(I1).GT.0).AND.(ss%id_NMINI(I1).LE.isize)) THEN
              ss%id_zonwt(ss%id_epll_mini(I1)) = ss%id_NMINI(I1)
           ELSE
              ierval = ierval + 1
           ENDIF
        ELSE
           iertarg = iertarg + 1
        ENDIF
     ENDDO   ! I1
     IF(iertarg.GT.0) THEN
        WRITE(iout,*) " ?plasma_state_zonwt_update target element out of bounds detected!"
        write(IOUT,*) "  id_epll_mini: ",ss%id_epll_mini
        write(IOUT,*) "  allowable range is 1 to ",isize
        iertot = iertot + 1
     ENDIF
     IF(ierval.GT.0) THEN
        WRITE(iout,*) " ?plasma_state_zonwt_update weight element out of bounds detected!"
        write(IOUT,*) "  id_NMINI: ",ss%id_NMINI
        write(IOUT,*) "  allowable range is 1 to ",isize
        iertot = iertot + 1
     ENDIF
  ENDIF
  !singleton
  IF(ss%id_epll_rw.GT.0) THEN
     IF(ss%id_epll_rw.LE.isize) THEN
        IF((ss%id_NRW.GT.0).AND.(ss%id_NRW.LE.isize)) THEN
           ss%id_zonwt(ss%id_epll_rw) = ss%id_NRW
        ELSE
           WRITE(iout,*) " ?plasma_state_zonwt_update weight element out of bounds detected!"
           write(IOUT,*) "  id_NRW: ",ss%id_NRW
           write(IOUT,*) "  allowable range is 1 to ",isize
           iertot = iertot + 1
        ENDIF
     ELSE
        WRITE(iout,*) " ?plasma_state_zonwt_update weight element out of bounds detected!"
        write(IOUT,*) "  id_epll_rw: ",ss%id_epll_rw
        write(IOUT,*) "  allowable range is 1 to ",isize
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%id_NS)) THEN
     IF((ss%id_Fi_depletion.GT.0).AND.(ss%id_Fi_depletion.LE.isize)) THEN
        IF((ss%id_NS(PS_ELEC_INDEX).GT.0).AND.(ss%id_NS(PS_ELEC_INDEX).LE.isize)) THEN
           ss%id_zonwt(ss%id_Fi_depletion) = ss%id_NS(PS_ELEC_INDEX)
        ELSE
           iertot=iertot+1
           WRITE(iout,*) " ?plasma_state_zonwt_update element: id_NS(PS_ELEC_INDEX) = ",ss%id_NS(PS_ELEC_INDEX)
           WRITE(iout,*) "  out of bounds 1 to ",isize
        ENDIF
     ELSE
        iertot=iertot+1
        WRITE(iout,*) " ?plasma_state_zonwt_update element: id_Fi_depletion = ",ss%id_Fi_depletion
        WRITE(iout,*) "  out of bounds 1 to ",isize
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%id_TQQCX)) THEN
     iertarg = 0; ierval = 0
     DO I1 = 1,ss%ngsc0
        IF((ss%id_omeg0cx(I1).GT.0).AND.(ss%id_omeg0cx(I1).LE.isize)) THEN
           IF((ss%id_TQQCX(I1).GT.0).AND.(ss%id_TQQCX(I1).LE.isize)) THEN
              ss%id_zonwt(ss%id_omeg0cx(I1)) = ss%id_TQQCX(I1)
           ELSE
              ierval = ierval + 1
           ENDIF
        ELSE
           iertarg = iertarg + 1
        ENDIF
     ENDDO   ! I1
     IF(iertarg.GT.0) THEN
        WRITE(iout,*) " ?plasma_state_zonwt_update target element out of bounds detected!"
        write(IOUT,*) "  id_omeg0cx: ",ss%id_omeg0cx
        write(IOUT,*) "  allowable range is 1 to ",isize
        iertot = iertot + 1
     ENDIF
     IF(ierval.GT.0) THEN
        WRITE(iout,*) " ?plasma_state_zonwt_update weight element out of bounds detected!"
        write(IOUT,*) "  id_TQQCX: ",ss%id_TQQCX
        write(IOUT,*) "  allowable range is 1 to ",isize
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%id_N0NORM)) THEN
     iertarg = 0; ierval = 0
     DO I2 = 1,ss%ngsc0
        DO I1 = 1,ss%nspec_gas
           IF((ss%id_omeg0sc0(I1,I2).GT.0).AND.(ss%id_omeg0sc0(I1,I2).LE.isize)) THEN
              IF((ss%id_N0NORM(I1,I2).GT.0).AND.(ss%id_N0NORM(I1,I2).LE.isize)) THEN
                 ss%id_zonwt(ss%id_omeg0sc0(I1,I2)) = ss%id_N0NORM(I1,I2)
              ELSE
                 ierval = ierval + 1
              ENDIF
           ELSE
              iertarg = iertarg + 1
           ENDIF
        ENDDO   ! I1
     ENDDO   ! I2
     IF(iertarg.GT.0) THEN
        WRITE(iout,*) " ?plasma_state_zonwt_update target element out of bounds detected!"
        write(IOUT,*) "  id_omeg0sc0: ",ss%id_omeg0sc0
        write(IOUT,*) "  allowable range is 1 to ",isize
        iertot = iertot + 1
     ENDIF
     IF(ierval.GT.0) THEN
        WRITE(iout,*) " ?plasma_state_zonwt_update weight element out of bounds detected!"
        write(IOUT,*) "  id_N0NORM: ",ss%id_N0NORM
        write(IOUT,*) "  allowable range is 1 to ",isize
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%id_N0_HALO)) THEN
     iertarg = 0; ierval = 0
     DO I1 = 1,ss%nspec_gas
        IF((ss%id_omeg0_halo(I1).GT.0).AND.(ss%id_omeg0_halo(I1).LE.isize)) THEN
           IF((ss%id_N0_HALO(I1).GT.0).AND.(ss%id_N0_HALO(I1).LE.isize)) THEN
              ss%id_zonwt(ss%id_omeg0_halo(I1)) = ss%id_N0_HALO(I1)
           ELSE
              ierval = ierval + 1
           ENDIF
        ELSE
           iertarg = iertarg + 1
        ENDIF
     ENDDO   ! I1
     IF(iertarg.GT.0) THEN
        WRITE(iout,*) " ?plasma_state_zonwt_update target element out of bounds detected!"
        write(IOUT,*) "  id_omeg0_halo: ",ss%id_omeg0_halo
        write(IOUT,*) "  allowable range is 1 to ",isize
        iertot = iertot + 1
     ENDIF
     IF(ierval.GT.0) THEN
        WRITE(iout,*) " ?plasma_state_zonwt_update weight element out of bounds detected!"
        write(IOUT,*) "  id_N0_HALO: ",ss%id_N0_HALO
        write(IOUT,*) "  allowable range is 1 to ",isize
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%id_N0_RECO)) THEN
     iertarg = 0; ierval = 0
     DO I1 = 1,ss%nspec_gas
        IF((ss%id_omeg0_reco(I1).GT.0).AND.(ss%id_omeg0_reco(I1).LE.isize)) THEN
           IF((ss%id_N0_RECO(I1).GT.0).AND.(ss%id_N0_RECO(I1).LE.isize)) THEN
              ss%id_zonwt(ss%id_omeg0_reco(I1)) = ss%id_N0_RECO(I1)
           ELSE
              ierval = ierval + 1
           ENDIF
        ELSE
           iertarg = iertarg + 1
        ENDIF
     ENDDO   ! I1
     IF(iertarg.GT.0) THEN
        WRITE(iout,*) " ?plasma_state_zonwt_update target element out of bounds detected!"
        write(IOUT,*) "  id_omeg0_reco: ",ss%id_omeg0_reco
        write(IOUT,*) "  allowable range is 1 to ",isize
        iertot = iertot + 1
     ENDIF
     IF(ierval.GT.0) THEN
        WRITE(iout,*) " ?plasma_state_zonwt_update weight element out of bounds detected!"
        write(IOUT,*) "  id_N0_RECO: ",ss%id_N0_RECO
        write(IOUT,*) "  allowable range is 1 to ",isize
        iertot = iertot + 1
     ENDIF
  ENDIF
  !singleton
  IF(ss%id_omegat.GT.0) THEN
     IF(ss%id_omegat.LE.isize) THEN
        IF((ss%id_NI.GT.0).AND.(ss%id_NI.LE.isize)) THEN
           ss%id_zonwt(ss%id_omegat) = ss%id_NI
        ELSE
           WRITE(iout,*) " ?plasma_state_zonwt_update weight element out of bounds detected!"
           write(IOUT,*) "  id_NI: ",ss%id_NI
           write(IOUT,*) "  allowable range is 1 to ",isize
           iertot = iertot + 1
        ENDIF
     ELSE
        WRITE(iout,*) " ?plasma_state_zonwt_update weight element out of bounds detected!"
        write(IOUT,*) "  id_omegat: ",ss%id_omegat
        write(IOUT,*) "  allowable range is 1 to ",isize
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%id_NBEAMI)) THEN
     iertarg = 0; ierval = 0
     DO I1 = 1,ss%nspec_beam
        IF((ss%id_qbeami(I1).GT.0).AND.(ss%id_qbeami(I1).LE.isize)) THEN
           IF((ss%id_NBEAMI(I1).GT.0).AND.(ss%id_NBEAMI(I1).LE.isize)) THEN
              ss%id_zonwt(ss%id_qbeami(I1)) = ss%id_NBEAMI(I1)
           ELSE
              ierval = ierval + 1
           ENDIF
        ELSE
           iertarg = iertarg + 1
        ENDIF
     ENDDO   ! I1
     IF(iertarg.GT.0) THEN
        WRITE(iout,*) " ?plasma_state_zonwt_update target element out of bounds detected!"
        write(IOUT,*) "  id_qbeami: ",ss%id_qbeami
        write(IOUT,*) "  allowable range is 1 to ",isize
        iertot = iertot + 1
     ENDIF
     IF(ierval.GT.0) THEN
        WRITE(iout,*) " ?plasma_state_zonwt_update weight element out of bounds detected!"
        write(IOUT,*) "  id_NBEAMI: ",ss%id_NBEAMI
        write(IOUT,*) "  allowable range is 1 to ",isize
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%id_QQCX)) THEN
     iertarg = 0; ierval = 0
     DO I1 = 1,ss%ngsc0
        IF((ss%id_T0cx(I1).GT.0).AND.(ss%id_T0cx(I1).LE.isize)) THEN
           IF((ss%id_QQCX(I1).GT.0).AND.(ss%id_QQCX(I1).LE.isize)) THEN
              ss%id_zonwt(ss%id_T0cx(I1)) = ss%id_QQCX(I1)
           ELSE
              ierval = ierval + 1
           ENDIF
        ELSE
           iertarg = iertarg + 1
        ENDIF
     ENDDO   ! I1
     IF(iertarg.GT.0) THEN
        WRITE(iout,*) " ?plasma_state_zonwt_update target element out of bounds detected!"
        write(IOUT,*) "  id_T0cx: ",ss%id_T0cx
        write(IOUT,*) "  allowable range is 1 to ",isize
        iertot = iertot + 1
     ENDIF
     IF(ierval.GT.0) THEN
        WRITE(iout,*) " ?plasma_state_zonwt_update weight element out of bounds detected!"
        write(IOUT,*) "  id_QQCX: ",ss%id_QQCX
        write(IOUT,*) "  allowable range is 1 to ",isize
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%id_N0NORM)) THEN
     iertarg = 0; ierval = 0
     DO I2 = 1,ss%ngsc0
        DO I1 = 1,ss%nspec_gas
           IF((ss%id_T0sc0(I1,I2).GT.0).AND.(ss%id_T0sc0(I1,I2).LE.isize)) THEN
              IF((ss%id_N0NORM(I1,I2).GT.0).AND.(ss%id_N0NORM(I1,I2).LE.isize)) THEN
                 ss%id_zonwt(ss%id_T0sc0(I1,I2)) = ss%id_N0NORM(I1,I2)
              ELSE
                 ierval = ierval + 1
              ENDIF
           ELSE
              iertarg = iertarg + 1
           ENDIF
        ENDDO   ! I1
     ENDDO   ! I2
     IF(iertarg.GT.0) THEN
        WRITE(iout,*) " ?plasma_state_zonwt_update target element out of bounds detected!"
        write(IOUT,*) "  id_T0sc0: ",ss%id_T0sc0
        write(IOUT,*) "  allowable range is 1 to ",isize
        iertot = iertot + 1
     ENDIF
     IF(ierval.GT.0) THEN
        WRITE(iout,*) " ?plasma_state_zonwt_update weight element out of bounds detected!"
        write(IOUT,*) "  id_N0NORM: ",ss%id_N0NORM
        write(IOUT,*) "  allowable range is 1 to ",isize
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%id_N0_HALO)) THEN
     iertarg = 0; ierval = 0
     DO I1 = 1,ss%nspec_gas
        IF((ss%id_T0_halo(I1).GT.0).AND.(ss%id_T0_halo(I1).LE.isize)) THEN
           IF((ss%id_N0_HALO(I1).GT.0).AND.(ss%id_N0_HALO(I1).LE.isize)) THEN
              ss%id_zonwt(ss%id_T0_halo(I1)) = ss%id_N0_HALO(I1)
           ELSE
              ierval = ierval + 1
           ENDIF
        ELSE
           iertarg = iertarg + 1
        ENDIF
     ENDDO   ! I1
     IF(iertarg.GT.0) THEN
        WRITE(iout,*) " ?plasma_state_zonwt_update target element out of bounds detected!"
        write(IOUT,*) "  id_T0_halo: ",ss%id_T0_halo
        write(IOUT,*) "  allowable range is 1 to ",isize
        iertot = iertot + 1
     ENDIF
     IF(ierval.GT.0) THEN
        WRITE(iout,*) " ?plasma_state_zonwt_update weight element out of bounds detected!"
        write(IOUT,*) "  id_N0_HALO: ",ss%id_N0_HALO
        write(IOUT,*) "  allowable range is 1 to ",isize
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%id_N0_RECO)) THEN
     iertarg = 0; ierval = 0
     DO I1 = 1,ss%nspec_gas
        IF((ss%id_T0_reco(I1).GT.0).AND.(ss%id_T0_reco(I1).LE.isize)) THEN
           IF((ss%id_N0_RECO(I1).GT.0).AND.(ss%id_N0_RECO(I1).LE.isize)) THEN
              ss%id_zonwt(ss%id_T0_reco(I1)) = ss%id_N0_RECO(I1)
           ELSE
              ierval = ierval + 1
           ENDIF
        ELSE
           iertarg = iertarg + 1
        ENDIF
     ENDDO   ! I1
     IF(iertarg.GT.0) THEN
        WRITE(iout,*) " ?plasma_state_zonwt_update target element out of bounds detected!"
        write(IOUT,*) "  id_T0_reco: ",ss%id_T0_reco
        write(IOUT,*) "  allowable range is 1 to ",isize
        iertot = iertot + 1
     ENDIF
     IF(ierval.GT.0) THEN
        WRITE(iout,*) " ?plasma_state_zonwt_update weight element out of bounds detected!"
        write(IOUT,*) "  id_N0_RECO: ",ss%id_N0_RECO
        write(IOUT,*) "  allowable range is 1 to ",isize
        iertot = iertot + 1
     ENDIF
  ENDIF
  !singleton
  IF(ss%id_Ti.GT.0) THEN
     IF(ss%id_Ti.LE.isize) THEN
        IF((ss%id_NI.GT.0).AND.(ss%id_NI.LE.isize)) THEN
           ss%id_zonwt(ss%id_Ti) = ss%id_NI
        ELSE
           WRITE(iout,*) " ?plasma_state_zonwt_update weight element out of bounds detected!"
           write(IOUT,*) "  id_NI: ",ss%id_NI
           write(IOUT,*) "  allowable range is 1 to ",isize
           iertot = iertot + 1
        ENDIF
     ELSE
        WRITE(iout,*) " ?plasma_state_zonwt_update weight element out of bounds detected!"
        write(IOUT,*) "  id_Ti: ",ss%id_Ti
        write(IOUT,*) "  allowable range is 1 to ",isize
        iertot = iertot + 1
     ENDIF
  ENDIF
  !singleton
  IF(ss%id_tmodel.GT.0) THEN
     IF(ss%id_tmodel.LE.isize) THEN
        IF((ss%id_NMODEL.GT.0).AND.(ss%id_NMODEL.LE.isize)) THEN
           ss%id_zonwt(ss%id_tmodel) = ss%id_NMODEL
        ELSE
           WRITE(iout,*) " ?plasma_state_zonwt_update weight element out of bounds detected!"
           write(IOUT,*) "  id_NMODEL: ",ss%id_NMODEL
           write(IOUT,*) "  allowable range is 1 to ",isize
           iertot = iertot + 1
        ENDIF
     ELSE
        WRITE(iout,*) " ?plasma_state_zonwt_update weight element out of bounds detected!"
        write(IOUT,*) "  id_tmodel: ",ss%id_tmodel
        write(IOUT,*) "  allowable range is 1 to ",isize
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%id_NS)) THEN
     iertarg = 0; ierval = 0
     DO I1 = 0,ss%nspec_th
        IF((ss%id_Ts(I1).GT.0).AND.(ss%id_Ts(I1).LE.isize)) THEN
           IF((ss%id_NS(I1).GT.0).AND.(ss%id_NS(I1).LE.isize)) THEN
              ss%id_zonwt(ss%id_Ts(I1)) = ss%id_NS(I1)
           ELSE
              ierval = ierval + 1
           ENDIF
        ELSE
           iertarg = iertarg + 1
        ENDIF
     ENDDO   ! I1
     IF(iertarg.GT.0) THEN
        WRITE(iout,*) " ?plasma_state_zonwt_update target element out of bounds detected!"
        write(IOUT,*) "  id_Ts: ",ss%id_Ts
        write(IOUT,*) "  allowable range is 1 to ",isize
        iertot = iertot + 1
     ENDIF
     IF(ierval.GT.0) THEN
        WRITE(iout,*) " ?plasma_state_zonwt_update weight element out of bounds detected!"
        write(IOUT,*) "  id_NS: ",ss%id_NS
        write(IOUT,*) "  allowable range is 1 to ",isize
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%id_NS)) THEN
     iertarg = 0; ierval = 0
     DO I1 = 0,ss%nspec_th
        IF((ss%id_vpol_inmp(I1).GT.0).AND.(ss%id_vpol_inmp(I1).LE.isize)) THEN
           IF((ss%id_NS(I1).GT.0).AND.(ss%id_NS(I1).LE.isize)) THEN
              ss%id_zonwt(ss%id_vpol_inmp(I1)) = ss%id_NS(I1)
           ELSE
              ierval = ierval + 1
           ENDIF
        ELSE
           iertarg = iertarg + 1
        ENDIF
     ENDDO   ! I1
     IF(iertarg.GT.0) THEN
        WRITE(iout,*) " ?plasma_state_zonwt_update target element out of bounds detected!"
        write(IOUT,*) "  id_vpol_inmp: ",ss%id_vpol_inmp
        write(IOUT,*) "  allowable range is 1 to ",isize
        iertot = iertot + 1
     ENDIF
     IF(ierval.GT.0) THEN
        WRITE(iout,*) " ?plasma_state_zonwt_update weight element out of bounds detected!"
        write(IOUT,*) "  id_NS: ",ss%id_NS
        write(IOUT,*) "  allowable range is 1 to ",isize
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%id_NS)) THEN
     iertarg = 0; ierval = 0
     DO I1 = 0,ss%nspec_th
        IF((ss%id_vpol_omp(I1).GT.0).AND.(ss%id_vpol_omp(I1).LE.isize)) THEN
           IF((ss%id_NS(I1).GT.0).AND.(ss%id_NS(I1).LE.isize)) THEN
              ss%id_zonwt(ss%id_vpol_omp(I1)) = ss%id_NS(I1)
           ELSE
              ierval = ierval + 1
           ENDIF
        ELSE
           iertarg = iertarg + 1
        ENDIF
     ENDDO   ! I1
     IF(iertarg.GT.0) THEN
        WRITE(iout,*) " ?plasma_state_zonwt_update target element out of bounds detected!"
        write(IOUT,*) "  id_vpol_omp: ",ss%id_vpol_omp
        write(IOUT,*) "  allowable range is 1 to ",isize
        iertot = iertot + 1
     ENDIF
     IF(ierval.GT.0) THEN
        WRITE(iout,*) " ?plasma_state_zonwt_update weight element out of bounds detected!"
        write(IOUT,*) "  id_NS: ",ss%id_NS
        write(IOUT,*) "  allowable range is 1 to ",isize
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%id_NS)) THEN
     iertarg = 0; ierval = 0
     DO I1 = 0,ss%nspec_th
        IF((ss%id_vtor_inmp(I1).GT.0).AND.(ss%id_vtor_inmp(I1).LE.isize)) THEN
           IF((ss%id_NS(I1).GT.0).AND.(ss%id_NS(I1).LE.isize)) THEN
              ss%id_zonwt(ss%id_vtor_inmp(I1)) = ss%id_NS(I1)
           ELSE
              ierval = ierval + 1
           ENDIF
        ELSE
           iertarg = iertarg + 1
        ENDIF
     ENDDO   ! I1
     IF(iertarg.GT.0) THEN
        WRITE(iout,*) " ?plasma_state_zonwt_update target element out of bounds detected!"
        write(IOUT,*) "  id_vtor_inmp: ",ss%id_vtor_inmp
        write(IOUT,*) "  allowable range is 1 to ",isize
        iertot = iertot + 1
     ENDIF
     IF(ierval.GT.0) THEN
        WRITE(iout,*) " ?plasma_state_zonwt_update weight element out of bounds detected!"
        write(IOUT,*) "  id_NS: ",ss%id_NS
        write(IOUT,*) "  allowable range is 1 to ",isize
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%id_NS)) THEN
     iertarg = 0; ierval = 0
     DO I1 = 0,ss%nspec_th
        IF((ss%id_vtor_omp(I1).GT.0).AND.(ss%id_vtor_omp(I1).LE.isize)) THEN
           IF((ss%id_NS(I1).GT.0).AND.(ss%id_NS(I1).LE.isize)) THEN
              ss%id_zonwt(ss%id_vtor_omp(I1)) = ss%id_NS(I1)
           ELSE
              ierval = ierval + 1
           ENDIF
        ELSE
           iertarg = iertarg + 1
        ENDIF
     ENDDO   ! I1
     IF(iertarg.GT.0) THEN
        WRITE(iout,*) " ?plasma_state_zonwt_update target element out of bounds detected!"
        write(IOUT,*) "  id_vtor_omp: ",ss%id_vtor_omp
        write(IOUT,*) "  allowable range is 1 to ",isize
        iertot = iertot + 1
     ENDIF
     IF(ierval.GT.0) THEN
        WRITE(iout,*) " ?plasma_state_zonwt_update weight element out of bounds detected!"
        write(IOUT,*) "  id_NS: ",ss%id_NS
        write(IOUT,*) "  allowable range is 1 to ",isize
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%id_NS)) THEN
     iertarg = 0; ierval = 0
     DO I1 = 0,ss%nspec_th
        IF((ss%id_v_pars(I1).GT.0).AND.(ss%id_v_pars(I1).LE.isize)) THEN
           IF((ss%id_NS(I1).GT.0).AND.(ss%id_NS(I1).LE.isize)) THEN
              ss%id_zonwt(ss%id_v_pars(I1)) = ss%id_NS(I1)
           ELSE
              ierval = ierval + 1
           ENDIF
        ELSE
           iertarg = iertarg + 1
        ENDIF
     ENDDO   ! I1
     IF(iertarg.GT.0) THEN
        WRITE(iout,*) " ?plasma_state_zonwt_update target element out of bounds detected!"
        write(IOUT,*) "  id_v_pars: ",ss%id_v_pars
        write(IOUT,*) "  allowable range is 1 to ",isize
        iertot = iertot + 1
     ENDIF
     IF(ierval.GT.0) THEN
        WRITE(iout,*) " ?plasma_state_zonwt_update weight element out of bounds detected!"
        write(IOUT,*) "  id_NS: ",ss%id_NS
        write(IOUT,*) "  allowable range is 1 to ",isize
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%id_NS)) THEN
     iertarg = 0; ierval = 0
     DO I1 = 0,ss%nspec_th
        IF((ss%id_v_pers(I1).GT.0).AND.(ss%id_v_pers(I1).LE.isize)) THEN
           IF((ss%id_NS(I1).GT.0).AND.(ss%id_NS(I1).LE.isize)) THEN
              ss%id_zonwt(ss%id_v_pers(I1)) = ss%id_NS(I1)
           ELSE
              ierval = ierval + 1
           ENDIF
        ELSE
           iertarg = iertarg + 1
        ENDIF
     ENDDO   ! I1
     IF(iertarg.GT.0) THEN
        WRITE(iout,*) " ?plasma_state_zonwt_update target element out of bounds detected!"
        write(IOUT,*) "  id_v_pers: ",ss%id_v_pers
        write(IOUT,*) "  allowable range is 1 to ",isize
        iertot = iertot + 1
     ENDIF
     IF(ierval.GT.0) THEN
        WRITE(iout,*) " ?plasma_state_zonwt_update weight element out of bounds detected!"
        write(IOUT,*) "  id_NS: ",ss%id_NS
        write(IOUT,*) "  allowable range is 1 to ",isize
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%id_NS)) THEN
     IF((ss%id_Zeff.GT.0).AND.(ss%id_Zeff.LE.isize)) THEN
        IF((ss%id_NS(PS_ELEC_INDEX).GT.0).AND.(ss%id_NS(PS_ELEC_INDEX).LE.isize)) THEN
           ss%id_zonwt(ss%id_Zeff) = ss%id_NS(PS_ELEC_INDEX)
        ELSE
           iertot=iertot+1
           WRITE(iout,*) " ?plasma_state_zonwt_update element: id_NS(PS_ELEC_INDEX) = ",ss%id_NS(PS_ELEC_INDEX)
           WRITE(iout,*) "  out of bounds 1 to ",isize
        ENDIF
     ELSE
        iertot=iertot+1
        WRITE(iout,*) " ?plasma_state_zonwt_update element: id_Zeff = ",ss%id_Zeff
        WRITE(iout,*) "  out of bounds 1 to ",isize
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%id_NS)) THEN
     IF((ss%id_Zeff_fi.GT.0).AND.(ss%id_Zeff_fi.LE.isize)) THEN
        IF((ss%id_NS(PS_ELEC_INDEX).GT.0).AND.(ss%id_NS(PS_ELEC_INDEX).LE.isize)) THEN
           ss%id_zonwt(ss%id_Zeff_fi) = ss%id_NS(PS_ELEC_INDEX)
        ELSE
           iertot=iertot+1
           WRITE(iout,*) " ?plasma_state_zonwt_update element: id_NS(PS_ELEC_INDEX) = ",ss%id_NS(PS_ELEC_INDEX)
           WRITE(iout,*) "  out of bounds 1 to ",isize
        ENDIF
     ELSE
        iertot=iertot+1
        WRITE(iout,*) " ?plasma_state_zonwt_update element: id_Zeff_fi = ",ss%id_Zeff_fi
        WRITE(iout,*) "  out of bounds 1 to ",isize
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%id_NS)) THEN
     IF((ss%id_Zeff_th.GT.0).AND.(ss%id_Zeff_th.LE.isize)) THEN
        IF((ss%id_NS(PS_ELEC_INDEX).GT.0).AND.(ss%id_NS(PS_ELEC_INDEX).LE.isize)) THEN
           ss%id_zonwt(ss%id_Zeff_th) = ss%id_NS(PS_ELEC_INDEX)
        ELSE
           iertot=iertot+1
           WRITE(iout,*) " ?plasma_state_zonwt_update element: id_NS(PS_ELEC_INDEX) = ",ss%id_NS(PS_ELEC_INDEX)
           WRITE(iout,*) "  out of bounds 1 to ",isize
        ENDIF
     ELSE
        iertot=iertot+1
        WRITE(iout,*) " ?plasma_state_zonwt_update element: id_Zeff_th = ",ss%id_Zeff_th
        WRITE(iout,*) "  out of bounds 1 to ",isize
     ENDIF
  ENDIF


  IF(iertot.GT.0) THEN
     WRITE(iout,*) ' ?plasma_state_zonwt_update: encountered invalid profile IDs!'
     ierr=9999
  ENDIF

END SUBROUTINE plasma_state_zonwt_update

module rng_container

  !  Simple interface to random number generator RNG
  !  This is just an example of an RNG interface, for ps_nbline_driver.f90
  !  DMC May 2008

  use rng   ! Charles Karney RNG module (cf NTCC module -- under 
            ! "numerical tools" in the catalog at http://w3.pppl.gov/ntcc

  implicit NONE

  private

  !  Public routines:  seed/state initialization -- must be called first...
  !                    real*8 random numbers evenly distributed over [0:1]
  !                    real*8 random numbers for gaussian distributions

  public :: rngcon_init,rngcon_frandm,rngcon_fgauss

  SAVE

  !  For performance reasons, RNG numbers are fetched through buffers
  !  with this batch size
  
  integer, parameter :: batch_size = 10

  !---------------------------------------
  !  private internal state

  type(rng_state) :: state
  integer, dimension(rng_s) :: seed
  !---------------------------------------
  !  buffer indexing (-1 flags "un-initialized" value)

  integer :: indx_frandm = -1
  integer :: indx_fgauss = -1

  !  buffers

  real*8 :: frandm_buffer(batch_size)
  real*8 :: fgauss_buffer(batch_size)

  !---------------------------------------
  !  LUN for message
  integer, parameter :: lun_dbg = 6
  !---------------------------------------

CONTAINS

  !-----------------------------------
  ! initialization routine -- sets RNG from a seed string
  ! called once by driver

  ! in MPI implementation it could be called once per processing element (PE),
  ! but a distinct string (e.g. imbedding the encoded PE number) should be 
  ! provided for each PE.  <run_seed_string>_<PE_number> perhaps.

  subroutine rngcon_init(str)
    character*(*), intent(in) :: str

    call rng_set_seed(seed,str)
    call rng_init(seed,state)

    indx_frandm = 1
    indx_fgauss = 1

    call rng_number(state,frandm_buffer)  ! fetch initial batch -- Normal
    call rng_gauss(state,fgauss_buffer)   ! fetch initial batch -- Gaussian

  end subroutine rngcon_init

  !-----------------------------------
  !  RNG function (sample flat distribution btw 0 and 1; endpts excluded)

  real*8 function rngcon_frandm(istream)

    integer :: istream        ! RNG stream identifier
    ! (NOT USED in this sample code but may be desirable in parallel apps)

    if(indx_frandm.le.0) then
       write(lun_dbg,*) &
            ' ?rng_container:rngcon_frandm -- module never initialized!'
       rngcon_frandm = 0.0

    else
       rngcon_frandm = frandm_buffer(indx_frandm)

       indx_frandm = indx_frandm + 1
       if(indx_frandm.gt.batch_size) then
          call rng_number(state,frandm_buffer)
          indx_frandm = 1
       endif
    endif

  end function rngcon_frandm

  !-----------------------------------
  !  RNG function: sample Guassian exp(-(x-xcen)**2/(2*xwid**2))

  real*8 function rngcon_fgauss(istream,xcen,xwid)

    integer :: istream        ! RNG stream identifier
    ! (NOT USED in this sample code but may be desirable in parallel apps)

    real*8, intent(in) :: xcen    ! Gaussian center
    real*8, intent(in) :: xwid    ! Gaussian half-width (as defined above)

    if(indx_fgauss.le.0) then
       write(lun_dbg,*) &
            ' ?rng_container:rngcon_fgauss -- module never initialized!'
       rngcon_fgauss = 0.0

    else
       rngcon_fgauss = xwid * fgauss_buffer(indx_fgauss) + xcen

       indx_fgauss = indx_fgauss + 1
       if(indx_fgauss.gt.batch_size) then
          call rng_gauss(state,fgauss_buffer)
          indx_fgauss = 1
       endif
    endif

  end function rngcon_fgauss

end module rng_container

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


SUBROUTINE plasma_state_copy_5(cclist,ss,ss2,icopy_lists,iwant_1deq,partial_copy,ierr)


  ! Copy scalars, and, arrays that are allocated
  !   ss2 <-- ss

  USE plasma_state_definition_mod
  IMPLICIT NONE

  INTEGER, INTENT(IN) :: cclist(ps_ccount)
                                ! list of components to merge
                                ! use ps_cc_all to merge all components

  TYPE (plasma_state) :: ss     ! state data to copy *from*
  TYPE (plasma_state) :: ss2    ! state data to copy *to*

  INTEGER, INTENT(IN) :: icopy_lists ! =1 to require copying of all lists

  INTEGER, INTENT(IN) :: iwant_1deq  ! =1 to request fcns of (rho_eq)
                                     !  even if cclist(ps_cnum_EQ).eq.0

  LOGICAL, INTENT(IN) :: partial_copy ! .TRUE. if full state copy not in effect

  INTEGER, INTENT(INOUT) :: ierr  ! completion flag (not cleared, set by error)

  !-------------------
  INTEGER :: iout
  !-------------------

  iout = SWIM_err_out_file


  !-----------------------------------------------
  ! copy scalars and arrays that are allocated...
  IF((cclist(ps_cnum_RIPPLE).EQ.1).OR.(icopy_lists.EQ.1)) THEN
     ss2%ntf_coils = ss%ntf_coils
  ENDIF
  IF( ((ALLOCATED(ss2%nthinlh)).AND.(ALLOCATED(ss%nthinlh))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_LH).EQ.1)) ) THEN
     ss2%nthinlh = ss%nthinlh
  ENDIF
  IF( ((ALLOCATED(ss2%Nturns)).AND.(ALLOCATED(ss%Nturns))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_EQ).EQ.1)) ) THEN
     ss2%Nturns = ss%Nturns
  ENDIF
  IF( ((ALLOCATED(ss2%num_nphi)).AND.(ALLOCATED(ss%num_nphi))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_IC).EQ.1)) ) THEN
     ss2%num_nphi = ss%num_nphi
  ENDIF
  IF( ((ALLOCATED(ss2%num_nphi_vac)).AND.(ALLOCATED(ss%num_nphi_vac))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_IC).EQ.1)) ) THEN
     ss2%num_nphi_vac = ss%num_nphi_vac
  ENDIF
  IF(ALLOCATED(ss2%id_nzflux_ky_tglf)) THEN
     IF(partial_copy) THEN
        ss2%id_nzflux_ky_tglf = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%nzflux_ky_tglf).AND.ALLOCATED(ss2%nzflux_ky_tglf)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%nzflux_ky_tglf = ss%nzflux_ky_tglf
     IF(ALLOCATED(ss2%id_nzflux_ky_tglf)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_nzflux_ky_tglf = ss%id_nzflux_ky_tglf
        ENDIF
     ENDIF
  ENDIF
  IF(ALLOCATED(ss2%id_nz_ky_tglf)) THEN
     IF(partial_copy) THEN
        ss2%id_nz_ky_tglf = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%nz_ky_tglf).AND.ALLOCATED(ss2%nz_ky_tglf)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%nz_ky_tglf = ss%nz_ky_tglf
     IF(ALLOCATED(ss2%id_nz_ky_tglf)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_nz_ky_tglf = ss%id_nz_ky_tglf
        ENDIF
     ENDIF
  ENDIF
  IF( ((ALLOCATED(ss2%n_straps)).AND.(ALLOCATED(ss%n_straps))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_IC).EQ.1)) ) THEN
     ss2%n_straps = ss%n_straps
  ENDIF
  IF(ALLOCATED(ss2%id_omeg0cx)) THEN
     IF(partial_copy) THEN
        ss2%id_omeg0cx = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%omeg0cx).AND.ALLOCATED(ss2%omeg0cx)).AND. &
        ((cclist(ps_cnum_GAS).EQ.1))) THEN
     ss2%omeg0cx = ss%omeg0cx
     IF(ALLOCATED(ss2%id_omeg0cx)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_omeg0cx = ss%id_omeg0cx
        ENDIF
     ENDIF
  ENDIF
  IF(ALLOCATED(ss2%id_omeg0sc0)) THEN
     IF(partial_copy) THEN
        ss2%id_omeg0sc0 = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%omeg0sc0).AND.ALLOCATED(ss2%omeg0sc0)).AND. &
        ((cclist(ps_cnum_GAS).EQ.1))) THEN
     ss2%omeg0sc0 = ss%omeg0sc0
     IF(ALLOCATED(ss2%id_omeg0sc0)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_omeg0sc0 = ss%id_omeg0sc0
        ENDIF
     ENDIF
  ENDIF
  IF(ALLOCATED(ss2%id_omeg0_halo)) THEN
     IF(partial_copy) THEN
        ss2%id_omeg0_halo = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%omeg0_halo).AND.ALLOCATED(ss2%omeg0_halo)).AND. &
        ((cclist(ps_cnum_NBI).EQ.1))) THEN
     ss2%omeg0_halo = ss%omeg0_halo
     IF(ALLOCATED(ss2%id_omeg0_halo)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_omeg0_halo = ss%id_omeg0_halo
        ENDIF
     ENDIF
  ENDIF
  IF(ALLOCATED(ss2%id_omeg0_reco)) THEN
     IF(partial_copy) THEN
        ss2%id_omeg0_reco = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%omeg0_reco).AND.ALLOCATED(ss2%omeg0_reco)).AND. &
        ((cclist(ps_cnum_GAS).EQ.1))) THEN
     ss2%omeg0_reco = ss%omeg0_reco
     IF(ALLOCATED(ss2%id_omeg0_reco)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_omeg0_reco = ss%id_omeg0_reco
        ENDIF
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_omegat = 0
  ENDIF
  IF((ALLOCATED(ss%omegat).AND.ALLOCATED(ss2%omegat)).AND. &
        ((cclist(ps_cnum_PLASMA).EQ.1))) THEN
     ss2%omegat = ss%omegat
     IF(.not.partial_copy) THEN
        ss2%id_omegat = ss%id_omegat
     ENDIF
  ENDIF
  IF((cclist(ps_cnum_PLASMA).EQ.1).OR.(icopy_lists.EQ.1)) THEN
     ss2%omegat_bdy = ss%omegat_bdy
  ENDIF
  IF(partial_copy) THEN
     ss2%id_omega_exb = 0
  ENDIF
  IF((ALLOCATED(ss%omega_exb).AND.ALLOCATED(ss2%omega_exb)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%omega_exb = ss%omega_exb
     IF(.not.partial_copy) THEN
        ss2%id_omega_exb = ss%id_omega_exb
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_p0_reco = 0
  ENDIF
  IF((ALLOCATED(ss%p0_reco).AND.ALLOCATED(ss2%p0_reco)).AND. &
        ((cclist(ps_cnum_GAS).EQ.1))) THEN
     ss2%p0_reco = ss%p0_reco
     IF(.not.partial_copy) THEN
        ss2%id_p0_reco = ss%id_p0_reco
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_pb0_halo = 0
  ENDIF
  IF((ALLOCATED(ss%pb0_halo).AND.ALLOCATED(ss2%pb0_halo)).AND. &
        ((cclist(ps_cnum_NBI).EQ.1))) THEN
     ss2%pb0_halo = ss%pb0_halo
     IF(.not.partial_copy) THEN
        ss2%id_pb0_halo = ss%id_pb0_halo
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_pbe = 0
  ENDIF
  IF((ALLOCATED(ss%pbe).AND.ALLOCATED(ss2%pbe)).AND. &
        ((cclist(ps_cnum_NBI).EQ.1))) THEN
     ss2%pbe = ss%pbe
     IF(.not.partial_copy) THEN
        ss2%id_pbe = ss%id_pbe
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_pbi = 0
  ENDIF
  IF((ALLOCATED(ss%pbi).AND.ALLOCATED(ss2%pbi)).AND. &
        ((cclist(ps_cnum_NBI).EQ.1))) THEN
     ss2%pbi = ss%pbi
     IF(.not.partial_copy) THEN
        ss2%id_pbi = ss%id_pbi
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_pbth = 0
  ENDIF
  IF((ALLOCATED(ss%pbth).AND.ALLOCATED(ss2%pbth)).AND. &
        ((cclist(ps_cnum_NBI).EQ.1))) THEN
     ss2%pbth = ss%pbth
     IF(.not.partial_copy) THEN
        ss2%id_pbth = ss%id_pbth
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_pcx_halo = 0
  ENDIF
  IF((ALLOCATED(ss%pcx_halo).AND.ALLOCATED(ss2%pcx_halo)).AND. &
        ((cclist(ps_cnum_NBI).EQ.1))) THEN
     ss2%pcx_halo = ss%pcx_halo
     IF(.not.partial_copy) THEN
        ss2%id_pcx_halo = ss%id_pcx_halo
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_pcx_reco = 0
  ENDIF
  IF((ALLOCATED(ss%pcx_reco).AND.ALLOCATED(ss2%pcx_reco)).AND. &
        ((cclist(ps_cnum_GAS).EQ.1))) THEN
     ss2%pcx_reco = ss%pcx_reco
     IF(.not.partial_copy) THEN
        ss2%id_pcx_reco = ss%id_pcx_reco
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_peech = 0
  ENDIF
  IF((ALLOCATED(ss%peech).AND.ALLOCATED(ss2%peech)).AND. &
        ((cclist(ps_cnum_EC).EQ.1))) THEN
     ss2%peech = ss%peech
     IF(.not.partial_copy) THEN
        ss2%id_peech = ss%id_peech
     ENDIF
  ENDIF
  IF(ALLOCATED(ss2%id_peech_src)) THEN
     IF(partial_copy) THEN
        ss2%id_peech_src = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%peech_src).AND.ALLOCATED(ss2%peech_src)).AND. &
        ((cclist(ps_cnum_EC).EQ.1))) THEN
     ss2%peech_src = ss%peech_src
     IF(ALLOCATED(ss2%id_peech_src)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_peech_src = ss%id_peech_src
        ENDIF
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_pelh = 0
  ENDIF
  IF((ALLOCATED(ss%pelh).AND.ALLOCATED(ss2%pelh)).AND. &
        ((cclist(ps_cnum_LH).EQ.1))) THEN
     ss2%pelh = ss%pelh
     IF(.not.partial_copy) THEN
        ss2%id_pelh = ss%id_pelh
     ENDIF
  ENDIF
  IF(ALLOCATED(ss2%id_pelh_src)) THEN
     IF(partial_copy) THEN
        ss2%id_pelh_src = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%pelh_src).AND.ALLOCATED(ss2%pelh_src)).AND. &
        ((cclist(ps_cnum_LH).EQ.1))) THEN
     ss2%pelh_src = ss%pelh_src
     IF(ALLOCATED(ss2%id_pelh_src)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_pelh_src = ss%id_pelh_src
        ENDIF
     ENDIF
  ENDIF
  IF((cclist(ps_cnum_PEL).EQ.1).OR.(icopy_lists.EQ.1)) THEN
     ss2%PEL_Code_Info = ss%PEL_Code_Info
  ENDIF
  IF((cclist(ps_cnum_PEL).EQ.1).OR.(icopy_lists.EQ.1)) THEN
     ss2%PEL_Data_Info = ss%PEL_Data_Info
  ENDIF
  IF(partial_copy) THEN
     ss2%id_pe_anom = 0
  ENDIF
  IF((ALLOCATED(ss%pe_anom).AND.ALLOCATED(ss2%pe_anom)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%pe_anom = ss%pe_anom
     IF(.not.partial_copy) THEN
        ss2%id_pe_anom = ss%id_pe_anom
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_pe_trans = 0
  ENDIF
  IF((ALLOCATED(ss%pe_trans).AND.ALLOCATED(ss2%pe_trans)).AND. &
        ((cclist(ps_cnum_PLASMA).EQ.1))) THEN
     ss2%pe_trans = ss%pe_trans
     IF(.not.partial_copy) THEN
        ss2%id_pe_trans = ss%id_pe_trans
     ENDIF
  ENDIF
  IF(ALLOCATED(ss2%id_pe_transcat)) THEN
     IF(partial_copy) THEN
        ss2%id_pe_transcat = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%pe_transcat).AND.ALLOCATED(ss2%pe_transcat)).AND. &
        ((cclist(ps_cnum_PLASMA).EQ.1))) THEN
     ss2%pe_transcat = ss%pe_transcat
     IF(ALLOCATED(ss2%id_pe_transcat)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_pe_transcat = ss%id_pe_transcat
        ENDIF
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_pfuse = 0
  ENDIF
  IF((ALLOCATED(ss%pfuse).AND.ALLOCATED(ss2%pfuse)).AND. &
        ((cclist(ps_cnum_FUS).EQ.1))) THEN
     ss2%pfuse = ss%pfuse
     IF(.not.partial_copy) THEN
        ss2%id_pfuse = ss%id_pfuse
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_pfusi = 0
  ENDIF
  IF((ALLOCATED(ss%pfusi).AND.ALLOCATED(ss2%pfusi)).AND. &
        ((cclist(ps_cnum_FUS).EQ.1))) THEN
     ss2%pfusi = ss%pfusi
     IF(.not.partial_copy) THEN
        ss2%id_pfusi = ss%id_pfusi
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_pfusth = 0
  ENDIF
  IF((ALLOCATED(ss%pfusth).AND.ALLOCATED(ss2%pfusth)).AND. &
        ((cclist(ps_cnum_FUS).EQ.1))) THEN
     ss2%pfusth = ss%pfusth
     IF(.not.partial_copy) THEN
        ss2%id_pfusth = ss%id_pfusth
     ENDIF
  ENDIF
  IF( ((ALLOCATED(ss2%Phibsc)).AND.(ALLOCATED(ss%Phibsc))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_NBI).EQ.1)) ) THEN
     ss2%Phibsc = ss%Phibsc
  ENDIF
  IF(ALLOCATED(ss2%id_phiflux_ky_tglf)) THEN
     IF(partial_copy) THEN
        ss2%id_phiflux_ky_tglf = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%phiflux_ky_tglf).AND.ALLOCATED(ss2%phiflux_ky_tglf)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%phiflux_ky_tglf = ss%phiflux_ky_tglf
     IF(ALLOCATED(ss2%id_phiflux_ky_tglf)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_phiflux_ky_tglf = ss%id_phiflux_ky_tglf
        ENDIF
     ENDIF
  ENDIF
  IF( ((ALLOCATED(ss2%phigrilh)).AND.(ALLOCATED(ss%phigrilh))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_LH).EQ.1)) ) THEN
     ss2%phigrilh = ss%phigrilh
  ENDIF
  IF(partial_copy) THEN
     ss2%id_phit = 0
  ENDIF
  IF((ALLOCATED(ss%phit).AND.ALLOCATED(ss2%phit)).AND. &
        ((cclist(ps_cnum_EQ).EQ.1).OR.(iwant_1deq.eq.1))) THEN
     ss2%phit = ss%phit
     IF(.not.partial_copy) THEN
        ss2%id_phit = ss%id_phit
     ENDIF
  ENDIF
  IF( ((ALLOCATED(ss2%Phi_EC_launch)).AND.(ALLOCATED(ss%Phi_EC_launch))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_EC).EQ.1)) ) THEN
     ss2%Phi_EC_launch = ss%Phi_EC_launch
  ENDIF
  IF( ((ALLOCATED(ss2%picrf_abs)).AND.(ALLOCATED(ss%picrf_abs))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_IC).EQ.1)) ) THEN
     ss2%picrf_abs = ss%picrf_abs
  ENDIF
  IF( ((ALLOCATED(ss2%picrf_ext)).AND.(ALLOCATED(ss%picrf_ext))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_IC).EQ.1)) ) THEN
     ss2%picrf_ext = ss%picrf_ext
  ENDIF
  IF(ALLOCATED(ss2%id_picrf_nphi_srcs)) THEN
     IF(partial_copy) THEN
        ss2%id_picrf_nphi_srcs = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%picrf_nphi_srcs).AND.ALLOCATED(ss2%picrf_nphi_srcs)).AND. &
        ((cclist(ps_cnum_IC).EQ.1))) THEN
     ss2%picrf_nphi_srcs = ss%picrf_nphi_srcs
     IF(ALLOCATED(ss2%id_picrf_nphi_srcs)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_picrf_nphi_srcs = ss%id_picrf_nphi_srcs
        ENDIF
     ENDIF
  ENDIF
  IF(ALLOCATED(ss2%id_picrf_srcs)) THEN
     IF(partial_copy) THEN
        ss2%id_picrf_srcs = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%picrf_srcs).AND.ALLOCATED(ss2%picrf_srcs)).AND. &
        ((cclist(ps_cnum_IC).EQ.1))) THEN
     ss2%picrf_srcs = ss%picrf_srcs
     IF(ALLOCATED(ss2%id_picrf_srcs)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_picrf_srcs = ss%id_picrf_srcs
        ENDIF
     ENDIF
  ENDIF
  IF(ALLOCATED(ss2%id_picrf_totals)) THEN
     IF(partial_copy) THEN
        ss2%id_picrf_totals = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%picrf_totals).AND.ALLOCATED(ss2%picrf_totals)).AND. &
        ((cclist(ps_cnum_IC).EQ.1))) THEN
     ss2%picrf_totals = ss%picrf_totals
     IF(ALLOCATED(ss2%id_picrf_totals)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_picrf_totals = ss%id_picrf_totals
        ENDIF
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_picth = 0
  ENDIF
  IF((ALLOCATED(ss%picth).AND.ALLOCATED(ss2%picth)).AND. &
        ((cclist(ps_cnum_IC).EQ.1))) THEN
     ss2%picth = ss%picth
     IF(.not.partial_copy) THEN
        ss2%id_picth = ss%id_picth
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_pilh = 0
  ENDIF
  IF((ALLOCATED(ss%pilh).AND.ALLOCATED(ss2%pilh)).AND. &
        ((cclist(ps_cnum_LH).EQ.1))) THEN
     ss2%pilh = ss%pilh
     IF(.not.partial_copy) THEN
        ss2%id_pilh = ss%id_pilh
     ENDIF
  ENDIF
  IF(ALLOCATED(ss2%id_pilh_src)) THEN
     IF(partial_copy) THEN
        ss2%id_pilh_src = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%pilh_src).AND.ALLOCATED(ss2%pilh_src)).AND. &
        ((cclist(ps_cnum_LH).EQ.1))) THEN
     ss2%pilh_src = ss%pilh_src
     IF(ALLOCATED(ss2%id_pilh_src)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_pilh_src = ss%id_pilh_src
        ENDIF
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_pi_anom = 0
  ENDIF
  IF((ALLOCATED(ss%pi_anom).AND.ALLOCATED(ss2%pi_anom)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%pi_anom = ss%pi_anom
     IF(.not.partial_copy) THEN
        ss2%id_pi_anom = ss%id_pi_anom
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_pi_trans = 0
  ENDIF
  IF((ALLOCATED(ss%pi_trans).AND.ALLOCATED(ss2%pi_trans)).AND. &
        ((cclist(ps_cnum_PLASMA).EQ.1))) THEN
     ss2%pi_trans = ss%pi_trans
     IF(.not.partial_copy) THEN
        ss2%id_pi_trans = ss%id_pi_trans
     ENDIF
  ENDIF
  IF(ALLOCATED(ss2%id_pi_transcat)) THEN
     IF(partial_copy) THEN
        ss2%id_pi_transcat = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%pi_transcat).AND.ALLOCATED(ss2%pi_transcat)).AND. &
        ((cclist(ps_cnum_PLASMA).EQ.1))) THEN
     ss2%pi_transcat = ss%pi_transcat
     IF(ALLOCATED(ss2%id_pi_transcat)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_pi_transcat = ss%id_pi_transcat
        ENDIF
     ENDIF
  ENDIF
  IF((cclist(ps_cnum_PLASMA).EQ.1).OR.(icopy_lists.EQ.1)) THEN
     ss2%PLASMA_Code_Info = ss%PLASMA_Code_Info
  ENDIF
  IF(partial_copy) THEN
     ss2%id_pmine = 0
  ENDIF
  IF((ALLOCATED(ss%pmine).AND.ALLOCATED(ss2%pmine)).AND. &
        ((cclist(ps_cnum_IC).EQ.1))) THEN
     ss2%pmine = ss%pmine
     IF(.not.partial_copy) THEN
        ss2%id_pmine = ss%id_pmine
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_pmini = 0
  ENDIF
  IF((ALLOCATED(ss%pmini).AND.ALLOCATED(ss2%pmini)).AND. &
        ((cclist(ps_cnum_IC).EQ.1))) THEN
     ss2%pmini = ss%pmini
     IF(.not.partial_copy) THEN
        ss2%id_pmini = ss%id_pmini
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_pminth = 0
  ENDIF
  IF((ALLOCATED(ss%pminth).AND.ALLOCATED(ss2%pminth)).AND. &
        ((cclist(ps_cnum_IC).EQ.1))) THEN
     ss2%pminth = ss%pminth
     IF(.not.partial_copy) THEN
        ss2%id_pminth = ss%id_pminth
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_pohme = 0
  ENDIF
  IF((ALLOCATED(ss%pohme).AND.ALLOCATED(ss2%pohme)).AND. &
        ((cclist(ps_cnum_PLASMA).EQ.1))) THEN
     ss2%pohme = ss%pohme
     IF(.not.partial_copy) THEN
        ss2%id_pohme = ss%id_pohme
     ENDIF
  ENDIF
  IF(ALLOCATED(ss2%id_pot_ky_tglf)) THEN
     IF(partial_copy) THEN
        ss2%id_pot_ky_tglf = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%pot_ky_tglf).AND.ALLOCATED(ss2%pot_ky_tglf)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%pot_ky_tglf = ss%pot_ky_tglf
     IF(ALLOCATED(ss2%id_pot_ky_tglf)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_pot_ky_tglf = ss%id_pot_ky_tglf
        ENDIF
     ENDIF
  ENDIF
  IF( ((ALLOCATED(ss2%power_ec)).AND.(ALLOCATED(ss%power_ec))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_EC).EQ.1)) ) THEN
     ss2%power_ec = ss%power_ec
  ENDIF
  IF( ((ALLOCATED(ss2%power_ic)).AND.(ALLOCATED(ss%power_ic))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_IC).EQ.1)) ) THEN
     ss2%power_ic = ss%power_ic
  ENDIF
  IF( ((ALLOCATED(ss2%power_lh)).AND.(ALLOCATED(ss%power_lh))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_LH).EQ.1)) ) THEN
     ss2%power_lh = ss%power_lh
  ENDIF
  IF( ((ALLOCATED(ss2%power_nbi)).AND.(ALLOCATED(ss%power_nbi))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_NBI).EQ.1)) ) THEN
     ss2%power_nbi = ss%power_nbi
  ENDIF
  IF( ((ALLOCATED(ss2%power_nbi_trace)).AND.(ALLOCATED(ss%power_nbi_trace))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_NBI).EQ.1)) ) THEN
     ss2%power_nbi_trace = ss%power_nbi_trace
  ENDIF
  IF(partial_copy) THEN
     ss2%id_prad = 0
  ENDIF
  IF((ALLOCATED(ss%prad).AND.ALLOCATED(ss2%prad)).AND. &
        ((cclist(ps_cnum_RAD).EQ.1))) THEN
     ss2%prad = ss%prad
     IF(.not.partial_copy) THEN
        ss2%id_prad = ss%id_prad
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_prad_br = 0
  ENDIF
  IF((ALLOCATED(ss%prad_br).AND.ALLOCATED(ss2%prad_br)).AND. &
        ((cclist(ps_cnum_RAD).EQ.1))) THEN
     ss2%prad_br = ss%prad_br
     IF(.not.partial_copy) THEN
        ss2%id_prad_br = ss%id_prad_br
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_prad_cy = 0
  ENDIF
  IF((ALLOCATED(ss%prad_cy).AND.ALLOCATED(ss2%prad_cy)).AND. &
        ((cclist(ps_cnum_RAD).EQ.1))) THEN
     ss2%prad_cy = ss%prad_cy
     IF(.not.partial_copy) THEN
        ss2%id_prad_cy = ss%id_prad_cy
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_prad_li = 0
  ENDIF
  IF((ALLOCATED(ss%prad_li).AND.ALLOCATED(ss2%prad_li)).AND. &
        ((cclist(ps_cnum_RAD).EQ.1))) THEN
     ss2%prad_li = ss%prad_li
     IF(.not.partial_copy) THEN
        ss2%id_prad_li = ss%id_prad_li
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_psc_halo = 0
  ENDIF
  IF((ALLOCATED(ss%psc_halo).AND.ALLOCATED(ss2%psc_halo)).AND. &
        ((cclist(ps_cnum_NBI).EQ.1))) THEN
     ss2%psc_halo = ss%psc_halo
     IF(.not.partial_copy) THEN
        ss2%id_psc_halo = ss%id_psc_halo
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_psc_reco = 0
  ENDIF
  IF((ALLOCATED(ss%psc_reco).AND.ALLOCATED(ss2%psc_reco)).AND. &
        ((cclist(ps_cnum_GAS).EQ.1))) THEN
     ss2%psc_reco = ss%psc_reco
     IF(.not.partial_copy) THEN
        ss2%id_psc_reco = ss%id_psc_reco
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_psipol = 0
  ENDIF
  IF((ALLOCATED(ss%psipol).AND.ALLOCATED(ss2%psipol)).AND. &
        ((cclist(ps_cnum_EQ).EQ.1).OR.(iwant_1deq.eq.1))) THEN
     ss2%psipol = ss%psipol
     IF(.not.partial_copy) THEN
        ss2%id_psipol = ss%id_psipol
     ENDIF
  ENDIF

END SUBROUTINE plasma_state_copy_5

!******************** START FILE WXFINT.FOR ; GROUP FILTR6 ******************
!
!   WXFINT
!
!  COMPUTES INTEGRAL OF W(T)*F(T)*DT
!   WHERE W(T)=1-ABS(XCEN-T)/DELTA IS THE WEIGHTING FUNCTION
!   AND F(T) IS THE PIECEWISE LINEAR INTERPOLATION FUCNTION
!   OF THE DATA SERIES.
!
!   INTEGRATE FROM X1 TO X2
!   (XF1,YF1),(XF2,YF2) ARE THE ENDPOINTS OF A LINEAR
!   SEGMENT OF F(T);  XCEN SHOULD NOT LIE BETWEEN XF1 AND
!   XF2, X1 AND X2 SHOULD EQUAL OR LIE
!   BETWEEN XF1 AND XF2
!
REAL(fp) FUNCTION r8wxfint(X1,X2,XF1,YF1,XF2,YF2,XCEN,DELTA)
  use iso_c_binding, only: fp => c_double
  use physconst_mod, only: ZERO, HALF, ONE
  implicit none
  ! Arguments
  real(fp), intent(in) :: x1, x2
  real(fp), intent(in) :: xf1, yf1, xf2, yf2
  real(fp), intent(in) :: xcen
  real(fp), intent(in) :: delta
  ! Local variables
  real(fp) :: zs, xa, xb, xfa, zc0, zdi, zc1, zc2
  integer :: isign
  !
  ZS=(YF2-YF1)/(XF2-XF1)
  XA=max((X1-XCEN),-DELTA)
  XB=min((X2-XCEN),DELTA)
  XFA=XF1-XCEN
  !
  ZC0=YF1-XFA*ZS
  ZDI=ONE/DELTA
  ISIGN=-1
  IF(XA.LT.ZERO) ISIGN=1
  ZC1=HALF*(ZS+ISIGN*ZC0*ZDI)
  ZC2=.3333333333333333333333333_fp*ISIGN*ZS*ZDI
  !
  r8wxfint=ZDI*(XB-XA)*(ZC0+(XB+XA)*ZC1+(XB*XB+XA*XB+XA*XA)*ZC2)
  !
  RETURN
END FUNCTION r8wxfint

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_n0_dummy
     return
  end subroutine ccps_getset_n0_dummy

subroutine psget_nturns(iobj, n1, data, ierr)
    !! SIGNED number of conductor turns wrapped in each coil, +
    !! means, a positive current flows counter-clockwise viewed from
    !! above;, - means, a positive current flows clockwise viewed from
    !! above;
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_nturns', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % Nturns
end subroutine psget_nturns


subroutine psset_nturns(iobj, n1, data, ierr)
    !! SIGNED number of conductor turns wrapped in each coil, +
    !! means, a positive current flows counter-clockwise viewed from
    !! above;, - means, a positive current flows clockwise viewed from
    !! above;
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_nturns', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % Nturns = data(1:n1)
end subroutine psset_nturns


subroutine psgetrnk_nturns(iobj, ndims, ierr)
    !! SIGNED number of conductor turns wrapped in each coil, +
    !! means, a positive current flows counter-clockwise viewed from
    !! above;, - means, a positive current flows clockwise viewed from
    !! above;
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_nturns


subroutine psgetdim_nturns(iobj, ndims, dims, ierr)
    !! SIGNED number of conductor turns wrapped in each coil, +
    !! means, a positive current flows counter-clockwise viewed from
    !! above;, - means, a positive current flows clockwise viewed from
    !! above;
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_nturns', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % Nturns ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % Nturns)
    endif
end subroutine psgetdim_nturns


subroutine psget_nbap_shape(iobj, n1, data, ierr)
    !! shape keyword for beam aperture, For beam j,
    !! nbap_shape(j)="Rectangle" indicates a rectangular, aperture;
    !! nbap_shape(j)="Circle" indicates a circular aperture., The beam
    !! centerline is assumed to pass through the center of the,
    !! aperture.
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    CHARACTER*(*), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_nbap_shape', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % nbap_shape
end subroutine psget_nbap_shape


subroutine psset_nbap_shape(iobj, n1, data, ierr)
    !! shape keyword for beam aperture, For beam j,
    !! nbap_shape(j)="Rectangle" indicates a rectangular, aperture;
    !! nbap_shape(j)="Circle" indicates a circular aperture., The beam
    !! centerline is assumed to pass through the center of the,
    !! aperture.
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    CHARACTER*(*), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_nbap_shape', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % nbap_shape = data(1:n1)
end subroutine psset_nbap_shape


subroutine psgetsz_nbap_shape(iobj, size, ierr)
    !! shape keyword for beam aperture, For beam j,
    !! nbap_shape(j)="Rectangle" indicates a rectangular, aperture;
    !! nbap_shape(j)="Circle" indicates a circular aperture., The beam
    !! centerline is assumed to pass through the center of the,
    !! aperture.
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: size    ! size of character string
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psgetsz_nbap_shape', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! note that the following will return the character length size regardless of
    ! the number of array elements (if nbap_shape is an array)
    size = len(ss % nbap_shape)
end subroutine psgetsz_nbap_shape


subroutine psgetrnk_nbap_shape(iobj, ndims, ierr)
    !! shape keyword for beam aperture, For beam j,
    !! nbap_shape(j)="Rectangle" indicates a rectangular, aperture;
    !! nbap_shape(j)="Circle" indicates a circular aperture., The beam
    !! centerline is assumed to pass through the center of the,
    !! aperture.
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_nbap_shape


subroutine psgetdim_nbap_shape(iobj, ndims, dims, ierr)
    !! shape keyword for beam aperture, For beam j,
    !! nbap_shape(j)="Rectangle" indicates a rectangular, aperture;
    !! nbap_shape(j)="Circle" indicates a circular aperture., The beam
    !! centerline is assumed to pass through the center of the,
    !! aperture.
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_nbap_shape', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % nbap_shape ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % nbap_shape)
    endif
end subroutine psgetdim_nbap_shape


subroutine psget_num_nphi(iobj, n1, data, ierr)
    !! number of non-zero n_phi values, counting both positive and
    !! negative, n_phi values
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_num_nphi', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % num_nphi
end subroutine psget_num_nphi


subroutine psset_num_nphi(iobj, n1, data, ierr)
    !! number of non-zero n_phi values, counting both positive and
    !! negative, n_phi values
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_num_nphi', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % num_nphi = data(1:n1)
end subroutine psset_num_nphi


subroutine psgetrnk_num_nphi(iobj, ndims, ierr)
    !! number of non-zero n_phi values, counting both positive and
    !! negative, n_phi values
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_num_nphi


subroutine psgetdim_num_nphi(iobj, ndims, dims, ierr)
    !! number of non-zero n_phi values, counting both positive and
    !! negative, n_phi values
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_num_nphi', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % num_nphi ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % num_nphi)
    endif
end subroutine psgetdim_num_nphi


subroutine psget_nthinlh(iobj, n1, n2, data, ierr)
    !! need description
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_nthinlh', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % nthinlh
end subroutine psget_nthinlh


subroutine psset_nthinlh(iobj, n1, n2, data, ierr)
    !! need description
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    INTEGER, intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_nthinlh', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % nthinlh = data(1:n1, 1: n2)
end subroutine psset_nthinlh


subroutine psgetrnk_nthinlh(iobj, ndims, ierr)
    !! need description
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_nthinlh


subroutine psgetdim_nthinlh(iobj, ndims, dims, ierr)
    !! need description
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_nthinlh', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % nthinlh ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % nthinlh)
    endif
end subroutine psgetdim_nthinlh


subroutine psget_nspec_gas(iobj, data, ierr)
    !! species list dimension of SGAS (neutral_gas)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_nspec_gas', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % nspec_gas
end subroutine psget_nspec_gas


subroutine psset_nspec_gas(iobj, data, ierr)
    !! species list dimension of SGAS (neutral_gas)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_nspec_gas', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % nspec_gas = data
end subroutine psset_nspec_gas


subroutine psget_nrho_eq(iobj, data, ierr)
    !! grid dimension of rho_eq (RHO coordinate)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_nrho_eq', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % nrho_eq
end subroutine psget_nrho_eq


subroutine psset_nrho_eq(iobj, data, ierr)
    !! grid dimension of rho_eq (RHO coordinate)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_nrho_eq', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % nrho_eq = data
end subroutine psset_nrho_eq


subroutine psget_npsmom(iobj, data, ierr)
    !! item list dimension of psmom_num (PS_moments)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_npsmom', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % npsmom
end subroutine psget_npsmom


subroutine psset_npsmom(iobj, data, ierr)
    !! item list dimension of psmom_num (PS_moments)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_npsmom', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % npsmom = data
end subroutine psset_npsmom


subroutine psget_nefi_anom(iobj, data, ierr)
    !! grid dimension of E_anom (E coordinate)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_nefi_anom', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % nefi_anom
end subroutine psget_nefi_anom


subroutine psset_nefi_anom(iobj, data, ierr)
    !! grid dimension of E_anom (E coordinate)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_nefi_anom', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % nefi_anom = data
end subroutine psset_nefi_anom


subroutine psget_ns_bdy(iobj, n1, data, ierr)
    !! specie densities at/beyond boundary
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_ns_bdy', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % ns_bdy
end subroutine psget_ns_bdy


subroutine psset_ns_bdy(iobj, n1, data, ierr)
    !! specie densities at/beyond boundary
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_ns_bdy', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % ns_bdy = data(1:n1)
end subroutine psset_ns_bdy


subroutine psgetrnk_ns_bdy(iobj, ndims, ierr)
    !! specie densities at/beyond boundary
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_ns_bdy


subroutine psgetdim_ns_bdy(iobj, ndims, dims, ierr)
    !! specie densities at/beyond boundary
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_ns_bdy', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % ns_bdy ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % ns_bdy)
    endif
end subroutine psgetdim_ns_bdy


subroutine psget_nmini_bdy(iobj, n1, data, ierr)
    !! RF minority ion densities at/beyond boundary
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_nmini_bdy', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % nmini_bdy
end subroutine psget_nmini_bdy


subroutine psset_nmini_bdy(iobj, n1, data, ierr)
    !! RF minority ion densities at/beyond boundary
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_nmini_bdy', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % nmini_bdy = data(1:n1)
end subroutine psset_nmini_bdy


subroutine psgetrnk_nmini_bdy(iobj, ndims, ierr)
    !! RF minority ion densities at/beyond boundary
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_nmini_bdy


subroutine psgetdim_nmini_bdy(iobj, ndims, dims, ierr)
    !! RF minority ion densities at/beyond boundary
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_nmini_bdy', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % nmini_bdy ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % nmini_bdy)
    endif
end subroutine psgetdim_nmini_bdy


subroutine psget_ni_ky_tglf(iobj, n1, n2, data, ierr)
    !! ion density fluctuation spectrum
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_ni_ky_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % ni_ky_tglf
end subroutine psget_ni_ky_tglf


subroutine psset_ni_ky_tglf(iobj, n1, n2, data, ierr)
    !! ion density fluctuation spectrum
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_ni_ky_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % ni_ky_tglf = data(1:n1, 1: n2)
end subroutine psset_ni_ky_tglf


subroutine psgetrnk_ni_ky_tglf(iobj, ndims, ierr)
    !! ion density fluctuation spectrum
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_ni_ky_tglf


subroutine psgetdim_ni_ky_tglf(iobj, ndims, dims, ierr)
    !! ion density fluctuation spectrum
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_ni_ky_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % ni_ky_tglf ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % ni_ky_tglf)
    endif
end subroutine psgetdim_ni_ky_tglf


subroutine psget_nmodel(iobj, n1, data, ierr)
    !! target density profile, from experiment or "profile
    !! consistency" model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_nmodel', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % nmodel
end subroutine psget_nmodel


subroutine psset_nmodel(iobj, n1, data, ierr)
    !! target density profile, from experiment or "profile
    !! consistency" model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_nmodel', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % nmodel = data(1:n1)
end subroutine psset_nmodel


subroutine psgetrnk_nmodel(iobj, ndims, ierr)
    !! target density profile, from experiment or "profile
    !! consistency" model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_nmodel


subroutine psgetdim_nmodel(iobj, ndims, dims, ierr)
    !! target density profile, from experiment or "profile
    !! consistency" model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_nmodel', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % nmodel ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % nmodel)
    endif
end subroutine psgetdim_nmodel

subroutine ps_freetmp(iobj,id,iout)

  !------------------------------------------------------------
  ! delate a temporary object
  !------------------------------------------------------------

  use plasma_state_definition_mod
  use plasma_state_xpobj  ! XPLASMA2 state object definitions
  implicit NONE

  !-----------------------
  !  passed arguments:

  integer :: iobj(ps_container_size)     ! xplasma opaque container
  integer, intent(in) :: id       ! ID of object to free, if non-zero
  !  if id<=0 this routine silently does nothing.

  integer, intent(in) :: iout     ! LUN for messages

  !-----------------------
  integer :: iertmp
  character*32, parameter :: authname = "PS_XPLASMA2"

  type (interp_object) :: xobj
  type (xplasma), pointer :: s
  !-----------------------

  if(id.le.0) return

  xobj = transfer(iobj,xobj)
  s => xobj%s_xpobj

  call xplasma_global_info(s,iertmp, init_check=.TRUE.)
  if(iertmp.ne.0) then
     write(iout,*) ' %ps_freetmp: invalid or unitialized xplasma object.'
     return
  endif

  call xplasma_author_set(s,authname,iertmp)

  call xplasma_remove_item(s,id,iertmp)
  if(iertmp.ne.0) then
     write(iout,*) ' %ps_freetmp: error removing item:'
     call xplasma_error(s,iertmp,iout)
  endif

  call xplasma_author_clear(s,authname,iertmp)

end subroutine ps_freetmp

SUBROUTINE ccps_clear_profs(iobj, cclist, save_hash, ierr)
  use plasma_state_mod
  implicit NONE
  integer :: iobj(*)   ! (ps_container_size) words : state object
  INTEGER, INTENT(IN) :: cclist(ps_ccount)  ! component list
  !  default: clear profiles of ALL components; presence of this list
  !  allows selection of subset.

  integer, INTENT(IN) :: save_hash  ! 1 to save hash codes
  !  set in the state prior to this call; by default they are not saved.
  integer, intent(out) :: ierr  ! exit status code (0=OK)

  !-------------------------
  type (plasma_state_container) :: ptr
  type (plasma_state), pointer :: ss
  logical :: save_hash_log
  integer :: iersum
  !-------------------------

  iersum = 0

  call ccps_argcheck('ccps_clear_profs ',iobj,ierr)
  if(ierr.ne.0) iersum=iersum+1
  
  if(iersum.gt.0) then
     ierr=1
     return
  endif

  ! proceed...

  call load_ps_container(iobj,ptr)
  ss => ptr%ps_ptr

  save_hash_log = .FALSE.
  if (save_hash == 1) save_hash_log = .TRUE.

  call ps_clear_profs(state=ss, cclist=cclist, &
       & save_hash=save_hash_log, ierr=ierr)

end SUBROUTINE ccps_clear_profs

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_t4_dummy
     return
  end subroutine ccps_getset_t4_dummy

subroutine psget_t_fhalf_standard(iobj, n1, data, ierr)
    !! T beam half energy fractions
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_t_fhalf_standard', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % T_fhalf_standard
end subroutine psget_t_fhalf_standard


subroutine psset_t_fhalf_standard(iobj, n1, data, ierr)
    !! T beam half energy fractions
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_t_fhalf_standard', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % T_fhalf_standard = data(1:n1)
end subroutine psset_t_fhalf_standard


subroutine psgetrnk_t_fhalf_standard(iobj, ndims, ierr)
    !! T beam half energy fractions
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_t_fhalf_standard


subroutine psgetdim_t_fhalf_standard(iobj, ndims, dims, ierr)
    !! T beam half energy fractions
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_t_fhalf_standard', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % T_fhalf_standard ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % T_fhalf_standard)
    endif
end subroutine psgetdim_t_fhalf_standard


subroutine psget_tfinal(iobj, data, ierr)
    !! stop time of simulation (may be adjustable)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_tfinal', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % tfinal
end subroutine psget_tfinal


subroutine psset_tfinal(iobj, data, ierr)
    !! stop time of simulation (may be adjustable)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_tfinal', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % tfinal = data
end subroutine psset_tfinal


subroutine psget_ts_is_input(iobj, n1, data, ierr)
    !! specie temperature measurement flag
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_ts_is_input', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % Ts_is_input
end subroutine psget_ts_is_input


subroutine psset_ts_is_input(iobj, n1, data, ierr)
    !! specie temperature measurement flag
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_ts_is_input', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % Ts_is_input = data(1:n1)
end subroutine psset_ts_is_input


subroutine psgetrnk_ts_is_input(iobj, ndims, ierr)
    !! specie temperature measurement flag
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_ts_is_input


subroutine psgetdim_ts_is_input(iobj, ndims, dims, ierr)
    !! specie temperature measurement flag
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_ts_is_input', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % Ts_is_input ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % Ts_is_input)
    endif
end subroutine psgetdim_ts_is_input


subroutine psget_tqbi(iobj, n1, data, ierr)
    !! collisional beam torque to thermal ions
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_tqbi', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % tqbi
end subroutine psget_tqbi


subroutine psset_tqbi(iobj, n1, data, ierr)
    !! collisional beam torque to thermal ions
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_tqbi', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % tqbi = data(1:n1)
end subroutine psset_tqbi


subroutine psgetrnk_tqbi(iobj, ndims, ierr)
    !! collisional beam torque to thermal ions
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_tqbi


subroutine psgetdim_tqbi(iobj, ndims, dims, ierr)
    !! collisional beam torque to thermal ions
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_tqbi', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % tqbi ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % tqbi)
    endif
end subroutine psgetdim_tqbi


subroutine psget_tfrip2_log(iobj, n1, n2, data, ierr)
    !! 2nd component of TF ripple, log((Bmax-Bmin)/(Bmax+Bmin)),
    !! This field is sometimes introduced, time dependently in
    !! experiments.
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_tfrip2_log', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % tfrip2_log
end subroutine psget_tfrip2_log


subroutine psset_tfrip2_log(iobj, n1, n2, data, ierr)
    !! 2nd component of TF ripple, log((Bmax-Bmin)/(Bmax+Bmin)),
    !! This field is sometimes introduced, time dependently in
    !! experiments.
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_tfrip2_log', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % tfrip2_log = data(1:n1, 1: n2)
end subroutine psset_tfrip2_log


subroutine psgetrnk_tfrip2_log(iobj, ndims, ierr)
    !! 2nd component of TF ripple, log((Bmax-Bmin)/(Bmax+Bmin)),
    !! This field is sometimes introduced, time dependently in
    !! experiments.
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_tfrip2_log


subroutine psgetdim_tfrip2_log(iobj, ndims, dims, ierr)
    !! 2nd component of TF ripple, log((Bmax-Bmin)/(Bmax+Bmin)),
    !! This field is sometimes introduced, time dependently in
    !! experiments.
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_tfrip2_log', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % tfrip2_log ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % tfrip2_log)
    endif
end subroutine psgetdim_tfrip2_log


subroutine psget_tz_ky_tglf(iobj, n1, n2, data, ierr)
    !! impurity density fluctuation spectrum
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_tz_ky_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % tz_ky_tglf
end subroutine psget_tz_ky_tglf


subroutine psset_tz_ky_tglf(iobj, n1, n2, data, ierr)
    !! impurity density fluctuation spectrum
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_tz_ky_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % tz_ky_tglf = data(1:n1, 1: n2)
end subroutine psset_tz_ky_tglf


subroutine psgetrnk_tz_ky_tglf(iobj, ndims, ierr)
    !! impurity density fluctuation spectrum
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_tz_ky_tglf


subroutine psgetdim_tz_ky_tglf(iobj, ndims, dims, ierr)
    !! impurity density fluctuation spectrum
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_tz_ky_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % tz_ky_tglf ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % tz_ky_tglf)
    endif
end subroutine psgetdim_tz_ky_tglf

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_s2_dummy
     return
  end subroutine ccps_getset_s2_dummy

subroutine psget_sfus_name(iobj, n1, data, ierr)
    !! fusion product ion species
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    CHARACTER*(*), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_sfus_name', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % SFUS_name
end subroutine psget_sfus_name


subroutine psset_sfus_name(iobj, n1, data, ierr)
    !! fusion product ion species
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    CHARACTER*(*), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_sfus_name', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % SFUS_name = data(1:n1)
end subroutine psset_sfus_name


subroutine psgetsz_sfus_name(iobj, size, ierr)
    !! fusion product ion species
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: size    ! size of character string
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psgetsz_sfus_name', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! note that the following will return the character length size regardless of
    ! the number of array elements (if SFUS_name is an array)
    size = len(ss % SFUS_name)
end subroutine psgetsz_sfus_name


subroutine psgetrnk_sfus_name(iobj, ndims, ierr)
    !! fusion product ion species
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_sfus_name


subroutine psgetdim_sfus_name(iobj, ndims, dims, ierr)
    !! fusion product ion species
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_sfus_name', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % SFUS_name ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % SFUS_name)
    endif
end subroutine psgetdim_sfus_name


subroutine psget_simp0_name(iobj, n1, data, ierr)
    !! atomic impurity species in simulation
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    CHARACTER*(*), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_simp0_name', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % SIMP0_name
end subroutine psget_simp0_name


subroutine psset_simp0_name(iobj, n1, data, ierr)
    !! atomic impurity species in simulation
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    CHARACTER*(*), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_simp0_name', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % SIMP0_name = data(1:n1)
end subroutine psset_simp0_name


subroutine psgetsz_simp0_name(iobj, size, ierr)
    !! atomic impurity species in simulation
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: size    ! size of character string
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psgetsz_simp0_name', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! note that the following will return the character length size regardless of
    ! the number of array elements (if SIMP0_name is an array)
    size = len(ss % SIMP0_name)
end subroutine psgetsz_simp0_name


subroutine psgetrnk_simp0_name(iobj, ndims, ierr)
    !! atomic impurity species in simulation
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_simp0_name


subroutine psgetdim_simp0_name(iobj, ndims, dims, ierr)
    !! atomic impurity species in simulation
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_simp0_name', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % SIMP0_name ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % SIMP0_name)
    endif
end subroutine psgetdim_simp0_name


subroutine psget_surf(iobj, n1, data, ierr)
    !! area of flux surfaces
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_surf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % surf
end subroutine psget_surf


subroutine psset_surf(iobj, n1, data, ierr)
    !! area of flux surfaces
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_surf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % surf = data(1:n1)
end subroutine psset_surf


subroutine psgetrnk_surf(iobj, ndims, ierr)
    !! area of flux surfaces
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_surf


subroutine psgetdim_surf(iobj, ndims, dims, ierr)
    !! area of flux surfaces
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_surf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % surf ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % surf)
    endif
end subroutine psgetdim_surf


subroutine psget_sb0halo_recap(iobj, n1, n2, data, ierr)
    !! cx neutral recapture, recapture of thermal neutrals -- ion
    !! source, psc_halo =~ (3/2)*Ti*(sb0halo_recap-sb0halo)*1.602e-16,
    !! (cross species CX source/sink contributions may occur), note:
    !! electron recapture, cold source = sum
    !! (Z(i)*sb0halo_recap(:,i)), where Z(i) is the number of
    !! electrons carried by a neutral atom, of species (i).  => this
    !! is to be included in sbsce(:,0).
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_sb0halo_recap', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % sb0halo_recap
end subroutine psget_sb0halo_recap


subroutine psset_sb0halo_recap(iobj, n1, n2, data, ierr)
    !! cx neutral recapture, recapture of thermal neutrals -- ion
    !! source, psc_halo =~ (3/2)*Ti*(sb0halo_recap-sb0halo)*1.602e-16,
    !! (cross species CX source/sink contributions may occur), note:
    !! electron recapture, cold source = sum
    !! (Z(i)*sb0halo_recap(:,i)), where Z(i) is the number of
    !! electrons carried by a neutral atom, of species (i).  => this
    !! is to be included in sbsce(:,0).
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_sb0halo_recap', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % sb0halo_recap = data(1:n1, 1: n2)
end subroutine psset_sb0halo_recap


subroutine psgetrnk_sb0halo_recap(iobj, ndims, ierr)
    !! cx neutral recapture, recapture of thermal neutrals -- ion
    !! source, psc_halo =~ (3/2)*Ti*(sb0halo_recap-sb0halo)*1.602e-16,
    !! (cross species CX source/sink contributions may occur), note:
    !! electron recapture, cold source = sum
    !! (Z(i)*sb0halo_recap(:,i)), where Z(i) is the number of
    !! electrons carried by a neutral atom, of species (i).  => this
    !! is to be included in sbsce(:,0).
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_sb0halo_recap


subroutine psgetdim_sb0halo_recap(iobj, ndims, dims, ierr)
    !! cx neutral recapture, recapture of thermal neutrals -- ion
    !! source, psc_halo =~ (3/2)*Ti*(sb0halo_recap-sb0halo)*1.602e-16,
    !! (cross species CX source/sink contributions may occur), note:
    !! electron recapture, cold source = sum
    !! (Z(i)*sb0halo_recap(:,i)), where Z(i) is the number of
    !! electrons carried by a neutral atom, of species (i).  => this
    !! is to be included in sbsce(:,0).
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_sb0halo_recap', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % sb0halo_recap ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % sb0halo_recap)
    endif
end subroutine psgetdim_sb0halo_recap


subroutine psget_sfsce(iobj, n1, n2, data, ierr)
    !! net thermalization source of fusion ions, sources due to
    !! fusion ions:  fusion ion thermalization;, corrections due to
    !! charge exchange effects (usually small).
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_sfsce', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % sfsce
end subroutine psget_sfsce


subroutine psset_sfsce(iobj, n1, n2, data, ierr)
    !! net thermalization source of fusion ions, sources due to
    !! fusion ions:  fusion ion thermalization;, corrections due to
    !! charge exchange effects (usually small).
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_sfsce', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % sfsce = data(1:n1, 1: n2)
end subroutine psset_sfsce


subroutine psgetrnk_sfsce(iobj, ndims, ierr)
    !! net thermalization source of fusion ions, sources due to
    !! fusion ions:  fusion ion thermalization;, corrections due to
    !! charge exchange effects (usually small).
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_sfsce


subroutine psgetdim_sfsce(iobj, ndims, dims, ierr)
    !! net thermalization source of fusion ions, sources due to
    !! fusion ions:  fusion ion thermalization;, corrections due to
    !! charge exchange effects (usually small).
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_sfsce', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % sfsce ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % sfsce)
    endif
end subroutine psgetdim_sfsce


subroutine psget_s0reco_e(iobj, n1, data, ierr)
    !! net electron source associated with recombination:,
    !! sum[-Z(i)*s0reco(:,i) + Z(i)*s0reco_recap(:,i)]
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_s0reco_e', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % s0reco_e
end subroutine psget_s0reco_e


subroutine psset_s0reco_e(iobj, n1, data, ierr)
    !! net electron source associated with recombination:,
    !! sum[-Z(i)*s0reco(:,i) + Z(i)*s0reco_recap(:,i)]
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_s0reco_e', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % s0reco_e = data(1:n1)
end subroutine psset_s0reco_e


subroutine psgetrnk_s0reco_e(iobj, ndims, ierr)
    !! net electron source associated with recombination:,
    !! sum[-Z(i)*s0reco(:,i) + Z(i)*s0reco_recap(:,i)]
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_s0reco_e


subroutine psgetdim_s0reco_e(iobj, ndims, dims, ierr)
    !! net electron source associated with recombination:,
    !! sum[-Z(i)*s0reco(:,i) + Z(i)*s0reco_recap(:,i)]
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_s0reco_e', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % s0reco_e ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % s0reco_e)
    endif
end subroutine psgetdim_s0reco_e

subroutine ps_update_mhdeq(g_filename,crat,kpsi_cur,rho_curbrk,ps,iout,ierr)

  !  Update plasma state "ps" with equilibrium from g file.
  !  XPLASMA2 implementation -- DMC Oct 10 2006

  !------------------------------------------------------------

  use plasma_state_xpobj  ! XPLASMA2 state object definitions

  use plasma_state_definition_mod

  implicit NONE

  !-----------------------
  !  passed:

  character*(*), intent(in) :: g_filename ! filename
  real*8, intent(in) :: crat              ! minimum allowed bdy curvature ratio
  integer, intent(in) :: kpsi_cur         ! select method for getting I(rho)
  real*8, intent(in) :: rho_curbrk        ! interpolation break pt for I(rho)
  type (plasma_state) :: ps               ! plasma state object to be updated
  integer, intent(in) :: iout     ! Fortran LUN for messages
  integer, intent(out) :: ierr    ! exit status code 0=OK

  !-----------------------
  !  crat -- curvature ratio -- controls offset of bdy surface from separatrix
  !
  !  kpsi_cur -- =0: use EFIT file data for total toroidal current and for
  !                  q(psi);
  !              =1: compute q(psi) and total current from Psi(R,Z) data; EFIT
  !                  file data for these quantities is discarded.
  !
  !  rho_curbrk -- normalize sqrt tor flux location (btw 0.75 and 0.95) where
  !                transition from Psi(R,Z) computation of I(rho) to parabolic
  !                interpolation to reach boundary value occurs
  !    
  !-----------------------
  !  local:

  integer :: inrho,inth,i2pi,iwarn,iertmp
  integer :: ikmom
  real(KIND=rspec), parameter :: TWOPI = 6.2831853071795862_rspec
  real(KIND=rspec), parameter ::    PI = 3.1415926535897931_rspec

  real(KIND=rspec), parameter ::  zvar = 0.00010_rspec  ! see also: ps_xload_check.f90...

  type (interp_object) :: xobj
  type (xplasma), pointer :: s
  !-------------------------------------------------------------------------
  ! executable code...

  call ps_tagchk('ps_update_mhdeq',ps%itag,iout,ierr)
  if(ierr.ne.0) return

  if(ps_debug.ge.2) then
     write(iout,*) 'ps_update_mhdeq: set equilibrium from g_file: '// &
          trim(g_filename)
  endif

  call ps_reset_mhdeq_hash(ps)

  xobj = transfer(ps%iobj,xobj)
  s => xobj%s_xpobj

  call xplasma_global_info(s,ierr, init_check=.TRUE.)
  if(ierr.ne.0) then
     write(iout,*) ' %ps_update_mhdeq: invalid or unitialized xplasma object.'
     return
  endif

  ! allow more than the default det(J) variation...
  !   zvar is related to a limit on min(det(J))/max(det(J)) over each
  !   flux surface.

  call xplasma_ajac_maxvar_set(s,zvar,ierr)
  if(ierr.ne.0) then
     write(iout,*) ' %ps_update_mhdeq: xplasma_ajac_maxvar_set error.'
     return
  endif

  !----------------------

  call xplasma_author_set(s,'EQ',ierr)
  if (ierr/=0) then
     call xplasma_error(s,ierr,iout)
     return
  end if

  !----------------------
  !  G-eqdsk filename ***
  ps%eqdsk_file = g_filename

  !----------------------
  !  get rho,theta dimensions to use for geqdsk read

  if(ps%nrho_eq.le.0) then
     write(iout,*) ' %ps_update_mhdeq: default "rho_eq" grid size set = 51'
     inrho = 51  ! default radial resolution
  else
     inrho = ps%nrho_eq
  endif

  i2pi = 0

  if(ps%nth_eq.le.0) then
     inth = 2*(inrho-1) + 1
     i2pi=1
  else
     inth = ps%nth_eq
     if(allocated(ps%th_eq)) then
        if(abs(ps%th_eq(inth)-ps%th_eq(1)-twopi).gt.1.0e-1_rspec) then
           !  difference not close to twopi
           i2pi = 1
        else if(abs(ps%th_eq(1)+pi).lt.abs(ps%th_eq(1))) then
           !  [-pi,pi] range
           i2pi = 1
        else
           !  [0,2pi] range
           i2pi = 2
        endif
     endif
  endif

  !----------------------
  ! read the G-eqdsk file; map the equilibrium
  ikmom=min(ps%nmom,64) 
  if(ikmom.le.0) ikmom=64
  call xplasma_kmom_set(s,ikmom,ierr)  ! set FFT moments up to 64
  if(ierr.ne.0) then
     write(iout,*) ' %ps_update_mhdeq: error in  xplasma_kmom_set:'
     call xplasma_error(s,ierr,iout)
     go to 999
  endif

  call xplasma_fromgeqdsk(s,g_filename,ierr, &
       nrho=inrho, nth=inth, i2pi=i2pi, &
       cratio_min = crat, equal_arc = .TRUE., kmom = ikmom,&
       kpsi_cur = kpsi_cur, rho_curbreak = rho_curbrk, &
       lhermite = .TRUE.)
  
  if(ierr.ne.0) then
     write(iout,*) ' %ps_update_mhdeq: error in xplasma_fromgeqdsk:'
     call xplasma_error(s,ierr,iout)
     go to 999
  else
     call eqi_fromg_warn(iwarn)
     if(iwarn.gt.0) then
        write(iout,*) ' '
        write(iout,*) ' %ps_update_mhdeq: xplasma_fromgeqdsk messages:'
        call xplasma_error(s,ierr,iout)
     endif
  endif

  ! ------------------
  ! update plasma_state from xplasma object

  call ps_update_fromxplasma(ps,iout,ierr)
  if(ierr.ne.0) go to 999
 
999 continue
  call xplasma_author_clear(s,'EQ',iertmp)
  if (iertmp/=0) then
     call xplasma_error(s,iertmp,iout)
     ierr=1
  end if

  if(ierr.ne.0) then
     ierr=999
     write(iout,*) ' ?ps_update_mhdeq: an error was detected.'
  else
     if(ps_debug.ge.2) then
        write(iout,*) ' ps_update_mhdeq: MHD equilibrium OK, normal exit.'
        write(iout,*) ' '
     endif
  endif

end subroutine ps_update_mhdeq

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_b0_dummy
     return
  end subroutine ccps_getset_b0_dummy

subroutine psget_balloon_mapper(iobj, n1, data, ierr)
    !! mapper code used for each ballooning code
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    CHARACTER*(*), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_balloon_mapper', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % Balloon_mapper
end subroutine psget_balloon_mapper


subroutine psset_balloon_mapper(iobj, n1, data, ierr)
    !! mapper code used for each ballooning code
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    CHARACTER*(*), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_balloon_mapper', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % Balloon_mapper = data(1:n1)
end subroutine psset_balloon_mapper


subroutine psgetsz_balloon_mapper(iobj, size, ierr)
    !! mapper code used for each ballooning code
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: size    ! size of character string
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psgetsz_balloon_mapper', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! note that the following will return the character length size regardless of
    ! the number of array elements (if Balloon_mapper is an array)
    size = len(ss % Balloon_mapper)
end subroutine psgetsz_balloon_mapper


subroutine psgetrnk_balloon_mapper(iobj, ndims, ierr)
    !! mapper code used for each ballooning code
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_balloon_mapper


subroutine psgetdim_balloon_mapper(iobj, ndims, dims, ierr)
    !! mapper code used for each ballooning code
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_balloon_mapper', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % Balloon_mapper ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % Balloon_mapper)
    endif
end subroutine psgetdim_balloon_mapper


subroutine psget_b_max_lcfs(iobj, data, ierr)
    !! |B|_max of last closed flux surface
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_b_max_lcfs', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % B_max_lcfs
end subroutine psget_b_max_lcfs


subroutine psset_b_max_lcfs(iobj, data, ierr)
    !! |B|_max of last closed flux surface
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_b_max_lcfs', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % B_max_lcfs = data
end subroutine psset_b_max_lcfs


subroutine psget_balloon_stable(iobj, n1, data, ierr)
    !! 0: stable everywhere; =1: unstable somewhere
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_balloon_stable', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % Balloon_stable
end subroutine psget_balloon_stable


subroutine psset_balloon_stable(iobj, n1, data, ierr)
    !! 0: stable everywhere; =1: unstable somewhere
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_balloon_stable', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % Balloon_stable = data(1:n1)
end subroutine psset_balloon_stable


subroutine psgetrnk_balloon_stable(iobj, ndims, ierr)
    !! 0: stable everywhere; =1: unstable somewhere
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_balloon_stable


subroutine psgetdim_balloon_stable(iobj, ndims, dims, ierr)
    !! 0: stable everywhere; =1: unstable somewhere
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_balloon_stable', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % Balloon_stable ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % Balloon_stable)
    endif
end subroutine psgetdim_balloon_stable


subroutine psget_bzrz(iobj, n1, n2, data, ierr)
    !! Z component of poloidal field
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_bzrz', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % BZRZ
end subroutine psget_bzrz


subroutine psset_bzrz(iobj, n1, n2, data, ierr)
    !! Z component of poloidal field
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_bzrz', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % BZRZ = data(1:n1, 1: n2)
end subroutine psset_bzrz


subroutine psgetrnk_bzrz(iobj, ndims, ierr)
    !! Z component of poloidal field
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_bzrz


subroutine psgetdim_bzrz(iobj, ndims, dims, ierr)
    !! Z component of poloidal field
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_bzrz', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % BZRZ ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % BZRZ)
    endif
end subroutine psgetdim_bzrz


subroutine psget_b_surfmax(iobj, n1, data, ierr)
    !! max mod(B) on flux surface
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_b_surfmax', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % B_surfMax
end subroutine psget_b_surfmax


subroutine psset_b_surfmax(iobj, n1, data, ierr)
    !! max mod(B) on flux surface
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_b_surfmax', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % B_surfMax = data(1:n1)
end subroutine psset_b_surfmax


subroutine psgetrnk_b_surfmax(iobj, ndims, ierr)
    !! max mod(B) on flux surface
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_b_surfmax


subroutine psgetdim_b_surfmax(iobj, ndims, dims, ierr)
    !! max mod(B) on flux surface
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_b_surfmax', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % B_surfMax ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % B_surfMax)
    endif
end subroutine psgetdim_b_surfmax


subroutine psget_bidiff_bpass_co(iobj, n1, n2, n3, data, ierr)
    !! beam ion diffusivity: co barely passing orbits
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2, n3 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2, n3) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_bidiff_bpass_co', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2, 1: n3) = ss % bidiff_bpass_co
end subroutine psget_bidiff_bpass_co


subroutine psset_bidiff_bpass_co(iobj, n1, n2, n3, data, ierr)
    !! beam ion diffusivity: co barely passing orbits
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2, n3 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2, n3) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_bidiff_bpass_co', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % bidiff_bpass_co = data(1:n1, 1: n2, 1: n3)
end subroutine psset_bidiff_bpass_co


subroutine psgetrnk_bidiff_bpass_co(iobj, ndims, ierr)
    !! beam ion diffusivity: co barely passing orbits
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 3
end subroutine psgetrnk_bidiff_bpass_co


subroutine psgetdim_bidiff_bpass_co(iobj, ndims, dims, ierr)
    !! beam ion diffusivity: co barely passing orbits
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 3) ierr = 1
    call ccps_argcheck('psgetdim_bidiff_bpass_co', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % bidiff_bpass_co ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % bidiff_bpass_co)
    endif
end subroutine psgetdim_bidiff_bpass_co

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_i0_dummy
     return
  end subroutine ccps_getset_i0_dummy

subroutine psget_ic_data_info(iobj, data, ierr)
    !! information on source of ICRF power data
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    CHARACTER*(*), intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_ic_data_info', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % IC_Data_Info
end subroutine psget_ic_data_info


subroutine psset_ic_data_info(iobj, data, ierr)
    !! information on source of ICRF power data
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    CHARACTER*(*), intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_ic_data_info', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % IC_Data_Info = data
end subroutine psset_ic_data_info


subroutine psgetsz_ic_data_info(iobj, size, ierr)
    !! information on source of ICRF power data
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: size    ! size of character string
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psgetsz_ic_data_info', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! note that the following will return the character length size regardless of
    ! the number of array elements (if IC_Data_Info is an array)
    size = len(ss % IC_Data_Info)
end subroutine psgetsz_ic_data_info


subroutine psget_id_ts(iobj, n1, data, ierr)
    !! 'Array of IDs for Ts profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_ts', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_ts
end subroutine psget_id_ts


subroutine psgetrnk_id_ts(iobj, ndims, ierr)
    !! 'Array of IDs for Ts profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_ts


subroutine psgetdim_id_ts(iobj, ndims, dims, ierr)
    !! 'Array of IDs for Ts profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_ts', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_ts ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_ts)
    endif
end subroutine psgetdim_id_ts


subroutine psget_id_zeff_fi(iobj, data, ierr)
    !! 'ID for Zeff_fi profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_zeff_fi', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_zeff_fi
end subroutine psget_id_zeff_fi


subroutine psget_id_pohme(iobj, data, ierr)
    !! 'ID for pohme profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_pohme', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_pohme
end subroutine psget_id_pohme


subroutine psget_id_pe_trans(iobj, data, ierr)
    !! 'ID for pe_trans profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_pe_trans', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_pe_trans
end subroutine psget_id_pe_trans


subroutine psget_id_vmo_trans(iobj, data, ierr)
    !! 'ID for vmo_trans profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_vmo_trans', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_vmo_trans
end subroutine psget_id_vmo_trans


subroutine psget_id_vee_transcat(iobj, n1, data, ierr)
    !! 'Array of IDs for vee_transcat profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_vee_transcat', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_vee_transcat
end subroutine psget_id_vee_transcat


subroutine psgetrnk_id_vee_transcat(iobj, ndims, ierr)
    !! 'Array of IDs for vee_transcat profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_vee_transcat


subroutine psgetdim_id_vee_transcat(iobj, ndims, dims, ierr)
    !! 'Array of IDs for vee_transcat profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_vee_transcat', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_vee_transcat ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_vee_transcat)
    endif
end subroutine psgetdim_id_vee_transcat


subroutine psget_id_vol(iobj, data, ierr)
    !! 'ID for vol profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_vol', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_vol
end subroutine psget_id_vol


subroutine psget_id_curt(iobj, data, ierr)
    !! 'ID for curt profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_curt', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_curt
end subroutine psget_id_curt


subroutine psget_id_bzrz(iobj, data, ierr)
    !! 'ID for BZRZ profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_bzrz', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_bzrz
end subroutine psget_id_bzrz


subroutine psget_id_gr2rho2(iobj, data, ierr)
    !! 'ID for gr2rho2 profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_gr2rho2', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_gr2rho2
end subroutine psget_id_gr2rho2


subroutine psget_id_psmom_errck(iobj, data, ierr)
    !! 'ID for psmom_errck profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_psmom_errck', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_psmom_errck
end subroutine psget_id_psmom_errck


subroutine psget_id_b_surfmax(iobj, data, ierr)
    !! 'ID for B_surfMax profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_b_surfmax', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_b_surfmax
end subroutine psget_id_b_surfmax


subroutine psget_id_triang_miller_u(iobj, data, ierr)
    !! 'ID for triang_miller_U profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_triang_miller_u', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_triang_miller_u
end subroutine psget_id_triang_miller_u


subroutine psget_id_pmini(iobj, data, ierr)
    !! 'ID for pmini profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_pmini', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_pmini
end subroutine psget_id_pmini


subroutine psget_id_pbe(iobj, data, ierr)
    !! 'ID for pbe profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_pbe', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_pbe
end subroutine psget_id_pbe


subroutine psget_id_sb0halo(iobj, n1, data, ierr)
    !! 'Array of IDs for sb0halo profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_sb0halo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_sb0halo
end subroutine psget_id_sb0halo


subroutine psgetrnk_id_sb0halo(iobj, ndims, ierr)
    !! 'Array of IDs for sb0halo profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_sb0halo


subroutine psgetdim_id_sb0halo(iobj, ndims, dims, ierr)
    !! 'Array of IDs for sb0halo profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_sb0halo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_sb0halo ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_sb0halo)
    endif
end subroutine psgetdim_id_sb0halo


subroutine psget_id_t0_halo(iobj, n1, data, ierr)
    !! 'Array of IDs for T0_halo profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_t0_halo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_t0_halo
end subroutine psget_id_t0_halo


subroutine psgetrnk_id_t0_halo(iobj, ndims, ierr)
    !! 'Array of IDs for T0_halo profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_t0_halo


subroutine psgetdim_id_t0_halo(iobj, ndims, dims, ierr)
    !! 'Array of IDs for T0_halo profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_t0_halo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_t0_halo ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_t0_halo)
    endif
end subroutine psgetdim_id_t0_halo


subroutine psget_id_pfusi(iobj, data, ierr)
    !! 'ID for pfusi profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_pfusi', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_pfusi
end subroutine psget_id_pfusi


subroutine psget_id_dcur_rw_dvloop(iobj, data, ierr)
    !! 'ID for dcur_rw_dVloop profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_dcur_rw_dvloop', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_dcur_rw_dvloop
end subroutine psget_id_dcur_rw_dvloop


subroutine psget_id_qqcx(iobj, n1, data, ierr)
    !! 'Array of IDs for qqcx profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_qqcx', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_qqcx
end subroutine psget_id_qqcx


subroutine psgetrnk_id_qqcx(iobj, ndims, ierr)
    !! 'Array of IDs for qqcx profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_qqcx


subroutine psgetdim_id_qqcx(iobj, ndims, dims, ierr)
    !! 'Array of IDs for qqcx profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_qqcx', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_qqcx ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_qqcx)
    endif
end subroutine psgetdim_id_qqcx


subroutine psget_id_s0reco(iobj, n1, data, ierr)
    !! 'Array of IDs for s0reco profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_s0reco', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_s0reco
end subroutine psget_id_s0reco


subroutine psgetrnk_id_s0reco(iobj, ndims, ierr)
    !! 'Array of IDs for s0reco profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_s0reco


subroutine psgetdim_id_s0reco(iobj, ndims, dims, ierr)
    !! 'Array of IDs for s0reco profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_s0reco', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_s0reco ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_s0reco)
    endif
end subroutine psgetdim_id_s0reco


subroutine psget_id_t0_reco(iobj, n1, data, ierr)
    !! 'Array of IDs for T0_reco profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_t0_reco', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_t0_reco
end subroutine psget_id_t0_reco


subroutine psgetrnk_id_t0_reco(iobj, ndims, ierr)
    !! 'Array of IDs for T0_reco profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_t0_reco


subroutine psgetdim_id_t0_reco(iobj, ndims, dims, ierr)
    !! 'Array of IDs for T0_reco profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_t0_reco', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_t0_reco ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_t0_reco)
    endif
end subroutine psgetdim_id_t0_reco


subroutine psget_id_curlh(iobj, data, ierr)
    !! 'ID for curlh profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_curlh', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_curlh
end subroutine psget_id_curlh


subroutine psget_id_velb_rfmi(iobj, data, ierr)
    !! 'ID for velb_rfmi profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_velb_rfmi', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_velb_rfmi
end subroutine psget_id_velb_rfmi


subroutine psget_id_bidiff_bpass_co(iobj, n1, data, ierr)
    !! 'Array of IDs for bidiff_bpass_co profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_bidiff_bpass_co', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_bidiff_bpass_co
end subroutine psget_id_bidiff_bpass_co


subroutine psgetrnk_id_bidiff_bpass_co(iobj, ndims, ierr)
    !! 'Array of IDs for bidiff_bpass_co profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_bidiff_bpass_co


subroutine psgetdim_id_bidiff_bpass_co(iobj, ndims, dims, ierr)
    !! 'Array of IDs for bidiff_bpass_co profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_bidiff_bpass_co', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_bidiff_bpass_co ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_bidiff_bpass_co)
    endif
end subroutine psgetdim_id_bidiff_bpass_co


subroutine psget_id_velpphi_anom(iobj, data, ierr)
    !! 'ID for velpphi_anom profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_velpphi_anom', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_velpphi_anom
end subroutine psget_id_velpphi_anom


subroutine psget_id_ni_ky_tglf(iobj, n1, data, ierr)
    !! 'Array of IDs for ni_ky_tglf profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_ni_ky_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_ni_ky_tglf
end subroutine psget_id_ni_ky_tglf


subroutine psgetrnk_id_ni_ky_tglf(iobj, ndims, ierr)
    !! 'Array of IDs for ni_ky_tglf profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_ni_ky_tglf


subroutine psgetdim_id_ni_ky_tglf(iobj, ndims, dims, ierr)
    !! 'Array of IDs for ni_ky_tglf profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_ni_ky_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_ni_ky_tglf ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_ni_ky_tglf)
    endif
end subroutine psgetdim_id_ni_ky_tglf


subroutine psget_id_tzflux_ky_tglf(iobj, n1, data, ierr)
    !! 'Array of IDs for tzflux_ky_tglf profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_tzflux_ky_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_tzflux_ky_tglf
end subroutine psget_id_tzflux_ky_tglf


subroutine psgetrnk_id_tzflux_ky_tglf(iobj, ndims, ierr)
    !! 'Array of IDs for tzflux_ky_tglf profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_tzflux_ky_tglf


subroutine psgetdim_id_tzflux_ky_tglf(iobj, ndims, dims, ierr)
    !! 'Array of IDs for tzflux_ky_tglf profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_tzflux_ky_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_tzflux_ky_tglf ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_tzflux_ky_tglf)
    endif
end subroutine psgetdim_id_tzflux_ky_tglf


subroutine psget_id_dqedgrdti_tglf(iobj, data, ierr)
    !! 'ID for dQedGrdti_tglf profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_dqedgrdti_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_dqedgrdti_tglf
end subroutine psget_id_dqedgrdti_tglf


subroutine psget_id_chii_mmm71(iobj, data, ierr)
    !! 'ID for chii_mmm71 profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_chii_mmm71', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_chii_mmm71
end subroutine psget_id_chii_mmm71


subroutine psget_id_velns_mmm71(iobj, n1, data, ierr)
    !! 'Array of IDs for velns_mmm71 profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_velns_mmm71', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_velns_mmm71
end subroutine psget_id_velns_mmm71


subroutine psgetrnk_id_velns_mmm71(iobj, ndims, ierr)
    !! 'Array of IDs for velns_mmm71 profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_velns_mmm71


subroutine psgetdim_id_velns_mmm71(iobj, ndims, dims, ierr)
    !! 'Array of IDs for velns_mmm71 profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_velns_mmm71', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_velns_mmm71 ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_velns_mmm71)
    endif
end subroutine psgetdim_id_velns_mmm71


subroutine psget_id_growthrate_drbm(iobj, data, ierr)
    !! 'ID for growthrate_drbm profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_growthrate_drbm', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_growthrate_drbm
end subroutine psget_id_growthrate_drbm


subroutine psget_id_growthrate_glf(iobj, data, ierr)
    !! 'ID for growthrate_glf profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_growthrate_glf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_growthrate_glf
end subroutine psget_id_growthrate_glf


subroutine psget_id_chie_gtcneo(iobj, data, ierr)
    !! 'ID for chie_gtcneo profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_chie_gtcneo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_chie_gtcneo
end subroutine psget_id_chie_gtcneo


subroutine psget_id_chiphi_neo(iobj, data, ierr)
    !! 'ID for chiphi_neo profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_chiphi_neo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_chiphi_neo
end subroutine psget_id_chiphi_neo


subroutine psget_id_difnh_nclass(iobj, data, ierr)
    !! 'ID for difnh_nclass profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_difnh_nclass', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_difnh_nclass
end subroutine psget_id_difnh_nclass


subroutine psget_id_nmodel(iobj, data, ierr)
    !! 'ID for nmodel profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_nmodel', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_nmodel
end subroutine psget_id_nmodel

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


SUBROUTINE plasma_state_copy_2(cclist,ss,ss2,icopy_lists,iwant_1deq,partial_copy,ierr)


  ! Copy scalars, and, arrays that are allocated
  !   ss2 <-- ss

  USE plasma_state_definition_mod
  IMPLICIT NONE

  INTEGER, INTENT(IN) :: cclist(ps_ccount)
                                ! list of components to merge
                                ! use ps_cc_all to merge all components

  TYPE (plasma_state) :: ss     ! state data to copy *from*
  TYPE (plasma_state) :: ss2    ! state data to copy *to*

  INTEGER, INTENT(IN) :: icopy_lists ! =1 to require copying of all lists

  INTEGER, INTENT(IN) :: iwant_1deq  ! =1 to request fcns of (rho_eq)
                                     !  even if cclist(ps_cnum_EQ).eq.0

  LOGICAL, INTENT(IN) :: partial_copy ! .TRUE. if full state copy not in effect

  INTEGER, INTENT(INOUT) :: ierr  ! completion flag (not cleared, set by error)

  !-------------------
  INTEGER :: iout
  !-------------------

  iout = SWIM_err_out_file


  !-----------------------------------------------
  ! copy scalars and arrays that are allocated...
  IF( ((ALLOCATED(ss2%D_einj_standard)).AND.(ALLOCATED(ss%D_einj_standard))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_NBI).EQ.1)) ) THEN
     ss2%D_einj_standard = ss%D_einj_standard
  ENDIF
  IF( ((ALLOCATED(ss2%D_ffull_standard)).AND.(ALLOCATED(ss%D_ffull_standard))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_NBI).EQ.1)) ) THEN
     ss2%D_ffull_standard = ss%D_ffull_standard
  ENDIF
  IF( ((ALLOCATED(ss2%D_fhalf_standard)).AND.(ALLOCATED(ss%D_fhalf_standard))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_NBI).EQ.1)) ) THEN
     ss2%D_fhalf_standard = ss%D_fhalf_standard
  ENDIF
  IF( ((ALLOCATED(ss2%e0_av)).AND.(ALLOCATED(ss%e0_av))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_GAS).EQ.1)) ) THEN
     ss2%e0_av = ss%e0_av
  ENDIF
  IF( ((ALLOCATED(ss2%ecrf_src_name)).AND.(ALLOCATED(ss%ecrf_src_name))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_EC).EQ.1)) ) THEN
     ss2%ecrf_src_name = ss%ecrf_src_name
  ENDIF
  IF( ((ALLOCATED(ss2%EC_Beam_Elongation)).AND.(ALLOCATED(ss%EC_Beam_Elongation))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_EC).EQ.1)) ) THEN
     ss2%EC_Beam_Elongation = ss%EC_Beam_Elongation
  ENDIF
  IF((cclist(ps_cnum_EC).EQ.1).OR.(icopy_lists.EQ.1)) THEN
     ss2%EC_Code_Info = ss%EC_Code_Info
  ENDIF
  IF((cclist(ps_cnum_EC).EQ.1).OR.(icopy_lists.EQ.1)) THEN
     ss2%EC_Data_Info = ss%EC_Data_Info
  ENDIF
  IF( ((ALLOCATED(ss2%EC_Half_Power_Angle)).AND.(ALLOCATED(ss%EC_Half_Power_Angle))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_EC).EQ.1)) ) THEN
     ss2%EC_Half_Power_Angle = ss%EC_Half_Power_Angle
  ENDIF
  IF( ((ALLOCATED(ss2%EC_Omode_Fraction)).AND.(ALLOCATED(ss%EC_Omode_Fraction))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_EC).EQ.1)) ) THEN
     ss2%EC_Omode_Fraction = ss%EC_Omode_Fraction
  ENDIF
  IF( ((ALLOCATED(ss2%EC_phi_aim)).AND.(ALLOCATED(ss%EC_phi_aim))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_EC).EQ.1)) ) THEN
     ss2%EC_phi_aim = ss%EC_phi_aim
  ENDIF
  IF( ((ALLOCATED(ss2%EC_PRINC_CURV_HOR)).AND.(ALLOCATED(ss%EC_PRINC_CURV_HOR))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_EC).EQ.1)) ) THEN
     ss2%EC_PRINC_CURV_HOR = ss%EC_PRINC_CURV_HOR
  ENDIF
  IF( ((ALLOCATED(ss2%EC_PRINC_CURV_VERT)).AND.(ALLOCATED(ss%EC_PRINC_CURV_VERT))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_EC).EQ.1)) ) THEN
     ss2%EC_PRINC_CURV_VERT = ss%EC_PRINC_CURV_VERT
  ENDIF
  IF( ((ALLOCATED(ss2%EC_PRINC_WIDTH_HOR)).AND.(ALLOCATED(ss%EC_PRINC_WIDTH_HOR))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_EC).EQ.1)) ) THEN
     ss2%EC_PRINC_WIDTH_HOR = ss%EC_PRINC_WIDTH_HOR
  ENDIF
  IF( ((ALLOCATED(ss2%EC_PRINC_WIDTH_VERT)).AND.(ALLOCATED(ss%EC_PRINC_WIDTH_VERT))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_EC).EQ.1)) ) THEN
     ss2%EC_PRINC_WIDTH_VERT = ss%EC_PRINC_WIDTH_VERT
  ENDIF
  IF( ((ALLOCATED(ss2%EC_theta_aim)).AND.(ALLOCATED(ss%EC_theta_aim))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_EC).EQ.1)) ) THEN
     ss2%EC_theta_aim = ss%EC_theta_aim
  ENDIF
  IF(partial_copy) THEN
     ss2%id_ee_mobility_factor = 0
  ENDIF
  IF((ALLOCATED(ss%ee_mobility_factor).AND.ALLOCATED(ss2%ee_mobility_factor)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%ee_mobility_factor = ss%ee_mobility_factor
     IF(.not.partial_copy) THEN
        ss2%id_ee_mobility_factor = ss%id_ee_mobility_factor
     ENDIF
  ENDIF
  IF( ((ALLOCATED(ss2%Einj_max)).AND.(ALLOCATED(ss%Einj_max))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_NBI).EQ.1)) ) THEN
     ss2%Einj_max = ss%Einj_max
  ENDIF
  IF( ((ALLOCATED(ss2%Einj_min)).AND.(ALLOCATED(ss%Einj_min))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_NBI).EQ.1)) ) THEN
     ss2%Einj_min = ss%Einj_min
  ENDIF
  IF((cclist(ps_cnum_PLASMA).EQ.1).OR.(icopy_lists.EQ.1)) THEN
     ss2%eldot = ss%eldot
  ENDIF
  IF(partial_copy) THEN
     ss2%id_elong = 0
  ENDIF
  IF((ALLOCATED(ss%elong).AND.ALLOCATED(ss2%elong)).AND. &
        ((cclist(ps_cnum_EQ).EQ.1))) THEN
     ss2%elong = ss%elong
     IF(.not.partial_copy) THEN
        ss2%id_elong = ss%id_elong
     ENDIF
  ENDIF
  IF(ALLOCATED(ss2%id_eperp_beami)) THEN
     IF(partial_copy) THEN
        ss2%id_eperp_beami = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%eperp_beami).AND.ALLOCATED(ss2%eperp_beami)).AND. &
        ((cclist(ps_cnum_NBI).EQ.1))) THEN
     ss2%eperp_beami = ss%eperp_beami
     IF(ALLOCATED(ss2%id_eperp_beami)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_eperp_beami = ss%id_eperp_beami
        ENDIF
     ENDIF
  ENDIF
  IF(ALLOCATED(ss2%id_eperp_fusi)) THEN
     IF(partial_copy) THEN
        ss2%id_eperp_fusi = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%eperp_fusi).AND.ALLOCATED(ss2%eperp_fusi)).AND. &
        ((cclist(ps_cnum_FUS).EQ.1))) THEN
     ss2%eperp_fusi = ss%eperp_fusi
     IF(ALLOCATED(ss2%id_eperp_fusi)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_eperp_fusi = ss%id_eperp_fusi
        ENDIF
     ENDIF
  ENDIF
  IF(ALLOCATED(ss2%id_eperp_mini)) THEN
     IF(partial_copy) THEN
        ss2%id_eperp_mini = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%eperp_mini).AND.ALLOCATED(ss2%eperp_mini)).AND. &
        ((cclist(ps_cnum_IC).EQ.1))) THEN
     ss2%eperp_mini = ss%eperp_mini
     IF(ALLOCATED(ss2%id_eperp_mini)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_eperp_mini = ss%id_eperp_mini
        ENDIF
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_eperp_rw = 0
  ENDIF
  IF((ALLOCATED(ss%eperp_rw).AND.ALLOCATED(ss2%eperp_rw)).AND. &
        ((cclist(ps_cnum_RUNAWAY).EQ.1))) THEN
     ss2%eperp_rw = ss%eperp_rw
     IF(.not.partial_copy) THEN
        ss2%id_eperp_rw = ss%id_eperp_rw
     ENDIF
  ENDIF
  IF(ALLOCATED(ss2%id_epll_beami)) THEN
     IF(partial_copy) THEN
        ss2%id_epll_beami = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%epll_beami).AND.ALLOCATED(ss2%epll_beami)).AND. &
        ((cclist(ps_cnum_NBI).EQ.1))) THEN
     ss2%epll_beami = ss%epll_beami
     IF(ALLOCATED(ss2%id_epll_beami)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_epll_beami = ss%id_epll_beami
        ENDIF
     ENDIF
  ENDIF
  IF(ALLOCATED(ss2%id_epll_fusi)) THEN
     IF(partial_copy) THEN
        ss2%id_epll_fusi = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%epll_fusi).AND.ALLOCATED(ss2%epll_fusi)).AND. &
        ((cclist(ps_cnum_FUS).EQ.1))) THEN
     ss2%epll_fusi = ss%epll_fusi
     IF(ALLOCATED(ss2%id_epll_fusi)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_epll_fusi = ss%id_epll_fusi
        ENDIF
     ENDIF
  ENDIF
  IF(ALLOCATED(ss2%id_epll_mini)) THEN
     IF(partial_copy) THEN
        ss2%id_epll_mini = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%epll_mini).AND.ALLOCATED(ss2%epll_mini)).AND. &
        ((cclist(ps_cnum_IC).EQ.1))) THEN
     ss2%epll_mini = ss%epll_mini
     IF(ALLOCATED(ss2%id_epll_mini)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_epll_mini = ss%id_epll_mini
        ENDIF
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_epll_rw = 0
  ENDIF
  IF((ALLOCATED(ss%epll_rw).AND.ALLOCATED(ss2%epll_rw)).AND. &
        ((cclist(ps_cnum_RUNAWAY).EQ.1))) THEN
     ss2%epll_rw = ss%epll_rw
     IF(.not.partial_copy) THEN
        ss2%id_epll_rw = ss%id_epll_rw
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_Epot = 0
  ENDIF
  IF((ALLOCATED(ss%Epot).AND.ALLOCATED(ss2%Epot)).AND. &
        ((cclist(ps_cnum_PLASMA).EQ.1))) THEN
     ss2%Epot = ss%Epot
     IF(.not.partial_copy) THEN
        ss2%id_Epot = ss%id_Epot
     ENDIF
  ENDIF
  IF((cclist(ps_cnum_EQ).EQ.1).OR.(icopy_lists.EQ.1)) THEN
     ss2%eqdsk_file = ss%eqdsk_file
  ENDIF
  IF( ((ALLOCATED(ss2%eqmom_num)).AND.(ALLOCATED(ss%eqmom_num))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_EQ).EQ.1)) ) THEN
     ss2%eqmom_num = ss%eqmom_num
  ENDIF
  IF((cclist(ps_cnum_EQ).EQ.1).OR.(icopy_lists.EQ.1)) THEN
     ss2%EQ_Code_Info = ss%EQ_Code_Info
  ENDIF
  IF((cclist(ps_cnum_EQ).EQ.1).OR.(icopy_lists.EQ.1)) THEN
     ss2%EQ_Data_Info = ss%EQ_Data_Info
  ENDIF
  IF(partial_copy) THEN
     ss2%id_eta_parallel = 0
  ENDIF
  IF((ALLOCATED(ss%eta_parallel).AND.ALLOCATED(ss2%eta_parallel)).AND. &
        ((cclist(ps_cnum_PLASMA).EQ.1))) THEN
     ss2%eta_parallel = ss%eta_parallel
     IF(.not.partial_copy) THEN
        ss2%id_eta_parallel = ss%id_eta_parallel
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%E_anom).AND.ALLOCATED(ss2%E_anom)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%E_anom = ss%E_anom
  ENDIF
  IF((ALLOCATED(ss%E_anom2).AND.ALLOCATED(ss2%E_anom2)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%E_anom2 = ss%E_anom2
  ENDIF
  IF(ALLOCATED(ss2%id_fidiff_bpass_co)) THEN
     IF(partial_copy) THEN
        ss2%id_fidiff_bpass_co = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%fidiff_bpass_co).AND.ALLOCATED(ss2%fidiff_bpass_co)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%fidiff_bpass_co = ss%fidiff_bpass_co
     IF(ALLOCATED(ss2%id_fidiff_bpass_co)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_fidiff_bpass_co = ss%id_fidiff_bpass_co
        ENDIF
     ENDIF
  ENDIF
  IF(ALLOCATED(ss2%id_fidiff_bpass_ctr)) THEN
     IF(partial_copy) THEN
        ss2%id_fidiff_bpass_ctr = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%fidiff_bpass_ctr).AND.ALLOCATED(ss2%fidiff_bpass_ctr)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%fidiff_bpass_ctr = ss%fidiff_bpass_ctr
     IF(ALLOCATED(ss2%id_fidiff_bpass_ctr)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_fidiff_bpass_ctr = ss%id_fidiff_bpass_ctr
        ENDIF
     ENDIF
  ENDIF
  IF(ALLOCATED(ss2%id_fidiff_btrap)) THEN
     IF(partial_copy) THEN
        ss2%id_fidiff_btrap = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%fidiff_btrap).AND.ALLOCATED(ss2%fidiff_btrap)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%fidiff_btrap = ss%fidiff_btrap
     IF(ALLOCATED(ss2%id_fidiff_btrap)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_fidiff_btrap = ss%id_fidiff_btrap
        ENDIF
     ENDIF
  ENDIF
  IF(ALLOCATED(ss2%id_fidiff_dpass_co)) THEN
     IF(partial_copy) THEN
        ss2%id_fidiff_dpass_co = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%fidiff_dpass_co).AND.ALLOCATED(ss2%fidiff_dpass_co)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%fidiff_dpass_co = ss%fidiff_dpass_co
     IF(ALLOCATED(ss2%id_fidiff_dpass_co)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_fidiff_dpass_co = ss%id_fidiff_dpass_co
        ENDIF
     ENDIF
  ENDIF
  IF(ALLOCATED(ss2%id_fidiff_dpass_ctr)) THEN
     IF(partial_copy) THEN
        ss2%id_fidiff_dpass_ctr = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%fidiff_dpass_ctr).AND.ALLOCATED(ss2%fidiff_dpass_ctr)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%fidiff_dpass_ctr = ss%fidiff_dpass_ctr
     IF(ALLOCATED(ss2%id_fidiff_dpass_ctr)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_fidiff_dpass_ctr = ss%id_fidiff_dpass_ctr
        ENDIF
     ENDIF
  ENDIF
  IF(ALLOCATED(ss2%id_fidiff_dtrap)) THEN
     IF(partial_copy) THEN
        ss2%id_fidiff_dtrap = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%fidiff_dtrap).AND.ALLOCATED(ss2%fidiff_dtrap)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%fidiff_dtrap = ss%fidiff_dtrap
     IF(ALLOCATED(ss2%id_fidiff_dtrap)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_fidiff_dtrap = ss%id_fidiff_dtrap
        ENDIF
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_Fi_depletion = 0
  ENDIF
  IF((ALLOCATED(ss%Fi_depletion).AND.ALLOCATED(ss2%Fi_depletion)).AND. &
        ((cclist(ps_cnum_PLASMA).EQ.1))) THEN
     ss2%Fi_depletion = ss%Fi_depletion
     IF(.not.partial_copy) THEN
        ss2%id_Fi_depletion = ss%id_Fi_depletion
     ENDIF
  ENDIF
  IF( ((ALLOCATED(ss2%fracmin)).AND.(ALLOCATED(ss%fracmin))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_IC).EQ.1)) ) THEN
     ss2%fracmin = ss%fracmin
  ENDIF
  IF( ((ALLOCATED(ss2%fracpslh)).AND.(ALLOCATED(ss%fracpslh))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_LH).EQ.1)) ) THEN
     ss2%fracpslh = ss%fracpslh
  ENDIF
  IF( ((ALLOCATED(ss2%frac_full)).AND.(ALLOCATED(ss%frac_full))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_NBI).EQ.1)) ) THEN
     ss2%frac_full = ss%frac_full
  ENDIF
  IF( ((ALLOCATED(ss2%frac_half)).AND.(ALLOCATED(ss%frac_half))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_NBI).EQ.1)) ) THEN
     ss2%frac_half = ss%frac_half
  ENDIF
  IF(partial_copy) THEN
     ss2%id_freq_drbm = 0
  ENDIF
  IF((ALLOCATED(ss%freq_drbm).AND.ALLOCATED(ss2%freq_drbm)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%freq_drbm = ss%freq_drbm
     IF(.not.partial_copy) THEN
        ss2%id_freq_drbm = ss%id_freq_drbm
     ENDIF
  ENDIF
  IF( ((ALLOCATED(ss2%freq_ec)).AND.(ALLOCATED(ss%freq_ec))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_EC).EQ.1)) ) THEN
     ss2%freq_ec = ss%freq_ec
  ENDIF
  IF(partial_copy) THEN
     ss2%id_freq_glf = 0
  ENDIF
  IF((ALLOCATED(ss%freq_glf).AND.ALLOCATED(ss2%freq_glf)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%freq_glf = ss%freq_glf
     IF(.not.partial_copy) THEN
        ss2%id_freq_glf = ss%id_freq_glf
     ENDIF
  ENDIF
  IF( ((ALLOCATED(ss2%freq_ic)).AND.(ALLOCATED(ss%freq_ic))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_IC).EQ.1)) ) THEN
     ss2%freq_ic = ss%freq_ic
  ENDIF
  IF( ((ALLOCATED(ss2%freq_lh)).AND.(ALLOCATED(ss%freq_lh))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_LH).EQ.1)) ) THEN
     ss2%freq_lh = ss%freq_lh
  ENDIF
  IF(partial_copy) THEN
     ss2%id_freq_max_tglf = 0
  ENDIF
  IF((ALLOCATED(ss%freq_max_tglf).AND.ALLOCATED(ss2%freq_max_tglf)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%freq_max_tglf = ss%freq_max_tglf
     IF(.not.partial_copy) THEN
        ss2%id_freq_max_tglf = ss%id_freq_max_tglf
     ENDIF
  ENDIF
  IF(ALLOCATED(ss2%id_freq_mmm71)) THEN
     IF(partial_copy) THEN
        ss2%id_freq_mmm71 = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%freq_mmm71).AND.ALLOCATED(ss2%freq_mmm71)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%freq_mmm71 = ss%freq_mmm71
     IF(ALLOCATED(ss2%id_freq_mmm71)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_freq_mmm71 = ss%id_freq_mmm71
        ENDIF
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_freq_mtm = 0
  ENDIF
  IF((ALLOCATED(ss%freq_mtm).AND.ALLOCATED(ss2%freq_mtm)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%freq_mtm = ss%freq_mtm
     IF(.not.partial_copy) THEN
        ss2%id_freq_mtm = ss%id_freq_mtm
     ENDIF
  ENDIF
  IF(ALLOCATED(ss2%id_freq_tglf)) THEN
     IF(partial_copy) THEN
        ss2%id_freq_tglf = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%freq_tglf).AND.ALLOCATED(ss2%freq_tglf)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%freq_tglf = ss%freq_tglf
     IF(ALLOCATED(ss2%id_freq_tglf)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_freq_tglf = ss%id_freq_tglf
        ENDIF
     ENDIF
  ENDIF
  IF((cclist(ps_cnum_FUS).EQ.1).OR.(icopy_lists.EQ.1)) THEN
     ss2%FUS_Code_Info = ss%FUS_Code_Info
  ENDIF
  IF( ((ALLOCATED(ss2%gamma_lmhd)).AND.(ALLOCATED(ss%gamma_lmhd))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_LMHD).EQ.1)) ) THEN
     ss2%gamma_lmhd = ss%gamma_lmhd
  ENDIF
  IF(partial_copy) THEN
     ss2%id_gamma_nc = 0
  ENDIF
  IF((ALLOCATED(ss%gamma_nc).AND.ALLOCATED(ss2%gamma_nc)).AND. &
        ((cclist(ps_cnum_EQ).EQ.1))) THEN
     ss2%gamma_nc = ss%gamma_nc
     IF(.not.partial_copy) THEN
        ss2%id_gamma_nc = ss%id_gamma_nc
     ENDIF
  ENDIF
  IF( ((ALLOCATED(ss2%gas_atom)).AND.(ALLOCATED(ss%gas_atom))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_GAS).EQ.1)) ) THEN
     ss2%gas_atom = ss%gas_atom
  ENDIF
  IF((cclist(ps_cnum_GAS).EQ.1).OR.(icopy_lists.EQ.1)) THEN
     ss2%GAS_Code_Info = ss%GAS_Code_Info
  ENDIF
  IF(partial_copy) THEN
     ss2%id_gb1 = 0
  ENDIF
  IF((ALLOCATED(ss%gb1).AND.ALLOCATED(ss2%gb1)).AND. &
        ((cclist(ps_cnum_EQ).EQ.1))) THEN
     ss2%gb1 = ss%gb1
     IF(.not.partial_copy) THEN
        ss2%id_gb1 = ss%id_gb1
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_gb2 = 0
  ENDIF
  IF((ALLOCATED(ss%gb2).AND.ALLOCATED(ss2%gb2)).AND. &
        ((cclist(ps_cnum_EQ).EQ.1))) THEN
     ss2%gb2 = ss%gb2
     IF(.not.partial_copy) THEN
        ss2%id_gb2 = ss%id_gb2
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_gb2i = 0
  ENDIF
  IF((ALLOCATED(ss%gb2i).AND.ALLOCATED(ss2%gb2i)).AND. &
        ((cclist(ps_cnum_EQ).EQ.1))) THEN
     ss2%gb2i = ss%gb2i
     IF(.not.partial_copy) THEN
        ss2%id_gb2i = ss%id_gb2i
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_gbr2 = 0
  ENDIF
  IF((ALLOCATED(ss%gbr2).AND.ALLOCATED(ss2%gbr2)).AND. &
        ((cclist(ps_cnum_EQ).EQ.1))) THEN
     ss2%gbr2 = ss%gbr2
     IF(.not.partial_copy) THEN
        ss2%id_gbr2 = ss%id_gbr2
     ENDIF
  ENDIF
  IF((cclist(ps_cnum_EQ).EQ.1).OR.(icopy_lists.EQ.1)) THEN
     ss2%geometry = ss%geometry
  ENDIF
  IF((cclist(ps_cnum_PLASMA).EQ.1).OR.(icopy_lists.EQ.1)) THEN
     ss2%Global_label = ss%Global_label
  ENDIF
  IF(partial_copy) THEN
     ss2%id_gncfb2h = 0
  ENDIF
  IF((ALLOCATED(ss%gncfb2h).AND.ALLOCATED(ss2%gncfb2h)).AND. &
        ((cclist(ps_cnum_EQ).EQ.1))) THEN
     ss2%gncfb2h = ss%gncfb2h
     IF(.not.partial_copy) THEN
        ss2%id_gncfb2h = ss%id_gncfb2h
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_gncfh = 0
  ENDIF
  IF((ALLOCATED(ss%gncfh).AND.ALLOCATED(ss2%gncfh)).AND. &
        ((cclist(ps_cnum_EQ).EQ.1))) THEN
     ss2%gncfh = ss%gncfh
     IF(.not.partial_copy) THEN
        ss2%id_gncfh = ss%id_gncfh
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_gr1 = 0
  ENDIF
  IF((ALLOCATED(ss%gr1).AND.ALLOCATED(ss2%gr1)).AND. &
        ((cclist(ps_cnum_EQ).EQ.1))) THEN
     ss2%gr1 = ss%gr1
     IF(.not.partial_copy) THEN
        ss2%id_gr1 = ss%id_gr1
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_gr2 = 0
  ENDIF
  IF((ALLOCATED(ss%gr2).AND.ALLOCATED(ss2%gr2)).AND. &
        ((cclist(ps_cnum_EQ).EQ.1))) THEN
     ss2%gr2 = ss%gr2
     IF(.not.partial_copy) THEN
        ss2%id_gr2 = ss%id_gr2
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_gr2i = 0
  ENDIF
  IF((ALLOCATED(ss%gr2i).AND.ALLOCATED(ss2%gr2i)).AND. &
        ((cclist(ps_cnum_EQ).EQ.1))) THEN
     ss2%gr2i = ss%gr2i
     IF(.not.partial_copy) THEN
        ss2%id_gr2i = ss%id_gr2i
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_gr2rho2 = 0
  ENDIF
  IF((ALLOCATED(ss%gr2rho2).AND.ALLOCATED(ss2%gr2rho2)).AND. &
        ((cclist(ps_cnum_EQ).EQ.1))) THEN
     ss2%gr2rho2 = ss%gr2rho2
     IF(.not.partial_copy) THEN
        ss2%id_gr2rho2 = ss%id_gr2rho2
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_gr3i = 0
  ENDIF
  IF((ALLOCATED(ss%gr3i).AND.ALLOCATED(ss2%gr3i)).AND. &
        ((cclist(ps_cnum_EQ).EQ.1))) THEN
     ss2%gr3i = ss%gr3i
     IF(.not.partial_copy) THEN
        ss2%id_gr3i = ss%id_gr3i
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_grho1 = 0
  ENDIF
  IF((ALLOCATED(ss%grho1).AND.ALLOCATED(ss2%grho1)).AND. &
        ((cclist(ps_cnum_EQ).EQ.1))) THEN
     ss2%grho1 = ss%grho1
     IF(.not.partial_copy) THEN
        ss2%id_grho1 = ss%id_grho1
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_grho2 = 0
  ENDIF
  IF((ALLOCATED(ss%grho2).AND.ALLOCATED(ss2%grho2)).AND. &
        ((cclist(ps_cnum_EQ).EQ.1))) THEN
     ss2%grho2 = ss%grho2
     IF(.not.partial_copy) THEN
        ss2%id_grho2 = ss%id_grho2
     ENDIF
  ENDIF

END SUBROUTINE plasma_state_copy_2

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_r2_dummy
     return
  end subroutine ccps_getset_r2_dummy

subroutine psget_r_ant(iobj, n1, data, ierr)
    !! major radius of antenna
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_r_ant', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % R_ant
end subroutine psget_r_ant


subroutine psset_r_ant(iobj, n1, data, ierr)
    !! major radius of antenna
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_r_ant', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % R_ant = data(1:n1)
end subroutine psset_r_ant


subroutine psgetrnk_r_ant(iobj, ndims, ierr)
    !! major radius of antenna
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_r_ant


subroutine psgetdim_r_ant(iobj, ndims, dims, ierr)
    !! major radius of antenna
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_r_ant', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % R_ant ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % R_ant)
    endif
end subroutine psgetdim_r_ant


subroutine psget_rfmin_to_alla(iobj, n1, data, ierr)
    !! map rfmin index to "alla" list
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_rfmin_to_alla', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % rfmin_to_alla
end subroutine psget_rfmin_to_alla


subroutine psset_rfmin_to_alla(iobj, n1, data, ierr)
    !! map rfmin index to "alla" list
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_rfmin_to_alla', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % rfmin_to_alla = data(1:n1)
end subroutine psset_rfmin_to_alla


subroutine psgetrnk_rfmin_to_alla(iobj, ndims, ierr)
    !! map rfmin index to "alla" list
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_rfmin_to_alla


subroutine psgetdim_rfmin_to_alla(iobj, ndims, dims, ierr)
    !! map rfmin index to "alla" list
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_rfmin_to_alla', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % rfmin_to_alla ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % rfmin_to_alla)
    endif
end subroutine psgetdim_rfmin_to_alla


subroutine psget_rho_rad(iobj, n1, data, ierr)
    !! rho grid (RAD)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_rho_rad', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % rho_rad
end subroutine psget_rho_rad


subroutine psset_rho_rad(iobj, n1, data, ierr)
    !! rho grid (RAD)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_rho_rad', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % rho_rad = data(1:n1)
end subroutine psset_rho_rad


subroutine psgetrnk_rho_rad(iobj, ndims, ierr)
    !! rho grid (RAD)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_rho_rad


subroutine psgetdim_rho_rad(iobj, ndims, dims, ierr)
    !! rho grid (RAD)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_rho_rad', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % rho_rad ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % rho_rad)
    endif
end subroutine psgetdim_rho_rad


subroutine psget_rho_bdy_ti(iobj, data, ierr)
    !! location beyond which Ti is known
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_rho_bdy_ti', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % rho_bdy_Ti
end subroutine psget_rho_bdy_ti


subroutine psset_rho_bdy_ti(iobj, data, ierr)
    !! location beyond which Ti is known
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_rho_bdy_ti', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % rho_bdy_Ti = data
end subroutine psset_rho_bdy_ti


subroutine psget_rmajor_mean(iobj, n1, data, ierr)
    !! Rmajor_mean = (R_Surfmax+R_surfmin)/2
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_rmajor_mean', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % Rmajor_mean
end subroutine psget_rmajor_mean


subroutine psset_rmajor_mean(iobj, n1, data, ierr)
    !! Rmajor_mean = (R_Surfmax+R_surfmin)/2
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_rmajor_mean', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % Rmajor_mean = data(1:n1)
end subroutine psset_rmajor_mean


subroutine psgetrnk_rmajor_mean(iobj, ndims, ierr)
    !! Rmajor_mean = (R_Surfmax+R_surfmin)/2
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_rmajor_mean


subroutine psgetdim_rmajor_mean(iobj, ndims, dims, ierr)
    !! Rmajor_mean = (R_Surfmax+R_surfmin)/2
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_rmajor_mean', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % Rmajor_mean ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % Rmajor_mean)
    endif
end subroutine psgetdim_rmajor_mean

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


SUBROUTINE plasma_state_store_def_9(ss,icdf,iout,iertot)


  !  define subset of variables and arrays for NetCDF file

  USE plasma_state_definition_mod
  USE netcdf
  IMPLICIT NONE

  TYPE (plasma_state) :: ss     ! state data to read
  INTEGER, INTENT(IN) :: icdf   ! NetCDF file ID
  INTEGER, INTENT(IN) :: iout   ! message LUN
  INTEGER, INTENT(INOUT) :: iertot  ! error count

  !--------------

  INTEGER :: varid,dimid,status,ival,idims(20),indim
  CHARACTER*80 :: nc_errmsg

  !--------------
  !  define variables...


  IF(ALLOCATED(ss%velte_mmm71)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     CALL define_var("velte_mmm71","R",indim,idims, &
            "Te-equation, advective velocity term from MMM71 model", &
            "m/sec","ANOM","STATE_PROFILES", &
            "R|units=m/sec|pclin  velte_mmm71(nrho_anomth)")
  ENDIF

  IF(ALLOCATED(ss%velte_nclass)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     CALL define_var("velte_nclass","R",indim,idims, &
            "Te-equation, advective velocity term from NCLASS model", &
            "m/sec","ANOM","STATE_PROFILES", &
            "R|units=m/sec|pclin velte_nclass(nrho_anomth)")
  ENDIF

  IF(ALLOCATED(ss%velte_neo)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     CALL define_var("velte_neo","R",indim,idims, &
            "Te-equation, advective velocity term from NEO model", &
            "m/sec","ANOM","STATE_PROFILES", &
            "R|units=m/sec|pclin  velte_neo(nrho_anomth)")
  ENDIF

  IF(ALLOCATED(ss%velte_paleo)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     CALL define_var("velte_paleo","R",indim,idims, &
            "Te-equation, convection term from PALEO model", &
            "m/sec","ANOM","STATE_PROFILES", &
            "R|units=m/sec|pclin   velte_paleo(nrho_anomth)")
  ENDIF

  IF(ALLOCATED(ss%velte_tglf)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     CALL define_var("velte_tglf","R",indim,idims, &
            "Te-equation, advective velocity term from TGLF model", &
            "m/sec","ANOM","STATE_PROFILES", &
            "R|units=m/sec|pclin velte_tglf(nrho_anomth)")
  ENDIF

  IF(ALLOCATED(ss%velti_anom)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     CALL define_var("velti_anom","R",indim,idims, &
            "Ti-equation, advective velocity term", &
            "m/sec","ANOM","STATE_PROFILES", &
            "R|units=m/sec|pclin  velti_anom(nrho_anomth)")
  ENDIF

  IF(ALLOCATED(ss%velti_glf)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     CALL define_var("velti_glf","R",indim,idims, &
            "Ti-equation, advective velocity term from GLF23 model", &
            "m/sec","ANOM","STATE_PROFILES", &
            "R|units=m/sec|pclin  velti_glf(nrho_anomth)")
  ENDIF

  IF(ALLOCATED(ss%velti_gtcneo)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     CALL define_var("velti_gtcneo","R",indim,idims, &
            "Ti-equation, advective velocity term from GTC_NEO model", &
            "m/sec","ANOM","STATE_PROFILES", &
            "R|units=m/sec|pclin  velti_gtcneo(nrho_anomth)")
  ENDIF

  IF(ALLOCATED(ss%velti_mmm71)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     CALL define_var("velti_mmm71","R",indim,idims, &
            "Ti-equation, advective velocity term from MMM71 model", &
            "m/sec","ANOM","STATE_PROFILES", &
            "R|units=m/sec|pclin  velti_mmm71(nrho_anomth)")
  ENDIF

  IF(ALLOCATED(ss%velti_nclass)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     CALL define_var("velti_nclass","R",indim,idims, &
            "Ti-equation, advective velocity term from NCLASS model", &
            "m/sec","ANOM","STATE_PROFILES", &
            "R|units=m/sec|pclin velti_nclass(nrho_anomth)")
  ENDIF

  IF(ALLOCATED(ss%velti_neo)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     CALL define_var("velti_neo","R",indim,idims, &
            "Ti-equation, advective velocity term from NEO model", &
            "m/sec","ANOM","STATE_PROFILES", &
            "R|units=m/sec|pclin  velti_neo(nrho_anomth)")
  ENDIF

  IF(ALLOCATED(ss%velti_tglf)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     CALL define_var("velti_tglf","R",indim,idims, &
            "Ti-equation, advective velocity term from TGLF model", &
            "m/sec","ANOM","STATE_PROFILES", &
            "R|units=m/sec|pclin velti_tglf(nrho_anomth)")
  ENDIF

  IF(ALLOCATED(ss%vie_trans)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho",idims(indim))
     CALL define_var("vie_trans","R",indim,idims, &
            "ion energy radial velocity", &
            "m/sec","PLASMA","STATE_PROFILES", &
            "R|pclin   vie_trans(nrho)")
  ENDIF

  IF(ALLOCATED(ss%vie_transcat)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_ntrcat",idims(indim))
     CALL define_var("vie_transcat","R",indim,idims, &
            "Ion energy radial velocity", &
            "m/sec","PLASMA","STATE_PROFILES", &
            "R|units=m/sec|pclin vie_transcat(nrho,ntrcat)")
  ENDIF

  IF(ALLOCATED(ss%vmo_trans)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho",idims(indim))
     CALL define_var("vmo_trans","R",indim,idims, &
            "angular momentum radial velocity", &
            "m/sec","PLASMA","STATE_PROFILES", &
            "R|pclin   vmo_trans(nrho)")
  ENDIF

  IF(ALLOCATED(ss%vmo_transcat)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_ntrcat",idims(indim))
     CALL define_var("vmo_transcat","R",indim,idims, &
            "Angular momentum radial velocity", &
            "m/sec","PLASMA","STATE_PROFILES", &
            "R|units=m/sec|pclin vmo_transcat(nrho,ntrcat)")
  ENDIF

  IF(ALLOCATED(ss%vn_trans)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dp1_nspec_th",idims(indim))
     CALL define_var("vn_trans","R",indim,idims, &
            "specie radial velocity", &
            "m/sec","PLASMA","STATE_PROFILES", &
            "R|units=m/sec|pclin   vn_trans(nrho,0:nspec_th)")
  ENDIF

  IF(ALLOCATED(ss%vn_transcat)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dp1_nspec_th",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_ntrcat",idims(indim))
     CALL define_var("vn_transcat","R",indim,idims, &
            "specie radial velocity", &
            "m/sec","PLASMA","STATE_PROFILES", &
            "R|units=m/sec|pclin vn_transcat(nrho,0:nspec_th,ntrcat)")
  ENDIF

  IF(ALLOCATED(ss%vol)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_eq",idims(indim))
     CALL define_var("vol","R",indim,idims, &
            "enclosed volume", &
            "m^3","EQ","STATE_PROFILES", &
            "R|units=m^3|Spline_00  vol(nrho_eq)")
  ENDIF

  IF(ALLOCATED(ss%vphi0_av)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_ngsc0",idims(indim))
     CALL define_var("vphi0_av","R",indim,idims, &
            "average toroidal velocity of neutral source", &
            "m/sec","GAS","STATE_DATA", &
            "R|units=m/sec vphi0_av(ngsc0)")
  ENDIF

  indim = 1
  status = nf90_inq_dimid(icdf,"ps_clen_80",idims(1))
  CALL define_var("vpol_Data_Info","C*80",indim,idims, &
         "information on source of poloidal velocity data", &
         "__NONE","PLASMA","SIMULATION_INIT", &
         "C*80   vpol_Data_Info")

  IF(ALLOCATED(ss%vpol_inmp)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dp1_nspec_th",idims(indim))
     CALL define_var("vpol_inmp","R",indim,idims, &
            "poloidal velocity, inner half midplane", &
            "m/sec","PLASMA","STATE_PROFILES", &
            "R|units=m/sec|step*ns vpol_inmp(~nrho,0:nspec_th)")
  ENDIF

  IF(ALLOCATED(ss%vpol_is_input)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dp1_nspec_th",idims(indim))
     CALL define_var("vpol_is_input","I",indim,idims, &
            "specie outer midplane poloidal velocit flag", &
            "__NONE","PLASMA","STATE_DATA", &
            "I vpol_is_input(0:nspec_th)")
  ENDIF

  IF(ALLOCATED(ss%vpol_omp)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dp1_nspec_th",idims(indim))
     CALL define_var("vpol_omp","R",indim,idims, &
            "poloidal velocity, outer half midplane", &
            "m/sec","PLASMA","STATE_PROFILES", &
            "R|units=m/sec|step*ns vpol_omp(~nrho,0:nspec_th)")
  ENDIF

  IF(ALLOCATED(ss%VRep_coil_count)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_ncoils",idims(indim))
     CALL define_var("VRep_coil_count","I",indim,idims, &
            "replication count, vertical coil stack", &
            "__NONE","EQ","MACHINE_DESCRIPTION", &
            "I  VRep_coil_count(ncoils)")
  ENDIF

  IF(ALLOCATED(ss%Vrep_coil_spacing)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_ncoils",idims(indim))
     CALL define_var("Vrep_coil_spacing","R",indim,idims, &
            "replicated coil separation", &
            "m","EQ","MACHINE_DESCRIPTION", &
            "R|units=m Vrep_coil_spacing(ncoils)")
  ENDIF

  IF(ALLOCATED(ss%Vsize_coil)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_ncoils",idims(indim))
     CALL define_var("Vsize_coil","R",indim,idims, &
            "(Rotatable) Vertical coil size", &
            "m","EQ","MACHINE_DESCRIPTION", &
            "R|units=m  Vsize_coil(ncoils)")
  ENDIF

  indim = 0
  CALL define_var("vsur","R",indim,idims, &
         "toroidal voltage at surface", &
         "Volts","PLASMA","STATE_DATA", &
         "R  vsur")

  indim = 1
  status = nf90_inq_dimid(icdf,"ps_clen_80",idims(1))
  CALL define_var("VSUR_Data_Info","C*80",indim,idims, &
         "information on source of surface voltage data", &
         "__NONE","PLASMA","SIMULATION_INIT", &
         "C*80   VSUR_Data_Info")

  indim = 1
  status = nf90_inq_dimid(icdf,"ps_clen_80",idims(1))
  CALL define_var("vtor_Data_Info","C*80",indim,idims, &
         "information on source of toroidal velocity data", &
         "__NONE","PLASMA","SIMULATION_INIT", &
         "C*80   vtor_Data_Info")

  IF(ALLOCATED(ss%vtor_inmp)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dp1_nspec_th",idims(indim))
     CALL define_var("vtor_inmp","R",indim,idims, &
            "toroidal velocity, inner half midplane", &
            "m/sec","PLASMA","STATE_PROFILES", &
            "R|units=m/sec|step*ns vtor_inmp(~nrho,0:nspec_th)")
  ENDIF

  IF(ALLOCATED(ss%vtor_is_input)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dp1_nspec_th",idims(indim))
     CALL define_var("vtor_is_input","I",indim,idims, &
            "specie outer midplane toroidal velocit flag", &
            "__NONE","PLASMA","STATE_DATA", &
            "I vtor_is_input(0:nspec_th)")
  ENDIF

  IF(ALLOCATED(ss%vtor_omp)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dp1_nspec_th",idims(indim))
     CALL define_var("vtor_omp","R",indim,idims, &
            "toroidal velocity, outer half midplane", &
            "m/sec","PLASMA","STATE_PROFILES", &
            "R|units=m/sec|step*ns vtor_omp(~nrho,0:nspec_th)")
  ENDIF

  IF(ALLOCATED(ss%V_loop)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho",idims(indim))
     CALL define_var("V_loop","R",indim,idims, &
            "loop voltage", &
            "Volts","PLASMA","STATE_PROFILES", &
            "R|units=Volts|pclin	V_loop(nrho)")
  ENDIF

  IF(ALLOCATED(ss%v_pars)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dp1_nspec_th",idims(indim))
     CALL define_var("v_pars","R",indim,idims, &
            "thermal specie <vpll>", &
            "m/sec","PLASMA","STATE_PROFILES", &
            "R|units=m/sec|alias=vpll_|step*ns v_pars(~nrho,0:nspec_th)")
  ENDIF

  IF(ALLOCATED(ss%v_pers)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dp1_nspec_th",idims(indim))
     CALL define_var("v_pers","R",indim,idims, &
            "thermal specie <vper>", &
            "m/sec","PLASMA","STATE_PROFILES", &
            "R|units=m/sec|alias=vper_|step*ns v_pers(~nrho,0:nspec_th)")
  ENDIF

  IF(ALLOCATED(ss%wt_nphi)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_max_num_nphi",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nicrf_src",idims(indim))
     CALL define_var("wt_nphi","R",indim,idims, &
            "vacuum spectrum n_phi weight", &
            "-","IC","SHOT_CONFIGURATION", &
            "R|units=- wt_nphi(num_nphi(),nicrf_src)")
  ENDIF

  IF(ALLOCATED(ss%wt_nphi_abs)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_max_num_nphi",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nicrf_src",idims(indim))
     CALL define_var("wt_nphi_abs","R",indim,idims, &
            "absorbed spectrum n_phi weight", &
            "-","IC","STATE_DATA", &
            "R|units=- wt_nphi_abs(num_nphi(),nicrf_src)")
  ENDIF

  IF(ALLOCATED(ss%wt_nphi_ext)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_max_num_nphi",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nicrf_src",idims(indim))
     CALL define_var("wt_nphi_ext","R",indim,idims, &
            "fraction of power deposited outside", &
            "-","IC","STATE_DATA", &
            "R|units=- wt_nphi_ext(num_nphi(),nicrf_src)")
  ENDIF

  IF(ALLOCATED(ss%xRjcos_momeq)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_eq",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_neqmom",idims(indim))
     CALL define_var("xRjcos_momeq","R",indim,idims, &
            "scaled R cos moments", &
            "m","EQ","STATE_PROFILES", &
            "R|units=m|Hermite_explicit  xRjcos_momeq(nrho_eq,neqmom)")
  ENDIF

  IF(ALLOCATED(ss%xRjsin_momeq)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_eq",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_neqmom",idims(indim))
     CALL define_var("xRjsin_momeq","R",indim,idims, &
            "scaled R sin moments", &
            "m","EQ","STATE_PROFILES", &
            "R|units=m|Hermite_explicit  xRjsin_momeq(nrho_eq,neqmom)")
  ENDIF

  IF(ALLOCATED(ss%xs)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nxs",idims(indim))
     CALL define_var("xs","R",indim,idims, &
            "impurity source magnitude (atoms/sec)", &
            "#/sec","RAD","STATE_DATA", &
            "R|units=#/sec    xs(nxs)")
  ENDIF

  IF(ALLOCATED(ss%xs_name)) THEN
     indim = 1
     status = nf90_inq_dimid(icdf,"ps_clen_32",idims(1))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nxs",idims(indim))
     CALL define_var("xs_name","N",indim,idims, &
            "number & name of impurity sources", &
            "__NONE","RAD","SHOT_CONFIGURATION", &
            "L|impurity_source  xs_name(nxs)")
  ENDIF

  IF(ALLOCATED(ss%xZjcos_momeq)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_eq",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_neqmom",idims(indim))
     CALL define_var("xZjcos_momeq","R",indim,idims, &
            "scaled Z cos moments", &
            "m","EQ","STATE_PROFILES", &
            "R|units=m|Hermite_explicit  xZjcos_momeq(nrho_eq,neqmom)")
  ENDIF

  IF(ALLOCATED(ss%xZjsin_momeq)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_eq",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_neqmom",idims(indim))
     CALL define_var("xZjsin_momeq","R",indim,idims, &
            "scaled Z sin moments", &
            "m","EQ","STATE_PROFILES", &
            "R|units=m|Hermite_explicit  xZjsin_momeq(nrho_eq,neqmom)")
  ENDIF

  indim = 0
  CALL define_var("Z0max","I",indim,idims, &
         "maximum Z of non-impurity species", &
         "__NONE","PLASMA","SIMULATION_INIT", &
         "IS  Z0max = 2")

  IF(ALLOCATED(ss%Z0_momeq)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_eq",idims(indim))
     CALL define_var("Z0_momeq","R",indim,idims, &
            "Z0 of flux surface", &
            "m","EQ","STATE_PROFILES", &
            "R|units=m|Hermite_explicit  Z0_momeq(nrho_eq)")
  ENDIF

  IF(ALLOCATED(ss%Zbap)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nbeam",idims(indim))
     CALL define_var("Zbap","R",indim,idims, &
            "elevation of beam centerline at aperture", &
            "m","NBI","MACHINE_DESCRIPTION", &
            "R|units=m       Zbap(nbeam)")
  ENDIF

  IF(ALLOCATED(ss%Zbsc)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nbeam",idims(indim))
     CALL define_var("Zbsc","R",indim,idims, &
            "elevation of beam source", &
            "m","NBI","MACHINE_DESCRIPTION", &
            "R|units=m       Zbsc(nbeam)")
  ENDIF

  IF(ALLOCATED(ss%Zeff)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho",idims(indim))
     CALL define_var("Zeff","R",indim,idims, &
            "Zeff (sum[nj*Zj**2]/ne)", &
            "-","PLASMA","STATE_PROFILES", &
            "R|step*ns(:,ps_elec_index)  Zeff(~nrho)")
  ENDIF

  indim = 1
  status = nf90_inq_dimid(icdf,"ps_clen_80",idims(1))
  CALL define_var("ZEFF_Data_Info","C*80",indim,idims, &
         "information on source of Zeff data", &
         "__NONE","PLASMA","SIMULATION_INIT", &
         "C*80   ZEFF_Data_Info")

  IF(ALLOCATED(ss%Zeff_fi)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho",idims(indim))
     CALL define_var("Zeff_fi","R",indim,idims, &
            "Fast ion contribution to Zeff", &
            "-","PLASMA","STATE_PROFILES", &
            "R|step*ns(:,ps_elec_index)  Zeff_fi(~nrho)")
  ENDIF

  IF(ALLOCATED(ss%Zeff_th)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho",idims(indim))
     CALL define_var("Zeff_th","R",indim,idims, &
            "Thermal ion contribution to Zeff", &
            "-","PLASMA","STATE_PROFILES", &
            "R|step*ns(:,ps_elec_index)  Zeff_th(~nrho)")
  ENDIF

  indim = 0
  CALL define_var("Zimp1","I",indim,idims, &
         "lower limit on Z of impurity in reduced species list SA;", &
         "__NONE","PLASMA","SIMULATION_INIT", &
         "IS  Zimp1 = 2")

  indim = 0
  CALL define_var("Zimp2","I",indim,idims, &
         "upper limit on Z of impurity in SA species list;", &
         "__NONE","PLASMA","SIMULATION_INIT", &
         "IS  Zimp2 = 1000")

  IF(ALLOCATED(ss%zlim)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_num_rzlim",idims(indim))
     CALL define_var("zlim","R",indim,idims, &
            "Z points in closed (R,Z) contour sequence", &
            "m","EQ","MACHINE_DESCRIPTION", &
            "R|units=m  zlim(num_rzlim)")
  ENDIF

  IF(ALLOCATED(ss%Zloc_coil)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_ncoils",idims(indim))
     CALL define_var("Zloc_coil","R",indim,idims, &
            "Z location of coil, lower left corner", &
            "m","EQ","MACHINE_DESCRIPTION", &
            "R|units=m  Zloc_coil(ncoils)")
  ENDIF

  IF(ALLOCATED(ss%Z_ant)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nicrf_src",idims(indim))
     CALL define_var("Z_ant","R",indim,idims, &
            "height of antenna", &
            "m","IC","SHOT_CONFIGURATION", &
            "R|units=m Z_ant(nicrf_src)")
  ENDIF

  IF(ALLOCATED(ss%Z_antgeo)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_max_nrz_antgeo",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nicrf_src",idims(indim))
     CALL define_var("Z_antgeo","R",indim,idims, &
            "antenna geo: Z pts", &
            "m","IC","MACHINE_DESCRIPTION", &
            "R|units=m Z_antgeo(nrz_antgeo(),nicrf_src)")
  ENDIF

  indim = 0
  CALL define_var("Z_axis","R",indim,idims, &
         "Z of magnetic axis", &
         "m","EQ","STATE_DATA", &
         "R  Z_axis")

  IF(ALLOCATED(ss%Z_EC_launch)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_necrf_src",idims(indim))
     CALL define_var("Z_EC_launch","R",indim,idims, &
            "Z of center of launcher", &
            "m","EC","MACHINE_DESCRIPTION", &
            "R|units=m   Z_EC_launch(necrf_src)")
  ENDIF

  IF(ALLOCATED(ss%Z_geo)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_eq",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nth_eq",idims(indim))
     CALL define_var("Z_geo","R",indim,idims, &
            "flux surfaces Z(rho,theta)", &
            "m","EQ","STATE_PROFILES", &
            "R|units=m|Hermite_explicit Z_geo(nrho_eq,nth_eq)")
  ENDIF

  IF(ALLOCATED(ss%Z_grid)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nz",idims(indim))
     CALL define_var("Z_grid","R",indim,idims, &
            "Z grid", &
            "m","EQ","SIMULATION_INIT", &
            "G   Z_grid(nZ)")
  ENDIF

  indim = 0
  CALL define_var("Z_max_box","R",indim,idims, &
         "Z_max of bounding box", &
         "m","EQ","MACHINE_DESCRIPTION", &
         "R  Z_max_box")

  indim = 0
  CALL define_var("Z_max_lcfs","R",indim,idims, &
         "Z_max of last closed flux surface", &
         "m","EQ","STATE_DATA", &
         "R  Z_max_lcfs")

  IF(ALLOCATED(ss%Z_midp)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_eq_geo",idims(indim))
     CALL define_var("Z_midp","R",indim,idims, &
            "flux surface midplane elevation", &
            "m","EQ","STATE_PROFILES", &
            "R|pclin  Z_midp(nrho_eq_geo)")
  ENDIF

  IF(ALLOCATED(ss%Z_mid_ant)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nicrf_src",idims(indim))
     CALL define_var("Z_mid_ant","R",indim,idims, &
            "center of antenna relative to TF coil midplane", &
            "m","IC","SHOT_CONFIGURATION", &
            "R|units=m Z_mid_ant(nicrf_src)")
  ENDIF

  indim = 0
  CALL define_var("Z_min_box","R",indim,idims, &
         "Z_min of bounding box", &
         "m","EQ","MACHINE_DESCRIPTION", &
         "R  Z_min_box")

  indim = 0
  CALL define_var("Z_min_lcfs","R",indim,idims, &
         "Z_min of last closed flux surface", &
         "m","EQ","STATE_DATA", &
         "R  Z_min_lcfs")

  IF(ALLOCATED(ss%Z_ripple)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nz_rip",idims(indim))
     CALL define_var("Z_ripple","R",indim,idims, &
            "Z grid for TF ripple field(s)", &
            "m","RIPPLE","SIMULATION_INIT", &
            "G  Z_ripple(nZ_rip)")
  ENDIF

  IF(ALLOCATED(ss%Z_surfMax)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_eq_geo",idims(indim))
     CALL define_var("Z_surfMax","R",indim,idims, &
            "max Z on flux surface", &
            "m","EQ","STATE_PROFILES", &
            "R|pclin  Z_surfMax(nrho_eq_geo)")
  ENDIF

  IF(ALLOCATED(ss%Z_surfMin)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_eq_geo",idims(indim))
     CALL define_var("Z_surfMin","R",indim,idims, &
            "min Z on flux surface", &
            "m","EQ","STATE_PROFILES", &
            "R|pclin  Z_surfMin(nrho_eq_geo)")
  ENDIF

  CONTAINS


     SUBROUTINE define_var(name,dtype,indim,idims, &
          long_name,units,component,section,spec)

        CHARACTER*(*), INTENT(in) :: name
        CHARACTER*(*), INTENT(in) :: dtype
        INTEGER, INTENT(in) :: indim
        INTEGER, dimension(:), INTENT(in) :: idims
        CHARACTER*(*), INTENT(in) :: long_name
        CHARACTER*(*), INTENT(in) :: units
        CHARACTER*(*), INTENT(in) :: component
        CHARACTER*(*), INTENT(in) :: section
        CHARACTER*(*), INTENT(in) :: spec

        integer :: itype

        IF(dtype.EQ.'R') THEN
           itype = NF90_DOUBLE

        ELSE IF (dtype.EQ.'I') THEN
           itype = NF90_INT

        ELSE
           itype = NF90_CHAR

        ENDIF

        IF(indim.EQ.0) THEN
           status=nf90_def_var(icdf,name,itype, varid=varid)

        ELSE
           status=nf90_def_var(icdf,name,itype, dimids=idims(1:indim),varid=varid)

        ENDIF

        IF(status.NE.NF90_NOERR) THEN
           WRITE(iout,*) " ?plasma_state_store: error defining variable: "//trim(name)
           CALL ncerr(status)
           iertot = iertot + 1
           RETURN
        ENDIF

        ! Variable OK, now add attributes:

        CALL add_attrib("long_name",long_name)
        IF(dtype.EQ.'R') CALL add_attrib("units",units)
        CALL add_attrib("component",component)
        CALL add_attrib("section",section)
        CALL add_attrib("specification",spec)

     END SUBROUTINE define_var

     SUBROUTINE add_attrib(name,value)
        CHARACTER*(*), intent(in) :: name
        CHARACTER*(*), intent(in) :: value

        status=nf90_put_att(icdf,varid,name,value)
        IF(status.NE.NF90_NOERR) THEN
           WRITE(iout,*) " ?plasma_state_store: error defining attribute: "//trim(name)//' = '//trim(value)
           CALL ncerr(status)
           iertot = iertot + 1
        ENDIF
     END SUBROUTINE add_attrib

     SUBROUTINE ncerr(status)
        INTEGER, INTENT(in) :: status

        nc_errmsg = NF90_strerror(status)
        write(iout,*) '  NetCDF message: ',trim(nc_errmsg)
     END SUBROUTINE ncerr

END SUBROUTINE plasma_state_store_def_9


SUBROUTINE plasma_state_store_9(ss,icdf,iout,iertot)


  !  write subset of variables and arrays from NetCDF file

  USE plasma_state_definition_mod
  USE netcdf
  IMPLICIT NONE

  TYPE (plasma_state) :: ss     ! state data to read
  INTEGER, INTENT(IN) :: icdf   ! NetCDF file ID
  INTEGER, INTENT(IN) :: iout   ! message LUN
  INTEGER, INTENT(INOUT) :: iertot  ! error count

  !--------------

  INTEGER :: varid,dimid,status,ival,idims(20),indim
  CHARACTER*80 :: nc_errmsg

  !--------------
  !  write variables...


  IF(ALLOCATED(ss%velte_mmm71)) THEN
     status = nf90_inq_varid(icdf,"velte_mmm71",varid)
     status = nf90_put_var(icdf,varid,ss%velte_mmm71)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: velte_mmm71"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%velte_nclass)) THEN
     status = nf90_inq_varid(icdf,"velte_nclass",varid)
     status = nf90_put_var(icdf,varid,ss%velte_nclass)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: velte_nclass"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%velte_neo)) THEN
     status = nf90_inq_varid(icdf,"velte_neo",varid)
     status = nf90_put_var(icdf,varid,ss%velte_neo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: velte_neo"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%velte_paleo)) THEN
     status = nf90_inq_varid(icdf,"velte_paleo",varid)
     status = nf90_put_var(icdf,varid,ss%velte_paleo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: velte_paleo"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%velte_tglf)) THEN
     status = nf90_inq_varid(icdf,"velte_tglf",varid)
     status = nf90_put_var(icdf,varid,ss%velte_tglf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: velte_tglf"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%velti_anom)) THEN
     status = nf90_inq_varid(icdf,"velti_anom",varid)
     status = nf90_put_var(icdf,varid,ss%velti_anom)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: velti_anom"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%velti_glf)) THEN
     status = nf90_inq_varid(icdf,"velti_glf",varid)
     status = nf90_put_var(icdf,varid,ss%velti_glf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: velti_glf"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%velti_gtcneo)) THEN
     status = nf90_inq_varid(icdf,"velti_gtcneo",varid)
     status = nf90_put_var(icdf,varid,ss%velti_gtcneo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: velti_gtcneo"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%velti_mmm71)) THEN
     status = nf90_inq_varid(icdf,"velti_mmm71",varid)
     status = nf90_put_var(icdf,varid,ss%velti_mmm71)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: velti_mmm71"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%velti_nclass)) THEN
     status = nf90_inq_varid(icdf,"velti_nclass",varid)
     status = nf90_put_var(icdf,varid,ss%velti_nclass)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: velti_nclass"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%velti_neo)) THEN
     status = nf90_inq_varid(icdf,"velti_neo",varid)
     status = nf90_put_var(icdf,varid,ss%velti_neo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: velti_neo"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%velti_tglf)) THEN
     status = nf90_inq_varid(icdf,"velti_tglf",varid)
     status = nf90_put_var(icdf,varid,ss%velti_tglf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: velti_tglf"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%vie_trans)) THEN
     status = nf90_inq_varid(icdf,"vie_trans",varid)
     status = nf90_put_var(icdf,varid,ss%vie_trans)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: vie_trans"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%vie_transcat)) THEN
     status = nf90_inq_varid(icdf,"vie_transcat",varid)
     status = nf90_put_var(icdf,varid,ss%vie_transcat)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: vie_transcat"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%vmo_trans)) THEN
     status = nf90_inq_varid(icdf,"vmo_trans",varid)
     status = nf90_put_var(icdf,varid,ss%vmo_trans)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: vmo_trans"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%vmo_transcat)) THEN
     status = nf90_inq_varid(icdf,"vmo_transcat",varid)
     status = nf90_put_var(icdf,varid,ss%vmo_transcat)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: vmo_transcat"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%vn_trans)) THEN
     status = nf90_inq_varid(icdf,"vn_trans",varid)
     status = nf90_put_var(icdf,varid,ss%vn_trans)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: vn_trans"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%vn_transcat)) THEN
     status = nf90_inq_varid(icdf,"vn_transcat",varid)
     status = nf90_put_var(icdf,varid,ss%vn_transcat)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: vn_transcat"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%vol)) THEN
     status = nf90_inq_varid(icdf,"vol",varid)
     status = nf90_put_var(icdf,varid,ss%vol)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: vol"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%vphi0_av)) THEN
     status = nf90_inq_varid(icdf,"vphi0_av",varid)
     status = nf90_put_var(icdf,varid,ss%vphi0_av)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: vphi0_av"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"vpol_Data_Info",varid)
  status = nf90_put_var(icdf,varid,ss%vpol_Data_Info)
  IF(status.NE.NF90_NOERR) THEN
     WRITE(iout,*) " ?plasma_state_store: error storing: vpol_Data_Info"
     CALL ncerr(status)
     iertot = iertot + 1
  ENDIF

  IF(ALLOCATED(ss%vpol_inmp)) THEN
     status = nf90_inq_varid(icdf,"vpol_inmp",varid)
     status = nf90_put_var(icdf,varid,ss%vpol_inmp)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: vpol_inmp"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%vpol_is_input)) THEN
     status = nf90_inq_varid(icdf,"vpol_is_input",varid)
     status = nf90_put_var(icdf,varid,ss%vpol_is_input)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: vpol_is_input"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%vpol_omp)) THEN
     status = nf90_inq_varid(icdf,"vpol_omp",varid)
     status = nf90_put_var(icdf,varid,ss%vpol_omp)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: vpol_omp"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%VRep_coil_count)) THEN
     status = nf90_inq_varid(icdf,"VRep_coil_count",varid)
     status = nf90_put_var(icdf,varid,ss%VRep_coil_count)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: VRep_coil_count"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%Vrep_coil_spacing)) THEN
     status = nf90_inq_varid(icdf,"Vrep_coil_spacing",varid)
     status = nf90_put_var(icdf,varid,ss%Vrep_coil_spacing)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: Vrep_coil_spacing"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%Vsize_coil)) THEN
     status = nf90_inq_varid(icdf,"Vsize_coil",varid)
     status = nf90_put_var(icdf,varid,ss%Vsize_coil)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: Vsize_coil"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"vsur",varid)
  status = nf90_put_var(icdf,varid,ss%vsur)
  IF(status.NE.NF90_NOERR) THEN
     WRITE(iout,*) " ?plasma_state_store: error storing: vsur"
     CALL ncerr(status)
     iertot = iertot + 1
  ENDIF

  status = nf90_inq_varid(icdf,"VSUR_Data_Info",varid)
  status = nf90_put_var(icdf,varid,ss%VSUR_Data_Info)
  IF(status.NE.NF90_NOERR) THEN
     WRITE(iout,*) " ?plasma_state_store: error storing: VSUR_Data_Info"
     CALL ncerr(status)
     iertot = iertot + 1
  ENDIF

  status = nf90_inq_varid(icdf,"vtor_Data_Info",varid)
  status = nf90_put_var(icdf,varid,ss%vtor_Data_Info)
  IF(status.NE.NF90_NOERR) THEN
     WRITE(iout,*) " ?plasma_state_store: error storing: vtor_Data_Info"
     CALL ncerr(status)
     iertot = iertot + 1
  ENDIF

  IF(ALLOCATED(ss%vtor_inmp)) THEN
     status = nf90_inq_varid(icdf,"vtor_inmp",varid)
     status = nf90_put_var(icdf,varid,ss%vtor_inmp)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: vtor_inmp"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%vtor_is_input)) THEN
     status = nf90_inq_varid(icdf,"vtor_is_input",varid)
     status = nf90_put_var(icdf,varid,ss%vtor_is_input)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: vtor_is_input"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%vtor_omp)) THEN
     status = nf90_inq_varid(icdf,"vtor_omp",varid)
     status = nf90_put_var(icdf,varid,ss%vtor_omp)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: vtor_omp"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%V_loop)) THEN
     status = nf90_inq_varid(icdf,"V_loop",varid)
     status = nf90_put_var(icdf,varid,ss%V_loop)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: V_loop"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%v_pars)) THEN
     status = nf90_inq_varid(icdf,"v_pars",varid)
     status = nf90_put_var(icdf,varid,ss%v_pars)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: v_pars"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%v_pers)) THEN
     status = nf90_inq_varid(icdf,"v_pers",varid)
     status = nf90_put_var(icdf,varid,ss%v_pers)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: v_pers"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%wt_nphi)) THEN
     status = nf90_inq_varid(icdf,"wt_nphi",varid)
     status = nf90_put_var(icdf,varid,ss%wt_nphi)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: wt_nphi"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%wt_nphi_abs)) THEN
     status = nf90_inq_varid(icdf,"wt_nphi_abs",varid)
     status = nf90_put_var(icdf,varid,ss%wt_nphi_abs)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: wt_nphi_abs"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%wt_nphi_ext)) THEN
     status = nf90_inq_varid(icdf,"wt_nphi_ext",varid)
     status = nf90_put_var(icdf,varid,ss%wt_nphi_ext)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: wt_nphi_ext"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%xRjcos_momeq)) THEN
     status = nf90_inq_varid(icdf,"xRjcos_momeq",varid)
     status = nf90_put_var(icdf,varid,ss%xRjcos_momeq)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: xRjcos_momeq"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%xRjsin_momeq)) THEN
     status = nf90_inq_varid(icdf,"xRjsin_momeq",varid)
     status = nf90_put_var(icdf,varid,ss%xRjsin_momeq)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: xRjsin_momeq"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%xs)) THEN
     status = nf90_inq_varid(icdf,"xs",varid)
     status = nf90_put_var(icdf,varid,ss%xs)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: xs"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%xs_name)) THEN
     status = nf90_inq_varid(icdf,"xs_name",varid)
     status = nf90_put_var(icdf,varid,ss%xs_name)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: xs_name"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%xZjcos_momeq)) THEN
     status = nf90_inq_varid(icdf,"xZjcos_momeq",varid)
     status = nf90_put_var(icdf,varid,ss%xZjcos_momeq)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: xZjcos_momeq"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%xZjsin_momeq)) THEN
     status = nf90_inq_varid(icdf,"xZjsin_momeq",varid)
     status = nf90_put_var(icdf,varid,ss%xZjsin_momeq)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: xZjsin_momeq"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Z0max",varid)
  status = nf90_put_var(icdf,varid,ss%Z0max)
  IF(status.NE.NF90_NOERR) THEN
     WRITE(iout,*) " ?plasma_state_store: error storing: Z0max"
     CALL ncerr(status)
     iertot = iertot + 1
  ENDIF

  IF(ALLOCATED(ss%Z0_momeq)) THEN
     status = nf90_inq_varid(icdf,"Z0_momeq",varid)
     status = nf90_put_var(icdf,varid,ss%Z0_momeq)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: Z0_momeq"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%Zbap)) THEN
     status = nf90_inq_varid(icdf,"Zbap",varid)
     status = nf90_put_var(icdf,varid,ss%Zbap)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: Zbap"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%Zbsc)) THEN
     status = nf90_inq_varid(icdf,"Zbsc",varid)
     status = nf90_put_var(icdf,varid,ss%Zbsc)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: Zbsc"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%Zeff)) THEN
     status = nf90_inq_varid(icdf,"Zeff",varid)
     status = nf90_put_var(icdf,varid,ss%Zeff)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: Zeff"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"ZEFF_Data_Info",varid)
  status = nf90_put_var(icdf,varid,ss%ZEFF_Data_Info)
  IF(status.NE.NF90_NOERR) THEN
     WRITE(iout,*) " ?plasma_state_store: error storing: ZEFF_Data_Info"
     CALL ncerr(status)
     iertot = iertot + 1
  ENDIF

  IF(ALLOCATED(ss%Zeff_fi)) THEN
     status = nf90_inq_varid(icdf,"Zeff_fi",varid)
     status = nf90_put_var(icdf,varid,ss%Zeff_fi)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: Zeff_fi"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%Zeff_th)) THEN
     status = nf90_inq_varid(icdf,"Zeff_th",varid)
     status = nf90_put_var(icdf,varid,ss%Zeff_th)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: Zeff_th"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Zimp1",varid)
  status = nf90_put_var(icdf,varid,ss%Zimp1)
  IF(status.NE.NF90_NOERR) THEN
     WRITE(iout,*) " ?plasma_state_store: error storing: Zimp1"
     CALL ncerr(status)
     iertot = iertot + 1
  ENDIF

  status = nf90_inq_varid(icdf,"Zimp2",varid)
  status = nf90_put_var(icdf,varid,ss%Zimp2)
  IF(status.NE.NF90_NOERR) THEN
     WRITE(iout,*) " ?plasma_state_store: error storing: Zimp2"
     CALL ncerr(status)
     iertot = iertot + 1
  ENDIF

  IF(ALLOCATED(ss%zlim)) THEN
     status = nf90_inq_varid(icdf,"zlim",varid)
     status = nf90_put_var(icdf,varid,ss%zlim)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: zlim"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%Zloc_coil)) THEN
     status = nf90_inq_varid(icdf,"Zloc_coil",varid)
     status = nf90_put_var(icdf,varid,ss%Zloc_coil)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: Zloc_coil"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%Z_ant)) THEN
     status = nf90_inq_varid(icdf,"Z_ant",varid)
     status = nf90_put_var(icdf,varid,ss%Z_ant)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: Z_ant"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%Z_antgeo)) THEN
     status = nf90_inq_varid(icdf,"Z_antgeo",varid)
     status = nf90_put_var(icdf,varid,ss%Z_antgeo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: Z_antgeo"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Z_axis",varid)
  status = nf90_put_var(icdf,varid,ss%Z_axis)
  IF(status.NE.NF90_NOERR) THEN
     WRITE(iout,*) " ?plasma_state_store: error storing: Z_axis"
     CALL ncerr(status)
     iertot = iertot + 1
  ENDIF

  IF(ALLOCATED(ss%Z_EC_launch)) THEN
     status = nf90_inq_varid(icdf,"Z_EC_launch",varid)
     status = nf90_put_var(icdf,varid,ss%Z_EC_launch)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: Z_EC_launch"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%Z_geo)) THEN
     status = nf90_inq_varid(icdf,"Z_geo",varid)
     status = nf90_put_var(icdf,varid,ss%Z_geo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: Z_geo"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%Z_grid)) THEN
     status = nf90_inq_varid(icdf,"Z_grid",varid)
     status = nf90_put_var(icdf,varid,ss%Z_grid)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: Z_grid"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Z_max_box",varid)
  status = nf90_put_var(icdf,varid,ss%Z_max_box)
  IF(status.NE.NF90_NOERR) THEN
     WRITE(iout,*) " ?plasma_state_store: error storing: Z_max_box"
     CALL ncerr(status)
     iertot = iertot + 1
  ENDIF

  status = nf90_inq_varid(icdf,"Z_max_lcfs",varid)
  status = nf90_put_var(icdf,varid,ss%Z_max_lcfs)
  IF(status.NE.NF90_NOERR) THEN
     WRITE(iout,*) " ?plasma_state_store: error storing: Z_max_lcfs"
     CALL ncerr(status)
     iertot = iertot + 1
  ENDIF

  IF(ALLOCATED(ss%Z_midp)) THEN
     status = nf90_inq_varid(icdf,"Z_midp",varid)
     status = nf90_put_var(icdf,varid,ss%Z_midp)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: Z_midp"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%Z_mid_ant)) THEN
     status = nf90_inq_varid(icdf,"Z_mid_ant",varid)
     status = nf90_put_var(icdf,varid,ss%Z_mid_ant)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: Z_mid_ant"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Z_min_box",varid)
  status = nf90_put_var(icdf,varid,ss%Z_min_box)
  IF(status.NE.NF90_NOERR) THEN
     WRITE(iout,*) " ?plasma_state_store: error storing: Z_min_box"
     CALL ncerr(status)
     iertot = iertot + 1
  ENDIF

  status = nf90_inq_varid(icdf,"Z_min_lcfs",varid)
  status = nf90_put_var(icdf,varid,ss%Z_min_lcfs)
  IF(status.NE.NF90_NOERR) THEN
     WRITE(iout,*) " ?plasma_state_store: error storing: Z_min_lcfs"
     CALL ncerr(status)
     iertot = iertot + 1
  ENDIF

  IF(ALLOCATED(ss%Z_ripple)) THEN
     status = nf90_inq_varid(icdf,"Z_ripple",varid)
     status = nf90_put_var(icdf,varid,ss%Z_ripple)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: Z_ripple"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%Z_surfMax)) THEN
     status = nf90_inq_varid(icdf,"Z_surfMax",varid)
     status = nf90_put_var(icdf,varid,ss%Z_surfMax)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: Z_surfMax"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%Z_surfMin)) THEN
     status = nf90_inq_varid(icdf,"Z_surfMin",varid)
     status = nf90_put_var(icdf,varid,ss%Z_surfMin)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: Z_surfMin"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  CONTAINS


     SUBROUTINE ncerr(status)
        INTEGER, INTENT(in) :: status

        nc_errmsg = NF90_strerror(status)
        write(iout,*) '  NetCDF message: ',trim(nc_errmsg)
     END SUBROUTINE ncerr

END SUBROUTINE plasma_state_store_9

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_v2_dummy
     return
  end subroutine ccps_getset_v2_dummy

subroutine psget_vrep_coil_spacing(iobj, n1, data, ierr)
    !! replicated coil separation, (only meaningful for coils {k}
    !! with VRep_coil_count(k) > 1).
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_vrep_coil_spacing', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % Vrep_coil_spacing
end subroutine psget_vrep_coil_spacing


subroutine psset_vrep_coil_spacing(iobj, n1, data, ierr)
    !! replicated coil separation, (only meaningful for coils {k}
    !! with VRep_coil_count(k) > 1).
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_vrep_coil_spacing', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % Vrep_coil_spacing = data(1:n1)
end subroutine psset_vrep_coil_spacing


subroutine psgetrnk_vrep_coil_spacing(iobj, ndims, ierr)
    !! replicated coil separation, (only meaningful for coils {k}
    !! with VRep_coil_count(k) > 1).
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_vrep_coil_spacing


subroutine psgetdim_vrep_coil_spacing(iobj, ndims, dims, ierr)
    !! replicated coil separation, (only meaningful for coils {k}
    !! with VRep_coil_count(k) > 1).
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_vrep_coil_spacing', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % Vrep_coil_spacing ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % Vrep_coil_spacing)
    endif
end subroutine psgetdim_vrep_coil_spacing


subroutine psget_v_pers(iobj, n1, n2, data, ierr)
    !! thermal specie <vper>
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_v_pers', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % v_pers
end subroutine psget_v_pers


subroutine psset_v_pers(iobj, n1, n2, data, ierr)
    !! thermal specie <vper>
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_v_pers', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % v_pers = data(1:n1, 1: n2)
end subroutine psset_v_pers


subroutine psgetrnk_v_pers(iobj, ndims, ierr)
    !! thermal specie <vper>
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_v_pers


subroutine psgetdim_v_pers(iobj, ndims, dims, ierr)
    !! thermal specie <vper>
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_v_pers', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % v_pers ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % v_pers)
    endif
end subroutine psgetdim_v_pers


subroutine psget_vmo_transcat(iobj, n1, n2, data, ierr)
    !! Angular momentum radial velocity
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_vmo_transcat', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % vmo_transcat
end subroutine psget_vmo_transcat


subroutine psset_vmo_transcat(iobj, n1, n2, data, ierr)
    !! Angular momentum radial velocity
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_vmo_transcat', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % vmo_transcat = data(1:n1, 1: n2)
end subroutine psset_vmo_transcat


subroutine psgetrnk_vmo_transcat(iobj, ndims, ierr)
    !! Angular momentum radial velocity
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_vmo_transcat


subroutine psgetdim_vmo_transcat(iobj, ndims, dims, ierr)
    !! Angular momentum radial velocity
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_vmo_transcat', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % vmo_transcat ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % vmo_transcat)
    endif
end subroutine psgetdim_vmo_transcat


subroutine psget_velte_glf(iobj, n1, data, ierr)
    !! Te-equation, advective velocity term from GLF23 model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_velte_glf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % velte_glf
end subroutine psget_velte_glf


subroutine psset_velte_glf(iobj, n1, data, ierr)
    !! Te-equation, advective velocity term from GLF23 model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_velte_glf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % velte_glf = data(1:n1)
end subroutine psset_velte_glf


subroutine psgetrnk_velte_glf(iobj, ndims, ierr)
    !! Te-equation, advective velocity term from GLF23 model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_velte_glf


subroutine psgetdim_velte_glf(iobj, ndims, dims, ierr)
    !! Te-equation, advective velocity term from GLF23 model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_velte_glf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % velte_glf ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % velte_glf)
    endif
end subroutine psgetdim_velte_glf


subroutine psget_velte_neo(iobj, n1, data, ierr)
    !! Te-equation, advective velocity term from NEO model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_velte_neo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % velte_neo
end subroutine psget_velte_neo


subroutine psset_velte_neo(iobj, n1, data, ierr)
    !! Te-equation, advective velocity term from NEO model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_velte_neo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % velte_neo = data(1:n1)
end subroutine psset_velte_neo


subroutine psgetrnk_velte_neo(iobj, ndims, ierr)
    !! Te-equation, advective velocity term from NEO model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_velte_neo


subroutine psgetdim_velte_neo(iobj, ndims, dims, ierr)
    !! Te-equation, advective velocity term from NEO model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_velte_neo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % velte_neo ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % velte_neo)
    endif
end subroutine psgetdim_velte_neo


subroutine psget_velte_nclass(iobj, n1, data, ierr)
    !! Te-equation, advective velocity term from NCLASS model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_velte_nclass', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % velte_nclass
end subroutine psget_velte_nclass


subroutine psset_velte_nclass(iobj, n1, data, ierr)
    !! Te-equation, advective velocity term from NCLASS model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_velte_nclass', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % velte_nclass = data(1:n1)
end subroutine psset_velte_nclass


subroutine psgetrnk_velte_nclass(iobj, ndims, ierr)
    !! Te-equation, advective velocity term from NCLASS model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_velte_nclass


subroutine psgetdim_velte_nclass(iobj, ndims, dims, ierr)
    !! Te-equation, advective velocity term from NCLASS model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_velte_nclass', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % velte_nclass ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % velte_nclass)
    endif
end subroutine psgetdim_velte_nclass

subroutine ps_wr_geqdsk_file(ps,gfile,iout,ierr)

  ! write G-eqdsk file from contents of plasma state, if possible.
  ! Psi(R,Z), [R,Z](rho,theta), g(rho), q(rho), and P(rho) must be there.
  !------------------------------------------------------------

  use plasma_state_xpobj  ! XPLASMA2 state object definitions

  use plasma_state_definition_mod

  implicit NONE

  !-----------------------
  ! arguments:

  type (plasma_state) :: ps            ! plasma state instance 
  character*(*), intent(in) :: gfile   ! name of file to write
  integer, intent(in) :: iout          ! Fortran LUN for messages
  integer, intent(out) :: ierr         ! status code, 0=OK

  !------------------------
  ! local:

  integer :: ilun

  !------------------------

  type (interp_object) :: xobj
  type (xplasma), pointer :: s
  !-------------------------------------------------------------------------
  ! executable code...

  call ps_tagchk('ps_wr_geqdsk_file',ps%itag,iout,ierr)
  if(ierr.ne.0) return

  ! check contents

  call ps_wrgeq_chk(ps,'ps_wr_geqdsk_file',iout,ierr)

  if(ierr.ne.0) return

  ! OK everything seems to be there...

  ! get xplasma pointer

  xobj = transfer(ps%iobj,xobj)
  s => xobj%s_xpobj

  call find_io_unit(ilun)
  call xplasma_wr_geqdsk(s,ierr, &
       lun_geqdsk=ilun, filename=gfile, &
       label=ps%Global_label, &
       id_qprof=ps%id_q_eq, id_Pprof=ps%id_P_eq)

end subroutine ps_wr_geqdsk_file

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_s9_dummy
     return
  end subroutine ccps_getset_s9_dummy

subroutine psget_sfus_to_all(iobj, n1, data, ierr)
    !! map sfus index to "all" list
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_sfus_to_all', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % sfus_to_all
end subroutine psget_sfus_to_all


subroutine psset_sfus_to_all(iobj, n1, data, ierr)
    !! map sfus index to "all" list
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_sfus_to_all', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % sfus_to_all = data(1:n1)
end subroutine psset_sfus_to_all


subroutine psgetrnk_sfus_to_all(iobj, ndims, ierr)
    !! map sfus index to "all" list
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_sfus_to_all


subroutine psgetdim_sfus_to_all(iobj, ndims, dims, ierr)
    !! map sfus index to "all" list
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_sfus_to_all', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % sfus_to_all ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % sfus_to_all)
    endif
end subroutine psgetdim_sfus_to_all


subroutine psget_simpi_to_s(iobj, n1, data, ierr)
    !! map simpi index to "s" list
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_simpi_to_s', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % simpi_to_s
end subroutine psget_simpi_to_s


subroutine psset_simpi_to_s(iobj, n1, data, ierr)
    !! map simpi index to "s" list
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_simpi_to_s', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % simpi_to_s = data(1:n1)
end subroutine psset_simpi_to_s


subroutine psgetrnk_simpi_to_s(iobj, ndims, ierr)
    !! map simpi index to "s" list
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_simpi_to_s


subroutine psgetdim_simpi_to_s(iobj, ndims, dims, ierr)
    !! map simpi index to "s" list
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_simpi_to_s', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % simpi_to_s ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % simpi_to_s)
    endif
end subroutine psgetdim_simpi_to_s


subroutine psget_sc0(iobj, n1, data, ierr)
    !! edge neutral sources (atoms/sec), these numbers normalize
    !! numerous GAS profiles
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_sc0', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % sc0
end subroutine psget_sc0


subroutine psset_sc0(iobj, n1, data, ierr)
    !! edge neutral sources (atoms/sec), these numbers normalize
    !! numerous GAS profiles
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_sc0', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % sc0 = data(1:n1)
end subroutine psset_sc0


subroutine psgetrnk_sc0(iobj, ndims, ierr)
    !! edge neutral sources (atoms/sec), these numbers normalize
    !! numerous GAS profiles
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_sc0


subroutine psgetdim_sc0(iobj, ndims, dims, ierr)
    !! edge neutral sources (atoms/sec), these numbers normalize
    !! numerous GAS profiles
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_sc0', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % sc0 ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % sc0)
    endif
end subroutine psgetdim_sc0


subroutine psget_squarelo(iobj, n1, data, ierr)
    !! lower outer squareness, lower half of plasma, large major
    !! radius side, definition per C. T. Holcomb et al,, Physics of
    !! Plasmas 15, 056116 (2009)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_squarelo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % squareLO
end subroutine psget_squarelo


subroutine psset_squarelo(iobj, n1, data, ierr)
    !! lower outer squareness, lower half of plasma, large major
    !! radius side, definition per C. T. Holcomb et al,, Physics of
    !! Plasmas 15, 056116 (2009)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_squarelo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % squareLO = data(1:n1)
end subroutine psset_squarelo


subroutine psgetrnk_squarelo(iobj, ndims, ierr)
    !! lower outer squareness, lower half of plasma, large major
    !! radius side, definition per C. T. Holcomb et al,, Physics of
    !! Plasmas 15, 056116 (2009)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_squarelo


subroutine psgetdim_squarelo(iobj, ndims, dims, ierr)
    !! lower outer squareness, lower half of plasma, large major
    !! radius side, definition per C. T. Holcomb et al,, Physics of
    !! Plasmas 15, 056116 (2009)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_squarelo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % squareLO ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % squareLO)
    endif
end subroutine psgetdim_squarelo


subroutine psget_sbtherm(iobj, n1, n2, data, ierr)
    !! beam ion thermalization, source of slowed down, thermalized
    !! beam ions
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_sbtherm', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % sbtherm
end subroutine psget_sbtherm


subroutine psset_sbtherm(iobj, n1, n2, data, ierr)
    !! beam ion thermalization, source of slowed down, thermalized
    !! beam ions
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_sbtherm', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % sbtherm = data(1:n1, 1: n2)
end subroutine psset_sbtherm


subroutine psgetrnk_sbtherm(iobj, ndims, ierr)
    !! beam ion thermalization, source of slowed down, thermalized
    !! beam ions
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_sbtherm


subroutine psgetdim_sbtherm(iobj, ndims, dims, ierr)
    !! beam ion thermalization, source of slowed down, thermalized
    !! beam ions
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_sbtherm', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % sbtherm ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % sbtherm)
    endif
end subroutine psgetdim_sbtherm

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_a5_dummy
     return
  end subroutine ccps_getset_a5_dummy

subroutine psget_alla_index(iobj, n1, data, ierr)
    !! species index in original lists, alla_index(j)=-1 indicates
    !! that element (j) of the "alla" list is, derived from a
    !! composite of ions in the "s" list (using Zeff, and
    !! quasineutrality equations)., otherwise for thermal ions
    !! alla_index(j) gives the index of the, species in "S".  For
    !! example, if index 2 corresponds to Deuterium, thermal ions in
    !! "alla", then alla_index(2) gives the index in "S", for
    !! Deuterium thermal ions.  For non-thermal ions, ion species j,
    !! corresponds to species index:, alla_index(j) in "SNBI" if
    !! all_type(j) = ps_beam_ion, alla_index(j) in "RFMIN" if
    !! all_type(j) = ps_rf_minority, alla_index(j) in "SFUS" if
    !! all_type(j) = ps_fusion_ion
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_alla_index', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % alla_index
end subroutine psget_alla_index


subroutine psset_alla_index(iobj, n1, data, ierr)
    !! species index in original lists, alla_index(j)=-1 indicates
    !! that element (j) of the "alla" list is, derived from a
    !! composite of ions in the "s" list (using Zeff, and
    !! quasineutrality equations)., otherwise for thermal ions
    !! alla_index(j) gives the index of the, species in "S".  For
    !! example, if index 2 corresponds to Deuterium, thermal ions in
    !! "alla", then alla_index(2) gives the index in "S", for
    !! Deuterium thermal ions.  For non-thermal ions, ion species j,
    !! corresponds to species index:, alla_index(j) in "SNBI" if
    !! all_type(j) = ps_beam_ion, alla_index(j) in "RFMIN" if
    !! all_type(j) = ps_rf_minority, alla_index(j) in "SFUS" if
    !! all_type(j) = ps_fusion_ion
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_alla_index', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % alla_index = data(1:n1)
end subroutine psset_alla_index


subroutine psgetrnk_alla_index(iobj, ndims, ierr)
    !! species index in original lists, alla_index(j)=-1 indicates
    !! that element (j) of the "alla" list is, derived from a
    !! composite of ions in the "s" list (using Zeff, and
    !! quasineutrality equations)., otherwise for thermal ions
    !! alla_index(j) gives the index of the, species in "S".  For
    !! example, if index 2 corresponds to Deuterium, thermal ions in
    !! "alla", then alla_index(2) gives the index in "S", for
    !! Deuterium thermal ions.  For non-thermal ions, ion species j,
    !! corresponds to species index:, alla_index(j) in "SNBI" if
    !! all_type(j) = ps_beam_ion, alla_index(j) in "RFMIN" if
    !! all_type(j) = ps_rf_minority, alla_index(j) in "SFUS" if
    !! all_type(j) = ps_fusion_ion
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_alla_index


subroutine psgetdim_alla_index(iobj, ndims, dims, ierr)
    !! species index in original lists, alla_index(j)=-1 indicates
    !! that element (j) of the "alla" list is, derived from a
    !! composite of ions in the "s" list (using Zeff, and
    !! quasineutrality equations)., otherwise for thermal ions
    !! alla_index(j) gives the index of the, species in "S".  For
    !! example, if index 2 corresponds to Deuterium, thermal ions in
    !! "alla", then alla_index(2) gives the index in "S", for
    !! Deuterium thermal ions.  For non-thermal ions, ion species j,
    !! corresponds to species index:, alla_index(j) in "SNBI" if
    !! all_type(j) = ps_beam_ion, alla_index(j) in "RFMIN" if
    !! all_type(j) = ps_rf_minority, alla_index(j) in "SFUS" if
    !! all_type(j) = ps_fusion_ion
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_alla_index', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % alla_index ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % alla_index)
    endif
end subroutine psgetdim_alla_index

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_c6_dummy
     return
  end subroutine ccps_getset_c6_dummy

subroutine psget_chimo_transcat(iobj, n1, n2, data, ierr)
    !! Angular momentum diffusivity
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_chimo_transcat', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % chimo_transcat
end subroutine psget_chimo_transcat


subroutine psset_chimo_transcat(iobj, n1, n2, data, ierr)
    !! Angular momentum diffusivity
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_chimo_transcat', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % chimo_transcat = data(1:n1, 1: n2)
end subroutine psset_chimo_transcat


subroutine psgetrnk_chimo_transcat(iobj, ndims, ierr)
    !! Angular momentum diffusivity
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_chimo_transcat


subroutine psgetdim_chimo_transcat(iobj, ndims, dims, ierr)
    !! Angular momentum diffusivity
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_chimo_transcat', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % chimo_transcat ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % chimo_transcat)
    endif
end subroutine psgetdim_chimo_transcat


subroutine psget_cdicrf_nphi(iobj, n1, n2, n3, data, ierr)
    !! ICRF current drive, contribution from each n_phi on each
    !! antenna
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2, n3 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2, n3) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_cdicrf_nphi', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2, 1: n3) = ss % cdicrf_nphi
end subroutine psget_cdicrf_nphi


subroutine psset_cdicrf_nphi(iobj, n1, n2, n3, data, ierr)
    !! ICRF current drive, contribution from each n_phi on each
    !! antenna
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2, n3 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2, n3) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_cdicrf_nphi', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % cdicrf_nphi = data(1:n1, 1: n2, 1: n3)
end subroutine psset_cdicrf_nphi


subroutine psgetrnk_cdicrf_nphi(iobj, ndims, ierr)
    !! ICRF current drive, contribution from each n_phi on each
    !! antenna
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 3
end subroutine psgetrnk_cdicrf_nphi


subroutine psgetdim_cdicrf_nphi(iobj, ndims, dims, ierr)
    !! ICRF current drive, contribution from each n_phi on each
    !! antenna
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 3) ierr = 1
    call ccps_argcheck('psgetdim_cdicrf_nphi', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % cdicrf_nphi ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % cdicrf_nphi)
    endif
end subroutine psgetdim_cdicrf_nphi


subroutine psget_chii_drbm(iobj, n1, data, ierr)
    !! Ti-equation, diffusivity term
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_chii_drbm', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % chii_drbm
end subroutine psget_chii_drbm


subroutine psset_chii_drbm(iobj, n1, data, ierr)
    !! Ti-equation, diffusivity term
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_chii_drbm', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % chii_drbm = data(1:n1)
end subroutine psset_chii_drbm


subroutine psgetrnk_chii_drbm(iobj, ndims, ierr)
    !! Ti-equation, diffusivity term
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_chii_drbm


subroutine psgetdim_chii_drbm(iobj, ndims, dims, ierr)
    !! Ti-equation, diffusivity term
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_chii_drbm', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % chii_drbm ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % chii_drbm)
    endif
end subroutine psgetdim_chii_drbm


subroutine psget_chie_glf(iobj, n1, data, ierr)
    !! Te-equation, diffusivity from GLF23 model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_chie_glf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % chie_glf
end subroutine psget_chie_glf


subroutine psset_chie_glf(iobj, n1, data, ierr)
    !! Te-equation, diffusivity from GLF23 model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_chie_glf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % chie_glf = data(1:n1)
end subroutine psset_chie_glf


subroutine psgetrnk_chie_glf(iobj, ndims, ierr)
    !! Te-equation, diffusivity from GLF23 model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_chie_glf


subroutine psgetdim_chie_glf(iobj, ndims, dims, ierr)
    !! Te-equation, diffusivity from GLF23 model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_chie_glf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % chie_glf ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % chie_glf)
    endif
end subroutine psgetdim_chie_glf


subroutine psget_chie_nclass(iobj, n1, data, ierr)
    !! Te-equation, neoclassical diffusivity from NCLASS model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_chie_nclass', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % chie_nclass
end subroutine psget_chie_nclass


subroutine psset_chie_nclass(iobj, n1, data, ierr)
    !! Te-equation, neoclassical diffusivity from NCLASS model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_chie_nclass', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % chie_nclass = data(1:n1)
end subroutine psset_chie_nclass


subroutine psgetrnk_chie_nclass(iobj, ndims, ierr)
    !! Te-equation, neoclassical diffusivity from NCLASS model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_chie_nclass


subroutine psgetdim_chie_nclass(iobj, ndims, dims, ierr)
    !! Te-equation, neoclassical diffusivity from NCLASS model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_chie_nclass', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % chie_nclass ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % chie_nclass)
    endif
end subroutine psgetdim_chie_nclass

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_d4_dummy
     return
  end subroutine ccps_getset_d4_dummy

subroutine psget_deltaw_stable(iobj, n1, n2, data, ierr)
    !! 0: stable; 1: unstable;, element (i,j) indicates if toroidal
    !! mode number, Tor_mode_No(i) is stable or unstable according to,
    !! the code DeltaW_code(j)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_deltaw_stable', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % DeltaW_stable
end subroutine psget_deltaw_stable


subroutine psset_deltaw_stable(iobj, n1, n2, data, ierr)
    !! 0: stable; 1: unstable;, element (i,j) indicates if toroidal
    !! mode number, Tor_mode_No(i) is stable or unstable according to,
    !! the code DeltaW_code(j)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    INTEGER, intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_deltaw_stable', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % DeltaW_stable = data(1:n1, 1: n2)
end subroutine psset_deltaw_stable


subroutine psgetrnk_deltaw_stable(iobj, ndims, ierr)
    !! 0: stable; 1: unstable;, element (i,j) indicates if toroidal
    !! mode number, Tor_mode_No(i) is stable or unstable according to,
    !! the code DeltaW_code(j)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_deltaw_stable


subroutine psgetdim_deltaw_stable(iobj, ndims, dims, ierr)
    !! 0: stable; 1: unstable;, element (i,j) indicates if toroidal
    !! mode number, Tor_mode_No(i) is stable or unstable according to,
    !! the code DeltaW_code(j)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_deltaw_stable', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % DeltaW_stable ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % DeltaW_stable)
    endif
end subroutine psgetdim_deltaw_stable


subroutine psget_difnz_mmm71(iobj, n1, data, ierr)
    !! impurity ion diffusivity term
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_difnz_mmm71', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % difnz_mmm71
end subroutine psget_difnz_mmm71


subroutine psset_difnz_mmm71(iobj, n1, data, ierr)
    !! impurity ion diffusivity term
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_difnz_mmm71', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % difnz_mmm71 = data(1:n1)
end subroutine psset_difnz_mmm71


subroutine psgetrnk_difnz_mmm71(iobj, ndims, ierr)
    !! impurity ion diffusivity term
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_difnz_mmm71


subroutine psgetdim_difnz_mmm71(iobj, ndims, dims, ierr)
    !! impurity ion diffusivity term
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_difnz_mmm71', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % difnz_mmm71 ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % difnz_mmm71)
    endif
end subroutine psgetdim_difnz_mmm71


subroutine psget_difns_w19(iobj, n1, n2, data, ierr)
    !! density-equations, diffusivity term
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_difns_w19', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % difns_w19
end subroutine psget_difns_w19


subroutine psset_difns_w19(iobj, n1, n2, data, ierr)
    !! density-equations, diffusivity term
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_difns_w19', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % difns_w19 = data(1:n1, 1: n2)
end subroutine psset_difns_w19


subroutine psgetrnk_difns_w19(iobj, ndims, ierr)
    !! density-equations, diffusivity term
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_difns_w19


subroutine psgetdim_difns_w19(iobj, ndims, dims, ierr)
    !! density-equations, diffusivity term
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_difns_w19', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % difns_w19 ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % difns_w19)
    endif
end subroutine psgetdim_difns_w19


subroutine psget_dr_geo_dth(iobj, n1, n2, data, ierr)
    !! flux surfaces R(rho,theta)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_dr_geo_dth', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % dR_geo_dTH
end subroutine psget_dr_geo_dth


subroutine psset_dr_geo_dth(iobj, n1, n2, data, ierr)
    !! flux surfaces R(rho,theta)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_dr_geo_dth', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % dR_geo_dTH = data(1:n1, 1: n2)
end subroutine psset_dr_geo_dth


subroutine psgetrnk_dr_geo_dth(iobj, ndims, ierr)
    !! flux surfaces R(rho,theta)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_dr_geo_dth


subroutine psgetdim_dr_geo_dth(iobj, ndims, dims, ierr)
    !! flux surfaces R(rho,theta)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_dr_geo_dth', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % dR_geo_dTH ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % dR_geo_dTH)
    endif
end subroutine psgetdim_dr_geo_dth


subroutine psget_dxzjsin_momeq_drho(iobj, n1, n2, data, ierr)
    !! scaled Z sin moments, Fourier Spline representation
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_dxzjsin_momeq_drho', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % dxZjsin_momeq_dRHO
end subroutine psget_dxzjsin_momeq_drho


subroutine psset_dxzjsin_momeq_drho(iobj, n1, n2, data, ierr)
    !! scaled Z sin moments, Fourier Spline representation
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_dxzjsin_momeq_drho', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % dxZjsin_momeq_dRHO = data(1:n1, 1: n2)
end subroutine psset_dxzjsin_momeq_drho


subroutine psgetrnk_dxzjsin_momeq_drho(iobj, ndims, ierr)
    !! scaled Z sin moments, Fourier Spline representation
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_dxzjsin_momeq_drho


subroutine psgetdim_dxzjsin_momeq_drho(iobj, ndims, dims, ierr)
    !! scaled Z sin moments, Fourier Spline representation
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_dxzjsin_momeq_drho', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % dxZjsin_momeq_dRHO ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % dxZjsin_momeq_dRHO)
    endif
end subroutine psgetdim_dxzjsin_momeq_drho

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


SUBROUTINE ps_update_file_read_9(ss,icdf,iout,iucount,iertot)


  ! Read updated data

  USE plasma_state_definition_mod
  USE plasma_hash_code
  USE netcdf
  IMPLICIT NONE

  TYPE (plasma_state) :: ss  ! state containing array elements to be allocated
  INTEGER, INTENT(IN) :: icdf  ! NetCDF file ID
  INTEGER, INTENT(IN) :: iout  ! LUN for messages
  INTEGER, INTENT(INOUT) :: iucount ! update count
  INTEGER, INTENT(INOUT) :: iertot  ! error count

  !-------------------

  INTEGER :: varid,status
  INTEGER :: ival,jval,ii
  INTEGER :: prehash1,prehash2
  INTEGER :: posthash1,posthash2
  CHARACTER*80 :: nc_errmsg
  LOGICAL :: izero

  !-------------------


  status = nf90_inq_varid(icdf,"velte_mmm71",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%velte_mmm71)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: velte_mmm71"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"velte_nclass",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%velte_nclass)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: velte_nclass"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"velte_neo",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%velte_neo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: velte_neo"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"velte_paleo",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%velte_paleo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: velte_paleo"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"velte_tglf",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%velte_tglf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: velte_tglf"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"velti_anom",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%velti_anom)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: velti_anom"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"velti_glf",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%velti_glf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: velti_glf"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"velti_gtcneo",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%velti_gtcneo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: velti_gtcneo"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"velti_mmm71",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%velti_mmm71)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: velti_mmm71"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"velti_nclass",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%velti_nclass)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: velti_nclass"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"velti_neo",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%velti_neo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: velti_neo"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"velti_tglf",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%velti_tglf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: velti_tglf"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"vie_trans",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%vie_trans)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: vie_trans"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"vie_transcat",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%vie_transcat)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: vie_transcat"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"vmo_trans",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%vmo_trans)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: vmo_trans"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"vmo_transcat",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%vmo_transcat)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: vmo_transcat"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"vn_trans",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%vn_trans)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: vn_trans"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"vn_transcat",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%vn_transcat)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: vn_transcat"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"vol",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%vol)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: vol"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"vphi0_av",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%vphi0_av)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: vphi0_av"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"vpol_Data_Info",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%vpol_Data_Info)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: vpol_Data_Info"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"vpol_inmp",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%vpol_inmp)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: vpol_inmp"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"vpol_is_input",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%vpol_is_input)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: vpol_is_input"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"vpol_omp",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%vpol_omp)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: vpol_omp"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"VRep_coil_count",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%VRep_coil_count)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: VRep_coil_count"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Vrep_coil_spacing",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%Vrep_coil_spacing)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: Vrep_coil_spacing"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Vsize_coil",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%Vsize_coil)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: Vsize_coil"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"vsur",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%vsur)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: vsur"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"VSUR_Data_Info",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%VSUR_Data_Info)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: VSUR_Data_Info"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"vtor_Data_Info",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%vtor_Data_Info)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: vtor_Data_Info"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"vtor_inmp",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%vtor_inmp)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: vtor_inmp"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"vtor_is_input",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%vtor_is_input)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: vtor_is_input"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"vtor_omp",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%vtor_omp)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: vtor_omp"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"V_loop",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%V_loop)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: V_loop"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"v_pars",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%v_pars)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: v_pars"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"v_pers",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%v_pers)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: v_pers"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"wt_nphi",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%wt_nphi)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: wt_nphi"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"wt_nphi_abs",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%wt_nphi_abs)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: wt_nphi_abs"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"wt_nphi_ext",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%wt_nphi_ext)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: wt_nphi_ext"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"xRjcos_momeq",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%xRjcos_momeq)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: xRjcos_momeq"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"xRjsin_momeq",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%xRjsin_momeq)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: xRjsin_momeq"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"xs",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%xs)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: xs"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"xs_name",varid)
  IF(status.EQ.NF90_NOERR) THEN
     CALL cchk_zero(ss%xs_name)
     status = nf90_get_var(icdf,varid,ss%xs_name)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: xs_name"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
     IF(.NOT.izero) THEN
        CALL cchk_hash("xs_name",ss%xs_name)
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"xZjcos_momeq",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%xZjcos_momeq)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: xZjcos_momeq"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"xZjsin_momeq",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%xZjsin_momeq)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: xZjsin_momeq"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Z0max",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%Z0max)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: Z0max"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Z0_momeq",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%Z0_momeq)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: Z0_momeq"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Zbap",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%Zbap)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: Zbap"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Zbsc",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%Zbsc)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: Zbsc"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Zeff",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%Zeff)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: Zeff"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"ZEFF_Data_Info",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%ZEFF_Data_Info)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: ZEFF_Data_Info"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Zeff_fi",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%Zeff_fi)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: Zeff_fi"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Zeff_th",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%Zeff_th)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: Zeff_th"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Zimp1",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%Zimp1)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: Zimp1"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Zimp2",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%Zimp2)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: Zimp2"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"zlim",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%zlim)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: zlim"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Zloc_coil",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%Zloc_coil)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: Zloc_coil"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Z_ant",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%Z_ant)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: Z_ant"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Z_antgeo",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%Z_antgeo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: Z_antgeo"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Z_axis",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%Z_axis)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: Z_axis"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Z_EC_launch",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%Z_EC_launch)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: Z_EC_launch"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Z_geo",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%Z_geo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: Z_geo"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Z_grid",varid)
  IF(status.EQ.NF90_NOERR) THEN
     CALL rchk_zero(ss%Z_grid)
     status = nf90_get_var(icdf,varid,ss%Z_grid)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: Z_grid"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
     IF(.NOT.izero) THEN
        CALL rchk_hash("Z_grid",ss%Z_grid)
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Z_max_box",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%Z_max_box)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: Z_max_box"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Z_max_lcfs",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%Z_max_lcfs)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: Z_max_lcfs"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Z_midp",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%Z_midp)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: Z_midp"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Z_mid_ant",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%Z_mid_ant)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: Z_mid_ant"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Z_min_box",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%Z_min_box)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: Z_min_box"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Z_min_lcfs",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%Z_min_lcfs)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: Z_min_lcfs"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Z_ripple",varid)
  IF(status.EQ.NF90_NOERR) THEN
     CALL rchk_zero(ss%Z_ripple)
     status = nf90_get_var(icdf,varid,ss%Z_ripple)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: Z_ripple"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
     IF(.NOT.izero) THEN
        CALL rchk_hash("Z_ripple",ss%Z_ripple)
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Z_surfMax",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%Z_surfMax)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: Z_surfMax"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Z_surfMin",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%Z_surfMin)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: Z_surfMin"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

CONTAINS

  subroutine ichk_zero(iarray)
     integer, dimension(:), intent(in) :: iarray

     integer :: ii

     izero=.TRUE.
     do ii=1,size(iarray)
        if(iarray(ii).ne.0) then
           izero=.FALSE.
           exit
        endif
     enddo

     if(.not.izero) then
        prehash1=17
        prehash2=23
        call hashCode(iarray,prehash1,prehash2)
     endif

  end subroutine ichk_zero

  subroutine rchk_zero(rarray)
     real(kind=rspec), dimension(:), intent(in) :: rarray

     integer :: ii

     izero=.TRUE.
     do ii=1,size(rarray)
        if(rarray(ii).ne.0.0_rspec) then
           izero=.FALSE.
           exit
        endif
     enddo

     if(.not.izero) then
        prehash1=17
        prehash2=23
        call hashCode(rarray,prehash1,prehash2)
     endif

  end subroutine rchk_zero

  subroutine cchk_zero(c32array)
     character*32, dimension(:), intent(in) :: c32array

     integer :: ii

     izero=.TRUE.
     do ii=1,size(c32array)
        if(c32array(ii).ne." ") then
           izero=.FALSE.
           exit
        endif
     enddo

     if(.not.izero) then
        prehash1=17
        prehash2=23
        call hashCode(c32array,prehash1,prehash2)
     endif

  end subroutine cchk_zero

  subroutine ichk_hash(itemName,iarray)
     character*(*), intent(in) :: itemName
     integer, dimension(:), intent(in) :: iarray

     posthash1=17
     posthash2=23
     call hashCode(iarray,posthash1,posthash2)

     if((prehash1.ne.posthash1).OR.(prehash2.ne.posthash2)) then
        write(iout,*) ' ?ps_update_file_read: value change detected in dimension quantity: '//trim(itemName)
        iertot = iertot + 1
     endif

  end subroutine ichk_hash

  subroutine rchk_hash(itemName,rarray)
     character*(*), intent(in) :: itemName
     real(kind=rspec), dimension(:), intent(in) :: rarray

     posthash1=17
     posthash2=23
     call hashCode(rarray,posthash1,posthash2)

     if((prehash1.ne.posthash1).OR.(prehash2.ne.posthash2)) then
        write(iout,*) ' ?ps_update_file_read: value change detected in dimension quantity: '//trim(itemName)
        iertot = iertot + 1
     endif

  end subroutine rchk_hash

  subroutine cchk_hash(itemName,c32array)
     character*(*), intent(in) :: itemName
     character*32, dimension(:), intent(in) :: c32array

     posthash1=17
     posthash2=23
     call hashCode(c32array,posthash1,posthash2)

     if((prehash1.ne.posthash1).OR.(prehash2.ne.posthash2)) then
        write(iout,*) ' ?ps_update_file_read: value change detected in dimension quantity: '//trim(itemName)
        iertot = iertot + 1
     endif

  end subroutine cchk_hash

  SUBROUTINE ichk_dim(ival,jval,dname)
     INTEGER, intent(in) :: ival  ! file dimension value
     INTEGER, intent(in) :: jval  ! state dimension value
     CHARACTER*(*), intent(in) :: dname

     IF(ival.ne.jval) THEN
        WRITE(iout,*) ' ?ps_update_file_read: update file dimension not consistent with state:'
        WRITE(iout,*) '  file value:  ',ival
        WRITE(iout,*) '  state value: ',jval
        WRITE(iout,*) '  dimension name: '//trim(dname)
        iertot = iertot + 1
     ENDIF
  END SUBROUTINE ichk_dim

  SUBROUTINE ncerr(status)
     INTEGER, INTENT(in) :: status

     nc_errmsg = NF90_strerror(status)
     write(iout,*) '  NetCDF message: ',trim(nc_errmsg)
  END SUBROUTINE ncerr

  SUBROUTINE denull(str)
     ! convert null characters to blank
     CHARACTER*(*) :: str
     INTEGER :: i

     do i=1,len(str)
        if(ichar(str(i:i)).eq.0) str(i:i)=' '
     enddo
  END SUBROUTINE denull

END SUBROUTINE ps_update_file_read_9

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


SUBROUTINE ps_update_file_write_def_2(ss,icdf,cclist,nids,iout,iwarn,iertot)


  ! Define updated data

  USE plasma_state_definition_mod
  USE netcdf
  USE ps_nidlist_defn
  IMPLICIT NONE

  TYPE (plasma_state) :: ss  ! state containing array elements to be allocated
  INTEGER, INTENT(IN) :: icdf  ! NetCDF file ID
  INTEGER, INTENT(IN) :: cclist(ps_ccount)  ! component selection
  TYPE (nidlist) :: nids       ! defined dimensions list
  INTEGER, INTENT(IN) :: iout  ! LUN for messages
  INTEGER, INTENT(INOUT) :: iwarn   ! warn count
  INTEGER, INTENT(INOUT) :: iertot  ! error count

  !-------------------
  LOGICAL :: plasma_state_hash_match,ichange

  INTEGER :: varid,pvarid,vvarid,dimid,status,iertmp,iaddr
  INTEGER :: idims(20),indim,ival,ii,ierr
  CHARACTER*80 :: nc_errmsg

  !-------------------

  ierr = 0   ! local

  iaddr = ps_shash_D_einj_standard
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%D_einj_standard).AND.ichange) THEN
     IF(cclist(ps_cnum_NBI).NE.1) THEN
        CALL ccwarn("D_einj_standard","NBI")
     ELSE
        indim = 0
        IF(nids%nid_dim_n_d_einj_standard.EQ.0) THEN
           CALL define_dim(nids%nid_dim_n_d_einj_standard,"dim_n_d_einj_standard",ss%n_d_einj_standard)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_n_d_einj_standard
        CALL define_var("D_einj_standard","R",indim,idims, &
               "D beam table energies", &
               "keV","NBI","MACHINE_DESCRIPTION", &
               "R|units=keV D_einj_standard(n_D_einj_standard)")
     ENDIF
  ENDIF

  iaddr = ps_shash_D_ffull_standard
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%D_ffull_standard).AND.ichange) THEN
     IF(cclist(ps_cnum_NBI).NE.1) THEN
        CALL ccwarn("D_ffull_standard","NBI")
     ELSE
        indim = 0
        IF(nids%nid_dim_n_d_einj_standard.EQ.0) THEN
           CALL define_dim(nids%nid_dim_n_d_einj_standard,"dim_n_d_einj_standard",ss%n_d_einj_standard)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_n_d_einj_standard
        CALL define_var("D_ffull_standard","R",indim,idims, &
               "D beam full energy fractions", &
               "-","NBI","MACHINE_DESCRIPTION", &
               "R|units=- D_ffull_standard(n_D_einj_standard)")
     ENDIF
  ENDIF

  iaddr = ps_shash_D_fhalf_standard
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%D_fhalf_standard).AND.ichange) THEN
     IF(cclist(ps_cnum_NBI).NE.1) THEN
        CALL ccwarn("D_fhalf_standard","NBI")
     ELSE
        indim = 0
        IF(nids%nid_dim_n_d_einj_standard.EQ.0) THEN
           CALL define_dim(nids%nid_dim_n_d_einj_standard,"dim_n_d_einj_standard",ss%n_d_einj_standard)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_n_d_einj_standard
        CALL define_var("D_fhalf_standard","R",indim,idims, &
               "D beam half energy fractions", &
               "-","NBI","MACHINE_DESCRIPTION", &
               "R|units=- D_fhalf_standard(n_D_einj_standard)")
     ENDIF
  ENDIF

  iaddr = ps_shash_e0_av
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%e0_av).AND.ichange) THEN
     IF(cclist(ps_cnum_GAS).NE.1) THEN
        CALL ccwarn("e0_av","GAS")
     ELSE
        indim = 0
        IF(nids%nid_dim_ngsc0.EQ.0) THEN
           CALL define_dim(nids%nid_dim_ngsc0,"dim_ngsc0",ss%ngsc0)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_ngsc0
        CALL define_var("e0_av","R",indim,idims, &
               'average energy of neutral sources, "(3/2)*T0"', &
               "KeV","GAS","STATE_DATA", &
               "R|units=KeV   e0_av(ngsc0)")
     ENDIF
  ENDIF

  iaddr = ps_dhash_necrf_src
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%ecrf_src_name).AND.ichange) THEN
     IF(cclist(ps_cnum_EC).NE.1) THEN
        CALL ccwarn("ecrf_src_name","EC")
     ELSE
        indim = 1
        idims(1)=nids%nid_clen_32
        IF(nids%nid_dim_necrf_src.EQ.0) THEN
           CALL define_dim(nids%nid_dim_necrf_src,"dim_necrf_src",ss%necrf_src)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_necrf_src
        CALL define_var("ecrf_src_name","N",indim,idims, &
               "number & name of ECRF sources", &
               "__NONE","EC","MACHINE_DESCRIPTION", &
               "L|ecrf_source   ecrf_src_name(necrf_src)")
     ENDIF
  ENDIF

  iaddr = ps_shash_EC_Beam_Elongation
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%EC_Beam_Elongation).AND.ichange) THEN
     IF(cclist(ps_cnum_EC).NE.1) THEN
        CALL ccwarn("EC_Beam_Elongation","EC")
     ELSE
        indim = 0
        IF(nids%nid_dim_necrf_src.EQ.0) THEN
           CALL define_dim(nids%nid_dim_necrf_src,"dim_necrf_src",ss%necrf_src)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_necrf_src
        CALL define_var("EC_Beam_Elongation","R",indim,idims, &
               "EC beam ellipticity", &
               "-","EC","MACHINE_DESCRIPTION", &
               "R|units=-   EC_Beam_Elongation(necrf_src)")
     ENDIF
  ENDIF

  iaddr = ps_shash_EC_Code_Info
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ichange) THEN
     IF(cclist(ps_cnum_EC).NE.1) THEN
        CALL ccwarn("EC_Code_Info","EC")
     ELSE
        indim = 1
        idims(1)=nids%nid_clen_80
        CALL define_var("EC_Code_Info","C*80",indim,idims, &
               "Information: code implementing EC component", &
               "__NONE","EC","SIMULATION_INIT", &
               "C*80   EC_Code_Info")
     ENDIF
  ENDIF

  iaddr = ps_shash_EC_Data_Info
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ichange) THEN
     IF(cclist(ps_cnum_EC).NE.1) THEN
        CALL ccwarn("EC_Data_Info","EC")
     ELSE
        indim = 1
        idims(1)=nids%nid_clen_80
        CALL define_var("EC_Data_Info","C*80",indim,idims, &
               "information on source of ECRF power data", &
               "__NONE","EC","SIMULATION_INIT", &
               "C*80   EC_Data_Info")
     ENDIF
  ENDIF

  iaddr = ps_shash_EC_Half_Power_Angle
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%EC_Half_Power_Angle).AND.ichange) THEN
     IF(cclist(ps_cnum_EC).NE.1) THEN
        CALL ccwarn("EC_Half_Power_Angle","EC")
     ELSE
        indim = 0
        IF(nids%nid_dim_necrf_src.EQ.0) THEN
           CALL define_dim(nids%nid_dim_necrf_src,"dim_necrf_src",ss%necrf_src)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_necrf_src
        CALL define_var("EC_Half_Power_Angle","R",indim,idims, &
               "Divergence of EC beam", &
               "degrees","EC","MACHINE_DESCRIPTION", &
               "R|units=degrees  EC_Half_Power_Angle(necrf_src)")
     ENDIF
  ENDIF

  iaddr = ps_shash_EC_Omode_Fraction
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%EC_Omode_Fraction).AND.ichange) THEN
     IF(cclist(ps_cnum_EC).NE.1) THEN
        CALL ccwarn("EC_Omode_Fraction","EC")
     ELSE
        indim = 0
        IF(nids%nid_dim_necrf_src.EQ.0) THEN
           CALL define_dim(nids%nid_dim_necrf_src,"dim_necrf_src",ss%necrf_src)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_necrf_src
        CALL define_var("EC_Omode_Fraction","R",indim,idims, &
               "O-mode fraction of EC source", &
               "-","EC","SHOT_CONFIGURATION", &
               "R|units=-   EC_Omode_Fraction(necrf_src)")
     ENDIF
  ENDIF

  iaddr = ps_shash_EC_phi_aim
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%EC_phi_aim).AND.ichange) THEN
     IF(cclist(ps_cnum_EC).NE.1) THEN
        CALL ccwarn("EC_phi_aim","EC")
     ELSE
        indim = 0
        IF(nids%nid_dim_necrf_src.EQ.0) THEN
           CALL define_dim(nids%nid_dim_necrf_src,"dim_necrf_src",ss%necrf_src)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_necrf_src
        CALL define_var("EC_phi_aim","R",indim,idims, &
               "toroidal aiming angle", &
               "degrees","EC","SHOT_CONFIGURATION", &
               "R|units=degrees  EC_phi_aim(necrf_src)")
     ENDIF
  ENDIF

  iaddr = ps_shash_EC_PRINC_CURV_HOR
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%EC_PRINC_CURV_HOR).AND.ichange) THEN
     IF(cclist(ps_cnum_EC).NE.1) THEN
        CALL ccwarn("EC_PRINC_CURV_HOR","EC")
     ELSE
        indim = 0
        IF(nids%nid_dim_necrf_src.EQ.0) THEN
           CALL define_dim(nids%nid_dim_necrf_src,"dim_necrf_src",ss%necrf_src)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_necrf_src
        CALL define_var("EC_PRINC_CURV_HOR","R",indim,idims, &
               "principal curvature in horizontal direction", &
               "m","EC","MACHINE_DESCRIPTION", &
               "R|units=m  EC_PRINC_CURV_HOR(necrf_src)")
     ENDIF
  ENDIF

  iaddr = ps_shash_EC_PRINC_CURV_VERT
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%EC_PRINC_CURV_VERT).AND.ichange) THEN
     IF(cclist(ps_cnum_EC).NE.1) THEN
        CALL ccwarn("EC_PRINC_CURV_VERT","EC")
     ELSE
        indim = 0
        IF(nids%nid_dim_necrf_src.EQ.0) THEN
           CALL define_dim(nids%nid_dim_necrf_src,"dim_necrf_src",ss%necrf_src)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_necrf_src
        CALL define_var("EC_PRINC_CURV_VERT","R",indim,idims, &
               "principal curvature in vertical direction", &
               "m","EC","MACHINE_DESCRIPTION", &
               "R|units=m  EC_PRINC_CURV_VERT(necrf_src)")
     ENDIF
  ENDIF

  iaddr = ps_shash_EC_PRINC_WIDTH_HOR
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%EC_PRINC_WIDTH_HOR).AND.ichange) THEN
     IF(cclist(ps_cnum_EC).NE.1) THEN
        CALL ccwarn("EC_PRINC_WIDTH_HOR","EC")
     ELSE
        indim = 0
        IF(nids%nid_dim_necrf_src.EQ.0) THEN
           CALL define_dim(nids%nid_dim_necrf_src,"dim_necrf_src",ss%necrf_src)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_necrf_src
        CALL define_var("EC_PRINC_WIDTH_HOR","R",indim,idims, &
               "principal beam width in horizontal direction", &
               "m","EC","MACHINE_DESCRIPTION", &
               "R|units=m  EC_PRINC_WIDTH_HOR(necrf_src)")
     ENDIF
  ENDIF

  iaddr = ps_shash_EC_PRINC_WIDTH_VERT
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%EC_PRINC_WIDTH_VERT).AND.ichange) THEN
     IF(cclist(ps_cnum_EC).NE.1) THEN
        CALL ccwarn("EC_PRINC_WIDTH_VERT","EC")
     ELSE
        indim = 0
        IF(nids%nid_dim_necrf_src.EQ.0) THEN
           CALL define_dim(nids%nid_dim_necrf_src,"dim_necrf_src",ss%necrf_src)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_necrf_src
        CALL define_var("EC_PRINC_WIDTH_VERT","R",indim,idims, &
               "principal beam width in vertical direction", &
               "m","EC","MACHINE_DESCRIPTION", &
               "R|units=m  EC_PRINC_WIDTH_VERT(necrf_src)")
     ENDIF
  ENDIF

  iaddr = ps_shash_EC_theta_aim
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%EC_theta_aim).AND.ichange) THEN
     IF(cclist(ps_cnum_EC).NE.1) THEN
        CALL ccwarn("EC_theta_aim","EC")
     ELSE
        indim = 0
        IF(nids%nid_dim_necrf_src.EQ.0) THEN
           CALL define_dim(nids%nid_dim_necrf_src,"dim_necrf_src",ss%necrf_src)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_necrf_src
        CALL define_var("EC_theta_aim","R",indim,idims, &
               "poloidal aiming angle", &
               "degrees","EC","SHOT_CONFIGURATION", &
               "R|units=degrees  EC_theta_aim(necrf_src)")
     ENDIF
  ENDIF

  iaddr = ps_phash_ee_mobility_factor
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%ee_mobility_factor).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("ee_mobility_factor","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        CALL define_var("ee_mobility_factor","R",indim,idims, &
               "chi_e/chi_i", &
               "-","ANOM","STATE_PROFILES", &
               "R|units=-|Hermite  ee_mobility_factor(nrho_anomth)")
     ENDIF
  ENDIF

  iaddr = ps_shash_Einj_max
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%Einj_max).AND.ichange) THEN
     IF(cclist(ps_cnum_NBI).NE.1) THEN
        CALL ccwarn("Einj_max","NBI")
     ELSE
        indim = 0
        IF(nids%nid_dim_nbeam.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nbeam,"dim_nbeam",ss%nbeam)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nbeam
        CALL define_var("Einj_max","R",indim,idims, &
               "maximum injection energy", &
               "keV","NBI","MACHINE_DESCRIPTION", &
               "R|units=keV       Einj_max(nbeam)")
     ENDIF
  ENDIF

  iaddr = ps_shash_Einj_min
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%Einj_min).AND.ichange) THEN
     IF(cclist(ps_cnum_NBI).NE.1) THEN
        CALL ccwarn("Einj_min","NBI")
     ELSE
        indim = 0
        IF(nids%nid_dim_nbeam.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nbeam,"dim_nbeam",ss%nbeam)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nbeam
        CALL define_var("Einj_min","R",indim,idims, &
               "minimum injection energy", &
               "keV","NBI","MACHINE_DESCRIPTION", &
               "R|units=keV       Einj_min(nbeam)")
     ENDIF
  ENDIF

  iaddr = ps_shash_eldot
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("eldot","PLASMA")
     ELSE
        indim = 0
        CALL define_var("eldot","R",indim,idims, &
               "[d(Philim)/dt]/[2*Philim]", &
               "1/sec","PLASMA","STATE_DATA", &
               "R|units=1/sec  eldot")
     ENDIF
  ENDIF

  iaddr = ps_phash_elong
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%elong).AND.ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("elong","EQ")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_eq_geo.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_eq_geo,"dim_nrho_eq_geo",ss%nrho_eq_geo)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_eq_geo
        CALL define_var("elong","R",indim,idims, &
               "elongation (b/a)", &
               "-","EQ","STATE_PROFILES", &
               "R|pclin  elong(nrho_eq_geo)")
     ENDIF
  ENDIF

  iaddr = ps_phash_eperp_beami
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%eperp_beami).AND.ichange) THEN
     IF(cclist(ps_cnum_NBI).NE.1) THEN
        CALL ccwarn("eperp_beami","NBI")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_nbi.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_nbi,"dm1_nrho_nbi",ss%nrho_nbi-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_nbi
        IF(nids%nid_dim_nspec_beam.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nspec_beam,"dim_nspec_beam",ss%nspec_beam)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nspec_beam
        CALL define_var("eperp_beami","R",indim,idims, &
               "beam species <Eperp>, lab frame", &
               "keV","NBI","STATE_PROFILES", &
               "R|units=keV|alias=eperp_|step*nbeami eperp_beami(~nrho_nbi,nspec_beam)")
     ENDIF
  ENDIF

  iaddr = ps_phash_eperp_fusi
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%eperp_fusi).AND.ichange) THEN
     IF(cclist(ps_cnum_FUS).NE.1) THEN
        CALL ccwarn("eperp_fusi","FUS")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_fus.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_fus,"dm1_nrho_fus",ss%nrho_fus-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_fus
        IF(nids%nid_dim_nspec_fusion.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nspec_fusion,"dim_nspec_fusion",ss%nspec_fusion)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nspec_fusion
        CALL define_var("eperp_fusi","R",indim,idims, &
               "fusion ion <Eperp>, lab frame", &
               "keV","FUS","STATE_PROFILES", &
               "R|units=keV|alias=eperp_|step*nfusi eperp_fusi(~nrho_fus,nspec_fusion)")
     ENDIF
  ENDIF

  iaddr = ps_phash_eperp_mini
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%eperp_mini).AND.ichange) THEN
     IF(cclist(ps_cnum_IC).NE.1) THEN
        CALL ccwarn("eperp_mini","IC")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_icrf.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_icrf,"dm1_nrho_icrf",ss%nrho_icrf-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_icrf
        IF(nids%nid_dim_nspec_rfmin.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nspec_rfmin,"dim_nspec_rfmin",ss%nspec_rfmin)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nspec_rfmin
        CALL define_var("eperp_mini","R",indim,idims, &
               "minority species <Eperp>, lab frame", &
               "keV","IC","STATE_PROFILES", &
               "R|units=keV|alias=eperp_|step*nmini eperp_mini(~nrho_icrf,nspec_rfmin)")
     ENDIF
  ENDIF

  iaddr = ps_phash_eperp_rw
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%eperp_rw).AND.ichange) THEN
     IF(cclist(ps_cnum_RUNAWAY).NE.1) THEN
        CALL ccwarn("eperp_rw","RUNAWAY")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_rw.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_rw,"dm1_nrho_rw",ss%nrho_rw-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_rw
        CALL define_var("eperp_rw","R",indim,idims, &
               "runaway electron <Eperp>", &
               "keV","RUNAWAY","STATE_PROFILES", &
               "R|units=keV|step*nrw  eperp_rw(~nrho_rw)")
     ENDIF
  ENDIF

  iaddr = ps_phash_epll_beami
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%epll_beami).AND.ichange) THEN
     IF(cclist(ps_cnum_NBI).NE.1) THEN
        CALL ccwarn("epll_beami","NBI")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_nbi.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_nbi,"dm1_nrho_nbi",ss%nrho_nbi-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_nbi
        IF(nids%nid_dim_nspec_beam.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nspec_beam,"dim_nspec_beam",ss%nspec_beam)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nspec_beam
        CALL define_var("epll_beami","R",indim,idims, &
               "beam species <Epll>, lab frame", &
               "keV","NBI","STATE_PROFILES", &
               "R|units=keV|alias=epll_|step*nbeami  epll_beami(~nrho_nbi,nspec_beam)")
     ENDIF
  ENDIF

  iaddr = ps_phash_epll_fusi
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%epll_fusi).AND.ichange) THEN
     IF(cclist(ps_cnum_FUS).NE.1) THEN
        CALL ccwarn("epll_fusi","FUS")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_fus.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_fus,"dm1_nrho_fus",ss%nrho_fus-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_fus
        IF(nids%nid_dim_nspec_fusion.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nspec_fusion,"dim_nspec_fusion",ss%nspec_fusion)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nspec_fusion
        CALL define_var("epll_fusi","R",indim,idims, &
               "fusion ion <Epll>, lab frame", &
               "keV","FUS","STATE_PROFILES", &
               "R|units=keV|alias=epll_|step*nfusi  epll_fusi(~nrho_fus,nspec_fusion)")
     ENDIF
  ENDIF

  iaddr = ps_phash_epll_mini
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%epll_mini).AND.ichange) THEN
     IF(cclist(ps_cnum_IC).NE.1) THEN
        CALL ccwarn("epll_mini","IC")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_icrf.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_icrf,"dm1_nrho_icrf",ss%nrho_icrf-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_icrf
        IF(nids%nid_dim_nspec_rfmin.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nspec_rfmin,"dim_nspec_rfmin",ss%nspec_rfmin)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nspec_rfmin
        CALL define_var("epll_mini","R",indim,idims, &
               "minority species <Epll>, lab frame", &
               "keV","IC","STATE_PROFILES", &
               "R|units=keV|alias=epll_|step*nmini  epll_mini(~nrho_icrf,nspec_rfmin)")
     ENDIF
  ENDIF

  iaddr = ps_phash_epll_rw
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%epll_rw).AND.ichange) THEN
     IF(cclist(ps_cnum_RUNAWAY).NE.1) THEN
        CALL ccwarn("epll_rw","RUNAWAY")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_rw.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_rw,"dm1_nrho_rw",ss%nrho_rw-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_rw
        CALL define_var("epll_rw","R",indim,idims, &
               "runaway electron <Epll>", &
               "keV","RUNAWAY","STATE_PROFILES", &
               "R|units=keV|step*nrw  epll_rw(~nrho_rw)")
     ENDIF
  ENDIF

  iaddr = ps_phash_Epot
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%Epot).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("Epot","PLASMA")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho,"dim_nrho",ss%nrho)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho
        CALL define_var("Epot","R",indim,idims, &
               "radial electrostatic potential", &
               "keV","PLASMA","STATE_PROFILES", &
               "R|units=keV|pclin  Epot(nrho)")
     ENDIF
  ENDIF

  iaddr = ps_shash_eqdsk_file
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("eqdsk_file","EQ")
     ELSE
        indim = 1
        idims(1)=nids%nid_clen_256
        CALL define_var("eqdsk_file","F",indim,idims, &
               "EFIT G-eqdsk file: psi(R,Z), g(psi), etc.", &
               "__NONE","EQ","STATE_DATA", &
               "F  eqdsk_file")
     ENDIF
  ENDIF

  iaddr = ps_dhash_neqmom
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%eqmom_num).AND.ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("eqmom_num","EQ")
     ELSE
        indim = 1
        idims(1)=nids%nid_clen_32
        IF(nids%nid_dim_neqmom.EQ.0) THEN
           CALL define_dim(nids%nid_dim_neqmom,"dim_neqmom",ss%neqmom)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_neqmom
        CALL define_var("eqmom_num","N",indim,idims, &
               "Equilibrium moments", &
               "__NONE","EQ","SIMULATION_INIT", &
               "L|EQ_moments  eqmom_num(neqmom)")
     ENDIF
  ENDIF

  iaddr = ps_shash_EQ_Code_Info
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("EQ_Code_Info","EQ")
     ELSE
        indim = 1
        idims(1)=nids%nid_clen_80
        CALL define_var("EQ_Code_Info","C*80",indim,idims, &
               "Information: code implementing EQ component", &
               "__NONE","EQ","SIMULATION_INIT", &
               "C*80   EQ_Code_Info")
     ENDIF
  ENDIF

  iaddr = ps_shash_EQ_Data_Info
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("EQ_Data_Info","EQ")
     ELSE
        indim = 1
        idims(1)=nids%nid_clen_80
        CALL define_var("EQ_Data_Info","C*80",indim,idims, &
               "Information: source of EQ input data", &
               "__NONE","EQ","SIMULATION_INIT", &
               "C*80   EQ_Data_Info")
     ENDIF
  ENDIF

  iaddr = ps_phash_eta_parallel
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%eta_parallel).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("eta_parallel","PLASMA")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho,"dim_nrho",ss%nrho)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho
        CALL define_var("eta_parallel","R",indim,idims, &
               "parallel electrical resistivity", &
               "ohm*m","PLASMA","STATE_PROFILES", &
               "R|units=ohm*m|Hermite eta_parallel(nrho)")
     ENDIF
  ENDIF

  iaddr = ps_dhash_nefi_anom
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%E_anom).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("E_anom","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nefi_anom.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nefi_anom,"dim_nefi_anom",ss%nefi_anom)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nefi_anom
        CALL define_var("E_anom","R",indim,idims, &
               "(optional) energy grid (1d profiles)", &
               "keV","ANOM","SIMULATION_INIT", &
               "G  E_anom(nefi_anom)")
     ENDIF
  ENDIF

  iaddr = ps_dhash_nefi_anom2
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%E_anom2).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("E_anom2","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nefi_anom2.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nefi_anom2,"dim_nefi_anom2",ss%nefi_anom2)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nefi_anom2
        CALL define_var("E_anom2","R",indim,idims, &
               "energy grid (2d anomalous transport profiles)", &
               "keV","ANOM","SIMULATION_INIT", &
               "G  E_anom2(nefi_anom2)")
     ENDIF
  ENDIF

  iaddr = ps_phash_fidiff_bpass_co
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%fidiff_bpass_co).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("fidiff_bpass_co","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nefi_anom2.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nefi_anom2,"dim_nefi_anom2",ss%nefi_anom2)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nefi_anom2
        IF(nids%nid_dim_nrho_anom2.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anom2,"dim_nrho_anom2",ss%nrho_anom2)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anom2
        IF(nids%nid_dim_nspec_fusion.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nspec_fusion,"dim_nspec_fusion",ss%nspec_fusion)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nspec_fusion
        CALL define_var("fidiff_bpass_co","R",indim,idims, &
               "fusion ion diffusivity: co barely passing orbits", &
               "m^2/sec","ANOM","STATE_PROFILES", &
               "R|units=m^2/sec|pclin  fidiff_bpass_co(nefi_anom2,nrho_anom2,nspec_fusion)")
     ENDIF
  ENDIF

  iaddr = ps_phash_fidiff_bpass_ctr
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%fidiff_bpass_ctr).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("fidiff_bpass_ctr","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nefi_anom2.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nefi_anom2,"dim_nefi_anom2",ss%nefi_anom2)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nefi_anom2
        IF(nids%nid_dim_nrho_anom2.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anom2,"dim_nrho_anom2",ss%nrho_anom2)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anom2
        IF(nids%nid_dim_nspec_fusion.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nspec_fusion,"dim_nspec_fusion",ss%nspec_fusion)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nspec_fusion
        CALL define_var("fidiff_bpass_ctr","R",indim,idims, &
               "fusion ion diffusivity: ctr barely passing orbits", &
               "m^2/sec","ANOM","STATE_PROFILES", &
               "R|units=m^2/sec|pclin  fidiff_bpass_ctr(nefi_anom2,nrho_anom2,nspec_fusion)")
     ENDIF
  ENDIF

  iaddr = ps_phash_fidiff_btrap
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%fidiff_btrap).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("fidiff_btrap","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nefi_anom2.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nefi_anom2,"dim_nefi_anom2",ss%nefi_anom2)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nefi_anom2
        IF(nids%nid_dim_nrho_anom2.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anom2,"dim_nrho_anom2",ss%nrho_anom2)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anom2
        IF(nids%nid_dim_nspec_fusion.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nspec_fusion,"dim_nspec_fusion",ss%nspec_fusion)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nspec_fusion
        CALL define_var("fidiff_btrap","R",indim,idims, &
               "fusion ion diffusivity: barely trapped orbits", &
               "m^2/sec","ANOM","STATE_PROFILES", &
               "R|units=m^2/sec|pclin  fidiff_btrap(nefi_anom2,nrho_anom2,nspec_fusion)")
     ENDIF
  ENDIF

  iaddr = ps_phash_fidiff_dpass_co
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%fidiff_dpass_co).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("fidiff_dpass_co","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nefi_anom2.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nefi_anom2,"dim_nefi_anom2",ss%nefi_anom2)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nefi_anom2
        IF(nids%nid_dim_nrho_anom2.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anom2,"dim_nrho_anom2",ss%nrho_anom2)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anom2
        IF(nids%nid_dim_nspec_fusion.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nspec_fusion,"dim_nspec_fusion",ss%nspec_fusion)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nspec_fusion
        CALL define_var("fidiff_dpass_co","R",indim,idims, &
               "fusion ion diffusivity: co passing |vpll/v| -> 1", &
               "m^2/sec","ANOM","STATE_PROFILES", &
               "R|units=m^2/sec|pclin  fidiff_dpass_co(nefi_anom2,nrho_anom2,nspec_fusion)")
     ENDIF
  ENDIF

  iaddr = ps_phash_fidiff_dpass_ctr
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%fidiff_dpass_ctr).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("fidiff_dpass_ctr","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nefi_anom2.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nefi_anom2,"dim_nefi_anom2",ss%nefi_anom2)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nefi_anom2
        IF(nids%nid_dim_nrho_anom2.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anom2,"dim_nrho_anom2",ss%nrho_anom2)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anom2
        IF(nids%nid_dim_nspec_fusion.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nspec_fusion,"dim_nspec_fusion",ss%nspec_fusion)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nspec_fusion
        CALL define_var("fidiff_dpass_ctr","R",indim,idims, &
               "fusion ion diffusivity: ctr passing |vpll/v| -> 1", &
               "m^2/sec","ANOM","STATE_PROFILES", &
               "R|units=m^2/sec|pclin  fidiff_dpass_ctr(nefi_anom2,nrho_anom2,nspec_fusion)")
     ENDIF
  ENDIF

  iaddr = ps_phash_fidiff_dtrap
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%fidiff_dtrap).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("fidiff_dtrap","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nefi_anom2.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nefi_anom2,"dim_nefi_anom2",ss%nefi_anom2)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nefi_anom2
        IF(nids%nid_dim_nrho_anom2.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anom2,"dim_nrho_anom2",ss%nrho_anom2)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anom2
        IF(nids%nid_dim_nspec_fusion.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nspec_fusion,"dim_nspec_fusion",ss%nspec_fusion)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nspec_fusion
        CALL define_var("fidiff_dtrap","R",indim,idims, &
               "fusion ion diffusivity: deeply trapped orbits", &
               "m^2/sec","ANOM","STATE_PROFILES", &
               "R|units=m^2/sec|pclin  fidiff_dtrap(nefi_anom2,nrho_anom2,nspec_fusion)")
     ENDIF
  ENDIF

  iaddr = ps_phash_Fi_depletion
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%Fi_depletion).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("Fi_depletion","PLASMA")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho,"dm1_nrho",ss%nrho-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho
        CALL define_var("Fi_depletion","R",indim,idims, &
               "fast ion depletion: sum[nj*Zj/ne]", &
               "-","PLASMA","STATE_PROFILES", &
               "R|units=-|step*ns(:,ps_elec_index) Fi_depletion(~nrho)")
     ENDIF
  ENDIF

  iaddr = ps_shash_fracmin
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%fracmin).AND.ichange) THEN
     IF(cclist(ps_cnum_IC).NE.1) THEN
        CALL ccwarn("fracmin","IC")
     ELSE
        indim = 0
        IF(nids%nid_dim_nspec_rfmin.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nspec_rfmin,"dim_nspec_rfmin",ss%nspec_rfmin)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nspec_rfmin
        CALL define_var("fracmin","R",indim,idims, &
               'minority density fraction if kdens_rfmin="fraction"', &
               "-","IC","SIMULATION_INIT", &
               "R|units=- fracmin(nspec_rfmin)")
     ENDIF
  ENDIF

  iaddr = ps_shash_fracpslh
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%fracpslh).AND.ichange) THEN
     IF(cclist(ps_cnum_LH).NE.1) THEN
        CALL ccwarn("fracpslh","LH")
     ELSE
        indim = 0
        IF(nids%nid_dim_max_nspectrumlh_src.EQ.0) THEN
           CALL define_dim(nids%nid_dim_max_nspectrumlh_src,"dim_max_nspectrumlh_src",ss%max_nspectrumlh_src)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_max_nspectrumlh_src
        IF(nids%nid_dim_nlhrf_src.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nlhrf_src,"dim_nlhrf_src",ss%nlhrf_src)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nlhrf_src
        CALL define_var("fracpslh","R",indim,idims, &
               "fraction of power on each peak (the sum over all peaks must be 1)", &
               "-","LH","SHOT_CONFIGURATION", &
               "R|units=- fracpslh(nspectrumlh_src(),nlhrf_src)")
     ENDIF
  ENDIF

  iaddr = ps_shash_frac_full
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%frac_full).AND.ichange) THEN
     IF(cclist(ps_cnum_NBI).NE.1) THEN
        CALL ccwarn("frac_full","NBI")
     ELSE
        indim = 0
        IF(nids%nid_dim_nbeam.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nbeam,"dim_nbeam",ss%nbeam)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nbeam
        CALL define_var("frac_full","R",indim,idims, &
               "fraction of beam current at full voltage", &
               "-","NBI","STATE_DATA", &
               "R|units=-  frac_full(nbeam)")
     ENDIF
  ENDIF

  iaddr = ps_shash_frac_half
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%frac_half).AND.ichange) THEN
     IF(cclist(ps_cnum_NBI).NE.1) THEN
        CALL ccwarn("frac_half","NBI")
     ELSE
        indim = 0
        IF(nids%nid_dim_nbeam.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nbeam,"dim_nbeam",ss%nbeam)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nbeam
        CALL define_var("frac_half","R",indim,idims, &
               "fraction of beam current at half voltage", &
               "-","NBI","STATE_DATA", &
               "R|units=-  frac_half(nbeam)")
     ENDIF
  ENDIF

  iaddr = ps_phash_freq_drbm
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%freq_drbm).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("freq_drbm","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        CALL define_var("freq_drbm","R",indim,idims, &
               "frequency from DRBM model", &
               "GB","ANOM","STATE_PROFILES", &
               "R|units=GB|pclin freq_drbm(nrho_anomth)")
     ENDIF
  ENDIF

  iaddr = ps_shash_freq_ec
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%freq_ec).AND.ichange) THEN
     IF(cclist(ps_cnum_EC).NE.1) THEN
        CALL ccwarn("freq_ec","EC")
     ELSE
        indim = 0
        IF(nids%nid_dim_necrf_src.EQ.0) THEN
           CALL define_dim(nids%nid_dim_necrf_src,"dim_necrf_src",ss%necrf_src)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_necrf_src
        CALL define_var("freq_ec","R",indim,idims, &
               "frequency of EC source", &
               "Hz","EC","SHOT_CONFIGURATION", &
               "R|units=Hz freq_ec(necrf_src)")
     ENDIF
  ENDIF

  iaddr = ps_phash_freq_glf
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%freq_glf).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("freq_glf","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        CALL define_var("freq_glf","R",indim,idims, &
               "frequency from GLF23 model", &
               "GB","ANOM","STATE_PROFILES", &
               "R|units=GB|pclin freq_glf(nrho_anomth)")
     ENDIF
  ENDIF

  iaddr = ps_shash_freq_ic
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%freq_ic).AND.ichange) THEN
     IF(cclist(ps_cnum_IC).NE.1) THEN
        CALL ccwarn("freq_ic","IC")
     ELSE
        indim = 0
        IF(nids%nid_dim_nicrf_src.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nicrf_src,"dim_nicrf_src",ss%nicrf_src)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nicrf_src
        CALL define_var("freq_ic","R",indim,idims, &
               "frequency on each ICRF source", &
               "Hz","IC","SHOT_CONFIGURATION", &
               "R|units=Hz freq_ic(nicrf_src)")
     ENDIF
  ENDIF

  iaddr = ps_shash_freq_lh
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%freq_lh).AND.ichange) THEN
     IF(cclist(ps_cnum_LH).NE.1) THEN
        CALL ccwarn("freq_lh","LH")
     ELSE
        indim = 0
        IF(nids%nid_dim_nlhrf_src.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nlhrf_src,"dim_nlhrf_src",ss%nlhrf_src)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nlhrf_src
        CALL define_var("freq_lh","R",indim,idims, &
               "frequency on each LHRF source", &
               "Hz","LH","SHOT_CONFIGURATION", &
               "R|units=Hz freq_lh(nlhrf_src)")
     ENDIF
  ENDIF

  iaddr = ps_phash_freq_max_tglf
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%freq_max_tglf).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("freq_max_tglf","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        CALL define_var("freq_max_tglf","R",indim,idims, &
               "frequency corresponding maximum growthrate from TGLF model", &
               "GB","ANOM","STATE_PROFILES", &
               "R|units=GB|pclin freq_max_tglf(nrho_anomth)")
     ENDIF
  ENDIF

  iaddr = ps_phash_freq_mmm71
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%freq_mmm71).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("freq_mmm71","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        IF(nids%nid_dim_nky_mmm.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nky_mmm,"dim_nky_mmm",ss%nky_mmm)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nky_mmm
        CALL define_var("freq_mmm71","R",indim,idims, &
               "frequency from mmm71 model", &
               "GB","ANOM","STATE_PROFILES", &
               "R|units=GB|pclin freq_mmm71(nrho_anomth,nky_mmm)")
     ENDIF
  ENDIF

  iaddr = ps_phash_freq_mtm
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%freq_mtm).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("freq_mtm","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        CALL define_var("freq_mtm","R",indim,idims, &
               "frequency from MTM model", &
               "rad/sec","ANOM","STATE_PROFILES", &
               "R|units=rad/sec|pclin freq_mtm(nrho_anomth)")
     ENDIF
  ENDIF

  iaddr = ps_phash_freq_tglf
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%freq_tglf).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("freq_tglf","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        IF(nids%nid_dim_nky_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nky_anomth,"dim_nky_anomth",ss%nky_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nky_anomth
        CALL define_var("freq_tglf","R",indim,idims, &
               "frequency from TGLF model", &
               "GB","ANOM","STATE_PROFILES", &
               "R|units=GB|pclin freq_tglf(nrho_anomth,nky_anomth)")
     ENDIF
  ENDIF

  iaddr = ps_shash_FUS_Code_Info
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ichange) THEN
     IF(cclist(ps_cnum_FUS).NE.1) THEN
        CALL ccwarn("FUS_Code_Info","FUS")
     ELSE
        indim = 1
        idims(1)=nids%nid_clen_80
        CALL define_var("FUS_Code_Info","C*80",indim,idims, &
               "Information: code implementing FUS component", &
               "__NONE","FUS","SIMULATION_INIT", &
               "C*80   FUS_Code_Info")
     ENDIF
  ENDIF

  iaddr = ps_shash_gamma_lmhd
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%gamma_lmhd).AND.ichange) THEN
     IF(cclist(ps_cnum_LMHD).NE.1) THEN
        CALL ccwarn("gamma_lmhd","LMHD")
     ELSE
        indim = 0
        IF(nids%nid_dim_mmodes.EQ.0) THEN
           CALL define_dim(nids%nid_dim_mmodes,"dim_mmodes",ss%mmodes)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_mmodes
        IF(nids%nid_dim_ndelta_w.EQ.0) THEN
           CALL define_dim(nids%nid_dim_ndelta_w,"dim_ndelta_w",ss%ndelta_w)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_ndelta_w
        CALL define_var("gamma_lmhd","R",indim,idims, &
               "ideal growth rate", &
               "-","LMHD","STATE_DATA", &
               "R|units=-  gamma_lmhd(mmodes,ndelta_W)")
     ENDIF
  ENDIF

  iaddr = ps_phash_gamma_nc
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%gamma_nc).AND.ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("gamma_nc","EQ")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_eq_geo.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_eq_geo,"dim_nrho_eq_geo",ss%nrho_eq_geo)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_eq_geo
        CALL define_var("gamma_nc","R",indim,idims, &
               "NC gamma", &
               "m^-1","EQ","STATE_PROFILES", &
               "R|units=m^-1|pclin   gamma_nc(nrho_eq_geo)")
     ENDIF
  ENDIF

  iaddr = ps_shash_gas_atom
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%gas_atom).AND.ichange) THEN
     IF(cclist(ps_cnum_GAS).NE.1) THEN
        CALL ccwarn("gas_atom","GAS")
     ELSE
        indim = 1
        idims(1)=nids%nid_clen_32
        IF(nids%nid_dim_ngsc0.EQ.0) THEN
           CALL define_dim(nids%nid_dim_ngsc0,"dim_ngsc0",ss%ngsc0)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_ngsc0
        CALL define_var("gas_atom","N",indim,idims, &
               "name of species introduced by each gas source", &
               "__NONE","GAS","SHOT_CONFIGURATION", &
               "N  gas_atom(ngsc0)")
     ENDIF
  ENDIF

  iaddr = ps_shash_GAS_Code_Info
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ichange) THEN
     IF(cclist(ps_cnum_GAS).NE.1) THEN
        CALL ccwarn("GAS_Code_Info","GAS")
     ELSE
        indim = 1
        idims(1)=nids%nid_clen_80
        CALL define_var("GAS_Code_Info","C*80",indim,idims, &
               "Information: code implementing GAS component", &
               "__NONE","GAS","SIMULATION_INIT", &
               "C*80   GAS_Code_Info")
     ENDIF
  ENDIF

  iaddr = ps_phash_gb1
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%gb1).AND.ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("gb1","EQ")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_eq_geo.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_eq_geo,"dim_nrho_eq_geo",ss%nrho_eq_geo)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_eq_geo
        CALL define_var("gb1","R",indim,idims, &
               "<|B|>", &
               "T","EQ","STATE_PROFILES", &
               "R|units=T|pclin      gb1(nrho_eq_geo)")
     ENDIF
  ENDIF

  iaddr = ps_phash_gb2
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%gb2).AND.ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("gb2","EQ")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_eq_geo.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_eq_geo,"dim_nrho_eq_geo",ss%nrho_eq_geo)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_eq_geo
        CALL define_var("gb2","R",indim,idims, &
               "<B^2>", &
               "T^2","EQ","STATE_PROFILES", &
               "R|units=T^2|pclin    gb2(nrho_eq_geo)")
     ENDIF
  ENDIF

  iaddr = ps_phash_gb2i
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%gb2i).AND.ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("gb2i","EQ")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_eq_geo.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_eq_geo,"dim_nrho_eq_geo",ss%nrho_eq_geo)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_eq_geo
        CALL define_var("gb2i","R",indim,idims, &
               "<1/B^2>", &
               "T^-2","EQ","STATE_PROFILES", &
               "R|units=T^-2|pclin   gb2i(nrho_eq_geo)")
     ENDIF
  ENDIF

  iaddr = ps_phash_gbr2
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%gbr2).AND.ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("gbr2","EQ")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_eq_geo.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_eq_geo,"dim_nrho_eq_geo",ss%nrho_eq_geo)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_eq_geo
        CALL define_var("gbr2","R",indim,idims, &
               "<|B|*R^2>", &
               "T*m^2","EQ","STATE_PROFILES", &
               "R|units=T*m^2|pclin  gbr2(nrho_eq_geo)")
     ENDIF
  ENDIF

  iaddr = ps_shash_geometry
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("geometry","EQ")
     ELSE
        indim = 1
        idims(1)=nids%nid_clen_256
        CALL define_var("geometry","F",indim,idims, &
               "path to file(s) vac. vessel & coil descr.", &
               "__NONE","EQ","MACHINE_DESCRIPTION", &
               "F  geometry")
     ENDIF
  ENDIF

  iaddr = ps_shash_Global_label
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("Global_label","PLASMA")
     ELSE
        indim = 1
        idims(1)=nids%nid_clen_80
        CALL define_var("Global_label","C*80",indim,idims, &
               "Run Label", &
               "__NONE","PLASMA","SIMULATION_INIT", &
               "C*80   Global_label")
     ENDIF
  ENDIF

  iaddr = ps_phash_gncfb2h
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%gncfb2h).AND.ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("gncfb2h","EQ")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_eq_geo.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_eq_geo,"dim_nrho_eq_geo",ss%nrho_eq_geo)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_eq_geo
        CALL define_var("gncfb2h","R",indim,idims, &
               "<(B^-2)*((1-H)^0.5-(1/3)*(1-H)^1.5)>; H=B/Bmax", &
               "T^-2","EQ","STATE_PROFILES", &
               "R|units=T^-2|pclin  gncfb2h(nrho_eq_geo)")
     ENDIF
  ENDIF

  iaddr = ps_phash_gncfh
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%gncfh).AND.ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("gncfh","EQ")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_eq_geo.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_eq_geo,"dim_nrho_eq_geo",ss%nrho_eq_geo)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_eq_geo
        CALL define_var("gncfh","R",indim,idims, &
               "<H^-2*(1-SQRT(1-H)*(1+H/2))>; H=B/Bmax", &
               "-","EQ","STATE_PROFILES", &
               "R|units=-|pclin  gncfh(nrho_eq_geo)")
     ENDIF
  ENDIF

  iaddr = ps_phash_gr1
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%gr1).AND.ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("gr1","EQ")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_eq_geo.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_eq_geo,"dim_nrho_eq_geo",ss%nrho_eq_geo)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_eq_geo
        CALL define_var("gr1","R",indim,idims, &
               "<R>", &
               "m","EQ","STATE_PROFILES", &
               "R|units=m|pclin   gr1(nrho_eq_geo)")
     ENDIF
  ENDIF

  iaddr = ps_phash_gr2
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%gr2).AND.ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("gr2","EQ")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_eq_geo.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_eq_geo,"dim_nrho_eq_geo",ss%nrho_eq_geo)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_eq_geo
        CALL define_var("gr2","R",indim,idims, &
               "<R^2>", &
               "m^2","EQ","STATE_PROFILES", &
               "R|units=m^2|pclin gr2(nrho_eq_geo)")
     ENDIF
  ENDIF

  iaddr = ps_phash_gr2i
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%gr2i).AND.ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("gr2i","EQ")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_eq_geo.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_eq_geo,"dim_nrho_eq_geo",ss%nrho_eq_geo)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_eq_geo
        CALL define_var("gr2i","R",indim,idims, &
               "<R^-2>", &
               "m^-2","EQ","STATE_PROFILES", &
               "R|units=m^-2|pclin gr2i(nrho_eq_geo)")
     ENDIF
  ENDIF

  iaddr = ps_phash_gr2rho2
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%gr2rho2).AND.ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("gr2rho2","EQ")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_eq_geo.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_eq_geo,"dim_nrho_eq_geo",ss%nrho_eq_geo)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_eq_geo
        CALL define_var("gr2rho2","R",indim,idims, &
               "<R^2*|grad(rho)|^2>", &
               "-","EQ","STATE_PROFILES", &
               "R|units=-|pclin gr2rho2(nrho_eq_geo)")
     ENDIF
  ENDIF

  iaddr = ps_phash_gr3i
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%gr3i).AND.ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("gr3i","EQ")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_eq_geo.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_eq_geo,"dim_nrho_eq_geo",ss%nrho_eq_geo)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_eq_geo
        CALL define_var("gr3i","R",indim,idims, &
               "<R^-3>", &
               "m^-3","EQ","STATE_PROFILES", &
               "R|units=m^-3|pclin gr3i(nrho_eq_geo)")
     ENDIF
  ENDIF

  iaddr = ps_phash_grho1
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%grho1).AND.ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("grho1","EQ")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_eq_geo.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_eq_geo,"dim_nrho_eq_geo",ss%nrho_eq_geo)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_eq_geo
        CALL define_var("grho1","R",indim,idims, &
               "<|grad(rho)|>", &
               "m^-1","EQ","STATE_PROFILES", &
               "R|units=m^-1|pclin grho1(nrho_eq_geo)")
     ENDIF
  ENDIF

  iaddr = ps_phash_grho2
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%grho2).AND.ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("grho2","EQ")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_eq_geo.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_eq_geo,"dim_nrho_eq_geo",ss%nrho_eq_geo)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_eq_geo
        CALL define_var("grho2","R",indim,idims, &
               "<|grad(rho)|^2>", &
               "m^-2","EQ","STATE_PROFILES", &
               "R|units=m^-2|pclin grho2(nrho_eq_geo)")
     ENDIF
  ENDIF
  CONTAINS


     SUBROUTINE define_dim(dimid,dname,idval)
        INTEGER, intent(out) :: dimid
        CHARACTER*(*), INTENT(in) :: dname
        INTEGER, intent(in) :: idval

        status = nf90_def_dim(icdf,dname,idval,dimid)
        IF(status.NE.NF90_NOERR) THEN
           WRITE(iout,*) ' ?ps_update_file_write: error defining dimension "'// &
                 trim(dname)//'".'
           IERR=9999
        ENDIF
     END SUBROUTINE define_dim



     SUBROUTINE define_var(name,dtype,indim,idims, &
          long_name,units,component,section,spec)

        CHARACTER*(*), INTENT(in) :: name
        CHARACTER*(*), INTENT(in) :: dtype
        INTEGER, INTENT(in) :: indim
        INTEGER, dimension(:), INTENT(in) :: idims
        CHARACTER*(*), INTENT(in) :: long_name
        CHARACTER*(*), INTENT(in) :: units
        CHARACTER*(*), INTENT(in) :: component
        CHARACTER*(*), INTENT(in) :: section
        CHARACTER*(*), INTENT(in) :: spec

        integer :: itype

        IF(dtype.EQ.'R') THEN
           itype = NF90_DOUBLE

        ELSE IF (dtype.EQ.'I') THEN
           itype = NF90_INT

        ELSE
           itype = NF90_CHAR

        ENDIF

        IF(indim.EQ.0) THEN
           status=nf90_def_var(icdf,name,itype, varid=varid)

        ELSE
           status=nf90_def_var(icdf,name,itype, dimids=idims(1:indim),varid=varid)

        ENDIF

        IF(status.NE.NF90_NOERR) THEN
           WRITE(iout,*) " ?plasma_state_store: error defining variable: "//trim(name)
           CALL ncerr(status)
           iertot = iertot + 1
           RETURN
        ENDIF

        ! Variable OK, now add attributes:

        CALL add_attrib("long_name",long_name)
        IF(dtype.EQ.'R') CALL add_attrib("units",units)
        CALL add_attrib("component",component)
        CALL add_attrib("section",section)
        CALL add_attrib("specification",spec)

     END SUBROUTINE define_var

     SUBROUTINE add_attrib(name,value)
        CHARACTER*(*), intent(in) :: name
        CHARACTER*(*), intent(in) :: value

        status=nf90_put_att(icdf,varid,name,value)
        IF(status.NE.NF90_NOERR) THEN
           WRITE(iout,*) " ?plasma_state_store: error defining attribute: "//trim(name)//' = '//trim(value)
           CALL ncerr(status)
           iertot = iertot + 1
        ENDIF
     END SUBROUTINE add_attrib



     SUBROUTINE ncerr(status)
        INTEGER, INTENT(in) :: status

        nc_errmsg = NF90_strerror(status)
        write(iout,*) '  NetCDF message: ',trim(nc_errmsg)
     END SUBROUTINE ncerr



     SUBROUTINE ccwarn(varnam,compnam)

        CHARACTER*(*), intent(in) :: varnam   ! name of variable or array
        CHARACTER*(*), intent(in) :: compnam  ! name of component

        if(iwarn.eq.0) then
           write(iout,*) ' '
           write(iout,*) ' %ps_update_file_write: modified state elements'
           write(iout,*) '  exist which were not written due to the "cclist"'
           write(iout,*) '  input variable which screens out elements from'
           write(iout,*) '  selected components: cclist = ',cclist,';'
           write(iout,*) '  element values of 1 indicate components that are'
           write(iout,*) '  enabled for write.'
           write(iout,*) ' '
        endif

        iwarn = iwarn + 1

        write(iout,*) ' %ps_update_file_write: modified: ss%'// &
             trim(varnam)//' ('//trim(compnam)//' component) NOT WRITTEN.'

     END SUBROUTINE ccwarn

END SUBROUTINE ps_update_file_write_def_2

SUBROUTINE ps_update_file_write_2(ss,icdf,cclist,iucount,iout,iwarn,iertot)


  ! Write updated data

  USE plasma_state_definition_mod
  USE netcdf
  IMPLICIT NONE

  TYPE (plasma_state) :: ss  ! state containing array elements to be allocated
  INTEGER, INTENT(IN) :: icdf  ! NetCDF file ID
  INTEGER, INTENT(IN) :: cclist(ps_ccount)  ! component selection
  INTEGER, INTENT(INOUT) :: iucount ! update count
  INTEGER, INTENT(IN) :: iout  ! LUN for messages
  INTEGER, INTENT(INOUT) :: iwarn   ! warn count
  INTEGER, INTENT(INOUT) :: iertot  ! error count

  !-------------------

  INTEGER :: varid,status
  CHARACTER*80 :: nc_errmsg

  !-------------------


  status = nf90_inq_varid(icdf,"D_einj_standard",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%D_einj_standard)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: D_einj_standard"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"D_ffull_standard",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%D_ffull_standard)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: D_ffull_standard"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"D_fhalf_standard",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%D_fhalf_standard)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: D_fhalf_standard"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"e0_av",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%e0_av)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: e0_av"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"ecrf_src_name",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%ecrf_src_name)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: ecrf_src_name"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"EC_Beam_Elongation",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%EC_Beam_Elongation)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: EC_Beam_Elongation"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"EC_Code_Info",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%EC_Code_Info)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: EC_Code_Info"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"EC_Data_Info",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%EC_Data_Info)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: EC_Data_Info"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"EC_Half_Power_Angle",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%EC_Half_Power_Angle)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: EC_Half_Power_Angle"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"EC_Omode_Fraction",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%EC_Omode_Fraction)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: EC_Omode_Fraction"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"EC_phi_aim",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%EC_phi_aim)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: EC_phi_aim"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"EC_PRINC_CURV_HOR",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%EC_PRINC_CURV_HOR)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: EC_PRINC_CURV_HOR"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"EC_PRINC_CURV_VERT",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%EC_PRINC_CURV_VERT)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: EC_PRINC_CURV_VERT"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"EC_PRINC_WIDTH_HOR",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%EC_PRINC_WIDTH_HOR)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: EC_PRINC_WIDTH_HOR"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"EC_PRINC_WIDTH_VERT",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%EC_PRINC_WIDTH_VERT)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: EC_PRINC_WIDTH_VERT"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"EC_theta_aim",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%EC_theta_aim)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: EC_theta_aim"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"ee_mobility_factor",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%ee_mobility_factor)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: ee_mobility_factor"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Einj_max",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%Einj_max)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: Einj_max"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Einj_min",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%Einj_min)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: Einj_min"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"eldot",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%eldot)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: eldot"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"elong",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%elong)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: elong"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"eperp_beami",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%eperp_beami)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: eperp_beami"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"eperp_fusi",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%eperp_fusi)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: eperp_fusi"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"eperp_mini",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%eperp_mini)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: eperp_mini"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"eperp_rw",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%eperp_rw)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: eperp_rw"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"epll_beami",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%epll_beami)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: epll_beami"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"epll_fusi",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%epll_fusi)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: epll_fusi"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"epll_mini",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%epll_mini)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: epll_mini"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"epll_rw",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%epll_rw)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: epll_rw"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Epot",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%Epot)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: Epot"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"eqdsk_file",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%eqdsk_file)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: eqdsk_file"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"eqmom_num",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%eqmom_num)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: eqmom_num"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"EQ_Code_Info",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%EQ_Code_Info)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: EQ_Code_Info"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"EQ_Data_Info",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%EQ_Data_Info)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: EQ_Data_Info"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"eta_parallel",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%eta_parallel)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: eta_parallel"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"E_anom",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%E_anom)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: E_anom"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"E_anom2",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%E_anom2)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: E_anom2"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"fidiff_bpass_co",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%fidiff_bpass_co)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: fidiff_bpass_co"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"fidiff_bpass_ctr",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%fidiff_bpass_ctr)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: fidiff_bpass_ctr"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"fidiff_btrap",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%fidiff_btrap)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: fidiff_btrap"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"fidiff_dpass_co",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%fidiff_dpass_co)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: fidiff_dpass_co"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"fidiff_dpass_ctr",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%fidiff_dpass_ctr)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: fidiff_dpass_ctr"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"fidiff_dtrap",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%fidiff_dtrap)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: fidiff_dtrap"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Fi_depletion",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%Fi_depletion)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: Fi_depletion"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"fracmin",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%fracmin)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: fracmin"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"fracpslh",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%fracpslh)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: fracpslh"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"frac_full",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%frac_full)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: frac_full"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"frac_half",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%frac_half)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: frac_half"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"freq_drbm",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%freq_drbm)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: freq_drbm"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"freq_ec",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%freq_ec)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: freq_ec"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"freq_glf",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%freq_glf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: freq_glf"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"freq_ic",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%freq_ic)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: freq_ic"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"freq_lh",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%freq_lh)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: freq_lh"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"freq_max_tglf",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%freq_max_tglf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: freq_max_tglf"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"freq_mmm71",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%freq_mmm71)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: freq_mmm71"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"freq_mtm",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%freq_mtm)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: freq_mtm"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"freq_tglf",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%freq_tglf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: freq_tglf"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"FUS_Code_Info",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%FUS_Code_Info)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: FUS_Code_Info"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"gamma_lmhd",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%gamma_lmhd)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: gamma_lmhd"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"gamma_nc",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%gamma_nc)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: gamma_nc"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"gas_atom",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%gas_atom)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: gas_atom"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"GAS_Code_Info",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%GAS_Code_Info)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: GAS_Code_Info"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"gb1",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%gb1)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: gb1"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"gb2",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%gb2)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: gb2"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"gb2i",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%gb2i)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: gb2i"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"gbr2",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%gbr2)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: gbr2"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"geometry",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%geometry)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: geometry"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Global_label",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%Global_label)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: Global_label"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"gncfb2h",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%gncfb2h)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: gncfb2h"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"gncfh",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%gncfh)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: gncfh"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"gr1",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%gr1)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: gr1"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"gr2",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%gr2)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: gr2"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"gr2i",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%gr2i)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: gr2i"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"gr2rho2",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%gr2rho2)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: gr2rho2"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"gr3i",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%gr3i)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: gr3i"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"grho1",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%grho1)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: grho1"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"grho2",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%grho2)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: grho2"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF
  CONTAINS


     SUBROUTINE ncerr(status)
        INTEGER, INTENT(in) :: status

        nc_errmsg = NF90_strerror(status)
        write(iout,*) '  NetCDF message: ',trim(nc_errmsg)
     END SUBROUTINE ncerr

END SUBROUTINE ps_update_file_write_2

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_t3_dummy
     return
  end subroutine ccps_getset_t3_dummy

subroutine psget_t_ffull_standard(iobj, n1, data, ierr)
    !! T beam full energy fractions
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_t_ffull_standard', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % T_ffull_standard
end subroutine psget_t_ffull_standard


subroutine psset_t_ffull_standard(iobj, n1, data, ierr)
    !! T beam full energy fractions
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_t_ffull_standard', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % T_ffull_standard = data(1:n1)
end subroutine psset_t_ffull_standard


subroutine psgetrnk_t_ffull_standard(iobj, ndims, ierr)
    !! T beam full energy fractions
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_t_ffull_standard


subroutine psgetdim_t_ffull_standard(iobj, ndims, dims, ierr)
    !! T beam full energy fractions
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_t_ffull_standard', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % T_ffull_standard ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % T_ffull_standard)
    endif
end subroutine psgetdim_t_ffull_standard


subroutine psget_tinit(iobj, data, ierr)
    !! start time of simulation
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_tinit', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % tinit
end subroutine psget_tinit


subroutine psset_tinit(iobj, data, ierr)
    !! start time of simulation
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_tinit', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % tinit = data
end subroutine psset_tinit


subroutine psget_th_eq(iobj, n1, data, ierr)
    !! theta grid (EQ)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_th_eq', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % th_eq
end subroutine psget_th_eq


subroutine psset_th_eq(iobj, n1, data, ierr)
    !! theta grid (EQ)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_th_eq', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % th_eq = data(1:n1)
end subroutine psset_th_eq


subroutine psgetrnk_th_eq(iobj, ndims, ierr)
    !! theta grid (EQ)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_th_eq


subroutine psgetdim_th_eq(iobj, ndims, dims, ierr)
    !! theta grid (EQ)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_th_eq', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % th_eq ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % th_eq)
    endif
end subroutine psgetdim_th_eq


subroutine psget_ti(iobj, n1, data, ierr)
    !! ion temperature, single profile for all thermal, ion
    !! species; should be consistent, with ns & Ts
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_ti', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % Ti
end subroutine psget_ti


subroutine psset_ti(iobj, n1, data, ierr)
    !! ion temperature, single profile for all thermal, ion
    !! species; should be consistent, with ns & Ts
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_ti', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % Ti = data(1:n1)
end subroutine psset_ti


subroutine psgetrnk_ti(iobj, ndims, ierr)
    !! ion temperature, single profile for all thermal, ion
    !! species; should be consistent, with ns & Ts
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_ti


subroutine psgetdim_ti(iobj, ndims, dims, ierr)
    !! ion temperature, single profile for all thermal, ion
    !! species; should be consistent, with ns & Ts
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_ti', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % Ti ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % Ti)
    endif
end subroutine psgetdim_ti


subroutine psget_tqbe(iobj, n1, data, ierr)
    !! collisional beam torque to electrons
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_tqbe', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % tqbe
end subroutine psget_tqbe


subroutine psset_tqbe(iobj, n1, data, ierr)
    !! collisional beam torque to electrons
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_tqbe', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % tqbe = data(1:n1)
end subroutine psset_tqbe


subroutine psgetrnk_tqbe(iobj, ndims, ierr)
    !! collisional beam torque to electrons
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_tqbe


subroutine psgetdim_tqbe(iobj, ndims, dims, ierr)
    !! collisional beam torque to electrons
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_tqbe', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % tqbe ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % tqbe)
    endif
end subroutine psgetdim_tqbe


subroutine psget_t0cx(iobj, n1, n2, data, ierr)
    !! effective neutral temperature for CX power, (use with qqcx)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_t0cx', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % T0cx
end subroutine psget_t0cx


subroutine psset_t0cx(iobj, n1, n2, data, ierr)
    !! effective neutral temperature for CX power, (use with qqcx)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_t0cx', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % T0cx = data(1:n1, 1: n2)
end subroutine psset_t0cx


subroutine psgetrnk_t0cx(iobj, ndims, ierr)
    !! effective neutral temperature for CX power, (use with qqcx)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_t0cx


subroutine psgetdim_t0cx(iobj, ndims, dims, ierr)
    !! effective neutral temperature for CX power, (use with qqcx)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_t0cx', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % T0cx ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % T0cx)
    endif
end subroutine psgetdim_t0cx


subroutine psget_tfrip_log(iobj, n1, n2, data, ierr)
    !! TF ripple: log((Bmax-Bmin)/(Bmax+Bmin)), This field is
    !! likely time invariant,, an attribute of the tokamak TF coils.
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_tfrip_log', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % tfrip_log
end subroutine psget_tfrip_log


subroutine psset_tfrip_log(iobj, n1, n2, data, ierr)
    !! TF ripple: log((Bmax-Bmin)/(Bmax+Bmin)), This field is
    !! likely time invariant,, an attribute of the tokamak TF coils.
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_tfrip_log', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % tfrip_log = data(1:n1, 1: n2)
end subroutine psset_tfrip_log


subroutine psgetrnk_tfrip_log(iobj, ndims, ierr)
    !! TF ripple: log((Bmax-Bmin)/(Bmax+Bmin)), This field is
    !! likely time invariant,, an attribute of the tokamak TF coils.
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_tfrip_log


subroutine psgetdim_tfrip_log(iobj, ndims, dims, ierr)
    !! TF ripple: log((Bmax-Bmin)/(Bmax+Bmin)), This field is
    !! likely time invariant,, an attribute of the tokamak TF coils.
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_tfrip_log', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % tfrip_log ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % tfrip_log)
    endif
end subroutine psgetdim_tfrip_log


subroutine psget_ti_ky_tglf(iobj, n1, n2, data, ierr)
    !! ion density fluctuation spectrum
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_ti_ky_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % ti_ky_tglf
end subroutine psget_ti_ky_tglf


subroutine psset_ti_ky_tglf(iobj, n1, n2, data, ierr)
    !! ion density fluctuation spectrum
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_ti_ky_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % ti_ky_tglf = data(1:n1, 1: n2)
end subroutine psset_ti_ky_tglf


subroutine psgetrnk_ti_ky_tglf(iobj, ndims, ierr)
    !! ion density fluctuation spectrum
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_ti_ky_tglf


subroutine psgetdim_ti_ky_tglf(iobj, ndims, dims, ierr)
    !! ion density fluctuation spectrum
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_ti_ky_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % ti_ky_tglf ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % ti_ky_tglf)
    endif
end subroutine psgetdim_ti_ky_tglf

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_n7_dummy
     return
  end subroutine ccps_getset_n7_dummy

subroutine psget_ntf_coil2(iobj, data, ierr)
    !! number of TF coils involved in inducing 2nd component, of TF
    !! ripple field (typically ntf_coil2 = ntf_coils/2)., (This 2nd TF
    !! ripple field is sometimes introduced in, tokamak experiments to
    !! study the effects of TF ripple, induced fast ion loss).
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_ntf_coil2', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % ntf_coil2
end subroutine psget_ntf_coil2


subroutine psset_ntf_coil2(iobj, data, ierr)
    !! number of TF coils involved in inducing 2nd component, of TF
    !! ripple field (typically ntf_coil2 = ntf_coils/2)., (This 2nd TF
    !! ripple field is sometimes introduced in, tokamak experiments to
    !! study the effects of TF ripple, induced fast ion loss).
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_ntf_coil2', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % ntf_coil2 = data
end subroutine psset_ntf_coil2


subroutine psget_nspec_fusion(iobj, data, ierr)
    !! species list dimension of SFUS (fusion_ion)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_nspec_fusion', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % nspec_fusion
end subroutine psget_nspec_fusion


subroutine psset_nspec_fusion(iobj, data, ierr)
    !! species list dimension of SFUS (fusion_ion)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_nspec_fusion', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % nspec_fusion = data
end subroutine psset_nspec_fusion


subroutine psget_nspectrumlh_src(iobj, n1, data, ierr)
    !! number of spectrum peaks
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_nspectrumlh_src', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % nspectrumlh_src
end subroutine psget_nspectrumlh_src


subroutine psset_nspectrumlh_src(iobj, n1, data, ierr)
    !! number of spectrum peaks
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_nspectrumlh_src', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % nspectrumlh_src = data(1:n1)
end subroutine psset_nspectrumlh_src


subroutine psgetrnk_nspectrumlh_src(iobj, ndims, ierr)
    !! number of spectrum peaks
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_nspectrumlh_src


subroutine psgetdim_nspectrumlh_src(iobj, ndims, dims, ierr)
    !! number of spectrum peaks
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_nspectrumlh_src', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % nspectrumlh_src ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % nspectrumlh_src)
    endif
end subroutine psgetdim_nspectrumlh_src


subroutine psget_nbi_code_info(iobj, data, ierr)
    !! Information: code implementing NBI component
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    CHARACTER*(*), intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_nbi_code_info', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % NBI_Code_Info
end subroutine psget_nbi_code_info


subroutine psset_nbi_code_info(iobj, data, ierr)
    !! Information: code implementing NBI component
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    CHARACTER*(*), intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_nbi_code_info', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % NBI_Code_Info = data
end subroutine psset_nbi_code_info


subroutine psgetsz_nbi_code_info(iobj, size, ierr)
    !! Information: code implementing NBI component
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: size    ! size of character string
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psgetsz_nbi_code_info', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! note that the following will return the character length size regardless of
    ! the number of array elements (if NBI_Code_Info is an array)
    size = len(ss % NBI_Code_Info)
end subroutine psgetsz_nbi_code_info


subroutine psget_nspec_imp0(iobj, data, ierr)
    !! species list dimension of SIMP0 (impurity_atoms)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_nspec_imp0', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % nspec_imp0
end subroutine psget_nspec_imp0


subroutine psset_nspec_imp0(iobj, data, ierr)
    !! species list dimension of SIMP0 (impurity_atoms)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_nspec_imp0', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % nspec_imp0 = data
end subroutine psset_nspec_imp0


subroutine psget_ntrcat(iobj, data, ierr)
    !! item list dimension of trcat (TR_categories)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_ntrcat', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % ntrcat
end subroutine psget_ntrcat


subroutine psset_ntrcat(iobj, data, ierr)
    !! item list dimension of trcat (TR_categories)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_ntrcat', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % ntrcat = data
end subroutine psset_ntrcat


subroutine psget_nrho_fus(iobj, data, ierr)
    !! grid dimension of rho_fus (RHO coordinate)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_nrho_fus', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % nrho_fus
end subroutine psget_nrho_fus


subroutine psset_nrho_fus(iobj, data, ierr)
    !! grid dimension of rho_fus (RHO coordinate)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_nrho_fus', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % nrho_fus = data
end subroutine psset_nrho_fus


subroutine psget_nrho_pel(iobj, data, ierr)
    !! grid dimension of rho_pel (RHO coordinate)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_nrho_pel', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % nrho_pel
end subroutine psget_nrho_pel


subroutine psset_nrho_pel(iobj, data, ierr)
    !! grid dimension of rho_pel (RHO coordinate)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_nrho_pel', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % nrho_pel = data
end subroutine psset_nrho_pel


subroutine psget_nrho_lmhd(iobj, data, ierr)
    !! grid dimension of rho_lmhd (RHO coordinate)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_nrho_lmhd', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % nrho_lmhd
end subroutine psget_nrho_lmhd


subroutine psset_nrho_lmhd(iobj, data, ierr)
    !! grid dimension of rho_lmhd (RHO coordinate)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_nrho_lmhd', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % nrho_lmhd = data
end subroutine psset_nrho_lmhd


subroutine psget_nky_mmm(iobj, data, ierr)
    !! number of points, ky grid for MMM model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_nky_mmm', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % nky_mmm
end subroutine psget_nky_mmm


subroutine psset_nky_mmm(iobj, data, ierr)
    !! number of points, ky grid for MMM model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_nky_mmm', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % nky_mmm = data
end subroutine psset_nky_mmm


subroutine psget_newcomb_status(iobj, n1, data, ierr)
    !! completion status: Newcomb codes
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_newcomb_status', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % Newcomb_status
end subroutine psget_newcomb_status


subroutine psset_newcomb_status(iobj, n1, data, ierr)
    !! completion status: Newcomb codes
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_newcomb_status', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % Newcomb_status = data(1:n1)
end subroutine psset_newcomb_status


subroutine psgetrnk_newcomb_status(iobj, ndims, ierr)
    !! completion status: Newcomb codes
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_newcomb_status


subroutine psgetdim_newcomb_status(iobj, ndims, dims, ierr)
    !! completion status: Newcomb codes
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_newcomb_status', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % Newcomb_status ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % Newcomb_status)
    endif
end subroutine psgetdim_newcomb_status


subroutine psget_nmodel_bdy(iobj, data, ierr)
    !! model density, boundary value
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_nmodel_bdy', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % nmodel_bdy
end subroutine psget_nmodel_bdy


subroutine psset_nmodel_bdy(iobj, data, ierr)
    !! model density, boundary value
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_nmodel_bdy', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % nmodel_bdy = data
end subroutine psset_nmodel_bdy


subroutine psget_n0norm(iobj, n1, n2, n3, data, ierr)
    !! neutral density per unit gas influx (sc0), for each neutral
    !! specie due to each source
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2, n3 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2, n3) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_n0norm', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2, 1: n3) = ss % n0norm
end subroutine psget_n0norm


subroutine psset_n0norm(iobj, n1, n2, n3, data, ierr)
    !! neutral density per unit gas influx (sc0), for each neutral
    !! specie due to each source
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2, n3 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2, n3) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_n0norm', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % n0norm = data(1:n1, 1: n2, 1: n3)
end subroutine psset_n0norm


subroutine psgetrnk_n0norm(iobj, ndims, ierr)
    !! neutral density per unit gas influx (sc0), for each neutral
    !! specie due to each source
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 3
end subroutine psgetrnk_n0norm


subroutine psgetdim_n0norm(iobj, ndims, dims, ierr)
    !! neutral density per unit gas influx (sc0), for each neutral
    !! specie due to each source
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 3) ierr = 1
    call ccps_argcheck('psgetdim_n0norm', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % n0norm ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % n0norm)
    endif
end subroutine psgetdim_n0norm


subroutine psget_nzflux_ky_tglf(iobj, n1, n2, data, ierr)
    !! impurity density flux spectrum
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_nzflux_ky_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % nzflux_ky_tglf
end subroutine psget_nzflux_ky_tglf


subroutine psset_nzflux_ky_tglf(iobj, n1, n2, data, ierr)
    !! impurity density flux spectrum
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_nzflux_ky_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % nzflux_ky_tglf = data(1:n1, 1: n2)
end subroutine psset_nzflux_ky_tglf


subroutine psgetrnk_nzflux_ky_tglf(iobj, ndims, ierr)
    !! impurity density flux spectrum
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_nzflux_ky_tglf


subroutine psgetdim_nzflux_ky_tglf(iobj, ndims, dims, ierr)
    !! impurity density flux spectrum
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_nzflux_ky_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % nzflux_ky_tglf ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % nzflux_ky_tglf)
    endif
end subroutine psgetdim_nzflux_ky_tglf

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


SUBROUTINE plasma_state_contents_profs_3(itype,icomponent,ss,w,isize)


  ! fill window structure with requested table of contents

  USE plasma_state_mod
  IMPLICIT NONE

  INTEGER, INTENT(IN) :: itype   ! type of table of contents
                                 ! values such as ps_grid_dims or ps_profiles

  INTEGER, INTENT(IN) :: icomponent(ps_ccount) ! component flags
             ! icomponent(j).eq.1 => component j active
             ! e.g. icomponent(ps_cnum_EQ).eq.1 => EQ component is active

  TYPE (plasma_state) :: ss      ! state examined
  TYPE (ps_list_window) :: w     ! list window structure filled

  INTEGER, INTENT(INOUT) :: isize  ! incremented size...

  !----------------

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! Fi_depletion
        w%list_elems(isize) = "Fi_depletion"
        w%elem_descr(isize) = "fast ion depletion: sum[nj*Zj/ne]"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "-"
        w%c256val(isize) = "(nrho-1)"
        IF(ALLOCATED(ss%Fi_depletion)) THEN
           IF(ss%hash_codes(ps_phash_Fi_depletion).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*NS(:,PS_ELEC_INDEX)"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! freq_drbm
        w%list_elems(isize) = "freq_drbm"
        w%elem_descr(isize) = "frequency from DRBM model"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "GB"
        w%c256val(isize) = "(nrho_anomth)"
        IF(ALLOCATED(ss%freq_drbm)) THEN
           IF(ss%hash_codes(ps_phash_freq_drbm).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! freq_glf
        w%list_elems(isize) = "freq_glf"
        w%elem_descr(isize) = "frequency from GLF23 model"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "GB"
        w%c256val(isize) = "(nrho_anomth)"
        IF(ALLOCATED(ss%freq_glf)) THEN
           IF(ss%hash_codes(ps_phash_freq_glf).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! freq_max_tglf
        w%list_elems(isize) = "freq_max_tglf"
        w%elem_descr(isize) = "frequency corresponding maximum growthrate from TGLF model"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "GB"
        w%c256val(isize) = "(nrho_anomth)"
        IF(ALLOCATED(ss%freq_max_tglf)) THEN
           IF(ss%hash_codes(ps_phash_freq_max_tglf).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! freq_mmm71
        w%list_elems(isize) = "freq_mmm71"
        w%elem_descr(isize) = "frequency from mmm71 model"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "GB"
        w%c256val(isize) = "(nrho_anomth,nky_mmm)"
        IF(ALLOCATED(ss%freq_mmm71)) THEN
           IF(ss%hash_codes(ps_phash_freq_mmm71).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! freq_mtm
        w%list_elems(isize) = "freq_mtm"
        w%elem_descr(isize) = "frequency from MTM model"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "rad/sec"
        w%c256val(isize) = "(nrho_anomth)"
        IF(ALLOCATED(ss%freq_mtm)) THEN
           IF(ss%hash_codes(ps_phash_freq_mtm).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! freq_tglf
        w%list_elems(isize) = "freq_tglf"
        w%elem_descr(isize) = "frequency from TGLF model"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "GB"
        w%c256val(isize) = "(nrho_anomth,nky_anomth)"
        IF(ALLOCATED(ss%freq_tglf)) THEN
           IF(ss%hash_codes(ps_phash_freq_tglf).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! gamma_nc
        w%list_elems(isize) = "gamma_nc"
        w%elem_descr(isize) = "NC gamma"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "m^-1"
        w%c256val(isize) = "(nrho_eq_geo)"
        IF(ALLOCATED(ss%gamma_nc)) THEN
           IF(ss%hash_codes(ps_phash_gamma_nc).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! gb1
        w%list_elems(isize) = "gb1"
        w%elem_descr(isize) = "<|B|>"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "T"
        w%c256val(isize) = "(nrho_eq_geo)"
        IF(ALLOCATED(ss%gb1)) THEN
           IF(ss%hash_codes(ps_phash_gb1).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! gb2
        w%list_elems(isize) = "gb2"
        w%elem_descr(isize) = "<B^2>"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "T^2"
        w%c256val(isize) = "(nrho_eq_geo)"
        IF(ALLOCATED(ss%gb2)) THEN
           IF(ss%hash_codes(ps_phash_gb2).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! gb2i
        w%list_elems(isize) = "gb2i"
        w%elem_descr(isize) = "<1/B^2>"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "T^-2"
        w%c256val(isize) = "(nrho_eq_geo)"
        IF(ALLOCATED(ss%gb2i)) THEN
           IF(ss%hash_codes(ps_phash_gb2i).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! gbr2
        w%list_elems(isize) = "gbr2"
        w%elem_descr(isize) = "<|B|*R^2>"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "T*m^2"
        w%c256val(isize) = "(nrho_eq_geo)"
        IF(ALLOCATED(ss%gbr2)) THEN
           IF(ss%hash_codes(ps_phash_gbr2).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! gncfb2h
        w%list_elems(isize) = "gncfb2h"
        w%elem_descr(isize) = "<(B^-2)*((1-H)^0.5-(1/3)*(1-H)^1.5)>; H=B/Bmax"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "T^-2"
        w%c256val(isize) = "(nrho_eq_geo)"
        IF(ALLOCATED(ss%gncfb2h)) THEN
           IF(ss%hash_codes(ps_phash_gncfb2h).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! gncfh
        w%list_elems(isize) = "gncfh"
        w%elem_descr(isize) = "<H^-2*(1-SQRT(1-H)*(1+H/2))>; H=B/Bmax"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "-"
        w%c256val(isize) = "(nrho_eq_geo)"
        IF(ALLOCATED(ss%gncfh)) THEN
           IF(ss%hash_codes(ps_phash_gncfh).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! gr1
        w%list_elems(isize) = "gr1"
        w%elem_descr(isize) = "<R>"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "m"
        w%c256val(isize) = "(nrho_eq_geo)"
        IF(ALLOCATED(ss%gr1)) THEN
           IF(ss%hash_codes(ps_phash_gr1).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! gr2
        w%list_elems(isize) = "gr2"
        w%elem_descr(isize) = "<R^2>"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "m^2"
        w%c256val(isize) = "(nrho_eq_geo)"
        IF(ALLOCATED(ss%gr2)) THEN
           IF(ss%hash_codes(ps_phash_gr2).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! gr2i
        w%list_elems(isize) = "gr2i"
        w%elem_descr(isize) = "<R^-2>"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "m^-2"
        w%c256val(isize) = "(nrho_eq_geo)"
        IF(ALLOCATED(ss%gr2i)) THEN
           IF(ss%hash_codes(ps_phash_gr2i).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! gr2rho2
        w%list_elems(isize) = "gr2rho2"
        w%elem_descr(isize) = "<R^2*|grad(rho)|^2>"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "-"
        w%c256val(isize) = "(nrho_eq_geo)"
        IF(ALLOCATED(ss%gr2rho2)) THEN
           IF(ss%hash_codes(ps_phash_gr2rho2).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! gr3i
        w%list_elems(isize) = "gr3i"
        w%elem_descr(isize) = "<R^-3>"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "m^-3"
        w%c256val(isize) = "(nrho_eq_geo)"
        IF(ALLOCATED(ss%gr3i)) THEN
           IF(ss%hash_codes(ps_phash_gr3i).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! grho1
        w%list_elems(isize) = "grho1"
        w%elem_descr(isize) = "<|grad(rho)|>"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "m^-1"
        w%c256val(isize) = "(nrho_eq_geo)"
        IF(ALLOCATED(ss%grho1)) THEN
           IF(ss%hash_codes(ps_phash_grho1).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! grho2
        w%list_elems(isize) = "grho2"
        w%elem_descr(isize) = "<|grad(rho)|^2>"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "m^-2"
        w%c256val(isize) = "(nrho_eq_geo)"
        IF(ALLOCATED(ss%grho2)) THEN
           IF(ss%hash_codes(ps_phash_grho2).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! grho2b2i
        w%list_elems(isize) = "grho2b2i"
        w%elem_descr(isize) = "<|grad(rho)|^2/B^2>"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "T^-2*m^-2"
        w%c256val(isize) = "(nrho_eq_geo)"
        IF(ALLOCATED(ss%grho2b2i)) THEN
           IF(ss%hash_codes(ps_phash_grho2b2i).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! grho2r2i
        w%list_elems(isize) = "grho2r2i"
        w%elem_descr(isize) = "<|grad(rho)|^2/R^2>"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "m^-4"
        w%c256val(isize) = "(nrho_eq_geo)"
        IF(ALLOCATED(ss%grho2r2i)) THEN
           IF(ss%hash_codes(ps_phash_grho2r2i).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! grho2r3i
        w%list_elems(isize) = "grho2r3i"
        w%elem_descr(isize) = "<|grad(rho)|^2/R^3>"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "m^-5"
        w%c256val(isize) = "(nrho_eq_geo)"
        IF(ALLOCATED(ss%grho2r3i)) THEN
           IF(ss%hash_codes(ps_phash_grho2r3i).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! gri
        w%list_elems(isize) = "gri"
        w%elem_descr(isize) = "<1/R>"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "m^-2"
        w%c256val(isize) = "(nrho_eq_geo)"
        IF(ALLOCATED(ss%gri)) THEN
           IF(ss%hash_codes(ps_phash_gri).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! grirhoi
        w%list_elems(isize) = "grirhoi"
        w%elem_descr(isize) = "<1/(R*|grad(rho)|)>"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "-"
        w%c256val(isize) = "(nrho_eq_geo)"
        IF(ALLOCATED(ss%grirhoi)) THEN
           IF(ss%hash_codes(ps_phash_grirhoi).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! growthrate_drbm
        w%list_elems(isize) = "growthrate_drbm"
        w%elem_descr(isize) = "growthrate from DRBM model"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "GB"
        w%c256val(isize) = "(nrho_anomth)"
        IF(ALLOCATED(ss%growthrate_drbm)) THEN
           IF(ss%hash_codes(ps_phash_growthrate_drbm).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! growthrate_glf
        w%list_elems(isize) = "growthrate_glf"
        w%elem_descr(isize) = "growthrate from GLF23 model"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "GB"
        w%c256val(isize) = "(nrho_anomth)"
        IF(ALLOCATED(ss%growthrate_glf)) THEN
           IF(ss%hash_codes(ps_phash_growthrate_glf).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! growthrate_max_tglf
        w%list_elems(isize) = "growthrate_max_tglf"
        w%elem_descr(isize) = "maximum growthrate from TGLF model"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "GB"
        w%c256val(isize) = "(nrho_anomth)"
        IF(ALLOCATED(ss%growthrate_max_tglf)) THEN
           IF(ss%hash_codes(ps_phash_growthrate_max_tglf).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! growthrate_mmm71
        w%list_elems(isize) = "growthrate_mmm71"
        w%elem_descr(isize) = "growthrate from mmm71 model"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "GB"
        w%c256val(isize) = "(nrho_anomth,nky_mmm)"
        IF(ALLOCATED(ss%growthrate_mmm71)) THEN
           IF(ss%hash_codes(ps_phash_growthrate_mmm71).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! growthrate_mtm
        w%list_elems(isize) = "growthrate_mtm"
        w%elem_descr(isize) = "growthrate from MTM model"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "1/sec"
        w%c256val(isize) = "(nrho_anomth)"
        IF(ALLOCATED(ss%growthrate_mtm)) THEN
           IF(ss%hash_codes(ps_phash_growthrate_mtm).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! growthrate_tglf
        w%list_elems(isize) = "growthrate_tglf"
        w%elem_descr(isize) = "growthrate from TGLF model"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "GB"
        w%c256val(isize) = "(nrho_anomth,nky_anomth)"
        IF(ALLOCATED(ss%growthrate_tglf)) THEN
           IF(ss%hash_codes(ps_phash_growthrate_tglf).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! growthrate_vpar
        w%list_elems(isize) = "growthrate_vpar"
        w%elem_descr(isize) = "growthrate from parallel velocity shear"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "GB"
        w%c256val(isize) = "(nrho_anomth,0:nspec_th)"
        IF(ALLOCATED(ss%growthrate_vpar)) THEN
           IF(ss%hash_codes(ps_phash_growthrate_vpar).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! g_eq
        w%list_elems(isize) = "g_eq"
        w%elem_descr(isize) = "equilibrium R*|B_phi|"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "T*m"
        w%c256val(isize) = "(nrho_eq)"
        IF(ALLOCATED(ss%g_eq)) THEN
           IF(ss%hash_codes(ps_phash_g_eq).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "SPLINE_00"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! iota
        w%list_elems(isize) = "iota"
        w%elem_descr(isize) = "iota profile (1/q)"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "-"
        w%c256val(isize) = "(nrho)"
        IF(ALLOCATED(ss%iota)) THEN
           IF(ss%hash_codes(ps_phash_iota).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "SPLINE_00"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! jdotb
        w%list_elems(isize) = "jdotb"
        w%elem_descr(isize) = "<J.B>"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "A*T/m^2"
        w%c256val(isize) = "(nrho_eq)"
        IF(ALLOCATED(ss%jdotb)) THEN
           IF(ss%hash_codes(ps_phash_jdotb).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "HERMITE_00"
     ENDIF
  ENDIF
END SUBROUTINE plasma_state_contents_profs_3

subroutine ccps_get_version_id(version, size, ierr)

  ! Set global debug level

  use plasma_state_mod
  implicit NONE
  character(len=*), intent(out) :: version
  integer, intent(out) :: size
  integer, intent(out) :: ierr    ! status code returned, 0=normal

  ierr = 0
  size    = len(ps_version_id)
  version = ps_version_id

end subroutine ccps_get_version_id

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_p3_dummy
     return
  end subroutine ccps_getset_p3_dummy

subroutine psget_psi_to_machine_axis(iobj, data, ierr)
    !! delta(Psi) from magnetic axis to machine axis, subtract this
    !! from Psi(R,Z) to get a Psi value, that approaches zero as R->
    !! zero: Psi ~ R*A_phi, (as in the EFIT free boundary
    !! representation)., Note: prescribed boundary code runs (e.g.,
    !! traditional TRANSP runs) cannot know this, number; so Plasma
    !! States created from such run, data will leave this at zero. 
    !! Plasma States, using free boundary MHD equilibrium information,
    !! will always have a non-zero value here.
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_psi_to_machine_axis', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % Psi_to_machine_axis
end subroutine psget_psi_to_machine_axis


subroutine psset_psi_to_machine_axis(iobj, data, ierr)
    !! delta(Psi) from magnetic axis to machine axis, subtract this
    !! from Psi(R,Z) to get a Psi value, that approaches zero as R->
    !! zero: Psi ~ R*A_phi, (as in the EFIT free boundary
    !! representation)., Note: prescribed boundary code runs (e.g.,
    !! traditional TRANSP runs) cannot know this, number; so Plasma
    !! States created from such run, data will leave this at zero. 
    !! Plasma States, using free boundary MHD equilibrium information,
    !! will always have a non-zero value here.
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_psi_to_machine_axis', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % Psi_to_machine_axis = data
end subroutine psset_psi_to_machine_axis


subroutine psget_picrf_srcs(iobj, n1, n2, n3, data, ierr)
    !! direct ICRF power deposition, (sum over nphi)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2, n3 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2, n3) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_picrf_srcs', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2, 1: n3) = ss % picrf_srcs
end subroutine psget_picrf_srcs


subroutine psset_picrf_srcs(iobj, n1, n2, n3, data, ierr)
    !! direct ICRF power deposition, (sum over nphi)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2, n3 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2, n3) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_picrf_srcs', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % picrf_srcs = data(1:n1, 1: n2, 1: n3)
end subroutine psset_picrf_srcs


subroutine psgetrnk_picrf_srcs(iobj, ndims, ierr)
    !! direct ICRF power deposition, (sum over nphi)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 3
end subroutine psgetrnk_picrf_srcs


subroutine psgetdim_picrf_srcs(iobj, ndims, dims, ierr)
    !! direct ICRF power deposition, (sum over nphi)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 3) ierr = 1
    call ccps_argcheck('psgetdim_picrf_srcs', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % picrf_srcs ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % picrf_srcs)
    endif
end subroutine psgetdim_picrf_srcs


subroutine psget_pb0_halo(iobj, n1, data, ierr)
    !! power in halo neutral source, (loss from thermal ions)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_pb0_halo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % pb0_halo
end subroutine psget_pb0_halo


subroutine psset_pb0_halo(iobj, n1, data, ierr)
    !! power in halo neutral source, (loss from thermal ions)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_pb0_halo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % pb0_halo = data(1:n1)
end subroutine psset_pb0_halo


subroutine psgetrnk_pb0_halo(iobj, ndims, ierr)
    !! power in halo neutral source, (loss from thermal ions)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_pb0_halo


subroutine psgetdim_pb0_halo(iobj, ndims, dims, ierr)
    !! power in halo neutral source, (loss from thermal ions)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_pb0_halo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % pb0_halo ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % pb0_halo)
    endif
end subroutine psgetdim_pb0_halo


subroutine psget_p0_reco(iobj, n1, data, ierr)
    !! power in recombination neutral source, (loss from thermal
    !! ions)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_p0_reco', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % p0_reco
end subroutine psget_p0_reco


subroutine psset_p0_reco(iobj, n1, data, ierr)
    !! power in recombination neutral source, (loss from thermal
    !! ions)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_p0_reco', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % p0_reco = data(1:n1)
end subroutine psset_p0_reco


subroutine psgetrnk_p0_reco(iobj, ndims, ierr)
    !! power in recombination neutral source, (loss from thermal
    !! ions)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_p0_reco


subroutine psgetdim_p0_reco(iobj, ndims, dims, ierr)
    !! power in recombination neutral source, (loss from thermal
    !! ions)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_p0_reco', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % p0_reco ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % p0_reco)
    endif
end subroutine psgetdim_p0_reco

subroutine cstate_wlen(w, &
     ilen_names,ilen_compo,ilen_vals,ilen_256,ilen_units,ilen_descr)

  !  return maximum non-blank length of various categories of ps_list_window
  !  CHARACTER*(*) data

  use plasma_state_mod
  implicit NONE

  type (ps_list_window) :: w

  integer, intent(out) :: ilen_names  ! max length: list name & element names
  integer, intent(out) :: ilen_compo  ! max length: list name & element names
  integer, intent(out) :: ilen_vals   ! max length: value fields
  integer, intent(out) :: ilen_256    ! max length: long value fields
  integer, intent(out) :: ilen_units  ! max length: units fields
  integer, intent(out) :: ilen_descr  ! max length: description fields

  !-------------------------------------
  integer :: ii
  !-------------------------------------

  ilen_names = len(trim(w%list_name))
  ilen_compo = 0
  ilen_vals = 0
  ilen_256 = 0
  ilen_units = 0
  ilen_descr = 0

  if(associated(w%list_elems)) then
     do ii=1,w%size
        ilen_names = max(ilen_names, len(trim(w%list_elems(ii))) )
     enddo
  endif

  if(associated(w%val_field)) then
     do ii=1,w%size
        ilen_vals = max(ilen_vals, len(trim(w%val_field(ii))) )
     enddo
  endif

  if(associated(w%c256val)) then
     do ii=1,w%size
        ilen_256 = max(ilen_256, len(trim(w%c256val(ii))) )
     enddo
  endif

  if(associated(w%component)) then
     ilen_compo = 9  ! allow for "Component" column header
     do ii=1,w%size
        ilen_compo = max(ilen_compo, len(trim(w%component(ii))) )
     enddo
  endif

  if(associated(w%elem_units)) then
     ilen_units = 5  ! allow for "Units" column header
     do ii=1,w%size
        ilen_units = max(ilen_units, len(trim(w%elem_units(ii))) )
     enddo
  endif

  if(associated(w%elem_descr)) then
     ilen_descr = 11 ! allow for "Description" column header
     do ii=1,w%size
        ilen_descr = max(ilen_descr, len(trim(w%elem_descr(ii))) )
     enddo
  endif

end subroutine cstate_wlen

subroutine ccps_intrp_2d_vector(iobj,id,ideriv1,ideriv2,nvals,x1vals,x2vals, &
     results,ierr)

  ! interpolate a 2d state element profile at a vector of target values

  use plasma_state_mod
  implicit NONE

  integer :: iobj(*)        ! (ps_container_size) words are used
  integer, intent(in) :: id ! profile ID
  integer, intent(in) :: ideriv1   ! 0 for value, 1 for d/dx1, 2 for d2/d[x1]2
  integer, intent(in) :: ideriv2   ! 0 for value, 1 for d/dx2, 2 for d2/d[x2]2
  !   e.g. ideriv1=ideriv2=1 for cross partial: d2f/d(x1)d(x2)
  !   allowed values for ideriv1,ideriv2 depends on the ID'd profiles 
  !   method of interpolation (as defined in the state specification).

  integer, intent(in) :: nvals    ! size of target & results vectors

  REAL(kind=rspec), intent(in) :: x1vals(nvals),x2vals(nvals) ! values at which
                                  ! to interpolate...

  REAL(kind=rspec), intent(out) :: results(nvals) ! interpolation results

  integer, intent(out) :: ierr    ! status code returned, 0=normal

  !--------------------------------
  type (plasma_state_container) :: ptr
  type (plasma_state), pointer :: ss
  !--------------------------------

  call ccps_argcheck('ccps_intrp_2d_vector',iobj,ierr)
  if(ierr.ne.0) return

  ! proceed...

  call load_ps_container(iobj,ptr)
  ss => ptr%ps_ptr

  call ps_intrp_2d(x1vals,x2vals,id,results,ierr, state=ss, &
       ideriv1=ideriv1, ideriv2=ideriv2)

end subroutine ccps_intrp_2d_vector

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)

SUBROUTINE plasma_state_xload_psingl(ss,xhash,iout,ierr)

  ! called from plasma_state_xload: check grids; store in xplasma structure

  USE plasma_state_definition_mod
  IMPLICIT NONE

  TYPE (plasma_state) :: ss     ! state data to write into xplasma
  INTEGER :: xhash(ps_hash_total)  ! hash data
  INTEGER, INTENT(IN) :: iout   ! LUN for messages
  INTEGER, INTENT(INOUT) :: ierr   ! completion code (set if error occurs)

  !-----------------------
  ! local:

  INTEGER, PARAMETER :: max_local = 4

  INTEGER :: icomponent,imod,nitems,idchk
  CHARACTER*32 :: listname,units,list_units
  CHARACTER*80 :: label,plabel
  INTEGER :: ahash(ps_max_static)

  CHARACTER*32 :: item_names(max_local)
  INTEGER :: item_ivals(max_local)
  REAL(KIND=rspec) :: item_r8vals(max_local)
  CHARACTER*256 :: item_c256(max_local)
  !-----------------------

  ahash(1) = ps_phash_VOL
  idchk = ss%id_vol
  IF(ALLOCATED(ss%vol).AND.hcheck(1,idchk)) THEN
     listname = "VOL_LIST"
     icomponent = ps_cnum_EQ
     units = "m^3"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "m^3"
     label = "edge value: vol"

     plabel = "enclosed volume"
     CALL ps_1d_prof_store(ss%iobj,"vol","RHO_EQ", &
          units,icomponent,plabel,ps_spline,ps_bc_grad00, &
          ss%nrho_eq,0, &
          ss%vol,ss%id_vol, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "vol"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_vol
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_AREA
  idchk = ss%id_area
  IF(ALLOCATED(ss%area).AND.hcheck(1,idchk)) THEN
     listname = "AREA_LIST"
     icomponent = ps_cnum_EQ
     units = "m^2"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "m^2"
     label = "edge value: area"

     plabel = "enclosed area"
     CALL ps_1d_prof_store(ss%iobj,"area","RHO_EQ", &
          units,icomponent,plabel,ps_spline,ps_bc_grad00, &
          ss%nrho_eq,0, &
          ss%area,ss%id_area, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "area"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_area
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_ANOM_EVAR
  idchk = ss%id_anom_evar
  IF(ALLOCATED(ss%anom_evar).AND.hcheck(1,idchk)) THEN
     listname = "ANOM_EVAR_LIST"
     icomponent = ps_cnum_ANOM
     units = "-"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "-"
     label = "simple avg: anom_evar"

     plabel = "anomalous transport energy variation"
     CALL ps_1d_prof_store(ss%iobj,"anom_evar","E_ANOM", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nefi_anom,0, &
          ss%anom_evar,ss%id_anom_evar, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "anom_evar"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_anom_evar
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_BALSTAB
  idchk = ss%id_balstab
  IF(ALLOCATED(ss%balstab).AND.hcheck(1,idchk)) THEN
     listname = "BALSTAB_LIST"
     icomponent = ps_cnum_LMHD
     units = "-"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "-"
     label = "simple avg: balstab"

     plabel = "Ballooning/Mercier stability indicator"
     CALL ps_1d_prof_store(ss%iobj,"balstab","RHO_LMHD", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_lmhd,0, &
          ss%balstab,ss%id_balstab, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "balstab"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_balstab
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_BPHIRZ
  idchk = ss%id_BphiRZ
  IF(ALLOCATED(ss%BphiRZ).AND.hcheck(1,idchk)) THEN
     listname = "BPHIRZ_LIST"
     icomponent = ps_cnum_EQ
     units = "T"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "T"
     label = "simple avg: BphiRZ"

     plabel = "Toroidal field"
     CALL ps_2d_prof_store(ss%iobj,"BphiRZ","R_GRID","Z_GRID", &
          units,icomponent,plabel,ps_hermite,ps_bc_dflt, &
          ss%nr,ss%nz,0,0, &
          ss%BphiRZ,ss%id_BphiRZ, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "BphiRZ"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_BphiRZ
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_BRRZ
  idchk = ss%id_BRRZ
  IF(ALLOCATED(ss%BRRZ).AND.hcheck(1,idchk)) THEN
     listname = "BRRZ_LIST"
     icomponent = ps_cnum_EQ
     units = "T"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "T"
     label = "simple avg: BRRZ"

     plabel = "R component of poloidal field"
     CALL ps_2d_prof_store(ss%iobj,"BRRZ","R_GRID","Z_GRID", &
          units,icomponent,plabel,ps_hermite,ps_bc_dflt, &
          ss%nr,ss%nz,0,0, &
          ss%BRRZ,ss%id_BRRZ, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "BRRZ"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_BRRZ
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_BZRZ
  idchk = ss%id_BZRZ
  IF(ALLOCATED(ss%BZRZ).AND.hcheck(1,idchk)) THEN
     listname = "BZRZ_LIST"
     icomponent = ps_cnum_EQ
     units = "T"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "T"
     label = "simple avg: BZRZ"

     plabel = "Z component of poloidal field"
     CALL ps_2d_prof_store(ss%iobj,"BZRZ","R_GRID","Z_GRID", &
          units,icomponent,plabel,ps_hermite,ps_bc_dflt, &
          ss%nr,ss%nz,0,0, &
          ss%BZRZ,ss%id_BZRZ, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "BZRZ"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_BZRZ
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_CHIE_ANOM
  idchk = ss%id_chie_anom
  IF(ALLOCATED(ss%chie_anom).AND.hcheck(1,idchk)) THEN
     listname = "CHIE_ANOM_LIST"
     icomponent = ps_cnum_ANOM
     units = "m^2/sec"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "m^2/sec"
     label = "simple avg: chie_anom"

     plabel = "Te-equation, diffusivity term"
     CALL ps_1d_prof_store(ss%iobj,"chie_anom","RHO_ANOMTH", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_anomth,0, &
          ss%chie_anom,ss%id_chie_anom, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "chie_anom"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_chie_anom
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_CHIE_DRBM
  idchk = ss%id_chie_drbm
  IF(ALLOCATED(ss%chie_drbm).AND.hcheck(1,idchk)) THEN
     listname = "CHIE_DRBM_LIST"
     icomponent = ps_cnum_ANOM
     units = "m^2/sec"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "m^2/sec"
     label = "simple avg: chie_drbm"

     plabel = "Te-equation, diffusivity term"
     CALL ps_1d_prof_store(ss%iobj,"chie_drbm","RHO_ANOMTH", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_anomth,0, &
          ss%chie_drbm,ss%id_chie_drbm, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "chie_drbm"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_chie_drbm
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_CHIE_ETG
  idchk = ss%id_chie_etg
  IF(ALLOCATED(ss%chie_etg).AND.hcheck(1,idchk)) THEN
     listname = "CHIE_ETG_LIST"
     icomponent = ps_cnum_ANOM
     units = "m^2/sec"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "m^2/sec"
     label = "simple avg: chie_etg"

     plabel = "Te-equation, diffusivity term ETG model"
     CALL ps_1d_prof_store(ss%iobj,"chie_etg","RHO_ANOMTH", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_anomth,0, &
          ss%chie_etg,ss%id_chie_etg, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "chie_etg"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_chie_etg
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_CHIE_GLF
  idchk = ss%id_chie_glf
  IF(ALLOCATED(ss%chie_glf).AND.hcheck(1,idchk)) THEN
     listname = "CHIE_GLF_LIST"
     icomponent = ps_cnum_ANOM
     units = "m^2/s"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "m^2/s"
     label = "simple avg: chie_glf"

     plabel = "Te-equation, diffusivity from GLF23 model"
     CALL ps_1d_prof_store(ss%iobj,"chie_glf","RHO_ANOMTH", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_anomth,0, &
          ss%chie_glf,ss%id_chie_glf, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "chie_glf"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_chie_glf
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_CHIE_GTCNEO
  idchk = ss%id_chie_gtcneo
  IF(ALLOCATED(ss%chie_gtcneo).AND.hcheck(1,idchk)) THEN
     listname = "CHIE_GTCNEO_LIST"
     icomponent = ps_cnum_ANOM
     units = "m^2/s"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "m^2/s"
     label = "simple avg: chie_gtcneo"

     plabel = "Te-equation, neoclassical diffusivity from GTC_NEO model"
     CALL ps_1d_prof_store(ss%iobj,"chie_gtcneo","RHO_ANOMTH", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_anomth,0, &
          ss%chie_gtcneo,ss%id_chie_gtcneo, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "chie_gtcneo"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_chie_gtcneo
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_CHIE_MMM71
  idchk = ss%id_chie_mmm71
  IF(ALLOCATED(ss%chie_mmm71).AND.hcheck(1,idchk)) THEN
     listname = "CHIE_MMM71_LIST"
     icomponent = ps_cnum_ANOM
     units = "m^2/sec"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "m^2/sec"
     label = "simple avg: chie_mmm71"

     plabel = "Te-equation, diffusivity term"
     CALL ps_1d_prof_store(ss%iobj,"chie_mmm71","RHO_ANOMTH", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_anomth,0, &
          ss%chie_mmm71,ss%id_chie_mmm71, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "chie_mmm71"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_chie_mmm71
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_CHIE_MTM
  idchk = ss%id_chie_mtm
  IF(ALLOCATED(ss%chie_mtm).AND.hcheck(1,idchk)) THEN
     listname = "CHIE_MTM_LIST"
     icomponent = ps_cnum_ANOM
     units = "m^2/sec"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "m^2/sec"
     label = "simple avg: chie_mtm"

     plabel = "Te-equation, thermal diffusivity term MTM model"
     CALL ps_1d_prof_store(ss%iobj,"chie_mtm","RHO_ANOMTH", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_anomth,0, &
          ss%chie_mtm,ss%id_chie_mtm, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "chie_mtm"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_chie_mtm
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_CHIE_NCLASS
  idchk = ss%id_chie_nclass
  IF(ALLOCATED(ss%chie_nclass).AND.hcheck(1,idchk)) THEN
     listname = "CHIE_NCLASS_LIST"
     icomponent = ps_cnum_ANOM
     units = "m^2/s"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "m^2/s"
     label = "simple avg: chie_nclass"

     plabel = "Te-equation, neoclassical diffusivity from NCLASS model"
     CALL ps_1d_prof_store(ss%iobj,"chie_nclass","RHO_ANOMTH", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_anomth,0, &
          ss%chie_nclass,ss%id_chie_nclass, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "chie_nclass"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_chie_nclass
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_CHIE_NEO
  idchk = ss%id_chie_neo
  IF(ALLOCATED(ss%chie_neo).AND.hcheck(1,idchk)) THEN
     listname = "CHIE_NEO_LIST"
     icomponent = ps_cnum_ANOM
     units = "m^2/s"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "m^2/s"
     label = "simple avg: chie_neo"

     plabel = "Te-equation, neoclassical diffusivity from NEO model"
     CALL ps_1d_prof_store(ss%iobj,"chie_neo","RHO_ANOMTH", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_anomth,0, &
          ss%chie_neo,ss%id_chie_neo, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "chie_neo"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_chie_neo
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_CHIE_NTM
  idchk = ss%id_chie_ntm
  IF(ALLOCATED(ss%chie_ntm).AND.hcheck(1,idchk)) THEN
     listname = "CHIE_NTM_LIST"
     icomponent = ps_cnum_ANOM
     units = "m^2/s"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "m^2/s"
     label = "simple avg: chie_ntm"

     plabel = "Te-equation, neoclassical diffusivity from NTM model"
     CALL ps_1d_prof_store(ss%iobj,"chie_ntm","RHO_ANOMTH", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_anomth,0, &
          ss%chie_ntm,ss%id_chie_ntm, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "chie_ntm"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_chie_ntm
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_CHIE_PALEO
  idchk = ss%id_chie_paleo
  IF(ALLOCATED(ss%chie_paleo).AND.hcheck(1,idchk)) THEN
     listname = "CHIE_PALEO_LIST"
     icomponent = ps_cnum_ANOM
     units = "m^2/sec"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "m^2/sec"
     label = "simple avg: chie_paleo"

     plabel = "Te-equation, diffusivity term PALEO model"
     CALL ps_1d_prof_store(ss%iobj,"chie_paleo","RHO_ANOMTH", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_anomth,0, &
          ss%chie_paleo,ss%id_chie_paleo, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "chie_paleo"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_chie_paleo
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_CHIE_TGLF
  idchk = ss%id_chie_tglf
  IF(ALLOCATED(ss%chie_tglf).AND.hcheck(1,idchk)) THEN
     listname = "CHIE_TGLF_LIST"
     icomponent = ps_cnum_ANOM
     units = "m^2/s"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "m^2/s"
     label = "simple avg: chie_tglf"

     plabel = "Te-equation, diffusivity from TGLF model"
     CALL ps_1d_prof_store(ss%iobj,"chie_tglf","RHO_ANOMTH", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_anomth,0, &
          ss%chie_tglf,ss%id_chie_tglf, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "chie_tglf"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_chie_tglf
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_CHIE_W19
  idchk = ss%id_chie_w19
  IF(ALLOCATED(ss%chie_w19).AND.hcheck(1,idchk)) THEN
     listname = "CHIE_W19_LIST"
     icomponent = ps_cnum_ANOM
     units = "m^2/sec"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "m^2/sec"
     label = "simple avg: chie_w19"

     plabel = "Te-equation, diffusivity term"
     CALL ps_1d_prof_store(ss%iobj,"chie_w19","RHO_ANOMTH", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_anomth,0, &
          ss%chie_w19,ss%id_chie_w19, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "chie_w19"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_chie_w19
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_CHII_ANOM
  idchk = ss%id_chii_anom
  IF(ALLOCATED(ss%chii_anom).AND.hcheck(1,idchk)) THEN
     listname = "CHII_ANOM_LIST"
     icomponent = ps_cnum_ANOM
     units = "m^2/sec"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "m^2/sec"
     label = "simple avg: chii_anom"

     plabel = "Ti-equation, diffusivity term"
     CALL ps_1d_prof_store(ss%iobj,"chii_anom","RHO_ANOMTH", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_anomth,0, &
          ss%chii_anom,ss%id_chii_anom, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "chii_anom"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_chii_anom
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_CHII_DRBM
  idchk = ss%id_chii_drbm
  IF(ALLOCATED(ss%chii_drbm).AND.hcheck(1,idchk)) THEN
     listname = "CHII_DRBM_LIST"
     icomponent = ps_cnum_ANOM
     units = "m^2/sec"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "m^2/sec"
     label = "simple avg: chii_drbm"

     plabel = "Ti-equation, diffusivity term"
     CALL ps_1d_prof_store(ss%iobj,"chii_drbm","RHO_ANOMTH", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_anomth,0, &
          ss%chii_drbm,ss%id_chii_drbm, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "chii_drbm"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_chii_drbm
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_CHII_GLF
  idchk = ss%id_chii_glf
  IF(ALLOCATED(ss%chii_glf).AND.hcheck(1,idchk)) THEN
     listname = "CHII_GLF_LIST"
     icomponent = ps_cnum_ANOM
     units = "m^2/s"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "m^2/s"
     label = "simple avg: chii_glf"

     plabel = "Ti-equation, diffusivity from GLF23 model"
     CALL ps_1d_prof_store(ss%iobj,"chii_glf","RHO_ANOMTH", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_anomth,0, &
          ss%chii_glf,ss%id_chii_glf, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "chii_glf"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_chii_glf
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_CHII_GTCNEO
  idchk = ss%id_chii_gtcneo
  IF(ALLOCATED(ss%chii_gtcneo).AND.hcheck(1,idchk)) THEN
     listname = "CHII_GTCNEO_LIST"
     icomponent = ps_cnum_ANOM
     units = "m^2/s"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "m^2/s"
     label = "simple avg: chii_gtcneo"

     plabel = "Ti-equation, neoclassical diffusivity from GTC_NEO model"
     CALL ps_1d_prof_store(ss%iobj,"chii_gtcneo","RHO_ANOMTH", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_anomth,0, &
          ss%chii_gtcneo,ss%id_chii_gtcneo, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "chii_gtcneo"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_chii_gtcneo
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_CHII_MMM71
  idchk = ss%id_chii_mmm71
  IF(ALLOCATED(ss%chii_mmm71).AND.hcheck(1,idchk)) THEN
     listname = "CHII_MMM71_LIST"
     icomponent = ps_cnum_ANOM
     units = "m^2/sec"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "m^2/sec"
     label = "simple avg: chii_mmm71"

     plabel = "Ti-equation, diffusivity term"
     CALL ps_1d_prof_store(ss%iobj,"chii_mmm71","RHO_ANOMTH", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_anomth,0, &
          ss%chii_mmm71,ss%id_chii_mmm71, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "chii_mmm71"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_chii_mmm71
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_CHII_NCLASS
  idchk = ss%id_chii_nclass
  IF(ALLOCATED(ss%chii_nclass).AND.hcheck(1,idchk)) THEN
     listname = "CHII_NCLASS_LIST"
     icomponent = ps_cnum_ANOM
     units = "m^2/s"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "m^2/s"
     label = "simple avg: chii_nclass"

     plabel = "Ti-equation, neoclassical diffusivity from NCALSS model"
     CALL ps_1d_prof_store(ss%iobj,"chii_nclass","RHO_ANOMTH", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_anomth,0, &
          ss%chii_nclass,ss%id_chii_nclass, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "chii_nclass"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_chii_nclass
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_CHII_NEO
  idchk = ss%id_chii_neo
  IF(ALLOCATED(ss%chii_neo).AND.hcheck(1,idchk)) THEN
     listname = "CHII_NEO_LIST"
     icomponent = ps_cnum_ANOM
     units = "m^2/s"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "m^2/s"
     label = "simple avg: chii_neo"

     plabel = "Ti-equation, neoclassical diffusivity from NEO model"
     CALL ps_1d_prof_store(ss%iobj,"chii_neo","RHO_ANOMTH", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_anomth,0, &
          ss%chii_neo,ss%id_chii_neo, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "chii_neo"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_chii_neo
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_CHII_NTM
  idchk = ss%id_chii_ntm
  IF(ALLOCATED(ss%chii_ntm).AND.hcheck(1,idchk)) THEN
     listname = "CHII_NTM_LIST"
     icomponent = ps_cnum_ANOM
     units = "m^2/s"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "m^2/s"
     label = "simple avg: chii_ntm"

     plabel = "Ti-equation, neoclassical diffusivity from NTM model"
     CALL ps_1d_prof_store(ss%iobj,"chii_ntm","RHO_ANOMTH", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_anomth,0, &
          ss%chii_ntm,ss%id_chii_ntm, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "chii_ntm"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_chii_ntm
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_CHII_TGLF
  idchk = ss%id_chii_tglf
  IF(ALLOCATED(ss%chii_tglf).AND.hcheck(1,idchk)) THEN
     listname = "CHII_TGLF_LIST"
     icomponent = ps_cnum_ANOM
     units = "m^2/s"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "m^2/s"
     label = "simple avg: chii_tglf"

     plabel = "Ti-equation, diffusivity from TGLF model"
     CALL ps_1d_prof_store(ss%iobj,"chii_tglf","RHO_ANOMTH", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_anomth,0, &
          ss%chii_tglf,ss%id_chii_tglf, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "chii_tglf"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_chii_tglf
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_CHII_W19
  idchk = ss%id_chii_w19
  IF(ALLOCATED(ss%chii_w19).AND.hcheck(1,idchk)) THEN
     listname = "CHII_W19_LIST"
     icomponent = ps_cnum_ANOM
     units = "m^2/sec"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "m^2/sec"
     label = "simple avg: chii_w19"

     plabel = "Ti-equation, diffusivity term"
     CALL ps_1d_prof_store(ss%iobj,"chii_w19","RHO_ANOMTH", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_anomth,0, &
          ss%chii_w19,ss%id_chii_w19, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "chii_w19"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_chii_w19
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_CHIPHI_ANOM
  idchk = ss%id_chiphi_anom
  IF(ALLOCATED(ss%chiphi_anom).AND.hcheck(1,idchk)) THEN
     listname = "CHIPHI_ANOM_LIST"
     icomponent = ps_cnum_ANOM
     units = "m^2/sec"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "m^2/sec"
     label = "simple avg: chiphi_anom"

     plabel = "momentum-equation, diffusivity term"
     CALL ps_1d_prof_store(ss%iobj,"chiphi_anom","RHO_ANOMTH", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_anomth,0, &
          ss%chiphi_anom,ss%id_chiphi_anom, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "chiphi_anom"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_chiphi_anom
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_CHIPHI_DRBM
  idchk = ss%id_chiphi_drbm
  IF(ALLOCATED(ss%chiphi_drbm).AND.hcheck(1,idchk)) THEN
     listname = "CHIPHI_DRBM_LIST"
     icomponent = ps_cnum_ANOM
     units = "m^2/sec"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "m^2/sec"
     label = "simple avg: chiphi_drbm"

     plabel = "momentum-equation, diffusivity term"
     CALL ps_1d_prof_store(ss%iobj,"chiphi_drbm","RHO_ANOMTH", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_anomth,0, &
          ss%chiphi_drbm,ss%id_chiphi_drbm, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "chiphi_drbm"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_chiphi_drbm
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_CHIPHI_GLF
  idchk = ss%id_chiphi_glf
  IF(ALLOCATED(ss%chiphi_glf).AND.hcheck(1,idchk)) THEN
     listname = "CHIPHI_GLF_LIST"
     icomponent = ps_cnum_ANOM
     units = "m^2/s"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "m^2/s"
     label = "simple avg: chiphi_glf"

     plabel = "momentum-equation, diffusivity from GLF23 model"
     CALL ps_1d_prof_store(ss%iobj,"chiphi_glf","RHO_ANOMTH", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_anomth,0, &
          ss%chiphi_glf,ss%id_chiphi_glf, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "chiphi_glf"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_chiphi_glf
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_CHIPHI_GTCNEO
  idchk = ss%id_chiphi_gtcneo
  IF(ALLOCATED(ss%chiphi_gtcneo).AND.hcheck(1,idchk)) THEN
     listname = "CHIPHI_GTCNEO_LIST"
     icomponent = ps_cnum_ANOM
     units = "m^2/s"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "m^2/s"
     label = "simple avg: chiphi_gtcneo"

     plabel = "momentum-equation, neoclassical diffusivity from GTC_NEO model"
     CALL ps_1d_prof_store(ss%iobj,"chiphi_gtcneo","RHO_ANOMTH", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_anomth,0, &
          ss%chiphi_gtcneo,ss%id_chiphi_gtcneo, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "chiphi_gtcneo"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_chiphi_gtcneo
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_CHIPHI_MMM71
  idchk = ss%id_chiphi_mmm71
  IF(ALLOCATED(ss%chiphi_mmm71).AND.hcheck(1,idchk)) THEN
     listname = "CHIPHI_MMM71_LIST"
     icomponent = ps_cnum_ANOM
     units = "m^2/sec"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "m^2/sec"
     label = "simple avg: chiphi_mmm71"

     plabel = "momentum-equation, diffusivity term, toroidal"
     CALL ps_1d_prof_store(ss%iobj,"chiphi_mmm71","RHO_ANOMTH", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_anomth,0, &
          ss%chiphi_mmm71,ss%id_chiphi_mmm71, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "chiphi_mmm71"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_chiphi_mmm71
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_CHIPHI_NEO
  idchk = ss%id_chiphi_neo
  IF(ALLOCATED(ss%chiphi_neo).AND.hcheck(1,idchk)) THEN
     listname = "CHIPHI_NEO_LIST"
     icomponent = ps_cnum_ANOM
     units = "m^2/s"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "m^2/s"
     label = "simple avg: chiphi_neo"

     plabel = "momentum-equation, neoclassical diffusivity from NEO model"
     CALL ps_1d_prof_store(ss%iobj,"chiphi_neo","RHO_ANOMTH", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_anomth,0, &
          ss%chiphi_neo,ss%id_chiphi_neo, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "chiphi_neo"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_chiphi_neo
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_CHIPHI_TGLF
  idchk = ss%id_chiphi_tglf
  IF(ALLOCATED(ss%chiphi_tglf).AND.hcheck(1,idchk)) THEN
     listname = "CHIPHI_TGLF_LIST"
     icomponent = ps_cnum_ANOM
     units = "m^2/s"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "m^2/s"
     label = "simple avg: chiphi_tglf"

     plabel = "momentum-equation, diffusivity from TGLF model"
     CALL ps_1d_prof_store(ss%iobj,"chiphi_tglf","RHO_ANOMTH", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_anomth,0, &
          ss%chiphi_tglf,ss%id_chiphi_tglf, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "chiphi_tglf"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_chiphi_tglf
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_CHIPHI_W19
  idchk = ss%id_chiphi_w19
  IF(ALLOCATED(ss%chiphi_w19).AND.hcheck(1,idchk)) THEN
     listname = "CHIPHI_W19_LIST"
     icomponent = ps_cnum_ANOM
     units = "m^2/sec"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "m^2/sec"
     label = "simple avg: chiphi_w19"

     plabel = "momentum-equation, diffusivity term"
     CALL ps_1d_prof_store(ss%iobj,"chiphi_w19","RHO_ANOMTH", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_anomth,0, &
          ss%chiphi_w19,ss%id_chiphi_w19, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "chiphi_w19"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_chiphi_w19
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_CHITHETA_MMM71
  idchk = ss%id_chitheta_mmm71
  IF(ALLOCATED(ss%chitheta_mmm71).AND.hcheck(1,idchk)) THEN
     listname = "CHITHETA_MMM71_LIST"
     icomponent = ps_cnum_ANOM
     units = "m^2/sec"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "m^2/sec"
     label = "simple avg: chitheta_mmm71"

     plabel = "momentum-equation, diffusivity term, poloidal"
     CALL ps_1d_prof_store(ss%iobj,"chitheta_mmm71","RHO_ANOMTH", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_anomth,0, &
          ss%chitheta_mmm71,ss%id_chitheta_mmm71, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "chitheta_mmm71"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_chitheta_mmm71
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_CURBEAM
  idchk = ss%id_curbeam
  IF(ALLOCATED(ss%curbeam).AND.hcheck(1,idchk)) THEN
     listname = "CURBEAM_LIST"
     icomponent = ps_cnum_NBI
     units = "A"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "A"
     label = "area int: curbeam"

     plabel = "beam ion driven current (shielded)"
     CALL ps_1d_prof_store(ss%iobj,"curbeam","RHO_NBI", &
          units,icomponent,plabel,ps_stepda,ps_bc_dflt, &
          ss%nrho_nbi-1,0, &
          ss%curbeam,ss%id_curbeam, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "curbeam"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_curbeam
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_CURECH
  idchk = ss%id_curech
  IF(ALLOCATED(ss%curech).AND.hcheck(1,idchk)) THEN
     listname = "CURECH_LIST"
     icomponent = ps_cnum_EC
     units = "A"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "A"
     label = "area int: curech"

     plabel = "ECH current drive"
     CALL ps_1d_prof_store(ss%iobj,"curech","RHO_ECRF", &
          units,icomponent,plabel,ps_stepda,ps_bc_dflt, &
          ss%nrho_ecrf-1,0, &
          ss%curech,ss%id_curech, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "curech"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_curech
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_CURFUSN
  idchk = ss%id_curfusn
  IF(ALLOCATED(ss%curfusn).AND.hcheck(1,idchk)) THEN
     listname = "CURFUSN_LIST"
     icomponent = ps_cnum_FUS
     units = "A"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "A"
     label = "area int: curfusn"

     plabel = "fusion ion driven current (shielded)"
     CALL ps_1d_prof_store(ss%iobj,"curfusn","RHO_FUS", &
          units,icomponent,plabel,ps_stepda,ps_bc_dflt, &
          ss%nrho_fus-1,0, &
          ss%curfusn,ss%id_curfusn, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "curfusn"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_curfusn
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_CURICH
  idchk = ss%id_curich
  IF(ALLOCATED(ss%curich).AND.hcheck(1,idchk)) THEN
     listname = "CURICH_LIST"
     icomponent = ps_cnum_IC
     units = "A"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "A"
     label = "area int: curich"

     plabel = "total driven current (all IC srcs)"
     CALL ps_1d_prof_store(ss%iobj,"curich","RHO_ICRF", &
          units,icomponent,plabel,ps_stepda,ps_bc_dflt, &
          ss%nrho_icrf-1,0, &
          ss%curich,ss%id_curich, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "curich"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_curich
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_CURLH
  idchk = ss%id_curlh
  IF(ALLOCATED(ss%curlh).AND.hcheck(1,idchk)) THEN
     listname = "CURLH_LIST"
     icomponent = ps_cnum_LH
     units = "A"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "A"
     label = "area int: curlh"

     plabel = "LH current drive"
     CALL ps_1d_prof_store(ss%iobj,"curlh","RHO_LHRF", &
          units,icomponent,plabel,ps_stepda,ps_bc_dflt, &
          ss%nrho_lhrf-1,0, &
          ss%curlh,ss%id_curlh, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "curlh"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_curlh
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_CURMINO
  idchk = ss%id_curmino
  IF(ALLOCATED(ss%curmino).AND.hcheck(1,idchk)) THEN
     listname = "CURMINO_LIST"
     icomponent = ps_cnum_IC
     units = "A"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "A"
     label = "area int: curmino"

     plabel = "minority ion driven cur (shielded)."
     CALL ps_1d_prof_store(ss%iobj,"curmino","RHO_ICRF", &
          units,icomponent,plabel,ps_stepda,ps_bc_dflt, &
          ss%nrho_icrf-1,0, &
          ss%curmino,ss%id_curmino, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "curmino"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_curmino
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_CURR_BOOTSTRAP
  idchk = ss%id_curr_bootstrap
  IF(ALLOCATED(ss%curr_bootstrap).AND.hcheck(1,idchk)) THEN
     listname = "CURR_BOOTSTRAP_LIST"
     icomponent = ps_cnum_PLASMA
     units = "A"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "A"
     label = "area int: curr_bootstrap"

     plabel = "Neoclassical bootstrap current"
     CALL ps_1d_prof_store(ss%iobj,"curr_bootstrap","RHO", &
          units,icomponent,plabel,ps_stepda,ps_bc_dflt, &
          ss%nrho-1,0, &
          ss%curr_bootstrap,ss%id_curr_bootstrap, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "curr_bootstrap"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_curr_bootstrap
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_CURR_OHMIC
  idchk = ss%id_curr_ohmic
  IF(ALLOCATED(ss%curr_ohmic).AND.hcheck(1,idchk)) THEN
     listname = "CURR_OHMIC_LIST"
     icomponent = ps_cnum_PLASMA
     units = "A"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "A"
     label = "area int: curr_ohmic"

     plabel = "Ohmic current"
     CALL ps_1d_prof_store(ss%iobj,"curr_ohmic","RHO", &
          units,icomponent,plabel,ps_stepda,ps_bc_dflt, &
          ss%nrho-1,0, &
          ss%curr_ohmic,ss%id_curr_ohmic, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "curr_ohmic"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_curr_ohmic
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_CURT
  idchk = ss%id_curt
  IF(ALLOCATED(ss%curt).AND.hcheck(1,idchk)) THEN
     listname = "CURT_LIST"
     icomponent = ps_cnum_EQ
     units = "A"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "A"
     label = "edge value: curt"

     plabel = "total enclosed toroidal current"
     CALL ps_1d_prof_store(ss%iobj,"curt","RHO_EQ", &
          units,icomponent,plabel,ps_spline,ps_bc_grad00, &
          ss%nrho_eq,0, &
          ss%curt,ss%id_curt, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "curt"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_curt
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_CUR_RW
  idchk = ss%id_cur_rw
  IF(ALLOCATED(ss%cur_rw).AND.hcheck(1,idchk)) THEN
     listname = "CUR_RW_LIST"
     icomponent = ps_cnum_RUNAWAY
     units = "A"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "A"
     label = "area int: cur_rw"

     plabel = "current carried by fast electrons"
     CALL ps_1d_prof_store(ss%iobj,"cur_rw","RHO_RW", &
          units,icomponent,plabel,ps_stepda,ps_bc_dflt, &
          ss%nrho_rw-1,0, &
          ss%cur_rw,ss%id_cur_rw, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "cur_rw"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_cur_rw
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_DB_MTM
  idchk = ss%id_db_mtm
  IF(ALLOCATED(ss%db_mtm).AND.hcheck(1,idchk)) THEN
     listname = "DB_MTM_LIST"
     icomponent = ps_cnum_ANOM
     units = "-"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "-"
     label = "simple avg: db_mtm"

     plabel = "dB/B from MTM model"
     CALL ps_1d_prof_store(ss%iobj,"db_mtm","RHO_ANOMTH", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_anomth,0, &
          ss%db_mtm,ss%id_db_mtm, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "db_mtm"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_db_mtm
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_DCUR_RW_DVLOOP
  idchk = ss%id_dcur_rw_dVloop
  IF(ALLOCATED(ss%dcur_rw_dVloop).AND.hcheck(1,idchk)) THEN
     listname = "DCUR_RW_DVLOOP_LIST"
     icomponent = ps_cnum_RUNAWAY
     units = "A/Volt"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "A/Volt"
     label = "area int: dcur_rw_dVloop"

     plabel = "sensitivity to loop volts"
     CALL ps_1d_prof_store(ss%iobj,"dcur_rw_dVloop","RHO_RW", &
          units,icomponent,plabel,ps_stepda,ps_bc_dflt, &
          ss%nrho_rw-1,0, &
          ss%dcur_rw_dVloop,ss%id_dcur_rw_dVloop, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "dcur_rw_dVloop"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_dcur_rw_dVloop
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_DIFNE_NCLASS
  idchk = ss%id_difne_nclass
  IF(ALLOCATED(ss%difne_nclass).AND.hcheck(1,idchk)) THEN
     listname = "DIFNE_NCLASS_LIST"
     icomponent = ps_cnum_ANOM
     units = "m^2/s"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "m^2/s"
     label = "simple avg: difne_nclass"

     plabel = "electron-density-equations, neoclassical diffusivity from NCLASS model"
     CALL ps_1d_prof_store(ss%iobj,"difne_nclass","RHO_ANOMTH", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_anomth,0, &
          ss%difne_nclass,ss%id_difne_nclass, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "difne_nclass"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_difne_nclass
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_DIFNH_NCLASS
  idchk = ss%id_difnh_nclass
  IF(ALLOCATED(ss%difnh_nclass).AND.hcheck(1,idchk)) THEN
     listname = "DIFNH_NCLASS_LIST"
     icomponent = ps_cnum_ANOM
     units = "m^2/s"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "m^2/s"
     label = "simple avg: difnh_nclass"

     plabel = "main-hydrogenic-density-equations, neoclassical diffusivity from NCLASS model"
     CALL ps_1d_prof_store(ss%iobj,"difnh_nclass","RHO_ANOMTH", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_anomth,0, &
          ss%difnh_nclass,ss%id_difnh_nclass, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "difnh_nclass"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_difnh_nclass
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_DIFNX_NCLASS
  idchk = ss%id_difnx_nclass
  IF(ALLOCATED(ss%difnx_nclass).AND.hcheck(1,idchk)) THEN
     listname = "DIFNX_NCLASS_LIST"
     icomponent = ps_cnum_ANOM
     units = "m^2/s"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "m^2/s"
     label = "simple avg: difnx_nclass"

     plabel = "main-impurity-density-equations, neoclassical diffusivity from NCLASS model"
     CALL ps_1d_prof_store(ss%iobj,"difnx_nclass","RHO_ANOMTH", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_anomth,0, &
          ss%difnx_nclass,ss%id_difnx_nclass, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "difnx_nclass"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_difnx_nclass
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_DIFNZ_MMM71
  idchk = ss%id_difnz_mmm71
  IF(ALLOCATED(ss%difnz_mmm71).AND.hcheck(1,idchk)) THEN
     listname = "DIFNZ_MMM71_LIST"
     icomponent = ps_cnum_ANOM
     units = "m^2/sec"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "m^2/sec"
     label = "simple avg: difnz_mmm71"

     plabel = "impurity ion diffusivity term"
     CALL ps_1d_prof_store(ss%iobj,"difnz_mmm71","RHO_ANOMTH", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_anomth,0, &
          ss%difnz_mmm71,ss%id_difnz_mmm71, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "difnz_mmm71"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_difnz_mmm71
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_DQEDGRDTE_TGLF
  idchk = ss%id_dQedGrdte_tglf
  IF(ALLOCATED(ss%dQedGrdte_tglf).AND.hcheck(1,idchk)) THEN
     listname = "DQEDGRDTE_TGLF_LIST"
     icomponent = ps_cnum_ANOM
     units = "1/(m*s)"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "1/(m*s)"
     label = "simple avg: dQedGrdte_tglf"

     plabel = "Te flux gradient term from TGLF model"
     CALL ps_1d_prof_store(ss%iobj,"dQedGrdte_tglf","RHO_ANOMTH", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_anomth,0, &
          ss%dQedGrdte_tglf,ss%id_dQedGrdte_tglf, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "dQedGrdte_tglf"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_dQedGrdte_tglf
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_DQEDGRDTI_TGLF
  idchk = ss%id_dQedGrdti_tglf
  IF(ALLOCATED(ss%dQedGrdti_tglf).AND.hcheck(1,idchk)) THEN
     listname = "DQEDGRDTI_TGLF_LIST"
     icomponent = ps_cnum_ANOM
     units = "1/(m*s)"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "1/(m*s)"
     label = "simple avg: dQedGrdti_tglf"

     plabel = "Te flux gradient term from TGLF model"
     CALL ps_1d_prof_store(ss%iobj,"dQedGrdti_tglf","RHO_ANOMTH", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_anomth,0, &
          ss%dQedGrdti_tglf,ss%id_dQedGrdti_tglf, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "dQedGrdti_tglf"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_dQedGrdti_tglf
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_DQIDGRDTE_TGLF
  idchk = ss%id_dQidGrdte_tglf
  IF(ALLOCATED(ss%dQidGrdte_tglf).AND.hcheck(1,idchk)) THEN
     listname = "DQIDGRDTE_TGLF_LIST"
     icomponent = ps_cnum_ANOM
     units = "1/(m*s)"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "1/(m*s)"
     label = "simple avg: dQidGrdte_tglf"

     plabel = "Ti flux gradient term from TGLF model"
     CALL ps_1d_prof_store(ss%iobj,"dQidGrdte_tglf","RHO_ANOMTH", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_anomth,0, &
          ss%dQidGrdte_tglf,ss%id_dQidGrdte_tglf, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "dQidGrdte_tglf"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_dQidGrdte_tglf
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_DQIDGRDTI_TGLF
  idchk = ss%id_dQidGrdti_tglf
  IF(ALLOCATED(ss%dQidGrdti_tglf).AND.hcheck(1,idchk)) THEN
     listname = "DQIDGRDTI_TGLF_LIST"
     icomponent = ps_cnum_ANOM
     units = "1/(m*s)"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "1/(m*s)"
     label = "simple avg: dQidGrdti_tglf"

     plabel = "Ti flux gradient term from TGLF model"
     CALL ps_1d_prof_store(ss%iobj,"dQidGrdti_tglf","RHO_ANOMTH", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_anomth,0, &
          ss%dQidGrdti_tglf,ss%id_dQidGrdti_tglf, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "dQidGrdti_tglf"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_dQidGrdti_tglf
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_EE_MOBILITY_FACTOR
  idchk = ss%id_ee_mobility_factor
  IF(ALLOCATED(ss%ee_mobility_factor).AND.hcheck(1,idchk)) THEN
     listname = "EE_MOBILITY_FACTOR_LIST"
     icomponent = ps_cnum_ANOM
     units = "-"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "-"
     label = "simple avg: ee_mobility_factor"

     plabel = "chi_e/chi_i"
     CALL ps_1d_prof_store(ss%iobj,"ee_mobility_factor","RHO_ANOMTH", &
          units,icomponent,plabel,ps_hermite,ps_bc_dflt, &
          ss%nrho_anomth,0, &
          ss%ee_mobility_factor,ss%id_ee_mobility_factor, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "ee_mobility_factor"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_ee_mobility_factor
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_EPERP_RW
  idchk = ss%id_eperp_rw
  IF(ALLOCATED(ss%eperp_rw).AND.hcheck(1,idchk)) THEN
     listname = "EPERP_RW_LIST"
     icomponent = ps_cnum_RUNAWAY
     units = "keV"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "keV"
     label = "wght avg (NRW): eperp_rw"

     plabel = "runaway electron <Eperp>"
     CALL ps_1d_prof_store(ss%iobj,"eperp_rw","RHO_RW", &
          units,icomponent,plabel,ps_stepfun,ps_bc_dflt, &
          ss%nrho_rw-1,0, &
          ss%eperp_rw,ss%id_eperp_rw, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "eperp_rw"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_eperp_rw
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_EPLL_RW
  idchk = ss%id_epll_rw
  IF(ALLOCATED(ss%epll_rw).AND.hcheck(1,idchk)) THEN
     listname = "EPLL_RW_LIST"
     icomponent = ps_cnum_RUNAWAY
     units = "keV"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "keV"
     label = "wght avg (NRW): epll_rw"

     plabel = "runaway electron <Epll>"
     CALL ps_1d_prof_store(ss%iobj,"epll_rw","RHO_RW", &
          units,icomponent,plabel,ps_stepfun,ps_bc_dflt, &
          ss%nrho_rw-1,0, &
          ss%epll_rw,ss%id_epll_rw, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "epll_rw"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_epll_rw
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_EPOT
  idchk = ss%id_Epot
  IF(ALLOCATED(ss%Epot).AND.hcheck(1,idchk)) THEN
     listname = "EPOT_LIST"
     icomponent = ps_cnum_PLASMA
     units = "keV"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "keV"
     label = "simple avg: Epot"

     plabel = "radial electrostatic potential"
     CALL ps_1d_prof_store(ss%iobj,"Epot","RHO", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho,0, &
          ss%Epot,ss%id_Epot, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "Epot"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_Epot
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_ETA_PARALLEL
  idchk = ss%id_eta_parallel
  IF(ALLOCATED(ss%eta_parallel).AND.hcheck(1,idchk)) THEN
     listname = "ETA_PARALLEL_LIST"
     icomponent = ps_cnum_PLASMA
     units = "ohm*m"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "ohm*m"
     label = "simple avg: eta_parallel"

     plabel = "parallel electrical resistivity"
     CALL ps_1d_prof_store(ss%iobj,"eta_parallel","RHO", &
          units,icomponent,plabel,ps_hermite,ps_bc_dflt, &
          ss%nrho,0, &
          ss%eta_parallel,ss%id_eta_parallel, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "eta_parallel"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_eta_parallel
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_FI_DEPLETION
  idchk = ss%id_Fi_depletion
  IF(ALLOCATED(ss%Fi_depletion).AND.hcheck(1,idchk)) THEN
     listname = "FI_DEPLETION_LIST"
     icomponent = ps_cnum_PLASMA
     units = "-"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "-"
     label = "wght avg (density): Fi_depletion"

     plabel = "fast ion depletion: sum[nj*Zj/ne]"
     CALL ps_1d_prof_store(ss%iobj,"Fi_depletion","RHO", &
          units,icomponent,plabel,ps_stepfun,ps_bc_dflt, &
          ss%nrho-1,0, &
          ss%Fi_depletion,ss%id_Fi_depletion, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "Fi_depletion"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_Fi_depletion
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_FREQ_DRBM
  idchk = ss%id_freq_drbm
  IF(ALLOCATED(ss%freq_drbm).AND.hcheck(1,idchk)) THEN
     listname = "FREQ_DRBM_LIST"
     icomponent = ps_cnum_ANOM
     units = "GB"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "GB"
     label = "simple avg: freq_drbm"

     plabel = "frequency from DRBM model"
     CALL ps_1d_prof_store(ss%iobj,"freq_drbm","RHO_ANOMTH", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_anomth,0, &
          ss%freq_drbm,ss%id_freq_drbm, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "freq_drbm"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_freq_drbm
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_FREQ_GLF
  idchk = ss%id_freq_glf
  IF(ALLOCATED(ss%freq_glf).AND.hcheck(1,idchk)) THEN
     listname = "FREQ_GLF_LIST"
     icomponent = ps_cnum_ANOM
     units = "GB"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "GB"
     label = "simple avg: freq_glf"

     plabel = "frequency from GLF23 model"
     CALL ps_1d_prof_store(ss%iobj,"freq_glf","RHO_ANOMTH", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_anomth,0, &
          ss%freq_glf,ss%id_freq_glf, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "freq_glf"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_freq_glf
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_FREQ_MAX_TGLF
  idchk = ss%id_freq_max_tglf
  IF(ALLOCATED(ss%freq_max_tglf).AND.hcheck(1,idchk)) THEN
     listname = "FREQ_MAX_TGLF_LIST"
     icomponent = ps_cnum_ANOM
     units = "GB"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "GB"
     label = "simple avg: freq_max_tglf"

     plabel = "frequency corresponding maximum growthrate from TGLF model"
     CALL ps_1d_prof_store(ss%iobj,"freq_max_tglf","RHO_ANOMTH", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_anomth,0, &
          ss%freq_max_tglf,ss%id_freq_max_tglf, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "freq_max_tglf"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_freq_max_tglf
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_FREQ_MTM
  idchk = ss%id_freq_mtm
  IF(ALLOCATED(ss%freq_mtm).AND.hcheck(1,idchk)) THEN
     listname = "FREQ_MTM_LIST"
     icomponent = ps_cnum_ANOM
     units = "rad/sec"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "rad/sec"
     label = "simple avg: freq_mtm"

     plabel = "frequency from MTM model"
     CALL ps_1d_prof_store(ss%iobj,"freq_mtm","RHO_ANOMTH", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_anomth,0, &
          ss%freq_mtm,ss%id_freq_mtm, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "freq_mtm"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_freq_mtm
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_GAMMA_NC
  idchk = ss%id_gamma_nc
  IF(ALLOCATED(ss%gamma_nc).AND.hcheck(1,idchk)) THEN
     listname = "GAMMA_NC_LIST"
     icomponent = ps_cnum_EQ
     units = "m^-1"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "m^-1"
     label = "edge value: gamma_nc"

     plabel = "NC gamma"
     CALL ps_1d_prof_store(ss%iobj,"gamma_nc","RHO_EQ_GEO", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_eq_geo,0, &
          ss%gamma_nc,ss%id_gamma_nc, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "gamma_nc"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_gamma_nc
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_GB1
  idchk = ss%id_gb1
  IF(ALLOCATED(ss%gb1).AND.hcheck(1,idchk)) THEN
     listname = "GB1_LIST"
     icomponent = ps_cnum_EQ
     units = "T"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "T"
     label = "edge value: gb1"

     plabel = "<|B|>"
     CALL ps_1d_prof_store(ss%iobj,"gb1","RHO_EQ_GEO", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_eq_geo,0, &
          ss%gb1,ss%id_gb1, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "gb1"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_gb1
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_GB2
  idchk = ss%id_gb2
  IF(ALLOCATED(ss%gb2).AND.hcheck(1,idchk)) THEN
     listname = "GB2_LIST"
     icomponent = ps_cnum_EQ
     units = "T^2"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "T^2"
     label = "edge value: gb2"

     plabel = "<B^2>"
     CALL ps_1d_prof_store(ss%iobj,"gb2","RHO_EQ_GEO", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_eq_geo,0, &
          ss%gb2,ss%id_gb2, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "gb2"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_gb2
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_GB2I
  idchk = ss%id_gb2i
  IF(ALLOCATED(ss%gb2i).AND.hcheck(1,idchk)) THEN
     listname = "GB2I_LIST"
     icomponent = ps_cnum_EQ
     units = "T^-2"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "T^-2"
     label = "edge value: gb2i"

     plabel = "<1/B^2>"
     CALL ps_1d_prof_store(ss%iobj,"gb2i","RHO_EQ_GEO", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_eq_geo,0, &
          ss%gb2i,ss%id_gb2i, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "gb2i"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_gb2i
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_GBR2
  idchk = ss%id_gbr2
  IF(ALLOCATED(ss%gbr2).AND.hcheck(1,idchk)) THEN
     listname = "GBR2_LIST"
     icomponent = ps_cnum_EQ
     units = "T*m^2"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "T*m^2"
     label = "edge value: gbr2"

     plabel = "<|B|*R^2>"
     CALL ps_1d_prof_store(ss%iobj,"gbr2","RHO_EQ_GEO", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_eq_geo,0, &
          ss%gbr2,ss%id_gbr2, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "gbr2"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_gbr2
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_GNCFB2H
  idchk = ss%id_gncfb2h
  IF(ALLOCATED(ss%gncfb2h).AND.hcheck(1,idchk)) THEN
     listname = "GNCFB2H_LIST"
     icomponent = ps_cnum_EQ
     units = "T^-2"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "T^-2"
     label = "edge value: gncfb2h"

     plabel = "<(B^-2)*((1-H)^0.5-(1/3)*(1-H)^1.5)>; H=B/Bmax"
     CALL ps_1d_prof_store(ss%iobj,"gncfb2h","RHO_EQ_GEO", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_eq_geo,0, &
          ss%gncfb2h,ss%id_gncfb2h, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "gncfb2h"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_gncfb2h
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_GNCFH
  idchk = ss%id_gncfh
  IF(ALLOCATED(ss%gncfh).AND.hcheck(1,idchk)) THEN
     listname = "GNCFH_LIST"
     icomponent = ps_cnum_EQ
     units = "-"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "-"
     label = "edge value: gncfh"

     plabel = "<H^-2*(1-SQRT(1-H)*(1+H/2))>; H=B/Bmax"
     CALL ps_1d_prof_store(ss%iobj,"gncfh","RHO_EQ_GEO", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_eq_geo,0, &
          ss%gncfh,ss%id_gncfh, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "gncfh"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_gncfh
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_GR1
  idchk = ss%id_gr1
  IF(ALLOCATED(ss%gr1).AND.hcheck(1,idchk)) THEN
     listname = "GR1_LIST"
     icomponent = ps_cnum_EQ
     units = "m"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "m"
     label = "edge value: gr1"

     plabel = "<R>"
     CALL ps_1d_prof_store(ss%iobj,"gr1","RHO_EQ_GEO", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_eq_geo,0, &
          ss%gr1,ss%id_gr1, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "gr1"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_gr1
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_GR2
  idchk = ss%id_gr2
  IF(ALLOCATED(ss%gr2).AND.hcheck(1,idchk)) THEN
     listname = "GR2_LIST"
     icomponent = ps_cnum_EQ
     units = "m^2"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "m^2"
     label = "edge value: gr2"

     plabel = "<R^2>"
     CALL ps_1d_prof_store(ss%iobj,"gr2","RHO_EQ_GEO", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_eq_geo,0, &
          ss%gr2,ss%id_gr2, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "gr2"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_gr2
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_GR2I
  idchk = ss%id_gr2i
  IF(ALLOCATED(ss%gr2i).AND.hcheck(1,idchk)) THEN
     listname = "GR2I_LIST"
     icomponent = ps_cnum_EQ
     units = "m^-2"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "m^-2"
     label = "edge value: gr2i"

     plabel = "<R^-2>"
     CALL ps_1d_prof_store(ss%iobj,"gr2i","RHO_EQ_GEO", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_eq_geo,0, &
          ss%gr2i,ss%id_gr2i, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "gr2i"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_gr2i
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_GR2RHO2
  idchk = ss%id_gr2rho2
  IF(ALLOCATED(ss%gr2rho2).AND.hcheck(1,idchk)) THEN
     listname = "GR2RHO2_LIST"
     icomponent = ps_cnum_EQ
     units = "-"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "-"
     label = "edge value: gr2rho2"

     plabel = "<R^2*|grad(rho)|^2>"
     CALL ps_1d_prof_store(ss%iobj,"gr2rho2","RHO_EQ_GEO", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_eq_geo,0, &
          ss%gr2rho2,ss%id_gr2rho2, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "gr2rho2"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_gr2rho2
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_GR3I
  idchk = ss%id_gr3i
  IF(ALLOCATED(ss%gr3i).AND.hcheck(1,idchk)) THEN
     listname = "GR3I_LIST"
     icomponent = ps_cnum_EQ
     units = "m^-3"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "m^-3"
     label = "edge value: gr3i"

     plabel = "<R^-3>"
     CALL ps_1d_prof_store(ss%iobj,"gr3i","RHO_EQ_GEO", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_eq_geo,0, &
          ss%gr3i,ss%id_gr3i, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "gr3i"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_gr3i
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_GRHO1
  idchk = ss%id_grho1
  IF(ALLOCATED(ss%grho1).AND.hcheck(1,idchk)) THEN
     listname = "GRHO1_LIST"
     icomponent = ps_cnum_EQ
     units = "m^-1"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "m^-1"
     label = "edge value: grho1"

     plabel = "<|grad(rho)|>"
     CALL ps_1d_prof_store(ss%iobj,"grho1","RHO_EQ_GEO", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_eq_geo,0, &
          ss%grho1,ss%id_grho1, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "grho1"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_grho1
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_GRHO2
  idchk = ss%id_grho2
  IF(ALLOCATED(ss%grho2).AND.hcheck(1,idchk)) THEN
     listname = "GRHO2_LIST"
     icomponent = ps_cnum_EQ
     units = "m^-2"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "m^-2"
     label = "edge value: grho2"

     plabel = "<|grad(rho)|^2>"
     CALL ps_1d_prof_store(ss%iobj,"grho2","RHO_EQ_GEO", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_eq_geo,0, &
          ss%grho2,ss%id_grho2, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "grho2"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_grho2
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_GRHO2B2I
  idchk = ss%id_grho2b2i
  IF(ALLOCATED(ss%grho2b2i).AND.hcheck(1,idchk)) THEN
     listname = "GRHO2B2I_LIST"
     icomponent = ps_cnum_EQ
     units = "T^-2*m^-2"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "T^-2*m^-2"
     label = "edge value: grho2b2i"

     plabel = "<|grad(rho)|^2/B^2>"
     CALL ps_1d_prof_store(ss%iobj,"grho2b2i","RHO_EQ_GEO", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_eq_geo,0, &
          ss%grho2b2i,ss%id_grho2b2i, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "grho2b2i"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_grho2b2i
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_GRHO2R2I
  idchk = ss%id_grho2r2i
  IF(ALLOCATED(ss%grho2r2i).AND.hcheck(1,idchk)) THEN
     listname = "GRHO2R2I_LIST"
     icomponent = ps_cnum_EQ
     units = "m^-4"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "m^-4"
     label = "edge value: grho2r2i"

     plabel = "<|grad(rho)|^2/R^2>"
     CALL ps_1d_prof_store(ss%iobj,"grho2r2i","RHO_EQ_GEO", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_eq_geo,0, &
          ss%grho2r2i,ss%id_grho2r2i, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "grho2r2i"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_grho2r2i
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_GRHO2R3I
  idchk = ss%id_grho2r3i
  IF(ALLOCATED(ss%grho2r3i).AND.hcheck(1,idchk)) THEN
     listname = "GRHO2R3I_LIST"
     icomponent = ps_cnum_EQ
     units = "m^-5"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "m^-5"
     label = "edge value: grho2r3i"

     plabel = "<|grad(rho)|^2/R^3>"
     CALL ps_1d_prof_store(ss%iobj,"grho2r3i","RHO_EQ_GEO", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_eq_geo,0, &
          ss%grho2r3i,ss%id_grho2r3i, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "grho2r3i"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_grho2r3i
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_GRI
  idchk = ss%id_gri
  IF(ALLOCATED(ss%gri).AND.hcheck(1,idchk)) THEN
     listname = "GRI_LIST"
     icomponent = ps_cnum_EQ
     units = "m^-2"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "m^-2"
     label = "edge value: gri"

     plabel = "<1/R>"
     CALL ps_1d_prof_store(ss%iobj,"gri","RHO_EQ_GEO", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_eq_geo,0, &
          ss%gri,ss%id_gri, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "gri"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_gri
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_GRIRHOI
  idchk = ss%id_grirhoi
  IF(ALLOCATED(ss%grirhoi).AND.hcheck(1,idchk)) THEN
     listname = "GRIRHOI_LIST"
     icomponent = ps_cnum_EQ
     units = "-"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "-"
     label = "edge value: grirhoi"

     plabel = "<1/(R*|grad(rho)|)>"
     CALL ps_1d_prof_store(ss%iobj,"grirhoi","RHO_EQ_GEO", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_eq_geo,0, &
          ss%grirhoi,ss%id_grirhoi, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "grirhoi"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_grirhoi
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_GROWTHRATE_DRBM
  idchk = ss%id_growthrate_drbm
  IF(ALLOCATED(ss%growthrate_drbm).AND.hcheck(1,idchk)) THEN
     listname = "GROWTHRATE_DRBM_LIST"
     icomponent = ps_cnum_ANOM
     units = "GB"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "GB"
     label = "simple avg: growthrate_drbm"

     plabel = "growthrate from DRBM model"
     CALL ps_1d_prof_store(ss%iobj,"growthrate_drbm","RHO_ANOMTH", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_anomth,0, &
          ss%growthrate_drbm,ss%id_growthrate_drbm, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "growthrate_drbm"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_growthrate_drbm
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_GROWTHRATE_GLF
  idchk = ss%id_growthrate_glf
  IF(ALLOCATED(ss%growthrate_glf).AND.hcheck(1,idchk)) THEN
     listname = "GROWTHRATE_GLF_LIST"
     icomponent = ps_cnum_ANOM
     units = "GB"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "GB"
     label = "simple avg: growthrate_glf"

     plabel = "growthrate from GLF23 model"
     CALL ps_1d_prof_store(ss%iobj,"growthrate_glf","RHO_ANOMTH", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_anomth,0, &
          ss%growthrate_glf,ss%id_growthrate_glf, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "growthrate_glf"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_growthrate_glf
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_GROWTHRATE_MAX_TGLF
  idchk = ss%id_growthrate_max_tglf
  IF(ALLOCATED(ss%growthrate_max_tglf).AND.hcheck(1,idchk)) THEN
     listname = "GROWTHRATE_MAX_TGLF_LIST"
     icomponent = ps_cnum_ANOM
     units = "GB"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "GB"
     label = "simple avg: growthrate_max_tglf"

     plabel = "maximum growthrate from TGLF model"
     CALL ps_1d_prof_store(ss%iobj,"growthrate_max_tglf","RHO_ANOMTH", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_anomth,0, &
          ss%growthrate_max_tglf,ss%id_growthrate_max_tglf, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "growthrate_max_tglf"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_growthrate_max_tglf
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_GROWTHRATE_MTM
  idchk = ss%id_growthrate_mtm
  IF(ALLOCATED(ss%growthrate_mtm).AND.hcheck(1,idchk)) THEN
     listname = "GROWTHRATE_MTM_LIST"
     icomponent = ps_cnum_ANOM
     units = "1/sec"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "1/sec"
     label = "simple avg: growthrate_mtm"

     plabel = "growthrate from MTM model"
     CALL ps_1d_prof_store(ss%iobj,"growthrate_mtm","RHO_ANOMTH", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_anomth,0, &
          ss%growthrate_mtm,ss%id_growthrate_mtm, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "growthrate_mtm"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_growthrate_mtm
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_G_EQ
  idchk = ss%id_g_eq
  IF(ALLOCATED(ss%g_eq).AND.hcheck(1,idchk)) THEN
     listname = "G_EQ_LIST"
     icomponent = ps_cnum_EQ
     units = "T*m"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "T*m"
     label = "edge value: g_eq"

     plabel = "equilibrium R*|B_phi|"
     CALL ps_1d_prof_store(ss%iobj,"g_eq","RHO_EQ", &
          units,icomponent,plabel,ps_spline,ps_bc_grad00, &
          ss%nrho_eq,0, &
          ss%g_eq,ss%id_g_eq, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "g_eq"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_g_eq
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_IOTA
  idchk = ss%id_iota
  IF(ALLOCATED(ss%iota).AND.hcheck(1,idchk)) THEN
     listname = "IOTA_LIST"
     icomponent = ps_cnum_PLASMA
     units = "-"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "-"
     label = "simple avg: iota"

     plabel = "iota profile (1/q)"
     CALL ps_1d_prof_store(ss%iobj,"iota","RHO", &
          units,icomponent,plabel,ps_spline,ps_bc_grad00, &
          ss%nrho,0, &
          ss%iota,ss%id_iota, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "iota"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_iota
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_JDOTB
  idchk = ss%id_jdotb
  IF(ALLOCATED(ss%jdotb).AND.hcheck(1,idchk)) THEN
     listname = "JDOTB_LIST"
     icomponent = ps_cnum_EQ
     units = "A*T/m^2"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "A*T/m^2"
     label = "edge value: jdotb"

     plabel = "<J.B>"
     CALL ps_1d_prof_store(ss%iobj,"jdotb","RHO_EQ", &
          units,icomponent,plabel,ps_hermite,ps_bc_grad00, &
          ss%nrho_eq,0, &
          ss%jdotb,ss%id_jdotb, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "jdotb"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_jdotb
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_KYRHOS_MTM
  idchk = ss%id_kyrhos_mtm
  IF(ALLOCATED(ss%kyrhos_mtm).AND.hcheck(1,idchk)) THEN
     listname = "KYRHOS_MTM_LIST"
     icomponent = ps_cnum_ANOM
     units = "-"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "-"
     label = "simple avg: kyrhos_mtm"

     plabel = "ky*rhos at max growth rate for MTM model"
     CALL ps_1d_prof_store(ss%iobj,"kyrhos_mtm","RHO_ANOMTH", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_anomth,0, &
          ss%kyrhos_mtm,ss%id_kyrhos_mtm, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "kyrhos_mtm"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_kyrhos_mtm
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_LPOL
  idchk = ss%id_Lpol
  IF(ALLOCATED(ss%Lpol).AND.hcheck(1,idchk)) THEN
     listname = "LPOL_LIST"
     icomponent = ps_cnum_EQ
     units = "m"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "m"
     label = "edge value: Lpol"

     plabel = "poloidal path length"
     CALL ps_1d_prof_store(ss%iobj,"Lpol","RHO_EQ", &
          units,icomponent,plabel,ps_spline,ps_bc_dflt, &
          ss%nrho_eq,0, &
          ss%Lpol,ss%id_Lpol, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "Lpol"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_Lpol
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_NGRADB2_AV
  idchk = ss%id_ngradb2_av
  IF(ALLOCATED(ss%ngradb2_av).AND.hcheck(1,idchk)) THEN
     listname = "NGRADB2_AV_LIST"
     icomponent = ps_cnum_EQ
     units = "T^2*m^-2"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "T^2*m^-2"
     label = "edge value: ngradb2_av"

     plabel = "<(B.grad(B)/|B|)^2>"
     CALL ps_1d_prof_store(ss%iobj,"ngradb2_av","RHO_EQ_GEO", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_eq_geo,0, &
          ss%ngradb2_av,ss%id_ngradb2_av, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "ngradb2_av"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_ngradb2_av
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_NI
  idchk = ss%id_ni
  IF(ALLOCATED(ss%ni).AND.hcheck(1,idchk)) THEN
     listname = "NI_LIST"
     icomponent = ps_cnum_PLASMA
     units = "m^-3"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "#"
     label = "vol int: ni"

     plabel = "total thermal ion density"
     CALL ps_1d_prof_store(ss%iobj,"ni","RHO", &
          units,icomponent,plabel,ps_stepfun,ps_bc_dflt, &
          ss%nrho-1,0, &
          ss%ni,ss%id_ni, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "ni"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_ni
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_NMODEL
  idchk = ss%id_nmodel
  IF(ALLOCATED(ss%nmodel).AND.hcheck(1,idchk)) THEN
     listname = "NMODEL_LIST"
     icomponent = ps_cnum_ANOM
     units = "m^-3"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "#"
     label = "vol int: nmodel"

     plabel = "target density profile"
     CALL ps_1d_prof_store(ss%iobj,"nmodel","RHO_ANOMTH", &
          units,icomponent,plabel,ps_stepfun,ps_bc_dflt, &
          ss%nrho_anomth-1,0, &
          ss%nmodel,ss%id_nmodel, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "nmodel"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_nmodel
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_NRW
  idchk = ss%id_nrw
  IF(ALLOCATED(ss%nrw).AND.hcheck(1,idchk)) THEN
     listname = "NRW_LIST"
     icomponent = ps_cnum_RUNAWAY
     units = "m^-3"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "#"
     label = "vol int: nrw"

     plabel = "runaway electron density"
     CALL ps_1d_prof_store(ss%iobj,"nrw","RHO_RW", &
          units,icomponent,plabel,ps_stepfun,ps_bc_dflt, &
          ss%nrho_rw-1,0, &
          ss%nrw,ss%id_nrw, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "nrw"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_nrw
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_OMEGAT
  idchk = ss%id_omegat
  IF(ALLOCATED(ss%omegat).AND.hcheck(1,idchk)) THEN
     listname = "OMEGAT_LIST"
     icomponent = ps_cnum_PLASMA
     units = "rad/sec"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "rad/sec"
     label = "wght avg (NI): omegat"

     plabel = "ion toroidal angular velocity"
     CALL ps_1d_prof_store(ss%iobj,"omegat","RHO", &
          units,icomponent,plabel,ps_stepfun,ps_bc_dflt, &
          ss%nrho-1,0, &
          ss%omegat,ss%id_omegat, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "omegat"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_omegat
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_OMEGA_EXB
  idchk = ss%id_omega_exb
  IF(ALLOCATED(ss%omega_exb).AND.hcheck(1,idchk)) THEN
     listname = "OMEGA_EXB_LIST"
     icomponent = ps_cnum_ANOM
     units = "GB"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "GB"
     label = "simple avg: omega_exb"

     plabel = "ExB flow shear rate"
     CALL ps_1d_prof_store(ss%iobj,"omega_exb","RHO_ANOMTH", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_anomth,0, &
          ss%omega_exb,ss%id_omega_exb, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "omega_exb"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_omega_exb
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_PEECH
  idchk = ss%id_peech
  IF(ALLOCATED(ss%peech).AND.hcheck(1,idchk)) THEN
     listname = "PEECH_LIST"
     icomponent = ps_cnum_EC
     units = "W"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "W"
     label = "vol int: peech"

     plabel = "electron heating by ECH"
     CALL ps_1d_prof_store(ss%iobj,"peech","RHO_ECRF", &
          units,icomponent,plabel,ps_stepdv,ps_bc_dflt, &
          ss%nrho_ecrf-1,0, &
          ss%peech,ss%id_peech, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "peech"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_peech
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_PE_ANOM
  idchk = ss%id_pe_anom
  IF(ALLOCATED(ss%pe_anom).AND.hcheck(1,idchk)) THEN
     listname = "PE_ANOM_LIST"
     icomponent = ps_cnum_ANOM
     units = "W"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "W"
     label = "vol int: pe_anom"

     plabel = "anomalous electron heating"
     CALL ps_1d_prof_store(ss%iobj,"pe_anom","RHO_ANOMTH", &
          units,icomponent,plabel,ps_stepdv,ps_bc_dflt, &
          ss%nrho_anomth-1,0, &
          ss%pe_anom,ss%id_pe_anom, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "pe_anom"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_pe_anom
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_PHIT
  idchk = ss%id_phit
  IF(ALLOCATED(ss%phit).AND.hcheck(1,idchk)) THEN
     listname = "PHIT_LIST"
     icomponent = ps_cnum_EQ
     units = "Wb"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "Wb"
     label = "edge value: phit"

     plabel = "toroidal flux vs. rho"
     CALL ps_1d_prof_store(ss%iobj,"phit","RHO_EQ", &
          units,icomponent,plabel,ps_spline,ps_bc_grad00, &
          ss%nrho_eq,0, &
          ss%phit,ss%id_phit, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "phit"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_phit
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_PICTH
  idchk = ss%id_picth
  IF(ALLOCATED(ss%picth).AND.hcheck(1,idchk)) THEN
     listname = "PICTH_LIST"
     icomponent = ps_cnum_IC
     units = "W"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "W"
     label = "vol int: picth"

     plabel = "direct thermal ion heating by ICRF"
     CALL ps_1d_prof_store(ss%iobj,"picth","RHO_ICRF", &
          units,icomponent,plabel,ps_stepdv,ps_bc_dflt, &
          ss%nrho_icrf-1,0, &
          ss%picth,ss%id_picth, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "picth"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_picth
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_PI_ANOM
  idchk = ss%id_pi_anom
  IF(ALLOCATED(ss%pi_anom).AND.hcheck(1,idchk)) THEN
     listname = "PI_ANOM_LIST"
     icomponent = ps_cnum_ANOM
     units = "W"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "W"
     label = "vol int: pi_anom"

     plabel = "anomalous ion heating"
     CALL ps_1d_prof_store(ss%iobj,"pi_anom","RHO_ANOMTH", &
          units,icomponent,plabel,ps_stepdv,ps_bc_dflt, &
          ss%nrho_anomth-1,0, &
          ss%pi_anom,ss%id_pi_anom, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "pi_anom"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_pi_anom
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_POHME
  idchk = ss%id_pohme
  IF(ALLOCATED(ss%pohme).AND.hcheck(1,idchk)) THEN
     listname = "POHME_LIST"
     icomponent = ps_cnum_PLASMA
     units = "W"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "W"
     label = "vol int: pohme"

     plabel = "Ohmic heating of electrons"
     CALL ps_1d_prof_store(ss%iobj,"pohme","RHO", &
          units,icomponent,plabel,ps_stepdv,ps_bc_dflt, &
          ss%nrho-1,0, &
          ss%pohme,ss%id_pohme, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "pohme"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_pohme
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_PSIPOL
  idchk = ss%id_psipol
  IF(ALLOCATED(ss%psipol).AND.hcheck(1,idchk)) THEN
     listname = "PSIPOL_LIST"
     icomponent = ps_cnum_EQ
     units = "Wb/rad"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "Wb/rad"
     label = "edge value: psipol"

     plabel = "poloidal flux vs. rho"
     CALL ps_1d_prof_store(ss%iobj,"psipol","RHO_EQ", &
          units,icomponent,plabel,ps_spline,ps_bc_grad00, &
          ss%nrho_eq,0, &
          ss%psipol,ss%id_psipol, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "psipol"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_psipol
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_PSIRZ
  idchk = ss%id_PsiRZ
  IF(ALLOCATED(ss%PsiRZ).AND.hcheck(1,idchk)) THEN
     listname = "PSIRZ_LIST"
     icomponent = ps_cnum_EQ
     units = "Wb/rad"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "Wb/rad"
     label = "simple avg: PsiRZ"

     plabel = "Psi(R,Z)"
     CALL ps_2d_prof_store(ss%iobj,"PsiRZ","R_GRID","Z_GRID", &
          units,icomponent,plabel,ps_spline,ps_bc_dflt, &
          ss%nr,ss%nz,0,0, &
          ss%PsiRZ,ss%id_PsiRZ, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "PsiRZ"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_PsiRZ
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_PSMOM_ERRCK
  idchk = ss%id_psmom_errck
  IF(ALLOCATED(ss%psmom_errck).AND.hcheck(1,idchk)) THEN
     listname = "PSMOM_ERRCK_LIST"
     icomponent = ps_cnum_EQ
     units = "-"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "-"
     label = "edge value: psmom_errck"

     plabel = "PS moments sum convergence"
     CALL ps_1d_prof_store(ss%iobj,"psmom_errck","RHO_EQ_GEO", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_eq_geo,0, &
          ss%psmom_errck,ss%id_psmom_errck, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "psmom_errck"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_psmom_errck
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_P_EQ
  idchk = ss%id_P_eq
  IF(ALLOCATED(ss%P_eq).AND.hcheck(1,idchk)) THEN
     listname = "P_EQ_LIST"
     icomponent = ps_cnum_EQ
     units = "Pa"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "Pa"
     label = "vol avg: P_eq"

     plabel = "equilibrium scalar pressure"
     CALL ps_1d_prof_store(ss%iobj,"P_eq","RHO_EQ", &
          units,icomponent,plabel,ps_spline,ps_bc_grad00, &
          ss%nrho_eq,0, &
          ss%P_eq,ss%id_P_eq, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "P_eq"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_P_eq
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_QIE
  idchk = ss%id_qie
  IF(ALLOCATED(ss%qie).AND.hcheck(1,idchk)) THEN
     listname = "QIE_LIST"
     icomponent = ps_cnum_PLASMA
     units = "W"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "W"
     label = "vol int: qie"

     plabel = "Ion->Electron heat coupling"
     CALL ps_1d_prof_store(ss%iobj,"qie","RHO", &
          units,icomponent,plabel,ps_stepdv,ps_bc_dflt, &
          ss%nrho-1,0, &
          ss%qie,ss%id_qie, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "qie"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_qie
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_Q_EQ
  idchk = ss%id_q_eq
  IF(ALLOCATED(ss%q_eq).AND.hcheck(1,idchk)) THEN
     listname = "Q_EQ_LIST"
     icomponent = ps_cnum_EQ
     units = "-"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "-"
     label = "edge value: q_eq"

     plabel = "equilibrium q profile"
     CALL ps_1d_prof_store(ss%iobj,"q_eq","RHO_EQ", &
          units,icomponent,plabel,ps_spline,ps_bc_dflt, &
          ss%nrho_eq,0, &
          ss%q_eq,ss%id_q_eq, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "q_eq"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_q_eq
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_R0_MOMEQ
  ahash(2) = ps_phash_DR0_MOMEQ_DRHO
  idchk = ss%id_R0_momeq
  IF(ALLOCATED(ss%R0_momeq).AND.hcheck(2,idchk)) THEN
     listname = "R0_MOMEQ_LIST"
     icomponent = ps_cnum_EQ
     units = "m"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "m"
     label = "edge value: R0_momeq"

     plabel = "R0 of flux surface"
     CALL ps_1dx_prof_store(ss%iobj,"R0_momeq","RHO_EQ", &
          units,icomponent,plabel, &
          ss%nrho_eq,0, &
          ss%R0_momeq,ss%dR0_momeq_dRHO,ss%id_R0_momeq, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "R0_momeq"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_R0_momeq
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_RES_TQ
  idchk = ss%id_res_tq
  IF(ALLOCATED(ss%res_tq).AND.hcheck(1,idchk)) THEN
     listname = "RES_TQ_LIST"
     icomponent = ps_cnum_PLASMA
     units = "Norm"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "Norm"
     label = "vol int: res_tq"

     plabel = "rediduals for angular momentum transport eqn"
     CALL ps_1d_prof_store(ss%iobj,"res_tq","RHO", &
          units,icomponent,plabel,ps_stepdv,ps_bc_dflt, &
          ss%nrho-1,0, &
          ss%res_tq,ss%id_res_tq, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "res_tq"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_res_tq
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_R_GEO
  ahash(2) = ps_phash_DR_GEO_DRHO
  ahash(3) = ps_phash_DR_GEO_DTH
  ahash(4) = ps_phash_D2R_GEO_DRHODTH
  idchk = ss%id_R_geo
  IF(ALLOCATED(ss%R_geo).AND.hcheck(4,idchk)) THEN
     listname = "R_GEO_LIST"
     icomponent = ps_cnum_EQ
     units = "m"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "m"
     label = "simple avg: R_geo"

     plabel = "flux surfaces R(rho,theta)"
     CALL ps_2dx_prof_store(ss%iobj,"R_geo","RHO_EQ","TH_EQ", &
          units,icomponent,plabel, &
          ss%nrho_eq,ss%nth_eq,0,ps_ccw_select, &
          ss%R_geo,ss%dR_geo_dRHO,ss%dR_geo_dTH,ss%d2R_geo_dRHOdTH,ss%id_R_geo, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "R_geo"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_R_geo
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_S0RECO_E
  idchk = ss%id_s0reco_e
  IF(ALLOCATED(ss%s0reco_e).AND.hcheck(1,idchk)) THEN
     listname = "S0RECO_E_LIST"
     icomponent = ps_cnum_GAS
     units = "#/sec"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "#/sec"
     label = "vol int: s0reco_e"

     plabel = "net electron source associated with recombination:"
     CALL ps_1d_prof_store(ss%iobj,"s0reco_e","RHO_GAS", &
          units,icomponent,plabel,ps_stepdv,ps_bc_dflt, &
          ss%nrho_gas-1,0, &
          ss%s0reco_e,ss%id_s0reco_e, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "s0reco_e"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_s0reco_e
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_SBEDEP
  idchk = ss%id_sbedep
  IF(ALLOCATED(ss%sbedep).AND.hcheck(1,idchk)) THEN
     listname = "SBEDEP_LIST"
     icomponent = ps_cnum_NBI
     units = "#/sec"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "#/sec"
     label = "vol int: sbedep"

     plabel = "beam deposition cold electron sce"
     CALL ps_1d_prof_store(ss%iobj,"sbedep","RHO_NBI", &
          units,icomponent,plabel,ps_stepdv,ps_bc_dflt, &
          ss%nrho_nbi-1,0, &
          ss%sbedep,ss%id_sbedep, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "sbedep"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_sbedep
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_SBEHALO
  idchk = ss%id_sbehalo
  IF(ALLOCATED(ss%sbehalo).AND.hcheck(1,idchk)) THEN
     listname = "SBEHALO_LIST"
     icomponent = ps_cnum_NBI
     units = "#/sec"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "#/sec"
     label = "vol int: sbehalo"

     plabel = "cold electron sce due to"
     CALL ps_1d_prof_store(ss%iobj,"sbehalo","RHO_NBI", &
          units,icomponent,plabel,ps_stepdv,ps_bc_dflt, &
          ss%nrho_nbi-1,0, &
          ss%sbehalo,ss%id_sbehalo, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "sbehalo"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_sbehalo
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_SURF
  idchk = ss%id_surf
  IF(ALLOCATED(ss%surf).AND.hcheck(1,idchk)) THEN
     listname = "SURF_LIST"
     icomponent = ps_cnum_EQ
     units = "m^2"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "m^2"
     label = "edge value: surf"

     plabel = "area of flux surfaces"
     CALL ps_1d_prof_store(ss%iobj,"surf","RHO_EQ", &
          units,icomponent,plabel,ps_spline,ps_bc_dflt, &
          ss%nrho_eq,0, &
          ss%surf,ss%id_surf, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "surf"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_surf
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_TI
  idchk = ss%id_Ti
  IF(ALLOCATED(ss%Ti).AND.hcheck(1,idchk)) THEN
     listname = "TI_LIST"
     icomponent = ps_cnum_PLASMA
     units = "keV"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "keV"
     label = "wght avg (NI): Ti"

     plabel = "ion temperature"
     CALL ps_1d_prof_store(ss%iobj,"Ti","RHO", &
          units,icomponent,plabel,ps_stepfun,ps_bc_dflt, &
          ss%nrho-1,0, &
          ss%Ti,ss%id_Ti, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "Ti"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_Ti
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_TMODEL
  idchk = ss%id_tmodel
  IF(ALLOCATED(ss%tmodel).AND.hcheck(1,idchk)) THEN
     listname = "TMODEL_LIST"
     icomponent = ps_cnum_ANOM
     units = "keV"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "keV"
     label = "wght avg (NMODEL): tmodel"

     plabel = "target temperature profile"
     CALL ps_1d_prof_store(ss%iobj,"tmodel","RHO_ANOMTH", &
          units,icomponent,plabel,ps_stepfun,ps_bc_dflt, &
          ss%nrho_anomth-1,0, &
          ss%tmodel,ss%id_tmodel, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "tmodel"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_tmodel
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_TQ_ANOM
  idchk = ss%id_tq_anom
  IF(ALLOCATED(ss%tq_anom).AND.hcheck(1,idchk)) THEN
     listname = "TQ_ANOM_LIST"
     icomponent = ps_cnum_ANOM
     units = "Nt*m"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "Nt*m"
     label = "vol int: tq_anom"

     plabel = "anomalous torque"
     CALL ps_1d_prof_store(ss%iobj,"tq_anom","RHO_ANOMTH", &
          units,icomponent,plabel,ps_stepdv,ps_bc_dflt, &
          ss%nrho_anomth-1,0, &
          ss%tq_anom,ss%id_tq_anom, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "tq_anom"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_tq_anom
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_TQ_TRANS
  idchk = ss%id_tq_trans
  IF(ALLOCATED(ss%tq_trans).AND.hcheck(1,idchk)) THEN
     listname = "TQ_TRANS_LIST"
     icomponent = ps_cnum_PLASMA
     units = "Nt*m"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "Nt*m"
     label = "vol int: tq_trans"

     plabel = "angular momentum transport (loss)"
     CALL ps_1d_prof_store(ss%iobj,"tq_trans","RHO", &
          units,icomponent,plabel,ps_stepdv,ps_bc_dflt, &
          ss%nrho-1,0, &
          ss%tq_trans,ss%id_tq_trans, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "tq_trans"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_tq_trans
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_VELNE_NCLASS
  idchk = ss%id_velne_nclass
  IF(ALLOCATED(ss%velne_nclass).AND.hcheck(1,idchk)) THEN
     listname = "VELNE_NCLASS_LIST"
     icomponent = ps_cnum_ANOM
     units = "m/sec"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "m/sec"
     label = "simple avg: velne_nclass"

     plabel = "electron-density-equations, advective velocity term from NCLASS model"
     CALL ps_1d_prof_store(ss%iobj,"velne_nclass","RHO_ANOMTH", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_anomth,0, &
          ss%velne_nclass,ss%id_velne_nclass, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "velne_nclass"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_velne_nclass
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_VELNH_NCLASS
  idchk = ss%id_velnh_nclass
  IF(ALLOCATED(ss%velnh_nclass).AND.hcheck(1,idchk)) THEN
     listname = "VELNH_NCLASS_LIST"
     icomponent = ps_cnum_ANOM
     units = "m/sec"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "m/sec"
     label = "simple avg: velnh_nclass"

     plabel = "main-hydrogenic-density-equations, advective velocity term from NCLASS model"
     CALL ps_1d_prof_store(ss%iobj,"velnh_nclass","RHO_ANOMTH", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_anomth,0, &
          ss%velnh_nclass,ss%id_velnh_nclass, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "velnh_nclass"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_velnh_nclass
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_VELNI_DRBM
  idchk = ss%id_velni_drbm
  IF(ALLOCATED(ss%velni_drbm).AND.hcheck(1,idchk)) THEN
     listname = "VELNI_DRBM_LIST"
     icomponent = ps_cnum_ANOM
     units = "m/s"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "m/s"
     label = "simple avg: velni_drbm"

     plabel = "ion convective velocity"
     CALL ps_1d_prof_store(ss%iobj,"velni_drbm","RHO_ANOMTH", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_anomth,0, &
          ss%velni_drbm,ss%id_velni_drbm, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "velni_drbm"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_velni_drbm
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_VELNX_NCLASS
  idchk = ss%id_velnx_nclass
  IF(ALLOCATED(ss%velnx_nclass).AND.hcheck(1,idchk)) THEN
     listname = "VELNX_NCLASS_LIST"
     icomponent = ps_cnum_ANOM
     units = "m/sec"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "m/sec"
     label = "simple avg: velnx_nclass"

     plabel = "main-impurity-density-equations, advective velocity term from NCLASS model"
     CALL ps_1d_prof_store(ss%iobj,"velnx_nclass","RHO_ANOMTH", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_anomth,0, &
          ss%velnx_nclass,ss%id_velnx_nclass, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "velnx_nclass"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_velnx_nclass
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_VELPPHI_ANOM
  idchk = ss%id_velpphi_anom
  IF(ALLOCATED(ss%velpphi_anom).AND.hcheck(1,idchk)) THEN
     listname = "VELPPHI_ANOM_LIST"
     icomponent = ps_cnum_ANOM
     units = "m/sec"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "m/sec"
     label = "simple avg: velpphi_anom"

     plabel = "momentum-equation, advective velocity term"
     CALL ps_1d_prof_store(ss%iobj,"velpphi_anom","RHO_ANOMTH", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_anomth,0, &
          ss%velpphi_anom,ss%id_velpphi_anom, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "velpphi_anom"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_velpphi_anom
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_VELPPHI_GLF
  idchk = ss%id_velpphi_glf
  IF(ALLOCATED(ss%velpphi_glf).AND.hcheck(1,idchk)) THEN
     listname = "VELPPHI_GLF_LIST"
     icomponent = ps_cnum_ANOM
     units = "m/sec"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "m/sec"
     label = "simple avg: velpphi_glf"

     plabel = "momentum-equation, advective velocity term from GLF23 model"
     CALL ps_1d_prof_store(ss%iobj,"velpphi_glf","RHO_ANOMTH", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_anomth,0, &
          ss%velpphi_glf,ss%id_velpphi_glf, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "velpphi_glf"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_velpphi_glf
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_VELPPHI_GTCNEO
  idchk = ss%id_velpphi_gtcneo
  IF(ALLOCATED(ss%velpphi_gtcneo).AND.hcheck(1,idchk)) THEN
     listname = "VELPPHI_GTCNEO_LIST"
     icomponent = ps_cnum_ANOM
     units = "m/sec"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "m/sec"
     label = "simple avg: velpphi_gtcneo"

     plabel = "momentum-equation, advective velocity term from GTC_NEO model"
     CALL ps_1d_prof_store(ss%iobj,"velpphi_gtcneo","RHO_ANOMTH", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_anomth,0, &
          ss%velpphi_gtcneo,ss%id_velpphi_gtcneo, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "velpphi_gtcneo"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_velpphi_gtcneo
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_VELPPHI_MMM71
  idchk = ss%id_velpphi_mmm71
  IF(ALLOCATED(ss%velpphi_mmm71).AND.hcheck(1,idchk)) THEN
     listname = "VELPPHI_MMM71_LIST"
     icomponent = ps_cnum_ANOM
     units = "m/sec"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "m/sec"
     label = "simple avg: velpphi_mmm71"

     plabel = "momentum-equation, advective velocity term from MMM71 model"
     CALL ps_1d_prof_store(ss%iobj,"velpphi_mmm71","RHO_ANOMTH", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_anomth,0, &
          ss%velpphi_mmm71,ss%id_velpphi_mmm71, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "velpphi_mmm71"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_velpphi_mmm71
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_VELPPHI_NEO
  idchk = ss%id_velpphi_neo
  IF(ALLOCATED(ss%velpphi_neo).AND.hcheck(1,idchk)) THEN
     listname = "VELPPHI_NEO_LIST"
     icomponent = ps_cnum_ANOM
     units = "m/sec"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "m/sec"
     label = "simple avg: velpphi_neo"

     plabel = "momentum-equation, advective velocity term from NEO model"
     CALL ps_1d_prof_store(ss%iobj,"velpphi_neo","RHO_ANOMTH", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_anomth,0, &
          ss%velpphi_neo,ss%id_velpphi_neo, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "velpphi_neo"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_velpphi_neo
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_VELPPHI_TGLF
  idchk = ss%id_velpphi_tglf
  IF(ALLOCATED(ss%velpphi_tglf).AND.hcheck(1,idchk)) THEN
     listname = "VELPPHI_TGLF_LIST"
     icomponent = ps_cnum_ANOM
     units = "m/sec"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "m/sec"
     label = "simple avg: velpphi_tglf"

     plabel = "momentum-equation, advective velocity term from TGLF model"
     CALL ps_1d_prof_store(ss%iobj,"velpphi_tglf","RHO_ANOMTH", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_anomth,0, &
          ss%velpphi_tglf,ss%id_velpphi_tglf, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "velpphi_tglf"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_velpphi_tglf
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_VELTE_ANOM
  idchk = ss%id_velte_anom
  IF(ALLOCATED(ss%velte_anom).AND.hcheck(1,idchk)) THEN
     listname = "VELTE_ANOM_LIST"
     icomponent = ps_cnum_ANOM
     units = "m/sec"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "m/sec"
     label = "simple avg: velte_anom"

     plabel = "Te-equation, advective velocity term"
     CALL ps_1d_prof_store(ss%iobj,"velte_anom","RHO_ANOMTH", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_anomth,0, &
          ss%velte_anom,ss%id_velte_anom, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "velte_anom"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_velte_anom
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_VELTE_GLF
  idchk = ss%id_velte_glf
  IF(ALLOCATED(ss%velte_glf).AND.hcheck(1,idchk)) THEN
     listname = "VELTE_GLF_LIST"
     icomponent = ps_cnum_ANOM
     units = "m/sec"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "m/sec"
     label = "simple avg: velte_glf"

     plabel = "Te-equation, advective velocity term from GLF23 model"
     CALL ps_1d_prof_store(ss%iobj,"velte_glf","RHO_ANOMTH", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_anomth,0, &
          ss%velte_glf,ss%id_velte_glf, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "velte_glf"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_velte_glf
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_VELTE_GTCNEO
  idchk = ss%id_velte_gtcneo
  IF(ALLOCATED(ss%velte_gtcneo).AND.hcheck(1,idchk)) THEN
     listname = "VELTE_GTCNEO_LIST"
     icomponent = ps_cnum_ANOM
     units = "m/sec"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "m/sec"
     label = "simple avg: velte_gtcneo"

     plabel = "Te-equation, advective velocity term from GTC_NEO model"
     CALL ps_1d_prof_store(ss%iobj,"velte_gtcneo","RHO_ANOMTH", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_anomth,0, &
          ss%velte_gtcneo,ss%id_velte_gtcneo, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "velte_gtcneo"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_velte_gtcneo
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_VELTE_MMM71
  idchk = ss%id_velte_mmm71
  IF(ALLOCATED(ss%velte_mmm71).AND.hcheck(1,idchk)) THEN
     listname = "VELTE_MMM71_LIST"
     icomponent = ps_cnum_ANOM
     units = "m/sec"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "m/sec"
     label = "simple avg: velte_mmm71"

     plabel = "Te-equation, advective velocity term from MMM71 model"
     CALL ps_1d_prof_store(ss%iobj,"velte_mmm71","RHO_ANOMTH", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_anomth,0, &
          ss%velte_mmm71,ss%id_velte_mmm71, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "velte_mmm71"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_velte_mmm71
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_VELTE_NCLASS
  idchk = ss%id_velte_nclass
  IF(ALLOCATED(ss%velte_nclass).AND.hcheck(1,idchk)) THEN
     listname = "VELTE_NCLASS_LIST"
     icomponent = ps_cnum_ANOM
     units = "m/sec"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "m/sec"
     label = "simple avg: velte_nclass"

     plabel = "Te-equation, advective velocity term from NCLASS model"
     CALL ps_1d_prof_store(ss%iobj,"velte_nclass","RHO_ANOMTH", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_anomth,0, &
          ss%velte_nclass,ss%id_velte_nclass, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "velte_nclass"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_velte_nclass
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_VELTE_NEO
  idchk = ss%id_velte_neo
  IF(ALLOCATED(ss%velte_neo).AND.hcheck(1,idchk)) THEN
     listname = "VELTE_NEO_LIST"
     icomponent = ps_cnum_ANOM
     units = "m/sec"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "m/sec"
     label = "simple avg: velte_neo"

     plabel = "Te-equation, advective velocity term from NEO model"
     CALL ps_1d_prof_store(ss%iobj,"velte_neo","RHO_ANOMTH", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_anomth,0, &
          ss%velte_neo,ss%id_velte_neo, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "velte_neo"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_velte_neo
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_VELTE_PALEO
  idchk = ss%id_velte_paleo
  IF(ALLOCATED(ss%velte_paleo).AND.hcheck(1,idchk)) THEN
     listname = "VELTE_PALEO_LIST"
     icomponent = ps_cnum_ANOM
     units = "m/sec"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "m/sec"
     label = "simple avg: velte_paleo"

     plabel = "Te-equation, convection term from PALEO model"
     CALL ps_1d_prof_store(ss%iobj,"velte_paleo","RHO_ANOMTH", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_anomth,0, &
          ss%velte_paleo,ss%id_velte_paleo, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "velte_paleo"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_velte_paleo
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_VELTE_TGLF
  idchk = ss%id_velte_tglf
  IF(ALLOCATED(ss%velte_tglf).AND.hcheck(1,idchk)) THEN
     listname = "VELTE_TGLF_LIST"
     icomponent = ps_cnum_ANOM
     units = "m/sec"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "m/sec"
     label = "simple avg: velte_tglf"

     plabel = "Te-equation, advective velocity term from TGLF model"
     CALL ps_1d_prof_store(ss%iobj,"velte_tglf","RHO_ANOMTH", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_anomth,0, &
          ss%velte_tglf,ss%id_velte_tglf, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "velte_tglf"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_velte_tglf
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_VELTI_ANOM
  idchk = ss%id_velti_anom
  IF(ALLOCATED(ss%velti_anom).AND.hcheck(1,idchk)) THEN
     listname = "VELTI_ANOM_LIST"
     icomponent = ps_cnum_ANOM
     units = "m/sec"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "m/sec"
     label = "simple avg: velti_anom"

     plabel = "Ti-equation, advective velocity term"
     CALL ps_1d_prof_store(ss%iobj,"velti_anom","RHO_ANOMTH", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_anomth,0, &
          ss%velti_anom,ss%id_velti_anom, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "velti_anom"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_velti_anom
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_VELTI_GLF
  idchk = ss%id_velti_glf
  IF(ALLOCATED(ss%velti_glf).AND.hcheck(1,idchk)) THEN
     listname = "VELTI_GLF_LIST"
     icomponent = ps_cnum_ANOM
     units = "m/sec"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "m/sec"
     label = "simple avg: velti_glf"

     plabel = "Ti-equation, advective velocity term from GLF23 model"
     CALL ps_1d_prof_store(ss%iobj,"velti_glf","RHO_ANOMTH", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_anomth,0, &
          ss%velti_glf,ss%id_velti_glf, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "velti_glf"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_velti_glf
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_VELTI_GTCNEO
  idchk = ss%id_velti_gtcneo
  IF(ALLOCATED(ss%velti_gtcneo).AND.hcheck(1,idchk)) THEN
     listname = "VELTI_GTCNEO_LIST"
     icomponent = ps_cnum_ANOM
     units = "m/sec"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "m/sec"
     label = "simple avg: velti_gtcneo"

     plabel = "Ti-equation, advective velocity term from GTC_NEO model"
     CALL ps_1d_prof_store(ss%iobj,"velti_gtcneo","RHO_ANOMTH", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_anomth,0, &
          ss%velti_gtcneo,ss%id_velti_gtcneo, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "velti_gtcneo"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_velti_gtcneo
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_VELTI_MMM71
  idchk = ss%id_velti_mmm71
  IF(ALLOCATED(ss%velti_mmm71).AND.hcheck(1,idchk)) THEN
     listname = "VELTI_MMM71_LIST"
     icomponent = ps_cnum_ANOM
     units = "m/sec"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "m/sec"
     label = "simple avg: velti_mmm71"

     plabel = "Ti-equation, advective velocity term from MMM71 model"
     CALL ps_1d_prof_store(ss%iobj,"velti_mmm71","RHO_ANOMTH", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_anomth,0, &
          ss%velti_mmm71,ss%id_velti_mmm71, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "velti_mmm71"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_velti_mmm71
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_VELTI_NCLASS
  idchk = ss%id_velti_nclass
  IF(ALLOCATED(ss%velti_nclass).AND.hcheck(1,idchk)) THEN
     listname = "VELTI_NCLASS_LIST"
     icomponent = ps_cnum_ANOM
     units = "m/sec"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "m/sec"
     label = "simple avg: velti_nclass"

     plabel = "Ti-equation, advective velocity term from NCLASS model"
     CALL ps_1d_prof_store(ss%iobj,"velti_nclass","RHO_ANOMTH", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_anomth,0, &
          ss%velti_nclass,ss%id_velti_nclass, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "velti_nclass"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_velti_nclass
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_VELTI_NEO
  idchk = ss%id_velti_neo
  IF(ALLOCATED(ss%velti_neo).AND.hcheck(1,idchk)) THEN
     listname = "VELTI_NEO_LIST"
     icomponent = ps_cnum_ANOM
     units = "m/sec"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "m/sec"
     label = "simple avg: velti_neo"

     plabel = "Ti-equation, advective velocity term from NEO model"
     CALL ps_1d_prof_store(ss%iobj,"velti_neo","RHO_ANOMTH", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_anomth,0, &
          ss%velti_neo,ss%id_velti_neo, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "velti_neo"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_velti_neo
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_VELTI_TGLF
  idchk = ss%id_velti_tglf
  IF(ALLOCATED(ss%velti_tglf).AND.hcheck(1,idchk)) THEN
     listname = "VELTI_TGLF_LIST"
     icomponent = ps_cnum_ANOM
     units = "m/sec"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "m/sec"
     label = "simple avg: velti_tglf"

     plabel = "Ti-equation, advective velocity term from TGLF model"
     CALL ps_1d_prof_store(ss%iobj,"velti_tglf","RHO_ANOMTH", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_anomth,0, &
          ss%velti_tglf,ss%id_velti_tglf, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "velti_tglf"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_velti_tglf
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_V_LOOP
  idchk = ss%id_V_loop
  IF(ALLOCATED(ss%V_loop).AND.hcheck(1,idchk)) THEN
     listname = "V_LOOP_LIST"
     icomponent = ps_cnum_PLASMA
     units = "Volts"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "Volts"
     label = "simple avg: V_loop"

     plabel = "loop voltage"
     CALL ps_1d_prof_store(ss%iobj,"V_loop","RHO", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho,0, &
          ss%V_loop,ss%id_V_loop, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "V_loop"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_V_loop
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_Z0_MOMEQ
  ahash(2) = ps_phash_DZ0_MOMEQ_DRHO
  idchk = ss%id_Z0_momeq
  IF(ALLOCATED(ss%Z0_momeq).AND.hcheck(2,idchk)) THEN
     listname = "Z0_MOMEQ_LIST"
     icomponent = ps_cnum_EQ
     units = "m"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "m"
     label = "edge value: Z0_momeq"

     plabel = "Z0 of flux surface"
     CALL ps_1dx_prof_store(ss%iobj,"Z0_momeq","RHO_EQ", &
          units,icomponent,plabel, &
          ss%nrho_eq,0, &
          ss%Z0_momeq,ss%dZ0_momeq_dRHO,ss%id_Z0_momeq, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "Z0_momeq"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_Z0_momeq
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_Z_GEO
  ahash(2) = ps_phash_DZ_GEO_DRHO
  ahash(3) = ps_phash_DZ_GEO_DTH
  ahash(4) = ps_phash_D2Z_GEO_DRHODTH
  idchk = ss%id_Z_geo
  IF(ALLOCATED(ss%Z_geo).AND.hcheck(4,idchk)) THEN
     listname = "Z_GEO_LIST"
     icomponent = ps_cnum_EQ
     units = "m"
     nitems = 1
     ! for assoc. scalar list:
     list_units = "m"
     label = "simple avg: Z_geo"

     plabel = "flux surfaces Z(rho,theta)"
     CALL ps_2dx_prof_store(ss%iobj,"Z_geo","RHO_EQ","TH_EQ", &
          units,icomponent,plabel, &
          ss%nrho_eq,ss%nth_eq,0,ps_ccw_select, &
          ss%Z_geo,ss%dZ_geo_dRHO,ss%dZ_geo_dTH,ss%d2Z_geo_dRHOdTH,ss%id_Z_geo, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "Z_geo"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_Z_geo
     item_c256(1) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

CONTAINS

  LOGICAL FUNCTION hcheck(inum,idchk)
     INTEGER, intent(in) :: inum
     INTEGER, intent(in) :: idchk

     !  check all hash codes: set function value TRUE if any show changes.
     !  also set TRUE if idchk = 0

     INTEGER :: ia1,ia2,ii

     if(idchk.eq.0) then
        hcheck=.TRUE.
        return
     endif

     hcheck = .FALSE.
     DO ii=1,inum
        hcheck = .TRUE.
        ia1 = ahash(ii)
        ia2 = ia1 + 1
        IF(ss%hash_codes(ia1).NE.ss%new_hash_codes(ia1)) EXIT
        IF(ss%hash_codes(ia2).NE.ss%new_hash_codes(ia2)) EXIT
        IF(xhash(ia1).NE.ss%new_hash_codes(ia1)) EXIT
        IF(xhash(ia2).NE.ss%new_hash_codes(ia2)) EXIT
        hcheck = .FALSE.
     ENDDO
  END FUNCTION hcheck

  SUBROUTINE lefpack(str)
     CHARACTER*(*), intent(inout) :: str
     !  left pack non-blank characters in str

     INTEGER :: ii,jj
     ii=0
     DO jj=1,len(str)
        IF(str(jj:jj).NE.' ') THEN
           ii = ii + 1
           str(ii:ii) = str(jj:jj)
        ENDIF
     ENDDO
     str(ii+1:) = ' '
  END SUBROUTINE lefpack

END SUBROUTINE plasma_state_xload_psingl

subroutine ccps_set_debug_level(idebug,ierr)

  ! Set global debug level

  use plasma_state_mod
  implicit NONE
  integer, intent(in) :: idebug ! 0, 1, 2, or 3
  integer, intent(out) :: ierr    ! status code returned, 0=normal

  ierr = 0
  ps_debug = idebug

end subroutine ccps_set_debug_level

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


SUBROUTINE plasma_state_get(filename,ss,ierr)

  ! get (i.e. read from file) plasma state
  ! this overwrites any prior contents that might have been in state "ss".

  USE plasma_state_definition_mod
  USE netcdf
  IMPLICIT NONE

  CHARACTER*(*), INTENT(IN) :: filename        ! state file
  TYPE (plasma_state) :: ss     ! state data to read
  INTEGER, INTENT(OUT) :: ierr  ! completion code (0=OK)

  !--------------

  INTEGER :: icdf,iout,varid,dimid,status,iertot,ilen,jlen,idims(20),indim
  INTEGER :: ii,iflag_alloc2,iflag_loc2,isize
  LOGICAL :: version_change
  CHARACTER*80 :: nc_errmsg
  CHARACTER*32 :: dimname
  INTEGER ilocka(3)

  !--------------
  ! Initialization...

  iout = SWIM_err_out_file
  version_change = .FALSE.

  iertot = 0
  CALL ps_init_xpl(ss%iobj,iout,ierr)
  IF(ierr.NE.0) THEN
     WRITE(iout,*) ' ?plasma_state_get: "ps_init_xpl" error prior to file read.'
     iertot = iertot + 1
  ENDIF

  CALL plasma_state_erase(ss,ierr)
  IF(ierr.NE.0) THEN
     WRITE(iout,*) ' ?plasma_state_get: "plasma_state_erase" error prior to file read.'
     iertot = iertot + 1
  ENDIF

  IF(iertot.GT.0) THEN
     ierr=9999
     RETURN
  ENDIF

  ! ********* OPEN the NetCDF file **********

  status = nf90_open(trim(filename),NF90_NOWRITE,icdf)
  IF(status.NE.NF90_NOERR) THEN
     CALL ncerr(status)
     WRITE(iout,*) ' ?plasma_state_get: file open failure: "'//trim(filename)//'".'
     ierr=9999
     RETURN
  ENDIF

  ! ********* READ header information
  ! ...check for version_id mismatch

  status = nf90_inq_varid(icdf,"ps_partial_update",varid)
  if(status.EQ.NF90_NOERR) THEN
     WRITE(iout,*) ' ?plasma_state_get: file contains "ps_partial_update"!'
     WRITE(iout,*) '  This routine can only read full states, not partial states.'
     ierr=9999
     status = nf90_close(icdf)
     RETURN
  ENDIF

  status = nf90_inq_varid(icdf,"version_id",varid)
  IF(status.NE.NF90_NOERR) THEN
     CALL ncerr(status)
     WRITE(iout,*) ' ?plasma_state_get: "version_id" not found.'
     ierr=9999
     status = nf90_close(icdf)
     RETURN
  ENDIF

  status = nf90_get_var(icdf,varid,ss%version_id)
  IF(status.NE.NF90_NOERR) THEN
     CALL ncerr(status)
     WRITE(iout,*) ' ?plasma_state_get: "version_id" read error.'
     ierr=9999
     status = nf90_close(icdf)
     RETURN
  ENDIF
  CALL denull(ss%version_id)

  IF(ss%version_id.NE.ps_version_id) THEN
     WRITE(iout,*) ' '
     WRITE(iout,*) ' %plasma_state_get: WARNING, version_id mismatch:'
     WRITE(iout,*) '  Version_ID of current software: "'//trim(ps_version_id)//'".'
     WRITE(iout,*) '  Version_ID found in file:       "'//trim(ss%version_id)//'".'
     WRITE(iout,*) ' '
     WRITE(iout,*) '  ...Hash code checks disabled.'
     WRITE(iout,*) '  ...Error handling modified.'
     WRITE(iout,*) ' '
     version_change = .TRUE.
     ss%hash_codes = 0   ! these cannot be used in case of version_change
  ENDIF

  IF(.not.version_change) THEN

     ! hash codes -- these are used to enforce "locks" on data sections
     ! that are meant to be time invariant after initialization...

     status = nf90_inq_varid(icdf,"hash_codes",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr(status)
        WRITE(iout,*) ' ?plasma_state_get: "hash_codes" not found.'
        ierr=9999
        status = nf90_close(icdf)
        RETURN
     ENDIF

     status = nf90_get_var(icdf,varid,ss%hash_codes)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr(status)
        WRITE(iout,*) ' ?plasma_state_get: "hash_codes" read error.'
        ierr=9999
        status = nf90_close(icdf)
        RETURN
     ENDIF
  ENDIF

  !----------------------------------------------------

  ! *** (scalar) Array Dimensions ***
  ss%active_dims = 0

  ss%max_nrz_antgeo = 0
  status = nf90_inq_dimid(icdf,"dim_max_nrz_antgeo",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ss%max_nrz_antgeo)
     IF(status.NE.NF90_NOERR) THEN
        ss%max_nrz_antgeo = 0
        CALL ncerr_name(2,status,"max_nrz_antgeo")
     ENDIF
  ENDIF
  IF(ss%max_nrz_antgeo.GT.0) THEN
     ss%active_dims(ps_cnum_IC) = ss%active_dims(ps_cnum_IC) + 1
  ENDIF

  ss%max_nspectrumlh_src = 0
  status = nf90_inq_dimid(icdf,"dim_max_nspectrumlh_src",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ss%max_nspectrumlh_src)
     IF(status.NE.NF90_NOERR) THEN
        ss%max_nspectrumlh_src = 0
        CALL ncerr_name(2,status,"max_nspectrumlh_src")
     ENDIF
  ENDIF
  IF(ss%max_nspectrumlh_src.GT.0) THEN
     ss%active_dims(ps_cnum_LH) = ss%active_dims(ps_cnum_LH) + 1
  ENDIF

  ss%max_num_nphi = 0
  status = nf90_inq_dimid(icdf,"dim_max_num_nphi",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ss%max_num_nphi)
     IF(status.NE.NF90_NOERR) THEN
        ss%max_num_nphi = 0
        CALL ncerr_name(2,status,"max_num_nphi")
     ENDIF
  ENDIF
  IF(ss%max_num_nphi.GT.0) THEN
     ss%active_dims(ps_cnum_IC) = ss%active_dims(ps_cnum_IC) + 1
  ENDIF

  ss%max_num_nphi_vac = 0
  status = nf90_inq_dimid(icdf,"dim_max_num_nphi_vac",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ss%max_num_nphi_vac)
     IF(status.NE.NF90_NOERR) THEN
        ss%max_num_nphi_vac = 0
        CALL ncerr_name(2,status,"max_num_nphi_vac")
     ENDIF
  ENDIF
  IF(ss%max_num_nphi_vac.GT.0) THEN
     ss%active_dims(ps_cnum_IC) = ss%active_dims(ps_cnum_IC) + 1
  ENDIF

  ss%max_n_straps = 0
  status = nf90_inq_dimid(icdf,"dim_max_n_straps",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ss%max_n_straps)
     IF(status.NE.NF90_NOERR) THEN
        ss%max_n_straps = 0
        CALL ncerr_name(2,status,"max_n_straps")
     ENDIF
  ENDIF
  IF(ss%max_n_straps.GT.0) THEN
     ss%active_dims(ps_cnum_IC) = ss%active_dims(ps_cnum_IC) + 1
  ENDIF

  ss%mmodes = 0
  status = nf90_inq_dimid(icdf,"dim_mmodes",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ss%mmodes)
     IF(status.NE.NF90_NOERR) THEN
        ss%mmodes = 0
        CALL ncerr_name(2,status,"mmodes")
     ENDIF
  ENDIF
  IF(ss%mmodes.GT.0) THEN
     ss%active_dims(ps_cnum_LMHD) = ss%active_dims(ps_cnum_LMHD) + 1
  ENDIF

  ss%nballoon = 0
  status = nf90_inq_dimid(icdf,"dim_nballoon",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ss%nballoon)
     IF(status.NE.NF90_NOERR) THEN
        ss%nballoon = 0
        CALL ncerr_name(2,status,"nballoon")
     ENDIF
  ENDIF
  IF(ss%nballoon.GT.0) THEN
     ss%active_dims(ps_cnum_LMHD) = ss%active_dims(ps_cnum_LMHD) + 1
  ENDIF

  ss%nbeam = 0
  status = nf90_inq_dimid(icdf,"dim_nbeam",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ss%nbeam)
     IF(status.NE.NF90_NOERR) THEN
        ss%nbeam = 0
        CALL ncerr_name(2,status,"nbeam")
     ENDIF
  ENDIF
  IF(ss%nbeam.GT.0) THEN
     ss%active_dims(ps_cnum_NBI) = ss%active_dims(ps_cnum_NBI) + 1
  ENDIF

  ss%ncircuits = 0
  status = nf90_inq_dimid(icdf,"dim_ncircuits",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ss%ncircuits)
     IF(status.NE.NF90_NOERR) THEN
        ss%ncircuits = 0
        CALL ncerr_name(2,status,"ncircuits")
     ENDIF
  ENDIF
  IF(ss%ncircuits.GT.0) THEN
     ss%active_dims(ps_cnum_EQ) = ss%active_dims(ps_cnum_EQ) + 1
  ENDIF

  ss%ncoils = 0
  status = nf90_inq_dimid(icdf,"dim_ncoils",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ss%ncoils)
     IF(status.NE.NF90_NOERR) THEN
        ss%ncoils = 0
        CALL ncerr_name(2,status,"ncoils")
     ENDIF
  ENDIF
  IF(ss%ncoils.GT.0) THEN
     ss%active_dims(ps_cnum_EQ) = ss%active_dims(ps_cnum_EQ) + 1
  ENDIF

  ss%ndelta_w = 0
  status = nf90_inq_dimid(icdf,"dim_ndelta_w",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ss%ndelta_w)
     IF(status.NE.NF90_NOERR) THEN
        ss%ndelta_w = 0
        CALL ncerr_name(2,status,"ndelta_w")
     ENDIF
  ENDIF
  IF(ss%ndelta_w.GT.0) THEN
     ss%active_dims(ps_cnum_LMHD) = ss%active_dims(ps_cnum_LMHD) + 1
  ENDIF

  ss%necrf_src = 0
  status = nf90_inq_dimid(icdf,"dim_necrf_src",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ss%necrf_src)
     IF(status.NE.NF90_NOERR) THEN
        ss%necrf_src = 0
        CALL ncerr_name(2,status,"necrf_src")
     ENDIF
  ENDIF
  IF(ss%necrf_src.GT.0) THEN
     ss%active_dims(ps_cnum_EC) = ss%active_dims(ps_cnum_EC) + 1
  ENDIF

  ss%nefi_anom = 0
  status = nf90_inq_dimid(icdf,"dim_nefi_anom",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ss%nefi_anom)
     IF(status.NE.NF90_NOERR) THEN
        ss%nefi_anom = 0
        CALL ncerr_name(2,status,"nefi_anom")
     ENDIF
  ENDIF
  IF(ss%nefi_anom.GT.0) THEN
     ss%active_dims(ps_cnum_ANOM) = ss%active_dims(ps_cnum_ANOM) + 1
  ENDIF

  ss%nefi_anom2 = 0
  status = nf90_inq_dimid(icdf,"dim_nefi_anom2",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ss%nefi_anom2)
     IF(status.NE.NF90_NOERR) THEN
        ss%nefi_anom2 = 0
        CALL ncerr_name(2,status,"nefi_anom2")
     ENDIF
  ENDIF
  IF(ss%nefi_anom2.GT.0) THEN
     ss%active_dims(ps_cnum_ANOM) = ss%active_dims(ps_cnum_ANOM) + 1
  ENDIF

  ss%neqmom = 0
  status = nf90_inq_dimid(icdf,"dim_neqmom",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ss%neqmom)
     IF(status.NE.NF90_NOERR) THEN
        ss%neqmom = 0
        CALL ncerr_name(2,status,"neqmom")
     ENDIF
  ENDIF
  IF(ss%neqmom.GT.0) THEN
     ss%active_dims(ps_cnum_EQ) = ss%active_dims(ps_cnum_EQ) + 1
  ENDIF

  ss%ngsc0 = 0
  status = nf90_inq_dimid(icdf,"dim_ngsc0",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ss%ngsc0)
     IF(status.NE.NF90_NOERR) THEN
        ss%ngsc0 = 0
        CALL ncerr_name(2,status,"ngsc0")
     ENDIF
  ENDIF
  IF(ss%ngsc0.GT.0) THEN
     ss%active_dims(ps_cnum_GAS) = ss%active_dims(ps_cnum_GAS) + 1
  ENDIF

  ss%nicrf_src = 0
  status = nf90_inq_dimid(icdf,"dim_nicrf_src",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ss%nicrf_src)
     IF(status.NE.NF90_NOERR) THEN
        ss%nicrf_src = 0
        CALL ncerr_name(2,status,"nicrf_src")
     ENDIF
  ENDIF
  IF(ss%nicrf_src.GT.0) THEN
     ss%active_dims(ps_cnum_IC) = ss%active_dims(ps_cnum_IC) + 1
  ENDIF

  ss%nky_anomth = 0
  status = nf90_inq_dimid(icdf,"dim_nky_anomth",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ss%nky_anomth)
     IF(status.NE.NF90_NOERR) THEN
        ss%nky_anomth = 0
        CALL ncerr_name(2,status,"nky_anomth")
     ENDIF
  ENDIF
  IF(ss%nky_anomth.GT.0) THEN
     ss%active_dims(ps_cnum_ANOM) = ss%active_dims(ps_cnum_ANOM) + 1
  ENDIF

  ss%nky_mmm = 0
  status = nf90_inq_dimid(icdf,"dim_nky_mmm",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ss%nky_mmm)
     IF(status.NE.NF90_NOERR) THEN
        ss%nky_mmm = 0
        CALL ncerr_name(2,status,"nky_mmm")
     ENDIF
  ENDIF
  IF(ss%nky_mmm.GT.0) THEN
     ss%active_dims(ps_cnum_ANOM) = ss%active_dims(ps_cnum_ANOM) + 1
  ENDIF

  ss%nlhrf_src = 0
  status = nf90_inq_dimid(icdf,"dim_nlhrf_src",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ss%nlhrf_src)
     IF(status.NE.NF90_NOERR) THEN
        ss%nlhrf_src = 0
        CALL ncerr_name(2,status,"nlhrf_src")
     ENDIF
  ENDIF
  IF(ss%nlhrf_src.GT.0) THEN
     ss%active_dims(ps_cnum_LH) = ss%active_dims(ps_cnum_LH) + 1
  ENDIF

  ss%nnewcomb = 0
  status = nf90_inq_dimid(icdf,"dim_nnewcomb",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ss%nnewcomb)
     IF(status.NE.NF90_NOERR) THEN
        ss%nnewcomb = 0
        CALL ncerr_name(2,status,"nnewcomb")
     ENDIF
  ENDIF
  IF(ss%nnewcomb.GT.0) THEN
     ss%active_dims(ps_cnum_LMHD) = ss%active_dims(ps_cnum_LMHD) + 1
  ENDIF

  ss%npsmom = 0
  status = nf90_inq_dimid(icdf,"dim_npsmom",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ss%npsmom)
     IF(status.NE.NF90_NOERR) THEN
        ss%npsmom = 0
        CALL ncerr_name(2,status,"npsmom")
     ENDIF
  ENDIF
  IF(ss%npsmom.GT.0) THEN
     ss%active_dims(ps_cnum_EQ) = ss%active_dims(ps_cnum_EQ) + 1
  ENDIF

  ss%nr = 0
  status = nf90_inq_dimid(icdf,"dim_nr",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ss%nr)
     IF(status.NE.NF90_NOERR) THEN
        ss%nr = 0
        CALL ncerr_name(2,status,"nr")
     ENDIF
  ENDIF
  IF(ss%nr.GT.0) THEN
     ss%active_dims(ps_cnum_EQ) = ss%active_dims(ps_cnum_EQ) + 1
  ENDIF

  ss%nrho = 0
  status = nf90_inq_dimid(icdf,"dim_nrho",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ss%nrho)
     IF(status.NE.NF90_NOERR) THEN
        ss%nrho = 0
        CALL ncerr_name(2,status,"nrho")
     ENDIF
  ENDIF
  IF(ss%nrho.GT.0) THEN
     ss%active_dims(ps_cnum_PLASMA) = ss%active_dims(ps_cnum_PLASMA) + 1
  ENDIF

  ss%nrho_anom = 0
  status = nf90_inq_dimid(icdf,"dim_nrho_anom",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ss%nrho_anom)
     IF(status.NE.NF90_NOERR) THEN
        ss%nrho_anom = 0
        CALL ncerr_name(2,status,"nrho_anom")
     ENDIF
  ENDIF
  IF(ss%nrho_anom.GT.0) THEN
     ss%active_dims(ps_cnum_ANOM) = ss%active_dims(ps_cnum_ANOM) + 1
  ENDIF

  ss%nrho_anom2 = 0
  status = nf90_inq_dimid(icdf,"dim_nrho_anom2",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ss%nrho_anom2)
     IF(status.NE.NF90_NOERR) THEN
        ss%nrho_anom2 = 0
        CALL ncerr_name(2,status,"nrho_anom2")
     ENDIF
  ENDIF
  IF(ss%nrho_anom2.GT.0) THEN
     ss%active_dims(ps_cnum_ANOM) = ss%active_dims(ps_cnum_ANOM) + 1
  ENDIF

  ss%nrho_anomth = 0
  status = nf90_inq_dimid(icdf,"dim_nrho_anomth",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ss%nrho_anomth)
     IF(status.NE.NF90_NOERR) THEN
        ss%nrho_anomth = 0
        CALL ncerr_name(2,status,"nrho_anomth")
     ENDIF
  ENDIF
  IF(ss%nrho_anomth.GT.0) THEN
     ss%active_dims(ps_cnum_ANOM) = ss%active_dims(ps_cnum_ANOM) + 1
  ENDIF

  ss%nrho_ecrf = 0
  status = nf90_inq_dimid(icdf,"dim_nrho_ecrf",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ss%nrho_ecrf)
     IF(status.NE.NF90_NOERR) THEN
        ss%nrho_ecrf = 0
        CALL ncerr_name(2,status,"nrho_ecrf")
     ENDIF
  ENDIF
  IF(ss%nrho_ecrf.GT.0) THEN
     ss%active_dims(ps_cnum_EC) = ss%active_dims(ps_cnum_EC) + 1
  ENDIF

  ss%nrho_eq = 0
  status = nf90_inq_dimid(icdf,"dim_nrho_eq",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ss%nrho_eq)
     IF(status.NE.NF90_NOERR) THEN
        ss%nrho_eq = 0
        CALL ncerr_name(2,status,"nrho_eq")
     ENDIF
  ENDIF
  IF(ss%nrho_eq.GT.0) THEN
     ss%active_dims(ps_cnum_EQ) = ss%active_dims(ps_cnum_EQ) + 1
  ENDIF

  ss%nrho_eq_geo = 0
  status = nf90_inq_dimid(icdf,"dim_nrho_eq_geo",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ss%nrho_eq_geo)
     IF(status.NE.NF90_NOERR) THEN
        ss%nrho_eq_geo = 0
        CALL ncerr_name(2,status,"nrho_eq_geo")
     ENDIF
  ENDIF
  IF(ss%nrho_eq_geo.GT.0) THEN
     ss%active_dims(ps_cnum_EQ) = ss%active_dims(ps_cnum_EQ) + 1
  ENDIF

  ss%nrho_fus = 0
  status = nf90_inq_dimid(icdf,"dim_nrho_fus",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ss%nrho_fus)
     IF(status.NE.NF90_NOERR) THEN
        ss%nrho_fus = 0
        CALL ncerr_name(2,status,"nrho_fus")
     ENDIF
  ENDIF
  IF(ss%nrho_fus.GT.0) THEN
     ss%active_dims(ps_cnum_FUS) = ss%active_dims(ps_cnum_FUS) + 1
  ENDIF

  ss%nrho_gas = 0
  status = nf90_inq_dimid(icdf,"dim_nrho_gas",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ss%nrho_gas)
     IF(status.NE.NF90_NOERR) THEN
        ss%nrho_gas = 0
        CALL ncerr_name(2,status,"nrho_gas")
     ENDIF
  ENDIF
  IF(ss%nrho_gas.GT.0) THEN
     ss%active_dims(ps_cnum_GAS) = ss%active_dims(ps_cnum_GAS) + 1
  ENDIF

  ss%nrho_icrf = 0
  status = nf90_inq_dimid(icdf,"dim_nrho_icrf",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ss%nrho_icrf)
     IF(status.NE.NF90_NOERR) THEN
        ss%nrho_icrf = 0
        CALL ncerr_name(2,status,"nrho_icrf")
     ENDIF
  ENDIF
  IF(ss%nrho_icrf.GT.0) THEN
     ss%active_dims(ps_cnum_IC) = ss%active_dims(ps_cnum_IC) + 1
  ENDIF

  ss%nrho_lhrf = 0
  status = nf90_inq_dimid(icdf,"dim_nrho_lhrf",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ss%nrho_lhrf)
     IF(status.NE.NF90_NOERR) THEN
        ss%nrho_lhrf = 0
        CALL ncerr_name(2,status,"nrho_lhrf")
     ENDIF
  ENDIF
  IF(ss%nrho_lhrf.GT.0) THEN
     ss%active_dims(ps_cnum_LH) = ss%active_dims(ps_cnum_LH) + 1
  ENDIF

  ss%nrho_lmhd = 0
  status = nf90_inq_dimid(icdf,"dim_nrho_lmhd",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ss%nrho_lmhd)
     IF(status.NE.NF90_NOERR) THEN
        ss%nrho_lmhd = 0
        CALL ncerr_name(2,status,"nrho_lmhd")
     ENDIF
  ENDIF
  IF(ss%nrho_lmhd.GT.0) THEN
     ss%active_dims(ps_cnum_LMHD) = ss%active_dims(ps_cnum_LMHD) + 1
  ENDIF

  ss%nrho_mist = 0
  status = nf90_inq_dimid(icdf,"dim_nrho_mist",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ss%nrho_mist)
     IF(status.NE.NF90_NOERR) THEN
        ss%nrho_mist = 0
        CALL ncerr_name(2,status,"nrho_mist")
     ENDIF
  ENDIF
  IF(ss%nrho_mist.GT.0) THEN
     ss%active_dims(ps_cnum_RAD) = ss%active_dims(ps_cnum_RAD) + 1
  ENDIF

  ss%nrho_nbi = 0
  status = nf90_inq_dimid(icdf,"dim_nrho_nbi",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ss%nrho_nbi)
     IF(status.NE.NF90_NOERR) THEN
        ss%nrho_nbi = 0
        CALL ncerr_name(2,status,"nrho_nbi")
     ENDIF
  ENDIF
  IF(ss%nrho_nbi.GT.0) THEN
     ss%active_dims(ps_cnum_NBI) = ss%active_dims(ps_cnum_NBI) + 1
  ENDIF

  ss%nrho_pel = 0
  status = nf90_inq_dimid(icdf,"dim_nrho_pel",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ss%nrho_pel)
     IF(status.NE.NF90_NOERR) THEN
        ss%nrho_pel = 0
        CALL ncerr_name(2,status,"nrho_pel")
     ENDIF
  ENDIF
  IF(ss%nrho_pel.GT.0) THEN
     ss%active_dims(ps_cnum_PEL) = ss%active_dims(ps_cnum_PEL) + 1
  ENDIF

  ss%nrho_rad = 0
  status = nf90_inq_dimid(icdf,"dim_nrho_rad",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ss%nrho_rad)
     IF(status.NE.NF90_NOERR) THEN
        ss%nrho_rad = 0
        CALL ncerr_name(2,status,"nrho_rad")
     ENDIF
  ENDIF
  IF(ss%nrho_rad.GT.0) THEN
     ss%active_dims(ps_cnum_RAD) = ss%active_dims(ps_cnum_RAD) + 1
  ENDIF

  ss%nrho_rw = 0
  status = nf90_inq_dimid(icdf,"dim_nrho_rw",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ss%nrho_rw)
     IF(status.NE.NF90_NOERR) THEN
        ss%nrho_rw = 0
        CALL ncerr_name(2,status,"nrho_rw")
     ENDIF
  ENDIF
  IF(ss%nrho_rw.GT.0) THEN
     ss%active_dims(ps_cnum_RUNAWAY) = ss%active_dims(ps_cnum_RUNAWAY) + 1
  ENDIF

  ss%nr_rip = 0
  status = nf90_inq_dimid(icdf,"dim_nr_rip",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ss%nr_rip)
     IF(status.NE.NF90_NOERR) THEN
        ss%nr_rip = 0
        CALL ncerr_name(2,status,"nr_rip")
     ENDIF
  ENDIF
  IF(ss%nr_rip.GT.0) THEN
     ss%active_dims(ps_cnum_RIPPLE) = ss%active_dims(ps_cnum_RIPPLE) + 1
  ENDIF

  ss%nspec_all = 0
  status = nf90_inq_dimid(icdf,"dim_nspec_all",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ss%nspec_all)
     IF(status.NE.NF90_NOERR) THEN
        ss%nspec_all = 0
        CALL ncerr_name(2,status,"nspec_all")
     ENDIF
  ENDIF
  IF(ss%nspec_all.GT.0) THEN
     ss%active_dims(ps_cnum_PLASMA) = ss%active_dims(ps_cnum_PLASMA) + 1
  ENDIF

  ss%nspec_alla = 0
  status = nf90_inq_dimid(icdf,"dim_nspec_alla",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ss%nspec_alla)
     IF(status.NE.NF90_NOERR) THEN
        ss%nspec_alla = 0
        CALL ncerr_name(2,status,"nspec_alla")
     ENDIF
  ENDIF
  IF(ss%nspec_alla.GT.0) THEN
     ss%active_dims(ps_cnum_PLASMA) = ss%active_dims(ps_cnum_PLASMA) + 1
  ENDIF

  ss%nspec_beam = 0
  status = nf90_inq_dimid(icdf,"dim_nspec_beam",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ss%nspec_beam)
     IF(status.NE.NF90_NOERR) THEN
        ss%nspec_beam = 0
        CALL ncerr_name(2,status,"nspec_beam")
     ENDIF
  ENDIF
  IF(ss%nspec_beam.GT.0) THEN
     ss%active_dims(ps_cnum_NBI) = ss%active_dims(ps_cnum_NBI) + 1
  ENDIF

  ss%nspec_fusion = 0
  status = nf90_inq_dimid(icdf,"dim_nspec_fusion",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ss%nspec_fusion)
     IF(status.NE.NF90_NOERR) THEN
        ss%nspec_fusion = 0
        CALL ncerr_name(2,status,"nspec_fusion")
     ENDIF
  ENDIF
  IF(ss%nspec_fusion.GT.0) THEN
     ss%active_dims(ps_cnum_FUS) = ss%active_dims(ps_cnum_FUS) + 1
  ENDIF

  ss%nspec_gas = 0
  status = nf90_inq_dimid(icdf,"dim_nspec_gas",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ss%nspec_gas)
     IF(status.NE.NF90_NOERR) THEN
        ss%nspec_gas = 0
        CALL ncerr_name(2,status,"nspec_gas")
     ENDIF
  ENDIF
  IF(ss%nspec_gas.GT.0) THEN
     ss%active_dims(ps_cnum_GAS) = ss%active_dims(ps_cnum_GAS) + 1
  ENDIF

  ss%nspec_imp0 = 0
  status = nf90_inq_dimid(icdf,"dim_nspec_imp0",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ss%nspec_imp0)
     IF(status.NE.NF90_NOERR) THEN
        ss%nspec_imp0 = 0
        CALL ncerr_name(2,status,"nspec_imp0")
     ENDIF
  ENDIF
  IF(ss%nspec_imp0.GT.0) THEN
     ss%active_dims(ps_cnum_GAS) = ss%active_dims(ps_cnum_GAS) + 1
  ENDIF

  ss%nspec_impi = 0
  status = nf90_inq_dimid(icdf,"dim_nspec_impi",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ss%nspec_impi)
     IF(status.NE.NF90_NOERR) THEN
        ss%nspec_impi = 0
        CALL ncerr_name(2,status,"nspec_impi")
     ENDIF
  ENDIF
  IF(ss%nspec_impi.GT.0) THEN
     ss%active_dims(ps_cnum_PLASMA) = ss%active_dims(ps_cnum_PLASMA) + 1
  ENDIF

  ss%nspec_rfmin = 0
  status = nf90_inq_dimid(icdf,"dim_nspec_rfmin",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ss%nspec_rfmin)
     IF(status.NE.NF90_NOERR) THEN
        ss%nspec_rfmin = 0
        CALL ncerr_name(2,status,"nspec_rfmin")
     ENDIF
  ENDIF
  IF(ss%nspec_rfmin.GT.0) THEN
     ss%active_dims(ps_cnum_IC) = ss%active_dims(ps_cnum_IC) + 1
  ENDIF

  ss%nspec_th = 0
  status = nf90_inq_dimid(icdf,"dim_nspec_th",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ss%nspec_th)
     IF(status.NE.NF90_NOERR) THEN
        ss%nspec_th = 0
        CALL ncerr_name(2,status,"nspec_th")
     ENDIF
  ENDIF
  IF(ss%nspec_th.GT.0) THEN
     ss%active_dims(ps_cnum_PLASMA) = ss%active_dims(ps_cnum_PLASMA) + 1
  ENDIF

  ss%nspec_tha = 0
  status = nf90_inq_dimid(icdf,"dim_nspec_tha",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ss%nspec_tha)
     IF(status.NE.NF90_NOERR) THEN
        ss%nspec_tha = 0
        CALL ncerr_name(2,status,"nspec_tha")
     ENDIF
  ENDIF
  IF(ss%nspec_tha.GT.0) THEN
     ss%active_dims(ps_cnum_PLASMA) = ss%active_dims(ps_cnum_PLASMA) + 1
  ENDIF

  ss%nth_eq = 0
  status = nf90_inq_dimid(icdf,"dim_nth_eq",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ss%nth_eq)
     IF(status.NE.NF90_NOERR) THEN
        ss%nth_eq = 0
        CALL ncerr_name(2,status,"nth_eq")
     ENDIF
  ENDIF
  IF(ss%nth_eq.GT.0) THEN
     ss%active_dims(ps_cnum_EQ) = ss%active_dims(ps_cnum_EQ) + 1
  ENDIF

  ss%ntrcat = 0
  status = nf90_inq_dimid(icdf,"dim_ntrcat",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ss%ntrcat)
     IF(status.NE.NF90_NOERR) THEN
        ss%ntrcat = 0
        CALL ncerr_name(2,status,"ntrcat")
     ENDIF
  ENDIF
  IF(ss%ntrcat.GT.0) THEN
     ss%active_dims(ps_cnum_PLASMA) = ss%active_dims(ps_cnum_PLASMA) + 1
  ENDIF

  ss%num_rzlim = 0
  status = nf90_inq_dimid(icdf,"dim_num_rzlim",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ss%num_rzlim)
     IF(status.NE.NF90_NOERR) THEN
        ss%num_rzlim = 0
        CALL ncerr_name(2,status,"num_rzlim")
     ENDIF
  ENDIF
  IF(ss%num_rzlim.GT.0) THEN
     ss%active_dims(ps_cnum_EQ) = ss%active_dims(ps_cnum_EQ) + 1
  ENDIF

  ss%nxs = 0
  status = nf90_inq_dimid(icdf,"dim_nxs",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ss%nxs)
     IF(status.NE.NF90_NOERR) THEN
        ss%nxs = 0
        CALL ncerr_name(2,status,"nxs")
     ENDIF
  ENDIF
  IF(ss%nxs.GT.0) THEN
     ss%active_dims(ps_cnum_RAD) = ss%active_dims(ps_cnum_RAD) + 1
  ENDIF

  ss%nz = 0
  status = nf90_inq_dimid(icdf,"dim_nz",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ss%nz)
     IF(status.NE.NF90_NOERR) THEN
        ss%nz = 0
        CALL ncerr_name(2,status,"nz")
     ENDIF
  ENDIF
  IF(ss%nz.GT.0) THEN
     ss%active_dims(ps_cnum_EQ) = ss%active_dims(ps_cnum_EQ) + 1
  ENDIF

  ss%nz_rip = 0
  status = nf90_inq_dimid(icdf,"dim_nz_rip",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ss%nz_rip)
     IF(status.NE.NF90_NOERR) THEN
        ss%nz_rip = 0
        CALL ncerr_name(2,status,"nz_rip")
     ENDIF
  ENDIF
  IF(ss%nz_rip.GT.0) THEN
     ss%active_dims(ps_cnum_RIPPLE) = ss%active_dims(ps_cnum_RIPPLE) + 1
  ENDIF

  ss%n_D_einj_standard = 0
  status = nf90_inq_dimid(icdf,"dim_n_d_einj_standard",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ss%n_D_einj_standard)
     IF(status.NE.NF90_NOERR) THEN
        ss%n_D_einj_standard = 0
        CALL ncerr_name(2,status,"n_D_einj_standard")
     ENDIF
  ENDIF
  IF(ss%n_D_einj_standard.GT.0) THEN
     ss%active_dims(ps_cnum_NBI) = ss%active_dims(ps_cnum_NBI) + 1
  ENDIF

  ss%n_H_einj_standard = 0
  status = nf90_inq_dimid(icdf,"dim_n_h_einj_standard",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ss%n_H_einj_standard)
     IF(status.NE.NF90_NOERR) THEN
        ss%n_H_einj_standard = 0
        CALL ncerr_name(2,status,"n_H_einj_standard")
     ENDIF
  ENDIF
  IF(ss%n_H_einj_standard.GT.0) THEN
     ss%active_dims(ps_cnum_NBI) = ss%active_dims(ps_cnum_NBI) + 1
  ENDIF

  ss%n_T_einj_standard = 0
  status = nf90_inq_dimid(icdf,"dim_n_t_einj_standard",dimid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_inquire_dimension(icdf,dimid,len=ss%n_T_einj_standard)
     IF(status.NE.NF90_NOERR) THEN
        ss%n_T_einj_standard = 0
        CALL ncerr_name(2,status,"n_T_einj_standard")
     ENDIF
  ENDIF
  IF(ss%n_T_einj_standard.GT.0) THEN
     ss%active_dims(ps_cnum_NBI) = ss%active_dims(ps_cnum_NBI) + 1
  ENDIF

  IF(iertot.NE.0) THEN
     WRITE(iout,*) " ?plasma_state_get: there were errors reading dimensions..."
     ierr=9999
     status = nf90_close(icdf)
     RETURN
  ENDIF

  ! DIMENSIONS read in OK; allocate state arrays...

  CALL plasma_state_empty_alloc(ss,ierr)
  IF(ierr.NE.0) THEN
     WRITE(iout,*) " ?plasma_state_get: plasma_state_empty_alloc error."
     ierr=9999
     status = nf90_close(icdf)
     RETURN
  ENDIF

  !----------------------------------------
  ! call subroutines to read variables and arrays

  call plasma_state_get_0(ss,icdf,version_change,iout,iertot)
  call plasma_state_get_1(ss,icdf,version_change,iout,iertot)
  call plasma_state_get_2(ss,icdf,version_change,iout,iertot)
  call plasma_state_get_3(ss,icdf,version_change,iout,iertot)
  call plasma_state_get_4(ss,icdf,version_change,iout,iertot)
  call plasma_state_get_5(ss,icdf,version_change,iout,iertot)
  call plasma_state_get_6(ss,icdf,version_change,iout,iertot)
  call plasma_state_get_7(ss,icdf,version_change,iout,iertot)
  call plasma_state_get_8(ss,icdf,version_change,iout,iertot)
  call plasma_state_get_9(ss,icdf,version_change,iout,iertot)

  !----------------------------------------
  ! Close the NetCDF file

  status = nf90_close(icdf)

  IF(iertot.NE.0) THEN
     WRITE(iout,*) " ?plasma_state_get: there were errors reading data..."
     ierr=9999
     RETURN
  ENDIF

  !----------------------------------------
  ! Store in xplasma; check equilibrium & hash codes

  IF(version_change) THEN
     ilocka(1) = ss%lock_machine_descr
     ss%lock_machine_descr = ps_unlocked
     ilocka(2) = ss%lock_shot_config
     ss%lock_shot_config = ps_unlocked
     ilocka(3) = ss%lock_sim_init
     ss%lock_sim_init = ps_unlocked
  ENDIF

  CALL plasma_state_store(" ",ss,1,ierr)

  IF(version_change) THEN
     ss%lock_machine_descr = ilocka(1)
     ss%lock_shot_config = ilocka(2)
     ss%lock_sim_init = ilocka(3)
  ENDIF

  CONTAINS
     SUBROUTINE denull_vec(vstr,isize)
        INTEGER, intent(in) :: isize
        CHARACTER*(*) :: vstr(isize)
        INTEGER :: i

        do i=1,isize
           call denull(vstr(i))
        enddo
     END SUBROUTINE denull_vec

     SUBROUTINE denull(str)
        ! convert null characters to blank
        CHARACTER*(*) :: str
        INTEGER :: i

        do i=1,len(str)
           if(ichar(str(i:i)).eq.0) str(i:i)=' '
        enddo
     END SUBROUTINE denull

     SUBROUTINE ncerr_name(itype,status,name)
        INTEGER, INTENT(in) :: itype
        INTEGER, INTENT(in) :: status
        CHARACTER*(*), INTENT(in) :: name

        if(itype.eq.1) then
           write(iout,*) ' %plasma_state_get: warning: variable name = "'// &
                  trim(name)//'":'
        else
           write(iout,*) ' ?plasma_state_get: error: variable name = "'// &
                  trim(name)//'":'
           if(version_change) then
              write(iout,*) '   => version change RECOVERY: variable reset to initial value.'
           else
              iertot = iertot + 1
           endif
        endif
        call ncerr(status)
     END SUBROUTINE ncerr_name

     SUBROUTINE ncerr(status)
        INTEGER, INTENT(in) :: status

        nc_errmsg = NF90_strerror(status)
        write(iout,*) '  NetCDF message: ',trim(nc_errmsg)
     END SUBROUTINE ncerr

END SUBROUTINE plasma_state_get

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_p4_dummy
     return
  end subroutine ccps_getset_p4_dummy

subroutine psget_power_nbi(iobj, n1, data, ierr)
    !! power on each beam source
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_power_nbi', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % power_nbi
end subroutine psget_power_nbi


subroutine psset_power_nbi(iobj, n1, data, ierr)
    !! power on each beam source
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_power_nbi', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % power_nbi = data(1:n1)
end subroutine psset_power_nbi


subroutine psgetrnk_power_nbi(iobj, ndims, ierr)
    !! power on each beam source
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_power_nbi


subroutine psgetdim_power_nbi(iobj, ndims, dims, ierr)
    !! power on each beam source
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_power_nbi', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % power_nbi ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % power_nbi)
    endif
end subroutine psgetdim_power_nbi


subroutine psget_pe_transcat(iobj, n1, n2, data, ierr)
    !! electron transport
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_pe_transcat', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % pe_transcat
end subroutine psget_pe_transcat


subroutine psset_pe_transcat(iobj, n1, n2, data, ierr)
    !! electron transport
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_pe_transcat', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % pe_transcat = data(1:n1, 1: n2)
end subroutine psset_pe_transcat


subroutine psgetrnk_pe_transcat(iobj, ndims, ierr)
    !! electron transport
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_pe_transcat


subroutine psgetdim_pe_transcat(iobj, ndims, dims, ierr)
    !! electron transport
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_pe_transcat', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % pe_transcat ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % pe_transcat)
    endif
end subroutine psgetdim_pe_transcat


subroutine psget_p_eq(iobj, n1, data, ierr)
    !! equilibrium scalar pressure
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_p_eq', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % P_eq
end subroutine psget_p_eq


subroutine psset_p_eq(iobj, n1, data, ierr)
    !! equilibrium scalar pressure
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_p_eq', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % P_eq = data(1:n1)
end subroutine psset_p_eq


subroutine psgetrnk_p_eq(iobj, ndims, ierr)
    !! equilibrium scalar pressure
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_p_eq


subroutine psgetdim_p_eq(iobj, ndims, dims, ierr)
    !! equilibrium scalar pressure
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_p_eq', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % P_eq ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % P_eq)
    endif
end subroutine psgetdim_p_eq


subroutine psget_picrf_totals(iobj, n1, n2, data, ierr)
    !! direct ICRF power deposition, (sum over IC sources & nphi)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_picrf_totals', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % picrf_totals
end subroutine psget_picrf_totals


subroutine psset_picrf_totals(iobj, n1, n2, data, ierr)
    !! direct ICRF power deposition, (sum over IC sources & nphi)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_picrf_totals', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % picrf_totals = data(1:n1, 1: n2)
end subroutine psset_picrf_totals


subroutine psgetrnk_picrf_totals(iobj, ndims, ierr)
    !! direct ICRF power deposition, (sum over IC sources & nphi)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_picrf_totals


subroutine psgetdim_picrf_totals(iobj, ndims, dims, ierr)
    !! direct ICRF power deposition, (sum over IC sources & nphi)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_picrf_totals', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % picrf_totals ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % picrf_totals)
    endif
end subroutine psgetdim_picrf_totals


subroutine psget_psc_halo(iobj, n1, data, ierr)
    !! beam halo power: recapture - pb0_halo, (net source/sink to
    !! thermal ions), (associated particle source/sink exists)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_psc_halo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % psc_halo
end subroutine psget_psc_halo


subroutine psset_psc_halo(iobj, n1, data, ierr)
    !! beam halo power: recapture - pb0_halo, (net source/sink to
    !! thermal ions), (associated particle source/sink exists)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_psc_halo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % psc_halo = data(1:n1)
end subroutine psset_psc_halo


subroutine psgetrnk_psc_halo(iobj, ndims, ierr)
    !! beam halo power: recapture - pb0_halo, (net source/sink to
    !! thermal ions), (associated particle source/sink exists)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_psc_halo


subroutine psgetdim_psc_halo(iobj, ndims, dims, ierr)
    !! beam halo power: recapture - pb0_halo, (net source/sink to
    !! thermal ions), (associated particle source/sink exists)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_psc_halo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % psc_halo ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % psc_halo)
    endif
end subroutine psgetdim_psc_halo


subroutine psget_prad(iobj, n1, data, ierr)
    !! total radiated power
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_prad', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % prad
end subroutine psget_prad


subroutine psset_prad(iobj, n1, data, ierr)
    !! total radiated power
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_prad', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % prad = data(1:n1)
end subroutine psset_prad


subroutine psgetrnk_prad(iobj, ndims, ierr)
    !! total radiated power
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_prad


subroutine psgetdim_prad(iobj, ndims, dims, ierr)
    !! total radiated power
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_prad', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % prad ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % prad)
    endif
end subroutine psgetdim_prad


subroutine psget_psc_reco(iobj, n1, data, ierr)
    !! reco power: recapture - p0_reco, (net source/sink to thermal
    !! ions), (associated particle source/sink exists)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_psc_reco', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % psc_reco
end subroutine psget_psc_reco


subroutine psset_psc_reco(iobj, n1, data, ierr)
    !! reco power: recapture - p0_reco, (net source/sink to thermal
    !! ions), (associated particle source/sink exists)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_psc_reco', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % psc_reco = data(1:n1)
end subroutine psset_psc_reco


subroutine psgetrnk_psc_reco(iobj, ndims, ierr)
    !! reco power: recapture - p0_reco, (net source/sink to thermal
    !! ions), (associated particle source/sink exists)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_psc_reco


subroutine psgetdim_psc_reco(iobj, ndims, dims, ierr)
    !! reco power: recapture - p0_reco, (net source/sink to thermal
    !! ions), (associated particle source/sink exists)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_psc_reco', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % psc_reco ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % psc_reco)
    endif
end subroutine psgetdim_psc_reco


subroutine psget_peech_src(iobj, n1, n2, data, ierr)
    !! ECH heating (by antenna)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_peech_src', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % peech_src
end subroutine psget_peech_src


subroutine psset_peech_src(iobj, n1, n2, data, ierr)
    !! ECH heating (by antenna)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_peech_src', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % peech_src = data(1:n1, 1: n2)
end subroutine psset_peech_src


subroutine psgetrnk_peech_src(iobj, ndims, ierr)
    !! ECH heating (by antenna)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_peech_src


subroutine psgetdim_peech_src(iobj, ndims, dims, ierr)
    !! ECH heating (by antenna)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_peech_src', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % peech_src ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % peech_src)
    endif
end subroutine psgetdim_peech_src


subroutine psget_pe_anom(iobj, n1, data, ierr)
    !! anomalous electron heating
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_pe_anom', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % pe_anom
end subroutine psget_pe_anom


subroutine psset_pe_anom(iobj, n1, data, ierr)
    !! anomalous electron heating
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_pe_anom', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % pe_anom = data(1:n1)
end subroutine psset_pe_anom


subroutine psgetrnk_pe_anom(iobj, ndims, ierr)
    !! anomalous electron heating
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_pe_anom


subroutine psgetdim_pe_anom(iobj, ndims, dims, ierr)
    !! anomalous electron heating
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_pe_anom', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % pe_anom ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % pe_anom)
    endif
end subroutine psgetdim_pe_anom

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_z2_dummy
     return
  end subroutine ccps_getset_z2_dummy

subroutine psget_zbap(iobj, n1, data, ierr)
    !! elevation of beam centerline at aperture, At a distance
    !! (Lbscap) from the beam source, the beam centerline, passes
    !! above (+) or below (-) machine midplane as defined by Z=0, in
    !! the equilibrium specification.  If defaulted, the centerline,
    !! is centered on the midplane (Z=0) when it crosses the plane of
    !! the, aperture.  If both Zbap(...) and Zbsc(...) are defaulted,
    !! the, entire beam centerline lies in the midplane., Note that Z
    !! at the beam centerline tangency radius is:, Ztan = Zbsc +
    !! (Lbsctan/Lbscap)*(Zbap-Zbsc)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_zbap', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % Zbap
end subroutine psget_zbap


subroutine psset_zbap(iobj, n1, data, ierr)
    !! elevation of beam centerline at aperture, At a distance
    !! (Lbscap) from the beam source, the beam centerline, passes
    !! above (+) or below (-) machine midplane as defined by Z=0, in
    !! the equilibrium specification.  If defaulted, the centerline,
    !! is centered on the midplane (Z=0) when it crosses the plane of
    !! the, aperture.  If both Zbap(...) and Zbsc(...) are defaulted,
    !! the, entire beam centerline lies in the midplane., Note that Z
    !! at the beam centerline tangency radius is:, Ztan = Zbsc +
    !! (Lbsctan/Lbscap)*(Zbap-Zbsc)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_zbap', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % Zbap = data(1:n1)
end subroutine psset_zbap


subroutine psgetrnk_zbap(iobj, ndims, ierr)
    !! elevation of beam centerline at aperture, At a distance
    !! (Lbscap) from the beam source, the beam centerline, passes
    !! above (+) or below (-) machine midplane as defined by Z=0, in
    !! the equilibrium specification.  If defaulted, the centerline,
    !! is centered on the midplane (Z=0) when it crosses the plane of
    !! the, aperture.  If both Zbap(...) and Zbsc(...) are defaulted,
    !! the, entire beam centerline lies in the midplane., Note that Z
    !! at the beam centerline tangency radius is:, Ztan = Zbsc +
    !! (Lbsctan/Lbscap)*(Zbap-Zbsc)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_zbap


subroutine psgetdim_zbap(iobj, ndims, dims, ierr)
    !! elevation of beam centerline at aperture, At a distance
    !! (Lbscap) from the beam source, the beam centerline, passes
    !! above (+) or below (-) machine midplane as defined by Z=0, in
    !! the equilibrium specification.  If defaulted, the centerline,
    !! is centered on the midplane (Z=0) when it crosses the plane of
    !! the, aperture.  If both Zbap(...) and Zbsc(...) are defaulted,
    !! the, entire beam centerline lies in the midplane., Note that Z
    !! at the beam centerline tangency radius is:, Ztan = Zbsc +
    !! (Lbsctan/Lbscap)*(Zbap-Zbsc)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_zbap', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % Zbap ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % Zbap)
    endif
end subroutine psgetdim_zbap


subroutine psget_zeff_data_info(iobj, data, ierr)
    !! information on source of Zeff data
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    CHARACTER*(*), intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_zeff_data_info', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % ZEFF_Data_Info
end subroutine psget_zeff_data_info


subroutine psset_zeff_data_info(iobj, data, ierr)
    !! information on source of Zeff data
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    CHARACTER*(*), intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_zeff_data_info', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % ZEFF_Data_Info = data
end subroutine psset_zeff_data_info


subroutine psgetsz_zeff_data_info(iobj, size, ierr)
    !! information on source of Zeff data
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: size    ! size of character string
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psgetsz_zeff_data_info', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! note that the following will return the character length size regardless of
    ! the number of array elements (if ZEFF_Data_Info is an array)
    size = len(ss % ZEFF_Data_Info)
end subroutine psgetsz_zeff_data_info


subroutine psget_z0max(iobj, data, ierr)
    !! maximum Z of non-impurity species, (default is 2: Helium). 
    !! Ion species with Z <= Z0max, are considered "non-impurities"
    !! and are present in, SGAS, a list of recycling neutral gas
    !! species.
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_z0max', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % Z0max
end subroutine psget_z0max


subroutine psset_z0max(iobj, data, ierr)
    !! maximum Z of non-impurity species, (default is 2: Helium). 
    !! Ion species with Z <= Z0max, are considered "non-impurities"
    !! and are present in, SGAS, a list of recycling neutral gas
    !! species.
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_z0max', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % Z0max = data
end subroutine psset_z0max


subroutine psget_z0_momeq(iobj, n1, data, ierr)
    !! Z0 of flux surface, Fourier Spline representation
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_z0_momeq', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % Z0_momeq
end subroutine psget_z0_momeq


subroutine psset_z0_momeq(iobj, n1, data, ierr)
    !! Z0 of flux surface, Fourier Spline representation
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_z0_momeq', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % Z0_momeq = data(1:n1)
end subroutine psset_z0_momeq


subroutine psgetrnk_z0_momeq(iobj, ndims, ierr)
    !! Z0 of flux surface, Fourier Spline representation
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_z0_momeq


subroutine psgetdim_z0_momeq(iobj, ndims, dims, ierr)
    !! Z0 of flux surface, Fourier Spline representation
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_z0_momeq', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % Z0_momeq ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % Z0_momeq)
    endif
end subroutine psgetdim_z0_momeq

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_c4_dummy
     return
  end subroutine ccps_getset_c4_dummy

subroutine psget_coil_apt(iobj, n1, data, ierr)
    !! SIGNED circuit current, amps/turn within each coil attached
    !! to the indicated circult:, SIGN: + means current flows
    !! counter-clockwise, viewed from above, for, a coil (j) with
    !! Nturns(j) > 0; direction opposite if Nturns(j) < 0, - means the
    !! reverse., The SIGNED current in coil (j) is
    !! Nturns(j)*coil_apt(icircuit_coil(j));, a positive current flows
    !! counter-clockwise viewed from above., Any element of
    !! Nturns(...) and any element of coil_apt(...) can be, either
    !! positive or negative.
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_coil_apt', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % coil_apt
end subroutine psget_coil_apt


subroutine psset_coil_apt(iobj, n1, data, ierr)
    !! SIGNED circuit current, amps/turn within each coil attached
    !! to the indicated circult:, SIGN: + means current flows
    !! counter-clockwise, viewed from above, for, a coil (j) with
    !! Nturns(j) > 0; direction opposite if Nturns(j) < 0, - means the
    !! reverse., The SIGNED current in coil (j) is
    !! Nturns(j)*coil_apt(icircuit_coil(j));, a positive current flows
    !! counter-clockwise viewed from above., Any element of
    !! Nturns(...) and any element of coil_apt(...) can be, either
    !! positive or negative.
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_coil_apt', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % coil_apt = data(1:n1)
end subroutine psset_coil_apt


subroutine psgetrnk_coil_apt(iobj, ndims, ierr)
    !! SIGNED circuit current, amps/turn within each coil attached
    !! to the indicated circult:, SIGN: + means current flows
    !! counter-clockwise, viewed from above, for, a coil (j) with
    !! Nturns(j) > 0; direction opposite if Nturns(j) < 0, - means the
    !! reverse., The SIGNED current in coil (j) is
    !! Nturns(j)*coil_apt(icircuit_coil(j));, a positive current flows
    !! counter-clockwise viewed from above., Any element of
    !! Nturns(...) and any element of coil_apt(...) can be, either
    !! positive or negative.
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_coil_apt


subroutine psgetdim_coil_apt(iobj, ndims, dims, ierr)
    !! SIGNED circuit current, amps/turn within each coil attached
    !! to the indicated circult:, SIGN: + means current flows
    !! counter-clockwise, viewed from above, for, a coil (j) with
    !! Nturns(j) > 0; direction opposite if Nturns(j) < 0, - means the
    !! reverse., The SIGNED current in coil (j) is
    !! Nturns(j)*coil_apt(icircuit_coil(j));, a positive current flows
    !! counter-clockwise viewed from above., Any element of
    !! Nturns(...) and any element of coil_apt(...) can be, either
    !! positive or negative.
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_coil_apt', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % coil_apt ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % coil_apt)
    endif
end subroutine psgetdim_coil_apt


subroutine psget_chimo_trans(iobj, n1, data, ierr)
    !! angular momentum diffusivity
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_chimo_trans', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % chimo_trans
end subroutine psget_chimo_trans


subroutine psset_chimo_trans(iobj, n1, data, ierr)
    !! angular momentum diffusivity
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_chimo_trans', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % chimo_trans = data(1:n1)
end subroutine psset_chimo_trans


subroutine psgetrnk_chimo_trans(iobj, ndims, ierr)
    !! angular momentum diffusivity
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_chimo_trans


subroutine psgetdim_chimo_trans(iobj, ndims, dims, ierr)
    !! angular momentum diffusivity
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_chimo_trans', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % chimo_trans ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % chimo_trans)
    endif
end subroutine psgetdim_chimo_trans


subroutine psget_chie_transcat(iobj, n1, n2, data, ierr)
    !! Electron energy diffusivity
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_chie_transcat', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % chie_transcat
end subroutine psget_chie_transcat


subroutine psset_chie_transcat(iobj, n1, n2, data, ierr)
    !! Electron energy diffusivity
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_chie_transcat', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % chie_transcat = data(1:n1, 1: n2)
end subroutine psset_chie_transcat


subroutine psgetrnk_chie_transcat(iobj, ndims, ierr)
    !! Electron energy diffusivity
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_chie_transcat


subroutine psgetdim_chie_transcat(iobj, ndims, dims, ierr)
    !! Electron energy diffusivity
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_chie_transcat', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % chie_transcat ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % chie_transcat)
    endif
end subroutine psgetdim_chie_transcat


subroutine psget_curfusn(iobj, n1, data, ierr)
    !! fusion ion driven current (shielded)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_curfusn', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % curfusn
end subroutine psget_curfusn


subroutine psset_curfusn(iobj, n1, data, ierr)
    !! fusion ion driven current (shielded)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_curfusn', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % curfusn = data(1:n1)
end subroutine psset_curfusn


subroutine psgetrnk_curfusn(iobj, ndims, ierr)
    !! fusion ion driven current (shielded)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_curfusn


subroutine psgetdim_curfusn(iobj, ndims, dims, ierr)
    !! fusion ion driven current (shielded)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_curfusn', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % curfusn ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % curfusn)
    endif
end subroutine psgetdim_curfusn


subroutine psget_chiphi_anom(iobj, n1, data, ierr)
    !! momentum-equation, diffusivity term
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_chiphi_anom', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % chiphi_anom
end subroutine psget_chiphi_anom


subroutine psset_chiphi_anom(iobj, n1, data, ierr)
    !! momentum-equation, diffusivity term
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_chiphi_anom', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % chiphi_anom = data(1:n1)
end subroutine psset_chiphi_anom


subroutine psgetrnk_chiphi_anom(iobj, ndims, ierr)
    !! momentum-equation, diffusivity term
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_chiphi_anom


subroutine psgetdim_chiphi_anom(iobj, ndims, dims, ierr)
    !! momentum-equation, diffusivity term
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_chiphi_anom', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % chiphi_anom ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % chiphi_anom)
    endif
end subroutine psgetdim_chiphi_anom


subroutine psget_chii_tglf(iobj, n1, data, ierr)
    !! Ti-equation, diffusivity from TGLF model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_chii_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % chii_tglf
end subroutine psget_chii_tglf


subroutine psset_chii_tglf(iobj, n1, data, ierr)
    !! Ti-equation, diffusivity from TGLF model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_chii_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % chii_tglf = data(1:n1)
end subroutine psset_chii_tglf


subroutine psgetrnk_chii_tglf(iobj, ndims, ierr)
    !! Ti-equation, diffusivity from TGLF model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_chii_tglf


subroutine psgetdim_chii_tglf(iobj, ndims, dims, ierr)
    !! Ti-equation, diffusivity from TGLF model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_chii_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % chii_tglf ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % chii_tglf)
    endif
end subroutine psgetdim_chii_tglf


subroutine psget_chie_etg(iobj, n1, data, ierr)
    !! Te-equation, diffusivity term ETG model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_chie_etg', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % chie_etg
end subroutine psget_chie_etg


subroutine psset_chie_etg(iobj, n1, data, ierr)
    !! Te-equation, diffusivity term ETG model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_chie_etg', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % chie_etg = data(1:n1)
end subroutine psset_chie_etg


subroutine psgetrnk_chie_etg(iobj, ndims, ierr)
    !! Te-equation, diffusivity term ETG model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_chie_etg


subroutine psgetdim_chie_etg(iobj, ndims, dims, ierr)
    !! Te-equation, diffusivity term ETG model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_chie_etg', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % chie_etg ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % chie_etg)
    endif
end subroutine psgetdim_chie_etg

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


subroutine ps_sconfig_namelist_write(filename,ss,ierr)

  ! from current contents of state, write shot configuration namelist

  USE plasma_state_definition_mod
  USE ps_namwr_mod
  IMPLICIT NONE

  CHARACTER*(*), INTENT(IN) :: filename        ! file to contain namelist
  TYPE (plasma_state) :: ss     ! state containing data to write
  INTEGER, INTENT(OUT) :: ierr  ! completion code (0=OK)

  !-------------------------------
  INTEGER :: iout, ilun_namel
  INTEGER, DIMENSION(:), ALLOCATABLE :: isize_vec
  !-------------------------------

  iout = SWIM_err_out_file

  CALL find_io_unit(ilun_namel)

  OPEN(UNIT=ilun_namel,file=filename,status='unknown',iostat=ierr)
  IF(ierr.NE.0) THEN
     WRITE(iout,*) ' ?ps_sconfig_namelist_write: OPEN failure on file: '// &
          TRIM(filename)
     RETURN
  ENDIF

  WRITE(unit=ilun_namel,fmt='(" &sconfig")')

  CALL ps_namwr(ilun_namel, &
       "integer shot number","integer", &
       "shot_number", ss%shot_number)

  IF(ALLOCATED(ss%S_name)) THEN
     CALL ps_namwr(ilun_namel, &
          "thermal species list","species_list", &
          "S", ss%NSPEC_TH, ss%S_name(1:ss%NSPEC_TH), &
          ss%qatom_S(1:ss%NSPEC_TH), ss%q_S(1:ss%NSPEC_TH), ss%m_S(1:ss%NSPEC_TH))
  ELSE
     CALL ps_namwr(ilun_namel, &
          "thermal species list","species_list", "S")
  ENDIF

  IF(ALLOCATED(ss%nbion)) THEN
     CALL ps_namwr(ilun_namel, &
          "name of species injected by each beam.","character", &
          "nbion", ss%NBEAM, ss%nbion)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "name of species injected by each beam.","character", "nbion")
  ENDIF

  IF(ALLOCATED(ss%nbion_trace)) THEN
     CALL ps_namwr(ilun_namel, &
          "(if non-blank) beam trace element","character", &
          "nbion_trace", ss%NBEAM, ss%nbion_trace)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "(if non-blank) beam trace element","character", "nbion_trace")
  ENDIF

  IF(ALLOCATED(ss%SFUS_name)) THEN
     CALL ps_namwr(ilun_namel, &
          "fusion product ion species","species_list", &
          "SFUS", ss%NSPEC_FUSION, ss%SFUS_name(1:ss%NSPEC_FUSION), &
          ss%qatom_SFUS(1:ss%NSPEC_FUSION), ss%q_SFUS(1:ss%NSPEC_FUSION), ss%m_SFUS(1:ss%NSPEC_FUSION))
  ELSE
     CALL ps_namwr(ilun_namel, &
          "fusion product ion species","species_list", "SFUS")
  ENDIF

  IF(ALLOCATED(ss%RFMIN_name)) THEN
     CALL ps_namwr(ilun_namel, &
          "ICRF minority species","species_list", &
          "RFMIN", ss%NSPEC_RFMIN, ss%RFMIN_name(1:ss%NSPEC_RFMIN), &
          ss%qatom_RFMIN(1:ss%NSPEC_RFMIN), ss%q_RFMIN(1:ss%NSPEC_RFMIN), ss%m_RFMIN(1:ss%NSPEC_RFMIN))
  ELSE
     CALL ps_namwr(ilun_namel, &
          "ICRF minority species","species_list", "RFMIN")
  ENDIF

  IF(ALLOCATED(ss%freq_ic)) THEN
     CALL ps_namwr(ilun_namel, &
          "frequency on each ICRF source","Hz", &
          "freq_ic", ss%NICRF_SRC, ss%freq_ic)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "frequency on each ICRF source","Hz", "freq_ic")
  ENDIF

  IF(ALLOCATED(ss%n_straps)) THEN
     CALL ps_namwr(ilun_namel, &
          "number of straps in the antenna","integer", &
          "n_straps", ss%NICRF_SRC, ss%n_straps)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "number of straps in the antenna","integer", "n_straps")
  ENDIF

  CALL ps_namwr(ilun_namel, &
       "Maximum size of variable length enumeration: N_STRAPS","integer", &
       "max_n_straps", ss%max_n_straps)

  IF(ALLOCATED(ss%R_ant)) THEN
     CALL ps_namwr(ilun_namel, &
          "major radius of antenna","m", &
          "R_ant", ss%NICRF_SRC, ss%R_ant)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "major radius of antenna","m", "R_ant")
  ENDIF

  IF(ALLOCATED(ss%Z_ant)) THEN
     CALL ps_namwr(ilun_namel, &
          "height of antenna","m", &
          "Z_ant", ss%NICRF_SRC, ss%Z_ant)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "height of antenna","m", "Z_ant")
  ENDIF

  IF(ALLOCATED(ss%Z_mid_ant)) THEN
     CALL ps_namwr(ilun_namel, &
          "center of antenna relative to TF coil midplane","m", &
          "Z_mid_ant", ss%NICRF_SRC, ss%Z_mid_ant)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "center of antenna relative to TF coil midplane","m", "Z_mid_ant")
  ENDIF

  IF(ALLOCATED(ss%num_nphi_vac)) THEN
     CALL ps_namwr(ilun_namel, &
          "number of non-zero n_phi values","integer", &
          "num_nphi_vac", ss%NICRF_SRC, ss%num_nphi_vac)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "number of non-zero n_phi values","integer", "num_nphi_vac")
  ENDIF

  CALL ps_namwr(ilun_namel, &
       "Maximum size of variable length enumeration: NUM_NPHI_VAC","integer", &
       "max_num_nphi_vac", ss%max_num_nphi_vac)

  IF(ALLOCATED(ss%Real_ant_coef)) THEN
     ALLOCATE(isize_vec(ss%NICRF_SRC))
     isize_vec = ss%NUM_NPHI_VAC
     CALL ps_namwr(ilun_namel, &
          "real part of Fourier Coef","Amps/m", &
          "Real_ant_coef", isize_vec, ss%Real_ant_coef)
     DEALLOCATE(isize_vec)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "real part of Fourier Coef","Amps/m", "Real_ant_coef")
  ENDIF

  IF(ALLOCATED(ss%Imag_ant_coef)) THEN
     ALLOCATE(isize_vec(ss%NICRF_SRC))
     isize_vec = ss%NUM_NPHI_VAC
     CALL ps_namwr(ilun_namel, &
          "imag part of Fourier Coef","Amps/m", &
          "Imag_ant_coef", isize_vec, ss%Imag_ant_coef)
     DEALLOCATE(isize_vec)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "imag part of Fourier Coef","Amps/m", "Imag_ant_coef")
  ENDIF

  IF(ALLOCATED(ss%num_nphi)) THEN
     CALL ps_namwr(ilun_namel, &
          "number of non-zero n_phi values","integer", &
          "num_nphi", ss%NICRF_SRC, ss%num_nphi)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "number of non-zero n_phi values","integer", "num_nphi")
  ENDIF

  CALL ps_namwr(ilun_namel, &
       "Maximum size of variable length enumeration: NUM_NPHI","integer", &
       "max_num_nphi", ss%max_num_nphi)

  IF(ALLOCATED(ss%nphi)) THEN
     ALLOCATE(isize_vec(ss%NICRF_SRC))
     isize_vec = ss%NUM_NPHI
     CALL ps_namwr(ilun_namel, &
          "n_phi wave spectrum from antenna","integer", &
          "nphi", isize_vec, ss%nphi)
     DEALLOCATE(isize_vec)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "n_phi wave spectrum from antenna","integer", "nphi")
  ENDIF

  IF(ALLOCATED(ss%wt_nphi)) THEN
     ALLOCATE(isize_vec(ss%NICRF_SRC))
     isize_vec = ss%NUM_NPHI
     CALL ps_namwr(ilun_namel, &
          "vacuum spectrum n_phi weight","-", &
          "wt_nphi", isize_vec, ss%wt_nphi)
     DEALLOCATE(isize_vec)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "vacuum spectrum n_phi weight","-", "wt_nphi")
  ENDIF

  CALL ps_namwr(ilun_namel, &
       "B_phi orientation: +1 means CCW viewed from above","integer", &
       "kccw_Bphi", ss%kccw_Bphi)

  CALL ps_namwr(ilun_namel, &
       "J_phi orientation: +1 means CCW viewed from above","integer", &
       "kccw_Jphi", ss%kccw_Jphi)

  IF(ALLOCATED(ss%gs_name)) THEN
     CALL ps_namwr(ilun_namel, &
          "number & name of edge neutral gas sources","character", &
          "gs_name", ss%NGSC0, ss%gs_name)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "number & name of edge neutral gas sources","character", "gs_name")
  ENDIF

  IF(ALLOCATED(ss%gas_atom)) THEN
     CALL ps_namwr(ilun_namel, &
          "name of species introduced by each gas source","character", &
          "gas_atom", ss%NGSC0, ss%gas_atom)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "name of species introduced by each gas source","character", "gas_atom")
  ENDIF

  IF(ALLOCATED(ss%is_recycling)) THEN
     CALL ps_namwr(ilun_namel, &
          "0/1; =1 to for recycling sources","integer", &
          "is_recycling", ss%NGSC0, ss%is_recycling)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "0/1; =1 to for recycling sources","integer", "is_recycling")
  ENDIF

  IF(ALLOCATED(ss%xs_name)) THEN
     CALL ps_namwr(ilun_namel, &
          "number & name of impurity sources","character", &
          "xs_name", ss%NXS, ss%xs_name)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "number & name of impurity sources","character", "xs_name")
  ENDIF

  IF(ALLOCATED(ss%freq_ec)) THEN
     CALL ps_namwr(ilun_namel, &
          "frequency of EC source","Hz", &
          "freq_ec", ss%NECRF_SRC, ss%freq_ec)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "frequency of EC source","Hz", "freq_ec")
  ENDIF

  IF(ALLOCATED(ss%EC_theta_aim)) THEN
     CALL ps_namwr(ilun_namel, &
          "poloidal aiming angle","degrees", &
          "EC_theta_aim", ss%NECRF_SRC, ss%EC_theta_aim)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "poloidal aiming angle","degrees", "EC_theta_aim")
  ENDIF

  IF(ALLOCATED(ss%EC_phi_aim)) THEN
     CALL ps_namwr(ilun_namel, &
          "toroidal aiming angle","degrees", &
          "EC_phi_aim", ss%NECRF_SRC, ss%EC_phi_aim)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "toroidal aiming angle","degrees", "EC_phi_aim")
  ENDIF

  IF(ALLOCATED(ss%EC_Omode_Fraction)) THEN
     CALL ps_namwr(ilun_namel, &
          "O-mode fraction of EC source","-", &
          "EC_Omode_Fraction", ss%NECRF_SRC, ss%EC_Omode_Fraction)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "O-mode fraction of EC source","-", "EC_Omode_Fraction")
  ENDIF

  IF(ALLOCATED(ss%freq_lh)) THEN
     CALL ps_namwr(ilun_namel, &
          "frequency on each LHRF source","Hz", &
          "freq_lh", ss%NLHRF_SRC, ss%freq_lh)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "frequency on each LHRF source","Hz", "freq_lh")
  ENDIF

  IF(ALLOCATED(ss%nspectrumlh_src)) THEN
     CALL ps_namwr(ilun_namel, &
          "number of spectrum peaks","integer", &
          "nspectrumlh_src", ss%NLHRF_SRC, ss%nspectrumlh_src)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "number of spectrum peaks","integer", "nspectrumlh_src")
  ENDIF

  CALL ps_namwr(ilun_namel, &
       "Maximum size of variable length enumeration: NSPECTRUMLH_SRC","integer", &
       "max_nspectrumlh_src", ss%max_nspectrumlh_src)

  IF(ALLOCATED(ss%aminlh)) THEN
     ALLOCATE(isize_vec(ss%NLHRF_SRC))
     isize_vec = ss%NSPECTRUMLH_SRC
     CALL ps_namwr(ilun_namel, &
          "parallel mode number, center of the spectrum peak","-", &
          "aminlh", isize_vec, ss%aminlh)
     DEALLOCATE(isize_vec)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "parallel mode number, center of the spectrum peak","-", "aminlh")
  ENDIF

  IF(ALLOCATED(ss%amaxlh)) THEN
     ALLOCATE(isize_vec(ss%NLHRF_SRC))
     isize_vec = ss%NSPECTRUMLH_SRC
     CALL ps_namwr(ilun_namel, &
          "width of the spectrum peak","-", &
          "amaxlh", isize_vec, ss%amaxlh)
     DEALLOCATE(isize_vec)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "width of the spectrum peak","-", "amaxlh")
  ENDIF

  IF(ALLOCATED(ss%atorminlh)) THEN
     ALLOCATE(isize_vec(ss%NLHRF_SRC))
     isize_vec = ss%NSPECTRUMLH_SRC
     CALL ps_namwr(ilun_namel, &
          "toroidal mode number left of lumps","-", &
          "atorminlh", isize_vec, ss%atorminlh)
     DEALLOCATE(isize_vec)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "toroidal mode number left of lumps","-", "atorminlh")
  ENDIF

  IF(ALLOCATED(ss%atormaxlh)) THEN
     ALLOCATE(isize_vec(ss%NLHRF_SRC))
     isize_vec = ss%NSPECTRUMLH_SRC
     CALL ps_namwr(ilun_namel, &
          "toroidal mode number right of lumps","-", &
          "atormaxlh", isize_vec, ss%atormaxlh)
     DEALLOCATE(isize_vec)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "toroidal mode number right of lumps","-", "atormaxlh")
  ENDIF

  IF(ALLOCATED(ss%apolminlh)) THEN
     ALLOCATE(isize_vec(ss%NLHRF_SRC))
     isize_vec = ss%NSPECTRUMLH_SRC
     CALL ps_namwr(ilun_namel, &
          "poloidal mode number left of lumps","-", &
          "apolminlh", isize_vec, ss%apolminlh)
     DEALLOCATE(isize_vec)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "poloidal mode number left of lumps","-", "apolminlh")
  ENDIF

  IF(ALLOCATED(ss%apolmaxlh)) THEN
     ALLOCATE(isize_vec(ss%NLHRF_SRC))
     isize_vec = ss%NSPECTRUMLH_SRC
     CALL ps_namwr(ilun_namel, &
          "poloidal mode number right of lumps","-", &
          "apolmaxlh", isize_vec, ss%apolmaxlh)
     DEALLOCATE(isize_vec)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "poloidal mode number right of lumps","-", "apolmaxlh")
  ENDIF

  IF(ALLOCATED(ss%fracpslh)) THEN
     ALLOCATE(isize_vec(ss%NLHRF_SRC))
     isize_vec = ss%NSPECTRUMLH_SRC
     CALL ps_namwr(ilun_namel, &
          "fraction of power on each peak (the sum over all peaks must be 1)","-", &
          "fracpslh", isize_vec, ss%fracpslh)
     DEALLOCATE(isize_vec)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "fraction of power on each peak (the sum over all peaks must be 1)","-", "fracpslh")
  ENDIF

  CALL ps_namwr(ilun_namel, &
       "need description","integer", &
       "i_npoloidal", ss%i_npoloidal)

  IF(ALLOCATED(ss%rhopsi0lh)) THEN
     ALLOCATE(isize_vec(ss%NLHRF_SRC))
     isize_vec = ss%NSPECTRUMLH_SRC
     CALL ps_namwr(ilun_namel, &
          "need description","-", &
          "rhopsi0lh", isize_vec, ss%rhopsi0lh)
     DEALLOCATE(isize_vec)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "need description","-", "rhopsi0lh")
  ENDIF

  IF(ALLOCATED(ss%thegrilh)) THEN
     ALLOCATE(isize_vec(ss%NLHRF_SRC))
     isize_vec = ss%NSPECTRUMLH_SRC
     CALL ps_namwr(ilun_namel, &
          "need description","-", &
          "thegrilh", isize_vec, ss%thegrilh)
     DEALLOCATE(isize_vec)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "need description","-", "thegrilh")
  ENDIF

  IF(ALLOCATED(ss%phigrilh)) THEN
     ALLOCATE(isize_vec(ss%NLHRF_SRC))
     isize_vec = ss%NSPECTRUMLH_SRC
     CALL ps_namwr(ilun_namel, &
          "need description","-", &
          "phigrilh", isize_vec, ss%phigrilh)
     DEALLOCATE(isize_vec)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "need description","-", "phigrilh")
  ENDIF

  IF(ALLOCATED(ss%hegrilh)) THEN
     ALLOCATE(isize_vec(ss%NLHRF_SRC))
     isize_vec = ss%NSPECTRUMLH_SRC
     CALL ps_namwr(ilun_namel, &
          "need description","-", &
          "hegrilh", isize_vec, ss%hegrilh)
     DEALLOCATE(isize_vec)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "need description","-", "hegrilh")
  ENDIF

  IF(ALLOCATED(ss%nthinlh)) THEN
     ALLOCATE(isize_vec(ss%NLHRF_SRC))
     isize_vec = ss%NSPECTRUMLH_SRC
     CALL ps_namwr(ilun_namel, &
          "need description","integer", &
          "nthinlh", isize_vec, ss%nthinlh)
     DEALLOCATE(isize_vec)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "need description","integer", "nthinlh")
  ENDIF

  IF(ALLOCATED(ss%nnkparlh)) THEN
     ALLOCATE(isize_vec(ss%NLHRF_SRC))
     isize_vec = ss%NSPECTRUMLH_SRC
     CALL ps_namwr(ilun_namel, &
          "need description","integer", &
          "nnkparlh", isize_vec, ss%nnkparlh)
     DEALLOCATE(isize_vec)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "need description","integer", "nnkparlh")
  ENDIF

  IF(ALLOCATED(ss%nnktorlh)) THEN
     ALLOCATE(isize_vec(ss%NLHRF_SRC))
     isize_vec = ss%NSPECTRUMLH_SRC
     CALL ps_namwr(ilun_namel, &
          "need description","integer", &
          "nnktorlh", isize_vec, ss%nnktorlh)
     DEALLOCATE(isize_vec)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "need description","integer", "nnktorlh")
  ENDIF

  IF(ALLOCATED(ss%nnkpollh)) THEN
     ALLOCATE(isize_vec(ss%NLHRF_SRC))
     isize_vec = ss%NSPECTRUMLH_SRC
     CALL ps_namwr(ilun_namel, &
          "need description","integer", &
          "nnkpollh", isize_vec, ss%nnkpollh)
     DEALLOCATE(isize_vec)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "need description","integer", "nnkpollh")
  ENDIF


  WRITE(ilun_namel,'(" /")')
  CLOSE(UNIT=ilun_namel)

END SUBROUTINE ps_sconfig_namelist_write

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_d1_dummy
     return
  end subroutine ccps_getset_d1_dummy

subroutine psget_d_fhalf_standard(iobj, n1, data, ierr)
    !! D beam half energy fractions
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_d_fhalf_standard', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % D_fhalf_standard
end subroutine psget_d_fhalf_standard


subroutine psset_d_fhalf_standard(iobj, n1, data, ierr)
    !! D beam half energy fractions
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_d_fhalf_standard', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % D_fhalf_standard = data(1:n1)
end subroutine psset_d_fhalf_standard


subroutine psgetrnk_d_fhalf_standard(iobj, ndims, ierr)
    !! D beam half energy fractions
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_d_fhalf_standard


subroutine psgetdim_d_fhalf_standard(iobj, ndims, dims, ierr)
    !! D beam half energy fractions
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_d_fhalf_standard', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % D_fhalf_standard ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % D_fhalf_standard)
    endif
end subroutine psgetdim_d_fhalf_standard


subroutine psget_dqidgrdte_tglf(iobj, n1, data, ierr)
    !! Ti flux gradient term from TGLF model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_dqidgrdte_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % dQidGrdte_tglf
end subroutine psget_dqidgrdte_tglf


subroutine psset_dqidgrdte_tglf(iobj, n1, data, ierr)
    !! Ti flux gradient term from TGLF model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_dqidgrdte_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % dQidGrdte_tglf = data(1:n1)
end subroutine psset_dqidgrdte_tglf


subroutine psgetrnk_dqidgrdte_tglf(iobj, ndims, ierr)
    !! Ti flux gradient term from TGLF model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_dqidgrdte_tglf


subroutine psgetdim_dqidgrdte_tglf(iobj, ndims, dims, ierr)
    !! Ti flux gradient term from TGLF model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_dqidgrdte_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % dQidGrdte_tglf ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % dQidGrdte_tglf)
    endif
end subroutine psgetdim_dqidgrdte_tglf


subroutine psget_difns_neo(iobj, n1, n2, data, ierr)
    !! density-equations, neoclassical diffusivity from NEO model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_difns_neo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % difns_neo
end subroutine psget_difns_neo


subroutine psset_difns_neo(iobj, n1, n2, data, ierr)
    !! density-equations, neoclassical diffusivity from NEO model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_difns_neo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % difns_neo = data(1:n1, 1: n2)
end subroutine psset_difns_neo


subroutine psgetrnk_difns_neo(iobj, ndims, ierr)
    !! density-equations, neoclassical diffusivity from NEO model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_difns_neo


subroutine psgetdim_difns_neo(iobj, ndims, dims, ierr)
    !! density-equations, neoclassical diffusivity from NEO model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_difns_neo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % difns_neo ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % difns_neo)
    endif
end subroutine psgetdim_difns_neo


subroutine psget_difnx_nclass(iobj, n1, data, ierr)
    !! main-impurity-density-equations, neoclassical diffusivity
    !! from NCLASS model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_difnx_nclass', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % difnx_nclass
end subroutine psget_difnx_nclass


subroutine psset_difnx_nclass(iobj, n1, data, ierr)
    !! main-impurity-density-equations, neoclassical diffusivity
    !! from NCLASS model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_difnx_nclass', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % difnx_nclass = data(1:n1)
end subroutine psset_difnx_nclass


subroutine psgetrnk_difnx_nclass(iobj, ndims, ierr)
    !! main-impurity-density-equations, neoclassical diffusivity
    !! from NCLASS model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_difnx_nclass


subroutine psgetdim_difnx_nclass(iobj, ndims, dims, ierr)
    !! main-impurity-density-equations, neoclassical diffusivity
    !! from NCLASS model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_difnx_nclass', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % difnx_nclass ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % difnx_nclass)
    endif
end subroutine psgetdim_difnx_nclass


subroutine psget_dxrjcos_momeq_drho(iobj, n1, n2, data, ierr)
    !! scaled R cos moments, Fourier Spline representation
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_dxrjcos_momeq_drho', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % dxRjcos_momeq_dRHO
end subroutine psget_dxrjcos_momeq_drho


subroutine psset_dxrjcos_momeq_drho(iobj, n1, n2, data, ierr)
    !! scaled R cos moments, Fourier Spline representation
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_dxrjcos_momeq_drho', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % dxRjcos_momeq_dRHO = data(1:n1, 1: n2)
end subroutine psset_dxrjcos_momeq_drho


subroutine psgetrnk_dxrjcos_momeq_drho(iobj, ndims, ierr)
    !! scaled R cos moments, Fourier Spline representation
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_dxrjcos_momeq_drho


subroutine psgetdim_dxrjcos_momeq_drho(iobj, ndims, dims, ierr)
    !! scaled R cos moments, Fourier Spline representation
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_dxrjcos_momeq_drho', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % dxRjcos_momeq_dRHO ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % dxRjcos_momeq_dRHO)
    endif
end subroutine psgetdim_dxrjcos_momeq_drho

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


SUBROUTINE plasma_state_clear_profs(cclist,ss,ierr)

  !   set profile data to ZERO
  !   scalar data and id & name variables unaffected.
  !   grids and species lists and item lists unaffected.

  USE plasma_state_definition_mod
  IMPLICIT NONE

  INTEGER, INTENT(IN) :: cclist(ps_ccount)
                                ! list of components in which to clear profiles
                                ! use ps_cc_all to clear all components

  TYPE (plasma_state) :: ss     ! state object whose profiles are to be cleared
  INTEGER, INTENT(OUT) :: ierr  ! completion code (0=OK)

  ! errors -- expected array dimensions undefined
  !           arrays already allocated

  !-------------------
  INTEGER :: iout,isize
  !-------------------

  iout = SWIM_err_out_file

  ierr = 0


  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%anom_evar)) ss%anom_evar = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_EQ).EQ.1) THEN
     IF(ALLOCATED(ss%area)) ss%area = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_LMHD).EQ.1) THEN
     IF(ALLOCATED(ss%balstab)) ss%balstab = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%bidiff_bpass_co)) ss%bidiff_bpass_co = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%bidiff_bpass_ctr)) ss%bidiff_bpass_ctr = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%bidiff_btrap)) ss%bidiff_btrap = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%bidiff_dpass_co)) ss%bidiff_dpass_co = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%bidiff_dpass_ctr)) ss%bidiff_dpass_ctr = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%bidiff_dtrap)) ss%bidiff_dtrap = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_EQ).EQ.1) THEN
     IF(ALLOCATED(ss%BphiRZ)) ss%BphiRZ = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_EQ).EQ.1) THEN
     IF(ALLOCATED(ss%BRRZ)) ss%BRRZ = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_EQ).EQ.1) THEN
     IF(ALLOCATED(ss%BZRZ)) ss%BZRZ = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_EQ).EQ.1) THEN
     IF(ALLOCATED(ss%B_surfMax)) ss%B_surfMax = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_EQ).EQ.1) THEN
     IF(ALLOCATED(ss%B_surfMin)) ss%B_surfMin = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_IC).EQ.1) THEN
     IF(ALLOCATED(ss%cdicrf)) ss%cdicrf = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_IC).EQ.1) THEN
     IF(ALLOCATED(ss%cdicrf_nphi)) ss%cdicrf_nphi = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%chie_anom)) ss%chie_anom = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%chie_drbm)) ss%chie_drbm = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%chie_etg)) ss%chie_etg = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%chie_glf)) ss%chie_glf = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%chie_gtcneo)) ss%chie_gtcneo = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%chie_mmm71)) ss%chie_mmm71 = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%chie_mtm)) ss%chie_mtm = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%chie_nclass)) ss%chie_nclass = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%chie_neo)) ss%chie_neo = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%chie_ntm)) ss%chie_ntm = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%chie_paleo)) ss%chie_paleo = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%chie_tglf)) ss%chie_tglf = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_PLASMA).EQ.1) THEN
     IF(ALLOCATED(ss%chie_trans)) ss%chie_trans = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_PLASMA).EQ.1) THEN
     IF(ALLOCATED(ss%chie_transcat)) ss%chie_transcat = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%chie_w19)) ss%chie_w19 = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%chii_anom)) ss%chii_anom = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%chii_drbm)) ss%chii_drbm = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%chii_glf)) ss%chii_glf = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%chii_gtcneo)) ss%chii_gtcneo = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%chii_mmm71)) ss%chii_mmm71 = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%chii_nclass)) ss%chii_nclass = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%chii_neo)) ss%chii_neo = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%chii_ntm)) ss%chii_ntm = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%chii_tglf)) ss%chii_tglf = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_PLASMA).EQ.1) THEN
     IF(ALLOCATED(ss%chii_trans)) ss%chii_trans = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_PLASMA).EQ.1) THEN
     IF(ALLOCATED(ss%chii_transcat)) ss%chii_transcat = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%chii_w19)) ss%chii_w19 = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_PLASMA).EQ.1) THEN
     IF(ALLOCATED(ss%chimo_trans)) ss%chimo_trans = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_PLASMA).EQ.1) THEN
     IF(ALLOCATED(ss%chimo_transcat)) ss%chimo_transcat = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%chiphi_anom)) ss%chiphi_anom = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%chiphi_drbm)) ss%chiphi_drbm = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%chiphi_glf)) ss%chiphi_glf = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%chiphi_gtcneo)) ss%chiphi_gtcneo = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%chiphi_mmm71)) ss%chiphi_mmm71 = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%chiphi_neo)) ss%chiphi_neo = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%chiphi_tglf)) ss%chiphi_tglf = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%chiphi_w19)) ss%chiphi_w19 = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%chitheta_mmm71)) ss%chitheta_mmm71 = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_NBI).EQ.1) THEN
     IF(ALLOCATED(ss%curbeam)) ss%curbeam = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_EC).EQ.1) THEN
     IF(ALLOCATED(ss%curech)) ss%curech = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_EC).EQ.1) THEN
     IF(ALLOCATED(ss%curech_src)) ss%curech_src = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_FUS).EQ.1) THEN
     IF(ALLOCATED(ss%curfusn)) ss%curfusn = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_IC).EQ.1) THEN
     IF(ALLOCATED(ss%curich)) ss%curich = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_LH).EQ.1) THEN
     IF(ALLOCATED(ss%curlh)) ss%curlh = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_LH).EQ.1) THEN
     IF(ALLOCATED(ss%curlh_src)) ss%curlh_src = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_IC).EQ.1) THEN
     IF(ALLOCATED(ss%curmino)) ss%curmino = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_PLASMA).EQ.1) THEN
     IF(ALLOCATED(ss%curr_bootstrap)) ss%curr_bootstrap = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_PLASMA).EQ.1) THEN
     IF(ALLOCATED(ss%curr_ohmic)) ss%curr_ohmic = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_EQ).EQ.1) THEN
     IF(ALLOCATED(ss%curt)) ss%curt = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_RUNAWAY).EQ.1) THEN
     IF(ALLOCATED(ss%cur_rw)) ss%cur_rw = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_EQ).EQ.1) THEN
     IF(ALLOCATED(ss%d2R_geo_dRHOdTH)) ss%d2R_geo_dRHOdTH = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_EQ).EQ.1) THEN
     IF(ALLOCATED(ss%d2Z_geo_dRHOdTH)) ss%d2Z_geo_dRHOdTH = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%db_mtm)) ss%db_mtm = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_RUNAWAY).EQ.1) THEN
     IF(ALLOCATED(ss%dcur_rw_dVloop)) ss%dcur_rw_dVloop = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%difb_fusi)) ss%difb_fusi = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%difb_nbi)) ss%difb_nbi = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%difb_rfmi)) ss%difb_rfmi = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_PLASMA).EQ.1) THEN
     IF(ALLOCATED(ss%diff_trans)) ss%diff_trans = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_PLASMA).EQ.1) THEN
     IF(ALLOCATED(ss%diff_transcat)) ss%diff_transcat = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%difne_nclass)) ss%difne_nclass = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%difnh_nclass)) ss%difnh_nclass = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%difns_anom)) ss%difns_anom = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%difns_drbm)) ss%difns_drbm = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%difns_glf)) ss%difns_glf = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%difns_gtcneo)) ss%difns_gtcneo = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%difns_mmm71)) ss%difns_mmm71 = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%difns_nclass)) ss%difns_nclass = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%difns_neo)) ss%difns_neo = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%difns_tglf)) ss%difns_tglf = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%difns_w19)) ss%difns_w19 = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%difnx_nclass)) ss%difnx_nclass = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%difnz_mmm71)) ss%difnz_mmm71 = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%dQedGrdte_tglf)) ss%dQedGrdte_tglf = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%dQedGrdti_tglf)) ss%dQedGrdti_tglf = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%dQidGrdte_tglf)) ss%dQidGrdte_tglf = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%dQidGrdti_tglf)) ss%dQidGrdti_tglf = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_EQ).EQ.1) THEN
     IF(ALLOCATED(ss%dR0_momeq_dRHO)) ss%dR0_momeq_dRHO = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_EQ).EQ.1) THEN
     IF(ALLOCATED(ss%dR_geo_dRHO)) ss%dR_geo_dRHO = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_EQ).EQ.1) THEN
     IF(ALLOCATED(ss%dR_geo_dTH)) ss%dR_geo_dTH = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_EQ).EQ.1) THEN
     IF(ALLOCATED(ss%dxRjcos_momeq_dRHO)) ss%dxRjcos_momeq_dRHO = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_EQ).EQ.1) THEN
     IF(ALLOCATED(ss%dxRjsin_momeq_dRHO)) ss%dxRjsin_momeq_dRHO = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_EQ).EQ.1) THEN
     IF(ALLOCATED(ss%dxZjcos_momeq_dRHO)) ss%dxZjcos_momeq_dRHO = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_EQ).EQ.1) THEN
     IF(ALLOCATED(ss%dxZjsin_momeq_dRHO)) ss%dxZjsin_momeq_dRHO = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_EQ).EQ.1) THEN
     IF(ALLOCATED(ss%dZ0_momeq_dRHO)) ss%dZ0_momeq_dRHO = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_EQ).EQ.1) THEN
     IF(ALLOCATED(ss%dZ_geo_dRHO)) ss%dZ_geo_dRHO = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_EQ).EQ.1) THEN
     IF(ALLOCATED(ss%dZ_geo_dTH)) ss%dZ_geo_dTH = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%ee_mobility_factor)) ss%ee_mobility_factor = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_EQ).EQ.1) THEN
     IF(ALLOCATED(ss%elong)) ss%elong = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_NBI).EQ.1) THEN
     IF(ALLOCATED(ss%eperp_beami)) ss%eperp_beami = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_FUS).EQ.1) THEN
     IF(ALLOCATED(ss%eperp_fusi)) ss%eperp_fusi = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_IC).EQ.1) THEN
     IF(ALLOCATED(ss%eperp_mini)) ss%eperp_mini = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_RUNAWAY).EQ.1) THEN
     IF(ALLOCATED(ss%eperp_rw)) ss%eperp_rw = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_NBI).EQ.1) THEN
     IF(ALLOCATED(ss%epll_beami)) ss%epll_beami = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_FUS).EQ.1) THEN
     IF(ALLOCATED(ss%epll_fusi)) ss%epll_fusi = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_IC).EQ.1) THEN
     IF(ALLOCATED(ss%epll_mini)) ss%epll_mini = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_RUNAWAY).EQ.1) THEN
     IF(ALLOCATED(ss%epll_rw)) ss%epll_rw = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_PLASMA).EQ.1) THEN
     IF(ALLOCATED(ss%Epot)) ss%Epot = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_PLASMA).EQ.1) THEN
     IF(ALLOCATED(ss%eta_parallel)) ss%eta_parallel = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%fidiff_bpass_co)) ss%fidiff_bpass_co = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%fidiff_bpass_ctr)) ss%fidiff_bpass_ctr = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%fidiff_btrap)) ss%fidiff_btrap = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%fidiff_dpass_co)) ss%fidiff_dpass_co = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%fidiff_dpass_ctr)) ss%fidiff_dpass_ctr = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%fidiff_dtrap)) ss%fidiff_dtrap = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_PLASMA).EQ.1) THEN
     IF(ALLOCATED(ss%Fi_depletion)) ss%Fi_depletion = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%freq_drbm)) ss%freq_drbm = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%freq_glf)) ss%freq_glf = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%freq_max_tglf)) ss%freq_max_tglf = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%freq_mmm71)) ss%freq_mmm71 = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%freq_mtm)) ss%freq_mtm = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%freq_tglf)) ss%freq_tglf = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_EQ).EQ.1) THEN
     IF(ALLOCATED(ss%gamma_nc)) ss%gamma_nc = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_EQ).EQ.1) THEN
     IF(ALLOCATED(ss%gb1)) ss%gb1 = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_EQ).EQ.1) THEN
     IF(ALLOCATED(ss%gb2)) ss%gb2 = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_EQ).EQ.1) THEN
     IF(ALLOCATED(ss%gb2i)) ss%gb2i = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_EQ).EQ.1) THEN
     IF(ALLOCATED(ss%gbr2)) ss%gbr2 = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_EQ).EQ.1) THEN
     IF(ALLOCATED(ss%gncfb2h)) ss%gncfb2h = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_EQ).EQ.1) THEN
     IF(ALLOCATED(ss%gncfh)) ss%gncfh = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_EQ).EQ.1) THEN
     IF(ALLOCATED(ss%gr1)) ss%gr1 = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_EQ).EQ.1) THEN
     IF(ALLOCATED(ss%gr2)) ss%gr2 = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_EQ).EQ.1) THEN
     IF(ALLOCATED(ss%gr2i)) ss%gr2i = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_EQ).EQ.1) THEN
     IF(ALLOCATED(ss%gr2rho2)) ss%gr2rho2 = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_EQ).EQ.1) THEN
     IF(ALLOCATED(ss%gr3i)) ss%gr3i = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_EQ).EQ.1) THEN
     IF(ALLOCATED(ss%grho1)) ss%grho1 = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_EQ).EQ.1) THEN
     IF(ALLOCATED(ss%grho2)) ss%grho2 = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_EQ).EQ.1) THEN
     IF(ALLOCATED(ss%grho2b2i)) ss%grho2b2i = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_EQ).EQ.1) THEN
     IF(ALLOCATED(ss%grho2r2i)) ss%grho2r2i = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_EQ).EQ.1) THEN
     IF(ALLOCATED(ss%grho2r3i)) ss%grho2r3i = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_EQ).EQ.1) THEN
     IF(ALLOCATED(ss%gri)) ss%gri = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_EQ).EQ.1) THEN
     IF(ALLOCATED(ss%grirhoi)) ss%grirhoi = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%growthrate_drbm)) ss%growthrate_drbm = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%growthrate_glf)) ss%growthrate_glf = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%growthrate_max_tglf)) ss%growthrate_max_tglf = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%growthrate_mmm71)) ss%growthrate_mmm71 = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%growthrate_mtm)) ss%growthrate_mtm = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%growthrate_tglf)) ss%growthrate_tglf = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%growthrate_vpar)) ss%growthrate_vpar = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_EQ).EQ.1) THEN
     IF(ALLOCATED(ss%g_eq)) ss%g_eq = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_PLASMA).EQ.1) THEN
     IF(ALLOCATED(ss%iota)) ss%iota = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_EQ).EQ.1) THEN
     IF(ALLOCATED(ss%jdotb)) ss%jdotb = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%kyrhos_mtm)) ss%kyrhos_mtm = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%kyspectrum_tglf)) ss%kyspectrum_tglf = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_EQ).EQ.1) THEN
     IF(ALLOCATED(ss%Lpol)) ss%Lpol = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_GAS).EQ.1) THEN
     IF(ALLOCATED(ss%n0norm)) ss%n0norm = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_NBI).EQ.1) THEN
     IF(ALLOCATED(ss%n0_halo)) ss%n0_halo = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_GAS).EQ.1) THEN
     IF(ALLOCATED(ss%n0_reco)) ss%n0_reco = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_NBI).EQ.1) THEN
     IF(ALLOCATED(ss%nbeami)) ss%nbeami = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%neflux_ky_tglf)) ss%neflux_ky_tglf = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%ne_ky_tglf)) ss%ne_ky_tglf = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_FUS).EQ.1) THEN
     IF(ALLOCATED(ss%nfusi)) ss%nfusi = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_EQ).EQ.1) THEN
     IF(ALLOCATED(ss%ngradb2_av)) ss%ngradb2_av = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_PLASMA).EQ.1) THEN
     IF(ALLOCATED(ss%ni)) ss%ni = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%niflux_ky_tglf)) ss%niflux_ky_tglf = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%ni_ky_tglf)) ss%ni_ky_tglf = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_IC).EQ.1) THEN
     IF(ALLOCATED(ss%nmini)) ss%nmini = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%nmodel)) ss%nmodel = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_RUNAWAY).EQ.1) THEN
     IF(ALLOCATED(ss%nrw)) ss%nrw = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_PLASMA).EQ.1) THEN
     IF(ALLOCATED(ss%ns)) ss%ns = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%nzflux_ky_tglf)) ss%nzflux_ky_tglf = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%nz_ky_tglf)) ss%nz_ky_tglf = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_GAS).EQ.1) THEN
     IF(ALLOCATED(ss%omeg0cx)) ss%omeg0cx = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_GAS).EQ.1) THEN
     IF(ALLOCATED(ss%omeg0sc0)) ss%omeg0sc0 = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_NBI).EQ.1) THEN
     IF(ALLOCATED(ss%omeg0_halo)) ss%omeg0_halo = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_GAS).EQ.1) THEN
     IF(ALLOCATED(ss%omeg0_reco)) ss%omeg0_reco = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_PLASMA).EQ.1) THEN
     IF(ALLOCATED(ss%omegat)) ss%omegat = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%omega_exb)) ss%omega_exb = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_GAS).EQ.1) THEN
     IF(ALLOCATED(ss%p0_reco)) ss%p0_reco = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_NBI).EQ.1) THEN
     IF(ALLOCATED(ss%pb0_halo)) ss%pb0_halo = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_NBI).EQ.1) THEN
     IF(ALLOCATED(ss%pbe)) ss%pbe = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_NBI).EQ.1) THEN
     IF(ALLOCATED(ss%pbi)) ss%pbi = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_NBI).EQ.1) THEN
     IF(ALLOCATED(ss%pbth)) ss%pbth = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_NBI).EQ.1) THEN
     IF(ALLOCATED(ss%pcx_halo)) ss%pcx_halo = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_GAS).EQ.1) THEN
     IF(ALLOCATED(ss%pcx_reco)) ss%pcx_reco = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_EC).EQ.1) THEN
     IF(ALLOCATED(ss%peech)) ss%peech = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_EC).EQ.1) THEN
     IF(ALLOCATED(ss%peech_src)) ss%peech_src = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_LH).EQ.1) THEN
     IF(ALLOCATED(ss%pelh)) ss%pelh = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_LH).EQ.1) THEN
     IF(ALLOCATED(ss%pelh_src)) ss%pelh_src = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%pe_anom)) ss%pe_anom = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_PLASMA).EQ.1) THEN
     IF(ALLOCATED(ss%pe_trans)) ss%pe_trans = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_PLASMA).EQ.1) THEN
     IF(ALLOCATED(ss%pe_transcat)) ss%pe_transcat = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_FUS).EQ.1) THEN
     IF(ALLOCATED(ss%pfuse)) ss%pfuse = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_FUS).EQ.1) THEN
     IF(ALLOCATED(ss%pfusi)) ss%pfusi = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_FUS).EQ.1) THEN
     IF(ALLOCATED(ss%pfusth)) ss%pfusth = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%phiflux_ky_tglf)) ss%phiflux_ky_tglf = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_EQ).EQ.1) THEN
     IF(ALLOCATED(ss%phit)) ss%phit = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_IC).EQ.1) THEN
     IF(ALLOCATED(ss%picrf_nphi_srcs)) ss%picrf_nphi_srcs = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_IC).EQ.1) THEN
     IF(ALLOCATED(ss%picrf_srcs)) ss%picrf_srcs = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_IC).EQ.1) THEN
     IF(ALLOCATED(ss%picrf_totals)) ss%picrf_totals = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_IC).EQ.1) THEN
     IF(ALLOCATED(ss%picth)) ss%picth = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_LH).EQ.1) THEN
     IF(ALLOCATED(ss%pilh)) ss%pilh = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_LH).EQ.1) THEN
     IF(ALLOCATED(ss%pilh_src)) ss%pilh_src = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%pi_anom)) ss%pi_anom = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_PLASMA).EQ.1) THEN
     IF(ALLOCATED(ss%pi_trans)) ss%pi_trans = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_PLASMA).EQ.1) THEN
     IF(ALLOCATED(ss%pi_transcat)) ss%pi_transcat = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_IC).EQ.1) THEN
     IF(ALLOCATED(ss%pmine)) ss%pmine = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_IC).EQ.1) THEN
     IF(ALLOCATED(ss%pmini)) ss%pmini = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_IC).EQ.1) THEN
     IF(ALLOCATED(ss%pminth)) ss%pminth = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_PLASMA).EQ.1) THEN
     IF(ALLOCATED(ss%pohme)) ss%pohme = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%pot_ky_tglf)) ss%pot_ky_tglf = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_RAD).EQ.1) THEN
     IF(ALLOCATED(ss%prad)) ss%prad = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_RAD).EQ.1) THEN
     IF(ALLOCATED(ss%prad_br)) ss%prad_br = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_RAD).EQ.1) THEN
     IF(ALLOCATED(ss%prad_cy)) ss%prad_cy = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_RAD).EQ.1) THEN
     IF(ALLOCATED(ss%prad_li)) ss%prad_li = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_NBI).EQ.1) THEN
     IF(ALLOCATED(ss%psc_halo)) ss%psc_halo = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_GAS).EQ.1) THEN
     IF(ALLOCATED(ss%psc_reco)) ss%psc_reco = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_EQ).EQ.1) THEN
     IF(ALLOCATED(ss%psipol)) ss%psipol = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_EQ).EQ.1) THEN
     IF(ALLOCATED(ss%PsiRZ)) ss%PsiRZ = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_EQ).EQ.1) THEN
     IF(ALLOCATED(ss%psmom_errck)) ss%psmom_errck = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_EQ).EQ.1) THEN
     IF(ALLOCATED(ss%psmom_nc)) ss%psmom_nc = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_EQ).EQ.1) THEN
     IF(ALLOCATED(ss%P_eq)) ss%P_eq = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_NBI).EQ.1) THEN
     IF(ALLOCATED(ss%qbeami)) ss%qbeami = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_PLASMA).EQ.1) THEN
     IF(ALLOCATED(ss%qcomp_e)) ss%qcomp_e = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_PLASMA).EQ.1) THEN
     IF(ALLOCATED(ss%qcomp_i)) ss%qcomp_i = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_PLASMA).EQ.1) THEN
     IF(ALLOCATED(ss%qie)) ss%qie = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_GAS).EQ.1) THEN
     IF(ALLOCATED(ss%qioniz)) ss%qioniz = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_GAS).EQ.1) THEN
     IF(ALLOCATED(ss%qqcx)) ss%qqcx = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_PLASMA).EQ.1) THEN
     IF(ALLOCATED(ss%qrot_conv)) ss%qrot_conv = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_PLASMA).EQ.1) THEN
     IF(ALLOCATED(ss%qrot_diff)) ss%qrot_diff = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_EQ).EQ.1) THEN
     IF(ALLOCATED(ss%q_eq)) ss%q_eq = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_EQ).EQ.1) THEN
     IF(ALLOCATED(ss%R0_momeq)) ss%R0_momeq = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_NBI).EQ.1) THEN
     IF(ALLOCATED(ss%rate_sinb0i)) ss%rate_sinb0i = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_NBI).EQ.1) THEN
     IF(ALLOCATED(ss%rate_sinb0x)) ss%rate_sinb0x = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_NBI).EQ.1) THEN
     IF(ALLOCATED(ss%rate_sinb0xs)) ss%rate_sinb0xs = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_FUS).EQ.1) THEN
     IF(ALLOCATED(ss%rate_sinf0i)) ss%rate_sinf0i = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_FUS).EQ.1) THEN
     IF(ALLOCATED(ss%rate_sinf0x)) ss%rate_sinf0x = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_FUS).EQ.1) THEN
     IF(ALLOCATED(ss%rate_sinf0xs)) ss%rate_sinf0xs = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_PLASMA).EQ.1) THEN
     IF(ALLOCATED(ss%res_sn)) ss%res_sn = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_PLASMA).EQ.1) THEN
     IF(ALLOCATED(ss%res_te)) ss%res_te = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_PLASMA).EQ.1) THEN
     IF(ALLOCATED(ss%res_ti)) ss%res_ti = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_PLASMA).EQ.1) THEN
     IF(ALLOCATED(ss%res_tq)) ss%res_tq = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_EQ).EQ.1) THEN
     IF(ALLOCATED(ss%Rmajor_mean)) ss%Rmajor_mean = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_EQ).EQ.1) THEN
     IF(ALLOCATED(ss%rMinor_mean)) ss%rMinor_mean = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_EQ).EQ.1) THEN
     IF(ALLOCATED(ss%R_geo)) ss%R_geo = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_EQ).EQ.1) THEN
     IF(ALLOCATED(ss%R_midp_in)) ss%R_midp_in = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_EQ).EQ.1) THEN
     IF(ALLOCATED(ss%R_midp_out)) ss%R_midp_out = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_EQ).EQ.1) THEN
     IF(ALLOCATED(ss%R_surfMax)) ss%R_surfMax = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_EQ).EQ.1) THEN
     IF(ALLOCATED(ss%R_surfMin)) ss%R_surfMin = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_GAS).EQ.1) THEN
     IF(ALLOCATED(ss%s0reco)) ss%s0reco = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_GAS).EQ.1) THEN
     IF(ALLOCATED(ss%s0reco_e)) ss%s0reco_e = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_GAS).EQ.1) THEN
     IF(ALLOCATED(ss%s0reco_recap)) ss%s0reco_recap = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_NBI).EQ.1) THEN
     IF(ALLOCATED(ss%sb0halo)) ss%sb0halo = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_NBI).EQ.1) THEN
     IF(ALLOCATED(ss%sb0halo_recap)) ss%sb0halo_recap = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_NBI).EQ.1) THEN
     IF(ALLOCATED(ss%sbedep)) ss%sbedep = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_NBI).EQ.1) THEN
     IF(ALLOCATED(ss%sbehalo)) ss%sbehalo = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_NBI).EQ.1) THEN
     IF(ALLOCATED(ss%sbsce)) ss%sbsce = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_NBI).EQ.1) THEN
     IF(ALLOCATED(ss%sbtherm)) ss%sbtherm = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%sc_anom)) ss%sc_anom = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_FUS).EQ.1) THEN
     IF(ALLOCATED(ss%sfsce)) ss%sfsce = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_FUS).EQ.1) THEN
     IF(ALLOCATED(ss%sftherm)) ss%sftherm = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_RAD).EQ.1) THEN
     IF(ALLOCATED(ss%sii_xs)) ss%sii_xs = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_PLASMA).EQ.1) THEN
     IF(ALLOCATED(ss%sn_trans)) ss%sn_trans = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_PLASMA).EQ.1) THEN
     IF(ALLOCATED(ss%sn_transcat)) ss%sn_transcat = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_GAS).EQ.1) THEN
     IF(ALLOCATED(ss%sprof0)) ss%sprof0 = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_GAS).EQ.1) THEN
     IF(ALLOCATED(ss%sprof0e)) ss%sprof0e = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_PEL).EQ.1) THEN
     IF(ALLOCATED(ss%spsce)) ss%spsce = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_EQ).EQ.1) THEN
     IF(ALLOCATED(ss%squareLO)) ss%squareLO = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_EQ).EQ.1) THEN
     IF(ALLOCATED(ss%squareUO)) ss%squareUO = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_EQ).EQ.1) THEN
     IF(ALLOCATED(ss%surf)) ss%surf = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_GAS).EQ.1) THEN
     IF(ALLOCATED(ss%T0cx)) ss%T0cx = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_GAS).EQ.1) THEN
     IF(ALLOCATED(ss%T0sc0)) ss%T0sc0 = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_NBI).EQ.1) THEN
     IF(ALLOCATED(ss%T0_halo)) ss%T0_halo = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_GAS).EQ.1) THEN
     IF(ALLOCATED(ss%T0_reco)) ss%T0_reco = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%teflux_ky_tglf)) ss%teflux_ky_tglf = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%te_ky_tglf)) ss%te_ky_tglf = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_RIPPLE).EQ.1) THEN
     IF(ALLOCATED(ss%tfrip2_log)) ss%tfrip2_log = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_RIPPLE).EQ.1) THEN
     IF(ALLOCATED(ss%tfrip_log)) ss%tfrip_log = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_PLASMA).EQ.1) THEN
     IF(ALLOCATED(ss%Ti)) ss%Ti = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%tiflux_ky_tglf)) ss%tiflux_ky_tglf = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%ti_ky_tglf)) ss%ti_ky_tglf = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%tmodel)) ss%tmodel = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_GAS).EQ.1) THEN
     IF(ALLOCATED(ss%tq0_reco)) ss%tq0_reco = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_NBI).EQ.1) THEN
     IF(ALLOCATED(ss%tqb0_halo)) ss%tqb0_halo = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_NBI).EQ.1) THEN
     IF(ALLOCATED(ss%tqbe)) ss%tqbe = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_NBI).EQ.1) THEN
     IF(ALLOCATED(ss%tqbi)) ss%tqbi = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_NBI).EQ.1) THEN
     IF(ALLOCATED(ss%tqbjxb)) ss%tqbjxb = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_NBI).EQ.1) THEN
     IF(ALLOCATED(ss%tqbth)) ss%tqbth = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_NBI).EQ.1) THEN
     IF(ALLOCATED(ss%tqcx_halo)) ss%tqcx_halo = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_GAS).EQ.1) THEN
     IF(ALLOCATED(ss%tqcx_reco)) ss%tqcx_reco = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_GAS).EQ.1) THEN
     IF(ALLOCATED(ss%tqioniz)) ss%tqioniz = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_GAS).EQ.1) THEN
     IF(ALLOCATED(ss%tqqcx)) ss%tqqcx = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_NBI).EQ.1) THEN
     IF(ALLOCATED(ss%tqsc_halo)) ss%tqsc_halo = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_GAS).EQ.1) THEN
     IF(ALLOCATED(ss%tqsc_reco)) ss%tqsc_reco = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%tq_anom)) ss%tq_anom = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_PLASMA).EQ.1) THEN
     IF(ALLOCATED(ss%tq_trans)) ss%tq_trans = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_PLASMA).EQ.1) THEN
     IF(ALLOCATED(ss%tq_transcat)) ss%tq_transcat = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_EQ).EQ.1) THEN
     IF(ALLOCATED(ss%triang)) ss%triang = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_EQ).EQ.1) THEN
     IF(ALLOCATED(ss%triangL)) ss%triangL = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_EQ).EQ.1) THEN
     IF(ALLOCATED(ss%triangU)) ss%triangU = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_EQ).EQ.1) THEN
     IF(ALLOCATED(ss%triang_miller_L)) ss%triang_miller_L = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_EQ).EQ.1) THEN
     IF(ALLOCATED(ss%triang_miller_U)) ss%triang_miller_U = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_PLASMA).EQ.1) THEN
     IF(ALLOCATED(ss%Ts)) ss%Ts = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%tzflux_ky_tglf)) ss%tzflux_ky_tglf = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%tz_ky_tglf)) ss%tz_ky_tglf = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_PLASMA).EQ.1) THEN
     IF(ALLOCATED(ss%upwind_pfrac_ns)) ss%upwind_pfrac_ns = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_PLASMA).EQ.1) THEN
     IF(ALLOCATED(ss%upwind_pfrac_omega)) ss%upwind_pfrac_omega = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_PLASMA).EQ.1) THEN
     IF(ALLOCATED(ss%upwind_pfrac_Te)) ss%upwind_pfrac_Te = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_PLASMA).EQ.1) THEN
     IF(ALLOCATED(ss%upwind_pfrac_Ti)) ss%upwind_pfrac_Ti = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_PLASMA).EQ.1) THEN
     IF(ALLOCATED(ss%vee_trans)) ss%vee_trans = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_PLASMA).EQ.1) THEN
     IF(ALLOCATED(ss%vee_transcat)) ss%vee_transcat = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%velb_fusi)) ss%velb_fusi = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%velb_nbi)) ss%velb_nbi = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%velb_rfmi)) ss%velb_rfmi = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%velne_nclass)) ss%velne_nclass = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%velnh_nclass)) ss%velnh_nclass = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%velni_drbm)) ss%velni_drbm = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%velns_anom)) ss%velns_anom = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%velns_glf)) ss%velns_glf = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%velns_gtcneo)) ss%velns_gtcneo = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%velns_mmm71)) ss%velns_mmm71 = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%velns_nclass)) ss%velns_nclass = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%velns_neo)) ss%velns_neo = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%velns_tglf)) ss%velns_tglf = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%velnx_nclass)) ss%velnx_nclass = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%velpphi_anom)) ss%velpphi_anom = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%velpphi_glf)) ss%velpphi_glf = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%velpphi_gtcneo)) ss%velpphi_gtcneo = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%velpphi_mmm71)) ss%velpphi_mmm71 = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%velpphi_neo)) ss%velpphi_neo = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%velpphi_tglf)) ss%velpphi_tglf = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%velte_anom)) ss%velte_anom = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%velte_glf)) ss%velte_glf = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%velte_gtcneo)) ss%velte_gtcneo = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%velte_mmm71)) ss%velte_mmm71 = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%velte_nclass)) ss%velte_nclass = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%velte_neo)) ss%velte_neo = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%velte_paleo)) ss%velte_paleo = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%velte_tglf)) ss%velte_tglf = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%velti_anom)) ss%velti_anom = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%velti_glf)) ss%velti_glf = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%velti_gtcneo)) ss%velti_gtcneo = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%velti_mmm71)) ss%velti_mmm71 = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%velti_nclass)) ss%velti_nclass = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%velti_neo)) ss%velti_neo = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     IF(ALLOCATED(ss%velti_tglf)) ss%velti_tglf = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_PLASMA).EQ.1) THEN
     IF(ALLOCATED(ss%vie_trans)) ss%vie_trans = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_PLASMA).EQ.1) THEN
     IF(ALLOCATED(ss%vie_transcat)) ss%vie_transcat = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_PLASMA).EQ.1) THEN
     IF(ALLOCATED(ss%vmo_trans)) ss%vmo_trans = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_PLASMA).EQ.1) THEN
     IF(ALLOCATED(ss%vmo_transcat)) ss%vmo_transcat = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_PLASMA).EQ.1) THEN
     IF(ALLOCATED(ss%vn_trans)) ss%vn_trans = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_PLASMA).EQ.1) THEN
     IF(ALLOCATED(ss%vn_transcat)) ss%vn_transcat = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_EQ).EQ.1) THEN
     IF(ALLOCATED(ss%vol)) ss%vol = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_PLASMA).EQ.1) THEN
     IF(ALLOCATED(ss%vpol_inmp)) ss%vpol_inmp = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_PLASMA).EQ.1) THEN
     IF(ALLOCATED(ss%vpol_omp)) ss%vpol_omp = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_PLASMA).EQ.1) THEN
     IF(ALLOCATED(ss%vtor_inmp)) ss%vtor_inmp = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_PLASMA).EQ.1) THEN
     IF(ALLOCATED(ss%vtor_omp)) ss%vtor_omp = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_PLASMA).EQ.1) THEN
     IF(ALLOCATED(ss%V_loop)) ss%V_loop = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_PLASMA).EQ.1) THEN
     IF(ALLOCATED(ss%v_pars)) ss%v_pars = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_PLASMA).EQ.1) THEN
     IF(ALLOCATED(ss%v_pers)) ss%v_pers = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_EQ).EQ.1) THEN
     IF(ALLOCATED(ss%xRjcos_momeq)) ss%xRjcos_momeq = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_EQ).EQ.1) THEN
     IF(ALLOCATED(ss%xRjsin_momeq)) ss%xRjsin_momeq = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_EQ).EQ.1) THEN
     IF(ALLOCATED(ss%xZjcos_momeq)) ss%xZjcos_momeq = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_EQ).EQ.1) THEN
     IF(ALLOCATED(ss%xZjsin_momeq)) ss%xZjsin_momeq = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_EQ).EQ.1) THEN
     IF(ALLOCATED(ss%Z0_momeq)) ss%Z0_momeq = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_PLASMA).EQ.1) THEN
     IF(ALLOCATED(ss%Zeff)) ss%Zeff = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_PLASMA).EQ.1) THEN
     IF(ALLOCATED(ss%Zeff_fi)) ss%Zeff_fi = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_PLASMA).EQ.1) THEN
     IF(ALLOCATED(ss%Zeff_th)) ss%Zeff_th = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_EQ).EQ.1) THEN
     IF(ALLOCATED(ss%Z_geo)) ss%Z_geo = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_EQ).EQ.1) THEN
     IF(ALLOCATED(ss%Z_midp)) ss%Z_midp = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_EQ).EQ.1) THEN
     IF(ALLOCATED(ss%Z_surfMax)) ss%Z_surfMax = 0.0_rspec
  ENDIF
  IF(cclist(ps_cnum_EQ).EQ.1) THEN
     IF(ALLOCATED(ss%Z_surfMin)) ss%Z_surfMin = 0.0_rspec
  ENDIF


END SUBROUTINE plasma_state_clear_profs

program ps_nbline_driver

  ! demo program for ps_nbline
  ! demonstrate:
  !   (a) setup of a random number generator (rng);
  !   (b) access to a Plasma State with an NBI machine description plus
  !       powers, voltages, and energy fractions;
  !   (c) fetch and print N randomly chosen starting coordinates for
  !       beam neutrals: (R,phi,Z,v_R,v_phi,v_Z) (m,rad,m,m/s,m/s,m/s)
  !
  ! command line arguments control the rng seed, the state input file,
  ! and the number N

  ! syntax:  
  !    ps_nbline_driver -seed:<seed_str> -ps:<plasma_state_file> -N:<number>

  !    (command line keywords case insensitive; -n:<number> also works).

  use rng_container   ! a container module for the Charles Karney rng
                      ! this is only one of many possible implementations

  use plasma_state_mod
  use ps_nbline_module

  implicit NONE

  !----------------------------------
  !  local:

  integer, parameter :: max_args=3
  integer :: nargs

  character*250 args(max_args),arg,value
  character*10 keywd
  character*16 znam16

  integer :: npts          ! #beam ptcl start pts to generate
  character*40 seed_str    ! RNG seed string
  character*120 PSpath     ! path to Plasma State file

  integer :: ierr,istat,ii,icolon,ilenv,istream,ie,ispecm

  integer, parameter :: rng_test_size = 50
  real*8 :: zran(rng_test_size),zgauss(rng_test_size)
  real*8 :: zavg1,zrms1,zavg2,zrms2,xcen,xwid,zv2
  real*8 :: zfrac1,zfrac2,zfrac3,zpco,zpctr,zptot
  real*8, external :: frandm,fgauss

  type (beamlet) :: trajectory

  integer :: ipts
  character*3 scod

  logical :: ilco
  !----------------------------------

  npts = 0
  seed_str = ' '
  PSpath = ' '

  ierr = 0

  !------------------------------------------------
  ! get the number of command line arguments
  call get_arg_count(nargs)

  ! is the number of arguments OK?
  if(nargs.eq.0) then
     ierr = ierr + 1
     write(6,*) ' ?ps_nbline_driver: no command line arguments found.'

  else if(nargs.gt.max_args) then
     ierr = ierr + 1
     write(6,*) ' ?ps_nbline_driver: maximum argument count exceeded: ', &
          nargs,' > ',max_args,'.'
     nargs = max_args
  endif

  !------------------------------------------------
  ! read and echo the arguments

  do ii=1,nargs
     call get_arg(ii,args(ii))
     write(6,'(a,i2,a)') '    argument no. ',ii,': '//trim(args(ii))
  enddo

  !------------------------------------------------
  ! check each individual argument
  !   syntax -<keywd>:<value>

  do ii=1,nargs
     arg = args(ii)
     if(arg(1:1).ne.'-') then
        write(6,*) ' ?ps_nbline_driver: argument #',ii, &
             ' keyword does not start with "-".'
        ierr = ierr + 1
        cycle
     endif

     icolon = index(arg,':')
     if(icolon.le.0) then
        write(6,*) ' ?ps_nbline_driver: argument #',ii, &
             ' keyword ":" delimiter missing.'
        ierr = ierr + 1
        cycle
     else if(icolon.gt.(2+len(keywd))) then
        write(6,*) ' ?ps_nbline_driver: argument #',ii, &
             ' keyword too long.'
        ierr = ierr + 1
        cycle
     endif

     !  syntax -<keywd>:<value> is OK

     keywd = arg(2:icolon-1)

     value = arg(icolon+1:)
     ilenv = len(trim(value))

     call uupper(keywd)  ! convert to uppercase

     !  check keyword; decode value

     if(keywd.eq.'N') then
        call getival(npts)     ! get value field of -N:<number>

     else if(keywd.eq.'SEED') then
        call getcval(seed_str) ! get value field of -SEED:<seed_str>

     else if(keywd.eq.'PS') then
        call getcval(PSpath)   ! get value field of -PS:<path_to_Plasma_State>

     else
        ierr = ierr + 1
        write(6,*) ' ?ps_nbline_driver: keyword unrecognized: '//trim(keywd)
     endif
  enddo

  !---------------------------
  !  did we get everything?

  if(npts.le.0) then
     ierr = ierr+1
     write(6,*) ' ?ps_nbline_driver: a positive number of beam trajectories must be specified.'
  endif

  if(pspath.eq.' ') then
     ierr = ierr+1
     write(6,*) ' ?ps_nbline_driver: a Plasma State file path must be given.'
  endif

  if(seed_str.eq.' ') then
     ierr = ierr+1
     write(6,*) ' ?ps_nbline_driver: a random number seed initialization string must be given.'
  endif

  !---------------------------
  !  syntax scan completed...

  if(ierr.ne.0) then
     write(6,*) ' '
     write(6,*) ' syntax: '
     write(6,*) ' ps_nbline_driver -ps:<Plasma_State_file_path> \ '
     write(6,*) '                  -seed:<RNG_seed_string> \ '
     write(6,*) '                  -N:<number_of_beam_trajectories>'
     write(6,*) ' '
     call exit(ierr)
  endif

  write(6,*) ' '
  write(6,*) ' ps_nbline_driver: syntax OK'
  write(6,*) ' ' 

  !--------------------------------
  !  RNG test

  istream = 1   ! this serial test code only has a single RNG stream

  xcen = 10.0d0
  xwid =  1.0d0 ! will sample exp(-(x-xcen)**2/(2*xwid**2))

  call rngcon_init(seed_str)

  zavg1 = 0.0d0
  zavg2 = 0.0d0

  do ii=1,rng_test_size
     zran(ii) = frandm(istream)
     zavg1 = zavg1 + zran(ii)
     zgauss(ii) = fgauss(istream,xcen,xwid)
     zavg2 = zavg2 + zgauss(ii)
  enddo

  zavg1 = zavg1/rng_test_size
  zavg2 = zavg2/rng_test_size

  zrms1 = 0.0d0
  zrms2 = 0.0d0

  do ii=1,rng_test_size

     zrms1 = zrms1 + (zran(ii)-zavg1)**2
     zrms2 = zrms2 + (zgauss(ii)-zavg2)**2

  enddo

  zrms1 = sqrt(zrms1/rng_test_size)
  zrms2 = sqrt(zrms2/rng_test_size)

  write(6,*) ' ------------------------------------ '
  write(6,*) ' RNG test results:'
  write(6,*) '     frandm          fgauss'
  do ii=1,rng_test_size
     write(6,'(1x,i3,2(1x,1pe15.8))') ii,zran(ii),zgauss(ii)
  enddo

  write(6,*) ' '
  write(6,'(a,2(1x,1pe15.8))') ' frandm mean & rms deviation: ',zavg1,zrms1

  write(6,*) ' '
  write(6,*) '  Guassian sample over exp(-(x-xcen)**2/(2*xwid**2))'

  write(6,'(a,2(1x,1pe15.8))') ' xcen, xwid: ',xcen,xwid
  write(6,'(a,2(1x,1pe15.8))') ' fgauss mean & rms deviation: ',zavg2,zrms2
  write(6,*) ' '

  !--------------------------------
  !  read plasma state

  write(6,*) ' ------------------------------------ '
  write(6,*) ' Read the Plasma State: ',trim(PSpath)

  call ps_get_plasma_state(ierr, filename=trim(PSpath))
  if(ierr.ne.0) then
     write(6,*) '   ?ps_nbline_driver: Plasma State file read error.'
     call exit(ierr)
  endif

  write(6,*) ' '
  write(6,*) ' The number of neutral beams: ',ps%nbeam
  write(6,*) ' '
  write(6,*) ' Check beam energy fractions...'

  call ps_chk_nbfrac(0,ierr)
  if(ierr.ne.0) then
     write(6,*) '   ?ps_nbline_driver: error in beam energy fractions.'
     call exit(ierr)
  endif
  write(6,*) ' '

  write(6,*) ' Name            co?  Pinj(W)       Einj(KeV)     F(full-E)     F(half-E)'

  zpco = 0
  zpctr= 0

  do ii=1,ps%nbeam
     znam16 = ps%nbi_src_name(ii)(1:16)
     ilco = ( ps%srtcen(ii) * ps%kccw_Jphi  .gt. 0.0 ) 

     write(6,'(1x,a,2x,L1,1x,4(2x,1pe12.5))') znam16,ilco,ps%power_nbi(ii), &
          ps%kvolt_nbi(ii), ps%frac_full(ii), ps%frac_half(ii)
     if(ilco) then
        zpco = zpco + ps%power_nbi(ii) + ps%power_nbi_trace(ii)
     else
        zpctr = zpctr + ps%power_nbi(ii) + ps%power_nbi_trace(ii)
     endif
  enddo

  zptot = zpco + zpctr

  if(zptot.le.0.0d0) then
     write(6,*) ' Total Power is ZERO.'
  else
     write(6,'(3x,a,1pe10.3,a,1pe10.3,a,1pe10.3)') 'Total Power (W): ',zptot, &
          ' Co-inj fraction: ',zpco/zptot,' Ctr-inj: ',zpctr/zptot
  endif

  write(6,*) ' '
  write(6,'(a)') ' S   iB E co  Rsta       Phista     Zsta       vR         vPhi       vZ'
  write(6,'(a)') ' --- -- - -- ---------- ---------- ---------- ---------- ---------- ----------'

  zfrac1=0
  zfrac2=0
  zfrac3=0

  zpco = 0
  zpctr= 0

  do ipts=1,npts
     call ps_nbline(istream,frandm,fgauss, &
          ps,All_species, &
          trajectory,ierr)

     if(ierr.ne.0) then
        write(6,*) ' ?ps_nbline: ierr = ',ierr
        exit
     endif

     iE = trajectory%energy_frac
     if(iE.eq.1) zfrac1 = zfrac1 + 1
     if(iE.eq.2) zfrac2 = zfrac2 + 1
     if(iE.eq.3) zfrac3 = zfrac3 + 1

     scod='?  '
     if(trajectory%specie.eq.i_Hydrogen) then
        scod='H  '
     else if(trajectory%specie.eq.i_Deuterium) then
        scod='D  '
     else if(trajectory%specie.eq.i_Tritium) then
        scod='T  '
     else if(trajectory%specie.eq.i_Helium3) then
        scod='He3'
     else if(trajectory%specie.eq.i_Helium4) then
        scod='He4'
     endif

     ilco = (trajectory%vPhi * ps%kccw_Jphi) .gt. 0.0

     ispecm = trajectory%specie
     if(ispecm.gt.3) ispecm = ispecm - 1  ! approx. mass in AMU

     zv2 = (trajectory%vR)**2 + (trajectory%vZ)**2 + (trajectory%vPhi)**2
     if(ilco) then
        zpco = zpco + ispecm*zv2   ! odd units
     else
        zpctr= zpctr+ ispecm*zv2   ! odd units
     endif

     write(6,'(1x,a3,1x,i2,1x,i1,1x,L1,1x,6(1x,1pe10.3))') scod, &
          trajectory%beam_number, trajectory%energy_frac, ilco, &
          trajectory%Rsta, trajectory%Phista, trajectory%Zsta, &
          trajectory%vR, trajectory%vPhi, trajectory%vZ

  enddo

  write(6,*) ' ' 
  write(6,'(a,1x,1pe10.3)') 'full energy fraction:  ',zfrac1/npts
  write(6,'(a,1x,1pe10.3)') 'half energy fraction:  ',zfrac2/npts
  write(6,'(a,1x,1pe10.3)') '(1/3) energy fraction: ',zfrac3/npts
  if(zpco+zpctr.gt.0.0) then
     write(6,*) ' ' 
     write(6,'(a,1x,1pe10.3)') 'Co-injected power fraction:  ', &
          zpco/(zpco+zpctr)
     write(6,'(a,1x,1pe10.3)') 'Ctr-injected power fraction: ', &
          zpctr/(zpco+zpctr)
  endif
  
!--------------------------------------------------------
CONTAINS

  subroutine getival(ival)

    !  get integer value

    integer, intent(out) :: ival  ! unchanged if argument value is omitted

    character*10 :: zidcod

    ival=0

    if(ilenv.eq.0) then
       ierr = ierr + 1
       write(6,*) ' ?ps_nbline_driver: missing value field: '//trim(arg)

    else if(ilenv.gt.len(zidcod)) then
       ierr = ierr + 1
       write(6,*) ' ?ps_nbline_driver: value field too long: '//trim(arg)

    else
       zidcod = ' '
       zidcod(len(zidcod)-ilenv+1:len(zidcod)) = value(1:ilenv)

       read(zidcod,'(I10)',iostat=istat) ival

       if(istat.ne.0) then
          ierr=ierr + 1
          write(6,*) ' ?ps_nbline_driver: integer value decode failed: '// &
               trim(arg)
          ival=0
       endif

    endif

  end subroutine getival

  subroutine getcval(cval)

    !  get character string value
    !    args(iarg); icolon specifies colon location

    character*(*), intent(out) :: cval

    integer :: ilen_cval

    ilen_cval=len(cval)

    if(ilenv.eq.0) then
       ierr = ierr + 1
       write(6,*) ' ?ps_nbline_driver: missing value field: '//trim(arg)

    else if(ilenv.gt.ilen_cval) then
       ierr = ierr + 1
       write(6,*) ' ?ps_nbline_driver: value field too long: '//trim(arg)
       write(6,*) '  maximum length for this value: ',ilen_cval

    else
       cval = value

    endif

  end subroutine getcval

END program ps_nbline_driver

!=====================================================================
!  externally callable interface to RNG

REAL*8 FUNCTION frandm(istream)

  use rng_container
  implicit NONE

  integer :: istream

  frandm = rngcon_frandm(istream)

END FUNCTION frandm

REAL*8 FUNCTION fgauss(istream,xcen,xwid)

  use rng_container
  implicit NONE

  integer :: istream
  real*8 :: xcen,xwid   ! center & width of Gaussian sample

  fgauss = rngcon_fgauss(istream,xcen,xwid)

END FUNCTION fgauss

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_s1_dummy
     return
  end subroutine ccps_getset_s1_dummy

subroutine psget_sgas_type(iobj, n1, data, ierr)
    !! SGAS specie types
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_sgas_type', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % SGAS_type
end subroutine psget_sgas_type


subroutine psset_sgas_type(iobj, n1, data, ierr)
    !! SGAS specie types
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_sgas_type', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % SGAS_type = data(1:n1)
end subroutine psset_sgas_type


subroutine psgetrnk_sgas_type(iobj, ndims, ierr)
    !! SGAS specie types
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_sgas_type


subroutine psgetdim_sgas_type(iobj, ndims, dims, ierr)
    !! SGAS specie types
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_sgas_type', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % SGAS_type ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % SGAS_type)
    endif
end subroutine psgetdim_sgas_type


subroutine psget_sbehalo(iobj, n1, data, ierr)
    !! cold electron sce due to, recapture of beam halo charge
    !! exchange thermal neutrals, = sum Z(i)*sb0halo_recap(i), if
    !! electrons do not go into, an impurity charge state spectrum.
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_sbehalo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % sbehalo
end subroutine psget_sbehalo


subroutine psset_sbehalo(iobj, n1, data, ierr)
    !! cold electron sce due to, recapture of beam halo charge
    !! exchange thermal neutrals, = sum Z(i)*sb0halo_recap(i), if
    !! electrons do not go into, an impurity charge state spectrum.
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_sbehalo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % sbehalo = data(1:n1)
end subroutine psset_sbehalo


subroutine psgetrnk_sbehalo(iobj, ndims, ierr)
    !! cold electron sce due to, recapture of beam halo charge
    !! exchange thermal neutrals, = sum Z(i)*sb0halo_recap(i), if
    !! electrons do not go into, an impurity charge state spectrum.
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_sbehalo


subroutine psgetdim_sbehalo(iobj, ndims, dims, ierr)
    !! cold electron sce due to, recapture of beam halo charge
    !! exchange thermal neutrals, = sum Z(i)*sb0halo_recap(i), if
    !! electrons do not go into, an impurity charge state spectrum.
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_sbehalo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % sbehalo ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % sbehalo)
    endif
end subroutine psgetdim_sbehalo


subroutine psget_s0reco_recap(iobj, n1, n2, data, ierr)
    !! recombination neutrals recapture, recapture of recombination
    !! source thermal neutrals -- ion source, psc_reco =~
    !! (3/2)*Ti*(sb0reco_recap-sb0reco)*1.602e-16
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_s0reco_recap', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % s0reco_recap
end subroutine psget_s0reco_recap


subroutine psset_s0reco_recap(iobj, n1, n2, data, ierr)
    !! recombination neutrals recapture, recapture of recombination
    !! source thermal neutrals -- ion source, psc_reco =~
    !! (3/2)*Ti*(sb0reco_recap-sb0reco)*1.602e-16
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_s0reco_recap', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % s0reco_recap = data(1:n1, 1: n2)
end subroutine psset_s0reco_recap


subroutine psgetrnk_s0reco_recap(iobj, ndims, ierr)
    !! recombination neutrals recapture, recapture of recombination
    !! source thermal neutrals -- ion source, psc_reco =~
    !! (3/2)*Ti*(sb0reco_recap-sb0reco)*1.602e-16
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_s0reco_recap


subroutine psgetdim_s0reco_recap(iobj, ndims, dims, ierr)
    !! recombination neutrals recapture, recapture of recombination
    !! source thermal neutrals -- ion source, psc_reco =~
    !! (3/2)*Ti*(sb0reco_recap-sb0reco)*1.602e-16
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_s0reco_recap', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % s0reco_recap ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % s0reco_recap)
    endif
end subroutine psgetdim_s0reco_recap

module cstate_lib_mod

  use plasma_state_mod
  implicit NONE

  public
  save

  !------------------------------------------------------------------
  ! module to contain data items shared amongst cstate_lib routines

  character*60 :: cur_components = '*' ! current components -- this specifies 
  ! the FSP component for which data is being examined, or, it has the value
  ! "*" (wildcard) to specify all components.

  integer :: ncur_components(ps_ccount) = 1 ! current components -- represented
  ! as integer.  0 means absent, 1 means present.

  ! data windows-- gather data on states and/or state comparisons
  type (ps_list_window), dimension(:), allocatable :: ww,wwnorm

  ! data windows for display
  type (ps_list_window), dimension(:), allocatable :: wdisp

  ! windows w/o variation from state to state (e.g. list of dimensions)
  type (ps_list_window) :: w1,wmerge,wgrid,wtmp

  !----------------------------------------
  ! utility variables for displays

  character*70 :: rline = &
       '----------------------------------------------------------------------'

  character*60 c2lab  ! col. 2 label
  character*60 c3lab  ! col. 3 label
  character*60 c4lab  ! col. 4 label

  character*256 :: cbuf
  
  !------------------------------------------------------------------
  ! old style sglib/trgraf plot labels

  character*75 mnlab(3)
  character*17 kylab(5)

  !------------------------------------------------------------------
  ! list of grid dimensions

  character*32, dimension(:), allocatable :: grid_dims

  !------------------------------------------------------------------
  ! list of empty (unallocated) dimensions

  character*32, dimension(:), allocatable :: empty_dims
  logical :: omit_empty = .TRUE.
  logical :: is_empty

  !------------------------------------------------------------------
  ! list dimension statistics block

  integer :: nldims   ! number of dimensions not tied to physical coordinates

  ! dimension names & integer lower limits of dimension as declared
  !   "0:nspec_th" -> list_lolim(j)=0; "nrfmin" -> list_lolim(j)=1

  character*32, dimension(:), allocatable :: list_dims  ! (dim#)
  integer, dimension(:), allocatable :: list_lolim      ! (dim#)
  !  (species lists, lists of beams, antennas, etc.)

  integer :: maxnl    ! max length of any list dimension in any single run.
  integer :: maxml    ! max length of any list dimension, with all runs merged.

  integer, dimension(:,:), allocatable :: dimsizes  ! list dim sizes
  !            (state#,dim#)

  integer, dimension(:), allocatable :: mrgsizes    ! merged list dim sizes

  !  mapping data for ordered merge of datasets from different states
  integer, dimension(:,:,:), allocatable :: mrg_addr_map
  !            (state#,merge#,dim#)

  !  name of species or list element in merged list
  character*32, dimension(:,:), allocatable :: mrg_name
  !                   (merge#,dim#)

  !  original ordering in each state's list dimensions
  integer, dimension(:,:,:), allocatable :: orig_order
  !            (index#,state#,dim#)

  integer, parameter :: nmax_rsum = 40  ! max number of sums reduced to...
  !  choose a safe upper limit

  character*10, dimension(:,:), allocatable :: sumlbl
  !                  (sum#,dim#)
  ! list dimension reduction summation label
  !    e.g. "BEAM" to sum over beam ion species

  integer, dimension(:,:), allocatable :: sumterms
  ! no. of terms in summations.  If 0 or 1, summation is suppressed.
  ! dimensioning: same as sumlbl

  integer, dimension(:,:,:), allocatable :: sumindx,sumctrl
  !               (index#,state#,dim#)
  ! index to list dimension reduction sum, if applicable
  ! index to reduction control information, if applicable

  !------------------------------------------------------------------
  ! enumeration dimension information

  integer :: nedims
  character*32, dimension(:), allocatable :: enum_dims  ! scalar name
  integer, dimension(:), allocatable :: enum_max        ! max size seen
  character*80, dimension(:), allocatable :: enum_decl  ! declaration
  integer, dimension(:), allocatable :: enum_ldim_ref   ! reference to list dim

  !------------------------------------------------------------------
  ! floating point display precision (#digits after decimal pt):

  integer :: nprec = 4   ! will be kept btw 2 and 16

  !------------------------------------------------------------------
  ! long character string display option
  ! these are only used for partial display of strings with lengths
  ! exceeding 32 characters...

  integer :: ntail = 0   ! 0: head of string; -1: tail of string;
  !  <positive value> -> start display at indicated charactor position

  !------------------------------------------------------------------
  ! suggested enumeration data length limit
  ! this is a hint for display of enumeration quantities such as (R,Z)
  ! limiter contours

  integer :: nenum = 6   ! will be kept btw 5 and 50

  !------------------------------------------------------------------
  ! rezone grid size control
  !   if =0, use the minimum size found in the state data

  integer :: nrezon_rho = 0

  !------------------------------------------------------------------
  ! list dimension reduction controls
  !   there are reductions for species lists and a few other things
  !   **maintenance note** -- as plasma state definition evolves
  !   (in particular if new species lists are added) this section
  !   will need to evolve in parallel).

  integer, parameter :: nreduce_opt = 14
  logical :: reduce_active(nreduce_opt) = (/ &
       .FALSE., .FALSE., .FALSE., .FALSE., &
       .FALSE., .FALSE., .FALSE., .FALSE., &
       .FALSE., .FALSE., .FALSE., .FALSE., &
       .FALSE., .FALSE. /)

  ! These should be all in LOWER CASE letters:
  character*12 :: reduce_dims(nreduce_opt) = (/ &
       'nspec_th    ', 'nspec_all   ', 'nspec_tha   ', 'nspec_alla  ', &
       'nspec_beam  ', 'nspec_fusion', 'nspec_rfmin ', 'nspec_gas   ', &
       'nspec_imp0  ', 'nspec_impi  ', &
       'nbeam       ', 'nicrf_src   ', 'nlhrf_src   ', 'necrf_src   ' /)

  ! Some scalar reductions are power weighted averages instead of straight
  ! sums.  List these here...
  integer, parameter :: nreduce_avg = 4

  ! All in UPPER CASE letters:
  character*10 :: avg_var(nreduce_avg) = (/ &
       'KVOLT_NBI ', 'FREQ_IC   ', 'FREQ_LH   ', 'FREQ_EC   ' /)
  character*10 :: avg_wgt(nreduce_avg) = (/ &
       'POWER_NBI ', 'POWER_IC  ', 'POWER_LH  ', 'POWER_EC  ' /)

  !---------------------------
  ! flags to track user-modified state labels

  logical :: user_label(nsss_max)

end module cstate_lib_mod

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_g1_dummy
     return
  end subroutine ccps_getset_g1_dummy

subroutine psget_geometry(iobj, data, ierr)
    !! path to file(s) vac. vessel & coil descr.
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    CHARACTER*(*), intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_geometry', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % geometry
end subroutine psget_geometry


subroutine psset_geometry(iobj, data, ierr)
    !! path to file(s) vac. vessel & coil descr.
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    CHARACTER*(*), intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_geometry', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % geometry = data
end subroutine psset_geometry


subroutine psgetsz_geometry(iobj, size, ierr)
    !! path to file(s) vac. vessel & coil descr.
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: size    ! size of character string
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psgetsz_geometry', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! note that the following will return the character length size regardless of
    ! the number of array elements (if geometry is an array)
    size = len(ss % geometry)
end subroutine psgetsz_geometry


subroutine psget_gas_code_info(iobj, data, ierr)
    !! Information: code implementing GAS component
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    CHARACTER*(*), intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_gas_code_info', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % GAS_Code_Info
end subroutine psget_gas_code_info


subroutine psset_gas_code_info(iobj, data, ierr)
    !! Information: code implementing GAS component
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    CHARACTER*(*), intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_gas_code_info', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % GAS_Code_Info = data
end subroutine psset_gas_code_info


subroutine psgetsz_gas_code_info(iobj, size, ierr)
    !! Information: code implementing GAS component
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: size    ! size of character string
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psgetsz_gas_code_info', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! note that the following will return the character length size regardless of
    ! the number of array elements (if GAS_Code_Info is an array)
    size = len(ss % GAS_Code_Info)
end subroutine psgetsz_gas_code_info


subroutine psget_gr2i(iobj, n1, data, ierr)
    !! <R^-2>
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_gr2i', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % gr2i
end subroutine psget_gr2i


subroutine psset_gr2i(iobj, n1, data, ierr)
    !! <R^-2>
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_gr2i', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % gr2i = data(1:n1)
end subroutine psset_gr2i


subroutine psgetrnk_gr2i(iobj, ndims, ierr)
    !! <R^-2>
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_gr2i


subroutine psgetdim_gr2i(iobj, ndims, dims, ierr)
    !! <R^-2>
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_gr2i', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % gr2i ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % gr2i)
    endif
end subroutine psgetdim_gr2i


subroutine psget_grirhoi(iobj, n1, data, ierr)
    !! <1/(R*|grad(rho)|)>
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_grirhoi', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % grirhoi
end subroutine psget_grirhoi


subroutine psset_grirhoi(iobj, n1, data, ierr)
    !! <1/(R*|grad(rho)|)>
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_grirhoi', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % grirhoi = data(1:n1)
end subroutine psset_grirhoi


subroutine psgetrnk_grirhoi(iobj, ndims, ierr)
    !! <1/(R*|grad(rho)|)>
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_grirhoi


subroutine psgetdim_grirhoi(iobj, ndims, dims, ierr)
    !! <1/(R*|grad(rho)|)>
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_grirhoi', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % grirhoi ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % grirhoi)
    endif
end subroutine psgetdim_grirhoi


subroutine psget_gncfh(iobj, n1, data, ierr)
    !! <H^-2*(1-SQRT(1-H)*(1+H/2))>; H=B/Bmax
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_gncfh', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % gncfh
end subroutine psget_gncfh


subroutine psset_gncfh(iobj, n1, data, ierr)
    !! <H^-2*(1-SQRT(1-H)*(1+H/2))>; H=B/Bmax
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_gncfh', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % gncfh = data(1:n1)
end subroutine psset_gncfh


subroutine psgetrnk_gncfh(iobj, ndims, ierr)
    !! <H^-2*(1-SQRT(1-H)*(1+H/2))>; H=B/Bmax
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_gncfh


subroutine psgetdim_gncfh(iobj, ndims, dims, ierr)
    !! <H^-2*(1-SQRT(1-H)*(1+H/2))>; H=B/Bmax
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_gncfh', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % gncfh ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % gncfh)
    endif
end subroutine psgetdim_gncfh

subroutine ur_cstate_component

  !  compare contents of one or more states

  use cstate_lib_mod
  implicit NONE

  !-------------------------
  ! local

  character*32 ctmp,ztest

  integer :: i,j,iwarn,ilen_names,ilen_vals,ilen_units,ilen_descr,ilen_256
  integer :: ilen_compo
  integer :: luntty,lnout
  logical :: lxout,lchar
  integer :: iremove,isum,icount,iflag,ilen,ilen_new
  !-------------------------

  luntty = lnout(0)

5 continue

  call psw_components(w1)
  call cstate_wlen(w1,ilen_names, &
       ilen_compo,ilen_vals,ilen_256,ilen_units,ilen_descr)

  write(luntty,*) ' '
  write(luntty,2001) w1%list_name(1:ilen_names),'Description'
  write(luntty,2001) rline(1:ilen_names),rline(1:min(50,ilen_descr))
  do i=1,w1%size
     write(luntty,2001) w1%list_elems(i)(1:ilen_names), &
          trim(w1%elem_descr(i))
  enddo

2001 format(a,1x,a)

  do

     isum = sum(ncur_components)

     if(lxout(0)) then
        write(luntty,*) ' '
        write(luntty,*) ' cur_components: ',trim(cur_components)
        write(luntty,*) ' '
        write(luntty,*) ' enter "A" to select ALL components.'
        write(luntty,*) ' enter "0" to UNselect all components.'
        write(luntty,*) ' enter <component_name> to add component.'
        write(luntty,*) ' enter -<component_name> to remove component.'
        write(luntty,*) ' enter "R" to review components.'
        write(luntty,*) ' enter "Q" to quit this loop.'
     endif

     call ureadw('component selection: ',ctmp)

     if(ctmp.eq.'Q') then
        if(isum.eq.0) then
           call uermsg(' ?ur_cstate_component: at least one component must be selected.',' ',0)
           cycle
        else
           exit
        endif

     else if(ctmp.eq.'R') then
        go to 5

     else if(ctmp.eq.'A') then
        cur_components = '*'
        ncur_components = 1

     else if(ctmp.eq.'0') then
        cur_components = ' '
        ncur_components = 0

     else 

        if(ctmp(1:1).eq.'-') then
           iremove = 1
           ctmp = ctmp(2:)
           call ps_cclist_remove(ctmp,ncur_components,iwarn)
        else
           iremove = 0
           call ps_cclist_add(ctmp,ncur_components,iwarn)
        endif

        if(iwarn.ne.0) then
           call uermsg('component name unrecognized',ctmp,0)
        else
           !  build ordered list of selected components
           if((iremove.eq.0).and.(cur_components.eq.'*')) cycle

           icount = 0
           iflag = 0

           do i=1,w1%size
              ztest = w1%list_elems(i)
              call uupper(ztest)
              do j=1,ps_ccount
                 if(ztest.eq.ps_cnames(j)) then
                    if(ncur_components(j).eq.1) then
                       icount = icount + 1
                       if(icount.eq.1) then
                          cur_components = ztest
                       else
                          ilen_new = 1 + len(trim(ztest))
                          if((ilen+ilen_new).gt.(len(cur_components)-5)) then
                             cur_components(ilen+1:ilen+4)=',...'
                             iflag = 1
                          else
                             cur_components(ilen+1:ilen+ilen_new) = ','//ztest
                          endif
                       endif
                       ilen = len(trim(cur_components))
                    endif
                 endif
              enddo
              if(iflag.eq.1) exit
           enddo

        endif
     endif

  enddo

end subroutine ur_cstate_component

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_c8_dummy
     return
  end subroutine ccps_getset_c8_dummy

subroutine psget_cur_data_info(iobj, data, ierr)
    !! information on source of plasma current data
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    CHARACTER*(*), intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_cur_data_info', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % CUR_Data_Info
end subroutine psget_cur_data_info


subroutine psset_cur_data_info(iobj, data, ierr)
    !! information on source of plasma current data
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    CHARACTER*(*), intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_cur_data_info', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % CUR_Data_Info = data
end subroutine psset_cur_data_info


subroutine psgetsz_cur_data_info(iobj, size, ierr)
    !! information on source of plasma current data
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: size    ! size of character string
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psgetsz_cur_data_info', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! note that the following will return the character length size regardless of
    ! the number of array elements (if CUR_Data_Info is an array)
    size = len(ss % CUR_Data_Info)
end subroutine psgetsz_cur_data_info


subroutine psget_curr_ohmic(iobj, n1, data, ierr)
    !! Ohmic current, i.e. inductive current driven by toroidal
    !! loop voltage, in the toroidal direction, Amps/zone:  sum of:,
    !! curr_ohmic + curr_bootstrap + RF driven currents +, fast ion
    !! driven currents + runaway electron current +, diamagnetic
    !! current => curt (total enclosed toroidal, current) in the EQ
    !! component.
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_curr_ohmic', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % curr_ohmic
end subroutine psget_curr_ohmic


subroutine psset_curr_ohmic(iobj, n1, data, ierr)
    !! Ohmic current, i.e. inductive current driven by toroidal
    !! loop voltage, in the toroidal direction, Amps/zone:  sum of:,
    !! curr_ohmic + curr_bootstrap + RF driven currents +, fast ion
    !! driven currents + runaway electron current +, diamagnetic
    !! current => curt (total enclosed toroidal, current) in the EQ
    !! component.
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_curr_ohmic', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % curr_ohmic = data(1:n1)
end subroutine psset_curr_ohmic


subroutine psgetrnk_curr_ohmic(iobj, ndims, ierr)
    !! Ohmic current, i.e. inductive current driven by toroidal
    !! loop voltage, in the toroidal direction, Amps/zone:  sum of:,
    !! curr_ohmic + curr_bootstrap + RF driven currents +, fast ion
    !! driven currents + runaway electron current +, diamagnetic
    !! current => curt (total enclosed toroidal, current) in the EQ
    !! component.
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_curr_ohmic


subroutine psgetdim_curr_ohmic(iobj, ndims, dims, ierr)
    !! Ohmic current, i.e. inductive current driven by toroidal
    !! loop voltage, in the toroidal direction, Amps/zone:  sum of:,
    !! curr_ohmic + curr_bootstrap + RF driven currents +, fast ion
    !! driven currents + runaway electron current +, diamagnetic
    !! current => curt (total enclosed toroidal, current) in the EQ
    !! component.
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_curr_ohmic', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % curr_ohmic ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % curr_ohmic)
    endif
end subroutine psgetdim_curr_ohmic


subroutine psget_curich(iobj, n1, data, ierr)
    !! total driven current (all IC srcs)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_curich', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % curich
end subroutine psget_curich


subroutine psset_curich(iobj, n1, data, ierr)
    !! total driven current (all IC srcs)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_curich', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % curich = data(1:n1)
end subroutine psset_curich


subroutine psgetrnk_curich(iobj, ndims, ierr)
    !! total driven current (all IC srcs)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_curich


subroutine psgetdim_curich(iobj, ndims, dims, ierr)
    !! total driven current (all IC srcs)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_curich', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % curich ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % curich)
    endif
end subroutine psgetdim_curich


subroutine psget_chiphi_glf(iobj, n1, data, ierr)
    !! momentum-equation, diffusivity from GLF23 model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_chiphi_glf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % chiphi_glf
end subroutine psget_chiphi_glf


subroutine psset_chiphi_glf(iobj, n1, data, ierr)
    !! momentum-equation, diffusivity from GLF23 model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_chiphi_glf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % chiphi_glf = data(1:n1)
end subroutine psset_chiphi_glf


subroutine psgetrnk_chiphi_glf(iobj, ndims, ierr)
    !! momentum-equation, diffusivity from GLF23 model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_chiphi_glf


subroutine psgetdim_chiphi_glf(iobj, ndims, dims, ierr)
    !! momentum-equation, diffusivity from GLF23 model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_chiphi_glf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % chiphi_glf ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % chiphi_glf)
    endif
end subroutine psgetdim_chiphi_glf


subroutine psget_chie_neo(iobj, n1, data, ierr)
    !! Te-equation, neoclassical diffusivity from NEO model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_chie_neo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % chie_neo
end subroutine psget_chie_neo


subroutine psset_chie_neo(iobj, n1, data, ierr)
    !! Te-equation, neoclassical diffusivity from NEO model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_chie_neo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % chie_neo = data(1:n1)
end subroutine psset_chie_neo


subroutine psgetrnk_chie_neo(iobj, ndims, ierr)
    !! Te-equation, neoclassical diffusivity from NEO model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_chie_neo


subroutine psgetdim_chie_neo(iobj, ndims, dims, ierr)
    !! Te-equation, neoclassical diffusivity from NEO model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_chie_neo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % chie_neo ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % chie_neo)
    endif
end subroutine psgetdim_chie_neo


subroutine psget_chie_ntm(iobj, n1, data, ierr)
    !! Te-equation, neoclassical diffusivity from NTM model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_chie_ntm', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % chie_ntm
end subroutine psget_chie_ntm


subroutine psset_chie_ntm(iobj, n1, data, ierr)
    !! Te-equation, neoclassical diffusivity from NTM model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_chie_ntm', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % chie_ntm = data(1:n1)
end subroutine psset_chie_ntm


subroutine psgetrnk_chie_ntm(iobj, ndims, ierr)
    !! Te-equation, neoclassical diffusivity from NTM model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_chie_ntm


subroutine psgetdim_chie_ntm(iobj, ndims, dims, ierr)
    !! Te-equation, neoclassical diffusivity from NTM model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_chie_ntm', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % chie_ntm ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % chie_ntm)
    endif
end subroutine psgetdim_chie_ntm

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


SUBROUTINE plasma_state_merge_3(cclist,w1,ss1,ss2,ss3,icheck,iout,ierr)


  ! Merge floating point data
  !   ss3 <-- w1*ss1 + (1-w1)*ss2

  USE plasma_state_definition_mod
  IMPLICIT NONE

  INTEGER, INTENT(IN) :: cclist(ps_ccount)
                                ! list of components to merge
                                ! use ps_cc_all to merge all components

  REAL(KIND=rspec) :: w1        ! weight on ss1
  TYPE (plasma_state) :: ss1    ! state data to copy *from* with weight (w1)
  TYPE (plasma_state) :: ss2    ! state data to copy *from* with weight (1-w1)
  TYPE (plasma_state) :: ss3    ! state to which data is copied.
  INTEGER, INTENT(IN) :: icheck ! control for checking match of non-floating-
  !  point data: ps_ignore, ps_warn, or ps_error on mismatch.

  INTEGER, INTENT(IN) :: iout
  INTEGER, INTENT(INOUT) :: ierr  ! completion code (not cleared,set on error)

  !-------------------
  INTEGER :: isize
  !-------------------

  !-----------------------------------------------
  ! copy scalars and arrays that are allocated...

  IF((ALLOCATED(ss3%grho2b2i)).AND.(cclist(ps_cnum_EQ).EQ.1)) THEN
     IF(ALLOCATED(ss1%grho2b2i).AND.ALLOCATED(ss2%grho2b2i)) THEN
        CALL ps_conformal("grho2b2i",ss2%grho2b2i,ss3%grho2b2i,iout,ierr)
        CALL ps_conformal("grho2b2i",ss1%grho2b2i,ss3%grho2b2i,iout,ierr)
        if(ierr.eq.0) ss3%grho2b2i = w1*ss1%grho2b2i + (1.0_rspec-w1)*ss2%grho2b2i
     ELSE IF(ALLOCATED(ss1%grho2b2i)) THEN
        CALL ps_conformal("grho2b2i",ss1%grho2b2i,ss3%grho2b2i,iout,ierr)
        ss3%grho2b2i = ss1%grho2b2i
     ELSE IF(ALLOCATED(ss2%grho2b2i)) THEN
        CALL ps_conformal("grho2b2i",ss2%grho2b2i,ss3%grho2b2i,iout,ierr)
        ss3%grho2b2i = ss2%grho2b2i
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%grho2r2i)).AND.(cclist(ps_cnum_EQ).EQ.1)) THEN
     IF(ALLOCATED(ss1%grho2r2i).AND.ALLOCATED(ss2%grho2r2i)) THEN
        CALL ps_conformal("grho2r2i",ss2%grho2r2i,ss3%grho2r2i,iout,ierr)
        CALL ps_conformal("grho2r2i",ss1%grho2r2i,ss3%grho2r2i,iout,ierr)
        if(ierr.eq.0) ss3%grho2r2i = w1*ss1%grho2r2i + (1.0_rspec-w1)*ss2%grho2r2i
     ELSE IF(ALLOCATED(ss1%grho2r2i)) THEN
        CALL ps_conformal("grho2r2i",ss1%grho2r2i,ss3%grho2r2i,iout,ierr)
        ss3%grho2r2i = ss1%grho2r2i
     ELSE IF(ALLOCATED(ss2%grho2r2i)) THEN
        CALL ps_conformal("grho2r2i",ss2%grho2r2i,ss3%grho2r2i,iout,ierr)
        ss3%grho2r2i = ss2%grho2r2i
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%grho2r3i)).AND.(cclist(ps_cnum_EQ).EQ.1)) THEN
     IF(ALLOCATED(ss1%grho2r3i).AND.ALLOCATED(ss2%grho2r3i)) THEN
        CALL ps_conformal("grho2r3i",ss2%grho2r3i,ss3%grho2r3i,iout,ierr)
        CALL ps_conformal("grho2r3i",ss1%grho2r3i,ss3%grho2r3i,iout,ierr)
        if(ierr.eq.0) ss3%grho2r3i = w1*ss1%grho2r3i + (1.0_rspec-w1)*ss2%grho2r3i
     ELSE IF(ALLOCATED(ss1%grho2r3i)) THEN
        CALL ps_conformal("grho2r3i",ss1%grho2r3i,ss3%grho2r3i,iout,ierr)
        ss3%grho2r3i = ss1%grho2r3i
     ELSE IF(ALLOCATED(ss2%grho2r3i)) THEN
        CALL ps_conformal("grho2r3i",ss2%grho2r3i,ss3%grho2r3i,iout,ierr)
        ss3%grho2r3i = ss2%grho2r3i
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%gri)).AND.(cclist(ps_cnum_EQ).EQ.1)) THEN
     IF(ALLOCATED(ss1%gri).AND.ALLOCATED(ss2%gri)) THEN
        CALL ps_conformal("gri",ss2%gri,ss3%gri,iout,ierr)
        CALL ps_conformal("gri",ss1%gri,ss3%gri,iout,ierr)
        if(ierr.eq.0) ss3%gri = w1*ss1%gri + (1.0_rspec-w1)*ss2%gri
     ELSE IF(ALLOCATED(ss1%gri)) THEN
        CALL ps_conformal("gri",ss1%gri,ss3%gri,iout,ierr)
        ss3%gri = ss1%gri
     ELSE IF(ALLOCATED(ss2%gri)) THEN
        CALL ps_conformal("gri",ss2%gri,ss3%gri,iout,ierr)
        ss3%gri = ss2%gri
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%grirhoi)).AND.(cclist(ps_cnum_EQ).EQ.1)) THEN
     IF(ALLOCATED(ss1%grirhoi).AND.ALLOCATED(ss2%grirhoi)) THEN
        CALL ps_conformal("grirhoi",ss2%grirhoi,ss3%grirhoi,iout,ierr)
        CALL ps_conformal("grirhoi",ss1%grirhoi,ss3%grirhoi,iout,ierr)
        if(ierr.eq.0) ss3%grirhoi = w1*ss1%grirhoi + (1.0_rspec-w1)*ss2%grirhoi
     ELSE IF(ALLOCATED(ss1%grirhoi)) THEN
        CALL ps_conformal("grirhoi",ss1%grirhoi,ss3%grirhoi,iout,ierr)
        ss3%grirhoi = ss1%grirhoi
     ELSE IF(ALLOCATED(ss2%grirhoi)) THEN
        CALL ps_conformal("grirhoi",ss2%grirhoi,ss3%grirhoi,iout,ierr)
        ss3%grirhoi = ss2%grirhoi
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%growthrate_drbm)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%growthrate_drbm).AND.ALLOCATED(ss2%growthrate_drbm)) THEN
        CALL ps_conformal("growthrate_drbm",ss2%growthrate_drbm,ss3%growthrate_drbm,iout,ierr)
        CALL ps_conformal("growthrate_drbm",ss1%growthrate_drbm,ss3%growthrate_drbm,iout,ierr)
        if(ierr.eq.0) ss3%growthrate_drbm = w1*ss1%growthrate_drbm + (1.0_rspec-w1)*ss2%growthrate_drbm
     ELSE IF(ALLOCATED(ss1%growthrate_drbm)) THEN
        CALL ps_conformal("growthrate_drbm",ss1%growthrate_drbm,ss3%growthrate_drbm,iout,ierr)
        ss3%growthrate_drbm = ss1%growthrate_drbm
     ELSE IF(ALLOCATED(ss2%growthrate_drbm)) THEN
        CALL ps_conformal("growthrate_drbm",ss2%growthrate_drbm,ss3%growthrate_drbm,iout,ierr)
        ss3%growthrate_drbm = ss2%growthrate_drbm
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%growthrate_glf)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%growthrate_glf).AND.ALLOCATED(ss2%growthrate_glf)) THEN
        CALL ps_conformal("growthrate_glf",ss2%growthrate_glf,ss3%growthrate_glf,iout,ierr)
        CALL ps_conformal("growthrate_glf",ss1%growthrate_glf,ss3%growthrate_glf,iout,ierr)
        if(ierr.eq.0) ss3%growthrate_glf = w1*ss1%growthrate_glf + (1.0_rspec-w1)*ss2%growthrate_glf
     ELSE IF(ALLOCATED(ss1%growthrate_glf)) THEN
        CALL ps_conformal("growthrate_glf",ss1%growthrate_glf,ss3%growthrate_glf,iout,ierr)
        ss3%growthrate_glf = ss1%growthrate_glf
     ELSE IF(ALLOCATED(ss2%growthrate_glf)) THEN
        CALL ps_conformal("growthrate_glf",ss2%growthrate_glf,ss3%growthrate_glf,iout,ierr)
        ss3%growthrate_glf = ss2%growthrate_glf
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%growthrate_max_tglf)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%growthrate_max_tglf).AND.ALLOCATED(ss2%growthrate_max_tglf)) THEN
        CALL ps_conformal("growthrate_max_tglf",ss2%growthrate_max_tglf,ss3%growthrate_max_tglf,iout,ierr)
        CALL ps_conformal("growthrate_max_tglf",ss1%growthrate_max_tglf,ss3%growthrate_max_tglf,iout,ierr)
        if(ierr.eq.0) ss3%growthrate_max_tglf = w1*ss1%growthrate_max_tglf + (1.0_rspec-w1)*ss2%growthrate_max_tglf
     ELSE IF(ALLOCATED(ss1%growthrate_max_tglf)) THEN
        CALL ps_conformal("growthrate_max_tglf",ss1%growthrate_max_tglf,ss3%growthrate_max_tglf,iout,ierr)
        ss3%growthrate_max_tglf = ss1%growthrate_max_tglf
     ELSE IF(ALLOCATED(ss2%growthrate_max_tglf)) THEN
        CALL ps_conformal("growthrate_max_tglf",ss2%growthrate_max_tglf,ss3%growthrate_max_tglf,iout,ierr)
        ss3%growthrate_max_tglf = ss2%growthrate_max_tglf
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%growthrate_mmm71)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%growthrate_mmm71).AND.ALLOCATED(ss2%growthrate_mmm71)) THEN
        CALL ps_conformal("growthrate_mmm71",ss2%growthrate_mmm71,ss3%growthrate_mmm71,iout,ierr)
        CALL ps_conformal("growthrate_mmm71",ss1%growthrate_mmm71,ss3%growthrate_mmm71,iout,ierr)
        if(ierr.eq.0) ss3%growthrate_mmm71 = w1*ss1%growthrate_mmm71 + (1.0_rspec-w1)*ss2%growthrate_mmm71
     ELSE IF(ALLOCATED(ss1%growthrate_mmm71)) THEN
        CALL ps_conformal("growthrate_mmm71",ss1%growthrate_mmm71,ss3%growthrate_mmm71,iout,ierr)
        ss3%growthrate_mmm71 = ss1%growthrate_mmm71
     ELSE IF(ALLOCATED(ss2%growthrate_mmm71)) THEN
        CALL ps_conformal("growthrate_mmm71",ss2%growthrate_mmm71,ss3%growthrate_mmm71,iout,ierr)
        ss3%growthrate_mmm71 = ss2%growthrate_mmm71
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%growthrate_mtm)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%growthrate_mtm).AND.ALLOCATED(ss2%growthrate_mtm)) THEN
        CALL ps_conformal("growthrate_mtm",ss2%growthrate_mtm,ss3%growthrate_mtm,iout,ierr)
        CALL ps_conformal("growthrate_mtm",ss1%growthrate_mtm,ss3%growthrate_mtm,iout,ierr)
        if(ierr.eq.0) ss3%growthrate_mtm = w1*ss1%growthrate_mtm + (1.0_rspec-w1)*ss2%growthrate_mtm
     ELSE IF(ALLOCATED(ss1%growthrate_mtm)) THEN
        CALL ps_conformal("growthrate_mtm",ss1%growthrate_mtm,ss3%growthrate_mtm,iout,ierr)
        ss3%growthrate_mtm = ss1%growthrate_mtm
     ELSE IF(ALLOCATED(ss2%growthrate_mtm)) THEN
        CALL ps_conformal("growthrate_mtm",ss2%growthrate_mtm,ss3%growthrate_mtm,iout,ierr)
        ss3%growthrate_mtm = ss2%growthrate_mtm
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%growthrate_tglf)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%growthrate_tglf).AND.ALLOCATED(ss2%growthrate_tglf)) THEN
        CALL ps_conformal("growthrate_tglf",ss2%growthrate_tglf,ss3%growthrate_tglf,iout,ierr)
        CALL ps_conformal("growthrate_tglf",ss1%growthrate_tglf,ss3%growthrate_tglf,iout,ierr)
        if(ierr.eq.0) ss3%growthrate_tglf = w1*ss1%growthrate_tglf + (1.0_rspec-w1)*ss2%growthrate_tglf
     ELSE IF(ALLOCATED(ss1%growthrate_tglf)) THEN
        CALL ps_conformal("growthrate_tglf",ss1%growthrate_tglf,ss3%growthrate_tglf,iout,ierr)
        ss3%growthrate_tglf = ss1%growthrate_tglf
     ELSE IF(ALLOCATED(ss2%growthrate_tglf)) THEN
        CALL ps_conformal("growthrate_tglf",ss2%growthrate_tglf,ss3%growthrate_tglf,iout,ierr)
        ss3%growthrate_tglf = ss2%growthrate_tglf
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%growthrate_vpar)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%growthrate_vpar).AND.ALLOCATED(ss2%growthrate_vpar)) THEN
        CALL ps_conformal("growthrate_vpar",ss2%growthrate_vpar,ss3%growthrate_vpar,iout,ierr)
        CALL ps_conformal("growthrate_vpar",ss1%growthrate_vpar,ss3%growthrate_vpar,iout,ierr)
        if(ierr.eq.0) ss3%growthrate_vpar = w1*ss1%growthrate_vpar + (1.0_rspec-w1)*ss2%growthrate_vpar
     ELSE IF(ALLOCATED(ss1%growthrate_vpar)) THEN
        CALL ps_conformal("growthrate_vpar",ss1%growthrate_vpar,ss3%growthrate_vpar,iout,ierr)
        ss3%growthrate_vpar = ss1%growthrate_vpar
     ELSE IF(ALLOCATED(ss2%growthrate_vpar)) THEN
        CALL ps_conformal("growthrate_vpar",ss2%growthrate_vpar,ss3%growthrate_vpar,iout,ierr)
        ss3%growthrate_vpar = ss2%growthrate_vpar
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%gs_name)).AND.(cclist(ps_cnum_GAS).EQ.1)) THEN
     IF(ALLOCATED(ss1%gs_name).AND.ALLOCATED(ss2%gs_name)) THEN
        CALL ps_diff("gs_name",ss1%gs_name,ss2%gs_name,icheck,iout,ierr)
        CALL ps_conformal("gs_name",ss1%gs_name,ss3%gs_name,iout,ierr)
        if(ierr.eq.0) ss3%gs_name = ss1%gs_name
     ELSE IF(ALLOCATED(ss1%gs_name)) THEN
        CALL ps_conformal("gs_name",ss1%gs_name,ss3%gs_name,iout,ierr)
        ss3%gs_name = ss1%gs_name
     ELSE IF(ALLOCATED(ss2%gs_name)) THEN
        CALL ps_conformal("gs_name",ss2%gs_name,ss3%gs_name,iout,ierr)
        ss3%gs_name = ss2%gs_name
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%g_eq)).AND.(cclist(ps_cnum_EQ).EQ.1)) THEN
     IF(ALLOCATED(ss1%g_eq).AND.ALLOCATED(ss2%g_eq)) THEN
        CALL ps_conformal("g_eq",ss2%g_eq,ss3%g_eq,iout,ierr)
        CALL ps_conformal("g_eq",ss1%g_eq,ss3%g_eq,iout,ierr)
        if(ierr.eq.0) ss3%g_eq = w1*ss1%g_eq + (1.0_rspec-w1)*ss2%g_eq
     ELSE IF(ALLOCATED(ss1%g_eq)) THEN
        CALL ps_conformal("g_eq",ss1%g_eq,ss3%g_eq,iout,ierr)
        ss3%g_eq = ss1%g_eq
     ELSE IF(ALLOCATED(ss2%g_eq)) THEN
        CALL ps_conformal("g_eq",ss2%g_eq,ss3%g_eq,iout,ierr)
        ss3%g_eq = ss2%g_eq
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%hegrilh)).AND.(cclist(ps_cnum_LH).EQ.1)) THEN
     IF(ALLOCATED(ss1%hegrilh).AND.ALLOCATED(ss2%hegrilh)) THEN
        CALL ps_diff("hegrilh",ss1%hegrilh,ss2%hegrilh,icheck,iout,ierr)
        CALL ps_conformal("hegrilh",ss1%hegrilh,ss3%hegrilh,iout,ierr)
        if(ierr.eq.0) ss3%hegrilh = ss1%hegrilh
     ELSE IF(ALLOCATED(ss1%hegrilh)) THEN
        CALL ps_conformal("hegrilh",ss1%hegrilh,ss3%hegrilh,iout,ierr)
        ss3%hegrilh = ss1%hegrilh
     ELSE IF(ALLOCATED(ss2%hegrilh)) THEN
        CALL ps_conformal("hegrilh",ss2%hegrilh,ss3%hegrilh,iout,ierr)
        ss3%hegrilh = ss2%hegrilh
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%Hsize_coil)).AND.(cclist(ps_cnum_EQ).EQ.1)) THEN
     IF(ALLOCATED(ss1%Hsize_coil).AND.ALLOCATED(ss2%Hsize_coil)) THEN
        CALL ps_diff("Hsize_coil",ss1%Hsize_coil,ss2%Hsize_coil,icheck,iout,ierr)
        CALL ps_conformal("Hsize_coil",ss1%Hsize_coil,ss3%Hsize_coil,iout,ierr)
        if(ierr.eq.0) ss3%Hsize_coil = ss1%Hsize_coil
     ELSE IF(ALLOCATED(ss1%Hsize_coil)) THEN
        CALL ps_conformal("Hsize_coil",ss1%Hsize_coil,ss3%Hsize_coil,iout,ierr)
        ss3%Hsize_coil = ss1%Hsize_coil
     ELSE IF(ALLOCATED(ss2%Hsize_coil)) THEN
        CALL ps_conformal("Hsize_coil",ss2%Hsize_coil,ss3%Hsize_coil,iout,ierr)
        ss3%Hsize_coil = ss2%Hsize_coil
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%H_einj_standard)).AND.(cclist(ps_cnum_NBI).EQ.1)) THEN
     IF(ALLOCATED(ss1%H_einj_standard).AND.ALLOCATED(ss2%H_einj_standard)) THEN
        CALL ps_diff("H_einj_standard",ss1%H_einj_standard,ss2%H_einj_standard,icheck,iout,ierr)
        CALL ps_conformal("H_einj_standard",ss1%H_einj_standard,ss3%H_einj_standard,iout,ierr)
        if(ierr.eq.0) ss3%H_einj_standard = ss1%H_einj_standard
     ELSE IF(ALLOCATED(ss1%H_einj_standard)) THEN
        CALL ps_conformal("H_einj_standard",ss1%H_einj_standard,ss3%H_einj_standard,iout,ierr)
        ss3%H_einj_standard = ss1%H_einj_standard
     ELSE IF(ALLOCATED(ss2%H_einj_standard)) THEN
        CALL ps_conformal("H_einj_standard",ss2%H_einj_standard,ss3%H_einj_standard,iout,ierr)
        ss3%H_einj_standard = ss2%H_einj_standard
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%H_ffull_standard)).AND.(cclist(ps_cnum_NBI).EQ.1)) THEN
     IF(ALLOCATED(ss1%H_ffull_standard).AND.ALLOCATED(ss2%H_ffull_standard)) THEN
        CALL ps_diff("H_ffull_standard",ss1%H_ffull_standard,ss2%H_ffull_standard,icheck,iout,ierr)
        CALL ps_conformal("H_ffull_standard",ss1%H_ffull_standard,ss3%H_ffull_standard,iout,ierr)
        if(ierr.eq.0) ss3%H_ffull_standard = ss1%H_ffull_standard
     ELSE IF(ALLOCATED(ss1%H_ffull_standard)) THEN
        CALL ps_conformal("H_ffull_standard",ss1%H_ffull_standard,ss3%H_ffull_standard,iout,ierr)
        ss3%H_ffull_standard = ss1%H_ffull_standard
     ELSE IF(ALLOCATED(ss2%H_ffull_standard)) THEN
        CALL ps_conformal("H_ffull_standard",ss2%H_ffull_standard,ss3%H_ffull_standard,iout,ierr)
        ss3%H_ffull_standard = ss2%H_ffull_standard
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%H_fhalf_standard)).AND.(cclist(ps_cnum_NBI).EQ.1)) THEN
     IF(ALLOCATED(ss1%H_fhalf_standard).AND.ALLOCATED(ss2%H_fhalf_standard)) THEN
        CALL ps_diff("H_fhalf_standard",ss1%H_fhalf_standard,ss2%H_fhalf_standard,icheck,iout,ierr)
        CALL ps_conformal("H_fhalf_standard",ss1%H_fhalf_standard,ss3%H_fhalf_standard,iout,ierr)
        if(ierr.eq.0) ss3%H_fhalf_standard = ss1%H_fhalf_standard
     ELSE IF(ALLOCATED(ss1%H_fhalf_standard)) THEN
        CALL ps_conformal("H_fhalf_standard",ss1%H_fhalf_standard,ss3%H_fhalf_standard,iout,ierr)
        ss3%H_fhalf_standard = ss1%H_fhalf_standard
     ELSE IF(ALLOCATED(ss2%H_fhalf_standard)) THEN
        CALL ps_conformal("H_fhalf_standard",ss2%H_fhalf_standard,ss3%H_fhalf_standard,iout,ierr)
        ss3%H_fhalf_standard = ss2%H_fhalf_standard
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%icircuit_coil)).AND.(cclist(ps_cnum_EQ).EQ.1)) THEN
     IF(ALLOCATED(ss1%icircuit_coil).AND.ALLOCATED(ss2%icircuit_coil)) THEN
        CALL ps_diff("icircuit_coil",ss1%icircuit_coil,ss2%icircuit_coil,icheck,iout,ierr)
        CALL ps_conformal("icircuit_coil",ss1%icircuit_coil,ss3%icircuit_coil,iout,ierr)
        if(ierr.eq.0) ss3%icircuit_coil = ss1%icircuit_coil
     ELSE IF(ALLOCATED(ss1%icircuit_coil)) THEN
        CALL ps_conformal("icircuit_coil",ss1%icircuit_coil,ss3%icircuit_coil,iout,ierr)
        ss3%icircuit_coil = ss1%icircuit_coil
     ELSE IF(ALLOCATED(ss2%icircuit_coil)) THEN
        CALL ps_conformal("icircuit_coil",ss2%icircuit_coil,ss3%icircuit_coil,iout,ierr)
        ss3%icircuit_coil = ss2%icircuit_coil
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%icrf_src_name)).AND.(cclist(ps_cnum_IC).EQ.1)) THEN
     IF(ALLOCATED(ss1%icrf_src_name).AND.ALLOCATED(ss2%icrf_src_name)) THEN
        CALL ps_diff("icrf_src_name",ss1%icrf_src_name,ss2%icrf_src_name,icheck,iout,ierr)
        CALL ps_conformal("icrf_src_name",ss1%icrf_src_name,ss3%icrf_src_name,iout,ierr)
        if(ierr.eq.0) ss3%icrf_src_name = ss1%icrf_src_name
     ELSE IF(ALLOCATED(ss1%icrf_src_name)) THEN
        CALL ps_conformal("icrf_src_name",ss1%icrf_src_name,ss3%icrf_src_name,iout,ierr)
        ss3%icrf_src_name = ss1%icrf_src_name
     ELSE IF(ALLOCATED(ss2%icrf_src_name)) THEN
        CALL ps_conformal("icrf_src_name",ss2%icrf_src_name,ss3%icrf_src_name,iout,ierr)
        ss3%icrf_src_name = ss2%icrf_src_name
     ENDIF
  ENDIF

  IF(cclist(ps_cnum_IC).EQ.1) THEN

     CALL ps_diff("IC_Code_Info",ss1%IC_Code_Info,ss2%IC_Code_Info,icheck,iout,ierr)
     ss3%IC_Code_Info = ss1%IC_Code_Info
  ENDIF

  IF(cclist(ps_cnum_IC).EQ.1) THEN

     CALL ps_diff("IC_Data_Info",ss1%IC_Data_Info,ss2%IC_Data_Info,icheck,iout,ierr)
     ss3%IC_Data_Info = ss1%IC_Data_Info
  ENDIF

  IF((ALLOCATED(ss3%Imag_ant_coef)).AND.(cclist(ps_cnum_IC).EQ.1)) THEN
     IF(ALLOCATED(ss1%Imag_ant_coef).AND.ALLOCATED(ss2%Imag_ant_coef)) THEN
        CALL ps_diff("Imag_ant_coef",ss1%Imag_ant_coef,ss2%Imag_ant_coef,icheck,iout,ierr)
        CALL ps_conformal("Imag_ant_coef",ss1%Imag_ant_coef,ss3%Imag_ant_coef,iout,ierr)
        if(ierr.eq.0) ss3%Imag_ant_coef = ss1%Imag_ant_coef
     ELSE IF(ALLOCATED(ss1%Imag_ant_coef)) THEN
        CALL ps_conformal("Imag_ant_coef",ss1%Imag_ant_coef,ss3%Imag_ant_coef,iout,ierr)
        ss3%Imag_ant_coef = ss1%Imag_ant_coef
     ELSE IF(ALLOCATED(ss2%Imag_ant_coef)) THEN
        CALL ps_conformal("Imag_ant_coef",ss2%Imag_ant_coef,ss3%Imag_ant_coef,iout,ierr)
        ss3%Imag_ant_coef = ss2%Imag_ant_coef
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%iota)).AND.(cclist(ps_cnum_PLASMA).EQ.1)) THEN
     IF(ALLOCATED(ss1%iota).AND.ALLOCATED(ss2%iota)) THEN
        CALL ps_conformal("iota",ss2%iota,ss3%iota,iout,ierr)
        CALL ps_conformal("iota",ss1%iota,ss3%iota,iout,ierr)
        if(ierr.eq.0) ss3%iota = w1*ss1%iota + (1.0_rspec-w1)*ss2%iota
     ELSE IF(ALLOCATED(ss1%iota)) THEN
        CALL ps_conformal("iota",ss1%iota,ss3%iota,iout,ierr)
        ss3%iota = ss1%iota
     ELSE IF(ALLOCATED(ss2%iota)) THEN
        CALL ps_conformal("iota",ss2%iota,ss3%iota,iout,ierr)
        ss3%iota = ss2%iota
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%isThermal)).AND.(cclist(ps_cnum_IC).EQ.1)) THEN
     IF(ALLOCATED(ss1%isThermal).AND.ALLOCATED(ss2%isThermal)) THEN
        CALL ps_diff("isThermal",ss1%isThermal,ss2%isThermal,icheck,iout,ierr)
        CALL ps_conformal("isThermal",ss1%isThermal,ss3%isThermal,iout,ierr)
        if(ierr.eq.0) ss3%isThermal = ss1%isThermal
     ELSE IF(ALLOCATED(ss1%isThermal)) THEN
        CALL ps_conformal("isThermal",ss1%isThermal,ss3%isThermal,iout,ierr)
        ss3%isThermal = ss1%isThermal
     ELSE IF(ALLOCATED(ss2%isThermal)) THEN
        CALL ps_conformal("isThermal",ss2%isThermal,ss3%isThermal,iout,ierr)
        ss3%isThermal = ss2%isThermal
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%is_recycling)).AND.(cclist(ps_cnum_GAS).EQ.1)) THEN
     IF(ALLOCATED(ss1%is_recycling).AND.ALLOCATED(ss2%is_recycling)) THEN
        CALL ps_diff("is_recycling",ss1%is_recycling,ss2%is_recycling,icheck,iout,ierr)
        CALL ps_conformal("is_recycling",ss1%is_recycling,ss3%is_recycling,iout,ierr)
        if(ierr.eq.0) ss3%is_recycling = ss1%is_recycling
     ELSE IF(ALLOCATED(ss1%is_recycling)) THEN
        CALL ps_conformal("is_recycling",ss1%is_recycling,ss3%is_recycling,iout,ierr)
        ss3%is_recycling = ss1%is_recycling
     ELSE IF(ALLOCATED(ss2%is_recycling)) THEN
        CALL ps_conformal("is_recycling",ss2%is_recycling,ss3%is_recycling,iout,ierr)
        ss3%is_recycling = ss2%is_recycling
     ENDIF
  ENDIF

  IF(cclist(ps_cnum_LH).EQ.1) THEN

     CALL ps_diff("i_npoloidal",ss1%i_npoloidal,ss2%i_npoloidal,icheck,iout,ierr)
     ss3%i_npoloidal = ss1%i_npoloidal
  ENDIF

  IF((ALLOCATED(ss3%jdotb)).AND.(cclist(ps_cnum_EQ).EQ.1)) THEN
     IF(ALLOCATED(ss1%jdotb).AND.ALLOCATED(ss2%jdotb)) THEN
        CALL ps_conformal("jdotb",ss2%jdotb,ss3%jdotb,iout,ierr)
        CALL ps_conformal("jdotb",ss1%jdotb,ss3%jdotb,iout,ierr)
        if(ierr.eq.0) ss3%jdotb = w1*ss1%jdotb + (1.0_rspec-w1)*ss2%jdotb
     ELSE IF(ALLOCATED(ss1%jdotb)) THEN
        CALL ps_conformal("jdotb",ss1%jdotb,ss3%jdotb,iout,ierr)
        ss3%jdotb = ss1%jdotb
     ELSE IF(ALLOCATED(ss2%jdotb)) THEN
        CALL ps_conformal("jdotb",ss2%jdotb,ss3%jdotb,iout,ierr)
        ss3%jdotb = ss2%jdotb
     ENDIF
  ENDIF

  IF(cclist(ps_cnum_EQ).EQ.1) THEN

     CALL ps_diff("kccw_Bphi",ss1%kccw_Bphi,ss2%kccw_Bphi,icheck,iout,ierr)
     ss3%kccw_Bphi = ss1%kccw_Bphi
  ENDIF

  IF(cclist(ps_cnum_EQ).EQ.1) THEN

     CALL ps_diff("kccw_Jphi",ss1%kccw_Jphi,ss2%kccw_Jphi,icheck,iout,ierr)
     ss3%kccw_Jphi = ss1%kccw_Jphi
  ENDIF

  IF(cclist(ps_cnum_IC).EQ.1) THEN

     CALL ps_diff("kdens_rfmin",ss1%kdens_rfmin,ss2%kdens_rfmin,icheck,iout,ierr)
     ss3%kdens_rfmin = ss1%kdens_rfmin
  ENDIF

  IF((ALLOCATED(ss3%kvolt_nbi)).AND.(cclist(ps_cnum_NBI).EQ.1)) THEN
     IF(ALLOCATED(ss1%kvolt_nbi).AND.ALLOCATED(ss2%kvolt_nbi)) THEN
        CALL ps_conformal("kvolt_nbi",ss2%kvolt_nbi,ss3%kvolt_nbi,iout,ierr)
        CALL ps_conformal("kvolt_nbi",ss1%kvolt_nbi,ss3%kvolt_nbi,iout,ierr)
        if(ierr.eq.0) ss3%kvolt_nbi = w1*ss1%kvolt_nbi + (1.0_rspec-w1)*ss2%kvolt_nbi
     ELSE IF(ALLOCATED(ss1%kvolt_nbi)) THEN
        CALL ps_conformal("kvolt_nbi",ss1%kvolt_nbi,ss3%kvolt_nbi,iout,ierr)
        ss3%kvolt_nbi = ss1%kvolt_nbi
     ELSE IF(ALLOCATED(ss2%kvolt_nbi)) THEN
        CALL ps_conformal("kvolt_nbi",ss2%kvolt_nbi,ss3%kvolt_nbi,iout,ierr)
        ss3%kvolt_nbi = ss2%kvolt_nbi
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%kyrhos_mtm)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%kyrhos_mtm).AND.ALLOCATED(ss2%kyrhos_mtm)) THEN
        CALL ps_conformal("kyrhos_mtm",ss2%kyrhos_mtm,ss3%kyrhos_mtm,iout,ierr)
        CALL ps_conformal("kyrhos_mtm",ss1%kyrhos_mtm,ss3%kyrhos_mtm,iout,ierr)
        if(ierr.eq.0) ss3%kyrhos_mtm = w1*ss1%kyrhos_mtm + (1.0_rspec-w1)*ss2%kyrhos_mtm
     ELSE IF(ALLOCATED(ss1%kyrhos_mtm)) THEN
        CALL ps_conformal("kyrhos_mtm",ss1%kyrhos_mtm,ss3%kyrhos_mtm,iout,ierr)
        ss3%kyrhos_mtm = ss1%kyrhos_mtm
     ELSE IF(ALLOCATED(ss2%kyrhos_mtm)) THEN
        CALL ps_conformal("kyrhos_mtm",ss2%kyrhos_mtm,ss3%kyrhos_mtm,iout,ierr)
        ss3%kyrhos_mtm = ss2%kyrhos_mtm
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%kyspectrum_tglf)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%kyspectrum_tglf).AND.ALLOCATED(ss2%kyspectrum_tglf)) THEN
        CALL ps_conformal("kyspectrum_tglf",ss2%kyspectrum_tglf,ss3%kyspectrum_tglf,iout,ierr)
        CALL ps_conformal("kyspectrum_tglf",ss1%kyspectrum_tglf,ss3%kyspectrum_tglf,iout,ierr)
        if(ierr.eq.0) ss3%kyspectrum_tglf = w1*ss1%kyspectrum_tglf + (1.0_rspec-w1)*ss2%kyspectrum_tglf
     ELSE IF(ALLOCATED(ss1%kyspectrum_tglf)) THEN
        CALL ps_conformal("kyspectrum_tglf",ss1%kyspectrum_tglf,ss3%kyspectrum_tglf,iout,ierr)
        ss3%kyspectrum_tglf = ss1%kyspectrum_tglf
     ELSE IF(ALLOCATED(ss2%kyspectrum_tglf)) THEN
        CALL ps_conformal("kyspectrum_tglf",ss2%kyspectrum_tglf,ss3%kyspectrum_tglf,iout,ierr)
        ss3%kyspectrum_tglf = ss2%kyspectrum_tglf
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%Lbscap)).AND.(cclist(ps_cnum_NBI).EQ.1)) THEN
     IF(ALLOCATED(ss1%Lbscap).AND.ALLOCATED(ss2%Lbscap)) THEN
        CALL ps_diff("Lbscap",ss1%Lbscap,ss2%Lbscap,icheck,iout,ierr)
        CALL ps_conformal("Lbscap",ss1%Lbscap,ss3%Lbscap,iout,ierr)
        if(ierr.eq.0) ss3%Lbscap = ss1%Lbscap
     ELSE IF(ALLOCATED(ss1%Lbscap)) THEN
        CALL ps_conformal("Lbscap",ss1%Lbscap,ss3%Lbscap,iout,ierr)
        ss3%Lbscap = ss1%Lbscap
     ELSE IF(ALLOCATED(ss2%Lbscap)) THEN
        CALL ps_conformal("Lbscap",ss2%Lbscap,ss3%Lbscap,iout,ierr)
        ss3%Lbscap = ss2%Lbscap
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%Lbscap2)).AND.(cclist(ps_cnum_NBI).EQ.1)) THEN
     IF(ALLOCATED(ss1%Lbscap2).AND.ALLOCATED(ss2%Lbscap2)) THEN
        CALL ps_diff("Lbscap2",ss1%Lbscap2,ss2%Lbscap2,icheck,iout,ierr)
        CALL ps_conformal("Lbscap2",ss1%Lbscap2,ss3%Lbscap2,iout,ierr)
        if(ierr.eq.0) ss3%Lbscap2 = ss1%Lbscap2
     ELSE IF(ALLOCATED(ss1%Lbscap2)) THEN
        CALL ps_conformal("Lbscap2",ss1%Lbscap2,ss3%Lbscap2,iout,ierr)
        ss3%Lbscap2 = ss1%Lbscap2
     ELSE IF(ALLOCATED(ss2%Lbscap2)) THEN
        CALL ps_conformal("Lbscap2",ss2%Lbscap2,ss3%Lbscap2,iout,ierr)
        ss3%Lbscap2 = ss2%Lbscap2
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%Lbsctan)).AND.(cclist(ps_cnum_NBI).EQ.1)) THEN
     IF(ALLOCATED(ss1%Lbsctan).AND.ALLOCATED(ss2%Lbsctan)) THEN
        CALL ps_diff("Lbsctan",ss1%Lbsctan,ss2%Lbsctan,icheck,iout,ierr)
        CALL ps_conformal("Lbsctan",ss1%Lbsctan,ss3%Lbsctan,iout,ierr)
        if(ierr.eq.0) ss3%Lbsctan = ss1%Lbsctan
     ELSE IF(ALLOCATED(ss1%Lbsctan)) THEN
        CALL ps_conformal("Lbsctan",ss1%Lbsctan,ss3%Lbsctan,iout,ierr)
        ss3%Lbsctan = ss1%Lbsctan
     ELSE IF(ALLOCATED(ss2%Lbsctan)) THEN
        CALL ps_conformal("Lbsctan",ss2%Lbsctan,ss3%Lbsctan,iout,ierr)
        ss3%Lbsctan = ss2%Lbsctan
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%lhrf_src_name)).AND.(cclist(ps_cnum_LH).EQ.1)) THEN
     IF(ALLOCATED(ss1%lhrf_src_name).AND.ALLOCATED(ss2%lhrf_src_name)) THEN
        CALL ps_diff("lhrf_src_name",ss1%lhrf_src_name,ss2%lhrf_src_name,icheck,iout,ierr)
        CALL ps_conformal("lhrf_src_name",ss1%lhrf_src_name,ss3%lhrf_src_name,iout,ierr)
        if(ierr.eq.0) ss3%lhrf_src_name = ss1%lhrf_src_name
     ELSE IF(ALLOCATED(ss1%lhrf_src_name)) THEN
        CALL ps_conformal("lhrf_src_name",ss1%lhrf_src_name,ss3%lhrf_src_name,iout,ierr)
        ss3%lhrf_src_name = ss1%lhrf_src_name
     ELSE IF(ALLOCATED(ss2%lhrf_src_name)) THEN
        CALL ps_conformal("lhrf_src_name",ss2%lhrf_src_name,ss3%lhrf_src_name,iout,ierr)
        ss3%lhrf_src_name = ss2%lhrf_src_name
     ENDIF
  ENDIF

  IF(cclist(ps_cnum_LH).EQ.1) THEN

     CALL ps_diff("LH_Code_Info",ss1%LH_Code_Info,ss2%LH_Code_Info,icheck,iout,ierr)
     ss3%LH_Code_Info = ss1%LH_Code_Info
  ENDIF

  IF(cclist(ps_cnum_LH).EQ.1) THEN

     CALL ps_diff("LH_Data_Info",ss1%LH_Data_Info,ss2%LH_Data_Info,icheck,iout,ierr)
     ss3%LH_Data_Info = ss1%LH_Data_Info
  ENDIF

  IF(cclist(ps_cnum_LMHD).EQ.1) THEN

     CALL ps_diff("LMHD_eq_code",ss1%LMHD_eq_code,ss2%LMHD_eq_code,icheck,iout,ierr)
     ss3%LMHD_eq_code = ss1%LMHD_eq_code
  ENDIF

  IF(cclist(ps_cnum_LMHD).EQ.1) THEN

     CALL ps_diff("LMHD_status",ss1%LMHD_status,ss2%LMHD_status,icheck,iout,ierr)
     ss3%LMHD_status = ss1%LMHD_status
  ENDIF

  IF(cclist(ps_cnum_PLASMA).EQ.1) THEN

     CALL ps_diff("lock_machine_descr",ss1%lock_machine_descr,ss2%lock_machine_descr,icheck,iout,ierr)
     ss3%lock_machine_descr = ss1%lock_machine_descr
  ENDIF

  IF(cclist(ps_cnum_PLASMA).EQ.1) THEN

     CALL ps_diff("lock_shot_config",ss1%lock_shot_config,ss2%lock_shot_config,icheck,iout,ierr)
     ss3%lock_shot_config = ss1%lock_shot_config
  ENDIF

  IF(cclist(ps_cnum_PLASMA).EQ.1) THEN

     CALL ps_diff("lock_sim_init",ss1%lock_sim_init,ss2%lock_sim_init,icheck,iout,ierr)
     ss3%lock_sim_init = ss1%lock_sim_init
  ENDIF

  IF((ALLOCATED(ss3%Lpol)).AND.(cclist(ps_cnum_EQ).EQ.1)) THEN
     IF(ALLOCATED(ss1%Lpol).AND.ALLOCATED(ss2%Lpol)) THEN
        CALL ps_conformal("Lpol",ss2%Lpol,ss3%Lpol,iout,ierr)
        CALL ps_conformal("Lpol",ss1%Lpol,ss3%Lpol,iout,ierr)
        if(ierr.eq.0) ss3%Lpol = w1*ss1%Lpol + (1.0_rspec-w1)*ss2%Lpol
     ELSE IF(ALLOCATED(ss1%Lpol)) THEN
        CALL ps_conformal("Lpol",ss1%Lpol,ss3%Lpol,iout,ierr)
        ss3%Lpol = ss1%Lpol
     ELSE IF(ALLOCATED(ss2%Lpol)) THEN
        CALL ps_conformal("Lpol",ss2%Lpol,ss3%Lpol,iout,ierr)
        ss3%Lpol = ss2%Lpol
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%Mercier_stable)).AND.(cclist(ps_cnum_LMHD).EQ.1)) THEN
     IF(ALLOCATED(ss1%Mercier_stable).AND.ALLOCATED(ss2%Mercier_stable)) THEN
        CALL ps_diff("Mercier_stable",ss1%Mercier_stable,ss2%Mercier_stable,icheck,iout,ierr)
        CALL ps_conformal("Mercier_stable",ss1%Mercier_stable,ss3%Mercier_stable,iout,ierr)
        if(ierr.eq.0) ss3%Mercier_stable = ss1%Mercier_stable
     ELSE IF(ALLOCATED(ss1%Mercier_stable)) THEN
        CALL ps_conformal("Mercier_stable",ss1%Mercier_stable,ss3%Mercier_stable,iout,ierr)
        ss3%Mercier_stable = ss1%Mercier_stable
     ELSE IF(ALLOCATED(ss2%Mercier_stable)) THEN
        CALL ps_conformal("Mercier_stable",ss2%Mercier_stable,ss3%Mercier_stable,iout,ierr)
        ss3%Mercier_stable = ss2%Mercier_stable
     ENDIF
  ENDIF

  IF(cclist(ps_cnum_LMHD).EQ.1) THEN

     CALL ps_diff("MHD_eq_status",ss1%MHD_eq_status,ss2%MHD_eq_status,icheck,iout,ierr)
     ss3%MHD_eq_status = ss1%MHD_eq_status
  ENDIF

  IF(ALLOCATED(ss3%m_ALL)) THEN
     IF(ALLOCATED(ss1%m_ALL).AND.ALLOCATED(ss2%m_ALL)) THEN
        CALL ps_diff("m_ALL",ss1%m_ALL,ss2%m_ALL,ps_error,iout,ierr)
        CALL ps_conformal("m_ALL",ss1%m_ALL,ss3%m_ALL,iout,ierr)
        if(ierr.eq.0) ss3%m_ALL = ss1%m_ALL
     ELSE IF(ALLOCATED(ss1%m_ALL)) THEN
        CALL ps_conformal("m_ALL",ss1%m_ALL,ss3%m_ALL,iout,ierr)
        ss3%m_ALL = ss1%m_ALL
     ELSE IF(ALLOCATED(ss2%m_ALL)) THEN
        CALL ps_conformal("m_ALL",ss2%m_ALL,ss3%m_ALL,iout,ierr)
        ss3%m_ALL = ss2%m_ALL
     ENDIF
  ENDIF

  IF(ALLOCATED(ss3%m_ALLA)) THEN
     IF(ALLOCATED(ss1%m_ALLA).AND.ALLOCATED(ss2%m_ALLA)) THEN
        CALL ps_diff("m_ALLA",ss1%m_ALLA,ss2%m_ALLA,ps_error,iout,ierr)
        CALL ps_conformal("m_ALLA",ss1%m_ALLA,ss3%m_ALLA,iout,ierr)
        if(ierr.eq.0) ss3%m_ALLA = ss1%m_ALLA
     ELSE IF(ALLOCATED(ss1%m_ALLA)) THEN
        CALL ps_conformal("m_ALLA",ss1%m_ALLA,ss3%m_ALLA,iout,ierr)
        ss3%m_ALLA = ss1%m_ALLA
     ELSE IF(ALLOCATED(ss2%m_ALLA)) THEN
        CALL ps_conformal("m_ALLA",ss2%m_ALLA,ss3%m_ALLA,iout,ierr)
        ss3%m_ALLA = ss2%m_ALLA
     ENDIF
  ENDIF

  IF(ALLOCATED(ss3%m_RFMIN)) THEN
     IF(ALLOCATED(ss1%m_RFMIN).AND.ALLOCATED(ss2%m_RFMIN)) THEN
        CALL ps_diff("m_RFMIN",ss1%m_RFMIN,ss2%m_RFMIN,ps_error,iout,ierr)
        CALL ps_conformal("m_RFMIN",ss1%m_RFMIN,ss3%m_RFMIN,iout,ierr)
        if(ierr.eq.0) ss3%m_RFMIN = ss1%m_RFMIN
     ELSE IF(ALLOCATED(ss1%m_RFMIN)) THEN
        CALL ps_conformal("m_RFMIN",ss1%m_RFMIN,ss3%m_RFMIN,iout,ierr)
        ss3%m_RFMIN = ss1%m_RFMIN
     ELSE IF(ALLOCATED(ss2%m_RFMIN)) THEN
        CALL ps_conformal("m_RFMIN",ss2%m_RFMIN,ss3%m_RFMIN,iout,ierr)
        ss3%m_RFMIN = ss2%m_RFMIN
     ENDIF
  ENDIF

  IF(ALLOCATED(ss3%m_S)) THEN
     IF(ALLOCATED(ss1%m_S).AND.ALLOCATED(ss2%m_S)) THEN
        CALL ps_diff("m_S",ss1%m_S,ss2%m_S,ps_error,iout,ierr)
        CALL ps_conformal("m_S",ss1%m_S,ss3%m_S,iout,ierr)
        if(ierr.eq.0) ss3%m_S = ss1%m_S
     ELSE IF(ALLOCATED(ss1%m_S)) THEN
        CALL ps_conformal("m_S",ss1%m_S,ss3%m_S,iout,ierr)
        ss3%m_S = ss1%m_S
     ELSE IF(ALLOCATED(ss2%m_S)) THEN
        CALL ps_conformal("m_S",ss2%m_S,ss3%m_S,iout,ierr)
        ss3%m_S = ss2%m_S
     ENDIF
  ENDIF

  IF(ALLOCATED(ss3%m_SA)) THEN
     IF(ALLOCATED(ss1%m_SA).AND.ALLOCATED(ss2%m_SA)) THEN
        CALL ps_diff("m_SA",ss1%m_SA,ss2%m_SA,ps_error,iout,ierr)
        CALL ps_conformal("m_SA",ss1%m_SA,ss3%m_SA,iout,ierr)
        if(ierr.eq.0) ss3%m_SA = ss1%m_SA
     ELSE IF(ALLOCATED(ss1%m_SA)) THEN
        CALL ps_conformal("m_SA",ss1%m_SA,ss3%m_SA,iout,ierr)
        ss3%m_SA = ss1%m_SA
     ELSE IF(ALLOCATED(ss2%m_SA)) THEN
        CALL ps_conformal("m_SA",ss2%m_SA,ss3%m_SA,iout,ierr)
        ss3%m_SA = ss2%m_SA
     ENDIF
  ENDIF

  IF(ALLOCATED(ss3%m_SFUS)) THEN
     IF(ALLOCATED(ss1%m_SFUS).AND.ALLOCATED(ss2%m_SFUS)) THEN
        CALL ps_diff("m_SFUS",ss1%m_SFUS,ss2%m_SFUS,ps_error,iout,ierr)
        CALL ps_conformal("m_SFUS",ss1%m_SFUS,ss3%m_SFUS,iout,ierr)
        if(ierr.eq.0) ss3%m_SFUS = ss1%m_SFUS
     ELSE IF(ALLOCATED(ss1%m_SFUS)) THEN
        CALL ps_conformal("m_SFUS",ss1%m_SFUS,ss3%m_SFUS,iout,ierr)
        ss3%m_SFUS = ss1%m_SFUS
     ELSE IF(ALLOCATED(ss2%m_SFUS)) THEN
        CALL ps_conformal("m_SFUS",ss2%m_SFUS,ss3%m_SFUS,iout,ierr)
        ss3%m_SFUS = ss2%m_SFUS
     ENDIF
  ENDIF

  IF(ALLOCATED(ss3%m_SGAS)) THEN
     IF(ALLOCATED(ss1%m_SGAS).AND.ALLOCATED(ss2%m_SGAS)) THEN
        CALL ps_diff("m_SGAS",ss1%m_SGAS,ss2%m_SGAS,ps_error,iout,ierr)
        CALL ps_conformal("m_SGAS",ss1%m_SGAS,ss3%m_SGAS,iout,ierr)
        if(ierr.eq.0) ss3%m_SGAS = ss1%m_SGAS
     ELSE IF(ALLOCATED(ss1%m_SGAS)) THEN
        CALL ps_conformal("m_SGAS",ss1%m_SGAS,ss3%m_SGAS,iout,ierr)
        ss3%m_SGAS = ss1%m_SGAS
     ELSE IF(ALLOCATED(ss2%m_SGAS)) THEN
        CALL ps_conformal("m_SGAS",ss2%m_SGAS,ss3%m_SGAS,iout,ierr)
        ss3%m_SGAS = ss2%m_SGAS
     ENDIF
  ENDIF

  IF(ALLOCATED(ss3%m_SIMP0)) THEN
     IF(ALLOCATED(ss1%m_SIMP0).AND.ALLOCATED(ss2%m_SIMP0)) THEN
        CALL ps_diff("m_SIMP0",ss1%m_SIMP0,ss2%m_SIMP0,ps_error,iout,ierr)
        CALL ps_conformal("m_SIMP0",ss1%m_SIMP0,ss3%m_SIMP0,iout,ierr)
        if(ierr.eq.0) ss3%m_SIMP0 = ss1%m_SIMP0
     ELSE IF(ALLOCATED(ss1%m_SIMP0)) THEN
        CALL ps_conformal("m_SIMP0",ss1%m_SIMP0,ss3%m_SIMP0,iout,ierr)
        ss3%m_SIMP0 = ss1%m_SIMP0
     ELSE IF(ALLOCATED(ss2%m_SIMP0)) THEN
        CALL ps_conformal("m_SIMP0",ss2%m_SIMP0,ss3%m_SIMP0,iout,ierr)
        ss3%m_SIMP0 = ss2%m_SIMP0
     ENDIF
  ENDIF

  IF(ALLOCATED(ss3%m_SIMPI)) THEN
     IF(ALLOCATED(ss1%m_SIMPI).AND.ALLOCATED(ss2%m_SIMPI)) THEN
        CALL ps_diff("m_SIMPI",ss1%m_SIMPI,ss2%m_SIMPI,ps_error,iout,ierr)
        CALL ps_conformal("m_SIMPI",ss1%m_SIMPI,ss3%m_SIMPI,iout,ierr)
        if(ierr.eq.0) ss3%m_SIMPI = ss1%m_SIMPI
     ELSE IF(ALLOCATED(ss1%m_SIMPI)) THEN
        CALL ps_conformal("m_SIMPI",ss1%m_SIMPI,ss3%m_SIMPI,iout,ierr)
        ss3%m_SIMPI = ss1%m_SIMPI
     ELSE IF(ALLOCATED(ss2%m_SIMPI)) THEN
        CALL ps_conformal("m_SIMPI",ss2%m_SIMPI,ss3%m_SIMPI,iout,ierr)
        ss3%m_SIMPI = ss2%m_SIMPI
     ENDIF
  ENDIF

  IF(ALLOCATED(ss3%m_SNBI)) THEN
     IF(ALLOCATED(ss1%m_SNBI).AND.ALLOCATED(ss2%m_SNBI)) THEN
        CALL ps_diff("m_SNBI",ss1%m_SNBI,ss2%m_SNBI,ps_error,iout,ierr)
        CALL ps_conformal("m_SNBI",ss1%m_SNBI,ss3%m_SNBI,iout,ierr)
        if(ierr.eq.0) ss3%m_SNBI = ss1%m_SNBI
     ELSE IF(ALLOCATED(ss1%m_SNBI)) THEN
        CALL ps_conformal("m_SNBI",ss1%m_SNBI,ss3%m_SNBI,iout,ierr)
        ss3%m_SNBI = ss1%m_SNBI
     ELSE IF(ALLOCATED(ss2%m_SNBI)) THEN
        CALL ps_conformal("m_SNBI",ss2%m_SNBI,ss3%m_SNBI,iout,ierr)
        ss3%m_SNBI = ss2%m_SNBI
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%n0norm)).AND.(cclist(ps_cnum_GAS).EQ.1)) THEN
     IF(ALLOCATED(ss1%n0norm).AND.ALLOCATED(ss2%n0norm)) THEN
        CALL ps_conformal("n0norm",ss2%n0norm,ss3%n0norm,iout,ierr)
        CALL ps_conformal("n0norm",ss1%n0norm,ss3%n0norm,iout,ierr)
        if(ierr.eq.0) ss3%n0norm = w1*ss1%n0norm + (1.0_rspec-w1)*ss2%n0norm
     ELSE IF(ALLOCATED(ss1%n0norm)) THEN
        CALL ps_conformal("n0norm",ss1%n0norm,ss3%n0norm,iout,ierr)
        ss3%n0norm = ss1%n0norm
     ELSE IF(ALLOCATED(ss2%n0norm)) THEN
        CALL ps_conformal("n0norm",ss2%n0norm,ss3%n0norm,iout,ierr)
        ss3%n0norm = ss2%n0norm
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%n0_halo)).AND.(cclist(ps_cnum_NBI).EQ.1)) THEN
     IF(ALLOCATED(ss1%n0_halo).AND.ALLOCATED(ss2%n0_halo)) THEN
        CALL ps_conformal("n0_halo",ss2%n0_halo,ss3%n0_halo,iout,ierr)
        CALL ps_conformal("n0_halo",ss1%n0_halo,ss3%n0_halo,iout,ierr)
        if(ierr.eq.0) ss3%n0_halo = w1*ss1%n0_halo + (1.0_rspec-w1)*ss2%n0_halo
     ELSE IF(ALLOCATED(ss1%n0_halo)) THEN
        CALL ps_conformal("n0_halo",ss1%n0_halo,ss3%n0_halo,iout,ierr)
        ss3%n0_halo = ss1%n0_halo
     ELSE IF(ALLOCATED(ss2%n0_halo)) THEN
        CALL ps_conformal("n0_halo",ss2%n0_halo,ss3%n0_halo,iout,ierr)
        ss3%n0_halo = ss2%n0_halo
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%n0_reco)).AND.(cclist(ps_cnum_GAS).EQ.1)) THEN
     IF(ALLOCATED(ss1%n0_reco).AND.ALLOCATED(ss2%n0_reco)) THEN
        CALL ps_conformal("n0_reco",ss2%n0_reco,ss3%n0_reco,iout,ierr)
        CALL ps_conformal("n0_reco",ss1%n0_reco,ss3%n0_reco,iout,ierr)
        if(ierr.eq.0) ss3%n0_reco = w1*ss1%n0_reco + (1.0_rspec-w1)*ss2%n0_reco
     ELSE IF(ALLOCATED(ss1%n0_reco)) THEN
        CALL ps_conformal("n0_reco",ss1%n0_reco,ss3%n0_reco,iout,ierr)
        ss3%n0_reco = ss1%n0_reco
     ELSE IF(ALLOCATED(ss2%n0_reco)) THEN
        CALL ps_conformal("n0_reco",ss2%n0_reco,ss3%n0_reco,iout,ierr)
        ss3%n0_reco = ss2%n0_reco
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%nbap2_shape)).AND.(cclist(ps_cnum_NBI).EQ.1)) THEN
     IF(ALLOCATED(ss1%nbap2_shape).AND.ALLOCATED(ss2%nbap2_shape)) THEN
        CALL ps_diff("nbap2_shape",ss1%nbap2_shape,ss2%nbap2_shape,icheck,iout,ierr)
        CALL ps_conformal("nbap2_shape",ss1%nbap2_shape,ss3%nbap2_shape,iout,ierr)
        if(ierr.eq.0) ss3%nbap2_shape = ss1%nbap2_shape
     ELSE IF(ALLOCATED(ss1%nbap2_shape)) THEN
        CALL ps_conformal("nbap2_shape",ss1%nbap2_shape,ss3%nbap2_shape,iout,ierr)
        ss3%nbap2_shape = ss1%nbap2_shape
     ELSE IF(ALLOCATED(ss2%nbap2_shape)) THEN
        CALL ps_conformal("nbap2_shape",ss2%nbap2_shape,ss3%nbap2_shape,iout,ierr)
        ss3%nbap2_shape = ss2%nbap2_shape
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%nbap_shape)).AND.(cclist(ps_cnum_NBI).EQ.1)) THEN
     IF(ALLOCATED(ss1%nbap_shape).AND.ALLOCATED(ss2%nbap_shape)) THEN
        CALL ps_diff("nbap_shape",ss1%nbap_shape,ss2%nbap_shape,icheck,iout,ierr)
        CALL ps_conformal("nbap_shape",ss1%nbap_shape,ss3%nbap_shape,iout,ierr)
        if(ierr.eq.0) ss3%nbap_shape = ss1%nbap_shape
     ELSE IF(ALLOCATED(ss1%nbap_shape)) THEN
        CALL ps_conformal("nbap_shape",ss1%nbap_shape,ss3%nbap_shape,iout,ierr)
        ss3%nbap_shape = ss1%nbap_shape
     ELSE IF(ALLOCATED(ss2%nbap_shape)) THEN
        CALL ps_conformal("nbap_shape",ss2%nbap_shape,ss3%nbap_shape,iout,ierr)
        ss3%nbap_shape = ss2%nbap_shape
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%nbeami)).AND.(cclist(ps_cnum_NBI).EQ.1)) THEN
     IF(ALLOCATED(ss1%nbeami).AND.ALLOCATED(ss2%nbeami)) THEN
        CALL ps_conformal("nbeami",ss2%nbeami,ss3%nbeami,iout,ierr)
        CALL ps_conformal("nbeami",ss1%nbeami,ss3%nbeami,iout,ierr)
        if(ierr.eq.0) ss3%nbeami = w1*ss1%nbeami + (1.0_rspec-w1)*ss2%nbeami
     ELSE IF(ALLOCATED(ss1%nbeami)) THEN
        CALL ps_conformal("nbeami",ss1%nbeami,ss3%nbeami,iout,ierr)
        ss3%nbeami = ss1%nbeami
     ELSE IF(ALLOCATED(ss2%nbeami)) THEN
        CALL ps_conformal("nbeami",ss2%nbeami,ss3%nbeami,iout,ierr)
        ss3%nbeami = ss2%nbeami
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%nbeami_bdy)).AND.(cclist(ps_cnum_NBI).EQ.1)) THEN
     IF(ALLOCATED(ss1%nbeami_bdy).AND.ALLOCATED(ss2%nbeami_bdy)) THEN
        CALL ps_conformal("nbeami_bdy",ss2%nbeami_bdy,ss3%nbeami_bdy,iout,ierr)
        CALL ps_conformal("nbeami_bdy",ss1%nbeami_bdy,ss3%nbeami_bdy,iout,ierr)
        if(ierr.eq.0) ss3%nbeami_bdy = w1*ss1%nbeami_bdy + (1.0_rspec-w1)*ss2%nbeami_bdy
     ELSE IF(ALLOCATED(ss1%nbeami_bdy)) THEN
        CALL ps_conformal("nbeami_bdy",ss1%nbeami_bdy,ss3%nbeami_bdy,iout,ierr)
        ss3%nbeami_bdy = ss1%nbeami_bdy
     ELSE IF(ALLOCATED(ss2%nbeami_bdy)) THEN
        CALL ps_conformal("nbeami_bdy",ss2%nbeami_bdy,ss3%nbeami_bdy,iout,ierr)
        ss3%nbeami_bdy = ss2%nbeami_bdy
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%nbion)).AND.(cclist(ps_cnum_NBI).EQ.1)) THEN
     IF(ALLOCATED(ss1%nbion).AND.ALLOCATED(ss2%nbion)) THEN
        CALL ps_diff("nbion",ss1%nbion,ss2%nbion,icheck,iout,ierr)
        CALL ps_conformal("nbion",ss1%nbion,ss3%nbion,iout,ierr)
        if(ierr.eq.0) ss3%nbion = ss1%nbion
     ELSE IF(ALLOCATED(ss1%nbion)) THEN
        CALL ps_conformal("nbion",ss1%nbion,ss3%nbion,iout,ierr)
        ss3%nbion = ss1%nbion
     ELSE IF(ALLOCATED(ss2%nbion)) THEN
        CALL ps_conformal("nbion",ss2%nbion,ss3%nbion,iout,ierr)
        ss3%nbion = ss2%nbion
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%nbion_trace)).AND.(cclist(ps_cnum_NBI).EQ.1)) THEN
     IF(ALLOCATED(ss1%nbion_trace).AND.ALLOCATED(ss2%nbion_trace)) THEN
        CALL ps_diff("nbion_trace",ss1%nbion_trace,ss2%nbion_trace,icheck,iout,ierr)
        CALL ps_conformal("nbion_trace",ss1%nbion_trace,ss3%nbion_trace,iout,ierr)
        if(ierr.eq.0) ss3%nbion_trace = ss1%nbion_trace
     ELSE IF(ALLOCATED(ss1%nbion_trace)) THEN
        CALL ps_conformal("nbion_trace",ss1%nbion_trace,ss3%nbion_trace,iout,ierr)
        ss3%nbion_trace = ss1%nbion_trace
     ELSE IF(ALLOCATED(ss2%nbion_trace)) THEN
        CALL ps_conformal("nbion_trace",ss2%nbion_trace,ss3%nbion_trace,iout,ierr)
        ss3%nbion_trace = ss2%nbion_trace
     ENDIF
  ENDIF

  IF(cclist(ps_cnum_NBI).EQ.1) THEN

     CALL ps_diff("NBI_Code_Info",ss1%NBI_Code_Info,ss2%NBI_Code_Info,icheck,iout,ierr)
     ss3%NBI_Code_Info = ss1%NBI_Code_Info
  ENDIF

END SUBROUTINE plasma_state_merge_3

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_c9_dummy
     return
  end subroutine ccps_getset_c9_dummy

subroutine psget_curr_bootstrap(iobj, n1, data, ierr)
    !! Neoclassical bootstrap current
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_curr_bootstrap', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % curr_bootstrap
end subroutine psget_curr_bootstrap


subroutine psset_curr_bootstrap(iobj, n1, data, ierr)
    !! Neoclassical bootstrap current
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_curr_bootstrap', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % curr_bootstrap = data(1:n1)
end subroutine psset_curr_bootstrap


subroutine psgetrnk_curr_bootstrap(iobj, ndims, ierr)
    !! Neoclassical bootstrap current
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_curr_bootstrap


subroutine psgetdim_curr_bootstrap(iobj, ndims, dims, ierr)
    !! Neoclassical bootstrap current
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_curr_bootstrap', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % curr_bootstrap ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % curr_bootstrap)
    endif
end subroutine psgetdim_curr_bootstrap


subroutine psget_cur_rw(iobj, n1, data, ierr)
    !! current carried by fast electrons
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_cur_rw', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % cur_rw
end subroutine psget_cur_rw


subroutine psset_cur_rw(iobj, n1, data, ierr)
    !! current carried by fast electrons
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_cur_rw', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % cur_rw = data(1:n1)
end subroutine psset_cur_rw


subroutine psgetrnk_cur_rw(iobj, ndims, ierr)
    !! current carried by fast electrons
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_cur_rw


subroutine psgetdim_cur_rw(iobj, ndims, dims, ierr)
    !! current carried by fast electrons
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_cur_rw', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % cur_rw ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % cur_rw)
    endif
end subroutine psgetdim_cur_rw


subroutine psget_chie_mmm71(iobj, n1, data, ierr)
    !! Te-equation, diffusivity term
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_chie_mmm71', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % chie_mmm71
end subroutine psget_chie_mmm71


subroutine psset_chie_mmm71(iobj, n1, data, ierr)
    !! Te-equation, diffusivity term
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_chie_mmm71', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % chie_mmm71 = data(1:n1)
end subroutine psset_chie_mmm71


subroutine psgetrnk_chie_mmm71(iobj, ndims, ierr)
    !! Te-equation, diffusivity term
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_chie_mmm71


subroutine psgetdim_chie_mmm71(iobj, ndims, dims, ierr)
    !! Te-equation, diffusivity term
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_chie_mmm71', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % chie_mmm71 ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % chie_mmm71)
    endif
end subroutine psgetdim_chie_mmm71


subroutine psget_chii_neo(iobj, n1, data, ierr)
    !! Ti-equation, neoclassical diffusivity from NEO model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_chii_neo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % chii_neo
end subroutine psget_chii_neo


subroutine psset_chii_neo(iobj, n1, data, ierr)
    !! Ti-equation, neoclassical diffusivity from NEO model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_chii_neo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % chii_neo = data(1:n1)
end subroutine psset_chii_neo


subroutine psgetrnk_chii_neo(iobj, ndims, ierr)
    !! Ti-equation, neoclassical diffusivity from NEO model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_chii_neo


subroutine psgetdim_chii_neo(iobj, ndims, dims, ierr)
    !! Ti-equation, neoclassical diffusivity from NEO model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_chii_neo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % chii_neo ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % chii_neo)
    endif
end subroutine psgetdim_chii_neo


subroutine psget_chii_ntm(iobj, n1, data, ierr)
    !! Ti-equation, neoclassical diffusivity from NTM model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_chii_ntm', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % chii_ntm
end subroutine psget_chii_ntm


subroutine psset_chii_ntm(iobj, n1, data, ierr)
    !! Ti-equation, neoclassical diffusivity from NTM model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_chii_ntm', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % chii_ntm = data(1:n1)
end subroutine psset_chii_ntm


subroutine psgetrnk_chii_ntm(iobj, ndims, ierr)
    !! Ti-equation, neoclassical diffusivity from NTM model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_chii_ntm


subroutine psgetdim_chii_ntm(iobj, ndims, dims, ierr)
    !! Ti-equation, neoclassical diffusivity from NTM model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_chii_ntm', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % chii_ntm ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % chii_ntm)
    endif
end subroutine psgetdim_chii_ntm

subroutine ur_cstate_sprof

  ! examine profile data contained in the state(s)

  ! functionality includes:
  !   -- options to display available profiles and groups of profiles
  !      with labeling and descriptive information
  !   -- options to "reduce" profile sets (e.g. combine all profiles
  !      related to "impurities" into a single profile
  !   -- select profile or profile group for plotting
  !   -- choose data to plot: several profiles from one of the states, or,
  !      a compartive plot of one profile for all states that contain the 
  !      profile
  !   -- plot the original data, or interpolation, or rezoning
  !   -- option to plot volume- or area-integral where appropriate
  !   -- option to plot results of differential operators, e.g. <grad()> or
  !      scale lengths

  use cstate_lib_mod
  implicit NONE

  !-------------------------
  ! local

  integer :: luntty,lnout
  logical :: lxout,lchar,lyes
  integer :: icontents,iimap,indx,ind2,isize
  integer, dimension(:), allocatable :: indmap
  integer :: imin,imaxx,ilen_coln(0:nsss_cur),ilen0d
  integer :: isize_tot,ii,ierr,jsize,jj,kk,ia,ifloat,ngrids,ig,is,inx
  integer :: totsize,iminx,ifc
  integer :: iterms,iii,jjj,icount,icountp,ifirst,imaxn
  integer, dimension(:,:), allocatable :: addr_table

  integer :: ndims,idims(20),ilodims(20),igrids(20),idim,igrid,indx_enum

  character*32 :: dname,dunits,funits,iunits,pname,name1,group_name
  character*70 :: disp0,xlabel,xxunits,tmplabel,tmpunits,cmt,method
  real*8 :: pnorm,psum,pwght
  logical :: avg_flag,smflag,curdens

  character*32, dimension(:,:), allocatable :: val_field
  integer, dimension(:,:), allocatable :: sum_key
  integer, dimension(:,:,:), allocatable :: sum_table
  character*32, dimension(:), allocatable :: merge_names

  character*32, dimension(:), allocatable :: ctags,xunits,gnames
  integer, dimension(:,:), allocatable :: ids,igsizes,intargs
  real*8, dimension(:,:,:), allocatable :: xgrids,xgridz
  real*8, dimension(:,:,:), allocatable :: xgridt,xgridtz
  real*8, dimension(:,:), allocatable :: xrezon,xrezonz
  real*8, dimension(:), allocatable :: vfixed
  integer :: inum_rezone

  integer :: intflag,iexit

  real*8, save :: scalemax = 1000.0d0

  real*8, parameter :: ZERO=0.0d0

  logical :: metric_flag(nsss_cur),metric_any,metric_all

  integer, save :: ntarg_factor = 5

  !-------------------------
  !  we will need grid information to look at profiles...

  call psw_contents('G',ncur_components,wgrid,ierr, state=sss(1))
  if(ierr.ne.0) return

  !-------------------------

  luntty = lnout(0)
  
  icontents = 0
  iimap = 0
  
  ! gather information on which states include "metric data" -- i.e.  
  ! include an MHD equilibrium specification

  metric_any = .FALSE.
  metric_all = .TRUE.
  do ii=1,nsss_cur
     metric_flag(ii) = (sss(ii)%id_vol.gt.0).AND. &
          (sss(ii)%id_surf.gt.0).AND.(sss(ii)%id_area.gt.0)
     metric_any = metric_any.OR.metric_flag(ii)
     metric_all = metric_all.AND.metric_flag(ii)
  enddo
     
  ! control loop

  do
     if(lxout(0)) then
        write(luntty,1001) omit_empty,trim(cur_components),nprec

1001    format('ur_cstate_sprof options:'/ &
             '  A -- option to omit empty elements from display (',L1,')'/ &
             '  C -- select & restrict view to component(s) (current selection: ',a,')'/ &
             '  T -- table of contents (show units & dimensions)'/ &
             '  U -- table of contents (show component, units & interpolation method)'/ &
             '  V -- table of contents (show descriptions)'/ &
             '  R -- set list dimension reduction (summation) options'/ &
             '  S -- select a single profile item & examine in detail'/ &
             '  P -- reset precision for display of floating point data (', &
             i2,')'/ &
             '  L -- modify state label(s)'/ &
             '  X -- "xplasma" plots of individual state'/ &
             '  Y -- additional comparitive display options'/ &
             '       (limiter plots; quasineutrality, Zeff checks...)'/ &
             '  Q -- quit this menu'/)
     endif
     call uread('ur_cstate_sprof option:')

     if(lchar('Q')) then
        exit

     else if(lchar('X')) then
        call ur_cstate_xplasma_plots

     else if(lchar('Y')) then
        call ur_cstate_misc_plots

     else if(lchar('A')) then
        ! contents display option: by default, omit empty elements...

        if(lxout(0)) write(luntty,*) &
             ' option to omit display of elements that are empty in all states.'

        call uread('omit empty elements ? (Y/N):')
        omit_empty = lyes(0)

     else if(lchar('C')) then
        ! restrict view to subset of components, or, expand view to all 
        ! components...

        icontents = 0
        iimap = 0
        call ur_cstate_component

     else if(lchar('L')) then
        ! modify state labels
        call ur_cstate_setLabel

     else if(lchar('T')) then
        ! table of contents variant
        icontents = 1
        call ur_cstate_sprof_contents(1)

     else if(lchar('U')) then
        ! table of contents variant
        icontents = 1
        call ur_cstate_sprof_contents(2)

     else if(lchar('V')) then
        ! table of contents variant
        icontents = 1
        call ur_cstate_sprof_contents(3)

     else if(lchar('R')) then
        ! profile reduction options (e.g. sum over subgroups of species or
        ! across other dimensions such as beam lines)

        call ur_cstate_rcon

     else if(lchar('P')) then
        ! floating point precision control for scalar displays

        if(lxout(0)) then
           write(luntty,*) ' Floating point format: <sign>n.mm<esign>Exx'
           write(luntty,*) ' precision controls number of digits mm after the'
           write(luntty,*) ' decimal point; values btw 2 and 16 are accepted.'
        endif

        call ureadi('ur_cstate_sdata: floating point display precision:',nprec)
        nprec=max(2,min(16,nprec))

     else if(lchar('S')) then
        ! select profile (group) to plot...

        if(icontents.eq.0) then
           icontents = 1
           call ur_cstate_sprof_contents(0)
        endif

        ! check contents...
        isize = w1%size
        if(isize.eq.0) then
           write(luntty,*) &
                ' %ur_cstate_sdatea: selected components contain no profiles.'
           call uclear
           cycle
        endif

        ! map some names to container group name...
        if(iimap.eq.0) then
           if(allocated(indmap)) deallocate(indmap)
           allocate(indmap(isize))
           call cstate_gen_indmap(indmap,isize)
           iimap=1
        endif

        ! get profile (or profile group) name...
        if(lxout(0)) then
           write(luntty,*) '(unambiguous prefix of name may be entered).'
        endif
        call ureadw('ur_cstate_sprof: enter profile name or "." to skip:', &
             dname)
        if(dname.eq.'.') cycle

        call cstate_findm(dname,luntty,indx)
        if(indx.eq.0) then
           call uclear
           cycle
        endif

        ! map name to self or to container...
        ind2 = indmap(indx)

        dname = w1%list_elems(ind2)
        dunits = w1%elem_units(ind2)
        funits = dunits

        !--------------------------------------
        ! generate scalar display...
        !   (code is very similar to display code for scalar state variables)
        !--------------------------------------

        cmt = ' '
        pname = ' '
        avg_flag=.FALSE.
        curdens =.FALSE.
        method = w1%val_field(ind2)
        if(method(1:5).eq.'STEP*') then
           pname = method(6:)
           ii = index(pname,'(')
           if(ii.gt.0) then
              pname=method(6:6+ii-2)      ! note avg_flag NOT set
              !  pname weighting not conformal with table data to be averaged
              !  but the information can be used during plotting
           else if(pname.eq.'DA') then
              pname=' '
              curdens=.TRUE.
              funits = trim(dunits)//'/m^2'
           else if(pname.eq.'DV') then
              pname=' '
              funits = trim(dunits)//'/m^3'
           else
              avg_flag=.TRUE.
              call free_wwnorm
              allocate(wwnorm(nsss_cur))  ! weighted avg possible
              cmt='   ...'//trim(pname)//' weighted volume average.'
           endif
        endif

        ! minimum, maximum display lengths
        if(dunits.eq.'character') then
           imin=6
           ifloat=0
        else if(dunits.eq.'integer') then
           imin=10
           ifloat=0
        else
           imin=nprec + 8  ! floating point...
           ifloat=1
        endif

        isize_tot = 0
        icount = 0

        ! set minimum display column widths...
        do ii=1,nsss_cur
           icountp=icount
           ilen_coln(ii)=max(imin,len(trim(sss_label(ii))))

           call psw_plist(dname,ww(ii),xlabel,xxunits,ierr, state=sss(ii))
           if(ww(ii)%size.gt.0) then
              icount = icount + 1
              if(avg_flag) then
                 call psw_plist(pname,wwnorm(ii),tmplabel,tmpunits,ierr, &
                      state=sss(ii))
              endif
           endif
           if((icount.eq.1).and.(icountp.eq.0)) then
              ifirst=ii
              group_name=ww(ii)%list_name
              if(ifloat.eq.0) then
                 disp0 = trim(ww(ii)%list_name)
              else
                 disp0 = trim(ww(ii)%list_name)//' ('//trim(xxunits)//')'
              endif
              ilen_coln(0)=len(trim(disp0))

              ! also compute intflag here
              intflag = 0
              if(xlabel(1:8).eq.'vol int:') intflag = 1
              if(xlabel(1:9).eq.'area int:') intflag = 2
              if(xlabel(1:11).eq.'simple avg:') intflag = 3
              if((intflag.eq.1).or.(intflag.eq.2)) iunits=trim(xxunits)
           endif

           if(ww(ii)%size.eq.0) then
              write(luntty,*) ' empty list for state: '//trim(sss_label(ii))
           else
              isize_tot=isize_tot + ww(ii)%size
           endif
        enddo
        if(isize_tot.eq.0) then
           write(luntty,*) ' empty list.'
           cycle
        endif

        ! form merged list...

        call cstate_ck_listdims(w1%c256val(ind2),size(idims),ndims, &
             idims,ilodims,indx_enum)
        if(indx_enum.ne.0) then
           if(pname.ne.' ') then
              write(luntty,*) ' ?ur_cstate_sprof: not implemented yet:'
              write(luntty,*) '  viewing of weighted profile with enumeration dimension:'
              write(luntty,*) '   '//enum_dims(indx_enum)
              cycle
           endif
           icount=0
           do jj=1,nreduce_opt
              if(reduce_active(jj)) icount = icount + 1
           enddo
           if(icount.gt.0) then
              write(luntty,*) &
                   ' %ur_cstate_sprof: reduction sums not implemented for'
              write(luntty,*) &
                   '  quantities with enumeration dimensions.'
           endif
        endif

        if(indx_enum.ne.0) then
           call hck(dname)
           ! enumeration-dimensioned quantity: sort on the fly
           ! first calculate a safe upper limit (imaxn) on the size
           ! of the merged set of profiles
           imaxn = enum_max(indx_enum)*nsss_cur
           do iii=1,ndims
              idim=idims(iii)
              imaxn = imaxn*maxval(dimsizes(:,idim))
           enddo

           allocate(addr_table(nsss_cur,imaxn))
           call psw_merge(ww,wmerge,ierr, addr_table=addr_table)
           jsize=wmerge%size
           totsize=jsize
           allocate(val_field(nsss_cur,jsize))

           allocate(sum_table(0:1,nsss_cur,jsize)); sum_table = 0

           do jj=1,jsize
              name1=wmerge%list_elems(jj)
              ilen_coln(0)=max(ilen_coln(0),len(trim(name1)))
              do ii=1,nsss_cur
                 if(addr_table(ii,jj).eq.0) then
                    val_field(ii,jj)=' (absent)'
                 else
                    kk=addr_table(ii,jj)
                    sum_table(0,ii,jj)=1
                    sum_table(1,ii,jj)=kk
                    call cstate_encode(dunits,0,ww(ii)%fval(kk), &
                         ' ', val_field(ii,jj), ilen_coln(ii))
                 endif
              enddo
           enddo

        else if(ndims.eq.0) then

           ! singleton profile or group of singletons (no species list
           ! or item list indexing...); contents the same for all states.

           call clone_window(ww(ifirst),wmerge)
           jsize = wmerge%size
           totsize=jsize
           allocate(val_field(nsss_cur,jsize))

           allocate(sum_table(0:1,nsss_cur,jsize)); sum_table = 0

           do jj=1,jsize
              name1=ww(ifirst)%list_elems(jj)
              call hck(name1)
              ilen_coln(0)=max(ilen_coln(0),len(trim(name1)))
              do ii=1,nsss_cur
                 if(jj.gt.ww(ii)%size) then
                    val_field(ii,jj)=' (absent)'
                 else
                    if(ww(ii)%ival(jj).eq.0) then
                       val_field(ii,jj)=' (absent)'
                    else
                       sum_table(0,ii,jj)=1
                       sum_table(1,ii,jj)=jj
                       call cstate_encode(dunits,0,ww(ii)%fval(jj),&
                            ' ', val_field(ii,jj), ilen_coln(ii))
                    endif
                 endif
              enddo
           enddo
        else
           call hck(dname)
           ! separate dimensioning for each state

           call free_window(wmerge)
           call cstate_merge_size(ndims,idims(1:ndims),ilodims(1:ndims),jsize)
           allocate(sum_table(0:jsize,nsss_cur,jsize))
           allocate(sum_key(ndims,jsize))
           allocate(merge_names(jsize))

           call cstate_merge_addr( &
                ndims,idims(1:ndims),ilodims(1:ndims),jsize,dname,dunits,0, &
                sum_table,sum_key,merge_names,totsize)

           allocate(val_field(nsss_cur,totsize))

           wmerge%size = totsize
           allocate(wmerge%list_elems(totsize))
           wmerge%list_elems(1:totsize) = merge_names(1:totsize)

           do ii=1,nsss_cur
              do kk=1,totsize
                 if(sum(sum_key(1:ndims,kk)).eq.0) then
                    ! no summation
                    jj=sum_table(1,ii,kk)
                    if(jj.eq.0) then
                       val_field(ii,kk)=' (absent)'
                    else
                       call cstate_encode(dunits, &
                            0,ww(ii)%fval(jj),' ', val_field(ii,kk), &
                            ilen_coln(ii))
                       ilen_coln(0)=max(ilen_coln(0), &
                            len(trim(wmerge%list_elems(kk))))
                    endif
                 else
                    psum=ZERO
                    pnorm=1.0d0
                    if(cmt.eq.' ') then
                       cmt='   ...summation(s) applied.'
                    endif
                    iterms=sum_table(0,ii,kk)

                    if(iterms.eq.0) then
                       val_field(ii,kk)=' (absent)'

                    else
                       do iii=1,iterms
                          jjj=sum_table(iii,ii,kk)
                          if(avg_flag) then
                             pwght=max(ZERO,wwnorm(ii)%fval(jjj))
                             pnorm=pnorm+pwght
                             psum=psum+pwght*ww(ii)%fval(jjj)
                          else
                             psum=psum+ww(ii)%fval(jjj)
                             if((intflag.eq.3).and.(iii.gt.1)) then
                                pnorm=pnorm+1.0d0  ! simple avg
                             endif
                          endif
                       enddo

                       if(pnorm.gt.ZERO) psum = psum/pnorm

                       call cstate_encode(dunits, &
                            0,psum,' ', val_field(ii,kk), ilen_coln(ii))
                       ilen_coln(0)=max(ilen_coln(0), &
                            len(trim(wmerge%list_elems(kk))))
                    endif
                 endif
              enddo
           enddo

        endif

        !  display header...

        ! display data and offer plotting options...

        call cstate_ck_grids(w1%c256val(ind2),size(igrids),ngrids,igrids)

        allocate(ctags(ngrids),xunits(ngrids),gnames(ngrids), &
             ids(ngrids,nsss_cur),igsizes(ngrids,nsss_cur))

        call cstate_grid_info(luntty,ngrids,igrids(1:ngrids), &
             gnames,ids,igsizes,ctags,xunits)

        imaxx=maxval(igsizes)

        allocate(xgrids(imaxx,ngrids,nsss_cur)); xgrids = ZERO
        allocate(xgridz(imaxx-1,ngrids,nsss_cur)); xgridz = ZERO

        iminx=imaxx
        do is=1,nsss_cur
           do ig=1,ngrids
              inx=igsizes(ig,is)
              if(inx.gt.0) then
                 call ps_get_grid_by_name(gnames(ig), ierr, &
                      state = sss(is), gdata=xgrids(1:inx,ig,is))
                 xgridz(1:inx-1,ig,is) = &
                      (xgrids(1:inx-1,ig,is)+xgrids(2:inx,ig,is))/2
                 iminx=min(iminx,inx)
              endif
           enddo
        enddo

        !  Summary data display:

        call print_summary

        !  Plotting options

        if(ngrids.le.2) then

           call f_plot
              
        else if(ngrids.eq.3) then
           write(luntty,*) 'plot 3d f(x,y,z) not implemented.'
           iexit=1

        else
           write(luntty,*) 'plot profiles of rank > 3 not implemented.'
           iexit=1
        endif

        deallocate(val_field)
        if(allocated(sum_table)) deallocate(sum_table)
        if(allocated(sum_key)) deallocate(sum_key)
        if(allocated(merge_names)) deallocate(merge_names)
        if(allocated(ctags)) deallocate(ctags,xunits,gnames,ids,igsizes)
        if(allocated(xgrids)) deallocate(xgrids,xgridz)
        if(allocated(addr_table)) deallocate(addr_table)

        call free_wwnorm

     else
        call uermsg(' ?ur_cstate_sprof: unrecognized option.',' ',0)
     endif
  enddo

  contains

    subroutine hck(name)
      character*(*), intent(in) :: name

      integer :: ihash1(nsss_cur),ihash2(nsss_cur)
      integer :: iii,iaddr

      call plasma_state_hash_addr("PROFILE",name,iaddr)

      if(iaddr.gt.0) then
         do iii=1,nsss_cur
            ihash1(iii) = sss(iii)%hash_codes(iaddr)
            ihash2(iii) = sss(iii)%hash_codes(iaddr+1)
         enddo

         call cstate_hash_compare(trim(name)//' profiles',ihash1,ihash2)
      endif
    end subroutine hck

    subroutine print_summary

      integer :: ivd2

      ivd2 = size(val_field,2)

      call cstate_table_out(disp0,xlabel,cmt, &
           ilen_coln,1,val_field,ivd2, &
           0,totsize)

    end subroutine print_summary

    subroutine f_plot
      
      !  f(x) and f(x,y) plotting...
      !  if ngrids = 1 and ctags(1)='rho':  f(rho) plotting...

      !-------------------
      character*70 :: cur_select
      character*32 :: curname,rzunits,yyunits
      logical :: iselect,loc_metric,ix_fixed,f_rho_plot
      integer :: kselect,imatch,ix,ixi,in,iopt

      integer :: imaxtarg,intarg,invar,irezone,imaxvar,inactiv

      character*32 :: fixlab,zgrid,ztest,xfix1
      character*32 :: varlab(max(totsize,nsss_cur))
      character*32 :: vlbsel(max(totsize,nsss_cur))
      character*10 :: zdigs = '0123456789'

      character*17 kylab(5)
      character*60 xfixall
      character*9 zdate

      integer :: iself(max(totsize,nsss_cur))
      integer :: jself(max(totsize,nsss_cur))
      integer :: inmax,inums(max(totsize,nsss_cur))
      integer :: inumc(max(totsize,nsss_cur))

      real*8 :: zz(max(totsize,nsss_cur))
      real*8 :: vmin1,vmax1

      logical :: inrange(nsss_cur),imrange(max(totsize,nsss_cur))
      logical :: isactiv(max(totsize,nsss_cur))

      integer :: isa(max(totsize,nsss_cur)),iva(max(totsize,nsss_cur)),iv

      real*8, dimension(:,:), allocatable :: xxplot,yyplot

      character*1 :: zgnums(8) = (/ '1', '2', '3', '4', '5', '6', '7', '8' /)
      !-------------------

      call c9date(zdate)

      cur_select = 'NONE'
      iselect = .FALSE.

      f_rho_plot = .FALSE.
      if(ngrids.eq.1) then
         ix_fixed = .TRUE.
         f_rho_plot = (ctags(1).eq.'rho') 
         inrange = .TRUE.
         imrange = .TRUE.
         igrid = 1
      else
         ix_fixed = .FALSE.
         inrange = .FALSE.
         imrange = .FALSE.
         igrid = 0
         if(allocated(vfixed)) deallocate(vfixed)
         allocate(vfixed(ngrids))
      endif

      xfixall = ' '
      kselect = 0
      imatch = 0
      curname = ' '
      isa = 0
      iva = 0
      inmax = 0

      ! x grid name & units: ctags(1); xunits
      ! data units: funits (integrated: rzunits).

      imaxvar=max(totsize,nsss_cur)
      do ii=1,imaxvar
         iself(ii)=ii
         zz(ii)=ii
      enddo

      kylab = ' '
      mnlab(2)=' '
      do
         !-------------------------------------------------------------
         ! metric flag (enable integro-differential transforms if true)
         !   for f(rho) profiles ONLY...

         if(kselect.gt.0) then
            loc_metric=f_rho_plot .AND. metric_flag(kselect)
         else
            loc_metric=f_rho_plot .AND. metric_all
         endif

         !-------------------------------------------------------------
         ! rezone options: f(rho) plots only...

         if(f_rho_plot.and.loc_metric) then
            if(pname.ne.' ') then
               irezone=3
               rzunits = funits
            else if(intflag.eq.1) then
               irezone=1
               rzunits = iunits
            else if(intflag.eq.2) then
               irezone=2
               rzunits = iunits
            endif
         else
            irezone=0
         endif

         !-------------------------------------------------------------
         ! interpolation target grids (redo: ntarg_factor may change)

         if(allocated(xgridt)) deallocate(xgridt,xgridtz,intargs)
         if(allocated(xrezon)) deallocate(xrezon,xrezonz)

         imaxtarg=(imaxx-1)*ntarg_factor + 1
         allocate(xgridt(imaxtarg,ngrids,nsss_cur)); xgridt = ZERO
         allocate(xgridtz(imaxtarg-1,ngrids,nsss_cur)); xgridtz = ZERO
         allocate(intargs(ngrids,nsss_cur))

         if(f_rho_plot.and.loc_metric) then

            !-----------------
            ! rezone & integration target grid here...
            !-----------------

            if(nrezon_rho.eq.0) then
               inum_rezone=iminx
            else
               inum_rezone=nrezon_rho
            endif
            allocate(xrezon(inum_rezone,ngrids),xrezonz(inum_rezone-1,ngrids))
            ig=1  ! assume ngrids = 1 & f(rho) for xrezon
            xrezon(1,ig)=ZERO
            do ix=2,inum_rezone
               xrezon(ix,ig)=(ix-1)*1.0d0/(inum_rezone-1)
               xrezonz(ix-1,ig)=(xrezon(ix,ig)+xrezon(ix-1,ig))/2
            enddo
         endif

         do is=1,nsss_cur
            do ig=1,ngrids
               inx=igsizes(ig,is)
               if(inx.eq.0) cycle
               ixi=1
               xgridt(1,ig,is)=xgrids(1,ig,is)
               do ix=2,inx
                  do in=1,ntarg_factor
                     ixi=ixi+1
                     xgridt(ixi,ig,is)=xgrids(ix-1,ig,is) + in* &
                          (xgrids(ix,ig,is)-xgrids(ix-1,ig,is))/ntarg_factor
                     xgridtz(ixi-1,ig,is)= &
                          0.5d0*(xgridt(ixi-1,ig,is)+xgridt(ixi,ig,is))
                  enddo
               enddo
               intargs(ig,is)=ixi
            enddo
         enddo

         if(iselect.and.ix_fixed) then

            icount = 0
            do ii=1,invar
               imrange(ii)=inrange(isa(ii))
               if(imrange(ii)) icount = icount + 1
            enddo

            if(icount.eq.0) then
               write(luntty,*) ' %CAUTION: no selected profiles in range of fixed coordinates.'
            endif
         endif

         !-------------------------------------------------------------
         ! clear plotting information
         kylab(2:5)=' '
         if(igrid.eq.0) then
            mnlab(3) = trim(curname)
         else
            if(xfixall.eq.' ') then
               mnlab(3) = trim(curname)//' vs. '//trim(ctags(igrid))
            else
               mnlab(3) = trim(curname)//' vs. '//trim(ctags(igrid))// &
                    '; '//trim(xfixall)
            endif
         endif
         inmax = 0
         if(allocated(xxplot)) deallocate(xxplot)
         if(allocated(yyplot)) deallocate(yyplot)

         !-------------------------------------------------------------
         ! interactive menu options:
         !    data-to-plot must be selected before plots are made;

         !    if #grids > 1 , "F" option for specifying plotting grid
         !         and fixed values for non-plotting grids must be selected
         !         before plots are made.

         if(lxout(0)) then
            write(luntty,*) 'Data storage descriptor: '//trim(method)
            write(luntty,*) ' '

            write(luntty,*) &
                 ' 1 -- retype summary of currently selected data items.'
            write(luntty,*) &
                 ' S -- select data to plot, currently "'// &
                 trim(cur_select)//'".'

            if(ngrids.gt.1) then
               write(luntty,*) &
                    ' F -- fix value of 1 independent coordinate; plot vs. the other(s).'
               if(.not.ix_fixed) then
                  write(luntty,*) &
                       '      (selection has NOT been made).'
               else
                  write(luntty,*) &
                       '      plot vs. '//trim(ctags(igrid))// &
                       ' with fixed values:'
                  do ig=1,ngrids
                     if(ig.ne.igrid) then
                        write(luntty,'(10x,a," = ",1pe11.4,1x,a)') &
                             trim(ctags(ig)),vfixed(ig),trim(xunits(ig))
                     endif
                  enddo
               endif
            endif

            write(luntty,*) &
                 ' Q -- quit.'

            if(iselect.and.ix_fixed) then
               if(loc_metric.and.(intflag.eq.1)) write(luntty,*) &
                    ' I -- volume integral'
               if(loc_metric.and.(intflag.eq.2)) write(luntty,*) &
                    ' I -- area integral (current profile)'
               write(luntty,*) &
                    ' P -- plot data on native grid(s).'
               write(luntty,*) &
                    ' M -- plot data interpolated (mapped) to target grid.'
               write(luntty,*) &
                    ' N -- reset interpolation or rezone grid resolutions:'
               write(luntty,*) '      interpolation target grid size: ', &
                    ntarg_factor,' * [state grid size];'
               if(loc_metric) write(luntty,*) &
                    '      rezone grid size: ',inum_rezone
               if(loc_metric) write(luntty,*) &
                    ' D -- derivative plot options (gradient, scale length).'
               write(luntty,*) &
                    ' X -- option to exclude selected curves from plot.'
            endif
         endif

         !-------------------------------------------------------------
         !  user inputs option...

         call uread('ur_cstate_sprof: f(rho) plotting option:')

         !-------------------------------------------------------------

         if(lchar('Q')) then
            iexit = 1        ! all done
            exit

         else if(lchar('1')) then
            call print_summary

         !-------------------------------------------------------------
         else if(lchar('S')) then

            !  select item(s) to plot

            if(lxout(0)) then
               write(luntty,*) ' A -- plot ALL data for a SINGLE state.'
               write(luntty,*) ' S -- plot a SINGLE data item for ALL states.'
               write(luntty,*) ' Q -- quit: do not change current selection.'
            endif
            call uread('ur_cstate_sprof: plot data selection option:')

            if(lchar('Q')) then
               continue

            else if(lchar('A')) then
               !-------------------------------------------------------------
               !  all items for a single state; it could be there are none.

               if(lxout(0)) then
                  write(luntty,*) 'choose a state number btw 1 and ', &
                       nsss_cur,':'
                  do ii=1,nsss_cur
                     write(luntty,'(4x,i2,".  ",a)') ii,trim(sss_label(ii))
                  enddo
               endif
               call ureadi('state selection number:',kselect)
               kselect=min(nsss_cur,max(1,kselect))

               fixlab = trim(sss_label(kselect))
               cur_select = 'all items in state '//trim(sss_label(kselect))
               write(luntty,*) ' selected:  '//trim(cur_select)

               isa = kselect

               invar = 0
               do jj=1,totsize
                  if(val_field(kselect,jj).ne.' (absent)') then
                     invar = invar + 1
                     iva(invar)=jj
                     varlab(invar) = wmerge%list_elems(jj)
                     write(luntty,*) '     '//trim(varlab(invar))
                     isactiv(invar) = .TRUE.
                  endif
               enddo

               if(invar.eq.0) then
                  write(luntty,*) ' '
                  write(luntty,*) ' No such items available...'
                  write(luntty,*) ' '
                  iselect = .FALSE.
                  kselect = 0
                  imatch = 0
                  cur_select = 'NONE'
                  isa = 0
                  iva = 0
               else
                  iselect = .TRUE.
                  kylab(1) = 'profile names'
                  mnlab(2) = ' '
                  write(mnlab(2),'("state label: ",a," t1(sec): ",1pe11.4)') trim(sss_label(kselect)),sss(kselect)%t1
               endif
               curname = group_name

            else if(lchar('S')) then
               !-------------------------------------------------------------
               !  a single item for all states; at least 1 exists...

               if(lxout(0)) then
                  write(luntty,*) 'enter the name of the data item to plot.'
                  write(luntty,*) '  e.g.: '//trim(wmerge%list_elems(1))
                  write(luntty,*) 'or enter the number of the item:'
                  do jj=1,totsize
                     write(luntty,'(4x,i2,".  ",a)') jj,trim(wmerge%list_elems(jj))
                  enddo
               endif

               if(curname.eq.' ') curname = wmerge%list_elems(1)
               call ureadw('data item name:',curname)

               imatch=0
               do ii=1,wmerge%size
                  if(curname.eq.wmerge%list_elems(ii)) then
                     imatch=ii
                     exit
                  endif
               enddo

               if(imatch.eq.0) then
                  do ii=1,len(trim(curname))
                     jj=index(zdigs,curname(ii:ii))
                     if(jj.lt.1) then
                        imatch=0
                        exit  ! not a positive integer
                     else
                        imatch = 10*imatch + (jj-1)
                     endif
                  enddo
               endif
               if(imatch.gt.totsize) imatch=0

               if(imatch.eq.0) then
                  call uermsg('data item name not in current list',curname,0)
               else

                  iselect = .TRUE.
                  kselect = 0
                  curname = wmerge%list_elems(imatch)
                  cur_select = trim(curname)//' in all states'
                  write(luntty,*) ' selected:  '//trim(cur_select)

                  fixlab = curname
                  kylab(1) = 'state labels'
                  mnlab(2) = ' '

                  iva = imatch
                  invar = 0
                  do ii=1,nsss_cur
                     if(val_field(ii,imatch).ne.' (absent)') then
                        invar = invar + 1
                        isa(invar) = ii
                        varlab(invar) = sss_label(ii)
                        write(luntty,*) '     '//trim(varlab(invar))
                        isactiv(invar) = .TRUE.
                     endif
                  enddo

               endif
            endif

         !-------------------------------------------------------------
         else if(lchar('F')) then

            !  select grid over which to plot; select fixed values for all
            !  other grids...

            if(ngrids.eq.1) then
               call uermsg(' %ur_cstate_sprof (f_plot): no "F" option; there is only one grid.',' ',0)
               cycle
            endif

            if(lxout(0)) then
               write(luntty,*) ' available grid coordinates (choose 1 for x axis of plot):'
               do ii=1,ngrids
                  write(luntty,'(6x,i2,2x,a)') ii,ctags(ii)
               enddo
            endif

            call ureadw('choose one of these grids by tag name or number:', &
                 zgrid)

            call uupper(zgrid)

            ig=0
            do ii=1,ngrids
               ztest=ctags(ii)
               call uupper(ztest)
               if(ztest.eq.zgrid) then
                  ig=ii
                  exit
               endif
               if(zgrid.eq.zgnums(ii)) then
                  ig=ii
                  exit
               endif
            enddo

            if(ig.eq.0) then
               call uermsg(' input does not match any available grid',zgrid,0)
               cycle
            endif

            ! OK: x axis chosen:

            igrid = ig
            ix_fixed = .TRUE.

            !-----------------------------
            ! choose fixed values for coordinates NOT plotted
            
            vfixed = ZERO
            xfixall = ' '

            inrange = .TRUE.

            do ig=1,ngrids
               if(ig.ne.igrid) then
                  do
                     icount=0
                     do is=1,nsss_cur
                        inx=igsizes(ig,is)
                        if(lxout(0).and.inrange(is)) then
                           write(luntty,'(a,1x,1pe11.4," to ",1pe11.4,1x,a)') &
                                trim(sss_label(is))//' '//trim(ctags(ig))// &
                                ' range: ',xgrids(1,ig,is),xgrids(inx,ig,is), &
                                trim(xunits(ig))
                        endif
                        if(inrange(is)) then
                           icount=icount+1
                           if(icount.eq.1) then
                              vmin1=xgrids(1,ig,is)
                              vmax1=xgrids(inx,ig,is)
                           else
                              vmin1=min(vmin1,xgrids(1,ig,is))
                              vmax1=max(vmax1,xgrids(inx,ig,is))
                           endif
                        endif
                     enddo

                     if(lxout(0)) write(luntty,*) ' '

                     call ureadr8('enter fixed '//trim(ctags(ig))//' value:', &
                          vfixed(ig))

                     if((vfixed(ig).lt.vmin1).or.(vfixed(ig).gt.vmax1)) then
                        write(luntty, &
                             '(" value ",1pe11.4," not in range ",1pe11.4," to ",1pe11.4,".")') &
                             vfixed(ig),vmin1,vmax1
                        call uclear
                        cycle
                     endif

                     xfix1=' '
                     write(xfix1,'(1x,a,"=",1pe11.4,1x,a)') trim(ctags(ig)), &
                          vfixed(ig),trim(xunits(ig))
                     xfixall = trim(xfixall)//trim(xfix1)

                     do is=1,nsss_cur
                        inx=igsizes(ig,is)
                        if((vfixed(ig).lt.xgrids(1,ig,is)).or. &
                             (vfixed(ig).gt.xgrids(inx,ig,is))) then
                           write(luntty,*) ' %fixed value exceeds coordinate range for state: '//sss_label(is)
                           inrange(is) = .FALSE.
                        endif
                     enddo

                     exit
                  enddo
               endif
            enddo

         else if(lchar('X')) then

            do
               if(lxout(0)) then
                  write(luntty,*) &
                       '  #  label                          in range?  active?'
                  do iv=1,invar
                     write(luntty,'(1x,i2,2x,a,4x,L1,10x,L1)') &
                          iv,varlab(iv),imrange(iv),isactiv(iv)
                  enddo
                  write(luntty,*) ' '
                  write(luntty,*) ' enter "Q" or "0" to exit control loop.'
               endif

               inactiv=0
               do iv=1,invar
                  if(imrange(iv).and.isactiv(iv)) inactiv=inactiv+1
               enddo

               iv=0
               call ureadi('enter item # to toggle (de)activate item:',iv)
               if(iv.eq.0) exit

               if((iv.lt.0).or.(iv.gt.invar)) then
                  call uermsi('% item # not in range',iv,0)
                  cycle
               endif

               if(imrange(iv)) then
                  if(isactiv(iv)) then
                     if(inactiv.eq.1) then
                        call uermsg('% at least one item must remain active.',&
                             ' ',0)
                        cycle
                     endif
                     inactiv=inactiv-1
                  else
                     inactiv=inactiv+1
                  endif
               endif
               isactiv(iv) = .not.isactiv(iv)
            enddo

         else if(lchar('I')) then
            !  integrated plot option...

            if(.not.loc_metric) then
               call uermsg( &
                    'Integration plot unavailable: no flux surface metric.', &
                    ' ',0)
               cycle
            else if((intflag.lt.1).or.(intflag.gt.2)) then
               call uermsg( &
                    'Integration operation not defined for this data.', &
                    ' ',0)
               cycle
            endif

            if(intflag.eq.1) kylab(5)='volume integral'
            if(intflag.eq.2) kylab(5)='area integral'

            yyunits = rzunits
            iopt = 0
            inmax = inum_rezone
            allocate(xxplot(inmax,invar),yyplot(inmax,invar))

            do iv=1,invar
               call get1('I',xxplot(1:inmax,iv),yyplot(1:inmax,iv), &
                    isa(iv),iva(iv),iopt,inums(iv))
            enddo

         else if(lchar('P')) then
            !  basic plot option...

            yyunits = funits

            allocate(xxplot(imaxx,invar),yyplot(imaxx,invar))
            iopt = 0
            do iv=1,invar
               call get1('P',xxplot(1:imaxx,iv),yyplot(1:imaxx,iv), &
                    isa(iv),iva(iv),iopt,inums(iv))
            enddo
            inmax = size(xxplot,1)

         else if(lchar('M')) then
            !  interpolated or rezoned plot...

            smflag = .FALSE.
            yyunits = funits
            if(irezone.eq.0) then
               iopt = 1
               inmax=imaxtarg
            else
               if(lxout(0)) then
                  write(luntty,*) ' mapping options:'
                  write(luntty,*) '  I: standard interpolation.'
                  if(irezone.eq.1) then
                     write(luntty,*) '  R: rezone; volume integral conserved.'
                  else if(irezone.eq.2) then
                     write(luntty,*) '  R: rezone; area integral conserved.'
                  else 
                     write(luntty,*) '  R: rezone; '//trim(pname)// &
                          ' weighted volume integral conserved.'
                  endif
                  write(luntty,*) '  S: rezone with smoothing.'
                  write(luntty,*) '  Q: quit (no plot).'
               endif

               call uread('interpolation/rezone option:')

               if(lchar('I')) then
                  iopt = 1
                  inmax=imaxtarg
               else if(lchar('R')) then
                  iopt = 2
                  inmax=inum_rezone
               else if(lchar('S')) then
                  iopt = 2
                  inmax=inum_rezone
                  smflag=.TRUE.
               else if(lchar('Q')) then
                  cycle
               else
                  call uermsg('interpolation/rezone option not recognized.', &
                       ' ',0)
                  cycle
               endif
            endif

            if(iopt.eq.1) then
               kylab(5)='interpolation'

            else if(iopt.eq.2) then
               if(irezone.eq.1) then
                  kylab(5)='volume rezone'
               else if(irezone.eq.2) then
                  kylab(5)='area rezone'
               else if(irezone.eq.3) then
                  kylab(4)='weighted rezone:'
                  kylab(5)='  '//trim(pname)
               endif
               if(smflag) kylab(3)='(smoothed)'
            endif

            allocate(xxplot(inmax,invar),yyplot(inmax,invar))
            do iv=1,invar
               call get1('P',xxplot(1:inmax,iv),yyplot(1:inmax,iv), &
                    isa(iv),iva(iv),iopt,inums(iv))
            enddo

         else if(lchar('N')) then
            !  reset interpolation target grid resolution factor

            if(lxout(0)) then
               write(luntty,*) ' Interpolation target grids for plots'
               write(luntty,*) ' are made a fixed factor N finer in resolution'
               write(luntty,*) ' than the native grids of the data.'
               write(luntty,*) ' enter a new N, between 2 and 25...:'
            endif
            call ureadi('enter new resolution factor for interpolation:', &
                 ntarg_factor)
            ntarg_factor = max(2,min(25,ntarg_factor))

            if(lxout(0)) then
               write(luntty,*) ' The rezone target grid size is controlled'
               write(luntty,*) ' separately, and is also used for volume and'
               write(luntty,*) ' area integral plots.  Enter the desired size'
               write(luntty,*) ' (between 11 and 1001), or "0" to select the'
               write(luntty,*) ' size from the state with the smallest grid.'
            endif

            call ureadi('enter new rezone grid size or "0":',nrezon_rho)
            if(nrezon_rho.le.0) then
               nrezon_rho = 0
            else
               nrezon_rho = max(11,min(1001,nrezon_rho))
            endif

         else if(lchar('D')) then
            !  derivative operator

            if(.not.loc_metric) then
               call uermsg( &
                    'Derivative plots unavailable: no flux surface metric.', &
                    ' ',0)
               cycle
            endif
            do 
               iopt = 0
               if(lxout(0)) then
                  write(luntty,*) ' derivative options:'
                  write(luntty,*) '  D -- df/drho'
                  write(luntty,*) &
                       '  G -- flux surface averaged gradient <grad(f)>.'
                  write(luntty,*) '  I -- inverse scale length min(M,|<grad(f)>/f|).'
                  write(luntty,*) '  L -- scale length min(M,|f/<grad(f)>|).'
                  write(luntty,*) '  M -- reset value of M: ',scalemax
                  write(luntty,*) '  P -- df/dPsi'
                  write(luntty,*) '  Q -- quit (no plot).'
               endif

               call uread('choose option for derivative operator:')

               if(lchar('D')) then
                  iopt=4
                  yyunits = funits
                  kylab(4)= ' '
                  kylab(5)= 'd(f)/drho'

               else if(lchar('P')) then
                  iopt=5
                  yyunits = trim(funits)//'/(Wb/rad)'
                  kylab(4)= ' '
                  kylab(5)= 'd(f)/dPsi'

               else if(lchar('G')) then
                  iopt=1
                  yyunits = trim(funits)//'/m'
                  kylab(4)='(gradient)'
                  kylab(5)='=<grad(f)>'

               else if(lchar('I')) then
                  iopt=3
                  yyunits = '1/m'
                  kylab(4)='1/(Scale Length)'
                  kylab(5)='=|<grad(f)>/f|'

               else if(lchar('L')) then
                  iopt=2
                  yyunits = 'm'
                  kylab(4)='(Scale Length)'
                  kylab(5)='=|f/<grad(f)>|'

               else if(lchar('M')) then

                  if(lxout(0)) then
                     write(luntty,*) ' M is in (m) for Scale Length;'
                     write(luntty,*) ' M is also in (1/m) for Inverse Scale Length.'
                  endif

                  call ureadr8( &
                       'enter new scale length limit M, or 0 to restore default:', &
                       scalemax)

                  if(scalemax.le.ZERO) scalemax = 1000.0d0
                  scalemax = min(1.0d10,scalemax)

               else if(lchar('Q')) then
                  exit
               else
                  call uermsg('derivative option unrecognized.',' ',0)
                  cycle
               endif

               if(iopt.eq.0) exit

               if((method(1:4).eq.'STEP').or.(method(1:5).eq.'PCLIN').or. &
                    (pname.ne.' ')) then
                  inmax=imaxx            ! finite difference on orig. grids.

               else
                  inmax=imaxtarg         ! interpolated derivative 
               endif

               allocate(xxplot(inmax,invar),yyplot(inmax,invar))
               do iv=1,invar
                  call get1('D',xxplot(1:inmax,iv),yyplot(1:inmax,iv), &
                       isa(iv),iva(iv),iopt,inums(iv))
               enddo
               exit

            enddo
            
         else
            call uermsg(' ?f_plot (ur_cstate_sprof): invalid option code.',&
                 ' ',0)
            cycle
         endif

         if(inmax.gt.0) then

            call varlab_chk(varlab,invar)  ! define ifc

            ii = 0
            do iv=1,invar
               if(isactiv(iv).and.imrange(iv)) then
                  ii=ii+1
                  if(ii.eq.1) then
                     jself(ii)=-iv
                  else
                     jself(ii)=iv
                  endif
                  inumc(ii)=inums(iv)
                  vlbsel(ii)=varlab(iv)(ifc:)
               endif
            enddo

            inactiv=ii

            if(inactiv.eq.0) then

               write(luntty,*) ' %f_plot: no data available.'
               write(luntty,*) '  This can happen if none of the selected'
               write(luntty,*) '  profiles are in range of fixed coordinate'
               write(luntty,*) '  values.'

            else

               call r8_grfmm1(xxplot,yyplot,inmax,inumc,inactiv, &
                    zz,invar,jself,inactiv, &
                    xunits,yyunits,mnlab,kylab,vlbsel)

            endif

         endif
      enddo
      deallocate(xgridt,xgridtz,intargs)

    end subroutine f_plot

    subroutine get1(ctrl,xx,yy,istate,ivar,iopt,inum)

      ! fetch data for 1d profile or profile sum

      character*1 :: ctrl  ! "P" for plot, "I" for integration plot, ...
      real*8, dimension(:) :: xx   ! x axis to use
      real*8, dimension(:) :: yy   ! fetched data

      integer, intent(in) :: istate   ! state index
      integer, intent(in) :: ivar     ! profile sum index
      integer, intent(in) :: iopt     ! ctrl sub-option

      integer, intent(out) :: inum    ! #pts in data fetched

      real*8, dimension(:), allocatable :: yyloc,wght,wsum,xfixa
      real*8, dimension(:), allocatable :: xeval,vola,surfa,yyderiv,yydsum
      real*8, dimension(:), allocatable :: psieval,psideriv
      real*8 :: ygrad,yval,ydiff,ydpsi

      integer :: is,insum,iv,id,idw,idpsi,ierr,inw,ix,i0,ict_zero
      logical :: findiff
      !---------------------------------

      xx = ZERO
      yy = ZERO
      i0 = 1

      if((ctrl.eq.'P').or.(ctrl.eq.'I')) then

         ! plot data itself or interpolation or rezone of data

         if(ctrl.eq.'I') then
            ! integration, done by rezone...
            inum = inum_rezone
            xx(1:inum) = xrezon(1:inum,igrid)
            i0 = 2

         else if(iopt.eq.2) then
            ! rezone...
            inum = inum_rezone - 1
            xx(1:inum) = xrezonz(1:inum,igrid)

         else if(method(1:4).eq.'STEP') then
            ! step function: interpolation or plot on original grid.
            if(iopt.eq.0) then
               inum = igsizes(igrid,istate) - 1
               xx(1:inum) = xgridz(1:inum,igrid,istate)
            else if(iopt.eq.1) then
               inum = intargs(igrid,istate) - 1
               xx(1:inum) = xgridtz(1:inum,igrid,istate)
            endif

         else
            ! other than step function: interpolation or plot on original grid.
            if(iopt.eq.0) then
               inum = igsizes(igrid,istate)
               xx(1:inum) = xgrids(1:inum,igrid,istate)
            else if(iopt.eq.1) then
               inum = intargs(igrid,istate)
               xx(1:inum) = xgridt(1:inum,igrid,istate)
            endif
         endif

         allocate(yyloc(inum),wght(inum),wsum(inum)); wsum = ZERO
         inw = 0

         insum = sum_table(0,istate,ivar)
         do is = 1,insum
            iv = sum_table(is,istate,ivar)
            id = ww(istate)%ival(iv)
            idw = sss(istate)%id_zonwt(id)
            if(idw.gt.0) then
               inw = inw + 1
            else
               wght = 1.0d0  ! weighting for simple sum
            endif

            if(ctrl.eq.'I') then
               ! rezone for integration
               call ps_rho_rezone(xrezon(1:inum_rezone,1), id, &
                    yyloc(2:inum_rezone), ierr, &
                    state=sss(istate), curdens=curdens, zonesmoo=smflag, &
                    nonorm=.TRUE.)

            else if(iopt.eq.2) then
               ! rezone
               call ps_rho_rezone(xrezon(1:inum_rezone,1), id, yyloc, ierr, &
                    state=sss(istate), curdens=curdens, zonesmoo=smflag)
            else
               ! interpolation
               if(ngrids.eq.1) then
                  call ps_intrp_1d(xx(1:inum), id, yyloc, ierr, &
                       state=sss(istate))
               else if(ngrids.eq.2) then
                  allocate(xfixa(inum))
                  if(igrid.eq.1) then
                     xfixa=vfixed(2)
                     call ps_intrp_2d(xx(1:inum), xfixa, id, yyloc, ierr, &
                          state=sss(istate))
                  else
                     xfixa=vfixed(1)
                     call ps_intrp_2d(xfixa, xx(1:inum), id, yyloc, ierr, &
                          state=sss(istate))
                  endif
                  deallocate(xfixa)
               endif
            endif

            if((idw.gt.0).and.(ierr.eq.0)) then
               if(ctrl.eq.'I') then
                  ! rezone for integration
                  call ps_rho_rezone(xrezon(1:inum_rezone,1), idw, &
                       wght(2:inum_rezone), ierr, &
                       state=sss(istate), curdens=curdens, zonesmoo=smflag, &
                       nonorm=.TRUE.)

               else if(iopt.eq.2) then
                  ! rezone
                  call ps_rho_rezone(xrezon(1:inum_rezone,1), &
                       idw, wght(1:inum), ierr, &
                       state=sss(istate), curdens=curdens, zonesmoo=smflag)
               else
                  ! interpolation
                  if(ngrids.eq.1) then
                     call ps_intrp_1d(xx(1:inum), idw, wght(1:inum), ierr, &
                          state=sss(istate))
                  else if(ngrids.eq.2) then
                     allocate(xfixa(inum))
                     if(igrid.eq.1) then
                        xfixa=vfixed(2)
                        call ps_intrp_2d(xx(1:inum), xfixa, idw, &
                             wght(1:inum), ierr, &
                             state=sss(istate))
                     else
                        xfixa=vfixed(1)
                        call ps_intrp_2d(xfixa, xx(1:inum), idw, &
                             wght(1:inum), ierr, &
                             state=sss(istate))
                     endif
                     deallocate(xfixa)
                  endif
               endif
            endif

            if(ierr.ne.0) then
               write(luntty,*) ' ?? ur_cstate_sprof: interpolation error.'
               yy = ZERO
               exit
            endif

            yy(i0:inum) = yy(i0:inum) + yyloc(i0:inum)*wght(i0:inum)
            wsum(i0:inum) = wsum(i0:inum) + wght(i0:inum)
         enddo

         !  renormalize weighted average if necessary

         if(inw.gt.0) then
            if(inw.ne.insum) then
               write(luntty,*) ' ?? ur_cstate_sprof: missing weights.'
               yy = ZERO
            else
               do ix=i0,inum
                  if(wsum(ix).gt.ZERO) then
                     yy(ix)=yy(ix)/wsum(ix)
                  else
                     yy(ix)=ZERO
                  endif
               enddo
            endif
         endif

         if(ctrl.eq.'I') then
            ! do the integration...
            yy(1)=ZERO
            do ix=i0,inum
               yy(ix)=yy(ix-1)+yy(ix)
            enddo
         endif

      else if(ctrl.eq.'D') then

         ! evaluate gradient or scale length;
         ! it is assumed that metric data is available; else this routine
         ! would not be called with this option.

         findiff = size(xx).le.imaxx

         if(findiff) then
            ! finite difference formula applies; evaluate function on orig.
            ! grid, possibly with weighting

            if(method(1:4).eq.'STEP') then
               inum=igsizes(igrid,istate)-2
               xx(1:inum)=xgrids(2:inum+1,igrid,istate)

               allocate(psieval(inum+1),xeval(inum+1),vola(inum+1),surfa(inum))
               xeval=xgridz(1:inum+1,igrid,istate)

            else
               inum=igsizes(igrid,istate)-1
               xx(1:inum)=xgridz(1:inum,igrid,istate)

               allocate(psieval(inum+1),xeval(inum+1),vola(inum+1),surfa(inum))
               xeval=xgrids(1:inum+1,igrid,istate)
            endif

            id = sss(istate)%id_vol
            call ps_intrp_1d(xeval,id,vola,ierr, state=sss(istate))
            if(ierr.ne.0) then
               write(luntty,*) &
                    ' ?ur_cstate_sprof (get1): error fetching metric: Vol(x)'
               return
            endif

            id = sss(istate)%id_surf
            call ps_intrp_1d(xx(1:inum),id,surfa,ierr, state=sss(istate))
            if(ierr.ne.0) then
               write(luntty,*) &
                    ' ?ur_cstate_sprof (get1): error fetching metric: Surf(x)'
               return
            endif

            idpsi = sss(istate)%id_psipol
            if(idpsi.gt.0) then
               call ps_intrp_1d(xeval,id,psieval,ierr, state=sss(istate))
               if(ierr.ne.0) then
                  write(luntty,*) &
                       ' ?ur_cstate_sprof (get1): error fetching Psipol(x)'
                  return
               endif
            else
               write(luntty,*) &
                    ' %ur_cstate_sprof (get1): no poloidal flux function'
               psieval = ZERO
            endif

            allocate(yyloc(inum+1),wght(inum+1),wsum(inum+1)); wsum = ZERO
            allocate(yydsum(inum+1)); yydsum = ZERO
            inw = 0

            insum = sum_table(0,istate,ivar)
            do is = 1,insum
               iv = sum_table(is,istate,ivar)
               id = ww(istate)%ival(iv)
               idw = sss(istate)%id_zonwt(id)
               if(idw.gt.0) then
                  inw = inw + 1
               else
                  wght = 1.0d0  ! weighting for simple sum
               endif

               call ps_intrp_1d(xeval, id, yyloc, ierr, &
                    state=sss(istate))

               if((idw.gt.0).and.(ierr.eq.0)) then

                  call ps_intrp_1d(xeval, idw, wght, ierr, &
                       state=sss(istate))

               endif
               if(ierr.ne.0) then
                  write(luntty,*) ' ?? ur_cstate_sprof: interpolation error during finite diff setup.'
                  yy = ZERO
                  exit
               endif
               
               yydsum = yydsum + yyloc*wght
               wsum = wsum + wght
            enddo

            !  renormalize weighted average if necessary

            if(inw.gt.0) then
               if(inw.ne.insum) then
                  write(luntty,*) ' ?? ur_cstate_sprof("D"): missing weights.'
                  yydsum = ZERO
               else
                  do ix=1,inum+1
                     if(wsum(ix).gt.ZERO) then
                        yydsum(ix)=yydsum(ix)/wsum(ix)
                     else
                        yydsum(ix)=ZERO
                     endif
                  enddo
               endif
            endif

            !  finite difference evaluate of gradient or scale length...

            do ix=1,inum

               yval = (yydsum(ix)+yydsum(ix+1))/2
               ygrad = (yydsum(ix+1)-yydsum(ix))*surfa(ix)/ &
                    (vola(ix+1)-vola(ix))
               ydiff = (yydsum(ix+1)-yydsum(ix))/(xeval(ix+1)-xeval(ix))
               if(idpsi.gt.0) then
                  ydpsi = (yydsum(ix+1)-yydsum(ix))/(psieval(ix+1)-psieval(ix))
               else
                  ydpsi = 0.0d0
               endif

               if(iopt.eq.1) then
                  ! return gradient
                  yy(ix)=ygrad

               else if(iopt.eq.2) then
                  ! return scale length
                  if(max(abs(yval),abs(ygrad)).eq.ZERO) then
                     yy(ix)=ZERO
                  else if(abs(yval).gt.scalemax*abs(ygrad)) then
                     yy(ix)=scalemax
                  else
                     yy(ix)=abs(yval)/abs(ygrad)
                  endif

               else if(iopt.eq.3) then
                  ! return inverse scale length
                  if(max(abs(yval),abs(ygrad)).eq.ZERO) then
                     yy(ix)=ZERO
                  else if(abs(ygrad).gt.scalemax*abs(yval)) then
                     yy(ix)=scalemax
                  else
                     yy(ix)=abs(ygrad)/abs(yval)
                  endif

               else if(iopt.eq.4) then
                  yy(ix)=ydiff

               else if(iopt.eq.5) then
                  yy(ix)=ydpsi

               endif

            enddo

         else
            ! derivative of unweighted Spline or Hermite, evaluated by
            ! interpolation

            inum=intargs(igrid,istate)-1
            xx(1:inum)=xgridtz(1:inum,igrid,istate)

            allocate(xeval(inum),vola(inum),surfa(inum))
            xeval = xx(1:inum)

            id = sss(istate)%id_vol
            call ps_intrp_1d(xeval,id,vola,ierr, state=sss(istate), &
                 ideriv=1)   ! dVol/dx
            if(ierr.ne.0) then
               write(luntty,*) &
                    " ?ur_cstate_sprof (get1): error fetching metric: Vol'(x)"
               return
            endif

            id = sss(istate)%id_surf
            call ps_intrp_1d(xeval,id,surfa,ierr, state=sss(istate))
            if(ierr.ne.0) then
               write(luntty,*) &
                    ' ?ur_cstate_sprof (get1): error fetching metric: Surf(x)'
               return
            endif

            allocate(yyloc(inum),yyderiv(inum),yydsum(inum),psideriv(inum))

            idpsi = sss(istate)%id_psipol
            if(idpsi.gt.0) then
               call ps_intrp_1d(xeval,idpsi,psideriv,ierr, state=sss(istate), &
                    ideriv=1)
               if(ierr.ne.0) then
                  write(luntty,*) &
                       ' ?ur_cstate_sprof (get1): error fetching dPsi/drho'
                  return
               endif
               !  make sure axial value is zero exactly...
               if(xeval(1).eq.ZERO) then
                  psideriv(1)=ZERO
                  ict_zero=0
               else
                  ict_zero=999999
               endif
            else
               write(luntty,*) &
                    ' %ur_cstate_sprof (get1): no poloidal flux function'
               psideriv = ZERO
               ict_zero=99
            endif

            yydsum = ZERO

            insum = sum_table(0,istate,ivar)

            do is = 1,insum
               iv = sum_table(is,istate,ivar)
               id = ww(istate)%ival(iv)
               idw = sss(istate)%id_zonwt(id)
               if(idw.gt.0) then
                  write(luntty,*) &
                       ' ?ur_cstate_sprof (get1): unexpected weight data.'
                  exit
               endif

               call ps_intrp_1d(xeval,id,yyloc,ierr, state=sss(istate))
               if(ierr.ne.0) then
                  write(luntty,*) &
                       ' ?ur_cstate_sprof (get1): f(x) interpolation error.'
                  yy = ZERO
                  exit
               endif

               call ps_intrp_1d(xeval,id,yyderiv,ierr, state=sss(istate), &
                    ideriv=1)
               if(ierr.ne.0) then
                  write(luntty,*) &
                       ' ?ur_cstate_sprof (get1): df/dx interpolation error.'
                  yy = ZERO
                  exit
               endif

               yy(1:inum)=yy(1:inum)+yyloc
               yydsum = yydsum + yyderiv
            enddo

            !  yy is the sum of f
            !  yydsum is the sum of df/dx

            do ix=1,inum
               ygrad=yydsum(ix)*surfa(ix)/vola(ix)
               yval=yy(ix)

               if(iopt.eq.1) then
                  ! return gradient
                  yy(ix)=ygrad

               else if(iopt.eq.2) then
                  ! return scale length
                  if(max(abs(yval),abs(ygrad)).eq.ZERO) then
                     yy(ix)=ZERO
                  else if(abs(yval).gt.scalemax*abs(ygrad)) then
                     yy(ix)=scalemax
                  else
                     yy(ix)=abs(yval)/abs(ygrad)
                  endif

               else if(iopt.eq.3) then
                  ! return inverse scale length
                  if(max(abs(yval),abs(ygrad)).eq.ZERO) then
                     yy(ix)=ZERO
                  else if(abs(ygrad).gt.scalemax*abs(yval)) then
                     yy(ix)=scalemax
                  else
                     yy(ix)=abs(ygrad)/abs(yval)
                  endif

               else if(iopt.eq.4) then
                  yy(ix)=yydsum(ix)

               else if(iopt.eq.5) then
                  if(psideriv(ix).eq.ZERO) then
                     yy(ix)=0
                     ict_zero=ict_zero+ix
                  else
                     yy(ix)=yydsum(ix)/psideriv(ix)
                  endif
               endif

            enddo

            if(iopt.ne.5) ict_zero = 0
            if(ict_zero.eq.999999) ict_zero = 0

            if(ict_zero.gt.1) then
               write(luntty,*) &
                    ' %ur_cstate_sprof: dPsi/drho = 0 away from axis.'
               write(luntty,*) &
                    '  df/dpsi not evaluated, where dPsi/drho = 0.'
            else if(ict_zero.eq.1) then
               write(luntty,*) &
                    ' %ur_cstate_sprof: patched on axis; dPsi -> 0.'
               yy(1) = yy(2) - (xeval(2)-xeval(1))*(yy(3)-yy(2))/ &
                    (xeval(3)-xeval(2))
            endif

         endif
      else
         write(luntty,*) ' ?? ur_cstate_sprof: get1 internal error: ctrl=',ctrl
      endif
    end subroutine get1

    subroutine free_wwnorm
      if(allocated(wwnorm)) then
         do ii=1,nsss_cur
            call free_window(wwnorm(ii))
         enddo
         deallocate(wwnorm)
      endif
    end subroutine free_wwnorm

    subroutine varlab_chk(varlab,invar)

      !  find common prefix among profile data labels
      !  (if labels are long, omit common prefix to improve readibility
      !  of multigraph key box)

      integer :: invar
      character*(*) :: varlab(invar)

      integer :: lenmax,lenmin,lenmatch
      integer :: ivar,ic,ilen,imatch

      ifc=1
      if(invar.eq.1) return

      lenmax=0
      lenmin=len(varlab(1))
      do ivar=1,invar
         ilen=len(trim(varlab(ivar)))
         lenmax=max(lenmax,ilen)
         lenmin=min(lenmin,ilen)
      enddo

      if(lenmax.le.12) return

      ! OK labels are rather long... see if there are identical prefixes
      ! that we will presume can be dropped...

      lenmatch=lenmin-1
      if(lenmatch.le.0) return

      do ivar=2,invar
         imatch=lenmatch
         do ic=1,lenmatch
            if(varlab(1)(ic:ic).ne.varlab(ivar)(ic:ic)) then
               imatch=ic-1
               exit
            endif
         enddo
         lenmatch=imatch
      enddo

      if(lenmatch.gt.3) ifc=lenmatch+1

    end subroutine varlab_chk

end subroutine ur_cstate_sprof

subroutine ps_eq_volume(iobj,isize,rhovals,vols,iout,ierr)

  !------------------------------------------------------------
  ! D. McCune 10 Apr 2007
  !
  ! Fetch XPLASMA2 enclosed volumes, from equilibrium Vol(rho)
  !------------------------------------------------------------

  use plasma_state_definition_mod
  use plasma_state_xpobj  ! XPLASMA2 state object definitions
  implicit NONE

  !-----------------------
  !  passed arguments:

  integer :: iobj(ps_container_size)     ! xplasma opaque container

  integer, intent(in) :: isize     ! size of array to receive grid
  real(kind=rspec), intent(in) :: rhovals(isize) ! ascending grid of rho values
  real(kind=rspec) :: vols(isize)  ! array to receive volumes(rhovals)

  integer, intent(in) :: iout     ! Fortran LUN of file for messages
  integer, intent(out) :: ierr    ! completion status code (0=OK)

  !-----------------------
  ! local:
  integer :: ii,iflag,iwarn
  real(kind=rspec) zrhos(isize)
  type (interp_object) :: xobj
  type (xplasma), pointer :: s
  !-----------------------

  vols = 0.0_rspec

  xobj = transfer(iobj,xobj)
  s => xobj%s_xpobj

  call xplasma_global_info(s,ierr, init_check=.TRUE.)
  if(ierr.ne.0) then
     write(iout,*) ' %ps_eq_volume: invalid or unitialized xplasma object.'
     return
  endif

  iflag = 0
  iwarn = 0

  do ii=1,isize
     if(rhovals(ii).lt.(-1.0e-10_rspec)) then
        write(iout,*) &
             ' ?ps_volume: negative rhovals(',ii,'):',rhovals(ii)
        ierr = 999
     else if(rhovals(ii).gt.(1.0000000001_rspec)) then
        write(iout,*) &
             ' ?ps_volume: rhovals(',ii,') exceeds 1.000:',rhovals(ii)
        ierr = 999
     else if((rhovals(ii).lt.0.0_rspec).or.(rhovals(ii).gt.1.0_rspec)) then
        zrhos(ii)=max(0.0_rspec,min(1.0_rspec,rhovals(ii)))
        iflag = iflag + 1
     else
        zrhos(ii) = rhovals(ii)
     endif
  enddo
  if(ierr.ne.0) return

  do ii=1,isize-1
     if(zrhos(ii+1).le.zrhos(ii)) then
        write(iout,*) &
             ' ?ps_volume: rho grid input values not strict ascending:'
        write(iout,'("  rhovals(",i4,")=",1pe11.4)') ii,zrhos(ii)
        write(iout,'("  rhovals(",i4,")=",1pe11.4)') ii+1,zrhos(ii+1)
        if(iflag.gt.0) then
           if((zrhos(ii).eq.0.0_rspec).or.(zrhos(ii).eq.1.0_rspec)) then
              write(iout,*) '  NOTE: rhovals forced to be between 0.0 and 1.0'
           endif
        endif
        ierr=999
        iwarn = iwarn + 1
        if(iwarn.gt.3) exit
     endif
  enddo
  if(ierr.ne.0) return

  call xplasma_volume(s,zrhos,vols,ierr)

  if(ierr.ne.0) then
     write(iout,*) ' ?ps_volume: xplasma_volume error:'
     call xplasma_error(s,ierr,iout)
     ierr=999
     return
  endif

end subroutine ps_eq_volume

subroutine ps_eq_area(iobj,isize,rhovals,areas,iout,ierr)

  !------------------------------------------------------------
  ! D. McCune 10 Apr 2007
  !
  ! Fetch XPLASMA2 enclosed areas, from equilibrium Vol(rho)
  !------------------------------------------------------------

  use plasma_state_definition_mod
  use plasma_state_xpobj  ! XPLASMA2 state object definitions
  implicit NONE

  !-----------------------
  !  passed arguments:

  integer :: iobj(ps_container_size)     ! xplasma opaque container

  integer, intent(in) :: isize     ! size of array to receive grid
  real(kind=rspec), intent(in) :: rhovals(isize) ! ascending grid of rho values
  real(kind=rspec) :: areas(isize)  ! array to receive areas(rhovals)

  integer, intent(in) :: iout     ! Fortran LUN of file for messages
  integer, intent(out) :: ierr    ! completion status code (0=OK)

  !-----------------------
  ! local:
  integer :: ii,iflag,iwarn
  real(kind=rspec) zrhos(isize)
  type (interp_object) :: xobj
  type (xplasma), pointer :: s
  !-----------------------

  areas = 0.0_rspec

  xobj = transfer(iobj,xobj)
  s => xobj%s_xpobj

  call xplasma_global_info(s,ierr, init_check=.TRUE.)
  if(ierr.ne.0) then
     write(iout,*) ' %ps_eq_area: invalid or unitialized xplasma object.'
     return
  endif

  iflag = 0
  iwarn = 0

  do ii=1,isize
     if(rhovals(ii).lt.(-1.0e-10_rspec)) then
        write(iout,*) &
             ' ?ps_area: negative rhovals(',ii,'):',rhovals(ii)
        ierr = 999
     else if(rhovals(ii).gt.(1.0000000001_rspec)) then
        write(iout,*) &
             ' ?ps_area: rhovals(',ii,') exceeds 1.000:',rhovals(ii)
        ierr = 999
     else if((rhovals(ii).lt.0.0_rspec).or.(rhovals(ii).gt.1.0_rspec)) then
        zrhos(ii)=max(0.0_rspec,min(1.0_rspec,rhovals(ii)))
        iflag = iflag + 1
     else
        zrhos(ii) = rhovals(ii)
     endif
  enddo
  if(ierr.ne.0) return

  do ii=1,isize-1
     if(zrhos(ii+1).le.zrhos(ii)) then
        write(iout,*) &
             ' ?ps_area: rho grid input values not strict ascending:'
        write(iout,'("  rhovals(",i4,")=",1pe11.4)') ii,zrhos(ii)
        write(iout,'("  rhovals(",i4,")=",1pe11.4)') ii+1,zrhos(ii+1)
        if(iflag.gt.0) then
           if((zrhos(ii).eq.0.0_rspec).or.(zrhos(ii).eq.1.0_rspec)) then
              write(iout,*) '  NOTE: rhovals forced to be between 0.0 and 1.0'
           endif
        endif
        ierr=999
        iwarn = iwarn + 1
        if(iwarn.gt.3) exit
     endif
  enddo
  if(ierr.ne.0) return

  call xplasma_area(s,zrhos,areas,ierr)

  if(ierr.ne.0) then
     write(iout,*) ' ?ps_area: xplasma_area error:'
     call xplasma_error(s,ierr,iout)
     ierr=999
     return
  endif

end subroutine ps_eq_area

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


SUBROUTINE plasma_state_get_3(ss,icdf,version_change,iout,iertot)


  !  read subset of variables and arrays from NetCDF file

  USE plasma_state_definition_mod
  USE netcdf
  IMPLICIT NONE

  TYPE (plasma_state) :: ss     ! state data to read
  INTEGER, INTENT(IN) :: icdf   ! NetCDF file ID
  LOGICAL, INTENT(IN) :: version_change  ! flag file/software version mismatch
  INTEGER, INTENT(IN) :: iout   ! message LUN
  INTEGER, INTENT(INOUT) :: iertot  ! error count

  !--------------

  INTEGER :: varid,dimid,status,ilen,jlen,idims(20),indim
  INTEGER :: ii,iflag_alloc2,iflag_loc2,isize
  CHARACTER*80 :: nc_errmsg

  !--------------


  !-----------------------------------------------
  ! NetCDF reads...

  IF(ALLOCATED(ss%grho2b2i)) THEN
     status = nf90_inq_varid(icdf,"grho2b2i",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"grho2b2i")
     ELSE
        status = nf90_get_var(icdf,varid,ss%grho2b2i)
        IF(status.NE.NF90_NOERR) THEN
           ss%grho2b2i = 0.0_rspec
           CALL ncerr_name(2,status,"grho2b2i")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%grho2r2i)) THEN
     status = nf90_inq_varid(icdf,"grho2r2i",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"grho2r2i")
     ELSE
        status = nf90_get_var(icdf,varid,ss%grho2r2i)
        IF(status.NE.NF90_NOERR) THEN
           ss%grho2r2i = 0.0_rspec
           CALL ncerr_name(2,status,"grho2r2i")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%grho2r3i)) THEN
     status = nf90_inq_varid(icdf,"grho2r3i",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"grho2r3i")
     ELSE
        status = nf90_get_var(icdf,varid,ss%grho2r3i)
        IF(status.NE.NF90_NOERR) THEN
           ss%grho2r3i = 0.0_rspec
           CALL ncerr_name(2,status,"grho2r3i")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%gri)) THEN
     status = nf90_inq_varid(icdf,"gri",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"gri")
     ELSE
        status = nf90_get_var(icdf,varid,ss%gri)
        IF(status.NE.NF90_NOERR) THEN
           ss%gri = 0.0_rspec
           CALL ncerr_name(2,status,"gri")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%grirhoi)) THEN
     status = nf90_inq_varid(icdf,"grirhoi",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"grirhoi")
     ELSE
        status = nf90_get_var(icdf,varid,ss%grirhoi)
        IF(status.NE.NF90_NOERR) THEN
           ss%grirhoi = 0.0_rspec
           CALL ncerr_name(2,status,"grirhoi")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%growthrate_drbm)) THEN
     status = nf90_inq_varid(icdf,"growthrate_drbm",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"growthrate_drbm")
     ELSE
        status = nf90_get_var(icdf,varid,ss%growthrate_drbm)
        IF(status.NE.NF90_NOERR) THEN
           ss%growthrate_drbm = 0.0_rspec
           CALL ncerr_name(2,status,"growthrate_drbm")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%growthrate_glf)) THEN
     status = nf90_inq_varid(icdf,"growthrate_glf",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"growthrate_glf")
     ELSE
        status = nf90_get_var(icdf,varid,ss%growthrate_glf)
        IF(status.NE.NF90_NOERR) THEN
           ss%growthrate_glf = 0.0_rspec
           CALL ncerr_name(2,status,"growthrate_glf")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%growthrate_max_tglf)) THEN
     status = nf90_inq_varid(icdf,"growthrate_max_tglf",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"growthrate_max_tglf")
     ELSE
        status = nf90_get_var(icdf,varid,ss%growthrate_max_tglf)
        IF(status.NE.NF90_NOERR) THEN
           ss%growthrate_max_tglf = 0.0_rspec
           CALL ncerr_name(2,status,"growthrate_max_tglf")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%growthrate_mmm71)) THEN
     status = nf90_inq_varid(icdf,"growthrate_mmm71",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"growthrate_mmm71")
     ELSE
        status = nf90_get_var(icdf,varid,ss%growthrate_mmm71)
        IF(status.NE.NF90_NOERR) THEN
           ss%growthrate_mmm71 = 0.0_rspec
           CALL ncerr_name(2,status,"growthrate_mmm71")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%growthrate_mtm)) THEN
     status = nf90_inq_varid(icdf,"growthrate_mtm",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"growthrate_mtm")
     ELSE
        status = nf90_get_var(icdf,varid,ss%growthrate_mtm)
        IF(status.NE.NF90_NOERR) THEN
           ss%growthrate_mtm = 0.0_rspec
           CALL ncerr_name(2,status,"growthrate_mtm")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%growthrate_tglf)) THEN
     status = nf90_inq_varid(icdf,"growthrate_tglf",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"growthrate_tglf")
     ELSE
        status = nf90_get_var(icdf,varid,ss%growthrate_tglf)
        IF(status.NE.NF90_NOERR) THEN
           ss%growthrate_tglf = 0.0_rspec
           CALL ncerr_name(2,status,"growthrate_tglf")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%growthrate_vpar)) THEN
     status = nf90_inq_varid(icdf,"growthrate_vpar",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"growthrate_vpar")
     ELSE
        status = nf90_get_var(icdf,varid,ss%growthrate_vpar)
        IF(status.NE.NF90_NOERR) THEN
           ss%growthrate_vpar = 0.0_rspec
           CALL ncerr_name(2,status,"growthrate_vpar")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%gs_name)) THEN
     status = nf90_inq_varid(icdf,"gs_name",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"gs_name")
     ELSE
        status = nf90_get_var(icdf,varid,ss%gs_name)
        IF(status.NE.NF90_NOERR) THEN
           ss%gs_name = " "
           CALL ncerr_name(2,status,"gs_name")
        ELSE
           CALL denull_vec(ss%gs_name,ss%ngsc0)
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%g_eq)) THEN
     status = nf90_inq_varid(icdf,"g_eq",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"g_eq")
     ELSE
        status = nf90_get_var(icdf,varid,ss%g_eq)
        IF(status.NE.NF90_NOERR) THEN
           ss%g_eq = 0.0_rspec
           CALL ncerr_name(2,status,"g_eq")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%hegrilh)) THEN
     status = nf90_inq_varid(icdf,"hegrilh",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"hegrilh")
     ELSE
        status = nf90_get_var(icdf,varid,ss%hegrilh)
        IF(status.NE.NF90_NOERR) THEN
           ss%hegrilh = 0.0_rspec
           CALL ncerr_name(2,status,"hegrilh")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%Hsize_coil)) THEN
     status = nf90_inq_varid(icdf,"Hsize_coil",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"Hsize_coil")
     ELSE
        status = nf90_get_var(icdf,varid,ss%Hsize_coil)
        IF(status.NE.NF90_NOERR) THEN
           ss%Hsize_coil = 0.0_rspec
           CALL ncerr_name(2,status,"Hsize_coil")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%H_einj_standard)) THEN
     status = nf90_inq_varid(icdf,"H_einj_standard",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"H_einj_standard")
     ELSE
        status = nf90_get_var(icdf,varid,ss%H_einj_standard)
        IF(status.NE.NF90_NOERR) THEN
           ss%H_einj_standard = 0.0_rspec
           CALL ncerr_name(2,status,"H_einj_standard")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%H_ffull_standard)) THEN
     status = nf90_inq_varid(icdf,"H_ffull_standard",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"H_ffull_standard")
     ELSE
        status = nf90_get_var(icdf,varid,ss%H_ffull_standard)
        IF(status.NE.NF90_NOERR) THEN
           ss%H_ffull_standard = 0.0_rspec
           CALL ncerr_name(2,status,"H_ffull_standard")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%H_fhalf_standard)) THEN
     status = nf90_inq_varid(icdf,"H_fhalf_standard",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"H_fhalf_standard")
     ELSE
        status = nf90_get_var(icdf,varid,ss%H_fhalf_standard)
        IF(status.NE.NF90_NOERR) THEN
           ss%H_fhalf_standard = 0.0_rspec
           CALL ncerr_name(2,status,"H_fhalf_standard")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%icircuit_coil)) THEN
     status = nf90_inq_varid(icdf,"icircuit_coil",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"icircuit_coil")
     ELSE
        status = nf90_get_var(icdf,varid,ss%icircuit_coil)
        IF(status.NE.NF90_NOERR) THEN
           ss%icircuit_coil = 0
           CALL ncerr_name(2,status,"icircuit_coil")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%icrf_src_name)) THEN
     status = nf90_inq_varid(icdf,"icrf_src_name",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"icrf_src_name")
     ELSE
        status = nf90_get_var(icdf,varid,ss%icrf_src_name)
        IF(status.NE.NF90_NOERR) THEN
           ss%icrf_src_name = " "
           CALL ncerr_name(2,status,"icrf_src_name")
        ELSE
           CALL denull_vec(ss%icrf_src_name,ss%nicrf_src)
        ENDIF
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"IC_Code_Info",varid)
  IF(status.NE.NF90_NOERR) THEN
     CALL ncerr_name(1,status,"IC_Code_Info")
  ELSE
     ilen = len(ss%IC_Code_Info)
     status = nf90_inquire_variable(icdf,varid,ndims=indim,dimids=idims)
     IF((status.EQ.NF90_NOERR).AND.(indim.eq.1)) THEN
        status = nf90_inquire_dimension(icdf,idims(1),len=jlen)
        IF(status.EQ.NF90_NOERR) ilen=min(ilen,jlen)
     ENDIF
     ss%IC_Code_Info = " "
     status = nf90_get_var(icdf,varid,ss%IC_Code_Info(1:ilen))
     IF(status.NE.NF90_NOERR) THEN
        ss%IC_Code_Info = " "
        CALL ncerr_name(2,status,"IC_Code_Info")
     ELSE
        CALL denull(ss%IC_Code_Info)
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"IC_Data_Info",varid)
  IF(status.NE.NF90_NOERR) THEN
     CALL ncerr_name(1,status,"IC_Data_Info")
  ELSE
     ilen = len(ss%IC_Data_Info)
     status = nf90_inquire_variable(icdf,varid,ndims=indim,dimids=idims)
     IF((status.EQ.NF90_NOERR).AND.(indim.eq.1)) THEN
        status = nf90_inquire_dimension(icdf,idims(1),len=jlen)
        IF(status.EQ.NF90_NOERR) ilen=min(ilen,jlen)
     ENDIF
     ss%IC_Data_Info = " "
     status = nf90_get_var(icdf,varid,ss%IC_Data_Info(1:ilen))
     IF(status.NE.NF90_NOERR) THEN
        ss%IC_Data_Info = " "
        CALL ncerr_name(2,status,"IC_Data_Info")
     ELSE
        CALL denull(ss%IC_Data_Info)
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%Imag_ant_coef)) THEN
     status = nf90_inq_varid(icdf,"Imag_ant_coef",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"Imag_ant_coef")
     ELSE
        status = nf90_get_var(icdf,varid,ss%Imag_ant_coef)
        IF(status.NE.NF90_NOERR) THEN
           ss%Imag_ant_coef = 0.0_rspec
           CALL ncerr_name(2,status,"Imag_ant_coef")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%iota)) THEN
     status = nf90_inq_varid(icdf,"iota",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"iota")
     ELSE
        status = nf90_get_var(icdf,varid,ss%iota)
        IF(status.NE.NF90_NOERR) THEN
           ss%iota = 0.0_rspec
           CALL ncerr_name(2,status,"iota")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%isThermal)) THEN
     status = nf90_inq_varid(icdf,"isThermal",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"isThermal")
     ELSE
        status = nf90_get_var(icdf,varid,ss%isThermal)
        IF(status.NE.NF90_NOERR) THEN
           ss%isThermal = 0
           CALL ncerr_name(2,status,"isThermal")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%is_recycling)) THEN
     status = nf90_inq_varid(icdf,"is_recycling",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"is_recycling")
     ELSE
        status = nf90_get_var(icdf,varid,ss%is_recycling)
        IF(status.NE.NF90_NOERR) THEN
           ss%is_recycling = 0
           CALL ncerr_name(2,status,"is_recycling")
        ENDIF
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"i_npoloidal",varid)
  IF(status.NE.NF90_NOERR) THEN
     CALL ncerr_name(1,status,"i_npoloidal")
  ELSE
     status = nf90_get_var(icdf,varid,ss%i_npoloidal)
     IF(status.NE.NF90_NOERR) THEN
        ss%i_npoloidal = ps_unInit
        CALL ncerr_name(2,status,"i_npoloidal")
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%jdotb)) THEN
     status = nf90_inq_varid(icdf,"jdotb",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"jdotb")
     ELSE
        status = nf90_get_var(icdf,varid,ss%jdotb)
        IF(status.NE.NF90_NOERR) THEN
           ss%jdotb = 0.0_rspec
           CALL ncerr_name(2,status,"jdotb")
        ENDIF
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"kccw_Bphi",varid)
  IF(status.NE.NF90_NOERR) THEN
     CALL ncerr_name(1,status,"kccw_Bphi")
  ELSE
     status = nf90_get_var(icdf,varid,ss%kccw_Bphi)
     IF(status.NE.NF90_NOERR) THEN
        ss%kccw_Bphi = 0
        CALL ncerr_name(2,status,"kccw_Bphi")
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"kccw_Jphi",varid)
  IF(status.NE.NF90_NOERR) THEN
     CALL ncerr_name(1,status,"kccw_Jphi")
  ELSE
     status = nf90_get_var(icdf,varid,ss%kccw_Jphi)
     IF(status.NE.NF90_NOERR) THEN
        ss%kccw_Jphi = 0
        CALL ncerr_name(2,status,"kccw_Jphi")
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"kdens_rfmin",varid)
  IF(status.NE.NF90_NOERR) THEN
     CALL ncerr_name(1,status,"kdens_rfmin")
  ELSE
     ilen = len(ss%kdens_rfmin)
     status = nf90_inquire_variable(icdf,varid,ndims=indim,dimids=idims)
     IF((status.EQ.NF90_NOERR).AND.(indim.eq.1)) THEN
        status = nf90_inquire_dimension(icdf,idims(1),len=jlen)
        IF(status.EQ.NF90_NOERR) ilen=min(ilen,jlen)
     ENDIF
     ss%kdens_rfmin = "data"
     status = nf90_get_var(icdf,varid,ss%kdens_rfmin(1:ilen))
     IF(status.NE.NF90_NOERR) THEN
        ss%kdens_rfmin = "data"
        CALL ncerr_name(2,status,"kdens_rfmin")
     ELSE
        CALL denull(ss%kdens_rfmin)
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%kvolt_nbi)) THEN
     status = nf90_inq_varid(icdf,"kvolt_nbi",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"kvolt_nbi")
     ELSE
        status = nf90_get_var(icdf,varid,ss%kvolt_nbi)
        IF(status.NE.NF90_NOERR) THEN
           ss%kvolt_nbi = 0.0_rspec
           CALL ncerr_name(2,status,"kvolt_nbi")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%kyrhos_mtm)) THEN
     status = nf90_inq_varid(icdf,"kyrhos_mtm",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"kyrhos_mtm")
     ELSE
        status = nf90_get_var(icdf,varid,ss%kyrhos_mtm)
        IF(status.NE.NF90_NOERR) THEN
           ss%kyrhos_mtm = 0.0_rspec
           CALL ncerr_name(2,status,"kyrhos_mtm")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%kyspectrum_tglf)) THEN
     status = nf90_inq_varid(icdf,"kyspectrum_tglf",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"kyspectrum_tglf")
     ELSE
        status = nf90_get_var(icdf,varid,ss%kyspectrum_tglf)
        IF(status.NE.NF90_NOERR) THEN
           ss%kyspectrum_tglf = 0.0_rspec
           CALL ncerr_name(2,status,"kyspectrum_tglf")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%Lbscap)) THEN
     status = nf90_inq_varid(icdf,"Lbscap",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"Lbscap")
     ELSE
        status = nf90_get_var(icdf,varid,ss%Lbscap)
        IF(status.NE.NF90_NOERR) THEN
           ss%Lbscap = 0.0_rspec
           CALL ncerr_name(2,status,"Lbscap")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%Lbscap2)) THEN
     status = nf90_inq_varid(icdf,"Lbscap2",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"Lbscap2")
     ELSE
        status = nf90_get_var(icdf,varid,ss%Lbscap2)
        IF(status.NE.NF90_NOERR) THEN
           ss%Lbscap2 = 0.0_rspec
           CALL ncerr_name(2,status,"Lbscap2")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%Lbsctan)) THEN
     status = nf90_inq_varid(icdf,"Lbsctan",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"Lbsctan")
     ELSE
        status = nf90_get_var(icdf,varid,ss%Lbsctan)
        IF(status.NE.NF90_NOERR) THEN
           ss%Lbsctan = 0.0_rspec
           CALL ncerr_name(2,status,"Lbsctan")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%lhrf_src_name)) THEN
     status = nf90_inq_varid(icdf,"lhrf_src_name",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"lhrf_src_name")
     ELSE
        status = nf90_get_var(icdf,varid,ss%lhrf_src_name)
        IF(status.NE.NF90_NOERR) THEN
           ss%lhrf_src_name = " "
           CALL ncerr_name(2,status,"lhrf_src_name")
        ELSE
           CALL denull_vec(ss%lhrf_src_name,ss%nlhrf_src)
        ENDIF
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"LH_Code_Info",varid)
  IF(status.NE.NF90_NOERR) THEN
     CALL ncerr_name(1,status,"LH_Code_Info")
  ELSE
     ilen = len(ss%LH_Code_Info)
     status = nf90_inquire_variable(icdf,varid,ndims=indim,dimids=idims)
     IF((status.EQ.NF90_NOERR).AND.(indim.eq.1)) THEN
        status = nf90_inquire_dimension(icdf,idims(1),len=jlen)
        IF(status.EQ.NF90_NOERR) ilen=min(ilen,jlen)
     ENDIF
     ss%LH_Code_Info = " "
     status = nf90_get_var(icdf,varid,ss%LH_Code_Info(1:ilen))
     IF(status.NE.NF90_NOERR) THEN
        ss%LH_Code_Info = " "
        CALL ncerr_name(2,status,"LH_Code_Info")
     ELSE
        CALL denull(ss%LH_Code_Info)
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"LH_Data_Info",varid)
  IF(status.NE.NF90_NOERR) THEN
     CALL ncerr_name(1,status,"LH_Data_Info")
  ELSE
     ilen = len(ss%LH_Data_Info)
     status = nf90_inquire_variable(icdf,varid,ndims=indim,dimids=idims)
     IF((status.EQ.NF90_NOERR).AND.(indim.eq.1)) THEN
        status = nf90_inquire_dimension(icdf,idims(1),len=jlen)
        IF(status.EQ.NF90_NOERR) ilen=min(ilen,jlen)
     ENDIF
     ss%LH_Data_Info = " "
     status = nf90_get_var(icdf,varid,ss%LH_Data_Info(1:ilen))
     IF(status.NE.NF90_NOERR) THEN
        ss%LH_Data_Info = " "
        CALL ncerr_name(2,status,"LH_Data_Info")
     ELSE
        CALL denull(ss%LH_Data_Info)
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"LMHD_eq_code",varid)
  IF(status.NE.NF90_NOERR) THEN
     CALL ncerr_name(1,status,"LMHD_eq_code")
  ELSE
     ilen = len(ss%LMHD_eq_code)
     status = nf90_inquire_variable(icdf,varid,ndims=indim,dimids=idims)
     IF((status.EQ.NF90_NOERR).AND.(indim.eq.1)) THEN
        status = nf90_inquire_dimension(icdf,idims(1),len=jlen)
        IF(status.EQ.NF90_NOERR) ilen=min(ilen,jlen)
     ENDIF
     ss%LMHD_eq_code = " "
     status = nf90_get_var(icdf,varid,ss%LMHD_eq_code(1:ilen))
     IF(status.NE.NF90_NOERR) THEN
        ss%LMHD_eq_code = " "
        CALL ncerr_name(2,status,"LMHD_eq_code")
     ELSE
        CALL denull(ss%LMHD_eq_code)
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"LMHD_status",varid)
  IF(status.NE.NF90_NOERR) THEN
     CALL ncerr_name(1,status,"LMHD_status")
  ELSE
     status = nf90_get_var(icdf,varid,ss%LMHD_status)
     IF(status.NE.NF90_NOERR) THEN
        ss%LMHD_status = ps_unInit
        CALL ncerr_name(2,status,"LMHD_status")
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"lock_machine_descr",varid)
  IF(status.NE.NF90_NOERR) THEN
     CALL ncerr_name(1,status,"lock_machine_descr")
  ELSE
     status = nf90_get_var(icdf,varid,ss%lock_machine_descr)
     IF(status.NE.NF90_NOERR) THEN
        ss%lock_machine_descr = 0
        CALL ncerr_name(2,status,"lock_machine_descr")
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"lock_shot_config",varid)
  IF(status.NE.NF90_NOERR) THEN
     CALL ncerr_name(1,status,"lock_shot_config")
  ELSE
     status = nf90_get_var(icdf,varid,ss%lock_shot_config)
     IF(status.NE.NF90_NOERR) THEN
        ss%lock_shot_config = 0
        CALL ncerr_name(2,status,"lock_shot_config")
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"lock_sim_init",varid)
  IF(status.NE.NF90_NOERR) THEN
     CALL ncerr_name(1,status,"lock_sim_init")
  ELSE
     status = nf90_get_var(icdf,varid,ss%lock_sim_init)
     IF(status.NE.NF90_NOERR) THEN
        ss%lock_sim_init = 0
        CALL ncerr_name(2,status,"lock_sim_init")
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%Lpol)) THEN
     status = nf90_inq_varid(icdf,"Lpol",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"Lpol")
     ELSE
        status = nf90_get_var(icdf,varid,ss%Lpol)
        IF(status.NE.NF90_NOERR) THEN
           ss%Lpol = 0.0_rspec
           CALL ncerr_name(2,status,"Lpol")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%Mercier_stable)) THEN
     status = nf90_inq_varid(icdf,"Mercier_stable",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"Mercier_stable")
     ELSE
        status = nf90_get_var(icdf,varid,ss%Mercier_stable)
        IF(status.NE.NF90_NOERR) THEN
           ss%Mercier_stable = 0
           CALL ncerr_name(2,status,"Mercier_stable")
        ENDIF
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"MHD_eq_status",varid)
  IF(status.NE.NF90_NOERR) THEN
     CALL ncerr_name(1,status,"MHD_eq_status")
  ELSE
     status = nf90_get_var(icdf,varid,ss%MHD_eq_status)
     IF(status.NE.NF90_NOERR) THEN
        ss%MHD_eq_status = ps_unInit
        CALL ncerr_name(2,status,"MHD_eq_status")
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%m_ALL)) THEN
     status = nf90_inq_varid(icdf,"m_ALL",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"m_ALL")
     ELSE
        status = nf90_get_var(icdf,varid,ss%m_ALL)
        IF(status.NE.NF90_NOERR) THEN
           ss%m_ALL = 0.0_rspec
           CALL ncerr_name(2,status,"m_ALL")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%m_ALLA)) THEN
     status = nf90_inq_varid(icdf,"m_ALLA",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"m_ALLA")
     ELSE
        status = nf90_get_var(icdf,varid,ss%m_ALLA)
        IF(status.NE.NF90_NOERR) THEN
           ss%m_ALLA = 0.0_rspec
           CALL ncerr_name(2,status,"m_ALLA")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%m_RFMIN)) THEN
     status = nf90_inq_varid(icdf,"m_RFMIN",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"m_RFMIN")
     ELSE
        status = nf90_get_var(icdf,varid,ss%m_RFMIN)
        IF(status.NE.NF90_NOERR) THEN
           ss%m_RFMIN = 0.0_rspec
           CALL ncerr_name(2,status,"m_RFMIN")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%m_S)) THEN
     status = nf90_inq_varid(icdf,"m_S",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"m_S")
     ELSE
        status = nf90_get_var(icdf,varid,ss%m_S)
        IF(status.NE.NF90_NOERR) THEN
           ss%m_S = 0.0_rspec
           CALL ncerr_name(2,status,"m_S")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%m_SA)) THEN
     status = nf90_inq_varid(icdf,"m_SA",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"m_SA")
     ELSE
        status = nf90_get_var(icdf,varid,ss%m_SA)
        IF(status.NE.NF90_NOERR) THEN
           ss%m_SA = 0.0_rspec
           CALL ncerr_name(2,status,"m_SA")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%m_SFUS)) THEN
     status = nf90_inq_varid(icdf,"m_SFUS",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"m_SFUS")
     ELSE
        status = nf90_get_var(icdf,varid,ss%m_SFUS)
        IF(status.NE.NF90_NOERR) THEN
           ss%m_SFUS = 0.0_rspec
           CALL ncerr_name(2,status,"m_SFUS")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%m_SGAS)) THEN
     status = nf90_inq_varid(icdf,"m_SGAS",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"m_SGAS")
     ELSE
        status = nf90_get_var(icdf,varid,ss%m_SGAS)
        IF(status.NE.NF90_NOERR) THEN
           ss%m_SGAS = 0.0_rspec
           CALL ncerr_name(2,status,"m_SGAS")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%m_SIMP0)) THEN
     status = nf90_inq_varid(icdf,"m_SIMP0",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"m_SIMP0")
     ELSE
        status = nf90_get_var(icdf,varid,ss%m_SIMP0)
        IF(status.NE.NF90_NOERR) THEN
           ss%m_SIMP0 = 0.0_rspec
           CALL ncerr_name(2,status,"m_SIMP0")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%m_SIMPI)) THEN
     status = nf90_inq_varid(icdf,"m_SIMPI",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"m_SIMPI")
     ELSE
        status = nf90_get_var(icdf,varid,ss%m_SIMPI)
        IF(status.NE.NF90_NOERR) THEN
           ss%m_SIMPI = 0.0_rspec
           CALL ncerr_name(2,status,"m_SIMPI")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%m_SNBI)) THEN
     status = nf90_inq_varid(icdf,"m_SNBI",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"m_SNBI")
     ELSE
        status = nf90_get_var(icdf,varid,ss%m_SNBI)
        IF(status.NE.NF90_NOERR) THEN
           ss%m_SNBI = 0.0_rspec
           CALL ncerr_name(2,status,"m_SNBI")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%n0norm)) THEN
     status = nf90_inq_varid(icdf,"n0norm",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"n0norm")
     ELSE
        status = nf90_get_var(icdf,varid,ss%n0norm)
        IF(status.NE.NF90_NOERR) THEN
           ss%n0norm = 0.0_rspec
           CALL ncerr_name(2,status,"n0norm")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%n0_halo)) THEN
     status = nf90_inq_varid(icdf,"n0_halo",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"n0_halo")
     ELSE
        status = nf90_get_var(icdf,varid,ss%n0_halo)
        IF(status.NE.NF90_NOERR) THEN
           ss%n0_halo = 0.0_rspec
           CALL ncerr_name(2,status,"n0_halo")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%n0_reco)) THEN
     status = nf90_inq_varid(icdf,"n0_reco",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"n0_reco")
     ELSE
        status = nf90_get_var(icdf,varid,ss%n0_reco)
        IF(status.NE.NF90_NOERR) THEN
           ss%n0_reco = 0.0_rspec
           CALL ncerr_name(2,status,"n0_reco")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%nbap2_shape)) THEN
     status = nf90_inq_varid(icdf,"nbap2_shape",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"nbap2_shape")
     ELSE
        status = nf90_get_var(icdf,varid,ss%nbap2_shape)
        IF(status.NE.NF90_NOERR) THEN
           ss%nbap2_shape = " "
           CALL ncerr_name(2,status,"nbap2_shape")
        ELSE
           CALL denull_vec(ss%nbap2_shape,ss%nbeam)
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%nbap_shape)) THEN
     status = nf90_inq_varid(icdf,"nbap_shape",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"nbap_shape")
     ELSE
        status = nf90_get_var(icdf,varid,ss%nbap_shape)
        IF(status.NE.NF90_NOERR) THEN
           ss%nbap_shape = " "
           CALL ncerr_name(2,status,"nbap_shape")
        ELSE
           CALL denull_vec(ss%nbap_shape,ss%nbeam)
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%nbeami)) THEN
     status = nf90_inq_varid(icdf,"nbeami",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"nbeami")
     ELSE
        status = nf90_get_var(icdf,varid,ss%nbeami)
        IF(status.NE.NF90_NOERR) THEN
           ss%nbeami = 0.0_rspec
           CALL ncerr_name(2,status,"nbeami")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%nbeami_bdy)) THEN
     status = nf90_inq_varid(icdf,"nbeami_bdy",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"nbeami_bdy")
     ELSE
        status = nf90_get_var(icdf,varid,ss%nbeami_bdy)
        IF(status.NE.NF90_NOERR) THEN
           ss%nbeami_bdy = 0.0_rspec
           CALL ncerr_name(2,status,"nbeami_bdy")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%nbion)) THEN
     status = nf90_inq_varid(icdf,"nbion",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"nbion")
     ELSE
        status = nf90_get_var(icdf,varid,ss%nbion)
        IF(status.NE.NF90_NOERR) THEN
           ss%nbion = " "
           CALL ncerr_name(2,status,"nbion")
        ELSE
           CALL denull_vec(ss%nbion,ss%nbeam)
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%nbion_trace)) THEN
     status = nf90_inq_varid(icdf,"nbion_trace",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"nbion_trace")
     ELSE
        status = nf90_get_var(icdf,varid,ss%nbion_trace)
        IF(status.NE.NF90_NOERR) THEN
           ss%nbion_trace = " "
           CALL ncerr_name(2,status,"nbion_trace")
        ELSE
           CALL denull_vec(ss%nbion_trace,ss%nbeam)
        ENDIF
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"NBI_Code_Info",varid)
  IF(status.NE.NF90_NOERR) THEN
     CALL ncerr_name(1,status,"NBI_Code_Info")
  ELSE
     ilen = len(ss%NBI_Code_Info)
     status = nf90_inquire_variable(icdf,varid,ndims=indim,dimids=idims)
     IF((status.EQ.NF90_NOERR).AND.(indim.eq.1)) THEN
        status = nf90_inquire_dimension(icdf,idims(1),len=jlen)
        IF(status.EQ.NF90_NOERR) ilen=min(ilen,jlen)
     ENDIF
     ss%NBI_Code_Info = " "
     status = nf90_get_var(icdf,varid,ss%NBI_Code_Info(1:ilen))
     IF(status.NE.NF90_NOERR) THEN
        ss%NBI_Code_Info = " "
        CALL ncerr_name(2,status,"NBI_Code_Info")
     ELSE
        CALL denull(ss%NBI_Code_Info)
     ENDIF
  ENDIF

  CONTAINS
     SUBROUTINE denull_vec(vstr,isize)
        INTEGER, intent(in) :: isize
        CHARACTER*(*) :: vstr(isize)
        INTEGER :: i

        do i=1,isize
           call denull(vstr(i))
        enddo
     END SUBROUTINE denull_vec

     SUBROUTINE denull(str)
        ! convert null characters to blank
        CHARACTER*(*) :: str
        INTEGER :: i

        do i=1,len(str)
           if(ichar(str(i:i)).eq.0) str(i:i)=' '
        enddo
     END SUBROUTINE denull

     SUBROUTINE ncerr_name(itype,status,name)
        INTEGER, INTENT(in) :: itype
        INTEGER, INTENT(in) :: status
        CHARACTER*(*), INTENT(in) :: name

        if(itype.eq.1) then
           write(iout,*) ' %plasma_state_get: warning: variable name = "'// &
                  trim(name)//'":'
        else
           write(iout,*) ' ?plasma_state_get: error: variable name = "'// &
                  trim(name)//'":'
           if(version_change) then
              write(iout,*) '   => version change RECOVERY: variable reset to initial value.'
           else
              iertot = iertot + 1
           endif
        endif
        call ncerr(status)
     END SUBROUTINE ncerr_name

     SUBROUTINE ncerr(status)
        INTEGER, INTENT(in) :: status

        nc_errmsg = NF90_strerror(status)
        write(iout,*) '  NetCDF message: ',trim(nc_errmsg)
     END SUBROUTINE ncerr

END SUBROUTINE plasma_state_get_3

subroutine ccps_frantic(iobj_plasma, iobj_srces, ilun_msgs, &
  iwall, ihalo, ireco, ierr)

  ! use FRANTIC to evaluate neutral transport using input 
  ! data from two plasma states. 
  !

  use plasma_state_mod
  implicit NONE

  integer :: iobj_plasma(*) ! (ps_container_size) contains equilibrium data
  integer :: iobj_srces(*)  ! (ps_container_size) contains sources
  integer, intent(in) :: ilun_msgs
  integer, intent(in) :: iwall ! /= 0 for wall source neutral transport turned on
  integer, intent(in) :: ihalo ! /= 0 for halo source neutral transp. enabled
  integer, intent(in) :: ireco ! /= 0 to turn recombination on
  
  integer,intent(out) :: ierr  ! exit status 0=OK

  !-------------------------
  type (plasma_state_container) :: ptr_plasma, ptr_srces
  type (plasma_state), pointer :: ss_plasma, ss_srces
  !-------------------------

  call ccps_argcheck('ccps_frantic plasma',iobj_plasma,ierr)
  if(ierr.ne.0) return
  call ccps_argcheck('ccps_frantic srces',iobj_srces,ierr)
  if(ierr.ne.0) return

  ! proceed...

  call load_ps_container(iobj_plasma, ptr_plasma)
  call load_ps_container(iobj_srces, ptr_srces)
  ss_plasma => ptr_plasma%ps_ptr
  ss_srces => ptr_srces%ps_ptr

  call ps_frantic(ss_plasma, ss_srces, ilun_msgs, &
       iwall, ihalo, ireco, ierr)

end subroutine ccps_frantic

subroutine ps_intrp1s(nvec,xvec,nids,ids,iobj,iderivs,iccw_th,ansa,iout,ierr)

  !------------------------------------------------------------
  ! D. McCune 13 Oct 2006
  !
  ! XPLASMA2 implementation of plasma_state subroutine
  ! interpolate a set of 1d profiles to a vector of target points,
  !   returning a set of vector results.
  !
  ! All profiles must be defined over the same set of grids and 
  ! all must be interpolated by the same method.
  !------------------------------------------------------------

  use plasma_state_definition_mod
  use plasma_state_xpobj  ! XPLASMA2 state object definitions
  implicit NONE

  !-----------------------
  !  passed arguments:

  integer, intent(in) :: nvec  ! size of interpolation target vector
  REAL(KIND=rspec), intent(in) :: xvec(nvec)  ! interpolation target vector

  integer, intent(in) :: nids  ! number of profiles to evaluate
  integer, intent(in) :: ids(nids)  ! the profile IDs

  integer :: iobj(ps_container_size)     ! xplasma opaque container

  integer, intent(in) :: iderivs(nids) ! derivative control:
  !  0 for profile value; 1 for d[profile]/dx; 2 for d2[profile]/dx2
  !  separately provided for each profile

  integer, intent(in) :: iccw_th  ! poloidal angle orientation control (CCW)

  REAL(KIND=rspec), intent(out) :: ansa(nvec,nids)  ! interpolation results

  integer, intent(in) :: iout     ! Fortran LUN of file for messages
  integer, intent(out) :: ierr    ! completion status code (0=OK)

  !-----------------------
  integer :: ii,irank,igrid,jgrid,icoord,ispline,jspline
  logical :: jccw
  character*32 :: profname1,profname2

  type (interp_object) :: xobj
  type (xplasma), pointer :: s
  !-----------------------

  xobj = transfer(iobj,xobj)
  s => xobj%s_xpobj

  call xplasma_global_info(s,ierr, init_check=.TRUE.)
  if(ierr.ne.0) then
     write(iout,*) ' %ps_intrp1s: invalid or unitialized xplasma object.'
     return
  endif

  !  look to 1st profile ID to define grids and interpolation type

  call xplasma_prof_info(s,ids(1),ierr, name=profname1, gridId1=igrid, &
       splineType = ispline, rank=irank)
  
  if(ierr.ne.0) then
     write(iout,*) ' ?ps_intrp1s: 1st xplasma_prof_info call failed:'
     call xplasma_error(s,ierr,iout)
     ierr=77
     return
  endif

  if(irank.ne.1) then
     write(iout,*) ' ?ps_intrp1: profile id=',ids(1), &
          ' name="',trim(profname1),'" has rank: ',irank
     write(iout,*) '  This profile cannot be evaluated by 1d interpolation.'
     ierr=77
     return
  endif

  call xplasma_grid_info(s,igrid,ierr, coord=icoord)
  if(ierr.ne.0) then
     write(iout,*) ' ?ps_intrp1s: xplasma_grid_info call failed:'
     call xplasma_error(s,ierr,iout)
     ierr=77
     return
  endif

  !  check for theta reversal request

  if(icoord.eq.xplasma_theta_coord) then
     jccw = (iccw_th.ne.ps_ccw_reverse)
  else
     jccw = .TRUE.
  endif

  !  check that all additional profiles are on the same grid and of same
  !  rank and spline type...

  do ii=2,nids

     call xplasma_prof_info(s,ids(ii),ierr, name=profname2, gridId1=jgrid, &
          splineType = jspline, rank=irank)
  
     if(ierr.ne.0) then
        write(iout,*) ' ?ps_intrp1s: 2nd xplasma_prof_info call failed:'
        call xplasma_error(s,ierr,iout)
        ierr=77
        return
     endif

     if(irank.ne.1) then
        write(iout,*) ' ?ps_intrp1: profile id=',ids(ii), &
             ' name="',trim(profname2),'" has rank: ',irank
        write(iout,*) '  This profile cannot be evaluated by 1d interpolation.'
        ierr=77
        return
     endif

     if(igrid.ne.jgrid) then
        write(iout,*) ' ?ps_intrp1s: profiles "', &
             trim(profname1),'" and "',trim(profname2),'" are'
        write(iout,*) '  not defined over the same grids-- use separate'
        write(iout,*) '  interpolation calls.'
        ierr=77
        return
     endif

     if(ispline.ne.jspline) then
        write(iout,*) ' ?ps_intrp1s: profiles "', &
             trim(profname1),'" and "',trim(profname2),'" are'
        write(iout,*) '  employ different interpolation methods-- use separate'
        write(iout,*) '  interpolation calls.'
        ierr=77
        return
     endif

  enddo

  call xplasma_eval_prof(s,ids,xvec,ansa,ierr, &
       ideriv1s=iderivs,ccwflag1=jccw)

  if(ierr.ne.0) then
     write(iout,*) ' ?ps_intrp1s: xplasma_eval_prof call failed:'
     call xplasma_error(s,ierr,iout)
     return
  endif

end subroutine ps_intrp1s

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


subroutine ps_mdescr_namelist_write(filename,ss,ierr)

  ! from current contents of state, write machine description namelist

  USE plasma_state_definition_mod
  USE ps_namwr_mod
  IMPLICIT NONE

  CHARACTER*(*), INTENT(IN) :: filename        ! file to contain namelist
  TYPE (plasma_state) :: ss     ! state containing data to write
  INTEGER, INTENT(OUT) :: ierr  ! completion code (0=OK)

  !-------------------------------
  INTEGER :: iout, ilun_namel
  INTEGER, DIMENSION(:), ALLOCATABLE :: isize_vec
  !-------------------------------

  iout = SWIM_err_out_file

  CALL find_io_unit(ilun_namel)

  OPEN(UNIT=ilun_namel,file=filename,status='unknown',iostat=ierr)
  IF(ierr.NE.0) THEN
     WRITE(iout,*) ' ?ps_mdescr_namelist_write: OPEN failure on file: '// &
          TRIM(filename)
     RETURN
  ENDIF

  WRITE(unit=ilun_namel,fmt='(" &mdescr")')

  CALL ps_namwr(ilun_namel, &
       "Tokamak (Machine Description) ID","character", &
       "tokamak_id", ss%tokamak_id)

  CALL ps_namwr(ilun_namel, &
       "path to file(s) vac. vessel & coil descr.","character", &
       "geometry", ss%geometry)

  CALL ps_namwr(ilun_namel, &
       "number of points, axisymmetric (R,Z) limiter","integer", &
       "num_rzlim", ss%num_rzlim)

  IF(ALLOCATED(ss%rlim)) THEN
     CALL ps_namwr(ilun_namel, &
          "R points in closed (R,Z) contour sequence","m", &
          "rlim", ss%NUM_RZLIM, ss%rlim)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "R points in closed (R,Z) contour sequence","m", "rlim")
  ENDIF

  IF(ALLOCATED(ss%zlim)) THEN
     CALL ps_namwr(ilun_namel, &
          "Z points in closed (R,Z) contour sequence","m", &
          "zlim", ss%NUM_RZLIM, ss%zlim)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "Z points in closed (R,Z) contour sequence","m", "zlim")
  ENDIF

  CALL ps_namwr(ilun_namel, &
       "R_min of bounding box","m", &
       "R_min_box", ss%R_min_box)

  CALL ps_namwr(ilun_namel, &
       "R_max of bounding box","m", &
       "R_max_box", ss%R_max_box)

  CALL ps_namwr(ilun_namel, &
       "Z_min of bounding box","m", &
       "Z_min_box", ss%Z_min_box)

  CALL ps_namwr(ilun_namel, &
       "Z_max of bounding box","m", &
       "Z_max_box", ss%Z_max_box)

  IF(ALLOCATED(ss%circuit_name)) THEN
     CALL ps_namwr(ilun_namel, &
          "Number & names of circuits","character", &
          "circuit_name", ss%NCIRCUITS, ss%circuit_name)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "Number & names of circuits","character", "circuit_name")
  ENDIF

  IF(ALLOCATED(ss%coil_name)) THEN
     CALL ps_namwr(ilun_namel, &
          "Number & name of axisymmetric coils","character", &
          "coil_name", ss%NCOILS, ss%coil_name)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "Number & name of axisymmetric coils","character", "coil_name")
  ENDIF

  IF(ALLOCATED(ss%coil_in_circuit)) THEN
     CALL ps_namwr(ilun_namel, &
          "circuit to which each coil belongs","character", &
          "coil_in_circuit", ss%NCOILS, ss%coil_in_circuit)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "circuit to which each coil belongs","character", "coil_in_circuit")
  ENDIF

  IF(ALLOCATED(ss%Rloc_coil)) THEN
     CALL ps_namwr(ilun_namel, &
          "R location of coil, lower left corner","m", &
          "Rloc_coil", ss%NCOILS, ss%Rloc_coil)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "R location of coil, lower left corner","m", "Rloc_coil")
  ENDIF

  IF(ALLOCATED(ss%Zloc_coil)) THEN
     CALL ps_namwr(ilun_namel, &
          "Z location of coil, lower left corner","m", &
          "Zloc_coil", ss%NCOILS, ss%Zloc_coil)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "Z location of coil, lower left corner","m", "Zloc_coil")
  ENDIF

  IF(ALLOCATED(ss%Hsize_coil)) THEN
     CALL ps_namwr(ilun_namel, &
          "(Rotatable) Horizontal coil base size","m", &
          "Hsize_coil", ss%NCOILS, ss%Hsize_coil)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "(Rotatable) Horizontal coil base size","m", "Hsize_coil")
  ENDIF

  IF(ALLOCATED(ss%Ang_Href_coil)) THEN
     CALL ps_namwr(ilun_namel, &
          "angle w.r.t. horizontal of coil base","degrees", &
          "Ang_Href_coil", ss%NCOILS, ss%Ang_Href_coil)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "angle w.r.t. horizontal of coil base","degrees", "Ang_Href_coil")
  ENDIF

  IF(ALLOCATED(ss%Vsize_coil)) THEN
     CALL ps_namwr(ilun_namel, &
          "(Rotatable) Vertical coil size","m", &
          "Vsize_coil", ss%NCOILS, ss%Vsize_coil)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "(Rotatable) Vertical coil size","m", "Vsize_coil")
  ENDIF

  IF(ALLOCATED(ss%Ang_Vref_coil)) THEN
     CALL ps_namwr(ilun_namel, &
          "angle w.r.t. vertical of coil sides","degrees", &
          "Ang_Vref_coil", ss%NCOILS, ss%Ang_Vref_coil)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "angle w.r.t. vertical of coil sides","degrees", "Ang_Vref_coil")
  ENDIF

  IF(ALLOCATED(ss%Nturns)) THEN
     CALL ps_namwr(ilun_namel, &
          "SIGNED number of conductor turns wrapped in each coil","integer", &
          "Nturns", ss%NCOILS, ss%Nturns)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "SIGNED number of conductor turns wrapped in each coil","integer", "Nturns")
  ENDIF

  IF(ALLOCATED(ss%VRep_coil_count)) THEN
     CALL ps_namwr(ilun_namel, &
          "replication count, vertical coil stack","integer", &
          "VRep_coil_count", ss%NCOILS, ss%VRep_coil_count)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "replication count, vertical coil stack","integer", "VRep_coil_count")
  ENDIF

  IF(ALLOCATED(ss%Vrep_coil_spacing)) THEN
     CALL ps_namwr(ilun_namel, &
          "replicated coil separation","m", &
          "Vrep_coil_spacing", ss%NCOILS, ss%Vrep_coil_spacing)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "replicated coil separation","m", "Vrep_coil_spacing")
  ENDIF

  IF(ALLOCATED(ss%coil_resispt)) THEN
     CALL ps_namwr(ilun_namel, &
          "coil resistance per turn","ohms/turn", &
          "coil_resispt", ss%NCOILS, ss%coil_resispt)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "coil resistance per turn","ohms/turn", "coil_resispt")
  ENDIF

  IF(ALLOCATED(ss%nbi_src_name)) THEN
     CALL ps_namwr(ilun_namel, &
          "number & name of neutral beams","character", &
          "nbi_src_name", ss%NBEAM, ss%nbi_src_name)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "number & name of neutral beams","character", "nbi_src_name")
  ENDIF

  IF(ALLOCATED(ss%beam_type)) THEN
     CALL ps_namwr(ilun_namel, &
          "beam type:","character", &
          "beam_type", ss%NBEAM, ss%beam_type)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "beam type:","character", "beam_type")
  ENDIF

  IF(ALLOCATED(ss%sRtcen)) THEN
     CALL ps_namwr(ilun_namel, &
          "signed tangency radius","m", &
          "sRtcen", ss%NBEAM, ss%sRtcen)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "signed tangency radius","m", "sRtcen")
  ENDIF

  IF(ALLOCATED(ss%Lbsctan)) THEN
     CALL ps_namwr(ilun_namel, &
          "distance, source to tangency point","m", &
          "Lbsctan", ss%NBEAM, ss%Lbsctan)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "distance, source to tangency point","m", "Lbsctan")
  ENDIF

  IF(ALLOCATED(ss%Zbsc)) THEN
     CALL ps_namwr(ilun_namel, &
          "elevation of beam source","m", &
          "Zbsc", ss%NBEAM, ss%Zbsc)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "elevation of beam source","m", "Zbsc")
  ENDIF

  IF(ALLOCATED(ss%Phibsc)) THEN
     CALL ps_namwr(ilun_namel, &
          "toroidal location of beam source","degrees", &
          "Phibsc", ss%NBEAM, ss%Phibsc)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "toroidal location of beam source","degrees", "Phibsc")
  ENDIF

  IF(ALLOCATED(ss%Lbscap)) THEN
     CALL ps_namwr(ilun_namel, &
          "distance, source to aperture","m", &
          "Lbscap", ss%NBEAM, ss%Lbscap)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "distance, source to aperture","m", "Lbscap")
  ENDIF

  IF(ALLOCATED(ss%Zbap)) THEN
     CALL ps_namwr(ilun_namel, &
          "elevation of beam centerline at aperture","m", &
          "Zbap", ss%NBEAM, ss%Zbap)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "elevation of beam centerline at aperture","m", "Zbap")
  ENDIF

  IF(ALLOCATED(ss%nbshape)) THEN
     CALL ps_namwr(ilun_namel, &
          "shape keyword for beam source grid","character", &
          "nbshape", ss%NBEAM, ss%nbshape)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "shape keyword for beam source grid","character", "nbshape")
  ENDIF

  IF(ALLOCATED(ss%b_halfwidth)) THEN
     CALL ps_namwr(ilun_namel, &
          "beam half-width at source","m", &
          "b_halfwidth", ss%NBEAM, ss%b_halfwidth)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "beam half-width at source","m", "b_halfwidth")
  ENDIF

  IF(ALLOCATED(ss%b_halfHeight)) THEN
     CALL ps_namwr(ilun_namel, &
          "beam half-height at source","m", &
          "b_halfHeight", ss%NBEAM, ss%b_halfHeight)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "beam half-height at source","m", "b_halfHeight")
  ENDIF

  IF(ALLOCATED(ss%b_Hfocal_length)) THEN
     CALL ps_namwr(ilun_namel, &
          "horizontal focal length","m", &
          "b_Hfocal_length", ss%NBEAM, ss%b_Hfocal_length)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "horizontal focal length","m", "b_Hfocal_length")
  ENDIF

  IF(ALLOCATED(ss%b_Vfocal_length)) THEN
     CALL ps_namwr(ilun_namel, &
          "vertical focal length","m", &
          "b_Vfocal_length", ss%NBEAM, ss%b_Vfocal_length)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "vertical focal length","m", "b_Vfocal_length")
  ENDIF

  IF(ALLOCATED(ss%b_Hdivergence)) THEN
     CALL ps_namwr(ilun_namel, &
          "horizontal divergence (D) of beam","degrees", &
          "b_Hdivergence", ss%NBEAM, ss%b_Hdivergence)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "horizontal divergence (D) of beam","degrees", "b_Hdivergence")
  ENDIF

  IF(ALLOCATED(ss%b_Vdivergence)) THEN
     CALL ps_namwr(ilun_namel, &
          "vertical divergence (D) of beam","degrees", &
          "b_Vdivergence", ss%NBEAM, ss%b_Vdivergence)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "vertical divergence (D) of beam","degrees", "b_Vdivergence")
  ENDIF

  IF(ALLOCATED(ss%nbap_shape)) THEN
     CALL ps_namwr(ilun_namel, &
          "shape keyword for beam aperture","character", &
          "nbap_shape", ss%NBEAM, ss%nbap_shape)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "shape keyword for beam aperture","character", "nbap_shape")
  ENDIF

  IF(ALLOCATED(ss%ap_halfwidth)) THEN
     CALL ps_namwr(ilun_namel, &
          "aperture half-width","m", &
          "ap_halfwidth", ss%NBEAM, ss%ap_halfwidth)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "aperture half-width","m", "ap_halfwidth")
  ENDIF

  IF(ALLOCATED(ss%ap_halfheight)) THEN
     CALL ps_namwr(ilun_namel, &
          "aperture half-height","m", &
          "ap_halfheight", ss%NBEAM, ss%ap_halfheight)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "aperture half-height","m", "ap_halfheight")
  ENDIF

  IF(ALLOCATED(ss%ap_horiz_offset)) THEN
     CALL ps_namwr(ilun_namel, &
          "horizontal offset of aperture","m", &
          "ap_horiz_offset", ss%NBEAM, ss%ap_horiz_offset)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "horizontal offset of aperture","m", "ap_horiz_offset")
  ENDIF

  IF(ALLOCATED(ss%ap_vert_offset)) THEN
     CALL ps_namwr(ilun_namel, &
          "vertical offset of aperture","m", &
          "ap_vert_offset", ss%NBEAM, ss%ap_vert_offset)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "vertical offset of aperture","m", "ap_vert_offset")
  ENDIF

  IF(ALLOCATED(ss%nbap2_shape)) THEN
     CALL ps_namwr(ilun_namel, &
          "keyword for optional 2nd aperture","character", &
          "nbap2_shape", ss%NBEAM, ss%nbap2_shape)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "keyword for optional 2nd aperture","character", "nbap2_shape")
  ENDIF

  IF(ALLOCATED(ss%Lbscap2)) THEN
     CALL ps_namwr(ilun_namel, &
          "distance, source to 2nd aperture","m", &
          "Lbscap2", ss%NBEAM, ss%Lbscap2)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "distance, source to 2nd aperture","m", "Lbscap2")
  ENDIF

  IF(ALLOCATED(ss%ap2_halfwidth)) THEN
     CALL ps_namwr(ilun_namel, &
          "2nd aperture half-width","m", &
          "ap2_halfwidth", ss%NBEAM, ss%ap2_halfwidth)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "2nd aperture half-width","m", "ap2_halfwidth")
  ENDIF

  IF(ALLOCATED(ss%ap2_halfheight)) THEN
     CALL ps_namwr(ilun_namel, &
          "aperture half-height","m", &
          "ap2_halfheight", ss%NBEAM, ss%ap2_halfheight)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "aperture half-height","m", "ap2_halfheight")
  ENDIF

  IF(ALLOCATED(ss%ap2_horiz_offset)) THEN
     CALL ps_namwr(ilun_namel, &
          "horizontal offset, 2nd aperture","m", &
          "ap2_horiz_offset", ss%NBEAM, ss%ap2_horiz_offset)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "horizontal offset, 2nd aperture","m", "ap2_horiz_offset")
  ENDIF

  IF(ALLOCATED(ss%ap2_vert_offset)) THEN
     CALL ps_namwr(ilun_namel, &
          "vertical offset, 2nd aperture","m", &
          "ap2_vert_offset", ss%NBEAM, ss%ap2_vert_offset)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "vertical offset, 2nd aperture","m", "ap2_vert_offset")
  ENDIF

  IF(ALLOCATED(ss%Einj_min)) THEN
     CALL ps_namwr(ilun_namel, &
          "minimum injection energy","keV", &
          "Einj_min", ss%NBEAM, ss%Einj_min)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "minimum injection energy","keV", "Einj_min")
  ENDIF

  IF(ALLOCATED(ss%Einj_max)) THEN
     CALL ps_namwr(ilun_namel, &
          "maximum injection energy","keV", &
          "Einj_max", ss%NBEAM, ss%Einj_max)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "maximum injection energy","keV", "Einj_max")
  ENDIF

  CALL ps_namwr(ilun_namel, &
       "no. pts in H beam energy fractions table","integer", &
       "n_H_einj_standard", ss%n_H_einj_standard)

  CALL ps_namwr(ilun_namel, &
       "no. pts in D beam energy fractions table","integer", &
       "n_D_einj_standard", ss%n_D_einj_standard)

  CALL ps_namwr(ilun_namel, &
       "no. pts in T beam energy fractions table","integer", &
       "n_T_einj_standard", ss%n_T_einj_standard)

  IF(ALLOCATED(ss%H_einj_standard)) THEN
     CALL ps_namwr(ilun_namel, &
          "H beam table energies","keV", &
          "H_einj_standard", ss%N_H_EINJ_STANDARD, ss%H_einj_standard)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "H beam table energies","keV", "H_einj_standard")
  ENDIF

  IF(ALLOCATED(ss%H_ffull_standard)) THEN
     CALL ps_namwr(ilun_namel, &
          "H beam full energy fractions","-", &
          "H_ffull_standard", ss%N_H_EINJ_STANDARD, ss%H_ffull_standard)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "H beam full energy fractions","-", "H_ffull_standard")
  ENDIF

  IF(ALLOCATED(ss%H_fhalf_standard)) THEN
     CALL ps_namwr(ilun_namel, &
          "H beam half energy fractions","-", &
          "H_fhalf_standard", ss%N_H_EINJ_STANDARD, ss%H_fhalf_standard)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "H beam half energy fractions","-", "H_fhalf_standard")
  ENDIF

  IF(ALLOCATED(ss%D_einj_standard)) THEN
     CALL ps_namwr(ilun_namel, &
          "D beam table energies","keV", &
          "D_einj_standard", ss%N_D_EINJ_STANDARD, ss%D_einj_standard)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "D beam table energies","keV", "D_einj_standard")
  ENDIF

  IF(ALLOCATED(ss%D_ffull_standard)) THEN
     CALL ps_namwr(ilun_namel, &
          "D beam full energy fractions","-", &
          "D_ffull_standard", ss%N_D_EINJ_STANDARD, ss%D_ffull_standard)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "D beam full energy fractions","-", "D_ffull_standard")
  ENDIF

  IF(ALLOCATED(ss%D_fhalf_standard)) THEN
     CALL ps_namwr(ilun_namel, &
          "D beam half energy fractions","-", &
          "D_fhalf_standard", ss%N_D_EINJ_STANDARD, ss%D_fhalf_standard)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "D beam half energy fractions","-", "D_fhalf_standard")
  ENDIF

  IF(ALLOCATED(ss%T_einj_standard)) THEN
     CALL ps_namwr(ilun_namel, &
          "T beam table energies","keV", &
          "T_einj_standard", ss%N_T_EINJ_STANDARD, ss%T_einj_standard)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "T beam table energies","keV", "T_einj_standard")
  ENDIF

  IF(ALLOCATED(ss%T_ffull_standard)) THEN
     CALL ps_namwr(ilun_namel, &
          "T beam full energy fractions","-", &
          "T_ffull_standard", ss%N_T_EINJ_STANDARD, ss%T_ffull_standard)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "T beam full energy fractions","-", "T_ffull_standard")
  ENDIF

  IF(ALLOCATED(ss%T_fhalf_standard)) THEN
     CALL ps_namwr(ilun_namel, &
          "T beam half energy fractions","-", &
          "T_fhalf_standard", ss%N_T_EINJ_STANDARD, ss%T_fhalf_standard)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "T beam half energy fractions","-", "T_fhalf_standard")
  ENDIF

  IF(ALLOCATED(ss%icrf_src_name)) THEN
     CALL ps_namwr(ilun_namel, &
          "number & name of ICRF sources","character", &
          "icrf_src_name", ss%NICRF_SRC, ss%icrf_src_name)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "number & name of ICRF sources","character", "icrf_src_name")
  ENDIF

  IF(ALLOCATED(ss%ant_model)) THEN
     CALL ps_namwr(ilun_namel, &
          "antenna model filenames (1 per antenna source)","character", &
          "ant_model", ss%NICRF_SRC, ss%ant_model)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "antenna model filenames (1 per antenna source)","character", "ant_model")
  ENDIF

  IF(ALLOCATED(ss%nrz_antgeo)) THEN
     CALL ps_namwr(ilun_namel, &
          "number of (R,Z) points, antenna geometries","integer", &
          "nrz_antgeo", ss%NICRF_SRC, ss%nrz_antgeo)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "number of (R,Z) points, antenna geometries","integer", "nrz_antgeo")
  ENDIF

  CALL ps_namwr(ilun_namel, &
       "Maximum size of variable length enumeration: NRZ_ANTGEO","integer", &
       "max_nrz_antgeo", ss%max_nrz_antgeo)

  IF(ALLOCATED(ss%R_antgeo)) THEN
     ALLOCATE(isize_vec(ss%NICRF_SRC))
     isize_vec = ss%NRZ_ANTGEO
     CALL ps_namwr(ilun_namel, &
          "antenna geo: R pts","m", &
          "R_antgeo", isize_vec, ss%R_antgeo)
     DEALLOCATE(isize_vec)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "antenna geo: R pts","m", "R_antgeo")
  ENDIF

  IF(ALLOCATED(ss%Z_antgeo)) THEN
     ALLOCATE(isize_vec(ss%NICRF_SRC))
     isize_vec = ss%NRZ_ANTGEO
     CALL ps_namwr(ilun_namel, &
          "antenna geo: Z pts","m", &
          "Z_antgeo", isize_vec, ss%Z_antgeo)
     DEALLOCATE(isize_vec)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "antenna geo: Z pts","m", "Z_antgeo")
  ENDIF

  IF(ALLOCATED(ss%dx_fshield)) THEN
     CALL ps_namwr(ilun_namel, &
          "distance, antenna to Faraday shield","m", &
          "dx_fshield", ss%NICRF_SRC, ss%dx_fshield)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "distance, antenna to Faraday shield","m", "dx_fshield")
  ENDIF

  IF(ALLOCATED(ss%ecrf_src_name)) THEN
     CALL ps_namwr(ilun_namel, &
          "number & name of ECRF sources","character", &
          "ecrf_src_name", ss%NECRF_SRC, ss%ecrf_src_name)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "number & name of ECRF sources","character", "ecrf_src_name")
  ENDIF

  IF(ALLOCATED(ss%R_EC_launch)) THEN
     CALL ps_namwr(ilun_namel, &
          "R of center of launcher","m", &
          "R_EC_launch", ss%NECRF_SRC, ss%R_EC_launch)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "R of center of launcher","m", "R_EC_launch")
  ENDIF

  IF(ALLOCATED(ss%Z_EC_launch)) THEN
     CALL ps_namwr(ilun_namel, &
          "Z of center of launcher","m", &
          "Z_EC_launch", ss%NECRF_SRC, ss%Z_EC_launch)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "Z of center of launcher","m", "Z_EC_launch")
  ENDIF

  IF(ALLOCATED(ss%Phi_EC_launch)) THEN
     CALL ps_namwr(ilun_namel, &
          "Phi of center of launcher","degrees", &
          "Phi_EC_launch", ss%NECRF_SRC, ss%Phi_EC_launch)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "Phi of center of launcher","degrees", "Phi_EC_launch")
  ENDIF

  IF(ALLOCATED(ss%EC_PRINC_WIDTH_HOR)) THEN
     CALL ps_namwr(ilun_namel, &
          "principal beam width in horizontal direction","m", &
          "EC_PRINC_WIDTH_HOR", ss%NECRF_SRC, ss%EC_PRINC_WIDTH_HOR)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "principal beam width in horizontal direction","m", "EC_PRINC_WIDTH_HOR")
  ENDIF

  IF(ALLOCATED(ss%EC_PRINC_WIDTH_VERT)) THEN
     CALL ps_namwr(ilun_namel, &
          "principal beam width in vertical direction","m", &
          "EC_PRINC_WIDTH_VERT", ss%NECRF_SRC, ss%EC_PRINC_WIDTH_VERT)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "principal beam width in vertical direction","m", "EC_PRINC_WIDTH_VERT")
  ENDIF

  IF(ALLOCATED(ss%EC_PRINC_CURV_HOR)) THEN
     CALL ps_namwr(ilun_namel, &
          "principal curvature in horizontal direction","m", &
          "EC_PRINC_CURV_HOR", ss%NECRF_SRC, ss%EC_PRINC_CURV_HOR)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "principal curvature in horizontal direction","m", "EC_PRINC_CURV_HOR")
  ENDIF

  IF(ALLOCATED(ss%EC_PRINC_CURV_VERT)) THEN
     CALL ps_namwr(ilun_namel, &
          "principal curvature in vertical direction","m", &
          "EC_PRINC_CURV_VERT", ss%NECRF_SRC, ss%EC_PRINC_CURV_VERT)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "principal curvature in vertical direction","m", "EC_PRINC_CURV_VERT")
  ENDIF

  IF(ALLOCATED(ss%EC_Half_Power_Angle)) THEN
     CALL ps_namwr(ilun_namel, &
          "Divergence of EC beam","degrees", &
          "EC_Half_Power_Angle", ss%NECRF_SRC, ss%EC_Half_Power_Angle)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "Divergence of EC beam","degrees", "EC_Half_Power_Angle")
  ENDIF

  IF(ALLOCATED(ss%EC_Beam_Elongation)) THEN
     CALL ps_namwr(ilun_namel, &
          "EC beam ellipticity","-", &
          "EC_Beam_Elongation", ss%NECRF_SRC, ss%EC_Beam_Elongation)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "EC beam ellipticity","-", "EC_Beam_Elongation")
  ENDIF

  IF(ALLOCATED(ss%lhrf_src_name)) THEN
     CALL ps_namwr(ilun_namel, &
          "number & name of LHRF sources","character", &
          "lhrf_src_name", ss%NLHRF_SRC, ss%lhrf_src_name)
  ELSE
     CALL ps_namwr(ilun_namel, &
          "number & name of LHRF sources","character", "lhrf_src_name")
  ENDIF

  CALL ps_namwr(ilun_namel, &
       "number of TF coils","integer", &
       "ntf_coils", ss%ntf_coils)

  CALL ps_namwr(ilun_namel, &
       "number of TF coils involved in inducing 2nd component","integer", &
       "ntf_coil2", ss%ntf_coil2)


  WRITE(ilun_namel,'(" /")')
  CLOSE(UNIT=ilun_namel)

END SUBROUTINE ps_mdescr_namelist_write

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


SUBROUTINE plasma_state_merge_5(cclist,w1,ss1,ss2,ss3,icheck,iout,ierr)


  ! Merge floating point data
  !   ss3 <-- w1*ss1 + (1-w1)*ss2

  USE plasma_state_definition_mod
  IMPLICIT NONE

  INTEGER, INTENT(IN) :: cclist(ps_ccount)
                                ! list of components to merge
                                ! use ps_cc_all to merge all components

  REAL(KIND=rspec) :: w1        ! weight on ss1
  TYPE (plasma_state) :: ss1    ! state data to copy *from* with weight (w1)
  TYPE (plasma_state) :: ss2    ! state data to copy *from* with weight (1-w1)
  TYPE (plasma_state) :: ss3    ! state to which data is copied.
  INTEGER, INTENT(IN) :: icheck ! control for checking match of non-floating-
  !  point data: ps_ignore, ps_warn, or ps_error on mismatch.

  INTEGER, INTENT(IN) :: iout
  INTEGER, INTENT(INOUT) :: ierr  ! completion code (not cleared,set on error)

  !-------------------
  INTEGER :: isize
  !-------------------

  !-----------------------------------------------
  ! copy scalars and arrays that are allocated...

  IF(cclist(ps_cnum_RIPPLE).EQ.1) THEN

     CALL ps_diff("ntf_coils",ss1%ntf_coils,ss2%ntf_coils,icheck,iout,ierr)
     ss3%ntf_coils = ss1%ntf_coils
  ENDIF

  IF((ALLOCATED(ss3%nthinlh)).AND.(cclist(ps_cnum_LH).EQ.1)) THEN
     IF(ALLOCATED(ss1%nthinlh).AND.ALLOCATED(ss2%nthinlh)) THEN
        CALL ps_diff("nthinlh",ss1%nthinlh,ss2%nthinlh,icheck,iout,ierr)
        CALL ps_conformal("nthinlh",ss1%nthinlh,ss3%nthinlh,iout,ierr)
        if(ierr.eq.0) ss3%nthinlh = ss1%nthinlh
     ELSE IF(ALLOCATED(ss1%nthinlh)) THEN
        CALL ps_conformal("nthinlh",ss1%nthinlh,ss3%nthinlh,iout,ierr)
        ss3%nthinlh = ss1%nthinlh
     ELSE IF(ALLOCATED(ss2%nthinlh)) THEN
        CALL ps_conformal("nthinlh",ss2%nthinlh,ss3%nthinlh,iout,ierr)
        ss3%nthinlh = ss2%nthinlh
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%Nturns)).AND.(cclist(ps_cnum_EQ).EQ.1)) THEN
     IF(ALLOCATED(ss1%Nturns).AND.ALLOCATED(ss2%Nturns)) THEN
        CALL ps_diff("Nturns",ss1%Nturns,ss2%Nturns,icheck,iout,ierr)
        CALL ps_conformal("Nturns",ss1%Nturns,ss3%Nturns,iout,ierr)
        if(ierr.eq.0) ss3%Nturns = ss1%Nturns
     ELSE IF(ALLOCATED(ss1%Nturns)) THEN
        CALL ps_conformal("Nturns",ss1%Nturns,ss3%Nturns,iout,ierr)
        ss3%Nturns = ss1%Nturns
     ELSE IF(ALLOCATED(ss2%Nturns)) THEN
        CALL ps_conformal("Nturns",ss2%Nturns,ss3%Nturns,iout,ierr)
        ss3%Nturns = ss2%Nturns
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%num_nphi)).AND.(cclist(ps_cnum_IC).EQ.1)) THEN
     IF(ALLOCATED(ss1%num_nphi).AND.ALLOCATED(ss2%num_nphi)) THEN
        CALL ps_diff("num_nphi",ss1%num_nphi,ss2%num_nphi,icheck,iout,ierr)
        CALL ps_conformal("num_nphi",ss1%num_nphi,ss3%num_nphi,iout,ierr)
        if(ierr.eq.0) ss3%num_nphi = ss1%num_nphi
     ELSE IF(ALLOCATED(ss1%num_nphi)) THEN
        CALL ps_conformal("num_nphi",ss1%num_nphi,ss3%num_nphi,iout,ierr)
        ss3%num_nphi = ss1%num_nphi
     ELSE IF(ALLOCATED(ss2%num_nphi)) THEN
        CALL ps_conformal("num_nphi",ss2%num_nphi,ss3%num_nphi,iout,ierr)
        ss3%num_nphi = ss2%num_nphi
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%num_nphi_vac)).AND.(cclist(ps_cnum_IC).EQ.1)) THEN
     IF(ALLOCATED(ss1%num_nphi_vac).AND.ALLOCATED(ss2%num_nphi_vac)) THEN
        CALL ps_diff("num_nphi_vac",ss1%num_nphi_vac,ss2%num_nphi_vac,icheck,iout,ierr)
        CALL ps_conformal("num_nphi_vac",ss1%num_nphi_vac,ss3%num_nphi_vac,iout,ierr)
        if(ierr.eq.0) ss3%num_nphi_vac = ss1%num_nphi_vac
     ELSE IF(ALLOCATED(ss1%num_nphi_vac)) THEN
        CALL ps_conformal("num_nphi_vac",ss1%num_nphi_vac,ss3%num_nphi_vac,iout,ierr)
        ss3%num_nphi_vac = ss1%num_nphi_vac
     ELSE IF(ALLOCATED(ss2%num_nphi_vac)) THEN
        CALL ps_conformal("num_nphi_vac",ss2%num_nphi_vac,ss3%num_nphi_vac,iout,ierr)
        ss3%num_nphi_vac = ss2%num_nphi_vac
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%nzflux_ky_tglf)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%nzflux_ky_tglf).AND.ALLOCATED(ss2%nzflux_ky_tglf)) THEN
        CALL ps_conformal("nzflux_ky_tglf",ss2%nzflux_ky_tglf,ss3%nzflux_ky_tglf,iout,ierr)
        CALL ps_conformal("nzflux_ky_tglf",ss1%nzflux_ky_tglf,ss3%nzflux_ky_tglf,iout,ierr)
        if(ierr.eq.0) ss3%nzflux_ky_tglf = w1*ss1%nzflux_ky_tglf + (1.0_rspec-w1)*ss2%nzflux_ky_tglf
     ELSE IF(ALLOCATED(ss1%nzflux_ky_tglf)) THEN
        CALL ps_conformal("nzflux_ky_tglf",ss1%nzflux_ky_tglf,ss3%nzflux_ky_tglf,iout,ierr)
        ss3%nzflux_ky_tglf = ss1%nzflux_ky_tglf
     ELSE IF(ALLOCATED(ss2%nzflux_ky_tglf)) THEN
        CALL ps_conformal("nzflux_ky_tglf",ss2%nzflux_ky_tglf,ss3%nzflux_ky_tglf,iout,ierr)
        ss3%nzflux_ky_tglf = ss2%nzflux_ky_tglf
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%nz_ky_tglf)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%nz_ky_tglf).AND.ALLOCATED(ss2%nz_ky_tglf)) THEN
        CALL ps_conformal("nz_ky_tglf",ss2%nz_ky_tglf,ss3%nz_ky_tglf,iout,ierr)
        CALL ps_conformal("nz_ky_tglf",ss1%nz_ky_tglf,ss3%nz_ky_tglf,iout,ierr)
        if(ierr.eq.0) ss3%nz_ky_tglf = w1*ss1%nz_ky_tglf + (1.0_rspec-w1)*ss2%nz_ky_tglf
     ELSE IF(ALLOCATED(ss1%nz_ky_tglf)) THEN
        CALL ps_conformal("nz_ky_tglf",ss1%nz_ky_tglf,ss3%nz_ky_tglf,iout,ierr)
        ss3%nz_ky_tglf = ss1%nz_ky_tglf
     ELSE IF(ALLOCATED(ss2%nz_ky_tglf)) THEN
        CALL ps_conformal("nz_ky_tglf",ss2%nz_ky_tglf,ss3%nz_ky_tglf,iout,ierr)
        ss3%nz_ky_tglf = ss2%nz_ky_tglf
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%n_straps)).AND.(cclist(ps_cnum_IC).EQ.1)) THEN
     IF(ALLOCATED(ss1%n_straps).AND.ALLOCATED(ss2%n_straps)) THEN
        CALL ps_diff("n_straps",ss1%n_straps,ss2%n_straps,icheck,iout,ierr)
        CALL ps_conformal("n_straps",ss1%n_straps,ss3%n_straps,iout,ierr)
        if(ierr.eq.0) ss3%n_straps = ss1%n_straps
     ELSE IF(ALLOCATED(ss1%n_straps)) THEN
        CALL ps_conformal("n_straps",ss1%n_straps,ss3%n_straps,iout,ierr)
        ss3%n_straps = ss1%n_straps
     ELSE IF(ALLOCATED(ss2%n_straps)) THEN
        CALL ps_conformal("n_straps",ss2%n_straps,ss3%n_straps,iout,ierr)
        ss3%n_straps = ss2%n_straps
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%omeg0cx)).AND.(cclist(ps_cnum_GAS).EQ.1)) THEN
     IF(ALLOCATED(ss1%omeg0cx).AND.ALLOCATED(ss2%omeg0cx)) THEN
        CALL ps_conformal("omeg0cx",ss2%omeg0cx,ss3%omeg0cx,iout,ierr)
        CALL ps_conformal("omeg0cx",ss1%omeg0cx,ss3%omeg0cx,iout,ierr)
        if(ierr.eq.0) ss3%omeg0cx = w1*ss1%omeg0cx + (1.0_rspec-w1)*ss2%omeg0cx
     ELSE IF(ALLOCATED(ss1%omeg0cx)) THEN
        CALL ps_conformal("omeg0cx",ss1%omeg0cx,ss3%omeg0cx,iout,ierr)
        ss3%omeg0cx = ss1%omeg0cx
     ELSE IF(ALLOCATED(ss2%omeg0cx)) THEN
        CALL ps_conformal("omeg0cx",ss2%omeg0cx,ss3%omeg0cx,iout,ierr)
        ss3%omeg0cx = ss2%omeg0cx
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%omeg0sc0)).AND.(cclist(ps_cnum_GAS).EQ.1)) THEN
     IF(ALLOCATED(ss1%omeg0sc0).AND.ALLOCATED(ss2%omeg0sc0)) THEN
        CALL ps_conformal("omeg0sc0",ss2%omeg0sc0,ss3%omeg0sc0,iout,ierr)
        CALL ps_conformal("omeg0sc0",ss1%omeg0sc0,ss3%omeg0sc0,iout,ierr)
        if(ierr.eq.0) ss3%omeg0sc0 = w1*ss1%omeg0sc0 + (1.0_rspec-w1)*ss2%omeg0sc0
     ELSE IF(ALLOCATED(ss1%omeg0sc0)) THEN
        CALL ps_conformal("omeg0sc0",ss1%omeg0sc0,ss3%omeg0sc0,iout,ierr)
        ss3%omeg0sc0 = ss1%omeg0sc0
     ELSE IF(ALLOCATED(ss2%omeg0sc0)) THEN
        CALL ps_conformal("omeg0sc0",ss2%omeg0sc0,ss3%omeg0sc0,iout,ierr)
        ss3%omeg0sc0 = ss2%omeg0sc0
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%omeg0_halo)).AND.(cclist(ps_cnum_NBI).EQ.1)) THEN
     IF(ALLOCATED(ss1%omeg0_halo).AND.ALLOCATED(ss2%omeg0_halo)) THEN
        CALL ps_conformal("omeg0_halo",ss2%omeg0_halo,ss3%omeg0_halo,iout,ierr)
        CALL ps_conformal("omeg0_halo",ss1%omeg0_halo,ss3%omeg0_halo,iout,ierr)
        if(ierr.eq.0) ss3%omeg0_halo = w1*ss1%omeg0_halo + (1.0_rspec-w1)*ss2%omeg0_halo
     ELSE IF(ALLOCATED(ss1%omeg0_halo)) THEN
        CALL ps_conformal("omeg0_halo",ss1%omeg0_halo,ss3%omeg0_halo,iout,ierr)
        ss3%omeg0_halo = ss1%omeg0_halo
     ELSE IF(ALLOCATED(ss2%omeg0_halo)) THEN
        CALL ps_conformal("omeg0_halo",ss2%omeg0_halo,ss3%omeg0_halo,iout,ierr)
        ss3%omeg0_halo = ss2%omeg0_halo
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%omeg0_reco)).AND.(cclist(ps_cnum_GAS).EQ.1)) THEN
     IF(ALLOCATED(ss1%omeg0_reco).AND.ALLOCATED(ss2%omeg0_reco)) THEN
        CALL ps_conformal("omeg0_reco",ss2%omeg0_reco,ss3%omeg0_reco,iout,ierr)
        CALL ps_conformal("omeg0_reco",ss1%omeg0_reco,ss3%omeg0_reco,iout,ierr)
        if(ierr.eq.0) ss3%omeg0_reco = w1*ss1%omeg0_reco + (1.0_rspec-w1)*ss2%omeg0_reco
     ELSE IF(ALLOCATED(ss1%omeg0_reco)) THEN
        CALL ps_conformal("omeg0_reco",ss1%omeg0_reco,ss3%omeg0_reco,iout,ierr)
        ss3%omeg0_reco = ss1%omeg0_reco
     ELSE IF(ALLOCATED(ss2%omeg0_reco)) THEN
        CALL ps_conformal("omeg0_reco",ss2%omeg0_reco,ss3%omeg0_reco,iout,ierr)
        ss3%omeg0_reco = ss2%omeg0_reco
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%omegat)).AND.(cclist(ps_cnum_PLASMA).EQ.1)) THEN
     IF(ALLOCATED(ss1%omegat).AND.ALLOCATED(ss2%omegat)) THEN
        CALL ps_conformal("omegat",ss2%omegat,ss3%omegat,iout,ierr)
        CALL ps_conformal("omegat",ss1%omegat,ss3%omegat,iout,ierr)
        if(ierr.eq.0) ss3%omegat = w1*ss1%omegat + (1.0_rspec-w1)*ss2%omegat
     ELSE IF(ALLOCATED(ss1%omegat)) THEN
        CALL ps_conformal("omegat",ss1%omegat,ss3%omegat,iout,ierr)
        ss3%omegat = ss1%omegat
     ELSE IF(ALLOCATED(ss2%omegat)) THEN
        CALL ps_conformal("omegat",ss2%omegat,ss3%omegat,iout,ierr)
        ss3%omegat = ss2%omegat
     ENDIF
  ENDIF

  IF(cclist(ps_cnum_PLASMA).EQ.1) THEN
     ss3%omegat_bdy = w1*ss1%omegat_bdy + (1.0_rspec-w1)*ss2%omegat_bdy
  ENDIF

  IF((ALLOCATED(ss3%omega_exb)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%omega_exb).AND.ALLOCATED(ss2%omega_exb)) THEN
        CALL ps_conformal("omega_exb",ss2%omega_exb,ss3%omega_exb,iout,ierr)
        CALL ps_conformal("omega_exb",ss1%omega_exb,ss3%omega_exb,iout,ierr)
        if(ierr.eq.0) ss3%omega_exb = w1*ss1%omega_exb + (1.0_rspec-w1)*ss2%omega_exb
     ELSE IF(ALLOCATED(ss1%omega_exb)) THEN
        CALL ps_conformal("omega_exb",ss1%omega_exb,ss3%omega_exb,iout,ierr)
        ss3%omega_exb = ss1%omega_exb
     ELSE IF(ALLOCATED(ss2%omega_exb)) THEN
        CALL ps_conformal("omega_exb",ss2%omega_exb,ss3%omega_exb,iout,ierr)
        ss3%omega_exb = ss2%omega_exb
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%p0_reco)).AND.(cclist(ps_cnum_GAS).EQ.1)) THEN
     IF(ALLOCATED(ss1%p0_reco).AND.ALLOCATED(ss2%p0_reco)) THEN
        CALL ps_conformal("p0_reco",ss2%p0_reco,ss3%p0_reco,iout,ierr)
        CALL ps_conformal("p0_reco",ss1%p0_reco,ss3%p0_reco,iout,ierr)
        if(ierr.eq.0) ss3%p0_reco = w1*ss1%p0_reco + (1.0_rspec-w1)*ss2%p0_reco
     ELSE IF(ALLOCATED(ss1%p0_reco)) THEN
        CALL ps_conformal("p0_reco",ss1%p0_reco,ss3%p0_reco,iout,ierr)
        ss3%p0_reco = ss1%p0_reco
     ELSE IF(ALLOCATED(ss2%p0_reco)) THEN
        CALL ps_conformal("p0_reco",ss2%p0_reco,ss3%p0_reco,iout,ierr)
        ss3%p0_reco = ss2%p0_reco
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%pb0_halo)).AND.(cclist(ps_cnum_NBI).EQ.1)) THEN
     IF(ALLOCATED(ss1%pb0_halo).AND.ALLOCATED(ss2%pb0_halo)) THEN
        CALL ps_conformal("pb0_halo",ss2%pb0_halo,ss3%pb0_halo,iout,ierr)
        CALL ps_conformal("pb0_halo",ss1%pb0_halo,ss3%pb0_halo,iout,ierr)
        if(ierr.eq.0) ss3%pb0_halo = w1*ss1%pb0_halo + (1.0_rspec-w1)*ss2%pb0_halo
     ELSE IF(ALLOCATED(ss1%pb0_halo)) THEN
        CALL ps_conformal("pb0_halo",ss1%pb0_halo,ss3%pb0_halo,iout,ierr)
        ss3%pb0_halo = ss1%pb0_halo
     ELSE IF(ALLOCATED(ss2%pb0_halo)) THEN
        CALL ps_conformal("pb0_halo",ss2%pb0_halo,ss3%pb0_halo,iout,ierr)
        ss3%pb0_halo = ss2%pb0_halo
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%pbe)).AND.(cclist(ps_cnum_NBI).EQ.1)) THEN
     IF(ALLOCATED(ss1%pbe).AND.ALLOCATED(ss2%pbe)) THEN
        CALL ps_conformal("pbe",ss2%pbe,ss3%pbe,iout,ierr)
        CALL ps_conformal("pbe",ss1%pbe,ss3%pbe,iout,ierr)
        if(ierr.eq.0) ss3%pbe = w1*ss1%pbe + (1.0_rspec-w1)*ss2%pbe
     ELSE IF(ALLOCATED(ss1%pbe)) THEN
        CALL ps_conformal("pbe",ss1%pbe,ss3%pbe,iout,ierr)
        ss3%pbe = ss1%pbe
     ELSE IF(ALLOCATED(ss2%pbe)) THEN
        CALL ps_conformal("pbe",ss2%pbe,ss3%pbe,iout,ierr)
        ss3%pbe = ss2%pbe
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%pbi)).AND.(cclist(ps_cnum_NBI).EQ.1)) THEN
     IF(ALLOCATED(ss1%pbi).AND.ALLOCATED(ss2%pbi)) THEN
        CALL ps_conformal("pbi",ss2%pbi,ss3%pbi,iout,ierr)
        CALL ps_conformal("pbi",ss1%pbi,ss3%pbi,iout,ierr)
        if(ierr.eq.0) ss3%pbi = w1*ss1%pbi + (1.0_rspec-w1)*ss2%pbi
     ELSE IF(ALLOCATED(ss1%pbi)) THEN
        CALL ps_conformal("pbi",ss1%pbi,ss3%pbi,iout,ierr)
        ss3%pbi = ss1%pbi
     ELSE IF(ALLOCATED(ss2%pbi)) THEN
        CALL ps_conformal("pbi",ss2%pbi,ss3%pbi,iout,ierr)
        ss3%pbi = ss2%pbi
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%pbth)).AND.(cclist(ps_cnum_NBI).EQ.1)) THEN
     IF(ALLOCATED(ss1%pbth).AND.ALLOCATED(ss2%pbth)) THEN
        CALL ps_conformal("pbth",ss2%pbth,ss3%pbth,iout,ierr)
        CALL ps_conformal("pbth",ss1%pbth,ss3%pbth,iout,ierr)
        if(ierr.eq.0) ss3%pbth = w1*ss1%pbth + (1.0_rspec-w1)*ss2%pbth
     ELSE IF(ALLOCATED(ss1%pbth)) THEN
        CALL ps_conformal("pbth",ss1%pbth,ss3%pbth,iout,ierr)
        ss3%pbth = ss1%pbth
     ELSE IF(ALLOCATED(ss2%pbth)) THEN
        CALL ps_conformal("pbth",ss2%pbth,ss3%pbth,iout,ierr)
        ss3%pbth = ss2%pbth
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%pcx_halo)).AND.(cclist(ps_cnum_NBI).EQ.1)) THEN
     IF(ALLOCATED(ss1%pcx_halo).AND.ALLOCATED(ss2%pcx_halo)) THEN
        CALL ps_conformal("pcx_halo",ss2%pcx_halo,ss3%pcx_halo,iout,ierr)
        CALL ps_conformal("pcx_halo",ss1%pcx_halo,ss3%pcx_halo,iout,ierr)
        if(ierr.eq.0) ss3%pcx_halo = w1*ss1%pcx_halo + (1.0_rspec-w1)*ss2%pcx_halo
     ELSE IF(ALLOCATED(ss1%pcx_halo)) THEN
        CALL ps_conformal("pcx_halo",ss1%pcx_halo,ss3%pcx_halo,iout,ierr)
        ss3%pcx_halo = ss1%pcx_halo
     ELSE IF(ALLOCATED(ss2%pcx_halo)) THEN
        CALL ps_conformal("pcx_halo",ss2%pcx_halo,ss3%pcx_halo,iout,ierr)
        ss3%pcx_halo = ss2%pcx_halo
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%pcx_reco)).AND.(cclist(ps_cnum_GAS).EQ.1)) THEN
     IF(ALLOCATED(ss1%pcx_reco).AND.ALLOCATED(ss2%pcx_reco)) THEN
        CALL ps_conformal("pcx_reco",ss2%pcx_reco,ss3%pcx_reco,iout,ierr)
        CALL ps_conformal("pcx_reco",ss1%pcx_reco,ss3%pcx_reco,iout,ierr)
        if(ierr.eq.0) ss3%pcx_reco = w1*ss1%pcx_reco + (1.0_rspec-w1)*ss2%pcx_reco
     ELSE IF(ALLOCATED(ss1%pcx_reco)) THEN
        CALL ps_conformal("pcx_reco",ss1%pcx_reco,ss3%pcx_reco,iout,ierr)
        ss3%pcx_reco = ss1%pcx_reco
     ELSE IF(ALLOCATED(ss2%pcx_reco)) THEN
        CALL ps_conformal("pcx_reco",ss2%pcx_reco,ss3%pcx_reco,iout,ierr)
        ss3%pcx_reco = ss2%pcx_reco
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%peech)).AND.(cclist(ps_cnum_EC).EQ.1)) THEN
     IF(ALLOCATED(ss1%peech).AND.ALLOCATED(ss2%peech)) THEN
        CALL ps_conformal("peech",ss2%peech,ss3%peech,iout,ierr)
        CALL ps_conformal("peech",ss1%peech,ss3%peech,iout,ierr)
        if(ierr.eq.0) ss3%peech = w1*ss1%peech + (1.0_rspec-w1)*ss2%peech
     ELSE IF(ALLOCATED(ss1%peech)) THEN
        CALL ps_conformal("peech",ss1%peech,ss3%peech,iout,ierr)
        ss3%peech = ss1%peech
     ELSE IF(ALLOCATED(ss2%peech)) THEN
        CALL ps_conformal("peech",ss2%peech,ss3%peech,iout,ierr)
        ss3%peech = ss2%peech
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%peech_src)).AND.(cclist(ps_cnum_EC).EQ.1)) THEN
     IF(ALLOCATED(ss1%peech_src).AND.ALLOCATED(ss2%peech_src)) THEN
        CALL ps_conformal("peech_src",ss2%peech_src,ss3%peech_src,iout,ierr)
        CALL ps_conformal("peech_src",ss1%peech_src,ss3%peech_src,iout,ierr)
        if(ierr.eq.0) ss3%peech_src = w1*ss1%peech_src + (1.0_rspec-w1)*ss2%peech_src
     ELSE IF(ALLOCATED(ss1%peech_src)) THEN
        CALL ps_conformal("peech_src",ss1%peech_src,ss3%peech_src,iout,ierr)
        ss3%peech_src = ss1%peech_src
     ELSE IF(ALLOCATED(ss2%peech_src)) THEN
        CALL ps_conformal("peech_src",ss2%peech_src,ss3%peech_src,iout,ierr)
        ss3%peech_src = ss2%peech_src
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%pelh)).AND.(cclist(ps_cnum_LH).EQ.1)) THEN
     IF(ALLOCATED(ss1%pelh).AND.ALLOCATED(ss2%pelh)) THEN
        CALL ps_conformal("pelh",ss2%pelh,ss3%pelh,iout,ierr)
        CALL ps_conformal("pelh",ss1%pelh,ss3%pelh,iout,ierr)
        if(ierr.eq.0) ss3%pelh = w1*ss1%pelh + (1.0_rspec-w1)*ss2%pelh
     ELSE IF(ALLOCATED(ss1%pelh)) THEN
        CALL ps_conformal("pelh",ss1%pelh,ss3%pelh,iout,ierr)
        ss3%pelh = ss1%pelh
     ELSE IF(ALLOCATED(ss2%pelh)) THEN
        CALL ps_conformal("pelh",ss2%pelh,ss3%pelh,iout,ierr)
        ss3%pelh = ss2%pelh
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%pelh_src)).AND.(cclist(ps_cnum_LH).EQ.1)) THEN
     IF(ALLOCATED(ss1%pelh_src).AND.ALLOCATED(ss2%pelh_src)) THEN
        CALL ps_conformal("pelh_src",ss2%pelh_src,ss3%pelh_src,iout,ierr)
        CALL ps_conformal("pelh_src",ss1%pelh_src,ss3%pelh_src,iout,ierr)
        if(ierr.eq.0) ss3%pelh_src = w1*ss1%pelh_src + (1.0_rspec-w1)*ss2%pelh_src
     ELSE IF(ALLOCATED(ss1%pelh_src)) THEN
        CALL ps_conformal("pelh_src",ss1%pelh_src,ss3%pelh_src,iout,ierr)
        ss3%pelh_src = ss1%pelh_src
     ELSE IF(ALLOCATED(ss2%pelh_src)) THEN
        CALL ps_conformal("pelh_src",ss2%pelh_src,ss3%pelh_src,iout,ierr)
        ss3%pelh_src = ss2%pelh_src
     ENDIF
  ENDIF

  IF(cclist(ps_cnum_PEL).EQ.1) THEN

     CALL ps_diff("PEL_Code_Info",ss1%PEL_Code_Info,ss2%PEL_Code_Info,icheck,iout,ierr)
     ss3%PEL_Code_Info = ss1%PEL_Code_Info
  ENDIF

  IF(cclist(ps_cnum_PEL).EQ.1) THEN

     CALL ps_diff("PEL_Data_Info",ss1%PEL_Data_Info,ss2%PEL_Data_Info,icheck,iout,ierr)
     ss3%PEL_Data_Info = ss1%PEL_Data_Info
  ENDIF

  IF((ALLOCATED(ss3%pe_anom)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%pe_anom).AND.ALLOCATED(ss2%pe_anom)) THEN
        CALL ps_conformal("pe_anom",ss2%pe_anom,ss3%pe_anom,iout,ierr)
        CALL ps_conformal("pe_anom",ss1%pe_anom,ss3%pe_anom,iout,ierr)
        if(ierr.eq.0) ss3%pe_anom = w1*ss1%pe_anom + (1.0_rspec-w1)*ss2%pe_anom
     ELSE IF(ALLOCATED(ss1%pe_anom)) THEN
        CALL ps_conformal("pe_anom",ss1%pe_anom,ss3%pe_anom,iout,ierr)
        ss3%pe_anom = ss1%pe_anom
     ELSE IF(ALLOCATED(ss2%pe_anom)) THEN
        CALL ps_conformal("pe_anom",ss2%pe_anom,ss3%pe_anom,iout,ierr)
        ss3%pe_anom = ss2%pe_anom
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%pe_trans)).AND.(cclist(ps_cnum_PLASMA).EQ.1)) THEN
     IF(ALLOCATED(ss1%pe_trans).AND.ALLOCATED(ss2%pe_trans)) THEN
        CALL ps_conformal("pe_trans",ss2%pe_trans,ss3%pe_trans,iout,ierr)
        CALL ps_conformal("pe_trans",ss1%pe_trans,ss3%pe_trans,iout,ierr)
        if(ierr.eq.0) ss3%pe_trans = w1*ss1%pe_trans + (1.0_rspec-w1)*ss2%pe_trans
     ELSE IF(ALLOCATED(ss1%pe_trans)) THEN
        CALL ps_conformal("pe_trans",ss1%pe_trans,ss3%pe_trans,iout,ierr)
        ss3%pe_trans = ss1%pe_trans
     ELSE IF(ALLOCATED(ss2%pe_trans)) THEN
        CALL ps_conformal("pe_trans",ss2%pe_trans,ss3%pe_trans,iout,ierr)
        ss3%pe_trans = ss2%pe_trans
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%pe_transcat)).AND.(cclist(ps_cnum_PLASMA).EQ.1)) THEN
     IF(ALLOCATED(ss1%pe_transcat).AND.ALLOCATED(ss2%pe_transcat)) THEN
        CALL ps_conformal("pe_transcat",ss2%pe_transcat,ss3%pe_transcat,iout,ierr)
        CALL ps_conformal("pe_transcat",ss1%pe_transcat,ss3%pe_transcat,iout,ierr)
        if(ierr.eq.0) ss3%pe_transcat = w1*ss1%pe_transcat + (1.0_rspec-w1)*ss2%pe_transcat
     ELSE IF(ALLOCATED(ss1%pe_transcat)) THEN
        CALL ps_conformal("pe_transcat",ss1%pe_transcat,ss3%pe_transcat,iout,ierr)
        ss3%pe_transcat = ss1%pe_transcat
     ELSE IF(ALLOCATED(ss2%pe_transcat)) THEN
        CALL ps_conformal("pe_transcat",ss2%pe_transcat,ss3%pe_transcat,iout,ierr)
        ss3%pe_transcat = ss2%pe_transcat
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%pfuse)).AND.(cclist(ps_cnum_FUS).EQ.1)) THEN
     IF(ALLOCATED(ss1%pfuse).AND.ALLOCATED(ss2%pfuse)) THEN
        CALL ps_conformal("pfuse",ss2%pfuse,ss3%pfuse,iout,ierr)
        CALL ps_conformal("pfuse",ss1%pfuse,ss3%pfuse,iout,ierr)
        if(ierr.eq.0) ss3%pfuse = w1*ss1%pfuse + (1.0_rspec-w1)*ss2%pfuse
     ELSE IF(ALLOCATED(ss1%pfuse)) THEN
        CALL ps_conformal("pfuse",ss1%pfuse,ss3%pfuse,iout,ierr)
        ss3%pfuse = ss1%pfuse
     ELSE IF(ALLOCATED(ss2%pfuse)) THEN
        CALL ps_conformal("pfuse",ss2%pfuse,ss3%pfuse,iout,ierr)
        ss3%pfuse = ss2%pfuse
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%pfusi)).AND.(cclist(ps_cnum_FUS).EQ.1)) THEN
     IF(ALLOCATED(ss1%pfusi).AND.ALLOCATED(ss2%pfusi)) THEN
        CALL ps_conformal("pfusi",ss2%pfusi,ss3%pfusi,iout,ierr)
        CALL ps_conformal("pfusi",ss1%pfusi,ss3%pfusi,iout,ierr)
        if(ierr.eq.0) ss3%pfusi = w1*ss1%pfusi + (1.0_rspec-w1)*ss2%pfusi
     ELSE IF(ALLOCATED(ss1%pfusi)) THEN
        CALL ps_conformal("pfusi",ss1%pfusi,ss3%pfusi,iout,ierr)
        ss3%pfusi = ss1%pfusi
     ELSE IF(ALLOCATED(ss2%pfusi)) THEN
        CALL ps_conformal("pfusi",ss2%pfusi,ss3%pfusi,iout,ierr)
        ss3%pfusi = ss2%pfusi
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%pfusth)).AND.(cclist(ps_cnum_FUS).EQ.1)) THEN
     IF(ALLOCATED(ss1%pfusth).AND.ALLOCATED(ss2%pfusth)) THEN
        CALL ps_conformal("pfusth",ss2%pfusth,ss3%pfusth,iout,ierr)
        CALL ps_conformal("pfusth",ss1%pfusth,ss3%pfusth,iout,ierr)
        if(ierr.eq.0) ss3%pfusth = w1*ss1%pfusth + (1.0_rspec-w1)*ss2%pfusth
     ELSE IF(ALLOCATED(ss1%pfusth)) THEN
        CALL ps_conformal("pfusth",ss1%pfusth,ss3%pfusth,iout,ierr)
        ss3%pfusth = ss1%pfusth
     ELSE IF(ALLOCATED(ss2%pfusth)) THEN
        CALL ps_conformal("pfusth",ss2%pfusth,ss3%pfusth,iout,ierr)
        ss3%pfusth = ss2%pfusth
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%Phibsc)).AND.(cclist(ps_cnum_NBI).EQ.1)) THEN
     IF(ALLOCATED(ss1%Phibsc).AND.ALLOCATED(ss2%Phibsc)) THEN
        CALL ps_diff("Phibsc",ss1%Phibsc,ss2%Phibsc,icheck,iout,ierr)
        CALL ps_conformal("Phibsc",ss1%Phibsc,ss3%Phibsc,iout,ierr)
        if(ierr.eq.0) ss3%Phibsc = ss1%Phibsc
     ELSE IF(ALLOCATED(ss1%Phibsc)) THEN
        CALL ps_conformal("Phibsc",ss1%Phibsc,ss3%Phibsc,iout,ierr)
        ss3%Phibsc = ss1%Phibsc
     ELSE IF(ALLOCATED(ss2%Phibsc)) THEN
        CALL ps_conformal("Phibsc",ss2%Phibsc,ss3%Phibsc,iout,ierr)
        ss3%Phibsc = ss2%Phibsc
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%phiflux_ky_tglf)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%phiflux_ky_tglf).AND.ALLOCATED(ss2%phiflux_ky_tglf)) THEN
        CALL ps_conformal("phiflux_ky_tglf",ss2%phiflux_ky_tglf,ss3%phiflux_ky_tglf,iout,ierr)
        CALL ps_conformal("phiflux_ky_tglf",ss1%phiflux_ky_tglf,ss3%phiflux_ky_tglf,iout,ierr)
        if(ierr.eq.0) ss3%phiflux_ky_tglf = w1*ss1%phiflux_ky_tglf + (1.0_rspec-w1)*ss2%phiflux_ky_tglf
     ELSE IF(ALLOCATED(ss1%phiflux_ky_tglf)) THEN
        CALL ps_conformal("phiflux_ky_tglf",ss1%phiflux_ky_tglf,ss3%phiflux_ky_tglf,iout,ierr)
        ss3%phiflux_ky_tglf = ss1%phiflux_ky_tglf
     ELSE IF(ALLOCATED(ss2%phiflux_ky_tglf)) THEN
        CALL ps_conformal("phiflux_ky_tglf",ss2%phiflux_ky_tglf,ss3%phiflux_ky_tglf,iout,ierr)
        ss3%phiflux_ky_tglf = ss2%phiflux_ky_tglf
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%phigrilh)).AND.(cclist(ps_cnum_LH).EQ.1)) THEN
     IF(ALLOCATED(ss1%phigrilh).AND.ALLOCATED(ss2%phigrilh)) THEN
        CALL ps_diff("phigrilh",ss1%phigrilh,ss2%phigrilh,icheck,iout,ierr)
        CALL ps_conformal("phigrilh",ss1%phigrilh,ss3%phigrilh,iout,ierr)
        if(ierr.eq.0) ss3%phigrilh = ss1%phigrilh
     ELSE IF(ALLOCATED(ss1%phigrilh)) THEN
        CALL ps_conformal("phigrilh",ss1%phigrilh,ss3%phigrilh,iout,ierr)
        ss3%phigrilh = ss1%phigrilh
     ELSE IF(ALLOCATED(ss2%phigrilh)) THEN
        CALL ps_conformal("phigrilh",ss2%phigrilh,ss3%phigrilh,iout,ierr)
        ss3%phigrilh = ss2%phigrilh
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%phit)).AND.(cclist(ps_cnum_EQ).EQ.1)) THEN
     IF(ALLOCATED(ss1%phit).AND.ALLOCATED(ss2%phit)) THEN
        CALL ps_conformal("phit",ss2%phit,ss3%phit,iout,ierr)
        CALL ps_conformal("phit",ss1%phit,ss3%phit,iout,ierr)
        if(ierr.eq.0) ss3%phit = w1*ss1%phit + (1.0_rspec-w1)*ss2%phit
     ELSE IF(ALLOCATED(ss1%phit)) THEN
        CALL ps_conformal("phit",ss1%phit,ss3%phit,iout,ierr)
        ss3%phit = ss1%phit
     ELSE IF(ALLOCATED(ss2%phit)) THEN
        CALL ps_conformal("phit",ss2%phit,ss3%phit,iout,ierr)
        ss3%phit = ss2%phit
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%Phi_EC_launch)).AND.(cclist(ps_cnum_EC).EQ.1)) THEN
     IF(ALLOCATED(ss1%Phi_EC_launch).AND.ALLOCATED(ss2%Phi_EC_launch)) THEN
        CALL ps_diff("Phi_EC_launch",ss1%Phi_EC_launch,ss2%Phi_EC_launch,icheck,iout,ierr)
        CALL ps_conformal("Phi_EC_launch",ss1%Phi_EC_launch,ss3%Phi_EC_launch,iout,ierr)
        if(ierr.eq.0) ss3%Phi_EC_launch = ss1%Phi_EC_launch
     ELSE IF(ALLOCATED(ss1%Phi_EC_launch)) THEN
        CALL ps_conformal("Phi_EC_launch",ss1%Phi_EC_launch,ss3%Phi_EC_launch,iout,ierr)
        ss3%Phi_EC_launch = ss1%Phi_EC_launch
     ELSE IF(ALLOCATED(ss2%Phi_EC_launch)) THEN
        CALL ps_conformal("Phi_EC_launch",ss2%Phi_EC_launch,ss3%Phi_EC_launch,iout,ierr)
        ss3%Phi_EC_launch = ss2%Phi_EC_launch
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%picrf_abs)).AND.(cclist(ps_cnum_IC).EQ.1)) THEN
     IF(ALLOCATED(ss1%picrf_abs).AND.ALLOCATED(ss2%picrf_abs)) THEN
        CALL ps_conformal("picrf_abs",ss2%picrf_abs,ss3%picrf_abs,iout,ierr)
        CALL ps_conformal("picrf_abs",ss1%picrf_abs,ss3%picrf_abs,iout,ierr)
        if(ierr.eq.0) ss3%picrf_abs = w1*ss1%picrf_abs + (1.0_rspec-w1)*ss2%picrf_abs
     ELSE IF(ALLOCATED(ss1%picrf_abs)) THEN
        CALL ps_conformal("picrf_abs",ss1%picrf_abs,ss3%picrf_abs,iout,ierr)
        ss3%picrf_abs = ss1%picrf_abs
     ELSE IF(ALLOCATED(ss2%picrf_abs)) THEN
        CALL ps_conformal("picrf_abs",ss2%picrf_abs,ss3%picrf_abs,iout,ierr)
        ss3%picrf_abs = ss2%picrf_abs
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%picrf_ext)).AND.(cclist(ps_cnum_IC).EQ.1)) THEN
     IF(ALLOCATED(ss1%picrf_ext).AND.ALLOCATED(ss2%picrf_ext)) THEN
        CALL ps_conformal("picrf_ext",ss2%picrf_ext,ss3%picrf_ext,iout,ierr)
        CALL ps_conformal("picrf_ext",ss1%picrf_ext,ss3%picrf_ext,iout,ierr)
        if(ierr.eq.0) ss3%picrf_ext = w1*ss1%picrf_ext + (1.0_rspec-w1)*ss2%picrf_ext
     ELSE IF(ALLOCATED(ss1%picrf_ext)) THEN
        CALL ps_conformal("picrf_ext",ss1%picrf_ext,ss3%picrf_ext,iout,ierr)
        ss3%picrf_ext = ss1%picrf_ext
     ELSE IF(ALLOCATED(ss2%picrf_ext)) THEN
        CALL ps_conformal("picrf_ext",ss2%picrf_ext,ss3%picrf_ext,iout,ierr)
        ss3%picrf_ext = ss2%picrf_ext
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%picrf_nphi_srcs)).AND.(cclist(ps_cnum_IC).EQ.1)) THEN
     IF(ALLOCATED(ss1%picrf_nphi_srcs).AND.ALLOCATED(ss2%picrf_nphi_srcs)) THEN
        CALL ps_conformal("picrf_nphi_srcs",ss2%picrf_nphi_srcs,ss3%picrf_nphi_srcs,iout,ierr)
        CALL ps_conformal("picrf_nphi_srcs",ss1%picrf_nphi_srcs,ss3%picrf_nphi_srcs,iout,ierr)
        if(ierr.eq.0) ss3%picrf_nphi_srcs = w1*ss1%picrf_nphi_srcs + (1.0_rspec-w1)*ss2%picrf_nphi_srcs
     ELSE IF(ALLOCATED(ss1%picrf_nphi_srcs)) THEN
        CALL ps_conformal("picrf_nphi_srcs",ss1%picrf_nphi_srcs,ss3%picrf_nphi_srcs,iout,ierr)
        ss3%picrf_nphi_srcs = ss1%picrf_nphi_srcs
     ELSE IF(ALLOCATED(ss2%picrf_nphi_srcs)) THEN
        CALL ps_conformal("picrf_nphi_srcs",ss2%picrf_nphi_srcs,ss3%picrf_nphi_srcs,iout,ierr)
        ss3%picrf_nphi_srcs = ss2%picrf_nphi_srcs
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%picrf_srcs)).AND.(cclist(ps_cnum_IC).EQ.1)) THEN
     IF(ALLOCATED(ss1%picrf_srcs).AND.ALLOCATED(ss2%picrf_srcs)) THEN
        CALL ps_conformal("picrf_srcs",ss2%picrf_srcs,ss3%picrf_srcs,iout,ierr)
        CALL ps_conformal("picrf_srcs",ss1%picrf_srcs,ss3%picrf_srcs,iout,ierr)
        if(ierr.eq.0) ss3%picrf_srcs = w1*ss1%picrf_srcs + (1.0_rspec-w1)*ss2%picrf_srcs
     ELSE IF(ALLOCATED(ss1%picrf_srcs)) THEN
        CALL ps_conformal("picrf_srcs",ss1%picrf_srcs,ss3%picrf_srcs,iout,ierr)
        ss3%picrf_srcs = ss1%picrf_srcs
     ELSE IF(ALLOCATED(ss2%picrf_srcs)) THEN
        CALL ps_conformal("picrf_srcs",ss2%picrf_srcs,ss3%picrf_srcs,iout,ierr)
        ss3%picrf_srcs = ss2%picrf_srcs
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%picrf_totals)).AND.(cclist(ps_cnum_IC).EQ.1)) THEN
     IF(ALLOCATED(ss1%picrf_totals).AND.ALLOCATED(ss2%picrf_totals)) THEN
        CALL ps_conformal("picrf_totals",ss2%picrf_totals,ss3%picrf_totals,iout,ierr)
        CALL ps_conformal("picrf_totals",ss1%picrf_totals,ss3%picrf_totals,iout,ierr)
        if(ierr.eq.0) ss3%picrf_totals = w1*ss1%picrf_totals + (1.0_rspec-w1)*ss2%picrf_totals
     ELSE IF(ALLOCATED(ss1%picrf_totals)) THEN
        CALL ps_conformal("picrf_totals",ss1%picrf_totals,ss3%picrf_totals,iout,ierr)
        ss3%picrf_totals = ss1%picrf_totals
     ELSE IF(ALLOCATED(ss2%picrf_totals)) THEN
        CALL ps_conformal("picrf_totals",ss2%picrf_totals,ss3%picrf_totals,iout,ierr)
        ss3%picrf_totals = ss2%picrf_totals
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%picth)).AND.(cclist(ps_cnum_IC).EQ.1)) THEN
     IF(ALLOCATED(ss1%picth).AND.ALLOCATED(ss2%picth)) THEN
        CALL ps_conformal("picth",ss2%picth,ss3%picth,iout,ierr)
        CALL ps_conformal("picth",ss1%picth,ss3%picth,iout,ierr)
        if(ierr.eq.0) ss3%picth = w1*ss1%picth + (1.0_rspec-w1)*ss2%picth
     ELSE IF(ALLOCATED(ss1%picth)) THEN
        CALL ps_conformal("picth",ss1%picth,ss3%picth,iout,ierr)
        ss3%picth = ss1%picth
     ELSE IF(ALLOCATED(ss2%picth)) THEN
        CALL ps_conformal("picth",ss2%picth,ss3%picth,iout,ierr)
        ss3%picth = ss2%picth
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%pilh)).AND.(cclist(ps_cnum_LH).EQ.1)) THEN
     IF(ALLOCATED(ss1%pilh).AND.ALLOCATED(ss2%pilh)) THEN
        CALL ps_conformal("pilh",ss2%pilh,ss3%pilh,iout,ierr)
        CALL ps_conformal("pilh",ss1%pilh,ss3%pilh,iout,ierr)
        if(ierr.eq.0) ss3%pilh = w1*ss1%pilh + (1.0_rspec-w1)*ss2%pilh
     ELSE IF(ALLOCATED(ss1%pilh)) THEN
        CALL ps_conformal("pilh",ss1%pilh,ss3%pilh,iout,ierr)
        ss3%pilh = ss1%pilh
     ELSE IF(ALLOCATED(ss2%pilh)) THEN
        CALL ps_conformal("pilh",ss2%pilh,ss3%pilh,iout,ierr)
        ss3%pilh = ss2%pilh
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%pilh_src)).AND.(cclist(ps_cnum_LH).EQ.1)) THEN
     IF(ALLOCATED(ss1%pilh_src).AND.ALLOCATED(ss2%pilh_src)) THEN
        CALL ps_conformal("pilh_src",ss2%pilh_src,ss3%pilh_src,iout,ierr)
        CALL ps_conformal("pilh_src",ss1%pilh_src,ss3%pilh_src,iout,ierr)
        if(ierr.eq.0) ss3%pilh_src = w1*ss1%pilh_src + (1.0_rspec-w1)*ss2%pilh_src
     ELSE IF(ALLOCATED(ss1%pilh_src)) THEN
        CALL ps_conformal("pilh_src",ss1%pilh_src,ss3%pilh_src,iout,ierr)
        ss3%pilh_src = ss1%pilh_src
     ELSE IF(ALLOCATED(ss2%pilh_src)) THEN
        CALL ps_conformal("pilh_src",ss2%pilh_src,ss3%pilh_src,iout,ierr)
        ss3%pilh_src = ss2%pilh_src
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%pi_anom)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%pi_anom).AND.ALLOCATED(ss2%pi_anom)) THEN
        CALL ps_conformal("pi_anom",ss2%pi_anom,ss3%pi_anom,iout,ierr)
        CALL ps_conformal("pi_anom",ss1%pi_anom,ss3%pi_anom,iout,ierr)
        if(ierr.eq.0) ss3%pi_anom = w1*ss1%pi_anom + (1.0_rspec-w1)*ss2%pi_anom
     ELSE IF(ALLOCATED(ss1%pi_anom)) THEN
        CALL ps_conformal("pi_anom",ss1%pi_anom,ss3%pi_anom,iout,ierr)
        ss3%pi_anom = ss1%pi_anom
     ELSE IF(ALLOCATED(ss2%pi_anom)) THEN
        CALL ps_conformal("pi_anom",ss2%pi_anom,ss3%pi_anom,iout,ierr)
        ss3%pi_anom = ss2%pi_anom
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%pi_trans)).AND.(cclist(ps_cnum_PLASMA).EQ.1)) THEN
     IF(ALLOCATED(ss1%pi_trans).AND.ALLOCATED(ss2%pi_trans)) THEN
        CALL ps_conformal("pi_trans",ss2%pi_trans,ss3%pi_trans,iout,ierr)
        CALL ps_conformal("pi_trans",ss1%pi_trans,ss3%pi_trans,iout,ierr)
        if(ierr.eq.0) ss3%pi_trans = w1*ss1%pi_trans + (1.0_rspec-w1)*ss2%pi_trans
     ELSE IF(ALLOCATED(ss1%pi_trans)) THEN
        CALL ps_conformal("pi_trans",ss1%pi_trans,ss3%pi_trans,iout,ierr)
        ss3%pi_trans = ss1%pi_trans
     ELSE IF(ALLOCATED(ss2%pi_trans)) THEN
        CALL ps_conformal("pi_trans",ss2%pi_trans,ss3%pi_trans,iout,ierr)
        ss3%pi_trans = ss2%pi_trans
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%pi_transcat)).AND.(cclist(ps_cnum_PLASMA).EQ.1)) THEN
     IF(ALLOCATED(ss1%pi_transcat).AND.ALLOCATED(ss2%pi_transcat)) THEN
        CALL ps_conformal("pi_transcat",ss2%pi_transcat,ss3%pi_transcat,iout,ierr)
        CALL ps_conformal("pi_transcat",ss1%pi_transcat,ss3%pi_transcat,iout,ierr)
        if(ierr.eq.0) ss3%pi_transcat = w1*ss1%pi_transcat + (1.0_rspec-w1)*ss2%pi_transcat
     ELSE IF(ALLOCATED(ss1%pi_transcat)) THEN
        CALL ps_conformal("pi_transcat",ss1%pi_transcat,ss3%pi_transcat,iout,ierr)
        ss3%pi_transcat = ss1%pi_transcat
     ELSE IF(ALLOCATED(ss2%pi_transcat)) THEN
        CALL ps_conformal("pi_transcat",ss2%pi_transcat,ss3%pi_transcat,iout,ierr)
        ss3%pi_transcat = ss2%pi_transcat
     ENDIF
  ENDIF

  IF(cclist(ps_cnum_PLASMA).EQ.1) THEN

     CALL ps_diff("PLASMA_Code_Info",ss1%PLASMA_Code_Info,ss2%PLASMA_Code_Info,icheck,iout,ierr)
     ss3%PLASMA_Code_Info = ss1%PLASMA_Code_Info
  ENDIF

  IF((ALLOCATED(ss3%pmine)).AND.(cclist(ps_cnum_IC).EQ.1)) THEN
     IF(ALLOCATED(ss1%pmine).AND.ALLOCATED(ss2%pmine)) THEN
        CALL ps_conformal("pmine",ss2%pmine,ss3%pmine,iout,ierr)
        CALL ps_conformal("pmine",ss1%pmine,ss3%pmine,iout,ierr)
        if(ierr.eq.0) ss3%pmine = w1*ss1%pmine + (1.0_rspec-w1)*ss2%pmine
     ELSE IF(ALLOCATED(ss1%pmine)) THEN
        CALL ps_conformal("pmine",ss1%pmine,ss3%pmine,iout,ierr)
        ss3%pmine = ss1%pmine
     ELSE IF(ALLOCATED(ss2%pmine)) THEN
        CALL ps_conformal("pmine",ss2%pmine,ss3%pmine,iout,ierr)
        ss3%pmine = ss2%pmine
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%pmini)).AND.(cclist(ps_cnum_IC).EQ.1)) THEN
     IF(ALLOCATED(ss1%pmini).AND.ALLOCATED(ss2%pmini)) THEN
        CALL ps_conformal("pmini",ss2%pmini,ss3%pmini,iout,ierr)
        CALL ps_conformal("pmini",ss1%pmini,ss3%pmini,iout,ierr)
        if(ierr.eq.0) ss3%pmini = w1*ss1%pmini + (1.0_rspec-w1)*ss2%pmini
     ELSE IF(ALLOCATED(ss1%pmini)) THEN
        CALL ps_conformal("pmini",ss1%pmini,ss3%pmini,iout,ierr)
        ss3%pmini = ss1%pmini
     ELSE IF(ALLOCATED(ss2%pmini)) THEN
        CALL ps_conformal("pmini",ss2%pmini,ss3%pmini,iout,ierr)
        ss3%pmini = ss2%pmini
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%pminth)).AND.(cclist(ps_cnum_IC).EQ.1)) THEN
     IF(ALLOCATED(ss1%pminth).AND.ALLOCATED(ss2%pminth)) THEN
        CALL ps_conformal("pminth",ss2%pminth,ss3%pminth,iout,ierr)
        CALL ps_conformal("pminth",ss1%pminth,ss3%pminth,iout,ierr)
        if(ierr.eq.0) ss3%pminth = w1*ss1%pminth + (1.0_rspec-w1)*ss2%pminth
     ELSE IF(ALLOCATED(ss1%pminth)) THEN
        CALL ps_conformal("pminth",ss1%pminth,ss3%pminth,iout,ierr)
        ss3%pminth = ss1%pminth
     ELSE IF(ALLOCATED(ss2%pminth)) THEN
        CALL ps_conformal("pminth",ss2%pminth,ss3%pminth,iout,ierr)
        ss3%pminth = ss2%pminth
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%pohme)).AND.(cclist(ps_cnum_PLASMA).EQ.1)) THEN
     IF(ALLOCATED(ss1%pohme).AND.ALLOCATED(ss2%pohme)) THEN
        CALL ps_conformal("pohme",ss2%pohme,ss3%pohme,iout,ierr)
        CALL ps_conformal("pohme",ss1%pohme,ss3%pohme,iout,ierr)
        if(ierr.eq.0) ss3%pohme = w1*ss1%pohme + (1.0_rspec-w1)*ss2%pohme
     ELSE IF(ALLOCATED(ss1%pohme)) THEN
        CALL ps_conformal("pohme",ss1%pohme,ss3%pohme,iout,ierr)
        ss3%pohme = ss1%pohme
     ELSE IF(ALLOCATED(ss2%pohme)) THEN
        CALL ps_conformal("pohme",ss2%pohme,ss3%pohme,iout,ierr)
        ss3%pohme = ss2%pohme
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%pot_ky_tglf)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%pot_ky_tglf).AND.ALLOCATED(ss2%pot_ky_tglf)) THEN
        CALL ps_conformal("pot_ky_tglf",ss2%pot_ky_tglf,ss3%pot_ky_tglf,iout,ierr)
        CALL ps_conformal("pot_ky_tglf",ss1%pot_ky_tglf,ss3%pot_ky_tglf,iout,ierr)
        if(ierr.eq.0) ss3%pot_ky_tglf = w1*ss1%pot_ky_tglf + (1.0_rspec-w1)*ss2%pot_ky_tglf
     ELSE IF(ALLOCATED(ss1%pot_ky_tglf)) THEN
        CALL ps_conformal("pot_ky_tglf",ss1%pot_ky_tglf,ss3%pot_ky_tglf,iout,ierr)
        ss3%pot_ky_tglf = ss1%pot_ky_tglf
     ELSE IF(ALLOCATED(ss2%pot_ky_tglf)) THEN
        CALL ps_conformal("pot_ky_tglf",ss2%pot_ky_tglf,ss3%pot_ky_tglf,iout,ierr)
        ss3%pot_ky_tglf = ss2%pot_ky_tglf
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%power_ec)).AND.(cclist(ps_cnum_EC).EQ.1)) THEN
     IF(ALLOCATED(ss1%power_ec).AND.ALLOCATED(ss2%power_ec)) THEN
        CALL ps_conformal("power_ec",ss2%power_ec,ss3%power_ec,iout,ierr)
        CALL ps_conformal("power_ec",ss1%power_ec,ss3%power_ec,iout,ierr)
        if(ierr.eq.0) ss3%power_ec = w1*ss1%power_ec + (1.0_rspec-w1)*ss2%power_ec
     ELSE IF(ALLOCATED(ss1%power_ec)) THEN
        CALL ps_conformal("power_ec",ss1%power_ec,ss3%power_ec,iout,ierr)
        ss3%power_ec = ss1%power_ec
     ELSE IF(ALLOCATED(ss2%power_ec)) THEN
        CALL ps_conformal("power_ec",ss2%power_ec,ss3%power_ec,iout,ierr)
        ss3%power_ec = ss2%power_ec
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%power_ic)).AND.(cclist(ps_cnum_IC).EQ.1)) THEN
     IF(ALLOCATED(ss1%power_ic).AND.ALLOCATED(ss2%power_ic)) THEN
        CALL ps_conformal("power_ic",ss2%power_ic,ss3%power_ic,iout,ierr)
        CALL ps_conformal("power_ic",ss1%power_ic,ss3%power_ic,iout,ierr)
        if(ierr.eq.0) ss3%power_ic = w1*ss1%power_ic + (1.0_rspec-w1)*ss2%power_ic
     ELSE IF(ALLOCATED(ss1%power_ic)) THEN
        CALL ps_conformal("power_ic",ss1%power_ic,ss3%power_ic,iout,ierr)
        ss3%power_ic = ss1%power_ic
     ELSE IF(ALLOCATED(ss2%power_ic)) THEN
        CALL ps_conformal("power_ic",ss2%power_ic,ss3%power_ic,iout,ierr)
        ss3%power_ic = ss2%power_ic
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%power_lh)).AND.(cclist(ps_cnum_LH).EQ.1)) THEN
     IF(ALLOCATED(ss1%power_lh).AND.ALLOCATED(ss2%power_lh)) THEN
        CALL ps_conformal("power_lh",ss2%power_lh,ss3%power_lh,iout,ierr)
        CALL ps_conformal("power_lh",ss1%power_lh,ss3%power_lh,iout,ierr)
        if(ierr.eq.0) ss3%power_lh = w1*ss1%power_lh + (1.0_rspec-w1)*ss2%power_lh
     ELSE IF(ALLOCATED(ss1%power_lh)) THEN
        CALL ps_conformal("power_lh",ss1%power_lh,ss3%power_lh,iout,ierr)
        ss3%power_lh = ss1%power_lh
     ELSE IF(ALLOCATED(ss2%power_lh)) THEN
        CALL ps_conformal("power_lh",ss2%power_lh,ss3%power_lh,iout,ierr)
        ss3%power_lh = ss2%power_lh
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%power_nbi)).AND.(cclist(ps_cnum_NBI).EQ.1)) THEN
     IF(ALLOCATED(ss1%power_nbi).AND.ALLOCATED(ss2%power_nbi)) THEN
        CALL ps_conformal("power_nbi",ss2%power_nbi,ss3%power_nbi,iout,ierr)
        CALL ps_conformal("power_nbi",ss1%power_nbi,ss3%power_nbi,iout,ierr)
        if(ierr.eq.0) ss3%power_nbi = w1*ss1%power_nbi + (1.0_rspec-w1)*ss2%power_nbi
     ELSE IF(ALLOCATED(ss1%power_nbi)) THEN
        CALL ps_conformal("power_nbi",ss1%power_nbi,ss3%power_nbi,iout,ierr)
        ss3%power_nbi = ss1%power_nbi
     ELSE IF(ALLOCATED(ss2%power_nbi)) THEN
        CALL ps_conformal("power_nbi",ss2%power_nbi,ss3%power_nbi,iout,ierr)
        ss3%power_nbi = ss2%power_nbi
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%power_nbi_trace)).AND.(cclist(ps_cnum_NBI).EQ.1)) THEN
     IF(ALLOCATED(ss1%power_nbi_trace).AND.ALLOCATED(ss2%power_nbi_trace)) THEN
        CALL ps_conformal("power_nbi_trace",ss2%power_nbi_trace,ss3%power_nbi_trace,iout,ierr)
        CALL ps_conformal("power_nbi_trace",ss1%power_nbi_trace,ss3%power_nbi_trace,iout,ierr)
        if(ierr.eq.0) ss3%power_nbi_trace = w1*ss1%power_nbi_trace + (1.0_rspec-w1)*ss2%power_nbi_trace
     ELSE IF(ALLOCATED(ss1%power_nbi_trace)) THEN
        CALL ps_conformal("power_nbi_trace",ss1%power_nbi_trace,ss3%power_nbi_trace,iout,ierr)
        ss3%power_nbi_trace = ss1%power_nbi_trace
     ELSE IF(ALLOCATED(ss2%power_nbi_trace)) THEN
        CALL ps_conformal("power_nbi_trace",ss2%power_nbi_trace,ss3%power_nbi_trace,iout,ierr)
        ss3%power_nbi_trace = ss2%power_nbi_trace
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%prad)).AND.(cclist(ps_cnum_RAD).EQ.1)) THEN
     IF(ALLOCATED(ss1%prad).AND.ALLOCATED(ss2%prad)) THEN
        CALL ps_conformal("prad",ss2%prad,ss3%prad,iout,ierr)
        CALL ps_conformal("prad",ss1%prad,ss3%prad,iout,ierr)
        if(ierr.eq.0) ss3%prad = w1*ss1%prad + (1.0_rspec-w1)*ss2%prad
     ELSE IF(ALLOCATED(ss1%prad)) THEN
        CALL ps_conformal("prad",ss1%prad,ss3%prad,iout,ierr)
        ss3%prad = ss1%prad
     ELSE IF(ALLOCATED(ss2%prad)) THEN
        CALL ps_conformal("prad",ss2%prad,ss3%prad,iout,ierr)
        ss3%prad = ss2%prad
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%prad_br)).AND.(cclist(ps_cnum_RAD).EQ.1)) THEN
     IF(ALLOCATED(ss1%prad_br).AND.ALLOCATED(ss2%prad_br)) THEN
        CALL ps_conformal("prad_br",ss2%prad_br,ss3%prad_br,iout,ierr)
        CALL ps_conformal("prad_br",ss1%prad_br,ss3%prad_br,iout,ierr)
        if(ierr.eq.0) ss3%prad_br = w1*ss1%prad_br + (1.0_rspec-w1)*ss2%prad_br
     ELSE IF(ALLOCATED(ss1%prad_br)) THEN
        CALL ps_conformal("prad_br",ss1%prad_br,ss3%prad_br,iout,ierr)
        ss3%prad_br = ss1%prad_br
     ELSE IF(ALLOCATED(ss2%prad_br)) THEN
        CALL ps_conformal("prad_br",ss2%prad_br,ss3%prad_br,iout,ierr)
        ss3%prad_br = ss2%prad_br
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%prad_cy)).AND.(cclist(ps_cnum_RAD).EQ.1)) THEN
     IF(ALLOCATED(ss1%prad_cy).AND.ALLOCATED(ss2%prad_cy)) THEN
        CALL ps_conformal("prad_cy",ss2%prad_cy,ss3%prad_cy,iout,ierr)
        CALL ps_conformal("prad_cy",ss1%prad_cy,ss3%prad_cy,iout,ierr)
        if(ierr.eq.0) ss3%prad_cy = w1*ss1%prad_cy + (1.0_rspec-w1)*ss2%prad_cy
     ELSE IF(ALLOCATED(ss1%prad_cy)) THEN
        CALL ps_conformal("prad_cy",ss1%prad_cy,ss3%prad_cy,iout,ierr)
        ss3%prad_cy = ss1%prad_cy
     ELSE IF(ALLOCATED(ss2%prad_cy)) THEN
        CALL ps_conformal("prad_cy",ss2%prad_cy,ss3%prad_cy,iout,ierr)
        ss3%prad_cy = ss2%prad_cy
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%prad_li)).AND.(cclist(ps_cnum_RAD).EQ.1)) THEN
     IF(ALLOCATED(ss1%prad_li).AND.ALLOCATED(ss2%prad_li)) THEN
        CALL ps_conformal("prad_li",ss2%prad_li,ss3%prad_li,iout,ierr)
        CALL ps_conformal("prad_li",ss1%prad_li,ss3%prad_li,iout,ierr)
        if(ierr.eq.0) ss3%prad_li = w1*ss1%prad_li + (1.0_rspec-w1)*ss2%prad_li
     ELSE IF(ALLOCATED(ss1%prad_li)) THEN
        CALL ps_conformal("prad_li",ss1%prad_li,ss3%prad_li,iout,ierr)
        ss3%prad_li = ss1%prad_li
     ELSE IF(ALLOCATED(ss2%prad_li)) THEN
        CALL ps_conformal("prad_li",ss2%prad_li,ss3%prad_li,iout,ierr)
        ss3%prad_li = ss2%prad_li
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%psc_halo)).AND.(cclist(ps_cnum_NBI).EQ.1)) THEN
     IF(ALLOCATED(ss1%psc_halo).AND.ALLOCATED(ss2%psc_halo)) THEN
        CALL ps_conformal("psc_halo",ss2%psc_halo,ss3%psc_halo,iout,ierr)
        CALL ps_conformal("psc_halo",ss1%psc_halo,ss3%psc_halo,iout,ierr)
        if(ierr.eq.0) ss3%psc_halo = w1*ss1%psc_halo + (1.0_rspec-w1)*ss2%psc_halo
     ELSE IF(ALLOCATED(ss1%psc_halo)) THEN
        CALL ps_conformal("psc_halo",ss1%psc_halo,ss3%psc_halo,iout,ierr)
        ss3%psc_halo = ss1%psc_halo
     ELSE IF(ALLOCATED(ss2%psc_halo)) THEN
        CALL ps_conformal("psc_halo",ss2%psc_halo,ss3%psc_halo,iout,ierr)
        ss3%psc_halo = ss2%psc_halo
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%psc_reco)).AND.(cclist(ps_cnum_GAS).EQ.1)) THEN
     IF(ALLOCATED(ss1%psc_reco).AND.ALLOCATED(ss2%psc_reco)) THEN
        CALL ps_conformal("psc_reco",ss2%psc_reco,ss3%psc_reco,iout,ierr)
        CALL ps_conformal("psc_reco",ss1%psc_reco,ss3%psc_reco,iout,ierr)
        if(ierr.eq.0) ss3%psc_reco = w1*ss1%psc_reco + (1.0_rspec-w1)*ss2%psc_reco
     ELSE IF(ALLOCATED(ss1%psc_reco)) THEN
        CALL ps_conformal("psc_reco",ss1%psc_reco,ss3%psc_reco,iout,ierr)
        ss3%psc_reco = ss1%psc_reco
     ELSE IF(ALLOCATED(ss2%psc_reco)) THEN
        CALL ps_conformal("psc_reco",ss2%psc_reco,ss3%psc_reco,iout,ierr)
        ss3%psc_reco = ss2%psc_reco
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%psipol)).AND.(cclist(ps_cnum_EQ).EQ.1)) THEN
     IF(ALLOCATED(ss1%psipol).AND.ALLOCATED(ss2%psipol)) THEN
        CALL ps_conformal("psipol",ss2%psipol,ss3%psipol,iout,ierr)
        CALL ps_conformal("psipol",ss1%psipol,ss3%psipol,iout,ierr)
        if(ierr.eq.0) ss3%psipol = w1*ss1%psipol + (1.0_rspec-w1)*ss2%psipol
     ELSE IF(ALLOCATED(ss1%psipol)) THEN
        CALL ps_conformal("psipol",ss1%psipol,ss3%psipol,iout,ierr)
        ss3%psipol = ss1%psipol
     ELSE IF(ALLOCATED(ss2%psipol)) THEN
        CALL ps_conformal("psipol",ss2%psipol,ss3%psipol,iout,ierr)
        ss3%psipol = ss2%psipol
     ENDIF
  ENDIF

END SUBROUTINE plasma_state_merge_5

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_v0_dummy
     return
  end subroutine ccps_getset_v0_dummy

subroutine psget_vmo_trans(iobj, n1, data, ierr)
    !! angular momentum radial velocity
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_vmo_trans', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % vmo_trans
end subroutine psget_vmo_trans


subroutine psset_vmo_trans(iobj, n1, data, ierr)
    !! angular momentum radial velocity
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_vmo_trans', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % vmo_trans = data(1:n1)
end subroutine psset_vmo_trans


subroutine psgetrnk_vmo_trans(iobj, ndims, ierr)
    !! angular momentum radial velocity
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_vmo_trans


subroutine psgetdim_vmo_trans(iobj, ndims, dims, ierr)
    !! angular momentum radial velocity
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_vmo_trans', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % vmo_trans ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % vmo_trans)
    endif
end subroutine psgetdim_vmo_trans


subroutine psget_vee_transcat(iobj, n1, n2, data, ierr)
    !! Electron energy radial velocity
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_vee_transcat', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % vee_transcat
end subroutine psget_vee_transcat


subroutine psset_vee_transcat(iobj, n1, n2, data, ierr)
    !! Electron energy radial velocity
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_vee_transcat', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % vee_transcat = data(1:n1, 1: n2)
end subroutine psset_vee_transcat


subroutine psgetrnk_vee_transcat(iobj, ndims, ierr)
    !! Electron energy radial velocity
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_vee_transcat


subroutine psgetdim_vee_transcat(iobj, ndims, dims, ierr)
    !! Electron energy radial velocity
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_vee_transcat', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % vee_transcat ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % vee_transcat)
    endif
end subroutine psgetdim_vee_transcat


subroutine psget_vol(iobj, n1, data, ierr)
    !! enclosed volume
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_vol', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % vol
end subroutine psget_vol


subroutine psset_vol(iobj, n1, data, ierr)
    !! enclosed volume
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_vol', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % vol = data(1:n1)
end subroutine psset_vol


subroutine psgetrnk_vol(iobj, ndims, ierr)
    !! enclosed volume
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_vol


subroutine psgetdim_vol(iobj, ndims, dims, ierr)
    !! enclosed volume
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_vol', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % vol ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % vol)
    endif
end subroutine psgetdim_vol


subroutine psget_velb_rfmi(iobj, n1, data, ierr)
    !! RF minority ion anom. radial velocity
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_velb_rfmi', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % velb_rfmi
end subroutine psget_velb_rfmi


subroutine psset_velb_rfmi(iobj, n1, data, ierr)
    !! RF minority ion anom. radial velocity
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_velb_rfmi', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % velb_rfmi = data(1:n1)
end subroutine psset_velb_rfmi


subroutine psgetrnk_velb_rfmi(iobj, ndims, ierr)
    !! RF minority ion anom. radial velocity
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_velb_rfmi


subroutine psgetdim_velb_rfmi(iobj, ndims, dims, ierr)
    !! RF minority ion anom. radial velocity
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_velb_rfmi', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % velb_rfmi ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % velb_rfmi)
    endif
end subroutine psgetdim_velb_rfmi


subroutine psget_velpphi_anom(iobj, n1, data, ierr)
    !! momentum-equation, advective velocity term
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_velpphi_anom', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % velpphi_anom
end subroutine psget_velpphi_anom


subroutine psset_velpphi_anom(iobj, n1, data, ierr)
    !! momentum-equation, advective velocity term
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_velpphi_anom', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % velpphi_anom = data(1:n1)
end subroutine psset_velpphi_anom


subroutine psgetrnk_velpphi_anom(iobj, ndims, ierr)
    !! momentum-equation, advective velocity term
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_velpphi_anom


subroutine psgetdim_velpphi_anom(iobj, ndims, dims, ierr)
    !! momentum-equation, advective velocity term
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_velpphi_anom', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % velpphi_anom ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % velpphi_anom)
    endif
end subroutine psgetdim_velpphi_anom


subroutine psget_velns_mmm71(iobj, n1, n2, data, ierr)
    !! density-equations, advective velocity term from MMM71 model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_velns_mmm71', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % velns_mmm71
end subroutine psget_velns_mmm71


subroutine psset_velns_mmm71(iobj, n1, n2, data, ierr)
    !! density-equations, advective velocity term from MMM71 model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_velns_mmm71', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % velns_mmm71 = data(1:n1, 1: n2)
end subroutine psset_velns_mmm71


subroutine psgetrnk_velns_mmm71(iobj, ndims, ierr)
    !! density-equations, advective velocity term from MMM71 model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_velns_mmm71


subroutine psgetdim_velns_mmm71(iobj, ndims, dims, ierr)
    !! density-equations, advective velocity term from MMM71 model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_velns_mmm71', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % velns_mmm71 ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % velns_mmm71)
    endif
end subroutine psgetdim_velns_mmm71

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_e0_dummy
     return
  end subroutine ccps_getset_e0_dummy

subroutine psget_ec_princ_curv_hor(iobj, n1, data, ierr)
    !! principal curvature in horizontal direction
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_ec_princ_curv_hor', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % EC_PRINC_CURV_HOR
end subroutine psget_ec_princ_curv_hor


subroutine psset_ec_princ_curv_hor(iobj, n1, data, ierr)
    !! principal curvature in horizontal direction
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_ec_princ_curv_hor', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % EC_PRINC_CURV_HOR = data(1:n1)
end subroutine psset_ec_princ_curv_hor


subroutine psgetrnk_ec_princ_curv_hor(iobj, ndims, ierr)
    !! principal curvature in horizontal direction
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_ec_princ_curv_hor


subroutine psgetdim_ec_princ_curv_hor(iobj, ndims, dims, ierr)
    !! principal curvature in horizontal direction
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_ec_princ_curv_hor', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % EC_PRINC_CURV_HOR ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % EC_PRINC_CURV_HOR)
    endif
end subroutine psgetdim_ec_princ_curv_hor


subroutine psget_e0_av(iobj, n1, data, ierr)
    !! average energy of neutral sources, "(3/2)*T0", [in reference
    !! frame of (vphi0_av)]; some models, impose a minimum value such
    !! as 0.005 KeV.  The, value can effect penetration of neutrals
    !! and, depth of edge-driven charge exchange loss, but, (depending
    !! on plasma parameters) the effect, is often weak.
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_e0_av', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % e0_av
end subroutine psget_e0_av


subroutine psset_e0_av(iobj, n1, data, ierr)
    !! average energy of neutral sources, "(3/2)*T0", [in reference
    !! frame of (vphi0_av)]; some models, impose a minimum value such
    !! as 0.005 KeV.  The, value can effect penetration of neutrals
    !! and, depth of edge-driven charge exchange loss, but, (depending
    !! on plasma parameters) the effect, is often weak.
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_e0_av', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % e0_av = data(1:n1)
end subroutine psset_e0_av


subroutine psgetrnk_e0_av(iobj, ndims, ierr)
    !! average energy of neutral sources, "(3/2)*T0", [in reference
    !! frame of (vphi0_av)]; some models, impose a minimum value such
    !! as 0.005 KeV.  The, value can effect penetration of neutrals
    !! and, depth of edge-driven charge exchange loss, but, (depending
    !! on plasma parameters) the effect, is often weak.
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_e0_av


subroutine psgetdim_e0_av(iobj, ndims, dims, ierr)
    !! average energy of neutral sources, "(3/2)*T0", [in reference
    !! frame of (vphi0_av)]; some models, impose a minimum value such
    !! as 0.005 KeV.  The, value can effect penetration of neutrals
    !! and, depth of edge-driven charge exchange loss, but, (depending
    !! on plasma parameters) the effect, is often weak.
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_e0_av', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % e0_av ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % e0_av)
    endif
end subroutine psgetdim_e0_av

subroutine ccps_store_plasma_state(iobj,filepath,ierr)

  ! write state object contents to file

  use plasma_state_mod
  implicit NONE

#include "fpreproc/byte_declare.h"

  integer :: iobj(*)        ! (ps_container_size) words are used: state object
  BYTE_DECLARE, intent(in) :: filepath(*)  ! null terminated file path string (max 256 chars)
  integer,intent(out) :: ierr      ! exit status 0=OK

  !-------------------------
  character*256 filename
  type (plasma_state_container) :: ptr
  type (plasma_state), pointer :: ss
  !-------------------------

  call ccps_argcheck('ccps_store_plasma_state',iobj,ierr)
  if(ierr.ne.0) return

  ! proceed...

  call load_ps_container(iobj,ptr)
  ss => ptr%ps_ptr

  ! convert filepath to fortran string
  call cstring(filename,filepath,'2F')  ! convert file path to fortran string

  call ps_store_plasma_state(ierr, filename=filename, state=ss)

end subroutine ccps_store_plasma_state

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_t0_dummy
     return
  end subroutine ccps_getset_t0_dummy

subroutine psget_tokamak_id(iobj, data, ierr)
    !! Tokamak (Machine Description) ID, <tokid>_<revid> within a
    !! 32 character string.
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    CHARACTER*(*), intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_tokamak_id', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % tokamak_id
end subroutine psget_tokamak_id


subroutine psset_tokamak_id(iobj, data, ierr)
    !! Tokamak (Machine Description) ID, <tokid>_<revid> within a
    !! 32 character string.
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    CHARACTER*(*), intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_tokamak_id', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % tokamak_id = data
end subroutine psset_tokamak_id


subroutine psgetsz_tokamak_id(iobj, size, ierr)
    !! Tokamak (Machine Description) ID, <tokid>_<revid> within a
    !! 32 character string.
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: size    ! size of character string
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psgetsz_tokamak_id', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! note that the following will return the character length size regardless of
    ! the number of array elements (if tokamak_id is an array)
    size = len(ss % tokamak_id)
end subroutine psgetsz_tokamak_id


subroutine psget_ts_data_info(iobj, data, ierr)
    !! information on source of Temperature data
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    CHARACTER*(*), intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_ts_data_info', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % Ts_Data_Info
end subroutine psget_ts_data_info


subroutine psset_ts_data_info(iobj, data, ierr)
    !! information on source of Temperature data
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    CHARACTER*(*), intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_ts_data_info', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % Ts_Data_Info = data
end subroutine psset_ts_data_info


subroutine psgetsz_ts_data_info(iobj, size, ierr)
    !! information on source of Temperature data
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: size    ! size of character string
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psgetsz_ts_data_info', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! note that the following will return the character length size regardless of
    ! the number of array elements (if Ts_Data_Info is an array)
    size = len(ss % Ts_Data_Info)
end subroutine psgetsz_ts_data_info


subroutine psget_tor_mode_label(iobj, n1, data, ierr)
    !! Toroidal modes to monitor
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    CHARACTER*(*), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_tor_mode_label', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % Tor_mode_label
end subroutine psget_tor_mode_label


subroutine psset_tor_mode_label(iobj, n1, data, ierr)
    !! Toroidal modes to monitor
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    CHARACTER*(*), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_tor_mode_label', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % Tor_mode_label = data(1:n1)
end subroutine psset_tor_mode_label


subroutine psgetsz_tor_mode_label(iobj, size, ierr)
    !! Toroidal modes to monitor
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: size    ! size of character string
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psgetsz_tor_mode_label', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! note that the following will return the character length size regardless of
    ! the number of array elements (if Tor_mode_label is an array)
    size = len(ss % Tor_mode_label)
end subroutine psgetsz_tor_mode_label


subroutine psgetrnk_tor_mode_label(iobj, ndims, ierr)
    !! Toroidal modes to monitor
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_tor_mode_label


subroutine psgetdim_tor_mode_label(iobj, ndims, dims, ierr)
    !! Toroidal modes to monitor
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_tor_mode_label', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % Tor_mode_label ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % Tor_mode_label)
    endif
end subroutine psgetdim_tor_mode_label


subroutine psget_t1(iobj, data, ierr)
    !! time at end of IPS macro timestep
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_t1', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % t1
end subroutine psget_t1


subroutine psset_t1(iobj, data, ierr)
    !! time at end of IPS macro timestep
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_t1', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % t1 = data
end subroutine psset_t1


subroutine psget_ts(iobj, n1, n2, data, ierr)
    !! thermal specie temperature
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_ts', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % Ts
end subroutine psget_ts


subroutine psset_ts(iobj, n1, n2, data, ierr)
    !! thermal specie temperature
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_ts', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % Ts = data(1:n1, 1: n2)
end subroutine psset_ts


subroutine psgetrnk_ts(iobj, ndims, ierr)
    !! thermal specie temperature
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_ts


subroutine psgetdim_ts(iobj, ndims, dims, ierr)
    !! thermal specie temperature
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_ts', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % Ts ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % Ts)
    endif
end subroutine psgetdim_ts


subroutine psget_triang_miller_u(iobj, n1, data, ierr)
    !! Miller upper triangularity,
    !! Sin(aCos((R(Zmax)-Rmajor_mean)/rMinor_mean)-pi/2).
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_triang_miller_u', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % triang_miller_U
end subroutine psget_triang_miller_u


subroutine psset_triang_miller_u(iobj, n1, data, ierr)
    !! Miller upper triangularity,
    !! Sin(aCos((R(Zmax)-Rmajor_mean)/rMinor_mean)-pi/2).
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_triang_miller_u', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % triang_miller_U = data(1:n1)
end subroutine psset_triang_miller_u


subroutine psgetrnk_triang_miller_u(iobj, ndims, ierr)
    !! Miller upper triangularity,
    !! Sin(aCos((R(Zmax)-Rmajor_mean)/rMinor_mean)-pi/2).
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_triang_miller_u


subroutine psgetdim_triang_miller_u(iobj, ndims, dims, ierr)
    !! Miller upper triangularity,
    !! Sin(aCos((R(Zmax)-Rmajor_mean)/rMinor_mean)-pi/2).
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_triang_miller_u', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % triang_miller_U ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % triang_miller_U)
    endif
end subroutine psgetdim_triang_miller_u


subroutine psget_t0_halo(iobj, n1, n2, data, ierr)
    !! halo neutral temperature (2/3)<E0>
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_t0_halo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % T0_halo
end subroutine psget_t0_halo


subroutine psset_t0_halo(iobj, n1, n2, data, ierr)
    !! halo neutral temperature (2/3)<E0>
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_t0_halo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % T0_halo = data(1:n1, 1: n2)
end subroutine psset_t0_halo


subroutine psgetrnk_t0_halo(iobj, ndims, ierr)
    !! halo neutral temperature (2/3)<E0>
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_t0_halo


subroutine psgetdim_t0_halo(iobj, ndims, dims, ierr)
    !! halo neutral temperature (2/3)<E0>
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_t0_halo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % T0_halo ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % T0_halo)
    endif
end subroutine psgetdim_t0_halo


subroutine psget_t0_reco(iobj, n1, n2, data, ierr)
    !! reco neutral temperature (2/3)<E0>
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_t0_reco', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % T0_reco
end subroutine psget_t0_reco


subroutine psset_t0_reco(iobj, n1, n2, data, ierr)
    !! reco neutral temperature (2/3)<E0>
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_t0_reco', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % T0_reco = data(1:n1, 1: n2)
end subroutine psset_t0_reco


subroutine psgetrnk_t0_reco(iobj, ndims, ierr)
    !! reco neutral temperature (2/3)<E0>
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_t0_reco


subroutine psgetdim_t0_reco(iobj, ndims, dims, ierr)
    !! reco neutral temperature (2/3)<E0>
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_t0_reco', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % T0_reco ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % T0_reco)
    endif
end subroutine psgetdim_t0_reco


subroutine psget_tzflux_ky_tglf(iobj, n1, n2, data, ierr)
    !! impurity density flux spectrum
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_tzflux_ky_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % tzflux_ky_tglf
end subroutine psget_tzflux_ky_tglf


subroutine psset_tzflux_ky_tglf(iobj, n1, n2, data, ierr)
    !! impurity density flux spectrum
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_tzflux_ky_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % tzflux_ky_tglf = data(1:n1, 1: n2)
end subroutine psset_tzflux_ky_tglf


subroutine psgetrnk_tzflux_ky_tglf(iobj, ndims, ierr)
    !! impurity density flux spectrum
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_tzflux_ky_tglf


subroutine psgetdim_tzflux_ky_tglf(iobj, ndims, dims, ierr)
    !! impurity density flux spectrum
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_tzflux_ky_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % tzflux_ky_tglf ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % tzflux_ky_tglf)
    endif
end subroutine psgetdim_tzflux_ky_tglf

subroutine ur_cstate_nchk(isel)

  !  Print density data, state #isel

  use cstate_lib_mod
  implicit NONE

  integer, intent(in) :: isel  ! selected state (btw 1 & nsss_cur)

  !------------------------
  ! local

  integer :: luntty,lnout
  logical :: lxout,lchar
  !------------------------

  luntty = lnout(0)

  do 
     if(lxout(0)) then
        write(luntty,*) ' A -- examine thermal species data'
        write(luntty,*) ' B -- examine beam species data'
        write(luntty,*) ' C -- examine fusion product species data'
        write(luntty,*) ' D -- examine RF minority data'
        write(luntty,*) ' Q -- quit'
     endif

     call uread('ur_cstate_nchk: menu option:')

     if(lchar('Q')) then
        exit

     else if(lchar('A')) then
        if(.NOT.allocated(sss(isel)%ns)) then
           write(luntty,*) ' %ur_cshate_nchk: no thermal densities available.'
           cycle
        endif

        call display(sss(isel)%rho,sss(isel)%m_s/ps_mp,sss(isel)%q_s/ps_xe, &
             sss(isel)%qatom_s/ps_xe,sss(isel)%ns,sss(isel)%s_name)

     else if(lchar('B')) then
        if(.NOT.allocated(sss(isel)%nbeami)) then
           write(luntty,*) ' %ur_cshate_nchk: no beam ion densities available.'
           cycle
        endif

        call display(sss(isel)%rho_nbi,sss(isel)%m_snbi/ps_mp, &
             sss(isel)%q_snbi/ps_xe, &
             sss(isel)%qatom_snbi/ps_xe,sss(isel)%nbeami,sss(isel)%snbi_name)

     else if(lchar('C')) then
        if(.NOT.allocated(sss(isel)%nfusi)) then
           write(luntty,*) ' %ur_cshate_nchk: no fusion ion densities available.'
           cycle
        endif

        call display(sss(isel)%rho_fus,sss(isel)%m_sfus/ps_mp, &
             sss(isel)%q_sfus/ps_xe, &
             sss(isel)%qatom_sfus/ps_xe,sss(isel)%nfusi,sss(isel)%sfus_name)

     else if(lchar('D')) then
        if(.NOT.allocated(sss(isel)%nmini)) then
           write(luntty,*) ' %ur_cshate_nchk: no RF minority densities available.'
           cycle
        endif

        call display(sss(isel)%rho_icrf,sss(isel)%m_rfmin/ps_mp, &
             sss(isel)%q_rfmin/ps_xe, &
             sss(isel)%qatom_rfmin/ps_xe,sss(isel)%nfusi,sss(isel)%rfmin_name)

     else
        call uermsg('unrecognized menu option',' ',0)
        cycle
     endif

  enddo

CONTAINS

  subroutine display(rho,A,Z,Zatom,ns,names)
    real*8, dimension(:) :: rho
    real*8, dimension(:) :: A
    real*8, dimension(:) :: Z
    real*8, dimension(:) :: Zatom
    real*8, dimension(:,:) :: ns
    character*(*), dimension(:) :: names

    !-------------------------------
    integer :: inzon,ins,izon,is
    real*8 :: nzsum
    !-------------------------------

    inzon = size(ns,1)
    ins   = size(ns,2)

    do
       if(lxout(0)) then
          write(luntty,*) ' ...choose a grid zone index, btw 1 and ',inzon
          write(luntty,*) '    or "Q" or 0 to quit'
       endif

       izon = 0

       call ureadi('ur_cstate_nchk(display): choose zone index:',izon)
       izon= max(0,min(inzon,izon))

       if(izon.eq.0) exit

       nzsum = 0.0d0
       
       write(luntty,*) ' '
       write(luntty,'(A,i4,A,2(1x,1pe11.4))') '  Zone #',izon,' rho range: ',&
            rho(izon),rho(izon+1)
       write(luntty,*) ' '
       write(luntty,*) 'name         density     Z           Zatom       A           NZsum'
       write(luntty,*) '----------   ----------  ----------  ----------  ----------  ----------'
       do is=1,ins
          nzsum = nzsum + ns(izon,is)*Z(is)
          write(luntty,'(1x,a,1x,5(1x,1pe11.4))') names(is)(1:10),ns(izon,is),&
               Z(is),Zatom(is),A(is),NZsum
       enddo
    enddo

  end subroutine display

end subroutine ur_cstate_nchk

subroutine ps_geqdsk_write_nrz(ps,gfile,glabel,inR,inZ,inB,iout,ierr)

  !------------------------------------------------------------
  ! write G-eqdsk file from contents of plasma state; control the sizes
  ! of the R & Z grids (inR,inZ) and the number of boundary points to 
  ! be written (inB)
  ! Psi(R,Z), [R,Z](rho,theta), g(rho), q(rho), and P(rho) must be there.
  !------------------------------------------------------------

  use plasma_state_xpobj  ! XPLASMA2 state object definitions

  use plasma_state_definition_mod

  implicit NONE

  !-----------------------
  ! arguments:

  type (plasma_state) :: ps            ! plasma state instance 
  character*(*), intent(in) :: gfile   ! name of file to write
  character*(*), intent(in) :: glabel  ! label string for file

  integer, intent(in) :: inR           ! desired R grid size
  integer, intent(in) :: inZ           ! desired Z grid size
  integer, intent(in) :: inB           ! desired no. of bdy points

  integer, intent(in) :: iout          ! Fortran LUN for messages
  integer, intent(out) :: ierr         ! status code, 0=OK

  !------------------------
  ! local:

  integer :: ilun,id_p,id_q,id_Rc,id_Zc
  real*8 :: Rmin,Rmax,Zmin,Zmax,zcur
  !------------------------

  type (interp_object) :: xobj
  type (xplasma), pointer :: s
  !-------------------------------------------------------------------------
  ! executable code...

  call ps_tagchk('ps_geqdsk_write_nrz',ps%itag,iout,ierr)
  if(ierr.ne.0) return

  ! check contents

  call ps_wrgeq_chk(ps,'ps_geqdsk_write_nrz',iout,ierr)
  if(ierr.ne.0) return

  ! OK basics seems to be there...

  ! get xplasma pointer

  xobj = transfer(ps%iobj,xobj)
  s => xobj%s_xpobj

  call xplasma_profID(s,'P_EQ',id_p)
  call xplasma_profID(s,'Q_EQ',id_q)

  zcur = ps%curt(ps%nrho_eq) ! total plasma current (A)

  do
     call xplasma_find_item(s,'__R_coord',id_Rc,ierr); if(ierr.ne.0) exit
     call xplasma_find_item(s,'__Z_coord',id_Zc,ierr); if(ierr.ne.0) exit

     call xplasma_coord_info(s,id_Rc,ierr, &
          xmin=Rmin,xmax=Rmax); if(ierr.ne.0) exit

     call xplasma_coord_info(s,id_Zc,ierr, &
          xmin=Zmin,xmax=Zmax); if(ierr.ne.0) exit

     call find_io_unit(ilun)

     call xplasma_wr_geqdsk(s,ierr, &
          lun_geqdsk=ilun, filename=gfile, &
          label=glabel, &
          Rmin=Rmin, Rmax=Rmax, Zmin=Zmin, Zmax=Zmax, &
          cur=zcur, id_pprof=id_p, id_qprof=id_q, &
          nh=inR, nv=inZ, nbdy=inB)

     if(ierr.ne.0) then
        write(iout,*) ' ?ps_geqdsk_write_nRZ: xplasma_wr_geqdsk error status:'
        call xplasma_error(s,ierr,iout)
     endif

     exit
  enddo

end subroutine ps_geqdsk_write_nrz

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_i8_dummy
     return
  end subroutine ccps_getset_i8_dummy

subroutine psget_imag_ant_coef(iobj, n1, n2, data, ierr)
    !! imag part of Fourier Coef
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_imag_ant_coef', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % Imag_ant_coef
end subroutine psget_imag_ant_coef


subroutine psset_imag_ant_coef(iobj, n1, n2, data, ierr)
    !! imag part of Fourier Coef
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_imag_ant_coef', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % Imag_ant_coef = data(1:n1, 1: n2)
end subroutine psset_imag_ant_coef


subroutine psgetrnk_imag_ant_coef(iobj, ndims, ierr)
    !! imag part of Fourier Coef
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_imag_ant_coef


subroutine psgetdim_imag_ant_coef(iobj, ndims, dims, ierr)
    !! imag part of Fourier Coef
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_imag_ant_coef', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % Imag_ant_coef ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % Imag_ant_coef)
    endif
end subroutine psgetdim_imag_ant_coef


subroutine psget_is_recycling(iobj, n1, data, ierr)
    !! 0/1; =1 to for recycling sources, i.e. sources proportional
    !! to ion outfluxes
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_is_recycling', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % is_recycling
end subroutine psget_is_recycling


subroutine psset_is_recycling(iobj, n1, data, ierr)
    !! 0/1; =1 to for recycling sources, i.e. sources proportional
    !! to ion outfluxes
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_is_recycling', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % is_recycling = data(1:n1)
end subroutine psset_is_recycling


subroutine psgetrnk_is_recycling(iobj, ndims, ierr)
    !! 0/1; =1 to for recycling sources, i.e. sources proportional
    !! to ion outfluxes
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_is_recycling


subroutine psgetdim_is_recycling(iobj, ndims, dims, ierr)
    !! 0/1; =1 to for recycling sources, i.e. sources proportional
    !! to ion outfluxes
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_is_recycling', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % is_recycling ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % is_recycling)
    endif
end subroutine psgetdim_is_recycling


subroutine psget_icircuit_coil(iobj, n1, data, ierr)
    !! index of circuit to which each coil belongs, (derived from
    !! machine description): coil j, named coil_name(j),, belongs to
    !! the circuit named circuit_name(icircuit_coil(j)).
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_icircuit_coil', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % icircuit_coil
end subroutine psget_icircuit_coil


subroutine psset_icircuit_coil(iobj, n1, data, ierr)
    !! index of circuit to which each coil belongs, (derived from
    !! machine description): coil j, named coil_name(j),, belongs to
    !! the circuit named circuit_name(icircuit_coil(j)).
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_icircuit_coil', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % icircuit_coil = data(1:n1)
end subroutine psset_icircuit_coil


subroutine psgetrnk_icircuit_coil(iobj, ndims, ierr)
    !! index of circuit to which each coil belongs, (derived from
    !! machine description): coil j, named coil_name(j),, belongs to
    !! the circuit named circuit_name(icircuit_coil(j)).
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_icircuit_coil


subroutine psgetdim_icircuit_coil(iobj, ndims, dims, ierr)
    !! index of circuit to which each coil belongs, (derived from
    !! machine description): coil j, named coil_name(j),, belongs to
    !! the circuit named circuit_name(icircuit_coil(j)).
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_icircuit_coil', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % icircuit_coil ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % icircuit_coil)
    endif
end subroutine psgetdim_icircuit_coil


subroutine psget_id_zeff(iobj, data, ierr)
    !! 'ID for Zeff profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_zeff', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_zeff
end subroutine psget_id_zeff


subroutine psget_id_curr_ohmic(iobj, data, ierr)
    !! 'ID for curr_ohmic profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_curr_ohmic', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_curr_ohmic
end subroutine psget_id_curr_ohmic


subroutine psget_id_res_tq(iobj, data, ierr)
    !! 'ID for res_tq profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_res_tq', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_res_tq
end subroutine psget_id_res_tq


subroutine psget_id_vee_trans(iobj, data, ierr)
    !! 'ID for vee_trans profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_vee_trans', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_vee_trans
end subroutine psget_id_vee_trans


subroutine psget_id_upwind_pfrac_omega(iobj, data, ierr)
    !! 'ID for upwind_pfrac_omega profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_upwind_pfrac_omega', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_upwind_pfrac_omega
end subroutine psget_id_upwind_pfrac_omega


subroutine psget_id_r_geo(iobj, data, ierr)
    !! 'ID for R_geo profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_r_geo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_r_geo
end subroutine psget_id_r_geo


subroutine psget_id_psipol(iobj, data, ierr)
    !! 'ID for psipol profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_psipol', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_psipol
end subroutine psget_id_psipol


subroutine psget_id_bphirz(iobj, data, ierr)
    !! 'ID for BphiRZ profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_bphirz', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_bphirz
end subroutine psget_id_bphirz


subroutine psget_id_gr3i(iobj, data, ierr)
    !! 'ID for gr3i profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_gr3i', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_gr3i
end subroutine psget_id_gr3i


subroutine psget_id_ngradb2_av(iobj, data, ierr)
    !! 'ID for ngradb2_av profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_ngradb2_av', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_ngradb2_av
end subroutine psget_id_ngradb2_av


subroutine psget_id_z_surfmax(iobj, data, ierr)
    !! 'ID for Z_surfMax profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_z_surfmax', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_z_surfmax
end subroutine psget_id_z_surfmax


subroutine psget_id_squareuo(iobj, data, ierr)
    !! 'ID for squareUO profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_squareuo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_squareuo
end subroutine psget_id_squareuo


subroutine psget_id_curich(iobj, data, ierr)
    !! 'ID for curich profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_curich', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_curich
end subroutine psget_id_curich


subroutine psget_id_epll_beami(iobj, n1, data, ierr)
    !! 'Array of IDs for epll_beami profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_epll_beami', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_epll_beami
end subroutine psget_id_epll_beami


subroutine psgetrnk_id_epll_beami(iobj, ndims, ierr)
    !! 'Array of IDs for epll_beami profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_epll_beami


subroutine psgetdim_id_epll_beami(iobj, ndims, dims, ierr)
    !! 'Array of IDs for epll_beami profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_epll_beami', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_epll_beami ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_epll_beami)
    endif
end subroutine psgetdim_id_epll_beami


subroutine psget_id_sbedep(iobj, data, ierr)
    !! 'ID for sbedep profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_sbedep', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_sbedep
end subroutine psget_id_sbedep


subroutine psget_id_tqcx_halo(iobj, data, ierr)
    !! 'ID for tqcx_halo profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_tqcx_halo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_tqcx_halo
end subroutine psget_id_tqcx_halo


subroutine psget_id_epll_fusi(iobj, n1, data, ierr)
    !! 'Array of IDs for epll_fusi profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_epll_fusi', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_epll_fusi
end subroutine psget_id_epll_fusi


subroutine psgetrnk_id_epll_fusi(iobj, ndims, ierr)
    !! 'Array of IDs for epll_fusi profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_epll_fusi


subroutine psgetdim_id_epll_fusi(iobj, ndims, dims, ierr)
    !! 'Array of IDs for epll_fusi profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_epll_fusi', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_epll_fusi ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_epll_fusi)
    endif
end subroutine psgetdim_id_epll_fusi


subroutine psget_id_spsce(iobj, n1, data, ierr)
    !! 'Array of IDs for spsce profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_spsce', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_spsce
end subroutine psget_id_spsce


subroutine psgetrnk_id_spsce(iobj, ndims, ierr)
    !! 'Array of IDs for spsce profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_spsce


subroutine psgetdim_id_spsce(iobj, ndims, dims, ierr)
    !! 'Array of IDs for spsce profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_spsce', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_spsce ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_spsce)
    endif
end subroutine psgetdim_id_spsce


subroutine psget_id_sii_xs(iobj, n1, n2, data, ierr)
    !! 'Array of IDs for sii_xs profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_sii_xs', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % id_sii_xs
end subroutine psget_id_sii_xs


subroutine psgetrnk_id_sii_xs(iobj, ndims, ierr)
    !! 'Array of IDs for sii_xs profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_id_sii_xs


subroutine psgetdim_id_sii_xs(iobj, ndims, dims, ierr)
    !! 'Array of IDs for sii_xs profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_id_sii_xs', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_sii_xs ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_sii_xs)
    endif
end subroutine psgetdim_id_sii_xs


subroutine psget_id_t0sc0(iobj, n1, n2, data, ierr)
    !! 'Array of IDs for T0sc0 profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_t0sc0', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % id_t0sc0
end subroutine psget_id_t0sc0


subroutine psgetrnk_id_t0sc0(iobj, ndims, ierr)
    !! 'Array of IDs for T0sc0 profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_id_t0sc0


subroutine psgetdim_id_t0sc0(iobj, ndims, dims, ierr)
    !! 'Array of IDs for T0sc0 profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_id_t0sc0', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_t0sc0 ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_t0sc0)
    endif
end subroutine psgetdim_id_t0sc0


subroutine psget_id_tqcx_reco(iobj, data, ierr)
    !! 'ID for tqcx_reco profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_tqcx_reco', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_tqcx_reco
end subroutine psget_id_tqcx_reco


subroutine psget_id_pelh_src(iobj, n1, data, ierr)
    !! 'Array of IDs for pelh_src profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_pelh_src', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_pelh_src
end subroutine psget_id_pelh_src


subroutine psgetrnk_id_pelh_src(iobj, ndims, ierr)
    !! 'Array of IDs for pelh_src profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_pelh_src


subroutine psgetdim_id_pelh_src(iobj, ndims, dims, ierr)
    !! 'Array of IDs for pelh_src profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_pelh_src', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_pelh_src ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_pelh_src)
    endif
end subroutine psgetdim_id_pelh_src


subroutine psget_id_velb_nbi(iobj, data, ierr)
    !! 'ID for velb_nbi profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_velb_nbi', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_velb_nbi
end subroutine psget_id_velb_nbi


subroutine psget_id_bidiff_dtrap(iobj, n1, data, ierr)
    !! 'Array of IDs for bidiff_dtrap profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_bidiff_dtrap', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_bidiff_dtrap
end subroutine psget_id_bidiff_dtrap


subroutine psgetrnk_id_bidiff_dtrap(iobj, ndims, ierr)
    !! 'Array of IDs for bidiff_dtrap profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_bidiff_dtrap


subroutine psgetdim_id_bidiff_dtrap(iobj, ndims, dims, ierr)
    !! 'Array of IDs for bidiff_dtrap profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_bidiff_dtrap', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_bidiff_dtrap ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_bidiff_dtrap)
    endif
end subroutine psgetdim_id_bidiff_dtrap


subroutine psget_id_velte_anom(iobj, data, ierr)
    !! 'ID for velte_anom profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_velte_anom', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_velte_anom
end subroutine psget_id_velte_anom


subroutine psget_id_freq_tglf(iobj, n1, data, ierr)
    !! 'Array of IDs for freq_tglf profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_freq_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_freq_tglf
end subroutine psget_id_freq_tglf


subroutine psgetrnk_id_freq_tglf(iobj, ndims, ierr)
    !! 'Array of IDs for freq_tglf profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_freq_tglf


subroutine psgetdim_id_freq_tglf(iobj, ndims, dims, ierr)
    !! 'Array of IDs for freq_tglf profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_freq_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_freq_tglf ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_freq_tglf)
    endif
end subroutine psgetdim_id_freq_tglf


subroutine psget_id_teflux_ky_tglf(iobj, n1, data, ierr)
    !! 'Array of IDs for teflux_ky_tglf profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_teflux_ky_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_teflux_ky_tglf
end subroutine psget_id_teflux_ky_tglf


subroutine psgetrnk_id_teflux_ky_tglf(iobj, ndims, ierr)
    !! 'Array of IDs for teflux_ky_tglf profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_teflux_ky_tglf


subroutine psgetdim_id_teflux_ky_tglf(iobj, ndims, dims, ierr)
    !! 'Array of IDs for teflux_ky_tglf profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_teflux_ky_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_teflux_ky_tglf ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_teflux_ky_tglf)
    endif
end subroutine psgetdim_id_teflux_ky_tglf


subroutine psget_id_velns_tglf(iobj, n1, data, ierr)
    !! 'Array of IDs for velns_tglf profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_velns_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_velns_tglf
end subroutine psget_id_velns_tglf


subroutine psgetrnk_id_velns_tglf(iobj, ndims, ierr)
    !! 'Array of IDs for velns_tglf profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_velns_tglf


subroutine psgetdim_id_velns_tglf(iobj, ndims, dims, ierr)
    !! 'Array of IDs for velns_tglf profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_velns_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_velns_tglf ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_velns_tglf)
    endif
end subroutine psgetdim_id_velns_tglf


subroutine psget_id_growthrate_vpar(iobj, n1, data, ierr)
    !! 'Array of IDs for growthrate_vpar profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_growthrate_vpar', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_growthrate_vpar
end subroutine psget_id_growthrate_vpar


subroutine psgetrnk_id_growthrate_vpar(iobj, ndims, ierr)
    !! 'Array of IDs for growthrate_vpar profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_growthrate_vpar


subroutine psgetdim_id_growthrate_vpar(iobj, ndims, dims, ierr)
    !! 'Array of IDs for growthrate_vpar profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_growthrate_vpar', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_growthrate_vpar ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_growthrate_vpar)
    endif
end subroutine psgetdim_id_growthrate_vpar


subroutine psget_id_velti_mmm71(iobj, data, ierr)
    !! 'ID for velti_mmm71 profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_velti_mmm71', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_velti_mmm71
end subroutine psget_id_velti_mmm71


subroutine psget_id_difns_drbm(iobj, n1, data, ierr)
    !! 'Array of IDs for difns_drbm profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_difns_drbm', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_difns_drbm
end subroutine psget_id_difns_drbm


subroutine psgetrnk_id_difns_drbm(iobj, ndims, ierr)
    !! 'Array of IDs for difns_drbm profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_difns_drbm


subroutine psgetdim_id_difns_drbm(iobj, ndims, dims, ierr)
    !! 'Array of IDs for difns_drbm profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_difns_drbm', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_difns_drbm ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_difns_drbm)
    endif
end subroutine psgetdim_id_difns_drbm


subroutine psget_id_freq_mtm(iobj, data, ierr)
    !! 'ID for freq_mtm profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_freq_mtm', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_freq_mtm
end subroutine psget_id_freq_mtm


subroutine psget_id_chiphi_glf(iobj, data, ierr)
    !! 'ID for chiphi_glf profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_chiphi_glf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_chiphi_glf
end subroutine psget_id_chiphi_glf


subroutine psget_id_chie_neo(iobj, data, ierr)
    !! 'ID for chie_neo profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_chie_neo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_chie_neo
end subroutine psget_id_chie_neo


subroutine psget_id_difns_nclass(iobj, n1, data, ierr)
    !! 'Array of IDs for difns_nclass profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_difns_nclass', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_difns_nclass
end subroutine psget_id_difns_nclass


subroutine psgetrnk_id_difns_nclass(iobj, ndims, ierr)
    !! 'Array of IDs for difns_nclass profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_difns_nclass


subroutine psgetdim_id_difns_nclass(iobj, ndims, dims, ierr)
    !! 'Array of IDs for difns_nclass profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_difns_nclass', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_difns_nclass ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_difns_nclass)
    endif
end subroutine psgetdim_id_difns_nclass


subroutine psget_id_chie_ntm(iobj, data, ierr)
    !! 'ID for chie_ntm profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_chie_ntm', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_chie_ntm
end subroutine psget_id_chie_ntm

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_i7_dummy
     return
  end subroutine ccps_getset_i7_dummy

subroutine psget_id_v_loop(iobj, data, ierr)
    !! 'ID for V_loop profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_v_loop', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_v_loop
end subroutine psget_id_v_loop


subroutine psget_id_eta_parallel(iobj, data, ierr)
    !! 'ID for eta_parallel profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_eta_parallel', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_eta_parallel
end subroutine psget_id_eta_parallel


subroutine psget_id_res_ti(iobj, data, ierr)
    !! 'ID for res_ti profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_res_ti', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_res_ti
end subroutine psget_id_res_ti


subroutine psget_id_sn_transcat(iobj, n1, n2, data, ierr)
    !! 'Array of IDs for sn_transcat profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_sn_transcat', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % id_sn_transcat
end subroutine psget_id_sn_transcat


subroutine psgetrnk_id_sn_transcat(iobj, ndims, ierr)
    !! 'Array of IDs for sn_transcat profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_id_sn_transcat


subroutine psgetdim_id_sn_transcat(iobj, ndims, dims, ierr)
    !! 'Array of IDs for sn_transcat profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_id_sn_transcat', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_sn_transcat ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_sn_transcat)
    endif
end subroutine psgetdim_id_sn_transcat


subroutine psget_id_upwind_pfrac_ti(iobj, data, ierr)
    !! 'ID for upwind_pfrac_Ti profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_upwind_pfrac_ti', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_upwind_pfrac_ti
end subroutine psget_id_upwind_pfrac_ti


subroutine psget_id_diff_transcat(iobj, n1, n2, data, ierr)
    !! 'Array of IDs for diff_transcat profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_diff_transcat', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % id_diff_transcat
end subroutine psget_id_diff_transcat


subroutine psgetrnk_id_diff_transcat(iobj, ndims, ierr)
    !! 'Array of IDs for diff_transcat profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_id_diff_transcat


subroutine psgetdim_id_diff_transcat(iobj, ndims, dims, ierr)
    !! 'Array of IDs for diff_transcat profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_id_diff_transcat', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_diff_transcat ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_diff_transcat)
    endif
end subroutine psgetdim_id_diff_transcat


subroutine psget_id_phit(iobj, data, ierr)
    !! 'ID for phit profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_phit', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_phit
end subroutine psget_id_phit


subroutine psget_id_psirz(iobj, data, ierr)
    !! 'ID for PsiRZ profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_psirz', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_psirz
end subroutine psget_id_psirz


subroutine psget_id_gri(iobj, data, ierr)
    !! 'ID for gri profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_gri', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_gri
end subroutine psget_id_gri


subroutine psget_id_gamma_nc(iobj, data, ierr)
    !! 'ID for gamma_nc profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_gamma_nc', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_gamma_nc
end subroutine psget_id_gamma_nc


subroutine psget_id_r_surfmin(iobj, data, ierr)
    !! 'ID for R_surfMin profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_r_surfmin', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_r_surfmin
end subroutine psget_id_r_surfmin


subroutine psget_id_triangl(iobj, data, ierr)
    !! 'ID for triangL profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_triangl', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_triangl
end subroutine psget_id_triangl


subroutine psget_id_cdicrf(iobj, n1, data, ierr)
    !! 'Array of IDs for cdicrf profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_cdicrf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_cdicrf
end subroutine psget_id_cdicrf


subroutine psgetrnk_id_cdicrf(iobj, ndims, ierr)
    !! 'Array of IDs for cdicrf profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_cdicrf


subroutine psgetdim_id_cdicrf(iobj, ndims, dims, ierr)
    !! 'Array of IDs for cdicrf profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_cdicrf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_cdicrf ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_cdicrf)
    endif
end subroutine psgetdim_id_cdicrf


subroutine psget_id_eperp_beami(iobj, n1, data, ierr)
    !! 'Array of IDs for eperp_beami profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_eperp_beami', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_eperp_beami
end subroutine psget_id_eperp_beami


subroutine psgetrnk_id_eperp_beami(iobj, ndims, ierr)
    !! 'Array of IDs for eperp_beami profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_eperp_beami


subroutine psgetdim_id_eperp_beami(iobj, ndims, dims, ierr)
    !! 'Array of IDs for eperp_beami profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_eperp_beami', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_eperp_beami ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_eperp_beami)
    endif
end subroutine psgetdim_id_eperp_beami


subroutine psget_id_sbsce(iobj, n1, data, ierr)
    !! 'Array of IDs for sbsce profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_sbsce', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_sbsce
end subroutine psget_id_sbsce


subroutine psgetrnk_id_sbsce(iobj, ndims, ierr)
    !! 'Array of IDs for sbsce profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_sbsce


subroutine psgetdim_id_sbsce(iobj, ndims, dims, ierr)
    !! 'Array of IDs for sbsce profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_sbsce', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_sbsce ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_sbsce)
    endif
end subroutine psgetdim_id_sbsce


subroutine psget_id_tqsc_halo(iobj, data, ierr)
    !! 'ID for tqsc_halo profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_tqsc_halo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_tqsc_halo
end subroutine psget_id_tqsc_halo


subroutine psget_id_eperp_fusi(iobj, n1, data, ierr)
    !! 'Array of IDs for eperp_fusi profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_eperp_fusi', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_eperp_fusi
end subroutine psget_id_eperp_fusi


subroutine psgetrnk_id_eperp_fusi(iobj, ndims, ierr)
    !! 'Array of IDs for eperp_fusi profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_eperp_fusi


subroutine psgetdim_id_eperp_fusi(iobj, ndims, dims, ierr)
    !! 'Array of IDs for eperp_fusi profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_eperp_fusi', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_eperp_fusi ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_eperp_fusi)
    endif
end subroutine psgetdim_id_eperp_fusi


subroutine psget_id_rate_sinf0i(iobj, n1, data, ierr)
    !! 'Array of IDs for rate_sinf0i profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_rate_sinf0i', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_rate_sinf0i
end subroutine psget_id_rate_sinf0i


subroutine psgetrnk_id_rate_sinf0i(iobj, ndims, ierr)
    !! 'Array of IDs for rate_sinf0i profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_rate_sinf0i


subroutine psgetdim_id_rate_sinf0i(iobj, ndims, dims, ierr)
    !! 'Array of IDs for rate_sinf0i profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_rate_sinf0i', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_rate_sinf0i ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_rate_sinf0i)
    endif
end subroutine psgetdim_id_rate_sinf0i


subroutine psget_id_prad_li(iobj, data, ierr)
    !! 'ID for prad_li profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_prad_li', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_prad_li
end subroutine psget_id_prad_li


subroutine psget_id_n0norm(iobj, n1, n2, data, ierr)
    !! 'Array of IDs for n0norm profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_n0norm', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % id_n0norm
end subroutine psget_id_n0norm


subroutine psgetrnk_id_n0norm(iobj, ndims, ierr)
    !! 'Array of IDs for n0norm profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_id_n0norm


subroutine psgetdim_id_n0norm(iobj, ndims, dims, ierr)
    !! 'Array of IDs for n0norm profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_id_n0norm', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_n0norm ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_n0norm)
    endif
end subroutine psgetdim_id_n0norm


subroutine psget_id_tqsc_reco(iobj, data, ierr)
    !! 'ID for tqsc_reco profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_tqsc_reco', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_tqsc_reco
end subroutine psget_id_tqsc_reco


subroutine psget_id_pilh(iobj, data, ierr)
    !! 'ID for pilh profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_pilh', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_pilh
end subroutine psget_id_pilh


subroutine psget_id_difb_rfmi(iobj, data, ierr)
    !! 'ID for difb_rfmi profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_difb_rfmi', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_difb_rfmi
end subroutine psget_id_difb_rfmi


subroutine psget_id_fidiff_dpass_ctr(iobj, n1, data, ierr)
    !! 'Array of IDs for fidiff_dpass_ctr profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_fidiff_dpass_ctr', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_fidiff_dpass_ctr
end subroutine psget_id_fidiff_dpass_ctr


subroutine psgetrnk_id_fidiff_dpass_ctr(iobj, ndims, ierr)
    !! 'Array of IDs for fidiff_dpass_ctr profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_fidiff_dpass_ctr


subroutine psgetdim_id_fidiff_dpass_ctr(iobj, ndims, dims, ierr)
    !! 'Array of IDs for fidiff_dpass_ctr profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_fidiff_dpass_ctr', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_fidiff_dpass_ctr ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_fidiff_dpass_ctr)
    endif
end subroutine psgetdim_id_fidiff_dpass_ctr


subroutine psget_id_sc_anom(iobj, n1, data, ierr)
    !! 'Array of IDs for sc_anom profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_sc_anom', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_sc_anom
end subroutine psget_id_sc_anom


subroutine psgetrnk_id_sc_anom(iobj, ndims, ierr)
    !! 'Array of IDs for sc_anom profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_sc_anom


subroutine psgetdim_id_sc_anom(iobj, ndims, dims, ierr)
    !! 'Array of IDs for sc_anom profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_sc_anom', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_sc_anom ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_sc_anom)
    endif
end subroutine psgetdim_id_sc_anom


subroutine psget_id_growthrate_tglf(iobj, n1, data, ierr)
    !! 'Array of IDs for growthrate_tglf profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_growthrate_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_growthrate_tglf
end subroutine psget_id_growthrate_tglf


subroutine psgetrnk_id_growthrate_tglf(iobj, ndims, ierr)
    !! 'Array of IDs for growthrate_tglf profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_growthrate_tglf


subroutine psgetdim_id_growthrate_tglf(iobj, ndims, dims, ierr)
    !! 'Array of IDs for growthrate_tglf profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_growthrate_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_growthrate_tglf ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_growthrate_tglf)
    endif
end subroutine psgetdim_id_growthrate_tglf


subroutine psget_id_nzflux_ky_tglf(iobj, n1, data, ierr)
    !! 'Array of IDs for nzflux_ky_tglf profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_nzflux_ky_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_nzflux_ky_tglf
end subroutine psget_id_nzflux_ky_tglf


subroutine psgetrnk_id_nzflux_ky_tglf(iobj, ndims, ierr)
    !! 'Array of IDs for nzflux_ky_tglf profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_nzflux_ky_tglf


subroutine psgetdim_id_nzflux_ky_tglf(iobj, ndims, dims, ierr)
    !! 'Array of IDs for nzflux_ky_tglf profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_nzflux_ky_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_nzflux_ky_tglf ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_nzflux_ky_tglf)
    endif
end subroutine psgetdim_id_nzflux_ky_tglf


subroutine psget_id_velpphi_tglf(iobj, data, ierr)
    !! 'ID for velpphi_tglf profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_velpphi_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_velpphi_tglf
end subroutine psget_id_velpphi_tglf


subroutine psget_id_omega_exb(iobj, data, ierr)
    !! 'ID for omega_exb profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_omega_exb', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_omega_exb
end subroutine psget_id_omega_exb


subroutine psget_id_velte_mmm71(iobj, data, ierr)
    !! 'ID for velte_mmm71 profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_velte_mmm71', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_velte_mmm71
end subroutine psget_id_velte_mmm71


subroutine psget_id_chiphi_drbm(iobj, data, ierr)
    !! 'ID for chiphi_drbm profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_chiphi_drbm', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_chiphi_drbm
end subroutine psget_id_chiphi_drbm


subroutine psget_id_growthrate_mtm(iobj, data, ierr)
    !! 'ID for growthrate_mtm profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_growthrate_mtm', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_growthrate_mtm
end subroutine psget_id_growthrate_mtm


subroutine psget_id_chii_glf(iobj, data, ierr)
    !! 'ID for chii_glf profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_chii_glf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_chii_glf
end subroutine psget_id_chii_glf


subroutine psget_id_velns_gtcneo(iobj, n1, data, ierr)
    !! 'Array of IDs for velns_gtcneo profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_velns_gtcneo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_velns_gtcneo
end subroutine psget_id_velns_gtcneo


subroutine psgetrnk_id_velns_gtcneo(iobj, ndims, ierr)
    !! 'Array of IDs for velns_gtcneo profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_velns_gtcneo


subroutine psgetdim_id_velns_gtcneo(iobj, ndims, dims, ierr)
    !! 'Array of IDs for velns_gtcneo profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_velns_gtcneo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_velns_gtcneo ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_velns_gtcneo)
    endif
end subroutine psgetdim_id_velns_gtcneo


subroutine psget_id_chii_nclass(iobj, data, ierr)
    !! 'ID for chii_nclass profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_chii_nclass', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_chii_nclass
end subroutine psget_id_chii_nclass


subroutine psget_id_velnx_nclass(iobj, data, ierr)
    !! 'ID for velnx_nclass profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_velnx_nclass', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_velnx_nclass
end subroutine psget_id_velnx_nclass

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)

SUBROUTINE plasma_state_xload_pgrps(ss,xhash,iout,ierr)

  ! called from plasma_state_xload: check grids; store in xplasma structure

  USE plasma_state_definition_mod
  IMPLICIT NONE

  TYPE (plasma_state) :: ss     ! state data to write into xplasma
  INTEGER :: xhash(ps_hash_total)  ! hash data
  INTEGER, INTENT(IN) :: iout   ! LUN for messages
  INTEGER, INTENT(INOUT) :: ierr   ! completion code (set if error occurs)

  !-----------------------
  ! local:

  INTEGER, PARAMETER :: max_itemlist = ps_max_static

  INTEGER :: icomponent,imod,nitems,idchk
  CHARACTER*32 :: listname,units,list_units
  CHARACTER*80 :: label,plabel
  INTEGER :: ahash(ps_max_static)

  CHARACTER*32 :: item_names(max_itemlist)
  INTEGER :: item_ivals(max_itemlist)
  REAL(KIND=rspec) :: item_r8vals(max_itemlist)
  CHARACTER*256 :: item_c256(max_itemlist)

  !-----------------------

  ahash(1) = ps_phash_DIFB_NBI
  idchk = ss%id_DIFB_NBI
  ahash(2) = ps_phash_DIFB_FUSI
  idchk = min(idchk,ss%id_DIFB_FUSI)
  ahash(3) = ps_phash_DIFB_RFMI
  idchk = min(idchk,ss%id_DIFB_RFMI)
  IF(ALLOCATED(ss%difb_nbi).AND.hcheck(3,idchk)) THEN
     listname = "ANOM_DIFFUS"
     icomponent = ps_cnum_ANOM
     units = "m^2/sec"
     nitems = 3
     ! for assoc. scalar list:
     list_units = "m^2/sec"
     label = "simple avg: difb_nbi"

     plabel = "beam ion anomalous diffusivity"
     CALL ps_1d_prof_store(ss%iobj,"difb_nbi","RHO_ANOM", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_anom,0, &
          ss%difb_nbi,ss%id_difb_nbi, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "difb_nbi"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_difb_nbi
     item_c256(1) = plabel

     plabel = "fusion ion anomalous diffusivity"
     CALL ps_1d_prof_store(ss%iobj,"difb_fusi","RHO_ANOM", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_anom,0, &
          ss%difb_fusi,ss%id_difb_fusi, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(2) = "difb_fusi"
     item_r8vals(2) = 0.0_rspec
     item_ivals(2) = ss%id_difb_fusi
     item_c256(2) = plabel

     plabel = "RF minority ion anomalous diffusivity"
     CALL ps_1d_prof_store(ss%iobj,"difb_rfmi","RHO_ANOM", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_anom,0, &
          ss%difb_rfmi,ss%id_difb_rfmi, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(3) = "difb_rfmi"
     item_r8vals(3) = 0.0_rspec
     item_ivals(3) = ss%id_difb_rfmi
     item_c256(3) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_VELB_NBI
  idchk = ss%id_VELB_NBI
  ahash(2) = ps_phash_VELB_FUSI
  idchk = min(idchk,ss%id_VELB_FUSI)
  ahash(3) = ps_phash_VELB_RFMI
  idchk = min(idchk,ss%id_VELB_RFMI)
  IF(ALLOCATED(ss%velb_nbi).AND.hcheck(3,idchk)) THEN
     listname = "ANOM_VELOC"
     icomponent = ps_cnum_ANOM
     units = "m/sec"
     nitems = 3
     ! for assoc. scalar list:
     list_units = "m/sec"
     label = "simple avg: velb_nbi"

     plabel = "beam ion anom. radial velocity"
     CALL ps_1d_prof_store(ss%iobj,"velb_nbi","RHO_ANOM", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_anom,0, &
          ss%velb_nbi,ss%id_velb_nbi, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "velb_nbi"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_velb_nbi
     item_c256(1) = plabel

     plabel = "fusion ion anom. radial velocity"
     CALL ps_1d_prof_store(ss%iobj,"velb_fusi","RHO_ANOM", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_anom,0, &
          ss%velb_fusi,ss%id_velb_fusi, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(2) = "velb_fusi"
     item_r8vals(2) = 0.0_rspec
     item_ivals(2) = ss%id_velb_fusi
     item_c256(2) = plabel

     plabel = "RF minority ion anom. radial velocity"
     CALL ps_1d_prof_store(ss%iobj,"velb_rfmi","RHO_ANOM", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_anom,0, &
          ss%velb_rfmi,ss%id_velb_rfmi, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(3) = "velb_rfmi"
     item_r8vals(3) = 0.0_rspec
     item_ivals(3) = ss%id_velb_rfmi
     item_c256(3) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_PB0_HALO
  idchk = ss%id_PB0_HALO
  ahash(2) = ps_phash_PSC_HALO
  idchk = min(idchk,ss%id_PSC_HALO)
  ahash(3) = ps_phash_PCX_HALO
  idchk = min(idchk,ss%id_PCX_HALO)
  IF(ALLOCATED(ss%pb0_halo).AND.hcheck(3,idchk)) THEN
     listname = "BEAM_HALO_POWER"
     icomponent = ps_cnum_NBI
     units = "W"
     nitems = 3
     ! for assoc. scalar list:
     list_units = "W"
     label = "vol int: pb0_halo"

     plabel = "power in halo neutral source"
     CALL ps_1d_prof_store(ss%iobj,"pb0_halo","RHO_NBI", &
          units,icomponent,plabel,ps_stepdv,ps_bc_dflt, &
          ss%nrho_nbi-1,0, &
          ss%pb0_halo,ss%id_pb0_halo, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "pb0_halo"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_pb0_halo
     item_c256(1) = plabel

     plabel = "beam halo power: recapture - pb0_halo"
     CALL ps_1d_prof_store(ss%iobj,"psc_halo","RHO_NBI", &
          units,icomponent,plabel,ps_stepdv,ps_bc_dflt, &
          ss%nrho_nbi-1,0, &
          ss%psc_halo,ss%id_psc_halo, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(2) = "psc_halo"
     item_r8vals(2) = 0.0_rspec
     item_ivals(2) = ss%id_psc_halo
     item_c256(2) = plabel

     plabel = "beam halo driven CX power"
     CALL ps_1d_prof_store(ss%iobj,"pcx_halo","RHO_NBI", &
          units,icomponent,plabel,ps_stepdv,ps_bc_dflt, &
          ss%nrho_nbi-1,0, &
          ss%pcx_halo,ss%id_pcx_halo, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(3) = "pcx_halo"
     item_r8vals(3) = 0.0_rspec
     item_ivals(3) = ss%id_pcx_halo
     item_c256(3) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_TQB0_HALO
  idchk = ss%id_TQB0_HALO
  ahash(2) = ps_phash_TQSC_HALO
  idchk = min(idchk,ss%id_TQSC_HALO)
  ahash(3) = ps_phash_TQCX_HALO
  idchk = min(idchk,ss%id_TQCX_HALO)
  IF(ALLOCATED(ss%tqb0_halo).AND.hcheck(3,idchk)) THEN
     listname = "BEAM_HALO_TORQUE"
     icomponent = ps_cnum_NBI
     units = "Nt*m"
     nitems = 3
     ! for assoc. scalar list:
     list_units = "Nt*m"
     label = "vol int: tqb0_halo"

     plabel = "torque of halo neutral source"
     CALL ps_1d_prof_store(ss%iobj,"tqb0_halo","RHO_NBI", &
          units,icomponent,plabel,ps_stepdv,ps_bc_dflt, &
          ss%nrho_nbi-1,0, &
          ss%tqb0_halo,ss%id_tqb0_halo, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "tqb0_halo"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_tqb0_halo
     item_c256(1) = plabel

     plabel = "beam halo torque: recapture - tqb0_halo"
     CALL ps_1d_prof_store(ss%iobj,"tqsc_halo","RHO_NBI", &
          units,icomponent,plabel,ps_stepdv,ps_bc_dflt, &
          ss%nrho_nbi-1,0, &
          ss%tqsc_halo,ss%id_tqsc_halo, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(2) = "tqsc_halo"
     item_r8vals(2) = 0.0_rspec
     item_ivals(2) = ss%id_tqsc_halo
     item_c256(2) = plabel

     plabel = "beam halo driven CX momentum torque"
     CALL ps_1d_prof_store(ss%iobj,"tqcx_halo","RHO_NBI", &
          units,icomponent,plabel,ps_stepdv,ps_bc_dflt, &
          ss%nrho_nbi-1,0, &
          ss%tqcx_halo,ss%id_tqcx_halo, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(3) = "tqcx_halo"
     item_r8vals(3) = 0.0_rspec
     item_ivals(3) = ss%id_tqcx_halo
     item_c256(3) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_PBE
  idchk = ss%id_PBE
  ahash(2) = ps_phash_PBI
  idchk = min(idchk,ss%id_PBI)
  ahash(3) = ps_phash_PBTH
  idchk = min(idchk,ss%id_PBTH)
  IF(ALLOCATED(ss%pbe).AND.hcheck(3,idchk)) THEN
     listname = "BEAM_HEATING"
     icomponent = ps_cnum_NBI
     units = "W"
     nitems = 3
     ! for assoc. scalar list:
     list_units = "W"
     label = "vol int: pbe"

     plabel = "electron heating by all beam ions"
     CALL ps_1d_prof_store(ss%iobj,"pbe","RHO_NBI", &
          units,icomponent,plabel,ps_stepdv,ps_bc_dflt, &
          ss%nrho_nbi-1,0, &
          ss%pbe,ss%id_pbe, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "pbe"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_pbe
     item_c256(1) = plabel

     plabel = "thermal ion heating by all beam ions"
     CALL ps_1d_prof_store(ss%iobj,"pbi","RHO_NBI", &
          units,icomponent,plabel,ps_stepdv,ps_bc_dflt, &
          ss%nrho_nbi-1,0, &
          ss%pbi,ss%id_pbi, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(2) = "pbi"
     item_r8vals(2) = 0.0_rspec
     item_ivals(2) = ss%id_pbi
     item_c256(2) = plabel

     plabel = "thermalization of beam ions"
     CALL ps_1d_prof_store(ss%iobj,"pbth","RHO_NBI", &
          units,icomponent,plabel,ps_stepdv,ps_bc_dflt, &
          ss%nrho_nbi-1,0, &
          ss%pbth,ss%id_pbth, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(3) = "pbth"
     item_r8vals(3) = 0.0_rspec
     item_ivals(3) = ss%id_pbth
     item_c256(3) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_TQBE
  idchk = ss%id_TQBE
  ahash(2) = ps_phash_TQBI
  idchk = min(idchk,ss%id_TQBI)
  ahash(3) = ps_phash_TQBJXB
  idchk = min(idchk,ss%id_TQBJXB)
  ahash(4) = ps_phash_TQBTH
  idchk = min(idchk,ss%id_TQBTH)
  IF(ALLOCATED(ss%tqbe).AND.hcheck(4,idchk)) THEN
     listname = "BEAM_TORQUE"
     icomponent = ps_cnum_NBI
     units = "Nt*m"
     nitems = 4
     ! for assoc. scalar list:
     list_units = "Nt*m"
     label = "vol int: tqbe"

     plabel = "collisional beam torque to electrons"
     CALL ps_1d_prof_store(ss%iobj,"tqbe","RHO_NBI", &
          units,icomponent,plabel,ps_stepdv,ps_bc_dflt, &
          ss%nrho_nbi-1,0, &
          ss%tqbe,ss%id_tqbe, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "tqbe"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_tqbe
     item_c256(1) = plabel

     plabel = "collisional beam torque to thermal ions"
     CALL ps_1d_prof_store(ss%iobj,"tqbi","RHO_NBI", &
          units,icomponent,plabel,ps_stepdv,ps_bc_dflt, &
          ss%nrho_nbi-1,0, &
          ss%tqbi,ss%id_tqbi, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(2) = "tqbi"
     item_r8vals(2) = 0.0_rspec
     item_ivals(2) = ss%id_tqbi
     item_c256(2) = plabel

     plabel = "JxB beam torque"
     CALL ps_1d_prof_store(ss%iobj,"tqbjxb","RHO_NBI", &
          units,icomponent,plabel,ps_stepdv,ps_bc_dflt, &
          ss%nrho_nbi-1,0, &
          ss%tqbjxb,ss%id_tqbjxb, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(3) = "tqbjxb"
     item_r8vals(3) = 0.0_rspec
     item_ivals(3) = ss%id_tqbjxb
     item_c256(3) = plabel

     plabel = "momentum in thermalization of beam ions"
     CALL ps_1d_prof_store(ss%iobj,"tqbth","RHO_NBI", &
          units,icomponent,plabel,ps_stepdv,ps_bc_dflt, &
          ss%nrho_nbi-1,0, &
          ss%tqbth,ss%id_tqbth, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(4) = "tqbth"
     item_r8vals(4) = 0.0_rspec
     item_ivals(4) = ss%id_tqbth
     item_c256(4) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_B_SURFMAX
  idchk = ss%id_B_SURFMAX
  ahash(2) = ps_phash_B_SURFMIN
  idchk = min(idchk,ss%id_B_SURFMIN)
  IF(ALLOCATED(ss%B_surfMax).AND.hcheck(2,idchk)) THEN
     listname = "BMINMAX"
     icomponent = ps_cnum_EQ
     units = "T"
     nitems = 2
     ! for assoc. scalar list:
     list_units = "T"
     label = "edge value: B_surfMax"

     plabel = "max mod(B) on flux surface"
     CALL ps_1d_prof_store(ss%iobj,"B_surfMax","RHO_EQ_GEO", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_eq_geo,0, &
          ss%B_surfMax,ss%id_B_surfMax, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "B_surfMax"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_B_surfMax
     item_c256(1) = plabel

     plabel = "min mod(B) on flux surface"
     CALL ps_1d_prof_store(ss%iobj,"B_surfMin","RHO_EQ_GEO", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_eq_geo,0, &
          ss%B_surfMin,ss%id_B_surfMin, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(2) = "B_surfMin"
     item_r8vals(2) = 0.0_rspec
     item_ivals(2) = ss%id_B_surfMin
     item_c256(2) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_QCOMP_E
  idchk = ss%id_QCOMP_E
  ahash(2) = ps_phash_QCOMP_I
  idchk = min(idchk,ss%id_QCOMP_I)
  IF(ALLOCATED(ss%qcomp_e).AND.hcheck(2,idchk)) THEN
     listname = "COMPRESSION"
     icomponent = ps_cnum_PLASMA
     units = "W"
     nitems = 2
     ! for assoc. scalar list:
     list_units = "W"
     label = "vol int: qcomp_e"

     plabel = "Compressional electron heating"
     CALL ps_1d_prof_store(ss%iobj,"qcomp_e","RHO", &
          units,icomponent,plabel,ps_stepdv,ps_bc_dflt, &
          ss%nrho-1,0, &
          ss%qcomp_e,ss%id_qcomp_e, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "qcomp_e"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_qcomp_e
     item_c256(1) = plabel

     plabel = "Compressional ion heating"
     CALL ps_1d_prof_store(ss%iobj,"qcomp_i","RHO", &
          units,icomponent,plabel,ps_stepdv,ps_bc_dflt, &
          ss%nrho-1,0, &
          ss%qcomp_i,ss%id_qcomp_i, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(2) = "qcomp_i"
     item_r8vals(2) = 0.0_rspec
     item_ivals(2) = ss%id_qcomp_i
     item_c256(2) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_CHIE_TRANS
  idchk = ss%id_CHIE_TRANS
  ahash(2) = ps_phash_CHII_TRANS
  idchk = min(idchk,ss%id_CHII_TRANS)
  ahash(3) = ps_phash_CHIMO_TRANS
  idchk = min(idchk,ss%id_CHIMO_TRANS)
  IF(ALLOCATED(ss%chie_trans).AND.hcheck(3,idchk)) THEN
     listname = "DIFFUSIVITY"
     icomponent = ps_cnum_PLASMA
     units = "m^2/sec"
     nitems = 3
     ! for assoc. scalar list:
     list_units = "m^2/sec"
     label = "simple avg: chie_trans"

     plabel = "electron thermal diffusivity"
     CALL ps_1d_prof_store(ss%iobj,"chie_trans","RHO", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho,0, &
          ss%chie_trans,ss%id_chie_trans, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "chie_trans"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_chie_trans
     item_c256(1) = plabel

     plabel = "ion thermal diffusivity"
     CALL ps_1d_prof_store(ss%iobj,"chii_trans","RHO", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho,0, &
          ss%chii_trans,ss%id_chii_trans, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(2) = "chii_trans"
     item_r8vals(2) = 0.0_rspec
     item_ivals(2) = ss%id_chii_trans
     item_c256(2) = plabel

     plabel = "angular momentum diffusivity"
     CALL ps_1d_prof_store(ss%iobj,"chimo_trans","RHO", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho,0, &
          ss%chimo_trans,ss%id_chimo_trans, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(3) = "chimo_trans"
     item_r8vals(3) = 0.0_rspec
     item_ivals(3) = ss%id_chimo_trans
     item_c256(3) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_PFUSE
  idchk = ss%id_PFUSE
  ahash(2) = ps_phash_PFUSI
  idchk = min(idchk,ss%id_PFUSI)
  ahash(3) = ps_phash_PFUSTH
  idchk = min(idchk,ss%id_PFUSTH)
  IF(ALLOCATED(ss%pfuse).AND.hcheck(3,idchk)) THEN
     listname = "FUSION_HEATING"
     icomponent = ps_cnum_FUS
     units = "W"
     nitems = 3
     ! for assoc. scalar list:
     list_units = "W"
     label = "vol int: pfuse"

     plabel = "electron heating by all fusion ions"
     CALL ps_1d_prof_store(ss%iobj,"pfuse","RHO_FUS", &
          units,icomponent,plabel,ps_stepdv,ps_bc_dflt, &
          ss%nrho_fus-1,0, &
          ss%pfuse,ss%id_pfuse, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "pfuse"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_pfuse
     item_c256(1) = plabel

     plabel = "thermal ion heating by all fusion ions"
     CALL ps_1d_prof_store(ss%iobj,"pfusi","RHO_FUS", &
          units,icomponent,plabel,ps_stepdv,ps_bc_dflt, &
          ss%nrho_fus-1,0, &
          ss%pfusi,ss%id_pfusi, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(2) = "pfusi"
     item_r8vals(2) = 0.0_rspec
     item_ivals(2) = ss%id_pfusi
     item_c256(2) = plabel

     plabel = "thermalization of fusion ions"
     CALL ps_1d_prof_store(ss%iobj,"pfusth","RHO_FUS", &
          units,icomponent,plabel,ps_stepdv,ps_bc_dflt, &
          ss%nrho_fus-1,0, &
          ss%pfusth,ss%id_pfusth, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(3) = "pfusth"
     item_r8vals(3) = 0.0_rspec
     item_ivals(3) = ss%id_pfusth
     item_c256(3) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_PELH
  idchk = ss%id_PELH
  ahash(2) = ps_phash_PILH
  idchk = min(idchk,ss%id_PILH)
  IF(ALLOCATED(ss%pelh).AND.hcheck(2,idchk)) THEN
     listname = "LOWER_HYBRID_HEATING"
     icomponent = ps_cnum_LH
     units = "W"
     nitems = 2
     ! for assoc. scalar list:
     list_units = "W"
     label = "vol int: pelh"

     plabel = "electron heating by LH"
     CALL ps_1d_prof_store(ss%iobj,"pelh","RHO_LHRF", &
          units,icomponent,plabel,ps_stepdv,ps_bc_dflt, &
          ss%nrho_lhrf-1,0, &
          ss%pelh,ss%id_pelh, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "pelh"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_pelh
     item_c256(1) = plabel

     plabel = "ion heating by LH"
     CALL ps_1d_prof_store(ss%iobj,"pilh","RHO_LHRF", &
          units,icomponent,plabel,ps_stepdv,ps_bc_dflt, &
          ss%nrho_lhrf-1,0, &
          ss%pilh,ss%id_pilh, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(2) = "pilh"
     item_r8vals(2) = 0.0_rspec
     item_ivals(2) = ss%id_pilh
     item_c256(2) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_Z_MIDP
  idchk = ss%id_Z_MIDP
  ahash(2) = ps_phash_R_MIDP_IN
  idchk = min(idchk,ss%id_R_MIDP_IN)
  ahash(3) = ps_phash_R_MIDP_OUT
  idchk = min(idchk,ss%id_R_MIDP_OUT)
  IF(ALLOCATED(ss%Z_midp).AND.hcheck(3,idchk)) THEN
     listname = "MIDPLANE"
     icomponent = ps_cnum_EQ
     units = "m"
     nitems = 3
     ! for assoc. scalar list:
     list_units = "m"
     label = "edge value: Z_midp"

     plabel = "flux surface midplane elevation"
     CALL ps_1d_prof_store(ss%iobj,"Z_midp","RHO_EQ_GEO", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_eq_geo,0, &
          ss%Z_midp,ss%id_Z_midp, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "Z_midp"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_Z_midp
     item_c256(1) = plabel

     plabel = "R (high field side) midplane intercept"
     CALL ps_1d_prof_store(ss%iobj,"R_midp_in","RHO_EQ_GEO", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_eq_geo,0, &
          ss%R_midp_in,ss%id_R_midp_in, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(2) = "R_midp_in"
     item_r8vals(2) = 0.0_rspec
     item_ivals(2) = ss%id_R_midp_in
     item_c256(2) = plabel

     plabel = "R (low field side) midplane intercept"
     CALL ps_1d_prof_store(ss%iobj,"R_midp_out","RHO_EQ_GEO", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_eq_geo,0, &
          ss%R_midp_out,ss%id_R_midp_out, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(3) = "R_midp_out"
     item_r8vals(3) = 0.0_rspec
     item_ivals(3) = ss%id_R_midp_out
     item_c256(3) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_PMINE
  idchk = ss%id_PMINE
  ahash(2) = ps_phash_PMINI
  idchk = min(idchk,ss%id_PMINI)
  ahash(3) = ps_phash_PMINTH
  idchk = min(idchk,ss%id_PMINTH)
  IF(ALLOCATED(ss%pmine).AND.hcheck(3,idchk)) THEN
     listname = "MINORITY_HEATING"
     icomponent = ps_cnum_IC
     units = "W"
     nitems = 3
     ! for assoc. scalar list:
     list_units = "W"
     label = "vol int: pmine"

     plabel = "electron heating by minority ions"
     CALL ps_1d_prof_store(ss%iobj,"pmine","RHO_ICRF", &
          units,icomponent,plabel,ps_stepdv,ps_bc_dflt, &
          ss%nrho_icrf-1,0, &
          ss%pmine,ss%id_pmine, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "pmine"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_pmine
     item_c256(1) = plabel

     plabel = "thermal ion heating by minority ions"
     CALL ps_1d_prof_store(ss%iobj,"pmini","RHO_ICRF", &
          units,icomponent,plabel,ps_stepdv,ps_bc_dflt, &
          ss%nrho_icrf-1,0, &
          ss%pmini,ss%id_pmini, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(2) = "pmini"
     item_r8vals(2) = 0.0_rspec
     item_ivals(2) = ss%id_pmini
     item_c256(2) = plabel

     plabel = "(de)thermalization of minority ions"
     CALL ps_1d_prof_store(ss%iobj,"pminth","RHO_ICRF", &
          units,icomponent,plabel,ps_stepdv,ps_bc_dflt, &
          ss%nrho_icrf-1,0, &
          ss%pminth,ss%id_pminth, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(3) = "pminth"
     item_r8vals(3) = 0.0_rspec
     item_ivals(3) = ss%id_pminth
     item_c256(3) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_VEE_TRANS
  idchk = ss%id_VEE_TRANS
  ahash(2) = ps_phash_VIE_TRANS
  idchk = min(idchk,ss%id_VIE_TRANS)
  ahash(3) = ps_phash_VMO_TRANS
  idchk = min(idchk,ss%id_VMO_TRANS)
  IF(ALLOCATED(ss%vee_trans).AND.hcheck(3,idchk)) THEN
     listname = "RADIAL_VELOCITY"
     icomponent = ps_cnum_PLASMA
     units = "m/sec"
     nitems = 3
     ! for assoc. scalar list:
     list_units = "m/sec"
     label = "simple avg: vee_trans"

     plabel = "electron energy radial velocity"
     CALL ps_1d_prof_store(ss%iobj,"vee_trans","RHO", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho,0, &
          ss%vee_trans,ss%id_vee_trans, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "vee_trans"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_vee_trans
     item_c256(1) = plabel

     plabel = "ion energy radial velocity"
     CALL ps_1d_prof_store(ss%iobj,"vie_trans","RHO", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho,0, &
          ss%vie_trans,ss%id_vie_trans, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(2) = "vie_trans"
     item_r8vals(2) = 0.0_rspec
     item_ivals(2) = ss%id_vie_trans
     item_c256(2) = plabel

     plabel = "angular momentum radial velocity"
     CALL ps_1d_prof_store(ss%iobj,"vmo_trans","RHO", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho,0, &
          ss%vmo_trans,ss%id_vmo_trans, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(3) = "vmo_trans"
     item_r8vals(3) = 0.0_rspec
     item_ivals(3) = ss%id_vmo_trans
     item_c256(3) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_PRAD
  idchk = ss%id_PRAD
  ahash(2) = ps_phash_PRAD_CY
  idchk = min(idchk,ss%id_PRAD_CY)
  ahash(3) = ps_phash_PRAD_BR
  idchk = min(idchk,ss%id_PRAD_BR)
  ahash(4) = ps_phash_PRAD_LI
  idchk = min(idchk,ss%id_PRAD_LI)
  IF(ALLOCATED(ss%prad).AND.hcheck(4,idchk)) THEN
     listname = "RADIATED_POWERS"
     icomponent = ps_cnum_RAD
     units = "W"
     nitems = 4
     ! for assoc. scalar list:
     list_units = "W"
     label = "vol int: prad"

     plabel = "total radiated power"
     CALL ps_1d_prof_store(ss%iobj,"prad","RHO_RAD", &
          units,icomponent,plabel,ps_stepdv,ps_bc_dflt, &
          ss%nrho_rad-1,0, &
          ss%prad,ss%id_prad, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "prad"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_prad
     item_c256(1) = plabel

     plabel = "cyclotron radiation contribution"
     CALL ps_1d_prof_store(ss%iobj,"prad_cy","RHO_RAD", &
          units,icomponent,plabel,ps_stepdv,ps_bc_dflt, &
          ss%nrho_rad-1,0, &
          ss%prad_cy,ss%id_prad_cy, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(2) = "prad_cy"
     item_r8vals(2) = 0.0_rspec
     item_ivals(2) = ss%id_prad_cy
     item_c256(2) = plabel

     plabel = "bremsstrahlung contribution"
     CALL ps_1d_prof_store(ss%iobj,"prad_br","RHO_RAD", &
          units,icomponent,plabel,ps_stepdv,ps_bc_dflt, &
          ss%nrho_rad-1,0, &
          ss%prad_br,ss%id_prad_br, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(3) = "prad_br"
     item_r8vals(3) = 0.0_rspec
     item_ivals(3) = ss%id_prad_br
     item_c256(3) = plabel

     plabel = "line radiation contribution"
     CALL ps_1d_prof_store(ss%iobj,"prad_li","RHO_RAD", &
          units,icomponent,plabel,ps_stepdv,ps_bc_dflt, &
          ss%nrho_rad-1,0, &
          ss%prad_li,ss%id_prad_li, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(4) = "prad_li"
     item_r8vals(4) = 0.0_rspec
     item_ivals(4) = ss%id_prad_li
     item_c256(4) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_P0_RECO
  idchk = ss%id_P0_RECO
  ahash(2) = ps_phash_PSC_RECO
  idchk = min(idchk,ss%id_PSC_RECO)
  ahash(3) = ps_phash_PCX_RECO
  idchk = min(idchk,ss%id_PCX_RECO)
  IF(ALLOCATED(ss%p0_reco).AND.hcheck(3,idchk)) THEN
     listname = "RECO_POWER"
     icomponent = ps_cnum_GAS
     units = "W"
     nitems = 3
     ! for assoc. scalar list:
     list_units = "W"
     label = "vol int: p0_reco"

     plabel = "power in recombination neutral source"
     CALL ps_1d_prof_store(ss%iobj,"p0_reco","RHO_GAS", &
          units,icomponent,plabel,ps_stepdv,ps_bc_dflt, &
          ss%nrho_gas-1,0, &
          ss%p0_reco,ss%id_p0_reco, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "p0_reco"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_p0_reco
     item_c256(1) = plabel

     plabel = "reco power: recapture - p0_reco"
     CALL ps_1d_prof_store(ss%iobj,"psc_reco","RHO_GAS", &
          units,icomponent,plabel,ps_stepdv,ps_bc_dflt, &
          ss%nrho_gas-1,0, &
          ss%psc_reco,ss%id_psc_reco, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(2) = "psc_reco"
     item_r8vals(2) = 0.0_rspec
     item_ivals(2) = ss%id_psc_reco
     item_c256(2) = plabel

     plabel = "reco driven CX power"
     CALL ps_1d_prof_store(ss%iobj,"pcx_reco","RHO_GAS", &
          units,icomponent,plabel,ps_stepdv,ps_bc_dflt, &
          ss%nrho_gas-1,0, &
          ss%pcx_reco,ss%id_pcx_reco, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(3) = "pcx_reco"
     item_r8vals(3) = 0.0_rspec
     item_ivals(3) = ss%id_pcx_reco
     item_c256(3) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_TQ0_RECO
  idchk = ss%id_TQ0_RECO
  ahash(2) = ps_phash_TQSC_RECO
  idchk = min(idchk,ss%id_TQSC_RECO)
  ahash(3) = ps_phash_TQCX_RECO
  idchk = min(idchk,ss%id_TQCX_RECO)
  IF(ALLOCATED(ss%tq0_reco).AND.hcheck(3,idchk)) THEN
     listname = "RECO_TORQUE"
     icomponent = ps_cnum_GAS
     units = "Nt*m"
     nitems = 3
     ! for assoc. scalar list:
     list_units = "Nt*m"
     label = "vol int: tq0_reco"

     plabel = "torque of recombination neutral source"
     CALL ps_1d_prof_store(ss%iobj,"tq0_reco","RHO_GAS", &
          units,icomponent,plabel,ps_stepdv,ps_bc_dflt, &
          ss%nrho_gas-1,0, &
          ss%tq0_reco,ss%id_tq0_reco, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "tq0_reco"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_tq0_reco
     item_c256(1) = plabel

     plabel = "reco torque: recapture - tq0_reco"
     CALL ps_1d_prof_store(ss%iobj,"tqsc_reco","RHO_GAS", &
          units,icomponent,plabel,ps_stepdv,ps_bc_dflt, &
          ss%nrho_gas-1,0, &
          ss%tqsc_reco,ss%id_tqsc_reco, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(2) = "tqsc_reco"
     item_r8vals(2) = 0.0_rspec
     item_ivals(2) = ss%id_tqsc_reco
     item_c256(2) = plabel

     plabel = "reco driven CX momentum torque"
     CALL ps_1d_prof_store(ss%iobj,"tqcx_reco","RHO_GAS", &
          units,icomponent,plabel,ps_stepdv,ps_bc_dflt, &
          ss%nrho_gas-1,0, &
          ss%tqcx_reco,ss%id_tqcx_reco, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(3) = "tqcx_reco"
     item_r8vals(3) = 0.0_rspec
     item_ivals(3) = ss%id_tqcx_reco
     item_c256(3) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_RES_TE
  idchk = ss%id_RES_TE
  ahash(2) = ps_phash_RES_TI
  idchk = min(idchk,ss%id_RES_TI)
  IF(ALLOCATED(ss%res_te).AND.hcheck(2,idchk)) THEN
     listname = "RESIDUAL"
     icomponent = ps_cnum_PLASMA
     units = "Norm"
     nitems = 2
     ! for assoc. scalar list:
     list_units = "Norm"
     label = "vol int: res_te"

     plabel = "residuals for electron transport eqn"
     CALL ps_1d_prof_store(ss%iobj,"res_te","RHO", &
          units,icomponent,plabel,ps_stepdv,ps_bc_dflt, &
          ss%nrho-1,0, &
          ss%res_te,ss%id_res_te, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "res_te"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_res_te
     item_c256(1) = plabel

     plabel = "residuals for ion transport eqn"
     CALL ps_1d_prof_store(ss%iobj,"res_ti","RHO", &
          units,icomponent,plabel,ps_stepdv,ps_bc_dflt, &
          ss%nrho-1,0, &
          ss%res_ti,ss%id_res_ti, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(2) = "res_ti"
     item_r8vals(2) = 0.0_rspec
     item_ivals(2) = ss%id_res_ti
     item_c256(2) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_TFRIP_LOG
  idchk = ss%id_TFRIP_LOG
  ahash(2) = ps_phash_TFRIP2_LOG
  idchk = min(idchk,ss%id_TFRIP2_LOG)
  IF(ALLOCATED(ss%tfrip_log).AND.hcheck(2,idchk)) THEN
     listname = "RIPPLE_FIELDS"
     icomponent = ps_cnum_RIPPLE
     units = "-"
     nitems = 2
     ! for assoc. scalar list:
     list_units = "-"
     label = "simple avg: tfrip_log"

     plabel = "TF ripple: log((Bmax-Bmin)/(Bmax+Bmin))"
     CALL ps_2d_prof_store(ss%iobj,"tfrip_log","R_RIPPLE","Z_RIPPLE", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nr_rip,ss%nz_rip,0,0, &
          ss%tfrip_log,ss%id_tfrip_log, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "tfrip_log"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_tfrip_log
     item_c256(1) = plabel

     plabel = "2nd component of TF ripple"
     CALL ps_2d_prof_store(ss%iobj,"tfrip2_log","R_RIPPLE","Z_RIPPLE", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nr_rip,ss%nz_rip,0,0, &
          ss%tfrip2_log,ss%id_tfrip2_log, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(2) = "tfrip2_log"
     item_r8vals(2) = 0.0_rspec
     item_ivals(2) = ss%id_tfrip2_log
     item_c256(2) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_RMAJOR_MEAN
  idchk = ss%id_RMAJOR_MEAN
  ahash(2) = ps_phash_RMINOR_MEAN
  idchk = min(idchk,ss%id_RMINOR_MEAN)
  IF(ALLOCATED(ss%Rmajor_mean).AND.hcheck(2,idchk)) THEN
     listname = "RMAJMIN"
     icomponent = ps_cnum_EQ
     units = "m"
     nitems = 2
     ! for assoc. scalar list:
     list_units = "m"
     label = "edge value: Rmajor_mean"

     plabel = "Rmajor_mean = (R_Surfmax+R_surfmin)/2"
     CALL ps_1d_prof_store(ss%iobj,"Rmajor_mean","RHO_EQ_GEO", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_eq_geo,0, &
          ss%Rmajor_mean,ss%id_Rmajor_mean, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "Rmajor_mean"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_Rmajor_mean
     item_c256(1) = plabel

     plabel = "rMinor_mean = (R_Surfmax-R_surfmin)/2"
     CALL ps_1d_prof_store(ss%iobj,"rMinor_mean","RHO_EQ_GEO", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_eq_geo,0, &
          ss%rMinor_mean,ss%id_rMinor_mean, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(2) = "rMinor_mean"
     item_r8vals(2) = 0.0_rspec
     item_ivals(2) = ss%id_rMinor_mean
     item_c256(2) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_QROT_CONV
  idchk = ss%id_QROT_CONV
  ahash(2) = ps_phash_QROT_DIFF
  idchk = min(idchk,ss%id_QROT_DIFF)
  IF(ALLOCATED(ss%qrot_conv).AND.hcheck(2,idchk)) THEN
     listname = "ROTATION_DISSIPATION"
     icomponent = ps_cnum_PLASMA
     units = "W"
     nitems = 2
     ! for assoc. scalar list:
     list_units = "W"
     label = "vol int: qrot_conv"

     plabel = "rotational energy dissipation (convective)"
     CALL ps_1d_prof_store(ss%iobj,"qrot_conv","RHO", &
          units,icomponent,plabel,ps_stepdv,ps_bc_dflt, &
          ss%nrho-1,0, &
          ss%qrot_conv,ss%id_qrot_conv, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "qrot_conv"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_qrot_conv
     item_c256(1) = plabel

     plabel = "rotational energy dissipation (diffusive)"
     CALL ps_1d_prof_store(ss%iobj,"qrot_diff","RHO", &
          units,icomponent,plabel,ps_stepdv,ps_bc_dflt, &
          ss%nrho-1,0, &
          ss%qrot_diff,ss%id_qrot_diff, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(2) = "qrot_diff"
     item_r8vals(2) = 0.0_rspec
     item_ivals(2) = ss%id_qrot_diff
     item_c256(2) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_R_SURFMAX
  idchk = ss%id_R_SURFMAX
  ahash(2) = ps_phash_R_SURFMIN
  idchk = min(idchk,ss%id_R_SURFMIN)
  ahash(3) = ps_phash_Z_SURFMAX
  idchk = min(idchk,ss%id_Z_SURFMAX)
  ahash(4) = ps_phash_Z_SURFMIN
  idchk = min(idchk,ss%id_Z_SURFMIN)
  IF(ALLOCATED(ss%R_surfMax).AND.hcheck(4,idchk)) THEN
     listname = "RZMINMAX"
     icomponent = ps_cnum_EQ
     units = "m"
     nitems = 4
     ! for assoc. scalar list:
     list_units = "m"
     label = "edge value: R_surfMax"

     plabel = "max R on flux surface"
     CALL ps_1d_prof_store(ss%iobj,"R_surfMax","RHO_EQ_GEO", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_eq_geo,0, &
          ss%R_surfMax,ss%id_R_surfMax, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "R_surfMax"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_R_surfMax
     item_c256(1) = plabel

     plabel = "min R on flux surface"
     CALL ps_1d_prof_store(ss%iobj,"R_surfMin","RHO_EQ_GEO", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_eq_geo,0, &
          ss%R_surfMin,ss%id_R_surfMin, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(2) = "R_surfMin"
     item_r8vals(2) = 0.0_rspec
     item_ivals(2) = ss%id_R_surfMin
     item_c256(2) = plabel

     plabel = "max Z on flux surface"
     CALL ps_1d_prof_store(ss%iobj,"Z_surfMax","RHO_EQ_GEO", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_eq_geo,0, &
          ss%Z_surfMax,ss%id_Z_surfMax, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(3) = "Z_surfMax"
     item_r8vals(3) = 0.0_rspec
     item_ivals(3) = ss%id_Z_surfMax
     item_c256(3) = plabel

     plabel = "min Z on flux surface"
     CALL ps_1d_prof_store(ss%iobj,"Z_surfMin","RHO_EQ_GEO", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_eq_geo,0, &
          ss%Z_surfMin,ss%id_Z_surfMin, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(4) = "Z_surfMin"
     item_r8vals(4) = 0.0_rspec
     item_ivals(4) = ss%id_Z_surfMin
     item_c256(4) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_ELONG
  idchk = ss%id_ELONG
  ahash(2) = ps_phash_TRIANG
  idchk = min(idchk,ss%id_TRIANG)
  ahash(3) = ps_phash_TRIANGU
  idchk = min(idchk,ss%id_TRIANGU)
  ahash(4) = ps_phash_TRIANGL
  idchk = min(idchk,ss%id_TRIANGL)
  ahash(5) = ps_phash_SQUAREUO
  idchk = min(idchk,ss%id_SQUAREUO)
  ahash(6) = ps_phash_SQUARELO
  idchk = min(idchk,ss%id_SQUARELO)
  IF(ALLOCATED(ss%elong).AND.hcheck(6,idchk)) THEN
     listname = "SURFSHAPE"
     icomponent = ps_cnum_EQ
     units = "-"
     nitems = 6
     ! for assoc. scalar list:
     list_units = "-"
     label = "edge value: elong"

     plabel = "elongation (b/a)"
     CALL ps_1d_prof_store(ss%iobj,"elong","RHO_EQ_GEO", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_eq_geo,0, &
          ss%elong,ss%id_elong, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "elong"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_elong
     item_c256(1) = plabel

     plabel = "triangularity (symmetrized)"
     CALL ps_1d_prof_store(ss%iobj,"triang","RHO_EQ_GEO", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_eq_geo,0, &
          ss%triang,ss%id_triang, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(2) = "triang"
     item_r8vals(2) = 0.0_rspec
     item_ivals(2) = ss%id_triang
     item_c256(2) = plabel

     plabel = "upper triangularity"
     CALL ps_1d_prof_store(ss%iobj,"triangU","RHO_EQ_GEO", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_eq_geo,0, &
          ss%triangU,ss%id_triangU, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(3) = "triangU"
     item_r8vals(3) = 0.0_rspec
     item_ivals(3) = ss%id_triangU
     item_c256(3) = plabel

     plabel = "lower triangularity"
     CALL ps_1d_prof_store(ss%iobj,"triangL","RHO_EQ_GEO", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_eq_geo,0, &
          ss%triangL,ss%id_triangL, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(4) = "triangL"
     item_r8vals(4) = 0.0_rspec
     item_ivals(4) = ss%id_triangL
     item_c256(4) = plabel

     plabel = "upper outer squareness"
     CALL ps_1d_prof_store(ss%iobj,"squareUO","RHO_EQ_GEO", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_eq_geo,0, &
          ss%squareUO,ss%id_squareUO, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(5) = "squareUO"
     item_r8vals(5) = 0.0_rspec
     item_ivals(5) = ss%id_squareUO
     item_c256(5) = plabel

     plabel = "lower outer squareness"
     CALL ps_1d_prof_store(ss%iobj,"squareLO","RHO_EQ_GEO", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_eq_geo,0, &
          ss%squareLO,ss%id_squareLO, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(6) = "squareLO"
     item_r8vals(6) = 0.0_rspec
     item_ivals(6) = ss%id_squareLO
     item_c256(6) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_PE_TRANS
  idchk = ss%id_PE_TRANS
  ahash(2) = ps_phash_PI_TRANS
  idchk = min(idchk,ss%id_PI_TRANS)
  IF(ALLOCATED(ss%pe_trans).AND.hcheck(2,idchk)) THEN
     listname = "TRANSPORT"
     icomponent = ps_cnum_PLASMA
     units = "W"
     nitems = 2
     ! for assoc. scalar list:
     list_units = "W"
     label = "vol int: pe_trans"

     plabel = "electron transport (loss) power"
     CALL ps_1d_prof_store(ss%iobj,"pe_trans","RHO", &
          units,icomponent,plabel,ps_stepdv,ps_bc_dflt, &
          ss%nrho-1,0, &
          ss%pe_trans,ss%id_pe_trans, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "pe_trans"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_pe_trans
     item_c256(1) = plabel

     plabel = "ion transport (loss) power"
     CALL ps_1d_prof_store(ss%iobj,"pi_trans","RHO", &
          units,icomponent,plabel,ps_stepdv,ps_bc_dflt, &
          ss%nrho-1,0, &
          ss%pi_trans,ss%id_pi_trans, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(2) = "pi_trans"
     item_r8vals(2) = 0.0_rspec
     item_ivals(2) = ss%id_pi_trans
     item_c256(2) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_TRIANG_MILLER_U
  idchk = ss%id_TRIANG_MILLER_U
  ahash(2) = ps_phash_TRIANG_MILLER_L
  idchk = min(idchk,ss%id_TRIANG_MILLER_L)
  IF(ALLOCATED(ss%triang_miller_U).AND.hcheck(2,idchk)) THEN
     listname = "TRIANG_MILLER"
     icomponent = ps_cnum_EQ
     units = "-"
     nitems = 2
     ! for assoc. scalar list:
     list_units = "-"
     label = "edge value: triang_miller_U"

     plabel = "Miller upper triangularity"
     CALL ps_1d_prof_store(ss%iobj,"triang_miller_U","RHO_EQ_GEO", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_eq_geo,0, &
          ss%triang_miller_U,ss%id_triang_miller_U, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "triang_miller_U"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_triang_miller_U
     item_c256(1) = plabel

     plabel = "Miller lower triangularity"
     CALL ps_1d_prof_store(ss%iobj,"triang_miller_L","RHO_EQ_GEO", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho_eq_geo,0, &
          ss%triang_miller_L,ss%id_triang_miller_L, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(2) = "triang_miller_L"
     item_r8vals(2) = 0.0_rspec
     item_ivals(2) = ss%id_triang_miller_L
     item_c256(2) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_UPWIND_PFRAC_TE
  idchk = ss%id_UPWIND_PFRAC_TE
  ahash(2) = ps_phash_UPWIND_PFRAC_TI
  idchk = min(idchk,ss%id_UPWIND_PFRAC_TI)
  ahash(3) = ps_phash_UPWIND_PFRAC_OMEGA
  idchk = min(idchk,ss%id_UPWIND_PFRAC_OMEGA)
  IF(ALLOCATED(ss%upwind_pfrac_Te).AND.hcheck(3,idchk)) THEN
     listname = "UPWIND_FORWARD_FRACTIONS"
     icomponent = ps_cnum_PLASMA
     units = "-"
     nitems = 3
     ! for assoc. scalar list:
     list_units = "-"
     label = "simple avg: upwind_pfrac_Te"

     plabel = "Te (electron energy advection) forward upwind fraction"
     CALL ps_1d_prof_store(ss%iobj,"upwind_pfrac_Te","RHO", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho,0, &
          ss%upwind_pfrac_Te,ss%id_upwind_pfrac_Te, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "upwind_pfrac_Te"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_upwind_pfrac_Te
     item_c256(1) = plabel

     plabel = "Ti (ion energy advection) forward upwind fraction"
     CALL ps_1d_prof_store(ss%iobj,"upwind_pfrac_Ti","RHO", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho,0, &
          ss%upwind_pfrac_Ti,ss%id_upwind_pfrac_Ti, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(2) = "upwind_pfrac_Ti"
     item_r8vals(2) = 0.0_rspec
     item_ivals(2) = ss%id_upwind_pfrac_Ti
     item_c256(2) = plabel

     plabel = "omega (ang. velocity) forward upwind fraction"
     CALL ps_1d_prof_store(ss%iobj,"upwind_pfrac_omega","RHO", &
          units,icomponent,plabel,ps_pclin,ps_bc_dflt, &
          ss%nrho,0, &
          ss%upwind_pfrac_omega,ss%id_upwind_pfrac_omega, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(3) = "upwind_pfrac_omega"
     item_r8vals(3) = 0.0_rspec
     item_ivals(3) = ss%id_upwind_pfrac_omega
     item_c256(3) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_ZEFF
  idchk = ss%id_ZEFF
  ahash(2) = ps_phash_ZEFF_TH
  idchk = min(idchk,ss%id_ZEFF_TH)
  ahash(3) = ps_phash_ZEFF_FI
  idchk = min(idchk,ss%id_ZEFF_FI)
  IF(ALLOCATED(ss%Zeff).AND.hcheck(3,idchk)) THEN
     listname = "ZEFF_GROUP"
     icomponent = ps_cnum_PLASMA
     units = "-"
     nitems = 3
     ! for assoc. scalar list:
     list_units = "-"
     label = "wght avg (density): Zeff"

     plabel = "Zeff (sum[nj*Zj**2]/ne)"
     CALL ps_1d_prof_store(ss%iobj,"Zeff","RHO", &
          units,icomponent,plabel,ps_stepfun,ps_bc_dflt, &
          ss%nrho-1,0, &
          ss%Zeff,ss%id_Zeff, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(1) = "Zeff"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%id_Zeff
     item_c256(1) = plabel

     plabel = "Thermal ion contribution to Zeff"
     CALL ps_1d_prof_store(ss%iobj,"Zeff_th","RHO", &
          units,icomponent,plabel,ps_stepfun,ps_bc_dflt, &
          ss%nrho-1,0, &
          ss%Zeff_th,ss%id_Zeff_th, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(2) = "Zeff_th"
     item_r8vals(2) = 0.0_rspec
     item_ivals(2) = ss%id_Zeff_th
     item_c256(2) = plabel

     plabel = "Fast ion contribution to Zeff"
     CALL ps_1d_prof_store(ss%iobj,"Zeff_fi","RHO", &
          units,icomponent,plabel,ps_stepfun,ps_bc_dflt, &
          ss%nrho-1,0, &
          ss%Zeff_fi,ss%id_Zeff_fi, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_names(3) = "Zeff_fi"
     item_r8vals(3) = 0.0_rspec
     item_ivals(3) = ss%id_Zeff_fi
     item_c256(3) = plabel

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

CONTAINS

  LOGICAL FUNCTION hcheck(inum,idchk)
     INTEGER, intent(in) :: inum
     INTEGER, intent(in) :: idchk

     !  check all hash codes: set function value TRUE if any show changes.
     !  also set TRUE if idchk = 0

     INTEGER :: ia1,ia2,ii

     if(idchk.eq.0) then
        hcheck=.TRUE.
        return
     endif

     hcheck = .FALSE.
     DO ii=1,inum
        hcheck = .TRUE.
        ia1 = ahash(ii)
        ia2 = ia1 + 1
        IF(ss%hash_codes(ia1).NE.ss%new_hash_codes(ia1)) EXIT
        IF(ss%hash_codes(ia2).NE.ss%new_hash_codes(ia2)) EXIT
        IF(xhash(ia1).NE.ss%new_hash_codes(ia1)) EXIT
        IF(xhash(ia2).NE.ss%new_hash_codes(ia2)) EXIT
        hcheck = .FALSE.
     ENDDO
  END FUNCTION hcheck

  SUBROUTINE lefpack(str)
     CHARACTER*(*), intent(inout) :: str
     !  left pack non-blank characters in str

     INTEGER :: ii,jj
     ii=0
     DO jj=1,len(str)
        IF(str(jj:jj).NE.' ') THEN
           ii = ii + 1
           str(ii:ii) = str(jj:jj)
        ENDIF
     ENDDO
     str(ii+1:) = ' '
  END SUBROUTINE lefpack

END SUBROUTINE plasma_state_xload_pgrps

subroutine cstate_ck_listdims(dims,nmax,ndims,idims,ilolims,indx_enum)

  !  check if item has list dimensions

  use cstate_lib_mod
  implicit NONE

  character*(*), intent(in) :: dims
  integer, intent(in) :: nmax      ! max no. of list dimensions

  integer, intent(out) :: ndims    ! actual no. of list dimensions (0 possible)
  !  CAUTION: if ndims=nmax, output list may be incomplete...

  integer, intent(out) :: idims(nmax)   ! the dimension numbers...
  integer, intent(out) :: ilolims(nmax) ! difference btw declared lower limits
  !  for each dimension in "dims" vs. the original list dimension declaration.
  integer, intent(out) :: indx_enum     ! "enumeration" dimension index, or 
  !  zero if there is none.

  !---------------------------------
  integer :: luntty,lnout
  integer :: ii,inum,jj,iloc,jjmatch
  character*32 :: locdims(20)  ! 20 a more than reasonable upper bound
  character*32 :: enum_dim
  integer :: loc_lodims(20)
  !---------------------------------

  ndims = 0
  idims = 0
  ilolims = 0
  indx_enum = 0

  enum_dim = ' '

  inum = 0
  if(allocated(list_dims)) inum = size(list_dims)
  if(inum.eq.0) return
  if(dims.eq.'scalar') return

  ! extract dims from dims string
  !   typical dims string value: "(1:nrho_fp-1,1:nspec_nonmax)"

  call cstate_extract_dims(dims,size(locdims),iloc,locdims,loc_lodims)

  !  see if any dims are list dims

  do ii=1,iloc
     jjmatch=0
     do jj=1,inum
        if(locdims(ii).eq.list_dims(jj)) then
           jjmatch=jj
           if(nmax.gt.ndims) then
              ndims = ndims + 1
              idims(ndims) = jj
              ilolims(ndims) = loc_lodims(ii)-list_lolim(jj)
              exit
           endif
        endif
     enddo
     if(jjmatch.eq.0) then
        ! not a list dim: grid dim?
        do jj=1,size(grid_dims)
           if(locdims(ii).eq.grid_dims(jj)) then
              jjmatch=jj
              exit
           endif
        enddo
     endif
     if(jjmatch.eq.0) then
        ! not a list dim, not a grid dim: must be an enumeration dimension
        if(enum_dim.ne.' ') then
           luntty=lnout(0)
           write(luntty,*) ' ?cstate_ck_listdims: >1 enumeration dimensions:'
           write(luntty,*) enum_dim,locdims(ii)
        else
           enum_dim = locdims(ii)
           call ulower(enum_dim)
           do jj=1,nedims
              if(enum_dim.eq.enum_dims(jj)) then
                 jjmatch=jj
                 indx_enum=jj
                 exit
              endif
           enddo
        endif
     endif

     if(jjmatch.eq.0) then
        write(luntty,*) &
             ' ?cstate_ck_listdims: could not classify dimension: ', &
             locdims(ii)
     endif
  enddo

end subroutine cstate_ck_listdims

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_n1_dummy
     return
  end subroutine ccps_getset_n1_dummy

subroutine psget_ncoils(iobj, data, ierr)
    !! item list dimension of coil_name (pf_coils)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_ncoils', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % ncoils
end subroutine psget_ncoils


subroutine psset_ncoils(iobj, data, ierr)
    !! item list dimension of coil_name (pf_coils)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_ncoils', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % ncoils = data
end subroutine psset_ncoils


subroutine psget_n_straps(iobj, n1, data, ierr)
    !! number of straps in the antenna
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_n_straps', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % n_straps
end subroutine psget_n_straps


subroutine psset_n_straps(iobj, n1, data, ierr)
    !! number of straps in the antenna
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_n_straps', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % n_straps = data(1:n1)
end subroutine psset_n_straps


subroutine psgetrnk_n_straps(iobj, ndims, ierr)
    !! number of straps in the antenna
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_n_straps


subroutine psgetdim_n_straps(iobj, ndims, dims, ierr)
    !! number of straps in the antenna
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_n_straps', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % n_straps ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % n_straps)
    endif
end subroutine psgetdim_n_straps


subroutine psget_nphi(iobj, n1, n2, data, ierr)
    !! n_phi wave spectrum from antenna
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_nphi', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % nphi
end subroutine psget_nphi


subroutine psset_nphi(iobj, n1, n2, data, ierr)
    !! n_phi wave spectrum from antenna
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    INTEGER, intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_nphi', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % nphi = data(1:n1, 1: n2)
end subroutine psset_nphi


subroutine psgetrnk_nphi(iobj, ndims, ierr)
    !! n_phi wave spectrum from antenna
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_nphi


subroutine psgetdim_nphi(iobj, ndims, dims, ierr)
    !! n_phi wave spectrum from antenna
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_nphi', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % nphi ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % nphi)
    endif
end subroutine psgetdim_nphi


subroutine psget_nnkparlh(iobj, n1, n2, data, ierr)
    !! need description
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_nnkparlh', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % nnkparlh
end subroutine psget_nnkparlh


subroutine psset_nnkparlh(iobj, n1, n2, data, ierr)
    !! need description
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    INTEGER, intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_nnkparlh', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % nnkparlh = data(1:n1, 1: n2)
end subroutine psset_nnkparlh


subroutine psgetrnk_nnkparlh(iobj, ndims, ierr)
    !! need description
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_nnkparlh


subroutine psgetdim_nnkparlh(iobj, ndims, dims, ierr)
    !! need description
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_nnkparlh', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % nnkparlh ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % nnkparlh)
    endif
end subroutine psgetdim_nnkparlh


subroutine psget_ns_data_info(iobj, data, ierr)
    !! information on source of Density data
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    CHARACTER*(*), intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_ns_data_info', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % ns_Data_Info
end subroutine psget_ns_data_info


subroutine psset_ns_data_info(iobj, data, ierr)
    !! information on source of Density data
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    CHARACTER*(*), intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_ns_data_info', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % ns_Data_Info = data
end subroutine psset_ns_data_info


subroutine psgetsz_ns_data_info(iobj, size, ierr)
    !! information on source of Density data
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: size    ! size of character string
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psgetsz_ns_data_info', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! note that the following will return the character length size regardless of
    ! the number of array elements (if ns_Data_Info is an array)
    size = len(ss % ns_Data_Info)
end subroutine psgetsz_ns_data_info


subroutine psget_nrho_rad(iobj, data, ierr)
    !! grid dimension of rho_rad (RHO coordinate)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_nrho_rad', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % nrho_rad
end subroutine psget_nrho_rad


subroutine psset_nrho_rad(iobj, data, ierr)
    !! grid dimension of rho_rad (RHO coordinate)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_nrho_rad', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % nrho_rad = data
end subroutine psset_nrho_rad


subroutine psget_nrw(iobj, n1, data, ierr)
    !! runaway electron density, nrw/ne << 1 is assumed
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_nrw', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % nrw
end subroutine psget_nrw


subroutine psset_nrw(iobj, n1, data, ierr)
    !! runaway electron density, nrw/ne << 1 is assumed
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_nrw', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % nrw = data(1:n1)
end subroutine psset_nrw


subroutine psgetrnk_nrw(iobj, ndims, ierr)
    !! runaway electron density, nrw/ne << 1 is assumed
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_nrw


subroutine psgetdim_nrw(iobj, ndims, dims, ierr)
    !! runaway electron density, nrw/ne << 1 is assumed
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_nrw', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % nrw ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % nrw)
    endif
end subroutine psgetdim_nrw


subroutine psget_nz_ky_tglf(iobj, n1, n2, data, ierr)
    !! impurity density fluctuation spectrum
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_nz_ky_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % nz_ky_tglf
end subroutine psget_nz_ky_tglf


subroutine psset_nz_ky_tglf(iobj, n1, n2, data, ierr)
    !! impurity density fluctuation spectrum
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_nz_ky_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % nz_ky_tglf = data(1:n1, 1: n2)
end subroutine psset_nz_ky_tglf


subroutine psgetrnk_nz_ky_tglf(iobj, ndims, ierr)
    !! impurity density fluctuation spectrum
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_nz_ky_tglf


subroutine psgetdim_nz_ky_tglf(iobj, ndims, dims, ierr)
    !! impurity density fluctuation spectrum
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_nz_ky_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % nz_ky_tglf ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % nz_ky_tglf)
    endif
end subroutine psgetdim_nz_ky_tglf

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_q5_dummy
     return
  end subroutine ccps_getset_q5_dummy

subroutine psget_q_rfmin(iobj, n1, data, ierr)
    !! RFMIN specie charge
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_q_rfmin', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % q_RFMIN
end subroutine psget_q_rfmin


subroutine psset_q_rfmin(iobj, n1, data, ierr)
    !! RFMIN specie charge
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_q_rfmin', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % q_RFMIN = data(1:n1)
end subroutine psset_q_rfmin


subroutine psgetrnk_q_rfmin(iobj, ndims, ierr)
    !! RFMIN specie charge
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_q_rfmin


subroutine psgetdim_q_rfmin(iobj, ndims, dims, ierr)
    !! RFMIN specie charge
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_q_rfmin', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % q_RFMIN ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % q_RFMIN)
    endif
end subroutine psgetdim_q_rfmin


subroutine psget_qatom_sa(iobj, n1, data, ierr)
    !! SA atomic number
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_qatom_sa', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % qatom_SA
end subroutine psget_qatom_sa


subroutine psset_qatom_sa(iobj, n1, data, ierr)
    !! SA atomic number
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_qatom_sa', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % qatom_SA = data(1:n1)
end subroutine psset_qatom_sa


subroutine psgetrnk_qatom_sa(iobj, ndims, ierr)
    !! SA atomic number
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_qatom_sa


subroutine psgetdim_qatom_sa(iobj, ndims, dims, ierr)
    !! SA atomic number
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_qatom_sa', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % qatom_SA ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % qatom_SA)
    endif
end subroutine psgetdim_qatom_sa


subroutine psget_q_simpi(iobj, n1, data, ierr)
    !! SIMPI specie charge
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_q_simpi', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % q_SIMPI
end subroutine psget_q_simpi


subroutine psset_q_simpi(iobj, n1, data, ierr)
    !! SIMPI specie charge
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_q_simpi', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % q_SIMPI = data(1:n1)
end subroutine psset_q_simpi


subroutine psgetrnk_q_simpi(iobj, ndims, ierr)
    !! SIMPI specie charge
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_q_simpi


subroutine psgetdim_q_simpi(iobj, ndims, dims, ierr)
    !! SIMPI specie charge
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_q_simpi', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % q_SIMPI ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % q_SIMPI)
    endif
end subroutine psgetdim_q_simpi


subroutine psget_qrot_diff(iobj, n1, data, ierr)
    !! rotational energy dissipation (diffusive)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_qrot_diff', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % qrot_diff
end subroutine psget_qrot_diff


subroutine psset_qrot_diff(iobj, n1, data, ierr)
    !! rotational energy dissipation (diffusive)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_qrot_diff', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % qrot_diff = data(1:n1)
end subroutine psset_qrot_diff


subroutine psgetrnk_qrot_diff(iobj, ndims, ierr)
    !! rotational energy dissipation (diffusive)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_qrot_diff


subroutine psgetdim_qrot_diff(iobj, ndims, dims, ierr)
    !! rotational energy dissipation (diffusive)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_qrot_diff', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % qrot_diff ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % qrot_diff)
    endif
end subroutine psgetdim_qrot_diff


subroutine psget_q_eq(iobj, n1, data, ierr)
    !! equilibrium q profile
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_q_eq', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % q_eq
end subroutine psget_q_eq


subroutine psset_q_eq(iobj, n1, data, ierr)
    !! equilibrium q profile
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_q_eq', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % q_eq = data(1:n1)
end subroutine psset_q_eq


subroutine psgetrnk_q_eq(iobj, ndims, ierr)
    !! equilibrium q profile
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_q_eq


subroutine psgetdim_q_eq(iobj, ndims, dims, ierr)
    !! equilibrium q profile
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_q_eq', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % q_eq ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % q_eq)
    endif
end subroutine psgetdim_q_eq

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_z3_dummy
     return
  end subroutine ccps_getset_z3_dummy

subroutine psget_z_ant(iobj, n1, data, ierr)
    !! height of antenna
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_z_ant', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % Z_ant
end subroutine psget_z_ant


subroutine psset_z_ant(iobj, n1, data, ierr)
    !! height of antenna
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_z_ant', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % Z_ant = data(1:n1)
end subroutine psset_z_ant


subroutine psgetrnk_z_ant(iobj, ndims, ierr)
    !! height of antenna
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_z_ant


subroutine psgetdim_z_ant(iobj, ndims, dims, ierr)
    !! height of antenna
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_z_ant', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % Z_ant ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % Z_ant)
    endif
end subroutine psgetdim_z_ant


subroutine psget_zimp1(iobj, data, ierr)
    !! lower limit on Z of impurity in reduced species list SA;, by
    !! default the lowest available Z impurity is chosen., After the
    !! SA list is defined, this value is reset to, match the lower Z
    !! impurity selected for the SA list.
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_zimp1', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % Zimp1
end subroutine psget_zimp1


subroutine psset_zimp1(iobj, data, ierr)
    !! lower limit on Z of impurity in reduced species list SA;, by
    !! default the lowest available Z impurity is chosen., After the
    !! SA list is defined, this value is reset to, match the lower Z
    !! impurity selected for the SA list.
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_zimp1', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % Zimp1 = data
end subroutine psset_zimp1


subroutine psget_z_midp(iobj, n1, data, ierr)
    !! flux surface midplane elevation
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_z_midp', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % Z_midp
end subroutine psget_z_midp


subroutine psset_z_midp(iobj, n1, data, ierr)
    !! flux surface midplane elevation
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_z_midp', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % Z_midp = data(1:n1)
end subroutine psset_z_midp


subroutine psgetrnk_z_midp(iobj, ndims, ierr)
    !! flux surface midplane elevation
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_z_midp


subroutine psgetdim_z_midp(iobj, ndims, dims, ierr)
    !! flux surface midplane elevation
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_z_midp', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % Z_midp ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % Z_midp)
    endif
end subroutine psgetdim_z_midp

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_t2_dummy
     return
  end subroutine ccps_getset_t2_dummy

subroutine psget_t_einj_standard(iobj, n1, data, ierr)
    !! T beam table energies, for full-half-third energy beam
    !! current fractions data
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_t_einj_standard', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % T_einj_standard
end subroutine psget_t_einj_standard


subroutine psset_t_einj_standard(iobj, n1, data, ierr)
    !! T beam table energies, for full-half-third energy beam
    !! current fractions data
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_t_einj_standard', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % T_einj_standard = data(1:n1)
end subroutine psset_t_einj_standard


subroutine psgetrnk_t_einj_standard(iobj, ndims, ierr)
    !! T beam table energies, for full-half-third energy beam
    !! current fractions data
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_t_einj_standard


subroutine psgetdim_t_einj_standard(iobj, ndims, dims, ierr)
    !! T beam table energies, for full-half-third energy beam
    !! current fractions data
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_t_einj_standard', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % T_einj_standard ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % T_einj_standard)
    endif
end subroutine psgetdim_t_einj_standard


subroutine psget_tornum_balcrit(iobj, n1, data, ierr)
    !! critical toroidal mode number for ballooning, unstable cases
    !! (-1 if could not be found).
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_tornum_balcrit', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % Tornum_balcrit
end subroutine psget_tornum_balcrit


subroutine psset_tornum_balcrit(iobj, n1, data, ierr)
    !! critical toroidal mode number for ballooning, unstable cases
    !! (-1 if could not be found).
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_tornum_balcrit', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % Tornum_balcrit = data(1:n1)
end subroutine psset_tornum_balcrit


subroutine psgetrnk_tornum_balcrit(iobj, ndims, ierr)
    !! critical toroidal mode number for ballooning, unstable cases
    !! (-1 if could not be found).
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_tornum_balcrit


subroutine psgetdim_tornum_balcrit(iobj, ndims, dims, ierr)
    !! critical toroidal mode number for ballooning, unstable cases
    !! (-1 if could not be found).
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_tornum_balcrit', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % Tornum_balcrit ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % Tornum_balcrit)
    endif
end subroutine psgetdim_tornum_balcrit


subroutine psget_tq_trans(iobj, n1, data, ierr)
    !! angular momentum transport (loss), toroidal angular momentum
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_tq_trans', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % tq_trans
end subroutine psget_tq_trans


subroutine psset_tq_trans(iobj, n1, data, ierr)
    !! angular momentum transport (loss), toroidal angular momentum
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_tq_trans', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % tq_trans = data(1:n1)
end subroutine psset_tq_trans


subroutine psgetrnk_tq_trans(iobj, ndims, ierr)
    !! angular momentum transport (loss), toroidal angular momentum
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_tq_trans


subroutine psgetdim_tq_trans(iobj, ndims, dims, ierr)
    !! angular momentum transport (loss), toroidal angular momentum
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_tq_trans', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % tq_trans ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % tq_trans)
    endif
end subroutine psgetdim_tq_trans


subroutine psget_tqqcx(iobj, n1, n2, data, ierr)
    !! cx torque per unit influx per (omeg0-omegi)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_tqqcx', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % tqqcx
end subroutine psget_tqqcx


subroutine psset_tqqcx(iobj, n1, n2, data, ierr)
    !! cx torque per unit influx per (omeg0-omegi)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_tqqcx', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % tqqcx = data(1:n1, 1: n2)
end subroutine psset_tqqcx


subroutine psgetrnk_tqqcx(iobj, ndims, ierr)
    !! cx torque per unit influx per (omeg0-omegi)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_tqqcx


subroutine psgetdim_tqqcx(iobj, ndims, dims, ierr)
    !! cx torque per unit influx per (omeg0-omegi)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_tqqcx', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % tqqcx ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % tqqcx)
    endif
end subroutine psgetdim_tqqcx


subroutine psget_te_ky_tglf(iobj, n1, n2, data, ierr)
    !! electron density fluctuation spectrum
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_te_ky_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % te_ky_tglf
end subroutine psget_te_ky_tglf


subroutine psset_te_ky_tglf(iobj, n1, n2, data, ierr)
    !! electron density fluctuation spectrum
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_te_ky_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % te_ky_tglf = data(1:n1, 1: n2)
end subroutine psset_te_ky_tglf


subroutine psgetrnk_te_ky_tglf(iobj, ndims, ierr)
    !! electron density fluctuation spectrum
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_te_ky_tglf


subroutine psgetdim_te_ky_tglf(iobj, ndims, dims, ierr)
    !! electron density fluctuation spectrum
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_te_ky_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % te_ky_tglf ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % te_ky_tglf)
    endif
end subroutine psgetdim_te_ky_tglf

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_r8_dummy
     return
  end subroutine ccps_getset_r8_dummy

subroutine psget_rfmin_name(iobj, n1, data, ierr)
    !! ICRF minority species
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    CHARACTER*(*), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_rfmin_name', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % RFMIN_name
end subroutine psget_rfmin_name


subroutine psset_rfmin_name(iobj, n1, data, ierr)
    !! ICRF minority species
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    CHARACTER*(*), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_rfmin_name', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % RFMIN_name = data(1:n1)
end subroutine psset_rfmin_name


subroutine psgetsz_rfmin_name(iobj, size, ierr)
    !! ICRF minority species
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: size    ! size of character string
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psgetsz_rfmin_name', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! note that the following will return the character length size regardless of
    ! the number of array elements (if RFMIN_name is an array)
    size = len(ss % RFMIN_name)
end subroutine psgetsz_rfmin_name


subroutine psgetrnk_rfmin_name(iobj, ndims, ierr)
    !! ICRF minority species
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_rfmin_name


subroutine psgetdim_rfmin_name(iobj, ndims, dims, ierr)
    !! ICRF minority species
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_rfmin_name', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % RFMIN_name ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % RFMIN_name)
    endif
end subroutine psgetdim_rfmin_name


subroutine psget_rho_fus(iobj, n1, data, ierr)
    !! rho grid -- Fusion products model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_rho_fus', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % rho_fus
end subroutine psget_rho_fus


subroutine psset_rho_fus(iobj, n1, data, ierr)
    !! rho grid -- Fusion products model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_rho_fus', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % rho_fus = data(1:n1)
end subroutine psset_rho_fus


subroutine psgetrnk_rho_fus(iobj, ndims, ierr)
    !! rho grid -- Fusion products model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_rho_fus


subroutine psgetdim_rho_fus(iobj, ndims, dims, ierr)
    !! rho grid -- Fusion products model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_rho_fus', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % rho_fus ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % rho_fus)
    endif
end subroutine psgetdim_rho_fus


subroutine psget_rho_pel(iobj, n1, data, ierr)
    !! rho grid -- PEL
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_rho_pel', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % rho_pel
end subroutine psget_rho_pel


subroutine psset_rho_pel(iobj, n1, data, ierr)
    !! rho grid -- PEL
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_rho_pel', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % rho_pel = data(1:n1)
end subroutine psset_rho_pel


subroutine psgetrnk_rho_pel(iobj, ndims, ierr)
    !! rho grid -- PEL
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_rho_pel


subroutine psgetdim_rho_pel(iobj, ndims, dims, ierr)
    !! rho grid -- PEL
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_rho_pel', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % rho_pel ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % rho_pel)
    endif
end subroutine psgetdim_rho_pel


subroutine psget_rho_lmhd(iobj, n1, data, ierr)
    !! rho grid (LMHD component)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_rho_lmhd', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % rho_lmhd
end subroutine psget_rho_lmhd


subroutine psset_rho_lmhd(iobj, n1, data, ierr)
    !! rho grid (LMHD component)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_rho_lmhd', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % rho_lmhd = data(1:n1)
end subroutine psset_rho_lmhd


subroutine psgetrnk_rho_lmhd(iobj, ndims, ierr)
    !! rho grid (LMHD component)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_rho_lmhd


subroutine psgetdim_rho_lmhd(iobj, ndims, dims, ierr)
    !! rho grid (LMHD component)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_rho_lmhd', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % rho_lmhd ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % rho_lmhd)
    endif
end subroutine psgetdim_rho_lmhd


subroutine psget_res_tq(iobj, n1, data, ierr)
    !! rediduals for angular momentum transport eqn
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_res_tq', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % res_tq
end subroutine psget_res_tq


subroutine psset_res_tq(iobj, n1, data, ierr)
    !! rediduals for angular momentum transport eqn
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_res_tq', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % res_tq = data(1:n1)
end subroutine psset_res_tq


subroutine psgetrnk_res_tq(iobj, ndims, ierr)
    !! rediduals for angular momentum transport eqn
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_res_tq


subroutine psgetdim_res_tq(iobj, ndims, dims, ierr)
    !! rediduals for angular momentum transport eqn
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_res_tq', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % res_tq ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % res_tq)
    endif
end subroutine psgetdim_res_tq


subroutine psget_r_geo(iobj, n1, n2, data, ierr)
    !! flux surfaces R(rho,theta)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_r_geo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % R_geo
end subroutine psget_r_geo


subroutine psset_r_geo(iobj, n1, n2, data, ierr)
    !! flux surfaces R(rho,theta)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_r_geo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % R_geo = data(1:n1, 1: n2)
end subroutine psset_r_geo


subroutine psgetrnk_r_geo(iobj, ndims, ierr)
    !! flux surfaces R(rho,theta)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_r_geo


subroutine psgetdim_r_geo(iobj, ndims, dims, ierr)
    !! flux surfaces R(rho,theta)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_r_geo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % R_geo ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % R_geo)
    endif
end subroutine psgetdim_r_geo

! $Id: ccps_mhdeq.F90,v 1.3 2009-01-20 02:13:57 xshare Exp $

subroutine ccps_mhdeq_verify(iobj, reltol, nrhowk, rhowk, &
       update_phit, update_psi, update_q, check_phit, check_q,  &
       relerr_max, ierr)

    ! Verify that profile of enclosed toroidal flux state%phit(:) is 
    ! consistent with definition of rho coordinate, i.e. that the relation
    !
    !     [Tor.flux] = rho**2*[Tor.flux.at.bdy]
    !
    ! is satisfied to reasonable accuracy (2% or value of optional argument
    ! reltol).
    !
    ! If flags are set, actually update the profiles state%phit(:),
    ! state%psipol(:), and/or state%q_eq(:).
    !    Note#1: all update controls if defaulted are taken as .FALSE.
    !    Note#2: update of Psipol depends on q_eq; update of q_eq depends
    !            on Psipol.  Therefore update_psi and update_q cannot BOTH
    !            be .TRUE. (an error would be reported).
    !
    ! if (check_q) is set, check consistency of q_eq and Psipol profiles.
    !              this is the default.
    !
    ! Note: consistency of MHDEQ pressure profile NOT checked!  This routine
    !       does not check the self-consistency of the Grad-Shafranov MHD
    !       equilibrium in the state!  Only the fluxes are checked.
    !
    ! If the check reveals no error, after any requested profiles are 
    ! updated, internal splines representing equilibrium field quantities
    ! are updated; this allows all PS_MHDEQ_DERIVE actions to be carried
    ! out.
 

  use plasma_state_mod
  implicit NONE

   integer :: iobj(*)        ! (ps_container_size) words are used: state object
    REAL(kind=rspec), intent(IN) :: reltol ! error tolerance for
                                  ! toroidal flux check (default: 2%)

    integer, intent(in)                             :: nrhowk   				  
    REAL(kind=rspec), dimension(nrhowk), intent(IN) :: rhowk
                                  ! working grid for <1/R^2> integration
                                  ! if defaulted use state%rho_eq_geo.
                                  ! some codes may want a coarser grid for
                                  ! performance reasons.

    ! all LOGICAL optional controls default to 0:

    integer, intent(IN) :: update_phit ! update toroidal flux profile
                                                 ! state%phit(:)

    integer, intent(IN) :: update_psi  ! update poloidal flux profile
                                                 ! state%psipol(:)

    integer, intent(IN) :: update_q    ! update q profile
                                                 ! state%q_eq(:)

    integer, intent(IN) :: check_phit  ! check consistency of
                                                 ! toroidal flux profile
                                                 ! default: .TRUE.

    integer, intent(IN) :: check_q     ! check consistency of q
                                                 ! and psipol profiles
                                                 ! default: .TRUE.

    REAL(kind=rspec), intent(out) :: relerr_max  ! maximum rel. error
                                                 ! in phit or q tests
    integer, intent(out)           :: ierr       ! error code (0=OK)

  !-------------------------
  type (plasma_state_container) :: ptr
  type (plasma_state), pointer :: ss

  logical :: update_phit_bool = .FALSE.
  logical :: update_psi_bool = .FALSE.
  logical :: update_q_bool = .FALSE.
  logical :: check_phit_bool = .TRUE.
  logical :: check_q_bool = .TRUE.
  !-------------------------

  if (update_phit /= 0) update_phit_bool = .TRUE.
  if (update_psi /= 0) update_psi_bool = .TRUE.
  if (update_q /= 0) update_q_bool = .TRUE.

  if (check_phit == 0) check_phit_bool = .FALSE.
  if (check_q == 0) check_q_bool = .FALSE.

  call ccps_argcheck('ccps_mhd_verify',iobj,ierr)
  if(ierr.ne.0) return

  ! proceed...

  call load_ps_container(iobj,ptr)
  ss => ptr%ps_ptr

  if (nrhowk /= 0) then 
     call ps_mhdeq_verify(ierr=ierr, state=ss, reltol=reltol, rhowk=rhowk, &
       update_phit=update_phit_bool, update_psi=update_psi_bool, update_q=update_q_bool, &
       check_phit=check_phit_bool, check_q=check_q_bool, &
       relerr_max=relerr_max)
  else
     call ps_mhdeq_verify(ierr=ierr, state=ss, reltol=reltol, &
       update_phit=update_phit_bool, update_psi=update_psi_bool, update_q=update_q_bool, &
       check_phit=check_phit_bool, check_q=check_q_bool, &
       relerr_max=relerr_max)
  endif

end subroutine ccps_mhdeq_verify

subroutine ccps_mhdeq_derive(iobj, action, nrhowk, rhowk, ierr) 

    ! compute flux surface averages and other profiles derived from
    ! the MHD equilibrium geometry and fields

  use plasma_state_mod
  implicit NONE

#include "fpreproc/byte_declare.h"

    integer :: iobj(*)        ! (ps_container_size) words are used: state object
    BYTE_DECLARE, intent(in) :: action      ! specify action(s) to be taken (null termined)
    integer, intent(in)  :: nrhowk  ! size of rhowk
    REAL(kind=rspec), intent(IN) :: rhowk(nrhowk)
                                  ! working grid for flux surface averages
                                  ! if defaulted use state%rho_eq_geo.
                                  ! some codes may want a coarser grid for
                                  ! performance reasons
    integer, intent(out) :: ierr             ! exit status code (0=OK)

  !-------------------------
  type (plasma_state_container) :: ptr
  type (plasma_state), pointer :: ss
  character(len=256)           :: action_ftn
  !-------------------------

  call ccps_argcheck('ccps_mhd_derive',iobj,ierr)
  if(ierr.ne.0) return

  ! proceed...

  call load_ps_container(iobj,ptr)
  ss => ptr%ps_ptr

  ! convert to fortran string
  call cstring(action_ftn, action, '2F')  ! convert file path to 
                                            ! fortran string (g_filename)

  if (nrhowk == 0) then 
     call ps_mhdeq_derive(action=action_ftn, ierr=ierr, state=ss)
  else
     call ps_mhdeq_derive(action=action_ftn, ierr=ierr, state=ss, rhowk=rhowk)
  endif

end subroutine ccps_mhdeq_derive

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_f1_dummy
     return
  end subroutine ccps_getset_f1_dummy

subroutine psget_freq_ec(iobj, n1, data, ierr)
    !! frequency of EC source
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_freq_ec', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % freq_ec
end subroutine psget_freq_ec


subroutine psset_freq_ec(iobj, n1, data, ierr)
    !! frequency of EC source
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_freq_ec', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % freq_ec = data(1:n1)
end subroutine psset_freq_ec


subroutine psgetrnk_freq_ec(iobj, ndims, ierr)
    !! frequency of EC source
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_freq_ec


subroutine psgetdim_freq_ec(iobj, ndims, dims, ierr)
    !! frequency of EC source
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_freq_ec', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % freq_ec ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % freq_ec)
    endif
end subroutine psgetdim_freq_ec


subroutine psget_fracmin(iobj, n1, data, ierr)
    !! minority density fraction if kdens_rfmin="fraction", if so,
    !! it must have non-zero positive value for each minority ion
    !! specie., sum(fracmin) << 1 is expected.
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_fracmin', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % fracmin
end subroutine psget_fracmin


subroutine psset_fracmin(iobj, n1, data, ierr)
    !! minority density fraction if kdens_rfmin="fraction", if so,
    !! it must have non-zero positive value for each minority ion
    !! specie., sum(fracmin) << 1 is expected.
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_fracmin', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % fracmin = data(1:n1)
end subroutine psset_fracmin


subroutine psgetrnk_fracmin(iobj, ndims, ierr)
    !! minority density fraction if kdens_rfmin="fraction", if so,
    !! it must have non-zero positive value for each minority ion
    !! specie., sum(fracmin) << 1 is expected.
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_fracmin


subroutine psgetdim_fracmin(iobj, ndims, dims, ierr)
    !! minority density fraction if kdens_rfmin="fraction", if so,
    !! it must have non-zero positive value for each minority ion
    !! specie., sum(fracmin) << 1 is expected.
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_fracmin', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % fracmin ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % fracmin)
    endif
end subroutine psgetdim_fracmin


subroutine psget_fi_depletion(iobj, n1, data, ierr)
    !! fast ion depletion: sum[nj*Zj/ne]
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_fi_depletion', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % Fi_depletion
end subroutine psget_fi_depletion


subroutine psset_fi_depletion(iobj, n1, data, ierr)
    !! fast ion depletion: sum[nj*Zj/ne]
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_fi_depletion', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % Fi_depletion = data(1:n1)
end subroutine psset_fi_depletion


subroutine psgetrnk_fi_depletion(iobj, ndims, ierr)
    !! fast ion depletion: sum[nj*Zj/ne]
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_fi_depletion


subroutine psgetdim_fi_depletion(iobj, ndims, dims, ierr)
    !! fast ion depletion: sum[nj*Zj/ne]
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_fi_depletion', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % Fi_depletion ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % Fi_depletion)
    endif
end subroutine psgetdim_fi_depletion


subroutine psget_freq_drbm(iobj, n1, data, ierr)
    !! frequency from DRBM model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_freq_drbm', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % freq_drbm
end subroutine psget_freq_drbm


subroutine psset_freq_drbm(iobj, n1, data, ierr)
    !! frequency from DRBM model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_freq_drbm', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % freq_drbm = data(1:n1)
end subroutine psset_freq_drbm


subroutine psgetrnk_freq_drbm(iobj, ndims, ierr)
    !! frequency from DRBM model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_freq_drbm


subroutine psgetdim_freq_drbm(iobj, ndims, dims, ierr)
    !! frequency from DRBM model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_freq_drbm', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % freq_drbm ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % freq_drbm)
    endif
end subroutine psgetdim_freq_drbm


subroutine psget_freq_glf(iobj, n1, data, ierr)
    !! frequency from GLF23 model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_freq_glf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % freq_glf
end subroutine psget_freq_glf


subroutine psset_freq_glf(iobj, n1, data, ierr)
    !! frequency from GLF23 model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_freq_glf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % freq_glf = data(1:n1)
end subroutine psset_freq_glf


subroutine psgetrnk_freq_glf(iobj, ndims, ierr)
    !! frequency from GLF23 model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_freq_glf


subroutine psgetdim_freq_glf(iobj, ndims, dims, ierr)
    !! frequency from GLF23 model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_freq_glf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % freq_glf ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % freq_glf)
    endif
end subroutine psgetdim_freq_glf

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_t7_dummy
     return
  end subroutine ccps_getset_t7_dummy

subroutine psget_thegrilh(iobj, n1, n2, data, ierr)
    !! need description
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_thegrilh', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % thegrilh
end subroutine psget_thegrilh


subroutine psset_thegrilh(iobj, n1, n2, data, ierr)
    !! need description
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_thegrilh', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % thegrilh = data(1:n1, 1: n2)
end subroutine psset_thegrilh


subroutine psgetrnk_thegrilh(iobj, ndims, ierr)
    !! need description
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_thegrilh


subroutine psgetdim_thegrilh(iobj, ndims, dims, ierr)
    !! need description
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_thegrilh', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % thegrilh ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % thegrilh)
    endif
end subroutine psgetdim_thegrilh


subroutine psget_te_bdy(iobj, data, ierr)
    !! Electron temperature at/beyond boundary
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_te_bdy', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % Te_bdy
end subroutine psget_te_bdy


subroutine psset_te_bdy(iobj, data, ierr)
    !! Electron temperature at/beyond boundary
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_te_bdy', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % Te_bdy = data
end subroutine psset_te_bdy


subroutine psget_triangl(iobj, n1, data, ierr)
    !! lower triangularity, ((Rmin+Rmax)/2 -
    !! R(Zmin))/((Rmax-Rmin)/2)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_triangl', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % triangL
end subroutine psget_triangl


subroutine psset_triangl(iobj, n1, data, ierr)
    !! lower triangularity, ((Rmin+Rmax)/2 -
    !! R(Zmin))/((Rmax-Rmin)/2)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_triangl', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % triangL = data(1:n1)
end subroutine psset_triangl


subroutine psgetrnk_triangl(iobj, ndims, ierr)
    !! lower triangularity, ((Rmin+Rmax)/2 -
    !! R(Zmin))/((Rmax-Rmin)/2)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_triangl


subroutine psgetdim_triangl(iobj, ndims, dims, ierr)
    !! lower triangularity, ((Rmin+Rmax)/2 -
    !! R(Zmin))/((Rmax-Rmin)/2)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_triangl', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % triangL ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % triangL)
    endif
end subroutine psgetdim_triangl


subroutine psget_tqsc_halo(iobj, n1, data, ierr)
    !! beam halo torque: recapture - tqb0_halo, (net source/sink to
    !! thermal ions), (associated particle source/sink exists)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_tqsc_halo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % tqsc_halo
end subroutine psget_tqsc_halo


subroutine psset_tqsc_halo(iobj, n1, data, ierr)
    !! beam halo torque: recapture - tqb0_halo, (net source/sink to
    !! thermal ions), (associated particle source/sink exists)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_tqsc_halo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % tqsc_halo = data(1:n1)
end subroutine psset_tqsc_halo


subroutine psgetrnk_tqsc_halo(iobj, ndims, ierr)
    !! beam halo torque: recapture - tqb0_halo, (net source/sink to
    !! thermal ions), (associated particle source/sink exists)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_tqsc_halo


subroutine psgetdim_tqsc_halo(iobj, ndims, dims, ierr)
    !! beam halo torque: recapture - tqb0_halo, (net source/sink to
    !! thermal ions), (associated particle source/sink exists)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_tqsc_halo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % tqsc_halo ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % tqsc_halo)
    endif
end subroutine psgetdim_tqsc_halo


subroutine psget_tqsc_reco(iobj, n1, data, ierr)
    !! reco torque: recapture - tq0_reco, (net source/sink to
    !! thermal ions), (associated particle source/sink exists)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_tqsc_reco', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % tqsc_reco
end subroutine psget_tqsc_reco


subroutine psset_tqsc_reco(iobj, n1, data, ierr)
    !! reco torque: recapture - tq0_reco, (net source/sink to
    !! thermal ions), (associated particle source/sink exists)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_tqsc_reco', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % tqsc_reco = data(1:n1)
end subroutine psset_tqsc_reco


subroutine psgetrnk_tqsc_reco(iobj, ndims, ierr)
    !! reco torque: recapture - tq0_reco, (net source/sink to
    !! thermal ions), (associated particle source/sink exists)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_tqsc_reco


subroutine psgetdim_tqsc_reco(iobj, ndims, dims, ierr)
    !! reco torque: recapture - tq0_reco, (net source/sink to
    !! thermal ions), (associated particle source/sink exists)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_tqsc_reco', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % tqsc_reco ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % tqsc_reco)
    endif
end subroutine psgetdim_tqsc_reco

program ps2geq

  !  DMC Apr 2008: ps2geq, plasma state to G-eqdsk

  !  this program writes a geqdsk file from the data contained in a plasma
  !  state.  The plasma state must contain an equilibrium description and
  !  related data including:

  !      Psi(R,Z)          
  !      [R,Z](rho,theta)
  !      P(rho)
  !      q(rho)
  !      limiter [R,Z] closed contour

  !  these are all normal elements of the plasma state definition, but, not
  !  every plasma state instance has all of them defined.  If this program
  !  receives a state with required elements missing, it will report an
  !  error.

  !  this program takes command line arguments.  Syntax:

  !     ps2geq  <ps-path>  <geq-path>

  !  if <geq-path> ends in "/", the state variable ps%eqdsk_file sets the
  !  name of the file written; if not, <geq-path> is assumed to be the full
  !  filename for the file to be written. 
  !--------------------------------------------------------------------------
  USE plasma_state_mod
  implicit NONE

  !-------------------------------------------

  integer :: iarg,nargs,ilen,idash,ifail,ierr,ilun,istat
  integer :: ihave_g,ihave_ps

  integer, parameter :: imax_args = 3
  character*250 gpath,pspath,args(imax_args)

  !-------------------------------------------
  !  Part 1: parse command line arguments

  ihave_g = 0
  ihave_ps = 0
  gpath = ' '
  pspath = ' '

  ierr = 0

  call get_arg_count(nargs)
  if(nargs.gt.imax_args) then
     ierr=1
     write(0,*) 'ps2geq: too many arguments (max: ',imax_args, &
          '; got: ',nargs,')'
     nargs=imax_args
  endif

  do iarg=1,nargs
     call get_arg(iarg,args(iarg))

     ilen = len(trim(args(iarg)))

     ifail=0
     do
        ! parse arguments

        idash = 0
        if(args(iarg)(1:1).eq.'-') idash=1

        if(idash.eq.1) then
           ifail=1
           exit

        else
           ! path argument

           if(ihave_ps.eq.0) then
              pspath = args(iarg)
              ihave_ps = iarg
           else if(ihave_g.eq.0) then
              gpath = args(iarg)
              ihave_g = iarg
           else
              ifail=4  ! too many path args
           endif

        endif

        exit
     enddo

     if(ifail.eq.1) then
        ierr = ierr + 1
        write(0,*) 'ps2geq: -qualifier argument not valid: '// &
             trim(args(iarg))
     else if(ifail.eq.4) then
        ierr = ierr + 1
        write(0,*) 'ps2geq:  too many file path arguments.'
     endif
  enddo

  if(ihave_g.eq.0) then
     ierr=ierr+1
     write(0,*) 'ps2geq:  missing G-eqdsk path argument.'
  endif

  if(ihave_ps.eq.0) then
     ierr=ierr+1
     write(0,*) 'ps2geq:  missing plasma state file path argument.'
  endif

  if(ierr.gt.0) then
     write(0,*) 'ps2geq syntax:'
     write(0,*) '  ps2geq  <plasma-state-path>  <g-file-path>'
     write(0,*) '  the 2 path arguments are required.'
     call exit(ierr)
  else
     write(6,*) ' ps2geq syntax OK:'
     write(6,*) ' ps-path:  ',trim(pspath)
     write(6,*) '  g-path:  ',trim(gpath)
  endif

  !---------------------
  !  check existence of input file

  call find_io_unit(ilun)
  open(unit=ilun,file=trim(pspath),status='old',action='read',iostat=istat)
  if(istat.ne.0) then
     write(0,*) ' '
     write(0,*) ' file not found: '//trim(pspath)
     write(0,*) ' '
     call exit(4)
  endif
  close(unit=ilun)

  !-------------------------------------------
  !  Part 2: execute

  call ps_get_plasma_state(ierr, filename=trim(pspath))
  if(ierr.ne.0) then
     write(0,*) '?ps2geq: failed to read input plasma state.'
     call exit(ierr)
  endif

  ilen = len(trim(gpath))
  if(gpath(ilen:ilen).eq.'/') then
     if(ps%eqdsk_file.eq.' ') then
        write(6,*) ' ps2geq: ps%eqdsk_file is blank; default name used: geqdsk.dat'
        ps%eqdsk_file = 'geqdsk.dat'
     else
        write(6,*) ' ps2geq: ps%eqdsk_file contents: ',trim(ps%eqdsk_file)
     endif
     gpath(ilen+1:) = trim(ps%eqdsk_file)
     write(6,*) ' Full g-eqdsk file path:  ',trim(gpath)
  endif

  call ps_wr_geqdsk(ierr, g_filepath=trim(gpath))
  if(ierr.ne.0) then
     write(0,*) '?ps2geq: failed to read input plasma state.'
     call exit(ierr)
  endif

  !--------------------
  !  all done.
  !--------------------

  write(6,*) ' '
  write(6,*) ' %ps2geq: normal exit.'
  write(6,*) ' '

  !--------------------------------------------
CONTAINS
  !--------------------------------------------
  !  error handling routine

  subroutine ckerr(sbrtn)

    character*(*), intent(in) :: sbrtn

    if(ierr.ne.0) then
       write(0,*) ' ?ps2geq: unexpected error in subroutine '//trim(sbrtn)//'.'
       call exit(ierr)
    endif

  end subroutine ckerr

end program ps2geq

subroutine ps_purge_equilibrium(iobj,iout,ierr)

  !  Remove equilibrium-related data from a plasma state
  !  XPLASMA2 implementation -- DMC Jul 18 2007

  !------------------------------------------------------------

  use plasma_state_definition_mod
  use plasma_state_xpobj  ! XPLASMA2 state object definitions
  implicit NONE

  !-----------------------
  !  passed:

  integer :: iobj(ps_container_size)     ! xplasma opaque container
  integer, intent(in) :: iout     ! Fortran LUN for messages
  integer, intent(out) :: ierr    ! exit status code 0=OK

  !-------------------------------------------------------------------------
  type (interp_object) :: xobj
  type (xplasma), pointer :: s
  !-------------------------------------------------------------------------
  ! executable code...

  xobj = transfer(iobj,xobj)
  s => xobj%s_xpobj

  call xplasma_global_info(s,ierr, init_check=.TRUE.)
  if(ierr.ne.0) then
     write(iout,*) ' %ps_purge_equilibrium: invalid or unitialized xplasma object.'
     return
  endif

  !----------------------

  call xplasma_remove_author(s,xplasma_xmhd,ierr)
  if(ierr.ne.0) then
     write(iout,*) ' ?ps_purge_equilibrium: xplasma error:'
     call xplasma_error(s,iout,ierr)
  endif

  call xplasma_remove_author(s,'EQ',ierr)
  if(ierr.ne.0) then
     write(iout,*) ' ?ps_purge_equilibrium: xplasma error:'
     call xplasma_error(s,iout,ierr)
  endif

end subroutine ps_purge_equilibrium

program ps2xplasma

  !  DMC Apr 2008: ps2xplasma, plasma state file to xplasma file

  !  this program writes an xplasma NetCDF file from the data contained in a 
  !  plasma state NetCDF file.

  !  this program takes two command line arguments.  Syntax:

  !     ps2xplasma  <ps-path>  <xplasma-path>

  !--------------------------------------------------------------------------
  USE plasma_state_mod
  implicit NONE

  !-------------------------------------------

  integer :: iarg,nargs,ilen,idash,ifail,ierr,ilun,istat
  integer :: ihave_xp,ihave_ps

  integer, parameter :: imax_args = 3
  character*250 xpath,pspath,args(imax_args)

  !-------------------------------------------
  !  Part 1: parse command line arguments

  ihave_xp = 0
  ihave_ps = 0
  xpath = ' '
  pspath = ' '

  ierr = 0

  call get_arg_count(nargs)
  if(nargs.gt.imax_args) then
     ierr=1
     write(0,*) 'ps2xplasma: too many arguments (max: ',imax_args, &
          '; got: ',nargs,')'
     nargs=imax_args
  endif

  do iarg=1,nargs
     call get_arg(iarg,args(iarg))

     ilen = len(trim(args(iarg)))

     ifail=0
     do
        ! parse arguments

        idash = 0
        if(args(iarg)(1:1).eq.'-') idash=1

        if(idash.eq.1) then
           ifail=1
           exit

        else
           ! path argument

           if(ihave_ps.eq.0) then
              pspath = args(iarg)
              ihave_ps = iarg
           else if(ihave_xp.eq.0) then
              xpath = args(iarg)
              ihave_xp = iarg
           else
              ifail=4  ! too many path args
           endif

        endif

        exit
     enddo

     if(ifail.eq.1) then
        ierr = ierr + 1
        write(0,*) 'ps2xplasma: -qualifier argument not valid: '// &
             trim(args(iarg))
     else if(ifail.eq.4) then
        ierr = ierr + 1
        write(0,*) 'ps2xplasma:  too many file path arguments.'
     endif
  enddo

  if(ihave_xp.eq.0) then
     ierr=ierr+1
     write(0,*) 'ps2xplasma:  missing xplasma file path argument.'
  endif

  if(ihave_ps.eq.0) then
     ierr=ierr+1
     write(0,*) 'ps2xplasma:  missing plasma state file path argument.'
  endif

  if(ierr.gt.0) then
     write(0,*) 'ps2xplasma syntax:'
     write(0,*) '  ps2xplasma  <plasma-state-path>  <xplasma-file-path>'
     write(0,*) '  the 2 path arguments are required.'
     call exit(ierr)
  else
     write(6,*) ' ps2xplasma syntax OK:'
     write(6,*) ' ps-path:  ',trim(pspath)
     write(6,*) ' xplasma-path:  ',trim(xpath)
  endif

  !---------------------
  !  check existence of input file

  call find_io_unit(ilun)
  open(unit=ilun,file=trim(pspath),status='old',action='read',iostat=istat)
  if(istat.ne.0) then
     write(0,*) ' '
     write(0,*) ' file not found: '//trim(pspath)
     write(0,*) ' '
     call exit(4)
  endif
  close(unit=ilun)

  !-------------------------------------------
  !  Part 2: execute

  call ps_get_plasma_state(ierr, filename=trim(pspath))
  if(ierr.ne.0) then
     write(0,*) '?ps2xplasma: failed to read input plasma state.'
     call exit(ierr)
  endif

  call ps_xplasma_write
  call ckerr('ps_xplasma_write')

  !--------------------
  !  all done.
  !--------------------

  write(6,*) ' '
  write(6,*) ' %ps2xplasma: normal exit.'
  write(6,*) ' '

  !--------------------------------------------
CONTAINS
  !--------------------------------------------
  !  error handling routine

  subroutine ckerr(sbrtn)

    character*(*), intent(in) :: sbrtn

    if(ierr.ne.0) then
       write(0,*) ' ?ps2xplasma: unexpected error in subroutine '//trim(sbrtn)//'.'
       call exit(ierr)
    endif

  end subroutine ckerr

  subroutine ps_xplasma_write
    !  extract xplasma pointer; write xplasma file
    !  (option provided at request of grad student Jong-kyu Park).

    use xplasma_definitions

    type :: interp_object
       type (xplasma), pointer :: s_xpobj => NULL()
    end type interp_object

    type (interp_object) :: xobj
    type (xplasma), pointer :: s

    !------------------------------

    xobj = transfer(ps%iobj,xobj)
    s => xobj%s_xpobj

    call xplasma_write(s,trim(xpath),ierr)

    write(6,*) ' '
    if(ierr.eq.0) then
       write(6,*) ' %jsocdf2ps:  wrote xplasma file: ',trim(xpath)
    else
       write(6,*) ' %jsocdf2ps:  error writing xplasma file: ',trim(xpath)
       call xplasma_error(s,ierr,6)
    endif

  end subroutine ps_xplasma_write

end program ps2xplasma

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_g5_dummy
     return
  end subroutine ccps_getset_g5_dummy

subroutine psget_global_label(iobj, data, ierr)
    !! Run Label, imbedded blanks allowed; <= 80 characters
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    CHARACTER*(*), intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_global_label', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % Global_label
end subroutine psget_global_label


subroutine psset_global_label(iobj, data, ierr)
    !! Run Label, imbedded blanks allowed; <= 80 characters
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    CHARACTER*(*), intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_global_label', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % Global_label = data
end subroutine psset_global_label


subroutine psgetsz_global_label(iobj, size, ierr)
    !! Run Label, imbedded blanks allowed; <= 80 characters
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: size    ! size of character string
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psgetsz_global_label', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! note that the following will return the character length size regardless of
    ! the number of array elements (if Global_label is an array)
    size = len(ss % Global_label)
end subroutine psgetsz_global_label


subroutine psget_gamma_lmhd(iobj, n1, n2, data, ierr)
    !! ideal growth rate, from a delta-W linear MHD code,
    !! normalized to the, Alfven time Rq/V_a where:, R -- major radius
    !! of magnetic axis, V_a -- alfven speed at magnetic axis, q =
    !! qmin  (minimum q anywhere in equilibrium)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_gamma_lmhd', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % gamma_lmhd
end subroutine psget_gamma_lmhd


subroutine psset_gamma_lmhd(iobj, n1, n2, data, ierr)
    !! ideal growth rate, from a delta-W linear MHD code,
    !! normalized to the, Alfven time Rq/V_a where:, R -- major radius
    !! of magnetic axis, V_a -- alfven speed at magnetic axis, q =
    !! qmin  (minimum q anywhere in equilibrium)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_gamma_lmhd', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % gamma_lmhd = data(1:n1, 1: n2)
end subroutine psset_gamma_lmhd


subroutine psgetrnk_gamma_lmhd(iobj, ndims, ierr)
    !! ideal growth rate, from a delta-W linear MHD code,
    !! normalized to the, Alfven time Rq/V_a where:, R -- major radius
    !! of magnetic axis, V_a -- alfven speed at magnetic axis, q =
    !! qmin  (minimum q anywhere in equilibrium)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_gamma_lmhd


subroutine psgetdim_gamma_lmhd(iobj, ndims, dims, ierr)
    !! ideal growth rate, from a delta-W linear MHD code,
    !! normalized to the, Alfven time Rq/V_a where:, R -- major radius
    !! of magnetic axis, V_a -- alfven speed at magnetic axis, q =
    !! qmin  (minimum q anywhere in equilibrium)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_gamma_lmhd', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % gamma_lmhd ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % gamma_lmhd)
    endif
end subroutine psgetdim_gamma_lmhd


subroutine psget_gr1(iobj, n1, data, ierr)
    !! <R>
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_gr1', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % gr1
end subroutine psget_gr1


subroutine psset_gr1(iobj, n1, data, ierr)
    !! <R>
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_gr1', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % gr1 = data(1:n1)
end subroutine psset_gr1


subroutine psgetrnk_gr1(iobj, ndims, ierr)
    !! <R>
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_gr1


subroutine psgetdim_gr1(iobj, ndims, dims, ierr)
    !! <R>
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_gr1', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % gr1 ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % gr1)
    endif
end subroutine psgetdim_gr1


subroutine psget_gb2i(iobj, n1, data, ierr)
    !! <1/B^2>
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_gb2i', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % gb2i
end subroutine psget_gb2i


subroutine psset_gb2i(iobj, n1, data, ierr)
    !! <1/B^2>
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_gb2i', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % gb2i = data(1:n1)
end subroutine psset_gb2i


subroutine psgetrnk_gb2i(iobj, ndims, ierr)
    !! <1/B^2>
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_gb2i


subroutine psgetdim_gb2i(iobj, ndims, dims, ierr)
    !! <1/B^2>
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_gb2i', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % gb2i ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % gb2i)
    endif
end subroutine psgetdim_gb2i


subroutine psget_growthrate_mmm71(iobj, n1, n2, data, ierr)
    !! growthrate from mmm71 model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_growthrate_mmm71', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % growthrate_mmm71
end subroutine psget_growthrate_mmm71


subroutine psset_growthrate_mmm71(iobj, n1, n2, data, ierr)
    !! growthrate from mmm71 model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_growthrate_mmm71', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % growthrate_mmm71 = data(1:n1, 1: n2)
end subroutine psset_growthrate_mmm71


subroutine psgetrnk_growthrate_mmm71(iobj, ndims, ierr)
    !! growthrate from mmm71 model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_growthrate_mmm71


subroutine psgetdim_growthrate_mmm71(iobj, ndims, dims, ierr)
    !! growthrate from mmm71 model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_growthrate_mmm71', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % growthrate_mmm71 ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % growthrate_mmm71)
    endif
end subroutine psgetdim_growthrate_mmm71

subroutine cstate_table_out(disp0,xlabel,cmt, &
     ilen_coln,incr,val_field,ivd2, &
     ienum,totsize)

  ! write ASCII table output

  ! output loop modified to support display of enumerations
  !     iper=max(1,ienum)
  !     (iper > 1 indicates an enumeration is present; iper=1 usually).

  use cstate_lib_mod
  implicit NONE

  character*(*), intent(in) :: disp0  ! header of column of data names
  character*(*), intent(in) :: xlabel ! field displayed above table if not ' '
  character*(*), intent(in) :: cmt    ! field displayed below table if not ' '

  integer, intent(in) :: ilen_coln(0:nsss_cur)  ! column widths
  integer, intent(in) :: incr  ! spacing btw columns

  integer :: ivd2      ! 2nd dimension of val_field
  character*(*) :: val_field(nsss_cur,ivd2)

  integer, intent(in) :: ienum   ! enumeration display flag
  integer, intent(in) :: totsize

  !-----------------------
  integer :: ia_coln(0:nsss_cur)    ! ASCII column buffer addresses
  integer :: lnout,luntty
  integer :: ii,jj,kk,ia,iper,ierr

  character*256 :: hdr,rln,buf

  !-----------------------

  luntty = lnout(0)

  ia_coln(0)=1
  do ii=1,nsss_cur
     if(ii.eq.1) then
        hdr = disp0
        rln = rline(1:ilen_coln(0))
     endif

     ia_coln(ii)=ia_coln(ii-1) + ilen_coln(ii-1) + incr

     ia=ia_coln(ii)
     hdr(ia:) = trim(sss_label(ii))
     rln(ia:) = rline(1:ilen_coln(ii))
  enddo

  write(luntty,*) ' '
  write(luntty,*) trim(xlabel)
  write(luntty,*) ' '
  write(luntty,*) trim(hdr)
  write(luntty,*) trim(rln)

  do jj=1,totsize
     do kk=1,iper
        if(kk.eq.1) then
           buf = wmerge%list_elems(jj)
        else
           buf = ' '
        endif

        do ii=1,nsss_cur
           ia=ia_coln(ii)
           buf(ia:) = val_field(ii,(jj-1)*iper + kk)
        enddo
        write(luntty,*) trim(buf)
     enddo
  enddo
  write(luntty,*) ' '
  if(cmt.ne.' ') then
     write(luntty,*) trim(cmt)
     write(luntty,*) ' '
  endif

end subroutine cstate_table_out

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_c3_dummy
     return
  end subroutine ccps_getset_c3_dummy

subroutine psget_coil_in_circuit(iobj, n1, data, ierr)
    !! circuit to which each coil belongs, (each must exactly match
    !! a name in the circuit_name(...) list).
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    CHARACTER*(*), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_coil_in_circuit', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % coil_in_circuit
end subroutine psget_coil_in_circuit


subroutine psset_coil_in_circuit(iobj, n1, data, ierr)
    !! circuit to which each coil belongs, (each must exactly match
    !! a name in the circuit_name(...) list).
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    CHARACTER*(*), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_coil_in_circuit', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % coil_in_circuit = data(1:n1)
end subroutine psset_coil_in_circuit


subroutine psgetsz_coil_in_circuit(iobj, size, ierr)
    !! circuit to which each coil belongs, (each must exactly match
    !! a name in the circuit_name(...) list).
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: size    ! size of character string
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psgetsz_coil_in_circuit', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! note that the following will return the character length size regardless of
    ! the number of array elements (if coil_in_circuit is an array)
    size = len(ss % coil_in_circuit)
end subroutine psgetsz_coil_in_circuit


subroutine psgetrnk_coil_in_circuit(iobj, ndims, ierr)
    !! circuit to which each coil belongs, (each must exactly match
    !! a name in the circuit_name(...) list).
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_coil_in_circuit


subroutine psgetdim_coil_in_circuit(iobj, ndims, dims, ierr)
    !! circuit to which each coil belongs, (each must exactly match
    !! a name in the circuit_name(...) list).
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_coil_in_circuit', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % coil_in_circuit ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % coil_in_circuit)
    endif
end subroutine psgetdim_coil_in_circuit


subroutine psget_coil_resispt(iobj, n1, data, ierr)
    !! coil resistance per turn, total resistance (ohms) of coil j:
    !! abs(Nturns(j))*coil_resispt(j)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_coil_resispt', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % coil_resispt
end subroutine psget_coil_resispt


subroutine psset_coil_resispt(iobj, n1, data, ierr)
    !! coil resistance per turn, total resistance (ohms) of coil j:
    !! abs(Nturns(j))*coil_resispt(j)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_coil_resispt', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % coil_resispt = data(1:n1)
end subroutine psset_coil_resispt


subroutine psgetrnk_coil_resispt(iobj, ndims, ierr)
    !! coil resistance per turn, total resistance (ohms) of coil j:
    !! abs(Nturns(j))*coil_resispt(j)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_coil_resispt


subroutine psgetdim_coil_resispt(iobj, ndims, dims, ierr)
    !! coil resistance per turn, total resistance (ohms) of coil j:
    !! abs(Nturns(j))*coil_resispt(j)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_coil_resispt', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % coil_resispt ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % coil_resispt)
    endif
end subroutine psgetdim_coil_resispt


subroutine psget_chii_trans(iobj, n1, data, ierr)
    !! ion thermal diffusivity
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_chii_trans', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % chii_trans
end subroutine psget_chii_trans


subroutine psset_chii_trans(iobj, n1, data, ierr)
    !! ion thermal diffusivity
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_chii_trans', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % chii_trans = data(1:n1)
end subroutine psset_chii_trans


subroutine psgetrnk_chii_trans(iobj, ndims, ierr)
    !! ion thermal diffusivity
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_chii_trans


subroutine psgetdim_chii_trans(iobj, ndims, dims, ierr)
    !! ion thermal diffusivity
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_chii_trans', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % chii_trans ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % chii_trans)
    endif
end subroutine psgetdim_chii_trans


subroutine psget_curech(iobj, n1, data, ierr)
    !! ECH current drive
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_curech', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % curech
end subroutine psget_curech


subroutine psset_curech(iobj, n1, data, ierr)
    !! ECH current drive
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_curech', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % curech = data(1:n1)
end subroutine psset_curech


subroutine psgetrnk_curech(iobj, ndims, ierr)
    !! ECH current drive
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_curech


subroutine psgetdim_curech(iobj, ndims, dims, ierr)
    !! ECH current drive
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_curech', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % curech ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % curech)
    endif
end subroutine psgetdim_curech


subroutine psget_chii_anom(iobj, n1, data, ierr)
    !! Ti-equation, diffusivity term
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_chii_anom', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % chii_anom
end subroutine psget_chii_anom


subroutine psset_chii_anom(iobj, n1, data, ierr)
    !! Ti-equation, diffusivity term
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_chii_anom', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % chii_anom = data(1:n1)
end subroutine psset_chii_anom


subroutine psgetrnk_chii_anom(iobj, ndims, ierr)
    !! Ti-equation, diffusivity term
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_chii_anom


subroutine psgetdim_chii_anom(iobj, ndims, dims, ierr)
    !! Ti-equation, diffusivity term
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_chii_anom', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % chii_anom ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % chii_anom)
    endif
end subroutine psgetdim_chii_anom


subroutine psget_chie_tglf(iobj, n1, data, ierr)
    !! Te-equation, diffusivity from TGLF model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_chie_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % chie_tglf
end subroutine psget_chie_tglf


subroutine psset_chie_tglf(iobj, n1, data, ierr)
    !! Te-equation, diffusivity from TGLF model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_chie_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % chie_tglf = data(1:n1)
end subroutine psset_chie_tglf


subroutine psgetrnk_chie_tglf(iobj, ndims, ierr)
    !! Te-equation, diffusivity from TGLF model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_chie_tglf


subroutine psgetdim_chie_tglf(iobj, ndims, dims, ierr)
    !! Te-equation, diffusivity from TGLF model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_chie_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % chie_tglf ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % chie_tglf)
    endif
end subroutine psgetdim_chie_tglf


subroutine psget_chiphi_w19(iobj, n1, data, ierr)
    !! momentum-equation, diffusivity term
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_chiphi_w19', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % chiphi_w19
end subroutine psget_chiphi_w19


subroutine psset_chiphi_w19(iobj, n1, data, ierr)
    !! momentum-equation, diffusivity term
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_chiphi_w19', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % chiphi_w19 = data(1:n1)
end subroutine psset_chiphi_w19


subroutine psgetrnk_chiphi_w19(iobj, ndims, ierr)
    !! momentum-equation, diffusivity term
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_chiphi_w19


subroutine psgetdim_chiphi_w19(iobj, ndims, dims, ierr)
    !! momentum-equation, diffusivity term
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_chiphi_w19', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % chiphi_w19 ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % chiphi_w19)
    endif
end subroutine psgetdim_chiphi_w19

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_a7_dummy
     return
  end subroutine ccps_getset_a7_dummy

subroutine psget_ang_href_coil(iobj, n1, data, ierr)
    !! angle w.r.t. horizontal of coil base, zero means, base is
    !! alligned horizontally, +10 (degrees) means, tilted up to the
    !! right;, -10 (degrees) means, tilted down to the right
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_ang_href_coil', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % Ang_Href_coil
end subroutine psget_ang_href_coil


subroutine psset_ang_href_coil(iobj, n1, data, ierr)
    !! angle w.r.t. horizontal of coil base, zero means, base is
    !! alligned horizontally, +10 (degrees) means, tilted up to the
    !! right;, -10 (degrees) means, tilted down to the right
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_ang_href_coil', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % Ang_Href_coil = data(1:n1)
end subroutine psset_ang_href_coil


subroutine psgetrnk_ang_href_coil(iobj, ndims, ierr)
    !! angle w.r.t. horizontal of coil base, zero means, base is
    !! alligned horizontally, +10 (degrees) means, tilted up to the
    !! right;, -10 (degrees) means, tilted down to the right
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_ang_href_coil


subroutine psgetdim_ang_href_coil(iobj, ndims, dims, ierr)
    !! angle w.r.t. horizontal of coil base, zero means, base is
    !! alligned horizontally, +10 (degrees) means, tilted up to the
    !! right;, -10 (degrees) means, tilted down to the right
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_ang_href_coil', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % Ang_Href_coil ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % Ang_Href_coil)
    endif
end subroutine psgetdim_ang_href_coil


subroutine psget_ap2_halfwidth(iobj, n1, data, ierr)
    !! 2nd aperture half-width, for nbap_shape(j)="rectangle", this
    !! is the horizontal size, specification; for
    !! nbap_shape(j)="circle", ap_halfwidth(j) is, the radius; ignored
    !! if there is no 2nd aperture.
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_ap2_halfwidth', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % ap2_halfwidth
end subroutine psget_ap2_halfwidth


subroutine psset_ap2_halfwidth(iobj, n1, data, ierr)
    !! 2nd aperture half-width, for nbap_shape(j)="rectangle", this
    !! is the horizontal size, specification; for
    !! nbap_shape(j)="circle", ap_halfwidth(j) is, the radius; ignored
    !! if there is no 2nd aperture.
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_ap2_halfwidth', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % ap2_halfwidth = data(1:n1)
end subroutine psset_ap2_halfwidth


subroutine psgetrnk_ap2_halfwidth(iobj, ndims, ierr)
    !! 2nd aperture half-width, for nbap_shape(j)="rectangle", this
    !! is the horizontal size, specification; for
    !! nbap_shape(j)="circle", ap_halfwidth(j) is, the radius; ignored
    !! if there is no 2nd aperture.
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_ap2_halfwidth


subroutine psgetdim_ap2_halfwidth(iobj, ndims, dims, ierr)
    !! 2nd aperture half-width, for nbap_shape(j)="rectangle", this
    !! is the horizontal size, specification; for
    !! nbap_shape(j)="circle", ap_halfwidth(j) is, the radius; ignored
    !! if there is no 2nd aperture.
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_ap2_halfwidth', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % ap2_halfwidth ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % ap2_halfwidth)
    endif
end subroutine psgetdim_ap2_halfwidth


subroutine psget_ant_model(iobj, n1, data, ierr)
    !! antenna model filenames (1 per antenna source)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    CHARACTER*(*), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_ant_model', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % ant_model
end subroutine psget_ant_model


subroutine psset_ant_model(iobj, n1, data, ierr)
    !! antenna model filenames (1 per antenna source)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    CHARACTER*(*), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_ant_model', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % ant_model = data(1:n1)
end subroutine psset_ant_model


subroutine psgetsz_ant_model(iobj, size, ierr)
    !! antenna model filenames (1 per antenna source)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: size    ! size of character string
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psgetsz_ant_model', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! note that the following will return the character length size regardless of
    ! the number of array elements (if ant_model is an array)
    size = len(ss % ant_model)
end subroutine psgetsz_ant_model


subroutine psgetrnk_ant_model(iobj, ndims, ierr)
    !! antenna model filenames (1 per antenna source)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_ant_model


subroutine psgetdim_ant_model(iobj, ndims, dims, ierr)
    !! antenna model filenames (1 per antenna source)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_ant_model', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % ant_model ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % ant_model)
    endif
end subroutine psgetdim_ant_model

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_p1_dummy
     return
  end subroutine ccps_getset_p1_dummy

subroutine psget_psmom_num(iobj, n1, data, ierr)
    !! Pfirsch-Schlutter moments, if call to compute PS moments
    !! occurs and this has not been', "initialized, npsmom=16 will be
    !! set, and psmom_num(1)='1',", "psmom_num(2)='2', ...,
    !! psmom_num(16)='16'"]
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    CHARACTER*(*), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_psmom_num', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % psmom_num
end subroutine psget_psmom_num


subroutine psset_psmom_num(iobj, n1, data, ierr)
    !! Pfirsch-Schlutter moments, if call to compute PS moments
    !! occurs and this has not been', "initialized, npsmom=16 will be
    !! set, and psmom_num(1)='1',", "psmom_num(2)='2', ...,
    !! psmom_num(16)='16'"]
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    CHARACTER*(*), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_psmom_num', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % psmom_num = data(1:n1)
end subroutine psset_psmom_num


subroutine psgetsz_psmom_num(iobj, size, ierr)
    !! Pfirsch-Schlutter moments, if call to compute PS moments
    !! occurs and this has not been', "initialized, npsmom=16 will be
    !! set, and psmom_num(1)='1',", "psmom_num(2)='2', ...,
    !! psmom_num(16)='16'"]
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: size    ! size of character string
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psgetsz_psmom_num', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! note that the following will return the character length size regardless of
    ! the number of array elements (if psmom_num is an array)
    size = len(ss % psmom_num)
end subroutine psgetsz_psmom_num


subroutine psgetrnk_psmom_num(iobj, ndims, ierr)
    !! Pfirsch-Schlutter moments, if call to compute PS moments
    !! occurs and this has not been', "initialized, npsmom=16 will be
    !! set, and psmom_num(1)='1',", "psmom_num(2)='2', ...,
    !! psmom_num(16)='16'"]
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_psmom_num


subroutine psgetdim_psmom_num(iobj, ndims, dims, ierr)
    !! Pfirsch-Schlutter moments, if call to compute PS moments
    !! occurs and this has not been', "initialized, npsmom=16 will be
    !! set, and psmom_num(1)='1',", "psmom_num(2)='2', ...,
    !! psmom_num(16)='16'"]
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_psmom_num', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % psmom_num ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % psmom_num)
    endif
end subroutine psgetdim_psmom_num


subroutine psget_power_ic(iobj, n1, data, ierr)
    !! power on each ICRF source
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_power_ic', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % power_ic
end subroutine psget_power_ic


subroutine psset_power_ic(iobj, n1, data, ierr)
    !! power on each ICRF source
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_power_ic', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % power_ic = data(1:n1)
end subroutine psset_power_ic


subroutine psgetrnk_power_ic(iobj, ndims, ierr)
    !! power on each ICRF source
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_power_ic


subroutine psgetdim_power_ic(iobj, ndims, dims, ierr)
    !! power on each ICRF source
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_power_ic', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % power_ic ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % power_ic)
    endif
end subroutine psgetdim_power_ic


subroutine psget_power_lh(iobj, n1, data, ierr)
    !! power on each LHRF source
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_power_lh', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % power_lh
end subroutine psget_power_lh


subroutine psset_power_lh(iobj, n1, data, ierr)
    !! power on each LHRF source
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_power_lh', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % power_lh = data(1:n1)
end subroutine psset_power_lh


subroutine psgetrnk_power_lh(iobj, ndims, ierr)
    !! power on each LHRF source
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_power_lh


subroutine psgetdim_power_lh(iobj, ndims, dims, ierr)
    !! power on each LHRF source
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_power_lh', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % power_lh ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % power_lh)
    endif
end subroutine psgetdim_power_lh


subroutine psget_pi_trans(iobj, n1, data, ierr)
    !! ion transport (loss) power
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_pi_trans', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % pi_trans
end subroutine psget_pi_trans


subroutine psset_pi_trans(iobj, n1, data, ierr)
    !! ion transport (loss) power
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_pi_trans', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % pi_trans = data(1:n1)
end subroutine psset_pi_trans


subroutine psgetrnk_pi_trans(iobj, ndims, ierr)
    !! ion transport (loss) power
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_pi_trans


subroutine psgetdim_pi_trans(iobj, ndims, dims, ierr)
    !! ion transport (loss) power
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_pi_trans', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % pi_trans ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % pi_trans)
    endif
end subroutine psgetdim_pi_trans


subroutine psget_pminth(iobj, n1, data, ierr)
    !! (de)thermalization of minority ions
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_pminth', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % pminth
end subroutine psget_pminth


subroutine psset_pminth(iobj, n1, data, ierr)
    !! (de)thermalization of minority ions
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_pminth', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % pminth = data(1:n1)
end subroutine psset_pminth


subroutine psgetrnk_pminth(iobj, ndims, ierr)
    !! (de)thermalization of minority ions
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_pminth


subroutine psgetdim_pminth(iobj, ndims, dims, ierr)
    !! (de)thermalization of minority ions
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_pminth', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % pminth ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % pminth)
    endif
end subroutine psgetdim_pminth


subroutine psget_pbi(iobj, n1, data, ierr)
    !! thermal ion heating by all beam ions
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_pbi', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % pbi
end subroutine psget_pbi


subroutine psset_pbi(iobj, n1, data, ierr)
    !! thermal ion heating by all beam ions
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_pbi', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % pbi = data(1:n1)
end subroutine psset_pbi


subroutine psgetrnk_pbi(iobj, ndims, ierr)
    !! thermal ion heating by all beam ions
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_pbi


subroutine psgetdim_pbi(iobj, ndims, dims, ierr)
    !! thermal ion heating by all beam ions
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_pbi', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % pbi ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % pbi)
    endif
end subroutine psgetdim_pbi


subroutine psget_pfusth(iobj, n1, data, ierr)
    !! thermalization of fusion ions
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_pfusth', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % pfusth
end subroutine psget_pfusth


subroutine psset_pfusth(iobj, n1, data, ierr)
    !! thermalization of fusion ions
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_pfusth', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % pfusth = data(1:n1)
end subroutine psset_pfusth


subroutine psgetrnk_pfusth(iobj, ndims, ierr)
    !! thermalization of fusion ions
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_pfusth


subroutine psgetdim_pfusth(iobj, ndims, dims, ierr)
    !! thermalization of fusion ions
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_pfusth', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % pfusth ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % pfusth)
    endif
end subroutine psgetdim_pfusth


subroutine psget_pot_ky_tglf(iobj, n1, n2, data, ierr)
    !! potential fluctuation spectrum
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_pot_ky_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % pot_ky_tglf
end subroutine psget_pot_ky_tglf


subroutine psset_pot_ky_tglf(iobj, n1, n2, data, ierr)
    !! potential fluctuation spectrum
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_pot_ky_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % pot_ky_tglf = data(1:n1, 1: n2)
end subroutine psset_pot_ky_tglf


subroutine psgetrnk_pot_ky_tglf(iobj, ndims, ierr)
    !! potential fluctuation spectrum
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_pot_ky_tglf


subroutine psgetdim_pot_ky_tglf(iobj, ndims, dims, ierr)
    !! potential fluctuation spectrum
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_pot_ky_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % pot_ky_tglf ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % pot_ky_tglf)
    endif
end subroutine psgetdim_pot_ky_tglf

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


SUBROUTINE plasma_state_contents_profs_7(itype,icomponent,ss,w,isize)


  ! fill window structure with requested table of contents

  USE plasma_state_mod
  IMPLICIT NONE

  INTEGER, INTENT(IN) :: itype   ! type of table of contents
                                 ! values such as ps_grid_dims or ps_profiles

  INTEGER, INTENT(IN) :: icomponent(ps_ccount) ! component flags
             ! icomponent(j).eq.1 => component j active
             ! e.g. icomponent(ps_cnum_EQ).eq.1 => EQ component is active

  TYPE (plasma_state) :: ss      ! state examined
  TYPE (ps_list_window) :: w     ! list window structure filled

  INTEGER, INTENT(INOUT) :: isize  ! incremented size...

  !----------------

  IF(icomponent(ps_cnum_FUS).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! sftherm
        w%list_elems(isize) = "sftherm"
        w%elem_descr(isize) = "fusion ion thermalization"
        w%component(isize) = "FUS"
        w%elem_units(isize) = "#/sec"
        w%c256val(isize) = "(nrho_fus-1,nspec_fusion)"
        IF(ALLOCATED(ss%sftherm)) THEN
           IF(ss%hash_codes(ps_phash_sftherm).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*DV"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_RAD).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! sii_xs
        w%list_elems(isize) = "sii_xs"
        w%elem_descr(isize) = "species source/sinks driven by xs(1:nxs)"
        w%component(isize) = "RAD"
        w%elem_units(isize) = "(#/sec)/(#/sec)"
        w%c256val(isize) = "(nrho_mist-1,0:nspec_th,nxs)"
        IF(ALLOCATED(ss%sii_xs)) THEN
           IF(ss%hash_codes(ps_phash_sii_xs).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*DV"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! sn_trans
        w%list_elems(isize) = "sn_trans"
        w%elem_descr(isize) = "particle transport (loss)"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "#/sec"
        w%c256val(isize) = "(nrho-1,0:nspec_th)"
        IF(ALLOCATED(ss%sn_trans)) THEN
           IF(ss%hash_codes(ps_phash_sn_trans).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*DV"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! sn_transcat
        w%list_elems(isize) = "sn_transcat"
        w%elem_descr(isize) = "species transport"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "#/sec"
        w%c256val(isize) = "(nrho-1,0:nspec_th,ntrcat)"
        IF(ALLOCATED(ss%sn_transcat)) THEN
           IF(ss%hash_codes(ps_phash_sn_transcat).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*DV"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_GAS).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! sprof0
        w%list_elems(isize) = "sprof0"
        w%elem_descr(isize) = "gas species source/sinks per unit species influx"
        w%component(isize) = "GAS"
        w%elem_units(isize) = "(#/sec)/(#/sec)"
        w%c256val(isize) = "(nrho_gas-1,nspec_gas,ngsc0)"
        IF(ALLOCATED(ss%sprof0)) THEN
           IF(ss%hash_codes(ps_phash_sprof0).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*DV"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_GAS).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! sprof0e
        w%list_elems(isize) = "sprof0e"
        w%elem_descr(isize) = "electron source per unit neutral species influx"
        w%component(isize) = "GAS"
        w%elem_units(isize) = "(#/sec)/(#/sec)"
        w%c256val(isize) = "(nrho_gas-1,ngsc0)"
        IF(ALLOCATED(ss%sprof0e)) THEN
           IF(ss%hash_codes(ps_phash_sprof0e).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*DV"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PEL).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! spsce
        w%list_elems(isize) = "spsce"
        w%elem_descr(isize) = "net source, thermal ions & electrons"
        w%component(isize) = "PEL"
        w%elem_units(isize) = "#/sec"
        w%c256val(isize) = "(nrho_pel-1,0:nspec_tha)"
        IF(ALLOCATED(ss%spsce)) THEN
           IF(ss%hash_codes(ps_phash_spsce).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*DV"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! squareLO
        w%list_elems(isize) = "squareLO"
        w%elem_descr(isize) = "lower outer squareness"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "-"
        w%c256val(isize) = "(nrho_eq_geo)"
        IF(ALLOCATED(ss%squareLO)) THEN
           IF(ss%hash_codes(ps_phash_squareLO).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! squareUO
        w%list_elems(isize) = "squareUO"
        w%elem_descr(isize) = "upper outer squareness"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "-"
        w%c256val(isize) = "(nrho_eq_geo)"
        IF(ALLOCATED(ss%squareUO)) THEN
           IF(ss%hash_codes(ps_phash_squareUO).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! surf
        w%list_elems(isize) = "surf"
        w%elem_descr(isize) = "area of flux surfaces"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "m^2"
        w%c256val(isize) = "(nrho_eq)"
        IF(ALLOCATED(ss%surf)) THEN
           IF(ss%hash_codes(ps_phash_surf).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "SPLINE"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_GAS).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! T0cx
        w%list_elems(isize) = "T0cx"
        w%elem_descr(isize) = "effective neutral temperature for CX power"
        w%component(isize) = "GAS"
        w%elem_units(isize) = "keV"
        w%c256val(isize) = "(nrho_gas-1,ngsc0)"
        IF(ALLOCATED(ss%T0cx)) THEN
           IF(ss%hash_codes(ps_phash_T0cx).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*QQCX"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_GAS).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! T0sc0
        w%list_elems(isize) = "T0sc0"
        w%elem_descr(isize) = "neutral temperature (2/3)<E0>"
        w%component(isize) = "GAS"
        w%elem_units(isize) = "keV"
        w%c256val(isize) = "(nrho_gas-1,nspec_gas,ngsc0)"
        IF(ALLOCATED(ss%T0sc0)) THEN
           IF(ss%hash_codes(ps_phash_T0sc0).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*N0NORM"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! T0_halo
        w%list_elems(isize) = "T0_halo"
        w%elem_descr(isize) = "halo neutral temperature (2/3)<E0>"
        w%component(isize) = "NBI"
        w%elem_units(isize) = "keV"
        w%c256val(isize) = "(nrho_nbi-1,nspec_gas)"
        IF(ALLOCATED(ss%T0_halo)) THEN
           IF(ss%hash_codes(ps_phash_T0_halo).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*N0_HALO"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_GAS).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! T0_reco
        w%list_elems(isize) = "T0_reco"
        w%elem_descr(isize) = "reco neutral temperature (2/3)<E0>"
        w%component(isize) = "GAS"
        w%elem_units(isize) = "keV"
        w%c256val(isize) = "(nrho_gas-1,nspec_gas)"
        IF(ALLOCATED(ss%T0_reco)) THEN
           IF(ss%hash_codes(ps_phash_T0_reco).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*N0_RECO"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! teflux_ky_tglf
        w%list_elems(isize) = "teflux_ky_tglf"
        w%elem_descr(isize) = "electron density flux spectrum"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "GB"
        w%c256val(isize) = "(nrho_anomth,nky_anomth)"
        IF(ALLOCATED(ss%teflux_ky_tglf)) THEN
           IF(ss%hash_codes(ps_phash_teflux_ky_tglf).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! te_ky_tglf
        w%list_elems(isize) = "te_ky_tglf"
        w%elem_descr(isize) = "electron density fluctuation spectrum"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "GB"
        w%c256val(isize) = "(nrho_anomth,nky_anomth)"
        IF(ALLOCATED(ss%te_ky_tglf)) THEN
           IF(ss%hash_codes(ps_phash_te_ky_tglf).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_RIPPLE).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! tfrip2_log
        w%list_elems(isize) = "tfrip2_log"
        w%elem_descr(isize) = "2nd component of TF ripple"
        w%component(isize) = "RIPPLE"
        w%elem_units(isize) = "-"
        w%c256val(isize) = "(nr_rip,nz_rip)"
        IF(ALLOCATED(ss%tfrip2_log)) THEN
           IF(ss%hash_codes(ps_phash_tfrip2_log).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_RIPPLE).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! tfrip_log
        w%list_elems(isize) = "tfrip_log"
        w%elem_descr(isize) = "TF ripple: log((Bmax-Bmin)/(Bmax+Bmin))"
        w%component(isize) = "RIPPLE"
        w%elem_units(isize) = "-"
        w%c256val(isize) = "(nr_rip,nz_rip)"
        IF(ALLOCATED(ss%tfrip_log)) THEN
           IF(ss%hash_codes(ps_phash_tfrip_log).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! Ti
        w%list_elems(isize) = "Ti"
        w%elem_descr(isize) = "ion temperature"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "keV"
        w%c256val(isize) = "(nrho-1)"
        IF(ALLOCATED(ss%Ti)) THEN
           IF(ss%hash_codes(ps_phash_Ti).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*NI"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! tiflux_ky_tglf
        w%list_elems(isize) = "tiflux_ky_tglf"
        w%elem_descr(isize) = "ion density flux spectrum"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "GB"
        w%c256val(isize) = "(nrho_anomth,nky_anomth)"
        IF(ALLOCATED(ss%tiflux_ky_tglf)) THEN
           IF(ss%hash_codes(ps_phash_tiflux_ky_tglf).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! ti_ky_tglf
        w%list_elems(isize) = "ti_ky_tglf"
        w%elem_descr(isize) = "ion density fluctuation spectrum"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "GB"
        w%c256val(isize) = "(nrho_anomth,nky_anomth)"
        IF(ALLOCATED(ss%ti_ky_tglf)) THEN
           IF(ss%hash_codes(ps_phash_ti_ky_tglf).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! tmodel
        w%list_elems(isize) = "tmodel"
        w%elem_descr(isize) = "target temperature profile"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "keV"
        w%c256val(isize) = "(nrho_anomth-1)"
        IF(ALLOCATED(ss%tmodel)) THEN
           IF(ss%hash_codes(ps_phash_tmodel).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*NMODEL"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_GAS).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! tq0_reco
        w%list_elems(isize) = "tq0_reco"
        w%elem_descr(isize) = "torque of recombination neutral source"
        w%component(isize) = "GAS"
        w%elem_units(isize) = "Nt*m"
        w%c256val(isize) = "(nrho_gas-1)"
        IF(ALLOCATED(ss%tq0_reco)) THEN
           IF(ss%hash_codes(ps_phash_tq0_reco).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*DV"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! tqb0_halo
        w%list_elems(isize) = "tqb0_halo"
        w%elem_descr(isize) = "torque of halo neutral source"
        w%component(isize) = "NBI"
        w%elem_units(isize) = "Nt*m"
        w%c256val(isize) = "(nrho_nbi-1)"
        IF(ALLOCATED(ss%tqb0_halo)) THEN
           IF(ss%hash_codes(ps_phash_tqb0_halo).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*DV"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! tqbe
        w%list_elems(isize) = "tqbe"
        w%elem_descr(isize) = "collisional beam torque to electrons"
        w%component(isize) = "NBI"
        w%elem_units(isize) = "Nt*m"
        w%c256val(isize) = "(nrho_nbi-1)"
        IF(ALLOCATED(ss%tqbe)) THEN
           IF(ss%hash_codes(ps_phash_tqbe).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*DV"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! tqbi
        w%list_elems(isize) = "tqbi"
        w%elem_descr(isize) = "collisional beam torque to thermal ions"
        w%component(isize) = "NBI"
        w%elem_units(isize) = "Nt*m"
        w%c256val(isize) = "(nrho_nbi-1)"
        IF(ALLOCATED(ss%tqbi)) THEN
           IF(ss%hash_codes(ps_phash_tqbi).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*DV"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! tqbjxb
        w%list_elems(isize) = "tqbjxb"
        w%elem_descr(isize) = "JxB beam torque"
        w%component(isize) = "NBI"
        w%elem_units(isize) = "Nt*m"
        w%c256val(isize) = "(nrho_nbi-1)"
        IF(ALLOCATED(ss%tqbjxb)) THEN
           IF(ss%hash_codes(ps_phash_tqbjxb).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*DV"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! tqbth
        w%list_elems(isize) = "tqbth"
        w%elem_descr(isize) = "momentum in thermalization of beam ions"
        w%component(isize) = "NBI"
        w%elem_units(isize) = "Nt*m"
        w%c256val(isize) = "(nrho_nbi-1)"
        IF(ALLOCATED(ss%tqbth)) THEN
           IF(ss%hash_codes(ps_phash_tqbth).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*DV"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! tqcx_halo
        w%list_elems(isize) = "tqcx_halo"
        w%elem_descr(isize) = "beam halo driven CX momentum torque"
        w%component(isize) = "NBI"
        w%elem_units(isize) = "Nt*m"
        w%c256val(isize) = "(nrho_nbi-1)"
        IF(ALLOCATED(ss%tqcx_halo)) THEN
           IF(ss%hash_codes(ps_phash_tqcx_halo).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*DV"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_GAS).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! tqcx_reco
        w%list_elems(isize) = "tqcx_reco"
        w%elem_descr(isize) = "reco driven CX momentum torque"
        w%component(isize) = "GAS"
        w%elem_units(isize) = "Nt*m"
        w%c256val(isize) = "(nrho_gas-1)"
        IF(ALLOCATED(ss%tqcx_reco)) THEN
           IF(ss%hash_codes(ps_phash_tqcx_reco).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*DV"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_GAS).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! tqioniz
        w%list_elems(isize) = "tqioniz"
        w%elem_descr(isize) = "ionization torque per unit influx (sc0)"
        w%component(isize) = "GAS"
        w%elem_units(isize) = "Nt*m/(#/sec)"
        w%c256val(isize) = "(nrho_gas-1,ngsc0)"
        IF(ALLOCATED(ss%tqioniz)) THEN
           IF(ss%hash_codes(ps_phash_tqioniz).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*DV"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_GAS).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! tqqcx
        w%list_elems(isize) = "tqqcx"
        w%elem_descr(isize) = "cx torque per unit influx per (omeg0-omegi)"
        w%component(isize) = "GAS"
        w%elem_units(isize) = "Nt*m/(#/sec)/(rad/sec)"
        w%c256val(isize) = "(nrho_gas-1,ngsc0)"
        IF(ALLOCATED(ss%tqqcx)) THEN
           IF(ss%hash_codes(ps_phash_tqqcx).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*DV"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! tqsc_halo
        w%list_elems(isize) = "tqsc_halo"
        w%elem_descr(isize) = "beam halo torque: recapture - tqb0_halo"
        w%component(isize) = "NBI"
        w%elem_units(isize) = "Nt*m"
        w%c256val(isize) = "(nrho_nbi-1)"
        IF(ALLOCATED(ss%tqsc_halo)) THEN
           IF(ss%hash_codes(ps_phash_tqsc_halo).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*DV"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_GAS).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! tqsc_reco
        w%list_elems(isize) = "tqsc_reco"
        w%elem_descr(isize) = "reco torque: recapture - tq0_reco"
        w%component(isize) = "GAS"
        w%elem_units(isize) = "Nt*m"
        w%c256val(isize) = "(nrho_gas-1)"
        IF(ALLOCATED(ss%tqsc_reco)) THEN
           IF(ss%hash_codes(ps_phash_tqsc_reco).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*DV"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! tq_anom
        w%list_elems(isize) = "tq_anom"
        w%elem_descr(isize) = "anomalous torque"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "Nt*m"
        w%c256val(isize) = "(nrho_anomth-1)"
        IF(ALLOCATED(ss%tq_anom)) THEN
           IF(ss%hash_codes(ps_phash_tq_anom).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*DV"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! tq_trans
        w%list_elems(isize) = "tq_trans"
        w%elem_descr(isize) = "angular momentum transport (loss)"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "Nt*m"
        w%c256val(isize) = "(nrho-1)"
        IF(ALLOCATED(ss%tq_trans)) THEN
           IF(ss%hash_codes(ps_phash_tq_trans).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*DV"
     ENDIF
  ENDIF
END SUBROUTINE plasma_state_contents_profs_7

subroutine ps_psimap_sub(nvec,psi,rhopsi,tol,jwarn,iobj,iout,ierr)

  !------------------------------------------------------------
  ! D. McCune 4 Apr 2007

  ! XPLASMA2 implementation of Psi -> rho(Psi) mapper
  ! Find rho values such that spline of Psi(rho(j)) = psi(j) input

  !------------------------------------------------------------

  use plasma_state_definition_mod
  use plasma_state_xpobj  ! XPLASMA2 state object definitions
  implicit NONE

  !-----------------------
  integer, intent(in) :: nvec              ! size of arrays

  real(kind=rspec), intent(in) :: psi(nvec)      ! Psi values
  real(kind=rspec), intent(out) :: rhopsi(nvec)  ! rho(Psi) values returned

  real(kind=rspec), intent(in) :: tol      ! accuracy tolerance
  integer, intent(out) :: jwarn            ! out-of-bounds warning (0 for none)

  integer :: iobj(ps_container_size)     ! xplasma opaque container
  integer, intent(in) :: iout              ! LUN for error messages
  integer, intent(out) :: ierr             ! error status code returned 0 = OK

  !--------------------------------------------------
  type (interp_object) :: xobj
  type (xplasma), pointer :: s
  !--------------------------------------------------

  xobj = transfer(iobj,xobj)
  s => xobj%s_xpobj

  call xplasma_global_info(s,ierr, init_check=.TRUE.)
  if(ierr.ne.0) then
     write(iout,*) ' %ps_limsize: invalid or unitialized xplasma object.'
     jwarn = 99
     rhopsi = 0.0_rspec
     return
  endif

  !--------------------------------------------------
  !  perform the integration with error checking...

  call xplasma_rhopsi_find(s,psi,rhopsi,ierr, tol=tol, iwarn=jwarn)
  if(ierr.ne.0) then
     write(iout,*) &
          ' ?ps_psimap_sub: Psi -> rho(Psi) mapping failed in xplasma:'
     call xplasma_error(s,ierr,iout)
     rhopsi = 0.0_rspec
     return
  endif

end subroutine ps_psimap_sub

subroutine cstate_gen_indmap(indmap,isize)

  !  create index map:  members of groups are mapped to group that contains
  !  them...

  use cstate_lib_mod
  implicit NONE

  !-------------------------
  !  passed:

  integer, intent(in) :: isize
  integer, intent(out) :: indmap(isize)

  !-------------------------
  !  local:

  integer :: itest,ii,indx,ic,ic1,ic2,icprev,ilen
  logical :: ilast
  character*32 zname
  character*200 zbuf
  !-------------------------
 
  do ii=1,isize
     indmap(ii)=ii
  enddo

  if(isize.ne.w1%size) then
     call errmsg_exit(' ?cstate_gen_indmap: internal error, w1 & indmap sizes not consistent.')
  endif

  do ii=1,isize

     itest = w1%ival(ii)
     if((itest.lt.-1).or.(itest.gt.1)) then
        ! group name detected, parse out contents

        zbuf = w1%elem_descr(ii)
        ilen = len(trim(zbuf))

        icprev=1
        ilast = .FALSE.

        do 
           ic1=icprev+1
           do ic=ic1,ilen
              if(zbuf(ic:ic).eq.',') then
                 ilast=.FALSE.
                 icprev=ic
                 ic2=ic-1
                 exit
              else if(zbuf(ic:ic).eq.'}') then
                 ilast=.TRUE.
                 ic2=ic-1
                 exit
              endif
           enddo

           zname = zbuf(ic1:ic2)
           call uupper(zname)

           call cstate_find1(zname,indx)

           indmap(indx)=ii
           if(ilast) exit
        enddo
     endif
  enddo

end subroutine cstate_gen_indmap

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_r3_dummy
     return
  end subroutine ccps_getset_r3_dummy

subroutine psget_rlim(iobj, n1, data, ierr)
    !! R points in closed (R,Z) contour sequence
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_rlim', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % rlim
end subroutine psget_rlim


subroutine psset_rlim(iobj, n1, data, ierr)
    !! R points in closed (R,Z) contour sequence
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_rlim', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % rlim = data(1:n1)
end subroutine psset_rlim


subroutine psgetrnk_rlim(iobj, ndims, ierr)
    !! R points in closed (R,Z) contour sequence
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_rlim


subroutine psgetdim_rlim(iobj, ndims, dims, ierr)
    !! R points in closed (R,Z) contour sequence
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_rlim', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % rlim ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % rlim)
    endif
end subroutine psgetdim_rlim


subroutine psget_r_ripple(iobj, n1, data, ierr)
    !! R grid for TF ripple field(s)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_r_ripple', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % R_ripple
end subroutine psget_r_ripple


subroutine psset_r_ripple(iobj, n1, data, ierr)
    !! R grid for TF ripple field(s)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_r_ripple', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % R_ripple = data(1:n1)
end subroutine psset_r_ripple


subroutine psgetrnk_r_ripple(iobj, ndims, ierr)
    !! R grid for TF ripple field(s)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_r_ripple


subroutine psgetdim_r_ripple(iobj, ndims, dims, ierr)
    !! R grid for TF ripple field(s)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_r_ripple', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % R_ripple ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % R_ripple)
    endif
end subroutine psgetdim_r_ripple


subroutine psget_rho_anom2(iobj, n1, data, ierr)
    !! rho grid (2d anomalous transport profiles)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_rho_anom2', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % rho_anom2
end subroutine psget_rho_anom2


subroutine psset_rho_anom2(iobj, n1, data, ierr)
    !! rho grid (2d anomalous transport profiles)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_rho_anom2', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % rho_anom2 = data(1:n1)
end subroutine psset_rho_anom2


subroutine psgetrnk_rho_anom2(iobj, ndims, ierr)
    !! rho grid (2d anomalous transport profiles)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_rho_anom2


subroutine psgetdim_rho_anom2(iobj, ndims, dims, ierr)
    !! rho grid (2d anomalous transport profiles)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_rho_anom2', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % rho_anom2 ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % rho_anom2)
    endif
end subroutine psgetdim_rho_anom2


subroutine psget_rho_bdy_omegat(iobj, data, ierr)
    !! location beyond which angular velocity is known
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_rho_bdy_omegat', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % rho_bdy_omegat
end subroutine psget_rho_bdy_omegat


subroutine psset_rho_bdy_omegat(iobj, data, ierr)
    !! location beyond which angular velocity is known
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_rho_bdy_omegat', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % rho_bdy_omegat = data
end subroutine psset_rho_bdy_omegat


subroutine psget_r_min_lcfs(iobj, data, ierr)
    !! R_min of last closed flux surface
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_r_min_lcfs', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % R_min_lcfs
end subroutine psget_r_min_lcfs


subroutine psset_r_min_lcfs(iobj, data, ierr)
    !! R_min of last closed flux surface
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_r_min_lcfs', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % R_min_lcfs = data
end subroutine psset_r_min_lcfs


subroutine psget_rminor_mean(iobj, n1, data, ierr)
    !! rMinor_mean = (R_Surfmax-R_surfmin)/2
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_rminor_mean', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % rMinor_mean
end subroutine psget_rminor_mean


subroutine psset_rminor_mean(iobj, n1, data, ierr)
    !! rMinor_mean = (R_Surfmax-R_surfmin)/2
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_rminor_mean', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % rMinor_mean = data(1:n1)
end subroutine psset_rminor_mean


subroutine psgetrnk_rminor_mean(iobj, ndims, ierr)
    !! rMinor_mean = (R_Surfmax-R_surfmin)/2
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_rminor_mean


subroutine psgetdim_rminor_mean(iobj, ndims, dims, ierr)
    !! rMinor_mean = (R_Surfmax-R_surfmin)/2
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_rminor_mean', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % rMinor_mean ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % rMinor_mean)
    endif
end subroutine psgetdim_rminor_mean


subroutine psget_rate_sinb0x(iobj, n1, n2, data, ierr)
    !! sink rate due to CX with beam ions (total)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_rate_sinb0x', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % rate_sinb0x
end subroutine psget_rate_sinb0x


subroutine psset_rate_sinb0x(iobj, n1, n2, data, ierr)
    !! sink rate due to CX with beam ions (total)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_rate_sinb0x', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % rate_sinb0x = data(1:n1, 1: n2)
end subroutine psset_rate_sinb0x


subroutine psgetrnk_rate_sinb0x(iobj, ndims, ierr)
    !! sink rate due to CX with beam ions (total)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_rate_sinb0x


subroutine psgetdim_rate_sinb0x(iobj, ndims, dims, ierr)
    !! sink rate due to CX with beam ions (total)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_rate_sinb0x', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % rate_sinb0x ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % rate_sinb0x)
    endif
end subroutine psgetdim_rate_sinb0x

subroutine ur_cstate_sdata(subsect)

  ! examine non-profile data contained in the state(s)

  use cstate_lib_mod
  implicit NONE

  character*(*), intent(in) :: subsect

  !-------------------------
  ! local

  integer :: luntty,lnout
  logical :: lxout,lchar,lyes
  integer :: icontents,iimap,indx,ind2,isize,icount
  integer, dimension(:), allocatable :: indmap
  integer :: imin,imax,ilen_coln(0:nsss_cur),ilen0d
  integer :: isize_tot,ii,ierr,jsize,jj,kk,ia,ifloat,inorm
  integer :: totsize
  integer :: iterms,iii,jjj,ienum,imaxe,iper

  integer :: ndims,idims(20),ilodims(20),indx_enum

  character*9 zdate
  character*32 :: dname,dunits,pname
  character*70 :: disp0,xlabel,xunits,plabel,punits,cmt
  real*8 :: pnorm,psum,pwght
  logical :: avg_flag

  integer :: ivd2

  character*32, dimension(:,:), allocatable :: val_field
  integer, dimension(:,:), allocatable :: sum_key
  integer, dimension(:,:,:), allocatable :: sum_table
  character*32, dimension(:), allocatable :: merge_names

  !-------------------------
  ! for enumeration plot option:
  integer :: jself(nsss_cur),inumc(nsss_cur)
  integer :: isel,ivecsiz
  real*8 :: zdum(nsss_cur)
  character*32 fnlab(nsss_cur)
  real*8, dimension(:,:), allocatable :: xxplot,yyplot
  !-------------------------
  real*8, parameter :: ZERO=0.0d0
  !-------------------------

  luntty = lnout(0)

  kk=0

  icontents = 0
  iimap = 0

  do
     if(lxout(0)) then
        write(luntty,1001) omit_empty,trim(cur_components),nprec,ntail,nenum

1001    format('ur_cstate_sdata options:'/ &
             '  A -- option to omit empty elements from display (',L1,')'/ &
             '  C -- select & restrict view to component(s) (current selection: ',a,')'/ &
             '  T -- table of contents (show descriptions)'/ &
             '  U -- table of contents (show component, units & dimensions)'/ &
             '  R -- set list dimension reduction (summation) options'/ &
             '  S -- select a single data item & examine in detail'/ &
             '  P -- reset precision for display of floating point data (', &
             i2,')'/ &
             '  H -- adjust display subset for long character strings (', &
             i3,')'/ &
             '  L -- modify state label(s)'/ &
             '  M -- reset "soft" maximum enumeration data length (',i2,')'/ &
             '  Q -- quit this menu'/)
     endif
     call uread('ur_cstate_sdata option:')

     if(lchar('Q')) then
        exit

     else if(lchar('A')) then
        if(lxout(0)) write(luntty,*) &
             ' option to omit display of elements that are empty in all states.'

        call uread('omit empty elements ? (Y/N):')
        omit_empty = lyes(0)

     else if(lchar('C')) then
        icontents = 0
        iimap = 0
        call ur_cstate_component

     else if(lchar('L')) then
        call ur_cstate_setLabel

     else if(lchar('T')) then
        icontents = 1
        call ur_cstate_sdata_contents(2,subsect)

     else if(lchar('U')) then
        icontents = 1
        call ur_cstate_sdata_contents(1,subsect)

     else if(lchar('R')) then
        call ur_cstate_rcon

     else if(lchar('P')) then
        if(lxout(0)) then
           write(luntty,*) ' Floating point format: <sign>n.mm<esign>Exx'
           write(luntty,*) ' precision controls number of digits mm after the'
           write(luntty,*) ' decimal point; values btw 2 and 16 are accepted.'
        endif

        call ureadi('ur_cstate_sdata: floating point display precision:',nprec)
        nprec=max(2,min(16,nprec))

     else if(lchar('M')) then
        if(lxout(0)) then
           write(luntty,*) ' Provide a hint for maximum length of enumeration'
           write(luntty,*) ' data displays.  If the actual length is within'
           write(luntty,*) ' 50% of the limit, the actual length will be used.'
           write(luntty,*) ' Values between 6 and 50 are accepted.'
        endif

        call ureadi('ur_cstate_sdata: enumeration display lengh limit:',nenum)
        nenum=max(6,min(50,nenum))

     else if(lchar('H')) then
        if(lxout(0)) then
           write(luntty,*) ' In some table outputs, displays of character'
           write(luntty,*) ' strings of length greater than (32) are truncated.'
           write(luntty,*) ' The truncation variable controls how this is done:'
           write(luntty,*) ' 0 means display leading part of string;'
           write(luntty,*) ' -1 means display trailing part of string;'
           write(luntty,*) ' a positive integer value means, display starting'
           write(luntty,*) ' at the indicated character index value; this is'
           write(luntty,*) ' adjusted so that as much of the character string'
           write(luntty,*) ' as possible is displayed.  Truncation will be'
           write(luntty,*) ' indicated by ellipses "...".'
        endif

        call ureadi( &
             'ur_cstate_sdata: string truncation control (btw -1 and 999):', &
             ntail)
        ntail=max(-1,min(999,ntail))

     else if(lchar('S')) then
        if(icontents.eq.0) then
           icontents = 1
           call ur_cstate_sdata_contents(0,subsect)
        endif

        ! check contents...
        isize = w1%size
        if(isize.eq.0) then
           write(luntty,*) &
                ' %ur_cstate_sdatea: selected components contain no items.'
           call uclear
           cycle
        endif

        ! map some names to container group name...
        if(iimap.eq.0) then
           if(allocated(indmap)) deallocate(indmap)
           allocate(indmap(isize))
           call cstate_gen_indmap(indmap,isize)
           iimap=1
        endif

        ! get data item name
        if(lxout(0)) then
           write(luntty,*) '(unambiguous prefix of name may be entered).'
        endif
        call ureadw('ur_cstate_sdata: enter data item name or "." to skip:', &
             dname)
        if(dname.eq.'.') cycle

        call cstate_findm(dname,luntty,indx)
        if(indx.eq.0) then
           call uclear
           cycle
        endif

        ! map name to self or to container...
        ind2 = indmap(indx)

        dname = w1%list_elems(ind2)
        dunits = w1%elem_units(ind2)

        pname = ' '
        avg_flag=.FALSE.
        do inorm=1,nreduce_avg
           if(dname.eq.avg_var(inorm)) then
              pname=avg_wgt(inorm)
              call free_wwnorm
              allocate(wwnorm(nsss_cur))  ! weighted average possible
              avg_flag=.TRUE.
              exit
           endif
        enddo

        ! minimum, maximum display lengths
        if(dunits.eq.'character') then
           imin=6
           ifloat=0
        else if(dunits.eq.'integer') then
           imin=10
           ifloat=0
        else
           imin=nprec + 8  ! floating point...
           ifloat=1
        endif
        imax = 32

        isize_tot = 0
        icount = 0
        imaxe = 0   ! max enumeration size (if enumerations are encountered)

        ! set minimum display column widths...
        do ii=1,nsss_cur
           ilen_coln(ii)=max(imin,len(trim(sss_label(ii))))

           call psw_dlist(dname,ww(ii),xlabel,xunits,ierr, state=sss(ii))
           if(associated(ww(ii)%vecsizes)) then
              imaxe=max(1,imaxe)
              imaxe=max(imaxe,maxval(ww(ii)%vecsizes))
           endif

           if(ww(ii)%size.gt.0) then
              icount=icount+1
              if(pname.ne.' ') then
                 call psw_dlist(pname,wwnorm(ii),plabel,punits,ierr, &
                      state=sss(ii))
              endif
           endif

           if(icount.eq.1) then
              if(ifloat.eq.0) then
                 disp0 = trim(ww(ii)%list_name)
              else
                 disp0 = trim(ww(ii)%list_name)//' ('//trim(dunits)//')'
              endif
              ilen_coln(0)=len(trim(disp0))
           endif

           if(ww(ii)%size.eq.0) then
              write(luntty,*) ' empty list for state: '//trim(sss_label(ii))
           else
              isize_tot=isize_tot + ww(ii)%size
           endif
        enddo
        if(isize_tot.eq.0) then
           write(luntty,*) ' empty list.'
           cycle
        endif

        ienum=0
        if(imaxe.gt.0) then
           if(avg_flag) then
              write(luntty,*) ' ?ur_cstate_sdata: internal error, avg_flag=T'
              write(luntty,*) '  flag not applicable to enumeration data.'
              cycle
           endif
           ienum=imaxe
           if(ienum.gt.((3*nenum)/2)) ienum=nenum
        endif

        ! form merged list...

        cmt = ' '

        call cstate_ck_listdims(w1%c256val(ind2),size(idims),ndims, &
             idims,ilodims,indx_enum)
        if(ndims.eq.0) then

           ! scalar or scalar group; contents same for all states

           call clone_window(ww(1),wmerge)
           jsize = wmerge%size
           totsize = jsize
           if(imaxe.eq.0) then
              allocate(val_field(nsss_cur,jsize))
           else
              allocate(val_field(nsss_cur,ienum*jsize))
           endif
           val_field = ' '

           do jj=1,jsize
              ilen_coln(0)=max(ilen_coln(0),len(trim(ww(1)%list_elems(jj))))
              do ii=1,nsss_cur
                 if(imaxe.eq.0) then
                    call cstate_encode(dunits,ww(ii)%ival(jj),ww(ii)%fval(jj),&
                         ww(ii)%c256val(jj), val_field(ii,jj), ilen_coln(ii))
                 else
                    if(associated(ww(ii)%fvec)) then
                       call cstate_enumco( &
                            ww(ii)%vecsizes(jj),ww(ii)%fvec(:,jj), &
                            val_field,nsss_cur,ienum*jsize,ii,jj,ienum, &
                            ilen_coln(ii))
                    else
                       call cstate_inumco( &
                            ww(ii)%vecsizes(jj),ww(ii)%ivec(:,jj), &
                            val_field,nsss_cur,ienum*jsize,ii,jj,ienum, &
                            ilen_coln(ii))
                    endif
                 endif
              enddo
           enddo
        else

           ! separate dimensioning for each state

           call free_window(wmerge)
           call cstate_merge_size(ndims,idims(1:ndims),ilodims(1:ndims),jsize)
           allocate(sum_table(0:jsize,nsss_cur,jsize))
           allocate(sum_key(ndims,jsize))
           allocate(merge_names(jsize))

           call cstate_merge_addr( &
                ndims,idims(1:ndims),ilodims(1:ndims),jsize, &
                dname,dunits,imaxe, &
                sum_table,sum_key,merge_names,totsize)

           if(imaxe.eq.0) then
              allocate(val_field(nsss_cur,totsize))
           else
              allocate(val_field(nsss_cur,ienum*totsize))
           endif
           val_field = ' '

           wmerge%size = totsize
           allocate(wmerge%list_elems(totsize))
           wmerge%list_elems(1:totsize) = merge_names(1:totsize)

           do ii=1,nsss_cur
              do kk=1,totsize
                 if(sum(sum_key(1:ndims,kk)).eq.0) then
                    ! no summation
                    jj=sum_table(1,ii,kk)
                    if(jj.eq.0) then
                       if(imaxe.eq.0) then
                          val_field(ii,kk)=' (absent)'
                       else
                          val_field(ii,1+(kk-1)*ienum)=' (absent)'
                       endif
                    else
                       if(imaxe.eq.0) then
                          call cstate_encode(dunits, &
                               ww(ii)%ival(jj),ww(ii)%fval(jj), &
                               ww(ii)%c256val(jj), val_field(ii,kk), &
                               ilen_coln(ii))
                       else
                          if(associated(ww(ii)%fvec)) then
                             call cstate_enumco( &
                                  ww(ii)%vecsizes(jj),ww(ii)%fvec(:,jj), &
                                  val_field,nsss_cur,ienum*totsize, &
                                  ii,kk,ienum,ilen_coln(ii))
                          else
                             call cstate_inumco( &
                                  ww(ii)%vecsizes(jj),ww(ii)%ivec(:,jj), &
                                  val_field,nsss_cur,ienum*totsize, &
                                  ii,kk,ienum,ilen_coln(ii))
                          endif
                       endif

                       ilen_coln(0)=max(ilen_coln(0), &
                            len(trim(wmerge%list_elems(kk))))
                    endif
                 else
                    psum=ZERO
                    pnorm=1.0d0
                    if(avg_flag) then
                       cmt='   ...power weighted average(s).'
                       pnorm=ZERO
                    else
                       cmt='   ...summation(s) applied.'
                    endif
                    iterms=sum_table(0,ii,kk)

                    if(iterms.eq.0) then
                       val_field(ii,kk)=' (absent)'

                    else
                       do iii=1,iterms
                          jjj=sum_table(iii,ii,kk)
                          if(avg_flag) then
                             pwght=max(ZERO,wwnorm(ii)%fval(jjj))
                             pnorm=pnorm+pwght
                             psum=psum+pwght*ww(ii)%fval(jjj)
                          else
                             psum=psum+ww(ii)%fval(jjj)
                          endif
                       enddo

                       if(pnorm.gt.ZERO) psum = psum/pnorm

                       call cstate_encode(dunits, &
                            0,psum,' ', val_field(ii,kk), ilen_coln(ii))
                       ilen_coln(0)=max(ilen_coln(0), &
                            len(trim(wmerge%list_elems(kk))))
                    endif
                 endif
              enddo
           enddo

        endif

        !----------------------------------
        !  write the output table...

        ivd2 = size(val_field,2)

        call cstate_table_out(disp0,xlabel,cmt, &
             ilen_coln,1,val_field,ivd2, &
             ienum,totsize)

        !----------------------------------

        if(ienum.gt.0) then
           allocate(xxplot(imaxe,nsss_cur),yyplot(imaxe,nsss_cur))
           do kk=1,nsss_cur
              do jj=1,imaxe
                 xxplot(jj,kk)=jj
                 yyplot(jj,kk)=ZERO
              enddo
           enddo

           call c9date(zdate)

           kylab = ' '
           kylab(1)='State Label'

           mnlab(2)=' '

           do 
              if(lxout(0)) then
                 write(luntty,*) &
                      ' enter "Q" to quit (skip plot), or indicated number to select:'
                 do jj=1,totsize
                    write(luntty,'(3x,i3,".  ",a)') jj,wmerge%list_elems(jj)
                 enddo
              endif
              isel=0
              call ureadi( &
                   'ur_cstat_sdata plot option: enumeration # or "Q":',isel)
              if(isel.eq.0) exit

              if((isel.lt.0).or.(isel.gt.totsize)) then
                 write(luntty,*) ' %ur_cstate_sdata: enumeration selection not in range:'
                 write(luntty,*) '  min=1, max=',totsize,'  received: ',isel
                 call uclear
                 cycle
              endif

              kk=0
              do ii=1,nsss_cur
                 if(allocated(sum_table)) then
                    jj=sum_table(1,ii,isel)
                 else
                    jj=isel
                 endif
                 if(jj.ne.0) then
                    ivecsiz=ww(ii)%vecsizes(jj)
                    if(ivecsiz.gt.0) then
                       kk=kk+1
                       if(kk.eq.1) then
                          jself(kk)=-kk
                          mnlab(3)=trim(wmerge%list_elems(isel))// &
                               ' vs. array index'
                       else
                          jself(kk)=kk
                       endif
                       fnlab(kk)=trim(sss_label(ii))
                       inumc(kk)=ivecsiz
                       zdum(kk)=kk

                       if(associated(ww(ii)%fvec)) then
                          yyplot(1:ivecsiz,kk)=ww(ii)%fvec(1:ivecsiz,jj)
                       else
                          yyplot(1:ivecsiz,kk)=ww(ii)%ivec(1:ivecsiz,jj)
                       endif
                    endif
                 endif
              enddo

              if(kk.gt.0) then
                 call r8_grfmm1(xxplot,yyplot,imaxe,inumc,kk, &
                      zdum,kk,jself,kk, &
                      ' ',dunits,mnlab,kylab,fnlab)
              else
                 write(luntty,*) ' '
                 write(luntty,*) ' %ur_cstate_sdata: no data available.'
                 write(luntty,*) ' '
              endif

           enddo
           deallocate(xxplot,yyplot)
        endif

        deallocate(val_field)
        if(allocated(sum_table)) deallocate(sum_table)
        if(allocated(sum_key)) deallocate(sum_key)
        if(allocated(merge_names)) deallocate(merge_names)
        
        call free_wwnorm
     else
        call uermsg(' ?ur_cstate_sdata: unrecognized option.',' ',0)
     endif
  enddo

contains

  subroutine free_wwnorm
    if(allocated(wwnorm)) then
       do ii=1,nsss_cur
          call free_window(wwnorm(ii))
       enddo
       deallocate(wwnorm)
    endif
  end subroutine free_wwnorm

end subroutine ur_cstate_sdata

subroutine ps_sconfig_namelist_check(ss,iout,ierr)

  !------------------------------------------------------------
  ! (hand maintained) namelist input checks -- machine description namelist
  !------------------------------------------------------------

  use plasma_state_xpobj  ! XPLASMA2 state object definitions

  use plasma_state_definition_mod

  implicit NONE

  !-----------------------
  !  passed:

  type (plasma_state) :: ss       ! plasma state object
  integer, intent(in) :: iout     ! Fortran LUN for messages
  integer, intent(out) :: ierr    ! exit status code 0=OK

  !-----------------------

  call ps_sconfig_nphi_check(ss,iout,ierr)

end subroutine ps_sconfig_namelist_check

subroutine ps_sconfig_nphi_check(ss,iout,ierr)

  !------------------------------------------------------------
  ! (hand maintained) data checks: nphi, wt_nphi...
  !------------------------------------------------------------

  use plasma_state_xpobj  ! XPLASMA2 state object definitions

  use plasma_state_definition_mod

  implicit NONE

  !-----------------------
  !  passed:

  type (plasma_state) :: ss       ! plasma state object
  integer, intent(in) :: iout     ! Fortran LUN for messages
  integer, intent(out) :: ierr    ! exit status code 0=OK

  !-----------------------
  !  local:

  integer :: iant,i,inum,iwarn,iwarn2,iprev_nphi
  real*8 :: zwsum
  !-----------------------

  ierr = 0

  iwarn = 0
  iwarn2 = 0

  do iant = 1,ss%nicrf_src
     inum = ss%num_nphi(iant)

     zwsum = 0.0_rspec
     do i=1,inum
        if(ss%wt_nphi(i,iant).le.0.0_rspec) then
           if(iwarn.eq.0) then
              write(iout,*) &
                   ' ?ps_sconfig_nphi_check: invalid ICRF n_phi weight (.LE.0):'
           endif
           iwarn = iwarn + 1
           write(iout, &
                '(" antenna #",i3," n_phi #",i3,"   n_phi =",i4,"  wt = ",1pe12.5)') &
                iant, i, ss%nphi(i,iant), ss%wt_nphi(i,iant)
        else
           zwsum = zwsum + ss%wt_nphi(i,iant)
        endif
        
        if(i.eq.1) then
           iprev_nphi=ss%nphi(i,iant)-1
        else
           iprev_nphi=ss%nphi(i-1,iant)
        endif

        if(iprev_nphi.ge.ss%nphi(i,iant)) then
           if(iwarn2.eq.0) then
              write(iout,*) &
                   ' ?ps_sconfig_nphi_check: nphi values not in ascending order:'
           endif
           iwarn2 = iwarn2 + 1
           write(iout, &
                '(" antenna #",i3," n_phi values: ",2(1x,i4))') &
                iant,iprev_nphi,ss%nphi(i,iant)
        endif
     enddo
     if(zwsum.gt.0.0_rspec) then
        ss%wt_nphi(1:inum,iant) = ss%wt_nphi(1:inum,iant)/zwsum
     endif

     if(ierr.ne.0) return

  enddo

end subroutine ps_sconfig_nphi_check

program cstate

  ! compare plasma states
  ! all action in cstate_lib

  integer :: luntty

  call uinita(0)       ! UREAD init

  luntty = lnout(0)

  call initvis("CSTATE")

  call cstate_main(1)  ! acquire list of states; call code to read & compare...

  call uexita          ! UREAD exit
  stop

end program cstate

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


SUBROUTINE plasma_state_store_def_2(ss,icdf,iout,iertot)


  !  define subset of variables and arrays for NetCDF file

  USE plasma_state_definition_mod
  USE netcdf
  IMPLICIT NONE

  TYPE (plasma_state) :: ss     ! state data to read
  INTEGER, INTENT(IN) :: icdf   ! NetCDF file ID
  INTEGER, INTENT(IN) :: iout   ! message LUN
  INTEGER, INTENT(INOUT) :: iertot  ! error count

  !--------------

  INTEGER :: varid,dimid,status,ival,idims(20),indim
  CHARACTER*80 :: nc_errmsg

  !--------------
  !  define variables...


  IF(ALLOCATED(ss%D_einj_standard)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_n_d_einj_standard",idims(indim))
     CALL define_var("D_einj_standard","R",indim,idims, &
            "D beam table energies", &
            "keV","NBI","MACHINE_DESCRIPTION", &
            "R|units=keV D_einj_standard(n_D_einj_standard)")
  ENDIF

  IF(ALLOCATED(ss%D_ffull_standard)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_n_d_einj_standard",idims(indim))
     CALL define_var("D_ffull_standard","R",indim,idims, &
            "D beam full energy fractions", &
            "-","NBI","MACHINE_DESCRIPTION", &
            "R|units=- D_ffull_standard(n_D_einj_standard)")
  ENDIF

  IF(ALLOCATED(ss%D_fhalf_standard)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_n_d_einj_standard",idims(indim))
     CALL define_var("D_fhalf_standard","R",indim,idims, &
            "D beam half energy fractions", &
            "-","NBI","MACHINE_DESCRIPTION", &
            "R|units=- D_fhalf_standard(n_D_einj_standard)")
  ENDIF

  IF(ALLOCATED(ss%e0_av)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_ngsc0",idims(indim))
     CALL define_var("e0_av","R",indim,idims, &
            'average energy of neutral sources, "(3/2)*T0"', &
            "KeV","GAS","STATE_DATA", &
            "R|units=KeV   e0_av(ngsc0)")
  ENDIF

  IF(ALLOCATED(ss%ecrf_src_name)) THEN
     indim = 1
     status = nf90_inq_dimid(icdf,"ps_clen_32",idims(1))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_necrf_src",idims(indim))
     CALL define_var("ecrf_src_name","N",indim,idims, &
            "number & name of ECRF sources", &
            "__NONE","EC","MACHINE_DESCRIPTION", &
            "L|ecrf_source   ecrf_src_name(necrf_src)")
  ENDIF

  IF(ALLOCATED(ss%EC_Beam_Elongation)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_necrf_src",idims(indim))
     CALL define_var("EC_Beam_Elongation","R",indim,idims, &
            "EC beam ellipticity", &
            "-","EC","MACHINE_DESCRIPTION", &
            "R|units=-   EC_Beam_Elongation(necrf_src)")
  ENDIF

  indim = 1
  status = nf90_inq_dimid(icdf,"ps_clen_80",idims(1))
  CALL define_var("EC_Code_Info","C*80",indim,idims, &
         "Information: code implementing EC component", &
         "__NONE","EC","SIMULATION_INIT", &
         "C*80   EC_Code_Info")

  indim = 1
  status = nf90_inq_dimid(icdf,"ps_clen_80",idims(1))
  CALL define_var("EC_Data_Info","C*80",indim,idims, &
         "information on source of ECRF power data", &
         "__NONE","EC","SIMULATION_INIT", &
         "C*80   EC_Data_Info")

  IF(ALLOCATED(ss%EC_Half_Power_Angle)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_necrf_src",idims(indim))
     CALL define_var("EC_Half_Power_Angle","R",indim,idims, &
            "Divergence of EC beam", &
            "degrees","EC","MACHINE_DESCRIPTION", &
            "R|units=degrees  EC_Half_Power_Angle(necrf_src)")
  ENDIF

  IF(ALLOCATED(ss%EC_Omode_Fraction)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_necrf_src",idims(indim))
     CALL define_var("EC_Omode_Fraction","R",indim,idims, &
            "O-mode fraction of EC source", &
            "-","EC","SHOT_CONFIGURATION", &
            "R|units=-   EC_Omode_Fraction(necrf_src)")
  ENDIF

  IF(ALLOCATED(ss%EC_phi_aim)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_necrf_src",idims(indim))
     CALL define_var("EC_phi_aim","R",indim,idims, &
            "toroidal aiming angle", &
            "degrees","EC","SHOT_CONFIGURATION", &
            "R|units=degrees  EC_phi_aim(necrf_src)")
  ENDIF

  IF(ALLOCATED(ss%EC_PRINC_CURV_HOR)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_necrf_src",idims(indim))
     CALL define_var("EC_PRINC_CURV_HOR","R",indim,idims, &
            "principal curvature in horizontal direction", &
            "m","EC","MACHINE_DESCRIPTION", &
            "R|units=m  EC_PRINC_CURV_HOR(necrf_src)")
  ENDIF

  IF(ALLOCATED(ss%EC_PRINC_CURV_VERT)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_necrf_src",idims(indim))
     CALL define_var("EC_PRINC_CURV_VERT","R",indim,idims, &
            "principal curvature in vertical direction", &
            "m","EC","MACHINE_DESCRIPTION", &
            "R|units=m  EC_PRINC_CURV_VERT(necrf_src)")
  ENDIF

  IF(ALLOCATED(ss%EC_PRINC_WIDTH_HOR)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_necrf_src",idims(indim))
     CALL define_var("EC_PRINC_WIDTH_HOR","R",indim,idims, &
            "principal beam width in horizontal direction", &
            "m","EC","MACHINE_DESCRIPTION", &
            "R|units=m  EC_PRINC_WIDTH_HOR(necrf_src)")
  ENDIF

  IF(ALLOCATED(ss%EC_PRINC_WIDTH_VERT)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_necrf_src",idims(indim))
     CALL define_var("EC_PRINC_WIDTH_VERT","R",indim,idims, &
            "principal beam width in vertical direction", &
            "m","EC","MACHINE_DESCRIPTION", &
            "R|units=m  EC_PRINC_WIDTH_VERT(necrf_src)")
  ENDIF

  IF(ALLOCATED(ss%EC_theta_aim)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_necrf_src",idims(indim))
     CALL define_var("EC_theta_aim","R",indim,idims, &
            "poloidal aiming angle", &
            "degrees","EC","SHOT_CONFIGURATION", &
            "R|units=degrees  EC_theta_aim(necrf_src)")
  ENDIF

  IF(ALLOCATED(ss%ee_mobility_factor)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     CALL define_var("ee_mobility_factor","R",indim,idims, &
            "chi_e/chi_i", &
            "-","ANOM","STATE_PROFILES", &
            "R|units=-|Hermite  ee_mobility_factor(nrho_anomth)")
  ENDIF

  IF(ALLOCATED(ss%Einj_max)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nbeam",idims(indim))
     CALL define_var("Einj_max","R",indim,idims, &
            "maximum injection energy", &
            "keV","NBI","MACHINE_DESCRIPTION", &
            "R|units=keV       Einj_max(nbeam)")
  ENDIF

  IF(ALLOCATED(ss%Einj_min)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nbeam",idims(indim))
     CALL define_var("Einj_min","R",indim,idims, &
            "minimum injection energy", &
            "keV","NBI","MACHINE_DESCRIPTION", &
            "R|units=keV       Einj_min(nbeam)")
  ENDIF

  indim = 0
  CALL define_var("eldot","R",indim,idims, &
         "[d(Philim)/dt]/[2*Philim]", &
         "1/sec","PLASMA","STATE_DATA", &
         "R|units=1/sec  eldot")

  IF(ALLOCATED(ss%elong)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_eq_geo",idims(indim))
     CALL define_var("elong","R",indim,idims, &
            "elongation (b/a)", &
            "-","EQ","STATE_PROFILES", &
            "R|pclin  elong(nrho_eq_geo)")
  ENDIF

  IF(ALLOCATED(ss%eperp_beami)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_nbi",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nspec_beam",idims(indim))
     CALL define_var("eperp_beami","R",indim,idims, &
            "beam species <Eperp>, lab frame", &
            "keV","NBI","STATE_PROFILES", &
            "R|units=keV|alias=eperp_|step*nbeami eperp_beami(~nrho_nbi,nspec_beam)")
  ENDIF

  IF(ALLOCATED(ss%eperp_fusi)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_fus",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nspec_fusion",idims(indim))
     CALL define_var("eperp_fusi","R",indim,idims, &
            "fusion ion <Eperp>, lab frame", &
            "keV","FUS","STATE_PROFILES", &
            "R|units=keV|alias=eperp_|step*nfusi eperp_fusi(~nrho_fus,nspec_fusion)")
  ENDIF

  IF(ALLOCATED(ss%eperp_mini)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_icrf",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nspec_rfmin",idims(indim))
     CALL define_var("eperp_mini","R",indim,idims, &
            "minority species <Eperp>, lab frame", &
            "keV","IC","STATE_PROFILES", &
            "R|units=keV|alias=eperp_|step*nmini eperp_mini(~nrho_icrf,nspec_rfmin)")
  ENDIF

  IF(ALLOCATED(ss%eperp_rw)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_rw",idims(indim))
     CALL define_var("eperp_rw","R",indim,idims, &
            "runaway electron <Eperp>", &
            "keV","RUNAWAY","STATE_PROFILES", &
            "R|units=keV|step*nrw  eperp_rw(~nrho_rw)")
  ENDIF

  IF(ALLOCATED(ss%epll_beami)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_nbi",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nspec_beam",idims(indim))
     CALL define_var("epll_beami","R",indim,idims, &
            "beam species <Epll>, lab frame", &
            "keV","NBI","STATE_PROFILES", &
            "R|units=keV|alias=epll_|step*nbeami  epll_beami(~nrho_nbi,nspec_beam)")
  ENDIF

  IF(ALLOCATED(ss%epll_fusi)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_fus",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nspec_fusion",idims(indim))
     CALL define_var("epll_fusi","R",indim,idims, &
            "fusion ion <Epll>, lab frame", &
            "keV","FUS","STATE_PROFILES", &
            "R|units=keV|alias=epll_|step*nfusi  epll_fusi(~nrho_fus,nspec_fusion)")
  ENDIF

  IF(ALLOCATED(ss%epll_mini)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_icrf",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nspec_rfmin",idims(indim))
     CALL define_var("epll_mini","R",indim,idims, &
            "minority species <Epll>, lab frame", &
            "keV","IC","STATE_PROFILES", &
            "R|units=keV|alias=epll_|step*nmini  epll_mini(~nrho_icrf,nspec_rfmin)")
  ENDIF

  IF(ALLOCATED(ss%epll_rw)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_rw",idims(indim))
     CALL define_var("epll_rw","R",indim,idims, &
            "runaway electron <Epll>", &
            "keV","RUNAWAY","STATE_PROFILES", &
            "R|units=keV|step*nrw  epll_rw(~nrho_rw)")
  ENDIF

  IF(ALLOCATED(ss%Epot)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho",idims(indim))
     CALL define_var("Epot","R",indim,idims, &
            "radial electrostatic potential", &
            "keV","PLASMA","STATE_PROFILES", &
            "R|units=keV|pclin  Epot(nrho)")
  ENDIF

  indim = 1
  status = nf90_inq_dimid(icdf,"ps_clen_256",idims(1))
  CALL define_var("eqdsk_file","F",indim,idims, &
         "EFIT G-eqdsk file: psi(R,Z), g(psi), etc.", &
         "__NONE","EQ","STATE_DATA", &
         "F  eqdsk_file")

  IF(ALLOCATED(ss%eqmom_num)) THEN
     indim = 1
     status = nf90_inq_dimid(icdf,"ps_clen_32",idims(1))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_neqmom",idims(indim))
     CALL define_var("eqmom_num","N",indim,idims, &
            "Equilibrium moments", &
            "__NONE","EQ","SIMULATION_INIT", &
            "L|EQ_moments  eqmom_num(neqmom)")
  ENDIF

  indim = 1
  status = nf90_inq_dimid(icdf,"ps_clen_80",idims(1))
  CALL define_var("EQ_Code_Info","C*80",indim,idims, &
         "Information: code implementing EQ component", &
         "__NONE","EQ","SIMULATION_INIT", &
         "C*80   EQ_Code_Info")

  indim = 1
  status = nf90_inq_dimid(icdf,"ps_clen_80",idims(1))
  CALL define_var("EQ_Data_Info","C*80",indim,idims, &
         "Information: source of EQ input data", &
         "__NONE","EQ","SIMULATION_INIT", &
         "C*80   EQ_Data_Info")

  IF(ALLOCATED(ss%eta_parallel)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho",idims(indim))
     CALL define_var("eta_parallel","R",indim,idims, &
            "parallel electrical resistivity", &
            "ohm*m","PLASMA","STATE_PROFILES", &
            "R|units=ohm*m|Hermite eta_parallel(nrho)")
  ENDIF

  IF(ALLOCATED(ss%E_anom)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nefi_anom",idims(indim))
     CALL define_var("E_anom","R",indim,idims, &
            "(optional) energy grid (1d profiles)", &
            "keV","ANOM","SIMULATION_INIT", &
            "G  E_anom(nefi_anom)")
  ENDIF

  IF(ALLOCATED(ss%E_anom2)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nefi_anom2",idims(indim))
     CALL define_var("E_anom2","R",indim,idims, &
            "energy grid (2d anomalous transport profiles)", &
            "keV","ANOM","SIMULATION_INIT", &
            "G  E_anom2(nefi_anom2)")
  ENDIF

  IF(ALLOCATED(ss%fidiff_bpass_co)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nefi_anom2",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anom2",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nspec_fusion",idims(indim))
     CALL define_var("fidiff_bpass_co","R",indim,idims, &
            "fusion ion diffusivity: co barely passing orbits", &
            "m^2/sec","ANOM","STATE_PROFILES", &
            "R|units=m^2/sec|pclin  fidiff_bpass_co(nefi_anom2,nrho_anom2,nspec_fusion)")
  ENDIF

  IF(ALLOCATED(ss%fidiff_bpass_ctr)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nefi_anom2",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anom2",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nspec_fusion",idims(indim))
     CALL define_var("fidiff_bpass_ctr","R",indim,idims, &
            "fusion ion diffusivity: ctr barely passing orbits", &
            "m^2/sec","ANOM","STATE_PROFILES", &
            "R|units=m^2/sec|pclin  fidiff_bpass_ctr(nefi_anom2,nrho_anom2,nspec_fusion)")
  ENDIF

  IF(ALLOCATED(ss%fidiff_btrap)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nefi_anom2",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anom2",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nspec_fusion",idims(indim))
     CALL define_var("fidiff_btrap","R",indim,idims, &
            "fusion ion diffusivity: barely trapped orbits", &
            "m^2/sec","ANOM","STATE_PROFILES", &
            "R|units=m^2/sec|pclin  fidiff_btrap(nefi_anom2,nrho_anom2,nspec_fusion)")
  ENDIF

  IF(ALLOCATED(ss%fidiff_dpass_co)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nefi_anom2",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anom2",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nspec_fusion",idims(indim))
     CALL define_var("fidiff_dpass_co","R",indim,idims, &
            "fusion ion diffusivity: co passing |vpll/v| -> 1", &
            "m^2/sec","ANOM","STATE_PROFILES", &
            "R|units=m^2/sec|pclin  fidiff_dpass_co(nefi_anom2,nrho_anom2,nspec_fusion)")
  ENDIF

  IF(ALLOCATED(ss%fidiff_dpass_ctr)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nefi_anom2",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anom2",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nspec_fusion",idims(indim))
     CALL define_var("fidiff_dpass_ctr","R",indim,idims, &
            "fusion ion diffusivity: ctr passing |vpll/v| -> 1", &
            "m^2/sec","ANOM","STATE_PROFILES", &
            "R|units=m^2/sec|pclin  fidiff_dpass_ctr(nefi_anom2,nrho_anom2,nspec_fusion)")
  ENDIF

  IF(ALLOCATED(ss%fidiff_dtrap)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nefi_anom2",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anom2",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nspec_fusion",idims(indim))
     CALL define_var("fidiff_dtrap","R",indim,idims, &
            "fusion ion diffusivity: deeply trapped orbits", &
            "m^2/sec","ANOM","STATE_PROFILES", &
            "R|units=m^2/sec|pclin  fidiff_dtrap(nefi_anom2,nrho_anom2,nspec_fusion)")
  ENDIF

  IF(ALLOCATED(ss%Fi_depletion)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho",idims(indim))
     CALL define_var("Fi_depletion","R",indim,idims, &
            "fast ion depletion: sum[nj*Zj/ne]", &
            "-","PLASMA","STATE_PROFILES", &
            "R|units=-|step*ns(:,ps_elec_index) Fi_depletion(~nrho)")
  ENDIF

  IF(ALLOCATED(ss%fracmin)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nspec_rfmin",idims(indim))
     CALL define_var("fracmin","R",indim,idims, &
            'minority density fraction if kdens_rfmin="fraction"', &
            "-","IC","SIMULATION_INIT", &
            "R|units=- fracmin(nspec_rfmin)")
  ENDIF

  IF(ALLOCATED(ss%fracpslh)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_max_nspectrumlh_src",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nlhrf_src",idims(indim))
     CALL define_var("fracpslh","R",indim,idims, &
            "fraction of power on each peak (the sum over all peaks must be 1)", &
            "-","LH","SHOT_CONFIGURATION", &
            "R|units=- fracpslh(nspectrumlh_src(),nlhrf_src)")
  ENDIF

  IF(ALLOCATED(ss%frac_full)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nbeam",idims(indim))
     CALL define_var("frac_full","R",indim,idims, &
            "fraction of beam current at full voltage", &
            "-","NBI","STATE_DATA", &
            "R|units=-  frac_full(nbeam)")
  ENDIF

  IF(ALLOCATED(ss%frac_half)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nbeam",idims(indim))
     CALL define_var("frac_half","R",indim,idims, &
            "fraction of beam current at half voltage", &
            "-","NBI","STATE_DATA", &
            "R|units=-  frac_half(nbeam)")
  ENDIF

  IF(ALLOCATED(ss%freq_drbm)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     CALL define_var("freq_drbm","R",indim,idims, &
            "frequency from DRBM model", &
            "GB","ANOM","STATE_PROFILES", &
            "R|units=GB|pclin freq_drbm(nrho_anomth)")
  ENDIF

  IF(ALLOCATED(ss%freq_ec)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_necrf_src",idims(indim))
     CALL define_var("freq_ec","R",indim,idims, &
            "frequency of EC source", &
            "Hz","EC","SHOT_CONFIGURATION", &
            "R|units=Hz freq_ec(necrf_src)")
  ENDIF

  IF(ALLOCATED(ss%freq_glf)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     CALL define_var("freq_glf","R",indim,idims, &
            "frequency from GLF23 model", &
            "GB","ANOM","STATE_PROFILES", &
            "R|units=GB|pclin freq_glf(nrho_anomth)")
  ENDIF

  IF(ALLOCATED(ss%freq_ic)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nicrf_src",idims(indim))
     CALL define_var("freq_ic","R",indim,idims, &
            "frequency on each ICRF source", &
            "Hz","IC","SHOT_CONFIGURATION", &
            "R|units=Hz freq_ic(nicrf_src)")
  ENDIF

  IF(ALLOCATED(ss%freq_lh)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nlhrf_src",idims(indim))
     CALL define_var("freq_lh","R",indim,idims, &
            "frequency on each LHRF source", &
            "Hz","LH","SHOT_CONFIGURATION", &
            "R|units=Hz freq_lh(nlhrf_src)")
  ENDIF

  IF(ALLOCATED(ss%freq_max_tglf)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     CALL define_var("freq_max_tglf","R",indim,idims, &
            "frequency corresponding maximum growthrate from TGLF model", &
            "GB","ANOM","STATE_PROFILES", &
            "R|units=GB|pclin freq_max_tglf(nrho_anomth)")
  ENDIF

  IF(ALLOCATED(ss%freq_mmm71)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nky_mmm",idims(indim))
     CALL define_var("freq_mmm71","R",indim,idims, &
            "frequency from mmm71 model", &
            "GB","ANOM","STATE_PROFILES", &
            "R|units=GB|pclin freq_mmm71(nrho_anomth,nky_mmm)")
  ENDIF

  IF(ALLOCATED(ss%freq_mtm)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     CALL define_var("freq_mtm","R",indim,idims, &
            "frequency from MTM model", &
            "rad/sec","ANOM","STATE_PROFILES", &
            "R|units=rad/sec|pclin freq_mtm(nrho_anomth)")
  ENDIF

  IF(ALLOCATED(ss%freq_tglf)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nky_anomth",idims(indim))
     CALL define_var("freq_tglf","R",indim,idims, &
            "frequency from TGLF model", &
            "GB","ANOM","STATE_PROFILES", &
            "R|units=GB|pclin freq_tglf(nrho_anomth,nky_anomth)")
  ENDIF

  indim = 1
  status = nf90_inq_dimid(icdf,"ps_clen_80",idims(1))
  CALL define_var("FUS_Code_Info","C*80",indim,idims, &
         "Information: code implementing FUS component", &
         "__NONE","FUS","SIMULATION_INIT", &
         "C*80   FUS_Code_Info")

  IF(ALLOCATED(ss%gamma_lmhd)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_mmodes",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_ndelta_w",idims(indim))
     CALL define_var("gamma_lmhd","R",indim,idims, &
            "ideal growth rate", &
            "-","LMHD","STATE_DATA", &
            "R|units=-  gamma_lmhd(mmodes,ndelta_W)")
  ENDIF

  IF(ALLOCATED(ss%gamma_nc)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_eq_geo",idims(indim))
     CALL define_var("gamma_nc","R",indim,idims, &
            "NC gamma", &
            "m^-1","EQ","STATE_PROFILES", &
            "R|units=m^-1|pclin   gamma_nc(nrho_eq_geo)")
  ENDIF

  IF(ALLOCATED(ss%gas_atom)) THEN
     indim = 1
     status = nf90_inq_dimid(icdf,"ps_clen_32",idims(1))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_ngsc0",idims(indim))
     CALL define_var("gas_atom","N",indim,idims, &
            "name of species introduced by each gas source", &
            "__NONE","GAS","SHOT_CONFIGURATION", &
            "N  gas_atom(ngsc0)")
  ENDIF

  indim = 1
  status = nf90_inq_dimid(icdf,"ps_clen_80",idims(1))
  CALL define_var("GAS_Code_Info","C*80",indim,idims, &
         "Information: code implementing GAS component", &
         "__NONE","GAS","SIMULATION_INIT", &
         "C*80   GAS_Code_Info")

  IF(ALLOCATED(ss%gb1)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_eq_geo",idims(indim))
     CALL define_var("gb1","R",indim,idims, &
            "<|B|>", &
            "T","EQ","STATE_PROFILES", &
            "R|units=T|pclin      gb1(nrho_eq_geo)")
  ENDIF

  IF(ALLOCATED(ss%gb2)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_eq_geo",idims(indim))
     CALL define_var("gb2","R",indim,idims, &
            "<B^2>", &
            "T^2","EQ","STATE_PROFILES", &
            "R|units=T^2|pclin    gb2(nrho_eq_geo)")
  ENDIF

  IF(ALLOCATED(ss%gb2i)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_eq_geo",idims(indim))
     CALL define_var("gb2i","R",indim,idims, &
            "<1/B^2>", &
            "T^-2","EQ","STATE_PROFILES", &
            "R|units=T^-2|pclin   gb2i(nrho_eq_geo)")
  ENDIF

  IF(ALLOCATED(ss%gbr2)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_eq_geo",idims(indim))
     CALL define_var("gbr2","R",indim,idims, &
            "<|B|*R^2>", &
            "T*m^2","EQ","STATE_PROFILES", &
            "R|units=T*m^2|pclin  gbr2(nrho_eq_geo)")
  ENDIF

  indim = 1
  status = nf90_inq_dimid(icdf,"ps_clen_256",idims(1))
  CALL define_var("geometry","F",indim,idims, &
         "path to file(s) vac. vessel & coil descr.", &
         "__NONE","EQ","MACHINE_DESCRIPTION", &
         "F  geometry")

  indim = 1
  status = nf90_inq_dimid(icdf,"ps_clen_80",idims(1))
  CALL define_var("Global_label","C*80",indim,idims, &
         "Run Label", &
         "__NONE","PLASMA","SIMULATION_INIT", &
         "C*80   Global_label")

  IF(ALLOCATED(ss%gncfb2h)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_eq_geo",idims(indim))
     CALL define_var("gncfb2h","R",indim,idims, &
            "<(B^-2)*((1-H)^0.5-(1/3)*(1-H)^1.5)>; H=B/Bmax", &
            "T^-2","EQ","STATE_PROFILES", &
            "R|units=T^-2|pclin  gncfb2h(nrho_eq_geo)")
  ENDIF

  IF(ALLOCATED(ss%gncfh)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_eq_geo",idims(indim))
     CALL define_var("gncfh","R",indim,idims, &
            "<H^-2*(1-SQRT(1-H)*(1+H/2))>; H=B/Bmax", &
            "-","EQ","STATE_PROFILES", &
            "R|units=-|pclin  gncfh(nrho_eq_geo)")
  ENDIF

  IF(ALLOCATED(ss%gr1)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_eq_geo",idims(indim))
     CALL define_var("gr1","R",indim,idims, &
            "<R>", &
            "m","EQ","STATE_PROFILES", &
            "R|units=m|pclin   gr1(nrho_eq_geo)")
  ENDIF

  IF(ALLOCATED(ss%gr2)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_eq_geo",idims(indim))
     CALL define_var("gr2","R",indim,idims, &
            "<R^2>", &
            "m^2","EQ","STATE_PROFILES", &
            "R|units=m^2|pclin gr2(nrho_eq_geo)")
  ENDIF

  IF(ALLOCATED(ss%gr2i)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_eq_geo",idims(indim))
     CALL define_var("gr2i","R",indim,idims, &
            "<R^-2>", &
            "m^-2","EQ","STATE_PROFILES", &
            "R|units=m^-2|pclin gr2i(nrho_eq_geo)")
  ENDIF

  IF(ALLOCATED(ss%gr2rho2)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_eq_geo",idims(indim))
     CALL define_var("gr2rho2","R",indim,idims, &
            "<R^2*|grad(rho)|^2>", &
            "-","EQ","STATE_PROFILES", &
            "R|units=-|pclin gr2rho2(nrho_eq_geo)")
  ENDIF

  IF(ALLOCATED(ss%gr3i)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_eq_geo",idims(indim))
     CALL define_var("gr3i","R",indim,idims, &
            "<R^-3>", &
            "m^-3","EQ","STATE_PROFILES", &
            "R|units=m^-3|pclin gr3i(nrho_eq_geo)")
  ENDIF

  IF(ALLOCATED(ss%grho1)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_eq_geo",idims(indim))
     CALL define_var("grho1","R",indim,idims, &
            "<|grad(rho)|>", &
            "m^-1","EQ","STATE_PROFILES", &
            "R|units=m^-1|pclin grho1(nrho_eq_geo)")
  ENDIF

  IF(ALLOCATED(ss%grho2)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_eq_geo",idims(indim))
     CALL define_var("grho2","R",indim,idims, &
            "<|grad(rho)|^2>", &
            "m^-2","EQ","STATE_PROFILES", &
            "R|units=m^-2|pclin grho2(nrho_eq_geo)")
  ENDIF

  CONTAINS


     SUBROUTINE define_var(name,dtype,indim,idims, &
          long_name,units,component,section,spec)

        CHARACTER*(*), INTENT(in) :: name
        CHARACTER*(*), INTENT(in) :: dtype
        INTEGER, INTENT(in) :: indim
        INTEGER, dimension(:), INTENT(in) :: idims
        CHARACTER*(*), INTENT(in) :: long_name
        CHARACTER*(*), INTENT(in) :: units
        CHARACTER*(*), INTENT(in) :: component
        CHARACTER*(*), INTENT(in) :: section
        CHARACTER*(*), INTENT(in) :: spec

        integer :: itype

        IF(dtype.EQ.'R') THEN
           itype = NF90_DOUBLE

        ELSE IF (dtype.EQ.'I') THEN
           itype = NF90_INT

        ELSE
           itype = NF90_CHAR

        ENDIF

        IF(indim.EQ.0) THEN
           status=nf90_def_var(icdf,name,itype, varid=varid)

        ELSE
           status=nf90_def_var(icdf,name,itype, dimids=idims(1:indim),varid=varid)

        ENDIF

        IF(status.NE.NF90_NOERR) THEN
           WRITE(iout,*) " ?plasma_state_store: error defining variable: "//trim(name)
           CALL ncerr(status)
           iertot = iertot + 1
           RETURN
        ENDIF

        ! Variable OK, now add attributes:

        CALL add_attrib("long_name",long_name)
        IF(dtype.EQ.'R') CALL add_attrib("units",units)
        CALL add_attrib("component",component)
        CALL add_attrib("section",section)
        CALL add_attrib("specification",spec)

     END SUBROUTINE define_var

     SUBROUTINE add_attrib(name,value)
        CHARACTER*(*), intent(in) :: name
        CHARACTER*(*), intent(in) :: value

        status=nf90_put_att(icdf,varid,name,value)
        IF(status.NE.NF90_NOERR) THEN
           WRITE(iout,*) " ?plasma_state_store: error defining attribute: "//trim(name)//' = '//trim(value)
           CALL ncerr(status)
           iertot = iertot + 1
        ENDIF
     END SUBROUTINE add_attrib

     SUBROUTINE ncerr(status)
        INTEGER, INTENT(in) :: status

        nc_errmsg = NF90_strerror(status)
        write(iout,*) '  NetCDF message: ',trim(nc_errmsg)
     END SUBROUTINE ncerr

END SUBROUTINE plasma_state_store_def_2


SUBROUTINE plasma_state_store_2(ss,icdf,iout,iertot)


  !  write subset of variables and arrays from NetCDF file

  USE plasma_state_definition_mod
  USE netcdf
  IMPLICIT NONE

  TYPE (plasma_state) :: ss     ! state data to read
  INTEGER, INTENT(IN) :: icdf   ! NetCDF file ID
  INTEGER, INTENT(IN) :: iout   ! message LUN
  INTEGER, INTENT(INOUT) :: iertot  ! error count

  !--------------

  INTEGER :: varid,dimid,status,ival,idims(20),indim
  CHARACTER*80 :: nc_errmsg

  !--------------
  !  write variables...


  IF(ALLOCATED(ss%D_einj_standard)) THEN
     status = nf90_inq_varid(icdf,"D_einj_standard",varid)
     status = nf90_put_var(icdf,varid,ss%D_einj_standard)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: D_einj_standard"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%D_ffull_standard)) THEN
     status = nf90_inq_varid(icdf,"D_ffull_standard",varid)
     status = nf90_put_var(icdf,varid,ss%D_ffull_standard)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: D_ffull_standard"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%D_fhalf_standard)) THEN
     status = nf90_inq_varid(icdf,"D_fhalf_standard",varid)
     status = nf90_put_var(icdf,varid,ss%D_fhalf_standard)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: D_fhalf_standard"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%e0_av)) THEN
     status = nf90_inq_varid(icdf,"e0_av",varid)
     status = nf90_put_var(icdf,varid,ss%e0_av)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: e0_av"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%ecrf_src_name)) THEN
     status = nf90_inq_varid(icdf,"ecrf_src_name",varid)
     status = nf90_put_var(icdf,varid,ss%ecrf_src_name)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: ecrf_src_name"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%EC_Beam_Elongation)) THEN
     status = nf90_inq_varid(icdf,"EC_Beam_Elongation",varid)
     status = nf90_put_var(icdf,varid,ss%EC_Beam_Elongation)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: EC_Beam_Elongation"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"EC_Code_Info",varid)
  status = nf90_put_var(icdf,varid,ss%EC_Code_Info)
  IF(status.NE.NF90_NOERR) THEN
     WRITE(iout,*) " ?plasma_state_store: error storing: EC_Code_Info"
     CALL ncerr(status)
     iertot = iertot + 1
  ENDIF

  status = nf90_inq_varid(icdf,"EC_Data_Info",varid)
  status = nf90_put_var(icdf,varid,ss%EC_Data_Info)
  IF(status.NE.NF90_NOERR) THEN
     WRITE(iout,*) " ?plasma_state_store: error storing: EC_Data_Info"
     CALL ncerr(status)
     iertot = iertot + 1
  ENDIF

  IF(ALLOCATED(ss%EC_Half_Power_Angle)) THEN
     status = nf90_inq_varid(icdf,"EC_Half_Power_Angle",varid)
     status = nf90_put_var(icdf,varid,ss%EC_Half_Power_Angle)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: EC_Half_Power_Angle"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%EC_Omode_Fraction)) THEN
     status = nf90_inq_varid(icdf,"EC_Omode_Fraction",varid)
     status = nf90_put_var(icdf,varid,ss%EC_Omode_Fraction)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: EC_Omode_Fraction"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%EC_phi_aim)) THEN
     status = nf90_inq_varid(icdf,"EC_phi_aim",varid)
     status = nf90_put_var(icdf,varid,ss%EC_phi_aim)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: EC_phi_aim"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%EC_PRINC_CURV_HOR)) THEN
     status = nf90_inq_varid(icdf,"EC_PRINC_CURV_HOR",varid)
     status = nf90_put_var(icdf,varid,ss%EC_PRINC_CURV_HOR)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: EC_PRINC_CURV_HOR"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%EC_PRINC_CURV_VERT)) THEN
     status = nf90_inq_varid(icdf,"EC_PRINC_CURV_VERT",varid)
     status = nf90_put_var(icdf,varid,ss%EC_PRINC_CURV_VERT)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: EC_PRINC_CURV_VERT"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%EC_PRINC_WIDTH_HOR)) THEN
     status = nf90_inq_varid(icdf,"EC_PRINC_WIDTH_HOR",varid)
     status = nf90_put_var(icdf,varid,ss%EC_PRINC_WIDTH_HOR)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: EC_PRINC_WIDTH_HOR"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%EC_PRINC_WIDTH_VERT)) THEN
     status = nf90_inq_varid(icdf,"EC_PRINC_WIDTH_VERT",varid)
     status = nf90_put_var(icdf,varid,ss%EC_PRINC_WIDTH_VERT)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: EC_PRINC_WIDTH_VERT"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%EC_theta_aim)) THEN
     status = nf90_inq_varid(icdf,"EC_theta_aim",varid)
     status = nf90_put_var(icdf,varid,ss%EC_theta_aim)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: EC_theta_aim"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%ee_mobility_factor)) THEN
     status = nf90_inq_varid(icdf,"ee_mobility_factor",varid)
     status = nf90_put_var(icdf,varid,ss%ee_mobility_factor)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: ee_mobility_factor"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%Einj_max)) THEN
     status = nf90_inq_varid(icdf,"Einj_max",varid)
     status = nf90_put_var(icdf,varid,ss%Einj_max)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: Einj_max"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%Einj_min)) THEN
     status = nf90_inq_varid(icdf,"Einj_min",varid)
     status = nf90_put_var(icdf,varid,ss%Einj_min)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: Einj_min"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"eldot",varid)
  status = nf90_put_var(icdf,varid,ss%eldot)
  IF(status.NE.NF90_NOERR) THEN
     WRITE(iout,*) " ?plasma_state_store: error storing: eldot"
     CALL ncerr(status)
     iertot = iertot + 1
  ENDIF

  IF(ALLOCATED(ss%elong)) THEN
     status = nf90_inq_varid(icdf,"elong",varid)
     status = nf90_put_var(icdf,varid,ss%elong)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: elong"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%eperp_beami)) THEN
     status = nf90_inq_varid(icdf,"eperp_beami",varid)
     status = nf90_put_var(icdf,varid,ss%eperp_beami)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: eperp_beami"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%eperp_fusi)) THEN
     status = nf90_inq_varid(icdf,"eperp_fusi",varid)
     status = nf90_put_var(icdf,varid,ss%eperp_fusi)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: eperp_fusi"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%eperp_mini)) THEN
     status = nf90_inq_varid(icdf,"eperp_mini",varid)
     status = nf90_put_var(icdf,varid,ss%eperp_mini)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: eperp_mini"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%eperp_rw)) THEN
     status = nf90_inq_varid(icdf,"eperp_rw",varid)
     status = nf90_put_var(icdf,varid,ss%eperp_rw)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: eperp_rw"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%epll_beami)) THEN
     status = nf90_inq_varid(icdf,"epll_beami",varid)
     status = nf90_put_var(icdf,varid,ss%epll_beami)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: epll_beami"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%epll_fusi)) THEN
     status = nf90_inq_varid(icdf,"epll_fusi",varid)
     status = nf90_put_var(icdf,varid,ss%epll_fusi)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: epll_fusi"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%epll_mini)) THEN
     status = nf90_inq_varid(icdf,"epll_mini",varid)
     status = nf90_put_var(icdf,varid,ss%epll_mini)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: epll_mini"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%epll_rw)) THEN
     status = nf90_inq_varid(icdf,"epll_rw",varid)
     status = nf90_put_var(icdf,varid,ss%epll_rw)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: epll_rw"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%Epot)) THEN
     status = nf90_inq_varid(icdf,"Epot",varid)
     status = nf90_put_var(icdf,varid,ss%Epot)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: Epot"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"eqdsk_file",varid)
  status = nf90_put_var(icdf,varid,ss%eqdsk_file)
  IF(status.NE.NF90_NOERR) THEN
     WRITE(iout,*) " ?plasma_state_store: error storing: eqdsk_file"
     CALL ncerr(status)
     iertot = iertot + 1
  ENDIF

  IF(ALLOCATED(ss%eqmom_num)) THEN
     status = nf90_inq_varid(icdf,"eqmom_num",varid)
     status = nf90_put_var(icdf,varid,ss%eqmom_num)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: eqmom_num"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"EQ_Code_Info",varid)
  status = nf90_put_var(icdf,varid,ss%EQ_Code_Info)
  IF(status.NE.NF90_NOERR) THEN
     WRITE(iout,*) " ?plasma_state_store: error storing: EQ_Code_Info"
     CALL ncerr(status)
     iertot = iertot + 1
  ENDIF

  status = nf90_inq_varid(icdf,"EQ_Data_Info",varid)
  status = nf90_put_var(icdf,varid,ss%EQ_Data_Info)
  IF(status.NE.NF90_NOERR) THEN
     WRITE(iout,*) " ?plasma_state_store: error storing: EQ_Data_Info"
     CALL ncerr(status)
     iertot = iertot + 1
  ENDIF

  IF(ALLOCATED(ss%eta_parallel)) THEN
     status = nf90_inq_varid(icdf,"eta_parallel",varid)
     status = nf90_put_var(icdf,varid,ss%eta_parallel)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: eta_parallel"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%E_anom)) THEN
     status = nf90_inq_varid(icdf,"E_anom",varid)
     status = nf90_put_var(icdf,varid,ss%E_anom)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: E_anom"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%E_anom2)) THEN
     status = nf90_inq_varid(icdf,"E_anom2",varid)
     status = nf90_put_var(icdf,varid,ss%E_anom2)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: E_anom2"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%fidiff_bpass_co)) THEN
     status = nf90_inq_varid(icdf,"fidiff_bpass_co",varid)
     status = nf90_put_var(icdf,varid,ss%fidiff_bpass_co)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: fidiff_bpass_co"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%fidiff_bpass_ctr)) THEN
     status = nf90_inq_varid(icdf,"fidiff_bpass_ctr",varid)
     status = nf90_put_var(icdf,varid,ss%fidiff_bpass_ctr)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: fidiff_bpass_ctr"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%fidiff_btrap)) THEN
     status = nf90_inq_varid(icdf,"fidiff_btrap",varid)
     status = nf90_put_var(icdf,varid,ss%fidiff_btrap)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: fidiff_btrap"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%fidiff_dpass_co)) THEN
     status = nf90_inq_varid(icdf,"fidiff_dpass_co",varid)
     status = nf90_put_var(icdf,varid,ss%fidiff_dpass_co)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: fidiff_dpass_co"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%fidiff_dpass_ctr)) THEN
     status = nf90_inq_varid(icdf,"fidiff_dpass_ctr",varid)
     status = nf90_put_var(icdf,varid,ss%fidiff_dpass_ctr)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: fidiff_dpass_ctr"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%fidiff_dtrap)) THEN
     status = nf90_inq_varid(icdf,"fidiff_dtrap",varid)
     status = nf90_put_var(icdf,varid,ss%fidiff_dtrap)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: fidiff_dtrap"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%Fi_depletion)) THEN
     status = nf90_inq_varid(icdf,"Fi_depletion",varid)
     status = nf90_put_var(icdf,varid,ss%Fi_depletion)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: Fi_depletion"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%fracmin)) THEN
     status = nf90_inq_varid(icdf,"fracmin",varid)
     status = nf90_put_var(icdf,varid,ss%fracmin)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: fracmin"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%fracpslh)) THEN
     status = nf90_inq_varid(icdf,"fracpslh",varid)
     status = nf90_put_var(icdf,varid,ss%fracpslh)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: fracpslh"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%frac_full)) THEN
     status = nf90_inq_varid(icdf,"frac_full",varid)
     status = nf90_put_var(icdf,varid,ss%frac_full)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: frac_full"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%frac_half)) THEN
     status = nf90_inq_varid(icdf,"frac_half",varid)
     status = nf90_put_var(icdf,varid,ss%frac_half)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: frac_half"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%freq_drbm)) THEN
     status = nf90_inq_varid(icdf,"freq_drbm",varid)
     status = nf90_put_var(icdf,varid,ss%freq_drbm)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: freq_drbm"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%freq_ec)) THEN
     status = nf90_inq_varid(icdf,"freq_ec",varid)
     status = nf90_put_var(icdf,varid,ss%freq_ec)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: freq_ec"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%freq_glf)) THEN
     status = nf90_inq_varid(icdf,"freq_glf",varid)
     status = nf90_put_var(icdf,varid,ss%freq_glf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: freq_glf"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%freq_ic)) THEN
     status = nf90_inq_varid(icdf,"freq_ic",varid)
     status = nf90_put_var(icdf,varid,ss%freq_ic)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: freq_ic"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%freq_lh)) THEN
     status = nf90_inq_varid(icdf,"freq_lh",varid)
     status = nf90_put_var(icdf,varid,ss%freq_lh)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: freq_lh"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%freq_max_tglf)) THEN
     status = nf90_inq_varid(icdf,"freq_max_tglf",varid)
     status = nf90_put_var(icdf,varid,ss%freq_max_tglf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: freq_max_tglf"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%freq_mmm71)) THEN
     status = nf90_inq_varid(icdf,"freq_mmm71",varid)
     status = nf90_put_var(icdf,varid,ss%freq_mmm71)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: freq_mmm71"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%freq_mtm)) THEN
     status = nf90_inq_varid(icdf,"freq_mtm",varid)
     status = nf90_put_var(icdf,varid,ss%freq_mtm)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: freq_mtm"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%freq_tglf)) THEN
     status = nf90_inq_varid(icdf,"freq_tglf",varid)
     status = nf90_put_var(icdf,varid,ss%freq_tglf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: freq_tglf"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"FUS_Code_Info",varid)
  status = nf90_put_var(icdf,varid,ss%FUS_Code_Info)
  IF(status.NE.NF90_NOERR) THEN
     WRITE(iout,*) " ?plasma_state_store: error storing: FUS_Code_Info"
     CALL ncerr(status)
     iertot = iertot + 1
  ENDIF

  IF(ALLOCATED(ss%gamma_lmhd)) THEN
     status = nf90_inq_varid(icdf,"gamma_lmhd",varid)
     status = nf90_put_var(icdf,varid,ss%gamma_lmhd)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: gamma_lmhd"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%gamma_nc)) THEN
     status = nf90_inq_varid(icdf,"gamma_nc",varid)
     status = nf90_put_var(icdf,varid,ss%gamma_nc)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: gamma_nc"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%gas_atom)) THEN
     status = nf90_inq_varid(icdf,"gas_atom",varid)
     status = nf90_put_var(icdf,varid,ss%gas_atom)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: gas_atom"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"GAS_Code_Info",varid)
  status = nf90_put_var(icdf,varid,ss%GAS_Code_Info)
  IF(status.NE.NF90_NOERR) THEN
     WRITE(iout,*) " ?plasma_state_store: error storing: GAS_Code_Info"
     CALL ncerr(status)
     iertot = iertot + 1
  ENDIF

  IF(ALLOCATED(ss%gb1)) THEN
     status = nf90_inq_varid(icdf,"gb1",varid)
     status = nf90_put_var(icdf,varid,ss%gb1)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: gb1"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%gb2)) THEN
     status = nf90_inq_varid(icdf,"gb2",varid)
     status = nf90_put_var(icdf,varid,ss%gb2)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: gb2"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%gb2i)) THEN
     status = nf90_inq_varid(icdf,"gb2i",varid)
     status = nf90_put_var(icdf,varid,ss%gb2i)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: gb2i"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%gbr2)) THEN
     status = nf90_inq_varid(icdf,"gbr2",varid)
     status = nf90_put_var(icdf,varid,ss%gbr2)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: gbr2"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"geometry",varid)
  status = nf90_put_var(icdf,varid,ss%geometry)
  IF(status.NE.NF90_NOERR) THEN
     WRITE(iout,*) " ?plasma_state_store: error storing: geometry"
     CALL ncerr(status)
     iertot = iertot + 1
  ENDIF

  status = nf90_inq_varid(icdf,"Global_label",varid)
  status = nf90_put_var(icdf,varid,ss%Global_label)
  IF(status.NE.NF90_NOERR) THEN
     WRITE(iout,*) " ?plasma_state_store: error storing: Global_label"
     CALL ncerr(status)
     iertot = iertot + 1
  ENDIF

  IF(ALLOCATED(ss%gncfb2h)) THEN
     status = nf90_inq_varid(icdf,"gncfb2h",varid)
     status = nf90_put_var(icdf,varid,ss%gncfb2h)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: gncfb2h"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%gncfh)) THEN
     status = nf90_inq_varid(icdf,"gncfh",varid)
     status = nf90_put_var(icdf,varid,ss%gncfh)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: gncfh"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%gr1)) THEN
     status = nf90_inq_varid(icdf,"gr1",varid)
     status = nf90_put_var(icdf,varid,ss%gr1)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: gr1"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%gr2)) THEN
     status = nf90_inq_varid(icdf,"gr2",varid)
     status = nf90_put_var(icdf,varid,ss%gr2)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: gr2"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%gr2i)) THEN
     status = nf90_inq_varid(icdf,"gr2i",varid)
     status = nf90_put_var(icdf,varid,ss%gr2i)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: gr2i"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%gr2rho2)) THEN
     status = nf90_inq_varid(icdf,"gr2rho2",varid)
     status = nf90_put_var(icdf,varid,ss%gr2rho2)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: gr2rho2"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%gr3i)) THEN
     status = nf90_inq_varid(icdf,"gr3i",varid)
     status = nf90_put_var(icdf,varid,ss%gr3i)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: gr3i"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%grho1)) THEN
     status = nf90_inq_varid(icdf,"grho1",varid)
     status = nf90_put_var(icdf,varid,ss%grho1)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: grho1"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%grho2)) THEN
     status = nf90_inq_varid(icdf,"grho2",varid)
     status = nf90_put_var(icdf,varid,ss%grho2)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: grho2"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  CONTAINS


     SUBROUTINE ncerr(status)
        INTEGER, INTENT(in) :: status

        nc_errmsg = NF90_strerror(status)
        write(iout,*) '  NetCDF message: ',trim(nc_errmsg)
     END SUBROUTINE ncerr

END SUBROUTINE plasma_state_store_2

subroutine ps_register_state(state,sname,iout,ierr)

  ! register a plasma state object:
  !   1) mark as initialized
  !   2) copy tagname into state memory
  !   3) create and initialize xplasma interpolation object

  use plasma_state_definition_mod  ! plasma state object definitions
  use plasma_state_xpobj           ! XPLASMA2 state object definitions
  implicit NONE
  
  type (plasma_state) :: state
  character*(*), intent(in) :: sname  ! name for this state object
  !  short alphanumeric name, 1st character not a digit.

  integer, intent(in) :: iout         ! LUN for messages
  integer, intent(out) :: ierr        ! status code, 0=OK

  type (interp_object) :: xobj
  type (xplasma), pointer :: s
  !-------------------------------

  state%itag = 1

  state%chtag = sname

  allocate(xobj%s_xpobj)

  s => xobj%s_xpobj

  call xplasma_init(s, sname, ierr)

  ! transfer back
  call ps_reg_backtrans(xobj, state)

  if(ierr.ne.0) then
     write(iout,*) ' ?ps_register_state: xplasma interpolation object initialization error.'
     write(iout,*) '  state tag name: "',trim(sname),'".'
     call xplasma_error(s,ierr,iout)
  endif

end subroutine ps_register_state

subroutine ps_deregister_state(state,iout,ierr)

  ! deregister a plasma state object:
  !   1) mark as UNinitialized
  !   2) clear tagname
  !   3) clean up and remove xplasma interpolation object

  use plasma_state_definition_mod  ! plasma state object definitions
  use plasma_state_xpobj           ! XPLASMA2 state object definitions
  implicit NONE
  
  type (plasma_state) :: state
  integer, intent(in) :: iout         ! LUN for messages
  integer, intent(out) :: ierr        ! status code, 0=OK

  type (interp_object) :: xobj
  type (xplasma), pointer :: s
  !-------------------------------

  state%itag = ps_unInit
  state%chtag = ' '

  ! transfer opaque representation imbedded in plasma state object
  xobj = transfer(state%iobj, xobj)
  s => xobj%s_xpobj

  call xplasma_free(s, ierr, total=.TRUE.)
  if(ierr.ne.0) then
     write(iout,*) ' ?ps_deregister_state: xplasma_free error; continuing...'
     call xplasma_error(s,ierr,iout)
  endif

  nullify(s)

  deallocate(xobj%s_xpobj)
  nullify(xobj%s_xpobj)

  state%iobj = 0

end subroutine ps_deregister_state

subroutine ps_reg_backtrans(xobj, state)

  use plasma_state_definition_mod  ! plasma state object definitions
  use plasma_state_xpobj           ! XPLASMA2 state object definitions
  implicit NONE
  
  type (plasma_state) :: state
  type (interp_object) :: xobj

  state%iobj = transfer(xobj, state%iobj)

end subroutine ps_reg_backtrans

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_z9_dummy
     return
  end subroutine ccps_getset_z9_dummy

subroutine psget_zbsc(iobj, n1, data, ierr)
    !! elevation of beam source, Elevation of beam centerline at
    !! source (+ above) (- below), machine midplane as defined by Z=0
    !! in the equilibrium specification, (the default, 0.0, centers
    !! beam source in the machine midplane).
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_zbsc', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % Zbsc
end subroutine psget_zbsc


subroutine psset_zbsc(iobj, n1, data, ierr)
    !! elevation of beam source, Elevation of beam centerline at
    !! source (+ above) (- below), machine midplane as defined by Z=0
    !! in the equilibrium specification, (the default, 0.0, centers
    !! beam source in the machine midplane).
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_zbsc', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % Zbsc = data(1:n1)
end subroutine psset_zbsc


subroutine psgetrnk_zbsc(iobj, ndims, ierr)
    !! elevation of beam source, Elevation of beam centerline at
    !! source (+ above) (- below), machine midplane as defined by Z=0
    !! in the equilibrium specification, (the default, 0.0, centers
    !! beam source in the machine midplane).
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_zbsc


subroutine psgetdim_zbsc(iobj, ndims, dims, ierr)
    !! elevation of beam source, Elevation of beam centerline at
    !! source (+ above) (- below), machine midplane as defined by Z=0
    !! in the equilibrium specification, (the default, 0.0, centers
    !! beam source in the machine midplane).
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_zbsc', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % Zbsc ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % Zbsc)
    endif
end subroutine psgetdim_zbsc


subroutine psget_zeff_th(iobj, n1, data, ierr)
    !! Thermal ion contribution to Zeff
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_zeff_th', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % Zeff_th
end subroutine psget_zeff_th


subroutine psset_zeff_th(iobj, n1, data, ierr)
    !! Thermal ion contribution to Zeff
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_zeff_th', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % Zeff_th = data(1:n1)
end subroutine psset_zeff_th


subroutine psgetrnk_zeff_th(iobj, ndims, ierr)
    !! Thermal ion contribution to Zeff
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_zeff_th


subroutine psgetdim_zeff_th(iobj, ndims, dims, ierr)
    !! Thermal ion contribution to Zeff
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_zeff_th', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % Zeff_th ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % Zeff_th)
    endif
end subroutine psgetdim_zeff_th


subroutine psget_z_geo(iobj, n1, n2, data, ierr)
    !! flux surfaces Z(rho,theta)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_z_geo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % Z_geo
end subroutine psget_z_geo


subroutine psset_z_geo(iobj, n1, n2, data, ierr)
    !! flux surfaces Z(rho,theta)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_z_geo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % Z_geo = data(1:n1, 1: n2)
end subroutine psset_z_geo


subroutine psgetrnk_z_geo(iobj, ndims, ierr)
    !! flux surfaces Z(rho,theta)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_z_geo


subroutine psgetdim_z_geo(iobj, ndims, dims, ierr)
    !! flux surfaces Z(rho,theta)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_z_geo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % Z_geo ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % Z_geo)
    endif
end subroutine psgetdim_z_geo


subroutine psget_z_surfmin(iobj, n1, data, ierr)
    !! min Z on flux surface
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_z_surfmin', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % Z_surfMin
end subroutine psget_z_surfmin


subroutine psset_z_surfmin(iobj, n1, data, ierr)
    !! min Z on flux surface
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_z_surfmin', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % Z_surfMin = data(1:n1)
end subroutine psset_z_surfmin


subroutine psgetrnk_z_surfmin(iobj, ndims, ierr)
    !! min Z on flux surface
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_z_surfmin


subroutine psgetdim_z_surfmin(iobj, ndims, dims, ierr)
    !! min Z on flux surface
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_z_surfmin', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % Z_surfMin ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % Z_surfMin)
    endif
end subroutine psgetdim_z_surfmin

subroutine ps_grid_get(iobj, coord_tag, gridname, iauthor, label, &
     max_altnames, alt_author, alt_gridname, &
     n, k_ccw, grid_data, iout, ierr)

  !------------------------------------------------------------
  ! D. McCune 8 Oct 2006

  ! XPLASMA2 implementation of plasma_state subroutine
  ! fetch a grid, perform error checking

  ! This routine is called by generated code associated with the
  ! plasma state.  Component codes will not call this directly.

  ! Added: alternate grid names.  This is a mechanism to allow
  ! earlier versions of state file data to be read with the current
  ! software.
  !------------------------------------------------------------

  use plasma_state_definition_mod
  use plasma_state_xpobj  ! XPLASMA2 state object definitions
  implicit NONE

  !-----------------------
  integer :: iobj(ps_container_size)  ! opaque container for xplasma object

  character*(*), intent(in) :: coord_tag   ! "RHO", "TH", "R", or "Z", ...
  character*(*), intent(in) :: gridname    ! NAME of grid 
  integer, intent(in) :: iauthor           ! author ID (checked)

  character*(*), intent(out) :: label      ! grid label

  integer, intent(in) :: max_altnames      ! array dimension: alternate names
  character*(*), intent(in) :: alt_author(max_altnames)  ! alternate author IDs
  character*(*), intent(in) :: alt_gridname(max_altnames)  ! alt. grid names

  integer, intent(in) :: n                 ! expected grid data size
  integer, intent(in) :: k_ccw             ! CCW flag ("TH" only)

  REAL(KIND=rspec) :: grid_data(n)          ! grid data returned

  integer, intent(in) :: iout              ! LUN for error messages
  integer, intent(out) :: ierr             ! error status code returned 0 = OK

  !--------------------------------------------------
  ! local...

  integer :: id,icoord,ialt,imatch
  character*32 pauth,zauth
  logical :: ccwflag

  type (interp_object) :: xobj
  type (xplasma), pointer :: s
  !--------------------------------------------------

  xobj = transfer(iobj,xobj)
  s => xobj%s_xpobj

  call xplasma_global_info(s,ierr, init_check=.TRUE.)
  if(ierr.ne.0) then
     write(iout,*) ' ?ps_grid_get: invalid or unitialized xplasma object.'
     return
  endif

  !--------------------------------------------------
  !  find grid ID

  call xplasma_gridId(s,gridname,id)
  if(id.eq.0) then
     do ialt = 1,max_altnames
        if(alt_gridname(ialt).eq.' ') exit
        call xplasma_gridId(s,alt_gridname(ialt),id)
        if(id.ne.0) exit
     enddo
     if(id.eq.0) then
        ierr=705
        write(iout,*) ' ?ps_grid_get: grid not found: ',trim(gridname)
        return
     endif
  endif

  !--------------------------------------------------
  !  fetch and check grid info

  call xplasma_grid_info(s,id,ierr, &
       coord=icoord, label=label, author=pauth)

  if(ierr.ne.0) then
     write(iout,*) ' ?ps_grid_get: unexpected XPLASMA2 error:'
     call xplasma_error(s,ierr,iout)
     ierr=706

  else
     ! general checks...

     ccwflag = .TRUE.
     if(icoord.eq.xplasma_theta_coord) then
        ccwflag = (k_ccw.ne.ps_ccw_reverse)
     endif

     if(ps_cnames(iauthor).ne.pauth) then
        imatch = 0
        do ialt = 1,max_altnames
           zauth = alt_author(ialt)
           call uupper(zauth)
           if(zauth.eq.pauth) then
              imatch=ialt
              exit
           endif
        enddo

        if(imatch.eq.0) then
           write(iout,*) ' ?ps_grid_get: author label mismatch:'
           write(iout,*) '  grid name: "',trim(gridname),'".'
           write(iout,*) '  grid has: "',trim(pauth), &
                '"; passed author reference: "',trim(ps_cnames(iauthor)),'".'
           ierr=706
        else
           call xplasma_reset_author(s,id,pauth,ps_cnames(iauthor),ierr)
        endif
     endif

  endif

  if(ierr.ne.0) return

  !--------------------------------------------------
  ! OK fetch the data

  call xplasma_grid(s,id,grid_data,ierr, ccwflag=ccwflag)

  if(ierr.ne.0) then
     write(iout,*) ' ?XPLASMA2 error while attempting grid data retrieval:'
     call xplasma_error(s,ierr,iout)
     ierr=707
  endif

end subroutine ps_grid_get

subroutine ps_gridId(iobj,iout,gridname,id,inum)
  !  get ID of grid item

  use plasma_state_definition_mod
  use plasma_state_xpobj  ! XPLASMA2 state object definitions
  implicit NONE

  !-----------------------
  integer :: iobj(ps_container_size)  ! opaque container for xplasma object
  integer, intent(in) :: iout   ! LUN for messages
  character*(*), intent(in) :: gridname  ! name of grid item
  integer, intent(out) :: id    ! id of item returned (0 if not found).
  integer, intent(out) :: inum  ! size of grid (0 if none was found).

  !-----------------------
  integer :: ierr

  type (interp_object) :: xobj
  type (xplasma), pointer :: s
  !-----------------------

  id = 0
  inum = 0

  xobj = transfer(iobj,xobj)
  s => xobj%s_xpobj

  call xplasma_global_info(s,ierr, init_check=.TRUE.)
  if(ierr.ne.0) then
     write(iout,*) ' ?ps_gridId: invalid or unitialized xplasma object.'
     return
  endif

  call xplasma_gridId(s,gridname,id)
  if(id.gt.0) then
     call xplasma_grid_size(s,id,inum,ierr)
  endif

end subroutine ps_gridId

subroutine ps_gridCoord(iobj,iout,id,cname,cunits)

  !  get coordinate tag of grid (id given, fetched by prior call to ps_gridId).

  use plasma_state_definition_mod
  use plasma_state_xpobj  ! XPLASMA2 state object definitions
  implicit NONE

  !-----------------------
  integer :: iobj(ps_container_size)  ! opaque container for xplasma object
  integer, intent(in) :: iout   ! LUN for messages
  integer, intent(in) :: id     ! id of grid

  character*(*), intent(out) :: cname  ! coordinate tag: "RHO", "R", "Z", ...
  character*(*), intent(out) :: cunits ! coordinate units

  !-----------------------
  integer :: ierr,idc

  type (interp_object) :: xobj
  type (xplasma), pointer :: s
  !-----------------------

  cname=' '

  xobj = transfer(iobj,xobj)
  s => xobj%s_xpobj

  call xplasma_global_info(s,ierr, init_check=.TRUE.)
  if(ierr.ne.0) then
     write(iout,*) ' ?ps_gridCoord: invalid or unitialized xplasma object.'
     return
  endif

  call xplasma_grid_info(s,id,ierr, coord=idc, units=cunits)
  if(ierr.ne.0) then
     write(iout,*) ' ?ps_gridCoord: xplasma error on xplasma_grid_info call:'
     call xplasma_error(s,ierr,iout)
     return
  endif

  call ps_coordTag(xobj,idc,cname)
  if(cname.eq.'??') then
     call xplasma_grid_info(s,id,ierr, name=cname)
     write(iout,*) &
          ' %ps_gridCoord: no abbreviation found, full grid name used: ', &
          trim(cname)
  endif

end subroutine ps_gridCoord

subroutine ps_grid_get_data(iobj,iout,id,imax,data,inum,icoord,iwarn,ierr)
  !  get grid data, given state tag and grid id.

  use plasma_state_definition_mod
  use plasma_state_xpobj  ! XPLASMA2 state object definitions
  implicit NONE

  !-----------------------
  integer :: iobj(ps_container_size)  ! opaque container for xplasma object
  integer, intent(in) :: iout   ! LUN for messages
  integer, intent(in) :: id     ! id of grid

  integer, intent(in) :: imax   ! size of array to receive grid data
  
  REAL(KIND=rspec) :: data(imax)     ! grid data returned (if inum.le.imax)
  integer, intent(out) :: inum       ! actual number of points in grid
  integer, intent(out) :: icoord     ! coordinate tag (indicates "RHO", etc.)

  integer, intent(out) :: iwarn ! =1 if grid data too large for data(1:imax)
  integer, intent(out) :: ierr  ! =0 if OK; >0 if error is detected.

  ! setting iwarn=1 does not cause ierr to be set >1.

  type (interp_object) :: xobj
  type (xplasma), pointer :: s
  !-----------------------

  inum=0
  icoord=0
  iwarn=0
  ierr=0
  data = 0.0_rspec

  if(id.eq.0) return

  xobj = transfer(iobj,xobj)
  s => xobj%s_xpobj

  call xplasma_global_info(s,ierr, init_check=.TRUE.)
  if(ierr.ne.0) then
     write(iout,*) ' ?ps_grid_get_data: invalid or unitialized xplasma object.'
     return
  endif

  call xplasma_grid_size(s,id,inum,ierr)
  if(ierr.ne.0) return

  if(inum.gt.imax) then
     iwarn=1
     return
  endif

  call xplasma_grid_info(s,id,ierr, coord=icoord)
  if(ierr.ne.0) return

  call xplasma_grid(s,id,data(1:inum),ierr)

end subroutine ps_grid_get_data

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_x2_dummy
     return
  end subroutine ccps_getset_x2_dummy

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_c1_dummy
     return
  end subroutine ccps_getset_c1_dummy

subroutine psget_curlh_src(iobj, n1, n2, data, ierr)
    !! LH current drive (by antenna)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_curlh_src', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % curlh_src
end subroutine psget_curlh_src


subroutine psset_curlh_src(iobj, n1, n2, data, ierr)
    !! LH current drive (by antenna)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_curlh_src', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % curlh_src = data(1:n1, 1: n2)
end subroutine psset_curlh_src


subroutine psgetrnk_curlh_src(iobj, ndims, ierr)
    !! LH current drive (by antenna)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_curlh_src


subroutine psgetdim_curlh_src(iobj, ndims, dims, ierr)
    !! LH current drive (by antenna)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_curlh_src', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % curlh_src ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % curlh_src)
    endif
end subroutine psgetdim_curlh_src


subroutine psget_chiphi_mmm71(iobj, n1, data, ierr)
    !! momentum-equation, diffusivity term, toroidal
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_chiphi_mmm71', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % chiphi_mmm71
end subroutine psget_chiphi_mmm71


subroutine psset_chiphi_mmm71(iobj, n1, data, ierr)
    !! momentum-equation, diffusivity term, toroidal
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_chiphi_mmm71', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % chiphi_mmm71 = data(1:n1)
end subroutine psset_chiphi_mmm71


subroutine psgetrnk_chiphi_mmm71(iobj, ndims, ierr)
    !! momentum-equation, diffusivity term, toroidal
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_chiphi_mmm71


subroutine psgetdim_chiphi_mmm71(iobj, ndims, dims, ierr)
    !! momentum-equation, diffusivity term, toroidal
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_chiphi_mmm71', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % chiphi_mmm71 ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % chiphi_mmm71)
    endif
end subroutine psgetdim_chiphi_mmm71


subroutine psget_chie_w19(iobj, n1, data, ierr)
    !! Te-equation, diffusivity term
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_chie_w19', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % chie_w19
end subroutine psget_chie_w19


subroutine psset_chie_w19(iobj, n1, data, ierr)
    !! Te-equation, diffusivity term
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_chie_w19', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % chie_w19 = data(1:n1)
end subroutine psset_chie_w19


subroutine psgetrnk_chie_w19(iobj, ndims, ierr)
    !! Te-equation, diffusivity term
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_chie_w19


subroutine psgetdim_chie_w19(iobj, ndims, dims, ierr)
    !! Te-equation, diffusivity term
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_chie_w19', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % chie_w19 ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % chie_w19)
    endif
end subroutine psgetdim_chie_w19


subroutine psget_chii_gtcneo(iobj, n1, data, ierr)
    !! Ti-equation, neoclassical diffusivity from GTC_NEO model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_chii_gtcneo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % chii_gtcneo
end subroutine psget_chii_gtcneo


subroutine psset_chii_gtcneo(iobj, n1, data, ierr)
    !! Ti-equation, neoclassical diffusivity from GTC_NEO model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_chii_gtcneo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % chii_gtcneo = data(1:n1)
end subroutine psset_chii_gtcneo


subroutine psgetrnk_chii_gtcneo(iobj, ndims, ierr)
    !! Ti-equation, neoclassical diffusivity from GTC_NEO model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_chii_gtcneo


subroutine psgetdim_chii_gtcneo(iobj, ndims, dims, ierr)
    !! Ti-equation, neoclassical diffusivity from GTC_NEO model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_chii_gtcneo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % chii_gtcneo ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % chii_gtcneo)
    endif
end subroutine psgetdim_chii_gtcneo

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_p0_dummy
     return
  end subroutine ccps_getset_p0_dummy

subroutine psget_phibsc(iobj, n1, data, ierr)
    !! toroidal location of beam source, Angle of location of beam
    !! centerline at source, with respect to some, reference Phi=0
    !! vertical plane.  Phi is assumed to increase in the,
    !! counter-clockwise direction of the torus when viewed from
    !! above, i.e., (R,phi,Z) form a right handed coordinate system. 
    !! The setting of, Phibsc does not affect beam heating in
    !! axisymmetric simulations.
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_phibsc', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % Phibsc
end subroutine psget_phibsc


subroutine psset_phibsc(iobj, n1, data, ierr)
    !! toroidal location of beam source, Angle of location of beam
    !! centerline at source, with respect to some, reference Phi=0
    !! vertical plane.  Phi is assumed to increase in the,
    !! counter-clockwise direction of the torus when viewed from
    !! above, i.e., (R,phi,Z) form a right handed coordinate system. 
    !! The setting of, Phibsc does not affect beam heating in
    !! axisymmetric simulations.
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_phibsc', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % Phibsc = data(1:n1)
end subroutine psset_phibsc


subroutine psgetrnk_phibsc(iobj, ndims, ierr)
    !! toroidal location of beam source, Angle of location of beam
    !! centerline at source, with respect to some, reference Phi=0
    !! vertical plane.  Phi is assumed to increase in the,
    !! counter-clockwise direction of the torus when viewed from
    !! above, i.e., (R,phi,Z) form a right handed coordinate system. 
    !! The setting of, Phibsc does not affect beam heating in
    !! axisymmetric simulations.
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_phibsc


subroutine psgetdim_phibsc(iobj, ndims, dims, ierr)
    !! toroidal location of beam source, Angle of location of beam
    !! centerline at source, with respect to some, reference Phi=0
    !! vertical plane.  Phi is assumed to increase in the,
    !! counter-clockwise direction of the torus when viewed from
    !! above, i.e., (R,phi,Z) form a right handed coordinate system. 
    !! The setting of, Phibsc does not affect beam heating in
    !! axisymmetric simulations.
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_phibsc', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % Phibsc ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % Phibsc)
    endif
end subroutine psgetdim_phibsc


subroutine psget_power_ec(iobj, n1, data, ierr)
    !! power on each ECRF source
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_power_ec', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % power_ec
end subroutine psget_power_ec


subroutine psset_power_ec(iobj, n1, data, ierr)
    !! power on each ECRF source
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_power_ec', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % power_ec = data(1:n1)
end subroutine psset_power_ec


subroutine psgetrnk_power_ec(iobj, ndims, ierr)
    !! power on each ECRF source
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_power_ec


subroutine psgetdim_power_ec(iobj, ndims, dims, ierr)
    !! power on each ECRF source
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_power_ec', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % power_ec ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % power_ec)
    endif
end subroutine psgetdim_power_ec


subroutine psget_pohme(iobj, n1, data, ierr)
    !! Ohmic heating of electrons
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_pohme', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % pohme
end subroutine psget_pohme


subroutine psset_pohme(iobj, n1, data, ierr)
    !! Ohmic heating of electrons
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_pohme', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % pohme = data(1:n1)
end subroutine psset_pohme


subroutine psgetrnk_pohme(iobj, ndims, ierr)
    !! Ohmic heating of electrons
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_pohme


subroutine psgetdim_pohme(iobj, ndims, dims, ierr)
    !! Ohmic heating of electrons
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_pohme', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % pohme ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % pohme)
    endif
end subroutine psgetdim_pohme


subroutine psget_pe_trans(iobj, n1, data, ierr)
    !! electron transport (loss) power
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_pe_trans', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % pe_trans
end subroutine psget_pe_trans


subroutine psset_pe_trans(iobj, n1, data, ierr)
    !! electron transport (loss) power
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_pe_trans', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % pe_trans = data(1:n1)
end subroutine psset_pe_trans


subroutine psgetrnk_pe_trans(iobj, ndims, ierr)
    !! electron transport (loss) power
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_pe_trans


subroutine psgetdim_pe_trans(iobj, ndims, dims, ierr)
    !! electron transport (loss) power
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_pe_trans', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % pe_trans ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % pe_trans)
    endif
end subroutine psgetdim_pe_trans


subroutine psget_psmom_errck(iobj, n1, data, ierr)
    !! PS moments sum convergence,
    !! |ngradb2_av(:)-sum[j=1:npsmom]psmom_nc(:,j)/gb2(:)|/maxval(|ngradb2_av(:)|
    !! 
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_psmom_errck', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % psmom_errck
end subroutine psget_psmom_errck


subroutine psset_psmom_errck(iobj, n1, data, ierr)
    !! PS moments sum convergence,
    !! |ngradb2_av(:)-sum[j=1:npsmom]psmom_nc(:,j)/gb2(:)|/maxval(|ngradb2_av(:)|
    !! 
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_psmom_errck', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % psmom_errck = data(1:n1)
end subroutine psset_psmom_errck


subroutine psgetrnk_psmom_errck(iobj, ndims, ierr)
    !! PS moments sum convergence,
    !! |ngradb2_av(:)-sum[j=1:npsmom]psmom_nc(:,j)/gb2(:)|/maxval(|ngradb2_av(:)|
    !! 
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_psmom_errck


subroutine psgetdim_psmom_errck(iobj, ndims, dims, ierr)
    !! PS moments sum convergence,
    !! |ngradb2_av(:)-sum[j=1:npsmom]psmom_nc(:,j)/gb2(:)|/maxval(|ngradb2_av(:)|
    !! 
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_psmom_errck', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % psmom_errck ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % psmom_errck)
    endif
end subroutine psgetdim_psmom_errck


subroutine psget_pmini(iobj, n1, data, ierr)
    !! thermal ion heating by minority ions
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_pmini', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % pmini
end subroutine psget_pmini


subroutine psset_pmini(iobj, n1, data, ierr)
    !! thermal ion heating by minority ions
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_pmini', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % pmini = data(1:n1)
end subroutine psset_pmini


subroutine psgetrnk_pmini(iobj, ndims, ierr)
    !! thermal ion heating by minority ions
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_pmini


subroutine psgetdim_pmini(iobj, ndims, dims, ierr)
    !! thermal ion heating by minority ions
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_pmini', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % pmini ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % pmini)
    endif
end subroutine psgetdim_pmini


subroutine psget_pbe(iobj, n1, data, ierr)
    !! electron heating by all beam ions
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_pbe', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % pbe
end subroutine psget_pbe


subroutine psset_pbe(iobj, n1, data, ierr)
    !! electron heating by all beam ions
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_pbe', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % pbe = data(1:n1)
end subroutine psset_pbe


subroutine psgetrnk_pbe(iobj, ndims, ierr)
    !! electron heating by all beam ions
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_pbe


subroutine psgetdim_pbe(iobj, ndims, dims, ierr)
    !! electron heating by all beam ions
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_pbe', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % pbe ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % pbe)
    endif
end subroutine psgetdim_pbe


subroutine psget_pfusi(iobj, n1, data, ierr)
    !! thermal ion heating by all fusion ions
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_pfusi', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % pfusi
end subroutine psget_pfusi


subroutine psset_pfusi(iobj, n1, data, ierr)
    !! thermal ion heating by all fusion ions
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_pfusi', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % pfusi = data(1:n1)
end subroutine psset_pfusi


subroutine psgetrnk_pfusi(iobj, ndims, ierr)
    !! thermal ion heating by all fusion ions
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_pfusi


subroutine psgetdim_pfusi(iobj, ndims, dims, ierr)
    !! thermal ion heating by all fusion ions
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_pfusi', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % pfusi ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % pfusi)
    endif
end subroutine psgetdim_pfusi

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_s4_dummy
     return
  end subroutine ccps_getset_s4_dummy

subroutine psget_s_name(iobj, n1, data, ierr)
    !! thermal species list, index 0 for electrons
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    CHARACTER*(*), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_s_name', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % S_name
end subroutine psget_s_name


subroutine psset_s_name(iobj, n1, data, ierr)
    !! thermal species list, index 0 for electrons
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    CHARACTER*(*), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_s_name', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % S_name = data(1:n1)
end subroutine psset_s_name


subroutine psgetsz_s_name(iobj, size, ierr)
    !! thermal species list, index 0 for electrons
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: size    ! size of character string
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psgetsz_s_name', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! note that the following will return the character length size regardless of
    ! the number of array elements (if S_name is an array)
    size = len(ss % S_name)
end subroutine psgetsz_s_name


subroutine psgetrnk_s_name(iobj, ndims, ierr)
    !! thermal species list, index 0 for electrons
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_s_name


subroutine psgetdim_s_name(iobj, ndims, dims, ierr)
    !! thermal species list, index 0 for electrons
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_s_name', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % S_name ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % S_name)
    endif
end subroutine psgetdim_s_name


subroutine psget_simpi_type(iobj, n1, data, ierr)
    !! SIMPI specie types
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_simpi_type', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % SIMPI_type
end subroutine psget_simpi_type


subroutine psset_simpi_type(iobj, n1, data, ierr)
    !! SIMPI specie types
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_simpi_type', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % SIMPI_type = data(1:n1)
end subroutine psset_simpi_type


subroutine psgetrnk_simpi_type(iobj, ndims, ierr)
    !! SIMPI specie types
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_simpi_type


subroutine psgetdim_simpi_type(iobj, ndims, dims, ierr)
    !! SIMPI specie types
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_simpi_type', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % SIMPI_type ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % SIMPI_type)
    endif
end subroutine psgetdim_simpi_type


subroutine psget_sc0_to_sgas(iobj, n1, data, ierr)
    !! index map from neutral source to neutral species, (computed
    !! from GAS_ATOM(ngsc0))., this indicates the species injected by
    !! the source, although charge exchange induces a source/sink,
    !! profile of additional species proportional to, each source.
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_sc0_to_sgas', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % sc0_to_sgas
end subroutine psget_sc0_to_sgas


subroutine psset_sc0_to_sgas(iobj, n1, data, ierr)
    !! index map from neutral source to neutral species, (computed
    !! from GAS_ATOM(ngsc0))., this indicates the species injected by
    !! the source, although charge exchange induces a source/sink,
    !! profile of additional species proportional to, each source.
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_sc0_to_sgas', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % sc0_to_sgas = data(1:n1)
end subroutine psset_sc0_to_sgas


subroutine psgetrnk_sc0_to_sgas(iobj, ndims, ierr)
    !! index map from neutral source to neutral species, (computed
    !! from GAS_ATOM(ngsc0))., this indicates the species injected by
    !! the source, although charge exchange induces a source/sink,
    !! profile of additional species proportional to, each source.
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_sc0_to_sgas


subroutine psgetdim_sc0_to_sgas(iobj, ndims, dims, ierr)
    !! index map from neutral source to neutral species, (computed
    !! from GAS_ATOM(ngsc0))., this indicates the species injected by
    !! the source, although charge exchange induces a source/sink,
    !! profile of additional species proportional to, each source.
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_sc0_to_sgas', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % sc0_to_sgas ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % sc0_to_sgas)
    endif
end subroutine psgetdim_sc0_to_sgas

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_j9_dummy
     return
  end subroutine ccps_getset_j9_dummy

subroutine psget_jdotb(iobj, n1, data, ierr)
    !! <J.B>, Parallel current * mod(B) -- note sign convention:,
    !! Local positive values indicate local current flow, in the
    !! direction of the main toroidal current; i.e. actually,
    !! kccw_Jphi * kccw_Bphi * <J.B> is stored.  So, even if the, main
    !! toroidal current and the toroidal field are anti-parallel,,
    !! jdotb is generally positive, but there can be localized
    !! regions, of negative values, usually near the plasma edge.',
    !! "From a parallel Ampere's Law expression, <J.B> can be
    !! expressed", 'as a combination of derivatives of toroidal
    !! current and toroidal, field functions curt(rho) and g(rho):,
    !! <J.B> = 2pi*[g*d(curt)/drho-curt*dg/drho]/(dVol/drho)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_jdotb', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % jdotb
end subroutine psget_jdotb


subroutine psset_jdotb(iobj, n1, data, ierr)
    !! <J.B>, Parallel current * mod(B) -- note sign convention:,
    !! Local positive values indicate local current flow, in the
    !! direction of the main toroidal current; i.e. actually,
    !! kccw_Jphi * kccw_Bphi * <J.B> is stored.  So, even if the, main
    !! toroidal current and the toroidal field are anti-parallel,,
    !! jdotb is generally positive, but there can be localized
    !! regions, of negative values, usually near the plasma edge.',
    !! "From a parallel Ampere's Law expression, <J.B> can be
    !! expressed", 'as a combination of derivatives of toroidal
    !! current and toroidal, field functions curt(rho) and g(rho):,
    !! <J.B> = 2pi*[g*d(curt)/drho-curt*dg/drho]/(dVol/drho)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_jdotb', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % jdotb = data(1:n1)
end subroutine psset_jdotb


subroutine psgetrnk_jdotb(iobj, ndims, ierr)
    !! <J.B>, Parallel current * mod(B) -- note sign convention:,
    !! Local positive values indicate local current flow, in the
    !! direction of the main toroidal current; i.e. actually,
    !! kccw_Jphi * kccw_Bphi * <J.B> is stored.  So, even if the, main
    !! toroidal current and the toroidal field are anti-parallel,,
    !! jdotb is generally positive, but there can be localized
    !! regions, of negative values, usually near the plasma edge.',
    !! "From a parallel Ampere's Law expression, <J.B> can be
    !! expressed", 'as a combination of derivatives of toroidal
    !! current and toroidal, field functions curt(rho) and g(rho):,
    !! <J.B> = 2pi*[g*d(curt)/drho-curt*dg/drho]/(dVol/drho)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_jdotb


subroutine psgetdim_jdotb(iobj, ndims, dims, ierr)
    !! <J.B>, Parallel current * mod(B) -- note sign convention:,
    !! Local positive values indicate local current flow, in the
    !! direction of the main toroidal current; i.e. actually,
    !! kccw_Jphi * kccw_Bphi * <J.B> is stored.  So, even if the, main
    !! toroidal current and the toroidal field are anti-parallel,,
    !! jdotb is generally positive, but there can be localized
    !! regions, of negative values, usually near the plasma edge.',
    !! "From a parallel Ampere's Law expression, <J.B> can be
    !! expressed", 'as a combination of derivatives of toroidal
    !! current and toroidal, field functions curt(rho) and g(rho):,
    !! <J.B> = 2pi*[g*d(curt)/drho-curt*dg/drho]/(dVol/drho)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_jdotb', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % jdotb ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % jdotb)
    endif
end subroutine psgetdim_jdotb

subroutine ur_cstate_compare

  !  compare contents of one or more states

  use cstate_lib_mod
  implicit NONE

  !-------------------------
  ! local

  character*32 ctmp,ztest

  integer :: i,iac,icomp,idiff
  integer :: luntty,lnout
  logical :: lxout,lchar

  !-------------------------

  mnlab(1) = 'cstate: PS_vsn '//trim(ps_version_id)
  iac = len_trim(mnlab(1)) + 2
  call fdate(mnlab(1)(iac:len(mnlab(1))))

  luntty = lnout(0)

  if(nsss_cur.eq.0) then
     write(luntty,*) ' ?ur_cstate_compare: no states found.'
     call uclear
     return
  endif

  !  allocate module variable here
  !  must free & deallocate before exiting this subroutine!

  allocate(ww(nsss_cur),wdisp(nsss_cur))
  do i=1,nsss_cur
     call free_window(ww(i))
     call free_window(wdisp(i))
  enddo

  do
     if(lxout(0)) then
        write(luntty,1001) trim(cur_components)

1001    format(/ &
             ' ur_cstate_compare options:'/ &
             '  C -- select & restrict view to components (current selection: ',a,')'/ &
             '  A -- category lookup'/ &
             '  T -- tables of contents'// &
             '  G -- view/compare GRIDS'/ &
             '  S -- view/compare SPECIES LISTS'/ &
             '  I -- view/compare ITEM LISTS'// &
             '  M -- view/compare MACHINE DESCRIPTION other than item lists'/ &
             '  F -- view/compare SHOT CONFIGURATION other than species lists'/ &
             '  N -- view/compare SIMULATION INITIALIZATION data other than grids'// &
             '  D -- view/compare STATE DATA'/ &
             '  P -- view/compare STATE PROFILES'// &
             '  X -- "xplasma" plots of individual state'/ &
             '  Y -- additional comparitive display options'/ &
             '       (limiter plots; quasineutrality, Zeff checks...)'/ &
             '  Q -- quit')
        if(nsss_cur.eq.2) then
           write(luntty,1002)
1002       format( &
                '  2 -- view summary of differences between the two selected states.')
        endif
     endif

     call uread('ur_cstate_compare: option select:')

     if(lchar('Q')) then
        exit

     else if(lchar('2')) then
        if(nsss_cur.ne.2) then
           call uermsg('option "2" only available when exactly 2 states are selected.',' ',0)
           cycle
        else
           call plasma_state_hash_diff( &
                sss(1),sss_label(1),sss(2),sss_label(2),'*',icomp,idiff)
        endif

     else if(lchar('X')) then
        call ur_cstate_xplasma_plots

     else if(lchar('Y')) then
        call ur_cstate_misc_plots

     else if(lchar('C')) then
        call ur_cstate_component

     else if(lchar('A')) then
        call ureadw('enter state element name or substring, ".Q" to skip:', &
             ctmp)
        if(ctmp.eq.'.Q') cycle

        call ps_print_category(luntty,ctmp)

     else if(lchar('T')) then
        call ur_cstate_contents

     else if(lchar('G')) then
        call ur_cstate_grids

     else if(lchar('S')) then
        call ur_cstate_slists

     else if(lchar('I')) then
        call ur_cstate_ilists

     else if(lchar('M')) then
        call ur_cstate_sdata('MACHINE_DESCRIPTION')

     else if(lchar('F')) then
        call ur_cstate_sdata('SHOT_CONFIGURATION')

     else if(lchar('N')) then
        call ur_cstate_sdata('SIMULATION_INIT')

     else if(lchar('D')) then
        call ur_cstate_sdata('STATE_DATA')

     else if(lchar('P')) then
        call ur_cstate_sprof

     else
        call uermsg(' ?ur_cstate_compare: unrecognized option',' ',0)
     endif

  enddo

  do i=1,nsss_cur
     call free_window(ww(i))
     call free_window(wdisp(i))
  enddo
  deallocate(ww,wdisp)

end subroutine ur_cstate_compare

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


SUBROUTINE ps_update_file_write_def_0(ss,icdf,cclist,nids,iout,iwarn,iertot)


  ! Define updated data

  USE plasma_state_definition_mod
  USE netcdf
  USE ps_nidlist_defn
  IMPLICIT NONE

  TYPE (plasma_state) :: ss  ! state containing array elements to be allocated
  INTEGER, INTENT(IN) :: icdf  ! NetCDF file ID
  INTEGER, INTENT(IN) :: cclist(ps_ccount)  ! component selection
  TYPE (nidlist) :: nids       ! defined dimensions list
  INTEGER, INTENT(IN) :: iout  ! LUN for messages
  INTEGER, INTENT(INOUT) :: iwarn   ! warn count
  INTEGER, INTENT(INOUT) :: iertot  ! error count

  !-------------------
  LOGICAL :: plasma_state_hash_match,ichange

  INTEGER :: varid,pvarid,vvarid,dimid,status,iertmp,iaddr
  INTEGER :: idims(20),indim,ival,ii,ierr
  CHARACTER*80 :: nc_errmsg

  !-------------------

  ierr = 0   ! local

  iaddr = ps_shash_alla_index
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%alla_index).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("alla_index","PLASMA")
     ELSE
        indim = 0
        IF(nids%nid_dp1_nspec_alla.EQ.0) THEN
           CALL define_dim(nids%nid_dp1_nspec_alla,"dp1_nspec_alla",ss%nspec_alla+1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dp1_nspec_alla
        CALL define_var("alla_index","I",indim,idims, &
               "species index in original lists", &
               "__NONE","PLASMA","SIMULATION_INIT", &
               "I alla_index(0:nspec_alla)")
     ENDIF
  ENDIF

  iaddr = ps_dhash_nspec_alla
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%ALLA_name).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("ALLA_name","PLASMA")
     ELSE
        indim = 1
        idims(1)=nids%nid_clen_32
        IF(nids%nid_dp1_nspec_alla.EQ.0) THEN
           CALL define_dim(nids%nid_dp1_nspec_alla,"dp1_nspec_alla",ss%nspec_alla+1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dp1_nspec_alla
        CALL define_var("ALLA_name","N",indim,idims, &
               "all species abridged", &
               "__NONE","PLASMA","SIMULATION_INIT", &
               "S|specie  ALLA(0:nspec_alla)")
     ENDIF
  ENDIF

  iaddr = ps_dhash_nspec_alla
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%ALLA_type).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("ALLA_type","PLASMA")
     ELSE
        indim = 0
        IF(nids%nid_dp1_nspec_alla.EQ.0) THEN
           CALL define_dim(nids%nid_dp1_nspec_alla,"dp1_nspec_alla",ss%nspec_alla+1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dp1_nspec_alla
        CALL define_var("ALLA_type","I",indim,idims, &
               "ALLA specie types", &
               "__NONE","PLASMA","SIMULATION_INIT", &
               "S|specie  ALLA(0:nspec_alla)")
     ENDIF
  ENDIF

  iaddr = ps_shash_all_index
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%all_index).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("all_index","PLASMA")
     ELSE
        indim = 0
        IF(nids%nid_dp1_nspec_all.EQ.0) THEN
           CALL define_dim(nids%nid_dp1_nspec_all,"dp1_nspec_all",ss%nspec_all+1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dp1_nspec_all
        CALL define_var("all_index","I",indim,idims, &
               "species index in original lists", &
               "__NONE","PLASMA","SIMULATION_INIT", &
               "I all_index(0:nspec_all)")
     ENDIF
  ENDIF

  iaddr = ps_dhash_nspec_all
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%ALL_name).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("ALL_name","PLASMA")
     ELSE
        indim = 1
        idims(1)=nids%nid_clen_32
        IF(nids%nid_dp1_nspec_all.EQ.0) THEN
           CALL define_dim(nids%nid_dp1_nspec_all,"dp1_nspec_all",ss%nspec_all+1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dp1_nspec_all
        CALL define_var("ALL_name","N",indim,idims, &
               "all species", &
               "__NONE","PLASMA","SIMULATION_INIT", &
               "S|specie  ALL(0:nspec_all)")
     ENDIF
  ENDIF

  iaddr = ps_dhash_nspec_all
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%ALL_type).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("ALL_type","PLASMA")
     ELSE
        indim = 0
        IF(nids%nid_dp1_nspec_all.EQ.0) THEN
           CALL define_dim(nids%nid_dp1_nspec_all,"dp1_nspec_all",ss%nspec_all+1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dp1_nspec_all
        CALL define_var("ALL_type","I",indim,idims, &
               "ALL specie types", &
               "__NONE","PLASMA","SIMULATION_INIT", &
               "S|specie  ALL(0:nspec_all)")
     ENDIF
  ENDIF

  iaddr = ps_shash_amaxlh
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%amaxlh).AND.ichange) THEN
     IF(cclist(ps_cnum_LH).NE.1) THEN
        CALL ccwarn("amaxlh","LH")
     ELSE
        indim = 0
        IF(nids%nid_dim_max_nspectrumlh_src.EQ.0) THEN
           CALL define_dim(nids%nid_dim_max_nspectrumlh_src,"dim_max_nspectrumlh_src",ss%max_nspectrumlh_src)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_max_nspectrumlh_src
        IF(nids%nid_dim_nlhrf_src.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nlhrf_src,"dim_nlhrf_src",ss%nlhrf_src)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nlhrf_src
        CALL define_var("amaxlh","R",indim,idims, &
               "width of the spectrum peak", &
               "-","LH","SHOT_CONFIGURATION", &
               "R|units=- amaxlh(nspectrumlh_src(),nlhrf_src)")
     ENDIF
  ENDIF

  iaddr = ps_shash_aminlh
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%aminlh).AND.ichange) THEN
     IF(cclist(ps_cnum_LH).NE.1) THEN
        CALL ccwarn("aminlh","LH")
     ELSE
        indim = 0
        IF(nids%nid_dim_max_nspectrumlh_src.EQ.0) THEN
           CALL define_dim(nids%nid_dim_max_nspectrumlh_src,"dim_max_nspectrumlh_src",ss%max_nspectrumlh_src)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_max_nspectrumlh_src
        IF(nids%nid_dim_nlhrf_src.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nlhrf_src,"dim_nlhrf_src",ss%nlhrf_src)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nlhrf_src
        CALL define_var("aminlh","R",indim,idims, &
               "parallel mode number, center of the spectrum peak", &
               "-","LH","SHOT_CONFIGURATION", &
               "R|units=- aminlh(nspectrumlh_src(),nlhrf_src)")
     ENDIF
  ENDIF

  iaddr = ps_shash_Ang_Href_coil
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%Ang_Href_coil).AND.ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("Ang_Href_coil","EQ")
     ELSE
        indim = 0
        IF(nids%nid_dim_ncoils.EQ.0) THEN
           CALL define_dim(nids%nid_dim_ncoils,"dim_ncoils",ss%ncoils)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_ncoils
        CALL define_var("Ang_Href_coil","R",indim,idims, &
               "angle w.r.t. horizontal of coil base", &
               "degrees","EQ","MACHINE_DESCRIPTION", &
               "R|units=degrees Ang_Href_coil(ncoils)")
     ENDIF
  ENDIF

  iaddr = ps_shash_Ang_Vref_coil
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%Ang_Vref_coil).AND.ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("Ang_Vref_coil","EQ")
     ELSE
        indim = 0
        IF(nids%nid_dim_ncoils.EQ.0) THEN
           CALL define_dim(nids%nid_dim_ncoils,"dim_ncoils",ss%ncoils)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_ncoils
        CALL define_var("Ang_Vref_coil","R",indim,idims, &
               "angle w.r.t. vertical of coil sides", &
               "degrees","EQ","MACHINE_DESCRIPTION", &
               "R|units=degrees Ang_Vref_coil(ncoils)")
     ENDIF
  ENDIF

  iaddr = ps_shash_ANOM_Code_Info
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("ANOM_Code_Info","ANOM")
     ELSE
        indim = 1
        idims(1)=nids%nid_clen_80
        CALL define_var("ANOM_Code_Info","C*80",indim,idims, &
               "Information: code implementing ANOM component", &
               "__NONE","ANOM","SIMULATION_INIT", &
               "C*80   ANOM_Code_Info")
     ENDIF
  ENDIF

  iaddr = ps_phash_anom_evar
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%anom_evar).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("anom_evar","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nefi_anom.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nefi_anom,"dim_nefi_anom",ss%nefi_anom)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nefi_anom
        CALL define_var("anom_evar","R",indim,idims, &
               "anomalous transport energy variation", &
               "-","ANOM","STATE_PROFILES", &
               "R|pclin|units=- anom_evar(nefi_anom)")
     ENDIF
  ENDIF

  iaddr = ps_shash_ant_model
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%ant_model).AND.ichange) THEN
     IF(cclist(ps_cnum_IC).NE.1) THEN
        CALL ccwarn("ant_model","IC")
     ELSE
        indim = 1
        idims(1)=nids%nid_clen_256
        IF(nids%nid_dim_nicrf_src.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nicrf_src,"dim_nicrf_src",ss%nicrf_src)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nicrf_src
        CALL define_var("ant_model","F",indim,idims, &
               "antenna model filenames (1 per antenna source)", &
               "__NONE","IC","MACHINE_DESCRIPTION", &
               "F ant_model(nicrf_src)")
     ENDIF
  ENDIF

  iaddr = ps_shash_ap2_halfheight
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%ap2_halfheight).AND.ichange) THEN
     IF(cclist(ps_cnum_NBI).NE.1) THEN
        CALL ccwarn("ap2_halfheight","NBI")
     ELSE
        indim = 0
        IF(nids%nid_dim_nbeam.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nbeam,"dim_nbeam",ss%nbeam)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nbeam
        CALL define_var("ap2_halfheight","R",indim,idims, &
               "aperture half-height", &
               "m","NBI","MACHINE_DESCRIPTION", &
               "R|units=m         ap2_halfheight(nbeam)")
     ENDIF
  ENDIF

  iaddr = ps_shash_ap2_halfwidth
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%ap2_halfwidth).AND.ichange) THEN
     IF(cclist(ps_cnum_NBI).NE.1) THEN
        CALL ccwarn("ap2_halfwidth","NBI")
     ELSE
        indim = 0
        IF(nids%nid_dim_nbeam.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nbeam,"dim_nbeam",ss%nbeam)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nbeam
        CALL define_var("ap2_halfwidth","R",indim,idims, &
               "2nd aperture half-width", &
               "m","NBI","MACHINE_DESCRIPTION", &
               "R|units=m         ap2_halfwidth(nbeam)")
     ENDIF
  ENDIF

  iaddr = ps_shash_ap2_horiz_offset
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%ap2_horiz_offset).AND.ichange) THEN
     IF(cclist(ps_cnum_NBI).NE.1) THEN
        CALL ccwarn("ap2_horiz_offset","NBI")
     ELSE
        indim = 0
        IF(nids%nid_dim_nbeam.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nbeam,"dim_nbeam",ss%nbeam)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nbeam
        CALL define_var("ap2_horiz_offset","R",indim,idims, &
               "horizontal offset, 2nd aperture", &
               "m","NBI","MACHINE_DESCRIPTION", &
               "R|units=m         ap2_horiz_offset(nbeam)")
     ENDIF
  ENDIF

  iaddr = ps_shash_ap2_vert_offset
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%ap2_vert_offset).AND.ichange) THEN
     IF(cclist(ps_cnum_NBI).NE.1) THEN
        CALL ccwarn("ap2_vert_offset","NBI")
     ELSE
        indim = 0
        IF(nids%nid_dim_nbeam.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nbeam,"dim_nbeam",ss%nbeam)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nbeam
        CALL define_var("ap2_vert_offset","R",indim,idims, &
               "vertical offset, 2nd aperture", &
               "m","NBI","MACHINE_DESCRIPTION", &
               "R|units=m         ap2_vert_offset(nbeam)")
     ENDIF
  ENDIF

  iaddr = ps_shash_apolmaxlh
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%apolmaxlh).AND.ichange) THEN
     IF(cclist(ps_cnum_LH).NE.1) THEN
        CALL ccwarn("apolmaxlh","LH")
     ELSE
        indim = 0
        IF(nids%nid_dim_max_nspectrumlh_src.EQ.0) THEN
           CALL define_dim(nids%nid_dim_max_nspectrumlh_src,"dim_max_nspectrumlh_src",ss%max_nspectrumlh_src)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_max_nspectrumlh_src
        IF(nids%nid_dim_nlhrf_src.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nlhrf_src,"dim_nlhrf_src",ss%nlhrf_src)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nlhrf_src
        CALL define_var("apolmaxlh","R",indim,idims, &
               "poloidal mode number right of lumps", &
               "-","LH","SHOT_CONFIGURATION", &
               "R|units=- apolmaxlh(nspectrumlh_src(),nlhrf_src)")
     ENDIF
  ENDIF

  iaddr = ps_shash_apolminlh
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%apolminlh).AND.ichange) THEN
     IF(cclist(ps_cnum_LH).NE.1) THEN
        CALL ccwarn("apolminlh","LH")
     ELSE
        indim = 0
        IF(nids%nid_dim_max_nspectrumlh_src.EQ.0) THEN
           CALL define_dim(nids%nid_dim_max_nspectrumlh_src,"dim_max_nspectrumlh_src",ss%max_nspectrumlh_src)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_max_nspectrumlh_src
        IF(nids%nid_dim_nlhrf_src.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nlhrf_src,"dim_nlhrf_src",ss%nlhrf_src)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nlhrf_src
        CALL define_var("apolminlh","R",indim,idims, &
               "poloidal mode number left of lumps", &
               "-","LH","SHOT_CONFIGURATION", &
               "R|units=- apolminlh(nspectrumlh_src(),nlhrf_src)")
     ENDIF
  ENDIF

  iaddr = ps_shash_ap_halfheight
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%ap_halfheight).AND.ichange) THEN
     IF(cclist(ps_cnum_NBI).NE.1) THEN
        CALL ccwarn("ap_halfheight","NBI")
     ELSE
        indim = 0
        IF(nids%nid_dim_nbeam.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nbeam,"dim_nbeam",ss%nbeam)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nbeam
        CALL define_var("ap_halfheight","R",indim,idims, &
               "aperture half-height", &
               "m","NBI","MACHINE_DESCRIPTION", &
               "R|units=m         ap_halfheight(nbeam)")
     ENDIF
  ENDIF

  iaddr = ps_shash_ap_halfwidth
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%ap_halfwidth).AND.ichange) THEN
     IF(cclist(ps_cnum_NBI).NE.1) THEN
        CALL ccwarn("ap_halfwidth","NBI")
     ELSE
        indim = 0
        IF(nids%nid_dim_nbeam.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nbeam,"dim_nbeam",ss%nbeam)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nbeam
        CALL define_var("ap_halfwidth","R",indim,idims, &
               "aperture half-width", &
               "m","NBI","MACHINE_DESCRIPTION", &
               "R|units=m         ap_halfwidth(nbeam)")
     ENDIF
  ENDIF

  iaddr = ps_shash_ap_horiz_offset
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%ap_horiz_offset).AND.ichange) THEN
     IF(cclist(ps_cnum_NBI).NE.1) THEN
        CALL ccwarn("ap_horiz_offset","NBI")
     ELSE
        indim = 0
        IF(nids%nid_dim_nbeam.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nbeam,"dim_nbeam",ss%nbeam)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nbeam
        CALL define_var("ap_horiz_offset","R",indim,idims, &
               "horizontal offset of aperture", &
               "m","NBI","MACHINE_DESCRIPTION", &
               "R|units=m         ap_horiz_offset(nbeam)")
     ENDIF
  ENDIF

  iaddr = ps_shash_ap_vert_offset
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%ap_vert_offset).AND.ichange) THEN
     IF(cclist(ps_cnum_NBI).NE.1) THEN
        CALL ccwarn("ap_vert_offset","NBI")
     ELSE
        indim = 0
        IF(nids%nid_dim_nbeam.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nbeam,"dim_nbeam",ss%nbeam)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nbeam
        CALL define_var("ap_vert_offset","R",indim,idims, &
               "vertical offset of aperture", &
               "m","NBI","MACHINE_DESCRIPTION", &
               "R|units=m         ap_vert_offset(nbeam)")
     ENDIF
  ENDIF

  iaddr = ps_phash_area
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%area).AND.ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("area","EQ")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_eq.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_eq,"dim_nrho_eq",ss%nrho_eq)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_eq
        CALL define_var("area","R",indim,idims, &
               "enclosed area", &
               "m^2","EQ","STATE_PROFILES", &
               "R|units=m^2|Spline_00 area(nrho_eq)")
     ENDIF
  ENDIF

  iaddr = ps_shash_atormaxlh
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%atormaxlh).AND.ichange) THEN
     IF(cclist(ps_cnum_LH).NE.1) THEN
        CALL ccwarn("atormaxlh","LH")
     ELSE
        indim = 0
        IF(nids%nid_dim_max_nspectrumlh_src.EQ.0) THEN
           CALL define_dim(nids%nid_dim_max_nspectrumlh_src,"dim_max_nspectrumlh_src",ss%max_nspectrumlh_src)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_max_nspectrumlh_src
        IF(nids%nid_dim_nlhrf_src.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nlhrf_src,"dim_nlhrf_src",ss%nlhrf_src)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nlhrf_src
        CALL define_var("atormaxlh","R",indim,idims, &
               "toroidal mode number right of lumps", &
               "-","LH","SHOT_CONFIGURATION", &
               "R|units=- atormaxlh(nspectrumlh_src(),nlhrf_src)")
     ENDIF
  ENDIF

  iaddr = ps_shash_atorminlh
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%atorminlh).AND.ichange) THEN
     IF(cclist(ps_cnum_LH).NE.1) THEN
        CALL ccwarn("atorminlh","LH")
     ELSE
        indim = 0
        IF(nids%nid_dim_max_nspectrumlh_src.EQ.0) THEN
           CALL define_dim(nids%nid_dim_max_nspectrumlh_src,"dim_max_nspectrumlh_src",ss%max_nspectrumlh_src)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_max_nspectrumlh_src
        IF(nids%nid_dim_nlhrf_src.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nlhrf_src,"dim_nlhrf_src",ss%nlhrf_src)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nlhrf_src
        CALL define_var("atorminlh","R",indim,idims, &
               "toroidal mode number left of lumps", &
               "-","LH","SHOT_CONFIGURATION", &
               "R|units=- atorminlh(nspectrumlh_src(),nlhrf_src)")
     ENDIF
  ENDIF

  iaddr = ps_dhash_nballoon
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%Balloon_code).AND.ichange) THEN
     IF(cclist(ps_cnum_LMHD).NE.1) THEN
        CALL ccwarn("Balloon_code","LMHD")
     ELSE
        indim = 1
        idims(1)=nids%nid_clen_32
        IF(nids%nid_dim_nballoon.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nballoon,"dim_nballoon",ss%nballoon)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nballoon
        CALL define_var("Balloon_code","N",indim,idims, &
               "name(s) of Ballooning code(s) used", &
               "__NONE","LMHD","SIMULATION_INIT", &
               "L|Balloon_codes  Balloon_code(nballoon)")
     ENDIF
  ENDIF

  iaddr = ps_shash_Balloon_mapper
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%Balloon_mapper).AND.ichange) THEN
     IF(cclist(ps_cnum_LMHD).NE.1) THEN
        CALL ccwarn("Balloon_mapper","LMHD")
     ELSE
        indim = 1
        idims(1)=nids%nid_clen_32
        IF(nids%nid_dim_nballoon.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nballoon,"dim_nballoon",ss%nballoon)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nballoon
        CALL define_var("Balloon_mapper","N",indim,idims, &
               "mapper code used for each ballooning code", &
               "__NONE","LMHD","SIMULATION_INIT", &
               "N  Balloon_mapper(nballoon)")
     ENDIF
  ENDIF

  iaddr = ps_shash_Balloon_stable
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%Balloon_stable).AND.ichange) THEN
     IF(cclist(ps_cnum_LMHD).NE.1) THEN
        CALL ccwarn("Balloon_stable","LMHD")
     ELSE
        indim = 0
        IF(nids%nid_dim_nballoon.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nballoon,"dim_nballoon",ss%nballoon)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nballoon
        CALL define_var("Balloon_stable","I",indim,idims, &
               "0: stable everywhere; =1: unstable somewhere", &
               "__NONE","LMHD","STATE_DATA", &
               "I   Balloon_stable(nballoon)")
     ENDIF
  ENDIF

  iaddr = ps_shash_Balloon_status
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%Balloon_status).AND.ichange) THEN
     IF(cclist(ps_cnum_LMHD).NE.1) THEN
        CALL ccwarn("Balloon_status","LMHD")
     ELSE
        indim = 0
        IF(nids%nid_dim_nballoon.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nballoon,"dim_nballoon",ss%nballoon)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nballoon
        CALL define_var("Balloon_status","I",indim,idims, &
               "completion status: Ballooning codes", &
               "__NONE","LMHD","STATE_DATA", &
               "I   Balloon_status(nballoon)")
     ENDIF
  ENDIF

  iaddr = ps_phash_balstab
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%balstab).AND.ichange) THEN
     IF(cclist(ps_cnum_LMHD).NE.1) THEN
        CALL ccwarn("balstab","LMHD")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_lmhd.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_lmhd,"dim_nrho_lmhd",ss%nrho_lmhd)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_lmhd
        CALL define_var("balstab","R",indim,idims, &
               "Ballooning/Mercier stability indicator", &
               "-","LMHD","STATE_PROFILES", &
               "R|units=-|pclin balstab(nrho_lmhd)")
     ENDIF
  ENDIF

  iaddr = ps_shash_beam_type
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%beam_type).AND.ichange) THEN
     IF(cclist(ps_cnum_NBI).NE.1) THEN
        CALL ccwarn("beam_type","NBI")
     ELSE
        indim = 1
        idims(1)=nids%nid_clen_32
        IF(nids%nid_dim_nbeam.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nbeam,"dim_nbeam",ss%nbeam)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nbeam
        CALL define_var("beam_type","N",indim,idims, &
               "beam type:", &
               "__NONE","NBI","MACHINE_DESCRIPTION", &
               "N     beam_type(nbeam)")
     ENDIF
  ENDIF

  iaddr = ps_phash_bidiff_bpass_co
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%bidiff_bpass_co).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("bidiff_bpass_co","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nefi_anom2.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nefi_anom2,"dim_nefi_anom2",ss%nefi_anom2)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nefi_anom2
        IF(nids%nid_dim_nrho_anom2.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anom2,"dim_nrho_anom2",ss%nrho_anom2)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anom2
        IF(nids%nid_dim_nspec_beam.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nspec_beam,"dim_nspec_beam",ss%nspec_beam)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nspec_beam
        CALL define_var("bidiff_bpass_co","R",indim,idims, &
               "beam ion diffusivity: co barely passing orbits", &
               "m^2/sec","ANOM","STATE_PROFILES", &
               "R|units=m^2/sec|pclin  bidiff_bpass_co(nefi_anom2,nrho_anom2,nspec_beam)")
     ENDIF
  ENDIF

  iaddr = ps_phash_bidiff_bpass_ctr
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%bidiff_bpass_ctr).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("bidiff_bpass_ctr","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nefi_anom2.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nefi_anom2,"dim_nefi_anom2",ss%nefi_anom2)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nefi_anom2
        IF(nids%nid_dim_nrho_anom2.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anom2,"dim_nrho_anom2",ss%nrho_anom2)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anom2
        IF(nids%nid_dim_nspec_beam.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nspec_beam,"dim_nspec_beam",ss%nspec_beam)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nspec_beam
        CALL define_var("bidiff_bpass_ctr","R",indim,idims, &
               "beam ion diffusivity: ctr barely passing orbits", &
               "m^2/sec","ANOM","STATE_PROFILES", &
               "R|units=m^2/sec|pclin  bidiff_bpass_ctr(nefi_anom2,nrho_anom2,nspec_beam)")
     ENDIF
  ENDIF

  iaddr = ps_phash_bidiff_btrap
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%bidiff_btrap).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("bidiff_btrap","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nefi_anom2.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nefi_anom2,"dim_nefi_anom2",ss%nefi_anom2)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nefi_anom2
        IF(nids%nid_dim_nrho_anom2.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anom2,"dim_nrho_anom2",ss%nrho_anom2)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anom2
        IF(nids%nid_dim_nspec_beam.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nspec_beam,"dim_nspec_beam",ss%nspec_beam)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nspec_beam
        CALL define_var("bidiff_btrap","R",indim,idims, &
               "beam ion diffusivity: barely trapped orbits", &
               "m^2/sec","ANOM","STATE_PROFILES", &
               "R|units=m^2/sec|pclin  bidiff_btrap(nefi_anom2,nrho_anom2,nspec_beam)")
     ENDIF
  ENDIF

  iaddr = ps_phash_bidiff_dpass_co
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%bidiff_dpass_co).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("bidiff_dpass_co","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nefi_anom2.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nefi_anom2,"dim_nefi_anom2",ss%nefi_anom2)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nefi_anom2
        IF(nids%nid_dim_nrho_anom2.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anom2,"dim_nrho_anom2",ss%nrho_anom2)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anom2
        IF(nids%nid_dim_nspec_beam.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nspec_beam,"dim_nspec_beam",ss%nspec_beam)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nspec_beam
        CALL define_var("bidiff_dpass_co","R",indim,idims, &
               "beam ion diffusivity: co passing |vpll/v| -> 1", &
               "m^2/sec","ANOM","STATE_PROFILES", &
               "R|units=m^2/sec|pclin  bidiff_dpass_co(nefi_anom2,nrho_anom2,nspec_beam)")
     ENDIF
  ENDIF

  iaddr = ps_phash_bidiff_dpass_ctr
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%bidiff_dpass_ctr).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("bidiff_dpass_ctr","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nefi_anom2.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nefi_anom2,"dim_nefi_anom2",ss%nefi_anom2)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nefi_anom2
        IF(nids%nid_dim_nrho_anom2.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anom2,"dim_nrho_anom2",ss%nrho_anom2)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anom2
        IF(nids%nid_dim_nspec_beam.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nspec_beam,"dim_nspec_beam",ss%nspec_beam)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nspec_beam
        CALL define_var("bidiff_dpass_ctr","R",indim,idims, &
               "beam ion diffusivity: ctr passing |vpll/v| -> 1", &
               "m^2/sec","ANOM","STATE_PROFILES", &
               "R|units=m^2/sec|pclin  bidiff_dpass_ctr(nefi_anom2,nrho_anom2,nspec_beam)")
     ENDIF
  ENDIF

  iaddr = ps_phash_bidiff_dtrap
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%bidiff_dtrap).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("bidiff_dtrap","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nefi_anom2.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nefi_anom2,"dim_nefi_anom2",ss%nefi_anom2)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nefi_anom2
        IF(nids%nid_dim_nrho_anom2.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anom2,"dim_nrho_anom2",ss%nrho_anom2)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anom2
        IF(nids%nid_dim_nspec_beam.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nspec_beam,"dim_nspec_beam",ss%nspec_beam)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nspec_beam
        CALL define_var("bidiff_dtrap","R",indim,idims, &
               "beam ion diffusivity: deeply trapped orbits", &
               "m^2/sec","ANOM","STATE_PROFILES", &
               "R|units=m^2/sec|pclin  bidiff_dtrap(nefi_anom2,nrho_anom2,nspec_beam)")
     ENDIF
  ENDIF

  iaddr = ps_phash_BphiRZ
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%BphiRZ).AND.ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("BphiRZ","EQ")
     ELSE
        indim = 0
        IF(nids%nid_dim_nr.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nr,"dim_nr",ss%nr)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nr
        IF(nids%nid_dim_nz.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nz,"dim_nz",ss%nz)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nz
        CALL define_var("BphiRZ","R",indim,idims, &
               "Toroidal field", &
               "T","EQ","STATE_PROFILES", &
               "R|units=T|Hermite      BphiRZ(nR,nZ)")
     ENDIF
  ENDIF

  iaddr = ps_phash_BRRZ
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%BRRZ).AND.ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("BRRZ","EQ")
     ELSE
        indim = 0
        IF(nids%nid_dim_nr.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nr,"dim_nr",ss%nr)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nr
        IF(nids%nid_dim_nz.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nz,"dim_nz",ss%nz)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nz
        CALL define_var("BRRZ","R",indim,idims, &
               "R component of poloidal field", &
               "T","EQ","STATE_PROFILES", &
               "R|units=T|Hermite      BRRZ(nR,nZ)")
     ENDIF
  ENDIF

  iaddr = ps_phash_BZRZ
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%BZRZ).AND.ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("BZRZ","EQ")
     ELSE
        indim = 0
        IF(nids%nid_dim_nr.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nr,"dim_nr",ss%nr)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nr
        IF(nids%nid_dim_nz.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nz,"dim_nz",ss%nz)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nz
        CALL define_var("BZRZ","R",indim,idims, &
               "Z component of poloidal field", &
               "T","EQ","STATE_PROFILES", &
               "R|units=T|Hermite      BZRZ(nR,nZ)")
     ENDIF
  ENDIF

  iaddr = ps_shash_B_axis
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("B_axis","EQ")
     ELSE
        indim = 0
        CALL define_var("B_axis","R",indim,idims, &
               "|B| at magnetic axis", &
               "T","EQ","STATE_DATA", &
               "R  B_axis")
     ENDIF
  ENDIF

  iaddr = ps_shash_B_axis_vac
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("B_axis_vac","EQ")
     ELSE
        indim = 0
        CALL define_var("B_axis_vac","R",indim,idims, &
               "vacuum B field at axis", &
               "T","EQ","STATE_DATA", &
               "R  B_axis_vac")
     ENDIF
  ENDIF

  iaddr = ps_shash_b_halfHeight
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%b_halfHeight).AND.ichange) THEN
     IF(cclist(ps_cnum_NBI).NE.1) THEN
        CALL ccwarn("b_halfHeight","NBI")
     ELSE
        indim = 0
        IF(nids%nid_dim_nbeam.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nbeam,"dim_nbeam",ss%nbeam)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nbeam
        CALL define_var("b_halfHeight","R",indim,idims, &
               "beam half-height at source", &
               "m","NBI","MACHINE_DESCRIPTION", &
               "R|units=m       b_halfHeight(nbeam)")
     ENDIF
  ENDIF

  iaddr = ps_shash_b_halfwidth
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%b_halfwidth).AND.ichange) THEN
     IF(cclist(ps_cnum_NBI).NE.1) THEN
        CALL ccwarn("b_halfwidth","NBI")
     ELSE
        indim = 0
        IF(nids%nid_dim_nbeam.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nbeam,"dim_nbeam",ss%nbeam)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nbeam
        CALL define_var("b_halfwidth","R",indim,idims, &
               "beam half-width at source", &
               "m","NBI","MACHINE_DESCRIPTION", &
               "R|units=m       b_halfwidth(nbeam)")
     ENDIF
  ENDIF

  iaddr = ps_shash_b_Hdivergence
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%b_Hdivergence).AND.ichange) THEN
     IF(cclist(ps_cnum_NBI).NE.1) THEN
        CALL ccwarn("b_Hdivergence","NBI")
     ELSE
        indim = 0
        IF(nids%nid_dim_nbeam.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nbeam,"dim_nbeam",ss%nbeam)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nbeam
        CALL define_var("b_Hdivergence","R",indim,idims, &
               "horizontal divergence (D) of beam", &
               "degrees","NBI","MACHINE_DESCRIPTION", &
               "R|units=degrees   b_Hdivergence(nbeam)")
     ENDIF
  ENDIF

  iaddr = ps_shash_b_Hfocal_length
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%b_Hfocal_length).AND.ichange) THEN
     IF(cclist(ps_cnum_NBI).NE.1) THEN
        CALL ccwarn("b_Hfocal_length","NBI")
     ELSE
        indim = 0
        IF(nids%nid_dim_nbeam.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nbeam,"dim_nbeam",ss%nbeam)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nbeam
        CALL define_var("b_Hfocal_length","R",indim,idims, &
               "horizontal focal length", &
               "m","NBI","MACHINE_DESCRIPTION", &
               "R|units=m       b_Hfocal_length(nbeam)")
     ENDIF
  ENDIF

  iaddr = ps_shash_B_max_lcfs
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("B_max_lcfs","EQ")
     ELSE
        indim = 0
        CALL define_var("B_max_lcfs","R",indim,idims, &
               "|B|_max of last closed flux surface", &
               "T","EQ","STATE_DATA", &
               "R  B_max_lcfs")
     ENDIF
  ENDIF

  iaddr = ps_shash_B_min_lcfs
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("B_min_lcfs","EQ")
     ELSE
        indim = 0
        CALL define_var("B_min_lcfs","R",indim,idims, &
               "|B|_min of last closed flux surface", &
               "T","EQ","STATE_DATA", &
               "R  B_min_lcfs")
     ENDIF
  ENDIF

  iaddr = ps_phash_B_surfMax
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%B_surfMax).AND.ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("B_surfMax","EQ")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_eq_geo.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_eq_geo,"dim_nrho_eq_geo",ss%nrho_eq_geo)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_eq_geo
        CALL define_var("B_surfMax","R",indim,idims, &
               "max mod(B) on flux surface", &
               "T","EQ","STATE_PROFILES", &
               "R|pclin  B_surfMax(nrho_eq_geo)")
     ENDIF
  ENDIF

  iaddr = ps_phash_B_surfMin
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%B_surfMin).AND.ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("B_surfMin","EQ")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_eq_geo.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_eq_geo,"dim_nrho_eq_geo",ss%nrho_eq_geo)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_eq_geo
        CALL define_var("B_surfMin","R",indim,idims, &
               "min mod(B) on flux surface", &
               "T","EQ","STATE_PROFILES", &
               "R|pclin  B_surfMin(nrho_eq_geo)")
     ENDIF
  ENDIF

  iaddr = ps_shash_b_Vdivergence
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%b_Vdivergence).AND.ichange) THEN
     IF(cclist(ps_cnum_NBI).NE.1) THEN
        CALL ccwarn("b_Vdivergence","NBI")
     ELSE
        indim = 0
        IF(nids%nid_dim_nbeam.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nbeam,"dim_nbeam",ss%nbeam)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nbeam
        CALL define_var("b_Vdivergence","R",indim,idims, &
               "vertical divergence (D) of beam", &
               "degrees","NBI","MACHINE_DESCRIPTION", &
               "R|units=degrees   b_Vdivergence(nbeam)")
     ENDIF
  ENDIF

  iaddr = ps_shash_b_Vfocal_length
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%b_Vfocal_length).AND.ichange) THEN
     IF(cclist(ps_cnum_NBI).NE.1) THEN
        CALL ccwarn("b_Vfocal_length","NBI")
     ELSE
        indim = 0
        IF(nids%nid_dim_nbeam.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nbeam,"dim_nbeam",ss%nbeam)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nbeam
        CALL define_var("b_Vfocal_length","R",indim,idims, &
               "vertical focal length", &
               "m","NBI","MACHINE_DESCRIPTION", &
               "R|units=m       b_Vfocal_length(nbeam)")
     ENDIF
  ENDIF

  iaddr = ps_phash_cdicrf
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%cdicrf).AND.ichange) THEN
     IF(cclist(ps_cnum_IC).NE.1) THEN
        CALL ccwarn("cdicrf","IC")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_icrf.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_icrf,"dm1_nrho_icrf",ss%nrho_icrf-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_icrf
        IF(nids%nid_dim_nicrf_src.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nicrf_src,"dim_nicrf_src",ss%nicrf_src)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nicrf_src
        CALL define_var("cdicrf","R",indim,idims, &
               "ICRF current drive", &
               "A","IC","STATE_PROFILES", &
               "R|units=A|step*dA   cdicrf(~nrho_icrf,nicrf_src)")
     ENDIF
  ENDIF

  iaddr = ps_phash_cdicrf_nphi
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%cdicrf_nphi).AND.ichange) THEN
     IF(cclist(ps_cnum_IC).NE.1) THEN
        CALL ccwarn("cdicrf_nphi","IC")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_icrf.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_icrf,"dm1_nrho_icrf",ss%nrho_icrf-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_icrf
        IF(nids%nid_dim_max_num_nphi.EQ.0) THEN
           CALL define_dim(nids%nid_dim_max_num_nphi,"dim_max_num_nphi",ss%max_num_nphi)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_max_num_nphi
        IF(nids%nid_dim_nicrf_src.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nicrf_src,"dim_nicrf_src",ss%nicrf_src)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nicrf_src
        CALL define_var("cdicrf_nphi","R",indim,idims, &
               "ICRF current drive", &
               "A","IC","STATE_PROFILES", &
               "R|units=A|step*dA   cdicrf_nphi(~nrho_icrf,num_nphi(),nicrf_src)")
     ENDIF
  ENDIF

  iaddr = ps_phash_chie_anom
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%chie_anom).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("chie_anom","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        CALL define_var("chie_anom","R",indim,idims, &
               "Te-equation, diffusivity term", &
               "m^2/sec","ANOM","STATE_PROFILES", &
               "R|units=m^2/sec|pclin  chie_anom(nrho_anomth)")
     ENDIF
  ENDIF

  iaddr = ps_phash_chie_drbm
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%chie_drbm).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("chie_drbm","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        CALL define_var("chie_drbm","R",indim,idims, &
               "Te-equation, diffusivity term", &
               "m^2/sec","ANOM","STATE_PROFILES", &
               "R|units=m^2/sec|pclin  chie_drbm(nrho_anomth)")
     ENDIF
  ENDIF

  iaddr = ps_phash_chie_etg
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%chie_etg).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("chie_etg","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        CALL define_var("chie_etg","R",indim,idims, &
               "Te-equation, diffusivity term ETG model", &
               "m^2/sec","ANOM","STATE_PROFILES", &
               "R|units=m^2/sec|pclin chie_etg(nrho_anomth)")
     ENDIF
  ENDIF

  iaddr = ps_phash_chie_glf
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%chie_glf).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("chie_glf","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        CALL define_var("chie_glf","R",indim,idims, &
               "Te-equation, diffusivity from GLF23 model", &
               "m^2/s","ANOM","STATE_PROFILES", &
               "R|units=m^2/s|pclin chie_glf(nrho_anomth)")
     ENDIF
  ENDIF

  iaddr = ps_phash_chie_gtcneo
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%chie_gtcneo).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("chie_gtcneo","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        CALL define_var("chie_gtcneo","R",indim,idims, &
               "Te-equation, neoclassical diffusivity from GTC_NEO model", &
               "m^2/s","ANOM","STATE_PROFILES", &
               "R|units=m^2/s|pclin chie_gtcneo(nrho_anomth)")
     ENDIF
  ENDIF

  iaddr = ps_phash_chie_mmm71
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%chie_mmm71).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("chie_mmm71","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        CALL define_var("chie_mmm71","R",indim,idims, &
               "Te-equation, diffusivity term", &
               "m^2/sec","ANOM","STATE_PROFILES", &
               "R|units=m^2/sec|pclin  chie_mmm71(nrho_anomth)")
     ENDIF
  ENDIF

  iaddr = ps_phash_chie_mtm
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%chie_mtm).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("chie_mtm","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        CALL define_var("chie_mtm","R",indim,idims, &
               "Te-equation, thermal diffusivity term MTM model", &
               "m^2/sec","ANOM","STATE_PROFILES", &
               "R|units=m^2/sec|pclin chie_mtm(nrho_anomth)")
     ENDIF
  ENDIF

  iaddr = ps_phash_chie_nclass
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%chie_nclass).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("chie_nclass","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        CALL define_var("chie_nclass","R",indim,idims, &
               "Te-equation, neoclassical diffusivity from NCLASS model", &
               "m^2/s","ANOM","STATE_PROFILES", &
               "R|units=m^2/s|pclin chie_nclass(nrho_anomth)")
     ENDIF
  ENDIF

  iaddr = ps_phash_chie_neo
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%chie_neo).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("chie_neo","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        CALL define_var("chie_neo","R",indim,idims, &
               "Te-equation, neoclassical diffusivity from NEO model", &
               "m^2/s","ANOM","STATE_PROFILES", &
               "R|units=m^2/s|pclin chie_neo(nrho_anomth)")
     ENDIF
  ENDIF

  iaddr = ps_phash_chie_ntm
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%chie_ntm).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("chie_ntm","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        CALL define_var("chie_ntm","R",indim,idims, &
               "Te-equation, neoclassical diffusivity from NTM model", &
               "m^2/s","ANOM","STATE_PROFILES", &
               "R|units=m^2/s|pclin chie_ntm(nrho_anomth)")
     ENDIF
  ENDIF

  iaddr = ps_phash_chie_paleo
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%chie_paleo).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("chie_paleo","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        CALL define_var("chie_paleo","R",indim,idims, &
               "Te-equation, diffusivity term PALEO model", &
               "m^2/sec","ANOM","STATE_PROFILES", &
               "R|units=m^2/sec|pclin chie_paleo(nrho_anomth)")
     ENDIF
  ENDIF

  iaddr = ps_phash_chie_tglf
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%chie_tglf).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("chie_tglf","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        CALL define_var("chie_tglf","R",indim,idims, &
               "Te-equation, diffusivity from TGLF model", &
               "m^2/s","ANOM","STATE_PROFILES", &
               "R|units=m^2/s|pclin chie_tglf(nrho_anomth)")
     ENDIF
  ENDIF

  iaddr = ps_phash_chie_trans
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%chie_trans).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("chie_trans","PLASMA")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho,"dim_nrho",ss%nrho)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho
        CALL define_var("chie_trans","R",indim,idims, &
               "electron thermal diffusivity", &
               "m^2/sec","PLASMA","STATE_PROFILES", &
               "R|pclin chie_trans(nrho)")
     ENDIF
  ENDIF

  iaddr = ps_phash_chie_transcat
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%chie_transcat).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("chie_transcat","PLASMA")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho,"dim_nrho",ss%nrho)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho
        IF(nids%nid_dim_ntrcat.EQ.0) THEN
           CALL define_dim(nids%nid_dim_ntrcat,"dim_ntrcat",ss%ntrcat)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_ntrcat
        CALL define_var("chie_transcat","R",indim,idims, &
               "Electron energy diffusivity", &
               "m^2/sec","PLASMA","STATE_PROFILES", &
               "R|units=m^2/sec|pclin chie_transcat(nrho,ntrcat)")
     ENDIF
  ENDIF

  iaddr = ps_phash_chie_w19
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%chie_w19).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("chie_w19","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        CALL define_var("chie_w19","R",indim,idims, &
               "Te-equation, diffusivity term", &
               "m^2/sec","ANOM","STATE_PROFILES", &
               "R|units=m^2/sec|pclin  chie_w19(nrho_anomth)")
     ENDIF
  ENDIF

  iaddr = ps_phash_chii_anom
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%chii_anom).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("chii_anom","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        CALL define_var("chii_anom","R",indim,idims, &
               "Ti-equation, diffusivity term", &
               "m^2/sec","ANOM","STATE_PROFILES", &
               "R|units=m^2/sec|pclin  chii_anom(nrho_anomth)")
     ENDIF
  ENDIF

  iaddr = ps_phash_chii_drbm
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%chii_drbm).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("chii_drbm","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        CALL define_var("chii_drbm","R",indim,idims, &
               "Ti-equation, diffusivity term", &
               "m^2/sec","ANOM","STATE_PROFILES", &
               "R|units=m^2/sec|pclin  chii_drbm(nrho_anomth)")
     ENDIF
  ENDIF

  iaddr = ps_phash_chii_glf
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%chii_glf).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("chii_glf","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        CALL define_var("chii_glf","R",indim,idims, &
               "Ti-equation, diffusivity from GLF23 model", &
               "m^2/s","ANOM","STATE_PROFILES", &
               "R|units=m^2/s|pclin chii_glf(nrho_anomth)")
     ENDIF
  ENDIF

  iaddr = ps_phash_chii_gtcneo
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%chii_gtcneo).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("chii_gtcneo","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        CALL define_var("chii_gtcneo","R",indim,idims, &
               "Ti-equation, neoclassical diffusivity from GTC_NEO model", &
               "m^2/s","ANOM","STATE_PROFILES", &
               "R|units=m^2/s|pclin chii_gtcneo(nrho_anomth)")
     ENDIF
  ENDIF

  iaddr = ps_phash_chii_mmm71
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%chii_mmm71).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("chii_mmm71","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        CALL define_var("chii_mmm71","R",indim,idims, &
               "Ti-equation, diffusivity term", &
               "m^2/sec","ANOM","STATE_PROFILES", &
               "R|units=m^2/sec|pclin  chii_mmm71(nrho_anomth)")
     ENDIF
  ENDIF

  iaddr = ps_phash_chii_nclass
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%chii_nclass).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("chii_nclass","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        CALL define_var("chii_nclass","R",indim,idims, &
               "Ti-equation, neoclassical diffusivity from NCALSS model", &
               "m^2/s","ANOM","STATE_PROFILES", &
               "R|units=m^2/s|pclin chii_nclass(nrho_anomth)")
     ENDIF
  ENDIF

  iaddr = ps_phash_chii_neo
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%chii_neo).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("chii_neo","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        CALL define_var("chii_neo","R",indim,idims, &
               "Ti-equation, neoclassical diffusivity from NEO model", &
               "m^2/s","ANOM","STATE_PROFILES", &
               "R|units=m^2/s|pclin chii_neo(nrho_anomth)")
     ENDIF
  ENDIF
  CONTAINS


     SUBROUTINE define_dim(dimid,dname,idval)
        INTEGER, intent(out) :: dimid
        CHARACTER*(*), INTENT(in) :: dname
        INTEGER, intent(in) :: idval

        status = nf90_def_dim(icdf,dname,idval,dimid)
        IF(status.NE.NF90_NOERR) THEN
           WRITE(iout,*) ' ?ps_update_file_write: error defining dimension "'// &
                 trim(dname)//'".'
           IERR=9999
        ENDIF
     END SUBROUTINE define_dim



     SUBROUTINE define_var(name,dtype,indim,idims, &
          long_name,units,component,section,spec)

        CHARACTER*(*), INTENT(in) :: name
        CHARACTER*(*), INTENT(in) :: dtype
        INTEGER, INTENT(in) :: indim
        INTEGER, dimension(:), INTENT(in) :: idims
        CHARACTER*(*), INTENT(in) :: long_name
        CHARACTER*(*), INTENT(in) :: units
        CHARACTER*(*), INTENT(in) :: component
        CHARACTER*(*), INTENT(in) :: section
        CHARACTER*(*), INTENT(in) :: spec

        integer :: itype

        IF(dtype.EQ.'R') THEN
           itype = NF90_DOUBLE

        ELSE IF (dtype.EQ.'I') THEN
           itype = NF90_INT

        ELSE
           itype = NF90_CHAR

        ENDIF

        IF(indim.EQ.0) THEN
           status=nf90_def_var(icdf,name,itype, varid=varid)

        ELSE
           status=nf90_def_var(icdf,name,itype, dimids=idims(1:indim),varid=varid)

        ENDIF

        IF(status.NE.NF90_NOERR) THEN
           WRITE(iout,*) " ?plasma_state_store: error defining variable: "//trim(name)
           CALL ncerr(status)
           iertot = iertot + 1
           RETURN
        ENDIF

        ! Variable OK, now add attributes:

        CALL add_attrib("long_name",long_name)
        IF(dtype.EQ.'R') CALL add_attrib("units",units)
        CALL add_attrib("component",component)
        CALL add_attrib("section",section)
        CALL add_attrib("specification",spec)

     END SUBROUTINE define_var

     SUBROUTINE add_attrib(name,value)
        CHARACTER*(*), intent(in) :: name
        CHARACTER*(*), intent(in) :: value

        status=nf90_put_att(icdf,varid,name,value)
        IF(status.NE.NF90_NOERR) THEN
           WRITE(iout,*) " ?plasma_state_store: error defining attribute: "//trim(name)//' = '//trim(value)
           CALL ncerr(status)
           iertot = iertot + 1
        ENDIF
     END SUBROUTINE add_attrib



     SUBROUTINE ncerr(status)
        INTEGER, INTENT(in) :: status

        nc_errmsg = NF90_strerror(status)
        write(iout,*) '  NetCDF message: ',trim(nc_errmsg)
     END SUBROUTINE ncerr



     SUBROUTINE ccwarn(varnam,compnam)

        CHARACTER*(*), intent(in) :: varnam   ! name of variable or array
        CHARACTER*(*), intent(in) :: compnam  ! name of component

        if(iwarn.eq.0) then
           write(iout,*) ' '
           write(iout,*) ' %ps_update_file_write: modified state elements'
           write(iout,*) '  exist which were not written due to the "cclist"'
           write(iout,*) '  input variable which screens out elements from'
           write(iout,*) '  selected components: cclist = ',cclist,';'
           write(iout,*) '  element values of 1 indicate components that are'
           write(iout,*) '  enabled for write.'
           write(iout,*) ' '
        endif

        iwarn = iwarn + 1

        write(iout,*) ' %ps_update_file_write: modified: ss%'// &
             trim(varnam)//' ('//trim(compnam)//' component) NOT WRITTEN.'

     END SUBROUTINE ccwarn

END SUBROUTINE ps_update_file_write_def_0

SUBROUTINE ps_update_file_write_0(ss,icdf,cclist,iucount,iout,iwarn,iertot)


  ! Write updated data

  USE plasma_state_definition_mod
  USE netcdf
  IMPLICIT NONE

  TYPE (plasma_state) :: ss  ! state containing array elements to be allocated
  INTEGER, INTENT(IN) :: icdf  ! NetCDF file ID
  INTEGER, INTENT(IN) :: cclist(ps_ccount)  ! component selection
  INTEGER, INTENT(INOUT) :: iucount ! update count
  INTEGER, INTENT(IN) :: iout  ! LUN for messages
  INTEGER, INTENT(INOUT) :: iwarn   ! warn count
  INTEGER, INTENT(INOUT) :: iertot  ! error count

  !-------------------

  INTEGER :: varid,status
  CHARACTER*80 :: nc_errmsg

  !-------------------


  status = nf90_inq_varid(icdf,"alla_index",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%alla_index)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: alla_index"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"ALLA_name",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%ALLA_name)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: ALLA_name"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"ALLA_type",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%ALLA_type)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: ALLA_type"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"all_index",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%all_index)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: all_index"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"ALL_name",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%ALL_name)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: ALL_name"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"ALL_type",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%ALL_type)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: ALL_type"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"amaxlh",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%amaxlh)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: amaxlh"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"aminlh",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%aminlh)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: aminlh"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Ang_Href_coil",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%Ang_Href_coil)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: Ang_Href_coil"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Ang_Vref_coil",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%Ang_Vref_coil)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: Ang_Vref_coil"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"ANOM_Code_Info",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%ANOM_Code_Info)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: ANOM_Code_Info"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"anom_evar",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%anom_evar)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: anom_evar"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"ant_model",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%ant_model)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: ant_model"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"ap2_halfheight",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%ap2_halfheight)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: ap2_halfheight"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"ap2_halfwidth",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%ap2_halfwidth)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: ap2_halfwidth"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"ap2_horiz_offset",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%ap2_horiz_offset)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: ap2_horiz_offset"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"ap2_vert_offset",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%ap2_vert_offset)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: ap2_vert_offset"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"apolmaxlh",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%apolmaxlh)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: apolmaxlh"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"apolminlh",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%apolminlh)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: apolminlh"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"ap_halfheight",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%ap_halfheight)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: ap_halfheight"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"ap_halfwidth",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%ap_halfwidth)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: ap_halfwidth"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"ap_horiz_offset",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%ap_horiz_offset)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: ap_horiz_offset"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"ap_vert_offset",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%ap_vert_offset)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: ap_vert_offset"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"area",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%area)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: area"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"atormaxlh",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%atormaxlh)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: atormaxlh"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"atorminlh",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%atorminlh)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: atorminlh"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Balloon_code",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%Balloon_code)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: Balloon_code"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Balloon_mapper",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%Balloon_mapper)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: Balloon_mapper"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Balloon_stable",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%Balloon_stable)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: Balloon_stable"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Balloon_status",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%Balloon_status)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: Balloon_status"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"balstab",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%balstab)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: balstab"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"beam_type",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%beam_type)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: beam_type"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"bidiff_bpass_co",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%bidiff_bpass_co)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: bidiff_bpass_co"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"bidiff_bpass_ctr",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%bidiff_bpass_ctr)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: bidiff_bpass_ctr"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"bidiff_btrap",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%bidiff_btrap)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: bidiff_btrap"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"bidiff_dpass_co",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%bidiff_dpass_co)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: bidiff_dpass_co"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"bidiff_dpass_ctr",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%bidiff_dpass_ctr)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: bidiff_dpass_ctr"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"bidiff_dtrap",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%bidiff_dtrap)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: bidiff_dtrap"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"BphiRZ",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%BphiRZ)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: BphiRZ"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"BRRZ",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%BRRZ)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: BRRZ"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"BZRZ",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%BZRZ)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: BZRZ"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"B_axis",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%B_axis)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: B_axis"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"B_axis_vac",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%B_axis_vac)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: B_axis_vac"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"b_halfHeight",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%b_halfHeight)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: b_halfHeight"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"b_halfwidth",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%b_halfwidth)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: b_halfwidth"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"b_Hdivergence",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%b_Hdivergence)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: b_Hdivergence"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"b_Hfocal_length",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%b_Hfocal_length)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: b_Hfocal_length"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"B_max_lcfs",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%B_max_lcfs)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: B_max_lcfs"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"B_min_lcfs",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%B_min_lcfs)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: B_min_lcfs"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"B_surfMax",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%B_surfMax)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: B_surfMax"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"B_surfMin",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%B_surfMin)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: B_surfMin"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"b_Vdivergence",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%b_Vdivergence)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: b_Vdivergence"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"b_Vfocal_length",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%b_Vfocal_length)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: b_Vfocal_length"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"cdicrf",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%cdicrf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: cdicrf"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"cdicrf_nphi",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%cdicrf_nphi)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: cdicrf_nphi"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"chie_anom",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%chie_anom)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: chie_anom"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"chie_drbm",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%chie_drbm)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: chie_drbm"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"chie_etg",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%chie_etg)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: chie_etg"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"chie_glf",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%chie_glf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: chie_glf"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"chie_gtcneo",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%chie_gtcneo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: chie_gtcneo"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"chie_mmm71",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%chie_mmm71)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: chie_mmm71"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"chie_mtm",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%chie_mtm)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: chie_mtm"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"chie_nclass",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%chie_nclass)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: chie_nclass"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"chie_neo",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%chie_neo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: chie_neo"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"chie_ntm",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%chie_ntm)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: chie_ntm"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"chie_paleo",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%chie_paleo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: chie_paleo"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"chie_tglf",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%chie_tglf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: chie_tglf"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"chie_trans",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%chie_trans)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: chie_trans"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"chie_transcat",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%chie_transcat)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: chie_transcat"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"chie_w19",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%chie_w19)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: chie_w19"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"chii_anom",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%chii_anom)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: chii_anom"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"chii_drbm",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%chii_drbm)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: chii_drbm"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"chii_glf",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%chii_glf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: chii_glf"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"chii_gtcneo",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%chii_gtcneo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: chii_gtcneo"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"chii_mmm71",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%chii_mmm71)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: chii_mmm71"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"chii_nclass",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%chii_nclass)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: chii_nclass"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"chii_neo",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%chii_neo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: chii_neo"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF
  CONTAINS


     SUBROUTINE ncerr(status)
        INTEGER, INTENT(in) :: status

        nc_errmsg = NF90_strerror(status)
        write(iout,*) '  NetCDF message: ',trim(nc_errmsg)
     END SUBROUTINE ncerr

END SUBROUTINE ps_update_file_write_0

subroutine ps_getlabel(ps,id,label,units,author,iout,ierr)

  !  retrieve labeling information on a profile
  !  DMC 3 Jan 2007

  !------------------------------------------------------------

  use plasma_state_xpobj  ! XPLASMA2 state object definitions

  use plasma_state_definition_mod

  implicit NONE

  !-----------------------
  !  passed:

  type (plasma_state) :: ps       ! plasma state object
  integer, intent(in) :: id       ! ID of profile for which label info needed

  character*(*), intent(out) :: label
  character*(*), intent(out) :: units
  character*(*), intent(out) :: author

  integer, intent(in) :: iout     ! Fortran LUN for messages
  integer, intent(out) :: ierr    ! exit status code 0=OK

  !-----------------------
  !  local:
  type (interp_object) :: xobj
  type (xplasma), pointer :: s

  !-----------------------
  ! executable code...

  call ps_tagchk('ps_getLabel',ps%itag,iout,ierr)
  if(ierr.ne.0) then
     label=' '
     units=' '
     author=' '
     return
  endif

  xobj = transfer(ps%iobj,xobj)
  s => xobj%s_xpobj

  call xplasma_prof_info(s,id,ierr, &
       label=label,units=units,author=author)

  if(ierr.ne.0) then
     label=' '
     units=' '
     author=' '
     write(iout,*) ' ?xplasma2 error in ps_getlabel:'
     call xplasma_error(s,ierr,iout)
  endif

end subroutine ps_getlabel

subroutine cstate_chk_locks(luntty)

  ! print a table showing lock status of init sections of states
  ! (machine description, etc).

  use cstate_lib_mod
  implicit NONE

  integer, intent(in) :: luntty   ! LUN on which to write the table

  integer, parameter :: num_init_sects = 3
  character*32 :: init_sects(num_init_sects)
  character*8 :: lockstat(nsss_cur,num_init_sects)

  !-------------------------
  ! local

  integer :: ii,jj,ia,ilen_coln(0:nsss_cur),ia_coln(0:nsss_cur)

  character*256 :: hdr,rln,buf

  !-------------------------

  init_sects(1)='MACHINE_DESCRIPTION'
  init_sects(2)='SHOT_CONFIGURATION'
  init_sects(3)='SIMULATION_INIT'

  ia_coln(0)=1
  ilen_coln(0)=11          ! min length: enough for string "Lock Status".

  ilen_coln(1:nsss_cur)=8  ! min length: enough for string "unlocked".

  do ii=1,num_init_sects
     ilen_coln(0)=max(ilen_coln(0),len(trim(init_sects(ii))))
  enddo

  ilen_coln(0) = ilen_coln(0) + 1  ! pad 1st column by 1 space

  do ii=1,nsss_cur
     ilen_coln(ii)=max(ilen_coln(ii),len(trim(sss_label(ii))))
     ia_coln(ii)=ia_coln(ii-1) + ilen_coln(ii-1) + 1
     if(sss(ii)%lock_machine_descr.eq.ps_locked) then
        lockstat(ii,1)='LOCKED'
     else
        lockstat(ii,1)='unlocked'
     endif

     if(sss(ii)%lock_shot_config.eq.ps_locked) then
        lockstat(ii,2)='LOCKED'
     else
        lockstat(ii,2)='unlocked'
     endif

     if(sss(ii)%lock_sim_init.eq.ps_locked) then
        lockstat(ii,3)='LOCKED'
     else
        lockstat(ii,3)='unlocked'
     endif
  enddo

  hdr = 'Lock Status'
  rln = rline(1:ilen_coln(0))
  do ii=1,nsss_cur
     ia=ia_coln(ii)
     hdr(ia:)=trim(sss_label(ii))
     rln(ia:)=rline(1:ilen_coln(ii))
  enddo

  write(luntty,*) ' '
  write(luntty,*) trim(hdr)
  write(luntty,*) trim(rln)

  do jj=1,num_init_sects
     buf = init_sects(jj)
     do ii=1,nsss_cur
        ia=ia_coln(ii)
        buf(ia:)=lockstat(ii,jj)
     enddo
     write(luntty,*) trim(buf)
  enddo

  write(luntty,*) ' '

end subroutine cstate_chk_locks

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_n4_dummy
     return
  end subroutine ccps_getset_n4_dummy

subroutine psget_nbeam(iobj, data, ierr)
    !! item list dimension of nbi_src_name (neutral_beams)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_nbeam', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % nbeam
end subroutine psget_nbeam


subroutine psset_nbeam(iobj, data, ierr)
    !! item list dimension of nbi_src_name (neutral_beams)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_nbeam', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % nbeam = data
end subroutine psset_nbeam


subroutine psget_n_d_einj_standard(iobj, data, ierr)
    !! no. pts in D beam energy fractions table
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_n_d_einj_standard', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % n_D_einj_standard
end subroutine psget_n_d_einj_standard


subroutine psset_n_d_einj_standard(iobj, data, ierr)
    !! no. pts in D beam energy fractions table
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_n_d_einj_standard', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % n_D_einj_standard = data
end subroutine psset_n_d_einj_standard


subroutine psget_nlhrf_src(iobj, data, ierr)
    !! item list dimension of lhrf_src_name (lhrf_source)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_nlhrf_src', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % nlhrf_src
end subroutine psget_nlhrf_src


subroutine psset_nlhrf_src(iobj, data, ierr)
    !! item list dimension of lhrf_src_name (lhrf_source)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_nlhrf_src', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % nlhrf_src = data
end subroutine psset_nlhrf_src


subroutine psget_nr(iobj, data, ierr)
    !! grid dimension of R_grid (R coordinate)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_nr', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % nr
end subroutine psget_nr


subroutine psset_nr(iobj, data, ierr)
    !! grid dimension of R_grid (R coordinate)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_nr', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % nr = data
end subroutine psset_nr


subroutine psget_ndelta_w(iobj, data, ierr)
    !! item list dimension of DeltaW_code (Delta_W_codes)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_ndelta_w', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % ndelta_w
end subroutine psget_ndelta_w


subroutine psset_ndelta_w(iobj, data, ierr)
    !! item list dimension of DeltaW_code (Delta_W_codes)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_ndelta_w', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % ndelta_w = data
end subroutine psset_ndelta_w


subroutine psget_nz_rip(iobj, data, ierr)
    !! grid dimension of Z_ripple (Z coordinate)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_nz_rip', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % nz_rip
end subroutine psget_nz_rip


subroutine psset_nz_rip(iobj, data, ierr)
    !! grid dimension of Z_ripple (Z coordinate)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_nz_rip', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % nz_rip = data
end subroutine psset_nz_rip


subroutine psget_nefi_anom2(iobj, data, ierr)
    !! grid dimension of E_anom2 (E coordinate)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_nefi_anom2', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % nefi_anom2
end subroutine psget_nefi_anom2


subroutine psset_nefi_anom2(iobj, data, ierr)
    !! grid dimension of E_anom2 (E coordinate)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_nefi_anom2', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % nefi_anom2 = data
end subroutine psset_nefi_anom2

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)

SUBROUTINE plasma_state_xload_sgrps(ss,xhash,iout,ierr)

  ! called from plasma_state_xload: check grids; store in xplasma structure

  USE plasma_state_definition_mod
  IMPLICIT NONE

  TYPE (plasma_state) :: ss     ! state data to write into xplasma
  INTEGER :: xhash(ps_hash_total)  ! hash data
  INTEGER, INTENT(IN) :: iout   ! LUN for messages
  INTEGER, INTENT(INOUT) :: ierr   ! completion code (set if error occurs)

  !-----------------------
  ! local:

  INTEGER, PARAMETER :: max_itemlist = ps_max_static

  INTEGER :: icomponent,imod,nitems
  CHARACTER*32 :: listname,units
  CHARACTER*80 :: label
  INTEGER :: ahash(ps_max_static)

  CHARACTER*32 :: item_names(max_itemlist)
  INTEGER :: item_ivals(max_itemlist)
  REAL(KIND=rspec) :: item_r8vals(max_itemlist)
  CHARACTER*256 :: item_c256(max_itemlist)
  !-----------------------

  ahash(1) = ps_shash_STATE_DATA
  IF(hcheck(1,1)) THEN
     listname = "EQ_BAXIS"
     icomponent = ps_cnum_EQ
     units = "T"
     label = "group: EQ_BAXIS; component: EQ"
     nitems = 2
     item_names(1) = "B_axis"
     item_r8vals(1) = ss%B_axis
     item_ivals(1) = 0
     item_c256(1) = " "
     item_names(2) = "B_axis_vac"
     item_r8vals(2) = ss%B_axis_vac
     item_ivals(2) = 0
     item_c256(2) = " "

     CALL ps_list_store("STATE_DATA", ss%iobj, &
          listname,icomponent,units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_shash_STATE_DATA
  IF(hcheck(1,1)) THEN
     listname = "EQ_BLCFS"
     icomponent = ps_cnum_EQ
     units = "T"
     label = "group: EQ_BLCFS; component: EQ"
     nitems = 2
     item_names(1) = "B_min_lcfs"
     item_r8vals(1) = ss%B_min_lcfs
     item_ivals(1) = 0
     item_c256(1) = " "
     item_names(2) = "B_max_lcfs"
     item_r8vals(2) = ss%B_max_lcfs
     item_ivals(2) = 0
     item_c256(2) = " "

     CALL ps_list_store("STATE_DATA", ss%iobj, &
          listname,icomponent,units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_shash_SHOT_CONFIGURATION
  IF(hcheck(1,1)) THEN
     listname = "EQ_BSIGNS"
     icomponent = ps_cnum_EQ
     units = " "
     label = "group: EQ_BSIGNS; component: EQ"
     nitems = 2
     item_names(1) = "kccw_Bphi"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%kccw_Bphi
     item_c256(1) = " "
     item_names(2) = "kccw_Jphi"
     item_r8vals(2) = 0.0_rspec
     item_ivals(2) = ss%kccw_Jphi
     item_c256(2) = " "

     CALL ps_list_store("SHOT_CONFIGURATION", ss%iobj, &
          listname,icomponent,units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_shash_STATE_DATA
  IF(hcheck(1,1)) THEN
     listname = "EQ_FILES"
     icomponent = ps_cnum_EQ
     units = " "
     label = "group: EQ_FILES; component: EQ"
     nitems = 1
     item_names(1) = "eqdsk_file"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = 0
     item_c256(1) = ss%eqdsk_file

     CALL ps_list_store("STATE_DATA", ss%iobj, &
          listname,icomponent,units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_shash_STATE_DATA
  IF(hcheck(1,1)) THEN
     listname = "EQ_RZAXIS"
     icomponent = ps_cnum_EQ
     units = "m"
     label = "group: EQ_RZAXIS; component: EQ"
     nitems = 2
     item_names(1) = "R_axis"
     item_r8vals(1) = ss%R_axis
     item_ivals(1) = 0
     item_c256(1) = " "
     item_names(2) = "Z_axis"
     item_r8vals(2) = ss%Z_axis
     item_ivals(2) = 0
     item_c256(2) = " "

     CALL ps_list_store("STATE_DATA", ss%iobj, &
          listname,icomponent,units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_shash_MACHINE_DESCRIPTION
  IF(hcheck(1,1)) THEN
     listname = "EQ_RZBOX"
     icomponent = ps_cnum_EQ
     units = "m"
     label = "group: EQ_RZBOX; component: EQ"
     nitems = 4
     item_names(1) = "R_min_box"
     item_r8vals(1) = ss%R_min_box
     item_ivals(1) = 0
     item_c256(1) = " "
     item_names(2) = "R_max_box"
     item_r8vals(2) = ss%R_max_box
     item_ivals(2) = 0
     item_c256(2) = " "
     item_names(3) = "Z_min_box"
     item_r8vals(3) = ss%Z_min_box
     item_ivals(3) = 0
     item_c256(3) = " "
     item_names(4) = "Z_max_box"
     item_r8vals(4) = ss%Z_max_box
     item_ivals(4) = 0
     item_c256(4) = " "

     CALL ps_list_store("MACHINE_DESCRIPTION", ss%iobj, &
          listname,icomponent,units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_shash_STATE_DATA
  IF(hcheck(1,1)) THEN
     listname = "EQ_RZLCFS"
     icomponent = ps_cnum_EQ
     units = "m"
     label = "group: EQ_RZLCFS; component: EQ"
     nitems = 4
     item_names(1) = "R_min_lcfs"
     item_r8vals(1) = ss%R_min_lcfs
     item_ivals(1) = 0
     item_c256(1) = " "
     item_names(2) = "R_max_lcfs"
     item_r8vals(2) = ss%R_max_lcfs
     item_ivals(2) = 0
     item_c256(2) = " "
     item_names(3) = "Z_min_lcfs"
     item_r8vals(3) = ss%Z_min_lcfs
     item_ivals(3) = 0
     item_c256(3) = " "
     item_names(4) = "Z_max_lcfs"
     item_r8vals(4) = ss%Z_max_lcfs
     item_ivals(4) = 0
     item_c256(4) = " "

     CALL ps_list_store("STATE_DATA", ss%iobj, &
          listname,icomponent,units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_shash_SIMULATION_INIT
  IF(hcheck(1,1)) THEN
     listname = "ICRF_CONTROLS"
     icomponent = ps_cnum_IC
     units = " "
     label = "group: ICRF_CONTROLS; component: IC"
     nitems = 1
     item_names(1) = "kdens_rfmin"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = 0
     item_c256(1) = ss%kdens_rfmin

     CALL ps_list_store("SIMULATION_INIT", ss%iobj, &
          listname,icomponent,units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_shash_STATE_DATA
  IF(hcheck(1,1)) THEN
     listname = "LMHD_FLAGS"
     icomponent = ps_cnum_LMHD
     units = " "
     label = "group: LMHD_FLAGS; component: LMHD"
     nitems = 2
     item_names(1) = "MHD_eq_status"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%MHD_eq_status
     item_c256(1) = " "
     item_names(2) = "LMHD_status"
     item_r8vals(2) = 0.0_rspec
     item_ivals(2) = ss%LMHD_status
     item_c256(2) = " "

     CALL ps_list_store("STATE_DATA", ss%iobj, &
          listname,icomponent,units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_shash_STATE_DATA
  IF(hcheck(1,1)) THEN
     listname = "LOCK_VARIABLES"
     icomponent = ps_cnum_PLASMA
     units = " "
     label = "group: LOCK_VARIABLES; component: PLASMA"
     nitems = 3
     item_names(1) = "lock_machine_descr"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%lock_machine_descr
     item_c256(1) = " "
     item_names(2) = "lock_shot_config"
     item_r8vals(2) = 0.0_rspec
     item_ivals(2) = ss%lock_shot_config
     item_c256(2) = " "
     item_names(3) = "lock_sim_init"
     item_r8vals(3) = 0.0_rspec
     item_ivals(3) = ss%lock_sim_init
     item_c256(3) = " "

     CALL ps_list_store("STATE_DATA", ss%iobj, &
          listname,icomponent,units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_shash_STATE_DATA
  IF(hcheck(1,1)) THEN
     listname = "RHO_BDY_SOLVE"
     icomponent = ps_cnum_PLASMA
     units = "-"
     label = "group: RHO_BDY_SOLVE; component: PLASMA"
     nitems = 3
     item_names(1) = "rho_bdy_Te"
     item_r8vals(1) = ss%rho_bdy_Te
     item_ivals(1) = 0
     item_c256(1) = " "
     item_names(2) = "rho_bdy_Ti"
     item_r8vals(2) = ss%rho_bdy_Ti
     item_ivals(2) = 0
     item_c256(2) = " "
     item_names(3) = "rho_bdy_omegat"
     item_r8vals(3) = ss%rho_bdy_omegat
     item_ivals(3) = 0
     item_c256(3) = " "

     CALL ps_list_store("STATE_DATA", ss%iobj, &
          listname,icomponent,units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_shash_STATE_DATA
  IF(hcheck(1,1)) THEN
     listname = "SURFACE_VOLTAGE"
     icomponent = ps_cnum_PLASMA
     units = "Volts"
     label = "group: SURFACE_VOLTAGE; component: PLASMA"
     nitems = 1
     item_names(1) = "vsur"
     item_r8vals(1) = ss%vsur
     item_ivals(1) = 0
     item_c256(1) = " "

     CALL ps_list_store("STATE_DATA", ss%iobj, &
          listname,icomponent,units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_shash_STATE_DATA
  IF(hcheck(1,1)) THEN
     listname = "TEMPERATURE_BCS"
     icomponent = ps_cnum_PLASMA
     units = "KeV"
     label = "group: TEMPERATURE_BCS; component: PLASMA"
     nitems = 2
     item_names(1) = "Te_bdy"
     item_r8vals(1) = ss%Te_bdy
     item_ivals(1) = 0
     item_c256(1) = " "
     item_names(2) = "Ti_bdy"
     item_r8vals(2) = ss%Ti_bdy
     item_ivals(2) = 0
     item_c256(2) = " "

     CALL ps_list_store("STATE_DATA", ss%iobj, &
          listname,icomponent,units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_shash_SIMULATION_INIT
  IF(hcheck(1,1)) THEN
     listname = "TIME_RANGE"
     icomponent = ps_cnum_PLASMA
     units = "sec"
     label = "group: TIME_RANGE; component: PLASMA"
     nitems = 2
     item_names(1) = "tinit"
     item_r8vals(1) = ss%tinit
     item_ivals(1) = 0
     item_c256(1) = " "
     item_names(2) = "tfinal"
     item_r8vals(2) = ss%tfinal
     item_ivals(2) = 0
     item_c256(2) = " "

     CALL ps_list_store("SIMULATION_INIT", ss%iobj, &
          listname,icomponent,units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_shash_STATE_DATA
  IF(hcheck(1,1)) THEN
     listname = "TIME_STEP"
     icomponent = ps_cnum_PLASMA
     units = "sec"
     label = "group: TIME_STEP; component: PLASMA"
     nitems = 2
     item_names(1) = "t0"
     item_r8vals(1) = ss%t0
     item_ivals(1) = 0
     item_c256(1) = " "
     item_names(2) = "t1"
     item_r8vals(2) = ss%t1
     item_ivals(2) = 0
     item_c256(2) = " "

     CALL ps_list_store("STATE_DATA", ss%iobj, &
          listname,icomponent,units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_shash_SIMULATION_INIT
  IF(hcheck(1,1)) THEN
     listname = "ZIMP_SA"
     icomponent = ps_cnum_PLASMA
     units = " "
     label = "group: ZIMP_SA; component: PLASMA"
     nitems = 2
     item_names(1) = "Zimp1"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%Zimp1
     item_c256(1) = " "
     item_names(2) = "Zimp2"
     item_r8vals(2) = 0.0_rspec
     item_ivals(2) = ss%Zimp2
     item_c256(2) = " "

     CALL ps_list_store("SIMULATION_INIT", ss%iobj, &
          listname,icomponent,units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

CONTAINS

  LOGICAL FUNCTION hcheck(inum,idchk)
     INTEGER, intent(in) :: inum
     INTEGER, intent(in) :: idchk

     !  check all hash codes: set function value TRUE if any show changes.
     !  also set TRUE if idchk = 0

     INTEGER :: ia1,ia2,ii

     if(idchk.eq.0) then
        hcheck=.TRUE.
        return
     endif

     hcheck = .FALSE.
     DO ii=1,inum
        hcheck = .TRUE.
        ia1 = ahash(ii)
        ia2 = ia1 + 1
        IF(ss%hash_codes(ia1).NE.ss%new_hash_codes(ia1)) EXIT
        IF(ss%hash_codes(ia2).NE.ss%new_hash_codes(ia2)) EXIT
        IF(xhash(ia1).NE.ss%new_hash_codes(ia1)) EXIT
        IF(xhash(ia2).NE.ss%new_hash_codes(ia2)) EXIT
        hcheck = .FALSE.
     ENDDO
  END FUNCTION hcheck

  SUBROUTINE lefpack(str)
     CHARACTER*(*), intent(inout) :: str
     !  left pack non-blank characters in str

     INTEGER :: ii,jj
     ii=0
     DO jj=1,len(str)
        IF(str(jj:jj).NE.' ') THEN
           ii = ii + 1
           str(ii:ii) = str(jj:jj)
        ENDIF
     ENDDO
     str(ii+1:) = ' '
  END SUBROUTINE lefpack

END SUBROUTINE plasma_state_xload_sgrps

#include "config_random.h"
! Version 2.1 of random number routines
! Author: Charles Karney <karney@princeton.edu>
! Date: 1999-10-27 14:10 -0400
!
      subroutine random_gauss(y,n,ri,ra)
      implicit none
      integer ri
      REAL8 ra(0:100-1)
      integer n
      REAL8 y(0:n-1)
      integer i
      REAL8 pi,theta,z
      REAL8 random
      external random_array,random
      data pi/__PI/
#ifndef HIPREC
      Real ys(0:n-1)
      Real spi,stheta,sz
      Real srandom
      external srandom_array,srandom
      data spi/__RPI/
#else /* HIPREC */
      entry srandom_gauss(y,n,ri,ra)
#endif /* HIPREC */
      if(n.LE.0)return
      call random_array(y,n,ri,ra(0))
      do i=0,int(n/2)*2-1,2
      theta=pi*(TWO*y(i)-ONE)
      z=sqrt(-TWO*log(y(i+1)))
      y(i)=z*cos(theta)
      y(i+1)=z*sin(theta)
      end do
      if(mod(n,2).EQ.0)return
      theta=pi*(TWO*y(n-1)-ONE)
      z=sqrt(-TWO*random(ri,ra(0)))
      y(n-1)=z*cos(theta)
      return
#ifndef HIPREC
      entry srandom_gauss(ys,n,ri,ra)
      if(n.LE.0)return
      call srandom_array(ys,n,ri,ra(0))
      do i=0,int(n/2)*2-1,2
      stheta=spi*(2.0*ys(i)-1.0)
      sz=sqrt(-2.0*log(ys(i+1)))
      ys(i)=sz*cos(stheta)
      ys(i+1)=sz*sin(stheta)
      end do
      if(mod(n,2).EQ.0)return
      stheta=spi*(2.0*ys(n-1)-1.0)
      sz=sqrt(-2.0*srandom(ri,ra(0)))
      ys(n-1)=sz*cos(stheta)
      return
#endif /* not HIPREC */
      end
!
      subroutine random_isodist(v,n,ri,ra)
      implicit none
      integer ri
      REAL8 ra(0:100-1)
      integer n
      REAL8 v(0:3*n-1)
      integer i
      REAL8 pi,costheta,phi
      external random_array
      data pi/__PI/
#ifndef HIPREC
      Real vs(0:3*n-1)
      Real spi,scostheta,sphi
      external srandom_array
      data spi/__RPI/
#else /* HIPREC */
      entry srandom_isodist(v,n,ri,ra)
#endif /* HIPREC */
      if(n.LE.0)return
      call random_array(v(n),2*n,ri,ra(0))
      do i=0,n-1
      costheta=TWO*v(n+2*i)-ONE
      phi=pi*(TWO*v(n+2*i+1)-ONE)
      v(3*i)=cos(phi)*sqrt(ONE-costheta**2)
      v(3*i+1)=sin(phi)*sqrt(ONE-costheta**2)
      v(3*i+2)=costheta
      end do
      return
#ifndef HIPREC
      entry srandom_isodist(vs,n,ri,ra)
      if(n.LE.0)return
      call srandom_array(vs(n),2*n,ri,ra(0))
      do i=0,n-1
      scostheta=2.0*vs(n+2*i)-1.0
      sphi=spi*(2.0*vs(n+2*i+1)-1.0)
      vs(3*i)=cos(sphi)*sqrt(1.0-scostheta**2)
      vs(3*i+1)=sin(sphi)*sqrt(1.0-scostheta**2)
      vs(3*i+2)=scostheta
      end do
      return
#endif /* not HIPREC */
      end
!
      subroutine random_cosdist(v,n,ri,ra)
      implicit none
      integer ri
      REAL8 ra(0:100-1)
      integer n
      REAL8 v(0:3*n-1)
      integer i
      REAL8 pi,costheta2,phi
      external random_array
      data pi/__PI/
#ifndef HIPREC
      Real vs(0:2*n-1)
      Real spi,scostheta2,sphi
      external srandom_array
      data spi/__RPI/
#else /* HIPREC */
      entry srandom_cosdist(v,n,ri,ra)
#endif /* HIPREC */
      if(n.LE.0)return
      call random_array(v(n),2*n,ri,ra(0))
      do i=0,n-1
      costheta2=v(n+2*i)
      phi=pi*(TWO*v(n+2*i+1)-ONE)
      v(3*i)=cos(phi)*sqrt(ONE-costheta2)
      v(3*i+1)=sin(phi)*sqrt(ONE-costheta2)
      v(3*i+2)=sqrt(costheta2)
#ifndef HIPREC
      end do
      return
      entry srandom_cosdist(vs,n,ri,ra)
      if(n.LE.0)return
      call srandom_array(vs(n),2*n,ri,ra(0))
      do i=0,n-1
      scostheta2=vs(n+2*i)
      sphi=spi*(2.0*vs(n+2*i+1)-1.0)
      vs(3*i)=cos(sphi)*sqrt(1.0-scostheta2)
      vs(3*i+1)=sin(sphi)*sqrt(1.0-scostheta2)
      vs(3*i+2)=sqrt(scostheta2)
#endif /* not HIPREC */
      end do
      return
      end
!

subroutine ccps_get_num_components(num)
  ! Number of components
  use plasma_state_util_mod, only : ps_ccount
  implicit none
  integer, intent(out) :: num
  num = ps_ccount
end subroutine ccps_get_num_components

subroutine ccps_get_component_number(name, number)
  ! Hand maintained routine returning the index number of 
  ! a plasma sub-component. This would typically be used 
  ! in conjunction with the ps_copy_plasma_state routine.
  ! $Id: ccps_get_component.f90,v 1.1 2009-12-07 23:57:49 Alex_Pletzer Exp $
  use plasma_state_util_mod
  implicit none
  character(*), intent(in) :: name
  integer, intent(out) :: number
  
  number = -1 ! <0 is an error

  if (name == 'ANOM') then
     number = ps_cnum_ANOM
  else if (name == 'EC') then
     number = ps_cnum_EC
  else if (name == 'EQ') then
     number = ps_cnum_EQ
  else if (name == 'FUS') then
     number = ps_cnum_FUS
  else if (name == 'GAS') then
     number = ps_cnum_GAS
  else if (name == 'IC') then
     number = ps_cnum_IC
  else if (name == 'LH') then
     number = ps_cnum_LH
  else if (name == 'LMHD') then
     number = ps_cnum_LMHD
  else if (name == 'NBI') then
     number = ps_cnum_NBI
  else if (name == 'PLASMA') then
     number = ps_cnum_PLASMA
  else if (name == 'RAD') then
     number = ps_cnum_RAD
  else if (name == 'RIPPLE') then
     number = ps_cnum_RIPPLE
  else if (name == 'RUNAWAY') then
     number = ps_cnum_RUNAWAY
  endif

end subroutine ccps_get_component_number

subroutine ccps_get_component_descriptor(name, descr)
  ! Hand maintained routine returning the descriptor of 
  ! a plasma sub-component. This would typically be used 
  ! in conjunction with the ps_copy_plasma_state routine.
  ! $Id: ccps_get_component.f90,v 1.1 2009-12-07 23:57:49 Alex_Pletzer Exp $
  use plasma_state_util_mod
  implicit none
  character(*), intent(in) :: name
  character(*), intent(out) :: descr
  
  descr = '' ! empty string is an error

  if (name == 'ANOM') then
     descr = ps_cdescr_ANOM
  else if (name == 'EC') then
     descr = ps_cdescr_EC
  else if (name == 'EQ') then
     descr = ps_cdescr_EQ
  else if (name == 'FUS') then
     descr = ps_cdescr_FUS
  else if (name == 'GAS') then
     descr = ps_cdescr_GAS
  else if (name == 'IC') then
     descr = ps_cdescr_IC
  else if (name == 'LH') then
     descr = ps_cdescr_LH
  else if (name == 'LMHD') then
     descr = ps_cdescr_LMHD
  else if (name == 'NBI') then
     descr = ps_cdescr_NBI
  else if (name == 'PLASMA') then
     descr = ps_cdescr_PLASMA
  else if (name == 'RAD') then
     descr = ps_cdescr_RAD
  else if (name == 'RIPPLE') then
     descr = ps_cdescr_RIPPLE
  else if (name == 'RUNAWAY') then
     descr = ps_cdescr_RUNAWAY
  endif

end subroutine ccps_get_component_descriptor

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_a9_dummy
     return
  end subroutine ccps_getset_a9_dummy

subroutine psget_ang_vref_coil(iobj, n1, data, ierr)
    !! angle w.r.t. vertical of coil sides, zero means, walls are
    !! alligned vertically, +10 (degrees) means, tilted up and to left
    !! 10 degrees from vertical, -10 (degrees) means, tilted up and to
    !! right, 10 degrees from vertical
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_ang_vref_coil', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % Ang_Vref_coil
end subroutine psget_ang_vref_coil


subroutine psset_ang_vref_coil(iobj, n1, data, ierr)
    !! angle w.r.t. vertical of coil sides, zero means, walls are
    !! alligned vertically, +10 (degrees) means, tilted up and to left
    !! 10 degrees from vertical, -10 (degrees) means, tilted up and to
    !! right, 10 degrees from vertical
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_ang_vref_coil', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % Ang_Vref_coil = data(1:n1)
end subroutine psset_ang_vref_coil


subroutine psgetrnk_ang_vref_coil(iobj, ndims, ierr)
    !! angle w.r.t. vertical of coil sides, zero means, walls are
    !! alligned vertically, +10 (degrees) means, tilted up and to left
    !! 10 degrees from vertical, -10 (degrees) means, tilted up and to
    !! right, 10 degrees from vertical
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_ang_vref_coil


subroutine psgetdim_ang_vref_coil(iobj, ndims, dims, ierr)
    !! angle w.r.t. vertical of coil sides, zero means, walls are
    !! alligned vertically, +10 (degrees) means, tilted up and to left
    !! 10 degrees from vertical, -10 (degrees) means, tilted up and to
    !! right, 10 degrees from vertical
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_ang_vref_coil', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % Ang_Vref_coil ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % Ang_Vref_coil)
    endif
end subroutine psgetdim_ang_vref_coil


subroutine psget_ap2_horiz_offset(iobj, n1, data, ierr)
    !! horizontal offset, 2nd aperture, opening relative to beam
    !! centerline; positive value means shift of, aperture away from
    !! machine axis i.e. to make a beam with a larger, tangency radius
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_ap2_horiz_offset', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % ap2_horiz_offset
end subroutine psget_ap2_horiz_offset


subroutine psset_ap2_horiz_offset(iobj, n1, data, ierr)
    !! horizontal offset, 2nd aperture, opening relative to beam
    !! centerline; positive value means shift of, aperture away from
    !! machine axis i.e. to make a beam with a larger, tangency radius
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_ap2_horiz_offset', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % ap2_horiz_offset = data(1:n1)
end subroutine psset_ap2_horiz_offset


subroutine psgetrnk_ap2_horiz_offset(iobj, ndims, ierr)
    !! horizontal offset, 2nd aperture, opening relative to beam
    !! centerline; positive value means shift of, aperture away from
    !! machine axis i.e. to make a beam with a larger, tangency radius
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_ap2_horiz_offset


subroutine psgetdim_ap2_horiz_offset(iobj, ndims, dims, ierr)
    !! horizontal offset, 2nd aperture, opening relative to beam
    !! centerline; positive value means shift of, aperture away from
    !! machine axis i.e. to make a beam with a larger, tangency radius
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_ap2_horiz_offset', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % ap2_horiz_offset ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % ap2_horiz_offset)
    endif
end subroutine psgetdim_ap2_horiz_offset


subroutine psget_amaxlh(iobj, n1, n2, data, ierr)
    !! width of the spectrum peak
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_amaxlh', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % amaxlh
end subroutine psget_amaxlh


subroutine psset_amaxlh(iobj, n1, n2, data, ierr)
    !! width of the spectrum peak
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_amaxlh', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % amaxlh = data(1:n1, 1: n2)
end subroutine psset_amaxlh


subroutine psgetrnk_amaxlh(iobj, ndims, ierr)
    !! width of the spectrum peak
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_amaxlh


subroutine psgetdim_amaxlh(iobj, ndims, dims, ierr)
    !! width of the spectrum peak
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_amaxlh', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % amaxlh ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % amaxlh)
    endif
end subroutine psgetdim_amaxlh

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_d0_dummy
     return
  end subroutine ccps_getset_d0_dummy

subroutine psget_d_ffull_standard(iobj, n1, data, ierr)
    !! D beam full energy fractions
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_d_ffull_standard', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % D_ffull_standard
end subroutine psget_d_ffull_standard


subroutine psset_d_ffull_standard(iobj, n1, data, ierr)
    !! D beam full energy fractions
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_d_ffull_standard', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % D_ffull_standard = data(1:n1)
end subroutine psset_d_ffull_standard


subroutine psgetrnk_d_ffull_standard(iobj, ndims, ierr)
    !! D beam full energy fractions
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_d_ffull_standard


subroutine psgetdim_d_ffull_standard(iobj, ndims, dims, ierr)
    !! D beam full energy fractions
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_d_ffull_standard', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % D_ffull_standard ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % D_ffull_standard)
    endif
end subroutine psgetdim_d_ffull_standard


subroutine psget_dcur_rw_dvloop(iobj, n1, data, ierr)
    !! sensitivity to loop volts
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_dcur_rw_dvloop', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % dcur_rw_dVloop
end subroutine psget_dcur_rw_dvloop


subroutine psset_dcur_rw_dvloop(iobj, n1, data, ierr)
    !! sensitivity to loop volts
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_dcur_rw_dvloop', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % dcur_rw_dVloop = data(1:n1)
end subroutine psset_dcur_rw_dvloop


subroutine psgetrnk_dcur_rw_dvloop(iobj, ndims, ierr)
    !! sensitivity to loop volts
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_dcur_rw_dvloop


subroutine psgetdim_dcur_rw_dvloop(iobj, ndims, dims, ierr)
    !! sensitivity to loop volts
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_dcur_rw_dvloop', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % dcur_rw_dVloop ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % dcur_rw_dVloop)
    endif
end subroutine psgetdim_dcur_rw_dvloop


subroutine psget_dqedgrdti_tglf(iobj, n1, data, ierr)
    !! Te flux gradient term from TGLF model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_dqedgrdti_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % dQedGrdti_tglf
end subroutine psget_dqedgrdti_tglf


subroutine psset_dqedgrdti_tglf(iobj, n1, data, ierr)
    !! Te flux gradient term from TGLF model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_dqedgrdti_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % dQedGrdti_tglf = data(1:n1)
end subroutine psset_dqedgrdti_tglf


subroutine psgetrnk_dqedgrdti_tglf(iobj, ndims, ierr)
    !! Te flux gradient term from TGLF model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_dqedgrdti_tglf


subroutine psgetdim_dqedgrdti_tglf(iobj, ndims, dims, ierr)
    !! Te flux gradient term from TGLF model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_dqedgrdti_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % dQedGrdti_tglf ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % dQedGrdti_tglf)
    endif
end subroutine psgetdim_dqedgrdti_tglf


subroutine psget_difnh_nclass(iobj, n1, data, ierr)
    !! main-hydrogenic-density-equations, neoclassical diffusivity
    !! from NCLASS model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_difnh_nclass', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % difnh_nclass
end subroutine psget_difnh_nclass


subroutine psset_difnh_nclass(iobj, n1, data, ierr)
    !! main-hydrogenic-density-equations, neoclassical diffusivity
    !! from NCLASS model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_difnh_nclass', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % difnh_nclass = data(1:n1)
end subroutine psset_difnh_nclass


subroutine psgetrnk_difnh_nclass(iobj, ndims, ierr)
    !! main-hydrogenic-density-equations, neoclassical diffusivity
    !! from NCLASS model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_difnh_nclass


subroutine psgetdim_difnh_nclass(iobj, ndims, dims, ierr)
    !! main-hydrogenic-density-equations, neoclassical diffusivity
    !! from NCLASS model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_difnh_nclass', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % difnh_nclass ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % difnh_nclass)
    endif
end subroutine psgetdim_difnh_nclass


subroutine psget_dz0_momeq_drho(iobj, n1, data, ierr)
    !! Z0 of flux surface, Fourier Spline representation
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_dz0_momeq_drho', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % dZ0_momeq_dRHO
end subroutine psget_dz0_momeq_drho


subroutine psset_dz0_momeq_drho(iobj, n1, data, ierr)
    !! Z0 of flux surface, Fourier Spline representation
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_dz0_momeq_drho', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % dZ0_momeq_dRHO = data(1:n1)
end subroutine psset_dz0_momeq_drho


subroutine psgetrnk_dz0_momeq_drho(iobj, ndims, ierr)
    !! Z0 of flux surface, Fourier Spline representation
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_dz0_momeq_drho


subroutine psgetdim_dz0_momeq_drho(iobj, ndims, dims, ierr)
    !! Z0 of flux surface, Fourier Spline representation
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_dz0_momeq_drho', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % dZ0_momeq_dRHO ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % dZ0_momeq_dRHO)
    endif
end subroutine psgetdim_dz0_momeq_drho

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_e4_dummy
     return
  end subroutine ccps_getset_e4_dummy

subroutine psget_ecrf_src_name(iobj, n1, data, ierr)
    !! number & name of ECRF sources
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    CHARACTER*(*), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_ecrf_src_name', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % ecrf_src_name
end subroutine psget_ecrf_src_name


subroutine psset_ecrf_src_name(iobj, n1, data, ierr)
    !! number & name of ECRF sources
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    CHARACTER*(*), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_ecrf_src_name', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % ecrf_src_name = data(1:n1)
end subroutine psset_ecrf_src_name


subroutine psgetsz_ecrf_src_name(iobj, size, ierr)
    !! number & name of ECRF sources
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: size    ! size of character string
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psgetsz_ecrf_src_name', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! note that the following will return the character length size regardless of
    ! the number of array elements (if ecrf_src_name is an array)
    size = len(ss % ecrf_src_name)
end subroutine psgetsz_ecrf_src_name


subroutine psgetrnk_ecrf_src_name(iobj, ndims, ierr)
    !! number & name of ECRF sources
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_ecrf_src_name


subroutine psgetdim_ecrf_src_name(iobj, ndims, dims, ierr)
    !! number & name of ECRF sources
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_ecrf_src_name', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % ecrf_src_name ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % ecrf_src_name)
    endif
end subroutine psgetdim_ecrf_src_name


subroutine psget_ec_omode_fraction(iobj, n1, data, ierr)
    !! O-mode fraction of EC source,
    !! Power(O-mode)/(Power(O-mode)+Power(X-mode))
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_ec_omode_fraction', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % EC_Omode_Fraction
end subroutine psget_ec_omode_fraction


subroutine psset_ec_omode_fraction(iobj, n1, data, ierr)
    !! O-mode fraction of EC source,
    !! Power(O-mode)/(Power(O-mode)+Power(X-mode))
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_ec_omode_fraction', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % EC_Omode_Fraction = data(1:n1)
end subroutine psset_ec_omode_fraction


subroutine psgetrnk_ec_omode_fraction(iobj, ndims, ierr)
    !! O-mode fraction of EC source,
    !! Power(O-mode)/(Power(O-mode)+Power(X-mode))
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_ec_omode_fraction


subroutine psgetdim_ec_omode_fraction(iobj, ndims, dims, ierr)
    !! O-mode fraction of EC source,
    !! Power(O-mode)/(Power(O-mode)+Power(X-mode))
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_ec_omode_fraction', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % EC_Omode_Fraction ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % EC_Omode_Fraction)
    endif
end subroutine psgetdim_ec_omode_fraction


subroutine psget_eqmom_num(iobj, n1, data, ierr)
    !! Equilibrium moments', "neqmom = nmom; eqmom_num(1)='1',
    !! eqmom_num(2)='2', etc..."]
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    CHARACTER*(*), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_eqmom_num', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % eqmom_num
end subroutine psget_eqmom_num


subroutine psset_eqmom_num(iobj, n1, data, ierr)
    !! Equilibrium moments', "neqmom = nmom; eqmom_num(1)='1',
    !! eqmom_num(2)='2', etc..."]
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    CHARACTER*(*), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_eqmom_num', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % eqmom_num = data(1:n1)
end subroutine psset_eqmom_num


subroutine psgetsz_eqmom_num(iobj, size, ierr)
    !! Equilibrium moments', "neqmom = nmom; eqmom_num(1)='1',
    !! eqmom_num(2)='2', etc..."]
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: size    ! size of character string
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psgetsz_eqmom_num', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! note that the following will return the character length size regardless of
    ! the number of array elements (if eqmom_num is an array)
    size = len(ss % eqmom_num)
end subroutine psgetsz_eqmom_num


subroutine psgetrnk_eqmom_num(iobj, ndims, ierr)
    !! Equilibrium moments', "neqmom = nmom; eqmom_num(1)='1',
    !! eqmom_num(2)='2', etc..."]
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_eqmom_num


subroutine psgetdim_eqmom_num(iobj, ndims, dims, ierr)
    !! Equilibrium moments', "neqmom = nmom; eqmom_num(1)='1',
    !! eqmom_num(2)='2', etc..."]
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_eqmom_num', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % eqmom_num ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % eqmom_num)
    endif
end subroutine psgetdim_eqmom_num


subroutine psget_elong(iobj, n1, data, ierr)
    !! elongation (b/a), (Zmax-Zmin)/(Rmax-Rmin) on each surface
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_elong', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % elong
end subroutine psget_elong


subroutine psset_elong(iobj, n1, data, ierr)
    !! elongation (b/a), (Zmax-Zmin)/(Rmax-Rmin) on each surface
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_elong', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % elong = data(1:n1)
end subroutine psset_elong


subroutine psgetrnk_elong(iobj, ndims, ierr)
    !! elongation (b/a), (Zmax-Zmin)/(Rmax-Rmin) on each surface
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_elong


subroutine psgetdim_elong(iobj, ndims, dims, ierr)
    !! elongation (b/a), (Zmax-Zmin)/(Rmax-Rmin) on each surface
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_elong', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % elong ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % elong)
    endif
end subroutine psgetdim_elong


subroutine psget_epll_mini(iobj, n1, n2, data, ierr)
    !! minority species <Epll>, lab frame
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_epll_mini', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % epll_mini
end subroutine psget_epll_mini


subroutine psset_epll_mini(iobj, n1, n2, data, ierr)
    !! minority species <Epll>, lab frame
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_epll_mini', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % epll_mini = data(1:n1, 1: n2)
end subroutine psset_epll_mini


subroutine psgetrnk_epll_mini(iobj, ndims, ierr)
    !! minority species <Epll>, lab frame
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_epll_mini


subroutine psgetdim_epll_mini(iobj, ndims, dims, ierr)
    !! minority species <Epll>, lab frame
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_epll_mini', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % epll_mini ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % epll_mini)
    endif
end subroutine psgetdim_epll_mini

subroutine ur_cstate_list(iexit)

  !  acquire list of states to read for comparitive analysis / visualization
  !  UREAD command line interface library calls are used.

  use cstate_lib_mod
  implicit NONE

  integer, intent(out) :: iexit   ! =1 to request skipping the analysis
  !  this is set if there are no states to compare

  !---------------------------------
  !  local:

  integer :: i,ii,luntty,lnout,iertmp,ic,ilen,i1,i2,ierr
  integer :: ihash1(nsss_max),ihash2(nsss_max)
  logical :: lxout,lchar
  character*7 ztest
  !---------------------------------

  ierr = 0

  luntty = lnout(0)

  if(nsss_cur.eq.0) then
     user_label = .FALSE.
  endif

  write(luntty,*) ' ------------------------------------------------------ '
  write(luntty,*) ' (re)entering state list spec routine ur_cstate_list... '
  do
     !  information for the user...

     if(lxout(0)) then
        write(luntty,*) ' '
        write(luntty,'(1x,i1," states are in the list:")') nsss_cur
        do i=1,nsss_cur
           write(luntty,*) ' '
           write(luntty,'(" state #",i1,"  label: ",a)') i,trim(sss_label(i))
           write(luntty,'("    path: ",a)') trim(sss_path(i))
        enddo
        write(luntty,*) ' '
        write(luntty,*) ' options (NOTE menu has changed 3/2007): '
        if(nsss_cur.eq.nsss_max) then
           write(luntty,*) '   (maximum number of states already specified).'
        else
           write(luntty,*) '  A -- add a state to the list.'
        endif
        write(luntty,*) '  C -- clear list, remove all states.'
        if(nsss_cur.gt.0) then
           write(luntty,*) '  L -- modify a state label.'
        endif
        write(luntty,*) '  P -- proceed, using list as currently specified.'
        write(luntty,*) '  Q -- quit: exit program.'
     endif

     call uread('ur_cstate_list: command option:')

     if(lchar('Q')) then
        call erase_list
        iexit = 1
        exit             ! user requested exit (exit program)

     else if(lchar('P')) then
        if(nsss_cur.eq.0) then
           call uermsg('%ur_cstate_list: list is empty.',' ',0)
        else
           iexit = 0
           exit          ! user request: exit loop, plot selected states...
        endif

     else if(lchar('C')) then
        ! erase the list & associated states
        call erase_list

     else if(lchar('A')) then
        ! add a state
        if(nsss_cur.eq.nsss_max) then
           call uermsi('?ur_cstate_list: cannot add state, list is full',nsss_max,0)
           cycle
        endif

        nsss_cur = nsss_cur + 1
        i = nsss_cur

        user_label(i:nsss_max)=.FALSE.
        sss_label(i:nsss_max)=' '
        sss_path(i:nsss_max)=' '

        if(lxout(0)) write(luntty,*) ' an HTTP:// path may be specified.'

        sss_path(i)='NONE'
        call unixfile('state path',sss_path(i))

        if(sss_path(i).eq.'NONE') then
           nsss_cur = nsss_cur - 1
           sss_path(i)=' '
           cycle
        endif

        !  OK a path was given; assign temporary label

        sss_label(i)=' '
        write(sss_label(i),'("State_",i1)') i

        write(luntty,*) ' reading: State #',i

        call ps_get_plasma_state(iertmp, &
             filename = sss_path(i), &
             state = sss(i))

        if(iertmp.ne.0) then
           write(luntty,*) ' error reading state: ',trim(sss_path(i))
           ztest = sss_path(i)(1:7)
           call uupper(ztest)
           if(ztest.eq.'HTTP://') then
              write(luntty,*) ' '
              write(luntty,*) ' *** ur_cstate_list NOTE:'
              write(luntty,*) '  "Not a netCDF file" could mean: no such URL.'
              write(luntty,*) ' '
           endif
           sss_path(i)=' '
           sss_label(i)=' '
           call plasma_state_erase(sss(i),iertmp)
           nsss_cur = nsss_cur - 1
        endif

        !  update state labels -- try for distinguishing, but short...
        call relabel

     else if(lchar('L')) then
        !  modify label for state
        if(nsss_cur.eq.0) then
           call uermsg('%ur_cstate_list: no states have been read.',' ',0)
           cycle
        else
           call ur_cstate_setLabel
        endif

     else
        call uermsg('?ur_cstate_list: unrecognized command option.',' ',0)
     endif

  enddo

  if(nsss_cur.gt.0) then
     call cstate_empty_dims(luntty,ierr)
     if(ierr.eq.0) then
        call cstate_ldim_stats(luntty,ierr)
     endif
     call hcheck('machine descriptions',ps_shash_machine_description)
     call hcheck('shot configurations',ps_shash_shot_configuration)
     call hcheck('simulation initialization',ps_shash_simulation_init)
     call hcheck('(scalar) state data',ps_shash_state_data)
     call cstate_chk_locks(luntty)
  endif

  if(ierr.ne.0) then
     write(luntty,*) ' ?internal error detected in ur_cstate_list.f90'
     nsss_cur = 0
  endif

contains

  subroutine erase_list

    do i=1,nsss_cur
       call plasma_state_erase(sss(i),iertmp)
       if(iertmp.ne.0) then
          write(luntty,*) '  %ur_cstate_list: plasma_state_erase status: ', &
               iertmp
       endif
    enddo

    nsss_cur = 0

    sss_label = ' '
    sss_path = ' '

  end subroutine erase_list

  subroutine hcheck(label,iaddr)
    character*(*), intent(in) :: label
    integer, intent(in) :: iaddr

    ihash1 = 0
    ihash2 = 0

    do ii=1,nsss_cur
       ihash1(ii) = sss(ii)%hash_codes(iaddr)
       ihash2(ii) = sss(ii)%hash_codes(iaddr+1)
    enddo

    call cstate_hash_compare(label,ihash1(1:nsss_cur),ihash2(1:nsss_cur))
  end subroutine hcheck

  subroutine relabel

    ! collective relabeling of states not labeled by user...
    ! the idea here is to keep labels short but distinct

    integer :: inum,ivar,ilen,ildot,last_dot,ilook,ii,jj,iu,iuu
    integer :: ilstart(nsss_max),ilend(nsss_max),nmatch(nsss_max)
    character*256 :: suffix,suffix_ref
    character*256 :: prefix,prefix_ref

    ilstart=0
    ilend=0
    nmatch=0

    ! first check if common filename suffix is present:

    inum=0
    ivar=0

    do ii=1,nsss_cur
       if(.not.user_label(ii)) then
          inum = inum+1
          ilen = len(trim(sss_path(ii)))
          ilend(ii)=last_dot(sss_path(ii),ilen,'.')

          if(ilend(ii).eq.ilen) then
             suffix=' '
          else
             suffix = sss_path(ii)(ilend(ii)+1:ilen)
          endif

          if(inum.eq.1) then
             suffix_ref = suffix
          else
             if(suffix.ne.suffix_ref) then
                ivar = ivar + 1
             endif
          endif
       endif
    enddo

    if(inum.eq.0) return
    if(ivar.gt.0) then
       ! no common suffix; retain filename suffix as possible part of label
       do ii=1,nsss_cur
          if(.not.user_label(ii)) then
             ilend(ii) = len(trim(sss_path(ii)))
          endif
       enddo
    endif

    ! now look for common prefix, terminated by "_"

    iu = 0
    do 
       iu = iu + 1

       inum=0
       ivar=0

       do ii = 1,nsss_cur
          if(.not.user_label(ii)) then
             inum=inum+1

             ilook=ilend(ii)
             do iuu=1,iu
                ilook = last_dot(sss_path(ii),ilook,'_')
             enddo

             if(ilook.eq.0) then
                ilstart(ii) = 1
             else
                ilstart(ii) = ilook + 2
             endif

             if(ilook.eq.0) then
                prefix=' '
             else
                prefix=sss_path(ii)(1:ilook)
             endif

             if(inum.eq.1) then
                prefix_ref = prefix
             else
                if(prefix.ne.prefix_ref) then
                   ivar = ivar + 1
                   exit
                endif
             endif
          endif
       enddo

       if(ivar.eq.0) exit
    enddo

    do ii = 1,nsss_cur
       if(.not.user_label(ii)) then
          iuu=ilend(ii)
          if(iuu-ilstart(ii)+1.gt.20) then
             iu=ilend(ii)-16
             sss_label(ii)='...'//sss_path(ii)(iu:iuu)
          else
             iu=ilstart(ii)
             sss_label(ii)=sss_path(ii)(iu:iuu)
          endif
       endif
    enddo

    !  check against duplicate labeling
    do ii = 1,nsss_cur
       do jj=ii+1,nsss_cur
          if(sss_label(ii).eq.sss_label(jj)) then
             write(luntty,*) ' %ur_cstate_list: duplicate label suppressed.'
             nmatch(ii)=nmatch(ii)+1
             nmatch(jj)=nmatch(jj)+1
          endif
       enddo
    enddo

    do ii = 1,nsss_cur
       if(.not.user_label(ii)) then
          if(nmatch(ii).ne.0) then
             write(sss_label(ii),'("State_",i1)') ii
          endif
       endif
    enddo

  end subroutine relabel

end subroutine ur_cstate_list

integer function last_dot(str,ii,schar)

  character*(*), intent(in) :: str
  integer, intent(in) :: ii
  character*1, intent(in) :: schar

  !  search back in string for matching character; return location - 1

  integer :: jj,jmatch,kmatch

  !-------------------

  if(ii.eq.0) then
     last_dot=0
     return
  endif

  jmatch=0
  do jj=ii,1,-1
     if(str(jj:jj).eq.schar) then
        jmatch=jj
        exit
     endif
  enddo

  if(jmatch.eq.0) then
     last_dot=0
     return
  endif

  kmatch=0
  do jj=jmatch,1,-1
     if(str(jj:jj).ne.schar) then
        kmatch=jj
        exit
     endif
  enddo

  last_dot = kmatch
  return

end function last_dot

subroutine ur_cstate_setLabel

  !  modify state labels (for labeling of tables and displays)

  use cstate_lib_mod
  implicit NONE

  !---------------------------------
  !  local:

  integer :: luntty,ic,idcod,lnout,i,iert,imatch
  logical :: lxout,lchar
  character*7 ztest
  character*32 :: zlabel
  !---------------------------------

  luntty = lnout(0)

  do
     if(lxout(0)) then
        write(luntty,*) ' '
        write(luntty,'(1x,i1," states are in the list:")') nsss_cur
        do i=1,nsss_cur
           write(luntty,*) ' '
           write(luntty,'(" state #",i1,"  label: ",a)') i,trim(sss_label(i))
           write(luntty,'("    path: ",a)') trim(sss_path(i))
        enddo
        write(luntty,*) ' '
        write(luntty,*) ' options: '
        write(luntty,*) '  <number> -- indicate number of state for which to change the label.'
        write(luntty,*) '  Q -- quit (without changing any more labels).'
     endif

     call uread('ur_cstate_setLabel: enter state number or "Q" to quit:')
     if(lchar('Q')) exit

     ic=idcod(iert)
     if(iert.ne.0) cycle

     if((ic.le.0).or.(ic.gt.nsss_cur)) then
        write(luntty,*) ' Range of available state numbers: 1 to ',nsss_cur
        call uermsi('ur_cstate_setLabel: state number out of range',ic,0)
        cycle
     endif

     !  one word, uppercase not forced:
     call ureadlw('New state label:',zlabel)

     !  check/enforce uniqueness

     imatch=0
     do i=1,nsss_cur
        if(i.ne.ic) then
           if(zlabel.eq.sss_label(i)) then
              imatch=i
              exit
           endif
        else
           if(zlabel(1:6).eq.'State_') then
              imatch=-1
              exit
           endif
        endif
     enddo

     if(imatch.gt.0) then
        call uermsg('ur_cstate_setLabel: label already in use: ',zlabel,0)
        cycle
     else if(imatch.lt.0) then
        call uermsg('ur_cstate_setLabel: "State_" label not allowed: ', &
             zlabel,0)
        cycle
     endif

     sss_label(ic)=zlabel
     user_label(ic)=.TRUE.

  enddo

end subroutine ur_cstate_setLabel

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


SUBROUTINE ps_update_file_read_0(ss,icdf,iout,iucount,iertot)


  ! Read updated data

  USE plasma_state_definition_mod
  USE plasma_hash_code
  USE netcdf
  IMPLICIT NONE

  TYPE (plasma_state) :: ss  ! state containing array elements to be allocated
  INTEGER, INTENT(IN) :: icdf  ! NetCDF file ID
  INTEGER, INTENT(IN) :: iout  ! LUN for messages
  INTEGER, INTENT(INOUT) :: iucount ! update count
  INTEGER, INTENT(INOUT) :: iertot  ! error count

  !-------------------

  INTEGER :: varid,status
  INTEGER :: ival,jval,ii
  INTEGER :: prehash1,prehash2
  INTEGER :: posthash1,posthash2
  CHARACTER*80 :: nc_errmsg
  LOGICAL :: izero

  !-------------------


  status = nf90_inq_varid(icdf,"alla_index",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%alla_index)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: alla_index"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"ALLA_name",varid)
  IF(status.EQ.NF90_NOERR) THEN
     CALL cchk_zero(ss%ALLA_name)
     status = nf90_get_var(icdf,varid,ss%ALLA_name)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: ALLA_name"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
     IF(.NOT.izero) THEN
        CALL cchk_hash("ALLA_name",ss%ALLA_name)
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"ALLA_type",varid)
  IF(status.EQ.NF90_NOERR) THEN
     CALL ichk_zero(ss%ALLA_type)
     status = nf90_get_var(icdf,varid,ss%ALLA_type)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: ALLA_type"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
     IF(.NOT.izero) THEN
        CALL ichk_hash("ALLA_type",ss%ALLA_type)
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"all_index",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%all_index)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: all_index"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"ALL_name",varid)
  IF(status.EQ.NF90_NOERR) THEN
     CALL cchk_zero(ss%ALL_name)
     status = nf90_get_var(icdf,varid,ss%ALL_name)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: ALL_name"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
     IF(.NOT.izero) THEN
        CALL cchk_hash("ALL_name",ss%ALL_name)
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"ALL_type",varid)
  IF(status.EQ.NF90_NOERR) THEN
     CALL ichk_zero(ss%ALL_type)
     status = nf90_get_var(icdf,varid,ss%ALL_type)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: ALL_type"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
     IF(.NOT.izero) THEN
        CALL ichk_hash("ALL_type",ss%ALL_type)
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"amaxlh",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%amaxlh)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: amaxlh"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"aminlh",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%aminlh)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: aminlh"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Ang_Href_coil",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%Ang_Href_coil)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: Ang_Href_coil"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Ang_Vref_coil",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%Ang_Vref_coil)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: Ang_Vref_coil"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"ANOM_Code_Info",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%ANOM_Code_Info)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: ANOM_Code_Info"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"anom_evar",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%anom_evar)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: anom_evar"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"ant_model",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%ant_model)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: ant_model"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"ap2_halfheight",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%ap2_halfheight)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: ap2_halfheight"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"ap2_halfwidth",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%ap2_halfwidth)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: ap2_halfwidth"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"ap2_horiz_offset",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%ap2_horiz_offset)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: ap2_horiz_offset"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"ap2_vert_offset",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%ap2_vert_offset)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: ap2_vert_offset"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"apolmaxlh",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%apolmaxlh)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: apolmaxlh"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"apolminlh",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%apolminlh)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: apolminlh"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"ap_halfheight",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%ap_halfheight)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: ap_halfheight"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"ap_halfwidth",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%ap_halfwidth)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: ap_halfwidth"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"ap_horiz_offset",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%ap_horiz_offset)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: ap_horiz_offset"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"ap_vert_offset",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%ap_vert_offset)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: ap_vert_offset"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"area",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%area)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: area"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"atormaxlh",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%atormaxlh)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: atormaxlh"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"atorminlh",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%atorminlh)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: atorminlh"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Balloon_code",varid)
  IF(status.EQ.NF90_NOERR) THEN
     CALL cchk_zero(ss%Balloon_code)
     status = nf90_get_var(icdf,varid,ss%Balloon_code)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: Balloon_code"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
     IF(.NOT.izero) THEN
        CALL cchk_hash("Balloon_code",ss%Balloon_code)
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Balloon_mapper",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%Balloon_mapper)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: Balloon_mapper"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Balloon_stable",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%Balloon_stable)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: Balloon_stable"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Balloon_status",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%Balloon_status)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: Balloon_status"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"balstab",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%balstab)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: balstab"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"beam_type",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%beam_type)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: beam_type"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"bidiff_bpass_co",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%bidiff_bpass_co)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: bidiff_bpass_co"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"bidiff_bpass_ctr",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%bidiff_bpass_ctr)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: bidiff_bpass_ctr"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"bidiff_btrap",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%bidiff_btrap)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: bidiff_btrap"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"bidiff_dpass_co",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%bidiff_dpass_co)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: bidiff_dpass_co"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"bidiff_dpass_ctr",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%bidiff_dpass_ctr)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: bidiff_dpass_ctr"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"bidiff_dtrap",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%bidiff_dtrap)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: bidiff_dtrap"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"BphiRZ",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%BphiRZ)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: BphiRZ"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"BRRZ",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%BRRZ)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: BRRZ"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"BZRZ",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%BZRZ)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: BZRZ"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"B_axis",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%B_axis)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: B_axis"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"B_axis_vac",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%B_axis_vac)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: B_axis_vac"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"b_halfHeight",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%b_halfHeight)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: b_halfHeight"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"b_halfwidth",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%b_halfwidth)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: b_halfwidth"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"b_Hdivergence",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%b_Hdivergence)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: b_Hdivergence"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"b_Hfocal_length",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%b_Hfocal_length)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: b_Hfocal_length"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"B_max_lcfs",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%B_max_lcfs)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: B_max_lcfs"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"B_min_lcfs",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%B_min_lcfs)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: B_min_lcfs"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"B_surfMax",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%B_surfMax)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: B_surfMax"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"B_surfMin",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%B_surfMin)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: B_surfMin"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"b_Vdivergence",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%b_Vdivergence)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: b_Vdivergence"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"b_Vfocal_length",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%b_Vfocal_length)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: b_Vfocal_length"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"cdicrf",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%cdicrf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: cdicrf"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"cdicrf_nphi",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%cdicrf_nphi)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: cdicrf_nphi"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"chie_anom",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%chie_anom)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: chie_anom"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"chie_drbm",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%chie_drbm)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: chie_drbm"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"chie_etg",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%chie_etg)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: chie_etg"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"chie_glf",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%chie_glf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: chie_glf"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"chie_gtcneo",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%chie_gtcneo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: chie_gtcneo"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"chie_mmm71",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%chie_mmm71)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: chie_mmm71"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"chie_mtm",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%chie_mtm)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: chie_mtm"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"chie_nclass",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%chie_nclass)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: chie_nclass"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"chie_neo",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%chie_neo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: chie_neo"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"chie_ntm",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%chie_ntm)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: chie_ntm"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"chie_paleo",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%chie_paleo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: chie_paleo"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"chie_tglf",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%chie_tglf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: chie_tglf"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"chie_trans",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%chie_trans)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: chie_trans"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"chie_transcat",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%chie_transcat)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: chie_transcat"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"chie_w19",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%chie_w19)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: chie_w19"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"chii_anom",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%chii_anom)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: chii_anom"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"chii_drbm",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%chii_drbm)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: chii_drbm"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"chii_glf",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%chii_glf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: chii_glf"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"chii_gtcneo",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%chii_gtcneo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: chii_gtcneo"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"chii_mmm71",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%chii_mmm71)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: chii_mmm71"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"chii_nclass",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%chii_nclass)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: chii_nclass"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"chii_neo",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%chii_neo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: chii_neo"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

CONTAINS

  subroutine ichk_zero(iarray)
     integer, dimension(:), intent(in) :: iarray

     integer :: ii

     izero=.TRUE.
     do ii=1,size(iarray)
        if(iarray(ii).ne.0) then
           izero=.FALSE.
           exit
        endif
     enddo

     if(.not.izero) then
        prehash1=17
        prehash2=23
        call hashCode(iarray,prehash1,prehash2)
     endif

  end subroutine ichk_zero

  subroutine rchk_zero(rarray)
     real(kind=rspec), dimension(:), intent(in) :: rarray

     integer :: ii

     izero=.TRUE.
     do ii=1,size(rarray)
        if(rarray(ii).ne.0.0_rspec) then
           izero=.FALSE.
           exit
        endif
     enddo

     if(.not.izero) then
        prehash1=17
        prehash2=23
        call hashCode(rarray,prehash1,prehash2)
     endif

  end subroutine rchk_zero

  subroutine cchk_zero(c32array)
     character*32, dimension(:), intent(in) :: c32array

     integer :: ii

     izero=.TRUE.
     do ii=1,size(c32array)
        if(c32array(ii).ne." ") then
           izero=.FALSE.
           exit
        endif
     enddo

     if(.not.izero) then
        prehash1=17
        prehash2=23
        call hashCode(c32array,prehash1,prehash2)
     endif

  end subroutine cchk_zero

  subroutine ichk_hash(itemName,iarray)
     character*(*), intent(in) :: itemName
     integer, dimension(:), intent(in) :: iarray

     posthash1=17
     posthash2=23
     call hashCode(iarray,posthash1,posthash2)

     if((prehash1.ne.posthash1).OR.(prehash2.ne.posthash2)) then
        write(iout,*) ' ?ps_update_file_read: value change detected in dimension quantity: '//trim(itemName)
        iertot = iertot + 1
     endif

  end subroutine ichk_hash

  subroutine rchk_hash(itemName,rarray)
     character*(*), intent(in) :: itemName
     real(kind=rspec), dimension(:), intent(in) :: rarray

     posthash1=17
     posthash2=23
     call hashCode(rarray,posthash1,posthash2)

     if((prehash1.ne.posthash1).OR.(prehash2.ne.posthash2)) then
        write(iout,*) ' ?ps_update_file_read: value change detected in dimension quantity: '//trim(itemName)
        iertot = iertot + 1
     endif

  end subroutine rchk_hash

  subroutine cchk_hash(itemName,c32array)
     character*(*), intent(in) :: itemName
     character*32, dimension(:), intent(in) :: c32array

     posthash1=17
     posthash2=23
     call hashCode(c32array,posthash1,posthash2)

     if((prehash1.ne.posthash1).OR.(prehash2.ne.posthash2)) then
        write(iout,*) ' ?ps_update_file_read: value change detected in dimension quantity: '//trim(itemName)
        iertot = iertot + 1
     endif

  end subroutine cchk_hash

  SUBROUTINE ichk_dim(ival,jval,dname)
     INTEGER, intent(in) :: ival  ! file dimension value
     INTEGER, intent(in) :: jval  ! state dimension value
     CHARACTER*(*), intent(in) :: dname

     IF(ival.ne.jval) THEN
        WRITE(iout,*) ' ?ps_update_file_read: update file dimension not consistent with state:'
        WRITE(iout,*) '  file value:  ',ival
        WRITE(iout,*) '  state value: ',jval
        WRITE(iout,*) '  dimension name: '//trim(dname)
        iertot = iertot + 1
     ENDIF
  END SUBROUTINE ichk_dim

  SUBROUTINE ncerr(status)
     INTEGER, INTENT(in) :: status

     nc_errmsg = NF90_strerror(status)
     write(iout,*) '  NetCDF message: ',trim(nc_errmsg)
  END SUBROUTINE ncerr

  SUBROUTINE denull(str)
     ! convert null characters to blank
     CHARACTER*(*) :: str
     INTEGER :: i

     do i=1,len(str)
        if(ichar(str(i:i)).eq.0) str(i:i)=' '
     enddo
  END SUBROUTINE denull

END SUBROUTINE ps_update_file_read_0

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


SUBROUTINE plasma_state_store_def_8(ss,icdf,iout,iertot)


  !  define subset of variables and arrays for NetCDF file

  USE plasma_state_definition_mod
  USE netcdf
  IMPLICIT NONE

  TYPE (plasma_state) :: ss     ! state data to read
  INTEGER, INTENT(IN) :: icdf   ! NetCDF file ID
  INTEGER, INTENT(IN) :: iout   ! message LUN
  INTEGER, INTENT(INOUT) :: iertot  ! error count

  !--------------

  INTEGER :: varid,dimid,status,ival,idims(20),indim
  CHARACTER*80 :: nc_errmsg

  !--------------
  !  define variables...


  indim = 0
  CALL define_var("tfinal","R",indim,idims, &
         "stop time of simulation (may be adjustable)", &
         "sec","PLASMA","SIMULATION_INIT", &
         "R  tfinal")

  IF(ALLOCATED(ss%tfrip2_log)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nr_rip",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nz_rip",idims(indim))
     CALL define_var("tfrip2_log","R",indim,idims, &
            "2nd component of TF ripple", &
            "-","RIPPLE","STATE_PROFILES", &
            "R|pclin  tfrip2_log(nR_rip,nZ_rip)")
  ENDIF

  IF(ALLOCATED(ss%tfrip_log)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nr_rip",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nz_rip",idims(indim))
     CALL define_var("tfrip_log","R",indim,idims, &
            "TF ripple: log((Bmax-Bmin)/(Bmax+Bmin))", &
            "-","RIPPLE","STATE_PROFILES", &
            "R|pclin  tfrip_log(nR_rip,nZ_rip)")
  ENDIF

  indim = 1
  status = nf90_inq_dimid(icdf,"ps_clen_80",idims(1))
  CALL define_var("TF_Data_Info","C*80",indim,idims, &
         "information on source of toroidal field data", &
         "__NONE","PLASMA","SIMULATION_INIT", &
         "C*80   TF_Data_Info")

  IF(ALLOCATED(ss%thegrilh)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_max_nspectrumlh_src",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nlhrf_src",idims(indim))
     CALL define_var("thegrilh","R",indim,idims, &
            "need description", &
            "-","LH","SHOT_CONFIGURATION", &
            "R|units=- thegrilh(nspectrumlh_src(),nlhrf_src)")
  ENDIF

  IF(ALLOCATED(ss%th_eq)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nth_eq",idims(indim))
     CALL define_var("th_eq","R",indim,idims, &
            "theta grid (EQ)", &
            "rad","EQ","SIMULATION_INIT", &
            "G|CCW   th_eq(nth_eq)")
  ENDIF

  IF(ALLOCATED(ss%Ti)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho",idims(indim))
     CALL define_var("Ti","R",indim,idims, &
            "ion temperature", &
            "keV","PLASMA","STATE_PROFILES", &
            "R|units=keV|step*ni Ti(~nrho)")
  ENDIF

  IF(ALLOCATED(ss%tiflux_ky_tglf)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nky_anomth",idims(indim))
     CALL define_var("tiflux_ky_tglf","R",indim,idims, &
            "ion density flux spectrum", &
            "GB","ANOM","STATE_PROFILES", &
            "R|units=GB|pclin tiflux_ky_tglf(nrho_anomth,nky_anomth)")
  ENDIF

  indim = 0
  CALL define_var("tinit","R",indim,idims, &
         "start time of simulation", &
         "sec","PLASMA","SIMULATION_INIT", &
         "R  tinit")

  indim = 0
  CALL define_var("Ti_bdy","R",indim,idims, &
         "Ion temperature at/beyond boundary", &
         "KeV","PLASMA","STATE_DATA", &
         "R Ti_bdy")

  IF(ALLOCATED(ss%ti_ky_tglf)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nky_anomth",idims(indim))
     CALL define_var("ti_ky_tglf","R",indim,idims, &
            "ion density fluctuation spectrum", &
            "GB","ANOM","STATE_PROFILES", &
            "R|units=GB|pclin ti_ky_tglf(nrho_anomth,nky_anomth)")
  ENDIF

  IF(ALLOCATED(ss%tmodel)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_anomth",idims(indim))
     CALL define_var("tmodel","R",indim,idims, &
            "target temperature profile", &
            "keV","ANOM","STATE_PROFILES", &
            "R|units=keV|step*nmodel   tmodel(~nrho_anomth)")
  ENDIF

  indim = 0
  CALL define_var("tmodel_bdy","R",indim,idims, &
         "model temperature, boundary value", &
         "keV","ANOM","STATE_DATA", &
         "R|units=keV    tmodel_bdy")

  indim = 1
  status = nf90_inq_dimid(icdf,"ps_clen_32",idims(1))
  CALL define_var("tokamak_id","N",indim,idims, &
         "Tokamak (Machine Description) ID", &
         "__NONE","PLASMA","MACHINE_DESCRIPTION", &
         "N  tokamak_id")

  IF(ALLOCATED(ss%Tornum_balcrit)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nballoon",idims(indim))
     CALL define_var("Tornum_balcrit","I",indim,idims, &
            "critical toroidal mode number for ballooning", &
            "__NONE","LMHD","STATE_DATA", &
            "I   Tornum_balcrit(nballoon)")
  ENDIF

  IF(ALLOCATED(ss%Tor_mode_label)) THEN
     indim = 1
     status = nf90_inq_dimid(icdf,"ps_clen_32",idims(1))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_mmodes",idims(indim))
     CALL define_var("Tor_mode_label","N",indim,idims, &
            "Toroidal modes to monitor", &
            "__NONE","LMHD","SIMULATION_INIT", &
            "L|toroidal_modes Tor_mode_label(mmodes)")
  ENDIF

  IF(ALLOCATED(ss%Tor_mode_No)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_mmodes",idims(indim))
     CALL define_var("Tor_mode_No","I",indim,idims, &
            "(from input) Toroidal modes monitored", &
            "__NONE","LMHD","SIMULATION_INIT", &
            "I   Tor_mode_No(mmodes)")
  ENDIF

  IF(ALLOCATED(ss%tq0_reco)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_gas",idims(indim))
     CALL define_var("tq0_reco","R",indim,idims, &
            "torque of recombination neutral source", &
            "Nt*m","GAS","STATE_PROFILES", &
            "R|step*dV   tq0_reco(~nrho_gas)")
  ENDIF

  IF(ALLOCATED(ss%tqb0_halo)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_nbi",idims(indim))
     CALL define_var("tqb0_halo","R",indim,idims, &
            "torque of halo neutral source", &
            "Nt*m","NBI","STATE_PROFILES", &
            "R|step*dV   tqb0_halo(~nrho_nbi)")
  ENDIF

  IF(ALLOCATED(ss%tqbe)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_nbi",idims(indim))
     CALL define_var("tqbe","R",indim,idims, &
            "collisional beam torque to electrons", &
            "Nt*m","NBI","STATE_PROFILES", &
            "R|step*dV   tqbe(~nrho_nbi)")
  ENDIF

  IF(ALLOCATED(ss%tqbi)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_nbi",idims(indim))
     CALL define_var("tqbi","R",indim,idims, &
            "collisional beam torque to thermal ions", &
            "Nt*m","NBI","STATE_PROFILES", &
            "R|step*dV   tqbi(~nrho_nbi)")
  ENDIF

  IF(ALLOCATED(ss%tqbjxb)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_nbi",idims(indim))
     CALL define_var("tqbjxb","R",indim,idims, &
            "JxB beam torque", &
            "Nt*m","NBI","STATE_PROFILES", &
            "R|step*dV   tqbjxb(~nrho_nbi)")
  ENDIF

  IF(ALLOCATED(ss%tqbth)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_nbi",idims(indim))
     CALL define_var("tqbth","R",indim,idims, &
            "momentum in thermalization of beam ions", &
            "Nt*m","NBI","STATE_PROFILES", &
            "R|step*dV   tqbth(~nrho_nbi)")
  ENDIF

  IF(ALLOCATED(ss%tqcx_halo)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_nbi",idims(indim))
     CALL define_var("tqcx_halo","R",indim,idims, &
            "beam halo driven CX momentum torque", &
            "Nt*m","NBI","STATE_PROFILES", &
            "R|step*dV   tqcx_halo(~nrho_nbi)")
  ENDIF

  IF(ALLOCATED(ss%tqcx_reco)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_gas",idims(indim))
     CALL define_var("tqcx_reco","R",indim,idims, &
            "reco driven CX momentum torque", &
            "Nt*m","GAS","STATE_PROFILES", &
            "R|step*dV   tqcx_reco(~nrho_gas)")
  ENDIF

  IF(ALLOCATED(ss%tqioniz)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_gas",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_ngsc0",idims(indim))
     CALL define_var("tqioniz","R",indim,idims, &
            "ionization torque per unit influx (sc0)", &
            "Nt*m/(#/sec)","GAS","STATE_PROFILES", &
            "R|step*dV|units=Nt*m/(#/sec)     tqioniz(~nrho_gas,ngsc0)")
  ENDIF

  IF(ALLOCATED(ss%tqqcx)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_gas",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_ngsc0",idims(indim))
     CALL define_var("tqqcx","R",indim,idims, &
            "cx torque per unit influx per (omeg0-omegi)", &
            "Nt*m/(#/sec)/(rad/sec)","GAS","STATE_PROFILES", &
            "R|step*dV|units=Nt*m/(#/sec)/(rad/sec)  tqqcx(~nrho_gas,ngsc0)")
  ENDIF

  IF(ALLOCATED(ss%tqsc_halo)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_nbi",idims(indim))
     CALL define_var("tqsc_halo","R",indim,idims, &
            "beam halo torque: recapture - tqb0_halo", &
            "Nt*m","NBI","STATE_PROFILES", &
            "R|step*dV   tqsc_halo(~nrho_nbi)")
  ENDIF

  IF(ALLOCATED(ss%tqsc_reco)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_gas",idims(indim))
     CALL define_var("tqsc_reco","R",indim,idims, &
            "reco torque: recapture - tq0_reco", &
            "Nt*m","GAS","STATE_PROFILES", &
            "R|step*dV   tqsc_reco(~nrho_gas)")
  ENDIF

  IF(ALLOCATED(ss%tq_anom)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_anomth",idims(indim))
     CALL define_var("tq_anom","R",indim,idims, &
            "anomalous torque", &
            "Nt*m","ANOM","STATE_PROFILES", &
            "R|units=Nt*m|step*dV  tq_anom(~nrho_anomth)")
  ENDIF

  IF(ALLOCATED(ss%tq_trans)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho",idims(indim))
     CALL define_var("tq_trans","R",indim,idims, &
            "angular momentum transport (loss)", &
            "Nt*m","PLASMA","STATE_PROFILES", &
            "R|units=Nt*m|step*dV  tq_trans(~nrho)")
  ENDIF

  IF(ALLOCATED(ss%tq_transcat)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_ntrcat",idims(indim))
     CALL define_var("tq_transcat","R",indim,idims, &
            "toroidal angular momentum transport", &
            "Nt*m","PLASMA","STATE_PROFILES", &
            "R|step*dV|units=Nt*m  tq_transcat(~nrho,ntrcat)")
  ENDIF

  IF(ALLOCATED(ss%trace_flag)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nbeam",idims(indim))
     CALL define_var("trace_flag","I",indim,idims, &
            "trace element flag", &
            "__NONE","NBI","SIMULATION_INIT", &
            "I  trace_flag(nbeam)")
  ENDIF

  IF(ALLOCATED(ss%trcat)) THEN
     indim = 1
     status = nf90_inq_dimid(icdf,"ps_clen_32",idims(1))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_ntrcat",idims(indim))
     CALL define_var("trcat","N",indim,idims, &
            "Application defined list of", &
            "__NONE","PLASMA","SIMULATION_INIT", &
            "L|TR_categories  trcat(ntrcat)")
  ENDIF

  IF(ALLOCATED(ss%triang)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_eq_geo",idims(indim))
     CALL define_var("triang","R",indim,idims, &
            "triangularity (symmetrized)", &
            "-","EQ","STATE_PROFILES", &
            "R|pclin  triang(nrho_eq_geo)")
  ENDIF

  IF(ALLOCATED(ss%triangL)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_eq_geo",idims(indim))
     CALL define_var("triangL","R",indim,idims, &
            "lower triangularity", &
            "-","EQ","STATE_PROFILES", &
            "R|pclin  triangL(nrho_eq_geo)")
  ENDIF

  IF(ALLOCATED(ss%triangU)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_eq_geo",idims(indim))
     CALL define_var("triangU","R",indim,idims, &
            "upper triangularity", &
            "-","EQ","STATE_PROFILES", &
            "R|pclin  triangU(nrho_eq_geo)")
  ENDIF

  IF(ALLOCATED(ss%triang_miller_L)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_eq_geo",idims(indim))
     CALL define_var("triang_miller_L","R",indim,idims, &
            "Miller lower triangularity", &
            "-","EQ","STATE_PROFILES", &
            "R|pclin  triang_miller_L(nrho_eq_geo)")
  ENDIF

  IF(ALLOCATED(ss%triang_miller_U)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_eq_geo",idims(indim))
     CALL define_var("triang_miller_U","R",indim,idims, &
            "Miller upper triangularity", &
            "-","EQ","STATE_PROFILES", &
            "R|pclin  triang_miller_U(nrho_eq_geo)")
  ENDIF

  IF(ALLOCATED(ss%trmodels)) THEN
     indim = 1
     status = nf90_inq_dimid(icdf,"ps_clen_256",idims(1))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_ntrcat",idims(indim))
     CALL define_var("trmodels","C*256",indim,idims, &
            "short description or ID of transport models", &
            "__NONE","PLASMA","SIMULATION_INIT", &
            "C*256 trmodels(ntrcat)")
  ENDIF

  IF(ALLOCATED(ss%Ts)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dp1_nspec_th",idims(indim))
     CALL define_var("Ts","R",indim,idims, &
            "thermal specie temperature", &
            "keV","PLASMA","STATE_PROFILES", &
            "R|units=keV|alias=T|step*ns  Ts(~nrho,0:nspec_th)")
  ENDIF

  indim = 1
  status = nf90_inq_dimid(icdf,"ps_clen_80",idims(1))
  CALL define_var("Ts_Data_Info","C*80",indim,idims, &
         "information on source of Temperature data", &
         "__NONE","PLASMA","SIMULATION_INIT", &
         "C*80   Ts_Data_Info")

  IF(ALLOCATED(ss%Ts_is_input)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dp1_nspec_th",idims(indim))
     CALL define_var("Ts_is_input","I",indim,idims, &
            "specie temperature measurement flag", &
            "__NONE","PLASMA","STATE_DATA", &
            "I Ts_is_input(0:nspec_th)")
  ENDIF

  IF(ALLOCATED(ss%tzflux_ky_tglf)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nky_anomth",idims(indim))
     CALL define_var("tzflux_ky_tglf","R",indim,idims, &
            "impurity density flux spectrum", &
            "GB","ANOM","STATE_PROFILES", &
            "R|units=GB|pclin tzflux_ky_tglf(nrho_anomth,nky_anomth)")
  ENDIF

  IF(ALLOCATED(ss%tz_ky_tglf)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nky_anomth",idims(indim))
     CALL define_var("tz_ky_tglf","R",indim,idims, &
            "impurity density fluctuation spectrum", &
            "GB","ANOM","STATE_PROFILES", &
            "R|units=GB|pclin tz_ky_tglf(nrho_anomth,nky_anomth)")
  ENDIF

  IF(ALLOCATED(ss%T_einj_standard)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_n_t_einj_standard",idims(indim))
     CALL define_var("T_einj_standard","R",indim,idims, &
            "T beam table energies", &
            "keV","NBI","MACHINE_DESCRIPTION", &
            "R|units=keV T_einj_standard(n_T_einj_standard)")
  ENDIF

  IF(ALLOCATED(ss%T_ffull_standard)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_n_t_einj_standard",idims(indim))
     CALL define_var("T_ffull_standard","R",indim,idims, &
            "T beam full energy fractions", &
            "-","NBI","MACHINE_DESCRIPTION", &
            "R|units=- T_ffull_standard(n_T_einj_standard)")
  ENDIF

  IF(ALLOCATED(ss%T_fhalf_standard)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_n_t_einj_standard",idims(indim))
     CALL define_var("T_fhalf_standard","R",indim,idims, &
            "T beam half energy fractions", &
            "-","NBI","MACHINE_DESCRIPTION", &
            "R|units=- T_fhalf_standard(n_T_einj_standard)")
  ENDIF

  IF(ALLOCATED(ss%upwind_pfrac_ns)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dp1_nspec_th",idims(indim))
     CALL define_var("upwind_pfrac_ns","R",indim,idims, &
            "specie density forward upwind fractions", &
            "-","PLASMA","STATE_PROFILES", &
            "R|units=-|pclin upwind_pfrac_ns(nrho,0:nspec_th)")
  ENDIF

  IF(ALLOCATED(ss%upwind_pfrac_omega)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho",idims(indim))
     CALL define_var("upwind_pfrac_omega","R",indim,idims, &
            "omega (ang. velocity) forward upwind fraction", &
            "-","PLASMA","STATE_PROFILES", &
            "R|pclin upwind_pfrac_omega(nrho)")
  ENDIF

  IF(ALLOCATED(ss%upwind_pfrac_Te)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho",idims(indim))
     CALL define_var("upwind_pfrac_Te","R",indim,idims, &
            "Te (electron energy advection) forward upwind fraction", &
            "-","PLASMA","STATE_PROFILES", &
            "R|pclin upwind_pfrac_Te(nrho)")
  ENDIF

  IF(ALLOCATED(ss%upwind_pfrac_Ti)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho",idims(indim))
     CALL define_var("upwind_pfrac_Ti","R",indim,idims, &
            "Ti (ion energy advection) forward upwind fraction", &
            "-","PLASMA","STATE_PROFILES", &
            "R|pclin upwind_pfrac_Ti(nrho)")
  ENDIF

  IF(ALLOCATED(ss%vee_trans)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho",idims(indim))
     CALL define_var("vee_trans","R",indim,idims, &
            "electron energy radial velocity", &
            "m/sec","PLASMA","STATE_PROFILES", &
            "R|pclin   vee_trans(nrho)")
  ENDIF

  IF(ALLOCATED(ss%vee_transcat)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_ntrcat",idims(indim))
     CALL define_var("vee_transcat","R",indim,idims, &
            "Electron energy radial velocity", &
            "m/sec","PLASMA","STATE_PROFILES", &
            "R|units=m/sec|pclin vee_transcat(nrho,ntrcat)")
  ENDIF

  IF(ALLOCATED(ss%velb_fusi)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anom",idims(indim))
     CALL define_var("velb_fusi","R",indim,idims, &
            "fusion ion anom. radial velocity", &
            "m/sec","ANOM","STATE_PROFILES", &
            "R|pclin  velb_fusi(nrho_anom)")
  ENDIF

  IF(ALLOCATED(ss%velb_nbi)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anom",idims(indim))
     CALL define_var("velb_nbi","R",indim,idims, &
            "beam ion anom. radial velocity", &
            "m/sec","ANOM","STATE_PROFILES", &
            "R|pclin  velb_nbi(nrho_anom)")
  ENDIF

  IF(ALLOCATED(ss%velb_rfmi)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anom",idims(indim))
     CALL define_var("velb_rfmi","R",indim,idims, &
            "RF minority ion anom. radial velocity", &
            "m/sec","ANOM","STATE_PROFILES", &
            "R|pclin  velb_rfmi(nrho_anom)")
  ENDIF

  IF(ALLOCATED(ss%velne_nclass)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     CALL define_var("velne_nclass","R",indim,idims, &
            "electron-density-equations, advective velocity term from NCLASS model", &
            "m/sec","ANOM","STATE_PROFILES", &
            "R|units=m/sec|pclin velne_nclass(nrho_anomth)")
  ENDIF

  IF(ALLOCATED(ss%velnh_nclass)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     CALL define_var("velnh_nclass","R",indim,idims, &
            "main-hydrogenic-density-equations, advective velocity term from NCLASS model", &
            "m/sec","ANOM","STATE_PROFILES", &
            "R|units=m/sec|pclin velnh_nclass(nrho_anomth)")
  ENDIF

  IF(ALLOCATED(ss%velni_drbm)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     CALL define_var("velni_drbm","R",indim,idims, &
            "ion convective velocity", &
            "m/s","ANOM","STATE_PROFILES", &
            "R|units=m/s|pclin velni_drbm(nrho_anomth)")
  ENDIF

  IF(ALLOCATED(ss%velns_anom)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dp1_nspec_th",idims(indim))
     CALL define_var("velns_anom","R",indim,idims, &
            "density-equations, advective velocity term", &
            "m/sec","ANOM","STATE_PROFILES", &
            "R|units=m/sec|pclin  velns_anom(nrho_anomth,0:nspec_th)")
  ENDIF

  IF(ALLOCATED(ss%velns_glf)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dp1_nspec_th",idims(indim))
     CALL define_var("velns_glf","R",indim,idims, &
            "density-equations, advective velocity term from GLF23 model", &
            "m/sec","ANOM","STATE_PROFILES", &
            "R|units=m/sec|pclin  velns_glf(nrho_anomth,0:nspec_th)")
  ENDIF

  IF(ALLOCATED(ss%velns_gtcneo)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dp1_nspec_th",idims(indim))
     CALL define_var("velns_gtcneo","R",indim,idims, &
            "density-equations, advective velocity term from GTC_NEO model", &
            "m/sec","ANOM","STATE_PROFILES", &
            "R|units=m/sec|pclin  velns_gtcneo(nrho_anomth,0:nspec_th)")
  ENDIF

  IF(ALLOCATED(ss%velns_mmm71)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dp1_nspec_th",idims(indim))
     CALL define_var("velns_mmm71","R",indim,idims, &
            "density-equations, advective velocity term from MMM71 model", &
            "m/sec","ANOM","STATE_PROFILES", &
            "R|units=m/sec|pclin  velns_mmm71(nrho_anomth,0:nspec_th)")
  ENDIF

  IF(ALLOCATED(ss%velns_nclass)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dp1_nspec_th",idims(indim))
     CALL define_var("velns_nclass","R",indim,idims, &
            "density-equations, advective velocity term from NCLASS model", &
            "m/sec","ANOM","STATE_PROFILES", &
            "R|units=m/sec|pclin velns_nclass(nrho_anomth,0:nspec_th)")
  ENDIF

  IF(ALLOCATED(ss%velns_neo)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dp1_nspec_th",idims(indim))
     CALL define_var("velns_neo","R",indim,idims, &
            "density-equations, advective velocity term from NEO model", &
            "m/sec","ANOM","STATE_PROFILES", &
            "R|units=m/sec|pclin  velns_neo(nrho_anomth,0:nspec_th)")
  ENDIF

  IF(ALLOCATED(ss%velns_tglf)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dp1_nspec_th",idims(indim))
     CALL define_var("velns_tglf","R",indim,idims, &
            "density-equations, advective velocity term from TGLF model", &
            "m/sec","ANOM","STATE_PROFILES", &
            "R|units=m/sec|pclin velns_tglf(nrho_anomth,0:nspec_th)")
  ENDIF

  IF(ALLOCATED(ss%velnx_nclass)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     CALL define_var("velnx_nclass","R",indim,idims, &
            "main-impurity-density-equations, advective velocity term from NCLASS model", &
            "m/sec","ANOM","STATE_PROFILES", &
            "R|units=m/sec|pclin velnx_nclass(nrho_anomth)")
  ENDIF

  IF(ALLOCATED(ss%velpphi_anom)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     CALL define_var("velpphi_anom","R",indim,idims, &
            "momentum-equation, advective velocity term", &
            "m/sec","ANOM","STATE_PROFILES", &
            "R|units=m/sec|pclin  velpphi_anom(nrho_anomth)")
  ENDIF

  IF(ALLOCATED(ss%velpphi_glf)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     CALL define_var("velpphi_glf","R",indim,idims, &
            "momentum-equation, advective velocity term from GLF23 model", &
            "m/sec","ANOM","STATE_PROFILES", &
            "R|units=m/sec|pclin  velpphi_glf(nrho_anomth)")
  ENDIF

  IF(ALLOCATED(ss%velpphi_gtcneo)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     CALL define_var("velpphi_gtcneo","R",indim,idims, &
            "momentum-equation, advective velocity term from GTC_NEO model", &
            "m/sec","ANOM","STATE_PROFILES", &
            "R|units=m/sec|pclin  velpphi_gtcneo(nrho_anomth)")
  ENDIF

  IF(ALLOCATED(ss%velpphi_mmm71)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     CALL define_var("velpphi_mmm71","R",indim,idims, &
            "momentum-equation, advective velocity term from MMM71 model", &
            "m/sec","ANOM","STATE_PROFILES", &
            "R|units=m/sec|pclin  velpphi_mmm71(nrho_anomth)")
  ENDIF

  IF(ALLOCATED(ss%velpphi_neo)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     CALL define_var("velpphi_neo","R",indim,idims, &
            "momentum-equation, advective velocity term from NEO model", &
            "m/sec","ANOM","STATE_PROFILES", &
            "R|units=m/sec|pclin  velpphi_neo(nrho_anomth)")
  ENDIF

  IF(ALLOCATED(ss%velpphi_tglf)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     CALL define_var("velpphi_tglf","R",indim,idims, &
            "momentum-equation, advective velocity term from TGLF model", &
            "m/sec","ANOM","STATE_PROFILES", &
            "R|units=m/sec|pclin velpphi_tglf(nrho_anomth)")
  ENDIF

  IF(ALLOCATED(ss%velte_anom)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     CALL define_var("velte_anom","R",indim,idims, &
            "Te-equation, advective velocity term", &
            "m/sec","ANOM","STATE_PROFILES", &
            "R|units=m/sec|pclin  velte_anom(nrho_anomth)")
  ENDIF

  IF(ALLOCATED(ss%velte_glf)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     CALL define_var("velte_glf","R",indim,idims, &
            "Te-equation, advective velocity term from GLF23 model", &
            "m/sec","ANOM","STATE_PROFILES", &
            "R|units=m/sec|pclin  velte_glf(nrho_anomth)")
  ENDIF

  IF(ALLOCATED(ss%velte_gtcneo)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     CALL define_var("velte_gtcneo","R",indim,idims, &
            "Te-equation, advective velocity term from GTC_NEO model", &
            "m/sec","ANOM","STATE_PROFILES", &
            "R|units=m/sec|pclin  velte_gtcneo(nrho_anomth)")
  ENDIF

  CONTAINS


     SUBROUTINE define_var(name,dtype,indim,idims, &
          long_name,units,component,section,spec)

        CHARACTER*(*), INTENT(in) :: name
        CHARACTER*(*), INTENT(in) :: dtype
        INTEGER, INTENT(in) :: indim
        INTEGER, dimension(:), INTENT(in) :: idims
        CHARACTER*(*), INTENT(in) :: long_name
        CHARACTER*(*), INTENT(in) :: units
        CHARACTER*(*), INTENT(in) :: component
        CHARACTER*(*), INTENT(in) :: section
        CHARACTER*(*), INTENT(in) :: spec

        integer :: itype

        IF(dtype.EQ.'R') THEN
           itype = NF90_DOUBLE

        ELSE IF (dtype.EQ.'I') THEN
           itype = NF90_INT

        ELSE
           itype = NF90_CHAR

        ENDIF

        IF(indim.EQ.0) THEN
           status=nf90_def_var(icdf,name,itype, varid=varid)

        ELSE
           status=nf90_def_var(icdf,name,itype, dimids=idims(1:indim),varid=varid)

        ENDIF

        IF(status.NE.NF90_NOERR) THEN
           WRITE(iout,*) " ?plasma_state_store: error defining variable: "//trim(name)
           CALL ncerr(status)
           iertot = iertot + 1
           RETURN
        ENDIF

        ! Variable OK, now add attributes:

        CALL add_attrib("long_name",long_name)
        IF(dtype.EQ.'R') CALL add_attrib("units",units)
        CALL add_attrib("component",component)
        CALL add_attrib("section",section)
        CALL add_attrib("specification",spec)

     END SUBROUTINE define_var

     SUBROUTINE add_attrib(name,value)
        CHARACTER*(*), intent(in) :: name
        CHARACTER*(*), intent(in) :: value

        status=nf90_put_att(icdf,varid,name,value)
        IF(status.NE.NF90_NOERR) THEN
           WRITE(iout,*) " ?plasma_state_store: error defining attribute: "//trim(name)//' = '//trim(value)
           CALL ncerr(status)
           iertot = iertot + 1
        ENDIF
     END SUBROUTINE add_attrib

     SUBROUTINE ncerr(status)
        INTEGER, INTENT(in) :: status

        nc_errmsg = NF90_strerror(status)
        write(iout,*) '  NetCDF message: ',trim(nc_errmsg)
     END SUBROUTINE ncerr

END SUBROUTINE plasma_state_store_def_8


SUBROUTINE plasma_state_store_8(ss,icdf,iout,iertot)


  !  write subset of variables and arrays from NetCDF file

  USE plasma_state_definition_mod
  USE netcdf
  IMPLICIT NONE

  TYPE (plasma_state) :: ss     ! state data to read
  INTEGER, INTENT(IN) :: icdf   ! NetCDF file ID
  INTEGER, INTENT(IN) :: iout   ! message LUN
  INTEGER, INTENT(INOUT) :: iertot  ! error count

  !--------------

  INTEGER :: varid,dimid,status,ival,idims(20),indim
  CHARACTER*80 :: nc_errmsg

  !--------------
  !  write variables...


  status = nf90_inq_varid(icdf,"tfinal",varid)
  status = nf90_put_var(icdf,varid,ss%tfinal)
  IF(status.NE.NF90_NOERR) THEN
     WRITE(iout,*) " ?plasma_state_store: error storing: tfinal"
     CALL ncerr(status)
     iertot = iertot + 1
  ENDIF

  IF(ALLOCATED(ss%tfrip2_log)) THEN
     status = nf90_inq_varid(icdf,"tfrip2_log",varid)
     status = nf90_put_var(icdf,varid,ss%tfrip2_log)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: tfrip2_log"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%tfrip_log)) THEN
     status = nf90_inq_varid(icdf,"tfrip_log",varid)
     status = nf90_put_var(icdf,varid,ss%tfrip_log)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: tfrip_log"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"TF_Data_Info",varid)
  status = nf90_put_var(icdf,varid,ss%TF_Data_Info)
  IF(status.NE.NF90_NOERR) THEN
     WRITE(iout,*) " ?plasma_state_store: error storing: TF_Data_Info"
     CALL ncerr(status)
     iertot = iertot + 1
  ENDIF

  IF(ALLOCATED(ss%thegrilh)) THEN
     status = nf90_inq_varid(icdf,"thegrilh",varid)
     status = nf90_put_var(icdf,varid,ss%thegrilh)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: thegrilh"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%th_eq)) THEN
     status = nf90_inq_varid(icdf,"th_eq",varid)
     status = nf90_put_var(icdf,varid,ss%th_eq)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: th_eq"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%Ti)) THEN
     status = nf90_inq_varid(icdf,"Ti",varid)
     status = nf90_put_var(icdf,varid,ss%Ti)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: Ti"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%tiflux_ky_tglf)) THEN
     status = nf90_inq_varid(icdf,"tiflux_ky_tglf",varid)
     status = nf90_put_var(icdf,varid,ss%tiflux_ky_tglf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: tiflux_ky_tglf"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"tinit",varid)
  status = nf90_put_var(icdf,varid,ss%tinit)
  IF(status.NE.NF90_NOERR) THEN
     WRITE(iout,*) " ?plasma_state_store: error storing: tinit"
     CALL ncerr(status)
     iertot = iertot + 1
  ENDIF

  status = nf90_inq_varid(icdf,"Ti_bdy",varid)
  status = nf90_put_var(icdf,varid,ss%Ti_bdy)
  IF(status.NE.NF90_NOERR) THEN
     WRITE(iout,*) " ?plasma_state_store: error storing: Ti_bdy"
     CALL ncerr(status)
     iertot = iertot + 1
  ENDIF

  IF(ALLOCATED(ss%ti_ky_tglf)) THEN
     status = nf90_inq_varid(icdf,"ti_ky_tglf",varid)
     status = nf90_put_var(icdf,varid,ss%ti_ky_tglf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: ti_ky_tglf"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%tmodel)) THEN
     status = nf90_inq_varid(icdf,"tmodel",varid)
     status = nf90_put_var(icdf,varid,ss%tmodel)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: tmodel"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"tmodel_bdy",varid)
  status = nf90_put_var(icdf,varid,ss%tmodel_bdy)
  IF(status.NE.NF90_NOERR) THEN
     WRITE(iout,*) " ?plasma_state_store: error storing: tmodel_bdy"
     CALL ncerr(status)
     iertot = iertot + 1
  ENDIF

  status = nf90_inq_varid(icdf,"tokamak_id",varid)
  status = nf90_put_var(icdf,varid,ss%tokamak_id)
  IF(status.NE.NF90_NOERR) THEN
     WRITE(iout,*) " ?plasma_state_store: error storing: tokamak_id"
     CALL ncerr(status)
     iertot = iertot + 1
  ENDIF

  IF(ALLOCATED(ss%Tornum_balcrit)) THEN
     status = nf90_inq_varid(icdf,"Tornum_balcrit",varid)
     status = nf90_put_var(icdf,varid,ss%Tornum_balcrit)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: Tornum_balcrit"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%Tor_mode_label)) THEN
     status = nf90_inq_varid(icdf,"Tor_mode_label",varid)
     status = nf90_put_var(icdf,varid,ss%Tor_mode_label)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: Tor_mode_label"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%Tor_mode_No)) THEN
     status = nf90_inq_varid(icdf,"Tor_mode_No",varid)
     status = nf90_put_var(icdf,varid,ss%Tor_mode_No)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: Tor_mode_No"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%tq0_reco)) THEN
     status = nf90_inq_varid(icdf,"tq0_reco",varid)
     status = nf90_put_var(icdf,varid,ss%tq0_reco)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: tq0_reco"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%tqb0_halo)) THEN
     status = nf90_inq_varid(icdf,"tqb0_halo",varid)
     status = nf90_put_var(icdf,varid,ss%tqb0_halo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: tqb0_halo"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%tqbe)) THEN
     status = nf90_inq_varid(icdf,"tqbe",varid)
     status = nf90_put_var(icdf,varid,ss%tqbe)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: tqbe"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%tqbi)) THEN
     status = nf90_inq_varid(icdf,"tqbi",varid)
     status = nf90_put_var(icdf,varid,ss%tqbi)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: tqbi"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%tqbjxb)) THEN
     status = nf90_inq_varid(icdf,"tqbjxb",varid)
     status = nf90_put_var(icdf,varid,ss%tqbjxb)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: tqbjxb"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%tqbth)) THEN
     status = nf90_inq_varid(icdf,"tqbth",varid)
     status = nf90_put_var(icdf,varid,ss%tqbth)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: tqbth"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%tqcx_halo)) THEN
     status = nf90_inq_varid(icdf,"tqcx_halo",varid)
     status = nf90_put_var(icdf,varid,ss%tqcx_halo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: tqcx_halo"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%tqcx_reco)) THEN
     status = nf90_inq_varid(icdf,"tqcx_reco",varid)
     status = nf90_put_var(icdf,varid,ss%tqcx_reco)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: tqcx_reco"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%tqioniz)) THEN
     status = nf90_inq_varid(icdf,"tqioniz",varid)
     status = nf90_put_var(icdf,varid,ss%tqioniz)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: tqioniz"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%tqqcx)) THEN
     status = nf90_inq_varid(icdf,"tqqcx",varid)
     status = nf90_put_var(icdf,varid,ss%tqqcx)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: tqqcx"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%tqsc_halo)) THEN
     status = nf90_inq_varid(icdf,"tqsc_halo",varid)
     status = nf90_put_var(icdf,varid,ss%tqsc_halo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: tqsc_halo"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%tqsc_reco)) THEN
     status = nf90_inq_varid(icdf,"tqsc_reco",varid)
     status = nf90_put_var(icdf,varid,ss%tqsc_reco)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: tqsc_reco"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%tq_anom)) THEN
     status = nf90_inq_varid(icdf,"tq_anom",varid)
     status = nf90_put_var(icdf,varid,ss%tq_anom)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: tq_anom"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%tq_trans)) THEN
     status = nf90_inq_varid(icdf,"tq_trans",varid)
     status = nf90_put_var(icdf,varid,ss%tq_trans)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: tq_trans"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%tq_transcat)) THEN
     status = nf90_inq_varid(icdf,"tq_transcat",varid)
     status = nf90_put_var(icdf,varid,ss%tq_transcat)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: tq_transcat"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%trace_flag)) THEN
     status = nf90_inq_varid(icdf,"trace_flag",varid)
     status = nf90_put_var(icdf,varid,ss%trace_flag)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: trace_flag"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%trcat)) THEN
     status = nf90_inq_varid(icdf,"trcat",varid)
     status = nf90_put_var(icdf,varid,ss%trcat)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: trcat"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%triang)) THEN
     status = nf90_inq_varid(icdf,"triang",varid)
     status = nf90_put_var(icdf,varid,ss%triang)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: triang"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%triangL)) THEN
     status = nf90_inq_varid(icdf,"triangL",varid)
     status = nf90_put_var(icdf,varid,ss%triangL)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: triangL"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%triangU)) THEN
     status = nf90_inq_varid(icdf,"triangU",varid)
     status = nf90_put_var(icdf,varid,ss%triangU)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: triangU"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%triang_miller_L)) THEN
     status = nf90_inq_varid(icdf,"triang_miller_L",varid)
     status = nf90_put_var(icdf,varid,ss%triang_miller_L)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: triang_miller_L"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%triang_miller_U)) THEN
     status = nf90_inq_varid(icdf,"triang_miller_U",varid)
     status = nf90_put_var(icdf,varid,ss%triang_miller_U)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: triang_miller_U"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%trmodels)) THEN
     status = nf90_inq_varid(icdf,"trmodels",varid)
     status = nf90_put_var(icdf,varid,ss%trmodels)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: trmodels"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%Ts)) THEN
     status = nf90_inq_varid(icdf,"Ts",varid)
     status = nf90_put_var(icdf,varid,ss%Ts)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: Ts"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Ts_Data_Info",varid)
  status = nf90_put_var(icdf,varid,ss%Ts_Data_Info)
  IF(status.NE.NF90_NOERR) THEN
     WRITE(iout,*) " ?plasma_state_store: error storing: Ts_Data_Info"
     CALL ncerr(status)
     iertot = iertot + 1
  ENDIF

  IF(ALLOCATED(ss%Ts_is_input)) THEN
     status = nf90_inq_varid(icdf,"Ts_is_input",varid)
     status = nf90_put_var(icdf,varid,ss%Ts_is_input)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: Ts_is_input"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%tzflux_ky_tglf)) THEN
     status = nf90_inq_varid(icdf,"tzflux_ky_tglf",varid)
     status = nf90_put_var(icdf,varid,ss%tzflux_ky_tglf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: tzflux_ky_tglf"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%tz_ky_tglf)) THEN
     status = nf90_inq_varid(icdf,"tz_ky_tglf",varid)
     status = nf90_put_var(icdf,varid,ss%tz_ky_tglf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: tz_ky_tglf"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%T_einj_standard)) THEN
     status = nf90_inq_varid(icdf,"T_einj_standard",varid)
     status = nf90_put_var(icdf,varid,ss%T_einj_standard)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: T_einj_standard"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%T_ffull_standard)) THEN
     status = nf90_inq_varid(icdf,"T_ffull_standard",varid)
     status = nf90_put_var(icdf,varid,ss%T_ffull_standard)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: T_ffull_standard"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%T_fhalf_standard)) THEN
     status = nf90_inq_varid(icdf,"T_fhalf_standard",varid)
     status = nf90_put_var(icdf,varid,ss%T_fhalf_standard)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: T_fhalf_standard"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%upwind_pfrac_ns)) THEN
     status = nf90_inq_varid(icdf,"upwind_pfrac_ns",varid)
     status = nf90_put_var(icdf,varid,ss%upwind_pfrac_ns)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: upwind_pfrac_ns"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%upwind_pfrac_omega)) THEN
     status = nf90_inq_varid(icdf,"upwind_pfrac_omega",varid)
     status = nf90_put_var(icdf,varid,ss%upwind_pfrac_omega)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: upwind_pfrac_omega"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%upwind_pfrac_Te)) THEN
     status = nf90_inq_varid(icdf,"upwind_pfrac_Te",varid)
     status = nf90_put_var(icdf,varid,ss%upwind_pfrac_Te)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: upwind_pfrac_Te"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%upwind_pfrac_Ti)) THEN
     status = nf90_inq_varid(icdf,"upwind_pfrac_Ti",varid)
     status = nf90_put_var(icdf,varid,ss%upwind_pfrac_Ti)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: upwind_pfrac_Ti"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%vee_trans)) THEN
     status = nf90_inq_varid(icdf,"vee_trans",varid)
     status = nf90_put_var(icdf,varid,ss%vee_trans)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: vee_trans"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%vee_transcat)) THEN
     status = nf90_inq_varid(icdf,"vee_transcat",varid)
     status = nf90_put_var(icdf,varid,ss%vee_transcat)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: vee_transcat"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%velb_fusi)) THEN
     status = nf90_inq_varid(icdf,"velb_fusi",varid)
     status = nf90_put_var(icdf,varid,ss%velb_fusi)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: velb_fusi"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%velb_nbi)) THEN
     status = nf90_inq_varid(icdf,"velb_nbi",varid)
     status = nf90_put_var(icdf,varid,ss%velb_nbi)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: velb_nbi"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%velb_rfmi)) THEN
     status = nf90_inq_varid(icdf,"velb_rfmi",varid)
     status = nf90_put_var(icdf,varid,ss%velb_rfmi)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: velb_rfmi"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%velne_nclass)) THEN
     status = nf90_inq_varid(icdf,"velne_nclass",varid)
     status = nf90_put_var(icdf,varid,ss%velne_nclass)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: velne_nclass"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%velnh_nclass)) THEN
     status = nf90_inq_varid(icdf,"velnh_nclass",varid)
     status = nf90_put_var(icdf,varid,ss%velnh_nclass)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: velnh_nclass"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%velni_drbm)) THEN
     status = nf90_inq_varid(icdf,"velni_drbm",varid)
     status = nf90_put_var(icdf,varid,ss%velni_drbm)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: velni_drbm"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%velns_anom)) THEN
     status = nf90_inq_varid(icdf,"velns_anom",varid)
     status = nf90_put_var(icdf,varid,ss%velns_anom)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: velns_anom"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%velns_glf)) THEN
     status = nf90_inq_varid(icdf,"velns_glf",varid)
     status = nf90_put_var(icdf,varid,ss%velns_glf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: velns_glf"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%velns_gtcneo)) THEN
     status = nf90_inq_varid(icdf,"velns_gtcneo",varid)
     status = nf90_put_var(icdf,varid,ss%velns_gtcneo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: velns_gtcneo"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%velns_mmm71)) THEN
     status = nf90_inq_varid(icdf,"velns_mmm71",varid)
     status = nf90_put_var(icdf,varid,ss%velns_mmm71)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: velns_mmm71"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%velns_nclass)) THEN
     status = nf90_inq_varid(icdf,"velns_nclass",varid)
     status = nf90_put_var(icdf,varid,ss%velns_nclass)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: velns_nclass"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%velns_neo)) THEN
     status = nf90_inq_varid(icdf,"velns_neo",varid)
     status = nf90_put_var(icdf,varid,ss%velns_neo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: velns_neo"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%velns_tglf)) THEN
     status = nf90_inq_varid(icdf,"velns_tglf",varid)
     status = nf90_put_var(icdf,varid,ss%velns_tglf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: velns_tglf"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%velnx_nclass)) THEN
     status = nf90_inq_varid(icdf,"velnx_nclass",varid)
     status = nf90_put_var(icdf,varid,ss%velnx_nclass)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: velnx_nclass"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%velpphi_anom)) THEN
     status = nf90_inq_varid(icdf,"velpphi_anom",varid)
     status = nf90_put_var(icdf,varid,ss%velpphi_anom)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: velpphi_anom"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%velpphi_glf)) THEN
     status = nf90_inq_varid(icdf,"velpphi_glf",varid)
     status = nf90_put_var(icdf,varid,ss%velpphi_glf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: velpphi_glf"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%velpphi_gtcneo)) THEN
     status = nf90_inq_varid(icdf,"velpphi_gtcneo",varid)
     status = nf90_put_var(icdf,varid,ss%velpphi_gtcneo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: velpphi_gtcneo"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%velpphi_mmm71)) THEN
     status = nf90_inq_varid(icdf,"velpphi_mmm71",varid)
     status = nf90_put_var(icdf,varid,ss%velpphi_mmm71)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: velpphi_mmm71"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%velpphi_neo)) THEN
     status = nf90_inq_varid(icdf,"velpphi_neo",varid)
     status = nf90_put_var(icdf,varid,ss%velpphi_neo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: velpphi_neo"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%velpphi_tglf)) THEN
     status = nf90_inq_varid(icdf,"velpphi_tglf",varid)
     status = nf90_put_var(icdf,varid,ss%velpphi_tglf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: velpphi_tglf"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%velte_anom)) THEN
     status = nf90_inq_varid(icdf,"velte_anom",varid)
     status = nf90_put_var(icdf,varid,ss%velte_anom)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: velte_anom"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%velte_glf)) THEN
     status = nf90_inq_varid(icdf,"velte_glf",varid)
     status = nf90_put_var(icdf,varid,ss%velte_glf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: velte_glf"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%velte_gtcneo)) THEN
     status = nf90_inq_varid(icdf,"velte_gtcneo",varid)
     status = nf90_put_var(icdf,varid,ss%velte_gtcneo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: velte_gtcneo"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  CONTAINS


     SUBROUTINE ncerr(status)
        INTEGER, INTENT(in) :: status

        nc_errmsg = NF90_strerror(status)
        write(iout,*) '  NetCDF message: ',trim(nc_errmsg)
     END SUBROUTINE ncerr

END SUBROUTINE plasma_state_store_8

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_g3_dummy
     return
  end subroutine ccps_getset_g3_dummy

subroutine psget_grho1(iobj, n1, data, ierr)
    !! <|grad(rho)|>
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_grho1', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % grho1
end subroutine psget_grho1


subroutine psset_grho1(iobj, n1, data, ierr)
    !! <|grad(rho)|>
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_grho1', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % grho1 = data(1:n1)
end subroutine psset_grho1


subroutine psgetrnk_grho1(iobj, ndims, ierr)
    !! <|grad(rho)|>
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_grho1


subroutine psgetdim_grho1(iobj, ndims, dims, ierr)
    !! <|grad(rho)|>
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_grho1', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % grho1 ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % grho1)
    endif
end subroutine psgetdim_grho1


subroutine psget_gb1(iobj, n1, data, ierr)
    !! <|B|>
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_gb1', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % gb1
end subroutine psget_gb1


subroutine psset_gb1(iobj, n1, data, ierr)
    !! <|B|>
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_gb1', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % gb1 = data(1:n1)
end subroutine psset_gb1


subroutine psgetrnk_gb1(iobj, ndims, ierr)
    !! <|B|>
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_gb1


subroutine psgetdim_gb1(iobj, ndims, dims, ierr)
    !! <|B|>
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_gb1', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % gb1 ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % gb1)
    endif
end subroutine psgetdim_gb1


subroutine psget_growthrate_max_tglf(iobj, n1, data, ierr)
    !! maximum growthrate from TGLF model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_growthrate_max_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % growthrate_max_tglf
end subroutine psget_growthrate_max_tglf


subroutine psset_growthrate_max_tglf(iobj, n1, data, ierr)
    !! maximum growthrate from TGLF model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_growthrate_max_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % growthrate_max_tglf = data(1:n1)
end subroutine psset_growthrate_max_tglf


subroutine psgetrnk_growthrate_max_tglf(iobj, ndims, ierr)
    !! maximum growthrate from TGLF model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_growthrate_max_tglf


subroutine psgetdim_growthrate_max_tglf(iobj, ndims, dims, ierr)
    !! maximum growthrate from TGLF model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_growthrate_max_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % growthrate_max_tglf ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % growthrate_max_tglf)
    endif
end subroutine psgetdim_growthrate_max_tglf

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_c0_dummy
     return
  end subroutine ccps_getset_c0_dummy

subroutine psget_circuit_name(iobj, n1, data, ierr)
    !! Number & names of circuits, connecting coils affecting
    !! poloidal field-- axisymmetric coils,, or eddy currents
    !! represented as cancelling coil pairs
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    CHARACTER*(*), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_circuit_name', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % circuit_name
end subroutine psget_circuit_name


subroutine psset_circuit_name(iobj, n1, data, ierr)
    !! Number & names of circuits, connecting coils affecting
    !! poloidal field-- axisymmetric coils,, or eddy currents
    !! represented as cancelling coil pairs
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    CHARACTER*(*), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_circuit_name', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % circuit_name = data(1:n1)
end subroutine psset_circuit_name


subroutine psgetsz_circuit_name(iobj, size, ierr)
    !! Number & names of circuits, connecting coils affecting
    !! poloidal field-- axisymmetric coils,, or eddy currents
    !! represented as cancelling coil pairs
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: size    ! size of character string
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psgetsz_circuit_name', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! note that the following will return the character length size regardless of
    ! the number of array elements (if circuit_name is an array)
    size = len(ss % circuit_name)
end subroutine psgetsz_circuit_name


subroutine psgetrnk_circuit_name(iobj, ndims, ierr)
    !! Number & names of circuits, connecting coils affecting
    !! poloidal field-- axisymmetric coils,, or eddy currents
    !! represented as cancelling coil pairs
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_circuit_name


subroutine psgetdim_circuit_name(iobj, ndims, dims, ierr)
    !! Number & names of circuits, connecting coils affecting
    !! poloidal field-- axisymmetric coils,, or eddy currents
    !! represented as cancelling coil pairs
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_circuit_name', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % circuit_name ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % circuit_name)
    endif
end subroutine psgetdim_circuit_name


subroutine psget_curt(iobj, n1, data, ierr)
    !! total enclosed toroidal current, this includes <j.B>
    !! contributions and <j x B> contributions and, is related to the
    !! poloidal field:, mu0*I(rho) =
    !! rho*phit(nrho_eq)/(q(rho)*2*pi*pi), * grho2r2i(rho) *
    !! (dVol/drho)', "(From Ampere's Law, mu0*I_phi = loop integral
    !! (B_pol*dl)", '= loop integral (dl * grad(psi)/R), =
    !! rho*phit(nrho_eq)/(q(rho)*pi) *, loop integral (dl *
    !! grad(rho)/R), (2*pi) * loop integral (dl * grad(rho)/rho), =
    !! loop integral (dl * 2*pi*R/grad(rho) * grad(rho)**2/R**2), =
    !! grho2r2i(rho) * dVol/drho, derivation depends on the definition
    !! of the radial coord.:, rho = sqrt(phit(rho)/phit(rho=1)),
    !! curt(nrho_eq) gives the total current, >0 by convention;, see
    !! kccw_Jphi, +/-1, for direction of toroidal current.
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_curt', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % curt
end subroutine psget_curt


subroutine psset_curt(iobj, n1, data, ierr)
    !! total enclosed toroidal current, this includes <j.B>
    !! contributions and <j x B> contributions and, is related to the
    !! poloidal field:, mu0*I(rho) =
    !! rho*phit(nrho_eq)/(q(rho)*2*pi*pi), * grho2r2i(rho) *
    !! (dVol/drho)', "(From Ampere's Law, mu0*I_phi = loop integral
    !! (B_pol*dl)", '= loop integral (dl * grad(psi)/R), =
    !! rho*phit(nrho_eq)/(q(rho)*pi) *, loop integral (dl *
    !! grad(rho)/R), (2*pi) * loop integral (dl * grad(rho)/rho), =
    !! loop integral (dl * 2*pi*R/grad(rho) * grad(rho)**2/R**2), =
    !! grho2r2i(rho) * dVol/drho, derivation depends on the definition
    !! of the radial coord.:, rho = sqrt(phit(rho)/phit(rho=1)),
    !! curt(nrho_eq) gives the total current, >0 by convention;, see
    !! kccw_Jphi, +/-1, for direction of toroidal current.
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_curt', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % curt = data(1:n1)
end subroutine psset_curt


subroutine psgetrnk_curt(iobj, ndims, ierr)
    !! total enclosed toroidal current, this includes <j.B>
    !! contributions and <j x B> contributions and, is related to the
    !! poloidal field:, mu0*I(rho) =
    !! rho*phit(nrho_eq)/(q(rho)*2*pi*pi), * grho2r2i(rho) *
    !! (dVol/drho)', "(From Ampere's Law, mu0*I_phi = loop integral
    !! (B_pol*dl)", '= loop integral (dl * grad(psi)/R), =
    !! rho*phit(nrho_eq)/(q(rho)*pi) *, loop integral (dl *
    !! grad(rho)/R), (2*pi) * loop integral (dl * grad(rho)/rho), =
    !! loop integral (dl * 2*pi*R/grad(rho) * grad(rho)**2/R**2), =
    !! grho2r2i(rho) * dVol/drho, derivation depends on the definition
    !! of the radial coord.:, rho = sqrt(phit(rho)/phit(rho=1)),
    !! curt(nrho_eq) gives the total current, >0 by convention;, see
    !! kccw_Jphi, +/-1, for direction of toroidal current.
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_curt


subroutine psgetdim_curt(iobj, ndims, dims, ierr)
    !! total enclosed toroidal current, this includes <j.B>
    !! contributions and <j x B> contributions and, is related to the
    !! poloidal field:, mu0*I(rho) =
    !! rho*phit(nrho_eq)/(q(rho)*2*pi*pi), * grho2r2i(rho) *
    !! (dVol/drho)', "(From Ampere's Law, mu0*I_phi = loop integral
    !! (B_pol*dl)", '= loop integral (dl * grad(psi)/R), =
    !! rho*phit(nrho_eq)/(q(rho)*pi) *, loop integral (dl *
    !! grad(rho)/R), (2*pi) * loop integral (dl * grad(rho)/rho), =
    !! loop integral (dl * 2*pi*R/grad(rho) * grad(rho)**2/R**2), =
    !! grho2r2i(rho) * dVol/drho, derivation depends on the definition
    !! of the radial coord.:, rho = sqrt(phit(rho)/phit(rho=1)),
    !! curt(nrho_eq) gives the total current, >0 by convention;, see
    !! kccw_Jphi, +/-1, for direction of toroidal current.
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_curt', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % curt ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % curt)
    endif
end subroutine psgetdim_curt


subroutine psget_curlh(iobj, n1, data, ierr)
    !! LH current drive
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_curlh', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % curlh
end subroutine psget_curlh


subroutine psset_curlh(iobj, n1, data, ierr)
    !! LH current drive
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_curlh', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % curlh = data(1:n1)
end subroutine psset_curlh


subroutine psgetrnk_curlh(iobj, ndims, ierr)
    !! LH current drive
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_curlh


subroutine psgetdim_curlh(iobj, ndims, dims, ierr)
    !! LH current drive
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_curlh', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % curlh ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % curlh)
    endif
end subroutine psgetdim_curlh


subroutine psget_chii_mmm71(iobj, n1, data, ierr)
    !! Ti-equation, diffusivity term
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_chii_mmm71', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % chii_mmm71
end subroutine psget_chii_mmm71


subroutine psset_chii_mmm71(iobj, n1, data, ierr)
    !! Ti-equation, diffusivity term
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_chii_mmm71', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % chii_mmm71 = data(1:n1)
end subroutine psset_chii_mmm71


subroutine psgetrnk_chii_mmm71(iobj, ndims, ierr)
    !! Ti-equation, diffusivity term
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_chii_mmm71


subroutine psgetdim_chii_mmm71(iobj, ndims, dims, ierr)
    !! Ti-equation, diffusivity term
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_chii_mmm71', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % chii_mmm71 ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % chii_mmm71)
    endif
end subroutine psgetdim_chii_mmm71


subroutine psget_chie_gtcneo(iobj, n1, data, ierr)
    !! Te-equation, neoclassical diffusivity from GTC_NEO model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_chie_gtcneo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % chie_gtcneo
end subroutine psget_chie_gtcneo


subroutine psset_chie_gtcneo(iobj, n1, data, ierr)
    !! Te-equation, neoclassical diffusivity from GTC_NEO model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_chie_gtcneo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % chie_gtcneo = data(1:n1)
end subroutine psset_chie_gtcneo


subroutine psgetrnk_chie_gtcneo(iobj, ndims, ierr)
    !! Te-equation, neoclassical diffusivity from GTC_NEO model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_chie_gtcneo


subroutine psgetdim_chie_gtcneo(iobj, ndims, dims, ierr)
    !! Te-equation, neoclassical diffusivity from GTC_NEO model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_chie_gtcneo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % chie_gtcneo ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % chie_gtcneo)
    endif
end subroutine psgetdim_chie_gtcneo


subroutine psget_chiphi_neo(iobj, n1, data, ierr)
    !! momentum-equation, neoclassical diffusivity from NEO model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_chiphi_neo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % chiphi_neo
end subroutine psget_chiphi_neo


subroutine psset_chiphi_neo(iobj, n1, data, ierr)
    !! momentum-equation, neoclassical diffusivity from NEO model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_chiphi_neo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % chiphi_neo = data(1:n1)
end subroutine psset_chiphi_neo


subroutine psgetrnk_chiphi_neo(iobj, ndims, ierr)
    !! momentum-equation, neoclassical diffusivity from NEO model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_chiphi_neo


subroutine psgetdim_chiphi_neo(iobj, ndims, dims, ierr)
    !! momentum-equation, neoclassical diffusivity from NEO model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_chiphi_neo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % chiphi_neo ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % chiphi_neo)
    endif
end subroutine psgetdim_chiphi_neo

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_n6_dummy
     return
  end subroutine ccps_getset_n6_dummy

subroutine psget_ntf_coils(iobj, data, ierr)
    !! number of TF coils, the number of toroidal field (TF) coils
    !! is also the, number of periods in the main TF ripple field
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_ntf_coils', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % ntf_coils
end subroutine psget_ntf_coils


subroutine psset_ntf_coils(iobj, data, ierr)
    !! number of TF coils, the number of toroidal field (TF) coils
    !! is also the, number of periods in the main TF ripple field
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_ntf_coils', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % ntf_coils = data
end subroutine psset_ntf_coils


subroutine psget_nbion_trace(iobj, n1, data, ierr)
    !! (if non-blank) beam trace element, Possible values same as
    !! nbion; nbion(ib).ne.nbion_trace(ib) enforced., This allows a
    !! second trace element to be injected with any neutral, beam-- as
    !! in trace tritium beam experiments, or, heating beams doped,
    !! with a noble gas species.  See: power_nbi_trace(...)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    CHARACTER*(*), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_nbion_trace', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % nbion_trace
end subroutine psget_nbion_trace


subroutine psset_nbion_trace(iobj, n1, data, ierr)
    !! (if non-blank) beam trace element, Possible values same as
    !! nbion; nbion(ib).ne.nbion_trace(ib) enforced., This allows a
    !! second trace element to be injected with any neutral, beam-- as
    !! in trace tritium beam experiments, or, heating beams doped,
    !! with a noble gas species.  See: power_nbi_trace(...)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    CHARACTER*(*), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_nbion_trace', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % nbion_trace = data(1:n1)
end subroutine psset_nbion_trace


subroutine psgetsz_nbion_trace(iobj, size, ierr)
    !! (if non-blank) beam trace element, Possible values same as
    !! nbion; nbion(ib).ne.nbion_trace(ib) enforced., This allows a
    !! second trace element to be injected with any neutral, beam-- as
    !! in trace tritium beam experiments, or, heating beams doped,
    !! with a noble gas species.  See: power_nbi_trace(...)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: size    ! size of character string
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psgetsz_nbion_trace', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! note that the following will return the character length size regardless of
    ! the number of array elements (if nbion_trace is an array)
    size = len(ss % nbion_trace)
end subroutine psgetsz_nbion_trace


subroutine psgetrnk_nbion_trace(iobj, ndims, ierr)
    !! (if non-blank) beam trace element, Possible values same as
    !! nbion; nbion(ib).ne.nbion_trace(ib) enforced., This allows a
    !! second trace element to be injected with any neutral, beam-- as
    !! in trace tritium beam experiments, or, heating beams doped,
    !! with a noble gas species.  See: power_nbi_trace(...)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_nbion_trace


subroutine psgetdim_nbion_trace(iobj, ndims, dims, ierr)
    !! (if non-blank) beam trace element, Possible values same as
    !! nbion; nbion(ib).ne.nbion_trace(ib) enforced., This allows a
    !! second trace element to be injected with any neutral, beam-- as
    !! in trace tritium beam experiments, or, heating beams doped,
    !! with a noble gas species.  See: power_nbi_trace(...)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_nbion_trace', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % nbion_trace ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % nbion_trace)
    endif
end subroutine psgetdim_nbion_trace


subroutine psget_num_nphi_vac(iobj, n1, data, ierr)
    !! number of non-zero n_phi values, counting both positive and
    !! negative, n_phi values for the retained vacuum, spectrum--will
    !! typicall be a few hundred, or less and is a super set of num_phi
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_num_nphi_vac', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % num_nphi_vac
end subroutine psget_num_nphi_vac


subroutine psset_num_nphi_vac(iobj, n1, data, ierr)
    !! number of non-zero n_phi values, counting both positive and
    !! negative, n_phi values for the retained vacuum, spectrum--will
    !! typicall be a few hundred, or less and is a super set of num_phi
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_num_nphi_vac', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % num_nphi_vac = data(1:n1)
end subroutine psset_num_nphi_vac


subroutine psgetrnk_num_nphi_vac(iobj, ndims, ierr)
    !! number of non-zero n_phi values, counting both positive and
    !! negative, n_phi values for the retained vacuum, spectrum--will
    !! typicall be a few hundred, or less and is a super set of num_phi
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_num_nphi_vac


subroutine psgetdim_num_nphi_vac(iobj, ndims, dims, ierr)
    !! number of non-zero n_phi values, counting both positive and
    !! negative, n_phi values for the retained vacuum, spectrum--will
    !! typicall be a few hundred, or less and is a super set of num_phi
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_num_nphi_vac', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % num_nphi_vac ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % num_nphi_vac)
    endif
end subroutine psgetdim_num_nphi_vac


subroutine psget_nz(iobj, data, ierr)
    !! grid dimension of Z_grid (Z coordinate)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_nz', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % nz
end subroutine psget_nz


subroutine psset_nz(iobj, data, ierr)
    !! grid dimension of Z_grid (Z coordinate)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_nz', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % nz = data
end subroutine psset_nz


subroutine psget_nballoon(iobj, data, ierr)
    !! item list dimension of Balloon_code (Balloon_codes)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_nballoon', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % nballoon
end subroutine psget_nballoon


subroutine psset_nballoon(iobj, data, ierr)
    !! item list dimension of Balloon_code (Balloon_codes)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_nballoon', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % nballoon = data
end subroutine psset_nballoon


subroutine psget_nrho_anomth(iobj, data, ierr)
    !! grid dimension of rho_anomth (RHO coordinate)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_nrho_anomth', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % nrho_anomth
end subroutine psget_nrho_anomth


subroutine psset_nrho_anomth(iobj, data, ierr)
    !! grid dimension of rho_anomth (RHO coordinate)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_nrho_anomth', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % nrho_anomth = data
end subroutine psset_nrho_anomth


subroutine psget_nky_anomth(iobj, data, ierr)
    !! number of points, ky grid ( anomalous data over ky spectrum)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_nky_anomth', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % nky_anomth
end subroutine psget_nky_anomth


subroutine psset_nky_anomth(iobj, data, ierr)
    !! number of points, ky grid ( anomalous data over ky spectrum)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_nky_anomth', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % nky_anomth = data
end subroutine psset_nky_anomth


subroutine psget_nmdifb(iobj, data, ierr)
    !! type of fast ion diffusivity, =4: 2D fast ion diffusivity
    !! from ufiles, =6: fast ion diffusivity from dep code
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_nmdifb', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % nmdifb
end subroutine psget_nmdifb


subroutine psset_nmdifb(iobj, data, ierr)
    !! type of fast ion diffusivity, =4: 2D fast ion diffusivity
    !! from ufiles, =6: fast ion diffusivity from dep code
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_nmdifb', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % nmdifb = data
end subroutine psset_nmdifb


subroutine psget_nbeami(iobj, n1, n2, data, ierr)
    !! beam species density
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_nbeami', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % nbeami
end subroutine psget_nbeami


subroutine psset_nbeami(iobj, n1, n2, data, ierr)
    !! beam species density
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_nbeami', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % nbeami = data(1:n1, 1: n2)
end subroutine psset_nbeami


subroutine psgetrnk_nbeami(iobj, ndims, ierr)
    !! beam species density
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_nbeami


subroutine psgetdim_nbeami(iobj, ndims, dims, ierr)
    !! beam species density
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_nbeami', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % nbeami ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % nbeami)
    endif
end subroutine psgetdim_nbeami


subroutine psget_nfusi(iobj, n1, n2, data, ierr)
    !! fusion ion density
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_nfusi', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % nfusi
end subroutine psget_nfusi


subroutine psset_nfusi(iobj, n1, n2, data, ierr)
    !! fusion ion density
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_nfusi', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % nfusi = data(1:n1, 1: n2)
end subroutine psset_nfusi


subroutine psgetrnk_nfusi(iobj, ndims, ierr)
    !! fusion ion density
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_nfusi


subroutine psgetdim_nfusi(iobj, ndims, dims, ierr)
    !! fusion ion density
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_nfusi', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % nfusi ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % nfusi)
    endif
end subroutine psgetdim_nfusi


subroutine psget_niflux_ky_tglf(iobj, n1, n2, data, ierr)
    !! ion density flux spectrum
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_niflux_ky_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % niflux_ky_tglf
end subroutine psget_niflux_ky_tglf


subroutine psset_niflux_ky_tglf(iobj, n1, n2, data, ierr)
    !! ion density flux spectrum
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_niflux_ky_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % niflux_ky_tglf = data(1:n1, 1: n2)
end subroutine psset_niflux_ky_tglf


subroutine psgetrnk_niflux_ky_tglf(iobj, ndims, ierr)
    !! ion density flux spectrum
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_niflux_ky_tglf


subroutine psgetdim_niflux_ky_tglf(iobj, ndims, dims, ierr)
    !! ion density flux spectrum
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_niflux_ky_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % niflux_ky_tglf ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % niflux_ky_tglf)
    endif
end subroutine psgetdim_niflux_ky_tglf

subroutine ps_list_get(section, iobj, listname, &
     iauthor, units, label, &
     max_prior, alt_listname, alt_author, &
     nelems, elem_names, alt_elem_names, &
     elem_ivals, elem_r8vals, elem_labels, &
     iout,ierr)

  !------------------------------------------------------------
  ! D. McCune 8 Oct 2006

  ! XPLASMA2 implementation of plasma_state subroutine
  ! fetch a list of values, perform error checking

  ! This routine is called by generated code associated with the
  ! plasma state.  Component codes will not call this directly.
  !------------------------------------------------------------

  use plasma_state_definition_mod
  use plasma_state_xpobj  ! XPLASMA2 state object definitions
  implicit NONE

  !-----------------------
  character*(*), intent(in) :: section     ! plasma state section name

  integer :: iobj(ps_container_size)     ! xplasma opaque container

  character*(*), intent(in) :: listname    ! NAME of list to fetch

  integer, intent(in) :: iauthor           ! author ID (checked if non-zero)
  character*(*), intent(inout) :: units    ! units label (checked for match)
  ! if the passed units label is "*" the check is skipped; the actual units
  ! are substituted as output.

  character*(*), intent(out) :: label      ! label for whole list

  integer, intent(in) :: max_prior         ! max prior names dimension
  character*(*), intent(in) :: alt_listname(max_prior)
           ! alternate listnames (compatibility with earlier vsn state files)
  character*(*), intent(in) :: alt_author(max_prior)
           ! alternate authornames (compatibility with earlier vsn state files)

  integer, intent(in) :: nelems            ! expected list size (checked)

  character*(*), intent(inout) :: elem_names(nelems) ! element names
                                           ! if "*", read from list
                                           ! otherwise the names must match

  character*(*), intent(in) :: alt_elem_names(max_prior,nelems)
           ! alternalte element names (compatibility with earlier versions).

  integer, intent(out) :: elem_ivals(nelems)   ! element integer values
  REAL(kind=rspec), intent(out) :: elem_r8vals(nelems)  ! element values
  character*(*), intent(out) :: elem_labels(nelems)  ! element labels or
                                           ! character data

  integer, intent(in) :: iout              ! Fortran LUN for messages
  integer, intent(out) :: ierr             ! error status code returned 0 = OK

  !--------------------------------------------------
  ! local...

  integer :: ialt,ifound,id,ielems,ielem,jelem
  logical :: imatch,jmatch
  character*32 punits,pauth,ztest1,ztest2
  character*32, dimension(:), allocatable :: enames
  character*80, dimension(:), allocatable :: chvals
  integer, dimension(:), allocatable :: ivals
  REAL(kind=rspec), dimension(:), allocatable :: r8vals

  type (interp_object) :: xobj
  type (xplasma), pointer :: s
  !--------------------------------------------------

  xobj = transfer(iobj,xobj)
  s => xobj%s_xpobj

  call xplasma_global_info(s,ierr, init_check=.TRUE.)
  if(ierr.ne.0) then
     write(iout,*) ' %ps_list_get: invalid or unitialized xplasma object.'
     return
  endif

  !--------------------------------------------------
  !  find list ID

  call xplasma_listId(s,listname,id)
  if(id.eq.0) then
     do ialt = 1,max_prior
        if(alt_listname(ialt).eq.' ') exit
        call xplasma_listId(s,alt_listname(ialt),id)
        if(id.ne.0) exit
     enddo
     if(id.eq.0) then
        if(elem_names(1).eq.'*') then
           write(iout,*) ' ?ps_list_get: list not found: ',trim(listname), &
                '   (*-element, cannot recover).'
           ierr=801
           return
        else
           write(iout,*) ' %ps_list_get: list not found: ',trim(listname), &
                '   (cleared).'
           label = '(undefined).'
           elem_ivals = 0
           elem_r8vals = 0
           elem_labels = ' '
           return
        endif
     endif
  endif

  !--------------------------------------------------
  !  fetch and check profile info

  call xplasma_list_info(s,id,ierr, &
       nelems=ielems, label=label, &
       units=punits, author=pauth)

  if(ierr.ne.0) then
     write(iout,*) ' ?ps_list_get: unexpected XPLASMA2 error:'
     call xplasma_error(s,ierr,iout)
     ierr=801

  else
     ! general checks...

     if(units.ne.'*') then
        if(max(len(trim(units)),len(trim(punits))).gt.0) then
           if(trim(units).ne.trim(punits)) then
              write(iout,*) ' %ps_list_get: units label mismatch:'
              write(iout,*) '  list ',trim(listname),' has: "',trim(punits), &
                   '"; passed units are: "',trim(units),'" (fixed).'
              units = punits
           endif
        endif
     else
        units = punits
     endif

     if(iauthor.gt.0) then
        if(trim(ps_cnames(iauthor)).ne.trim(pauth)) then
           ifound=0
           do ialt = 1,max_prior
              if(alt_author(ialt).eq.' ') exit
              if(alt_author(ialt).eq.trim(pauth)) then
                 ifound=ialt
                 exit
              endif
           enddo
           if(ifound.eq.0) then
              write(iout,*) ' ?ps_list_get: author label mismatch:'
              write(iout,*) '  list ',trim(listname),' has: "',trim(pauth), &
                   '"; passed author reference: "',trim(ps_cnames(iauthor)),'".'
              ierr=801
           else
              call xplasma_reset_author(s,id,pauth,ps_cnames(iauthor),ierr)
           endif
        endif
     endif
  endif

  if(ierr.ne.0) return

  !--------------------------------------------------
  ! OK fetch the data

  allocate(enames(ielems),chvals(ielems),ivals(ielems),r8vals(ielems))

  call xplasma_getList_names(s,id,enames,ierr, &
       ivals=ivals, r8vals=r8vals, chvals=chvals)

  if(ierr.ne.0) then
     write(iout,*) ' ?XPLASMA2 error while attempting list data retrieval:'
     call xplasma_error(s,ierr,iout)
     ierr=802
  endif
  if(ierr.ne.0) return

  if(elem_names(1).eq.'*') then
     ! names are output
     if(ielems.ne.nelems) then
        write(iout,*) ' ?ps_list_get: size of list: ',trim(listname),' = ',nelems
        write(iout,*) '  does not match value found in file: ',ielems
        write(iout,*) '  As element names are not provided: cannot recover.'
        ierr=803

     else
        elem_names = enames
        elem_ivals = ivals
        elem_r8vals = r8vals
        elem_labels = chvals

     endif

  else

     imatch=.FALSE.
     if(ielems.eq.nelems) then
        imatch=.TRUE.
        do ielem=1,nelems
           ztest1=enames(ielem)
           ztest2=elem_names(ielem)
           call uupper(ztest1)
           call uupper(ztest2)
           if(ztest1.ne.ztest2) then
              imatch=.FALSE.
              exit
           endif
        enddo
     endif

     if(imatch) then
        elem_ivals(1:nelems)=ivals(1:nelems)
        elem_r8vals(1:nelems)=r8vals(1:nelems)
        elem_labels(1:nelems)=chvals(1:nelems)

     else
     
        ! look for match on name by name basis
        do ielem=1,nelems
           ztest1=elem_names(ielem)
           call uupper(ztest1)
           call search_list
           if(.not.jmatch) then
              do ialt=1,max_prior
                 ztest1=alt_elem_names(ialt,ielem)
                 if(ztest1.eq.' ') exit
                 call uupper(ztest1)
                 call search_list
              enddo
           endif

           if(.not.jmatch) then
              write(iout,*) ' %ps_list_get:  in ',trim(listname)
              write(iout,*) '  failed to locate list element: ', &
                   elem_names(ielem), ' (cleared).'
              elem_ivals(ielem) = 0
              elem_r8vals(ielem) = 0.0_rspec
              elem_labels(ielem) = ' '
           endif
        enddo
     endif
  endif

  contains
    subroutine search_list

      jmatch=.FALSE.
      do jelem=1,ielems
         ztest2=enames(jelem)
         call uupper(ztest2)
         if(ztest1.eq.ztest2) then
            jmatch=.TRUE.
            elem_ivals(ielem)=ivals(jelem)
            elem_r8vals(ielem)=r8vals(jelem)
            elem_labels(ielem)=chvals(jelem)
            exit
         endif
      enddo

    end subroutine search_list

end subroutine ps_list_get

subroutine ps_listId(iobj,iout,listname,id,inum)
  !  get ID of list item

  use plasma_state_definition_mod
  use plasma_state_xpobj  ! XPLASMA2 state object definitions
  implicit NONE

  !-----------------------
  integer :: iobj(ps_container_size)     ! xplasma opaque container
  integer, intent(in) :: iout   ! LUN for messages
  character*(*), intent(in) :: listname  ! name of list item
  integer, intent(out) :: id    ! id of item returned (0 if not found).
  integer, intent(out) :: inum  ! size of list item (0 if not found).

  !-----------------------
  integer :: ierr
  type (interp_object) :: xobj
  type (xplasma), pointer :: s
  !-----------------------

  id = 0
  inum = 0

  xobj = transfer(iobj,xobj)
  s => xobj%s_xpobj

  call xplasma_global_info(s,ierr, init_check=.TRUE.)
  if(ierr.ne.0) then
     write(iout,*) ' %ps_listId: invalid or unitialized xplasma object.'
     return
  endif

  call xplasma_listId(s,listname,id)
  if(id.gt.0) then
     call xplasma_getList_size(s,id,inum,ierr)
  endif

end subroutine ps_listId

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_e3_dummy
     return
  end subroutine ccps_getset_e3_dummy

subroutine psget_ec_beam_elongation(iobj, n1, data, ierr)
    !! EC beam ellipticity, The conical EC beam shape can be
    !! elongated, "vertically" (elongation > 1) or "horizontally",
    !! (elongation < 1).  Here "vertical" means in the, direction
    !! normal to the plane contaiing the beam, centerline and the +phi
    !! unit vector; "horizontal", means normal to the plane of the
    !! beam centerline, and the "vertical" direction.  If this
    !! quantity is, defaulted to zero, it is reset to 1.0 exactly,
    !! i.e., for a beam with circular cross section.
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_ec_beam_elongation', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % EC_Beam_Elongation
end subroutine psget_ec_beam_elongation


subroutine psset_ec_beam_elongation(iobj, n1, data, ierr)
    !! EC beam ellipticity, The conical EC beam shape can be
    !! elongated, "vertically" (elongation > 1) or "horizontally",
    !! (elongation < 1).  Here "vertical" means in the, direction
    !! normal to the plane contaiing the beam, centerline and the +phi
    !! unit vector; "horizontal", means normal to the plane of the
    !! beam centerline, and the "vertical" direction.  If this
    !! quantity is, defaulted to zero, it is reset to 1.0 exactly,
    !! i.e., for a beam with circular cross section.
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_ec_beam_elongation', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % EC_Beam_Elongation = data(1:n1)
end subroutine psset_ec_beam_elongation


subroutine psgetrnk_ec_beam_elongation(iobj, ndims, ierr)
    !! EC beam ellipticity, The conical EC beam shape can be
    !! elongated, "vertically" (elongation > 1) or "horizontally",
    !! (elongation < 1).  Here "vertical" means in the, direction
    !! normal to the plane contaiing the beam, centerline and the +phi
    !! unit vector; "horizontal", means normal to the plane of the
    !! beam centerline, and the "vertical" direction.  If this
    !! quantity is, defaulted to zero, it is reset to 1.0 exactly,
    !! i.e., for a beam with circular cross section.
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_ec_beam_elongation


subroutine psgetdim_ec_beam_elongation(iobj, ndims, dims, ierr)
    !! EC beam ellipticity, The conical EC beam shape can be
    !! elongated, "vertically" (elongation > 1) or "horizontally",
    !! (elongation < 1).  Here "vertical" means in the, direction
    !! normal to the plane contaiing the beam, centerline and the +phi
    !! unit vector; "horizontal", means normal to the plane of the
    !! beam centerline, and the "vertical" direction.  If this
    !! quantity is, defaulted to zero, it is reset to 1.0 exactly,
    !! i.e., for a beam with circular cross section.
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_ec_beam_elongation', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % EC_Beam_Elongation ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % EC_Beam_Elongation)
    endif
end subroutine psgetdim_ec_beam_elongation


subroutine psget_ec_phi_aim(iobj, n1, data, ierr)
    !! toroidal aiming angle, 0 degrees-> component of beam in +R
    !! direction, 90 degrees-> component of beam in +phi direction,
    !! 180 degrees-> component of beam in -R direction, 270 degrees or
    !! -90 degrees-> component in -phi direction, An EC beam with a
    !! component in the +phi direction, will push electrons in the
    !! +phi direction, counter, clockwise (CCW) around the machine
    !! axis as viewed, from above; and hence drive current in a
    !! clockwise, (CW) direction.  See shot configuration variable,
    !! kCCW_Jphi for orientation of main plasma current., See also
    !! EC_theta_aim(...).
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_ec_phi_aim', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % EC_phi_aim
end subroutine psget_ec_phi_aim


subroutine psset_ec_phi_aim(iobj, n1, data, ierr)
    !! toroidal aiming angle, 0 degrees-> component of beam in +R
    !! direction, 90 degrees-> component of beam in +phi direction,
    !! 180 degrees-> component of beam in -R direction, 270 degrees or
    !! -90 degrees-> component in -phi direction, An EC beam with a
    !! component in the +phi direction, will push electrons in the
    !! +phi direction, counter, clockwise (CCW) around the machine
    !! axis as viewed, from above; and hence drive current in a
    !! clockwise, (CW) direction.  See shot configuration variable,
    !! kCCW_Jphi for orientation of main plasma current., See also
    !! EC_theta_aim(...).
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_ec_phi_aim', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % EC_phi_aim = data(1:n1)
end subroutine psset_ec_phi_aim


subroutine psgetrnk_ec_phi_aim(iobj, ndims, ierr)
    !! toroidal aiming angle, 0 degrees-> component of beam in +R
    !! direction, 90 degrees-> component of beam in +phi direction,
    !! 180 degrees-> component of beam in -R direction, 270 degrees or
    !! -90 degrees-> component in -phi direction, An EC beam with a
    !! component in the +phi direction, will push electrons in the
    !! +phi direction, counter, clockwise (CCW) around the machine
    !! axis as viewed, from above; and hence drive current in a
    !! clockwise, (CW) direction.  See shot configuration variable,
    !! kCCW_Jphi for orientation of main plasma current., See also
    !! EC_theta_aim(...).
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_ec_phi_aim


subroutine psgetdim_ec_phi_aim(iobj, ndims, dims, ierr)
    !! toroidal aiming angle, 0 degrees-> component of beam in +R
    !! direction, 90 degrees-> component of beam in +phi direction,
    !! 180 degrees-> component of beam in -R direction, 270 degrees or
    !! -90 degrees-> component in -phi direction, An EC beam with a
    !! component in the +phi direction, will push electrons in the
    !! +phi direction, counter, clockwise (CCW) around the machine
    !! axis as viewed, from above; and hence drive current in a
    !! clockwise, (CW) direction.  See shot configuration variable,
    !! kCCW_Jphi for orientation of main plasma current., See also
    !! EC_theta_aim(...).
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_ec_phi_aim', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % EC_phi_aim ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % EC_phi_aim)
    endif
end subroutine psgetdim_ec_phi_aim


subroutine psget_eperp_mini(iobj, n1, n2, data, ierr)
    !! minority species <Eperp>, lab frame
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_eperp_mini', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % eperp_mini
end subroutine psget_eperp_mini


subroutine psset_eperp_mini(iobj, n1, n2, data, ierr)
    !! minority species <Eperp>, lab frame
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_eperp_mini', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % eperp_mini = data(1:n1, 1: n2)
end subroutine psset_eperp_mini


subroutine psgetrnk_eperp_mini(iobj, ndims, ierr)
    !! minority species <Eperp>, lab frame
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_eperp_mini


subroutine psgetdim_eperp_mini(iobj, ndims, dims, ierr)
    !! minority species <Eperp>, lab frame
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_eperp_mini', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % eperp_mini ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % eperp_mini)
    endif
end subroutine psgetdim_eperp_mini


subroutine psget_epll_rw(iobj, n1, data, ierr)
    !! runaway electron <Epll>
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_epll_rw', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % epll_rw
end subroutine psget_epll_rw


subroutine psset_epll_rw(iobj, n1, data, ierr)
    !! runaway electron <Epll>
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_epll_rw', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % epll_rw = data(1:n1)
end subroutine psset_epll_rw


subroutine psgetrnk_epll_rw(iobj, ndims, ierr)
    !! runaway electron <Epll>
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_epll_rw


subroutine psgetdim_epll_rw(iobj, ndims, dims, ierr)
    !! runaway electron <Epll>
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_epll_rw', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % epll_rw ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % epll_rw)
    endif
end subroutine psgetdim_epll_rw

subroutine cstate_hash_compare(hlabel,hash1,hash2)

  !  display matched sets according to hash codes

  use cstate_lib_mod
  use plasma_hash_code
  implicit NONE

  !------------------------
  ! passed arguments
  !   if entities have 2 positive matching hash codes they are assumed
  !   to be identical

  character*(*), intent(in) :: hlabel    ! label of entity
  integer, intent(in) :: hash1(nsss_cur) ! 1st set of hash codes
  integer, intent(in) :: hash2(nsss_cur) ! 2nd set of hash codes
  !------------------------
  ! local

  integer :: ii,jj,maxmatch,imatch(nsss_cur),ihashm(nsss_cur)
  integer :: luntty,lnout
  character*40 :: describ
  !------------------------

  luntty = lnout(0)

  imatch = 0
  maxmatch = 0

  do ii=2,nsss_cur
     if(hash1(ii).lt.-1) cycle
     if(hash2(ii).lt.-1) cycle

     do jj=1,ii-1
        if((hash1(ii).eq.hash1(jj)).AND.(hash2(ii).eq.hash2(jj))) then
           if(imatch(jj).eq.0) then
              maxmatch = maxmatch + 1
              ihashm(maxmatch)=hash1(ii)
              imatch(jj)=maxmatch
              imatch(ii)=maxmatch
           else
              imatch(ii)=imatch(jj)
           endif
           exit
        endif
     enddo
  enddo

  do ii=1,maxmatch
     if(ihashm(ii).lt.0) then
        describ='identically ZERO'
     else
        describ='identical'
     endif
     if(maxmatch.gt.1) then
        write(luntty,'(/" {set ",i1,"} ",a,1x,a" in states:")') &
             ii,trim(hlabel),trim(describ)
     else
        write(luntty,'(/1x,a,1x,a" in states:")') trim(hlabel),trim(describ)
     endif
     do jj=1,nsss_cur
        if(imatch(jj).eq.ii) then
           write(luntty,*) '     '//trim(sss_label(jj))
        endif
     enddo
  enddo

end subroutine cstate_hash_compare

subroutine ccps_read_update_file(iobj,filepath,finalflag,ierr)

  ! read file containing updates-- i.e. state element value changes.

  ! if finalflag.NE.0 is set, perform internal updates to state (update
  ! hash table and interpolation data).  If hashflag=0, hash table is not 
  ! updated.  If a series of update files are to be read, the most efficient
  ! thing to do is, set finalflag=0 for all but the last of the reads.

  use plasma_state_mod
  implicit NONE

#include "fpreproc/byte_declare.h"

  integer :: iobj(*)        ! (ps_container_size) words are used: state object
  BYTE_DECLARE, intent(in) :: filepath(*)  ! null terminated file path string (max 256 chars)
  integer,intent(in) :: finalflag  ! .NE.0 to update state internal tables
  integer,intent(out) :: ierr      ! exit status 0=OK

  !-------------------------
  character*256 filename
  type (plasma_state_container) :: ptr
  type (plasma_state), pointer :: ss
  logical :: fflag
  !-------------------------

  call ccps_argcheck('ccps_read_update_file',iobj,ierr)
  if(ierr.ne.0) return

  ! proceed...

  call load_ps_container(iobj,ptr)
  ss => ptr%ps_ptr

  ! convert filepath to fortran string
  call cstring(filename,filepath,'2F')  ! convert file path to fortran string

  fflag = (finalflag.NE.0)
  call ps_read_update_file(filename, ierr, state=ss, update_complete=fflag)

end subroutine ccps_read_update_file

program update_state

  !  DMC Oct 2008: update state (using files)
  !    a base state is read from a file; state updates are then applied
  !    from update files in sequence.  When done, the state is written
  !    back out (optionally to a different file)

  !  syntax:
  !    update_state -input <state_filename> [-output <output_filename>]
  !                     [-updates <file1> [file2 file3 ...]]
  !                     [-stdin]

  !    -input  specifies the input state file -- this information required;
  !            subsequent argument must be a filename.

  !    -output specifies the output file; if provided subsequent argument
  !            must be a filename.  If omitted the file specified under
  !            -input will be rewritten with any updates received.
  
  !    -updates specifies a list of one or more state update files; the
  !            arguments that follow are taken as filenames, until the
  !            next argument starting with "-", or end of arguments is
  !            encountered.

  !    -stdin  specifies to read stdin for update filenames.

  !    messages are written to stdout.  If an error occurs, 
  !    the program exits with a non-zero status code.

  !--------------------------------------------------------------------------
  USE plasma_state_mod
  implicit NONE

  !-------------------------------------------

  integer :: iarg,nargs,ilen,idash,ifail,ierr,ilen_keywd,ii,ieof,icomp,idiff

  integer, parameter :: imax_args = 100
  character*250 :: args(imax_args),update_files(imax_args)
  character*250 :: infile,outfile,afile
  character*20 mode_str

  logical :: read_stdin

  integer :: imode  ! =0, seek "-" option; 
                    ! =1, seek infile
                    ! =2, seek outfile
                    ! =3, seek update_files

  integer :: num_updates

  !-------------------------------------------
  !  Part 1: parse command line arguments

  read_stdin = .FALSE.

  num_updates = 0
  imode = 0

  infile=' '
  outfile=' '

  call get_arg_count(nargs)
  if(nargs.gt.imax_args) then
     ierr=1
     write(6,*) '?update_state: too many arguments (max: ',imax_args, &
          '; got: ',nargs,')'
     call syntax_error
  endif

  do iarg=1,nargs
     call get_arg(iarg,args(iarg))

     ilen = len(trim(args(iarg)))

     ifail=0

     ! parse arguments

     idash = 0
     if(args(iarg)(1:1).eq.'-') idash=1

     if(idash.eq.1) then
        !  command qualifer -nth or -nrho

        if(imode.eq.1) then
           write(6,*) '?update_state: -input filename argument missing.'
           call syntax_error
        endif

        if(imode.eq.2) then
           write(6,*) '?update_state: -output filename argument missing.'
           call syntax_error
        endif

        mode_str = args(iarg)(2:)
        call uupper(mode_str)

        if(mode_str.eq.'INPUT') then
           if(infile.ne.' ') then
              write(6,*) '?update_state: duplicate -input argument.'
              call syntax_error
           endif
           imode = 1

        else if(mode_str.eq.'OUTPUT') then
           if(outfile.ne.' ') then
              write(6,*) '?update_state: duplicate -output argument.'
              call syntax_error
           endif
           imode = 2

        else if(mode_str.eq.'UPDATES') then
           imode = 3

        else if(mode_str.eq.'STDIN') then
           read_stdin = .TRUE.

        else
           write(6,*) '?update_state: unrecognized command argument: '// &
                trim(args(iarg))
           call syntax_error
        endif

     else

        if(imode.eq.0) then
           write(6,*) '?update_state: argument "'//trim(args(iarg))// &
                '" misplaced.'
           call syntax_error
        endif

        if(imode.eq.1) then
           infile = args(iarg)
           imode = 0

        else if(imode.eq.2) then
           outfile = args(iarg)
           imode = 0

        else
           num_updates = num_updates + 1
           update_files(num_updates) = args(iarg)
              
        endif

     endif

  enddo

  if(infile.eq.' ') then
     write(6,*) '?update_state: -input file argument not found.'
     call syntax_error
  endif

  if(outfile.eq.' ') then
     outfile = infile
  endif

  if(.not.read_stdin) then

     if(num_updates.eq.0) then
        write(6,*) '?update_state: no updates specified.'
        call syntax_error
     endif

  endif

  write(6,*) ' update_state: arguments OK.'
  write(6,*) '   -input:  ',trim(infile)
  write(6,*) '   -output: ',trim(outfile)
  write(6,*) '   -updates on command line: ',num_updates,' files.'
  write(6,*) '   -stdin (T/F): ',read_stdin
  write(6,*) ' '

  !------------------------------
  !  execute...

  call ps_get_plasma_state(ierr,filename=trim(infile))
  if(ierr.ne.0) call io_error('ps_get_plasma_state',infile)

  write(6,*) ' ps_get_plasma_state OK: ',trim(infile)

  !  command line directed updates:

  do ii=1,num_updates

     call ps_read_update_file(update_files(ii),ierr, update_complete=.FALSE.)
     if(ierr.ne.0) call io_error('ps_read_update_file',update_files(ii))

     write(6,*) ' update applied: ',trim(update_files(ii))
  enddo

  !  update filenames received via stdin:

  if(read_stdin) then

     write(6,*) ' '
     write(6,*) ' reading update filenames on stdin:'

     do
        read(5,'(A)',iostat=ieof) afile
        if(ieof.ne.0) exit

        call ps_read_update_file(afile,ierr)
        if(ierr.ne.0) call io_error('ps_read_update_file',afile)

        write(6,*) ' update applied: ',trim(afile)
     enddo

  endif

  call ps_store_plasma_state(ierr,filename=trim(outfile))
  if(ierr.ne.0) call io_error('ps_store_plasma_state',outfile)

  call exit(0)

CONTAINS
  
  subroutine syntax_error

    write(6,*) ' '
    write(6,*) ' command argument syntax of "update_state" program: '
    write(6,*) ' '

    write(6,*) '    update_state  -input  <input_state_filename> '
    write(6,*) '                 [-output <output_state_filename>]'
    write(6,*) '                 [-updates <list_of_update_filenames>]'
    write(6,*) '                 [-stdin]'
    write(6,*) ' '
    write(6,*) ' if no -output file is specified, the -input file is replaced'
    write(6,*) ' with an updated version.  If -stdin is specified, additional'
    write(6,*) ' update filenames are read from -stdin, after all updates'
    write(6,*) ' from files named under the -updates argument are applied.'
    write(6,*) ' '

    call exit(2)
  end subroutine syntax_error

  subroutine io_error(subr,filenam)

    character*(*), intent(in) :: subr,filenam

    write(6,*) ' '
    write(6,*) ' ?update_state: I/O operation failed:'
    write(6,*) '  failing call: '//trim(subr)
    write(6,*) '  named file:   '//trim(filenam)
    write(6,*) ' '

    call exit(1)
  end subroutine io_error

  subroutine unknown_error(subr,filenam)

    character*(*), intent(in) :: subr,filenam

    write(6,*) ' '
    write(6,*) ' ?update_state: unexpected error:'
    write(6,*) '  failing call: '//trim(subr)
    write(6,*) '  recently named file: '//trim(filenam)
    write(6,*) ' '

    call exit(1)
  end subroutine unknown_error

end program update_state

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


SUBROUTINE ps_update_file_write_def_4(ss,icdf,cclist,nids,iout,iwarn,iertot)


  ! Define updated data

  USE plasma_state_definition_mod
  USE netcdf
  USE ps_nidlist_defn
  IMPLICIT NONE

  TYPE (plasma_state) :: ss  ! state containing array elements to be allocated
  INTEGER, INTENT(IN) :: icdf  ! NetCDF file ID
  INTEGER, INTENT(IN) :: cclist(ps_ccount)  ! component selection
  TYPE (nidlist) :: nids       ! defined dimensions list
  INTEGER, INTENT(IN) :: iout  ! LUN for messages
  INTEGER, INTENT(INOUT) :: iwarn   ! warn count
  INTEGER, INTENT(INOUT) :: iertot  ! error count

  !-------------------
  LOGICAL :: plasma_state_hash_match,ichange

  INTEGER :: varid,pvarid,vvarid,dimid,status,iertmp,iaddr
  INTEGER :: idims(20),indim,ival,ii,ierr
  CHARACTER*80 :: nc_errmsg

  !-------------------

  ierr = 0   ! local

  iaddr = ps_shash_NBI_Data_Info
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ichange) THEN
     IF(cclist(ps_cnum_NBI).NE.1) THEN
        CALL ccwarn("NBI_Data_Info","NBI")
     ELSE
        indim = 1
        idims(1)=nids%nid_clen_80
        CALL define_var("NBI_Data_Info","C*80",indim,idims, &
               "information on source of beam power & voltage data", &
               "__NONE","NBI","SIMULATION_INIT", &
               "C*80   NBI_Data_Info")
     ENDIF
  ENDIF

  iaddr = ps_dhash_nbeam
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%nbi_src_name).AND.ichange) THEN
     IF(cclist(ps_cnum_NBI).NE.1) THEN
        CALL ccwarn("nbi_src_name","NBI")
     ELSE
        indim = 1
        idims(1)=nids%nid_clen_32
        IF(nids%nid_dim_nbeam.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nbeam,"dim_nbeam",ss%nbeam)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nbeam
        CALL define_var("nbi_src_name","N",indim,idims, &
               "number & name of neutral beams", &
               "__NONE","NBI","MACHINE_DESCRIPTION", &
               "L|neutral_beams nbi_src_name(nbeam)")
     ENDIF
  ENDIF

  iaddr = ps_shash_nbshape
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%nbshape).AND.ichange) THEN
     IF(cclist(ps_cnum_NBI).NE.1) THEN
        CALL ccwarn("nbshape","NBI")
     ELSE
        indim = 1
        idims(1)=nids%nid_clen_32
        IF(nids%nid_dim_nbeam.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nbeam,"dim_nbeam",ss%nbeam)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nbeam
        CALL define_var("nbshape","N",indim,idims, &
               "shape keyword for beam source grid", &
               "__NONE","NBI","MACHINE_DESCRIPTION", &
               "N     nbshape(nbeam)")
     ENDIF
  ENDIF

  iaddr = ps_shash_nebar
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("nebar","PLASMA")
     ELSE
        indim = 0
        CALL define_var("nebar","R",indim,idims, &
               "line-averaged electron density", &
               "#/m^2","PLASMA","STATE_DATA", &
               "R|units=#/m^2 nebar")
     ENDIF
  ENDIF

  iaddr = ps_phash_neflux_ky_tglf
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%neflux_ky_tglf).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("neflux_ky_tglf","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        IF(nids%nid_dim_nky_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nky_anomth,"dim_nky_anomth",ss%nky_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nky_anomth
        CALL define_var("neflux_ky_tglf","R",indim,idims, &
               "electron density flux spectrum", &
               "GB","ANOM","STATE_PROFILES", &
               "R|units=GB|pclin neflux_ky_tglf(nrho_anomth,nky_anomth)")
     ENDIF
  ENDIF

  iaddr = ps_dhash_nnewcomb
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%Newcomb_code).AND.ichange) THEN
     IF(cclist(ps_cnum_LMHD).NE.1) THEN
        CALL ccwarn("Newcomb_code","LMHD")
     ELSE
        indim = 1
        idims(1)=nids%nid_clen_32
        IF(nids%nid_dim_nnewcomb.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nnewcomb,"dim_nnewcomb",ss%nnewcomb)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nnewcomb
        CALL define_var("Newcomb_code","N",indim,idims, &
               "name(s) of Newcomb code(s) used", &
               "__NONE","LMHD","SIMULATION_INIT", &
               "L|Newcomb_codes  Newcomb_code(nnewcomb)")
     ENDIF
  ENDIF

  iaddr = ps_shash_Newcomb_mapper
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%Newcomb_mapper).AND.ichange) THEN
     IF(cclist(ps_cnum_LMHD).NE.1) THEN
        CALL ccwarn("Newcomb_mapper","LMHD")
     ELSE
        indim = 1
        idims(1)=nids%nid_clen_32
        IF(nids%nid_dim_nnewcomb.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nnewcomb,"dim_nnewcomb",ss%nnewcomb)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nnewcomb
        CALL define_var("Newcomb_mapper","N",indim,idims, &
               "mapper code used for each Newcomb code", &
               "__NONE","LMHD","SIMULATION_INIT", &
               "N  Newcomb_mapper(nnewcomb)")
     ENDIF
  ENDIF

  iaddr = ps_shash_Newcomb_stable
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%Newcomb_stable).AND.ichange) THEN
     IF(cclist(ps_cnum_LMHD).NE.1) THEN
        CALL ccwarn("Newcomb_stable","LMHD")
     ELSE
        indim = 0
        IF(nids%nid_dim_mmodes.EQ.0) THEN
           CALL define_dim(nids%nid_dim_mmodes,"dim_mmodes",ss%mmodes)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_mmodes
        IF(nids%nid_dim_nnewcomb.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nnewcomb,"dim_nnewcomb",ss%nnewcomb)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nnewcomb
        CALL define_var("Newcomb_stable","I",indim,idims, &
               "0: stable; 1: unstable;", &
               "__NONE","LMHD","STATE_DATA", &
               "I   Newcomb_stable(mmodes,nnewcomb)")
     ENDIF
  ENDIF

  iaddr = ps_shash_Newcomb_status
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%Newcomb_status).AND.ichange) THEN
     IF(cclist(ps_cnum_LMHD).NE.1) THEN
        CALL ccwarn("Newcomb_status","LMHD")
     ELSE
        indim = 0
        IF(nids%nid_dim_nnewcomb.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nnewcomb,"dim_nnewcomb",ss%nnewcomb)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nnewcomb
        CALL define_var("Newcomb_status","I",indim,idims, &
               "completion status: Newcomb codes", &
               "__NONE","LMHD","STATE_DATA", &
               "I   Newcomb_status(nnewcomb)")
     ENDIF
  ENDIF

  iaddr = ps_phash_ne_ky_tglf
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%ne_ky_tglf).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("ne_ky_tglf","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        IF(nids%nid_dim_nky_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nky_anomth,"dim_nky_anomth",ss%nky_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nky_anomth
        CALL define_var("ne_ky_tglf","R",indim,idims, &
               "electron density fluctuation spectrum", &
               "GB","ANOM","STATE_PROFILES", &
               "R|units=GB|pclin ne_ky_tglf(nrho_anomth,nky_anomth)")
     ENDIF
  ENDIF

  iaddr = ps_phash_nfusi
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%nfusi).AND.ichange) THEN
     IF(cclist(ps_cnum_FUS).NE.1) THEN
        CALL ccwarn("nfusi","FUS")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_fus.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_fus,"dm1_nrho_fus",ss%nrho_fus-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_fus
        IF(nids%nid_dim_nspec_fusion.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nspec_fusion,"dim_nspec_fusion",ss%nspec_fusion)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nspec_fusion
        CALL define_var("nfusi","R",indim,idims, &
               "fusion ion density", &
               "m^-3","FUS","STATE_PROFILES", &
               "R|units=m^-3|alias=n|step  nfusi(~nrho_fus,nspec_fusion)")
     ENDIF
  ENDIF

  iaddr = ps_shash_nfusi_bdy
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%nfusi_bdy).AND.ichange) THEN
     IF(cclist(ps_cnum_IC).NE.1) THEN
        CALL ccwarn("nfusi_bdy","IC")
     ELSE
        indim = 0
        IF(nids%nid_dim_nspec_fusion.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nspec_fusion,"dim_nspec_fusion",ss%nspec_fusion)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nspec_fusion
        CALL define_var("nfusi_bdy","R",indim,idims, &
               "fusion ion densities at/beyond boundary", &
               "m^-3","IC","STATE_DATA", &
               "R|units=m^-3  nfusi_bdy(nspec_fusion)")
     ENDIF
  ENDIF

  iaddr = ps_phash_ngradb2_av
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%ngradb2_av).AND.ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("ngradb2_av","EQ")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_eq_geo.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_eq_geo,"dim_nrho_eq_geo",ss%nrho_eq_geo)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_eq_geo
        CALL define_var("ngradb2_av","R",indim,idims, &
               "<(B.grad(B)/|B|)^2>", &
               "T^2*m^-2","EQ","STATE_PROFILES", &
               "R|units=T^2*m^-2|pclin   ngradb2_av(nrho_eq_geo)")
     ENDIF
  ENDIF

  iaddr = ps_phash_ni
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%ni).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("ni","PLASMA")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho,"dm1_nrho",ss%nrho-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho
        CALL define_var("ni","R",indim,idims, &
               "total thermal ion density", &
               "m^-3","PLASMA","STATE_PROFILES", &
               "R|units=m^-3|step  ni(~nrho)")
     ENDIF
  ENDIF

  iaddr = ps_phash_niflux_ky_tglf
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%niflux_ky_tglf).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("niflux_ky_tglf","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        IF(nids%nid_dim_nky_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nky_anomth,"dim_nky_anomth",ss%nky_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nky_anomth
        CALL define_var("niflux_ky_tglf","R",indim,idims, &
               "ion density flux spectrum", &
               "GB","ANOM","STATE_PROFILES", &
               "R|units=GB|pclin niflux_ky_tglf(nrho_anomth,nky_anomth)")
     ENDIF
  ENDIF

  iaddr = ps_phash_ni_ky_tglf
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%ni_ky_tglf).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("ni_ky_tglf","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        IF(nids%nid_dim_nky_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nky_anomth,"dim_nky_anomth",ss%nky_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nky_anomth
        CALL define_var("ni_ky_tglf","R",indim,idims, &
               "ion density fluctuation spectrum", &
               "GB","ANOM","STATE_PROFILES", &
               "R|units=GB|pclin ni_ky_tglf(nrho_anomth,nky_anomth)")
     ENDIF
  ENDIF

  iaddr = ps_shash_nmdifb
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("nmdifb","ANOM")
     ELSE
        indim = 0
        CALL define_var("nmdifb","I",indim,idims, &
               "type of fast ion diffusivity", &
               "__NONE","ANOM","STATE_DATA", &
               "I   nmdifb = 0")
     ENDIF
  ENDIF

  iaddr = ps_phash_nmini
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%nmini).AND.ichange) THEN
     IF(cclist(ps_cnum_IC).NE.1) THEN
        CALL ccwarn("nmini","IC")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_icrf.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_icrf,"dm1_nrho_icrf",ss%nrho_icrf-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_icrf
        IF(nids%nid_dim_nspec_rfmin.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nspec_rfmin,"dim_nspec_rfmin",ss%nspec_rfmin)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nspec_rfmin
        CALL define_var("nmini","R",indim,idims, &
               "minority species density", &
               "m^-3","IC","STATE_PROFILES", &
               "R|units=m^-3|alias=n|step  nmini(~nrho_icrf,nspec_rfmin)")
     ENDIF
  ENDIF

  iaddr = ps_shash_nmini_bdy
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%nmini_bdy).AND.ichange) THEN
     IF(cclist(ps_cnum_FUS).NE.1) THEN
        CALL ccwarn("nmini_bdy","FUS")
     ELSE
        indim = 0
        IF(nids%nid_dim_nspec_rfmin.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nspec_rfmin,"dim_nspec_rfmin",ss%nspec_rfmin)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nspec_rfmin
        CALL define_var("nmini_bdy","R",indim,idims, &
               "RF minority ion densities at/beyond boundary", &
               "m^-3","FUS","STATE_DATA", &
               "R|units=m^-3  nmini_bdy(nspec_rfmin)")
     ENDIF
  ENDIF

  iaddr = ps_phash_nmodel
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%nmodel).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("nmodel","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_anomth,"dm1_nrho_anomth",ss%nrho_anomth-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_anomth
        CALL define_var("nmodel","R",indim,idims, &
               "target density profile", &
               "m^-3","ANOM","STATE_PROFILES", &
               "R|units=m^-3|step  nmodel(~nrho_anomth)")
     ENDIF
  ENDIF

  iaddr = ps_shash_nmodel_bdy
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("nmodel_bdy","ANOM")
     ELSE
        indim = 0
        CALL define_var("nmodel_bdy","R",indim,idims, &
               "model density, boundary value", &
               "m^-3","ANOM","STATE_DATA", &
               "R|units=m^-3   nmodel_bdy")
     ENDIF
  ENDIF

  iaddr = ps_shash_nmom
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("nmom","EQ")
     ELSE
        indim = 0
        CALL define_var("nmom","I",indim,idims, &
               "number of Fourier (R,Z) moments", &
               "__NONE","EQ","SIMULATION_INIT", &
               "I  nmom = 16")
     ENDIF
  ENDIF

  iaddr = ps_shash_nnkparlh
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%nnkparlh).AND.ichange) THEN
     IF(cclist(ps_cnum_LH).NE.1) THEN
        CALL ccwarn("nnkparlh","LH")
     ELSE
        indim = 0
        IF(nids%nid_dim_max_nspectrumlh_src.EQ.0) THEN
           CALL define_dim(nids%nid_dim_max_nspectrumlh_src,"dim_max_nspectrumlh_src",ss%max_nspectrumlh_src)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_max_nspectrumlh_src
        IF(nids%nid_dim_nlhrf_src.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nlhrf_src,"dim_nlhrf_src",ss%nlhrf_src)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nlhrf_src
        CALL define_var("nnkparlh","I",indim,idims, &
               "need description", &
               "__NONE","LH","SHOT_CONFIGURATION", &
               "I nnkparlh(nspectrumlh_src(),nlhrf_src)")
     ENDIF
  ENDIF

  iaddr = ps_shash_nnkpollh
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%nnkpollh).AND.ichange) THEN
     IF(cclist(ps_cnum_LH).NE.1) THEN
        CALL ccwarn("nnkpollh","LH")
     ELSE
        indim = 0
        IF(nids%nid_dim_max_nspectrumlh_src.EQ.0) THEN
           CALL define_dim(nids%nid_dim_max_nspectrumlh_src,"dim_max_nspectrumlh_src",ss%max_nspectrumlh_src)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_max_nspectrumlh_src
        IF(nids%nid_dim_nlhrf_src.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nlhrf_src,"dim_nlhrf_src",ss%nlhrf_src)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nlhrf_src
        CALL define_var("nnkpollh","I",indim,idims, &
               "need description", &
               "__NONE","LH","SHOT_CONFIGURATION", &
               "I nnkpollh(nspectrumlh_src(),nlhrf_src)")
     ENDIF
  ENDIF

  iaddr = ps_shash_nnktorlh
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%nnktorlh).AND.ichange) THEN
     IF(cclist(ps_cnum_LH).NE.1) THEN
        CALL ccwarn("nnktorlh","LH")
     ELSE
        indim = 0
        IF(nids%nid_dim_max_nspectrumlh_src.EQ.0) THEN
           CALL define_dim(nids%nid_dim_max_nspectrumlh_src,"dim_max_nspectrumlh_src",ss%max_nspectrumlh_src)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_max_nspectrumlh_src
        IF(nids%nid_dim_nlhrf_src.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nlhrf_src,"dim_nlhrf_src",ss%nlhrf_src)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nlhrf_src
        CALL define_var("nnktorlh","I",indim,idims, &
               "need description", &
               "__NONE","LH","SHOT_CONFIGURATION", &
               "I nnktorlh(nspectrumlh_src(),nlhrf_src)")
     ENDIF
  ENDIF

  iaddr = ps_shash_nphi
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%nphi).AND.ichange) THEN
     IF(cclist(ps_cnum_IC).NE.1) THEN
        CALL ccwarn("nphi","IC")
     ELSE
        indim = 0
        IF(nids%nid_dim_max_num_nphi.EQ.0) THEN
           CALL define_dim(nids%nid_dim_max_num_nphi,"dim_max_num_nphi",ss%max_num_nphi)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_max_num_nphi
        IF(nids%nid_dim_nicrf_src.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nicrf_src,"dim_nicrf_src",ss%nicrf_src)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nicrf_src
        CALL define_var("nphi","I",indim,idims, &
               "n_phi wave spectrum from antenna", &
               "__NONE","IC","SHOT_CONFIGURATION", &
               "I nphi(num_nphi(),nicrf_src)")
     ENDIF
  ENDIF

  iaddr = ps_phash_nrw
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%nrw).AND.ichange) THEN
     IF(cclist(ps_cnum_RUNAWAY).NE.1) THEN
        CALL ccwarn("nrw","RUNAWAY")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_rw.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_rw,"dm1_nrho_rw",ss%nrho_rw-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_rw
        CALL define_var("nrw","R",indim,idims, &
               "runaway electron density", &
               "m^-3","RUNAWAY","STATE_PROFILES", &
               "R|units=m^-3|step   nrw(~nrho_rw)")
     ENDIF
  ENDIF

  iaddr = ps_shash_nrz_antgeo
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%nrz_antgeo).AND.ichange) THEN
     IF(cclist(ps_cnum_IC).NE.1) THEN
        CALL ccwarn("nrz_antgeo","IC")
     ELSE
        indim = 0
        IF(nids%nid_dim_nicrf_src.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nicrf_src,"dim_nicrf_src",ss%nicrf_src)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nicrf_src
        CALL define_var("nrz_antgeo","I",indim,idims, &
               "number of (R,Z) points, antenna geometries", &
               "__NONE","IC","MACHINE_DESCRIPTION", &
               "I|ENUM nrz_antgeo(nicrf_src)")
     ENDIF
  ENDIF

  iaddr = ps_phash_ns
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%ns).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("ns","PLASMA")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho,"dm1_nrho",ss%nrho-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho
        IF(nids%nid_dp1_nspec_th.EQ.0) THEN
           CALL define_dim(nids%nid_dp1_nspec_th,"dp1_nspec_th",ss%nspec_th+1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dp1_nspec_th
        CALL define_var("ns","R",indim,idims, &
               "thermal specie density", &
               "m^-3","PLASMA","STATE_PROFILES", &
               "R|units=m^-3|alias=n|step  ns(~nrho,0:nspec_th)")
     ENDIF
  ENDIF

  iaddr = ps_shash_nspectrumlh_src
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%nspectrumlh_src).AND.ichange) THEN
     IF(cclist(ps_cnum_LH).NE.1) THEN
        CALL ccwarn("nspectrumlh_src","LH")
     ELSE
        indim = 0
        IF(nids%nid_dim_nlhrf_src.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nlhrf_src,"dim_nlhrf_src",ss%nlhrf_src)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nlhrf_src
        CALL define_var("nspectrumlh_src","I",indim,idims, &
               "number of spectrum peaks", &
               "__NONE","LH","SHOT_CONFIGURATION", &
               "I|ENUM nspectrumlh_src(nlhrf_src)")
     ENDIF
  ENDIF

  iaddr = ps_shash_ns_bdy
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%ns_bdy).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("ns_bdy","PLASMA")
     ELSE
        indim = 0
        IF(nids%nid_dp1_nspec_th.EQ.0) THEN
           CALL define_dim(nids%nid_dp1_nspec_th,"dp1_nspec_th",ss%nspec_th+1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dp1_nspec_th
        CALL define_var("ns_bdy","R",indim,idims, &
               "specie densities at/beyond boundary", &
               "m^-3","PLASMA","STATE_DATA", &
               "R|units=m^-3 ns_bdy(0:nspec_th)")
     ENDIF
  ENDIF

  iaddr = ps_shash_ns_Data_Info
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("ns_Data_Info","PLASMA")
     ELSE
        indim = 1
        idims(1)=nids%nid_clen_80
        CALL define_var("ns_Data_Info","C*80",indim,idims, &
               "information on source of Density data", &
               "__NONE","PLASMA","SIMULATION_INIT", &
               "C*80   ns_Data_Info")
     ENDIF
  ENDIF

  iaddr = ps_shash_ns_is_input
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%ns_is_input).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("ns_is_input","PLASMA")
     ELSE
        indim = 0
        IF(nids%nid_dp1_nspec_th.EQ.0) THEN
           CALL define_dim(nids%nid_dp1_nspec_th,"dp1_nspec_th",ss%nspec_th+1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dp1_nspec_th
        CALL define_var("ns_is_input","I",indim,idims, &
               "specie density measurement flag", &
               "__NONE","PLASMA","STATE_DATA", &
               "I ns_is_input(0:nspec_th)")
     ENDIF
  ENDIF

  iaddr = ps_shash_ntf_coil2
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ichange) THEN
     IF(cclist(ps_cnum_RIPPLE).NE.1) THEN
        CALL ccwarn("ntf_coil2","RIPPLE")
     ELSE
        indim = 0
        CALL define_var("ntf_coil2","I",indim,idims, &
               "number of TF coils involved in inducing 2nd component", &
               "__NONE","RIPPLE","MACHINE_DESCRIPTION", &
               "I ntf_coil2")
     ENDIF
  ENDIF
  CONTAINS


     SUBROUTINE define_dim(dimid,dname,idval)
        INTEGER, intent(out) :: dimid
        CHARACTER*(*), INTENT(in) :: dname
        INTEGER, intent(in) :: idval

        status = nf90_def_dim(icdf,dname,idval,dimid)
        IF(status.NE.NF90_NOERR) THEN
           WRITE(iout,*) ' ?ps_update_file_write: error defining dimension "'// &
                 trim(dname)//'".'
           IERR=9999
        ENDIF
     END SUBROUTINE define_dim



     SUBROUTINE define_var(name,dtype,indim,idims, &
          long_name,units,component,section,spec)

        CHARACTER*(*), INTENT(in) :: name
        CHARACTER*(*), INTENT(in) :: dtype
        INTEGER, INTENT(in) :: indim
        INTEGER, dimension(:), INTENT(in) :: idims
        CHARACTER*(*), INTENT(in) :: long_name
        CHARACTER*(*), INTENT(in) :: units
        CHARACTER*(*), INTENT(in) :: component
        CHARACTER*(*), INTENT(in) :: section
        CHARACTER*(*), INTENT(in) :: spec

        integer :: itype

        IF(dtype.EQ.'R') THEN
           itype = NF90_DOUBLE

        ELSE IF (dtype.EQ.'I') THEN
           itype = NF90_INT

        ELSE
           itype = NF90_CHAR

        ENDIF

        IF(indim.EQ.0) THEN
           status=nf90_def_var(icdf,name,itype, varid=varid)

        ELSE
           status=nf90_def_var(icdf,name,itype, dimids=idims(1:indim),varid=varid)

        ENDIF

        IF(status.NE.NF90_NOERR) THEN
           WRITE(iout,*) " ?plasma_state_store: error defining variable: "//trim(name)
           CALL ncerr(status)
           iertot = iertot + 1
           RETURN
        ENDIF

        ! Variable OK, now add attributes:

        CALL add_attrib("long_name",long_name)
        IF(dtype.EQ.'R') CALL add_attrib("units",units)
        CALL add_attrib("component",component)
        CALL add_attrib("section",section)
        CALL add_attrib("specification",spec)

     END SUBROUTINE define_var

     SUBROUTINE add_attrib(name,value)
        CHARACTER*(*), intent(in) :: name
        CHARACTER*(*), intent(in) :: value

        status=nf90_put_att(icdf,varid,name,value)
        IF(status.NE.NF90_NOERR) THEN
           WRITE(iout,*) " ?plasma_state_store: error defining attribute: "//trim(name)//' = '//trim(value)
           CALL ncerr(status)
           iertot = iertot + 1
        ENDIF
     END SUBROUTINE add_attrib



     SUBROUTINE ncerr(status)
        INTEGER, INTENT(in) :: status

        nc_errmsg = NF90_strerror(status)
        write(iout,*) '  NetCDF message: ',trim(nc_errmsg)
     END SUBROUTINE ncerr



     SUBROUTINE ccwarn(varnam,compnam)

        CHARACTER*(*), intent(in) :: varnam   ! name of variable or array
        CHARACTER*(*), intent(in) :: compnam  ! name of component

        if(iwarn.eq.0) then
           write(iout,*) ' '
           write(iout,*) ' %ps_update_file_write: modified state elements'
           write(iout,*) '  exist which were not written due to the "cclist"'
           write(iout,*) '  input variable which screens out elements from'
           write(iout,*) '  selected components: cclist = ',cclist,';'
           write(iout,*) '  element values of 1 indicate components that are'
           write(iout,*) '  enabled for write.'
           write(iout,*) ' '
        endif

        iwarn = iwarn + 1

        write(iout,*) ' %ps_update_file_write: modified: ss%'// &
             trim(varnam)//' ('//trim(compnam)//' component) NOT WRITTEN.'

     END SUBROUTINE ccwarn

END SUBROUTINE ps_update_file_write_def_4

SUBROUTINE ps_update_file_write_4(ss,icdf,cclist,iucount,iout,iwarn,iertot)


  ! Write updated data

  USE plasma_state_definition_mod
  USE netcdf
  IMPLICIT NONE

  TYPE (plasma_state) :: ss  ! state containing array elements to be allocated
  INTEGER, INTENT(IN) :: icdf  ! NetCDF file ID
  INTEGER, INTENT(IN) :: cclist(ps_ccount)  ! component selection
  INTEGER, INTENT(INOUT) :: iucount ! update count
  INTEGER, INTENT(IN) :: iout  ! LUN for messages
  INTEGER, INTENT(INOUT) :: iwarn   ! warn count
  INTEGER, INTENT(INOUT) :: iertot  ! error count

  !-------------------

  INTEGER :: varid,status
  CHARACTER*80 :: nc_errmsg

  !-------------------


  status = nf90_inq_varid(icdf,"NBI_Data_Info",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%NBI_Data_Info)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: NBI_Data_Info"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"nbi_src_name",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%nbi_src_name)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: nbi_src_name"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"nbshape",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%nbshape)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: nbshape"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"nebar",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%nebar)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: nebar"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"neflux_ky_tglf",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%neflux_ky_tglf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: neflux_ky_tglf"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Newcomb_code",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%Newcomb_code)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: Newcomb_code"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Newcomb_mapper",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%Newcomb_mapper)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: Newcomb_mapper"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Newcomb_stable",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%Newcomb_stable)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: Newcomb_stable"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Newcomb_status",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%Newcomb_status)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: Newcomb_status"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"ne_ky_tglf",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%ne_ky_tglf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: ne_ky_tglf"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"nfusi",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%nfusi)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: nfusi"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"nfusi_bdy",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%nfusi_bdy)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: nfusi_bdy"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"ngradb2_av",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%ngradb2_av)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: ngradb2_av"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"ni",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%ni)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: ni"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"niflux_ky_tglf",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%niflux_ky_tglf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: niflux_ky_tglf"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"ni_ky_tglf",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%ni_ky_tglf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: ni_ky_tglf"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"nmdifb",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%nmdifb)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: nmdifb"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"nmini",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%nmini)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: nmini"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"nmini_bdy",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%nmini_bdy)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: nmini_bdy"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"nmodel",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%nmodel)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: nmodel"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"nmodel_bdy",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%nmodel_bdy)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: nmodel_bdy"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"nmom",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%nmom)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: nmom"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"nnkparlh",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%nnkparlh)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: nnkparlh"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"nnkpollh",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%nnkpollh)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: nnkpollh"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"nnktorlh",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%nnktorlh)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: nnktorlh"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"nphi",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%nphi)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: nphi"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"nrw",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%nrw)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: nrw"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"nrz_antgeo",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%nrz_antgeo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: nrz_antgeo"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"ns",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%ns)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: ns"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"nspectrumlh_src",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%nspectrumlh_src)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: nspectrumlh_src"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"ns_bdy",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%ns_bdy)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: ns_bdy"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"ns_Data_Info",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%ns_Data_Info)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: ns_Data_Info"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"ns_is_input",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%ns_is_input)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: ns_is_input"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"ntf_coil2",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%ntf_coil2)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: ntf_coil2"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF
  CONTAINS


     SUBROUTINE ncerr(status)
        INTEGER, INTENT(in) :: status

        nc_errmsg = NF90_strerror(status)
        write(iout,*) '  NetCDF message: ',trim(nc_errmsg)
     END SUBROUTINE ncerr

END SUBROUTINE ps_update_file_write_4

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_q1_dummy
     return
  end subroutine ccps_getset_q1_dummy

subroutine psget_q_s(iobj, n1, data, ierr)
    !! S specie charge
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_q_s', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % q_S
end subroutine psget_q_s


subroutine psset_q_s(iobj, n1, data, ierr)
    !! S specie charge
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_q_s', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % q_S = data(1:n1)
end subroutine psset_q_s


subroutine psgetrnk_q_s(iobj, ndims, ierr)
    !! S specie charge
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_q_s


subroutine psgetdim_q_s(iobj, ndims, dims, ierr)
    !! S specie charge
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_q_s', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % q_S ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % q_S)
    endif
end subroutine psgetdim_q_s


subroutine psget_q_alla(iobj, n1, data, ierr)
    !! ALLA specie charge
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_q_alla', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % q_ALLA
end subroutine psget_q_alla


subroutine psset_q_alla(iobj, n1, data, ierr)
    !! ALLA specie charge
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_q_alla', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % q_ALLA = data(1:n1)
end subroutine psset_q_alla


subroutine psgetrnk_q_alla(iobj, ndims, ierr)
    !! ALLA specie charge
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_q_alla


subroutine psgetdim_q_alla(iobj, ndims, dims, ierr)
    !! ALLA specie charge
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_q_alla', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % q_ALLA ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % q_ALLA)
    endif
end subroutine psgetdim_q_alla


subroutine psget_qie(iobj, n1, data, ierr)
    !! Ion->Electron heat coupling, +: power flow from ions to
    !! electrons, -: power flow from electrons to ions
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_qie', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % qie
end subroutine psget_qie


subroutine psset_qie(iobj, n1, data, ierr)
    !! Ion->Electron heat coupling, +: power flow from ions to
    !! electrons, -: power flow from electrons to ions
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_qie', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % qie = data(1:n1)
end subroutine psset_qie


subroutine psgetrnk_qie(iobj, ndims, ierr)
    !! Ion->Electron heat coupling, +: power flow from ions to
    !! electrons, -: power flow from electrons to ions
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_qie


subroutine psgetdim_qie(iobj, ndims, dims, ierr)
    !! Ion->Electron heat coupling, +: power flow from ions to
    !! electrons, -: power flow from electrons to ions
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_qie', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % qie ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % qie)
    endif
end subroutine psgetdim_qie

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_r6_dummy
     return
  end subroutine ccps_getset_r6_dummy

subroutine psget_r_max_box(iobj, data, ierr)
    !! R_max of bounding box
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_r_max_box', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % R_max_box
end subroutine psget_r_max_box


subroutine psset_r_max_box(iobj, data, ierr)
    !! R_max of bounding box
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_r_max_box', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % R_max_box = data
end subroutine psset_r_max_box


subroutine psget_rhopsi0lh(iobj, n1, n2, data, ierr)
    !! need description
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_rhopsi0lh', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % rhopsi0lh
end subroutine psget_rhopsi0lh


subroutine psset_rhopsi0lh(iobj, n1, n2, data, ierr)
    !! need description
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_rhopsi0lh', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % rhopsi0lh = data(1:n1, 1: n2)
end subroutine psset_rhopsi0lh


subroutine psgetrnk_rhopsi0lh(iobj, ndims, ierr)
    !! need description
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_rhopsi0lh


subroutine psgetdim_rhopsi0lh(iobj, ndims, dims, ierr)
    !! need description
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_rhopsi0lh', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % rhopsi0lh ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % rhopsi0lh)
    endif
end subroutine psgetdim_rhopsi0lh


subroutine psget_rho(iobj, n1, data, ierr)
    !! rho grid (PLASMA)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_rho', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % rho
end subroutine psget_rho


subroutine psset_rho(iobj, n1, data, ierr)
    !! rho grid (PLASMA)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_rho', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % rho = data(1:n1)
end subroutine psset_rho


subroutine psgetrnk_rho(iobj, ndims, ierr)
    !! rho grid (PLASMA)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_rho


subroutine psgetdim_rho(iobj, ndims, dims, ierr)
    !! rho grid (PLASMA)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_rho', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % rho ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % rho)
    endif
end subroutine psgetdim_rho


subroutine psget_rho_nbi(iobj, n1, data, ierr)
    !! rho grid -- NBI
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_rho_nbi', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % rho_nbi
end subroutine psget_rho_nbi


subroutine psset_rho_nbi(iobj, n1, data, ierr)
    !! rho grid -- NBI
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_rho_nbi', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % rho_nbi = data(1:n1)
end subroutine psset_rho_nbi


subroutine psgetrnk_rho_nbi(iobj, ndims, ierr)
    !! rho grid -- NBI
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_rho_nbi


subroutine psgetdim_rho_nbi(iobj, ndims, dims, ierr)
    !! rho grid -- NBI
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_rho_nbi', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % rho_nbi ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % rho_nbi)
    endif
end subroutine psgetdim_rho_nbi


subroutine psget_rho_lhrf(iobj, n1, data, ierr)
    !! rho grid -- LHRF
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_rho_lhrf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % rho_lhrf
end subroutine psget_rho_lhrf


subroutine psset_rho_lhrf(iobj, n1, data, ierr)
    !! rho grid -- LHRF
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_rho_lhrf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % rho_lhrf = data(1:n1)
end subroutine psset_rho_lhrf


subroutine psgetrnk_rho_lhrf(iobj, ndims, ierr)
    !! rho grid -- LHRF
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_rho_lhrf


subroutine psgetdim_rho_lhrf(iobj, ndims, dims, ierr)
    !! rho grid -- LHRF
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_rho_lhrf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % rho_lhrf ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % rho_lhrf)
    endif
end subroutine psgetdim_rho_lhrf


subroutine psget_rho_gas(iobj, n1, data, ierr)
    !! rho grid (GAS -- neutral gas model)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_rho_gas', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % rho_gas
end subroutine psget_rho_gas


subroutine psset_rho_gas(iobj, n1, data, ierr)
    !! rho grid (GAS -- neutral gas model)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_rho_gas', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % rho_gas = data(1:n1)
end subroutine psset_rho_gas


subroutine psgetrnk_rho_gas(iobj, ndims, ierr)
    !! rho grid (GAS -- neutral gas model)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_rho_gas


subroutine psgetdim_rho_gas(iobj, ndims, dims, ierr)
    !! rho grid (GAS -- neutral gas model)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_rho_gas', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % rho_gas ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % rho_gas)
    endif
end subroutine psgetdim_rho_gas


subroutine psget_res_te(iobj, n1, data, ierr)
    !! residuals for electron transport eqn
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_res_te', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % res_te
end subroutine psget_res_te


subroutine psset_res_te(iobj, n1, data, ierr)
    !! residuals for electron transport eqn
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_res_te', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % res_te = data(1:n1)
end subroutine psset_res_te


subroutine psgetrnk_res_te(iobj, ndims, ierr)
    !! residuals for electron transport eqn
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_res_te


subroutine psgetdim_res_te(iobj, ndims, dims, ierr)
    !! residuals for electron transport eqn
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_res_te', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % res_te ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % res_te)
    endif
end subroutine psgetdim_res_te


subroutine psget_r_surfmax(iobj, n1, data, ierr)
    !! max R on flux surface
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_r_surfmax', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % R_surfMax
end subroutine psget_r_surfmax


subroutine psset_r_surfmax(iobj, n1, data, ierr)
    !! max R on flux surface
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_r_surfmax', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % R_surfMax = data(1:n1)
end subroutine psset_r_surfmax


subroutine psgetrnk_r_surfmax(iobj, ndims, ierr)
    !! max R on flux surface
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_r_surfmax


subroutine psgetdim_r_surfmax(iobj, ndims, dims, ierr)
    !! max R on flux surface
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_r_surfmax', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % R_surfMax ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % R_surfMax)
    endif
end subroutine psgetdim_r_surfmax


subroutine psget_rate_sinf0xs(iobj, n1, n2, n3, data, ierr)
    !! sink rate due to CX with fusion ions
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2, n3 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2, n3) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_rate_sinf0xs', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2, 1: n3) = ss % rate_sinf0xs
end subroutine psget_rate_sinf0xs


subroutine psset_rate_sinf0xs(iobj, n1, n2, n3, data, ierr)
    !! sink rate due to CX with fusion ions
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2, n3 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2, n3) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_rate_sinf0xs', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % rate_sinf0xs = data(1:n1, 1: n2, 1: n3)
end subroutine psset_rate_sinf0xs


subroutine psgetrnk_rate_sinf0xs(iobj, ndims, ierr)
    !! sink rate due to CX with fusion ions
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 3
end subroutine psgetrnk_rate_sinf0xs


subroutine psgetdim_rate_sinf0xs(iobj, ndims, dims, ierr)
    !! sink rate due to CX with fusion ions
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 3) ierr = 1
    call ccps_argcheck('psgetdim_rate_sinf0xs', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % rate_sinf0xs ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % rate_sinf0xs)
    endif
end subroutine psgetdim_rate_sinf0xs

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


SUBROUTINE ps_update_file_read_4(ss,icdf,iout,iucount,iertot)


  ! Read updated data

  USE plasma_state_definition_mod
  USE plasma_hash_code
  USE netcdf
  IMPLICIT NONE

  TYPE (plasma_state) :: ss  ! state containing array elements to be allocated
  INTEGER, INTENT(IN) :: icdf  ! NetCDF file ID
  INTEGER, INTENT(IN) :: iout  ! LUN for messages
  INTEGER, INTENT(INOUT) :: iucount ! update count
  INTEGER, INTENT(INOUT) :: iertot  ! error count

  !-------------------

  INTEGER :: varid,status
  INTEGER :: ival,jval,ii
  INTEGER :: prehash1,prehash2
  INTEGER :: posthash1,posthash2
  CHARACTER*80 :: nc_errmsg
  LOGICAL :: izero

  !-------------------


  status = nf90_inq_varid(icdf,"NBI_Data_Info",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%NBI_Data_Info)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: NBI_Data_Info"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"nbi_src_name",varid)
  IF(status.EQ.NF90_NOERR) THEN
     CALL cchk_zero(ss%nbi_src_name)
     status = nf90_get_var(icdf,varid,ss%nbi_src_name)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: nbi_src_name"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
     IF(.NOT.izero) THEN
        CALL cchk_hash("nbi_src_name",ss%nbi_src_name)
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"nbshape",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%nbshape)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: nbshape"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"nebar",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%nebar)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: nebar"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"neflux_ky_tglf",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%neflux_ky_tglf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: neflux_ky_tglf"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Newcomb_code",varid)
  IF(status.EQ.NF90_NOERR) THEN
     CALL cchk_zero(ss%Newcomb_code)
     status = nf90_get_var(icdf,varid,ss%Newcomb_code)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: Newcomb_code"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
     IF(.NOT.izero) THEN
        CALL cchk_hash("Newcomb_code",ss%Newcomb_code)
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Newcomb_mapper",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%Newcomb_mapper)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: Newcomb_mapper"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Newcomb_stable",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%Newcomb_stable)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: Newcomb_stable"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Newcomb_status",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%Newcomb_status)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: Newcomb_status"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"ne_ky_tglf",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%ne_ky_tglf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: ne_ky_tglf"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"nfusi",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%nfusi)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: nfusi"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"nfusi_bdy",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%nfusi_bdy)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: nfusi_bdy"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"ngradb2_av",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%ngradb2_av)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: ngradb2_av"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"ni",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%ni)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: ni"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"niflux_ky_tglf",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%niflux_ky_tglf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: niflux_ky_tglf"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"ni_ky_tglf",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%ni_ky_tglf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: ni_ky_tglf"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"nmdifb",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%nmdifb)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: nmdifb"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"nmini",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%nmini)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: nmini"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"nmini_bdy",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%nmini_bdy)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: nmini_bdy"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"nmodel",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%nmodel)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: nmodel"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"nmodel_bdy",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%nmodel_bdy)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: nmodel_bdy"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"nmom",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%nmom)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: nmom"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"nnkparlh",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%nnkparlh)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: nnkparlh"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"nnkpollh",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%nnkpollh)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: nnkpollh"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"nnktorlh",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%nnktorlh)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: nnktorlh"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"nphi",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%nphi)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: nphi"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"nrw",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%nrw)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: nrw"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"nrz_antgeo",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%nrz_antgeo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: nrz_antgeo"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"ns",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%ns)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: ns"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"nspectrumlh_src",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%nspectrumlh_src)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: nspectrumlh_src"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"ns_bdy",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%ns_bdy)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: ns_bdy"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"ns_Data_Info",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%ns_Data_Info)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: ns_Data_Info"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"ns_is_input",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%ns_is_input)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: ns_is_input"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"ntf_coil2",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%ntf_coil2)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: ntf_coil2"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

CONTAINS

  subroutine ichk_zero(iarray)
     integer, dimension(:), intent(in) :: iarray

     integer :: ii

     izero=.TRUE.
     do ii=1,size(iarray)
        if(iarray(ii).ne.0) then
           izero=.FALSE.
           exit
        endif
     enddo

     if(.not.izero) then
        prehash1=17
        prehash2=23
        call hashCode(iarray,prehash1,prehash2)
     endif

  end subroutine ichk_zero

  subroutine rchk_zero(rarray)
     real(kind=rspec), dimension(:), intent(in) :: rarray

     integer :: ii

     izero=.TRUE.
     do ii=1,size(rarray)
        if(rarray(ii).ne.0.0_rspec) then
           izero=.FALSE.
           exit
        endif
     enddo

     if(.not.izero) then
        prehash1=17
        prehash2=23
        call hashCode(rarray,prehash1,prehash2)
     endif

  end subroutine rchk_zero

  subroutine cchk_zero(c32array)
     character*32, dimension(:), intent(in) :: c32array

     integer :: ii

     izero=.TRUE.
     do ii=1,size(c32array)
        if(c32array(ii).ne." ") then
           izero=.FALSE.
           exit
        endif
     enddo

     if(.not.izero) then
        prehash1=17
        prehash2=23
        call hashCode(c32array,prehash1,prehash2)
     endif

  end subroutine cchk_zero

  subroutine ichk_hash(itemName,iarray)
     character*(*), intent(in) :: itemName
     integer, dimension(:), intent(in) :: iarray

     posthash1=17
     posthash2=23
     call hashCode(iarray,posthash1,posthash2)

     if((prehash1.ne.posthash1).OR.(prehash2.ne.posthash2)) then
        write(iout,*) ' ?ps_update_file_read: value change detected in dimension quantity: '//trim(itemName)
        iertot = iertot + 1
     endif

  end subroutine ichk_hash

  subroutine rchk_hash(itemName,rarray)
     character*(*), intent(in) :: itemName
     real(kind=rspec), dimension(:), intent(in) :: rarray

     posthash1=17
     posthash2=23
     call hashCode(rarray,posthash1,posthash2)

     if((prehash1.ne.posthash1).OR.(prehash2.ne.posthash2)) then
        write(iout,*) ' ?ps_update_file_read: value change detected in dimension quantity: '//trim(itemName)
        iertot = iertot + 1
     endif

  end subroutine rchk_hash

  subroutine cchk_hash(itemName,c32array)
     character*(*), intent(in) :: itemName
     character*32, dimension(:), intent(in) :: c32array

     posthash1=17
     posthash2=23
     call hashCode(c32array,posthash1,posthash2)

     if((prehash1.ne.posthash1).OR.(prehash2.ne.posthash2)) then
        write(iout,*) ' ?ps_update_file_read: value change detected in dimension quantity: '//trim(itemName)
        iertot = iertot + 1
     endif

  end subroutine cchk_hash

  SUBROUTINE ichk_dim(ival,jval,dname)
     INTEGER, intent(in) :: ival  ! file dimension value
     INTEGER, intent(in) :: jval  ! state dimension value
     CHARACTER*(*), intent(in) :: dname

     IF(ival.ne.jval) THEN
        WRITE(iout,*) ' ?ps_update_file_read: update file dimension not consistent with state:'
        WRITE(iout,*) '  file value:  ',ival
        WRITE(iout,*) '  state value: ',jval
        WRITE(iout,*) '  dimension name: '//trim(dname)
        iertot = iertot + 1
     ENDIF
  END SUBROUTINE ichk_dim

  SUBROUTINE ncerr(status)
     INTEGER, INTENT(in) :: status

     nc_errmsg = NF90_strerror(status)
     write(iout,*) '  NetCDF message: ',trim(nc_errmsg)
  END SUBROUTINE ncerr

  SUBROUTINE denull(str)
     ! convert null characters to blank
     CHARACTER*(*) :: str
     INTEGER :: i

     do i=1,len(str)
        if(ichar(str(i:i)).eq.0) str(i:i)=' '
     enddo
  END SUBROUTINE denull

END SUBROUTINE ps_update_file_read_4

subroutine ccps_get_prof_label(iobj,id,label,units,component,ierr)

  ! retrieve label information for specified profile
  !    C caller should allow 120 bytes for label, and 32 bytes for units
  !    and components -- all returned as null terminated byte strings

  use plasma_state_mod
  implicit NONE

#include "fpreproc/byte_declare.h"

  integer :: iobj(*)        ! (ps_container_size) words are used: state object
  integer :: id             ! profile ID

  BYTE_DECLARE, intent(out) :: label(*)     ! item label (up to 120 characters)
  BYTE_DECLARE, intent(out) :: units(*)     ! item physical units (up to 32 characters)
  BYTE_DECLARE, intent(out) :: component(*) ! component owning the item (up to 32 characters).

  integer,intent(out) :: ierr   ! exit status 0=OK

  !-------------------------
  type (plasma_state_container) :: ptr
  type (plasma_state), pointer :: ss
  character*32 :: zunits,zcomponent
  character*120 :: zlabel
  !-------------------------

  call cstring(" ",label,'2C')
  call cstring(" ",units,'2C')
  call cstring(" ",component,'2C')

  call ccps_argcheck('ccps_get_prof_label',iobj,ierr)
  if(ierr.ne.0) return

  ! proceed...

  call load_ps_container(iobj,ptr)
  ss => ptr%ps_ptr

  call ps_get_prof_label(id,ierr, state=ss, &
       label=zlabel, units=zunits, author=zcomponent)

  call cstring(trim(zlabel),label,'2C')
  call cstring(trim(zunits),units,'2C')
  call cstring(trim(zcomponent),component,'2C')

end subroutine ccps_get_prof_label

subroutine ur_cstate_xplasma_plots

  !  XPLASMA level plots of a single individual state

  use plasma_state_mod
  implicit NONE

  !---------------------------------
  !  local:

  integer :: luntty,lnout
  integer :: i,istate,ierr
  logical :: lxout
  !---------------------------------

  luntty = lnout(0)

  if(nsss_cur.eq.0) then

     write(luntty,*) ' %ur_cstate_xplasma_plots: no states are loaded.'
     return

  endif

  do
     if(lxout(0)) then
        write(luntty,*) ' '
        write(luntty,'(1x,i1," states are loaded:")') nsss_cur
        do i=1,nsss_cur
           write(luntty,*) ' '
           write(luntty,'(" state #",i1,"  label: ",a)') i,trim(sss_label(i))
           write(luntty,'("    path: ",a)') trim(sss_path(i))
        enddo

        write(luntty,*) ' '
        write(luntty,*) ' state data to be plotted with original labels.'
        write(luntty,*) ' enter state # or "0" or "Q" to skip.'
        write(luntty,*) ' '
     endif

     istate = 0
     call ureadi('ur_cstate_xplasma_plots: state# or "0" to exit:',istate)

     if(istate.eq.0) exit

     if((istate.lt.0).or.(istate.gt.nsss_cur)) then
        call uermsi('state number not in available range',istate,0)
        cycle
     endif

     call ps_dbg_plot(sss(istate)%iobj, luntty, ierr)
  enddo

end subroutine ur_cstate_xplasma_plots

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_g6_dummy
     return
  end subroutine ccps_getset_g6_dummy

subroutine psget_gs_name(iobj, n1, data, ierr)
    !! number & name of edge neutral gas sources
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    CHARACTER*(*), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_gs_name', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % gs_name
end subroutine psget_gs_name


subroutine psset_gs_name(iobj, n1, data, ierr)
    !! number & name of edge neutral gas sources
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    CHARACTER*(*), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_gs_name', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % gs_name = data(1:n1)
end subroutine psset_gs_name


subroutine psgetsz_gs_name(iobj, size, ierr)
    !! number & name of edge neutral gas sources
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: size    ! size of character string
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psgetsz_gs_name', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! note that the following will return the character length size regardless of
    ! the number of array elements (if gs_name is an array)
    size = len(ss % gs_name)
end subroutine psgetsz_gs_name


subroutine psgetrnk_gs_name(iobj, ndims, ierr)
    !! number & name of edge neutral gas sources
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_gs_name


subroutine psgetdim_gs_name(iobj, ndims, dims, ierr)
    !! number & name of edge neutral gas sources
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_gs_name', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % gs_name ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % gs_name)
    endif
end subroutine psgetdim_gs_name


subroutine psget_g_eq(iobj, n1, data, ierr)
    !! equilibrium R*|B_phi|, By convention this profile is always
    !! positive; direction, of B_phi is taken from element kccw_Bphi:,
    !! B_phi = kccw_Bphi*g/R
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_g_eq', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % g_eq
end subroutine psget_g_eq


subroutine psset_g_eq(iobj, n1, data, ierr)
    !! equilibrium R*|B_phi|, By convention this profile is always
    !! positive; direction, of B_phi is taken from element kccw_Bphi:,
    !! B_phi = kccw_Bphi*g/R
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_g_eq', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % g_eq = data(1:n1)
end subroutine psset_g_eq


subroutine psgetrnk_g_eq(iobj, ndims, ierr)
    !! equilibrium R*|B_phi|, By convention this profile is always
    !! positive; direction, of B_phi is taken from element kccw_Bphi:,
    !! B_phi = kccw_Bphi*g/R
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_g_eq


subroutine psgetdim_g_eq(iobj, ndims, dims, ierr)
    !! equilibrium R*|B_phi|, By convention this profile is always
    !! positive; direction, of B_phi is taken from element kccw_Bphi:,
    !! B_phi = kccw_Bphi*g/R
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_g_eq', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % g_eq ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % g_eq)
    endif
end subroutine psgetdim_g_eq


subroutine psget_gr2(iobj, n1, data, ierr)
    !! <R^2>
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_gr2', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % gr2
end subroutine psget_gr2


subroutine psset_gr2(iobj, n1, data, ierr)
    !! <R^2>
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_gr2', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % gr2 = data(1:n1)
end subroutine psset_gr2


subroutine psgetrnk_gr2(iobj, ndims, ierr)
    !! <R^2>
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_gr2


subroutine psgetdim_gr2(iobj, ndims, dims, ierr)
    !! <R^2>
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_gr2', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % gr2 ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % gr2)
    endif
end subroutine psgetdim_gr2


subroutine psget_grho2b2i(iobj, n1, data, ierr)
    !! <|grad(rho)|^2/B^2>
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_grho2b2i', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % grho2b2i
end subroutine psget_grho2b2i


subroutine psset_grho2b2i(iobj, n1, data, ierr)
    !! <|grad(rho)|^2/B^2>
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_grho2b2i', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % grho2b2i = data(1:n1)
end subroutine psset_grho2b2i


subroutine psgetrnk_grho2b2i(iobj, ndims, ierr)
    !! <|grad(rho)|^2/B^2>
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_grho2b2i


subroutine psgetdim_grho2b2i(iobj, ndims, dims, ierr)
    !! <|grad(rho)|^2/B^2>
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_grho2b2i', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % grho2b2i ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % grho2b2i)
    endif
end subroutine psgetdim_grho2b2i

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_d5_dummy
     return
  end subroutine ccps_getset_d5_dummy

subroutine psget_deltaw_code(iobj, n1, data, ierr)
    !! name(s) of delta(W) code(s) used
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    CHARACTER*(*), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_deltaw_code', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % DeltaW_code
end subroutine psget_deltaw_code


subroutine psset_deltaw_code(iobj, n1, data, ierr)
    !! name(s) of delta(W) code(s) used
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    CHARACTER*(*), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_deltaw_code', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % DeltaW_code = data(1:n1)
end subroutine psset_deltaw_code


subroutine psgetsz_deltaw_code(iobj, size, ierr)
    !! name(s) of delta(W) code(s) used
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: size    ! size of character string
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psgetsz_deltaw_code', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! note that the following will return the character length size regardless of
    ! the number of array elements (if DeltaW_code is an array)
    size = len(ss % DeltaW_code)
end subroutine psgetsz_deltaw_code


subroutine psgetrnk_deltaw_code(iobj, ndims, ierr)
    !! name(s) of delta(W) code(s) used
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_deltaw_code


subroutine psgetdim_deltaw_code(iobj, ndims, dims, ierr)
    !! name(s) of delta(W) code(s) used
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_deltaw_code', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % DeltaW_code ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % DeltaW_code)
    endif
end subroutine psgetdim_deltaw_code


subroutine psget_diff_trans(iobj, n1, n2, data, ierr)
    !! specie ptcl diffusivity
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_diff_trans', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % diff_trans
end subroutine psget_diff_trans


subroutine psset_diff_trans(iobj, n1, n2, data, ierr)
    !! specie ptcl diffusivity
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_diff_trans', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % diff_trans = data(1:n1, 1: n2)
end subroutine psset_diff_trans


subroutine psgetrnk_diff_trans(iobj, ndims, ierr)
    !! specie ptcl diffusivity
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_diff_trans


subroutine psgetdim_diff_trans(iobj, ndims, dims, ierr)
    !! specie ptcl diffusivity
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_diff_trans', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % diff_trans ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % diff_trans)
    endif
end subroutine psgetdim_diff_trans


subroutine psget_difb_nbi(iobj, n1, data, ierr)
    !! beam ion anomalous diffusivity
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_difb_nbi', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % difb_nbi
end subroutine psget_difb_nbi


subroutine psset_difb_nbi(iobj, n1, data, ierr)
    !! beam ion anomalous diffusivity
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_difb_nbi', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % difb_nbi = data(1:n1)
end subroutine psset_difb_nbi


subroutine psgetrnk_difb_nbi(iobj, ndims, ierr)
    !! beam ion anomalous diffusivity
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_difb_nbi


subroutine psgetdim_difb_nbi(iobj, ndims, dims, ierr)
    !! beam ion anomalous diffusivity
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_difb_nbi', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % difb_nbi ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % difb_nbi)
    endif
end subroutine psgetdim_difb_nbi


subroutine psget_difns_anom(iobj, n1, n2, data, ierr)
    !! density-equations, diffusivity term
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_difns_anom', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % difns_anom
end subroutine psget_difns_anom


subroutine psset_difns_anom(iobj, n1, n2, data, ierr)
    !! density-equations, diffusivity term
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_difns_anom', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % difns_anom = data(1:n1, 1: n2)
end subroutine psset_difns_anom


subroutine psgetrnk_difns_anom(iobj, ndims, ierr)
    !! density-equations, diffusivity term
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_difns_anom


subroutine psgetdim_difns_anom(iobj, ndims, dims, ierr)
    !! density-equations, diffusivity term
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_difns_anom', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % difns_anom ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % difns_anom)
    endif
end subroutine psgetdim_difns_anom


subroutine psget_d2r_geo_drhodth(iobj, n1, n2, data, ierr)
    !! flux surfaces R(rho,theta)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_d2r_geo_drhodth', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % d2R_geo_dRHOdTH
end subroutine psget_d2r_geo_drhodth


subroutine psset_d2r_geo_drhodth(iobj, n1, n2, data, ierr)
    !! flux surfaces R(rho,theta)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_d2r_geo_drhodth', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % d2R_geo_dRHOdTH = data(1:n1, 1: n2)
end subroutine psset_d2r_geo_drhodth


subroutine psgetrnk_d2r_geo_drhodth(iobj, ndims, ierr)
    !! flux surfaces R(rho,theta)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_d2r_geo_drhodth


subroutine psgetdim_d2r_geo_drhodth(iobj, ndims, dims, ierr)
    !! flux surfaces R(rho,theta)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_d2r_geo_drhodth', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % d2R_geo_dRHOdTH ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % d2R_geo_dRHOdTH)
    endif
end subroutine psgetdim_d2r_geo_drhodth

subroutine ur_cstate_slists

  ! examine species lists contained in the state(s)

  use cstate_lib_mod
  implicit NONE

  !-------------------------
  ! local

  integer :: luntty,lnout
  logical :: lxout,lchar,lyes

  integer :: ii,jj,ia,ierr,imatch,isize_tot,izc,iza,ivd2
  integer :: idetail,ilen_coln(0:nsss_cur),ilen0d
  character*32 :: sname

  character*1 :: dd(2) = (/ 'Y', 'N' /)
  character*256 :: hdr,rln,buf

  integer, dimension(:,:), allocatable :: addr_table
  character*10, dimension(:,:), allocatable :: val_field
  !-------------------------

  luntty = lnout(0)
  idetail = 2

  call psw_contents('S',ncur_components,w1,ierr, state=sss(1))
  
  do
     if(lxout(0)) then
        write(luntty,1001) omit_empty,trim(cur_components),dd(idetail)

1001    format('ur_cstate_slists options:'/ &
             '  A -- option to omit empty elements from display (',L1,')'/ &
             '  C -- select & restrict view to component(s) (current selection: ',a,')'/ &
             '  T -- table of contents (show dimensions and description)'/ &
             '  U -- table of contents (show component and description)'/ &
             '  D -- summary comparitive display of species lists'/ &
             '  S -- select a single species list & compare; details=',a1/ &
             '  X -- set details flag for species list comparison.'/ &
             '  L -- modify state label(s)'/ &
             '  Q -- quit this menu'/)
     endif
     call uread('ur_cstate_slists option:')

     if(lchar('Q')) then
        exit

     else if(lchar('A')) then
        if(lxout(0)) write(luntty,*) &
             ' option to omit display of elements that are empty in all states.'

        call uread('omit empty elements ? (Y/N):')
        omit_empty = lyes(0)

     else if(lchar('C')) then
        call ur_cstate_component

     else if(lchar('D')) then
        call ur_dcomp_display('S', 'Species_count', 'lists')

     else if(lchar('X')) then
        if(lxout(0)) then
           write(luntty,*) 'answer "Y" to for display of atomic charge and weight of species.'
        endif
        call uread('show details on species? (Y/N):')
        if(lyes(0)) then
           idetail=1
        else
           idetail=2
        endif

     else if(lchar('L')) then
        call ur_cstate_setLabel

     else if(lchar('T')) then
        call ur_cstate_slist_contents(1)

     else if(lchar('U')) then
        call ur_cstate_slist_contents(2)

     else if(lchar('S')) then
        call psw_contents('S',ncur_components,w1,ierr, state=sss(1))
        if(w1%size.eq.0) then
           write(luntty,*) ' %ur_cstate_slists: no species lists found in currently selected components.'
           cycle
        endif

        if(lxout(0)) then
           write(luntty,*) '(unambiguous prefix of name may be entered).'
        endif
        call ureadw('name of species list to examine:',sname)
        if(sname.eq.'Q') cycle
        if(sname.eq.'.') cycle

        call cstate_findm(sname,luntty,imatch)
        if(imatch.eq.0) then
           call uclear
           cycle
        endif

        isize_tot = 0
        do ii=1,nsss_cur
           call psw_slist(sname,ww(ii),ierr, state=sss(ii))

           if(ww(ii)%size.eq.0) then
              write(luntty,*) ' empty list for state: '//trim(sss_label(ii))
           else
              isize_tot=isize_tot + ww(ii)%size
           endif
        enddo

        if(isize_tot.eq.0) then
           write(luntty,*) ' empty list.'
           cycle
        endif

        allocate(addr_table(nsss_cur,isize_tot))
        call psw_merge(ww,wmerge,ierr, addr_table=addr_table)
        isize_tot = wmerge%size

        if(ierr.eq.0) then

           !  show which species are in which state...

           ilen_coln(0)=len(trim(ww(1)%list_name))
           do ii=1,nsss_cur
              ilen_coln(ii)=max(7,len(trim(sss_label(ii))))
           enddo

           allocate(val_field(nsss_cur,isize_tot))
           ivd2 = isize_tot

           do jj=1,isize_tot
              if(wmerge%list_elems(jj).eq.'E') then
                 wmerge%list_elems(jj) = 'e'
              endif
              do ii=1,nsss_cur
                 if(addr_table(ii,jj).gt.0) then
                    val_field(ii,jj)='PRESENT'
                 else
                    val_field(ii,jj)='absent'
                 endif
              enddo
           enddo

           call cstate_table_out(ww(1)%list_name, '   ', '   ', &
                ilen_coln,2,val_field,ivd2, &
                0,isize_tot)

           ilen0d = len('Species_Label')
           do jj=1,isize_tot
              ilen0d = max(ilen0d,len(trim(wmerge%list_elems(jj))))
           enddo
           write(luntty,*) ' '

           if(idetail.eq.1) then

              !  show information on individual species

              hdr = 'Species_Label'
              rln = rline(1:ilen0d)
              hdr(ilen0d+1:) = '  Type_ID  Z_charge  Z_atom  A_wght'
              rln(ilen0d+1:) = '  -------  --------  ------  ----------'
              write(luntty,*) trim(hdr)
              write(luntty,*) trim(rln)

              do jj=1,isize_tot
                 if(wmerge%qval(jj).lt.0) then
                    buf = 'e'
                 else
                    buf = wmerge%list_elems(jj)
                 endif
                 izc = wmerge%qval(jj)
                 iza = wmerge%qatom(jj)
                 write(buf(ilen0d+1:),'(4x,i2,8x,i2,7x,i2,3x,1pe11.4)') &
                      wmerge%spectype(jj),izc,iza,wmerge%awght(jj)/ps_mp
                 write(luntty,*) trim(buf)
              enddo
              write(luntty,*) ' '
           endif

           deallocate(val_field)
        endif

        deallocate(addr_table)
     else
        call uermsg(' ?ur_cstate_slists: unrecognized option.',' ',0)
     endif
  enddo

end subroutine ur_cstate_slists

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_t8_dummy
     return
  end subroutine ccps_getset_t8_dummy

subroutine psget_trcat(iobj, n1, data, ierr)
    !! Application defined list of, transport categories (possible
    !! examples: NC for neoclassical,, TURB for turbulent, SAW for
    !! sawtooth induced, ...); used to, dimension profile data
    !! provided to quantify transport rates, according to underlying
    !! physics
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    CHARACTER*(*), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_trcat', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % trcat
end subroutine psget_trcat


subroutine psset_trcat(iobj, n1, data, ierr)
    !! Application defined list of, transport categories (possible
    !! examples: NC for neoclassical,, TURB for turbulent, SAW for
    !! sawtooth induced, ...); used to, dimension profile data
    !! provided to quantify transport rates, according to underlying
    !! physics
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    CHARACTER*(*), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_trcat', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % trcat = data(1:n1)
end subroutine psset_trcat


subroutine psgetsz_trcat(iobj, size, ierr)
    !! Application defined list of, transport categories (possible
    !! examples: NC for neoclassical,, TURB for turbulent, SAW for
    !! sawtooth induced, ...); used to, dimension profile data
    !! provided to quantify transport rates, according to underlying
    !! physics
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: size    ! size of character string
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psgetsz_trcat', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! note that the following will return the character length size regardless of
    ! the number of array elements (if trcat is an array)
    size = len(ss % trcat)
end subroutine psgetsz_trcat


subroutine psgetrnk_trcat(iobj, ndims, ierr)
    !! Application defined list of, transport categories (possible
    !! examples: NC for neoclassical,, TURB for turbulent, SAW for
    !! sawtooth induced, ...); used to, dimension profile data
    !! provided to quantify transport rates, according to underlying
    !! physics
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_trcat


subroutine psgetdim_trcat(iobj, ndims, dims, ierr)
    !! Application defined list of, transport categories (possible
    !! examples: NC for neoclassical,, TURB for turbulent, SAW for
    !! sawtooth induced, ...); used to, dimension profile data
    !! provided to quantify transport rates, according to underlying
    !! physics
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_trcat', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % trcat ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % trcat)
    endif
end subroutine psgetdim_trcat


subroutine psget_ti_bdy(iobj, data, ierr)
    !! Ion temperature at/beyond boundary
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_ti_bdy', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % Ti_bdy
end subroutine psget_ti_bdy


subroutine psset_ti_bdy(iobj, data, ierr)
    !! Ion temperature at/beyond boundary
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_ti_bdy', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % Ti_bdy = data
end subroutine psset_ti_bdy


subroutine psget_tmodel_bdy(iobj, data, ierr)
    !! model temperature, boundary value
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_tmodel_bdy', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % tmodel_bdy
end subroutine psget_tmodel_bdy


subroutine psset_tmodel_bdy(iobj, data, ierr)
    !! model temperature, boundary value
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_tmodel_bdy', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % tmodel_bdy = data
end subroutine psset_tmodel_bdy


subroutine psget_tqcx_halo(iobj, n1, data, ierr)
    !! beam halo driven CX momentum torque, (positive value =
    !! momentum source), (no associated particle source/sink)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_tqcx_halo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % tqcx_halo
end subroutine psget_tqcx_halo


subroutine psset_tqcx_halo(iobj, n1, data, ierr)
    !! beam halo driven CX momentum torque, (positive value =
    !! momentum source), (no associated particle source/sink)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_tqcx_halo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % tqcx_halo = data(1:n1)
end subroutine psset_tqcx_halo


subroutine psgetrnk_tqcx_halo(iobj, ndims, ierr)
    !! beam halo driven CX momentum torque, (positive value =
    !! momentum source), (no associated particle source/sink)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_tqcx_halo


subroutine psgetdim_tqcx_halo(iobj, ndims, dims, ierr)
    !! beam halo driven CX momentum torque, (positive value =
    !! momentum source), (no associated particle source/sink)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_tqcx_halo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % tqcx_halo ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % tqcx_halo)
    endif
end subroutine psgetdim_tqcx_halo


subroutine psget_t0sc0(iobj, n1, n2, n3, data, ierr)
    !! neutral temperature (2/3)<E0>, in co-rotating frame for each
    !! neutral specie, due each neutral influx (sc0)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2, n3 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2, n3) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_t0sc0', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2, 1: n3) = ss % T0sc0
end subroutine psget_t0sc0


subroutine psset_t0sc0(iobj, n1, n2, n3, data, ierr)
    !! neutral temperature (2/3)<E0>, in co-rotating frame for each
    !! neutral specie, due each neutral influx (sc0)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2, n3 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2, n3) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_t0sc0', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % T0sc0 = data(1:n1, 1: n2, 1: n3)
end subroutine psset_t0sc0


subroutine psgetrnk_t0sc0(iobj, ndims, ierr)
    !! neutral temperature (2/3)<E0>, in co-rotating frame for each
    !! neutral specie, due each neutral influx (sc0)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 3
end subroutine psgetrnk_t0sc0


subroutine psgetdim_t0sc0(iobj, ndims, dims, ierr)
    !! neutral temperature (2/3)<E0>, in co-rotating frame for each
    !! neutral specie, due each neutral influx (sc0)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 3) ierr = 1
    call ccps_argcheck('psgetdim_t0sc0', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % T0sc0 ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % T0sc0)
    endif
end subroutine psgetdim_t0sc0


subroutine psget_tqcx_reco(iobj, n1, data, ierr)
    !! reco driven CX momentum torque, (positive value = momentum
    !! source), (no associated particle source/sink)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_tqcx_reco', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % tqcx_reco
end subroutine psget_tqcx_reco


subroutine psset_tqcx_reco(iobj, n1, data, ierr)
    !! reco driven CX momentum torque, (positive value = momentum
    !! source), (no associated particle source/sink)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_tqcx_reco', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % tqcx_reco = data(1:n1)
end subroutine psset_tqcx_reco


subroutine psgetrnk_tqcx_reco(iobj, ndims, ierr)
    !! reco driven CX momentum torque, (positive value = momentum
    !! source), (no associated particle source/sink)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_tqcx_reco


subroutine psgetdim_tqcx_reco(iobj, ndims, dims, ierr)
    !! reco driven CX momentum torque, (positive value = momentum
    !! source), (no associated particle source/sink)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_tqcx_reco', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % tqcx_reco ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % tqcx_reco)
    endif
end subroutine psgetdim_tqcx_reco


subroutine psget_teflux_ky_tglf(iobj, n1, n2, data, ierr)
    !! electron density flux spectrum
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_teflux_ky_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % teflux_ky_tglf
end subroutine psget_teflux_ky_tglf


subroutine psset_teflux_ky_tglf(iobj, n1, n2, data, ierr)
    !! electron density flux spectrum
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_teflux_ky_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % teflux_ky_tglf = data(1:n1, 1: n2)
end subroutine psset_teflux_ky_tglf


subroutine psgetrnk_teflux_ky_tglf(iobj, ndims, ierr)
    !! electron density flux spectrum
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_teflux_ky_tglf


subroutine psgetdim_teflux_ky_tglf(iobj, ndims, dims, ierr)
    !! electron density flux spectrum
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_teflux_ky_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % teflux_ky_tglf ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % teflux_ky_tglf)
    endif
end subroutine psgetdim_teflux_ky_tglf

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


SUBROUTINE plasma_state_merge_1(cclist,w1,ss1,ss2,ss3,icheck,iout,ierr)


  ! Merge floating point data
  !   ss3 <-- w1*ss1 + (1-w1)*ss2

  USE plasma_state_definition_mod
  IMPLICIT NONE

  INTEGER, INTENT(IN) :: cclist(ps_ccount)
                                ! list of components to merge
                                ! use ps_cc_all to merge all components

  REAL(KIND=rspec) :: w1        ! weight on ss1
  TYPE (plasma_state) :: ss1    ! state data to copy *from* with weight (w1)
  TYPE (plasma_state) :: ss2    ! state data to copy *from* with weight (1-w1)
  TYPE (plasma_state) :: ss3    ! state to which data is copied.
  INTEGER, INTENT(IN) :: icheck ! control for checking match of non-floating-
  !  point data: ps_ignore, ps_warn, or ps_error on mismatch.

  INTEGER, INTENT(IN) :: iout
  INTEGER, INTENT(INOUT) :: ierr  ! completion code (not cleared,set on error)

  !-------------------
  INTEGER :: isize
  !-------------------

  !-----------------------------------------------
  ! copy scalars and arrays that are allocated...

  IF((ALLOCATED(ss3%chii_ntm)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%chii_ntm).AND.ALLOCATED(ss2%chii_ntm)) THEN
        CALL ps_conformal("chii_ntm",ss2%chii_ntm,ss3%chii_ntm,iout,ierr)
        CALL ps_conformal("chii_ntm",ss1%chii_ntm,ss3%chii_ntm,iout,ierr)
        if(ierr.eq.0) ss3%chii_ntm = w1*ss1%chii_ntm + (1.0_rspec-w1)*ss2%chii_ntm
     ELSE IF(ALLOCATED(ss1%chii_ntm)) THEN
        CALL ps_conformal("chii_ntm",ss1%chii_ntm,ss3%chii_ntm,iout,ierr)
        ss3%chii_ntm = ss1%chii_ntm
     ELSE IF(ALLOCATED(ss2%chii_ntm)) THEN
        CALL ps_conformal("chii_ntm",ss2%chii_ntm,ss3%chii_ntm,iout,ierr)
        ss3%chii_ntm = ss2%chii_ntm
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%chii_tglf)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%chii_tglf).AND.ALLOCATED(ss2%chii_tglf)) THEN
        CALL ps_conformal("chii_tglf",ss2%chii_tglf,ss3%chii_tglf,iout,ierr)
        CALL ps_conformal("chii_tglf",ss1%chii_tglf,ss3%chii_tglf,iout,ierr)
        if(ierr.eq.0) ss3%chii_tglf = w1*ss1%chii_tglf + (1.0_rspec-w1)*ss2%chii_tglf
     ELSE IF(ALLOCATED(ss1%chii_tglf)) THEN
        CALL ps_conformal("chii_tglf",ss1%chii_tglf,ss3%chii_tglf,iout,ierr)
        ss3%chii_tglf = ss1%chii_tglf
     ELSE IF(ALLOCATED(ss2%chii_tglf)) THEN
        CALL ps_conformal("chii_tglf",ss2%chii_tglf,ss3%chii_tglf,iout,ierr)
        ss3%chii_tglf = ss2%chii_tglf
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%chii_trans)).AND.(cclist(ps_cnum_PLASMA).EQ.1)) THEN
     IF(ALLOCATED(ss1%chii_trans).AND.ALLOCATED(ss2%chii_trans)) THEN
        CALL ps_conformal("chii_trans",ss2%chii_trans,ss3%chii_trans,iout,ierr)
        CALL ps_conformal("chii_trans",ss1%chii_trans,ss3%chii_trans,iout,ierr)
        if(ierr.eq.0) ss3%chii_trans = w1*ss1%chii_trans + (1.0_rspec-w1)*ss2%chii_trans
     ELSE IF(ALLOCATED(ss1%chii_trans)) THEN
        CALL ps_conformal("chii_trans",ss1%chii_trans,ss3%chii_trans,iout,ierr)
        ss3%chii_trans = ss1%chii_trans
     ELSE IF(ALLOCATED(ss2%chii_trans)) THEN
        CALL ps_conformal("chii_trans",ss2%chii_trans,ss3%chii_trans,iout,ierr)
        ss3%chii_trans = ss2%chii_trans
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%chii_transcat)).AND.(cclist(ps_cnum_PLASMA).EQ.1)) THEN
     IF(ALLOCATED(ss1%chii_transcat).AND.ALLOCATED(ss2%chii_transcat)) THEN
        CALL ps_conformal("chii_transcat",ss2%chii_transcat,ss3%chii_transcat,iout,ierr)
        CALL ps_conformal("chii_transcat",ss1%chii_transcat,ss3%chii_transcat,iout,ierr)
        if(ierr.eq.0) ss3%chii_transcat = w1*ss1%chii_transcat + (1.0_rspec-w1)*ss2%chii_transcat
     ELSE IF(ALLOCATED(ss1%chii_transcat)) THEN
        CALL ps_conformal("chii_transcat",ss1%chii_transcat,ss3%chii_transcat,iout,ierr)
        ss3%chii_transcat = ss1%chii_transcat
     ELSE IF(ALLOCATED(ss2%chii_transcat)) THEN
        CALL ps_conformal("chii_transcat",ss2%chii_transcat,ss3%chii_transcat,iout,ierr)
        ss3%chii_transcat = ss2%chii_transcat
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%chii_w19)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%chii_w19).AND.ALLOCATED(ss2%chii_w19)) THEN
        CALL ps_conformal("chii_w19",ss2%chii_w19,ss3%chii_w19,iout,ierr)
        CALL ps_conformal("chii_w19",ss1%chii_w19,ss3%chii_w19,iout,ierr)
        if(ierr.eq.0) ss3%chii_w19 = w1*ss1%chii_w19 + (1.0_rspec-w1)*ss2%chii_w19
     ELSE IF(ALLOCATED(ss1%chii_w19)) THEN
        CALL ps_conformal("chii_w19",ss1%chii_w19,ss3%chii_w19,iout,ierr)
        ss3%chii_w19 = ss1%chii_w19
     ELSE IF(ALLOCATED(ss2%chii_w19)) THEN
        CALL ps_conformal("chii_w19",ss2%chii_w19,ss3%chii_w19,iout,ierr)
        ss3%chii_w19 = ss2%chii_w19
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%chimo_trans)).AND.(cclist(ps_cnum_PLASMA).EQ.1)) THEN
     IF(ALLOCATED(ss1%chimo_trans).AND.ALLOCATED(ss2%chimo_trans)) THEN
        CALL ps_conformal("chimo_trans",ss2%chimo_trans,ss3%chimo_trans,iout,ierr)
        CALL ps_conformal("chimo_trans",ss1%chimo_trans,ss3%chimo_trans,iout,ierr)
        if(ierr.eq.0) ss3%chimo_trans = w1*ss1%chimo_trans + (1.0_rspec-w1)*ss2%chimo_trans
     ELSE IF(ALLOCATED(ss1%chimo_trans)) THEN
        CALL ps_conformal("chimo_trans",ss1%chimo_trans,ss3%chimo_trans,iout,ierr)
        ss3%chimo_trans = ss1%chimo_trans
     ELSE IF(ALLOCATED(ss2%chimo_trans)) THEN
        CALL ps_conformal("chimo_trans",ss2%chimo_trans,ss3%chimo_trans,iout,ierr)
        ss3%chimo_trans = ss2%chimo_trans
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%chimo_transcat)).AND.(cclist(ps_cnum_PLASMA).EQ.1)) THEN
     IF(ALLOCATED(ss1%chimo_transcat).AND.ALLOCATED(ss2%chimo_transcat)) THEN
        CALL ps_conformal("chimo_transcat",ss2%chimo_transcat,ss3%chimo_transcat,iout,ierr)
        CALL ps_conformal("chimo_transcat",ss1%chimo_transcat,ss3%chimo_transcat,iout,ierr)
        if(ierr.eq.0) ss3%chimo_transcat = w1*ss1%chimo_transcat + (1.0_rspec-w1)*ss2%chimo_transcat
     ELSE IF(ALLOCATED(ss1%chimo_transcat)) THEN
        CALL ps_conformal("chimo_transcat",ss1%chimo_transcat,ss3%chimo_transcat,iout,ierr)
        ss3%chimo_transcat = ss1%chimo_transcat
     ELSE IF(ALLOCATED(ss2%chimo_transcat)) THEN
        CALL ps_conformal("chimo_transcat",ss2%chimo_transcat,ss3%chimo_transcat,iout,ierr)
        ss3%chimo_transcat = ss2%chimo_transcat
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%chiphi_anom)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%chiphi_anom).AND.ALLOCATED(ss2%chiphi_anom)) THEN
        CALL ps_conformal("chiphi_anom",ss2%chiphi_anom,ss3%chiphi_anom,iout,ierr)
        CALL ps_conformal("chiphi_anom",ss1%chiphi_anom,ss3%chiphi_anom,iout,ierr)
        if(ierr.eq.0) ss3%chiphi_anom = w1*ss1%chiphi_anom + (1.0_rspec-w1)*ss2%chiphi_anom
     ELSE IF(ALLOCATED(ss1%chiphi_anom)) THEN
        CALL ps_conformal("chiphi_anom",ss1%chiphi_anom,ss3%chiphi_anom,iout,ierr)
        ss3%chiphi_anom = ss1%chiphi_anom
     ELSE IF(ALLOCATED(ss2%chiphi_anom)) THEN
        CALL ps_conformal("chiphi_anom",ss2%chiphi_anom,ss3%chiphi_anom,iout,ierr)
        ss3%chiphi_anom = ss2%chiphi_anom
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%chiphi_drbm)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%chiphi_drbm).AND.ALLOCATED(ss2%chiphi_drbm)) THEN
        CALL ps_conformal("chiphi_drbm",ss2%chiphi_drbm,ss3%chiphi_drbm,iout,ierr)
        CALL ps_conformal("chiphi_drbm",ss1%chiphi_drbm,ss3%chiphi_drbm,iout,ierr)
        if(ierr.eq.0) ss3%chiphi_drbm = w1*ss1%chiphi_drbm + (1.0_rspec-w1)*ss2%chiphi_drbm
     ELSE IF(ALLOCATED(ss1%chiphi_drbm)) THEN
        CALL ps_conformal("chiphi_drbm",ss1%chiphi_drbm,ss3%chiphi_drbm,iout,ierr)
        ss3%chiphi_drbm = ss1%chiphi_drbm
     ELSE IF(ALLOCATED(ss2%chiphi_drbm)) THEN
        CALL ps_conformal("chiphi_drbm",ss2%chiphi_drbm,ss3%chiphi_drbm,iout,ierr)
        ss3%chiphi_drbm = ss2%chiphi_drbm
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%chiphi_glf)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%chiphi_glf).AND.ALLOCATED(ss2%chiphi_glf)) THEN
        CALL ps_conformal("chiphi_glf",ss2%chiphi_glf,ss3%chiphi_glf,iout,ierr)
        CALL ps_conformal("chiphi_glf",ss1%chiphi_glf,ss3%chiphi_glf,iout,ierr)
        if(ierr.eq.0) ss3%chiphi_glf = w1*ss1%chiphi_glf + (1.0_rspec-w1)*ss2%chiphi_glf
     ELSE IF(ALLOCATED(ss1%chiphi_glf)) THEN
        CALL ps_conformal("chiphi_glf",ss1%chiphi_glf,ss3%chiphi_glf,iout,ierr)
        ss3%chiphi_glf = ss1%chiphi_glf
     ELSE IF(ALLOCATED(ss2%chiphi_glf)) THEN
        CALL ps_conformal("chiphi_glf",ss2%chiphi_glf,ss3%chiphi_glf,iout,ierr)
        ss3%chiphi_glf = ss2%chiphi_glf
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%chiphi_gtcneo)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%chiphi_gtcneo).AND.ALLOCATED(ss2%chiphi_gtcneo)) THEN
        CALL ps_conformal("chiphi_gtcneo",ss2%chiphi_gtcneo,ss3%chiphi_gtcneo,iout,ierr)
        CALL ps_conformal("chiphi_gtcneo",ss1%chiphi_gtcneo,ss3%chiphi_gtcneo,iout,ierr)
        if(ierr.eq.0) ss3%chiphi_gtcneo = w1*ss1%chiphi_gtcneo + (1.0_rspec-w1)*ss2%chiphi_gtcneo
     ELSE IF(ALLOCATED(ss1%chiphi_gtcneo)) THEN
        CALL ps_conformal("chiphi_gtcneo",ss1%chiphi_gtcneo,ss3%chiphi_gtcneo,iout,ierr)
        ss3%chiphi_gtcneo = ss1%chiphi_gtcneo
     ELSE IF(ALLOCATED(ss2%chiphi_gtcneo)) THEN
        CALL ps_conformal("chiphi_gtcneo",ss2%chiphi_gtcneo,ss3%chiphi_gtcneo,iout,ierr)
        ss3%chiphi_gtcneo = ss2%chiphi_gtcneo
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%chiphi_mmm71)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%chiphi_mmm71).AND.ALLOCATED(ss2%chiphi_mmm71)) THEN
        CALL ps_conformal("chiphi_mmm71",ss2%chiphi_mmm71,ss3%chiphi_mmm71,iout,ierr)
        CALL ps_conformal("chiphi_mmm71",ss1%chiphi_mmm71,ss3%chiphi_mmm71,iout,ierr)
        if(ierr.eq.0) ss3%chiphi_mmm71 = w1*ss1%chiphi_mmm71 + (1.0_rspec-w1)*ss2%chiphi_mmm71
     ELSE IF(ALLOCATED(ss1%chiphi_mmm71)) THEN
        CALL ps_conformal("chiphi_mmm71",ss1%chiphi_mmm71,ss3%chiphi_mmm71,iout,ierr)
        ss3%chiphi_mmm71 = ss1%chiphi_mmm71
     ELSE IF(ALLOCATED(ss2%chiphi_mmm71)) THEN
        CALL ps_conformal("chiphi_mmm71",ss2%chiphi_mmm71,ss3%chiphi_mmm71,iout,ierr)
        ss3%chiphi_mmm71 = ss2%chiphi_mmm71
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%chiphi_neo)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%chiphi_neo).AND.ALLOCATED(ss2%chiphi_neo)) THEN
        CALL ps_conformal("chiphi_neo",ss2%chiphi_neo,ss3%chiphi_neo,iout,ierr)
        CALL ps_conformal("chiphi_neo",ss1%chiphi_neo,ss3%chiphi_neo,iout,ierr)
        if(ierr.eq.0) ss3%chiphi_neo = w1*ss1%chiphi_neo + (1.0_rspec-w1)*ss2%chiphi_neo
     ELSE IF(ALLOCATED(ss1%chiphi_neo)) THEN
        CALL ps_conformal("chiphi_neo",ss1%chiphi_neo,ss3%chiphi_neo,iout,ierr)
        ss3%chiphi_neo = ss1%chiphi_neo
     ELSE IF(ALLOCATED(ss2%chiphi_neo)) THEN
        CALL ps_conformal("chiphi_neo",ss2%chiphi_neo,ss3%chiphi_neo,iout,ierr)
        ss3%chiphi_neo = ss2%chiphi_neo
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%chiphi_tglf)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%chiphi_tglf).AND.ALLOCATED(ss2%chiphi_tglf)) THEN
        CALL ps_conformal("chiphi_tglf",ss2%chiphi_tglf,ss3%chiphi_tglf,iout,ierr)
        CALL ps_conformal("chiphi_tglf",ss1%chiphi_tglf,ss3%chiphi_tglf,iout,ierr)
        if(ierr.eq.0) ss3%chiphi_tglf = w1*ss1%chiphi_tglf + (1.0_rspec-w1)*ss2%chiphi_tglf
     ELSE IF(ALLOCATED(ss1%chiphi_tglf)) THEN
        CALL ps_conformal("chiphi_tglf",ss1%chiphi_tglf,ss3%chiphi_tglf,iout,ierr)
        ss3%chiphi_tglf = ss1%chiphi_tglf
     ELSE IF(ALLOCATED(ss2%chiphi_tglf)) THEN
        CALL ps_conformal("chiphi_tglf",ss2%chiphi_tglf,ss3%chiphi_tglf,iout,ierr)
        ss3%chiphi_tglf = ss2%chiphi_tglf
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%chiphi_w19)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%chiphi_w19).AND.ALLOCATED(ss2%chiphi_w19)) THEN
        CALL ps_conformal("chiphi_w19",ss2%chiphi_w19,ss3%chiphi_w19,iout,ierr)
        CALL ps_conformal("chiphi_w19",ss1%chiphi_w19,ss3%chiphi_w19,iout,ierr)
        if(ierr.eq.0) ss3%chiphi_w19 = w1*ss1%chiphi_w19 + (1.0_rspec-w1)*ss2%chiphi_w19
     ELSE IF(ALLOCATED(ss1%chiphi_w19)) THEN
        CALL ps_conformal("chiphi_w19",ss1%chiphi_w19,ss3%chiphi_w19,iout,ierr)
        ss3%chiphi_w19 = ss1%chiphi_w19
     ELSE IF(ALLOCATED(ss2%chiphi_w19)) THEN
        CALL ps_conformal("chiphi_w19",ss2%chiphi_w19,ss3%chiphi_w19,iout,ierr)
        ss3%chiphi_w19 = ss2%chiphi_w19
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%chitheta_mmm71)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%chitheta_mmm71).AND.ALLOCATED(ss2%chitheta_mmm71)) THEN
        CALL ps_conformal("chitheta_mmm71",ss2%chitheta_mmm71,ss3%chitheta_mmm71,iout,ierr)
        CALL ps_conformal("chitheta_mmm71",ss1%chitheta_mmm71,ss3%chitheta_mmm71,iout,ierr)
        if(ierr.eq.0) ss3%chitheta_mmm71 = w1*ss1%chitheta_mmm71 + (1.0_rspec-w1)*ss2%chitheta_mmm71
     ELSE IF(ALLOCATED(ss1%chitheta_mmm71)) THEN
        CALL ps_conformal("chitheta_mmm71",ss1%chitheta_mmm71,ss3%chitheta_mmm71,iout,ierr)
        ss3%chitheta_mmm71 = ss1%chitheta_mmm71
     ELSE IF(ALLOCATED(ss2%chitheta_mmm71)) THEN
        CALL ps_conformal("chitheta_mmm71",ss2%chitheta_mmm71,ss3%chitheta_mmm71,iout,ierr)
        ss3%chitheta_mmm71 = ss2%chitheta_mmm71
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%circuit_name)).AND.(cclist(ps_cnum_EQ).EQ.1)) THEN
     IF(ALLOCATED(ss1%circuit_name).AND.ALLOCATED(ss2%circuit_name)) THEN
        CALL ps_diff("circuit_name",ss1%circuit_name,ss2%circuit_name,icheck,iout,ierr)
        CALL ps_conformal("circuit_name",ss1%circuit_name,ss3%circuit_name,iout,ierr)
        if(ierr.eq.0) ss3%circuit_name = ss1%circuit_name
     ELSE IF(ALLOCATED(ss1%circuit_name)) THEN
        CALL ps_conformal("circuit_name",ss1%circuit_name,ss3%circuit_name,iout,ierr)
        ss3%circuit_name = ss1%circuit_name
     ELSE IF(ALLOCATED(ss2%circuit_name)) THEN
        CALL ps_conformal("circuit_name",ss2%circuit_name,ss3%circuit_name,iout,ierr)
        ss3%circuit_name = ss2%circuit_name
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%coil_apt)).AND.(cclist(ps_cnum_EQ).EQ.1)) THEN
     IF(ALLOCATED(ss1%coil_apt).AND.ALLOCATED(ss2%coil_apt)) THEN
        CALL ps_conformal("coil_apt",ss2%coil_apt,ss3%coil_apt,iout,ierr)
        CALL ps_conformal("coil_apt",ss1%coil_apt,ss3%coil_apt,iout,ierr)
        if(ierr.eq.0) ss3%coil_apt = w1*ss1%coil_apt + (1.0_rspec-w1)*ss2%coil_apt
     ELSE IF(ALLOCATED(ss1%coil_apt)) THEN
        CALL ps_conformal("coil_apt",ss1%coil_apt,ss3%coil_apt,iout,ierr)
        ss3%coil_apt = ss1%coil_apt
     ELSE IF(ALLOCATED(ss2%coil_apt)) THEN
        CALL ps_conformal("coil_apt",ss2%coil_apt,ss3%coil_apt,iout,ierr)
        ss3%coil_apt = ss2%coil_apt
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%coil_in_circuit)).AND.(cclist(ps_cnum_EQ).EQ.1)) THEN
     IF(ALLOCATED(ss1%coil_in_circuit).AND.ALLOCATED(ss2%coil_in_circuit)) THEN
        CALL ps_diff("coil_in_circuit",ss1%coil_in_circuit,ss2%coil_in_circuit,icheck,iout,ierr)
        CALL ps_conformal("coil_in_circuit",ss1%coil_in_circuit,ss3%coil_in_circuit,iout,ierr)
        if(ierr.eq.0) ss3%coil_in_circuit = ss1%coil_in_circuit
     ELSE IF(ALLOCATED(ss1%coil_in_circuit)) THEN
        CALL ps_conformal("coil_in_circuit",ss1%coil_in_circuit,ss3%coil_in_circuit,iout,ierr)
        ss3%coil_in_circuit = ss1%coil_in_circuit
     ELSE IF(ALLOCATED(ss2%coil_in_circuit)) THEN
        CALL ps_conformal("coil_in_circuit",ss2%coil_in_circuit,ss3%coil_in_circuit,iout,ierr)
        ss3%coil_in_circuit = ss2%coil_in_circuit
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%coil_name)).AND.(cclist(ps_cnum_EQ).EQ.1)) THEN
     IF(ALLOCATED(ss1%coil_name).AND.ALLOCATED(ss2%coil_name)) THEN
        CALL ps_diff("coil_name",ss1%coil_name,ss2%coil_name,icheck,iout,ierr)
        CALL ps_conformal("coil_name",ss1%coil_name,ss3%coil_name,iout,ierr)
        if(ierr.eq.0) ss3%coil_name = ss1%coil_name
     ELSE IF(ALLOCATED(ss1%coil_name)) THEN
        CALL ps_conformal("coil_name",ss1%coil_name,ss3%coil_name,iout,ierr)
        ss3%coil_name = ss1%coil_name
     ELSE IF(ALLOCATED(ss2%coil_name)) THEN
        CALL ps_conformal("coil_name",ss2%coil_name,ss3%coil_name,iout,ierr)
        ss3%coil_name = ss2%coil_name
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%coil_resispt)).AND.(cclist(ps_cnum_EQ).EQ.1)) THEN
     IF(ALLOCATED(ss1%coil_resispt).AND.ALLOCATED(ss2%coil_resispt)) THEN
        CALL ps_diff("coil_resispt",ss1%coil_resispt,ss2%coil_resispt,icheck,iout,ierr)
        CALL ps_conformal("coil_resispt",ss1%coil_resispt,ss3%coil_resispt,iout,ierr)
        if(ierr.eq.0) ss3%coil_resispt = ss1%coil_resispt
     ELSE IF(ALLOCATED(ss1%coil_resispt)) THEN
        CALL ps_conformal("coil_resispt",ss1%coil_resispt,ss3%coil_resispt,iout,ierr)
        ss3%coil_resispt = ss1%coil_resispt
     ELSE IF(ALLOCATED(ss2%coil_resispt)) THEN
        CALL ps_conformal("coil_resispt",ss2%coil_resispt,ss3%coil_resispt,iout,ierr)
        ss3%coil_resispt = ss2%coil_resispt
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%curbeam)).AND.(cclist(ps_cnum_NBI).EQ.1)) THEN
     IF(ALLOCATED(ss1%curbeam).AND.ALLOCATED(ss2%curbeam)) THEN
        CALL ps_conformal("curbeam",ss2%curbeam,ss3%curbeam,iout,ierr)
        CALL ps_conformal("curbeam",ss1%curbeam,ss3%curbeam,iout,ierr)
        if(ierr.eq.0) ss3%curbeam = w1*ss1%curbeam + (1.0_rspec-w1)*ss2%curbeam
     ELSE IF(ALLOCATED(ss1%curbeam)) THEN
        CALL ps_conformal("curbeam",ss1%curbeam,ss3%curbeam,iout,ierr)
        ss3%curbeam = ss1%curbeam
     ELSE IF(ALLOCATED(ss2%curbeam)) THEN
        CALL ps_conformal("curbeam",ss2%curbeam,ss3%curbeam,iout,ierr)
        ss3%curbeam = ss2%curbeam
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%curech)).AND.(cclist(ps_cnum_EC).EQ.1)) THEN
     IF(ALLOCATED(ss1%curech).AND.ALLOCATED(ss2%curech)) THEN
        CALL ps_conformal("curech",ss2%curech,ss3%curech,iout,ierr)
        CALL ps_conformal("curech",ss1%curech,ss3%curech,iout,ierr)
        if(ierr.eq.0) ss3%curech = w1*ss1%curech + (1.0_rspec-w1)*ss2%curech
     ELSE IF(ALLOCATED(ss1%curech)) THEN
        CALL ps_conformal("curech",ss1%curech,ss3%curech,iout,ierr)
        ss3%curech = ss1%curech
     ELSE IF(ALLOCATED(ss2%curech)) THEN
        CALL ps_conformal("curech",ss2%curech,ss3%curech,iout,ierr)
        ss3%curech = ss2%curech
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%curech_src)).AND.(cclist(ps_cnum_EC).EQ.1)) THEN
     IF(ALLOCATED(ss1%curech_src).AND.ALLOCATED(ss2%curech_src)) THEN
        CALL ps_conformal("curech_src",ss2%curech_src,ss3%curech_src,iout,ierr)
        CALL ps_conformal("curech_src",ss1%curech_src,ss3%curech_src,iout,ierr)
        if(ierr.eq.0) ss3%curech_src = w1*ss1%curech_src + (1.0_rspec-w1)*ss2%curech_src
     ELSE IF(ALLOCATED(ss1%curech_src)) THEN
        CALL ps_conformal("curech_src",ss1%curech_src,ss3%curech_src,iout,ierr)
        ss3%curech_src = ss1%curech_src
     ELSE IF(ALLOCATED(ss2%curech_src)) THEN
        CALL ps_conformal("curech_src",ss2%curech_src,ss3%curech_src,iout,ierr)
        ss3%curech_src = ss2%curech_src
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%curfusn)).AND.(cclist(ps_cnum_FUS).EQ.1)) THEN
     IF(ALLOCATED(ss1%curfusn).AND.ALLOCATED(ss2%curfusn)) THEN
        CALL ps_conformal("curfusn",ss2%curfusn,ss3%curfusn,iout,ierr)
        CALL ps_conformal("curfusn",ss1%curfusn,ss3%curfusn,iout,ierr)
        if(ierr.eq.0) ss3%curfusn = w1*ss1%curfusn + (1.0_rspec-w1)*ss2%curfusn
     ELSE IF(ALLOCATED(ss1%curfusn)) THEN
        CALL ps_conformal("curfusn",ss1%curfusn,ss3%curfusn,iout,ierr)
        ss3%curfusn = ss1%curfusn
     ELSE IF(ALLOCATED(ss2%curfusn)) THEN
        CALL ps_conformal("curfusn",ss2%curfusn,ss3%curfusn,iout,ierr)
        ss3%curfusn = ss2%curfusn
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%curich)).AND.(cclist(ps_cnum_IC).EQ.1)) THEN
     IF(ALLOCATED(ss1%curich).AND.ALLOCATED(ss2%curich)) THEN
        CALL ps_conformal("curich",ss2%curich,ss3%curich,iout,ierr)
        CALL ps_conformal("curich",ss1%curich,ss3%curich,iout,ierr)
        if(ierr.eq.0) ss3%curich = w1*ss1%curich + (1.0_rspec-w1)*ss2%curich
     ELSE IF(ALLOCATED(ss1%curich)) THEN
        CALL ps_conformal("curich",ss1%curich,ss3%curich,iout,ierr)
        ss3%curich = ss1%curich
     ELSE IF(ALLOCATED(ss2%curich)) THEN
        CALL ps_conformal("curich",ss2%curich,ss3%curich,iout,ierr)
        ss3%curich = ss2%curich
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%curlh)).AND.(cclist(ps_cnum_LH).EQ.1)) THEN
     IF(ALLOCATED(ss1%curlh).AND.ALLOCATED(ss2%curlh)) THEN
        CALL ps_conformal("curlh",ss2%curlh,ss3%curlh,iout,ierr)
        CALL ps_conformal("curlh",ss1%curlh,ss3%curlh,iout,ierr)
        if(ierr.eq.0) ss3%curlh = w1*ss1%curlh + (1.0_rspec-w1)*ss2%curlh
     ELSE IF(ALLOCATED(ss1%curlh)) THEN
        CALL ps_conformal("curlh",ss1%curlh,ss3%curlh,iout,ierr)
        ss3%curlh = ss1%curlh
     ELSE IF(ALLOCATED(ss2%curlh)) THEN
        CALL ps_conformal("curlh",ss2%curlh,ss3%curlh,iout,ierr)
        ss3%curlh = ss2%curlh
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%curlh_src)).AND.(cclist(ps_cnum_LH).EQ.1)) THEN
     IF(ALLOCATED(ss1%curlh_src).AND.ALLOCATED(ss2%curlh_src)) THEN
        CALL ps_conformal("curlh_src",ss2%curlh_src,ss3%curlh_src,iout,ierr)
        CALL ps_conformal("curlh_src",ss1%curlh_src,ss3%curlh_src,iout,ierr)
        if(ierr.eq.0) ss3%curlh_src = w1*ss1%curlh_src + (1.0_rspec-w1)*ss2%curlh_src
     ELSE IF(ALLOCATED(ss1%curlh_src)) THEN
        CALL ps_conformal("curlh_src",ss1%curlh_src,ss3%curlh_src,iout,ierr)
        ss3%curlh_src = ss1%curlh_src
     ELSE IF(ALLOCATED(ss2%curlh_src)) THEN
        CALL ps_conformal("curlh_src",ss2%curlh_src,ss3%curlh_src,iout,ierr)
        ss3%curlh_src = ss2%curlh_src
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%curmino)).AND.(cclist(ps_cnum_IC).EQ.1)) THEN
     IF(ALLOCATED(ss1%curmino).AND.ALLOCATED(ss2%curmino)) THEN
        CALL ps_conformal("curmino",ss2%curmino,ss3%curmino,iout,ierr)
        CALL ps_conformal("curmino",ss1%curmino,ss3%curmino,iout,ierr)
        if(ierr.eq.0) ss3%curmino = w1*ss1%curmino + (1.0_rspec-w1)*ss2%curmino
     ELSE IF(ALLOCATED(ss1%curmino)) THEN
        CALL ps_conformal("curmino",ss1%curmino,ss3%curmino,iout,ierr)
        ss3%curmino = ss1%curmino
     ELSE IF(ALLOCATED(ss2%curmino)) THEN
        CALL ps_conformal("curmino",ss2%curmino,ss3%curmino,iout,ierr)
        ss3%curmino = ss2%curmino
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%curr_bootstrap)).AND.(cclist(ps_cnum_PLASMA).EQ.1)) THEN
     IF(ALLOCATED(ss1%curr_bootstrap).AND.ALLOCATED(ss2%curr_bootstrap)) THEN
        CALL ps_conformal("curr_bootstrap",ss2%curr_bootstrap,ss3%curr_bootstrap,iout,ierr)
        CALL ps_conformal("curr_bootstrap",ss1%curr_bootstrap,ss3%curr_bootstrap,iout,ierr)
        if(ierr.eq.0) ss3%curr_bootstrap = w1*ss1%curr_bootstrap + (1.0_rspec-w1)*ss2%curr_bootstrap
     ELSE IF(ALLOCATED(ss1%curr_bootstrap)) THEN
        CALL ps_conformal("curr_bootstrap",ss1%curr_bootstrap,ss3%curr_bootstrap,iout,ierr)
        ss3%curr_bootstrap = ss1%curr_bootstrap
     ELSE IF(ALLOCATED(ss2%curr_bootstrap)) THEN
        CALL ps_conformal("curr_bootstrap",ss2%curr_bootstrap,ss3%curr_bootstrap,iout,ierr)
        ss3%curr_bootstrap = ss2%curr_bootstrap
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%curr_ohmic)).AND.(cclist(ps_cnum_PLASMA).EQ.1)) THEN
     IF(ALLOCATED(ss1%curr_ohmic).AND.ALLOCATED(ss2%curr_ohmic)) THEN
        CALL ps_conformal("curr_ohmic",ss2%curr_ohmic,ss3%curr_ohmic,iout,ierr)
        CALL ps_conformal("curr_ohmic",ss1%curr_ohmic,ss3%curr_ohmic,iout,ierr)
        if(ierr.eq.0) ss3%curr_ohmic = w1*ss1%curr_ohmic + (1.0_rspec-w1)*ss2%curr_ohmic
     ELSE IF(ALLOCATED(ss1%curr_ohmic)) THEN
        CALL ps_conformal("curr_ohmic",ss1%curr_ohmic,ss3%curr_ohmic,iout,ierr)
        ss3%curr_ohmic = ss1%curr_ohmic
     ELSE IF(ALLOCATED(ss2%curr_ohmic)) THEN
        CALL ps_conformal("curr_ohmic",ss2%curr_ohmic,ss3%curr_ohmic,iout,ierr)
        ss3%curr_ohmic = ss2%curr_ohmic
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%curt)).AND.(cclist(ps_cnum_EQ).EQ.1)) THEN
     IF(ALLOCATED(ss1%curt).AND.ALLOCATED(ss2%curt)) THEN
        CALL ps_conformal("curt",ss2%curt,ss3%curt,iout,ierr)
        CALL ps_conformal("curt",ss1%curt,ss3%curt,iout,ierr)
        if(ierr.eq.0) ss3%curt = w1*ss1%curt + (1.0_rspec-w1)*ss2%curt
     ELSE IF(ALLOCATED(ss1%curt)) THEN
        CALL ps_conformal("curt",ss1%curt,ss3%curt,iout,ierr)
        ss3%curt = ss1%curt
     ELSE IF(ALLOCATED(ss2%curt)) THEN
        CALL ps_conformal("curt",ss2%curt,ss3%curt,iout,ierr)
        ss3%curt = ss2%curt
     ENDIF
  ENDIF

  IF(cclist(ps_cnum_PLASMA).EQ.1) THEN

     CALL ps_diff("CUR_Data_Info",ss1%CUR_Data_Info,ss2%CUR_Data_Info,icheck,iout,ierr)
     ss3%CUR_Data_Info = ss1%CUR_Data_Info
  ENDIF

  IF((ALLOCATED(ss3%cur_rw)).AND.(cclist(ps_cnum_RUNAWAY).EQ.1)) THEN
     IF(ALLOCATED(ss1%cur_rw).AND.ALLOCATED(ss2%cur_rw)) THEN
        CALL ps_conformal("cur_rw",ss2%cur_rw,ss3%cur_rw,iout,ierr)
        CALL ps_conformal("cur_rw",ss1%cur_rw,ss3%cur_rw,iout,ierr)
        if(ierr.eq.0) ss3%cur_rw = w1*ss1%cur_rw + (1.0_rspec-w1)*ss2%cur_rw
     ELSE IF(ALLOCATED(ss1%cur_rw)) THEN
        CALL ps_conformal("cur_rw",ss1%cur_rw,ss3%cur_rw,iout,ierr)
        ss3%cur_rw = ss1%cur_rw
     ELSE IF(ALLOCATED(ss2%cur_rw)) THEN
        CALL ps_conformal("cur_rw",ss2%cur_rw,ss3%cur_rw,iout,ierr)
        ss3%cur_rw = ss2%cur_rw
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%d2R_geo_dRHOdTH)).AND.(cclist(ps_cnum_EQ).EQ.1)) THEN
     IF(ALLOCATED(ss1%d2R_geo_dRHOdTH).AND.ALLOCATED(ss2%d2R_geo_dRHOdTH)) THEN
        CALL ps_conformal("d2R_geo_dRHOdTH",ss2%d2R_geo_dRHOdTH,ss3%d2R_geo_dRHOdTH,iout,ierr)
        CALL ps_conformal("d2R_geo_dRHOdTH",ss1%d2R_geo_dRHOdTH,ss3%d2R_geo_dRHOdTH,iout,ierr)
        if(ierr.eq.0) ss3%d2R_geo_dRHOdTH = w1*ss1%d2R_geo_dRHOdTH + (1.0_rspec-w1)*ss2%d2R_geo_dRHOdTH
     ELSE IF(ALLOCATED(ss1%d2R_geo_dRHOdTH)) THEN
        CALL ps_conformal("d2R_geo_dRHOdTH",ss1%d2R_geo_dRHOdTH,ss3%d2R_geo_dRHOdTH,iout,ierr)
        ss3%d2R_geo_dRHOdTH = ss1%d2R_geo_dRHOdTH
     ELSE IF(ALLOCATED(ss2%d2R_geo_dRHOdTH)) THEN
        CALL ps_conformal("d2R_geo_dRHOdTH",ss2%d2R_geo_dRHOdTH,ss3%d2R_geo_dRHOdTH,iout,ierr)
        ss3%d2R_geo_dRHOdTH = ss2%d2R_geo_dRHOdTH
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%d2Z_geo_dRHOdTH)).AND.(cclist(ps_cnum_EQ).EQ.1)) THEN
     IF(ALLOCATED(ss1%d2Z_geo_dRHOdTH).AND.ALLOCATED(ss2%d2Z_geo_dRHOdTH)) THEN
        CALL ps_conformal("d2Z_geo_dRHOdTH",ss2%d2Z_geo_dRHOdTH,ss3%d2Z_geo_dRHOdTH,iout,ierr)
        CALL ps_conformal("d2Z_geo_dRHOdTH",ss1%d2Z_geo_dRHOdTH,ss3%d2Z_geo_dRHOdTH,iout,ierr)
        if(ierr.eq.0) ss3%d2Z_geo_dRHOdTH = w1*ss1%d2Z_geo_dRHOdTH + (1.0_rspec-w1)*ss2%d2Z_geo_dRHOdTH
     ELSE IF(ALLOCATED(ss1%d2Z_geo_dRHOdTH)) THEN
        CALL ps_conformal("d2Z_geo_dRHOdTH",ss1%d2Z_geo_dRHOdTH,ss3%d2Z_geo_dRHOdTH,iout,ierr)
        ss3%d2Z_geo_dRHOdTH = ss1%d2Z_geo_dRHOdTH
     ELSE IF(ALLOCATED(ss2%d2Z_geo_dRHOdTH)) THEN
        CALL ps_conformal("d2Z_geo_dRHOdTH",ss2%d2Z_geo_dRHOdTH,ss3%d2Z_geo_dRHOdTH,iout,ierr)
        ss3%d2Z_geo_dRHOdTH = ss2%d2Z_geo_dRHOdTH
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%db_mtm)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%db_mtm).AND.ALLOCATED(ss2%db_mtm)) THEN
        CALL ps_conformal("db_mtm",ss2%db_mtm,ss3%db_mtm,iout,ierr)
        CALL ps_conformal("db_mtm",ss1%db_mtm,ss3%db_mtm,iout,ierr)
        if(ierr.eq.0) ss3%db_mtm = w1*ss1%db_mtm + (1.0_rspec-w1)*ss2%db_mtm
     ELSE IF(ALLOCATED(ss1%db_mtm)) THEN
        CALL ps_conformal("db_mtm",ss1%db_mtm,ss3%db_mtm,iout,ierr)
        ss3%db_mtm = ss1%db_mtm
     ELSE IF(ALLOCATED(ss2%db_mtm)) THEN
        CALL ps_conformal("db_mtm",ss2%db_mtm,ss3%db_mtm,iout,ierr)
        ss3%db_mtm = ss2%db_mtm
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%dcur_rw_dVloop)).AND.(cclist(ps_cnum_RUNAWAY).EQ.1)) THEN
     IF(ALLOCATED(ss1%dcur_rw_dVloop).AND.ALLOCATED(ss2%dcur_rw_dVloop)) THEN
        CALL ps_conformal("dcur_rw_dVloop",ss2%dcur_rw_dVloop,ss3%dcur_rw_dVloop,iout,ierr)
        CALL ps_conformal("dcur_rw_dVloop",ss1%dcur_rw_dVloop,ss3%dcur_rw_dVloop,iout,ierr)
        if(ierr.eq.0) ss3%dcur_rw_dVloop = w1*ss1%dcur_rw_dVloop + (1.0_rspec-w1)*ss2%dcur_rw_dVloop
     ELSE IF(ALLOCATED(ss1%dcur_rw_dVloop)) THEN
        CALL ps_conformal("dcur_rw_dVloop",ss1%dcur_rw_dVloop,ss3%dcur_rw_dVloop,iout,ierr)
        ss3%dcur_rw_dVloop = ss1%dcur_rw_dVloop
     ELSE IF(ALLOCATED(ss2%dcur_rw_dVloop)) THEN
        CALL ps_conformal("dcur_rw_dVloop",ss2%dcur_rw_dVloop,ss3%dcur_rw_dVloop,iout,ierr)
        ss3%dcur_rw_dVloop = ss2%dcur_rw_dVloop
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%DeltaW_code)).AND.(cclist(ps_cnum_LMHD).EQ.1)) THEN
     IF(ALLOCATED(ss1%DeltaW_code).AND.ALLOCATED(ss2%DeltaW_code)) THEN
        CALL ps_diff("DeltaW_code",ss1%DeltaW_code,ss2%DeltaW_code,icheck,iout,ierr)
        CALL ps_conformal("DeltaW_code",ss1%DeltaW_code,ss3%DeltaW_code,iout,ierr)
        if(ierr.eq.0) ss3%DeltaW_code = ss1%DeltaW_code
     ELSE IF(ALLOCATED(ss1%DeltaW_code)) THEN
        CALL ps_conformal("DeltaW_code",ss1%DeltaW_code,ss3%DeltaW_code,iout,ierr)
        ss3%DeltaW_code = ss1%DeltaW_code
     ELSE IF(ALLOCATED(ss2%DeltaW_code)) THEN
        CALL ps_conformal("DeltaW_code",ss2%DeltaW_code,ss3%DeltaW_code,iout,ierr)
        ss3%DeltaW_code = ss2%DeltaW_code
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%DeltaW_mapper)).AND.(cclist(ps_cnum_LMHD).EQ.1)) THEN
     IF(ALLOCATED(ss1%DeltaW_mapper).AND.ALLOCATED(ss2%DeltaW_mapper)) THEN
        CALL ps_diff("DeltaW_mapper",ss1%DeltaW_mapper,ss2%DeltaW_mapper,icheck,iout,ierr)
        CALL ps_conformal("DeltaW_mapper",ss1%DeltaW_mapper,ss3%DeltaW_mapper,iout,ierr)
        if(ierr.eq.0) ss3%DeltaW_mapper = ss1%DeltaW_mapper
     ELSE IF(ALLOCATED(ss1%DeltaW_mapper)) THEN
        CALL ps_conformal("DeltaW_mapper",ss1%DeltaW_mapper,ss3%DeltaW_mapper,iout,ierr)
        ss3%DeltaW_mapper = ss1%DeltaW_mapper
     ELSE IF(ALLOCATED(ss2%DeltaW_mapper)) THEN
        CALL ps_conformal("DeltaW_mapper",ss2%DeltaW_mapper,ss3%DeltaW_mapper,iout,ierr)
        ss3%DeltaW_mapper = ss2%DeltaW_mapper
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%DeltaW_stable)).AND.(cclist(ps_cnum_LMHD).EQ.1)) THEN
     IF(ALLOCATED(ss1%DeltaW_stable).AND.ALLOCATED(ss2%DeltaW_stable)) THEN
        CALL ps_diff("DeltaW_stable",ss1%DeltaW_stable,ss2%DeltaW_stable,icheck,iout,ierr)
        CALL ps_conformal("DeltaW_stable",ss1%DeltaW_stable,ss3%DeltaW_stable,iout,ierr)
        if(ierr.eq.0) ss3%DeltaW_stable = ss1%DeltaW_stable
     ELSE IF(ALLOCATED(ss1%DeltaW_stable)) THEN
        CALL ps_conformal("DeltaW_stable",ss1%DeltaW_stable,ss3%DeltaW_stable,iout,ierr)
        ss3%DeltaW_stable = ss1%DeltaW_stable
     ELSE IF(ALLOCATED(ss2%DeltaW_stable)) THEN
        CALL ps_conformal("DeltaW_stable",ss2%DeltaW_stable,ss3%DeltaW_stable,iout,ierr)
        ss3%DeltaW_stable = ss2%DeltaW_stable
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%DeltaW_status)).AND.(cclist(ps_cnum_LMHD).EQ.1)) THEN
     IF(ALLOCATED(ss1%DeltaW_status).AND.ALLOCATED(ss2%DeltaW_status)) THEN
        CALL ps_diff("DeltaW_status",ss1%DeltaW_status,ss2%DeltaW_status,icheck,iout,ierr)
        CALL ps_conformal("DeltaW_status",ss1%DeltaW_status,ss3%DeltaW_status,iout,ierr)
        if(ierr.eq.0) ss3%DeltaW_status = ss1%DeltaW_status
     ELSE IF(ALLOCATED(ss1%DeltaW_status)) THEN
        CALL ps_conformal("DeltaW_status",ss1%DeltaW_status,ss3%DeltaW_status,iout,ierr)
        ss3%DeltaW_status = ss1%DeltaW_status
     ELSE IF(ALLOCATED(ss2%DeltaW_status)) THEN
        CALL ps_conformal("DeltaW_status",ss2%DeltaW_status,ss3%DeltaW_status,iout,ierr)
        ss3%DeltaW_status = ss2%DeltaW_status
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%difb_fusi)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%difb_fusi).AND.ALLOCATED(ss2%difb_fusi)) THEN
        CALL ps_conformal("difb_fusi",ss2%difb_fusi,ss3%difb_fusi,iout,ierr)
        CALL ps_conformal("difb_fusi",ss1%difb_fusi,ss3%difb_fusi,iout,ierr)
        if(ierr.eq.0) ss3%difb_fusi = w1*ss1%difb_fusi + (1.0_rspec-w1)*ss2%difb_fusi
     ELSE IF(ALLOCATED(ss1%difb_fusi)) THEN
        CALL ps_conformal("difb_fusi",ss1%difb_fusi,ss3%difb_fusi,iout,ierr)
        ss3%difb_fusi = ss1%difb_fusi
     ELSE IF(ALLOCATED(ss2%difb_fusi)) THEN
        CALL ps_conformal("difb_fusi",ss2%difb_fusi,ss3%difb_fusi,iout,ierr)
        ss3%difb_fusi = ss2%difb_fusi
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%difb_nbi)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%difb_nbi).AND.ALLOCATED(ss2%difb_nbi)) THEN
        CALL ps_conformal("difb_nbi",ss2%difb_nbi,ss3%difb_nbi,iout,ierr)
        CALL ps_conformal("difb_nbi",ss1%difb_nbi,ss3%difb_nbi,iout,ierr)
        if(ierr.eq.0) ss3%difb_nbi = w1*ss1%difb_nbi + (1.0_rspec-w1)*ss2%difb_nbi
     ELSE IF(ALLOCATED(ss1%difb_nbi)) THEN
        CALL ps_conformal("difb_nbi",ss1%difb_nbi,ss3%difb_nbi,iout,ierr)
        ss3%difb_nbi = ss1%difb_nbi
     ELSE IF(ALLOCATED(ss2%difb_nbi)) THEN
        CALL ps_conformal("difb_nbi",ss2%difb_nbi,ss3%difb_nbi,iout,ierr)
        ss3%difb_nbi = ss2%difb_nbi
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%difb_rfmi)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%difb_rfmi).AND.ALLOCATED(ss2%difb_rfmi)) THEN
        CALL ps_conformal("difb_rfmi",ss2%difb_rfmi,ss3%difb_rfmi,iout,ierr)
        CALL ps_conformal("difb_rfmi",ss1%difb_rfmi,ss3%difb_rfmi,iout,ierr)
        if(ierr.eq.0) ss3%difb_rfmi = w1*ss1%difb_rfmi + (1.0_rspec-w1)*ss2%difb_rfmi
     ELSE IF(ALLOCATED(ss1%difb_rfmi)) THEN
        CALL ps_conformal("difb_rfmi",ss1%difb_rfmi,ss3%difb_rfmi,iout,ierr)
        ss3%difb_rfmi = ss1%difb_rfmi
     ELSE IF(ALLOCATED(ss2%difb_rfmi)) THEN
        CALL ps_conformal("difb_rfmi",ss2%difb_rfmi,ss3%difb_rfmi,iout,ierr)
        ss3%difb_rfmi = ss2%difb_rfmi
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%diff_trans)).AND.(cclist(ps_cnum_PLASMA).EQ.1)) THEN
     IF(ALLOCATED(ss1%diff_trans).AND.ALLOCATED(ss2%diff_trans)) THEN
        CALL ps_conformal("diff_trans",ss2%diff_trans,ss3%diff_trans,iout,ierr)
        CALL ps_conformal("diff_trans",ss1%diff_trans,ss3%diff_trans,iout,ierr)
        if(ierr.eq.0) ss3%diff_trans = w1*ss1%diff_trans + (1.0_rspec-w1)*ss2%diff_trans
     ELSE IF(ALLOCATED(ss1%diff_trans)) THEN
        CALL ps_conformal("diff_trans",ss1%diff_trans,ss3%diff_trans,iout,ierr)
        ss3%diff_trans = ss1%diff_trans
     ELSE IF(ALLOCATED(ss2%diff_trans)) THEN
        CALL ps_conformal("diff_trans",ss2%diff_trans,ss3%diff_trans,iout,ierr)
        ss3%diff_trans = ss2%diff_trans
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%diff_transcat)).AND.(cclist(ps_cnum_PLASMA).EQ.1)) THEN
     IF(ALLOCATED(ss1%diff_transcat).AND.ALLOCATED(ss2%diff_transcat)) THEN
        CALL ps_conformal("diff_transcat",ss2%diff_transcat,ss3%diff_transcat,iout,ierr)
        CALL ps_conformal("diff_transcat",ss1%diff_transcat,ss3%diff_transcat,iout,ierr)
        if(ierr.eq.0) ss3%diff_transcat = w1*ss1%diff_transcat + (1.0_rspec-w1)*ss2%diff_transcat
     ELSE IF(ALLOCATED(ss1%diff_transcat)) THEN
        CALL ps_conformal("diff_transcat",ss1%diff_transcat,ss3%diff_transcat,iout,ierr)
        ss3%diff_transcat = ss1%diff_transcat
     ELSE IF(ALLOCATED(ss2%diff_transcat)) THEN
        CALL ps_conformal("diff_transcat",ss2%diff_transcat,ss3%diff_transcat,iout,ierr)
        ss3%diff_transcat = ss2%diff_transcat
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%difne_nclass)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%difne_nclass).AND.ALLOCATED(ss2%difne_nclass)) THEN
        CALL ps_conformal("difne_nclass",ss2%difne_nclass,ss3%difne_nclass,iout,ierr)
        CALL ps_conformal("difne_nclass",ss1%difne_nclass,ss3%difne_nclass,iout,ierr)
        if(ierr.eq.0) ss3%difne_nclass = w1*ss1%difne_nclass + (1.0_rspec-w1)*ss2%difne_nclass
     ELSE IF(ALLOCATED(ss1%difne_nclass)) THEN
        CALL ps_conformal("difne_nclass",ss1%difne_nclass,ss3%difne_nclass,iout,ierr)
        ss3%difne_nclass = ss1%difne_nclass
     ELSE IF(ALLOCATED(ss2%difne_nclass)) THEN
        CALL ps_conformal("difne_nclass",ss2%difne_nclass,ss3%difne_nclass,iout,ierr)
        ss3%difne_nclass = ss2%difne_nclass
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%difnh_nclass)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%difnh_nclass).AND.ALLOCATED(ss2%difnh_nclass)) THEN
        CALL ps_conformal("difnh_nclass",ss2%difnh_nclass,ss3%difnh_nclass,iout,ierr)
        CALL ps_conformal("difnh_nclass",ss1%difnh_nclass,ss3%difnh_nclass,iout,ierr)
        if(ierr.eq.0) ss3%difnh_nclass = w1*ss1%difnh_nclass + (1.0_rspec-w1)*ss2%difnh_nclass
     ELSE IF(ALLOCATED(ss1%difnh_nclass)) THEN
        CALL ps_conformal("difnh_nclass",ss1%difnh_nclass,ss3%difnh_nclass,iout,ierr)
        ss3%difnh_nclass = ss1%difnh_nclass
     ELSE IF(ALLOCATED(ss2%difnh_nclass)) THEN
        CALL ps_conformal("difnh_nclass",ss2%difnh_nclass,ss3%difnh_nclass,iout,ierr)
        ss3%difnh_nclass = ss2%difnh_nclass
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%difns_anom)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%difns_anom).AND.ALLOCATED(ss2%difns_anom)) THEN
        CALL ps_conformal("difns_anom",ss2%difns_anom,ss3%difns_anom,iout,ierr)
        CALL ps_conformal("difns_anom",ss1%difns_anom,ss3%difns_anom,iout,ierr)
        if(ierr.eq.0) ss3%difns_anom = w1*ss1%difns_anom + (1.0_rspec-w1)*ss2%difns_anom
     ELSE IF(ALLOCATED(ss1%difns_anom)) THEN
        CALL ps_conformal("difns_anom",ss1%difns_anom,ss3%difns_anom,iout,ierr)
        ss3%difns_anom = ss1%difns_anom
     ELSE IF(ALLOCATED(ss2%difns_anom)) THEN
        CALL ps_conformal("difns_anom",ss2%difns_anom,ss3%difns_anom,iout,ierr)
        ss3%difns_anom = ss2%difns_anom
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%difns_drbm)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%difns_drbm).AND.ALLOCATED(ss2%difns_drbm)) THEN
        CALL ps_conformal("difns_drbm",ss2%difns_drbm,ss3%difns_drbm,iout,ierr)
        CALL ps_conformal("difns_drbm",ss1%difns_drbm,ss3%difns_drbm,iout,ierr)
        if(ierr.eq.0) ss3%difns_drbm = w1*ss1%difns_drbm + (1.0_rspec-w1)*ss2%difns_drbm
     ELSE IF(ALLOCATED(ss1%difns_drbm)) THEN
        CALL ps_conformal("difns_drbm",ss1%difns_drbm,ss3%difns_drbm,iout,ierr)
        ss3%difns_drbm = ss1%difns_drbm
     ELSE IF(ALLOCATED(ss2%difns_drbm)) THEN
        CALL ps_conformal("difns_drbm",ss2%difns_drbm,ss3%difns_drbm,iout,ierr)
        ss3%difns_drbm = ss2%difns_drbm
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%difns_glf)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%difns_glf).AND.ALLOCATED(ss2%difns_glf)) THEN
        CALL ps_conformal("difns_glf",ss2%difns_glf,ss3%difns_glf,iout,ierr)
        CALL ps_conformal("difns_glf",ss1%difns_glf,ss3%difns_glf,iout,ierr)
        if(ierr.eq.0) ss3%difns_glf = w1*ss1%difns_glf + (1.0_rspec-w1)*ss2%difns_glf
     ELSE IF(ALLOCATED(ss1%difns_glf)) THEN
        CALL ps_conformal("difns_glf",ss1%difns_glf,ss3%difns_glf,iout,ierr)
        ss3%difns_glf = ss1%difns_glf
     ELSE IF(ALLOCATED(ss2%difns_glf)) THEN
        CALL ps_conformal("difns_glf",ss2%difns_glf,ss3%difns_glf,iout,ierr)
        ss3%difns_glf = ss2%difns_glf
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%difns_gtcneo)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%difns_gtcneo).AND.ALLOCATED(ss2%difns_gtcneo)) THEN
        CALL ps_conformal("difns_gtcneo",ss2%difns_gtcneo,ss3%difns_gtcneo,iout,ierr)
        CALL ps_conformal("difns_gtcneo",ss1%difns_gtcneo,ss3%difns_gtcneo,iout,ierr)
        if(ierr.eq.0) ss3%difns_gtcneo = w1*ss1%difns_gtcneo + (1.0_rspec-w1)*ss2%difns_gtcneo
     ELSE IF(ALLOCATED(ss1%difns_gtcneo)) THEN
        CALL ps_conformal("difns_gtcneo",ss1%difns_gtcneo,ss3%difns_gtcneo,iout,ierr)
        ss3%difns_gtcneo = ss1%difns_gtcneo
     ELSE IF(ALLOCATED(ss2%difns_gtcneo)) THEN
        CALL ps_conformal("difns_gtcneo",ss2%difns_gtcneo,ss3%difns_gtcneo,iout,ierr)
        ss3%difns_gtcneo = ss2%difns_gtcneo
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%difns_mmm71)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%difns_mmm71).AND.ALLOCATED(ss2%difns_mmm71)) THEN
        CALL ps_conformal("difns_mmm71",ss2%difns_mmm71,ss3%difns_mmm71,iout,ierr)
        CALL ps_conformal("difns_mmm71",ss1%difns_mmm71,ss3%difns_mmm71,iout,ierr)
        if(ierr.eq.0) ss3%difns_mmm71 = w1*ss1%difns_mmm71 + (1.0_rspec-w1)*ss2%difns_mmm71
     ELSE IF(ALLOCATED(ss1%difns_mmm71)) THEN
        CALL ps_conformal("difns_mmm71",ss1%difns_mmm71,ss3%difns_mmm71,iout,ierr)
        ss3%difns_mmm71 = ss1%difns_mmm71
     ELSE IF(ALLOCATED(ss2%difns_mmm71)) THEN
        CALL ps_conformal("difns_mmm71",ss2%difns_mmm71,ss3%difns_mmm71,iout,ierr)
        ss3%difns_mmm71 = ss2%difns_mmm71
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%difns_nclass)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%difns_nclass).AND.ALLOCATED(ss2%difns_nclass)) THEN
        CALL ps_conformal("difns_nclass",ss2%difns_nclass,ss3%difns_nclass,iout,ierr)
        CALL ps_conformal("difns_nclass",ss1%difns_nclass,ss3%difns_nclass,iout,ierr)
        if(ierr.eq.0) ss3%difns_nclass = w1*ss1%difns_nclass + (1.0_rspec-w1)*ss2%difns_nclass
     ELSE IF(ALLOCATED(ss1%difns_nclass)) THEN
        CALL ps_conformal("difns_nclass",ss1%difns_nclass,ss3%difns_nclass,iout,ierr)
        ss3%difns_nclass = ss1%difns_nclass
     ELSE IF(ALLOCATED(ss2%difns_nclass)) THEN
        CALL ps_conformal("difns_nclass",ss2%difns_nclass,ss3%difns_nclass,iout,ierr)
        ss3%difns_nclass = ss2%difns_nclass
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%difns_neo)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%difns_neo).AND.ALLOCATED(ss2%difns_neo)) THEN
        CALL ps_conformal("difns_neo",ss2%difns_neo,ss3%difns_neo,iout,ierr)
        CALL ps_conformal("difns_neo",ss1%difns_neo,ss3%difns_neo,iout,ierr)
        if(ierr.eq.0) ss3%difns_neo = w1*ss1%difns_neo + (1.0_rspec-w1)*ss2%difns_neo
     ELSE IF(ALLOCATED(ss1%difns_neo)) THEN
        CALL ps_conformal("difns_neo",ss1%difns_neo,ss3%difns_neo,iout,ierr)
        ss3%difns_neo = ss1%difns_neo
     ELSE IF(ALLOCATED(ss2%difns_neo)) THEN
        CALL ps_conformal("difns_neo",ss2%difns_neo,ss3%difns_neo,iout,ierr)
        ss3%difns_neo = ss2%difns_neo
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%difns_tglf)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%difns_tglf).AND.ALLOCATED(ss2%difns_tglf)) THEN
        CALL ps_conformal("difns_tglf",ss2%difns_tglf,ss3%difns_tglf,iout,ierr)
        CALL ps_conformal("difns_tglf",ss1%difns_tglf,ss3%difns_tglf,iout,ierr)
        if(ierr.eq.0) ss3%difns_tglf = w1*ss1%difns_tglf + (1.0_rspec-w1)*ss2%difns_tglf
     ELSE IF(ALLOCATED(ss1%difns_tglf)) THEN
        CALL ps_conformal("difns_tglf",ss1%difns_tglf,ss3%difns_tglf,iout,ierr)
        ss3%difns_tglf = ss1%difns_tglf
     ELSE IF(ALLOCATED(ss2%difns_tglf)) THEN
        CALL ps_conformal("difns_tglf",ss2%difns_tglf,ss3%difns_tglf,iout,ierr)
        ss3%difns_tglf = ss2%difns_tglf
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%difns_w19)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%difns_w19).AND.ALLOCATED(ss2%difns_w19)) THEN
        CALL ps_conformal("difns_w19",ss2%difns_w19,ss3%difns_w19,iout,ierr)
        CALL ps_conformal("difns_w19",ss1%difns_w19,ss3%difns_w19,iout,ierr)
        if(ierr.eq.0) ss3%difns_w19 = w1*ss1%difns_w19 + (1.0_rspec-w1)*ss2%difns_w19
     ELSE IF(ALLOCATED(ss1%difns_w19)) THEN
        CALL ps_conformal("difns_w19",ss1%difns_w19,ss3%difns_w19,iout,ierr)
        ss3%difns_w19 = ss1%difns_w19
     ELSE IF(ALLOCATED(ss2%difns_w19)) THEN
        CALL ps_conformal("difns_w19",ss2%difns_w19,ss3%difns_w19,iout,ierr)
        ss3%difns_w19 = ss2%difns_w19
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%difnx_nclass)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%difnx_nclass).AND.ALLOCATED(ss2%difnx_nclass)) THEN
        CALL ps_conformal("difnx_nclass",ss2%difnx_nclass,ss3%difnx_nclass,iout,ierr)
        CALL ps_conformal("difnx_nclass",ss1%difnx_nclass,ss3%difnx_nclass,iout,ierr)
        if(ierr.eq.0) ss3%difnx_nclass = w1*ss1%difnx_nclass + (1.0_rspec-w1)*ss2%difnx_nclass
     ELSE IF(ALLOCATED(ss1%difnx_nclass)) THEN
        CALL ps_conformal("difnx_nclass",ss1%difnx_nclass,ss3%difnx_nclass,iout,ierr)
        ss3%difnx_nclass = ss1%difnx_nclass
     ELSE IF(ALLOCATED(ss2%difnx_nclass)) THEN
        CALL ps_conformal("difnx_nclass",ss2%difnx_nclass,ss3%difnx_nclass,iout,ierr)
        ss3%difnx_nclass = ss2%difnx_nclass
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%difnz_mmm71)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%difnz_mmm71).AND.ALLOCATED(ss2%difnz_mmm71)) THEN
        CALL ps_conformal("difnz_mmm71",ss2%difnz_mmm71,ss3%difnz_mmm71,iout,ierr)
        CALL ps_conformal("difnz_mmm71",ss1%difnz_mmm71,ss3%difnz_mmm71,iout,ierr)
        if(ierr.eq.0) ss3%difnz_mmm71 = w1*ss1%difnz_mmm71 + (1.0_rspec-w1)*ss2%difnz_mmm71
     ELSE IF(ALLOCATED(ss1%difnz_mmm71)) THEN
        CALL ps_conformal("difnz_mmm71",ss1%difnz_mmm71,ss3%difnz_mmm71,iout,ierr)
        ss3%difnz_mmm71 = ss1%difnz_mmm71
     ELSE IF(ALLOCATED(ss2%difnz_mmm71)) THEN
        CALL ps_conformal("difnz_mmm71",ss2%difnz_mmm71,ss3%difnz_mmm71,iout,ierr)
        ss3%difnz_mmm71 = ss2%difnz_mmm71
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%dist_fun)).AND.(cclist(ps_cnum_IC).EQ.1)) THEN
     IF(ALLOCATED(ss1%dist_fun).AND.ALLOCATED(ss2%dist_fun)) THEN
        CALL ps_diff("dist_fun",ss1%dist_fun,ss2%dist_fun,icheck,iout,ierr)
        CALL ps_conformal("dist_fun",ss1%dist_fun,ss3%dist_fun,iout,ierr)
        if(ierr.eq.0) ss3%dist_fun = ss1%dist_fun
     ELSE IF(ALLOCATED(ss1%dist_fun)) THEN
        CALL ps_conformal("dist_fun",ss1%dist_fun,ss3%dist_fun,iout,ierr)
        ss3%dist_fun = ss1%dist_fun
     ELSE IF(ALLOCATED(ss2%dist_fun)) THEN
        CALL ps_conformal("dist_fun",ss2%dist_fun,ss3%dist_fun,iout,ierr)
        ss3%dist_fun = ss2%dist_fun
     ENDIF
  ENDIF

  IF(cclist(ps_cnum_GAS).EQ.1) THEN
     ss3%dn0out = w1*ss1%dn0out + (1.0_rspec-w1)*ss2%dn0out
  ENDIF

  IF((ALLOCATED(ss3%dQedGrdte_tglf)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%dQedGrdte_tglf).AND.ALLOCATED(ss2%dQedGrdte_tglf)) THEN
        CALL ps_conformal("dQedGrdte_tglf",ss2%dQedGrdte_tglf,ss3%dQedGrdte_tglf,iout,ierr)
        CALL ps_conformal("dQedGrdte_tglf",ss1%dQedGrdte_tglf,ss3%dQedGrdte_tglf,iout,ierr)
        if(ierr.eq.0) ss3%dQedGrdte_tglf = w1*ss1%dQedGrdte_tglf + (1.0_rspec-w1)*ss2%dQedGrdte_tglf
     ELSE IF(ALLOCATED(ss1%dQedGrdte_tglf)) THEN
        CALL ps_conformal("dQedGrdte_tglf",ss1%dQedGrdte_tglf,ss3%dQedGrdte_tglf,iout,ierr)
        ss3%dQedGrdte_tglf = ss1%dQedGrdte_tglf
     ELSE IF(ALLOCATED(ss2%dQedGrdte_tglf)) THEN
        CALL ps_conformal("dQedGrdte_tglf",ss2%dQedGrdte_tglf,ss3%dQedGrdte_tglf,iout,ierr)
        ss3%dQedGrdte_tglf = ss2%dQedGrdte_tglf
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%dQedGrdti_tglf)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%dQedGrdti_tglf).AND.ALLOCATED(ss2%dQedGrdti_tglf)) THEN
        CALL ps_conformal("dQedGrdti_tglf",ss2%dQedGrdti_tglf,ss3%dQedGrdti_tglf,iout,ierr)
        CALL ps_conformal("dQedGrdti_tglf",ss1%dQedGrdti_tglf,ss3%dQedGrdti_tglf,iout,ierr)
        if(ierr.eq.0) ss3%dQedGrdti_tglf = w1*ss1%dQedGrdti_tglf + (1.0_rspec-w1)*ss2%dQedGrdti_tglf
     ELSE IF(ALLOCATED(ss1%dQedGrdti_tglf)) THEN
        CALL ps_conformal("dQedGrdti_tglf",ss1%dQedGrdti_tglf,ss3%dQedGrdti_tglf,iout,ierr)
        ss3%dQedGrdti_tglf = ss1%dQedGrdti_tglf
     ELSE IF(ALLOCATED(ss2%dQedGrdti_tglf)) THEN
        CALL ps_conformal("dQedGrdti_tglf",ss2%dQedGrdti_tglf,ss3%dQedGrdti_tglf,iout,ierr)
        ss3%dQedGrdti_tglf = ss2%dQedGrdti_tglf
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%dQidGrdte_tglf)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%dQidGrdte_tglf).AND.ALLOCATED(ss2%dQidGrdte_tglf)) THEN
        CALL ps_conformal("dQidGrdte_tglf",ss2%dQidGrdte_tglf,ss3%dQidGrdte_tglf,iout,ierr)
        CALL ps_conformal("dQidGrdte_tglf",ss1%dQidGrdte_tglf,ss3%dQidGrdte_tglf,iout,ierr)
        if(ierr.eq.0) ss3%dQidGrdte_tglf = w1*ss1%dQidGrdte_tglf + (1.0_rspec-w1)*ss2%dQidGrdte_tglf
     ELSE IF(ALLOCATED(ss1%dQidGrdte_tglf)) THEN
        CALL ps_conformal("dQidGrdte_tglf",ss1%dQidGrdte_tglf,ss3%dQidGrdte_tglf,iout,ierr)
        ss3%dQidGrdte_tglf = ss1%dQidGrdte_tglf
     ELSE IF(ALLOCATED(ss2%dQidGrdte_tglf)) THEN
        CALL ps_conformal("dQidGrdte_tglf",ss2%dQidGrdte_tglf,ss3%dQidGrdte_tglf,iout,ierr)
        ss3%dQidGrdte_tglf = ss2%dQidGrdte_tglf
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%dQidGrdti_tglf)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%dQidGrdti_tglf).AND.ALLOCATED(ss2%dQidGrdti_tglf)) THEN
        CALL ps_conformal("dQidGrdti_tglf",ss2%dQidGrdti_tglf,ss3%dQidGrdti_tglf,iout,ierr)
        CALL ps_conformal("dQidGrdti_tglf",ss1%dQidGrdti_tglf,ss3%dQidGrdti_tglf,iout,ierr)
        if(ierr.eq.0) ss3%dQidGrdti_tglf = w1*ss1%dQidGrdti_tglf + (1.0_rspec-w1)*ss2%dQidGrdti_tglf
     ELSE IF(ALLOCATED(ss1%dQidGrdti_tglf)) THEN
        CALL ps_conformal("dQidGrdti_tglf",ss1%dQidGrdti_tglf,ss3%dQidGrdti_tglf,iout,ierr)
        ss3%dQidGrdti_tglf = ss1%dQidGrdti_tglf
     ELSE IF(ALLOCATED(ss2%dQidGrdti_tglf)) THEN
        CALL ps_conformal("dQidGrdti_tglf",ss2%dQidGrdti_tglf,ss3%dQidGrdti_tglf,iout,ierr)
        ss3%dQidGrdti_tglf = ss2%dQidGrdti_tglf
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%dR0_momeq_dRHO)).AND.(cclist(ps_cnum_EQ).EQ.1)) THEN
     IF(ALLOCATED(ss1%dR0_momeq_dRHO).AND.ALLOCATED(ss2%dR0_momeq_dRHO)) THEN
        CALL ps_conformal("dR0_momeq_dRHO",ss2%dR0_momeq_dRHO,ss3%dR0_momeq_dRHO,iout,ierr)
        CALL ps_conformal("dR0_momeq_dRHO",ss1%dR0_momeq_dRHO,ss3%dR0_momeq_dRHO,iout,ierr)
        if(ierr.eq.0) ss3%dR0_momeq_dRHO = w1*ss1%dR0_momeq_dRHO + (1.0_rspec-w1)*ss2%dR0_momeq_dRHO
     ELSE IF(ALLOCATED(ss1%dR0_momeq_dRHO)) THEN
        CALL ps_conformal("dR0_momeq_dRHO",ss1%dR0_momeq_dRHO,ss3%dR0_momeq_dRHO,iout,ierr)
        ss3%dR0_momeq_dRHO = ss1%dR0_momeq_dRHO
     ELSE IF(ALLOCATED(ss2%dR0_momeq_dRHO)) THEN
        CALL ps_conformal("dR0_momeq_dRHO",ss2%dR0_momeq_dRHO,ss3%dR0_momeq_dRHO,iout,ierr)
        ss3%dR0_momeq_dRHO = ss2%dR0_momeq_dRHO
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%dR_geo_dRHO)).AND.(cclist(ps_cnum_EQ).EQ.1)) THEN
     IF(ALLOCATED(ss1%dR_geo_dRHO).AND.ALLOCATED(ss2%dR_geo_dRHO)) THEN
        CALL ps_conformal("dR_geo_dRHO",ss2%dR_geo_dRHO,ss3%dR_geo_dRHO,iout,ierr)
        CALL ps_conformal("dR_geo_dRHO",ss1%dR_geo_dRHO,ss3%dR_geo_dRHO,iout,ierr)
        if(ierr.eq.0) ss3%dR_geo_dRHO = w1*ss1%dR_geo_dRHO + (1.0_rspec-w1)*ss2%dR_geo_dRHO
     ELSE IF(ALLOCATED(ss1%dR_geo_dRHO)) THEN
        CALL ps_conformal("dR_geo_dRHO",ss1%dR_geo_dRHO,ss3%dR_geo_dRHO,iout,ierr)
        ss3%dR_geo_dRHO = ss1%dR_geo_dRHO
     ELSE IF(ALLOCATED(ss2%dR_geo_dRHO)) THEN
        CALL ps_conformal("dR_geo_dRHO",ss2%dR_geo_dRHO,ss3%dR_geo_dRHO,iout,ierr)
        ss3%dR_geo_dRHO = ss2%dR_geo_dRHO
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%dR_geo_dTH)).AND.(cclist(ps_cnum_EQ).EQ.1)) THEN
     IF(ALLOCATED(ss1%dR_geo_dTH).AND.ALLOCATED(ss2%dR_geo_dTH)) THEN
        CALL ps_conformal("dR_geo_dTH",ss2%dR_geo_dTH,ss3%dR_geo_dTH,iout,ierr)
        CALL ps_conformal("dR_geo_dTH",ss1%dR_geo_dTH,ss3%dR_geo_dTH,iout,ierr)
        if(ierr.eq.0) ss3%dR_geo_dTH = w1*ss1%dR_geo_dTH + (1.0_rspec-w1)*ss2%dR_geo_dTH
     ELSE IF(ALLOCATED(ss1%dR_geo_dTH)) THEN
        CALL ps_conformal("dR_geo_dTH",ss1%dR_geo_dTH,ss3%dR_geo_dTH,iout,ierr)
        ss3%dR_geo_dTH = ss1%dR_geo_dTH
     ELSE IF(ALLOCATED(ss2%dR_geo_dTH)) THEN
        CALL ps_conformal("dR_geo_dTH",ss2%dR_geo_dTH,ss3%dR_geo_dTH,iout,ierr)
        ss3%dR_geo_dTH = ss2%dR_geo_dTH
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%dxRjcos_momeq_dRHO)).AND.(cclist(ps_cnum_EQ).EQ.1)) THEN
     IF(ALLOCATED(ss1%dxRjcos_momeq_dRHO).AND.ALLOCATED(ss2%dxRjcos_momeq_dRHO)) THEN
        CALL ps_conformal("dxRjcos_momeq_dRHO",ss2%dxRjcos_momeq_dRHO,ss3%dxRjcos_momeq_dRHO,iout,ierr)
        CALL ps_conformal("dxRjcos_momeq_dRHO",ss1%dxRjcos_momeq_dRHO,ss3%dxRjcos_momeq_dRHO,iout,ierr)
        if(ierr.eq.0) ss3%dxRjcos_momeq_dRHO = w1*ss1%dxRjcos_momeq_dRHO + (1.0_rspec-w1)*ss2%dxRjcos_momeq_dRHO
     ELSE IF(ALLOCATED(ss1%dxRjcos_momeq_dRHO)) THEN
        CALL ps_conformal("dxRjcos_momeq_dRHO",ss1%dxRjcos_momeq_dRHO,ss3%dxRjcos_momeq_dRHO,iout,ierr)
        ss3%dxRjcos_momeq_dRHO = ss1%dxRjcos_momeq_dRHO
     ELSE IF(ALLOCATED(ss2%dxRjcos_momeq_dRHO)) THEN
        CALL ps_conformal("dxRjcos_momeq_dRHO",ss2%dxRjcos_momeq_dRHO,ss3%dxRjcos_momeq_dRHO,iout,ierr)
        ss3%dxRjcos_momeq_dRHO = ss2%dxRjcos_momeq_dRHO
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%dxRjsin_momeq_dRHO)).AND.(cclist(ps_cnum_EQ).EQ.1)) THEN
     IF(ALLOCATED(ss1%dxRjsin_momeq_dRHO).AND.ALLOCATED(ss2%dxRjsin_momeq_dRHO)) THEN
        CALL ps_conformal("dxRjsin_momeq_dRHO",ss2%dxRjsin_momeq_dRHO,ss3%dxRjsin_momeq_dRHO,iout,ierr)
        CALL ps_conformal("dxRjsin_momeq_dRHO",ss1%dxRjsin_momeq_dRHO,ss3%dxRjsin_momeq_dRHO,iout,ierr)
        if(ierr.eq.0) ss3%dxRjsin_momeq_dRHO = w1*ss1%dxRjsin_momeq_dRHO + (1.0_rspec-w1)*ss2%dxRjsin_momeq_dRHO
     ELSE IF(ALLOCATED(ss1%dxRjsin_momeq_dRHO)) THEN
        CALL ps_conformal("dxRjsin_momeq_dRHO",ss1%dxRjsin_momeq_dRHO,ss3%dxRjsin_momeq_dRHO,iout,ierr)
        ss3%dxRjsin_momeq_dRHO = ss1%dxRjsin_momeq_dRHO
     ELSE IF(ALLOCATED(ss2%dxRjsin_momeq_dRHO)) THEN
        CALL ps_conformal("dxRjsin_momeq_dRHO",ss2%dxRjsin_momeq_dRHO,ss3%dxRjsin_momeq_dRHO,iout,ierr)
        ss3%dxRjsin_momeq_dRHO = ss2%dxRjsin_momeq_dRHO
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%dxZjcos_momeq_dRHO)).AND.(cclist(ps_cnum_EQ).EQ.1)) THEN
     IF(ALLOCATED(ss1%dxZjcos_momeq_dRHO).AND.ALLOCATED(ss2%dxZjcos_momeq_dRHO)) THEN
        CALL ps_conformal("dxZjcos_momeq_dRHO",ss2%dxZjcos_momeq_dRHO,ss3%dxZjcos_momeq_dRHO,iout,ierr)
        CALL ps_conformal("dxZjcos_momeq_dRHO",ss1%dxZjcos_momeq_dRHO,ss3%dxZjcos_momeq_dRHO,iout,ierr)
        if(ierr.eq.0) ss3%dxZjcos_momeq_dRHO = w1*ss1%dxZjcos_momeq_dRHO + (1.0_rspec-w1)*ss2%dxZjcos_momeq_dRHO
     ELSE IF(ALLOCATED(ss1%dxZjcos_momeq_dRHO)) THEN
        CALL ps_conformal("dxZjcos_momeq_dRHO",ss1%dxZjcos_momeq_dRHO,ss3%dxZjcos_momeq_dRHO,iout,ierr)
        ss3%dxZjcos_momeq_dRHO = ss1%dxZjcos_momeq_dRHO
     ELSE IF(ALLOCATED(ss2%dxZjcos_momeq_dRHO)) THEN
        CALL ps_conformal("dxZjcos_momeq_dRHO",ss2%dxZjcos_momeq_dRHO,ss3%dxZjcos_momeq_dRHO,iout,ierr)
        ss3%dxZjcos_momeq_dRHO = ss2%dxZjcos_momeq_dRHO
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%dxZjsin_momeq_dRHO)).AND.(cclist(ps_cnum_EQ).EQ.1)) THEN
     IF(ALLOCATED(ss1%dxZjsin_momeq_dRHO).AND.ALLOCATED(ss2%dxZjsin_momeq_dRHO)) THEN
        CALL ps_conformal("dxZjsin_momeq_dRHO",ss2%dxZjsin_momeq_dRHO,ss3%dxZjsin_momeq_dRHO,iout,ierr)
        CALL ps_conformal("dxZjsin_momeq_dRHO",ss1%dxZjsin_momeq_dRHO,ss3%dxZjsin_momeq_dRHO,iout,ierr)
        if(ierr.eq.0) ss3%dxZjsin_momeq_dRHO = w1*ss1%dxZjsin_momeq_dRHO + (1.0_rspec-w1)*ss2%dxZjsin_momeq_dRHO
     ELSE IF(ALLOCATED(ss1%dxZjsin_momeq_dRHO)) THEN
        CALL ps_conformal("dxZjsin_momeq_dRHO",ss1%dxZjsin_momeq_dRHO,ss3%dxZjsin_momeq_dRHO,iout,ierr)
        ss3%dxZjsin_momeq_dRHO = ss1%dxZjsin_momeq_dRHO
     ELSE IF(ALLOCATED(ss2%dxZjsin_momeq_dRHO)) THEN
        CALL ps_conformal("dxZjsin_momeq_dRHO",ss2%dxZjsin_momeq_dRHO,ss3%dxZjsin_momeq_dRHO,iout,ierr)
        ss3%dxZjsin_momeq_dRHO = ss2%dxZjsin_momeq_dRHO
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%dx_fshield)).AND.(cclist(ps_cnum_IC).EQ.1)) THEN
     IF(ALLOCATED(ss1%dx_fshield).AND.ALLOCATED(ss2%dx_fshield)) THEN
        CALL ps_diff("dx_fshield",ss1%dx_fshield,ss2%dx_fshield,icheck,iout,ierr)
        CALL ps_conformal("dx_fshield",ss1%dx_fshield,ss3%dx_fshield,iout,ierr)
        if(ierr.eq.0) ss3%dx_fshield = ss1%dx_fshield
     ELSE IF(ALLOCATED(ss1%dx_fshield)) THEN
        CALL ps_conformal("dx_fshield",ss1%dx_fshield,ss3%dx_fshield,iout,ierr)
        ss3%dx_fshield = ss1%dx_fshield
     ELSE IF(ALLOCATED(ss2%dx_fshield)) THEN
        CALL ps_conformal("dx_fshield",ss2%dx_fshield,ss3%dx_fshield,iout,ierr)
        ss3%dx_fshield = ss2%dx_fshield
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%dZ0_momeq_dRHO)).AND.(cclist(ps_cnum_EQ).EQ.1)) THEN
     IF(ALLOCATED(ss1%dZ0_momeq_dRHO).AND.ALLOCATED(ss2%dZ0_momeq_dRHO)) THEN
        CALL ps_conformal("dZ0_momeq_dRHO",ss2%dZ0_momeq_dRHO,ss3%dZ0_momeq_dRHO,iout,ierr)
        CALL ps_conformal("dZ0_momeq_dRHO",ss1%dZ0_momeq_dRHO,ss3%dZ0_momeq_dRHO,iout,ierr)
        if(ierr.eq.0) ss3%dZ0_momeq_dRHO = w1*ss1%dZ0_momeq_dRHO + (1.0_rspec-w1)*ss2%dZ0_momeq_dRHO
     ELSE IF(ALLOCATED(ss1%dZ0_momeq_dRHO)) THEN
        CALL ps_conformal("dZ0_momeq_dRHO",ss1%dZ0_momeq_dRHO,ss3%dZ0_momeq_dRHO,iout,ierr)
        ss3%dZ0_momeq_dRHO = ss1%dZ0_momeq_dRHO
     ELSE IF(ALLOCATED(ss2%dZ0_momeq_dRHO)) THEN
        CALL ps_conformal("dZ0_momeq_dRHO",ss2%dZ0_momeq_dRHO,ss3%dZ0_momeq_dRHO,iout,ierr)
        ss3%dZ0_momeq_dRHO = ss2%dZ0_momeq_dRHO
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%dZ_geo_dRHO)).AND.(cclist(ps_cnum_EQ).EQ.1)) THEN
     IF(ALLOCATED(ss1%dZ_geo_dRHO).AND.ALLOCATED(ss2%dZ_geo_dRHO)) THEN
        CALL ps_conformal("dZ_geo_dRHO",ss2%dZ_geo_dRHO,ss3%dZ_geo_dRHO,iout,ierr)
        CALL ps_conformal("dZ_geo_dRHO",ss1%dZ_geo_dRHO,ss3%dZ_geo_dRHO,iout,ierr)
        if(ierr.eq.0) ss3%dZ_geo_dRHO = w1*ss1%dZ_geo_dRHO + (1.0_rspec-w1)*ss2%dZ_geo_dRHO
     ELSE IF(ALLOCATED(ss1%dZ_geo_dRHO)) THEN
        CALL ps_conformal("dZ_geo_dRHO",ss1%dZ_geo_dRHO,ss3%dZ_geo_dRHO,iout,ierr)
        ss3%dZ_geo_dRHO = ss1%dZ_geo_dRHO
     ELSE IF(ALLOCATED(ss2%dZ_geo_dRHO)) THEN
        CALL ps_conformal("dZ_geo_dRHO",ss2%dZ_geo_dRHO,ss3%dZ_geo_dRHO,iout,ierr)
        ss3%dZ_geo_dRHO = ss2%dZ_geo_dRHO
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%dZ_geo_dTH)).AND.(cclist(ps_cnum_EQ).EQ.1)) THEN
     IF(ALLOCATED(ss1%dZ_geo_dTH).AND.ALLOCATED(ss2%dZ_geo_dTH)) THEN
        CALL ps_conformal("dZ_geo_dTH",ss2%dZ_geo_dTH,ss3%dZ_geo_dTH,iout,ierr)
        CALL ps_conformal("dZ_geo_dTH",ss1%dZ_geo_dTH,ss3%dZ_geo_dTH,iout,ierr)
        if(ierr.eq.0) ss3%dZ_geo_dTH = w1*ss1%dZ_geo_dTH + (1.0_rspec-w1)*ss2%dZ_geo_dTH
     ELSE IF(ALLOCATED(ss1%dZ_geo_dTH)) THEN
        CALL ps_conformal("dZ_geo_dTH",ss1%dZ_geo_dTH,ss3%dZ_geo_dTH,iout,ierr)
        ss3%dZ_geo_dTH = ss1%dZ_geo_dTH
     ELSE IF(ALLOCATED(ss2%dZ_geo_dTH)) THEN
        CALL ps_conformal("dZ_geo_dTH",ss2%dZ_geo_dTH,ss3%dZ_geo_dTH,iout,ierr)
        ss3%dZ_geo_dTH = ss2%dZ_geo_dTH
     ENDIF
  ENDIF

END SUBROUTINE plasma_state_merge_1

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_d3_dummy
     return
  end subroutine ccps_getset_d3_dummy

subroutine psget_difns_mmm71(iobj, n1, n2, data, ierr)
    !! density-equations, diffusivity term
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_difns_mmm71', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % difns_mmm71
end subroutine psget_difns_mmm71


subroutine psset_difns_mmm71(iobj, n1, n2, data, ierr)
    !! density-equations, diffusivity term
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_difns_mmm71', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % difns_mmm71 = data(1:n1, 1: n2)
end subroutine psset_difns_mmm71


subroutine psgetrnk_difns_mmm71(iobj, ndims, ierr)
    !! density-equations, diffusivity term
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_difns_mmm71


subroutine psgetdim_difns_mmm71(iobj, ndims, dims, ierr)
    !! density-equations, diffusivity term
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_difns_mmm71', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % difns_mmm71 ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % difns_mmm71)
    endif
end subroutine psgetdim_difns_mmm71


subroutine psget_difns_gtcneo(iobj, n1, n2, data, ierr)
    !! density-equations, neoclassical diffusivity from GTC_NEO
    !! model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_difns_gtcneo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % difns_gtcneo
end subroutine psget_difns_gtcneo


subroutine psset_difns_gtcneo(iobj, n1, n2, data, ierr)
    !! density-equations, neoclassical diffusivity from GTC_NEO
    !! model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_difns_gtcneo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % difns_gtcneo = data(1:n1, 1: n2)
end subroutine psset_difns_gtcneo


subroutine psgetrnk_difns_gtcneo(iobj, ndims, ierr)
    !! density-equations, neoclassical diffusivity from GTC_NEO
    !! model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_difns_gtcneo


subroutine psgetdim_difns_gtcneo(iobj, ndims, dims, ierr)
    !! density-equations, neoclassical diffusivity from GTC_NEO
    !! model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_difns_gtcneo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % difns_gtcneo ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % difns_gtcneo)
    endif
end subroutine psgetdim_difns_gtcneo


subroutine psget_dr_geo_drho(iobj, n1, n2, data, ierr)
    !! flux surfaces R(rho,theta)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_dr_geo_drho', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % dR_geo_dRHO
end subroutine psget_dr_geo_drho


subroutine psset_dr_geo_drho(iobj, n1, n2, data, ierr)
    !! flux surfaces R(rho,theta)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_dr_geo_drho', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % dR_geo_dRHO = data(1:n1, 1: n2)
end subroutine psset_dr_geo_drho


subroutine psgetrnk_dr_geo_drho(iobj, ndims, ierr)
    !! flux surfaces R(rho,theta)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_dr_geo_drho


subroutine psgetdim_dr_geo_drho(iobj, ndims, dims, ierr)
    !! flux surfaces R(rho,theta)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_dr_geo_drho', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % dR_geo_dRHO ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % dR_geo_dRHO)
    endif
end subroutine psgetdim_dr_geo_drho


subroutine psget_dxzjcos_momeq_drho(iobj, n1, n2, data, ierr)
    !! scaled Z cos moments, Fourier Spline representation
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_dxzjcos_momeq_drho', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % dxZjcos_momeq_dRHO
end subroutine psget_dxzjcos_momeq_drho


subroutine psset_dxzjcos_momeq_drho(iobj, n1, n2, data, ierr)
    !! scaled Z cos moments, Fourier Spline representation
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_dxzjcos_momeq_drho', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % dxZjcos_momeq_dRHO = data(1:n1, 1: n2)
end subroutine psset_dxzjcos_momeq_drho


subroutine psgetrnk_dxzjcos_momeq_drho(iobj, ndims, ierr)
    !! scaled Z cos moments, Fourier Spline representation
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_dxzjcos_momeq_drho


subroutine psgetdim_dxzjcos_momeq_drho(iobj, ndims, dims, ierr)
    !! scaled Z cos moments, Fourier Spline representation
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_dxzjcos_momeq_drho', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % dxZjcos_momeq_dRHO ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % dxZjcos_momeq_dRHO)
    endif
end subroutine psgetdim_dxzjcos_momeq_drho

module pspro

  ! routines to compute physics profile quantities that from Plasma State 
  ! object data are gathered here:
  !
  !    pspro_cloge -- electron Coulomb Log
  !    pspro_resis_hhb -- resistivity (Hirshman-Hawryluk-Birge Neoclassical)
  !      ... ...
  !
  ! It is recommended to compute full profiles (rho(:) covering the whole
  ! plasma column or nearly so).  If doing one surface at a time use intrp=0
  ! for direct interpolation.

  use plasma_state_mod
  implicit NONE

  PRIVATE

  public :: pspro_cloge,pspro_resis_hhb

  real*8, parameter :: ZERO = 0.0d0
  real*8, parameter :: ONE  = 1.0d0

CONTAINS

  subroutine pspro_cloge(pps,rho,cloge,ierr,intrp)

    ! Return electron Coulomb Log at indicated locations

    type (plasma_state) :: pps  ! Plasma State object
    !   (PLASMA and EQ components should be filled out)
    !   (electron temperature, density, and Zeff are used with rezoning)

    real*8, dimension(:), intent(in) :: rho ! radial flux zone locations in
    real*8, dimension(:), intent(out) :: cloge ! electron coulomb log out

    integer, intent(out) :: ierr   ! status code on exit, 0=OK

    integer, intent(in), optional :: intrp  ! interpolation options
    !                     =0 direct interpolation
    !                     =1 rezone w/o smoothing (default)
    !                     =2 rezone w/smoothing
    !                     =3 rezone, smoothing if size(rho) larger than
    !                                     (3/2)*[pps PLASMA rho grid size]

    !-----------------------------------------------
    !  local:

    integer :: intrpi,isize,ii,iwarn,jwarn,iout
    LOGICAL :: zonesmoo

    real*8, dimension(:), allocatable :: rhozb,ne,te,zeff
    real*8 :: cloge_r8_fcn
    !-----------------------------------------------

    iout = SWIM_err_out_file

    cloge = ZERO

    !  error checks

    call chk_pps('pspro_cloge',pps,1,ierr)
    if(ierr.ne.0) return

    call chk_rho('pspro_cloge',rho,ierr)
    if(ierr.ne.0) return

    !  rezone option

    intrpi=1
    if(present(intrp)) intrpi = max(0,min(3,intrp))

    isize = size(rho)
    call get_zonesmoo(pps,intrpi,isize,zonesmoo)

    !  allocate local arrays

    allocate(rhozb(isize+1),ne(isize),Te(isize),Zeff(isize))

    call gen_rhozb(rho,rhozb)

    call get_parms(pps,rho,rhozb,intrpi,zonesmoo,ne,Te,Zeff,ierr)
    if(ierr.ne.0) then
       write(iout,*) &
            ' pspro("pspro_cloge"): {ne,Te,Zeff} interpolation/rezone error.'
       return
    endif

    jwarn=0
    do ii=1,isize
       cloge(ii) = cloge_r8_fcn( ne(ii)*1.0e-6_rspec, Te(ii)*1000.0_rspec, &
            Zeff(ii), iwarn)
       jwarn = max(jwarn,iwarn)
    enddo

    if(jwarn.gt.0) then
       ierr=1
       write(iout,*) &
            ' pspro("pspro_cloge"): cloge_r8_fcn warning flag detected.'
       cloge = ZERO
       return
    endif

  end subroutine pspro_cloge

  subroutine pspro_resis_hhb(pps,rho,eta_sp,eta_nc,ierr,intrp)

    ! Return resistivity at indicated locations, using Hirshman-Hawryluk-Birge
    ! aspect ratio neoclassical formula.  Both the Spitzer and the Neoclassical
    ! resistivities are computed.

    type (plasma_state) :: pps  ! Plasma State object
    !   (PLASMA and EQ components should be filled out)
    !   (electron temperature, density, and Zeff are used with rezoning)

    real*8, dimension(:), intent(in) :: rho ! radial flux zone locations in
    real*8, dimension(:), intent(out) :: eta_sp ! Spitzer resistivity, Ohm*m
    real*8, dimension(:), intent(out) :: eta_nc ! Neoclassical resistivity, 
    !                                                also Ohm*m

    integer, intent(out) :: ierr   ! status code on exit, 0=OK

    integer, intent(in), optional :: intrp  ! interpolation options
    !                     =0 direct interpolation
    !                     =1 rezone w/o smoothing (default)
    !                     =2 rezone w/smoothing
    !                     =3 rezone, smoothing if size(rho) larger than
    !                                     (3/2)*[pps PLASMA rho grid size]

    !-----------------------------------------------
    !  local:

    integer :: intrpi,isize,ii,iwarn,jwarn,iout
    LOGICAL :: zonesmoo

    real*8, dimension(:), allocatable :: rhozb,rhozc,ne,te,zeff
    real*8, dimension(:), allocatable :: aratii,Lpol,dVdrho,xiotb,Rin,Rout
    real*8 :: tflux,bzxr,rmin_mp,rmaj_mp
    !-----------------------------------------------

    iout = SWIM_err_out_file

    eta_sp = ZERO
    eta_nc = ZERO

    !  error checks

    call chk_pps('pspro_resis_hhb',pps,2,ierr)
    if(ierr.ne.0) return

    call chk_rho('pspro_resis_hhb',rho,ierr)
    if(ierr.ne.0) return

    !  rezone option

    intrpi=1
    if(present(intrp)) intrpi = max(0,min(3,intrp))

    isize = size(rho)
    call get_zonesmoo(pps,intrpi,isize,zonesmoo)

    !  allocate local arrays

    allocate(rhozc(isize),rhozb(isize+1),ne(isize),Te(isize),Zeff(isize))
    allocate(aratii(isize),Lpol(isize),dVdrho(isize),xiotb(isize))
    allocate(Rin(isize),Rout(isize))

    call gen_rhozb(rho,rhozb)

    ! for HHB resistivity, need to stay epsilon away from magnetic axis, so,
    ! rhozc is (rho(:)) with 1st point adjusted if necessary

    rhozc = rho
    if(isize.gt.1) then
       rhozc(1) = max(rhozc(1),min(1.e-6_rspec,rhozc(2)/10.0_rspec))
    else
       rhozc(1) = max(rhozc(1),1.e-6_rspec)
    endif

    ! get ne,Te,Zeff

    call get_parms(pps,rho,rhozb,intrpi,zonesmoo,ne,Te,Zeff,ierr)
    if(ierr.ne.0) then
       write(iout,*) &
            ' pspro("pspro_resis_hhb"): {ne,Te,Zeff} interp/rezone error.'
       return
    endif

    ! get field & geometry information

    tflux = pps%phit(pps%nrho_eq)  ! enclosed toroidal flux, Wb
    bzxr = 100.0_rspec*pps%g_eq(pps%nrho_eq)  ! vacuum R*B_phi, Tesla*cm

    do
       call ps_intrp_1d(rhozc,pps%id_R_midp_in,Rin,ierr,state=pps)
       if(ierr.ne.0) exit
       call ps_intrp_1d(rhozc,pps%id_R_midp_out,Rout,ierr,state=pps)
       if(ierr.ne.0) exit

       ! inverse aspect ratio r/R

       do ii=1,isize
          Rmin_mp = (Rout(ii)-Rin(ii))*0.5_rspec
          Rmaj_mp = (Rout(ii)+Rin(ii))*0.5_rspec
          if(Rmaj_mp.le.ZERO) then
             aratii(ii)=ZERO
          else
             aratii(ii)=Rmin_mp/Rmaj_mp
          endif
       enddo

       ! poloidal path length -> cm
       call ps_intrp_1d(rhozc,pps%id_Lpol,Lpol,ierr,state=pps)
       if(ierr.ne.0) exit

       Lpol = 100.0_rspec*Lpol

       ! dVol/drho -> cm**3

       call ps_intrp_1d(rhozc,pps%id_vol,dVdrho,ierr,state=pps,ideriv=1)
       if(ierr.ne.0) exit

       dVdrho = 1.0e6_rspec*dVdrho

       !  iota(bar) = 1/q

       call ps_intrp_1d(rhozc,pps%id_iota,xiotb,ierr,state=pps)
       if(ierr.ne.0) exit

       exit
    enddo

    if(ierr.ne.0) then
       write(iout,*) &
            ' ?pspro("pspro_resis_hhb") input data interpolation error.'
       return
    endif

#ifdef __DEBUG
    write(iout,*) ' '
    write(iout,*) ' #,ne,Te,Zeff,eta_sp,eta_nc '
#endif

    jwarn=0
    do ii=1,isize
       call hhb_resis(ne(ii)*1.0e-6_rspec, Te(ii)*1000.0_rspec, Zeff(ii), &
            aratii(ii), Lpol(ii), tflux, rhozc(ii), dVdrho(ii), &
            xiotb(ii), bzxr, &
            eta_sp(ii),eta_nc(ii), iwarn)

       eta_sp(ii) = eta_sp(ii)/100.0_rspec  ! -> Ohm*m
       eta_nc(ii) = eta_nc(ii)/100.0_rspec  ! -> Ohm*m

#ifdef __DEBUG
       write(iout,'(1x,i2,5(1x,1pe11.4))') ii,ne(ii),Te(ii),Zeff(ii), &
            eta_sp(ii),eta_nc(ii)
#endif

       jwarn = max(jwarn,iwarn)
    enddo

    if(jwarn.gt.0) then
       ierr=1
       write(iout,*) &
            ' pspro("pspro_resis_hhb"): SR hhb_resis warning flag detected.'
       eta_sp = ZERO
       eta_nc = ZERO
    endif

  end subroutine pspro_resis_hhb

  !-------------------------------
  ! private internal routines...

  subroutine chk_pps(label,pps,ilev,ierr)

    ! check if Plasma State contains allocated PLASMA & EQ component data

    character*(*), intent(in) :: label
    type (plasma_state) :: pps     ! Plasma State object
    integer, intent(in) :: ilev    ! check "level"
    integer, intent(out) :: ierr   ! exit status 0=OK
   
    !--------------------------------
    integer :: iout
    !--------------------------------

    iout = SWIM_err_out_file

    call ps_state_memory_update(ierr,state=pps,eqcheck=.FALSE.)
    if(ierr.ne.0) then
       write(iout,*) ' ?pspro("'//trim(label)// &
            '") chk_pps ps_state_memory_update error.'
       return
    endif

    if(pps%nrho.le.0) then
       ierr=1
       write(iout,*) ' ?pspro("'//trim(label)// &
            '") chk_pps: PLASMA component nrho=0.'
       return
    endif

    if(pps%nrho_eq.le.0) then
       ierr=1
       write(iout,*) ' ?pspro("'//trim(label)// &
            '") chk_pps: EQ component nrho_eq=0.'
       return
    endif

    if((ilev.gt.1).AND.(pps%nrho_eq_geo.eq.0)) then
       ierr=1
       write(iout,*) ' ?pspro("'//trim(label)// &
            '") chk_pps: EQ component nrho_eq_geo=0.'
       return
    endif

  end subroutine chk_pps

  subroutine get_zonesmoo(pps,intrpi,isize,zonesmoo)

    ! rezone interpolation smoothing option (T/F) set here

    type (plasma_state) :: pps          ! Plasma State object
    integer, intent(in) :: intrpi           ! interpolation option
    integer, intent(in) :: isize            ! target grid size
    logical, intent(out) :: zonesmoo        ! rezone smoothing option (out)
   
    !--------------------------------
    zonesmoo = .FALSE.

    if(intrpi.eq.2) then
       zonesmoo=.TRUE.

    else if(intrpi.eq.3) then
       if(pps%nrho .lt. (2*isize)/3 ) then
          zonesmoo=.TRUE.  ! rezone from coarse to fine grid: smooth
       else
          zonesmoo=.FALSE.
       endif
    endif

  end subroutine get_zonesmoo

  subroutine gen_rhozb(rho,rhozb)

    ! get bdys for rezone target grid

    real*8, dimension(:) :: rho,rhozb
    integer :: isize,ii

    !-------------------------------
    isize = size(rho)

    rhozb(1) = ZERO
    rhozb(isize+1) = ONE

    do ii=2,isize
       rhozb(ii) = 0.5_rspec * (rho(ii-1) + rho(ii))
    enddo

  end subroutine gen_rhozb

  subroutine chk_rho(label,rho,ierr)

    character*(*), intent(in) :: label
    real*8, dimension(:), intent(in) :: rho
    integer, intent(out) :: ierr

    ! set status flag if: 
    !    minval(rho) < ZERO, or 
    !    maxval(rho) > ONE, or
    !    rho not strict ascending, rho(j+1).gt.rho(j)

    !---------------------------------------------
    integer :: ii,iwarn1,iwarn2,iwarn3,iout
    !---------------------------------------------

    ierr = 0
    iout = SWIM_err_out_file

    iwarn1=0
    iwarn2=0
    iwarn3=0

    if(rho(1).lt.ZERO) iwarn1=1
    if(rho(1).gt.ONE) iwarn2=1

    do ii=2,size(rho)
       if(rho(ii).lt.ZERO) iwarn1=1
       if(rho(ii).gt.ONE) iwarn2=1
       if(rho(ii).le.rho(ii-1)) iwarn3=1
    enddo

    if(iwarn1.eq.1) then
       write(iout,*) ' ?pspro("'//trim(label)// &
            '") chk_rho: minval(rho).lt.ZERO'
       ierr=1
    endif

    if(iwarn2.eq.1) then
       write(iout,*) ' ?pspro("'//trim(label)// &
            '") chk_rho: maxval(rho).gt.ONE'
       ierr=1
    endif

    if(iwarn3.eq.1) then
       write(iout,*) ' ?pspro("'//trim(label)// &
            '") chk_rho: rho(:) not strict ascending.'
       ierr=1
    endif

    if(ierr.gt.0) then
       write(iout,*) ' ...rho = ',rho
    endif

  end subroutine chk_rho

  subroutine get_parms(pps,rho,rhozb,intrpi,zonesmoo,ne,Te,Zeff,ierr)

    ! get ne,Te,Zeff profiles (m**-3, keV, -)

    type (plasma_state) :: pps          ! Plasma State object
    real*8, dimension(:), intent(in) :: rho,rhozb   ! interpolation targets
    integer, intent(in) :: intrpi       ! interpolation option
    logical, intent(in) :: zonesmoo     ! smoothing option

    real*8, dimension(:), intent(out) :: ne,Te,Zeff ! output data
    integer, intent(out) :: ierr        ! status code on exit, 0=OK

    !-------------------------

    do
       if(intrpi.eq.0) then
          call ps_intrp_1d(rho,pps%id_ns(0),ne,ierr,state=pps)
          if(ierr.ne.0) exit

          call ps_intrp_1d(rho,pps%id_Ts(0),Te,ierr,state=pps)
          if(ierr.ne.0) exit

          call ps_intrp_1d(rho,pps%id_zeff,Zeff,ierr,state=pps)
          if(ierr.ne.0) exit

       else
          call ps_rho_rezone(rhozb,pps%id_ns(0),ne,ierr, &
               state=pps, zonesmoo=zonesmoo)
          if(ierr.ne.0) exit

          call ps_rho_rezone(rhozb,pps%id_Ts(0),Te,ierr, &
               state=pps, zonesmoo=zonesmoo)
          if(ierr.ne.0) exit

          call ps_rho_rezone(rhozb,pps%id_Zeff,Zeff,ierr, &
               state=pps, zonesmoo=zonesmoo)
          if(ierr.ne.0) exit
       endif

       exit
    enddo

  end subroutine get_parms

end module pspro

subroutine ps_mdescr_namelist_check(ss,iout,ierr)

  !------------------------------------------------------------
  ! (hand maintained) namelist input checks -- machine description namelist
  !------------------------------------------------------------

  use plasma_state_xpobj  ! XPLASMA2 state object definitions

  use plasma_state_definition_mod

  implicit NONE

  !-----------------------
  !  passed:

  type (plasma_state) :: ss       ! plasma state object
  integer, intent(in) :: iout     ! Fortran LUN for messages
  integer, intent(out) :: ierr    ! exit status code 0=OK

  !-----------------------

  ierr = 0

  write(iout,*) ' %ps_mdescr_namelist_check:'
  write(iout,*) '  machine description namelist checks: not implemented.'

end subroutine ps_mdescr_namelist_check

subroutine ps_1dprof_grid(iobj,profId,profName,gridName,iout,ierr)

  !------------------------------------------------------------
  ! given ID and/or name of a 1d f(rho) profile, return the name 
  ! of the grid over which the profile is defined.
  !
  ! DMC May 2008
  !------------------------------------------------------------

  use plasma_state_definition_mod
  use plasma_state_xpobj  ! XPLASMA2 state object definitions
  implicit NONE

  !-----------------------
  !  passed arguments:

  integer :: iobj(ps_container_size)  ! opaque container for xplasma object

  !  if ID.gt.0 is provided, profName is fetched for output;
  !  if ID.le.0 is provided, profName is used as input, to look up ID.

  integer, intent(inout) :: profId    ! ID of 1d profile
  character*(*), intent(inout) :: profName ! name of 1d profile

  character*(*), intent(out) :: gridName   ! name of profile's grid
  
  integer, intent(in) :: iout         ! Fortran LUN of file for messages

  integer, intent(out) :: ierr        ! exit status, 0=OK

  ! non-zero value means: profile ID information invalid or points to
  ! something other than a 1d profile.

  !-----------------------
  ! local:
  integer :: id,idzero,irank
  character*32 zname
  type (interp_object) :: xobj
  type (xplasma), pointer :: s
  !-----------------------
 
  ierr = 0
  gridName = ' '

  xobj = transfer(iobj,xobj)
  s => xobj%s_xpobj

  if(profId.le.0) then
     idzero = 1
     call xplasma_profId(s,profName,profId)
     if(profId.le.0) then
        write(iout,*) ' ?ps_1dprof_grid: invalid profile ID and/or name: ', &
             profId,' "'//trim(profName)//'".'
        ierr=1
        return
     endif

  else
     idzero = 0   ! non-zero ID was provided.
  endif

  call xplasma_prof_info(s,profId,ierr, rank=irank, name=zname, gridId1=id)

  if(ierr.ne.0) then
     write(iout,*) ' ?ps_1dprof_grid: could not find profile:'
     call xplasma_error(s,ierr,iout)
     return
  endif

  if(irank.ne.1) then
     write(iout,*) ' ?ps_1dprof_grid: profile not 1d: ',profId,' "'// &
          trim(zname)//'".'
     ierr=1
     return
  endif

  if(idzero.eq.0) profName=zname  ! name is output; non-zero ID was provided.

  call xplasma_grid_info(s,id,ierr, name=gridName)
  if(ierr.ne.0) then
     write(iout,*) ' ?ps_1dprof_grid: grid look up failed:'
     call xplasma_error(s,ierr,iout)
  endif

end subroutine ps_1dprof_grid

subroutine ps_grid_exist(iobj,gridname,iout,iexist)

  !------------------------------------------------------------
  ! return iexist=.TRUE. if grid exists; .FALSE. if not or if an error occrs.
  ! only print a message if the xplasma object initialization check fails.
  !
  ! DMC Feb 2008
  !------------------------------------------------------------

  use plasma_state_definition_mod
  use plasma_state_xpobj  ! XPLASMA2 state object definitions
  implicit NONE

  !-----------------------
  !  passed arguments:

  integer :: iobj(ps_container_size)  ! opaque container for xplasma object

  character*(*), intent(in) :: gridname  ! name of grid

  integer, intent(in) :: iout     ! Fortran LUN of file for messages

  logical, intent(out) :: iexist  ! .TRUE. if grid exists

  !-----------------------
  ! local:
  integer :: id,ierr
  type (interp_object) :: xobj
  type (xplasma), pointer :: s
  !-----------------------
 
  xobj = transfer(iobj,xobj)
  s => xobj%s_xpobj

  iexist = .FALSE.

  call xplasma_global_info(s,ierr, init_check=.TRUE.)
  if(ierr.ne.0) then
     write(iout,*) ' ?ps_grid_size: invalid or unitialized xplasma object.'
     return
  endif

  call xplasma_gridId(s,gridname,id)

  iexist = (id.NE.0)

end subroutine ps_grid_exist

subroutine ps_grid_size(iobj,gridname,isize,iout,ierr)

  !------------------------------------------------------------
  ! D. McCune 10 Apr 2007
  !
  ! Fetch size of XPLASMA2 grid, supplying the ASCII grid name
  !------------------------------------------------------------

  use plasma_state_definition_mod
  use plasma_state_xpobj  ! XPLASMA2 state object definitions
  implicit NONE

  !-----------------------
  !  passed arguments:

  integer :: iobj(ps_container_size)  ! opaque container for xplasma object

  character*(*), intent(in) :: gridname  ! name of grid

  integer, intent(out) :: isize   ! size of grid

  integer, intent(in) :: iout     ! Fortran LUN of file for messages
  integer, intent(out) :: ierr    ! completion status code (0=OK)

  !-----------------------
  ! local:
  integer :: id
  type (interp_object) :: xobj
  type (xplasma), pointer :: s
  !-----------------------

  isize = 0

  xobj = transfer(iobj,xobj)
  s => xobj%s_xpobj

  call xplasma_global_info(s,ierr, init_check=.TRUE.)
  if(ierr.ne.0) then
     write(iout,*) ' ?ps_grid_size: invalid or unitialized xplasma object.'
     return
  endif

  call xplasma_gridId(s,gridname,id)
  if(id.eq.0) then
     ierr=999
     write(iout,*) ' ?ps_grid_size: grid name unrecognized: ',trim(gridname)
     return
  endif

  call xplasma_grid_info(s,id,ierr, size=isize)

  if(ierr.ne.0) then
     write(iout,*) ' ?ps_grid_size: xplasma_grid_info error:'
     call xplasma_error(s,ierr,iout)
     ierr=999
  endif

end subroutine ps_grid_size
  
subroutine ps_grid(iobj,gridname,isize,gridvals,iout,ierr)

  !------------------------------------------------------------
  ! D. McCune 10 Apr 2007
  !
  ! Fetch XPLASMA2 grid, supplying the ASCII grid name & sized array
  !------------------------------------------------------------

  use plasma_state_definition_mod
  use plasma_state_xpobj  ! XPLASMA2 state object definitions
  implicit NONE

  !-----------------------
  !  passed arguments:

  integer :: iobj(ps_container_size)  ! opaque container for xplasma object

  character*(*), intent(in) :: gridname  ! name of grid

  integer, intent(in) :: isize    ! size of array to receive grid
  real(kind=rspec) :: gridvals(isize)  ! array to receive grid

  integer, intent(in) :: iout     ! Fortran LUN of file for messages
  integer, intent(out) :: ierr    ! completion status code (0=OK)

  !-----------------------
  ! local:
  integer :: id,jsize
  type (interp_object) :: xobj
  type (xplasma), pointer :: s
  !-----------------------

  gridvals = 0.0_rspec

  xobj = transfer(iobj,xobj)
  s => xobj%s_xpobj

  call xplasma_global_info(s,ierr, init_check=.TRUE.)
  if(ierr.ne.0) then
     write(iout,*) ' ?ps_grid: invalid or unitialized xplasma object.'
     return
  endif

  call xplasma_gridId(s,gridname,id)
  if(id.eq.0) then
     ierr=999
     write(iout,*) ' ?ps_grid: grid name unrecognized: ',trim(gridname)
     return
  endif

  call xplasma_grid_info(s,id,ierr, size=jsize)

  if(ierr.ne.0) then
     write(iout,*) ' ?ps_grid: xplasma_grid_info error:'
     call xplasma_error(s,ierr,iout)
     ierr=999
     return
  endif

  if(jsize.gt.isize) then
     write(iout,*) ' ?ps_grid: passed array size too small for grid ', &
          trim(gridname)
     write(iout,*) '  size needed: ',jsize
     write(iout,*) '  size passed: ',isize
     ierr=999
     return
  endif

  call xplasma_grid(s,id,gridvals(1:jsize),ierr)

  if(ierr.ne.0) then
     write(iout,*) ' ?ps_grid: xplasma_grid error:'
     call xplasma_error(s,ierr,iout)
     ierr=999
     return
  endif

end subroutine ps_grid

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_s6_dummy
     return
  end subroutine ccps_getset_s6_dummy

subroutine psget_snbi_type(iobj, n1, data, ierr)
    !! SNBI specie types
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_snbi_type', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % SNBI_type
end subroutine psget_snbi_type


subroutine psset_snbi_type(iobj, n1, data, ierr)
    !! SNBI specie types
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_snbi_type', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % SNBI_type = data(1:n1)
end subroutine psset_snbi_type


subroutine psgetrnk_snbi_type(iobj, ndims, ierr)
    !! SNBI specie types
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_snbi_type


subroutine psgetdim_snbi_type(iobj, ndims, dims, ierr)
    !! SNBI specie types
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_snbi_type', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % SNBI_type ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % SNBI_type)
    endif
end subroutine psgetdim_snbi_type


subroutine psget_s_to_sa(iobj, n1, data, ierr)
    !! address in sa species list, if species s(j) is in list SA,
    !! s_to_sa(j) gives its address in SA., if species s(j) is NOT in
    !! list SA, s_to_sa(j)=-1.
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_s_to_sa', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % s_to_sa
end subroutine psget_s_to_sa


subroutine psset_s_to_sa(iobj, n1, data, ierr)
    !! address in sa species list, if species s(j) is in list SA,
    !! s_to_sa(j) gives its address in SA., if species s(j) is NOT in
    !! list SA, s_to_sa(j)=-1.
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_s_to_sa', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % s_to_sa = data(1:n1)
end subroutine psset_s_to_sa


subroutine psgetrnk_s_to_sa(iobj, ndims, ierr)
    !! address in sa species list, if species s(j) is in list SA,
    !! s_to_sa(j) gives its address in SA., if species s(j) is NOT in
    !! list SA, s_to_sa(j)=-1.
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_s_to_sa


subroutine psgetdim_s_to_sa(iobj, ndims, dims, ierr)
    !! address in sa species list, if species s(j) is in list SA,
    !! s_to_sa(j) gives its address in SA., if species s(j) is NOT in
    !! list SA, s_to_sa(j)=-1.
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_s_to_sa', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % s_to_sa ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % s_to_sa)
    endif
end subroutine psgetdim_s_to_sa


subroutine psget_sgas_to_s(iobj, n1, data, ierr)
    !! map sgas index to "s" list
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_sgas_to_s', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % sgas_to_s
end subroutine psget_sgas_to_s


subroutine psset_sgas_to_s(iobj, n1, data, ierr)
    !! map sgas index to "s" list
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_sgas_to_s', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % sgas_to_s = data(1:n1)
end subroutine psset_sgas_to_s


subroutine psgetrnk_sgas_to_s(iobj, ndims, ierr)
    !! map sgas index to "s" list
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_sgas_to_s


subroutine psgetdim_sgas_to_s(iobj, ndims, dims, ierr)
    !! map sgas index to "s" list
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_sgas_to_s', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % sgas_to_s ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % sgas_to_s)
    endif
end subroutine psgetdim_sgas_to_s


subroutine psget_sprof0e(iobj, n1, n2, data, ierr)
    !! electron source per unit neutral species influx
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_sprof0e', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % sprof0e
end subroutine psget_sprof0e


subroutine psset_sprof0e(iobj, n1, n2, data, ierr)
    !! electron source per unit neutral species influx
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_sprof0e', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % sprof0e = data(1:n1, 1: n2)
end subroutine psset_sprof0e


subroutine psgetrnk_sprof0e(iobj, ndims, ierr)
    !! electron source per unit neutral species influx
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_sprof0e


subroutine psgetdim_sprof0e(iobj, ndims, dims, ierr)
    !! electron source per unit neutral species influx
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_sprof0e', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % sprof0e ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % sprof0e)
    endif
end subroutine psgetdim_sprof0e

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_v1_dummy
     return
  end subroutine ccps_getset_v1_dummy

subroutine psget_vrep_coil_count(iobj, n1, data, ierr)
    !! replication count, vertical coil stack, default: 1
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_vrep_coil_count', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % VRep_coil_count
end subroutine psget_vrep_coil_count


subroutine psset_vrep_coil_count(iobj, n1, data, ierr)
    !! replication count, vertical coil stack, default: 1
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_vrep_coil_count', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % VRep_coil_count = data(1:n1)
end subroutine psset_vrep_coil_count


subroutine psgetrnk_vrep_coil_count(iobj, ndims, ierr)
    !! replication count, vertical coil stack, default: 1
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_vrep_coil_count


subroutine psgetdim_vrep_coil_count(iobj, ndims, dims, ierr)
    !! replication count, vertical coil stack, default: 1
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_vrep_coil_count', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % VRep_coil_count ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % VRep_coil_count)
    endif
end subroutine psgetdim_vrep_coil_count


subroutine psget_vphi0_av(iobj, n1, data, ierr)
    !! average toroidal velocity of neutral source, (some models
    !! may assume this is zero).
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_vphi0_av', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % vphi0_av
end subroutine psget_vphi0_av


subroutine psset_vphi0_av(iobj, n1, data, ierr)
    !! average toroidal velocity of neutral source, (some models
    !! may assume this is zero).
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_vphi0_av', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % vphi0_av = data(1:n1)
end subroutine psset_vphi0_av


subroutine psgetrnk_vphi0_av(iobj, ndims, ierr)
    !! average toroidal velocity of neutral source, (some models
    !! may assume this is zero).
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_vphi0_av


subroutine psgetdim_vphi0_av(iobj, ndims, dims, ierr)
    !! average toroidal velocity of neutral source, (some models
    !! may assume this is zero).
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_vphi0_av', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % vphi0_av ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % vphi0_av)
    endif
end subroutine psgetdim_vphi0_av


subroutine psget_v_pars(iobj, n1, n2, data, ierr)
    !! thermal specie <vpll>
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_v_pars', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % v_pars
end subroutine psget_v_pars


subroutine psset_v_pars(iobj, n1, n2, data, ierr)
    !! thermal specie <vpll>
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_v_pars', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % v_pars = data(1:n1, 1: n2)
end subroutine psset_v_pars


subroutine psgetrnk_v_pars(iobj, ndims, ierr)
    !! thermal specie <vpll>
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_v_pars


subroutine psgetdim_v_pars(iobj, ndims, dims, ierr)
    !! thermal specie <vpll>
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_v_pars', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % v_pars ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % v_pars)
    endif
end subroutine psgetdim_v_pars


subroutine psget_vn_trans(iobj, n1, n2, data, ierr)
    !! specie radial velocity
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_vn_trans', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % vn_trans
end subroutine psget_vn_trans


subroutine psset_vn_trans(iobj, n1, n2, data, ierr)
    !! specie radial velocity
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_vn_trans', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % vn_trans = data(1:n1, 1: n2)
end subroutine psset_vn_trans


subroutine psgetrnk_vn_trans(iobj, ndims, ierr)
    !! specie radial velocity
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_vn_trans


subroutine psgetdim_vn_trans(iobj, ndims, dims, ierr)
    !! specie radial velocity
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_vn_trans', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % vn_trans ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % vn_trans)
    endif
end subroutine psgetdim_vn_trans


subroutine psget_vie_transcat(iobj, n1, n2, data, ierr)
    !! Ion energy radial velocity
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_vie_transcat', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % vie_transcat
end subroutine psget_vie_transcat


subroutine psset_vie_transcat(iobj, n1, n2, data, ierr)
    !! Ion energy radial velocity
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_vie_transcat', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % vie_transcat = data(1:n1, 1: n2)
end subroutine psset_vie_transcat


subroutine psgetrnk_vie_transcat(iobj, ndims, ierr)
    !! Ion energy radial velocity
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_vie_transcat


subroutine psgetdim_vie_transcat(iobj, ndims, dims, ierr)
    !! Ion energy radial velocity
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_vie_transcat', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % vie_transcat ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % vie_transcat)
    endif
end subroutine psgetdim_vie_transcat


subroutine psget_velns_anom(iobj, n1, n2, data, ierr)
    !! density-equations, advective velocity term
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_velns_anom', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % velns_anom
end subroutine psget_velns_anom


subroutine psset_velns_anom(iobj, n1, n2, data, ierr)
    !! density-equations, advective velocity term
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_velns_anom', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % velns_anom = data(1:n1, 1: n2)
end subroutine psset_velns_anom


subroutine psgetrnk_velns_anom(iobj, ndims, ierr)
    !! density-equations, advective velocity term
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_velns_anom


subroutine psgetdim_velns_anom(iobj, ndims, dims, ierr)
    !! density-equations, advective velocity term
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_velns_anom', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % velns_anom ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % velns_anom)
    endif
end subroutine psgetdim_velns_anom

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_g7_dummy
     return
  end subroutine ccps_getset_g7_dummy

subroutine psget_gas_atom(iobj, n1, data, ierr)
    !! name of species introduced by each gas source, Possible
    !! values are: "H", "D", "T", "He3", and "He4" at present., Each
    !! must correspond to an actual species in the SGAS list.
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    CHARACTER*(*), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_gas_atom', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % gas_atom
end subroutine psget_gas_atom


subroutine psset_gas_atom(iobj, n1, data, ierr)
    !! name of species introduced by each gas source, Possible
    !! values are: "H", "D", "T", "He3", and "He4" at present., Each
    !! must correspond to an actual species in the SGAS list.
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    CHARACTER*(*), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_gas_atom', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % gas_atom = data(1:n1)
end subroutine psset_gas_atom


subroutine psgetsz_gas_atom(iobj, size, ierr)
    !! name of species introduced by each gas source, Possible
    !! values are: "H", "D", "T", "He3", and "He4" at present., Each
    !! must correspond to an actual species in the SGAS list.
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: size    ! size of character string
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psgetsz_gas_atom', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! note that the following will return the character length size regardless of
    ! the number of array elements (if gas_atom is an array)
    size = len(ss % gas_atom)
end subroutine psgetsz_gas_atom


subroutine psgetrnk_gas_atom(iobj, ndims, ierr)
    !! name of species introduced by each gas source, Possible
    !! values are: "H", "D", "T", "He3", and "He4" at present., Each
    !! must correspond to an actual species in the SGAS list.
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_gas_atom


subroutine psgetdim_gas_atom(iobj, ndims, dims, ierr)
    !! name of species introduced by each gas source, Possible
    !! values are: "H", "D", "T", "He3", and "He4" at present., Each
    !! must correspond to an actual species in the SGAS list.
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_gas_atom', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % gas_atom ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % gas_atom)
    endif
end subroutine psgetdim_gas_atom


subroutine psget_gri(iobj, n1, data, ierr)
    !! <1/R>
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_gri', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % gri
end subroutine psget_gri


subroutine psset_gri(iobj, n1, data, ierr)
    !! <1/R>
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_gri', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % gri = data(1:n1)
end subroutine psset_gri


subroutine psgetrnk_gri(iobj, ndims, ierr)
    !! <1/R>
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_gri


subroutine psgetdim_gri(iobj, ndims, dims, ierr)
    !! <1/R>
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_gri', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % gri ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % gri)
    endif
end subroutine psgetdim_gri


subroutine psget_gamma_nc(iobj, n1, data, ierr)
    !! NC gamma, 2pi/int(0 to 2pi)[dtheta*(B/B.grad(theta))]
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_gamma_nc', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % gamma_nc
end subroutine psget_gamma_nc


subroutine psset_gamma_nc(iobj, n1, data, ierr)
    !! NC gamma, 2pi/int(0 to 2pi)[dtheta*(B/B.grad(theta))]
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_gamma_nc', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % gamma_nc = data(1:n1)
end subroutine psset_gamma_nc


subroutine psgetrnk_gamma_nc(iobj, ndims, ierr)
    !! NC gamma, 2pi/int(0 to 2pi)[dtheta*(B/B.grad(theta))]
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_gamma_nc


subroutine psgetdim_gamma_nc(iobj, ndims, dims, ierr)
    !! NC gamma, 2pi/int(0 to 2pi)[dtheta*(B/B.grad(theta))]
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_gamma_nc', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % gamma_nc ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % gamma_nc)
    endif
end subroutine psgetdim_gamma_nc


subroutine psget_growthrate_tglf(iobj, n1, n2, data, ierr)
    !! growthrate from TGLF model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_growthrate_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % growthrate_tglf
end subroutine psget_growthrate_tglf


subroutine psset_growthrate_tglf(iobj, n1, n2, data, ierr)
    !! growthrate from TGLF model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_growthrate_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % growthrate_tglf = data(1:n1, 1: n2)
end subroutine psset_growthrate_tglf


subroutine psgetrnk_growthrate_tglf(iobj, ndims, ierr)
    !! growthrate from TGLF model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_growthrate_tglf


subroutine psgetdim_growthrate_tglf(iobj, ndims, dims, ierr)
    !! growthrate from TGLF model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_growthrate_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % growthrate_tglf ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % growthrate_tglf)
    endif
end subroutine psgetdim_growthrate_tglf


subroutine psget_growthrate_mtm(iobj, n1, data, ierr)
    !! growthrate from MTM model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_growthrate_mtm', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % growthrate_mtm
end subroutine psget_growthrate_mtm


subroutine psset_growthrate_mtm(iobj, n1, data, ierr)
    !! growthrate from MTM model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_growthrate_mtm', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % growthrate_mtm = data(1:n1)
end subroutine psset_growthrate_mtm


subroutine psgetrnk_growthrate_mtm(iobj, ndims, ierr)
    !! growthrate from MTM model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_growthrate_mtm


subroutine psgetdim_growthrate_mtm(iobj, ndims, dims, ierr)
    !! growthrate from MTM model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_growthrate_mtm', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % growthrate_mtm ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % growthrate_mtm)
    endif
end subroutine psgetdim_growthrate_mtm

subroutine cstate_merge_size(ndims,idims,ilodiffs,jsize)

  ! given list of dimensions produce size of merged list of members
  ! across all states being compared

  ! use the data from cstate_ldim_stats.f90

  use cstate_lib_mod
  implicit NONE

  integer, intent(in) :: ndims   ! # of dimensions (.ge.1)
  integer, intent(in) :: idims(ndims)  ! the dimension indices
  integer, intent(in) :: ilodiffs(ndims)  ! indexing modification at low end

  integer, intent(out) :: jsize

  !------------------------------------------------
  ! local:
  integer :: iscan(ndims),isizes(ndims),izero(nsss_cur)
  integer :: idim,i,ii,kdims,izsum,imrg
  !------------------------------------------------

  iscan(1)=0
  if(ndims.gt.1) iscan(2:ndims)=1

  !  iscan will span the potential N1 x N2 x ... X N[ndims] index space
  !  of the merged dimensions

  !  the space to be used is reduced, removing [i1,i2,...i[ndims]] points
  !  for which there is no corresponding data

  do i=1,ndims
     idim = idims(i)
     isizes(i) = mrgsizes(idim)  ! Nj
  enddo

  jsize = 0

  do
     !  find next index point in merged space
     kdims=1
     do
        ! scan order is like fortran indexing: 1st index varies most
        ! rapidly...

        iscan(kdims)=iscan(kdims)+1
        if(iscan(kdims).le.isizes(kdims)) exit

        iscan(kdims)=1
        kdims=kdims+1
        if(kdims.gt.ndims) exit
     enddo
     if(kdims.gt.ndims) exit

     !  find if any of the compared states provide data for this index point
     !  a non-zero state-specific index must exist along all dimensions for
     !  this to be the case

     izero(1:nsss_cur) = 1
     do i=1,ndims
        idim = idims(i)
        imrg = iscan(i)
        do ii=1,nsss_cur
           if(mrg_addr_map(ii,imrg,idim).le.ilodiffs(i)) izero(ii)=0
           if(ww(ii)%size.eq.0) izero(ii)=0
        enddo
     enddo

     izsum=sum(izero)

     if(izsum.gt.0) jsize = jsize + 1
  enddo

end subroutine cstate_merge_size


subroutine cstate_merge_addr(ndims,idims,ilodiffs,jsize,dname,dunits,ienum, &
     sum_table,sum_key,merge_names,totsize)

  ! given list of dimensions produce merged list of members
  ! across all states being compared; incorporate reduction sums as needed

  ! use the data from cstate_ldim_stats.f90

  use cstate_lib_mod
  implicit NONE

  integer, intent(in) :: ndims   ! # of dimensions (.ge.1)
  integer, intent(in) :: idims(ndims)  ! the dimension indices
  integer, intent(in) :: ilodiffs(ndims)  ! indexing modification at low end
  integer, intent(in) :: jsize   ! size of merged list
  !            ---> "jsize" from prior call to cstate_merge_size
  character*(*), intent(in) :: dname   ! base name of data
  character*(*), intent(in) :: dunits  ! data units
  !            ---> if "integer" or "character", suppress sums
  integer, intent(in) :: ienum         ! .gt.0: enumerated output
  !            ---> if enumerated output, suppress sums

  integer, intent(out) :: sum_table(0:jsize,nsss_cur,jsize)
  !   sum_table(0,ii,jj) = N = #of terms in sum for merged list element (jj)
  !                            from state (ii).  0=> absent data in state (ii)
  !
  !   sum_table(1:N,ii,jj) = elements from state (ii) to be summed to form
  !                            merged element (jj)
  !    

  integer, intent(out) :: sum_key(ndims,jsize)
  !   sum_key(i,jj) is summation number for dimension (idims(i)) for merged 
  !             element (jj)

  character*32, intent(out) :: merge_names(jsize)

  integer, intent(out) :: totsize
  !   final number of merged elements, totsize < jsize if there are reductions;
  !   if there are no reduction sums, totsize = jsize on output

  !  ONLY elements sum_table(:,1:nsss_cur,1:totsize) are populated!
  !  ONLY elements sum_key(1:ndims,1:totsize) are populated!

  !------------------------------------------------
  ! local:
  integer :: iscan(ndims),isizes(ndims),izero(nsss_cur)
  integer :: dsizes(0:ndims,nsss_cur),iadr(ndims)
  integer :: idim,i,ii,kdims,izsum,imrg,iord,ictrl

  logical :: iactive(nreduce_opt)  ! flag active reduction sum options
  integer :: loc_sumkey(ndims),locsum,iorig_addr,indx,imatch,iterm,isum
  character*32 :: zname1,zname2
  integer, dimension(:,:), allocatable :: nosum_key
  character*32, dimension(:), allocatable :: orig_names
  !------------------------------------------------

  allocate(nosum_key(ndims,jsize)); nosum_key=0
  allocate(orig_names(jsize))

  if((dunits.eq.'character').or.(dunits.eq.'integer')) then
     iactive = .FALSE.  ! no sums for non-floating point data

  else if(ienum.gt.0) then
     iactive = .FALSE.  ! no sums for enumerated displays

  else
     iactive = reduce_active
  endif

  iscan(1)=0
  if(ndims.gt.1) iscan(2:ndims)=1

  !  iscan will span the potential N1 x N2 x ... X N[ndims] index space
  !  of the merged dimensions

  !  the space to be used is reduced, removing [i1,i2,...i[ndims]] points
  !  for which there is no corresponding data

  !  the size (jsize) of the reduced space is already known by means of the 
  !  prior call to cstate_merge_size.

  !  Each individual state has its own subset index space; the sizes of
  !  linear address space corresponding to each index increment are stored
  !  in dsizes(...)

  dsizes(0,1:nsss_cur)=1
  do i=1,ndims
     idim = idims(i)
     isizes(i) = mrgsizes(idim)  ! Nj
     do ii=1,nsss_cur
        dsizes(i,ii)=dsizes(i-1,ii)*(dimsizes(ii,idim)-ilodiffs(i))
     enddo
  enddo

  totsize = 0
  iadr = 0

  do
     !  find next index point in merged space
     kdims=1
     do
        ! scan order is like fortran indexing: 1st index varies most
        ! rapidly...

        iscan(kdims)=iscan(kdims)+1
        if(iscan(kdims).le.isizes(kdims)) exit

        iscan(kdims)=1
        kdims=kdims+1
        if(kdims.gt.ndims) exit
     enddo
     if(kdims.gt.ndims) exit

     !  find if any of the compared states provide data for this index point
     !  a non-zero state-specific index must exist along all dimensions for
     !  this to be the case

     izero(1:nsss_cur) = 1
     do i=1,ndims
        idim = idims(i)
        imrg = iscan(i)
        do ii=1,nsss_cur
           if(mrg_addr_map(ii,imrg,idim).le.ilodiffs(i)) then
              izero(ii)=0
           else if(ww(ii)%size.eq.0) then
              izero(ii)=0
           else
              iord=mrg_addr_map(ii,imrg,idim)
              ictrl=sumctrl(iord,ii,idim)
              if(ictrl.gt.0) then
                 if(iactive(ictrl)) then
                    loc_sumkey(i)=sumindx(iord,ii,idim)  ! done repeatedly
                 else
                    loc_sumkey(i)=0  ! sum not active
                 endif
              else
                 loc_sumkey(i)=0  ! no sum
              endif
           endif
        enddo
     enddo

     izsum=sum(izero)

     if(izsum.eq.0) cycle

     imatch=0
     locsum = sum(loc_sumkey)  ! (0,0,0) -> zero -> no sum.

     if(locsum.gt.0) then
        do ii=1,totsize
           do i=1,ndims
              if(loc_sumkey(i).eq.sum_key(i,ii)) imatch = imatch + 1
              if(loc_sumkey(i).eq.0) then
                 if(iscan(i).ne.nosum_key(i,ii)) imatch = imatch - 1
              endif
           enddo
           if(imatch.eq.ndims) then
              indx=ii
              exit
           else
              imatch=0  ! & keep looking for match on all dimensions
           endif
        enddo
     endif

     if(imatch.eq.0) then
        totsize=totsize + 1
        sum_key(1:ndims,totsize) = loc_sumkey
        do i=1,ndims
           if(sum_key(i,totsize).eq.0) nosum_key(i,totsize)=iscan(i)
        enddo
        sum_table(0:jsize,1:nsss_cur,totsize) = 0
        indx = totsize
        merge_names(totsize)=' '
     endif

     !  OK there is data from at least one state

     do ii=1,nsss_cur
        iorig_addr = 0
        if(izero(ii).eq.1) then

           ! state (ii) has data for this index point

           do i=1,ndims
              idim=idims(i)
              imrg=iscan(i)
              iord=mrg_addr_map(ii,imrg,idim)
              iadr(i)=orig_order(iord,ii,idim)-ilodiffs(i)
           enddo

           ! compute linear address

           iorig_addr = 1
           do i=1,ndims
              iorig_addr = iorig_addr + dsizes(i-1,ii)*(iadr(i)-1)
           enddo
        endif
        if(iorig_addr.gt.0) then
           iterm=sum_table(0,ii,indx)+1
           sum_table(0,ii,indx)=iterm
           sum_table(iterm,ii,indx)=iorig_addr
        endif
        if((merge_names(totsize).eq.' ').and.(iorig_addr.gt.0)) then
           if(locsum.eq.0) then
              merge_names(totsize)=ww(ii)%list_elems(iorig_addr)
              orig_names(totsize)=ww(ii)%list_elems(iorig_addr)
           else
              orig_names(totsize)=ww(ii)%list_elems(iorig_addr)
              zname1=dname
              do i=1,ndims
                 idim=idims(i)
                 imrg=iscan(i)
                 iord=mrg_addr_map(ii,imrg,idim)
                 isum=sumindx(iord,ii,idim)
                 if(isum.eq.0) then
                    zname2=trim(zname1)//'_'//mrg_name(imrg,idim)
                 else
                    zname2=trim(zname1)//'_'//sumlbl(isum,idim)
                 endif
                 zname1=zname2
              enddo
              merge_names(totsize)=zname1
           endif
        else if(iorig_addr.gt.0) then
           if(orig_names(totsize).ne.ww(ii)%list_elems(iorig_addr)) then
              orig_names(totsize)=' '
           endif
        endif
     enddo

  enddo

  do ii=1,totsize
     if(orig_names(ii).ne.' ') merge_names(ii)=orig_names(ii)
  enddo

  deallocate(nosum_key,orig_names)
end subroutine cstate_merge_addr

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_a0_dummy
     return
  end subroutine ccps_getset_a0_dummy

subroutine psget_ap2_vert_offset(iobj, n1, data, ierr)
    !! vertical offset, 2nd aperture, opening relative to beam
    !! centerline: positive value means the, aperture opening is
    !! shifted upward relative to the beam centerline
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_ap2_vert_offset', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % ap2_vert_offset
end subroutine psget_ap2_vert_offset


subroutine psset_ap2_vert_offset(iobj, n1, data, ierr)
    !! vertical offset, 2nd aperture, opening relative to beam
    !! centerline: positive value means the, aperture opening is
    !! shifted upward relative to the beam centerline
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_ap2_vert_offset', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % ap2_vert_offset = data(1:n1)
end subroutine psset_ap2_vert_offset


subroutine psgetrnk_ap2_vert_offset(iobj, ndims, ierr)
    !! vertical offset, 2nd aperture, opening relative to beam
    !! centerline: positive value means the, aperture opening is
    !! shifted upward relative to the beam centerline
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_ap2_vert_offset


subroutine psgetdim_ap2_vert_offset(iobj, ndims, dims, ierr)
    !! vertical offset, 2nd aperture, opening relative to beam
    !! centerline: positive value means the, aperture opening is
    !! shifted upward relative to the beam centerline
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_ap2_vert_offset', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % ap2_vert_offset ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % ap2_vert_offset)
    endif
end subroutine psgetdim_ap2_vert_offset


subroutine psget_atorminlh(iobj, n1, n2, data, ierr)
    !! toroidal mode number left of lumps
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_atorminlh', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % atorminlh
end subroutine psget_atorminlh


subroutine psset_atorminlh(iobj, n1, n2, data, ierr)
    !! toroidal mode number left of lumps
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_atorminlh', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % atorminlh = data(1:n1, 1: n2)
end subroutine psset_atorminlh


subroutine psgetrnk_atorminlh(iobj, ndims, ierr)
    !! toroidal mode number left of lumps
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_atorminlh


subroutine psgetdim_atorminlh(iobj, ndims, dims, ierr)
    !! toroidal mode number left of lumps
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_atorminlh', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % atorminlh ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % atorminlh)
    endif
end subroutine psgetdim_atorminlh


subroutine psget_all_name(iobj, n1, data, ierr)
    !! all species, index 0 for electrons, this list is the union
    !! of lists "s", "snbi", "rfmin", and "sfus"
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    CHARACTER*(*), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_all_name', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % ALL_name
end subroutine psget_all_name


subroutine psset_all_name(iobj, n1, data, ierr)
    !! all species, index 0 for electrons, this list is the union
    !! of lists "s", "snbi", "rfmin", and "sfus"
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    CHARACTER*(*), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_all_name', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % ALL_name = data(1:n1)
end subroutine psset_all_name


subroutine psgetsz_all_name(iobj, size, ierr)
    !! all species, index 0 for electrons, this list is the union
    !! of lists "s", "snbi", "rfmin", and "sfus"
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: size    ! size of character string
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psgetsz_all_name', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! note that the following will return the character length size regardless of
    ! the number of array elements (if ALL_name is an array)
    size = len(ss % ALL_name)
end subroutine psgetsz_all_name


subroutine psgetrnk_all_name(iobj, ndims, ierr)
    !! all species, index 0 for electrons, this list is the union
    !! of lists "s", "snbi", "rfmin", and "sfus"
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_all_name


subroutine psgetdim_all_name(iobj, ndims, dims, ierr)
    !! all species, index 0 for electrons, this list is the union
    !! of lists "s", "snbi", "rfmin", and "sfus"
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_all_name', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % ALL_name ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % ALL_name)
    endif
end subroutine psgetdim_all_name


subroutine psget_alla_type(iobj, n1, data, ierr)
    !! ALLA specie types
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_alla_type', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % ALLA_type
end subroutine psget_alla_type


subroutine psset_alla_type(iobj, n1, data, ierr)
    !! ALLA specie types
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_alla_type', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % ALLA_type = data(1:n1)
end subroutine psset_alla_type


subroutine psgetrnk_alla_type(iobj, ndims, ierr)
    !! ALLA specie types
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_alla_type


subroutine psgetdim_alla_type(iobj, ndims, dims, ierr)
    !! ALLA specie types
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_alla_type', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % ALLA_type ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % ALLA_type)
    endif
end subroutine psgetdim_alla_type

! $Id: ccps_species.f90,v 1.2 2009-01-20 02:13:58 xshare Exp $
! F77/C access routines to plasma_state methods

subroutine ccps_species_convert(iZatom, iZcharge, iAMU, qatom, qcharge, mass, &
     ierr)
  use plasma_state_mod
  implicit none

  integer, intent(in) :: iZatom    ! atomic number: 1 for H, 2 for He, ...
  !  special: -1 for electrons

  integer, intent(in) :: iZcharge  ! ionic charge btw 1 and iZatom
  !  ignored for electrons

  integer, intent(in) :: iAMU      ! atomic weight in AMU, nearest integer
  !  ignored unless 1 <= iZatom <= 2

  REAL(KIND=rspec), intent(out) :: qatom    ! charge of fully stripped ion
  REAL(KIND=rspec), intent(out) :: qcharge  ! actual charge
  REAL(KIND=rspec), intent(out) :: mass     ! mass in kg

  integer,intent(out) :: ierr      ! exit status 0=OK

  call ps_species_convert(iZatom, iZcharge, iAMU, qatom, qcharge, mass, ierr)
end subroutine ccps_species_convert

subroutine ccps_label_species(iobj, ierr)
  use plasma_state_mod
  implicit none

  integer :: iobj(*)        ! (ps_container_size) words are used: state object
  integer,intent(out) :: ierr      ! exit status 0=OK

  !-------------------------
  type (plasma_state_container) :: ptr
  type (plasma_state), pointer :: ss
  !-------------------------

  call ccps_argcheck('ccps_label_species',iobj,ierr)
  if(ierr.ne.0) return

  ! proceed...

  call load_ps_container(iobj,ptr)
  ss => ptr%ps_ptr

  call ps_label_species(ierr, state=ss)
end subroutine ccps_label_species

subroutine ccps_merge_species_lists(iobj, ierr)
  use plasma_state_mod
  implicit none

  integer :: iobj(*)        ! (ps_container_size) words are used: state object
  integer,intent(out) :: ierr      ! exit status 0=OK

  !-------------------------
  type (plasma_state_container) :: ptr
  type (plasma_state), pointer :: ss
  !-------------------------

  call ccps_argcheck('ccps_merge_species_lists',iobj,ierr)
  if(ierr.ne.0) return

  ! proceed...

  call load_ps_container(iobj,ptr)
  ss => ptr%ps_ptr

  call ps_merge_species_lists(ierr, state=ss)
end subroutine ccps_merge_species_lists

subroutine ccps_neutral_species(iobj, ierr)
  use plasma_state_mod
  implicit none

  integer :: iobj(*)        ! (ps_container_size) words are used: state object
  integer,intent(out) :: ierr      ! exit status 0=OK

  !-------------------------
  type (plasma_state_container) :: ptr
  type (plasma_state), pointer :: ss
  !-------------------------

  call ccps_argcheck('ccps_neutral_species',iobj,ierr)
  if(ierr.ne.0) return

  ! proceed...

  call load_ps_container(iobj,ptr)
  ss => ptr%ps_ptr

  call ps_neutral_species(ierr, state=ss)
end subroutine ccps_neutral_species

subroutine ccps_copy_plasma_state(iobj_from, iobj_to, &
     cclist, inodims, iwant_1deq, ierr)

  ! Copy state objects

  !  All of the data is physically copied; memory is not shared between
  !  states; modification to values of state A never effects state B.

  !  default is to copy ALL components

  !  unless optional argument inodims=1 is set, the to_state is erased
  !  prior to copy; to_state ends up containing ONLY the copied data

  !  if inodims=1 is set, to_state must have its array dimensions already
  !  defined; its contents are NOT erased.  Its non-zero dimensions MUST
  !  match the non-zero dimensions of from_state, or an error will be
  !  reported when the copy is attempted.

  !  (inodims=1 & cclist settings allow a portion of a state to be copied
  !  into another, established state).

  !  the optional control cclist allows selection of components for
  !  which grids and profiles should NOT be copied:

  !     cclist(ps_cnum_<component>) = 1 to copy this component's profiles
  !     cclist(ps_cnum_<component>) = 0 not to copy

  !  NOTE: machine_description and other scalars associated with
  !  components are still copied; only the copying of grids and profiles
  !  is affected by the cclist(...) control.

  !  the user can build a cclist, refering to components by name, using
  !  the ps_cclist_add and ps_cclist_remove subroutines...

  use plasma_state_mod
  implicit NONE

  integer :: iobj_from(*)   ! (ps_container_size) words : state object "from"
  integer :: iobj_to(*)     ! (ps_container_size) words : state object "to"
  INTEGER, INTENT(IN) :: cclist(ps_ccount)  ! component list
  INTEGER, INTENT(IN) :: inodims  ! =1 to copy data ONLY (no alloc)
  INTEGER, INTENT(IN) :: iwant_1deq  ! =1 to copy (nrho_eq) dim
  integer,intent(out) :: ierr      ! exit status 0=OK

  !-------------------------
  type (plasma_state_container) :: ptr_from,ptr_to
  type (plasma_state), pointer :: ss_from,ss_to
  integer :: iersum
  !-------------------------

  iersum = 0

  call ccps_argcheck('ccps_copy_plasma_state (from argument)',iobj_from,ierr)
  if(ierr.ne.0) iersum=iersum+1

  call ccps_argcheck('ccps_copy_plasma_state (to argument)',iobj_to,ierr)
  if(ierr.ne.0) iersum=iersum+1

  if(iersum.gt.0) then
     ierr=1
     return
  endif

  ! proceed...

  call load_ps_container(iobj_from,ptr_from)
  ss_from => ptr_from%ps_ptr

  call load_ps_container(iobj_to,ptr_to)
  ss_to => ptr_to%ps_ptr

  call ps_copy_plasma_state(from_state=ss_from, to_state=ss_to, &
       & cclist=cclist, inodims=inodims, iwant_1deq=iwant_1deq, ierr=ierr)

end subroutine ccps_copy_plasma_state

subroutine ccps_psimap(iobj,tol,npsi,psi,rhopsi,n_outside,ierr)

  !  Given a set of poloidal flux (Psi) values, Wb/rad
  !  find the corresponding rho values (normalized sqrt toroidal flux, 
  !  btw 0, the magnetic axis, and 1, the boundary at/near the last closed
  !  flux surface).  This inverts the mapping Psipol(rho) corresponding to
  !  the spline element (psipol) in the plasma state.  Psipol(0)=Psimin;
  !  Psipol(1)=Psimax; input psi values should normally fall in this range.
  !     To see these values, read or interpolate the Psipol state element.

  use plasma_state_mod
  implicit NONE

  integer :: iobj(*)        ! (ps_container_size) words are used
  REAL(kind=rspec), intent(in) :: tol   ! tolerance for Psi->rho map.
  !  constrained to be between 1.0d-4 and 1.0d-14; if 0.0 is specified
  !  a default value of 1.0d-10 is used.
  !  On output, abs(Psi(rhopsi(i))-Psi(i)) <= tol*Psimax

  integer, intent(in) :: npsi  ! number of psi values in & rhopsi values out
  REAL(kind=rspec), intent(in) :: psi(npsi)     ! psi values in
  REAL(kind=rspec), intent(out) :: rhopsi(npsi) ! rho values out
  !     For psi(j) <= Psimin, rhopsi(j)=0.0 is returned;
  !     For psi(j) >= Psimax, rhopsi(j)=1.0 is returned.

  integer, intent(out) :: n_outside   ! number of values not in range
  !   [Psimin:Psimax]

  integer :: ierr

  !--------------------------------
  type (plasma_state_container) :: ptr
  type (plasma_state), pointer :: ss
  REAL(kind=rspec) :: ztol
  !--------------------------------

  call ccps_argcheck('ccps_psimap',iobj,ierr)
  if(ierr.ne.0) return

  ! proceed...

  call load_ps_container(iobj,ptr)
  ss => ptr%ps_ptr

  if(tol.eq.0.0_rspec) then
     ztol=1.0e-10_rspec
  else
     ztol=max(1.0e-14_rspec,min(1.0e-4_rspec,tol))
  endif

  call ps_psimap(psi,rhopsi,ierr, state=ss, tol=ztol, &
       iwarn=n_outside)

end subroutine ccps_psimap

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


SUBROUTINE plasma_state_store_def_4(ss,icdf,iout,iertot)


  !  define subset of variables and arrays for NetCDF file

  USE plasma_state_definition_mod
  USE netcdf
  IMPLICIT NONE

  TYPE (plasma_state) :: ss     ! state data to read
  INTEGER, INTENT(IN) :: icdf   ! NetCDF file ID
  INTEGER, INTENT(IN) :: iout   ! message LUN
  INTEGER, INTENT(INOUT) :: iertot  ! error count

  !--------------

  INTEGER :: varid,dimid,status,ival,idims(20),indim
  CHARACTER*80 :: nc_errmsg

  !--------------
  !  define variables...


  indim = 1
  status = nf90_inq_dimid(icdf,"ps_clen_80",idims(1))
  CALL define_var("NBI_Data_Info","C*80",indim,idims, &
         "information on source of beam power & voltage data", &
         "__NONE","NBI","SIMULATION_INIT", &
         "C*80   NBI_Data_Info")

  IF(ALLOCATED(ss%nbi_src_name)) THEN
     indim = 1
     status = nf90_inq_dimid(icdf,"ps_clen_32",idims(1))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nbeam",idims(indim))
     CALL define_var("nbi_src_name","N",indim,idims, &
            "number & name of neutral beams", &
            "__NONE","NBI","MACHINE_DESCRIPTION", &
            "L|neutral_beams nbi_src_name(nbeam)")
  ENDIF

  IF(ALLOCATED(ss%nbshape)) THEN
     indim = 1
     status = nf90_inq_dimid(icdf,"ps_clen_32",idims(1))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nbeam",idims(indim))
     CALL define_var("nbshape","N",indim,idims, &
            "shape keyword for beam source grid", &
            "__NONE","NBI","MACHINE_DESCRIPTION", &
            "N     nbshape(nbeam)")
  ENDIF

  indim = 0
  CALL define_var("nebar","R",indim,idims, &
         "line-averaged electron density", &
         "#/m^2","PLASMA","STATE_DATA", &
         "R|units=#/m^2 nebar")

  IF(ALLOCATED(ss%neflux_ky_tglf)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nky_anomth",idims(indim))
     CALL define_var("neflux_ky_tglf","R",indim,idims, &
            "electron density flux spectrum", &
            "GB","ANOM","STATE_PROFILES", &
            "R|units=GB|pclin neflux_ky_tglf(nrho_anomth,nky_anomth)")
  ENDIF

  IF(ALLOCATED(ss%Newcomb_code)) THEN
     indim = 1
     status = nf90_inq_dimid(icdf,"ps_clen_32",idims(1))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nnewcomb",idims(indim))
     CALL define_var("Newcomb_code","N",indim,idims, &
            "name(s) of Newcomb code(s) used", &
            "__NONE","LMHD","SIMULATION_INIT", &
            "L|Newcomb_codes  Newcomb_code(nnewcomb)")
  ENDIF

  IF(ALLOCATED(ss%Newcomb_mapper)) THEN
     indim = 1
     status = nf90_inq_dimid(icdf,"ps_clen_32",idims(1))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nnewcomb",idims(indim))
     CALL define_var("Newcomb_mapper","N",indim,idims, &
            "mapper code used for each Newcomb code", &
            "__NONE","LMHD","SIMULATION_INIT", &
            "N  Newcomb_mapper(nnewcomb)")
  ENDIF

  IF(ALLOCATED(ss%Newcomb_stable)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_mmodes",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nnewcomb",idims(indim))
     CALL define_var("Newcomb_stable","I",indim,idims, &
            "0: stable; 1: unstable;", &
            "__NONE","LMHD","STATE_DATA", &
            "I   Newcomb_stable(mmodes,nnewcomb)")
  ENDIF

  IF(ALLOCATED(ss%Newcomb_status)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nnewcomb",idims(indim))
     CALL define_var("Newcomb_status","I",indim,idims, &
            "completion status: Newcomb codes", &
            "__NONE","LMHD","STATE_DATA", &
            "I   Newcomb_status(nnewcomb)")
  ENDIF

  IF(ALLOCATED(ss%ne_ky_tglf)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nky_anomth",idims(indim))
     CALL define_var("ne_ky_tglf","R",indim,idims, &
            "electron density fluctuation spectrum", &
            "GB","ANOM","STATE_PROFILES", &
            "R|units=GB|pclin ne_ky_tglf(nrho_anomth,nky_anomth)")
  ENDIF

  IF(ALLOCATED(ss%nfusi)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_fus",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nspec_fusion",idims(indim))
     CALL define_var("nfusi","R",indim,idims, &
            "fusion ion density", &
            "m^-3","FUS","STATE_PROFILES", &
            "R|units=m^-3|alias=n|step  nfusi(~nrho_fus,nspec_fusion)")
  ENDIF

  IF(ALLOCATED(ss%nfusi_bdy)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nspec_fusion",idims(indim))
     CALL define_var("nfusi_bdy","R",indim,idims, &
            "fusion ion densities at/beyond boundary", &
            "m^-3","IC","STATE_DATA", &
            "R|units=m^-3  nfusi_bdy(nspec_fusion)")
  ENDIF

  IF(ALLOCATED(ss%ngradb2_av)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_eq_geo",idims(indim))
     CALL define_var("ngradb2_av","R",indim,idims, &
            "<(B.grad(B)/|B|)^2>", &
            "T^2*m^-2","EQ","STATE_PROFILES", &
            "R|units=T^2*m^-2|pclin   ngradb2_av(nrho_eq_geo)")
  ENDIF

  IF(ALLOCATED(ss%ni)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho",idims(indim))
     CALL define_var("ni","R",indim,idims, &
            "total thermal ion density", &
            "m^-3","PLASMA","STATE_PROFILES", &
            "R|units=m^-3|step  ni(~nrho)")
  ENDIF

  IF(ALLOCATED(ss%niflux_ky_tglf)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nky_anomth",idims(indim))
     CALL define_var("niflux_ky_tglf","R",indim,idims, &
            "ion density flux spectrum", &
            "GB","ANOM","STATE_PROFILES", &
            "R|units=GB|pclin niflux_ky_tglf(nrho_anomth,nky_anomth)")
  ENDIF

  IF(ALLOCATED(ss%ni_ky_tglf)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nky_anomth",idims(indim))
     CALL define_var("ni_ky_tglf","R",indim,idims, &
            "ion density fluctuation spectrum", &
            "GB","ANOM","STATE_PROFILES", &
            "R|units=GB|pclin ni_ky_tglf(nrho_anomth,nky_anomth)")
  ENDIF

  indim = 0
  CALL define_var("nmdifb","I",indim,idims, &
         "type of fast ion diffusivity", &
         "__NONE","ANOM","STATE_DATA", &
         "I   nmdifb = 0")

  IF(ALLOCATED(ss%nmini)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_icrf",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nspec_rfmin",idims(indim))
     CALL define_var("nmini","R",indim,idims, &
            "minority species density", &
            "m^-3","IC","STATE_PROFILES", &
            "R|units=m^-3|alias=n|step  nmini(~nrho_icrf,nspec_rfmin)")
  ENDIF

  IF(ALLOCATED(ss%nmini_bdy)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nspec_rfmin",idims(indim))
     CALL define_var("nmini_bdy","R",indim,idims, &
            "RF minority ion densities at/beyond boundary", &
            "m^-3","FUS","STATE_DATA", &
            "R|units=m^-3  nmini_bdy(nspec_rfmin)")
  ENDIF

  IF(ALLOCATED(ss%nmodel)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_anomth",idims(indim))
     CALL define_var("nmodel","R",indim,idims, &
            "target density profile", &
            "m^-3","ANOM","STATE_PROFILES", &
            "R|units=m^-3|step  nmodel(~nrho_anomth)")
  ENDIF

  indim = 0
  CALL define_var("nmodel_bdy","R",indim,idims, &
         "model density, boundary value", &
         "m^-3","ANOM","STATE_DATA", &
         "R|units=m^-3   nmodel_bdy")

  indim = 0
  CALL define_var("nmom","I",indim,idims, &
         "number of Fourier (R,Z) moments", &
         "__NONE","EQ","SIMULATION_INIT", &
         "I  nmom = 16")

  IF(ALLOCATED(ss%nnkparlh)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_max_nspectrumlh_src",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nlhrf_src",idims(indim))
     CALL define_var("nnkparlh","I",indim,idims, &
            "need description", &
            "__NONE","LH","SHOT_CONFIGURATION", &
            "I nnkparlh(nspectrumlh_src(),nlhrf_src)")
  ENDIF

  IF(ALLOCATED(ss%nnkpollh)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_max_nspectrumlh_src",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nlhrf_src",idims(indim))
     CALL define_var("nnkpollh","I",indim,idims, &
            "need description", &
            "__NONE","LH","SHOT_CONFIGURATION", &
            "I nnkpollh(nspectrumlh_src(),nlhrf_src)")
  ENDIF

  IF(ALLOCATED(ss%nnktorlh)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_max_nspectrumlh_src",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nlhrf_src",idims(indim))
     CALL define_var("nnktorlh","I",indim,idims, &
            "need description", &
            "__NONE","LH","SHOT_CONFIGURATION", &
            "I nnktorlh(nspectrumlh_src(),nlhrf_src)")
  ENDIF

  IF(ALLOCATED(ss%nphi)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_max_num_nphi",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nicrf_src",idims(indim))
     CALL define_var("nphi","I",indim,idims, &
            "n_phi wave spectrum from antenna", &
            "__NONE","IC","SHOT_CONFIGURATION", &
            "I nphi(num_nphi(),nicrf_src)")
  ENDIF

  IF(ALLOCATED(ss%nrw)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_rw",idims(indim))
     CALL define_var("nrw","R",indim,idims, &
            "runaway electron density", &
            "m^-3","RUNAWAY","STATE_PROFILES", &
            "R|units=m^-3|step   nrw(~nrho_rw)")
  ENDIF

  IF(ALLOCATED(ss%nrz_antgeo)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nicrf_src",idims(indim))
     CALL define_var("nrz_antgeo","I",indim,idims, &
            "number of (R,Z) points, antenna geometries", &
            "__NONE","IC","MACHINE_DESCRIPTION", &
            "I|ENUM nrz_antgeo(nicrf_src)")
  ENDIF

  IF(ALLOCATED(ss%ns)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dp1_nspec_th",idims(indim))
     CALL define_var("ns","R",indim,idims, &
            "thermal specie density", &
            "m^-3","PLASMA","STATE_PROFILES", &
            "R|units=m^-3|alias=n|step  ns(~nrho,0:nspec_th)")
  ENDIF

  IF(ALLOCATED(ss%nspectrumlh_src)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nlhrf_src",idims(indim))
     CALL define_var("nspectrumlh_src","I",indim,idims, &
            "number of spectrum peaks", &
            "__NONE","LH","SHOT_CONFIGURATION", &
            "I|ENUM nspectrumlh_src(nlhrf_src)")
  ENDIF

  IF(ALLOCATED(ss%ns_bdy)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dp1_nspec_th",idims(indim))
     CALL define_var("ns_bdy","R",indim,idims, &
            "specie densities at/beyond boundary", &
            "m^-3","PLASMA","STATE_DATA", &
            "R|units=m^-3 ns_bdy(0:nspec_th)")
  ENDIF

  indim = 1
  status = nf90_inq_dimid(icdf,"ps_clen_80",idims(1))
  CALL define_var("ns_Data_Info","C*80",indim,idims, &
         "information on source of Density data", &
         "__NONE","PLASMA","SIMULATION_INIT", &
         "C*80   ns_Data_Info")

  IF(ALLOCATED(ss%ns_is_input)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dp1_nspec_th",idims(indim))
     CALL define_var("ns_is_input","I",indim,idims, &
            "specie density measurement flag", &
            "__NONE","PLASMA","STATE_DATA", &
            "I ns_is_input(0:nspec_th)")
  ENDIF

  indim = 0
  CALL define_var("ntf_coil2","I",indim,idims, &
         "number of TF coils involved in inducing 2nd component", &
         "__NONE","RIPPLE","MACHINE_DESCRIPTION", &
         "I ntf_coil2")

  CONTAINS


     SUBROUTINE define_var(name,dtype,indim,idims, &
          long_name,units,component,section,spec)

        CHARACTER*(*), INTENT(in) :: name
        CHARACTER*(*), INTENT(in) :: dtype
        INTEGER, INTENT(in) :: indim
        INTEGER, dimension(:), INTENT(in) :: idims
        CHARACTER*(*), INTENT(in) :: long_name
        CHARACTER*(*), INTENT(in) :: units
        CHARACTER*(*), INTENT(in) :: component
        CHARACTER*(*), INTENT(in) :: section
        CHARACTER*(*), INTENT(in) :: spec

        integer :: itype

        IF(dtype.EQ.'R') THEN
           itype = NF90_DOUBLE

        ELSE IF (dtype.EQ.'I') THEN
           itype = NF90_INT

        ELSE
           itype = NF90_CHAR

        ENDIF

        IF(indim.EQ.0) THEN
           status=nf90_def_var(icdf,name,itype, varid=varid)

        ELSE
           status=nf90_def_var(icdf,name,itype, dimids=idims(1:indim),varid=varid)

        ENDIF

        IF(status.NE.NF90_NOERR) THEN
           WRITE(iout,*) " ?plasma_state_store: error defining variable: "//trim(name)
           CALL ncerr(status)
           iertot = iertot + 1
           RETURN
        ENDIF

        ! Variable OK, now add attributes:

        CALL add_attrib("long_name",long_name)
        IF(dtype.EQ.'R') CALL add_attrib("units",units)
        CALL add_attrib("component",component)
        CALL add_attrib("section",section)
        CALL add_attrib("specification",spec)

     END SUBROUTINE define_var

     SUBROUTINE add_attrib(name,value)
        CHARACTER*(*), intent(in) :: name
        CHARACTER*(*), intent(in) :: value

        status=nf90_put_att(icdf,varid,name,value)
        IF(status.NE.NF90_NOERR) THEN
           WRITE(iout,*) " ?plasma_state_store: error defining attribute: "//trim(name)//' = '//trim(value)
           CALL ncerr(status)
           iertot = iertot + 1
        ENDIF
     END SUBROUTINE add_attrib

     SUBROUTINE ncerr(status)
        INTEGER, INTENT(in) :: status

        nc_errmsg = NF90_strerror(status)
        write(iout,*) '  NetCDF message: ',trim(nc_errmsg)
     END SUBROUTINE ncerr

END SUBROUTINE plasma_state_store_def_4


SUBROUTINE plasma_state_store_4(ss,icdf,iout,iertot)


  !  write subset of variables and arrays from NetCDF file

  USE plasma_state_definition_mod
  USE netcdf
  IMPLICIT NONE

  TYPE (plasma_state) :: ss     ! state data to read
  INTEGER, INTENT(IN) :: icdf   ! NetCDF file ID
  INTEGER, INTENT(IN) :: iout   ! message LUN
  INTEGER, INTENT(INOUT) :: iertot  ! error count

  !--------------

  INTEGER :: varid,dimid,status,ival,idims(20),indim
  CHARACTER*80 :: nc_errmsg

  !--------------
  !  write variables...


  status = nf90_inq_varid(icdf,"NBI_Data_Info",varid)
  status = nf90_put_var(icdf,varid,ss%NBI_Data_Info)
  IF(status.NE.NF90_NOERR) THEN
     WRITE(iout,*) " ?plasma_state_store: error storing: NBI_Data_Info"
     CALL ncerr(status)
     iertot = iertot + 1
  ENDIF

  IF(ALLOCATED(ss%nbi_src_name)) THEN
     status = nf90_inq_varid(icdf,"nbi_src_name",varid)
     status = nf90_put_var(icdf,varid,ss%nbi_src_name)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: nbi_src_name"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%nbshape)) THEN
     status = nf90_inq_varid(icdf,"nbshape",varid)
     status = nf90_put_var(icdf,varid,ss%nbshape)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: nbshape"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"nebar",varid)
  status = nf90_put_var(icdf,varid,ss%nebar)
  IF(status.NE.NF90_NOERR) THEN
     WRITE(iout,*) " ?plasma_state_store: error storing: nebar"
     CALL ncerr(status)
     iertot = iertot + 1
  ENDIF

  IF(ALLOCATED(ss%neflux_ky_tglf)) THEN
     status = nf90_inq_varid(icdf,"neflux_ky_tglf",varid)
     status = nf90_put_var(icdf,varid,ss%neflux_ky_tglf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: neflux_ky_tglf"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%Newcomb_code)) THEN
     status = nf90_inq_varid(icdf,"Newcomb_code",varid)
     status = nf90_put_var(icdf,varid,ss%Newcomb_code)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: Newcomb_code"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%Newcomb_mapper)) THEN
     status = nf90_inq_varid(icdf,"Newcomb_mapper",varid)
     status = nf90_put_var(icdf,varid,ss%Newcomb_mapper)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: Newcomb_mapper"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%Newcomb_stable)) THEN
     status = nf90_inq_varid(icdf,"Newcomb_stable",varid)
     status = nf90_put_var(icdf,varid,ss%Newcomb_stable)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: Newcomb_stable"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%Newcomb_status)) THEN
     status = nf90_inq_varid(icdf,"Newcomb_status",varid)
     status = nf90_put_var(icdf,varid,ss%Newcomb_status)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: Newcomb_status"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%ne_ky_tglf)) THEN
     status = nf90_inq_varid(icdf,"ne_ky_tglf",varid)
     status = nf90_put_var(icdf,varid,ss%ne_ky_tglf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: ne_ky_tglf"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%nfusi)) THEN
     status = nf90_inq_varid(icdf,"nfusi",varid)
     status = nf90_put_var(icdf,varid,ss%nfusi)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: nfusi"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%nfusi_bdy)) THEN
     status = nf90_inq_varid(icdf,"nfusi_bdy",varid)
     status = nf90_put_var(icdf,varid,ss%nfusi_bdy)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: nfusi_bdy"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%ngradb2_av)) THEN
     status = nf90_inq_varid(icdf,"ngradb2_av",varid)
     status = nf90_put_var(icdf,varid,ss%ngradb2_av)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: ngradb2_av"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%ni)) THEN
     status = nf90_inq_varid(icdf,"ni",varid)
     status = nf90_put_var(icdf,varid,ss%ni)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: ni"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%niflux_ky_tglf)) THEN
     status = nf90_inq_varid(icdf,"niflux_ky_tglf",varid)
     status = nf90_put_var(icdf,varid,ss%niflux_ky_tglf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: niflux_ky_tglf"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%ni_ky_tglf)) THEN
     status = nf90_inq_varid(icdf,"ni_ky_tglf",varid)
     status = nf90_put_var(icdf,varid,ss%ni_ky_tglf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: ni_ky_tglf"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"nmdifb",varid)
  status = nf90_put_var(icdf,varid,ss%nmdifb)
  IF(status.NE.NF90_NOERR) THEN
     WRITE(iout,*) " ?plasma_state_store: error storing: nmdifb"
     CALL ncerr(status)
     iertot = iertot + 1
  ENDIF

  IF(ALLOCATED(ss%nmini)) THEN
     status = nf90_inq_varid(icdf,"nmini",varid)
     status = nf90_put_var(icdf,varid,ss%nmini)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: nmini"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%nmini_bdy)) THEN
     status = nf90_inq_varid(icdf,"nmini_bdy",varid)
     status = nf90_put_var(icdf,varid,ss%nmini_bdy)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: nmini_bdy"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%nmodel)) THEN
     status = nf90_inq_varid(icdf,"nmodel",varid)
     status = nf90_put_var(icdf,varid,ss%nmodel)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: nmodel"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"nmodel_bdy",varid)
  status = nf90_put_var(icdf,varid,ss%nmodel_bdy)
  IF(status.NE.NF90_NOERR) THEN
     WRITE(iout,*) " ?plasma_state_store: error storing: nmodel_bdy"
     CALL ncerr(status)
     iertot = iertot + 1
  ENDIF

  status = nf90_inq_varid(icdf,"nmom",varid)
  status = nf90_put_var(icdf,varid,ss%nmom)
  IF(status.NE.NF90_NOERR) THEN
     WRITE(iout,*) " ?plasma_state_store: error storing: nmom"
     CALL ncerr(status)
     iertot = iertot + 1
  ENDIF

  IF(ALLOCATED(ss%nnkparlh)) THEN
     status = nf90_inq_varid(icdf,"nnkparlh",varid)
     status = nf90_put_var(icdf,varid,ss%nnkparlh)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: nnkparlh"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%nnkpollh)) THEN
     status = nf90_inq_varid(icdf,"nnkpollh",varid)
     status = nf90_put_var(icdf,varid,ss%nnkpollh)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: nnkpollh"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%nnktorlh)) THEN
     status = nf90_inq_varid(icdf,"nnktorlh",varid)
     status = nf90_put_var(icdf,varid,ss%nnktorlh)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: nnktorlh"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%nphi)) THEN
     status = nf90_inq_varid(icdf,"nphi",varid)
     status = nf90_put_var(icdf,varid,ss%nphi)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: nphi"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%nrw)) THEN
     status = nf90_inq_varid(icdf,"nrw",varid)
     status = nf90_put_var(icdf,varid,ss%nrw)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: nrw"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%nrz_antgeo)) THEN
     status = nf90_inq_varid(icdf,"nrz_antgeo",varid)
     status = nf90_put_var(icdf,varid,ss%nrz_antgeo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: nrz_antgeo"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%ns)) THEN
     status = nf90_inq_varid(icdf,"ns",varid)
     status = nf90_put_var(icdf,varid,ss%ns)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: ns"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%nspectrumlh_src)) THEN
     status = nf90_inq_varid(icdf,"nspectrumlh_src",varid)
     status = nf90_put_var(icdf,varid,ss%nspectrumlh_src)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: nspectrumlh_src"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%ns_bdy)) THEN
     status = nf90_inq_varid(icdf,"ns_bdy",varid)
     status = nf90_put_var(icdf,varid,ss%ns_bdy)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: ns_bdy"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"ns_Data_Info",varid)
  status = nf90_put_var(icdf,varid,ss%ns_Data_Info)
  IF(status.NE.NF90_NOERR) THEN
     WRITE(iout,*) " ?plasma_state_store: error storing: ns_Data_Info"
     CALL ncerr(status)
     iertot = iertot + 1
  ENDIF

  IF(ALLOCATED(ss%ns_is_input)) THEN
     status = nf90_inq_varid(icdf,"ns_is_input",varid)
     status = nf90_put_var(icdf,varid,ss%ns_is_input)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: ns_is_input"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"ntf_coil2",varid)
  status = nf90_put_var(icdf,varid,ss%ntf_coil2)
  IF(status.NE.NF90_NOERR) THEN
     WRITE(iout,*) " ?plasma_state_store: error storing: ntf_coil2"
     CALL ncerr(status)
     iertot = iertot + 1
  ENDIF

  CONTAINS


     SUBROUTINE ncerr(status)
        INTEGER, INTENT(in) :: status

        nc_errmsg = NF90_strerror(status)
        write(iout,*) '  NetCDF message: ',trim(nc_errmsg)
     END SUBROUTINE ncerr

END SUBROUTINE plasma_state_store_4

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


SUBROUTINE ps_update_file_write_def_9(ss,icdf,cclist,nids,iout,iwarn,iertot)


  ! Define updated data

  USE plasma_state_definition_mod
  USE netcdf
  USE ps_nidlist_defn
  IMPLICIT NONE

  TYPE (plasma_state) :: ss  ! state containing array elements to be allocated
  INTEGER, INTENT(IN) :: icdf  ! NetCDF file ID
  INTEGER, INTENT(IN) :: cclist(ps_ccount)  ! component selection
  TYPE (nidlist) :: nids       ! defined dimensions list
  INTEGER, INTENT(IN) :: iout  ! LUN for messages
  INTEGER, INTENT(INOUT) :: iwarn   ! warn count
  INTEGER, INTENT(INOUT) :: iertot  ! error count

  !-------------------
  LOGICAL :: plasma_state_hash_match,ichange

  INTEGER :: varid,pvarid,vvarid,dimid,status,iertmp,iaddr
  INTEGER :: idims(20),indim,ival,ii,ierr
  CHARACTER*80 :: nc_errmsg

  !-------------------

  ierr = 0   ! local

  iaddr = ps_phash_velte_mmm71
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%velte_mmm71).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("velte_mmm71","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        CALL define_var("velte_mmm71","R",indim,idims, &
               "Te-equation, advective velocity term from MMM71 model", &
               "m/sec","ANOM","STATE_PROFILES", &
               "R|units=m/sec|pclin  velte_mmm71(nrho_anomth)")
     ENDIF
  ENDIF

  iaddr = ps_phash_velte_nclass
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%velte_nclass).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("velte_nclass","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        CALL define_var("velte_nclass","R",indim,idims, &
               "Te-equation, advective velocity term from NCLASS model", &
               "m/sec","ANOM","STATE_PROFILES", &
               "R|units=m/sec|pclin velte_nclass(nrho_anomth)")
     ENDIF
  ENDIF

  iaddr = ps_phash_velte_neo
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%velte_neo).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("velte_neo","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        CALL define_var("velte_neo","R",indim,idims, &
               "Te-equation, advective velocity term from NEO model", &
               "m/sec","ANOM","STATE_PROFILES", &
               "R|units=m/sec|pclin  velte_neo(nrho_anomth)")
     ENDIF
  ENDIF

  iaddr = ps_phash_velte_paleo
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%velte_paleo).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("velte_paleo","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        CALL define_var("velte_paleo","R",indim,idims, &
               "Te-equation, convection term from PALEO model", &
               "m/sec","ANOM","STATE_PROFILES", &
               "R|units=m/sec|pclin   velte_paleo(nrho_anomth)")
     ENDIF
  ENDIF

  iaddr = ps_phash_velte_tglf
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%velte_tglf).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("velte_tglf","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        CALL define_var("velte_tglf","R",indim,idims, &
               "Te-equation, advective velocity term from TGLF model", &
               "m/sec","ANOM","STATE_PROFILES", &
               "R|units=m/sec|pclin velte_tglf(nrho_anomth)")
     ENDIF
  ENDIF

  iaddr = ps_phash_velti_anom
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%velti_anom).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("velti_anom","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        CALL define_var("velti_anom","R",indim,idims, &
               "Ti-equation, advective velocity term", &
               "m/sec","ANOM","STATE_PROFILES", &
               "R|units=m/sec|pclin  velti_anom(nrho_anomth)")
     ENDIF
  ENDIF

  iaddr = ps_phash_velti_glf
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%velti_glf).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("velti_glf","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        CALL define_var("velti_glf","R",indim,idims, &
               "Ti-equation, advective velocity term from GLF23 model", &
               "m/sec","ANOM","STATE_PROFILES", &
               "R|units=m/sec|pclin  velti_glf(nrho_anomth)")
     ENDIF
  ENDIF

  iaddr = ps_phash_velti_gtcneo
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%velti_gtcneo).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("velti_gtcneo","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        CALL define_var("velti_gtcneo","R",indim,idims, &
               "Ti-equation, advective velocity term from GTC_NEO model", &
               "m/sec","ANOM","STATE_PROFILES", &
               "R|units=m/sec|pclin  velti_gtcneo(nrho_anomth)")
     ENDIF
  ENDIF

  iaddr = ps_phash_velti_mmm71
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%velti_mmm71).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("velti_mmm71","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        CALL define_var("velti_mmm71","R",indim,idims, &
               "Ti-equation, advective velocity term from MMM71 model", &
               "m/sec","ANOM","STATE_PROFILES", &
               "R|units=m/sec|pclin  velti_mmm71(nrho_anomth)")
     ENDIF
  ENDIF

  iaddr = ps_phash_velti_nclass
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%velti_nclass).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("velti_nclass","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        CALL define_var("velti_nclass","R",indim,idims, &
               "Ti-equation, advective velocity term from NCLASS model", &
               "m/sec","ANOM","STATE_PROFILES", &
               "R|units=m/sec|pclin velti_nclass(nrho_anomth)")
     ENDIF
  ENDIF

  iaddr = ps_phash_velti_neo
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%velti_neo).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("velti_neo","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        CALL define_var("velti_neo","R",indim,idims, &
               "Ti-equation, advective velocity term from NEO model", &
               "m/sec","ANOM","STATE_PROFILES", &
               "R|units=m/sec|pclin  velti_neo(nrho_anomth)")
     ENDIF
  ENDIF

  iaddr = ps_phash_velti_tglf
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%velti_tglf).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("velti_tglf","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        CALL define_var("velti_tglf","R",indim,idims, &
               "Ti-equation, advective velocity term from TGLF model", &
               "m/sec","ANOM","STATE_PROFILES", &
               "R|units=m/sec|pclin velti_tglf(nrho_anomth)")
     ENDIF
  ENDIF

  iaddr = ps_phash_vie_trans
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%vie_trans).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("vie_trans","PLASMA")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho,"dim_nrho",ss%nrho)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho
        CALL define_var("vie_trans","R",indim,idims, &
               "ion energy radial velocity", &
               "m/sec","PLASMA","STATE_PROFILES", &
               "R|pclin   vie_trans(nrho)")
     ENDIF
  ENDIF

  iaddr = ps_phash_vie_transcat
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%vie_transcat).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("vie_transcat","PLASMA")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho,"dim_nrho",ss%nrho)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho
        IF(nids%nid_dim_ntrcat.EQ.0) THEN
           CALL define_dim(nids%nid_dim_ntrcat,"dim_ntrcat",ss%ntrcat)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_ntrcat
        CALL define_var("vie_transcat","R",indim,idims, &
               "Ion energy radial velocity", &
               "m/sec","PLASMA","STATE_PROFILES", &
               "R|units=m/sec|pclin vie_transcat(nrho,ntrcat)")
     ENDIF
  ENDIF

  iaddr = ps_phash_vmo_trans
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%vmo_trans).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("vmo_trans","PLASMA")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho,"dim_nrho",ss%nrho)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho
        CALL define_var("vmo_trans","R",indim,idims, &
               "angular momentum radial velocity", &
               "m/sec","PLASMA","STATE_PROFILES", &
               "R|pclin   vmo_trans(nrho)")
     ENDIF
  ENDIF

  iaddr = ps_phash_vmo_transcat
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%vmo_transcat).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("vmo_transcat","PLASMA")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho,"dim_nrho",ss%nrho)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho
        IF(nids%nid_dim_ntrcat.EQ.0) THEN
           CALL define_dim(nids%nid_dim_ntrcat,"dim_ntrcat",ss%ntrcat)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_ntrcat
        CALL define_var("vmo_transcat","R",indim,idims, &
               "Angular momentum radial velocity", &
               "m/sec","PLASMA","STATE_PROFILES", &
               "R|units=m/sec|pclin vmo_transcat(nrho,ntrcat)")
     ENDIF
  ENDIF

  iaddr = ps_phash_vn_trans
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%vn_trans).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("vn_trans","PLASMA")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho,"dim_nrho",ss%nrho)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho
        IF(nids%nid_dp1_nspec_th.EQ.0) THEN
           CALL define_dim(nids%nid_dp1_nspec_th,"dp1_nspec_th",ss%nspec_th+1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dp1_nspec_th
        CALL define_var("vn_trans","R",indim,idims, &
               "specie radial velocity", &
               "m/sec","PLASMA","STATE_PROFILES", &
               "R|units=m/sec|pclin   vn_trans(nrho,0:nspec_th)")
     ENDIF
  ENDIF

  iaddr = ps_phash_vn_transcat
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%vn_transcat).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("vn_transcat","PLASMA")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho,"dim_nrho",ss%nrho)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho
        IF(nids%nid_dp1_nspec_th.EQ.0) THEN
           CALL define_dim(nids%nid_dp1_nspec_th,"dp1_nspec_th",ss%nspec_th+1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dp1_nspec_th
        IF(nids%nid_dim_ntrcat.EQ.0) THEN
           CALL define_dim(nids%nid_dim_ntrcat,"dim_ntrcat",ss%ntrcat)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_ntrcat
        CALL define_var("vn_transcat","R",indim,idims, &
               "specie radial velocity", &
               "m/sec","PLASMA","STATE_PROFILES", &
               "R|units=m/sec|pclin vn_transcat(nrho,0:nspec_th,ntrcat)")
     ENDIF
  ENDIF

  iaddr = ps_phash_vol
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%vol).AND.ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("vol","EQ")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_eq.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_eq,"dim_nrho_eq",ss%nrho_eq)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_eq
        CALL define_var("vol","R",indim,idims, &
               "enclosed volume", &
               "m^3","EQ","STATE_PROFILES", &
               "R|units=m^3|Spline_00  vol(nrho_eq)")
     ENDIF
  ENDIF

  iaddr = ps_shash_vphi0_av
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%vphi0_av).AND.ichange) THEN
     IF(cclist(ps_cnum_GAS).NE.1) THEN
        CALL ccwarn("vphi0_av","GAS")
     ELSE
        indim = 0
        IF(nids%nid_dim_ngsc0.EQ.0) THEN
           CALL define_dim(nids%nid_dim_ngsc0,"dim_ngsc0",ss%ngsc0)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_ngsc0
        CALL define_var("vphi0_av","R",indim,idims, &
               "average toroidal velocity of neutral source", &
               "m/sec","GAS","STATE_DATA", &
               "R|units=m/sec vphi0_av(ngsc0)")
     ENDIF
  ENDIF

  iaddr = ps_shash_vpol_Data_Info
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("vpol_Data_Info","PLASMA")
     ELSE
        indim = 1
        idims(1)=nids%nid_clen_80
        CALL define_var("vpol_Data_Info","C*80",indim,idims, &
               "information on source of poloidal velocity data", &
               "__NONE","PLASMA","SIMULATION_INIT", &
               "C*80   vpol_Data_Info")
     ENDIF
  ENDIF

  iaddr = ps_phash_vpol_inmp
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%vpol_inmp).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("vpol_inmp","PLASMA")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho,"dm1_nrho",ss%nrho-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho
        IF(nids%nid_dp1_nspec_th.EQ.0) THEN
           CALL define_dim(nids%nid_dp1_nspec_th,"dp1_nspec_th",ss%nspec_th+1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dp1_nspec_th
        CALL define_var("vpol_inmp","R",indim,idims, &
               "poloidal velocity, inner half midplane", &
               "m/sec","PLASMA","STATE_PROFILES", &
               "R|units=m/sec|step*ns vpol_inmp(~nrho,0:nspec_th)")
     ENDIF
  ENDIF

  iaddr = ps_shash_vpol_is_input
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%vpol_is_input).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("vpol_is_input","PLASMA")
     ELSE
        indim = 0
        IF(nids%nid_dp1_nspec_th.EQ.0) THEN
           CALL define_dim(nids%nid_dp1_nspec_th,"dp1_nspec_th",ss%nspec_th+1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dp1_nspec_th
        CALL define_var("vpol_is_input","I",indim,idims, &
               "specie outer midplane poloidal velocit flag", &
               "__NONE","PLASMA","STATE_DATA", &
               "I vpol_is_input(0:nspec_th)")
     ENDIF
  ENDIF

  iaddr = ps_phash_vpol_omp
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%vpol_omp).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("vpol_omp","PLASMA")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho,"dm1_nrho",ss%nrho-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho
        IF(nids%nid_dp1_nspec_th.EQ.0) THEN
           CALL define_dim(nids%nid_dp1_nspec_th,"dp1_nspec_th",ss%nspec_th+1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dp1_nspec_th
        CALL define_var("vpol_omp","R",indim,idims, &
               "poloidal velocity, outer half midplane", &
               "m/sec","PLASMA","STATE_PROFILES", &
               "R|units=m/sec|step*ns vpol_omp(~nrho,0:nspec_th)")
     ENDIF
  ENDIF

  iaddr = ps_shash_VRep_coil_count
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%VRep_coil_count).AND.ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("VRep_coil_count","EQ")
     ELSE
        indim = 0
        IF(nids%nid_dim_ncoils.EQ.0) THEN
           CALL define_dim(nids%nid_dim_ncoils,"dim_ncoils",ss%ncoils)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_ncoils
        CALL define_var("VRep_coil_count","I",indim,idims, &
               "replication count, vertical coil stack", &
               "__NONE","EQ","MACHINE_DESCRIPTION", &
               "I  VRep_coil_count(ncoils)")
     ENDIF
  ENDIF

  iaddr = ps_shash_Vrep_coil_spacing
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%Vrep_coil_spacing).AND.ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("Vrep_coil_spacing","EQ")
     ELSE
        indim = 0
        IF(nids%nid_dim_ncoils.EQ.0) THEN
           CALL define_dim(nids%nid_dim_ncoils,"dim_ncoils",ss%ncoils)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_ncoils
        CALL define_var("Vrep_coil_spacing","R",indim,idims, &
               "replicated coil separation", &
               "m","EQ","MACHINE_DESCRIPTION", &
               "R|units=m Vrep_coil_spacing(ncoils)")
     ENDIF
  ENDIF

  iaddr = ps_shash_Vsize_coil
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%Vsize_coil).AND.ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("Vsize_coil","EQ")
     ELSE
        indim = 0
        IF(nids%nid_dim_ncoils.EQ.0) THEN
           CALL define_dim(nids%nid_dim_ncoils,"dim_ncoils",ss%ncoils)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_ncoils
        CALL define_var("Vsize_coil","R",indim,idims, &
               "(Rotatable) Vertical coil size", &
               "m","EQ","MACHINE_DESCRIPTION", &
               "R|units=m  Vsize_coil(ncoils)")
     ENDIF
  ENDIF

  iaddr = ps_shash_vsur
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("vsur","PLASMA")
     ELSE
        indim = 0
        CALL define_var("vsur","R",indim,idims, &
               "toroidal voltage at surface", &
               "Volts","PLASMA","STATE_DATA", &
               "R  vsur")
     ENDIF
  ENDIF

  iaddr = ps_shash_VSUR_Data_Info
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("VSUR_Data_Info","PLASMA")
     ELSE
        indim = 1
        idims(1)=nids%nid_clen_80
        CALL define_var("VSUR_Data_Info","C*80",indim,idims, &
               "information on source of surface voltage data", &
               "__NONE","PLASMA","SIMULATION_INIT", &
               "C*80   VSUR_Data_Info")
     ENDIF
  ENDIF

  iaddr = ps_shash_vtor_Data_Info
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("vtor_Data_Info","PLASMA")
     ELSE
        indim = 1
        idims(1)=nids%nid_clen_80
        CALL define_var("vtor_Data_Info","C*80",indim,idims, &
               "information on source of toroidal velocity data", &
               "__NONE","PLASMA","SIMULATION_INIT", &
               "C*80   vtor_Data_Info")
     ENDIF
  ENDIF

  iaddr = ps_phash_vtor_inmp
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%vtor_inmp).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("vtor_inmp","PLASMA")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho,"dm1_nrho",ss%nrho-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho
        IF(nids%nid_dp1_nspec_th.EQ.0) THEN
           CALL define_dim(nids%nid_dp1_nspec_th,"dp1_nspec_th",ss%nspec_th+1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dp1_nspec_th
        CALL define_var("vtor_inmp","R",indim,idims, &
               "toroidal velocity, inner half midplane", &
               "m/sec","PLASMA","STATE_PROFILES", &
               "R|units=m/sec|step*ns vtor_inmp(~nrho,0:nspec_th)")
     ENDIF
  ENDIF

  iaddr = ps_shash_vtor_is_input
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%vtor_is_input).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("vtor_is_input","PLASMA")
     ELSE
        indim = 0
        IF(nids%nid_dp1_nspec_th.EQ.0) THEN
           CALL define_dim(nids%nid_dp1_nspec_th,"dp1_nspec_th",ss%nspec_th+1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dp1_nspec_th
        CALL define_var("vtor_is_input","I",indim,idims, &
               "specie outer midplane toroidal velocit flag", &
               "__NONE","PLASMA","STATE_DATA", &
               "I vtor_is_input(0:nspec_th)")
     ENDIF
  ENDIF

  iaddr = ps_phash_vtor_omp
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%vtor_omp).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("vtor_omp","PLASMA")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho,"dm1_nrho",ss%nrho-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho
        IF(nids%nid_dp1_nspec_th.EQ.0) THEN
           CALL define_dim(nids%nid_dp1_nspec_th,"dp1_nspec_th",ss%nspec_th+1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dp1_nspec_th
        CALL define_var("vtor_omp","R",indim,idims, &
               "toroidal velocity, outer half midplane", &
               "m/sec","PLASMA","STATE_PROFILES", &
               "R|units=m/sec|step*ns vtor_omp(~nrho,0:nspec_th)")
     ENDIF
  ENDIF

  iaddr = ps_phash_V_loop
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%V_loop).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("V_loop","PLASMA")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho,"dim_nrho",ss%nrho)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho
        CALL define_var("V_loop","R",indim,idims, &
               "loop voltage", &
               "Volts","PLASMA","STATE_PROFILES", &
               "R|units=Volts|pclin	V_loop(nrho)")
     ENDIF
  ENDIF

  iaddr = ps_phash_v_pars
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%v_pars).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("v_pars","PLASMA")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho,"dm1_nrho",ss%nrho-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho
        IF(nids%nid_dp1_nspec_th.EQ.0) THEN
           CALL define_dim(nids%nid_dp1_nspec_th,"dp1_nspec_th",ss%nspec_th+1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dp1_nspec_th
        CALL define_var("v_pars","R",indim,idims, &
               "thermal specie <vpll>", &
               "m/sec","PLASMA","STATE_PROFILES", &
               "R|units=m/sec|alias=vpll_|step*ns v_pars(~nrho,0:nspec_th)")
     ENDIF
  ENDIF

  iaddr = ps_phash_v_pers
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%v_pers).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("v_pers","PLASMA")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho,"dm1_nrho",ss%nrho-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho
        IF(nids%nid_dp1_nspec_th.EQ.0) THEN
           CALL define_dim(nids%nid_dp1_nspec_th,"dp1_nspec_th",ss%nspec_th+1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dp1_nspec_th
        CALL define_var("v_pers","R",indim,idims, &
               "thermal specie <vper>", &
               "m/sec","PLASMA","STATE_PROFILES", &
               "R|units=m/sec|alias=vper_|step*ns v_pers(~nrho,0:nspec_th)")
     ENDIF
  ENDIF

  iaddr = ps_shash_wt_nphi
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%wt_nphi).AND.ichange) THEN
     IF(cclist(ps_cnum_IC).NE.1) THEN
        CALL ccwarn("wt_nphi","IC")
     ELSE
        indim = 0
        IF(nids%nid_dim_max_num_nphi.EQ.0) THEN
           CALL define_dim(nids%nid_dim_max_num_nphi,"dim_max_num_nphi",ss%max_num_nphi)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_max_num_nphi
        IF(nids%nid_dim_nicrf_src.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nicrf_src,"dim_nicrf_src",ss%nicrf_src)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nicrf_src
        CALL define_var("wt_nphi","R",indim,idims, &
               "vacuum spectrum n_phi weight", &
               "-","IC","SHOT_CONFIGURATION", &
               "R|units=- wt_nphi(num_nphi(),nicrf_src)")
     ENDIF
  ENDIF

  iaddr = ps_shash_wt_nphi_abs
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%wt_nphi_abs).AND.ichange) THEN
     IF(cclist(ps_cnum_IC).NE.1) THEN
        CALL ccwarn("wt_nphi_abs","IC")
     ELSE
        indim = 0
        IF(nids%nid_dim_max_num_nphi.EQ.0) THEN
           CALL define_dim(nids%nid_dim_max_num_nphi,"dim_max_num_nphi",ss%max_num_nphi)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_max_num_nphi
        IF(nids%nid_dim_nicrf_src.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nicrf_src,"dim_nicrf_src",ss%nicrf_src)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nicrf_src
        CALL define_var("wt_nphi_abs","R",indim,idims, &
               "absorbed spectrum n_phi weight", &
               "-","IC","STATE_DATA", &
               "R|units=- wt_nphi_abs(num_nphi(),nicrf_src)")
     ENDIF
  ENDIF

  iaddr = ps_shash_wt_nphi_ext
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%wt_nphi_ext).AND.ichange) THEN
     IF(cclist(ps_cnum_IC).NE.1) THEN
        CALL ccwarn("wt_nphi_ext","IC")
     ELSE
        indim = 0
        IF(nids%nid_dim_max_num_nphi.EQ.0) THEN
           CALL define_dim(nids%nid_dim_max_num_nphi,"dim_max_num_nphi",ss%max_num_nphi)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_max_num_nphi
        IF(nids%nid_dim_nicrf_src.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nicrf_src,"dim_nicrf_src",ss%nicrf_src)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nicrf_src
        CALL define_var("wt_nphi_ext","R",indim,idims, &
               "fraction of power deposited outside", &
               "-","IC","STATE_DATA", &
               "R|units=- wt_nphi_ext(num_nphi(),nicrf_src)")
     ENDIF
  ENDIF

  iaddr = ps_phash_xRjcos_momeq
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%xRjcos_momeq).AND.ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("xRjcos_momeq","EQ")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_eq.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_eq,"dim_nrho_eq",ss%nrho_eq)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_eq
        IF(nids%nid_dim_neqmom.EQ.0) THEN
           CALL define_dim(nids%nid_dim_neqmom,"dim_neqmom",ss%neqmom)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_neqmom
        CALL define_var("xRjcos_momeq","R",indim,idims, &
               "scaled R cos moments", &
               "m","EQ","STATE_PROFILES", &
               "R|units=m|Hermite_explicit  xRjcos_momeq(nrho_eq,neqmom)")
     ENDIF
  ENDIF

  iaddr = ps_phash_xRjsin_momeq
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%xRjsin_momeq).AND.ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("xRjsin_momeq","EQ")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_eq.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_eq,"dim_nrho_eq",ss%nrho_eq)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_eq
        IF(nids%nid_dim_neqmom.EQ.0) THEN
           CALL define_dim(nids%nid_dim_neqmom,"dim_neqmom",ss%neqmom)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_neqmom
        CALL define_var("xRjsin_momeq","R",indim,idims, &
               "scaled R sin moments", &
               "m","EQ","STATE_PROFILES", &
               "R|units=m|Hermite_explicit  xRjsin_momeq(nrho_eq,neqmom)")
     ENDIF
  ENDIF

  iaddr = ps_shash_xs
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%xs).AND.ichange) THEN
     IF(cclist(ps_cnum_RAD).NE.1) THEN
        CALL ccwarn("xs","RAD")
     ELSE
        indim = 0
        IF(nids%nid_dim_nxs.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nxs,"dim_nxs",ss%nxs)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nxs
        CALL define_var("xs","R",indim,idims, &
               "impurity source magnitude (atoms/sec)", &
               "#/sec","RAD","STATE_DATA", &
               "R|units=#/sec    xs(nxs)")
     ENDIF
  ENDIF

  iaddr = ps_dhash_nxs
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%xs_name).AND.ichange) THEN
     IF(cclist(ps_cnum_RAD).NE.1) THEN
        CALL ccwarn("xs_name","RAD")
     ELSE
        indim = 1
        idims(1)=nids%nid_clen_32
        IF(nids%nid_dim_nxs.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nxs,"dim_nxs",ss%nxs)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nxs
        CALL define_var("xs_name","N",indim,idims, &
               "number & name of impurity sources", &
               "__NONE","RAD","SHOT_CONFIGURATION", &
               "L|impurity_source  xs_name(nxs)")
     ENDIF
  ENDIF

  iaddr = ps_phash_xZjcos_momeq
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%xZjcos_momeq).AND.ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("xZjcos_momeq","EQ")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_eq.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_eq,"dim_nrho_eq",ss%nrho_eq)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_eq
        IF(nids%nid_dim_neqmom.EQ.0) THEN
           CALL define_dim(nids%nid_dim_neqmom,"dim_neqmom",ss%neqmom)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_neqmom
        CALL define_var("xZjcos_momeq","R",indim,idims, &
               "scaled Z cos moments", &
               "m","EQ","STATE_PROFILES", &
               "R|units=m|Hermite_explicit  xZjcos_momeq(nrho_eq,neqmom)")
     ENDIF
  ENDIF

  iaddr = ps_phash_xZjsin_momeq
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%xZjsin_momeq).AND.ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("xZjsin_momeq","EQ")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_eq.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_eq,"dim_nrho_eq",ss%nrho_eq)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_eq
        IF(nids%nid_dim_neqmom.EQ.0) THEN
           CALL define_dim(nids%nid_dim_neqmom,"dim_neqmom",ss%neqmom)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_neqmom
        CALL define_var("xZjsin_momeq","R",indim,idims, &
               "scaled Z sin moments", &
               "m","EQ","STATE_PROFILES", &
               "R|units=m|Hermite_explicit  xZjsin_momeq(nrho_eq,neqmom)")
     ENDIF
  ENDIF

  iaddr = ps_shash_Z0max
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("Z0max","PLASMA")
     ELSE
        indim = 0
        CALL define_var("Z0max","I",indim,idims, &
               "maximum Z of non-impurity species", &
               "__NONE","PLASMA","SIMULATION_INIT", &
               "IS  Z0max = 2")
     ENDIF
  ENDIF

  iaddr = ps_phash_Z0_momeq
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%Z0_momeq).AND.ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("Z0_momeq","EQ")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_eq.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_eq,"dim_nrho_eq",ss%nrho_eq)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_eq
        CALL define_var("Z0_momeq","R",indim,idims, &
               "Z0 of flux surface", &
               "m","EQ","STATE_PROFILES", &
               "R|units=m|Hermite_explicit  Z0_momeq(nrho_eq)")
     ENDIF
  ENDIF

  iaddr = ps_shash_Zbap
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%Zbap).AND.ichange) THEN
     IF(cclist(ps_cnum_NBI).NE.1) THEN
        CALL ccwarn("Zbap","NBI")
     ELSE
        indim = 0
        IF(nids%nid_dim_nbeam.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nbeam,"dim_nbeam",ss%nbeam)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nbeam
        CALL define_var("Zbap","R",indim,idims, &
               "elevation of beam centerline at aperture", &
               "m","NBI","MACHINE_DESCRIPTION", &
               "R|units=m       Zbap(nbeam)")
     ENDIF
  ENDIF

  iaddr = ps_shash_Zbsc
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%Zbsc).AND.ichange) THEN
     IF(cclist(ps_cnum_NBI).NE.1) THEN
        CALL ccwarn("Zbsc","NBI")
     ELSE
        indim = 0
        IF(nids%nid_dim_nbeam.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nbeam,"dim_nbeam",ss%nbeam)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nbeam
        CALL define_var("Zbsc","R",indim,idims, &
               "elevation of beam source", &
               "m","NBI","MACHINE_DESCRIPTION", &
               "R|units=m       Zbsc(nbeam)")
     ENDIF
  ENDIF

  iaddr = ps_phash_Zeff
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%Zeff).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("Zeff","PLASMA")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho,"dm1_nrho",ss%nrho-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho
        CALL define_var("Zeff","R",indim,idims, &
               "Zeff (sum[nj*Zj**2]/ne)", &
               "-","PLASMA","STATE_PROFILES", &
               "R|step*ns(:,ps_elec_index)  Zeff(~nrho)")
     ENDIF
  ENDIF

  iaddr = ps_shash_ZEFF_Data_Info
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("ZEFF_Data_Info","PLASMA")
     ELSE
        indim = 1
        idims(1)=nids%nid_clen_80
        CALL define_var("ZEFF_Data_Info","C*80",indim,idims, &
               "information on source of Zeff data", &
               "__NONE","PLASMA","SIMULATION_INIT", &
               "C*80   ZEFF_Data_Info")
     ENDIF
  ENDIF

  iaddr = ps_phash_Zeff_fi
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%Zeff_fi).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("Zeff_fi","PLASMA")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho,"dm1_nrho",ss%nrho-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho
        CALL define_var("Zeff_fi","R",indim,idims, &
               "Fast ion contribution to Zeff", &
               "-","PLASMA","STATE_PROFILES", &
               "R|step*ns(:,ps_elec_index)  Zeff_fi(~nrho)")
     ENDIF
  ENDIF

  iaddr = ps_phash_Zeff_th
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%Zeff_th).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("Zeff_th","PLASMA")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho,"dm1_nrho",ss%nrho-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho
        CALL define_var("Zeff_th","R",indim,idims, &
               "Thermal ion contribution to Zeff", &
               "-","PLASMA","STATE_PROFILES", &
               "R|step*ns(:,ps_elec_index)  Zeff_th(~nrho)")
     ENDIF
  ENDIF

  iaddr = ps_shash_Zimp1
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("Zimp1","PLASMA")
     ELSE
        indim = 0
        CALL define_var("Zimp1","I",indim,idims, &
               "lower limit on Z of impurity in reduced species list SA;", &
               "__NONE","PLASMA","SIMULATION_INIT", &
               "IS  Zimp1 = 2")
     ENDIF
  ENDIF

  iaddr = ps_shash_Zimp2
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("Zimp2","PLASMA")
     ELSE
        indim = 0
        CALL define_var("Zimp2","I",indim,idims, &
               "upper limit on Z of impurity in SA species list;", &
               "__NONE","PLASMA","SIMULATION_INIT", &
               "IS  Zimp2 = 1000")
     ENDIF
  ENDIF

  iaddr = ps_shash_zlim
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%zlim).AND.ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("zlim","EQ")
     ELSE
        indim = 0
        IF(nids%nid_dim_num_rzlim.EQ.0) THEN
           CALL define_dim(nids%nid_dim_num_rzlim,"dim_num_rzlim",ss%num_rzlim)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_num_rzlim
        CALL define_var("zlim","R",indim,idims, &
               "Z points in closed (R,Z) contour sequence", &
               "m","EQ","MACHINE_DESCRIPTION", &
               "R|units=m  zlim(num_rzlim)")
     ENDIF
  ENDIF

  iaddr = ps_shash_Zloc_coil
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%Zloc_coil).AND.ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("Zloc_coil","EQ")
     ELSE
        indim = 0
        IF(nids%nid_dim_ncoils.EQ.0) THEN
           CALL define_dim(nids%nid_dim_ncoils,"dim_ncoils",ss%ncoils)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_ncoils
        CALL define_var("Zloc_coil","R",indim,idims, &
               "Z location of coil, lower left corner", &
               "m","EQ","MACHINE_DESCRIPTION", &
               "R|units=m  Zloc_coil(ncoils)")
     ENDIF
  ENDIF

  iaddr = ps_shash_Z_ant
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%Z_ant).AND.ichange) THEN
     IF(cclist(ps_cnum_IC).NE.1) THEN
        CALL ccwarn("Z_ant","IC")
     ELSE
        indim = 0
        IF(nids%nid_dim_nicrf_src.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nicrf_src,"dim_nicrf_src",ss%nicrf_src)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nicrf_src
        CALL define_var("Z_ant","R",indim,idims, &
               "height of antenna", &
               "m","IC","SHOT_CONFIGURATION", &
               "R|units=m Z_ant(nicrf_src)")
     ENDIF
  ENDIF

  iaddr = ps_shash_Z_antgeo
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%Z_antgeo).AND.ichange) THEN
     IF(cclist(ps_cnum_IC).NE.1) THEN
        CALL ccwarn("Z_antgeo","IC")
     ELSE
        indim = 0
        IF(nids%nid_dim_max_nrz_antgeo.EQ.0) THEN
           CALL define_dim(nids%nid_dim_max_nrz_antgeo,"dim_max_nrz_antgeo",ss%max_nrz_antgeo)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_max_nrz_antgeo
        IF(nids%nid_dim_nicrf_src.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nicrf_src,"dim_nicrf_src",ss%nicrf_src)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nicrf_src
        CALL define_var("Z_antgeo","R",indim,idims, &
               "antenna geo: Z pts", &
               "m","IC","MACHINE_DESCRIPTION", &
               "R|units=m Z_antgeo(nrz_antgeo(),nicrf_src)")
     ENDIF
  ENDIF

  iaddr = ps_shash_Z_axis
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("Z_axis","EQ")
     ELSE
        indim = 0
        CALL define_var("Z_axis","R",indim,idims, &
               "Z of magnetic axis", &
               "m","EQ","STATE_DATA", &
               "R  Z_axis")
     ENDIF
  ENDIF

  iaddr = ps_shash_Z_EC_launch
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%Z_EC_launch).AND.ichange) THEN
     IF(cclist(ps_cnum_EC).NE.1) THEN
        CALL ccwarn("Z_EC_launch","EC")
     ELSE
        indim = 0
        IF(nids%nid_dim_necrf_src.EQ.0) THEN
           CALL define_dim(nids%nid_dim_necrf_src,"dim_necrf_src",ss%necrf_src)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_necrf_src
        CALL define_var("Z_EC_launch","R",indim,idims, &
               "Z of center of launcher", &
               "m","EC","MACHINE_DESCRIPTION", &
               "R|units=m   Z_EC_launch(necrf_src)")
     ENDIF
  ENDIF

  iaddr = ps_phash_Z_geo
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%Z_geo).AND.ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("Z_geo","EQ")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_eq.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_eq,"dim_nrho_eq",ss%nrho_eq)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_eq
        IF(nids%nid_dim_nth_eq.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nth_eq,"dim_nth_eq",ss%nth_eq)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nth_eq
        CALL define_var("Z_geo","R",indim,idims, &
               "flux surfaces Z(rho,theta)", &
               "m","EQ","STATE_PROFILES", &
               "R|units=m|Hermite_explicit Z_geo(nrho_eq,nth_eq)")
     ENDIF
  ENDIF

  iaddr = ps_dhash_nz
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%Z_grid).AND.ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("Z_grid","EQ")
     ELSE
        indim = 0
        IF(nids%nid_dim_nz.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nz,"dim_nz",ss%nz)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nz
        CALL define_var("Z_grid","R",indim,idims, &
               "Z grid", &
               "m","EQ","SIMULATION_INIT", &
               "G   Z_grid(nZ)")
     ENDIF
  ENDIF

  iaddr = ps_shash_Z_max_box
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("Z_max_box","EQ")
     ELSE
        indim = 0
        CALL define_var("Z_max_box","R",indim,idims, &
               "Z_max of bounding box", &
               "m","EQ","MACHINE_DESCRIPTION", &
               "R  Z_max_box")
     ENDIF
  ENDIF

  iaddr = ps_shash_Z_max_lcfs
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("Z_max_lcfs","EQ")
     ELSE
        indim = 0
        CALL define_var("Z_max_lcfs","R",indim,idims, &
               "Z_max of last closed flux surface", &
               "m","EQ","STATE_DATA", &
               "R  Z_max_lcfs")
     ENDIF
  ENDIF

  iaddr = ps_phash_Z_midp
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%Z_midp).AND.ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("Z_midp","EQ")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_eq_geo.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_eq_geo,"dim_nrho_eq_geo",ss%nrho_eq_geo)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_eq_geo
        CALL define_var("Z_midp","R",indim,idims, &
               "flux surface midplane elevation", &
               "m","EQ","STATE_PROFILES", &
               "R|pclin  Z_midp(nrho_eq_geo)")
     ENDIF
  ENDIF

  iaddr = ps_shash_Z_mid_ant
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%Z_mid_ant).AND.ichange) THEN
     IF(cclist(ps_cnum_IC).NE.1) THEN
        CALL ccwarn("Z_mid_ant","IC")
     ELSE
        indim = 0
        IF(nids%nid_dim_nicrf_src.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nicrf_src,"dim_nicrf_src",ss%nicrf_src)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nicrf_src
        CALL define_var("Z_mid_ant","R",indim,idims, &
               "center of antenna relative to TF coil midplane", &
               "m","IC","SHOT_CONFIGURATION", &
               "R|units=m Z_mid_ant(nicrf_src)")
     ENDIF
  ENDIF

  iaddr = ps_shash_Z_min_box
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("Z_min_box","EQ")
     ELSE
        indim = 0
        CALL define_var("Z_min_box","R",indim,idims, &
               "Z_min of bounding box", &
               "m","EQ","MACHINE_DESCRIPTION", &
               "R  Z_min_box")
     ENDIF
  ENDIF

  iaddr = ps_shash_Z_min_lcfs
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("Z_min_lcfs","EQ")
     ELSE
        indim = 0
        CALL define_var("Z_min_lcfs","R",indim,idims, &
               "Z_min of last closed flux surface", &
               "m","EQ","STATE_DATA", &
               "R  Z_min_lcfs")
     ENDIF
  ENDIF

  iaddr = ps_dhash_nz_rip
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%Z_ripple).AND.ichange) THEN
     IF(cclist(ps_cnum_RIPPLE).NE.1) THEN
        CALL ccwarn("Z_ripple","RIPPLE")
     ELSE
        indim = 0
        IF(nids%nid_dim_nz_rip.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nz_rip,"dim_nz_rip",ss%nz_rip)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nz_rip
        CALL define_var("Z_ripple","R",indim,idims, &
               "Z grid for TF ripple field(s)", &
               "m","RIPPLE","SIMULATION_INIT", &
               "G  Z_ripple(nZ_rip)")
     ENDIF
  ENDIF

  iaddr = ps_phash_Z_surfMax
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%Z_surfMax).AND.ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("Z_surfMax","EQ")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_eq_geo.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_eq_geo,"dim_nrho_eq_geo",ss%nrho_eq_geo)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_eq_geo
        CALL define_var("Z_surfMax","R",indim,idims, &
               "max Z on flux surface", &
               "m","EQ","STATE_PROFILES", &
               "R|pclin  Z_surfMax(nrho_eq_geo)")
     ENDIF
  ENDIF

  iaddr = ps_phash_Z_surfMin
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%Z_surfMin).AND.ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("Z_surfMin","EQ")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_eq_geo.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_eq_geo,"dim_nrho_eq_geo",ss%nrho_eq_geo)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_eq_geo
        CALL define_var("Z_surfMin","R",indim,idims, &
               "min Z on flux surface", &
               "m","EQ","STATE_PROFILES", &
               "R|pclin  Z_surfMin(nrho_eq_geo)")
     ENDIF
  ENDIF
  CONTAINS


     SUBROUTINE define_dim(dimid,dname,idval)
        INTEGER, intent(out) :: dimid
        CHARACTER*(*), INTENT(in) :: dname
        INTEGER, intent(in) :: idval

        status = nf90_def_dim(icdf,dname,idval,dimid)
        IF(status.NE.NF90_NOERR) THEN
           WRITE(iout,*) ' ?ps_update_file_write: error defining dimension "'// &
                 trim(dname)//'".'
           IERR=9999
        ENDIF
     END SUBROUTINE define_dim



     SUBROUTINE define_var(name,dtype,indim,idims, &
          long_name,units,component,section,spec)

        CHARACTER*(*), INTENT(in) :: name
        CHARACTER*(*), INTENT(in) :: dtype
        INTEGER, INTENT(in) :: indim
        INTEGER, dimension(:), INTENT(in) :: idims
        CHARACTER*(*), INTENT(in) :: long_name
        CHARACTER*(*), INTENT(in) :: units
        CHARACTER*(*), INTENT(in) :: component
        CHARACTER*(*), INTENT(in) :: section
        CHARACTER*(*), INTENT(in) :: spec

        integer :: itype

        IF(dtype.EQ.'R') THEN
           itype = NF90_DOUBLE

        ELSE IF (dtype.EQ.'I') THEN
           itype = NF90_INT

        ELSE
           itype = NF90_CHAR

        ENDIF

        IF(indim.EQ.0) THEN
           status=nf90_def_var(icdf,name,itype, varid=varid)

        ELSE
           status=nf90_def_var(icdf,name,itype, dimids=idims(1:indim),varid=varid)

        ENDIF

        IF(status.NE.NF90_NOERR) THEN
           WRITE(iout,*) " ?plasma_state_store: error defining variable: "//trim(name)
           CALL ncerr(status)
           iertot = iertot + 1
           RETURN
        ENDIF

        ! Variable OK, now add attributes:

        CALL add_attrib("long_name",long_name)
        IF(dtype.EQ.'R') CALL add_attrib("units",units)
        CALL add_attrib("component",component)
        CALL add_attrib("section",section)
        CALL add_attrib("specification",spec)

     END SUBROUTINE define_var

     SUBROUTINE add_attrib(name,value)
        CHARACTER*(*), intent(in) :: name
        CHARACTER*(*), intent(in) :: value

        status=nf90_put_att(icdf,varid,name,value)
        IF(status.NE.NF90_NOERR) THEN
           WRITE(iout,*) " ?plasma_state_store: error defining attribute: "//trim(name)//' = '//trim(value)
           CALL ncerr(status)
           iertot = iertot + 1
        ENDIF
     END SUBROUTINE add_attrib



     SUBROUTINE ncerr(status)
        INTEGER, INTENT(in) :: status

        nc_errmsg = NF90_strerror(status)
        write(iout,*) '  NetCDF message: ',trim(nc_errmsg)
     END SUBROUTINE ncerr



     SUBROUTINE ccwarn(varnam,compnam)

        CHARACTER*(*), intent(in) :: varnam   ! name of variable or array
        CHARACTER*(*), intent(in) :: compnam  ! name of component

        if(iwarn.eq.0) then
           write(iout,*) ' '
           write(iout,*) ' %ps_update_file_write: modified state elements'
           write(iout,*) '  exist which were not written due to the "cclist"'
           write(iout,*) '  input variable which screens out elements from'
           write(iout,*) '  selected components: cclist = ',cclist,';'
           write(iout,*) '  element values of 1 indicate components that are'
           write(iout,*) '  enabled for write.'
           write(iout,*) ' '
        endif

        iwarn = iwarn + 1

        write(iout,*) ' %ps_update_file_write: modified: ss%'// &
             trim(varnam)//' ('//trim(compnam)//' component) NOT WRITTEN.'

     END SUBROUTINE ccwarn

END SUBROUTINE ps_update_file_write_def_9

SUBROUTINE ps_update_file_write_9(ss,icdf,cclist,iucount,iout,iwarn,iertot)


  ! Write updated data

  USE plasma_state_definition_mod
  USE netcdf
  IMPLICIT NONE

  TYPE (plasma_state) :: ss  ! state containing array elements to be allocated
  INTEGER, INTENT(IN) :: icdf  ! NetCDF file ID
  INTEGER, INTENT(IN) :: cclist(ps_ccount)  ! component selection
  INTEGER, INTENT(INOUT) :: iucount ! update count
  INTEGER, INTENT(IN) :: iout  ! LUN for messages
  INTEGER, INTENT(INOUT) :: iwarn   ! warn count
  INTEGER, INTENT(INOUT) :: iertot  ! error count

  !-------------------

  INTEGER :: varid,status
  CHARACTER*80 :: nc_errmsg

  !-------------------


  status = nf90_inq_varid(icdf,"velte_mmm71",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%velte_mmm71)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: velte_mmm71"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"velte_nclass",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%velte_nclass)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: velte_nclass"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"velte_neo",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%velte_neo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: velte_neo"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"velte_paleo",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%velte_paleo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: velte_paleo"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"velte_tglf",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%velte_tglf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: velte_tglf"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"velti_anom",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%velti_anom)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: velti_anom"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"velti_glf",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%velti_glf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: velti_glf"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"velti_gtcneo",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%velti_gtcneo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: velti_gtcneo"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"velti_mmm71",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%velti_mmm71)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: velti_mmm71"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"velti_nclass",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%velti_nclass)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: velti_nclass"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"velti_neo",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%velti_neo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: velti_neo"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"velti_tglf",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%velti_tglf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: velti_tglf"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"vie_trans",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%vie_trans)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: vie_trans"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"vie_transcat",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%vie_transcat)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: vie_transcat"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"vmo_trans",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%vmo_trans)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: vmo_trans"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"vmo_transcat",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%vmo_transcat)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: vmo_transcat"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"vn_trans",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%vn_trans)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: vn_trans"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"vn_transcat",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%vn_transcat)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: vn_transcat"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"vol",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%vol)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: vol"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"vphi0_av",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%vphi0_av)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: vphi0_av"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"vpol_Data_Info",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%vpol_Data_Info)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: vpol_Data_Info"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"vpol_inmp",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%vpol_inmp)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: vpol_inmp"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"vpol_is_input",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%vpol_is_input)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: vpol_is_input"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"vpol_omp",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%vpol_omp)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: vpol_omp"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"VRep_coil_count",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%VRep_coil_count)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: VRep_coil_count"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Vrep_coil_spacing",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%Vrep_coil_spacing)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: Vrep_coil_spacing"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Vsize_coil",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%Vsize_coil)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: Vsize_coil"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"vsur",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%vsur)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: vsur"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"VSUR_Data_Info",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%VSUR_Data_Info)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: VSUR_Data_Info"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"vtor_Data_Info",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%vtor_Data_Info)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: vtor_Data_Info"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"vtor_inmp",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%vtor_inmp)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: vtor_inmp"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"vtor_is_input",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%vtor_is_input)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: vtor_is_input"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"vtor_omp",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%vtor_omp)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: vtor_omp"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"V_loop",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%V_loop)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: V_loop"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"v_pars",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%v_pars)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: v_pars"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"v_pers",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%v_pers)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: v_pers"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"wt_nphi",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%wt_nphi)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: wt_nphi"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"wt_nphi_abs",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%wt_nphi_abs)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: wt_nphi_abs"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"wt_nphi_ext",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%wt_nphi_ext)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: wt_nphi_ext"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"xRjcos_momeq",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%xRjcos_momeq)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: xRjcos_momeq"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"xRjsin_momeq",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%xRjsin_momeq)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: xRjsin_momeq"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"xs",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%xs)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: xs"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"xs_name",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%xs_name)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: xs_name"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"xZjcos_momeq",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%xZjcos_momeq)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: xZjcos_momeq"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"xZjsin_momeq",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%xZjsin_momeq)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: xZjsin_momeq"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Z0max",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%Z0max)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: Z0max"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Z0_momeq",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%Z0_momeq)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: Z0_momeq"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Zbap",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%Zbap)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: Zbap"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Zbsc",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%Zbsc)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: Zbsc"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Zeff",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%Zeff)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: Zeff"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"ZEFF_Data_Info",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%ZEFF_Data_Info)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: ZEFF_Data_Info"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Zeff_fi",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%Zeff_fi)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: Zeff_fi"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Zeff_th",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%Zeff_th)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: Zeff_th"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Zimp1",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%Zimp1)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: Zimp1"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Zimp2",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%Zimp2)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: Zimp2"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"zlim",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%zlim)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: zlim"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Zloc_coil",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%Zloc_coil)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: Zloc_coil"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Z_ant",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%Z_ant)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: Z_ant"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Z_antgeo",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%Z_antgeo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: Z_antgeo"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Z_axis",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%Z_axis)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: Z_axis"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Z_EC_launch",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%Z_EC_launch)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: Z_EC_launch"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Z_geo",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%Z_geo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: Z_geo"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Z_grid",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%Z_grid)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: Z_grid"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Z_max_box",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%Z_max_box)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: Z_max_box"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Z_max_lcfs",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%Z_max_lcfs)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: Z_max_lcfs"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Z_midp",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%Z_midp)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: Z_midp"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Z_mid_ant",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%Z_mid_ant)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: Z_mid_ant"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Z_min_box",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%Z_min_box)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: Z_min_box"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Z_min_lcfs",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%Z_min_lcfs)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: Z_min_lcfs"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Z_ripple",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%Z_ripple)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: Z_ripple"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Z_surfMax",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%Z_surfMax)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: Z_surfMax"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Z_surfMin",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%Z_surfMin)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: Z_surfMin"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF
  CONTAINS


     SUBROUTINE ncerr(status)
        INTEGER, INTENT(in) :: status

        nc_errmsg = NF90_strerror(status)
        write(iout,*) '  NetCDF message: ',trim(nc_errmsg)
     END SUBROUTINE ncerr

END SUBROUTINE ps_update_file_write_9

subroutine ur_cstate_ilists

  ! examine item lists contained in the state(s)

  use cstate_lib_mod
  implicit NONE

  !-------------------------
  ! local

  integer :: luntty,lnout
  logical :: lxout,lchar,lyes

  integer :: ii,jj,ia,imatch,ierr,isize,isize_tot,ivd2
  integer :: ilen_coln(0:nsss_cur)
  character*32 iname
 
  integer, dimension(:,:), allocatable :: addr_table
  character*10, dimension(:,:), allocatable :: val_field
  !-------------------------

  luntty = lnout(0)

  call psw_contents('L',ncur_components,w1,ierr, state=sss(1))
  isize = w1%size
  
  do
     if(lxout(0)) then
        write(luntty,1001) omit_empty,trim(cur_components)

1001    format('ur_cstate_ilists options:'/ &
             '  A -- option to omit empty elements from display (',L1,')'/ &
             '  C -- select & restrict view to component(s) (current selection: ',a,')'/ &
             '  T -- table of contents (show dimensions and description)'/ &
             '  U -- table of contents (show component and description)'/ &
             '  D -- summary comparitive display of item lists'/ &
             '  S -- select a single item list & examine in detail'/ &
             '  L -- modify state label(s)'/ &
             '  Q -- quit this menu'/)
     endif
     call uread('ur_cstate_ilists option:')

     if(lchar('Q')) then
        exit

     else if(lchar('A')) then
        if(lxout(0)) write(luntty,*) &
             ' option to omit display of elements that are empty in all states.'

        call uread('omit empty elements ? (Y/N):')
        omit_empty = lyes(0)

     else if(lchar('C')) then
        call ur_cstate_component

     else if(lchar('D')) then
        call ur_dcomp_display('L', 'List_sizes', 'lists')

     else if(lchar('L')) then
        call ur_cstate_setLabel

     else if(lchar('T')) then
        call ur_cstate_ilist_contents(1)

     else if(lchar('U')) then
        call ur_cstate_ilist_contents(2)

     else if(lchar('S')) then
        call psw_contents('L',ncur_components,w1,ierr, state=sss(1))
        if(w1%size.eq.0) then
           write(luntty,*) ' %ur_cstate_ilists: no item lists found in currently selected components.'
           cycle
        endif

        if(lxout(0)) then
           write(luntty,*) '(unambiguous prefix of name may be entered).'
        endif
        call ureadw('name of item list to examine:',iname)
        if(iname.eq.'Q') cycle
        if(iname.eq.'.') cycle

        call cstate_findm(iname,luntty,imatch)
        if(imatch.eq.0) then
           call uclear
           cycle
        endif

        isize_tot = 0
        ilen_coln = 0

        do ii=1,nsss_cur
           call psw_ilist(iname,ww(ii),ierr, state=sss(ii))
           isize=ww(ii)%size

           if(ii.eq.1) then
              ilen_coln(0)=len(trim(ww(ii)%list_name))
           endif

           ilen_coln(ii)=max(7,len(trim(sss_label(ii))))

           if(isize.eq.0) then
              write(luntty,*) ' empty list for state: '//trim(sss_label(ii))
           else
              isize_tot=isize_tot + ww(ii)%size
           endif

           !  the following is special for item list element names only...
           !  the actual item names are in the C*256 value field
           !  alphabetic ordering is preserved in ww
           !  because initially list_elems(jj) = <prefix>//trim(c256val(jj))
           !  where <prefix> depends on the particular list selected.

           do jj=1,isize
              ww(ii)%list_elems(jj) = trim(ww(ii)%c256val(jj))
              ilen_coln(0)=max(ilen_coln(0),len(trim(ww(ii)%list_elems(jj))))
           enddo
        enddo

        if(isize_tot.eq.0) then
           write(luntty,*) ' empty list.'
           cycle
        endif

        allocate(addr_table(nsss_cur,isize_tot))
        call psw_merge(ww,wmerge,ierr, addr_table=addr_table)
        isize_tot = wmerge%size

        if(ierr.eq.0) then
           !  show which species are in which state...

           allocate(val_field(nsss_cur,isize_tot))
           ivd2 = isize_tot

           do jj=1,isize_tot
              do ii=1,nsss_cur
                 if(addr_table(ii,jj).gt.0) then
                    val_field(ii,jj)='PRESENT'
                 else
                    val_field(ii,jj)='absent'
                 endif
              enddo
           enddo

           call cstate_table_out(ww(1)%list_name, '   ', '   ', &
                ilen_coln,2,val_field,ivd2, &
                0,isize_tot)

           deallocate(val_field)
        endif

        deallocate(addr_table)

     else
        call uermsg(' ?ur_cstate_ilists: unrecognized option.',' ',0)
     endif
  enddo

end subroutine ur_cstate_ilists

! $Id: ccps_chk_nbfrac.f90,v 1.1 2009-02-09 20:38:28 Alex_Pletzer Exp $

subroutine ccps_chk_nbfrac(iobj, ichk, ierr)
    !-------------------------------------------------------------------
    !
    ! PS_CHK_NBFRAC -- utility routine for beam energy fractions
    !
    ! For He or negative_ion beams (ib): set ss%frac_full(ib)=1 and
    !     ss%frac_half(ib)=0:  these beams are at 100% full energy
    !
    ! For H/D/T beams with ss%beam_type(ib).eq."standard":
    !   if ss%nbion(ib).eq."H" check H energy fraction tables
    !   if ss%nbion(ib).eq."D" check H energy fraction tables
    !   if ss%nbion(ib).eq."T" check H energy fraction tables
    !   ...and interpolate to get full, 1/2, and 1/3 energy fractions of
    !   beam current for each beam
    !
    !   if ichk=1 set the error code if a needed energy table has not been
    !   initialized; if ichk=0, do nothing in this case.
    
    !----------------------------------------------------------------------
    !
    !   Declare local variables
    !
    !----------------------------------------------------------------------
  use plasma_state_mod
  implicit NONE

   integer :: iobj(*)        ! (ps_container_size) words are used: state object
   integer, intent(in) :: ichk              ! =1 to set error code if
    !  energy fraction table(s) are not ready.

   integer, intent(out) :: ierr             ! exit status code (0=OK)

  !-------------------------
  type (plasma_state_container) :: ptr
  type (plasma_state), pointer :: ss

  call ccps_argcheck('ccps_mhd_verify',iobj,ierr)
  if(ierr.ne.0) return

  ! proceed...

  call load_ps_container(iobj,ptr)
  ss => ptr%ps_ptr

  call ps_chk_nbfrac(ichk=ichk, ierr=ierr, state=ss)
   
end subroutine ccps_chk_nbfrac

module ps_nbline_module

  ! module for selection of beam trajectories, using 
  ! Plasma State data and random number generator routines provided.

  use plasma_state_mod
  implicit NONE

  SAVE
  PRIVATE

  ! these are the only publicly defined symbols

  PUBLIC :: beamlet    ! definition of data type returned by ps_nbline
  PUBLIC :: ps_nbline  ! subroutine to select beamlet neutral trajectory

  !-------------------------------------------------------------
  ! use one of these for "ispecie" argument in ps_nbline
  INTEGER, PARAMETER, PUBLIC :: All_species = 0   ! select all beams

  INTEGER, PARAMETER, PUBLIC :: i_Hydrogen = 1    ! select H beams only
  INTEGER, PARAMETER, PUBLIC :: i_Deuterium = 2   ! select D beams only
  INTEGER, PARAMETER, PUBLIC :: i_Tritium = 3     ! select T beams only

  INTEGER, PARAMETER, PUBLIC :: i_Helium3 = 4     ! select He3 beams only
  INTEGER, PARAMETER, PUBLIC :: i_Helium4 = 5     ! select He4 beams only

  INTEGER, PARAMETER, PUBLIC :: i_Neon = 6        ! select Neon beams only
  INTEGER, PARAMETER, PUBLIC :: i_Argon = 7       ! select Argon beams only
  INTEGER, PARAMETER, PUBLIC :: i_Krypton = 8     ! select Krypton beams only
  INTEGER, PARAMETER, PUBLIC :: i_Xenon = 9       ! select Xenon beams only

  INTEGER, PARAMETER :: ispec_min = 1, ispec_max = 9  ! validity range

  !-------------------------------------------------------------
  ! data type returned -- NOT FILLED if ierr.ne.0 on exit from nb_psline
  !   (specie = -1 is set on error).

  type beamlet

     integer :: specie        ! code for "H", "D", "T", "He3" or "He4", or...

     integer :: beam_number   ! selected injector (from Plasma State list)
     integer :: energy_frac   ! selected energy fraction (1:full; 2:half;
                              ! 3:(1/3) energy).

     real*8 :: Rsta           ! Major Radius of start of trajectory(m)
     real*8 :: Phista         ! Toroidal angle position of start (rad)
     real*8 :: Zsta           ! Elevation of start trajectory (m)

     real*8 :: vR             ! velocity in R direction (>0: outward) (m/s)
     real*8 :: vZ             ! velocity in Z direction (>0: up) (m/s)
     real*8 :: vPhi           ! velocity in toroidal direction (m/s)
                              !  (>0: counter-clockwise direction veiwed from
                              !  above).

  end type beamlet

  !-------------------------------------------------------------
  ! private stored data -- beam currents & state data hash code.
  ! when the state data hash code changes, the beam currents are updated.

  integer :: ps_hash1 = -99
  integer :: ps_hash2 = -99
  integer :: ierr_save = 0

  ! beam species identification, converted to integer:
  integer, dimension(:), allocatable :: beam_species
  integer, dimension(:), allocatable :: trace_beam_species

  real*8, dimension(:), allocatable :: beamcurs  ! currents in each beam
  real*8, dimension(:), allocatable :: beamcurt  ! trace currents in each beam
  integer, dimension(:), allocatable :: ifract   ! trace fractionation flag
  real*8 :: bmcur_spec(ispec_max)  ! total current for each species
  real*8 :: bmcur_tot      ! total current, all beams, all species

  !  index ranges of beams with power
  integer :: ib1a,ib2a             ! all beams
  integer :: ib1(ispec_max)        ! 1st beam index for each species
  integer :: ib2(ispec_max)        ! last beam index for each species

  real*8 :: mass_kg(ispec_max)     ! mass of nucleus, kg (taken from state)
  !  this is only set for beam injected species

  !-------------------------------------------------------------
  !  private data -- cgs nbline data, reconstructed from Plasma State
  !  machine description

  real*8, dimension(:), allocatable :: bmwidra,bmwidza
  real*8, dimension(:), allocatable :: rapedga,xzpedga
  real*8, dimension(:), allocatable :: xrapoffa,xzapoffa
  real*8, dimension(:), allocatable :: xlbapa2,rapedg2,xzpedg2
  real*8, dimension(:), allocatable :: xrapoff2,xzapoff2
  integer, dimension(:), allocatable :: nbapsha,nbapsh2,nbshapa
  real*8, dimension(:), allocatable :: foclra,foclza,divra,divza
  real*8, dimension(:), allocatable :: xlbapa,xybsca,xybapa,xlbtna
  real*8, dimension(:), allocatable :: rtcena,xbzeta

  !-------------------------------------------------------------
  !  private constants

  REAL*8, parameter :: ZERO = 0.0d0
  REAL*8, parameter :: ONE  = 1.0d0
  REAL*8, parameter :: Z100 = 1.0d2  ! m -> cm
  REAL*8, parameter :: Z001 = 1.0d-2 ! cm -> m
  REAL*8, parameter :: Z1000= 1.0d3  ! KeV -> eV; make current Amps
  REAL*8, parameter :: DEGRAD = 1.745329251994330d-2 ! radians/degree, pi/180
  REAL*8, parameter :: TWOPI = 6.2831853071795862D+00
CONTAINS

  subroutine ps_nbline(istream,frandm,fgauss, &
       pstate,ispecie, &
       trajectory,ierr)

    integer, intent(in) :: istream  ! RNG stream ID
    !  (interpretation depends on passed RNG routines frandm and fgauss)

    REAL*8 :: frandm                ! passed [0:1] RNG EXTERNAL function
    !   eta=frandm(istream) -> evenly sampled random number eta, 0 < eta < 1.

    REAL*8 :: fgauss                ! passed Gaussian RNG EXTERNAL function
    !   nu= fgauss(istream,xcen,xwid) -> sample from Gaussian 
    !        exp(-(x-xcen)**2/(2*xwid**2))

    type (plasma_state) :: pstate   ! Plasma State containing beam description

    integer, intent(in) :: ispecie  ! specie select (choose one of the
    !   module parameters, e.g. i_Deuterium or All_species.

    type (beamlet) :: trajectory    ! return one randomly selected trajectory
    !   probability weighting according to total beam current

    integer, intent(out) :: ierr    ! completion status: 0=OK

    !-------------------------------
    !  possible error:  Plasma State lacks beam description
    !     ierr=1 -- no beams
    !     ierr=2 -- beams, but no power
    !     ierr=3 -- for a beam with power, the voltage is zero or negative
    !     ierr=4 -- for a beam with power, the 1st & 2nd energy fractions are 0
    !     ierr=5 -- error in beam geometry
    !
    !     ierr=10 -- no power for selected beam species (no error message)
    !     ierr=11 -- "ispecie" input argument value out of range
    !
    !     ierr=13 -- error in plasma state: trace power > 10% main beam power
    !
    !     ierr=99 -- ps_chk_nbfrac error
    !-------------------------------

    integer :: ib,inb,ia1,ia2,ia,iz,ibi1,ibi2,ibsel,iesel,iout,ispec
    integer :: ispec_trace,iso,iso_trace,itrace
    real*8 :: pnbtot,fracfac,curtot,zcur,zrng,zsum,zv,zconv,zf2,zf3,zfrac
    real*8 :: zfac,zplim

    character*4 zspec,zspec_trace
    character*10 zshape

    !-------------------------------
    EXTERNAL frandm
    EXTERNAL fgauss
    !-------------------------------

    trajectory%specie = -1

    iout = SWIM_err_out_file

    inb = pstate%nbeam

    ia1 = ps_shash_state_data
    ia2 = ia1 + 1

    if((ps_hash1.eq.pstate%hash_codes(ia1)).and. &
         (ps_hash2.eq.pstate%hash_codes(ia2))) then

       ierr = ierr_save

    else

       ps_hash1 = pstate%hash_codes(ia1)
       ps_hash2 = pstate%hash_codes(ia2)

       mass_kg = ZERO
       do ib=1,pstate%nspec_beam
          iz = pstate%qatom_snbi(ib)/ps_xe + 0.1
          ia = pstate%m_snbi(ib)/ps_mp + 0.1
          if(iz.eq.1) then
             if(ia.eq.1) mass_kg(1) = pstate%m_snbi(ib)
             if(ia.eq.2) mass_kg(2) = pstate%m_snbi(ib)
             if(ia.eq.3) mass_kg(3) = pstate%m_snbi(ib)
          else if(iz.eq.2) then
             if(ia.eq.3) mass_kg(4) = pstate%m_snbi(ib)
             if(ia.eq.4) mass_kg(5) = pstate%m_snbi(ib)
          endif
       enddo
       ! new hash code means new state data

       ierr = 0

       call ps_chk_nbfrac(0, ierr, state=pstate)
       if(ierr.ne.0) then
          ierr = 99

       else if((inb.le.0).or.(.not.allocated(pstate%power_nbi))) then
          ierr = 1

       else
          pnbtot = ZERO
          do ib = 1,inb
             if(pstate%power_nbi(ib).gt.ZERO) then
                pnbtot = pnbtot + pstate%power_nbi(ib) + pstate%power_nbi_trace(ib)
                if(pstate%kvolt_nbi(ib).LE.ZERO) then
                   ierr = 3
                   exit
                endif
             endif
          enddo

          if(pnbtot.le.ZERO) then
             ierr = 2
          endif
       endif

       if(ierr.eq.0) then
          
          if(allocated(beamcurs)) deallocate(beamcurs,beamcurt,beam_species,ifract)
          allocate(beamcurs(inb),beamcurt(inb),beam_species(inb),ifract(inb))

          if(allocated(trace_beam_species)) deallocate(trace_beam_species)
          allocate(trace_beam_species(inb))

          trace_beam_species = 0 ! usually, no trace beam species
          beamcurt = ZERO  ! trace element currents-- generally zero
          ifract = 0

          bmcur_spec = ZERO
          bmcur_tot  = ZERO
          ib1 = 0
          ib2 = 0
          ib1a = 0
          ib2a = 0

          do ib = 1,inb

             zplim = 0.1d0*(pstate%power_nbi(ib)+pstate%power_nbi_trace(ib))
             if(pstate%power_nbi_trace(ib).gt.zplim) then
                ierr=13
                write(iout,*) ' ?ps_nbline: for beam #',ib
                write(iout,*) '  trace beam power = ',pstate%power_nbi_trace(ib)
                write(iout,*) '  exceeds 10% of total beam power: ',zplim
                exit
             endif

             zspec = pstate%nbion(ib)
             call uupper(zspec)

             zspec_trace = pstate%nbion_trace(ib)
             call uupper(zspec_trace)

             if(zspec.eq.'H') then
                iso=1
                ispec= i_Hydrogen  ! (1)
             else if(zspec.eq.'D') then
                iso=1
                ispec= i_Deuterium ! (2)
             else if(zspec.eq.'T') then
                iso=1
                ispec= i_Tritium   ! (3)
             else if(zspec.eq.'HE3') then
                iso=2
                ispec= i_Helium3
             else if(zspec.eq.'HE4') then
                iso=2
                ispec= i_Helium4
             else if(zspec.eq.'NE') then
                iso=10
                ispec= i_Neon
             else if(zspec.eq.'AR') then
                iso=18
                ispec= i_Argon
             else if(zspec.eq.'KR') then
                iso=36
                ispec= i_Krypton
             else if(zspec.eq.'XE') then
                iso=54
                ispec= i_Xenon
             else
                ierr=5
                exit
             endif

             beam_species(ib)=ispec

             trace_beam_species(ib)=0
             if(zspec_trace.ne.' ') then
                if(zspec_trace.eq.'H') then
                   iso_trace=1
                   ispec_trace= i_Hydrogen  ! (1)
                else if(zspec_trace.eq.'D') then
                   iso_trace=1
                   ispec_trace= i_Deuterium ! (2)
                else if(zspec_trace.eq.'T') then
                   iso_trace=1
                   ispec_trace= i_Tritium   ! (3)
                else if(zspec_trace.eq.'HE3') then
                   iso_trace=2
                   ispec_trace= i_Helium3
                else if(zspec_trace.eq.'HE4') then
                   iso_trace=2
                   ispec_trace= i_Helium4
                else if(zspec_trace.eq.'NE') then
                   iso_trace=10
                   ispec_trace= i_Neon
                else if(zspec_trace.eq.'AR') then
                   iso_trace=18
                   ispec_trace= i_Argon
                else if(zspec_trace.eq.'KR') then
                   iso_trace=36
                   ispec_trace= i_Krypton
                else if(zspec_trace.eq.'XE') then
                   iso_trace=54
                   ispec_trace= i_Xenon
                else
                   ierr=5
                   exit
                endif
             endif

             beamcurs(ib)=ZERO
             if(pstate%power_nbi(ib).gt.ZERO) then
                fracfac = pstate%frac_full(ib) + pstate%frac_half(ib)/2 + &
                     (ONE-pstate%frac_full(ib)-pstate%frac_half(ib))/3
                if(fracfac.le.ZERO) then
                   ierr=4
                   exit
                endif

                zcur = pstate%power_nbi(ib)/ &
                     (Z1000*pstate%kvolt_nbi(ib)*fracfac)

                beamcurs(ib) = zcur
                bmcur_tot = bmcur_tot + zcur
                bmcur_spec(ispec) = bmcur_spec(ispec) + zcur

                !  set indices for this species beam with non-zero power:

                if(ib1(ispec).eq.0) ib1(ispec)=ib
                ib2(ispec)=ib

                if(ib1a.eq.0) ib1a=ib
                ib2a=ib

             endif

             if(pstate%power_nbi_trace(ib).gt.ZERO) then
                if((iso.eq.1).and.(iso_trace.eq.1)) then
                   ! H isotope molecule @Einj; trace atom mass ratios:
                   zf2 = ispec_trace*ONE/(ispec + ispec_trace)
                   zf3 = ispec_trace*ONE/(2*ispec + ispec_trace)
                   fracfac = pstate%frac_full(ib) + pstate%frac_half(ib)*zf2 +&
                        (ONE-pstate%frac_full(ib)-pstate%frac_half(ib))*zf3
                   ifract(ib)=1
                else
                   fracfac=ONE
                endif

                zcur = pstate%power_nbi_trace(ib)/ &
                     (Z1000*pstate%kvolt_nbi(ib)*fracfac)

                beamcurt(ib) = zcur
                bmcur_tot = bmcur_tot + zcur
                bmcur_spec(ispec_trace) = bmcur_spec(ispec_trace) + zcur

                !  set indices for this species beam with non-zero power:

                if(ib1(ispec_trace).eq.0) ib1(ispec_trace)=ib
                ib2(ispec_trace)=ib

                if(ib1a.eq.0) ib1a=ib
                ib2a=ib
             endif

          enddo
       endif

       if(ierr.eq.1) then
          write(iout,*) ' ?ps_nbline: no neutral beams in plasma state.'

       else if(ierr.eq.2) then
          write(iout,*) ' ?ps_nbline: plasma state shows no beam power.'

       else if(ierr.eq.3) then
          write(iout,*) ' ?ps_nbline: beam with non-zero power has Einj=0.'

       else if(ierr.eq.4) then
          write(iout,*) ' ?ps_nbline: beam with non-zero power has zero energy fractions.'

       else if(ierr.eq.5) then
          write(iout,*) ' ?ps_nbline: beam #',ib,' unrecognized species: ', &
               pstate%nbion(ib)

       else if(ierr.ne.0) then
          write(iout,*) ' ?ps_nbline: an unexpected error occurred.'
       endif

       ierr_save = ierr

       !---------------------------------------------------------------------
       ! restore legacy NUBEAM NBLINE CGS geometry description

       if(ierr.eq.0) then
          ! transfer state geometry to local CGS variables-- names originally
          ! from nubeam/nbline.for

          if(allocated(rtcena)) then
             deallocate(bmwidra,bmwidza,rapedga,xzpedga)
             deallocate(xlbapa2,rapedg2,xzpedg2)
             deallocate(xrapoffa,xzapoffa,xrapoff2,xzapoff2)
             deallocate(nbapsha,nbapsh2,nbshapa)
             deallocate(foclra,foclza,divra,divza)
             deallocate(xlbapa,xybsca,xybapa,xlbtna)
             deallocate(rtcena,xbzeta)
          endif

          allocate(bmwidra(inb),bmwidza(inb))
          allocate(rapedga(inb),xzpedga(inb))
          allocate(xrapoffa(inb),xzapoffa(inb))
          allocate(xlbapa2(inb),rapedg2(inb),xzpedg2(inb))
          allocate(xrapoff2(inb),xzapoff2(inb))
          allocate(nbapsha(inb),nbapsh2(inb),nbshapa(inb))
          allocate(foclra(inb),foclza(inb),divra(inb),divza(inb))
          allocate(xlbapa(inb),xybsca(inb),xybapa(inb),xlbtna(inb))
          allocate(rtcena(inb),xbzeta(inb))

          bmwidra = Z100*pstate%b_halfwidth
          bmwidza = Z100*pstate%b_halfheight

          rapedga = Z100*pstate%ap_halfwidth
          xzpedga = Z100*pstate%ap_halfheight

          xrapoffa = Z100*pstate%ap_horiz_offset
          xzapoffa = Z100*pstate%ap_vert_offset

          foclra = Z100*pstate%b_hfocal_length
          foclza = Z100*pstate%b_vfocal_length

          zconv = degrad/sqrt(2.0d0)

          divra = zconv*pstate%b_hdivergence
          divza = zconv*pstate%b_vdivergence

          xlbapa = Z100*pstate%Lbscap
          xlbtna = Z100*pstate%Lbsctan
          rtcena = Z100*pstate%srtcen  ! SIGNed quantity, now

          xybsca = Z100*pstate%zbsc
          xybapa = Z100*pstate%zbap

          xbzeta = pstate%Phibsc

          xlbapa2 = Z100*pstate%Lbscap2
          rapedg2 = Z100*pstate%ap2_halfwidth
          xzpedg2 = Z100*pstate%ap2_halfheight

          xrapoff2 = Z100*pstate%ap2_horiz_offset
          xzapoff2 = Z100*pstate%ap2_vert_offset

          do ib=1,inb
             zshape = pstate%nbshape(ib)
             call uupper(zshape)
             if(zshape.eq.'RECTANGLE') then
                nbshapa(ib)=1
             else if(zshape.eq.'CIRCLE') then
                nbshapa(ib)=2
             else
                ierr=ierr+1
                write(6,*) ' ?ps_nbline: beam #',ib, &
                     ' source grid shape unknown: ',zshape
             endif

             zshape = pstate%nbap_shape(ib)
             call uupper(zshape)
             if(zshape.eq.'RECTANGLE') then
                nbapsha(ib)=1
             else if(zshape.eq.'CIRCLE') then
                nbapsha(ib)=2
             else
                ierr=ierr+1
                write(6,*) ' ?ps_nbline: beam #',ib, &
                     ' aperture shape unknown: ',zshape
             endif

             !  if 2nd aperture shape not "CIRCLE" or "RECTANGLE", assume
             !  there is no 2nd aperture

             zshape = pstate%nbap2_shape(ib)
             call uupper(zshape)
             if(zshape.eq.'RECTANGLE') then
                nbapsh2(ib)=1
             else if(zshape.eq.'CIRCLE') then
                nbapsh2(ib)=2
             else
                nbapsh2(ib)=0
                xlbapa2(ib)=ZERO
             endif

          enddo
          if(ierr.gt.0) then
             write(6,*) '?ps_nbline: error in Plasma State beam description.'
             ierr=5
          endif

       endif

    endif
    if(ierr.ne.0) return

    !--------------------------------------------
    !  OK: internal module data has been initialized
    !
    !  Check species selection...

    if(ispecie.eq.All_species) then
       curtot = bmcur_tot
       ibi1=ib1a
       ibi2=ib2a
    else if((ispecie.ge.ispec_min).and.(ispecie.le.ispec_max)) then
       curtot = bmcur_spec(ispecie)
       ibi1=ib1(ispecie)
       ibi2=ib2(ispecie)
    else
       write(6,*) ' ?ps_nbline: "ispecie" argument value invalid: ',ispecie
       ierr = 11
    endif

    if(ierr.eq.0) then
       if(curtot.le.ZERO) then
          ierr = 10    ! no power, no current, this specie
       endif
    endif
    if(ierr.ne.0) return

    !--------------------------------------------
    !  Use RNG to select neutral beam and energy fraction, if necessary

    if(ibi1.eq.ibi2) then
       ibsel = ibi1
    else
       zrng = frandm(istream)*curtot
       ibsel = ibi2
       zsum = ZERO
       do ib=ibi1,ibi2
          if(ispecie.eq.All_species) then
             zsum = zsum + beamcurs(ib) + beamcurt(ib)
             if(zsum.ge.zrng) then
                if(zsum-beamcurt(ib).ge.zrng) then
                   itrace=0
                   zfrac=pstate%frac_full(ib)
                else
                   itrace=1
                   if(ifract(ib).eq.1) then
                      zfrac=pstate%frac_full(ib)
                   else
                      zfrac=ONE
                   endif
                endif
                ibsel=ib
                exit
             endif
          else if(ispecie.eq.beam_species(ib)) then
             zsum = zsum + beamcurs(ib)
             if(zsum.ge.zrng) then
                itrace=0
                zfrac=pstate%frac_full(ib)
                ibsel=ib
                exit
             endif
          else if(ispecie.eq.trace_beam_species(ib)) then
             zsum = zsum + beamcurt(ib)
             if(zsum.ge.zrng) then
                itrace=1
                ibsel=ib
                exit
             endif
          endif
       enddo
    endif

    ispec=beam_species(ibsel)
    ispec_trace=trace_beam_species(ibsel)

    if(itrace.eq.0) then
       zfrac = pstate%frac_full(ib)
    else
       if(ifract(ib).eq.1) then
          zfrac=pstate%frac_full(ib)
       else
          zfrac=ONE
       endif
    endif

    zfac=ONE

    if(zfrac.eq.ONE) then
       iesel = 1
    else
       zrng = frandm(istream)
       if(zrng.le.pstate%frac_full(ib)) then
          iesel = 1
       else if(zrng.le.(pstate%frac_full(ib)+pstate%frac_half(ib))) then
          iesel = 2
          if(itrace.eq.0) then
             zfac=0.5d0
          else
             ! H isotope molecule @ Einj; trace atom mass ratio
             zfac=ispec_trace*ONE/(ispec+ispec_trace)
          endif
       else
          iesel = 3
          if(itrace.eq.0) then
             zfac=ONE/3
          else
             ! H isotope molecule @ Einj; trace atom mass ratio
             zfac=ispec_trace*ONE/(2*ispec+ispec_trace)
          endif
       endif
    endif

    !--------------------------------------------
    ! OK beam line has been selected...

    trajectory%specie = beam_species(ibsel)
    trajectory%beam_number = ibsel
    trajectory%energy_frac = iesel

    zv = sqrt(2*Z1000*pstate%kvolt_nbi(ibsel)*ps_xe*zfac/ &
         (mass_kg(beam_species(ibsel))) )  ! m/s

    !! write(6,*) ' E = ',pstate%kvolt_nbi(ibsel)*Z1000/iesel
    !! write(6,*) ' m/mp = ',mass_kg(beam_species(ibsel))/ps_mp
    !! write(6,*) ' Echk = ',(zv*zv*ia*1.0e4/(1.384e6*1.384e6))

    call ps_nbline_sub(istream,frandm,fgauss, pstate, trajectory, ibsel, ierr)

    if(ierr.ne.0) then
       write(6,*) ' ?ps_nbline: could not find trajectory in ps_nbline_sub.'
    else
       trajectory%vR = zv * trajectory%vR
       trajectory%vPhi = zv * trajectory%vPhi
       trajectory%vZ = zv * trajectory%vZ
    endif

  end subroutine ps_nbline

  subroutine ps_nbline_sub(istream,frandm,fgauss, pstate, trajectory, ib, ierr)

    integer, intent(in) :: istream  ! RNG stream ID
    !  (interpretation depends on passed RNG routines frandm and fgauss)

    REAL*8 :: frandm                ! passed [0:1] RNG EXTERNAL function
    !   eta=frandm(istream) -> evenly sampled random number eta, 0 < eta < 1.

    REAL*8 :: fgauss                ! passed Gaussian RNG EXTERNAL function
    !   nu= fgauss(istream,xcen,xwid) -> sample from Gaussian 
    !        exp(-(x-xcen)**2/(2*xwid**2))

    type (plasma_state) :: pstate   ! Plasma State containing beam description

    type (beamlet) :: trajectory    ! return one randomly selected trajectory
    !   start position; velocity normalized to v=1; actual velocity inserted
    !   by caller.

    integer, intent(in) :: ib       ! (already selected) beam index

    integer, intent(out) :: ierr    ! status code
    !  a non-zero "ierr" value indicates that a trajectory could not be
    !  found.  Generally this indicates an error in the beam geometry
    !  description (e.g. a zero width aperture).

    !-------------------------------
    !-------------------------------
    EXTERNAL frandm
    EXTERNAL fgauss
    !-------------------------------
    !  nubeam/nbline.for copied & adapted... DMC May 2008

    INTEGER, PARAMETER :: R8=SELECTED_REAL_KIND(12,100)

    REAL*8 zzgrd,zrgrd,zdzdl,zdrdl,zdza,zzap,zdra,zrap,zdzdl0
    REAL*8 zdrdl0,zradap,zdza2,zzap2,zdra2,zrap2,zradap2,zdymp
    REAL*8 zsiny,zcosy,zthet0,zlbmp,zlbmpa,zphil,zphi0,zbeta

    integer   intry, intrylim
    parameter ( intrylim = 100 )  !  Give up after .. attempts

    REAL*8 :: ysta,rsta,esta      ! Y(cm) R(cm) Phi_start (rad)
    real*8 :: thea                ! vert. velocity angle (rad)
    !              zero: horizontal; +: vZ > 0
    real*8 :: phia                ! horiz. angle (rad) w.r.t. -R direction
    !              zero: directed in towards center of machine
    !               +:   component in CCW horizontal direction

    REAL*8 :: zcosth,zsinth

    REAL*8 :: zrtcen
    logical :: ilccw

    !----------------------------------------------------------------
    !
    !  SELECT FROM BEAM FACE
    !  ---------------------

    ierr = 0

    if(rtcena(ib).lt.ZERO) then
       zrtcen=-rtcena(ib)
       ilccw=.FALSE.
    else
       zrtcen=rtcena(ib)
       ilccw=.TRUE.
    endif

    !  RETURN POINT FOR CASES OF BEAM SCRAPE OFF

    intry  =  0
10 CONTINUE
    !----------------------------------

    intry  =  intry + 1

    if( intry .gt. intrylim )   then
       !..       no good trajectory found ..  problem with aperture defn ?
       write(6,6000) ib, intry
       write(6,*) 'ps_nbline_sub : Cannot find good beam trajectory'
       write(6,*) '  (check beam geometry description)'
 
       ierr=20
       return
 
    endif
6000 format(10x,'ps_nbline_sub, beam #',i4,', after ',i6,' attempts ' )

    IF(NBSHAPA(IB).EQ.1) GOTO 100

    !  CIRCULAR BEAM GRIDS
50  CONTINUE
    ZZGRD=BMWIDRA(IB)*(1.0_R8-2.0_R8*FRANDM(ISTREAM))
    ZRGRD=BMWIDRA(IB)*(1.0_R8-2.0_R8*FRANDM(ISTREAM))
    !--     IF(ZZGRD**2+ZRGRD**2.GT.BMWIDRA(IB)**2) GOTO 50
    IF(ZZGRD**2+ZRGRD**2.GT.BMWIDRA(IB)**2) then
       !--        another loop trap..
       intry  =  intry + 1
       if( intry .gt. intrylim )  goto  10
       GOTO 50
    else
       GOTO 150
    endif

    !  RECTANGULAR BEAM GRIDS
100 CONTINUE
    ZZGRD=BMWIDZA(IB)*(1.0_R8-2.0_R8*FRANDM(ISTREAM))
    ZRGRD=BMWIDRA(IB)*(1.0_R8-2.0_R8*FRANDM(ISTREAM))
    
    !  ESTABLISH NEUTRAL TRAJECTORY WITHIN BEAM-LINE
    !  ---------------------------------------------

    !  ZDZDL AND ZDRDL ARE THE TANGENTS OF THE
    !  ANGLES BETWEEN THE NORMAL TO THE (ASSUMED FLAT) GRID
    !  SURFACE AND THE PARTICLE TRAJECTORY, PROJECTED INTO
    !  THE VERTICAL AND HORIZONTAL PLANES.
    !  I.E. DL IN THIS DEFINITION IS LENGTH ALONG THE GRID-NORMAL LINE

150 CONTINUE
    IF(NBSHAPA(IB).EQ.1) GOTO 1100

    !  CIRCULAR BEAM GRIDS
    ZDZDL0=-ZZGRD/FOCLRA(IB)
    ZDRDL0=-ZRGRD/FOCLRA(IB)
    ZDZDL=fgauss(istream,zdZdL0,divRa(ib))
    ZDRDL=fgauss(istream,zdRdL0,divRa(ib))
    GOTO 1150

    !  RECTANGULAR BEAM GRIDS
1100 CONTINUE
    ZDZDL0=-ZZGRD/FOCLZA(IB)
    ZDRDL0=-ZRGRD/FOCLRA(IB)
    ZDZDL=fgauss(istream,zdZdL0,divZa(ib))
    ZDRDL=fgauss(istream,zdRdL0,divRa(ib))
       
    !  SCRAPE OFF BEAM AT RECTANGULAR APERTURE
    !  ---------------------------------------

1150 CONTINUE

    ZDZA=ZDZDL*XLBAPA(IB)
    ZZAP=ZZGRD+ZDZA
    ZDRA=ZDRDL*XLBAPA(IB)
    ZRAP=ZRGRD+ZDRA
    IF(NBAPSHA(IB).EQ.1) THEN
       !  RECTANGULAR APERTURE
       IF(ABS(ZZAP-xzapoffa(ib)).GT.XZPEDGA(IB)) GOTO 10
       IF(ABS(ZRAP-xrapoffa(ib)).GT.RAPEDGA(IB)) GOTO 10
    ELSE
       !  CIRCULAR APERTURE
       ZRADAP=SQRT((ZZAP-xzapoffa(ib))**2+(ZRAP-xrapoffa(ib))**2)
       IF(ZRADAP.GT.RAPEDGA(IB)) GOTO 10
    ENDIF
       
    !  OPTIONAL 2ND APERTURE

    IF(XLBAPA2(IB).GT.0.0_R8) THEN
       ZDZA2=ZDZDL*XLBAPA2(IB)
       ZZAP2=ZZGRD+ZDZA2
       ZDRA2=ZDRDL*XLBAPA2(IB)
       ZRAP2=ZRGRD+ZDRA2
       IF(NBAPSH2(IB).EQ.1) THEN
          !  RECTANGULAR APERTURE
          IF(ABS(ZZAP2-xzapoff2(ib)).GT.XZPEDG2(IB)) GOTO 10
          IF(ABS(ZRAP2-xrapoff2(ib)).GT.RAPEDG2(IB)) GOTO 10
       ELSE
          !  CIRCULAR APERTURE
          ZRADAP2=SQRT((ZZAP2-xzapoff2(ib))**2+(ZRAP2-xrapoff2(ib))**2)
          IF(ZRADAP2.GT.RAPEDG2(IB)) GOTO 10
       ENDIF

    ENDIF
    !----------------------------------

    !  GOT A VIABLE PARTICLE TRAJECTORY
    !  --------------------------------

    !  DMC-- DEAL WITH BEAMLINE NOT PLL TO MIDPLANE

    ZDYMP=XYBAPA(IB)-XYBSCA(IB)
    IF(ZDYMP.EQ.0.0_R8) THEN
       ZSINY=0.0_R8
       ZCOSY=1.0_R8
       ZTHET0=0.0_R8
    ELSE
       ZSINY=ZDYMP/XLBAPA(IB)
       ZCOSY=SQRT(1.0_R8-ZSINY*ZSINY)
       ZTHET0=ATAN(ZSINY/ZCOSY)
    ENDIF

    !  FOLLOWING QUANTITIES INCLUDE CORRECTION FOR DEVIATION OF SELECTED
    !  SIGHTLINE FROM BEAM CENTERLINE

    !  DISTANCE, APERTURE TO TANGENCY RADIUS, PROJECTED TO MIDPLANE
    !  WITH CORRECTION FOR TILT OF APERTURE PLANE
    !   NOTE SIGN CONVENTION: ZSINY.LT.0.0 IF BEAMLINE IS COMING DOWN
    !  FROM ABOVE (CORRESPONDING TO A NEGATIVE THETA ARGUMENT FOR
    !  TRAKRB).

    ZLBMP=(XLBTNA(IB)-XLBAPA(IB))*ZCOSY + ZZAP*ZSINY

    !  DISTANCE, SCE TO APERTURE, PROJECTED TO MIDPLANE

    ZLBMPA=XLBAPA(IB)*ZCOSY - ZDZA*ZSINY

    !  FIND YSTA AND RSTA

    YSTA=ZZAP*ZCOSY+XYBAPA(IB)
    RSTA=SQRT((ZRTCEN-ZRAP)**2+ZLBMP**2)

    !  FIND PHIA AND THEA

    !  POSITIVE ZRAP, ZDRA MAKE BEAMLET MORE PERP (==> SMALLER PHIA)

    zphil = atan(zrtcen/(zcosy*xlbtna(ib)))  ! angle from beam sightline 
    ! to axis on equatorial plane

    !  COMPONENT, SCE TO APERTURE
    ZPHI0=ATAN(ZDRA/ZLBMPA)
    !  COMPONENT, FROM PT. CROSSING APERTURE PLANE ON IN
    PHIA=ATAN((ZRTCEN-ZRAP)/ZLBMP)
    !  ADD
    esta=phia-zphil   ! zeta angle relative to source
    PHIA=PHIA-ZPHI0

    IF(.NOT.ilccw) then
       PHIA=-PHIA    ! radians (unlike nubeam/nbline.for)
       esta=-esta
    end if
    esta=xbzeta(ib)*degrad + esta  !  make angle absolute in zeta -- radians

    !  NOTE THAT THEA IS **NOT** SIMPLY TAN(ZDZDL) SINCE
    !  DL NEEDS TO BE PROJECTED FROM THE TRAJECTORY DOWN TO THE
    !  HORIZONTAL MIDPLANE FIRST, RATHER THAN BEING THE GRID-NORMAL

    !  DMC-- ADD THETA CONTRIBUTION DUE TO BEAMLINE ITSELF

    THEA=ATAN(ZDZDL/SQRT(1.0_R8+ZDRDL**2))+ZTHET0   ! radians

    !-----------------
    !  load trajectory

    trajectory%Rsta = rsta*Z001
    trajectory%Phista = esta
    trajectory%Zsta = ysta*Z001

    !  normalized velocity components
    !  note -pi/2 < THEA < pi/2; cos(THEA) > 0

    trajectory%vZ = sin(THEA)

    zcosth = cos(THEA)
    trajectory%vR = -zcosth*cos(PHIA)  ! PHIA=0 -- dead perp inward injection
    trajectory%vPhi = zcosth*sin(PHIA) ! +PHIA: in CCW direction

  end subroutine ps_nbline_sub

end module ps_nbline_module

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_p9_dummy
     return
  end subroutine ccps_getset_p9_dummy

subroutine psget_psmom_nc(iobj, n1, n2, data, ierr)
    !! PS moments, (1:npsmom) Pfirsch-Schlutter moments (NCLASS),
    !! convergence check: sum[j=1:infinity](psmom_nc(:,j))=
    !! gb2(:)*ngradb2_av(:)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_psmom_nc', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % psmom_nc
end subroutine psget_psmom_nc


subroutine psset_psmom_nc(iobj, n1, n2, data, ierr)
    !! PS moments, (1:npsmom) Pfirsch-Schlutter moments (NCLASS),
    !! convergence check: sum[j=1:infinity](psmom_nc(:,j))=
    !! gb2(:)*ngradb2_av(:)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_psmom_nc', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % psmom_nc = data(1:n1, 1: n2)
end subroutine psset_psmom_nc


subroutine psgetrnk_psmom_nc(iobj, ndims, ierr)
    !! PS moments, (1:npsmom) Pfirsch-Schlutter moments (NCLASS),
    !! convergence check: sum[j=1:infinity](psmom_nc(:,j))=
    !! gb2(:)*ngradb2_av(:)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_psmom_nc


subroutine psgetdim_psmom_nc(iobj, ndims, dims, ierr)
    !! PS moments, (1:npsmom) Pfirsch-Schlutter moments (NCLASS),
    !! convergence check: sum[j=1:infinity](psmom_nc(:,j))=
    !! gb2(:)*ngradb2_av(:)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_psmom_nc', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % psmom_nc ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % psmom_nc)
    endif
end subroutine psgetdim_psmom_nc


subroutine psget_pmine(iobj, n1, data, ierr)
    !! electron heating by minority ions
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_pmine', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % pmine
end subroutine psget_pmine


subroutine psset_pmine(iobj, n1, data, ierr)
    !! electron heating by minority ions
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_pmine', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % pmine = data(1:n1)
end subroutine psset_pmine


subroutine psgetrnk_pmine(iobj, ndims, ierr)
    !! electron heating by minority ions
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_pmine


subroutine psgetdim_pmine(iobj, ndims, dims, ierr)
    !! electron heating by minority ions
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_pmine', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % pmine ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % pmine)
    endif
end subroutine psgetdim_pmine


subroutine psget_pfuse(iobj, n1, data, ierr)
    !! electron heating by all fusion ions
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_pfuse', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % pfuse
end subroutine psget_pfuse


subroutine psset_pfuse(iobj, n1, data, ierr)
    !! electron heating by all fusion ions
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_pfuse', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % pfuse = data(1:n1)
end subroutine psset_pfuse


subroutine psgetrnk_pfuse(iobj, ndims, ierr)
    !! electron heating by all fusion ions
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_pfuse


subroutine psgetdim_pfuse(iobj, ndims, dims, ierr)
    !! electron heating by all fusion ions
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_pfuse', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % pfuse ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % pfuse)
    endif
end subroutine psgetdim_pfuse


subroutine psget_pilh_src(iobj, n1, n2, data, ierr)
    !! LH ion heating by antenna
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_pilh_src', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % pilh_src
end subroutine psget_pilh_src


subroutine psset_pilh_src(iobj, n1, n2, data, ierr)
    !! LH ion heating by antenna
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_pilh_src', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % pilh_src = data(1:n1, 1: n2)
end subroutine psset_pilh_src


subroutine psgetrnk_pilh_src(iobj, ndims, ierr)
    !! LH ion heating by antenna
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_pilh_src


subroutine psgetdim_pilh_src(iobj, ndims, dims, ierr)
    !! LH ion heating by antenna
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_pilh_src', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % pilh_src ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % pilh_src)
    endif
end subroutine psgetdim_pilh_src

program plasma_state_test

  !--------------------------------------------------------------------
  ! Demo program for use of plasma state component
  !
  ! Plasma State Vsn 2.00 -- December 10, 2007 (D. McCune)
  !
  ! (Original version D. McCune 9 Oct 2006)
  !
  !--------------------------------------------------------------------
  ! RB: added timers to code
  ! Wed May 16 12:20:10 EDT 2007
  !
  !--------------------------------------------------------------------
  !
  ! This routine demonstrates use of the IPS state interface.
  !
  !-----------------------------------
  ! The state contents are specified in "plasma_state_spec.dat".  This is
  ! input to a code generator which produces the state file i/o routines;
  ! an "internal" plasma state component interface is also defined; an
  ! implementation is provided using xplasma2.  The internal interface 
  ! is not currently documented.
  !
  !   Procedure for modifying the contents of state:
  !     1.  edit "plasma_state_spec.dat"
  !     2.  run the code generator script.
  !
  ! After the state definition is modified, old state files can still
  ! be examined (e.g. with a plotting tool) but may not be usable for
  ! simulation restarts.
  !
  ! DMC: I/O of version 2.00 state is based on NetCDF self describing
  ! file with separate variable for each state element (instead of 
  ! XPLASMA NetCDF I/O).  XPLASMA NetCDF files based on earlier state 
  ! software will not be readable.  Compatibility of future versions
  ! with files from earlier versions after 2.00 should be OK, but with 
  ! missing individual data items.
  !-----------------------------------
  !
  ! State elements are traditional f77 integer, floating point, and character
  ! string scalars and arrays all contained within a large container data 
  ! type "plasma_state".  Two instances of this container data type are
  ! declared in the module "plasma_state_mod":
  !
  !   ps -- the current state (timestep now being computed).
  !   psp -- the prior or "committed" state (completed, prior timestep)
  !
  ! Elements of the state can be referenced directly using the standard
  ! f95 syntax-- e.g. ps%nrho is the size of one of the radial flux 
  ! coordinate "rho" grids in the state.
  !
  ! State elements can be directly modified by codes that use the plasma
  ! state-- although this should be done carefully.  Generally, items in 
  ! the state are meant to be shared between multiple components of the 
  ! IPS; conventions for use of the state data will need to evolve.
  !
  ! States will be mapped to NetCDF files.  The module "plasma_state_mod"
  ! defines two variables for these filenames:
  !
  !   CHARACTER*256 :: state_file = 'plasma_state.cdf'
  !   CHARACTER*256 :: prior_file = 'prior_state.cdf'
  !
  ! RB: actually, those two names are set up in the call to ps_init_tag. 
  !
  ! The assigned default values can of course be modified.
  !-----------------------------------
  ! Version 2.00 software:
  ! Non-profile state data is split into sections:
  !
  ! set up during initialization; subsequently time invariant:
  !    MACHINE_DESCRIPTION   (e.g. limiter description; beam geometries)
  !    SHOT_CONFIGURATION    (e.g. species lists)
  !    SIMULATION_INIT       (e.g. grid resolutions)
  !
  ! initial condition set; time evolved after initialization:
  !    STATE_DATA
  !
  ! There will be a possibility for exceptions to the time invariance
  ! of initialization sections, but generally, special code will be
  ! needed.  For example, if a grid is redefined, all profiles using 
  ! the grid would require interpolation.
  !-----------------------------------
  ! In addition to direct access to state data elements, the module
  !
  !    use plasma_state_mod
  !
  ! defines a subroutine interface which allows states to be loaded from
  ! or written out to files, support various steps during initialization,
  ! support profile interpolation, etc... For details, see the comments
  ! in plasma_state_mod.f90
  !
  ! Many of these routines are exercised here.  The code in this test
  ! program may serve as a suitable template for some applications, but,
  ! some will require a different approach.
  !-----------------------------------
  ! Profile IDs:  each state array that is defined over one or more coordinate
  !   grids is assigned an ID variable or array with name ID_<name>.  These IDs
  !   are needed to refer to specific profiles for interpolation or rezoning.
  !
  !   Examples mapping from plasma_state_spec.dat to plasma state object "ps":
  !
  !      R|units=ohm*m|Hermite eta_parallel(nrho)  
  !                            ! parallel electrical resistivity
  !
  !      -> ps%eta_parallel(...)  (1d allocated REAL(KIND=rspec) array)
  !                        (1:ps%nrho)
  !
  !      -> ps%id_eta_parallel    INTEGER scalar
  !
  !      R|units=m^-3|step  ns(~nrho,0:nspec_th)       ! thermal specie density
  !
  !      -> ps%ns(...)     (2d allocated REAL(KIND=rspec) array
  !      -> ps%id_ns(...)  (1d allocated INTEGER array)
  !
  !              ps%ns(1:ps%nrho-1,0:ps%nspec_th)
  !              ps%id_ns(0:ps%nspec_th)
  !
  ! Because this data is a zone oriented "step function", the number of
  ! radial points is ps%nrho-1; each zone is between two successive grid
  ! points.
  !
  ! The ID variables are handles used for interpolation.  For details on
  ! available interpolation calls, see the comments in "plasma_state_mod.f90".
  !
  ! Some examples are presented in this code.
  ! 
  !-----------------------------------
  ! Implementation of interpolation and rezoning-- the "visible" state
  ! elements ps%* and psp%* are not the entire state.  When interpolation
  ! and rezoning operations are carried out, additional hidden information--
  ! such as spline coefficients-- is accessed depending on the interpolation
  ! method given in the state specification.
  !
  ! Interpolation methods for profiles are part of the state specification
  ! "plasma_state_spec.dat" and are handled by generated code.
  !
  ! However, since applications have direct access to the profile data, they
  ! can separately define their own interpolation methods if needed.
  !-----------------------------------

  ! define state object and interface...

  USE plasma_state_mod

  IMPLICIT NONE

  !------------------------------------
  !  local
  INTEGER :: ierr,ier1,ier2,ier3
  INTEGER :: iout = 6

  !  for this simple demo, all profiles will vary as:
  !    (<core_value>-<edge_value>)*(1-rho**2)**2 + <edge_value> -- cf profgen

  REAL(KIND=rspec) :: time0 = 0.1_rspec      ! s -- time of start of "run".
  REAL(KIND=rspec) :: delta_t = 0.01_rspec   ! s -- initial time step size

  REAL(KIND=rspec) :: T0 = 5.0_rspec   ! KeV at core
  REAL(KIND=rspec) :: Ta = 0.1_rspec   ! KeV at edge

  REAL(KIND=rspec) :: den0 = 1.0e20_rspec  ! #/m^3 electrons at core
  REAL(KIND=rspec) :: dena = 0.2e20_rspec  ! #/m^3 electrons at edge

  REAL(KIND=rspec) :: Zeff0 = 1.2_rspec    ! Z_eff at core
  REAL(KIND=rspec) :: Zeffa = 2.0_rspec    ! Z_eff at edge

  REAL(KIND=rspec) :: Aimp_atom = 12.011_rspec ! Carbon A

  REAL(KIND=rspec) :: frac_mino = 0.01_rspec  ! n_minority/n_e
  integer :: iZ_mino = 1   ! Z of minority (H)
  integer :: iA_mino = 1   ! A of minority (H)

  integer :: iz_imp = 6               ! Z of impurity (C)
  integer :: iz_imp2 = 26             ! Z of 2nd impurity (Fe)
  real*8 :: zimp

  REAL(KIND=rspec), dimension(:), allocatable :: Zeff,rho_zc

  integer :: i,ii,jj,ith,ict,inum,nrho,nrho_zc,isave
  integer :: id,ids(2)
  integer :: icomp,idiff,i_nonzero

  REAL(KIND=rspec) :: zne_adj,zzne_adj,zrho,zdvol
  REAL(KIND=rspec) :: ZERO= 0.0_rspec
  REAL(KIND=rspec) :: ONE = 1.0_rspec
  REAL(KIND=rspec) :: vpp0,ppp0,zansR0,zansZ0
  REAL(KIND=rspec) :: test_Rmin,test_Rmax,zdiff1,zdiff2
  REAL(KIND=rspec) :: test_Zmin,test_Zmax

  REAL(KIND=rspec), dimension(:), allocatable :: zdvola,zdvolc
  REAL(KIND=rspec), dimension(:), allocatable :: rho_intrp,th_intrp
  REAL(KIND=rspec), dimension(:), allocatable :: dvdrho,dpsidrho
  REAL(KIND=rspec), dimension(:,:), allocatable :: buf2

  REAL(KIND=rspec), dimension(:), allocatable :: rho_bdys,dvols
  REAL(KIND=rspec), dimension(:,:), allocatable :: my_ns,my_ts,my_ns2,my_ts2
  REAL(KIND=rspec), dimension(:), allocatable :: my_ns1,my_ts1
  REAL(KIND=rspec), dimension(:,:,:), allocatable :: my_profa,my_profb,my_profc
  REAL(KIND=rspec), dimension(:), allocatable :: zvols,ttest1,ttest2,ttest3
  REAL(KIND=rspec), dimension(:), allocatable :: volref_ns,volref_nt
  REAL(KIND=rspec), dimension(:), allocatable :: volint_ns,volint_nt
  REAL(KIND=rspec), dimension(:), allocatable :: maxdiff_ns,maxdiff_nt
  REAL(KIND=rspec), dimension(:), allocatable :: dmaxn,dmaxt,zb_test

  REAL(KIND=rspec), dimension(:,:), allocatable :: tha_test
  REAL(KIND=rspec) :: test_voltot(1)

  REAL(KIND=rspec), parameter :: small_n=1.0_rspec
  REAL(KIND=rspec), parameter :: small_T=1.0e-20_rspec
  
  TYPE (plasma_state) :: my_state       ! used for un-initialized state test

  !-----------------------
  !  unified plasma parameter arrays (on ps%nspec_alla list)
  !    abridged thermal species + all fast species combined.
  integer :: ipts,nrho_user,nrhop1
  REAL(KIND=rspec), dimension(:), allocatable :: rho_user, rho_bdy_rezon
  REAL(KIND=rspec), dimension(:), allocatable :: dense,tempe
  REAL(KIND=rspec), dimension(:,:), allocatable :: densi,tempi
  REAL(KIND=rspec), dimension(:), allocatable :: wk_eperp,wk_epll,wk_dens
  !-----------------------

  !-----------------
  ! Timing variables
  !-----------------
  REAL(KIND=rspec) :: t1, t2, t3, t4, t5, t_overall

  integer :: iarg,narg,iwarn
  character*32 argval

  integer :: cclist(ps_ccount)

  !------------------------------------
  ! When starting a simulation, there is no prior state.
  ! To create a state from scratch:
  !   a) specify state array dimensions (could be e.g. by a namelist read)
  !   b) apply a global label to the plasma state data (e.g. name of a program)
  !      set the initial time.
  !   c) allocate state arrays
  !   d) fill in names and values where appropriate for all non-coordinate
  !      array dimensions:  species lists, RF antenna lists, NB injector
  !      lists, ...
  !   e) acquire initial MHD equilibrium
  !   f) acquire initial conditions-- e.g. temperatures and densities for
  !      each species.
  !   g) store and commit the initial state-- now both a current and prior
  !      state exist, and time dependent simulation can commence.
  !
  ! Elements of the current state are in ps%<element-names>(indices,...)
  ! Elements of the prior state are in  psp%<element-names>(indices,...)
  !------------------------------------

  !==========================================================================
  !  Contents of "ps" are defined in "plasma_state_spec.dat"

  !==========================================================================
  ! (a) array dimensions -- set ONLY ONCE at start of simulation...
  !     (the values here are chosen somewhat arbitrarily).

  ! activate some extra debugging output
  ! default value of ps_debug is 0, for quiet operation
  ! set ps_debug = 2 or 3 for even more extra output

  write(iout,*) ' ==> plasma_state_test'
  write(iout,*) '     generated plasma state software version: ',trim(ps_version_id)
  write(iout,*) ' '

  t_overall = mytime()

  ps_debug = 2

  ! DMC 6 June 2007 -- add command argument to allow modification of
  ! debug switch:   "debug=0", "debug=1", "debug=2", or "debug=3"

  call get_arg_count(narg)
  do iarg=1,narg
     call get_arg(iarg,argval)
     call ulower(argval)  ! force lowercase
     if(argval.eq.'debug=0') ps_debug = 0
     if(argval.eq.'debug=1') ps_debug = 1
     if(argval.eq.'debug=2') ps_debug = 2
     if(argval.eq.'debug=3') ps_debug = 3
  enddo
  write(iout,'(1x,a,1x,i1/)') ' plasma_state_test debug level: ',ps_debug

  ! PLASMA...

  ps%nspec_th = 7     ! 7 thermal ion species, 6 impurity-charge-states
  ps%nspec_rfmin = 1  ! 1 RF minority specie

  !  ps%nspec will be computed when the state is allocated
  !    see state specification "plasma_state_spec.dat".

  ps%nrho = 101       ! OK, a grid for the plasma component
  ps%nrho_rw = 26     ! OK, a grid for the runaway electron component

  ! ICRF...

! ps%nicrf_src = 1    ! ONE antenna...
  ps%nicrf_src = 2    ! two antennas  LAB..
  CALL ps_alloc_plasma_state(ierr)
  call ckerr('ps_alloc_plasma_state')
    
  ps%ant_model(1) = 'icrf_antenna model_1'
  ps%ant_model(2) = 'icrf_antenna model_2'
  ps%n_straps(1) = 3  ! straps for first source
  ps%n_straps(2) = 4  ! straps for second source
  ps%num_nphi_vac(1) = 128 ! vac modes for antenna
  ps%num_nphi_vac(2) = 128 ! vac modes for antenna
  ps%num_nphi(1) = 12 ! used modes for antenna
  ps%num_nphi(2) = 12 ! used  modes for antenna
  CALL ps_alloc_plasma_state(ierr)
  call ckerr('ps_alloc_plasma_state')
  ps%nrho_icrf = 61   ! OK, a grid for the IC component

  ps%nphi(1:12,1) = (/ (i, i=0,11) /)  ! for unique label
  ps%nphi(1:12,2) = (/ (i, i=0,11) /)
  ps%wt_nphi      = 1._rspec           ! nonzero weight required by namelist check

  ! Equilibrium -- R and Z grid sizes will be reset when first G-eqdsk is read.
  !   (The G-eqdsk R and Z grids are used).

  ps%nrho_eq = 51     ! Grids for EQ
  ps%nth_eq = 101
  ps%nR = 0
  ps%nZ = 0

  !----------------------------------------------------------------
  ! (b) Global label for state data (as will appear in state files)
  !     Here the program name "plasma_state_test" is used, but it is likely
  !     better to use a runid -- ID string to uniquely identify a specific
  !     run or simulation
  ! RB: added the version id to the state label.
  !----------------------------------------------------------------

  ps%Global_Label = 'plasma_state_test_'//trim(ps_version_id)//' (test)'
  ps%RunID = 'Test'

  ps%Tokamak_ID = 'Dummy'
  ps%Shot_Number = 12345

  !----------------------------------------------------------------
  ! NOTE: for this application I use a very simple error handling method:
  !   if ierr.NE.0 print a message and exit, in contained subroutine "ckerr".
  !   Real applications will require something more than this.
  !----------------------------------------------------------------

  !  the initial times.  The first state does not really represent a timestep
  !  so both the start time ps%t0 and the final time ps%t1 are set:

  ps%t0 = time0
  ps%t1 = time0

  !-------------------------
  ! (c) Initial allocation of state arrays.  All integers and floats are
  ! initialized to ZERO; all character strings to blank

  ! Note, it is possible to call this several times, providing additional
  ! non-zero array dimensions on each call, BUT: once a non-zero dimension
  ! has been supplied, the rule for now is that it cannot be changed!  This
  ! routine enforces the rule by checking all arrays prior to allocation,
  ! and checking the sizes of arrays already allocated against their
  ! corresponding array dimension variables in the state.  Generated 
  ! code is used to do this.

  CALL ps_alloc_plasma_state(ierr)
  call ckerr('ps_alloc_plasma_state')

  !==========================================================================
  ! (d) Define names of list elements.
  !
  ! Explanation:
  ! Array dimensions come in two flavor:
  !    1.  Grid dimensions -- e.g. along rho, theta, R, Z
  !    2.  List dimensions -- e.g. species index, RF antenna index, ...
  ! Each element of each list dimension must have a tag name associated
  ! with it, so that distinct names can be provided for every profile
  ! over the grid dimensions.  For example, the state array:
  !
  !  R|units=MW/m^3|step prf_srcs(~nrho_icrf,nicrf_src,0:nspec)
  !                    ! RF power deposition
  !
  ! defines (ps%nicrf_src * (ps%nspec + 1)) profiles vs. rho.  In the state
  ! output files these will be gathered as a list "PRF_SRCS" containing
  ! elements with such names as:
  !    "PRF_SRCS_ANT1_E" (heating from Antenna#1 to electrons)
  !    "PRF_SRCS_ANT1_D" (heating from Antenna#1 to deuterons)
  !    "PRF_SRCS_ANT1_C6" (heating from Antenna#1 to Carbon impurity)
  !    "PRF_SRCS_ANT3_HMINO" (heating from Antenna#3 to H-minority)
  !       ...
  !       ...
  !    "PRF_SRCS_ANT3_HMINO" (heating from Antenna#3 to H-minority)
  ! I.e. if there are 3 antennas and 4 species {e,D,C,Hmino}, there would
  ! be 4 profiles, each separately named and available (e.g. for plotting).
  !
  ! But, these names can only be generated if the tag names for all elements
  ! of the list dimensions are defined first.
  !
  ! (The plasma state cannot be saved to a file until all tag names are 
  ! defined; duplicate tags within a list dimension are not allowed).
  !
  ! (The names are used in state visualization tools such as "cstate").
  !
  !-------------------------
  ! 1. Define species lists tag names...
  !
  !  The procedure here is to load the charge and mass of each species
  !  and then call PS_LABEL_SPECIES(...).
  !
  !  In the state, integer atomic numbers, ion charges, and ion masses
  !  are mapped to REAL(KIND=rspec) charges (C) and masses (kg).
  !
  !  If starting from integer atomic #, charge #, and AMU mass, it is
  !  convenient to use PS_SPECIES_CONVERT(...) to do the conversion
  !
  !  CALL ps_species_convert(atomic#, charge#, AMU-nearest-integer, &  ! input
  !                 atomic-charge, ion-charge, mass, ierr)             ! output
  !
  !  The AMU-nearest-integer argument is only used for H and He isotopes;
  !  it is ignored for all other elements...
  !
  !  various combinations of the first three arguments and their meaning:
  !
  !  (-1,-1,0) -- electrons -- 2nd and 3rd arguments ignored.
  !
  !  (1,1,1) -- H ion  --> "H"
  !  (1,1,2) -- D ion  --> "D"
  !  (1,1,3) -- T ion  --> "T"
  !  (2,2,3) -- He3 (fully stripped) --> "He3"
  !  (2,2,4) -- He4 (fully stripped) --> "He4"
  !  (2,1,4) -- He4 charge +1 --> "He4_1"
  !  (6,6,0) -- C (Carbon) (fully stripped) -- AMU (3rd) arg ignored. --> "C"
  !  (6,4,0) -- C (Carbon) charge +4 -- AMU (3rd) arg ignored. --> "C_4"
  !
  !  DMC -- multiple charge states defined but only C+6 will be given
  !         non-zero density (to exercise naming logic for derived species
  !         lists in presence of multiple impurities and charge states)

  CALL ps_species_convert(-1, -1, 0, &
       ps%qatom_s(0), ps%q_s(0), ps%m_s(0), ierr)  ! electron (species 0)
  CALL ckerr('ps_species_convert')

  CALL ps_species_convert(1, 1, 2, &
       ps%qatom_s(1), ps%q_s(1), ps%m_s(1), ierr)  ! Deuterium (species 1)
  CALL ckerr('ps_species_convert')

  CALL ps_species_convert(iz_imp, iz_imp, 0, &
       ps%qatom_s(2), ps%q_s(2), ps%m_s(2), ierr)  ! Carbon +6 (species 2)
  CALL ckerr('ps_species_convert')

  CALL ps_species_convert(iz_imp, iz_imp-1, 0, &
       ps%qatom_s(3), ps%q_s(3), ps%m_s(3), ierr)  ! Carbon +5 charge state
  CALL ckerr('ps_species_convert')

  CALL ps_species_convert(iz_imp, iz_imp-2, 0, &
       ps%qatom_s(4), ps%q_s(4), ps%m_s(4), ierr)  ! Carbon +4 charge state
  CALL ckerr('ps_species_convert')

  CALL ps_species_convert(iz_imp2, iz_imp2, 0, &
       ps%qatom_s(5), ps%q_s(5), ps%m_s(5), ierr)  ! Iron +26 (species 5)
  CALL ckerr('ps_species_convert')

  CALL ps_species_convert(iz_imp2, iz_imp2-1, 0, &
       ps%qatom_s(6), ps%q_s(6), ps%m_s(6), ierr)  ! Iron +25 charge state
  CALL ckerr('ps_species_convert')

  CALL ps_species_convert(iz_imp2, iz_imp2-2, 0, &
       ps%qatom_s(7), ps%q_s(7), ps%m_s(7), ierr)  ! Iron +24 charge state
  CALL ckerr('ps_species_convert')

  !  *** fast species ***
  !  ALL (1:nspec_nonMax) MUST BE LABELED!
  !    suffix argument set -- fast species
  !
  !  (I have used suffixes "mino", "beam", and "fusn" for RF minority, beam,
  !  and fusion product ions respectively -- dmc).
  !
  !  Hydrogen minority -- "mino" suffix suggested...
  !  element (1) of the "rfmin" species list.

  CALL ps_species_convert(1, 1, 1, &
       ps%qatom_rfmin(1), ps%q_rfmin(1), ps%m_rfmin(1), ierr)  ! Hydrogen
  CALL ckerr('ps_species_convert')

  !  ** AFTER all species are defined, they need to be labeled:
  !     Here error checks are performed: e.g. if fewer species were defined
  !     than were promised e.g. by the setting of ps%nspec_th.

  !  This routine is called only after the following species lists have
  !  had their qatom, q, and m arrays completely filled out:
  !
  !     Thermal species "s" -- mandatory
  !     Neutral beam species "snbi" -- only required if beams are present.
  !     RF minority species "rfmin" -- only required if RF minorities present.
  !     Fusion product species "sfus" -- only required if there are fusion 
  !                                    products.
  !
  !  In this test application, only "s" and "rfmin" species lists have been
  !  allocated and filled out.

  CALL ps_label_species(ierr)
  CALL ckerr('ps_label_species')

  !----------------------------------
  !  form combined species list -- some arrays e.g. RF power coupling will
  !    want to be defined over a combined list with all species, thermal
  !    and non-thermal alike.  So:

  CALL ps_merge_species_lists(ierr)
  CALL ckerr('ps_merge_species_lists')

  !  The above call creates the combined species list "all", and:
  !    "abridged" thermal species list "sa"
  !    "abridged" all species list "alla"

  !  The abridged lists merge all impurities down to 2 impurities which
  !  will have their densities computed by the Zeff and Quasi-neutrality 
  !  equations from the full list.  Here, "impurity" is defined as a thermal
  !  specie with Z >= Zimp; by default Zimp=3 but this is adjustable by an
  !  optional argument in the PS_LABEL_SPECIES call.
  
  !----------------------------------
  !  Form list of neutral gas species e.g. for a gas-fueling model
  !  This is formed from thermal ion species with Z<=Zmax; by default Zmax=2
  !  but this can be reset by an optional argument (for details see the
  !  comments in plasma_state_mod.f90).

  CALL ps_neutral_species(ierr)
  CALL ckerr('ps_neutral_species')
  !----------------------------------

  !  Print out combined species list...

  do ii=0,ps%nspec_all
     write(iout,1001) ii,ps%all_type(ii), &
          trim(ps%all_name(ii)),ps%q_all(ii),ps%m_all(ii)
  enddo
1001 format(' Specie index & type: ',i2,1x,i2,1x, &
          '"',a,'" charge & mass: ',2(1pe12.5,1x))

  !------------------------------------
  ! (d) continued: lists other than species lists...
  ! Define antenna list
  ! ALL (1:nicrf_src) MUST BE LABELED!

  ps%icrf_src_name(1) = 'Ant_1'
  ps%icrf_src_name(2) = 'Ant_2'

  ! additional lists -- e.g. of neutral beams -- could be added to the state
  ! and defined...

  !==========================================================================
  ! (e) Initialize (rho,theta) grids -- use local CONTAIN'ed routine below...

  CALL rho_grid(ps%nrho_rw,   ps%rho_rw)
  CALL rho_grid(ps%nrho_icrf, ps%rho_icrf)
  CALL rho_grid(ps%nrho,      ps%rho)

  ! Note: all grids must be defined before the state can be written to file.
  ! The following step defines the equilibrium and its grids.

  !==========================================================================
  ! (f) initial equilibrium
  !    Here I simply take an existing (old NSTX) equilibrium G-eqdsk file
  !    The R and Z grids will be allocated (along with associated profile
  !    arrays on the first call to "ps_update_equilibrium".  It is assumed,
  !    at least for now, that the range and resolution of the R and Z grids,
  !    once established, will not change in time.

  !    A number of profiles corresponding to metric quantities and flux
  !    surface averages are also computed in this call

  !  this routine also initializes the ps%rho_eq and ps%th_eq grids
  !  on its first call
  
  ps%V_loop = 2.0
  
  write(iout,'(1x,a,1pe12.5)') 'loop voltage at center: ',ps%V_loop(1)
  write(iout,'(1x,a,1pe12.5)') 'loop voltage at edge:   ',ps%V_loop(ps%nrho)
  
  ! "slightly" non-default value of bdy_crat provided; default is 0.075d0.

  t1 = mytime()
  write(iout,*) ' '
  write(iout,'(1x,a)') ' -- building plasma state equilibrium from g file -- '
  CALL ps_update_equilibrium(ierr, g_filepath='g104403.nstx', &
       bdy_crat = 0.075001d0 )
  call ckerr('ps_update_equilibrium')

  t1 = mytime() - t1
  write(iout,'(1x,a,t34,1pe10.3)') 'Time for ps_update_equilibrium: ', t1

  call ps_momtest(ps,iout,ierr)
  call ckerr('ps_momtest')

  !----------------------
  ! (f2) flux surface averages, etc., derived from equilibrium
  !      stuff like <|grad(rho)|^2/R^2> that ends up used in transport
  !      equations; neoclassical moments; elongation; triangularity...

  t1 = mytime()
  write(iout,*) ' '
  write(iout,'(1x,a)') ' -- computing equilibrium derived profiles -- '

  ! ** the derived quantities are written on a different grid than the
  !    primary equilibriumk quantities **

  ! in this instance I choose to use the same grid for the geometric profiles
  ! as was used for the original equilibrium.

  ps%nrho_eq_geo = ps%nrho_eq

  CALL ps_alloc_plasma_state(ierr)
  call ckerr('ps_alloc_plasma_state')

  ps%rho_eq_geo = ps%rho_eq  ! use same grid

  !----
  ! the grid is also used for the computation, but, a coarser grid could
  ! be used if performance becomes an issue...
  !----

  write(iout,*) ' '
  write(iout,*) ' (ps_mhdeq_verify call as debug test-- not required)'
  call ps_mhdeq_verify(ierr,pcur=ps%curt(ps%nrho_eq))
  call ckerr('ps_mhdeq_verify')
  
  write(iout,*) ' '
  write(iout,*) ' -- flux surface computations -- '
  call ps_mhdeq_derive('Everything',ierr)
  call ckerr('ps_mhdeq_derive')

  t1 = mytime() - t1
  write(iout,'(1x,a,t34,1pe10.3)') 'Time for ps_mhdeq_derive: ', t1

  !==========================================================================
  ! (f1) machine description and shot configuration sections completed
  ! setting locks causes further changes to be flagged as errors.  Here
  ! also, calls are made to exerciste machine description and shot 
  ! configuration namelist I/O routines.

  CALL ps_update_hashCodes(ierr, mdescr_lock=.TRUE., sconfig_lock=.TRUE.)

  write(iout,*) ' '
  write(iout,*) ' plasma_state_test: locked machine description (mdescr).'
  write(iout,*) ' plasma_state_test: locked shot configuration (sconfig).'

  write(iout,*) '   mdescr namelist write test...'
  call ps_mdescr_write('mdescr_sample_namelist.dat',ierr)
  call ckerr('ps_mdescr_write')

  write(iout,*) '   sconfig namelist read test...'
  call ps_sconfig_write('sconfig_sample_namelist.dat',ierr)
  call ckerr('ps_sconfig_write')

  ! read these namelists into a separate state object

  write(iout,*) '   mdescr namelist read test...'
  call ps_mdescr_read('mdescr_sample_namelist.dat',ierr, state=aux)
  call ckerr('ps_mdescr_write')

  write(iout,*) '   sconfig namelist read test...'
  call ps_sconfig_read('sconfig_sample_namelist.dat',ierr, state=aux)
  call ckerr('ps_sconfig_write')

  ! store to file
  CALL ps_store_plasma_state(ierr, state=aux)

  write(iout,*) ' namelist I/O tests completed.'

  !==========================================================================
  ! (g) initial profiles

  !------------------------------------------------
  !  densities -- ps%ns(1:ps%nrho-1,0:ps%nspec_th)
  !     step function zone oriented data

  !  zone centered grid (construct local copy)

  nrho_zc = ps%nrho - 1
  allocate(rho_zc(nrho_zc))
  rho_zc = (ps%rho(1:nrho_zc) + ps%rho(2:ps%nrho))/2

  !   electron density
  call profgen(den0, dena, rho_zc, ps%ns(:,0))

  !   D and impurity density...
  !   will use ne*Zeff = sum[i]((Z[i]^2*n[i])
  !        and      ne = sum[i](Z[i]*n[i])

  !   and account for depletion by minority ion species

  allocate(Zeff(nrho_zc))

  call profgen(Zeff0, Zeffa, rho_zc, Zeff)  ! Zeff profile

  Zimp = ps%q_s(2)/ps_xe  ! Zimp (=6)

  do i=1,nrho_zc
     !  depletion due to RF minority species
     zne_adj = (ONE-frac_mino*iZ_mino)*ps%ns(i,0)
     zzne_adj = ps%ns(i,0)*Zeff(i) - iZ_mino**2*frac_mino*ps%ns(i,0)

     !  thermal species  sum n*Z = zne_adj
     !                   sum n*Z**2 = zzne_adj

     !  in this little test program there are only 2 ion species, so this
     !  is 2 eqns in 2 unknowns.  In real codes, a mix of multiple non-
     !  impurity species becomes part of the initial condition...

     !         nD + nimp*Zimp = zne_adj
     !         nD + nimp*Zimp*Zimp = zzne_adj

     !         nimp = (zzne_adj-zne_adj)/(Zimp*(Zimp-1))
     !         nD   = (zne_adj*Zimp-zzne_adj)/(Zimp-1)

     ps%ns(i,1) = (zne_adj*Zimp-zzne_adj)/(Zimp-ONE)   ! nD
     ps%ns(i,2) = (zzne_adj-zne_adj)/(Zimp*(Zimp-ONE)) ! nimp (C)
     ps%Zeff(i) = Zeff(i)
  enddo

  i_nonZero=2  ! non-zero densities up to this index only...

  !------------------------------------------------
  !  Temperatures -- ps%Ts(1:ps%nrho-1,0:ps%nspec_th)
  !     step function zone oriented data

  !  Here, all receive the same temperature

  do ith=0,ps%nspec_th
     call profgen(T0, Ta, rho_zc, ps%TS(:,ith))
  enddo
  
  !  Compute test volume integrals, based on profile of EQ volumes
  allocate(zvols(ps%nrho),volref_ns(0:ps%nspec_th),volref_nt(0:ps%nspec_th))
  allocate(maxdiff_ns(0:ps%nspec_th),maxdiff_nt(0:ps%nspec_th))
  allocate(dmaxn(0:ps%nspec_th),dmaxt(0:ps%nspec_th))

  !  Use interpolation call *** get volume on "nrho" grid
  call ps_intrp_1d(ps%rho, ps%id_vol, zvols, ierr)
  call ckerr('ps_intrp_1d')

  do ith=0,ps%nspec_th
     maxdiff_ns(ith)=ZERO
     maxdiff_nt(ith)=ZERO

     volref_ns(ith)=ZERO
     volref_nt(ith)=ZERO
     do i=1,ps%nrho-1
        zdvol = zvols(i+1)-zvols(i)
        volref_ns(ith)=volref_ns(ith) + zdvol*ps%ns(i,ith)
        volref_nt(ith)=volref_nt(ith) + zdvol*ps%ns(i,ith)*ps%Ts(i,ith)
     enddo
  enddo

  !  store plasma parameters so these can be used to fill minority 
  !  profiles -- involves interpolation to a different grid

  isave = ps_debug
  ps_debug = 0

  call ps_state_memory_update(ierr,eqcheck=.FALSE.)
  call ckerr('ps_state_memory_update')

  ps_debug = isave

  !---------------------------------------
  !  Minority parameters... derived from plasma parameters, ad hoc

  call ps_rho_rezone(ps%rho_icrf, ps%id_ns(0), ps%nmini(:,1), ierr)
  call ckerr('ps_rho_rezone (set up minority Eperp)')
  ps%nmini(:,1) = ps%nmini(:,1) * frac_mino

  call ps_rho_rezone(ps%rho_icrf, ps%id_Ts(1), ps%eperp_mini(:,1), ierr)
  call ckerr('ps_rho_rezone (set up minority Eperp)')

  ps%eperp_mini(:,1) = ps%eperp_mini(:,1)*10.0_rspec
  ps%epll_mini(:,1) = ps%eperp_mini(:,1)/2.0_rspec
  write(iout,'(1x,a,3(1x,1pe12.5)/)') &
       ' minority density, Eperp, Epll on axis:',ps%nmini(1,1), &
       ps%eperp_mini(1,1),ps%epll_mini(1,1)

  !---------------------------------------

  !------------------------------------
  write(iout,'(1x,a)') ' '
  write(iout,'(1x,a)') ' I/O tests ...'
  write(iout,'(1x,a)') ' '
  write(iout,'(1x,a)') ' -- storing plasma state -- '

  t1 = mytime()
  CALL ps_store_plasma_state(ierr)
  call ckerr('ps_store_plasma_state')
  t1 = mytime() - t1
  write(iout,'(1x,a,t34,1pe10.3)') 'Time for ps_store_plasma_state: ', t1

  write(iout,'(1x,a)') ' '
  write(iout,'(1x,a)') ' -- committing plasma state -- '
  t2 = mytime()
  CALL ps_commit_plasma_state(ierr)
  call ckerr('ps_commit_plasma_state')
  t2 = mytime() - t2
  write(iout,'(1x,a,t34,1pe10.3)') 'Time for ps_commit_plasma_state: ', t2

  !  look for differences btw ps and psp...
  write(iout,*) ' '
  CALL plasma_state_hash_diff(ps,'ps',psp,'psp','*',icomp,idiff)
  if(idiff.eq.0) then
     write(iout,*) ' --> no differences, as expected.'
  else
     write(iout,*) ' -->>>> Unexpected differences !!! <<<<<--'
  endif

  write(iout,'(1x,a)') ' '
  write(iout,'(1x,a)') ' -- clearing plasma state profiles to ZERO -- '
  t3 = mytime()
  CALL ps_clear_profs(ierr)
  call ckerr('ps_clear_profs')
  t3 = mytime() - t3
  write(iout,'(1x,a,t34,1pe10.3)') 'Time for ps_clear_profs: ', t3

  write(iout,'(1x,a)') ' '
  write(iout,'(1x,a)') ' -- get (restore) plasma state from file -- '
  t4 = mytime()
  CALL ps_get_plasma_state(ierr)
  call ckerr('ps_get_plasma_state')
  t4 = mytime() - t4
  write(iout,'(1x,a,t34,1pe10.3)') 'Time for ps_get_plasma_state: ', t4

  !  look for differences btw ps and psp...
  CALL plasma_state_hash_diff(ps,'ps',psp,'psp','*',icomp,idiff)
  if(idiff.eq.0) then
     write(iout,*) ' --> no differences, as expected.'
  else
     write(iout,*) ' -->>>> Unexpected differences !!! <<<<<--'
  endif
  
  write(iout,'(1x,a)') ' '
  write(iout,'(1x,a)') ' -- storing plasma state -- '
  t5 = mytime()
  CALL ps_store_plasma_state(ierr)
  call ckerr('ps_store_plasma_state')
  t5 = mytime() - t5
  write(iout,'(1x,a,t34,1pe10.3)') 'Time for ps_store_plasma_state: ', t5

  write(iout,'(1x,a)') ' -- current and prior state files should be identical.'

  !  look for differences btw ps and psp...
  CALL plasma_state_hash_diff(ps,'ps',psp,'psp','*',icomp,idiff)
  if(idiff.eq.0) then
     write(iout,*) ' --> no differences, as expected.'
  else
     write(iout,*) ' -->>>> Unexpected differences !!! <<<<<--'
  endif

  !------------------------
  !  partial copy

  write(iout,*) ' '
  write(iout,*) ' partial copy test (PLASMA component only; no MHD equilibrium)'
  write(iout,*) ' '

  call ps_cclist_remove('*',cclist,iwarn)
  call ps_cclist_add('PLASMA',cclist,iwarn)

  !  cclist contains the PLASMA component only.

  call ps_copy_plasma_state(ps, aux, ierr, cclist=cclist)
  call ckerr('ps_copy_plasma_state')

  call ps_store_plasma_state(ierr, filename='partial_state.cdf', state=aux)
  call ckerr('ps_store_plasma_state')

  !------------------------------------

  write(iout,*) ' '
  write(iout,*) '  Test using local, un-initialized state-- warning expected.'
  CALL ps_get_plasma_state(ierr,state=my_state, filename='partial_state.cdf')
  call ckerr('ps_get_plasma_state')
  write(iout,*) ' '

  !------------------------------------
  !  new dmc Dec 2006

  write(iout,'(1x,a)') ' '
  write(iout,'(1x,a)') ' limiter data test ... '
  write(iout,'(1x,a)') ' '

  !  from version 2.00 on, the plasma state contains elements describing
  !  an axisymmetric limiter...

  write(iout,'(1x,a,1x,i4)') &
       ' Number of points in closed axisymmetric limiter contour: ', &
       ps%num_rzlim

  do ipts=1,2
     write(iout,2001) ipts,ps%rlim(ipts),ps%zlim(ipts)
  enddo

  do ipts=ps%num_rzlim-1,ps%num_rzlim
     write(iout,2001) ipts,ps%rlim(ipts),ps%zlim(ipts)
  enddo

2001 format(3x,' limiter point #',i3,' (R,Z) = (',1pe13.6,',',1pe13.6,')')

  write(iout,'(1x,a,2(1x,1pe16.9))') &
       ' limiter Rmin,Rmax: ',minval(ps%rlim),maxval(ps%rlim)
  write(iout,'(1x,a,2(1x,1pe16.9))') &
       ' limiter Zmin,Zmax: ',minval(ps%zlim),maxval(ps%zlim)

  !------------------------------------
  !  new dmc Feb 2008

  write(iout,'(1x,a)') ' '
  write(iout,'(1x,a)') ' abridged species list data fetch test ... '
  write(iout,'(1x,a)') ' '

  !  fetch temperatures, densities, and flows: abridged species

  allocate(tha_test(ps%nrho-1,ps%nspec_tha))

  call ps_tha_fetch(ierr,ns=tha_test,iwarn=iwarn)
  call ckerr('ps_tha_fetch(ns)')
  write(iout,'(a,2(1x,1pe16.9))') &
       ' "abridged" impurity densities, 1st zone: ', &
       tha_test(1,ps%nspec_tha-1),tha_test(1,ps%nspec_tha)

  call ps_tha_fetch(ierr,Ts=tha_test,iwarn=iwarn)
  call ckerr('ps_tha_fetch(Ts)')
  write(iout,'(a,2(1x,1pe16.9))') &
       ' "abridged" impurity temperatures, 1st zone: ', &
       tha_test(1,ps%nspec_tha-1),tha_test(1,ps%nspec_tha)

  call ps_tha_fetch(ierr,v_pars=tha_test,iwarn=iwarn)
  call ckerr('ps_tha_fetch(v_pars)')

  deallocate(tha_test)

  allocate(tha_test(1,ps%nspec_tha))
  call ps_tha_rezone((/ 0.0_rspec, 1.0_rspec /),ierr, ns=tha_test, &
       zonevol=test_voltot)
  call ckerr('ps_tha_rezone(ns)')

  tha_test=tha_test*test_voltot(1)
  write(iout,'(a,2(1x,1pe16.9))') &
       ' "abridged" impurity density volume integrals:', &
       tha_test(1,ps%nspec_tha-1),tha_test(1,ps%nspec_tha)

  call ps_tha_rezone((/ 0.0_rspec, 1.0_rspec /),ierr, Ts=tha_test)
  call ckerr('ps_tha_rezone(Ts)')
  write(iout,'(a,2(1x,1pe16.9))') &
       ' "abridged" impurity temperature averages: ', &
       tha_test(1,ps%nspec_tha-1),tha_test(1,ps%nspec_tha)

  call ps_tha_rezone((/ 0.0_rspec, 1.0_rspec /),ierr, v_pars=tha_test)
  call ckerr('ps_tha_rezone(v_pars)')

  deallocate(tha_test)

  !  Collective Ti fetch/rezone test
  allocate(ttest1(ps%nrho-1),ttest2(ps%nrho-1),ttest3(ps%nrho-1))
  ttest1 = ps%ts(:,1)
  call ps_ti_fetch(ierr,state=ps,ti=ttest2); call ckerr('ps_ti_fetch')
  call ps_ti_rezone(ps%rho,ierr,state=ps,ti=ttest3); call ckerr('ps_ti_rezone')

  do i=1,ps%nrho-1
     zdiff1=abs(ttest2(i)-ttest1(i))/max(ttest2(i),ttest1(i))
     zdiff2=abs(ttest3(i)-ttest1(i))/max(ttest3(i),ttest1(i))
     if(max(zdiff1,zdiff2).gt.(1.0d-12)) then
        write(iout,*) ' ?? PS_TI_FETCH/PS_TI_REZONE result outside tolerance:'
        write(iout,*) '    zone ',i,' original, fetch, rezone values: ', &
             ttest1(i),ttest2(i),ttest3(i)
     endif
  enddo
  deallocate(ttest1,ttest2,ttest3)
  !------------------------------------
  write(iout,'(1x,a)') ' '
  write(iout,'(1x,a)') ' 1d interpolation test ... '
  write(iout,'(1x,a)') ' '

  allocate(zb_test(ps%nrho))
  call ps_zone2bdy_rezone(ps%id_Ts(0),zb_test,ierr)
  call ckerr('ps_zone2bdy_rezone')

  write(iout,'("  Te on axis: ",1pe12.5)') zb_test(1)
  do i=2,7
     write(iout,'("  Te at zone center #",i1,": ",1pe12.5)') i-1,ps%Ts(i-1,0)
     write(iout,'("  Te at zone bdy    #",i1,": ",1pe12.5)') i,zb_test(i)
  enddo
  write(iout,*) '  ... ... '
  do i=ps%nrho-5,ps%nrho
     write(iout,'("  Te at zone center #",i3,": ",1pe12.5)') i-1,ps%Ts(i-1,0)
     write(iout,'("  Te at zone bdy    #",i3,": ",1pe12.5)') i,zb_test(i)
  enddo

  inum=11
  allocate(rho_intrp(inum),dvdrho(inum),dpsidrho(inum))
  allocate(buf2(inum-1,2))

  do i=1,inum
     rho_intrp(i) = (i-1)*ONE/(inum-1)
  enddo

  ! scalar interpolations -- refer to current state by default

  call ps_intrp_1d(ZERO,ps%id_vol,vpp0,ierr, ideriv=2)    ! d2(Vol)/drho2 @axis
  call ckerr('ps_intrp_1d')
  call ps_intrp_1d(ZERO,ps%id_psipol,ppp0,ierr, ideriv=2) ! d2(Psi)/drho2 @axis
  call ckerr('ps_intrp_1d')
  
  write(iout,'(1x,a,1x,1pe16.9)') ' @axis: d2[Vol]/d2[Psi] = ', vpp0/ppp0

  ! scalar interpolations -- to refer to prior state:

  call ps_intrp_1d(ZERO,psp%id_vol,vpp0,ierr, ideriv=2, state=psp)
  call ckerr('ps_intrp_1d')
  call ps_intrp_1d(ZERO,psp%id_psipol,ppp0,ierr, ideriv=2, state=psp)
  call ckerr('ps_intrp_1d')
  
  write(iout,'(1x,a,1x,1pe16.9,1x,a)') &
       ' @axis: d2[Vol]/d2[Psi] = ', vpp0/ppp0,' (prior state)'

  dvdrho(1)=vpp0   ! OK for ratio
  dpsidrho(1)=ppp0 ! OK for ratio

  ! one call can also do two interpolations to a common target vector,
  ! yielding a 2d array of values; array & vector sizes must be consistent.
  ! (If not errors are reported).
  
  ids(1)=ps%id_vol
  ids(2)=ps%id_psipol

  ! evaluate 1st derivative of both profiles.

  call ps_intrp_1d(rho_intrp(2:inum),ids,buf2,ierr, ideriv=1)
  call ckerr('ps_intrp_1d')

  ! a vector iderivs(:) could also have been specified, giving seperate 
  ! control of derivative for each profile id...

  dvdrho(2:inum)=buf2(:,1)
  dpsidrho(2:inum)=buf2(:,2)

  write(iout,'(1x,a)') ' '
  write(iout,'(1x,a)') '  #   rho             dVol/dPsi'
  do i=1,inum
     write(iout,'(1x,i2,1x,2(1pe15.8,1x))') &
          i,rho_intrp(i),dvdrho(i)/dpsidrho(i)
  enddo

  deallocate(rho_intrp,dvdrho,dpsidrho,buf2)

  !------------------------------------
  write(iout,'(1x,a)') ' '
  write(iout,'(1x,a)') ' 2d interpolation test ... '
  write(iout,'(1x,a)') ' '

  call ps_intrp_2d(ZERO,ZERO,ps%id_R_geo,zansR0,ierr)
  call ckerr('ps_intrp_2d')
  call ps_intrp_2d(ZERO,ZERO,ps%id_Z_geo,zansZ0,ierr)
  call ckerr('ps_intrp_2d')

  write(iout,'(1x,a,1x,2(1pe16.9,1x))') ' [R,Z]axis (state scalars):', &
       ps%R_axis,ps%Z_axis

  write(iout,'(1x,a,1x,2(1pe16.9,1x))') ' [R,Z]axis (interpolation):', &
       zansR0,zansZ0

  ids(1) = ps%id_R_geo
  ids(2) = ps%id_Z_geo

  inum=1001
  allocate(rho_intrp(inum),th_intrp(inum),buf2(inum,2))

  rho_intrp = ONE  ! replicated 1001 times...
  do i=1,inum
     th_intrp(i) = (i-1)*6.2831853071795862_rspec/(inum-1)
  enddo

  ! Here a 1000-pt bdy (R,Z) contour is evaluated

  call ps_intrp_2d(rho_intrp,th_intrp,ids,buf2,ierr)
  call ckerr('ps_intrp_2d')

  test_Rmin = minval(buf2(:,1))  
  test_Rmax = maxval(buf2(:,1))

  test_Zmin = minval(buf2(:,2))  
  test_Zmax = maxval(buf2(:,2))

  write(iout,'(1x,a)') ' '
  write(iout,'(1x,a)') ' Last Closed Flux Surface Extrema:'
  write(iout,'(1x,a)') ' (1000 pt [R,Z] surface contour was evaluated by interpolation):'
  write(iout,'(1x,a)') ' '
  write(iout,'(1x,a,1x,2(1pe16.9,1x))') ' Rmin,Rmax (state scalars): ', &
       ps%R_min_lcfs,ps%R_max_lcfs
  write(iout,'(1x,a,1x,2(1pe16.9,1x))') ' Rmin,Rmax (1000 pt search):', &
       test_Rmin,test_Rmax
  write(iout,'(1x,a,1x,2(1pe16.9,1x))') ' Zmin,Zmax (state scalars): ', &
       ps%Z_min_lcfs,ps%Z_max_lcfs
  write(iout,'(1x,a,1x,2(1pe16.9,1x))') ' Zmin,Zmax (1000 pt search):', &
       test_Zmin,test_Zmax

  deallocate(rho_intrp,th_intrp,buf2)

  !------------------------------------
  !  demonstration of rho-rezoning
  !  when the density "ns" is rezoned, its volume integral is preserved
  !  when the temperature "Ts" is rezoned, the volume integrals of (ns*Ts)
  !  are conserved species by species.  The weighting of Ts is defined in
  !  "plasma_state_spec.dat".

  inum=1
  do ict = 1,3

     inum = inum + 10

     allocate(rho_bdys(inum),dvols(inum-1))  ! grid; volumes zone by zone

     allocate(my_ns(inum-1,0:ps%nspec_th))    ! densities...
     allocate(my_Ts(inum-1,0:ps%nspec_th))    ! Temperatures...

     allocate(my_ns2(inum-1,0:ps%nspec_th))   ! densities (user_rezone)
     allocate(my_Ts2(inum-1,0:ps%nspec_th))   ! Temperatures (user_rezone)

     allocate(volint_ns(0:ps%nspec_th),volint_nt(0:ps%nspec_th))

     do i=1,inum
        rho_bdys(i) = (i-1)*ONE/(inum-1)
     enddo

     call ps_rho_rezone(rho_bdys, ps%id_ns, my_ns, ierr, zonediff = dvols)
     call ckerr('ps_rho_rezone')
     call ps_rho_rezone(rho_bdys, ps%id_Ts, my_Ts, ierr)
     call ckerr('ps_rho_rezone')

     call ps_user_rezone(ps%rho, rho_bdys, ps%ns, my_ns2, ierr, &
          interp=-1)
     call ckerr('ps_user_rezone')

     call ps_user_rezone(ps%rho, rho_bdys, ps%Ts, my_ts2, ierr, &
          interp=-1, w_orig = ps%ns)
     call ckerr('ps_user_rezone')

     write(iout,'(1x,a)') ' '
     write(iout,'(1x,a,i3,a)') ' test with ',inum-1,' zones:'
     write(iout,'(1x,a)') ' zone  rho            ne             Te             nD             Ti '

     volint_ns = ZERO
     volint_nt = ZERO

     dmaxn = ZERO
     dmaxt = ZERO

     do i=1,inum-1
        do ith=0,ps%nspec_th
           dmaxn(ith) = max(dmaxn(ith), &
                abs(my_ns(i,ith)-my_ns2(i,ith))/max(small_n,my_ns(i,ith)))
           if(my_ns(i,ith).eq.0.0_rspec) then
              dmaxt(ith) = 0.0_rspec
           else
              dmaxt(ith) = max(dmaxt(ith), &
                   abs(my_Ts(i,ith)-my_Ts2(i,ith))/max(small_T,my_Ts(i,ith)))
           endif
        enddo
        zrho = (rho_bdys(i) + rho_bdys(i+1))/2
        write(iout,'(1x,i2,1x,5(1x,1pe14.7))') i,zrho, &
             my_ns(i,0),my_Ts(i,0),my_ns(i,1),my_Ts(i,1)

        volint_ns = volint_ns + dvols(i)*my_ns(i,:)
        volint_nt = volint_nt + dvols(i)*my_ns(i,:)*my_Ts(i,:)

     enddo

     write(iout,'(1x,a,3(1x,1pe16.9))') 'VOLINT_ns: ',VOLINT_ns(0:i_nonZero)
     write(iout,'(1x,a,3(1x,1pe16.9))') 'Volint_nt: ',Volint_nt(0:i_nonZero)
     write(iout,'(1x,a,2(1x,1pe11.4))') &
          ' ps_rho_rezone vs. ps_user_rezone (0 diff expected): ', &
          maxval(dmaxn),maxval(dmaxt)

     do ith=0,ps%nspec_th
        maxdiff_ns(ith)=max(maxdiff_ns(ith), &
             abs(volint_ns(ith)-volref_ns(ith))/max(small_n,volref_ns(ith)))
        if(volref_ns(ith).eq.0.0_rspec) then
           maxdiff_nt(ith)= 0.0_rspec
        else
           maxdiff_nt(ith)=max(maxdiff_nt(ith), &
                abs(volint_nt(ith)-volref_nt(ith))/max(small_n,volref_nt(ith)))
        endif
     enddo

     if(ict.lt.3) then
        deallocate(rho_bdys,dvols,my_ns,my_ts, &
             my_ns2,my_ts2,volint_ns,volint_nt)
     endif
  enddo

  allocate(my_ns1(inum-1),my_Ts1(inum-1))
  call ps_user_rezone(ps%rho, rho_bdys, ps%ns(:,1), my_ns1, ierr)
  call ckerr('ps_user_rezone')
  call ps_user_rezone(ps%rho, rho_bdys, ps%Ts(:,1), my_Ts1, ierr, &
       w_orig = ps%ns(:,1))
  call ckerr('ps_user_rezone')

  dmaxn = ZERO
  dmaxt = ZERO

  do i=1,inum-1
     dmaxn(1) = max(dmaxn(1),abs(my_ns(i,1)-my_ns1(i))/max(small_n,my_ns(i,1)))
     dmaxt(1) = max(dmaxt(1),abs(my_Ts(i,1)-my_Ts1(i))/max(small_T,my_Ts(i,1)))
  enddo
  write(iout,'(1x,a,2(1x,1pe11.4))') &
       ' ps_rho_rezone vs. ps_user_rezone (0 diff expected): ', &
       maxval(dmaxn),maxval(dmaxt)

  allocate(my_profa(ps%nrho-1,0:ps%nspec_th,2))
  allocate(my_profb(ps%nrho-1,0:ps%nspec_th,2))
  allocate(my_profc(inum-1,0:ps%nspec_th,2))

  my_profa(:,:,1) = ps%ns
  my_profa(:,:,2) = ps%Ts
  my_profb(:,:,1) = ZERO
  my_profb(:,:,2) = ps%ns

  call ps_user_rezone(ps%rho, rho_bdys, my_profa, my_profc, ierr, &
       w_orig = my_profb)
  call ckerr('ps_user_rezone')

  dmaxn = ZERO
  dmaxt = ZERO

  do i=1,inum-1
     do ith=0,ps%nspec_th
        dmaxn(ith) = max(dmaxn(ith), &
             abs(my_ns(i,ith)-my_profc(i,ith,1))/max(small_n,my_ns(i,ith)))
        if(my_ns(i,ith).eq.0.0_rspec) then
           dmaxt(ith) = 0.0_rspec
        else
           dmaxt(ith) = max(dmaxt(ith), &
                abs(my_Ts(i,ith)-my_profc(i,ith,2))/max(small_T,my_Ts(i,ith)))
        endif
     enddo
  enddo
  write(iout,'(1x,a,2(1x,1pe11.4))') &
       ' ps_rho_rezone vs. ps_user_rezone (0 diff expected): ', &
       maxval(dmaxn),maxval(dmaxt)

  allocate(zdvola(ps%nrho-1),zdvolc(size(rho_bdys)-1))

  call ps_rho_metric('USER','DVOL_EQ',zdvola,ierr, user_rho_grid = ps%rho)
  call ckerr('ps_rho_metric')
  call ps_rho_metric('USER','DVOL_EQ',zdvolc,ierr, user_rho_grid = rho_bdys)
  call ckerr('ps_rho_metric')

  do ith=0,ps%nspec_th
     my_profa(:,ith,1) = my_profa(:,ith,1)*zdvola
     my_profa(:,ith,2) = my_profa(:,ith,2)*zdvola
     my_profb(:,ith,1) = my_profb(:,ith,1)*zdvola
     my_profb(:,ith,2) = my_profb(:,ith,2)*zdvola
  enddo

  call ps_user_rezone(ps%rho, rho_bdys, my_profa, my_profc, ierr, &
       w_orig = my_profb, nonorm = .TRUE.)
  call ckerr('ps_user_rezone')

  dmaxn = ZERO
  dmaxt = ZERO

  do i=1,inum-1
     do ith=0,ps%nspec_th
        dmaxn(ith) = max(dmaxn(ith), &
             abs(my_ns(i,ith)-my_profc(i,ith,1)/zdvolc(i))/max(small_n,my_ns(i,ith)))
        if(my_ns(i,ith).eq.0.0_rspec) then
           dmaxt(ith) = 0.0_rspec
        else
           dmaxt(ith) = max(dmaxt(ith), &
                abs(my_Ts(i,ith)-my_profc(i,ith,2))/max(small_T,my_Ts(i,ith)))
        endif
     enddo
  enddo
  write(iout,*) '   ps_user_rezone nonorm=T (arrays #/zone in place of #/m^3)'
  write(iout,'(1x,a,2(1x,1pe11.4))') &
       ' ps_rho_rezone vs. ps_user_rezone (near 0 diff exp): ', &
       maxval(dmaxn),maxval(dmaxt)
 
  do ith=0,ps%nspec_th
     write(iout,'(1x,a)') ' '
     if(ith.le.i_nonZero) then
        write(iout,'(1x,a,a)') ' species: ',ps%s_name(ith)
        write(iout,'(1x,a,1pe16.9)') &
             ' Max deviation, volint(n): ',maxdiff_ns(ith)
        write(iout,'(1x,a,1pe16.9)') &
             ' Max deviation, volint(n*T): ',maxdiff_nt(ith)
     else
        write(iout,'(1x,a,a)') ' species: '//trim(ps%s_name(ith))// &
             ': ZERO density'
     endif
  enddo

  !------------------------------------
  !  May 2008: demonstrate
  !  creation of single arrays of all the densities and temperatures
  !  for the nspec_alla list:
  !       abridged thermal ion species + all fast species
  !
  !  rezoned to a boundary oriented grid; use rho_bdy_rezone(...) for
  !  this rezoning.
  !

  nrho_user=201
  nrhop1=nrho_user+1
  allocate(rho_user(nrho_user),rho_bdy_rezon(nrhop1))

  do ii=1,nrho_user
     rho_user(ii) = (ii-1)*1.0_rspec/(nrho_user-1)
  enddo

  !  rho_bdy_rezon(...) has a half width zone at the center and edge, and a
  !  full width zone around each interior boundary in rho_user(...).
  !  size(rho_bdy_rezon) = size(rho_user) + 1

  rho_bdy_rezon(1)=rho_user(1)
  rho_bdy_rezon(nrhop1)=rho_user(nrho_user)
  rho_bdy_rezon(2:nrho_user) = &
       0.5_rspec*(rho_user(1:nrho_user-1)+rho_user(2:nrho_user))

  allocate(dense(nrho_user),tempe(nrho_user))
  allocate(densi(nrho_user,ps%nspec_alla),tempi(nrho_user,ps%nspec_alla))

  call ps_rho_rezone(rho_bdy_rezon, ps%id_ns(0), dense, ierr, zonesmoo=.TRUE.)
  call ckerr('ps_rho_rezone (U1)')

  call ps_rho_rezone(rho_bdy_rezon, ps%id_Ts(0), tempe, ierr, zonesmoo=.TRUE.)
  call ckerr('ps_rho_rezone (U2)')

  !  get the abridged thermal species list first...

  call ps_tha_rezone(rho_bdy_rezon, ierr, zonesmoo=.TRUE., &
       ns = densi(:,1:ps%nspec_tha), Ts = tempi(:,1:ps%nspec_tha))
  call ckerr('ps_tha_rezone')

  !  get the fast species; in general these will be on different grids.

  allocate(wk_dens(nrho_user),wk_eperp(nrho_user),wk_epll(nrho_user))

  do ii=ps%nspec_tha + 1, ps%nspec_alla
     jj = ps%alla_index(ii)   ! index in "all species" list
     !       jj=-1 if ps%alla_type(ii).eq.ps_impurity, but this should not
     !       occur as here we loop over fast ions only.  Still, I test this...
     if(jj.le.0) then
        write(iout,*) ' ? unexpected alla_index(ii) value: ',jj
     else
        !  OK, jj=alla_index(ii) points to the element index of whatever
        !  fast species list element corresponds to element ii of the alla list

        if(ps%alla_type(ii).eq.ps_beam_ion) then
           call ps_rho_rezone(rho_bdy_rezon, ps%id_nbeami(jj), wk_dens, &
                ier1, zonesmoo=.TRUE.)
           call ps_rho_rezone(rho_bdy_rezon, ps%id_eperp_beami(jj), wk_eperp, &
                ier2, zonesmoo=.TRUE.)
           call ps_rho_rezone(rho_bdy_rezon, ps%id_epll_beami(jj), wk_epll, &
                ier3, zonesmoo=.TRUE.)

        else if(ps%alla_type(ii).eq.ps_rf_minority) then
           call ps_rho_rezone(rho_bdy_rezon, ps%id_nmini(jj), wk_dens, &
                ier1, zonesmoo=.TRUE.)
           call ps_rho_rezone(rho_bdy_rezon, ps%id_eperp_mini(jj), wk_eperp, &
                ier2, zonesmoo=.TRUE.)
           call ps_rho_rezone(rho_bdy_rezon, ps%id_epll_mini(jj), wk_epll, &
                ier3, zonesmoo=.TRUE.)

        else if(ps%alla_type(ii).eq.ps_fusion_ion) then
           call ps_rho_rezone(rho_bdy_rezon, ps%id_nfusi(jj), wk_dens, &
                ier1, zonesmoo=.TRUE.)
           call ps_rho_rezone(rho_bdy_rezon, ps%id_eperp_fusi(jj), wk_eperp, &
                ier2, zonesmoo=.TRUE.)
           call ps_rho_rezone(rho_bdy_rezon, ps%id_epll_fusi(jj), wk_epll, &
                ier3, zonesmoo=.TRUE.)

        endif

        ierr = ier1 + ier2 + ier3
        call ckerr('ps_rho_rezone (fast specie)')

        densi(:,ii) = wk_dens
        tempi(:,ii) = (2.0_rspec/3.0_rspec)*(wk_eperp + wk_epll)

     endif
  enddo

  write(iout,'(A,1pe12.5)') &
       '  density      Temperature   Species @ rho_user(7) = ',rho_user(7)
  write(iout,'(2(1x,1pe12.5),3x,a)') dense(7),tempe(7), &
       trim(ps%alla_name(0))
  do ii=1,ps%nspec_alla
     write(iout,'(2(1x,1pe12.5),3x,a)') densi(7,ii),tempi(7,ii), &
          trim(ps%alla_name(ii))
  enddo

  !------------------------------------
  !  ps_rho_metric test...

  if(allocated(zvols)) deallocate(zvols)

  allocate(zvols(ps%nrho - 1))  ! use for volume elements here...

  write(iout,*) ' '
  write(iout,*) ' -------------------'
  write(iout,*) ' ps_rho_metric test.'
  write(iout,*) ' '

  zvols = 0
  call ps_rho_metric('RHO','DVOL',zvols,ierr)
  call ckerr('ps_rho_metric')
  write(iout,'(1x,a,1x,1pe16.9)') ' volume of 3rd zone: ',zvols(3)

  zvols = 0
  call ps_rho_metric('RHO','DAREA',zvols,ierr)
  call ckerr('ps_rho_metric')
  write(iout,'(1x,a,1x,1pe16.9)') ' area of 3rd zone: ',zvols(3)

  write(iout,*) &
       ' ... recomputation with "user" rho grid = ps%rho: should match.'

  zvols = 0
  call ps_rho_metric('USER_RHO','DVOL',zvols,ierr, user_rho_grid = ps%rho)
  call ckerr('ps_rho_metric')
  write(iout,'(1x,a,1x,1pe16.9)') ' volume of 3rd zone: ',zvols(3)

  zvols = 0
  call ps_rho_metric('USER_RHO','DAREA',zvols,ierr, user_rho_grid = ps%rho)
  call ckerr('ps_rho_metric')
  write(iout,'(1x,a,1x,1pe16.9)') ' area of 3rd zone: ',zvols(3)

  write(iout,*) ' '
  write(iout,*) ' -------------------'
  write(iout,*) ' partial update test'
  write(iout,*) ' '

  ! state updates (updates only) can be propagated through files
  ! here form an update consisting of 3 elements: ts, t0, t1

  aux%ts(:,0) = 1.01_rspec*aux%ts(:,0)  ! increase Te by 1%
  aux%t0 = aux%t0 + 0.001_rspec
  aux%t1 = aux%t1 + 0.001_rspec

  ! write update file: PLASMA & EQ components only

  call ps_cclist_remove('*',cclist,iwarn)
  call ps_cclist_add('PLASMA',cclist,iwarn)
  call ps_cclist_add('EQ',cclist,iwarn)

  call ps_update_report(ierr,state=aux,cclist=cclist, &
       report_filename='update_test.list')
  call ckerr('ps_update_report (1)')

  call ps_write_update_file('update_test.cdf',ierr,state=aux, &
       cclist=cclist, iwarn=iwarn)
  call ckerr('ps_write_update_file (1)')

  ! read update file, but do not update hash codes (update_complete=.FALSE.)
  ! in normal usage, several updates might be read in sequence, with
  ! update_complete=.FALSE. until the last one is read with 
  ! update_complete=.TRUE. after which the interpolation structures are 
  ! checked and hash codes are updated.

  ! here, by not updating the hash codes, I can write another update file
  ! (it uses the hash codes to determine what has been updated).

  call ps_read_update_file('update_test.cdf',ierr,state=ps, &
       update_complete=.FALSE.)
  call ckerr('ps_read_update_file')

  ! ps state by default: ps_state_test.cdf

  call ps_update_report(ierr,report_filename='ps_update_test1.list')
  call ckerr('ps_update_report (2)')

  call ps_write_update_file('ps_update_test1.cdf',ierr)
  call ckerr('ps_write_update_file (2)')

  ! ps state by default: ps_state_test.cdf
  ! since the update was already written, writing a 2nd time shows 0 changes...

  call ps_update_report(ierr,report_filename='ps_update_test2.list')
  call ckerr('ps_update_report (3)')

  call ps_write_update_file('ps_update_test2.cdf',ierr)
  call ckerr('ps_write_update_file (3)')

  write(iout,*) ' plasma_state_test: update file test completed.'

  ! test merging data from 2 states into a third state (ps,psp) -> (aux)
  ! just the equilibrium (EQ) component data is merged.
  ! array dimensions for the EQ component are copied into (aux) first.

  call ps_cclist_remove('*',cclist,iwarn)
  call ps_cclist_add('EQ',cclist,iwarn)

  call ps_copy_dims(ps,aux,0,ierr,cclist=cclist)
  call ckerr('ps_copy_dims')

  call ps_merge_plasma_state(0.1_rspec,psp,ps,ierr, cclist=cclist, &
       new_state = aux, icheck=ps_warn)
  call ckerr('ps_merge_plasma_state')

  write(iout,*) ' plasma_state_test: merge test completed.'

  !  DMC: add this Apr 2011 -- source code, see below...
  call pspro_test

  write(iout,*) ' '
  t_overall = mytime() - t_overall
  write(iout,'(1x,a,t34,1pe10.3)') 'Time for overall execution: ', t_overall

  !------------------------------------
  !------------------------------------

  CONTAINS
    !------------------------------------
    SUBROUTINE rho_grid(nrho,rho)

      ! generate evenly spaced rho grid

      integer, intent(in) :: nrho    ! # of pts covering [0:1]
      REAL(KIND=rspec) :: rho(nrho)  ! the rho grid being generated

      REAL(KIND=rspec), parameter :: ONE = 1.0_rspec

      integer :: irho

      do irho = 1,nrho
         rho(irho) = (irho-1)*ONE/(nrho-1)
      enddo

    END SUBROUTINE rho_grid

    !------------------------------------
    SUBROUTINE th_grid(nth,th)

      ! generate evenly spaced theta grid [-pi:pi]

      integer, intent(in) :: nth    ! # of pts covering the range
      REAL(KIND=rspec) :: th(nth)   ! the theta grid being generated

      REAL(KIND=rspec), parameter :: PI = 3.1415926535897931_rspec

      integer :: ith

      do ith = 1,nth
         th(ith) = -PI + (ith-1)*2*PI/(nth-1)
      enddo

    END SUBROUTINE th_grid

    !------------------------------------
    SUBROUTINE profgen(f0,fa,rho,fans)

      !  quick & dirty profile generator

      REAL(KIND=rspec), intent(in) :: f0,fa  ! core and edge values
      REAL(KIND=rspec), dimension(:), intent(in) :: rho  ! normalized sqrt tor. flux
      REAL(KIND=rspec), dimension(:), intent(out) :: fans  ! formula output

      fans = (f0-fa)*(1.0_rspec-rho**2)**2 + fa

    END SUBROUTINE profgen

    REAL(KIND=rspec) FUNCTION mytime()

      real*8 :: ztime

      call cpu_time(ztime)

      mytime = ztime

    END FUNCTION mytime

    SUBROUTINE ckerr(sbrtn)
      character*(*), intent(in) :: sbrtn

      IF(ierr.NE.0) then
         write(6,*) ' ?plasma_state_test: error in call: '//trim(sbrtn)
         stop
      ENDIF
    END SUBROUTINE ckerr

end program plasma_state_test

subroutine pspro_test

  USE pspro
  USE plasma_state_mod
  implicit NONE

  !  test pspro routines...

  integer :: jintrp,ii,jjii,ierr

  real*8 :: rho(9),cloge(9,3),eta_sp(9,3),eta_nc(9,3)

  write(6,*) ' '
  write(6,*) ' Plasma_state_test: ---> pspro tests... '
  write(6,*) ' '

  ! prelim: get iota(bar) = 1/q
  !   NOTE: pspro routines call ps_state_memory_update; iota(bar)
  !         interpolation will be available

  call ps_intrp_1d(ps%rho,ps%id_q_eq,ps%iota,ierr, state=ps)
  do ii=1,ps%nrho
     if(ps%iota(ii).gt.0.0_rspec) then
        ps%iota(ii) = 1.0_rspec/ps%iota(ii)  ! q -> 1/q
     else
        write(6,*) ' ?pspro_test: singular q value: ',ps%iota(ii)
        ps%iota(ii) = 100.0_rspec
     endif
  enddo


  do ii=1,9
     rho(ii) = 0.1d0*ii
  enddo

  do jintrp=0,2
     jjii=jintrp+1

     call pspro_cloge(ps,rho,cloge(:,jjii),ierr, intrp=jintrp)
     if(ierr.ne.0) write(6,*) '  *** pspro_cloge: ierr = ',ierr

     call pspro_resis_hhb(ps,rho,eta_sp(:,jjii),eta_nc(:,jjii),ierr, &
          intrp=jintrp)
     if(ierr.ne.0) write(6,*) '  *** pspro_resis_hhb: ierr = ',ierr
  enddo

  write(6,*) ' '
  write(6,*) ' Electron coulomb log -- input profile interpolations varied:'
  write(6,*) '   #     rho        cloge(0)      cloge(1)      cloge(2)'
  do ii=1,9
     write(6,'(3x,i1,4(2x,1pe12.5))') ii,rho(ii),cloge(ii,1:3)
  enddo

  write(6,*) ' '
  write(6,*) ' HHB NC resistivity (Ohm/m) -- input profile interpolations varied:'
  write(6,*) '   #     rho        eta_nc(0)     eta_nc(1)     eta_nc(2)'
  do ii=1,9
     write(6,'(3x,i1,4(2x,1pe12.5))') ii,rho(ii),eta_nc(ii,1:3)
  enddo

end subroutine pspro_test

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_f6_dummy
     return
  end subroutine ccps_getset_f6_dummy

subroutine psget_frac_full(iobj, n1, data, ierr)
    !! fraction of beam current at full voltage
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_frac_full', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % frac_full
end subroutine psget_frac_full


subroutine psset_frac_full(iobj, n1, data, ierr)
    !! fraction of beam current at full voltage
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_frac_full', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % frac_full = data(1:n1)
end subroutine psset_frac_full


subroutine psgetrnk_frac_full(iobj, ndims, ierr)
    !! fraction of beam current at full voltage
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_frac_full


subroutine psgetdim_frac_full(iobj, ndims, dims, ierr)
    !! fraction of beam current at full voltage
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_frac_full', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % frac_full ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % frac_full)
    endif
end subroutine psgetdim_frac_full


subroutine psget_fidiff_bpass_ctr(iobj, n1, n2, n3, data, ierr)
    !! fusion ion diffusivity: ctr barely passing orbits
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2, n3 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2, n3) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_fidiff_bpass_ctr', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2, 1: n3) = ss % fidiff_bpass_ctr
end subroutine psget_fidiff_bpass_ctr


subroutine psset_fidiff_bpass_ctr(iobj, n1, n2, n3, data, ierr)
    !! fusion ion diffusivity: ctr barely passing orbits
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2, n3 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2, n3) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_fidiff_bpass_ctr', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % fidiff_bpass_ctr = data(1:n1, 1: n2, 1: n3)
end subroutine psset_fidiff_bpass_ctr


subroutine psgetrnk_fidiff_bpass_ctr(iobj, ndims, ierr)
    !! fusion ion diffusivity: ctr barely passing orbits
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 3
end subroutine psgetrnk_fidiff_bpass_ctr


subroutine psgetdim_fidiff_bpass_ctr(iobj, ndims, dims, ierr)
    !! fusion ion diffusivity: ctr barely passing orbits
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 3) ierr = 1
    call ccps_argcheck('psgetdim_fidiff_bpass_ctr', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % fidiff_bpass_ctr ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % fidiff_bpass_ctr)
    endif
end subroutine psgetdim_fidiff_bpass_ctr


subroutine psget_freq_mmm71(iobj, n1, n2, data, ierr)
    !! frequency from mmm71 model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_freq_mmm71', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % freq_mmm71
end subroutine psget_freq_mmm71


subroutine psset_freq_mmm71(iobj, n1, n2, data, ierr)
    !! frequency from mmm71 model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_freq_mmm71', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % freq_mmm71 = data(1:n1, 1: n2)
end subroutine psset_freq_mmm71


subroutine psgetrnk_freq_mmm71(iobj, ndims, ierr)
    !! frequency from mmm71 model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_freq_mmm71


subroutine psgetdim_freq_mmm71(iobj, ndims, dims, ierr)
    !! frequency from mmm71 model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_freq_mmm71', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % freq_mmm71 ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % freq_mmm71)
    endif
end subroutine psgetdim_freq_mmm71

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


SUBROUTINE plasma_state_empty_alloc_9(ss,iout,ierr)


  ! Allocate array data for which all dimensions are provided

  USE plasma_state_definition_mod
  IMPLICIT NONE

  TYPE (plasma_state) :: ss  ! state containing array elements to be allocated
  INTEGER, INTENT(IN) :: iout
  INTEGER, INTENT(INOUT) :: ierr  ! completion code (not cleared,set on error)

  !-------------------
  INTEGER :: isize,jsize
  !-------------------


  !-----------------------------------------------
  ! allocate arrays...

  isize = (ss%nrho_anomth)
  IF(ALLOCATED(ss%velte_mmm71).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%velte_mmm71)
  ENDIF
  IF(ALLOCATED(ss%velte_mmm71)) then
     jsize = SIZE(ss%velte_mmm71)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: velte_mmm71 already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%velte_mmm71(ss%nrho_anomth))
     ss%velte_mmm71 = 0.0_rspec
  ENDIF

  isize = (ss%nrho_anomth)
  IF(ALLOCATED(ss%velte_nclass).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%velte_nclass)
  ENDIF
  IF(ALLOCATED(ss%velte_nclass)) then
     jsize = SIZE(ss%velte_nclass)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: velte_nclass already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%velte_nclass(ss%nrho_anomth))
     ss%velte_nclass = 0.0_rspec
  ENDIF

  isize = (ss%nrho_anomth)
  IF(ALLOCATED(ss%velte_neo).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%velte_neo)
  ENDIF
  IF(ALLOCATED(ss%velte_neo)) then
     jsize = SIZE(ss%velte_neo)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: velte_neo already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%velte_neo(ss%nrho_anomth))
     ss%velte_neo = 0.0_rspec
  ENDIF

  isize = (ss%nrho_anomth)
  IF(ALLOCATED(ss%velte_paleo).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%velte_paleo)
  ENDIF
  IF(ALLOCATED(ss%velte_paleo)) then
     jsize = SIZE(ss%velte_paleo)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: velte_paleo already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%velte_paleo(ss%nrho_anomth))
     ss%velte_paleo = 0.0_rspec
  ENDIF

  isize = (ss%nrho_anomth)
  IF(ALLOCATED(ss%velte_tglf).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%velte_tglf)
  ENDIF
  IF(ALLOCATED(ss%velte_tglf)) then
     jsize = SIZE(ss%velte_tglf)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: velte_tglf already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%velte_tglf(ss%nrho_anomth))
     ss%velte_tglf = 0.0_rspec
  ENDIF

  isize = (ss%nrho_anomth)
  IF(ALLOCATED(ss%velti_anom).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%velti_anom)
  ENDIF
  IF(ALLOCATED(ss%velti_anom)) then
     jsize = SIZE(ss%velti_anom)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: velti_anom already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%velti_anom(ss%nrho_anomth))
     ss%velti_anom = 0.0_rspec
  ENDIF

  isize = (ss%nrho_anomth)
  IF(ALLOCATED(ss%velti_glf).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%velti_glf)
  ENDIF
  IF(ALLOCATED(ss%velti_glf)) then
     jsize = SIZE(ss%velti_glf)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: velti_glf already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%velti_glf(ss%nrho_anomth))
     ss%velti_glf = 0.0_rspec
  ENDIF

  isize = (ss%nrho_anomth)
  IF(ALLOCATED(ss%velti_gtcneo).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%velti_gtcneo)
  ENDIF
  IF(ALLOCATED(ss%velti_gtcneo)) then
     jsize = SIZE(ss%velti_gtcneo)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: velti_gtcneo already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%velti_gtcneo(ss%nrho_anomth))
     ss%velti_gtcneo = 0.0_rspec
  ENDIF

  isize = (ss%nrho_anomth)
  IF(ALLOCATED(ss%velti_mmm71).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%velti_mmm71)
  ENDIF
  IF(ALLOCATED(ss%velti_mmm71)) then
     jsize = SIZE(ss%velti_mmm71)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: velti_mmm71 already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%velti_mmm71(ss%nrho_anomth))
     ss%velti_mmm71 = 0.0_rspec
  ENDIF

  isize = (ss%nrho_anomth)
  IF(ALLOCATED(ss%velti_nclass).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%velti_nclass)
  ENDIF
  IF(ALLOCATED(ss%velti_nclass)) then
     jsize = SIZE(ss%velti_nclass)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: velti_nclass already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%velti_nclass(ss%nrho_anomth))
     ss%velti_nclass = 0.0_rspec
  ENDIF

  isize = (ss%nrho_anomth)
  IF(ALLOCATED(ss%velti_neo).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%velti_neo)
  ENDIF
  IF(ALLOCATED(ss%velti_neo)) then
     jsize = SIZE(ss%velti_neo)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: velti_neo already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%velti_neo(ss%nrho_anomth))
     ss%velti_neo = 0.0_rspec
  ENDIF

  isize = (ss%nrho_anomth)
  IF(ALLOCATED(ss%velti_tglf).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%velti_tglf)
  ENDIF
  IF(ALLOCATED(ss%velti_tglf)) then
     jsize = SIZE(ss%velti_tglf)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: velti_tglf already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%velti_tglf(ss%nrho_anomth))
     ss%velti_tglf = 0.0_rspec
  ENDIF

  isize = (ss%nrho)
  IF(ALLOCATED(ss%vie_trans).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%vie_trans)
  ENDIF
  IF(ALLOCATED(ss%vie_trans)) then
     jsize = SIZE(ss%vie_trans)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: vie_trans already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%vie_trans(ss%nrho))
     ss%vie_trans = 0.0_rspec
  ENDIF

  isize = (ss%nrho)*(ss%ntrcat)
  IF(ALLOCATED(ss%vie_transcat).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%vie_transcat)
  ENDIF
  IF(ALLOCATED(ss%vie_transcat)) then
     jsize = SIZE(ss%vie_transcat)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: vie_transcat already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%vie_transcat(ss%nrho,ss%ntrcat))
     ss%vie_transcat = 0.0_rspec
     ALLOCATE(ss%id_vie_transcat(ss%ntrcat))
     ss%id_vie_transcat = 0
  ENDIF

  isize = (ss%nrho)
  IF(ALLOCATED(ss%vmo_trans).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%vmo_trans)
  ENDIF
  IF(ALLOCATED(ss%vmo_trans)) then
     jsize = SIZE(ss%vmo_trans)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: vmo_trans already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%vmo_trans(ss%nrho))
     ss%vmo_trans = 0.0_rspec
  ENDIF

  isize = (ss%nrho)*(ss%ntrcat)
  IF(ALLOCATED(ss%vmo_transcat).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%vmo_transcat)
  ENDIF
  IF(ALLOCATED(ss%vmo_transcat)) then
     jsize = SIZE(ss%vmo_transcat)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: vmo_transcat already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%vmo_transcat(ss%nrho,ss%ntrcat))
     ss%vmo_transcat = 0.0_rspec
     ALLOCATE(ss%id_vmo_transcat(ss%ntrcat))
     ss%id_vmo_transcat = 0
  ENDIF

  isize = (ss%nrho)*(ss%nspec_th+1)
  IF(ss%nspec_th.LE.0) isize = 0
  IF(ALLOCATED(ss%vn_trans).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%vn_trans)
  ENDIF
  IF(ALLOCATED(ss%vn_trans)) then
     jsize = SIZE(ss%vn_trans)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: vn_trans already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%vn_trans(ss%nrho,0:ss%nspec_th))
     ss%vn_trans = 0.0_rspec
     ALLOCATE(ss%id_vn_trans(0:ss%nspec_th))
     ss%id_vn_trans = 0
  ENDIF

  isize = (ss%nrho)*(ss%nspec_th+1)*(ss%ntrcat)
  IF(ss%nspec_th.LE.0) isize = 0
  IF(ALLOCATED(ss%vn_transcat).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%vn_transcat)
  ENDIF
  IF(ALLOCATED(ss%vn_transcat)) then
     jsize = SIZE(ss%vn_transcat)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: vn_transcat already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%vn_transcat(ss%nrho,0:ss%nspec_th,ss%ntrcat))
     ss%vn_transcat = 0.0_rspec
     ALLOCATE(ss%id_vn_transcat(0:ss%nspec_th,ss%ntrcat))
     ss%id_vn_transcat = 0
  ENDIF

  isize = (ss%nrho_eq)
  IF(ALLOCATED(ss%vol).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%vol)
  ENDIF
  IF(ALLOCATED(ss%vol)) then
     jsize = SIZE(ss%vol)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: vol already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%vol(ss%nrho_eq))
     ss%vol = 0.0_rspec
  ENDIF

  isize = (ss%ngsc0)
  IF(ALLOCATED(ss%vphi0_av).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%vphi0_av)
  ENDIF
  IF(ALLOCATED(ss%vphi0_av)) then
     jsize = SIZE(ss%vphi0_av)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: vphi0_av already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%vphi0_av(ss%ngsc0))
     ss%vphi0_av = 0.0_rspec
  ENDIF

  isize = (ss%nrho-1)*(ss%nspec_th+1)
  IF(ss%nspec_th.LE.0) isize = 0
  IF(ALLOCATED(ss%vpol_inmp).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%vpol_inmp)
  ENDIF
  IF(ALLOCATED(ss%vpol_inmp)) then
     jsize = SIZE(ss%vpol_inmp)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: vpol_inmp already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%vpol_inmp(ss%nrho-1,0:ss%nspec_th))
     ss%vpol_inmp = 0.0_rspec
     ALLOCATE(ss%id_vpol_inmp(0:ss%nspec_th))
     ss%id_vpol_inmp = 0
  ENDIF

  isize = (ss%nspec_th+1)
  IF(ss%nspec_th.LE.0) isize = 0
  IF(ALLOCATED(ss%vpol_is_input).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%vpol_is_input)
  ENDIF
  IF(ALLOCATED(ss%vpol_is_input)) then
     jsize = SIZE(ss%vpol_is_input)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: vpol_is_input already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%vpol_is_input(0:ss%nspec_th))
     ss%vpol_is_input = 0
  ENDIF

  isize = (ss%nrho-1)*(ss%nspec_th+1)
  IF(ss%nspec_th.LE.0) isize = 0
  IF(ALLOCATED(ss%vpol_omp).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%vpol_omp)
  ENDIF
  IF(ALLOCATED(ss%vpol_omp)) then
     jsize = SIZE(ss%vpol_omp)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: vpol_omp already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%vpol_omp(ss%nrho-1,0:ss%nspec_th))
     ss%vpol_omp = 0.0_rspec
     ALLOCATE(ss%id_vpol_omp(0:ss%nspec_th))
     ss%id_vpol_omp = 0
  ENDIF

  isize = (ss%ncoils)
  IF(ALLOCATED(ss%VRep_coil_count).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%VRep_coil_count)
  ENDIF
  IF(ALLOCATED(ss%VRep_coil_count)) then
     jsize = SIZE(ss%VRep_coil_count)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: VRep_coil_count already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%VRep_coil_count(ss%ncoils))
     ss%VRep_coil_count = 0
  ENDIF

  isize = (ss%ncoils)
  IF(ALLOCATED(ss%Vrep_coil_spacing).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%Vrep_coil_spacing)
  ENDIF
  IF(ALLOCATED(ss%Vrep_coil_spacing)) then
     jsize = SIZE(ss%Vrep_coil_spacing)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: Vrep_coil_spacing already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%Vrep_coil_spacing(ss%ncoils))
     ss%Vrep_coil_spacing = 0.0_rspec
  ENDIF

  isize = (ss%ncoils)
  IF(ALLOCATED(ss%Vsize_coil).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%Vsize_coil)
  ENDIF
  IF(ALLOCATED(ss%Vsize_coil)) then
     jsize = SIZE(ss%Vsize_coil)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: Vsize_coil already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%Vsize_coil(ss%ncoils))
     ss%Vsize_coil = 0.0_rspec
  ENDIF

  isize = (ss%nrho-1)*(ss%nspec_th+1)
  IF(ss%nspec_th.LE.0) isize = 0
  IF(ALLOCATED(ss%vtor_inmp).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%vtor_inmp)
  ENDIF
  IF(ALLOCATED(ss%vtor_inmp)) then
     jsize = SIZE(ss%vtor_inmp)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: vtor_inmp already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%vtor_inmp(ss%nrho-1,0:ss%nspec_th))
     ss%vtor_inmp = 0.0_rspec
     ALLOCATE(ss%id_vtor_inmp(0:ss%nspec_th))
     ss%id_vtor_inmp = 0
  ENDIF

  isize = (ss%nspec_th+1)
  IF(ss%nspec_th.LE.0) isize = 0
  IF(ALLOCATED(ss%vtor_is_input).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%vtor_is_input)
  ENDIF
  IF(ALLOCATED(ss%vtor_is_input)) then
     jsize = SIZE(ss%vtor_is_input)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: vtor_is_input already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%vtor_is_input(0:ss%nspec_th))
     ss%vtor_is_input = 0
  ENDIF

  isize = (ss%nrho-1)*(ss%nspec_th+1)
  IF(ss%nspec_th.LE.0) isize = 0
  IF(ALLOCATED(ss%vtor_omp).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%vtor_omp)
  ENDIF
  IF(ALLOCATED(ss%vtor_omp)) then
     jsize = SIZE(ss%vtor_omp)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: vtor_omp already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%vtor_omp(ss%nrho-1,0:ss%nspec_th))
     ss%vtor_omp = 0.0_rspec
     ALLOCATE(ss%id_vtor_omp(0:ss%nspec_th))
     ss%id_vtor_omp = 0
  ENDIF

  isize = (ss%nrho)
  IF(ALLOCATED(ss%V_loop).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%V_loop)
  ENDIF
  IF(ALLOCATED(ss%V_loop)) then
     jsize = SIZE(ss%V_loop)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: V_loop already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%V_loop(ss%nrho))
     ss%V_loop = 0.0_rspec
  ENDIF

  isize = (ss%nrho-1)*(ss%nspec_th+1)
  IF(ss%nspec_th.LE.0) isize = 0
  IF(ALLOCATED(ss%v_pars).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%v_pars)
  ENDIF
  IF(ALLOCATED(ss%v_pars)) then
     jsize = SIZE(ss%v_pars)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: v_pars already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%v_pars(ss%nrho-1,0:ss%nspec_th))
     ss%v_pars = 0.0_rspec
     ALLOCATE(ss%id_v_pars(0:ss%nspec_th))
     ss%id_v_pars = 0
  ENDIF

  isize = (ss%nrho-1)*(ss%nspec_th+1)
  IF(ss%nspec_th.LE.0) isize = 0
  IF(ALLOCATED(ss%v_pers).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%v_pers)
  ENDIF
  IF(ALLOCATED(ss%v_pers)) then
     jsize = SIZE(ss%v_pers)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: v_pers already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%v_pers(ss%nrho-1,0:ss%nspec_th))
     ss%v_pers = 0.0_rspec
     ALLOCATE(ss%id_v_pers(0:ss%nspec_th))
     ss%id_v_pers = 0
  ENDIF

  isize = (ss%max_num_nphi)*(ss%nicrf_src)
  IF(ALLOCATED(ss%wt_nphi).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%wt_nphi)
  ENDIF
  IF(ALLOCATED(ss%wt_nphi)) then
     jsize = SIZE(ss%wt_nphi)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: wt_nphi already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%wt_nphi(ss%max_num_nphi,ss%nicrf_src))
     ss%wt_nphi = 0.0_rspec
  ENDIF

  isize = (ss%max_num_nphi)*(ss%nicrf_src)
  IF(ALLOCATED(ss%wt_nphi_abs).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%wt_nphi_abs)
  ENDIF
  IF(ALLOCATED(ss%wt_nphi_abs)) then
     jsize = SIZE(ss%wt_nphi_abs)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: wt_nphi_abs already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%wt_nphi_abs(ss%max_num_nphi,ss%nicrf_src))
     ss%wt_nphi_abs = 0.0_rspec
  ENDIF

  isize = (ss%max_num_nphi)*(ss%nicrf_src)
  IF(ALLOCATED(ss%wt_nphi_ext).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%wt_nphi_ext)
  ENDIF
  IF(ALLOCATED(ss%wt_nphi_ext)) then
     jsize = SIZE(ss%wt_nphi_ext)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: wt_nphi_ext already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%wt_nphi_ext(ss%max_num_nphi,ss%nicrf_src))
     ss%wt_nphi_ext = 0.0_rspec
  ENDIF

  isize = (ss%nrho_eq)*(ss%neqmom)
  IF(ALLOCATED(ss%xRjcos_momeq).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%xRjcos_momeq)
  ENDIF
  IF(ALLOCATED(ss%xRjcos_momeq)) then
     jsize = SIZE(ss%xRjcos_momeq)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: xRjcos_momeq already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%xRjcos_momeq(ss%nrho_eq,ss%neqmom))
     ss%xRjcos_momeq = 0.0_rspec
     ALLOCATE(ss%id_xRjcos_momeq(ss%neqmom))
     ss%id_xRjcos_momeq = 0
  ENDIF

  isize = (ss%nrho_eq)*(ss%neqmom)
  IF(ALLOCATED(ss%xRjsin_momeq).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%xRjsin_momeq)
  ENDIF
  IF(ALLOCATED(ss%xRjsin_momeq)) then
     jsize = SIZE(ss%xRjsin_momeq)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: xRjsin_momeq already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%xRjsin_momeq(ss%nrho_eq,ss%neqmom))
     ss%xRjsin_momeq = 0.0_rspec
     ALLOCATE(ss%id_xRjsin_momeq(ss%neqmom))
     ss%id_xRjsin_momeq = 0
  ENDIF

  isize = (ss%nxs)
  IF(ALLOCATED(ss%xs).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%xs)
  ENDIF
  IF(ALLOCATED(ss%xs)) then
     jsize = SIZE(ss%xs)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: xs already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%xs(ss%nxs))
     ss%xs = 0.0_rspec
  ENDIF

  isize = (ss%nxs)
  IF(ALLOCATED(ss%xs_name).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%xs_name)
  ENDIF
  IF(ALLOCATED(ss%xs_name)) then
     jsize = SIZE(ss%xs_name)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: xs_name already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%xs_name(ss%nxs))
     ss%xs_name = " "
  ENDIF

  isize = (ss%nrho_eq)*(ss%neqmom)
  IF(ALLOCATED(ss%xZjcos_momeq).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%xZjcos_momeq)
  ENDIF
  IF(ALLOCATED(ss%xZjcos_momeq)) then
     jsize = SIZE(ss%xZjcos_momeq)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: xZjcos_momeq already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%xZjcos_momeq(ss%nrho_eq,ss%neqmom))
     ss%xZjcos_momeq = 0.0_rspec
     ALLOCATE(ss%id_xZjcos_momeq(ss%neqmom))
     ss%id_xZjcos_momeq = 0
  ENDIF

  isize = (ss%nrho_eq)*(ss%neqmom)
  IF(ALLOCATED(ss%xZjsin_momeq).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%xZjsin_momeq)
  ENDIF
  IF(ALLOCATED(ss%xZjsin_momeq)) then
     jsize = SIZE(ss%xZjsin_momeq)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: xZjsin_momeq already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%xZjsin_momeq(ss%nrho_eq,ss%neqmom))
     ss%xZjsin_momeq = 0.0_rspec
     ALLOCATE(ss%id_xZjsin_momeq(ss%neqmom))
     ss%id_xZjsin_momeq = 0
  ENDIF

  isize = (ss%nrho_eq)
  IF(ALLOCATED(ss%Z0_momeq).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%Z0_momeq)
  ENDIF
  IF(ALLOCATED(ss%Z0_momeq)) then
     jsize = SIZE(ss%Z0_momeq)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: Z0_momeq already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%Z0_momeq(ss%nrho_eq))
     ss%Z0_momeq = 0.0_rspec
  ENDIF

  isize = (ss%nbeam)
  IF(ALLOCATED(ss%Zbap).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%Zbap)
  ENDIF
  IF(ALLOCATED(ss%Zbap)) then
     jsize = SIZE(ss%Zbap)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: Zbap already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%Zbap(ss%nbeam))
     ss%Zbap = 0.0_rspec
  ENDIF

  isize = (ss%nbeam)
  IF(ALLOCATED(ss%Zbsc).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%Zbsc)
  ENDIF
  IF(ALLOCATED(ss%Zbsc)) then
     jsize = SIZE(ss%Zbsc)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: Zbsc already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%Zbsc(ss%nbeam))
     ss%Zbsc = 0.0_rspec
  ENDIF

  isize = (ss%nrho-1)
  IF(ALLOCATED(ss%Zeff).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%Zeff)
  ENDIF
  IF(ALLOCATED(ss%Zeff)) then
     jsize = SIZE(ss%Zeff)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: Zeff already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%Zeff(ss%nrho-1))
     ss%Zeff = 0.0_rspec
  ENDIF

  isize = (ss%nrho-1)
  IF(ALLOCATED(ss%Zeff_fi).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%Zeff_fi)
  ENDIF
  IF(ALLOCATED(ss%Zeff_fi)) then
     jsize = SIZE(ss%Zeff_fi)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: Zeff_fi already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%Zeff_fi(ss%nrho-1))
     ss%Zeff_fi = 0.0_rspec
  ENDIF

  isize = (ss%nrho-1)
  IF(ALLOCATED(ss%Zeff_th).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%Zeff_th)
  ENDIF
  IF(ALLOCATED(ss%Zeff_th)) then
     jsize = SIZE(ss%Zeff_th)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: Zeff_th already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%Zeff_th(ss%nrho-1))
     ss%Zeff_th = 0.0_rspec
  ENDIF

  isize = (ss%num_rzlim)
  IF(ALLOCATED(ss%zlim).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%zlim)
  ENDIF
  IF(ALLOCATED(ss%zlim)) then
     jsize = SIZE(ss%zlim)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: zlim already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%zlim(ss%num_rzlim))
     ss%zlim = 0.0_rspec
  ENDIF

  isize = (ss%ncoils)
  IF(ALLOCATED(ss%Zloc_coil).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%Zloc_coil)
  ENDIF
  IF(ALLOCATED(ss%Zloc_coil)) then
     jsize = SIZE(ss%Zloc_coil)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: Zloc_coil already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%Zloc_coil(ss%ncoils))
     ss%Zloc_coil = 0.0_rspec
  ENDIF

  isize = (ss%nicrf_src)
  IF(ALLOCATED(ss%Z_ant).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%Z_ant)
  ENDIF
  IF(ALLOCATED(ss%Z_ant)) then
     jsize = SIZE(ss%Z_ant)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: Z_ant already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%Z_ant(ss%nicrf_src))
     ss%Z_ant = 0.0_rspec
  ENDIF

  isize = (ss%max_nrz_antgeo)*(ss%nicrf_src)
  IF(ALLOCATED(ss%Z_antgeo).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%Z_antgeo)
  ENDIF
  IF(ALLOCATED(ss%Z_antgeo)) then
     jsize = SIZE(ss%Z_antgeo)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: Z_antgeo already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%Z_antgeo(ss%max_nrz_antgeo,ss%nicrf_src))
     ss%Z_antgeo = 0.0_rspec
  ENDIF

  isize = (ss%necrf_src)
  IF(ALLOCATED(ss%Z_EC_launch).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%Z_EC_launch)
  ENDIF
  IF(ALLOCATED(ss%Z_EC_launch)) then
     jsize = SIZE(ss%Z_EC_launch)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: Z_EC_launch already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%Z_EC_launch(ss%necrf_src))
     ss%Z_EC_launch = 0.0_rspec
  ENDIF

  isize = (ss%nrho_eq)*(ss%nth_eq)
  IF(ALLOCATED(ss%Z_geo).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%Z_geo)
  ENDIF
  IF(ALLOCATED(ss%Z_geo)) then
     jsize = SIZE(ss%Z_geo)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: Z_geo already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%Z_geo(ss%nrho_eq,ss%nth_eq))
     ss%Z_geo = 0.0_rspec
  ENDIF

  isize = (ss%nz)
  IF(ALLOCATED(ss%Z_grid).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%Z_grid)
  ENDIF
  IF(ALLOCATED(ss%Z_grid)) then
     jsize = SIZE(ss%Z_grid)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: Z_grid already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%Z_grid(ss%nz))
     ss%Z_grid = 0.0_rspec
  ENDIF

  isize = (ss%nrho_eq_geo)
  IF(ALLOCATED(ss%Z_midp).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%Z_midp)
  ENDIF
  IF(ALLOCATED(ss%Z_midp)) then
     jsize = SIZE(ss%Z_midp)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: Z_midp already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%Z_midp(ss%nrho_eq_geo))
     ss%Z_midp = 0.0_rspec
  ENDIF

  isize = (ss%nicrf_src)
  IF(ALLOCATED(ss%Z_mid_ant).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%Z_mid_ant)
  ENDIF
  IF(ALLOCATED(ss%Z_mid_ant)) then
     jsize = SIZE(ss%Z_mid_ant)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: Z_mid_ant already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%Z_mid_ant(ss%nicrf_src))
     ss%Z_mid_ant = 0.0_rspec
  ENDIF

  isize = (ss%nz_rip)
  IF(ALLOCATED(ss%Z_ripple).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%Z_ripple)
  ENDIF
  IF(ALLOCATED(ss%Z_ripple)) then
     jsize = SIZE(ss%Z_ripple)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: Z_ripple already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%Z_ripple(ss%nz_rip))
     ss%Z_ripple = 0.0_rspec
  ENDIF

  isize = (ss%nrho_eq_geo)
  IF(ALLOCATED(ss%Z_surfMax).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%Z_surfMax)
  ENDIF
  IF(ALLOCATED(ss%Z_surfMax)) then
     jsize = SIZE(ss%Z_surfMax)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: Z_surfMax already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%Z_surfMax(ss%nrho_eq_geo))
     ss%Z_surfMax = 0.0_rspec
  ENDIF

  isize = (ss%nrho_eq_geo)
  IF(ALLOCATED(ss%Z_surfMin).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%Z_surfMin)
  ENDIF
  IF(ALLOCATED(ss%Z_surfMin)) then
     jsize = SIZE(ss%Z_surfMin)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: Z_surfMin already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%Z_surfMin(ss%nrho_eq_geo))
     ss%Z_surfMin = 0.0_rspec
  ENDIF

END SUBROUTINE plasma_state_empty_alloc_9

subroutine ccps_alloc(iobj,ierr)

  ! allocate a portion of a state object
  !    state elements for which all array dimensions have been defined (are
  !    non-zero) are allocated.

  use plasma_state_mod
  implicit NONE

  integer :: iobj(*)   ! (ps_container_size) words are used
  integer :: ierr

  !--------------------------------
  type (plasma_state_container) :: ptr
  type (plasma_state), pointer :: ss
  !--------------------------------

  call ccps_argcheck('ccps_alloc',iobj,ierr)
  if(ierr.ne.0) return

  ! proceed...

  call load_ps_container(iobj,ptr)
  ss => ptr%ps_ptr

  call ps_alloc_plasma_state(ierr, state=ss)

end subroutine ccps_alloc

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_r0_dummy
     return
  end subroutine ccps_getset_r0_dummy

subroutine psget_r_antgeo(iobj, n1, n2, data, ierr)
    !! antenna geo: R pts
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_r_antgeo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % R_antgeo
end subroutine psget_r_antgeo


subroutine psset_r_antgeo(iobj, n1, n2, data, ierr)
    !! antenna geo: R pts
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_r_antgeo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % R_antgeo = data(1:n1, 1: n2)
end subroutine psset_r_antgeo


subroutine psgetrnk_r_antgeo(iobj, ndims, ierr)
    !! antenna geo: R pts
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_r_antgeo


subroutine psgetdim_r_antgeo(iobj, ndims, dims, ierr)
    !! antenna geo: R pts
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_r_antgeo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % R_antgeo ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % R_antgeo)
    endif
end subroutine psgetdim_r_antgeo


subroutine psget_rad_data_info(iobj, data, ierr)
    !! Information on source of radiated power data
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    CHARACTER*(*), intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_rad_data_info', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % RAD_Data_Info
end subroutine psget_rad_data_info


subroutine psset_rad_data_info(iobj, data, ierr)
    !! Information on source of radiated power data
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    CHARACTER*(*), intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_rad_data_info', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % RAD_Data_Info = data
end subroutine psset_rad_data_info


subroutine psgetsz_rad_data_info(iobj, size, ierr)
    !! Information on source of radiated power data
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: size    ! size of character string
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psgetsz_rad_data_info', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! note that the following will return the character length size regardless of
    ! the number of array elements (if RAD_Data_Info is an array)
    size = len(ss % RAD_Data_Info)
end subroutine psgetsz_rad_data_info


subroutine psget_rho_icrf(iobj, n1, data, ierr)
    !! rho grid (RF)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_rho_icrf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % rho_icrf
end subroutine psget_rho_icrf


subroutine psset_rho_icrf(iobj, n1, data, ierr)
    !! rho grid (RF)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_rho_icrf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % rho_icrf = data(1:n1)
end subroutine psset_rho_icrf


subroutine psgetrnk_rho_icrf(iobj, ndims, ierr)
    !! rho grid (RF)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_rho_icrf


subroutine psgetdim_rho_icrf(iobj, ndims, dims, ierr)
    !! rho grid (RF)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_rho_icrf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % rho_icrf ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % rho_icrf)
    endif
end subroutine psgetdim_rho_icrf


subroutine psget_rho_rw(iobj, n1, data, ierr)
    !! rho grid -- RUNAWAY electrons
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_rho_rw', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % rho_rw
end subroutine psget_rho_rw


subroutine psset_rho_rw(iobj, n1, data, ierr)
    !! rho grid -- RUNAWAY electrons
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_rho_rw', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % rho_rw = data(1:n1)
end subroutine psset_rho_rw


subroutine psgetrnk_rho_rw(iobj, ndims, ierr)
    !! rho grid -- RUNAWAY electrons
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_rho_rw


subroutine psgetdim_rho_rw(iobj, ndims, dims, ierr)
    !! rho grid -- RUNAWAY electrons
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_rho_rw', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % rho_rw ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % rho_rw)
    endif
end subroutine psgetdim_rho_rw

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_b1_dummy
     return
  end subroutine ccps_getset_b1_dummy

subroutine psget_b_axis(iobj, data, ierr)
    !! |B| at magnetic axis
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_b_axis', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % B_axis
end subroutine psget_b_axis


subroutine psset_b_axis(iobj, data, ierr)
    !! |B| at magnetic axis
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_b_axis', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % B_axis = data
end subroutine psset_b_axis


subroutine psget_b_surfmin(iobj, n1, data, ierr)
    !! min mod(B) on flux surface
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_b_surfmin', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % B_surfMin
end subroutine psget_b_surfmin


subroutine psset_b_surfmin(iobj, n1, data, ierr)
    !! min mod(B) on flux surface
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_b_surfmin', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % B_surfMin = data(1:n1)
end subroutine psset_b_surfmin


subroutine psgetrnk_b_surfmin(iobj, ndims, ierr)
    !! min mod(B) on flux surface
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_b_surfmin


subroutine psgetdim_b_surfmin(iobj, ndims, dims, ierr)
    !! min mod(B) on flux surface
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_b_surfmin', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % B_surfMin ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % B_surfMin)
    endif
end subroutine psgetdim_b_surfmin


subroutine psget_bidiff_dpass_co(iobj, n1, n2, n3, data, ierr)
    !! beam ion diffusivity: co passing |vpll/v| -> 1
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2, n3 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2, n3) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_bidiff_dpass_co', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2, 1: n3) = ss % bidiff_dpass_co
end subroutine psget_bidiff_dpass_co


subroutine psset_bidiff_dpass_co(iobj, n1, n2, n3, data, ierr)
    !! beam ion diffusivity: co passing |vpll/v| -> 1
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2, n3 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2, n3) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_bidiff_dpass_co', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % bidiff_dpass_co = data(1:n1, 1: n2, 1: n3)
end subroutine psset_bidiff_dpass_co


subroutine psgetrnk_bidiff_dpass_co(iobj, ndims, ierr)
    !! beam ion diffusivity: co passing |vpll/v| -> 1
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 3
end subroutine psgetrnk_bidiff_dpass_co


subroutine psgetdim_bidiff_dpass_co(iobj, ndims, dims, ierr)
    !! beam ion diffusivity: co passing |vpll/v| -> 1
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 3) ierr = 1
    call ccps_argcheck('psgetdim_bidiff_dpass_co', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % bidiff_dpass_co ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % bidiff_dpass_co)
    endif
end subroutine psgetdim_bidiff_dpass_co

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_v5_dummy
     return
  end subroutine ccps_getset_v5_dummy

subroutine psget_vtor_is_input(iobj, n1, data, ierr)
    !! specie outer midplane toroidal velocit flag
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_vtor_is_input', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % vtor_is_input
end subroutine psget_vtor_is_input


subroutine psset_vtor_is_input(iobj, n1, data, ierr)
    !! specie outer midplane toroidal velocit flag
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_vtor_is_input', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % vtor_is_input = data(1:n1)
end subroutine psset_vtor_is_input


subroutine psgetrnk_vtor_is_input(iobj, ndims, ierr)
    !! specie outer midplane toroidal velocit flag
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_vtor_is_input


subroutine psgetdim_vtor_is_input(iobj, ndims, dims, ierr)
    !! specie outer midplane toroidal velocit flag
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_vtor_is_input', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % vtor_is_input ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % vtor_is_input)
    endif
end subroutine psgetdim_vtor_is_input


subroutine psget_vsur(iobj, data, ierr)
    !! toroidal voltage at surface
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_vsur', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % vsur
end subroutine psget_vsur


subroutine psset_vsur(iobj, data, ierr)
    !! toroidal voltage at surface
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_vsur', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % vsur = data
end subroutine psset_vsur


subroutine psget_vtor_inmp(iobj, n1, n2, data, ierr)
    !! toroidal velocity, inner half midplane
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_vtor_inmp', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % vtor_inmp
end subroutine psget_vtor_inmp


subroutine psset_vtor_inmp(iobj, n1, n2, data, ierr)
    !! toroidal velocity, inner half midplane
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_vtor_inmp', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % vtor_inmp = data(1:n1, 1: n2)
end subroutine psset_vtor_inmp


subroutine psgetrnk_vtor_inmp(iobj, ndims, ierr)
    !! toroidal velocity, inner half midplane
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_vtor_inmp


subroutine psgetdim_vtor_inmp(iobj, ndims, dims, ierr)
    !! toroidal velocity, inner half midplane
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_vtor_inmp', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % vtor_inmp ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % vtor_inmp)
    endif
end subroutine psgetdim_vtor_inmp


subroutine psget_velte_tglf(iobj, n1, data, ierr)
    !! Te-equation, advective velocity term from TGLF model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_velte_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % velte_tglf
end subroutine psget_velte_tglf


subroutine psset_velte_tglf(iobj, n1, data, ierr)
    !! Te-equation, advective velocity term from TGLF model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_velte_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % velte_tglf = data(1:n1)
end subroutine psset_velte_tglf


subroutine psgetrnk_velte_tglf(iobj, ndims, ierr)
    !! Te-equation, advective velocity term from TGLF model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_velte_tglf


subroutine psgetdim_velte_tglf(iobj, ndims, dims, ierr)
    !! Te-equation, advective velocity term from TGLF model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_velte_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % velte_tglf ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % velte_tglf)
    endif
end subroutine psgetdim_velte_tglf


subroutine psget_velns_glf(iobj, n1, n2, data, ierr)
    !! density-equations, advective velocity term from GLF23 model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_velns_glf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % velns_glf
end subroutine psget_velns_glf


subroutine psset_velns_glf(iobj, n1, n2, data, ierr)
    !! density-equations, advective velocity term from GLF23 model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_velns_glf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % velns_glf = data(1:n1, 1: n2)
end subroutine psset_velns_glf


subroutine psgetrnk_velns_glf(iobj, ndims, ierr)
    !! density-equations, advective velocity term from GLF23 model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_velns_glf


subroutine psgetdim_velns_glf(iobj, ndims, dims, ierr)
    !! density-equations, advective velocity term from GLF23 model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_velns_glf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % velns_glf ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % velns_glf)
    endif
end subroutine psgetdim_velns_glf


subroutine psget_velti_gtcneo(iobj, n1, data, ierr)
    !! Ti-equation, advective velocity term from GTC_NEO model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_velti_gtcneo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % velti_gtcneo
end subroutine psget_velti_gtcneo


subroutine psset_velti_gtcneo(iobj, n1, data, ierr)
    !! Ti-equation, advective velocity term from GTC_NEO model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_velti_gtcneo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % velti_gtcneo = data(1:n1)
end subroutine psset_velti_gtcneo


subroutine psgetrnk_velti_gtcneo(iobj, ndims, ierr)
    !! Ti-equation, advective velocity term from GTC_NEO model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_velti_gtcneo


subroutine psgetdim_velti_gtcneo(iobj, ndims, dims, ierr)
    !! Ti-equation, advective velocity term from GTC_NEO model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_velti_gtcneo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % velti_gtcneo ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % velti_gtcneo)
    endif
end subroutine psgetdim_velti_gtcneo


subroutine psget_velns_neo(iobj, n1, n2, data, ierr)
    !! density-equations, advective velocity term from NEO model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_velns_neo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % velns_neo
end subroutine psget_velns_neo


subroutine psset_velns_neo(iobj, n1, n2, data, ierr)
    !! density-equations, advective velocity term from NEO model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_velns_neo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % velns_neo = data(1:n1, 1: n2)
end subroutine psset_velns_neo


subroutine psgetrnk_velns_neo(iobj, ndims, ierr)
    !! density-equations, advective velocity term from NEO model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_velns_neo


subroutine psgetdim_velns_neo(iobj, ndims, dims, ierr)
    !! density-equations, advective velocity term from NEO model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_velns_neo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % velns_neo ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % velns_neo)
    endif
end subroutine psgetdim_velns_neo


subroutine psget_velne_nclass(iobj, n1, data, ierr)
    !! electron-density-equations, advective velocity term from
    !! NCLASS model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_velne_nclass', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % velne_nclass
end subroutine psget_velne_nclass


subroutine psset_velne_nclass(iobj, n1, data, ierr)
    !! electron-density-equations, advective velocity term from
    !! NCLASS model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_velne_nclass', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % velne_nclass = data(1:n1)
end subroutine psset_velne_nclass


subroutine psgetrnk_velne_nclass(iobj, ndims, ierr)
    !! electron-density-equations, advective velocity term from
    !! NCLASS model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_velne_nclass


subroutine psgetdim_velne_nclass(iobj, ndims, dims, ierr)
    !! electron-density-equations, advective velocity term from
    !! NCLASS model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_velne_nclass', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % velne_nclass ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % velne_nclass)
    endif
end subroutine psgetdim_velne_nclass

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_p8_dummy
     return
  end subroutine ccps_getset_p8_dummy

subroutine psget_phigrilh(iobj, n1, n2, data, ierr)
    !! need description
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_phigrilh', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % phigrilh
end subroutine psget_phigrilh


subroutine psset_phigrilh(iobj, n1, n2, data, ierr)
    !! need description
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_phigrilh', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % phigrilh = data(1:n1, 1: n2)
end subroutine psset_phigrilh


subroutine psgetrnk_phigrilh(iobj, ndims, ierr)
    !! need description
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_phigrilh


subroutine psgetdim_phigrilh(iobj, ndims, dims, ierr)
    !! need description
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_phigrilh', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % phigrilh ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % phigrilh)
    endif
end subroutine psgetdim_phigrilh


subroutine psget_power_nbi_trace(iobj, n1, data, ierr)
    !! power injected as trace element (if any), total power on
    !! beam ib is power_nbi(ib) + power_nbi_trace(ib)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_power_nbi_trace', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % power_nbi_trace
end subroutine psget_power_nbi_trace


subroutine psset_power_nbi_trace(iobj, n1, data, ierr)
    !! power injected as trace element (if any), total power on
    !! beam ib is power_nbi(ib) + power_nbi_trace(ib)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_power_nbi_trace', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % power_nbi_trace = data(1:n1)
end subroutine psset_power_nbi_trace


subroutine psgetrnk_power_nbi_trace(iobj, ndims, ierr)
    !! power injected as trace element (if any), total power on
    !! beam ib is power_nbi(ib) + power_nbi_trace(ib)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_power_nbi_trace


subroutine psgetdim_power_nbi_trace(iobj, ndims, dims, ierr)
    !! power injected as trace element (if any), total power on
    !! beam ib is power_nbi(ib) + power_nbi_trace(ib)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_power_nbi_trace', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % power_nbi_trace ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % power_nbi_trace)
    endif
end subroutine psgetdim_power_nbi_trace


subroutine psget_psipol(iobj, n1, data, ierr)
    !! poloidal flux vs. rho, By convention, this profile always
    !! positive; 0 on axis., -- see kccw_Jphi; see also
    !! psi_to_machine_axis, for specification of direction (sign) of
    !! toroidal current and, hence the poloidal magnetic field.
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_psipol', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % psipol
end subroutine psget_psipol


subroutine psset_psipol(iobj, n1, data, ierr)
    !! poloidal flux vs. rho, By convention, this profile always
    !! positive; 0 on axis., -- see kccw_Jphi; see also
    !! psi_to_machine_axis, for specification of direction (sign) of
    !! toroidal current and, hence the poloidal magnetic field.
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_psipol', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % psipol = data(1:n1)
end subroutine psset_psipol


subroutine psgetrnk_psipol(iobj, ndims, ierr)
    !! poloidal flux vs. rho, By convention, this profile always
    !! positive; 0 on axis., -- see kccw_Jphi; see also
    !! psi_to_machine_axis, for specification of direction (sign) of
    !! toroidal current and, hence the poloidal magnetic field.
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_psipol


subroutine psgetdim_psipol(iobj, ndims, dims, ierr)
    !! poloidal flux vs. rho, By convention, this profile always
    !! positive; 0 on axis., -- see kccw_Jphi; see also
    !! psi_to_machine_axis, for specification of direction (sign) of
    !! toroidal current and, hence the poloidal magnetic field.
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_psipol', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % psipol ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % psipol)
    endif
end subroutine psgetdim_psipol


subroutine psget_pelh_src(iobj, n1, n2, data, ierr)
    !! LH electron heating by antenna
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_pelh_src', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % pelh_src
end subroutine psget_pelh_src


subroutine psset_pelh_src(iobj, n1, n2, data, ierr)
    !! LH electron heating by antenna
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_pelh_src', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % pelh_src = data(1:n1, 1: n2)
end subroutine psset_pelh_src


subroutine psgetrnk_pelh_src(iobj, ndims, ierr)
    !! LH electron heating by antenna
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_pelh_src


subroutine psgetdim_pelh_src(iobj, ndims, dims, ierr)
    !! LH electron heating by antenna
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_pelh_src', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % pelh_src ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % pelh_src)
    endif
end subroutine psgetdim_pelh_src

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


SUBROUTINE ps_update_file_write(filename,ss,cclist,iwarn,ierr)

  ! store (i.e. write to file) plasma state updates
  ! determine what to write as follows:
  !   (a) scalar data:  each item with a change in value is written; if any
  !       element of an array of scalars has changes the entire array is
  !       written.
  !   (b) profile data:  each array that contains ANY changes is written;
  !       Note the entire array is written if there are changes to any parts.
  !   (c) array dimensions needed to define arrays to be written... are also
  !       written.
  !
  ! dimensioning information necessary to support this data is also written.
  ! attributes are NOT written-- these are in the full state files only.

  USE plasma_state_definition_mod
  USE netcdf
  USE ps_nidlist_defn
  IMPLICIT NONE

  CHARACTER*(*), INTENT(IN) :: filename        ! update file
  TYPE (plasma_state) :: ss     ! state containing data to write
  INTEGER, INTENT(IN) :: cclist(ps_ccount) ! component-by-component control

  INTEGER, INTENT(OUT) :: iwarn ! number of modified items not written
  !  this would be due to a modification in an item belonging to component XX
  !  for which cclist(ps_cnum_XX).ne.1; warning messages are printed.

  INTEGER, INTENT(OUT) :: ierr  ! completion code (0=OK)

  !-----------------------
  LOGICAL :: plasma_state_hash_match,ichange

  TYPE (nidlist) :: nids

  INTEGER :: icdf,iout,varid,pvarid,vvarid,dimid,status,iertot,iertmp,iaddr
  INTEGER :: idims(20),indim,ival,iucount,ii
  CHARACTER*80 :: nc_errmsg


  !-----------------------
  ! Initialization...

  nids%nid_dim_max_nrz_antgeo = 0
  nids%nid_dim_max_nspectrumlh_src = 0
  nids%nid_dim_max_num_nphi = 0
  nids%nid_dim_max_num_nphi_vac = 0
  nids%nid_dim_max_n_straps = 0
  nids%nid_dim_mmodes = 0
  nids%nid_dim_nballoon = 0
  nids%nid_dim_nbeam = 0
  nids%nid_dim_ncircuits = 0
  nids%nid_dim_ncoils = 0
  nids%nid_dim_ndelta_w = 0
  nids%nid_dim_necrf_src = 0
  nids%nid_dim_nefi_anom = 0
  nids%nid_dim_nefi_anom2 = 0
  nids%nid_dim_neqmom = 0
  nids%nid_dim_ngsc0 = 0
  nids%nid_dim_nicrf_src = 0
  nids%nid_dim_nky_anomth = 0
  nids%nid_dim_nky_mmm = 0
  nids%nid_dim_nlhrf_src = 0
  nids%nid_dim_nnewcomb = 0
  nids%nid_dim_npsmom = 0
  nids%nid_dim_nr = 0
  nids%nid_dm1_nrho = 0
  nids%nid_dim_nrho = 0
  nids%nid_dim_nrho_anom = 0
  nids%nid_dim_nrho_anom2 = 0
  nids%nid_dm1_nrho_anomth = 0
  nids%nid_dim_nrho_anomth = 0
  nids%nid_dm1_nrho_ecrf = 0
  nids%nid_dim_nrho_ecrf = 0
  nids%nid_dim_nrho_eq = 0
  nids%nid_dim_nrho_eq_geo = 0
  nids%nid_dm1_nrho_fus = 0
  nids%nid_dim_nrho_fus = 0
  nids%nid_dm1_nrho_gas = 0
  nids%nid_dim_nrho_gas = 0
  nids%nid_dm1_nrho_icrf = 0
  nids%nid_dim_nrho_icrf = 0
  nids%nid_dm1_nrho_lhrf = 0
  nids%nid_dim_nrho_lhrf = 0
  nids%nid_dim_nrho_lmhd = 0
  nids%nid_dm1_nrho_mist = 0
  nids%nid_dim_nrho_mist = 0
  nids%nid_dm1_nrho_nbi = 0
  nids%nid_dim_nrho_nbi = 0
  nids%nid_dm1_nrho_pel = 0
  nids%nid_dim_nrho_pel = 0
  nids%nid_dm1_nrho_rad = 0
  nids%nid_dim_nrho_rad = 0
  nids%nid_dm1_nrho_rw = 0
  nids%nid_dim_nrho_rw = 0
  nids%nid_dim_nr_rip = 0
  nids%nid_dim_nspec_all = 0
  nids%nid_dp1_nspec_all = 0
  nids%nid_dim_nspec_alla = 0
  nids%nid_dp1_nspec_alla = 0
  nids%nid_dim_nspec_beam = 0
  nids%nid_dim_nspec_fusion = 0
  nids%nid_dim_nspec_gas = 0
  nids%nid_dim_nspec_imp0 = 0
  nids%nid_dim_nspec_impi = 0
  nids%nid_dim_nspec_rfmin = 0
  nids%nid_dim_nspec_th = 0
  nids%nid_dp1_nspec_th = 0
  nids%nid_dim_nspec_tha = 0
  nids%nid_dp1_nspec_tha = 0
  nids%nid_dim_nth_eq = 0
  nids%nid_dim_ntrcat = 0
  nids%nid_dim_num_rzlim = 0
  nids%nid_dim_nxs = 0
  nids%nid_dim_nz = 0
  nids%nid_dim_nz_rip = 0
  nids%nid_dim_n_d_einj_standard = 0
  nids%nid_dim_n_h_einj_standard = 0
  nids%nid_dim_n_t_einj_standard = 0
  nids%nid_clen_32 = 0
  nids%nid_clen_256 = 0
  nids%nid_clen_80 = 0

  iout = SWIM_err_out_file

  iucount = 0

  iwarn = 0

  !------------------------------------
  ! reload equilibrium and other data in xplasma, with checks, as needed...
  ! ...hand maintained code orchestrates:
  !     0. plasma_state_empty_alloc; update ps_active_dims(...)
  !     1. compute new_hash_codes
  !     2. xplasma update of equilibrium as needed based on hash codes
  !     3. xplasma update of data and profiles as needed
  !     4. "zonwt" update
  !     5. update of derived quantities in xplasma.

  CALL ps_xload_check(ss,iout,1,ierr)
  IF(ierr.NE.0) THEN
     WRITE(iout,*) " ?ps_update_file_write: error in ps_xload_check."
     ierr = 9999
     RETURN
  ENDIF

  !------------------------------------
  ! open the updates file...

  status = nf90_create(trim(filename),NF90_CLOBBER,icdf)
  IF(status.NE.NF90_NOERR) THEN
     CALL ncerr(status)
     WRITE(iout,*) ' ?ps_update_file_write: file create failure: "'//trim(filename)//'".'
     ierr=9999
     RETURN
  ENDIF

  status = nf90_def_var(icdf,"ps_partial_update",NF90_INT, varid=pvarid)
  IF(status.NE.NF90_NOERR) THEN
     CALL ncerr(status)
     WRITE(iout,*) ' ?ps_update_file_write: "ps_partial_update" variable definition error."'
     ierr=9999
     RETURN
  ENDIF

  !------------------------------------
  iertot = 0

  status = nf90_def_dim(icdf,"ps_clen_32",32,dimid)
  IF(status.NE.NF90_NOERR) THEN
     WRITE(iout,*) " error defining dimension: ps_clen_32"
     CALL ncerr(status)
     iertot = iertot + 1
  ELSE
     nids%nid_clen_32 = dimid
  ENDIF

  status = nf90_def_dim(icdf,"ps_clen_256",256,dimid)
  IF(status.NE.NF90_NOERR) THEN
     WRITE(iout,*) " error defining dimension: ps_clen_256"
     CALL ncerr(status)
     iertot = iertot + 1
  ELSE
     nids%nid_clen_256 = dimid
  ENDIF

  status = nf90_def_dim(icdf,"ps_clen_80",80,dimid)
  IF(status.NE.NF90_NOERR) THEN
     WRITE(iout,*) " error defining dimension: ps_clen_80"
     CALL ncerr(status)
     iertot = iertot + 1
  ELSE
     nids%nid_clen_80 = dimid
  ENDIF

  IF(iertot.GT.0) THEN
     WRITE(iout,*) ' ?ps_update_file_write: character length dimension error.'
     ierr=9999
     RETURN
  ENDIF

  idims(1) = nids%nid_clen_32
  status = nf90_def_var(icdf,"version_id",NF90_CHAR, &
           dimids=idims(1:1), varid=vvarid)
  IF(status.NE.NF90_NOERR) THEN
     write(iout,*) " error defining: version_id character string."
     call ncerr(status)
     iertot = iertot + 1
  ENDIF

  !---------------------------------------------
  ! call subroutines to define data and arrays...

  call ps_update_file_write_def_0(ss,icdf,cclist,nids,iout,iwarn,iertot)
  call ps_update_file_write_def_1(ss,icdf,cclist,nids,iout,iwarn,iertot)
  call ps_update_file_write_def_2(ss,icdf,cclist,nids,iout,iwarn,iertot)
  call ps_update_file_write_def_3(ss,icdf,cclist,nids,iout,iwarn,iertot)
  call ps_update_file_write_def_4(ss,icdf,cclist,nids,iout,iwarn,iertot)
  call ps_update_file_write_def_5(ss,icdf,cclist,nids,iout,iwarn,iertot)
  call ps_update_file_write_def_6(ss,icdf,cclist,nids,iout,iwarn,iertot)
  call ps_update_file_write_def_7(ss,icdf,cclist,nids,iout,iwarn,iertot)
  call ps_update_file_write_def_8(ss,icdf,cclist,nids,iout,iwarn,iertot)
  call ps_update_file_write_def_9(ss,icdf,cclist,nids,iout,iwarn,iertot)

  IF(iertot.GT.0) THEN
     WRITE(iout,*) " ?ps_update_file_write: error defining NetCDF variables."
     ierr = 9999
     status = nf90_close(icdf)
     RETURN
  ELSE
     ierr = 0
  ENDIF

  !------------------------------------
  ! transfer the data to NetCDF

  status = nf90_enddef(icdf)  ! exit definition mode

  IF(status.NE.NF90_NOERR) THEN
     WRITE(iout,*) " ?ps_update_file_write: nf90_enddef error"
     CALL ncerr(status)
     ierr = 9999
     status = nf90_close(icdf)
     RETURN
  ENDIF

  iertot = 0

  status = nf90_put_var(icdf,vvarid,ps_version_id)
  IF(status.NE.NF90_NOERR) THEN
     WRITE(iout,*) " ?ps_update_file_write: error storing ps_version_id"
     CALL ncerr(status)
     ierr = 9999
     status = nf90_close(icdf)
     RETURN
  ENDIF

  ival = 1
  status = nf90_put_var(icdf,pvarid,ival)
  IF(status.NE.NF90_NOERR) THEN
     WRITE(iout,*) " ?ps_update_file_write: error storing ps_partial_update marker"
     CALL ncerr(status)
     ierr = 9999
     status = nf90_close(icdf)
     RETURN
  ENDIF
  call ps_update_file_write_0(ss,icdf,cclist,iucount,iout,iwarn,iertot)
  call ps_update_file_write_1(ss,icdf,cclist,iucount,iout,iwarn,iertot)
  call ps_update_file_write_2(ss,icdf,cclist,iucount,iout,iwarn,iertot)
  call ps_update_file_write_3(ss,icdf,cclist,iucount,iout,iwarn,iertot)
  call ps_update_file_write_4(ss,icdf,cclist,iucount,iout,iwarn,iertot)
  call ps_update_file_write_5(ss,icdf,cclist,iucount,iout,iwarn,iertot)
  call ps_update_file_write_6(ss,icdf,cclist,iucount,iout,iwarn,iertot)
  call ps_update_file_write_7(ss,icdf,cclist,iucount,iout,iwarn,iertot)
  call ps_update_file_write_8(ss,icdf,cclist,iucount,iout,iwarn,iertot)
  call ps_update_file_write_9(ss,icdf,cclist,iucount,iout,iwarn,iertot)


  status = nf90_close(icdf)

  IF(iertot.GT.0) THEN
     WRITE(iout,*) " ?ps_update_file_write: error storing NetCDF variables."
     ierr = 9999
     RETURN
  ELSE
     ierr = 0
     WRITE(iout,*) " *ps_update_file_write: normal exit, ",iucount, &
          " update elements written."
  ENDIF

  CONTAINS


     SUBROUTINE define_dim(dimid,dname,idval)
        INTEGER, intent(out) :: dimid
        CHARACTER*(*), INTENT(in) :: dname
        INTEGER, intent(in) :: idval

        status = nf90_def_dim(icdf,dname,idval,dimid)
        IF(status.NE.NF90_NOERR) THEN
           WRITE(iout,*) ' ?ps_update_file_write: error defining dimension "'// &
                 trim(dname)//'".'
           IERR=9999
        ENDIF
     END SUBROUTINE define_dim



     SUBROUTINE ncerr(status)
        INTEGER, INTENT(in) :: status

        nc_errmsg = NF90_strerror(status)
        write(iout,*) '  NetCDF message: ',trim(nc_errmsg)
     END SUBROUTINE ncerr



     SUBROUTINE ccwarn(varnam,compnam)

        CHARACTER*(*), intent(in) :: varnam   ! name of variable or array
        CHARACTER*(*), intent(in) :: compnam  ! name of component

        if(iwarn.eq.0) then
           write(iout,*) ' '
           write(iout,*) ' %ps_update_file_write: modified state elements'
           write(iout,*) '  exist which were not written due to the "cclist"'
           write(iout,*) '  input variable which screens out elements from'
           write(iout,*) '  selected components: cclist = ',cclist,';'
           write(iout,*) '  element values of 1 indicate components that are'
           write(iout,*) '  enabled for write.'
           write(iout,*) ' '
        endif

        iwarn = iwarn + 1

        write(iout,*) ' %ps_update_file_write: modified: ss%'// &
             trim(varnam)//' ('//trim(compnam)//' component) NOT WRITTEN.'

     END SUBROUTINE ccwarn

END SUBROUTINE ps_update_file_write

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_n5_dummy
     return
  end subroutine ccps_getset_n5_dummy

subroutine psget_nbi_src_name(iobj, n1, data, ierr)
    !! number & name of neutral beams
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    CHARACTER*(*), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_nbi_src_name', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % nbi_src_name
end subroutine psget_nbi_src_name


subroutine psset_nbi_src_name(iobj, n1, data, ierr)
    !! number & name of neutral beams
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    CHARACTER*(*), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_nbi_src_name', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % nbi_src_name = data(1:n1)
end subroutine psset_nbi_src_name


subroutine psgetsz_nbi_src_name(iobj, size, ierr)
    !! number & name of neutral beams
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: size    ! size of character string
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psgetsz_nbi_src_name', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! note that the following will return the character length size regardless of
    ! the number of array elements (if nbi_src_name is an array)
    size = len(ss % nbi_src_name)
end subroutine psgetsz_nbi_src_name


subroutine psgetrnk_nbi_src_name(iobj, ndims, ierr)
    !! number & name of neutral beams
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_nbi_src_name


subroutine psgetdim_nbi_src_name(iobj, ndims, dims, ierr)
    !! number & name of neutral beams
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_nbi_src_name', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % nbi_src_name ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % nbi_src_name)
    endif
end subroutine psgetdim_nbi_src_name


subroutine psget_nbap2_shape(iobj, n1, data, ierr)
    !! keyword for optional 2nd aperture', "For beam j,
    !! nbap2_shape= blank or 'None': no 2nd aperture", 'Other possible
    !! values:  "Rectangle"; "Circle"., The beam centerline is assumed
    !! to pass through the center of the, aperture.
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    CHARACTER*(*), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_nbap2_shape', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % nbap2_shape
end subroutine psget_nbap2_shape


subroutine psset_nbap2_shape(iobj, n1, data, ierr)
    !! keyword for optional 2nd aperture', "For beam j,
    !! nbap2_shape= blank or 'None': no 2nd aperture", 'Other possible
    !! values:  "Rectangle"; "Circle"., The beam centerline is assumed
    !! to pass through the center of the, aperture.
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    CHARACTER*(*), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_nbap2_shape', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % nbap2_shape = data(1:n1)
end subroutine psset_nbap2_shape


subroutine psgetsz_nbap2_shape(iobj, size, ierr)
    !! keyword for optional 2nd aperture', "For beam j,
    !! nbap2_shape= blank or 'None': no 2nd aperture", 'Other possible
    !! values:  "Rectangle"; "Circle"., The beam centerline is assumed
    !! to pass through the center of the, aperture.
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: size    ! size of character string
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psgetsz_nbap2_shape', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! note that the following will return the character length size regardless of
    ! the number of array elements (if nbap2_shape is an array)
    size = len(ss % nbap2_shape)
end subroutine psgetsz_nbap2_shape


subroutine psgetrnk_nbap2_shape(iobj, ndims, ierr)
    !! keyword for optional 2nd aperture', "For beam j,
    !! nbap2_shape= blank or 'None': no 2nd aperture", 'Other possible
    !! values:  "Rectangle"; "Circle"., The beam centerline is assumed
    !! to pass through the center of the, aperture.
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_nbap2_shape


subroutine psgetdim_nbap2_shape(iobj, ndims, dims, ierr)
    !! keyword for optional 2nd aperture', "For beam j,
    !! nbap2_shape= blank or 'None': no 2nd aperture", 'Other possible
    !! values:  "Rectangle"; "Circle"., The beam centerline is assumed
    !! to pass through the center of the, aperture.
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_nbap2_shape', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % nbap2_shape ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % nbap2_shape)
    endif
end subroutine psgetdim_nbap2_shape


subroutine psget_n_t_einj_standard(iobj, data, ierr)
    !! no. pts in T beam energy fractions table
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_n_t_einj_standard', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % n_T_einj_standard
end subroutine psget_n_t_einj_standard


subroutine psset_n_t_einj_standard(iobj, data, ierr)
    !! no. pts in T beam energy fractions table
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_n_t_einj_standard', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % n_T_einj_standard = data
end subroutine psset_n_t_einj_standard


subroutine psget_nicrf_src(iobj, data, ierr)
    !! item list dimension of icrf_src_name (icrf_source)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_nicrf_src', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % nicrf_src
end subroutine psget_nicrf_src


subroutine psset_nicrf_src(iobj, data, ierr)
    !! item list dimension of icrf_src_name (icrf_source)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_nicrf_src', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % nicrf_src = data
end subroutine psset_nicrf_src


subroutine psget_nbion(iobj, n1, data, ierr)
    !! name of species injected by each beam., Possible values are:
    !! "H", "D", "T", "He3", and "He4" at present., DMC Apr 2010:
    !! added: "Ne", "Ar", "Kr", "Xe", Each beam can inject one
    !! species.  Multiple beams (or usually, all beams) can inject the
    !! same species., the SNBI species list will be constructed from
    !! nbion elements;, in many experiments this will consist only of
    !! the single element "D".
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    CHARACTER*(*), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_nbion', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % nbion
end subroutine psget_nbion


subroutine psset_nbion(iobj, n1, data, ierr)
    !! name of species injected by each beam., Possible values are:
    !! "H", "D", "T", "He3", and "He4" at present., DMC Apr 2010:
    !! added: "Ne", "Ar", "Kr", "Xe", Each beam can inject one
    !! species.  Multiple beams (or usually, all beams) can inject the
    !! same species., the SNBI species list will be constructed from
    !! nbion elements;, in many experiments this will consist only of
    !! the single element "D".
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    CHARACTER*(*), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_nbion', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % nbion = data(1:n1)
end subroutine psset_nbion


subroutine psgetsz_nbion(iobj, size, ierr)
    !! name of species injected by each beam., Possible values are:
    !! "H", "D", "T", "He3", and "He4" at present., DMC Apr 2010:
    !! added: "Ne", "Ar", "Kr", "Xe", Each beam can inject one
    !! species.  Multiple beams (or usually, all beams) can inject the
    !! same species., the SNBI species list will be constructed from
    !! nbion elements;, in many experiments this will consist only of
    !! the single element "D".
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: size    ! size of character string
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psgetsz_nbion', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! note that the following will return the character length size regardless of
    ! the number of array elements (if nbion is an array)
    size = len(ss % nbion)
end subroutine psgetsz_nbion


subroutine psgetrnk_nbion(iobj, ndims, ierr)
    !! name of species injected by each beam., Possible values are:
    !! "H", "D", "T", "He3", and "He4" at present., DMC Apr 2010:
    !! added: "Ne", "Ar", "Kr", "Xe", Each beam can inject one
    !! species.  Multiple beams (or usually, all beams) can inject the
    !! same species., the SNBI species list will be constructed from
    !! nbion elements;, in many experiments this will consist only of
    !! the single element "D".
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_nbion


subroutine psgetdim_nbion(iobj, ndims, dims, ierr)
    !! name of species injected by each beam., Possible values are:
    !! "H", "D", "T", "He3", and "He4" at present., DMC Apr 2010:
    !! added: "Ne", "Ar", "Kr", "Xe", Each beam can inject one
    !! species.  Multiple beams (or usually, all beams) can inject the
    !! same species., the SNBI species list will be constructed from
    !! nbion elements;, in many experiments this will consist only of
    !! the single element "D".
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_nbion', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % nbion ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % nbion)
    endif
end subroutine psgetdim_nbion


subroutine psget_ngsc0(iobj, data, ierr)
    !! item list dimension of gs_name (gas_source)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_ngsc0', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % ngsc0
end subroutine psget_ngsc0


subroutine psset_ngsc0(iobj, data, ierr)
    !! item list dimension of gs_name (gas_source)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_ngsc0', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % ngsc0 = data
end subroutine psset_ngsc0


subroutine psget_nspec_beam(iobj, data, ierr)
    !! species list dimension of SNBI (beam_ion)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_nspec_beam', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % nspec_beam
end subroutine psget_nspec_beam


subroutine psset_nspec_beam(iobj, data, ierr)
    !! species list dimension of SNBI (beam_ion)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_nspec_beam', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % nspec_beam = data
end subroutine psset_nspec_beam


subroutine psget_nspec_all(iobj, data, ierr)
    !! species list dimension of ALL (specie)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_nspec_all', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % nspec_all
end subroutine psget_nspec_all


subroutine psset_nspec_all(iobj, data, ierr)
    !! species list dimension of ALL (specie)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_nspec_all', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % nspec_all = data
end subroutine psset_nspec_all


subroutine psget_nrho(iobj, data, ierr)
    !! grid dimension of rho (RHO coordinate)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_nrho', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % nrho
end subroutine psget_nrho


subroutine psset_nrho(iobj, data, ierr)
    !! grid dimension of rho (RHO coordinate)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_nrho', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % nrho = data
end subroutine psset_nrho


subroutine psget_nrho_nbi(iobj, data, ierr)
    !! grid dimension of rho_nbi (RHO coordinate)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_nrho_nbi', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % nrho_nbi
end subroutine psget_nrho_nbi


subroutine psset_nrho_nbi(iobj, data, ierr)
    !! grid dimension of rho_nbi (RHO coordinate)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_nrho_nbi', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % nrho_nbi = data
end subroutine psset_nrho_nbi


subroutine psget_nrho_lhrf(iobj, data, ierr)
    !! grid dimension of rho_lhrf (RHO coordinate)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_nrho_lhrf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % nrho_lhrf
end subroutine psget_nrho_lhrf


subroutine psset_nrho_lhrf(iobj, data, ierr)
    !! grid dimension of rho_lhrf (RHO coordinate)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_nrho_lhrf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % nrho_lhrf = data
end subroutine psset_nrho_lhrf


subroutine psget_nrho_gas(iobj, data, ierr)
    !! grid dimension of rho_gas (RHO coordinate)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_nrho_gas', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % nrho_gas
end subroutine psget_nrho_gas


subroutine psset_nrho_gas(iobj, data, ierr)
    !! grid dimension of rho_gas (RHO coordinate)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_nrho_gas', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % nrho_gas = data
end subroutine psset_nrho_gas


subroutine psget_neflux_ky_tglf(iobj, n1, n2, data, ierr)
    !! electron density flux spectrum
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_neflux_ky_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % neflux_ky_tglf
end subroutine psget_neflux_ky_tglf


subroutine psset_neflux_ky_tglf(iobj, n1, n2, data, ierr)
    !! electron density flux spectrum
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_neflux_ky_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % neflux_ky_tglf = data(1:n1, 1: n2)
end subroutine psset_neflux_ky_tglf


subroutine psgetrnk_neflux_ky_tglf(iobj, ndims, ierr)
    !! electron density flux spectrum
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_neflux_ky_tglf


subroutine psgetdim_neflux_ky_tglf(iobj, ndims, dims, ierr)
    !! electron density flux spectrum
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_neflux_ky_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % neflux_ky_tglf ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % neflux_ky_tglf)
    endif
end subroutine psgetdim_neflux_ky_tglf

subroutine ps_xload_check(ss,iout,icheck,ierr)

  ! load xplasma from state structure; only load items that changed
  ! or are not found in the xplasma object (small items may be loaded
  ! regardless).  Check for rebuild of equilibrium in xplasma.

  use plasma_state_definition_mod
  use plasma_state_xpobj  ! XPLASMA2 state object definitions
  implicit NONE

  TYPE (plasma_state) :: ss     ! state instance from which to load
  INTEGER, intent(in) :: iout   ! I/O channel for messages

  INTEGER, intent(in) :: icheck ! =0 to SKIP equilibrium check
                                ! =1 to perform all checks
                                ! =2 to perform core equilibrium check but
                                !    skip free boundary "RZ" check.

  INTEGER, intent(out) :: ierr  ! completion status (0=OK)

  !-----------------------------
  INTEGER :: iwarn,iertmp,id_lim,kccw_Jphi,kccw_Bphi,icount,id_hash
  INTEGER :: id_rho,id_th,id_Rgrid,id_Zgrid,id_R,id_Z,id_prof,id_psi,id
  INTEGER :: id_g,id_Bphi
  INTEGER :: ict,ic2,idiff,im
  LOGICAL :: plasma_state_hash_match, ichanged
  LOGICAL :: enough_eq, enough_eqRZ, enough_RZsurf
  LOGICAL :: ichange_eq, ichange_eqRZ, ichange_RZsurf, ichange_flag
  LOGICAL :: mdescr_change, config_change, simcon_change,inew
  CHARACTER*32 :: rlabel
  REAL*8, dimension(:,:), allocatable :: Rtest,Ztest
  REAL*8, dimension(:,:,:), allocatable :: Rderivs,Zderivs
  REAL*8, parameter :: ZERO = 0.0_rspec

  real*8, parameter ::  zvar = 0.00010_rspec  ! see also: ps_update_mhdeq.f90...

  integer, dimension(:), pointer :: ia_ptr
  real*8, dimension(:), pointer :: r8a_ptr

  integer :: ii,jj
  logical :: izero  ! flag Psi(R,Z)=0 everywhere

  integer :: loc_cclist(ps_ccount)
  type (interp_object) :: xobj
  type (xplasma), pointer :: s
  !-----------------------------

  external eqm_bpsi, eqm_brz_adhoc

  !=====================================================================
  !  check that state has associated xplasma object; set pointer.

  if(ps_debug.ge.2) then
     write(iout,*) ' Entering: ps_xload_check; ss%global_label = "'// &
          trim(ss%global_label)//'".'
  endif

  ichange_flag = .FALSE.

  do
     call ps_tagchk('ps_xload_check',ss%itag,iout,ierr)
     if(ierr.ne.0) exit

     xobj = transfer(ss%iobj,xobj)
     s => xobj%s_xpobj

     call xplasma_ajac_maxvar_set(s,zvar,ierr)
     if(ierr.ne.0) exit

     ! probe xplasma contents

     call xplasma_profId(s,'G',id_g)
     call xplasma_profId(s,'Bphi',id_Bphi)

     !---------------------------------------
     !  step 0.  Make sure all state elements are allocated.
     !           Update active_dims count.

     if(ps_debug.ge.2) write(iout,*) ' call plasma_state_empty_alloc()...'
     call plasma_state_empty_alloc(ss,ierr); call ckerr(ierr)
     if(ierr.ne.0) exit

     !---------------------------------------
     !  step 1.  Update state hash codes; this gives summary information
     !           on what has changed since the state was read or last copied
     !           or stored.

     if(ps_debug.ge.2) write(iout,*) ' call plasma_state_hash_code()...'
     call plasma_state_hash_code(ss,ps_cc_all,ierr); call ckerr(ierr)
     if(ierr.ne.0) exit

     if((ss%nrho_eq.eq.0).or.(ss%nth_eq.eq.0)) call ps_reset_mhdeq_hash(ss)

     mdescr_change = &
          .not.plasma_state_hash_match(ss,ps_shash_machine_description,iertmp)

     config_change = &
          .not.plasma_state_hash_match(ss,ps_shash_shot_configuration,iertmp)

     simcon_change = &
          .not.plasma_state_hash_match(ss,ps_shash_simulation_init,iertmp)

     if(mdescr_change) then
        if(ps_debug.ge.2) write(iout,*) '...changed machine description detected.'
     endif

     if(config_change) then
        if(ps_debug.ge.2) write(iout,*) '...changed shot configuration detected.'
     endif

     if(simcon_change) then
        if(ps_debug.ge.2) write(iout,*) '...changed simulation initialization data detected.'
     endif

     !---------------------------------------
     !  step 2.  Fetch or create xplasma hash array

     call xpobj_blkbx(xobj, &
          xpobj_hash_name,ps_hash_total,r8hash_size,inew,id_hash, &
          ia_ptr,r8a_ptr,iout,ierr)

     if(inew) then
        ia_ptr = ps_unInit
        r8a_ptr = 1.0_rspec
     endif

     if(icheck.eq.0) exit

     !---------------------------------------
     !  step 3.  Update equilibrium related quantities as needed.
     !
     !  First determine if there is sufficient data to build an equilibrium

     if(ps_debug.ge.2) write(iout,*) ' check equilibrium data...'

     enough_eqRZ = .FALSE.    ! core and Psi(R,Z) and limiter
     enough_eq = .FALSE.      ! core equilibrium only
     enough_RZsurf = .FALSE.  ! {(R,Z) vs. (rho,theta)} surfaces only

     do
        ! flux coordinate grids (test if allocated)
        rlabel='(rho,theta) grid'
        if(.not.allocated(ss%rho_eq)) exit
        if(.not.allocated(ss%th_eq)) exit

        ! flux surfaces
        rlabel='R_geo profile'
        if(ss%new_hash_codes(ps_phash_R_geo).lt.0) exit
        rlabel='Z_geo profile'
        if(ss%new_hash_codes(ps_phash_Z_geo).lt.0) exit

        rlabel='dR_geo_drho profile'
        if(ss%new_hash_codes(ps_phash_dR_geo_drho).lt.0) exit
        rlabel='dZ_geo_drho profile'
        if(ss%new_hash_codes(ps_phash_dZ_geo_drho).lt.0) exit

        rlabel='dR_geo_dth profile'
        if(ss%new_hash_codes(ps_phash_dR_geo_dth).lt.0) exit
        rlabel='dZ_geo_dth profile'
        if(ss%new_hash_codes(ps_phash_dZ_geo_dth).lt.0) exit

        rlabel='d2R_geo_drhodth profile'
        if(ss%new_hash_codes(ps_phash_d2R_geo_drhodth).lt.0) exit
        rlabel='d2Z_geo_drhodth profile'
        if(ss%new_hash_codes(ps_phash_d2Z_geo_drhodth).lt.0) exit

        enough_RZsurf = .TRUE.  ! flux surface data exists 

        ! field and current orientation?
        rlabel='Bphi ccw orientation'
        if(ss%kccw_Bphi.eq.0) exit
        rlabel='Jphi ccw orientation'
        if(ss%kccw_Jphi.eq.0) exit

        ! profiles (test if anywhere non-zero)
        ! in 1d profiles check skip P_eq: it could be zero.

        rlabel='q_eq profile'
        if(ss%new_hash_codes(ps_phash_q_eq).lt.0) exit
        rlabel='g_eq profile'
        if(ss%new_hash_codes(ps_phash_g_eq).lt.0) exit

        rlabel='phit profile'
        if(ss%new_hash_codes(ps_phash_phit).lt.0) exit
        rlabel='psipol profile'
        if(ss%new_hash_codes(ps_phash_psipol).lt.0) exit

        ! OK
        enough_eq = .TRUE.

        ! (R,Z) grids (test if allocated)
        rlabel='(R,Z) grids'
        if(.not.allocated(ss%R_grid)) exit
        if(.not.allocated(ss%Z_grid)) exit

        ! limiter?
        rlabel = 'limiter'
        if(ss%num_rzlim.eq.0) exit
        ! non-zero so arrays were allocated at step 0.
        if(maxval(abs(ss%rlim)).eq.0.0_rspec) exit
        if(maxval(abs(ss%zlim)).eq.0.0_rspec) exit

        enough_eqRZ = .TRUE.

        ! Psi(R,Z) and (R,Z) grids not checked yet.
        exit
     enddo

     if(enough_eq) then
        ! enough data exists to define core equilibrium at least; now see if 
        ! anything changed s.t. derived quantities actually need to be updated.

        if(ps_debug.ge.2) write(iout,*) &
             'ps_xload_check:  found sufficient data for MHD equilibrium.'

        ict = 0
        ic2 = 0

        ichange_RZsurf = .TRUE.    ! initially assume surface change

        do

           ! check flux coordinate grids
           call chk_fluxgrids
           if((id_rho.eq.0).or.(id_th.eq.0)) then
              ict = ict + 1
              exit
           endif

           call xplasma_profId(s,'R',id_R)
           call xplasma_profId(s,'Z',id_Z)
           if((ps_debug.ge.2).and.((id_R.eq.0).or.(id_Z.eq.0))) write(iout,*) &
                '...equilibrium flux surfaces new for xplasma.'

           if((id_R.eq.0).or.(id_Z.eq.0)) exit

           call chk_surfaces
           if(ierr.ne.0) exit           
           if(ichanged) exit

           ! the data is all there and it is unchanged...

           ichange_RZsurf = .FALSE.
           exit
        enddo
        if(ierr.ne.0) exit

        ichange_eq = .TRUE.       ! initially assume data changed

        if(enough_eqRZ) then
           ichange_eqRZ = .TRUE.  ! initially assume data changed
        else
           ichange_eqRZ = .FALSE. ! data is not there
        endif

        do

           if(enough_eqRZ) then

              ! check limiter
              call cklim
              if(id_lim.eq.0) then
                 if(ps_debug.ge.2) write(iout,*) &
                      '...axisymmetric limiter data new for xplasma.'
                 ict = ict + 1
              endif

              ! check (R,Z) grids

              call ckgrid(ss%R_grid,'__RGRID',id_Rgrid,0)
              if((ps_debug.ge.2).and.(id_Rgrid.eq.0)) write(iout,*) &
                   '...psi(R,Z) "R" grid new for xplasma.'

              call ckgrid(ss%Z_grid,'__ZGRID',id_Zgrid,0)
              if((ps_debug.ge.2).and.(id_Zgrid.eq.0)) write(iout,*) &
                   '...psi(R,Z) "Z" grid new for xplasma.'

              if((id_Rgrid.eq.0).or.(id_Zgrid.eq.0)) ic2 = ic2 + 1

           endif

           ! check field orientation (check against 0 already was done)

           if((abs(ss%kccw_Bphi).ne.1).or.(abs(ss%kccw_Jphi).ne.1)) then
              write(iout,*) &
                   ' ?ps_xload_check: kccw factors must be +/-1, but found:'
              write(iout,*) '  ss%kccw_Jphi = ',ss%kccw_Jphi
              write(iout,*) '  ss%kccw_Bphi = ',ss%kccw_Bphi
              ierr=9999
              exit
           endif

           call xplasma_global_info(s,ierr, &
                Bphi_ccw=kccw_Bphi, Jphi_ccw=kccw_Jphi); call xckerr(ierr)
           if(ierr.ne.0) exit
           if((kccw_Bphi.ne.ss%kccw_Bphi).or. &
                (kccw_Jphi.ne.ss%kccw_Jphi)) then
              if(ps_debug.ge.2) write(iout,*) &
                   '...field orientation data new for xplasma.'
              exit
           endif

           ! exit now if there were limiter or flux coordinate grid changes:
           ! entire set of equilibrium splines will have to be recomputed.
           if(enough_eqRZ.and.(ict.gt.0)) exit 

           ! equilibrium may be OK as is:
           ! checked for change in flux surface geometry (see prior loop)

           if(ichange_RZsurf) then
              if(ps_debug.ge.2) write(iout,*) '...change was detected in flux surface geometry...'
              exit
           endif

           call ckprof(ss%g_eq,'G',id_prof)
           if(id_prof.eq.0) then
              if(ps_debug.ge.2) write(iout,*) '...G profile change.'
              exit
           else if(id_g.eq.0) then
              if(ps_debug.ge.2) write(iout,*) '...xplasma G profile restore needed.'
              exit
           else if(id_Bphi.eq.0) then
              if(ps_debug.ge.2) write(iout,*) '...xplasma Bphi profile restore needed.'
              exit
           endif

           call ckprof(ss%q_eq,'q',id_prof)
           if(id_prof.eq.0) then
              if(ps_debug.ge.2) write(iout,*) '...q profile change.'
              exit
           endif

           call ckprof(ss%P_eq,'P',id_prof)
           if(id_prof.eq.0) then
              if(ps_debug.ge.2) write(iout,*) '...P profile change.'
              exit
           endif

           call ckprof(ss%phit,'PHITOR',id_prof)
           if(id_prof.eq.0) then
              if(ps_debug.ge.2) write(iout,*) &
                   '...Toroidal flux profile change.'
              exit
           endif

           call ckprof(ss%psipol,'PSI',id_prof)
           if(id_prof.eq.0) then
              if(ps_debug.ge.2) write(iout,*) &
                   '...Poloidal flux profile change.'
              exit
           endif

           ! OK: limiter, orientation, (rho,theta) grids, and flux surfaces
           ! and core profiles are unchanged...

           ichange_eq = .FALSE.
           
           ! exit now if (R,Z) grids changed or are missing
           if(enough_eqRZ.and.(ic2.gt.0)) exit
           if(.not.enough_eqRZ) exit

           ! check Psi(R,Z)
           call xplasma_profId(s,'PSI_RZ',id_prof)
           if(id_prof.eq.0) then
              idiff=1
              ierr=0
           else
              call xplasma_diff_prof(s,id_prof,ss%psiRZ,idiff,ierr, &
                   splineType=1)
           endif
           call xckerr(ierr)
           if(ierr.ne.0) exit

           ichanged = (idiff.ne.0)
           if(ichanged) then
              ichange_eq = .TRUE.
              if(ps_debug.ge.2) write(iout,*) '...detected psi(R,Z) change.'
              exit
           endif
                
           ichange_eqRZ = .FALSE.  ! data is present but unchanged

           exit
        enddo
        if(ierr.ne.0) exit

        if(ichange_eq.or.ichange_eqRZ) then
           ichange_flag=.TRUE.
           call xplasma_author_set(s,'EQ',ierr); call xckerr(ierr)
           if(ierr.ne.0) exit
        endif

        if(ichange_eq.or.ichange_eqRZ) then

           ! rebuild xplasma equilibrium representation

           if(ichange_eqRZ) then
              if(id_lim.eq.0) then
                 !  Limiter...
                 if(ps_debug.ge.2) write(iout,*) '...loading limiter data...'
                 call xplasma_mklim_contour(s, &
                      ss%rlim(1:ss%num_rzlim),ss%zlim(1:ss%num_rzlim),iwarn, &
                      ierr)
                 call xckerr(ierr)
                 if(ierr.ne.0) exit
              endif

              !  Save Psi0

              call xplasma_save_Psi0(s,ss%Psi_to_machine_axis,ierr)
              if(ierr.ne.0) exit

           endif

           if(ichange_RZsurf) then
              call build_surfaces
              if(ierr.ne.0) exit
           endif

           if(ichange_eq.or.ichange_RZsurf) then
              ! 1d profiles

              call xplasma_create_1dprof(s,'PSI', &
                   id_rho,ss%psipol,id_prof,ierr, &
                   ispline=2, ibca=1, zbca=ZERO, ibcb=0, &
                   label='Poloidal Flux',units='Wb/rad')
              call xckerr(ierr)
              if(ierr.ne.0) exit

              id_psi=id_prof
              ss%id_psipol=id_prof

              call xplasma_create_1dprof(s,'PHITOR', &
                   id_rho,ss%phit,id_prof,ierr, &
                   ispline=2, ibca=1, zbca=ZERO, ibcb=0, &
                   label='Toroidal Flux',units='Wb')
              call xckerr(ierr)
              if(ierr.ne.0) exit

              ss%id_phit=id_prof

              call xplasma_create_1dprof(s,'G', &
                   id_rho,ss%g_eq,id_prof,ierr, &
                   ispline=2, ibca=1, zbca=ZERO, ibcb=0, &
                   label='R*B_phi (toroidal field functino)',units='T*m')
              call xckerr(ierr)
              if(ierr.ne.0) exit

              ss%id_g_eq=id_prof

              call xplasma_create_1dprof(s,'Q', &
                   id_rho,ss%q_eq,id_prof,ierr, &
                   ispline=2, ibca=0, ibcb=0, &
                   label='q profile',units=' ')
              call xckerr(ierr)
              if(ierr.ne.0) exit

              ss%id_q_eq=id_prof

              call xplasma_create_1dprof(s,'P', &
                   id_rho,ss%P_eq,id_prof,ierr, &
                   ispline=2, ibca=1, zbca=ZERO, ibcb=0, &
                   label='MHD equilibrium pressure',units='Pa')
              call xckerr(ierr)
              if(ierr.ne.0) exit

              call xplasma_set_pressure_id(s,id_prof,ierr)
              call xckerr(ierr)
              if(ierr.ne.0) exit

              ss%id_P_eq=id_prof
 
              !  set the field and current orientations

              call xplasma_field_ccw_set(s,ierr, &
                   bphi_ccw=ss%kccw_Bphi,jphi_ccw=ss%kccw_Jphi)
              call xckerr(ierr)
              if(ierr.ne.0) exit
 
              ! ...OK, geom. and psi and g are set, compute 
              ! B,BR,BZ vs. (rho,th); the field and current orientations 
              ! have been specified.
 
              call xplasma_eqcheck(s,.FALSE.,icount,ierr)
              call xckerr(ierr)
              if(ierr.ne.0) exit

              ! update remaining derived scalars...

              call ps_mhdeq_derived_scalars(ss,iout,ierr)
              call ckerr(ierr)
              if(ierr.ne.0) exit
           endif

           ! and derived profiles...

           if(ichange_RZsurf) then
              call ps_mhdeq_volumes(ss,iout,ierr); call ckerr(ierr)
              if(ierr.ne.0) exit
              call ps_mhdeq_fsmoms(ss,iout,ierr); call ckerr(ierr)
              if(ierr.ne.0) exit
           endif

        endif

        if(ichange_eqRZ) then
           ! if this is .TRUE. then presence of sufficient data has also
           ! been checked.

           ! (R,Z) grids

           if((id_Rgrid.eq.0).or.(id_Zgrid.eq.0)) then
              call xplasma_create_RZgrid(s,ss%R_grid,ss%Z_grid, &
                   id_Rgrid,id_Zgrid,ierr)
              call xckerr(ierr)
              if(ierr.ne.0) exit

              !  update [R,Z] extrema
              call ps_update_rzbox(ss,iout,ierr)
              call ckerr(ierr)
              if(ierr.ne.0) exit
           endif
        endif

        if(icheck.eq.2) ichange_eqRZ=.FALSE.

        if(ichange_eqRZ) then

           ! Psi(R,Z)

           izero=.TRUE.
           do jj=1,ss%nZ
              do ii=1,ss%nR
                 if(ss%psiRZ(ii,jj).ne.0.0_rspec) then
                    izero=.FALSE.
                    exit
                 endif
              enddo
              if(.not.izero) exit
           enddo

           if(.not.izero) then

              ! real Psi(R,Z) was provided; use it...

              call xplasma_create_2dprof(s,'PSI_RZ', &
                   id_Rgrid,id_Zgrid,ss%psirz,id_prof,ierr, &
                   ispline=1,assoc_id=id_psi, &
                   label='Poloidal Flux',units='Wb/rad')
              call xckerr(ierr)
              if(ierr.ne.0) exit

              ss%id_psirz=id_prof

              ! B(R,Z) computed in xplasma

              call xplasma_brz(s,eqm_bpsi,ierr)
              call xckerr(ierr)
              if(ierr.ne.0) then
                 write(iout,*) '  --> error getting B(R,Z) (eqm_bpsi).'
                 exit
              endif

           else

              ! first, generate ad hoc Psi(R,Z) using smoothed extrapolation

              call xplasma_brz(s,eqm_brz_adhoc,ierr)
              call xckerr(ierr)
              if(ierr.ne.0) exit

              ! save generated Psi(R,Z) in state object

              call xplasma_profId(s,'Psi_RZ',ss%id_psirz)
              call xplasma_eval_prof(s,ss%id_psirz,ss%psirz,ierr)
              call xckerr(ierr)
              if(ierr.ne.0) then
                 write(iout,*) '  --> error getting B(R,Z) (eqm_brz_adhoc).'
                 exit
              endif

              ! now, recompute B(R,Z) based on the Psi(R,Z) just generated.
              ! this may seem redundant, but it is necessary to get 
              ! the same B(R,Z) field as would be the case if the current
              ! state were written and read back in.

              call xplasma_brz(s,eqm_bpsi,ierr)
              call xckerr(ierr)
              if(ierr.ne.0) then
                 write(iout,*) '  --> error getting B(R,Z) (eqm_bpsi).'
                 exit
              endif

           endif

           ! and update B(R,Z) component profiles in state object...

           call ps_update_brz(ss,iout,ierr)
           call ckerr(ierr)
           if(ierr.ne.0) exit

        endif

        if(ichange_flag) then
           call xplasma_author_clear(s,'EQ',ierr); call xckerr(ierr)
           call xckerr(ierr)
           if(ierr.ne.0) exit

           ! update hash codes (equilibrium data was updated).
           loc_cclist = ps_noCheck
           loc_cclist(ps_cnum_EQ)=ps_chkProfs ! update EQ prof hashcodes only
           call plasma_state_hash_code(ss,loc_cclist,ierr); call ckerr(ierr)
           if(ierr.ne.0) exit

        else
           if(ps_debug.ge.2) then
              write(iout,*) ' no change to existing MHD equilibrium.'
           endif
        endif

     else if(enough_RZsurf) then

        ! this block reached if geometry data is present but field data
        ! is missing...

        if(ps_debug.ge.2) then
           write(iout,*) &
                ' (R,Z) flux surfaces exist but equilibrium not complete:'// &
                ' missing data: '//trim(rlabel)
        endif

        ichange_eq = .TRUE.

        ! see if there are changes s.t. xplasma requires updating...
        do
           ! check flux coordinate grids
           call chk_fluxgrids
           if((id_rho.eq.0).or.(id_th.eq.0)) exit

           ! check flux surfaces

           call xplasma_profId(s,'R',id_R)
           call xplasma_profId(s,'Z',id_Z)
           if((ps_debug.ge.2).and.((id_R.eq.0).or.(id_Z.eq.0))) write(iout,*) &
                '...equilibrium flux surfaces new for xplasma.'

           if((id_R.eq.0).or.(id_Z.eq.0)) exit

           call chk_surfaces
           if(ierr.ne.0) exit           

           if(ichanged) then
              if(ps_debug.ge.2) write(iout,*) '...detected change in flux surface geometry...'
              exit
           endif

           ichange_eq=.FALSE.
           exit
        enddo
        if(ierr.ne.0) exit

        if(ichange_eq) then
           call xplasma_author_set(s,'EQ',ierr); call xckerr(ierr)
           if(ierr.ne.0) exit

           call build_surfaces
           if(ierr.ne.0) exit

           call xplasma_author_clear(s,'EQ',ierr); call xckerr(ierr)
           if(ierr.ne.0) exit

           call ps_mhdeq_volumes(ss,iout,ierr); call ckerr(ierr)
           if(ierr.ne.0) exit

           call ps_mhdeq_fsmoms(ss,iout,ierr); call ckerr(ierr)
           if(ierr.ne.0) exit

           ! update hash codes again
           loc_cclist = ps_noCheck
           loc_cclist(ps_cnum_EQ)=ps_chkProfs ! update EQ prof hashcodes only
           call plasma_state_hash_code(ss,loc_cclist,ierr); call ckerr(ierr)
           if(ierr.ne.0) exit
        else
           if(ps_debug.ge.2) then
              write(iout,*) ' no change to existing (R,Z).'
           endif
        endif

     else
        if(ps_debug.ge.2) then
           write(iout,*) ' no MHD equilibrium: missing data: '//trim(rlabel)
        endif
     endif

     !---------------------------------------
     !  step 4.  Update non-equilibrium quantities as needed.
     !           (this call moved to plasma_state_store.f90)
     !---------------------------------------
     !  ALL DONE

     exit
  enddo


CONTAINS

  subroutine chk_fluxgrids

    call ckgrid(ss%rho_eq,'__RHO',id_rho,0)
    if((ps_debug.ge.2).and.(id_rho.eq.0)) write(iout,*) &
         '...equilibrium "rho" grid new for xplasma.'

    call ckgrid(ss%th_eq,'__CHI',id_th,1)
    if((ps_debug.ge.2).and.(id_th.eq.0)) write(iout,*) &
         '...equilibrium "th" grid new for xplasma.'

  end subroutine chk_fluxgrids

  subroutine chk_surfaces

    allocate(Rtest(ss%nth_eq,ss%nrho_eq))
    allocate(Ztest(ss%nth_eq,ss%nrho_eq))
    allocate(Rderivs(3,ss%nth_eq,ss%nrho_eq))
    allocate(Zderivs(3,ss%nth_eq,ss%nrho_eq))

    do jj=1,ss%nrho_eq
       do ii=1,ss%nth_eq
          Rtest(ii,jj) = ss%R_geo(jj,ii)
          Ztest(ii,jj) = ss%Z_geo(jj,ii)
          Rderivs(1,ii,jj) = ss%dR_geo_dth(jj,ii)
          Rderivs(2,ii,jj) = ss%dR_geo_drho(jj,ii)
          Rderivs(3,ii,jj) = ss%d2R_geo_drhodth(jj,ii)
          Zderivs(1,ii,jj) = ss%dZ_geo_dth(jj,ii)
          Zderivs(2,ii,jj) = ss%dZ_geo_drho(jj,ii)
          Zderivs(3,ii,jj) = ss%d2Z_geo_drhodth(jj,ii)
       enddo
    enddo

    ! xplasma has flux surfaces... do they need to be updated?

    call xplasma_diff_prof(s,id_R,Rtest,idiff,ierr, &
         coeffs=Rderivs); call xckerr(ierr)
    if((ierr.eq.0).and.(idiff.eq.0)) then
       call xplasma_diff_prof(s,id_Z,Ztest,idiff,ierr, &
            coeffs=Zderivs); call xckerr(ierr)
    endif

    deallocate(Rtest,Ztest,Rderivs,Zderivs)

    ichanged = (idiff.ne.0)

  end subroutine chk_surfaces

  subroutine build_surfaces

    character*3 zint

    if(id_rho.eq.0) then
       !  rho grid
       call xplasma_create_grid(s,'__RHO',xplasma_rho_coord, &
            ss%rho_eq,id_rho,ierr)
       call xckerr(ierr)
       if(ierr.ne.0) return
    endif

    if(id_th.eq.0) then
       !  th grid
       call xplasma_create_grid(s,'__CHI',xplasma_theta_coord, &
            ss%th_eq,id_th,ierr)
       call xckerr(ierr)
       if(ierr.ne.0) return
    endif

    ! the flux surface geometry -- Hermite representation
    ! although the Hermite derivatives are likely from a C2 spline

    if(ss%neqmom.gt.0) ss%nmom = ss%neqmom

    call xplasma_kmom_set(s, ss%nmom, ierr)
    call xckerr(ierr)
    if(ierr.ne.0) return

    if(ss%neqmom.eq.0) then
       ss%neqmom = ss%nmom
       call plasma_state_empty_alloc(ss,ierr); call ckerr(ierr)
       if(ierr.ne.0) return
       ! set up eqmom_num labels...
       do im=1,ss%nmom
          zint=' '
          if(im.le.9) then
             write(zint(1:1),'(I1)') im
          else if(im.le.99) then
             write(zint(1:2),'(I2)') im
          else
             write(zint(1:3),'(I3)') im
          endif
          ss%eqmom_num(im)=zint
       enddo
    endif

    allocate(Rderivs(3,ss%nrho_eq,ss%nth_eq))
    allocate(Zderivs(3,ss%nrho_eq,ss%nth_eq))

    Rderivs(1,:,:) = ss%dR_geo_drho
    Rderivs(2,:,:) = ss%dR_geo_dth
    Rderivs(3,:,:) = ss%d2R_geo_drhodth

    Zderivs(1,:,:) = ss%dZ_geo_drho
    Zderivs(2,:,:) = ss%dZ_geo_dth
    Zderivs(3,:,:) = ss%d2Z_geo_drhodth

    call xplasma_rzmag(s,id_rho,id_th,ss%R_geo,ss%Z_geo, &
         id_R,id_Z,ierr, &
         lhermite=.TRUE., Rderivs=Rderivs, Zderivs=Zderivs)
    call xckerr(ierr)

    if(ierr.eq.0) then
       ! set state IDs; mark profiles as up-to-date
       ss%id_R_geo = id_R
       ss%id_Z_geo = id_Z
    endif

    deallocate(Rderivs,Zderivs)

  end subroutine build_surfaces

  subroutine xckerr(ierr)
     integer :: ierr

     if(ierr.ne.0) then
        write(iout,*) ' ?ps_xload_check: xplasma error detected.'
        call xplasma_error(s,ierr,iout)
        ierr = 9999
     endif
   end subroutine xckerr

  subroutine ckerr(ierr)
     integer :: ierr

     if(ierr.ne.0) then
        write(iout,*) ' ?ps_xload_check: error detected.'
        ierr = 9999
     endif
  end subroutine ckerr

  subroutine cklim

    !-------------
    !  check if limiter exists; and if so if it has changed.

    integer :: itype,isizo,i,iflag
    real*8, dimension(:), allocatable :: rlimo,zlimo
    !-------------

    iflag = 0

    call xplasma_find_item(s,'__LIMITER',id_lim,iertmp,nf_noerr=.TRUE.)
    if(id_lim.eq.0) return

    call xplasma_lim_info(s,iertmp,itype=itype)
    if(itype.ne.100) then
       id_lim=0
       return
    endif

    ! there is a contour limiter

    call xplasma_lim_info(s,iertmp, npts=isizo)
    if(isizo.ne.ss%num_rzlim) then
       iflag = 1   ! size mismatch
    endif

    if(iflag.eq.0) then
       allocate(rlimo(isizo),zlimo(isizo))
       call xplasma_lim_info(s,iertmp, rpts=rlimo, zpts=zlimo)

       do i=1,isizo
          if((rlimo(i).ne.ss%Rlim(i)).or.(zlimo(i).ne.ss%Zlim(i))) then
             iflag = 1   ! value mismatch
             exit
          endif
       enddo

       deallocate(rlimo,zlimo)
    endif

    if(iflag.eq.1) then
       id_lim = 0  !... limiter changed; replace it...
    endif

  end subroutine cklim

  subroutine ckgrid(zdata,zname,id,iper)

    real*8, dimension(:), intent(in) :: zdata
    character*(*), intent(in) :: zname
    integer, intent(out) :: id
    integer, intent(in) :: iper   ! =1 for periodic grid coordinate

    !-----------
    !  check if grid is already defined & identical to new grid
 
    integer :: i,isizo
    real*8 :: zgrido(size(zdata)),ztol

    real*8, parameter :: loctol = 1.0d-10
    real*8, dimension(:,:), allocatable :: xpkg
    real*8 :: zdum
    !-----------

    call xplasma_find_item(s,zname,id,iertmp,nf_noerr=.TRUE.)
    if(id.eq.0) return

    call xplasma_grid_size(s,id,isizo,iertmp)
    if(iertmp.ne.0) then
       id=0
       return
    endif

    if(isizo.ne.size(zdata)) then
       id=0
       return
    endif

    call xplasma_grid(s,id,zgrido,iertmp)
    if(iertmp.ne.0) then
       id=0
       return
    endif

    ztol=loctol*max(abs(zgrido(1)),abs(zgrido(isizo)))

    ! compare grid this way, to match grid storage logic in xplasma
    ! (genxpkg, as called, makes nearly-evenly-spaced grids exactly
    !  evenly spaced)

    zdum=0.0
    allocate(xpkg(isizo,4))
    call genxpkg(isizo,zdata,xpkg,iper,0,0,zdum,3,iertmp)
    if(iertmp.ne.0) then
       id=0
       deallocate(xpkg)
       return
    endif

    do i=1,isizo
       if(abs(zgrido(i)-xpkg(i,1)).gt.ztol) then
          id=0  ! value changed...
          exit
       endif
    enddo

  end subroutine ckgrid

  subroutine ckprof(zdata,zname,id)

    ! check for match of 1d spline profile data

    real*8, dimension(:), intent(in) :: zdata
    character*(*), intent(in) :: zname
    integer, intent(out) :: id

    !------------------
    integer :: idiff
    !------------------

    call xplasma_profId(s,zname,id)
    if(id.eq.0) return

    call xplasma_diff_prof(s,id,zdata,idiff,ierr, splineType=2)
    call xckerr(ierr)

    if(idiff.ne.0) id=0
    
  end subroutine ckprof

end subroutine ps_xload_check
     

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


SUBROUTINE plasma_state_free(ss,ierr)

  ! deallocate state object
  !   deallocate anything that was previously allocated.

  USE plasma_state_definition_mod
  IMPLICIT NONE

  TYPE (plasma_state) :: ss    ! state object whose elements are deallocated
  INTEGER, INTENT(OUT) :: ierr  ! completion code (0=OK)

  ! errors -- expected array dimensions undefined
  !           arrays already allocated

  !-------------------
  INTEGER :: iout,isize
  !-------------------

  iout = SWIM_err_out_file

  ierr = 0

  IF(ALLOCATED(ss%id_zonwt)) DEALLOCATE(ss%id_zonwt)


  IF(ALLOCATED(ss%alla_index)) DEALLOCATE(ss%alla_index)

  IF(ALLOCATED(ss%ALLA_name)) DEALLOCATE(ss%ALLA_name)

  IF(ALLOCATED(ss%ALLA_type)) DEALLOCATE(ss%ALLA_type)

  IF(ALLOCATED(ss%all_index)) DEALLOCATE(ss%all_index)

  IF(ALLOCATED(ss%ALL_name)) DEALLOCATE(ss%ALL_name)

  IF(ALLOCATED(ss%ALL_type)) DEALLOCATE(ss%ALL_type)

  IF(ALLOCATED(ss%amaxlh)) DEALLOCATE(ss%amaxlh)

  IF(ALLOCATED(ss%aminlh)) DEALLOCATE(ss%aminlh)

  IF(ALLOCATED(ss%Ang_Href_coil)) DEALLOCATE(ss%Ang_Href_coil)

  IF(ALLOCATED(ss%Ang_Vref_coil)) DEALLOCATE(ss%Ang_Vref_coil)

  IF(ALLOCATED(ss%anom_evar)) DEALLOCATE(ss%anom_evar)

  IF(ALLOCATED(ss%ant_model)) DEALLOCATE(ss%ant_model)

  IF(ALLOCATED(ss%ap2_halfheight)) DEALLOCATE(ss%ap2_halfheight)

  IF(ALLOCATED(ss%ap2_halfwidth)) DEALLOCATE(ss%ap2_halfwidth)

  IF(ALLOCATED(ss%ap2_horiz_offset)) DEALLOCATE(ss%ap2_horiz_offset)

  IF(ALLOCATED(ss%ap2_vert_offset)) DEALLOCATE(ss%ap2_vert_offset)

  IF(ALLOCATED(ss%apolmaxlh)) DEALLOCATE(ss%apolmaxlh)

  IF(ALLOCATED(ss%apolminlh)) DEALLOCATE(ss%apolminlh)

  IF(ALLOCATED(ss%ap_halfheight)) DEALLOCATE(ss%ap_halfheight)

  IF(ALLOCATED(ss%ap_halfwidth)) DEALLOCATE(ss%ap_halfwidth)

  IF(ALLOCATED(ss%ap_horiz_offset)) DEALLOCATE(ss%ap_horiz_offset)

  IF(ALLOCATED(ss%ap_vert_offset)) DEALLOCATE(ss%ap_vert_offset)

  IF(ALLOCATED(ss%area)) DEALLOCATE(ss%area)

  IF(ALLOCATED(ss%atormaxlh)) DEALLOCATE(ss%atormaxlh)

  IF(ALLOCATED(ss%atorminlh)) DEALLOCATE(ss%atorminlh)

  IF(ALLOCATED(ss%Balloon_code)) DEALLOCATE(ss%Balloon_code)

  IF(ALLOCATED(ss%Balloon_mapper)) DEALLOCATE(ss%Balloon_mapper)

  IF(ALLOCATED(ss%Balloon_stable)) DEALLOCATE(ss%Balloon_stable)

  IF(ALLOCATED(ss%Balloon_status)) DEALLOCATE(ss%Balloon_status)

  IF(ALLOCATED(ss%balstab)) DEALLOCATE(ss%balstab)

  IF(ALLOCATED(ss%beam_type)) DEALLOCATE(ss%beam_type)

  IF(ALLOCATED(ss%id_bidiff_bpass_co)) DEALLOCATE(ss%id_bidiff_bpass_co)
  IF(ALLOCATED(ss%bidiff_bpass_co)) DEALLOCATE(ss%bidiff_bpass_co)

  IF(ALLOCATED(ss%id_bidiff_bpass_ctr)) DEALLOCATE(ss%id_bidiff_bpass_ctr)
  IF(ALLOCATED(ss%bidiff_bpass_ctr)) DEALLOCATE(ss%bidiff_bpass_ctr)

  IF(ALLOCATED(ss%id_bidiff_btrap)) DEALLOCATE(ss%id_bidiff_btrap)
  IF(ALLOCATED(ss%bidiff_btrap)) DEALLOCATE(ss%bidiff_btrap)

  IF(ALLOCATED(ss%id_bidiff_dpass_co)) DEALLOCATE(ss%id_bidiff_dpass_co)
  IF(ALLOCATED(ss%bidiff_dpass_co)) DEALLOCATE(ss%bidiff_dpass_co)

  IF(ALLOCATED(ss%id_bidiff_dpass_ctr)) DEALLOCATE(ss%id_bidiff_dpass_ctr)
  IF(ALLOCATED(ss%bidiff_dpass_ctr)) DEALLOCATE(ss%bidiff_dpass_ctr)

  IF(ALLOCATED(ss%id_bidiff_dtrap)) DEALLOCATE(ss%id_bidiff_dtrap)
  IF(ALLOCATED(ss%bidiff_dtrap)) DEALLOCATE(ss%bidiff_dtrap)

  IF(ALLOCATED(ss%BphiRZ)) DEALLOCATE(ss%BphiRZ)

  IF(ALLOCATED(ss%BRRZ)) DEALLOCATE(ss%BRRZ)

  IF(ALLOCATED(ss%BZRZ)) DEALLOCATE(ss%BZRZ)

  IF(ALLOCATED(ss%b_halfHeight)) DEALLOCATE(ss%b_halfHeight)

  IF(ALLOCATED(ss%b_halfwidth)) DEALLOCATE(ss%b_halfwidth)

  IF(ALLOCATED(ss%b_Hdivergence)) DEALLOCATE(ss%b_Hdivergence)

  IF(ALLOCATED(ss%b_Hfocal_length)) DEALLOCATE(ss%b_Hfocal_length)

  IF(ALLOCATED(ss%B_surfMax)) DEALLOCATE(ss%B_surfMax)

  IF(ALLOCATED(ss%B_surfMin)) DEALLOCATE(ss%B_surfMin)

  IF(ALLOCATED(ss%b_Vdivergence)) DEALLOCATE(ss%b_Vdivergence)

  IF(ALLOCATED(ss%b_Vfocal_length)) DEALLOCATE(ss%b_Vfocal_length)

  IF(ALLOCATED(ss%id_cdicrf)) DEALLOCATE(ss%id_cdicrf)
  IF(ALLOCATED(ss%cdicrf)) DEALLOCATE(ss%cdicrf)

  IF(ALLOCATED(ss%id_cdicrf_nphi)) DEALLOCATE(ss%id_cdicrf_nphi)
  IF(ALLOCATED(ss%cdicrf_nphi)) DEALLOCATE(ss%cdicrf_nphi)

  IF(ALLOCATED(ss%chie_anom)) DEALLOCATE(ss%chie_anom)

  IF(ALLOCATED(ss%chie_drbm)) DEALLOCATE(ss%chie_drbm)

  IF(ALLOCATED(ss%chie_etg)) DEALLOCATE(ss%chie_etg)

  IF(ALLOCATED(ss%chie_glf)) DEALLOCATE(ss%chie_glf)

  IF(ALLOCATED(ss%chie_gtcneo)) DEALLOCATE(ss%chie_gtcneo)

  IF(ALLOCATED(ss%chie_mmm71)) DEALLOCATE(ss%chie_mmm71)

  IF(ALLOCATED(ss%chie_mtm)) DEALLOCATE(ss%chie_mtm)

  IF(ALLOCATED(ss%chie_nclass)) DEALLOCATE(ss%chie_nclass)

  IF(ALLOCATED(ss%chie_neo)) DEALLOCATE(ss%chie_neo)

  IF(ALLOCATED(ss%chie_ntm)) DEALLOCATE(ss%chie_ntm)

  IF(ALLOCATED(ss%chie_paleo)) DEALLOCATE(ss%chie_paleo)

  IF(ALLOCATED(ss%chie_tglf)) DEALLOCATE(ss%chie_tglf)

  IF(ALLOCATED(ss%chie_trans)) DEALLOCATE(ss%chie_trans)

  IF(ALLOCATED(ss%id_chie_transcat)) DEALLOCATE(ss%id_chie_transcat)
  IF(ALLOCATED(ss%chie_transcat)) DEALLOCATE(ss%chie_transcat)

  IF(ALLOCATED(ss%chie_w19)) DEALLOCATE(ss%chie_w19)

  IF(ALLOCATED(ss%chii_anom)) DEALLOCATE(ss%chii_anom)

  IF(ALLOCATED(ss%chii_drbm)) DEALLOCATE(ss%chii_drbm)

  IF(ALLOCATED(ss%chii_glf)) DEALLOCATE(ss%chii_glf)

  IF(ALLOCATED(ss%chii_gtcneo)) DEALLOCATE(ss%chii_gtcneo)

  IF(ALLOCATED(ss%chii_mmm71)) DEALLOCATE(ss%chii_mmm71)

  IF(ALLOCATED(ss%chii_nclass)) DEALLOCATE(ss%chii_nclass)

  IF(ALLOCATED(ss%chii_neo)) DEALLOCATE(ss%chii_neo)

  IF(ALLOCATED(ss%chii_ntm)) DEALLOCATE(ss%chii_ntm)

  IF(ALLOCATED(ss%chii_tglf)) DEALLOCATE(ss%chii_tglf)

  IF(ALLOCATED(ss%chii_trans)) DEALLOCATE(ss%chii_trans)

  IF(ALLOCATED(ss%id_chii_transcat)) DEALLOCATE(ss%id_chii_transcat)
  IF(ALLOCATED(ss%chii_transcat)) DEALLOCATE(ss%chii_transcat)

  IF(ALLOCATED(ss%chii_w19)) DEALLOCATE(ss%chii_w19)

  IF(ALLOCATED(ss%chimo_trans)) DEALLOCATE(ss%chimo_trans)

  IF(ALLOCATED(ss%id_chimo_transcat)) DEALLOCATE(ss%id_chimo_transcat)
  IF(ALLOCATED(ss%chimo_transcat)) DEALLOCATE(ss%chimo_transcat)

  IF(ALLOCATED(ss%chiphi_anom)) DEALLOCATE(ss%chiphi_anom)

  IF(ALLOCATED(ss%chiphi_drbm)) DEALLOCATE(ss%chiphi_drbm)

  IF(ALLOCATED(ss%chiphi_glf)) DEALLOCATE(ss%chiphi_glf)

  IF(ALLOCATED(ss%chiphi_gtcneo)) DEALLOCATE(ss%chiphi_gtcneo)

  IF(ALLOCATED(ss%chiphi_mmm71)) DEALLOCATE(ss%chiphi_mmm71)

  IF(ALLOCATED(ss%chiphi_neo)) DEALLOCATE(ss%chiphi_neo)

  IF(ALLOCATED(ss%chiphi_tglf)) DEALLOCATE(ss%chiphi_tglf)

  IF(ALLOCATED(ss%chiphi_w19)) DEALLOCATE(ss%chiphi_w19)

  IF(ALLOCATED(ss%chitheta_mmm71)) DEALLOCATE(ss%chitheta_mmm71)

  IF(ALLOCATED(ss%circuit_name)) DEALLOCATE(ss%circuit_name)

  IF(ALLOCATED(ss%coil_apt)) DEALLOCATE(ss%coil_apt)

  IF(ALLOCATED(ss%coil_in_circuit)) DEALLOCATE(ss%coil_in_circuit)

  IF(ALLOCATED(ss%coil_name)) DEALLOCATE(ss%coil_name)

  IF(ALLOCATED(ss%coil_resispt)) DEALLOCATE(ss%coil_resispt)

  IF(ALLOCATED(ss%curbeam)) DEALLOCATE(ss%curbeam)

  IF(ALLOCATED(ss%curech)) DEALLOCATE(ss%curech)

  IF(ALLOCATED(ss%id_curech_src)) DEALLOCATE(ss%id_curech_src)
  IF(ALLOCATED(ss%curech_src)) DEALLOCATE(ss%curech_src)

  IF(ALLOCATED(ss%curfusn)) DEALLOCATE(ss%curfusn)

  IF(ALLOCATED(ss%curich)) DEALLOCATE(ss%curich)

  IF(ALLOCATED(ss%curlh)) DEALLOCATE(ss%curlh)

  IF(ALLOCATED(ss%id_curlh_src)) DEALLOCATE(ss%id_curlh_src)
  IF(ALLOCATED(ss%curlh_src)) DEALLOCATE(ss%curlh_src)

  IF(ALLOCATED(ss%curmino)) DEALLOCATE(ss%curmino)

  IF(ALLOCATED(ss%curr_bootstrap)) DEALLOCATE(ss%curr_bootstrap)

  IF(ALLOCATED(ss%curr_ohmic)) DEALLOCATE(ss%curr_ohmic)

  IF(ALLOCATED(ss%curt)) DEALLOCATE(ss%curt)

  IF(ALLOCATED(ss%cur_rw)) DEALLOCATE(ss%cur_rw)

  IF(ALLOCATED(ss%d2R_geo_dRHOdTH)) DEALLOCATE(ss%d2R_geo_dRHOdTH)

  IF(ALLOCATED(ss%d2Z_geo_dRHOdTH)) DEALLOCATE(ss%d2Z_geo_dRHOdTH)

  IF(ALLOCATED(ss%db_mtm)) DEALLOCATE(ss%db_mtm)

  IF(ALLOCATED(ss%dcur_rw_dVloop)) DEALLOCATE(ss%dcur_rw_dVloop)

  IF(ALLOCATED(ss%DeltaW_code)) DEALLOCATE(ss%DeltaW_code)

  IF(ALLOCATED(ss%DeltaW_mapper)) DEALLOCATE(ss%DeltaW_mapper)

  IF(ALLOCATED(ss%DeltaW_stable)) DEALLOCATE(ss%DeltaW_stable)

  IF(ALLOCATED(ss%DeltaW_status)) DEALLOCATE(ss%DeltaW_status)

  IF(ALLOCATED(ss%difb_fusi)) DEALLOCATE(ss%difb_fusi)

  IF(ALLOCATED(ss%difb_nbi)) DEALLOCATE(ss%difb_nbi)

  IF(ALLOCATED(ss%difb_rfmi)) DEALLOCATE(ss%difb_rfmi)

  IF(ALLOCATED(ss%id_diff_trans)) DEALLOCATE(ss%id_diff_trans)
  IF(ALLOCATED(ss%diff_trans)) DEALLOCATE(ss%diff_trans)

  IF(ALLOCATED(ss%id_diff_transcat)) DEALLOCATE(ss%id_diff_transcat)
  IF(ALLOCATED(ss%diff_transcat)) DEALLOCATE(ss%diff_transcat)

  IF(ALLOCATED(ss%difne_nclass)) DEALLOCATE(ss%difne_nclass)

  IF(ALLOCATED(ss%difnh_nclass)) DEALLOCATE(ss%difnh_nclass)

  IF(ALLOCATED(ss%id_difns_anom)) DEALLOCATE(ss%id_difns_anom)
  IF(ALLOCATED(ss%difns_anom)) DEALLOCATE(ss%difns_anom)

  IF(ALLOCATED(ss%id_difns_drbm)) DEALLOCATE(ss%id_difns_drbm)
  IF(ALLOCATED(ss%difns_drbm)) DEALLOCATE(ss%difns_drbm)

  IF(ALLOCATED(ss%id_difns_glf)) DEALLOCATE(ss%id_difns_glf)
  IF(ALLOCATED(ss%difns_glf)) DEALLOCATE(ss%difns_glf)

  IF(ALLOCATED(ss%id_difns_gtcneo)) DEALLOCATE(ss%id_difns_gtcneo)
  IF(ALLOCATED(ss%difns_gtcneo)) DEALLOCATE(ss%difns_gtcneo)

  IF(ALLOCATED(ss%id_difns_mmm71)) DEALLOCATE(ss%id_difns_mmm71)
  IF(ALLOCATED(ss%difns_mmm71)) DEALLOCATE(ss%difns_mmm71)

  IF(ALLOCATED(ss%id_difns_nclass)) DEALLOCATE(ss%id_difns_nclass)
  IF(ALLOCATED(ss%difns_nclass)) DEALLOCATE(ss%difns_nclass)

  IF(ALLOCATED(ss%id_difns_neo)) DEALLOCATE(ss%id_difns_neo)
  IF(ALLOCATED(ss%difns_neo)) DEALLOCATE(ss%difns_neo)

  IF(ALLOCATED(ss%id_difns_tglf)) DEALLOCATE(ss%id_difns_tglf)
  IF(ALLOCATED(ss%difns_tglf)) DEALLOCATE(ss%difns_tglf)

  IF(ALLOCATED(ss%id_difns_w19)) DEALLOCATE(ss%id_difns_w19)
  IF(ALLOCATED(ss%difns_w19)) DEALLOCATE(ss%difns_w19)

  IF(ALLOCATED(ss%difnx_nclass)) DEALLOCATE(ss%difnx_nclass)

  IF(ALLOCATED(ss%difnz_mmm71)) DEALLOCATE(ss%difnz_mmm71)

  IF(ALLOCATED(ss%dist_fun)) DEALLOCATE(ss%dist_fun)

  IF(ALLOCATED(ss%dQedGrdte_tglf)) DEALLOCATE(ss%dQedGrdte_tglf)

  IF(ALLOCATED(ss%dQedGrdti_tglf)) DEALLOCATE(ss%dQedGrdti_tglf)

  IF(ALLOCATED(ss%dQidGrdte_tglf)) DEALLOCATE(ss%dQidGrdte_tglf)

  IF(ALLOCATED(ss%dQidGrdti_tglf)) DEALLOCATE(ss%dQidGrdti_tglf)

  IF(ALLOCATED(ss%dR0_momeq_dRHO)) DEALLOCATE(ss%dR0_momeq_dRHO)

  IF(ALLOCATED(ss%dR_geo_dRHO)) DEALLOCATE(ss%dR_geo_dRHO)

  IF(ALLOCATED(ss%dR_geo_dTH)) DEALLOCATE(ss%dR_geo_dTH)

  IF(ALLOCATED(ss%dxRjcos_momeq_dRHO)) DEALLOCATE(ss%dxRjcos_momeq_dRHO)

  IF(ALLOCATED(ss%dxRjsin_momeq_dRHO)) DEALLOCATE(ss%dxRjsin_momeq_dRHO)

  IF(ALLOCATED(ss%dxZjcos_momeq_dRHO)) DEALLOCATE(ss%dxZjcos_momeq_dRHO)

  IF(ALLOCATED(ss%dxZjsin_momeq_dRHO)) DEALLOCATE(ss%dxZjsin_momeq_dRHO)

  IF(ALLOCATED(ss%dx_fshield)) DEALLOCATE(ss%dx_fshield)

  IF(ALLOCATED(ss%dZ0_momeq_dRHO)) DEALLOCATE(ss%dZ0_momeq_dRHO)

  IF(ALLOCATED(ss%dZ_geo_dRHO)) DEALLOCATE(ss%dZ_geo_dRHO)

  IF(ALLOCATED(ss%dZ_geo_dTH)) DEALLOCATE(ss%dZ_geo_dTH)

  IF(ALLOCATED(ss%D_einj_standard)) DEALLOCATE(ss%D_einj_standard)

  IF(ALLOCATED(ss%D_ffull_standard)) DEALLOCATE(ss%D_ffull_standard)

  IF(ALLOCATED(ss%D_fhalf_standard)) DEALLOCATE(ss%D_fhalf_standard)

  IF(ALLOCATED(ss%e0_av)) DEALLOCATE(ss%e0_av)

  IF(ALLOCATED(ss%ecrf_src_name)) DEALLOCATE(ss%ecrf_src_name)

  IF(ALLOCATED(ss%EC_Beam_Elongation)) DEALLOCATE(ss%EC_Beam_Elongation)

  IF(ALLOCATED(ss%EC_Half_Power_Angle)) DEALLOCATE(ss%EC_Half_Power_Angle)

  IF(ALLOCATED(ss%EC_Omode_Fraction)) DEALLOCATE(ss%EC_Omode_Fraction)

  IF(ALLOCATED(ss%EC_phi_aim)) DEALLOCATE(ss%EC_phi_aim)

  IF(ALLOCATED(ss%EC_PRINC_CURV_HOR)) DEALLOCATE(ss%EC_PRINC_CURV_HOR)

  IF(ALLOCATED(ss%EC_PRINC_CURV_VERT)) DEALLOCATE(ss%EC_PRINC_CURV_VERT)

  IF(ALLOCATED(ss%EC_PRINC_WIDTH_HOR)) DEALLOCATE(ss%EC_PRINC_WIDTH_HOR)

  IF(ALLOCATED(ss%EC_PRINC_WIDTH_VERT)) DEALLOCATE(ss%EC_PRINC_WIDTH_VERT)

  IF(ALLOCATED(ss%EC_theta_aim)) DEALLOCATE(ss%EC_theta_aim)

  IF(ALLOCATED(ss%ee_mobility_factor)) DEALLOCATE(ss%ee_mobility_factor)

  IF(ALLOCATED(ss%Einj_max)) DEALLOCATE(ss%Einj_max)

  IF(ALLOCATED(ss%Einj_min)) DEALLOCATE(ss%Einj_min)

  IF(ALLOCATED(ss%elong)) DEALLOCATE(ss%elong)

  IF(ALLOCATED(ss%id_eperp_beami)) DEALLOCATE(ss%id_eperp_beami)
  IF(ALLOCATED(ss%eperp_beami)) DEALLOCATE(ss%eperp_beami)

  IF(ALLOCATED(ss%id_eperp_fusi)) DEALLOCATE(ss%id_eperp_fusi)
  IF(ALLOCATED(ss%eperp_fusi)) DEALLOCATE(ss%eperp_fusi)

  IF(ALLOCATED(ss%id_eperp_mini)) DEALLOCATE(ss%id_eperp_mini)
  IF(ALLOCATED(ss%eperp_mini)) DEALLOCATE(ss%eperp_mini)

  IF(ALLOCATED(ss%eperp_rw)) DEALLOCATE(ss%eperp_rw)

  IF(ALLOCATED(ss%id_epll_beami)) DEALLOCATE(ss%id_epll_beami)
  IF(ALLOCATED(ss%epll_beami)) DEALLOCATE(ss%epll_beami)

  IF(ALLOCATED(ss%id_epll_fusi)) DEALLOCATE(ss%id_epll_fusi)
  IF(ALLOCATED(ss%epll_fusi)) DEALLOCATE(ss%epll_fusi)

  IF(ALLOCATED(ss%id_epll_mini)) DEALLOCATE(ss%id_epll_mini)
  IF(ALLOCATED(ss%epll_mini)) DEALLOCATE(ss%epll_mini)

  IF(ALLOCATED(ss%epll_rw)) DEALLOCATE(ss%epll_rw)

  IF(ALLOCATED(ss%Epot)) DEALLOCATE(ss%Epot)

  IF(ALLOCATED(ss%eqmom_num)) DEALLOCATE(ss%eqmom_num)

  IF(ALLOCATED(ss%eta_parallel)) DEALLOCATE(ss%eta_parallel)

  IF(ALLOCATED(ss%E_anom)) DEALLOCATE(ss%E_anom)

  IF(ALLOCATED(ss%E_anom2)) DEALLOCATE(ss%E_anom2)

  IF(ALLOCATED(ss%id_fidiff_bpass_co)) DEALLOCATE(ss%id_fidiff_bpass_co)
  IF(ALLOCATED(ss%fidiff_bpass_co)) DEALLOCATE(ss%fidiff_bpass_co)

  IF(ALLOCATED(ss%id_fidiff_bpass_ctr)) DEALLOCATE(ss%id_fidiff_bpass_ctr)
  IF(ALLOCATED(ss%fidiff_bpass_ctr)) DEALLOCATE(ss%fidiff_bpass_ctr)

  IF(ALLOCATED(ss%id_fidiff_btrap)) DEALLOCATE(ss%id_fidiff_btrap)
  IF(ALLOCATED(ss%fidiff_btrap)) DEALLOCATE(ss%fidiff_btrap)

  IF(ALLOCATED(ss%id_fidiff_dpass_co)) DEALLOCATE(ss%id_fidiff_dpass_co)
  IF(ALLOCATED(ss%fidiff_dpass_co)) DEALLOCATE(ss%fidiff_dpass_co)

  IF(ALLOCATED(ss%id_fidiff_dpass_ctr)) DEALLOCATE(ss%id_fidiff_dpass_ctr)
  IF(ALLOCATED(ss%fidiff_dpass_ctr)) DEALLOCATE(ss%fidiff_dpass_ctr)

  IF(ALLOCATED(ss%id_fidiff_dtrap)) DEALLOCATE(ss%id_fidiff_dtrap)
  IF(ALLOCATED(ss%fidiff_dtrap)) DEALLOCATE(ss%fidiff_dtrap)

  IF(ALLOCATED(ss%Fi_depletion)) DEALLOCATE(ss%Fi_depletion)

  IF(ALLOCATED(ss%fracmin)) DEALLOCATE(ss%fracmin)

  IF(ALLOCATED(ss%fracpslh)) DEALLOCATE(ss%fracpslh)

  IF(ALLOCATED(ss%frac_full)) DEALLOCATE(ss%frac_full)

  IF(ALLOCATED(ss%frac_half)) DEALLOCATE(ss%frac_half)

  IF(ALLOCATED(ss%freq_drbm)) DEALLOCATE(ss%freq_drbm)

  IF(ALLOCATED(ss%freq_ec)) DEALLOCATE(ss%freq_ec)

  IF(ALLOCATED(ss%freq_glf)) DEALLOCATE(ss%freq_glf)

  IF(ALLOCATED(ss%freq_ic)) DEALLOCATE(ss%freq_ic)

  IF(ALLOCATED(ss%freq_lh)) DEALLOCATE(ss%freq_lh)

  IF(ALLOCATED(ss%freq_max_tglf)) DEALLOCATE(ss%freq_max_tglf)

  IF(ALLOCATED(ss%id_freq_mmm71)) DEALLOCATE(ss%id_freq_mmm71)
  IF(ALLOCATED(ss%freq_mmm71)) DEALLOCATE(ss%freq_mmm71)

  IF(ALLOCATED(ss%freq_mtm)) DEALLOCATE(ss%freq_mtm)

  IF(ALLOCATED(ss%id_freq_tglf)) DEALLOCATE(ss%id_freq_tglf)
  IF(ALLOCATED(ss%freq_tglf)) DEALLOCATE(ss%freq_tglf)

  IF(ALLOCATED(ss%gamma_lmhd)) DEALLOCATE(ss%gamma_lmhd)

  IF(ALLOCATED(ss%gamma_nc)) DEALLOCATE(ss%gamma_nc)

  IF(ALLOCATED(ss%gas_atom)) DEALLOCATE(ss%gas_atom)

  IF(ALLOCATED(ss%gb1)) DEALLOCATE(ss%gb1)

  IF(ALLOCATED(ss%gb2)) DEALLOCATE(ss%gb2)

  IF(ALLOCATED(ss%gb2i)) DEALLOCATE(ss%gb2i)

  IF(ALLOCATED(ss%gbr2)) DEALLOCATE(ss%gbr2)

  IF(ALLOCATED(ss%gncfb2h)) DEALLOCATE(ss%gncfb2h)

  IF(ALLOCATED(ss%gncfh)) DEALLOCATE(ss%gncfh)

  IF(ALLOCATED(ss%gr1)) DEALLOCATE(ss%gr1)

  IF(ALLOCATED(ss%gr2)) DEALLOCATE(ss%gr2)

  IF(ALLOCATED(ss%gr2i)) DEALLOCATE(ss%gr2i)

  IF(ALLOCATED(ss%gr2rho2)) DEALLOCATE(ss%gr2rho2)

  IF(ALLOCATED(ss%gr3i)) DEALLOCATE(ss%gr3i)

  IF(ALLOCATED(ss%grho1)) DEALLOCATE(ss%grho1)

  IF(ALLOCATED(ss%grho2)) DEALLOCATE(ss%grho2)

  IF(ALLOCATED(ss%grho2b2i)) DEALLOCATE(ss%grho2b2i)

  IF(ALLOCATED(ss%grho2r2i)) DEALLOCATE(ss%grho2r2i)

  IF(ALLOCATED(ss%grho2r3i)) DEALLOCATE(ss%grho2r3i)

  IF(ALLOCATED(ss%gri)) DEALLOCATE(ss%gri)

  IF(ALLOCATED(ss%grirhoi)) DEALLOCATE(ss%grirhoi)

  IF(ALLOCATED(ss%growthrate_drbm)) DEALLOCATE(ss%growthrate_drbm)

  IF(ALLOCATED(ss%growthrate_glf)) DEALLOCATE(ss%growthrate_glf)

  IF(ALLOCATED(ss%growthrate_max_tglf)) DEALLOCATE(ss%growthrate_max_tglf)

  IF(ALLOCATED(ss%id_growthrate_mmm71)) DEALLOCATE(ss%id_growthrate_mmm71)
  IF(ALLOCATED(ss%growthrate_mmm71)) DEALLOCATE(ss%growthrate_mmm71)

  IF(ALLOCATED(ss%growthrate_mtm)) DEALLOCATE(ss%growthrate_mtm)

  IF(ALLOCATED(ss%id_growthrate_tglf)) DEALLOCATE(ss%id_growthrate_tglf)
  IF(ALLOCATED(ss%growthrate_tglf)) DEALLOCATE(ss%growthrate_tglf)

  IF(ALLOCATED(ss%id_growthrate_vpar)) DEALLOCATE(ss%id_growthrate_vpar)
  IF(ALLOCATED(ss%growthrate_vpar)) DEALLOCATE(ss%growthrate_vpar)

  IF(ALLOCATED(ss%gs_name)) DEALLOCATE(ss%gs_name)

  IF(ALLOCATED(ss%g_eq)) DEALLOCATE(ss%g_eq)

  IF(ALLOCATED(ss%hegrilh)) DEALLOCATE(ss%hegrilh)

  IF(ALLOCATED(ss%Hsize_coil)) DEALLOCATE(ss%Hsize_coil)

  IF(ALLOCATED(ss%H_einj_standard)) DEALLOCATE(ss%H_einj_standard)

  IF(ALLOCATED(ss%H_ffull_standard)) DEALLOCATE(ss%H_ffull_standard)

  IF(ALLOCATED(ss%H_fhalf_standard)) DEALLOCATE(ss%H_fhalf_standard)

  IF(ALLOCATED(ss%icircuit_coil)) DEALLOCATE(ss%icircuit_coil)

  IF(ALLOCATED(ss%icrf_src_name)) DEALLOCATE(ss%icrf_src_name)

  IF(ALLOCATED(ss%Imag_ant_coef)) DEALLOCATE(ss%Imag_ant_coef)

  IF(ALLOCATED(ss%iota)) DEALLOCATE(ss%iota)

  IF(ALLOCATED(ss%isThermal)) DEALLOCATE(ss%isThermal)

  IF(ALLOCATED(ss%is_recycling)) DEALLOCATE(ss%is_recycling)

  IF(ALLOCATED(ss%jdotb)) DEALLOCATE(ss%jdotb)

  IF(ALLOCATED(ss%kvolt_nbi)) DEALLOCATE(ss%kvolt_nbi)

  IF(ALLOCATED(ss%kyrhos_mtm)) DEALLOCATE(ss%kyrhos_mtm)

  IF(ALLOCATED(ss%id_kyspectrum_tglf)) DEALLOCATE(ss%id_kyspectrum_tglf)
  IF(ALLOCATED(ss%kyspectrum_tglf)) DEALLOCATE(ss%kyspectrum_tglf)

  IF(ALLOCATED(ss%Lbscap)) DEALLOCATE(ss%Lbscap)

  IF(ALLOCATED(ss%Lbscap2)) DEALLOCATE(ss%Lbscap2)

  IF(ALLOCATED(ss%Lbsctan)) DEALLOCATE(ss%Lbsctan)

  IF(ALLOCATED(ss%lhrf_src_name)) DEALLOCATE(ss%lhrf_src_name)

  IF(ALLOCATED(ss%Lpol)) DEALLOCATE(ss%Lpol)

  IF(ALLOCATED(ss%Mercier_stable)) DEALLOCATE(ss%Mercier_stable)

  IF(ALLOCATED(ss%m_ALL)) DEALLOCATE(ss%m_ALL)

  IF(ALLOCATED(ss%m_ALLA)) DEALLOCATE(ss%m_ALLA)

  IF(ALLOCATED(ss%m_RFMIN)) DEALLOCATE(ss%m_RFMIN)

  IF(ALLOCATED(ss%m_S)) DEALLOCATE(ss%m_S)

  IF(ALLOCATED(ss%m_SA)) DEALLOCATE(ss%m_SA)

  IF(ALLOCATED(ss%m_SFUS)) DEALLOCATE(ss%m_SFUS)

  IF(ALLOCATED(ss%m_SGAS)) DEALLOCATE(ss%m_SGAS)

  IF(ALLOCATED(ss%m_SIMP0)) DEALLOCATE(ss%m_SIMP0)

  IF(ALLOCATED(ss%m_SIMPI)) DEALLOCATE(ss%m_SIMPI)

  IF(ALLOCATED(ss%m_SNBI)) DEALLOCATE(ss%m_SNBI)

  IF(ALLOCATED(ss%id_n0norm)) DEALLOCATE(ss%id_n0norm)
  IF(ALLOCATED(ss%n0norm)) DEALLOCATE(ss%n0norm)

  IF(ALLOCATED(ss%id_n0_halo)) DEALLOCATE(ss%id_n0_halo)
  IF(ALLOCATED(ss%n0_halo)) DEALLOCATE(ss%n0_halo)

  IF(ALLOCATED(ss%id_n0_reco)) DEALLOCATE(ss%id_n0_reco)
  IF(ALLOCATED(ss%n0_reco)) DEALLOCATE(ss%n0_reco)

  IF(ALLOCATED(ss%nbap2_shape)) DEALLOCATE(ss%nbap2_shape)

  IF(ALLOCATED(ss%nbap_shape)) DEALLOCATE(ss%nbap_shape)

  IF(ALLOCATED(ss%id_nbeami)) DEALLOCATE(ss%id_nbeami)
  IF(ALLOCATED(ss%nbeami)) DEALLOCATE(ss%nbeami)

  IF(ALLOCATED(ss%nbeami_bdy)) DEALLOCATE(ss%nbeami_bdy)

  IF(ALLOCATED(ss%nbion)) DEALLOCATE(ss%nbion)

  IF(ALLOCATED(ss%nbion_trace)) DEALLOCATE(ss%nbion_trace)

  IF(ALLOCATED(ss%nbi_src_name)) DEALLOCATE(ss%nbi_src_name)

  IF(ALLOCATED(ss%nbshape)) DEALLOCATE(ss%nbshape)

  IF(ALLOCATED(ss%id_neflux_ky_tglf)) DEALLOCATE(ss%id_neflux_ky_tglf)
  IF(ALLOCATED(ss%neflux_ky_tglf)) DEALLOCATE(ss%neflux_ky_tglf)

  IF(ALLOCATED(ss%Newcomb_code)) DEALLOCATE(ss%Newcomb_code)

  IF(ALLOCATED(ss%Newcomb_mapper)) DEALLOCATE(ss%Newcomb_mapper)

  IF(ALLOCATED(ss%Newcomb_stable)) DEALLOCATE(ss%Newcomb_stable)

  IF(ALLOCATED(ss%Newcomb_status)) DEALLOCATE(ss%Newcomb_status)

  IF(ALLOCATED(ss%id_ne_ky_tglf)) DEALLOCATE(ss%id_ne_ky_tglf)
  IF(ALLOCATED(ss%ne_ky_tglf)) DEALLOCATE(ss%ne_ky_tglf)

  IF(ALLOCATED(ss%id_nfusi)) DEALLOCATE(ss%id_nfusi)
  IF(ALLOCATED(ss%nfusi)) DEALLOCATE(ss%nfusi)

  IF(ALLOCATED(ss%nfusi_bdy)) DEALLOCATE(ss%nfusi_bdy)

  IF(ALLOCATED(ss%ngradb2_av)) DEALLOCATE(ss%ngradb2_av)

  IF(ALLOCATED(ss%ni)) DEALLOCATE(ss%ni)

  IF(ALLOCATED(ss%id_niflux_ky_tglf)) DEALLOCATE(ss%id_niflux_ky_tglf)
  IF(ALLOCATED(ss%niflux_ky_tglf)) DEALLOCATE(ss%niflux_ky_tglf)

  IF(ALLOCATED(ss%id_ni_ky_tglf)) DEALLOCATE(ss%id_ni_ky_tglf)
  IF(ALLOCATED(ss%ni_ky_tglf)) DEALLOCATE(ss%ni_ky_tglf)

  IF(ALLOCATED(ss%id_nmini)) DEALLOCATE(ss%id_nmini)
  IF(ALLOCATED(ss%nmini)) DEALLOCATE(ss%nmini)

  IF(ALLOCATED(ss%nmini_bdy)) DEALLOCATE(ss%nmini_bdy)

  IF(ALLOCATED(ss%nmodel)) DEALLOCATE(ss%nmodel)

  IF(ALLOCATED(ss%nnkparlh)) DEALLOCATE(ss%nnkparlh)

  IF(ALLOCATED(ss%nnkpollh)) DEALLOCATE(ss%nnkpollh)

  IF(ALLOCATED(ss%nnktorlh)) DEALLOCATE(ss%nnktorlh)

  IF(ALLOCATED(ss%nphi)) DEALLOCATE(ss%nphi)

  IF(ALLOCATED(ss%nrw)) DEALLOCATE(ss%nrw)

  IF(ALLOCATED(ss%nrz_antgeo)) DEALLOCATE(ss%nrz_antgeo)

  IF(ALLOCATED(ss%id_ns)) DEALLOCATE(ss%id_ns)
  IF(ALLOCATED(ss%ns)) DEALLOCATE(ss%ns)

  IF(ALLOCATED(ss%nspectrumlh_src)) DEALLOCATE(ss%nspectrumlh_src)

  IF(ALLOCATED(ss%ns_bdy)) DEALLOCATE(ss%ns_bdy)

  IF(ALLOCATED(ss%ns_is_input)) DEALLOCATE(ss%ns_is_input)

  IF(ALLOCATED(ss%nthinlh)) DEALLOCATE(ss%nthinlh)

  IF(ALLOCATED(ss%Nturns)) DEALLOCATE(ss%Nturns)

  IF(ALLOCATED(ss%num_nphi)) DEALLOCATE(ss%num_nphi)

  IF(ALLOCATED(ss%num_nphi_vac)) DEALLOCATE(ss%num_nphi_vac)

  IF(ALLOCATED(ss%id_nzflux_ky_tglf)) DEALLOCATE(ss%id_nzflux_ky_tglf)
  IF(ALLOCATED(ss%nzflux_ky_tglf)) DEALLOCATE(ss%nzflux_ky_tglf)

  IF(ALLOCATED(ss%id_nz_ky_tglf)) DEALLOCATE(ss%id_nz_ky_tglf)
  IF(ALLOCATED(ss%nz_ky_tglf)) DEALLOCATE(ss%nz_ky_tglf)

  IF(ALLOCATED(ss%n_straps)) DEALLOCATE(ss%n_straps)

  IF(ALLOCATED(ss%id_omeg0cx)) DEALLOCATE(ss%id_omeg0cx)
  IF(ALLOCATED(ss%omeg0cx)) DEALLOCATE(ss%omeg0cx)

  IF(ALLOCATED(ss%id_omeg0sc0)) DEALLOCATE(ss%id_omeg0sc0)
  IF(ALLOCATED(ss%omeg0sc0)) DEALLOCATE(ss%omeg0sc0)

  IF(ALLOCATED(ss%id_omeg0_halo)) DEALLOCATE(ss%id_omeg0_halo)
  IF(ALLOCATED(ss%omeg0_halo)) DEALLOCATE(ss%omeg0_halo)

  IF(ALLOCATED(ss%id_omeg0_reco)) DEALLOCATE(ss%id_omeg0_reco)
  IF(ALLOCATED(ss%omeg0_reco)) DEALLOCATE(ss%omeg0_reco)

  IF(ALLOCATED(ss%omegat)) DEALLOCATE(ss%omegat)

  IF(ALLOCATED(ss%omega_exb)) DEALLOCATE(ss%omega_exb)

  IF(ALLOCATED(ss%p0_reco)) DEALLOCATE(ss%p0_reco)

  IF(ALLOCATED(ss%pb0_halo)) DEALLOCATE(ss%pb0_halo)

  IF(ALLOCATED(ss%pbe)) DEALLOCATE(ss%pbe)

  IF(ALLOCATED(ss%pbi)) DEALLOCATE(ss%pbi)

  IF(ALLOCATED(ss%pbth)) DEALLOCATE(ss%pbth)

  IF(ALLOCATED(ss%pcx_halo)) DEALLOCATE(ss%pcx_halo)

  IF(ALLOCATED(ss%pcx_reco)) DEALLOCATE(ss%pcx_reco)

  IF(ALLOCATED(ss%peech)) DEALLOCATE(ss%peech)

  IF(ALLOCATED(ss%id_peech_src)) DEALLOCATE(ss%id_peech_src)
  IF(ALLOCATED(ss%peech_src)) DEALLOCATE(ss%peech_src)

  IF(ALLOCATED(ss%pelh)) DEALLOCATE(ss%pelh)

  IF(ALLOCATED(ss%id_pelh_src)) DEALLOCATE(ss%id_pelh_src)
  IF(ALLOCATED(ss%pelh_src)) DEALLOCATE(ss%pelh_src)

  IF(ALLOCATED(ss%pe_anom)) DEALLOCATE(ss%pe_anom)

  IF(ALLOCATED(ss%pe_trans)) DEALLOCATE(ss%pe_trans)

  IF(ALLOCATED(ss%id_pe_transcat)) DEALLOCATE(ss%id_pe_transcat)
  IF(ALLOCATED(ss%pe_transcat)) DEALLOCATE(ss%pe_transcat)

  IF(ALLOCATED(ss%pfuse)) DEALLOCATE(ss%pfuse)

  IF(ALLOCATED(ss%pfusi)) DEALLOCATE(ss%pfusi)

  IF(ALLOCATED(ss%pfusth)) DEALLOCATE(ss%pfusth)

  IF(ALLOCATED(ss%Phibsc)) DEALLOCATE(ss%Phibsc)

  IF(ALLOCATED(ss%id_phiflux_ky_tglf)) DEALLOCATE(ss%id_phiflux_ky_tglf)
  IF(ALLOCATED(ss%phiflux_ky_tglf)) DEALLOCATE(ss%phiflux_ky_tglf)

  IF(ALLOCATED(ss%phigrilh)) DEALLOCATE(ss%phigrilh)

  IF(ALLOCATED(ss%phit)) DEALLOCATE(ss%phit)

  IF(ALLOCATED(ss%Phi_EC_launch)) DEALLOCATE(ss%Phi_EC_launch)

  IF(ALLOCATED(ss%picrf_abs)) DEALLOCATE(ss%picrf_abs)

  IF(ALLOCATED(ss%picrf_ext)) DEALLOCATE(ss%picrf_ext)

  IF(ALLOCATED(ss%id_picrf_nphi_srcs)) DEALLOCATE(ss%id_picrf_nphi_srcs)
  IF(ALLOCATED(ss%picrf_nphi_srcs)) DEALLOCATE(ss%picrf_nphi_srcs)

  IF(ALLOCATED(ss%id_picrf_srcs)) DEALLOCATE(ss%id_picrf_srcs)
  IF(ALLOCATED(ss%picrf_srcs)) DEALLOCATE(ss%picrf_srcs)

  IF(ALLOCATED(ss%id_picrf_totals)) DEALLOCATE(ss%id_picrf_totals)
  IF(ALLOCATED(ss%picrf_totals)) DEALLOCATE(ss%picrf_totals)

  IF(ALLOCATED(ss%picth)) DEALLOCATE(ss%picth)

  IF(ALLOCATED(ss%pilh)) DEALLOCATE(ss%pilh)

  IF(ALLOCATED(ss%id_pilh_src)) DEALLOCATE(ss%id_pilh_src)
  IF(ALLOCATED(ss%pilh_src)) DEALLOCATE(ss%pilh_src)

  IF(ALLOCATED(ss%pi_anom)) DEALLOCATE(ss%pi_anom)

  IF(ALLOCATED(ss%pi_trans)) DEALLOCATE(ss%pi_trans)

  IF(ALLOCATED(ss%id_pi_transcat)) DEALLOCATE(ss%id_pi_transcat)
  IF(ALLOCATED(ss%pi_transcat)) DEALLOCATE(ss%pi_transcat)

  IF(ALLOCATED(ss%pmine)) DEALLOCATE(ss%pmine)

  IF(ALLOCATED(ss%pmini)) DEALLOCATE(ss%pmini)

  IF(ALLOCATED(ss%pminth)) DEALLOCATE(ss%pminth)

  IF(ALLOCATED(ss%pohme)) DEALLOCATE(ss%pohme)

  IF(ALLOCATED(ss%id_pot_ky_tglf)) DEALLOCATE(ss%id_pot_ky_tglf)
  IF(ALLOCATED(ss%pot_ky_tglf)) DEALLOCATE(ss%pot_ky_tglf)

  IF(ALLOCATED(ss%power_ec)) DEALLOCATE(ss%power_ec)

  IF(ALLOCATED(ss%power_ic)) DEALLOCATE(ss%power_ic)

  IF(ALLOCATED(ss%power_lh)) DEALLOCATE(ss%power_lh)

  IF(ALLOCATED(ss%power_nbi)) DEALLOCATE(ss%power_nbi)

  IF(ALLOCATED(ss%power_nbi_trace)) DEALLOCATE(ss%power_nbi_trace)

  IF(ALLOCATED(ss%prad)) DEALLOCATE(ss%prad)

  IF(ALLOCATED(ss%prad_br)) DEALLOCATE(ss%prad_br)

  IF(ALLOCATED(ss%prad_cy)) DEALLOCATE(ss%prad_cy)

  IF(ALLOCATED(ss%prad_li)) DEALLOCATE(ss%prad_li)

  IF(ALLOCATED(ss%psc_halo)) DEALLOCATE(ss%psc_halo)

  IF(ALLOCATED(ss%psc_reco)) DEALLOCATE(ss%psc_reco)

  IF(ALLOCATED(ss%psipol)) DEALLOCATE(ss%psipol)

  IF(ALLOCATED(ss%PsiRZ)) DEALLOCATE(ss%PsiRZ)

  IF(ALLOCATED(ss%psmom_errck)) DEALLOCATE(ss%psmom_errck)

  IF(ALLOCATED(ss%id_psmom_nc)) DEALLOCATE(ss%id_psmom_nc)
  IF(ALLOCATED(ss%psmom_nc)) DEALLOCATE(ss%psmom_nc)

  IF(ALLOCATED(ss%psmom_num)) DEALLOCATE(ss%psmom_num)

  IF(ALLOCATED(ss%P_eq)) DEALLOCATE(ss%P_eq)

  IF(ALLOCATED(ss%qatom_ALL)) DEALLOCATE(ss%qatom_ALL)

  IF(ALLOCATED(ss%qatom_ALLA)) DEALLOCATE(ss%qatom_ALLA)

  IF(ALLOCATED(ss%qatom_RFMIN)) DEALLOCATE(ss%qatom_RFMIN)

  IF(ALLOCATED(ss%qatom_S)) DEALLOCATE(ss%qatom_S)

  IF(ALLOCATED(ss%qatom_SA)) DEALLOCATE(ss%qatom_SA)

  IF(ALLOCATED(ss%qatom_SFUS)) DEALLOCATE(ss%qatom_SFUS)

  IF(ALLOCATED(ss%qatom_SGAS)) DEALLOCATE(ss%qatom_SGAS)

  IF(ALLOCATED(ss%qatom_SIMP0)) DEALLOCATE(ss%qatom_SIMP0)

  IF(ALLOCATED(ss%qatom_SIMPI)) DEALLOCATE(ss%qatom_SIMPI)

  IF(ALLOCATED(ss%qatom_SNBI)) DEALLOCATE(ss%qatom_SNBI)

  IF(ALLOCATED(ss%id_qbeami)) DEALLOCATE(ss%id_qbeami)
  IF(ALLOCATED(ss%qbeami)) DEALLOCATE(ss%qbeami)

  IF(ALLOCATED(ss%qcomp_e)) DEALLOCATE(ss%qcomp_e)

  IF(ALLOCATED(ss%qcomp_i)) DEALLOCATE(ss%qcomp_i)

  IF(ALLOCATED(ss%qie)) DEALLOCATE(ss%qie)

  IF(ALLOCATED(ss%id_qioniz)) DEALLOCATE(ss%id_qioniz)
  IF(ALLOCATED(ss%qioniz)) DEALLOCATE(ss%qioniz)

  IF(ALLOCATED(ss%ql_operator)) DEALLOCATE(ss%ql_operator)

  IF(ALLOCATED(ss%id_qqcx)) DEALLOCATE(ss%id_qqcx)
  IF(ALLOCATED(ss%qqcx)) DEALLOCATE(ss%qqcx)

  IF(ALLOCATED(ss%qrot_conv)) DEALLOCATE(ss%qrot_conv)

  IF(ALLOCATED(ss%qrot_diff)) DEALLOCATE(ss%qrot_diff)

  IF(ALLOCATED(ss%q_ALL)) DEALLOCATE(ss%q_ALL)

  IF(ALLOCATED(ss%q_ALLA)) DEALLOCATE(ss%q_ALLA)

  IF(ALLOCATED(ss%q_eq)) DEALLOCATE(ss%q_eq)

  IF(ALLOCATED(ss%q_RFMIN)) DEALLOCATE(ss%q_RFMIN)

  IF(ALLOCATED(ss%q_S)) DEALLOCATE(ss%q_S)

  IF(ALLOCATED(ss%q_SA)) DEALLOCATE(ss%q_SA)

  IF(ALLOCATED(ss%q_SFUS)) DEALLOCATE(ss%q_SFUS)

  IF(ALLOCATED(ss%q_SGAS)) DEALLOCATE(ss%q_SGAS)

  IF(ALLOCATED(ss%q_SIMP0)) DEALLOCATE(ss%q_SIMP0)

  IF(ALLOCATED(ss%q_SIMPI)) DEALLOCATE(ss%q_SIMPI)

  IF(ALLOCATED(ss%q_SNBI)) DEALLOCATE(ss%q_SNBI)

  IF(ALLOCATED(ss%R0_momeq)) DEALLOCATE(ss%R0_momeq)

  IF(ALLOCATED(ss%id_rate_sinb0i)) DEALLOCATE(ss%id_rate_sinb0i)
  IF(ALLOCATED(ss%rate_sinb0i)) DEALLOCATE(ss%rate_sinb0i)

  IF(ALLOCATED(ss%id_rate_sinb0x)) DEALLOCATE(ss%id_rate_sinb0x)
  IF(ALLOCATED(ss%rate_sinb0x)) DEALLOCATE(ss%rate_sinb0x)

  IF(ALLOCATED(ss%id_rate_sinb0xs)) DEALLOCATE(ss%id_rate_sinb0xs)
  IF(ALLOCATED(ss%rate_sinb0xs)) DEALLOCATE(ss%rate_sinb0xs)

  IF(ALLOCATED(ss%id_rate_sinf0i)) DEALLOCATE(ss%id_rate_sinf0i)
  IF(ALLOCATED(ss%rate_sinf0i)) DEALLOCATE(ss%rate_sinf0i)

  IF(ALLOCATED(ss%id_rate_sinf0x)) DEALLOCATE(ss%id_rate_sinf0x)
  IF(ALLOCATED(ss%rate_sinf0x)) DEALLOCATE(ss%rate_sinf0x)

  IF(ALLOCATED(ss%id_rate_sinf0xs)) DEALLOCATE(ss%id_rate_sinf0xs)
  IF(ALLOCATED(ss%rate_sinf0xs)) DEALLOCATE(ss%rate_sinf0xs)

  IF(ALLOCATED(ss%Real_ant_coef)) DEALLOCATE(ss%Real_ant_coef)

  IF(ALLOCATED(ss%id_res_sn)) DEALLOCATE(ss%id_res_sn)
  IF(ALLOCATED(ss%res_sn)) DEALLOCATE(ss%res_sn)

  IF(ALLOCATED(ss%res_te)) DEALLOCATE(ss%res_te)

  IF(ALLOCATED(ss%res_ti)) DEALLOCATE(ss%res_ti)

  IF(ALLOCATED(ss%res_tq)) DEALLOCATE(ss%res_tq)

  IF(ALLOCATED(ss%RFMIN_name)) DEALLOCATE(ss%RFMIN_name)

  IF(ALLOCATED(ss%rfmin_to_all)) DEALLOCATE(ss%rfmin_to_all)

  IF(ALLOCATED(ss%rfmin_to_alla)) DEALLOCATE(ss%rfmin_to_alla)

  IF(ALLOCATED(ss%RFMIN_type)) DEALLOCATE(ss%RFMIN_type)

  IF(ALLOCATED(ss%rho)) DEALLOCATE(ss%rho)

  IF(ALLOCATED(ss%rhopsi0lh)) DEALLOCATE(ss%rhopsi0lh)

  IF(ALLOCATED(ss%rho_anom)) DEALLOCATE(ss%rho_anom)

  IF(ALLOCATED(ss%rho_anom2)) DEALLOCATE(ss%rho_anom2)

  IF(ALLOCATED(ss%rho_anomth)) DEALLOCATE(ss%rho_anomth)

  IF(ALLOCATED(ss%rho_bdy_ns)) DEALLOCATE(ss%rho_bdy_ns)

  IF(ALLOCATED(ss%rho_ecrf)) DEALLOCATE(ss%rho_ecrf)

  IF(ALLOCATED(ss%rho_eq)) DEALLOCATE(ss%rho_eq)

  IF(ALLOCATED(ss%rho_eq_geo)) DEALLOCATE(ss%rho_eq_geo)

  IF(ALLOCATED(ss%rho_fus)) DEALLOCATE(ss%rho_fus)

  IF(ALLOCATED(ss%rho_gas)) DEALLOCATE(ss%rho_gas)

  IF(ALLOCATED(ss%rho_icrf)) DEALLOCATE(ss%rho_icrf)

  IF(ALLOCATED(ss%rho_lhrf)) DEALLOCATE(ss%rho_lhrf)

  IF(ALLOCATED(ss%rho_lmhd)) DEALLOCATE(ss%rho_lmhd)

  IF(ALLOCATED(ss%rho_mist)) DEALLOCATE(ss%rho_mist)

  IF(ALLOCATED(ss%rho_nbi)) DEALLOCATE(ss%rho_nbi)

  IF(ALLOCATED(ss%rho_pel)) DEALLOCATE(ss%rho_pel)

  IF(ALLOCATED(ss%rho_rad)) DEALLOCATE(ss%rho_rad)

  IF(ALLOCATED(ss%rho_rw)) DEALLOCATE(ss%rho_rw)

  IF(ALLOCATED(ss%rlim)) DEALLOCATE(ss%rlim)

  IF(ALLOCATED(ss%Rloc_coil)) DEALLOCATE(ss%Rloc_coil)

  IF(ALLOCATED(ss%Rmajor_mean)) DEALLOCATE(ss%Rmajor_mean)

  IF(ALLOCATED(ss%rMinor_mean)) DEALLOCATE(ss%rMinor_mean)

  IF(ALLOCATED(ss%R_ant)) DEALLOCATE(ss%R_ant)

  IF(ALLOCATED(ss%R_antgeo)) DEALLOCATE(ss%R_antgeo)

  IF(ALLOCATED(ss%R_EC_launch)) DEALLOCATE(ss%R_EC_launch)

  IF(ALLOCATED(ss%R_geo)) DEALLOCATE(ss%R_geo)

  IF(ALLOCATED(ss%R_grid)) DEALLOCATE(ss%R_grid)

  IF(ALLOCATED(ss%R_midp_in)) DEALLOCATE(ss%R_midp_in)

  IF(ALLOCATED(ss%R_midp_out)) DEALLOCATE(ss%R_midp_out)

  IF(ALLOCATED(ss%R_ripple)) DEALLOCATE(ss%R_ripple)

  IF(ALLOCATED(ss%R_surfMax)) DEALLOCATE(ss%R_surfMax)

  IF(ALLOCATED(ss%R_surfMin)) DEALLOCATE(ss%R_surfMin)

  IF(ALLOCATED(ss%id_s0reco)) DEALLOCATE(ss%id_s0reco)
  IF(ALLOCATED(ss%s0reco)) DEALLOCATE(ss%s0reco)

  IF(ALLOCATED(ss%s0reco_e)) DEALLOCATE(ss%s0reco_e)

  IF(ALLOCATED(ss%id_s0reco_recap)) DEALLOCATE(ss%id_s0reco_recap)
  IF(ALLOCATED(ss%s0reco_recap)) DEALLOCATE(ss%s0reco_recap)

  IF(ALLOCATED(ss%sa_index)) DEALLOCATE(ss%sa_index)

  IF(ALLOCATED(ss%SA_name)) DEALLOCATE(ss%SA_name)

  IF(ALLOCATED(ss%SA_type)) DEALLOCATE(ss%SA_type)

  IF(ALLOCATED(ss%id_sb0halo)) DEALLOCATE(ss%id_sb0halo)
  IF(ALLOCATED(ss%sb0halo)) DEALLOCATE(ss%sb0halo)

  IF(ALLOCATED(ss%id_sb0halo_recap)) DEALLOCATE(ss%id_sb0halo_recap)
  IF(ALLOCATED(ss%sb0halo_recap)) DEALLOCATE(ss%sb0halo_recap)

  IF(ALLOCATED(ss%sbedep)) DEALLOCATE(ss%sbedep)

  IF(ALLOCATED(ss%sbehalo)) DEALLOCATE(ss%sbehalo)

  IF(ALLOCATED(ss%id_sbsce)) DEALLOCATE(ss%id_sbsce)
  IF(ALLOCATED(ss%sbsce)) DEALLOCATE(ss%sbsce)

  IF(ALLOCATED(ss%id_sbtherm)) DEALLOCATE(ss%id_sbtherm)
  IF(ALLOCATED(ss%sbtherm)) DEALLOCATE(ss%sbtherm)

  IF(ALLOCATED(ss%sc0)) DEALLOCATE(ss%sc0)

  IF(ALLOCATED(ss%sc0_to_sgas)) DEALLOCATE(ss%sc0_to_sgas)

  IF(ALLOCATED(ss%id_sc_anom)) DEALLOCATE(ss%id_sc_anom)
  IF(ALLOCATED(ss%sc_anom)) DEALLOCATE(ss%sc_anom)

  IF(ALLOCATED(ss%id_sfsce)) DEALLOCATE(ss%id_sfsce)
  IF(ALLOCATED(ss%sfsce)) DEALLOCATE(ss%sfsce)

  IF(ALLOCATED(ss%id_sftherm)) DEALLOCATE(ss%id_sftherm)
  IF(ALLOCATED(ss%sftherm)) DEALLOCATE(ss%sftherm)

  IF(ALLOCATED(ss%SFUS_name)) DEALLOCATE(ss%SFUS_name)

  IF(ALLOCATED(ss%sfus_to_all)) DEALLOCATE(ss%sfus_to_all)

  IF(ALLOCATED(ss%sfus_to_alla)) DEALLOCATE(ss%sfus_to_alla)

  IF(ALLOCATED(ss%SFUS_type)) DEALLOCATE(ss%SFUS_type)

  IF(ALLOCATED(ss%SGAS_name)) DEALLOCATE(ss%SGAS_name)

  IF(ALLOCATED(ss%sgas_to_s)) DEALLOCATE(ss%sgas_to_s)

  IF(ALLOCATED(ss%SGAS_type)) DEALLOCATE(ss%SGAS_type)

  IF(ALLOCATED(ss%id_sii_xs)) DEALLOCATE(ss%id_sii_xs)
  IF(ALLOCATED(ss%sii_xs)) DEALLOCATE(ss%sii_xs)

  IF(ALLOCATED(ss%SIMP0_name)) DEALLOCATE(ss%SIMP0_name)

  IF(ALLOCATED(ss%simp0_to_s)) DEALLOCATE(ss%simp0_to_s)

  IF(ALLOCATED(ss%SIMP0_type)) DEALLOCATE(ss%SIMP0_type)

  IF(ALLOCATED(ss%SIMPI_name)) DEALLOCATE(ss%SIMPI_name)

  IF(ALLOCATED(ss%simpi_to_s)) DEALLOCATE(ss%simpi_to_s)

  IF(ALLOCATED(ss%SIMPI_type)) DEALLOCATE(ss%SIMPI_type)

  IF(ALLOCATED(ss%SNBI_name)) DEALLOCATE(ss%SNBI_name)

  IF(ALLOCATED(ss%snbi_to_all)) DEALLOCATE(ss%snbi_to_all)

  IF(ALLOCATED(ss%snbi_to_alla)) DEALLOCATE(ss%snbi_to_alla)

  IF(ALLOCATED(ss%SNBI_type)) DEALLOCATE(ss%SNBI_type)

  IF(ALLOCATED(ss%id_sn_trans)) DEALLOCATE(ss%id_sn_trans)
  IF(ALLOCATED(ss%sn_trans)) DEALLOCATE(ss%sn_trans)

  IF(ALLOCATED(ss%id_sn_transcat)) DEALLOCATE(ss%id_sn_transcat)
  IF(ALLOCATED(ss%sn_transcat)) DEALLOCATE(ss%sn_transcat)

  IF(ALLOCATED(ss%id_sprof0)) DEALLOCATE(ss%id_sprof0)
  IF(ALLOCATED(ss%sprof0)) DEALLOCATE(ss%sprof0)

  IF(ALLOCATED(ss%id_sprof0e)) DEALLOCATE(ss%id_sprof0e)
  IF(ALLOCATED(ss%sprof0e)) DEALLOCATE(ss%sprof0e)

  IF(ALLOCATED(ss%id_spsce)) DEALLOCATE(ss%id_spsce)
  IF(ALLOCATED(ss%spsce)) DEALLOCATE(ss%spsce)

  IF(ALLOCATED(ss%squareLO)) DEALLOCATE(ss%squareLO)

  IF(ALLOCATED(ss%squareUO)) DEALLOCATE(ss%squareUO)

  IF(ALLOCATED(ss%sRtcen)) DEALLOCATE(ss%sRtcen)

  IF(ALLOCATED(ss%surf)) DEALLOCATE(ss%surf)

  IF(ALLOCATED(ss%S_name)) DEALLOCATE(ss%S_name)

  IF(ALLOCATED(ss%s_to_sa)) DEALLOCATE(ss%s_to_sa)

  IF(ALLOCATED(ss%S_type)) DEALLOCATE(ss%S_type)

  IF(ALLOCATED(ss%id_T0cx)) DEALLOCATE(ss%id_T0cx)
  IF(ALLOCATED(ss%T0cx)) DEALLOCATE(ss%T0cx)

  IF(ALLOCATED(ss%id_T0sc0)) DEALLOCATE(ss%id_T0sc0)
  IF(ALLOCATED(ss%T0sc0)) DEALLOCATE(ss%T0sc0)

  IF(ALLOCATED(ss%id_T0_halo)) DEALLOCATE(ss%id_T0_halo)
  IF(ALLOCATED(ss%T0_halo)) DEALLOCATE(ss%T0_halo)

  IF(ALLOCATED(ss%id_T0_reco)) DEALLOCATE(ss%id_T0_reco)
  IF(ALLOCATED(ss%T0_reco)) DEALLOCATE(ss%T0_reco)

  IF(ALLOCATED(ss%id_teflux_ky_tglf)) DEALLOCATE(ss%id_teflux_ky_tglf)
  IF(ALLOCATED(ss%teflux_ky_tglf)) DEALLOCATE(ss%teflux_ky_tglf)

  IF(ALLOCATED(ss%id_te_ky_tglf)) DEALLOCATE(ss%id_te_ky_tglf)
  IF(ALLOCATED(ss%te_ky_tglf)) DEALLOCATE(ss%te_ky_tglf)

  IF(ALLOCATED(ss%tfrip2_log)) DEALLOCATE(ss%tfrip2_log)

  IF(ALLOCATED(ss%tfrip_log)) DEALLOCATE(ss%tfrip_log)

  IF(ALLOCATED(ss%thegrilh)) DEALLOCATE(ss%thegrilh)

  IF(ALLOCATED(ss%th_eq)) DEALLOCATE(ss%th_eq)

  IF(ALLOCATED(ss%Ti)) DEALLOCATE(ss%Ti)

  IF(ALLOCATED(ss%id_tiflux_ky_tglf)) DEALLOCATE(ss%id_tiflux_ky_tglf)
  IF(ALLOCATED(ss%tiflux_ky_tglf)) DEALLOCATE(ss%tiflux_ky_tglf)

  IF(ALLOCATED(ss%id_ti_ky_tglf)) DEALLOCATE(ss%id_ti_ky_tglf)
  IF(ALLOCATED(ss%ti_ky_tglf)) DEALLOCATE(ss%ti_ky_tglf)

  IF(ALLOCATED(ss%tmodel)) DEALLOCATE(ss%tmodel)

  IF(ALLOCATED(ss%Tornum_balcrit)) DEALLOCATE(ss%Tornum_balcrit)

  IF(ALLOCATED(ss%Tor_mode_label)) DEALLOCATE(ss%Tor_mode_label)

  IF(ALLOCATED(ss%Tor_mode_No)) DEALLOCATE(ss%Tor_mode_No)

  IF(ALLOCATED(ss%tq0_reco)) DEALLOCATE(ss%tq0_reco)

  IF(ALLOCATED(ss%tqb0_halo)) DEALLOCATE(ss%tqb0_halo)

  IF(ALLOCATED(ss%tqbe)) DEALLOCATE(ss%tqbe)

  IF(ALLOCATED(ss%tqbi)) DEALLOCATE(ss%tqbi)

  IF(ALLOCATED(ss%tqbjxb)) DEALLOCATE(ss%tqbjxb)

  IF(ALLOCATED(ss%tqbth)) DEALLOCATE(ss%tqbth)

  IF(ALLOCATED(ss%tqcx_halo)) DEALLOCATE(ss%tqcx_halo)

  IF(ALLOCATED(ss%tqcx_reco)) DEALLOCATE(ss%tqcx_reco)

  IF(ALLOCATED(ss%id_tqioniz)) DEALLOCATE(ss%id_tqioniz)
  IF(ALLOCATED(ss%tqioniz)) DEALLOCATE(ss%tqioniz)

  IF(ALLOCATED(ss%id_tqqcx)) DEALLOCATE(ss%id_tqqcx)
  IF(ALLOCATED(ss%tqqcx)) DEALLOCATE(ss%tqqcx)

  IF(ALLOCATED(ss%tqsc_halo)) DEALLOCATE(ss%tqsc_halo)

  IF(ALLOCATED(ss%tqsc_reco)) DEALLOCATE(ss%tqsc_reco)

  IF(ALLOCATED(ss%tq_anom)) DEALLOCATE(ss%tq_anom)

  IF(ALLOCATED(ss%tq_trans)) DEALLOCATE(ss%tq_trans)

  IF(ALLOCATED(ss%id_tq_transcat)) DEALLOCATE(ss%id_tq_transcat)
  IF(ALLOCATED(ss%tq_transcat)) DEALLOCATE(ss%tq_transcat)

  IF(ALLOCATED(ss%trace_flag)) DEALLOCATE(ss%trace_flag)

  IF(ALLOCATED(ss%trcat)) DEALLOCATE(ss%trcat)

  IF(ALLOCATED(ss%triang)) DEALLOCATE(ss%triang)

  IF(ALLOCATED(ss%triangL)) DEALLOCATE(ss%triangL)

  IF(ALLOCATED(ss%triangU)) DEALLOCATE(ss%triangU)

  IF(ALLOCATED(ss%triang_miller_L)) DEALLOCATE(ss%triang_miller_L)

  IF(ALLOCATED(ss%triang_miller_U)) DEALLOCATE(ss%triang_miller_U)

  IF(ALLOCATED(ss%trmodels)) DEALLOCATE(ss%trmodels)

  IF(ALLOCATED(ss%id_Ts)) DEALLOCATE(ss%id_Ts)
  IF(ALLOCATED(ss%Ts)) DEALLOCATE(ss%Ts)

  IF(ALLOCATED(ss%Ts_is_input)) DEALLOCATE(ss%Ts_is_input)

  IF(ALLOCATED(ss%id_tzflux_ky_tglf)) DEALLOCATE(ss%id_tzflux_ky_tglf)
  IF(ALLOCATED(ss%tzflux_ky_tglf)) DEALLOCATE(ss%tzflux_ky_tglf)

  IF(ALLOCATED(ss%id_tz_ky_tglf)) DEALLOCATE(ss%id_tz_ky_tglf)
  IF(ALLOCATED(ss%tz_ky_tglf)) DEALLOCATE(ss%tz_ky_tglf)

  IF(ALLOCATED(ss%T_einj_standard)) DEALLOCATE(ss%T_einj_standard)

  IF(ALLOCATED(ss%T_ffull_standard)) DEALLOCATE(ss%T_ffull_standard)

  IF(ALLOCATED(ss%T_fhalf_standard)) DEALLOCATE(ss%T_fhalf_standard)

  IF(ALLOCATED(ss%id_upwind_pfrac_ns)) DEALLOCATE(ss%id_upwind_pfrac_ns)
  IF(ALLOCATED(ss%upwind_pfrac_ns)) DEALLOCATE(ss%upwind_pfrac_ns)

  IF(ALLOCATED(ss%upwind_pfrac_omega)) DEALLOCATE(ss%upwind_pfrac_omega)

  IF(ALLOCATED(ss%upwind_pfrac_Te)) DEALLOCATE(ss%upwind_pfrac_Te)

  IF(ALLOCATED(ss%upwind_pfrac_Ti)) DEALLOCATE(ss%upwind_pfrac_Ti)

  IF(ALLOCATED(ss%vee_trans)) DEALLOCATE(ss%vee_trans)

  IF(ALLOCATED(ss%id_vee_transcat)) DEALLOCATE(ss%id_vee_transcat)
  IF(ALLOCATED(ss%vee_transcat)) DEALLOCATE(ss%vee_transcat)

  IF(ALLOCATED(ss%velb_fusi)) DEALLOCATE(ss%velb_fusi)

  IF(ALLOCATED(ss%velb_nbi)) DEALLOCATE(ss%velb_nbi)

  IF(ALLOCATED(ss%velb_rfmi)) DEALLOCATE(ss%velb_rfmi)

  IF(ALLOCATED(ss%velne_nclass)) DEALLOCATE(ss%velne_nclass)

  IF(ALLOCATED(ss%velnh_nclass)) DEALLOCATE(ss%velnh_nclass)

  IF(ALLOCATED(ss%velni_drbm)) DEALLOCATE(ss%velni_drbm)

  IF(ALLOCATED(ss%id_velns_anom)) DEALLOCATE(ss%id_velns_anom)
  IF(ALLOCATED(ss%velns_anom)) DEALLOCATE(ss%velns_anom)

  IF(ALLOCATED(ss%id_velns_glf)) DEALLOCATE(ss%id_velns_glf)
  IF(ALLOCATED(ss%velns_glf)) DEALLOCATE(ss%velns_glf)

  IF(ALLOCATED(ss%id_velns_gtcneo)) DEALLOCATE(ss%id_velns_gtcneo)
  IF(ALLOCATED(ss%velns_gtcneo)) DEALLOCATE(ss%velns_gtcneo)

  IF(ALLOCATED(ss%id_velns_mmm71)) DEALLOCATE(ss%id_velns_mmm71)
  IF(ALLOCATED(ss%velns_mmm71)) DEALLOCATE(ss%velns_mmm71)

  IF(ALLOCATED(ss%id_velns_nclass)) DEALLOCATE(ss%id_velns_nclass)
  IF(ALLOCATED(ss%velns_nclass)) DEALLOCATE(ss%velns_nclass)

  IF(ALLOCATED(ss%id_velns_neo)) DEALLOCATE(ss%id_velns_neo)
  IF(ALLOCATED(ss%velns_neo)) DEALLOCATE(ss%velns_neo)

  IF(ALLOCATED(ss%id_velns_tglf)) DEALLOCATE(ss%id_velns_tglf)
  IF(ALLOCATED(ss%velns_tglf)) DEALLOCATE(ss%velns_tglf)

  IF(ALLOCATED(ss%velnx_nclass)) DEALLOCATE(ss%velnx_nclass)

  IF(ALLOCATED(ss%velpphi_anom)) DEALLOCATE(ss%velpphi_anom)

  IF(ALLOCATED(ss%velpphi_glf)) DEALLOCATE(ss%velpphi_glf)

  IF(ALLOCATED(ss%velpphi_gtcneo)) DEALLOCATE(ss%velpphi_gtcneo)

  IF(ALLOCATED(ss%velpphi_mmm71)) DEALLOCATE(ss%velpphi_mmm71)

  IF(ALLOCATED(ss%velpphi_neo)) DEALLOCATE(ss%velpphi_neo)

  IF(ALLOCATED(ss%velpphi_tglf)) DEALLOCATE(ss%velpphi_tglf)

  IF(ALLOCATED(ss%velte_anom)) DEALLOCATE(ss%velte_anom)

  IF(ALLOCATED(ss%velte_glf)) DEALLOCATE(ss%velte_glf)

  IF(ALLOCATED(ss%velte_gtcneo)) DEALLOCATE(ss%velte_gtcneo)

  IF(ALLOCATED(ss%velte_mmm71)) DEALLOCATE(ss%velte_mmm71)

  IF(ALLOCATED(ss%velte_nclass)) DEALLOCATE(ss%velte_nclass)

  IF(ALLOCATED(ss%velte_neo)) DEALLOCATE(ss%velte_neo)

  IF(ALLOCATED(ss%velte_paleo)) DEALLOCATE(ss%velte_paleo)

  IF(ALLOCATED(ss%velte_tglf)) DEALLOCATE(ss%velte_tglf)

  IF(ALLOCATED(ss%velti_anom)) DEALLOCATE(ss%velti_anom)

  IF(ALLOCATED(ss%velti_glf)) DEALLOCATE(ss%velti_glf)

  IF(ALLOCATED(ss%velti_gtcneo)) DEALLOCATE(ss%velti_gtcneo)

  IF(ALLOCATED(ss%velti_mmm71)) DEALLOCATE(ss%velti_mmm71)

  IF(ALLOCATED(ss%velti_nclass)) DEALLOCATE(ss%velti_nclass)

  IF(ALLOCATED(ss%velti_neo)) DEALLOCATE(ss%velti_neo)

  IF(ALLOCATED(ss%velti_tglf)) DEALLOCATE(ss%velti_tglf)

  IF(ALLOCATED(ss%vie_trans)) DEALLOCATE(ss%vie_trans)

  IF(ALLOCATED(ss%id_vie_transcat)) DEALLOCATE(ss%id_vie_transcat)
  IF(ALLOCATED(ss%vie_transcat)) DEALLOCATE(ss%vie_transcat)

  IF(ALLOCATED(ss%vmo_trans)) DEALLOCATE(ss%vmo_trans)

  IF(ALLOCATED(ss%id_vmo_transcat)) DEALLOCATE(ss%id_vmo_transcat)
  IF(ALLOCATED(ss%vmo_transcat)) DEALLOCATE(ss%vmo_transcat)

  IF(ALLOCATED(ss%id_vn_trans)) DEALLOCATE(ss%id_vn_trans)
  IF(ALLOCATED(ss%vn_trans)) DEALLOCATE(ss%vn_trans)

  IF(ALLOCATED(ss%id_vn_transcat)) DEALLOCATE(ss%id_vn_transcat)
  IF(ALLOCATED(ss%vn_transcat)) DEALLOCATE(ss%vn_transcat)

  IF(ALLOCATED(ss%vol)) DEALLOCATE(ss%vol)

  IF(ALLOCATED(ss%vphi0_av)) DEALLOCATE(ss%vphi0_av)

  IF(ALLOCATED(ss%id_vpol_inmp)) DEALLOCATE(ss%id_vpol_inmp)
  IF(ALLOCATED(ss%vpol_inmp)) DEALLOCATE(ss%vpol_inmp)

  IF(ALLOCATED(ss%vpol_is_input)) DEALLOCATE(ss%vpol_is_input)

  IF(ALLOCATED(ss%id_vpol_omp)) DEALLOCATE(ss%id_vpol_omp)
  IF(ALLOCATED(ss%vpol_omp)) DEALLOCATE(ss%vpol_omp)

  IF(ALLOCATED(ss%VRep_coil_count)) DEALLOCATE(ss%VRep_coil_count)

  IF(ALLOCATED(ss%Vrep_coil_spacing)) DEALLOCATE(ss%Vrep_coil_spacing)

  IF(ALLOCATED(ss%Vsize_coil)) DEALLOCATE(ss%Vsize_coil)

  IF(ALLOCATED(ss%id_vtor_inmp)) DEALLOCATE(ss%id_vtor_inmp)
  IF(ALLOCATED(ss%vtor_inmp)) DEALLOCATE(ss%vtor_inmp)

  IF(ALLOCATED(ss%vtor_is_input)) DEALLOCATE(ss%vtor_is_input)

  IF(ALLOCATED(ss%id_vtor_omp)) DEALLOCATE(ss%id_vtor_omp)
  IF(ALLOCATED(ss%vtor_omp)) DEALLOCATE(ss%vtor_omp)

  IF(ALLOCATED(ss%V_loop)) DEALLOCATE(ss%V_loop)

  IF(ALLOCATED(ss%id_v_pars)) DEALLOCATE(ss%id_v_pars)
  IF(ALLOCATED(ss%v_pars)) DEALLOCATE(ss%v_pars)

  IF(ALLOCATED(ss%id_v_pers)) DEALLOCATE(ss%id_v_pers)
  IF(ALLOCATED(ss%v_pers)) DEALLOCATE(ss%v_pers)

  IF(ALLOCATED(ss%wt_nphi)) DEALLOCATE(ss%wt_nphi)

  IF(ALLOCATED(ss%wt_nphi_abs)) DEALLOCATE(ss%wt_nphi_abs)

  IF(ALLOCATED(ss%wt_nphi_ext)) DEALLOCATE(ss%wt_nphi_ext)

  IF(ALLOCATED(ss%id_xRjcos_momeq)) DEALLOCATE(ss%id_xRjcos_momeq)
  IF(ALLOCATED(ss%xRjcos_momeq)) DEALLOCATE(ss%xRjcos_momeq)

  IF(ALLOCATED(ss%id_xRjsin_momeq)) DEALLOCATE(ss%id_xRjsin_momeq)
  IF(ALLOCATED(ss%xRjsin_momeq)) DEALLOCATE(ss%xRjsin_momeq)

  IF(ALLOCATED(ss%xs)) DEALLOCATE(ss%xs)

  IF(ALLOCATED(ss%xs_name)) DEALLOCATE(ss%xs_name)

  IF(ALLOCATED(ss%id_xZjcos_momeq)) DEALLOCATE(ss%id_xZjcos_momeq)
  IF(ALLOCATED(ss%xZjcos_momeq)) DEALLOCATE(ss%xZjcos_momeq)

  IF(ALLOCATED(ss%id_xZjsin_momeq)) DEALLOCATE(ss%id_xZjsin_momeq)
  IF(ALLOCATED(ss%xZjsin_momeq)) DEALLOCATE(ss%xZjsin_momeq)

  IF(ALLOCATED(ss%Z0_momeq)) DEALLOCATE(ss%Z0_momeq)

  IF(ALLOCATED(ss%Zbap)) DEALLOCATE(ss%Zbap)

  IF(ALLOCATED(ss%Zbsc)) DEALLOCATE(ss%Zbsc)

  IF(ALLOCATED(ss%Zeff)) DEALLOCATE(ss%Zeff)

  IF(ALLOCATED(ss%Zeff_fi)) DEALLOCATE(ss%Zeff_fi)

  IF(ALLOCATED(ss%Zeff_th)) DEALLOCATE(ss%Zeff_th)

  IF(ALLOCATED(ss%zlim)) DEALLOCATE(ss%zlim)

  IF(ALLOCATED(ss%Zloc_coil)) DEALLOCATE(ss%Zloc_coil)

  IF(ALLOCATED(ss%Z_ant)) DEALLOCATE(ss%Z_ant)

  IF(ALLOCATED(ss%Z_antgeo)) DEALLOCATE(ss%Z_antgeo)

  IF(ALLOCATED(ss%Z_EC_launch)) DEALLOCATE(ss%Z_EC_launch)

  IF(ALLOCATED(ss%Z_geo)) DEALLOCATE(ss%Z_geo)

  IF(ALLOCATED(ss%Z_grid)) DEALLOCATE(ss%Z_grid)

  IF(ALLOCATED(ss%Z_midp)) DEALLOCATE(ss%Z_midp)

  IF(ALLOCATED(ss%Z_mid_ant)) DEALLOCATE(ss%Z_mid_ant)

  IF(ALLOCATED(ss%Z_ripple)) DEALLOCATE(ss%Z_ripple)

  IF(ALLOCATED(ss%Z_surfMax)) DEALLOCATE(ss%Z_surfMax)

  IF(ALLOCATED(ss%Z_surfMin)) DEALLOCATE(ss%Z_surfMin)


END SUBROUTINE plasma_state_free

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_c5_dummy
     return
  end subroutine ccps_getset_c5_dummy

subroutine psget_chii_transcat(iobj, n1, n2, data, ierr)
    !! Ion energy diffusivity
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_chii_transcat', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % chii_transcat
end subroutine psget_chii_transcat


subroutine psset_chii_transcat(iobj, n1, n2, data, ierr)
    !! Ion energy diffusivity
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_chii_transcat', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % chii_transcat = data(1:n1, 1: n2)
end subroutine psset_chii_transcat


subroutine psgetrnk_chii_transcat(iobj, ndims, ierr)
    !! Ion energy diffusivity
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_chii_transcat


subroutine psgetdim_chii_transcat(iobj, ndims, dims, ierr)
    !! Ion energy diffusivity
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_chii_transcat', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % chii_transcat ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % chii_transcat)
    endif
end subroutine psgetdim_chii_transcat


subroutine psget_curmino(iobj, n1, data, ierr)
    !! minority ion driven cur (shielded).
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_curmino', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % curmino
end subroutine psget_curmino


subroutine psset_curmino(iobj, n1, data, ierr)
    !! minority ion driven cur (shielded).
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_curmino', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % curmino = data(1:n1)
end subroutine psset_curmino


subroutine psgetrnk_curmino(iobj, ndims, ierr)
    !! minority ion driven cur (shielded).
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_curmino


subroutine psgetdim_curmino(iobj, ndims, dims, ierr)
    !! minority ion driven cur (shielded).
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_curmino', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % curmino ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % curmino)
    endif
end subroutine psgetdim_curmino


subroutine psget_curech_src(iobj, n1, n2, data, ierr)
    !! ECH current drive (by antenna)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_curech_src', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % curech_src
end subroutine psget_curech_src


subroutine psset_curech_src(iobj, n1, n2, data, ierr)
    !! ECH current drive (by antenna)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_curech_src', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % curech_src = data(1:n1, 1: n2)
end subroutine psset_curech_src


subroutine psgetrnk_curech_src(iobj, ndims, ierr)
    !! ECH current drive (by antenna)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_curech_src


subroutine psgetdim_curech_src(iobj, ndims, dims, ierr)
    !! ECH current drive (by antenna)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_curech_src', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % curech_src ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % curech_src)
    endif
end subroutine psgetdim_curech_src


subroutine psget_chiphi_tglf(iobj, n1, data, ierr)
    !! momentum-equation, diffusivity from TGLF model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_chiphi_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % chiphi_tglf
end subroutine psget_chiphi_tglf


subroutine psset_chiphi_tglf(iobj, n1, data, ierr)
    !! momentum-equation, diffusivity from TGLF model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_chiphi_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % chiphi_tglf = data(1:n1)
end subroutine psset_chiphi_tglf


subroutine psgetrnk_chiphi_tglf(iobj, ndims, ierr)
    !! momentum-equation, diffusivity from TGLF model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_chiphi_tglf


subroutine psgetdim_chiphi_tglf(iobj, ndims, dims, ierr)
    !! momentum-equation, diffusivity from TGLF model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_chiphi_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % chiphi_tglf ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % chiphi_tglf)
    endif
end subroutine psgetdim_chiphi_tglf


subroutine psget_chie_drbm(iobj, n1, data, ierr)
    !! Te-equation, diffusivity term
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_chie_drbm', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % chie_drbm
end subroutine psget_chie_drbm


subroutine psset_chie_drbm(iobj, n1, data, ierr)
    !! Te-equation, diffusivity term
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_chie_drbm', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % chie_drbm = data(1:n1)
end subroutine psset_chie_drbm


subroutine psgetrnk_chie_drbm(iobj, ndims, ierr)
    !! Te-equation, diffusivity term
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_chie_drbm


subroutine psgetdim_chie_drbm(iobj, ndims, dims, ierr)
    !! Te-equation, diffusivity term
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_chie_drbm', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % chie_drbm ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % chie_drbm)
    endif
end subroutine psgetdim_chie_drbm


subroutine psget_chie_mtm(iobj, n1, data, ierr)
    !! Te-equation, thermal diffusivity term MTM model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_chie_mtm', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % chie_mtm
end subroutine psget_chie_mtm


subroutine psset_chie_mtm(iobj, n1, data, ierr)
    !! Te-equation, thermal diffusivity term MTM model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_chie_mtm', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % chie_mtm = data(1:n1)
end subroutine psset_chie_mtm


subroutine psgetrnk_chie_mtm(iobj, ndims, ierr)
    !! Te-equation, thermal diffusivity term MTM model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_chie_mtm


subroutine psgetdim_chie_mtm(iobj, ndims, dims, ierr)
    !! Te-equation, thermal diffusivity term MTM model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_chie_mtm', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % chie_mtm ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % chie_mtm)
    endif
end subroutine psgetdim_chie_mtm

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


MODULE plasma_state_constants_mod

  ! plasma_state header:

  use swim_global_data_mod, only: rspec, swim_err_out_file, swim_error
  implicit NONE


  PRIVATE

  !--------------------------------------------
  !
  !  PLASMA STATE MODULE -- CONSTANTS (PARAMETER statements)
  !
  !--------------------------------------------

  CHARACTER*32, PARAMETER, PUBLIC :: ps_version_id = "2.055"


  !---------------------------------------
  ! module parameters (constants):


  REAL(KIND=rspec), PARAMETER, PUBLIC :: ps_me = 9.1094e-31_rspec
         ! electron mass, kg

  REAL(KIND=rspec), PARAMETER, PUBLIC :: ps_mp = 1.6726e-27_rspec
         ! proton mass, kg

  REAL(KIND=rspec), PARAMETER, PUBLIC :: ps_xe = 1.6022e-19_rspec
         ! Joule/ptcl-eV (also, electron charge)

  REAL(KIND=rspec), PARAMETER, PUBLIC :: ps_epslon = 1.0e-34_rspec
         ! small number

  REAL(KIND=rspec), PARAMETER, PUBLIC :: ps_epsinv = 1.0e+34_rspec
         ! large number

  REAL(KIND=rspec), PARAMETER, PUBLIC :: ps_pi = 3.1415926535897931_rspec
         ! pi

  REAL(KIND=rspec), PARAMETER, PUBLIC :: ps_twopi = 6.2831853071795862_rspec
         ! 2*pi

  REAL(KIND=rspec), PARAMETER, PUBLIC :: ps_zero = 0.0_rspec
         ! Zero

  REAL(KIND=rspec), PARAMETER, PUBLIC :: ps_one = 1.0_rspec
         ! one

  REAL(KIND=rspec), PARAMETER, PUBLIC :: ps_two = 2.0_rspec
         ! two

  REAL(KIND=rspec), PARAMETER, PUBLIC :: ps_three = 3.0_rspec
         ! three

  REAL(KIND=rspec), PARAMETER, PUBLIC :: ps_half = 0.5_rspec
         ! one-half

  REAL(KIND=rspec), PARAMETER, PUBLIC :: ps_onethird = 0.3333333333333333_rspec
         ! one-third

  REAL(KIND=rspec), PARAMETER, PUBLIC :: ps_twothird = 0.6666666666666667_rspec
         ! two-third

  REAL(KIND=rspec), PARAMETER, PUBLIC :: ps_mu0 = 1.2566e-6_rspec
         ! mu0

  INTEGER, PARAMETER, PUBLIC :: ps_electron = -1

  INTEGER, PARAMETER, PUBLIC :: ps_therm_ion = 1

  INTEGER, PARAMETER, PUBLIC :: ps_impurity = 2

  INTEGER, PARAMETER, PUBLIC :: ps_tokamakium = 3

  INTEGER, PARAMETER, PUBLIC :: ps_beam_ion = 4

  INTEGER, PARAMETER, PUBLIC :: ps_rf_minority = 5

  INTEGER, PARAMETER, PUBLIC :: ps_fusion_ion = 6

  INTEGER, PARAMETER, PUBLIC :: ps_elec_index = 0

  INTEGER, PARAMETER, PUBLIC :: ps_ccw_select = 1
         ! used as indicator of counter-clockwise oriented theta

  INTEGER, PARAMETER, PUBLIC :: ps_ccw_reverse = 2
         ! used as indicator of clockwise oriented theta

  INTEGER, PARAMETER, PUBLIC :: ps_stepdv = -3
         ! step function *dV in plasma state object

  INTEGER, PARAMETER, PUBLIC :: ps_stepda = -2
         ! step function *dA in plasma state object

  INTEGER, PARAMETER, PUBLIC :: ps_stepfun = -1
         ! step function

  INTEGER, PARAMETER, PUBLIC :: ps_pclin = 0
         ! piecewise linear function

  INTEGER, PARAMETER, PUBLIC :: ps_hermite = 1
         ! Hermite cubic interpolant

  INTEGER, PARAMETER, PUBLIC :: ps_spline = 2
         ! Cubic spline interpolant

  INTEGER, PARAMETER, PUBLIC :: ps_bc_dflt = -1
         ! Default boundary condition: "not a knot" for splines

  INTEGER, PARAMETER, PUBLIC :: ps_bc_grad00 = 0
         ! d/drho -> 0 as rho -> 0

  INTEGER, PARAMETER, PUBLIC :: ps_bc_xxx = 99
         ! This indicates Hermite item with all explicit nodal
         ! derivitaves as input

  INTEGER, PARAMETER, PUBLIC :: ps_uninit = -123456789
         ! value for un-initialized integer scalars

  INTEGER, PARAMETER, PUBLIC :: ps_components = 1

  INTEGER, PARAMETER, PUBLIC :: ps_array_dims = 2

  INTEGER, PARAMETER, PUBLIC :: ps_species_lists = 3

  INTEGER, PARAMETER, PUBLIC :: ps_data_sets = 4

  INTEGER, PARAMETER, PUBLIC :: ps_profile_sets = 5

  INTEGER, PARAMETER, PUBLIC :: ps_data = 6

  INTEGER, PARAMETER, PUBLIC :: ps_profiles = 7

  INTEGER, PARAMETER, PUBLIC :: ps_item_lists = 8

  INTEGER, PARAMETER, PUBLIC :: ps_grid_dims = 9

  INTEGER, PARAMETER, PUBLIC :: ps_machine_descr = 10

  INTEGER, PARAMETER, PUBLIC :: ps_shot_config = 11

  INTEGER, PARAMETER, PUBLIC :: ps_sim_control = 12

  INTEGER, PARAMETER, PUBLIC :: ps_enum_dims = 13

  INTEGER, PARAMETER, PUBLIC :: ps_unlocked = 0

  INTEGER, PARAMETER, PUBLIC :: ps_monitor = 1

  INTEGER, PARAMETER, PUBLIC :: ps_locked = 2

  INTEGER, PARAMETER, PUBLIC :: ps_nocheck = 0
         ! skip hash checks

  INTEGER, PARAMETER, PUBLIC :: ps_chkall = 1
         ! check profiles & dimensions & scalars

  INTEGER, PARAMETER, PUBLIC :: ps_chkprofs = 2
         ! check profiles & dimensions; skip scalars

  INTEGER, PARAMETER, PUBLIC :: ps_stable = 0
         ! constant indicating a stable linear MHD mode

  INTEGER, PARAMETER, PUBLIC :: ps_normal = 0
         ! LMHD code exit status: normal

  INTEGER, PARAMETER, PUBLIC :: ps_eqfail = 1
         ! LMHD code exit status: equilibrium refinement failed

  INTEGER, PARAMETER, PUBLIC :: ps_mapfail = 2
         ! LMHD code exit status: mapper failed
         ! >2 may indicate various failures peculiar to each LMHD code itself

  INTEGER, PARAMETER, PUBLIC :: ps_max_static = 500

  INTEGER, PARAMETER, PUBLIC :: ps_max_static_2d = 128

  !---------------------------------------
  ! CCW parameters (constants):

  INTEGER, PARAMETER, PUBLIC :: ps_ccw_nth_eq = ps_ccw_select

END MODULE plasma_state_constants_mod

subroutine ccps_intrp_1d_single(iobj,id,ideriv,xval,result,ierr)

  ! interpolate a 1d state element profile at a single point

  use plasma_state_mod
  implicit NONE

  integer :: iobj(*)        ! (ps_container_size) words are used
  integer, intent(in) :: id ! profile ID
  integer, intent(in) :: ideriv   ! 0 for value, 1 for d/dx, 2 for d2/dx2
  ! which are supported depends on profile interpolation method

  REAL(kind=rspec), intent(in) :: xval  ! value at which to interpolate

  REAL(kind=rspec), intent(out) :: result  ! interpolated value returned.

  integer, intent(out) :: ierr    ! status code returned, 0=normal

  !--------------------------------
  type (plasma_state_container) :: ptr
  type (plasma_state), pointer :: ss
  !--------------------------------

  call ccps_argcheck('ccps_intrp_1d_single',iobj,ierr)
  if(ierr.ne.0) return

  ! proceed...

  call load_ps_container(iobj,ptr)
  ss => ptr%ps_ptr

  call ps_intrp_1d(xval,id,result,ierr, state=ss, ideriv=ideriv)

end subroutine ccps_intrp_1d_single

subroutine ur_cstate_grids

  ! examine grids contained in the state(s)

  use cstate_lib_mod
  implicit NONE

  !-------------------------
  ! local

  integer :: luntty,lnout
  logical :: lxout,lchar,lyes
  integer :: isize,ierr,i,ii,inum,imatch_cur,inmax,insel
  integer :: inums(nsss_cur),iself(nsss_cur)

  character*32 :: slbls(nsss_cur)
  character*32 :: ztest,gname

  real*8, dimension(:,:), allocatable :: xxindx,yygrid
  real*8 :: zz(nsss_cur)

  !-------------------------

  luntty = lnout(0)

  call psw_contents('G',ncur_components,wgrid,ierr, state=sss(1))
  isize = wgrid%size

  call clone_window(wgrid,w1)
  
  do
     if(lxout(0)) then
        write(luntty,1001) omit_empty,trim(cur_components)

1001    format(/'ur_cstate_grids options:'/ &
             '  A -- option to omit empty elements from display (',L1,')'/ &
             '  C -- select & restrict view to component(s) (current selection: ',a,')'/ &
             '  T -- grid table of contents & descriptions'/ &
             '  D -- summary comparitive display of grids'/ &
             '  S -- select a single grid for comparitive plot'/ &
             '  L -- modify state label(s)'/ &
             '  Q -- quit this menu'/)
     endif
     call uread('ur_cstate_grids option:')

     if(lchar('Q')) then
        exit

     else if(lchar('A')) then
        if(lxout(0)) write(luntty,*) &
             ' option to omit display of elements that are empty in all states.'

        call uread('omit empty elements ? (Y/N):')
        omit_empty = lyes(0)

     else if(lchar('C')) then
        call ur_cstate_component

     else if(lchar('L')) then
        call ur_cstate_setLabel

     else if(lchar('T')) then
        call ur_cstate_grid_contents

     else if(lchar('D')) then
        call ur_dcomp_display('G', 'Grid_sizes', 'grids')

     else if(lchar('S')) then
        if(lxout(0)) then
           write(luntty,*) '(unambiguous prefix of name may be entered).'
        endif
        call ureadw('enter grid name or "Q" to skip:',gname)
        if(gname.eq.'Q') cycle
        if(gname.eq.'.') cycle

        call cstate_findm(gname,luntty,imatch_cur)
        if(imatch_cur.eq.0) then
           call uclear
           cycle
        endif

        ! find max grid size in selection
        inmax=0
        insel=0
        do i=1,nsss_cur
           call psw_contents('G',ncur_components,ww(i),ierr, state=sss(i))
           zz(i) = i
           inum = ww(i)%ival(imatch_cur)
           if(inum.gt.0) then
              insel=insel+1
              iself(insel) = i
              inums(insel) = inum
              inmax=max(inmax,inum)
              slbls(insel) = sss_label(i)
           else
              write(luntty,*) ' %grid not present for state: ', &
                   trim(sss_label(i))
           endif
        enddo
        if(insel.eq.0) then
           write(luntty,*) ' %grid not present.'
           cycle
        endif
        iself(1) = -iself(1)  ! signals not an (R,Z) contour plot...

        allocate(xxindx(inmax,nsss_cur),yygrid(inmax,nsss_cur))

        do i=1,nsss_cur
           do ii=1,inmax
              xxindx(ii,i)=ii
           enddo

           inum = ww(i)%ival(imatch_cur)
           if(inum.gt.0) then
              call ps_get_grid_by_name(gname, ierr, &
                   state = sss(i), gdata=yygrid(1:inmax,i))
           else
              yygrid(1:inmax,i) = 0.0d0
           endif
        enddo

        !  plot the grids...

        kylab = ' '
        kylab(1) = '  state'
        kylab(2) = 'identification'

        mnlab(2:3) = ' '
        mnlab(2) = 'plot of '//trim(gname)//' grid, vs. grid point index.'
        call ur_cstate_mnlab3(insel,nsss_cur-insel)

        call r8_grfmm1(xxindx,yygrid,inmax,inums,nsss_cur,zz,nsss_cur, &
             iself,insel,'index',gname,mnlab,kylab,slbls)
        
        deallocate(xxindx,yygrid)

     else
        call uermsg(' ?ur_cstate_grids: unrecognized option.',' ',0)
     endif
  enddo

end subroutine ur_cstate_grids

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


SUBROUTINE ps_update_file_write_def_5(ss,icdf,cclist,nids,iout,iwarn,iertot)


  ! Define updated data

  USE plasma_state_definition_mod
  USE netcdf
  USE ps_nidlist_defn
  IMPLICIT NONE

  TYPE (plasma_state) :: ss  ! state containing array elements to be allocated
  INTEGER, INTENT(IN) :: icdf  ! NetCDF file ID
  INTEGER, INTENT(IN) :: cclist(ps_ccount)  ! component selection
  TYPE (nidlist) :: nids       ! defined dimensions list
  INTEGER, INTENT(IN) :: iout  ! LUN for messages
  INTEGER, INTENT(INOUT) :: iwarn   ! warn count
  INTEGER, INTENT(INOUT) :: iertot  ! error count

  !-------------------
  LOGICAL :: plasma_state_hash_match,ichange

  INTEGER :: varid,pvarid,vvarid,dimid,status,iertmp,iaddr
  INTEGER :: idims(20),indim,ival,ii,ierr
  CHARACTER*80 :: nc_errmsg

  !-------------------

  ierr = 0   ! local

  iaddr = ps_shash_ntf_coils
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ichange) THEN
     IF(cclist(ps_cnum_RIPPLE).NE.1) THEN
        CALL ccwarn("ntf_coils","RIPPLE")
     ELSE
        indim = 0
        CALL define_var("ntf_coils","I",indim,idims, &
               "number of TF coils", &
               "__NONE","RIPPLE","MACHINE_DESCRIPTION", &
               "I ntf_coils")
     ENDIF
  ENDIF

  iaddr = ps_shash_nthinlh
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%nthinlh).AND.ichange) THEN
     IF(cclist(ps_cnum_LH).NE.1) THEN
        CALL ccwarn("nthinlh","LH")
     ELSE
        indim = 0
        IF(nids%nid_dim_max_nspectrumlh_src.EQ.0) THEN
           CALL define_dim(nids%nid_dim_max_nspectrumlh_src,"dim_max_nspectrumlh_src",ss%max_nspectrumlh_src)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_max_nspectrumlh_src
        IF(nids%nid_dim_nlhrf_src.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nlhrf_src,"dim_nlhrf_src",ss%nlhrf_src)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nlhrf_src
        CALL define_var("nthinlh","I",indim,idims, &
               "need description", &
               "__NONE","LH","SHOT_CONFIGURATION", &
               "I nthinlh(nspectrumlh_src(),nlhrf_src)")
     ENDIF
  ENDIF

  iaddr = ps_shash_Nturns
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%Nturns).AND.ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("Nturns","EQ")
     ELSE
        indim = 0
        IF(nids%nid_dim_ncoils.EQ.0) THEN
           CALL define_dim(nids%nid_dim_ncoils,"dim_ncoils",ss%ncoils)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_ncoils
        CALL define_var("Nturns","I",indim,idims, &
               "SIGNED number of conductor turns wrapped in each coil", &
               "__NONE","EQ","MACHINE_DESCRIPTION", &
               "I  Nturns(ncoils)")
     ENDIF
  ENDIF

  iaddr = ps_shash_num_nphi
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%num_nphi).AND.ichange) THEN
     IF(cclist(ps_cnum_IC).NE.1) THEN
        CALL ccwarn("num_nphi","IC")
     ELSE
        indim = 0
        IF(nids%nid_dim_nicrf_src.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nicrf_src,"dim_nicrf_src",ss%nicrf_src)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nicrf_src
        CALL define_var("num_nphi","I",indim,idims, &
               "number of non-zero n_phi values", &
               "__NONE","IC","SHOT_CONFIGURATION", &
               "I|ENUM:nphi  num_nphi(nicrf_src)")
     ENDIF
  ENDIF

  iaddr = ps_shash_num_nphi_vac
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%num_nphi_vac).AND.ichange) THEN
     IF(cclist(ps_cnum_IC).NE.1) THEN
        CALL ccwarn("num_nphi_vac","IC")
     ELSE
        indim = 0
        IF(nids%nid_dim_nicrf_src.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nicrf_src,"dim_nicrf_src",ss%nicrf_src)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nicrf_src
        CALL define_var("num_nphi_vac","I",indim,idims, &
               "number of non-zero n_phi values", &
               "__NONE","IC","SHOT_CONFIGURATION", &
               "I|ENUM num_nphi_vac(nicrf_src)")
     ENDIF
  ENDIF

  iaddr = ps_phash_nzflux_ky_tglf
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%nzflux_ky_tglf).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("nzflux_ky_tglf","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        IF(nids%nid_dim_nky_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nky_anomth,"dim_nky_anomth",ss%nky_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nky_anomth
        CALL define_var("nzflux_ky_tglf","R",indim,idims, &
               "impurity density flux spectrum", &
               "GB","ANOM","STATE_PROFILES", &
               "R|units=GB|pclin nzflux_ky_tglf(nrho_anomth,nky_anomth)")
     ENDIF
  ENDIF

  iaddr = ps_phash_nz_ky_tglf
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%nz_ky_tglf).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("nz_ky_tglf","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        IF(nids%nid_dim_nky_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nky_anomth,"dim_nky_anomth",ss%nky_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nky_anomth
        CALL define_var("nz_ky_tglf","R",indim,idims, &
               "impurity density fluctuation spectrum", &
               "GB","ANOM","STATE_PROFILES", &
               "R|units=GB|pclin nz_ky_tglf(nrho_anomth,nky_anomth)")
     ENDIF
  ENDIF

  iaddr = ps_shash_n_straps
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%n_straps).AND.ichange) THEN
     IF(cclist(ps_cnum_IC).NE.1) THEN
        CALL ccwarn("n_straps","IC")
     ELSE
        indim = 0
        IF(nids%nid_dim_nicrf_src.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nicrf_src,"dim_nicrf_src",ss%nicrf_src)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nicrf_src
        CALL define_var("n_straps","I",indim,idims, &
               "number of straps in the antenna", &
               "__NONE","IC","SHOT_CONFIGURATION", &
               "I|ENUM n_straps(nicrf_src)")
     ENDIF
  ENDIF

  iaddr = ps_phash_omeg0cx
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%omeg0cx).AND.ichange) THEN
     IF(cclist(ps_cnum_GAS).NE.1) THEN
        CALL ccwarn("omeg0cx","GAS")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_gas.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_gas,"dm1_nrho_gas",ss%nrho_gas-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_gas
        IF(nids%nid_dim_ngsc0.EQ.0) THEN
           CALL define_dim(nids%nid_dim_ngsc0,"dim_ngsc0",ss%ngsc0)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_ngsc0
        CALL define_var("omeg0cx","R",indim,idims, &
               "effective neutral angular velocity for CX torque", &
               "rad/sec","GAS","STATE_PROFILES", &
               "R|step*tqqcx|units=rad/sec  omeg0cx(~nrho_gas,ngsc0)")
     ENDIF
  ENDIF

  iaddr = ps_phash_omeg0sc0
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%omeg0sc0).AND.ichange) THEN
     IF(cclist(ps_cnum_GAS).NE.1) THEN
        CALL ccwarn("omeg0sc0","GAS")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_gas.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_gas,"dm1_nrho_gas",ss%nrho_gas-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_gas
        IF(nids%nid_dim_nspec_gas.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nspec_gas,"dim_nspec_gas",ss%nspec_gas)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nspec_gas
        IF(nids%nid_dim_ngsc0.EQ.0) THEN
           CALL define_dim(nids%nid_dim_ngsc0,"dim_ngsc0",ss%ngsc0)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_ngsc0
        CALL define_var("omeg0sc0","R",indim,idims, &
               "toroidal angular velocity", &
               "(rad/sec)","GAS","STATE_PROFILES", &
               "R|step*n0norm|units=(rad/sec)  omeg0sc0(~nrho_gas,nspec_gas,ngsc0)")
     ENDIF
  ENDIF

  iaddr = ps_phash_omeg0_halo
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%omeg0_halo).AND.ichange) THEN
     IF(cclist(ps_cnum_NBI).NE.1) THEN
        CALL ccwarn("omeg0_halo","NBI")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_nbi.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_nbi,"dm1_nrho_nbi",ss%nrho_nbi-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_nbi
        IF(nids%nid_dim_nspec_gas.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nspec_gas,"dim_nspec_gas",ss%nspec_gas)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nspec_gas
        CALL define_var("omeg0_halo","R",indim,idims, &
               "halo neutral toroidal angular velocity", &
               "rad/sec","NBI","STATE_PROFILES", &
               "R|units=rad/sec|step*n0_halo  omeg0_halo(~nrho_nbi,nspec_gas)")
     ENDIF
  ENDIF

  iaddr = ps_phash_omeg0_reco
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%omeg0_reco).AND.ichange) THEN
     IF(cclist(ps_cnum_GAS).NE.1) THEN
        CALL ccwarn("omeg0_reco","GAS")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_gas.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_gas,"dm1_nrho_gas",ss%nrho_gas-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_gas
        IF(nids%nid_dim_nspec_gas.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nspec_gas,"dim_nspec_gas",ss%nspec_gas)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nspec_gas
        CALL define_var("omeg0_reco","R",indim,idims, &
               "reco neutral toroidal angular velocity", &
               "rad/sec","GAS","STATE_PROFILES", &
               "R|units=rad/sec|step*n0_reco  omeg0_reco(~nrho_gas,nspec_gas)")
     ENDIF
  ENDIF

  iaddr = ps_phash_omegat
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%omegat).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("omegat","PLASMA")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho,"dm1_nrho",ss%nrho-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho
        CALL define_var("omegat","R",indim,idims, &
               "ion toroidal angular velocity", &
               "rad/sec","PLASMA","STATE_PROFILES", &
               "R|units=rad/sec|step*ni  omegat(~nrho)")
     ENDIF
  ENDIF

  iaddr = ps_shash_omegat_bdy
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("omegat_bdy","PLASMA")
     ELSE
        indim = 0
        CALL define_var("omegat_bdy","R",indim,idims, &
               "toroidal angular velocity at/beyond boundary", &
               "rad/sec","PLASMA","STATE_DATA", &
               "R|units=rad/sec  omegat_bdy")
     ENDIF
  ENDIF

  iaddr = ps_phash_omega_exb
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%omega_exb).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("omega_exb","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        CALL define_var("omega_exb","R",indim,idims, &
               "ExB flow shear rate", &
               "GB","ANOM","STATE_PROFILES", &
               "R|units=GB|pclin omega_exb(nrho_anomth)")
     ENDIF
  ENDIF

  iaddr = ps_phash_p0_reco
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%p0_reco).AND.ichange) THEN
     IF(cclist(ps_cnum_GAS).NE.1) THEN
        CALL ccwarn("p0_reco","GAS")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_gas.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_gas,"dm1_nrho_gas",ss%nrho_gas-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_gas
        CALL define_var("p0_reco","R",indim,idims, &
               "power in recombination neutral source", &
               "W","GAS","STATE_PROFILES", &
               "R|step*dV   p0_reco(~nrho_gas)")
     ENDIF
  ENDIF

  iaddr = ps_phash_pb0_halo
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%pb0_halo).AND.ichange) THEN
     IF(cclist(ps_cnum_NBI).NE.1) THEN
        CALL ccwarn("pb0_halo","NBI")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_nbi.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_nbi,"dm1_nrho_nbi",ss%nrho_nbi-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_nbi
        CALL define_var("pb0_halo","R",indim,idims, &
               "power in halo neutral source", &
               "W","NBI","STATE_PROFILES", &
               "R|step*dV   pb0_halo(~nrho_nbi)")
     ENDIF
  ENDIF

  iaddr = ps_phash_pbe
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%pbe).AND.ichange) THEN
     IF(cclist(ps_cnum_NBI).NE.1) THEN
        CALL ccwarn("pbe","NBI")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_nbi.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_nbi,"dm1_nrho_nbi",ss%nrho_nbi-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_nbi
        CALL define_var("pbe","R",indim,idims, &
               "electron heating by all beam ions", &
               "W","NBI","STATE_PROFILES", &
               "R|step*dV   pbe(~nrho_nbi)")
     ENDIF
  ENDIF

  iaddr = ps_phash_pbi
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%pbi).AND.ichange) THEN
     IF(cclist(ps_cnum_NBI).NE.1) THEN
        CALL ccwarn("pbi","NBI")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_nbi.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_nbi,"dm1_nrho_nbi",ss%nrho_nbi-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_nbi
        CALL define_var("pbi","R",indim,idims, &
               "thermal ion heating by all beam ions", &
               "W","NBI","STATE_PROFILES", &
               "R|step*dV   pbi(~nrho_nbi)")
     ENDIF
  ENDIF

  iaddr = ps_phash_pbth
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%pbth).AND.ichange) THEN
     IF(cclist(ps_cnum_NBI).NE.1) THEN
        CALL ccwarn("pbth","NBI")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_nbi.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_nbi,"dm1_nrho_nbi",ss%nrho_nbi-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_nbi
        CALL define_var("pbth","R",indim,idims, &
               "thermalization of beam ions", &
               "W","NBI","STATE_PROFILES", &
               "R|step*dV   pbth(~nrho_nbi)")
     ENDIF
  ENDIF

  iaddr = ps_phash_pcx_halo
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%pcx_halo).AND.ichange) THEN
     IF(cclist(ps_cnum_NBI).NE.1) THEN
        CALL ccwarn("pcx_halo","NBI")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_nbi.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_nbi,"dm1_nrho_nbi",ss%nrho_nbi-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_nbi
        CALL define_var("pcx_halo","R",indim,idims, &
               "beam halo driven CX power", &
               "W","NBI","STATE_PROFILES", &
               "R|step*dV   pcx_halo(~nrho_nbi)")
     ENDIF
  ENDIF

  iaddr = ps_phash_pcx_reco
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%pcx_reco).AND.ichange) THEN
     IF(cclist(ps_cnum_GAS).NE.1) THEN
        CALL ccwarn("pcx_reco","GAS")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_gas.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_gas,"dm1_nrho_gas",ss%nrho_gas-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_gas
        CALL define_var("pcx_reco","R",indim,idims, &
               "reco driven CX power", &
               "W","GAS","STATE_PROFILES", &
               "R|step*dV   pcx_reco(~nrho_gas)")
     ENDIF
  ENDIF

  iaddr = ps_phash_peech
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%peech).AND.ichange) THEN
     IF(cclist(ps_cnum_EC).NE.1) THEN
        CALL ccwarn("peech","EC")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_ecrf.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_ecrf,"dm1_nrho_ecrf",ss%nrho_ecrf-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_ecrf
        CALL define_var("peech","R",indim,idims, &
               "electron heating by ECH", &
               "W","EC","STATE_PROFILES", &
               "R|step*dV|units=W   peech(~nrho_ecrf)")
     ENDIF
  ENDIF

  iaddr = ps_phash_peech_src
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%peech_src).AND.ichange) THEN
     IF(cclist(ps_cnum_EC).NE.1) THEN
        CALL ccwarn("peech_src","EC")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_ecrf.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_ecrf,"dm1_nrho_ecrf",ss%nrho_ecrf-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_ecrf
        IF(nids%nid_dim_necrf_src.EQ.0) THEN
           CALL define_dim(nids%nid_dim_necrf_src,"dim_necrf_src",ss%necrf_src)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_necrf_src
        CALL define_var("peech_src","R",indim,idims, &
               "ECH heating (by antenna)", &
               "W","EC","STATE_PROFILES", &
               "R|step*dV|units=W   peech_src(~nrho_ecrf,necrf_src)")
     ENDIF
  ENDIF

  iaddr = ps_phash_pelh
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%pelh).AND.ichange) THEN
     IF(cclist(ps_cnum_LH).NE.1) THEN
        CALL ccwarn("pelh","LH")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_lhrf.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_lhrf,"dm1_nrho_lhrf",ss%nrho_lhrf-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_lhrf
        CALL define_var("pelh","R",indim,idims, &
               "electron heating by LH", &
               "W","LH","STATE_PROFILES", &
               "R|step*dV   pelh(~nrho_lhrf)")
     ENDIF
  ENDIF

  iaddr = ps_phash_pelh_src
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%pelh_src).AND.ichange) THEN
     IF(cclist(ps_cnum_LH).NE.1) THEN
        CALL ccwarn("pelh_src","LH")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_lhrf.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_lhrf,"dm1_nrho_lhrf",ss%nrho_lhrf-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_lhrf
        IF(nids%nid_dim_nlhrf_src.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nlhrf_src,"dim_nlhrf_src",ss%nlhrf_src)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nlhrf_src
        CALL define_var("pelh_src","R",indim,idims, &
               "LH electron heating by antenna", &
               "W","LH","STATE_PROFILES", &
               "R|step*dV|units=W   pelh_src(~nrho_lhrf,nlhrf_src)")
     ENDIF
  ENDIF

  iaddr = ps_shash_PEL_Code_Info
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ichange) THEN
     IF(cclist(ps_cnum_PEL).NE.1) THEN
        CALL ccwarn("PEL_Code_Info","PEL")
     ELSE
        indim = 1
        idims(1)=nids%nid_clen_80
        CALL define_var("PEL_Code_Info","C*80",indim,idims, &
               "Information: code implementing PELLET component", &
               "__NONE","PEL","SIMULATION_INIT", &
               "C*80   PEL_Code_Info")
     ENDIF
  ENDIF

  iaddr = ps_shash_PEL_Data_Info
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ichange) THEN
     IF(cclist(ps_cnum_PEL).NE.1) THEN
        CALL ccwarn("PEL_Data_Info","PEL")
     ELSE
        indim = 1
        idims(1)=nids%nid_clen_80
        CALL define_var("PEL_Data_Info","C*80",indim,idims, &
               "Information: on source of pellet injection", &
               "__NONE","PEL","SIMULATION_INIT", &
               "C*80   PEL_Data_Info")
     ENDIF
  ENDIF

  iaddr = ps_phash_pe_anom
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%pe_anom).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("pe_anom","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_anomth,"dm1_nrho_anomth",ss%nrho_anomth-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_anomth
        CALL define_var("pe_anom","R",indim,idims, &
               "anomalous electron heating", &
               "W","ANOM","STATE_PROFILES", &
               "R|units=W|step*dV  pe_anom(~nrho_anomth)")
     ENDIF
  ENDIF

  iaddr = ps_phash_pe_trans
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%pe_trans).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("pe_trans","PLASMA")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho,"dm1_nrho",ss%nrho-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho
        CALL define_var("pe_trans","R",indim,idims, &
               "electron transport (loss) power", &
               "W","PLASMA","STATE_PROFILES", &
               "R|step*dV   pe_trans(~nrho)")
     ENDIF
  ENDIF

  iaddr = ps_phash_pe_transcat
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%pe_transcat).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("pe_transcat","PLASMA")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho,"dm1_nrho",ss%nrho-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho
        IF(nids%nid_dim_ntrcat.EQ.0) THEN
           CALL define_dim(nids%nid_dim_ntrcat,"dim_ntrcat",ss%ntrcat)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_ntrcat
        CALL define_var("pe_transcat","R",indim,idims, &
               "electron transport", &
               "W","PLASMA","STATE_PROFILES", &
               "R|step*dV|units=W  pe_transcat(~nrho,ntrcat)")
     ENDIF
  ENDIF

  iaddr = ps_phash_pfuse
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%pfuse).AND.ichange) THEN
     IF(cclist(ps_cnum_FUS).NE.1) THEN
        CALL ccwarn("pfuse","FUS")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_fus.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_fus,"dm1_nrho_fus",ss%nrho_fus-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_fus
        CALL define_var("pfuse","R",indim,idims, &
               "electron heating by all fusion ions", &
               "W","FUS","STATE_PROFILES", &
               "R|step*dV   pfuse(~nrho_fus)")
     ENDIF
  ENDIF

  iaddr = ps_phash_pfusi
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%pfusi).AND.ichange) THEN
     IF(cclist(ps_cnum_FUS).NE.1) THEN
        CALL ccwarn("pfusi","FUS")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_fus.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_fus,"dm1_nrho_fus",ss%nrho_fus-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_fus
        CALL define_var("pfusi","R",indim,idims, &
               "thermal ion heating by all fusion ions", &
               "W","FUS","STATE_PROFILES", &
               "R|step*dV   pfusi(~nrho_fus)")
     ENDIF
  ENDIF

  iaddr = ps_phash_pfusth
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%pfusth).AND.ichange) THEN
     IF(cclist(ps_cnum_FUS).NE.1) THEN
        CALL ccwarn("pfusth","FUS")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_fus.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_fus,"dm1_nrho_fus",ss%nrho_fus-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_fus
        CALL define_var("pfusth","R",indim,idims, &
               "thermalization of fusion ions", &
               "W","FUS","STATE_PROFILES", &
               "R|step*dV   pfusth(~nrho_fus)")
     ENDIF
  ENDIF

  iaddr = ps_shash_Phibsc
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%Phibsc).AND.ichange) THEN
     IF(cclist(ps_cnum_NBI).NE.1) THEN
        CALL ccwarn("Phibsc","NBI")
     ELSE
        indim = 0
        IF(nids%nid_dim_nbeam.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nbeam,"dim_nbeam",ss%nbeam)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nbeam
        CALL define_var("Phibsc","R",indim,idims, &
               "toroidal location of beam source", &
               "degrees","NBI","MACHINE_DESCRIPTION", &
               "R|units=degrees       Phibsc(nbeam)")
     ENDIF
  ENDIF

  iaddr = ps_phash_phiflux_ky_tglf
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%phiflux_ky_tglf).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("phiflux_ky_tglf","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        IF(nids%nid_dim_nky_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nky_anomth,"dim_nky_anomth",ss%nky_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nky_anomth
        CALL define_var("phiflux_ky_tglf","R",indim,idims, &
               "momentum fluctuation spectrum", &
               "GB","ANOM","STATE_PROFILES", &
               "R|units=GB|pclin phiflux_ky_tglf(nrho_anomth,nky_anomth)")
     ENDIF
  ENDIF

  iaddr = ps_shash_phigrilh
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%phigrilh).AND.ichange) THEN
     IF(cclist(ps_cnum_LH).NE.1) THEN
        CALL ccwarn("phigrilh","LH")
     ELSE
        indim = 0
        IF(nids%nid_dim_max_nspectrumlh_src.EQ.0) THEN
           CALL define_dim(nids%nid_dim_max_nspectrumlh_src,"dim_max_nspectrumlh_src",ss%max_nspectrumlh_src)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_max_nspectrumlh_src
        IF(nids%nid_dim_nlhrf_src.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nlhrf_src,"dim_nlhrf_src",ss%nlhrf_src)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nlhrf_src
        CALL define_var("phigrilh","R",indim,idims, &
               "need description", &
               "-","LH","SHOT_CONFIGURATION", &
               "R|units=- phigrilh(nspectrumlh_src(),nlhrf_src)")
     ENDIF
  ENDIF

  iaddr = ps_phash_phit
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%phit).AND.ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("phit","EQ")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_eq.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_eq,"dim_nrho_eq",ss%nrho_eq)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_eq
        CALL define_var("phit","R",indim,idims, &
               "toroidal flux vs. rho", &
               "Wb","EQ","STATE_PROFILES", &
               "R|units=Wb|Spline_00       phit(nrho_eq)")
     ENDIF
  ENDIF

  iaddr = ps_shash_Phi_EC_launch
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%Phi_EC_launch).AND.ichange) THEN
     IF(cclist(ps_cnum_EC).NE.1) THEN
        CALL ccwarn("Phi_EC_launch","EC")
     ELSE
        indim = 0
        IF(nids%nid_dim_necrf_src.EQ.0) THEN
           CALL define_dim(nids%nid_dim_necrf_src,"dim_necrf_src",ss%necrf_src)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_necrf_src
        CALL define_var("Phi_EC_launch","R",indim,idims, &
               "Phi of center of launcher", &
               "degrees","EC","MACHINE_DESCRIPTION", &
               "R|units=degrees  Phi_EC_launch(necrf_src)")
     ENDIF
  ENDIF

  iaddr = ps_shash_picrf_abs
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%picrf_abs).AND.ichange) THEN
     IF(cclist(ps_cnum_IC).NE.1) THEN
        CALL ccwarn("picrf_abs","IC")
     ELSE
        indim = 0
        IF(nids%nid_dim_nicrf_src.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nicrf_src,"dim_nicrf_src",ss%nicrf_src)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nicrf_src
        CALL define_var("picrf_abs","R",indim,idims, &
               "RF power absorbed inside plasma", &
               "W","IC","STATE_DATA", &
               "R|units=W picrf_abs(nicrf_src)")
     ENDIF
  ENDIF

  iaddr = ps_shash_picrf_ext
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%picrf_ext).AND.ichange) THEN
     IF(cclist(ps_cnum_IC).NE.1) THEN
        CALL ccwarn("picrf_ext","IC")
     ELSE
        indim = 0
        IF(nids%nid_dim_nicrf_src.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nicrf_src,"dim_nicrf_src",ss%nicrf_src)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nicrf_src
        CALL define_var("picrf_ext","R",indim,idims, &
               "RF power deposited outside plasma", &
               "W","IC","STATE_DATA", &
               "R|units=W picrf_ext(nicrf_src)")
     ENDIF
  ENDIF

  iaddr = ps_phash_picrf_nphi_srcs
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%picrf_nphi_srcs).AND.ichange) THEN
     IF(cclist(ps_cnum_IC).NE.1) THEN
        CALL ccwarn("picrf_nphi_srcs","IC")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_icrf.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_icrf,"dm1_nrho_icrf",ss%nrho_icrf-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_icrf
        IF(nids%nid_dim_max_num_nphi.EQ.0) THEN
           CALL define_dim(nids%nid_dim_max_num_nphi,"dim_max_num_nphi",ss%max_num_nphi)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_max_num_nphi
        IF(nids%nid_dim_nicrf_src.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nicrf_src,"dim_nicrf_src",ss%nicrf_src)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nicrf_src
        IF(nids%nid_dp1_nspec_alla.EQ.0) THEN
           CALL define_dim(nids%nid_dp1_nspec_alla,"dp1_nspec_alla",ss%nspec_alla+1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dp1_nspec_alla
        CALL define_var("picrf_nphi_srcs","R",indim,idims, &
               "direct ICRF power deposition", &
               "W","IC","STATE_PROFILES", &
               "R|units=W|alias=picrf_nphi_|step*dV   picrf_nphi_srcs(~nrho_icrf,num_nphi(),nicrf_src,0:nspec_alla)")
     ENDIF
  ENDIF

  iaddr = ps_phash_picrf_srcs
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%picrf_srcs).AND.ichange) THEN
     IF(cclist(ps_cnum_IC).NE.1) THEN
        CALL ccwarn("picrf_srcs","IC")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_icrf.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_icrf,"dm1_nrho_icrf",ss%nrho_icrf-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_icrf
        IF(nids%nid_dim_nicrf_src.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nicrf_src,"dim_nicrf_src",ss%nicrf_src)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nicrf_src
        IF(nids%nid_dp1_nspec_alla.EQ.0) THEN
           CALL define_dim(nids%nid_dp1_nspec_alla,"dp1_nspec_alla",ss%nspec_alla+1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dp1_nspec_alla
        CALL define_var("picrf_srcs","R",indim,idims, &
               "direct ICRF power deposition", &
               "W","IC","STATE_PROFILES", &
               "R|units=W|alias=picrfs_|step*dV   picrf_srcs(~nrho_icrf,nicrf_src,0:nspec_alla)")
     ENDIF
  ENDIF

  iaddr = ps_phash_picrf_totals
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%picrf_totals).AND.ichange) THEN
     IF(cclist(ps_cnum_IC).NE.1) THEN
        CALL ccwarn("picrf_totals","IC")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_icrf.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_icrf,"dm1_nrho_icrf",ss%nrho_icrf-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_icrf
        IF(nids%nid_dp1_nspec_alla.EQ.0) THEN
           CALL define_dim(nids%nid_dp1_nspec_alla,"dp1_nspec_alla",ss%nspec_alla+1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dp1_nspec_alla
        CALL define_var("picrf_totals","R",indim,idims, &
               "direct ICRF power deposition", &
               "W","IC","STATE_PROFILES", &
               "R|units=W|alias=picrf_|step*dV    picrf_totals(~nrho_icrf,0:nspec_alla)")
     ENDIF
  ENDIF

  iaddr = ps_phash_picth
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%picth).AND.ichange) THEN
     IF(cclist(ps_cnum_IC).NE.1) THEN
        CALL ccwarn("picth","IC")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_icrf.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_icrf,"dm1_nrho_icrf",ss%nrho_icrf-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_icrf
        CALL define_var("picth","R",indim,idims, &
               "direct thermal ion heating by ICRF", &
               "W","IC","STATE_PROFILES", &
               "R|step*dV|units=W   picth(~nrho_icrf)")
     ENDIF
  ENDIF

  iaddr = ps_phash_pilh
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%pilh).AND.ichange) THEN
     IF(cclist(ps_cnum_LH).NE.1) THEN
        CALL ccwarn("pilh","LH")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_lhrf.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_lhrf,"dm1_nrho_lhrf",ss%nrho_lhrf-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_lhrf
        CALL define_var("pilh","R",indim,idims, &
               "ion heating by LH", &
               "W","LH","STATE_PROFILES", &
               "R|step*dV   pilh(~nrho_lhrf)")
     ENDIF
  ENDIF

  iaddr = ps_phash_pilh_src
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%pilh_src).AND.ichange) THEN
     IF(cclist(ps_cnum_LH).NE.1) THEN
        CALL ccwarn("pilh_src","LH")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_lhrf.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_lhrf,"dm1_nrho_lhrf",ss%nrho_lhrf-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_lhrf
        IF(nids%nid_dim_nlhrf_src.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nlhrf_src,"dim_nlhrf_src",ss%nlhrf_src)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nlhrf_src
        CALL define_var("pilh_src","R",indim,idims, &
               "LH ion heating by antenna", &
               "W","LH","STATE_PROFILES", &
               "R|step*dV|units=W   pilh_src(~nrho_lhrf,nlhrf_src)")
     ENDIF
  ENDIF

  iaddr = ps_phash_pi_anom
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%pi_anom).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("pi_anom","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_anomth,"dm1_nrho_anomth",ss%nrho_anomth-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_anomth
        CALL define_var("pi_anom","R",indim,idims, &
               "anomalous ion heating", &
               "W","ANOM","STATE_PROFILES", &
               "R|units=W|step*dV  pi_anom(~nrho_anomth)")
     ENDIF
  ENDIF

  iaddr = ps_phash_pi_trans
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%pi_trans).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("pi_trans","PLASMA")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho,"dm1_nrho",ss%nrho-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho
        CALL define_var("pi_trans","R",indim,idims, &
               "ion transport (loss) power", &
               "W","PLASMA","STATE_PROFILES", &
               "R|step*dV   pi_trans(~nrho)")
     ENDIF
  ENDIF

  iaddr = ps_phash_pi_transcat
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%pi_transcat).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("pi_transcat","PLASMA")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho,"dm1_nrho",ss%nrho-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho
        IF(nids%nid_dim_ntrcat.EQ.0) THEN
           CALL define_dim(nids%nid_dim_ntrcat,"dim_ntrcat",ss%ntrcat)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_ntrcat
        CALL define_var("pi_transcat","R",indim,idims, &
               "ion transport", &
               "W","PLASMA","STATE_PROFILES", &
               "R|step*dV|units=W  pi_transcat(~nrho,ntrcat)")
     ENDIF
  ENDIF

  iaddr = ps_shash_PLASMA_Code_Info
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("PLASMA_Code_Info","PLASMA")
     ELSE
        indim = 1
        idims(1)=nids%nid_clen_80
        CALL define_var("PLASMA_Code_Info","C*80",indim,idims, &
               "Information: code managing PLASMA component", &
               "__NONE","PLASMA","SIMULATION_INIT", &
               "C*80   PLASMA_Code_Info")
     ENDIF
  ENDIF

  iaddr = ps_phash_pmine
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%pmine).AND.ichange) THEN
     IF(cclist(ps_cnum_IC).NE.1) THEN
        CALL ccwarn("pmine","IC")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_icrf.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_icrf,"dm1_nrho_icrf",ss%nrho_icrf-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_icrf
        CALL define_var("pmine","R",indim,idims, &
               "electron heating by minority ions", &
               "W","IC","STATE_PROFILES", &
               "R|step*dV   pmine(~nrho_icrf)")
     ENDIF
  ENDIF

  iaddr = ps_phash_pmini
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%pmini).AND.ichange) THEN
     IF(cclist(ps_cnum_IC).NE.1) THEN
        CALL ccwarn("pmini","IC")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_icrf.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_icrf,"dm1_nrho_icrf",ss%nrho_icrf-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_icrf
        CALL define_var("pmini","R",indim,idims, &
               "thermal ion heating by minority ions", &
               "W","IC","STATE_PROFILES", &
               "R|step*dV   pmini(~nrho_icrf)")
     ENDIF
  ENDIF

  iaddr = ps_phash_pminth
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%pminth).AND.ichange) THEN
     IF(cclist(ps_cnum_IC).NE.1) THEN
        CALL ccwarn("pminth","IC")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_icrf.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_icrf,"dm1_nrho_icrf",ss%nrho_icrf-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_icrf
        CALL define_var("pminth","R",indim,idims, &
               "(de)thermalization of minority ions", &
               "W","IC","STATE_PROFILES", &
               "R|step*dV   pminth(~nrho_icrf)")
     ENDIF
  ENDIF

  iaddr = ps_phash_pohme
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%pohme).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("pohme","PLASMA")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho,"dm1_nrho",ss%nrho-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho
        CALL define_var("pohme","R",indim,idims, &
               "Ohmic heating of electrons", &
               "W","PLASMA","STATE_PROFILES", &
               "R|units=W|step*dV   pohme(~nrho)")
     ENDIF
  ENDIF

  iaddr = ps_phash_pot_ky_tglf
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%pot_ky_tglf).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("pot_ky_tglf","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        IF(nids%nid_dim_nky_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nky_anomth,"dim_nky_anomth",ss%nky_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nky_anomth
        CALL define_var("pot_ky_tglf","R",indim,idims, &
               "potential fluctuation spectrum", &
               "GB","ANOM","STATE_PROFILES", &
               "R|units=GB|pclin pot_ky_tglf(nrho_anomth,nky_anomth)")
     ENDIF
  ENDIF

  iaddr = ps_shash_power_ec
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%power_ec).AND.ichange) THEN
     IF(cclist(ps_cnum_EC).NE.1) THEN
        CALL ccwarn("power_ec","EC")
     ELSE
        indim = 0
        IF(nids%nid_dim_necrf_src.EQ.0) THEN
           CALL define_dim(nids%nid_dim_necrf_src,"dim_necrf_src",ss%necrf_src)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_necrf_src
        CALL define_var("power_ec","R",indim,idims, &
               "power on each ECRF source", &
               "W","EC","STATE_DATA", &
               "R|units=W  power_ec(necrf_src)")
     ENDIF
  ENDIF

  iaddr = ps_shash_power_ic
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%power_ic).AND.ichange) THEN
     IF(cclist(ps_cnum_IC).NE.1) THEN
        CALL ccwarn("power_ic","IC")
     ELSE
        indim = 0
        IF(nids%nid_dim_nicrf_src.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nicrf_src,"dim_nicrf_src",ss%nicrf_src)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nicrf_src
        CALL define_var("power_ic","R",indim,idims, &
               "power on each ICRF source", &
               "W","IC","STATE_DATA", &
               "R|units=W  power_ic(nicrf_src)")
     ENDIF
  ENDIF

  iaddr = ps_shash_power_lh
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%power_lh).AND.ichange) THEN
     IF(cclist(ps_cnum_LH).NE.1) THEN
        CALL ccwarn("power_lh","LH")
     ELSE
        indim = 0
        IF(nids%nid_dim_nlhrf_src.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nlhrf_src,"dim_nlhrf_src",ss%nlhrf_src)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nlhrf_src
        CALL define_var("power_lh","R",indim,idims, &
               "power on each LHRF source", &
               "W","LH","STATE_DATA", &
               "R|units=W  power_lh(nlhrf_src)")
     ENDIF
  ENDIF

  iaddr = ps_shash_power_nbi
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%power_nbi).AND.ichange) THEN
     IF(cclist(ps_cnum_NBI).NE.1) THEN
        CALL ccwarn("power_nbi","NBI")
     ELSE
        indim = 0
        IF(nids%nid_dim_nbeam.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nbeam,"dim_nbeam",ss%nbeam)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nbeam
        CALL define_var("power_nbi","R",indim,idims, &
               "power on each beam source", &
               "W","NBI","STATE_DATA", &
               "R|units=W  power_nbi(nbeam)")
     ENDIF
  ENDIF

  iaddr = ps_shash_power_nbi_trace
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%power_nbi_trace).AND.ichange) THEN
     IF(cclist(ps_cnum_NBI).NE.1) THEN
        CALL ccwarn("power_nbi_trace","NBI")
     ELSE
        indim = 0
        IF(nids%nid_dim_nbeam.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nbeam,"dim_nbeam",ss%nbeam)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nbeam
        CALL define_var("power_nbi_trace","R",indim,idims, &
               "power injected as trace element (if any)", &
               "W","NBI","STATE_DATA", &
               "R|units=W  power_nbi_trace(nbeam)")
     ENDIF
  ENDIF

  iaddr = ps_phash_prad
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%prad).AND.ichange) THEN
     IF(cclist(ps_cnum_RAD).NE.1) THEN
        CALL ccwarn("prad","RAD")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_rad.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_rad,"dm1_nrho_rad",ss%nrho_rad-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_rad
        CALL define_var("prad","R",indim,idims, &
               "total radiated power", &
               "W","RAD","STATE_PROFILES", &
               "R|step*dV  prad(~nrho_rad)")
     ENDIF
  ENDIF

  iaddr = ps_phash_prad_br
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%prad_br).AND.ichange) THEN
     IF(cclist(ps_cnum_RAD).NE.1) THEN
        CALL ccwarn("prad_br","RAD")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_rad.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_rad,"dm1_nrho_rad",ss%nrho_rad-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_rad
        CALL define_var("prad_br","R",indim,idims, &
               "bremsstrahlung contribution", &
               "W","RAD","STATE_PROFILES", &
               "R|step*dV  prad_br(~nrho_rad)")
     ENDIF
  ENDIF

  iaddr = ps_phash_prad_cy
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%prad_cy).AND.ichange) THEN
     IF(cclist(ps_cnum_RAD).NE.1) THEN
        CALL ccwarn("prad_cy","RAD")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_rad.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_rad,"dm1_nrho_rad",ss%nrho_rad-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_rad
        CALL define_var("prad_cy","R",indim,idims, &
               "cyclotron radiation contribution", &
               "W","RAD","STATE_PROFILES", &
               "R|step*dV  prad_cy(~nrho_rad)")
     ENDIF
  ENDIF

  iaddr = ps_phash_prad_li
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%prad_li).AND.ichange) THEN
     IF(cclist(ps_cnum_RAD).NE.1) THEN
        CALL ccwarn("prad_li","RAD")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_rad.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_rad,"dm1_nrho_rad",ss%nrho_rad-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_rad
        CALL define_var("prad_li","R",indim,idims, &
               "line radiation contribution", &
               "W","RAD","STATE_PROFILES", &
               "R|step*dV  prad_li(~nrho_rad)")
     ENDIF
  ENDIF

  iaddr = ps_phash_psc_halo
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%psc_halo).AND.ichange) THEN
     IF(cclist(ps_cnum_NBI).NE.1) THEN
        CALL ccwarn("psc_halo","NBI")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_nbi.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_nbi,"dm1_nrho_nbi",ss%nrho_nbi-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_nbi
        CALL define_var("psc_halo","R",indim,idims, &
               "beam halo power: recapture - pb0_halo", &
               "W","NBI","STATE_PROFILES", &
               "R|step*dV   psc_halo(~nrho_nbi)")
     ENDIF
  ENDIF

  iaddr = ps_phash_psc_reco
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%psc_reco).AND.ichange) THEN
     IF(cclist(ps_cnum_GAS).NE.1) THEN
        CALL ccwarn("psc_reco","GAS")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_gas.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_gas,"dm1_nrho_gas",ss%nrho_gas-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_gas
        CALL define_var("psc_reco","R",indim,idims, &
               "reco power: recapture - p0_reco", &
               "W","GAS","STATE_PROFILES", &
               "R|step*dV   psc_reco(~nrho_gas)")
     ENDIF
  ENDIF

  iaddr = ps_phash_psipol
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%psipol).AND.ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("psipol","EQ")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_eq.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_eq,"dim_nrho_eq",ss%nrho_eq)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_eq
        CALL define_var("psipol","R",indim,idims, &
               "poloidal flux vs. rho", &
               "Wb/rad","EQ","STATE_PROFILES", &
               "R|units=Wb/rad|Spline_00   psipol(nrho_eq)")
     ENDIF
  ENDIF
  CONTAINS


     SUBROUTINE define_dim(dimid,dname,idval)
        INTEGER, intent(out) :: dimid
        CHARACTER*(*), INTENT(in) :: dname
        INTEGER, intent(in) :: idval

        status = nf90_def_dim(icdf,dname,idval,dimid)
        IF(status.NE.NF90_NOERR) THEN
           WRITE(iout,*) ' ?ps_update_file_write: error defining dimension "'// &
                 trim(dname)//'".'
           IERR=9999
        ENDIF
     END SUBROUTINE define_dim



     SUBROUTINE define_var(name,dtype,indim,idims, &
          long_name,units,component,section,spec)

        CHARACTER*(*), INTENT(in) :: name
        CHARACTER*(*), INTENT(in) :: dtype
        INTEGER, INTENT(in) :: indim
        INTEGER, dimension(:), INTENT(in) :: idims
        CHARACTER*(*), INTENT(in) :: long_name
        CHARACTER*(*), INTENT(in) :: units
        CHARACTER*(*), INTENT(in) :: component
        CHARACTER*(*), INTENT(in) :: section
        CHARACTER*(*), INTENT(in) :: spec

        integer :: itype

        IF(dtype.EQ.'R') THEN
           itype = NF90_DOUBLE

        ELSE IF (dtype.EQ.'I') THEN
           itype = NF90_INT

        ELSE
           itype = NF90_CHAR

        ENDIF

        IF(indim.EQ.0) THEN
           status=nf90_def_var(icdf,name,itype, varid=varid)

        ELSE
           status=nf90_def_var(icdf,name,itype, dimids=idims(1:indim),varid=varid)

        ENDIF

        IF(status.NE.NF90_NOERR) THEN
           WRITE(iout,*) " ?plasma_state_store: error defining variable: "//trim(name)
           CALL ncerr(status)
           iertot = iertot + 1
           RETURN
        ENDIF

        ! Variable OK, now add attributes:

        CALL add_attrib("long_name",long_name)
        IF(dtype.EQ.'R') CALL add_attrib("units",units)
        CALL add_attrib("component",component)
        CALL add_attrib("section",section)
        CALL add_attrib("specification",spec)

     END SUBROUTINE define_var

     SUBROUTINE add_attrib(name,value)
        CHARACTER*(*), intent(in) :: name
        CHARACTER*(*), intent(in) :: value

        status=nf90_put_att(icdf,varid,name,value)
        IF(status.NE.NF90_NOERR) THEN
           WRITE(iout,*) " ?plasma_state_store: error defining attribute: "//trim(name)//' = '//trim(value)
           CALL ncerr(status)
           iertot = iertot + 1
        ENDIF
     END SUBROUTINE add_attrib



     SUBROUTINE ncerr(status)
        INTEGER, INTENT(in) :: status

        nc_errmsg = NF90_strerror(status)
        write(iout,*) '  NetCDF message: ',trim(nc_errmsg)
     END SUBROUTINE ncerr



     SUBROUTINE ccwarn(varnam,compnam)

        CHARACTER*(*), intent(in) :: varnam   ! name of variable or array
        CHARACTER*(*), intent(in) :: compnam  ! name of component

        if(iwarn.eq.0) then
           write(iout,*) ' '
           write(iout,*) ' %ps_update_file_write: modified state elements'
           write(iout,*) '  exist which were not written due to the "cclist"'
           write(iout,*) '  input variable which screens out elements from'
           write(iout,*) '  selected components: cclist = ',cclist,';'
           write(iout,*) '  element values of 1 indicate components that are'
           write(iout,*) '  enabled for write.'
           write(iout,*) ' '
        endif

        iwarn = iwarn + 1

        write(iout,*) ' %ps_update_file_write: modified: ss%'// &
             trim(varnam)//' ('//trim(compnam)//' component) NOT WRITTEN.'

     END SUBROUTINE ccwarn

END SUBROUTINE ps_update_file_write_def_5

SUBROUTINE ps_update_file_write_5(ss,icdf,cclist,iucount,iout,iwarn,iertot)


  ! Write updated data

  USE plasma_state_definition_mod
  USE netcdf
  IMPLICIT NONE

  TYPE (plasma_state) :: ss  ! state containing array elements to be allocated
  INTEGER, INTENT(IN) :: icdf  ! NetCDF file ID
  INTEGER, INTENT(IN) :: cclist(ps_ccount)  ! component selection
  INTEGER, INTENT(INOUT) :: iucount ! update count
  INTEGER, INTENT(IN) :: iout  ! LUN for messages
  INTEGER, INTENT(INOUT) :: iwarn   ! warn count
  INTEGER, INTENT(INOUT) :: iertot  ! error count

  !-------------------

  INTEGER :: varid,status
  CHARACTER*80 :: nc_errmsg

  !-------------------


  status = nf90_inq_varid(icdf,"ntf_coils",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%ntf_coils)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: ntf_coils"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"nthinlh",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%nthinlh)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: nthinlh"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Nturns",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%Nturns)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: Nturns"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"num_nphi",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%num_nphi)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: num_nphi"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"num_nphi_vac",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%num_nphi_vac)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: num_nphi_vac"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"nzflux_ky_tglf",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%nzflux_ky_tglf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: nzflux_ky_tglf"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"nz_ky_tglf",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%nz_ky_tglf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: nz_ky_tglf"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"n_straps",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%n_straps)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: n_straps"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"omeg0cx",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%omeg0cx)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: omeg0cx"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"omeg0sc0",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%omeg0sc0)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: omeg0sc0"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"omeg0_halo",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%omeg0_halo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: omeg0_halo"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"omeg0_reco",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%omeg0_reco)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: omeg0_reco"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"omegat",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%omegat)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: omegat"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"omegat_bdy",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%omegat_bdy)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: omegat_bdy"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"omega_exb",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%omega_exb)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: omega_exb"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"p0_reco",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%p0_reco)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: p0_reco"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"pb0_halo",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%pb0_halo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: pb0_halo"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"pbe",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%pbe)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: pbe"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"pbi",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%pbi)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: pbi"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"pbth",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%pbth)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: pbth"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"pcx_halo",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%pcx_halo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: pcx_halo"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"pcx_reco",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%pcx_reco)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: pcx_reco"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"peech",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%peech)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: peech"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"peech_src",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%peech_src)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: peech_src"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"pelh",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%pelh)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: pelh"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"pelh_src",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%pelh_src)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: pelh_src"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"PEL_Code_Info",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%PEL_Code_Info)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: PEL_Code_Info"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"PEL_Data_Info",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%PEL_Data_Info)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: PEL_Data_Info"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"pe_anom",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%pe_anom)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: pe_anom"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"pe_trans",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%pe_trans)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: pe_trans"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"pe_transcat",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%pe_transcat)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: pe_transcat"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"pfuse",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%pfuse)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: pfuse"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"pfusi",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%pfusi)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: pfusi"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"pfusth",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%pfusth)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: pfusth"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Phibsc",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%Phibsc)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: Phibsc"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"phiflux_ky_tglf",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%phiflux_ky_tglf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: phiflux_ky_tglf"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"phigrilh",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%phigrilh)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: phigrilh"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"phit",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%phit)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: phit"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Phi_EC_launch",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%Phi_EC_launch)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: Phi_EC_launch"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"picrf_abs",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%picrf_abs)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: picrf_abs"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"picrf_ext",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%picrf_ext)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: picrf_ext"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"picrf_nphi_srcs",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%picrf_nphi_srcs)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: picrf_nphi_srcs"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"picrf_srcs",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%picrf_srcs)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: picrf_srcs"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"picrf_totals",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%picrf_totals)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: picrf_totals"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"picth",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%picth)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: picth"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"pilh",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%pilh)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: pilh"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"pilh_src",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%pilh_src)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: pilh_src"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"pi_anom",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%pi_anom)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: pi_anom"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"pi_trans",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%pi_trans)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: pi_trans"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"pi_transcat",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%pi_transcat)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: pi_transcat"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"PLASMA_Code_Info",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%PLASMA_Code_Info)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: PLASMA_Code_Info"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"pmine",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%pmine)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: pmine"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"pmini",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%pmini)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: pmini"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"pminth",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%pminth)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: pminth"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"pohme",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%pohme)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: pohme"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"pot_ky_tglf",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%pot_ky_tglf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: pot_ky_tglf"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"power_ec",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%power_ec)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: power_ec"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"power_ic",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%power_ic)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: power_ic"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"power_lh",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%power_lh)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: power_lh"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"power_nbi",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%power_nbi)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: power_nbi"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"power_nbi_trace",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%power_nbi_trace)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: power_nbi_trace"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"prad",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%prad)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: prad"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"prad_br",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%prad_br)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: prad_br"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"prad_cy",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%prad_cy)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: prad_cy"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"prad_li",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%prad_li)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: prad_li"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"psc_halo",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%psc_halo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: psc_halo"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"psc_reco",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%psc_reco)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: psc_reco"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"psipol",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%psipol)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: psipol"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF
  CONTAINS


     SUBROUTINE ncerr(status)
        INTEGER, INTENT(in) :: status

        nc_errmsg = NF90_strerror(status)
        write(iout,*) '  NetCDF message: ',trim(nc_errmsg)
     END SUBROUTINE ncerr

END SUBROUTINE ps_update_file_write_5

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_e5_dummy
     return
  end subroutine ccps_getset_e5_dummy

subroutine psget_eq_code_info(iobj, data, ierr)
    !! Information: code implementing EQ component
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    CHARACTER*(*), intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_eq_code_info', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % EQ_Code_Info
end subroutine psget_eq_code_info


subroutine psset_eq_code_info(iobj, data, ierr)
    !! Information: code implementing EQ component
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    CHARACTER*(*), intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_eq_code_info', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % EQ_Code_Info = data
end subroutine psset_eq_code_info


subroutine psgetsz_eq_code_info(iobj, size, ierr)
    !! Information: code implementing EQ component
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: size    ! size of character string
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psgetsz_eq_code_info', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! note that the following will return the character length size regardless of
    ! the number of array elements (if EQ_Code_Info is an array)
    size = len(ss % EQ_Code_Info)
end subroutine psgetsz_eq_code_info


subroutine psget_e_anom2(iobj, n1, data, ierr)
    !! energy grid (2d anomalous transport profiles), for
    !! Db(E,rho), separate profiles for various, pitch related
    !! limiting orbit topologies:, deeply trapped, barely trapped,
    !! barely passing  co/ctr, vpll/v -> 1 limit  co/ctr
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_e_anom2', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % E_anom2
end subroutine psget_e_anom2


subroutine psset_e_anom2(iobj, n1, data, ierr)
    !! energy grid (2d anomalous transport profiles), for
    !! Db(E,rho), separate profiles for various, pitch related
    !! limiting orbit topologies:, deeply trapped, barely trapped,
    !! barely passing  co/ctr, vpll/v -> 1 limit  co/ctr
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_e_anom2', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % E_anom2 = data(1:n1)
end subroutine psset_e_anom2


subroutine psgetrnk_e_anom2(iobj, ndims, ierr)
    !! energy grid (2d anomalous transport profiles), for
    !! Db(E,rho), separate profiles for various, pitch related
    !! limiting orbit topologies:, deeply trapped, barely trapped,
    !! barely passing  co/ctr, vpll/v -> 1 limit  co/ctr
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_e_anom2


subroutine psgetdim_e_anom2(iobj, ndims, dims, ierr)
    !! energy grid (2d anomalous transport profiles), for
    !! Db(E,rho), separate profiles for various, pitch related
    !! limiting orbit topologies:, deeply trapped, barely trapped,
    !! barely passing  co/ctr, vpll/v -> 1 limit  co/ctr
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_e_anom2', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % E_anom2 ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % E_anom2)
    endif
end subroutine psgetdim_e_anom2


subroutine psget_epot(iobj, n1, data, ierr)
    !! radial electrostatic potential, at zone bdys
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_epot', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % Epot
end subroutine psget_epot


subroutine psset_epot(iobj, n1, data, ierr)
    !! radial electrostatic potential, at zone bdys
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_epot', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % Epot = data(1:n1)
end subroutine psset_epot


subroutine psgetrnk_epot(iobj, ndims, ierr)
    !! radial electrostatic potential, at zone bdys
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_epot


subroutine psgetdim_epot(iobj, ndims, dims, ierr)
    !! radial electrostatic potential, at zone bdys
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_epot', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % Epot ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % Epot)
    endif
end subroutine psgetdim_epot

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_k3_dummy
     return
  end subroutine ccps_getset_k3_dummy

subroutine psget_kccw_bphi(iobj, data, ierr)
    !! B_phi orientation: +1 means CCW viewed from above, -1 means
    !! clockwise (CW) viewed from above.
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_kccw_bphi', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % kccw_Bphi
end subroutine psget_kccw_bphi


subroutine psset_kccw_bphi(iobj, data, ierr)
    !! B_phi orientation: +1 means CCW viewed from above, -1 means
    !! clockwise (CW) viewed from above.
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_kccw_bphi', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % kccw_Bphi = data
end subroutine psset_kccw_bphi

subroutine ur_cstate_mnlab3(ipresent,iabsent)
  ! generate mnlab(3) label "Present in # states; absent in # states."
  ! get the pluralization right

  use cstate_lib_mod
  implicit NONE

  integer, intent(in) :: ipresent   ! #of states present
  integer, intent(in) :: iabsent   ! #of states absent

  !---------------------------------

  mnlab(3) = ' '

  if((ipresent.eq.1).and.(iabsent.eq.1)) then
     mnlab(3)='Present in 1 state; absent in 1 state.'

  else if((ipresent.eq.1).and.(iabsent.ne.1)) then
     write(mnlab(3),'("Present in 1 state; absent in ",i1," states.")') &
          iabsent

  else if((ipresent.ne.1).and.(iabsent.eq.1)) then
     write(mnlab(3),'("Present in ",i1," states; absent in 1 state.")') &
          ipresent

  else
     write(mnlab(3),'("Present in ",i1," states; absent in ",i1," states")') &
          ipresent,iabsent
  endif

end subroutine ur_cstate_mnlab3

subroutine cstate_find1(dname,indx)

  !  find index matching "dname" in alphabetized list w1%list_elems(:)
  !  return as indx; return indx=0 if no match is found.

  use cstate_lib_mod
  implicit NONE

  !-------------------------
  !  passed:

  character*(*), intent(in) :: dname
  integer, intent(out) :: indx

  !-------------------------
  !  local:

  character*32 zname
  integer :: ii,i1,i2,isize
  !-------------------------

  zname = dname
  call uupper(zname)  ! force uppercase

  indx = 0

  isize=w1%size
  if(isize.eq.0) return

  if(zname.lt.w1%list_elems(1)) return
  if(zname.gt.w1%list_elems(isize)) return

  if(zname.eq.w1%list_elems(1)) then
     indx = 1
     return
  endif

  if(zname.eq.w1%list_elems(isize)) then
     indx = isize
     return
  endif

  i1=1
  i2=isize

  do
     ii = (i1+i2)/2
     if(ii.eq.i1) ii=i1+1

     if(zname.gt.w1%list_elems(ii)) then
        i1=ii

     else if(zname.eq.w1%list_elems(ii)) then
        indx=ii
        exit

     else
        i2=ii
        if(i2.eq.i1+1) exit  ! inbetwee i1 and i2; no match

     endif
  enddo

end subroutine cstate_find1

subroutine cstate_findm(dname,luntty,indx)

  !  find index matching "dname" in alphabetized list w1%list_elems(:)
  !  return as indx; return indx=0 if no match is found.

  !  "dname" can be a prefix of a name; if its length is N and it matches
  !  character positions (1:N) of one name only, that counts as a match.

  use cstate_lib_mod
  implicit NONE

  !-------------------------
  !  passed:

  character*(*), intent(inout) :: dname   ! name or prefix item
  !  full name, in uppercase, returned (if match is found).

  integer, intent(in) :: luntty        ! LUN (for warning message)

  integer, intent(out) :: indx         ! match index, or 0 if none.

  !-------------------------
  !  local:

  character*32 zname
  integer :: ii,i1,i2,isize,inmatch,inb
  !-------------------------

  zname = dname
  call uupper(zname)     ! force uppercase
  inb = len(trim(zname)) ! non-blank length

  indx = 0
  inmatch = 0

  isize=w1%size
  do
     if(isize.eq.0) exit

     i1=1
     i2=isize

     do ii=i1,i2
        if(zname.eq.w1%list_elems(ii)) then
           inmatch = 1
           indx = ii
           exit
        endif
        if(zname(1:inb).eq.w1%list_elems(ii)(1:inb)) then
           inmatch = inmatch + 1
           indx = ii
           write(luntty,*) '   ...match: '//trim(w1%list_elems(indx))
        endif
     enddo

     exit
  enddo

  if(inmatch.eq.0) then
     write(luntty,*) ' %cstate_findm: "'//trim(zname)//'" does not match any available name.'
     write(luntty,*) ' '
     indx=0
  else if(inmatch.gt.1) then
     write(luntty,*) ' %cstate_findm: "'//trim(zname)//'" ambiguous: matches more than one name.'
     write(luntty,*) ' '
     indx=0
  else
     dname = w1%list_elems(indx)
  endif

end subroutine cstate_findm

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_c2_dummy
     return
  end subroutine ccps_getset_c2_dummy

subroutine psget_coil_name(iobj, n1, data, ierr)
    !! Number & name of axisymmetric coils
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    CHARACTER*(*), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_coil_name', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % coil_name
end subroutine psget_coil_name


subroutine psset_coil_name(iobj, n1, data, ierr)
    !! Number & name of axisymmetric coils
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    CHARACTER*(*), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_coil_name', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % coil_name = data(1:n1)
end subroutine psset_coil_name


subroutine psgetsz_coil_name(iobj, size, ierr)
    !! Number & name of axisymmetric coils
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: size    ! size of character string
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psgetsz_coil_name', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! note that the following will return the character length size regardless of
    ! the number of array elements (if coil_name is an array)
    size = len(ss % coil_name)
end subroutine psgetsz_coil_name


subroutine psgetrnk_coil_name(iobj, ndims, ierr)
    !! Number & name of axisymmetric coils
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_coil_name


subroutine psgetdim_coil_name(iobj, ndims, dims, ierr)
    !! Number & name of axisymmetric coils
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_coil_name', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % coil_name ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % coil_name)
    endif
end subroutine psgetdim_coil_name


subroutine psget_chie_trans(iobj, n1, data, ierr)
    !! electron thermal diffusivity
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_chie_trans', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % chie_trans
end subroutine psget_chie_trans


subroutine psset_chie_trans(iobj, n1, data, ierr)
    !! electron thermal diffusivity
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_chie_trans', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % chie_trans = data(1:n1)
end subroutine psset_chie_trans


subroutine psgetrnk_chie_trans(iobj, ndims, ierr)
    !! electron thermal diffusivity
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_chie_trans


subroutine psgetdim_chie_trans(iobj, ndims, dims, ierr)
    !! electron thermal diffusivity
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_chie_trans', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % chie_trans ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % chie_trans)
    endif
end subroutine psgetdim_chie_trans


subroutine psget_curbeam(iobj, n1, data, ierr)
    !! beam ion driven current (shielded)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_curbeam', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % curbeam
end subroutine psget_curbeam


subroutine psset_curbeam(iobj, n1, data, ierr)
    !! beam ion driven current (shielded)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_curbeam', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % curbeam = data(1:n1)
end subroutine psset_curbeam


subroutine psgetrnk_curbeam(iobj, ndims, ierr)
    !! beam ion driven current (shielded)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_curbeam


subroutine psgetdim_curbeam(iobj, ndims, dims, ierr)
    !! beam ion driven current (shielded)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_curbeam', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % curbeam ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % curbeam)
    endif
end subroutine psgetdim_curbeam


subroutine psget_chie_anom(iobj, n1, data, ierr)
    !! Te-equation, diffusivity term
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_chie_anom', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % chie_anom
end subroutine psget_chie_anom


subroutine psset_chie_anom(iobj, n1, data, ierr)
    !! Te-equation, diffusivity term
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_chie_anom', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % chie_anom = data(1:n1)
end subroutine psset_chie_anom


subroutine psgetrnk_chie_anom(iobj, ndims, ierr)
    !! Te-equation, diffusivity term
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_chie_anom


subroutine psgetdim_chie_anom(iobj, ndims, dims, ierr)
    !! Te-equation, diffusivity term
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_chie_anom', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % chie_anom ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % chie_anom)
    endif
end subroutine psgetdim_chie_anom


subroutine psget_chitheta_mmm71(iobj, n1, data, ierr)
    !! momentum-equation, diffusivity term, poloidal
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_chitheta_mmm71', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % chitheta_mmm71
end subroutine psget_chitheta_mmm71


subroutine psset_chitheta_mmm71(iobj, n1, data, ierr)
    !! momentum-equation, diffusivity term, poloidal
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_chitheta_mmm71', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % chitheta_mmm71 = data(1:n1)
end subroutine psset_chitheta_mmm71


subroutine psgetrnk_chitheta_mmm71(iobj, ndims, ierr)
    !! momentum-equation, diffusivity term, poloidal
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_chitheta_mmm71


subroutine psgetdim_chitheta_mmm71(iobj, ndims, dims, ierr)
    !! momentum-equation, diffusivity term, poloidal
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_chitheta_mmm71', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % chitheta_mmm71 ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % chitheta_mmm71)
    endif
end subroutine psgetdim_chitheta_mmm71


subroutine psget_chii_w19(iobj, n1, data, ierr)
    !! Ti-equation, diffusivity term
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_chii_w19', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % chii_w19
end subroutine psget_chii_w19


subroutine psset_chii_w19(iobj, n1, data, ierr)
    !! Ti-equation, diffusivity term
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_chii_w19', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % chii_w19 = data(1:n1)
end subroutine psset_chii_w19


subroutine psgetrnk_chii_w19(iobj, ndims, ierr)
    !! Ti-equation, diffusivity term
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_chii_w19


subroutine psgetdim_chii_w19(iobj, ndims, dims, ierr)
    !! Ti-equation, diffusivity term
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_chii_w19', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % chii_w19 ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % chii_w19)
    endif
end subroutine psgetdim_chii_w19


subroutine psget_chie_paleo(iobj, n1, data, ierr)
    !! Te-equation, diffusivity term PALEO model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_chie_paleo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % chie_paleo
end subroutine psget_chie_paleo


subroutine psset_chie_paleo(iobj, n1, data, ierr)
    !! Te-equation, diffusivity term PALEO model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_chie_paleo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % chie_paleo = data(1:n1)
end subroutine psset_chie_paleo


subroutine psgetrnk_chie_paleo(iobj, ndims, ierr)
    !! Te-equation, diffusivity term PALEO model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_chie_paleo


subroutine psgetdim_chie_paleo(iobj, ndims, dims, ierr)
    !! Te-equation, diffusivity term PALEO model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_chie_paleo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % chie_paleo ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % chie_paleo)
    endif
end subroutine psgetdim_chie_paleo


subroutine psget_chiphi_gtcneo(iobj, n1, data, ierr)
    !! momentum-equation, neoclassical diffusivity from GTC_NEO
    !! model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_chiphi_gtcneo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % chiphi_gtcneo
end subroutine psget_chiphi_gtcneo


subroutine psset_chiphi_gtcneo(iobj, n1, data, ierr)
    !! momentum-equation, neoclassical diffusivity from GTC_NEO
    !! model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_chiphi_gtcneo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % chiphi_gtcneo = data(1:n1)
end subroutine psset_chiphi_gtcneo


subroutine psgetrnk_chiphi_gtcneo(iobj, ndims, ierr)
    !! momentum-equation, neoclassical diffusivity from GTC_NEO
    !! model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_chiphi_gtcneo


subroutine psgetdim_chiphi_gtcneo(iobj, ndims, dims, ierr)
    !! momentum-equation, neoclassical diffusivity from GTC_NEO
    !! model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_chiphi_gtcneo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % chiphi_gtcneo ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % chiphi_gtcneo)
    endif
end subroutine psgetdim_chiphi_gtcneo

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_r9_dummy
     return
  end subroutine ccps_getset_r9_dummy

subroutine psget_rad_code_info(iobj, data, ierr)
    !! Information: code implementing RAD component
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    CHARACTER*(*), intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_rad_code_info', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % RAD_Code_Info
end subroutine psget_rad_code_info


subroutine psset_rad_code_info(iobj, data, ierr)
    !! Information: code implementing RAD component
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    CHARACTER*(*), intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_rad_code_info', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % RAD_Code_Info = data
end subroutine psset_rad_code_info


subroutine psgetsz_rad_code_info(iobj, size, ierr)
    !! Information: code implementing RAD component
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: size    ! size of character string
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psgetsz_rad_code_info', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! note that the following will return the character length size regardless of
    ! the number of array elements (if RAD_Code_Info is an array)
    size = len(ss % RAD_Code_Info)
end subroutine psgetsz_rad_code_info


subroutine psget_rho_eq_geo(iobj, n1, data, ierr)
    !! rho grid (EQ flux surface averages), this grid is built from
    !! rho_eq: nrho_eq_geo = 2*nrho_eq - 1,
    !! rho_eq_geo(1:nrho_eq_geo:2) = rho_eq(1:nrho_eq),
    !! rho_eq_geo(2:nrho_eq_geo:2) =,
    !! (rho_eq(1:nrho_eq-1)+rho_eq(2:nrho_eq))/2, i.e. a doubly fine
    !! grid for metric flux surface averages stored, as piecewise
    !! linear radidal profiles.
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_rho_eq_geo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % rho_eq_geo
end subroutine psget_rho_eq_geo


subroutine psset_rho_eq_geo(iobj, n1, data, ierr)
    !! rho grid (EQ flux surface averages), this grid is built from
    !! rho_eq: nrho_eq_geo = 2*nrho_eq - 1,
    !! rho_eq_geo(1:nrho_eq_geo:2) = rho_eq(1:nrho_eq),
    !! rho_eq_geo(2:nrho_eq_geo:2) =,
    !! (rho_eq(1:nrho_eq-1)+rho_eq(2:nrho_eq))/2, i.e. a doubly fine
    !! grid for metric flux surface averages stored, as piecewise
    !! linear radidal profiles.
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_rho_eq_geo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % rho_eq_geo = data(1:n1)
end subroutine psset_rho_eq_geo


subroutine psgetrnk_rho_eq_geo(iobj, ndims, ierr)
    !! rho grid (EQ flux surface averages), this grid is built from
    !! rho_eq: nrho_eq_geo = 2*nrho_eq - 1,
    !! rho_eq_geo(1:nrho_eq_geo:2) = rho_eq(1:nrho_eq),
    !! rho_eq_geo(2:nrho_eq_geo:2) =,
    !! (rho_eq(1:nrho_eq-1)+rho_eq(2:nrho_eq))/2, i.e. a doubly fine
    !! grid for metric flux surface averages stored, as piecewise
    !! linear radidal profiles.
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_rho_eq_geo


subroutine psgetdim_rho_eq_geo(iobj, ndims, dims, ierr)
    !! rho grid (EQ flux surface averages), this grid is built from
    !! rho_eq: nrho_eq_geo = 2*nrho_eq - 1,
    !! rho_eq_geo(1:nrho_eq_geo:2) = rho_eq(1:nrho_eq),
    !! rho_eq_geo(2:nrho_eq_geo:2) =,
    !! (rho_eq(1:nrho_eq-1)+rho_eq(2:nrho_eq))/2, i.e. a doubly fine
    !! grid for metric flux surface averages stored, as piecewise
    !! linear radidal profiles.
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_rho_eq_geo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % rho_eq_geo ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % rho_eq_geo)
    endif
end subroutine psgetdim_rho_eq_geo


subroutine psget_rho_anom(iobj, n1, data, ierr)
    !! rho grid (1d anomalous transport profiles)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_rho_anom', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % rho_anom
end subroutine psget_rho_anom


subroutine psset_rho_anom(iobj, n1, data, ierr)
    !! rho grid (1d anomalous transport profiles)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_rho_anom', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % rho_anom = data(1:n1)
end subroutine psset_rho_anom


subroutine psgetrnk_rho_anom(iobj, ndims, ierr)
    !! rho grid (1d anomalous transport profiles)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_rho_anom


subroutine psgetdim_rho_anom(iobj, ndims, dims, ierr)
    !! rho grid (1d anomalous transport profiles)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_rho_anom', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % rho_anom ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % rho_anom)
    endif
end subroutine psgetdim_rho_anom


subroutine psget_res_sn(iobj, n1, n2, data, ierr)
    !! residuals for particle transport eqn
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_res_sn', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % res_sn
end subroutine psget_res_sn


subroutine psset_res_sn(iobj, n1, n2, data, ierr)
    !! residuals for particle transport eqn
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_res_sn', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % res_sn = data(1:n1, 1: n2)
end subroutine psset_res_sn


subroutine psgetrnk_res_sn(iobj, ndims, ierr)
    !! residuals for particle transport eqn
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_res_sn


subroutine psgetdim_res_sn(iobj, ndims, dims, ierr)
    !! residuals for particle transport eqn
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_res_sn', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % res_sn ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % res_sn)
    endif
end subroutine psgetdim_res_sn

subroutine ccps_rho_metric(iobj,metric_name,ngrid,rho_grid,nresult,result, &
     ierr)

  ! compute and return flux surface averaged or integrated metrics over
  ! a specified rho grid.

  ! specify metric_name "DVOL_EQ" to use the Volume(rho) profile employed
  ! in ps_rho_rezone and ps_user_rezone; use "DVOL" to get exact volumes.

  ! specify metric_name "AREA_EQ" to use the Area(rho) profile employed
  ! in ps_rho_rezone and ps_user_rezone; use "DAREA" to get exact cross
  ! sectional areas.

  use plasma_state_mod
  implicit NONE

#include "fpreproc/byte_declare.h"

  integer :: iobj(*)        ! (ps_container_size) words are used: state object

  BYTE_DECLARE, intent(in) :: metric_name(*) ! null terminated string specifying the desired
  ! metric... name specification not sensitive to use of upper or lower case
  ! alphabetic characters: e.g. "dVol" and "DVOL" yield the same result.

  integer :: ngrid          ! size of RHO grid provided
  REAL(kind=rspec) :: rho_grid(ngrid)  ! the RHO grid
          ! *** strict ascending order ***
          ! *** in range [0.0_rspec:1.0_rspec] ***

  integer :: nresult        ! size of result expected (=ngrid or =ngrid-1)
  REAL(kind=rspec) :: result(nresult) ! results returned

  !  there will either be (ngrid) results or (ngrid-1) results depending
  !  on the type of metric chosen-- see e.g. partial table, below

  !  ***The caller must set ngrid and nresults consistently, to avoid an error
  !  condition.

  integer,intent(out) :: ierr   ! exit status 0=OK

  !-----------------------------------------
  !  partial table of common metrics
  !
  !      sizes:  nrho = [rho_name grid size]           (possible nresult value)
  !              nrho-1  = [rho_name grid size] - 1    (possible nresult value)
  !
  !  metric_name   size      description
  ! 
  !    "dVol"      nrho-1    zone volumes, m^3
  !    "dArea"     nrho-1    zone cross sectional areas, m^2
  !    "Vol"       nrho      volume enclosed in rho surfaces, m^3
  !    "Area"      nrho      cross section area enclosed by rho surfaces, m^2
  !    "<1/R^2>S"  nrho      differential volume flux surface average of
  !                          (1/R^2) at each surface, m^-2
  !    "<1/R^2>    nrho-1    zonal volume average of (1/R^2), m^-2
  !
  !  in some cases, surface averages are faster to compute than zonal
  !  averages.
  !
  !    "dVol_eq"   nrho-1    interpolated volumes as used in ccps_rho_rezone
  !    "dArea_eq"  nrho-1    interpolated areas as used in ccps_rho_rezone
  ! 
  !-----------------------------------------
  ! there are many more; see the xplasma documentation.
  ! in TRANSP this is in source/doc/xplasma.hlp; on the web it is currently
  ! at http://w3.pppl.gov/~pshare/help/xplasma.htm
  !      (or access via the xplasma web page under the catalog at
  !       http://w3.pppl.gov/NTCC).
  !
  !-----------------------------------------

  !-------------------------
  character*32 zmetric
  type (plasma_state_container) :: ptr
  type (plasma_state), pointer :: ss
  !-------------------------

  call ccps_argcheck('ccps_rho_metric',iobj,ierr)
  if(ierr.ne.0) return

  ! proceed...

  call load_ps_container(iobj,ptr)
  ss => ptr%ps_ptr

  ! convert metric specification to fortran string
  call cstring(zmetric,metric_name,'2F')

  call ps_rho_metric('USER',zmetric,result,ierr, &
       state=ss, user_rho_grid=rho_grid)

end subroutine ccps_rho_metric

subroutine ccps_update_hashcodes(iobj, &
     mdescr_iflag,sconfig_iflag,simInit_iflag,ierr)

  ! update hash table; lock (or unlock) initialization sections of state

  use plasma_state_mod
  implicit NONE

  integer :: iobj(*)        ! (ps_container_size) words are used: state object
  integer :: mdescr_iflag   ! .NE. 0 => lock machine description section
  integer :: sconfig_iflag  ! .NE. 0 => lock shot configuration section
  integer :: simInit_iflag  ! .NE. 0 => lock simulation initialization section
  integer,intent(out) :: ierr      ! exit status 0=OK

  !-------------------------
  type (plasma_state_container) :: ptr
  type (plasma_state), pointer :: ss
  !-------------------------

  call ccps_argcheck('ccps_update_hashcodes',iobj,ierr)
  if(ierr.ne.0) return

  ! proceed...

  call load_ps_container(iobj,ptr)
  ss => ptr%ps_ptr

  call ps_update_hashcodes(ierr, state=ss, &
       mdescr_lock = (mdescr_iflag.NE.0), &
       sconfig_lock = (sconfig_iflag.NE.0), &
       simInit_lock = (simInit_iflag.NE.0) )

end subroutine ccps_update_hashcodes

subroutine ccps_save_hash_codes(iobj, ierr)

  use plasma_state_mod
  implicit none
  integer :: iobj(*)        ! (ps_container_size) words are used: state object
  integer,intent(out) :: ierr ! exit status 0=OK

  !-------------------------
  type (plasma_state_container) :: ptr
  type (plasma_state), pointer :: ss
  !-------------------------

  call ccps_argcheck('ccps_save_hash_codes',iobj,ierr)
  if(ierr.ne.0) return

  ! proceed...

  call load_ps_container(iobj,ptr)
  ss => ptr%ps_ptr

  call ps_save_hash_codes(iwarn=ierr, state=ss)

end subroutine ccps_save_hash_codes

subroutine ccps_restore_hash_codes(iobj, ierr)

  use plasma_state_mod
  implicit none
  integer :: iobj(*)        ! (ps_container_size) words are used: state object
  integer,intent(out) :: ierr  ! exit status 0=OK

  !-------------------------
  type (plasma_state_container) :: ptr
  type (plasma_state), pointer :: ss
  !-------------------------

  call ccps_argcheck('ccps_restore_hash_codes',iobj,ierr)
  if(ierr.ne.0) return

  ! proceed...

  call load_ps_container(iobj,ptr)
  ss => ptr%ps_ptr

  call ps_restore_hash_codes(ierr=ierr, state=ss)

end subroutine ccps_restore_hash_codes

subroutine psxpl_rhoth2rz(ss,isize,rho,th,R,Z,iout,ierr)

  !  coordinate transform: (rho,th) -> (R,Z)
  !  in xplasma contained in state "ss"

  use plasma_state_xpobj  ! XPLASMA2 state object definitions
  use plasma_state_definition_mod
  implicit NONE

  !---------------------------------------
  !  passed arguments:

  type (plasma_state) :: ss
  integer, intent(in) :: isize  ! vector size

  REAL(KIND=rspec), intent(in) :: rho(isize),th(isize)

  REAL(KIND=rspec), intent(out) :: R(isize),Z(isize)

  integer, intent(in) :: iout   ! LUN for messages
  integer, intent(out) :: ierr  ! exit status 0=OK

  !---------------------------------------
  !  local:

  type (interp_object) :: xobj
  type (xplasma), pointer :: s
  !-----------------------

  xobj = transfer(ss%iobj,xobj)
  s => xobj%s_xpobj

  call xplasma_ctrans(s, .TRUE., ierr, &
       rho_in = rho, theta_in = th, &
       R_out = R, Z_out = Z)

  if(ierr.ne.0) then
     write(iout,*) ' ?psxpl_rhoth2RZ: xplasma error:'
     call xplasma_error(s,ierr,iout)
  endif

end subroutine psxpl_rhoth2rz

subroutine psxpl_rz2rhoth(ss,isize,R,Z,rho,th,iout,imap,rtol,ierr)

  !  coordinate transform: (R,Z) -> (rho,th)
  !  in xplasma contained in state "ss"

  use plasma_state_xpobj  ! XPLASMA2 state object definitions
  use plasma_state_definition_mod
  implicit NONE

  !---------------------------------------
  !  passed arguments:

  type (plasma_state) :: ss
  integer, intent(in) :: isize  ! vector size

  REAL(KIND=rspec), intent(in) :: R(isize),Z(isize)

  REAL(KIND=rspec), intent(out) :: rho(isize),th(isize)

  integer, intent(in) :: iout   ! LUN for messages

  integer, intent(in) :: imap   ! inverse map selection code

  REAL(KIND=rspec), intent(in) :: rtol  ! accuracy tolerance, if imap=1
  !  (Newton map only)

  integer, intent(out) :: ierr  ! exit status 0=OK

  !---------------------------------------
  !  local:

  type (interp_object) :: xobj
  type (xplasma), pointer :: s
  !-----------------------

  xobj = transfer(ss%iobj,xobj)
  s => xobj%s_xpobj

  call xplasma_ctrans(s, .TRUE., ierr, &
       R_in = R, Z_in = Z, &
       rho_out = rho, theta_out = th, &
       maptype = imap, tol = rtol)

  if(ierr.ne.0) then
     write(iout,*) ' ?psxpl_rhoth2RZ: xplasma error:'
     call xplasma_error(s,ierr,iout)
  endif

end subroutine psxpl_rz2rhoth

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_t6_dummy
     return
  end subroutine ccps_getset_t6_dummy

subroutine psget_tq_transcat(iobj, n1, n2, data, ierr)
    !! toroidal angular momentum transport
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_tq_transcat', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % tq_transcat
end subroutine psget_tq_transcat


subroutine psset_tq_transcat(iobj, n1, n2, data, ierr)
    !! toroidal angular momentum transport
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_tq_transcat', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % tq_transcat = data(1:n1, 1: n2)
end subroutine psset_tq_transcat


subroutine psgetrnk_tq_transcat(iobj, ndims, ierr)
    !! toroidal angular momentum transport
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_tq_transcat


subroutine psgetdim_tq_transcat(iobj, ndims, dims, ierr)
    !! toroidal angular momentum transport
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_tq_transcat', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % tq_transcat ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % tq_transcat)
    endif
end subroutine psgetdim_tq_transcat


subroutine psget_triangu(iobj, n1, data, ierr)
    !! upper triangularity, ((Rmin+Rmax)/2 -
    !! R(Zmax))/((Rmax-Rmin)/2)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_triangu', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % triangU
end subroutine psget_triangu


subroutine psset_triangu(iobj, n1, data, ierr)
    !! upper triangularity, ((Rmin+Rmax)/2 -
    !! R(Zmax))/((Rmax-Rmin)/2)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_triangu', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % triangU = data(1:n1)
end subroutine psset_triangu


subroutine psgetrnk_triangu(iobj, ndims, ierr)
    !! upper triangularity, ((Rmin+Rmax)/2 -
    !! R(Zmax))/((Rmax-Rmin)/2)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_triangu


subroutine psgetdim_triangu(iobj, ndims, dims, ierr)
    !! upper triangularity, ((Rmin+Rmax)/2 -
    !! R(Zmax))/((Rmax-Rmin)/2)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_triangu', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % triangU ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % triangU)
    endif
end subroutine psgetdim_triangu


subroutine psget_tqbth(iobj, n1, data, ierr)
    !! momentum in thermalization of beam ions
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_tqbth', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % tqbth
end subroutine psget_tqbth


subroutine psset_tqbth(iobj, n1, data, ierr)
    !! momentum in thermalization of beam ions
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_tqbth', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % tqbth = data(1:n1)
end subroutine psset_tqbth


subroutine psgetrnk_tqbth(iobj, ndims, ierr)
    !! momentum in thermalization of beam ions
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_tqbth


subroutine psgetdim_tqbth(iobj, ndims, dims, ierr)
    !! momentum in thermalization of beam ions
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_tqbth', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % tqbth ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % tqbth)
    endif
end subroutine psgetdim_tqbth


subroutine psget_tqb0_halo(iobj, n1, data, ierr)
    !! torque of halo neutral source, (loss from thermal ions)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_tqb0_halo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % tqb0_halo
end subroutine psget_tqb0_halo


subroutine psset_tqb0_halo(iobj, n1, data, ierr)
    !! torque of halo neutral source, (loss from thermal ions)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_tqb0_halo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % tqb0_halo = data(1:n1)
end subroutine psset_tqb0_halo


subroutine psgetrnk_tqb0_halo(iobj, ndims, ierr)
    !! torque of halo neutral source, (loss from thermal ions)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_tqb0_halo


subroutine psgetdim_tqb0_halo(iobj, ndims, dims, ierr)
    !! torque of halo neutral source, (loss from thermal ions)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_tqb0_halo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % tqb0_halo ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % tqb0_halo)
    endif
end subroutine psgetdim_tqb0_halo


subroutine psget_tq0_reco(iobj, n1, data, ierr)
    !! torque of recombination neutral source, (momentum loss from
    !! thermal ions)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_tq0_reco', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % tq0_reco
end subroutine psget_tq0_reco


subroutine psset_tq0_reco(iobj, n1, data, ierr)
    !! torque of recombination neutral source, (momentum loss from
    !! thermal ions)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_tq0_reco', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % tq0_reco = data(1:n1)
end subroutine psset_tq0_reco


subroutine psgetrnk_tq0_reco(iobj, ndims, ierr)
    !! torque of recombination neutral source, (momentum loss from
    !! thermal ions)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_tq0_reco


subroutine psgetdim_tq0_reco(iobj, ndims, dims, ierr)
    !! torque of recombination neutral source, (momentum loss from
    !! thermal ions)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_tq0_reco', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % tq0_reco ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % tq0_reco)
    endif
end subroutine psgetdim_tq0_reco


subroutine psget_tq_anom(iobj, n1, data, ierr)
    !! anomalous torque
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_tq_anom', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % tq_anom
end subroutine psget_tq_anom


subroutine psset_tq_anom(iobj, n1, data, ierr)
    !! anomalous torque
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_tq_anom', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % tq_anom = data(1:n1)
end subroutine psset_tq_anom


subroutine psgetrnk_tq_anom(iobj, ndims, ierr)
    !! anomalous torque
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_tq_anom


subroutine psgetdim_tq_anom(iobj, ndims, dims, ierr)
    !! anomalous torque
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_tq_anom', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % tq_anom ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % tq_anom)
    endif
end subroutine psgetdim_tq_anom

subroutine ur_cstate_misc_plots

  !  miscellaneous plotting options...

  use cstate_lib_mod
  use plasma_hash_code
  implicit NONE

  !------------------------
  ! local

  integer :: luntty,lnout
  logical :: lxout,lchar

  integer, parameter :: nbdy=501
  real*8, parameter :: z2pi = 6.2831853071795862D+00

  integer :: ith
  real*8 :: xbdy(nbdy),thbdy(nbdy)

  real*8, dimension(:,:), allocatable :: rbdy,zbdy,rlim,zlim,rcon,zcon

  integer :: iself(nsss_cur),inums(nsss_cur),insel,i,indx,idR,idZ,ierr
  integer :: isel2(nsss_cur),inum2(nsss_cur),insel2,indx2
  character*32 slbls(nsss_cur),slbl2(nsss_cur)
  real*8 :: zndx(nsss_cur)
  integer :: have_geo(nsss_cur)
  integer :: have_lim(nsss_cur)
  integer :: num_rzlim(nsss_cur)
  integer :: max_rzlim,inum

  integer :: ihash,inmax,isel,incon,ii,ind
  integer :: lim_hash(nsss_cur)
  integer :: bdy_hash(nsss_cur)
  integer :: ns_hash(nsss_cur),insgot
  integer :: inum_contours(nsss_cur)

  integer, dimension(:), allocatable :: iselc,inumc
  real*8, dimension(:), allocatable :: zndxc
  character*32, dimension(:), allocatable :: slblc
  !------------------------

  luntty = lnout(0)

  if(nsss_cur.eq.0) then
     write(luntty,*) ' ur_cstate_misc_plots: no states are loaded.'
     return
  endif

  !------------------------
  !  bdy in flux coordinates:
  do ith=1,nbdy
     xbdy(ith)=1.0d0
     thbdy(ith)=(ith-1)*z2pi/(nbdy-1)
  enddo

  !------------------------
  !  count number of states with geometry & limiter information available

  lim_hash=0
  bdy_hash=0

  have_geo = 0
  have_lim = 0
  inum_contours = 0

  inmax=nbdy

  insel = 0
  insel2 = 0
  insgot = 0
  max_rzlim = 0
  do i=1,nsss_cur
     zndx(i)=i
     idR = sss(i)%id_R_geo
     idZ = sss(i)%id_Z_geo
     if((idR.gt.0).and.(idZ.gt.0)) then
        insel = insel + 1
        iself(insel)=insel
        inums(insel)=nbdy
        slbls(insel)=sss_label(i)

        have_geo(i)=insel
        inum_contours(i) = inum_contours(i) + 1
     endif

     inum=sss(i)%num_rzlim
     num_rzlim(i)=inum
     if(inum.gt.0) then
        max_rzlim = max(max_rzlim,inum)
        inmax = max(inmax,inum)
        insel2=insel2 + 1
        isel2(insel2)=insel2
        inum2(insel2)=inum
        slbl2(insel2)=sss_label(i)

        have_lim(i)=insel2
        inum_contours(i) = inum_contours(i) + 1
     endif

     !  count contours of ICRF antennas
     inmax = max(inmax,sss(i)%max_nrz_antgeo)
     inum_contours(i) = inum_contours(i) + sss(i)%nicrf_src
  enddo

  if(insel.gt.0) then
     allocate(rbdy(nbdy,insel),zbdy(nbdy,insel))
     rbdy = 0
     zbdy = 0
  endif

  if(insel2.gt.0) then
     allocate(rlim(max_rzlim,insel2),zlim(max_rzlim,insel2))
     rlim = 0
     zlim = 0
  endif

  indx = 0
  indx2 = 0
  do i=1,nsss_cur
     idR = sss(i)%id_R_geo
     idZ = sss(i)%id_Z_geo
     if((idR.gt.0).and.(idZ.gt.0)) then
        indx = indx + 1

        call ps_intrp_2d(xbdy,thbdy,idR,rbdy(1:nbdy,indx),ierr, &
             state = sss(i))
        if(ierr.ne.0) then
           write(luntty,*) ' ?? ur_cstate_misc_plots: R(rho,theta) interpolation error.'
           insel = 0
           exit
        endif

        call ps_intrp_2d(xbdy,thbdy,idZ,zbdy(1:nbdy,indx),ierr, &
             state = sss(i))
        if(ierr.ne.0) then
           write(luntty,*) ' ?? ur_cstate_misc_plots: Z(rho,theta) interpolation error.'
           insel = 0
           exit
        endif

        ihash=17
        call hashCode(nbdy,ihash)
        call hashCode(Rbdy(1:nbdy,indx),ihash)
        call hashCode(Zbdy(1:nbdy,indx),ihash)
        bdy_hash(i)=ihash
     endif

     inum=sss(i)%num_rzlim
     if(inum.gt.0) then
        indx2 = indx2 + 1
        
        rlim(1:inum,indx2) = sss(i)%rlim(1:inum)
        zlim(1:inum,indx2) = sss(i)%zlim(1:inum)

        ihash=17
        call hashCode(inum,ihash)
        call hashCode(Rlim(1:inum,indx2),ihash)
        call hashCode(Zlim(1:inum,indx2),ihash)
        lim_hash(i)=ihash
     endif

     ns_hash(i) = -1
     if((allocated(sss(i)%ns)).AND.(allocated(sss(i)%qatom_all))) then
        insgot = insgot + 1
        ihash=17
        call hashCode(sss(i)%ns,ihash)
        if(allocated(sss(i)%nbeami)) then
           call hashCode(sss(i)%nbeami,ihash)
        endif
        if(allocated(sss(i)%nfusi)) then
           call hashCode(sss(i)%nfusi,ihash)
        endif
        if(allocated(sss(i)%nmini)) then
           call hashCode(sss(i)%nmini,ihash)
        endif
        ns_hash(i)=ihash
     endif
  enddo

  if(insel.gt.0) then
     call cstate_hash_compare('plasma boundaries',bdy_hash,bdy_hash)
  else
     write(luntty,*) ' '
     write(luntty,*) ' (none of the states contain plasma geometry w/boundary)'
  endif

  if(insel2.gt.0) then
     call cstate_hash_compare('limiters',lim_hash,lim_hash)
  else
     write(luntty,*) ' '
     write(luntty,*) ' (none of the states specify a limiter)'
  endif

  if(insgot.gt.0) then
     call cstate_hash_compare('densities',ns_hash,ns_hash)
  else
     write(luntty,*) ' '
     write(luntty,*) ' (none of the states contain thermal specie densities)'
  endif

  !------------------------
  !  interactive loop:

  do
     if(lxout(0)) then
        write(luntty,*) ' '
        write(luntty,*) 'ur_cstate_misc_plots options:'
        if(insel.gt.0) &
             write(luntty,*) ' B -- comparitive plot of boundaries.'
        if(insel2.gt.0) &
             write(luntty,*) ' L -- comparitive plot of axisymmetric limiters.'
        if(maxval(inum_contours).gt.0) &
             write(luntty,*) ' S -- plot boundary, limiter, and antennas for single state.'
        write(luntty,*) ' X -- "xplasma" plots of individual state.'
        write(luntty,*) ' N -- quasiNeutrality test, individual state.'
        write(luntty,*) ' Z -- Zeff test, individual state.'
        write(luntty,*) ' Q -- quit.'
        write(luntty,*) ' '
     endif

     call uread('ur_cstate_misc_plots option:')

     if(lchar('Q')) then
        exit

     else if(lchar('X')) then
        call ur_cstate_xplasma_plots

     else if(lchar('B')) then
        if(insel.eq.0) then
           call uermsg('ur_cstate_misc_plots: geometry data not available.', &
                ' ',0)
           cycle
        endif

        !  plot the boundaries...

        kylab = ' '
        kylab(1) = '  state'
        kylab(2) = 'identification'

        mnlab(2:3) = ' '
        mnlab(2) = 'plot of plasma boundaries'
        call ur_cstate_mnlab3(insel,nsss_cur-insel)

        call r8_grfmm1(Rbdy,Zbdy,nbdy,inums,insel,zndx,insel, &
             iself,insel,'m','m',mnlab,kylab,slbls)

     else if(lchar('L')) then
        if(insel2.eq.0) then
           call uermsg('ur_cstate_misc_plots: limiter data not available.', &
                ' ',0)
           cycle
        endif

        !  plot the boundaries...

        kylab = ' '
        kylab(1) = '  state'
        kylab(2) = 'identification'

        mnlab(2:3) = ' '
        mnlab(2) = 'plot of limiters'
        call ur_cstate_mnlab3(insel2,nsss_cur-insel2)

        call r8_grfmm1(Rlim,Zlim,max_rzlim,inum2,insel2,zndx,insel2, &
             isel2,insel2,'m','m',mnlab,kylab,slbl2)

     else if(lchar('S')) then
        if(maxval(inum_contours).eq.0) then
           call uermsg('ur_cstate_misc_plots: no single state plots available.',' ',0)
           cycle
        endif

        do
           if(lxout(0)) then
              write(luntty,*) ' '
              write(luntty,*) ' select single state: '
              do i=1,nsss_cur
                 if(inum_contours(i).eq.0) then
                    write(luntty,'(2x,i1," -- ",a," (plot not available).")') &
                         i,trim(sss_label(i))
                 else
                    write(luntty,'(2x,i1," -- ",a)') &
                         i,trim(sss_label(i))
                 endif
              enddo
              write(luntty,*) ' ... 0 or "Q" to exit this loop.'
           endif
           isel = 0
           call ureadi('enter 1 digit number to select state:',isel)
           if(isel.eq.0) exit

           incon=inum_contours(isel)
           if(incon.eq.0) then
              call uermsi('ur_cstate_misc_plots: no plot available for state',&
                   isel,0)
              cycle
           endif

           if(allocated(rcon)) deallocate(rcon,zcon)
           if(allocated(inumc)) deallocate(inumc,iselc,zndxc,slblc)

           allocate(rcon(inmax,incon),zcon(inmax,incon)); rcon=0.0; zcon=0.0
           allocate(inumc(incon),iselc(incon),zndxc(incon),slblc(incon))

           !  plot the contours

           kylab = ' '
           kylab(1) = '  contour'
           kylab(2) = 'identification'

           mnlab(2:3)=' '
           mnlab(2)='plot of boundary, limiter, and antenna locations'
           mnlab(3)='for state: '//trim(sss_label(isel))

           do i=1,incon
              iselc(i)=i
              zndxc(i)=i
           enddo

           ii=0

           if(have_geo(isel).gt.0) then
              ii=ii+1
              slblc(ii)='bdy'
              inumc(ii)=nbdy
              Rcon(1:nbdy,ii)=Rbdy(1:nbdy,have_geo(isel))
              Zcon(1:nbdy,ii)=Zbdy(1:nbdy,have_geo(isel))
           endif

           if(have_lim(isel).gt.0) then
              ii=ii+1
              ind=have_lim(isel)
              inumc(ii)=inum2(ind)
              slblc(ii)='limiter'
              Rcon(1:inumc(ii),ii)=Rlim(1:inum2(ind),ind)
              Zcon(1:inumc(ii),ii)=Zlim(1:inum2(ind),ind)
           endif

           do i=1,sss(isel)%nicrf_src
              if(sss(isel)%nrz_antgeo(i).gt.0) then
                 ii=ii+1
                 inumc(ii)=sss(isel)%nrz_antgeo(i)
                 slblc(ii)='Ant.'//trim(sss(isel)%icrf_src_name(i))
                 Rcon(1:inumc(ii),ii)=sss(isel)%R_antgeo(1:inumc(ii),i)
                 Zcon(1:inumc(ii),ii)=sss(isel)%Z_antgeo(1:inumc(ii),i)
              endif
           enddo

           call r8_grfmm1(Rcon,Zcon,inmax,inumc,ii,zndxc,ii, &
                iselc,ii,'m','m',mnlab,kylab,slblc)
        enddo

     else if(lchar('N')) then
        call choose1(isel)
        if(isel.eq.0) cycle

        call ur_cstate_quasi_check(isel)
        
     else if(lchar('Z')) then
        call choose1(isel)
        if(isel.eq.0) cycle

        call ur_cstate_Zeff_check(isel)
        
     else
        call uermsg('unrecognized option',' ',0)
     endif
  enddo

CONTAINS
  subroutine choose1(isel)

    integer, intent(out) :: isel

    !----------------
    integer :: iskip
    !----------------

    isel = 0

    if(lxout(0)) then
       write(luntty,*) ' '
       write(luntty,*) ' select single state: '
       do i=1,nsss_cur
          if(ns_hash(i).eq.-1) then
             write(luntty,'(2x,i1," -- ",a," (densities not available).")') &
                  i,trim(sss_label(i))
          else
             write(luntty,'(2x,i1," -- ",a)') &
                  i,trim(sss_label(i))
          endif
       enddo
       write(luntty,*) ' ... 0 or "Q" to exit.'
    endif

    iskip = 0

    call ureadi('enter 1 digit number to select state:',isel)
    if(ns_hash(isel).eq.-1) iskip = 1
    if(isel.lt.0) iskip = 1
    if(isel.gt.nsss_cur) iskip = 1

    if(iskip.gt.0) then
       call uermsi('%ur_cstate_misc_plots: no density data for state #',isel,0)
       isel=0
    endif

  end subroutine choose1

end subroutine ur_cstate_misc_plots

subroutine ccps_xload_check(iobj,iout,icheck,ierr)
  ! load xplasma from state structure; only load items that changed
  ! or are not found in the xplasma object (small items may be loaded
  ! regardless).  Check for rebuild of equilibrium in xplasma.

  use plasma_state_mod
  implicit NONE

  integer :: iobj(*)        ! (ps_container_size) words are used: state object
  INTEGER, intent(in) :: iout   ! I/O channel for messages
  INTEGER, intent(in) :: icheck ! =0 to SKIP equilibrium check
  INTEGER, intent(out) :: ierr  ! completion status (0=OK)

  !-------------------------
  type (plasma_state_container) :: ptr
  type (plasma_state), pointer :: ss
  !-------------------------

  call ccps_argcheck('ccps_xload_check',iobj,ierr)
  if(ierr.ne.0) return

  ! proceed...

  call load_ps_container(iobj,ptr)
  ss => ptr%ps_ptr

  call ps_xload_check(ss, iout, icheck, ierr)
end subroutine ccps_xload_check

SUBROUTINE ccps_hash_diff(iobj1, lbl1, iobj2, lbl2, sstr, icomp, idiff)

  ! summarize difference between two states, based on hash code comparison.

  use plasma_state_mod
  implicit NONE

#include "fpreproc/byte_declare.h"

  integer :: iobj1(*)        ! 1st state
  BYTE_DECLARE, intent(in) :: lbl1 ! label for 1st state

  integer :: iobj2(*)        ! 2nd state
  BYTE_DECLARE, intent(in) :: lbl2 ! label for 2nd state

  BYTE_DECLARE, intent(in) :: sstr ! search string
  !  if section, dimension, or profile name contains sstr as a substring
  !  check the hash difference for that item.

  !  ==> if sstr = "*", check the hash difference for ALL items.

  INTEGER, intent(out) :: icomp     ! number of hash comparisons done
  INTEGER, intent(out) :: idiff     ! number of DIFFERENCES found

  !-------------------------
  character*256 lbl1_ftn, lbl2_ftn, sstr_ftn
  type (plasma_state_container) :: ptr1
  type (plasma_state), pointer :: ss1
  type (plasma_state_container) :: ptr2
  type (plasma_state), pointer :: ss2
  integer :: ierr
  !-------------------------
  
  call ccps_argcheck('ccps_hash_diff',iobj1,ierr)
  if(ierr.ne.0) return
  call ccps_argcheck('ccps_hash_diff',iobj2,ierr)
  if(ierr.ne.0) return

  ! proceed...

  call load_ps_container(iobj1, ptr1)
  ss1 => ptr1%ps_ptr
  call load_ps_container(iobj2, ptr2)
  ss2 => ptr2%ps_ptr

  ! convert null terminated string to fortran string
  call cstring(lbl1_ftn, lbl1,'2F')
  call cstring(lbl2_ftn, lbl2,'2F')
  call cstring(sstr_ftn, sstr,'2F')
  
  call plasma_state_hash_diff(ss1,lbl1,ss2,lbl2,sstr,icomp,idiff)

end SUBROUTINE ccps_hash_diff

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_i9_dummy
     return
  end subroutine ccps_getset_i9_dummy

subroutine psget_ic_code_info(iobj, data, ierr)
    !! Information: code implementing IC component
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    CHARACTER*(*), intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_ic_code_info', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % IC_Code_Info
end subroutine psget_ic_code_info


subroutine psset_ic_code_info(iobj, data, ierr)
    !! Information: code implementing IC component
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    CHARACTER*(*), intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_ic_code_info', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % IC_Code_Info = data
end subroutine psset_ic_code_info


subroutine psgetsz_ic_code_info(iobj, size, ierr)
    !! Information: code implementing IC component
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: size    ! size of character string
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psgetsz_ic_code_info', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! note that the following will return the character length size regardless of
    ! the number of array elements (if IC_Code_Info is an array)
    size = len(ss % IC_Code_Info)
end subroutine psgetsz_ic_code_info


subroutine psget_id_ns(iobj, n1, data, ierr)
    !! 'Array of IDs for ns profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_ns', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_ns
end subroutine psget_id_ns


subroutine psgetrnk_id_ns(iobj, ndims, ierr)
    !! 'Array of IDs for ns profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_ns


subroutine psgetdim_id_ns(iobj, ndims, dims, ierr)
    !! 'Array of IDs for ns profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_ns', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_ns ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_ns)
    endif
end subroutine psgetdim_id_ns


subroutine psget_id_zeff_th(iobj, data, ierr)
    !! 'ID for Zeff_th profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_zeff_th', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_zeff_th
end subroutine psget_id_zeff_th


subroutine psget_id_curr_bootstrap(iobj, data, ierr)
    !! 'ID for curr_bootstrap profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_curr_bootstrap', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_curr_bootstrap
end subroutine psget_id_curr_bootstrap


subroutine psget_id_res_sn(iobj, n1, data, ierr)
    !! 'Array of IDs for res_sn profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_res_sn', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_res_sn
end subroutine psget_id_res_sn


subroutine psgetrnk_id_res_sn(iobj, ndims, ierr)
    !! 'Array of IDs for res_sn profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_res_sn


subroutine psgetdim_id_res_sn(iobj, ndims, dims, ierr)
    !! 'Array of IDs for res_sn profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_res_sn', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_res_sn ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_res_sn)
    endif
end subroutine psgetdim_id_res_sn


subroutine psget_id_vie_trans(iobj, data, ierr)
    !! 'ID for vie_trans profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_vie_trans', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_vie_trans
end subroutine psget_id_vie_trans


subroutine psget_id_upwind_pfrac_ns(iobj, n1, data, ierr)
    !! 'Array of IDs for upwind_pfrac_ns profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_upwind_pfrac_ns', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_upwind_pfrac_ns
end subroutine psget_id_upwind_pfrac_ns


subroutine psgetrnk_id_upwind_pfrac_ns(iobj, ndims, ierr)
    !! 'Array of IDs for upwind_pfrac_ns profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_upwind_pfrac_ns


subroutine psgetdim_id_upwind_pfrac_ns(iobj, ndims, dims, ierr)
    !! 'Array of IDs for upwind_pfrac_ns profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_upwind_pfrac_ns', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_upwind_pfrac_ns ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_upwind_pfrac_ns)
    endif
end subroutine psgetdim_id_upwind_pfrac_ns


subroutine psget_id_z_geo(iobj, data, ierr)
    !! 'ID for Z_geo profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_z_geo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_z_geo
end subroutine psget_id_z_geo


subroutine psget_id_jdotb(iobj, data, ierr)
    !! 'ID for jdotb profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_jdotb', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_jdotb
end subroutine psget_id_jdotb


subroutine psget_id_brrz(iobj, data, ierr)
    !! 'ID for BRRZ profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_brrz', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_brrz
end subroutine psget_id_brrz


subroutine psget_id_grho2r3i(iobj, data, ierr)
    !! 'ID for grho2r3i profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_grho2r3i', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_grho2r3i
end subroutine psget_id_grho2r3i


subroutine psget_id_psmom_nc(iobj, n1, data, ierr)
    !! 'Array of IDs for psmom_nc profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_psmom_nc', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_psmom_nc
end subroutine psget_id_psmom_nc


subroutine psgetrnk_id_psmom_nc(iobj, ndims, ierr)
    !! 'Array of IDs for psmom_nc profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_psmom_nc


subroutine psgetdim_id_psmom_nc(iobj, ndims, dims, ierr)
    !! 'Array of IDs for psmom_nc profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_psmom_nc', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_psmom_nc ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_psmom_nc)
    endif
end subroutine psgetdim_id_psmom_nc


subroutine psget_id_z_surfmin(iobj, data, ierr)
    !! 'ID for Z_surfMin profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_z_surfmin', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_z_surfmin
end subroutine psget_id_z_surfmin


subroutine psget_id_squarelo(iobj, data, ierr)
    !! 'ID for squareLO profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_squarelo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_squarelo
end subroutine psget_id_squarelo


subroutine psget_id_pmine(iobj, data, ierr)
    !! 'ID for pmine profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_pmine', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_pmine
end subroutine psget_id_pmine


subroutine psget_id_qbeami(iobj, n1, data, ierr)
    !! 'Array of IDs for qbeami profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_qbeami', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_qbeami
end subroutine psget_id_qbeami


subroutine psgetrnk_id_qbeami(iobj, ndims, ierr)
    !! 'Array of IDs for qbeami profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_qbeami


subroutine psgetdim_id_qbeami(iobj, ndims, dims, ierr)
    !! 'Array of IDs for qbeami profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_qbeami', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_qbeami ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_qbeami)
    endif
end subroutine psgetdim_id_qbeami


subroutine psget_id_sbtherm(iobj, n1, data, ierr)
    !! 'Array of IDs for sbtherm profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_sbtherm', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_sbtherm
end subroutine psget_id_sbtherm


subroutine psgetrnk_id_sbtherm(iobj, ndims, ierr)
    !! 'Array of IDs for sbtherm profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_sbtherm


subroutine psgetdim_id_sbtherm(iobj, ndims, dims, ierr)
    !! 'Array of IDs for sbtherm profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_sbtherm', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_sbtherm ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_sbtherm)
    endif
end subroutine psgetdim_id_sbtherm


subroutine psget_id_n0_halo(iobj, n1, data, ierr)
    !! 'Array of IDs for n0_halo profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_n0_halo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_n0_halo
end subroutine psget_id_n0_halo


subroutine psgetrnk_id_n0_halo(iobj, ndims, ierr)
    !! 'Array of IDs for n0_halo profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_n0_halo


subroutine psgetdim_id_n0_halo(iobj, ndims, dims, ierr)
    !! 'Array of IDs for n0_halo profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_n0_halo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_n0_halo ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_n0_halo)
    endif
end subroutine psgetdim_id_n0_halo


subroutine psget_id_pfuse(iobj, data, ierr)
    !! 'ID for pfuse profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_pfuse', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_pfuse
end subroutine psget_id_pfuse


subroutine psget_id_cur_rw(iobj, data, ierr)
    !! 'ID for cur_rw profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_cur_rw', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_cur_rw
end subroutine psget_id_cur_rw


subroutine psget_id_qioniz(iobj, n1, data, ierr)
    !! 'Array of IDs for qioniz profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_qioniz', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_qioniz
end subroutine psget_id_qioniz


subroutine psgetrnk_id_qioniz(iobj, ndims, ierr)
    !! 'Array of IDs for qioniz profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_qioniz


subroutine psgetdim_id_qioniz(iobj, ndims, dims, ierr)
    !! 'Array of IDs for qioniz profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_qioniz', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_qioniz ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_qioniz)
    endif
end subroutine psgetdim_id_qioniz


subroutine psget_id_omeg0sc0(iobj, n1, n2, data, ierr)
    !! 'Array of IDs for omeg0sc0 profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_omeg0sc0', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % id_omeg0sc0
end subroutine psget_id_omeg0sc0


subroutine psgetrnk_id_omeg0sc0(iobj, ndims, ierr)
    !! 'Array of IDs for omeg0sc0 profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_id_omeg0sc0


subroutine psgetdim_id_omeg0sc0(iobj, ndims, dims, ierr)
    !! 'Array of IDs for omeg0sc0 profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_id_omeg0sc0', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_omeg0sc0 ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_omeg0sc0)
    endif
end subroutine psgetdim_id_omeg0sc0


subroutine psget_id_n0_reco(iobj, n1, data, ierr)
    !! 'Array of IDs for n0_reco profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_n0_reco', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_n0_reco
end subroutine psget_id_n0_reco


subroutine psgetrnk_id_n0_reco(iobj, ndims, ierr)
    !! 'Array of IDs for n0_reco profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_n0_reco


subroutine psgetdim_id_n0_reco(iobj, ndims, dims, ierr)
    !! 'Array of IDs for n0_reco profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_n0_reco', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_n0_reco ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_n0_reco)
    endif
end subroutine psgetdim_id_n0_reco


subroutine psget_id_pilh_src(iobj, n1, data, ierr)
    !! 'Array of IDs for pilh_src profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_pilh_src', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_pilh_src
end subroutine psget_id_pilh_src


subroutine psgetrnk_id_pilh_src(iobj, ndims, ierr)
    !! 'Array of IDs for pilh_src profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_pilh_src


subroutine psgetdim_id_pilh_src(iobj, ndims, dims, ierr)
    !! 'Array of IDs for pilh_src profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_pilh_src', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_pilh_src ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_pilh_src)
    endif
end subroutine psgetdim_id_pilh_src


subroutine psget_id_velb_fusi(iobj, data, ierr)
    !! 'ID for velb_fusi profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_velb_fusi', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_velb_fusi
end subroutine psget_id_velb_fusi


subroutine psget_id_bidiff_btrap(iobj, n1, data, ierr)
    !! 'Array of IDs for bidiff_btrap profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_bidiff_btrap', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_bidiff_btrap
end subroutine psget_id_bidiff_btrap


subroutine psgetrnk_id_bidiff_btrap(iobj, ndims, ierr)
    !! 'Array of IDs for bidiff_btrap profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_bidiff_btrap


subroutine psgetdim_id_bidiff_btrap(iobj, ndims, dims, ierr)
    !! 'Array of IDs for bidiff_btrap profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_bidiff_btrap', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_bidiff_btrap ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_bidiff_btrap)
    endif
end subroutine psgetdim_id_bidiff_btrap


subroutine psget_id_velti_anom(iobj, data, ierr)
    !! 'ID for velti_anom profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_velti_anom', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_velti_anom
end subroutine psget_id_velti_anom


subroutine psget_id_ne_ky_tglf(iobj, n1, data, ierr)
    !! 'Array of IDs for ne_ky_tglf profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_ne_ky_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_ne_ky_tglf
end subroutine psget_id_ne_ky_tglf


subroutine psgetrnk_id_ne_ky_tglf(iobj, ndims, ierr)
    !! 'Array of IDs for ne_ky_tglf profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_ne_ky_tglf


subroutine psgetdim_id_ne_ky_tglf(iobj, ndims, dims, ierr)
    !! 'Array of IDs for ne_ky_tglf profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_ne_ky_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_ne_ky_tglf ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_ne_ky_tglf)
    endif
end subroutine psgetdim_id_ne_ky_tglf


subroutine psget_id_tiflux_ky_tglf(iobj, n1, data, ierr)
    !! 'Array of IDs for tiflux_ky_tglf profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_tiflux_ky_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_tiflux_ky_tglf
end subroutine psget_id_tiflux_ky_tglf


subroutine psgetrnk_id_tiflux_ky_tglf(iobj, ndims, ierr)
    !! 'Array of IDs for tiflux_ky_tglf profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_tiflux_ky_tglf


subroutine psgetdim_id_tiflux_ky_tglf(iobj, ndims, dims, ierr)
    !! 'Array of IDs for tiflux_ky_tglf profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_tiflux_ky_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_tiflux_ky_tglf ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_tiflux_ky_tglf)
    endif
end subroutine psgetdim_id_tiflux_ky_tglf


subroutine psget_id_dqedgrdte_tglf(iobj, data, ierr)
    !! 'ID for dQedGrdte_tglf profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_dqedgrdte_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_dqedgrdte_tglf
end subroutine psget_id_dqedgrdte_tglf


subroutine psget_id_chie_mmm71(iobj, data, ierr)
    !! 'ID for chie_mmm71 profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_chie_mmm71', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_chie_mmm71
end subroutine psget_id_chie_mmm71


subroutine psget_id_velpphi_mmm71(iobj, data, ierr)
    !! 'ID for velpphi_mmm71 profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_velpphi_mmm71', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_velpphi_mmm71
end subroutine psget_id_velpphi_mmm71


subroutine psget_id_velni_drbm(iobj, data, ierr)
    !! 'ID for velni_drbm profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_velni_drbm', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_velni_drbm
end subroutine psget_id_velni_drbm


subroutine psget_id_kyrhos_mtm(iobj, data, ierr)
    !! 'ID for kyrhos_mtm profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_kyrhos_mtm', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_kyrhos_mtm
end subroutine psget_id_kyrhos_mtm


subroutine psget_id_difns_glf(iobj, n1, data, ierr)
    !! 'Array of IDs for difns_glf profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_difns_glf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_difns_glf
end subroutine psget_id_difns_glf


subroutine psgetrnk_id_difns_glf(iobj, ndims, ierr)
    !! 'Array of IDs for difns_glf profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_difns_glf


subroutine psgetdim_id_difns_glf(iobj, ndims, dims, ierr)
    !! 'Array of IDs for difns_glf profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_difns_glf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_difns_glf ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_difns_glf)
    endif
end subroutine psgetdim_id_difns_glf


subroutine psget_id_chii_neo(iobj, data, ierr)
    !! 'ID for chii_neo profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_chii_neo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_chii_neo
end subroutine psget_id_chii_neo


subroutine psget_id_difne_nclass(iobj, data, ierr)
    !! 'ID for difne_nclass profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_difne_nclass', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_difne_nclass
end subroutine psget_id_difne_nclass


subroutine psget_id_chii_ntm(iobj, data, ierr)
    !! 'ID for chii_ntm profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_chii_ntm', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_chii_ntm
end subroutine psget_id_chii_ntm

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


SUBROUTINE plasma_state_empty_alloc_0(ss,iout,ierr)


  ! Allocate array data for which all dimensions are provided

  USE plasma_state_definition_mod
  IMPLICIT NONE

  TYPE (plasma_state) :: ss  ! state containing array elements to be allocated
  INTEGER, INTENT(IN) :: iout
  INTEGER, INTENT(INOUT) :: ierr  ! completion code (not cleared,set on error)

  !-------------------
  INTEGER :: isize,jsize
  !-------------------


  !-----------------------------------------------
  ! allocate arrays...

  isize = (ss%nspec_alla+1)
  IF(ss%nspec_alla.LE.0) isize = 0
  IF(ALLOCATED(ss%alla_index).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%alla_index)
  ENDIF
  IF(ALLOCATED(ss%alla_index)) then
     jsize = SIZE(ss%alla_index)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: alla_index already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%alla_index(0:ss%nspec_alla))
     ss%alla_index = 0
  ENDIF

  isize = (ss%nspec_alla+1)
  IF(ss%nspec_alla.LE.0) isize = 0
  IF(ALLOCATED(ss%ALLA_name).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%ALLA_name)
  ENDIF
  IF(ALLOCATED(ss%ALLA_name)) then
     jsize = SIZE(ss%ALLA_name)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: ALLA_name already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%ALLA_name(0:ss%nspec_alla))
     ss%ALLA_name = " "
  ENDIF

  isize = (ss%nspec_alla+1)
  IF(ss%nspec_alla.LE.0) isize = 0
  IF(ALLOCATED(ss%ALLA_type).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%ALLA_type)
  ENDIF
  IF(ALLOCATED(ss%ALLA_type)) then
     jsize = SIZE(ss%ALLA_type)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: ALLA_type already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%ALLA_type(0:ss%nspec_alla))
     ss%ALLA_type = 0
  ENDIF

  isize = (ss%nspec_all+1)
  IF(ss%nspec_all.LE.0) isize = 0
  IF(ALLOCATED(ss%all_index).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%all_index)
  ENDIF
  IF(ALLOCATED(ss%all_index)) then
     jsize = SIZE(ss%all_index)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: all_index already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%all_index(0:ss%nspec_all))
     ss%all_index = 0
  ENDIF

  isize = (ss%nspec_all+1)
  IF(ss%nspec_all.LE.0) isize = 0
  IF(ALLOCATED(ss%ALL_name).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%ALL_name)
  ENDIF
  IF(ALLOCATED(ss%ALL_name)) then
     jsize = SIZE(ss%ALL_name)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: ALL_name already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%ALL_name(0:ss%nspec_all))
     ss%ALL_name = " "
  ENDIF

  isize = (ss%nspec_all+1)
  IF(ss%nspec_all.LE.0) isize = 0
  IF(ALLOCATED(ss%ALL_type).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%ALL_type)
  ENDIF
  IF(ALLOCATED(ss%ALL_type)) then
     jsize = SIZE(ss%ALL_type)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: ALL_type already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%ALL_type(0:ss%nspec_all))
     ss%ALL_type = 0
  ENDIF

  isize = (ss%max_nspectrumlh_src)*(ss%nlhrf_src)
  IF(ALLOCATED(ss%amaxlh).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%amaxlh)
  ENDIF
  IF(ALLOCATED(ss%amaxlh)) then
     jsize = SIZE(ss%amaxlh)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: amaxlh already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%amaxlh(ss%max_nspectrumlh_src,ss%nlhrf_src))
     ss%amaxlh = 0.0_rspec
  ENDIF

  isize = (ss%max_nspectrumlh_src)*(ss%nlhrf_src)
  IF(ALLOCATED(ss%aminlh).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%aminlh)
  ENDIF
  IF(ALLOCATED(ss%aminlh)) then
     jsize = SIZE(ss%aminlh)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: aminlh already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%aminlh(ss%max_nspectrumlh_src,ss%nlhrf_src))
     ss%aminlh = 0.0_rspec
  ENDIF

  isize = (ss%ncoils)
  IF(ALLOCATED(ss%Ang_Href_coil).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%Ang_Href_coil)
  ENDIF
  IF(ALLOCATED(ss%Ang_Href_coil)) then
     jsize = SIZE(ss%Ang_Href_coil)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: Ang_Href_coil already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%Ang_Href_coil(ss%ncoils))
     ss%Ang_Href_coil = 0.0_rspec
  ENDIF

  isize = (ss%ncoils)
  IF(ALLOCATED(ss%Ang_Vref_coil).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%Ang_Vref_coil)
  ENDIF
  IF(ALLOCATED(ss%Ang_Vref_coil)) then
     jsize = SIZE(ss%Ang_Vref_coil)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: Ang_Vref_coil already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%Ang_Vref_coil(ss%ncoils))
     ss%Ang_Vref_coil = 0.0_rspec
  ENDIF

  isize = (ss%nefi_anom)
  IF(ALLOCATED(ss%anom_evar).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%anom_evar)
  ENDIF
  IF(ALLOCATED(ss%anom_evar)) then
     jsize = SIZE(ss%anom_evar)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: anom_evar already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%anom_evar(ss%nefi_anom))
     ss%anom_evar = 0.0_rspec
  ENDIF

  isize = (ss%nicrf_src)
  IF(ALLOCATED(ss%ant_model).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%ant_model)
  ENDIF
  IF(ALLOCATED(ss%ant_model)) then
     jsize = SIZE(ss%ant_model)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: ant_model already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%ant_model(ss%nicrf_src))
     ss%ant_model = " "
  ENDIF

  isize = (ss%nbeam)
  IF(ALLOCATED(ss%ap2_halfheight).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%ap2_halfheight)
  ENDIF
  IF(ALLOCATED(ss%ap2_halfheight)) then
     jsize = SIZE(ss%ap2_halfheight)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: ap2_halfheight already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%ap2_halfheight(ss%nbeam))
     ss%ap2_halfheight = 0.0_rspec
  ENDIF

  isize = (ss%nbeam)
  IF(ALLOCATED(ss%ap2_halfwidth).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%ap2_halfwidth)
  ENDIF
  IF(ALLOCATED(ss%ap2_halfwidth)) then
     jsize = SIZE(ss%ap2_halfwidth)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: ap2_halfwidth already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%ap2_halfwidth(ss%nbeam))
     ss%ap2_halfwidth = 0.0_rspec
  ENDIF

  isize = (ss%nbeam)
  IF(ALLOCATED(ss%ap2_horiz_offset).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%ap2_horiz_offset)
  ENDIF
  IF(ALLOCATED(ss%ap2_horiz_offset)) then
     jsize = SIZE(ss%ap2_horiz_offset)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: ap2_horiz_offset already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%ap2_horiz_offset(ss%nbeam))
     ss%ap2_horiz_offset = 0.0_rspec
  ENDIF

  isize = (ss%nbeam)
  IF(ALLOCATED(ss%ap2_vert_offset).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%ap2_vert_offset)
  ENDIF
  IF(ALLOCATED(ss%ap2_vert_offset)) then
     jsize = SIZE(ss%ap2_vert_offset)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: ap2_vert_offset already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%ap2_vert_offset(ss%nbeam))
     ss%ap2_vert_offset = 0.0_rspec
  ENDIF

  isize = (ss%max_nspectrumlh_src)*(ss%nlhrf_src)
  IF(ALLOCATED(ss%apolmaxlh).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%apolmaxlh)
  ENDIF
  IF(ALLOCATED(ss%apolmaxlh)) then
     jsize = SIZE(ss%apolmaxlh)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: apolmaxlh already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%apolmaxlh(ss%max_nspectrumlh_src,ss%nlhrf_src))
     ss%apolmaxlh = 0.0_rspec
  ENDIF

  isize = (ss%max_nspectrumlh_src)*(ss%nlhrf_src)
  IF(ALLOCATED(ss%apolminlh).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%apolminlh)
  ENDIF
  IF(ALLOCATED(ss%apolminlh)) then
     jsize = SIZE(ss%apolminlh)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: apolminlh already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%apolminlh(ss%max_nspectrumlh_src,ss%nlhrf_src))
     ss%apolminlh = 0.0_rspec
  ENDIF

  isize = (ss%nbeam)
  IF(ALLOCATED(ss%ap_halfheight).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%ap_halfheight)
  ENDIF
  IF(ALLOCATED(ss%ap_halfheight)) then
     jsize = SIZE(ss%ap_halfheight)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: ap_halfheight already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%ap_halfheight(ss%nbeam))
     ss%ap_halfheight = 0.0_rspec
  ENDIF

  isize = (ss%nbeam)
  IF(ALLOCATED(ss%ap_halfwidth).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%ap_halfwidth)
  ENDIF
  IF(ALLOCATED(ss%ap_halfwidth)) then
     jsize = SIZE(ss%ap_halfwidth)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: ap_halfwidth already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%ap_halfwidth(ss%nbeam))
     ss%ap_halfwidth = 0.0_rspec
  ENDIF

  isize = (ss%nbeam)
  IF(ALLOCATED(ss%ap_horiz_offset).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%ap_horiz_offset)
  ENDIF
  IF(ALLOCATED(ss%ap_horiz_offset)) then
     jsize = SIZE(ss%ap_horiz_offset)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: ap_horiz_offset already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%ap_horiz_offset(ss%nbeam))
     ss%ap_horiz_offset = 0.0_rspec
  ENDIF

  isize = (ss%nbeam)
  IF(ALLOCATED(ss%ap_vert_offset).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%ap_vert_offset)
  ENDIF
  IF(ALLOCATED(ss%ap_vert_offset)) then
     jsize = SIZE(ss%ap_vert_offset)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: ap_vert_offset already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%ap_vert_offset(ss%nbeam))
     ss%ap_vert_offset = 0.0_rspec
  ENDIF

  isize = (ss%nrho_eq)
  IF(ALLOCATED(ss%area).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%area)
  ENDIF
  IF(ALLOCATED(ss%area)) then
     jsize = SIZE(ss%area)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: area already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%area(ss%nrho_eq))
     ss%area = 0.0_rspec
  ENDIF

  isize = (ss%max_nspectrumlh_src)*(ss%nlhrf_src)
  IF(ALLOCATED(ss%atormaxlh).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%atormaxlh)
  ENDIF
  IF(ALLOCATED(ss%atormaxlh)) then
     jsize = SIZE(ss%atormaxlh)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: atormaxlh already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%atormaxlh(ss%max_nspectrumlh_src,ss%nlhrf_src))
     ss%atormaxlh = 0.0_rspec
  ENDIF

  isize = (ss%max_nspectrumlh_src)*(ss%nlhrf_src)
  IF(ALLOCATED(ss%atorminlh).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%atorminlh)
  ENDIF
  IF(ALLOCATED(ss%atorminlh)) then
     jsize = SIZE(ss%atorminlh)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: atorminlh already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%atorminlh(ss%max_nspectrumlh_src,ss%nlhrf_src))
     ss%atorminlh = 0.0_rspec
  ENDIF

  isize = (ss%nballoon)
  IF(ALLOCATED(ss%Balloon_code).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%Balloon_code)
  ENDIF
  IF(ALLOCATED(ss%Balloon_code)) then
     jsize = SIZE(ss%Balloon_code)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: Balloon_code already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%Balloon_code(ss%nballoon))
     ss%Balloon_code = " "
  ENDIF

  isize = (ss%nballoon)
  IF(ALLOCATED(ss%Balloon_mapper).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%Balloon_mapper)
  ENDIF
  IF(ALLOCATED(ss%Balloon_mapper)) then
     jsize = SIZE(ss%Balloon_mapper)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: Balloon_mapper already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%Balloon_mapper(ss%nballoon))
     ss%Balloon_mapper = " "
  ENDIF

  isize = (ss%nballoon)
  IF(ALLOCATED(ss%Balloon_stable).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%Balloon_stable)
  ENDIF
  IF(ALLOCATED(ss%Balloon_stable)) then
     jsize = SIZE(ss%Balloon_stable)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: Balloon_stable already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%Balloon_stable(ss%nballoon))
     ss%Balloon_stable = 0
  ENDIF

  isize = (ss%nballoon)
  IF(ALLOCATED(ss%Balloon_status).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%Balloon_status)
  ENDIF
  IF(ALLOCATED(ss%Balloon_status)) then
     jsize = SIZE(ss%Balloon_status)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: Balloon_status already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%Balloon_status(ss%nballoon))
     ss%Balloon_status = 0
  ENDIF

  isize = (ss%nrho_lmhd)
  IF(ALLOCATED(ss%balstab).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%balstab)
  ENDIF
  IF(ALLOCATED(ss%balstab)) then
     jsize = SIZE(ss%balstab)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: balstab already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%balstab(ss%nrho_lmhd))
     ss%balstab = 0.0_rspec
  ENDIF

  isize = (ss%nbeam)
  IF(ALLOCATED(ss%beam_type).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%beam_type)
  ENDIF
  IF(ALLOCATED(ss%beam_type)) then
     jsize = SIZE(ss%beam_type)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: beam_type already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%beam_type(ss%nbeam))
     ss%beam_type = " "
  ENDIF

  isize = (ss%nefi_anom2)*(ss%nrho_anom2)*(ss%nspec_beam)
  IF(ALLOCATED(ss%bidiff_bpass_co).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%bidiff_bpass_co)
  ENDIF
  IF(ALLOCATED(ss%bidiff_bpass_co)) then
     jsize = SIZE(ss%bidiff_bpass_co)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: bidiff_bpass_co already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%bidiff_bpass_co(ss%nefi_anom2,ss%nrho_anom2,ss%nspec_beam))
     ss%bidiff_bpass_co = 0.0_rspec
     ALLOCATE(ss%id_bidiff_bpass_co(ss%nspec_beam))
     ss%id_bidiff_bpass_co = 0
  ENDIF

  isize = (ss%nefi_anom2)*(ss%nrho_anom2)*(ss%nspec_beam)
  IF(ALLOCATED(ss%bidiff_bpass_ctr).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%bidiff_bpass_ctr)
  ENDIF
  IF(ALLOCATED(ss%bidiff_bpass_ctr)) then
     jsize = SIZE(ss%bidiff_bpass_ctr)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: bidiff_bpass_ctr already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%bidiff_bpass_ctr(ss%nefi_anom2,ss%nrho_anom2,ss%nspec_beam))
     ss%bidiff_bpass_ctr = 0.0_rspec
     ALLOCATE(ss%id_bidiff_bpass_ctr(ss%nspec_beam))
     ss%id_bidiff_bpass_ctr = 0
  ENDIF

  isize = (ss%nefi_anom2)*(ss%nrho_anom2)*(ss%nspec_beam)
  IF(ALLOCATED(ss%bidiff_btrap).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%bidiff_btrap)
  ENDIF
  IF(ALLOCATED(ss%bidiff_btrap)) then
     jsize = SIZE(ss%bidiff_btrap)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: bidiff_btrap already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%bidiff_btrap(ss%nefi_anom2,ss%nrho_anom2,ss%nspec_beam))
     ss%bidiff_btrap = 0.0_rspec
     ALLOCATE(ss%id_bidiff_btrap(ss%nspec_beam))
     ss%id_bidiff_btrap = 0
  ENDIF

  isize = (ss%nefi_anom2)*(ss%nrho_anom2)*(ss%nspec_beam)
  IF(ALLOCATED(ss%bidiff_dpass_co).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%bidiff_dpass_co)
  ENDIF
  IF(ALLOCATED(ss%bidiff_dpass_co)) then
     jsize = SIZE(ss%bidiff_dpass_co)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: bidiff_dpass_co already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%bidiff_dpass_co(ss%nefi_anom2,ss%nrho_anom2,ss%nspec_beam))
     ss%bidiff_dpass_co = 0.0_rspec
     ALLOCATE(ss%id_bidiff_dpass_co(ss%nspec_beam))
     ss%id_bidiff_dpass_co = 0
  ENDIF

  isize = (ss%nefi_anom2)*(ss%nrho_anom2)*(ss%nspec_beam)
  IF(ALLOCATED(ss%bidiff_dpass_ctr).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%bidiff_dpass_ctr)
  ENDIF
  IF(ALLOCATED(ss%bidiff_dpass_ctr)) then
     jsize = SIZE(ss%bidiff_dpass_ctr)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: bidiff_dpass_ctr already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%bidiff_dpass_ctr(ss%nefi_anom2,ss%nrho_anom2,ss%nspec_beam))
     ss%bidiff_dpass_ctr = 0.0_rspec
     ALLOCATE(ss%id_bidiff_dpass_ctr(ss%nspec_beam))
     ss%id_bidiff_dpass_ctr = 0
  ENDIF

  isize = (ss%nefi_anom2)*(ss%nrho_anom2)*(ss%nspec_beam)
  IF(ALLOCATED(ss%bidiff_dtrap).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%bidiff_dtrap)
  ENDIF
  IF(ALLOCATED(ss%bidiff_dtrap)) then
     jsize = SIZE(ss%bidiff_dtrap)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: bidiff_dtrap already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%bidiff_dtrap(ss%nefi_anom2,ss%nrho_anom2,ss%nspec_beam))
     ss%bidiff_dtrap = 0.0_rspec
     ALLOCATE(ss%id_bidiff_dtrap(ss%nspec_beam))
     ss%id_bidiff_dtrap = 0
  ENDIF

  isize = (ss%nr)*(ss%nz)
  IF(ALLOCATED(ss%BphiRZ).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%BphiRZ)
  ENDIF
  IF(ALLOCATED(ss%BphiRZ)) then
     jsize = SIZE(ss%BphiRZ)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: BphiRZ already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%BphiRZ(ss%nr,ss%nz))
     ss%BphiRZ = 0.0_rspec
  ENDIF

  isize = (ss%nr)*(ss%nz)
  IF(ALLOCATED(ss%BRRZ).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%BRRZ)
  ENDIF
  IF(ALLOCATED(ss%BRRZ)) then
     jsize = SIZE(ss%BRRZ)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: BRRZ already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%BRRZ(ss%nr,ss%nz))
     ss%BRRZ = 0.0_rspec
  ENDIF

  isize = (ss%nr)*(ss%nz)
  IF(ALLOCATED(ss%BZRZ).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%BZRZ)
  ENDIF
  IF(ALLOCATED(ss%BZRZ)) then
     jsize = SIZE(ss%BZRZ)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: BZRZ already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%BZRZ(ss%nr,ss%nz))
     ss%BZRZ = 0.0_rspec
  ENDIF

  isize = (ss%nbeam)
  IF(ALLOCATED(ss%b_halfHeight).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%b_halfHeight)
  ENDIF
  IF(ALLOCATED(ss%b_halfHeight)) then
     jsize = SIZE(ss%b_halfHeight)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: b_halfHeight already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%b_halfHeight(ss%nbeam))
     ss%b_halfHeight = 0.0_rspec
  ENDIF

  isize = (ss%nbeam)
  IF(ALLOCATED(ss%b_halfwidth).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%b_halfwidth)
  ENDIF
  IF(ALLOCATED(ss%b_halfwidth)) then
     jsize = SIZE(ss%b_halfwidth)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: b_halfwidth already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%b_halfwidth(ss%nbeam))
     ss%b_halfwidth = 0.0_rspec
  ENDIF

  isize = (ss%nbeam)
  IF(ALLOCATED(ss%b_Hdivergence).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%b_Hdivergence)
  ENDIF
  IF(ALLOCATED(ss%b_Hdivergence)) then
     jsize = SIZE(ss%b_Hdivergence)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: b_Hdivergence already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%b_Hdivergence(ss%nbeam))
     ss%b_Hdivergence = 0.0_rspec
  ENDIF

  isize = (ss%nbeam)
  IF(ALLOCATED(ss%b_Hfocal_length).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%b_Hfocal_length)
  ENDIF
  IF(ALLOCATED(ss%b_Hfocal_length)) then
     jsize = SIZE(ss%b_Hfocal_length)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: b_Hfocal_length already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%b_Hfocal_length(ss%nbeam))
     ss%b_Hfocal_length = 0.0_rspec
  ENDIF

  isize = (ss%nrho_eq_geo)
  IF(ALLOCATED(ss%B_surfMax).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%B_surfMax)
  ENDIF
  IF(ALLOCATED(ss%B_surfMax)) then
     jsize = SIZE(ss%B_surfMax)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: B_surfMax already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%B_surfMax(ss%nrho_eq_geo))
     ss%B_surfMax = 0.0_rspec
  ENDIF

  isize = (ss%nrho_eq_geo)
  IF(ALLOCATED(ss%B_surfMin).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%B_surfMin)
  ENDIF
  IF(ALLOCATED(ss%B_surfMin)) then
     jsize = SIZE(ss%B_surfMin)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: B_surfMin already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%B_surfMin(ss%nrho_eq_geo))
     ss%B_surfMin = 0.0_rspec
  ENDIF

  isize = (ss%nbeam)
  IF(ALLOCATED(ss%b_Vdivergence).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%b_Vdivergence)
  ENDIF
  IF(ALLOCATED(ss%b_Vdivergence)) then
     jsize = SIZE(ss%b_Vdivergence)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: b_Vdivergence already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%b_Vdivergence(ss%nbeam))
     ss%b_Vdivergence = 0.0_rspec
  ENDIF

  isize = (ss%nbeam)
  IF(ALLOCATED(ss%b_Vfocal_length).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%b_Vfocal_length)
  ENDIF
  IF(ALLOCATED(ss%b_Vfocal_length)) then
     jsize = SIZE(ss%b_Vfocal_length)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: b_Vfocal_length already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%b_Vfocal_length(ss%nbeam))
     ss%b_Vfocal_length = 0.0_rspec
  ENDIF

  isize = (ss%nrho_icrf-1)*(ss%nicrf_src)
  IF(ALLOCATED(ss%cdicrf).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%cdicrf)
  ENDIF
  IF(ALLOCATED(ss%cdicrf)) then
     jsize = SIZE(ss%cdicrf)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: cdicrf already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%cdicrf(ss%nrho_icrf-1,ss%nicrf_src))
     ss%cdicrf = 0.0_rspec
     ALLOCATE(ss%id_cdicrf(ss%nicrf_src))
     ss%id_cdicrf = 0
  ENDIF

  isize = (ss%nrho_icrf-1)*(ss%max_num_nphi)*(ss%nicrf_src)
  IF(ALLOCATED(ss%cdicrf_nphi).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%cdicrf_nphi)
  ENDIF
  IF(ALLOCATED(ss%cdicrf_nphi)) then
     jsize = SIZE(ss%cdicrf_nphi)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: cdicrf_nphi already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%cdicrf_nphi(ss%nrho_icrf-1,ss%max_num_nphi,ss%nicrf_src))
     ss%cdicrf_nphi = 0.0_rspec
     ALLOCATE(ss%id_cdicrf_nphi(ss%max_num_nphi,ss%nicrf_src))
     ss%id_cdicrf_nphi = 0
  ENDIF

  isize = (ss%nrho_anomth)
  IF(ALLOCATED(ss%chie_anom).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%chie_anom)
  ENDIF
  IF(ALLOCATED(ss%chie_anom)) then
     jsize = SIZE(ss%chie_anom)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: chie_anom already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%chie_anom(ss%nrho_anomth))
     ss%chie_anom = 0.0_rspec
  ENDIF

  isize = (ss%nrho_anomth)
  IF(ALLOCATED(ss%chie_drbm).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%chie_drbm)
  ENDIF
  IF(ALLOCATED(ss%chie_drbm)) then
     jsize = SIZE(ss%chie_drbm)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: chie_drbm already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%chie_drbm(ss%nrho_anomth))
     ss%chie_drbm = 0.0_rspec
  ENDIF

  isize = (ss%nrho_anomth)
  IF(ALLOCATED(ss%chie_etg).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%chie_etg)
  ENDIF
  IF(ALLOCATED(ss%chie_etg)) then
     jsize = SIZE(ss%chie_etg)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: chie_etg already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%chie_etg(ss%nrho_anomth))
     ss%chie_etg = 0.0_rspec
  ENDIF

  isize = (ss%nrho_anomth)
  IF(ALLOCATED(ss%chie_glf).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%chie_glf)
  ENDIF
  IF(ALLOCATED(ss%chie_glf)) then
     jsize = SIZE(ss%chie_glf)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: chie_glf already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%chie_glf(ss%nrho_anomth))
     ss%chie_glf = 0.0_rspec
  ENDIF

  isize = (ss%nrho_anomth)
  IF(ALLOCATED(ss%chie_gtcneo).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%chie_gtcneo)
  ENDIF
  IF(ALLOCATED(ss%chie_gtcneo)) then
     jsize = SIZE(ss%chie_gtcneo)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: chie_gtcneo already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%chie_gtcneo(ss%nrho_anomth))
     ss%chie_gtcneo = 0.0_rspec
  ENDIF

  isize = (ss%nrho_anomth)
  IF(ALLOCATED(ss%chie_mmm71).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%chie_mmm71)
  ENDIF
  IF(ALLOCATED(ss%chie_mmm71)) then
     jsize = SIZE(ss%chie_mmm71)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: chie_mmm71 already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%chie_mmm71(ss%nrho_anomth))
     ss%chie_mmm71 = 0.0_rspec
  ENDIF

  isize = (ss%nrho_anomth)
  IF(ALLOCATED(ss%chie_mtm).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%chie_mtm)
  ENDIF
  IF(ALLOCATED(ss%chie_mtm)) then
     jsize = SIZE(ss%chie_mtm)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: chie_mtm already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%chie_mtm(ss%nrho_anomth))
     ss%chie_mtm = 0.0_rspec
  ENDIF

  isize = (ss%nrho_anomth)
  IF(ALLOCATED(ss%chie_nclass).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%chie_nclass)
  ENDIF
  IF(ALLOCATED(ss%chie_nclass)) then
     jsize = SIZE(ss%chie_nclass)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: chie_nclass already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%chie_nclass(ss%nrho_anomth))
     ss%chie_nclass = 0.0_rspec
  ENDIF

  isize = (ss%nrho_anomth)
  IF(ALLOCATED(ss%chie_neo).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%chie_neo)
  ENDIF
  IF(ALLOCATED(ss%chie_neo)) then
     jsize = SIZE(ss%chie_neo)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: chie_neo already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%chie_neo(ss%nrho_anomth))
     ss%chie_neo = 0.0_rspec
  ENDIF

  isize = (ss%nrho_anomth)
  IF(ALLOCATED(ss%chie_ntm).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%chie_ntm)
  ENDIF
  IF(ALLOCATED(ss%chie_ntm)) then
     jsize = SIZE(ss%chie_ntm)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: chie_ntm already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%chie_ntm(ss%nrho_anomth))
     ss%chie_ntm = 0.0_rspec
  ENDIF

  isize = (ss%nrho_anomth)
  IF(ALLOCATED(ss%chie_paleo).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%chie_paleo)
  ENDIF
  IF(ALLOCATED(ss%chie_paleo)) then
     jsize = SIZE(ss%chie_paleo)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: chie_paleo already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%chie_paleo(ss%nrho_anomth))
     ss%chie_paleo = 0.0_rspec
  ENDIF

  isize = (ss%nrho_anomth)
  IF(ALLOCATED(ss%chie_tglf).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%chie_tglf)
  ENDIF
  IF(ALLOCATED(ss%chie_tglf)) then
     jsize = SIZE(ss%chie_tglf)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: chie_tglf already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%chie_tglf(ss%nrho_anomth))
     ss%chie_tglf = 0.0_rspec
  ENDIF

  isize = (ss%nrho)
  IF(ALLOCATED(ss%chie_trans).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%chie_trans)
  ENDIF
  IF(ALLOCATED(ss%chie_trans)) then
     jsize = SIZE(ss%chie_trans)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: chie_trans already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%chie_trans(ss%nrho))
     ss%chie_trans = 0.0_rspec
  ENDIF

  isize = (ss%nrho)*(ss%ntrcat)
  IF(ALLOCATED(ss%chie_transcat).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%chie_transcat)
  ENDIF
  IF(ALLOCATED(ss%chie_transcat)) then
     jsize = SIZE(ss%chie_transcat)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: chie_transcat already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%chie_transcat(ss%nrho,ss%ntrcat))
     ss%chie_transcat = 0.0_rspec
     ALLOCATE(ss%id_chie_transcat(ss%ntrcat))
     ss%id_chie_transcat = 0
  ENDIF

  isize = (ss%nrho_anomth)
  IF(ALLOCATED(ss%chie_w19).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%chie_w19)
  ENDIF
  IF(ALLOCATED(ss%chie_w19)) then
     jsize = SIZE(ss%chie_w19)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: chie_w19 already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%chie_w19(ss%nrho_anomth))
     ss%chie_w19 = 0.0_rspec
  ENDIF

  isize = (ss%nrho_anomth)
  IF(ALLOCATED(ss%chii_anom).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%chii_anom)
  ENDIF
  IF(ALLOCATED(ss%chii_anom)) then
     jsize = SIZE(ss%chii_anom)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: chii_anom already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%chii_anom(ss%nrho_anomth))
     ss%chii_anom = 0.0_rspec
  ENDIF

  isize = (ss%nrho_anomth)
  IF(ALLOCATED(ss%chii_drbm).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%chii_drbm)
  ENDIF
  IF(ALLOCATED(ss%chii_drbm)) then
     jsize = SIZE(ss%chii_drbm)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: chii_drbm already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%chii_drbm(ss%nrho_anomth))
     ss%chii_drbm = 0.0_rspec
  ENDIF

  isize = (ss%nrho_anomth)
  IF(ALLOCATED(ss%chii_glf).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%chii_glf)
  ENDIF
  IF(ALLOCATED(ss%chii_glf)) then
     jsize = SIZE(ss%chii_glf)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: chii_glf already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%chii_glf(ss%nrho_anomth))
     ss%chii_glf = 0.0_rspec
  ENDIF

  isize = (ss%nrho_anomth)
  IF(ALLOCATED(ss%chii_gtcneo).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%chii_gtcneo)
  ENDIF
  IF(ALLOCATED(ss%chii_gtcneo)) then
     jsize = SIZE(ss%chii_gtcneo)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: chii_gtcneo already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%chii_gtcneo(ss%nrho_anomth))
     ss%chii_gtcneo = 0.0_rspec
  ENDIF

  isize = (ss%nrho_anomth)
  IF(ALLOCATED(ss%chii_mmm71).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%chii_mmm71)
  ENDIF
  IF(ALLOCATED(ss%chii_mmm71)) then
     jsize = SIZE(ss%chii_mmm71)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: chii_mmm71 already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%chii_mmm71(ss%nrho_anomth))
     ss%chii_mmm71 = 0.0_rspec
  ENDIF

  isize = (ss%nrho_anomth)
  IF(ALLOCATED(ss%chii_nclass).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%chii_nclass)
  ENDIF
  IF(ALLOCATED(ss%chii_nclass)) then
     jsize = SIZE(ss%chii_nclass)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: chii_nclass already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%chii_nclass(ss%nrho_anomth))
     ss%chii_nclass = 0.0_rspec
  ENDIF

  isize = (ss%nrho_anomth)
  IF(ALLOCATED(ss%chii_neo).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%chii_neo)
  ENDIF
  IF(ALLOCATED(ss%chii_neo)) then
     jsize = SIZE(ss%chii_neo)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: chii_neo already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%chii_neo(ss%nrho_anomth))
     ss%chii_neo = 0.0_rspec
  ENDIF

END SUBROUTINE plasma_state_empty_alloc_0

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_s7_dummy
     return
  end subroutine ccps_getset_s7_dummy

subroutine psget_srtcen(iobj, n1, data, ierr)
    !! signed tangency radius, This is the major radius of tangency
    !! of the neutral beam centerlines--, i.e. the distance of closest
    !! approach of each beam centerline to the, machine axis, in
    !! meters., Sign convention: + for beams which impart angular
    !! momentum in the, counter-clockwise direction around the torus
    !! as viewed from above.
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_srtcen', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % sRtcen
end subroutine psget_srtcen


subroutine psset_srtcen(iobj, n1, data, ierr)
    !! signed tangency radius, This is the major radius of tangency
    !! of the neutral beam centerlines--, i.e. the distance of closest
    !! approach of each beam centerline to the, machine axis, in
    !! meters., Sign convention: + for beams which impart angular
    !! momentum in the, counter-clockwise direction around the torus
    !! as viewed from above.
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_srtcen', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % sRtcen = data(1:n1)
end subroutine psset_srtcen


subroutine psgetrnk_srtcen(iobj, ndims, ierr)
    !! signed tangency radius, This is the major radius of tangency
    !! of the neutral beam centerlines--, i.e. the distance of closest
    !! approach of each beam centerline to the, machine axis, in
    !! meters., Sign convention: + for beams which impart angular
    !! momentum in the, counter-clockwise direction around the torus
    !! as viewed from above.
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_srtcen


subroutine psgetdim_srtcen(iobj, ndims, dims, ierr)
    !! signed tangency radius, This is the major radius of tangency
    !! of the neutral beam centerlines--, i.e. the distance of closest
    !! approach of each beam centerline to the, machine axis, in
    !! meters., Sign convention: + for beams which impart angular
    !! momentum in the, counter-clockwise direction around the torus
    !! as viewed from above.
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_srtcen', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % sRtcen ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % sRtcen)
    endif
end subroutine psgetdim_srtcen


subroutine psget_sa_name(iobj, n1, data, ierr)
    !! thermal species abridged, (index 0 for electrons)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    CHARACTER*(*), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_sa_name', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % SA_name
end subroutine psget_sa_name


subroutine psset_sa_name(iobj, n1, data, ierr)
    !! thermal species abridged, (index 0 for electrons)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    CHARACTER*(*), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_sa_name', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % SA_name = data(1:n1)
end subroutine psset_sa_name


subroutine psgetsz_sa_name(iobj, size, ierr)
    !! thermal species abridged, (index 0 for electrons)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: size    ! size of character string
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psgetsz_sa_name', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! note that the following will return the character length size regardless of
    ! the number of array elements (if SA_name is an array)
    size = len(ss % SA_name)
end subroutine psgetsz_sa_name


subroutine psgetrnk_sa_name(iobj, ndims, ierr)
    !! thermal species abridged, (index 0 for electrons)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_sa_name


subroutine psgetdim_sa_name(iobj, ndims, dims, ierr)
    !! thermal species abridged, (index 0 for electrons)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_sa_name', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % SA_name ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % SA_name)
    endif
end subroutine psgetdim_sa_name


subroutine psget_snbi_to_all(iobj, n1, data, ierr)
    !! map snbi index to "all" list
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_snbi_to_all', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % snbi_to_all
end subroutine psget_snbi_to_all


subroutine psset_snbi_to_all(iobj, n1, data, ierr)
    !! map snbi index to "all" list
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_snbi_to_all', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % snbi_to_all = data(1:n1)
end subroutine psset_snbi_to_all


subroutine psgetrnk_snbi_to_all(iobj, ndims, ierr)
    !! map snbi index to "all" list
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_snbi_to_all


subroutine psgetdim_snbi_to_all(iobj, ndims, dims, ierr)
    !! map snbi index to "all" list
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_snbi_to_all', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % snbi_to_all ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % snbi_to_all)
    endif
end subroutine psgetdim_snbi_to_all


subroutine psget_sn_transcat(iobj, n1, n2, n3, data, ierr)
    !! species transport
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2, n3 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2, n3) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_sn_transcat', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2, 1: n3) = ss % sn_transcat
end subroutine psget_sn_transcat


subroutine psset_sn_transcat(iobj, n1, n2, n3, data, ierr)
    !! species transport
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2, n3 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2, n3) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_sn_transcat', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % sn_transcat = data(1:n1, 1: n2, 1: n3)
end subroutine psset_sn_transcat


subroutine psgetrnk_sn_transcat(iobj, ndims, ierr)
    !! species transport
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 3
end subroutine psgetrnk_sn_transcat


subroutine psgetdim_sn_transcat(iobj, ndims, dims, ierr)
    !! species transport
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 3) ierr = 1
    call ccps_argcheck('psgetdim_sn_transcat', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % sn_transcat ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % sn_transcat)
    endif
end subroutine psgetdim_sn_transcat


subroutine psget_sbsce(iobj, n1, n2, data, ierr)
    !! net source, thermal ions & electrons, ...cold electron
    !! deposition; ion thermalization;, corrections for charge
    !! exchange (beam deposition halo, mainly),, halo recapture, for
    !! thermal ions:, sbsce = sbtherm - sb0halo + sb0halo_recap,
    !! (caution: sbtherm is defined over beam species list;, sbsce
    !! over thermal species list;, sb0halo & sb0halo_recap over the
    !! neutral gas species list)., for electrons:, sbsce = sbedep +
    !! sbehalo
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_sbsce', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % sbsce
end subroutine psget_sbsce


subroutine psset_sbsce(iobj, n1, n2, data, ierr)
    !! net source, thermal ions & electrons, ...cold electron
    !! deposition; ion thermalization;, corrections for charge
    !! exchange (beam deposition halo, mainly),, halo recapture, for
    !! thermal ions:, sbsce = sbtherm - sb0halo + sb0halo_recap,
    !! (caution: sbtherm is defined over beam species list;, sbsce
    !! over thermal species list;, sb0halo & sb0halo_recap over the
    !! neutral gas species list)., for electrons:, sbsce = sbedep +
    !! sbehalo
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_sbsce', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % sbsce = data(1:n1, 1: n2)
end subroutine psset_sbsce


subroutine psgetrnk_sbsce(iobj, ndims, ierr)
    !! net source, thermal ions & electrons, ...cold electron
    !! deposition; ion thermalization;, corrections for charge
    !! exchange (beam deposition halo, mainly),, halo recapture, for
    !! thermal ions:, sbsce = sbtherm - sb0halo + sb0halo_recap,
    !! (caution: sbtherm is defined over beam species list;, sbsce
    !! over thermal species list;, sb0halo & sb0halo_recap over the
    !! neutral gas species list)., for electrons:, sbsce = sbedep +
    !! sbehalo
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_sbsce


subroutine psgetdim_sbsce(iobj, ndims, dims, ierr)
    !! net source, thermal ions & electrons, ...cold electron
    !! deposition; ion thermalization;, corrections for charge
    !! exchange (beam deposition halo, mainly),, halo recapture, for
    !! thermal ions:, sbsce = sbtherm - sb0halo + sb0halo_recap,
    !! (caution: sbtherm is defined over beam species list;, sbsce
    !! over thermal species list;, sb0halo & sb0halo_recap over the
    !! neutral gas species list)., for electrons:, sbsce = sbedep +
    !! sbehalo
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_sbsce', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % sbsce ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % sbsce)
    endif
end subroutine psgetdim_sbsce


subroutine psget_sc_anom(iobj, n1, n2, data, ierr)
    !! anomalous sources
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_sc_anom', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % sc_anom
end subroutine psget_sc_anom


subroutine psset_sc_anom(iobj, n1, n2, data, ierr)
    !! anomalous sources
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_sc_anom', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % sc_anom = data(1:n1, 1: n2)
end subroutine psset_sc_anom


subroutine psgetrnk_sc_anom(iobj, ndims, ierr)
    !! anomalous sources
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_sc_anom


subroutine psgetdim_sc_anom(iobj, ndims, dims, ierr)
    !! anomalous sources
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_sc_anom', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % sc_anom ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % sc_anom)
    endif
end subroutine psgetdim_sc_anom

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_i6_dummy
     return
  end subroutine ccps_getset_i6_dummy

subroutine psget_icrf_src_name(iobj, n1, data, ierr)
    !! number & name of ICRF sources
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    CHARACTER*(*), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_icrf_src_name', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % icrf_src_name
end subroutine psget_icrf_src_name


subroutine psset_icrf_src_name(iobj, n1, data, ierr)
    !! number & name of ICRF sources
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    CHARACTER*(*), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_icrf_src_name', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % icrf_src_name = data(1:n1)
end subroutine psset_icrf_src_name


subroutine psgetsz_icrf_src_name(iobj, size, ierr)
    !! number & name of ICRF sources
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: size    ! size of character string
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psgetsz_icrf_src_name', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! note that the following will return the character length size regardless of
    ! the number of array elements (if icrf_src_name is an array)
    size = len(ss % icrf_src_name)
end subroutine psgetsz_icrf_src_name


subroutine psgetrnk_icrf_src_name(iobj, ndims, ierr)
    !! number & name of ICRF sources
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_icrf_src_name


subroutine psgetdim_icrf_src_name(iobj, ndims, dims, ierr)
    !! number & name of ICRF sources
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_icrf_src_name', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % icrf_src_name ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % icrf_src_name)
    endif
end subroutine psgetdim_icrf_src_name


subroutine psget_id_vpol_inmp(iobj, n1, data, ierr)
    !! 'Array of IDs for vpol_inmp profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_vpol_inmp', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_vpol_inmp
end subroutine psget_id_vpol_inmp


subroutine psgetrnk_id_vpol_inmp(iobj, ndims, ierr)
    !! 'Array of IDs for vpol_inmp profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_vpol_inmp


subroutine psgetdim_id_vpol_inmp(iobj, ndims, dims, ierr)
    !! 'Array of IDs for vpol_inmp profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_vpol_inmp', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_vpol_inmp ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_vpol_inmp)
    endif
end subroutine psgetdim_id_vpol_inmp


subroutine psget_iota(iobj, n1, data, ierr)
    !! iota profile (1/q)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_iota', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % iota
end subroutine psget_iota


subroutine psset_iota(iobj, n1, data, ierr)
    !! iota profile (1/q)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_iota', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % iota = data(1:n1)
end subroutine psset_iota


subroutine psgetrnk_iota(iobj, ndims, ierr)
    !! iota profile (1/q)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_iota


subroutine psgetdim_iota(iobj, ndims, dims, ierr)
    !! iota profile (1/q)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_iota', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % iota ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % iota)
    endif
end subroutine psgetdim_iota


subroutine psget_id_iota(iobj, data, ierr)
    !! 'ID for iota profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_iota', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_iota
end subroutine psget_id_iota


subroutine psget_id_res_te(iobj, data, ierr)
    !! 'ID for res_te profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_res_te', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_res_te
end subroutine psget_id_res_te


subroutine psget_id_tq_transcat(iobj, n1, data, ierr)
    !! 'Array of IDs for tq_transcat profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_tq_transcat', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_tq_transcat
end subroutine psget_id_tq_transcat


subroutine psgetrnk_id_tq_transcat(iobj, ndims, ierr)
    !! 'Array of IDs for tq_transcat profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_tq_transcat


subroutine psgetdim_id_tq_transcat(iobj, ndims, dims, ierr)
    !! 'Array of IDs for tq_transcat profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_tq_transcat', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_tq_transcat ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_tq_transcat)
    endif
end subroutine psgetdim_id_tq_transcat


subroutine psget_id_upwind_pfrac_te(iobj, data, ierr)
    !! 'ID for upwind_pfrac_Te profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_upwind_pfrac_te', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_upwind_pfrac_te
end subroutine psget_id_upwind_pfrac_te


subroutine psget_id_chimo_transcat(iobj, n1, data, ierr)
    !! 'Array of IDs for chimo_transcat profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_chimo_transcat', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_chimo_transcat
end subroutine psget_id_chimo_transcat


subroutine psgetrnk_id_chimo_transcat(iobj, ndims, ierr)
    !! 'Array of IDs for chimo_transcat profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_chimo_transcat


subroutine psgetdim_id_chimo_transcat(iobj, ndims, dims, ierr)
    !! 'Array of IDs for chimo_transcat profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_chimo_transcat', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_chimo_transcat ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_chimo_transcat)
    endif
end subroutine psgetdim_id_chimo_transcat


subroutine psget_id_g_eq(iobj, data, ierr)
    !! 'ID for g_eq profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_g_eq', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_g_eq
end subroutine psget_id_g_eq


subroutine psget_id_xzjsin_momeq(iobj, n1, data, ierr)
    !! 'Array of IDs for xZjsin_momeq profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_xzjsin_momeq', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_xzjsin_momeq
end subroutine psget_id_xzjsin_momeq


subroutine psgetrnk_id_xzjsin_momeq(iobj, ndims, ierr)
    !! 'Array of IDs for xZjsin_momeq profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_xzjsin_momeq


subroutine psgetdim_id_xzjsin_momeq(iobj, ndims, dims, ierr)
    !! 'Array of IDs for xZjsin_momeq profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_xzjsin_momeq', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_xzjsin_momeq ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_xzjsin_momeq)
    endif
end subroutine psgetdim_id_xzjsin_momeq


subroutine psget_id_gr2(iobj, data, ierr)
    !! 'ID for gr2 profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_gr2', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_gr2
end subroutine psget_id_gr2


subroutine psget_id_grho2b2i(iobj, data, ierr)
    !! 'ID for grho2b2i profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_grho2b2i', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_grho2b2i
end subroutine psget_id_grho2b2i


subroutine psget_id_r_surfmax(iobj, data, ierr)
    !! 'ID for R_surfMax profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_r_surfmax', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_r_surfmax
end subroutine psget_id_r_surfmax


subroutine psget_id_triangu(iobj, data, ierr)
    !! 'ID for triangU profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_triangu', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_triangu
end subroutine psget_id_triangu


subroutine psget_id_cdicrf_nphi(iobj, n1, n2, data, ierr)
    !! 'Array of IDs for cdicrf_nphi profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_cdicrf_nphi', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % id_cdicrf_nphi
end subroutine psget_id_cdicrf_nphi


subroutine psgetrnk_id_cdicrf_nphi(iobj, ndims, ierr)
    !! 'Array of IDs for cdicrf_nphi profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_id_cdicrf_nphi


subroutine psgetdim_id_cdicrf_nphi(iobj, ndims, dims, ierr)
    !! 'Array of IDs for cdicrf_nphi profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_id_cdicrf_nphi', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_cdicrf_nphi ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_cdicrf_nphi)
    endif
end subroutine psgetdim_id_cdicrf_nphi


subroutine psget_id_nbeami(iobj, n1, data, ierr)
    !! 'Array of IDs for nbeami profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_nbeami', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_nbeami
end subroutine psget_id_nbeami


subroutine psgetrnk_id_nbeami(iobj, ndims, ierr)
    !! 'Array of IDs for nbeami profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_nbeami


subroutine psgetdim_id_nbeami(iobj, ndims, dims, ierr)
    !! 'Array of IDs for nbeami profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_nbeami', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_nbeami ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_nbeami)
    endif
end subroutine psgetdim_id_nbeami


subroutine psget_id_tqbth(iobj, data, ierr)
    !! 'ID for tqbth profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_tqbth', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_tqbth
end subroutine psget_id_tqbth


subroutine psget_id_tqb0_halo(iobj, data, ierr)
    !! 'ID for tqb0_halo profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_tqb0_halo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_tqb0_halo
end subroutine psget_id_tqb0_halo


subroutine psget_id_nfusi(iobj, n1, data, ierr)
    !! 'Array of IDs for nfusi profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_nfusi', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_nfusi
end subroutine psget_id_nfusi


subroutine psgetrnk_id_nfusi(iobj, ndims, ierr)
    !! 'Array of IDs for nfusi profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_nfusi


subroutine psgetdim_id_nfusi(iobj, ndims, dims, ierr)
    !! 'Array of IDs for nfusi profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_nfusi', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_nfusi ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_nfusi)
    endif
end subroutine psgetdim_id_nfusi


subroutine psget_id_rate_sinf0xs(iobj, n1, n2, data, ierr)
    !! 'Array of IDs for rate_sinf0xs profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_rate_sinf0xs', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % id_rate_sinf0xs
end subroutine psget_id_rate_sinf0xs


subroutine psgetrnk_id_rate_sinf0xs(iobj, ndims, ierr)
    !! 'Array of IDs for rate_sinf0xs profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_id_rate_sinf0xs


subroutine psgetdim_id_rate_sinf0xs(iobj, ndims, dims, ierr)
    !! 'Array of IDs for rate_sinf0xs profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_id_rate_sinf0xs', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_rate_sinf0xs ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_rate_sinf0xs)
    endif
end subroutine psgetdim_id_rate_sinf0xs


subroutine psget_id_prad_br(iobj, data, ierr)
    !! 'ID for prad_br profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_prad_br', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_prad_br
end subroutine psget_id_prad_br


subroutine psget_id_sprof0e(iobj, n1, data, ierr)
    !! 'Array of IDs for sprof0e profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_sprof0e', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_sprof0e
end subroutine psget_id_sprof0e


subroutine psgetrnk_id_sprof0e(iobj, ndims, ierr)
    !! 'Array of IDs for sprof0e profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_sprof0e


subroutine psgetdim_id_sprof0e(iobj, ndims, dims, ierr)
    !! 'Array of IDs for sprof0e profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_sprof0e', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_sprof0e ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_sprof0e)
    endif
end subroutine psgetdim_id_sprof0e


subroutine psget_id_tq0_reco(iobj, data, ierr)
    !! 'ID for tq0_reco profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_tq0_reco', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_tq0_reco
end subroutine psget_id_tq0_reco


subroutine psget_id_pelh(iobj, data, ierr)
    !! 'ID for pelh profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_pelh', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_pelh
end subroutine psget_id_pelh


subroutine psget_id_difb_fusi(iobj, data, ierr)
    !! 'ID for difb_fusi profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_difb_fusi', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_difb_fusi
end subroutine psget_id_difb_fusi


subroutine psget_id_fidiff_bpass_ctr(iobj, n1, data, ierr)
    !! 'Array of IDs for fidiff_bpass_ctr profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_fidiff_bpass_ctr', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_fidiff_bpass_ctr
end subroutine psget_id_fidiff_bpass_ctr


subroutine psgetrnk_id_fidiff_bpass_ctr(iobj, ndims, ierr)
    !! 'Array of IDs for fidiff_bpass_ctr profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_fidiff_bpass_ctr


subroutine psgetdim_id_fidiff_bpass_ctr(iobj, ndims, dims, ierr)
    !! 'Array of IDs for fidiff_bpass_ctr profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_fidiff_bpass_ctr', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_fidiff_bpass_ctr ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_fidiff_bpass_ctr)
    endif
end subroutine psgetdim_id_fidiff_bpass_ctr


subroutine psget_id_tq_anom(iobj, data, ierr)
    !! 'ID for tq_anom profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_tq_anom', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_tq_anom
end subroutine psget_id_tq_anom


subroutine psget_id_kyspectrum_tglf(iobj, n1, data, ierr)
    !! 'Array of IDs for kyspectrum_tglf profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_kyspectrum_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_kyspectrum_tglf
end subroutine psget_id_kyspectrum_tglf


subroutine psgetrnk_id_kyspectrum_tglf(iobj, ndims, ierr)
    !! 'Array of IDs for kyspectrum_tglf profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_kyspectrum_tglf


subroutine psgetdim_id_kyspectrum_tglf(iobj, ndims, dims, ierr)
    !! 'Array of IDs for kyspectrum_tglf profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_kyspectrum_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_kyspectrum_tglf ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_kyspectrum_tglf)
    endif
end subroutine psgetdim_id_kyspectrum_tglf


subroutine psget_id_niflux_ky_tglf(iobj, n1, data, ierr)
    !! 'Array of IDs for niflux_ky_tglf profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_niflux_ky_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_niflux_ky_tglf
end subroutine psget_id_niflux_ky_tglf


subroutine psgetrnk_id_niflux_ky_tglf(iobj, ndims, ierr)
    !! 'Array of IDs for niflux_ky_tglf profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_niflux_ky_tglf


subroutine psgetdim_id_niflux_ky_tglf(iobj, ndims, dims, ierr)
    !! 'Array of IDs for niflux_ky_tglf profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_niflux_ky_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_niflux_ky_tglf ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_niflux_ky_tglf)
    endif
end subroutine psgetdim_id_niflux_ky_tglf


subroutine psget_id_velti_tglf(iobj, data, ierr)
    !! 'ID for velti_tglf profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_velti_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_velti_tglf
end subroutine psget_id_velti_tglf


subroutine psget_id_difns_tglf(iobj, n1, data, ierr)
    !! 'Array of IDs for difns_tglf profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_difns_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_difns_tglf
end subroutine psget_id_difns_tglf


subroutine psgetrnk_id_difns_tglf(iobj, ndims, ierr)
    !! 'Array of IDs for difns_tglf profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_difns_tglf


subroutine psgetdim_id_difns_tglf(iobj, ndims, dims, ierr)
    !! 'Array of IDs for difns_tglf profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_difns_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_difns_tglf ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_difns_tglf)
    endif
end subroutine psgetdim_id_difns_tglf


subroutine psget_id_freq_mmm71(iobj, n1, data, ierr)
    !! 'Array of IDs for freq_mmm71 profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_freq_mmm71', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_freq_mmm71
end subroutine psget_id_freq_mmm71


subroutine psgetrnk_id_freq_mmm71(iobj, ndims, ierr)
    !! 'Array of IDs for freq_mmm71 profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_freq_mmm71


subroutine psgetdim_id_freq_mmm71(iobj, ndims, dims, ierr)
    !! 'Array of IDs for freq_mmm71 profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_freq_mmm71', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_freq_mmm71 ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_freq_mmm71)
    endif
end subroutine psgetdim_id_freq_mmm71


subroutine psget_id_chii_drbm(iobj, data, ierr)
    !! 'ID for chii_drbm profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_chii_drbm', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_chii_drbm
end subroutine psget_id_chii_drbm


subroutine psget_id_db_mtm(iobj, data, ierr)
    !! 'ID for db_mtm profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_db_mtm', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_db_mtm
end subroutine psget_id_db_mtm


subroutine psget_id_chie_glf(iobj, data, ierr)
    !! 'ID for chie_glf profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_chie_glf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_chie_glf
end subroutine psget_id_chie_glf


subroutine psget_id_velpphi_gtcneo(iobj, data, ierr)
    !! 'ID for velpphi_gtcneo profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_velpphi_gtcneo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_velpphi_gtcneo
end subroutine psget_id_velpphi_gtcneo


subroutine psget_id_chie_nclass(iobj, data, ierr)
    !! 'ID for chie_nclass profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_chie_nclass', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_chie_nclass
end subroutine psget_id_chie_nclass


subroutine psget_id_velnh_nclass(iobj, data, ierr)
    !! 'ID for velnh_nclass profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_velnh_nclass', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_velnh_nclass
end subroutine psget_id_velnh_nclass

subroutine ps_get_integ(iobj, rhoname, idi, iout, ierr)

  !------------------------------------------------------------
  ! D. McCune 4 Apr 2007

  ! XPLASMA2 implementation of plasma_state subroutine
  ! get or create a metric integrator for the indicated RHO grid

  !------------------------------------------------------------

  use plasma_state_definition_mod
  use plasma_state_xpobj  ! XPLASMA2 state object definitions
  implicit NONE

  !-----------------------
  integer :: iobj(ps_container_size)     ! xplasma opaque container

  character*(*), intent(in) :: rhoname     ! NAME of RHO grid 

  integer, intent(out) :: idi              ! handle for integrator (0 if fail)

  integer, intent(in) :: iout              ! LUN for error messages
  integer, intent(out) :: ierr             ! error status code returned 0 = OK

  !--------------------------------------------------
  ! local...

  integer :: id,icoord,isize,iertmp
  character*32 pauth,integ_name
  real(kind=rspec), dimension(:), allocatable :: rhogrid

  type (interp_object) :: xobj
  type (xplasma), pointer :: s
  !--------------------------------------------------
  idi = 0

  xobj = transfer(iobj,xobj)
  s => xobj%s_xpobj

  call xplasma_global_info(s,ierr, init_check=.TRUE.)
  if(ierr.ne.0) then
     write(iout,*) ' %ps_get_integ: invalid or unitialized xplasma object.'
     return
  endif

  !--------------------------------------------------
  !  find grid ID

  call xplasma_gridId(s,rhoname,id)
  if(id.eq.0) then
     if(id.eq.0) then
        ierr=705
        write(iout,*) ' ?ps_get_integ: RHO grid not found: ',trim(rhoname)
        return
     endif
  endif

  !--------------------------------------------------
  !  fetch and check grid info

  call xplasma_grid_info(s,id,ierr, &
       coord=icoord, author=pauth, size=isize)

  if(icoord.ne.xplasma_rho_coord) then
     write(iout,*) ' ?ps_get_integ: not a RHO grid: ',trim(rhoname)
     if(ierr.ne.0) call xplasma_error(s,ierr,iout)
     ierr=705
     return
  endif

  !  get the integrator ID; if not found create...

  integ_name = '__'//trim(rhoname)//'_INTEG1D'
  call xplasma_blkbxId(s,integ_name,idi)

  if(idi.eq.0) then
     ! OK; need to create integrator; fetch the grid data

     allocate(rhogrid(isize))
     call xplasma_grid(s,id,rhogrid,ierr)

     if(ierr.ne.0) then
        write(iout,*) &
             ' ?ps_get_integ: XPLASMA2 error attempting rho retrieval: ', &
             trim(rhoname)
        call xplasma_error(s,ierr,iout)
        ierr=707

     else

        !  use xplasma_xmhd as author -- this arranges for cache data to be
        !  cleared if the equilibrium changes.

        call xplasma_author_set(s,xplasma_xmhd,iertmp)

        call xplasma_create_integ(s,integ_name,rhogrid,idi,ierr)

        call xplasma_author_clear(s,xplasma_xmhd,iertmp)

        if(ierr.ne.0) then
           write(iout,*) &
                ' ?ps_get_integ: XPLASMA2 error creating rho integrator: ', &
                trim(rhoname)
           call xplasma_error(s,ierr,iout)
        endif
     endif

     deallocate(rhogrid)
  endif

end subroutine ps_get_integ

subroutine ps_get_userInteg(iobj,rhoname,nrho,rho,idi,iout,ierr)

  !------------------------------------------------------------
  ! D. McCune 4 Apr 2007

  ! XPLASMA2 implementation of plasma_state subroutine
  ! get or create a metric integrator for the user supplied RHO grid or subset

  !------------------------------------------------------------

  use plasma_state_definition_mod
  use plasma_state_xpobj  ! XPLASMA2 state object definitions
  implicit NONE

  !-----------------------
  integer :: iobj(ps_container_size)     ! xplasma opaque container

  character*(*), intent(in) :: rhoname     ! NAME of user provided RHO grid 

  integer, intent(in) :: nrho              ! size of user provided RHO grid 
  real(kind=rspec) :: rho(nrho)            ! the user provided RHO grid

  integer, intent(out) :: idi              ! handle for integrator (0 if fail)

  integer, intent(in) :: iout              ! LUN for error messages
  integer, intent(out) :: ierr             ! error status code returned 0 = OK

  !--------------------------------------------------
  ! local...

  integer :: id,i,incr,idiff,iertmp
  character*32 integ_name

  integer, pointer, dimension(:) :: ibuf
  real*8, pointer, dimension(:) :: rbuf

  type (interp_object) :: xobj
  type (xplasma), pointer :: s
  !--------------------------------------------------
  idi = 0

  xobj = transfer(iobj,xobj)
  s => xobj%s_xpobj

  call xplasma_global_info(s,ierr, init_check=.TRUE.)
  if(ierr.ne.0) then
     write(iout,*) ' %ps_get_userInteg: invalid or unitialized xplasma object.'
     return
  endif

  !--------------------------------------------------

  integ_name = '__'//trim(rhoname)//'_INTEG1D'

  call xplasma_blkbxId(s,integ_name,id)
  if(id.gt.0) then

     call xplasma_blackBox_retrieve(s,id,ierr, ia_ptr=ibuf, r8a_ptr=rbuf)
     if(ierr.ne.0) then
        write(iout,*) ' ?ps_get_userInteg: unexpected xplasma2 error:'
        call xplasma_error(s,ierr,iout)
        return
     endif

     incr=1
     idiff=0
     do i=1,nrho
        if(rho(i).ne.rbuf(incr+i)) then
           idiff=1
           exit
        endif
     enddo

     if(idiff.gt.0) then
        id = 0   ! user RHO grid changed...
     endif
  endif

  if(id.gt.0) then
     idi = id

  else
     ! create integrator
     !  use xplasma_xmhd as author -- this arranges for cache data to be
     !  cleared if the equilibrium changes.

     call xplasma_author_set(s,xplasma_xmhd,iertmp)
        
     call xplasma_create_integ(s,integ_name,rho,idi,ierr)

     call xplasma_author_clear(s,xplasma_xmhd,iertmp)

     if(ierr.ne.0) then
        write(iout,*) &
             ' ?ps_get_userInteg: XPLASMA2 error creating rho integrator: ', &
             trim(rhoname)
        call xplasma_error(s,ierr,iout)
     endif
  endif

end subroutine ps_get_userInteg

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_n9_dummy
     return
  end subroutine ccps_getset_n9_dummy

subroutine psget_ncircuits(iobj, data, ierr)
    !! item list dimension of circuit_name (pf_circuits)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_ncircuits', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % ncircuits
end subroutine psget_ncircuits


subroutine psset_ncircuits(iobj, data, ierr)
    !! item list dimension of circuit_name (pf_circuits)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_ncircuits', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % ncircuits = data
end subroutine psset_ncircuits


subroutine psget_nrz_antgeo(iobj, n1, data, ierr)
    !! number of (R,Z) points, antenna geometries
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_nrz_antgeo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % nrz_antgeo
end subroutine psget_nrz_antgeo


subroutine psset_nrz_antgeo(iobj, n1, data, ierr)
    !! number of (R,Z) points, antenna geometries
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_nrz_antgeo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % nrz_antgeo = data(1:n1)
end subroutine psset_nrz_antgeo


subroutine psgetrnk_nrz_antgeo(iobj, ndims, ierr)
    !! number of (R,Z) points, antenna geometries
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_nrz_antgeo


subroutine psgetdim_nrz_antgeo(iobj, ndims, dims, ierr)
    !! number of (R,Z) points, antenna geometries
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_nrz_antgeo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % nrz_antgeo ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % nrz_antgeo)
    endif
end subroutine psgetdim_nrz_antgeo


subroutine psget_nspec_th(iobj, data, ierr)
    !! species list dimension of S (thermal_specie)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_nspec_th', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % nspec_th
end subroutine psget_nspec_th


subroutine psset_nspec_th(iobj, data, ierr)
    !! species list dimension of S (thermal_specie)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_nspec_th', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % nspec_th = data
end subroutine psset_nspec_th


subroutine psget_nxs(iobj, data, ierr)
    !! item list dimension of xs_name (impurity_source)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_nxs', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % nxs
end subroutine psget_nxs


subroutine psset_nxs(iobj, data, ierr)
    !! item list dimension of xs_name (impurity_source)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_nxs', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % nxs = data
end subroutine psset_nxs


subroutine psget_nspec_alla(iobj, data, ierr)
    !! species list dimension of ALLA (specie)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_nspec_alla', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % nspec_alla
end subroutine psget_nspec_alla


subroutine psset_nspec_alla(iobj, data, ierr)
    !! species list dimension of ALLA (specie)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_nspec_alla', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % nspec_alla = data
end subroutine psset_nspec_alla


subroutine psget_nrho_icrf(iobj, data, ierr)
    !! grid dimension of rho_icrf (RHO coordinate)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_nrho_icrf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % nrho_icrf
end subroutine psget_nrho_icrf


subroutine psset_nrho_icrf(iobj, data, ierr)
    !! grid dimension of rho_icrf (RHO coordinate)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_nrho_icrf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % nrho_icrf = data
end subroutine psset_nrho_icrf


subroutine psget_nrho_rw(iobj, data, ierr)
    !! grid dimension of rho_rw (RHO coordinate)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_nrho_rw', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % nrho_rw
end subroutine psget_nrho_rw


subroutine psset_nrho_rw(iobj, data, ierr)
    !! grid dimension of rho_rw (RHO coordinate)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_nrho_rw', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % nrho_rw = data
end subroutine psset_nrho_rw


subroutine psget_nbeami_bdy(iobj, n1, data, ierr)
    !! beam ion densities at/beyond boundary
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_nbeami_bdy', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % nbeami_bdy
end subroutine psget_nbeami_bdy


subroutine psset_nbeami_bdy(iobj, n1, data, ierr)
    !! beam ion densities at/beyond boundary
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_nbeami_bdy', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % nbeami_bdy = data(1:n1)
end subroutine psset_nbeami_bdy


subroutine psgetrnk_nbeami_bdy(iobj, ndims, ierr)
    !! beam ion densities at/beyond boundary
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_nbeami_bdy


subroutine psgetdim_nbeami_bdy(iobj, ndims, dims, ierr)
    !! beam ion densities at/beyond boundary
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_nbeami_bdy', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % nbeami_bdy ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % nbeami_bdy)
    endif
end subroutine psgetdim_nbeami_bdy


subroutine psget_nfusi_bdy(iobj, n1, data, ierr)
    !! fusion ion densities at/beyond boundary
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_nfusi_bdy', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % nfusi_bdy
end subroutine psget_nfusi_bdy


subroutine psset_nfusi_bdy(iobj, n1, data, ierr)
    !! fusion ion densities at/beyond boundary
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_nfusi_bdy', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % nfusi_bdy = data(1:n1)
end subroutine psset_nfusi_bdy


subroutine psgetrnk_nfusi_bdy(iobj, ndims, ierr)
    !! fusion ion densities at/beyond boundary
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_nfusi_bdy


subroutine psgetdim_nfusi_bdy(iobj, ndims, dims, ierr)
    !! fusion ion densities at/beyond boundary
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_nfusi_bdy', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % nfusi_bdy ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % nfusi_bdy)
    endif
end subroutine psgetdim_nfusi_bdy


subroutine psget_ns(iobj, n1, n2, data, ierr)
    !! thermal specie density
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_ns', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % ns
end subroutine psget_ns


subroutine psset_ns(iobj, n1, n2, data, ierr)
    !! thermal specie density
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_ns', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % ns = data(1:n1, 1: n2)
end subroutine psset_ns


subroutine psgetrnk_ns(iobj, ndims, ierr)
    !! thermal specie density
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_ns


subroutine psgetdim_ns(iobj, ndims, dims, ierr)
    !! thermal specie density
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_ns', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % ns ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % ns)
    endif
end subroutine psgetdim_ns


subroutine psget_n0_halo(iobj, n1, n2, data, ierr)
    !! halo thermal neutral density
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_n0_halo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % n0_halo
end subroutine psget_n0_halo


subroutine psset_n0_halo(iobj, n1, n2, data, ierr)
    !! halo thermal neutral density
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_n0_halo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % n0_halo = data(1:n1, 1: n2)
end subroutine psset_n0_halo


subroutine psgetrnk_n0_halo(iobj, ndims, ierr)
    !! halo thermal neutral density
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_n0_halo


subroutine psgetdim_n0_halo(iobj, ndims, dims, ierr)
    !! halo thermal neutral density
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_n0_halo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % n0_halo ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % n0_halo)
    endif
end subroutine psgetdim_n0_halo


subroutine psget_n0_reco(iobj, n1, n2, data, ierr)
    !! reco thermal neutral density
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_n0_reco', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % n0_reco
end subroutine psget_n0_reco


subroutine psset_n0_reco(iobj, n1, n2, data, ierr)
    !! reco thermal neutral density
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_n0_reco', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % n0_reco = data(1:n1, 1: n2)
end subroutine psset_n0_reco


subroutine psgetrnk_n0_reco(iobj, ndims, ierr)
    !! reco thermal neutral density
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_n0_reco


subroutine psgetdim_n0_reco(iobj, ndims, dims, ierr)
    !! reco thermal neutral density
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_n0_reco', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % n0_reco ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % n0_reco)
    endif
end subroutine psgetdim_n0_reco


subroutine psget_ne_ky_tglf(iobj, n1, n2, data, ierr)
    !! electron density fluctuation spectrum
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_ne_ky_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % ne_ky_tglf
end subroutine psget_ne_ky_tglf


subroutine psset_ne_ky_tglf(iobj, n1, n2, data, ierr)
    !! electron density fluctuation spectrum
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_ne_ky_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % ne_ky_tglf = data(1:n1, 1: n2)
end subroutine psset_ne_ky_tglf


subroutine psgetrnk_ne_ky_tglf(iobj, ndims, ierr)
    !! electron density fluctuation spectrum
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_ne_ky_tglf


subroutine psgetdim_ne_ky_tglf(iobj, ndims, dims, ierr)
    !! electron density fluctuation spectrum
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_ne_ky_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % ne_ky_tglf ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % ne_ky_tglf)
    endif
end subroutine psgetdim_ne_ky_tglf

subroutine ps_grid_store(iobj, coord_tag, gridname, iauthor, label, &
     n, k_ccw, grid_data, iout, ierr)

  !------------------------------------------------------------
  ! D. McCune 8 Oct 2006

  ! XPLASMA2 implementation of plasma_state subroutine
  ! store a grid, perform error checking.  NOTE-- if the
  ! grid already exists, its size and values are compared with
  ! those passed; these must match within a high level of tolerance
  ! or an error is reported.

  ! Special code is needed to change a grid, because, generally, profiles
  ! defined over the grids have to be changed when their underlying grids
  ! are changed.  This is *not* handled here.

  ! This routine is called by generated code associated with the
  ! plasma state.  Component codes will not call this directly.
  !------------------------------------------------------------

  use plasma_state_definition_mod
  use plasma_state_xpobj  ! XPLASMA2 state object definitions
  implicit NONE

  !-----------------------
  integer :: iobj(ps_container_size)  ! opaque container for xplasma object

  character*(*), intent(in) :: coord_tag   ! "RHO", "TH", "R", or "Z", ...
  character*(*), intent(in) :: gridname    ! NAME of grid 
  integer, intent(in) :: iauthor           ! author ID

  character*(*), intent(in) :: label       ! grid label

  integer, intent(in) :: n                 ! grid data size
  integer, intent(in) :: k_ccw             ! CCW flag ("TH" only)

  REAL(KIND=rspec) :: grid_data(n)         ! grid data to be stored

  integer, intent(in) :: iout              ! LUN for error messages
  integer, intent(out) :: ierr             ! error status code returned 0 = OK
  !--------------------------------------------------
  ! local...

  integer :: id,icoord,jcoord,i,inx,iertmp
  REAL(KIND=rspec) :: bdytol,ztol
  REAL(KIND=rspec), dimension(:), allocatable :: grid
  logical :: ccwflag
  character*32 pauth

  type (interp_object) :: xobj
  type (xplasma), pointer :: s
  !--------------------------------------------------

  xobj = transfer(iobj,xobj)
  s => xobj%s_xpobj

  call xplasma_global_info(s,ierr, init_check=.TRUE.)
  if(ierr.ne.0) then
     write(iout,*) ' ?ps_grid_store: invalid or unitialized xplasma object.'
     return
  endif

  !--------------------------------------------------
  !  find grid ID -- if grid is already defined, compare; if not, create

  call xplasma_gridId(s,gridname,id)

  call xplasma_author_set(s,ps_cnames(iauthor),ierr)
  if(ierr.ne.0) then
     ! (this is the only time an xplasma_author call is checked)
     write(iout,*) ' ?ps_grid_store: unexpected xplasma_author_set error:'
     call xplasma_error(s,ierr,iout)
     ierr=201
     return
  endif

  call ps_coordchk(xobj,coord_tag,gridname,id,iauthor, &
       icoord,n,grid_data,iout,ierr)

  call xplasma_author_clear(s,ps_cnames(iauthor),iertmp)

  if(ierr.ne.0) then
     call gen_errmsg
     return
  endif

  ccwflag = .TRUE.
  if(icoord.eq.xplasma_theta_coord) then
     ccwflag = (k_ccw.ne.ps_ccw_reverse)
  endif

  if(id.eq.0) then

     !---------------------------
     ! OK: create the grid

     call xplasma_author_set(s,ps_cnames(iauthor),iertmp)

     call xplasma_create_grid(s,gridname,icoord,grid_data,id,ierr, &
          ccwflag=ccwflag, label=label)
     if(ierr.ne.0) then
        write(iout,*) ' ?ps_grid_store: unexpected xplasma_create_grid error:'
        call xplasma_error(s,ierr,iout)
        ierr=201
     endif

     call xplasma_author_clear(s,ps_cnames(iauthor),iertmp)

  else

     !--------------------------------------------------
     !  fetch and check grid info

     call xplasma_grid_info(s,id,ierr, &
          size=inx, coord=jcoord, author=pauth)

     if(ierr.ne.0) then
        write(iout,*) ' ?ps_grid_store: unexpected xplasma_grid_info error:'
        call xplasma_error(s,ierr,iout)
        ierr=206
     else
        ! general checks...

        if(ps_cnames(iauthor).ne.pauth) then
           write(iout,*) ' ?ps_grid_store: existing grid author mismatch:'
           write(iout,*) '  existing grid has: "',trim(pauth), &
                '"; passed author reference: "',trim(ps_cnames(iauthor)),'".'
           ierr=206
        endif

        if(icoord.ne.jcoord) then
           write(iout,*) &
                ' ?ps_grid_store: existing grid coordinate ID mismatch:', &
                icoord, jcoord
           write(iout,*) '  this error is unexpected.'
           ierr=206
        endif

        if(inx.ne.n) then
           write(iout,*) ' ?ps_grid_store: existing grid size mismatch:'
           write(iout,*) '  existing grid size: ',inx, &
                '; passed grid size: ',n
           ierr=206
        endif
     endif

     if(ierr.eq.0) then
        allocate(grid(n))
        call xplasma_grid(s,id,grid,iertmp, ccwflag)

        call xplasma_global_info(s,iertmp, bdytol=bdytol)
        ztol=bdytol*max(abs(grid(1)),abs(grid(n)))

        do i=1,n
           if(abs(grid(i)-grid_data(i)).gt.ztol) then
              if(ierr.eq.0) then
                 ierr=209
                 write(iout,*) ' ?ps_grid_store:  grid value does not match'
                 write(iout,*) '  value in copy of grid already stored:'
              endif
              write(iout,*) '  index# ',i,' stored: ',grid(i), &
                   ' passed: ',grid_data(i)
           endif
        enddo
     endif
  endif

  if(ierr.ne.0) call gen_errmsg

  contains
    subroutine gen_errmsg
      write(iout,*) ' *** error in ps_grid_store, gridname is "'// &
           trim(gridname)//'".'
    end subroutine gen_errmsg
end subroutine ps_grid_store

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


SUBROUTINE plasma_state_merge_2(cclist,w1,ss1,ss2,ss3,icheck,iout,ierr)


  ! Merge floating point data
  !   ss3 <-- w1*ss1 + (1-w1)*ss2

  USE plasma_state_definition_mod
  IMPLICIT NONE

  INTEGER, INTENT(IN) :: cclist(ps_ccount)
                                ! list of components to merge
                                ! use ps_cc_all to merge all components

  REAL(KIND=rspec) :: w1        ! weight on ss1
  TYPE (plasma_state) :: ss1    ! state data to copy *from* with weight (w1)
  TYPE (plasma_state) :: ss2    ! state data to copy *from* with weight (1-w1)
  TYPE (plasma_state) :: ss3    ! state to which data is copied.
  INTEGER, INTENT(IN) :: icheck ! control for checking match of non-floating-
  !  point data: ps_ignore, ps_warn, or ps_error on mismatch.

  INTEGER, INTENT(IN) :: iout
  INTEGER, INTENT(INOUT) :: ierr  ! completion code (not cleared,set on error)

  !-------------------
  INTEGER :: isize
  !-------------------

  !-----------------------------------------------
  ! copy scalars and arrays that are allocated...

  IF((ALLOCATED(ss3%D_einj_standard)).AND.(cclist(ps_cnum_NBI).EQ.1)) THEN
     IF(ALLOCATED(ss1%D_einj_standard).AND.ALLOCATED(ss2%D_einj_standard)) THEN
        CALL ps_diff("D_einj_standard",ss1%D_einj_standard,ss2%D_einj_standard,icheck,iout,ierr)
        CALL ps_conformal("D_einj_standard",ss1%D_einj_standard,ss3%D_einj_standard,iout,ierr)
        if(ierr.eq.0) ss3%D_einj_standard = ss1%D_einj_standard
     ELSE IF(ALLOCATED(ss1%D_einj_standard)) THEN
        CALL ps_conformal("D_einj_standard",ss1%D_einj_standard,ss3%D_einj_standard,iout,ierr)
        ss3%D_einj_standard = ss1%D_einj_standard
     ELSE IF(ALLOCATED(ss2%D_einj_standard)) THEN
        CALL ps_conformal("D_einj_standard",ss2%D_einj_standard,ss3%D_einj_standard,iout,ierr)
        ss3%D_einj_standard = ss2%D_einj_standard
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%D_ffull_standard)).AND.(cclist(ps_cnum_NBI).EQ.1)) THEN
     IF(ALLOCATED(ss1%D_ffull_standard).AND.ALLOCATED(ss2%D_ffull_standard)) THEN
        CALL ps_diff("D_ffull_standard",ss1%D_ffull_standard,ss2%D_ffull_standard,icheck,iout,ierr)
        CALL ps_conformal("D_ffull_standard",ss1%D_ffull_standard,ss3%D_ffull_standard,iout,ierr)
        if(ierr.eq.0) ss3%D_ffull_standard = ss1%D_ffull_standard
     ELSE IF(ALLOCATED(ss1%D_ffull_standard)) THEN
        CALL ps_conformal("D_ffull_standard",ss1%D_ffull_standard,ss3%D_ffull_standard,iout,ierr)
        ss3%D_ffull_standard = ss1%D_ffull_standard
     ELSE IF(ALLOCATED(ss2%D_ffull_standard)) THEN
        CALL ps_conformal("D_ffull_standard",ss2%D_ffull_standard,ss3%D_ffull_standard,iout,ierr)
        ss3%D_ffull_standard = ss2%D_ffull_standard
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%D_fhalf_standard)).AND.(cclist(ps_cnum_NBI).EQ.1)) THEN
     IF(ALLOCATED(ss1%D_fhalf_standard).AND.ALLOCATED(ss2%D_fhalf_standard)) THEN
        CALL ps_diff("D_fhalf_standard",ss1%D_fhalf_standard,ss2%D_fhalf_standard,icheck,iout,ierr)
        CALL ps_conformal("D_fhalf_standard",ss1%D_fhalf_standard,ss3%D_fhalf_standard,iout,ierr)
        if(ierr.eq.0) ss3%D_fhalf_standard = ss1%D_fhalf_standard
     ELSE IF(ALLOCATED(ss1%D_fhalf_standard)) THEN
        CALL ps_conformal("D_fhalf_standard",ss1%D_fhalf_standard,ss3%D_fhalf_standard,iout,ierr)
        ss3%D_fhalf_standard = ss1%D_fhalf_standard
     ELSE IF(ALLOCATED(ss2%D_fhalf_standard)) THEN
        CALL ps_conformal("D_fhalf_standard",ss2%D_fhalf_standard,ss3%D_fhalf_standard,iout,ierr)
        ss3%D_fhalf_standard = ss2%D_fhalf_standard
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%e0_av)).AND.(cclist(ps_cnum_GAS).EQ.1)) THEN
     IF(ALLOCATED(ss1%e0_av).AND.ALLOCATED(ss2%e0_av)) THEN
        CALL ps_conformal("e0_av",ss2%e0_av,ss3%e0_av,iout,ierr)
        CALL ps_conformal("e0_av",ss1%e0_av,ss3%e0_av,iout,ierr)
        if(ierr.eq.0) ss3%e0_av = w1*ss1%e0_av + (1.0_rspec-w1)*ss2%e0_av
     ELSE IF(ALLOCATED(ss1%e0_av)) THEN
        CALL ps_conformal("e0_av",ss1%e0_av,ss3%e0_av,iout,ierr)
        ss3%e0_av = ss1%e0_av
     ELSE IF(ALLOCATED(ss2%e0_av)) THEN
        CALL ps_conformal("e0_av",ss2%e0_av,ss3%e0_av,iout,ierr)
        ss3%e0_av = ss2%e0_av
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%ecrf_src_name)).AND.(cclist(ps_cnum_EC).EQ.1)) THEN
     IF(ALLOCATED(ss1%ecrf_src_name).AND.ALLOCATED(ss2%ecrf_src_name)) THEN
        CALL ps_diff("ecrf_src_name",ss1%ecrf_src_name,ss2%ecrf_src_name,icheck,iout,ierr)
        CALL ps_conformal("ecrf_src_name",ss1%ecrf_src_name,ss3%ecrf_src_name,iout,ierr)
        if(ierr.eq.0) ss3%ecrf_src_name = ss1%ecrf_src_name
     ELSE IF(ALLOCATED(ss1%ecrf_src_name)) THEN
        CALL ps_conformal("ecrf_src_name",ss1%ecrf_src_name,ss3%ecrf_src_name,iout,ierr)
        ss3%ecrf_src_name = ss1%ecrf_src_name
     ELSE IF(ALLOCATED(ss2%ecrf_src_name)) THEN
        CALL ps_conformal("ecrf_src_name",ss2%ecrf_src_name,ss3%ecrf_src_name,iout,ierr)
        ss3%ecrf_src_name = ss2%ecrf_src_name
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%EC_Beam_Elongation)).AND.(cclist(ps_cnum_EC).EQ.1)) THEN
     IF(ALLOCATED(ss1%EC_Beam_Elongation).AND.ALLOCATED(ss2%EC_Beam_Elongation)) THEN
        CALL ps_diff("EC_Beam_Elongation",ss1%EC_Beam_Elongation,ss2%EC_Beam_Elongation,icheck,iout,ierr)
        CALL ps_conformal("EC_Beam_Elongation",ss1%EC_Beam_Elongation,ss3%EC_Beam_Elongation,iout,ierr)
        if(ierr.eq.0) ss3%EC_Beam_Elongation = ss1%EC_Beam_Elongation
     ELSE IF(ALLOCATED(ss1%EC_Beam_Elongation)) THEN
        CALL ps_conformal("EC_Beam_Elongation",ss1%EC_Beam_Elongation,ss3%EC_Beam_Elongation,iout,ierr)
        ss3%EC_Beam_Elongation = ss1%EC_Beam_Elongation
     ELSE IF(ALLOCATED(ss2%EC_Beam_Elongation)) THEN
        CALL ps_conformal("EC_Beam_Elongation",ss2%EC_Beam_Elongation,ss3%EC_Beam_Elongation,iout,ierr)
        ss3%EC_Beam_Elongation = ss2%EC_Beam_Elongation
     ENDIF
  ENDIF

  IF(cclist(ps_cnum_EC).EQ.1) THEN

     CALL ps_diff("EC_Code_Info",ss1%EC_Code_Info,ss2%EC_Code_Info,icheck,iout,ierr)
     ss3%EC_Code_Info = ss1%EC_Code_Info
  ENDIF

  IF(cclist(ps_cnum_EC).EQ.1) THEN

     CALL ps_diff("EC_Data_Info",ss1%EC_Data_Info,ss2%EC_Data_Info,icheck,iout,ierr)
     ss3%EC_Data_Info = ss1%EC_Data_Info
  ENDIF

  IF((ALLOCATED(ss3%EC_Half_Power_Angle)).AND.(cclist(ps_cnum_EC).EQ.1)) THEN
     IF(ALLOCATED(ss1%EC_Half_Power_Angle).AND.ALLOCATED(ss2%EC_Half_Power_Angle)) THEN
        CALL ps_diff("EC_Half_Power_Angle",ss1%EC_Half_Power_Angle,ss2%EC_Half_Power_Angle,icheck,iout,ierr)
        CALL ps_conformal("EC_Half_Power_Angle",ss1%EC_Half_Power_Angle,ss3%EC_Half_Power_Angle,iout,ierr)
        if(ierr.eq.0) ss3%EC_Half_Power_Angle = ss1%EC_Half_Power_Angle
     ELSE IF(ALLOCATED(ss1%EC_Half_Power_Angle)) THEN
        CALL ps_conformal("EC_Half_Power_Angle",ss1%EC_Half_Power_Angle,ss3%EC_Half_Power_Angle,iout,ierr)
        ss3%EC_Half_Power_Angle = ss1%EC_Half_Power_Angle
     ELSE IF(ALLOCATED(ss2%EC_Half_Power_Angle)) THEN
        CALL ps_conformal("EC_Half_Power_Angle",ss2%EC_Half_Power_Angle,ss3%EC_Half_Power_Angle,iout,ierr)
        ss3%EC_Half_Power_Angle = ss2%EC_Half_Power_Angle
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%EC_Omode_Fraction)).AND.(cclist(ps_cnum_EC).EQ.1)) THEN
     IF(ALLOCATED(ss1%EC_Omode_Fraction).AND.ALLOCATED(ss2%EC_Omode_Fraction)) THEN
        CALL ps_diff("EC_Omode_Fraction",ss1%EC_Omode_Fraction,ss2%EC_Omode_Fraction,icheck,iout,ierr)
        CALL ps_conformal("EC_Omode_Fraction",ss1%EC_Omode_Fraction,ss3%EC_Omode_Fraction,iout,ierr)
        if(ierr.eq.0) ss3%EC_Omode_Fraction = ss1%EC_Omode_Fraction
     ELSE IF(ALLOCATED(ss1%EC_Omode_Fraction)) THEN
        CALL ps_conformal("EC_Omode_Fraction",ss1%EC_Omode_Fraction,ss3%EC_Omode_Fraction,iout,ierr)
        ss3%EC_Omode_Fraction = ss1%EC_Omode_Fraction
     ELSE IF(ALLOCATED(ss2%EC_Omode_Fraction)) THEN
        CALL ps_conformal("EC_Omode_Fraction",ss2%EC_Omode_Fraction,ss3%EC_Omode_Fraction,iout,ierr)
        ss3%EC_Omode_Fraction = ss2%EC_Omode_Fraction
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%EC_phi_aim)).AND.(cclist(ps_cnum_EC).EQ.1)) THEN
     IF(ALLOCATED(ss1%EC_phi_aim).AND.ALLOCATED(ss2%EC_phi_aim)) THEN
        CALL ps_diff("EC_phi_aim",ss1%EC_phi_aim,ss2%EC_phi_aim,icheck,iout,ierr)
        CALL ps_conformal("EC_phi_aim",ss1%EC_phi_aim,ss3%EC_phi_aim,iout,ierr)
        if(ierr.eq.0) ss3%EC_phi_aim = ss1%EC_phi_aim
     ELSE IF(ALLOCATED(ss1%EC_phi_aim)) THEN
        CALL ps_conformal("EC_phi_aim",ss1%EC_phi_aim,ss3%EC_phi_aim,iout,ierr)
        ss3%EC_phi_aim = ss1%EC_phi_aim
     ELSE IF(ALLOCATED(ss2%EC_phi_aim)) THEN
        CALL ps_conformal("EC_phi_aim",ss2%EC_phi_aim,ss3%EC_phi_aim,iout,ierr)
        ss3%EC_phi_aim = ss2%EC_phi_aim
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%EC_PRINC_CURV_HOR)).AND.(cclist(ps_cnum_EC).EQ.1)) THEN
     IF(ALLOCATED(ss1%EC_PRINC_CURV_HOR).AND.ALLOCATED(ss2%EC_PRINC_CURV_HOR)) THEN
        CALL ps_diff("EC_PRINC_CURV_HOR",ss1%EC_PRINC_CURV_HOR,ss2%EC_PRINC_CURV_HOR,icheck,iout,ierr)
        CALL ps_conformal("EC_PRINC_CURV_HOR",ss1%EC_PRINC_CURV_HOR,ss3%EC_PRINC_CURV_HOR,iout,ierr)
        if(ierr.eq.0) ss3%EC_PRINC_CURV_HOR = ss1%EC_PRINC_CURV_HOR
     ELSE IF(ALLOCATED(ss1%EC_PRINC_CURV_HOR)) THEN
        CALL ps_conformal("EC_PRINC_CURV_HOR",ss1%EC_PRINC_CURV_HOR,ss3%EC_PRINC_CURV_HOR,iout,ierr)
        ss3%EC_PRINC_CURV_HOR = ss1%EC_PRINC_CURV_HOR
     ELSE IF(ALLOCATED(ss2%EC_PRINC_CURV_HOR)) THEN
        CALL ps_conformal("EC_PRINC_CURV_HOR",ss2%EC_PRINC_CURV_HOR,ss3%EC_PRINC_CURV_HOR,iout,ierr)
        ss3%EC_PRINC_CURV_HOR = ss2%EC_PRINC_CURV_HOR
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%EC_PRINC_CURV_VERT)).AND.(cclist(ps_cnum_EC).EQ.1)) THEN
     IF(ALLOCATED(ss1%EC_PRINC_CURV_VERT).AND.ALLOCATED(ss2%EC_PRINC_CURV_VERT)) THEN
        CALL ps_diff("EC_PRINC_CURV_VERT",ss1%EC_PRINC_CURV_VERT,ss2%EC_PRINC_CURV_VERT,icheck,iout,ierr)
        CALL ps_conformal("EC_PRINC_CURV_VERT",ss1%EC_PRINC_CURV_VERT,ss3%EC_PRINC_CURV_VERT,iout,ierr)
        if(ierr.eq.0) ss3%EC_PRINC_CURV_VERT = ss1%EC_PRINC_CURV_VERT
     ELSE IF(ALLOCATED(ss1%EC_PRINC_CURV_VERT)) THEN
        CALL ps_conformal("EC_PRINC_CURV_VERT",ss1%EC_PRINC_CURV_VERT,ss3%EC_PRINC_CURV_VERT,iout,ierr)
        ss3%EC_PRINC_CURV_VERT = ss1%EC_PRINC_CURV_VERT
     ELSE IF(ALLOCATED(ss2%EC_PRINC_CURV_VERT)) THEN
        CALL ps_conformal("EC_PRINC_CURV_VERT",ss2%EC_PRINC_CURV_VERT,ss3%EC_PRINC_CURV_VERT,iout,ierr)
        ss3%EC_PRINC_CURV_VERT = ss2%EC_PRINC_CURV_VERT
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%EC_PRINC_WIDTH_HOR)).AND.(cclist(ps_cnum_EC).EQ.1)) THEN
     IF(ALLOCATED(ss1%EC_PRINC_WIDTH_HOR).AND.ALLOCATED(ss2%EC_PRINC_WIDTH_HOR)) THEN
        CALL ps_diff("EC_PRINC_WIDTH_HOR",ss1%EC_PRINC_WIDTH_HOR,ss2%EC_PRINC_WIDTH_HOR,icheck,iout,ierr)
        CALL ps_conformal("EC_PRINC_WIDTH_HOR",ss1%EC_PRINC_WIDTH_HOR,ss3%EC_PRINC_WIDTH_HOR,iout,ierr)
        if(ierr.eq.0) ss3%EC_PRINC_WIDTH_HOR = ss1%EC_PRINC_WIDTH_HOR
     ELSE IF(ALLOCATED(ss1%EC_PRINC_WIDTH_HOR)) THEN
        CALL ps_conformal("EC_PRINC_WIDTH_HOR",ss1%EC_PRINC_WIDTH_HOR,ss3%EC_PRINC_WIDTH_HOR,iout,ierr)
        ss3%EC_PRINC_WIDTH_HOR = ss1%EC_PRINC_WIDTH_HOR
     ELSE IF(ALLOCATED(ss2%EC_PRINC_WIDTH_HOR)) THEN
        CALL ps_conformal("EC_PRINC_WIDTH_HOR",ss2%EC_PRINC_WIDTH_HOR,ss3%EC_PRINC_WIDTH_HOR,iout,ierr)
        ss3%EC_PRINC_WIDTH_HOR = ss2%EC_PRINC_WIDTH_HOR
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%EC_PRINC_WIDTH_VERT)).AND.(cclist(ps_cnum_EC).EQ.1)) THEN
     IF(ALLOCATED(ss1%EC_PRINC_WIDTH_VERT).AND.ALLOCATED(ss2%EC_PRINC_WIDTH_VERT)) THEN
        CALL ps_diff("EC_PRINC_WIDTH_VERT",ss1%EC_PRINC_WIDTH_VERT,ss2%EC_PRINC_WIDTH_VERT,icheck,iout,ierr)
        CALL ps_conformal("EC_PRINC_WIDTH_VERT",ss1%EC_PRINC_WIDTH_VERT,ss3%EC_PRINC_WIDTH_VERT,iout,ierr)
        if(ierr.eq.0) ss3%EC_PRINC_WIDTH_VERT = ss1%EC_PRINC_WIDTH_VERT
     ELSE IF(ALLOCATED(ss1%EC_PRINC_WIDTH_VERT)) THEN
        CALL ps_conformal("EC_PRINC_WIDTH_VERT",ss1%EC_PRINC_WIDTH_VERT,ss3%EC_PRINC_WIDTH_VERT,iout,ierr)
        ss3%EC_PRINC_WIDTH_VERT = ss1%EC_PRINC_WIDTH_VERT
     ELSE IF(ALLOCATED(ss2%EC_PRINC_WIDTH_VERT)) THEN
        CALL ps_conformal("EC_PRINC_WIDTH_VERT",ss2%EC_PRINC_WIDTH_VERT,ss3%EC_PRINC_WIDTH_VERT,iout,ierr)
        ss3%EC_PRINC_WIDTH_VERT = ss2%EC_PRINC_WIDTH_VERT
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%EC_theta_aim)).AND.(cclist(ps_cnum_EC).EQ.1)) THEN
     IF(ALLOCATED(ss1%EC_theta_aim).AND.ALLOCATED(ss2%EC_theta_aim)) THEN
        CALL ps_diff("EC_theta_aim",ss1%EC_theta_aim,ss2%EC_theta_aim,icheck,iout,ierr)
        CALL ps_conformal("EC_theta_aim",ss1%EC_theta_aim,ss3%EC_theta_aim,iout,ierr)
        if(ierr.eq.0) ss3%EC_theta_aim = ss1%EC_theta_aim
     ELSE IF(ALLOCATED(ss1%EC_theta_aim)) THEN
        CALL ps_conformal("EC_theta_aim",ss1%EC_theta_aim,ss3%EC_theta_aim,iout,ierr)
        ss3%EC_theta_aim = ss1%EC_theta_aim
     ELSE IF(ALLOCATED(ss2%EC_theta_aim)) THEN
        CALL ps_conformal("EC_theta_aim",ss2%EC_theta_aim,ss3%EC_theta_aim,iout,ierr)
        ss3%EC_theta_aim = ss2%EC_theta_aim
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%ee_mobility_factor)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%ee_mobility_factor).AND.ALLOCATED(ss2%ee_mobility_factor)) THEN
        CALL ps_conformal("ee_mobility_factor",ss2%ee_mobility_factor,ss3%ee_mobility_factor,iout,ierr)
        CALL ps_conformal("ee_mobility_factor",ss1%ee_mobility_factor,ss3%ee_mobility_factor,iout,ierr)
        if(ierr.eq.0) ss3%ee_mobility_factor = w1*ss1%ee_mobility_factor + (1.0_rspec-w1)*ss2%ee_mobility_factor
     ELSE IF(ALLOCATED(ss1%ee_mobility_factor)) THEN
        CALL ps_conformal("ee_mobility_factor",ss1%ee_mobility_factor,ss3%ee_mobility_factor,iout,ierr)
        ss3%ee_mobility_factor = ss1%ee_mobility_factor
     ELSE IF(ALLOCATED(ss2%ee_mobility_factor)) THEN
        CALL ps_conformal("ee_mobility_factor",ss2%ee_mobility_factor,ss3%ee_mobility_factor,iout,ierr)
        ss3%ee_mobility_factor = ss2%ee_mobility_factor
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%Einj_max)).AND.(cclist(ps_cnum_NBI).EQ.1)) THEN
     IF(ALLOCATED(ss1%Einj_max).AND.ALLOCATED(ss2%Einj_max)) THEN
        CALL ps_diff("Einj_max",ss1%Einj_max,ss2%Einj_max,icheck,iout,ierr)
        CALL ps_conformal("Einj_max",ss1%Einj_max,ss3%Einj_max,iout,ierr)
        if(ierr.eq.0) ss3%Einj_max = ss1%Einj_max
     ELSE IF(ALLOCATED(ss1%Einj_max)) THEN
        CALL ps_conformal("Einj_max",ss1%Einj_max,ss3%Einj_max,iout,ierr)
        ss3%Einj_max = ss1%Einj_max
     ELSE IF(ALLOCATED(ss2%Einj_max)) THEN
        CALL ps_conformal("Einj_max",ss2%Einj_max,ss3%Einj_max,iout,ierr)
        ss3%Einj_max = ss2%Einj_max
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%Einj_min)).AND.(cclist(ps_cnum_NBI).EQ.1)) THEN
     IF(ALLOCATED(ss1%Einj_min).AND.ALLOCATED(ss2%Einj_min)) THEN
        CALL ps_diff("Einj_min",ss1%Einj_min,ss2%Einj_min,icheck,iout,ierr)
        CALL ps_conformal("Einj_min",ss1%Einj_min,ss3%Einj_min,iout,ierr)
        if(ierr.eq.0) ss3%Einj_min = ss1%Einj_min
     ELSE IF(ALLOCATED(ss1%Einj_min)) THEN
        CALL ps_conformal("Einj_min",ss1%Einj_min,ss3%Einj_min,iout,ierr)
        ss3%Einj_min = ss1%Einj_min
     ELSE IF(ALLOCATED(ss2%Einj_min)) THEN
        CALL ps_conformal("Einj_min",ss2%Einj_min,ss3%Einj_min,iout,ierr)
        ss3%Einj_min = ss2%Einj_min
     ENDIF
  ENDIF

  IF(cclist(ps_cnum_PLASMA).EQ.1) THEN
     ss3%eldot = w1*ss1%eldot + (1.0_rspec-w1)*ss2%eldot
  ENDIF

  IF((ALLOCATED(ss3%elong)).AND.(cclist(ps_cnum_EQ).EQ.1)) THEN
     IF(ALLOCATED(ss1%elong).AND.ALLOCATED(ss2%elong)) THEN
        CALL ps_conformal("elong",ss2%elong,ss3%elong,iout,ierr)
        CALL ps_conformal("elong",ss1%elong,ss3%elong,iout,ierr)
        if(ierr.eq.0) ss3%elong = w1*ss1%elong + (1.0_rspec-w1)*ss2%elong
     ELSE IF(ALLOCATED(ss1%elong)) THEN
        CALL ps_conformal("elong",ss1%elong,ss3%elong,iout,ierr)
        ss3%elong = ss1%elong
     ELSE IF(ALLOCATED(ss2%elong)) THEN
        CALL ps_conformal("elong",ss2%elong,ss3%elong,iout,ierr)
        ss3%elong = ss2%elong
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%eperp_beami)).AND.(cclist(ps_cnum_NBI).EQ.1)) THEN
     IF(ALLOCATED(ss1%eperp_beami).AND.ALLOCATED(ss2%eperp_beami)) THEN
        CALL ps_conformal("eperp_beami",ss2%eperp_beami,ss3%eperp_beami,iout,ierr)
        CALL ps_conformal("eperp_beami",ss1%eperp_beami,ss3%eperp_beami,iout,ierr)
        if(ierr.eq.0) ss3%eperp_beami = w1*ss1%eperp_beami + (1.0_rspec-w1)*ss2%eperp_beami
     ELSE IF(ALLOCATED(ss1%eperp_beami)) THEN
        CALL ps_conformal("eperp_beami",ss1%eperp_beami,ss3%eperp_beami,iout,ierr)
        ss3%eperp_beami = ss1%eperp_beami
     ELSE IF(ALLOCATED(ss2%eperp_beami)) THEN
        CALL ps_conformal("eperp_beami",ss2%eperp_beami,ss3%eperp_beami,iout,ierr)
        ss3%eperp_beami = ss2%eperp_beami
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%eperp_fusi)).AND.(cclist(ps_cnum_FUS).EQ.1)) THEN
     IF(ALLOCATED(ss1%eperp_fusi).AND.ALLOCATED(ss2%eperp_fusi)) THEN
        CALL ps_conformal("eperp_fusi",ss2%eperp_fusi,ss3%eperp_fusi,iout,ierr)
        CALL ps_conformal("eperp_fusi",ss1%eperp_fusi,ss3%eperp_fusi,iout,ierr)
        if(ierr.eq.0) ss3%eperp_fusi = w1*ss1%eperp_fusi + (1.0_rspec-w1)*ss2%eperp_fusi
     ELSE IF(ALLOCATED(ss1%eperp_fusi)) THEN
        CALL ps_conformal("eperp_fusi",ss1%eperp_fusi,ss3%eperp_fusi,iout,ierr)
        ss3%eperp_fusi = ss1%eperp_fusi
     ELSE IF(ALLOCATED(ss2%eperp_fusi)) THEN
        CALL ps_conformal("eperp_fusi",ss2%eperp_fusi,ss3%eperp_fusi,iout,ierr)
        ss3%eperp_fusi = ss2%eperp_fusi
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%eperp_mini)).AND.(cclist(ps_cnum_IC).EQ.1)) THEN
     IF(ALLOCATED(ss1%eperp_mini).AND.ALLOCATED(ss2%eperp_mini)) THEN
        CALL ps_conformal("eperp_mini",ss2%eperp_mini,ss3%eperp_mini,iout,ierr)
        CALL ps_conformal("eperp_mini",ss1%eperp_mini,ss3%eperp_mini,iout,ierr)
        if(ierr.eq.0) ss3%eperp_mini = w1*ss1%eperp_mini + (1.0_rspec-w1)*ss2%eperp_mini
     ELSE IF(ALLOCATED(ss1%eperp_mini)) THEN
        CALL ps_conformal("eperp_mini",ss1%eperp_mini,ss3%eperp_mini,iout,ierr)
        ss3%eperp_mini = ss1%eperp_mini
     ELSE IF(ALLOCATED(ss2%eperp_mini)) THEN
        CALL ps_conformal("eperp_mini",ss2%eperp_mini,ss3%eperp_mini,iout,ierr)
        ss3%eperp_mini = ss2%eperp_mini
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%eperp_rw)).AND.(cclist(ps_cnum_RUNAWAY).EQ.1)) THEN
     IF(ALLOCATED(ss1%eperp_rw).AND.ALLOCATED(ss2%eperp_rw)) THEN
        CALL ps_conformal("eperp_rw",ss2%eperp_rw,ss3%eperp_rw,iout,ierr)
        CALL ps_conformal("eperp_rw",ss1%eperp_rw,ss3%eperp_rw,iout,ierr)
        if(ierr.eq.0) ss3%eperp_rw = w1*ss1%eperp_rw + (1.0_rspec-w1)*ss2%eperp_rw
     ELSE IF(ALLOCATED(ss1%eperp_rw)) THEN
        CALL ps_conformal("eperp_rw",ss1%eperp_rw,ss3%eperp_rw,iout,ierr)
        ss3%eperp_rw = ss1%eperp_rw
     ELSE IF(ALLOCATED(ss2%eperp_rw)) THEN
        CALL ps_conformal("eperp_rw",ss2%eperp_rw,ss3%eperp_rw,iout,ierr)
        ss3%eperp_rw = ss2%eperp_rw
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%epll_beami)).AND.(cclist(ps_cnum_NBI).EQ.1)) THEN
     IF(ALLOCATED(ss1%epll_beami).AND.ALLOCATED(ss2%epll_beami)) THEN
        CALL ps_conformal("epll_beami",ss2%epll_beami,ss3%epll_beami,iout,ierr)
        CALL ps_conformal("epll_beami",ss1%epll_beami,ss3%epll_beami,iout,ierr)
        if(ierr.eq.0) ss3%epll_beami = w1*ss1%epll_beami + (1.0_rspec-w1)*ss2%epll_beami
     ELSE IF(ALLOCATED(ss1%epll_beami)) THEN
        CALL ps_conformal("epll_beami",ss1%epll_beami,ss3%epll_beami,iout,ierr)
        ss3%epll_beami = ss1%epll_beami
     ELSE IF(ALLOCATED(ss2%epll_beami)) THEN
        CALL ps_conformal("epll_beami",ss2%epll_beami,ss3%epll_beami,iout,ierr)
        ss3%epll_beami = ss2%epll_beami
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%epll_fusi)).AND.(cclist(ps_cnum_FUS).EQ.1)) THEN
     IF(ALLOCATED(ss1%epll_fusi).AND.ALLOCATED(ss2%epll_fusi)) THEN
        CALL ps_conformal("epll_fusi",ss2%epll_fusi,ss3%epll_fusi,iout,ierr)
        CALL ps_conformal("epll_fusi",ss1%epll_fusi,ss3%epll_fusi,iout,ierr)
        if(ierr.eq.0) ss3%epll_fusi = w1*ss1%epll_fusi + (1.0_rspec-w1)*ss2%epll_fusi
     ELSE IF(ALLOCATED(ss1%epll_fusi)) THEN
        CALL ps_conformal("epll_fusi",ss1%epll_fusi,ss3%epll_fusi,iout,ierr)
        ss3%epll_fusi = ss1%epll_fusi
     ELSE IF(ALLOCATED(ss2%epll_fusi)) THEN
        CALL ps_conformal("epll_fusi",ss2%epll_fusi,ss3%epll_fusi,iout,ierr)
        ss3%epll_fusi = ss2%epll_fusi
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%epll_mini)).AND.(cclist(ps_cnum_IC).EQ.1)) THEN
     IF(ALLOCATED(ss1%epll_mini).AND.ALLOCATED(ss2%epll_mini)) THEN
        CALL ps_conformal("epll_mini",ss2%epll_mini,ss3%epll_mini,iout,ierr)
        CALL ps_conformal("epll_mini",ss1%epll_mini,ss3%epll_mini,iout,ierr)
        if(ierr.eq.0) ss3%epll_mini = w1*ss1%epll_mini + (1.0_rspec-w1)*ss2%epll_mini
     ELSE IF(ALLOCATED(ss1%epll_mini)) THEN
        CALL ps_conformal("epll_mini",ss1%epll_mini,ss3%epll_mini,iout,ierr)
        ss3%epll_mini = ss1%epll_mini
     ELSE IF(ALLOCATED(ss2%epll_mini)) THEN
        CALL ps_conformal("epll_mini",ss2%epll_mini,ss3%epll_mini,iout,ierr)
        ss3%epll_mini = ss2%epll_mini
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%epll_rw)).AND.(cclist(ps_cnum_RUNAWAY).EQ.1)) THEN
     IF(ALLOCATED(ss1%epll_rw).AND.ALLOCATED(ss2%epll_rw)) THEN
        CALL ps_conformal("epll_rw",ss2%epll_rw,ss3%epll_rw,iout,ierr)
        CALL ps_conformal("epll_rw",ss1%epll_rw,ss3%epll_rw,iout,ierr)
        if(ierr.eq.0) ss3%epll_rw = w1*ss1%epll_rw + (1.0_rspec-w1)*ss2%epll_rw
     ELSE IF(ALLOCATED(ss1%epll_rw)) THEN
        CALL ps_conformal("epll_rw",ss1%epll_rw,ss3%epll_rw,iout,ierr)
        ss3%epll_rw = ss1%epll_rw
     ELSE IF(ALLOCATED(ss2%epll_rw)) THEN
        CALL ps_conformal("epll_rw",ss2%epll_rw,ss3%epll_rw,iout,ierr)
        ss3%epll_rw = ss2%epll_rw
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%Epot)).AND.(cclist(ps_cnum_PLASMA).EQ.1)) THEN
     IF(ALLOCATED(ss1%Epot).AND.ALLOCATED(ss2%Epot)) THEN
        CALL ps_conformal("Epot",ss2%Epot,ss3%Epot,iout,ierr)
        CALL ps_conformal("Epot",ss1%Epot,ss3%Epot,iout,ierr)
        if(ierr.eq.0) ss3%Epot = w1*ss1%Epot + (1.0_rspec-w1)*ss2%Epot
     ELSE IF(ALLOCATED(ss1%Epot)) THEN
        CALL ps_conformal("Epot",ss1%Epot,ss3%Epot,iout,ierr)
        ss3%Epot = ss1%Epot
     ELSE IF(ALLOCATED(ss2%Epot)) THEN
        CALL ps_conformal("Epot",ss2%Epot,ss3%Epot,iout,ierr)
        ss3%Epot = ss2%Epot
     ENDIF
  ENDIF

  IF(cclist(ps_cnum_EQ).EQ.1) THEN

     CALL ps_diff("eqdsk_file",ss1%eqdsk_file,ss2%eqdsk_file,icheck,iout,ierr)
     ss3%eqdsk_file = ss1%eqdsk_file
  ENDIF

  IF((ALLOCATED(ss3%eqmom_num)).AND.(cclist(ps_cnum_EQ).EQ.1)) THEN
     IF(ALLOCATED(ss1%eqmom_num).AND.ALLOCATED(ss2%eqmom_num)) THEN
        CALL ps_diff("eqmom_num",ss1%eqmom_num,ss2%eqmom_num,icheck,iout,ierr)
        CALL ps_conformal("eqmom_num",ss1%eqmom_num,ss3%eqmom_num,iout,ierr)
        if(ierr.eq.0) ss3%eqmom_num = ss1%eqmom_num
     ELSE IF(ALLOCATED(ss1%eqmom_num)) THEN
        CALL ps_conformal("eqmom_num",ss1%eqmom_num,ss3%eqmom_num,iout,ierr)
        ss3%eqmom_num = ss1%eqmom_num
     ELSE IF(ALLOCATED(ss2%eqmom_num)) THEN
        CALL ps_conformal("eqmom_num",ss2%eqmom_num,ss3%eqmom_num,iout,ierr)
        ss3%eqmom_num = ss2%eqmom_num
     ENDIF
  ENDIF

  IF(cclist(ps_cnum_EQ).EQ.1) THEN

     CALL ps_diff("EQ_Code_Info",ss1%EQ_Code_Info,ss2%EQ_Code_Info,icheck,iout,ierr)
     ss3%EQ_Code_Info = ss1%EQ_Code_Info
  ENDIF

  IF(cclist(ps_cnum_EQ).EQ.1) THEN

     CALL ps_diff("EQ_Data_Info",ss1%EQ_Data_Info,ss2%EQ_Data_Info,icheck,iout,ierr)
     ss3%EQ_Data_Info = ss1%EQ_Data_Info
  ENDIF

  IF((ALLOCATED(ss3%eta_parallel)).AND.(cclist(ps_cnum_PLASMA).EQ.1)) THEN
     IF(ALLOCATED(ss1%eta_parallel).AND.ALLOCATED(ss2%eta_parallel)) THEN
        CALL ps_conformal("eta_parallel",ss2%eta_parallel,ss3%eta_parallel,iout,ierr)
        CALL ps_conformal("eta_parallel",ss1%eta_parallel,ss3%eta_parallel,iout,ierr)
        if(ierr.eq.0) ss3%eta_parallel = w1*ss1%eta_parallel + (1.0_rspec-w1)*ss2%eta_parallel
     ELSE IF(ALLOCATED(ss1%eta_parallel)) THEN
        CALL ps_conformal("eta_parallel",ss1%eta_parallel,ss3%eta_parallel,iout,ierr)
        ss3%eta_parallel = ss1%eta_parallel
     ELSE IF(ALLOCATED(ss2%eta_parallel)) THEN
        CALL ps_conformal("eta_parallel",ss2%eta_parallel,ss3%eta_parallel,iout,ierr)
        ss3%eta_parallel = ss2%eta_parallel
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%E_anom)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%E_anom).AND.ALLOCATED(ss2%E_anom)) THEN
        CALL ps_diff("E_anom",ss1%E_anom,ss2%E_anom,ps_error,iout,ierr)
        CALL ps_conformal("E_anom",ss1%E_anom,ss3%E_anom,iout,ierr)
        if(ierr.eq.0) ss3%E_anom = ss1%E_anom
     ELSE IF(ALLOCATED(ss1%E_anom)) THEN
        CALL ps_conformal("E_anom",ss1%E_anom,ss3%E_anom,iout,ierr)
        ss3%E_anom = ss1%E_anom
     ELSE IF(ALLOCATED(ss2%E_anom)) THEN
        CALL ps_conformal("E_anom",ss2%E_anom,ss3%E_anom,iout,ierr)
        ss3%E_anom = ss2%E_anom
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%E_anom2)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%E_anom2).AND.ALLOCATED(ss2%E_anom2)) THEN
        CALL ps_diff("E_anom2",ss1%E_anom2,ss2%E_anom2,ps_error,iout,ierr)
        CALL ps_conformal("E_anom2",ss1%E_anom2,ss3%E_anom2,iout,ierr)
        if(ierr.eq.0) ss3%E_anom2 = ss1%E_anom2
     ELSE IF(ALLOCATED(ss1%E_anom2)) THEN
        CALL ps_conformal("E_anom2",ss1%E_anom2,ss3%E_anom2,iout,ierr)
        ss3%E_anom2 = ss1%E_anom2
     ELSE IF(ALLOCATED(ss2%E_anom2)) THEN
        CALL ps_conformal("E_anom2",ss2%E_anom2,ss3%E_anom2,iout,ierr)
        ss3%E_anom2 = ss2%E_anom2
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%fidiff_bpass_co)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%fidiff_bpass_co).AND.ALLOCATED(ss2%fidiff_bpass_co)) THEN
        CALL ps_conformal("fidiff_bpass_co",ss2%fidiff_bpass_co,ss3%fidiff_bpass_co,iout,ierr)
        CALL ps_conformal("fidiff_bpass_co",ss1%fidiff_bpass_co,ss3%fidiff_bpass_co,iout,ierr)
        if(ierr.eq.0) ss3%fidiff_bpass_co = w1*ss1%fidiff_bpass_co + (1.0_rspec-w1)*ss2%fidiff_bpass_co
     ELSE IF(ALLOCATED(ss1%fidiff_bpass_co)) THEN
        CALL ps_conformal("fidiff_bpass_co",ss1%fidiff_bpass_co,ss3%fidiff_bpass_co,iout,ierr)
        ss3%fidiff_bpass_co = ss1%fidiff_bpass_co
     ELSE IF(ALLOCATED(ss2%fidiff_bpass_co)) THEN
        CALL ps_conformal("fidiff_bpass_co",ss2%fidiff_bpass_co,ss3%fidiff_bpass_co,iout,ierr)
        ss3%fidiff_bpass_co = ss2%fidiff_bpass_co
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%fidiff_bpass_ctr)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%fidiff_bpass_ctr).AND.ALLOCATED(ss2%fidiff_bpass_ctr)) THEN
        CALL ps_conformal("fidiff_bpass_ctr",ss2%fidiff_bpass_ctr,ss3%fidiff_bpass_ctr,iout,ierr)
        CALL ps_conformal("fidiff_bpass_ctr",ss1%fidiff_bpass_ctr,ss3%fidiff_bpass_ctr,iout,ierr)
        if(ierr.eq.0) ss3%fidiff_bpass_ctr = w1*ss1%fidiff_bpass_ctr + (1.0_rspec-w1)*ss2%fidiff_bpass_ctr
     ELSE IF(ALLOCATED(ss1%fidiff_bpass_ctr)) THEN
        CALL ps_conformal("fidiff_bpass_ctr",ss1%fidiff_bpass_ctr,ss3%fidiff_bpass_ctr,iout,ierr)
        ss3%fidiff_bpass_ctr = ss1%fidiff_bpass_ctr
     ELSE IF(ALLOCATED(ss2%fidiff_bpass_ctr)) THEN
        CALL ps_conformal("fidiff_bpass_ctr",ss2%fidiff_bpass_ctr,ss3%fidiff_bpass_ctr,iout,ierr)
        ss3%fidiff_bpass_ctr = ss2%fidiff_bpass_ctr
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%fidiff_btrap)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%fidiff_btrap).AND.ALLOCATED(ss2%fidiff_btrap)) THEN
        CALL ps_conformal("fidiff_btrap",ss2%fidiff_btrap,ss3%fidiff_btrap,iout,ierr)
        CALL ps_conformal("fidiff_btrap",ss1%fidiff_btrap,ss3%fidiff_btrap,iout,ierr)
        if(ierr.eq.0) ss3%fidiff_btrap = w1*ss1%fidiff_btrap + (1.0_rspec-w1)*ss2%fidiff_btrap
     ELSE IF(ALLOCATED(ss1%fidiff_btrap)) THEN
        CALL ps_conformal("fidiff_btrap",ss1%fidiff_btrap,ss3%fidiff_btrap,iout,ierr)
        ss3%fidiff_btrap = ss1%fidiff_btrap
     ELSE IF(ALLOCATED(ss2%fidiff_btrap)) THEN
        CALL ps_conformal("fidiff_btrap",ss2%fidiff_btrap,ss3%fidiff_btrap,iout,ierr)
        ss3%fidiff_btrap = ss2%fidiff_btrap
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%fidiff_dpass_co)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%fidiff_dpass_co).AND.ALLOCATED(ss2%fidiff_dpass_co)) THEN
        CALL ps_conformal("fidiff_dpass_co",ss2%fidiff_dpass_co,ss3%fidiff_dpass_co,iout,ierr)
        CALL ps_conformal("fidiff_dpass_co",ss1%fidiff_dpass_co,ss3%fidiff_dpass_co,iout,ierr)
        if(ierr.eq.0) ss3%fidiff_dpass_co = w1*ss1%fidiff_dpass_co + (1.0_rspec-w1)*ss2%fidiff_dpass_co
     ELSE IF(ALLOCATED(ss1%fidiff_dpass_co)) THEN
        CALL ps_conformal("fidiff_dpass_co",ss1%fidiff_dpass_co,ss3%fidiff_dpass_co,iout,ierr)
        ss3%fidiff_dpass_co = ss1%fidiff_dpass_co
     ELSE IF(ALLOCATED(ss2%fidiff_dpass_co)) THEN
        CALL ps_conformal("fidiff_dpass_co",ss2%fidiff_dpass_co,ss3%fidiff_dpass_co,iout,ierr)
        ss3%fidiff_dpass_co = ss2%fidiff_dpass_co
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%fidiff_dpass_ctr)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%fidiff_dpass_ctr).AND.ALLOCATED(ss2%fidiff_dpass_ctr)) THEN
        CALL ps_conformal("fidiff_dpass_ctr",ss2%fidiff_dpass_ctr,ss3%fidiff_dpass_ctr,iout,ierr)
        CALL ps_conformal("fidiff_dpass_ctr",ss1%fidiff_dpass_ctr,ss3%fidiff_dpass_ctr,iout,ierr)
        if(ierr.eq.0) ss3%fidiff_dpass_ctr = w1*ss1%fidiff_dpass_ctr + (1.0_rspec-w1)*ss2%fidiff_dpass_ctr
     ELSE IF(ALLOCATED(ss1%fidiff_dpass_ctr)) THEN
        CALL ps_conformal("fidiff_dpass_ctr",ss1%fidiff_dpass_ctr,ss3%fidiff_dpass_ctr,iout,ierr)
        ss3%fidiff_dpass_ctr = ss1%fidiff_dpass_ctr
     ELSE IF(ALLOCATED(ss2%fidiff_dpass_ctr)) THEN
        CALL ps_conformal("fidiff_dpass_ctr",ss2%fidiff_dpass_ctr,ss3%fidiff_dpass_ctr,iout,ierr)
        ss3%fidiff_dpass_ctr = ss2%fidiff_dpass_ctr
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%fidiff_dtrap)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%fidiff_dtrap).AND.ALLOCATED(ss2%fidiff_dtrap)) THEN
        CALL ps_conformal("fidiff_dtrap",ss2%fidiff_dtrap,ss3%fidiff_dtrap,iout,ierr)
        CALL ps_conformal("fidiff_dtrap",ss1%fidiff_dtrap,ss3%fidiff_dtrap,iout,ierr)
        if(ierr.eq.0) ss3%fidiff_dtrap = w1*ss1%fidiff_dtrap + (1.0_rspec-w1)*ss2%fidiff_dtrap
     ELSE IF(ALLOCATED(ss1%fidiff_dtrap)) THEN
        CALL ps_conformal("fidiff_dtrap",ss1%fidiff_dtrap,ss3%fidiff_dtrap,iout,ierr)
        ss3%fidiff_dtrap = ss1%fidiff_dtrap
     ELSE IF(ALLOCATED(ss2%fidiff_dtrap)) THEN
        CALL ps_conformal("fidiff_dtrap",ss2%fidiff_dtrap,ss3%fidiff_dtrap,iout,ierr)
        ss3%fidiff_dtrap = ss2%fidiff_dtrap
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%Fi_depletion)).AND.(cclist(ps_cnum_PLASMA).EQ.1)) THEN
     IF(ALLOCATED(ss1%Fi_depletion).AND.ALLOCATED(ss2%Fi_depletion)) THEN
        CALL ps_conformal("Fi_depletion",ss2%Fi_depletion,ss3%Fi_depletion,iout,ierr)
        CALL ps_conformal("Fi_depletion",ss1%Fi_depletion,ss3%Fi_depletion,iout,ierr)
        if(ierr.eq.0) ss3%Fi_depletion = w1*ss1%Fi_depletion + (1.0_rspec-w1)*ss2%Fi_depletion
     ELSE IF(ALLOCATED(ss1%Fi_depletion)) THEN
        CALL ps_conformal("Fi_depletion",ss1%Fi_depletion,ss3%Fi_depletion,iout,ierr)
        ss3%Fi_depletion = ss1%Fi_depletion
     ELSE IF(ALLOCATED(ss2%Fi_depletion)) THEN
        CALL ps_conformal("Fi_depletion",ss2%Fi_depletion,ss3%Fi_depletion,iout,ierr)
        ss3%Fi_depletion = ss2%Fi_depletion
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%fracmin)).AND.(cclist(ps_cnum_IC).EQ.1)) THEN
     IF(ALLOCATED(ss1%fracmin).AND.ALLOCATED(ss2%fracmin)) THEN
        CALL ps_diff("fracmin",ss1%fracmin,ss2%fracmin,icheck,iout,ierr)
        CALL ps_conformal("fracmin",ss1%fracmin,ss3%fracmin,iout,ierr)
        if(ierr.eq.0) ss3%fracmin = ss1%fracmin
     ELSE IF(ALLOCATED(ss1%fracmin)) THEN
        CALL ps_conformal("fracmin",ss1%fracmin,ss3%fracmin,iout,ierr)
        ss3%fracmin = ss1%fracmin
     ELSE IF(ALLOCATED(ss2%fracmin)) THEN
        CALL ps_conformal("fracmin",ss2%fracmin,ss3%fracmin,iout,ierr)
        ss3%fracmin = ss2%fracmin
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%fracpslh)).AND.(cclist(ps_cnum_LH).EQ.1)) THEN
     IF(ALLOCATED(ss1%fracpslh).AND.ALLOCATED(ss2%fracpslh)) THEN
        CALL ps_diff("fracpslh",ss1%fracpslh,ss2%fracpslh,icheck,iout,ierr)
        CALL ps_conformal("fracpslh",ss1%fracpslh,ss3%fracpslh,iout,ierr)
        if(ierr.eq.0) ss3%fracpslh = ss1%fracpslh
     ELSE IF(ALLOCATED(ss1%fracpslh)) THEN
        CALL ps_conformal("fracpslh",ss1%fracpslh,ss3%fracpslh,iout,ierr)
        ss3%fracpslh = ss1%fracpslh
     ELSE IF(ALLOCATED(ss2%fracpslh)) THEN
        CALL ps_conformal("fracpslh",ss2%fracpslh,ss3%fracpslh,iout,ierr)
        ss3%fracpslh = ss2%fracpslh
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%frac_full)).AND.(cclist(ps_cnum_NBI).EQ.1)) THEN
     IF(ALLOCATED(ss1%frac_full).AND.ALLOCATED(ss2%frac_full)) THEN
        CALL ps_conformal("frac_full",ss2%frac_full,ss3%frac_full,iout,ierr)
        CALL ps_conformal("frac_full",ss1%frac_full,ss3%frac_full,iout,ierr)
        if(ierr.eq.0) ss3%frac_full = w1*ss1%frac_full + (1.0_rspec-w1)*ss2%frac_full
     ELSE IF(ALLOCATED(ss1%frac_full)) THEN
        CALL ps_conformal("frac_full",ss1%frac_full,ss3%frac_full,iout,ierr)
        ss3%frac_full = ss1%frac_full
     ELSE IF(ALLOCATED(ss2%frac_full)) THEN
        CALL ps_conformal("frac_full",ss2%frac_full,ss3%frac_full,iout,ierr)
        ss3%frac_full = ss2%frac_full
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%frac_half)).AND.(cclist(ps_cnum_NBI).EQ.1)) THEN
     IF(ALLOCATED(ss1%frac_half).AND.ALLOCATED(ss2%frac_half)) THEN
        CALL ps_conformal("frac_half",ss2%frac_half,ss3%frac_half,iout,ierr)
        CALL ps_conformal("frac_half",ss1%frac_half,ss3%frac_half,iout,ierr)
        if(ierr.eq.0) ss3%frac_half = w1*ss1%frac_half + (1.0_rspec-w1)*ss2%frac_half
     ELSE IF(ALLOCATED(ss1%frac_half)) THEN
        CALL ps_conformal("frac_half",ss1%frac_half,ss3%frac_half,iout,ierr)
        ss3%frac_half = ss1%frac_half
     ELSE IF(ALLOCATED(ss2%frac_half)) THEN
        CALL ps_conformal("frac_half",ss2%frac_half,ss3%frac_half,iout,ierr)
        ss3%frac_half = ss2%frac_half
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%freq_drbm)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%freq_drbm).AND.ALLOCATED(ss2%freq_drbm)) THEN
        CALL ps_conformal("freq_drbm",ss2%freq_drbm,ss3%freq_drbm,iout,ierr)
        CALL ps_conformal("freq_drbm",ss1%freq_drbm,ss3%freq_drbm,iout,ierr)
        if(ierr.eq.0) ss3%freq_drbm = w1*ss1%freq_drbm + (1.0_rspec-w1)*ss2%freq_drbm
     ELSE IF(ALLOCATED(ss1%freq_drbm)) THEN
        CALL ps_conformal("freq_drbm",ss1%freq_drbm,ss3%freq_drbm,iout,ierr)
        ss3%freq_drbm = ss1%freq_drbm
     ELSE IF(ALLOCATED(ss2%freq_drbm)) THEN
        CALL ps_conformal("freq_drbm",ss2%freq_drbm,ss3%freq_drbm,iout,ierr)
        ss3%freq_drbm = ss2%freq_drbm
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%freq_ec)).AND.(cclist(ps_cnum_EC).EQ.1)) THEN
     IF(ALLOCATED(ss1%freq_ec).AND.ALLOCATED(ss2%freq_ec)) THEN
        CALL ps_diff("freq_ec",ss1%freq_ec,ss2%freq_ec,icheck,iout,ierr)
        CALL ps_conformal("freq_ec",ss1%freq_ec,ss3%freq_ec,iout,ierr)
        if(ierr.eq.0) ss3%freq_ec = ss1%freq_ec
     ELSE IF(ALLOCATED(ss1%freq_ec)) THEN
        CALL ps_conformal("freq_ec",ss1%freq_ec,ss3%freq_ec,iout,ierr)
        ss3%freq_ec = ss1%freq_ec
     ELSE IF(ALLOCATED(ss2%freq_ec)) THEN
        CALL ps_conformal("freq_ec",ss2%freq_ec,ss3%freq_ec,iout,ierr)
        ss3%freq_ec = ss2%freq_ec
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%freq_glf)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%freq_glf).AND.ALLOCATED(ss2%freq_glf)) THEN
        CALL ps_conformal("freq_glf",ss2%freq_glf,ss3%freq_glf,iout,ierr)
        CALL ps_conformal("freq_glf",ss1%freq_glf,ss3%freq_glf,iout,ierr)
        if(ierr.eq.0) ss3%freq_glf = w1*ss1%freq_glf + (1.0_rspec-w1)*ss2%freq_glf
     ELSE IF(ALLOCATED(ss1%freq_glf)) THEN
        CALL ps_conformal("freq_glf",ss1%freq_glf,ss3%freq_glf,iout,ierr)
        ss3%freq_glf = ss1%freq_glf
     ELSE IF(ALLOCATED(ss2%freq_glf)) THEN
        CALL ps_conformal("freq_glf",ss2%freq_glf,ss3%freq_glf,iout,ierr)
        ss3%freq_glf = ss2%freq_glf
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%freq_ic)).AND.(cclist(ps_cnum_IC).EQ.1)) THEN
     IF(ALLOCATED(ss1%freq_ic).AND.ALLOCATED(ss2%freq_ic)) THEN
        CALL ps_diff("freq_ic",ss1%freq_ic,ss2%freq_ic,icheck,iout,ierr)
        CALL ps_conformal("freq_ic",ss1%freq_ic,ss3%freq_ic,iout,ierr)
        if(ierr.eq.0) ss3%freq_ic = ss1%freq_ic
     ELSE IF(ALLOCATED(ss1%freq_ic)) THEN
        CALL ps_conformal("freq_ic",ss1%freq_ic,ss3%freq_ic,iout,ierr)
        ss3%freq_ic = ss1%freq_ic
     ELSE IF(ALLOCATED(ss2%freq_ic)) THEN
        CALL ps_conformal("freq_ic",ss2%freq_ic,ss3%freq_ic,iout,ierr)
        ss3%freq_ic = ss2%freq_ic
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%freq_lh)).AND.(cclist(ps_cnum_LH).EQ.1)) THEN
     IF(ALLOCATED(ss1%freq_lh).AND.ALLOCATED(ss2%freq_lh)) THEN
        CALL ps_diff("freq_lh",ss1%freq_lh,ss2%freq_lh,icheck,iout,ierr)
        CALL ps_conformal("freq_lh",ss1%freq_lh,ss3%freq_lh,iout,ierr)
        if(ierr.eq.0) ss3%freq_lh = ss1%freq_lh
     ELSE IF(ALLOCATED(ss1%freq_lh)) THEN
        CALL ps_conformal("freq_lh",ss1%freq_lh,ss3%freq_lh,iout,ierr)
        ss3%freq_lh = ss1%freq_lh
     ELSE IF(ALLOCATED(ss2%freq_lh)) THEN
        CALL ps_conformal("freq_lh",ss2%freq_lh,ss3%freq_lh,iout,ierr)
        ss3%freq_lh = ss2%freq_lh
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%freq_max_tglf)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%freq_max_tglf).AND.ALLOCATED(ss2%freq_max_tglf)) THEN
        CALL ps_conformal("freq_max_tglf",ss2%freq_max_tglf,ss3%freq_max_tglf,iout,ierr)
        CALL ps_conformal("freq_max_tglf",ss1%freq_max_tglf,ss3%freq_max_tglf,iout,ierr)
        if(ierr.eq.0) ss3%freq_max_tglf = w1*ss1%freq_max_tglf + (1.0_rspec-w1)*ss2%freq_max_tglf
     ELSE IF(ALLOCATED(ss1%freq_max_tglf)) THEN
        CALL ps_conformal("freq_max_tglf",ss1%freq_max_tglf,ss3%freq_max_tglf,iout,ierr)
        ss3%freq_max_tglf = ss1%freq_max_tglf
     ELSE IF(ALLOCATED(ss2%freq_max_tglf)) THEN
        CALL ps_conformal("freq_max_tglf",ss2%freq_max_tglf,ss3%freq_max_tglf,iout,ierr)
        ss3%freq_max_tglf = ss2%freq_max_tglf
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%freq_mmm71)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%freq_mmm71).AND.ALLOCATED(ss2%freq_mmm71)) THEN
        CALL ps_conformal("freq_mmm71",ss2%freq_mmm71,ss3%freq_mmm71,iout,ierr)
        CALL ps_conformal("freq_mmm71",ss1%freq_mmm71,ss3%freq_mmm71,iout,ierr)
        if(ierr.eq.0) ss3%freq_mmm71 = w1*ss1%freq_mmm71 + (1.0_rspec-w1)*ss2%freq_mmm71
     ELSE IF(ALLOCATED(ss1%freq_mmm71)) THEN
        CALL ps_conformal("freq_mmm71",ss1%freq_mmm71,ss3%freq_mmm71,iout,ierr)
        ss3%freq_mmm71 = ss1%freq_mmm71
     ELSE IF(ALLOCATED(ss2%freq_mmm71)) THEN
        CALL ps_conformal("freq_mmm71",ss2%freq_mmm71,ss3%freq_mmm71,iout,ierr)
        ss3%freq_mmm71 = ss2%freq_mmm71
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%freq_mtm)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%freq_mtm).AND.ALLOCATED(ss2%freq_mtm)) THEN
        CALL ps_conformal("freq_mtm",ss2%freq_mtm,ss3%freq_mtm,iout,ierr)
        CALL ps_conformal("freq_mtm",ss1%freq_mtm,ss3%freq_mtm,iout,ierr)
        if(ierr.eq.0) ss3%freq_mtm = w1*ss1%freq_mtm + (1.0_rspec-w1)*ss2%freq_mtm
     ELSE IF(ALLOCATED(ss1%freq_mtm)) THEN
        CALL ps_conformal("freq_mtm",ss1%freq_mtm,ss3%freq_mtm,iout,ierr)
        ss3%freq_mtm = ss1%freq_mtm
     ELSE IF(ALLOCATED(ss2%freq_mtm)) THEN
        CALL ps_conformal("freq_mtm",ss2%freq_mtm,ss3%freq_mtm,iout,ierr)
        ss3%freq_mtm = ss2%freq_mtm
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%freq_tglf)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%freq_tglf).AND.ALLOCATED(ss2%freq_tglf)) THEN
        CALL ps_conformal("freq_tglf",ss2%freq_tglf,ss3%freq_tglf,iout,ierr)
        CALL ps_conformal("freq_tglf",ss1%freq_tglf,ss3%freq_tglf,iout,ierr)
        if(ierr.eq.0) ss3%freq_tglf = w1*ss1%freq_tglf + (1.0_rspec-w1)*ss2%freq_tglf
     ELSE IF(ALLOCATED(ss1%freq_tglf)) THEN
        CALL ps_conformal("freq_tglf",ss1%freq_tglf,ss3%freq_tglf,iout,ierr)
        ss3%freq_tglf = ss1%freq_tglf
     ELSE IF(ALLOCATED(ss2%freq_tglf)) THEN
        CALL ps_conformal("freq_tglf",ss2%freq_tglf,ss3%freq_tglf,iout,ierr)
        ss3%freq_tglf = ss2%freq_tglf
     ENDIF
  ENDIF

  IF(cclist(ps_cnum_FUS).EQ.1) THEN

     CALL ps_diff("FUS_Code_Info",ss1%FUS_Code_Info,ss2%FUS_Code_Info,icheck,iout,ierr)
     ss3%FUS_Code_Info = ss1%FUS_Code_Info
  ENDIF

  IF((ALLOCATED(ss3%gamma_lmhd)).AND.(cclist(ps_cnum_LMHD).EQ.1)) THEN
     IF(ALLOCATED(ss1%gamma_lmhd).AND.ALLOCATED(ss2%gamma_lmhd)) THEN
        CALL ps_conformal("gamma_lmhd",ss2%gamma_lmhd,ss3%gamma_lmhd,iout,ierr)
        CALL ps_conformal("gamma_lmhd",ss1%gamma_lmhd,ss3%gamma_lmhd,iout,ierr)
        if(ierr.eq.0) ss3%gamma_lmhd = w1*ss1%gamma_lmhd + (1.0_rspec-w1)*ss2%gamma_lmhd
     ELSE IF(ALLOCATED(ss1%gamma_lmhd)) THEN
        CALL ps_conformal("gamma_lmhd",ss1%gamma_lmhd,ss3%gamma_lmhd,iout,ierr)
        ss3%gamma_lmhd = ss1%gamma_lmhd
     ELSE IF(ALLOCATED(ss2%gamma_lmhd)) THEN
        CALL ps_conformal("gamma_lmhd",ss2%gamma_lmhd,ss3%gamma_lmhd,iout,ierr)
        ss3%gamma_lmhd = ss2%gamma_lmhd
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%gamma_nc)).AND.(cclist(ps_cnum_EQ).EQ.1)) THEN
     IF(ALLOCATED(ss1%gamma_nc).AND.ALLOCATED(ss2%gamma_nc)) THEN
        CALL ps_conformal("gamma_nc",ss2%gamma_nc,ss3%gamma_nc,iout,ierr)
        CALL ps_conformal("gamma_nc",ss1%gamma_nc,ss3%gamma_nc,iout,ierr)
        if(ierr.eq.0) ss3%gamma_nc = w1*ss1%gamma_nc + (1.0_rspec-w1)*ss2%gamma_nc
     ELSE IF(ALLOCATED(ss1%gamma_nc)) THEN
        CALL ps_conformal("gamma_nc",ss1%gamma_nc,ss3%gamma_nc,iout,ierr)
        ss3%gamma_nc = ss1%gamma_nc
     ELSE IF(ALLOCATED(ss2%gamma_nc)) THEN
        CALL ps_conformal("gamma_nc",ss2%gamma_nc,ss3%gamma_nc,iout,ierr)
        ss3%gamma_nc = ss2%gamma_nc
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%gas_atom)).AND.(cclist(ps_cnum_GAS).EQ.1)) THEN
     IF(ALLOCATED(ss1%gas_atom).AND.ALLOCATED(ss2%gas_atom)) THEN
        CALL ps_diff("gas_atom",ss1%gas_atom,ss2%gas_atom,icheck,iout,ierr)
        CALL ps_conformal("gas_atom",ss1%gas_atom,ss3%gas_atom,iout,ierr)
        if(ierr.eq.0) ss3%gas_atom = ss1%gas_atom
     ELSE IF(ALLOCATED(ss1%gas_atom)) THEN
        CALL ps_conformal("gas_atom",ss1%gas_atom,ss3%gas_atom,iout,ierr)
        ss3%gas_atom = ss1%gas_atom
     ELSE IF(ALLOCATED(ss2%gas_atom)) THEN
        CALL ps_conformal("gas_atom",ss2%gas_atom,ss3%gas_atom,iout,ierr)
        ss3%gas_atom = ss2%gas_atom
     ENDIF
  ENDIF

  IF(cclist(ps_cnum_GAS).EQ.1) THEN

     CALL ps_diff("GAS_Code_Info",ss1%GAS_Code_Info,ss2%GAS_Code_Info,icheck,iout,ierr)
     ss3%GAS_Code_Info = ss1%GAS_Code_Info
  ENDIF

  IF((ALLOCATED(ss3%gb1)).AND.(cclist(ps_cnum_EQ).EQ.1)) THEN
     IF(ALLOCATED(ss1%gb1).AND.ALLOCATED(ss2%gb1)) THEN
        CALL ps_conformal("gb1",ss2%gb1,ss3%gb1,iout,ierr)
        CALL ps_conformal("gb1",ss1%gb1,ss3%gb1,iout,ierr)
        if(ierr.eq.0) ss3%gb1 = w1*ss1%gb1 + (1.0_rspec-w1)*ss2%gb1
     ELSE IF(ALLOCATED(ss1%gb1)) THEN
        CALL ps_conformal("gb1",ss1%gb1,ss3%gb1,iout,ierr)
        ss3%gb1 = ss1%gb1
     ELSE IF(ALLOCATED(ss2%gb1)) THEN
        CALL ps_conformal("gb1",ss2%gb1,ss3%gb1,iout,ierr)
        ss3%gb1 = ss2%gb1
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%gb2)).AND.(cclist(ps_cnum_EQ).EQ.1)) THEN
     IF(ALLOCATED(ss1%gb2).AND.ALLOCATED(ss2%gb2)) THEN
        CALL ps_conformal("gb2",ss2%gb2,ss3%gb2,iout,ierr)
        CALL ps_conformal("gb2",ss1%gb2,ss3%gb2,iout,ierr)
        if(ierr.eq.0) ss3%gb2 = w1*ss1%gb2 + (1.0_rspec-w1)*ss2%gb2
     ELSE IF(ALLOCATED(ss1%gb2)) THEN
        CALL ps_conformal("gb2",ss1%gb2,ss3%gb2,iout,ierr)
        ss3%gb2 = ss1%gb2
     ELSE IF(ALLOCATED(ss2%gb2)) THEN
        CALL ps_conformal("gb2",ss2%gb2,ss3%gb2,iout,ierr)
        ss3%gb2 = ss2%gb2
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%gb2i)).AND.(cclist(ps_cnum_EQ).EQ.1)) THEN
     IF(ALLOCATED(ss1%gb2i).AND.ALLOCATED(ss2%gb2i)) THEN
        CALL ps_conformal("gb2i",ss2%gb2i,ss3%gb2i,iout,ierr)
        CALL ps_conformal("gb2i",ss1%gb2i,ss3%gb2i,iout,ierr)
        if(ierr.eq.0) ss3%gb2i = w1*ss1%gb2i + (1.0_rspec-w1)*ss2%gb2i
     ELSE IF(ALLOCATED(ss1%gb2i)) THEN
        CALL ps_conformal("gb2i",ss1%gb2i,ss3%gb2i,iout,ierr)
        ss3%gb2i = ss1%gb2i
     ELSE IF(ALLOCATED(ss2%gb2i)) THEN
        CALL ps_conformal("gb2i",ss2%gb2i,ss3%gb2i,iout,ierr)
        ss3%gb2i = ss2%gb2i
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%gbr2)).AND.(cclist(ps_cnum_EQ).EQ.1)) THEN
     IF(ALLOCATED(ss1%gbr2).AND.ALLOCATED(ss2%gbr2)) THEN
        CALL ps_conformal("gbr2",ss2%gbr2,ss3%gbr2,iout,ierr)
        CALL ps_conformal("gbr2",ss1%gbr2,ss3%gbr2,iout,ierr)
        if(ierr.eq.0) ss3%gbr2 = w1*ss1%gbr2 + (1.0_rspec-w1)*ss2%gbr2
     ELSE IF(ALLOCATED(ss1%gbr2)) THEN
        CALL ps_conformal("gbr2",ss1%gbr2,ss3%gbr2,iout,ierr)
        ss3%gbr2 = ss1%gbr2
     ELSE IF(ALLOCATED(ss2%gbr2)) THEN
        CALL ps_conformal("gbr2",ss2%gbr2,ss3%gbr2,iout,ierr)
        ss3%gbr2 = ss2%gbr2
     ENDIF
  ENDIF

  IF(cclist(ps_cnum_EQ).EQ.1) THEN

     CALL ps_diff("geometry",ss1%geometry,ss2%geometry,icheck,iout,ierr)
     ss3%geometry = ss1%geometry
  ENDIF

  IF(cclist(ps_cnum_PLASMA).EQ.1) THEN

     CALL ps_diff("Global_label",ss1%Global_label,ss2%Global_label,icheck,iout,ierr)
     ss3%Global_label = ss1%Global_label
  ENDIF

  IF((ALLOCATED(ss3%gncfb2h)).AND.(cclist(ps_cnum_EQ).EQ.1)) THEN
     IF(ALLOCATED(ss1%gncfb2h).AND.ALLOCATED(ss2%gncfb2h)) THEN
        CALL ps_conformal("gncfb2h",ss2%gncfb2h,ss3%gncfb2h,iout,ierr)
        CALL ps_conformal("gncfb2h",ss1%gncfb2h,ss3%gncfb2h,iout,ierr)
        if(ierr.eq.0) ss3%gncfb2h = w1*ss1%gncfb2h + (1.0_rspec-w1)*ss2%gncfb2h
     ELSE IF(ALLOCATED(ss1%gncfb2h)) THEN
        CALL ps_conformal("gncfb2h",ss1%gncfb2h,ss3%gncfb2h,iout,ierr)
        ss3%gncfb2h = ss1%gncfb2h
     ELSE IF(ALLOCATED(ss2%gncfb2h)) THEN
        CALL ps_conformal("gncfb2h",ss2%gncfb2h,ss3%gncfb2h,iout,ierr)
        ss3%gncfb2h = ss2%gncfb2h
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%gncfh)).AND.(cclist(ps_cnum_EQ).EQ.1)) THEN
     IF(ALLOCATED(ss1%gncfh).AND.ALLOCATED(ss2%gncfh)) THEN
        CALL ps_conformal("gncfh",ss2%gncfh,ss3%gncfh,iout,ierr)
        CALL ps_conformal("gncfh",ss1%gncfh,ss3%gncfh,iout,ierr)
        if(ierr.eq.0) ss3%gncfh = w1*ss1%gncfh + (1.0_rspec-w1)*ss2%gncfh
     ELSE IF(ALLOCATED(ss1%gncfh)) THEN
        CALL ps_conformal("gncfh",ss1%gncfh,ss3%gncfh,iout,ierr)
        ss3%gncfh = ss1%gncfh
     ELSE IF(ALLOCATED(ss2%gncfh)) THEN
        CALL ps_conformal("gncfh",ss2%gncfh,ss3%gncfh,iout,ierr)
        ss3%gncfh = ss2%gncfh
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%gr1)).AND.(cclist(ps_cnum_EQ).EQ.1)) THEN
     IF(ALLOCATED(ss1%gr1).AND.ALLOCATED(ss2%gr1)) THEN
        CALL ps_conformal("gr1",ss2%gr1,ss3%gr1,iout,ierr)
        CALL ps_conformal("gr1",ss1%gr1,ss3%gr1,iout,ierr)
        if(ierr.eq.0) ss3%gr1 = w1*ss1%gr1 + (1.0_rspec-w1)*ss2%gr1
     ELSE IF(ALLOCATED(ss1%gr1)) THEN
        CALL ps_conformal("gr1",ss1%gr1,ss3%gr1,iout,ierr)
        ss3%gr1 = ss1%gr1
     ELSE IF(ALLOCATED(ss2%gr1)) THEN
        CALL ps_conformal("gr1",ss2%gr1,ss3%gr1,iout,ierr)
        ss3%gr1 = ss2%gr1
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%gr2)).AND.(cclist(ps_cnum_EQ).EQ.1)) THEN
     IF(ALLOCATED(ss1%gr2).AND.ALLOCATED(ss2%gr2)) THEN
        CALL ps_conformal("gr2",ss2%gr2,ss3%gr2,iout,ierr)
        CALL ps_conformal("gr2",ss1%gr2,ss3%gr2,iout,ierr)
        if(ierr.eq.0) ss3%gr2 = w1*ss1%gr2 + (1.0_rspec-w1)*ss2%gr2
     ELSE IF(ALLOCATED(ss1%gr2)) THEN
        CALL ps_conformal("gr2",ss1%gr2,ss3%gr2,iout,ierr)
        ss3%gr2 = ss1%gr2
     ELSE IF(ALLOCATED(ss2%gr2)) THEN
        CALL ps_conformal("gr2",ss2%gr2,ss3%gr2,iout,ierr)
        ss3%gr2 = ss2%gr2
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%gr2i)).AND.(cclist(ps_cnum_EQ).EQ.1)) THEN
     IF(ALLOCATED(ss1%gr2i).AND.ALLOCATED(ss2%gr2i)) THEN
        CALL ps_conformal("gr2i",ss2%gr2i,ss3%gr2i,iout,ierr)
        CALL ps_conformal("gr2i",ss1%gr2i,ss3%gr2i,iout,ierr)
        if(ierr.eq.0) ss3%gr2i = w1*ss1%gr2i + (1.0_rspec-w1)*ss2%gr2i
     ELSE IF(ALLOCATED(ss1%gr2i)) THEN
        CALL ps_conformal("gr2i",ss1%gr2i,ss3%gr2i,iout,ierr)
        ss3%gr2i = ss1%gr2i
     ELSE IF(ALLOCATED(ss2%gr2i)) THEN
        CALL ps_conformal("gr2i",ss2%gr2i,ss3%gr2i,iout,ierr)
        ss3%gr2i = ss2%gr2i
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%gr2rho2)).AND.(cclist(ps_cnum_EQ).EQ.1)) THEN
     IF(ALLOCATED(ss1%gr2rho2).AND.ALLOCATED(ss2%gr2rho2)) THEN
        CALL ps_conformal("gr2rho2",ss2%gr2rho2,ss3%gr2rho2,iout,ierr)
        CALL ps_conformal("gr2rho2",ss1%gr2rho2,ss3%gr2rho2,iout,ierr)
        if(ierr.eq.0) ss3%gr2rho2 = w1*ss1%gr2rho2 + (1.0_rspec-w1)*ss2%gr2rho2
     ELSE IF(ALLOCATED(ss1%gr2rho2)) THEN
        CALL ps_conformal("gr2rho2",ss1%gr2rho2,ss3%gr2rho2,iout,ierr)
        ss3%gr2rho2 = ss1%gr2rho2
     ELSE IF(ALLOCATED(ss2%gr2rho2)) THEN
        CALL ps_conformal("gr2rho2",ss2%gr2rho2,ss3%gr2rho2,iout,ierr)
        ss3%gr2rho2 = ss2%gr2rho2
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%gr3i)).AND.(cclist(ps_cnum_EQ).EQ.1)) THEN
     IF(ALLOCATED(ss1%gr3i).AND.ALLOCATED(ss2%gr3i)) THEN
        CALL ps_conformal("gr3i",ss2%gr3i,ss3%gr3i,iout,ierr)
        CALL ps_conformal("gr3i",ss1%gr3i,ss3%gr3i,iout,ierr)
        if(ierr.eq.0) ss3%gr3i = w1*ss1%gr3i + (1.0_rspec-w1)*ss2%gr3i
     ELSE IF(ALLOCATED(ss1%gr3i)) THEN
        CALL ps_conformal("gr3i",ss1%gr3i,ss3%gr3i,iout,ierr)
        ss3%gr3i = ss1%gr3i
     ELSE IF(ALLOCATED(ss2%gr3i)) THEN
        CALL ps_conformal("gr3i",ss2%gr3i,ss3%gr3i,iout,ierr)
        ss3%gr3i = ss2%gr3i
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%grho1)).AND.(cclist(ps_cnum_EQ).EQ.1)) THEN
     IF(ALLOCATED(ss1%grho1).AND.ALLOCATED(ss2%grho1)) THEN
        CALL ps_conformal("grho1",ss2%grho1,ss3%grho1,iout,ierr)
        CALL ps_conformal("grho1",ss1%grho1,ss3%grho1,iout,ierr)
        if(ierr.eq.0) ss3%grho1 = w1*ss1%grho1 + (1.0_rspec-w1)*ss2%grho1
     ELSE IF(ALLOCATED(ss1%grho1)) THEN
        CALL ps_conformal("grho1",ss1%grho1,ss3%grho1,iout,ierr)
        ss3%grho1 = ss1%grho1
     ELSE IF(ALLOCATED(ss2%grho1)) THEN
        CALL ps_conformal("grho1",ss2%grho1,ss3%grho1,iout,ierr)
        ss3%grho1 = ss2%grho1
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%grho2)).AND.(cclist(ps_cnum_EQ).EQ.1)) THEN
     IF(ALLOCATED(ss1%grho2).AND.ALLOCATED(ss2%grho2)) THEN
        CALL ps_conformal("grho2",ss2%grho2,ss3%grho2,iout,ierr)
        CALL ps_conformal("grho2",ss1%grho2,ss3%grho2,iout,ierr)
        if(ierr.eq.0) ss3%grho2 = w1*ss1%grho2 + (1.0_rspec-w1)*ss2%grho2
     ELSE IF(ALLOCATED(ss1%grho2)) THEN
        CALL ps_conformal("grho2",ss1%grho2,ss3%grho2,iout,ierr)
        ss3%grho2 = ss1%grho2
     ELSE IF(ALLOCATED(ss2%grho2)) THEN
        CALL ps_conformal("grho2",ss2%grho2,ss3%grho2,iout,ierr)
        ss3%grho2 = ss2%grho2
     ENDIF
  ENDIF

END SUBROUTINE plasma_state_merge_2

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_i5_dummy
     return
  end subroutine ccps_getset_i5_dummy

subroutine psget_i_npoloidal(iobj, data, ierr)
    !! need description
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_i_npoloidal', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % i_npoloidal
end subroutine psget_i_npoloidal


subroutine psset_i_npoloidal(iobj, data, ierr)
    !! need description
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_i_npoloidal', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % i_npoloidal = data
end subroutine psset_i_npoloidal


subroutine psget_id_vtor_inmp(iobj, n1, data, ierr)
    !! 'Array of IDs for vtor_inmp profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_vtor_inmp', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_vtor_inmp
end subroutine psget_id_vtor_inmp


subroutine psgetrnk_id_vtor_inmp(iobj, ndims, ierr)
    !! 'Array of IDs for vtor_inmp profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_vtor_inmp


subroutine psgetdim_id_vtor_inmp(iobj, ndims, dims, ierr)
    !! 'Array of IDs for vtor_inmp profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_vtor_inmp', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_vtor_inmp ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_vtor_inmp)
    endif
end subroutine psgetdim_id_vtor_inmp


subroutine psget_id_epot(iobj, data, ierr)
    !! 'ID for Epot profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_epot', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_epot
end subroutine psget_id_epot


subroutine psget_id_qrot_diff(iobj, data, ierr)
    !! 'ID for qrot_diff profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_qrot_diff', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_qrot_diff
end subroutine psget_id_qrot_diff


subroutine psget_id_pi_transcat(iobj, n1, data, ierr)
    !! 'Array of IDs for pi_transcat profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_pi_transcat', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_pi_transcat
end subroutine psget_id_pi_transcat


subroutine psgetrnk_id_pi_transcat(iobj, ndims, ierr)
    !! 'Array of IDs for pi_transcat profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_pi_transcat


subroutine psgetdim_id_pi_transcat(iobj, ndims, dims, ierr)
    !! 'Array of IDs for pi_transcat profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_pi_transcat', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_pi_transcat ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_pi_transcat)
    endif
end subroutine psgetdim_id_pi_transcat


subroutine psget_id_diff_trans(iobj, n1, data, ierr)
    !! 'Array of IDs for diff_trans profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_diff_trans', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_diff_trans
end subroutine psget_id_diff_trans


subroutine psgetrnk_id_diff_trans(iobj, ndims, ierr)
    !! 'Array of IDs for diff_trans profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_diff_trans


subroutine psgetdim_id_diff_trans(iobj, ndims, dims, ierr)
    !! 'Array of IDs for diff_trans profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_diff_trans', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_diff_trans ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_diff_trans)
    endif
end subroutine psgetdim_id_diff_trans


subroutine psget_id_chii_transcat(iobj, n1, data, ierr)
    !! 'Array of IDs for chii_transcat profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_chii_transcat', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_chii_transcat
end subroutine psget_id_chii_transcat


subroutine psgetrnk_id_chii_transcat(iobj, ndims, ierr)
    !! 'Array of IDs for chii_transcat profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_chii_transcat


subroutine psgetdim_id_chii_transcat(iobj, ndims, dims, ierr)
    !! 'Array of IDs for chii_transcat profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_chii_transcat', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_chii_transcat ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_chii_transcat)
    endif
end subroutine psgetdim_id_chii_transcat


subroutine psget_id_q_eq(iobj, data, ierr)
    !! 'ID for q_eq profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_q_eq', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_q_eq
end subroutine psget_id_q_eq


subroutine psget_id_xzjcos_momeq(iobj, n1, data, ierr)
    !! 'Array of IDs for xZjcos_momeq profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_xzjcos_momeq', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_xzjcos_momeq
end subroutine psget_id_xzjcos_momeq


subroutine psgetrnk_id_xzjcos_momeq(iobj, ndims, ierr)
    !! 'Array of IDs for xZjcos_momeq profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_xzjcos_momeq


subroutine psgetdim_id_xzjcos_momeq(iobj, ndims, dims, ierr)
    !! 'Array of IDs for xZjcos_momeq profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_xzjcos_momeq', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_xzjcos_momeq ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_xzjcos_momeq)
    endif
end subroutine psgetdim_id_xzjcos_momeq


subroutine psget_id_gr1(iobj, data, ierr)
    !! 'ID for gr1 profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_gr1', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_gr1
end subroutine psget_id_gr1


subroutine psget_id_gb2i(iobj, data, ierr)
    !! 'ID for gb2i profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_gb2i', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_gb2i
end subroutine psget_id_gb2i


subroutine psget_id_r_midp_out(iobj, data, ierr)
    !! 'ID for R_midp_out profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_r_midp_out', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_r_midp_out
end subroutine psget_id_r_midp_out


subroutine psget_id_triang(iobj, data, ierr)
    !! 'ID for triang profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_triang', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_triang
end subroutine psget_id_triang


subroutine psget_id_picth(iobj, data, ierr)
    !! 'ID for picth profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_picth', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_picth
end subroutine psget_id_picth


subroutine psget_id_curmino(iobj, data, ierr)
    !! 'ID for curmino profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_curmino', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_curmino
end subroutine psget_id_curmino


subroutine psget_id_tqbjxb(iobj, data, ierr)
    !! 'ID for tqbjxb profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_tqbjxb', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_tqbjxb
end subroutine psget_id_tqbjxb


subroutine psget_id_pcx_halo(iobj, data, ierr)
    !! 'ID for pcx_halo profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_pcx_halo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_pcx_halo
end subroutine psget_id_pcx_halo


subroutine psget_id_rate_sinb0i(iobj, n1, data, ierr)
    !! 'Array of IDs for rate_sinb0i profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_rate_sinb0i', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_rate_sinb0i
end subroutine psget_id_rate_sinb0i


subroutine psgetrnk_id_rate_sinb0i(iobj, ndims, ierr)
    !! 'Array of IDs for rate_sinb0i profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_rate_sinb0i


subroutine psgetdim_id_rate_sinb0i(iobj, ndims, dims, ierr)
    !! 'Array of IDs for rate_sinb0i profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_rate_sinb0i', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_rate_sinb0i ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_rate_sinb0i)
    endif
end subroutine psgetdim_id_rate_sinb0i


subroutine psget_id_rate_sinf0x(iobj, n1, data, ierr)
    !! 'Array of IDs for rate_sinf0x profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_rate_sinf0x', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_rate_sinf0x
end subroutine psget_id_rate_sinf0x


subroutine psgetrnk_id_rate_sinf0x(iobj, ndims, ierr)
    !! 'Array of IDs for rate_sinf0x profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_rate_sinf0x


subroutine psgetdim_id_rate_sinf0x(iobj, ndims, dims, ierr)
    !! 'Array of IDs for rate_sinf0x profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_rate_sinf0x', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_rate_sinf0x ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_rate_sinf0x)
    endif
end subroutine psgetdim_id_rate_sinf0x


subroutine psget_id_prad_cy(iobj, data, ierr)
    !! 'ID for prad_cy profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_prad_cy', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_prad_cy
end subroutine psget_id_prad_cy


subroutine psget_id_sprof0(iobj, n1, n2, data, ierr)
    !! 'Array of IDs for sprof0 profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_sprof0', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % id_sprof0
end subroutine psget_id_sprof0


subroutine psgetrnk_id_sprof0(iobj, ndims, ierr)
    !! 'Array of IDs for sprof0 profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_id_sprof0


subroutine psgetdim_id_sprof0(iobj, ndims, dims, ierr)
    !! 'Array of IDs for sprof0 profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_id_sprof0', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_sprof0 ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_sprof0)
    endif
end subroutine psgetdim_id_sprof0


subroutine psget_id_pcx_reco(iobj, data, ierr)
    !! 'ID for pcx_reco profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_pcx_reco', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_pcx_reco
end subroutine psget_id_pcx_reco


subroutine psget_id_curech_src(iobj, n1, data, ierr)
    !! 'Array of IDs for curech_src profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_curech_src', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_curech_src
end subroutine psget_id_curech_src


subroutine psgetrnk_id_curech_src(iobj, ndims, ierr)
    !! 'Array of IDs for curech_src profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_curech_src


subroutine psgetdim_id_curech_src(iobj, ndims, dims, ierr)
    !! 'Array of IDs for curech_src profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_curech_src', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_curech_src ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_curech_src)
    endif
end subroutine psgetdim_id_curech_src


subroutine psget_id_difb_nbi(iobj, data, ierr)
    !! 'ID for difb_nbi profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_difb_nbi', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_difb_nbi
end subroutine psget_id_difb_nbi


subroutine psget_id_fidiff_dpass_co(iobj, n1, data, ierr)
    !! 'Array of IDs for fidiff_dpass_co profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_fidiff_dpass_co', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_fidiff_dpass_co
end subroutine psget_id_fidiff_dpass_co


subroutine psgetrnk_id_fidiff_dpass_co(iobj, ndims, ierr)
    !! 'Array of IDs for fidiff_dpass_co profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_fidiff_dpass_co


subroutine psgetdim_id_fidiff_dpass_co(iobj, ndims, dims, ierr)
    !! 'Array of IDs for fidiff_dpass_co profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_fidiff_dpass_co', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_fidiff_dpass_co ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_fidiff_dpass_co)
    endif
end subroutine psgetdim_id_fidiff_dpass_co


subroutine psget_id_pi_anom(iobj, data, ierr)
    !! 'ID for pi_anom profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_pi_anom', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_pi_anom
end subroutine psget_id_pi_anom


subroutine psget_id_difns_anom(iobj, n1, data, ierr)
    !! 'Array of IDs for difns_anom profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_difns_anom', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_difns_anom
end subroutine psget_id_difns_anom


subroutine psgetrnk_id_difns_anom(iobj, ndims, ierr)
    !! 'Array of IDs for difns_anom profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_difns_anom


subroutine psgetdim_id_difns_anom(iobj, ndims, dims, ierr)
    !! 'Array of IDs for difns_anom profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_difns_anom', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_difns_anom ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_difns_anom)
    endif
end subroutine psgetdim_id_difns_anom


subroutine psget_id_neflux_ky_tglf(iobj, n1, data, ierr)
    !! 'Array of IDs for neflux_ky_tglf profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_neflux_ky_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_neflux_ky_tglf
end subroutine psget_id_neflux_ky_tglf


subroutine psgetrnk_id_neflux_ky_tglf(iobj, ndims, ierr)
    !! 'Array of IDs for neflux_ky_tglf profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_neflux_ky_tglf


subroutine psgetdim_id_neflux_ky_tglf(iobj, ndims, dims, ierr)
    !! 'Array of IDs for neflux_ky_tglf profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_neflux_ky_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_neflux_ky_tglf ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_neflux_ky_tglf)
    endif
end subroutine psgetdim_id_neflux_ky_tglf


subroutine psget_id_velte_tglf(iobj, data, ierr)
    !! 'ID for velte_tglf profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_velte_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_velte_tglf
end subroutine psget_id_velte_tglf


subroutine psget_id_chiphi_tglf(iobj, data, ierr)
    !! 'ID for chiphi_tglf profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_chiphi_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_chiphi_tglf
end subroutine psget_id_chiphi_tglf


subroutine psget_id_growthrate_mmm71(iobj, n1, data, ierr)
    !! 'Array of IDs for growthrate_mmm71 profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_growthrate_mmm71', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_growthrate_mmm71
end subroutine psget_id_growthrate_mmm71


subroutine psgetrnk_id_growthrate_mmm71(iobj, ndims, ierr)
    !! 'Array of IDs for growthrate_mmm71 profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_growthrate_mmm71


subroutine psgetdim_id_growthrate_mmm71(iobj, ndims, dims, ierr)
    !! 'Array of IDs for growthrate_mmm71 profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_growthrate_mmm71', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_growthrate_mmm71 ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_growthrate_mmm71)
    endif
end subroutine psgetdim_id_growthrate_mmm71


subroutine psget_id_chie_drbm(iobj, data, ierr)
    !! 'ID for chie_drbm profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_chie_drbm', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_chie_drbm
end subroutine psget_id_chie_drbm


subroutine psget_id_chie_mtm(iobj, data, ierr)
    !! 'ID for chie_mtm profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_chie_mtm', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_chie_mtm
end subroutine psget_id_chie_mtm


subroutine psget_id_velns_glf(iobj, n1, data, ierr)
    !! 'Array of IDs for velns_glf profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_velns_glf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_velns_glf
end subroutine psget_id_velns_glf


subroutine psgetrnk_id_velns_glf(iobj, ndims, ierr)
    !! 'Array of IDs for velns_glf profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_velns_glf


subroutine psgetdim_id_velns_glf(iobj, ndims, dims, ierr)
    !! 'Array of IDs for velns_glf profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_velns_glf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_velns_glf ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_velns_glf)
    endif
end subroutine psgetdim_id_velns_glf


subroutine psget_id_velti_gtcneo(iobj, data, ierr)
    !! 'ID for velti_gtcneo profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_velti_gtcneo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_velti_gtcneo
end subroutine psget_id_velti_gtcneo


subroutine psget_id_velns_neo(iobj, n1, data, ierr)
    !! 'Array of IDs for velns_neo profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_velns_neo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_velns_neo
end subroutine psget_id_velns_neo


subroutine psgetrnk_id_velns_neo(iobj, ndims, ierr)
    !! 'Array of IDs for velns_neo profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_velns_neo


subroutine psgetdim_id_velns_neo(iobj, ndims, dims, ierr)
    !! 'Array of IDs for velns_neo profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_velns_neo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_velns_neo ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_velns_neo)
    endif
end subroutine psgetdim_id_velns_neo


subroutine psget_id_velne_nclass(iobj, data, ierr)
    !! 'ID for velne_nclass profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_velne_nclass', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_velne_nclass
end subroutine psget_id_velne_nclass

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


SUBROUTINE plasma_state_copy_3(cclist,ss,ss2,icopy_lists,iwant_1deq,partial_copy,ierr)


  ! Copy scalars, and, arrays that are allocated
  !   ss2 <-- ss

  USE plasma_state_definition_mod
  IMPLICIT NONE

  INTEGER, INTENT(IN) :: cclist(ps_ccount)
                                ! list of components to merge
                                ! use ps_cc_all to merge all components

  TYPE (plasma_state) :: ss     ! state data to copy *from*
  TYPE (plasma_state) :: ss2    ! state data to copy *to*

  INTEGER, INTENT(IN) :: icopy_lists ! =1 to require copying of all lists

  INTEGER, INTENT(IN) :: iwant_1deq  ! =1 to request fcns of (rho_eq)
                                     !  even if cclist(ps_cnum_EQ).eq.0

  LOGICAL, INTENT(IN) :: partial_copy ! .TRUE. if full state copy not in effect

  INTEGER, INTENT(INOUT) :: ierr  ! completion flag (not cleared, set by error)

  !-------------------
  INTEGER :: iout
  !-------------------

  iout = SWIM_err_out_file


  !-----------------------------------------------
  ! copy scalars and arrays that are allocated...
  IF(partial_copy) THEN
     ss2%id_grho2b2i = 0
  ENDIF
  IF((ALLOCATED(ss%grho2b2i).AND.ALLOCATED(ss2%grho2b2i)).AND. &
        ((cclist(ps_cnum_EQ).EQ.1))) THEN
     ss2%grho2b2i = ss%grho2b2i
     IF(.not.partial_copy) THEN
        ss2%id_grho2b2i = ss%id_grho2b2i
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_grho2r2i = 0
  ENDIF
  IF((ALLOCATED(ss%grho2r2i).AND.ALLOCATED(ss2%grho2r2i)).AND. &
        ((cclist(ps_cnum_EQ).EQ.1))) THEN
     ss2%grho2r2i = ss%grho2r2i
     IF(.not.partial_copy) THEN
        ss2%id_grho2r2i = ss%id_grho2r2i
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_grho2r3i = 0
  ENDIF
  IF((ALLOCATED(ss%grho2r3i).AND.ALLOCATED(ss2%grho2r3i)).AND. &
        ((cclist(ps_cnum_EQ).EQ.1))) THEN
     ss2%grho2r3i = ss%grho2r3i
     IF(.not.partial_copy) THEN
        ss2%id_grho2r3i = ss%id_grho2r3i
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_gri = 0
  ENDIF
  IF((ALLOCATED(ss%gri).AND.ALLOCATED(ss2%gri)).AND. &
        ((cclist(ps_cnum_EQ).EQ.1))) THEN
     ss2%gri = ss%gri
     IF(.not.partial_copy) THEN
        ss2%id_gri = ss%id_gri
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_grirhoi = 0
  ENDIF
  IF((ALLOCATED(ss%grirhoi).AND.ALLOCATED(ss2%grirhoi)).AND. &
        ((cclist(ps_cnum_EQ).EQ.1))) THEN
     ss2%grirhoi = ss%grirhoi
     IF(.not.partial_copy) THEN
        ss2%id_grirhoi = ss%id_grirhoi
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_growthrate_drbm = 0
  ENDIF
  IF((ALLOCATED(ss%growthrate_drbm).AND.ALLOCATED(ss2%growthrate_drbm)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%growthrate_drbm = ss%growthrate_drbm
     IF(.not.partial_copy) THEN
        ss2%id_growthrate_drbm = ss%id_growthrate_drbm
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_growthrate_glf = 0
  ENDIF
  IF((ALLOCATED(ss%growthrate_glf).AND.ALLOCATED(ss2%growthrate_glf)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%growthrate_glf = ss%growthrate_glf
     IF(.not.partial_copy) THEN
        ss2%id_growthrate_glf = ss%id_growthrate_glf
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_growthrate_max_tglf = 0
  ENDIF
  IF((ALLOCATED(ss%growthrate_max_tglf).AND.ALLOCATED(ss2%growthrate_max_tglf)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%growthrate_max_tglf = ss%growthrate_max_tglf
     IF(.not.partial_copy) THEN
        ss2%id_growthrate_max_tglf = ss%id_growthrate_max_tglf
     ENDIF
  ENDIF
  IF(ALLOCATED(ss2%id_growthrate_mmm71)) THEN
     IF(partial_copy) THEN
        ss2%id_growthrate_mmm71 = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%growthrate_mmm71).AND.ALLOCATED(ss2%growthrate_mmm71)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%growthrate_mmm71 = ss%growthrate_mmm71
     IF(ALLOCATED(ss2%id_growthrate_mmm71)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_growthrate_mmm71 = ss%id_growthrate_mmm71
        ENDIF
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_growthrate_mtm = 0
  ENDIF
  IF((ALLOCATED(ss%growthrate_mtm).AND.ALLOCATED(ss2%growthrate_mtm)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%growthrate_mtm = ss%growthrate_mtm
     IF(.not.partial_copy) THEN
        ss2%id_growthrate_mtm = ss%id_growthrate_mtm
     ENDIF
  ENDIF
  IF(ALLOCATED(ss2%id_growthrate_tglf)) THEN
     IF(partial_copy) THEN
        ss2%id_growthrate_tglf = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%growthrate_tglf).AND.ALLOCATED(ss2%growthrate_tglf)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%growthrate_tglf = ss%growthrate_tglf
     IF(ALLOCATED(ss2%id_growthrate_tglf)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_growthrate_tglf = ss%id_growthrate_tglf
        ENDIF
     ENDIF
  ENDIF
  IF(ALLOCATED(ss2%id_growthrate_vpar)) THEN
     IF(partial_copy) THEN
        ss2%id_growthrate_vpar = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%growthrate_vpar).AND.ALLOCATED(ss2%growthrate_vpar)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%growthrate_vpar = ss%growthrate_vpar
     IF(ALLOCATED(ss2%id_growthrate_vpar)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_growthrate_vpar = ss%id_growthrate_vpar
        ENDIF
     ENDIF
  ENDIF
  IF( ((ALLOCATED(ss2%gs_name)).AND.(ALLOCATED(ss%gs_name))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_GAS).EQ.1)) ) THEN
     ss2%gs_name = ss%gs_name
  ENDIF
  IF(partial_copy) THEN
     ss2%id_g_eq = 0
  ENDIF
  IF((ALLOCATED(ss%g_eq).AND.ALLOCATED(ss2%g_eq)).AND. &
        ((cclist(ps_cnum_EQ).EQ.1).OR.(iwant_1deq.eq.1))) THEN
     ss2%g_eq = ss%g_eq
     IF(.not.partial_copy) THEN
        ss2%id_g_eq = ss%id_g_eq
     ENDIF
  ENDIF
  IF( ((ALLOCATED(ss2%hegrilh)).AND.(ALLOCATED(ss%hegrilh))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_LH).EQ.1)) ) THEN
     ss2%hegrilh = ss%hegrilh
  ENDIF
  IF( ((ALLOCATED(ss2%Hsize_coil)).AND.(ALLOCATED(ss%Hsize_coil))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_EQ).EQ.1)) ) THEN
     ss2%Hsize_coil = ss%Hsize_coil
  ENDIF
  IF( ((ALLOCATED(ss2%H_einj_standard)).AND.(ALLOCATED(ss%H_einj_standard))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_NBI).EQ.1)) ) THEN
     ss2%H_einj_standard = ss%H_einj_standard
  ENDIF
  IF( ((ALLOCATED(ss2%H_ffull_standard)).AND.(ALLOCATED(ss%H_ffull_standard))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_NBI).EQ.1)) ) THEN
     ss2%H_ffull_standard = ss%H_ffull_standard
  ENDIF
  IF( ((ALLOCATED(ss2%H_fhalf_standard)).AND.(ALLOCATED(ss%H_fhalf_standard))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_NBI).EQ.1)) ) THEN
     ss2%H_fhalf_standard = ss%H_fhalf_standard
  ENDIF
  IF( ((ALLOCATED(ss2%icircuit_coil)).AND.(ALLOCATED(ss%icircuit_coil))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_EQ).EQ.1)) ) THEN
     ss2%icircuit_coil = ss%icircuit_coil
  ENDIF
  IF( ((ALLOCATED(ss2%icrf_src_name)).AND.(ALLOCATED(ss%icrf_src_name))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_IC).EQ.1)) ) THEN
     ss2%icrf_src_name = ss%icrf_src_name
  ENDIF
  IF((cclist(ps_cnum_IC).EQ.1).OR.(icopy_lists.EQ.1)) THEN
     ss2%IC_Code_Info = ss%IC_Code_Info
  ENDIF
  IF((cclist(ps_cnum_IC).EQ.1).OR.(icopy_lists.EQ.1)) THEN
     ss2%IC_Data_Info = ss%IC_Data_Info
  ENDIF
  IF( ((ALLOCATED(ss2%Imag_ant_coef)).AND.(ALLOCATED(ss%Imag_ant_coef))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_IC).EQ.1)) ) THEN
     ss2%Imag_ant_coef = ss%Imag_ant_coef
  ENDIF
  IF(partial_copy) THEN
     ss2%id_iota = 0
  ENDIF
  IF((ALLOCATED(ss%iota).AND.ALLOCATED(ss2%iota)).AND. &
        ((cclist(ps_cnum_PLASMA).EQ.1))) THEN
     ss2%iota = ss%iota
     IF(.not.partial_copy) THEN
        ss2%id_iota = ss%id_iota
     ENDIF
  ENDIF
  IF( ((ALLOCATED(ss2%isThermal)).AND.(ALLOCATED(ss%isThermal))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_IC).EQ.1)) ) THEN
     ss2%isThermal = ss%isThermal
  ENDIF
  IF( ((ALLOCATED(ss2%is_recycling)).AND.(ALLOCATED(ss%is_recycling))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_GAS).EQ.1)) ) THEN
     ss2%is_recycling = ss%is_recycling
  ENDIF
  IF((cclist(ps_cnum_LH).EQ.1).OR.(icopy_lists.EQ.1)) THEN
     ss2%i_npoloidal = ss%i_npoloidal
  ENDIF
  IF(partial_copy) THEN
     ss2%id_jdotb = 0
  ENDIF
  IF((ALLOCATED(ss%jdotb).AND.ALLOCATED(ss2%jdotb)).AND. &
        ((cclist(ps_cnum_EQ).EQ.1).OR.(iwant_1deq.eq.1))) THEN
     ss2%jdotb = ss%jdotb
     IF(.not.partial_copy) THEN
        ss2%id_jdotb = ss%id_jdotb
     ENDIF
  ENDIF
  IF((cclist(ps_cnum_EQ).EQ.1).OR.(icopy_lists.EQ.1)) THEN
     ss2%kccw_Bphi = ss%kccw_Bphi
  ENDIF
  IF((cclist(ps_cnum_EQ).EQ.1).OR.(icopy_lists.EQ.1)) THEN
     ss2%kccw_Jphi = ss%kccw_Jphi
  ENDIF
  IF((cclist(ps_cnum_IC).EQ.1).OR.(icopy_lists.EQ.1)) THEN
     ss2%kdens_rfmin = ss%kdens_rfmin
  ENDIF
  IF( ((ALLOCATED(ss2%kvolt_nbi)).AND.(ALLOCATED(ss%kvolt_nbi))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_NBI).EQ.1)) ) THEN
     ss2%kvolt_nbi = ss%kvolt_nbi
  ENDIF
  IF(partial_copy) THEN
     ss2%id_kyrhos_mtm = 0
  ENDIF
  IF((ALLOCATED(ss%kyrhos_mtm).AND.ALLOCATED(ss2%kyrhos_mtm)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%kyrhos_mtm = ss%kyrhos_mtm
     IF(.not.partial_copy) THEN
        ss2%id_kyrhos_mtm = ss%id_kyrhos_mtm
     ENDIF
  ENDIF
  IF(ALLOCATED(ss2%id_kyspectrum_tglf)) THEN
     IF(partial_copy) THEN
        ss2%id_kyspectrum_tglf = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%kyspectrum_tglf).AND.ALLOCATED(ss2%kyspectrum_tglf)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%kyspectrum_tglf = ss%kyspectrum_tglf
     IF(ALLOCATED(ss2%id_kyspectrum_tglf)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_kyspectrum_tglf = ss%id_kyspectrum_tglf
        ENDIF
     ENDIF
  ENDIF
  IF( ((ALLOCATED(ss2%Lbscap)).AND.(ALLOCATED(ss%Lbscap))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_NBI).EQ.1)) ) THEN
     ss2%Lbscap = ss%Lbscap
  ENDIF
  IF( ((ALLOCATED(ss2%Lbscap2)).AND.(ALLOCATED(ss%Lbscap2))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_NBI).EQ.1)) ) THEN
     ss2%Lbscap2 = ss%Lbscap2
  ENDIF
  IF( ((ALLOCATED(ss2%Lbsctan)).AND.(ALLOCATED(ss%Lbsctan))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_NBI).EQ.1)) ) THEN
     ss2%Lbsctan = ss%Lbsctan
  ENDIF
  IF( ((ALLOCATED(ss2%lhrf_src_name)).AND.(ALLOCATED(ss%lhrf_src_name))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_LH).EQ.1)) ) THEN
     ss2%lhrf_src_name = ss%lhrf_src_name
  ENDIF
  IF((cclist(ps_cnum_LH).EQ.1).OR.(icopy_lists.EQ.1)) THEN
     ss2%LH_Code_Info = ss%LH_Code_Info
  ENDIF
  IF((cclist(ps_cnum_LH).EQ.1).OR.(icopy_lists.EQ.1)) THEN
     ss2%LH_Data_Info = ss%LH_Data_Info
  ENDIF
  IF((cclist(ps_cnum_LMHD).EQ.1).OR.(icopy_lists.EQ.1)) THEN
     ss2%LMHD_eq_code = ss%LMHD_eq_code
  ENDIF
  IF((cclist(ps_cnum_LMHD).EQ.1).OR.(icopy_lists.EQ.1)) THEN
     ss2%LMHD_status = ss%LMHD_status
  ENDIF
  IF((cclist(ps_cnum_PLASMA).EQ.1).OR.(icopy_lists.EQ.1)) THEN
     ss2%lock_machine_descr = ss%lock_machine_descr
  ENDIF
  IF((cclist(ps_cnum_PLASMA).EQ.1).OR.(icopy_lists.EQ.1)) THEN
     ss2%lock_shot_config = ss%lock_shot_config
  ENDIF
  IF((cclist(ps_cnum_PLASMA).EQ.1).OR.(icopy_lists.EQ.1)) THEN
     ss2%lock_sim_init = ss%lock_sim_init
  ENDIF
  IF(partial_copy) THEN
     ss2%id_Lpol = 0
  ENDIF
  IF((ALLOCATED(ss%Lpol).AND.ALLOCATED(ss2%Lpol)).AND. &
        ((cclist(ps_cnum_EQ).EQ.1).OR.(iwant_1deq.eq.1))) THEN
     ss2%Lpol = ss%Lpol
     IF(.not.partial_copy) THEN
        ss2%id_Lpol = ss%id_Lpol
     ENDIF
  ENDIF
  IF( ((ALLOCATED(ss2%Mercier_stable)).AND.(ALLOCATED(ss%Mercier_stable))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_LMHD).EQ.1)) ) THEN
     ss2%Mercier_stable = ss%Mercier_stable
  ENDIF
  IF((cclist(ps_cnum_LMHD).EQ.1).OR.(icopy_lists.EQ.1)) THEN
     ss2%MHD_eq_status = ss%MHD_eq_status
  ENDIF
  IF((ALLOCATED(ss2%m_ALL)).AND.(ALLOCATED(ss%m_ALL))) THEN
     ss2%m_ALL = ss%m_ALL
  ENDIF
  IF((ALLOCATED(ss2%m_ALLA)).AND.(ALLOCATED(ss%m_ALLA))) THEN
     ss2%m_ALLA = ss%m_ALLA
  ENDIF
  IF((ALLOCATED(ss2%m_RFMIN)).AND.(ALLOCATED(ss%m_RFMIN))) THEN
     ss2%m_RFMIN = ss%m_RFMIN
  ENDIF
  IF((ALLOCATED(ss2%m_S)).AND.(ALLOCATED(ss%m_S))) THEN
     ss2%m_S = ss%m_S
  ENDIF
  IF((ALLOCATED(ss2%m_SA)).AND.(ALLOCATED(ss%m_SA))) THEN
     ss2%m_SA = ss%m_SA
  ENDIF
  IF((ALLOCATED(ss2%m_SFUS)).AND.(ALLOCATED(ss%m_SFUS))) THEN
     ss2%m_SFUS = ss%m_SFUS
  ENDIF
  IF((ALLOCATED(ss2%m_SGAS)).AND.(ALLOCATED(ss%m_SGAS))) THEN
     ss2%m_SGAS = ss%m_SGAS
  ENDIF
  IF((ALLOCATED(ss2%m_SIMP0)).AND.(ALLOCATED(ss%m_SIMP0))) THEN
     ss2%m_SIMP0 = ss%m_SIMP0
  ENDIF
  IF((ALLOCATED(ss2%m_SIMPI)).AND.(ALLOCATED(ss%m_SIMPI))) THEN
     ss2%m_SIMPI = ss%m_SIMPI
  ENDIF
  IF((ALLOCATED(ss2%m_SNBI)).AND.(ALLOCATED(ss%m_SNBI))) THEN
     ss2%m_SNBI = ss%m_SNBI
  ENDIF
  IF(ALLOCATED(ss2%id_n0norm)) THEN
     IF(partial_copy) THEN
        ss2%id_n0norm = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%n0norm).AND.ALLOCATED(ss2%n0norm)).AND. &
        ((cclist(ps_cnum_GAS).EQ.1))) THEN
     ss2%n0norm = ss%n0norm
     IF(ALLOCATED(ss2%id_n0norm)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_n0norm = ss%id_n0norm
        ENDIF
     ENDIF
  ENDIF
  IF(ALLOCATED(ss2%id_n0_halo)) THEN
     IF(partial_copy) THEN
        ss2%id_n0_halo = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%n0_halo).AND.ALLOCATED(ss2%n0_halo)).AND. &
        ((cclist(ps_cnum_NBI).EQ.1))) THEN
     ss2%n0_halo = ss%n0_halo
     IF(ALLOCATED(ss2%id_n0_halo)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_n0_halo = ss%id_n0_halo
        ENDIF
     ENDIF
  ENDIF
  IF(ALLOCATED(ss2%id_n0_reco)) THEN
     IF(partial_copy) THEN
        ss2%id_n0_reco = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%n0_reco).AND.ALLOCATED(ss2%n0_reco)).AND. &
        ((cclist(ps_cnum_GAS).EQ.1))) THEN
     ss2%n0_reco = ss%n0_reco
     IF(ALLOCATED(ss2%id_n0_reco)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_n0_reco = ss%id_n0_reco
        ENDIF
     ENDIF
  ENDIF
  IF( ((ALLOCATED(ss2%nbap2_shape)).AND.(ALLOCATED(ss%nbap2_shape))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_NBI).EQ.1)) ) THEN
     ss2%nbap2_shape = ss%nbap2_shape
  ENDIF
  IF( ((ALLOCATED(ss2%nbap_shape)).AND.(ALLOCATED(ss%nbap_shape))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_NBI).EQ.1)) ) THEN
     ss2%nbap_shape = ss%nbap_shape
  ENDIF
  IF(ALLOCATED(ss2%id_nbeami)) THEN
     IF(partial_copy) THEN
        ss2%id_nbeami = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%nbeami).AND.ALLOCATED(ss2%nbeami)).AND. &
        ((cclist(ps_cnum_NBI).EQ.1))) THEN
     ss2%nbeami = ss%nbeami
     IF(ALLOCATED(ss2%id_nbeami)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_nbeami = ss%id_nbeami
        ENDIF
     ENDIF
  ENDIF
  IF( ((ALLOCATED(ss2%nbeami_bdy)).AND.(ALLOCATED(ss%nbeami_bdy))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_NBI).EQ.1)) ) THEN
     ss2%nbeami_bdy = ss%nbeami_bdy
  ENDIF
  IF( ((ALLOCATED(ss2%nbion)).AND.(ALLOCATED(ss%nbion))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_NBI).EQ.1)) ) THEN
     ss2%nbion = ss%nbion
  ENDIF
  IF( ((ALLOCATED(ss2%nbion_trace)).AND.(ALLOCATED(ss%nbion_trace))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_NBI).EQ.1)) ) THEN
     ss2%nbion_trace = ss%nbion_trace
  ENDIF
  IF((cclist(ps_cnum_NBI).EQ.1).OR.(icopy_lists.EQ.1)) THEN
     ss2%NBI_Code_Info = ss%NBI_Code_Info
  ENDIF

END SUBROUTINE plasma_state_copy_3

subroutine ur_cstate_contents

  !  generate tables of contents of various categories of items stored
  !  in plasma states

  use cstate_lib_mod
  implicit NONE

  !-------------------------
  ! local

  integer :: luntty,lnout
  logical :: lxout,lchar,lyes
  character*32 :: subsect

  !-------------------------

  luntty = lnout(0)

  do
     if(lxout(0)) then
        write(luntty,1001) omit_empty,trim(cur_components)
1001    format(' tables of contents (select 1):'/ &
             ' A -- option to omit empty elements from display (',L1,')'/ &
             ' C -- reselect component(s) (current setting: ',a,')'// &
             ' G -- grids'/ &
             ' S -- species lists'/ &
             ' I -- item lists'// &
             ' D -- state data, machine description, etc. (show units & dimensions)'/ &
             ' E -- state data, machine description, etc. (show descriptions)'// &
             ' N -- state profiles (show units & dimensions)'/ &
             ' O -- state profiles (show units & interpolation method)'/ &
             ' P -- state profiles (show descriptions)'// &
             ' Q -- quit this menu'/)
     endif

     call uread('ur_cstate_contents option:')

     if(lchar('Q')) then
        exit
        
     else if(lchar('A')) then
        if(lxout(0)) write(luntty,*) &
             ' option to omit display of elements that are empty in all states.'

        call uread('omit empty elements ? (Y/N):')
        omit_empty = lyes(0)

     else if(lchar('C')) then
        call ur_cstate_component

     else if(lchar('G')) then
        call ur_cstate_grid_contents

     else if(lchar('S')) then
        call ur_cstate_slist_contents(1)

     else if(lchar('I')) then
        call ur_cstate_ilist_contents(1)

     else if(lchar('D')) then
        call subselect
        if(subsect.eq.'Q') cycle
        call ur_cstate_sdata_contents(1,subsect)

     else if(lchar('E')) then
        call subselect
        if(subsect.eq.'Q') cycle
        call ur_cstate_sdata_contents(2,subsect)

     else if(lchar('N')) then
        call ur_cstate_sprof_contents(1)

     else if(lchar('O')) then
        call ur_cstate_sprof_contents(2)

     else if(lchar('P')) then
        call ur_cstate_sprof_contents(3)

     else 
        call uermsg(' ?ur_cstate_contents: unknown option.',' ',0)
     endif
  enddo

  contains
    subroutine subselect

      do
         if(lxout(0)) then
            write(luntty,1002)

1002        format(/ &
                 '  M -- view/compare MACHINE DESCRIPTION other than item lists'/ &
                 '  F -- view/compare SHOT CONFIGURATION other than species lists'/ &
                 '  N -- view/compare SIMULATION INITIALIZATION data other than grids'/ &
                 '  D -- view/compare STATE DATA'/ &
                 '  Q -- quit (skip display)')
         endif
         
         call uread('ur_cstate_contents_subselect: option selection:')

         if(lchar('Q')) then
            subsect='Q'

         else if(lchar('M')) then
            subsect='MACHINE_DESCRIPTION'

         else if(lchar('F')) then
            subsect='SHOT_CONFIGURATION'

         else if(lchar('N')) then
            subsect='SIMULATION_INIT'

         else if(lchar('D')) then
            subsect='STATE_DATA'

         else
            call uermsg('?ur_cstate_contents_subselect: unrecognized option', &
                 ' ',0)
            cycle
         endif

         exit
      enddo
    end subroutine subselect

end subroutine ur_cstate_contents

subroutine ur_cstate_grid_contents

  ! grids contained in the state(s)

  use cstate_lib_mod
  implicit NONE

  !-------------------------
  ! local

  integer :: luntty,lnout
  logical :: lxout,lchar
  integer :: i,ierr,ilen_names,ilen_vals,ilen_256,ilen_units,ilen_descr
  integer :: ilen_compo,inum_empty,ic
  character*32 :: zelem
  !-------------------------

  luntty = lnout(0)
  call psw_contents('G',ncur_components,wgrid,ierr, state=sss(1))
  call cstate_wlen(wgrid,ilen_names,ilen_compo, &
       ilen_vals,ilen_256,ilen_units,ilen_descr)

  ilen_vals = max(9,ilen_vals)
  ilen_names = ilen_names + 1   ! create an extra vertical space

2000 format(/ &
          ' no grids in selected component(s).'/)

2001 format(a,1x,a,1x,a,1x,a)

  if(wgrid%size.eq.0) then
     write(luntty,2000)
  else
     c2lab='Component'
     c3lab='Dimension'
     write(luntty,*) ' '
     write(luntty,2001) wgrid%list_name(1:ilen_names), &
          c2lab(1:ilen_compo),c3lab(1:ilen_vals),'Description'
     write(luntty,2001) rline(1:ilen_names), &
          rline(1:ilen_compo),rline(1:ilen_vals),rline(1:min(50,ilen_descr))
     do i=1,wgrid%size
        call cstate_ck_empty(wgrid%val_field(i),is_empty)
        zelem=wgrid%list_elems(i)
        if(is_empty) then
           if(omit_empty) cycle
           inum_empty=inum_empty+1
           ic=min(len(zelem),len(trim(zelem))+1)
           zelem(ic:ic)='*'
        endif
        write(luntty,2001) zelem(1:ilen_names), &
             wgrid%component(i)(1:ilen_compo), &
             wgrid%val_field(i)(1:ilen_vals), &
             trim(wgrid%elem_descr(i))
     enddo
     write(luntty,*) ' '
  endif
  if(inum_empty.gt.0) then
     write(luntty,*) '   [*]: empty in all states.'
     write(luntty,*) ' '
  endif

end subroutine ur_cstate_grid_contents

subroutine ur_cstate_slist_contents(icall)

  ! species lists contained in the state(s)

  use cstate_lib_mod
  implicit NONE

  integer, intent(in) :: icall  ! =1 for dimension & description;
  !          =2 for component & description; other values: put contents
  !          data in w1 but do not print anything

  !-------------------------
  ! local

  integer :: luntty,lnout
  logical :: lxout,lchar
  integer :: i,ierr,ilen_names,ilen_vals,ilen_256,ilen_units,ilen_descr
  integer :: ilen_compo,inum_empty,ic
  character*32 :: zelem
  !-------------------------

  luntty = lnout(0)
  call psw_contents('S',ncur_components,w1,ierr, state=sss(1))
  call cstate_wlen(w1,ilen_names,ilen_compo, &
       ilen_vals,ilen_256,ilen_units,ilen_descr)

  ilen_vals = max(9,ilen_vals)
  ilen_names = ilen_names + 1   ! create an extra vertical space

2000 format(/ &
          ' no species lists in selected component(s).'/)

2001 format(a,1x,a,1x,a)

  inum_empty = 0
  if(w1%size.eq.0) then
     write(luntty,2000)

  else if(icall.eq.1) then
     c2lab='Dimension'
     write(luntty,*) ' '
     write(luntty,2001) w1%list_name(1:ilen_names),c2lab(1:ilen_vals),'Description'
     write(luntty,2001) rline(1:ilen_names),rline(1:ilen_vals),rline(1:min(50,ilen_descr))
     do i=1,w1%size
        call cstate_ck_empty(w1%val_field(i),is_empty)
        zelem=w1%list_elems(i)
        if(is_empty) then
           if(omit_empty) cycle
           inum_empty=inum_empty+1
           ic=min(len(zelem),len(trim(zelem))+1)
           zelem(ic:ic)='*'
        endif
        write(luntty,2001) zelem(1:ilen_names), &
             w1%val_field(i)(1:ilen_vals),trim(w1%elem_descr(i))
     enddo
     write(luntty,*) ' '

  else if(icall.eq.2) then
     c2lab='Component'
     write(luntty,*) ' '
     write(luntty,2001) w1%list_name(1:ilen_names),c2lab(1:ilen_compo),'Description'
     write(luntty,2001) rline(1:ilen_names),rline(1:ilen_compo),rline(1:min(50,ilen_descr))
     do i=1,w1%size
        call cstate_ck_empty(w1%val_field(i),is_empty)
        zelem=w1%list_elems(i)
        if(is_empty) then
           if(omit_empty) cycle
           inum_empty=inum_empty+1
           ic=min(len(zelem),len(trim(zelem))+1)
           zelem(ic:ic)='*'
        endif
        write(luntty,2001) zelem(1:ilen_names), &
             w1%component(i)(1:ilen_compo),trim(w1%elem_descr(i))
     enddo
     write(luntty,*) ' '

  endif
  if(inum_empty.gt.0) then
     write(luntty,*) '   [*]: empty in all states.'
     write(luntty,*) ' '
  endif

end subroutine ur_cstate_slist_contents

subroutine ur_cstate_ilist_contents(icall)

  ! item lists contained in the state(s)

  use cstate_lib_mod
  implicit NONE

  integer, intent(in) :: icall  ! =1 for dimension & description;
  !          =2 for component & description; other values: put contents
  !          data in w1 but do not print anything
  !-------------------------
  ! local

  integer :: luntty,lnout
  logical :: lxout,lchar
  integer :: i,ierr,ilen_names,ilen_vals,ilen_256,ilen_units,ilen_descr
  integer :: ilen_compo,inum_empty,ic
  character*32 :: zelem
  !-------------------------

  luntty = lnout(0)
  call psw_contents('L',ncur_components,w1,ierr, state=sss(1))
  call cstate_wlen(w1,ilen_names,ilen_compo, &
       ilen_vals,ilen_256,ilen_units,ilen_descr)

  ilen_vals = max(9,ilen_vals)
  ilen_names = ilen_names + 1   ! create an extra vertical space

2000 format(/ &
          ' no item lists in selected component(s).'/)

2001 format(a,1x,a,1x,a)

  inum_empty = 0
  if(w1%size.eq.0) then
     write(luntty,2000)

  else if(icall.eq.1) then
     c2lab='Dimension'
     write(luntty,*) ' '
     write(luntty,2001) w1%list_name(1:ilen_names),c2lab(1:ilen_vals),'Description'
     write(luntty,2001) rline(1:ilen_names),rline(1:ilen_vals),rline(1:min(50,ilen_descr))
     do i=1,w1%size
        call cstate_ck_empty(w1%val_field(i),is_empty)
        zelem=w1%list_elems(i)
        if(is_empty) then
           if(omit_empty) cycle
           inum_empty=inum_empty+1
           ic=min(len(zelem),len(trim(zelem))+1)
           zelem(ic:ic)='*'
        endif
        write(luntty,2001) zelem(1:ilen_names), &
             w1%val_field(i)(1:ilen_vals),trim(w1%elem_descr(i))
     enddo
     write(luntty,*) ' '

  else if(icall.eq.2) then
     c2lab='Component'
     write(luntty,*) ' '
     write(luntty,2001) w1%list_name(1:ilen_names),c2lab(1:ilen_compo),'Description'
     write(luntty,2001) rline(1:ilen_names),rline(1:ilen_compo),rline(1:min(50,ilen_descr))
     do i=1,w1%size
        call cstate_ck_empty(w1%val_field(i),is_empty)
        zelem=w1%list_elems(i)
        if(is_empty) then
           if(omit_empty) cycle
           inum_empty=inum_empty+1
           ic=min(len(zelem),len(trim(zelem))+1)
           zelem(ic:ic)='*'
        endif
        write(luntty,2001) zelem(1:ilen_names), &
             w1%component(i)(1:ilen_compo),trim(w1%elem_descr(i))
     enddo
     write(luntty,*) ' '

  endif
  if(inum_empty.gt.0) then
     write(luntty,*) '   [*]: empty in all states.'
     write(luntty,*) ' '
  endif

end subroutine ur_cstate_ilist_contents

subroutine ur_cstate_sdata_contents(icall,subsect)

  ! non-profile data contained in the state(s)

  use cstate_lib_mod
  implicit NONE

  integer, intent(in) :: icall  ! =1 for units & dimensions; =2 for description
  !  other values: put contents in w1 but do not print anything.

  character*(*), intent(in) :: subsect

  !-------------------------
  ! local

  integer :: luntty,lnout
  logical :: lxout,lchar

  integer :: ierr,ilen_names,ilen_vals,ilen_256,ilen_units,ilen_descr,i,isize
  integer :: ilen_compo,inum_empty,ic
  character*32 :: zelem
  character*1 :: dcod
  logical, dimension(:), allocatable :: is_blank
  integer :: bcount
  !-------------------------

  luntty = lnout(0)

  if(subsect.eq.'MACHINE_DESCRIPTION') then
     dcod='M'
  else if(subsect.eq.'SHOT_CONFIGURATION') then
     dcod='C'
  else if(subsect.eq.'SIMULATION_INIT') then
     dcod='N'
  else
     dcod='D'
  endif

  call psw_contents(dcod,ncur_components,w1,ierr, state=sss(1))
  call cstate_wlen(w1,ilen_names,ilen_compo, &
       ilen_vals,ilen_256,ilen_units,ilen_descr)
  ilen_names = ilen_names + 2   ! create two extra vertical spaces

  ilen_256=max(10,ilen_256)
  ilen_units=max(5,ilen_units)
  ilen_descr=max(23,ilen_descr)

2000 format(/ &
          ' no state data items in selected component(s).'/)

2002 format(a,1x,a)
2003 format(a,1x,a,1x,a)
2004 format(a,1x,a,1x,a,1x,a)

  bcount = 0
  inum_empty = 0

  isize=w1%size
  if(isize.eq.0) then
     write(luntty,2000)
  else
     allocate(is_blank(isize)); is_blank = .FALSE.
     call ur_cstate_blanks(dcod,isize,is_blank)
     if(icall.eq.1) then
        c2lab='Component'
        c3lab='Units'
        write(luntty,*) ' '
        write(luntty,2004) w1%list_name(1:ilen_names), &
             c2lab(1:ilen_compo),c3lab(1:ilen_units),'Dimensions'
        write(luntty,2004) rline(1:ilen_names),&
             rline(1:ilen_compo),rline(1:ilen_units),rline(1:min(35,ilen_256))
        do i=1,isize
           call cstate_ck_empty(w1%c256val(i),is_empty)
           zelem=w1%list_elems(i)
           if(is_empty) then
              if(omit_empty) cycle
              inum_empty=inum_empty+1
              ic=len(zelem)-1
              zelem = '*'//zelem(1:ic)
           else if(is_blank(i)) then
              ic=len(zelem)-2
              zelem = '**'//zelem(1:ic)
              bcount = bcount + 1
           endif
           write(luntty,2004) zelem(1:ilen_names), &
                w1%component(i)(1:ilen_compo),w1%elem_units(i)(1:ilen_units), &
                trim(w1%c256val(i))
        enddo
        write(luntty,*) ' '
     else if(icall.eq.2) then
        write(luntty,*) ' '
        write(luntty,2002) w1%list_name(1:ilen_names),'Description or Contents'
        write(luntty,2002) rline(1:ilen_names),rline(1:min(50,ilen_descr))
        do i=1,isize
           call cstate_ck_empty(w1%c256val(i),is_empty)
           zelem=w1%list_elems(i)
           if(is_empty) then
              if(omit_empty) cycle
              inum_empty=inum_empty+1
              ic=len(zelem)-1
              zelem = '*'//zelem(1:ic)
           else if(is_blank(i)) then
              ic=len(zelem)-2
              zelem = '**'//zelem(1:ic)
              bcount = bcount + 1
           endif
           write(luntty,2002) zelem(1:ilen_names), &
                trim(w1%elem_descr(i))
        enddo
        write(luntty,*) ' '
     endif
     deallocate(is_blank)
  endif
  if(inum_empty.gt.0) write(luntty,*) '   [*]: empty in all states.'
  if(bcount.gt.0) write(luntty,*) '   [**]: zero, blank, uninitialized or empty in all states.'
  if(max(bcount,inum_empty).gt.0) write(luntty,*) ' '

end subroutine ur_cstate_sdata_contents

subroutine ur_cstate_sprof_contents(icall)

  ! profile data contained in the state(s)

  use cstate_lib_mod
  implicit NONE

  integer, intent(in) :: icall  ! =1 for units & dimensions;
  !                       =2 for units & interpolation method;
  !                       =3 for descriptions
  !  other values: put contents in w1 but do not print anything.

  !-------------------------
  ! local

  integer :: luntty,lnout
  logical :: lxout,lchar

  integer :: ierr,ilen_names,ilen_vals,ilen_256,ilen_units,ilen_descr,i,isize
  integer :: ilen_compo,inum_empty,ic
  character*32 :: zelem
  logical, dimension(:), allocatable :: is_blank
  integer :: bcount
  !-------------------------

  luntty = lnout(0)
  call psw_contents('P',ncur_components,w1,ierr, state=sss(1))
  call cstate_wlen(w1,ilen_names,ilen_compo, &
       ilen_vals,ilen_256,ilen_units,ilen_descr)

  ilen_256=max(10,ilen_256)
  ilen_units=max(5,ilen_units)
  ilen_vals=max(20,ilen_vals)
  ilen_descr=max(23,ilen_descr)
  ilen_names = ilen_names + 2   ! create two extra vertical spaces

2000 format(/ &
          ' no profiles in selected component(s).'/)

2002 format(a,1x,a)
2003 format(a,1x,a,1x,a)
2004 format(a,1x,a,1x,a,1x,a)

  inum_empty = 0
  bcount = 0

  isize = w1%size
  if(isize.eq.0) then
     write(luntty,2000)
  else
     allocate(is_blank(isize)); is_blank = .FALSE.
     call ur_cstate_blanks('P',isize,is_blank)
     if(icall.eq.1) then
        c2lab='Units'
        write(luntty,*) ' '
        write(luntty,2003) w1%list_name(1:ilen_names),c2lab(1:ilen_units),'Dimensions'
        write(luntty,2003) rline(1:ilen_names),rline(1:ilen_units),rline(1:min(40,ilen_256))
        do i=1,isize
           call cstate_ck_empty(w1%c256val(i),is_empty)
           zelem=w1%list_elems(i)
           if(is_empty) then
              if(omit_empty) cycle
              inum_empty=inum_empty+1
              ic=len(zelem)-1
              zelem = '*'//zelem(1:ic)
           else if(is_blank(i)) then
              ic=len(zelem)-2
              zelem = '**'//zelem(1:ic)
              bcount = bcount + 1
           endif
           write(luntty,2003) zelem(1:ilen_names), &
                w1%elem_units(i)(1:ilen_units),trim(w1%c256val(i))
        enddo
        write(luntty,*) ' '

     else if(icall.eq.2) then
        c2lab='Component'
        c3lab='Units'
        write(luntty,*) ' '
        write(luntty,2004) w1%list_name(1:ilen_names), &
             c2lab(1:ilen_compo),c3lab(1:ilen_units),'Interpolation method'
        write(luntty,2004) rline(1:ilen_names), &
             rline(1:ilen_compo),rline(1:ilen_units),rline(1:min(35,ilen_vals))
        do i=1,isize
           call cstate_ck_empty(w1%c256val(i),is_empty)
           zelem=w1%list_elems(i)
           if(is_empty) then
              if(omit_empty) cycle
              inum_empty=inum_empty+1
              ic=len(zelem)-1
              zelem = '*'//zelem(1:ic)
           else if(is_blank(i)) then
              ic=len(zelem)-2
              zelem = '**'//zelem(1:ic)
              bcount = bcount + 1
           endif
           write(luntty,2004) zelem(1:ilen_names), &
                w1%component(i)(1:ilen_compo),w1%elem_units(i)(1:ilen_units), &
                trim(w1%val_field(i))
        enddo
        write(luntty,*) ' '

     else if(icall.eq.3) then
        write(luntty,*) ' '
        write(luntty,2002) w1%list_name(1:ilen_names),'Description or Contents'
        write(luntty,2002) rline(1:ilen_names),rline(1:min(50,ilen_descr))
        do i=1,isize
           call cstate_ck_empty(w1%c256val(i),is_empty)
           zelem=w1%list_elems(i)
           if(is_empty) then
              if(omit_empty) cycle
              inum_empty=inum_empty+1
              ic=len(zelem)-1
              zelem = '*'//zelem(1:ic)
           else if(is_blank(i)) then
              ic=len(zelem)-2
              zelem = '**'//zelem(1:ic)
              bcount = bcount + 1
           endif
           write(luntty,2002) zelem(1:ilen_names), &
                trim(w1%elem_descr(i))
        enddo
        write(luntty,*) ' '
     endif
     deallocate(is_blank)
  endif
  if(inum_empty.gt.0) write(luntty,*) '   [*]: empty in all states.'
  if(bcount.gt.0) write(luntty,*) '   [**]: zero, blank, uninitialized or empty in all states.'
  if(max(bcount,inum_empty).gt.0) write(luntty,*) ' '

end subroutine ur_cstate_sprof_contents

subroutine ur_cstate_blanks(dcod,isize,is_blank)

  ! identify data elements that are blank, zero, or empty/unallocated for
  ! all states on the list;  the 1st state contents information is already
  ! loaded in w1.

  use cstate_lib_mod
  implicit NONE

  !--------------------------------------------
  ! passed:
  character*1 :: dcod    ! data type code
  integer :: isize       ! size of logical array
  logical :: is_blank(isize)

  !--------------------------------------------
  ! local:

  integer :: i,ii,ierr
  !--------------------------------------------

  do i=1,isize
     is_blank(i) = w1%ival(i).le.0
  enddo

  do ii=2,nsss_cur
     call psw_contents(dcod,ncur_components,wtmp,ierr, state=sss(ii))
     do i=1,isize
        if(is_blank(i)) then
           is_blank(i) = wtmp%ival(i).le.0
        endif
     enddo
  enddo

end subroutine ur_cstate_blanks

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)

SUBROUTINE plasma_state_contents_sconfig(itype,icomponent,ss,w,isize)


  ! fill window structure with requested table of contents

  USE plasma_state_mod
  IMPLICIT NONE

  INTEGER, INTENT(IN) :: itype   ! type of table of contents
                                 ! values such as ps_grid_dims or ps_profiles

  INTEGER, INTENT(IN) :: icomponent(ps_ccount) ! component flags
             ! icomponent(j).eq.1 => component j active
             ! e.g. icomponent(ps_cnum_EQ).eq.1 => EQ component is active

  TYPE (plasma_state) :: ss      ! state examined
  TYPE (ps_list_window) :: w     ! list window structure filled

  INTEGER, INTENT(INOUT) :: isize  ! incremented size...

  !local:

  INTEGER :: id,inum
  INTEGER :: i1,i2,i3,i4

  !----------------

  IF(icomponent(ps_cnum_LH).EQ.1) THEN
     IF(itype.EQ.ps_shot_config) THEN
        isize = isize + 1  ! amaxlh
        w%list_elems(isize) = "amaxlh"
        w%elem_descr(isize) = "width of the spectrum peak"
        w%component(isize) = "LH"
        w%elem_units(isize) = "-"
        w%c256val(isize) = "(max_nspectrumlh_src,nlhrf_src)"
        IF(ALLOCATED(ss%amaxlh)) THEN
           IF(MAXVAL(ABS(ss%amaxlh)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LH).EQ.1) THEN
     IF(itype.EQ.ps_shot_config) THEN
        isize = isize + 1  ! aminlh
        w%list_elems(isize) = "aminlh"
        w%elem_descr(isize) = "parallel mode number, center of the spectrum peak"
        w%component(isize) = "LH"
        w%elem_units(isize) = "-"
        w%c256val(isize) = "(max_nspectrumlh_src,nlhrf_src)"
        IF(ALLOCATED(ss%aminlh)) THEN
           IF(MAXVAL(ABS(ss%aminlh)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LH).EQ.1) THEN
     IF(itype.EQ.ps_shot_config) THEN
        isize = isize + 1  ! apolmaxlh
        w%list_elems(isize) = "apolmaxlh"
        w%elem_descr(isize) = "poloidal mode number right of lumps"
        w%component(isize) = "LH"
        w%elem_units(isize) = "-"
        w%c256val(isize) = "(max_nspectrumlh_src,nlhrf_src)"
        IF(ALLOCATED(ss%apolmaxlh)) THEN
           IF(MAXVAL(ABS(ss%apolmaxlh)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LH).EQ.1) THEN
     IF(itype.EQ.ps_shot_config) THEN
        isize = isize + 1  ! apolminlh
        w%list_elems(isize) = "apolminlh"
        w%elem_descr(isize) = "poloidal mode number left of lumps"
        w%component(isize) = "LH"
        w%elem_units(isize) = "-"
        w%c256val(isize) = "(max_nspectrumlh_src,nlhrf_src)"
        IF(ALLOCATED(ss%apolminlh)) THEN
           IF(MAXVAL(ABS(ss%apolminlh)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LH).EQ.1) THEN
     IF(itype.EQ.ps_shot_config) THEN
        isize = isize + 1  ! atormaxlh
        w%list_elems(isize) = "atormaxlh"
        w%elem_descr(isize) = "toroidal mode number right of lumps"
        w%component(isize) = "LH"
        w%elem_units(isize) = "-"
        w%c256val(isize) = "(max_nspectrumlh_src,nlhrf_src)"
        IF(ALLOCATED(ss%atormaxlh)) THEN
           IF(MAXVAL(ABS(ss%atormaxlh)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LH).EQ.1) THEN
     IF(itype.EQ.ps_shot_config) THEN
        isize = isize + 1  ! atorminlh
        w%list_elems(isize) = "atorminlh"
        w%elem_descr(isize) = "toroidal mode number left of lumps"
        w%component(isize) = "LH"
        w%elem_units(isize) = "-"
        w%c256val(isize) = "(max_nspectrumlh_src,nlhrf_src)"
        IF(ALLOCATED(ss%atorminlh)) THEN
           IF(MAXVAL(ABS(ss%atorminlh)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EC).EQ.1) THEN
     IF(itype.EQ.ps_shot_config) THEN
        isize = isize + 1  ! EC_Omode_Fraction
        w%list_elems(isize) = "EC_Omode_Fraction"
        w%elem_descr(isize) = "O-mode fraction of EC source"
        w%component(isize) = "EC"
        w%elem_units(isize) = "-"
        w%c256val(isize) = "(necrf_src)"
        IF(ALLOCATED(ss%EC_Omode_Fraction)) THEN
           IF(MAXVAL(ABS(ss%EC_Omode_Fraction)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EC).EQ.1) THEN
     IF(itype.EQ.ps_shot_config) THEN
        isize = isize + 1  ! EC_phi_aim
        w%list_elems(isize) = "EC_phi_aim"
        w%elem_descr(isize) = "toroidal aiming angle"
        w%component(isize) = "EC"
        w%elem_units(isize) = "degrees"
        w%c256val(isize) = "(necrf_src)"
        IF(ALLOCATED(ss%EC_phi_aim)) THEN
           IF(MAXVAL(ABS(ss%EC_phi_aim)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EC).EQ.1) THEN
     IF(itype.EQ.ps_shot_config) THEN
        isize = isize + 1  ! EC_theta_aim
        w%list_elems(isize) = "EC_theta_aim"
        w%elem_descr(isize) = "poloidal aiming angle"
        w%component(isize) = "EC"
        w%elem_units(isize) = "degrees"
        w%c256val(isize) = "(necrf_src)"
        IF(ALLOCATED(ss%EC_theta_aim)) THEN
           IF(MAXVAL(ABS(ss%EC_theta_aim)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LH).EQ.1) THEN
     IF(itype.EQ.ps_shot_config) THEN
        isize = isize + 1  ! fracpslh
        w%list_elems(isize) = "fracpslh"
        w%elem_descr(isize) = "fraction of power on each peak (the sum over all peaks must be 1)"
        w%component(isize) = "LH"
        w%elem_units(isize) = "-"
        w%c256val(isize) = "(max_nspectrumlh_src,nlhrf_src)"
        IF(ALLOCATED(ss%fracpslh)) THEN
           IF(MAXVAL(ABS(ss%fracpslh)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EC).EQ.1) THEN
     IF(itype.EQ.ps_shot_config) THEN
        isize = isize + 1  ! freq_ec
        w%list_elems(isize) = "freq_ec"
        w%elem_descr(isize) = "frequency of EC source"
        w%component(isize) = "EC"
        w%elem_units(isize) = "Hz"
        w%c256val(isize) = "(necrf_src)"
        IF(ALLOCATED(ss%freq_ec)) THEN
           IF(MAXVAL(ABS(ss%freq_ec)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_shot_config) THEN
        isize = isize + 1  ! freq_ic
        w%list_elems(isize) = "freq_ic"
        w%elem_descr(isize) = "frequency on each ICRF source"
        w%component(isize) = "IC"
        w%elem_units(isize) = "Hz"
        w%c256val(isize) = "(nicrf_src)"
        IF(ALLOCATED(ss%freq_ic)) THEN
           IF(MAXVAL(ABS(ss%freq_ic)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LH).EQ.1) THEN
     IF(itype.EQ.ps_shot_config) THEN
        isize = isize + 1  ! freq_lh
        w%list_elems(isize) = "freq_lh"
        w%elem_descr(isize) = "frequency on each LHRF source"
        w%component(isize) = "LH"
        w%elem_units(isize) = "Hz"
        w%c256val(isize) = "(nlhrf_src)"
        IF(ALLOCATED(ss%freq_lh)) THEN
           IF(MAXVAL(ABS(ss%freq_lh)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_GAS).EQ.1) THEN
     IF(itype.EQ.ps_shot_config) THEN
        isize = isize + 1  ! gas_atom
        w%list_elems(isize) = "gas_atom"
        w%elem_descr(isize) = "name of species introduced by each gas source"
        w%component(isize) = "GAS"
        w%elem_units(isize) = "character"
        w%c256val(isize) = "(ngsc0)"
        IF(ALLOCATED(ss%gas_atom)) THEN
           w%ival(isize) = 0
           DO I1 = 1,ss%ngsc0
              IF(ss%gas_atom(I1).NE." ") THEN
                 w%ival(isize) = 1
                 exit
              ENDIF
           ENDDO   ! I1
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LH).EQ.1) THEN
     IF(itype.EQ.ps_shot_config) THEN
        isize = isize + 1  ! hegrilh
        w%list_elems(isize) = "hegrilh"
        w%elem_descr(isize) = "need description"
        w%component(isize) = "LH"
        w%elem_units(isize) = "-"
        w%c256val(isize) = "(max_nspectrumlh_src,nlhrf_src)"
        IF(ALLOCATED(ss%hegrilh)) THEN
           IF(MAXVAL(ABS(ss%hegrilh)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_shot_config) THEN
        isize = isize + 1  ! Imag_ant_coef
        w%list_elems(isize) = "Imag_ant_coef"
        w%elem_descr(isize) = "imag part of Fourier Coef"
        w%component(isize) = "IC"
        w%elem_units(isize) = "Amps/m"
        w%c256val(isize) = "(max_num_nphi_vac,nicrf_src)"
        IF(ALLOCATED(ss%Imag_ant_coef)) THEN
           IF(MAXVAL(ABS(ss%Imag_ant_coef)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_GAS).EQ.1) THEN
     IF(itype.EQ.ps_shot_config) THEN
        isize = isize + 1  ! is_recycling
        w%list_elems(isize) = "is_recycling"
        w%elem_descr(isize) = "0/1; =1 to for recycling sources"
        w%component(isize) = "GAS"
        w%elem_units(isize) = "integer"
        w%c256val(isize) = "(ngsc0)"
        IF(ALLOCATED(ss%is_recycling)) THEN
           w%ival(isize) = 0
           DO I1 = 1,ss%ngsc0
              IF((ss%is_recycling(I1).NE.0).AND.(ss%is_recycling(I1).NE.ps_unInit)) THEN
                 w%ival(isize) = 1
                 exit
              ENDIF
           ENDDO   ! I1
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LH).EQ.1) THEN
     IF(itype.EQ.ps_shot_config) THEN
        isize = isize + 1  ! i_npoloidal
        w%list_elems(isize) = "i_npoloidal"
        w%elem_descr(isize) = "need description"
        w%component(isize) = "LH"
        w%elem_units(isize) = "integer"
        w%c256val(isize) = "scalar"
        IF((ss%i_npoloidal.EQ.0).OR.(ss%i_npoloidal.EQ.ps_unInit)) THEN
           w%ival(isize) = 0
        ELSE
           w%ival(isize) = 1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_shot_config) THEN
        isize = isize + 1  ! kccw_Bphi
        w%list_elems(isize) = "kccw_Bphi"
        w%elem_descr(isize) = "B_phi orientation: +1 means CCW viewed from above"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "integer"
        w%c256val(isize) = "scalar"
        IF((ss%kccw_Bphi.EQ.0).OR.(ss%kccw_Bphi.EQ.ps_unInit)) THEN
           w%ival(isize) = 0
        ELSE
           w%ival(isize) = 1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_shot_config) THEN
        isize = isize + 1  ! kccw_Jphi
        w%list_elems(isize) = "kccw_Jphi"
        w%elem_descr(isize) = "J_phi orientation: +1 means CCW viewed from above"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "integer"
        w%c256val(isize) = "scalar"
        IF((ss%kccw_Jphi.EQ.0).OR.(ss%kccw_Jphi.EQ.ps_unInit)) THEN
           w%ival(isize) = 0
        ELSE
           w%ival(isize) = 1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_shot_config) THEN
        isize = isize + 1  ! nbion
        w%list_elems(isize) = "nbion"
        w%elem_descr(isize) = "name of species injected by each beam."
        w%component(isize) = "NBI"
        w%elem_units(isize) = "character"
        w%c256val(isize) = "(nbeam)"
        IF(ALLOCATED(ss%nbion)) THEN
           w%ival(isize) = 0
           DO I1 = 1,ss%nbeam
              IF(ss%nbion(I1).NE." ") THEN
                 w%ival(isize) = 1
                 exit
              ENDIF
           ENDDO   ! I1
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_shot_config) THEN
        isize = isize + 1  ! nbion_trace
        w%list_elems(isize) = "nbion_trace"
        w%elem_descr(isize) = "(if non-blank) beam trace element"
        w%component(isize) = "NBI"
        w%elem_units(isize) = "character"
        w%c256val(isize) = "(nbeam)"
        IF(ALLOCATED(ss%nbion_trace)) THEN
           w%ival(isize) = 0
           DO I1 = 1,ss%nbeam
              IF(ss%nbion_trace(I1).NE." ") THEN
                 w%ival(isize) = 1
                 exit
              ENDIF
           ENDDO   ! I1
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LH).EQ.1) THEN
     IF(itype.EQ.ps_shot_config) THEN
        isize = isize + 1  ! nnkparlh
        w%list_elems(isize) = "nnkparlh"
        w%elem_descr(isize) = "need description"
        w%component(isize) = "LH"
        w%elem_units(isize) = "integer"
        w%c256val(isize) = "(max_nspectrumlh_src,nlhrf_src)"
        IF(ALLOCATED(ss%nnkparlh)) THEN
           w%ival(isize) = 0
           DO I2 = 1,ss%nlhrf_src
              DO I1 = 1,ss%max_nspectrumlh_src
                 IF((ss%nnkparlh(I1,I2).NE.0).AND.(ss%nnkparlh(I1,I2).NE.ps_unInit)) THEN
                    w%ival(isize) = 1
                    exit
                 ENDIF
              ENDDO   ! I1
           ENDDO   ! I2
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LH).EQ.1) THEN
     IF(itype.EQ.ps_shot_config) THEN
        isize = isize + 1  ! nnkpollh
        w%list_elems(isize) = "nnkpollh"
        w%elem_descr(isize) = "need description"
        w%component(isize) = "LH"
        w%elem_units(isize) = "integer"
        w%c256val(isize) = "(max_nspectrumlh_src,nlhrf_src)"
        IF(ALLOCATED(ss%nnkpollh)) THEN
           w%ival(isize) = 0
           DO I2 = 1,ss%nlhrf_src
              DO I1 = 1,ss%max_nspectrumlh_src
                 IF((ss%nnkpollh(I1,I2).NE.0).AND.(ss%nnkpollh(I1,I2).NE.ps_unInit)) THEN
                    w%ival(isize) = 1
                    exit
                 ENDIF
              ENDDO   ! I1
           ENDDO   ! I2
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LH).EQ.1) THEN
     IF(itype.EQ.ps_shot_config) THEN
        isize = isize + 1  ! nnktorlh
        w%list_elems(isize) = "nnktorlh"
        w%elem_descr(isize) = "need description"
        w%component(isize) = "LH"
        w%elem_units(isize) = "integer"
        w%c256val(isize) = "(max_nspectrumlh_src,nlhrf_src)"
        IF(ALLOCATED(ss%nnktorlh)) THEN
           w%ival(isize) = 0
           DO I2 = 1,ss%nlhrf_src
              DO I1 = 1,ss%max_nspectrumlh_src
                 IF((ss%nnktorlh(I1,I2).NE.0).AND.(ss%nnktorlh(I1,I2).NE.ps_unInit)) THEN
                    w%ival(isize) = 1
                    exit
                 ENDIF
              ENDDO   ! I1
           ENDDO   ! I2
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_shot_config) THEN
        isize = isize + 1  ! nphi
        w%list_elems(isize) = "nphi"
        w%elem_descr(isize) = "n_phi wave spectrum from antenna"
        w%component(isize) = "IC"
        w%elem_units(isize) = "integer"
        w%c256val(isize) = "(max_num_nphi,nicrf_src)"
        IF(ALLOCATED(ss%nphi)) THEN
           w%ival(isize) = 0
           DO I2 = 1,ss%nicrf_src
              DO I1 = 1,ss%max_num_nphi
                 IF((ss%nphi(I1,I2).NE.0).AND.(ss%nphi(I1,I2).NE.ps_unInit)) THEN
                    w%ival(isize) = 1
                    exit
                 ENDIF
              ENDDO   ! I1
           ENDDO   ! I2
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LH).EQ.1) THEN
     IF(itype.EQ.ps_shot_config) THEN
        isize = isize + 1  ! nspectrumlh_src
        w%list_elems(isize) = "nspectrumlh_src"
        w%elem_descr(isize) = "number of spectrum peaks"
        w%component(isize) = "LH"
        w%elem_units(isize) = "integer"
        w%c256val(isize) = "(nlhrf_src)"
        IF(ALLOCATED(ss%nspectrumlh_src)) THEN
           w%ival(isize) = 0
           DO I1 = 1,ss%nlhrf_src
              IF((ss%nspectrumlh_src(I1).NE.0).AND.(ss%nspectrumlh_src(I1).NE.ps_unInit)) THEN
                 w%ival(isize) = 1
                 exit
              ENDIF
           ENDDO   ! I1
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LH).EQ.1) THEN
     IF(itype.EQ.ps_shot_config) THEN
        isize = isize + 1  ! nthinlh
        w%list_elems(isize) = "nthinlh"
        w%elem_descr(isize) = "need description"
        w%component(isize) = "LH"
        w%elem_units(isize) = "integer"
        w%c256val(isize) = "(max_nspectrumlh_src,nlhrf_src)"
        IF(ALLOCATED(ss%nthinlh)) THEN
           w%ival(isize) = 0
           DO I2 = 1,ss%nlhrf_src
              DO I1 = 1,ss%max_nspectrumlh_src
                 IF((ss%nthinlh(I1,I2).NE.0).AND.(ss%nthinlh(I1,I2).NE.ps_unInit)) THEN
                    w%ival(isize) = 1
                    exit
                 ENDIF
              ENDDO   ! I1
           ENDDO   ! I2
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_shot_config) THEN
        isize = isize + 1  ! num_nphi
        w%list_elems(isize) = "num_nphi"
        w%elem_descr(isize) = "number of non-zero n_phi values"
        w%component(isize) = "IC"
        w%elem_units(isize) = "integer"
        w%c256val(isize) = "(nicrf_src)"
        IF(ALLOCATED(ss%num_nphi)) THEN
           w%ival(isize) = 0
           DO I1 = 1,ss%nicrf_src
              IF((ss%num_nphi(I1).NE.0).AND.(ss%num_nphi(I1).NE.ps_unInit)) THEN
                 w%ival(isize) = 1
                 exit
              ENDIF
           ENDDO   ! I1
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_shot_config) THEN
        isize = isize + 1  ! num_nphi_vac
        w%list_elems(isize) = "num_nphi_vac"
        w%elem_descr(isize) = "number of non-zero n_phi values"
        w%component(isize) = "IC"
        w%elem_units(isize) = "integer"
        w%c256val(isize) = "(nicrf_src)"
        IF(ALLOCATED(ss%num_nphi_vac)) THEN
           w%ival(isize) = 0
           DO I1 = 1,ss%nicrf_src
              IF((ss%num_nphi_vac(I1).NE.0).AND.(ss%num_nphi_vac(I1).NE.ps_unInit)) THEN
                 w%ival(isize) = 1
                 exit
              ENDIF
           ENDDO   ! I1
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_shot_config) THEN
        isize = isize + 1  ! n_straps
        w%list_elems(isize) = "n_straps"
        w%elem_descr(isize) = "number of straps in the antenna"
        w%component(isize) = "IC"
        w%elem_units(isize) = "integer"
        w%c256val(isize) = "(nicrf_src)"
        IF(ALLOCATED(ss%n_straps)) THEN
           w%ival(isize) = 0
           DO I1 = 1,ss%nicrf_src
              IF((ss%n_straps(I1).NE.0).AND.(ss%n_straps(I1).NE.ps_unInit)) THEN
                 w%ival(isize) = 1
                 exit
              ENDIF
           ENDDO   ! I1
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LH).EQ.1) THEN
     IF(itype.EQ.ps_shot_config) THEN
        isize = isize + 1  ! phigrilh
        w%list_elems(isize) = "phigrilh"
        w%elem_descr(isize) = "need description"
        w%component(isize) = "LH"
        w%elem_units(isize) = "-"
        w%c256val(isize) = "(max_nspectrumlh_src,nlhrf_src)"
        IF(ALLOCATED(ss%phigrilh)) THEN
           IF(MAXVAL(ABS(ss%phigrilh)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_shot_config) THEN
        isize = isize + 1  ! Real_ant_coef
        w%list_elems(isize) = "Real_ant_coef"
        w%elem_descr(isize) = "real part of Fourier Coef"
        w%component(isize) = "IC"
        w%elem_units(isize) = "Amps/m"
        w%c256val(isize) = "(max_num_nphi_vac,nicrf_src)"
        IF(ALLOCATED(ss%Real_ant_coef)) THEN
           IF(MAXVAL(ABS(ss%Real_ant_coef)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LH).EQ.1) THEN
     IF(itype.EQ.ps_shot_config) THEN
        isize = isize + 1  ! rhopsi0lh
        w%list_elems(isize) = "rhopsi0lh"
        w%elem_descr(isize) = "need description"
        w%component(isize) = "LH"
        w%elem_units(isize) = "-"
        w%c256val(isize) = "(max_nspectrumlh_src,nlhrf_src)"
        IF(ALLOCATED(ss%rhopsi0lh)) THEN
           IF(MAXVAL(ABS(ss%rhopsi0lh)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_shot_config) THEN
        isize = isize + 1  ! R_ant
        w%list_elems(isize) = "R_ant"
        w%elem_descr(isize) = "major radius of antenna"
        w%component(isize) = "IC"
        w%elem_units(isize) = "m"
        w%c256val(isize) = "(nicrf_src)"
        IF(ALLOCATED(ss%R_ant)) THEN
           IF(MAXVAL(ABS(ss%R_ant)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_shot_config) THEN
        isize = isize + 1  ! shot_number
        w%list_elems(isize) = "shot_number"
        w%elem_descr(isize) = "integer shot number"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "integer"
        w%c256val(isize) = "scalar"
        IF((ss%shot_number.EQ.0).OR.(ss%shot_number.EQ.ps_unInit)) THEN
           w%ival(isize) = 0
        ELSE
           w%ival(isize) = 1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LH).EQ.1) THEN
     IF(itype.EQ.ps_shot_config) THEN
        isize = isize + 1  ! thegrilh
        w%list_elems(isize) = "thegrilh"
        w%elem_descr(isize) = "need description"
        w%component(isize) = "LH"
        w%elem_units(isize) = "-"
        w%c256val(isize) = "(max_nspectrumlh_src,nlhrf_src)"
        IF(ALLOCATED(ss%thegrilh)) THEN
           IF(MAXVAL(ABS(ss%thegrilh)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_shot_config) THEN
        isize = isize + 1  ! wt_nphi
        w%list_elems(isize) = "wt_nphi"
        w%elem_descr(isize) = "vacuum spectrum n_phi weight"
        w%component(isize) = "IC"
        w%elem_units(isize) = "-"
        w%c256val(isize) = "(max_num_nphi,nicrf_src)"
        IF(ALLOCATED(ss%wt_nphi)) THEN
           IF(MAXVAL(ABS(ss%wt_nphi)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_shot_config) THEN
        isize = isize + 1  ! Z_ant
        w%list_elems(isize) = "Z_ant"
        w%elem_descr(isize) = "height of antenna"
        w%component(isize) = "IC"
        w%elem_units(isize) = "m"
        w%c256val(isize) = "(nicrf_src)"
        IF(ALLOCATED(ss%Z_ant)) THEN
           IF(MAXVAL(ABS(ss%Z_ant)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_shot_config) THEN
        isize = isize + 1  ! Z_mid_ant
        w%list_elems(isize) = "Z_mid_ant"
        w%elem_descr(isize) = "center of antenna relative to TF coil midplane"
        w%component(isize) = "IC"
        w%elem_units(isize) = "m"
        w%c256val(isize) = "(nicrf_src)"
        IF(ALLOCATED(ss%Z_mid_ant)) THEN
           IF(MAXVAL(ABS(ss%Z_mid_ant)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF
END SUBROUTINE plasma_state_contents_sconfig

subroutine ur_cstate_rcon

  ! control list dimension reduction options

  use cstate_lib_mod
  implicit NONE

  !-------------------------
  ! local

  integer :: luntty,lnout
  logical :: lxout,lchar
  integer :: i,ifound
  character*32 :: dword

  !-------------------------

  luntty = lnout(0)
  
  do
     if(lxout(0)) then
        write(luntty,*) ' '
        write(luntty,*) ' Status of reduction operators:'
        write(luntty,*) ' dimension     activated? (T/F)'
        write(luntty,*) ' ------------  ----------------'
        do i=1,nreduce_opt
           write(luntty,'(2x,a,6x,L1)') reduce_dims(i),reduce_active(i)
        enddo

        write(luntty,*) ' '
        write(luntty,*) ' options:'
        write(luntty,*) '  <dimension-name> to ACTIVATE reduction operator'
        write(luntty,*) '  -<dimension-name> to DEactivate reduction operator'
        write(luntty,*) '     use a listed item for <dimension-name>, or,'
        write(luntty,*) '     "nspec" or "nsa" as prefix names.'
        write(luntty,*) ' '
        write(luntty,*) '  A  activate ALL'
        write(luntty,*) '  B  DEactivate ALL'
        write(luntty,*) '  D  for description of reduction operators'
        write(luntty,*) '  Q  quit (no further changes).'
        write(luntty,*) ' '

     endif

     call ureadw('ur_cstate_rcon: option selection:',dword)
     if(dword.eq.'Q') then
        exit

     else if(dword.eq.'A') then
        reduce_active = .TRUE.
        
     else if(dword.eq.'B') then
        reduce_active = .FALSE.

     else if(dword.eq.'D') then
        dword=reduce_dims(1)
        call ureadw( &
             'ur_cstate_rcon: select <dimension-name> or "*" for all:', &
             dword)

        ifound = 0

        if(dword.eq.'*') then
           do i=1,nreduce_opt
              dword = reduce_dims(i)
              call descr(dword)
           enddo

        else
           call ulower(dword)
           call descr(dword)

        endif

        if(ifound.gt.0) then
           write(luntty,*) ' '
           write(luntty,*) '   No name change if all states combined only have a'
           write(luntty,*) '   single species of a given category.'
           write(luntty,*) ' '
           write(luntty,*) '   If a given category is missing from all states, it'
           write(luntty,*) '   will be omitted.'
           write(luntty,*) ' '
        endif

     else if(dword(1:1).eq.'-') then
        call ulower(dword)
        call deactivate(dword(2:))

     else
        call ulower(dword)
        call activate(dword)

     endif
  enddo

  contains

    subroutine activate(dim)

      character*(*), intent(in) :: dim
      integer :: imatch

      call chk(dim,imatch)

      if(imatch.gt.0) reduce_active(imatch) = .TRUE.
      if(dim.eq.'nspec') then
         call chk('nspec_th',imatch)
         if(imatch.gt.0) reduce_active(imatch)=.TRUE.
         call chk('nspec_all',imatch)
         if(imatch.gt.0) reduce_active(imatch)=.TRUE.
      endif
      if(dim.eq.'nsa') then
         call chk('nsa_th',imatch)
         if(imatch.gt.0) reduce_active(imatch)=.TRUE.
         call chk('nsa_all',imatch)
         if(imatch.gt.0) reduce_active(imatch)=.TRUE.
      endif

    end subroutine activate

    subroutine deactivate(dim)

      character*(*), intent(in) :: dim
      integer :: imatch

      call chk(dim,imatch)

      if(imatch.gt.0) reduce_active(imatch) = .FALSE.
      if(dim.eq.'nspec') then
         call chk('nspec_th',imatch)
         if(imatch.gt.0) reduce_active(imatch)=.FALSE.
         call chk('nspec_all',imatch)
         if(imatch.gt.0) reduce_active(imatch)=.FALSE.
      endif
      if(dim.eq.'nsa') then
         call chk('nsa_th',imatch)
         if(imatch.gt.0) reduce_active(imatch)=.FALSE.
         call chk('nsa_all',imatch)
         if(imatch.gt.0) reduce_active(imatch)=.FALSE.
      endif

    end subroutine deactivate

    subroutine chk(chkdim,imatch)

      character*(*), intent(in) :: chkdim
      integer, intent(out) :: imatch

      integer :: i

      imatch = 0

      do i=1,nreduce_opt
         if(chkdim.eq.reduce_dims(i)) then
            imatch = i
            exit
         endif
      enddo

      if(imatch.eq.0) then
         call uermsg('dimension unrecognized or irreducible',chkdim,0)
      endif
    end subroutine chk

    subroutine descr(dim)

      character*(*), intent(in) :: dim
      integer :: imatch

      call chk(dim,imatch); if(imatch.eq.0) return

      write(luntty,*)
      write(luntty,*) ' ........... '//trim(dim)//':'

      if(dim.eq.'nsbeam') then
         ifound = ifound + 1
         write(luntty,*) ' combine together all beam ions -> "BEAM";'
      else if(dim.eq.'nsfusn') then
         ifound = ifound + 1
         write(luntty,*) ' combine together all fusion product ions -> "FUSN";'
      else if(dim.eq.'nrfmin') then
         ifound = ifound + 1
         write(luntty,*) ' combine together all RF minority ions; -> "MINO".'

      else if(dim.eq.'ngas') then
         ifound = ifound + 1
         write(luntty,*) ' combine all H isotopes -> "H_ISO".'
         write(luntty,*) ' combine all He isotopes -> "HE_ISO".'

      else if(dim.eq.'nspec_th') then
         ifound = ifound + 1
         write(luntty,*) ' combine impurity ions -> "IMP".'

      else if(dim.eq.'nsa_th') then
         ifound = ifound + 1
         write(luntty,*) ' combine impurity ions -> "IMP".'

      else if(dim.eq.'nspec_all') then
         ifound = ifound + 1
         write(luntty,*) ' combine impurity ions -> "IMP".'
         write(luntty,*) ' combine together all beam ions -> "BEAM";'
         write(luntty,*) ' combine together all fusion product ions -> "FUSN";'
         write(luntty,*) ' combine together all RF minority ions; -> "MINO".'

      else if(dim.eq.'nsa_all') then
         ifound = ifound + 1
         write(luntty,*) ' combine impurity ions -> "IMP".'
         write(luntty,*) ' combine together all beam ions -> "BEAM";'
         write(luntty,*) ' combine together all fusion product ions -> "FUSN";'
         write(luntty,*) ' combine together all RF minority ions; -> "MINO".'

      else if(dim.eq.'nbeam') then
         ifound = ifound + 1
         write(luntty,*) ' sum over neutral beams -> "NBI".'

      else if(dim.eq.'nicrf_src') then
         ifound = ifound + 1
         write(luntty,*) ' sum over ICRF antennas -> "ICRF".'

      else if(dim.eq.'nlhrf_src') then
         ifound = ifound + 1
         write(luntty,*) ' sum over LH antennas -> "LHRF".'

      else if(dim.eq.'necrf_src') then
         ifound = ifound + 1
         write(luntty,*) ' sum over ECRF antennas -> "ECRF".'

      else
         ifound = ifound + 1
         write(luntty,*) ' ?? unknown: ',trim(dim)
      endif

    end subroutine descr

end subroutine ur_cstate_rcon

subroutine ccps_write_update_file(iobj,filepath,hashflag,ierr)

  ! write file containing updates-- i.e. state elements that have
  ! changed since the last time the file was read or written.

  ! if hashflag.NE.0 is set, update hash table, so that a subsequent
  ! call to this routine won't rewrite the same elements (unless they
  ! change value again).  If hashflag=0, hash table is not updated.

  use plasma_state_mod
  implicit NONE

#include "fpreproc/byte_declare.h"

  integer :: iobj(*)        ! (ps_container_size) words are used: state object
  BYTE_DECLARE, intent(in) :: filepath(*)  ! null terminated file path string (max 256 chars)
  integer,intent(in) :: hashflag   ! .NE.0 to update I/O hash table
  integer,intent(out) :: ierr      ! exit status 0=OK

  !-------------------------
  character*256 filename
  type (plasma_state_container) :: ptr
  type (plasma_state), pointer :: ss
  logical :: hash_update
  !-------------------------

  call ccps_argcheck('ccps_write_update_file',iobj,ierr)
  if(ierr.ne.0) return

  ! proceed...

  call load_ps_container(iobj,ptr)
  ss => ptr%ps_ptr

  ! convert filepath to fortran string
  call cstring(filename,filepath,'2F')  ! convert file path to fortran string

  hash_update = (hashflag.NE.0)
  call ps_write_update_file(filename, ierr, state=ss, hash_update=hash_update)

end subroutine ccps_write_update_file

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_s5_dummy
     return
  end subroutine ccps_getset_s5_dummy

subroutine psget_sgas_name(iobj, n1, data, ierr)
    !! atomic neutral species in plasma core
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    CHARACTER*(*), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_sgas_name', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % SGAS_name
end subroutine psget_sgas_name


subroutine psset_sgas_name(iobj, n1, data, ierr)
    !! atomic neutral species in plasma core
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    CHARACTER*(*), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_sgas_name', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % SGAS_name = data(1:n1)
end subroutine psset_sgas_name


subroutine psgetsz_sgas_name(iobj, size, ierr)
    !! atomic neutral species in plasma core
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: size    ! size of character string
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psgetsz_sgas_name', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! note that the following will return the character length size regardless of
    ! the number of array elements (if SGAS_name is an array)
    size = len(ss % SGAS_name)
end subroutine psgetsz_sgas_name


subroutine psgetrnk_sgas_name(iobj, ndims, ierr)
    !! atomic neutral species in plasma core
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_sgas_name


subroutine psgetdim_sgas_name(iobj, ndims, dims, ierr)
    !! atomic neutral species in plasma core
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_sgas_name', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % SGAS_name ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % SGAS_name)
    endif
end subroutine psgetdim_sgas_name


subroutine psget_sprof0(iobj, n1, n2, n3, data, ierr)
    !! gas species source/sinks per unit species influx, due to
    !! charge exchange, single species neutral, source (sc0(i)) leads
    !! to multi species ion sce., remark (Jan. 2009):, charge exchange
    !! can affect impurity charge, states -- may need to add profiles
    !! to track, this interaction, in the future...
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2, n3 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2, n3) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_sprof0', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2, 1: n3) = ss % sprof0
end subroutine psget_sprof0


subroutine psset_sprof0(iobj, n1, n2, n3, data, ierr)
    !! gas species source/sinks per unit species influx, due to
    !! charge exchange, single species neutral, source (sc0(i)) leads
    !! to multi species ion sce., remark (Jan. 2009):, charge exchange
    !! can affect impurity charge, states -- may need to add profiles
    !! to track, this interaction, in the future...
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2, n3 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2, n3) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_sprof0', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % sprof0 = data(1:n1, 1: n2, 1: n3)
end subroutine psset_sprof0


subroutine psgetrnk_sprof0(iobj, ndims, ierr)
    !! gas species source/sinks per unit species influx, due to
    !! charge exchange, single species neutral, source (sc0(i)) leads
    !! to multi species ion sce., remark (Jan. 2009):, charge exchange
    !! can affect impurity charge, states -- may need to add profiles
    !! to track, this interaction, in the future...
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 3
end subroutine psgetrnk_sprof0


subroutine psgetdim_sprof0(iobj, ndims, dims, ierr)
    !! gas species source/sinks per unit species influx, due to
    !! charge exchange, single species neutral, source (sc0(i)) leads
    !! to multi species ion sce., remark (Jan. 2009):, charge exchange
    !! can affect impurity charge, states -- may need to add profiles
    !! to track, this interaction, in the future...
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 3) ierr = 1
    call ccps_argcheck('psgetdim_sprof0', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % sprof0 ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % sprof0)
    endif
end subroutine psgetdim_sprof0

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


SUBROUTINE plasma_state_store_def_6(ss,icdf,iout,iertot)


  !  define subset of variables and arrays for NetCDF file

  USE plasma_state_definition_mod
  USE netcdf
  IMPLICIT NONE

  TYPE (plasma_state) :: ss     ! state data to read
  INTEGER, INTENT(IN) :: icdf   ! NetCDF file ID
  INTEGER, INTENT(IN) :: iout   ! message LUN
  INTEGER, INTENT(INOUT) :: iertot  ! error count

  !--------------

  INTEGER :: varid,dimid,status,ival,idims(20),indim
  CHARACTER*80 :: nc_errmsg

  !--------------
  !  define variables...


  IF(ALLOCATED(ss%PsiRZ)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nr",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nz",idims(indim))
     CALL define_var("PsiRZ","R",indim,idims, &
            "Psi(R,Z)", &
            "Wb/rad","EQ","STATE_PROFILES", &
            "R|units=Wb/rad|Spline  PsiRZ(nR,nZ)")
  ENDIF

  indim = 0
  CALL define_var("Psi_to_machine_axis","R",indim,idims, &
         "delta(Psi) from magnetic axis to machine axis", &
         "Wb/rad","EQ","STATE_DATA", &
         "R|units=Wb/rad   Psi_to_machine_axis")

  IF(ALLOCATED(ss%psmom_errck)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_eq_geo",idims(indim))
     CALL define_var("psmom_errck","R",indim,idims, &
            "PS moments sum convergence", &
            "-","EQ","STATE_PROFILES", &
            "R|units=-|pclin       psmom_errck(nrho_eq_geo)")
  ENDIF

  IF(ALLOCATED(ss%psmom_nc)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_eq_geo",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_npsmom",idims(indim))
     CALL define_var("psmom_nc","R",indim,idims, &
            "PS moments", &
            "m^-2","EQ","STATE_PROFILES", &
            "R|units=m^-2|pclin    psmom_nc(nrho_eq_geo,npsmom)")
  ENDIF

  IF(ALLOCATED(ss%psmom_num)) THEN
     indim = 1
     status = nf90_inq_dimid(icdf,"ps_clen_32",idims(1))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_npsmom",idims(indim))
     CALL define_var("psmom_num","N",indim,idims, &
            "Pfirsch-Schlutter moments", &
            "__NONE","EQ","SIMULATION_INIT", &
            "L|PS_moments  psmom_num(npsmom)")
  ENDIF

  IF(ALLOCATED(ss%P_eq)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_eq",idims(indim))
     CALL define_var("P_eq","R",indim,idims, &
            "equilibrium scalar pressure", &
            "Pa","EQ","STATE_PROFILES", &
            "R|units=Pa|Spline_00       P_eq(nrho_eq)")
  ENDIF

  IF(ALLOCATED(ss%qatom_ALL)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dp1_nspec_all",idims(indim))
     CALL define_var("qatom_ALL","R",indim,idims, &
            "ALL atomic number", &
            "C","PLASMA","SIMULATION_INIT", &
            "S|specie  ALL(0:nspec_all)")
  ENDIF

  IF(ALLOCATED(ss%qatom_ALLA)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dp1_nspec_alla",idims(indim))
     CALL define_var("qatom_ALLA","R",indim,idims, &
            "ALLA atomic number", &
            "C","PLASMA","SIMULATION_INIT", &
            "S|specie  ALLA(0:nspec_alla)")
  ENDIF

  IF(ALLOCATED(ss%qatom_RFMIN)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nspec_rfmin",idims(indim))
     CALL define_var("qatom_RFMIN","R",indim,idims, &
            "RFMIN atomic number", &
            "C","IC","SHOT_CONFIGURATION", &
            "S|RF_minority  RFMIN(nspec_rfmin)")
  ENDIF

  IF(ALLOCATED(ss%qatom_S)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dp1_nspec_th",idims(indim))
     CALL define_var("qatom_S","R",indim,idims, &
            "S atomic number", &
            "C","PLASMA","SHOT_CONFIGURATION", &
            "S|thermal_specie  S(0:nspec_th)")
  ENDIF

  IF(ALLOCATED(ss%qatom_SA)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dp1_nspec_tha",idims(indim))
     CALL define_var("qatom_SA","R",indim,idims, &
            "SA atomic number", &
            "C","PLASMA","SIMULATION_INIT", &
            "S|thermal_specie  SA(0:nspec_tha)")
  ENDIF

  IF(ALLOCATED(ss%qatom_SFUS)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nspec_fusion",idims(indim))
     CALL define_var("qatom_SFUS","R",indim,idims, &
            "SFUS atomic number", &
            "C","FUS","SHOT_CONFIGURATION", &
            "S|fusion_ion   SFUS(nspec_fusion)")
  ENDIF

  IF(ALLOCATED(ss%qatom_SGAS)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nspec_gas",idims(indim))
     CALL define_var("qatom_SGAS","R",indim,idims, &
            "SGAS atomic number", &
            "C","GAS","SIMULATION_INIT", &
            "S|neutral_gas  SGAS(nspec_gas)")
  ENDIF

  IF(ALLOCATED(ss%qatom_SIMP0)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nspec_imp0",idims(indim))
     CALL define_var("qatom_SIMP0","R",indim,idims, &
            "SIMP0 atomic number", &
            "C","GAS","SIMULATION_INIT", &
            "S|impurity_atoms SIMP0(nspec_imp0)")
  ENDIF

  IF(ALLOCATED(ss%qatom_SIMPI)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nspec_impi",idims(indim))
     CALL define_var("qatom_SIMPI","R",indim,idims, &
            "SIMPI atomic number", &
            "C","PLASMA","SIMULATION_INIT", &
            "S|impurity_atoms SIMPI(nspec_impi)")
  ENDIF

  IF(ALLOCATED(ss%qatom_SNBI)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nspec_beam",idims(indim))
     CALL define_var("qatom_SNBI","R",indim,idims, &
            "SNBI atomic number", &
            "C","NBI","SIMULATION_INIT", &
            "S|beam_ion     SNBI(nspec_beam)")
  ENDIF

  IF(ALLOCATED(ss%qbeami)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_nbi",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nspec_beam",idims(indim))
     CALL define_var("qbeami","R",indim,idims, &
            "average beam ion charge", &
            "C","NBI","STATE_PROFILES", &
            "R|units=C|step*nbeami qbeami(~nrho_nbi,nspec_beam)")
  ENDIF

  IF(ALLOCATED(ss%qcomp_e)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho",idims(indim))
     CALL define_var("qcomp_e","R",indim,idims, &
            "Compressional electron heating", &
            "W","PLASMA","STATE_PROFILES", &
            "R|step*dV   qcomp_e(~nrho)")
  ENDIF

  IF(ALLOCATED(ss%qcomp_i)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho",idims(indim))
     CALL define_var("qcomp_i","R",indim,idims, &
            "Compressional ion heating", &
            "W","PLASMA","STATE_PROFILES", &
            "R|step*dV   qcomp_i(~nrho)")
  ENDIF

  IF(ALLOCATED(ss%qie)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho",idims(indim))
     CALL define_var("qie","R",indim,idims, &
            "Ion->Electron heat coupling", &
            "W","PLASMA","STATE_PROFILES", &
            "R|units=W|step*dV   qie(~nrho)")
  ENDIF

  IF(ALLOCATED(ss%qioniz)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_gas",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_ngsc0",idims(indim))
     CALL define_var("qioniz","R",indim,idims, &
            "ionization power per unit influx (sc0)", &
            "W/(#/sec)","GAS","STATE_PROFILES", &
            "R|step*dV|units=W/(#/sec)     qioniz(~nrho_gas,ngsc0)")
  ENDIF

  IF(ALLOCATED(ss%ql_operator)) THEN
     indim = 1
     status = nf90_inq_dimid(icdf,"ps_clen_256",idims(1))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dp1_nspec_alla",idims(indim))
     CALL define_var("ql_operator","F",indim,idims, &
            "quasilinear operator filenames", &
            "__NONE","IC","STATE_DATA", &
            "F  ql_operator(0:nspec_alla)")
  ENDIF

  IF(ALLOCATED(ss%qqcx)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_gas",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_ngsc0",idims(indim))
     CALL define_var("qqcx","R",indim,idims, &
            "cx power per unit influx per (T0-Ti)", &
            "W/(#/sec)/keV","GAS","STATE_PROFILES", &
            "R|step*dV|units=W/(#/sec)/keV  qqcx(~nrho_gas,ngsc0)")
  ENDIF

  IF(ALLOCATED(ss%qrot_conv)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho",idims(indim))
     CALL define_var("qrot_conv","R",indim,idims, &
            "rotational energy dissipation (convective)", &
            "W","PLASMA","STATE_PROFILES", &
            "R|step*dV   qrot_conv(~nrho)")
  ENDIF

  IF(ALLOCATED(ss%qrot_diff)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho",idims(indim))
     CALL define_var("qrot_diff","R",indim,idims, &
            "rotational energy dissipation (diffusive)", &
            "W","PLASMA","STATE_PROFILES", &
            "R|step*dV   qrot_diff(~nrho)")
  ENDIF

  IF(ALLOCATED(ss%q_ALL)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dp1_nspec_all",idims(indim))
     CALL define_var("q_ALL","R",indim,idims, &
            "ALL specie charge", &
            "C","PLASMA","SIMULATION_INIT", &
            "S|specie  ALL(0:nspec_all)")
  ENDIF

  IF(ALLOCATED(ss%q_ALLA)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dp1_nspec_alla",idims(indim))
     CALL define_var("q_ALLA","R",indim,idims, &
            "ALLA specie charge", &
            "C","PLASMA","SIMULATION_INIT", &
            "S|specie  ALLA(0:nspec_alla)")
  ENDIF

  IF(ALLOCATED(ss%q_eq)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_eq",idims(indim))
     CALL define_var("q_eq","R",indim,idims, &
            "equilibrium q profile", &
            "-","EQ","STATE_PROFILES", &
            "R|units=-|Spline           q_eq(nrho_eq)")
  ENDIF

  IF(ALLOCATED(ss%q_RFMIN)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nspec_rfmin",idims(indim))
     CALL define_var("q_RFMIN","R",indim,idims, &
            "RFMIN specie charge", &
            "C","IC","SHOT_CONFIGURATION", &
            "S|RF_minority  RFMIN(nspec_rfmin)")
  ENDIF

  IF(ALLOCATED(ss%q_S)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dp1_nspec_th",idims(indim))
     CALL define_var("q_S","R",indim,idims, &
            "S specie charge", &
            "C","PLASMA","SHOT_CONFIGURATION", &
            "S|thermal_specie  S(0:nspec_th)")
  ENDIF

  IF(ALLOCATED(ss%q_SA)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dp1_nspec_tha",idims(indim))
     CALL define_var("q_SA","R",indim,idims, &
            "SA specie charge", &
            "C","PLASMA","SIMULATION_INIT", &
            "S|thermal_specie  SA(0:nspec_tha)")
  ENDIF

  IF(ALLOCATED(ss%q_SFUS)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nspec_fusion",idims(indim))
     CALL define_var("q_SFUS","R",indim,idims, &
            "SFUS specie charge", &
            "C","FUS","SHOT_CONFIGURATION", &
            "S|fusion_ion   SFUS(nspec_fusion)")
  ENDIF

  IF(ALLOCATED(ss%q_SGAS)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nspec_gas",idims(indim))
     CALL define_var("q_SGAS","R",indim,idims, &
            "SGAS specie charge", &
            "C","GAS","SIMULATION_INIT", &
            "S|neutral_gas  SGAS(nspec_gas)")
  ENDIF

  IF(ALLOCATED(ss%q_SIMP0)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nspec_imp0",idims(indim))
     CALL define_var("q_SIMP0","R",indim,idims, &
            "SIMP0 specie charge", &
            "C","GAS","SIMULATION_INIT", &
            "S|impurity_atoms SIMP0(nspec_imp0)")
  ENDIF

  IF(ALLOCATED(ss%q_SIMPI)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nspec_impi",idims(indim))
     CALL define_var("q_SIMPI","R",indim,idims, &
            "SIMPI specie charge", &
            "C","PLASMA","SIMULATION_INIT", &
            "S|impurity_atoms SIMPI(nspec_impi)")
  ENDIF

  IF(ALLOCATED(ss%q_SNBI)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nspec_beam",idims(indim))
     CALL define_var("q_SNBI","R",indim,idims, &
            "SNBI specie charge", &
            "C","NBI","SIMULATION_INIT", &
            "S|beam_ion     SNBI(nspec_beam)")
  ENDIF

  IF(ALLOCATED(ss%R0_momeq)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_eq",idims(indim))
     CALL define_var("R0_momeq","R",indim,idims, &
            "R0 of flux surface", &
            "m","EQ","STATE_PROFILES", &
            "R|units=m|Hermite_explicit  R0_momeq(nrho_eq)")
  ENDIF

  indim = 1
  status = nf90_inq_dimid(icdf,"ps_clen_80",idims(1))
  CALL define_var("RAD_Code_Info","C*80",indim,idims, &
         "Information: code implementing RAD component", &
         "__NONE","RAD","SIMULATION_INIT", &
         "C*80   RAD_Code_Info")

  indim = 1
  status = nf90_inq_dimid(icdf,"ps_clen_80",idims(1))
  CALL define_var("RAD_Data_Info","C*80",indim,idims, &
         "Information on source of radiated power data", &
         "__NONE","RAD","SIMULATION_INIT", &
         "C*80   RAD_Data_Info")

  IF(ALLOCATED(ss%rate_sinb0i)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_nbi",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nspec_gas",idims(indim))
     CALL define_var("rate_sinb0i","R",indim,idims, &
            "sink rate due to ionization by beam ions", &
            "1/sec","NBI","STATE_PROFILES", &
            "R|step|units=1/sec       rate_sinb0i(~nrho_nbi,nspec_gas)")
  ENDIF

  IF(ALLOCATED(ss%rate_sinb0x)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_nbi",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nspec_gas",idims(indim))
     CALL define_var("rate_sinb0x","R",indim,idims, &
            "sink rate due to CX with beam ions (total)", &
            "1/sec","NBI","STATE_PROFILES", &
            "R|step|units=1/sec       rate_sinb0x(~nrho_nbi,nspec_gas)")
  ENDIF

  IF(ALLOCATED(ss%rate_sinb0xs)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_nbi",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nspec_gas",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nspec_beam",idims(indim))
     CALL define_var("rate_sinb0xs","R",indim,idims, &
            "sink rate due to CX with beam ions", &
            "1/sec","NBI","STATE_PROFILES", &
            "R|step|units=1/sec       rate_sinb0xs(~nrho_nbi,nspec_gas,nspec_beam)")
  ENDIF

  IF(ALLOCATED(ss%rate_sinf0i)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_fus",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nspec_gas",idims(indim))
     CALL define_var("rate_sinf0i","R",indim,idims, &
            "sink rate due to ionization by fusion ions", &
            "1/sec","FUS","STATE_PROFILES", &
            "R|step|units=1/sec       rate_sinf0i(~nrho_fus,nspec_gas)")
  ENDIF

  IF(ALLOCATED(ss%rate_sinf0x)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_fus",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nspec_gas",idims(indim))
     CALL define_var("rate_sinf0x","R",indim,idims, &
            "sink rate due to CX with fusion ions (total)", &
            "1/sec","FUS","STATE_PROFILES", &
            "R|step|units=1/sec       rate_sinf0x(~nrho_fus,nspec_gas)")
  ENDIF

  IF(ALLOCATED(ss%rate_sinf0xs)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_fus",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nspec_gas",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nspec_fusion",idims(indim))
     CALL define_var("rate_sinf0xs","R",indim,idims, &
            "sink rate due to CX with fusion ions", &
            "1/sec","FUS","STATE_PROFILES", &
            "R|step|units=1/sec       rate_sinf0xs(~nrho_fus,nspec_gas,nspec_fusion)")
  ENDIF

  IF(ALLOCATED(ss%Real_ant_coef)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_max_num_nphi_vac",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nicrf_src",idims(indim))
     CALL define_var("Real_ant_coef","R",indim,idims, &
            "real part of Fourier Coef", &
            "Amps/m","IC","SHOT_CONFIGURATION", &
            "R|units=Amps/m Real_ant_coef(num_nphi_vac(),nicrf_src)")
  ENDIF

  IF(ALLOCATED(ss%res_sn)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dp1_nspec_th",idims(indim))
     CALL define_var("res_sn","R",indim,idims, &
            "residuals for particle transport eqn", &
            "Norm","PLASMA","STATE_PROFILES", &
            "R|units=Norm|step*dV res_sn(~nrho,0:nspec_th)")
  ENDIF

  IF(ALLOCATED(ss%res_te)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho",idims(indim))
     CALL define_var("res_te","R",indim,idims, &
            "residuals for electron transport eqn", &
            "Norm","PLASMA","STATE_PROFILES", &
            "R|step*dV res_te(~nrho)")
  ENDIF

  IF(ALLOCATED(ss%res_ti)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho",idims(indim))
     CALL define_var("res_ti","R",indim,idims, &
            "residuals for ion transport eqn", &
            "Norm","PLASMA","STATE_PROFILES", &
            "R|step*dV res_ti(~nrho)")
  ENDIF

  IF(ALLOCATED(ss%res_tq)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho",idims(indim))
     CALL define_var("res_tq","R",indim,idims, &
            "rediduals for angular momentum transport eqn", &
            "Norm","PLASMA","STATE_PROFILES", &
            "R|units=Norm|step*dV res_tq(~nrho)")
  ENDIF

  IF(ALLOCATED(ss%RFMIN_name)) THEN
     indim = 1
     status = nf90_inq_dimid(icdf,"ps_clen_32",idims(1))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nspec_rfmin",idims(indim))
     CALL define_var("RFMIN_name","N",indim,idims, &
            "ICRF minority species", &
            "__NONE","IC","SHOT_CONFIGURATION", &
            "S|RF_minority  RFMIN(nspec_rfmin)")
  ENDIF

  IF(ALLOCATED(ss%rfmin_to_all)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nspec_rfmin",idims(indim))
     CALL define_var("rfmin_to_all","I",indim,idims, &
            'map rfmin index to "all" list', &
            "__NONE","PLASMA","SIMULATION_INIT", &
            "I  rfmin_to_all(nspec_rfmin)")
  ENDIF

  IF(ALLOCATED(ss%rfmin_to_alla)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nspec_rfmin",idims(indim))
     CALL define_var("rfmin_to_alla","I",indim,idims, &
            'map rfmin index to "alla" list', &
            "__NONE","PLASMA","SIMULATION_INIT", &
            "I  rfmin_to_alla(nspec_rfmin)")
  ENDIF

  IF(ALLOCATED(ss%RFMIN_type)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nspec_rfmin",idims(indim))
     CALL define_var("RFMIN_type","I",indim,idims, &
            "RFMIN specie types", &
            "__NONE","IC","SHOT_CONFIGURATION", &
            "S|RF_minority  RFMIN(nspec_rfmin)")
  ENDIF

  IF(ALLOCATED(ss%rho)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho",idims(indim))
     CALL define_var("rho","R",indim,idims, &
            "rho grid (PLASMA)", &
            "-","PLASMA","SIMULATION_INIT", &
            "G   rho(nrho)")
  ENDIF

  IF(ALLOCATED(ss%rhopsi0lh)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_max_nspectrumlh_src",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nlhrf_src",idims(indim))
     CALL define_var("rhopsi0lh","R",indim,idims, &
            "need description", &
            "-","LH","SHOT_CONFIGURATION", &
            "R|units=- rhopsi0lh(nspectrumlh_src(),nlhrf_src)")
  ENDIF

  IF(ALLOCATED(ss%rho_anom)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anom",idims(indim))
     CALL define_var("rho_anom","R",indim,idims, &
            "rho grid (1d anomalous transport profiles)", &
            "-","ANOM","SIMULATION_INIT", &
            "G  rho_anom(nrho_anom)")
  ENDIF

  IF(ALLOCATED(ss%rho_anom2)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anom2",idims(indim))
     CALL define_var("rho_anom2","R",indim,idims, &
            "rho grid (2d anomalous transport profiles)", &
            "-","ANOM","SIMULATION_INIT", &
            "G  rho_anom2(nrho_anom2)")
  ENDIF

  IF(ALLOCATED(ss%rho_anomth)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     CALL define_var("rho_anomth","R",indim,idims, &
            "rho grid (1d anomalous data for 1d", &
            "-","ANOM","SIMULATION_INIT", &
            "G  rho_anomth(nrho_anomth)")
  ENDIF

  IF(ALLOCATED(ss%rho_bdy_ns)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dp1_nspec_th",idims(indim))
     CALL define_var("rho_bdy_ns","R",indim,idims, &
            "locations beyond which densities are known", &
            "-","PLASMA","STATE_DATA", &
            "R|units=- rho_bdy_ns(0:nspec_th)")
  ENDIF

  indim = 0
  CALL define_var("rho_bdy_omegat","R",indim,idims, &
         "location beyond which angular velocity is known", &
         "-","PLASMA","STATE_DATA", &
         "R rho_bdy_omegat")

  indim = 0
  CALL define_var("rho_bdy_Te","R",indim,idims, &
         "location beyond which Te is known", &
         "-","PLASMA","STATE_DATA", &
         "R rho_bdy_Te")

  indim = 0
  CALL define_var("rho_bdy_Ti","R",indim,idims, &
         "location beyond which Ti is known", &
         "-","PLASMA","STATE_DATA", &
         "R rho_bdy_Ti")

  IF(ALLOCATED(ss%rho_ecrf)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_ecrf",idims(indim))
     CALL define_var("rho_ecrf","R",indim,idims, &
            "rho grid -- ECRF", &
            "-","EC","SIMULATION_INIT", &
            "G  rho_ecrf(nrho_ecrf)")
  ENDIF

  IF(ALLOCATED(ss%rho_eq)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_eq",idims(indim))
     CALL define_var("rho_eq","R",indim,idims, &
            "rho grid (EQ)", &
            "-","EQ","SIMULATION_INIT", &
            "G   rho_eq(nrho_eq)")
  ENDIF

  IF(ALLOCATED(ss%rho_eq_geo)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_eq_geo",idims(indim))
     CALL define_var("rho_eq_geo","R",indim,idims, &
            "rho grid (EQ flux surface averages)", &
            "-","EQ","SIMULATION_INIT", &
            "G   rho_eq_geo(nrho_eq_geo)")
  ENDIF

  IF(ALLOCATED(ss%rho_fus)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_fus",idims(indim))
     CALL define_var("rho_fus","R",indim,idims, &
            "rho grid -- Fusion products model", &
            "-","FUS","SIMULATION_INIT", &
            "G  rho_fus(nrho_fus)")
  ENDIF

  IF(ALLOCATED(ss%rho_gas)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_gas",idims(indim))
     CALL define_var("rho_gas","R",indim,idims, &
            "rho grid (GAS -- neutral gas model)", &
            "-","GAS","SIMULATION_INIT", &
            "G  rho_gas(nrho_gas)")
  ENDIF

  IF(ALLOCATED(ss%rho_icrf)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_icrf",idims(indim))
     CALL define_var("rho_icrf","R",indim,idims, &
            "rho grid (RF)", &
            "-","IC","SIMULATION_INIT", &
            "G  rho_icrf(nrho_icrf)")
  ENDIF

  IF(ALLOCATED(ss%rho_lhrf)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_lhrf",idims(indim))
     CALL define_var("rho_lhrf","R",indim,idims, &
            "rho grid -- LHRF", &
            "-","LH","SIMULATION_INIT", &
            "G  rho_lhrf(nrho_lhrf)")
  ENDIF

  IF(ALLOCATED(ss%rho_lmhd)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_lmhd",idims(indim))
     CALL define_var("rho_lmhd","R",indim,idims, &
            "rho grid (LMHD component)", &
            "-","LMHD","SIMULATION_INIT", &
            "G  rho_lmhd(nrho_lmhd)")
  ENDIF

  IF(ALLOCATED(ss%rho_mist)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_mist",idims(indim))
     CALL define_var("rho_mist","R",indim,idims, &
            "rho grid (PLASMA) impurity-driven sources", &
            "-","RAD","SIMULATION_INIT", &
            "G  rho_mist(nrho_mist)")
  ENDIF

  IF(ALLOCATED(ss%rho_nbi)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_nbi",idims(indim))
     CALL define_var("rho_nbi","R",indim,idims, &
            "rho grid -- NBI", &
            "-","NBI","SIMULATION_INIT", &
            "G  rho_nbi(nrho_nbi)")
  ENDIF

  IF(ALLOCATED(ss%rho_pel)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_pel",idims(indim))
     CALL define_var("rho_pel","R",indim,idims, &
            "rho grid -- PEL", &
            "-","PEL","SIMULATION_INIT", &
            "G  rho_pel(nrho_pel)")
  ENDIF

  IF(ALLOCATED(ss%rho_rad)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_rad",idims(indim))
     CALL define_var("rho_rad","R",indim,idims, &
            "rho grid (RAD)", &
            "-","RAD","SIMULATION_INIT", &
            "G  rho_rad(nrho_rad)")
  ENDIF

  IF(ALLOCATED(ss%rho_rw)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_rw",idims(indim))
     CALL define_var("rho_rw","R",indim,idims, &
            "rho grid -- RUNAWAY electrons", &
            "-","RUNAWAY","SIMULATION_INIT", &
            "G  rho_rw(nrho_rw)")
  ENDIF

  IF(ALLOCATED(ss%rlim)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_num_rzlim",idims(indim))
     CALL define_var("rlim","R",indim,idims, &
            "R points in closed (R,Z) contour sequence", &
            "m","EQ","MACHINE_DESCRIPTION", &
            "R|units=m  rlim(num_rzlim)")
  ENDIF

  CONTAINS


     SUBROUTINE define_var(name,dtype,indim,idims, &
          long_name,units,component,section,spec)

        CHARACTER*(*), INTENT(in) :: name
        CHARACTER*(*), INTENT(in) :: dtype
        INTEGER, INTENT(in) :: indim
        INTEGER, dimension(:), INTENT(in) :: idims
        CHARACTER*(*), INTENT(in) :: long_name
        CHARACTER*(*), INTENT(in) :: units
        CHARACTER*(*), INTENT(in) :: component
        CHARACTER*(*), INTENT(in) :: section
        CHARACTER*(*), INTENT(in) :: spec

        integer :: itype

        IF(dtype.EQ.'R') THEN
           itype = NF90_DOUBLE

        ELSE IF (dtype.EQ.'I') THEN
           itype = NF90_INT

        ELSE
           itype = NF90_CHAR

        ENDIF

        IF(indim.EQ.0) THEN
           status=nf90_def_var(icdf,name,itype, varid=varid)

        ELSE
           status=nf90_def_var(icdf,name,itype, dimids=idims(1:indim),varid=varid)

        ENDIF

        IF(status.NE.NF90_NOERR) THEN
           WRITE(iout,*) " ?plasma_state_store: error defining variable: "//trim(name)
           CALL ncerr(status)
           iertot = iertot + 1
           RETURN
        ENDIF

        ! Variable OK, now add attributes:

        CALL add_attrib("long_name",long_name)
        IF(dtype.EQ.'R') CALL add_attrib("units",units)
        CALL add_attrib("component",component)
        CALL add_attrib("section",section)
        CALL add_attrib("specification",spec)

     END SUBROUTINE define_var

     SUBROUTINE add_attrib(name,value)
        CHARACTER*(*), intent(in) :: name
        CHARACTER*(*), intent(in) :: value

        status=nf90_put_att(icdf,varid,name,value)
        IF(status.NE.NF90_NOERR) THEN
           WRITE(iout,*) " ?plasma_state_store: error defining attribute: "//trim(name)//' = '//trim(value)
           CALL ncerr(status)
           iertot = iertot + 1
        ENDIF
     END SUBROUTINE add_attrib

     SUBROUTINE ncerr(status)
        INTEGER, INTENT(in) :: status

        nc_errmsg = NF90_strerror(status)
        write(iout,*) '  NetCDF message: ',trim(nc_errmsg)
     END SUBROUTINE ncerr

END SUBROUTINE plasma_state_store_def_6


SUBROUTINE plasma_state_store_6(ss,icdf,iout,iertot)


  !  write subset of variables and arrays from NetCDF file

  USE plasma_state_definition_mod
  USE netcdf
  IMPLICIT NONE

  TYPE (plasma_state) :: ss     ! state data to read
  INTEGER, INTENT(IN) :: icdf   ! NetCDF file ID
  INTEGER, INTENT(IN) :: iout   ! message LUN
  INTEGER, INTENT(INOUT) :: iertot  ! error count

  !--------------

  INTEGER :: varid,dimid,status,ival,idims(20),indim
  CHARACTER*80 :: nc_errmsg

  !--------------
  !  write variables...


  IF(ALLOCATED(ss%PsiRZ)) THEN
     status = nf90_inq_varid(icdf,"PsiRZ",varid)
     status = nf90_put_var(icdf,varid,ss%PsiRZ)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: PsiRZ"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Psi_to_machine_axis",varid)
  status = nf90_put_var(icdf,varid,ss%Psi_to_machine_axis)
  IF(status.NE.NF90_NOERR) THEN
     WRITE(iout,*) " ?plasma_state_store: error storing: Psi_to_machine_axis"
     CALL ncerr(status)
     iertot = iertot + 1
  ENDIF

  IF(ALLOCATED(ss%psmom_errck)) THEN
     status = nf90_inq_varid(icdf,"psmom_errck",varid)
     status = nf90_put_var(icdf,varid,ss%psmom_errck)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: psmom_errck"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%psmom_nc)) THEN
     status = nf90_inq_varid(icdf,"psmom_nc",varid)
     status = nf90_put_var(icdf,varid,ss%psmom_nc)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: psmom_nc"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%psmom_num)) THEN
     status = nf90_inq_varid(icdf,"psmom_num",varid)
     status = nf90_put_var(icdf,varid,ss%psmom_num)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: psmom_num"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%P_eq)) THEN
     status = nf90_inq_varid(icdf,"P_eq",varid)
     status = nf90_put_var(icdf,varid,ss%P_eq)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: P_eq"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%qatom_ALL)) THEN
     status = nf90_inq_varid(icdf,"qatom_ALL",varid)
     status = nf90_put_var(icdf,varid,ss%qatom_ALL)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: qatom_ALL"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%qatom_ALLA)) THEN
     status = nf90_inq_varid(icdf,"qatom_ALLA",varid)
     status = nf90_put_var(icdf,varid,ss%qatom_ALLA)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: qatom_ALLA"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%qatom_RFMIN)) THEN
     status = nf90_inq_varid(icdf,"qatom_RFMIN",varid)
     status = nf90_put_var(icdf,varid,ss%qatom_RFMIN)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: qatom_RFMIN"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%qatom_S)) THEN
     status = nf90_inq_varid(icdf,"qatom_S",varid)
     status = nf90_put_var(icdf,varid,ss%qatom_S)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: qatom_S"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%qatom_SA)) THEN
     status = nf90_inq_varid(icdf,"qatom_SA",varid)
     status = nf90_put_var(icdf,varid,ss%qatom_SA)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: qatom_SA"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%qatom_SFUS)) THEN
     status = nf90_inq_varid(icdf,"qatom_SFUS",varid)
     status = nf90_put_var(icdf,varid,ss%qatom_SFUS)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: qatom_SFUS"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%qatom_SGAS)) THEN
     status = nf90_inq_varid(icdf,"qatom_SGAS",varid)
     status = nf90_put_var(icdf,varid,ss%qatom_SGAS)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: qatom_SGAS"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%qatom_SIMP0)) THEN
     status = nf90_inq_varid(icdf,"qatom_SIMP0",varid)
     status = nf90_put_var(icdf,varid,ss%qatom_SIMP0)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: qatom_SIMP0"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%qatom_SIMPI)) THEN
     status = nf90_inq_varid(icdf,"qatom_SIMPI",varid)
     status = nf90_put_var(icdf,varid,ss%qatom_SIMPI)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: qatom_SIMPI"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%qatom_SNBI)) THEN
     status = nf90_inq_varid(icdf,"qatom_SNBI",varid)
     status = nf90_put_var(icdf,varid,ss%qatom_SNBI)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: qatom_SNBI"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%qbeami)) THEN
     status = nf90_inq_varid(icdf,"qbeami",varid)
     status = nf90_put_var(icdf,varid,ss%qbeami)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: qbeami"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%qcomp_e)) THEN
     status = nf90_inq_varid(icdf,"qcomp_e",varid)
     status = nf90_put_var(icdf,varid,ss%qcomp_e)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: qcomp_e"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%qcomp_i)) THEN
     status = nf90_inq_varid(icdf,"qcomp_i",varid)
     status = nf90_put_var(icdf,varid,ss%qcomp_i)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: qcomp_i"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%qie)) THEN
     status = nf90_inq_varid(icdf,"qie",varid)
     status = nf90_put_var(icdf,varid,ss%qie)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: qie"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%qioniz)) THEN
     status = nf90_inq_varid(icdf,"qioniz",varid)
     status = nf90_put_var(icdf,varid,ss%qioniz)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: qioniz"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%ql_operator)) THEN
     status = nf90_inq_varid(icdf,"ql_operator",varid)
     status = nf90_put_var(icdf,varid,ss%ql_operator)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: ql_operator"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%qqcx)) THEN
     status = nf90_inq_varid(icdf,"qqcx",varid)
     status = nf90_put_var(icdf,varid,ss%qqcx)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: qqcx"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%qrot_conv)) THEN
     status = nf90_inq_varid(icdf,"qrot_conv",varid)
     status = nf90_put_var(icdf,varid,ss%qrot_conv)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: qrot_conv"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%qrot_diff)) THEN
     status = nf90_inq_varid(icdf,"qrot_diff",varid)
     status = nf90_put_var(icdf,varid,ss%qrot_diff)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: qrot_diff"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%q_ALL)) THEN
     status = nf90_inq_varid(icdf,"q_ALL",varid)
     status = nf90_put_var(icdf,varid,ss%q_ALL)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: q_ALL"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%q_ALLA)) THEN
     status = nf90_inq_varid(icdf,"q_ALLA",varid)
     status = nf90_put_var(icdf,varid,ss%q_ALLA)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: q_ALLA"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%q_eq)) THEN
     status = nf90_inq_varid(icdf,"q_eq",varid)
     status = nf90_put_var(icdf,varid,ss%q_eq)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: q_eq"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%q_RFMIN)) THEN
     status = nf90_inq_varid(icdf,"q_RFMIN",varid)
     status = nf90_put_var(icdf,varid,ss%q_RFMIN)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: q_RFMIN"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%q_S)) THEN
     status = nf90_inq_varid(icdf,"q_S",varid)
     status = nf90_put_var(icdf,varid,ss%q_S)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: q_S"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%q_SA)) THEN
     status = nf90_inq_varid(icdf,"q_SA",varid)
     status = nf90_put_var(icdf,varid,ss%q_SA)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: q_SA"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%q_SFUS)) THEN
     status = nf90_inq_varid(icdf,"q_SFUS",varid)
     status = nf90_put_var(icdf,varid,ss%q_SFUS)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: q_SFUS"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%q_SGAS)) THEN
     status = nf90_inq_varid(icdf,"q_SGAS",varid)
     status = nf90_put_var(icdf,varid,ss%q_SGAS)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: q_SGAS"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%q_SIMP0)) THEN
     status = nf90_inq_varid(icdf,"q_SIMP0",varid)
     status = nf90_put_var(icdf,varid,ss%q_SIMP0)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: q_SIMP0"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%q_SIMPI)) THEN
     status = nf90_inq_varid(icdf,"q_SIMPI",varid)
     status = nf90_put_var(icdf,varid,ss%q_SIMPI)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: q_SIMPI"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%q_SNBI)) THEN
     status = nf90_inq_varid(icdf,"q_SNBI",varid)
     status = nf90_put_var(icdf,varid,ss%q_SNBI)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: q_SNBI"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%R0_momeq)) THEN
     status = nf90_inq_varid(icdf,"R0_momeq",varid)
     status = nf90_put_var(icdf,varid,ss%R0_momeq)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: R0_momeq"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"RAD_Code_Info",varid)
  status = nf90_put_var(icdf,varid,ss%RAD_Code_Info)
  IF(status.NE.NF90_NOERR) THEN
     WRITE(iout,*) " ?plasma_state_store: error storing: RAD_Code_Info"
     CALL ncerr(status)
     iertot = iertot + 1
  ENDIF

  status = nf90_inq_varid(icdf,"RAD_Data_Info",varid)
  status = nf90_put_var(icdf,varid,ss%RAD_Data_Info)
  IF(status.NE.NF90_NOERR) THEN
     WRITE(iout,*) " ?plasma_state_store: error storing: RAD_Data_Info"
     CALL ncerr(status)
     iertot = iertot + 1
  ENDIF

  IF(ALLOCATED(ss%rate_sinb0i)) THEN
     status = nf90_inq_varid(icdf,"rate_sinb0i",varid)
     status = nf90_put_var(icdf,varid,ss%rate_sinb0i)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: rate_sinb0i"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%rate_sinb0x)) THEN
     status = nf90_inq_varid(icdf,"rate_sinb0x",varid)
     status = nf90_put_var(icdf,varid,ss%rate_sinb0x)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: rate_sinb0x"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%rate_sinb0xs)) THEN
     status = nf90_inq_varid(icdf,"rate_sinb0xs",varid)
     status = nf90_put_var(icdf,varid,ss%rate_sinb0xs)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: rate_sinb0xs"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%rate_sinf0i)) THEN
     status = nf90_inq_varid(icdf,"rate_sinf0i",varid)
     status = nf90_put_var(icdf,varid,ss%rate_sinf0i)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: rate_sinf0i"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%rate_sinf0x)) THEN
     status = nf90_inq_varid(icdf,"rate_sinf0x",varid)
     status = nf90_put_var(icdf,varid,ss%rate_sinf0x)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: rate_sinf0x"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%rate_sinf0xs)) THEN
     status = nf90_inq_varid(icdf,"rate_sinf0xs",varid)
     status = nf90_put_var(icdf,varid,ss%rate_sinf0xs)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: rate_sinf0xs"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%Real_ant_coef)) THEN
     status = nf90_inq_varid(icdf,"Real_ant_coef",varid)
     status = nf90_put_var(icdf,varid,ss%Real_ant_coef)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: Real_ant_coef"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%res_sn)) THEN
     status = nf90_inq_varid(icdf,"res_sn",varid)
     status = nf90_put_var(icdf,varid,ss%res_sn)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: res_sn"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%res_te)) THEN
     status = nf90_inq_varid(icdf,"res_te",varid)
     status = nf90_put_var(icdf,varid,ss%res_te)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: res_te"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%res_ti)) THEN
     status = nf90_inq_varid(icdf,"res_ti",varid)
     status = nf90_put_var(icdf,varid,ss%res_ti)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: res_ti"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%res_tq)) THEN
     status = nf90_inq_varid(icdf,"res_tq",varid)
     status = nf90_put_var(icdf,varid,ss%res_tq)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: res_tq"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%RFMIN_name)) THEN
     status = nf90_inq_varid(icdf,"RFMIN_name",varid)
     status = nf90_put_var(icdf,varid,ss%RFMIN_name)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: RFMIN_name"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%rfmin_to_all)) THEN
     status = nf90_inq_varid(icdf,"rfmin_to_all",varid)
     status = nf90_put_var(icdf,varid,ss%rfmin_to_all)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: rfmin_to_all"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%rfmin_to_alla)) THEN
     status = nf90_inq_varid(icdf,"rfmin_to_alla",varid)
     status = nf90_put_var(icdf,varid,ss%rfmin_to_alla)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: rfmin_to_alla"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%RFMIN_type)) THEN
     status = nf90_inq_varid(icdf,"RFMIN_type",varid)
     status = nf90_put_var(icdf,varid,ss%RFMIN_type)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: RFMIN_type"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%rho)) THEN
     status = nf90_inq_varid(icdf,"rho",varid)
     status = nf90_put_var(icdf,varid,ss%rho)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: rho"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%rhopsi0lh)) THEN
     status = nf90_inq_varid(icdf,"rhopsi0lh",varid)
     status = nf90_put_var(icdf,varid,ss%rhopsi0lh)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: rhopsi0lh"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%rho_anom)) THEN
     status = nf90_inq_varid(icdf,"rho_anom",varid)
     status = nf90_put_var(icdf,varid,ss%rho_anom)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: rho_anom"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%rho_anom2)) THEN
     status = nf90_inq_varid(icdf,"rho_anom2",varid)
     status = nf90_put_var(icdf,varid,ss%rho_anom2)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: rho_anom2"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%rho_anomth)) THEN
     status = nf90_inq_varid(icdf,"rho_anomth",varid)
     status = nf90_put_var(icdf,varid,ss%rho_anomth)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: rho_anomth"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%rho_bdy_ns)) THEN
     status = nf90_inq_varid(icdf,"rho_bdy_ns",varid)
     status = nf90_put_var(icdf,varid,ss%rho_bdy_ns)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: rho_bdy_ns"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"rho_bdy_omegat",varid)
  status = nf90_put_var(icdf,varid,ss%rho_bdy_omegat)
  IF(status.NE.NF90_NOERR) THEN
     WRITE(iout,*) " ?plasma_state_store: error storing: rho_bdy_omegat"
     CALL ncerr(status)
     iertot = iertot + 1
  ENDIF

  status = nf90_inq_varid(icdf,"rho_bdy_Te",varid)
  status = nf90_put_var(icdf,varid,ss%rho_bdy_Te)
  IF(status.NE.NF90_NOERR) THEN
     WRITE(iout,*) " ?plasma_state_store: error storing: rho_bdy_Te"
     CALL ncerr(status)
     iertot = iertot + 1
  ENDIF

  status = nf90_inq_varid(icdf,"rho_bdy_Ti",varid)
  status = nf90_put_var(icdf,varid,ss%rho_bdy_Ti)
  IF(status.NE.NF90_NOERR) THEN
     WRITE(iout,*) " ?plasma_state_store: error storing: rho_bdy_Ti"
     CALL ncerr(status)
     iertot = iertot + 1
  ENDIF

  IF(ALLOCATED(ss%rho_ecrf)) THEN
     status = nf90_inq_varid(icdf,"rho_ecrf",varid)
     status = nf90_put_var(icdf,varid,ss%rho_ecrf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: rho_ecrf"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%rho_eq)) THEN
     status = nf90_inq_varid(icdf,"rho_eq",varid)
     status = nf90_put_var(icdf,varid,ss%rho_eq)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: rho_eq"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%rho_eq_geo)) THEN
     status = nf90_inq_varid(icdf,"rho_eq_geo",varid)
     status = nf90_put_var(icdf,varid,ss%rho_eq_geo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: rho_eq_geo"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%rho_fus)) THEN
     status = nf90_inq_varid(icdf,"rho_fus",varid)
     status = nf90_put_var(icdf,varid,ss%rho_fus)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: rho_fus"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%rho_gas)) THEN
     status = nf90_inq_varid(icdf,"rho_gas",varid)
     status = nf90_put_var(icdf,varid,ss%rho_gas)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: rho_gas"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%rho_icrf)) THEN
     status = nf90_inq_varid(icdf,"rho_icrf",varid)
     status = nf90_put_var(icdf,varid,ss%rho_icrf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: rho_icrf"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%rho_lhrf)) THEN
     status = nf90_inq_varid(icdf,"rho_lhrf",varid)
     status = nf90_put_var(icdf,varid,ss%rho_lhrf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: rho_lhrf"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%rho_lmhd)) THEN
     status = nf90_inq_varid(icdf,"rho_lmhd",varid)
     status = nf90_put_var(icdf,varid,ss%rho_lmhd)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: rho_lmhd"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%rho_mist)) THEN
     status = nf90_inq_varid(icdf,"rho_mist",varid)
     status = nf90_put_var(icdf,varid,ss%rho_mist)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: rho_mist"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%rho_nbi)) THEN
     status = nf90_inq_varid(icdf,"rho_nbi",varid)
     status = nf90_put_var(icdf,varid,ss%rho_nbi)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: rho_nbi"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%rho_pel)) THEN
     status = nf90_inq_varid(icdf,"rho_pel",varid)
     status = nf90_put_var(icdf,varid,ss%rho_pel)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: rho_pel"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%rho_rad)) THEN
     status = nf90_inq_varid(icdf,"rho_rad",varid)
     status = nf90_put_var(icdf,varid,ss%rho_rad)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: rho_rad"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%rho_rw)) THEN
     status = nf90_inq_varid(icdf,"rho_rw",varid)
     status = nf90_put_var(icdf,varid,ss%rho_rw)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: rho_rw"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%rlim)) THEN
     status = nf90_inq_varid(icdf,"rlim",varid)
     status = nf90_put_var(icdf,varid,ss%rlim)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: rlim"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  CONTAINS


     SUBROUTINE ncerr(status)
        INTEGER, INTENT(in) :: status

        nc_errmsg = NF90_strerror(status)
        write(iout,*) '  NetCDF message: ',trim(nc_errmsg)
     END SUBROUTINE ncerr

END SUBROUTINE plasma_state_store_6

subroutine ps_momtest(ss,iout,ierr)

  ! Test routine: compare xplasma and plasma state Fourier Spline (FS)
  ! equilibrium representations -- they should match

  ! Then, using Plasma State tools compare FS and bicubic spline evaluations
  ! for flux surface values: {R,Z,dR/drho,dZ/drho,dR/dth,dZ/dth}

  use plasma_state_mod
  use xplasma_definitions
  implicit NONE

  TYPE (plasma_state) :: ss     ! state instance from which to load
  INTEGER, intent(in) :: iout   ! I/O channel for messages

  INTEGER, intent(out) :: ierr  ! completion status (0=OK)

  !-----------------------------
  !  type definition -- enable acquisition of xplasma pointer from PS object

  INTEGER, PARAMETER :: R8=SELECTED_REAL_KIND(12,100)

  type :: interp_object
     type (xplasma), pointer :: s_xpobj => NULL()
  end type interp_object

  type (interp_object) :: xobj
  type (xplasma), pointer :: s

  integer :: imom,kmom,iflag,inrho,ict,irho,ids(4)
  real*8, dimension(:), allocatable :: rhobuf
  real*8, dimension(:,:), allocatable :: test1,test2
  integer :: imax0,imax1
  real*8 :: max_diff0, max_diff1
  real*8 :: cpt1,cpt2

  real*8, parameter :: tol_ref0 = 1.0e-11_R8
  real*8, parameter :: tol_ref1 = 1.0e-7_R8

  !-----------------------------
  !  for evaluation comparisons

  integer, parameter :: nkm_vals = 4
  integer, parameter :: nth = 201
  integer, parameter :: nsurfs = 10 

  integer :: isurf,ith,ik,imoms

  integer :: ikm_vals(nkm_vals) = (/ 0, 4, 16, 64 /)

  real*8 :: rhosurfs(nsurfs) = &
       (/ 0.1_R8,  0.3_R8,  0.5_R8,  0.7_R8,  0.9_R8, &
          0.95_R8, 0.97_R8, 0.98_R8, 0.99_R8, 1.0_R8 /)

  real*8 :: rhovec(nth),thvec(nth)
  real*8 :: Rvec(nth,nkm_vals),Zvec(nth,nkm_vals)
  real*8 :: Rvec2(nth,nkm_vals),Zvec2(nth,nkm_vals)
  real*8 :: dRdrho(nth,nkm_vals),dZdrho(nth,nkm_vals)
  real*8 :: dRdth(nth,nkm_vals),dZdth(nth,nkm_vals)

  real*8 :: RR1,RRmin,RRmax,ZZmin,ZZmax
  real*8 :: val_norm    ! val_norm = (RRmax+RRmin)/2
  real*8 :: deriv_norm  ! deriv_norm = max((RRmax-RRmin),(ZZmax-ZZmin))/2
  real*8 :: diftabv(nsurfs,nkm_vals-1),diftabd(nsurfs,nkm_vals-1)
  real*8 :: dR,dZ,dd(4)
  !-----------------------------

  !=====================================================================
  !  check that state has associated xplasma object; set pointer.

  call cpu_time(cpt1)

  write(iout,*) ' '
  if(ps_debug.ge.2) then
     write(iout,*) ' Entering: ps_momtest; ss%global_label = "'// &
          trim(ss%global_label)//'".'
  else
     write(iout,*) ' (ps_momtest...) '
  endif

  xobj = transfer(ss%iobj,xobj)
  s => xobj%s_xpobj

  call xpmom_info(s,ierr, kmom=kmom)
  if(ierr.ne.0) then
     call xplasma_error(s,ierr,iout)
     write(iout,*) ' ?xplasma error in ps_momtest, early exit.'
     return
  endif

  iflag=0
  if(ss%neqmom.eq.0) then
     write(iout,*) ' %ps_momtest: no FS moments in passed Plasma State object'
     iflag=1
  endif

  if(kmom.eq.0) then
     write(iout,*) ' %ps_momtest: no FS moments in state contained xplasma object'
     iflag=1
  endif

  if(iflag.eq.1) return

  if(kmom.ne.ss%neqmom) then
     ierr=1
     write(iout,*) ' ?ps_momtest: FS moments number mismatch btw Plasma State'
     write(iout,*) '  and contained xplasma object: ',ss%neqmom,kmom
     return
  endif

  ! construct test grid & buffers

  inrho = 2*ss%nrho_eq - 1
  allocate(rhobuf(inrho),test1(inrho,4),test2(inrho,4))

  ict=0
  do irho=1,inrho,2
     ict=ict+1
     rhobuf(irho) = ss%rho_eq(ict)
     if(ict.gt.1) then
        rhobuf(irho-1) = 0.5d0*(rhobuf(irho)+rhobuf(irho-2))
     endif
  enddo

  ! OK: compare 0th moments

  imax0 = -1
  imax1 = -1
  max_diff0 = 0.0d0
  max_diff1 = 0.0d0

  ids(1)=ss%id_R0_momeq
  ids(2)=ss%id_Z0_momeq
  ids(3)=0
  ids(4)=0

  call diff(0)
  if(ierr.ne.0) return

  ! compare higher moments

  do imom=1,kmom
     ids(1)=ss%id_xRjcos_momeq(imom)
     ids(2)=ss%id_xZjcos_momeq(imom)
     ids(3)=ss%id_xRjsin_momeq(imom)
     ids(4)=ss%id_xZjsin_momeq(imom)
     call diff(imom)
     if(ierr.ne.0) return
  enddo

  if(max_diff0.gt.tol_ref0) then
     write(iout,*) ' ?xp_momtest: max coefficient value difference exceeds reference'
     write(iout,'(1x,a,i4,a,1pe12.5)') '  moment #',imax0,':',max_diff0
     ierr = 1
  else
     write(iout,'(a,1pe12.5)') ' %xp_momtest: max coeff value diff OK: ', &
          max_diff0
  endif

  if(max_diff1.gt.tol_ref1) then
     write(iout,*) ' ?xp_momtest: max coefficient derivative difference exceeds reference'
     write(iout,'(1x,a,i4,a,1pe12.5)') '  moment #',imax0,':',max_diff1
     ierr = 1
  else
     write(iout,'(a,1pe12.5)') ' %xp_momtest: max coeff deriv diff OK: ', &
          max_diff1
  endif
  !--------------------------------------------------
  !  evaluation comparisons

  do ith=1,nth
     thvec(ith) = (ith-1)*6.2831853071795862_R8/(nth-1)
  enddo

  diftabv = 0.0_R8
  diftabd = 0.0_R8

  do isurf = 1,nsurfs
     rhovec(1:nth) = rhosurfs(isurf)

     do ik=1,nkm_vals
        imoms=ikm_vals(ik)

        call ps_rz_eval(rhovec,thvec,ierr, state=ss, fs_kmax=imoms, &
             R=Rvec(:,ik), Z=Zvec(:,ik))
        if(ierr.ne.0) return

        call ps_rz_eval(rhovec,thvec,ierr, state=ss, fs_kmax=imoms, &
             R=Rvec2(:,ik), Z=Zvec2(:,ik), &
             dRdrho=dRdrho(:,ik), dZdrho=dZdrho(:,ik), &
             dRdth=dRdth(:,ik), dZdth=dZdth(:,ik))
        if(ierr.ne.0) return

        ! preliminary check

        max_diff0 = 0.0_R8
        if((isurf.eq.1).and.(imoms.eq.0)) then
           RRmin=Rvec(1,ik)
           RRmax=RRmin
           RR1=max(1.0_R8,RRmin)
           ZZmin=Zvec(1,ik)
           ZZmax=ZZmin
        endif

        do ith=1,nth
           if(imoms.eq.0) then
              RRmin=min(RRmin,Rvec(ith,ik))
              RRmax=max(RRmax,Rvec(ith,ik))
              ZZmin=min(ZZmin,Zvec(ith,ik))
              ZZmax=max(ZZmax,Zvec(ith,ik))
           endif
           max_diff0 = max(max_diff0,abs(Rvec(ith,ik)-Rvec2(ith,ik))/RR1)
           max_diff0 = max(max_diff0,abs(Zvec(ith,ik)-Zvec2(ith,ik))/RR1)
           if(ik.gt.1) then
              dR=abs(Rvec(ith,ik)-Rvec(ith,1))
              dZ=abs(Zvec(ith,ik)-Zvec(ith,1))

              dd(1)=abs(dRdrho(ith,ik)-dRdrho(ith,1))
              dd(2)=abs(dZdrho(ith,ik)-dZdrho(ith,1))
              dd(3)=abs(dRdth(ith,ik)-dRdth(ith,1))
              dd(4)=abs(dZdth(ith,ik)-dZdth(ith,1))

              diftabv(isurf,ik-1)=max(diftabv(isurf,ik-1),dR)
              diftabv(isurf,ik-1)=max(diftabv(isurf,ik-1),dZ)
              diftabd(isurf,ik-1)=max(diftabd(isurf,ik-1),maxval(dd))
           endif
        enddo

        if(max_diff0.gt.tol_ref0) then
           write(iout,*) ' ?ps_momtest: unexpected difference in ps_RZ_eval results... '
           ierr=1
           return
        endif

     enddo
  enddo
     
  val_norm = (RRmax+RRmin)/2
  val_norm = max(1.0e-4_R8,val_norm)

  deriv_norm = max((RRmax-RRmin),(ZZmax-ZZmin))/2
  deriv_norm = max(1.0e-4_R8,deriv_norm)

  diftabv = diftabv/val_norm
  diftabd = diftabd/deriv_norm

  call diftab_print(diftabv,'Normalized maximum deviation in {R,Z}')
  call diftab_print(diftabd,'Normalized maximum deviation in {dR/drho,dZ/drho,dR/dth,dZ/dth}')

  !--------------------------------------------------
  call cpu_time(cpt2)

  write(iout,'(/1x,a,t34,1pe10.3)') 'Time for ps_momtest: ', cpt2-cpt1

CONTAINS

  subroutine diff(imom)

    integer, intent(in) :: imom

    !--------------------
    ! value comparison

    if(imom.eq.0) then

       test1 = 0.0d0
       test2 = 0.0d0

       call xpmom_get1(s,rhobuf,1,imom,ierr, &
            rcmom=test1(:,1), zcmom=test1(:,2), ideriv=0)

       if(ierr.ne.0) then
          call xplasma_error(s,ierr,iout)
          write(iout,*) '  moment #: ',imom
          return
       endif

       call ps_intrp_1d(rhobuf,ids(1:2),test2(:,1:2),ierr, state=ss, ideriv=0)

       if(ierr.ne.0) then
          write(iout,*) ' ?ps_momtest: ps_intrp_1d error code: ',ierr
          write(iout,*) '  moment #: ',imom
          return
       endif
            
    else

       call xpmom_get1(s,rhobuf,1,imom,ierr, &
            rcmom=test1(:,1), zcmom=test1(:,2), &
            rsmom=test1(:,3), zsmom=test1(:,4), &
            ideriv=0)

       if(ierr.ne.0) then
          call xplasma_error(s,ierr,iout)
          write(iout,*) '  moment #: ',imom
          return
       endif

       call ps_intrp_1d(rhobuf,ids,test2,ierr, state=ss, ideriv=0)

       if(ierr.ne.0) then
          write(iout,*) ' ?ps_momtest: ps_intrp_1d error code: ',ierr
          write(iout,*) '  moment #: ',imom
          return
       endif
            
    endif

    call compare(imom,0,max_diff0,imax0)

    !--------------------
    ! derivative comparison

    if(imom.eq.0) then

       test1 = 0.0d0
       test2 = 0.0d0

       call xpmom_get1(s,rhobuf,1,imom,ierr, &
            rcmom=test1(:,1), zcmom=test1(:,2), ideriv=1)

       if(ierr.ne.0) then
          call xplasma_error(s,ierr,iout)
          write(iout,*) '  moment #: ',imom
          return
       endif

       call ps_intrp_1d(rhobuf,ids(1:2),test2(:,1:2),ierr, state=ss, ideriv=1)

       if(ierr.ne.0) then
          write(iout,*) ' ?ps_momtest(deriv): ps_intrp_1d error code: ',ierr
          write(iout,*) '  moment #: ',imom
          return
       endif
            
    else

       call xpmom_get1(s,rhobuf,1,imom,ierr, &
            rcmom=test1(:,1), zcmom=test1(:,2), &
            rsmom=test1(:,3), zsmom=test1(:,4), &
            ideriv=1)

       if(ierr.ne.0) then
          call xplasma_error(s,ierr,iout)
          write(iout,*) '  moment #: ',imom
          return
       endif

       call ps_intrp_1d(rhobuf,ids,test2,ierr, state=ss, ideriv=1)

       if(ierr.ne.0) then
          write(iout,*) ' ?ps_momtest(deriv): ps_intrp_1d error code: ',ierr
          write(iout,*) '  moment #: ',imom
          return
       endif
            
    endif

    call compare(imom,1,max_diff1,imax1)

  end subroutine diff

  subroutine compare(imom,ideriv,zmax,imax)

    integer, intent(in) :: imom  ! moment index of comparison
    integer, intent(in) :: ideriv  ! 0 for value, 1 for derivative comparison

    real*8, intent(inout) :: zmax  ! max difference seen
    integer, intent(inout) :: imax ! moment index of max difference seen

    real*8 :: zref
    character*40 :: label,dlabel
    character*3 :: zint

    if(ideriv.eq.0) then
       zref = tol_ref0
       dlabel = '(value)'
    else
       zref = tol_ref1
       dlabel = '(derivative)'
    endif

    zint=' '
    if(imom.le.9) then
       write(zint(1:1),'(I1)') imom
    else if(imom.le.99) then
       write(zint(1:2),'(I2)') imom
    else
       write(zint(1:3),'(I3)') imom
    endif

    label = 'R'//trim(zint)//' cos moment '//trim(dlabel)
    call compare1(label,test1(:,1),test2(:,1),imom,zref,zmax,imax)

    label = 'Z'//trim(zint)//' cos moment '//trim(dlabel)
    call compare1(label,test1(:,2),test2(:,2),imom,zref,zmax,imax)

    if(imom.gt.0) then
       label = 'R'//trim(zint)//' sin moment '//trim(dlabel)
       call compare1(label,test1(:,3),test2(:,3),imom,zref,zmax,imax)

       label = 'Z'//trim(zint)//' sin moment '//trim(dlabel)
       call compare1(label,test1(:,4),test2(:,4),imom,zref,zmax,imax)
    endif

  end subroutine compare

  subroutine compare1(label,atest1,atest2,imom,zref,zmax,imax)

    character*(*), intent(in) :: label  ! message label
    real*8, dimension(:), intent(in) :: atest1,atest2  ! data to compare
    integer, intent(in) :: imom  ! moment index of comparison
    real*8, intent(in) :: zref   ! reference maximum relative difference

    real*8, intent(inout) :: zmax  ! max difference seen
    integer, intent(inout) :: imax ! moment index of max difference seen

    !----------------------
    real*8 :: maxa1,maxa2,maxaa,maxdiff
    integer :: iprint
    !----------------------

    maxa1=maxval(abs(atest1))
    maxa2=maxval(abs(atest2))
    maxaa = max(maxa1,maxa2)

    if(maxaa.eq.0.0d0) then
       maxdiff=0.0d0
    else

       maxdiff = maxval(abs(atest1-atest2))/maxaa

    endif

    iprint=0
    if(maxdiff.gt.zref) iprint=1

#ifdef __DEBUG
    iprint=1
#endif

    if(maxdiff.gt.zmax) then
       zmax=maxdiff
       imax=imom
    endif

    if(iprint.eq.1) then
       write(iout,*) ' *** '//trim(label)//' maxdiff: ',maxdiff
    endif

  end subroutine compare1

  subroutine diftab_print(diftab,label)

    real*8, dimension(:,:) :: diftab
    character*(*) :: label

    !-----------------------------
    integer :: iki
    !-----------------------------

    write(iout,*) ' '
    write(iout,*) ' Fourier Spline (FS) // Bicubic Spline evaluation comparison: '
    write(iout,*) ' '//trim(label)
    write(iout,*) ' vs. flux coordinate (rho) and number of FS moments: '
    write(iout,*) ' '
    write(iout,'(6x,a,3(6x,i2,6x))') 'rho',ikm_vals(2),ikm_vals(3),ikm_vals(4)

    do isurf=1,nsurfs
       write(iout,'(1x,f10.3,3(2x,1pe12.5))') rhosurfs(isurf), &
            diftab(isurf,1),diftab(isurf,2),diftab(isurf,3)
    enddo

  end subroutine diftab_print

end subroutine ps_momtest

! f90 interface to random number routine
! Charles Karney <karney@pppl.gov> 1999-09-30 16:58 -0400

#include "config_random.h"

module rngdef
  ! basic definitions
  implicit none
  integer, parameter :: double=selected_real_kind(12)
  integer, parameter :: single=selected_real_kind(6)
  integer, parameter :: rng_k=100, rng_s=8, rng_c=34
  type :: rng_state
     integer :: index
     real(double), dimension(0:rng_k-1) :: array
  end type rng_state
end module rngdef

module rng
  ! the main module 
  use rngdef, only: rng_state, rng_s, rng_c

  interface rng_number
     ! the basic random number routine
     subroutine rng_number_d0(state,x)
       use rngdef
       implicit none
       real(double), intent(out) :: x
       type(rng_state), intent(inout) :: state
     end subroutine rng_number_d0
     subroutine rng_number_d1(state,x)
       use rngdef
       implicit none
       real(double), intent(out), dimension(:) :: x
       type(rng_state), intent(inout) :: state
     end subroutine rng_number_d1
     subroutine rng_number_d2(state,x)
       use rngdef
       implicit none
       real(double), intent(out), dimension(:,:) :: x
       type(rng_state), intent(inout) :: state
     end subroutine rng_number_d2
     subroutine rng_number_d3(state,x)
       use rngdef
       implicit none
       real(double), intent(out), dimension(:,:,:) :: x
       type(rng_state), intent(inout) :: state
     end subroutine rng_number_d3
     subroutine rng_number_s0(state,x)
       use rngdef
       implicit none
       real(single), intent(out) :: x
       type(rng_state), intent(inout) :: state
     end subroutine rng_number_s0
     subroutine rng_number_s1(state,x)
       use rngdef
       implicit none
       real(single), intent(out), dimension(:) :: x
       type(rng_state), intent(inout) :: state
     end subroutine rng_number_s1
     subroutine rng_number_s2(state,x)
       use rngdef
       implicit none
       real(single), intent(out), dimension(:,:) :: x
       type(rng_state), intent(inout) :: state
     end subroutine rng_number_s2
     subroutine rng_number_s3(state,x)
       use rngdef
       implicit none
       real(single), intent(out), dimension(:,:,:) :: x
       type(rng_state), intent(inout) :: state
     end subroutine rng_number_s3
  end interface
  interface rng_gauss
     ! Gaussian random numbers
     subroutine rng_gauss_d0(state,x)
       use rngdef
       implicit none
       real(double), intent(out) :: x
       type(rng_state), intent(inout) :: state
     end subroutine rng_gauss_d0
     subroutine rng_gauss_d1(state,x)
       use rngdef
       implicit none
       real(double), intent(out), dimension(:) :: x
       type(rng_state), intent(inout) :: state
     end subroutine rng_gauss_d1
     subroutine rng_gauss_d2(state,x)
       use rngdef
       implicit none
       real(double), intent(out), dimension(:,:) :: x
       type(rng_state), intent(inout) :: state
     end subroutine rng_gauss_d2
     subroutine rng_gauss_d3(state,x)
       use rngdef
       implicit none
       real(double), intent(out), dimension(:,:,:) :: x
       type(rng_state), intent(inout) :: state
     end subroutine rng_gauss_d3
     subroutine rng_gauss_s0(state,x)
       use rngdef
       implicit none
       real(single), intent(out) :: x
       type(rng_state), intent(inout) :: state
     end subroutine rng_gauss_s0
     subroutine rng_gauss_s1(state,x)
       use rngdef
       implicit none
       real(single), intent(out), dimension(:) :: x
       type(rng_state), intent(inout) :: state
     end subroutine rng_gauss_s1
     subroutine rng_gauss_s2(state,x)
       use rngdef
       implicit none
       real(single), intent(out), dimension(:,:) :: x
       type(rng_state), intent(inout) :: state
     end subroutine rng_gauss_s2
     subroutine rng_gauss_s3(state,x)
       use rngdef
       implicit none
       real(single), intent(out), dimension(:,:,:) :: x
       type(rng_state), intent(inout) :: state
     end subroutine rng_gauss_s3
  end interface

  interface rng_set_seed
     ! setting the random number seed in various ways
     subroutine rng_set_seed_time(seed,time)
       use rngdef
       implicit none
       integer, dimension(rng_s), intent(out) :: seed
       integer, dimension(8), optional, intent(in) :: time
     end subroutine rng_set_seed_time
     subroutine rng_set_seed_int(seed,n)
       use rngdef
       implicit none
       integer, dimension(rng_s), intent(out) :: seed
       integer, intent(in) :: n
     end subroutine rng_set_seed_int
     subroutine rng_set_seed_string(seed,string)
       use rngdef
       implicit none
       integer, dimension(rng_s), intent(out) :: seed
       character(len=*), intent(in) :: string
     end subroutine rng_set_seed_string
  end interface

  interface
     function rng_print_seed(seed)
       ! return the seed in a string representation
       use rngdef
       implicit none
       integer, dimension(rng_s), intent(in) :: seed
       character(len=rng_c) :: rng_print_seed
     end function rng_print_seed
     subroutine rng_init(seed,state)
       ! initialize the state from the seed
       use rngdef
       implicit none
       integer, dimension(rng_s), intent(in) :: seed
       type(rng_state), intent(out) :: state
     end subroutine rng_init
     subroutine rng_step_seed(seed,n0,n1,n2)
       ! step seed forward in 3 dimensions
       use rngdef
       implicit none
       integer, dimension(rng_s), intent(inout) :: seed
       integer, optional, intent(in) :: n0,n1,n2
     end subroutine rng_step_seed
  end interface
end module rng

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


SUBROUTINE plasma_state_empty_alloc(ss,ierr)

  ! incremental allocation
  ! allocate arrays not previously allocated -- only done at initialization.
  !   initialization steps:
  !      0.  declaration of state gives array dimensions values of zero.
  !      1.  set some array dimensions.
  !      2.  call this routine via PS_alloc_state(ierr); arrays with non-
  !          zero dimensioning are allocated.
  !          --ERROR-- if arrays were previously allocated with different
  !          dimension sizes.
  !      3.  based on further calculations or data access, set some more
  !          array dimensions; call this routine again to allocate all
  !          arrays associated with these additional, newly specified
  !          dimensions.  Do not change dimensions already set.  Repeat
  !          until entire structure is allocated and filled in.
  !
  ! It is an error to try to change the size of an already-allocated array.
  !

  USE plasma_state_definition_mod
  IMPLICIT NONE

  TYPE (plasma_state) :: ss    ! state copy to receive empty allocation
  INTEGER, INTENT(OUT) :: ierr  ! completion code (0=OK)

  !-------------------
  INTEGER :: iout,isize,jsize
  !-------------------

  iout = SWIM_err_out_file

  ierr = 0
  !==============================
  ! update enumeration dimension maxima

  IF(ALLOCATED(ss%nrz_antgeo)) THEN
     ss%max_nrz_antgeo = max(ss%max_nrz_antgeo,maxval(ss%nrz_antgeo))
  ENDIF

  IF(ALLOCATED(ss%nspectrumlh_src)) THEN
     ss%max_nspectrumlh_src = max(ss%max_nspectrumlh_src,maxval(ss%nspectrumlh_src))
  ENDIF

  IF(ALLOCATED(ss%num_nphi)) THEN
     ss%max_num_nphi = max(ss%max_num_nphi,maxval(ss%num_nphi))
  ENDIF

  IF(ALLOCATED(ss%num_nphi_vac)) THEN
     ss%max_num_nphi_vac = max(ss%max_num_nphi_vac,maxval(ss%num_nphi_vac))
  ENDIF

  IF(ALLOCATED(ss%n_straps)) THEN
     ss%max_n_straps = max(ss%max_n_straps,maxval(ss%n_straps))
  ENDIF

  !==============================
  ! count dimensions with non-zero values (by component)

  ss%active_dims = 0

  ! count the number of active array dimensions...

  ! component: ANOM:
  IF(ss%nefi_anom.GT.0) ss%active_dims(1) = ss%active_dims(1) + 1
  IF(ss%nefi_anom2.GT.0) ss%active_dims(1) = ss%active_dims(1) + 1
  IF(ss%nky_anomth.GT.0) ss%active_dims(1) = ss%active_dims(1) + 1
  IF(ss%nky_mmm.GT.0) ss%active_dims(1) = ss%active_dims(1) + 1
  IF(ss%nrho_anom.GT.0) ss%active_dims(1) = ss%active_dims(1) + 1
  IF(ss%nrho_anom2.GT.0) ss%active_dims(1) = ss%active_dims(1) + 1
  IF(ss%nrho_anomth.GT.0) ss%active_dims(1) = ss%active_dims(1) + 1

  ! component: EC:
  IF(ss%necrf_src.GT.0) ss%active_dims(2) = ss%active_dims(2) + 1
  IF(ss%nrho_ecrf.GT.0) ss%active_dims(2) = ss%active_dims(2) + 1

  ! component: EQ:
  IF(ss%ncircuits.GT.0) ss%active_dims(3) = ss%active_dims(3) + 1
  IF(ss%ncoils.GT.0) ss%active_dims(3) = ss%active_dims(3) + 1
  IF(ss%neqmom.GT.0) ss%active_dims(3) = ss%active_dims(3) + 1
  IF(ss%npsmom.GT.0) ss%active_dims(3) = ss%active_dims(3) + 1
  IF(ss%nr.GT.0) ss%active_dims(3) = ss%active_dims(3) + 1
  IF(ss%nrho_eq.GT.0) ss%active_dims(3) = ss%active_dims(3) + 1
  IF(ss%nrho_eq_geo.GT.0) ss%active_dims(3) = ss%active_dims(3) + 1
  IF(ss%nth_eq.GT.0) ss%active_dims(3) = ss%active_dims(3) + 1
  IF(ss%num_rzlim.GT.0) ss%active_dims(3) = ss%active_dims(3) + 1
  IF(ss%nz.GT.0) ss%active_dims(3) = ss%active_dims(3) + 1

  ! component: FUS:
  IF(ss%nrho_fus.GT.0) ss%active_dims(4) = ss%active_dims(4) + 1
  IF(ss%nspec_fusion.GT.0) ss%active_dims(4) = ss%active_dims(4) + 1

  ! component: GAS:
  IF(ss%ngsc0.GT.0) ss%active_dims(5) = ss%active_dims(5) + 1
  IF(ss%nrho_gas.GT.0) ss%active_dims(5) = ss%active_dims(5) + 1
  IF(ss%nspec_gas.GT.0) ss%active_dims(5) = ss%active_dims(5) + 1
  IF(ss%nspec_imp0.GT.0) ss%active_dims(5) = ss%active_dims(5) + 1

  ! component: IC:
  IF(ss%max_nrz_antgeo.GT.0) ss%active_dims(6) = ss%active_dims(6) + 1
  IF(ss%max_num_nphi.GT.0) ss%active_dims(6) = ss%active_dims(6) + 1
  IF(ss%max_num_nphi_vac.GT.0) ss%active_dims(6) = ss%active_dims(6) + 1
  IF(ss%max_n_straps.GT.0) ss%active_dims(6) = ss%active_dims(6) + 1
  IF(ss%nicrf_src.GT.0) ss%active_dims(6) = ss%active_dims(6) + 1
  IF(ss%nrho_icrf.GT.0) ss%active_dims(6) = ss%active_dims(6) + 1
  IF(ss%nspec_rfmin.GT.0) ss%active_dims(6) = ss%active_dims(6) + 1

  ! component: LH:
  IF(ss%max_nspectrumlh_src.GT.0) ss%active_dims(7) = ss%active_dims(7) + 1
  IF(ss%nlhrf_src.GT.0) ss%active_dims(7) = ss%active_dims(7) + 1
  IF(ss%nrho_lhrf.GT.0) ss%active_dims(7) = ss%active_dims(7) + 1

  ! component: LMHD:
  IF(ss%mmodes.GT.0) ss%active_dims(8) = ss%active_dims(8) + 1
  IF(ss%nballoon.GT.0) ss%active_dims(8) = ss%active_dims(8) + 1
  IF(ss%ndelta_w.GT.0) ss%active_dims(8) = ss%active_dims(8) + 1
  IF(ss%nnewcomb.GT.0) ss%active_dims(8) = ss%active_dims(8) + 1
  IF(ss%nrho_lmhd.GT.0) ss%active_dims(8) = ss%active_dims(8) + 1

  ! component: NBI:
  IF(ss%nbeam.GT.0) ss%active_dims(9) = ss%active_dims(9) + 1
  IF(ss%nrho_nbi.GT.0) ss%active_dims(9) = ss%active_dims(9) + 1
  IF(ss%nspec_beam.GT.0) ss%active_dims(9) = ss%active_dims(9) + 1
  IF(ss%n_D_einj_standard.GT.0) ss%active_dims(9) = ss%active_dims(9) + 1
  IF(ss%n_H_einj_standard.GT.0) ss%active_dims(9) = ss%active_dims(9) + 1
  IF(ss%n_T_einj_standard.GT.0) ss%active_dims(9) = ss%active_dims(9) + 1

  ! component: PEL:
  IF(ss%nrho_pel.GT.0) ss%active_dims(10) = ss%active_dims(10) + 1

  ! component: PLASMA:
  IF(ss%nrho.GT.0) ss%active_dims(11) = ss%active_dims(11) + 1
  IF(ss%nspec_all.GT.0) ss%active_dims(11) = ss%active_dims(11) + 1
  IF(ss%nspec_alla.GT.0) ss%active_dims(11) = ss%active_dims(11) + 1
  IF(ss%nspec_impi.GT.0) ss%active_dims(11) = ss%active_dims(11) + 1
  IF(ss%nspec_th.GT.0) ss%active_dims(11) = ss%active_dims(11) + 1
  IF(ss%nspec_tha.GT.0) ss%active_dims(11) = ss%active_dims(11) + 1
  IF(ss%ntrcat.GT.0) ss%active_dims(11) = ss%active_dims(11) + 1

  ! component: RAD:
  IF(ss%nrho_mist.GT.0) ss%active_dims(12) = ss%active_dims(12) + 1
  IF(ss%nrho_rad.GT.0) ss%active_dims(12) = ss%active_dims(12) + 1
  IF(ss%nxs.GT.0) ss%active_dims(12) = ss%active_dims(12) + 1

  ! component: RIPPLE:
  IF(ss%nr_rip.GT.0) ss%active_dims(13) = ss%active_dims(13) + 1
  IF(ss%nz_rip.GT.0) ss%active_dims(13) = ss%active_dims(13) + 1

  ! component: RUNAWAY:
  IF(ss%nrho_rw.GT.0) ss%active_dims(14) = ss%active_dims(14) + 1

  !==============================
  ! call routines to allocate arrays with non-zero dimensions
  call plasma_state_empty_alloc_0(ss,iout,ierr)
  call plasma_state_empty_alloc_1(ss,iout,ierr)
  call plasma_state_empty_alloc_2(ss,iout,ierr)
  call plasma_state_empty_alloc_3(ss,iout,ierr)
  call plasma_state_empty_alloc_4(ss,iout,ierr)
  call plasma_state_empty_alloc_5(ss,iout,ierr)
  call plasma_state_empty_alloc_6(ss,iout,ierr)
  call plasma_state_empty_alloc_7(ss,iout,ierr)
  call plasma_state_empty_alloc_8(ss,iout,ierr)
  call plasma_state_empty_alloc_9(ss,iout,ierr)


END SUBROUTINE plasma_state_empty_alloc

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_b6_dummy
     return
  end subroutine ccps_getset_b6_dummy

subroutine psget_beam_type(iobj, n1, data, ierr)
    !! beam type:, "standard", H/D/T beam using standard
    !! full-half-third energy, injection fractions; energy dependence
    !! of standard beam energy, fractions are defined as part of the
    !! machine description, "negative_ion", H/D/T beam 100% injected
    !! at full energy, "Helium" for Helium or He3 beam, energy
    !! fraction is 100% full energy., "Impurity" for injection of one
    !! of: {Ne,Ar,Xe,Kr}: 100% full energy.
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    CHARACTER*(*), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_beam_type', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % beam_type
end subroutine psget_beam_type


subroutine psset_beam_type(iobj, n1, data, ierr)
    !! beam type:, "standard", H/D/T beam using standard
    !! full-half-third energy, injection fractions; energy dependence
    !! of standard beam energy, fractions are defined as part of the
    !! machine description, "negative_ion", H/D/T beam 100% injected
    !! at full energy, "Helium" for Helium or He3 beam, energy
    !! fraction is 100% full energy., "Impurity" for injection of one
    !! of: {Ne,Ar,Xe,Kr}: 100% full energy.
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    CHARACTER*(*), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_beam_type', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % beam_type = data(1:n1)
end subroutine psset_beam_type


subroutine psgetsz_beam_type(iobj, size, ierr)
    !! beam type:, "standard", H/D/T beam using standard
    !! full-half-third energy, injection fractions; energy dependence
    !! of standard beam energy, fractions are defined as part of the
    !! machine description, "negative_ion", H/D/T beam 100% injected
    !! at full energy, "Helium" for Helium or He3 beam, energy
    !! fraction is 100% full energy., "Impurity" for injection of one
    !! of: {Ne,Ar,Xe,Kr}: 100% full energy.
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: size    ! size of character string
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psgetsz_beam_type', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! note that the following will return the character length size regardless of
    ! the number of array elements (if beam_type is an array)
    size = len(ss % beam_type)
end subroutine psgetsz_beam_type


subroutine psgetrnk_beam_type(iobj, ndims, ierr)
    !! beam type:, "standard", H/D/T beam using standard
    !! full-half-third energy, injection fractions; energy dependence
    !! of standard beam energy, fractions are defined as part of the
    !! machine description, "negative_ion", H/D/T beam 100% injected
    !! at full energy, "Helium" for Helium or He3 beam, energy
    !! fraction is 100% full energy., "Impurity" for injection of one
    !! of: {Ne,Ar,Xe,Kr}: 100% full energy.
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_beam_type


subroutine psgetdim_beam_type(iobj, ndims, dims, ierr)
    !! beam type:, "standard", H/D/T beam using standard
    !! full-half-third energy, injection fractions; energy dependence
    !! of standard beam energy, fractions are defined as part of the
    !! machine description, "negative_ion", H/D/T beam 100% injected
    !! at full energy, "Helium" for Helium or He3 beam, energy
    !! fraction is 100% full energy., "Impurity" for injection of one
    !! of: {Ne,Ar,Xe,Kr}: 100% full energy.
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_beam_type', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % beam_type ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % beam_type)
    endif
end subroutine psgetdim_beam_type


subroutine psget_b_hfocal_length(iobj, n1, data, ierr)
    !! horizontal focal length, for nbshape(j)="circle" sources
    !! this is the only focal length.
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_b_hfocal_length', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % b_Hfocal_length
end subroutine psget_b_hfocal_length


subroutine psset_b_hfocal_length(iobj, n1, data, ierr)
    !! horizontal focal length, for nbshape(j)="circle" sources
    !! this is the only focal length.
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_b_hfocal_length', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % b_Hfocal_length = data(1:n1)
end subroutine psset_b_hfocal_length


subroutine psgetrnk_b_hfocal_length(iobj, ndims, ierr)
    !! horizontal focal length, for nbshape(j)="circle" sources
    !! this is the only focal length.
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_b_hfocal_length


subroutine psgetdim_b_hfocal_length(iobj, ndims, dims, ierr)
    !! horizontal focal length, for nbshape(j)="circle" sources
    !! this is the only focal length.
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_b_hfocal_length', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % b_Hfocal_length ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % b_Hfocal_length)
    endif
end subroutine psgetdim_b_hfocal_length

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_i2_dummy
     return
  end subroutine ccps_getset_i2_dummy

subroutine psget_id_v_pers(iobj, n1, data, ierr)
    !! 'Array of IDs for v_pers profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_v_pers', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_v_pers
end subroutine psget_id_v_pers


subroutine psgetrnk_id_v_pers(iobj, ndims, ierr)
    !! 'Array of IDs for v_pers profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_v_pers


subroutine psgetdim_id_v_pers(iobj, ndims, dims, ierr)
    !! 'Array of IDs for v_pers profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_v_pers', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_v_pers ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_v_pers)
    endif
end subroutine psgetdim_id_v_pers


subroutine psget_id_ni(iobj, data, ierr)
    !! 'ID for ni profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_ni', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_ni
end subroutine psget_id_ni


subroutine psget_id_qcomp_e(iobj, data, ierr)
    !! 'ID for qcomp_e profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_qcomp_e', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_qcomp_e
end subroutine psget_id_qcomp_e


subroutine psget_id_tq_trans(iobj, data, ierr)
    !! 'ID for tq_trans profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_tq_trans', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_tq_trans
end subroutine psget_id_tq_trans


subroutine psget_id_chie_trans(iobj, data, ierr)
    !! 'ID for chie_trans profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_chie_trans', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_chie_trans
end subroutine psget_id_chie_trans


subroutine psget_id_vmo_transcat(iobj, n1, data, ierr)
    !! 'Array of IDs for vmo_transcat profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_vmo_transcat', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_vmo_transcat
end subroutine psget_id_vmo_transcat


subroutine psgetrnk_id_vmo_transcat(iobj, ndims, ierr)
    !! 'Array of IDs for vmo_transcat profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_vmo_transcat


subroutine psgetdim_id_vmo_transcat(iobj, ndims, dims, ierr)
    !! 'Array of IDs for vmo_transcat profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_vmo_transcat', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_vmo_transcat ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_vmo_transcat)
    endif
end subroutine psgetdim_id_vmo_transcat


subroutine psget_id_surf(iobj, data, ierr)
    !! 'ID for surf profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_surf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_surf
end subroutine psget_id_surf


subroutine psget_id_z0_momeq(iobj, data, ierr)
    !! 'ID for Z0_momeq profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_z0_momeq', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_z0_momeq
end subroutine psget_id_z0_momeq


subroutine psget_id_grho2r2i(iobj, data, ierr)
    !! 'ID for grho2r2i profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_grho2r2i', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_grho2r2i
end subroutine psget_id_grho2r2i


subroutine psget_id_gbr2(iobj, data, ierr)
    !! 'ID for gbr2 profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_gbr2', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_gbr2
end subroutine psget_id_gbr2


subroutine psget_id_gncfb2h(iobj, data, ierr)
    !! 'ID for gncfb2h profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_gncfb2h', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_gncfb2h
end subroutine psget_id_gncfb2h


subroutine psget_id_rmajor_mean(iobj, data, ierr)
    !! 'ID for Rmajor_mean profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_rmajor_mean', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_rmajor_mean
end subroutine psget_id_rmajor_mean


subroutine psget_id_picrf_nphi_srcs(iobj, n1, n2, n3, data, ierr)
    !! 'Array of IDs for picrf_nphi_srcs profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2, n3 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1, n2, n3) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_picrf_nphi_srcs', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2, 1: n3) = ss % id_picrf_nphi_srcs
end subroutine psget_id_picrf_nphi_srcs


subroutine psgetrnk_id_picrf_nphi_srcs(iobj, ndims, ierr)
    !! 'Array of IDs for picrf_nphi_srcs profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 3
end subroutine psgetrnk_id_picrf_nphi_srcs


subroutine psgetdim_id_picrf_nphi_srcs(iobj, ndims, dims, ierr)
    !! 'Array of IDs for picrf_nphi_srcs profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 3) ierr = 1
    call ccps_argcheck('psgetdim_id_picrf_nphi_srcs', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_picrf_nphi_srcs ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_picrf_nphi_srcs)
    endif
end subroutine psgetdim_id_picrf_nphi_srcs


subroutine psget_id_nmini(iobj, n1, data, ierr)
    !! 'Array of IDs for nmini profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_nmini', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_nmini
end subroutine psget_id_nmini


subroutine psgetrnk_id_nmini(iobj, ndims, ierr)
    !! 'Array of IDs for nmini profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_nmini


subroutine psgetdim_id_nmini(iobj, ndims, dims, ierr)
    !! 'Array of IDs for nmini profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_nmini', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_nmini ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_nmini)
    endif
end subroutine psgetdim_id_nmini


subroutine psget_id_pbth(iobj, data, ierr)
    !! 'ID for pbth profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_pbth', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_pbth
end subroutine psget_id_pbth


subroutine psget_id_sb0halo_recap(iobj, n1, data, ierr)
    !! 'Array of IDs for sb0halo_recap profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_sb0halo_recap', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_sb0halo_recap
end subroutine psget_id_sb0halo_recap


subroutine psgetrnk_id_sb0halo_recap(iobj, ndims, ierr)
    !! 'Array of IDs for sb0halo_recap profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_sb0halo_recap


subroutine psgetdim_id_sb0halo_recap(iobj, ndims, dims, ierr)
    !! 'Array of IDs for sb0halo_recap profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_sb0halo_recap', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_sb0halo_recap ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_sb0halo_recap)
    endif
end subroutine psgetdim_id_sb0halo_recap


subroutine psget_id_curbeam(iobj, data, ierr)
    !! 'ID for curbeam profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_curbeam', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_curbeam
end subroutine psget_id_curbeam


subroutine psget_id_sfsce(iobj, n1, data, ierr)
    !! 'Array of IDs for sfsce profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_sfsce', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_sfsce
end subroutine psget_id_sfsce


subroutine psgetrnk_id_sfsce(iobj, ndims, ierr)
    !! 'Array of IDs for sfsce profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_sfsce


subroutine psgetdim_id_sfsce(iobj, ndims, dims, ierr)
    !! 'Array of IDs for sfsce profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_sfsce', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_sfsce ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_sfsce)
    endif
end subroutine psgetdim_id_sfsce


subroutine psget_id_eperp_rw(iobj, data, ierr)
    !! 'ID for eperp_rw profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_eperp_rw', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_eperp_rw
end subroutine psget_id_eperp_rw


subroutine psget_id_tqqcx(iobj, n1, data, ierr)
    !! 'Array of IDs for tqqcx profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_tqqcx', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_tqqcx
end subroutine psget_id_tqqcx


subroutine psgetrnk_id_tqqcx(iobj, ndims, ierr)
    !! 'Array of IDs for tqqcx profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_tqqcx


subroutine psgetdim_id_tqqcx(iobj, ndims, dims, ierr)
    !! 'Array of IDs for tqqcx profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_tqqcx', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_tqqcx ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_tqqcx)
    endif
end subroutine psgetdim_id_tqqcx


subroutine psget_id_s0reco_e(iobj, data, ierr)
    !! 'ID for s0reco_e profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_s0reco_e', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_s0reco_e
end subroutine psget_id_s0reco_e


subroutine psget_id_peech(iobj, data, ierr)
    !! 'ID for peech profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_peech', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_peech
end subroutine psget_id_peech


subroutine psget_id_balstab(iobj, data, ierr)
    !! 'ID for balstab profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_balstab', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_balstab
end subroutine psget_id_balstab


subroutine psget_id_fidiff_dtrap(iobj, n1, data, ierr)
    !! 'Array of IDs for fidiff_dtrap profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_fidiff_dtrap', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_fidiff_dtrap
end subroutine psget_id_fidiff_dtrap


subroutine psgetrnk_id_fidiff_dtrap(iobj, ndims, ierr)
    !! 'Array of IDs for fidiff_dtrap profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_fidiff_dtrap


subroutine psgetdim_id_fidiff_dtrap(iobj, ndims, dims, ierr)
    !! 'Array of IDs for fidiff_dtrap profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_fidiff_dtrap', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_fidiff_dtrap ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_fidiff_dtrap)
    endif
end subroutine psgetdim_id_fidiff_dtrap


subroutine psget_id_bidiff_bpass_ctr(iobj, n1, data, ierr)
    !! 'Array of IDs for bidiff_bpass_ctr profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_bidiff_bpass_ctr', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_bidiff_bpass_ctr
end subroutine psget_id_bidiff_bpass_ctr


subroutine psgetrnk_id_bidiff_bpass_ctr(iobj, ndims, ierr)
    !! 'Array of IDs for bidiff_bpass_ctr profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_bidiff_bpass_ctr


subroutine psgetdim_id_bidiff_bpass_ctr(iobj, ndims, dims, ierr)
    !! 'Array of IDs for bidiff_bpass_ctr profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_bidiff_bpass_ctr', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_bidiff_bpass_ctr ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_bidiff_bpass_ctr)
    endif
end subroutine psgetdim_id_bidiff_bpass_ctr


subroutine psget_id_chie_anom(iobj, data, ierr)
    !! 'ID for chie_anom profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_chie_anom', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_chie_anom
end subroutine psget_id_chie_anom


subroutine psget_id_te_ky_tglf(iobj, n1, data, ierr)
    !! 'Array of IDs for te_ky_tglf profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_te_ky_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_te_ky_tglf
end subroutine psget_id_te_ky_tglf


subroutine psgetrnk_id_te_ky_tglf(iobj, ndims, ierr)
    !! 'Array of IDs for te_ky_tglf profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_te_ky_tglf


subroutine psgetdim_id_te_ky_tglf(iobj, ndims, dims, ierr)
    !! 'Array of IDs for te_ky_tglf profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_te_ky_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_te_ky_tglf ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_te_ky_tglf)
    endif
end subroutine psgetdim_id_te_ky_tglf


subroutine psget_id_phiflux_ky_tglf(iobj, n1, data, ierr)
    !! 'Array of IDs for phiflux_ky_tglf profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_phiflux_ky_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_phiflux_ky_tglf
end subroutine psget_id_phiflux_ky_tglf


subroutine psgetrnk_id_phiflux_ky_tglf(iobj, ndims, ierr)
    !! 'Array of IDs for phiflux_ky_tglf profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_phiflux_ky_tglf


subroutine psgetdim_id_phiflux_ky_tglf(iobj, ndims, dims, ierr)
    !! 'Array of IDs for phiflux_ky_tglf profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_phiflux_ky_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_phiflux_ky_tglf ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_phiflux_ky_tglf)
    endif
end subroutine psgetdim_id_phiflux_ky_tglf


subroutine psget_id_dqidgrdti_tglf(iobj, data, ierr)
    !! 'ID for dQidGrdti_tglf profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_dqidgrdti_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_dqidgrdti_tglf
end subroutine psget_id_dqidgrdti_tglf


subroutine psget_id_chitheta_mmm71(iobj, data, ierr)
    !! 'ID for chitheta_mmm71 profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_chitheta_mmm71', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_chitheta_mmm71
end subroutine psget_id_chitheta_mmm71


subroutine psget_id_chii_w19(iobj, data, ierr)
    !! 'ID for chii_w19 profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_chii_w19', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_chii_w19
end subroutine psget_id_chii_w19


subroutine psget_id_chie_paleo(iobj, data, ierr)
    !! 'ID for chie_paleo profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_chie_paleo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_chie_paleo
end subroutine psget_id_chie_paleo


subroutine psget_id_velte_glf(iobj, data, ierr)
    !! 'ID for velte_glf profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_velte_glf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_velte_glf
end subroutine psget_id_velte_glf


subroutine psget_id_chiphi_gtcneo(iobj, data, ierr)
    !! 'ID for chiphi_gtcneo profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_chiphi_gtcneo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_chiphi_gtcneo
end subroutine psget_id_chiphi_gtcneo


subroutine psget_id_velte_neo(iobj, data, ierr)
    !! 'ID for velte_neo profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_velte_neo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_velte_neo
end subroutine psget_id_velte_neo


subroutine psget_id_velte_nclass(iobj, data, ierr)
    !! 'ID for velte_nclass profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_velte_nclass', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_velte_nclass
end subroutine psget_id_velte_nclass


subroutine psget_id_ee_mobility_factor(iobj, data, ierr)
    !! 'ID for ee_mobility_factor profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_ee_mobility_factor', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_ee_mobility_factor
end subroutine psget_id_ee_mobility_factor

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_e2_dummy
     return
  end subroutine ccps_getset_e2_dummy

subroutine psget_einj_max(iobj, n1, data, ierr)
    !! maximum injection energy, maximum energy of the full energy
    !! fractional component of each beam, Some codes use
    !! 1.5*maxval(Einj_max) as an upper limit on a lab frame, energy
    !! grid for beam ions slowing down distribution functions.
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_einj_max', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % Einj_max
end subroutine psget_einj_max


subroutine psset_einj_max(iobj, n1, data, ierr)
    !! maximum injection energy, maximum energy of the full energy
    !! fractional component of each beam, Some codes use
    !! 1.5*maxval(Einj_max) as an upper limit on a lab frame, energy
    !! grid for beam ions slowing down distribution functions.
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_einj_max', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % Einj_max = data(1:n1)
end subroutine psset_einj_max


subroutine psgetrnk_einj_max(iobj, ndims, ierr)
    !! maximum injection energy, maximum energy of the full energy
    !! fractional component of each beam, Some codes use
    !! 1.5*maxval(Einj_max) as an upper limit on a lab frame, energy
    !! grid for beam ions slowing down distribution functions.
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_einj_max


subroutine psgetdim_einj_max(iobj, ndims, dims, ierr)
    !! maximum injection energy, maximum energy of the full energy
    !! fractional component of each beam, Some codes use
    !! 1.5*maxval(Einj_max) as an upper limit on a lab frame, energy
    !! grid for beam ions slowing down distribution functions.
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_einj_max', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % Einj_max ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % Einj_max)
    endif
end subroutine psgetdim_einj_max


subroutine psget_ec_half_power_angle(iobj, n1, data, ierr)
    !! Divergence of EC beam, beam at half-power, this half-angle
    !! away from, direction of beam centerline which is started, at
    !! the launcher (treated as a point source);, See
    !! EC_theta_aim(necrf_src) & EC_phi_aim(necrf_src), in the shot
    !! configuration section.
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_ec_half_power_angle', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % EC_Half_Power_Angle
end subroutine psget_ec_half_power_angle


subroutine psset_ec_half_power_angle(iobj, n1, data, ierr)
    !! Divergence of EC beam, beam at half-power, this half-angle
    !! away from, direction of beam centerline which is started, at
    !! the launcher (treated as a point source);, See
    !! EC_theta_aim(necrf_src) & EC_phi_aim(necrf_src), in the shot
    !! configuration section.
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_ec_half_power_angle', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % EC_Half_Power_Angle = data(1:n1)
end subroutine psset_ec_half_power_angle


subroutine psgetrnk_ec_half_power_angle(iobj, ndims, ierr)
    !! Divergence of EC beam, beam at half-power, this half-angle
    !! away from, direction of beam centerline which is started, at
    !! the launcher (treated as a point source);, See
    !! EC_theta_aim(necrf_src) & EC_phi_aim(necrf_src), in the shot
    !! configuration section.
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_ec_half_power_angle


subroutine psgetdim_ec_half_power_angle(iobj, ndims, dims, ierr)
    !! Divergence of EC beam, beam at half-power, this half-angle
    !! away from, direction of beam centerline which is started, at
    !! the launcher (treated as a point source);, See
    !! EC_theta_aim(necrf_src) & EC_phi_aim(necrf_src), in the shot
    !! configuration section.
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_ec_half_power_angle', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % EC_Half_Power_Angle ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % EC_Half_Power_Angle)
    endif
end subroutine psgetdim_ec_half_power_angle


subroutine psget_ec_theta_aim(iobj, n1, data, ierr)
    !! poloidal aiming angle, = angle from +Z direction:, 0
    !! degrees-> straight up;, +/-  45 degrees-> on a cone in an
    !! upward direction, +/-  90 degrees-> in a horizontal
    !! direction..., +/- 135 degrees-> on a cone in a downward
    !! direction, +/- 180 degrees-> straight down, (for values other
    !! than 0,+/- 180, see alse EC_phi_aim).
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_ec_theta_aim', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % EC_theta_aim
end subroutine psget_ec_theta_aim


subroutine psset_ec_theta_aim(iobj, n1, data, ierr)
    !! poloidal aiming angle, = angle from +Z direction:, 0
    !! degrees-> straight up;, +/-  45 degrees-> on a cone in an
    !! upward direction, +/-  90 degrees-> in a horizontal
    !! direction..., +/- 135 degrees-> on a cone in a downward
    !! direction, +/- 180 degrees-> straight down, (for values other
    !! than 0,+/- 180, see alse EC_phi_aim).
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_ec_theta_aim', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % EC_theta_aim = data(1:n1)
end subroutine psset_ec_theta_aim


subroutine psgetrnk_ec_theta_aim(iobj, ndims, ierr)
    !! poloidal aiming angle, = angle from +Z direction:, 0
    !! degrees-> straight up;, +/-  45 degrees-> on a cone in an
    !! upward direction, +/-  90 degrees-> in a horizontal
    !! direction..., +/- 135 degrees-> on a cone in a downward
    !! direction, +/- 180 degrees-> straight down, (for values other
    !! than 0,+/- 180, see alse EC_phi_aim).
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_ec_theta_aim


subroutine psgetdim_ec_theta_aim(iobj, ndims, dims, ierr)
    !! poloidal aiming angle, = angle from +Z direction:, 0
    !! degrees-> straight up;, +/-  45 degrees-> on a cone in an
    !! upward direction, +/-  90 degrees-> in a horizontal
    !! direction..., +/- 135 degrees-> on a cone in a downward
    !! direction, +/- 180 degrees-> straight down, (for values other
    !! than 0,+/- 180, see alse EC_phi_aim).
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_ec_theta_aim', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % EC_theta_aim ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % EC_theta_aim)
    endif
end subroutine psgetdim_ec_theta_aim


subroutine psget_ec_data_info(iobj, data, ierr)
    !! information on source of ECRF power data
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    CHARACTER*(*), intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_ec_data_info', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % EC_Data_Info
end subroutine psget_ec_data_info


subroutine psset_ec_data_info(iobj, data, ierr)
    !! information on source of ECRF power data
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    CHARACTER*(*), intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_ec_data_info', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % EC_Data_Info = data
end subroutine psset_ec_data_info


subroutine psgetsz_ec_data_info(iobj, size, ierr)
    !! information on source of ECRF power data
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: size    ! size of character string
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psgetsz_ec_data_info', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! note that the following will return the character length size regardless of
    ! the number of array elements (if EC_Data_Info is an array)
    size = len(ss % EC_Data_Info)
end subroutine psgetsz_ec_data_info


subroutine psget_eqdsk_file(iobj, data, ierr)
    !! EFIT G-eqdsk file: psi(R,Z), g(psi), etc.
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    CHARACTER*(*), intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_eqdsk_file', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % eqdsk_file
end subroutine psget_eqdsk_file


subroutine psset_eqdsk_file(iobj, data, ierr)
    !! EFIT G-eqdsk file: psi(R,Z), g(psi), etc.
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    CHARACTER*(*), intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_eqdsk_file', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % eqdsk_file = data
end subroutine psset_eqdsk_file


subroutine psgetsz_eqdsk_file(iobj, size, ierr)
    !! EFIT G-eqdsk file: psi(R,Z), g(psi), etc.
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: size    ! size of character string
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psgetsz_eqdsk_file', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! note that the following will return the character length size regardless of
    ! the number of array elements (if eqdsk_file is an array)
    size = len(ss % eqdsk_file)
end subroutine psgetsz_eqdsk_file


subroutine psget_eperp_rw(iobj, n1, data, ierr)
    !! runaway electron <Eperp>
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_eperp_rw', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % eperp_rw
end subroutine psget_eperp_rw


subroutine psset_eperp_rw(iobj, n1, data, ierr)
    !! runaway electron <Eperp>
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_eperp_rw', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % eperp_rw = data(1:n1)
end subroutine psset_eperp_rw


subroutine psgetrnk_eperp_rw(iobj, ndims, ierr)
    !! runaway electron <Eperp>
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_eperp_rw


subroutine psgetdim_eperp_rw(iobj, ndims, dims, ierr)
    !! runaway electron <Eperp>
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_eperp_rw', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % eperp_rw ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % eperp_rw)
    endif
end subroutine psgetdim_eperp_rw


subroutine psget_ee_mobility_factor(iobj, n1, data, ierr)
    !! chi_e/chi_i, ratio of electron heat diffusivity to ion heat
    !! diffusivity, a model input, (does not effect relative
    !! non-diffusive heat pinch velocities).
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_ee_mobility_factor', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % ee_mobility_factor
end subroutine psget_ee_mobility_factor


subroutine psset_ee_mobility_factor(iobj, n1, data, ierr)
    !! chi_e/chi_i, ratio of electron heat diffusivity to ion heat
    !! diffusivity, a model input, (does not effect relative
    !! non-diffusive heat pinch velocities).
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_ee_mobility_factor', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % ee_mobility_factor = data(1:n1)
end subroutine psset_ee_mobility_factor


subroutine psgetrnk_ee_mobility_factor(iobj, ndims, ierr)
    !! chi_e/chi_i, ratio of electron heat diffusivity to ion heat
    !! diffusivity, a model input, (does not effect relative
    !! non-diffusive heat pinch velocities).
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_ee_mobility_factor


subroutine psgetdim_ee_mobility_factor(iobj, ndims, dims, ierr)
    !! chi_e/chi_i, ratio of electron heat diffusivity to ion heat
    !! diffusivity, a model input, (does not effect relative
    !! non-diffusive heat pinch velocities).
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_ee_mobility_factor', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % ee_mobility_factor ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % ee_mobility_factor)
    endif
end subroutine psgetdim_ee_mobility_factor

subroutine ccps_update_equilibrium(iobj,g_filepath,bdy_crat,kcur_option, &
     & rho_curbrk, npprime, rho_psmoo, delrho_psmoo, ierr)

  ! update MHD equilibrium stored in state object, from G-eqdsk file.

  use plasma_state_mod
  implicit NONE

#include "fpreproc/byte_declare.h"

  integer :: iobj(*)        ! (ps_container_size) words are used: state object
  BYTE_DECLARE, intent(in) :: g_filepath(*) ! null terminated file path string (max 256 chars)
  REAL(kind=rspec) :: bdy_crat  ! curvature ratio limit for boundary
  ! bdy_crat controls selection of a boundary surface somewhat in from
  ! the separatrix Last Closed Flux Surface (LCFS) found in the G-eqdsk
  ! Psi(R,Z) data.  Typical value: 0.075 -- this says the local ratio
  ! of curvature anywhere along the chosen boundary surface must be
  ! greater than equal to 0.075*[midplane half radius of equilibrium].
  ! At the exact LCFS this ratio is zero; for a limiter bound plasma,
  ! the ratio is typically >> bdy_crat=0.075.  So, a limiter bound
  ! plasma uses the G-eqdsk boundary; a separatrix bound plasma has
  ! a boundary chosen which backs off sufficiently to meet this 
  ! geometrical constraint.
  integer, intent(in) :: kcur_option ! how to set q(rho) and I(rho)
                         ! kcur_option control to select method
                         ! for obtaining q(rho) and I(rho) enclosed
                         ! toroidal current function (details below).
                         ! Default = -1: choose based on file label;
                         !   =0: use EFIT file data for total current
                         !       and q(psi) profile
                         !   =1: compute total current and q(psi)
                         !       profile from Psi(R,Z); supersede
                         !       EFIT file data for these quantities.  
  real(kind=rspec), intent(in) :: rho_curbrk  ! break location for
                         ! I(rho) -- point at which to transition
                         ! from Psi(R,Z) Ampere's Law integration 
                         ! to a parabolic interpolation to reach
                         ! the total enclosed current (boundary 
                         ! value). Default = 0.9_rspec.
  integer, intent(in) :: npprime  ! > 0 to request 
                         ! recomputation of pressure profile using
                         ! PPRIME data from G-eqdsk input file;
                         ! a value > 0 indicates that npprime rho_psmoo
                         ! and delrho_psmoo are expected (see following)
                         ! default is 0 
  real(kind=rspec), dimension(npprime), intent(in) :: rho_psmoo
                                  ! rho location(s) for pressure profile
                                  ! smoothing array delrho_psmoo; if this
                                  ! is present, delrho_psmoo(...) must
                                  ! also be present, and, sizes must match.

  real(kind=rspec), dimension(npprime), intent(in) :: delrho_psmoo
                                  ! array of smoothing parameters for pressure
                                  ! profile; together with rho_psmoo this
                                  ! defines a profile to be piecewise linearly
                                  ! interpolated to produce local delta_rho
                                  ! values for smoothing.  At each rho location
                                  ! the pressure profile is smoothed with a 
                                  ! triangular weighted average of neighboring
                                  ! data, from rho-delta_rho to rho+delta_rho.
                                  ! if delrho_psmoo(...) is present, the array
                                  ! rho_psmoo(...) must also be present, and, 
                                  ! sizes must match.
  integer,intent(out) :: ierr   ! exit status 0=OK

  !-------------------------
  character*256 g_filename
  type (plasma_state_container) :: ptr
  type (plasma_state), pointer :: ss
  !-------------------------

  call ccps_argcheck('ccps_update_equilibrium',iobj,ierr)
  if(ierr.ne.0) return

  ! proceed...

  call load_ps_container(iobj,ptr)
  ss => ptr%ps_ptr

  ! convert filepath to fortran string
  call cstring(g_filename,g_filepath,'2F')  ! convert file path to 
                                            ! fortran string (g_filename)

  if (npprime > 0) then
     call ps_update_equilibrium(ierr, g_filepath=g_filename, bdy_crat=bdy_crat, &
       kcur_option=kcur_option, pprime_option=.TRUE., &
       rho_psmoo=rho_psmoo, delrho_psmoo=delrho_psmoo, &
       state=ss)
  else
     call ps_update_equilibrium(ierr, g_filepath=g_filename, bdy_crat=bdy_crat, &
       kcur_option=kcur_option, pprime_option=.FALSE., &
       state=ss)
  endif

end subroutine ccps_update_equilibrium

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)

SUBROUTINE plasma_state_xload_grids(ss,xhash,iout,ierr)

  ! called from plasma_state_xload: check grids; store in xplasma structure

  USE plasma_state_definition_mod
  IMPLICIT NONE

  TYPE (plasma_state) :: ss     ! state data to write into xplasma
  INTEGER :: xhash(ps_hash_total)  ! hash data
  INTEGER, INTENT(IN) :: iout   ! LUN for messages
  INTEGER, INTENT(INOUT) :: ierr   ! completion code (set if error occurs)

  !-----------------------
  ! local:
  INTEGER :: isize,icomponent,iertmp
  CHARACTER*80 :: plabel
  INTEGER :: ahash(ps_max_static)
  !-----------------------

  ahash(1) = ps_dhash_NEFI_ANOM
  isize = ss%nefi_anom
  IF((isize.GT.0).AND.hcheck(1,1)) THEN
     icomponent = ps_cnum_ANOM
     plabel = "(optional) energy grid (1d profiles)"
     CALL ps_grid_store(ss%iobj,"E","E_ANOM",icomponent,plabel, &
          isize,0,ss%E_anom, iout,iertmp)
     ierr=MAX(ierr,iertmp)
  ENDIF

  ahash(1) = ps_dhash_NEFI_ANOM2
  isize = ss%nefi_anom2
  IF((isize.GT.0).AND.hcheck(1,1)) THEN
     icomponent = ps_cnum_ANOM
     plabel = "energy grid (2d anomalous transport profiles)"
     CALL ps_grid_store(ss%iobj,"E","E_ANOM2",icomponent,plabel, &
          isize,0,ss%E_anom2, iout,iertmp)
     ierr=MAX(ierr,iertmp)
  ENDIF

  ahash(1) = ps_dhash_NR
  isize = ss%nr
  IF((isize.GT.0).AND.hcheck(1,1)) THEN
     icomponent = ps_cnum_EQ
     plabel = "R grid"
     CALL ps_grid_store(ss%iobj,"R","R_GRID",icomponent,plabel, &
          isize,0,ss%R_grid, iout,iertmp)
     ierr=MAX(ierr,iertmp)
  ENDIF

  ahash(1) = ps_dhash_NRHO
  isize = ss%nrho
  IF((isize.GT.0).AND.hcheck(1,1)) THEN
     icomponent = ps_cnum_PLASMA
     plabel = "rho grid (PLASMA)"
     CALL ps_grid_store(ss%iobj,"RHO","RHO",icomponent,plabel, &
          isize,0,ss%rho, iout,iertmp)
     ierr=MAX(ierr,iertmp)
  ENDIF

  ahash(1) = ps_dhash_NRHO_ANOM
  isize = ss%nrho_anom
  IF((isize.GT.0).AND.hcheck(1,1)) THEN
     icomponent = ps_cnum_ANOM
     plabel = "rho grid (1d anomalous transport profiles)"
     CALL ps_grid_store(ss%iobj,"RHO","RHO_ANOM",icomponent,plabel, &
          isize,0,ss%rho_anom, iout,iertmp)
     ierr=MAX(ierr,iertmp)
  ENDIF

  ahash(1) = ps_dhash_NRHO_ANOM2
  isize = ss%nrho_anom2
  IF((isize.GT.0).AND.hcheck(1,1)) THEN
     icomponent = ps_cnum_ANOM
     plabel = "rho grid (2d anomalous transport profiles)"
     CALL ps_grid_store(ss%iobj,"RHO","RHO_ANOM2",icomponent,plabel, &
          isize,0,ss%rho_anom2, iout,iertmp)
     ierr=MAX(ierr,iertmp)
  ENDIF

  ahash(1) = ps_dhash_NRHO_ANOMTH
  isize = ss%nrho_anomth
  IF((isize.GT.0).AND.hcheck(1,1)) THEN
     icomponent = ps_cnum_ANOM
     plabel = "rho grid (1d anomalous data for 1d"
     CALL ps_grid_store(ss%iobj,"RHO","RHO_ANOMTH",icomponent,plabel, &
          isize,0,ss%rho_anomth, iout,iertmp)
     ierr=MAX(ierr,iertmp)
  ENDIF

  ahash(1) = ps_dhash_NRHO_ECRF
  isize = ss%nrho_ecrf
  IF((isize.GT.0).AND.hcheck(1,1)) THEN
     icomponent = ps_cnum_EC
     plabel = "rho grid -- ECRF"
     CALL ps_grid_store(ss%iobj,"RHO","RHO_ECRF",icomponent,plabel, &
          isize,0,ss%rho_ecrf, iout,iertmp)
     ierr=MAX(ierr,iertmp)
  ENDIF

  ahash(1) = ps_dhash_NRHO_EQ
  isize = ss%nrho_eq
  IF((isize.GT.0).AND.hcheck(1,1)) THEN
     icomponent = ps_cnum_EQ
     plabel = "rho grid (EQ)"
     CALL ps_grid_store(ss%iobj,"RHO","RHO_EQ",icomponent,plabel, &
          isize,0,ss%rho_eq, iout,iertmp)
     ierr=MAX(ierr,iertmp)
  ENDIF

  ahash(1) = ps_dhash_NRHO_EQ_GEO
  isize = ss%nrho_eq_geo
  IF((isize.GT.0).AND.hcheck(1,1)) THEN
     icomponent = ps_cnum_EQ
     plabel = "rho grid (EQ flux surface averages)"
     CALL ps_grid_store(ss%iobj,"RHO","RHO_EQ_GEO",icomponent,plabel, &
          isize,0,ss%rho_eq_geo, iout,iertmp)
     ierr=MAX(ierr,iertmp)
  ENDIF

  ahash(1) = ps_dhash_NRHO_FUS
  isize = ss%nrho_fus
  IF((isize.GT.0).AND.hcheck(1,1)) THEN
     icomponent = ps_cnum_FUS
     plabel = "rho grid -- Fusion products model"
     CALL ps_grid_store(ss%iobj,"RHO","RHO_FUS",icomponent,plabel, &
          isize,0,ss%rho_fus, iout,iertmp)
     ierr=MAX(ierr,iertmp)
  ENDIF

  ahash(1) = ps_dhash_NRHO_GAS
  isize = ss%nrho_gas
  IF((isize.GT.0).AND.hcheck(1,1)) THEN
     icomponent = ps_cnum_GAS
     plabel = "rho grid (GAS -- neutral gas model)"
     CALL ps_grid_store(ss%iobj,"RHO","RHO_GAS",icomponent,plabel, &
          isize,0,ss%rho_gas, iout,iertmp)
     ierr=MAX(ierr,iertmp)
  ENDIF

  ahash(1) = ps_dhash_NRHO_ICRF
  isize = ss%nrho_icrf
  IF((isize.GT.0).AND.hcheck(1,1)) THEN
     icomponent = ps_cnum_IC
     plabel = "rho grid (RF)"
     CALL ps_grid_store(ss%iobj,"RHO","RHO_ICRF",icomponent,plabel, &
          isize,0,ss%rho_icrf, iout,iertmp)
     ierr=MAX(ierr,iertmp)
  ENDIF

  ahash(1) = ps_dhash_NRHO_LHRF
  isize = ss%nrho_lhrf
  IF((isize.GT.0).AND.hcheck(1,1)) THEN
     icomponent = ps_cnum_LH
     plabel = "rho grid -- LHRF"
     CALL ps_grid_store(ss%iobj,"RHO","RHO_LHRF",icomponent,plabel, &
          isize,0,ss%rho_lhrf, iout,iertmp)
     ierr=MAX(ierr,iertmp)
  ENDIF

  ahash(1) = ps_dhash_NRHO_LMHD
  isize = ss%nrho_lmhd
  IF((isize.GT.0).AND.hcheck(1,1)) THEN
     icomponent = ps_cnum_LMHD
     plabel = "rho grid (LMHD component)"
     CALL ps_grid_store(ss%iobj,"RHO","RHO_LMHD",icomponent,plabel, &
          isize,0,ss%rho_lmhd, iout,iertmp)
     ierr=MAX(ierr,iertmp)
  ENDIF

  ahash(1) = ps_dhash_NRHO_MIST
  isize = ss%nrho_mist
  IF((isize.GT.0).AND.hcheck(1,1)) THEN
     icomponent = ps_cnum_RAD
     plabel = "rho grid (PLASMA) impurity-driven sources"
     CALL ps_grid_store(ss%iobj,"RHO","RHO_MIST",icomponent,plabel, &
          isize,0,ss%rho_mist, iout,iertmp)
     ierr=MAX(ierr,iertmp)
  ENDIF

  ahash(1) = ps_dhash_NRHO_NBI
  isize = ss%nrho_nbi
  IF((isize.GT.0).AND.hcheck(1,1)) THEN
     icomponent = ps_cnum_NBI
     plabel = "rho grid -- NBI"
     CALL ps_grid_store(ss%iobj,"RHO","RHO_NBI",icomponent,plabel, &
          isize,0,ss%rho_nbi, iout,iertmp)
     ierr=MAX(ierr,iertmp)
  ENDIF

  ahash(1) = ps_dhash_NRHO_PEL
  isize = ss%nrho_pel
  IF((isize.GT.0).AND.hcheck(1,1)) THEN
     icomponent = ps_cnum_PEL
     plabel = "rho grid -- PEL"
     CALL ps_grid_store(ss%iobj,"RHO","RHO_PEL",icomponent,plabel, &
          isize,0,ss%rho_pel, iout,iertmp)
     ierr=MAX(ierr,iertmp)
  ENDIF

  ahash(1) = ps_dhash_NRHO_RAD
  isize = ss%nrho_rad
  IF((isize.GT.0).AND.hcheck(1,1)) THEN
     icomponent = ps_cnum_RAD
     plabel = "rho grid (RAD)"
     CALL ps_grid_store(ss%iobj,"RHO","RHO_RAD",icomponent,plabel, &
          isize,0,ss%rho_rad, iout,iertmp)
     ierr=MAX(ierr,iertmp)
  ENDIF

  ahash(1) = ps_dhash_NRHO_RW
  isize = ss%nrho_rw
  IF((isize.GT.0).AND.hcheck(1,1)) THEN
     icomponent = ps_cnum_RUNAWAY
     plabel = "rho grid -- RUNAWAY electrons"
     CALL ps_grid_store(ss%iobj,"RHO","RHO_RW",icomponent,plabel, &
          isize,0,ss%rho_rw, iout,iertmp)
     ierr=MAX(ierr,iertmp)
  ENDIF

  ahash(1) = ps_dhash_NR_RIP
  isize = ss%nr_rip
  IF((isize.GT.0).AND.hcheck(1,1)) THEN
     icomponent = ps_cnum_RIPPLE
     plabel = "R grid for TF ripple field(s)"
     CALL ps_grid_store(ss%iobj,"R","R_RIPPLE",icomponent,plabel, &
          isize,0,ss%R_ripple, iout,iertmp)
     ierr=MAX(ierr,iertmp)
  ENDIF

  ahash(1) = ps_dhash_NTH_EQ
  isize = ss%nth_eq
  IF((isize.GT.0).AND.hcheck(1,1)) THEN
     icomponent = ps_cnum_EQ
     plabel = "theta grid (EQ)"
     CALL ps_grid_store(ss%iobj,"TH","TH_EQ",icomponent,plabel, &
          isize,ps_ccw_select,ss%th_eq, iout,iertmp)
     ierr=MAX(ierr,iertmp)
  ENDIF

  ahash(1) = ps_dhash_NZ
  isize = ss%nz
  IF((isize.GT.0).AND.hcheck(1,1)) THEN
     icomponent = ps_cnum_EQ
     plabel = "Z grid"
     CALL ps_grid_store(ss%iobj,"Z","Z_GRID",icomponent,plabel, &
          isize,0,ss%Z_grid, iout,iertmp)
     ierr=MAX(ierr,iertmp)
  ENDIF

  ahash(1) = ps_dhash_NZ_RIP
  isize = ss%nz_rip
  IF((isize.GT.0).AND.hcheck(1,1)) THEN
     icomponent = ps_cnum_RIPPLE
     plabel = "Z grid for TF ripple field(s)"
     CALL ps_grid_store(ss%iobj,"Z","Z_RIPPLE",icomponent,plabel, &
          isize,0,ss%Z_ripple, iout,iertmp)
     ierr=MAX(ierr,iertmp)
  ENDIF

CONTAINS

  LOGICAL FUNCTION hcheck(inum,idchk)
     INTEGER, intent(in) :: inum
     INTEGER, intent(in) :: idchk

     !  check all hash codes: set function value TRUE if any show changes.
     !  also set TRUE if idchk = 0

     INTEGER :: ia1,ia2,ii

     if(idchk.eq.0) then
        hcheck=.TRUE.
        return
     endif

     hcheck = .FALSE.
     DO ii=1,inum
        hcheck = .TRUE.
        ia1 = ahash(ii)
        ia2 = ia1 + 1
        IF(ss%hash_codes(ia1).NE.ss%new_hash_codes(ia1)) EXIT
        IF(ss%hash_codes(ia2).NE.ss%new_hash_codes(ia2)) EXIT
        IF(xhash(ia1).NE.ss%new_hash_codes(ia1)) EXIT
        IF(xhash(ia2).NE.ss%new_hash_codes(ia2)) EXIT
        hcheck = .FALSE.
     ENDDO
  END FUNCTION hcheck

  SUBROUTINE lefpack(str)
     CHARACTER*(*), intent(inout) :: str
     !  left pack non-blank characters in str

     INTEGER :: ii,jj
     ii=0
     DO jj=1,len(str)
        IF(str(jj:jj).NE.' ') THEN
           ii = ii + 1
           str(ii:ii) = str(jj:jj)
        ENDIF
     ENDDO
     str(ii+1:) = ' '
  END SUBROUTINE lefpack

END SUBROUTINE plasma_state_xload_grids

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_n3_dummy
     return
  end subroutine ccps_getset_n3_dummy

subroutine psget_nbshape(iobj, n1, data, ierr)
    !! shape keyword for beam source grid, For beam j,
    !! nbshape(j)="Rectangle" indicates a rectangular shaped, source;
    !! nbshape(j)="Circle" indicates a circular shaped source., (The
    !! keyword must be spelled correctly but upper or lower case,
    !! letters may be used interchangeably).  The plane of, the source
    !! is assumed perpendicular to the beam centerline.
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    CHARACTER*(*), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_nbshape', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % nbshape
end subroutine psget_nbshape


subroutine psset_nbshape(iobj, n1, data, ierr)
    !! shape keyword for beam source grid, For beam j,
    !! nbshape(j)="Rectangle" indicates a rectangular shaped, source;
    !! nbshape(j)="Circle" indicates a circular shaped source., (The
    !! keyword must be spelled correctly but upper or lower case,
    !! letters may be used interchangeably).  The plane of, the source
    !! is assumed perpendicular to the beam centerline.
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    CHARACTER*(*), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_nbshape', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % nbshape = data(1:n1)
end subroutine psset_nbshape


subroutine psgetsz_nbshape(iobj, size, ierr)
    !! shape keyword for beam source grid, For beam j,
    !! nbshape(j)="Rectangle" indicates a rectangular shaped, source;
    !! nbshape(j)="Circle" indicates a circular shaped source., (The
    !! keyword must be spelled correctly but upper or lower case,
    !! letters may be used interchangeably).  The plane of, the source
    !! is assumed perpendicular to the beam centerline.
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: size    ! size of character string
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psgetsz_nbshape', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! note that the following will return the character length size regardless of
    ! the number of array elements (if nbshape is an array)
    size = len(ss % nbshape)
end subroutine psgetsz_nbshape


subroutine psgetrnk_nbshape(iobj, ndims, ierr)
    !! shape keyword for beam source grid, For beam j,
    !! nbshape(j)="Rectangle" indicates a rectangular shaped, source;
    !! nbshape(j)="Circle" indicates a circular shaped source., (The
    !! keyword must be spelled correctly but upper or lower case,
    !! letters may be used interchangeably).  The plane of, the source
    !! is assumed perpendicular to the beam centerline.
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_nbshape


subroutine psgetdim_nbshape(iobj, ndims, dims, ierr)
    !! shape keyword for beam source grid, For beam j,
    !! nbshape(j)="Rectangle" indicates a rectangular shaped, source;
    !! nbshape(j)="Circle" indicates a circular shaped source., (The
    !! keyword must be spelled correctly but upper or lower case,
    !! letters may be used interchangeably).  The plane of, the source
    !! is assumed perpendicular to the beam centerline.
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_nbshape', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % nbshape ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % nbshape)
    endif
end subroutine psgetdim_nbshape


subroutine psget_n_h_einj_standard(iobj, data, ierr)
    !! no. pts in H beam energy fractions table
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_n_h_einj_standard', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % n_H_einj_standard
end subroutine psget_n_h_einj_standard


subroutine psset_n_h_einj_standard(iobj, data, ierr)
    !! no. pts in H beam energy fractions table
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_n_h_einj_standard', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % n_H_einj_standard = data
end subroutine psset_n_h_einj_standard


subroutine psget_necrf_src(iobj, data, ierr)
    !! item list dimension of ecrf_src_name (ecrf_source)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_necrf_src', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % necrf_src
end subroutine psget_necrf_src


subroutine psset_necrf_src(iobj, data, ierr)
    !! item list dimension of ecrf_src_name (ecrf_source)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_necrf_src', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % necrf_src = data
end subroutine psset_necrf_src


subroutine psget_nspec_rfmin(iobj, data, ierr)
    !! species list dimension of RFMIN (RF_minority)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_nspec_rfmin', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % nspec_rfmin
end subroutine psget_nspec_rfmin


subroutine psset_nspec_rfmin(iobj, data, ierr)
    !! species list dimension of RFMIN (RF_minority)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_nspec_rfmin', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % nspec_rfmin = data
end subroutine psset_nspec_rfmin


subroutine psget_nnkpollh(iobj, n1, n2, data, ierr)
    !! need description
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_nnkpollh', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % nnkpollh
end subroutine psget_nnkpollh


subroutine psset_nnkpollh(iobj, n1, n2, data, ierr)
    !! need description
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    INTEGER, intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_nnkpollh', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % nnkpollh = data(1:n1, 1: n2)
end subroutine psset_nnkpollh


subroutine psgetrnk_nnkpollh(iobj, ndims, ierr)
    !! need description
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_nnkpollh


subroutine psgetdim_nnkpollh(iobj, ndims, dims, ierr)
    !! need description
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_nnkpollh', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % nnkpollh ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % nnkpollh)
    endif
end subroutine psgetdim_nnkpollh


subroutine psget_nspec_impi(iobj, data, ierr)
    !! species list dimension of SIMPI (impurity_atoms)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_nspec_impi', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % nspec_impi
end subroutine psget_nspec_impi


subroutine psset_nspec_impi(iobj, data, ierr)
    !! species list dimension of SIMPI (impurity_atoms)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_nspec_impi', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % nspec_impi = data
end subroutine psset_nspec_impi


subroutine psget_neqmom(iobj, data, ierr)
    !! item list dimension of eqmom_num (EQ_moments)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_neqmom', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % neqmom
end subroutine psget_neqmom


subroutine psset_neqmom(iobj, data, ierr)
    !! item list dimension of eqmom_num (EQ_moments)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_neqmom', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % neqmom = data
end subroutine psset_neqmom


subroutine psget_nrho_ecrf(iobj, data, ierr)
    !! grid dimension of rho_ecrf (RHO coordinate)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_nrho_ecrf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % nrho_ecrf
end subroutine psget_nrho_ecrf


subroutine psset_nrho_ecrf(iobj, data, ierr)
    !! grid dimension of rho_ecrf (RHO coordinate)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_nrho_ecrf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % nrho_ecrf = data
end subroutine psset_nrho_ecrf


subroutine psget_nrho_mist(iobj, data, ierr)
    !! grid dimension of rho_mist (RHO coordinate)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_nrho_mist', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % nrho_mist
end subroutine psget_nrho_mist


subroutine psset_nrho_mist(iobj, data, ierr)
    !! grid dimension of rho_mist (RHO coordinate)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_nrho_mist', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % nrho_mist = data
end subroutine psset_nrho_mist


subroutine psget_newcomb_code(iobj, n1, data, ierr)
    !! name(s) of Newcomb code(s) used
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    CHARACTER*(*), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_newcomb_code', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % Newcomb_code
end subroutine psget_newcomb_code


subroutine psset_newcomb_code(iobj, n1, data, ierr)
    !! name(s) of Newcomb code(s) used
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    CHARACTER*(*), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_newcomb_code', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % Newcomb_code = data(1:n1)
end subroutine psset_newcomb_code


subroutine psgetsz_newcomb_code(iobj, size, ierr)
    !! name(s) of Newcomb code(s) used
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: size    ! size of character string
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psgetsz_newcomb_code', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! note that the following will return the character length size regardless of
    ! the number of array elements (if Newcomb_code is an array)
    size = len(ss % Newcomb_code)
end subroutine psgetsz_newcomb_code


subroutine psgetrnk_newcomb_code(iobj, ndims, ierr)
    !! name(s) of Newcomb code(s) used
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_newcomb_code


subroutine psgetdim_newcomb_code(iobj, ndims, dims, ierr)
    !! name(s) of Newcomb code(s) used
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_newcomb_code', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % Newcomb_code ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % Newcomb_code)
    endif
end subroutine psgetdim_newcomb_code


subroutine psget_ns_is_input(iobj, n1, data, ierr)
    !! specie density measurement flag
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_ns_is_input', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % ns_is_input
end subroutine psget_ns_is_input


subroutine psset_ns_is_input(iobj, n1, data, ierr)
    !! specie density measurement flag
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_ns_is_input', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % ns_is_input = data(1:n1)
end subroutine psset_ns_is_input


subroutine psgetrnk_ns_is_input(iobj, ndims, ierr)
    !! specie density measurement flag
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_ns_is_input


subroutine psgetdim_ns_is_input(iobj, ndims, dims, ierr)
    !! specie density measurement flag
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_ns_is_input', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % ns_is_input ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % ns_is_input)
    endif
end subroutine psgetdim_ns_is_input


subroutine psget_newcomb_stable(iobj, n1, n2, data, ierr)
    !! 0: stable; 1: unstable;, element (i,j) indicates if toroidal
    !! mode number, Tor_mode_No(i) is stable or unstable according to,
    !! the code Newcomb_code(j)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_newcomb_stable', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % Newcomb_stable
end subroutine psget_newcomb_stable


subroutine psset_newcomb_stable(iobj, n1, n2, data, ierr)
    !! 0: stable; 1: unstable;, element (i,j) indicates if toroidal
    !! mode number, Tor_mode_No(i) is stable or unstable according to,
    !! the code Newcomb_code(j)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    INTEGER, intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_newcomb_stable', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % Newcomb_stable = data(1:n1, 1: n2)
end subroutine psset_newcomb_stable


subroutine psgetrnk_newcomb_stable(iobj, ndims, ierr)
    !! 0: stable; 1: unstable;, element (i,j) indicates if toroidal
    !! mode number, Tor_mode_No(i) is stable or unstable according to,
    !! the code Newcomb_code(j)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_newcomb_stable


subroutine psgetdim_newcomb_stable(iobj, ndims, dims, ierr)
    !! 0: stable; 1: unstable;, element (i,j) indicates if toroidal
    !! mode number, Tor_mode_No(i) is stable or unstable according to,
    !! the code Newcomb_code(j)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_newcomb_stable', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % Newcomb_stable ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % Newcomb_stable)
    endif
end subroutine psgetdim_newcomb_stable

subroutine cstate_ck_grids(dims,nmax,ngrids,igrids)

  !  check item (profile or group of profiles) for grid dimensions
  !  it is assumed that "wgrid" contains the list of grid dimensions

  use cstate_lib_mod
  implicit NONE

  character*(*), intent(in) :: dims
  integer, intent(in) :: nmax      ! max no. of grids

  integer, intent(out) :: ngrids   ! actual no. of grids (0 possible)
  !  CAUTION: if ndims=ngrids, output list may be incomplete...

  integer, intent(out) :: igrids(nmax)   ! the dimension numbers (ref wgrid).

  !---------------------------------
  integer :: ii,inum,jj,iloc,imatch,igot
  character*32 :: locdims(20)  ! 20 a more than reasonable upper bound
  character*32 ztest2(1)
  integer :: loc_lodims(20),ilow2(1)
  !---------------------------------

  ngrids = 0
  igrids = 0

  inum = 0
  if(allocated(list_dims)) inum = size(list_dims)
  if(dims.eq.'scalar') return

  ! extract dims from dims string
  !   typical dims string value: "(1:nrho_fp-1,1:nspec_nonmax)"

  call cstate_extract_dims(dims,size(locdims),iloc,locdims,loc_lodims)

  !  see if any dims are list dims

  do ii=1,iloc
     imatch=0
     do jj=1,inum
        if(locdims(ii).eq.list_dims(jj)) then
           imatch=jj
           exit
        endif
     enddo
     if(imatch.ne.0) cycle

     ! not a list dim, so, must be a grid dim

     if(ngrids.eq.nmax) cycle

     ngrids = ngrids + 1

     imatch=0
     do jj=1,wgrid%size
        call cstate_extract_dims(wgrid%val_field(jj),1,igot,ztest2,ilow2)
        if(ztest2(1).eq.locdims(ii)) then
           imatch=jj
           exit
        endif
     enddo

     if(imatch.eq.0) then
        ngrids=ngrids-1   ! this should not happen

     else
        igrids(ngrids)=imatch
     endif

  enddo

end subroutine cstate_ck_grids

subroutine cstate_grid_info(luntty,ngrids,igrids, &
     gnames,ids,igsizes,cnames,xunits)

  !  check item (profile or group of profiles) for grid dimensions
  !  it is assumed that "wgrid" contains the list of grid dimensions

  use cstate_lib_mod
  implicit NONE

  !----------------------

  integer, intent(in) :: luntty  ! LUN for messages...

  integer, intent(in) :: ngrids  ! number of grids
  integer, intent(in) :: igrids(ngrids)          ! grid numbers in contents...

  character*(*), intent(out) :: gnames(ngrids)   ! grid names
  integer, intent(out) :: ids(ngrids,nsss_cur)   ! the grid IDs
  integer, intent(out) :: igsizes(ngrids,nsss_cur) ! the grid sizes
  character*(*), intent(out) :: cnames(ngrids)   ! coord tag: "rho", "R", "Z", ...
  character*(*), intent(out) :: xunits(ngrids)   ! coord units

  !----------------------
  integer :: ig,igrid,is,ierr,idgot
  character*32 :: gname
  logical :: ifirst(ngrids)
  !----------------------

  ids=0
  igsizes=0
  cnames=' '

  ifirst = .TRUE.

  do is=1,nsss_cur
     call psw_contents('G',ncur_components,wtmp,ierr, state=sss(is))
     if(ierr.ne.0) exit

     do ig=1,ngrids
        igrid=igrids(ig)
        gname = wtmp%list_elems(igrid)
        call ps_gridId(sss(is)%iobj,luntty,gname,idgot,igsizes(ig,is))
        ids(ig,is)=idgot
        if(idgot.gt.0) then
           if(ifirst(ig)) then
              ifirst(ig)=.FALSE.
              gnames(ig)=gname
              call ps_gridCoord(sss(is)%iobj,luntty,ids(ig,is),cnames(ig), &
                   xunits(ig))
              if(cnames(ig).eq.'RHO') cnames(ig)='rho'
              if(cnames(ig).eq.'TH') cnames(ig)='theta'
              if(cnames(ig).eq.'PHI') cnames(ig)='phi'
           endif
        endif
     enddo
  enddo

  if(ierr.ne.0) then
     write(luntty,*) ' ?cstate_grid_info: unexpected error.'
     return
  endif

end subroutine cstate_grid_info

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_p6_dummy
     return
  end subroutine ccps_getset_p6_dummy

subroutine psget_plasma_code_info(iobj, data, ierr)
    !! Information: code managing PLASMA component, (advance of
    !! specie temperatures & densities etc)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    CHARACTER*(*), intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_plasma_code_info', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % PLASMA_Code_Info
end subroutine psget_plasma_code_info


subroutine psset_plasma_code_info(iobj, data, ierr)
    !! Information: code managing PLASMA component, (advance of
    !! specie temperatures & densities etc)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    CHARACTER*(*), intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_plasma_code_info', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % PLASMA_Code_Info = data
end subroutine psset_plasma_code_info


subroutine psgetsz_plasma_code_info(iobj, size, ierr)
    !! Information: code managing PLASMA component, (advance of
    !! specie temperatures & densities etc)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: size    ! size of character string
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psgetsz_plasma_code_info', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! note that the following will return the character length size regardless of
    ! the number of array elements (if PLASMA_Code_Info is an array)
    size = len(ss % PLASMA_Code_Info)
end subroutine psgetsz_plasma_code_info


subroutine psget_pel_data_info(iobj, data, ierr)
    !! Information: on source of pellet injection
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    CHARACTER*(*), intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_pel_data_info', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % PEL_Data_Info
end subroutine psget_pel_data_info


subroutine psset_pel_data_info(iobj, data, ierr)
    !! Information: on source of pellet injection
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    CHARACTER*(*), intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_pel_data_info', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % PEL_Data_Info = data
end subroutine psset_pel_data_info


subroutine psgetsz_pel_data_info(iobj, size, ierr)
    !! Information: on source of pellet injection
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: size    ! size of character string
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psgetsz_pel_data_info', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! note that the following will return the character length size regardless of
    ! the number of array elements (if PEL_Data_Info is an array)
    size = len(ss % PEL_Data_Info)
end subroutine psgetsz_pel_data_info


subroutine psget_prad_br(iobj, n1, data, ierr)
    !! bremsstrahlung contribution
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_prad_br', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % prad_br
end subroutine psget_prad_br


subroutine psset_prad_br(iobj, n1, data, ierr)
    !! bremsstrahlung contribution
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_prad_br', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % prad_br = data(1:n1)
end subroutine psset_prad_br


subroutine psgetrnk_prad_br(iobj, ndims, ierr)
    !! bremsstrahlung contribution
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_prad_br


subroutine psgetdim_prad_br(iobj, ndims, dims, ierr)
    !! bremsstrahlung contribution
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_prad_br', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % prad_br ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % prad_br)
    endif
end subroutine psgetdim_prad_br


subroutine psget_pelh(iobj, n1, data, ierr)
    !! electron heating by LH
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_pelh', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % pelh
end subroutine psget_pelh


subroutine psset_pelh(iobj, n1, data, ierr)
    !! electron heating by LH
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_pelh', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % pelh = data(1:n1)
end subroutine psset_pelh


subroutine psgetrnk_pelh(iobj, ndims, ierr)
    !! electron heating by LH
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_pelh


subroutine psgetdim_pelh(iobj, ndims, dims, ierr)
    !! electron heating by LH
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_pelh', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % pelh ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % pelh)
    endif
end subroutine psgetdim_pelh

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_d7_dummy
     return
  end subroutine ccps_getset_d7_dummy

subroutine psget_diff_transcat(iobj, n1, n2, n3, data, ierr)
    !! specie diffusivity
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2, n3 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2, n3) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_diff_transcat', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2, 1: n3) = ss % diff_transcat
end subroutine psget_diff_transcat


subroutine psset_diff_transcat(iobj, n1, n2, n3, data, ierr)
    !! specie diffusivity
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2, n3 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2, n3) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_diff_transcat', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % diff_transcat = data(1:n1, 1: n2, 1: n3)
end subroutine psset_diff_transcat


subroutine psgetrnk_diff_transcat(iobj, ndims, ierr)
    !! specie diffusivity
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 3
end subroutine psgetrnk_diff_transcat


subroutine psgetdim_diff_transcat(iobj, ndims, dims, ierr)
    !! specie diffusivity
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 3) ierr = 1
    call ccps_argcheck('psgetdim_diff_transcat', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % diff_transcat ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % diff_transcat)
    endif
end subroutine psgetdim_diff_transcat


subroutine psget_difb_rfmi(iobj, n1, data, ierr)
    !! RF minority ion anomalous diffusivity
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_difb_rfmi', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % difb_rfmi
end subroutine psget_difb_rfmi


subroutine psset_difb_rfmi(iobj, n1, data, ierr)
    !! RF minority ion anomalous diffusivity
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_difb_rfmi', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % difb_rfmi = data(1:n1)
end subroutine psset_difb_rfmi


subroutine psgetrnk_difb_rfmi(iobj, ndims, ierr)
    !! RF minority ion anomalous diffusivity
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_difb_rfmi


subroutine psgetdim_difb_rfmi(iobj, ndims, dims, ierr)
    !! RF minority ion anomalous diffusivity
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_difb_rfmi', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % difb_rfmi ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % difb_rfmi)
    endif
end subroutine psgetdim_difb_rfmi


subroutine psget_dz_geo_dth(iobj, n1, n2, data, ierr)
    !! flux surfaces Z(rho,theta)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_dz_geo_dth', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % dZ_geo_dTH
end subroutine psget_dz_geo_dth


subroutine psset_dz_geo_dth(iobj, n1, n2, data, ierr)
    !! flux surfaces Z(rho,theta)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_dz_geo_dth', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % dZ_geo_dTH = data(1:n1, 1: n2)
end subroutine psset_dz_geo_dth


subroutine psgetrnk_dz_geo_dth(iobj, ndims, ierr)
    !! flux surfaces Z(rho,theta)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_dz_geo_dth


subroutine psgetdim_dz_geo_dth(iobj, ndims, dims, ierr)
    !! flux surfaces Z(rho,theta)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_dz_geo_dth', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % dZ_geo_dTH ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % dZ_geo_dTH)
    endif
end subroutine psgetdim_dz_geo_dth

subroutine ps_dbg_plot(iobj,iout,ierr)

  !------------------------------------------------------------
  ! D. McCune Aug 2007
  ! Debug plotting of xplasma contents
  !------------------------------------------------------------

  use plasma_state_definition_mod
  use xplasma_definitions
  use eqi_intg_module
  implicit NONE

  type :: interp_object

     type (xplasma), pointer :: s_xpobj => NULL()

  end type interp_object

  !-----------------------
  !  passed arguments:

  integer :: iobj(ps_container_size)  ! opaque container, xplasma object

  integer, intent(in) :: iout     ! Fortran LUN of file for messages
  integer, intent(out) :: ierr    ! completion status code (0=OK)

  !-----------------------
  ! local:
  type (interp_object) :: xobj
  type (xplasma), pointer :: s
  !-----------------------

  xobj = transfer(iobj,xobj)
  s => xobj%s_xpobj
  call xplasma_global_info(s,ierr, init_check=.TRUE.)
  if(ierr.ne.0) then
     write(iout,*) ' ?ps_dbg_plot: xplasma object invalid or uninitialized.'
     return
  endif

  sp_debug => xobj%s_xpobj
  call xplasma_debug

end subroutine ps_dbg_plot

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


SUBROUTINE plasma_state_empty_alloc_6(ss,iout,ierr)


  ! Allocate array data for which all dimensions are provided

  USE plasma_state_definition_mod
  IMPLICIT NONE

  TYPE (plasma_state) :: ss  ! state containing array elements to be allocated
  INTEGER, INTENT(IN) :: iout
  INTEGER, INTENT(INOUT) :: ierr  ! completion code (not cleared,set on error)

  !-------------------
  INTEGER :: isize,jsize
  !-------------------


  !-----------------------------------------------
  ! allocate arrays...

  isize = (ss%nr)*(ss%nz)
  IF(ALLOCATED(ss%PsiRZ).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%PsiRZ)
  ENDIF
  IF(ALLOCATED(ss%PsiRZ)) then
     jsize = SIZE(ss%PsiRZ)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: PsiRZ already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%PsiRZ(ss%nr,ss%nz))
     ss%PsiRZ = 0.0_rspec
  ENDIF

  isize = (ss%nrho_eq_geo)
  IF(ALLOCATED(ss%psmom_errck).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%psmom_errck)
  ENDIF
  IF(ALLOCATED(ss%psmom_errck)) then
     jsize = SIZE(ss%psmom_errck)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: psmom_errck already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%psmom_errck(ss%nrho_eq_geo))
     ss%psmom_errck = 0.0_rspec
  ENDIF

  isize = (ss%nrho_eq_geo)*(ss%npsmom)
  IF(ALLOCATED(ss%psmom_nc).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%psmom_nc)
  ENDIF
  IF(ALLOCATED(ss%psmom_nc)) then
     jsize = SIZE(ss%psmom_nc)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: psmom_nc already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%psmom_nc(ss%nrho_eq_geo,ss%npsmom))
     ss%psmom_nc = 0.0_rspec
     ALLOCATE(ss%id_psmom_nc(ss%npsmom))
     ss%id_psmom_nc = 0
  ENDIF

  isize = (ss%npsmom)
  IF(ALLOCATED(ss%psmom_num).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%psmom_num)
  ENDIF
  IF(ALLOCATED(ss%psmom_num)) then
     jsize = SIZE(ss%psmom_num)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: psmom_num already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%psmom_num(ss%npsmom))
     ss%psmom_num = " "
  ENDIF

  isize = (ss%nrho_eq)
  IF(ALLOCATED(ss%P_eq).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%P_eq)
  ENDIF
  IF(ALLOCATED(ss%P_eq)) then
     jsize = SIZE(ss%P_eq)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: P_eq already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%P_eq(ss%nrho_eq))
     ss%P_eq = 0.0_rspec
  ENDIF

  isize = (ss%nspec_all+1)
  IF(ss%nspec_all.LE.0) isize = 0
  IF(ALLOCATED(ss%qatom_ALL).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%qatom_ALL)
  ENDIF
  IF(ALLOCATED(ss%qatom_ALL)) then
     jsize = SIZE(ss%qatom_ALL)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: qatom_ALL already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%qatom_ALL(0:ss%nspec_all))
     ss%qatom_ALL = 0.0_rspec
  ENDIF

  isize = (ss%nspec_alla+1)
  IF(ss%nspec_alla.LE.0) isize = 0
  IF(ALLOCATED(ss%qatom_ALLA).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%qatom_ALLA)
  ENDIF
  IF(ALLOCATED(ss%qatom_ALLA)) then
     jsize = SIZE(ss%qatom_ALLA)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: qatom_ALLA already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%qatom_ALLA(0:ss%nspec_alla))
     ss%qatom_ALLA = 0.0_rspec
  ENDIF

  isize = (ss%nspec_rfmin)
  IF(ALLOCATED(ss%qatom_RFMIN).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%qatom_RFMIN)
  ENDIF
  IF(ALLOCATED(ss%qatom_RFMIN)) then
     jsize = SIZE(ss%qatom_RFMIN)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: qatom_RFMIN already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%qatom_RFMIN(ss%nspec_rfmin))
     ss%qatom_RFMIN = 0.0_rspec
  ENDIF

  isize = (ss%nspec_th+1)
  IF(ss%nspec_th.LE.0) isize = 0
  IF(ALLOCATED(ss%qatom_S).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%qatom_S)
  ENDIF
  IF(ALLOCATED(ss%qatom_S)) then
     jsize = SIZE(ss%qatom_S)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: qatom_S already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%qatom_S(0:ss%nspec_th))
     ss%qatom_S = 0.0_rspec
  ENDIF

  isize = (ss%nspec_tha+1)
  IF(ss%nspec_tha.LE.0) isize = 0
  IF(ALLOCATED(ss%qatom_SA).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%qatom_SA)
  ENDIF
  IF(ALLOCATED(ss%qatom_SA)) then
     jsize = SIZE(ss%qatom_SA)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: qatom_SA already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%qatom_SA(0:ss%nspec_tha))
     ss%qatom_SA = 0.0_rspec
  ENDIF

  isize = (ss%nspec_fusion)
  IF(ALLOCATED(ss%qatom_SFUS).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%qatom_SFUS)
  ENDIF
  IF(ALLOCATED(ss%qatom_SFUS)) then
     jsize = SIZE(ss%qatom_SFUS)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: qatom_SFUS already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%qatom_SFUS(ss%nspec_fusion))
     ss%qatom_SFUS = 0.0_rspec
  ENDIF

  isize = (ss%nspec_gas)
  IF(ALLOCATED(ss%qatom_SGAS).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%qatom_SGAS)
  ENDIF
  IF(ALLOCATED(ss%qatom_SGAS)) then
     jsize = SIZE(ss%qatom_SGAS)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: qatom_SGAS already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%qatom_SGAS(ss%nspec_gas))
     ss%qatom_SGAS = 0.0_rspec
  ENDIF

  isize = (ss%nspec_imp0)
  IF(ALLOCATED(ss%qatom_SIMP0).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%qatom_SIMP0)
  ENDIF
  IF(ALLOCATED(ss%qatom_SIMP0)) then
     jsize = SIZE(ss%qatom_SIMP0)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: qatom_SIMP0 already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%qatom_SIMP0(ss%nspec_imp0))
     ss%qatom_SIMP0 = 0.0_rspec
  ENDIF

  isize = (ss%nspec_impi)
  IF(ALLOCATED(ss%qatom_SIMPI).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%qatom_SIMPI)
  ENDIF
  IF(ALLOCATED(ss%qatom_SIMPI)) then
     jsize = SIZE(ss%qatom_SIMPI)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: qatom_SIMPI already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%qatom_SIMPI(ss%nspec_impi))
     ss%qatom_SIMPI = 0.0_rspec
  ENDIF

  isize = (ss%nspec_beam)
  IF(ALLOCATED(ss%qatom_SNBI).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%qatom_SNBI)
  ENDIF
  IF(ALLOCATED(ss%qatom_SNBI)) then
     jsize = SIZE(ss%qatom_SNBI)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: qatom_SNBI already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%qatom_SNBI(ss%nspec_beam))
     ss%qatom_SNBI = 0.0_rspec
  ENDIF

  isize = (ss%nrho_nbi-1)*(ss%nspec_beam)
  IF(ALLOCATED(ss%qbeami).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%qbeami)
  ENDIF
  IF(ALLOCATED(ss%qbeami)) then
     jsize = SIZE(ss%qbeami)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: qbeami already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%qbeami(ss%nrho_nbi-1,ss%nspec_beam))
     ss%qbeami = 0.0_rspec
     ALLOCATE(ss%id_qbeami(ss%nspec_beam))
     ss%id_qbeami = 0
  ENDIF

  isize = (ss%nrho-1)
  IF(ALLOCATED(ss%qcomp_e).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%qcomp_e)
  ENDIF
  IF(ALLOCATED(ss%qcomp_e)) then
     jsize = SIZE(ss%qcomp_e)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: qcomp_e already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%qcomp_e(ss%nrho-1))
     ss%qcomp_e = 0.0_rspec
  ENDIF

  isize = (ss%nrho-1)
  IF(ALLOCATED(ss%qcomp_i).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%qcomp_i)
  ENDIF
  IF(ALLOCATED(ss%qcomp_i)) then
     jsize = SIZE(ss%qcomp_i)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: qcomp_i already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%qcomp_i(ss%nrho-1))
     ss%qcomp_i = 0.0_rspec
  ENDIF

  isize = (ss%nrho-1)
  IF(ALLOCATED(ss%qie).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%qie)
  ENDIF
  IF(ALLOCATED(ss%qie)) then
     jsize = SIZE(ss%qie)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: qie already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%qie(ss%nrho-1))
     ss%qie = 0.0_rspec
  ENDIF

  isize = (ss%nrho_gas-1)*(ss%ngsc0)
  IF(ALLOCATED(ss%qioniz).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%qioniz)
  ENDIF
  IF(ALLOCATED(ss%qioniz)) then
     jsize = SIZE(ss%qioniz)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: qioniz already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%qioniz(ss%nrho_gas-1,ss%ngsc0))
     ss%qioniz = 0.0_rspec
     ALLOCATE(ss%id_qioniz(ss%ngsc0))
     ss%id_qioniz = 0
  ENDIF

  isize = (ss%nspec_alla+1)
  IF(ss%nspec_alla.LE.0) isize = 0
  IF(ALLOCATED(ss%ql_operator).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%ql_operator)
  ENDIF
  IF(ALLOCATED(ss%ql_operator)) then
     jsize = SIZE(ss%ql_operator)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: ql_operator already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%ql_operator(0:ss%nspec_alla))
     ss%ql_operator = " "
  ENDIF

  isize = (ss%nrho_gas-1)*(ss%ngsc0)
  IF(ALLOCATED(ss%qqcx).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%qqcx)
  ENDIF
  IF(ALLOCATED(ss%qqcx)) then
     jsize = SIZE(ss%qqcx)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: qqcx already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%qqcx(ss%nrho_gas-1,ss%ngsc0))
     ss%qqcx = 0.0_rspec
     ALLOCATE(ss%id_qqcx(ss%ngsc0))
     ss%id_qqcx = 0
  ENDIF

  isize = (ss%nrho-1)
  IF(ALLOCATED(ss%qrot_conv).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%qrot_conv)
  ENDIF
  IF(ALLOCATED(ss%qrot_conv)) then
     jsize = SIZE(ss%qrot_conv)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: qrot_conv already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%qrot_conv(ss%nrho-1))
     ss%qrot_conv = 0.0_rspec
  ENDIF

  isize = (ss%nrho-1)
  IF(ALLOCATED(ss%qrot_diff).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%qrot_diff)
  ENDIF
  IF(ALLOCATED(ss%qrot_diff)) then
     jsize = SIZE(ss%qrot_diff)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: qrot_diff already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%qrot_diff(ss%nrho-1))
     ss%qrot_diff = 0.0_rspec
  ENDIF

  isize = (ss%nspec_all+1)
  IF(ss%nspec_all.LE.0) isize = 0
  IF(ALLOCATED(ss%q_ALL).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%q_ALL)
  ENDIF
  IF(ALLOCATED(ss%q_ALL)) then
     jsize = SIZE(ss%q_ALL)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: q_ALL already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%q_ALL(0:ss%nspec_all))
     ss%q_ALL = 0.0_rspec
  ENDIF

  isize = (ss%nspec_alla+1)
  IF(ss%nspec_alla.LE.0) isize = 0
  IF(ALLOCATED(ss%q_ALLA).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%q_ALLA)
  ENDIF
  IF(ALLOCATED(ss%q_ALLA)) then
     jsize = SIZE(ss%q_ALLA)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: q_ALLA already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%q_ALLA(0:ss%nspec_alla))
     ss%q_ALLA = 0.0_rspec
  ENDIF

  isize = (ss%nrho_eq)
  IF(ALLOCATED(ss%q_eq).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%q_eq)
  ENDIF
  IF(ALLOCATED(ss%q_eq)) then
     jsize = SIZE(ss%q_eq)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: q_eq already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%q_eq(ss%nrho_eq))
     ss%q_eq = 0.0_rspec
  ENDIF

  isize = (ss%nspec_rfmin)
  IF(ALLOCATED(ss%q_RFMIN).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%q_RFMIN)
  ENDIF
  IF(ALLOCATED(ss%q_RFMIN)) then
     jsize = SIZE(ss%q_RFMIN)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: q_RFMIN already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%q_RFMIN(ss%nspec_rfmin))
     ss%q_RFMIN = 0.0_rspec
  ENDIF

  isize = (ss%nspec_th+1)
  IF(ss%nspec_th.LE.0) isize = 0
  IF(ALLOCATED(ss%q_S).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%q_S)
  ENDIF
  IF(ALLOCATED(ss%q_S)) then
     jsize = SIZE(ss%q_S)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: q_S already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%q_S(0:ss%nspec_th))
     ss%q_S = 0.0_rspec
  ENDIF

  isize = (ss%nspec_tha+1)
  IF(ss%nspec_tha.LE.0) isize = 0
  IF(ALLOCATED(ss%q_SA).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%q_SA)
  ENDIF
  IF(ALLOCATED(ss%q_SA)) then
     jsize = SIZE(ss%q_SA)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: q_SA already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%q_SA(0:ss%nspec_tha))
     ss%q_SA = 0.0_rspec
  ENDIF

  isize = (ss%nspec_fusion)
  IF(ALLOCATED(ss%q_SFUS).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%q_SFUS)
  ENDIF
  IF(ALLOCATED(ss%q_SFUS)) then
     jsize = SIZE(ss%q_SFUS)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: q_SFUS already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%q_SFUS(ss%nspec_fusion))
     ss%q_SFUS = 0.0_rspec
  ENDIF

  isize = (ss%nspec_gas)
  IF(ALLOCATED(ss%q_SGAS).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%q_SGAS)
  ENDIF
  IF(ALLOCATED(ss%q_SGAS)) then
     jsize = SIZE(ss%q_SGAS)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: q_SGAS already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%q_SGAS(ss%nspec_gas))
     ss%q_SGAS = 0.0_rspec
  ENDIF

  isize = (ss%nspec_imp0)
  IF(ALLOCATED(ss%q_SIMP0).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%q_SIMP0)
  ENDIF
  IF(ALLOCATED(ss%q_SIMP0)) then
     jsize = SIZE(ss%q_SIMP0)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: q_SIMP0 already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%q_SIMP0(ss%nspec_imp0))
     ss%q_SIMP0 = 0.0_rspec
  ENDIF

  isize = (ss%nspec_impi)
  IF(ALLOCATED(ss%q_SIMPI).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%q_SIMPI)
  ENDIF
  IF(ALLOCATED(ss%q_SIMPI)) then
     jsize = SIZE(ss%q_SIMPI)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: q_SIMPI already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%q_SIMPI(ss%nspec_impi))
     ss%q_SIMPI = 0.0_rspec
  ENDIF

  isize = (ss%nspec_beam)
  IF(ALLOCATED(ss%q_SNBI).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%q_SNBI)
  ENDIF
  IF(ALLOCATED(ss%q_SNBI)) then
     jsize = SIZE(ss%q_SNBI)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: q_SNBI already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%q_SNBI(ss%nspec_beam))
     ss%q_SNBI = 0.0_rspec
  ENDIF

  isize = (ss%nrho_eq)
  IF(ALLOCATED(ss%R0_momeq).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%R0_momeq)
  ENDIF
  IF(ALLOCATED(ss%R0_momeq)) then
     jsize = SIZE(ss%R0_momeq)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: R0_momeq already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%R0_momeq(ss%nrho_eq))
     ss%R0_momeq = 0.0_rspec
  ENDIF

  isize = (ss%nrho_nbi-1)*(ss%nspec_gas)
  IF(ALLOCATED(ss%rate_sinb0i).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%rate_sinb0i)
  ENDIF
  IF(ALLOCATED(ss%rate_sinb0i)) then
     jsize = SIZE(ss%rate_sinb0i)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: rate_sinb0i already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%rate_sinb0i(ss%nrho_nbi-1,ss%nspec_gas))
     ss%rate_sinb0i = 0.0_rspec
     ALLOCATE(ss%id_rate_sinb0i(ss%nspec_gas))
     ss%id_rate_sinb0i = 0
  ENDIF

  isize = (ss%nrho_nbi-1)*(ss%nspec_gas)
  IF(ALLOCATED(ss%rate_sinb0x).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%rate_sinb0x)
  ENDIF
  IF(ALLOCATED(ss%rate_sinb0x)) then
     jsize = SIZE(ss%rate_sinb0x)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: rate_sinb0x already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%rate_sinb0x(ss%nrho_nbi-1,ss%nspec_gas))
     ss%rate_sinb0x = 0.0_rspec
     ALLOCATE(ss%id_rate_sinb0x(ss%nspec_gas))
     ss%id_rate_sinb0x = 0
  ENDIF

  isize = (ss%nrho_nbi-1)*(ss%nspec_gas)*(ss%nspec_beam)
  IF(ALLOCATED(ss%rate_sinb0xs).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%rate_sinb0xs)
  ENDIF
  IF(ALLOCATED(ss%rate_sinb0xs)) then
     jsize = SIZE(ss%rate_sinb0xs)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: rate_sinb0xs already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%rate_sinb0xs(ss%nrho_nbi-1,ss%nspec_gas,ss%nspec_beam))
     ss%rate_sinb0xs = 0.0_rspec
     ALLOCATE(ss%id_rate_sinb0xs(ss%nspec_gas,ss%nspec_beam))
     ss%id_rate_sinb0xs = 0
  ENDIF

  isize = (ss%nrho_fus-1)*(ss%nspec_gas)
  IF(ALLOCATED(ss%rate_sinf0i).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%rate_sinf0i)
  ENDIF
  IF(ALLOCATED(ss%rate_sinf0i)) then
     jsize = SIZE(ss%rate_sinf0i)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: rate_sinf0i already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%rate_sinf0i(ss%nrho_fus-1,ss%nspec_gas))
     ss%rate_sinf0i = 0.0_rspec
     ALLOCATE(ss%id_rate_sinf0i(ss%nspec_gas))
     ss%id_rate_sinf0i = 0
  ENDIF

  isize = (ss%nrho_fus-1)*(ss%nspec_gas)
  IF(ALLOCATED(ss%rate_sinf0x).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%rate_sinf0x)
  ENDIF
  IF(ALLOCATED(ss%rate_sinf0x)) then
     jsize = SIZE(ss%rate_sinf0x)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: rate_sinf0x already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%rate_sinf0x(ss%nrho_fus-1,ss%nspec_gas))
     ss%rate_sinf0x = 0.0_rspec
     ALLOCATE(ss%id_rate_sinf0x(ss%nspec_gas))
     ss%id_rate_sinf0x = 0
  ENDIF

  isize = (ss%nrho_fus-1)*(ss%nspec_gas)*(ss%nspec_fusion)
  IF(ALLOCATED(ss%rate_sinf0xs).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%rate_sinf0xs)
  ENDIF
  IF(ALLOCATED(ss%rate_sinf0xs)) then
     jsize = SIZE(ss%rate_sinf0xs)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: rate_sinf0xs already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%rate_sinf0xs(ss%nrho_fus-1,ss%nspec_gas,ss%nspec_fusion))
     ss%rate_sinf0xs = 0.0_rspec
     ALLOCATE(ss%id_rate_sinf0xs(ss%nspec_gas,ss%nspec_fusion))
     ss%id_rate_sinf0xs = 0
  ENDIF

  isize = (ss%max_num_nphi_vac)*(ss%nicrf_src)
  IF(ALLOCATED(ss%Real_ant_coef).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%Real_ant_coef)
  ENDIF
  IF(ALLOCATED(ss%Real_ant_coef)) then
     jsize = SIZE(ss%Real_ant_coef)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: Real_ant_coef already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%Real_ant_coef(ss%max_num_nphi_vac,ss%nicrf_src))
     ss%Real_ant_coef = 0.0_rspec
  ENDIF

  isize = (ss%nrho-1)*(ss%nspec_th+1)
  IF(ss%nspec_th.LE.0) isize = 0
  IF(ALLOCATED(ss%res_sn).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%res_sn)
  ENDIF
  IF(ALLOCATED(ss%res_sn)) then
     jsize = SIZE(ss%res_sn)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: res_sn already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%res_sn(ss%nrho-1,0:ss%nspec_th))
     ss%res_sn = 0.0_rspec
     ALLOCATE(ss%id_res_sn(0:ss%nspec_th))
     ss%id_res_sn = 0
  ENDIF

  isize = (ss%nrho-1)
  IF(ALLOCATED(ss%res_te).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%res_te)
  ENDIF
  IF(ALLOCATED(ss%res_te)) then
     jsize = SIZE(ss%res_te)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: res_te already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%res_te(ss%nrho-1))
     ss%res_te = 0.0_rspec
  ENDIF

  isize = (ss%nrho-1)
  IF(ALLOCATED(ss%res_ti).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%res_ti)
  ENDIF
  IF(ALLOCATED(ss%res_ti)) then
     jsize = SIZE(ss%res_ti)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: res_ti already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%res_ti(ss%nrho-1))
     ss%res_ti = 0.0_rspec
  ENDIF

  isize = (ss%nrho-1)
  IF(ALLOCATED(ss%res_tq).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%res_tq)
  ENDIF
  IF(ALLOCATED(ss%res_tq)) then
     jsize = SIZE(ss%res_tq)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: res_tq already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%res_tq(ss%nrho-1))
     ss%res_tq = 0.0_rspec
  ENDIF

  isize = (ss%nspec_rfmin)
  IF(ALLOCATED(ss%RFMIN_name).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%RFMIN_name)
  ENDIF
  IF(ALLOCATED(ss%RFMIN_name)) then
     jsize = SIZE(ss%RFMIN_name)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: RFMIN_name already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%RFMIN_name(ss%nspec_rfmin))
     ss%RFMIN_name = " "
  ENDIF

  isize = (ss%nspec_rfmin)
  IF(ALLOCATED(ss%rfmin_to_all).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%rfmin_to_all)
  ENDIF
  IF(ALLOCATED(ss%rfmin_to_all)) then
     jsize = SIZE(ss%rfmin_to_all)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: rfmin_to_all already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%rfmin_to_all(ss%nspec_rfmin))
     ss%rfmin_to_all = 0
  ENDIF

  isize = (ss%nspec_rfmin)
  IF(ALLOCATED(ss%rfmin_to_alla).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%rfmin_to_alla)
  ENDIF
  IF(ALLOCATED(ss%rfmin_to_alla)) then
     jsize = SIZE(ss%rfmin_to_alla)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: rfmin_to_alla already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%rfmin_to_alla(ss%nspec_rfmin))
     ss%rfmin_to_alla = 0
  ENDIF

  isize = (ss%nspec_rfmin)
  IF(ALLOCATED(ss%RFMIN_type).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%RFMIN_type)
  ENDIF
  IF(ALLOCATED(ss%RFMIN_type)) then
     jsize = SIZE(ss%RFMIN_type)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: RFMIN_type already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%RFMIN_type(ss%nspec_rfmin))
     ss%RFMIN_type = 0
  ENDIF

  isize = (ss%nrho)
  IF(ALLOCATED(ss%rho).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%rho)
  ENDIF
  IF(ALLOCATED(ss%rho)) then
     jsize = SIZE(ss%rho)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: rho already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%rho(ss%nrho))
     ss%rho = 0.0_rspec
  ENDIF

  isize = (ss%max_nspectrumlh_src)*(ss%nlhrf_src)
  IF(ALLOCATED(ss%rhopsi0lh).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%rhopsi0lh)
  ENDIF
  IF(ALLOCATED(ss%rhopsi0lh)) then
     jsize = SIZE(ss%rhopsi0lh)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: rhopsi0lh already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%rhopsi0lh(ss%max_nspectrumlh_src,ss%nlhrf_src))
     ss%rhopsi0lh = 0.0_rspec
  ENDIF

  isize = (ss%nrho_anom)
  IF(ALLOCATED(ss%rho_anom).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%rho_anom)
  ENDIF
  IF(ALLOCATED(ss%rho_anom)) then
     jsize = SIZE(ss%rho_anom)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: rho_anom already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%rho_anom(ss%nrho_anom))
     ss%rho_anom = 0.0_rspec
  ENDIF

  isize = (ss%nrho_anom2)
  IF(ALLOCATED(ss%rho_anom2).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%rho_anom2)
  ENDIF
  IF(ALLOCATED(ss%rho_anom2)) then
     jsize = SIZE(ss%rho_anom2)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: rho_anom2 already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%rho_anom2(ss%nrho_anom2))
     ss%rho_anom2 = 0.0_rspec
  ENDIF

  isize = (ss%nrho_anomth)
  IF(ALLOCATED(ss%rho_anomth).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%rho_anomth)
  ENDIF
  IF(ALLOCATED(ss%rho_anomth)) then
     jsize = SIZE(ss%rho_anomth)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: rho_anomth already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%rho_anomth(ss%nrho_anomth))
     ss%rho_anomth = 0.0_rspec
  ENDIF

  isize = (ss%nspec_th+1)
  IF(ss%nspec_th.LE.0) isize = 0
  IF(ALLOCATED(ss%rho_bdy_ns).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%rho_bdy_ns)
  ENDIF
  IF(ALLOCATED(ss%rho_bdy_ns)) then
     jsize = SIZE(ss%rho_bdy_ns)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: rho_bdy_ns already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%rho_bdy_ns(0:ss%nspec_th))
     ss%rho_bdy_ns = 0.0_rspec
  ENDIF

  isize = (ss%nrho_ecrf)
  IF(ALLOCATED(ss%rho_ecrf).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%rho_ecrf)
  ENDIF
  IF(ALLOCATED(ss%rho_ecrf)) then
     jsize = SIZE(ss%rho_ecrf)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: rho_ecrf already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%rho_ecrf(ss%nrho_ecrf))
     ss%rho_ecrf = 0.0_rspec
  ENDIF

  isize = (ss%nrho_eq)
  IF(ALLOCATED(ss%rho_eq).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%rho_eq)
  ENDIF
  IF(ALLOCATED(ss%rho_eq)) then
     jsize = SIZE(ss%rho_eq)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: rho_eq already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%rho_eq(ss%nrho_eq))
     ss%rho_eq = 0.0_rspec
  ENDIF

  isize = (ss%nrho_eq_geo)
  IF(ALLOCATED(ss%rho_eq_geo).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%rho_eq_geo)
  ENDIF
  IF(ALLOCATED(ss%rho_eq_geo)) then
     jsize = SIZE(ss%rho_eq_geo)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: rho_eq_geo already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%rho_eq_geo(ss%nrho_eq_geo))
     ss%rho_eq_geo = 0.0_rspec
  ENDIF

  isize = (ss%nrho_fus)
  IF(ALLOCATED(ss%rho_fus).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%rho_fus)
  ENDIF
  IF(ALLOCATED(ss%rho_fus)) then
     jsize = SIZE(ss%rho_fus)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: rho_fus already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%rho_fus(ss%nrho_fus))
     ss%rho_fus = 0.0_rspec
  ENDIF

  isize = (ss%nrho_gas)
  IF(ALLOCATED(ss%rho_gas).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%rho_gas)
  ENDIF
  IF(ALLOCATED(ss%rho_gas)) then
     jsize = SIZE(ss%rho_gas)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: rho_gas already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%rho_gas(ss%nrho_gas))
     ss%rho_gas = 0.0_rspec
  ENDIF

  isize = (ss%nrho_icrf)
  IF(ALLOCATED(ss%rho_icrf).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%rho_icrf)
  ENDIF
  IF(ALLOCATED(ss%rho_icrf)) then
     jsize = SIZE(ss%rho_icrf)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: rho_icrf already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%rho_icrf(ss%nrho_icrf))
     ss%rho_icrf = 0.0_rspec
  ENDIF

  isize = (ss%nrho_lhrf)
  IF(ALLOCATED(ss%rho_lhrf).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%rho_lhrf)
  ENDIF
  IF(ALLOCATED(ss%rho_lhrf)) then
     jsize = SIZE(ss%rho_lhrf)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: rho_lhrf already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%rho_lhrf(ss%nrho_lhrf))
     ss%rho_lhrf = 0.0_rspec
  ENDIF

  isize = (ss%nrho_lmhd)
  IF(ALLOCATED(ss%rho_lmhd).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%rho_lmhd)
  ENDIF
  IF(ALLOCATED(ss%rho_lmhd)) then
     jsize = SIZE(ss%rho_lmhd)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: rho_lmhd already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%rho_lmhd(ss%nrho_lmhd))
     ss%rho_lmhd = 0.0_rspec
  ENDIF

  isize = (ss%nrho_mist)
  IF(ALLOCATED(ss%rho_mist).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%rho_mist)
  ENDIF
  IF(ALLOCATED(ss%rho_mist)) then
     jsize = SIZE(ss%rho_mist)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: rho_mist already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%rho_mist(ss%nrho_mist))
     ss%rho_mist = 0.0_rspec
  ENDIF

  isize = (ss%nrho_nbi)
  IF(ALLOCATED(ss%rho_nbi).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%rho_nbi)
  ENDIF
  IF(ALLOCATED(ss%rho_nbi)) then
     jsize = SIZE(ss%rho_nbi)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: rho_nbi already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%rho_nbi(ss%nrho_nbi))
     ss%rho_nbi = 0.0_rspec
  ENDIF

  isize = (ss%nrho_pel)
  IF(ALLOCATED(ss%rho_pel).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%rho_pel)
  ENDIF
  IF(ALLOCATED(ss%rho_pel)) then
     jsize = SIZE(ss%rho_pel)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: rho_pel already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%rho_pel(ss%nrho_pel))
     ss%rho_pel = 0.0_rspec
  ENDIF

  isize = (ss%nrho_rad)
  IF(ALLOCATED(ss%rho_rad).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%rho_rad)
  ENDIF
  IF(ALLOCATED(ss%rho_rad)) then
     jsize = SIZE(ss%rho_rad)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: rho_rad already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%rho_rad(ss%nrho_rad))
     ss%rho_rad = 0.0_rspec
  ENDIF

  isize = (ss%nrho_rw)
  IF(ALLOCATED(ss%rho_rw).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%rho_rw)
  ENDIF
  IF(ALLOCATED(ss%rho_rw)) then
     jsize = SIZE(ss%rho_rw)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: rho_rw already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%rho_rw(ss%nrho_rw))
     ss%rho_rw = 0.0_rspec
  ENDIF

  isize = (ss%num_rzlim)
  IF(ALLOCATED(ss%rlim).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%rlim)
  ENDIF
  IF(ALLOCATED(ss%rlim)) then
     jsize = SIZE(ss%rlim)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: rlim already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%rlim(ss%num_rzlim))
     ss%rlim = 0.0_rspec
  ENDIF

END SUBROUTINE plasma_state_empty_alloc_6

subroutine cstate_extract_dims(dims,nmax,iloc,locdims,lowdims)

  !  from original dimension string (e.g. "0:nspec_th") extract the
  !  root dimensions (e.g. nspec_th).

  use cstate_lib_mod
  implicit NONE

  character*(*), intent(in) :: dims
  integer, intent(in) :: nmax      ! max no. of extracted dimensions

  integer, intent(out) :: iloc
  character*(*), intent(out), dimension(nmax) :: locdims  ! dim names
  integer, intent(out), dimension(nmax) :: lowdims        ! dim lower limit

  ! examples:
  ! "(0:nspec_th)" -> iloc=1, locdims(1)="nspec_th",lowdims(1)=0
  ! "(nbeam,0:nspec_nonMax)" -> iloc=2, locdims(1:2) = "nbeam", "nspec_nonmax"
  !                                     lowdims(1:2) = 1, 0

  !---------------------------------
  integer :: ic,ic1,ic2,ilow,il1,il2,inclow
  character*6 :: zlow
  !---------------------------------

  locdims(1:nmax)=' '
  lowdims(1:nmax)=0
  iloc = 0

  ic = 0
  ic2 = len(dims) + 1

  ! extract dims from dims string
  !   typical dims string value: "(1:nrho_fp-1,1:nspec_nonmax)"

  ilow=1
  il1=2
  il2=1

  do
     ic = ic + 1
     if((dims(ic:ic).eq.',').or.(dims(ic:ic).eq.')')) then
        ic2=min(ic2,ic-1)
        iloc = iloc + 1
        if(iloc.le.nmax) then
           locdims(iloc) = dims(ic1:ic2)
           call ulower(locdims(iloc))

           if(il2.ge.il1) then
              zlow=' '
              inclow=il2-il1+1
              zlow(6-inclow+1:6)=dims(il1:il2)
              read(zlow,'(I6)') ilow
           endif
           lowdims(iloc)=ilow

           if(dims(ic:ic).eq.')') exit
        endif

        ic1 = ic + 1
        ic2 = len(dims) + 1

        ilow = 1
        il1 = ic + 1

     endif

     if(dims(ic:ic).eq.'(') then
        ic1 = ic + 1
        il1 = ic + 1
     endif

     if(dims(ic:ic).eq.':') then
        il2 = ic - 1
        ic1 = ic + 1
     endif

     if(dims(ic:ic).eq.'-') ic2 = ic - 1
  enddo

end subroutine cstate_extract_dims

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_r5_dummy
     return
  end subroutine ccps_getset_r5_dummy

subroutine psget_r_min_box(iobj, data, ierr)
    !! R_min of bounding box
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_r_min_box', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % R_min_box
end subroutine psget_r_min_box


subroutine psset_r_min_box(iobj, data, ierr)
    !! R_min of bounding box
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_r_min_box', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % R_min_box = data
end subroutine psset_r_min_box


subroutine psget_r_ec_launch(iobj, n1, data, ierr)
    !! R of center of launcher
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_r_ec_launch', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % R_EC_launch
end subroutine psget_r_ec_launch


subroutine psset_r_ec_launch(iobj, n1, data, ierr)
    !! R of center of launcher
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_r_ec_launch', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % R_EC_launch = data(1:n1)
end subroutine psset_r_ec_launch


subroutine psgetrnk_r_ec_launch(iobj, ndims, ierr)
    !! R of center of launcher
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_r_ec_launch


subroutine psgetdim_r_ec_launch(iobj, ndims, dims, ierr)
    !! R of center of launcher
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_r_ec_launch', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % R_EC_launch ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % R_EC_launch)
    endif
end subroutine psgetdim_r_ec_launch


subroutine psget_r_grid(iobj, n1, data, ierr)
    !! R grid
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_r_grid', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % R_grid
end subroutine psget_r_grid


subroutine psset_r_grid(iobj, n1, data, ierr)
    !! R grid
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_r_grid', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % R_grid = data(1:n1)
end subroutine psset_r_grid


subroutine psgetrnk_r_grid(iobj, ndims, ierr)
    !! R grid
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_r_grid


subroutine psgetdim_r_grid(iobj, ndims, dims, ierr)
    !! R grid
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_r_grid', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % R_grid ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % R_grid)
    endif
end subroutine psgetdim_r_grid


subroutine psget_r_midp_out(iobj, n1, data, ierr)
    !! R (low field side) midplane intercept
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_r_midp_out', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % R_midp_out
end subroutine psget_r_midp_out


subroutine psset_r_midp_out(iobj, n1, data, ierr)
    !! R (low field side) midplane intercept
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_r_midp_out', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % R_midp_out = data(1:n1)
end subroutine psset_r_midp_out


subroutine psgetrnk_r_midp_out(iobj, ndims, ierr)
    !! R (low field side) midplane intercept
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_r_midp_out


subroutine psgetdim_r_midp_out(iobj, ndims, dims, ierr)
    !! R (low field side) midplane intercept
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_r_midp_out', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % R_midp_out ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % R_midp_out)
    endif
end subroutine psgetdim_r_midp_out


subroutine psget_rate_sinb0i(iobj, n1, n2, data, ierr)
    !! sink rate due to ionization by beam ions
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_rate_sinb0i', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % rate_sinb0i
end subroutine psget_rate_sinb0i


subroutine psset_rate_sinb0i(iobj, n1, n2, data, ierr)
    !! sink rate due to ionization by beam ions
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_rate_sinb0i', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % rate_sinb0i = data(1:n1, 1: n2)
end subroutine psset_rate_sinb0i


subroutine psgetrnk_rate_sinb0i(iobj, ndims, ierr)
    !! sink rate due to ionization by beam ions
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_rate_sinb0i


subroutine psgetdim_rate_sinb0i(iobj, ndims, dims, ierr)
    !! sink rate due to ionization by beam ions
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_rate_sinb0i', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % rate_sinb0i ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % rate_sinb0i)
    endif
end subroutine psgetdim_rate_sinb0i


subroutine psget_rate_sinf0x(iobj, n1, n2, data, ierr)
    !! sink rate due to CX with fusion ions (total)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_rate_sinf0x', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % rate_sinf0x
end subroutine psget_rate_sinf0x


subroutine psset_rate_sinf0x(iobj, n1, n2, data, ierr)
    !! sink rate due to CX with fusion ions (total)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_rate_sinf0x', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % rate_sinf0x = data(1:n1, 1: n2)
end subroutine psset_rate_sinf0x


subroutine psgetrnk_rate_sinf0x(iobj, ndims, ierr)
    !! sink rate due to CX with fusion ions (total)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_rate_sinf0x


subroutine psgetdim_rate_sinf0x(iobj, ndims, dims, ierr)
    !! sink rate due to CX with fusion ions (total)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_rate_sinf0x', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % rate_sinf0x ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % rate_sinf0x)
    endif
end subroutine psgetdim_rate_sinf0x

subroutine ps_time_set(iobj,curtime,iout,ierr)

  !  Update plasma state time
  !  XPLASMA2 implementation -- DMC Oct 10 2006

  !------------------------------------------------------------

  use plasma_state_definition_mod
  use plasma_state_xpobj  ! XPLASMA2 state object definitions
  implicit NONE

  !-----------------------
  !  passed:

  integer :: iobj(ps_container_size)     ! xplasma opaque container
  REAL(KIND=rspec), intent(in) :: curtime  ! time to assign
  integer, intent(in) :: iout     ! Fortran LUN for messages
  integer, intent(out) :: ierr    ! exit status code 0=OK

  !-------------------------------------------------------------------------
  type (interp_object) :: xobj
  type (xplasma), pointer :: s
  !-------------------------------------------------------------------------
  ! executable code...

  xobj = transfer(iobj,xobj)
  s => xobj%s_xpobj

  call xplasma_global_info(s,ierr, init_check=.TRUE.)
  if(ierr.ne.0) then
     write(iout,*) ' %ps_time_set: invalid or unitialized xplasma object.'
     return
  endif

  !----------------------

  call xplasma_time_set(s,curtime,ierr)
  if(ierr.ne.0) then
     write(iout,*) ' ?ps_time_set: unexpected error in xplasma_time_set:'
     call xplasma_error(s,iout,ierr)
  endif

end subroutine ps_time_set

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_i1_dummy
     return
  end subroutine ccps_getset_i1_dummy

subroutine psget_id_v_pars(iobj, n1, data, ierr)
    !! 'Array of IDs for v_pars profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_v_pars', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_v_pars
end subroutine psget_id_v_pars


subroutine psgetrnk_id_v_pars(iobj, ndims, ierr)
    !! 'Array of IDs for v_pars profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_v_pars


subroutine psgetdim_id_v_pars(iobj, ndims, dims, ierr)
    !! 'Array of IDs for v_pars profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_v_pars', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_v_pars ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_v_pars)
    endif
end subroutine psgetdim_id_v_pars


subroutine psget_id_fi_depletion(iobj, data, ierr)
    !! 'ID for Fi_depletion profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_fi_depletion', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_fi_depletion
end subroutine psget_id_fi_depletion


subroutine psget_id_qie(iobj, data, ierr)
    !! 'ID for qie profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_qie', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_qie
end subroutine psget_id_qie


subroutine psget_id_pi_trans(iobj, data, ierr)
    !! 'ID for pi_trans profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_pi_trans', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_pi_trans
end subroutine psget_id_pi_trans


subroutine psget_id_vn_trans(iobj, n1, data, ierr)
    !! 'Array of IDs for vn_trans profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_vn_trans', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_vn_trans
end subroutine psget_id_vn_trans


subroutine psgetrnk_id_vn_trans(iobj, ndims, ierr)
    !! 'Array of IDs for vn_trans profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_vn_trans


subroutine psgetdim_id_vn_trans(iobj, ndims, dims, ierr)
    !! 'Array of IDs for vn_trans profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_vn_trans', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_vn_trans ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_vn_trans)
    endif
end subroutine psgetdim_id_vn_trans


subroutine psget_id_vie_transcat(iobj, n1, data, ierr)
    !! 'Array of IDs for vie_transcat profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_vie_transcat', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_vie_transcat
end subroutine psget_id_vie_transcat


subroutine psgetrnk_id_vie_transcat(iobj, ndims, ierr)
    !! 'Array of IDs for vie_transcat profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_vie_transcat


subroutine psgetdim_id_vie_transcat(iobj, ndims, dims, ierr)
    !! 'Array of IDs for vie_transcat profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_vie_transcat', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_vie_transcat ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_vie_transcat)
    endif
end subroutine psgetdim_id_vie_transcat


subroutine psget_id_area(iobj, data, ierr)
    !! 'ID for area profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_area', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_area
end subroutine psget_id_area


subroutine psget_id_r0_momeq(iobj, data, ierr)
    !! 'ID for R0_momeq profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_r0_momeq', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_r0_momeq
end subroutine psget_id_r0_momeq


subroutine psget_id_gr2i(iobj, data, ierr)
    !! 'ID for gr2i profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_gr2i', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_gr2i
end subroutine psget_id_gr2i


subroutine psget_id_grirhoi(iobj, data, ierr)
    !! 'ID for grirhoi profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_grirhoi', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_grirhoi
end subroutine psget_id_grirhoi


subroutine psget_id_gncfh(iobj, data, ierr)
    !! 'ID for gncfh profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_gncfh', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_gncfh
end subroutine psget_id_gncfh


subroutine psget_id_b_surfmin(iobj, data, ierr)
    !! 'ID for B_surfMin profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_b_surfmin', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_b_surfmin
end subroutine psget_id_b_surfmin


subroutine psget_id_triang_miller_l(iobj, data, ierr)
    !! 'ID for triang_miller_L profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_triang_miller_l', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_triang_miller_l
end subroutine psget_id_triang_miller_l


subroutine psget_id_pminth(iobj, data, ierr)
    !! 'ID for pminth profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_pminth', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_pminth
end subroutine psget_id_pminth


subroutine psget_id_pbi(iobj, data, ierr)
    !! 'ID for pbi profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_pbi', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_pbi
end subroutine psget_id_pbi


subroutine psget_id_sbehalo(iobj, data, ierr)
    !! 'ID for sbehalo profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_sbehalo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_sbehalo
end subroutine psget_id_sbehalo


subroutine psget_id_omeg0_halo(iobj, n1, data, ierr)
    !! 'Array of IDs for omeg0_halo profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_omeg0_halo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_omeg0_halo
end subroutine psget_id_omeg0_halo


subroutine psgetrnk_id_omeg0_halo(iobj, ndims, ierr)
    !! 'Array of IDs for omeg0_halo profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_omeg0_halo


subroutine psgetdim_id_omeg0_halo(iobj, ndims, dims, ierr)
    !! 'Array of IDs for omeg0_halo profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_omeg0_halo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_omeg0_halo ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_omeg0_halo)
    endif
end subroutine psgetdim_id_omeg0_halo


subroutine psget_id_pfusth(iobj, data, ierr)
    !! 'ID for pfusth profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_pfusth', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_pfusth
end subroutine psget_id_pfusth


subroutine psget_id_nrw(iobj, data, ierr)
    !! 'ID for nrw profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_nrw', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_nrw
end subroutine psget_id_nrw


subroutine psget_id_tqioniz(iobj, n1, data, ierr)
    !! 'Array of IDs for tqioniz profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_tqioniz', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_tqioniz
end subroutine psget_id_tqioniz


subroutine psgetrnk_id_tqioniz(iobj, ndims, ierr)
    !! 'Array of IDs for tqioniz profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_tqioniz


subroutine psgetdim_id_tqioniz(iobj, ndims, dims, ierr)
    !! 'Array of IDs for tqioniz profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_tqioniz', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_tqioniz ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_tqioniz)
    endif
end subroutine psgetdim_id_tqioniz


subroutine psget_id_s0reco_recap(iobj, n1, data, ierr)
    !! 'Array of IDs for s0reco_recap profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_s0reco_recap', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_s0reco_recap
end subroutine psget_id_s0reco_recap


subroutine psgetrnk_id_s0reco_recap(iobj, ndims, ierr)
    !! 'Array of IDs for s0reco_recap profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_s0reco_recap


subroutine psgetdim_id_s0reco_recap(iobj, ndims, dims, ierr)
    !! 'Array of IDs for s0reco_recap profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_s0reco_recap', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_s0reco_recap ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_s0reco_recap)
    endif
end subroutine psgetdim_id_s0reco_recap


subroutine psget_id_omeg0_reco(iobj, n1, data, ierr)
    !! 'Array of IDs for omeg0_reco profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_omeg0_reco', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_omeg0_reco
end subroutine psget_id_omeg0_reco


subroutine psgetrnk_id_omeg0_reco(iobj, ndims, ierr)
    !! 'Array of IDs for omeg0_reco profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_omeg0_reco


subroutine psgetdim_id_omeg0_reco(iobj, ndims, dims, ierr)
    !! 'Array of IDs for omeg0_reco profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_omeg0_reco', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_omeg0_reco ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_omeg0_reco)
    endif
end subroutine psgetdim_id_omeg0_reco


subroutine psget_id_curlh_src(iobj, n1, data, ierr)
    !! 'Array of IDs for curlh_src profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_curlh_src', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_curlh_src
end subroutine psget_id_curlh_src


subroutine psgetrnk_id_curlh_src(iobj, ndims, ierr)
    !! 'Array of IDs for curlh_src profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_curlh_src


subroutine psgetdim_id_curlh_src(iobj, ndims, dims, ierr)
    !! 'Array of IDs for curlh_src profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_curlh_src', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_curlh_src ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_curlh_src)
    endif
end subroutine psgetdim_id_curlh_src


subroutine psget_id_anom_evar(iobj, data, ierr)
    !! 'ID for anom_evar profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_anom_evar', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_anom_evar
end subroutine psget_id_anom_evar


subroutine psget_id_bidiff_dpass_co(iobj, n1, data, ierr)
    !! 'Array of IDs for bidiff_dpass_co profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_bidiff_dpass_co', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_bidiff_dpass_co
end subroutine psget_id_bidiff_dpass_co


subroutine psgetrnk_id_bidiff_dpass_co(iobj, ndims, ierr)
    !! 'Array of IDs for bidiff_dpass_co profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_bidiff_dpass_co


subroutine psgetdim_id_bidiff_dpass_co(iobj, ndims, dims, ierr)
    !! 'Array of IDs for bidiff_dpass_co profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_bidiff_dpass_co', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_bidiff_dpass_co ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_bidiff_dpass_co)
    endif
end subroutine psgetdim_id_bidiff_dpass_co


subroutine psget_id_velns_anom(iobj, n1, data, ierr)
    !! 'Array of IDs for velns_anom profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_velns_anom', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_velns_anom
end subroutine psget_id_velns_anom


subroutine psgetrnk_id_velns_anom(iobj, ndims, ierr)
    !! 'Array of IDs for velns_anom profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_velns_anom


subroutine psgetdim_id_velns_anom(iobj, ndims, dims, ierr)
    !! 'Array of IDs for velns_anom profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_velns_anom', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_velns_anom ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_velns_anom)
    endif
end subroutine psgetdim_id_velns_anom


subroutine psget_id_nz_ky_tglf(iobj, n1, data, ierr)
    !! 'Array of IDs for nz_ky_tglf profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_nz_ky_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_nz_ky_tglf
end subroutine psget_id_nz_ky_tglf


subroutine psgetrnk_id_nz_ky_tglf(iobj, ndims, ierr)
    !! 'Array of IDs for nz_ky_tglf profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_nz_ky_tglf


subroutine psgetdim_id_nz_ky_tglf(iobj, ndims, dims, ierr)
    !! 'Array of IDs for nz_ky_tglf profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_nz_ky_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_nz_ky_tglf ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_nz_ky_tglf)
    endif
end subroutine psgetdim_id_nz_ky_tglf


subroutine psget_id_pot_ky_tglf(iobj, n1, data, ierr)
    !! 'Array of IDs for pot_ky_tglf profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_pot_ky_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_pot_ky_tglf
end subroutine psget_id_pot_ky_tglf


subroutine psgetrnk_id_pot_ky_tglf(iobj, ndims, ierr)
    !! 'Array of IDs for pot_ky_tglf profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_pot_ky_tglf


subroutine psgetdim_id_pot_ky_tglf(iobj, ndims, dims, ierr)
    !! 'Array of IDs for pot_ky_tglf profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_pot_ky_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_pot_ky_tglf ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_pot_ky_tglf)
    endif
end subroutine psgetdim_id_pot_ky_tglf


subroutine psget_id_dqidgrdte_tglf(iobj, data, ierr)
    !! 'ID for dQidGrdte_tglf profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_dqidgrdte_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_dqidgrdte_tglf
end subroutine psget_id_dqidgrdte_tglf


subroutine psget_id_chiphi_mmm71(iobj, data, ierr)
    !! 'ID for chiphi_mmm71 profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_chiphi_mmm71', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_chiphi_mmm71
end subroutine psget_id_chiphi_mmm71


subroutine psget_id_chie_w19(iobj, data, ierr)
    !! 'ID for chie_w19 profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_chie_w19', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_chie_w19
end subroutine psget_id_chie_w19


subroutine psget_id_freq_drbm(iobj, data, ierr)
    !! 'ID for freq_drbm profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_freq_drbm', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_freq_drbm
end subroutine psget_id_freq_drbm


subroutine psget_id_freq_glf(iobj, data, ierr)
    !! 'ID for freq_glf profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_freq_glf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_freq_glf
end subroutine psget_id_freq_glf


subroutine psget_id_chii_gtcneo(iobj, data, ierr)
    !! 'ID for chii_gtcneo profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_chii_gtcneo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_chii_gtcneo
end subroutine psget_id_chii_gtcneo


subroutine psget_id_difns_neo(iobj, n1, data, ierr)
    !! 'Array of IDs for difns_neo profiles'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_difns_neo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % id_difns_neo
end subroutine psget_id_difns_neo


subroutine psgetrnk_id_difns_neo(iobj, ndims, ierr)
    !! 'Array of IDs for difns_neo profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_id_difns_neo


subroutine psgetdim_id_difns_neo(iobj, ndims, dims, ierr)
    !! 'Array of IDs for difns_neo profiles'
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_id_difns_neo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % id_difns_neo ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % id_difns_neo)
    endif
end subroutine psgetdim_id_difns_neo


subroutine psget_id_difnx_nclass(iobj, data, ierr)
    !! 'ID for difnx_nclass profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_difnx_nclass', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_difnx_nclass
end subroutine psget_id_difnx_nclass


subroutine psget_id_tmodel(iobj, data, ierr)
    !! 'ID for tmodel profile'
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    INTEGER, intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_id_tmodel', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % id_tmodel
end subroutine psget_id_tmodel

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


SUBROUTINE plasma_state_store_def_7(ss,icdf,iout,iertot)


  !  define subset of variables and arrays for NetCDF file

  USE plasma_state_definition_mod
  USE netcdf
  IMPLICIT NONE

  TYPE (plasma_state) :: ss     ! state data to read
  INTEGER, INTENT(IN) :: icdf   ! NetCDF file ID
  INTEGER, INTENT(IN) :: iout   ! message LUN
  INTEGER, INTENT(INOUT) :: iertot  ! error count

  !--------------

  INTEGER :: varid,dimid,status,ival,idims(20),indim
  CHARACTER*80 :: nc_errmsg

  !--------------
  !  define variables...


  IF(ALLOCATED(ss%Rloc_coil)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_ncoils",idims(indim))
     CALL define_var("Rloc_coil","R",indim,idims, &
            "R location of coil, lower left corner", &
            "m","EQ","MACHINE_DESCRIPTION", &
            "R|units=m  Rloc_coil(ncoils)")
  ENDIF

  IF(ALLOCATED(ss%Rmajor_mean)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_eq_geo",idims(indim))
     CALL define_var("Rmajor_mean","R",indim,idims, &
            "Rmajor_mean = (R_Surfmax+R_surfmin)/2", &
            "m","EQ","STATE_PROFILES", &
            "R|pclin  Rmajor_mean(nrho_eq_geo)")
  ENDIF

  IF(ALLOCATED(ss%rMinor_mean)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_eq_geo",idims(indim))
     CALL define_var("rMinor_mean","R",indim,idims, &
            "rMinor_mean = (R_Surfmax-R_surfmin)/2", &
            "m","EQ","STATE_PROFILES", &
            "R|pclin  rMinor_mean(nrho_eq_geo)")
  ENDIF

  indim = 1
  status = nf90_inq_dimid(icdf,"ps_clen_80",idims(1))
  CALL define_var("RUNAWAY_Code_Info","C*80",indim,idims, &
         "Information: code implementing RUNAWAY component", &
         "__NONE","RUNAWAY","SIMULATION_INIT", &
         "C*80   RUNAWAY_Code_Info")

  indim = 1
  status = nf90_inq_dimid(icdf,"ps_clen_32",idims(1))
  CALL define_var("RunID","N",indim,idims, &
         "Run ID", &
         "__NONE","PLASMA","SIMULATION_INIT", &
         "N      RunID")

  IF(ALLOCATED(ss%R_ant)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nicrf_src",idims(indim))
     CALL define_var("R_ant","R",indim,idims, &
            "major radius of antenna", &
            "m","IC","SHOT_CONFIGURATION", &
            "R|units=m R_ant(nicrf_src)")
  ENDIF

  IF(ALLOCATED(ss%R_antgeo)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_max_nrz_antgeo",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nicrf_src",idims(indim))
     CALL define_var("R_antgeo","R",indim,idims, &
            "antenna geo: R pts", &
            "m","IC","MACHINE_DESCRIPTION", &
            "R|units=m R_antgeo(nrz_antgeo(),nicrf_src)")
  ENDIF

  indim = 0
  CALL define_var("R_axis","R",indim,idims, &
         "R of magnetic axis", &
         "m","EQ","STATE_DATA", &
         "R  R_axis")

  IF(ALLOCATED(ss%R_EC_launch)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_necrf_src",idims(indim))
     CALL define_var("R_EC_launch","R",indim,idims, &
            "R of center of launcher", &
            "m","EC","MACHINE_DESCRIPTION", &
            "R|units=m   R_EC_launch(necrf_src)")
  ENDIF

  IF(ALLOCATED(ss%R_geo)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_eq",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nth_eq",idims(indim))
     CALL define_var("R_geo","R",indim,idims, &
            "flux surfaces R(rho,theta)", &
            "m","EQ","STATE_PROFILES", &
            "R|units=m|Hermite_explicit R_geo(nrho_eq,nth_eq)")
  ENDIF

  IF(ALLOCATED(ss%R_grid)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nr",idims(indim))
     CALL define_var("R_grid","R",indim,idims, &
            "R grid", &
            "m","EQ","SIMULATION_INIT", &
            "G   R_grid(nR)")
  ENDIF

  indim = 0
  CALL define_var("R_max_box","R",indim,idims, &
         "R_max of bounding box", &
         "m","EQ","MACHINE_DESCRIPTION", &
         "R  R_max_box")

  indim = 0
  CALL define_var("R_max_lcfs","R",indim,idims, &
         "R_max of last closed flux surface", &
         "m","EQ","STATE_DATA", &
         "R  R_max_lcfs")

  IF(ALLOCATED(ss%R_midp_in)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_eq_geo",idims(indim))
     CALL define_var("R_midp_in","R",indim,idims, &
            "R (high field side) midplane intercept", &
            "m","EQ","STATE_PROFILES", &
            "R|pclin  R_midp_in(nrho_eq_geo)")
  ENDIF

  IF(ALLOCATED(ss%R_midp_out)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_eq_geo",idims(indim))
     CALL define_var("R_midp_out","R",indim,idims, &
            "R (low field side) midplane intercept", &
            "m","EQ","STATE_PROFILES", &
            "R|pclin  R_midp_out(nrho_eq_geo)")
  ENDIF

  indim = 0
  CALL define_var("R_min_box","R",indim,idims, &
         "R_min of bounding box", &
         "m","EQ","MACHINE_DESCRIPTION", &
         "R  R_min_box")

  indim = 0
  CALL define_var("R_min_lcfs","R",indim,idims, &
         "R_min of last closed flux surface", &
         "m","EQ","STATE_DATA", &
         "R  R_min_lcfs")

  IF(ALLOCATED(ss%R_ripple)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nr_rip",idims(indim))
     CALL define_var("R_ripple","R",indim,idims, &
            "R grid for TF ripple field(s)", &
            "m","RIPPLE","SIMULATION_INIT", &
            "G  R_ripple(nR_rip)")
  ENDIF

  IF(ALLOCATED(ss%R_surfMax)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_eq_geo",idims(indim))
     CALL define_var("R_surfMax","R",indim,idims, &
            "max R on flux surface", &
            "m","EQ","STATE_PROFILES", &
            "R|pclin  R_surfMax(nrho_eq_geo)")
  ENDIF

  IF(ALLOCATED(ss%R_surfMin)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_eq_geo",idims(indim))
     CALL define_var("R_surfMin","R",indim,idims, &
            "min R on flux surface", &
            "m","EQ","STATE_PROFILES", &
            "R|pclin  R_surfMin(nrho_eq_geo)")
  ENDIF

  IF(ALLOCATED(ss%s0reco)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_gas",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nspec_gas",idims(indim))
     CALL define_var("s0reco","R",indim,idims, &
            "recombination neutral sce", &
            "#/sec","GAS","STATE_PROFILES", &
            "R|step*dV|units=#/sec s0reco(~nrho_gas,nspec_gas)")
  ENDIF

  IF(ALLOCATED(ss%s0reco_e)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_gas",idims(indim))
     CALL define_var("s0reco_e","R",indim,idims, &
            "net electron source associated with recombination:", &
            "#/sec","GAS","STATE_PROFILES", &
            "R|step*dV|units=#/sec s0reco_e(~nrho_gas)")
  ENDIF

  IF(ALLOCATED(ss%s0reco_recap)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_gas",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nspec_gas",idims(indim))
     CALL define_var("s0reco_recap","R",indim,idims, &
            "recombination neutrals recapture", &
            "#/sec","GAS","STATE_PROFILES", &
            "R|step*dV|units=#/sec s0reco_recap(~nrho_gas,nspec_gas)")
  ENDIF

  IF(ALLOCATED(ss%sa_index)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dp1_nspec_all",idims(indim))
     CALL define_var("sa_index","I",indim,idims, &
            "species index in original lists", &
            "__NONE","PLASMA","SIMULATION_INIT", &
            "I sa_index(0:nspec_all)")
  ENDIF

  IF(ALLOCATED(ss%SA_name)) THEN
     indim = 1
     status = nf90_inq_dimid(icdf,"ps_clen_32",idims(1))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dp1_nspec_tha",idims(indim))
     CALL define_var("SA_name","N",indim,idims, &
            "thermal species abridged", &
            "__NONE","PLASMA","SIMULATION_INIT", &
            "S|thermal_specie  SA(0:nspec_tha)")
  ENDIF

  IF(ALLOCATED(ss%SA_type)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dp1_nspec_tha",idims(indim))
     CALL define_var("SA_type","I",indim,idims, &
            "SA specie types", &
            "__NONE","PLASMA","SIMULATION_INIT", &
            "S|thermal_specie  SA(0:nspec_tha)")
  ENDIF

  IF(ALLOCATED(ss%sb0halo)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_nbi",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nspec_gas",idims(indim))
     CALL define_var("sb0halo","R",indim,idims, &
            "beam dep cx sink", &
            "#/sec","NBI","STATE_PROFILES", &
            "R|step*dV|units=#/sec sb0halo(~nrho_nbi,nspec_gas)")
  ENDIF

  IF(ALLOCATED(ss%sb0halo_recap)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_nbi",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nspec_gas",idims(indim))
     CALL define_var("sb0halo_recap","R",indim,idims, &
            "cx neutral recapture", &
            "#/sec","NBI","STATE_PROFILES", &
            "R|step*dV|units=#/sec sb0halo_recap(~nrho_nbi,nspec_gas)")
  ENDIF

  IF(ALLOCATED(ss%sbedep)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_nbi",idims(indim))
     CALL define_var("sbedep","R",indim,idims, &
            "beam deposition cold electron sce", &
            "#/sec","NBI","STATE_PROFILES", &
            "R|step*dV|units=#/sec sbedep(~nrho_nbi)")
  ENDIF

  IF(ALLOCATED(ss%sbehalo)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_nbi",idims(indim))
     CALL define_var("sbehalo","R",indim,idims, &
            "cold electron sce due to", &
            "#/sec","NBI","STATE_PROFILES", &
            "R|step*dV|units=#/sec sbehalo(~nrho_nbi)")
  ENDIF

  IF(ALLOCATED(ss%sbsce)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_nbi",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dp1_nspec_tha",idims(indim))
     CALL define_var("sbsce","R",indim,idims, &
            "net source, thermal ions & electrons", &
            "#/sec","NBI","STATE_PROFILES", &
            "R|step*dV|units=#/sec   sbsce(~nrho_nbi,0:nspec_tha)")
  ENDIF

  IF(ALLOCATED(ss%sbtherm)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_nbi",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nspec_beam",idims(indim))
     CALL define_var("sbtherm","R",indim,idims, &
            "beam ion thermalization", &
            "#/sec","NBI","STATE_PROFILES", &
            "R|step*dV|units=#/sec sbtherm(~nrho_nbi,nspec_beam)")
  ENDIF

  IF(ALLOCATED(ss%sc0)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_ngsc0",idims(indim))
     CALL define_var("sc0","R",indim,idims, &
            "edge neutral sources (atoms/sec)", &
            "#/sec","GAS","STATE_DATA", &
            "R|units=#/sec  sc0(ngsc0)")
  ENDIF

  IF(ALLOCATED(ss%sc0_to_sgas)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_ngsc0",idims(indim))
     CALL define_var("sc0_to_sgas","I",indim,idims, &
            "index map from neutral source to neutral species", &
            "__NONE","GAS","SIMULATION_INIT", &
            "I  sc0_to_sgas(ngsc0)")
  ENDIF

  IF(ALLOCATED(ss%sc_anom)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_anomth",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dp1_nspec_th",idims(indim))
     CALL define_var("sc_anom","R",indim,idims, &
            "anomalous sources", &
            "#/sec","ANOM","STATE_PROFILES", &
            "R|units=#/sec|step*dV sc_anom(~nrho_anomth,0:nspec_th)")
  ENDIF

  IF(ALLOCATED(ss%sfsce)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_fus",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dp1_nspec_tha",idims(indim))
     CALL define_var("sfsce","R",indim,idims, &
            "net thermalization source of fusion ions", &
            "#/sec","FUS","STATE_PROFILES", &
            "R|step*dV|units=#/sec   sfsce(~nrho_fus,0:nspec_tha)")
  ENDIF

  IF(ALLOCATED(ss%sftherm)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_fus",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nspec_fusion",idims(indim))
     CALL define_var("sftherm","R",indim,idims, &
            "fusion ion thermalization", &
            "#/sec","FUS","STATE_PROFILES", &
            "R|step*dV|units=#/sec   sftherm(~nrho_fus,nspec_fusion)")
  ENDIF

  IF(ALLOCATED(ss%SFUS_name)) THEN
     indim = 1
     status = nf90_inq_dimid(icdf,"ps_clen_32",idims(1))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nspec_fusion",idims(indim))
     CALL define_var("SFUS_name","N",indim,idims, &
            "fusion product ion species", &
            "__NONE","FUS","SHOT_CONFIGURATION", &
            "S|fusion_ion   SFUS(nspec_fusion)")
  ENDIF

  IF(ALLOCATED(ss%sfus_to_all)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nspec_fusion",idims(indim))
     CALL define_var("sfus_to_all","I",indim,idims, &
            'map sfus index to "all" list', &
            "__NONE","PLASMA","SIMULATION_INIT", &
            "I  sfus_to_all(nspec_fusion)")
  ENDIF

  IF(ALLOCATED(ss%sfus_to_alla)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nspec_fusion",idims(indim))
     CALL define_var("sfus_to_alla","I",indim,idims, &
            'map sfus index to "alla" list', &
            "__NONE","PLASMA","SIMULATION_INIT", &
            "I  sfus_to_alla(nspec_fusion)")
  ENDIF

  IF(ALLOCATED(ss%SFUS_type)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nspec_fusion",idims(indim))
     CALL define_var("SFUS_type","I",indim,idims, &
            "SFUS specie types", &
            "__NONE","FUS","SHOT_CONFIGURATION", &
            "S|fusion_ion   SFUS(nspec_fusion)")
  ENDIF

  IF(ALLOCATED(ss%SGAS_name)) THEN
     indim = 1
     status = nf90_inq_dimid(icdf,"ps_clen_32",idims(1))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nspec_gas",idims(indim))
     CALL define_var("SGAS_name","N",indim,idims, &
            "atomic neutral species in plasma core", &
            "__NONE","GAS","SIMULATION_INIT", &
            "S|neutral_gas  SGAS(nspec_gas)")
  ENDIF

  IF(ALLOCATED(ss%sgas_to_s)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nspec_gas",idims(indim))
     CALL define_var("sgas_to_s","I",indim,idims, &
            'map sgas index to "s" list', &
            "__NONE","GAS","SIMULATION_INIT", &
            "I  sgas_to_s(nspec_gas)")
  ENDIF

  IF(ALLOCATED(ss%SGAS_type)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nspec_gas",idims(indim))
     CALL define_var("SGAS_type","I",indim,idims, &
            "SGAS specie types", &
            "__NONE","GAS","SIMULATION_INIT", &
            "S|neutral_gas  SGAS(nspec_gas)")
  ENDIF

  indim = 0
  CALL define_var("shot_number","I",indim,idims, &
         "integer shot number", &
         "__NONE","PLASMA","SHOT_CONFIGURATION", &
         "I shot_number")

  IF(ALLOCATED(ss%sii_xs)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_mist",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dp1_nspec_th",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nxs",idims(indim))
     CALL define_var("sii_xs","R",indim,idims, &
            "species source/sinks driven by xs(1:nxs)", &
            "(#/sec)/(#/sec)","RAD","STATE_PROFILES", &
            "R|step*dV|units=(#/sec)/(#/sec) sii_xs(~nrho_mist,0:nspec_th,nxs)")
  ENDIF

  IF(ALLOCATED(ss%SIMP0_name)) THEN
     indim = 1
     status = nf90_inq_dimid(icdf,"ps_clen_32",idims(1))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nspec_imp0",idims(indim))
     CALL define_var("SIMP0_name","N",indim,idims, &
            "atomic impurity species in simulation", &
            "__NONE","GAS","SIMULATION_INIT", &
            "S|impurity_atoms SIMP0(nspec_imp0)")
  ENDIF

  IF(ALLOCATED(ss%simp0_to_s)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nspec_imp0",idims(indim))
     CALL define_var("simp0_to_s","I",indim,idims, &
            'map simp0 index to "s" list', &
            "__NONE","GAS","SIMULATION_INIT", &
            "I  simp0_to_s(nspec_imp0)")
  ENDIF

  IF(ALLOCATED(ss%SIMP0_type)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nspec_imp0",idims(indim))
     CALL define_var("SIMP0_type","I",indim,idims, &
            "SIMP0 specie types", &
            "__NONE","GAS","SIMULATION_INIT", &
            "S|impurity_atoms SIMP0(nspec_imp0)")
  ENDIF

  IF(ALLOCATED(ss%SIMPI_name)) THEN
     indim = 1
     status = nf90_inq_dimid(icdf,"ps_clen_32",idims(1))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nspec_impi",idims(indim))
     CALL define_var("SIMPI_name","N",indim,idims, &
            "impurity ion species in simulation", &
            "__NONE","PLASMA","SIMULATION_INIT", &
            "S|impurity_atoms SIMPI(nspec_impi)")
  ENDIF

  IF(ALLOCATED(ss%simpi_to_s)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nspec_impi",idims(indim))
     CALL define_var("simpi_to_s","I",indim,idims, &
            'map simpi index to "s" list', &
            "__NONE","PLASMA","SIMULATION_INIT", &
            "I  simpi_to_s(nspec_impi)")
  ENDIF

  IF(ALLOCATED(ss%SIMPI_type)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nspec_impi",idims(indim))
     CALL define_var("SIMPI_type","I",indim,idims, &
            "SIMPI specie types", &
            "__NONE","PLASMA","SIMULATION_INIT", &
            "S|impurity_atoms SIMPI(nspec_impi)")
  ENDIF

  IF(ALLOCATED(ss%SNBI_name)) THEN
     indim = 1
     status = nf90_inq_dimid(icdf,"ps_clen_32",idims(1))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nspec_beam",idims(indim))
     CALL define_var("SNBI_name","N",indim,idims, &
            "beam ion species", &
            "__NONE","NBI","SIMULATION_INIT", &
            "S|beam_ion     SNBI(nspec_beam)")
  ENDIF

  IF(ALLOCATED(ss%snbi_to_all)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nspec_beam",idims(indim))
     CALL define_var("snbi_to_all","I",indim,idims, &
            'map snbi index to "all" list', &
            "__NONE","PLASMA","SIMULATION_INIT", &
            "I  snbi_to_all(nspec_beam)")
  ENDIF

  IF(ALLOCATED(ss%snbi_to_alla)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nspec_beam",idims(indim))
     CALL define_var("snbi_to_alla","I",indim,idims, &
            'map snbi index to "alla" list', &
            "__NONE","PLASMA","SIMULATION_INIT", &
            "I  snbi_to_alla(nspec_beam)")
  ENDIF

  IF(ALLOCATED(ss%SNBI_type)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nspec_beam",idims(indim))
     CALL define_var("SNBI_type","I",indim,idims, &
            "SNBI specie types", &
            "__NONE","NBI","SIMULATION_INIT", &
            "S|beam_ion     SNBI(nspec_beam)")
  ENDIF

  IF(ALLOCATED(ss%sn_trans)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dp1_nspec_th",idims(indim))
     CALL define_var("sn_trans","R",indim,idims, &
            "particle transport (loss)", &
            "#/sec","PLASMA","STATE_PROFILES", &
            "R|units=#/sec|step*dV sn_trans(~nrho,0:nspec_th)")
  ENDIF

  IF(ALLOCATED(ss%sn_transcat)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dp1_nspec_th",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_ntrcat",idims(indim))
     CALL define_var("sn_transcat","R",indim,idims, &
            "species transport", &
            "#/sec","PLASMA","STATE_PROFILES", &
            "R|step*dV|units=#/sec  sn_transcat(~nrho,0:nspec_th,ntrcat)")
  ENDIF

  IF(ALLOCATED(ss%sprof0)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_gas",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nspec_gas",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_ngsc0",idims(indim))
     CALL define_var("sprof0","R",indim,idims, &
            "gas species source/sinks per unit species influx", &
            "(#/sec)/(#/sec)","GAS","STATE_PROFILES", &
            "R|step*dV|units=(#/sec)/(#/sec)  sprof0(~nrho_gas,nspec_gas,ngsc0)")
  ENDIF

  IF(ALLOCATED(ss%sprof0e)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_gas",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_ngsc0",idims(indim))
     CALL define_var("sprof0e","R",indim,idims, &
            "electron source per unit neutral species influx", &
            "(#/sec)/(#/sec)","GAS","STATE_PROFILES", &
            "R|step*dV|units=(#/sec)/(#/sec)  sprof0e(~nrho_gas,ngsc0)")
  ENDIF

  IF(ALLOCATED(ss%spsce)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_pel",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dp1_nspec_tha",idims(indim))
     CALL define_var("spsce","R",indim,idims, &
            "net source, thermal ions & electrons", &
            "#/sec","PEL","STATE_PROFILES", &
            "R|step*dV|units=#/sec   spsce(~nrho_pel,0:nspec_tha)")
  ENDIF

  IF(ALLOCATED(ss%squareLO)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_eq_geo",idims(indim))
     CALL define_var("squareLO","R",indim,idims, &
            "lower outer squareness", &
            "-","EQ","STATE_PROFILES", &
            "R|pclin  squareLO(nrho_eq_geo)")
  ENDIF

  IF(ALLOCATED(ss%squareUO)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_eq_geo",idims(indim))
     CALL define_var("squareUO","R",indim,idims, &
            "upper outer squareness", &
            "-","EQ","STATE_PROFILES", &
            "R|pclin  squareUO(nrho_eq_geo)")
  ENDIF

  IF(ALLOCATED(ss%sRtcen)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nbeam",idims(indim))
     CALL define_var("sRtcen","R",indim,idims, &
            "signed tangency radius", &
            "m","NBI","MACHINE_DESCRIPTION", &
            "R|units=m       sRtcen(nbeam)")
  ENDIF

  IF(ALLOCATED(ss%surf)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_eq",idims(indim))
     CALL define_var("surf","R",indim,idims, &
            "area of flux surfaces", &
            "m^2","EQ","STATE_PROFILES", &
            "R|units=m^2|Spline surf(nrho_eq)")
  ENDIF

  IF(ALLOCATED(ss%S_name)) THEN
     indim = 1
     status = nf90_inq_dimid(icdf,"ps_clen_32",idims(1))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dp1_nspec_th",idims(indim))
     CALL define_var("S_name","N",indim,idims, &
            "thermal species list", &
            "__NONE","PLASMA","SHOT_CONFIGURATION", &
            "S|thermal_specie  S(0:nspec_th)")
  ENDIF

  IF(ALLOCATED(ss%s_to_sa)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dp1_nspec_th",idims(indim))
     CALL define_var("s_to_sa","I",indim,idims, &
            "address in sa species list", &
            "__NONE","PLASMA","SIMULATION_INIT", &
            "I s_to_sa(0:nspec_th)")
  ENDIF

  IF(ALLOCATED(ss%S_type)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dp1_nspec_th",idims(indim))
     CALL define_var("S_type","I",indim,idims, &
            "S specie types", &
            "__NONE","PLASMA","SHOT_CONFIGURATION", &
            "S|thermal_specie  S(0:nspec_th)")
  ENDIF

  indim = 0
  CALL define_var("t0","R",indim,idims, &
         "time at beginning of IPS macro timestep", &
         "sec","PLASMA","STATE_DATA", &
         "R  t0")

  IF(ALLOCATED(ss%T0cx)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_gas",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_ngsc0",idims(indim))
     CALL define_var("T0cx","R",indim,idims, &
            "effective neutral temperature for CX power", &
            "keV","GAS","STATE_PROFILES", &
            "R|step*qqcx|units=keV  T0cx(~nrho_gas,ngsc0)")
  ENDIF

  IF(ALLOCATED(ss%T0sc0)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_gas",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nspec_gas",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_ngsc0",idims(indim))
     CALL define_var("T0sc0","R",indim,idims, &
            "neutral temperature (2/3)<E0>", &
            "keV","GAS","STATE_PROFILES", &
            "R|step*n0norm|units=keV        T0sc0(~nrho_gas,nspec_gas,ngsc0)")
  ENDIF

  IF(ALLOCATED(ss%T0_halo)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_nbi",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nspec_gas",idims(indim))
     CALL define_var("T0_halo","R",indim,idims, &
            "halo neutral temperature (2/3)<E0>", &
            "keV","NBI","STATE_PROFILES", &
            "R|units=keV|step*n0_halo  T0_halo(~nrho_nbi,nspec_gas)")
  ENDIF

  IF(ALLOCATED(ss%T0_reco)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_gas",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nspec_gas",idims(indim))
     CALL define_var("T0_reco","R",indim,idims, &
            "reco neutral temperature (2/3)<E0>", &
            "keV","GAS","STATE_PROFILES", &
            "R|units=keV|step*n0_reco  T0_reco(~nrho_gas,nspec_gas)")
  ENDIF

  indim = 0
  CALL define_var("t1","R",indim,idims, &
         "time at end of IPS macro timestep", &
         "sec","PLASMA","STATE_DATA", &
         "R  t1")

  IF(ALLOCATED(ss%teflux_ky_tglf)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nky_anomth",idims(indim))
     CALL define_var("teflux_ky_tglf","R",indim,idims, &
            "electron density flux spectrum", &
            "GB","ANOM","STATE_PROFILES", &
            "R|units=GB|pclin teflux_ky_tglf(nrho_anomth,nky_anomth)")
  ENDIF

  indim = 0
  CALL define_var("Te_bdy","R",indim,idims, &
         "Electron temperature at/beyond boundary", &
         "KeV","PLASMA","STATE_DATA", &
         "R Te_bdy")

  IF(ALLOCATED(ss%te_ky_tglf)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nky_anomth",idims(indim))
     CALL define_var("te_ky_tglf","R",indim,idims, &
            "electron density fluctuation spectrum", &
            "GB","ANOM","STATE_PROFILES", &
            "R|units=GB|pclin te_ky_tglf(nrho_anomth,nky_anomth)")
  ENDIF

  CONTAINS


     SUBROUTINE define_var(name,dtype,indim,idims, &
          long_name,units,component,section,spec)

        CHARACTER*(*), INTENT(in) :: name
        CHARACTER*(*), INTENT(in) :: dtype
        INTEGER, INTENT(in) :: indim
        INTEGER, dimension(:), INTENT(in) :: idims
        CHARACTER*(*), INTENT(in) :: long_name
        CHARACTER*(*), INTENT(in) :: units
        CHARACTER*(*), INTENT(in) :: component
        CHARACTER*(*), INTENT(in) :: section
        CHARACTER*(*), INTENT(in) :: spec

        integer :: itype

        IF(dtype.EQ.'R') THEN
           itype = NF90_DOUBLE

        ELSE IF (dtype.EQ.'I') THEN
           itype = NF90_INT

        ELSE
           itype = NF90_CHAR

        ENDIF

        IF(indim.EQ.0) THEN
           status=nf90_def_var(icdf,name,itype, varid=varid)

        ELSE
           status=nf90_def_var(icdf,name,itype, dimids=idims(1:indim),varid=varid)

        ENDIF

        IF(status.NE.NF90_NOERR) THEN
           WRITE(iout,*) " ?plasma_state_store: error defining variable: "//trim(name)
           CALL ncerr(status)
           iertot = iertot + 1
           RETURN
        ENDIF

        ! Variable OK, now add attributes:

        CALL add_attrib("long_name",long_name)
        IF(dtype.EQ.'R') CALL add_attrib("units",units)
        CALL add_attrib("component",component)
        CALL add_attrib("section",section)
        CALL add_attrib("specification",spec)

     END SUBROUTINE define_var

     SUBROUTINE add_attrib(name,value)
        CHARACTER*(*), intent(in) :: name
        CHARACTER*(*), intent(in) :: value

        status=nf90_put_att(icdf,varid,name,value)
        IF(status.NE.NF90_NOERR) THEN
           WRITE(iout,*) " ?plasma_state_store: error defining attribute: "//trim(name)//' = '//trim(value)
           CALL ncerr(status)
           iertot = iertot + 1
        ENDIF
     END SUBROUTINE add_attrib

     SUBROUTINE ncerr(status)
        INTEGER, INTENT(in) :: status

        nc_errmsg = NF90_strerror(status)
        write(iout,*) '  NetCDF message: ',trim(nc_errmsg)
     END SUBROUTINE ncerr

END SUBROUTINE plasma_state_store_def_7


SUBROUTINE plasma_state_store_7(ss,icdf,iout,iertot)


  !  write subset of variables and arrays from NetCDF file

  USE plasma_state_definition_mod
  USE netcdf
  IMPLICIT NONE

  TYPE (plasma_state) :: ss     ! state data to read
  INTEGER, INTENT(IN) :: icdf   ! NetCDF file ID
  INTEGER, INTENT(IN) :: iout   ! message LUN
  INTEGER, INTENT(INOUT) :: iertot  ! error count

  !--------------

  INTEGER :: varid,dimid,status,ival,idims(20),indim
  CHARACTER*80 :: nc_errmsg

  !--------------
  !  write variables...


  IF(ALLOCATED(ss%Rloc_coil)) THEN
     status = nf90_inq_varid(icdf,"Rloc_coil",varid)
     status = nf90_put_var(icdf,varid,ss%Rloc_coil)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: Rloc_coil"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%Rmajor_mean)) THEN
     status = nf90_inq_varid(icdf,"Rmajor_mean",varid)
     status = nf90_put_var(icdf,varid,ss%Rmajor_mean)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: Rmajor_mean"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%rMinor_mean)) THEN
     status = nf90_inq_varid(icdf,"rMinor_mean",varid)
     status = nf90_put_var(icdf,varid,ss%rMinor_mean)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: rMinor_mean"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"RUNAWAY_Code_Info",varid)
  status = nf90_put_var(icdf,varid,ss%RUNAWAY_Code_Info)
  IF(status.NE.NF90_NOERR) THEN
     WRITE(iout,*) " ?plasma_state_store: error storing: RUNAWAY_Code_Info"
     CALL ncerr(status)
     iertot = iertot + 1
  ENDIF

  status = nf90_inq_varid(icdf,"RunID",varid)
  status = nf90_put_var(icdf,varid,ss%RunID)
  IF(status.NE.NF90_NOERR) THEN
     WRITE(iout,*) " ?plasma_state_store: error storing: RunID"
     CALL ncerr(status)
     iertot = iertot + 1
  ENDIF

  IF(ALLOCATED(ss%R_ant)) THEN
     status = nf90_inq_varid(icdf,"R_ant",varid)
     status = nf90_put_var(icdf,varid,ss%R_ant)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: R_ant"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%R_antgeo)) THEN
     status = nf90_inq_varid(icdf,"R_antgeo",varid)
     status = nf90_put_var(icdf,varid,ss%R_antgeo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: R_antgeo"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"R_axis",varid)
  status = nf90_put_var(icdf,varid,ss%R_axis)
  IF(status.NE.NF90_NOERR) THEN
     WRITE(iout,*) " ?plasma_state_store: error storing: R_axis"
     CALL ncerr(status)
     iertot = iertot + 1
  ENDIF

  IF(ALLOCATED(ss%R_EC_launch)) THEN
     status = nf90_inq_varid(icdf,"R_EC_launch",varid)
     status = nf90_put_var(icdf,varid,ss%R_EC_launch)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: R_EC_launch"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%R_geo)) THEN
     status = nf90_inq_varid(icdf,"R_geo",varid)
     status = nf90_put_var(icdf,varid,ss%R_geo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: R_geo"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%R_grid)) THEN
     status = nf90_inq_varid(icdf,"R_grid",varid)
     status = nf90_put_var(icdf,varid,ss%R_grid)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: R_grid"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"R_max_box",varid)
  status = nf90_put_var(icdf,varid,ss%R_max_box)
  IF(status.NE.NF90_NOERR) THEN
     WRITE(iout,*) " ?plasma_state_store: error storing: R_max_box"
     CALL ncerr(status)
     iertot = iertot + 1
  ENDIF

  status = nf90_inq_varid(icdf,"R_max_lcfs",varid)
  status = nf90_put_var(icdf,varid,ss%R_max_lcfs)
  IF(status.NE.NF90_NOERR) THEN
     WRITE(iout,*) " ?plasma_state_store: error storing: R_max_lcfs"
     CALL ncerr(status)
     iertot = iertot + 1
  ENDIF

  IF(ALLOCATED(ss%R_midp_in)) THEN
     status = nf90_inq_varid(icdf,"R_midp_in",varid)
     status = nf90_put_var(icdf,varid,ss%R_midp_in)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: R_midp_in"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%R_midp_out)) THEN
     status = nf90_inq_varid(icdf,"R_midp_out",varid)
     status = nf90_put_var(icdf,varid,ss%R_midp_out)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: R_midp_out"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"R_min_box",varid)
  status = nf90_put_var(icdf,varid,ss%R_min_box)
  IF(status.NE.NF90_NOERR) THEN
     WRITE(iout,*) " ?plasma_state_store: error storing: R_min_box"
     CALL ncerr(status)
     iertot = iertot + 1
  ENDIF

  status = nf90_inq_varid(icdf,"R_min_lcfs",varid)
  status = nf90_put_var(icdf,varid,ss%R_min_lcfs)
  IF(status.NE.NF90_NOERR) THEN
     WRITE(iout,*) " ?plasma_state_store: error storing: R_min_lcfs"
     CALL ncerr(status)
     iertot = iertot + 1
  ENDIF

  IF(ALLOCATED(ss%R_ripple)) THEN
     status = nf90_inq_varid(icdf,"R_ripple",varid)
     status = nf90_put_var(icdf,varid,ss%R_ripple)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: R_ripple"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%R_surfMax)) THEN
     status = nf90_inq_varid(icdf,"R_surfMax",varid)
     status = nf90_put_var(icdf,varid,ss%R_surfMax)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: R_surfMax"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%R_surfMin)) THEN
     status = nf90_inq_varid(icdf,"R_surfMin",varid)
     status = nf90_put_var(icdf,varid,ss%R_surfMin)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: R_surfMin"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%s0reco)) THEN
     status = nf90_inq_varid(icdf,"s0reco",varid)
     status = nf90_put_var(icdf,varid,ss%s0reco)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: s0reco"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%s0reco_e)) THEN
     status = nf90_inq_varid(icdf,"s0reco_e",varid)
     status = nf90_put_var(icdf,varid,ss%s0reco_e)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: s0reco_e"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%s0reco_recap)) THEN
     status = nf90_inq_varid(icdf,"s0reco_recap",varid)
     status = nf90_put_var(icdf,varid,ss%s0reco_recap)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: s0reco_recap"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%sa_index)) THEN
     status = nf90_inq_varid(icdf,"sa_index",varid)
     status = nf90_put_var(icdf,varid,ss%sa_index)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: sa_index"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%SA_name)) THEN
     status = nf90_inq_varid(icdf,"SA_name",varid)
     status = nf90_put_var(icdf,varid,ss%SA_name)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: SA_name"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%SA_type)) THEN
     status = nf90_inq_varid(icdf,"SA_type",varid)
     status = nf90_put_var(icdf,varid,ss%SA_type)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: SA_type"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%sb0halo)) THEN
     status = nf90_inq_varid(icdf,"sb0halo",varid)
     status = nf90_put_var(icdf,varid,ss%sb0halo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: sb0halo"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%sb0halo_recap)) THEN
     status = nf90_inq_varid(icdf,"sb0halo_recap",varid)
     status = nf90_put_var(icdf,varid,ss%sb0halo_recap)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: sb0halo_recap"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%sbedep)) THEN
     status = nf90_inq_varid(icdf,"sbedep",varid)
     status = nf90_put_var(icdf,varid,ss%sbedep)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: sbedep"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%sbehalo)) THEN
     status = nf90_inq_varid(icdf,"sbehalo",varid)
     status = nf90_put_var(icdf,varid,ss%sbehalo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: sbehalo"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%sbsce)) THEN
     status = nf90_inq_varid(icdf,"sbsce",varid)
     status = nf90_put_var(icdf,varid,ss%sbsce)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: sbsce"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%sbtherm)) THEN
     status = nf90_inq_varid(icdf,"sbtherm",varid)
     status = nf90_put_var(icdf,varid,ss%sbtherm)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: sbtherm"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%sc0)) THEN
     status = nf90_inq_varid(icdf,"sc0",varid)
     status = nf90_put_var(icdf,varid,ss%sc0)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: sc0"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%sc0_to_sgas)) THEN
     status = nf90_inq_varid(icdf,"sc0_to_sgas",varid)
     status = nf90_put_var(icdf,varid,ss%sc0_to_sgas)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: sc0_to_sgas"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%sc_anom)) THEN
     status = nf90_inq_varid(icdf,"sc_anom",varid)
     status = nf90_put_var(icdf,varid,ss%sc_anom)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: sc_anom"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%sfsce)) THEN
     status = nf90_inq_varid(icdf,"sfsce",varid)
     status = nf90_put_var(icdf,varid,ss%sfsce)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: sfsce"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%sftherm)) THEN
     status = nf90_inq_varid(icdf,"sftherm",varid)
     status = nf90_put_var(icdf,varid,ss%sftherm)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: sftherm"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%SFUS_name)) THEN
     status = nf90_inq_varid(icdf,"SFUS_name",varid)
     status = nf90_put_var(icdf,varid,ss%SFUS_name)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: SFUS_name"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%sfus_to_all)) THEN
     status = nf90_inq_varid(icdf,"sfus_to_all",varid)
     status = nf90_put_var(icdf,varid,ss%sfus_to_all)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: sfus_to_all"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%sfus_to_alla)) THEN
     status = nf90_inq_varid(icdf,"sfus_to_alla",varid)
     status = nf90_put_var(icdf,varid,ss%sfus_to_alla)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: sfus_to_alla"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%SFUS_type)) THEN
     status = nf90_inq_varid(icdf,"SFUS_type",varid)
     status = nf90_put_var(icdf,varid,ss%SFUS_type)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: SFUS_type"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%SGAS_name)) THEN
     status = nf90_inq_varid(icdf,"SGAS_name",varid)
     status = nf90_put_var(icdf,varid,ss%SGAS_name)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: SGAS_name"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%sgas_to_s)) THEN
     status = nf90_inq_varid(icdf,"sgas_to_s",varid)
     status = nf90_put_var(icdf,varid,ss%sgas_to_s)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: sgas_to_s"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%SGAS_type)) THEN
     status = nf90_inq_varid(icdf,"SGAS_type",varid)
     status = nf90_put_var(icdf,varid,ss%SGAS_type)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: SGAS_type"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"shot_number",varid)
  status = nf90_put_var(icdf,varid,ss%shot_number)
  IF(status.NE.NF90_NOERR) THEN
     WRITE(iout,*) " ?plasma_state_store: error storing: shot_number"
     CALL ncerr(status)
     iertot = iertot + 1
  ENDIF

  IF(ALLOCATED(ss%sii_xs)) THEN
     status = nf90_inq_varid(icdf,"sii_xs",varid)
     status = nf90_put_var(icdf,varid,ss%sii_xs)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: sii_xs"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%SIMP0_name)) THEN
     status = nf90_inq_varid(icdf,"SIMP0_name",varid)
     status = nf90_put_var(icdf,varid,ss%SIMP0_name)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: SIMP0_name"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%simp0_to_s)) THEN
     status = nf90_inq_varid(icdf,"simp0_to_s",varid)
     status = nf90_put_var(icdf,varid,ss%simp0_to_s)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: simp0_to_s"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%SIMP0_type)) THEN
     status = nf90_inq_varid(icdf,"SIMP0_type",varid)
     status = nf90_put_var(icdf,varid,ss%SIMP0_type)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: SIMP0_type"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%SIMPI_name)) THEN
     status = nf90_inq_varid(icdf,"SIMPI_name",varid)
     status = nf90_put_var(icdf,varid,ss%SIMPI_name)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: SIMPI_name"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%simpi_to_s)) THEN
     status = nf90_inq_varid(icdf,"simpi_to_s",varid)
     status = nf90_put_var(icdf,varid,ss%simpi_to_s)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: simpi_to_s"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%SIMPI_type)) THEN
     status = nf90_inq_varid(icdf,"SIMPI_type",varid)
     status = nf90_put_var(icdf,varid,ss%SIMPI_type)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: SIMPI_type"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%SNBI_name)) THEN
     status = nf90_inq_varid(icdf,"SNBI_name",varid)
     status = nf90_put_var(icdf,varid,ss%SNBI_name)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: SNBI_name"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%snbi_to_all)) THEN
     status = nf90_inq_varid(icdf,"snbi_to_all",varid)
     status = nf90_put_var(icdf,varid,ss%snbi_to_all)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: snbi_to_all"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%snbi_to_alla)) THEN
     status = nf90_inq_varid(icdf,"snbi_to_alla",varid)
     status = nf90_put_var(icdf,varid,ss%snbi_to_alla)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: snbi_to_alla"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%SNBI_type)) THEN
     status = nf90_inq_varid(icdf,"SNBI_type",varid)
     status = nf90_put_var(icdf,varid,ss%SNBI_type)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: SNBI_type"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%sn_trans)) THEN
     status = nf90_inq_varid(icdf,"sn_trans",varid)
     status = nf90_put_var(icdf,varid,ss%sn_trans)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: sn_trans"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%sn_transcat)) THEN
     status = nf90_inq_varid(icdf,"sn_transcat",varid)
     status = nf90_put_var(icdf,varid,ss%sn_transcat)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: sn_transcat"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%sprof0)) THEN
     status = nf90_inq_varid(icdf,"sprof0",varid)
     status = nf90_put_var(icdf,varid,ss%sprof0)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: sprof0"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%sprof0e)) THEN
     status = nf90_inq_varid(icdf,"sprof0e",varid)
     status = nf90_put_var(icdf,varid,ss%sprof0e)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: sprof0e"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%spsce)) THEN
     status = nf90_inq_varid(icdf,"spsce",varid)
     status = nf90_put_var(icdf,varid,ss%spsce)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: spsce"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%squareLO)) THEN
     status = nf90_inq_varid(icdf,"squareLO",varid)
     status = nf90_put_var(icdf,varid,ss%squareLO)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: squareLO"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%squareUO)) THEN
     status = nf90_inq_varid(icdf,"squareUO",varid)
     status = nf90_put_var(icdf,varid,ss%squareUO)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: squareUO"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%sRtcen)) THEN
     status = nf90_inq_varid(icdf,"sRtcen",varid)
     status = nf90_put_var(icdf,varid,ss%sRtcen)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: sRtcen"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%surf)) THEN
     status = nf90_inq_varid(icdf,"surf",varid)
     status = nf90_put_var(icdf,varid,ss%surf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: surf"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%S_name)) THEN
     status = nf90_inq_varid(icdf,"S_name",varid)
     status = nf90_put_var(icdf,varid,ss%S_name)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: S_name"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%s_to_sa)) THEN
     status = nf90_inq_varid(icdf,"s_to_sa",varid)
     status = nf90_put_var(icdf,varid,ss%s_to_sa)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: s_to_sa"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%S_type)) THEN
     status = nf90_inq_varid(icdf,"S_type",varid)
     status = nf90_put_var(icdf,varid,ss%S_type)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: S_type"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"t0",varid)
  status = nf90_put_var(icdf,varid,ss%t0)
  IF(status.NE.NF90_NOERR) THEN
     WRITE(iout,*) " ?plasma_state_store: error storing: t0"
     CALL ncerr(status)
     iertot = iertot + 1
  ENDIF

  IF(ALLOCATED(ss%T0cx)) THEN
     status = nf90_inq_varid(icdf,"T0cx",varid)
     status = nf90_put_var(icdf,varid,ss%T0cx)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: T0cx"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%T0sc0)) THEN
     status = nf90_inq_varid(icdf,"T0sc0",varid)
     status = nf90_put_var(icdf,varid,ss%T0sc0)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: T0sc0"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%T0_halo)) THEN
     status = nf90_inq_varid(icdf,"T0_halo",varid)
     status = nf90_put_var(icdf,varid,ss%T0_halo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: T0_halo"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%T0_reco)) THEN
     status = nf90_inq_varid(icdf,"T0_reco",varid)
     status = nf90_put_var(icdf,varid,ss%T0_reco)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: T0_reco"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"t1",varid)
  status = nf90_put_var(icdf,varid,ss%t1)
  IF(status.NE.NF90_NOERR) THEN
     WRITE(iout,*) " ?plasma_state_store: error storing: t1"
     CALL ncerr(status)
     iertot = iertot + 1
  ENDIF

  IF(ALLOCATED(ss%teflux_ky_tglf)) THEN
     status = nf90_inq_varid(icdf,"teflux_ky_tglf",varid)
     status = nf90_put_var(icdf,varid,ss%teflux_ky_tglf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: teflux_ky_tglf"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Te_bdy",varid)
  status = nf90_put_var(icdf,varid,ss%Te_bdy)
  IF(status.NE.NF90_NOERR) THEN
     WRITE(iout,*) " ?plasma_state_store: error storing: Te_bdy"
     CALL ncerr(status)
     iertot = iertot + 1
  ENDIF

  IF(ALLOCATED(ss%te_ky_tglf)) THEN
     status = nf90_inq_varid(icdf,"te_ky_tglf",varid)
     status = nf90_put_var(icdf,varid,ss%te_ky_tglf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: te_ky_tglf"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  CONTAINS


     SUBROUTINE ncerr(status)
        INTEGER, INTENT(in) :: status

        nc_errmsg = NF90_strerror(status)
        write(iout,*) '  NetCDF message: ',trim(nc_errmsg)
     END SUBROUTINE ncerr

END SUBROUTINE plasma_state_store_7

subroutine ps_1d_prof_store(iobj, profname, gridname, &
     units, iauthor, label, isplini, bc_opt, &
     n, k_ccw, profdata, id, imod, iout, ierr)

  !------------------------------------------------------------
  ! D. McCune 8 Oct 2006

  ! XPLASMA2 implementation of plasma_state subroutine
  ! store a 1d profile, return its ID, perform error checking

  ! This routine is called by generated code associated with the
  ! plasma state.  Component codes will not call this directly.
  !------------------------------------------------------------

  use plasma_state_definition_mod
  use plasma_state_xpobj  ! XPLASMA2 state object definitions

  implicit NONE

  !-----------------------
  integer :: iobj(ps_container_size)  ! opaque container for xplasma object

  character*(*), intent(in) :: profname    ! NAME of profile to fetch
  character*(*), intent(in) :: gridname    ! NAME of profile's grid
  character*(*), intent(in) :: units       ! units label
  integer, intent(in) :: iauthor           ! author ID

  character*(*), intent(in) :: label       ! profile label
  integer, intent(in) :: isplini           ! profile interpolation method

  integer, intent(in) :: bc_opt            ! spline Bdy Cond option

  integer, intent(in) :: n                 ! profile data size
  integer, intent(in) :: k_ccw             ! CCW flag

  REAL(KIND=rspec) :: profdata(n)          ! profile data to be stored

  integer, intent(out) :: id               ! profile ID (interpolation handle)
  integer, intent(out) :: imod             ! =1 if profile is new or modified
  !  =0 on output if profile was not changed.

  integer, intent(in) :: iout              ! LUN for error messages
  integer, intent(out) :: ierr             ! error status code returned 0 = OK

  !--------------------------------------------------
  ! local...

  integer :: irank,idg,icoord,diff_code,iertmp,ispline,ing,inx
  logical :: ccwflag,ccwflag1
  logical :: rewrite
  integer :: ibca,ibcb
  REAL(KIND=rspec) :: zprof(n)
  character*32 :: zunits
  type (interp_object) :: xobj
  type (xplasma), pointer :: s
  !--------------------------------------------------

  imod=0

  xobj = transfer(iobj,xobj)
  s => xobj%s_xpobj

  call xplasma_global_info(s,ierr, init_check=.TRUE.)
  if(ierr.ne.0) then
     write(iout,*) ' ?ps_1d_prof_store: invalid or unitialized xplasma object.'
     return
  endif

  call xplasma_gridId(s,gridname,idg)
  if(idg.eq.0) then
     ierr=300
     write(iout,*) ' ?ps_1d_prof_store: grid name not recognized: "', &
          trim(gridname),'".'
     write(iout,*) '  error on call to store profile "',profname,'".'
     return
  endif

  call xplasma_grid_size(s,idg,ing,ierr)
  inx=ing
  if(isplini.lt.0) inx=inx-1

  if(n.ne.inx) then
     ierr=301
     write(iout,*) ' ?ps_1d_prof_store: profile size: ',n
     write(iout,*) '  does not match expected size from grid '// &
          trim(gridname)//': ',inx
     write(iout,*) '  for spline type: ',isplini
     return
  endif

  ispline=max(isplini,ps_stepfun)
  if(ispline.ne.isplini) then
     call norm1(isplini,profdata,zprof)
     if(ierr.ne.0) return
     if(isplini.eq.ps_stepdv) then
        zunits=trim(units)//'/m^3'
     else if(isplini.eq.ps_stepda) then
        zunits=trim(units)//'/m^2'
     endif
  else
     zprof=profdata
     zunits=units
  endif

  call xplasma_grid_info(s,idg,iertmp, coord=icoord)

  ccwflag = (k_ccw.ne.ps_ccw_reverse)
  ccwflag1 = .TRUE.

  if(icoord.eq.xplasma_theta_coord) then
     ccwflag1=ccwflag
  endif

  ibca=0
  ibcb=0

  if(bc_opt.ne.ps_bc_dflt) then
     if(icoord.eq.xplasma_rho_coord) then
        if(bc_opt.eq.ps_bc_grad00) then
           ibca=1  ! 1st derivative to -> 0 as rho -> 0
           ibcb=0  ! still the default at bdy
        endif
     endif
  endif

  !--------------------------------------------------
  !  find if profile ID already defined

  call xplasma_profId(s,profname,id)
  if(id.gt.0) then
     !  profile exists -- see if it is the same...
     call xplasma_prof_info(s,id,ierr, rank=irank)
     if(ierr.ne.0) then
        write(iout,*) ' ?ps_1d_prof_store: unexpected XPLASMA2 error:'
        call xplasma_error(s,ierr,iout)
        ierr=301
        rewrite=.FALSE.
     else
        if(irank.ne.1) then
           rewrite=.TRUE.
        else
           call xplasma_diff_prof(s,id,zprof,diff_code,ierr, &
                splineType=ispline, units=zunits, ccwflag1=ccwflag1)
           if(diff_code.eq.0) then
              rewrite=.FALSE.
           else
              rewrite=.TRUE.
           endif
        endif
     endif
  else
     rewrite=.TRUE.   ! actually, write for first time
  endif

  if(.not.rewrite) return

  !--------------------------------------------------
  !  store the modified profile...

  !  set author...

  imod = 1

  call xplasma_author_set(s,ps_cnames(iauthor),ierr)
  if(ierr.ne.0) then
     write(iout,*) ' ?ps_1d_prof_store: unexpected xplasma_author_set error:'
     call xplasma_error(s,ierr,iout)
     ierr=301
  endif
  if(ierr.ne.0) return

  !  write profile...

  call xplasma_create_1dprof(s,profname,idg,zprof,id,ierr, &
       ispline=ispline,ibca=ibca,ibcb=ibcb, &
       ccwflag=ccwflag1,label=label,units=zunits)

  if(ierr.ne.0) then
     write(iout,*) ' ?ps_1d_prof_store: unexpected XPLASMA2 error:'
     call xplasma_error(s,ierr,iout)
     ierr=302
  endif

  !  clear author...

  call xplasma_author_clear(s,ps_cnames(iauthor),ierr)
  if(ierr.ne.0) then
     write(iout,*) ' ?ps_1d_prof_store: unexpected xplasma_author_clear error:'
     call xplasma_error(s,ierr,iout)
     ierr=301
  endif

  contains
    subroutine norm1(itype,zfdv,zf)

      integer, intent(in) :: itype
      REAL(KIND=rspec), intent(in) :: zfdv(n)   ! input f*dV or f*dA
      REAL(KIND=rspec), intent(out) :: zf(n)    ! output f

      ! if {R,Z} surfaces are available:
      !   divide out area or volume element, depending on "itype"
      ! if not:  look for VOL(rho) and AREA(rho) functions and use
      !   these go get area and volume elements.
      ! if this too fails: 
      !   write a warning and create a black box marker s.t. the warning
      !   appears only once...

      REAL(KIND=rspec) :: zdv(n)

      integer :: id_vol,id_area,id_R,id_Z,id_blkbx,iii,iexec
      integer :: iarray(1),iertmp
      REAL(KIND=rspec) :: r8array(1)
      character*32, parameter :: bbname = '_1d_prof_store_warn_marker'
      real*8, dimension(:), allocatable :: zx,zva
      real*8 :: zmaxa
      real*8, parameter :: ZERO = 0.0d0
      !-----------------------------

      ierr=0
      iexec=0

      zmaxa=ZERO
      do iii=1,n
         zmaxa=max(zmaxa,abs(zfdv(iii)))
      enddo
      if(zmaxa.eq.ZERO) then
         zf=ZERO
         return
      endif

      call xplasma_common_ids(s,ierr,id_R=id_R,id_Z=id_Z)
      if(ierr.ne.0) then
         write(iout,*) ' ?ps_1d_prof_store: xplasma_common_ids error:'
         call xplasma_error(s,ierr,iout)
         zf=0.0d0
         return
      endif

      do

         if((id_R.eq.0).or.(id_Z.eq.0)) then
            !  state has not retained full flux surface geometry; look for
            !  Vol(rho) and Area(rho) instead...

            allocate(zx(ing),zva(ing))
            call xplasma_grid(s,idg,zx,iertmp)
            if(iertmp.ne.0) then
               write(iout,*) ' ?ps_1d_prof_store: grid extraction error.'
               id_vol=0
               id_area=0
            else
               call xplasma_profId(s,'VOL',id_vol)
               call xplasma_profId(s,'AREA',id_area)
            endif

            if((id_vol.eq.0).or.(id_area.eq.0)) then
               call xplasma_blkbxID(s,bbname,id_blkbx)
               if(id_blkbx.eq.0) then
                  write(iout,*) &
                       ' %ps_1d_prof_store: ZEROed step*dV & step*dA interpolants:'
                  write(iout,*) &
                       '  neither {R,Z} surfaces nor Vol(rho) & Area(rho) were found.'

                  ! set warning marker, owned by xplasma_xmhd s.t. erased when
                  ! an equilibrium is established.
                  call xplasma_author_set(s,xplasma_xmhd,iertmp)
                  iarray=0
                  r8array=0.0_rspec

                  call xplasma_create_blackBox(s,bbname,-12345,id_blkbx,ierr, &
                       iarray=iarray,r8array=r8array)
                  if(ierr.ne.0) then
                     write(iout,*) ' ?ps_1d_prof_store: blackbox warning marker error:'
                     call xplasma_error(s,ierr,iout)
                     exit
                  endif

                  call xplasma_author_clear(s,xplasma_xmhd,iertmp)
               else
                  ierr=0  ! warning already issued: OK
               endif

               zf=0.0d0
               
            else if(itype.eq.ps_stepdv) then
               ! OK step*dV & there appears to be a volume profile available
               call xplasma_eval_prof(s,id_vol,zx,zva,ierr)
               if(ierr.ne.0) then
                  write(iout,*) ' ?ps_1d_prof_store: VOL interpolation error:'
                  call xplasma_error(s,ierr,iout)
                  zf=0.0d0
               endif
               iexec=2

            else if(itype.eq.ps_stepda) then
               ! OK step*dA & there appears to be an area profile available
               call xplasma_eval_prof(s,id_area,zx,zva,ierr)
               if(ierr.ne.0) then
                  write(iout,*) ' ?ps_1d_prof_store: AREA interpolation error:'
                  call xplasma_error(s,ierr,iout)
                  zf=0.0d0
               endif
               iexec=2

            else
               ierr=302
               zf=0.0d0
               write(iout,*) &
                    ' ?ps_1d_prof_store internal error: bad norm1 call.'
            endif

            exit

         else if(itype.eq.ps_stepdv) then
            ! OK step*dV & there appears to be a geometry available
            call xplasma_rhogrid_dva(s,idg,ierr, dvol=zdv)
            if(ierr.ne.0) then
               write(iout,*) ' ?ps_1d_prof_store: xplasma_rhogrid_dva error:'
               call xplasma_error(s,ierr,iout)
               zf=0.0d0
            else
               iexec=1
            endif

         else if(itype.eq.ps_stepda) then
            ! OK step*dA & there appears to be a geometry available
            call xplasma_rhogrid_dva(s,idg,ierr, darea=zdv)
            if(ierr.ne.0) then
               write(iout,*) ' ?ps_1d_prof_store: xplasma_rhogrid_dva error:'
               call xplasma_error(s,ierr,iout)
               zf=0.0d0
            else
               iexec=1
            endif

         else
            ierr=302
            zf=0.0d0
            write(iout,*) ' ?ps_1d_prof_store internal error: bad norm1 call.'
         endif

         exit
      enddo

      if(iexec.eq.1) then
         zf = zfdv/zdv

      else if(iexec.eq.2) then
         do iii=1,inx
            zdv(iii)=zva(iii+1)-zva(iii)
            zf(iii) = zfdv(iii)/zdv(iii)
         enddo
      endif

      if(allocated(zx)) deallocate(zx,zva)

    end subroutine norm1

end subroutine ps_1d_prof_store

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


SUBROUTINE ps_update_file_write_def_6(ss,icdf,cclist,nids,iout,iwarn,iertot)


  ! Define updated data

  USE plasma_state_definition_mod
  USE netcdf
  USE ps_nidlist_defn
  IMPLICIT NONE

  TYPE (plasma_state) :: ss  ! state containing array elements to be allocated
  INTEGER, INTENT(IN) :: icdf  ! NetCDF file ID
  INTEGER, INTENT(IN) :: cclist(ps_ccount)  ! component selection
  TYPE (nidlist) :: nids       ! defined dimensions list
  INTEGER, INTENT(IN) :: iout  ! LUN for messages
  INTEGER, INTENT(INOUT) :: iwarn   ! warn count
  INTEGER, INTENT(INOUT) :: iertot  ! error count

  !-------------------
  LOGICAL :: plasma_state_hash_match,ichange

  INTEGER :: varid,pvarid,vvarid,dimid,status,iertmp,iaddr
  INTEGER :: idims(20),indim,ival,ii,ierr
  CHARACTER*80 :: nc_errmsg

  !-------------------

  ierr = 0   ! local

  iaddr = ps_phash_PsiRZ
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%PsiRZ).AND.ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("PsiRZ","EQ")
     ELSE
        indim = 0
        IF(nids%nid_dim_nr.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nr,"dim_nr",ss%nr)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nr
        IF(nids%nid_dim_nz.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nz,"dim_nz",ss%nz)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nz
        CALL define_var("PsiRZ","R",indim,idims, &
               "Psi(R,Z)", &
               "Wb/rad","EQ","STATE_PROFILES", &
               "R|units=Wb/rad|Spline  PsiRZ(nR,nZ)")
     ENDIF
  ENDIF

  iaddr = ps_shash_Psi_to_machine_axis
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("Psi_to_machine_axis","EQ")
     ELSE
        indim = 0
        CALL define_var("Psi_to_machine_axis","R",indim,idims, &
               "delta(Psi) from magnetic axis to machine axis", &
               "Wb/rad","EQ","STATE_DATA", &
               "R|units=Wb/rad   Psi_to_machine_axis")
     ENDIF
  ENDIF

  iaddr = ps_phash_psmom_errck
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%psmom_errck).AND.ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("psmom_errck","EQ")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_eq_geo.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_eq_geo,"dim_nrho_eq_geo",ss%nrho_eq_geo)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_eq_geo
        CALL define_var("psmom_errck","R",indim,idims, &
               "PS moments sum convergence", &
               "-","EQ","STATE_PROFILES", &
               "R|units=-|pclin       psmom_errck(nrho_eq_geo)")
     ENDIF
  ENDIF

  iaddr = ps_phash_psmom_nc
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%psmom_nc).AND.ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("psmom_nc","EQ")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_eq_geo.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_eq_geo,"dim_nrho_eq_geo",ss%nrho_eq_geo)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_eq_geo
        IF(nids%nid_dim_npsmom.EQ.0) THEN
           CALL define_dim(nids%nid_dim_npsmom,"dim_npsmom",ss%npsmom)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_npsmom
        CALL define_var("psmom_nc","R",indim,idims, &
               "PS moments", &
               "m^-2","EQ","STATE_PROFILES", &
               "R|units=m^-2|pclin    psmom_nc(nrho_eq_geo,npsmom)")
     ENDIF
  ENDIF

  iaddr = ps_dhash_npsmom
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%psmom_num).AND.ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("psmom_num","EQ")
     ELSE
        indim = 1
        idims(1)=nids%nid_clen_32
        IF(nids%nid_dim_npsmom.EQ.0) THEN
           CALL define_dim(nids%nid_dim_npsmom,"dim_npsmom",ss%npsmom)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_npsmom
        CALL define_var("psmom_num","N",indim,idims, &
               "Pfirsch-Schlutter moments", &
               "__NONE","EQ","SIMULATION_INIT", &
               "L|PS_moments  psmom_num(npsmom)")
     ENDIF
  ENDIF

  iaddr = ps_phash_P_eq
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%P_eq).AND.ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("P_eq","EQ")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_eq.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_eq,"dim_nrho_eq",ss%nrho_eq)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_eq
        CALL define_var("P_eq","R",indim,idims, &
               "equilibrium scalar pressure", &
               "Pa","EQ","STATE_PROFILES", &
               "R|units=Pa|Spline_00       P_eq(nrho_eq)")
     ENDIF
  ENDIF

  iaddr = ps_dhash_nspec_all
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%qatom_ALL).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("qatom_ALL","PLASMA")
     ELSE
        indim = 0
        IF(nids%nid_dp1_nspec_all.EQ.0) THEN
           CALL define_dim(nids%nid_dp1_nspec_all,"dp1_nspec_all",ss%nspec_all+1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dp1_nspec_all
        CALL define_var("qatom_ALL","R",indim,idims, &
               "ALL atomic number", &
               "C","PLASMA","SIMULATION_INIT", &
               "S|specie  ALL(0:nspec_all)")
     ENDIF
  ENDIF

  iaddr = ps_dhash_nspec_alla
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%qatom_ALLA).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("qatom_ALLA","PLASMA")
     ELSE
        indim = 0
        IF(nids%nid_dp1_nspec_alla.EQ.0) THEN
           CALL define_dim(nids%nid_dp1_nspec_alla,"dp1_nspec_alla",ss%nspec_alla+1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dp1_nspec_alla
        CALL define_var("qatom_ALLA","R",indim,idims, &
               "ALLA atomic number", &
               "C","PLASMA","SIMULATION_INIT", &
               "S|specie  ALLA(0:nspec_alla)")
     ENDIF
  ENDIF

  iaddr = ps_dhash_nspec_rfmin
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%qatom_RFMIN).AND.ichange) THEN
     IF(cclist(ps_cnum_IC).NE.1) THEN
        CALL ccwarn("qatom_RFMIN","IC")
     ELSE
        indim = 0
        IF(nids%nid_dim_nspec_rfmin.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nspec_rfmin,"dim_nspec_rfmin",ss%nspec_rfmin)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nspec_rfmin
        CALL define_var("qatom_RFMIN","R",indim,idims, &
               "RFMIN atomic number", &
               "C","IC","SHOT_CONFIGURATION", &
               "S|RF_minority  RFMIN(nspec_rfmin)")
     ENDIF
  ENDIF

  iaddr = ps_dhash_nspec_th
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%qatom_S).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("qatom_S","PLASMA")
     ELSE
        indim = 0
        IF(nids%nid_dp1_nspec_th.EQ.0) THEN
           CALL define_dim(nids%nid_dp1_nspec_th,"dp1_nspec_th",ss%nspec_th+1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dp1_nspec_th
        CALL define_var("qatom_S","R",indim,idims, &
               "S atomic number", &
               "C","PLASMA","SHOT_CONFIGURATION", &
               "S|thermal_specie  S(0:nspec_th)")
     ENDIF
  ENDIF

  iaddr = ps_dhash_nspec_tha
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%qatom_SA).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("qatom_SA","PLASMA")
     ELSE
        indim = 0
        IF(nids%nid_dp1_nspec_tha.EQ.0) THEN
           CALL define_dim(nids%nid_dp1_nspec_tha,"dp1_nspec_tha",ss%nspec_tha+1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dp1_nspec_tha
        CALL define_var("qatom_SA","R",indim,idims, &
               "SA atomic number", &
               "C","PLASMA","SIMULATION_INIT", &
               "S|thermal_specie  SA(0:nspec_tha)")
     ENDIF
  ENDIF

  iaddr = ps_dhash_nspec_fusion
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%qatom_SFUS).AND.ichange) THEN
     IF(cclist(ps_cnum_FUS).NE.1) THEN
        CALL ccwarn("qatom_SFUS","FUS")
     ELSE
        indim = 0
        IF(nids%nid_dim_nspec_fusion.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nspec_fusion,"dim_nspec_fusion",ss%nspec_fusion)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nspec_fusion
        CALL define_var("qatom_SFUS","R",indim,idims, &
               "SFUS atomic number", &
               "C","FUS","SHOT_CONFIGURATION", &
               "S|fusion_ion   SFUS(nspec_fusion)")
     ENDIF
  ENDIF

  iaddr = ps_dhash_nspec_gas
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%qatom_SGAS).AND.ichange) THEN
     IF(cclist(ps_cnum_GAS).NE.1) THEN
        CALL ccwarn("qatom_SGAS","GAS")
     ELSE
        indim = 0
        IF(nids%nid_dim_nspec_gas.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nspec_gas,"dim_nspec_gas",ss%nspec_gas)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nspec_gas
        CALL define_var("qatom_SGAS","R",indim,idims, &
               "SGAS atomic number", &
               "C","GAS","SIMULATION_INIT", &
               "S|neutral_gas  SGAS(nspec_gas)")
     ENDIF
  ENDIF

  iaddr = ps_dhash_nspec_imp0
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%qatom_SIMP0).AND.ichange) THEN
     IF(cclist(ps_cnum_GAS).NE.1) THEN
        CALL ccwarn("qatom_SIMP0","GAS")
     ELSE
        indim = 0
        IF(nids%nid_dim_nspec_imp0.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nspec_imp0,"dim_nspec_imp0",ss%nspec_imp0)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nspec_imp0
        CALL define_var("qatom_SIMP0","R",indim,idims, &
               "SIMP0 atomic number", &
               "C","GAS","SIMULATION_INIT", &
               "S|impurity_atoms SIMP0(nspec_imp0)")
     ENDIF
  ENDIF

  iaddr = ps_dhash_nspec_impi
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%qatom_SIMPI).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("qatom_SIMPI","PLASMA")
     ELSE
        indim = 0
        IF(nids%nid_dim_nspec_impi.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nspec_impi,"dim_nspec_impi",ss%nspec_impi)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nspec_impi
        CALL define_var("qatom_SIMPI","R",indim,idims, &
               "SIMPI atomic number", &
               "C","PLASMA","SIMULATION_INIT", &
               "S|impurity_atoms SIMPI(nspec_impi)")
     ENDIF
  ENDIF

  iaddr = ps_dhash_nspec_beam
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%qatom_SNBI).AND.ichange) THEN
     IF(cclist(ps_cnum_NBI).NE.1) THEN
        CALL ccwarn("qatom_SNBI","NBI")
     ELSE
        indim = 0
        IF(nids%nid_dim_nspec_beam.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nspec_beam,"dim_nspec_beam",ss%nspec_beam)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nspec_beam
        CALL define_var("qatom_SNBI","R",indim,idims, &
               "SNBI atomic number", &
               "C","NBI","SIMULATION_INIT", &
               "S|beam_ion     SNBI(nspec_beam)")
     ENDIF
  ENDIF

  iaddr = ps_phash_qbeami
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%qbeami).AND.ichange) THEN
     IF(cclist(ps_cnum_NBI).NE.1) THEN
        CALL ccwarn("qbeami","NBI")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_nbi.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_nbi,"dm1_nrho_nbi",ss%nrho_nbi-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_nbi
        IF(nids%nid_dim_nspec_beam.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nspec_beam,"dim_nspec_beam",ss%nspec_beam)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nspec_beam
        CALL define_var("qbeami","R",indim,idims, &
               "average beam ion charge", &
               "C","NBI","STATE_PROFILES", &
               "R|units=C|step*nbeami qbeami(~nrho_nbi,nspec_beam)")
     ENDIF
  ENDIF

  iaddr = ps_phash_qcomp_e
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%qcomp_e).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("qcomp_e","PLASMA")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho,"dm1_nrho",ss%nrho-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho
        CALL define_var("qcomp_e","R",indim,idims, &
               "Compressional electron heating", &
               "W","PLASMA","STATE_PROFILES", &
               "R|step*dV   qcomp_e(~nrho)")
     ENDIF
  ENDIF

  iaddr = ps_phash_qcomp_i
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%qcomp_i).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("qcomp_i","PLASMA")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho,"dm1_nrho",ss%nrho-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho
        CALL define_var("qcomp_i","R",indim,idims, &
               "Compressional ion heating", &
               "W","PLASMA","STATE_PROFILES", &
               "R|step*dV   qcomp_i(~nrho)")
     ENDIF
  ENDIF

  iaddr = ps_phash_qie
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%qie).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("qie","PLASMA")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho,"dm1_nrho",ss%nrho-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho
        CALL define_var("qie","R",indim,idims, &
               "Ion->Electron heat coupling", &
               "W","PLASMA","STATE_PROFILES", &
               "R|units=W|step*dV   qie(~nrho)")
     ENDIF
  ENDIF

  iaddr = ps_phash_qioniz
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%qioniz).AND.ichange) THEN
     IF(cclist(ps_cnum_GAS).NE.1) THEN
        CALL ccwarn("qioniz","GAS")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_gas.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_gas,"dm1_nrho_gas",ss%nrho_gas-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_gas
        IF(nids%nid_dim_ngsc0.EQ.0) THEN
           CALL define_dim(nids%nid_dim_ngsc0,"dim_ngsc0",ss%ngsc0)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_ngsc0
        CALL define_var("qioniz","R",indim,idims, &
               "ionization power per unit influx (sc0)", &
               "W/(#/sec)","GAS","STATE_PROFILES", &
               "R|step*dV|units=W/(#/sec)     qioniz(~nrho_gas,ngsc0)")
     ENDIF
  ENDIF

  iaddr = ps_shash_ql_operator
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%ql_operator).AND.ichange) THEN
     IF(cclist(ps_cnum_IC).NE.1) THEN
        CALL ccwarn("ql_operator","IC")
     ELSE
        indim = 1
        idims(1)=nids%nid_clen_256
        IF(nids%nid_dp1_nspec_alla.EQ.0) THEN
           CALL define_dim(nids%nid_dp1_nspec_alla,"dp1_nspec_alla",ss%nspec_alla+1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dp1_nspec_alla
        CALL define_var("ql_operator","F",indim,idims, &
               "quasilinear operator filenames", &
               "__NONE","IC","STATE_DATA", &
               "F  ql_operator(0:nspec_alla)")
     ENDIF
  ENDIF

  iaddr = ps_phash_qqcx
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%qqcx).AND.ichange) THEN
     IF(cclist(ps_cnum_GAS).NE.1) THEN
        CALL ccwarn("qqcx","GAS")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_gas.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_gas,"dm1_nrho_gas",ss%nrho_gas-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_gas
        IF(nids%nid_dim_ngsc0.EQ.0) THEN
           CALL define_dim(nids%nid_dim_ngsc0,"dim_ngsc0",ss%ngsc0)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_ngsc0
        CALL define_var("qqcx","R",indim,idims, &
               "cx power per unit influx per (T0-Ti)", &
               "W/(#/sec)/keV","GAS","STATE_PROFILES", &
               "R|step*dV|units=W/(#/sec)/keV  qqcx(~nrho_gas,ngsc0)")
     ENDIF
  ENDIF

  iaddr = ps_phash_qrot_conv
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%qrot_conv).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("qrot_conv","PLASMA")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho,"dm1_nrho",ss%nrho-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho
        CALL define_var("qrot_conv","R",indim,idims, &
               "rotational energy dissipation (convective)", &
               "W","PLASMA","STATE_PROFILES", &
               "R|step*dV   qrot_conv(~nrho)")
     ENDIF
  ENDIF

  iaddr = ps_phash_qrot_diff
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%qrot_diff).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("qrot_diff","PLASMA")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho,"dm1_nrho",ss%nrho-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho
        CALL define_var("qrot_diff","R",indim,idims, &
               "rotational energy dissipation (diffusive)", &
               "W","PLASMA","STATE_PROFILES", &
               "R|step*dV   qrot_diff(~nrho)")
     ENDIF
  ENDIF

  iaddr = ps_dhash_nspec_all
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%q_ALL).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("q_ALL","PLASMA")
     ELSE
        indim = 0
        IF(nids%nid_dp1_nspec_all.EQ.0) THEN
           CALL define_dim(nids%nid_dp1_nspec_all,"dp1_nspec_all",ss%nspec_all+1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dp1_nspec_all
        CALL define_var("q_ALL","R",indim,idims, &
               "ALL specie charge", &
               "C","PLASMA","SIMULATION_INIT", &
               "S|specie  ALL(0:nspec_all)")
     ENDIF
  ENDIF

  iaddr = ps_dhash_nspec_alla
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%q_ALLA).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("q_ALLA","PLASMA")
     ELSE
        indim = 0
        IF(nids%nid_dp1_nspec_alla.EQ.0) THEN
           CALL define_dim(nids%nid_dp1_nspec_alla,"dp1_nspec_alla",ss%nspec_alla+1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dp1_nspec_alla
        CALL define_var("q_ALLA","R",indim,idims, &
               "ALLA specie charge", &
               "C","PLASMA","SIMULATION_INIT", &
               "S|specie  ALLA(0:nspec_alla)")
     ENDIF
  ENDIF

  iaddr = ps_phash_q_eq
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%q_eq).AND.ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("q_eq","EQ")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_eq.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_eq,"dim_nrho_eq",ss%nrho_eq)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_eq
        CALL define_var("q_eq","R",indim,idims, &
               "equilibrium q profile", &
               "-","EQ","STATE_PROFILES", &
               "R|units=-|Spline           q_eq(nrho_eq)")
     ENDIF
  ENDIF

  iaddr = ps_dhash_nspec_rfmin
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%q_RFMIN).AND.ichange) THEN
     IF(cclist(ps_cnum_IC).NE.1) THEN
        CALL ccwarn("q_RFMIN","IC")
     ELSE
        indim = 0
        IF(nids%nid_dim_nspec_rfmin.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nspec_rfmin,"dim_nspec_rfmin",ss%nspec_rfmin)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nspec_rfmin
        CALL define_var("q_RFMIN","R",indim,idims, &
               "RFMIN specie charge", &
               "C","IC","SHOT_CONFIGURATION", &
               "S|RF_minority  RFMIN(nspec_rfmin)")
     ENDIF
  ENDIF

  iaddr = ps_dhash_nspec_th
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%q_S).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("q_S","PLASMA")
     ELSE
        indim = 0
        IF(nids%nid_dp1_nspec_th.EQ.0) THEN
           CALL define_dim(nids%nid_dp1_nspec_th,"dp1_nspec_th",ss%nspec_th+1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dp1_nspec_th
        CALL define_var("q_S","R",indim,idims, &
               "S specie charge", &
               "C","PLASMA","SHOT_CONFIGURATION", &
               "S|thermal_specie  S(0:nspec_th)")
     ENDIF
  ENDIF

  iaddr = ps_dhash_nspec_tha
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%q_SA).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("q_SA","PLASMA")
     ELSE
        indim = 0
        IF(nids%nid_dp1_nspec_tha.EQ.0) THEN
           CALL define_dim(nids%nid_dp1_nspec_tha,"dp1_nspec_tha",ss%nspec_tha+1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dp1_nspec_tha
        CALL define_var("q_SA","R",indim,idims, &
               "SA specie charge", &
               "C","PLASMA","SIMULATION_INIT", &
               "S|thermal_specie  SA(0:nspec_tha)")
     ENDIF
  ENDIF

  iaddr = ps_dhash_nspec_fusion
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%q_SFUS).AND.ichange) THEN
     IF(cclist(ps_cnum_FUS).NE.1) THEN
        CALL ccwarn("q_SFUS","FUS")
     ELSE
        indim = 0
        IF(nids%nid_dim_nspec_fusion.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nspec_fusion,"dim_nspec_fusion",ss%nspec_fusion)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nspec_fusion
        CALL define_var("q_SFUS","R",indim,idims, &
               "SFUS specie charge", &
               "C","FUS","SHOT_CONFIGURATION", &
               "S|fusion_ion   SFUS(nspec_fusion)")
     ENDIF
  ENDIF

  iaddr = ps_dhash_nspec_gas
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%q_SGAS).AND.ichange) THEN
     IF(cclist(ps_cnum_GAS).NE.1) THEN
        CALL ccwarn("q_SGAS","GAS")
     ELSE
        indim = 0
        IF(nids%nid_dim_nspec_gas.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nspec_gas,"dim_nspec_gas",ss%nspec_gas)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nspec_gas
        CALL define_var("q_SGAS","R",indim,idims, &
               "SGAS specie charge", &
               "C","GAS","SIMULATION_INIT", &
               "S|neutral_gas  SGAS(nspec_gas)")
     ENDIF
  ENDIF

  iaddr = ps_dhash_nspec_imp0
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%q_SIMP0).AND.ichange) THEN
     IF(cclist(ps_cnum_GAS).NE.1) THEN
        CALL ccwarn("q_SIMP0","GAS")
     ELSE
        indim = 0
        IF(nids%nid_dim_nspec_imp0.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nspec_imp0,"dim_nspec_imp0",ss%nspec_imp0)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nspec_imp0
        CALL define_var("q_SIMP0","R",indim,idims, &
               "SIMP0 specie charge", &
               "C","GAS","SIMULATION_INIT", &
               "S|impurity_atoms SIMP0(nspec_imp0)")
     ENDIF
  ENDIF

  iaddr = ps_dhash_nspec_impi
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%q_SIMPI).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("q_SIMPI","PLASMA")
     ELSE
        indim = 0
        IF(nids%nid_dim_nspec_impi.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nspec_impi,"dim_nspec_impi",ss%nspec_impi)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nspec_impi
        CALL define_var("q_SIMPI","R",indim,idims, &
               "SIMPI specie charge", &
               "C","PLASMA","SIMULATION_INIT", &
               "S|impurity_atoms SIMPI(nspec_impi)")
     ENDIF
  ENDIF

  iaddr = ps_dhash_nspec_beam
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%q_SNBI).AND.ichange) THEN
     IF(cclist(ps_cnum_NBI).NE.1) THEN
        CALL ccwarn("q_SNBI","NBI")
     ELSE
        indim = 0
        IF(nids%nid_dim_nspec_beam.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nspec_beam,"dim_nspec_beam",ss%nspec_beam)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nspec_beam
        CALL define_var("q_SNBI","R",indim,idims, &
               "SNBI specie charge", &
               "C","NBI","SIMULATION_INIT", &
               "S|beam_ion     SNBI(nspec_beam)")
     ENDIF
  ENDIF

  iaddr = ps_phash_R0_momeq
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%R0_momeq).AND.ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("R0_momeq","EQ")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_eq.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_eq,"dim_nrho_eq",ss%nrho_eq)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_eq
        CALL define_var("R0_momeq","R",indim,idims, &
               "R0 of flux surface", &
               "m","EQ","STATE_PROFILES", &
               "R|units=m|Hermite_explicit  R0_momeq(nrho_eq)")
     ENDIF
  ENDIF

  iaddr = ps_shash_RAD_Code_Info
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ichange) THEN
     IF(cclist(ps_cnum_RAD).NE.1) THEN
        CALL ccwarn("RAD_Code_Info","RAD")
     ELSE
        indim = 1
        idims(1)=nids%nid_clen_80
        CALL define_var("RAD_Code_Info","C*80",indim,idims, &
               "Information: code implementing RAD component", &
               "__NONE","RAD","SIMULATION_INIT", &
               "C*80   RAD_Code_Info")
     ENDIF
  ENDIF

  iaddr = ps_shash_RAD_Data_Info
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ichange) THEN
     IF(cclist(ps_cnum_RAD).NE.1) THEN
        CALL ccwarn("RAD_Data_Info","RAD")
     ELSE
        indim = 1
        idims(1)=nids%nid_clen_80
        CALL define_var("RAD_Data_Info","C*80",indim,idims, &
               "Information on source of radiated power data", &
               "__NONE","RAD","SIMULATION_INIT", &
               "C*80   RAD_Data_Info")
     ENDIF
  ENDIF

  iaddr = ps_phash_rate_sinb0i
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%rate_sinb0i).AND.ichange) THEN
     IF(cclist(ps_cnum_NBI).NE.1) THEN
        CALL ccwarn("rate_sinb0i","NBI")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_nbi.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_nbi,"dm1_nrho_nbi",ss%nrho_nbi-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_nbi
        IF(nids%nid_dim_nspec_gas.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nspec_gas,"dim_nspec_gas",ss%nspec_gas)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nspec_gas
        CALL define_var("rate_sinb0i","R",indim,idims, &
               "sink rate due to ionization by beam ions", &
               "1/sec","NBI","STATE_PROFILES", &
               "R|step|units=1/sec       rate_sinb0i(~nrho_nbi,nspec_gas)")
     ENDIF
  ENDIF

  iaddr = ps_phash_rate_sinb0x
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%rate_sinb0x).AND.ichange) THEN
     IF(cclist(ps_cnum_NBI).NE.1) THEN
        CALL ccwarn("rate_sinb0x","NBI")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_nbi.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_nbi,"dm1_nrho_nbi",ss%nrho_nbi-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_nbi
        IF(nids%nid_dim_nspec_gas.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nspec_gas,"dim_nspec_gas",ss%nspec_gas)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nspec_gas
        CALL define_var("rate_sinb0x","R",indim,idims, &
               "sink rate due to CX with beam ions (total)", &
               "1/sec","NBI","STATE_PROFILES", &
               "R|step|units=1/sec       rate_sinb0x(~nrho_nbi,nspec_gas)")
     ENDIF
  ENDIF

  iaddr = ps_phash_rate_sinb0xs
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%rate_sinb0xs).AND.ichange) THEN
     IF(cclist(ps_cnum_NBI).NE.1) THEN
        CALL ccwarn("rate_sinb0xs","NBI")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_nbi.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_nbi,"dm1_nrho_nbi",ss%nrho_nbi-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_nbi
        IF(nids%nid_dim_nspec_gas.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nspec_gas,"dim_nspec_gas",ss%nspec_gas)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nspec_gas
        IF(nids%nid_dim_nspec_beam.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nspec_beam,"dim_nspec_beam",ss%nspec_beam)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nspec_beam
        CALL define_var("rate_sinb0xs","R",indim,idims, &
               "sink rate due to CX with beam ions", &
               "1/sec","NBI","STATE_PROFILES", &
               "R|step|units=1/sec       rate_sinb0xs(~nrho_nbi,nspec_gas,nspec_beam)")
     ENDIF
  ENDIF

  iaddr = ps_phash_rate_sinf0i
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%rate_sinf0i).AND.ichange) THEN
     IF(cclist(ps_cnum_FUS).NE.1) THEN
        CALL ccwarn("rate_sinf0i","FUS")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_fus.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_fus,"dm1_nrho_fus",ss%nrho_fus-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_fus
        IF(nids%nid_dim_nspec_gas.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nspec_gas,"dim_nspec_gas",ss%nspec_gas)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nspec_gas
        CALL define_var("rate_sinf0i","R",indim,idims, &
               "sink rate due to ionization by fusion ions", &
               "1/sec","FUS","STATE_PROFILES", &
               "R|step|units=1/sec       rate_sinf0i(~nrho_fus,nspec_gas)")
     ENDIF
  ENDIF

  iaddr = ps_phash_rate_sinf0x
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%rate_sinf0x).AND.ichange) THEN
     IF(cclist(ps_cnum_FUS).NE.1) THEN
        CALL ccwarn("rate_sinf0x","FUS")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_fus.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_fus,"dm1_nrho_fus",ss%nrho_fus-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_fus
        IF(nids%nid_dim_nspec_gas.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nspec_gas,"dim_nspec_gas",ss%nspec_gas)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nspec_gas
        CALL define_var("rate_sinf0x","R",indim,idims, &
               "sink rate due to CX with fusion ions (total)", &
               "1/sec","FUS","STATE_PROFILES", &
               "R|step|units=1/sec       rate_sinf0x(~nrho_fus,nspec_gas)")
     ENDIF
  ENDIF

  iaddr = ps_phash_rate_sinf0xs
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%rate_sinf0xs).AND.ichange) THEN
     IF(cclist(ps_cnum_FUS).NE.1) THEN
        CALL ccwarn("rate_sinf0xs","FUS")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_fus.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_fus,"dm1_nrho_fus",ss%nrho_fus-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_fus
        IF(nids%nid_dim_nspec_gas.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nspec_gas,"dim_nspec_gas",ss%nspec_gas)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nspec_gas
        IF(nids%nid_dim_nspec_fusion.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nspec_fusion,"dim_nspec_fusion",ss%nspec_fusion)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nspec_fusion
        CALL define_var("rate_sinf0xs","R",indim,idims, &
               "sink rate due to CX with fusion ions", &
               "1/sec","FUS","STATE_PROFILES", &
               "R|step|units=1/sec       rate_sinf0xs(~nrho_fus,nspec_gas,nspec_fusion)")
     ENDIF
  ENDIF

  iaddr = ps_shash_Real_ant_coef
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%Real_ant_coef).AND.ichange) THEN
     IF(cclist(ps_cnum_IC).NE.1) THEN
        CALL ccwarn("Real_ant_coef","IC")
     ELSE
        indim = 0
        IF(nids%nid_dim_max_num_nphi_vac.EQ.0) THEN
           CALL define_dim(nids%nid_dim_max_num_nphi_vac,"dim_max_num_nphi_vac",ss%max_num_nphi_vac)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_max_num_nphi_vac
        IF(nids%nid_dim_nicrf_src.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nicrf_src,"dim_nicrf_src",ss%nicrf_src)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nicrf_src
        CALL define_var("Real_ant_coef","R",indim,idims, &
               "real part of Fourier Coef", &
               "Amps/m","IC","SHOT_CONFIGURATION", &
               "R|units=Amps/m Real_ant_coef(num_nphi_vac(),nicrf_src)")
     ENDIF
  ENDIF

  iaddr = ps_phash_res_sn
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%res_sn).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("res_sn","PLASMA")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho,"dm1_nrho",ss%nrho-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho
        IF(nids%nid_dp1_nspec_th.EQ.0) THEN
           CALL define_dim(nids%nid_dp1_nspec_th,"dp1_nspec_th",ss%nspec_th+1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dp1_nspec_th
        CALL define_var("res_sn","R",indim,idims, &
               "residuals for particle transport eqn", &
               "Norm","PLASMA","STATE_PROFILES", &
               "R|units=Norm|step*dV res_sn(~nrho,0:nspec_th)")
     ENDIF
  ENDIF

  iaddr = ps_phash_res_te
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%res_te).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("res_te","PLASMA")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho,"dm1_nrho",ss%nrho-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho
        CALL define_var("res_te","R",indim,idims, &
               "residuals for electron transport eqn", &
               "Norm","PLASMA","STATE_PROFILES", &
               "R|step*dV res_te(~nrho)")
     ENDIF
  ENDIF

  iaddr = ps_phash_res_ti
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%res_ti).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("res_ti","PLASMA")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho,"dm1_nrho",ss%nrho-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho
        CALL define_var("res_ti","R",indim,idims, &
               "residuals for ion transport eqn", &
               "Norm","PLASMA","STATE_PROFILES", &
               "R|step*dV res_ti(~nrho)")
     ENDIF
  ENDIF

  iaddr = ps_phash_res_tq
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%res_tq).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("res_tq","PLASMA")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho,"dm1_nrho",ss%nrho-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho
        CALL define_var("res_tq","R",indim,idims, &
               "rediduals for angular momentum transport eqn", &
               "Norm","PLASMA","STATE_PROFILES", &
               "R|units=Norm|step*dV res_tq(~nrho)")
     ENDIF
  ENDIF

  iaddr = ps_dhash_nspec_rfmin
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%RFMIN_name).AND.ichange) THEN
     IF(cclist(ps_cnum_IC).NE.1) THEN
        CALL ccwarn("RFMIN_name","IC")
     ELSE
        indim = 1
        idims(1)=nids%nid_clen_32
        IF(nids%nid_dim_nspec_rfmin.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nspec_rfmin,"dim_nspec_rfmin",ss%nspec_rfmin)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nspec_rfmin
        CALL define_var("RFMIN_name","N",indim,idims, &
               "ICRF minority species", &
               "__NONE","IC","SHOT_CONFIGURATION", &
               "S|RF_minority  RFMIN(nspec_rfmin)")
     ENDIF
  ENDIF

  iaddr = ps_shash_rfmin_to_all
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%rfmin_to_all).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("rfmin_to_all","PLASMA")
     ELSE
        indim = 0
        IF(nids%nid_dim_nspec_rfmin.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nspec_rfmin,"dim_nspec_rfmin",ss%nspec_rfmin)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nspec_rfmin
        CALL define_var("rfmin_to_all","I",indim,idims, &
               'map rfmin index to "all" list', &
               "__NONE","PLASMA","SIMULATION_INIT", &
               "I  rfmin_to_all(nspec_rfmin)")
     ENDIF
  ENDIF

  iaddr = ps_shash_rfmin_to_alla
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%rfmin_to_alla).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("rfmin_to_alla","PLASMA")
     ELSE
        indim = 0
        IF(nids%nid_dim_nspec_rfmin.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nspec_rfmin,"dim_nspec_rfmin",ss%nspec_rfmin)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nspec_rfmin
        CALL define_var("rfmin_to_alla","I",indim,idims, &
               'map rfmin index to "alla" list', &
               "__NONE","PLASMA","SIMULATION_INIT", &
               "I  rfmin_to_alla(nspec_rfmin)")
     ENDIF
  ENDIF

  iaddr = ps_dhash_nspec_rfmin
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%RFMIN_type).AND.ichange) THEN
     IF(cclist(ps_cnum_IC).NE.1) THEN
        CALL ccwarn("RFMIN_type","IC")
     ELSE
        indim = 0
        IF(nids%nid_dim_nspec_rfmin.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nspec_rfmin,"dim_nspec_rfmin",ss%nspec_rfmin)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nspec_rfmin
        CALL define_var("RFMIN_type","I",indim,idims, &
               "RFMIN specie types", &
               "__NONE","IC","SHOT_CONFIGURATION", &
               "S|RF_minority  RFMIN(nspec_rfmin)")
     ENDIF
  ENDIF

  iaddr = ps_dhash_nrho
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%rho).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("rho","PLASMA")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho,"dim_nrho",ss%nrho)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho
        CALL define_var("rho","R",indim,idims, &
               "rho grid (PLASMA)", &
               "-","PLASMA","SIMULATION_INIT", &
               "G   rho(nrho)")
     ENDIF
  ENDIF

  iaddr = ps_shash_rhopsi0lh
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%rhopsi0lh).AND.ichange) THEN
     IF(cclist(ps_cnum_LH).NE.1) THEN
        CALL ccwarn("rhopsi0lh","LH")
     ELSE
        indim = 0
        IF(nids%nid_dim_max_nspectrumlh_src.EQ.0) THEN
           CALL define_dim(nids%nid_dim_max_nspectrumlh_src,"dim_max_nspectrumlh_src",ss%max_nspectrumlh_src)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_max_nspectrumlh_src
        IF(nids%nid_dim_nlhrf_src.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nlhrf_src,"dim_nlhrf_src",ss%nlhrf_src)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nlhrf_src
        CALL define_var("rhopsi0lh","R",indim,idims, &
               "need description", &
               "-","LH","SHOT_CONFIGURATION", &
               "R|units=- rhopsi0lh(nspectrumlh_src(),nlhrf_src)")
     ENDIF
  ENDIF

  iaddr = ps_dhash_nrho_anom
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%rho_anom).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("rho_anom","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anom.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anom,"dim_nrho_anom",ss%nrho_anom)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anom
        CALL define_var("rho_anom","R",indim,idims, &
               "rho grid (1d anomalous transport profiles)", &
               "-","ANOM","SIMULATION_INIT", &
               "G  rho_anom(nrho_anom)")
     ENDIF
  ENDIF

  iaddr = ps_dhash_nrho_anom2
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%rho_anom2).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("rho_anom2","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anom2.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anom2,"dim_nrho_anom2",ss%nrho_anom2)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anom2
        CALL define_var("rho_anom2","R",indim,idims, &
               "rho grid (2d anomalous transport profiles)", &
               "-","ANOM","SIMULATION_INIT", &
               "G  rho_anom2(nrho_anom2)")
     ENDIF
  ENDIF

  iaddr = ps_dhash_nrho_anomth
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%rho_anomth).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("rho_anomth","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        CALL define_var("rho_anomth","R",indim,idims, &
               "rho grid (1d anomalous data for 1d", &
               "-","ANOM","SIMULATION_INIT", &
               "G  rho_anomth(nrho_anomth)")
     ENDIF
  ENDIF

  iaddr = ps_shash_rho_bdy_ns
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%rho_bdy_ns).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("rho_bdy_ns","PLASMA")
     ELSE
        indim = 0
        IF(nids%nid_dp1_nspec_th.EQ.0) THEN
           CALL define_dim(nids%nid_dp1_nspec_th,"dp1_nspec_th",ss%nspec_th+1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dp1_nspec_th
        CALL define_var("rho_bdy_ns","R",indim,idims, &
               "locations beyond which densities are known", &
               "-","PLASMA","STATE_DATA", &
               "R|units=- rho_bdy_ns(0:nspec_th)")
     ENDIF
  ENDIF

  iaddr = ps_shash_rho_bdy_omegat
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("rho_bdy_omegat","PLASMA")
     ELSE
        indim = 0
        CALL define_var("rho_bdy_omegat","R",indim,idims, &
               "location beyond which angular velocity is known", &
               "-","PLASMA","STATE_DATA", &
               "R rho_bdy_omegat")
     ENDIF
  ENDIF

  iaddr = ps_shash_rho_bdy_Te
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("rho_bdy_Te","PLASMA")
     ELSE
        indim = 0
        CALL define_var("rho_bdy_Te","R",indim,idims, &
               "location beyond which Te is known", &
               "-","PLASMA","STATE_DATA", &
               "R rho_bdy_Te")
     ENDIF
  ENDIF

  iaddr = ps_shash_rho_bdy_Ti
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("rho_bdy_Ti","PLASMA")
     ELSE
        indim = 0
        CALL define_var("rho_bdy_Ti","R",indim,idims, &
               "location beyond which Ti is known", &
               "-","PLASMA","STATE_DATA", &
               "R rho_bdy_Ti")
     ENDIF
  ENDIF

  iaddr = ps_dhash_nrho_ecrf
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%rho_ecrf).AND.ichange) THEN
     IF(cclist(ps_cnum_EC).NE.1) THEN
        CALL ccwarn("rho_ecrf","EC")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_ecrf.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_ecrf,"dim_nrho_ecrf",ss%nrho_ecrf)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_ecrf
        CALL define_var("rho_ecrf","R",indim,idims, &
               "rho grid -- ECRF", &
               "-","EC","SIMULATION_INIT", &
               "G  rho_ecrf(nrho_ecrf)")
     ENDIF
  ENDIF

  iaddr = ps_dhash_nrho_eq
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%rho_eq).AND.ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("rho_eq","EQ")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_eq.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_eq,"dim_nrho_eq",ss%nrho_eq)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_eq
        CALL define_var("rho_eq","R",indim,idims, &
               "rho grid (EQ)", &
               "-","EQ","SIMULATION_INIT", &
               "G   rho_eq(nrho_eq)")
     ENDIF
  ENDIF

  iaddr = ps_dhash_nrho_eq_geo
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%rho_eq_geo).AND.ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("rho_eq_geo","EQ")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_eq_geo.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_eq_geo,"dim_nrho_eq_geo",ss%nrho_eq_geo)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_eq_geo
        CALL define_var("rho_eq_geo","R",indim,idims, &
               "rho grid (EQ flux surface averages)", &
               "-","EQ","SIMULATION_INIT", &
               "G   rho_eq_geo(nrho_eq_geo)")
     ENDIF
  ENDIF

  iaddr = ps_dhash_nrho_fus
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%rho_fus).AND.ichange) THEN
     IF(cclist(ps_cnum_FUS).NE.1) THEN
        CALL ccwarn("rho_fus","FUS")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_fus.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_fus,"dim_nrho_fus",ss%nrho_fus)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_fus
        CALL define_var("rho_fus","R",indim,idims, &
               "rho grid -- Fusion products model", &
               "-","FUS","SIMULATION_INIT", &
               "G  rho_fus(nrho_fus)")
     ENDIF
  ENDIF

  iaddr = ps_dhash_nrho_gas
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%rho_gas).AND.ichange) THEN
     IF(cclist(ps_cnum_GAS).NE.1) THEN
        CALL ccwarn("rho_gas","GAS")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_gas.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_gas,"dim_nrho_gas",ss%nrho_gas)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_gas
        CALL define_var("rho_gas","R",indim,idims, &
               "rho grid (GAS -- neutral gas model)", &
               "-","GAS","SIMULATION_INIT", &
               "G  rho_gas(nrho_gas)")
     ENDIF
  ENDIF

  iaddr = ps_dhash_nrho_icrf
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%rho_icrf).AND.ichange) THEN
     IF(cclist(ps_cnum_IC).NE.1) THEN
        CALL ccwarn("rho_icrf","IC")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_icrf.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_icrf,"dim_nrho_icrf",ss%nrho_icrf)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_icrf
        CALL define_var("rho_icrf","R",indim,idims, &
               "rho grid (RF)", &
               "-","IC","SIMULATION_INIT", &
               "G  rho_icrf(nrho_icrf)")
     ENDIF
  ENDIF

  iaddr = ps_dhash_nrho_lhrf
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%rho_lhrf).AND.ichange) THEN
     IF(cclist(ps_cnum_LH).NE.1) THEN
        CALL ccwarn("rho_lhrf","LH")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_lhrf.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_lhrf,"dim_nrho_lhrf",ss%nrho_lhrf)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_lhrf
        CALL define_var("rho_lhrf","R",indim,idims, &
               "rho grid -- LHRF", &
               "-","LH","SIMULATION_INIT", &
               "G  rho_lhrf(nrho_lhrf)")
     ENDIF
  ENDIF

  iaddr = ps_dhash_nrho_lmhd
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%rho_lmhd).AND.ichange) THEN
     IF(cclist(ps_cnum_LMHD).NE.1) THEN
        CALL ccwarn("rho_lmhd","LMHD")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_lmhd.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_lmhd,"dim_nrho_lmhd",ss%nrho_lmhd)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_lmhd
        CALL define_var("rho_lmhd","R",indim,idims, &
               "rho grid (LMHD component)", &
               "-","LMHD","SIMULATION_INIT", &
               "G  rho_lmhd(nrho_lmhd)")
     ENDIF
  ENDIF

  iaddr = ps_dhash_nrho_mist
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%rho_mist).AND.ichange) THEN
     IF(cclist(ps_cnum_RAD).NE.1) THEN
        CALL ccwarn("rho_mist","RAD")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_mist.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_mist,"dim_nrho_mist",ss%nrho_mist)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_mist
        CALL define_var("rho_mist","R",indim,idims, &
               "rho grid (PLASMA) impurity-driven sources", &
               "-","RAD","SIMULATION_INIT", &
               "G  rho_mist(nrho_mist)")
     ENDIF
  ENDIF

  iaddr = ps_dhash_nrho_nbi
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%rho_nbi).AND.ichange) THEN
     IF(cclist(ps_cnum_NBI).NE.1) THEN
        CALL ccwarn("rho_nbi","NBI")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_nbi.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_nbi,"dim_nrho_nbi",ss%nrho_nbi)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_nbi
        CALL define_var("rho_nbi","R",indim,idims, &
               "rho grid -- NBI", &
               "-","NBI","SIMULATION_INIT", &
               "G  rho_nbi(nrho_nbi)")
     ENDIF
  ENDIF

  iaddr = ps_dhash_nrho_pel
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%rho_pel).AND.ichange) THEN
     IF(cclist(ps_cnum_PEL).NE.1) THEN
        CALL ccwarn("rho_pel","PEL")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_pel.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_pel,"dim_nrho_pel",ss%nrho_pel)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_pel
        CALL define_var("rho_pel","R",indim,idims, &
               "rho grid -- PEL", &
               "-","PEL","SIMULATION_INIT", &
               "G  rho_pel(nrho_pel)")
     ENDIF
  ENDIF

  iaddr = ps_dhash_nrho_rad
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%rho_rad).AND.ichange) THEN
     IF(cclist(ps_cnum_RAD).NE.1) THEN
        CALL ccwarn("rho_rad","RAD")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_rad.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_rad,"dim_nrho_rad",ss%nrho_rad)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_rad
        CALL define_var("rho_rad","R",indim,idims, &
               "rho grid (RAD)", &
               "-","RAD","SIMULATION_INIT", &
               "G  rho_rad(nrho_rad)")
     ENDIF
  ENDIF

  iaddr = ps_dhash_nrho_rw
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%rho_rw).AND.ichange) THEN
     IF(cclist(ps_cnum_RUNAWAY).NE.1) THEN
        CALL ccwarn("rho_rw","RUNAWAY")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_rw.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_rw,"dim_nrho_rw",ss%nrho_rw)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_rw
        CALL define_var("rho_rw","R",indim,idims, &
               "rho grid -- RUNAWAY electrons", &
               "-","RUNAWAY","SIMULATION_INIT", &
               "G  rho_rw(nrho_rw)")
     ENDIF
  ENDIF

  iaddr = ps_shash_rlim
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%rlim).AND.ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("rlim","EQ")
     ELSE
        indim = 0
        IF(nids%nid_dim_num_rzlim.EQ.0) THEN
           CALL define_dim(nids%nid_dim_num_rzlim,"dim_num_rzlim",ss%num_rzlim)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_num_rzlim
        CALL define_var("rlim","R",indim,idims, &
               "R points in closed (R,Z) contour sequence", &
               "m","EQ","MACHINE_DESCRIPTION", &
               "R|units=m  rlim(num_rzlim)")
     ENDIF
  ENDIF
  CONTAINS


     SUBROUTINE define_dim(dimid,dname,idval)
        INTEGER, intent(out) :: dimid
        CHARACTER*(*), INTENT(in) :: dname
        INTEGER, intent(in) :: idval

        status = nf90_def_dim(icdf,dname,idval,dimid)
        IF(status.NE.NF90_NOERR) THEN
           WRITE(iout,*) ' ?ps_update_file_write: error defining dimension "'// &
                 trim(dname)//'".'
           IERR=9999
        ENDIF
     END SUBROUTINE define_dim



     SUBROUTINE define_var(name,dtype,indim,idims, &
          long_name,units,component,section,spec)

        CHARACTER*(*), INTENT(in) :: name
        CHARACTER*(*), INTENT(in) :: dtype
        INTEGER, INTENT(in) :: indim
        INTEGER, dimension(:), INTENT(in) :: idims
        CHARACTER*(*), INTENT(in) :: long_name
        CHARACTER*(*), INTENT(in) :: units
        CHARACTER*(*), INTENT(in) :: component
        CHARACTER*(*), INTENT(in) :: section
        CHARACTER*(*), INTENT(in) :: spec

        integer :: itype

        IF(dtype.EQ.'R') THEN
           itype = NF90_DOUBLE

        ELSE IF (dtype.EQ.'I') THEN
           itype = NF90_INT

        ELSE
           itype = NF90_CHAR

        ENDIF

        IF(indim.EQ.0) THEN
           status=nf90_def_var(icdf,name,itype, varid=varid)

        ELSE
           status=nf90_def_var(icdf,name,itype, dimids=idims(1:indim),varid=varid)

        ENDIF

        IF(status.NE.NF90_NOERR) THEN
           WRITE(iout,*) " ?plasma_state_store: error defining variable: "//trim(name)
           CALL ncerr(status)
           iertot = iertot + 1
           RETURN
        ENDIF

        ! Variable OK, now add attributes:

        CALL add_attrib("long_name",long_name)
        IF(dtype.EQ.'R') CALL add_attrib("units",units)
        CALL add_attrib("component",component)
        CALL add_attrib("section",section)
        CALL add_attrib("specification",spec)

     END SUBROUTINE define_var

     SUBROUTINE add_attrib(name,value)
        CHARACTER*(*), intent(in) :: name
        CHARACTER*(*), intent(in) :: value

        status=nf90_put_att(icdf,varid,name,value)
        IF(status.NE.NF90_NOERR) THEN
           WRITE(iout,*) " ?plasma_state_store: error defining attribute: "//trim(name)//' = '//trim(value)
           CALL ncerr(status)
           iertot = iertot + 1
        ENDIF
     END SUBROUTINE add_attrib



     SUBROUTINE ncerr(status)
        INTEGER, INTENT(in) :: status

        nc_errmsg = NF90_strerror(status)
        write(iout,*) '  NetCDF message: ',trim(nc_errmsg)
     END SUBROUTINE ncerr



     SUBROUTINE ccwarn(varnam,compnam)

        CHARACTER*(*), intent(in) :: varnam   ! name of variable or array
        CHARACTER*(*), intent(in) :: compnam  ! name of component

        if(iwarn.eq.0) then
           write(iout,*) ' '
           write(iout,*) ' %ps_update_file_write: modified state elements'
           write(iout,*) '  exist which were not written due to the "cclist"'
           write(iout,*) '  input variable which screens out elements from'
           write(iout,*) '  selected components: cclist = ',cclist,';'
           write(iout,*) '  element values of 1 indicate components that are'
           write(iout,*) '  enabled for write.'
           write(iout,*) ' '
        endif

        iwarn = iwarn + 1

        write(iout,*) ' %ps_update_file_write: modified: ss%'// &
             trim(varnam)//' ('//trim(compnam)//' component) NOT WRITTEN.'

     END SUBROUTINE ccwarn

END SUBROUTINE ps_update_file_write_def_6

SUBROUTINE ps_update_file_write_6(ss,icdf,cclist,iucount,iout,iwarn,iertot)


  ! Write updated data

  USE plasma_state_definition_mod
  USE netcdf
  IMPLICIT NONE

  TYPE (plasma_state) :: ss  ! state containing array elements to be allocated
  INTEGER, INTENT(IN) :: icdf  ! NetCDF file ID
  INTEGER, INTENT(IN) :: cclist(ps_ccount)  ! component selection
  INTEGER, INTENT(INOUT) :: iucount ! update count
  INTEGER, INTENT(IN) :: iout  ! LUN for messages
  INTEGER, INTENT(INOUT) :: iwarn   ! warn count
  INTEGER, INTENT(INOUT) :: iertot  ! error count

  !-------------------

  INTEGER :: varid,status
  CHARACTER*80 :: nc_errmsg

  !-------------------


  status = nf90_inq_varid(icdf,"PsiRZ",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%PsiRZ)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: PsiRZ"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Psi_to_machine_axis",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%Psi_to_machine_axis)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: Psi_to_machine_axis"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"psmom_errck",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%psmom_errck)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: psmom_errck"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"psmom_nc",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%psmom_nc)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: psmom_nc"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"psmom_num",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%psmom_num)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: psmom_num"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"P_eq",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%P_eq)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: P_eq"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"qatom_ALL",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%qatom_ALL)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: qatom_ALL"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"qatom_ALLA",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%qatom_ALLA)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: qatom_ALLA"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"qatom_RFMIN",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%qatom_RFMIN)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: qatom_RFMIN"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"qatom_S",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%qatom_S)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: qatom_S"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"qatom_SA",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%qatom_SA)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: qatom_SA"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"qatom_SFUS",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%qatom_SFUS)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: qatom_SFUS"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"qatom_SGAS",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%qatom_SGAS)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: qatom_SGAS"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"qatom_SIMP0",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%qatom_SIMP0)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: qatom_SIMP0"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"qatom_SIMPI",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%qatom_SIMPI)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: qatom_SIMPI"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"qatom_SNBI",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%qatom_SNBI)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: qatom_SNBI"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"qbeami",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%qbeami)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: qbeami"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"qcomp_e",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%qcomp_e)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: qcomp_e"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"qcomp_i",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%qcomp_i)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: qcomp_i"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"qie",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%qie)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: qie"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"qioniz",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%qioniz)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: qioniz"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"ql_operator",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%ql_operator)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: ql_operator"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"qqcx",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%qqcx)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: qqcx"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"qrot_conv",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%qrot_conv)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: qrot_conv"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"qrot_diff",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%qrot_diff)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: qrot_diff"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"q_ALL",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%q_ALL)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: q_ALL"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"q_ALLA",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%q_ALLA)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: q_ALLA"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"q_eq",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%q_eq)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: q_eq"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"q_RFMIN",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%q_RFMIN)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: q_RFMIN"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"q_S",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%q_S)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: q_S"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"q_SA",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%q_SA)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: q_SA"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"q_SFUS",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%q_SFUS)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: q_SFUS"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"q_SGAS",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%q_SGAS)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: q_SGAS"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"q_SIMP0",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%q_SIMP0)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: q_SIMP0"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"q_SIMPI",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%q_SIMPI)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: q_SIMPI"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"q_SNBI",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%q_SNBI)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: q_SNBI"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"R0_momeq",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%R0_momeq)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: R0_momeq"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"RAD_Code_Info",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%RAD_Code_Info)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: RAD_Code_Info"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"RAD_Data_Info",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%RAD_Data_Info)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: RAD_Data_Info"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"rate_sinb0i",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%rate_sinb0i)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: rate_sinb0i"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"rate_sinb0x",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%rate_sinb0x)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: rate_sinb0x"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"rate_sinb0xs",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%rate_sinb0xs)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: rate_sinb0xs"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"rate_sinf0i",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%rate_sinf0i)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: rate_sinf0i"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"rate_sinf0x",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%rate_sinf0x)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: rate_sinf0x"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"rate_sinf0xs",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%rate_sinf0xs)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: rate_sinf0xs"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Real_ant_coef",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%Real_ant_coef)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: Real_ant_coef"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"res_sn",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%res_sn)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: res_sn"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"res_te",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%res_te)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: res_te"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"res_ti",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%res_ti)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: res_ti"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"res_tq",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%res_tq)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: res_tq"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"RFMIN_name",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%RFMIN_name)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: RFMIN_name"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"rfmin_to_all",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%rfmin_to_all)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: rfmin_to_all"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"rfmin_to_alla",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%rfmin_to_alla)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: rfmin_to_alla"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"RFMIN_type",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%RFMIN_type)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: RFMIN_type"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"rho",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%rho)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: rho"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"rhopsi0lh",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%rhopsi0lh)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: rhopsi0lh"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"rho_anom",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%rho_anom)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: rho_anom"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"rho_anom2",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%rho_anom2)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: rho_anom2"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"rho_anomth",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%rho_anomth)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: rho_anomth"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"rho_bdy_ns",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%rho_bdy_ns)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: rho_bdy_ns"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"rho_bdy_omegat",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%rho_bdy_omegat)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: rho_bdy_omegat"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"rho_bdy_Te",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%rho_bdy_Te)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: rho_bdy_Te"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"rho_bdy_Ti",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%rho_bdy_Ti)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: rho_bdy_Ti"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"rho_ecrf",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%rho_ecrf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: rho_ecrf"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"rho_eq",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%rho_eq)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: rho_eq"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"rho_eq_geo",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%rho_eq_geo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: rho_eq_geo"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"rho_fus",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%rho_fus)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: rho_fus"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"rho_gas",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%rho_gas)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: rho_gas"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"rho_icrf",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%rho_icrf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: rho_icrf"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"rho_lhrf",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%rho_lhrf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: rho_lhrf"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"rho_lmhd",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%rho_lmhd)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: rho_lmhd"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"rho_mist",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%rho_mist)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: rho_mist"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"rho_nbi",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%rho_nbi)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: rho_nbi"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"rho_pel",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%rho_pel)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: rho_pel"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"rho_rad",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%rho_rad)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: rho_rad"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"rho_rw",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%rho_rw)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: rho_rw"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"rlim",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%rlim)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: rlim"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF
  CONTAINS


     SUBROUTINE ncerr(status)
        INTEGER, INTENT(in) :: status

        nc_errmsg = NF90_strerror(status)
        write(iout,*) '  NetCDF message: ',trim(nc_errmsg)
     END SUBROUTINE ncerr

END SUBROUTINE ps_update_file_write_6

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_a2_dummy
     return
  end subroutine ccps_getset_a2_dummy

subroutine psget_ap_halfheight(iobj, n1, data, ierr)
    !! aperture half-height, for nbap_shape(j)="rectangle", this is
    !! the vertical size, specification; this quantity ignored for
    !! nbap_shape(j)="circle".
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_ap_halfheight', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % ap_halfheight
end subroutine psget_ap_halfheight


subroutine psset_ap_halfheight(iobj, n1, data, ierr)
    !! aperture half-height, for nbap_shape(j)="rectangle", this is
    !! the vertical size, specification; this quantity ignored for
    !! nbap_shape(j)="circle".
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_ap_halfheight', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % ap_halfheight = data(1:n1)
end subroutine psset_ap_halfheight


subroutine psgetrnk_ap_halfheight(iobj, ndims, ierr)
    !! aperture half-height, for nbap_shape(j)="rectangle", this is
    !! the vertical size, specification; this quantity ignored for
    !! nbap_shape(j)="circle".
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_ap_halfheight


subroutine psgetdim_ap_halfheight(iobj, ndims, dims, ierr)
    !! aperture half-height, for nbap_shape(j)="rectangle", this is
    !! the vertical size, specification; this quantity ignored for
    !! nbap_shape(j)="circle".
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_ap_halfheight', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % ap_halfheight ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % ap_halfheight)
    endif
end subroutine psgetdim_ap_halfheight


subroutine psget_apolminlh(iobj, n1, n2, data, ierr)
    !! poloidal mode number left of lumps
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_apolminlh', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % apolminlh
end subroutine psget_apolminlh


subroutine psset_apolminlh(iobj, n1, n2, data, ierr)
    !! poloidal mode number left of lumps
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_apolminlh', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % apolminlh = data(1:n1, 1: n2)
end subroutine psset_apolminlh


subroutine psgetrnk_apolminlh(iobj, ndims, ierr)
    !! poloidal mode number left of lumps
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_apolminlh


subroutine psgetdim_apolminlh(iobj, ndims, dims, ierr)
    !! poloidal mode number left of lumps
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_apolminlh', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % apolminlh ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % apolminlh)
    endif
end subroutine psgetdim_apolminlh


subroutine psget_anom_code_info(iobj, data, ierr)
    !! Information: code implementing ANOM component
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    CHARACTER*(*), intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_anom_code_info', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % ANOM_Code_Info
end subroutine psget_anom_code_info


subroutine psset_anom_code_info(iobj, data, ierr)
    !! Information: code implementing ANOM component
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    CHARACTER*(*), intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_anom_code_info', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % ANOM_Code_Info = data
end subroutine psset_anom_code_info


subroutine psgetsz_anom_code_info(iobj, size, ierr)
    !! Information: code implementing ANOM component
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: size    ! size of character string
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psgetsz_anom_code_info', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! note that the following will return the character length size regardless of
    ! the number of array elements (if ANOM_Code_Info is an array)
    size = len(ss % ANOM_Code_Info)
end subroutine psgetsz_anom_code_info

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_v7_dummy
     return
  end subroutine ccps_getset_v7_dummy

subroutine psget_vsur_data_info(iobj, data, ierr)
    !! information on source of surface voltage data
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    CHARACTER*(*), intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_vsur_data_info', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % VSUR_Data_Info
end subroutine psget_vsur_data_info


subroutine psset_vsur_data_info(iobj, data, ierr)
    !! information on source of surface voltage data
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    CHARACTER*(*), intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_vsur_data_info', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % VSUR_Data_Info = data
end subroutine psset_vsur_data_info


subroutine psgetsz_vsur_data_info(iobj, size, ierr)
    !! information on source of surface voltage data
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: size    ! size of character string
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psgetsz_vsur_data_info', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! note that the following will return the character length size regardless of
    ! the number of array elements (if VSUR_Data_Info is an array)
    size = len(ss % VSUR_Data_Info)
end subroutine psgetsz_vsur_data_info


subroutine psget_v_loop(iobj, n1, data, ierr)
    !! loop voltage
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_v_loop', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % V_loop
end subroutine psget_v_loop


subroutine psset_v_loop(iobj, n1, data, ierr)
    !! loop voltage
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_v_loop', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % V_loop = data(1:n1)
end subroutine psset_v_loop


subroutine psgetrnk_v_loop(iobj, ndims, ierr)
    !! loop voltage
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_v_loop


subroutine psgetdim_v_loop(iobj, ndims, dims, ierr)
    !! loop voltage
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_v_loop', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % V_loop ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % V_loop)
    endif
end subroutine psgetdim_v_loop


subroutine psget_velpphi_tglf(iobj, n1, data, ierr)
    !! momentum-equation, advective velocity term from TGLF model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_velpphi_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % velpphi_tglf
end subroutine psget_velpphi_tglf


subroutine psset_velpphi_tglf(iobj, n1, data, ierr)
    !! momentum-equation, advective velocity term from TGLF model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_velpphi_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % velpphi_tglf = data(1:n1)
end subroutine psset_velpphi_tglf


subroutine psgetrnk_velpphi_tglf(iobj, ndims, ierr)
    !! momentum-equation, advective velocity term from TGLF model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_velpphi_tglf


subroutine psgetdim_velpphi_tglf(iobj, ndims, dims, ierr)
    !! momentum-equation, advective velocity term from TGLF model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_velpphi_tglf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % velpphi_tglf ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % velpphi_tglf)
    endif
end subroutine psgetdim_velpphi_tglf


subroutine psget_velte_mmm71(iobj, n1, data, ierr)
    !! Te-equation, advective velocity term from MMM71 model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_velte_mmm71', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % velte_mmm71
end subroutine psget_velte_mmm71


subroutine psset_velte_mmm71(iobj, n1, data, ierr)
    !! Te-equation, advective velocity term from MMM71 model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_velte_mmm71', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % velte_mmm71 = data(1:n1)
end subroutine psset_velte_mmm71


subroutine psgetrnk_velte_mmm71(iobj, ndims, ierr)
    !! Te-equation, advective velocity term from MMM71 model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_velte_mmm71


subroutine psgetdim_velte_mmm71(iobj, ndims, dims, ierr)
    !! Te-equation, advective velocity term from MMM71 model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_velte_mmm71', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % velte_mmm71 ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % velte_mmm71)
    endif
end subroutine psgetdim_velte_mmm71


subroutine psget_velns_gtcneo(iobj, n1, n2, data, ierr)
    !! density-equations, advective velocity term from GTC_NEO model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_velns_gtcneo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % velns_gtcneo
end subroutine psget_velns_gtcneo


subroutine psset_velns_gtcneo(iobj, n1, n2, data, ierr)
    !! density-equations, advective velocity term from GTC_NEO model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_velns_gtcneo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % velns_gtcneo = data(1:n1, 1: n2)
end subroutine psset_velns_gtcneo


subroutine psgetrnk_velns_gtcneo(iobj, ndims, ierr)
    !! density-equations, advective velocity term from GTC_NEO model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_velns_gtcneo


subroutine psgetdim_velns_gtcneo(iobj, ndims, dims, ierr)
    !! density-equations, advective velocity term from GTC_NEO model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_velns_gtcneo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % velns_gtcneo ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % velns_gtcneo)
    endif
end subroutine psgetdim_velns_gtcneo


subroutine psget_velnx_nclass(iobj, n1, data, ierr)
    !! main-impurity-density-equations, advective velocity term
    !! from NCLASS model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_velnx_nclass', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % velnx_nclass
end subroutine psget_velnx_nclass


subroutine psset_velnx_nclass(iobj, n1, data, ierr)
    !! main-impurity-density-equations, advective velocity term
    !! from NCLASS model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_velnx_nclass', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % velnx_nclass = data(1:n1)
end subroutine psset_velnx_nclass


subroutine psgetrnk_velnx_nclass(iobj, ndims, ierr)
    !! main-impurity-density-equations, advective velocity term
    !! from NCLASS model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_velnx_nclass


subroutine psgetdim_velnx_nclass(iobj, ndims, dims, ierr)
    !! main-impurity-density-equations, advective velocity term
    !! from NCLASS model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_velnx_nclass', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % velnx_nclass ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % velnx_nclass)
    endif
end subroutine psgetdim_velnx_nclass

program geq2ps

  !  DMC Apr 2008: geq2ps, G-eqdsk to plasma state

  !  this program creates or modifies a plasma state with MHD equilibrium 
  !  representation from a file or MDS+ G-eqdsk dataset.  This includes a 
  !  mapping of the g-eqdsk Psi(R,Z) direct representation of the tokamak 
  !  MHD equilibrium to an "inverse representation" [R,Z](rho,theta), 
  !  g(rho), q(rho), P(rho).

  !  this program takes command line arguments.  Syntax:

  !     geq2ps <geq-path> <ps-path> \
  !         [-nrho:<# of rho surfaces>] [-nth:<# poloidal angle grid pts>]
  !         [-c_ratio:<curvature ratio>]
  !         [-rho_curbrk:<rho-value>] [-qcur:<EFIT|PSI|AUTO>] ...

  !            <geq-path> can be a file path or an MDS+ path
  !            if the argument starts with "MDS+:" it is the latter.

  !            MDS path examples:
  !                MDS+:skylark.pppl.gov:8501:EFIT01(104370;t=1.0e-1)
  !                MDS+:cmoda.psfc.mit.edu:EFIT09(123456789;t=2.3)

  !                generally: MDS+:<server>:<tree>(shot;t=<time-of-interest>)

  !            <ps-path> is a file path for the output plasma state file 
  !            written by this program; a writable path must be provided.

  !  -nrho defaults to 51 radial surfaces (counting axis and boundary)
  !        equally spaced in rho = normalized sqrt(enclosed toroidal flux)
  !        covering [0:1] (minimum of 11 radial grid points enforced).
  !        example:  "-nrho:101" -- no imbedded blanks, please.

  !  -nth  defaults to 101 poloidal grid points -- equal arc poloidal angle
  !        coordinate is used covering [-pi:pi] (minimum of 41 poloidal 
  !        grid points enforced).
  !        example:  "-nth:151" -- no imbedded blanks, please.

  !  -c_ratio  dimensionless quantity specifying the "minimum curvature ratio"
  !        allowed along the flux surface selected as the boundary of the
  !        equilibrium inverse representation.  The local curvature ratio is
  !        the numerically estimated radius of curvature of the boundary,
  !        divided by the plasma midplane half-width.  If a boundary surface
  !        comes near a separatrix, its curvature ratio near the separatrix
  !        has a local minimum-- indeed is zero if the surface passes directly
  !        through the separatrix.  Setting a limit on how small this minimum
  !        value can be, determines what surface inside the separatrix can
  !        be used as a boundary surface.
  !        ...various down stream codes which use the equilibrium can fail
  !        due to numerical metric singularities, if the chosen boundary 
  !        surface is too close.  Based on experience, the DEFAULT VALUE
  !        of c_ratio, 0.08, is recommended.  Use this argument to override
  !        the default.

  !  -rho_curbrk:<rho-value>  The values gives the flux location at which
  !        the enclosed toroidal current function I(rho) is transitioned
  !        from data based on Ampere's Law contour integrations over Psi(R,Z)
  !        to a parabolic interpolation to reach the edge value of total
  !        enclosed toroidal current.  This in effect smooths the edge
  !        current dI/drho and <J.B>.  <rho-value>, in normalized sqrt
  !        toroidal flux, is constrained to lie between 0.75 and 0.95.
  !        DEFAULT: 0.90.
  !
  !  -qcur ... select data source for q(psi) and the total enclosed
  !        toroidal current I(rho=1).  "EFIT" means: use q(psi) profile
  !        and the total toroidal current data provided with the EFIT
  !        data set; "PSI" means recompute q(psi) and I(1) from contour
  !        integrals over Psi(R,Z); "AUTO" (the default) means use the
  !        "EFIT" option if data label indicates that the source is a
  !        TRXPL (i.e. a TRANSP data time slice) otherwise use "PSI".
  !
  !  -pprime ... recompute Pressure profile by integrating PPRIME in
  !        from the pressure value at the boundary:  this reduces noise
  !        in the radial derivatives of P in the resulting state, but
  !        it requires the PPRIME profile in the EFIT data to be accurate.
  !
  !  -psmoo:<delta_rho> ... smoothing parameter for pressure profile
  !        Pressure data at rho is smoothed by a triangular weighted 
  !        average from rho - delta_rho to rho + delta_rho.  Default:
  !        no smoothing.  Allowed range of values: [0.0:0.2]
  !
  !  -psmoo_bdy:<delta_rho> ... smoothing parameter for pressure profile
  !        at the outer boundary (default: -psmoo <delta_rho> value).
  !        If neither -psmoo nor -psmoo_bdy are set, there is no smoothing;
  !        If only -psmoo is set, the pressure is smoothed with <delta_rho>
  !        constant over the entire profile; if only -psmoo_bdy is set,
  !        <delta_rho> varies linearly in rho from 0 to the -psmoo_bdy
  !        value; if both -psmoo and -psmoo_bdy are set, <delta_rho> varies
  !        linearly in rho from the -psmoo value at rho=0 to the -psmoo_bdy
  !        value at rho=1.  Allowed range of values: [0.0:0.2]
  !
  !  -new_state  ... forces creation of a new state containing ONLY the
  !        equilibrium data; if this is not specified, the program will
  !        try to read an existing state at <ps-path> and insert the
  !        equilibrium into it, while leaving all other data items
  !        unchanged.

  !  additional optional arguments for labeling/identification:
  !  (useful with -new_state option):

  !  -shot:<shot-number>
  !  -time:<time-in-seconds>
  !  -tok:<tokamak-ID>
 
  !--------------------------------------------------------------------------
  USE plasma_state_mod
  implicit NONE

  !-------------------------------------------

  integer :: iarg,nargs,ilen,icolon,idash,ifail,ierr,ilen_keywd
  integer :: nrho,nth,nshot,ihave_g,ihave_ps
  integer :: ilun,istat,init,iqcur
  logical :: imds,new_state,pprime_opt
  real*8 :: ztime_s,c_ratio,zt_default,rho_curbrk
  real*8 :: psmoo_axis,psmoo_bdy,rho_sm(2),delrho_sm(2)
  real*8, parameter :: ZERO = 0.0_rspec

  integer, parameter :: imax_args = 10
  character*250 gpath,pspath,args(imax_args)
  character*20 ztest,zvali,ztok,qcur_opt
  character*20 zvalr8

  !-------------------------------------------
  !  Part 1: parse command line arguments

  nrho=51
  nth=101

  nshot = -1
  zt_default = -1.2345e6_rspec
  ztime_s = zt_default
  c_ratio = 0.08_rspec
  ztok = '????'

  new_state=.FALSE.

  qcur_opt = "AUTO"
  rho_curbrk = 0.90_rspec

  pprime_opt = .FALSE.
  psmoo_axis = -1.0_rspec
  psmoo_bdy  = -1.0_rspec

  ihave_g = 0
  ihave_ps = 0
  gpath = ' '
  pspath = ' '
  imds = .FALSE.

  ierr = 0

  call get_arg_count(nargs)
  if(nargs.gt.imax_args) then
     ierr=1
     write(0,*) 'geq2ps: too many arguments (max: ',imax_args, &
          '; got: ',nargs,')'
     nargs=imax_args
  endif

  do iarg=1,nargs
     call get_arg(iarg,args(iarg))

     ilen = len(trim(args(iarg)))

     ifail=0
     do
        ! parse arguments

        idash = 0
        if(args(iarg)(1:1).eq.'-') idash=1

        if(idash.eq.1) then
           !  command qualifer -nth or -nrho

           icolon=index(args(iarg)(1:ilen),':')
           if(icolon.le.0) then
              ilen_keywd=ilen
           else
              ilen_keywd=icolon-1
           endif
           if((ilen_keywd.le.1).or.(ilen_keywd.gt.15)) then
              ifail=1
              exit
           else
              ztest=args(iarg)(1:ilen_keywd)
              call uupper(ztest)
              if(ztest.eq.'-NEW_STATE') then
                 new_state = .TRUE.

              else if(ztest.eq.'-NRHO') then
                 call getival(iarg,nrho)
                 ! (contained subroutine; ifail=3 means value parse fails)

              else if(ztest.eq.'-NTH') then
                 call getival(iarg,nth)
                 ! (contained subroutine; ifail=3 means value parse fails)

              else if(ztest.eq.'-SHOT') then
                 call getival(iarg,nshot)
                 ! (contained subroutine; ifail=3 means value parse fails)

              else if(ztest.eq.'-TOK') then
                 call getcval(iarg,ztok)

              else if(ztest.eq.'-TIME') then
                 call getr8val(iarg,ztime_s)

              else if(ztest.eq.'-C_RATIO') then
                 call getr8val(iarg,c_ratio)
                 if((c_ratio.lt.0.02_rspec).or.(c_ratio.gt.0.15_rspec)) then
                    ifail=3
                    write(0,*) '?geq2ps: c_ratio = ',c_ratio
                    write(0,*) ' exceeds range limits: 0.02 to 0.15'
                 endif

              else if(ztest.eq.'-RHO_CURBRK') then
                 call getr8val(iarg,rho_curbrk)
                 if(rho_curbrk.lt.0.75_rspec) then
                    write(6,*) '%geq2ps: rho_curbrk set to minimum value: 0.75'
                    rho_curbrk = 0.75_rspec
                 endif
                 if(rho_curbrk.gt.0.95_rspec) then
                    write(6,*) '%geq2ps: rho_curbrk set to minimum value: 0.95'
                    rho_curbrk = 0.95_rspec
                 endif

              else if(ztest.eq.'-QCUR') then
                 call getcval(iarg,qcur_opt)
                 call uupper(qcur_opt)
                 if((qcur_opt.ne.'AUTO').and. &
                      (qcur_opt.ne.'EFIT').and.(qcur_opt.ne.'PSI')) then
                    write(0,*) '?geq2ps: qcur value: "'//trim(qcur_opt)//'".'
                    write(0,*) ' not one of {"AUTO","EFIT","PSI"}.'
                    ifail=3
                 endif

              else if(ztest.eq.'-PPRIME') then
                 pprime_opt = .TRUE.

              else if(ztest.eq.'-PSMOO') then
                 call getr8val(iarg,psmoo_axis)
                 if((psmoo_axis.lt.0.0_rspec).or. &
                      (psmoo_axis.gt.0.201_rspec)) then
                    write(0,*) '?geq2ps: -PSMOO value not in range 0.0 to 0.2.'
                    ifail=3
                 else
                    psmoo_axis = max(0.0_rspec,min(0.2_rspec,psmoo_axis))
                 endif

              else if(ztest.eq.'-PSMOO_BDY') then
                 call getr8val(iarg,psmoo_bdy)
                 if((psmoo_bdy.lt.0.0_rspec).or. &
                      (psmoo_bdy.gt.0.201_rspec)) then
                    write(0,*) '?geq2ps: -PSMOO value not in range 0.0 to 0.2.'
                    ifail=3
                 else
                    psmoo_bdy = max(0.0_rspec,min(0.2_rspec,psmoo_bdy))
                 endif

              else
                 ifail=2  ! unrecognized qualifier
              endif
           endif
        else
           ! path argument

           if(ihave_g.eq.0) then
              gpath = args(iarg)
              ihave_g = iarg
              ztest = gpath(1:5)
              call uupper(ztest)
              if(ztest.eq.'MDS+:') imds = .TRUE.

           else if(ihave_ps.eq.0) then
              pspath = args(iarg)
              ihave_ps = iarg

           else
              ifail=4  ! too many path args
           endif

        endif

        exit
     enddo

     if(ifail.eq.1) then
        ierr = ierr + 1
        write(0,*) 'geq2ps: -qualifier argument syntax error: '// &
             trim(args(iarg))
     else if(ifail.eq.2) then
        ierr = ierr + 1
        write(0,*) 'geq2ps: -qualifier argument keyword unrecognized: '// &
             trim(args(iarg))
     else if(ifail.eq.3) then
        ierr = ierr + 1
        write(0,*) 'geq2ps: -qualifier argument value parse failed: '// &
             trim(args(iarg))
     else if(ifail.eq.4) then
        ierr = ierr + 1
        write(0,*) 'geq2ps:  too many file path arguments.'
     endif
  enddo

  if(ihave_g.eq.0) then
     ierr=ierr+1
     write(0,*) 'geq2ps:  missing G-eqdsk path argument.'
  endif

  if(ihave_ps.eq.0) then
     ierr=ierr+1
     write(0,*) 'geq2ps:  missing plasma state file path argument.'
  endif

  if(ierr.gt.0) then
     write(0,*) 'geq2ps syntax:'
     write(0,*) '  geq2ps  <g-file-path OR g-MDS+-path>  <plasma-state-path>\ '
     write(0,*) '          [-nrho:<# of radial surfaces>(51)] \ '
     write(0,*) '          [-nth:<# of poloidal grid pts>(101)] \ '
     write(0,*) '          [-c_ratio:<min. bdy curvature ratio>(0.08)] \ '
     write(0,*) ' '
     write(0,*) '          [-rho_curbrk:<rho-where-I(rho)-interpolation-starts>(0.90)] \ '
     write(0,*) '          [-qcur:<AUTO | EFIT | PSI>(default keyword: AUTO)] \ '
     write(0,*) ' '
     write(0,*) '          [-pprime] \ '
     write(0,*) '          [-psmoo:<delta_rho_on_axis>(0.0)] \ '
     write(0,*) '          [-psmoo_bdy:<delta_rho_at_bdy>(0.0)] \ '
     write(0,*) ' '
     write(0,*) '          [-new_state] \ '
     write(0,*) '          [-tok:<tokamak-ID-label>] \ '
     write(0,*) '          [-shot:<shot-number>] \ '
     write(0,*) '          [-time:<time-of-g-eqdsk-equilibrium>]'
     write(0,*) ' '
     write(0,*) '  NOTES:'
     write(0,*) '    Use "-c_ratio" to control boundary offset from separatrix.'
     write(0,*) ' '
     write(0,*) '    Plasma current & q profile treatment: -qcur option:'
     write(0,*) '      "EFIT" means, use EFIT profile q(psi) and scalar current at boundary);'
     write(0,*) '      "PSI" means, rederive q(psi) and total current from Psi(R,Z) data;'
     write(0,*) '      "AUTO" means, choose "EFIT" or "PSI" based on g-eqdsk header label.'
     write(0,*) '    -rho_curbrk specifies where to stop using Psi(R,Z) contour integral'
     write(0,*) '      and commence interpolation to smoothly match enclosed current at bdy.'
     write(0,*) ' '
     write(0,*) '    Pressure profile treatment:'
     write(0,*) '    Use -pprime to reduce dP/drho noise, when the g-eqdsk'
     write(0,*) '      file is known to have good PPRIME(Psi) data.'
     write(0,*) '    Use -psmoo and -psmoo_bdy to request explicit smoothing'
     write(0,*) '      of Pressure profile.  The smoothing at location (rho)'
     write(0,*) '      is a triangular weighted average from rho-<delta_rho>'
     write(0,*) '      to rho+<delta_rho>, where <delta_rho> is linearly interpolated in rho'
     write(0,*) '      between <delta_rho_on_axis> at rho=0 and <delta_rho_at_bdy> at rho=1;'
     write(0,*) '      Defaults: <delta_rho_on_axis> is zero (no smoothing);'
     write(0,*) '                <delta_rho_at_bdy> = <delta_rho_on_axis>.'
     write(0,*) ' '
     write(0,*) '    the 2 path arguments are required; all qualifiers are'
     write(0,*) '    optional; argument default values shown in parentheses;'
     write(0,*) ' '
     write(0,*) '    If there is no file at <plasma-state-path>, -new_state is put into effect.'
     write(0,*) '    -tok, -shot & -time are used to label the -new_state output'
     write(0,*) '    plasma state file; defaults are "????", -1, and -1.2345e6;'
     write(0,*) '    so it is preferable to provide labeling when -new_state is in effect.'
     call exit(ierr)
  else
     if(imds) then
        call gshot(gpath,nshot,ztime_s)
     endif

     if(.not.new_state) then
        call find_io_unit(ilun)
        open(unit=ilun,file=trim(pspath),status='old',action='read', &
             iostat=istat)
        if(istat.ne.0) then
           write(6,*) ' '
           write(6,*) ' file not found: '//trim(pspath)
           write(6,*) ' OK -- new state will be created.'
           write(6,*) ' '
           new_state=.TRUE.
        else
           close(unit=ilun)
        endif
     endif

     psmoo_axis=max(ZERO,psmoo_axis)
     if(psmoo_bdy.lt.ZERO) psmoo_bdy=psmoo_axis

     write(6,*) ' geq2ps syntax OK:'
     write(6,*) '  g-path:  ',trim(gpath)
     write(6,*) ' ps-path:  ',trim(pspath)
     write(6,*) ' new_state: ',new_state
     write(6,*) ' '
     write(6,*) '    nrho: ',nrho
     write(6,*) '     nth: ',nth
     write(6,'(a,1pe12.5)') '  c-ratio: ',c_ratio
     write(6,*) ' '
     write(6,*) '    qcur:  ',trim(qcur_opt)
     write(6,'(a,1pe12.5)') '  rho_curbrk: ',rho_curbrk
     write(6,*) ' '
     write(6,*) ' Pprime option: ',pprime_opt
     write(6,'(a,1pe12.5)') '  Psmoo <delta_rho_on_axis>: ',psmoo_axis
     write(6,'(a,1pe12.5)') '  Psmoo <delta_rho_at_bdy>:  ',psmoo_bdy
     write(6,*) ' '
     if(ztok.ne.'????') write(6,*) '     tok:  ',trim(ztok)
     if(nshot.ne.-1) write(6,*) '    shot: ',nshot
     if(ztime_s.ne.zt_default) write(6,'(a,1pe12.5)') '  time(s): ',ztime_s

     write(6,*) ' '
  endif

  !-------------------------------------------
  !  Part 1A: read old state if necessary

  if(.not.new_state) then
     write(6,*) '...reading: '//trim(pspath)
     call ps_get_plasma_state(ierr, filename=trim(pspath), state=psp)
     if(ierr.ne.0) then
        write(6,*) '?geq2ps: failed to read pre-existing plasma state.'
        call exit(ierr)
     endif

     !  copy dimensions

     init=1
     call ps_copy_dims(psp, ps, init, ierr)
     if(ierr.ne.0) then
        write(6,*) '?geq2ps: failed to copy dimensions of pre-existing plasma state.'
        call exit(ierr)
     endif

     !  zero some dimensions -- values may be changed when G-eqdsk data
     !  is processed, below

     ps%nR = 0
     ps%nZ = 0

     ps%nrho_eq = 0
     ps%nth_eq = 0
     ps%nrho_eq_geo = 0

     ps%npsmom = 0
     ps%num_rzlim = 0

     call ps_alloc_plasma_state(ierr)  ! alloc ps accordingly
     if(ierr.ne.0) then
        write(6,*) ' ?geq2ps: failed to allocate new state.'
        call exit(ierr)
     endif

     !  dimensions are set, now copy the data (not the dimensions):
     call ps_copy_plasma_state(psp, ps, ierr, inodims=1)
     if(ierr.ne.0) then
        write(6,*) ' ?geq2ps: failed to copy data into new state.'
        call exit(ierr)
     endif
  endif

  !-------------------------------------------
  !  Part 2: execute

  !  set grid resolutions
  ps%nrho_eq = nrho
  ps%nth_eq = nth

  !  these grids will be set from the G-eqdsk data itself
  ps%nR = 0
  ps%nZ = 0

  !  provide available labeling and identifying information

  if(new_state) then
     ps%Global_Label = 'Plasma state derived from G-eqdsk: '//trim(gpath)
     ps%RunID = 'geq2ps'
  endif

  if(new_state.or.(ztok.ne.'????')) then
     ps%Tokamak_ID = trim(ztok)
  endif

  if(new_state.or.(nshot.ne.-1)) then
     ps%Shot_Number = nshot
  endif

  if(new_state.or.(ztime_s.ne.-1.2345e6_rspec)) then
     ps%t0 = ztime_s
     ps%t1 = ztime_s
  endif

  !--------------------
  !  get the equilibrium from the indicated path; use requested or defaulted
  !  curvature ratio parameter to control the boundary selection

  if(qcur_opt.eq.'AUTO') iqcur = -1
  if(qcur_opt.eq.'EFIT') iqcur = 0
  if(qcur_opt.eq.'PSI')  iqcur = 1

  rho_sm(1)=0
  rho_sm(2)=1
  delrho_sm(1)=psmoo_axis
  delrho_sm(2)=psmoo_bdy

  CALL ps_update_equilibrium(ierr, g_filepath=gpath, bdy_crat=c_ratio, &
       kcur_option=iqcur, rho_curbrk=rho_curbrk, &
       pprime_option = pprime_opt, rho_psmoo=rho_sm, delrho_psmoo=delrho_sm)
  call ckerr('ps_update_equilibrium')

  !--------------------
  !  supplement equilibrium with computation of flux surface averages and
  !  NCLASS moments

  ps%nrho_eq_geo = ps%nrho_eq
  CALL ps_alloc_plasma_state(ierr)
  call ckerr('ps_alloc_plasma_state')

  ps%rho_eq_geo = ps%rho_eq  ! use same grid
  call ps_mhdeq_derive('Everything',ierr)
  call ckerr('ps_mhdeq_derive')

  !--------------------
  !  store the result to the indicated path

  call ps_store_plasma_state(ierr, filename=trim(pspath))
  call ckerr('ps_store_plasma_state')

  !--------------------
  !  all done.
  !--------------------

  write(6,*) ' '
  write(6,*) ' %geq2ps: normal exit.'
  write(6,*) ' '

  !--------------------------------------------
CONTAINS
  !--------------------------------------------
  !  error handling routine

  subroutine ckerr(sbrtn)

    character*(*), intent(in) :: sbrtn

    if(ierr.ne.0) then
       write(0,*) ' ?geq2ps: unexpected error in subroutine '//trim(sbrtn)//'.'
       call exit(ierr)
    endif

  end subroutine ckerr
  !--------------------------------------------
  !  parse subroutines

  subroutine getival(iarg,ival)

    !  get integer value
    !    args(iarg); icolon specifies colon location

    integer, intent(in) :: iarg
    integer, intent(inout) :: ival  ! unchanged if argument value is omitted

    integer :: ilenv,istat

    if((icolon.le.0).or.(icolon.eq.ilen)) then
       ! accept current value
       return
    endif

    ilenv = ilen-icolon
    if(ilenv.gt.10) then
       ifail=3  ! value field too long
       return
    endif

    zvali=' '
    zvali(10-ilenv+1:10)=args(iarg)(icolon+1:ilen)
    read(zvali,'(I10)',iostat=istat) ival

    if(istat.ne.0) then
       ifail=3
       ival=0
    endif
  end subroutine getival

  subroutine getcval(iarg,cval)

    !  get character string value
    !    args(iarg); icolon specifies colon location

    integer, intent(in) :: iarg
    character*(*), intent(inout) :: cval

    integer :: ilenv,ilen_cval,istat

    ilen_cval=len(cval)

    if((icolon.le.0).or.(icolon.eq.ilen)) then
       ! accept current value
       return
    endif

    ilenv = ilen-icolon
    if(ilenv.gt.ilen_cval) then
       ifail=3  ! value field too long
       return
    endif

    cval=args(iarg)(icolon+1:ilen)

  end subroutine getcval

  subroutine getr8val(iarg,r8val)

    !  get integer value
    !    args(iarg); icolon specifies colon location

    integer, intent(in) :: iarg
    real*8, intent(inout) :: r8val  ! unchanged if argument value is omitted

    integer :: ilenv,istat

    if((icolon.le.0).or.(icolon.eq.ilen)) then
       ! accept current value
       return
    endif

    ilenv = ilen-icolon
    if(ilenv.gt.20) then
       ifail=3  ! value field too long
       return
    endif

    zvalr8=' '
    zvalr8(20-ilenv+1:20)=args(iarg)(icolon+1:ilen)
    read(zvalr8,'(G20.0)',iostat=istat) r8val

    if(istat.ne.0) then
       ifail=3
       r8val=0
    endif
  end subroutine getr8val

  subroutine gshot(gpath,nshot,ztime)

    ! Attempt to parse shot number and time-of-interest from MDS+ path
    ! specification.  If error occurs, silently leave nshot and ztime
    ! unchanged.

    character*(*), intent(in) :: gpath
    integer, intent(inout) :: nshot    ! may be left unchanged
    real*8, intent(inout) :: ztime     ! may be left unchanged

    !---------------------------------

    integer :: ishot
    real*8 :: ztimi

    integer :: iparen1,iparen2,ilwk,ils,ilt,isemi,istat
    character*80 zwk

    !---------------------------------
    !  find parentheses
    !    gpath of form MDS+:<server>:<tree>(<shot-number>;t=<time-of-interest>)
    !    expected.

    iparen1=index(gpath,'(')
    if(iparen1.le.0) return

    iparen2=index(gpath,')')
    if(iparen2.le.0) return

    ilwk = iparen2-iparen1-1  ! #characters btw parentheses

    if(ilwk.le.5) return      ! if too few

    zwk = gpath(iparen1+1:iparen2-1)

    !---------------------------------
    !  zwk now expected to contain <shot-number>;t=<time-of-interest>

    isemi=index(zwk,';')

    ils=isemi-1               ! length of shot number field
    ilt=ilwk-isemi-1          ! length of time field

    if(ils.le.0) return
    if(ils.gt.len(zvali)) return

    !---------------------------------
    !  shot number field has been found & length is OK

    zvali=' '
    zvali(10-ils+1:10)=zwk(1:ils)
    read(zvali,'(I10)',iostat=istat) ishot
    if(istat.ne.0) return

    ! OK -- successfully parsed the shot number

    nshot = ishot
    write(6,*) ' %geq2ps: shot number from MDS+ path: ',nshot

    !---------------------------------
    !  parse out time of interest

    if(ilt.le.0) return
    if(ilt.gt.len(zvalr8)) return

    zvalr8=' '
    zvalr8(20-ilt+1:20)=zwk(isemi+1:ilwk)
    read(zvalr8,'(G20.0)',iostat=istat) ztimi
    if(istat.ne.0) return

    ! OK -- successfully parsed the shot number

    ztime = ztimi
    write(6,'(a,1pe11.5)') ' %geq2ps: time of interest from MDS+ path: ',ztime

  end subroutine gshot

end program geq2ps

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


SUBROUTINE plasma_state_merge_7(cclist,w1,ss1,ss2,ss3,icheck,iout,ierr)


  ! Merge floating point data
  !   ss3 <-- w1*ss1 + (1-w1)*ss2

  USE plasma_state_definition_mod
  IMPLICIT NONE

  INTEGER, INTENT(IN) :: cclist(ps_ccount)
                                ! list of components to merge
                                ! use ps_cc_all to merge all components

  REAL(KIND=rspec) :: w1        ! weight on ss1
  TYPE (plasma_state) :: ss1    ! state data to copy *from* with weight (w1)
  TYPE (plasma_state) :: ss2    ! state data to copy *from* with weight (1-w1)
  TYPE (plasma_state) :: ss3    ! state to which data is copied.
  INTEGER, INTENT(IN) :: icheck ! control for checking match of non-floating-
  !  point data: ps_ignore, ps_warn, or ps_error on mismatch.

  INTEGER, INTENT(IN) :: iout
  INTEGER, INTENT(INOUT) :: ierr  ! completion code (not cleared,set on error)

  !-------------------
  INTEGER :: isize
  !-------------------

  !-----------------------------------------------
  ! copy scalars and arrays that are allocated...

  IF((ALLOCATED(ss3%Rloc_coil)).AND.(cclist(ps_cnum_EQ).EQ.1)) THEN
     IF(ALLOCATED(ss1%Rloc_coil).AND.ALLOCATED(ss2%Rloc_coil)) THEN
        CALL ps_diff("Rloc_coil",ss1%Rloc_coil,ss2%Rloc_coil,icheck,iout,ierr)
        CALL ps_conformal("Rloc_coil",ss1%Rloc_coil,ss3%Rloc_coil,iout,ierr)
        if(ierr.eq.0) ss3%Rloc_coil = ss1%Rloc_coil
     ELSE IF(ALLOCATED(ss1%Rloc_coil)) THEN
        CALL ps_conformal("Rloc_coil",ss1%Rloc_coil,ss3%Rloc_coil,iout,ierr)
        ss3%Rloc_coil = ss1%Rloc_coil
     ELSE IF(ALLOCATED(ss2%Rloc_coil)) THEN
        CALL ps_conformal("Rloc_coil",ss2%Rloc_coil,ss3%Rloc_coil,iout,ierr)
        ss3%Rloc_coil = ss2%Rloc_coil
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%Rmajor_mean)).AND.(cclist(ps_cnum_EQ).EQ.1)) THEN
     IF(ALLOCATED(ss1%Rmajor_mean).AND.ALLOCATED(ss2%Rmajor_mean)) THEN
        CALL ps_conformal("Rmajor_mean",ss2%Rmajor_mean,ss3%Rmajor_mean,iout,ierr)
        CALL ps_conformal("Rmajor_mean",ss1%Rmajor_mean,ss3%Rmajor_mean,iout,ierr)
        if(ierr.eq.0) ss3%Rmajor_mean = w1*ss1%Rmajor_mean + (1.0_rspec-w1)*ss2%Rmajor_mean
     ELSE IF(ALLOCATED(ss1%Rmajor_mean)) THEN
        CALL ps_conformal("Rmajor_mean",ss1%Rmajor_mean,ss3%Rmajor_mean,iout,ierr)
        ss3%Rmajor_mean = ss1%Rmajor_mean
     ELSE IF(ALLOCATED(ss2%Rmajor_mean)) THEN
        CALL ps_conformal("Rmajor_mean",ss2%Rmajor_mean,ss3%Rmajor_mean,iout,ierr)
        ss3%Rmajor_mean = ss2%Rmajor_mean
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%rMinor_mean)).AND.(cclist(ps_cnum_EQ).EQ.1)) THEN
     IF(ALLOCATED(ss1%rMinor_mean).AND.ALLOCATED(ss2%rMinor_mean)) THEN
        CALL ps_conformal("rMinor_mean",ss2%rMinor_mean,ss3%rMinor_mean,iout,ierr)
        CALL ps_conformal("rMinor_mean",ss1%rMinor_mean,ss3%rMinor_mean,iout,ierr)
        if(ierr.eq.0) ss3%rMinor_mean = w1*ss1%rMinor_mean + (1.0_rspec-w1)*ss2%rMinor_mean
     ELSE IF(ALLOCATED(ss1%rMinor_mean)) THEN
        CALL ps_conformal("rMinor_mean",ss1%rMinor_mean,ss3%rMinor_mean,iout,ierr)
        ss3%rMinor_mean = ss1%rMinor_mean
     ELSE IF(ALLOCATED(ss2%rMinor_mean)) THEN
        CALL ps_conformal("rMinor_mean",ss2%rMinor_mean,ss3%rMinor_mean,iout,ierr)
        ss3%rMinor_mean = ss2%rMinor_mean
     ENDIF
  ENDIF

  IF(cclist(ps_cnum_RUNAWAY).EQ.1) THEN

     CALL ps_diff("RUNAWAY_Code_Info",ss1%RUNAWAY_Code_Info,ss2%RUNAWAY_Code_Info,icheck,iout,ierr)
     ss3%RUNAWAY_Code_Info = ss1%RUNAWAY_Code_Info
  ENDIF

  IF(cclist(ps_cnum_PLASMA).EQ.1) THEN

     CALL ps_diff("RunID",ss1%RunID,ss2%RunID,icheck,iout,ierr)
     ss3%RunID = ss1%RunID
  ENDIF

  IF((ALLOCATED(ss3%R_ant)).AND.(cclist(ps_cnum_IC).EQ.1)) THEN
     IF(ALLOCATED(ss1%R_ant).AND.ALLOCATED(ss2%R_ant)) THEN
        CALL ps_diff("R_ant",ss1%R_ant,ss2%R_ant,icheck,iout,ierr)
        CALL ps_conformal("R_ant",ss1%R_ant,ss3%R_ant,iout,ierr)
        if(ierr.eq.0) ss3%R_ant = ss1%R_ant
     ELSE IF(ALLOCATED(ss1%R_ant)) THEN
        CALL ps_conformal("R_ant",ss1%R_ant,ss3%R_ant,iout,ierr)
        ss3%R_ant = ss1%R_ant
     ELSE IF(ALLOCATED(ss2%R_ant)) THEN
        CALL ps_conformal("R_ant",ss2%R_ant,ss3%R_ant,iout,ierr)
        ss3%R_ant = ss2%R_ant
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%R_antgeo)).AND.(cclist(ps_cnum_IC).EQ.1)) THEN
     IF(ALLOCATED(ss1%R_antgeo).AND.ALLOCATED(ss2%R_antgeo)) THEN
        CALL ps_diff("R_antgeo",ss1%R_antgeo,ss2%R_antgeo,icheck,iout,ierr)
        CALL ps_conformal("R_antgeo",ss1%R_antgeo,ss3%R_antgeo,iout,ierr)
        if(ierr.eq.0) ss3%R_antgeo = ss1%R_antgeo
     ELSE IF(ALLOCATED(ss1%R_antgeo)) THEN
        CALL ps_conformal("R_antgeo",ss1%R_antgeo,ss3%R_antgeo,iout,ierr)
        ss3%R_antgeo = ss1%R_antgeo
     ELSE IF(ALLOCATED(ss2%R_antgeo)) THEN
        CALL ps_conformal("R_antgeo",ss2%R_antgeo,ss3%R_antgeo,iout,ierr)
        ss3%R_antgeo = ss2%R_antgeo
     ENDIF
  ENDIF

  IF(cclist(ps_cnum_EQ).EQ.1) THEN
     ss3%R_axis = w1*ss1%R_axis + (1.0_rspec-w1)*ss2%R_axis
  ENDIF

  IF((ALLOCATED(ss3%R_EC_launch)).AND.(cclist(ps_cnum_EC).EQ.1)) THEN
     IF(ALLOCATED(ss1%R_EC_launch).AND.ALLOCATED(ss2%R_EC_launch)) THEN
        CALL ps_diff("R_EC_launch",ss1%R_EC_launch,ss2%R_EC_launch,icheck,iout,ierr)
        CALL ps_conformal("R_EC_launch",ss1%R_EC_launch,ss3%R_EC_launch,iout,ierr)
        if(ierr.eq.0) ss3%R_EC_launch = ss1%R_EC_launch
     ELSE IF(ALLOCATED(ss1%R_EC_launch)) THEN
        CALL ps_conformal("R_EC_launch",ss1%R_EC_launch,ss3%R_EC_launch,iout,ierr)
        ss3%R_EC_launch = ss1%R_EC_launch
     ELSE IF(ALLOCATED(ss2%R_EC_launch)) THEN
        CALL ps_conformal("R_EC_launch",ss2%R_EC_launch,ss3%R_EC_launch,iout,ierr)
        ss3%R_EC_launch = ss2%R_EC_launch
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%R_geo)).AND.(cclist(ps_cnum_EQ).EQ.1)) THEN
     IF(ALLOCATED(ss1%R_geo).AND.ALLOCATED(ss2%R_geo)) THEN
        CALL ps_conformal("R_geo",ss2%R_geo,ss3%R_geo,iout,ierr)
        CALL ps_conformal("R_geo",ss1%R_geo,ss3%R_geo,iout,ierr)
        if(ierr.eq.0) ss3%R_geo = w1*ss1%R_geo + (1.0_rspec-w1)*ss2%R_geo
     ELSE IF(ALLOCATED(ss1%R_geo)) THEN
        CALL ps_conformal("R_geo",ss1%R_geo,ss3%R_geo,iout,ierr)
        ss3%R_geo = ss1%R_geo
     ELSE IF(ALLOCATED(ss2%R_geo)) THEN
        CALL ps_conformal("R_geo",ss2%R_geo,ss3%R_geo,iout,ierr)
        ss3%R_geo = ss2%R_geo
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%R_grid)).AND.(cclist(ps_cnum_EQ).EQ.1)) THEN
     IF(ALLOCATED(ss1%R_grid).AND.ALLOCATED(ss2%R_grid)) THEN
        CALL ps_diff("R_grid",ss1%R_grid,ss2%R_grid,ps_error,iout,ierr)
        CALL ps_conformal("R_grid",ss1%R_grid,ss3%R_grid,iout,ierr)
        if(ierr.eq.0) ss3%R_grid = ss1%R_grid
     ELSE IF(ALLOCATED(ss1%R_grid)) THEN
        CALL ps_conformal("R_grid",ss1%R_grid,ss3%R_grid,iout,ierr)
        ss3%R_grid = ss1%R_grid
     ELSE IF(ALLOCATED(ss2%R_grid)) THEN
        CALL ps_conformal("R_grid",ss2%R_grid,ss3%R_grid,iout,ierr)
        ss3%R_grid = ss2%R_grid
     ENDIF
  ENDIF

  IF(cclist(ps_cnum_EQ).EQ.1) THEN

     CALL ps_diff("R_max_box",ss1%R_max_box,ss2%R_max_box,icheck,iout,ierr)
     ss3%R_max_box = ss1%R_max_box
  ENDIF

  IF(cclist(ps_cnum_EQ).EQ.1) THEN
     ss3%R_max_lcfs = w1*ss1%R_max_lcfs + (1.0_rspec-w1)*ss2%R_max_lcfs
  ENDIF

  IF((ALLOCATED(ss3%R_midp_in)).AND.(cclist(ps_cnum_EQ).EQ.1)) THEN
     IF(ALLOCATED(ss1%R_midp_in).AND.ALLOCATED(ss2%R_midp_in)) THEN
        CALL ps_conformal("R_midp_in",ss2%R_midp_in,ss3%R_midp_in,iout,ierr)
        CALL ps_conformal("R_midp_in",ss1%R_midp_in,ss3%R_midp_in,iout,ierr)
        if(ierr.eq.0) ss3%R_midp_in = w1*ss1%R_midp_in + (1.0_rspec-w1)*ss2%R_midp_in
     ELSE IF(ALLOCATED(ss1%R_midp_in)) THEN
        CALL ps_conformal("R_midp_in",ss1%R_midp_in,ss3%R_midp_in,iout,ierr)
        ss3%R_midp_in = ss1%R_midp_in
     ELSE IF(ALLOCATED(ss2%R_midp_in)) THEN
        CALL ps_conformal("R_midp_in",ss2%R_midp_in,ss3%R_midp_in,iout,ierr)
        ss3%R_midp_in = ss2%R_midp_in
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%R_midp_out)).AND.(cclist(ps_cnum_EQ).EQ.1)) THEN
     IF(ALLOCATED(ss1%R_midp_out).AND.ALLOCATED(ss2%R_midp_out)) THEN
        CALL ps_conformal("R_midp_out",ss2%R_midp_out,ss3%R_midp_out,iout,ierr)
        CALL ps_conformal("R_midp_out",ss1%R_midp_out,ss3%R_midp_out,iout,ierr)
        if(ierr.eq.0) ss3%R_midp_out = w1*ss1%R_midp_out + (1.0_rspec-w1)*ss2%R_midp_out
     ELSE IF(ALLOCATED(ss1%R_midp_out)) THEN
        CALL ps_conformal("R_midp_out",ss1%R_midp_out,ss3%R_midp_out,iout,ierr)
        ss3%R_midp_out = ss1%R_midp_out
     ELSE IF(ALLOCATED(ss2%R_midp_out)) THEN
        CALL ps_conformal("R_midp_out",ss2%R_midp_out,ss3%R_midp_out,iout,ierr)
        ss3%R_midp_out = ss2%R_midp_out
     ENDIF
  ENDIF

  IF(cclist(ps_cnum_EQ).EQ.1) THEN

     CALL ps_diff("R_min_box",ss1%R_min_box,ss2%R_min_box,icheck,iout,ierr)
     ss3%R_min_box = ss1%R_min_box
  ENDIF

  IF(cclist(ps_cnum_EQ).EQ.1) THEN
     ss3%R_min_lcfs = w1*ss1%R_min_lcfs + (1.0_rspec-w1)*ss2%R_min_lcfs
  ENDIF

  IF((ALLOCATED(ss3%R_ripple)).AND.(cclist(ps_cnum_RIPPLE).EQ.1)) THEN
     IF(ALLOCATED(ss1%R_ripple).AND.ALLOCATED(ss2%R_ripple)) THEN
        CALL ps_diff("R_ripple",ss1%R_ripple,ss2%R_ripple,ps_error,iout,ierr)
        CALL ps_conformal("R_ripple",ss1%R_ripple,ss3%R_ripple,iout,ierr)
        if(ierr.eq.0) ss3%R_ripple = ss1%R_ripple
     ELSE IF(ALLOCATED(ss1%R_ripple)) THEN
        CALL ps_conformal("R_ripple",ss1%R_ripple,ss3%R_ripple,iout,ierr)
        ss3%R_ripple = ss1%R_ripple
     ELSE IF(ALLOCATED(ss2%R_ripple)) THEN
        CALL ps_conformal("R_ripple",ss2%R_ripple,ss3%R_ripple,iout,ierr)
        ss3%R_ripple = ss2%R_ripple
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%R_surfMax)).AND.(cclist(ps_cnum_EQ).EQ.1)) THEN
     IF(ALLOCATED(ss1%R_surfMax).AND.ALLOCATED(ss2%R_surfMax)) THEN
        CALL ps_conformal("R_surfMax",ss2%R_surfMax,ss3%R_surfMax,iout,ierr)
        CALL ps_conformal("R_surfMax",ss1%R_surfMax,ss3%R_surfMax,iout,ierr)
        if(ierr.eq.0) ss3%R_surfMax = w1*ss1%R_surfMax + (1.0_rspec-w1)*ss2%R_surfMax
     ELSE IF(ALLOCATED(ss1%R_surfMax)) THEN
        CALL ps_conformal("R_surfMax",ss1%R_surfMax,ss3%R_surfMax,iout,ierr)
        ss3%R_surfMax = ss1%R_surfMax
     ELSE IF(ALLOCATED(ss2%R_surfMax)) THEN
        CALL ps_conformal("R_surfMax",ss2%R_surfMax,ss3%R_surfMax,iout,ierr)
        ss3%R_surfMax = ss2%R_surfMax
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%R_surfMin)).AND.(cclist(ps_cnum_EQ).EQ.1)) THEN
     IF(ALLOCATED(ss1%R_surfMin).AND.ALLOCATED(ss2%R_surfMin)) THEN
        CALL ps_conformal("R_surfMin",ss2%R_surfMin,ss3%R_surfMin,iout,ierr)
        CALL ps_conformal("R_surfMin",ss1%R_surfMin,ss3%R_surfMin,iout,ierr)
        if(ierr.eq.0) ss3%R_surfMin = w1*ss1%R_surfMin + (1.0_rspec-w1)*ss2%R_surfMin
     ELSE IF(ALLOCATED(ss1%R_surfMin)) THEN
        CALL ps_conformal("R_surfMin",ss1%R_surfMin,ss3%R_surfMin,iout,ierr)
        ss3%R_surfMin = ss1%R_surfMin
     ELSE IF(ALLOCATED(ss2%R_surfMin)) THEN
        CALL ps_conformal("R_surfMin",ss2%R_surfMin,ss3%R_surfMin,iout,ierr)
        ss3%R_surfMin = ss2%R_surfMin
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%s0reco)).AND.(cclist(ps_cnum_GAS).EQ.1)) THEN
     IF(ALLOCATED(ss1%s0reco).AND.ALLOCATED(ss2%s0reco)) THEN
        CALL ps_conformal("s0reco",ss2%s0reco,ss3%s0reco,iout,ierr)
        CALL ps_conformal("s0reco",ss1%s0reco,ss3%s0reco,iout,ierr)
        if(ierr.eq.0) ss3%s0reco = w1*ss1%s0reco + (1.0_rspec-w1)*ss2%s0reco
     ELSE IF(ALLOCATED(ss1%s0reco)) THEN
        CALL ps_conformal("s0reco",ss1%s0reco,ss3%s0reco,iout,ierr)
        ss3%s0reco = ss1%s0reco
     ELSE IF(ALLOCATED(ss2%s0reco)) THEN
        CALL ps_conformal("s0reco",ss2%s0reco,ss3%s0reco,iout,ierr)
        ss3%s0reco = ss2%s0reco
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%s0reco_e)).AND.(cclist(ps_cnum_GAS).EQ.1)) THEN
     IF(ALLOCATED(ss1%s0reco_e).AND.ALLOCATED(ss2%s0reco_e)) THEN
        CALL ps_conformal("s0reco_e",ss2%s0reco_e,ss3%s0reco_e,iout,ierr)
        CALL ps_conformal("s0reco_e",ss1%s0reco_e,ss3%s0reco_e,iout,ierr)
        if(ierr.eq.0) ss3%s0reco_e = w1*ss1%s0reco_e + (1.0_rspec-w1)*ss2%s0reco_e
     ELSE IF(ALLOCATED(ss1%s0reco_e)) THEN
        CALL ps_conformal("s0reco_e",ss1%s0reco_e,ss3%s0reco_e,iout,ierr)
        ss3%s0reco_e = ss1%s0reco_e
     ELSE IF(ALLOCATED(ss2%s0reco_e)) THEN
        CALL ps_conformal("s0reco_e",ss2%s0reco_e,ss3%s0reco_e,iout,ierr)
        ss3%s0reco_e = ss2%s0reco_e
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%s0reco_recap)).AND.(cclist(ps_cnum_GAS).EQ.1)) THEN
     IF(ALLOCATED(ss1%s0reco_recap).AND.ALLOCATED(ss2%s0reco_recap)) THEN
        CALL ps_conformal("s0reco_recap",ss2%s0reco_recap,ss3%s0reco_recap,iout,ierr)
        CALL ps_conformal("s0reco_recap",ss1%s0reco_recap,ss3%s0reco_recap,iout,ierr)
        if(ierr.eq.0) ss3%s0reco_recap = w1*ss1%s0reco_recap + (1.0_rspec-w1)*ss2%s0reco_recap
     ELSE IF(ALLOCATED(ss1%s0reco_recap)) THEN
        CALL ps_conformal("s0reco_recap",ss1%s0reco_recap,ss3%s0reco_recap,iout,ierr)
        ss3%s0reco_recap = ss1%s0reco_recap
     ELSE IF(ALLOCATED(ss2%s0reco_recap)) THEN
        CALL ps_conformal("s0reco_recap",ss2%s0reco_recap,ss3%s0reco_recap,iout,ierr)
        ss3%s0reco_recap = ss2%s0reco_recap
     ENDIF
  ENDIF

  IF(ALLOCATED(ss3%sa_index)) THEN
     IF(ALLOCATED(ss1%sa_index).AND.ALLOCATED(ss2%sa_index)) THEN
        CALL ps_diff("sa_index",ss1%sa_index,ss2%sa_index,ps_error,iout,ierr)
        CALL ps_conformal("sa_index",ss1%sa_index,ss3%sa_index,iout,ierr)
        if(ierr.eq.0) ss3%sa_index = ss1%sa_index
     ELSE IF(ALLOCATED(ss1%sa_index)) THEN
        CALL ps_conformal("sa_index",ss1%sa_index,ss3%sa_index,iout,ierr)
        ss3%sa_index = ss1%sa_index
     ELSE IF(ALLOCATED(ss2%sa_index)) THEN
        CALL ps_conformal("sa_index",ss2%sa_index,ss3%sa_index,iout,ierr)
        ss3%sa_index = ss2%sa_index
     ENDIF
  ENDIF

  IF(ALLOCATED(ss3%SA_name)) THEN
     IF(ALLOCATED(ss1%SA_name).AND.ALLOCATED(ss2%SA_name)) THEN
        CALL ps_diff("SA_name",ss1%SA_name,ss2%SA_name,ps_error,iout,ierr)
        CALL ps_conformal("SA_name",ss1%SA_name,ss3%SA_name,iout,ierr)
        if(ierr.eq.0) ss3%SA_name = ss1%SA_name
     ELSE IF(ALLOCATED(ss1%SA_name)) THEN
        CALL ps_conformal("SA_name",ss1%SA_name,ss3%SA_name,iout,ierr)
        ss3%SA_name = ss1%SA_name
     ELSE IF(ALLOCATED(ss2%SA_name)) THEN
        CALL ps_conformal("SA_name",ss2%SA_name,ss3%SA_name,iout,ierr)
        ss3%SA_name = ss2%SA_name
     ENDIF
  ENDIF

  IF(ALLOCATED(ss3%SA_type)) THEN
     IF(ALLOCATED(ss1%SA_type).AND.ALLOCATED(ss2%SA_type)) THEN
        CALL ps_diff("SA_type",ss1%SA_type,ss2%SA_type,ps_error,iout,ierr)
        CALL ps_conformal("SA_type",ss1%SA_type,ss3%SA_type,iout,ierr)
        if(ierr.eq.0) ss3%SA_type = ss1%SA_type
     ELSE IF(ALLOCATED(ss1%SA_type)) THEN
        CALL ps_conformal("SA_type",ss1%SA_type,ss3%SA_type,iout,ierr)
        ss3%SA_type = ss1%SA_type
     ELSE IF(ALLOCATED(ss2%SA_type)) THEN
        CALL ps_conformal("SA_type",ss2%SA_type,ss3%SA_type,iout,ierr)
        ss3%SA_type = ss2%SA_type
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%sb0halo)).AND.(cclist(ps_cnum_NBI).EQ.1)) THEN
     IF(ALLOCATED(ss1%sb0halo).AND.ALLOCATED(ss2%sb0halo)) THEN
        CALL ps_conformal("sb0halo",ss2%sb0halo,ss3%sb0halo,iout,ierr)
        CALL ps_conformal("sb0halo",ss1%sb0halo,ss3%sb0halo,iout,ierr)
        if(ierr.eq.0) ss3%sb0halo = w1*ss1%sb0halo + (1.0_rspec-w1)*ss2%sb0halo
     ELSE IF(ALLOCATED(ss1%sb0halo)) THEN
        CALL ps_conformal("sb0halo",ss1%sb0halo,ss3%sb0halo,iout,ierr)
        ss3%sb0halo = ss1%sb0halo
     ELSE IF(ALLOCATED(ss2%sb0halo)) THEN
        CALL ps_conformal("sb0halo",ss2%sb0halo,ss3%sb0halo,iout,ierr)
        ss3%sb0halo = ss2%sb0halo
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%sb0halo_recap)).AND.(cclist(ps_cnum_NBI).EQ.1)) THEN
     IF(ALLOCATED(ss1%sb0halo_recap).AND.ALLOCATED(ss2%sb0halo_recap)) THEN
        CALL ps_conformal("sb0halo_recap",ss2%sb0halo_recap,ss3%sb0halo_recap,iout,ierr)
        CALL ps_conformal("sb0halo_recap",ss1%sb0halo_recap,ss3%sb0halo_recap,iout,ierr)
        if(ierr.eq.0) ss3%sb0halo_recap = w1*ss1%sb0halo_recap + (1.0_rspec-w1)*ss2%sb0halo_recap
     ELSE IF(ALLOCATED(ss1%sb0halo_recap)) THEN
        CALL ps_conformal("sb0halo_recap",ss1%sb0halo_recap,ss3%sb0halo_recap,iout,ierr)
        ss3%sb0halo_recap = ss1%sb0halo_recap
     ELSE IF(ALLOCATED(ss2%sb0halo_recap)) THEN
        CALL ps_conformal("sb0halo_recap",ss2%sb0halo_recap,ss3%sb0halo_recap,iout,ierr)
        ss3%sb0halo_recap = ss2%sb0halo_recap
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%sbedep)).AND.(cclist(ps_cnum_NBI).EQ.1)) THEN
     IF(ALLOCATED(ss1%sbedep).AND.ALLOCATED(ss2%sbedep)) THEN
        CALL ps_conformal("sbedep",ss2%sbedep,ss3%sbedep,iout,ierr)
        CALL ps_conformal("sbedep",ss1%sbedep,ss3%sbedep,iout,ierr)
        if(ierr.eq.0) ss3%sbedep = w1*ss1%sbedep + (1.0_rspec-w1)*ss2%sbedep
     ELSE IF(ALLOCATED(ss1%sbedep)) THEN
        CALL ps_conformal("sbedep",ss1%sbedep,ss3%sbedep,iout,ierr)
        ss3%sbedep = ss1%sbedep
     ELSE IF(ALLOCATED(ss2%sbedep)) THEN
        CALL ps_conformal("sbedep",ss2%sbedep,ss3%sbedep,iout,ierr)
        ss3%sbedep = ss2%sbedep
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%sbehalo)).AND.(cclist(ps_cnum_NBI).EQ.1)) THEN
     IF(ALLOCATED(ss1%sbehalo).AND.ALLOCATED(ss2%sbehalo)) THEN
        CALL ps_conformal("sbehalo",ss2%sbehalo,ss3%sbehalo,iout,ierr)
        CALL ps_conformal("sbehalo",ss1%sbehalo,ss3%sbehalo,iout,ierr)
        if(ierr.eq.0) ss3%sbehalo = w1*ss1%sbehalo + (1.0_rspec-w1)*ss2%sbehalo
     ELSE IF(ALLOCATED(ss1%sbehalo)) THEN
        CALL ps_conformal("sbehalo",ss1%sbehalo,ss3%sbehalo,iout,ierr)
        ss3%sbehalo = ss1%sbehalo
     ELSE IF(ALLOCATED(ss2%sbehalo)) THEN
        CALL ps_conformal("sbehalo",ss2%sbehalo,ss3%sbehalo,iout,ierr)
        ss3%sbehalo = ss2%sbehalo
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%sbsce)).AND.(cclist(ps_cnum_NBI).EQ.1)) THEN
     IF(ALLOCATED(ss1%sbsce).AND.ALLOCATED(ss2%sbsce)) THEN
        CALL ps_conformal("sbsce",ss2%sbsce,ss3%sbsce,iout,ierr)
        CALL ps_conformal("sbsce",ss1%sbsce,ss3%sbsce,iout,ierr)
        if(ierr.eq.0) ss3%sbsce = w1*ss1%sbsce + (1.0_rspec-w1)*ss2%sbsce
     ELSE IF(ALLOCATED(ss1%sbsce)) THEN
        CALL ps_conformal("sbsce",ss1%sbsce,ss3%sbsce,iout,ierr)
        ss3%sbsce = ss1%sbsce
     ELSE IF(ALLOCATED(ss2%sbsce)) THEN
        CALL ps_conformal("sbsce",ss2%sbsce,ss3%sbsce,iout,ierr)
        ss3%sbsce = ss2%sbsce
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%sbtherm)).AND.(cclist(ps_cnum_NBI).EQ.1)) THEN
     IF(ALLOCATED(ss1%sbtherm).AND.ALLOCATED(ss2%sbtherm)) THEN
        CALL ps_conformal("sbtherm",ss2%sbtherm,ss3%sbtherm,iout,ierr)
        CALL ps_conformal("sbtherm",ss1%sbtherm,ss3%sbtherm,iout,ierr)
        if(ierr.eq.0) ss3%sbtherm = w1*ss1%sbtherm + (1.0_rspec-w1)*ss2%sbtherm
     ELSE IF(ALLOCATED(ss1%sbtherm)) THEN
        CALL ps_conformal("sbtherm",ss1%sbtherm,ss3%sbtherm,iout,ierr)
        ss3%sbtherm = ss1%sbtherm
     ELSE IF(ALLOCATED(ss2%sbtherm)) THEN
        CALL ps_conformal("sbtherm",ss2%sbtherm,ss3%sbtherm,iout,ierr)
        ss3%sbtherm = ss2%sbtherm
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%sc0)).AND.(cclist(ps_cnum_GAS).EQ.1)) THEN
     IF(ALLOCATED(ss1%sc0).AND.ALLOCATED(ss2%sc0)) THEN
        CALL ps_conformal("sc0",ss2%sc0,ss3%sc0,iout,ierr)
        CALL ps_conformal("sc0",ss1%sc0,ss3%sc0,iout,ierr)
        if(ierr.eq.0) ss3%sc0 = w1*ss1%sc0 + (1.0_rspec-w1)*ss2%sc0
     ELSE IF(ALLOCATED(ss1%sc0)) THEN
        CALL ps_conformal("sc0",ss1%sc0,ss3%sc0,iout,ierr)
        ss3%sc0 = ss1%sc0
     ELSE IF(ALLOCATED(ss2%sc0)) THEN
        CALL ps_conformal("sc0",ss2%sc0,ss3%sc0,iout,ierr)
        ss3%sc0 = ss2%sc0
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%sc0_to_sgas)).AND.(cclist(ps_cnum_GAS).EQ.1)) THEN
     IF(ALLOCATED(ss1%sc0_to_sgas).AND.ALLOCATED(ss2%sc0_to_sgas)) THEN
        CALL ps_diff("sc0_to_sgas",ss1%sc0_to_sgas,ss2%sc0_to_sgas,icheck,iout,ierr)
        CALL ps_conformal("sc0_to_sgas",ss1%sc0_to_sgas,ss3%sc0_to_sgas,iout,ierr)
        if(ierr.eq.0) ss3%sc0_to_sgas = ss1%sc0_to_sgas
     ELSE IF(ALLOCATED(ss1%sc0_to_sgas)) THEN
        CALL ps_conformal("sc0_to_sgas",ss1%sc0_to_sgas,ss3%sc0_to_sgas,iout,ierr)
        ss3%sc0_to_sgas = ss1%sc0_to_sgas
     ELSE IF(ALLOCATED(ss2%sc0_to_sgas)) THEN
        CALL ps_conformal("sc0_to_sgas",ss2%sc0_to_sgas,ss3%sc0_to_sgas,iout,ierr)
        ss3%sc0_to_sgas = ss2%sc0_to_sgas
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%sc_anom)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%sc_anom).AND.ALLOCATED(ss2%sc_anom)) THEN
        CALL ps_conformal("sc_anom",ss2%sc_anom,ss3%sc_anom,iout,ierr)
        CALL ps_conformal("sc_anom",ss1%sc_anom,ss3%sc_anom,iout,ierr)
        if(ierr.eq.0) ss3%sc_anom = w1*ss1%sc_anom + (1.0_rspec-w1)*ss2%sc_anom
     ELSE IF(ALLOCATED(ss1%sc_anom)) THEN
        CALL ps_conformal("sc_anom",ss1%sc_anom,ss3%sc_anom,iout,ierr)
        ss3%sc_anom = ss1%sc_anom
     ELSE IF(ALLOCATED(ss2%sc_anom)) THEN
        CALL ps_conformal("sc_anom",ss2%sc_anom,ss3%sc_anom,iout,ierr)
        ss3%sc_anom = ss2%sc_anom
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%sfsce)).AND.(cclist(ps_cnum_FUS).EQ.1)) THEN
     IF(ALLOCATED(ss1%sfsce).AND.ALLOCATED(ss2%sfsce)) THEN
        CALL ps_conformal("sfsce",ss2%sfsce,ss3%sfsce,iout,ierr)
        CALL ps_conformal("sfsce",ss1%sfsce,ss3%sfsce,iout,ierr)
        if(ierr.eq.0) ss3%sfsce = w1*ss1%sfsce + (1.0_rspec-w1)*ss2%sfsce
     ELSE IF(ALLOCATED(ss1%sfsce)) THEN
        CALL ps_conformal("sfsce",ss1%sfsce,ss3%sfsce,iout,ierr)
        ss3%sfsce = ss1%sfsce
     ELSE IF(ALLOCATED(ss2%sfsce)) THEN
        CALL ps_conformal("sfsce",ss2%sfsce,ss3%sfsce,iout,ierr)
        ss3%sfsce = ss2%sfsce
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%sftherm)).AND.(cclist(ps_cnum_FUS).EQ.1)) THEN
     IF(ALLOCATED(ss1%sftherm).AND.ALLOCATED(ss2%sftherm)) THEN
        CALL ps_conformal("sftherm",ss2%sftherm,ss3%sftherm,iout,ierr)
        CALL ps_conformal("sftherm",ss1%sftherm,ss3%sftherm,iout,ierr)
        if(ierr.eq.0) ss3%sftherm = w1*ss1%sftherm + (1.0_rspec-w1)*ss2%sftherm
     ELSE IF(ALLOCATED(ss1%sftherm)) THEN
        CALL ps_conformal("sftherm",ss1%sftherm,ss3%sftherm,iout,ierr)
        ss3%sftherm = ss1%sftherm
     ELSE IF(ALLOCATED(ss2%sftherm)) THEN
        CALL ps_conformal("sftherm",ss2%sftherm,ss3%sftherm,iout,ierr)
        ss3%sftherm = ss2%sftherm
     ENDIF
  ENDIF

  IF(ALLOCATED(ss3%SFUS_name)) THEN
     IF(ALLOCATED(ss1%SFUS_name).AND.ALLOCATED(ss2%SFUS_name)) THEN
        CALL ps_diff("SFUS_name",ss1%SFUS_name,ss2%SFUS_name,ps_error,iout,ierr)
        CALL ps_conformal("SFUS_name",ss1%SFUS_name,ss3%SFUS_name,iout,ierr)
        if(ierr.eq.0) ss3%SFUS_name = ss1%SFUS_name
     ELSE IF(ALLOCATED(ss1%SFUS_name)) THEN
        CALL ps_conformal("SFUS_name",ss1%SFUS_name,ss3%SFUS_name,iout,ierr)
        ss3%SFUS_name = ss1%SFUS_name
     ELSE IF(ALLOCATED(ss2%SFUS_name)) THEN
        CALL ps_conformal("SFUS_name",ss2%SFUS_name,ss3%SFUS_name,iout,ierr)
        ss3%SFUS_name = ss2%SFUS_name
     ENDIF
  ENDIF

  IF(ALLOCATED(ss3%sfus_to_all)) THEN
     IF(ALLOCATED(ss1%sfus_to_all).AND.ALLOCATED(ss2%sfus_to_all)) THEN
        CALL ps_diff("sfus_to_all",ss1%sfus_to_all,ss2%sfus_to_all,ps_error,iout,ierr)
        CALL ps_conformal("sfus_to_all",ss1%sfus_to_all,ss3%sfus_to_all,iout,ierr)
        if(ierr.eq.0) ss3%sfus_to_all = ss1%sfus_to_all
     ELSE IF(ALLOCATED(ss1%sfus_to_all)) THEN
        CALL ps_conformal("sfus_to_all",ss1%sfus_to_all,ss3%sfus_to_all,iout,ierr)
        ss3%sfus_to_all = ss1%sfus_to_all
     ELSE IF(ALLOCATED(ss2%sfus_to_all)) THEN
        CALL ps_conformal("sfus_to_all",ss2%sfus_to_all,ss3%sfus_to_all,iout,ierr)
        ss3%sfus_to_all = ss2%sfus_to_all
     ENDIF
  ENDIF

  IF(ALLOCATED(ss3%sfus_to_alla)) THEN
     IF(ALLOCATED(ss1%sfus_to_alla).AND.ALLOCATED(ss2%sfus_to_alla)) THEN
        CALL ps_diff("sfus_to_alla",ss1%sfus_to_alla,ss2%sfus_to_alla,ps_error,iout,ierr)
        CALL ps_conformal("sfus_to_alla",ss1%sfus_to_alla,ss3%sfus_to_alla,iout,ierr)
        if(ierr.eq.0) ss3%sfus_to_alla = ss1%sfus_to_alla
     ELSE IF(ALLOCATED(ss1%sfus_to_alla)) THEN
        CALL ps_conformal("sfus_to_alla",ss1%sfus_to_alla,ss3%sfus_to_alla,iout,ierr)
        ss3%sfus_to_alla = ss1%sfus_to_alla
     ELSE IF(ALLOCATED(ss2%sfus_to_alla)) THEN
        CALL ps_conformal("sfus_to_alla",ss2%sfus_to_alla,ss3%sfus_to_alla,iout,ierr)
        ss3%sfus_to_alla = ss2%sfus_to_alla
     ENDIF
  ENDIF

  IF(ALLOCATED(ss3%SFUS_type)) THEN
     IF(ALLOCATED(ss1%SFUS_type).AND.ALLOCATED(ss2%SFUS_type)) THEN
        CALL ps_diff("SFUS_type",ss1%SFUS_type,ss2%SFUS_type,ps_error,iout,ierr)
        CALL ps_conformal("SFUS_type",ss1%SFUS_type,ss3%SFUS_type,iout,ierr)
        if(ierr.eq.0) ss3%SFUS_type = ss1%SFUS_type
     ELSE IF(ALLOCATED(ss1%SFUS_type)) THEN
        CALL ps_conformal("SFUS_type",ss1%SFUS_type,ss3%SFUS_type,iout,ierr)
        ss3%SFUS_type = ss1%SFUS_type
     ELSE IF(ALLOCATED(ss2%SFUS_type)) THEN
        CALL ps_conformal("SFUS_type",ss2%SFUS_type,ss3%SFUS_type,iout,ierr)
        ss3%SFUS_type = ss2%SFUS_type
     ENDIF
  ENDIF

  IF(ALLOCATED(ss3%SGAS_name)) THEN
     IF(ALLOCATED(ss1%SGAS_name).AND.ALLOCATED(ss2%SGAS_name)) THEN
        CALL ps_diff("SGAS_name",ss1%SGAS_name,ss2%SGAS_name,ps_error,iout,ierr)
        CALL ps_conformal("SGAS_name",ss1%SGAS_name,ss3%SGAS_name,iout,ierr)
        if(ierr.eq.0) ss3%SGAS_name = ss1%SGAS_name
     ELSE IF(ALLOCATED(ss1%SGAS_name)) THEN
        CALL ps_conformal("SGAS_name",ss1%SGAS_name,ss3%SGAS_name,iout,ierr)
        ss3%SGAS_name = ss1%SGAS_name
     ELSE IF(ALLOCATED(ss2%SGAS_name)) THEN
        CALL ps_conformal("SGAS_name",ss2%SGAS_name,ss3%SGAS_name,iout,ierr)
        ss3%SGAS_name = ss2%SGAS_name
     ENDIF
  ENDIF

  IF(ALLOCATED(ss3%sgas_to_s)) THEN
     IF(ALLOCATED(ss1%sgas_to_s).AND.ALLOCATED(ss2%sgas_to_s)) THEN
        CALL ps_diff("sgas_to_s",ss1%sgas_to_s,ss2%sgas_to_s,ps_error,iout,ierr)
        CALL ps_conformal("sgas_to_s",ss1%sgas_to_s,ss3%sgas_to_s,iout,ierr)
        if(ierr.eq.0) ss3%sgas_to_s = ss1%sgas_to_s
     ELSE IF(ALLOCATED(ss1%sgas_to_s)) THEN
        CALL ps_conformal("sgas_to_s",ss1%sgas_to_s,ss3%sgas_to_s,iout,ierr)
        ss3%sgas_to_s = ss1%sgas_to_s
     ELSE IF(ALLOCATED(ss2%sgas_to_s)) THEN
        CALL ps_conformal("sgas_to_s",ss2%sgas_to_s,ss3%sgas_to_s,iout,ierr)
        ss3%sgas_to_s = ss2%sgas_to_s
     ENDIF
  ENDIF

  IF(ALLOCATED(ss3%SGAS_type)) THEN
     IF(ALLOCATED(ss1%SGAS_type).AND.ALLOCATED(ss2%SGAS_type)) THEN
        CALL ps_diff("SGAS_type",ss1%SGAS_type,ss2%SGAS_type,ps_error,iout,ierr)
        CALL ps_conformal("SGAS_type",ss1%SGAS_type,ss3%SGAS_type,iout,ierr)
        if(ierr.eq.0) ss3%SGAS_type = ss1%SGAS_type
     ELSE IF(ALLOCATED(ss1%SGAS_type)) THEN
        CALL ps_conformal("SGAS_type",ss1%SGAS_type,ss3%SGAS_type,iout,ierr)
        ss3%SGAS_type = ss1%SGAS_type
     ELSE IF(ALLOCATED(ss2%SGAS_type)) THEN
        CALL ps_conformal("SGAS_type",ss2%SGAS_type,ss3%SGAS_type,iout,ierr)
        ss3%SGAS_type = ss2%SGAS_type
     ENDIF
  ENDIF

  IF(cclist(ps_cnum_PLASMA).EQ.1) THEN

     CALL ps_diff("shot_number",ss1%shot_number,ss2%shot_number,icheck,iout,ierr)
     ss3%shot_number = ss1%shot_number
  ENDIF

  IF((ALLOCATED(ss3%sii_xs)).AND.(cclist(ps_cnum_RAD).EQ.1)) THEN
     IF(ALLOCATED(ss1%sii_xs).AND.ALLOCATED(ss2%sii_xs)) THEN
        CALL ps_conformal("sii_xs",ss2%sii_xs,ss3%sii_xs,iout,ierr)
        CALL ps_conformal("sii_xs",ss1%sii_xs,ss3%sii_xs,iout,ierr)
        if(ierr.eq.0) ss3%sii_xs = w1*ss1%sii_xs + (1.0_rspec-w1)*ss2%sii_xs
     ELSE IF(ALLOCATED(ss1%sii_xs)) THEN
        CALL ps_conformal("sii_xs",ss1%sii_xs,ss3%sii_xs,iout,ierr)
        ss3%sii_xs = ss1%sii_xs
     ELSE IF(ALLOCATED(ss2%sii_xs)) THEN
        CALL ps_conformal("sii_xs",ss2%sii_xs,ss3%sii_xs,iout,ierr)
        ss3%sii_xs = ss2%sii_xs
     ENDIF
  ENDIF

  IF(ALLOCATED(ss3%SIMP0_name)) THEN
     IF(ALLOCATED(ss1%SIMP0_name).AND.ALLOCATED(ss2%SIMP0_name)) THEN
        CALL ps_diff("SIMP0_name",ss1%SIMP0_name,ss2%SIMP0_name,ps_error,iout,ierr)
        CALL ps_conformal("SIMP0_name",ss1%SIMP0_name,ss3%SIMP0_name,iout,ierr)
        if(ierr.eq.0) ss3%SIMP0_name = ss1%SIMP0_name
     ELSE IF(ALLOCATED(ss1%SIMP0_name)) THEN
        CALL ps_conformal("SIMP0_name",ss1%SIMP0_name,ss3%SIMP0_name,iout,ierr)
        ss3%SIMP0_name = ss1%SIMP0_name
     ELSE IF(ALLOCATED(ss2%SIMP0_name)) THEN
        CALL ps_conformal("SIMP0_name",ss2%SIMP0_name,ss3%SIMP0_name,iout,ierr)
        ss3%SIMP0_name = ss2%SIMP0_name
     ENDIF
  ENDIF

  IF(ALLOCATED(ss3%simp0_to_s)) THEN
     IF(ALLOCATED(ss1%simp0_to_s).AND.ALLOCATED(ss2%simp0_to_s)) THEN
        CALL ps_diff("simp0_to_s",ss1%simp0_to_s,ss2%simp0_to_s,ps_error,iout,ierr)
        CALL ps_conformal("simp0_to_s",ss1%simp0_to_s,ss3%simp0_to_s,iout,ierr)
        if(ierr.eq.0) ss3%simp0_to_s = ss1%simp0_to_s
     ELSE IF(ALLOCATED(ss1%simp0_to_s)) THEN
        CALL ps_conformal("simp0_to_s",ss1%simp0_to_s,ss3%simp0_to_s,iout,ierr)
        ss3%simp0_to_s = ss1%simp0_to_s
     ELSE IF(ALLOCATED(ss2%simp0_to_s)) THEN
        CALL ps_conformal("simp0_to_s",ss2%simp0_to_s,ss3%simp0_to_s,iout,ierr)
        ss3%simp0_to_s = ss2%simp0_to_s
     ENDIF
  ENDIF

  IF(ALLOCATED(ss3%SIMP0_type)) THEN
     IF(ALLOCATED(ss1%SIMP0_type).AND.ALLOCATED(ss2%SIMP0_type)) THEN
        CALL ps_diff("SIMP0_type",ss1%SIMP0_type,ss2%SIMP0_type,ps_error,iout,ierr)
        CALL ps_conformal("SIMP0_type",ss1%SIMP0_type,ss3%SIMP0_type,iout,ierr)
        if(ierr.eq.0) ss3%SIMP0_type = ss1%SIMP0_type
     ELSE IF(ALLOCATED(ss1%SIMP0_type)) THEN
        CALL ps_conformal("SIMP0_type",ss1%SIMP0_type,ss3%SIMP0_type,iout,ierr)
        ss3%SIMP0_type = ss1%SIMP0_type
     ELSE IF(ALLOCATED(ss2%SIMP0_type)) THEN
        CALL ps_conformal("SIMP0_type",ss2%SIMP0_type,ss3%SIMP0_type,iout,ierr)
        ss3%SIMP0_type = ss2%SIMP0_type
     ENDIF
  ENDIF

  IF(ALLOCATED(ss3%SIMPI_name)) THEN
     IF(ALLOCATED(ss1%SIMPI_name).AND.ALLOCATED(ss2%SIMPI_name)) THEN
        CALL ps_diff("SIMPI_name",ss1%SIMPI_name,ss2%SIMPI_name,ps_error,iout,ierr)
        CALL ps_conformal("SIMPI_name",ss1%SIMPI_name,ss3%SIMPI_name,iout,ierr)
        if(ierr.eq.0) ss3%SIMPI_name = ss1%SIMPI_name
     ELSE IF(ALLOCATED(ss1%SIMPI_name)) THEN
        CALL ps_conformal("SIMPI_name",ss1%SIMPI_name,ss3%SIMPI_name,iout,ierr)
        ss3%SIMPI_name = ss1%SIMPI_name
     ELSE IF(ALLOCATED(ss2%SIMPI_name)) THEN
        CALL ps_conformal("SIMPI_name",ss2%SIMPI_name,ss3%SIMPI_name,iout,ierr)
        ss3%SIMPI_name = ss2%SIMPI_name
     ENDIF
  ENDIF

  IF(ALLOCATED(ss3%simpi_to_s)) THEN
     IF(ALLOCATED(ss1%simpi_to_s).AND.ALLOCATED(ss2%simpi_to_s)) THEN
        CALL ps_diff("simpi_to_s",ss1%simpi_to_s,ss2%simpi_to_s,ps_error,iout,ierr)
        CALL ps_conformal("simpi_to_s",ss1%simpi_to_s,ss3%simpi_to_s,iout,ierr)
        if(ierr.eq.0) ss3%simpi_to_s = ss1%simpi_to_s
     ELSE IF(ALLOCATED(ss1%simpi_to_s)) THEN
        CALL ps_conformal("simpi_to_s",ss1%simpi_to_s,ss3%simpi_to_s,iout,ierr)
        ss3%simpi_to_s = ss1%simpi_to_s
     ELSE IF(ALLOCATED(ss2%simpi_to_s)) THEN
        CALL ps_conformal("simpi_to_s",ss2%simpi_to_s,ss3%simpi_to_s,iout,ierr)
        ss3%simpi_to_s = ss2%simpi_to_s
     ENDIF
  ENDIF

  IF(ALLOCATED(ss3%SIMPI_type)) THEN
     IF(ALLOCATED(ss1%SIMPI_type).AND.ALLOCATED(ss2%SIMPI_type)) THEN
        CALL ps_diff("SIMPI_type",ss1%SIMPI_type,ss2%SIMPI_type,ps_error,iout,ierr)
        CALL ps_conformal("SIMPI_type",ss1%SIMPI_type,ss3%SIMPI_type,iout,ierr)
        if(ierr.eq.0) ss3%SIMPI_type = ss1%SIMPI_type
     ELSE IF(ALLOCATED(ss1%SIMPI_type)) THEN
        CALL ps_conformal("SIMPI_type",ss1%SIMPI_type,ss3%SIMPI_type,iout,ierr)
        ss3%SIMPI_type = ss1%SIMPI_type
     ELSE IF(ALLOCATED(ss2%SIMPI_type)) THEN
        CALL ps_conformal("SIMPI_type",ss2%SIMPI_type,ss3%SIMPI_type,iout,ierr)
        ss3%SIMPI_type = ss2%SIMPI_type
     ENDIF
  ENDIF

  IF(ALLOCATED(ss3%SNBI_name)) THEN
     IF(ALLOCATED(ss1%SNBI_name).AND.ALLOCATED(ss2%SNBI_name)) THEN
        CALL ps_diff("SNBI_name",ss1%SNBI_name,ss2%SNBI_name,ps_error,iout,ierr)
        CALL ps_conformal("SNBI_name",ss1%SNBI_name,ss3%SNBI_name,iout,ierr)
        if(ierr.eq.0) ss3%SNBI_name = ss1%SNBI_name
     ELSE IF(ALLOCATED(ss1%SNBI_name)) THEN
        CALL ps_conformal("SNBI_name",ss1%SNBI_name,ss3%SNBI_name,iout,ierr)
        ss3%SNBI_name = ss1%SNBI_name
     ELSE IF(ALLOCATED(ss2%SNBI_name)) THEN
        CALL ps_conformal("SNBI_name",ss2%SNBI_name,ss3%SNBI_name,iout,ierr)
        ss3%SNBI_name = ss2%SNBI_name
     ENDIF
  ENDIF

  IF(ALLOCATED(ss3%snbi_to_all)) THEN
     IF(ALLOCATED(ss1%snbi_to_all).AND.ALLOCATED(ss2%snbi_to_all)) THEN
        CALL ps_diff("snbi_to_all",ss1%snbi_to_all,ss2%snbi_to_all,ps_error,iout,ierr)
        CALL ps_conformal("snbi_to_all",ss1%snbi_to_all,ss3%snbi_to_all,iout,ierr)
        if(ierr.eq.0) ss3%snbi_to_all = ss1%snbi_to_all
     ELSE IF(ALLOCATED(ss1%snbi_to_all)) THEN
        CALL ps_conformal("snbi_to_all",ss1%snbi_to_all,ss3%snbi_to_all,iout,ierr)
        ss3%snbi_to_all = ss1%snbi_to_all
     ELSE IF(ALLOCATED(ss2%snbi_to_all)) THEN
        CALL ps_conformal("snbi_to_all",ss2%snbi_to_all,ss3%snbi_to_all,iout,ierr)
        ss3%snbi_to_all = ss2%snbi_to_all
     ENDIF
  ENDIF

  IF(ALLOCATED(ss3%snbi_to_alla)) THEN
     IF(ALLOCATED(ss1%snbi_to_alla).AND.ALLOCATED(ss2%snbi_to_alla)) THEN
        CALL ps_diff("snbi_to_alla",ss1%snbi_to_alla,ss2%snbi_to_alla,ps_error,iout,ierr)
        CALL ps_conformal("snbi_to_alla",ss1%snbi_to_alla,ss3%snbi_to_alla,iout,ierr)
        if(ierr.eq.0) ss3%snbi_to_alla = ss1%snbi_to_alla
     ELSE IF(ALLOCATED(ss1%snbi_to_alla)) THEN
        CALL ps_conformal("snbi_to_alla",ss1%snbi_to_alla,ss3%snbi_to_alla,iout,ierr)
        ss3%snbi_to_alla = ss1%snbi_to_alla
     ELSE IF(ALLOCATED(ss2%snbi_to_alla)) THEN
        CALL ps_conformal("snbi_to_alla",ss2%snbi_to_alla,ss3%snbi_to_alla,iout,ierr)
        ss3%snbi_to_alla = ss2%snbi_to_alla
     ENDIF
  ENDIF

  IF(ALLOCATED(ss3%SNBI_type)) THEN
     IF(ALLOCATED(ss1%SNBI_type).AND.ALLOCATED(ss2%SNBI_type)) THEN
        CALL ps_diff("SNBI_type",ss1%SNBI_type,ss2%SNBI_type,ps_error,iout,ierr)
        CALL ps_conformal("SNBI_type",ss1%SNBI_type,ss3%SNBI_type,iout,ierr)
        if(ierr.eq.0) ss3%SNBI_type = ss1%SNBI_type
     ELSE IF(ALLOCATED(ss1%SNBI_type)) THEN
        CALL ps_conformal("SNBI_type",ss1%SNBI_type,ss3%SNBI_type,iout,ierr)
        ss3%SNBI_type = ss1%SNBI_type
     ELSE IF(ALLOCATED(ss2%SNBI_type)) THEN
        CALL ps_conformal("SNBI_type",ss2%SNBI_type,ss3%SNBI_type,iout,ierr)
        ss3%SNBI_type = ss2%SNBI_type
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%sn_trans)).AND.(cclist(ps_cnum_PLASMA).EQ.1)) THEN
     IF(ALLOCATED(ss1%sn_trans).AND.ALLOCATED(ss2%sn_trans)) THEN
        CALL ps_conformal("sn_trans",ss2%sn_trans,ss3%sn_trans,iout,ierr)
        CALL ps_conformal("sn_trans",ss1%sn_trans,ss3%sn_trans,iout,ierr)
        if(ierr.eq.0) ss3%sn_trans = w1*ss1%sn_trans + (1.0_rspec-w1)*ss2%sn_trans
     ELSE IF(ALLOCATED(ss1%sn_trans)) THEN
        CALL ps_conformal("sn_trans",ss1%sn_trans,ss3%sn_trans,iout,ierr)
        ss3%sn_trans = ss1%sn_trans
     ELSE IF(ALLOCATED(ss2%sn_trans)) THEN
        CALL ps_conformal("sn_trans",ss2%sn_trans,ss3%sn_trans,iout,ierr)
        ss3%sn_trans = ss2%sn_trans
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%sn_transcat)).AND.(cclist(ps_cnum_PLASMA).EQ.1)) THEN
     IF(ALLOCATED(ss1%sn_transcat).AND.ALLOCATED(ss2%sn_transcat)) THEN
        CALL ps_conformal("sn_transcat",ss2%sn_transcat,ss3%sn_transcat,iout,ierr)
        CALL ps_conformal("sn_transcat",ss1%sn_transcat,ss3%sn_transcat,iout,ierr)
        if(ierr.eq.0) ss3%sn_transcat = w1*ss1%sn_transcat + (1.0_rspec-w1)*ss2%sn_transcat
     ELSE IF(ALLOCATED(ss1%sn_transcat)) THEN
        CALL ps_conformal("sn_transcat",ss1%sn_transcat,ss3%sn_transcat,iout,ierr)
        ss3%sn_transcat = ss1%sn_transcat
     ELSE IF(ALLOCATED(ss2%sn_transcat)) THEN
        CALL ps_conformal("sn_transcat",ss2%sn_transcat,ss3%sn_transcat,iout,ierr)
        ss3%sn_transcat = ss2%sn_transcat
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%sprof0)).AND.(cclist(ps_cnum_GAS).EQ.1)) THEN
     IF(ALLOCATED(ss1%sprof0).AND.ALLOCATED(ss2%sprof0)) THEN
        CALL ps_conformal("sprof0",ss2%sprof0,ss3%sprof0,iout,ierr)
        CALL ps_conformal("sprof0",ss1%sprof0,ss3%sprof0,iout,ierr)
        if(ierr.eq.0) ss3%sprof0 = w1*ss1%sprof0 + (1.0_rspec-w1)*ss2%sprof0
     ELSE IF(ALLOCATED(ss1%sprof0)) THEN
        CALL ps_conformal("sprof0",ss1%sprof0,ss3%sprof0,iout,ierr)
        ss3%sprof0 = ss1%sprof0
     ELSE IF(ALLOCATED(ss2%sprof0)) THEN
        CALL ps_conformal("sprof0",ss2%sprof0,ss3%sprof0,iout,ierr)
        ss3%sprof0 = ss2%sprof0
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%sprof0e)).AND.(cclist(ps_cnum_GAS).EQ.1)) THEN
     IF(ALLOCATED(ss1%sprof0e).AND.ALLOCATED(ss2%sprof0e)) THEN
        CALL ps_conformal("sprof0e",ss2%sprof0e,ss3%sprof0e,iout,ierr)
        CALL ps_conformal("sprof0e",ss1%sprof0e,ss3%sprof0e,iout,ierr)
        if(ierr.eq.0) ss3%sprof0e = w1*ss1%sprof0e + (1.0_rspec-w1)*ss2%sprof0e
     ELSE IF(ALLOCATED(ss1%sprof0e)) THEN
        CALL ps_conformal("sprof0e",ss1%sprof0e,ss3%sprof0e,iout,ierr)
        ss3%sprof0e = ss1%sprof0e
     ELSE IF(ALLOCATED(ss2%sprof0e)) THEN
        CALL ps_conformal("sprof0e",ss2%sprof0e,ss3%sprof0e,iout,ierr)
        ss3%sprof0e = ss2%sprof0e
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%spsce)).AND.(cclist(ps_cnum_PEL).EQ.1)) THEN
     IF(ALLOCATED(ss1%spsce).AND.ALLOCATED(ss2%spsce)) THEN
        CALL ps_conformal("spsce",ss2%spsce,ss3%spsce,iout,ierr)
        CALL ps_conformal("spsce",ss1%spsce,ss3%spsce,iout,ierr)
        if(ierr.eq.0) ss3%spsce = w1*ss1%spsce + (1.0_rspec-w1)*ss2%spsce
     ELSE IF(ALLOCATED(ss1%spsce)) THEN
        CALL ps_conformal("spsce",ss1%spsce,ss3%spsce,iout,ierr)
        ss3%spsce = ss1%spsce
     ELSE IF(ALLOCATED(ss2%spsce)) THEN
        CALL ps_conformal("spsce",ss2%spsce,ss3%spsce,iout,ierr)
        ss3%spsce = ss2%spsce
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%squareLO)).AND.(cclist(ps_cnum_EQ).EQ.1)) THEN
     IF(ALLOCATED(ss1%squareLO).AND.ALLOCATED(ss2%squareLO)) THEN
        CALL ps_conformal("squareLO",ss2%squareLO,ss3%squareLO,iout,ierr)
        CALL ps_conformal("squareLO",ss1%squareLO,ss3%squareLO,iout,ierr)
        if(ierr.eq.0) ss3%squareLO = w1*ss1%squareLO + (1.0_rspec-w1)*ss2%squareLO
     ELSE IF(ALLOCATED(ss1%squareLO)) THEN
        CALL ps_conformal("squareLO",ss1%squareLO,ss3%squareLO,iout,ierr)
        ss3%squareLO = ss1%squareLO
     ELSE IF(ALLOCATED(ss2%squareLO)) THEN
        CALL ps_conformal("squareLO",ss2%squareLO,ss3%squareLO,iout,ierr)
        ss3%squareLO = ss2%squareLO
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%squareUO)).AND.(cclist(ps_cnum_EQ).EQ.1)) THEN
     IF(ALLOCATED(ss1%squareUO).AND.ALLOCATED(ss2%squareUO)) THEN
        CALL ps_conformal("squareUO",ss2%squareUO,ss3%squareUO,iout,ierr)
        CALL ps_conformal("squareUO",ss1%squareUO,ss3%squareUO,iout,ierr)
        if(ierr.eq.0) ss3%squareUO = w1*ss1%squareUO + (1.0_rspec-w1)*ss2%squareUO
     ELSE IF(ALLOCATED(ss1%squareUO)) THEN
        CALL ps_conformal("squareUO",ss1%squareUO,ss3%squareUO,iout,ierr)
        ss3%squareUO = ss1%squareUO
     ELSE IF(ALLOCATED(ss2%squareUO)) THEN
        CALL ps_conformal("squareUO",ss2%squareUO,ss3%squareUO,iout,ierr)
        ss3%squareUO = ss2%squareUO
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%sRtcen)).AND.(cclist(ps_cnum_NBI).EQ.1)) THEN
     IF(ALLOCATED(ss1%sRtcen).AND.ALLOCATED(ss2%sRtcen)) THEN
        CALL ps_diff("sRtcen",ss1%sRtcen,ss2%sRtcen,icheck,iout,ierr)
        CALL ps_conformal("sRtcen",ss1%sRtcen,ss3%sRtcen,iout,ierr)
        if(ierr.eq.0) ss3%sRtcen = ss1%sRtcen
     ELSE IF(ALLOCATED(ss1%sRtcen)) THEN
        CALL ps_conformal("sRtcen",ss1%sRtcen,ss3%sRtcen,iout,ierr)
        ss3%sRtcen = ss1%sRtcen
     ELSE IF(ALLOCATED(ss2%sRtcen)) THEN
        CALL ps_conformal("sRtcen",ss2%sRtcen,ss3%sRtcen,iout,ierr)
        ss3%sRtcen = ss2%sRtcen
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%surf)).AND.(cclist(ps_cnum_EQ).EQ.1)) THEN
     IF(ALLOCATED(ss1%surf).AND.ALLOCATED(ss2%surf)) THEN
        CALL ps_conformal("surf",ss2%surf,ss3%surf,iout,ierr)
        CALL ps_conformal("surf",ss1%surf,ss3%surf,iout,ierr)
        if(ierr.eq.0) ss3%surf = w1*ss1%surf + (1.0_rspec-w1)*ss2%surf
     ELSE IF(ALLOCATED(ss1%surf)) THEN
        CALL ps_conformal("surf",ss1%surf,ss3%surf,iout,ierr)
        ss3%surf = ss1%surf
     ELSE IF(ALLOCATED(ss2%surf)) THEN
        CALL ps_conformal("surf",ss2%surf,ss3%surf,iout,ierr)
        ss3%surf = ss2%surf
     ENDIF
  ENDIF

  IF(ALLOCATED(ss3%S_name)) THEN
     IF(ALLOCATED(ss1%S_name).AND.ALLOCATED(ss2%S_name)) THEN
        CALL ps_diff("S_name",ss1%S_name,ss2%S_name,ps_error,iout,ierr)
        CALL ps_conformal("S_name",ss1%S_name,ss3%S_name,iout,ierr)
        if(ierr.eq.0) ss3%S_name = ss1%S_name
     ELSE IF(ALLOCATED(ss1%S_name)) THEN
        CALL ps_conformal("S_name",ss1%S_name,ss3%S_name,iout,ierr)
        ss3%S_name = ss1%S_name
     ELSE IF(ALLOCATED(ss2%S_name)) THEN
        CALL ps_conformal("S_name",ss2%S_name,ss3%S_name,iout,ierr)
        ss3%S_name = ss2%S_name
     ENDIF
  ENDIF

  IF(ALLOCATED(ss3%s_to_sa)) THEN
     IF(ALLOCATED(ss1%s_to_sa).AND.ALLOCATED(ss2%s_to_sa)) THEN
        CALL ps_diff("s_to_sa",ss1%s_to_sa,ss2%s_to_sa,ps_error,iout,ierr)
        CALL ps_conformal("s_to_sa",ss1%s_to_sa,ss3%s_to_sa,iout,ierr)
        if(ierr.eq.0) ss3%s_to_sa = ss1%s_to_sa
     ELSE IF(ALLOCATED(ss1%s_to_sa)) THEN
        CALL ps_conformal("s_to_sa",ss1%s_to_sa,ss3%s_to_sa,iout,ierr)
        ss3%s_to_sa = ss1%s_to_sa
     ELSE IF(ALLOCATED(ss2%s_to_sa)) THEN
        CALL ps_conformal("s_to_sa",ss2%s_to_sa,ss3%s_to_sa,iout,ierr)
        ss3%s_to_sa = ss2%s_to_sa
     ENDIF
  ENDIF

  IF(ALLOCATED(ss3%S_type)) THEN
     IF(ALLOCATED(ss1%S_type).AND.ALLOCATED(ss2%S_type)) THEN
        CALL ps_diff("S_type",ss1%S_type,ss2%S_type,ps_error,iout,ierr)
        CALL ps_conformal("S_type",ss1%S_type,ss3%S_type,iout,ierr)
        if(ierr.eq.0) ss3%S_type = ss1%S_type
     ELSE IF(ALLOCATED(ss1%S_type)) THEN
        CALL ps_conformal("S_type",ss1%S_type,ss3%S_type,iout,ierr)
        ss3%S_type = ss1%S_type
     ELSE IF(ALLOCATED(ss2%S_type)) THEN
        CALL ps_conformal("S_type",ss2%S_type,ss3%S_type,iout,ierr)
        ss3%S_type = ss2%S_type
     ENDIF
  ENDIF

  IF(cclist(ps_cnum_PLASMA).EQ.1) THEN
     ss3%t0 = w1*ss1%t0 + (1.0_rspec-w1)*ss2%t0
  ENDIF

  IF((ALLOCATED(ss3%T0cx)).AND.(cclist(ps_cnum_GAS).EQ.1)) THEN
     IF(ALLOCATED(ss1%T0cx).AND.ALLOCATED(ss2%T0cx)) THEN
        CALL ps_conformal("T0cx",ss2%T0cx,ss3%T0cx,iout,ierr)
        CALL ps_conformal("T0cx",ss1%T0cx,ss3%T0cx,iout,ierr)
        if(ierr.eq.0) ss3%T0cx = w1*ss1%T0cx + (1.0_rspec-w1)*ss2%T0cx
     ELSE IF(ALLOCATED(ss1%T0cx)) THEN
        CALL ps_conformal("T0cx",ss1%T0cx,ss3%T0cx,iout,ierr)
        ss3%T0cx = ss1%T0cx
     ELSE IF(ALLOCATED(ss2%T0cx)) THEN
        CALL ps_conformal("T0cx",ss2%T0cx,ss3%T0cx,iout,ierr)
        ss3%T0cx = ss2%T0cx
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%T0sc0)).AND.(cclist(ps_cnum_GAS).EQ.1)) THEN
     IF(ALLOCATED(ss1%T0sc0).AND.ALLOCATED(ss2%T0sc0)) THEN
        CALL ps_conformal("T0sc0",ss2%T0sc0,ss3%T0sc0,iout,ierr)
        CALL ps_conformal("T0sc0",ss1%T0sc0,ss3%T0sc0,iout,ierr)
        if(ierr.eq.0) ss3%T0sc0 = w1*ss1%T0sc0 + (1.0_rspec-w1)*ss2%T0sc0
     ELSE IF(ALLOCATED(ss1%T0sc0)) THEN
        CALL ps_conformal("T0sc0",ss1%T0sc0,ss3%T0sc0,iout,ierr)
        ss3%T0sc0 = ss1%T0sc0
     ELSE IF(ALLOCATED(ss2%T0sc0)) THEN
        CALL ps_conformal("T0sc0",ss2%T0sc0,ss3%T0sc0,iout,ierr)
        ss3%T0sc0 = ss2%T0sc0
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%T0_halo)).AND.(cclist(ps_cnum_NBI).EQ.1)) THEN
     IF(ALLOCATED(ss1%T0_halo).AND.ALLOCATED(ss2%T0_halo)) THEN
        CALL ps_conformal("T0_halo",ss2%T0_halo,ss3%T0_halo,iout,ierr)
        CALL ps_conformal("T0_halo",ss1%T0_halo,ss3%T0_halo,iout,ierr)
        if(ierr.eq.0) ss3%T0_halo = w1*ss1%T0_halo + (1.0_rspec-w1)*ss2%T0_halo
     ELSE IF(ALLOCATED(ss1%T0_halo)) THEN
        CALL ps_conformal("T0_halo",ss1%T0_halo,ss3%T0_halo,iout,ierr)
        ss3%T0_halo = ss1%T0_halo
     ELSE IF(ALLOCATED(ss2%T0_halo)) THEN
        CALL ps_conformal("T0_halo",ss2%T0_halo,ss3%T0_halo,iout,ierr)
        ss3%T0_halo = ss2%T0_halo
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%T0_reco)).AND.(cclist(ps_cnum_GAS).EQ.1)) THEN
     IF(ALLOCATED(ss1%T0_reco).AND.ALLOCATED(ss2%T0_reco)) THEN
        CALL ps_conformal("T0_reco",ss2%T0_reco,ss3%T0_reco,iout,ierr)
        CALL ps_conformal("T0_reco",ss1%T0_reco,ss3%T0_reco,iout,ierr)
        if(ierr.eq.0) ss3%T0_reco = w1*ss1%T0_reco + (1.0_rspec-w1)*ss2%T0_reco
     ELSE IF(ALLOCATED(ss1%T0_reco)) THEN
        CALL ps_conformal("T0_reco",ss1%T0_reco,ss3%T0_reco,iout,ierr)
        ss3%T0_reco = ss1%T0_reco
     ELSE IF(ALLOCATED(ss2%T0_reco)) THEN
        CALL ps_conformal("T0_reco",ss2%T0_reco,ss3%T0_reco,iout,ierr)
        ss3%T0_reco = ss2%T0_reco
     ENDIF
  ENDIF

  IF(cclist(ps_cnum_PLASMA).EQ.1) THEN
     ss3%t1 = w1*ss1%t1 + (1.0_rspec-w1)*ss2%t1
  ENDIF

  IF((ALLOCATED(ss3%teflux_ky_tglf)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%teflux_ky_tglf).AND.ALLOCATED(ss2%teflux_ky_tglf)) THEN
        CALL ps_conformal("teflux_ky_tglf",ss2%teflux_ky_tglf,ss3%teflux_ky_tglf,iout,ierr)
        CALL ps_conformal("teflux_ky_tglf",ss1%teflux_ky_tglf,ss3%teflux_ky_tglf,iout,ierr)
        if(ierr.eq.0) ss3%teflux_ky_tglf = w1*ss1%teflux_ky_tglf + (1.0_rspec-w1)*ss2%teflux_ky_tglf
     ELSE IF(ALLOCATED(ss1%teflux_ky_tglf)) THEN
        CALL ps_conformal("teflux_ky_tglf",ss1%teflux_ky_tglf,ss3%teflux_ky_tglf,iout,ierr)
        ss3%teflux_ky_tglf = ss1%teflux_ky_tglf
     ELSE IF(ALLOCATED(ss2%teflux_ky_tglf)) THEN
        CALL ps_conformal("teflux_ky_tglf",ss2%teflux_ky_tglf,ss3%teflux_ky_tglf,iout,ierr)
        ss3%teflux_ky_tglf = ss2%teflux_ky_tglf
     ENDIF
  ENDIF

  IF(cclist(ps_cnum_PLASMA).EQ.1) THEN
     ss3%Te_bdy = w1*ss1%Te_bdy + (1.0_rspec-w1)*ss2%Te_bdy
  ENDIF

  IF((ALLOCATED(ss3%te_ky_tglf)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%te_ky_tglf).AND.ALLOCATED(ss2%te_ky_tglf)) THEN
        CALL ps_conformal("te_ky_tglf",ss2%te_ky_tglf,ss3%te_ky_tglf,iout,ierr)
        CALL ps_conformal("te_ky_tglf",ss1%te_ky_tglf,ss3%te_ky_tglf,iout,ierr)
        if(ierr.eq.0) ss3%te_ky_tglf = w1*ss1%te_ky_tglf + (1.0_rspec-w1)*ss2%te_ky_tglf
     ELSE IF(ALLOCATED(ss1%te_ky_tglf)) THEN
        CALL ps_conformal("te_ky_tglf",ss1%te_ky_tglf,ss3%te_ky_tglf,iout,ierr)
        ss3%te_ky_tglf = ss1%te_ky_tglf
     ELSE IF(ALLOCATED(ss2%te_ky_tglf)) THEN
        CALL ps_conformal("te_ky_tglf",ss2%te_ky_tglf,ss3%te_ky_tglf,iout,ierr)
        ss3%te_ky_tglf = ss2%te_ky_tglf
     ENDIF
  ENDIF

END SUBROUTINE plasma_state_merge_7

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


SUBROUTINE plasma_state_contents_profs_9(itype,icomponent,ss,w,isize)


  ! fill window structure with requested table of contents

  USE plasma_state_mod
  IMPLICIT NONE

  INTEGER, INTENT(IN) :: itype   ! type of table of contents
                                 ! values such as ps_grid_dims or ps_profiles

  INTEGER, INTENT(IN) :: icomponent(ps_ccount) ! component flags
             ! icomponent(j).eq.1 => component j active
             ! e.g. icomponent(ps_cnum_EQ).eq.1 => EQ component is active

  TYPE (plasma_state) :: ss      ! state examined
  TYPE (ps_list_window) :: w     ! list window structure filled

  INTEGER, INTENT(INOUT) :: isize  ! incremented size...

  !----------------

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! velte_glf
        w%list_elems(isize) = "velte_glf"
        w%elem_descr(isize) = "Te-equation, advective velocity term from GLF23 model"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "m/sec"
        w%c256val(isize) = "(nrho_anomth)"
        IF(ALLOCATED(ss%velte_glf)) THEN
           IF(ss%hash_codes(ps_phash_velte_glf).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! velte_gtcneo
        w%list_elems(isize) = "velte_gtcneo"
        w%elem_descr(isize) = "Te-equation, advective velocity term from GTC_NEO model"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "m/sec"
        w%c256val(isize) = "(nrho_anomth)"
        IF(ALLOCATED(ss%velte_gtcneo)) THEN
           IF(ss%hash_codes(ps_phash_velte_gtcneo).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! velte_mmm71
        w%list_elems(isize) = "velte_mmm71"
        w%elem_descr(isize) = "Te-equation, advective velocity term from MMM71 model"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "m/sec"
        w%c256val(isize) = "(nrho_anomth)"
        IF(ALLOCATED(ss%velte_mmm71)) THEN
           IF(ss%hash_codes(ps_phash_velte_mmm71).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! velte_nclass
        w%list_elems(isize) = "velte_nclass"
        w%elem_descr(isize) = "Te-equation, advective velocity term from NCLASS model"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "m/sec"
        w%c256val(isize) = "(nrho_anomth)"
        IF(ALLOCATED(ss%velte_nclass)) THEN
           IF(ss%hash_codes(ps_phash_velte_nclass).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! velte_neo
        w%list_elems(isize) = "velte_neo"
        w%elem_descr(isize) = "Te-equation, advective velocity term from NEO model"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "m/sec"
        w%c256val(isize) = "(nrho_anomth)"
        IF(ALLOCATED(ss%velte_neo)) THEN
           IF(ss%hash_codes(ps_phash_velte_neo).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! velte_paleo
        w%list_elems(isize) = "velte_paleo"
        w%elem_descr(isize) = "Te-equation, convection term from PALEO model"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "m/sec"
        w%c256val(isize) = "(nrho_anomth)"
        IF(ALLOCATED(ss%velte_paleo)) THEN
           IF(ss%hash_codes(ps_phash_velte_paleo).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! velte_tglf
        w%list_elems(isize) = "velte_tglf"
        w%elem_descr(isize) = "Te-equation, advective velocity term from TGLF model"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "m/sec"
        w%c256val(isize) = "(nrho_anomth)"
        IF(ALLOCATED(ss%velte_tglf)) THEN
           IF(ss%hash_codes(ps_phash_velte_tglf).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! velti_anom
        w%list_elems(isize) = "velti_anom"
        w%elem_descr(isize) = "Ti-equation, advective velocity term"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "m/sec"
        w%c256val(isize) = "(nrho_anomth)"
        IF(ALLOCATED(ss%velti_anom)) THEN
           IF(ss%hash_codes(ps_phash_velti_anom).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! velti_glf
        w%list_elems(isize) = "velti_glf"
        w%elem_descr(isize) = "Ti-equation, advective velocity term from GLF23 model"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "m/sec"
        w%c256val(isize) = "(nrho_anomth)"
        IF(ALLOCATED(ss%velti_glf)) THEN
           IF(ss%hash_codes(ps_phash_velti_glf).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! velti_gtcneo
        w%list_elems(isize) = "velti_gtcneo"
        w%elem_descr(isize) = "Ti-equation, advective velocity term from GTC_NEO model"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "m/sec"
        w%c256val(isize) = "(nrho_anomth)"
        IF(ALLOCATED(ss%velti_gtcneo)) THEN
           IF(ss%hash_codes(ps_phash_velti_gtcneo).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! velti_mmm71
        w%list_elems(isize) = "velti_mmm71"
        w%elem_descr(isize) = "Ti-equation, advective velocity term from MMM71 model"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "m/sec"
        w%c256val(isize) = "(nrho_anomth)"
        IF(ALLOCATED(ss%velti_mmm71)) THEN
           IF(ss%hash_codes(ps_phash_velti_mmm71).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! velti_nclass
        w%list_elems(isize) = "velti_nclass"
        w%elem_descr(isize) = "Ti-equation, advective velocity term from NCLASS model"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "m/sec"
        w%c256val(isize) = "(nrho_anomth)"
        IF(ALLOCATED(ss%velti_nclass)) THEN
           IF(ss%hash_codes(ps_phash_velti_nclass).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! velti_neo
        w%list_elems(isize) = "velti_neo"
        w%elem_descr(isize) = "Ti-equation, advective velocity term from NEO model"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "m/sec"
        w%c256val(isize) = "(nrho_anomth)"
        IF(ALLOCATED(ss%velti_neo)) THEN
           IF(ss%hash_codes(ps_phash_velti_neo).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! velti_tglf
        w%list_elems(isize) = "velti_tglf"
        w%elem_descr(isize) = "Ti-equation, advective velocity term from TGLF model"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "m/sec"
        w%c256val(isize) = "(nrho_anomth)"
        IF(ALLOCATED(ss%velti_tglf)) THEN
           IF(ss%hash_codes(ps_phash_velti_tglf).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! vie_trans
        w%list_elems(isize) = "vie_trans"
        w%elem_descr(isize) = "ion energy radial velocity"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "m/sec"
        w%c256val(isize) = "(nrho)"
        IF(ALLOCATED(ss%vie_trans)) THEN
           IF(ss%hash_codes(ps_phash_vie_trans).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! vie_transcat
        w%list_elems(isize) = "vie_transcat"
        w%elem_descr(isize) = "Ion energy radial velocity"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "m/sec"
        w%c256val(isize) = "(nrho,ntrcat)"
        IF(ALLOCATED(ss%vie_transcat)) THEN
           IF(ss%hash_codes(ps_phash_vie_transcat).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! vmo_trans
        w%list_elems(isize) = "vmo_trans"
        w%elem_descr(isize) = "angular momentum radial velocity"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "m/sec"
        w%c256val(isize) = "(nrho)"
        IF(ALLOCATED(ss%vmo_trans)) THEN
           IF(ss%hash_codes(ps_phash_vmo_trans).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! vmo_transcat
        w%list_elems(isize) = "vmo_transcat"
        w%elem_descr(isize) = "Angular momentum radial velocity"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "m/sec"
        w%c256val(isize) = "(nrho,ntrcat)"
        IF(ALLOCATED(ss%vmo_transcat)) THEN
           IF(ss%hash_codes(ps_phash_vmo_transcat).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! vn_trans
        w%list_elems(isize) = "vn_trans"
        w%elem_descr(isize) = "specie radial velocity"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "m/sec"
        w%c256val(isize) = "(nrho,0:nspec_th)"
        IF(ALLOCATED(ss%vn_trans)) THEN
           IF(ss%hash_codes(ps_phash_vn_trans).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! vn_transcat
        w%list_elems(isize) = "vn_transcat"
        w%elem_descr(isize) = "specie radial velocity"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "m/sec"
        w%c256val(isize) = "(nrho,0:nspec_th,ntrcat)"
        IF(ALLOCATED(ss%vn_transcat)) THEN
           IF(ss%hash_codes(ps_phash_vn_transcat).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! vol
        w%list_elems(isize) = "vol"
        w%elem_descr(isize) = "enclosed volume"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "m^3"
        w%c256val(isize) = "(nrho_eq)"
        IF(ALLOCATED(ss%vol)) THEN
           IF(ss%hash_codes(ps_phash_vol).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "SPLINE_00"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! vpol_inmp
        w%list_elems(isize) = "vpol_inmp"
        w%elem_descr(isize) = "poloidal velocity, inner half midplane"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "m/sec"
        w%c256val(isize) = "(nrho-1,0:nspec_th)"
        IF(ALLOCATED(ss%vpol_inmp)) THEN
           IF(ss%hash_codes(ps_phash_vpol_inmp).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*NS"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! vpol_omp
        w%list_elems(isize) = "vpol_omp"
        w%elem_descr(isize) = "poloidal velocity, outer half midplane"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "m/sec"
        w%c256val(isize) = "(nrho-1,0:nspec_th)"
        IF(ALLOCATED(ss%vpol_omp)) THEN
           IF(ss%hash_codes(ps_phash_vpol_omp).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*NS"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! vtor_inmp
        w%list_elems(isize) = "vtor_inmp"
        w%elem_descr(isize) = "toroidal velocity, inner half midplane"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "m/sec"
        w%c256val(isize) = "(nrho-1,0:nspec_th)"
        IF(ALLOCATED(ss%vtor_inmp)) THEN
           IF(ss%hash_codes(ps_phash_vtor_inmp).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*NS"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! vtor_omp
        w%list_elems(isize) = "vtor_omp"
        w%elem_descr(isize) = "toroidal velocity, outer half midplane"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "m/sec"
        w%c256val(isize) = "(nrho-1,0:nspec_th)"
        IF(ALLOCATED(ss%vtor_omp)) THEN
           IF(ss%hash_codes(ps_phash_vtor_omp).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*NS"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! V_loop
        w%list_elems(isize) = "V_loop"
        w%elem_descr(isize) = "loop voltage"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "Volts"
        w%c256val(isize) = "(nrho)"
        IF(ALLOCATED(ss%V_loop)) THEN
           IF(ss%hash_codes(ps_phash_V_loop).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! v_pars
        w%list_elems(isize) = "v_pars"
        w%elem_descr(isize) = "thermal specie <vpll>"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "m/sec"
        w%c256val(isize) = "(nrho-1,0:nspec_th)"
        IF(ALLOCATED(ss%v_pars)) THEN
           IF(ss%hash_codes(ps_phash_v_pars).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*NS"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! v_pers
        w%list_elems(isize) = "v_pers"
        w%elem_descr(isize) = "thermal specie <vper>"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "m/sec"
        w%c256val(isize) = "(nrho-1,0:nspec_th)"
        IF(ALLOCATED(ss%v_pers)) THEN
           IF(ss%hash_codes(ps_phash_v_pers).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*NS"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! xRjcos_momeq
        w%list_elems(isize) = "xRjcos_momeq"
        w%elem_descr(isize) = "scaled R cos moments"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "m"
        w%c256val(isize) = "(nrho_eq,neqmom)"
        IF(ALLOCATED(ss%xRjcos_momeq)) THEN
           IF(ss%hash_codes(ps_phash_xRjcos_momeq).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "HERMITE_EXPLICIT"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! xRjsin_momeq
        w%list_elems(isize) = "xRjsin_momeq"
        w%elem_descr(isize) = "scaled R sin moments"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "m"
        w%c256val(isize) = "(nrho_eq,neqmom)"
        IF(ALLOCATED(ss%xRjsin_momeq)) THEN
           IF(ss%hash_codes(ps_phash_xRjsin_momeq).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "HERMITE_EXPLICIT"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! xZjcos_momeq
        w%list_elems(isize) = "xZjcos_momeq"
        w%elem_descr(isize) = "scaled Z cos moments"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "m"
        w%c256val(isize) = "(nrho_eq,neqmom)"
        IF(ALLOCATED(ss%xZjcos_momeq)) THEN
           IF(ss%hash_codes(ps_phash_xZjcos_momeq).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "HERMITE_EXPLICIT"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! xZjsin_momeq
        w%list_elems(isize) = "xZjsin_momeq"
        w%elem_descr(isize) = "scaled Z sin moments"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "m"
        w%c256val(isize) = "(nrho_eq,neqmom)"
        IF(ALLOCATED(ss%xZjsin_momeq)) THEN
           IF(ss%hash_codes(ps_phash_xZjsin_momeq).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "HERMITE_EXPLICIT"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! Z0_momeq
        w%list_elems(isize) = "Z0_momeq"
        w%elem_descr(isize) = "Z0 of flux surface"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "m"
        w%c256val(isize) = "(nrho_eq)"
        IF(ALLOCATED(ss%Z0_momeq)) THEN
           IF(ss%hash_codes(ps_phash_Z0_momeq).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "HERMITE_EXPLICIT"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! Zeff
        w%list_elems(isize) = "Zeff"
        w%elem_descr(isize) = "Zeff (sum[nj*Zj**2]/ne)"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "-"
        w%c256val(isize) = "(nrho-1)"
        IF(ALLOCATED(ss%Zeff)) THEN
           IF(ss%hash_codes(ps_phash_Zeff).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*NS(:,PS_ELEC_INDEX)"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! Zeff_fi
        w%list_elems(isize) = "Zeff_fi"
        w%elem_descr(isize) = "Fast ion contribution to Zeff"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "-"
        w%c256val(isize) = "(nrho-1)"
        IF(ALLOCATED(ss%Zeff_fi)) THEN
           IF(ss%hash_codes(ps_phash_Zeff_fi).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*NS(:,PS_ELEC_INDEX)"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! Zeff_th
        w%list_elems(isize) = "Zeff_th"
        w%elem_descr(isize) = "Thermal ion contribution to Zeff"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "-"
        w%c256val(isize) = "(nrho-1)"
        IF(ALLOCATED(ss%Zeff_th)) THEN
           IF(ss%hash_codes(ps_phash_Zeff_th).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*NS(:,PS_ELEC_INDEX)"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! Z_geo
        w%list_elems(isize) = "Z_geo"
        w%elem_descr(isize) = "flux surfaces Z(rho,theta)"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "m"
        w%c256val(isize) = "(nrho_eq,nth_eq)"
        IF(ALLOCATED(ss%Z_geo)) THEN
           IF(ss%hash_codes(ps_phash_Z_geo).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "HERMITE_EXPLICIT"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! Z_midp
        w%list_elems(isize) = "Z_midp"
        w%elem_descr(isize) = "flux surface midplane elevation"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "m"
        w%c256val(isize) = "(nrho_eq_geo)"
        IF(ALLOCATED(ss%Z_midp)) THEN
           IF(ss%hash_codes(ps_phash_Z_midp).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! Z_surfMax
        w%list_elems(isize) = "Z_surfMax"
        w%elem_descr(isize) = "max Z on flux surface"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "m"
        w%c256val(isize) = "(nrho_eq_geo)"
        IF(ALLOCATED(ss%Z_surfMax)) THEN
           IF(ss%hash_codes(ps_phash_Z_surfMax).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! Z_surfMin
        w%list_elems(isize) = "Z_surfMin"
        w%elem_descr(isize) = "min Z on flux surface"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "m"
        w%c256val(isize) = "(nrho_eq_geo)"
        IF(ALLOCATED(ss%Z_surfMin)) THEN
           IF(ss%hash_codes(ps_phash_Z_surfMin).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF
END SUBROUTINE plasma_state_contents_profs_9

subroutine ccps_state_memory_update(iobj,ierr)

  ! update hash table and interpolation data associated with state

  use plasma_state_mod
  implicit NONE

  integer :: iobj(*)        ! (ps_container_size) words are used: state object
  integer,intent(out) :: ierr      ! exit status 0=OK

  !-------------------------
  type (plasma_state_container) :: ptr
  type (plasma_state), pointer :: ss
  !-------------------------

  call ccps_argcheck('ccps_state_memory_update',iobj,ierr)
  if(ierr.ne.0) return

  ! proceed...

  call load_ps_container(iobj,ptr)
  ss => ptr%ps_ptr

  call ps_state_memory_update(ierr, state=ss)

end subroutine ccps_state_memory_update

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_s3_dummy
     return
  end subroutine ccps_getset_s3_dummy

subroutine psget_sa_type(iobj, n1, data, ierr)
    !! SA specie types
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_sa_type', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % SA_type
end subroutine psget_sa_type


subroutine psset_sa_type(iobj, n1, data, ierr)
    !! SA specie types
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_sa_type', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % SA_type = data(1:n1)
end subroutine psset_sa_type


subroutine psgetrnk_sa_type(iobj, ndims, ierr)
    !! SA specie types
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_sa_type


subroutine psgetdim_sa_type(iobj, ndims, dims, ierr)
    !! SA specie types
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_sa_type', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % SA_type ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % SA_type)
    endif
end subroutine psgetdim_sa_type


subroutine psget_simp0_to_s(iobj, n1, data, ierr)
    !! map simp0 index to "s" list
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_simp0_to_s', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % simp0_to_s
end subroutine psget_simp0_to_s


subroutine psset_simp0_to_s(iobj, n1, data, ierr)
    !! map simp0 index to "s" list
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_simp0_to_s', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % simp0_to_s = data(1:n1)
end subroutine psset_simp0_to_s


subroutine psgetrnk_simp0_to_s(iobj, ndims, ierr)
    !! map simp0 index to "s" list
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_simp0_to_s


subroutine psgetdim_simp0_to_s(iobj, ndims, dims, ierr)
    !! map simp0 index to "s" list
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_simp0_to_s', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % simp0_to_s ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % simp0_to_s)
    endif
end subroutine psgetdim_simp0_to_s


subroutine psget_sn_trans(iobj, n1, n2, data, ierr)
    !! particle transport (loss), electrons & thermal ion species
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_sn_trans', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % sn_trans
end subroutine psget_sn_trans


subroutine psset_sn_trans(iobj, n1, n2, data, ierr)
    !! particle transport (loss), electrons & thermal ion species
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_sn_trans', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % sn_trans = data(1:n1, 1: n2)
end subroutine psset_sn_trans


subroutine psgetrnk_sn_trans(iobj, ndims, ierr)
    !! particle transport (loss), electrons & thermal ion species
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_sn_trans


subroutine psgetdim_sn_trans(iobj, ndims, dims, ierr)
    !! particle transport (loss), electrons & thermal ion species
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_sn_trans', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % sn_trans ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % sn_trans)
    endif
end subroutine psgetdim_sn_trans


subroutine psget_sftherm(iobj, n1, n2, data, ierr)
    !! fusion ion thermalization
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_sftherm', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % sftherm
end subroutine psget_sftherm


subroutine psset_sftherm(iobj, n1, n2, data, ierr)
    !! fusion ion thermalization
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_sftherm', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % sftherm = data(1:n1, 1: n2)
end subroutine psset_sftherm


subroutine psgetrnk_sftherm(iobj, ndims, ierr)
    !! fusion ion thermalization
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_sftherm


subroutine psgetdim_sftherm(iobj, ndims, dims, ierr)
    !! fusion ion thermalization
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_sftherm', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % sftherm ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % sftherm)
    endif
end subroutine psgetdim_sftherm

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


LOGICAL FUNCTION plasma_state_hash_match(ss,iaddr,ierr)

  ! return .TRUE. if hash codes match, implying no change in data
  ! this routine assumes hash codes are up-to-date:
  ! ...CALL plasma_hash_state_update(ss,ierr) first!!!

  USE plasma_state_definition_mod
  IMPLICIT NONE

  TYPE (plasma_state) :: ss       ! state data to check
  INTEGER, INTENT(IN) :: iaddr    ! address of hash codes to check
  INTEGER, INTENT(OUT) :: ierr    ! completion code (0=OK)

  ! non-zero ierr value indicates iaddr out of range

  !-------------------
  INTEGER :: iout
  !-------------------

  ierr = 0
  plasma_state_hash_match = .FALSE.

  iout = SWIM_err_out_file

  IF((iaddr.LE.0).or.(iaddr.GE.ps_hash_total)) THEN
     WRITE(iout,*) ' ?plasma_state_hash_match: iaddr out of expected range.'
     WRITE(iout,*) '  iaddr = ',iaddr,'; expected range: 1 to ',ps_hash_total-1
     ierr=9999
     RETURN
  ENDIF

  plasma_state_hash_match =(ss%hash_codes(iaddr).eq.ss%new_hash_codes(iaddr)) &
                   .AND.(ss%hash_codes(iaddr+1).eq.ss%new_hash_codes(iaddr+1))

END FUNCTION plasma_state_hash_match

SUBROUTINE plasma_state_hash_mark(ss,iaddr,ierr)

  ! mark indicated item as up-to-date, by copying its hash codes

  USE plasma_state_definition_mod
  IMPLICIT NONE

  TYPE (plasma_state) :: ss       ! state data to check
  INTEGER, INTENT(IN) :: iaddr    ! address of hash codes to check
  INTEGER, INTENT(OUT) :: ierr    ! completion code (0=OK)

  ! non-zero ierr value indicates iaddr out of range

  !-------------------
  INTEGER :: iout
  !-------------------

  ierr = 0
  iout = SWIM_err_out_file

  IF((iaddr.LE.0).or.(iaddr.GE.ps_hash_total)) THEN
     WRITE(iout,*) ' ?plasma_state_hash_mark: iaddr out of expected range.'
     WRITE(iout,*) '  iaddr = ',iaddr,'; expected range: 1 to ',ps_hash_total-1
     ierr=9999
     RETURN
  ENDIF

  ss%hash_codes(iaddr) = ss%new_hash_codes(iaddr)
  ss%hash_codes(iaddr+1) = ss%new_hash_codes(iaddr+1)

END SUBROUTINE plasma_state_hash_mark

SUBROUTINE plasma_state_hash_addr(htype,hname,iaddr)

  ! return base hash address for named entity of indicated type
  !   iaddr -- base; iaddr+1 -- 2ndary hash address

  ! (at present this routine does not know about component-specific
  ! section hash codes)

  USE plasma_state_definition_mod
  IMPLICIT NONE

  ! character string inputs are copied into local variables (C*32)
  ! which are converted to uppercase

  CHARACTER*(*), INTENT(IN) :: htype  ! hash entity type:
  !                             "SECTION" or "DIMENSION" or "PROFILE"

  CHARACTER*(*), INTENT(IN) :: hname  ! hash entity name:
  !                      example for "SECTION":  "MACHINE_DESCRIPTION"
  !                      example for "DIMENSION":  "RHO_EQ"
  !                      example for "PROFILE":  "TS"

  INTEGER, INTENT(OUT) :: iaddr       ! base hash address
  !  0 is returned & warning issued if htype & name do not map to a known
  !  quantity

  !----------------------------------
  CHARACTER*32 :: htypu,hnamu
  INTEGER :: iout
  !----------------------------------

  iout = SWIM_err_out_file

  !  fold input arguments to upper case

  htypu = htype
  hnamu = hname

  call uupper(htypu)
  call uupper(hnamu)

  iaddr = 0

  !--------------------------------------------
  ! section hash codes

  IF((htypu.EQ."SECTION").AND.(hnamu.EQ."MACHINE_DESCRIPTION")) THEN
     iaddr = ps_shash_machine_description
     RETURN
  ENDIF

  IF((htypu.EQ."SECTION").AND.(hnamu.EQ."SHOT_CONFIGURATION")) THEN
     iaddr = ps_shash_shot_configuration
     RETURN
  ENDIF

  IF((htypu.EQ."SECTION").AND.(hnamu.EQ."SIMULATION_INIT")) THEN
     iaddr = ps_shash_simulation_init
     RETURN
  ENDIF

  IF((htypu.EQ."SECTION").AND.(hnamu.EQ."STATE_DATA")) THEN
     iaddr = ps_shash_state_data
     RETURN
  ENDIF

  IF((htypu.EQ."SECTION").AND.(hnamu.EQ."STATE_PROFILES")) THEN
     iaddr = ps_shash_state_profiles
     RETURN
  ENDIF

  !--------------------------------------------
  ! dimension hash codes

  IF((htypu.EQ."DIMENSION").AND.(hnamu.EQ."MAX_NRZ_ANTGEO")) THEN
     iaddr = ps_dhash_max_nrz_antgeo
     RETURN
  ENDIF

  IF((htypu.EQ."DIMENSION").AND.(hnamu.EQ."MAX_NSPECTRUMLH_SRC")) THEN
     iaddr = ps_dhash_max_nspectrumlh_src
     RETURN
  ENDIF

  IF((htypu.EQ."DIMENSION").AND.(hnamu.EQ."MAX_NUM_NPHI")) THEN
     iaddr = ps_dhash_max_num_nphi
     RETURN
  ENDIF

  IF((htypu.EQ."DIMENSION").AND.(hnamu.EQ."MAX_NUM_NPHI_VAC")) THEN
     iaddr = ps_dhash_max_num_nphi_vac
     RETURN
  ENDIF

  IF((htypu.EQ."DIMENSION").AND.(hnamu.EQ."MAX_N_STRAPS")) THEN
     iaddr = ps_dhash_max_n_straps
     RETURN
  ENDIF

  IF((htypu.EQ."DIMENSION").AND.(hnamu.EQ."MMODES")) THEN
     iaddr = ps_dhash_mmodes
     RETURN
  ENDIF

  IF((htypu.EQ."DIMENSION").AND.(hnamu.EQ."NBALLOON")) THEN
     iaddr = ps_dhash_nballoon
     RETURN
  ENDIF

  IF((htypu.EQ."DIMENSION").AND.(hnamu.EQ."NBEAM")) THEN
     iaddr = ps_dhash_nbeam
     RETURN
  ENDIF

  IF((htypu.EQ."DIMENSION").AND.(hnamu.EQ."NCIRCUITS")) THEN
     iaddr = ps_dhash_ncircuits
     RETURN
  ENDIF

  IF((htypu.EQ."DIMENSION").AND.(hnamu.EQ."NCOILS")) THEN
     iaddr = ps_dhash_ncoils
     RETURN
  ENDIF

  IF((htypu.EQ."DIMENSION").AND.(hnamu.EQ."NDELTA_W")) THEN
     iaddr = ps_dhash_ndelta_w
     RETURN
  ENDIF

  IF((htypu.EQ."DIMENSION").AND.(hnamu.EQ."NECRF_SRC")) THEN
     iaddr = ps_dhash_necrf_src
     RETURN
  ENDIF

  IF((htypu.EQ."DIMENSION").AND.(hnamu.EQ."NEFI_ANOM")) THEN
     iaddr = ps_dhash_nefi_anom
     RETURN
  ENDIF

  IF((htypu.EQ."DIMENSION").AND.(hnamu.EQ."NEFI_ANOM2")) THEN
     iaddr = ps_dhash_nefi_anom2
     RETURN
  ENDIF

  IF((htypu.EQ."DIMENSION").AND.(hnamu.EQ."NEQMOM")) THEN
     iaddr = ps_dhash_neqmom
     RETURN
  ENDIF

  IF((htypu.EQ."DIMENSION").AND.(hnamu.EQ."NGSC0")) THEN
     iaddr = ps_dhash_ngsc0
     RETURN
  ENDIF

  IF((htypu.EQ."DIMENSION").AND.(hnamu.EQ."NICRF_SRC")) THEN
     iaddr = ps_dhash_nicrf_src
     RETURN
  ENDIF

  IF((htypu.EQ."DIMENSION").AND.(hnamu.EQ."NKY_ANOMTH")) THEN
     iaddr = ps_dhash_nky_anomth
     RETURN
  ENDIF

  IF((htypu.EQ."DIMENSION").AND.(hnamu.EQ."NKY_MMM")) THEN
     iaddr = ps_dhash_nky_mmm
     RETURN
  ENDIF

  IF((htypu.EQ."DIMENSION").AND.(hnamu.EQ."NLHRF_SRC")) THEN
     iaddr = ps_dhash_nlhrf_src
     RETURN
  ENDIF

  IF((htypu.EQ."DIMENSION").AND.(hnamu.EQ."NNEWCOMB")) THEN
     iaddr = ps_dhash_nnewcomb
     RETURN
  ENDIF

  IF((htypu.EQ."DIMENSION").AND.(hnamu.EQ."NPSMOM")) THEN
     iaddr = ps_dhash_npsmom
     RETURN
  ENDIF

  IF((htypu.EQ."DIMENSION").AND.(hnamu.EQ."NR")) THEN
     iaddr = ps_dhash_nr
     RETURN
  ENDIF

  IF((htypu.EQ."DIMENSION").AND.(hnamu.EQ."NRHO")) THEN
     iaddr = ps_dhash_nrho
     RETURN
  ENDIF

  IF((htypu.EQ."DIMENSION").AND.(hnamu.EQ."NRHO_ANOM")) THEN
     iaddr = ps_dhash_nrho_anom
     RETURN
  ENDIF

  IF((htypu.EQ."DIMENSION").AND.(hnamu.EQ."NRHO_ANOM2")) THEN
     iaddr = ps_dhash_nrho_anom2
     RETURN
  ENDIF

  IF((htypu.EQ."DIMENSION").AND.(hnamu.EQ."NRHO_ANOMTH")) THEN
     iaddr = ps_dhash_nrho_anomth
     RETURN
  ENDIF

  IF((htypu.EQ."DIMENSION").AND.(hnamu.EQ."NRHO_ECRF")) THEN
     iaddr = ps_dhash_nrho_ecrf
     RETURN
  ENDIF

  IF((htypu.EQ."DIMENSION").AND.(hnamu.EQ."NRHO_EQ")) THEN
     iaddr = ps_dhash_nrho_eq
     RETURN
  ENDIF

  IF((htypu.EQ."DIMENSION").AND.(hnamu.EQ."NRHO_EQ_GEO")) THEN
     iaddr = ps_dhash_nrho_eq_geo
     RETURN
  ENDIF

  IF((htypu.EQ."DIMENSION").AND.(hnamu.EQ."NRHO_FUS")) THEN
     iaddr = ps_dhash_nrho_fus
     RETURN
  ENDIF

  IF((htypu.EQ."DIMENSION").AND.(hnamu.EQ."NRHO_GAS")) THEN
     iaddr = ps_dhash_nrho_gas
     RETURN
  ENDIF

  IF((htypu.EQ."DIMENSION").AND.(hnamu.EQ."NRHO_ICRF")) THEN
     iaddr = ps_dhash_nrho_icrf
     RETURN
  ENDIF

  IF((htypu.EQ."DIMENSION").AND.(hnamu.EQ."NRHO_LHRF")) THEN
     iaddr = ps_dhash_nrho_lhrf
     RETURN
  ENDIF

  IF((htypu.EQ."DIMENSION").AND.(hnamu.EQ."NRHO_LMHD")) THEN
     iaddr = ps_dhash_nrho_lmhd
     RETURN
  ENDIF

  IF((htypu.EQ."DIMENSION").AND.(hnamu.EQ."NRHO_MIST")) THEN
     iaddr = ps_dhash_nrho_mist
     RETURN
  ENDIF

  IF((htypu.EQ."DIMENSION").AND.(hnamu.EQ."NRHO_NBI")) THEN
     iaddr = ps_dhash_nrho_nbi
     RETURN
  ENDIF

  IF((htypu.EQ."DIMENSION").AND.(hnamu.EQ."NRHO_PEL")) THEN
     iaddr = ps_dhash_nrho_pel
     RETURN
  ENDIF

  IF((htypu.EQ."DIMENSION").AND.(hnamu.EQ."NRHO_RAD")) THEN
     iaddr = ps_dhash_nrho_rad
     RETURN
  ENDIF

  IF((htypu.EQ."DIMENSION").AND.(hnamu.EQ."NRHO_RW")) THEN
     iaddr = ps_dhash_nrho_rw
     RETURN
  ENDIF

  IF((htypu.EQ."DIMENSION").AND.(hnamu.EQ."NR_RIP")) THEN
     iaddr = ps_dhash_nr_rip
     RETURN
  ENDIF

  IF((htypu.EQ."DIMENSION").AND.(hnamu.EQ."NSPEC_ALL")) THEN
     iaddr = ps_dhash_nspec_all
     RETURN
  ENDIF

  IF((htypu.EQ."DIMENSION").AND.(hnamu.EQ."NSPEC_ALLA")) THEN
     iaddr = ps_dhash_nspec_alla
     RETURN
  ENDIF

  IF((htypu.EQ."DIMENSION").AND.(hnamu.EQ."NSPEC_BEAM")) THEN
     iaddr = ps_dhash_nspec_beam
     RETURN
  ENDIF

  IF((htypu.EQ."DIMENSION").AND.(hnamu.EQ."NSPEC_FUSION")) THEN
     iaddr = ps_dhash_nspec_fusion
     RETURN
  ENDIF

  IF((htypu.EQ."DIMENSION").AND.(hnamu.EQ."NSPEC_GAS")) THEN
     iaddr = ps_dhash_nspec_gas
     RETURN
  ENDIF

  IF((htypu.EQ."DIMENSION").AND.(hnamu.EQ."NSPEC_IMP0")) THEN
     iaddr = ps_dhash_nspec_imp0
     RETURN
  ENDIF

  IF((htypu.EQ."DIMENSION").AND.(hnamu.EQ."NSPEC_IMPI")) THEN
     iaddr = ps_dhash_nspec_impi
     RETURN
  ENDIF

  IF((htypu.EQ."DIMENSION").AND.(hnamu.EQ."NSPEC_RFMIN")) THEN
     iaddr = ps_dhash_nspec_rfmin
     RETURN
  ENDIF

  IF((htypu.EQ."DIMENSION").AND.(hnamu.EQ."NSPEC_TH")) THEN
     iaddr = ps_dhash_nspec_th
     RETURN
  ENDIF

  IF((htypu.EQ."DIMENSION").AND.(hnamu.EQ."NSPEC_THA")) THEN
     iaddr = ps_dhash_nspec_tha
     RETURN
  ENDIF

  IF((htypu.EQ."DIMENSION").AND.(hnamu.EQ."NTH_EQ")) THEN
     iaddr = ps_dhash_nth_eq
     RETURN
  ENDIF

  IF((htypu.EQ."DIMENSION").AND.(hnamu.EQ."NTRCAT")) THEN
     iaddr = ps_dhash_ntrcat
     RETURN
  ENDIF

  IF((htypu.EQ."DIMENSION").AND.(hnamu.EQ."NUM_RZLIM")) THEN
     iaddr = ps_dhash_num_rzlim
     RETURN
  ENDIF

  IF((htypu.EQ."DIMENSION").AND.(hnamu.EQ."NXS")) THEN
     iaddr = ps_dhash_nxs
     RETURN
  ENDIF

  IF((htypu.EQ."DIMENSION").AND.(hnamu.EQ."NZ")) THEN
     iaddr = ps_dhash_nz
     RETURN
  ENDIF

  IF((htypu.EQ."DIMENSION").AND.(hnamu.EQ."NZ_RIP")) THEN
     iaddr = ps_dhash_nz_rip
     RETURN
  ENDIF

  IF((htypu.EQ."DIMENSION").AND.(hnamu.EQ."N_D_EINJ_STANDARD")) THEN
     iaddr = ps_dhash_n_d_einj_standard
     RETURN
  ENDIF

  IF((htypu.EQ."DIMENSION").AND.(hnamu.EQ."N_H_EINJ_STANDARD")) THEN
     iaddr = ps_dhash_n_h_einj_standard
     RETURN
  ENDIF

  IF((htypu.EQ."DIMENSION").AND.(hnamu.EQ."N_T_EINJ_STANDARD")) THEN
     iaddr = ps_dhash_n_t_einj_standard
     RETURN
  ENDIF

  !--------------------------------------------
  ! profile hash codes

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."ANOM_EVAR")) THEN
     iaddr = ps_phash_anom_evar
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."AREA")) THEN
     iaddr = ps_phash_area
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."BALSTAB")) THEN
     iaddr = ps_phash_balstab
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."BIDIFF_BPASS_CO")) THEN
     iaddr = ps_phash_bidiff_bpass_co
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."BIDIFF_BPASS_CTR")) THEN
     iaddr = ps_phash_bidiff_bpass_ctr
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."BIDIFF_BTRAP")) THEN
     iaddr = ps_phash_bidiff_btrap
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."BIDIFF_DPASS_CO")) THEN
     iaddr = ps_phash_bidiff_dpass_co
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."BIDIFF_DPASS_CTR")) THEN
     iaddr = ps_phash_bidiff_dpass_ctr
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."BIDIFF_DTRAP")) THEN
     iaddr = ps_phash_bidiff_dtrap
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."BPHIRZ")) THEN
     iaddr = ps_phash_bphirz
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."BRRZ")) THEN
     iaddr = ps_phash_brrz
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."BZRZ")) THEN
     iaddr = ps_phash_bzrz
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."B_SURFMAX")) THEN
     iaddr = ps_phash_b_surfmax
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."B_SURFMIN")) THEN
     iaddr = ps_phash_b_surfmin
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."CDICRF")) THEN
     iaddr = ps_phash_cdicrf
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."CDICRF_NPHI")) THEN
     iaddr = ps_phash_cdicrf_nphi
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."CHIE_ANOM")) THEN
     iaddr = ps_phash_chie_anom
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."CHIE_DRBM")) THEN
     iaddr = ps_phash_chie_drbm
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."CHIE_ETG")) THEN
     iaddr = ps_phash_chie_etg
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."CHIE_GLF")) THEN
     iaddr = ps_phash_chie_glf
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."CHIE_GTCNEO")) THEN
     iaddr = ps_phash_chie_gtcneo
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."CHIE_MMM71")) THEN
     iaddr = ps_phash_chie_mmm71
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."CHIE_MTM")) THEN
     iaddr = ps_phash_chie_mtm
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."CHIE_NCLASS")) THEN
     iaddr = ps_phash_chie_nclass
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."CHIE_NEO")) THEN
     iaddr = ps_phash_chie_neo
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."CHIE_NTM")) THEN
     iaddr = ps_phash_chie_ntm
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."CHIE_PALEO")) THEN
     iaddr = ps_phash_chie_paleo
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."CHIE_TGLF")) THEN
     iaddr = ps_phash_chie_tglf
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."CHIE_TRANS")) THEN
     iaddr = ps_phash_chie_trans
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."CHIE_TRANSCAT")) THEN
     iaddr = ps_phash_chie_transcat
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."CHIE_W19")) THEN
     iaddr = ps_phash_chie_w19
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."CHII_ANOM")) THEN
     iaddr = ps_phash_chii_anom
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."CHII_DRBM")) THEN
     iaddr = ps_phash_chii_drbm
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."CHII_GLF")) THEN
     iaddr = ps_phash_chii_glf
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."CHII_GTCNEO")) THEN
     iaddr = ps_phash_chii_gtcneo
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."CHII_MMM71")) THEN
     iaddr = ps_phash_chii_mmm71
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."CHII_NCLASS")) THEN
     iaddr = ps_phash_chii_nclass
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."CHII_NEO")) THEN
     iaddr = ps_phash_chii_neo
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."CHII_NTM")) THEN
     iaddr = ps_phash_chii_ntm
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."CHII_TGLF")) THEN
     iaddr = ps_phash_chii_tglf
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."CHII_TRANS")) THEN
     iaddr = ps_phash_chii_trans
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."CHII_TRANSCAT")) THEN
     iaddr = ps_phash_chii_transcat
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."CHII_W19")) THEN
     iaddr = ps_phash_chii_w19
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."CHIMO_TRANS")) THEN
     iaddr = ps_phash_chimo_trans
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."CHIMO_TRANSCAT")) THEN
     iaddr = ps_phash_chimo_transcat
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."CHIPHI_ANOM")) THEN
     iaddr = ps_phash_chiphi_anom
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."CHIPHI_DRBM")) THEN
     iaddr = ps_phash_chiphi_drbm
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."CHIPHI_GLF")) THEN
     iaddr = ps_phash_chiphi_glf
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."CHIPHI_GTCNEO")) THEN
     iaddr = ps_phash_chiphi_gtcneo
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."CHIPHI_MMM71")) THEN
     iaddr = ps_phash_chiphi_mmm71
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."CHIPHI_NEO")) THEN
     iaddr = ps_phash_chiphi_neo
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."CHIPHI_TGLF")) THEN
     iaddr = ps_phash_chiphi_tglf
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."CHIPHI_W19")) THEN
     iaddr = ps_phash_chiphi_w19
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."CHITHETA_MMM71")) THEN
     iaddr = ps_phash_chitheta_mmm71
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."CURBEAM")) THEN
     iaddr = ps_phash_curbeam
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."CURECH")) THEN
     iaddr = ps_phash_curech
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."CURECH_SRC")) THEN
     iaddr = ps_phash_curech_src
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."CURFUSN")) THEN
     iaddr = ps_phash_curfusn
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."CURICH")) THEN
     iaddr = ps_phash_curich
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."CURLH")) THEN
     iaddr = ps_phash_curlh
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."CURLH_SRC")) THEN
     iaddr = ps_phash_curlh_src
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."CURMINO")) THEN
     iaddr = ps_phash_curmino
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."CURR_BOOTSTRAP")) THEN
     iaddr = ps_phash_curr_bootstrap
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."CURR_OHMIC")) THEN
     iaddr = ps_phash_curr_ohmic
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."CURT")) THEN
     iaddr = ps_phash_curt
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."CUR_RW")) THEN
     iaddr = ps_phash_cur_rw
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."D2R_GEO_DRHODTH")) THEN
     iaddr = ps_phash_d2r_geo_drhodth
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."D2Z_GEO_DRHODTH")) THEN
     iaddr = ps_phash_d2z_geo_drhodth
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."DB_MTM")) THEN
     iaddr = ps_phash_db_mtm
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."DCUR_RW_DVLOOP")) THEN
     iaddr = ps_phash_dcur_rw_dvloop
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."DIFB_FUSI")) THEN
     iaddr = ps_phash_difb_fusi
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."DIFB_NBI")) THEN
     iaddr = ps_phash_difb_nbi
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."DIFB_RFMI")) THEN
     iaddr = ps_phash_difb_rfmi
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."DIFF_TRANS")) THEN
     iaddr = ps_phash_diff_trans
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."DIFF_TRANSCAT")) THEN
     iaddr = ps_phash_diff_transcat
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."DIFNE_NCLASS")) THEN
     iaddr = ps_phash_difne_nclass
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."DIFNH_NCLASS")) THEN
     iaddr = ps_phash_difnh_nclass
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."DIFNS_ANOM")) THEN
     iaddr = ps_phash_difns_anom
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."DIFNS_DRBM")) THEN
     iaddr = ps_phash_difns_drbm
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."DIFNS_GLF")) THEN
     iaddr = ps_phash_difns_glf
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."DIFNS_GTCNEO")) THEN
     iaddr = ps_phash_difns_gtcneo
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."DIFNS_MMM71")) THEN
     iaddr = ps_phash_difns_mmm71
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."DIFNS_NCLASS")) THEN
     iaddr = ps_phash_difns_nclass
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."DIFNS_NEO")) THEN
     iaddr = ps_phash_difns_neo
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."DIFNS_TGLF")) THEN
     iaddr = ps_phash_difns_tglf
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."DIFNS_W19")) THEN
     iaddr = ps_phash_difns_w19
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."DIFNX_NCLASS")) THEN
     iaddr = ps_phash_difnx_nclass
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."DIFNZ_MMM71")) THEN
     iaddr = ps_phash_difnz_mmm71
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."DQEDGRDTE_TGLF")) THEN
     iaddr = ps_phash_dqedgrdte_tglf
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."DQEDGRDTI_TGLF")) THEN
     iaddr = ps_phash_dqedgrdti_tglf
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."DQIDGRDTE_TGLF")) THEN
     iaddr = ps_phash_dqidgrdte_tglf
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."DQIDGRDTI_TGLF")) THEN
     iaddr = ps_phash_dqidgrdti_tglf
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."DR0_MOMEQ_DRHO")) THEN
     iaddr = ps_phash_dr0_momeq_drho
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."DR_GEO_DRHO")) THEN
     iaddr = ps_phash_dr_geo_drho
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."DR_GEO_DTH")) THEN
     iaddr = ps_phash_dr_geo_dth
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."DXRJCOS_MOMEQ_DRHO")) THEN
     iaddr = ps_phash_dxrjcos_momeq_drho
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."DXRJSIN_MOMEQ_DRHO")) THEN
     iaddr = ps_phash_dxrjsin_momeq_drho
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."DXZJCOS_MOMEQ_DRHO")) THEN
     iaddr = ps_phash_dxzjcos_momeq_drho
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."DXZJSIN_MOMEQ_DRHO")) THEN
     iaddr = ps_phash_dxzjsin_momeq_drho
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."DZ0_MOMEQ_DRHO")) THEN
     iaddr = ps_phash_dz0_momeq_drho
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."DZ_GEO_DRHO")) THEN
     iaddr = ps_phash_dz_geo_drho
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."DZ_GEO_DTH")) THEN
     iaddr = ps_phash_dz_geo_dth
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."EE_MOBILITY_FACTOR")) THEN
     iaddr = ps_phash_ee_mobility_factor
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."ELONG")) THEN
     iaddr = ps_phash_elong
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."EPERP_BEAMI")) THEN
     iaddr = ps_phash_eperp_beami
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."EPERP_FUSI")) THEN
     iaddr = ps_phash_eperp_fusi
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."EPERP_MINI")) THEN
     iaddr = ps_phash_eperp_mini
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."EPERP_RW")) THEN
     iaddr = ps_phash_eperp_rw
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."EPLL_BEAMI")) THEN
     iaddr = ps_phash_epll_beami
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."EPLL_FUSI")) THEN
     iaddr = ps_phash_epll_fusi
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."EPLL_MINI")) THEN
     iaddr = ps_phash_epll_mini
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."EPLL_RW")) THEN
     iaddr = ps_phash_epll_rw
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."EPOT")) THEN
     iaddr = ps_phash_epot
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."ETA_PARALLEL")) THEN
     iaddr = ps_phash_eta_parallel
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."FIDIFF_BPASS_CO")) THEN
     iaddr = ps_phash_fidiff_bpass_co
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."FIDIFF_BPASS_CTR")) THEN
     iaddr = ps_phash_fidiff_bpass_ctr
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."FIDIFF_BTRAP")) THEN
     iaddr = ps_phash_fidiff_btrap
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."FIDIFF_DPASS_CO")) THEN
     iaddr = ps_phash_fidiff_dpass_co
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."FIDIFF_DPASS_CTR")) THEN
     iaddr = ps_phash_fidiff_dpass_ctr
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."FIDIFF_DTRAP")) THEN
     iaddr = ps_phash_fidiff_dtrap
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."FI_DEPLETION")) THEN
     iaddr = ps_phash_fi_depletion
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."FREQ_DRBM")) THEN
     iaddr = ps_phash_freq_drbm
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."FREQ_GLF")) THEN
     iaddr = ps_phash_freq_glf
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."FREQ_MAX_TGLF")) THEN
     iaddr = ps_phash_freq_max_tglf
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."FREQ_MMM71")) THEN
     iaddr = ps_phash_freq_mmm71
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."FREQ_MTM")) THEN
     iaddr = ps_phash_freq_mtm
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."FREQ_TGLF")) THEN
     iaddr = ps_phash_freq_tglf
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."GAMMA_NC")) THEN
     iaddr = ps_phash_gamma_nc
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."GB1")) THEN
     iaddr = ps_phash_gb1
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."GB2")) THEN
     iaddr = ps_phash_gb2
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."GB2I")) THEN
     iaddr = ps_phash_gb2i
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."GBR2")) THEN
     iaddr = ps_phash_gbr2
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."GNCFB2H")) THEN
     iaddr = ps_phash_gncfb2h
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."GNCFH")) THEN
     iaddr = ps_phash_gncfh
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."GR1")) THEN
     iaddr = ps_phash_gr1
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."GR2")) THEN
     iaddr = ps_phash_gr2
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."GR2I")) THEN
     iaddr = ps_phash_gr2i
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."GR2RHO2")) THEN
     iaddr = ps_phash_gr2rho2
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."GR3I")) THEN
     iaddr = ps_phash_gr3i
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."GRHO1")) THEN
     iaddr = ps_phash_grho1
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."GRHO2")) THEN
     iaddr = ps_phash_grho2
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."GRHO2B2I")) THEN
     iaddr = ps_phash_grho2b2i
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."GRHO2R2I")) THEN
     iaddr = ps_phash_grho2r2i
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."GRHO2R3I")) THEN
     iaddr = ps_phash_grho2r3i
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."GRI")) THEN
     iaddr = ps_phash_gri
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."GRIRHOI")) THEN
     iaddr = ps_phash_grirhoi
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."GROWTHRATE_DRBM")) THEN
     iaddr = ps_phash_growthrate_drbm
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."GROWTHRATE_GLF")) THEN
     iaddr = ps_phash_growthrate_glf
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."GROWTHRATE_MAX_TGLF")) THEN
     iaddr = ps_phash_growthrate_max_tglf
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."GROWTHRATE_MMM71")) THEN
     iaddr = ps_phash_growthrate_mmm71
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."GROWTHRATE_MTM")) THEN
     iaddr = ps_phash_growthrate_mtm
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."GROWTHRATE_TGLF")) THEN
     iaddr = ps_phash_growthrate_tglf
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."GROWTHRATE_VPAR")) THEN
     iaddr = ps_phash_growthrate_vpar
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."G_EQ")) THEN
     iaddr = ps_phash_g_eq
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."IOTA")) THEN
     iaddr = ps_phash_iota
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."JDOTB")) THEN
     iaddr = ps_phash_jdotb
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."KYRHOS_MTM")) THEN
     iaddr = ps_phash_kyrhos_mtm
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."KYSPECTRUM_TGLF")) THEN
     iaddr = ps_phash_kyspectrum_tglf
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."LPOL")) THEN
     iaddr = ps_phash_lpol
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."N0NORM")) THEN
     iaddr = ps_phash_n0norm
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."N0_HALO")) THEN
     iaddr = ps_phash_n0_halo
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."N0_RECO")) THEN
     iaddr = ps_phash_n0_reco
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."NBEAMI")) THEN
     iaddr = ps_phash_nbeami
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."NEFLUX_KY_TGLF")) THEN
     iaddr = ps_phash_neflux_ky_tglf
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."NE_KY_TGLF")) THEN
     iaddr = ps_phash_ne_ky_tglf
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."NFUSI")) THEN
     iaddr = ps_phash_nfusi
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."NGRADB2_AV")) THEN
     iaddr = ps_phash_ngradb2_av
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."NI")) THEN
     iaddr = ps_phash_ni
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."NIFLUX_KY_TGLF")) THEN
     iaddr = ps_phash_niflux_ky_tglf
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."NI_KY_TGLF")) THEN
     iaddr = ps_phash_ni_ky_tglf
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."NMINI")) THEN
     iaddr = ps_phash_nmini
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."NMODEL")) THEN
     iaddr = ps_phash_nmodel
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."NRW")) THEN
     iaddr = ps_phash_nrw
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."NS")) THEN
     iaddr = ps_phash_ns
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."NZFLUX_KY_TGLF")) THEN
     iaddr = ps_phash_nzflux_ky_tglf
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."NZ_KY_TGLF")) THEN
     iaddr = ps_phash_nz_ky_tglf
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."OMEG0CX")) THEN
     iaddr = ps_phash_omeg0cx
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."OMEG0SC0")) THEN
     iaddr = ps_phash_omeg0sc0
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."OMEG0_HALO")) THEN
     iaddr = ps_phash_omeg0_halo
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."OMEG0_RECO")) THEN
     iaddr = ps_phash_omeg0_reco
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."OMEGAT")) THEN
     iaddr = ps_phash_omegat
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."OMEGA_EXB")) THEN
     iaddr = ps_phash_omega_exb
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."P0_RECO")) THEN
     iaddr = ps_phash_p0_reco
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."PB0_HALO")) THEN
     iaddr = ps_phash_pb0_halo
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."PBE")) THEN
     iaddr = ps_phash_pbe
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."PBI")) THEN
     iaddr = ps_phash_pbi
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."PBTH")) THEN
     iaddr = ps_phash_pbth
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."PCX_HALO")) THEN
     iaddr = ps_phash_pcx_halo
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."PCX_RECO")) THEN
     iaddr = ps_phash_pcx_reco
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."PEECH")) THEN
     iaddr = ps_phash_peech
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."PEECH_SRC")) THEN
     iaddr = ps_phash_peech_src
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."PELH")) THEN
     iaddr = ps_phash_pelh
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."PELH_SRC")) THEN
     iaddr = ps_phash_pelh_src
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."PE_ANOM")) THEN
     iaddr = ps_phash_pe_anom
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."PE_TRANS")) THEN
     iaddr = ps_phash_pe_trans
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."PE_TRANSCAT")) THEN
     iaddr = ps_phash_pe_transcat
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."PFUSE")) THEN
     iaddr = ps_phash_pfuse
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."PFUSI")) THEN
     iaddr = ps_phash_pfusi
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."PFUSTH")) THEN
     iaddr = ps_phash_pfusth
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."PHIFLUX_KY_TGLF")) THEN
     iaddr = ps_phash_phiflux_ky_tglf
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."PHIT")) THEN
     iaddr = ps_phash_phit
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."PICRF_NPHI_SRCS")) THEN
     iaddr = ps_phash_picrf_nphi_srcs
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."PICRF_SRCS")) THEN
     iaddr = ps_phash_picrf_srcs
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."PICRF_TOTALS")) THEN
     iaddr = ps_phash_picrf_totals
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."PICTH")) THEN
     iaddr = ps_phash_picth
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."PILH")) THEN
     iaddr = ps_phash_pilh
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."PILH_SRC")) THEN
     iaddr = ps_phash_pilh_src
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."PI_ANOM")) THEN
     iaddr = ps_phash_pi_anom
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."PI_TRANS")) THEN
     iaddr = ps_phash_pi_trans
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."PI_TRANSCAT")) THEN
     iaddr = ps_phash_pi_transcat
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."PMINE")) THEN
     iaddr = ps_phash_pmine
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."PMINI")) THEN
     iaddr = ps_phash_pmini
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."PMINTH")) THEN
     iaddr = ps_phash_pminth
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."POHME")) THEN
     iaddr = ps_phash_pohme
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."POT_KY_TGLF")) THEN
     iaddr = ps_phash_pot_ky_tglf
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."PRAD")) THEN
     iaddr = ps_phash_prad
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."PRAD_BR")) THEN
     iaddr = ps_phash_prad_br
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."PRAD_CY")) THEN
     iaddr = ps_phash_prad_cy
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."PRAD_LI")) THEN
     iaddr = ps_phash_prad_li
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."PSC_HALO")) THEN
     iaddr = ps_phash_psc_halo
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."PSC_RECO")) THEN
     iaddr = ps_phash_psc_reco
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."PSIPOL")) THEN
     iaddr = ps_phash_psipol
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."PSIRZ")) THEN
     iaddr = ps_phash_psirz
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."PSMOM_ERRCK")) THEN
     iaddr = ps_phash_psmom_errck
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."PSMOM_NC")) THEN
     iaddr = ps_phash_psmom_nc
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."P_EQ")) THEN
     iaddr = ps_phash_p_eq
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."QBEAMI")) THEN
     iaddr = ps_phash_qbeami
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."QCOMP_E")) THEN
     iaddr = ps_phash_qcomp_e
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."QCOMP_I")) THEN
     iaddr = ps_phash_qcomp_i
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."QIE")) THEN
     iaddr = ps_phash_qie
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."QIONIZ")) THEN
     iaddr = ps_phash_qioniz
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."QQCX")) THEN
     iaddr = ps_phash_qqcx
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."QROT_CONV")) THEN
     iaddr = ps_phash_qrot_conv
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."QROT_DIFF")) THEN
     iaddr = ps_phash_qrot_diff
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."Q_EQ")) THEN
     iaddr = ps_phash_q_eq
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."R0_MOMEQ")) THEN
     iaddr = ps_phash_r0_momeq
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."RATE_SINB0I")) THEN
     iaddr = ps_phash_rate_sinb0i
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."RATE_SINB0X")) THEN
     iaddr = ps_phash_rate_sinb0x
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."RATE_SINB0XS")) THEN
     iaddr = ps_phash_rate_sinb0xs
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."RATE_SINF0I")) THEN
     iaddr = ps_phash_rate_sinf0i
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."RATE_SINF0X")) THEN
     iaddr = ps_phash_rate_sinf0x
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."RATE_SINF0XS")) THEN
     iaddr = ps_phash_rate_sinf0xs
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."RES_SN")) THEN
     iaddr = ps_phash_res_sn
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."RES_TE")) THEN
     iaddr = ps_phash_res_te
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."RES_TI")) THEN
     iaddr = ps_phash_res_ti
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."RES_TQ")) THEN
     iaddr = ps_phash_res_tq
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."RMAJOR_MEAN")) THEN
     iaddr = ps_phash_rmajor_mean
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."RMINOR_MEAN")) THEN
     iaddr = ps_phash_rminor_mean
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."R_GEO")) THEN
     iaddr = ps_phash_r_geo
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."R_MIDP_IN")) THEN
     iaddr = ps_phash_r_midp_in
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."R_MIDP_OUT")) THEN
     iaddr = ps_phash_r_midp_out
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."R_SURFMAX")) THEN
     iaddr = ps_phash_r_surfmax
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."R_SURFMIN")) THEN
     iaddr = ps_phash_r_surfmin
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."S0RECO")) THEN
     iaddr = ps_phash_s0reco
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."S0RECO_E")) THEN
     iaddr = ps_phash_s0reco_e
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."S0RECO_RECAP")) THEN
     iaddr = ps_phash_s0reco_recap
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."SB0HALO")) THEN
     iaddr = ps_phash_sb0halo
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."SB0HALO_RECAP")) THEN
     iaddr = ps_phash_sb0halo_recap
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."SBEDEP")) THEN
     iaddr = ps_phash_sbedep
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."SBEHALO")) THEN
     iaddr = ps_phash_sbehalo
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."SBSCE")) THEN
     iaddr = ps_phash_sbsce
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."SBTHERM")) THEN
     iaddr = ps_phash_sbtherm
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."SC_ANOM")) THEN
     iaddr = ps_phash_sc_anom
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."SFSCE")) THEN
     iaddr = ps_phash_sfsce
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."SFTHERM")) THEN
     iaddr = ps_phash_sftherm
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."SII_XS")) THEN
     iaddr = ps_phash_sii_xs
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."SN_TRANS")) THEN
     iaddr = ps_phash_sn_trans
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."SN_TRANSCAT")) THEN
     iaddr = ps_phash_sn_transcat
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."SPROF0")) THEN
     iaddr = ps_phash_sprof0
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."SPROF0E")) THEN
     iaddr = ps_phash_sprof0e
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."SPSCE")) THEN
     iaddr = ps_phash_spsce
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."SQUARELO")) THEN
     iaddr = ps_phash_squarelo
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."SQUAREUO")) THEN
     iaddr = ps_phash_squareuo
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."SURF")) THEN
     iaddr = ps_phash_surf
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."T0CX")) THEN
     iaddr = ps_phash_t0cx
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."T0SC0")) THEN
     iaddr = ps_phash_t0sc0
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."T0_HALO")) THEN
     iaddr = ps_phash_t0_halo
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."T0_RECO")) THEN
     iaddr = ps_phash_t0_reco
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."TEFLUX_KY_TGLF")) THEN
     iaddr = ps_phash_teflux_ky_tglf
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."TE_KY_TGLF")) THEN
     iaddr = ps_phash_te_ky_tglf
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."TFRIP2_LOG")) THEN
     iaddr = ps_phash_tfrip2_log
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."TFRIP_LOG")) THEN
     iaddr = ps_phash_tfrip_log
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."TI")) THEN
     iaddr = ps_phash_ti
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."TIFLUX_KY_TGLF")) THEN
     iaddr = ps_phash_tiflux_ky_tglf
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."TI_KY_TGLF")) THEN
     iaddr = ps_phash_ti_ky_tglf
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."TMODEL")) THEN
     iaddr = ps_phash_tmodel
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."TQ0_RECO")) THEN
     iaddr = ps_phash_tq0_reco
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."TQB0_HALO")) THEN
     iaddr = ps_phash_tqb0_halo
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."TQBE")) THEN
     iaddr = ps_phash_tqbe
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."TQBI")) THEN
     iaddr = ps_phash_tqbi
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."TQBJXB")) THEN
     iaddr = ps_phash_tqbjxb
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."TQBTH")) THEN
     iaddr = ps_phash_tqbth
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."TQCX_HALO")) THEN
     iaddr = ps_phash_tqcx_halo
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."TQCX_RECO")) THEN
     iaddr = ps_phash_tqcx_reco
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."TQIONIZ")) THEN
     iaddr = ps_phash_tqioniz
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."TQQCX")) THEN
     iaddr = ps_phash_tqqcx
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."TQSC_HALO")) THEN
     iaddr = ps_phash_tqsc_halo
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."TQSC_RECO")) THEN
     iaddr = ps_phash_tqsc_reco
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."TQ_ANOM")) THEN
     iaddr = ps_phash_tq_anom
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."TQ_TRANS")) THEN
     iaddr = ps_phash_tq_trans
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."TQ_TRANSCAT")) THEN
     iaddr = ps_phash_tq_transcat
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."TRIANG")) THEN
     iaddr = ps_phash_triang
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."TRIANGL")) THEN
     iaddr = ps_phash_triangl
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."TRIANGU")) THEN
     iaddr = ps_phash_triangu
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."TRIANG_MILLER_L")) THEN
     iaddr = ps_phash_triang_miller_l
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."TRIANG_MILLER_U")) THEN
     iaddr = ps_phash_triang_miller_u
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."TS")) THEN
     iaddr = ps_phash_ts
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."TZFLUX_KY_TGLF")) THEN
     iaddr = ps_phash_tzflux_ky_tglf
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."TZ_KY_TGLF")) THEN
     iaddr = ps_phash_tz_ky_tglf
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."UPWIND_PFRAC_NS")) THEN
     iaddr = ps_phash_upwind_pfrac_ns
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."UPWIND_PFRAC_OMEGA")) THEN
     iaddr = ps_phash_upwind_pfrac_omega
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."UPWIND_PFRAC_TE")) THEN
     iaddr = ps_phash_upwind_pfrac_te
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."UPWIND_PFRAC_TI")) THEN
     iaddr = ps_phash_upwind_pfrac_ti
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."VEE_TRANS")) THEN
     iaddr = ps_phash_vee_trans
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."VEE_TRANSCAT")) THEN
     iaddr = ps_phash_vee_transcat
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."VELB_FUSI")) THEN
     iaddr = ps_phash_velb_fusi
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."VELB_NBI")) THEN
     iaddr = ps_phash_velb_nbi
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."VELB_RFMI")) THEN
     iaddr = ps_phash_velb_rfmi
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."VELNE_NCLASS")) THEN
     iaddr = ps_phash_velne_nclass
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."VELNH_NCLASS")) THEN
     iaddr = ps_phash_velnh_nclass
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."VELNI_DRBM")) THEN
     iaddr = ps_phash_velni_drbm
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."VELNS_ANOM")) THEN
     iaddr = ps_phash_velns_anom
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."VELNS_GLF")) THEN
     iaddr = ps_phash_velns_glf
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."VELNS_GTCNEO")) THEN
     iaddr = ps_phash_velns_gtcneo
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."VELNS_MMM71")) THEN
     iaddr = ps_phash_velns_mmm71
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."VELNS_NCLASS")) THEN
     iaddr = ps_phash_velns_nclass
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."VELNS_NEO")) THEN
     iaddr = ps_phash_velns_neo
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."VELNS_TGLF")) THEN
     iaddr = ps_phash_velns_tglf
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."VELNX_NCLASS")) THEN
     iaddr = ps_phash_velnx_nclass
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."VELPPHI_ANOM")) THEN
     iaddr = ps_phash_velpphi_anom
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."VELPPHI_GLF")) THEN
     iaddr = ps_phash_velpphi_glf
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."VELPPHI_GTCNEO")) THEN
     iaddr = ps_phash_velpphi_gtcneo
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."VELPPHI_MMM71")) THEN
     iaddr = ps_phash_velpphi_mmm71
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."VELPPHI_NEO")) THEN
     iaddr = ps_phash_velpphi_neo
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."VELPPHI_TGLF")) THEN
     iaddr = ps_phash_velpphi_tglf
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."VELTE_ANOM")) THEN
     iaddr = ps_phash_velte_anom
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."VELTE_GLF")) THEN
     iaddr = ps_phash_velte_glf
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."VELTE_GTCNEO")) THEN
     iaddr = ps_phash_velte_gtcneo
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."VELTE_MMM71")) THEN
     iaddr = ps_phash_velte_mmm71
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."VELTE_NCLASS")) THEN
     iaddr = ps_phash_velte_nclass
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."VELTE_NEO")) THEN
     iaddr = ps_phash_velte_neo
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."VELTE_PALEO")) THEN
     iaddr = ps_phash_velte_paleo
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."VELTE_TGLF")) THEN
     iaddr = ps_phash_velte_tglf
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."VELTI_ANOM")) THEN
     iaddr = ps_phash_velti_anom
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."VELTI_GLF")) THEN
     iaddr = ps_phash_velti_glf
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."VELTI_GTCNEO")) THEN
     iaddr = ps_phash_velti_gtcneo
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."VELTI_MMM71")) THEN
     iaddr = ps_phash_velti_mmm71
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."VELTI_NCLASS")) THEN
     iaddr = ps_phash_velti_nclass
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."VELTI_NEO")) THEN
     iaddr = ps_phash_velti_neo
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."VELTI_TGLF")) THEN
     iaddr = ps_phash_velti_tglf
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."VIE_TRANS")) THEN
     iaddr = ps_phash_vie_trans
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."VIE_TRANSCAT")) THEN
     iaddr = ps_phash_vie_transcat
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."VMO_TRANS")) THEN
     iaddr = ps_phash_vmo_trans
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."VMO_TRANSCAT")) THEN
     iaddr = ps_phash_vmo_transcat
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."VN_TRANS")) THEN
     iaddr = ps_phash_vn_trans
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."VN_TRANSCAT")) THEN
     iaddr = ps_phash_vn_transcat
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."VOL")) THEN
     iaddr = ps_phash_vol
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."VPOL_INMP")) THEN
     iaddr = ps_phash_vpol_inmp
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."VPOL_OMP")) THEN
     iaddr = ps_phash_vpol_omp
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."VTOR_INMP")) THEN
     iaddr = ps_phash_vtor_inmp
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."VTOR_OMP")) THEN
     iaddr = ps_phash_vtor_omp
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."V_LOOP")) THEN
     iaddr = ps_phash_v_loop
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."V_PARS")) THEN
     iaddr = ps_phash_v_pars
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."V_PERS")) THEN
     iaddr = ps_phash_v_pers
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."XRJCOS_MOMEQ")) THEN
     iaddr = ps_phash_xrjcos_momeq
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."XRJSIN_MOMEQ")) THEN
     iaddr = ps_phash_xrjsin_momeq
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."XZJCOS_MOMEQ")) THEN
     iaddr = ps_phash_xzjcos_momeq
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."XZJSIN_MOMEQ")) THEN
     iaddr = ps_phash_xzjsin_momeq
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."Z0_MOMEQ")) THEN
     iaddr = ps_phash_z0_momeq
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."ZEFF")) THEN
     iaddr = ps_phash_zeff
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."ZEFF_FI")) THEN
     iaddr = ps_phash_zeff_fi
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."ZEFF_TH")) THEN
     iaddr = ps_phash_zeff_th
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."Z_GEO")) THEN
     iaddr = ps_phash_z_geo
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."Z_MIDP")) THEN
     iaddr = ps_phash_z_midp
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."Z_SURFMAX")) THEN
     iaddr = ps_phash_z_surfmax
     RETURN
  ENDIF

  IF((htypu.EQ."PROFILE").AND.(hnamu.EQ."Z_SURFMIN")) THEN
     iaddr = ps_phash_z_surfmin
     RETURN
  ENDIF

  WRITE(iout,*) ' %plasma_state_hash_addr: no address found for:'
  WRITE(iout,*) '  htype = "'//trim(htypu)//'"; hname = "'//trim(hnamu)//'".'

  iaddr = 0

END SUBROUTINE plasma_state_hash_addr

subroutine ccps_xload(iobj,ierr)

  ! store plasma state data in xplasma
  ! enable interpolation services

  ! scalar data is written if section hashes indicate change, or if tests
  ! indicate t
  
  ! grid data items are written if hashes indicate change, or if grid IDs
  ! cannot be found in xplasma

  ! profile data is written if hashes indicate change of id ss%id_<profile>
  ! variables are zero.

  use plasma_state_mod
  implicit NONE

  integer :: iobj(*)        ! (ps_container_size) words are used: state object
  integer,intent(out) :: ierr      ! exit status 0=OK

  !-------------------------
  type (plasma_state_container) :: ptr
  type (plasma_state), pointer :: ss
  !-------------------------

  call ccps_argcheck('ccps_xload',iobj,ierr)
  if(ierr.ne.0) return

  ! proceed...

  call load_ps_container(iobj,ptr)
  ss => ptr%ps_ptr

  call plasma_state_xload(ss, ierr)

end subroutine ccps_xload

MODULE swim_global_data_mod

  SAVE
  ! the only global variable is SWIM_ierr
    
!--------------------------------------------------------------------------
!  original author: Don Batchelor (ORNL) 7/9/06
!                   batchelordb@ornl.gov (865) 574-1288
!
! Modifications:
!   
!   dbb 9/21/06 --  Use of derived types is deprecated when something simpler
!                   will work. Types SWIM_name, and SWIM_filename may dissappear.
!                   Added SWIM_name_length and SWIM_filename_length so as to
!                   avoid conflicting character string lengths.
!                   
!
!    dmc 21 Sep 2006 -- added SAVE stmt for global data
!                    -- changed default message in SWIM_ERROR to show
!                       "error_kind" argument.
!
!   F90 kind specifications
!
! For REAL variables
!   Use p = 6, r = 35       for single precision on 32 bit machines
!   Use p = 12, r = 100     for double precision on 64 bit machines
!
! For compatibility with SIDL doubles and ints
!   Use p = 15, r = 307     for doubles
!   Use p = 9               for ints
!
! Parameters for SELECTED_REAL_KIND:
!   p = number of digits
!   r = exponent range from -r to r
!
!--------------------------------------------------------------------------

    INTEGER, PARAMETER :: &
        rspec = SELECTED_REAL_KIND(p=15,r=307), &
        ispec = SELECTED_int_KIND(r=9)
        

!--------------------------------------------------------------------------
!
!   SWIM F90 derived data type declarations
!   Note: use of these derived types is deprecated and they may dissappear.
!   Use SWIM_name_length and SWIM_filename_length below in character declarations.
!
!--------------------------------------------------------------------------

    TYPE SWIM_name
        CHARACTER (len = 31) :: name    ! standard form for character names like species
    END TYPE SWIM_name

    TYPE SWIM_filename
        INTEGER :: unit                 ! Fortran unit number
        CHARACTER (len = 256) :: name   ! standard from for file names, should hold whole path
    END TYPE SWIM_filename
    

!--------------------------------------------------------------------------
!
!   Globally accessible data
!
!--------------------------------------------------------------------------



    INTEGER :: SWIM_ierr    ! Set in routine SWIM_error, below.  A simple way
                            ! to store some information about an error
    
    INTEGER, PARAMETER :: SWIM_err_out_file = 6 ! File to write error outputs.
                                                ! (Initially just standard out)

    INTEGER, PARAMETER :: SWIM_name_length = 31 ! Character string length to be
                                                ! used for names

    INTEGER, PARAMETER :: SWIM_filename_length = 256 ! Character string length to be
                                                ! used for file names

!--------------------------------------------------------------------------
!
!   Generally useful functions
!
!--------------------------------------------------------------------------

CONTAINS

!--------------------------------------------------------------------------
!
! SWIM_error
!   A simple way to handle errors. Writes to standard out the kind of error,
!   the routine from which SWIM_error was called, and optionally a variable
!   name associated with the error.  For example the name of an array for which
!   an allocation error occured.
!
!   It also sets an integer flag in the globally accessible data above: SWIM_ierr
!   This could be accessed by the caller or controller script to help figure out
!   What to do about the error.
!   
!   We can certainly be more elaborate later.
!
!--------------------------------------------------------------------------

SUBROUTINE SWIM_error (error_kind, calling_routine, variable_name)

    CHARACTER (len=*), INTENT(in) :: error_kind, calling_routine

    CHARACTER (len=*), OPTIONAL, INTENT(in) :: variable_name
    
    SWIM_ierr = 0
    
    SELECT CASE (TRIM( error_kind ))
    
        CASE ('allocation')
            IF (PRESENT( variable_name ))  THEN 
                WRITE(SWIM_err_out_file,*) 'Could not allocate ', &
                TRIM(variable_name), ' in routine ', TRIM(calling_routine)
            ELSE 
                WRITE(SWIM_err_out_file,*) 'Allocation error in routine ', TRIM(calling_routine)
            END IF
            
            SWIM_ierr = 1
    
        CASE ('open')
            IF (PRESENT( variable_name ))  THEN 
                WRITE(SWIM_err_out_file,*) 'Could not open file ', &
                TRIM(variable_name), ' in routine ', TRIM(calling_routine)
            ELSE 
                WRITE(SWIM_err_out_file,*) 'File open error in routine ', TRIM(calling_routine)
            END IF
            
            SWIM_ierr = 2
            
        CASE DEFAULT
            WRITE(*,*) '(Default Message) error "',TRIM(error_kind), &
                             '" in routine ', TRIM(calling_routine)
            
            SWIM_ierr = 999
            
    END SELECT
    
END SUBROUTINE SWIM_error
END MODULE swim_global_data_mod         

subroutine ps_maxid(iobj,idmax,iout,ierr)

  !------------------------------------------------------------
  ! return the maximum ID in the xplasma dictionary
  ! D. McCune 13 Oct 2006
  !------------------------------------------------------------

  use plasma_state_definition_mod
  use plasma_state_xpobj  ! XPLASMA2 state object definitions
  implicit NONE

  !-----------------------
  integer :: iobj(ps_container_size)     ! xplasma opaque container

  integer, intent(out) :: idmax      ! the max ID returned

  integer, intent(in) :: iout              ! LUN for error messages
  integer, intent(out) :: ierr             ! error status code returned 0 = OK

  !--------------------------------------------------
  ! local...

  type (interp_object) :: xobj
  type (xplasma), pointer :: s
  !--------------------------------------------------

  xobj = transfer(iobj,xobj)
  s => xobj%s_xpobj

  call xplasma_global_info(s,ierr, init_check=.TRUE., nitems=idmax)
  if(ierr.ne.0) then
     write(iout,*) ' %ps_maxid: invalid or unitialized xplasma object.'
     return
  endif

end subroutine ps_maxid

subroutine ccps_mdescr_read(iobj, filepath, caction, g_filepath, ierr)

  ! read file containing machine description
  ! optionally, get limiter and (R,Z) simulation limits from G-eqdsk file.

  use plasma_state_mod
  implicit NONE

#include "fpreproc/byte_declare.h"

  integer :: iobj(*)        ! (ps_container_size) words are used: state object
  BYTE_DECLARE, intent(in) :: filepath(*)  ! null terminated file path string (max 256 chars)
  BYTE_DECLARE, intent(in) :: caction(*)    ! null terminated string (max 32 chars)
  BYTE_DECLARE, intent(in) :: g_filepath(*) ! null terminated file path string (max 256 chars)
  ! if g_filename is blank or null, ignore.

  integer,intent(out) :: ierr      ! exit status 0=OK

  !-------------------------
  character*256 filename, g_filename
  character*32 action
  type (plasma_state_container) :: ptr
  type (plasma_state), pointer :: ss
  !-------------------------

  call ccps_argcheck('ccps_mdescr_read',iobj,ierr)
  if(ierr.ne.0) return

  ! proceed...

  call load_ps_container(iobj,ptr)
  ss => ptr%ps_ptr

  ! convert filepath to fortran string
  call cstring(filename,filepath,'2F')  ! convert file path to fortran string
  call cstring(action, caction, '2F')
  call cstring(g_filename,g_filepath,'2F')

  if(g_filename.eq.' ') then
     call ps_mdescr_read(filename, ierr, state=ss, action=action)
  else
     call ps_mdescr_read(filename, ierr, state=ss, &
          & action=action, g_filename=g_filename)
  endif

end subroutine ccps_mdescr_read

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_v9_dummy
     return
  end subroutine ccps_getset_v9_dummy

subroutine psget_vie_trans(iobj, n1, data, ierr)
    !! ion energy radial velocity
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_vie_trans', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % vie_trans
end subroutine psget_vie_trans


subroutine psset_vie_trans(iobj, n1, data, ierr)
    !! ion energy radial velocity
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_vie_trans', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % vie_trans = data(1:n1)
end subroutine psset_vie_trans


subroutine psgetrnk_vie_trans(iobj, ndims, ierr)
    !! ion energy radial velocity
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_vie_trans


subroutine psgetdim_vie_trans(iobj, ndims, dims, ierr)
    !! ion energy radial velocity
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_vie_trans', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % vie_trans ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % vie_trans)
    endif
end subroutine psgetdim_vie_trans


subroutine psget_velb_fusi(iobj, n1, data, ierr)
    !! fusion ion anom. radial velocity
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_velb_fusi', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % velb_fusi
end subroutine psget_velb_fusi


subroutine psset_velb_fusi(iobj, n1, data, ierr)
    !! fusion ion anom. radial velocity
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_velb_fusi', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % velb_fusi = data(1:n1)
end subroutine psset_velb_fusi


subroutine psgetrnk_velb_fusi(iobj, ndims, ierr)
    !! fusion ion anom. radial velocity
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_velb_fusi


subroutine psgetdim_velb_fusi(iobj, ndims, dims, ierr)
    !! fusion ion anom. radial velocity
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_velb_fusi', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % velb_fusi ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % velb_fusi)
    endif
end subroutine psgetdim_velb_fusi


subroutine psget_velti_anom(iobj, n1, data, ierr)
    !! Ti-equation, advective velocity term
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_velti_anom', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % velti_anom
end subroutine psget_velti_anom


subroutine psset_velti_anom(iobj, n1, data, ierr)
    !! Ti-equation, advective velocity term
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_velti_anom', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % velti_anom = data(1:n1)
end subroutine psset_velti_anom


subroutine psgetrnk_velti_anom(iobj, ndims, ierr)
    !! Ti-equation, advective velocity term
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_velti_anom


subroutine psgetdim_velti_anom(iobj, ndims, dims, ierr)
    !! Ti-equation, advective velocity term
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_velti_anom', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % velti_anom ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % velti_anom)
    endif
end subroutine psgetdim_velti_anom


subroutine psget_velpphi_mmm71(iobj, n1, data, ierr)
    !! momentum-equation, advective velocity term from MMM71 model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_velpphi_mmm71', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % velpphi_mmm71
end subroutine psget_velpphi_mmm71


subroutine psset_velpphi_mmm71(iobj, n1, data, ierr)
    !! momentum-equation, advective velocity term from MMM71 model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_velpphi_mmm71', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % velpphi_mmm71 = data(1:n1)
end subroutine psset_velpphi_mmm71


subroutine psgetrnk_velpphi_mmm71(iobj, ndims, ierr)
    !! momentum-equation, advective velocity term from MMM71 model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_velpphi_mmm71


subroutine psgetdim_velpphi_mmm71(iobj, ndims, dims, ierr)
    !! momentum-equation, advective velocity term from MMM71 model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_velpphi_mmm71', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % velpphi_mmm71 ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % velpphi_mmm71)
    endif
end subroutine psgetdim_velpphi_mmm71


subroutine psget_velni_drbm(iobj, n1, data, ierr)
    !! ion convective velocity
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_velni_drbm', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % velni_drbm
end subroutine psget_velni_drbm


subroutine psset_velni_drbm(iobj, n1, data, ierr)
    !! ion convective velocity
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_velni_drbm', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % velni_drbm = data(1:n1)
end subroutine psset_velni_drbm


subroutine psgetrnk_velni_drbm(iobj, ndims, ierr)
    !! ion convective velocity
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_velni_drbm


subroutine psgetdim_velni_drbm(iobj, ndims, dims, ierr)
    !! ion convective velocity
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_velni_drbm', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % velni_drbm ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % velni_drbm)
    endif
end subroutine psgetdim_velni_drbm

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_v3_dummy
     return
  end subroutine ccps_getset_v3_dummy

subroutine psget_vtor_data_info(iobj, data, ierr)
    !! information on source of toroidal velocity data
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    CHARACTER*(*), intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_vtor_data_info', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % vtor_Data_Info
end subroutine psget_vtor_data_info


subroutine psset_vtor_data_info(iobj, data, ierr)
    !! information on source of toroidal velocity data
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    CHARACTER*(*), intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_vtor_data_info', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % vtor_Data_Info = data
end subroutine psset_vtor_data_info


subroutine psgetsz_vtor_data_info(iobj, size, ierr)
    !! information on source of toroidal velocity data
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: size    ! size of character string
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psgetsz_vtor_data_info', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! note that the following will return the character length size regardless of
    ! the number of array elements (if vtor_Data_Info is an array)
    size = len(ss % vtor_Data_Info)
end subroutine psgetsz_vtor_data_info


subroutine psget_vtor_omp(iobj, n1, n2, data, ierr)
    !! toroidal velocity, outer half midplane
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_vtor_omp', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % vtor_omp
end subroutine psget_vtor_omp


subroutine psset_vtor_omp(iobj, n1, n2, data, ierr)
    !! toroidal velocity, outer half midplane
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_vtor_omp', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % vtor_omp = data(1:n1, 1: n2)
end subroutine psset_vtor_omp


subroutine psgetrnk_vtor_omp(iobj, ndims, ierr)
    !! toroidal velocity, outer half midplane
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_vtor_omp


subroutine psgetdim_vtor_omp(iobj, ndims, dims, ierr)
    !! toroidal velocity, outer half midplane
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_vtor_omp', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % vtor_omp ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % vtor_omp)
    endif
end subroutine psgetdim_vtor_omp


subroutine psget_vn_transcat(iobj, n1, n2, n3, data, ierr)
    !! specie radial velocity
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2, n3 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2, n3) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_vn_transcat', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2, 1: n3) = ss % vn_transcat
end subroutine psget_vn_transcat


subroutine psset_vn_transcat(iobj, n1, n2, n3, data, ierr)
    !! specie radial velocity
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2, n3 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2, n3) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_vn_transcat', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % vn_transcat = data(1:n1, 1: n2, 1: n3)
end subroutine psset_vn_transcat


subroutine psgetrnk_vn_transcat(iobj, ndims, ierr)
    !! specie radial velocity
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 3
end subroutine psgetrnk_vn_transcat


subroutine psgetdim_vn_transcat(iobj, ndims, dims, ierr)
    !! specie radial velocity
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 3) ierr = 1
    call ccps_argcheck('psgetdim_vn_transcat', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % vn_transcat ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % vn_transcat)
    endif
end subroutine psgetdim_vn_transcat


subroutine psget_velte_paleo(iobj, n1, data, ierr)
    !! Te-equation, convection term from PALEO model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_velte_paleo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % velte_paleo
end subroutine psget_velte_paleo


subroutine psset_velte_paleo(iobj, n1, data, ierr)
    !! Te-equation, convection term from PALEO model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_velte_paleo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % velte_paleo = data(1:n1)
end subroutine psset_velte_paleo


subroutine psgetrnk_velte_paleo(iobj, ndims, ierr)
    !! Te-equation, convection term from PALEO model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_velte_paleo


subroutine psgetdim_velte_paleo(iobj, ndims, dims, ierr)
    !! Te-equation, convection term from PALEO model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_velte_paleo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % velte_paleo ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % velte_paleo)
    endif
end subroutine psgetdim_velte_paleo


subroutine psget_velti_glf(iobj, n1, data, ierr)
    !! Ti-equation, advective velocity term from GLF23 model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_velti_glf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % velti_glf
end subroutine psget_velti_glf


subroutine psset_velti_glf(iobj, n1, data, ierr)
    !! Ti-equation, advective velocity term from GLF23 model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_velti_glf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % velti_glf = data(1:n1)
end subroutine psset_velti_glf


subroutine psgetrnk_velti_glf(iobj, ndims, ierr)
    !! Ti-equation, advective velocity term from GLF23 model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_velti_glf


subroutine psgetdim_velti_glf(iobj, ndims, dims, ierr)
    !! Ti-equation, advective velocity term from GLF23 model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_velti_glf', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % velti_glf ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % velti_glf)
    endif
end subroutine psgetdim_velti_glf


subroutine psget_velti_neo(iobj, n1, data, ierr)
    !! Ti-equation, advective velocity term from NEO model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_velti_neo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % velti_neo
end subroutine psget_velti_neo


subroutine psset_velti_neo(iobj, n1, data, ierr)
    !! Ti-equation, advective velocity term from NEO model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_velti_neo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % velti_neo = data(1:n1)
end subroutine psset_velti_neo


subroutine psgetrnk_velti_neo(iobj, ndims, ierr)
    !! Ti-equation, advective velocity term from NEO model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_velti_neo


subroutine psgetdim_velti_neo(iobj, ndims, dims, ierr)
    !! Ti-equation, advective velocity term from NEO model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_velti_neo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % velti_neo ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % velti_neo)
    endif
end subroutine psgetdim_velti_neo


subroutine psget_velti_nclass(iobj, n1, data, ierr)
    !! Ti-equation, advective velocity term from NCLASS model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_velti_nclass', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % velti_nclass
end subroutine psget_velti_nclass


subroutine psset_velti_nclass(iobj, n1, data, ierr)
    !! Ti-equation, advective velocity term from NCLASS model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_velti_nclass', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % velti_nclass = data(1:n1)
end subroutine psset_velti_nclass


subroutine psgetrnk_velti_nclass(iobj, ndims, ierr)
    !! Ti-equation, advective velocity term from NCLASS model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_velti_nclass


subroutine psgetdim_velti_nclass(iobj, ndims, dims, ierr)
    !! Ti-equation, advective velocity term from NCLASS model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_velti_nclass', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % velti_nclass ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % velti_nclass)
    endif
end subroutine psgetdim_velti_nclass

subroutine cstate_encode(units,ival,r8val,c256val,disp,ilen_disp)

  ! encode data for display

  use cstate_lib_mod
  implicit NONE

  character*(*), intent(in) :: units  ! units of data
  !  if "integer": use ival
  !  if "character": use c256val
  !  otherwise use r8val

  integer, intent(in) :: ival
  real*8, intent(in) :: r8val
  character*(*), intent(in) :: c256val

  character*(*), intent(out) :: disp  ! display form of data
  integer, intent(inout) :: ilen_disp ! output max(ilen_disp,len(trim(disp))) 

  !--------------------------------------
  integer :: ilend,ilenc,itest
  !--------------------------------------

  disp = ' '
  if(units.eq.'integer') then
     write(disp(1:10),'(I10)') ival

  else if(units.eq.'character') then
     ilend=len(disp)
     ilenc=len(trim(c256val))
     itest=ilenc-ilend+4
     if(ilenc.lt.ilend) then
        disp=c256val(1:ilenc)
     else if(ntail.eq.0) then
        disp=c256val(1:ilend-3)//'...'
     else if(ntail.le.itest) then
        disp='...'//c256val(ilenc-ilend+4:ilenc)
     else
        disp='...'//c256val(ntail:ntail+ilend-5)//'...'
     endif

  else
     call cstate_r8_encode(r8val,disp)
  endif

  ilen_disp=max(ilen_disp,len(trim(disp)))

end subroutine cstate_encode

subroutine cstate_r8_encode(r8val,disp)

  !  encode a single floating point number

  use cstate_lib_mod
  implicit NONE

  real*8, intent(in) :: r8val
  character*(*), intent(out) :: disp

  !-----------------------------------
  integer :: iprec,idot,iexp,isign,itmp,ic,id,ie,ict
  integer :: iesign,jexp,jsave
  character*24 :: z24
  character*25 :: zdisp
  character*1 :: zsave

  real*8, parameter :: ZERO = 0.0d0
  logical :: all9
  !-----------------------------------

  if(r8val.eq.ZERO) then
     disp=' 0.0'
  else
     all9=.TRUE.
     iprec=min(16,nprec)
     zdisp=' '
     z24=' '
     write(z24,'(1pe24.16)') r8val
     ic = 0
     id = 1 
     idot = 0
     ict = 0
     iexp = 0
     isign = 1
     do
        ic=ic+1
        if(ic.gt.24) exit
        if(z24(ic:ic).eq.' ') cycle
        if(id.eq.1) then
           if(z24(ic:ic).eq.'+') then
              z24(ic:ic)=' '
              cycle
           else if(z24(ic:ic).eq.'-') then
              isign=-1
              zdisp(1:1)='-'
              cycle
           endif
        endif
        if(ict.lt.iprec) then
           id=id+1
           zdisp(id:id)=z24(ic:ic)
           if(idot.gt.0) then
              if(z24(ic:ic).ne.'9') all9=.FALSE.
              ict=ict+1
              if(ict.eq.iprec) then
                 zsave=z24(ic+1:ic+1)
                 if(zsave.eq.'+') zsave='0'
                 if(zsave.eq.'-') zsave='0'
                 if(zsave.eq.'e') zsave='0'
                 if(zsave.eq.'E') zsave='0'
                 if(zsave.eq.'d') zsave='0'
                 if(zsave.eq.'D') zsave='0'
                 read(zsave,'(I1)') jsave
              endif
           else
              if(z24(ic:ic).eq.'.') then
                 idot=ic
              else if((z24(ic:ic).ne.'+').and.(z24(ic:ic).ne.'-')) then
                 if(z24(ic:ic).ne.'9') all9=.FALSE.
              endif
           endif
        else if(iexp.eq.0) then
           if((z24(ic:ic).eq.'+').or.(z24(ic:ic).eq.'-')) then
              if(z24(ic:ic).eq.'-') then
                 iesign=-1
              else
                 iesign=1
              endif
              iexp=1
              ie=0
           endif
        else
           read(z24(ic:ic),'(i1)') jexp
           ie=10*ie+jexp
        endif
     enddo

     ! apply increment if necessary
     if(jsave.ge.5) then
        if(all9) then
           ie=ie+iesign
           zdisp(2:2)='1'
           do ic=4,4+iprec-1
              zdisp(ic:ic)='0'
           enddo
        else
           ic=id
           do
              if(zdisp(ic:ic).eq.'9') then
                 zdisp(ic:ic)='0'
                 ic=ic-1
                 if(zdisp(ic:ic).eq.'.') ic=ic-1
              else
                 read(zdisp(ic:ic),'(I1)') itmp
                 itmp=itmp+1
                 write(zdisp(ic:ic),'(I1)') itmp
                 exit
              endif
           enddo
        endif
     endif
     
     if((ie*iesign.lt.-1).or.(ie*iesign.gt.min(3,iprec))) then
        ! encode exponent
        id=id+1
        zdisp(id:id)='e'
        id=id+1
        if(iesign.eq.1) zdisp(id:id)='+'
        if(iesign.eq.-1) zdisp(id:id)='-'
        if(ie.le.99) then
           write(zdisp(id+1:id+2),'(i2.2)') ie
        else
           write(zdisp(id+1:id+3),'(i3)') ie
        endif
        
        disp = zdisp
        
     else if(ie.eq.0) then
        disp = zdisp
        
     else if(ie*iesign.eq.-1) then
        disp = zdisp(1:1)//'0.'//zdisp(2:2)//zdisp(4:)
        
     else
        do ic=1,ie
           id=ic+2
           zdisp(id:id)=zdisp(id+1:id+1)
           zdisp(id+1:id+1)='.'
        enddo
        disp = zdisp
     endif
  endif

end subroutine cstate_r8_encode

subroutine cstate_enumco(ivec,fvec,dispa,id1,id2,icol,iblk,iblk_size,ilen)

  ! encode floating point enumeration data for display

  use cstate_lib_mod
  implicit NONE

  !--------------------------------------------------
  integer, intent(in) :: ivec       ! size of data
  real*8, intent(in) :: fvec(ivec)  ! the data

  integer, intent(in) :: id1,id2    ! display array dimensions
  character*(*) :: dispa(id1,id2)   ! display array (modified on output)

  integer, intent(in) :: icol       ! display column now being worked on
  integer, intent(in) :: iblk       ! # of contiguous block within column
  integer, intent(in) :: iblk_size  ! block size -- can be < ivec!

  integer :: ilen                   ! max display length (modified on output)

  !--------------------------------------------------
  !  local:
  integer :: irow1,ii
  !--------------------------------------------------

  irow1 = (iblk-1)*iblk_size + 1

  if(ivec.eq.0) then
     dispa(icol,irow1) = '  (empty)'

  else if(ivec.le.iblk_size) then
     do ii=1,ivec
        call cstate_r8_encode(fvec(ii),dispa(icol,irow1+ii-1))
     enddo

  else
     call cstate_dim_encode(ivec,dispa(icol,irow1))
     do ii=1,iblk_size-4
        call cstate_r8_encode(fvec(ii),dispa(icol,irow1+ii))
     enddo
     dispa(icol,irow1+iblk_size-3) = '  ... '
     do ii=1,2
        call cstate_r8_encode(fvec(ivec-2+ii),dispa(icol,irow1+iblk_size-3+ii))
     enddo
  endif

end subroutine cstate_enumco

subroutine cstate_inumco(ivec,iivec,dispa,id1,id2,icol,iblk,iblk_size,ilen)

  ! encode floating point enumeration data for display

  use cstate_lib_mod
  implicit NONE

  !--------------------------------------------------
  integer, intent(in) :: ivec       ! size of data
  integer, intent(in) :: iivec(ivec)  ! the data

  integer, intent(in) :: id1,id2    ! display array dimensions
  character*(*) :: dispa(id1,id2)   ! display array (modified on output)

  integer, intent(in) :: icol       ! display column now being worked on
  integer, intent(in) :: iblk       ! # of contiguous block within column
  integer, intent(in) :: iblk_size  ! block size -- can be < ivec!

  integer :: ilen                   ! max display length (modified on output)

  !--------------------------------------------------
  !  local:
  integer :: irow1,ii
  !--------------------------------------------------

  irow1 = (iblk-1)*iblk_size + 1

  if(ivec.eq.0) then
     dispa(icol,irow1) = '  (empty)'

  else if(ivec.le.iblk_size) then
     do ii=1,ivec
        write(dispa(icol,irow1+ii-1)(1:10),'(I10)') iivec(ii)
     enddo

  else
     call cstate_dim_encode(ivec,dispa(icol,irow1))
     do ii=1,iblk_size-4
        write(dispa(icol,irow1+ii)(1:10),'(I10)') iivec(ii)
     enddo
     dispa(icol,irow1+iblk_size-3) = '  ... '
     do ii=1,2
        write(dispa(icol,irow1+iblk_size-3+ii)(1:10),'(I10)') iivec(ivec-2+ii)
     enddo
  endif

end subroutine cstate_inumco

subroutine cstate_dim_encode(idim,disp)

  !  encode "(1:<idim>)"

  implicit NONE

  integer, intent(in) :: idim
  character*(*), intent(out) :: disp

  !------------------------------
  character*10 zdisp
  integer :: ii,jj
  !------------------------------

  disp='(1:'
  ii=3

  write(zdisp,'(I10)') idim

  do jj=1,len(zdisp)
     if(zdisp(jj:jj).ne.' ') then
        ii=ii+1
        disp(ii:ii)=zdisp(jj:jj)
     endif
  enddo

  ii=ii+1
  disp(ii:ii)=')'

end subroutine cstate_dim_encode

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_t1_dummy
     return
  end subroutine ccps_getset_t1_dummy

subroutine psget_trace_flag(iobj, n1, data, ierr)
    !! trace element flag, 0 means, beam has no trace element;, 1
    !! means, trace element, matching injection energy fractions, 2
    !! means, trace element injected at 100% full energy, (1 will be
    !! set if the trace element is an isotope of', "of the beam's main
    !! injection specie; 2 if not)."]
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_trace_flag', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % trace_flag
end subroutine psget_trace_flag


subroutine psset_trace_flag(iobj, n1, data, ierr)
    !! trace element flag, 0 means, beam has no trace element;, 1
    !! means, trace element, matching injection energy fractions, 2
    !! means, trace element injected at 100% full energy, (1 will be
    !! set if the trace element is an isotope of', "of the beam's main
    !! injection specie; 2 if not)."]
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_trace_flag', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % trace_flag = data(1:n1)
end subroutine psset_trace_flag


subroutine psgetrnk_trace_flag(iobj, ndims, ierr)
    !! trace element flag, 0 means, beam has no trace element;, 1
    !! means, trace element, matching injection energy fractions, 2
    !! means, trace element injected at 100% full energy, (1 will be
    !! set if the trace element is an isotope of', "of the beam's main
    !! injection specie; 2 if not)."]
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_trace_flag


subroutine psgetdim_trace_flag(iobj, ndims, dims, ierr)
    !! trace element flag, 0 means, beam has no trace element;, 1
    !! means, trace element, matching injection energy fractions, 2
    !! means, trace element injected at 100% full energy, (1 will be
    !! set if the trace element is an isotope of', "of the beam's main
    !! injection specie; 2 if not)."]
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_trace_flag', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % trace_flag ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % trace_flag)
    endif
end subroutine psgetdim_trace_flag


subroutine psget_tor_mode_no(iobj, n1, data, ierr)
    !! (from input) Toroidal modes monitored, set at
    !! initialization, would not vary in time, likely just:
    !! 1,2,3,...,mmodes
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_tor_mode_no', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % Tor_mode_No
end subroutine psget_tor_mode_no


subroutine psset_tor_mode_no(iobj, n1, data, ierr)
    !! (from input) Toroidal modes monitored, set at
    !! initialization, would not vary in time, likely just:
    !! 1,2,3,...,mmodes
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    INTEGER, intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_tor_mode_no', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % Tor_mode_No = data(1:n1)
end subroutine psset_tor_mode_no


subroutine psgetrnk_tor_mode_no(iobj, ndims, ierr)
    !! (from input) Toroidal modes monitored, set at
    !! initialization, would not vary in time, likely just:
    !! 1,2,3,...,mmodes
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_tor_mode_no


subroutine psgetdim_tor_mode_no(iobj, ndims, dims, ierr)
    !! (from input) Toroidal modes monitored, set at
    !! initialization, would not vary in time, likely just:
    !! 1,2,3,...,mmodes
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_tor_mode_no', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % Tor_mode_No ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % Tor_mode_No)
    endif
end subroutine psgetdim_tor_mode_no


subroutine psget_triang_miller_l(iobj, n1, data, ierr)
    !! Miller lower triangularity,
    !! Sin(aCos((R(Zmin)-Rmajor_mean)/rMinor_mean)-pi/2).
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_triang_miller_l', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % triang_miller_L
end subroutine psget_triang_miller_l


subroutine psset_triang_miller_l(iobj, n1, data, ierr)
    !! Miller lower triangularity,
    !! Sin(aCos((R(Zmin)-Rmajor_mean)/rMinor_mean)-pi/2).
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_triang_miller_l', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % triang_miller_L = data(1:n1)
end subroutine psset_triang_miller_l


subroutine psgetrnk_triang_miller_l(iobj, ndims, ierr)
    !! Miller lower triangularity,
    !! Sin(aCos((R(Zmin)-Rmajor_mean)/rMinor_mean)-pi/2).
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_triang_miller_l


subroutine psgetdim_triang_miller_l(iobj, ndims, dims, ierr)
    !! Miller lower triangularity,
    !! Sin(aCos((R(Zmin)-Rmajor_mean)/rMinor_mean)-pi/2).
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_triang_miller_l', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % triang_miller_L ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % triang_miller_L)
    endif
end subroutine psgetdim_triang_miller_l


subroutine psget_tqioniz(iobj, n1, n2, data, ierr)
    !! ionization torque per unit influx (sc0)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_tqioniz', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % tqioniz
end subroutine psget_tqioniz


subroutine psset_tqioniz(iobj, n1, n2, data, ierr)
    !! ionization torque per unit influx (sc0)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_tqioniz', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % tqioniz = data(1:n1, 1: n2)
end subroutine psset_tqioniz


subroutine psgetrnk_tqioniz(iobj, ndims, ierr)
    !! ionization torque per unit influx (sc0)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_tqioniz


subroutine psgetdim_tqioniz(iobj, ndims, dims, ierr)
    !! ionization torque per unit influx (sc0)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_tqioniz', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % tqioniz ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % tqioniz)
    endif
end subroutine psgetdim_tqioniz


subroutine psget_tmodel(iobj, n1, data, ierr)
    !! target temperature profile, from experiment or "profile
    !! consistency" model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_tmodel', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % tmodel
end subroutine psget_tmodel


subroutine psset_tmodel(iobj, n1, data, ierr)
    !! target temperature profile, from experiment or "profile
    !! consistency" model
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_tmodel', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % tmodel = data(1:n1)
end subroutine psset_tmodel


subroutine psgetrnk_tmodel(iobj, ndims, ierr)
    !! target temperature profile, from experiment or "profile
    !! consistency" model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_tmodel


subroutine psgetdim_tmodel(iobj, ndims, dims, ierr)
    !! target temperature profile, from experiment or "profile
    !! consistency" model
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_tmodel', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % tmodel ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % tmodel)
    endif
end subroutine psgetdim_tmodel

! written by plasma_cwrite.py
! input: plasma_state_spec.dat   version 2.055
! *** do not edit *** (use code generator instead)


  subroutine ccps_getset_p5_dummy
     return
  end subroutine ccps_getset_p5_dummy

subroutine psget_pel_code_info(iobj, data, ierr)
    !! Information: code implementing PELLET component
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    CHARACTER*(*), intent(out)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_pel_code_info', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data = ss % PEL_Code_Info
end subroutine psget_pel_code_info


subroutine psset_pel_code_info(iobj, data, ierr)
    !! Information: code implementing PELLET component
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
     ! list of dimensions (if any)
    CHARACTER*(*), intent(in)  :: data ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_pel_code_info', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % PEL_Code_Info = data
end subroutine psset_pel_code_info


subroutine psgetsz_pel_code_info(iobj, size, ierr)
    !! Information: code implementing PELLET component
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: size    ! size of character string
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psgetsz_pel_code_info', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! note that the following will return the character length size regardless of
    ! the number of array elements (if PEL_Code_Info is an array)
    size = len(ss % PEL_Code_Info)
end subroutine psgetsz_pel_code_info


subroutine psget_picrf_abs(iobj, n1, data, ierr)
    !! RF power absorbed inside plasma
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_picrf_abs', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % picrf_abs
end subroutine psget_picrf_abs


subroutine psset_picrf_abs(iobj, n1, data, ierr)
    !! RF power absorbed inside plasma
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_picrf_abs', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % picrf_abs = data(1:n1)
end subroutine psset_picrf_abs


subroutine psgetrnk_picrf_abs(iobj, ndims, ierr)
    !! RF power absorbed inside plasma
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_picrf_abs


subroutine psgetdim_picrf_abs(iobj, ndims, dims, ierr)
    !! RF power absorbed inside plasma
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_picrf_abs', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % picrf_abs ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % picrf_abs)
    endif
end subroutine psgetdim_picrf_abs


subroutine psget_pi_transcat(iobj, n1, n2, data, ierr)
    !! ion transport
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_pi_transcat', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1, 1: n2) = ss % pi_transcat
end subroutine psget_pi_transcat


subroutine psset_pi_transcat(iobj, n1, n2, data, ierr)
    !! ion transport
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1, n2 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1, n2) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_pi_transcat', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % pi_transcat = data(1:n1, 1: n2)
end subroutine psset_pi_transcat


subroutine psgetrnk_pi_transcat(iobj, ndims, ierr)
    !! ion transport
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 2
end subroutine psgetrnk_pi_transcat


subroutine psgetdim_pi_transcat(iobj, ndims, dims, ierr)
    !! ion transport
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 2) ierr = 1
    call ccps_argcheck('psgetdim_pi_transcat', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % pi_transcat ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % pi_transcat)
    endif
end subroutine psgetdim_pi_transcat


subroutine psget_picth(iobj, n1, data, ierr)
    !! direct thermal ion heating by ICRF, (sum over thermal ion
    !! species & IC sources)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_picth', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % picth
end subroutine psget_picth


subroutine psset_picth(iobj, n1, data, ierr)
    !! direct thermal ion heating by ICRF, (sum over thermal ion
    !! species & IC sources)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_picth', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % picth = data(1:n1)
end subroutine psset_picth


subroutine psgetrnk_picth(iobj, ndims, ierr)
    !! direct thermal ion heating by ICRF, (sum over thermal ion
    !! species & IC sources)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_picth


subroutine psgetdim_picth(iobj, ndims, dims, ierr)
    !! direct thermal ion heating by ICRF, (sum over thermal ion
    !! species & IC sources)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_picth', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % picth ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % picth)
    endif
end subroutine psgetdim_picth


subroutine psget_pcx_halo(iobj, n1, data, ierr)
    !! beam halo driven CX power, (>0 means local source), (no
    !! associated particle source/sink)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_pcx_halo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % pcx_halo
end subroutine psget_pcx_halo


subroutine psset_pcx_halo(iobj, n1, data, ierr)
    !! beam halo driven CX power, (>0 means local source), (no
    !! associated particle source/sink)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_pcx_halo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % pcx_halo = data(1:n1)
end subroutine psset_pcx_halo


subroutine psgetrnk_pcx_halo(iobj, ndims, ierr)
    !! beam halo driven CX power, (>0 means local source), (no
    !! associated particle source/sink)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_pcx_halo


subroutine psgetdim_pcx_halo(iobj, ndims, dims, ierr)
    !! beam halo driven CX power, (>0 means local source), (no
    !! associated particle source/sink)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_pcx_halo', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % pcx_halo ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % pcx_halo)
    endif
end subroutine psgetdim_pcx_halo


subroutine psget_prad_cy(iobj, n1, data, ierr)
    !! cyclotron radiation contribution
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_prad_cy', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % prad_cy
end subroutine psget_prad_cy


subroutine psset_prad_cy(iobj, n1, data, ierr)
    !! cyclotron radiation contribution
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_prad_cy', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % prad_cy = data(1:n1)
end subroutine psset_prad_cy


subroutine psgetrnk_prad_cy(iobj, ndims, ierr)
    !! cyclotron radiation contribution
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_prad_cy


subroutine psgetdim_prad_cy(iobj, ndims, dims, ierr)
    !! cyclotron radiation contribution
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_prad_cy', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % prad_cy ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % prad_cy)
    endif
end subroutine psgetdim_prad_cy


subroutine psget_pcx_reco(iobj, n1, data, ierr)
    !! reco driven CX power, (>0 => local source to thermal ions),
    !! (no associated particle source/sink)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_pcx_reco', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % pcx_reco
end subroutine psget_pcx_reco


subroutine psset_pcx_reco(iobj, n1, data, ierr)
    !! reco driven CX power, (>0 => local source to thermal ions),
    !! (no associated particle source/sink)
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_pcx_reco', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % pcx_reco = data(1:n1)
end subroutine psset_pcx_reco


subroutine psgetrnk_pcx_reco(iobj, ndims, ierr)
    !! reco driven CX power, (>0 => local source to thermal ions),
    !! (no associated particle source/sink)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_pcx_reco


subroutine psgetdim_pcx_reco(iobj, ndims, dims, ierr)
    !! reco driven CX power, (>0 => local source to thermal ions),
    !! (no associated particle source/sink)
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_pcx_reco', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % pcx_reco ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % pcx_reco)
    endif
end subroutine psgetdim_pcx_reco


subroutine psget_pi_anom(iobj, n1, data, ierr)
    !! anomalous ion heating
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(out)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psget_pi_anom', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    data(1:n1) = ss % pi_anom
end subroutine psget_pi_anom


subroutine psset_pi_anom(iobj, n1, data, ierr)
    !! anomalous ion heating
    use plasma_state_mod, only : plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*)  ! object handle
    integer, intent(in) :: n1 ! list of dimensions (if any)
    REAL(KIND=rspec), intent(in)  :: data(n1) ! to read to/write from
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    call ccps_argcheck('psset_pi_anom', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    ! set
    ss % pi_anom = data(1:n1)
end subroutine psset_pi_anom


subroutine psgetrnk_pi_anom(iobj, ndims, ierr)
    !! anomalous ion heating
    use plasma_state_mod, only :  plasma_state_container, plasma_state, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(out) :: ndims  ! number of dimensions
    integer, intent(out) :: ierr   ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    ndims = 1
end subroutine psgetrnk_pi_anom


subroutine psgetdim_pi_anom(iobj, ndims, dims, ierr)
    !! anomalous ion heating
    use plasma_state_mod, only :  plasma_state_container, plasma_state, &
                                & load_ps_container, rspec
    implicit NONE
    integer, intent(in) :: iobj(*) ! object handle
    integer, intent(in) :: ndims   ! number of dimensions
    integer, intent(out) :: dims(ndims) ! sizes
    integer, intent(out) :: ierr ! error code (0=OK)
    ! local
    type (plasma_state_container) :: ptr
    type (plasma_state), pointer  :: ss

    ierr = 0
    if (ndims /= 1) ierr = 1
    call ccps_argcheck('psgetdim_pi_anom', iobj, ierr)
    if(ierr.ne.0) return
    ! proceed...
    call load_ps_container(iobj,ptr)
    ss => ptr % ps_ptr
    dims = 0
    if (allocated( ss % pi_anom ) ) then
        ! can only call 'shape' on allocated/associated arrays
        dims = shape(ss % pi_anom)
    endif
end subroutine psgetdim_pi_anom

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


SUBROUTINE plasma_state_empty_alloc_3(ss,iout,ierr)


  ! Allocate array data for which all dimensions are provided

  USE plasma_state_definition_mod
  IMPLICIT NONE

  TYPE (plasma_state) :: ss  ! state containing array elements to be allocated
  INTEGER, INTENT(IN) :: iout
  INTEGER, INTENT(INOUT) :: ierr  ! completion code (not cleared,set on error)

  !-------------------
  INTEGER :: isize,jsize
  !-------------------


  !-----------------------------------------------
  ! allocate arrays...

  isize = (ss%nrho_eq_geo)
  IF(ALLOCATED(ss%grho2b2i).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%grho2b2i)
  ENDIF
  IF(ALLOCATED(ss%grho2b2i)) then
     jsize = SIZE(ss%grho2b2i)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: grho2b2i already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%grho2b2i(ss%nrho_eq_geo))
     ss%grho2b2i = 0.0_rspec
  ENDIF

  isize = (ss%nrho_eq_geo)
  IF(ALLOCATED(ss%grho2r2i).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%grho2r2i)
  ENDIF
  IF(ALLOCATED(ss%grho2r2i)) then
     jsize = SIZE(ss%grho2r2i)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: grho2r2i already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%grho2r2i(ss%nrho_eq_geo))
     ss%grho2r2i = 0.0_rspec
  ENDIF

  isize = (ss%nrho_eq_geo)
  IF(ALLOCATED(ss%grho2r3i).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%grho2r3i)
  ENDIF
  IF(ALLOCATED(ss%grho2r3i)) then
     jsize = SIZE(ss%grho2r3i)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: grho2r3i already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%grho2r3i(ss%nrho_eq_geo))
     ss%grho2r3i = 0.0_rspec
  ENDIF

  isize = (ss%nrho_eq_geo)
  IF(ALLOCATED(ss%gri).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%gri)
  ENDIF
  IF(ALLOCATED(ss%gri)) then
     jsize = SIZE(ss%gri)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: gri already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%gri(ss%nrho_eq_geo))
     ss%gri = 0.0_rspec
  ENDIF

  isize = (ss%nrho_eq_geo)
  IF(ALLOCATED(ss%grirhoi).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%grirhoi)
  ENDIF
  IF(ALLOCATED(ss%grirhoi)) then
     jsize = SIZE(ss%grirhoi)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: grirhoi already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%grirhoi(ss%nrho_eq_geo))
     ss%grirhoi = 0.0_rspec
  ENDIF

  isize = (ss%nrho_anomth)
  IF(ALLOCATED(ss%growthrate_drbm).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%growthrate_drbm)
  ENDIF
  IF(ALLOCATED(ss%growthrate_drbm)) then
     jsize = SIZE(ss%growthrate_drbm)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: growthrate_drbm already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%growthrate_drbm(ss%nrho_anomth))
     ss%growthrate_drbm = 0.0_rspec
  ENDIF

  isize = (ss%nrho_anomth)
  IF(ALLOCATED(ss%growthrate_glf).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%growthrate_glf)
  ENDIF
  IF(ALLOCATED(ss%growthrate_glf)) then
     jsize = SIZE(ss%growthrate_glf)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: growthrate_glf already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%growthrate_glf(ss%nrho_anomth))
     ss%growthrate_glf = 0.0_rspec
  ENDIF

  isize = (ss%nrho_anomth)
  IF(ALLOCATED(ss%growthrate_max_tglf).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%growthrate_max_tglf)
  ENDIF
  IF(ALLOCATED(ss%growthrate_max_tglf)) then
     jsize = SIZE(ss%growthrate_max_tglf)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: growthrate_max_tglf already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%growthrate_max_tglf(ss%nrho_anomth))
     ss%growthrate_max_tglf = 0.0_rspec
  ENDIF

  isize = (ss%nrho_anomth)*(ss%nky_mmm)
  IF(ALLOCATED(ss%growthrate_mmm71).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%growthrate_mmm71)
  ENDIF
  IF(ALLOCATED(ss%growthrate_mmm71)) then
     jsize = SIZE(ss%growthrate_mmm71)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: growthrate_mmm71 already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%growthrate_mmm71(ss%nrho_anomth,ss%nky_mmm))
     ss%growthrate_mmm71 = 0.0_rspec
     ALLOCATE(ss%id_growthrate_mmm71(ss%nky_mmm))
     ss%id_growthrate_mmm71 = 0
  ENDIF

  isize = (ss%nrho_anomth)
  IF(ALLOCATED(ss%growthrate_mtm).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%growthrate_mtm)
  ENDIF
  IF(ALLOCATED(ss%growthrate_mtm)) then
     jsize = SIZE(ss%growthrate_mtm)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: growthrate_mtm already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%growthrate_mtm(ss%nrho_anomth))
     ss%growthrate_mtm = 0.0_rspec
  ENDIF

  isize = (ss%nrho_anomth)*(ss%nky_anomth)
  IF(ALLOCATED(ss%growthrate_tglf).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%growthrate_tglf)
  ENDIF
  IF(ALLOCATED(ss%growthrate_tglf)) then
     jsize = SIZE(ss%growthrate_tglf)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: growthrate_tglf already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%growthrate_tglf(ss%nrho_anomth,ss%nky_anomth))
     ss%growthrate_tglf = 0.0_rspec
     ALLOCATE(ss%id_growthrate_tglf(ss%nky_anomth))
     ss%id_growthrate_tglf = 0
  ENDIF

  isize = (ss%nrho_anomth)*(ss%nspec_th+1)
  IF(ss%nspec_th.LE.0) isize = 0
  IF(ALLOCATED(ss%growthrate_vpar).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%growthrate_vpar)
  ENDIF
  IF(ALLOCATED(ss%growthrate_vpar)) then
     jsize = SIZE(ss%growthrate_vpar)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: growthrate_vpar already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%growthrate_vpar(ss%nrho_anomth,0:ss%nspec_th))
     ss%growthrate_vpar = 0.0_rspec
     ALLOCATE(ss%id_growthrate_vpar(0:ss%nspec_th))
     ss%id_growthrate_vpar = 0
  ENDIF

  isize = (ss%ngsc0)
  IF(ALLOCATED(ss%gs_name).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%gs_name)
  ENDIF
  IF(ALLOCATED(ss%gs_name)) then
     jsize = SIZE(ss%gs_name)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: gs_name already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%gs_name(ss%ngsc0))
     ss%gs_name = " "
  ENDIF

  isize = (ss%nrho_eq)
  IF(ALLOCATED(ss%g_eq).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%g_eq)
  ENDIF
  IF(ALLOCATED(ss%g_eq)) then
     jsize = SIZE(ss%g_eq)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: g_eq already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%g_eq(ss%nrho_eq))
     ss%g_eq = 0.0_rspec
  ENDIF

  isize = (ss%max_nspectrumlh_src)*(ss%nlhrf_src)
  IF(ALLOCATED(ss%hegrilh).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%hegrilh)
  ENDIF
  IF(ALLOCATED(ss%hegrilh)) then
     jsize = SIZE(ss%hegrilh)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: hegrilh already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%hegrilh(ss%max_nspectrumlh_src,ss%nlhrf_src))
     ss%hegrilh = 0.0_rspec
  ENDIF

  isize = (ss%ncoils)
  IF(ALLOCATED(ss%Hsize_coil).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%Hsize_coil)
  ENDIF
  IF(ALLOCATED(ss%Hsize_coil)) then
     jsize = SIZE(ss%Hsize_coil)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: Hsize_coil already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%Hsize_coil(ss%ncoils))
     ss%Hsize_coil = 0.0_rspec
  ENDIF

  isize = (ss%n_h_einj_standard)
  IF(ALLOCATED(ss%H_einj_standard).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%H_einj_standard)
  ENDIF
  IF(ALLOCATED(ss%H_einj_standard)) then
     jsize = SIZE(ss%H_einj_standard)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: H_einj_standard already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%H_einj_standard(ss%n_h_einj_standard))
     ss%H_einj_standard = 0.0_rspec
  ENDIF

  isize = (ss%n_h_einj_standard)
  IF(ALLOCATED(ss%H_ffull_standard).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%H_ffull_standard)
  ENDIF
  IF(ALLOCATED(ss%H_ffull_standard)) then
     jsize = SIZE(ss%H_ffull_standard)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: H_ffull_standard already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%H_ffull_standard(ss%n_h_einj_standard))
     ss%H_ffull_standard = 0.0_rspec
  ENDIF

  isize = (ss%n_h_einj_standard)
  IF(ALLOCATED(ss%H_fhalf_standard).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%H_fhalf_standard)
  ENDIF
  IF(ALLOCATED(ss%H_fhalf_standard)) then
     jsize = SIZE(ss%H_fhalf_standard)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: H_fhalf_standard already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%H_fhalf_standard(ss%n_h_einj_standard))
     ss%H_fhalf_standard = 0.0_rspec
  ENDIF

  isize = (ss%ncoils)
  IF(ALLOCATED(ss%icircuit_coil).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%icircuit_coil)
  ENDIF
  IF(ALLOCATED(ss%icircuit_coil)) then
     jsize = SIZE(ss%icircuit_coil)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: icircuit_coil already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%icircuit_coil(ss%ncoils))
     ss%icircuit_coil = 0
  ENDIF

  isize = (ss%nicrf_src)
  IF(ALLOCATED(ss%icrf_src_name).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%icrf_src_name)
  ENDIF
  IF(ALLOCATED(ss%icrf_src_name)) then
     jsize = SIZE(ss%icrf_src_name)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: icrf_src_name already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%icrf_src_name(ss%nicrf_src))
     ss%icrf_src_name = " "
  ENDIF

  isize = (ss%max_num_nphi_vac)*(ss%nicrf_src)
  IF(ALLOCATED(ss%Imag_ant_coef).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%Imag_ant_coef)
  ENDIF
  IF(ALLOCATED(ss%Imag_ant_coef)) then
     jsize = SIZE(ss%Imag_ant_coef)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: Imag_ant_coef already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%Imag_ant_coef(ss%max_num_nphi_vac,ss%nicrf_src))
     ss%Imag_ant_coef = 0.0_rspec
  ENDIF

  isize = (ss%nrho)
  IF(ALLOCATED(ss%iota).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%iota)
  ENDIF
  IF(ALLOCATED(ss%iota)) then
     jsize = SIZE(ss%iota)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: iota already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%iota(ss%nrho))
     ss%iota = 0.0_rspec
  ENDIF

  isize = (ss%nspec_rfmin)
  IF(ALLOCATED(ss%isThermal).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%isThermal)
  ENDIF
  IF(ALLOCATED(ss%isThermal)) then
     jsize = SIZE(ss%isThermal)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: isThermal already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%isThermal(ss%nspec_rfmin))
     ss%isThermal = 0
  ENDIF

  isize = (ss%ngsc0)
  IF(ALLOCATED(ss%is_recycling).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%is_recycling)
  ENDIF
  IF(ALLOCATED(ss%is_recycling)) then
     jsize = SIZE(ss%is_recycling)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: is_recycling already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%is_recycling(ss%ngsc0))
     ss%is_recycling = 0
  ENDIF

  isize = (ss%nrho_eq)
  IF(ALLOCATED(ss%jdotb).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%jdotb)
  ENDIF
  IF(ALLOCATED(ss%jdotb)) then
     jsize = SIZE(ss%jdotb)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: jdotb already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%jdotb(ss%nrho_eq))
     ss%jdotb = 0.0_rspec
  ENDIF

  isize = (ss%nbeam)
  IF(ALLOCATED(ss%kvolt_nbi).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%kvolt_nbi)
  ENDIF
  IF(ALLOCATED(ss%kvolt_nbi)) then
     jsize = SIZE(ss%kvolt_nbi)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: kvolt_nbi already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%kvolt_nbi(ss%nbeam))
     ss%kvolt_nbi = 0.0_rspec
  ENDIF

  isize = (ss%nrho_anomth)
  IF(ALLOCATED(ss%kyrhos_mtm).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%kyrhos_mtm)
  ENDIF
  IF(ALLOCATED(ss%kyrhos_mtm)) then
     jsize = SIZE(ss%kyrhos_mtm)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: kyrhos_mtm already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%kyrhos_mtm(ss%nrho_anomth))
     ss%kyrhos_mtm = 0.0_rspec
  ENDIF

  isize = (ss%nrho_anomth)*(ss%nky_anomth)
  IF(ALLOCATED(ss%kyspectrum_tglf).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%kyspectrum_tglf)
  ENDIF
  IF(ALLOCATED(ss%kyspectrum_tglf)) then
     jsize = SIZE(ss%kyspectrum_tglf)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: kyspectrum_tglf already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%kyspectrum_tglf(ss%nrho_anomth,ss%nky_anomth))
     ss%kyspectrum_tglf = 0.0_rspec
     ALLOCATE(ss%id_kyspectrum_tglf(ss%nky_anomth))
     ss%id_kyspectrum_tglf = 0
  ENDIF

  isize = (ss%nbeam)
  IF(ALLOCATED(ss%Lbscap).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%Lbscap)
  ENDIF
  IF(ALLOCATED(ss%Lbscap)) then
     jsize = SIZE(ss%Lbscap)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: Lbscap already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%Lbscap(ss%nbeam))
     ss%Lbscap = 0.0_rspec
  ENDIF

  isize = (ss%nbeam)
  IF(ALLOCATED(ss%Lbscap2).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%Lbscap2)
  ENDIF
  IF(ALLOCATED(ss%Lbscap2)) then
     jsize = SIZE(ss%Lbscap2)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: Lbscap2 already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%Lbscap2(ss%nbeam))
     ss%Lbscap2 = 0.0_rspec
  ENDIF

  isize = (ss%nbeam)
  IF(ALLOCATED(ss%Lbsctan).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%Lbsctan)
  ENDIF
  IF(ALLOCATED(ss%Lbsctan)) then
     jsize = SIZE(ss%Lbsctan)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: Lbsctan already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%Lbsctan(ss%nbeam))
     ss%Lbsctan = 0.0_rspec
  ENDIF

  isize = (ss%nlhrf_src)
  IF(ALLOCATED(ss%lhrf_src_name).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%lhrf_src_name)
  ENDIF
  IF(ALLOCATED(ss%lhrf_src_name)) then
     jsize = SIZE(ss%lhrf_src_name)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: lhrf_src_name already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%lhrf_src_name(ss%nlhrf_src))
     ss%lhrf_src_name = " "
  ENDIF

  isize = (ss%nrho_eq)
  IF(ALLOCATED(ss%Lpol).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%Lpol)
  ENDIF
  IF(ALLOCATED(ss%Lpol)) then
     jsize = SIZE(ss%Lpol)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: Lpol already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%Lpol(ss%nrho_eq))
     ss%Lpol = 0.0_rspec
  ENDIF

  isize = (ss%nballoon)
  IF(ALLOCATED(ss%Mercier_stable).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%Mercier_stable)
  ENDIF
  IF(ALLOCATED(ss%Mercier_stable)) then
     jsize = SIZE(ss%Mercier_stable)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: Mercier_stable already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%Mercier_stable(ss%nballoon))
     ss%Mercier_stable = 0
  ENDIF

  isize = (ss%nspec_all+1)
  IF(ss%nspec_all.LE.0) isize = 0
  IF(ALLOCATED(ss%m_ALL).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%m_ALL)
  ENDIF
  IF(ALLOCATED(ss%m_ALL)) then
     jsize = SIZE(ss%m_ALL)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: m_ALL already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%m_ALL(0:ss%nspec_all))
     ss%m_ALL = 0.0_rspec
  ENDIF

  isize = (ss%nspec_alla+1)
  IF(ss%nspec_alla.LE.0) isize = 0
  IF(ALLOCATED(ss%m_ALLA).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%m_ALLA)
  ENDIF
  IF(ALLOCATED(ss%m_ALLA)) then
     jsize = SIZE(ss%m_ALLA)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: m_ALLA already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%m_ALLA(0:ss%nspec_alla))
     ss%m_ALLA = 0.0_rspec
  ENDIF

  isize = (ss%nspec_rfmin)
  IF(ALLOCATED(ss%m_RFMIN).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%m_RFMIN)
  ENDIF
  IF(ALLOCATED(ss%m_RFMIN)) then
     jsize = SIZE(ss%m_RFMIN)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: m_RFMIN already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%m_RFMIN(ss%nspec_rfmin))
     ss%m_RFMIN = 0.0_rspec
  ENDIF

  isize = (ss%nspec_th+1)
  IF(ss%nspec_th.LE.0) isize = 0
  IF(ALLOCATED(ss%m_S).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%m_S)
  ENDIF
  IF(ALLOCATED(ss%m_S)) then
     jsize = SIZE(ss%m_S)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: m_S already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%m_S(0:ss%nspec_th))
     ss%m_S = 0.0_rspec
  ENDIF

  isize = (ss%nspec_tha+1)
  IF(ss%nspec_tha.LE.0) isize = 0
  IF(ALLOCATED(ss%m_SA).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%m_SA)
  ENDIF
  IF(ALLOCATED(ss%m_SA)) then
     jsize = SIZE(ss%m_SA)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: m_SA already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%m_SA(0:ss%nspec_tha))
     ss%m_SA = 0.0_rspec
  ENDIF

  isize = (ss%nspec_fusion)
  IF(ALLOCATED(ss%m_SFUS).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%m_SFUS)
  ENDIF
  IF(ALLOCATED(ss%m_SFUS)) then
     jsize = SIZE(ss%m_SFUS)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: m_SFUS already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%m_SFUS(ss%nspec_fusion))
     ss%m_SFUS = 0.0_rspec
  ENDIF

  isize = (ss%nspec_gas)
  IF(ALLOCATED(ss%m_SGAS).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%m_SGAS)
  ENDIF
  IF(ALLOCATED(ss%m_SGAS)) then
     jsize = SIZE(ss%m_SGAS)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: m_SGAS already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%m_SGAS(ss%nspec_gas))
     ss%m_SGAS = 0.0_rspec
  ENDIF

  isize = (ss%nspec_imp0)
  IF(ALLOCATED(ss%m_SIMP0).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%m_SIMP0)
  ENDIF
  IF(ALLOCATED(ss%m_SIMP0)) then
     jsize = SIZE(ss%m_SIMP0)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: m_SIMP0 already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%m_SIMP0(ss%nspec_imp0))
     ss%m_SIMP0 = 0.0_rspec
  ENDIF

  isize = (ss%nspec_impi)
  IF(ALLOCATED(ss%m_SIMPI).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%m_SIMPI)
  ENDIF
  IF(ALLOCATED(ss%m_SIMPI)) then
     jsize = SIZE(ss%m_SIMPI)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: m_SIMPI already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%m_SIMPI(ss%nspec_impi))
     ss%m_SIMPI = 0.0_rspec
  ENDIF

  isize = (ss%nspec_beam)
  IF(ALLOCATED(ss%m_SNBI).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%m_SNBI)
  ENDIF
  IF(ALLOCATED(ss%m_SNBI)) then
     jsize = SIZE(ss%m_SNBI)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: m_SNBI already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%m_SNBI(ss%nspec_beam))
     ss%m_SNBI = 0.0_rspec
  ENDIF

  isize = (ss%nrho_gas-1)*(ss%nspec_gas)*(ss%ngsc0)
  IF(ALLOCATED(ss%n0norm).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%n0norm)
  ENDIF
  IF(ALLOCATED(ss%n0norm)) then
     jsize = SIZE(ss%n0norm)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: n0norm already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%n0norm(ss%nrho_gas-1,ss%nspec_gas,ss%ngsc0))
     ss%n0norm = 0.0_rspec
     ALLOCATE(ss%id_n0norm(ss%nspec_gas,ss%ngsc0))
     ss%id_n0norm = 0
  ENDIF

  isize = (ss%nrho_nbi-1)*(ss%nspec_gas)
  IF(ALLOCATED(ss%n0_halo).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%n0_halo)
  ENDIF
  IF(ALLOCATED(ss%n0_halo)) then
     jsize = SIZE(ss%n0_halo)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: n0_halo already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%n0_halo(ss%nrho_nbi-1,ss%nspec_gas))
     ss%n0_halo = 0.0_rspec
     ALLOCATE(ss%id_n0_halo(ss%nspec_gas))
     ss%id_n0_halo = 0
  ENDIF

  isize = (ss%nrho_gas-1)*(ss%nspec_gas)
  IF(ALLOCATED(ss%n0_reco).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%n0_reco)
  ENDIF
  IF(ALLOCATED(ss%n0_reco)) then
     jsize = SIZE(ss%n0_reco)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: n0_reco already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%n0_reco(ss%nrho_gas-1,ss%nspec_gas))
     ss%n0_reco = 0.0_rspec
     ALLOCATE(ss%id_n0_reco(ss%nspec_gas))
     ss%id_n0_reco = 0
  ENDIF

  isize = (ss%nbeam)
  IF(ALLOCATED(ss%nbap2_shape).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%nbap2_shape)
  ENDIF
  IF(ALLOCATED(ss%nbap2_shape)) then
     jsize = SIZE(ss%nbap2_shape)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: nbap2_shape already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%nbap2_shape(ss%nbeam))
     ss%nbap2_shape = " "
  ENDIF

  isize = (ss%nbeam)
  IF(ALLOCATED(ss%nbap_shape).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%nbap_shape)
  ENDIF
  IF(ALLOCATED(ss%nbap_shape)) then
     jsize = SIZE(ss%nbap_shape)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: nbap_shape already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%nbap_shape(ss%nbeam))
     ss%nbap_shape = " "
  ENDIF

  isize = (ss%nrho_nbi-1)*(ss%nspec_beam)
  IF(ALLOCATED(ss%nbeami).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%nbeami)
  ENDIF
  IF(ALLOCATED(ss%nbeami)) then
     jsize = SIZE(ss%nbeami)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: nbeami already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%nbeami(ss%nrho_nbi-1,ss%nspec_beam))
     ss%nbeami = 0.0_rspec
     ALLOCATE(ss%id_nbeami(ss%nspec_beam))
     ss%id_nbeami = 0
  ENDIF

  isize = (ss%nspec_beam)
  IF(ALLOCATED(ss%nbeami_bdy).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%nbeami_bdy)
  ENDIF
  IF(ALLOCATED(ss%nbeami_bdy)) then
     jsize = SIZE(ss%nbeami_bdy)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: nbeami_bdy already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%nbeami_bdy(ss%nspec_beam))
     ss%nbeami_bdy = 0.0_rspec
  ENDIF

  isize = (ss%nbeam)
  IF(ALLOCATED(ss%nbion).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%nbion)
  ENDIF
  IF(ALLOCATED(ss%nbion)) then
     jsize = SIZE(ss%nbion)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: nbion already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%nbion(ss%nbeam))
     ss%nbion = " "
  ENDIF

  isize = (ss%nbeam)
  IF(ALLOCATED(ss%nbion_trace).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%nbion_trace)
  ENDIF
  IF(ALLOCATED(ss%nbion_trace)) then
     jsize = SIZE(ss%nbion_trace)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: nbion_trace already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%nbion_trace(ss%nbeam))
     ss%nbion_trace = " "
  ENDIF

END SUBROUTINE plasma_state_empty_alloc_3
